from shapely.geometry import Polygon, LineString

from server.map_handler.add_new_lake import create_grid


def test_create_grid_default():
    # Create a simple square polygon
    test_poly = Polygon([(0, 0), (1, 0), (1, 1), (0, 1)])

    # Define the expected grid output
    coordinates = [[(0, 0), (0, 1)], [(0.5, 0), (0.5, 1)], [(1, 0), (1, 1)],
                [(0, 0), (1, 0)], [(0, 0.4), (1, 0.4)], [(0, 0.8), (1, 0.8)]]
    expected = [LineString(coords) for coords in coordinates]

    grid = create_grid(test_poly, 0.5, 0.4)
    assert grid == expected
