var search_data = {
    "index": {
        "searchIndex": [
             "onliveerrorstatuslistener",
             "defines the listeners of the live video status.",
             "onerror",
             "when an error occurs during the live broadcast, the listener will receive this callback.  @param error the error code, currently only support `status_living_interruption_error(-3)` @param description description of the error.",
             "addliveerrorstatuslistener",
             "adds the listener for the live video status change events.  @param listener live video status change listener.",
             "removeliveerrorstatuslistener",
             "remove the listener for the live video status change events.  @param listener live video status change listener.",
             "isstreaming",
             "determines if the live streaming starts or not. after starting this flag will not be affected by the rtmp server status.  @return `true` if the live stream manager is streaming.",
             "setliveurl",
             "sets the url address of the rtmp server. this method should be called before the calling of `startstream`.  @param url the url address string of the rtmp server.",
             "getliveurl",
             "gets the current url address of the rtmp server.  @return a string of the url address.",
             "startstream",
             "starts the live streaming. if the manager starts successfully, `isstreaming` will return `true`. the  encoder will start to encoding the video frame if it is needed. the video will be streamed to the rtmp server if the server  is available. the audio can be streamed along with the video if the audio setting is enabled.  @return an int value of the error code. 0 means success. 254 means initialization error. -2，means livestream feature is disabled by ldm. -3 means failure to obtain sps/pps.",
             "stopstream",
             "stop the live streaming. the operation is asynchronous  and `isstreaming` will return `false`  when the operation is complete.",
             "getstarttime",
             "returns the start time of the live streaming. the start time is  updated when `startstream` is successful.  @return a long value of the start time.",
             "setaudiostreamingenabled",
             "enables/disables the audio streaming. when it is enabled, the audio received by the mobile device's microphone will be streamed  to the rtmp server along with the video. this setting will take effect before `startstream` is called. changing this setting after `startstream` is called requires restarting the streaming. the audio can be  muted during the streaming by calling `setaudiomuted`.  @param enabled pass `true` to enable the audio streaming, `false` to disable the audio streaming.",
             "setaudiomuted",
             "mutes the audio or unmutes the audio.  notes: this method only works when audio function is enabled ( `isliveaudioenabled` returns `true`).  @param enable pass `true` to mute the audio, `false` to unmute the audio.",
             "isliveaudioenabled",
             "returns `true` if the audio function is enabled, vice versa.  @return a boolean value to check if the audio function is enabled.",
             "isaudiomuted",
             "returns `true` if the audio is muted, vice versa.  @return a boolean value to check if the audio is muted.",
             "setvideoencodingenabled",
             "enables/disables the video encoding by force for the live streaming. the basic workflow to process  the video feed from the aircraft is to decode first and then encode again with a specific bit rate  into h.264 stream. therefore, video encoding is required in default. for some drones like mavic pro,  the original video feed from mavic pro remote controller can be streamed to a rtmp server directly,  so the video encoding is disabled for mavic pro, however, the bit- rate of the original video is very  high, by enabling this flag, the original video will be decoded and encoded to a lower speed video stream.  @param enable pass `true` to enable the video encoding, `false` to disable the video encoding.",
             "isvideoencodingenabled",
             "returns `true` if video encoding is enabled, vice versa.  @return `true` if the force encoding flag is enabled.",
             "getlivevideofps",
             "returns the real-time live video fps.  @return a float value of the live video fps.",
             "setlivevideoresolution",
             "sets the live video resolution.  @param videoresolution an emun value of the live video resolution.",
             "getlivevideoresolution",
             "returns the live video resolution.  @return an emun value of the live video resolution.",
             "setlivevideobitratemode",
             "sets the live video bit rate mode.  @param bitratemode an emun value of the live video bit rate mode.",
             "getlivevideobitratemode",
             "returns the live video bit rate mode.  @return an emun value of the live video bit rate mode.",
             "setlivevideobitrate",
             "sets the real-time video stream bit rate in kpbs.  @param bitrate a float value of the live video bit rate. the value should be in the range [0.5*1024, 3.5*1024] kpbs.",
             "getlivevideobitrate",
             "returns the real-time video stream bit rate in kpbs.  @return an int value of the live video bit rate.",
             "getliveaudiobitrate",
             "returns the real-time audio stream bit rate in kpbs.  @return an int value of the live audio bit rate.",
             "getlivevideocachesize",
             "returns the real-time video cache list size, unit: frame.  @return an int value of the live video cache list size.",
             "livevideoresolution",
             "enums represent the live video resolution.",
             "video_resolution_1920_1080",
             "the live streaming video resolution is 1920x1080.",
             "video_resolution_1440_1080",
             "the live streaming video resolution is 1440x1080.",
             "video_resolution_1280_720",
             "the live streaming video resolution is 1280x720.",
             "video_resolution_1280_960",
             "the live streaming video resolution is 1280x960.",
             "video_resolution_960_720",
             "the live streaming video resolution is 960x720.",
             "video_resolution_960_540",
             "the live streaming video resolution is 960x540.",
             "video_resolution_720_540",
             "the live streaming video resolution is 720x540.",
             "video_resolution_480_360",
             "the live streaming video resolution is 480x360.",
             "livevideobitratemode",
             "enums represent the live video bit rate mode.",
             "auto",
             "the live video bit rate mode is auto. in this mode, the live video bit rate will change as the network changes, and smoothness is preferred.",
             "manual",
             "the live video bit rate mode is manual. this is the initialization mode of live video. initial live video bit rate is 2*1024 kbps.",
             "setcomponentlistener",
             "sets the listener for the dji component.  @param listener the callback of `componentlistener`.",
             "onconnectivitychange",
             "called when the connectivity status has changes for the component. this callback will be called when the component disconnects from the product. if the product itself gets disconnected,  this callback method will be called by all of the product component.  @param isconnected `true` if the component is connected.",
             "getindex",
             "returns the component index. index is zero based. a component will have an index greater than zero when there  are multiple components of the same type on the dji product, and one of the components already has the index 0.  for instance, m210 can have two gimbal mounted cameras, and will therefore have two gimbal components with indices  0 and 1, and two camera components with indices 0 and 1. for matrice 600, there are printed numbers on the battery  boxes. the `battery` component instance with index 0 corresponds to battery compartment number 1. for inspire 2  and m200 series, `battery` with index 0 corresponds to the battery on the port (left hand) side of the aircraft.  for m210, m210 rtk, m300 rtk and m350 rtk, `camera` and `gimbal` with index 0 corresponds to the camera and gimbal on the port  (left hand) side of the aircraft. `lidar` with index 0 corresponds to the lidar(zenmuse l1) on the port  (left hand) side of the aircraft.  @return an int value of index.",
             "isconnected",
             "`true` if the component is connected.  @return `true` if the component is connected.",
             "getserialnumber",
             "gets the serial number of the component. depending on the component, this serial number might not match the serial number found  on the physical component.  @param callback the execution callback with the value returned.",
             "getfirmwareversion",
             "returns the firmware version of the component. each component will  have a different firmware version, the combination of which will  form the package firmware version `getfirmwarepackageversion` found in `baseproduct`.  @param callback the execution callback with the value(s) returned.",
             "componentlistener",
             "receives notifications of component connectivity changes.",
             "authorizeaccesstodjidevicehardwareinfo",
             "authorizes dji server to access dji device's hardware information (serial numbers of the aircraft and the remote  controller). the serial number will be sent to dji server for two purposes:  - dji sdk analytics: the hashed  serial number is used to distinguish statistics from different dji devices.  - app activation: the serial number  is used to request the app activation state from the server. when the user is located in china, the serial number is still sent to dji server for policy reason even it is not authorized by the user. dji server is not authorized by  default. however, it is highly recommended to ask the user to authorize it, which can help dji keep improving sdk.  @param hardwareinfoauthorized `true` to authorize dji server to access the data.  @return the encountered error if there is any.",
             "isaccesstodjidevicehardwareinfoauthorized",
             "get the authorization of access to data of type dji hardware information.  @return `true` if it is authorized.",
             "isaccesstoobfuscatedlocationauthorized",
             "get the authorization of access to data of type obfuscated location.  @return `true` if it is authorized.",
             "agreetoproductimprovement",
             "agree or disagree with the product improvement project. through this project, the dji device information, mobile device information,  and diagnostic and usage data collected through msdk will be provided to dji for analysis.  this analysis helps dji improve products and services.  dji will take necessary data protection measures before data analysis.  @param isagree `true` to ageree product improvement project.  @return the encountered error if there is any.",
             "isagreetoproductimprovement",
             "gets whether to agree to the product improvement project.  @return `true` if it is agreed to product improvement project.",
             "getinstance",
             "get the singleton instance of the class.  @return an object of `dataprotectionmanager`.",
             "djisdkmanager",
             "this class is the entry point for using the sdk with a dji product. most importantly, this class is used to register the sdk, and to connect to and access the product. this class also provides access to important feature managers (such as `getkeymanager`), debugging tools, and threading control of asynchronous callbacks. sdk registration using `registerapp` must be successful before the sdk can be used with a dji product.",
             "keymanager",
             "`keymanager` provides access to the keyed interface using `djikey` and corresponding subclass objects. `keymanager` is accessed from `getkeymanager` in `djisdkmanager`.",
             "flyzonemanager",
             "fly zone manager gives information about nearby fly zones, and apis to unlock zones that can be unlocked. depending on location, there are three types of fly zones possible:  - `circle`: cylinder or truncated cone volume with four levels of restriction:     - warning zones : no restriction     - enhanced warning zones : flight restricted, can be unlocked for         flight when the user logs into their dji account     - authorization zones : flight restricted, can be unlocked for         flight when the user logs into their dji account and the account         has been authorized to unlock authorization zones.     - restricted zones : flight restricted - `poly`: fly zone that consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. a height limitation of 0 means flight is completely restricted. this is used by spark, mavic, phantom 4 series, inspire 2 and matrice 200 series. on the phantom 3, inspire 1, m100, m600, a3/n3 series of products, there can also be a buffer area with radius about 23 km around a restricted fly zone where flight height is limited to 120m.</br> not supported by dji air 2s.</br>",
             "appactivationmanager",
             "dji aircraft firmware require mobile applications that control dji aircraft to be activated with the user's dji account, if that application is being used in china. this will ensure operators use the correct set of geospatial information and flight functions for their aircraft, as determined by their geographical location and user profile.  a summary of the activation system is:  - users in china are required to activate their application by logging into their dji account at least once every three months within the application  - activation will be persistent in the application until the user logs out  - a data connection will be required to log into a dji account  - outside of china, the sdk will automatically activate the application without requiring the user to log in  - additionally, users in china are required to bind their aircraft to their user account in dji go. this is required only once.  if an application is not activated, the aircraft not bound (if required), or a legacy version of the sdk (<4.1) is being used, all camera live streams will be disabled, and flight will be limited to a cylinder of 100m diameter and 30m height to ensure the aircraft stays within line of sight.  this class is used to check the state of application activation and aircraft binding.",
             "useraccountmanager",
             "class used to manage the dji account.",
             "dataprotectionmanager",
             "data protection manager. dji sdk will send data to dji servers in the background in order to complete logics, including data related to user's information. data protection manager can be used to authorize dji server to access the user- related data. sdk will not send the data to dji server in the background before the authorization. internet requests triggered by the user manually are not managed by `dataprotectionmanager`. involved user-related data is listed in the documentation of the interfaces. this class is accessible before calling `registerapp`. the utmissmanager class needs to report flight dynamic data to the utmiss server in accordance with the policy requirements of the civil aviation administration of china. it is not in this category of management. for details, please refer to the utmissmanager interface document.",
             "ldmmanager",
             "local data mode (ldm) manager. when local data mode is enabled, the sdk's access to the internet is restricted. you should use `registerappforldm` to register the app. only application registration (confirming the app key is valid) will be unrestricted. all other sdk services will be restricted. when the sdk's internet access is restricted, all sdk services that require an internet connection will not be available or able to update. for instance, the fly zone manager will not be able to update the fly zone data base, retrieve the latest tfrs (temporary flight restrictions) or unlock fly zones. ldm is therefore most appropriate for users that have very stringent data requirements, and are able to accommodate this restricted functionality.  when local data mode is enabled, the utmissmanager will not report flight dynamic data to the utmiss server.",
             "utmissmanager",
             "this class is to manage utmiss flight data upload. according to the civil aviation administration of china's light civil uav flight dynamic data management regulations , relevant units, individuals that operate light, small civil drones and plant protection drones in the airspace provided by the people's republic of china with air traffic services need timely, accurate and complete real-time reporting to the civil aviation administration to send real flight dynamic data. if flight dynamic data is not reported or missed in time, it shall be replaced in accordance with relevant regulations on navigation flight control. according to the above requirements, this function will report user flight dynamics data to the utmiss server. developers are requested to enable this function after obtaining user authorization.",
             "flighthubmanager",
             "the flighthubmanager class provides methods to interact with dji flighthub (https://www.dji.com/flighthub). sdk provides interfaces to upload the states of the connected aircraft to the flighthub server and download the flight data from the server. to access dji flighthub features through sdk, the logged-in user should be already activated with a valid flighthub license. use `isuseractivated` to check if the user is activated. note: invoke `updateactivationstate` before using any other method to verify your accessibility.",
             "livestreammanager",
             "the manager is used to stream the video to a rtmp server to do live streaming with dji products.",
             "iuasremoteidmanager",
             "rid management class of the drone system. in order to meet the increasingly standardized drone regulatory requirements around the world, the drone in flight should be able to broadcast the identification and location of the operator and the drone.",
             "upgrademanager",
             "this interface is used to manage the component that can be upgraded. it is only supported by mavic air, mavic 2 series and matrice 300 rtk.",
             "baseproduct",
             "abstract class for all dji products. `aircraft` and `handheld` objects are subclasses of `baseproduct` and can be accessed from `getproduct` in `djisdkmanager`. additional components can be found in `aircraft` and `handheld` that are unique to those products only.",
             "basecomponent",
             "abstract class for components in a dji product. a component can be a camera, gimbal, remote controller, etc. a dji product consists of several components. all components of a product are subclasses of `basecomponent` and can be accessed directly from the product objects (`aircraft` or `handheld`).",
             "aircraft",
             "aircraft product class, which includes basic product information and access to all components (such as flight controller, battery etc.). this object is accessed from `getproduct` in `djisdkmanager`.",
             "handheld",
             "handheld product class, which includes basic product information and access to all components (such as camera, battery etc.). this object is accessed from `getproduct` in `djisdkmanager`.",
             "flightcontroller",
             "this class contains components of the flight controller and provides methods to send different commands to the flight controller. this object is available from the `aircraft` object which is a subclass of `baseproduct`.",
             "battery",
             "this class manages information and real-time status of the connected product's batteries. this object is available from the `aircraft` or `handheld` object which is a subclass of `baseproduct`.",
             "camera",
             "this class contains the media manager and playback manager, which manage the camera's media content. it provides methods to change camera settings and perform camera actions. this object is available from the `aircraft` or `handheld` object, which is a subclass of `baseproduct`.",
             "gimbal",
             "this class provides multiple methods to control the gimbal. these include setting the gimbal work mode, rotating the gimbal with angle, starting the gimbal auto calibration, etc. this object is available from the `aircraft` or `handheld` object which is a subclass of `baseproduct`.",
             "airlink",
             "this class contains information about the wireless link between the aircraft and the remote controller, the aircraft and the mobile device or the handheld product and the mobile device. to determine whether a particular wireless link is supported, check the issupported flag. this object is available from the `aircraft` or `handheld` object which is a subclass of `baseproduct`.",
             "remotecontroller",
             "this class represents the remote controller of the aircraft. it provides methods to change the settings of the physical remote controller. for some products (e.g. inspire 1 and matrice 100), the class provides methods to manager the slave/master mode of the remote controllers. a remote controller is a device that can have a gps, battery, radio, buttons, sticks, wheels, and output ports for video. the mobile device is connected to the remote controller, which is always sending out information about what everything is doing. the normal remote controller is called the master. a slave wirelessly connects to the master remote controller at 5 ghz, and the aircraft can also download information to the slave. the slave can send gimbal control commands to the master. this configuration allows one person to fly the aircraft while another person controls the gimbal. this object is available from the `aircraft` subclass off `baseproduct`.",
             "handheldcontroller",
             "this class contains interfaces related to the hand controller of a handheld device (such as osmo). this object is available from the `handheld` subclass off `baseproduct`.",
             "mobileremotecontroller",
             "a simulated remote controller on the mobile device to control the aircraft when the physical remote controller is absent. the mobile remote controller only supports mode 2 control style and flight mode p. it is supported by mavic pro using wifi. this object is available from the `aircraft` subclass off `baseproduct`.",
             "payload",
             "class used to interact with the payload device mounted on dji aircraft. <b>note: in the msdk v4 version, the psdk payload device cannot be used with zenmuse l1 and zenmuse p1 at the same time. if you need to use them at the same time, please upgrade to msdk v5.</b>",
             "accessoryaggregation",
             "this class contains all possible accessories (spotlight, beacon and speaker) supported by the aircraft. the accessory aggregation component is available when mavic 2 enterprise is connected. an accessory becomes available only when the accessory is connected to the aircraft.",
             "basestation",
             "rtk base station.",
             "lidar",
             "this class represents the lidar of the aircraft which contanis the related functions of livox. current only supported by zenmuse l1. note: zenmuse l1 can only be set at gimbal position 0 where it is at the left side of the aircraft.  the zenmuse l1 integrates a livox lidar module, a high-accuracy imu, and a camera with a 1-inch cmos on a 3-axis stabilized gimbal. when used with matrice 300 rtk and dji terra, the l1 forms a complete solution that gives you real-time 3d data throughout the day, efficiently capturing the details of complex structures and delivering highly accurate reconstructed models.  this object is available from the `aircraft` or `handheld` object which is a subclass of `baseproduct`.",
             "missioncontrol",
             "mission control handles execution of missions. either single missions can be run through dedicated mission operators, or a series of missions and actions can be run serially using the timeline.  mission operators look after execution of a single mission. a mission operator has apis to control the mission (e.g. start, stop, pause etc.) and provides mission state through listeners.  mission control's timeline is made up of a series of timeline elements which can be waypoint missions, hotpoint missions (through the hotpoint action `hotpointaction`) or objects that follow the `timelineelement` protocol. `missionaction` is a timeline element, with `aircraftyawaction` and `gimbalattitudeaction` subclasses being examples of specific actions. if a mission is being executed in a timeline, the mission operator can still be used to get state information of the mission as well as change mission execution parameters.  timeline elements can also have triggers (`trigger`) associated with them. triggers are separate objects that are run in parallel with a timeline element. the trigger object is used to initiate actions if a set of criteria are met. for example, a trigger could be used to monitor battery level, and then initiate an action once a threshold is passed. mission control's timeline is only supported by aircrafts. handheld devices (e.g. osmo) do not support this feature.  > mission control is accessed from `getmissioncontrol` in `djisdkmanager`.",
             "missionaction",
             "base class for all mission control timeline based actions.",
             "timelinemission",
             "wrapper class for the different types of mission to be compatible with timeline.",
             "trigger",
             "mission triggers can be used to trigger an action during the execution of a timeline element if a set of criteria is met. the subclass of `trigger` should implement the logic for collecting and judging the criteria, and then executing the action. mission triggers are used in the timeline element `timelineelement`.  trigger actions can be listened to, so when subclassing this class, `notifylistenersofevent` should be used to notify listeners of trigger events.  see also: djimissioncontrol",
             "waypointmissionoperator",
             "the waypoint operator is the only object that controls, runs and monitors waypoint missions. it can be accessed from `missioncontrol`. for matrice 300 rtk,  it is recommended that you use `waypointv2missionoperator`. `waypointmissionoperator` will no longer be maintained.",
             "waypointv2missionoperator",
             "the waypoint operator is the only object that controls, runs and monitors waypoint v2 missions. it can be accessed from `missioncontrol`.",
             "followmemissionoperator",
             "the follow me mission operator is the only object that controls, runs and monitors followme missions. it can be accessed from `missioncontrol`.",
             "panoramamissionoperator",
             "the panorama mission operator is the only object that controls, runs and monitors panorama missions. it can be accessed from `missioncontrol`.",
             "hotpointmissionoperator",
             "the hotpoint mission operator is the only object that controls, runs and monitors hotpoint missions. it can be accessed from `missioncontrol`.",
             "intelligenthotpointmissionoperator",
             "the intelligent hotpoint mission operator is the only object that controls, runs and monitors intelligent hotpoint missions. it can be accessed from `missioncontrol`. `intelligenthotpointmissionoperator` has two ways to start an intelligent hotpoint mission: one is to start a `djiintelligenthotpointmission`, which will repeatedly around a specified point called hotpoint. the other you will target a rect in your fpv view, and send it to vision system to track, when the state change to `djiintelligenthotpointmissionoperator_waitingforconfirmation`, you can `acceptconfirmation`, then the aircraft will fly around the object. when mission executing, it will not need target object, actually track mode only help to set hotpoint at a target object.  now only supported by mavic 2 zoom and mavic 2 pro.",
             "tapflymissionoperator",
             "the operator for tapfly mission. it is used to execute a tapfly mission.",
             "activetrackoperator",
             "the active track mission operator is the only object that controls, runs and monitors activetrack missions. it can be accessed from `missioncontrol`.  an activetrack mission allows an aircraft to track a moving subject using the vision system and without a gps tracker on the subject. to use an activetrack mission:  - prepare a mission with the rectangle that best represents the target to track  - start the mission to initiate tracking of the object and begin the state updates (`getcurrentstate`)  - at this point, the aircraft will track the target while hovering in place.  - give confirmation that the tracked target is correct with `acceptconfirmation` and the aircraft will begin flying relative to the target. for mavic air 2 and dji air 2s, only circle mode need to be confirmation.  - if the tracking algorithm looses sufficient confidence in tracking the target, then the aircraft will stop flying relative to the object and either notify the user (through execution state) that the target is lost or it needs another confirmation that the target is correct.  - if you want to pause the mission, you can swith the mission mode to `spotlight`, the aircraft will hover in place, but continue tracking the target by adjusting gimbal pitch and aircraft yaw.  - if you want to resume the mission, you can switch the mission mode to track mode again, confirmation of tracking rectangle will need to be sent through to start flying relative to target. (for mavic air 2 and dji air 2s, there is no need to confirm when you switch mode, since there is no obstacle avoidance system on the left and right sides, be especially careful in the circle mode.)  - the mission can be canceled with `stoptracking` at any time. - `stoptracking` should also be used to reject tracking confirmation if the camera is tracking the wrong target. after stopping the mission, the mission needs to be recreated with a new rectangle and loaded into the operator.  - the main camera is used to track the target, so gimbal cannot be adjusted during an activetrack mission.  - during the mission the aircraft can be manually flown with roll and throttle. pitch,yaw and gimbal are automatically controlled to continue tracking the target.  - if the mission is executing, and after confirmation of the tracking rectangle has been sent, the aircraft can be manually controlled horizontally similar to a `home_lock` where the home is the tracked target. if aircraft is manually controlled upward, the aircraft will lift and retreat, and if it is controlled downward, it will go down and get closer to the target.  - for mavic air 2 and dji air 2s, you can use the activetrack mission in the normal, sport, tripod flight modes. because obstacle sensing is disabled in sport mode, so please use activetrack mission in an open area.  - for matrice 300 rtk, only support spotlight mode. you can use `setspotlightmode` to set the spotlight mode which support `zoom_gimbal_following` and `zoom_gimbal_free` .",
             "commoncallbacks",
             "interfaces of common callbacks used to return results of asynchronous operations.",
             "warningstatusitem",
             "this class wraps the required elements of the status into one warningstatusitem.",
             "videosizecalculatorutil",
             "utility class for calculating the appropriate size of the video based on screen type and video type defined by aircraft's mode and resolution settings",
             "locationutil",
             "util class to get location based information.",
             "djiparamcapability",
             "represents the capability of a parameter of a component or product. this class can be sub-classed to include additional information on the parameter. `djiparamminmaxcapability` includes the maximum and minimum possible values of the parameter.",
             "djierror",
             "class that handles all errors that are not handled by individual components.",
             "djidiagnostics",
             "product diagnostics.",
             "djicodecmanager",
             "class that handles encoding and decoding of media.",
             "stick",
             "dji hardware stick. for example, the joystick on a remote controller, or the gimbal control stick on a handheld controller.",
             "setstatecallback",
             "sets up the gimbal state update callback.  @param callback the execution callback.",
             "setmovementsettingscallback",
             "sets up the gimbal advanced setting state update callback.  @param callback the execution callback.",
             "setbatterychargeremainingcallback",
             "sets the gimbal remaining energy callback. the unit is percentage.  @param callback the execution callback.",
             "onupdate",
             "updates the gimbal's current state.  @param gimbalstate the gimbal state.",
             "onupdate",
             "update the gimbal's user configuration data. this method is only supported by osmo series.  @param settings an instance of `movementsettings`.",
             "onupdate",
             "update the gimbal's remaining energy in percentage.  @param remainingchargeinpercent an int value.",
             "setstiffnessselftuningcallback",
             "set listener for updating the gimbal's control parameters auto tuning state.  @param callback a `gimbalcontrolparametersautotuningstate` callback.",
             "setbalancecheckcallback",
             "set listener for updating the gimbal's balance detection state.  @param callback a `gimbalbalancedetectionstate` callback.",
             "setconcentricitycheckcallback",
             "set listener for updating the gimbal's coaxiality detection state.  @param callback a `gimbalcoaxialitydetectionstate` callback.",
             "getcapabilities",
             "returns the gimbal's features and possible range of settings. each key is a possible gimbal feature and is in `capabilitykey` enum. the value for each key is an instance of `djiparamcapability` or its sub-classes. the `issupported` property can be used to query if a feature is supported by the gimbal and the `getmin` and `getmax` properties of `djiparamminmaxcapability` can be used to query the valid range for the setting. when a feature is not supported, the values for `getmin` and `getmax` are undefined.  @return a map<capabilitykey, djiparamcapability> instance.",
             "capabilities",
             "sdk key for getcapabilities: returns the gimbal's features and possible range of settings. each key is a possible gimbal feature and is in `capabilitykey` enum. the value for each key is an instance of `djiparamcapability` or its sub-classes. the `issupported` property can be used to query if a feature is supported by the gimbal and the `getmin` and `getmax` properties of `djiparamminmaxcapability` can be used to query the valid range for the setting. when a feature is not supported, the values for `getmin` and `getmax` are undefined.  @return a map<capabilitykey, djiparamcapability> instance.",
             "getyawrelativetoaircraftheading",
             "this function will return the angle between gimbal and the drone heading.  @return a float value of yaw angle.",
             "yaw_angle_with_aircraft_in_degree",
             "sdk key for getyawrelativetoaircraftheading: this function will return the angle between gimbal and the drone heading.  @return a float value of yaw angle.",
             "setmode",
             "sets the gimbal's work mode.  @param mode gimbal work mode to be set. @param callback the execution callback with the returned execution result.",
             "gimbalkey.mode",
             "sdk key for setmode: sets the gimbal's work mode.  @param mode gimbal work mode to be set. @param callback the execution callback with the returned execution result.",
             "reset",
             "resets the gimbal. the behaviors are product-dependent. osmo series (e.g. osmo, osmo pro): the gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. phantom series (e.g. phantom 3 professional, phantom 4 series): the first call sets gimbal to point down vertically to the earth. the second call sets gimbal to the standard position. other products (e.g. inspire 1): only the gimbal's pitch will the set to the origin.  @param callback the execution callback with the returned execution result.",
             "reset_gimbal",
             "sdk key for reset: resets the gimbal. the behaviors are product-dependent. osmo series (e.g. osmo, osmo pro): the gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. phantom series (e.g. phantom 3 professional, phantom 4 series): the first call sets gimbal to point down vertically to the earth. the second call sets gimbal to the standard position. other products (e.g. inspire 1): only the gimbal's pitch will the set to the origin.  @param callback the execution callback with the returned execution result.",
             "reset",
             "resets the gimbal. the behaviors are dependent on the selected axis and reset direction.  supported by:  zenmuse h20 and zenmuse h20t (firmware version v01.00.06.98 and above)  dji x-port (firmware version v02.00.07.60 and above)  zenmuse z30 (firmware version v01.01.03.00 and above)  zenmuse x5s (firmware version v01.01.03.00 and above)  zenmuse x7 (firmware version v00.02.05.68 and above)  zenmuse xt2 (firmware version v00.02.06.46 and above)  zenmuse xts (firmware version v00.02.32.82 and above)  @param axis the axis to reset. @param resetdirection the direction on axis to reset. @param callback the execution callback with the returned execution result.",
             "rotate",
             "rotate gimbal's pitch, roll, and yaw with `djigimbalrotation`. for x5s, x4s and x7, rotating the gimbal with mode `relative_angle` or `absolute_angle`, will reset the gimbal mode to `free`.  @param rotation an instance of `rotation`. @param callback the callback of `completioncallback<t`.",
             "rotate",
             "sdk key for rotate: rotate gimbal's pitch, roll, and yaw with `djigimbalrotation`. for x5s, x4s and x7, rotating the gimbal with mode `relative_angle` or `absolute_angle`, will reset the gimbal mode to `free`.  @param rotation an instance of `rotation`. @param callback the callback of `completioncallback<t`.",
             "lookat",
             "the aircraft will look at the gps point you set up，it is only supported by zenmuse h20 series.  @param locationcoordinate3d the gps location you want to look at. you could get the location from `gettargetlocation` or get the location with map. @param mode the look at mode. @param callback the callback of `completioncallback<t`.",
             "lookatmode",
             "gimbal lookat mode. include gimbal free mode and gimbal following mode.",
             "look_at_gimbal_free",
             "gimbal free mode, only control the gimbal to look at the target, it will automatically exit after completion.",
             "look_at_gimbal_following",
             "gimbal following mode, control gimbal and aircraft to look at the target, it will automatically exit after completion.",
             "startcalibration",
             "starts calibrating the gimbal. the product should be stationary (not flying, or being held) and horizontal during calibration. for gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. for osmo mobile series, user should double-click the trigger (or mode button on osmo mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback the execution callback with the returned execution result.",
             "start_calibration",
             "sdk key for startcalibration: starts calibrating the gimbal. the product should be stationary (not flying, or being held) and horizontal during calibration. for gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. for osmo mobile series, user should double-click the trigger (or mode button on osmo mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback the execution callback with the returned execution result.",
             "finetunerollindegrees",
             "the gimbal roll can be fine tuned with a custom offset. the range for the custom offset is [-2.0, 2.0] degrees. if the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset fine-tuned offset, in degrees, to be tuned. @param callback the execution callback with the returned execution result.",
             "fine_tune_roll_in_degrees",
             "sdk key for finetunerollindegrees: the gimbal roll can be fine tuned with a custom offset. the range for the custom offset is [-2.0, 2.0] degrees. if the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset fine-tuned offset, in degrees, to be tuned. @param callback the execution callback with the returned execution result.",
             "finetunepitchindegrees",
             "the gimbal pitch can be fine tuned with a custom offset. the range for the custom offset is [-2.0, 2.0] degrees. if the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. it is only supported by spark, mavic 2 series and mavic air 2, dji air 2s.  @param offset fine-tuned offset, in degrees, to be tuned. @param callback the execution callback with the returned execution result.",
             "finetuneyawindegrees",
             "the gimbal yaw can be fine tuned with a custom offset. the range for the custom offset is [-2.0, 2.0] degrees. if the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. it is only supported by mavic air and mavic 2 series.  @param offset fine-tuned offset, in degrees, to be tuned. @param callback the execution callback with the returned execution result.",
             "startbalancetest",
             "starts testing the balance of the gimbal payload. for gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. the product should be stationary (not flying, or being held) and horizontal during testing. see `gimbalstate` for the test result.  @param callback the execution callback with the returned value(s). the callback will execute when the balance test is successfully started.",
             "start_balance_test",
             "sdk key for startbalancetest: starts testing the balance of the gimbal payload. for gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. the product should be stationary (not flying, or being held) and horizontal during testing. see `gimbalstate` for the test result.  @param callback the execution callback with the returned value(s). the callback will execute when the balance test is successfully started.",
             "setmovementsettingsprofile",
             "sets the movement settings profile. the movement settings profile has options for both preset and custom profiles for smoothtrack and controller settings. settings for smoothtrack and controller can only be set manually when using a custom profile.  @param profile profile to set. @param callback the execution callback with the returned value(s).",
             "movement_settings_profile",
             "sdk key for setmovementsettingsprofile: sets the movement settings profile. the movement settings profile has options for both preset and custom profiles for smoothtrack and controller settings. settings for smoothtrack and controller can only be set manually when using a custom profile.  @param profile profile to set. @param callback the execution callback with the returned value(s).",
             "getmovementsettingsprofile",
             "gets the advanced settings profile. use `movementsettingsprofile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
             "movement_settings_profile",
             "sdk key for getmovementsettingsprofile: gets the advanced settings profile. use `movementsettingsprofile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
             "restorefactorysettings",
             "restores the gimbal's settings to factory settings.  @param callback the completion callback that receives the execution result.",
             "gimbalkey.restore_factory_settings",
             "sdk key for restorefactorysettings: restores the gimbal's settings to factory settings.  @param callback the completion callback that receives the execution result.",
             "setpitchrangeextensionenabled",
             "extends the pitch range of gimbal. if extended, the range of the pitch angle should be gotten from the `adjust_pitch` or `adjust_pitch_upwards`. otherwise, the angle will be limited to avoid seeing the arm. use `pitch_range_extension` to check if it is supported by the gimbal.  @param isenabled whether the pitch range should be extended. @param callback the completion callback that receives the execution result.",
             "pitch_range_extension_enabled",
             "sdk key for setpitchrangeextensionenabled: extends the pitch range of gimbal. if extended, the range of the pitch angle should be gotten from the `adjust_pitch` or `adjust_pitch_upwards`. otherwise, the angle will be limited to avoid seeing the arm. use `pitch_range_extension` to check if it is supported by the gimbal.  @param isenabled whether the pitch range should be extended. @param callback the completion callback that receives the execution result.",
             "getpitchrangeextensionenabled",
             "get the extend gimbal pitch range state. use `pitch_range_extension` to check if it is supported by the gimbal.  @param callback the completion callback that receives the execution result.",
             "pitch_range_extension_enabled",
             "sdk key for getpitchrangeextensionenabled: get the extend gimbal pitch range state. use `pitch_range_extension` to check if it is supported by the gimbal.  @param callback the completion callback that receives the execution result.",
             "applymotorcontrolpreset",
             "configures gimbal's motor control with a preset configuration applicable for most popular cameras. in order to the optimize the performance, motor control tuning is still required.  @param preset the preset configuration to set. @param callback the completion callback that receives the execution result.",
             "apply_motor_control_preset",
             "sdk key for applymotorcontrolpreset: configures gimbal's motor control with a preset configuration applicable for most popular cameras. in order to the optimize the performance, motor control tuning is still required.  @param preset the preset configuration to set. @param callback the completion callback that receives the execution result.",
             "setmotorcontrolstiffness",
             "sets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param stiffness the stiffness value to set. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_stiffness",
             "sdk key for setmotorcontrolstiffness: sets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param stiffness the stiffness value to set. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_stiffness",
             "sdk key for setmotorcontrolstiffness: sets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param stiffness the stiffness value to set. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_stiffness",
             "sdk key for setmotorcontrolstiffness: sets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param stiffness the stiffness value to set. @param callback the completion callback that receives the execution result.",
             "getmotorcontrolstiffness",
             "gets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_stiffness",
             "sdk key for getmotorcontrolstiffness: gets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_stiffness",
             "sdk key for getmotorcontrolstiffness: gets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_stiffness",
             "sdk key for getmotorcontrolstiffness: gets the coefficient of speed error control. it can be seen as the coefficient for the proportional term in the pid controller. use `pitch_motor_control_stiffness`, `yaw_motor_control_stiffness` and `roll_motor_control_stiffness` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "setmotorcontrolstrength",
             "sets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param strength the strength value to set. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_strength",
             "sdk key for setmotorcontrolstrength: sets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param strength the strength value to set. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_strength",
             "sdk key for setmotorcontrolstrength: sets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param strength the strength value to set. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_strength",
             "sdk key for setmotorcontrolstrength: sets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param strength the strength value to set. @param callback the completion callback that receives the execution result.",
             "getmotorcontrolstrength",
             "gets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_strength",
             "sdk key for getmotorcontrolstrength: gets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_strength",
             "sdk key for getmotorcontrolstrength: gets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_strength",
             "sdk key for getmotorcontrolstrength: gets the coefficient of attitude accuracy control. it can be seen as the coefficient for the integral term in the pid controller. use `pitch_motor_control_strength`, `yaw_motor_control_strength` and `roll_motor_control_strength` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "setmotorcontrolgyrofilteringfactor",
             "sets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringfactor the gyro filtering value to set. @param axis the axis that the setting is applied to. @param callback asynchronous execution result.",
             "pitch_motor_control_gyro_filtering_factor",
             "sdk key for setmotorcontrolgyrofilteringfactor: sets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringfactor the gyro filtering value to set. @param axis the axis that the setting is applied to. @param callback asynchronous execution result.",
             "roll_motor_control_gyro_filtering_factor",
             "sdk key for setmotorcontrolgyrofilteringfactor: sets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringfactor the gyro filtering value to set. @param axis the axis that the setting is applied to. @param callback asynchronous execution result.",
             "yaw_motor_control_gyro_filtering_factor",
             "sdk key for setmotorcontrolgyrofilteringfactor: sets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringfactor the gyro filtering value to set. @param axis the axis that the setting is applied to. @param callback asynchronous execution result.",
             "getmotorcontrolgyrofilteringfactor",
             "gets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_gyro_filtering_factor",
             "sdk key for getmotorcontrolgyrofilteringfactor: gets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_gyro_filtering_factor",
             "sdk key for getmotorcontrolgyrofilteringfactor: gets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_gyro_filtering_factor",
             "sdk key for getmotorcontrolgyrofilteringfactor: gets the coefficient of denoising the output. use `pitch_motor_control_gyro_filtering_factor`, `yaw_motor_control_gyro_filtering_factor` and `roll_motor_control_gyro_filtering_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "setmotorcontrolprecontrol",
             "sets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param precontrol the precontrol value to set. @param callback asynchronous execution result.",
             "pitch_motor_control_pre_control",
             "sdk key for setmotorcontrolprecontrol: sets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param precontrol the precontrol value to set. @param callback asynchronous execution result.",
             "roll_motor_control_pre_control",
             "sdk key for setmotorcontrolprecontrol: sets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param precontrol the precontrol value to set. @param callback asynchronous execution result.",
             "yaw_motor_control_pre_control",
             "sdk key for setmotorcontrolprecontrol: sets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting is applied to. @param precontrol the precontrol value to set. @param callback asynchronous execution result.",
             "getmotorcontrolprecontrol",
             "gets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. only supported by ronin-mx. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_motor_control_pre_control",
             "sdk key for getmotorcontrolprecontrol: gets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. only supported by ronin-mx. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "roll_motor_control_pre_control",
             "sdk key for getmotorcontrolprecontrol: gets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. only supported by ronin-mx. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_motor_control_pre_control",
             "sdk key for getmotorcontrolprecontrol: gets the value for pre-adjust. it can be seen as the coefficient for the derivative term in the pid controller. only supported by ronin-mx. use `pitch_motor_control_pre_control`, `yaw_motor_control_pre_control` and `roll_motor_control_pre_control` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "setcontrollerdeadband",
             "sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) deadband on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband the deadband value to be set. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "pitch_controller_deadband",
             "sdk key for setcontrollerdeadband: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) deadband on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband the deadband value to be set. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "yaw_controller_deadband",
             "sdk key for setcontrollerdeadband: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) deadband on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband the deadband value to be set. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "getcontrollerdeadband",
             "gets physical controller deadband value on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_controller_deadband",
             "sdk key for getcontrollerdeadband: gets physical controller deadband value on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_controller_deadband",
             "sdk key for getcontrollerdeadband: gets physical controller deadband value on an axis. a larger deadband requires more controller movement to start gimbal motion. use `yaw_controller_deadband` and `pitch_controller_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction the axis to query. @param callback the completion callback that receives the execution result.",
             "setcontrollerspeedcoefficient",
             "sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) speed on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedcoefficient the speed value to be set. @param axis the axis that the setting will be applied to. @param callback asynchronous execution result.",
             "pitch_controller_speed_coefficient",
             "sdk key for setcontrollerspeedcoefficient: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) speed on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedcoefficient the speed value to be set. @param axis the axis that the setting will be applied to. @param callback asynchronous execution result.",
             "yaw_controller_speed_coefficient",
             "sdk key for setcontrollerspeedcoefficient: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) speed on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedcoefficient the speed value to be set. @param axis the axis that the setting will be applied to. @param callback asynchronous execution result.",
             "getcontrollerspeedcoefficient",
             "gets physical controller speed value on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "pitch_controller_speed_coefficient",
             "sdk key for getcontrollerspeedcoefficient: gets physical controller speed value on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "yaw_controller_speed_coefficient",
             "sdk key for getcontrollerspeedcoefficient: gets physical controller speed value on an axis. speed setting controls the mapping between the movement of the controller and the gimbal speed. use `yaw_controller_speed_coefficient` and `pitch_controller_speed_coefficient` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "setcontrollersmoothingfactor",
             "sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param callback the completion block that receives the execution result.",
             "pitch_controller_smoothing_factor",
             "sdk key for setcontrollersmoothingfactor: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param callback the completion block that receives the execution result.",
             "yaw_controller_smoothing_factor",
             "sdk key for setcontrollersmoothingfactor: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param callback the completion block that receives the execution result.",
             "setcontrollersmoothingfactor",
             "sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param mode the mode that the setting will be applied to. @param callback the execution callback that receives the execution result.",
             "pitch_controller_smoothing_factor",
             "sdk key for setcontrollersmoothingfactor: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param mode the mode that the setting will be applied to. @param callback the execution callback that receives the execution result.",
             "yaw_controller_smoothing_factor",
             "sdk key for setcontrollersmoothingfactor: sets physical controller (e.g. the joystick on osmo or the remote controller of the aircraft) smoothing on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param smoothingfactor the smoothing value to be set. @param axis the axis that the setting will be applied to. @param mode the mode that the setting will be applied to. @param callback the execution callback that receives the execution result.",
             "getcontrollersmoothingfactor",
             "gets physical controller smoothing value on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "pitch_controller_smoothing_factor",
             "sdk key for getcontrollersmoothingfactor: gets physical controller smoothing value on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "yaw_controller_smoothing_factor",
             "sdk key for getcontrollersmoothingfactor: gets physical controller smoothing value on an axis. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion block that receives the execution result.",
             "getcontrollersmoothingfactor",
             "gets physical controller smoothing value with axis and mode. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param axis the axis to query. @param mode the mode to query. @param callback the execution callback that receives the execution result.",
             "pitch_controller_smoothing_factor",
             "sdk key for getcontrollersmoothingfactor: gets physical controller smoothing value with axis and mode. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param axis the axis to query. @param mode the mode to query. @param callback the execution callback that receives the execution result.",
             "yaw_controller_smoothing_factor",
             "sdk key for getcontrollersmoothingfactor: gets physical controller smoothing value with axis and mode. smoothing controls the deceleration of the gimbal. use `yaw_controller_smoothing_factor` and `pitch_controller_smoothing_factor` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param axis the axis to query. @param mode the mode to query. @param callback the execution callback that receives the execution result.",
             "setcontrollermaxspeed",
             "sets physical controller max speed value on an axis. it controls the mapping between the movement of the controller and the gimbal speed. use `pitch_controller_max_speed` and `yaw_controller_max_speed` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis that the setting will be applied to. @param maxspeed the maximum speed to set for one axis. @param callback the completion callback that receives the execution result.",
             "setcontrollermaxspeed",
             "sets physical controller max speed value on an axis. it controls the mapping between the movement of the controller and the gimbal speed. use `pitch_controller_max_speed` and `yaw_controller_max_speed` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param axis the axis that the setting will be applied to. @param mode the mode that the setting will be applied to. @param maxspeed the maximum speed to set for one axis. @param callback the completion callback that receives the execution result.",
             "getcontrollermaxspeed",
             "gets physical controller max speed value on an axis. it controls the mapping between the movement of the controller and the gimbal speed. use `pitch_controller_max_speed` and `yaw_controller_max_speed` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "getcontrollermaxspeed",
             "gets physical controller max speed value on an axis. it controls the mapping between the movement of the controller and the gimbal speed. use `pitch_controller_max_speed` and `yaw_controller_max_speed` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). only supported by mavic air 2, dji air 2s.  @param axis the axis to query. @param mode the mode to query. @param callback the completion callback that receives the execution result.",
             "setsmoothtrackenabled",
             "enables smoothtrack for the axis. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable smoothtrack on the axis. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "pitch_smooth_track_enabled",
             "sdk key for setsmoothtrackenabled: enables smoothtrack for the axis. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable smoothtrack on the axis. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "yaw_smooth_track_enabled",
             "sdk key for setsmoothtrackenabled: enables smoothtrack for the axis. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable smoothtrack on the axis. @param axis the axis that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "getsmoothtrackenabled",
             "gets whether an axis has smoothtrack enabled. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "pitch_smooth_track_enabled",
             "sdk key for getsmoothtrackenabled: gets whether an axis has smoothtrack enabled. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "yaw_smooth_track_enabled",
             "sdk key for getsmoothtrackenabled: gets whether an axis has smoothtrack enabled. only supported by osmo. ronin-mx supports smoothtrack but it is always enabled for both pitch axis and yaw axis. use `pitch_smooth_track_enabled` and `yaw_smooth_track_enabled` with `getcapabilities` to check if the gimbal supports this feature.  @param axis the axis to query. @param callback the completion callback that receives the execution result.",
             "setsmoothtrackspeed",
             "sets gimbal smoothtrack catch up speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param speed smoothtrack speed. @param callback the execution callback with the returned execution result.",
             "pitch_smooth_track_speed",
             "sdk key for setsmoothtrackspeed: sets gimbal smoothtrack catch up speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param speed smoothtrack speed. @param callback the execution callback with the returned execution result.",
             "yaw_smooth_track_speed",
             "sdk key for setsmoothtrackspeed: sets gimbal smoothtrack catch up speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param speed smoothtrack speed. @param callback the execution callback with the returned execution result.",
             "getsmoothtrackspeed",
             "gets gimbal smoothtrack speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned value(s).",
             "pitch_smooth_track_speed",
             "sdk key for getsmoothtrackspeed: gets gimbal smoothtrack speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned value(s).",
             "yaw_smooth_track_speed",
             "sdk key for getsmoothtrackspeed: gets gimbal smoothtrack speed on an axis. smoothtrack speed determines how fast the gimbal will catch up with a large, translated handle movement. use `pitch_smooth_track_speed` and `yaw_smooth_track_speed` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned value(s).",
             "setsmoothtrackdeadband",
             "sets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param deadband smoothtrack deadband [0,90]. @param callback the execution callback with the returned execution result.",
             "yaw_smooth_track_deadband",
             "sdk key for setsmoothtrackdeadband: sets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param deadband smoothtrack deadband [0,90]. @param callback the execution callback with the returned execution result.",
             "pitch_smooth_track_deadband",
             "sdk key for setsmoothtrackdeadband: sets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param deadband smoothtrack deadband [0,90]. @param callback the execution callback with the returned execution result.",
             "getsmoothtrackdeadband",
             "gets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "yaw_smooth_track_deadband",
             "sdk key for getsmoothtrackdeadband: gets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "pitch_smooth_track_deadband",
             "sdk key for getsmoothtrackdeadband: gets smoothtrack deadband on an axis. a larger deadband requires more handle movement to translate into gimbal motion. use `pitch_smooth_track_deadband` and `yaw_smooth_track_deadband` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "setsmoothtrackacceleration",
             "sets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param acceleration smoothtrack acceleration [0,30]. @param callback the execution callback with the returned execution result.",
             "yaw_smooth_track_acceleration",
             "sdk key for setsmoothtrackacceleration: sets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param acceleration smoothtrack acceleration [0,30]. @param callback the execution callback with the returned execution result.",
             "pitch_smooth_track_acceleration",
             "sdk key for setsmoothtrackacceleration: sets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param acceleration smoothtrack acceleration [0,30]. @param callback the execution callback with the returned execution result.",
             "getsmoothtrackacceleration",
             "gets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "yaw_smooth_track_acceleration",
             "sdk key for getsmoothtrackacceleration: gets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "pitch_smooth_track_acceleration",
             "sdk key for getsmoothtrackacceleration: gets smoothtrack acceleration on an axis. acceleration determines how closely the camera will follow the translated yaw handle movement. use `pitch_smooth_track_acceleration` and `yaw_smooth_track_acceleration` with `getcapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis gimbal axis. @param callback the execution callback with the returned execution result.",
             "setendpoint",
             "endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "pitch_up_endpoint",
             "sdk key for setendpoint: endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "yaw_right_endpoint",
             "sdk key for setendpoint: endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "yaw_right_endpoint",
             "sdk key for setendpoint: endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "yaw_left_endpoint",
             "sdk key for setendpoint: endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "pitch_down_endpoint",
             "sdk key for setendpoint: endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. only supported by ronin-mx. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` in `getcapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint the endpoint value to set. @param direction the direction that the setting will be applied to. @param callback the completion callback that receives the execution result.",
             "getendpoint",
             "gets the farthest points to which the gimbal will rotate during manual controller input. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` with `getcapabilities` to check if the gimbal supports this feature.  @param direction the endpoint direction. @param callback the completion callback that receives the execution result.",
             "pitch_up_endpoint",
             "sdk key for getendpoint: gets the farthest points to which the gimbal will rotate during manual controller input. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` with `getcapabilities` to check if the gimbal supports this feature.  @param direction the endpoint direction. @param callback the completion callback that receives the execution result.",
             "yaw_right_endpoint",
             "sdk key for getendpoint: gets the farthest points to which the gimbal will rotate during manual controller input. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` with `getcapabilities` to check if the gimbal supports this feature.  @param direction the endpoint direction. @param callback the completion callback that receives the execution result.",
             "yaw_right_endpoint",
             "sdk key for getendpoint: gets the farthest points to which the gimbal will rotate during manual controller input. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` with `getcapabilities` to check if the gimbal supports this feature.  @param direction the endpoint direction. @param callback the completion callback that receives the execution result.",
             "yaw_left_endpoint",
             "sdk key for getendpoint: gets the farthest points to which the gimbal will rotate during manual controller input. use `pitch_up_endpoint`, `pitch_down_endpoint`, `yaw_left_endpoint` and `yaw_right_endpoint` with `getcapabilities` to check if the gimbal supports this feature.  @param direction the endpoint direction. @param callback the completion callback that receives the execution result.",
             "setmotorenabled",
             "turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback the execution callback with the returned execution result.",
             "motor_enabled",
             "sdk key for setmotorenabled: turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback the execution callback with the returned execution result.",
             "getmotorenabled",
             "determines whether the gimbal motors are enabled to work or not.  @param callback the execution callback with the returned value(s).",
             "motor_enabled",
             "sdk key for getmotorenabled: determines whether the gimbal motors are enabled to work or not.  @param callback the execution callback with the returned value(s).",
             "toggleselfie",
             "resets gimbal position to selfie setup. if the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). if the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. it's only supported by dji osmo, osmo pro and osmo raw.  @param callback the execution callback with the returned execution result.",
             "toggle_selfie",
             "sdk key for toggleselfie: resets gimbal position to selfie setup. if the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). if the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. it's only supported by dji osmo, osmo pro and osmo raw.  @param callback the execution callback with the returned execution result.",
             "setcontrollermode",
             "sets the gimbal's controller mode. the control mode for the gimbal controller (joystick for osmo). the total controller deflection is a combination of horizontal and vertical deflection. this translates to gimbal movement around the yaw and pitch axes. the gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode see enum named `controllermode` in djigimbal to find details on different gimbal stick control modes. @param callback the execution callback with the returned execution result.",
             "controller_mode",
             "sdk key for setcontrollermode: sets the gimbal's controller mode. the control mode for the gimbal controller (joystick for osmo). the total controller deflection is a combination of horizontal and vertical deflection. this translates to gimbal movement around the yaw and pitch axes. the gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode see enum named `controllermode` in djigimbal to find details on different gimbal stick control modes. @param callback the execution callback with the returned execution result.",
             "getcontrollermode",
             "gets the gimbal's controller mode.  @param callback the execution callback with the returned value(s).",
             "controller_mode",
             "sdk key for getcontrollermode: gets the gimbal's controller mode.  @param callback the execution callback with the returned value(s).",
             "setinvertedcontrolenabled",
             "inverts the physical control for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis the axis that the setting will be applied to. @param callback the execution callback with the returned execution result.",
             "yaw_inverted_control_enabled",
             "sdk key for setinvertedcontrolenabled: inverts the physical control for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis the axis that the setting will be applied to. @param callback the execution callback with the returned execution result.",
             "pitch_inverted_control_enabled",
             "sdk key for setinvertedcontrolenabled: inverts the physical control for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis the axis that the setting will be applied to. @param callback the execution callback with the returned execution result.",
             "getinvertedcontrolenabled",
             "determines whether the physical control is inverted for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param axis the axis to query. @param callback the execution callback with the returned value(s).",
             "yaw_inverted_control_enabled",
             "sdk key for getinvertedcontrolenabled: determines whether the physical control is inverted for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param axis the axis to query. @param callback the execution callback with the returned value(s).",
             "pitch_inverted_control_enabled",
             "sdk key for getinvertedcontrolenabled: determines whether the physical control is inverted for gimbal movement on an axis. the setting can only be applied to the pitch or yaw axis.  @param axis the axis to query. @param callback the execution callback with the returned value(s).",
             "setattitudesynchronizationenabled",
             "synchronizes the attitude of port (left) gimbal and starboard (right) gimbal. it is only valid when both gimbals are connected. if only 1 gimbal is connected, this setting will be reset to `false`. enables this setting will reset `getcontrollinggimbalindex` to index 0. it is only supported by m210 and m210 rtk, not supported by dji x-port.  @param enabled `true` to enable the synchronization. @param callback the execution callback with the returned value(s).",
             "getattitudesynchronizationenabled",
             "determines whether both gimbals' attitudes are synchronized. if only 1 gimbal is connected, this setting will be reset to `false`. it is only supported by m210 and m210 rtk.  @param axis an enum value of `axis`. @param callback the execution callback with the returned value(s).",
             "startmultigimbalattitudesynchronization",
             "selects two to three gimbals to run with multi-gimbal connection, which can be controlled by a single user. please check if payloads have been connected with gimbal. the left gimbal, the right gimbal and the upper gimbal can be chosen. you should call `setcontrollinggimbalindex` to  set the control of the remote controller to the gimbal you want to synchronize. it is only supported by matrice 300 rtk.  @param gimbals array of gimbal indexes, in which 0 represents the left gimbal, 1 represents the right gimbal and 2 stands for the upper one. nil</code> if this function is disabled. @param callback the completion block that receives the execution result.",
             "stopmultigimbalattitudesynchronization",
             "stops the gimbals to run with multi-gimbal connection. please check if payloads have been connected with gimbal. it is only supported by matrice 300 rtk.  @param callback the callback that receives the execution result.",
             "getmultigimbalattitudesynchronizationstatus",
             "gets the working status of multi-gimbal connection. it is only supported by matrice 300 rtk.  @return multiple gimbal synchronization status.",
             "setyawsimultaneousfollowenabled",
             "enables this to make the gimbal respond to the controller command to rotate aircraft's heading. enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param isenabled `true` to enable yaw simultaneous follow. @param callback the execution callback with the returned value(s).",
             "getyawsimultaneousfollowenabled",
             "determines whether yaw simultaneous follow is enabled. enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param callback the execution callback with the returned value(s).",
             "startbalancedetection",
             "starts the balance detection.  note:  please do not turn on the motors. the tilt angle of the pitch and roll axis should be between -30 and -20 degrees. please fit the screw on the auxiliary arm after the balance detection. invoked before `startconcentricitydetection` and `startcontrolparametersautotuning`. or start balance detection with default control parameters.  this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "stopbalancedetection",
             "stops the balance detection. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "startconcentricitydetection",
             "starts the coaxiality detection.  note:  please do not turn on the motors. the tilt angle of the pitch and roll axis cannot be greater than 5 degrees. please start coaxiality detection after gimbal's balance detection and fitting the screw on the auxiliary arm. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "stopconcentricitydetection",
             "stops the coaxiality detection. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "startcontrolparametersautotuning",
             "starts the control parameters auto tuning.  note:  please do not turn on the motors. the tilt angle of the pitch and roll axis cannot be greater than 5 degrees. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "stopcontrolparametersautotuning",
             "stops the control parameters auto tuning. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "resetcontrolparameters",
             "restores gimbal's control parameters coefficient.  note:  please do not turn on the motors. this can only be invoked during `development` phase.  @param callback the callback that receives the execution result.",
             "gimbalstate",
             "this class provides the current state of the gimbal.",
             "getattitudeindegrees",
             "the current gimbal attitude in degrees. roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of north pole.  @return an `attitude` instance.",
             "attitude_in_degrees",
             "sdk key for getattitudeindegrees: the current gimbal attitude in degrees. roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of north pole.  @return an `attitude` instance.",
             "getrollfinetuneindegrees",
             "returns the gimbal's roll fine-tuned value. the range for the fine-tuned value is [-10, 10] degrees. if the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return a float value.",
             "roll_fine_tune_in_degrees",
             "sdk key for getrollfinetuneindegrees: returns the gimbal's roll fine-tuned value. the range for the fine-tuned value is [-10, 10] degrees. if the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return a float value.",
             "getpitchfinetuneindegrees",
             "returns the gimbal's pitch fine-tuned value. the range for the fine-tuned value is [-10, 10] degrees. if the fine-tune value is negative, the gimbal will be fine-tuned to the specified number of degrees in the downward direction. it is only supported by spark.  @return a float value.",
             "getyawfinetuneindegrees",
             "returns the gimbal's yaw fine-tuned value. the range for the fine-tuned value is [-10, 10] degrees. if the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the port (left) direction. only supported by dji mavic air.  @return a float value.",
             "getmode",
             "returns the gimbal's current work mode.  @return a `gimbalmode` enum value.",
             "gimbalkey.mode",
             "sdk key for getmode: returns the gimbal's current work mode.  @return a `gimbalmode` enum value.",
             "ismobiledevicemounted",
             "`true` if the mobile device is mounted on the gimbal.  @return a boolean value.",
             "is_mobile_device_mounted",
             "sdk key for ismobiledevicemounted: `true` if the mobile device is mounted on the gimbal.  @return a boolean value.",
             "ismotoroverloaded",
             "`true` if one of the gimbal motors is overloaded.  @return a boolean value.",
             "is_motor_over_loaded",
             "sdk key for ismotoroverloaded: `true` if one of the gimbal motors is overloaded.  @return a boolean value.",
             "iscalibrationsuccessful",
             "`true` if the gimbal calibration succeeded.  @return a boolean value.",
             "is_calibration_successful",
             "sdk key for iscalibrationsuccessful: `true` if the gimbal calibration succeeded.  @return a boolean value.",
             "iscalibrating",
             "`true` if the gimbal is calibrating.  @return a boolean value.",
             "is_calibrating",
             "sdk key for iscalibrating: `true` if the gimbal is calibrating.  @return a boolean value.",
             "getcalibrationprogress",
             "current progress (percentage) for calibration.  @return an int value.",
             "calibration_progress",
             "sdk key for getcalibrationprogress: current progress (percentage) for calibration.  @return an int value.",
             "ispitchatstop",
             "`true` if the gimbal's pitch value is at its limit.  @return a boolean value.",
             "is_pitch_at_stop",
             "sdk key for ispitchatstop: `true` if the gimbal's pitch value is at its limit.  @return a boolean value.",
             "isrollatstop",
             "`true` if the gimbal's roll value is at its limit.  @return a boolean value.",
             "is_roll_at_stop",
             "sdk key for isrollatstop: `true` if the gimbal's roll value is at its limit.  @return a boolean value.",
             "isyawatstop",
             "`true` if the gimbal's yaw value is at its limit.  @return a boolean value.",
             "is_yaw_at_stop",
             "sdk key for isyawatstop: `true` if the gimbal's yaw value is at its limit.  @return a boolean value.",
             "isbalancetesting",
             "`true` if the gimbal is currently testing payload balance.  @return a boolean value.",
             "is_testing_balance",
             "sdk key for isbalancetesting: `true` if the gimbal is currently testing payload balance.  @return a boolean value.",
             "getpitchbalancetestresult",
             "returns the pitch axis balance test result.  @return a `balancetestresult` enum value.",
             "pitch_test_result",
             "sdk key for getpitchbalancetestresult: returns the pitch axis balance test result.  @return a `balancetestresult` enum value.",
             "getrollbalancetestresult",
             "returns the roll axis balance test result.  @return a `balancetestresult` enum value.",
             "roll_test_result",
             "sdk key for getrollbalancetestresult: returns the roll axis balance test result.  @return a `balancetestresult` enum value.",
             "getbalancestate",
             "returns the balance status of the gimbal.  @return a `balancestate` enum value.",
             "balance_state",
             "sdk key for getbalancestate: returns the balance status of the gimbal.  @return a `balancestate` enum value.",
             "ismountedupwards",
             "`true` if the gimbal is mounted upwards on the aircraft. it is only supported by m210 and m210 rtk.  @return a boolean value.",
             "movementsettings",
             "the current movement settings of the gimbal. these include settings for smoothtrack and the controller.",
             "getprofile",
             "advanced settings profile.  @return a `movementsettingsprofile` enum value.",
             "movement_settings_profile",
             "sdk key for getprofile: advanced settings profile.  @return a `movementsettingsprofile` enum value.",
             "isyawsmoothtrackenabled",
             "`true` if gimbal smoothtrack is enabled for the yaw axis.  @return a boolean value.",
             "yaw_smooth_track_enabled",
             "sdk key for isyawsmoothtrackenabled: `true` if gimbal smoothtrack is enabled for the yaw axis.  @return a boolean value.",
             "ispitchsmoothtrackenabled",
             "`true` if gimbal smoothtrack is enabled for the pitch axis.  @return a boolean value.",
             "pitch_smooth_track_enabled",
             "sdk key for ispitchsmoothtrackenabled: `true` if gimbal smoothtrack is enabled for the pitch axis.  @return a boolean value.",
             "getyawsmoothtrackspeed",
             "smoothtrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. range is [0,100].  @return an int value.",
             "yaw_smooth_track_speed",
             "sdk key for getyawsmoothtrackspeed: smoothtrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. range is [0,100].  @return an int value.",
             "getpitchsmoothtrackspeed",
             "smoothtrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. range is [0,100].  @return an int value.",
             "pitch_smooth_track_speed",
             "sdk key for getpitchsmoothtrackspeed: smoothtrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. range is [0,100].  @return an int value.",
             "getyawsmoothtrackdeadband",
             "a larger smoothtrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. range is [0,90] degrees.  @return an int value.",
             "yaw_smooth_track_deadband",
             "sdk key for getyawsmoothtrackdeadband: a larger smoothtrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. range is [0,90] degrees.  @return an int value.",
             "getpitchsmoothtrackdeadband",
             "a larger smoothtrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. range is [0,90] degrees.  @return an int value.",
             "pitch_smooth_track_deadband",
             "sdk key for getpitchsmoothtrackdeadband: a larger smoothtrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. range is [0,90] degrees.  @return an int value.",
             "getyawsmoothtrackacceleration",
             "smoothtrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. range is [0,30].  @return an int value.",
             "yaw_smooth_track_acceleration",
             "sdk key for getyawsmoothtrackacceleration: smoothtrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. range is [0,30].  @return an int value.",
             "getpitchsmoothtrackacceleration",
             "smoothtrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. range is [0,30].  @return an int value.",
             "pitch_smooth_track_acceleration",
             "sdk key for getpitchsmoothtrackacceleration: smoothtrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. range is [0,30].  @return an int value.",
             "getyawcontrollersmoothingfactor",
             "controller yaw axis smoothing controls the deceleration of the gimbal. a small value will cause the gimbal to stop abruptly. range is [0,30].  @return an int value.",
             "yaw_controller_smoothing_factor",
             "sdk key for getyawcontrollersmoothingfactor: controller yaw axis smoothing controls the deceleration of the gimbal. a small value will cause the gimbal to stop abruptly. range is [0,30].  @return an int value.",
             "getpitchcontrollersmoothingfactor",
             "controller pitch axis smoothing controls the deceleration of the gimbal. a small value will cause the gimbal to stop abruptly. range is [0,30].  @return an int value.",
             "pitch_controller_smoothing_factor",
             "sdk key for getpitchcontrollersmoothingfactor: controller pitch axis smoothing controls the deceleration of the gimbal. a small value will cause the gimbal to stop abruptly. range is [0,30].  @return an int value.",
             "getyawcontrollerspeedcoefficient",
             "controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. range is [0,100].  @return an int value.",
             "yaw_controller_speed_coefficient",
             "sdk key for getyawcontrollerspeedcoefficient: controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. range is [0,100].  @return an int value.",
             "getpitchcontrollerspeedcoefficient",
             "controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. range is [0,100].  @return an int value.",
             "pitch_controller_speed_coefficient",
             "sdk key for getpitchcontrollerspeedcoefficient: controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. range is [0,100].  @return an int value.",
             "attitude",
             "the gimbal's attitude in degrees relative to the aircraft. if you don't want a specific axis to get rotated, invoke the `gimbalattitudeaction` method and set the value of the axis to `no_rotation` in the `attitude` object. by default, the values of pitch, roll, and yaw in the `attitude` are set to `no_rotation`.",
             "attitude_in_degrees",
             "sdk key for attitude: the gimbal's attitude in degrees relative to the aircraft. if you don't want a specific axis to get rotated, invoke the `gimbalattitudeaction` method and set the value of the axis to `no_rotation` in the `attitude` object. by default, the values of pitch, roll, and yaw in the `attitude` are set to `no_rotation`.",
             "getpitch",
             "pitch value in degrees.  @return a float value.",
             "getroll",
             "roll value in degrees.  @return <<android:a float value.>",
             "getyaw",
             "yaw value in degrees.  @return <<android:a float value.>",
             "axis",
             "gimbal axis.",
             "yaw",
             "gimbal's yaw axis.",
             "pitch",
             "gimbal's pitch axis.",
             "roll",
             "gimbal's roll axis. not available in djigimbal_resetwithaxisandresetdirection</code>.",
             "yaw_and_pitch",
             "gimbal's yaw and pitch axis.",
             "gimbalmode",
             "gimbal work modes.",
             "gimbalkey.mode",
             "sdk key for gimbalmode: gimbal work modes.",
             "free",
             "the gimbal can move independently of the aircraft's yaw. in this mode, even if the aircraft yaw changes, the camera will continue pointing in the same world direction. this mode is only available for the ronin-mx when the m600 or m600 pro landing gear is retracted.",
             "fpv",
             "the gimbal's work mode is fpv mode. in this mode, the gimbal yaw will follow the aircraft's heading, and the gimbal roll will follow the rc's roll channel value. the pitch will be available to move. this mode is only available for the ronin- mx when the m600 landing gear is retracted.",
             "yaw_follow",
             "the gimbal's work mode is such that it will follow the yaw. in this mode, the gimbal yaw will be fixed, while pitch and roll will be available to move.",
             "unknown",
             "the gimbal's work mode is unknown.",
             "balancetestresult",
             "for gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
             "pitch_test_result",
             "sdk key for balancetestresult: for gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
             "roll_test_result",
             "sdk key for balancetestresult: for gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
             "pass",
             "the balance test result is great.",
             "marginal",
             "the balance test result is good. when this result is returned, it is possible there was some noise in the balance measurement. for best results, it is recommended to run the balance test again and adjust the payload position until the result becomes great.",
             "fail",
             "the balance test result is bad. the payload should be adjusted when this result is returned.",
             "unknown",
             "the balance test result is unknown.",
             "movementsettingsprofile",
             "the movement settings profile contains presets for smoothtrack and the physical controller sensitivity. smoothtrack and controller settings can only be manually changed if custom1 or custom2 profiles are selected.",
             "movement_settings_profile",
             "sdk key for movementsettingsprofile: the movement settings profile contains presets for smoothtrack and the physical controller sensitivity. smoothtrack and controller settings can only be manually changed if custom1 or custom2 profiles are selected.",
             "fast",
             "the gimbal's smoothtrack and controller sensitivity is high. when the gimbal is using this profile, user cannot change the movement settings manually.",
             "medium",
             "the gimbal's smoothtrack and controller sensitivity is medium. when the gimbal is using this profile, user cannot change the movement settings manually.",
             "slow",
             "the gimbal's smoothtrack and controller sensitivity is slow. when the gimbal is using this profile, user cannot change the movement settings manually.",
             "custom_1",
             "the gimbal uses a custom configuration in memory slot 1 where the yaw and pitch speed, deadband, and acceleration can be defined.",
             "custom_2",
             "the gimbal uses a custom configuration in memory slot 2 where the yaw and pitch speed, deadband, and acceleration can be defined.",
             "unknown",
             "the gimbal's user config type is unknown.",
             "motorcontrolpreset",
             "different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
             "apply_motor_control_preset",
             "sdk key for motorcontrolpreset: different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
             "red",
             "the gimbal's motor control configuration is optimized for red cameras.",
             "dslr",
             "the gimbal's motor control configuration is optimized for most dslr cameras.",
             "mirrorless",
             "the gimbal's motor control configuration is optimized for most mirrorless cameras.",
             "endpointdirection",
             "gimbal endpoint setting.",
             "pitch_up",
             "pitch (also called tilt) endpoint setting in the upwards direction.",
             "pitch_down",
             "pitch (also called tilt) endpoint setting in the downwards direction.",
             "yaw_left",
             "yaw (also called pan) endpoint setting in the left direction.",
             "yaw_right",
             "yaw (also called pan) endpoint setting in the right direction.",
             "balancestate",
             "the loading balance status of the gimbal. the gimbal loading is changeable for osmo mobile. when the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
             "balance_state",
             "sdk key for balancestate: the loading balance status of the gimbal. the gimbal loading is changeable for osmo mobile. when the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
             "balanced",
             "the gimbal is balanced.",
             "tilting_left",
             "the gimbal is tilting left. adjust the photo to the right hand side to balance the gimbal.",
             "tilting_right",
             "the gimbal is tilting right. adjust the photo to the left hand side to balance the gimbal.",
             "unknown",
             "the balance status is unknown.",
             "detectionresultonaxis",
             "gimbal's balance or coaxiality detection result on axis.",
             "great",
             "balance or coaxiality detection result is great.",
             "good",
             "balance or coaxiality detection result is good.",
             "bad",
             "balance or coaxiality detection result is bad. please adjust gimbal's balance or coaxiality according to corresponding result.",
             "unknown",
             "the gimbal detection result is unknown.",
             "balancedetectionprogressstatus",
             "current balance detection progress status of balance detection.",
             "in_process",
             "gimbal's balance detection is in process.",
             "finished",
             "gimbal's balance detection has finished.",
             "error",
             "gimbal's balance balance detection has stopped with error.",
             "unknown",
             "gimbal's balance detection status is unknown.",
             "coaxialitydetectionprogressstatus",
             "current coaxiality detection progress status of balance detection.",
             "in_process",
             "gimbal's coaxiality detection is in process.",
             "finished",
             "gimbal's coaxiality detection has finished.",
             "error",
             "gimbal's coaxiality detection has stopped with error.",
             "unknown",
             "gimbal's coaxiality detection status is unknown.",
             "directionadjustmentresult",
             "gimbal's direction adjustment result.",
             "good",
             "the direction check result is good.",
             "bad",
             "gimbal's direction adjustment result is bad.",
             "unknown",
             "gimbal's direction adjustment result is unknown.",
             "suggesteddirectionadjustment",
             "the suggested direction adjustment of gimbal.",
             "none",
             "no need to adjust.",
             "left",
             "manually adjust the camera to the corresponding direction on axis.",
             "right",
             "manually adjust the camera to the corresponding direction on axis.",
             "upwards",
             "manually adjust the camera to the corresponding direction on axis.",
             "downwards",
             "manually adjust the camera to the corresponding direction on axis.",
             "forwards",
             "manually adjust the camera to the corresponding direction on axis.",
             "backwards",
             "manually adjust the camera to the corresponding direction on axis.",
             "controlparametersautotuningstatus",
             "the control parameters auto tuning status of the gimbal.",
             "in_process",
             "control parameters auto-tuning is in progress.",
             "finished",
             "control parameters auto-tuning is finished.",
             "error",
             "the control parameters auto tuning occurs error.",
             "unknown",
             "unknown control parameters auto-tuning state.",
             "rotationalinertiastate",
             "gimbal's rotational inertia state.",
             "normal",
             "the rotational inertia of axis is normal.",
             "smaller",
             "the rotational inertia is too small. payload need to be added.",
             "too_larger",
             "the rotational inertia is too large. payload need to be reduced.",
             "unknown",
             "unknown.",
             "axialstiffnessstate",
             "gimbal's stiffness on axis.",
             "normal",
             "normal stiffness on axis.",
             "low",
             "low stiffness on axis.",
             "unknown",
             "the stiffness on axis is unknown.",
             "resetdirection",
             "gimbal reset direction.",
             "up_or_down",
             "the standard position for the upper gimbal is pointing up vertically to the sky. the standard position for the downward gimbal is pointing down vertically to the earth.",
             "center",
             "applies only to the yaw. the standard position is pointing to the center.",
             "callback",
             "callback for updating the gimbal's current state.",
             "callback",
             "this interface provides the method to receive the updated state and user configuration.",
             "batterychargeremainingcallback",
             "gimbal energy remaining of ronin mx in percent.",
             "capabilitykey",
             "these enums are keys for gimbal capability map.",
             "adjust_pitch",
             "key enum in the `getcapabilities` dictionary that holds the complete capability of the gimbal. the value is capability range of the gimbal is placed downwards, a negative value in the valid range represents counter-clockwise rotation. a positive value in the valid range represents clockwise rotation.",
             "adjust_pitch_upwards",
             "key enum in the `getcapabilities` dictionary that holds the complete capability of the gimbal. the value is capability range of the gimbal is placed upwards, a negative value in the valid range represents counter-clockwise rotation. a positive value in the valid range represents clockwise rotation.",
             "adjust_yaw",
             "key enum in `getcapabilities` associated with whether the gimbal supports yaw axis adjustment. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range in degrees is returned. a negative value in the valid range represents counter-clockwise rotation. a positive value in the valid range represents clockwise rotation. for gimbal's that allow a pitch range extension (see `pitch_range_extension`, the range will be representative of the extended range whether it is enabled or not.",
             "adjust_roll",
             "key enum in `getcapabilities` associated with whether the gimbal supports roll axis adjustment. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range in degrees is returned. a negative value in the valid range represents counter-clockwise rotation. a positive value in the valid range represents clockwise rotation.",
             "movement_settings",
             "key enum in `getcapabilities` associated with whether the gimbal supports advanced settings profiles. the corresponding value in `getcapabilities` is an instance of `djiparamcapability`.",
             "pitch_range_extension",
             "key enum in `getcapabilities` associated with whether the gimbal supports a range extension in pitch. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range in degrees is returned.",
             "pitch_controller_speed_coefficient",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis response speed to manual control can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_controller_speed_coefficient",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis response speed to manual control can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_controller_smoothing_factor",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis smoothing can be adjusted when using manual control. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_controller_smoothing_factor",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis smoothing can be adjusted when using manual control. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_controller_deadband",
             "key enum in `getcapabilities` associated with whether the gimbal's manual control pitch axis deadband can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_controller_deadband",
             "key enum in `getcapabilities` associated with whether the gimbal's manual control yaw axis deadband can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_controller_max_speed",
             "key  in `getcapabilities` associated with whether the gimbal's manual control pitch axis max speed can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_controller_max_speed",
             "key  in `getcapabilities` associated with whether the gimbal's manual control yaw axis max speed can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_smooth_track_enabled",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis smoothtrack can be toggled. the corresponding value in `getcapabilities` is an instance of `djiparamcapability`. ronin-mx cannot toggle the smoothtrack functionality and it is always enabled.",
             "yaw_smooth_track_enabled",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis smoothtrack can be toggled. the corresponding value in `getcapabilities` is an instance of `djiparamcapability`. ronin-mx cannot toggle the smoothtrack functionality and it is always enabled.",
             "pitch_smooth_track_acceleration",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis smoothtrack acceleration can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_smooth_track_acceleration",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis smoothtrack acceleration can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_smooth_track_speed",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis smoothtrack speed can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_smooth_track_speed",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis smoothtrack speed can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_smooth_track_deadband",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis smoothtrack deadband can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_smooth_track_deadband",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis smoothtrack deadband can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_up_endpoint",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch up endpoint can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_down_endpoint",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch down endpoint can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_left_endpoint",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw left endpoint can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_right_endpoint",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw right endpoint can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_motor_control_stiffness",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis motor control stiffness can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_motor_control_stiffness",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis motor control stiffness can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "roll_motor_control_stiffness",
             "key enum in `getcapabilities` associated with whether the gimbal's roll axis motor control stiffness can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_motor_control_strength",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis motor control strength can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_motor_control_strength",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis motor control strength can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "roll_motor_control_strength",
             "key enum in `getcapabilities` associated with whether the gimbal's roll axis motor control strength can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_motor_control_gyro_filtering_factor",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis motor control gyro filtering can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_motor_control_gyro_filtering_factor",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis motor control gyro filtering can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "roll_motor_control_gyro_filtering_factor",
             "key enum in `getcapabilities` associated with whether the gimbal's roll axis motor control gyro filtering can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "pitch_motor_control_pre_control",
             "key enum in `getcapabilities` associated with whether the gimbal's pitch axis motor control precontrol can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "yaw_motor_control_pre_control",
             "key enum in `getcapabilities` associated with whether the gimbal's yaw axis motor control precontrol can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "roll_motor_control_pre_control",
             "key enum in `getcapabilities` associated with whether the gimbal's roll axis motor control precontrol can be adjusted. the corresponding value in `getcapabilities` is an instance of `djiparamminmaxcapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
             "rotation",
             "represents a gimbal speed or angular rotation operation. if you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `no_rotation` in the `rotation` object. by default, the values of pitch, roll, and yaw in the `rotation` are set to `no_rotation`.",
             "rotate",
             "sdk key for rotation: represents a gimbal speed or angular rotation operation. if you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `no_rotation` in the `rotation` object. by default, the values of pitch, roll, and yaw in the `rotation` are set to `no_rotation`.",
             "getmode",
             "type of gimbal rotation operation mode.  @return a `rotationmode` enum value.",
             "getpitch",
             "the pitch property of a gimbal rotation operation, how much the gimbal rotates on the pitch axis. when it is `null`, no operation will be applied to the pitch axis.  @return a float value.",
             "getroll",
             "the roll property of a gimbal rotation operation, how much the gimbal rotates on the roll axis. when it is `null`, no operation will be applied to the roll axis.  @return a float value.",
             "getyaw",
             "the yaw property of a gimbal rotation operation, how much the gimbal rotates on the yaw axis. when the rotation mode is `absolute_angle`, the yaw value is relative to the aircraft's heading. when it is `null`, no operation will be applied to the yaw axis.  @return a float value.",
             "gettime",
             "the time of the gimbal speed rotation operation(unit: second). does not take effect in waypoint mission.  @return a double value. should set a value greater than 0.",
             "getignore",
             "sets true to ignore remote controller gimbal stick control.  @return a boolean value.",
             "builder",
             "object builder.",
             "builder",
             "default rotation constructor method.",
             "builder",
             "constructor method that clones a rotation object.  @param rotation an instance of `rotation`.",
             "mode",
             "constructor method.  @param mode an enum value of `rotationmode`.  @return builder object for mode",
             "pitch",
             "constructor method.  @param pitch a float value of pitch.  @return builder object for pitch",
             "roll",
             "constructor method.  @param roll a float value of roll.  @return builder object for roll",
             "yaw",
             "constructor method.  @param yaw a float value of yaw.  @return builder object for yaw",
             "time",
             "sets the completion time in seconds to complete an action to control the gimbal. if the the rotation mode is `absolute_angle` then the time determines the duration of time the gimbal should rotate to its new position. for example, if a value of 2.0 is used, then the gimbal will rotate to its target position in 2.0 seconds. range is [0.1,25.5] seconds. does not take effect in waypoint mission.  @param time a double value of time.  @return builder object for time",
             "ignore",
             "set whether the app can control the gimbal.  @param ignore `true` if the app can control the gimbal.  @return builder object.",
             "build",
             "build the object.  @return instance of `rotation`.",
             "rotationmode",
             "the mode of the gimbal rotation operation.",
             "relative_angle",
             "the angle value, when the gimbal is rotating, relative to the current angle.",
             "absolute_angle",
             "the angle value, when the gimbal is rotating, relative to 0 degrees (aircraft heading). for inspire 1, using x3, x3 zoom and z3 cameras will be relative to true north. using x5, xt and x5r will be relative to the aircraft heading.  for inspire 2, using x4s and x5s cameras will be relative to true north. using x7 and z30 will be relative to the aircraft heading.  for matrice 300 rtk with h20 series and zenmuse p1 camera, the angle rotation is relative to the aircraft heading if you rotate the gimbal directly. the angle rotation is relative to true north if you use it in `waypointv2missionaction`.",
             "speed",
             "rotate the gimbal's pitch, roll, and yaw in speed mode. the direction can either be set to clockwise or counter-clockwise.  for phantom 3 professional, phantom 3 advanced and phantom 3 standard, roll and yaw rotations are not available.  for inspire 1, inspire pro and m100, pitch, roll and yaw rotations are available.  for osmo, roll rotation is not available. the yaw anglevelocity of djigimbalspeedrotation range is (-120, 120).",
             "multigimbalconnectionworkingstatus",
             "this class describes which gimbal is running with multi-gimbal connection.",
             "ismultigimbalconnectionworking",
             "`true` if multi-gimbal connection is currently enabled.  @return a boolean value to check multi-gimbal connection.",
             "isleftgimbalrunningwithmultigimbalconnection",
             "`true` if the left gimbal is currently running with multi-gimbal connection.  @return a boolean value to check left gimbal running with multi-gimbal connection.",
             "isrightgimbalrunningwithmultigimbalconnection",
             "`true` if the right gimbal is currently running with multi-gimbal connection.  @return a boolean value to check right gimbal running with multi-gimbal connection.",
             "isuppergimbalrunningwithmultigimbalconnection",
             "`true` if the upper gimbal is currently running with multi-gimbal connection.  @return a boolean value to check upper gimbal running with multi-gimbal connection.",
             "gimbalbalancedetectionstate",
             "this class provides current balance detection information of the gimbal.",
             "getstatus",
             "the balance detection status.  @return an enum value of `balancedetectionprogressstatus`.",
             "getresultonpitch",
             "gimbal balance detection result on pitch.  @return an enum value of `detectionresultonaxis`.",
             "getresultonroll",
             "gimbal balance detection result on roll.  @return an enum value of `detectionresultonaxis`.",
             "getresultonyaw",
             "gimbal balance detection result on yaw.  @return an enum value of `detectionresultonaxis`.",
             "getdirectionadjustmentstateonpitch",
             "direction adjustment state on pitch.  @return return an object of `directionstate`.",
             "getdirectionadjustmentstateonroll",
             "direction adjustment state on roll.  @return return an object of `directionstate`.",
             "getdirectionadjustmentstateonyaw",
             "direction adjustment state on yaw.  @return return an object of `directionstate`.",
             "getprocess",
             "gimbal's balance detection progress percentage.  @return an int value of detection progress.",
             "isaircraftstabilitysatisfied",
             "`false` if aircraft stability does not meet requirements.  @return a boolean value to check the aircraft's stability.",
             "isaircraftmotoron",
             "turn off aircraft motor and run balance detection again if this is `true`.  @return a boolean value to check the aircraft's motor on.",
             "isgimbalmotoroverloaded",
             "`true` if the gimbal motor is overloaded. unable to test normally.  @return a boolean value to check if the gimbal motor is overloaed.",
             "callback",
             "callback for updating the gimbal's balance detection state.",
             "onupdate",
             "update the gimbal's balance detection state.  @param state the gimbal balance detection state.",
             "directionstate",
             "this class provides gimbal direction adjustment result and adjustment suggestion on axis.",
             "getadjustmentresultlr",
             "gimbal direction adjustment result for direction left and right.  @return an enum value of `directionadjustmentresult`.",
             "getadjustmentsuggestionlr",
             "suggestion for adjusting the gimbal to the left or to the right.  @return an enum value of `suggesteddirectionadjustment`.",
             "getadjustmentresultud",
             "gimbal direction adjustment result for direction upwards or downwards.  @return an enum value of `directionadjustmentresult`.",
             "getadjustmentsuggestionud",
             "suggestion for adjusting the gimbal upwards or downwards.  @return get the enum value of `suggesteddirectionadjustment`.",
             "getadjustmentresultfb",
             "gimbal direction adjustment result for direction forwards or backwards.  @return get the enum value of `directionadjustmentresult`.",
             "getadjustmentsuggestionfb",
             "suggestion for adjusting the camera forwards or backwards.  @return get the enum value of `suggesteddirectionadjustment`.",
             "gimbalcontrolparametersautotuningstate",
             "this class provides gimbal's control parameters auto-tuning state.",
             "getstatus",
             "the control parameters auto tuning status.  @return return an enum value of `controlparametersautotuningstatus`.",
             "getprocess",
             "gimbal's control parameters auto-tuning progress in percentage.  @return an int value the auto-tuning progress.",
             "isloadinstalled",
             "checks if the load has been installed.  @return a boolean value to check if the load has been installed.",
             "isbaseattitudenormal",
             "checks if the attitude of gimbal base is normal. returns `false` if the base is not placed horizontally.  @return a boolean value to check if the attitude of gimbal base is normal.",
             "isgyrodriftnormal",
             "checks if gyro drift is normal. returns `false` if the gyro drift is too large.  @return a boolean value to check if the gyro drift is too large.",
             "isjointangledeviationnormal",
             "checks if joint angle deviation is normal. returns `false` if the joint angle deviation is high.  @return a boolean value to check if joint angle deviation is normal.",
             "getrotationalinertiaonroll",
             "rotational inertia on roll axis.  @return return an enum value of `rotationalinertiastate`.",
             "getrotationalinertiaonpitch",
             "rotational inertia on pitch axis.  @return return an enum value of `rotationalinertiastate`.",
             "getrotationalinertiaonyaw",
             "rotational inertia on yaw axis.  @return return an enum value of `rotationalinertiastate`.",
             "getstiffnessonroll",
             "stiffness on roll axis.  @return return an enum value of `axialstiffnessstate`.",
             "getstiffnessonpitch",
             "stiffness on pitch axis.  @return return an enum value of `axialstiffnessstate`.",
             "getstiffnessonyaw",
             "stiffness on yaw axis.  @return return an enum value of `axialstiffnessstate`.",
             "isrolllocked",
             "`true` if gimbal's roll axis is locked.  @return a boolean value to check roll locked.",
             "ispitchlocked",
             "`true` if gimbal's pitch axis is locked.  @return a boolean value to check pitch locked.",
             "isyawlocked",
             "`true` if gimbal's yaw axis is locked.  @return a boolean value to check yaw locked.",
             "isprotectinggimbalmotorlockedrotor",
             "`true` if gimbal motor is locked-rotor and is being protected.  @return a boolean value to check gimbal motor status.",
             "isaircraftmotoron",
             "`true` if the aircraft's motor is on.  @return a boolean value to check if aircraft motor is on.",
             "callback",
             "callback for updating the gimbal's control parameters auto tuning state.",
             "onupdate",
             "update the gimbal's control parameters auto tuning state.  @param state the gimbal control parameters auto tuning state.",
             "gimbalcoaxialitydetectionstate",
             "this class provides current coaxiality detection information of the gimbal.",
             "getstatus",
             "get the coaxiality detection status.  @return an enum value of `coaxialitydetectionprogressstatus`.",
             "getresultonpitch",
             "get the gimbal coaxiality detection result on pitch.  @return an enum value of `detectionresultonaxis`.",
             "getprocess",
             "get the gimbal's coaxiality detection progress percentage.  @return an int value of the process..",
             "isaircraftstabilitysatisfied",
             "`false` if aircraft stability does not meet requirements.  @return a boolean value to check aircraft's stability.",
             "isaircraftmotoron",
             "turn off aircraft motor and run coaxiality detection again if this is `true`.  @return a boolean value to check aircraft motor on status.",
             "isgimbalmotoroverloaded",
             "`true` if the gimbal motor is overloaded. unable to test normally.  @return a boolean value to check gimbal motor overloaded.",
             "callback",
             "callback for updating the gimbal's coaxiality detection state.",
             "onupdate",
             "updates the gimbal's coaxiality detection state.  @param state the gimbal coaxiality detection state.",
             "getaircraftupgradecomponent",
             "the upgrade component is aircraft. upgrade this component when gimbal, battery, flight  controller and other internal modules' firmware versions are inconsistent. it is only  supported by mavic air, mavic 2 series.  @return an object of `upgradecomponent`.",
             "getremotecontrollerupgradecomponent",
             "the upgrade component is remote controller. upgrade this component when its internal  modules' firmware versions are inconsistent. it is only supported by mavic 2 series.  @return an object of `upgradecomponent`.",
             "upgradecomponent",
             "this class is used to control components' upgrade. it also provides methods to receive  firmware consistency upgrade state and the latest firmware version information. it is  only supported by mavic air, mavic 2 series, matrice 300 rtk.",
             "getcomponenttype",
             "component to upgrade.  @return an enum value of `upgradecomponenttype`.",
             "getindex",
             "returns the upgrade component index. index is zero based.  please refer to `getindex` to get the component index. for instance, if matrice 300 rtk can have three gimbal mounted cameras, the three camera components are with indices 0, 1 and 4.  @return an int value of index.",
             "getupgradestate",
             "current firmware upgrade state.  @return an enum value of `upgradefirmwarestate`.",
             "getlatestfirmwareinformation",
             "the latest firmware information.  @return an enum value of `firmwareinformation`.",
             "addupgradefirmwarelistener",
             "adds a listener to receive the `upgradefirmwarelistener`..  @param listener listener to receive the `upgradefirmwarelistener`..  it is used to distinguish different listener and the listener will be retained.",
             "removeupgradefirmwarelistener",
             "removes a listener that is added by passing to `addupgradefirmwarelistener`.  @param listener the listener to remove.",
             "removeallupgradefirmwarelistener",
             "remove all the listeners are added by passing to `addupgradefirmwarelistener`.",
             "cancancelconsistencyupgrade",
             "check if the consistency upgrade can be canceled. if false, please check the consistency of the firmware to ensure flight safety.  it is only supported by mavic air, mavic 2 series.  @return a boolean value.",
             "startfirmwareconsistencyupgrade",
             "starts firmware consistency upgrade. if the firmware version of some modules in the device is not compatible with the firmware version of other modules,  the firmware will send a request for consistent upgrade. after you start firmware consistency upgrade, you should invoke `onfirmwareupgradeprogressupdated` to receive upgrade progress  information. before invoking this method, please make sure that the motors are turned off and `getwifilink` is not using. it  is only supported by mavic air, mavic 2 series.  @param callback the execution callback with the returned execution result.",
             "stopfirmwareconsistencyupgrade",
             "cancels firmware consistency upgrade. `onconsistencyupgraderequestreceived` will stop to notify. before  invoking this method, please make sure that the motors are turned off and `getwifilink` is not using. it is only supported  by mavic air, mavic 2 series.  @param callback the execution callback with the returned execution result.",
             "upgradefirmwarelistener",
             "this listener provides methods to receive the upgrade information, the upgrade firmware state and the upgrade progress.",
             "onupgradefirmwarestateupdated",
             "called when the upgrade firmware state has been changed.  @param component the component of which the upgrade firmware state has been changed. @param state the upgrade firmware state.",
             "onfirmwareupgradeprogressupdated",
             "called when the upgrade is in progress.  @param component the component of which the upgrade progress is updating. @param progress the upgrade progress information.",
             "onconsistencyupgraderequestreceived",
             "raised when the firmware version is inconsistent among modules in component.   see `upgradecomponent`. invoke `startfirmwareconsistencyupgrade`  to start consistency upgrade.  the update frequency is 1hz.  stop to notify in  following situation:  - firmware version among modules in component is  consistent.  - firmware consistency upgrade stops.  - djiupgradecomponent_cancelconsistencyupgrade  is invoked. reboot the device to receive this notification again.",
             "onlatestfirmwareinformationupdated",
             "updates the latest firmware version information when the user is logged in. please use dji go/dji pilot to upgrade to the latest firmware.  @param component the component of which the latest firmware version information have been updated. @param firmwareinformation the latest firmware information.",
             "getdetectedcomponentstoupgrade",
             "get the list of detected components that can be upgraded. the list will change when a component is added or removed.  upgrade a component in the list when its internal modules' firmware versions are inconsistent.  it is only supported by matrice 300 rtk.  @return a list of `upgradecomponent`.",
             "addupgradecomponentchangelistener",
             "adds a listener to receive the `upgradecomponentchangelistener`.  it is only supported by matrice 300 rtk.  @param listener an object of `upgradecomponentchangelistener` to be added in the internal listener map.",
             "removeupgradecomponentchangelistener",
             "removes a listener that is added by passing to `addupgradecomponentchangelistener`. it is only supported by matrice 300 rtk.  @param listener the listener to be removed in the internal listener map.",
             "removeallupgradecomponentchangelistener",
             "remove all the listeners are added by passing to `addupgradecomponentchangelistener`. it is only supported by matrice 300 rtk.  @param listener the listener to be removed in the internal listener map.",
             "upgradecomponentchangelistener",
             "this listener provides method to receive the change of detected component which can be upgraded.",
             "onupgradecomponentchanged",
             "called when a dynamic upgrade component is added, or is removed.  @param type the type of the upgrade component. @param component the dynamic upgrade component. @param isconnected the connecting state of the component.",
             "firmwareupgradeprogress",
             "firmware upgrade progress.",
             "getprogress",
             "the progress of upgrading firmware.  @return a float value.",
             "getstate",
             "the state of upgrading firmware.  @return an enum value of `upgradingprogressstate`.",
             "firmwareinformation",
             "firmware information.",
             "getversion",
             "the version of the firmware.  @return the string value of firmware version.",
             "getreleasenote",
             "firmware release notes.  @return the string value of firmware release notes.",
             "getreleasedate",
             "firmware release date.  @return the string value of firmware release date.",
             "getfilesize",
             "firmware file size.  @return a long value of firmware file size.",
             "upgradecomponenttype",
             "upgrade component.",
             "remote_controller",
             "the upgrade component is remote controller.",
             "aircraft",
             "the upgrade component is aircraft.",
             "camera",
             "the upgrade component is camera.",
             "unknown",
             "the upgrade component is unknown.",
             "upgradefirmwarestate",
             "upgrade firmware state.",
             "initializing",
             "initializating.",
             "checking",
             "checking firmware information.",
             "up_to_date",
             "firmware version is up to date.",
             "upgrade_strongly_recommended",
             "to ensure flight safety, upgrade device is strongly recommended. check dji go for  available firmware updates. find more details in `firmwareinformation`.",
             "optional_upgrade_available",
             "optional upgrade is available. check dji go for any available firmware updates.",
             "unknown",
             "unknown.",
             "upgradingprogressstate",
             "device's firmware upgrading progress state.",
             "upgrading",
             "upgrading.",
             "upgrade_failed",
             "upgrade failed.",
             "upgrade_successfully",
             "upgrade successfully.",
             "unknown",
             "unknown.",
             "getflightdatauploadinterval",
             "current interval for uploading real-time flight data.  @return an int value of the interval.",
             "getuploadstate",
             "gets current upload state.  @return upload state.",
             "isuseractivated",
             "determines if the user has been activated. it is a cached data and it will be refreshed  when `updateactivationstate` is called.  @return `true` if `updateactivationstate` is invoked at least once. `false` if `updateactivationstate` is never invoked.",
             "setflightdatauploadinterval",
             "sets the interval for uploading real-time flight data. by default, the interval is 5 seconds.  @param interval interval in seconds. the value should be in the range [1, 10].  @return error if the input is invalid.",
             "setuploadflightdataenabled",
             "set `true` to enable sdk to upload real-time flight data of the connected aircraft to dji  flighthub server. when it is enabled, sdk will start uploading flight data automatically when  the aircraft is flying. flighthub user can access the uploaded flight data on the flighthub  online system. stop uploading data by setting `false` as parameter. use `getuploadstate`  to check current uploading state.  @param enabled interval in seconds. the value should be in the range [1, 10].",
             "updateactivationstate",
             "updates the logged-in user's activation state for dji flighthub. this method is only valid when the user  is logged in. when the state is updated, the state will be cached to `isuseractivated`. please invoke the `authorizeaccesstodjidevicehardwareinfo` to authorize dji server to access dji device's hardware information.  @param callback the execution callback with the returned execution result.",
             "getteamsinformation",
             "gets the teams' information that is visible for the user.  @param callback the execution callback with the returned a list of team objects.",
             "gethistoricalflightpath",
             "gets the flight path nodes of a historical flight path with the specific path id. this information is  only visible for the administrator of the group and the captain of the team.  @param orderid corresponding order id that the user wants to check with the flight path. @param callback the execution callback with the returned a list of flightpathnode objects.",
             "getflightstatistics",
             "gets flight statistics over a period of time. specify the account to get the statistics related to one  user. otherwise, statistics for the whole team will be fetched. only `administrator`  and `captain` can access the flight statistics.  @param starttime chosen start time of milliseconds. @param endtime chosen end time of milliseconds. @param account the account that the user wants to check. set to be null if whole team flight statistics is expected. @param teamid team id that the user wants to check. @param callback the execution callback with the returned historicalflight objects.",
             "bindaircraft",
             "bind the connected aircraft to dji flighthub system. specify the team id that the aircraft will belongs to.  @param teamid team id that current aircraft is expected to bind to. @param callback the execution callback with the returned execution result.",
             "unbindaircraft",
             "unbinds current aircraft from the certain team. only `administrator`  and `captain` can do this operation.  @param callback the execution callback with the returned execution result.",
             "getliveviewstreamsource",
             "gets the live view stream sourcing by the other aircraft to dji flighthub. the stream is using rtmp  (real-time messaging protocol). external libraries are required to decode and render the live view.  only `administrator` and `captain` can do this operation.  @param sn serial number of the aircraft sourcing the live view stream. @param callback the execution callback with the returned livestream objects.",
             "getliveviewstreamdestination",
             "gets rtmp (real-time messaging protocol) url that the connected aircraft should stream to.  @param callback the execution callback with the returned upstream objects.",
             "islivestreamstable",
             "determines whether the live stream is stable from the server perspective.  @param callback the execution callback with the returned boolean result representing if the stream is healthy or not.",
             "getstreamingdevices",
             "gets the list of devices streaming live video to dji flighthubmanager.  @param callback the execution callback with the returned a list of onlinedevice objects.",
             "getonlinedevices",
             "gets the list of online devices visiable in dji flighthub.  @param callback the execution callback with the returned a list of onlinedevice objects.",
             "getaircraftrealtimeflightdata",
             "gets real time flight data of the given aircraft(s).  @param sns serial numbers of aircraft expected. @param callback the execution callback with the returned a list of `realtimeflightdata` objects.",
             "addupdateduploadstatecallback",
             "add upload state callback.  @param callback the `updateduploadstatecallback` object to receive upload state.",
             "removeupdateduploadstatecallback",
             "remove upload state callback.  @param callback the `updateduploadstatecallback` object to receive upload state.",
             "uploadstate",
             "the uploading state of the flight data for dji flighthub system.",
             "disabled",
             "the uploading process is disabled.",
             "network_not_reachable",
             "the uploading process is enabled but it is not started because the network is not reachable.",
             "not_logged_in",
             "the uploading process is enabled but it is not started because no account is logged in.",
             "aircraft_disconnected",
             "the uploading process is enabled but it is not started because the aircraft is disconnected.",
             "rejected_by_server",
             "the uploading process is enabled but the uploading request is rejected by the server.",
             "ready_to_upload",
             "the uploading process is enabled and it will start when the aircraft takes off.",
             "uploading",
             "sdk is uploading flight data to dji flighthub system.",
             "unknown",
             "unknown.",
             "role",
             "different roles of members in a flighthub group. different roles will have different  permissions to access data in the sytem.",
             "administrator",
             "the administrator is the leader of a group (a group consists of several teams). this role  will appear in the member list of all the teams and this role can access all the data of the group.",
             "captain",
             "a captain is the leader of a team. `administrator` can define a captain for a team in the group but it is not compulsory for a team to have a captain. the captain can access the data of the team.",
             "pilot",
             "a pilot is a member in the team without special permissions.",
             "unknown",
             "unknown.",
             "onlinedevice",
             "device information in the djiflighthubmanager, including serial number and team id.",
             "getsn",
             "gets the serial number of current device.  @return device's serial number.",
             "getteamid",
             "gets the team id that online device belongs to.  @return team id.",
             "bounddevice",
             "the device bound in dji flighthub.",
             "getsn",
             "gets the serial number of the device.  @return serial number of the device.",
             "getname",
             "gets device name.  @return name of the device.",
             "getmodel",
             "gets device model.  @return model of the device.",
             "user",
             "a user in flighthub.",
             "getaccount",
             "gets the account of the user.  @return the string of the account.",
             "getnickname",
             "gets the nick name of the user.  @return the string of the nick name.",
             "getrole",
             "gets the role of the user. different roles will have different permissions to access the  data in dji flighthub.  @return an enum value of `role`.",
             "team",
             "a team in dji flighthub. a group can contain several teams.",
             "getteamid",
             "gets the id of the team. each team in a group will have a unique id.  @return an integer of team id.",
             "getgroupid",
             "gets group's id that current team belongs to.  @return an integer of group id.",
             "getname",
             "gets the team's name.  @return a string of team name.",
             "getdevices",
             "get devices of the team.  @return a list of devices that belongs to current team.",
             "getmembers",
             "gets members of the team.  @return a list of user.",
             "upstream",
             "this class contains rtmp url of up stream.",
             "getupstreamurl",
             "gets up stream rtmp url of live stream.  @return live up stream url.",
             "livestream",
             "this class represents the live stream information of devices in the same team.",
             "getrtmpurl",
             "gets the rtmp(real-time messaging protocol) url of the live stream. when the device is broadcasting, user can receive the live stream's video data and audio data through rtmp.  @return a url string.",
             "isvalid",
             "determines if the live stream is valid. when the team member stops live streaming or the device  is disconnected, the live stream will become invalid.  @return `true` if the live stream is valid.",
             "flightpathnode",
             "the class provide flight information of a node in flight path.",
             "getdate",
             "gets the flight date.  @return date of the flight.",
             "getdevicemodel",
             "gets flight device's model.  @return device's model.",
             "getflighttime",
             "gets the flight time.  @return flight time in seconds.",
             "getlocationcoordinate",
             "gets the location coordinate of the flight node.  @return a locationcoordinate3d object.",
             "getspeed",
             "gets the flight speed (m/s).  @return speed in m/s.",
             "getyaw",
             "gets flight yaw in degree.  @return flight yaw.",
             "flighthistoricaldetail",
             "this class provides the detail information for one flight. it includes aircraft information,  flight location and statistics data.",
             "getorderid",
             "gets the order id of the flight.  @return the order id.",
             "getsn",
             "gets the aircraft's serial number of the flight.  @return the aircraft's serial number.",
             "getdevicemodel",
             "gets the device model of the flight.  @return the product name.",
             "getteamid",
             "gets the team id of the flight.  @return the team id.",
             "getaccount",
             "gets the account of the flight.  @return the account of the flight.",
             "getaddress",
             "gets the address of the flight.  @return the address of the flight.",
             "getstarttime",
             "gets the start time of the flight.  @return the start time of the flight.",
             "getcontact",
             "gets flight account's contact.  @return the flight account's contact.",
             "getmaxflighttime",
             "gets the maximum flight time during the flight in seconds.  @return the maximum flight time in seconds.",
             "getminflighttime",
             "gets the minimum flight time during the flight in seconds.  @return the minimum flight time in seconds.",
             "getdistance",
             "gets the flight distance in meters.  @return the distance in meters.",
             "getduration",
             "gets flight duration in seconds.  @return duration in seconds.",
             "getpeakheight",
             "gets the peak height in meters during the flight.  @return the peak height in meters.",
             "statistics",
             "the flight statistics includes total and average flight duration. it also provides a distributed  diagram data of flight duration.",
             "gettotalduration",
             "gets total flight duration over a period of time in minutes.  @return the total flight duration.",
             "getaverageduration",
             "gets average flight duration over a period of time in minutes.  @return the average flight duration.",
             "getdurationdistribution",
             "gets the histogram distribution of the flight durations (in minutes). the duration intervals  are [0, 5), [5, 10), [10, 15), [15, 20) and [20, +&#x221e;).  @return a linkedhashmap with string keys 0-5, 5-10, 10-15, 15-20 and 20+ in order. the values are the number of flights in the duration range.",
             "historicalflight",
             "class that constructed with flight statistics data and flight history in flighthubmanager.",
             "getstatistics",
             "gets the statistics of flights.  @return a statistics object.",
             "gethistory",
             "gets the history of flight.  @return a historicaldata object.",
             "realtimeflightdata",
             "this class includes detail of current flight.",
             "getsn",
             "gets current device's serial number.  @return current device's serial number.",
             "getdevice",
             "gets the model of the device.  @return the product name.",
             "getteamid",
             "gets the team's id that current device belongs to.  @return team id.",
             "getdate",
             "gets flight date.  @return the flight date.",
             "getlocationcoordinate",
             "gets current location coordinate.  @return a locationcoordinate3d object.",
             "getspeed",
             "gets flight speed.  @return an integer value of the flight speed in m/s.",
             "getyaw",
             "gets flight yaw.  @return an integer value of flight yaw.",
             "updateduploadstatecallback",
             "updates current state of uploading flight data. in order to  begin updates, call the `onupdate`  addupdateduploadstatecallback} method.",
             "onupdate",
             "updates states for the uploading progress of flight data.  @param uploadstate an enum value of `uploadstate`. @param error error when uploading data failed.",
             "getdjierror",
             "returns the specific error in the `djiflighthuberror` according to the error code.  @param errorcode errorcode for `djiflighthuberror`.  @return an nserror object initialized with errorcode. if the errorcode was 0, returns nil.",
             "getdjierror",
             "get djiutmisserror.  @param errorcode an int value of error code.  @return an object of `djierror`.",
             "getdescription",
             "returns the description of the error code.  @return the description of the error code.",
             "setdescription",
             "sets the description for the error code.  @param desc description string.",
             "getdjierror",
             "returns the specific error in djigeoerror according to the error code.  @param ccode error code.  @return the djierror object.",
             "could_not_connect_to_internet_for_pulling_data",
             "could not connect to the internet while sdk try to pull the latest cached data from server.",
             "could_not_find_unlocked_record_in_the_server",
             "could not find unlocked record in the server.",
             "unlocked_record_not_find_on_aircraft",
             "could not find unlocked record on the aircraft.",
             "no_data_in_database",
             "no data in database.",
             "account_not_logged_in_or_not_authorized",
             "not logged in account or account did not get authorization.",
             "flight_controller_serial_number_is_not_ready",
             "the flight controller sn is not ready.",
             "could_not_enable_or_disable_geo_system_while_aircraft_is_in_the_sky",
             "could not enable or disable the geo system while the aircraft is flying.",
             "not_logged_in",
             "no user account recorded.",
             "invalid_simulated_location",
             "the simulated aircraft location is not valid. during the simulation, a location is valid if it is within 50km of (37.460484, -122.115312).",
             "no_mcsn",
             "no mcsn error.",
             "fc_query_failed",
             "unlock error, can't get license from the drone.",
             "fc_set_enable_failed",
             "unlock error, can't enable license.",
             "invalid_user_id",
             "set enabled with invalid user id.",
             "no_such_license",
             "license error, can't find the correct license.",
             "version_mismatch",
             "license error, incorrect length of request data.",
             "request_param_error",
             "license error, incorrect value of request data.",
             "set_certificate_not_allowed_when_drone_in_sky",
             "license error, can't set license when the drone is flying.",
             "user_id_error",
             "license error, incorrect checksum.",
             "license_data_index_error",
             "license error, wrong index please retry.",
             "license_data_error",
             "upload license data with error data.",
             "crc_check_failed",
             "license error, incorrect crc.",
             "sn_check_failed",
             "slicense error, incorrect serial number.",
             "version_checke_error",
             "license error, wrong version, please try to update the firmware of the drone.",
             "renew_certificate_not_allowed_when_drone_in_sky",
             "license error, can't update license when the drone is flying.",
             "license_unlock_not_supported",
             "unlock error, not supported by the drone.",
             "remove_licenses_not_allowed_when_drone_in_sky",
             "license error, can't delete license when the drone is flying.",
             "remove_licenses_not_supported",
             "license error, not supported by the drone.",
             "license_data_no_data_error",
             "license error, no data.",
             "low_firmware_version_error",
             "license error, please update the firmware of the drone.",
             "unlock_version_error",
             "unlock error, incorrect unlock version.",
             "old_data_error",
             "license error, local data is obsolete.",
             "invalid_key_version_error",
             "license error, invalid key version.",
             "query_area_id_no_exist_license_error",
             "license error, license id is not exist.",
             "server_invalid_token_error",
             "server error, invalid token.",
             "server_unidentified_phone_error",
             "server error, unknown phone.",
             "server_not_unlockable_area_error",
             "server error, invalid area.",
             "server_unlock_too_many_areas_error",
             "server error, too many areas.",
             "server_too_much_license_error",
             "server error, too many licenses.",
             "no_network",
             "network error, invalid network.",
             "network_server_data_error",
             "network error, data parsing failed in server.",
             "local_user_token_is_invalid",
             "network error, invalid token.",
             "network_page_not_found",
             "network error, page not found(deprecated).",
             "pm_wrong_serial_number",
             "package error, wrong serial number of the drone.",
             "db_file_error",
             "database error, can't unzip the database.",
             "db_invalid_params",
             "database error, invalid parameters when updating database.",
             "db_not_ready",
             "database error, load database fail.",
             "server_json_data_parse_error",
             "server error, incorrect json data.",
             "network_signature_error",
             "network error, invalid signature.",
             "network_check_signature_error",
             "network error, invalid signature (deprecated).",
             "network_invalid_requeset",
             "network error, invalid request.",
             "network_user_is_not_login",
             "network error, user is not login.",
             "network_operation_cancel_by_user",
             "network error, canceled by user(deprecated).",
             "pm_timeout",
             "package error, time out when waiting for the ack package from the drone.",
             "pm_wrong_unlock_version",
             "unlock error, unlock version from the drone should be 0, 1, or 2.",
             "pm_wrong_device_id",
             "package error, wrong device id.",
             "invalid_area_ids",
             "unlock error, area id is not exist in the license.",
             "user_mismatch",
             "license error, the user is not matching.",
             "mission_not_started",
             "mission is not started yet.",
             "common_state_error",
             "the command is not supported in current state.",
             "max_flight_speed_not_valid",
             "max flight speed value provided is invalid.",
             "auto_flight_speed_not_valid",
             "auto flight speed value provided is invalid.",
             "repeat_time_not_valid",
             "repeat time value provided is invalid.",
             "waypoint_count_not_valid",
             "waypoint count exceeds the maximum limit.",
             "waypoint_list_size_not_valid",
             "waypoint list size is invalid.",
             "waypoint_coordinate_not_valid",
             "waypoint coordinate provided is invalid.",
             "altitude_not_valid",
             "waypoint altitude provided is invalid.",
             "heading_not_valid",
             "waypoint heading provided is invalid.",
             "action_repeat_time_not_valid",
             "waypoint repeat time provided is invalid.",
             "action_timeout_not_valid",
             "waypoint action timeout provided is invalid.",
             "corner_radius_not_valid",
             "waypoint corner radius provided is invalid.",
             "gimbal_pitch_not_valid",
             "waypoint gimbal pitch provided is invalid.",
             "waypoint_speed_not_valid",
             "waypoint speed provided is invalid.",
             "shoot_photo_not_valid",
             "waypoint shoot photo distance provided is invalid.",
             "stay_action_not_valid",
             "waypoint stay action param provided is invalid.",
             "rotate_gimbal_action_not_valid",
             "waypoint rotate gimbal action param provided is invalid.",
             "rotate_aircraft_action_not_valid",
             "waypoint rotate aircraft action param provided is invalid.",
             "indices_are_discontinuous",
             "waypoint indecies are discontinuous.",
             "index_out_of_range",
             "waypoint index out of range.",
             "invalid_data_size",
             "waypoint data size is invalid. it is for internal usage.",
             "take_off_failure_caused_by_attitude",
             "the aircraft cannot take off because of improper aircraft's attitude.",
             "waypoint_get_interruption_failure_for_complete_mission",
             "the waypoint mission interruption is not available because the last mission completed successfully.",
             "waypoint_get_interruption_failure_without_reaching_first_waypoint",
             "the waypoint mission interruption is not available because the aircraft didn't reach the first waypoint in the last mission.",
             "system_abnormal",
             "system error, please try again. if the error continues, restart the aircraft.",
             "target_area_is_too_small",
             "frame selection subject too small.",
             "insufficient_features_in_target_area",
             "frame selection subject texture not obvious.",
             "lost_target_while_watching",
             "tracking subject lost while watching.",
             "lost_target_while_executing",
             "tracking subject lost while executing.",
             "reprojection_failed_while_executing",
             "failed to estimate, please try again.",
             "target_too_close",
             "frame subject too close.",
             "target_size_changed",
             "target size changed, please try again. if the error persists, restart the aircraft.",
             "gps_abnormal",
             "gps signal weak. please try again in an open area.",
             "hot_point_invalid",
             "hotpoint parameter do not meet requirements.",
             "watch_target_failed",
             "gimbal reached movement limit, subjecting failed. please try again.",
             "estimate_timeout",
             "estimate timeout, mission exit.",
             "estimate_result_invalid",
             "failed to estimate subject location.",
             "exit_by_user_button",
             "current mission exit by user button.",
             "radius_limit",
             "the aircraft reach the distance limit. please operate the aircraft within the distance limit.",
             "altitude_limit",
             "the aircraft reach the altitude limit. please operate the aircraft within the altitude limit.",
             "control_failed",
             "intelligent hotpoint mission execute failed, the description is the fail reason.",
             "lost_connection_with_remote_controller",
             "lost connection with remotecontroller.",
             "obstacle_encountered_while_estimating",
             "obstacles encountered while estimating, current mission quitted.",
             "obstacle_encountered_while_surrounding",
             "obstacles encountered while surrounding, current mission suspended.",
             "target_is_too_far_away",
             "target is too faraway, the aircraft needs to continue to measure distance.",
             "hotpoint_altitude_too_low",
             "aircraft's altitude is too low to execute hotpoint mission.",
             "multi_mode_disabled",
             "the mission cannot start when multi-mode is disabled.",
             "getdjierror",
             "returns the specific error in djimissionmanagererror according to the error code.  @param ccode error code.  @return the djierror object.",
             "common_unsupported",
             "unsupported feature error. where possible:  this error will be returned by the function for a special feature interface when the feature is not supported by the device.",
             "common_disconnected",
             "disconnected.",
             "began",
             "mission began (phantom 2 series).",
             "canceled",
             "mission canceled.",
             "failed",
             "mission failed.",
             "no_mission_running",
             "mission not existed.",
             "timeout",
             "mission timeout.",
             "gps_not_ready",
             "the gps of the aircraft is not ready.  maybe the aircraft haven't got the home point location.",
             "motors_did_not_start",
             "the aircraft's motor has not started.",
             "take_off",
             "the aircraft is taking off.",
             "is_flying",
             "the aircraft is flying.",
             "not_auto_mode",
             "the aircraft is not in auto mode.",
             "max_number_of_waypoints_upload_limit_reached",
             "waypoint mission has reached the maximum points limit.  1. phantom 2 vision/vision+: the max points limit is 16.  2. inspire1/ phantom 3 series: the max points limit is 99.",
             "uploading_waypoint",
             "waypoint is uploading.",
             "key_level_low",
             "the api key provided to you is not at the correct permission level.  check whether your key is a level 2 application key in your androidmanifest.xml.",
             "navigation_mode_disabled",
             "navigation is not open.",
             "ioc_type_unknown",
             "the type of ioc is unknown.",
             "home_point_value_invalid",
             "the homepoint is not a valid float value.",
             "home_point_location_invalid",
             "the latitude and longitude of the homepoint are invalid.",
             "home_point_direction_unknown",
             "the direction of the homepoint is unknown.",
             "home_point_mission_paused",
             "homepoint is paused.",
             "home_point_mission_not_paused",
             "the homepoint is not paused.",
             "follow_me_distance_too_large",
             "the distance between the aircraft and mobile phone is too large (must be lower than 20000m). this error will be returned when initializing the follow me task.",
             "follow_me_disconnect_time_too_long",
             "the disconnect time of the follow me mission is too long.",
             "follow_me_gimbal_pitch_error",
             "the initial pitch angle of the gimbal is too large.",
             "altitude_too_high",
             "the altitude is too high. the range of the altitude should be [-200,500].",
             "altitude_too_low",
             "the altitude is too low. the range of the altitude should be [-200,500].",
             "mission_radius_invalid",
             "the radius of mission is invalid.",
             "mission_speed_too_high",
             "the speed of the mission is too high.",
             "mission_entry_point_invalid",
             "the entry point of the mission is invalid.",
             "mission_heading_mode_invalid",
             "the heading mode of the mission is invalid.",
             "mission_radius_over_limit",
             "the radius of the mission is over the acceptable limit.",
             "navigation_mode_not_supported",
             "navigation in the product is unsupported.",
             "distance_from_mission_target_too_long",
             "the distance from the mission target is too long.  for example, the distance from hotpoint target position is too long,  or the distance from the first waypoint target position is too long",
             "rc_mode_error",
             "remote controller mode error.  you should put the remote controller's mode selection bar to f position.",
             "ioc_working",
             "the ioc mode is working.",
             "mission_not_initialized",
             "the mission is not initialized.",
             "mission_not_exist",
             "the mission does not exist.",
             "mission_conflict",
             "there is a conflicting setting in the mission.",
             "mission_estimate_time_too_long",
             "the estimated time for the mission is too long.",
             "rtk_is_not_ready",
             "rtk is not ready.",
             "multi_mode_is_off",
             "multi-mode switch is not turned on.",
             "high_priority_mission_executing",
             "a higher priority mission is executing.",
             "mission_condition_not_satisfied",
             "the condition of the mission is not satisfied.",
             "mission_across_no_fly_zone",
             "the mission is across a no fly zone.",
             "mission_info_invalid",
             "the information for the mission is invalid.",
             "waypoint_info_invalid",
             "the information for the waypoint is invalid.",
             "waypoint_trace_too_long",
             "the waypoint trace is too long. the maximum waypoint trace is 30km. the waypoint trace is the sum of all distances between waypoints in a mission.",
             "waypoint_total_trace_too_long",
             "the total waypoint mission distance is too long. the maximum total distance is 40km. the total distance includes the sum of:   - distance from current aircraft location to first waypoint   - sum of all distances between waypoints   - distance from last waypoint to the homepoint.",
             "waypoint_index_over_range",
             "the index of the waypoint is out of range.",
             "waypoint_distance_too_close",
             "the waypoint distance is too close.",
             "waypoint_distance_too_long",
             "the waypoint distance is too long. a valid distance between two adjacent waypoints is less than 2km and greater than 0.5m.",
             "waypoint_damping_check_failed",
             "the damping check failed.",
             "waypoint_action_parameter_invalid",
             "the parameter of the waypoint action is invalid.",
             "waypoint_mission_info_not_uploaded",
             "the information for the waypoint mission is not completely uploaded.",
             "waypoint_upload_not_complete",
             "the waypoint uploading is not complete.",
             "waypoint_request_is_running",
             "the waypoint mission is running.",
             "waypoint_not_running",
             "the waypoint mission is not running.",
             "waypoint_idle_velocity_invalid",
             "the idle velocity is invalid.",
             "aircraft_starting_motor",
             "the aircraft is starting the motor.",
             "wrong_cmd",
             "the command is wrong.",
             "pointing_aircraft_not_in_the_air",
             "the aircraft is not in the air. please take off first.",
             "vision_sensor_low_quality",
             "the quality of vision sensor is low.",
             "z30_only_support_spotlight_pro",
             "the camera only supports spotlight pro mode.",
             "user_cancel_uploading_mission",
             "the uploading mission has been canceled by the user.",
             "already_in_other_navigation_mode",
             "already in other navigation mode(such as: go home, landing,etc.). please exit navigation mode to start activetrack mission.",
             "unknown_object_target",
             "unknown object target do not support tracking. you can check `activetracktargettype` to get supported target type.",
             "aircraft_auto_landing",
             "aircraft landing automatically. unable to use activetrack.",
             "in_smart_photo_mode",
             "spotlight unavailable in smartphoto mode.",
             "in_burst_mode",
             "spotlight unavailable in burst mode.",
             "in_timed_shot_mode",
             "spotlight unavailable in timed shot mode.",
             "in_aeb_shot_mode",
             "spotlight unavailable in aeb shooting mode.",
             "in_48mp_shot_mode",
             "spotlight unavailable in 48mp shooting mode.",
             "in_slow_motion_mode",
             "spotlight unavailable in slot motion mode.",
             "camera_is_shooting",
             "camera is shooting, unable to use activetrack.",
             "autosensing_must_enable",
             "autosensing must be enabled.",
             "unknown",
             "unknown result.",
             "mode_error",
             "cannot execute in the current mode. for products and flight controller firmware versions that support 'f' mode (e.g. phantom 3 professional, inspire 1, a3 with flight controller firmware version lower than 3.2.10.0, etc), please make sure the remote controller's mode switch is in 'f' mode. for the others, please make sure the remote controller's mode switch is in 'p' mode.",
             "gps_signal_weak",
             "the gps signal of the aircraft is weak.",
             "low_battery",
             "low battery level warning.",
             "aircraft_not_in_the_air",
             "the aircraft is not in the air.",
             "aircraft_altitude_too_high",
             "the aircraft's altitude is too high.",
             "aircraft_altitude_too_low",
             "the aircraft's altitude is too low.",
             "aircraft_taking_off",
             "aircraft is taking off.",
             "aircraft_landing",
             "aircraft is landing.",
             "aircraft_going_home",
             "aircraft is going home.",
             "home_point_not_recorded",
             "the home point of the aircraft is not recorded.",
             "in_novice_mode",
             "aircraft is in novice mode.",
             "aircraft_in_no_fly_zone",
             "aircraft is in a no fly zone.",
             "reach_flight_limitation",
             "the aircraft has reached the flight limitation.",
             "running_mission",
             "the aircraft is running a mission.",
             "too_close_to_home_point",
             "aircraft is too close to the home point.",
             "mission_parameters_invalid",
             "the parameters of the mission are invalid.",
             "mission_resume_failed",
             "mission resume failed.",
             "tracking_target_lost",
             "the tracking target is lost.",
             "no_video_feed",
             "no live video feed is captured for the activetrack mission.",
             "video_frame_rate_too_low",
             "the frame rate of the live video feed is too low.",
             "vision_system_not_authorized",
             "the vision system cannot get the authorization to control the aircraft.",
             "vision_system_error",
             "the vision system encounters system error.",
             "cannot_bypass_obstacle",
             "the aircraft cannot bypass the obstacle.",
             "stopped_by_user",
             "mission was stopped by the user.",
             "vision_system_needs_calibration",
             "the vision system requires calibration.",
             "vision_sensor_overexposed",
             "the vision sensors are overexposed.",
             "vision_sensor_underexposed",
             "the vision sensors are underexposed.",
             "vision_data_abnormal",
             "the data from the vision system is abnormal.",
             "feature_point_cannot_match",
             "the feature points found by both vision sensors cannot match.",
             "tracking_rect_too_small",
             "the tracking rectangle is too small.",
             "tracking_rect_too_large",
             "the tracking rectangle is too large.",
             "tracking_target_not_enough_features",
             "the tracking target doesn't have enough features to lock onto.",
             "tracking_target_too_close",
             "the tracking target is too close to the aircraft.",
             "tracking_target_too_far",
             "the tracking target is too far away from the aircraft.",
             "tracking_target_too_high",
             "the tracking target is too high.",
             "tracking_target_shaking",
             "the tracking target is shaking too much.",
             "tracking_target_low_confidence",
             "the activetrack mission is too unsure the tracking object and confirmation is required.",
             "tracking_paused_by_user",
             "mission is paused by user.",
             "tracking_gimbal_pitch_too_low",
             "gimbal pitch is too low.",
             "tracking_obstacle_detected",
             "encounter an obstacle.",
             "reach_altitude_lower_bound",
             "the aircraft reaches the altitude lower bound of the tapfly mission.",
             "getdjierror",
             "returns the specific error in djiflightcontrollererror according to the error code.  @param ccode error code.  @return the djierror object.",
             "not_logged_in",
             "no user is logged in.",
             "fail_to_enter_transport_mode_when_motors_on",
             "when the motors are on, the aircraft could not get into transport mode.",
             "imu_calibration_error_in_the_air_or_motors_on",
             "imu calibration is not allowed if the aircraft's motors are on or the aircraft is in the air.",
             "invalid_parameter",
             "the parameter is not a valid value.",
             "gps_signal_weak",
             "gps level is not high enough to allow flight controller to obtain accurate location.",
             "could_not_enter_transport_mode",
             "aircraft could not enter transport mode, since the gimbal is still connected.",
             "cannot_turn_off_motors_while_aircraft_flying",
             "the aircraft is flying. for safety consideration, the motors could not be shut down.",
             "home_point_too_far",
             "the new home point is too far.",
             "go_home_altitude_too_low",
             "the new home altitude is too low. (lower than 20m).",
             "go_home_altitude_too_high",
             "the new home altitude is too high. (higher than 500m).",
             "go_home_altitude_higher_than_max_flight_height",
             "the go home altitude is too high (higher than max flight height).",
             "rtk_cannot_start",
             "rtk cannot start properly. please reboot.",
             "rtk_connection_broken",
             "connection between base station and mobile station is broken.",
             "rtk_bs_antenna_error",
             "rtk base station antenna error. check if the antenna is connected to the correct port.",
             "rtk_bs_coordinate_reset",
             "rtk base station's coordinate resets.",
             "base_station_not_activated",
             "the base station isn't activated.",
             "base_station_is_moved",
             "the base station is moved. land the aircraft to re-establish the connection to the ground station.",
             "base_station_fell",
             "the base station fell. land the aircraft to re-establish the connection to the base station.",
             "navigation_satellite_system_can_not_set",
             "the selection of navigation satellite system is only supported when the rtk function is turned off, and cannot be modified in the air.",
             "base_station_parameter_number_not_match",
             "base station internal error. parameter numbers do not match. please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
             "base_station_parameter_length_not_match",
             "base station internal error. parameters' length do not match. please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
             "base_station_parameter_read_only",
             "base station internal error. parameters read only. please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
             "gravity_center_calibration_not_flying",
             "the aircraft cannot start the gravity center calibration because it is not flying.",
             "gravity_center_calibration_not_flying_not_work_in_simulator",
             "the aircraft cannot start the gravity center calibration because the simulator starts.",
             "gravity_center_calibration_is_running",
             "the aircraft cannot start the gravity center calibration before the previous calibration finishes.",
             "gravity_center_calibration_not_hovering",
             "the aircraft cannot start the gravity center calibration because it is not hovering.",
             "gravity_center_calibration_stopped_by_user",
             "the gravity center calibration is stopped by the user.",
             "gravity_center_calibration_failed_in_big_wind",
             "the gravity center calibration is interrupted because the wind is too strong.",
             "owner_offline_error",
             "owner offline error.",
             "device_locked_error",
             "device locked error.",
             "owner_out_control_error",
             "owner out control error.",
             "command_not_supported_by_current_attitude",
             "the command cannot be executed with the current attitude.",
             "base_station_need_login",
             "for matrice 300 rtk, you must login before you can set name, or use `setbasestationreferencinglocation` etc.",
             "cannot_base_station_scan_in_flying",
             "for matrice 300 rtk, you cannot scan fro a base station while flying.",
             "base_station_password_invalid",
             "base station administrator account password is invalid. please login again. if you reset your password, please use the default password.",
             "feature_not_supported",
             "feature not supported error.",
             "application_not_activated",
             "application not activated error.",
             "system_busy",
             "system busy error.",
             "invalid_parameters",
             "parameters invalid error.",
             "parameter_get_failed",
             "get parameter failed error.",
             "parameter_set_failed",
             "setting parameters operation failed.",
             "command_execution_failed",
             "command execute failed error.",
             "send_data_failed",
             "send data failed error.",
             "connection_to_sdk_failed",
             "connection to sdk failed error.",
             "device_not_found",
             "device not found.",
             "not_defined",
             "not defined error.",
             "could_not_connect_to_internet",
             "the application is not able to connect to the internet the first time it tries to register the api key.",
             "invalid_app_key",
             "the application key you provided is incorrect.",
             "http_timeout",
             "the network you are trying to reach is busy, or the server is unreachable.",
             "device_not_match",
             "the attempt to copy metadata from another registered device to a device that is currently connected is not permitted. for example, if a developer has two devices and the application is activated with the app key on one of the devices and if the other device is plugged in and tries to register the application, this error will occur.",
             "bundle_not_match",
             "the bundle identifier of your application does not match the bundle identifier you registered on the developer website when you applied to obtain an application key.",
             "app_key_prohibited",
             "the application key is prohibited. this occurs when an application key that has already been released by dji is revoked. please contact dji for assistance.",
             "max_activation_count_reached",
             "there is a maximum number of devices one application key can be used to activate. the maximum number of devices is given when an application is registered on the dji developer website. this error will occur if the maximum number of activations has been reached.",
             "app_key_invalid_platform",
             "this error occurs when an application key was given for a specific platform and is trying to be used to activate an application for another platform. for instance, if an application key was given for an ios application and is used to activate an android application, this error will occur.",
             "app_key_not_exist",
             "the application key does not exist. please make sure the application key you are entering is correct.",
             "app_key_level_not_permitted",
             "there are two levels for the sdk framework, level 1 and level 2. if an application key was given under one level and is trying to be used to active an application using another level sdk framework, this error will occur.",
             "server_parse_failure",
             "there is a server error. please contact dji for assistance.",
             "server_write_failure",
             "there is a server error. please contact dji for assistance.",
             "server_data_abnormal",
             "there is a server error. please contact dji for assistance.",
             "invalid_metadata",
             "the activation data received from server is invalid. please reconnect to the internet and try again.",
             "empty_app_key",
             "no application key was provided.",
             "over_max_activations_count",
             "applications under basic develop account could only have the maximum of 20 unique activations. visit dji developer center <https://developer.dji.com/user/membership/> to upgrade the membership.",
             "app_key_not_enrolled_by_beta_sdk",
             "the application is not enrolled in the beta program. use an app key under the beta program instead.",
             "invalid_app_key_for_beta_version",
             "the app key is invalid for this beta version.",
             "download_flysafe_database_failed_with_ldm_on",
             "download flysafe database failed. you can close ldm model to retry register app or implementation flysafedatabase-release.aar in your app build.gradle before compile it.",
             "sdk_version_blocked",
             "sdk version is blocked.",
             "activate_failed",
             "app activation failed.",
             "app_key_blocked",
             "app key is blocked.",
             "can_not_execute",
             "the operation can't be executed in current state.",
             "unknown",
             "an unknown error occurred when the application was trying to register. please contact dji for assistance.",
             "key_unsupported",
             "the key is not supported.",
             "invalid_value",
             "invalid parameters.  this error will be returned when the sent parameters are invalid.",
             "invalid_key_format",
             "the key does not match the format: component/index/key with index being a number or *.",
             "invalid_key_for_component",
             "the key does not exist in component abstraction.",
             "no_get_for_key",
             "the key is not gettable.",
             "no_set_for_key",
             "the key is not settable.",
             "unknown_access_type",
             "the access type requested for the key is unknown. this is an implementation error in the cache as only valid types should be exposed to the public interface.",
             "disconnected",
             "the abstraction is no longer connected to real hardware.",
             "no_storage_access",
             "can not access to component storage.",
             "no_action_for_key",
             "the key is not actionable.",
             "setter_value_type_mismatch",
             "the key does not match the format: component/index/key with index being a number of *.",
             "getdjierror",
             "constructor method 1.  @param ccode error code.  @return the djierror object.",
             "unknown_error",
             "unknown.",
             "check_permission_level1_is_invalid",
             "level 1 api permission is invalid. this error indicates that the api key's level 1 permission is invalid.",
             "media_invalid_request_type",
             "result of media downloading request type is invalid.",
             "media_no_submedia_files",
             "no sub media files.",
             "media_request_client_abort",
             "result of media downloading: the client aborted the download.",
             "media_request_server_abort",
             "result of media downloading: the server aborted the download.",
             "media_request_disconnect",
             "result of media downloading: the download link disconnected.",
             "could_not_delete_all_files",
             "could not delete all files.",
             "cannot_set_parameters_in_this_state",
             "cannot set the parameters in this state.",
             "cannot_shoot_photo_when_not_fly",
             "cannot take panorama photo when aircraft is not flying.",
             "get_remote_media_failed",
             "failed to get remote media data.",
             "get_thumbnail_failed",
             "get thumbnail picture failed.",
             "not_connected",
             "camera connection isn't ok.",
             "exec_timeout",
             "the camera action executed a timeout.",
             "invalid_parameters",
             "camera invalid parameters.  this error will be returned when the sent parameters are invalid.",
             "unsupported_cmd_state",
             "the camera does not support the command in the current state.  this error is returned when the camera is busy and the camera is unsupported for the command in the current state.",
             "digital_zoom_not_supported_resolution",
             "failed to set digital zoom, because the resolution is over 4k.",
             "digital_zoom_not_supported_view_mode",
             "failed to set digital zoom, because app is in full view mode.",
             "parameters_set_failed",
             "failed to set the parameters.  this error will be returned when setting the camera parameters fails.",
             "parameters_get_failed",
             "failed to get the parameters.  this error will be returned when getting the camera parameters fails.",
             "parameters_not_available",
             "the parameters are not available.  this error will be returned when there are some errors with the parameters submitted to the camera.",
             "media_file_reset",
             "media file is reset. the operation can be executed.",
             "custom_info_length_error",
             "custom info should not be null and no more than 32 bytes.",
             "cannot_set_parameters_in_super_resolution_state",
             "cannot set the parameters in super resolution state.",
             "sd_card_not_inserted",
             "no sd card.",
             "sd_card_full",
             "sd card full.",
             "sd_card_error",
             "sd card error.",
             "sensor_error",
             "camera sensor error.",
             "system_error",
             "camera system error.",
             "no_such_media_file",
             "the media file is not found in sd card.",
             "panorama_not_flying",
             "panorama mode cannot work until the aircraft takes off.",
             "signature_invalid",
             "server rejected the request because the signature is invalid.",
             "no_right_to_access",
             "server rejected the request because the user does not have the permission.",
             "parameters_invalid",
             "invalid parameter(s).",
             "no_authorization_information_found",
             "no authorization information found.",
             "user_not_found_in_user_center",
             "the account information is not found.",
             "authorization_expired",
             "authorization information has expired. please authorize again.",
             "user_not_found_in_flight_hub",
             "user not found in dji flighthub system.",
             "service_package_expired",
             "the service package has been expired.",
             "service_package_limitation_reached",
             "the service package has reached the limit of device numbers.",
             "no_sdk_permission_for_service_package",
             "the service package does not have permission to access sdk service.",
             "no_team_found",
             "no team found.",
             "no_aircraft_found",
             "no aircraft found.",
             "aircraft_already_bound_in_team_chosen",
             "the aircraft has already been bound in the chosen team.",
             "no_record_found",
             "no record found.",
             "not_logged_in",
             "no user is logged in.",
             "aircraft_serial_number_is_not_available",
             "aircraft's serial number is not available.",
             "bound_device_limitation_reached",
             "bound device number has reached the limit of your service package.",
             "aircraft_already_bound_in_other_team",
             "the aircraft has already been bound in the other team. please unbind it first.",
             "authentication_failure",
             "the authentication failed when trying to access to the server.",
             "invalid_settings",
             "network settings are not configured yet or invalid.",
             "already_started",
             "the service is already started. stop it first to re-start the service.",
             "invalid_gps_data",
             "the gps location of the aircraft is invalid. the rtk network service requires the location of the air system.",
             "incorrect_reference_station_source",
             "please choose correct reference station srouce.",
             "account_not_logged_in_or_expired",
             "no logged in account or the login session has expired, please login dji account and try again.",
             "account_unactivated",
             "account not activated, please contact dji support. use `activatenetworkservice` to activate your account.",
             "invalid_request",
             "invalid request for the rtk service. please check if the network rtk service is purchased or activated. after purchasing, within 3 minutes, you might also get this error.",
             "server_not_reachable",
             "unable to connect to server.",
             "account_error",
             "unknown account error, please contact dji support.",
             "accessory_not_connected_error",
             "the accessory is not connected. also update the implementation.",
             "file_name_length_invalid",
             "the file name exceeds the maximum length (20 characters).",
             "duplication_of_file_name",
             "the file name is already taken in the aircraft. choose a different file name.",
             "file_name_empty_error",
             "a file name cannot be empty.",
             "file_not_exist_error",
             "the file does not exist in the aircraft.",
             "file_created_error",
             "an error occurs when creating the file.",
             "file_index_unavaiable_error",
             "there is no more file index available for the file.",
             "rename_file_error",
             "error occurs when renaming the file.",
             "data_transmission_disconnection_error",
             "the connection of the speaker is broken and data transmission cannot start.",
             "wrong_data_transimission_state",
             "the data transimission operation cannot be executed in the current state.",
             "data_corruption_error",
             "data validation failed. data is corrupted during the transmission.",
             "canceled_by_user",
             "the ongoing data transmission is cancelled.",
             "interrupted_by_timeout_error",
             "the ongoing data transmission is interrupted by timeout error.",
             "storage_full",
             "the storage is full.",
             "rejected_by_firmware",
             "the operation is rejected by the firmware because state error.",
             "order_of_func",
             "wrong order of invoking functions. failed to initialize.",
             "invalid_db",
             "failed to create database.",
             "cache_failed",
             "failed to insert the data. the data has been lost.",
             "empty_db",
             "the database is currently empty.",
             "upload_failed",
             "failed to upload. request code is bigger than 299.",
             "area_not_supported",
             "current area does not support this function.",
             "utmiss_had_started",
             "utmiss has started already.",
             "network_access_failed",
             "network access failed.",
             "sign_error",
             "signature error.",
             "area_code_restricted",
             "ldm is not supported in the current area.",
             "app_not_found",
             "app does not exist.",
             "ldm_license_not_valid",
             "no valid ldm certificate exists.",
             "client_time_not_valid",
             "client's current time is invalid.",
             "license_outdated",
             "license has expired.",
             "unavailable",
             "only available when the local data mode is enabled.",
             "ldm_network_access_failed",
             "in local data mode. network access failed!",
             "ldm_unknown_error",
             "ldm unknown error.",
             "invalid_state",
             "the command is not valid in current state.",
             "firmware_write_error",
             "write failure when updating data in the firmware.",
             "firmware_read_error",
             "read failure when accessing data in the firmware.",
             "security_code_incorrect",
             "the security code is incorrect.",
             "not_set_up_error",
             "the user account is not set up for the security feature yet.",
             "already_unlocked",
             "the aircraft is already unlocked.",
             "security_code_incorrect_five_times",
             "attempt with wrong security code more than 5 times. the aircraft is disable and try again in 1 minute.",
             "security_code_incorrect_twenty_times",
             "attempt with wrong security code more than 20 times. the aircraft is disable and try again in 24 hours.",
             "username_not_exist",
             "the username does not exist.",
             "security_code_format_invalid",
             "the new security code is not valid. a valid security code should contain only numbers and letters and its length is not less than 4 characters and not longer than 8 characters.",
             "invalid_format_of_widget_configuration",
             "the format of widget configuration is invalid.",
             "command_can_not_be_executed_in_current_mode",
             "the command cannot be executed in current payload mode. see `payloadproductphase`.",
             "in_wifi_link",
             "cannot upgrade when using `wifilink`.",
             "getdjierror",
             "get the mission waypoint error type.  @param errorcode an int value of the error code.  @return value of the `djiwaypointv2error` enum.",
             "djiwaypointv2error",
             "the mission waypoint count is larger than max waypoint count 65535.",
             "djiwaypointv2error",
             "the mission waypoint count is less than min waypoint count 2.",
             "djiwaypointv2error",
             "the mission djimutablewaypointv2mission_maxflightspeed</code> is greater than 15m/s or less than 2m/s. see djimutablewaypointv2mission_maxflightspeed</code>.",
             "djiwaypointv2error",
             "the mission djimutablewaypointv2mission_autoflightspeed</code> is greater than djimutablewaypointv2mission_maxflightspeed</code>.",
             "djiwaypointv2error",
             "the mission djimutablewaypointv2mission_gotofirstwaypointmode</code> is out of range of `missiongotowaypointmode`.",
             "djiwaypointv2error",
             "the mission `setfinishedaction` is out of range of `missionfinishedaction`.",
             "djiwaypointv2error",
             "the mission djimutablewaypointv2mission_exitmissiononrcsignallost</code> is invalid.",
             "djiwaypointv2error",
             "there is already a mission executing when trying to upload a new mission.",
             "djiwaypointv2error",
             "the upload waypoint count is bigger than mission waypoint count.",
             "djiwaypointv2error",
             "waypoint is too close to two adjacent waypoints. the min distance is 0.5m.",
             "djiwaypointv2error",
             "waypoint is too far from two adjacent waypoints, the max distance is 5km.",
             "djiwaypointv2error",
             "the upload waypoints have a `getmaxflightspeed` is greater than djimutablewaypointv2mission_maxflightspeed</code> waypoint.",
             "djiwaypointv2error",
             "the upload waypoint has a `getautoflightspeed` is greater than `getmaxflightspeed` waypoint.",
             "djiwaypointv2error",
             "the upload waypoints have a  `getautoflightspeed` is greater than djimutablewaypointv2mission_maxflightspeed</code> waypoint.",
             "djiwaypointv2error",
             "the waypoint `getheadingmode` is invalid.",
             "djiwaypointv2error",
             "the waypoint `getheading` is invalid. see `getheading`.",
             "djiwaypointv2error",
             "the waypoint `getturnmode` is invalid.",
             "djiwaypointv2error",
             "the waypoint `getflightpathmode` is invalid.",
             "djiwaypointv2error",
             "the waypoint `getdampingdistance` is greater than or equal to the distance of adjacent waypoint.",
             "djiwaypointv2error",
             "the waypoint `getflightpathmode` is invalid for last waypoint.",
             "djiwaypointv2error",
             "the index of upload waypoint is not continue after the stored waypoint.",
             "djiwaypointv2error",
             "the waypoint `getflightpathmode` is invalid for first waypoint.",
             "djiwaypointv2error",
             "the waypoint position coordinate exceeds rational range.",
             "djiwaypointv2error",
             "the waypoint position exceeds radius limit.",
             "djiwaypointv2error",
             "the waypoint position exceeds height limit.",
             "djiwaypointv2error",
             "the version of the sdk doesn't match the firmware version.",
             "djiwaypointv2error",
             "the index of first and last waypoint expected to download is not in range of waypoints stored in aircraft.",
             "djiwaypointv2error",
             "there is no mission uploaded in aircraft.",
             "djiwaypointv2error",
             "the mission info is not uploaded yet.",
             "djiwaypointv2error",
             "the aircraft current position is too far away from the first waypoint.",
             "djiwaypointv2error",
             "the uploaded waypoints are too few.",
             "djiwaypointv2error",
             "there is no mission executing.",
             "djiwaypointv2error",
             "the mission has already started by calling `startmission`.",
             "djiwaypointv2error",
             "the mission has already stopped by calling `stopmission`.",
             "djiwaypointv2error",
             "there is no executing mission to recover when calling `recovermission`.",
             "djiwaypointv2error",
             "the mission has already been interrupted by calling `interruptmission`.",
             "djiwaypointv2error",
             "there is no waypoint recorded to recover the mission when `recovermission` is called.",
             "djiwaypointv2error",
             "the aircraft flying status is bad.",
             "djiwaypointv2error",
             "the aircraft home point is not recorded yet.",
             "djiwaypointv2error",
             "the aircraft gps signal is weak.",
             "djiwaypointv2error",
             "the aircraft rtk is not ready.",
             "djiwaypointv2error",
             "the mission is across the no-fly zone.",
             "djiwaypointv2error",
             "the aircraft battery is low.",
             "djiwaypointv2error",
             "the uploaded action id is duplicated.",
             "djiwaypointv2error",
             "there is not enough space to store actions in aircraft.",
             "djiwaypointv2error",
             "download actions failed.",
             "djiwaypointv2error",
             "the upload action trigger type is invalid.",
             "djiwaypointv2error",
             "the action associate trigger `getassociatetype` is invalid.",
             "djiwaypointv2error",
             "the action associate trigger `gettype` is invalid.",
             "djiwaypointv2error",
             "the action associate trigger waypoint index invalid.",
             "djiwaypointv2error",
             "the actuator state does not match action.",
             "djiwaypointv2error",
             "the action actuator operation index is invalid.",
             "djiwaypointv2error",
             "camera failed to execute coressponding command.",
             "djiwaypointv2error",
             "the action actuator is not supported.",
             "djiwaypointv2error",
             "the action actuator `getactuatortype` is invalid.",
             "djiwaypointv2error",
             "the action actuator operation type is invalid. see `getcameraoperationtype` or `getaircraftcontroltype` or `getoperationtype`.",
             "djiwaypointv2error",
             "the action gimbal actuator parameters are invalid.",
             "djiwaypointv2error",
             "the action actuator rotate gimbal failed.",
             "djiwaypointv2error",
             "gimbal is not mounted or unable to execute stop rotation command.",
             "djiwaypointv2error",
             "the current waypoint type(coordinated turn or curved route aircraft continues) does not support setting the action when the waypoint is reached.",
             "djiwaypointv2error",
             "failed to take precise photos.",
             "djiwaypointv2error",
             "timeout for taking precise photos.",
             "djiwaypointv2error",
             "the action `waypointaircraftcontrolparam` parameters are invalid.",
             "djiwaypointv2error",
             "failed to execute navigation command.",
             "djiwaypointv2error",
             "failed to send shoot photo command to camera cause of no camera or camera is busy.",
             "djiwaypointv2error",
             "failed to send start record command to camera cause of no camera or camera is busy.",
             "djiwaypointv2error",
             "failed to send video stop command to camera cause of no camera or camera is not busy.",
             "djiwaypointv2error",
             "camera focus param xy exceed valid range [0, 1].",
             "djiwaypointv2error",
             "failed to send camera focus command cause of no camera or camera is busy.",
             "djiwaypointv2error",
             "failed to send camera zoom command cause of no camera or camera is busy.",
             "djiwaypointv2error",
             "illegal zoom focal length.",
             "djiwaypointv2error",
             "the action actuator rotate aircraft yaw execute failed.",
             "djiwaypointv2error",
             "the action actuator aircraft start or stop fly execute failed. for example: when the aircraft is flying, an error will occur when the `isstartfly`(true) action is executed. you should execute `isstartfly`(false) first.",
             "djiwaypointv2error",
             "the waypoint mission is interrupted by by obstacle avoidance system.",
             "djiwaypointv2error",
             "the waypoint mission is interrupted because of radius limit.",
             "djiwaypointv2error",
             "the waypoint mission is interrupted because of height limit.",
             "djiwaypointv2error",
             "the waypoint mission is interrupted because of rtk week signal.",
             "djiwaypointv2error",
             "the waypoint mission is interrupted because of user request.",
             "djiwaypointv2error",
             "command cannot execute.",
             "djiwaypointv2error",
             "command execution failed.",
             "djiwaypointv2error",
             "invalid parameters.",
             "djiwaypointv2error",
             "common timeout.",
             "djiwaypointv2error",
             "product connection failed.",
             "djiwaypointv2error",
             "system busy.",
             "djiwaypointv2error",
             "operation cancel by user.",
             "djiwaypointv2error",
             "upload media file failed.",
             "djiwaypointv2error",
             "sdr reserve failed.",
             "djiwaypointv2error",
             "check photo storage pack error.",
             "djiwaypointv2error",
             "sdr link reserve failed because motor is on.",
             "djiwaypointv2error",
             "the action actuator and the trigger type do not match.",
             "djiwaypointv2error",
             "the trajectory replay's location is invalid.",
             "djiwaypointv2error",
             "the trajectory replay has no waypoint to remove.",
             "djiwaypointv2error",
             "the trajectory replay's gimbal attitude has error.",
             "djiwaypointv2error",
             "data transmission does not match protocols.",
             "djiwaypointv2error",
             "invalid floating number.",
             "djiwaypointv2error",
             "last waypoint index is invalid.",
             "djiwaypointv2error",
             "invalid waypoint index, please check your waypoint index with waypoint count.",
             "djiwaypointv2error",
             "the upload waypoint start index isn't in the given range.",
             "djiwaypointv2error",
             "the aircraft start waypoint is too far away from the stop waypoint.",
             "djiwaypointv2error",
             "invalid pause resume operation.",
             "djiwaypointv2error",
             "invalid interrupt recover operation.",
             "djiwaypointv2error",
             "the mission is already paused.",
             "djiwaypointv2error",
             "the mission cannot resume because it is not running.",
             "djiwaypointv2error",
             "the mission cannot be paused or resumed now.",
             "djiwaypointv2error",
             "the mission cannot be interrupted or recovered now.",
             "djiwaypointv2error",
             "no recorded waypoint for recovery currently.",
             "djiwaypointv2error",
             "no recorded waypoint for next waypoint recovery.",
             "djiwaypointv2error",
             "uploaded reach trigger invalid.",
             "djiwaypointv2error",
             "uploaded reach trigger invalid.",
             "djiwaypointv2error",
             "uploaded reach trigger invalid.",
             "djiwaypointv2error",
             "uploaded spray actuator is invalid.",
             "djiwaypointv2error",
             "uploaded spray actuator is invalid.",
             "djiwaypointv2error",
             "uploaded spray actuator is invalid.",
             "djiwaypointv2error",
             "uploaded payload actuator is invalid.",
             "getdjierror",
             "returns the specific error in djiairlinkerror according to the error code.  @param ccode error code.  @return the djierror object.",
             "image_transmitter_cannot_set_parameters_in_this_state",
             "cannot set the parameters in this state.",
             "get_smart_battery_info_failed",
             "get smart battery failure information. this error is returned by functions when retrieving failure information for the djiphantombattery and djiaircraftbattery, including:  public void getsmartbatteryresttimeforall(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryneedtimeforgohome(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryneedtimeforland(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatterygohomebatterylevel(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatterylandbatterylevel(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryradiusforgohome(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryrequestgohomeflag(djismartbatteryexecuteresultcallback mcallback)",
             "update_wrong",
             "the update process is wrong.",
             "getdjierror",
             "returns the specific error in djiremotecontrollererror according to the error code.  @param ccode error code.  @return a djierror instance of the specific error.",
             "firmware_non_sequence",
             "the sequence number of the firmware is not continuous.",
             "firmware_length_wrong",
             "the file size of the firmware is wrong.",
             "firmware_crc_wrong",
             "the check number of the firmware is wrong.",
             "flash_clear_wrong",
             "the clear action of the flash is wrong.",
             "flash_write_wrong",
             "the write action of the flash is wrong.",
             "update_wrong",
             "the update process is wrong.",
             "firmware_match_error",
             "the firmware does not matched.",
             "flash_flushing",
             "the flash is flushing.",
             "owner_offline_error",
             "owner offline.",
             "device_offline_error",
             "device offline.",
             "is_owner_error",
             "is owner.",
             "device_locked_error",
             "device locked.",
             "getdjierror",
             "returns the specific error in djigimbalerror according to the error code.  @param ccode error code.  @return a djierror instance of the specific error.",
             "djigimbalerror",
             "defines all gimbal related errors.",
             "result_failed",
             "gimbal result failed.",
             "cannot_set_parameters_in_this_state",
             "cannot set the parameters in this state.",
             "dataprotectionerror",
             "the class for all errors related to data protection.",
             "cannot_add_authorization",
             "the authorization of this type of data has failed.",
             "cannot_remove_authorization",
             "the removal of this type of data's authorization has failed.",
             "no_hardware_info_authorization",
             "sdk does not have authorization to access hardware information.",
             "not_enough_authorization",
             "sdk does not have authorization to access some privacy related information.",
             "registration_success",
             "api key successfully registered.",
             "djiflighthuberror",
             "dji sdk flighthub error.",
             "djirtknetworkserviceerror",
             "errors related to rtk network services.",
             "djiaccessoryaggregationerror",
             "errors related to accessories on the aircraft (e.g. spotlights, speakers).",
             "djiaccesslockererror",
             "errors related to the access locker.",
             "djipayloaderror",
             "errors related to the payload.",
             "djiutmisserror",
             "errors related to the utmiss.",
             "djildmerror",
             "errors related to the ldm.",
             "djiupgradeerror",
             "errors related to the upgrade.",
             "djiwaypointv2error",
             "errors related to the payload.",
             "djisdkerror",
             "dji sdk error.",
             "djisdkcacheerror",
             "class that handles all errors about sdk cache.",
             "cannot_pause_stabilization",
             "the execution could not be performed.",
             "common_system_busy",
             "the system is too busy to execute the action.",
             "common_unknown",
             "catch all for various errors.",
             "common_data_error",
             "data error. shown as n/a in dji app.",
             "common_invalid_authorization_id",
             "invalid authorization id.",
             "common_undefined",
             "undefined error.  this error will be returned when the error is undefined.  public void setmulticontrolmode(boolean value,final djiexecuteresultcallback mcallback)",
             "common_timeout",
             "execution timeout.  this error will be returned when the execution times out.  public void senddatatoexternaldevice(byte[] data,final djiexecuteresultcallback mcallback)  public void setmulticontrolmode(boolean value,final djiexecuteresultcallback mcallback)",
             "common_param_illegal",
             "illegal parameters.  this error will be returned by the function for setting camera parameters in djiphantomcamera and djiinspirecamera, when illegal parameters are used.",
             "common_param_invalid",
             "invalid parameters.  this error will be returned by the function for setting camera parameters when invalid parameters are used.",
             "common_unsupported",
             "unsupported feature.  this error will be returned by the function for some special feature interface when the feature isn't supported by the device.",
             "common_disconnected",
             "disconnected error.  this error will be returned by the function for some special interface when the dji product is not connected to the mobile device.",
             "firmware_non_sequence",
             "inspire only.  the sequence number of firmware is not continuous.",
             "firmware_length_wrong",
             "the file size of the firmware is invalid.",
             "firmware_crc_wrong",
             "inspire only.  the check number of the firmware is invalid.",
             "flash_clear_wrong",
             "the clear action of the flash is invalid.",
             "flash_write_wrong",
             "the write action of the flash is invalid.",
             "update_wrong",
             "the update process is invalid.",
             "firmware_match_wrong",
             "there is a firmware match error.",
             "flash_flushing",
             "the flash is flushing.",
             "media_invalid_request_type",
             "the media download request type is invalid.",
             "media_no_such_file",
             "media download error: no such file.",
             "command_repeat",
             "execution of this process is sent repeatedly",
             "media_request_client_abort",
             "media download error: the client aborted the downloading.",
             "media_request_disconnect",
             "result of media downloading: the downloading link disconnects.",
             "image_transmitter_invalid_parameter",
             "the input parameters is out of bound or invalid.",
             "command_not_supported_by_firmware",
             "the command is not supported by the current firmware version.",
             "command_not_supported_by_hardware",
             "the command is not supported by the current hardware version.",
             "unable_to_get_firmware_version",
             "unable to get the firmware version. note: the sdk gets the firmware version table from the server. ensure internet connectivity before you invoke getversion().",
             "unable_to_get_flags",
             "unable to get the analytics flags from server. note: ensure internet connectivity before you invoke this method.",
             "unable_to_get_flag_but_retry",
             "unable to get the analytics flags from server, but retrying.",
             "set_param_failed",
             "set param failed.",
             "battery_pair_failed",
             "unable to pair the batteries.",
             "battery_get_smart_battery_info_failed",
             "get smart battery information failed.  this error will be returned by the functions for getting information in djiphantombattery and djiaircraftbattery when the request to get information failed.  public void getsmartbatteryresttimeforall(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryneedtimeforgohome(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryneedtimeforland(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatterygohomebatterylevel(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatterylandbatterylevel(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryradiusforgohome(djismartbatteryexecuteresultcallback mcallback)  public void getsmartbatteryrequestgohomeflag(djismartbatteryexecuteresultcallback mcallback)",
             "no_network",
             "no network access.",
             "database_is_not_ready",
             "database is not ready.",
             "area_code_not_same",
             "the set area code is inconsistent with the local area code.",
             "djicameraerror",
             "defines all camera-related errors.",
             "djiflightcontrollererror",
             "defines all flight controller errors.",
             "djimissionerror",
             "defines all mission manager related errors.",
             "djiairlinkerror",
             "defines all airlink related errors.",
             "djibatteryerror",
             "defines all battery related errors.",
             "djiflysafeerror",
             "this class contains the error type for geo feature.",
             "djiremotecontrollererror",
             "defines all remote controller related errors.",
             "registration_aesencrypt_failed",
             "server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
             "registration_aesencrypt_error",
             "server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
             "registration_invalid_uuid",
             "server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
             "media_request_server_abort",
             "media download error: the server aborted the downloading.",
             "stick",
             "constructor of the stick object.  @param horizontalposition stick's horizontal position value, the value it's in the range of [-660, 660]. @param verticalposition stick's vertical position value, the value it's in the range of [-660, 660].",
             "gethorizontalposition",
             "get the stick's horizontal position value, the value it's in the range of [-660, 660].  @return an int value.",
             "getverticalposition",
             "get the stick's vertical position value, the value it's in the range of [-660, 660].  @return an int value.",
             "gettype",
             "gets diagnostics type.  @return an enum value of `djidiagnosticstype`.",
             "getcode",
             "get diagnostics error code.  @return diagnostics error code.",
             "getreason",
             "the reason of the error.  @return reason of the error.",
             "getsolution",
             "the suggested solution for the error.  @return the suggest solution for the error.",
             "gethealthinformation",
             "the device healthy information, only available when the component is djidi agnostics_djidiagnosticswarningcomponent_devicehealthinformation</code>.  @return an object of `devicehealthinformation`.",
             "camera_upgrade_error",
             "camera upgrade error.",
             "camera_sensor_error",
             "camera sensor error.",
             "camera_over_heat",
             "camera is overheated.",
             "camera_encryption_error",
             "camera encryption error.",
             "camera_no_sd_card",
             "no sd card.",
             "camera_sd_card_error",
             "sd card error. for more detail, please refer to the reason and the solution.",
             "camera_sd_card_no_space",
             "remaining sd card capacity is not enough.",
             "camera_sd_card_full",
             "sd card is full.",
             "camera_sd_card_read_only",
             "sd card is readonly.",
             "camera_sd_card_not_formatted",
             "sd card not formatted.",
             "camera_chip_over_heat",
             "chip over heat.",
             "camera_temperaturestoohightostoprecord",
             "temperatures too high to stop record.",
             "gimbal_gyroscope_error",
             "gimbal gyroscope error.",
             "gimbal_pitch_error",
             "gimbal pitch error.",
             "gimbal_roll_error",
             "gimbal roll error.",
             "gimbal_yaw_error",
             "gimbal yaw error.",
             "gimbal_connect_to_fc_error",
             "gimbal cannot receive flight controller data.",
             "battery_discharge_over_current",
             "battery current too high during discharge.",
             "battery_discharge_over_heat",
             "battery too hot during discharge.",
             "battery_low_temperature",
             "low temperature environment: battery not suitable for flight.",
             "battery_cell_broken",
             "battery cell is broken.",
             "battery_need_study",
             "battery needs a complete charge and discharge cycle.",
             "battery_illegal",
             "battery is not a dji battery.",
             "single_battery_mode",
             "battery is in single battery mode.",
             "fake_battery_mode",
             "battery is in fake battery mode.",
             "battery_cycle_time_over",
             "battery's cycle times is over",
             "battery_diff_usage",
             "old battery and new battery.",
             "battery_over_load",
             "overload.",
             "battery_low_voltage",
             "battery voltage is low.",
             "battery_dangerous_warning_serious",
             "dangerous warning serious.",
             "battery_communication_fail",
             "battery communication failed.",
             "battery_short_cut",
             "battery short-circuit.",
             "remote_controller_fpga_error",
             "rc fpga error.",
             "remote_controller_transmitter_error",
             "rc transmitter error.",
             "remote_controller_battery_error",
             "rc battery error.",
             "remote_controller_gps_error",
             "rc gps error.",
             "remote_controller_encryption_error",
             "rc encryption error.",
             "remote_controller_need_calibration",
             "rc is not calibrated.",
             "remote_controller_battery_low",
             "rc battery low.",
             "remote_controller_idle_too_long",
             "rc idle for too long.",
             "remote_controller_reset",
             "rc is reset, please check rc settings",
             "remote_controller_over_heat",
             "rc overheated.",
             "central_board_connect_to_battery_error",
             "battery connection to the center board has failed.",
             "central_board_connect_to_gps_error",
             "gps connection to the center board has failed.",
             "central_board_connect_to_fc_error",
             "flight controller connection to the center board has failed.",
             "video_decoder_encryption_error",
             "video decoder encryption error.",
             "video_decoder_connect_to_deserializer_error",
             "deserializer disconnected.",
             "air_encoder_error",
             "aircraft encoder error.",
             "air_encoder_upgrade",
             "aircraft updating.",
             "air_link_no_signal",
             "no signal.",
             "air_link_low_rc_signal",
             "low rc signal.",
             "air_link_strong_rc_radio_signal_noise",
             "strong rc radio signal noise.",
             "air_link_low_radio_signal",
             "low radio signal.",
             "air_link_strong_radio_signal_noise",
             "strong radio signal noise.",
             "air_link_wifi_magnetic_interference_high",
             "wifi magnetic interference high.",
             "flight_controller_imu_need_calibration",
             "imu calibration required.",
             "flight_controller_imu_calibration_incomplete",
             "imu calibration incomplete.",
             "flight_controller_imu_data_error",
             "imu data error.",
             "flight_controller_imu_error",
             "general imu error.",
             "flight_controller_imu_init_failed",
             "imu initialization failed.",
             "flight_controller_barometer_init_failed",
             "barometer initialization failed.",
             "flight_controller_barometer_error",
             "barometer error.",
             "flight_controller_accelerometer_init_failed",
             "accelerometer failed.",
             "flight_controller_gyroscope_error",
             "gyroscope error.",
             "flight_controller_attitude_error",
             "aircraft attitude angle is too large.",
             "flight_controller_data_record_error",
             "data recorder errors.",
             "flight_controller_takeoff_failed",
             "take-off failure.",
             "flight_controller_system_error",
             "unknown flight controller error.",
             "flight_controller_imu_heating",
             "imu is heating.",
             "flight_controller_compass_need_restart",
             "compass needs restart.",
             "flight_controller_compass_abnormal",
             "compass abnormal.",
             "flight_controller_using_wrong_propellers",
             "using the wrong propellers. inspire 2 has propellers for high altitudes and low altitudes. this error will be present when the wrong propellers are being used at the wrong altitude.",
             "vision_system_need_calibration",
             "vision system calibration is required.",
             "vision_propeller_guard",
             "propeller guard mounted.",
             "vision_sensor_error",
             "vision sensor error.",
             "vision_sensor_calibration_error",
             "vision sensor calibration error.",
             "vision_sensor_communication_error",
             "vision sensor communication error.",
             "vision_system_error",
             "vision system error.",
             "gimbal_locate_error",
             "gimbal locate error.",
             "rtk_positioning_error",
             "rtk positioning error.",
             "rtk_orienteering_error",
             "rtk orienteering error.",
             "vision_weak_ambient_light",
             "weak ambient light error.",
             "flight_controller_mc_reading_data",
             "mc is reading flight data.",
             "flight_controller_mc_data_error",
             "mc data error.",
             "flight_controller_battery_not_in_position",
             "not in position error.",
             "flight_controller_not_enough_force",
             "aircraft has not enough force.",
             "remote_controller_go_home_fail",
             "go home failed.",
             "flight_controller_out_of_control_going_home",
             "remote controller out of controller, except when aircraft go home.",
             "flight_controller_gps_error",
             "aircraft gps error.",
             "flight_controller_compass_install_error",
             "compass install error.",
             "flight_controller_only_support_atti_mode",
             "only support atti mode.",
             "flight_controller_water_surface_warning",
             "water surface warning.",
             "flight_controller_kernel_board_high_temperature",
             "kernel board high temperature.",
             "flight_controller_enable_near_ground_alert",
             "enable near ground alert.",
             "flight_controller_heading_control_abnormal",
             "heading control abnormal.",
             "flight_controller_tilt_control_abnormal",
             "tilt control abnormal.",
             "flight_controller_aircraft_vibration_abnormal",
             "aircraft vibration abnormal.",
             "flight_controller_paddle_has_ice_on_it",
             "paddle has ice on it.",
             "flight_controller_gps_signal_blocked_by_gimbal",
             "gps signal blocked by gimbal.",
             "flight_controller_motor_blocked",
             "motor blocked.",
             "flight_controller_smart_low_power_go_home",
             "smart low power go home.",
             "flight_controller_over_heat_go_home",
             "over heat go home.",
             "flight_controller_out_of_flight_radius_limit",
             "out of flight radius limit.",
             "flight_controller_low_voltage_going_home",
             "low voltage goinghome.",
             "flight_controller_low_voltage_landing",
             "low voltage landing.",
             "flight_controller_height_limit_move_to_open_field",
             "gps initialization, the flying altitude is limited.",
             "product_aircraft_disconnected",
             "aircraft is disconnected.",
             "product_rc_disconnected",
             "remote controller is disconnected.",
             "camera_chip_over_heat_stop_record_warning",
             "chip over heat warning.",
             "air_link_chips_temperature_warning",
             "chip temperature warning.",
             "air_link_chips_temperature_dangererous",
             "chip temperature dangerous.",
             "air_link_chips_temperature_warning_in_air",
             "chip temperature warning.",
             "air_link_chips_temperature_dangererous_in_air",
             "chip temperature dangerous.",
             "flight_controller_motor_start_error",
             "motor start error.",
             "flight_controller_no_propeller",
             "aircraft propeller damage.",
             "flight_controller_motor_stop_reason",
             "motor stop error.",
             "flight_controller_forbid_side_fly_error",
             "in apas mode the forbid side fly switch is turned on, cannot fly sideways.",
             "camera_abnormal_reboot",
             "abnormal reboot.",
             "flight_controller_aircraft_normal_flight_atti",
             "aircraft in attitude mode. unable to hover.",
             "flight_controller_motor_power_abnormal_need_check",
             "the motor power is abnormal, and the propeller needs to be checked.",
             "flight_controller_flight_action_fly_limit_zone_landing",
             "aircraft is in the no fly zone and can't fly.",
             "flight_controller_height_limit_reason_no_gps",
             "height limit reason no gps.",
             "flight_controller_height_limit_reason_compass_interrupt",
             "height limit reason compass interrupt.",
             "flight_controller_env_state_temp_too_high",
             "env state temp too high.",
             "flight_controller_env_state_temp_too_low",
             "env state temp too low.",
             "flight_controller_cover_flight_enable_limit",
             "cover flight enable limit.",
             "flight_controller_motor_stop_for_esc_short_circuit",
             "motor stop for esc short circuit.",
             "flight_controller_no_real_name_height_limit",
             "no real name height limit.",
             "flight_controller_three_propeller_emergency_landing",
             "three propeller emergency landing.",
             "flight_controller_landing_protection",
             "landing protection.",
             "flight_controller_aircraft_propulsion_system_error",
             "aircraft propulsion system error.",
             "flight_controller_strong_gale_warning",
             "strong gale warning.",
             "djidiagnosticserror",
             "djidiagnosticserror.",
             "djidiagnosticstype",
             "diagnostics components type.",
             "battery",
             "battery component.",
             "camera",
             "camera component.",
             "center_board",
             "center board component.",
             "on_screen_display",
             "components' error often shown on the main screen.",
             "flight_controller",
             "flight controller component.",
             "gimbal",
             "gimbal component.",
             "lightbridge",
             "lightbridge component.",
             "remote_controller",
             "remote controller component.",
             "vision",
             "vision component.",
             "rtk",
             "rtk component.",
             "device_health_information",
             "device health information. only supported by some components of matrice 300 rtk and zenmuse h20 series. it is recommended to use device health information to replace old diagnostics for flight controller and rtk. there will be a few duplicated component error for gimbal, battery, perception module on matrice 300 rtk. find error code and detailed description information in the readme file on github (https://github.com/dji-sdk/mobile-sdk-android/blob/master/readme.md)",
             "other",
             "other.",
             "warninglevel",
             "warning level for components' health information.",
             "none",
             "no warning.",
             "notice",
             "device health information notice.",
             "caution",
             "warning message. fly with caution.",
             "warning",
             "warning message.",
             "serious_warning",
             "serious warning message.",
             "unknown",
             "unknown.",
             "diagnosticsinformationcallback",
             "callback interface that updates the product's current diagnostics information.",
             "onupdate",
             "callback interface that updates the product's current diagnostics information.  @param diagnosticslist the list of `djidiagnostics` instance.",
             "devicehealthinformation",
             "product diagnostics device healthy information. only supported by some components of matrice 300 rtk and zenmuse h20 series. it is recommended to use device health information to replace old diagnostics for flight controller and rtk. there will be a few duplicated component error for gimbal, battery, perception module on matrice 300 rtk. find error code and detailed description on github (https://github.com/dji-sdk/mobile-sdk-android).",
             "informationid",
             "a unique code. you can find the detailed information at github (https://github.com/dji-sdk/mobile-sdk-android).  @return a long value of the information id.",
             "sensorindex",
             "sensor index of a certain device module.  @return an int value of the sensor index.",
             "componentid",
             "added for double camera and double gimbal, this method could return the index of component.  @return an int value of the component id.",
             "getwarninglevel",
             "warning level.  @return an enum value of `warninglevel`.",
             "getbasestationreferencinglocation",
             "gets the referencing location manually configured to the  base station. when a user can get a more accurate  location (coordinate with less absolute error) of the base  station by using external tools, the accurate location can  be set to the base station to improve the accuracy of the  aircraft location. if the offset between the referencing  location and the location detected by the ground system is  larger than 5 meters, the base station will ignore the referencing location. it is only supported by phantom 4 rtk and m200 series v2 and matrice 300 rtk.  @param callback completion block that receives the execution result.",
             "setbasestationreferencinglocation",
             "sets the referencing location of the base station to improve the accuracy.  when a user  can get a more accurate location (coordinate with less absolute error) of the base station  by using external tools, the accurate location can be set to the  base station to improve  the accuracy of the aircraft location. if the offset between  the referencing location and  the location detected by the base station is larger than  5 meters, the base station will ignore the referencing location. it is only supported  by phantom 4 rtk and m200 series v2 and matrice 300 rtk. for matrice 300 rtk, device  administrator authentication is required before invoking this method.  @param location the referencing location of the base station. @param callback completion block that receives the execution result.",
             "resetbasestationreferencinglocation",
             "reset rtk base station's location. this will make base station's location type became `auto`. the previously set location  by `setbasestationreferencinglocation` will be invalid. for matrice 300 rtk, device administrator authentication is required before invoking this method.  @param callback callback that receives the execution result.",
             "hasdeviceadminloggedin",
             "`true` if device administrator has logged in. for matrice 300 rtk, device administrator authentication is required before  changing any settings, including base station's name, base station's password, and base station's referencing location.  device administrator login is required every time when the application is relaunched. please login with default password  123456, if the base station's password is reset. supported only by matrice 300 rtk.  @return the result whether login or not.",
             "loginasdeviceadmin",
             "log in as base station administrator account with password to change setting. user will need to login again in the following scenarios:  -  enter the application for the first time.  - re-enter after the application restarts.  - reset password via the button on the base  station.  - switch and connect other base stations.  the default password is `123456`. it is only supported by matrice 300 rtk.  @param password the password of base station. @param callback the completion callback block that receives the result.",
             "logout",
             "log out of the base station. it is only supported by matrice 300 rtk.  @param callback completion block that receives the execution result.",
             "changepassword",
             "change the password for current base station. the password must be 6 digits. it is only supported by matrice 300 rtk.  @param oldpassword the old password. @param newpassword the new password that you want to change. @param callback the completion callback that receives the result.",
             "setname",
             "change the name of the base station. the name is composed of maximum 4 characters or numbers.  please log in before invoking this method. it is only supported by matrice 300 rtk.  @param name the name of the base station set by the user. @param callback completion block that receives the execution result.",
             "getname",
             "gets the name of the base station. please log in before invoking this method. it is only supported by matrice 300 rtk.  @param callback completion block that receives the execution result.",
             "addbasestationbatterystateupdatedcallback",
             "adds a callback to receive the latest base station battery state. only supported by phantom  4 rtk and m200 series v2.  @param callback callback to receive base station battery state.",
             "removebasestationbatterystateupdatedcallback",
             "removes a callback that receives the latest base station battery state. only supported by  phantom 4 rtk and m200 series v2.  @param callback callback to receive base station battery state.",
             "addbasestationstateupdatedcallback",
             "adds a callback to receive the latest base station state. only supported by phantom 4 rtk and m200 series v2.  @param callback callback to receive base station state.",
             "removebasestationstateupdatedcallback",
             "removes a callback that receives the latest base station state.  @param callback callback to receive base station state.",
             "basestationlocationtype",
             "all the possible basestation location type of `basestationlocationtype`.",
             "auto",
             "basestation current location is auto calculateed by basestation itself.",
             "manual",
             "basestation current location is manually set by user.",
             "unknown",
             "unknown basestation location type.",
             "basestationbatterystate",
             "rtk base station current battery state.",
             "getvoltage",
             "returns the current rtk base station battery voltage (mv).  @return an int value of the current rtk base station battery voltage.",
             "getcurrent",
             "returns the real time current draw of the rtk base station battery (ma).  @return an int value of the current draw of the rtk base station battery.",
             "gettemperature",
             "returns the current rtk base station battery's temperature, in celsius, with range [-128, 127] degrees.  @return a float value of the current rtk base station battery's temperature.",
             "getcapacitypercent",
             "returns the battery's remaining lifetime as a percentage, with range [0, 100]. a new battery will be close  to 100%. as a battery experiences charge/discharge cycles, the value will go down.  @return an int value of the battery's remaining lifetime as a percentage.",
             "basestationstate",
             "rtk base station current state.",
             "isallowedtouse",
             "gets if the base station is allowed to use in current country.  @return a boolean value.",
             "getbasestationlocationtype",
             "gets rtk basestation location type. see `basestationlocationtype`.  @return an enum value of `basestationlocationtype`.",
             "callback",
             "callback interface for rtk base station state.",
             "onupdatebasestationstate",
             "callback function that updates the rtk base station state. only supported  by phantom 4 rtk and m200 series v2. this is only available on d-rtk 2 with firmware version v01.00.0300 or above.  @param basestationstate base station state.",
             "callback",
             "callback interface for rtk base station battery state.",
             "onupdatebasestationbatterystate",
             "callback function that updates the rtk base station battery state. only supported by phantom 4 rtk and m200 series v2.  @param state base station battery state.",
             "getinstance",
             "accessor for `rtknetworkserviceprovider` object.  @return an instance of the `rtknetworkserviceprovider` object.",
             "setcustomnetworksettings",
             "sets the configuration for the network service that provides network reference stations.  the network service should use ntrip (networked transport of rtcm via internet protocol).  @param settings the configuration to set.",
             "getcustomnetworksettings",
             "gets the configuration for the network service that provides network reference stations.  the network service should use ntrip(networked transport of rtcm via internet protocol).  @return an instance of `networkservicesettings`.",
             "startnetworkservice",
             "starts the network service as the reference station. this should be called after setting the  network service (`setcustomnetworksettings`).  @param callback the completion block that receives the result.",
             "startnetworkservice",
             "starts the network service as the reference station. this should be called after setting the  network service (`setcustomnetworksettings`).  @param coordinatesystem the coordinatesystem to set when init rtk service @param callback the completion block that receives the result.",
             "stopnetworkservice",
             "stops the network service.  @param callback the completion block that receives the result.",
             "addnetworkservicestatecallback",
             "adds a listener to receive the latest network service state.  @param callback the completion block that receives the result.",
             "removenetworkservicestatecallback",
             "removes a listener that is added by passing to `addnetworkservicestatecallback`.  @param callback the completion block that receives the result.",
             "setnetworkservicecoordinatesystem",
             "sets coordinate system for rtk network service. only can be used when  current `referencestationsource` is `network_rtk`,  and please make sure the `getchannelstate` is `transmitting`.  @param coordinatesystem the `djirtk_djirtknetworkservicecoordinatesystem` to set. @param callback the completion block that receives the result.",
             "getnetworkservicecoordinatesystem",
             "gets current network rtk coordinate system. only can be used when  current `referencestationsource` is `network_rtk`.  @param callback the execution callback with the returned value(s).",
             "activatenetworkservice",
             "activates network rtk `activatenetworkservice`.  @param plantype plan type to activate. @param callback the completion block that receives the result.",
             "getnetworkserviceorderplans",
             "gets network service plans.  @param callback the completion block that receives the result.",
             "networkservicechannelstate",
             "all the possible state of `networkservicechannelstate`.",
             "disabled",
             "the network service is not started.",
             "account_expired",
             "user account has expired.",
             "network_not_reachable",
             "the network is not reachable from the mobile device.",
             "aircraft_disconnected",
             "the aircraft is not connected.",
             "rtk_dongle_disconnected",
             "tthe rtk dongle is not connected.",
             "login_failure",
             "sdk cannot login with the provided username and password.  check `geterror`.",
             "transmitting",
             "data is transmitting through the channel.",
             "disconnected",
             "the channel is disconnected and the server is not reachable now. check `geterror`.",
             "account_error",
             "user account error. check `geterror`.",
             "server_not_reachable",
             "unable to connect to server.",
             "connecting",
             "connecting to server.",
             "service_suspension",
             "the account for network rtk plan a has been expired, please activate plan b.",
             "invalid_request",
             "the invalid request is rejected by the server.",
             "unknown",
             "unknown.",
             "networkservicestate",
             "the state of network service that provides reference station information.",
             "getchannelstate",
             "the state of the channel from the aircraft to the server that provides rtk network service.  @return the enum value of `networkservicechannelstate`.",
             "geterror",
             "the encountered error if any when building up the channel from the aircraft to the server  that provides rtk network service.  @return the object of `djirtknetworkserviceerror`.",
             "callback",
             "callback that receives the network service state.",
             "onnetworkservicestateupdate",
             "called when the network service state has been updated.  @param networkservicestate the state of the network service.",
             "networkserviceplan",
             "network service plan information.",
             "getplanstate",
             "gets network rtk plan state.  @return an enum value of `networkserviceplanstate`.",
             "getactivationdate",
             "gets network rtk plan activation date.  @return a string value of activation date.",
             "getexpirationdate",
             "gets network rtk plan expiration date.  @return a string value of expiration date.",
             "getplanname",
             "gets network rtk plan type.  @return a enum value of `networkserviceplantype`.",
             "networkserviceplansstate",
             "gets state of network service plans.",
             "getstate",
             "gets current account state.  @return an enum value of `networkserviceaccountstate`.",
             "getsupportedrenewaltimes",
             "gets current account supported renewal times.  @return an int value.",
             "getplans",
             "gets network rtk plans.  @return an enum value of `networkserviceaccountstate`.",
             "builder",
             "the class is used to build a `networkserviceplansstate` instance.",
             "state",
             "sets current account state.  @param state an enum value of `networkserviceaccountstate`.  @return a builder instance.",
             "supportedrenewaltimes",
             "sets network rtk supported renewal times.  @param supportedrenewaltimes an int value.  @return a builder instance.",
             "plans",
             "sets network rtk plans.  @param plans a list of `networkserviceplan`.  @return a builder instance.",
             "build",
             "builds an instance of `networkserviceplansstate`.  @return an instance of `networkserviceplansstate`.",
             "rtkbasestationinformation",
             "the class is used to save the information of the base station. only supported by matrice 300 rtk series.",
             "getbasestationid",
             "gets the scanned base station's id.  @return a long value of the base station id.",
             "getbasestationname",
             "gets the scanned base station's name.  @return a string value.",
             "getsignallevel",
             "gets the signal level of the base station. the signal is in range [0, 5], where 5 is the strongest signal.  @return an int value.",
             "rtkconnectionstatewithbasestationreferencesource",
             "all the possible connection state of djirtkconnectionstatewithbasestationreferencesource  when `referencestationsource`  is  `base_station`.  it is only supported by matrice 300 rtk.",
             "idle",
             "aircraft rtk is in idle state.",
             "scanning",
             "aircraft is scanning all base stations that are possible to be connected.",
             "connecting",
             "the aircraft is connecting with the base station.",
             "connected",
             "the aircraft is connected with the base station.",
             "disconnected",
             "the aircraft is disconnected from the base station.",
             "unknown",
             "unknown base station location connection state.",
             "networkservicesettings",
             "settings for the network service that provides rtk reference station information.",
             "getserveraddress",
             "the ip address or the domain name of the server that provides rtk network services.  @return a string value of the ip address or the domain name of the server.",
             "getport",
             "the port number that sdk should connect to.  @return the int value of port number.",
             "getusername",
             "user name to access the network service.  @return string value of the account user name.",
             "getpassword",
             "password to access the network service.  @return string value of the account password.",
             "getmountpoint",
             "mountpoint of the network service, which is a source id for every streamed ntripsource.  @return string value of the mountpoint.",
             "builder",
             "the class is used to build a `networkservicesettings` instance.",
             "getappactivationstate",
             "current app activation state.  @return an enum value of `appactivationstate`.",
             "getaircraftbindingstate",
             "current aircraft binding state. users in china need to bind additional account details with  the aircraft one-time through dji go. these details need to be bound and the application  needs to be activated by logging into their dji go account to lift the flight restrictions.  @return an enum value of `aircraftbindingstate`.",
             "addaircraftbindingstatelistener",
             "add the aircraft binding state listener.  @param listener a listener of `aircraftbindingstatelistener`.",
             "addappactivationstatelistener",
             "add listener for the app activation state update.  @param listener a listener of `appactivationstatelistener`.",
             "removeaircraftbindingstatelistener",
             "remove the aircraft binding state listener.  @param listener a listener of `aircraftbindingstatelistener`.",
             "removeappactivationstatelistener",
             "remove activation state listener.  @param listener a listener of `appactivationstatelistener`.",
             "aircraftbindingstate",
             "the aircraft's binding state.",
             "initial",
             "the binding state of the aircraft is not yet determined. the aircraft will only be in this  state until dji go or a dji mobile sdk based application rights the binding information to  the aircraft. binding is only required if the user is in china. if the user is not in china,  then this state will become `not_required` after the  country code check is complete. if country code check has been disabled, the user will need  to use dji go to move to the `not_required` state. in  this state, the aircraft will have the 30m height and 50m radius limitation.",
             "unbound",
             "the aircraft is not currently bound, and needs to be (as it is in china). in this state, the  aircraft will have 30m max flight height and 50m max flight distance limitation. user should  finish the one-off binding process with dji go to remove the flight limitation.",
             "unbound_but_cannot_sync",
             "the aircraft is flying inside china and is unbound. the aircraft can be bound using dji go.  if dji go is connected to the aircraft, then the binding will be stored in the aircraft. if  dji go is not connected to the aircraft during the binding process, then the binding result  will be stored on a server. the sdk can query this server to see if the binding has already  happened, and if it has, download the binding to the aircraft. however, if the aircraft is  unbound, and the server is not reachable, then this state will be presented. the user should  connect the mobile device to the internet to refresh this state.",
             "bound",
             "the aircraft is bound.",
             "not_required",
             "the aircraft is not bound but it is not currently located in china. therefore, binding the aircraft is not required.",
             "not_supported",
             "the aircraft's firmware does not support the app activation system.",
             "unknown",
             "either the aircraft is disconnected or the connected product is not a dji aircraft.",
             "appactivationstate",
             "the app activation state.",
             "not_supported",
             "the aircraft's firmware does not support the app activation system.",
             "login_required",
             "the application needs to be activated by the user through their dji account. use `useraccountmanager` to enable the user to log in. log in is only required if the  aircraft is located in china.",
             "activated",
             "the application is activated and flight restrictions turned off.",
             "unknown",
             "either the aircraft is disconnected or the connected product is not a dji aircraft.",
             "aircraftbindingstatelistener",
             "an interface for obtaining `aircraftbindingstate`.",
             "appactivationstatelistener",
             "an interface for obtaining `appactivationstate`.",
             "onupdate",
             "called when the app activation state changes.  @param state the app activation state. use this state to check if login is required to  unrestrict the flight limitation.",
             "onupdate",
             "called when the app activation manager updates the aircraft binding state.  @param state the aircraft binding state. use this state to check if it is required to use  dji go to bind the aircraft.",
             "getwidgettype",
             "get the type of the widget. different types have different type of values.  @return the type of the payload widget.",
             "getwidgetindex",
             "get the index of the widget. an index is used to differentiate widgets of the same type.  @return the index of the payload widget, same type of widgets must have different index.",
             "getwidgetvalue",
             "get the value of the payload widget.  @return the value of the payload widget, the widget of input type will return an int value of 0(normal) or 1(pressed), switch  type will return a int value of 0(switch off) or 1(switch on), range type will return a int value from 0 to 100 (inclusive),  list type will return a int value from 0 to n (n is determined by firmware), input type will return any int value which is set previously.",
             "getname",
             "get the name of the widget. this is determined by the payload device and not configurable  through the mobile device.  @return the name of the payload widget.",
             "gethintmsg",
             "get the hint message of the payload widget.  @return the hint message of the payload widget, input type of widget might has a hint message which describe the function of the widget.",
             "getsubitems",
             "get the sub items list of the payload widget.  @return the sub items list of the payload widget, list type widget could return the sub items, which describe the options or different functions  related with the widget value, for example, if the widget has a list of sub items with size of 5, then the widget could accept the  widget value between 0 to 4 (inclusive), the string with index of 0 will describe the function if the widget value of 0 is set.",
             "payloadwidget",
             "common widget information.  @param widgettype an enum value of `payloadwidgettype`. @param widgetindex the widget index. @param widgetvalue the value of the widget. @param name the widget name.",
             "payloadwidget",
             "common widget information with message hint.  @param widgettype an enum value of `payloadwidgettype`. @param widgetindex the widget index. @param widgetvalue the value of the widget. @param name the widget name. @param hintmsg a hint message string.",
             "payloadwidget",
             "list widget information with the sub items.  @param widgettype an enum value of `payloadwidgettype`. @param widgetindex the widget index. @param widgetvalue the value of the widget. @param name the widget name. @param subitems a list of sub items strings.",
             "payloadwidget",
             "list widget information with the sub items and message hint.  @param widgettype an enum value of `payloadwidgettype`. @param widgetindex the widget index. @param widgetvalue the value of the widget. @param name the widget name. @param hintmsg a hint message string. @param subitems a list of sub items strings.",
             "payloadwidgettype",
             "types of widgets on the payload device.",
             "unknown",
             "other unknown widget type.",
             "button",
             "button, button widget could return the widget value of 1 or 0, normally it's widget value is 0, when  the button is being pressed the widget value will change to 1.",
             "switch",
             "switch, switch widget could return the widget value of 1 or 0, when the switch is changed  to on state, the widget value will change to 1, if the switch is changed to off state,  the widget value will change to 0.",
             "range",
             "range, range widget could return the widget value between 0 - 100 (inclusive).",
             "list",
             "list, list widget could return the int value between 0 and n, n is determined by the firmware,  the size of sub items returned by getsubitems() method in payloadwidget will be n+1",
             "input",
             "input widget could be set with any int value, the default value is determined by the firmware.",
             "payloadwidgetlistener",
             "payload widgets listener.",
             "onupdate",
             "updates a set of payload widgets.  @param widgets the updated value for widgets.",
             "payloadwidgetdownloadlistener",
             "payload widget download listener.",
             "onprogress",
             "called when fetching widget data is in progress.  @param process the value is from 0 to 100.",
             "onsuccess",
             "called when fetching widget data successful.",
             "onfailure",
             "called when the payload file download failed.  @param error the error information.",
             "destroycodec",
             "destroys the media codec.",
             "djicodecmanager",
             "constructor for the class.  @param context the context. @param surfacetexture the surface texture view. @param width the width of surface texture view. @param height the height of surface texture view.",
             "djicodecmanager",
             "constructor for the class.  @param context the context. @param surfaceholder the surface view. @param width the width of surface texture view. @param height the height of surface texture view.",
             "cleansurface",
             "cleans the surface from the codec manager.",
             "switchsource",
             "switches the video source of the decoder.  @param source the new video source.",
             "isdecoderok",
             "determines whether the decoding status is normal.  @return `true` if the decoding status is normal, false otherwise.",
             "senddatatodecoder",
             "sends h264 raw video data to the decoder.  @param videobuffer the video buffer data. @param size the data size.",
             "senddatatodecoder",
             "sends h264 raw video data to the decoder.  @param videobuffer the video buffer data. @param size the data size. @param source the source of the data.",
             "senddatatodecoder",
             "sends h264 raw video data to the decoder with source id.  @param videobuffer the video buffer data. @param size the data size. @param source source id.",
             "getvideowidth",
             "get the video width.  @return video width integer value.",
             "getvideoheight",
             "get the video height.  @return video height integer value.",
             "onsurfacesizechanged",
             "resizes the surface when the size of the surface texture view has changed.  @param width the new width of the surface @param height the new height of the surface @param degree the new degree of the surface",
             "enabledyuvdata",
             "to enable the yuv data output to user which must set the surface  as null to avoid native buffer.  @param enabled the yuv data callback.",
             "setpeakfocusthresholdenabled",
             "enable peak focus threshold.  @param isenabled enable/disable focus threshold.",
             "setpeakfocusthreshold",
             "set the peak focus threshold value.  @param peakfocusthresholdvalue a float value representing peak focus threshold.",
             "setoverexposurewarningenabled",
             "enable or disable the over exposure warning.  @param isenabled enable/disable the over exposure warning.",
             "setcodecname",
             "set the codec name. for some mobile phones that cannot display video stream normally. you can set the codec name through this interface so that msdk can call the correct decoder for decoding and display. you can call android api:mediacodeclist to get available codec names for testing.  @param codecname ",
             "setyuvdatacallback",
             "sends yuv data from hardware decoder.  @param callback the yuv data callback.",
             "getyuvdatacallback",
             "sends yuv data from hardware decoder.  @return the yuv data callback.",
             "getyuvdata",
             "gets yuv data from hardware decoder. the obtained data of format is mediacodecinfo.codeccapabilities.color_formatyuv420planar</code> and the width and height must be even.  @param width width of the video. @param height height of the video.  @return the yuv data from the hardware decoder.",
             "getrgbadata",
             "gets rgba data from hardware decoder.  @param width width of the video. @param height height of the video.  @return the rgba data from the hardware decoder.",
             "yuvdatacallback",
             "interface for the yuv data callback.",
             "onyuvdatareceived",
             "callback method for processing the yuv frame data from hardware decoder.  only works well after `enabledyuvdata` is invoked and set as `true`.  @param format the format of yuv. @param yuvframe yuv data buffer in the codec. @param datasize size of the yuv data @param width width of the video @param height height of the video",
             "videosource",
             "the source of the video feed.",
             "camera",
             "the source of the video feed is the main camera.",
             "fpv",
             "the source of the video feed is the fpv camera.",
             "secondary_camera",
             "the source of the video feed is the secondary camera.",
             "unknown",
             "the source of the video feed is unknown.",
             "getinstance",
             "the instance of `videofeeder`.  @return an object of `videofeeder`.",
             "addphysicalsourcelistener",
             "add physical source listener.  @param listener an interface of `physicalsourcelistener`.",
             "removephysicalsourcelistener",
             "remove physical source listener.  @param listener an interface of `physicalsourcelistener`.",
             "getprimaryvideofeed",
             "the primary video feed.  the possible physical sources for the primary video feed include:  - `main_cam`  -  `lb`  -  `hdmi`  -  `left_cam`  -  `right_cam`  for m210 and m210 rtk, the  physical sources are controlled by the bandwidth allocation between the port (left) and starboard  (right) main cameras (`setbandwidthallocationforleftcamera`):  - when bandwidth  is 100% on the left camera, the primary source is  `left_cam` and the secondary source is  `fpv_cam`.  - when bandwidth is 0%  on the left camera, the primary source is `right_cam` and the secondary source is `fpv_cam`.  - when  bandwidth is neither 0% nor 100% on the left camera, the primary source is  `left_cam` and the secondary source is  `right_cam`.  for matrice 300 rtk, the physical  source can be:  `left_cam`,  `right_cam`,  `top_cam`  and  `fpv_cam`.  please note that video playback stream will be received as primary or secondary video feed, if video playback starts on zenmuse h20 series.  video feed channel could be assigned by `assignsourcetoprimarychannel` in `ocusynclink`.  @return a `videofeed` object.",
             "getsecondaryvideofeed",
             "the secondary video feed.  the possible physical sources for the secondary video feed include:  - `fpv_cam`  -  `ext`  -  `av`  - `right_cam`. for m210 and m210 rtk, the physical  sources are controlled by the bandwidth allocation between the port (left) and starboard (right) main cameras  (`setbandwidthallocationforleftcamera`):  - when bandwidth is 100% on the left camera, the primary  source is `left_cam` and the secondary source is  `fpv_cam`.  - when bandwidth is 0% on the left camera,  the primary source is `right_cam` and the secondary source is  `fpv_cam`.  - when bandwidth is neither 0% nor 100% on  the left camera, the primary source is `left_cam` and the  secondary source is `right_cam`.  for matrice 300 rtk, the  physical source can be: `left_cam`, `right_cam`, `top_cam`  and `fpv_cam`. please note that video playback stream will be received as primary or secondary video feed,  if video playback starts on zenmuse h20 series. video feed channel could be assigned by `assignsourcetoprimarychannel` in `ocusynclink`.  @return a `videofeed` object.",
             "providetranscodedvideofeed",
             "returns a new videofeed instance to receive the transcoded video feed from the main camera. the original video feed from the main camera is transcoded (using mediacodec)  to generate h.264 video feed for more general usages. the encoder will use the calibrated  decoded feed when lens distortion calibration is needed. setting the callback of videofeed  to null can stop the transcoding.  @return a `videofeed` object.",
             "settranscodingdatarate",
             "sets the destination data rate for the transcoded video feed. the valid range is [0.3, 20] in mbps.  caution: changing the data rate during transcoding may re- start the internal encoder. the  transcoded video feed will get interrupted for a few seconds.  @param rate the destination data rate for the transcoded video feed.",
             "gettranscodingdatarate",
             "gets the data rate of all transcoded video feeder, in mbps.  @return a float value of the data rate of all transcoded video feeder.",
             "islensdistortioncalibrationneeded",
             "determines if the original video feed requires lens distortion calibration. when calibration is needed,  it is not recommended to use the original video feed with the decoding  sample (https://github.com/dji-mobile-sdk-tutorials/android- videostreamdecodingsample). use the transcoded  video feed instead and also the module: 'library-anti-distortion' should be included.  @return `true` if the video need anti-distortion feature.",
             "isfetchkeyframeneeded",
             "determines if the original video feed requires sdk to fetch key frame. when fetch key frame is needed, it is  not recommended to use the original video feed with the decoding  sample (https://github.com/dji-mobile-sdk-tutorials/android- videostreamdecodingsample). use the transcoded video feed instead.  @return `true` if the video need anti-distortion feature.",
             "videodatalistener",
             "video data listener.",
             "onreceive",
             "listener that is called when video data is received, but if `islensdistortioncalibrationneeded` return true, the callback will never be called.  for matrice 300 rtk, you must use `assignsourcetoprimarychannel` to assign or reassign the channel when you restart the aircraft or the aircraft is reconnected with the remote controller, otherwise you will not receive any data from this callback.  @param videobuffer an array containing video buffer. @param size the size of the buffer that contains valid data.",
             "videoactivestatuslistener",
             "video active status listener.",
             "onupdate",
             "listener that is called when a video feed has changed active status.  @param active boolean value indicates if the feed is active.",
             "videofeed",
             "video feed. use it to receive video data from a physical source.",
             "setpriority",
             "set the channel priority of the video feed. priority will affect the bandwidth allocation if it is  not `unknown`, which is the default value. for example,  if the data comes from the payload device mounted on left gimbal is prefer, please set the priority to `high`,  and physicalsource is `left_cam`. the others should be  set to `medium` or `low`.  only supported by matrice 300 rtk.  @param priority priority for the primary video feed. @param callback callback the execution callback with the value(s) returned.",
             "getpriority",
             "get the channel priority of the video feed. only supported by matrice 300 rtk.  @param callback callback the execution callback with the value(s) returned.",
             "physicalsource",
             "the physical source of a video feed.",
             "main_cam",
             "the video feed is from the main camera. it is the physical source used by most of dji products.  `left_cam`  and `right_cam` are used instead in  m210 series and m210 v2 series.",
             "fpv_cam",
             "the video feed is from the fpv camera on inspire 2, m200 series and m200 series v2 and matrice 300 rtk.",
             "ext",
             "the video feed is from ext port while ext port is enabled. it is only used for lightbridge 2 or aircrafts with lightbridge 2 (e.g. m600).",
             "lb",
             "the video feed is from one of the lb ports (av or hdmi) while ext port is enabled.  it is only used for stand-alone lightbridge 2 or aircraft with stand- alone lightbridge 2 modules (e.g. m600).",
             "hdmi",
             "the video feed is from the hdmi port while ext port is disabled.  it is only used for stand-alone lightbridge 2 or aircraft with stand-alone lightbridge 2 modules.",
             "av",
             "the video feed is from av port while ext port is disabled. it is only used for stand-alone lightbridge 2 or aircraft with stand-alone lightbridge 2 modules.",
             "left_cam",
             "the video feed is from the port (left) main camera. it is only used for m210 series and m210 v2 series and matrice 300 rtk.",
             "right_cam",
             "the video feed is from the starboard (right) main camera. it is only used for m210 series and m210 v2 series and matrice 300 rtk.",
             "top_cam",
             "the video feed is from the camera above the aircraft. it is only used for matrice 300 rtk.",
             "unknown",
             "unknown video physical source.",
             "videofeedpriority",
             "the enum is used to represent priority of a stream channel. it is supported only by matrice 300 rtk.",
             "high",
             "the stream channel's priority is high.",
             "medium",
             "the stream channel's priority is medium.",
             "low",
             "the stream channel's priority is low.",
             "unknown",
             "the stream channel's priority is unknown.",
             "callback",
             "callback interface for image transmission source.",
             "onupdate",
             "callback function that updates the image transmission source.  @param source image transmission source.",
             "physicalsourcelistener",
             "physical source listener.",
             "onchange",
             "called when the physical source changes.  @param videofeed an interface of `videofeed`. @param newphysicalsource an int value.",
             "getvideosource",
             "gets the physical sources of the video data.  @return an enum value of `physicalsource`.",
             "addvideodatalistener",
             "adds a listener to access the video data that is being shown by the videofeed.  @param listener the listener to be added to the videofeed.  @return `true` if listener was added successfully.",
             "removevideodatalistener",
             "removes the specified listener from the videofeed, if it is present (optional operation).  if this videofeed does not contain the listener, it is unchanged.  @param listener the listener to be removed from the videofeed.  @return `true` if the listener was removed successfully.",
             "getlisteners",
             "returns the list of the existing video data listeners.  @return a list of existing `videodatalistener`.",
             "addvideoactivestatuslistener",
             "adds a listener to access the video active status that is being shown by the videofeed.  @param listener the listener to be added to the videofeed.  @return `true` if the listener was added successfully.",
             "removevideoactivestatuslistener",
             "removes the specified listener from the videofeed, if it is present (optional operation).  if this videofeed does not contain the listener, it is unchanged.  @param listener the listener to be removed from the videofeed.  @return `true` if the listener was removed successfully.",
             "destroy",
             "destroy all the listeners associated with this videofeed.",
             "setbluetoothdeviceslistcallback",
             "set djibluetoothproductconnector listener.  @param callback the callback of `bluetoothdeviceslistcallback`.",
             "searchbluetoothproducts",
             "used to start searching for dji products that are near the mobile device and can be controlled with the mobile  sdk using bluetooth. use `onupdate` to receive the product list.  @param callback completion block returns the command execution result. it is called once the searching is started.",
             "connect",
             "connects to the dji product using bluetooth. once it is connected, `djisdkmanager` can be used to access the product.  @param product the bluetooth product to connect to. @param callback the completion block returns the command execution result.",
             "disconnect",
             "disconnects connected bluetooth product.  @param callback the completion block returns the command execution result.",
             "bluetoothdeviceslistcallback",
             "delegate that receives the product list found by the connector.",
             "bluetoothdevice",
             "this class contains information for a dji bluetooth device.",
             "getname",
             "returns the name of the bluetooth device.  @return a string representing the name.",
             "getstatus",
             "returns connection status for the bluetooth device.  @return the enum value of `bluetoothdevicestatus`.",
             "getrssi",
             "returns the signal quality.  @return an integer representing the signal quality.",
             "bluetoothdevicestatus",
             "dji bluetooth device status enum.",
             "connected",
             "bluetooth device connected.",
             "disconnected",
             "bluetooth device disconnected.",
             "connecting",
             "bluetooth device connecting.",
             "onupdate",
             "provides the list of dji products that can be connected with the mobile device over bluetooth. delegate will  continue to receive an updated list after `searchbluetoothproducts` is called  until the searching is finished (either product is connected or after 10s).  @param devices a list of dji products found by the connector.",
             "getflightcontroller",
             "returns an instance of the aircraft's flight controller.  @return djiflightcontroller component.",
             "getcameras",
             "retrieves instances of the product's cameras. this is used when the aircraft has multiple dji cameras, e.g. m210 and  m210 rtk. note, when two cameras do exist, camera order within the array will not always the same. for example: on the m210, the port side (left) camera will have an index of 0 and the starboard side (right)  camera will have an index of 1. however, the first object of `getcameras` will not  necessarily always be the camera with `getindex` of 0.  @return a list of the aircraft's cameras.",
             "getcamerawithcomponentindex",
             "retrieves an instance of the device's camera with inputted index.  @param index an int value.  @return an instance of the aircraft's camera.",
             "getgimbals",
             "retrieves instances of the product's gimbals. this is used when the aircraft has multiple dji gimbals, e.g. m210  and m210 rtk. note, when two gimbals do exist, gimbal order within the array will not always the same. for example:  on the m210, the port side (left) gimbal will have an index of 0 and the starboard side (right) gimbal will have an index of 1. however, the first object of `getgimbals`  will not necessarily always be the gimbal with `getindex` of 0.  @return a list of the aircraft's gimbals.",
             "getremotecontroller",
             "returns an instance of the aircraft's remote controller.  @return djiremotecontroller component.",
             "getmobileremotecontroller",
             "a simulated remote controller on the mobile device. it is supported by mavic pro and spark using wifi.  @return djimobileremotecontroller component.",
             "getbasestation",
             "the connected base station instance. it is supported by phantom 4 rtk and matrice 210 rtk v2.  @return an instance of `basestation`.",
             "getradar",
             "retrieves an instance of the device's radar.",
             "getlidars",
             "retrieves instances of the product's lidars. this is used when the aircraft has multiple dji lidars, e.g. m300 rtk and m350 rtk.  note, when two zenmuse l1 do exist, lidar order within the array will not always the same. for example: on the  m300 rtk and m350 rtk, the port side (left) zenmuse l1 will have an index of 0 and the starboard side (right)  zenmuse will have an index of 1. however, the first object of `getlidars` will not  necessarily always be the lidar with `getindex` of 0.  @return a list of the aircraft's lidars.",
             "unknown_aircraft",
             "the aircraft's model name is unknown.",
             "inspire_1",
             "the aircraft's model name is inspire 1.",
             "inspire_1_pro",
             "the aircraft's model name is inspire 1 pro.",
             "inspire_1_raw",
             "the aircraft's model name is inspire 1 raw.",
             "inspire_2",
             "the aircraft's model name is inspire 2.",
             "phantom_3_professional",
             "the aircraft's model name is phantom 3 professional.",
             "phantom_3_advanced",
             "the aircraft's model name is phantom 3 advanced.",
             "phantom_3_standard",
             "the aircraft's model name is phantom 3 standard.",
             "phantom_3_4k",
             "the aircraft's model name is phantom 3 4k.",
             "phantom_4",
             "the aircraft's model name is phantom 4.",
             "phantom_4_pro",
             "the aircraft's model name is phantom 4 pro.",
             "phantom_4_pro_v2",
             "the aircraft's model name is phantom 4 pro v2.",
             "p_4_multispectral",
             "the aircraft's model name is p4 multispectral.",
             "mavic_air_2",
             "the aircraft's model name is mavic air 2.",
             "dji_mini_se",
             "the aircraft's model name is dji mini se.",
             "dji_mini_2",
             "the aircraft's model name is dji mini 2.",
             "mavic_2_enterprise_advanced",
             "the aircraft's model name is mavic 2 enterprise advanced.",
             "matrice_100",
             "the aircraft's model name is matrice 100.",
             "matrice_200",
             "the aircraft's model name is matrice 200.",
             "phantom_4_advanced",
             "the aircraft's model name is phantom 4 advanced.",
             "matrice_600",
             "the aircraft's model name is matrice 600.",
             "matrice_600_pro",
             "the aircraft's model name is matrice 600 pro.",
             "a3",
             "the aircraft flight controller's model name is a3.",
             "mavic_pro",
             "the aircraft's model name is mavic pro.",
             "spark",
             "the aircraft's model name is spark.",
             "matrice_210",
             "the aircraft's model name is matrice 210.",
             "matrice_210_rtk",
             "the aircraft's model name is matrice 210 rtk.",
             "matrice_200_v2",
             "the aircraft's model name is matrice 200 v2.",
             "matrice_210_v2",
             "the aircraft's model name is matrice 210 v2.",
             "matrice_210_rtk_v2",
             "the aircraft's model name is matrice 210 rtk v2.",
             "matrice_300_rtk",
             "the aircraft's model name is matrice 300 rtk.",
             "mavic_air",
             "the aircraft's model name is mavic air.",
             "mavic_2_pro",
             "the aircraft's model name is mavic 2 pro.",
             "mavic_2_zoom",
             "the aircraft's model name is mavic 2 zoom.",
             "mavic_2",
             "the aircraft's model name is either mavic 2 pro or mavic 2 zoom.  the camera is not recognized yet.",
             "mavic_2_enterprise",
             "the aircraft's model name is mavic 2 enterprise.",
             "mavic_2_enterprise_dual",
             "the aircraft's model name is mavic 2 enterprise dual.",
             "mavic_mini",
             "the aircraft's model name is mavic mini.",
             "dji_air_2s",
             "the aircraft's model name is dji air 2s.",
             "n3",
             "the aircraft flight controller's model name is n3.",
             "getloggedindjiuseraccountname",
             "the name of the currently logged in user account.  @param callback the execution callback with the returned execution result.",
             "getuseraccountstate",
             "gets the dji user account state.  @return an enum value of `useraccountstate`.",
             "logintodjiuseraccount",
             "after invoking this method, a dialog redirecting users to log into their dji account  will be shown. for users outside of china, authorization is required to unlock  authorization zones. after the login process, if `authorizationrequired` is `true`,  and the user is currently out of china and the account has not been authorized to  unlock authorization zones, the dialog will then redirect users to authorize their account.  @param context the android activity's or view's context. @param callback the execution callback with the returned execution result.",
             "logoutofdjiuseraccount",
             "logs out the dji user that is logged in.  @param callback the `completion callback` with the returned execution result.",
             "adduseraccountstatechangelistener",
             "start listen to the update of the user account state.  @param listener a `useraccountstatechangelistener` interface.",
             "removeuseraccountstatechangelistener",
             "remove the listener.  @param listener a `useraccountstatechangelistener` interface.",
             "useraccountstatechangelistener",
             "receive user account state and user account information of the user account manager.",
             "onuseraccountstatechanged",
             "called when the user account manager update the user account information.  @param state provides the user account states. @param information provides the account information of the user account.",
             "useraccountinformation",
             "account information for a logged-in user.",
             "getaccount",
             "the username of the account.  @return the username of the account.",
             "isverified",
             "whether the account is verified.  @return `true` if the account is verified, false otherwise.",
             "useraccountstate",
             "user account status. users need to be logged in.",
             "not_logged_in",
             "user is not logged in. user needs to be logged in to retrieve currently unlocked,  and unlock authorization zones.",
             "not_authorized",
             "user is logged in but has not been authorized to unlock authorization zones.",
             "authorized",
             "user is logged in and has been authorized to unlock authorization zones.",
             "token_out_of_date",
             "the token of the user account is out of date.",
             "unknown",
             "unknown.",
             "getsdkversion",
             "gets the dji mobile sdk version. returns sdk version as a string.  @return a sdk version string instance.",
             "registerapp",
             "the first time the app is initialized after installation, the app connects to a dji server through the internet to verify the application key. the request will include the following information:  - app key  - bundle id  - device uuid generated from hashed mobile device id (`getdeviceid`), hashed sim serial number (`getsimserialnumber`) and hashed android id (`secure.android_id`). if `read_phone_state` permission is not permitted, a random uuid is generated.  - system platform, version and name  - uuid generated by platform's api (`[uidevice currentdevice] identifierforvendor]`)  - mobile device model  - internet related feature initialisation.  subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context android context. @param callback callback used for both the registration result, and when the products changes.",
             "registerappforldm",
             "designed for ldm feature `ldmmanager`. the first time the app is initialized after installation, the app connects to a dji server through the internet to verify the application key. the request will include the following information:  - app key  - bundle id  - device uuid generated from hashed mobile device id (`getdeviceid`), hashed sim serial number (`getsimserialnumber`) and hashed android id (`secure.android_id`). if `read_phone_state` permission is not permitted, a random uuid is generated.  - system platform, version and name  - uuid generated by platform's api (`[uidevice currentdevice] identifierforvendor]`)  - mobile device model <strong> - internet related feature initialisation (not included)</strong>  after successfully registered, the app will enter ldm mode. subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context android context. @param callback callback used for both the registration result, and when the products changes.",
             "hassdkregistered",
             "registration state.  @return `true` if sdk is registered.",
             "usb_accessory_attached",
             "when this string is received in a broadcast, the sdk will attempt to connect to usb accessory.",
             "getinstance",
             "accessor for `djisdkmanager` object.  @return an instance of `djisdkmanager` object.",
             "setcallbackruninuithread",
             "determines whether asynchronous getter and setter method callbacks should be invoked in uithread or backgroundthread. this method is only for setters and getters, as push data callbacks (typically state data) always return in the backgroundthread.  @param enable a boolean value.",
             "closeaoaconnection",
             "this method is used to close the aoa connection during development and should not be used in the final application. when using as or eclipse to build and run the application, the aoa connection is not properly closed if the application is terminated. as a result, the next time the application is run, the sdk will not be able to connect to the product without first disconnecting and reconnecting the usb cable. as and eclipse can be configured to invoke this method before compiling the application, closing the link before the application is run, and overcoming this problem.",
             "getappactivationmanager",
             "used to check the states related to the app activation.  @return an instance of `appactivationmanager`.",
             "getrtknetworkserviceprovider",
             "accesses the rtk network service provider.  @return an instance of `rtknetworkserviceprovider`.",
             "getupgrademanager",
             "provide access to upgrademanager used to manage components upgrade.  @return an instance of `upgrademanager`.",
             "getuasremoteidmanager",
             "provide access to uasremoteidmanager used to manage ua sremote id.  @return an instance of djiuasremoteidmanager</code>.",
             "getproduct",
             "the dji product which is connected to the mobile device, only available after successful registration of the app.  @return an instance of `baseproduct`.",
             "getbluetoothproductconnector",
             "used to establish the bluetooth connection between the mobile device and the dji product. the bluetooth connection needs to be established before a connection between the sdk and the dji product can be made using `startconnectiontoproduct`.  @return a `bluetoothproductconnector` instance.",
             "startconnectiontoproduct",
             "starts a connection between the sdk and the dji product. this method should be called after successful registration of the app and once there is a data connection between the mobile device and dji product. this data connection is either a usb cable connection, a wifi connection (that needs to be established outside of the sdk) or a bluetooth connection (that needs to be established with `getbluetoothproductconnector`). if the connection succeeds, `onproductconnect` will be called if the connection succeeded. returns `true` if the connection is started successfully. for products which connect to the mobile device using bluetooth, `getbluetoothproductconnector` should be used to get a `bluetoothproductconnector` object which can handle bluetooth device connection.  @return `true` if the connection is started successfully.",
             "stopconnectiontoproduct",
             "disconnect from the connected dji product.",
             "setsupportonlyforbluetoothdevice",
             "if only bluetooth devices will be connected, then this should be set to `true`.  @param isbluetoothdevice `true` if only bluetooth devices will be connected.",
             "enablebridgemodewithbridgeappip",
             "enter debug mode with debug ip.  @param bridgeappip debug ip of the dji bridge app.",
             "getlogpath",
             "gets the path that flight logs are stored to. flight logs are automatically defineed by msdk and stored on the mobile device. the sdk does nothing with these logs, and they are provided only as a convenience for developers and users. users can use these flight logs with dji service centers if they are making a warranty claim. only developers using the sdk, and users of the mobile device can access these logs. older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs.  @return an nsstring object of the flight log path.",
             "getflyclogpath",
             "gets the path that flight control compact logs are stored to. flight control compact logs are defined by flight controller and stored on the mobile device. the sdk does nothing with these logs, and they are provided only as a convenience for developers and users. users can use these flight logs with dji service centers if they are making a warranty claim. only developers using the sdk, and users of the mobile device can access these logs. older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs. supported by dji air 2s, dji mini 2, dji mini se, mavic air 2, mavic mini, mavic pro, phantom 4 pro, matrice 300 rtk.  @return an nsstring object of the flight control compact log path.",
             "getflyzonemanager",
             "provide access to `flyzonemanager` used to manage dji's geo system for no fly zones.  @return an instance of `flyzonemanager`.",
             "getkeymanager",
             "provide access to the sdk key interface.  @return an instance of `keymanager`.",
             "getmissioncontrol",
             "provide access to `missioncontrol` used to manage missions.  @return an instance of `missioncontrol`.",
             "getflighthubmanager",
             "provide access to `flighthubmanager`. it can be used to interact with dji flighthub (https://www.dji.com/flighthub).  @return an instance of `flighthubmanager`.",
             "getlivestreammanager",
             "provides access to `getlivestreammanager`. it can be used to stream the video to a rtmp server to do live streaming with dji products.  @return an instance of `getlivestreammanager`.",
             "getldmmanager",
             "manages local data mode (ldm) functionality. local data mode gives the developer the option to put the sdk into airplane mode, restricting its access to the internet. see `ldmmanager` for details on when and where this is possible, and what is restricted.  @return an instance of `ldmmanager`.",
             "sdkmanagercallback",
             "callback interface for sdk manager.",
             "bluetoothproductconnector",
             "some dji products can be controlled using the mobile sdk over a bluetooth wireless connection. this class contains methods to search for, connect to, and disconnect from such products.",
             "onregister",
             "callback method after the application attempts to register.  @param error `registration_success` if registration is successful.",
             "onproductconnect",
             "called when the product is connected.  @param product product object. nil if the usb link or wifi link between the product and phone is disconnected.",
             "productkey.connection",
             "sdk key for onproductconnect: called when the product is connected.  @param product product object. nil if the usb link or wifi link between the product and phone is disconnected.",
             "onproductdisconnect",
             "called when the product is disconnected.",
             "productkey.connection",
             "sdk key for onproductdisconnect: called when the product is disconnected.",
             "onproductchanged",
             "called when the connected product is changed. the product will be updated when the aircraft connected changes from only remote controller connected.  @param product an instance of `baseproduct`.",
             "oncomponentchange",
             "called when a component object changes. note: if the component is disconnected, this method will not be called, pls use componentlistener to listen the disconnect event of any component.  @param key an enum value of the `componentkey`. @param oldcomponent an instance of `basecomponent`. @param newcomponent an instance of `basecomponent`.",
             "productkey.connection",
             "sdk key for oncomponentchange: called when a component object changes. note: if the component is disconnected, this method will not be called, pls use componentlistener to listen the disconnect event of any component.  @param key an enum value of the `componentkey`. @param oldcomponent an instance of `basecomponent`. @param newcomponent an instance of `basecomponent`.",
             "oninitprocess",
             "called when load sdk resource.  @param event an event that show what resource is loading. @param totalprocess the totalprocess of load resource, from 0 to 100.",
             "ondatabasedownloadprogress",
             "called when fly safe database download progress is updated. mobile sdk will download the database when `registerapp`  is invoked, if fly-safe-database is excluded in build.gradle. please find `onregister` for updated error.  @param current the current download data size. @param total the total size of the file being downloaded.",
             "djisdkinitevent",
             "the loading status of the dji sdk.",
             "getinitializationstate",
             "get the sdk initialization state.  @return an enum value of `djisdkinitevent`.",
             "initializationstate",
             "sdk initialization states.",
             "start_to_initialize",
             "dji sdk initialization starts.",
             "assets_loaded",
             "dji sdk assets has loaded.",
             "database_loaded",
             "dji sdk fly safe database has loaded.",
             "setleftstickvertical",
             "simulates the vertical movement of the left stick, which changes the aircraft's thrust causing it to raise or  lower in elevation. the valid range is [-1, 1].  @param data a float value of the left stick vertical movement.",
             "setleftstickhorizontal",
             "simulates the horizontal movement of the left stick, which changes the yaw of the aircraft causing it to rotate  horizontally. the valid range is [-1, 1].  @param data a float value of the left stick horizontal movement.",
             "setrightstickvertical",
             "simulates the vertical movement of the right stick, which changes the the aircraft's pitch causing it to fly  forward or backward. the valid range is [-1, 1].  @param data a float value of the right stick vertical movement.",
             "setrightstickhorizontal",
             "simulates the horizontal movement of the right stick, which changes the the aircraft's roll causing it to fly  left or right. the valid range is  [-1, 1].  @param data a float value of the left stick horizontal movement.",
             "getleftstickvertical",
             "gets the vertical movement value of the left stick.  @return a float value.",
             "getleftstickhorizontal",
             "gets the horizontal movement value of the left stick.  @return a float value.",
             "getrightstickvertical",
             "gets the vertical movement value of the right stick.  @return a float value.",
             "getrightstickhorizontal",
             "gets the horizontal movement value of the right stick.  @return a float value.",
             "isldmsupported",
             "`true` if ldm is supported in the current context. the sdk locally uses gps location and mcc (mobile country code) to determine the country  of operation. if ldm is not enabled and the internet is accessible, the ip address is also used to determine the country of operation. the default value is `true` after the first installation.  @return a bool value to check if ldm is supported.",
             "isldmenabled",
             "`true` if ldm is already enabled.  @return a boolean value to check if ldm is enabled.",
             "getldmsupported",
             "`true` if ldm is supported. the sdk will get whether your app supports ldm from the remote server.  @param callback the execution callback.",
             "enableldm",
             "enables ldm. can only be enabled if `isldmsupported` is `true`. please call `getldmsupported` methods firstly.  call this method before calling the other methods of sdk (including `registerapp`) to restrict the internet access  of sdk (sdk registration is unrestricted).  @param callback the execution callback.  @return the error occurred. null if ldm is enabled successfully.",
             "disableldm",
             "disables ldm.",
             "setmodulenetworkserviceenabled",
             "in ldm mode, you can use this interface to enable network service of the selected module.  @param modules the array of the modules need to be enabled.",
             "ismodulenetworkserviceenabled",
             "`true` if the network service of the module is enabled.  @param moduletype the type of module that needs to be checked.  @return `true` if the network service of the module is enabled.",
             "setcallback",
             "sets the ldm callback.  @param ldmcallback the execution callback with the returned value.",
             "ldmmodule",
             "module definition.",
             "builder",
             "default constructor of `ldmmodule`.",
             "build",
             "generate an object for `ldmmodule`.  @return the object of `ldmmodule`.",
             "enabled",
             "`true` to enable the network service.  @param enabled `true` to enable the network service.  @return the build of `builder`.",
             "moduletype",
             "the type of module. the module that you want to enable network service in ldm mode.  @param moduletype `ldmmoduletype` object to set.  @return the build of `builder`.",
             "isenabled",
             "`true` if the network service is enabled.",
             "getmoduletype",
             "the type of module. the module that you set to enable the network service.",
             "ldmmoduletype",
             "the type of module. the modules that support network service in ldm mode.",
             "rtk",
             "the module of rtk. in ldm mode, you can use this type to enable the network service for rtk, so that you can using the rtk function as normal.",
             "user_account",
             "the module of user account. in ldm mode, you can use this type to enable the network service for user account, so that you can using the login function as normal. after login your dji account, you can remove the height and distance limit in ldm mode.",
             "live_streaming",
             "the module of live streaming. in ldm mode, you can use this type to enable the network service for live streaming, so that you can using the live streaming function as normal.",
             "firmware_upgrade",
             "the module of firmwareupgrade. in ldm mode, you can use this type to enable the network service for firmwareupgrade, so that you can using the firmwareupgrade function as normal.",
             "ldmcallback",
             "ldm callback interface, callback will always be invoked in background thread.",
             "onldmenabledchange",
             "called when the ldm availability is changed.  @param isenabled true if ldm enabled.",
             "onldmsupportedchange",
             "if the value changes to false, ldm will be disable after 5 minutes  @param issupported true if ldm is supported.",
             "gethandheldcontroller",
             "returns an instance of the handheld device's handheld controller.  @return an instance of the `handheldcontroller`",
             "unknown_handheld",
             "handheld device model name unknown.",
             "osmo",
             "handheld device model name osmo.",
             "osmo_pro",
             "handheld device model name osmo pro.",
             "osmo_raw",
             "handheld device model name osmo raw.",
             "osmo_mobile",
             "handheld device model name osmo mobile.",
             "osmo_plus",
             "handheld device model name osmo+.",
             "osmo_mobile_2",
             "handheld device model name osmo mobile 2.",
             "setareacode",
             "set the area code of country or area. the following functions can not be used unless the corresponding area code is set. currently the supported country or area list and the supported function list is as follows: - usa: remote identification broadcast of drone  @param areacode area code of country or area.  @return return the setting execution result of area code.",
             "getuasremoteidstatus",
             "get the remote identification status of the drone system.  @return return the remote identification status of the drone system.",
             "adduasremoteidstatuslistener",
             "add the remote identification status listener of the drone system.  @param listener the remote identification status listener of the drone system",
             "removeuasremoteidstatuslistener",
             "remove the remote identification status listener of the drone system.  @param listener the remote identification status listener of the drone system",
             "clearuasremoteidstatuslistener",
             "remove all the remote identification status listeners of the drone system.",
             "isbroadcastremoteidenabled",
             "get whether the rid broadcast function of the drone is enabled.  @return return whether the rid broadcast function of the drone is enabled.",
             "getremoteidworkingstate",
             "get the working state of uas remote identification(rid).  @return return the working state of uas remote identification(rid).",
             "onupdate",
             "when the rid status of the drone changes, this method will be called back.  @param uasremoteidstatus the rid status of the drone.",
             "remoteidworkingstate",
             "the remote identification working status of the drone.",
             "uasremoteidstatus",
             "the remote identification status of the drone.",
             "uasremoteidstatuslistener",
             "the remote identification status listener of the drone.",
             "idle",
             "idle, initialization state.",
             "working",
             "working, it indicates that remote id is broadcasting.",
             "operator_location_lost_error",
             "not working, because the operator's position is lost, resulting in the remote id not being broadcast.",
             "firmware_error",
             "not working, because the firmware error, resulting in the remote id not being broadcast.",
             "unknown_error",
             "not working, because the unknown error, resulting in the remote id not being broadcast.",
             "areacode",
             "enums represent the aera code.",
             "us",
             "america.",
             "setpowermodecallback",
             "setup the callback that returns changed power mode state information.  @param callback the callback for the power mode state.",
             "power_mode",
             "sdk key for setpowermodecallback: setup the callback that returns changed power mode state information.  @param callback the callback for the power mode state.",
             "sethardwarestatecallback",
             "set up the callback for the handheld's hardware state.  @param callback callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
             "setpowermode",
             "set the power mode for the handheld controller.  @param mode the power mode to set. caution! when the mode is `off`, the handheld product will be shut down and the connection will be broken. the user must then power on the device manually. @param callback the execution callback with the execution result returned.",
             "power_mode",
             "sdk key for setpowermode: set the power mode for the handheld controller.  @param mode the power mode to set. caution! when the mode is `off`, the handheld product will be shut down and the connection will be broken. the user must then power on the device manually. @param callback the execution callback with the execution result returned.",
             "controlledwithcommand",
             "controls the led of the handheld controller.  @param command the command to control the led. @param callback the execution callback with the execution result returned.",
             "led_command",
             "sdk key for controlledwithcommand: controls the led of the handheld controller.  @param command the command to control the led. @param callback the execution callback with the execution result returned.",
             "setstickgimbalcontrolenabled",
             "enables/disables the gimbal control with the joystick. by default, it is enabled. the handheld will be reset to the default value  when it reboots or sdk reinitializes. when gimbal control is disabled, the joystick can be used for other purposes in an sdk application by reading its position values with `stickverticaldirection` and `stickhorizontaldirection`. only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback the execution callback with the execution result returned.",
             "stick_gimbal_control_enabled",
             "sdk key for setstickgimbalcontrolenabled: enables/disables the gimbal control with the joystick. by default, it is enabled. the handheld will be reset to the default value  when it reboots or sdk reinitializes. when gimbal control is disabled, the joystick can be used for other purposes in an sdk application by reading its position values with `stickverticaldirection` and `stickhorizontaldirection`. only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback the execution callback with the execution result returned.",
             "getstickgimbalcontrolenabled",
             "`true` if gimbal control with the joystick is enabled. only supported in firmware version 1.2.0.40 or above.  @param callback the execution callback with the returned value(s).",
             "stick_gimbal_control_enabled",
             "sdk key for getstickgimbalcontrolenabled: `true` if gimbal control with the joystick is enabled. only supported in firmware version 1.2.0.40 or above.  @param callback the execution callback with the returned value(s).",
             "onupdate",
             "called when the handheld controller's power mode has been updated.  @param powermode handheld controller's current power mode.",
             "power_mode",
             "sdk key for onupdate: called when the handheld controller's power mode has been updated.  @param powermode handheld controller's current power mode.",
             "onupdate",
             "called when the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks) has been updated.  @param state an object of `hardwarestate`.",
             "on",
             "the handheld product is awake. for osmo, when it is in this mode, all the components in `handheld` are accessible.",
             "sleeping",
             "the handheld product is sleeping. the handheld controller keeps the wireless connection to the mobile device alive but most other components are off. the power consumption is low in this mode. for osmo in this mode, only the `handheldcontroller`, `airlink`, and `battery` are accessible.",
             "off",
             "the handheld product is powered off. once this mode is set the callback will receive this mode until the handheld device is shut down completely. it is not supported by osmo mobile.",
             "unknown",
             "the handheld power mode in unknown.",
             "getrecordandshutterbuttons",
             "status of the shutter button and record button.  @return a `recordandshutterbuttons` enum value.",
             "record_and_shutter_buttons",
             "sdk key for getrecordandshutterbuttons: status of the shutter button and record button.  @return a `recordandshutterbuttons` enum value.",
             "gettriggerbutton",
             "status of the trigger button.  @return a `handheldbuttonclickevent` enum value.",
             "trigger_button",
             "sdk key for gettriggerbutton: status of the trigger button.  @return a `handheldbuttonclickevent` enum value.",
             "getmodebutton",
             "status of the mode button. it is only supported by osmo mobile 2.  @return a `handheldbuttonclickevent` enum value.",
             "istriggerbeingpressed",
             "`true` when the trigger is being pressed. it is only supported in firmware version 1.2.0.40 or above.  @return a boolean value.",
             "is_trigger_being_pressed",
             "sdk key for istriggerbeingpressed: `true` when the trigger is being pressed. it is only supported in firmware version 1.2.0.40 or above.  @return a boolean value.",
             "ismodebuttonbeingpressed",
             "`true` when the mode button is being pressed. it is only supported by osmo mobile 2.  @return a boolean value.",
             "getstickverticaldirection",
             "status of the joystick in vertical direction.  @return a `stickverticaldirection` enum value.",
             "stick_vertical_direction",
             "sdk key for getstickverticaldirection: status of the joystick in vertical direction.  @return a `stickverticaldirection` enum value.",
             "getstickhorizontaldirection",
             "status of the joystick in horizontal direction.  @return a `stickhorizontaldirection` enum value.",
             "stick_horizontal_direction",
             "sdk key for getstickhorizontaldirection: status of the joystick in horizontal direction.  @return a `stickhorizontaldirection` enum value.",
             "getstick",
             "position of the stick in both vertical and horizontal direction. only supported in firmware version 1.2.0.40 or above.  @return an object of `stick`.",
             "stick",
             "sdk key for getstick: position of the stick in both vertical and horizontal direction. only supported in firmware version 1.2.0.40 or above.  @return an object of `stick`.",
             "getzoomstate",
             "status of the zoom slider. it is only supported by osmo mobile 2.  @return an enum value of `zoomstate`.",
             "idle",
             "no buttons have been pressed.",
             "shutter_click",
             "only the shutter button was pressed and released.",
             "record_click",
             "only the record button was pressed and released.",
             "shutter_long_click",
             "the shutter button is being pressed without release.",
             "unknown",
             "the button status is unknown.",
             "idle",
             "trigger button status is idle.",
             "single_click",
             "trigger button is pressed and released.",
             "double_click",
             "trigger button is pressed twice quickly.",
             "triple_click",
             "trigger button is pressed three times quickly.",
             "unknown",
             "trigger button status is unknown.",
             "center",
             "joystick has no movement in the vertical direction.",
             "up",
             "joystick is moved up in the vertical direction.",
             "down",
             "joystick is moved down in the vertical direction.",
             "unknown",
             "joystick status in the vertical direction is unknown.",
             "center",
             "joystick has no movement in the horizontal direction.",
             "left",
             "joystick is moved left in the horizontal direction.",
             "right",
             "joystick is moved right in the horizontal direction.",
             "unknown",
             "joystick status in the horizontal direction is unknown.",
             "one_axis",
             "gimbal movement will be exclusively in yaw or pitch depending on whether the controller horizontal or vertical deflection is greater respectively.",
             "two_axis",
             "gimbal movement will be in both yaw and pitch simultaneously relative to the horizontal and vertical deflection of the controller respectively.",
             "unknown",
             "the gimbal controller control mode is unknown.",
             "idle",
             "zoom slider is idle.",
             "zoom_in",
             "the slider is pushed up and the camera should zoom in.",
             "zoom_out",
             "the slider is pushed down and the camera should zoom out.",
             "unknown",
             "unknown.",
             "red",
             "pattern to control the red color.",
             "green",
             "pattern to control the green color.",
             "blue",
             "pattern to control the blue color.",
             "pattern",
             "pattern to control the time varying behaviour of the led color. each element of pattern</code> is a boolean  representing the led on/off state for 0.125 seconds where `true` means the led is on. the length of the pattern cannot exceed 32. by default, the array is empty, which will turn the led color off.",
             "repeattimes",
             "the number of times to repeat the sequence with range [1, 255]. a value of 255 will repeat the sequence indefinitely until a new  command is sent. the default value is 255.",
             "callback",
             "callback to receive the updated power mode of the handheld controller.",
             "callback",
             "callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
             "powermode",
             "handheld power mode.",
             "power_mode",
             "sdk key for powermode: handheld power mode.",
             "hardwarestate",
             "the status of the shutter button and record button on the handheld controller. used by osmo mobile only.",
             "recordandshutterbuttons",
             "the status of the shutter button and record button on the handheld controller.",
             "record_and_shutter_buttons",
             "sdk key for recordandshutterbuttons: the status of the shutter button and record button on the handheld controller.",
             "handheldbuttonclickevent",
             "the status of the shutter button and record button on the handheld controller.",
             "trigger_button",
             "sdk key for handheldbuttonclickevent: the status of the shutter button and record button on the handheld controller.",
             "mode_button",
             "sdk key for handheldbuttonclickevent: the status of the shutter button and record button on the handheld controller.",
             "stickverticaldirection",
             "status of the handheld joystick in vertical direction.",
             "stick_vertical_direction",
             "sdk key for stickverticaldirection: status of the handheld joystick in vertical direction.",
             "stickhorizontaldirection",
             "status of the handheld joystick in horizontal direction.",
             "stick_horizontal_direction",
             "sdk key for stickhorizontaldirection: status of the handheld joystick in horizontal direction.",
             "controllermode",
             "the control mode for the gimbal physical controller (joystick for osmo). the total controller deflection is a combination of horizontal and vertical deflection. this translates to gimbal movement around the yaw and pitch axes. the gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
             "controller_mode",
             "sdk key for controllermode: the control mode for the gimbal physical controller (joystick for osmo). the total controller deflection is a combination of horizontal and vertical deflection. this translates to gimbal movement around the yaw and pitch axes. the gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
             "zoomstate",
             "the state of the zoom slider on the handheld controller. used by osmo mobile 2 only.",
             "ledcommand",
             "command used to control different colors (red, green and blue) of the handheld controller's led.",
             "led_command",
             "sdk key for ledcommand: command used to control different colors (red, green and blue) of the handheld controller's led.",
             "ledcolorpattern",
             "pattern used to control a single color (red, green or blue) of the handheld controller's led.",
             "issupported",
             "`true` if the component or product supports the parameter.  @return a boolean value.",
             "djiparamminmaxcapability",
             "adds the maximum and minimum possible values of the parameter to  the `djiparamcapability` base class.",
             "getmin",
             "return the valid minimum value of the  parameter for the product. if `issupported`  returns `false`, the value is undefined.  @return a number object.",
             "getmax",
             "return the valid maximum value of the  parameter for the product. if `issupported`  returns `false`, the value is undefined.  @return a number object.",
             "setdiagnosticsinformationcallback",
             "sets up the diagnostics list update callback.  @param callback the callback of `diagnosticsinformationcallback`.",
             "getfirmwarepackageversion",
             "gets the product's firmware package version. products other than phantom 4, phantom 4 pro, mavic pro, and inspire 2, require internet connection. the execution time for this method depends on the speed of internet connectivity.  @return the product's firmware package version string.",
             "firmware_package_version",
             "sdk key for getfirmwarepackageversion: gets the product's firmware package version. products other than phantom 4, phantom 4 pro, mavic pro, and inspire 2, require internet connection. the execution time for this method depends on the speed of internet connectivity.  @return the product's firmware package version string.",
             "setname",
             "retrieves the model of the product.  @param name name to be set to the aircraft. @param callback asynchronous execution result.",
             "getname",
             "retrieves the model of the product.  @param callback the execution callback with the returned value.",
             "getmodel",
             "retrieves the model of the product. see `aircraft` and `handheld` for the possible strings that can be returned.  @return the model of the product.",
             "model_name",
             "sdk key for getmodel: retrieves the model of the product. see `aircraft` and `handheld` for the possible strings that can be returned.  @return the model of the product.",
             "isconnected",
             "`true` if the device is connected.  @return `true` if the device is connected.",
             "productkey.connection",
             "sdk key for isconnected: `true` if the device is connected.  @return `true` if the device is connected.",
             "getcamera",
             "retrieves an instance of the device's camera. only supported by the product with single gimbal, except zenmuse xt2 and mavic 2 enterprise camera.  @return an instance of the aircraft's camera.",
             "getbattery",
             "retrieves an instance of the product's smart battery. when using products with multiple batteries, such as the m600 or inspire 2, use `getbatteries`, as this method will only return a single battery.  @return an instance of the aircraft's smart battery.",
             "getbatteries",
             "returns an array of aircraft's batteries. it is used when the aircraft has multiple batteries, e.g. matrice 600.  @return a list of `battery` objects.",
             "getgimbal",
             "retrieves an instance of the device's gimbal.  @return an instance of the aircraft's gimbal.",
             "getairlink",
             "retrieves an instance of the device's airlink.  @return an instance of the aircraft's airlink.",
             "getaccessoryaggregation",
             "retrieves an instance of the accessory aggregation.  @return 'null' if the product does not support accessories (e.g. spotlight, speaker or beacon).",
             "componentkey",
             "specifies all the components.",
             "camera",
             "camera component.",
             "gimbal",
             "gimbal component.",
             "remote_controller",
             "remote controller component.",
             "flight_controller",
             "flight controller component.",
             "battery",
             "battery component.",
             "hand_held_controller",
             "handheld controller component.",
             "air_link",
             "airlink component.",
             "mobile_remote_controller",
             "mobile remote controller component.",
             "accessory_aggregation",
             "accessory aggregation component.",
             "base_station",
             "the rtk base station component.",
             "radar",
             "the radar component.",
             "lidar",
             "the lidar component.",
             "model",
             "class containing all product strings.",
             "model_name",
             "sdk key for model: class containing all product strings.",
             "videofeeder",
             "class that manages live video feed from dji products to the mobile device.",
             "getpipelines",
             "the pipelines to transmit data between dji payload device and dji mobile sdk. this function does not support dual controllers scenarios.  it's only supported by matrice 300 rtk.  @return the djipipelines</code> objects.",
             "getupstreambandwidth",
             "gets the bandwidth of the upstream (from mobile sdk to payload). the unit is bytes/s.  the bandwidth is determined by the firmware and currently it is not larger than 500 bytes/s.  @param callback the execution callback with the returned value(s).",
             "getpayloadproductname",
             "gets the product name defined by the manufacturer of the payload device.  @return the product name of the payload device.",
             "isdjivideostreamingchannelavailable",
             "when it returns `true`, video stream type on psdk is set to dji video streaming channel. please use `videodatalistener` in `djivideofeeder` to receive the video data. when it returns `false`, video stream type on psdk is set to custom video streaming channel.  please use `onvideodatareceived` to receive custom video data.  @return `true` if dji video streaming channel is available.",
             "configurewidgetvalue",
             "set the value for a widget of the payload device.  @param index index of the widget. @param type type of the widget. @param value value of the widget. @param callback the execution callback with the returned value(s).",
             "getwidget",
             "gets a widget by specifying the widget type and the index.  @param widgetindex the index of the widget. @param widgettype the type of the widget.  @return the widget corresponding to the widget type and the index. `null` if the widgets are not ready or there is no widget corresponding  to the widget type and the index.",
             "getwidgets",
             "gets the full list of widgets on the payload device. a new instance of nsarray is returned when one of the widget is updated. please use `getconfiginterfacewidgets` instead.  @return the full list of widgets. `null` if the widgets are not fetched yet.",
             "getmaininterfacewidgets",
             "gets the main interface widget list on the payload device. an empty array will be returned if the payload's data is regarded as invalid.  @return a list of widgets. returns nil if no widgets are fetched.",
             "getconfiginterfacewidgets",
             "gets the configuration interface widget list on the payload device. an empty array will be returned if the payload's data is regarded as invalid.  @return a list of widgets. returns nil if no widgets are fetched.",
             "senddatatopayload",
             "sends data to payload.  - the length of the data to send cannot exceed 32 bytes for matrice 200 series.  - the length of the  data to send cannot exceed 128 bytes for matrice 200 v2 series. the throughput cannot exceed the bandwidth returned by `getupstreambandwidth`.  @param data data that will be sent to the payload device. @param callback the execution callback with the returned value(s).",
             "getdevicetype",
             "gets the device type.  @return get an enum value of `payloaddevicetype`.",
             "isfeatureopened",
             "gets the product feature open status. if the product's feature isn't fully opened, there are several  possibilities.  - payload status is abnormal.  - psdk is not bound.  - encryption chip  exception.  - the aircraft doesn't support this payload model.  @return `true` if the product is activated.",
             "getproductphase",
             "gets current payload product phase.  @return get the enum value of `payloadproductphase`.",
             "setmessagecallback",
             "set the message callback, message is a string, the content of string is determined by firmware,  it could be changed dynamically.  @param callback the interface of `hintmessagecallback`.",
             "setcommanddatacallback",
             "set the command data callback, the command data typically sent by payload in uart/can channel, the max bandwidth  of this channel is 3kbytes/s on m200.  @param callback the interface of `commanddatacallback`.",
             "setvideodatareceivedcallback",
             "set the video data callback, the video data from the payload device. the data may be live view or playback.  only supported by matrice 300 rtk.  @param callback the interface of `videodatareceivedcallback`.",
             "setstreamdatacallback",
             "set the udp data callback, this callback is for receiving the non-video data in udp channel, the max bandwidth of  this channel is 8mbps in m200, 4mbps in m210.  @param callback the interface of `streamdatacallback`.",
             "ongetcommanddata",
             "when the payload send some command bytes to the mobile sdk, this method will be called.  @param data the received command data.",
             "ongetstreamdata",
             "when the payload send the bytes to the mobile sdk by udp channel, this method will be called,  note that if dealing of the data block the data feeder, the byte might lost.  @param data the received stream data. @param len valid length of the data.",
             "onvideodatareceived",
             "receives the video data sent from the payload device. the data may be live view or playback.  only supported by matrice 300 rtk.  @param data the received stream data. @param len valid length of the data.",
             "ongetmessage",
             "when the payload send some message string to the mobile sdk, this method will be called.  @param str hint message string.",
             "setmaininterfacewidgetslistener",
             "updates a set of payload shortcuts in main interface. if the pay load's data is invalid, an  empty array will be updated. it is only supported by dji skyport 2.0 and dji x-port.  @param listener the listener received the updated widget values.",
             "setconfigwidgetslistener",
             "updates setting for payload widgets. if the pay load's data is invalid, an empty array will be updated.  @param listener the listener received the updated widget values.",
             "onwidgetvaluechanged",
             "called when the value of the widget is changed.  @param type the enum value of `payloadwidgettype`. @param index the index of the widget. @param newvalue an int value.",
             "addwidgetvaluechangedcallback",
             "set a callback for the specific widget, if the value of the widget is changed, the callback will be called.  @param index the index of the widget. @param type an enum value of `payloadwidgettype`. @param callback the interface of `widgetvaluechangedcallback`.",
             "removewidgetvaluechangedcallback",
             "remove a callback for the widget.  @param index the index of the widget. @param type an enum value of `payloadwidgettype`. @param callback the interface of `widgetvaluechangedcallback`.",
             "removewidgetvaluechangedcallback",
             "remove a callback for the widget.  @param callback the interface of `widgetvaluechangedcallback`.",
             "payloadwidget",
             "class to represent the properties of a payload widget. payload sdk defines different types of widgets for the interaction between the payload device  and the mobile device.",
             "hintmessagecallback",
             "this interface provides a callback to get messages sent from payload to the mobile sdk.",
             "commanddatacallback",
             "this interface provides a callback to get command data sent from payload to the mobile sdk.",
             "videodatareceivedcallback",
             "this interface provides a callback to receive video data sent from the payload.",
             "streamdatacallback",
             "this interface provides a callback to get stream data sent from payload to the mobile sdk.",
             "widgetvaluechangedcallback",
             "this interface provides a callback to get value of the widget when changed.",
             "fetchpayloadwidgetsfile",
             "fetches widget configuration. mobile sdk will fetch the configuration when it first launches.  returns nil if initial fetching failed. it is only supported by dji skyport 2.0.  @param listener the listener of `payloadwidgetdownloadlistener`.",
             "setpayloadchannelpriority",
             "set the channel priority of the payload. priority will affect the bandwidth allocation if it is not `unknown`,  which is the default value. for example, if the data that comes from the payload device mounted on left gimbal is preferred, please set the priority  to `high`, and physicalsource is `left_cam`.  the others should be set to `medium` or `low`.  only supported by matrice 300 rtk.  @param priority the priority to be set, see `videofeedpriority`. @param physicalsource see `physicalsource`. @param callback callback to receive the execution result.",
             "getpayloadchannelpriority",
             "get the channel priority of the payload. only supported by matrice 300 rtk.  @param physicalsource see `physicalsource`. @param callback callback to receive the execution result.",
             "payloadproductphase",
             "development phase has more settings than product phase, including control parameters auto-tuning,  coaxiality detection, balance detection, stiffness adjustment. please note that this phase should be  used with dji assistant 2, which has bound with payload sdk developer account. product phase means  that the product is in the stage ready to sell. during this stage, development settings, i.e., control  parameters auto-tuning, coaxiality detection, balance detection, stiffness adjustment, should be hidden from user interface.",
             "development",
             "the product is in the development phase.",
             "release",
             "the product is in the release phase.",
             "unknown",
             "unknown.",
             "payloaddevicetype",
             "all the possible mode of `payloaddevicetype`.",
             "dji_skyport_1",
             "dji skyport 1.0.",
             "dji_skyport_2",
             "dji skyport 2.0.",
             "dji_x_port",
             "dji x-port.",
             "unknown",
             "unknown.",
             "activateinfo",
             "this class provides the activation information of the payload.",
             "isactivated",
             "`true` if the current payload is activated.  @return a boolean value to check if payload is activated.",
             "setutmissflightdataupdateduploadstatuscallback",
             "called when the utmiss (unmanned aircraft system traffic management information service system) flight data upload status has been updated.  @param callback the callback of `callback`.",
             "getuploadstatus",
             "the current utmiss upload status.  @return an enum value of `utmissflightdatauploadstatus`.",
             "starttoupload",
             "start utmiss flight data upload.  @param param an object of `utmissparam`.  @return an object of `djierror`.",
             "isstarted",
             "start utmiss flight data upload.  @return a boolean value to check if the data upload is started.",
             "getutmisslogpath",
             "utmiss log save path.  @return a string value.",
             "stoptoupload",
             "stop utmiss flight data upload.",
             "callback",
             "this interface provides delegate methods to receive the utmiss (unmanned aircraft system traffic management information service system) flight data upload status.",
             "onupdate",
             "callback to update utmiss (unmanned aircraft system traffic management information service system) flight data upload status.  @param status an enum value of `utmissflightdatauploadstatus`.",
             "utmissparam",
             "this class provides necessary infomation to start utmiss flight data uploading.",
             "getdbpath",
             "get the local save path of flight data to be uploaded.  @return the string value of the save path.",
             "gettokenkey",
             "get the token key applied from caac.  @return the string value of the token key.",
             "getmanufactureid",
             "get the manufacture id of the drone.  @return the string value of the manufacture id.",
             "getuasid",
             "get the uas id of the drone.  @return the string value of the uas id.",
             "utmissflightdatauploadstatus",
             "the utmiss flight data upload status.",
             "idle",
             "the utmiss flight data upload status is idle.",
             "uploading",
             "the utmiss flight data upload status is uploading.",
             "caching",
             "the utmiss flight data upload status is caching.",
             "out_of_data_storage_space",
             "out of data storage space. no more data can be written.",
             "unknown",
             "the utmiss flight data upload status is unknown.",
             "setstatecallback",
             "set accessory aggregation state update callback.  @param callback the execution callback with the execution result returned.",
             "getspotlight",
             "gets the spotlight instance if it is connected.  @return the connected spotlight instance. `null` if no splotlight is connected.",
             "getbeacon",
             "gets the beacon instance if it is connected.  @return the connected beacon instance. `null` if no beacon is connected.",
             "getspeaker",
             "gets the speaker instance if it is connected.  @return the connected speaker instance. `null` if no speaker is connected.",
             "getrtkdongle",
             "gets the rtk dongle instance if it is connected.  @return the connected rtk dongle instance. `null` if no rtk dongle is connected.",
             "getaccessoryaggregationstate",
             "gets the accessory aggregation state.  @return an instance of `accessoryaggregationstate`.",
             "spotlight",
             "this class represents the spotlight accessory mounted on the aircraft. it provides methods to control the spotlight and get the related states.",
             "beacon",
             "the class represents the beacon accessory mounted on the aircraft.",
             "speaker",
             "the class represents the speaker accessory on the aircraft. used transmit audio files and control the speaker.",
             "accessoryaggregationstate",
             "this class contains the latest connectivity state of accessories.",
             "isspotlightconnected",
             "`true` if the spotlight is connected.  @return a boolean value to check if spotlight is connected.",
             "isbeaconconnected",
             "`true` if the beacon is connected.  @return a boolean value to check if beacon is connected.",
             "isspeakerconnected",
             "`true` if the speaker is connected.  @return a boolean value to check if speaker is connected.",
             "isrtkdongleconnected",
             "`true` if the rtk dongle is connected.  @return a boolean value to check if rtk dongle is connected.",
             "callback",
             "an interface for obtaining `accessoryaggregationstate`.",
             "onupdate",
             "callback function that updates the accessory aggregation state.  @param state the accessory aggregation state.",
             "getfileliststate",
             "current file list state of the speaker.  @return an enum value of `fileliststate`.",
             "getdatatransmissionstate",
             "the data transmission state of the speaker.  @return an enum value of `speakerdatatransmissionstate`.",
             "setvolume",
             "sets the volume to play audio. the valid range is [0, 100]. 100 means loudest.  @param value volume value to set. @param callback the execution callback with the returned execution result.",
             "setplaymode",
             "sets the play mode of the speaker to control the behavior after finishing playing a file.  @param mode the play mode to set. @param callback the execution callback with the returned execution result.",
             "starttransmission",
             "starts to send a complete audio file to the aircraft, which can be played by the speaker.  a transmission session can only be started when the transmission state is in `idle`.  if the transmission is started successfully, the state will change  to `ready_to_transmit`. then  call `pacedata` to send data to sdk.  call `markeof` when all data has been sent to sdk. sdk will maintain a  buffer to hold all the data and transmit it to the aircraft. for m2e speaker, the audio file to transmit  should fulfill the following configurations:  - the speaker only receives raw pcm(pulse-code modulation) data of an audio file,  if the audio file is compressed, pcm extraction is needed before the transmission.  - the audio channel is mono.  -  the audio sample rate is 44,100 hz.  - the pcm (pulse-code modulation) sample  depth is 16 bit per sample.  - the audio file is stored in the aircraft instead  of the speaker.  @param info the information of the file to transmit. it is also used to determine the  location the file will be stored in the aircraft. @param listener inform the progress of the data transfer.",
             "pacedata",
             "sends raw pcm data of the audio file to sdk internal logic.  for mavic 2 enterprise, the transmission rate is limited to 80kb/s by sdk.  therefore, sdk will cache the paced data to a local file when the rate of pacing data is over 80kb/s. the paced data will be appended  to the local file. call `markeof` when all data of the data has been paced to sdk.  @param data raw pcm data stream in bytes.  @return `true` if data is paced successfully. otherwise, pacing data is not in the current state or the data size is illegal.",
             "markeof",
             "marks eof (end-of-file). it is used to inform sdk that all data of the file has been paced. sdk will continue  to transmit data to the aircraft. the state will change to `idle` when all data is transmitted.  after calling this method, `pacedata` is invalid until a new transmission session starts. if no  data is paced before calling this method, the transmission session will end immediately.  @return the occurred error if any.",
             "canceltransmission",
             "this will entirely stop the data transfer process and of course clean the transfer thread pool.",
             "play",
             "starts to play the audio file with the specific index.  @param fileindex the file index of the `audiomediafile` to play. @param callback the execution callback with the returned execution result.",
             "stop",
             "stops the speaker from playing audio. the method is only valid when  the playing state is `playing`.  @param callback the execution callback with the returned execution result.",
             "rename",
             "renames the audio file with the specific index. if the operation is started successfully, fileliststate will become `renaming`.  @param index the index of the audio file to rename. @param filename the new file name of the audio file. the file name should not exceed 128 characters. @param callback completion callback to receive the result.",
             "getfilelistsnapshot",
             "returns a copy of the current audio file list from the storage. returns `null` if `getfileliststate` is reset.  @return an array of `audiomediafile` objects.",
             "refreshfilelist",
             "refresh the audio file list in the aircraft.  - if the current state  is `reset`, sdk  will try to fetch the complete file list.  - if the current state is `incomplete`, sdk  will only fetch the missing list of files.  - if the operation is started successfully,  the `fileliststate`  will become `syncing`.  - when the  file list is refreshed successfully, the `fileliststate` will become `up_to_date`.  @param callback completion callback to receive the result.",
             "delete",
             "deletes audio files in the aircraft. if the operation is started successfully, `getfileliststate` will  become `deleting`. if there is error or  failedfiles is not empty, `getfileliststate`  will become `reset`.  @param fileindices a list of audiomediafile's index. @param callback completion callback to receive the result.",
             "addfileliststatelistener",
             "start listen to the update of `getfileliststate`.  @param listener a `fileliststatelistener` interface.",
             "removefileliststatelistener",
             "stop listen to the update of `getfileliststate`.  @param listener listener to be removed.",
             "setstatecallback",
             "sets the callback that updates speaker state.  @param callback the execution callback with the execution result returned.",
             "speakerstate",
             "state of the speaker accessory.",
             "getvolume",
             "the volume of the speaker to play audio.  @return an int value.",
             "getplayingstate",
             "get the audio playing state.  @return an enum value of the `speakerplayingstate`.",
             "getplayingmode",
             "the playing mode of the speaker.  @return an enum value of the `playmode`.",
             "getplayingindex",
             "the index of the audio media file being played. if the speaker is not  playing any files, -1 will be returned.  @return an int value.",
             "getstoragelocation",
             "the storage location of the file that is being played by the speaker.  @return an enum value of the `audiostoragelocation`.",
             "callback",
             "this interface provides a callback to update the speaker's state.",
             "onupdate",
             "callback to update spotlight state.  @param state the spotlight's state.",
             "audiofileinfo",
             "the class contains the basic information of an audio file.",
             "audiofileinfo",
             "creates an `audiofileinfo` instance with a file name and the  storage location on the aircraft.  @param filename the file name of the file. it will be used by the aircraft to store the file  after it is successfully transmitted. a file name should not exceed 20 characters. @param storagelocation the storage location of the file. the aircraft will use it to determine where  to store the file.",
             "getfilename",
             "the file name of the audio file. the aircraft will store the audio file with this file name.  @return a string value.",
             "getstoragelocation",
             "the storage type of the audio file. the storage types will determine the strategy of  the aircraft to keep the file.  @return an enum value of the `audiostoragelocation`.",
             "playmode",
             "the speaker's play mode. it determines the behavior of the speaker when it finishes playing a file.",
             "single_once",
             "the speaker will play the selected file once. the speaker will stop playing after  finishing playing the file.",
             "repeat_single",
             "the speaker will play the selected file repeatedly.",
             "unknown",
             "unknown.",
             "speakerplayingstate",
             "the speaker's playing state.",
             "playing",
             "the speaker is playing the voice.",
             "stopped",
             "the speaker is stopped and playing nothing.",
             "unknown",
             "unknown.",
             "speakerdatatransmissionstate",
             "data transmission state of the speaker.",
             "idle",
             "the speaker is in idle state and is ready for receiving data from the mobile device.  call `starttransmission` to start the data transmission.",
             "ready_to_transmit",
             "the data transmission from the mobile device to the speaker is started.  call `pacedata` to transmit data.",
             "transmiting",
             "the mobile device is transmitting data to the speaker.",
             "unknown",
             "unknown state, either the speaker is disconnected or not recognized.",
             "transmissionlistener",
             "the listener will be notified when the transmission for the audio file starts.",
             "onstart",
             "called when the transmission starts and the aircraft is ready to receive data of the audio file from the mobile device.",
             "onprogress",
             "called to update the transmission progress. the progress is updated when a chunk of data is received successfully by the aircraft.  @param datasize the accumulated data size of the audio file received by the aircraft.",
             "onfinish",
             "called when the transmission finishes successfully.  @param index the index assigned by the aircraft for the new audio file.",
             "onfailure",
             "called when the transmission is interrupted by an error.  @param error the possible error during the transmission.",
             "getenabled",
             "determines if the beacon is enabled.  @param callback the execution callback with the returned value(s).",
             "setenabled",
             "enables the beacon to turn it on. the beacon will start blink.  @param enabled `true` to turn on the beacon. @param callback the execution callback with the returned execution result.",
             "setstatecallback",
             "set spotlight state update callback.  @param callback the execution callback with the execution result returned.",
             "getstate",
             "gets the state of the spotlight.  @return an instance of `spotlightstate`.",
             "getenabled",
             "gets on/off status of spotlight.  @param callback the execution callback with the returned value(s).",
             "setenabled",
             "enables the spotlight to turn it on.  @param enabled `true` to turn on the spotlight. @param callback the execution callback with the returned execution result.",
             "setbrightness",
             "sets the brightness of the spotlight. the valid range is [1, 100]. 100 means the brightest.  @param value brightness value to set. @param callback the execution callback with the returned execution result.",
             "spotlightstate",
             "the state of the spotlight accessory.",
             "gettemperature",
             "returns the temperature of the spotlight in celsius.  @return an float value.",
             "getbrightness",
             "the configurable brightness of the spotlight.  @return an int value.",
             "callback",
             "this interface provides a callback to update the spotlight's current state.",
             "onupdate",
             "callback to update spotlight state.  @param state the spotlight's state.",
             "warninglevel",
             "the warning level of the status",
             "none",
             "the status has an undetermined warning level.",
             "offline",
             "the status is offline.",
             "good",
             "the status is good.",
             "warning",
             "the status is a warning.",
             "error",
             "the status is an error.",
             "isurgentmessage",
             "get the urgency of the message.  @return `true` if message is urgent, `false` otherwise.",
             "getwarninglevel",
             "get the warning level of the message.  @return warninglevel type of the warning level.",
             "getmessage",
             "get the message of the warning status item.  @return string message for the warningstatusitem.",
             "getdefaultitem",
             "get a default warning status item with  - warning level: warninglevel.offline  - urgentmessage: false  - message:  (empty string)  this can be used for initialization.  @return default warningstatusitem.",
             "gettestitem",
             "get a test warning status item with  - warning level: warninglevel.error  -  urgentmessage: true  - message: test warning status logic item  this can be used for unit and integration testing as required.  @return default warningstatusitem.",
             "isinmacau",
             "check if the drone location is in macau.  @return `true` if current location is macau.",
             "isinhongkong",
             "check if the drone location is in hong kong.  @return `true` if current location is hong kong.",
             "isinchina",
             "check if the drone location is in china.  @return `true` if current location is in china.",
             "setlistener",
             "set a listener of the videosizelistener interface.  @param listener a listener for the videosizelistener interface.",
             "setvideotypebysize",
             "set video type by video size and camera index.  @param videowidth width of the video as received from the djicodecmanager. @param videoheight height of the video as received from the djicodecmanager. @param cameraindex index of the camera which is the source of the video.",
             "setvideoisrotated",
             "set video orientation.  @param isrotated `true` for portrait orientation and false for landscape.",
             "setscreentypebysize",
             "set screen type by screen size using the view width and height.  @param viewwidth width of the view in which the video is being displayed. @param viewheight height of the view in which the video is being displayed.",
             "calculatevideosize",
             "calculate the video size with the set options.",
             "videosizelistener",
             "interface for listening to changes in video size",
             "onvideosizechanged",
             "invoked when the video size is changed.  @param width the width of the video size. @param height the height of the video size. @param relativewidth the relative width of the video size. @param relativeheight the relative height of the video size.",
             "completioncallback<t",
             "completion callback for asynchronous operations when no information needs to be returned from the operation.",
             "onresult",
             "invoked when the asynchronous operation completes. if the operation  completes successfully, `error` will be `null`. override to handle in your own code.  @param error the dji error result",
             "completioncallbackwith<t>",
             "completion callback for asynchronous operations when information that requires one parameter (t) needs to be returned from the operation. the parameter t will be defined where the operation called.",
             "onsuccess",
             "invoked when the asynchronous operation completes successfully. override to handle in your own code.  @param t the parameter being returned.",
             "onfailure",
             "invoked when the asynchronous operation fails to complete normally. override to handle in your own code.  @param error the dji error result",
             "y>",
             "completion callback for asynchronous operations when information that requires two parameters (x, y) needs to be returned from the  operation. the parameters x and y will be defined where the operation is called.",
             "onsuccess",
             "invoked when the asynchronous operation completes successfully. override to handle in your own code.  @param x the first parameter being returned. @param y the second parameter being returned.",
             "onfailure",
             "invoked when the asynchronous operation fails to complete normally. override to handle in your own code.  @param error the dji error result",
             "loadmission",
             "loads the waypointmission into device memory. this also verifies all the information of `mission`. if something is incorrect, callback.result() will be called with an error. otherwise, callback.result() will be called with a `null` value. the `mission` object will remain in device memory even after the waypointmission execution has finished.  @param mission waypoint mission to load.  @return returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
             "getloadedmission",
             "gets the currently loaded mission of the operator. there are two ways to load a mission. 1. a mission can be loaded by user through `loadmission`. 2. if the aircraft is already executing a waypoint mission when sdk is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. in that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. user can call `downloadmission` to get all the information for the loaded mission. the `getloadedmission` will be reset to `null` when the execution of the loadedmission is stopped, finished or interrupted.  @return a object of `waypointmission`.",
             "getpreviousinterruption",
             "gets the interruption of the last waypoint mission. if a waypoint mission is interrupted before the completion, the aircraft will record the interruption information. this information is only available when the last waypoint mission is incomplete and the first waypoint of the mission has been reached. the interruption will also be recorded if the mission is stopped by the user. the interruption information is recorded in the aircraft and the information persists even after the aircraft's reboot. supported only by phantom 4 rtk.  @param callback the execution callback with the returned execution result.",
             "uploadmission",
             "starts to upload the `getloadedmission` to the aircraft. it can only be called when the `getloadedmission` is complete and the `getcurrentstate` is `ready_to_upload`. if a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. after a mission is uploaded successfully, the `waypointmissionstate` will become `ready_to_execute`.  @param callback completion block that will be called when the upload operation succeeds or fails to start. ",
             "retryuploadmission",
             "retry upload waypoint mission.  @param callback the execution callback with the returned execution result.",
             "downloadmission",
             "downloads information of each waypoint from aircraft and save it to `getloadedmission`. if a download operation is started, the operator will download the information of waypoints missing in `getloadedmission` one-by-one in ascending order. if `getloadedmission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. it can only be called when the `getcurrentstate` is one of the following: - `executing` - `execution_paused`  @param callback completion callback that will be called when the download operation succeeds or fails to start. ",
             "startmission",
             "starts the execution of the uploaded mission. it can only be called when the `getcurrentstate` is `ready_to_execute`. after a mission is started successfully, the `getcurrentstate` will become `executing`.  @param callback completion block that will be called when the operator succeeds or fails to start the execution. if it fails, an error will be returned.",
             "resumemission",
             "resumes the paused mission. it can only be called when the `getcurrentstate` is `execution_paused`. after a mission is resumed successfully, the `getcurrentstate` will become `executing`.  @param callback completion block that will be called when the operator succeeds or fails to resume the mission. if it fails, an error will be returned.",
             "pausemission",
             "pauses the executing mission. it can only be called when the `waypointmissionstate` is `executing`. after a mission is paused successfully, the `getcurrentstate` will become `execution_paused`.  @param callback completion block that will be called when the operator succeeds or fails to pause the mission. if it fails, an error will be returned.",
             "stopmission",
             "stops the executing or paused mission. it can only be called when the `getcurrentstate` is one of the following: - `executing` - `execution_paused` after a mission is stopped successfully, `getcurrentstate` will become `ready_to_upload`.  @param callback completion block that will be called when the operator succeeds or fails to stop the mission. if it fails, an error will be returned.",
             "getcurrentstate",
             "the current state of the operator.  @return a object of `waypointmissionstate`.",
             "addlistener",
             "add listener to listen for events.  @param listener an object of `waypointmissionoperatorlistener`.",
             "removelistener",
             "removes listener. if the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener listener to be removed.",
             "waypointmission",
             "in the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. waypoints are physical locations to which the aircraft will fly. creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. actions can also be added to waypoints, which will be carried out when the aircraft reaches the waypoint. the aircraft travels between waypoints automatically at a base speed. however, the user can change the speed by using the pitch joystick. if the stick is pushed up, the speed will increase. if the stick is pushed down, the speed will slow down. the stick can be pushed down to stop the aircraft and further pushed to start making the aircraft travel back along the path it came. when the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each waypoint. if the stick is released, the aircraft will again travel through the waypoints in the original order, and continue to execute waypoint actions (even if executed previously). if the aircraft is pulled back along the waypoint mission all the way to the first waypoint, then it will hover in place until the stick is released enough for it to again progress through the mission from start to finish. it is not supported by mavic pro when using wifi connection. it is not supported by spark, mavic mini, dji mini 2, dji mini se, mavic air 2, dji air 2s and matrice 300 rtk.",
             "waypointv2mission",
             "in the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. waypoints are physical locations to which the aircraft  will fly. creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. actions can also be added to waypoints, which will be carried out when the aircraft reaches the  waypoint. the aircraft travels between waypoints automatically at a base speed. however, the user can  change the speed by using the pitch joystick. if the stick is pushed up, the speed will increase. if the stick is pushed down, the speed will slow down. the stick can be pushed down to stop the aircraft  and further pushed to start making the aircraft travel back along the path it came. when the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each  waypoint. if the stick is released, the aircraft will again travel through the waypoints in the original  order, and continue to execute waypoint actions (even if executed previously). if the aircraft is pulled  back along the waypoint mission all the way to the first waypoint, then it will hover in place until the  stick is released enough for it to again progress through the mission from start to finish. it is only supported by `matrice_300_rtk`.",
             "waypointmissionevent",
             "waypoint event base class.",
             "waypointmissionuploadevent",
             "the upload event of a waypoint mission.",
             "waypointmissiondownloadevent",
             "the download event of a waypoint mission.",
             "waypointmissionexecutionevent",
             "the execution event of a waypoint mission.",
             "waypointmissionstate",
             "all the possible state of `waypointmissionoperator`.",
             "not_supported",
             "the connected product does not support waypoint mission.",
             "ready_to_upload",
             "the aircraft is ready to upload a mission.",
             "uploading",
             "the uploading is started successfully. detail information for each waypoint is being uploaded one by one.",
             "ready_to_execute",
             "waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
             "executing",
             "the execution is started successfully.",
             "execution_paused",
             "waypoint mission is paused successfully. user can call `resumemission` to continue the execution.",
             "disconnected",
             "the connection between the mobile device, remote controller and aircraft is broken.",
             "recovering",
             "the connection between the mobile device, remote controller and aircraft is built-up. the operator is synchronizing the state from the aircraft.",
             "unknown",
             "the state of the operator is unknown. it is the initial state when the operator is just created.",
             "geterror",
             "error for waypoint mission event.  @return an object of `djierror`.",
             "getprogress",
             "the upload progress of the mission. it is `null` if there is an error during upload.  @return an object of `waypointuploadprogress`.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `waypointmissionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `waypointmissionstate`.",
             "waypointuploadprogress",
             "the upload progress of the waypoint mission operator.",
             "getprogress",
             "the download progress of the mission. it is `null` if there is an error during download.  @return a object of `waypointdownloadprogress`.",
             "waypointdownloadprogress",
             "the download progress of the waypoint mission operator.",
             "getprogress",
             "the execution progress of the mission. it is `null` if there is an error during the execution.  @return an object of `waypointexecutionprogress`.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `waypointmissionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `waypointmissionstate`.",
             "waypointexecutionprogress",
             "the mission execution progress of the waypoint mission operator.",
             "waypointmissionexecutestate",
             "current waypoint mission state.",
             "waypointmissionoperatorlistener",
             "listener interface for waypoint mission operator events.",
             "onuploadupdate",
             "called when an upload event happens.  @param uploadevent upload event",
             "ondownloadupdate",
             "called when an download event happens.  @param downloadevent download event",
             "onexecutionstart",
             "called when the waypoint mission starts.",
             "onexecutionupdate",
             "called when there is an execution update for the waypoint mission operator.  @param executionevent execution event.",
             "onexecutionfinish",
             "called when the waypoint mission ends.  @param error error if the waypoint mission didn't end as expected.",
             "uploadedwaypointindex",
             "the index of the last uploaded waypoint. information for each waypoint is uploaded one by one in ascending order. if no waypoint has been uploaded, the value will be -1.",
             "totalwaypointcount",
             "the total count of waypoints in the waypoint mission.",
             "issummaryuploaded",
             "the waypoint mission operator has uploaded the the mission's summary (information except waypoints).",
             "issummarydownloaded",
             "`true` if waypoint summary is downloaded.",
             "totalwaypointcount",
             "the total count of waypoints in the waypoint mission.",
             "downloadedwaypointindex",
             "the index of the last downloaded waypoint. information for each waypoint is downloaded one by one in ascending order. if no waypoint has been downloaded, the value will be -1.",
             "targetwaypointindex",
             "index of the waypoint for the next mission to which the aircraft will proceed.",
             "iswaypointreached",
             "yes when the aircraft reaches a waypoint. after the waypoint actions and heading change is complete, the `targetwaypointindex` will increment and this property will become no.",
             "executestate",
             "current execution state of the aircraft.",
             "initializing",
             "waypoint mission is initializing, which means the mission has started and the aircraft is going to the first waypoint.",
             "moving",
             "aircraft is currently moving toward the mission's next waypoint. this happens when the `waypointmissionflightpathmode` is set to `normal`.",
             "curve_mode_moving",
             "aircraft is currently moving. this happens when the `waypointmissionflightpathmode` is set to `curved`.",
             "curve_mode_turning",
             "aircraft is currently turning. this happens when the `waypointmissionflightpathmode` is set to `curved`.",
             "begin_action",
             "aircraft has reached a waypoint, has rotated to the new heading and is now processing actions. this state will be called before the waypoint actions starts executing and will occur for each waypoint action.",
             "doing_action",
             "aircraft is at a waypoint and is executing an action.",
             "finished_action",
             "aircraft is at a waypoint and has finished executing the current waypoint action. this state occurs once for each waypoint action.",
             "return_to_first_waypoint",
             "aircraft has returned to the first waypoint. this happens when the `getfinishedaction` is set to `return_to_first_waypoint`.",
             "paused",
             "the mission is currently paused by the user.",
             "getloadedmission",
             "gets the currently loaded mission of the operator. there are two ways to load a mission. 1. a mission can be loaded by user through `loadmission`. 2. if the aircraft is already executing a waypoint mission when sdk is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. in that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. user can call `downloadmission` to get all the information for the loaded mission. the `getloadedmission` will be reset to `null` when the execution of the loadedmission is stopped, finished.  @return an object of `waypointv2mission`.",
             "loadmission",
             "loads a waypoint mission into the operator. a mission can be loaded only when the `waypointv2missionstate` is one of the following :  - `ready_to_upload`  - `ready_to_execute`  calling `loadmission` when the current state is `ready_to_execute` will change the state to `ready_to_upload`. after calling `getloadedmission`,  @param mission waypoint mission to load. @param callback returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
             "getloadedactioncount",
             "gets the currently loaded actions count of the operator. there are two ways to load a mission. 1. actions can be loaded by user through `loadmission`. 2. if the aircraft is already executing a waypoint mission and it has uploaded actions when sdk is re-connected, the operator will recover uploaded action count.  @return an int value of loaded action count.",
             "getloadedactions",
             "gets the count of loaded actions in current operator. there are two ways to load a mission. 1. actions can be loaded by user through `loadmission`. 2. if the aircraft is already executing a waypoint mission and it has uploaded actions when sdk is re-connected, the operator will recover uploaded action count. load it automatically. in that case, the loaded actions will be `null`, if user want get summary of the executing actions user can call `downloadmission` to get all the information for the loaded actions. the `getloadedactions` will be reset to `null` when the execution of the getloadedmission is stopped, finished.  @return a list of `waypointv2action` objects.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `waypointv2missionstate`.",
             "getcurrentactionstate",
             "the current action state of the operator.  @return an object of `actionstate`.",
             "addwaypointeventlistener",
             "add listener to listen for waypoint events.  @param listener an object of djiwaypointv2missionoperator_listener</code>.",
             "removewaypointlistener",
             "removes listener. if the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener listener to be removed.",
             "addactionlistener",
             "add listener to listen the events.  @param listener an object of djiwaypointv2missionoperator_actionlistener</code>.",
             "removeactionlistener",
             "removes listener. if the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener listener to be removed.",
             "waypointv2missionoperatorlistener",
             "listen mission event.",
             "ondownloadupdate",
             "called when an download event happens.  @param downloadevent the download event.",
             "onuploadupdate",
             "called when an upload event happens.  @param uploadevent the upload event.",
             "onexecutionupdate",
             "called when there is an execution update for the waypoint mission operator.  @param executionevent execution event.",
             "onexecutionstart",
             "called when the waypoint mission starts.",
             "onexecutionfinish",
             "called when the waypoint mission ends.  @param error error if the waypoint mission didn't end as expected.",
             "onexecutionstopped",
             "called when the waypoint mission is stopped by the user.",
             "waypointv2actionlistener",
             "listener that is interested on action event.",
             "ondownloadupdate",
             "called when a download event happens.  @param downloadevent the callback interface of `actiondownloadevent`.",
             "onuploadupdate",
             "called when an upload event happens.  @param uploadevent upload event.",
             "onexecutionupdate",
             "called when an execution update event happens.  @param executionevent execution event.",
             "onexecutionstart",
             "called when an execution start event happens.  @param actionid an int value of the execution action index.",
             "onexecutionfinish",
             "called when an execution finish event happens.  @param actionid an int value of the execution action index. @param error an object of `djiwaypointv2error`.",
             "actiondownloadevent",
             "the download event of a waypoint mission.",
             "getprogress",
             "the download progress of the mission. it is `null` if there is an error during download.  @return an object of djiwaypointv2action_djiwaypointv2actiondownloadprogress</code>.",
             "geterror",
             "the encountered error during download if there is any. otherwise, it is `null`.  @return an object of `djiwaypointv2error`.",
             "actionuploadevent",
             "the upload event of a waypoint mission.",
             "getpreviousstate",
             "the previous state of the action.  @return an object of `actionstate`.",
             "getcurrentstate",
             "the current state of the action.  @return an object of `actionstate`.",
             "getprogress",
             "the upload progress of the mission. it is `null` if there is an error during upload.  @return an object of `actionuploadprogress`.",
             "geterror",
             "the encountered error during upload if there is any. otherwise, it is `null`.  @return an object of `djiwaypointv2error`.",
             "actionexecutionevent",
             "the execution event of a waypoint mission.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `actionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `actionstate`.",
             "getprogress",
             "the execution progress of the mission. it is `null` if there is an error during the execution.  @return an object of `actionexecutionprogress`.",
             "geterror",
             "the encountered error during the execution if there is any. otherwise, it is `null`.  @return an object of `djiwaypointv2error`.",
             "actionuploadprogress",
             "the upload progress of the waypoint mission operator.",
             "getlastuploadedwaypointindex",
             "the upload progress of the waypoint mission operator.  @return an int value.",
             "gettotalactioncount",
             "the total count of actions in the waypoint mission.  @return an int value.",
             "uploadmission",
             "starts to upload the `getloadedmission` to the aircraft. it can only be called when the `getloadedmission` is complete and the djiwaypointv2missionactionexecutionevent_currentstate</code> is `ready_to_upload`. if a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. after a mission is uploaded successfully, the `waypointv2missionstate` will become `ready_to_execute`.  if it is started successfully, use djiwaypointv2missionoperator_listener_onuploadupdate</code> to receive the detailed progress.  @param callback callback will be invoked with the result if the upload command has been received successfully by the aircraft. if the upload command is successfully sent, use `addwaypointeventlistener` to check the detailed progress.",
             "uploadwaypointactions",
             "starts to upload the `getloadedactions` to the aircraft. it can only be called when the `getloadedactions` is complete and the djiwaypointv2missionactionexecutionevent_currentstate</code> is `ready_to_execute`. if a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. after a mission is uploaded successfully, the djiwaypointv2missionactionstate</code> will become `ready_to_execute`.  @param actions a list of `waypointv2action` objects. @param callback callback will be invoked with the result if the upload action command has been received successfully by the aircraft. if the upload command is successfully sent, use `addactionlistener` to check the detailed progress.",
             "downloadmission",
             "downloads information of each waypoint from aircraft and save it to `getloadedmission`. if a download operation starts, the operator will download the information of waypoints missing in `getloadedmission` one-by-one in ascending order. if `getloadedmission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is one of the following:  - `executing`  - `interrupted`.  @param callback callback that will be called when the download operation succeeds or fails to start. if it is started successfully, use djiwaypointv2missionoperator_listener_ondownloadupdate</code> to receive the detailed progress.",
             "downloadactions",
             "downloads information of actions from startactionid to endactionid. the information of waypoints missing in `getloadedmission` ascending order. if `getloadedmission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is one of the following:  - `executing`  - `interrupted`  @param callback callback that will be called when the download operation succeeds or fails to start. if it is started successfully, use djiwaypointv2missionoperator_addlistenertodownloadevent</code> to receive the detailed progress.",
             "startmission",
             "starts the execution of the uploaded mission. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is `ready_to_execute`. after a mission is started successfully, the djiwaypointv2missionactionexecutionevent_currentstate</code> will become `executing`.  @param callback completion block that will be called when the operator succeeds or fails to start the execution. if it fails, an error will be returned.",
             "interruptmission",
             "pauses the executing mission. it can only be called when the `waypointv2missionstate` is `executing`. after a mission is paused successfully, the djiwaypointv2missionactionexecutionevent_currentstate</code> will become `interrupted`.  @param callback callback that will be called when the operator succeeds or fails to pause the mission. if it fails, an error will be returned.",
             "recovermission",
             "resumes the paused mission. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is `interrupted`. after a mission is resumed successfully, the djiwaypointv2missionactionexecutionevent_currentstate</code> will become `executing`.  @param callback callback that will be called when the operator succeeds or fails to resume the mission. if it fails, an error will be returned.",
             "recovermission",
             "resumes the paused mission with recover type. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is `interrupted`. after a mission is resumed successfully, the djiwaypointv2missionactionexecutionevent_currentstate</code> will become `executing`.  @param type an enum value of `interruptrecoveractiontype` @param callback callback that will be called when the operator succeeds or fails to resume the mission. if it fails, an error will be returned.",
             "stopmission",
             "stops the executing or paused mission. it can only be called when the djiwaypointv2missionactionexecutionevent_currentstate</code> is one of the following:  - `executing`  - `interrupted` after a mission finishes successfully, djiwaypointv2missionactionexecutionevent_currentstate</code> will become `ready_to_upload`.  @param callback completion block that will be called when the operator succeeds or fails to resume the mission. if it fails, an error will be returned.",
             "setautoflightspeed",
             "set the flight speed while the mission is executing automatically (without manual joystick speed input). this is the only property or method in this class that can communicate with the aircraft during a mission. all other properties and methods are used offline to prepare the mission which is then uploaded to the aircraft.  @param speed auto flight speed to be set. the absolute value of the auto flight speed should be less than or equal to the `getmaxflightspeed`. its range is [-`getmaxflightspeed`, `getmaxflightspeed`] m/s. @param callback callback.",
             "getautoflightspeed",
             "get the flight speed while the mission is executing.  @param callback callback.",
             "waypointv2missionexecutionevent",
             "the execution event of a waypoint mission.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `waypointv2missionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `waypointmissionstate`.",
             "getprogress",
             "the execution progress of the mission. it is `nil` if there is an error during the execution.  @return an object of `waypointv2executionprogress`.",
             "geterror",
             "the encountered error during the execution if there is any. otherwise, it is `nil`.  @return an object of `djiwaypointv2error`.",
             "waypointv2missiondownloadevent",
             "the download event of a waypoint mission.",
             "getprogress",
             "the download progress of the mission. it is `nil` if there is an error during download.  @return an object of `waypointv2downloadprogress`.",
             "geterror",
             "the encountered error during download if there is any. otherwise, it is `nil`.  @return an object of `djiwaypointv2error`.",
             "waypointv2missionuploadevent",
             "the upload event of a waypoint mission.",
             "getpreviousstate",
             "the previous state of the operator.  @return an enum value of the `waypointv2missionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an enum value of the `waypointv2missionstate`.",
             "getprogress",
             "the upload progress of the mission. it is `null` if there is an error during uploading.  @return an object of the `waypointv2uploadprogress`.",
             "geterror",
             "the encountered error during upload if there is any. otherwise, it is `nil`.  @return an object of the `djiwaypointv2error`.",
             "waypointv2missionstate",
             "all the possible state of `waypointv2missionoperator`.",
             "unknown",
             "the state of the operator is unknown.",
             "disconnected",
             "the connection between the mobile device, remote controller and aircraft is broken.",
             "recovering",
             "the connection between the mobile device, remote controller and aircraft is built-up. the operator is synchronizing the state from the aircraft.",
             "not_supported",
             "the connected product does not support waypoint mission 2.0.",
             "ready_to_upload",
             "the aircraft is ready to upload a mission.",
             "uploading",
             "the uploading is started successfully. detail information for each waypoint is being uploaded one by one.",
             "ready_to_execute",
             "waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
             "executing",
             "the execution is started successfully.",
             "interrupted",
             "waypoint mission is paused successfully. user can call `interruptmission` to continue the execution.",
             "actionstate",
             "all the possible action state of `waypointv2missionoperator`.",
             "unknown",
             "the state of the operator is unknown. it is the initial action state when the operator is just created.",
             "disconnected",
             "the connection between the mobile device, remote controller and aircraft is broken.",
             "recovering",
             "the connection between the mobile device, remote controller and aircraft is built-up. the operator is synchronizing the action state from the aircraft.",
             "not_supported",
             "the connected product does not support waypoint mission 2.0.",
             "ready_to_upload",
             "the aircraft is ready to upload actions.",
             "uploading",
             "the uploading is started successfully. detail information for each action is being uploaded one by one.",
             "ready_to_execute",
             "waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
             "executing",
             "the execution is started successfully.",
             "interrupted",
             "waypoint mission is interrupted successfully. user can call `interruptmission` to continue the execution.",
             "waypointv2action",
             "this class represents an action for `waypointv2mission`. it determines how action is performed when a waypoint mission is executed.",
             "getactionid",
             "the id of action.  @return an int value of action id.",
             "gettrigger",
             "the trigger of action.  @return an object of `waypointtrigger`.",
             "getactuator",
             "the actuator of action.  @return an object of `waypointactuator`.",
             "builder",
             "the class is used to create the instance of `waypointv2action`.",
             "setactionid",
             "sets the action id.  @param actionid the value of action id.  @return the build of `builder`.",
             "settrigger",
             "sets the trigger.  @param trigger the object of `waypointtrigger`.  @return the build of `builder`.",
             "setactuator",
             "sets the actuator.  @param actuator the object of `waypointactuator`.  @return the build of `builder`.",
             "build",
             "create an object of `waypointv2action`.  @return the object of `waypointv2action`.",
             "intelligenthotpointmission",
             "this class represents an intelligent hotpoint mission. in an intelligent hotpoint mission, the aircraft will  repeatedly fly circles of a constant radius around a specified point called a hotpoint. the user can control  the aircraft to fly around the hotpoint with a specific radius and altitude. during execution, the user can  also use the physical remote controller to modify its radius and speed. it is only supported by mavic 2 zoom and mavic 2 pro.",
             "ispoimodeenabled",
             "`true` if poi mode is enabled. value is undefined if  the `getcurrentstate` is one of the  following:  - `not_supported`  - `disconnected`  - `recovering`.  now only  supported by mavic 2 zoom and mavic 2 pro.  @return a boolean value to check if poi mode is enabled.",
             "enablepoimode",
             "enable poi mode. enabling poi mode is the pre-condition of starting intelligent hotpoint mission.  now only supported by mavic 2 zoom and mavic 2 pro.  @param callback completioncallback callback that receives the execution result.",
             "disablepoimode",
             "disable poi mode. when poi mode is disabled, you can not starting intelligent hotpoint mission.  now only supported by mavic 2 zoom and mavic 2 pro.  @param callback completion callback that receives the execution result.",
             "getcurrentstate",
             "the current state of the executing intelligent hotpoint mission.  @return an object of `intelligenthotpointmissionstate`.",
             "addlistener",
             "adds listener to receive all of the intelligent hotpoint mission operator events.  @param listener listener that is interested in the intelligent hotpoint mission operator.",
             "removelistener",
             "removes listener. if the listener is listening to events and notifications, then it will stop listening to  all if called with this method.  @param targetlistener listener to be removed.",
             "removealllisteners",
             "remove all listeners from listener pool.",
             "startmission",
             "starts to execute an intelligent hotpoint mission. this only be called when the `getcurrentstate`  is `ready_to_start`. after a mission is started successfully, the `getcurrentstate` will become `executing`.  if the mission starts successful, the aircraft will fly arround the hotpoint of the mission. the current horizontal distance between the aircraft and the hotpoint must  be [5,500]. the current vertical distance between the aircraft and the relative takeoff altitude must be [5,500].  @param mission an object of `intelligenthotpointmission`. @param callback completion callback that will be called when the operator succeeds or fails to start the mission. if it fails, an error will be returned.",
             "startrecognizetargetinrect",
             "send a target rect in video stream to aircraft, the vision system will recognize the target in the rect. this only be called when  the `getcurrentstate` is `ready_to_start`.  after recognize target success, the `getcurrentstate` will become `waiting_for_confirmation`  means recognize the target successfully or `ready_to_start` means can not recognize the target.  @param rectf the tracking target rect in video stream. @param callback completion callback that will be called when the operator succeeds or fails to start recognize target. if it fails, an error will be returned.",
             "acceptconfirmation",
             "confirm the recognized target, only be called when the `getcurrentstate`  is `waiting_for_confirmation`. if accept successfully,  the `getcurrentstate` will become `measuring_target`,  the aircraft will measure the the target and calculate surrounding path. then the aircraft will start circle around the target on the surrounding path and `getcurrentstate`  will become `executing`.  @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "pausemission",
             "pauses the executing mission. it can only be called when the `getcurrentstate` is `executing`.  after a mission is paused successfully, the `getcurrentstate` will become `execution_paused`.  @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "resumemission",
             "resumes the paused mission. it can only be called when the `getcurrentstate`  is `execution_paused`. after a mission is resumed successfully,  the `getcurrentstate` will become `executing`.  @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "stopmission",
             "stops the executing or paused mission. it can only be called when `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  after a mission is stopped successfully, `getcurrentstate` will become `ready_to_start`.  @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "setangularvelocity",
             "sets angular velocity for the executing mission. it can only be called when `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  @param angularvelocity angular velocity to set. @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "setradius",
             "sets radius for the executing mission. it can only be called when the `getcurrentstate` is one of the  following:  - `executing`  - `execution_paused`  @param radius radius to set. @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "setaltitude",
             "sets altitude for the executing mission. it can only be called when the `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  @param altitude altitude to set. @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "resetgimbaltocenter",
             "reset gimbal to center for the executing mission, the camera will direct to the target. it can only be called when the `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  this feature is only avaliable in recognize mission.  @param callback completion callback that will be called when the operator succeeds or fails. if it fails, an error will be returned.",
             "intelligenthotpointmissionoperatorlistener",
             "listener interface for listening to intelligent hotpoint mission events.",
             "onexecutionupdate",
             "called when a new intelligent hotpoint mission event occurs.  @param event updated event.",
             "onexecutionstart",
             "called when the intelligent hotpoint mission starts.",
             "onexecutionfinish",
             "called when the intelligent hotpoint mission ends.  @param error used when mission is finishes in an unexpected way.",
             "intelligenthotpointmissionstate",
             "the states of the `intelligenthotpointmissionoperator`.",
             "unknown",
             "the state of the operator is unknown. this is the initial state when the operator has just been created.",
             "disconnected",
             "the state of the operator is unknown. this is the initial state when the operator has just been created.",
             "recovering",
             "the connection between the mobile device and aircraft is recovering. at this time, the operator is  synchronizing the state from the aircraft.",
             "not_supported",
             "the connected product does not support hotpoint mission.",
             "not_ready",
             "the operator is not ready to start an intelligent hotpoint mission.",
             "ready_to_start",
             "the operator is ready to start an intelligent hotpoint mission.",
             "recognizing_target",
             "the aircraft's vision system is recognizing the track object. if recognized the target, the state will change to `waiting_for_confirmation`.",
             "waiting_for_confirmation",
             "the aircraft has recognized the target and is waiting for confirmation.",
             "measuring_target",
             "confirm success and when a tracking mission started, the vision system will measure the track object and calculate the surrounding path. then it will begin to surround the track target. the state will change  to `executing`.",
             "executing",
             "the execution is started successfully.",
             "execution_paused",
             "hotpoint mission is paused successfully. user can call `resumemission` to continue the execution.",
             "intelligenthotpointmissionevent",
             "this class encapsulates all the state changes of the intelligent hotpoint mission operator.",
             "getpreviousstate",
             "get the previous state of the operator.  @return an object of `intelligenthotpointmissionstate`.",
             "getcurrentstate",
             "get the current state of the operator.  @return an object of `intelligenthotpointmissionstate`.",
             "getmissionmode",
             "gets the current mission mode.  @return an enum value of `intelligenthotpointmissionmode`.",
             "gettargetrectf",
             "get a bounding box for the target. the rectangle is normalized to [0,1] where (0,0) is the top left of  the video preview and (1,1) is the bottom right. when send target rect to vision system, it will  recognize the target and push modified target bounding box. value is available if  the `getcurrentstate`  is `recognizing_target`,  `waiting_for_confirmation`,  `measuring_target`.  @return an object of rectf",
             "getradius",
             "gets the intelligent hotpoint radius in meters of the mission. if there is no executing mission, it is 0.  @return a float value of current radius.",
             "gettargetradius",
             "gets the target intelligent hotpoint radius in meters of the mission. set by user, and the `getradius`  will change to `gettargetradius`. if there is no executing mission, it is 0.  @return a float value of target radius.",
             "getaltitude",
             "gets the current intelligent hotpoint altitude in meters of the mission.  @return a float value of current altitude.",
             "gettargetaltitude",
             "gets the target intelligent hotpoint altitude in meters of the mission. setted by user, and the `getaltitude`  will change to `gettargetaltitude`.  @return a float value of target altitude.",
             "getmaxangularvelocity",
             "gets the intelligent hotpoint max angular velocity from current radius. this value depends on the current situation of the aircraft.  @return a float value of max angularvelocity.",
             "getangularvelocity",
             "gets the current intelligent hotpoint angular velocity from current radius.  @return a float value of angularvelocity.",
             "gethotpoint",
             "gets the intelligent hotpoint's coordinate of the mission.  @return an object of `locationcoordinate2d`.",
             "geterror",
             "gets the intelligent hotpoint's encountered error if there is any. otherwise, it is `null`.  @return an object of `djierror`.",
             "isactive",
             "`true` if the trigger is currently active. the trigger is active when the timeline element it is associated with is being executed in the timeline.  @return `true` if active.",
             "setaction",
             "the action to execute. it is up to the trigger's implementation to decide when to call this action. the action should never be called by anything but the trigger. actions can be implemented without using this property, but in addition `notifylistenersofevent` needs to be used to notify any listeners of the trigger that an action was executed.  in future subclasses of this property to be provided, this action  block will be used to give developers control of an action when a  set of criteria has been met. for example, a subclass of this may  be a battery threshold trigger. once the battery passes some threshold developers will be able to define the action they want to trigger.  @param action action to trigger.",
             "start",
             "begins trigger activity including monitoring the criteria required to  trigger the action. when subclassing,  the super class's start</code> method should be called on the first line.",
             "stop",
             "ends all trigger activities including monitoring the criteria required to trigger the action. when subclassing,  the super class's stop</code> method should be called at the end.",
             "addlistener",
             "adds a listener to all trigger events  @param listener a listener object",
             "removelistener",
             "removes the listener from the listeners pool of all trigger events.  @param listener a previously added listener object.",
             "removealllisteners",
             "removes all listeners from the listeners pool of all trigger events.",
             "notifylistenersofevent",
             "notifies listeners about a trigger event. should be used in subclasses especially after calling the action.  @param event a valid djimissiontriggerevent. @param error an optional error.",
             "action",
             "the type for the block being called when the trigger is triggered.",
             "oncall",
             "call the action.",
             "listener",
             "listener interface for trigger events.",
             "onevent",
             "called when a trigger event occurs.  @param trigger the instance of the trigger. @param event the event type which caused the call. @param error an optional error.",
             "triggerevent",
             "events that may occur during the lifecycle of a mission trigger.",
             "unknown",
             "the default event if no other event matches the situation.",
             "started",
             "the trigger has started to monitor for its triggering criteria",
             "action_triggered",
             "the action block has been called as a result of matching the triggers' criteria",
             "stopped",
             "the trigger no longer monitors data for its triggering criteria",
             "batterypowerleveltrigger",
             "the class can be used to trigger an action during the execution of a  timeline if the aircraft battery goes below a certain level.",
             "setpowerpercentagetriggervalue",
             "if the remaining percentage drops below or equal to this value, the action will be triggered.  @param powerpercentagetriggervalue the power percentage trigger value to set.",
             "waypointreachedtrigger",
             "this class can be used to trigger an action during the execution of a waypoint mission when the aircraft reaches a certain waypoint index.",
             "getwaypointindex",
             "get the index of waypoint.  @return the index of the waypoint.",
             "setwaypointindex",
             "if the waypoint mission reaches this index, the action will be triggered.  @param waypointindex the index of the waypoint.",
             "aircraftlandedtrigger",
             "it can be used to trigger an action during the execution  of a timeline if the aircraft lands.",
             "waypointactuator",
             "this class defines an actuator for `waypointv2action`. it determines how the action is performed when a waypoint mission is executed. you can add multiple actions with `uploadwaypointactions`.  there are two scenarios for it. parallel execution: in parallel scenario, you can excute multiple actions with one trigger at the same time, the actions must be sent to different modules. for example, since gimbal and camera are different modules, you can use a trigger to rotate gimbal pitch and you can also use another triger  with identical parameters as the previous triger to take photos in order to execute these two actions at the same time.  you can not use two triggers with identical parameters to take photos and record videos at the same time, because these two actions are excuted with the same mudule. serial execution: in serial scenario, you can excute multiple actions one by one. for example, if you want to add actions for camera to take photo and record video, you should add action with `waypointv2associatetriggerparam`.  and set the associated action id with previous action, the `getassociatetype` should be djiwaypointv2triggerassociatedtimingtypeafterfinished</code>.",
             "getactuatortype",
             "the type of actuator.  @return an enum value of `actionactuatortype`.",
             "getactuatorindex",
             "the index of actuator. it is valid when the diagnostics is related to camera  or gimbal and the connected product has multiple gimbals and cameras.  @return an int value of actuator index.",
             "getcameraactuatorparam",
             "the camera actuator param, it is valid only when the `getactuatortype`  is `camera`.  @return an object of `waypointcameraactuatorparam`.",
             "getgimbalactuatorparam",
             "parameters for gimbal actuator. it is valid only when the `getactuatortype`  is `gimbal`.  @return an object of `waypointgimbalactuatorparam`.",
             "getaircraftcontrolactuatorparam",
             "parameters for lidar actuator. it is valid only when the `getactuatortype`  is `aircraft_control`.  @return an object of `waypointgimbalactuatorparam`.",
             "getlidaractuatorparam",
             "parameters for aircraft control actuator. it is valid only when the `getactuatortype`  is `lidar`.  @return an object of `waypointlidaractuatorparam`.",
             "waypointgimbalactuatorparam",
             "this class defines the parameters for `waypointactuator`. it determines how the gimbal actuator will be performed when a waypoint mission is executed.",
             "getoperationtype",
             "the operation type of gimbal actuator. see `gimbaloperationtype`.  @return an enum value of `gimbaloperationtype`.",
             "getrotation",
             "the rotation of gimbal actuator.  @return an object of `rotation`.",
             "waypointgimbalpathpointinfo",
             "this class defines the gimbal path point info parameters.",
             "getrunningtime",
             "the rotation time of the gimbal(unit: second). the gimbal will rotate at its maximum speed when the value is set to 0.  @return a float value to get the rotation time of the gimbal.",
             "getstaytime",
             "the time stays at the target location including the time of photo taken(unit: second). for example: the zenmuse p1 takes about 0.7s to take a photo. if you set stay time with 1s, the gimbal will stay for 0.3s after the camera has finished taking a photo. if the stay time is less than the photo time, the next pathpoint will be executed immediately after the photo is taken.  @return a float value to get the stay time of the gimbal.",
             "geteulerroll",
             "euler target angle for roll (north east down coordinate system). unit: degree. you should use `adjust_roll` to get the adjustable roll range.  @return a float value to get the euler target angle for roll.",
             "geteulerpitch",
             "euler target angle for pitch(north east down coordinate system). unit: degree. you should use `adjust_pitch` to get the adjustable pitch range.  @return a float value to get the euler target angle for pitch.",
             "geteuleryaw",
             "euler target angle for yaw (unit: degree). the yaw angle is relative to the aircraft heading. if you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  you should use `adjust_yaw` to get the adjustable yaw range.  @return a float value to get the euler target angle for yaw.",
             "builder",
             "the class is used to create the instance of `waypointgimbalpathpointinfo`.",
             "runningtime",
             "sets the running time.  @param runningtime a float value of running time. (unit:second)  @return the build of `builder`.",
             "staytime",
             "sets the stay time.  @param staytime a float value of stay time.(unit:second)  @return the build of `builder`.",
             "eulerroll",
             "sets the roll angle.  @param eulerroll euler target angle for roll(north east down coordinate system). unit:degree.  @return the build of `builder`.",
             "eulerpitch",
             "sets the pitch angle.  @param eulerpitch euler target angle for pitch(north east down coordinate system). unit:degree.  @return the build of `builder`.",
             "euleryaw",
             "sets the yaw angle.  @param euleryaw euler target angle for yaw (unit:degree). the yaw angle is relative to the aircraft heading. if you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `builder`.",
             "waypointgimbalstartpathshootingparam",
             "this class defines the gimbal start path shooting parameters.",
             "getpathcyclemode",
             "determines whether path shooting is executed once or countless times.  @return an enum value of the `gimbalpathcyclemode`.",
             "getpointnum",
             "the point number, it is the size of the `getpointinfo` list.  @return an int value of point number.",
             "getpointinfo",
             "path shooting point information list which contain parameters for path shooting.  @return the list of point information",
             "builder",
             "the class is used to create the instance of `waypointgimbalstartpathshootingparam`.",
             "pathcyclemode",
             "sets path cycle mode.  @param pathcyclemode an enum value of the `gimbalpathcyclemode`.  @return the build of `builder`.",
             "pointnum",
             "sets the point number, indicates the number of point you wish to execute. usually, it is the size of the `getpointinfo` list.  @param pointnum an int value of point number.  @return the build of `builder`.",
             "pointinfo",
             "sets the list of the point information.  @param pointinfo the list of point information  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `builder`.",
             "waypointgimbalstoppathshootingparam",
             "this class defines the gimbal stop path shooting parameters.",
             "getpathcyclemode",
             "determines whether path shooting is executed once or countless times.  @return an enum value of the `gimbalpathcyclemode`.",
             "builder",
             "the class is used to create the instance of `waypointgimbalstoppathshootingparam`.",
             "pathcyclemode",
             " @param pathcyclemode an enum value of the `gimbalpathcyclemode`, please set the mode which you set at start path shooting..  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `builder`.",
             "waypointgimbalpathshooting",
             "this class defines the parameters for `waypointgimbalactuatorparam`. it determines how the  gimbal actuator will be performed when a waypoint mission is executed.",
             "getpathshootingtype",
             "the operation type of gimbal actuator. see `gimbalpathshootingtype`.  @return a value of `gimbalpathshootingtype` enum.",
             "getstartpathshootingparam",
             "the parameter for start path shooting. it's valid only when `gimbalpathshootingtype` is `start_path_shooting`  @return the object of `waypointaircraftcontrolrotateyawparam`.",
             "getstoppathshootingparam",
             "the parameters for stop path shooting.  it's valid only when `gimbalpathshootingtype` is `stop_path_shooting`.  @return the object of `waypointaircraftcontrolstartstopflyparam`.",
             "builder",
             "the class is used to create the instance of `waypointgimbalpathshooting`.",
             "pathshootingtype",
             " @param type an enum value of the `gimbalpathshootingtype`.  @return the build of `builder`.",
             "startpathshooting",
             " @param param the object of `waypointgimbalstartpathshootingparam`.  @return the build of `builder`.",
             "stoppathshooting",
             " @param param the object of `gimbalpathshootingtype`.  @return the build of `builder`.",
             "builder",
             "the class is used to create the instance of `waypointgimbalactuatorparam`.",
             "operationtype",
             "sets the operation type.  @param val an enum value of `gimbaloperationtype`.  @return the build of `builder`.",
             "rotation",
             "sets the rotation.  @param val the object of `rotation`.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointgimbalactuatorparam`.",
             "waypointaircraftcontrolparam",
             "this class defines the parameters for `waypointactuator`. it determines how the aircraft control actuator will be performed when a waypoint mission is executed.",
             "getaircraftcontroltype",
             "the operation type of aircraft control actuator. see `aircraftcontroltype`.  @return a value of `aircraftcontroltype` enum.",
             "getrotateyawparam",
             "the parameter for rotating the aircraft's heading. it's valid only when `getaircraftcontroltype`  is `rotate_yaw`  @return the object of `waypointaircraftcontrolrotateyawparam`.",
             "getflycontrolparam",
             "the parameters to control flying behavior.  it's valid only when `getaircraftcontroltype`  is `start_stop_fly`.  @return the object of `waypointaircraftcontrolstartstopflyparam`.",
             "builder",
             "the class is used to create the instance of `builder`.",
             "setrotateyawparam",
             "sets the rotate yaw param.  @param rotateyawparam the object of `waypointaircraftcontrolrotateyawparam`.  @return the build of `builder`.",
             "setflycontrolparam",
             "sets the flycontrolparam.  @param flycontrolparam the object of `waypointaircraftcontrolstartstopflyparam`.  @return the build of `builder`.",
             "setaircraftcontroltype",
             "sets the aircraftcontroltype.  @param aircraftcontroltype an enum value of `aircraftcontroltype`.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointaircraftcontrolparam`.",
             "waypointaircraftcontrolstartstopflyparam",
             "this class defines if the aircraft starts or stops the flight.",
             "isstartfly",
             "determines the aircraft start flying or stop flying. `true` for the aircraft to start flying.  @return a boolean value to check aircraft start flying.",
             "builder",
             "the class is used to create the instance of `waypointaircraftcontrolstartstopflyparam`.",
             "setstartfly",
             "set the param isstartfly.  @param startfly the boolean value of startfly.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointaircraftcontrolstartstopflyparam`.",
             "waypointaircraftcontrolrotateyawparam",
             "this class defines how the aircraft rotates on the yaw axis.",
             "isrelative",
             "determines the aircraft rotate heading relative. if `true`, when the aircraft is rotating, relative to the current angle.  @return a boolean value to check aircraft rotate heading relative.",
             "getdirection",
             "determines the direction how aircraft changes its heading.  @return an enum value of `waypointv2turnmode`.",
             "getyawangle",
             "the heading in degrees to which the aircraft will rotate control by action. if isrelative is `true` a heading has a range of [-180, 180]  degrees, where 0 represents true north.  @return a float value of yaw angle.",
             "builder",
             "the class is used to create the instance of `waypointaircraftcontrolrotateyawparam`.",
             "setrelative",
             "sets the relative.  @param relative a boolean value of relative.  @return the build of `builder`.",
             "setdirection",
             "sets the direction.  @param direction an enum value of the `waypointv2turnmode`.  @return the build of `builder`.",
             "setyawangle",
             "sets the yaw angle.  @param yawangle a float value of yaw angle.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointaircraftcontrolrotateyawparam`.",
             "waypointpointcloudrecordactuatorparam",
             "this class defines the parameters for `waypointpointcloudrecordactuatorparam`.  you can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
             "gettype",
             "the operation type of lidar actuator. see `pointcloudrecordtype`.  @return an enum value of ``djiwaypointv2_pointcloudrecordtype`.",
             "builder",
             "generates the immutable object.",
             "type",
             "sets the point cloud record operation type.  @param type the value of `pointcloudrecordtype` enum.  @return the build of `builder`.",
             "waypointlidaractuatorparam",
             "this class defines the parameters for `waypointactuator`.  you can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
             "getlidaroperationtype",
             "the operation type of lidar actuator. see `lidaroperationtype`.  @return an enum value of `lidaroperationtype`.",
             "getpointcloudrecordparam",
             "the parameter for record point cloud. it's valid only when `lidaroperationtype` is `record_point_cloud`  @return the object of ``djiwaypointv2actuator_pointcloudrecordactuatorparam`.",
             "builder",
             "the class is used to create the instance of `waypointlidaractuatorparam`.",
             "lidaroperationtype",
             "sets the lidar operation type the action lidar to execute.  @param type the value of `lidaroperationtype` enum.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the object of `waypointcameraactuatorparam`.",
             "waypointcameraactuatorparam",
             "this class defines the parameters for `waypointactuator`. this determines how the camera  will be performed when a waypoint mission is executing.",
             "getcameraoperationtype",
             "the operation type of camera actuator. see `cameraoperationtype`.  @return an enum value of `cameraoperationtype`.",
             "getcustomnameparam",
             "the parameter for custom name. it's valid only when `getaircraftcontroltype`  is `custom_name`  @return the object of `waypointcameracustomnameparam`.",
             "getfocusmodeparam",
             "the parameter for camera focus mode. it's valid only when `getaircraftcontroltype`  is `focus_mode`  @return the object of djiwaypointv2cameraactuatorparam_djiwaypointv2camerafocusmodeparam</code>.",
             "getzoomparam",
             "the parameter for camera zoom. it's valid only when `getaircraftcontroltype`  is `zoom`  @return the object of `waypointcamerazoomparam`.",
             "getfocusparam",
             "the parameter for camrea focus. it's valid only when `getaircraftcontroltype` is `focus`  @return the object of djiwaypointv2actuator_djiwaypointcamerafocusparam</code>.",
             "builder",
             "the class is used to create the instance of `waypointcameraactuatorparam`.",
             "setcameraoperationtype",
             "sets the camera operation type the action camera to execute.  @param type the value of `cameraoperationtype` enum.  @return the build of `builder`.",
             "waypointcamerazoomparam",
             "this class defines a camera focal length operation for `waypointcameraactuatorparam`.",
             "getfocallength",
             "focal length of zoom lens. valid range is [`getminfocallength`, `getminfocallength`]  and must be a multiple of `getfocallengthstep`. only support by those camera `isopticalzoomsupported` return `true`.  @return an int value of the zoom lens' focal length.",
             "builder",
             "the class is used to create the obejct of `waypointcamerazoomparam`.",
             "setfocallength",
             "sets focal length of the zoom lens in units of 0.1mm.  @param focallength an int value of focal length.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return an object of `waypointcamerazoomparam`.",
             "waypointcamerafocusmodeparam",
             "this class defines a camera focus mode operation for `waypointcameraactuatorparam`.",
             "getcamerafocusmode",
             "get the camera focus mode.  @return an enum value of `camerafocusmode`.",
             "builder",
             "the class is used to create the obejct of `waypointcamerafocusmodeparam`.",
             "camerafocusmode",
             "set the camera focus mode.  @param camerafocusmode an enum value of `camerafocusmode`.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return an object of `waypointcamerafocusmodeparam`.",
             "waypointcamerafocusrectangletargetparam",
             "this class defines a camera rectangle focus target for `waypointcamerafocusparam`.",
             "getreferencepoint",
             "the point at the upper left corner of the rectangle. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left angle of the screen.  @return an object of pointf.",
             "getwidth",
             "the width of the rectangle. the range of the width is (0.0, 1.0]. the value increses from left to right from the `getreferencepoint`.  @return the width of the rectangle.",
             "getheight",
             "the height of the rectangle. the range of the height is (0.0, 1.0]. the value increases from top to botton from the `getreferencepoint`.  @return the height of the rectangle.",
             "builder",
             "this class is used to create the instance of `waypointcamerafocusrectangletargetparam`.",
             "build",
             "generates the immutable object.  @return the build of `waypointcamerafocusrectangletargetparam`.",
             "waypointcamerafocuspointtargetparam",
             "this class defines a camera point focus target for `waypointcamerafocusparam`.",
             "getfocuspoint",
             "the lens focus target point. when the focus mode is auto, the target point is the focal point. when the focus mode is manual, the target point is the zoom out area if the focus assistant  is enabled for the manual mode. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left angle of the screen.  @return an object of pointf.",
             "builder",
             "this class is used to create the instance of `waypointcamerafocuspointtargetparam`.",
             "build",
             "generates the immutable object.  @return the build of ``djiwaypointv2actionactuatorparam_djiwaypointv2camerafocus_pointtargetparam`.",
             "waypointcamerafocusparam",
             "this class defines a camera focus operation for `waypointcameraactuatorparam`.",
             "getcamerafocusregiontype",
             "focus region type of camera.  @return an enum value of `camerafocusregiontype`",
             "getpoint",
             "the parameter for point focus. it's valid only when `getcamerafocusregiontype`   is `point`  @return the object of `getpoint`.",
             "getrectangle",
             "the parameter for rectangle focus. it's valid only when `getcamerafocusregiontype`   is `rectangle`  @return the object of `getrectangle`.",
             "builder",
             "this class is used to create the instance of `waypointcamerafocusparam`.",
             "build",
             "generates the immutable object.  @return the build of `waypointcamerafocusparam`.",
             "waypointcameracustomnameparam",
             "this class defines a camera expand name operation for `waypointcameraactuatorparam`.",
             "gettype",
             "gets the type of camera custom expand name type.  @return an object of `gettype`.",
             "getcustomname",
             "gets the camera custom expand name.  @return a string value.",
             "builder",
             "the class is used to create the instance of `waypointcameracustomnameparam`.",
             "type",
             "sets the camera operation type the action camera to execute.  @param type the value of `cameracustomnametype` enum.  @return the build of `builder`.",
             "customname",
             "sets the camera custom expand name the action camera to execute.  @param name a string value.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the object of `waypointcameracustomnameparam`.",
             "waypointtrigger",
             "it determines when an action will be performed while the aircraft executes a waypoint mission.",
             "gettriggertype",
             "the type of trigger.  @return an enum value of `actiontriggertype`.",
             "getreachpointparam",
             "the parameters of `reach_point`. it's  valid only when the `gettriggertype`  is `reach_point`.  @return an object of `waypointreachpointtriggerparam`.",
             "getassociateparam",
             "the parameters of `associate`. it's valid  only when the `gettriggertype`  is `associate`.  @return an object of `waypointv2associatetriggerparam`.",
             "gettrajectoryparam",
             "the parameters of `trajectory`. it's valid only  when the `gettriggertype` is `trajectory`. this trigger applies only to `aircraft_control_gimbal`.  if this action is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index.  @return an object of `waypointtrajectorytriggerparam`.",
             "getintervaltriggerparam",
             "the parameters of `simple_interval`. it's valid only when the `gettriggertype` is `simple_interval`.  @return an object of `waypointintervaltriggerparam`.",
             "builder",
             "the class is used to create the instance of `waypointtrigger`.",
             "settriggertype",
             "set waypoint trigger type.  @param triggertype an enum value of `actiontriggertype`.  @return the build of `builder`.",
             "setassociateparam",
             "sets the associate param.  @param associateparam the object of `waypointv2associatetriggerparam`.  @return the build of `builder`.",
             "settrajectoryparam",
             "sets the trajectory param.  @param trajectoryparam the object of `waypointtrajectorytriggerparam`.  @return the build of `builder`.",
             "setreachpointparam",
             "sets the simple reach point param.  @param simplereachpointparam the object of `waypointreachpointtriggerparam`.  @return the build of `builder`.",
             "setintervaltriggerparam",
             "sets the simple interval trigger param.  @param intervaltriggerparam the object of `waypointintervaltriggerparam`.  @return the build of `builder`.",
             "build",
             "create an object of `waypointtrigger`.  @return the build of `waypointtrigger`.",
             "waypointintervaltriggerparam",
             "this class defines `trajectory`. this class only support the parameters of `waypointcameraactuatorparam`.  you can add multiple actions to the trigger, for example, if you want to add actions for camera to take photo and record video, you should add action with `waypointv2associatetriggerparam`, and set the associated action id with another action,  the `getassociatetype` should be `after_finished`.",
             "getstartindex",
             "it determines the index of the waypoint at which the trigger starts.  @return an int value of start index.",
             "gettype",
             "the type of interval trigger. see `actionintervaltype`.  @return an enum value of `actionintervaltype`.",
             "getinterval",
             "if the `gettype`  is `time` the time interval in seconds  when two action are executed as the aircraft moves from the current waypoint to the next waypoint. if the `gettype`  is `distance` the distance interval in meters  when two action are executed as the aircraft moves from the current waypoint to the next waypoint.  @return a float value of the interval.",
             "builder",
             "the class is used to create the instance of `waypointintervaltriggerparam`.",
             "setstartindex",
             "sets the waypoint index to start.  @param startindex the start index of waypoint.  @return the build of `builder`.",
             "settype",
             "sets the waypoint action trigger type.  @param type the enum value of `actiontriggertype`.  @return the build of `builder`.",
             "setinterval",
             "sets the interval.  @param interval a float value of interval.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointintervaltriggerparam`.",
             "waypointtrajectorytriggerparam",
             "this class represents a trajectory trigger action when should be trigger. this trigger only supported `waypointgimbalactuatorparam`.",
             "getstartindex",
             "it determines the index of the waypoint at which the trigger starts.  @return an int value of start index.",
             "getendindex",
             "it determines the waypoint when the trigger stops.  @return an int value of end index.",
             "builder",
             "it determines the index of the waypoint at which the trigger starts.",
             "setstartindex",
             "sets the start index.  @param startindex an int value of start index.  @return the build of `builder`.",
             "setendindex",
             "sets the end index.  @param endindex an int value of end index.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointtrajectorytriggerparam`.",
             "waypointv2associatetriggerparam",
             "this class defines `associate`.",
             "getassociateactionid",
             "associated action id.  @return an int value of associate action id.",
             "getassociatetype",
             "the type of assciate trigger.  @return an object of `actiontypes`.",
             "getwaitingtime",
             "waiting time in seconds after actiontrigger starts.  @return a float value of waiting time.",
             "builder",
             "the class is used to create the instance of `waypointv2associatetriggerparam`.",
             "setassociatetype",
             "sets the associatetype of the trigger. the associatetype determines the time and the way to trigger the action  to execute.  @param associatetype an enum value of `associatedtimingtype`.  @return the build of `builder`.",
             "setwaitingtime",
             "sets the waiting time.  @param waitingtimeinsec a float value of the waiting time in sec.  @return the build of `builder`.",
             "setassociateactionid",
             "sets the action id the trigger associated with.  @param associateactionid an int value of the associate action id.  @return the build of `builder`.",
             "build",
             "generate the immutable class.  @return the build of `waypointv2associatetriggerparam`.",
             "waypointreachpointtriggerparam",
             "this class defines `reach_point`. it describes  an action will be triggered when the aircraft reach the certain waypoint. we suggest you use `waypointaircraftcontrolstartstopflyparam`  to stop flying before the action you want to excute. after the action is completed, you should use `waypointaircraftcontrolstartstopflyparam` to start flying.",
             "getstartindex",
             "it determines the index of the waypoint at which the action will be triggered.  @return an int value of the waypoint start index.",
             "getautoterminatecount",
             "it determines the waypoint count till the action triggered stops.  @return an int value of auto terminate count.",
             "builder",
             "this class is used to create the object for `waypointreachpointtriggerparam`.",
             "setstartindex",
             "sets the start index.  @param startindex an int value of start index.  @return the build of `builder`.",
             "setautoterminatecount",
             "sets the auto terminate count.  @param autoterminatecount an int value of auto terminate count.  @return the build of `builder`.",
             "build",
             "generates the immutable object.  @return the build of `waypointreachpointtriggerparam`.",
             "builder",
             "the class is used to create the instance of `waypointactuator`.",
             "setactuatortype",
             "sets the `djiwaypointv2action_djiwaypointv2actuator_type`.  @param actuatortype the value of missionid to set.  @return the build of `builder`.",
             "setcameraactuatorparam",
             "sets the camera actuator param, it's only valid when `actionactuatortype` is `camera`.  @param cameraactuatorparam the object of `waypointcameraactuatorparam`.  @return the build of `builder`.",
             "setgimbalactuatorparam",
             "sets the gimbal actuator param, it's only valid when `actionactuatortype` is `gimbal`.  @param gimbalactuatorparam the object of `waypointgimbalactuatorparam`.  @return the build of `builder`.",
             "setaircraftcontrolactuatorparam",
             "sets the aircraft actuator param, it's only valid when `actionactuatortype` is `aircraft_control`.  @param aircraftcontrolactuatorparam the object of `waypointaircraftcontrolparam`.  @return the build of `builder`.",
             "setlidaractuatorparam",
             "sets the lidar param, it's only valid when `actionactuatortype` is `lidar`.  @param lidaractuatorparam the object of `waypointlidaractuatorparam`.  @return the build of `builder`.",
             "setactuatorindex",
             "sets the `djiwaypointv2action_djiwaypointv2actuator_actuatorindex`.  @param index the actuator index.  @return the build of `builder`.",
             "build",
             "generates the immutable class.  @return the object of `waypointactuator`.",
             "actiondownloadprogress",
             "the download progress of the actions operator.",
             "getlastdownloadedactionindex",
             "the last index of downloaded action. information for action is downloaded in ascending order. if no action has been downloaded, the value should be -1.  @return an int value of download action index.",
             "gettotalactioncount",
             "the total count of actions in the waypoint mission.  @return an int value of total action count.",
             "actionexecutionprogress",
             "the mission action execution progress of the waypoint mission operator.",
             "getexecutionactionid",
             "the id of action.  @return an int value of the execution action index.",
             "issuccess",
             "the execution result of action.  @return a boolean value of the execution result of action.",
             "target",
             "the image point from the video feed where the vision system should calculate the flight direction from. the image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
             "tapflymode",
             "tapfly mission mode. defaults to `forward`.  additional modes only supported by the phantom 4 pro.",
             "ishorizontalobstacleavoidanceenabled",
             "`true` to enable horizontal obstacle avoidance.",
             "speed",
             "speed in m/s during tap fly mission.",
             "tapflyexecutionstate",
             "this class provides the detailed state of a tapfly mission that is executing.",
             "getdirection",
             "the direction vector the aircraft is travelling in using the n-e-d  (north-east- down) coordinate system.  @return a vector object.",
             "getimagelocation",
             "the image point from the video feed where the vision system should calculate the flight direction from. the image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.  @return a pointf object.",
             "getspeed",
             "the real-time speed of the aircraft in m/s.  @return a float value of speed.",
             "getbypassdirection",
             "the direction the aircraft is moving around or bypassing an obstacle in. will be `none` if the aircraft is not executing  an avoidance maneuver.  @return an enum value of `bypassdirection`",
             "getrelativeheading",
             "aircraft's heading relative to the flight direction.  @return a float value of relative heading.",
             "vector",
             "a cartesian vector in 3d space.",
             "getx",
             "x-value of the cartesian vector.  @return a float value of x value.",
             "gety",
             "y-value of the cartesian vector.  @return a float value of y value.",
             "getz",
             "z-value of the cartesian vector.  @return a float value of z value.",
             "bypassdirection",
             "direction aircraft is moving around or bypassing an obstacle in.",
             "none",
             "flying normally, no obstacle to be avoided.",
             "over",
             "avoiding the obstacle by going over the top of it.",
             "left",
             "avoiding the obstacle by going to the left of it.",
             "right",
             "avoiding the obstacle by going to the right of it.",
             "unknown",
             "unknown obstacle avoidance direction",
             "tapflymode",
             "different modes of the tapfly mission. defaults to  `forward`, set to others to enable  the feature.",
             "forward",
             "aircraft will fly towards the target. forward obstacle  sensing system is active.",
             "backward",
             "aircraft will fly in the opposite direction from the target.  backward obstacle sensing system is active.",
             "free",
             "aircraft will fly towards the target. user can control the heading  by remote controller's stick. obstacle sensing systems may fail to  work when aircraft is flying sideward.",
             "unknown",
             "the tapfly mode is unknown.",
             "builder",
             "class builder.",
             "checkparameters",
             "checks if the configuration for the mission is valid before loading it into `waypointmissionoperator`.  @return error found when checking parameters of the waypoint. `null` if all the parameters are valid.",
             "getwaypointcount",
             "number of waypoints in the waypoint mission.  @return waypoint count.",
             "getmissionid",
             "get the mission id.  @return mission id.",
             "getwaypointlist",
             "returns an list of all waypoints in the mission.  @return a list of `waypoint` instances contained in the mission.",
             "getmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getmaxflightspeed` is this offset when the joystick is pushed  to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. if the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getmaxflightspeed`] with a resolution of 1000 steps. if the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getmaxflightspeed` has a range of [2,15] m/s.  @return flight speed in m/s",
             "getautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual  speed is `getautoflightspeed` + joystick speed (with combined max  of `getmaxflightspeed`) if `getautoflightspeed` =0: actual speed is  controlled only by the remote controller joystick. if `getautoflightspeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return flight speed in m/s",
             "getgotofirstwaypointmode",
             "defines how the aircraft will go to the first waypoint from its current position. default  is `safely`.  @return the behavior of the aircraft at the begining of the mission",
             "getfinishedaction",
             "action the aircraft will take when the waypoint mission is complete.  @return the action to execute when the waypoint mission finishes",
             "getheadingmode",
             "heading of the aircraft as it moves between waypoints. default  is `auto`.  @return heading mode.",
             "getpointofinterest",
             "aircraft heading will be fixed to the point of interest location during the waypoint mission. used when `getheadingmode`  is `toward_point_of_interest`.  @return point of interest location.",
             "getflightpathmode",
             "the path the aircraft follows between waypoints. the aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return the flight path mode.",
             "isexitmissiononrcsignallostenabled",
             "determines whether the mission should stop when connection between the  aircraft and remote controller is lost. default is `false`.  @return `true` if mission should stop when connection is lost.",
             "isgimbalpitchrotationenabled",
             "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. when `true`, `gimbalpitch` in `waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
             "getrepeattimes",
             "gets the repeat times of the mission.  @return number of times to repeat mission",
             "waypoint",
             "the class represents a target point in the waypoint mission. for a waypoint mission, a flight route  consists of multiple `waypoint` objects. the user can also define the actions to perform for  each `waypoint`.",
             "waypointmissionfinishedaction",
             "actions taken when the waypoint mission has finished.",
             "waypointmissionheadingmode",
             "current waypoint mission heading mode.",
             "waypointmissionflightpathmode",
             "waypoint mission flight path mode.",
             "waypointmissiongotowaypointmode",
             "this enum will determine the goto point mode while the drone executes the flight.",
             "waypointmissioninterruption",
             "the class provides information of the latest interrupted waypoint mission.",
             "builder",
             "default constructor of waypoint mission with 0 waypoints.",
             "builder",
             "waypoint mission constructor that clones this waypoint mission from another.  @param waypointmissiontoclone waypoint mission to clone",
             "addwaypoint",
             "add a waypoint to the waypoint mission.  @param waypoint waypoint to add.  @return a `builder` object",
             "removewaypoint",
             "remove a waypoint from the waypoint mission.  @param waypoint waypoint to remove.  @return a `builder` object",
             "removewaypoint",
             "remove a waypoint by index from the waypoint mission.  @param index index of waypoint to remove.  @return a `builder` object",
             "waypointlist",
             "list of waypoints that will define this mission  @param waypointlist list of waypoints  @return a `builder` object",
             "getwaypointlist",
             "list of waypoints that will define this mission  @return list of waypoints",
             "getmissionid",
             "get mission id.  @return mission id.",
             "setmissionid",
             "set mission id.  @param id the id of mission. the valid range is [0, 65535].  @return a `builder` object.",
             "calculatetotaldistance",
             "calculate the total distance of the waypoint list.  @return the total distance of the waypoint list.",
             "calculatetotaltime",
             "calculate the total time of the waypoint list.  @return the total time of the waypoint list.",
             "getlastcalculatedtotaldistance",
             "get the last calculated total distance of the waypoint list.  @return the last calculated total distance of the waypoint list.",
             "getlastcalculatedtotaltime",
             "get the last calculated total time of the waypoint list.  @return the last calculated total time of the waypoint list.",
             "insertwaypoint",
             "insert a waypoint to the waypoint mission.  @param waypoint waypoint to insert. @param index index to insert the waypoint.  @return a `builder` object",
             "waypointcount",
             "number of waypoints in the waypoint mission. this must be set to the correct number of waypoints added to the mission.  @param waypointcount waypoint count.  @return a `builder` object",
             "getwaypointcount",
             "number of waypoints in the waypoint mission.  @return waypoint count.",
             "maxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getmaxflightspeed` is this offset when the joystick is pushed  to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. if the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getmaxflightspeed`] with a resolution of 1000 steps. if the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getmaxflightspeed` has a range of [2,15] m/s.  @param maxflightspeed flight speed in m/s  @return a `builder` object",
             "getmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getmaxflightspeed` is this offset when the joystick is pushed  to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. if the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getmaxflightspeed`] with a resolution of 1000 steps. if the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getmaxflightspeed` has a range of [2,15] m/s.  @return flight speed in m/s",
             "autoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual  speed is `getautoflightspeed` + joystick speed (with combined max  of `getmaxflightspeed`) if `getautoflightspeed` =0: actual speed is  controlled only by the remote controller joystick. if `getautoflightspeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoflightspeed flight speed in m/s  @return a `builder` object",
             "getautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual  speed is `getautoflightspeed` + joystick speed (with combined max  of `getmaxflightspeed`) if `getautoflightspeed` =0: actual speed is  controlled only by the remote controller joystick. if `getautoflightspeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return flight speed in m/s",
             "gotofirstwaypointmode",
             "defines how the aircraft will go to the first waypoint from its current position. default  is `safely`.  @param gotofirstwaypointmode behavior prior to mission start.  @return a `builder` object",
             "getgotofirstwaypointmode",
             "defines how the aircraft will go to the first waypoint from its current position. default  is `safely`.  @return the behavior of the aircraft at the begining of the mission",
             "finishedaction",
             "action the aircraft will take when the waypoint mission is complete.  @param finishedaction behavior of aircraft when mission is complete.  @return a `builder` object",
             "getfinishedaction",
             "action the aircraft will take when the waypoint mission is complete.  @return the action to execute when the waypoint mission finishes",
             "headingmode",
             "heading of the aircraft as it moves between waypoints. default  is `auto`.  @param headingmode the heading mode.  @return a `builder` object",
             "getheadingmode",
             "heading of the aircraft as it moves between waypoints. default  is `auto`.  @return heading mode.",
             "setpointofinterest",
             "aircraft heading will be fixed to the point of interest location during the waypoint mission. used when `getheadingmode`  is `toward_point_of_interest`.  @param pointofinterest point of interest location.  @return a `builder` object",
             "getpointofinterest",
             "aircraft heading will be fixed to the point of interest location during the waypoint mission. used when `getheadingmode`  is `toward_point_of_interest`.  @return point of interest location.",
             "flightpathmode",
             "the path the aircraft follows between waypoints. the aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @param flightpathmode the flight path mode.  @return a `builder` object",
             "getflightpathmode",
             "the path the aircraft follows between waypoints. the aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return the flight path mode.",
             "setexitmissiononrcsignallostenabled",
             "determines whether the mission should stop when connection between the  aircraft and remote controller is lost. default is `false`.  @param enabled `true` if mission should stop when connection is lost.  @return a `builder` object",
             "isexitmissiononrcsignallostenabled",
             "determines whether the mission should stop when connection between the  aircraft and remote controller is lost. default is `false`.  @return `true` if mission should stop when connection is lost.",
             "setgimbalpitchrotationenabled",
             "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. when `true`, `gimbalpitch` in `waypoint` is used to control gimbal pitch.  @param gimbalpitchrotationenabled `true` if gimbal pitch can be controlled.  @return a `builder` object",
             "isgimbalpitchrotationenabled",
             "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. when `true`, `gimbalpitch` in `waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
             "repeattimes",
             "mission execution can be repeated more than once. the value range is [1, 255]. if 255 is selected,  then the mission will continue to be executed until `stopmission` is  called or any error occurs. other values represent the exact execution times of the mission.  @param repeattimes number of times to repeat mission, the value should be larger than 0.  @return a `builder` object",
             "getrepeattimes",
             "gets the repeat times of the mission builder.  @return number of times to repeat mission.",
             "ismissioncomplete",
             "when downloading a waypoint mission, the number of waypoints in `getwaypointlist` will be less than  `getwaypointcount` until the download is complete. this property is `true` when all the information in the waypoint mission is downloaded, and complete in this object.  @return `true` if mission information is complete.",
             "build",
             "build the object into a `waypointmission` object.  @return waypoint mission.",
             "no_action",
             "no further action will be taken on completion of mission. at this point, the aircraft can be  controlled by the remote controller.",
             "go_home",
             "the aircraft will go home when the mission is complete. if the aircraft is more than 20m away from  the home point it will go home and land. otherwise, it will land directly at the current location.",
             "auto_land",
             "the aircraft will land automatically at the last waypoint.",
             "go_first_waypoint",
             "the aircraft will go back to its first waypoint and hover in position.",
             "continue_until_end",
             "when the aircraft reaches its final waypoint, it will hover without ending the mission. the joystick  can still be used to pull the aircraft back along its previous waypoints. the only way this mission  can end is if stopmission is called.",
             "auto",
             "aircraft's heading will always be in the direction of flight.",
             "using_initial_direction",
             "aircraft's heading will be set to the heading when reaching the first waypoint. before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. when the aircraft  reaches the first waypoint, its heading will be fixed.",
             "control_by_remote_controller",
             "aircraft's heading will be controlled by the remote controller.",
             "using_waypoint_heading",
             "aircraft will rotate its heading after the waypoint has been reached. you should use this interface `heading` to set aircraft heading.",
             "toward_point_of_interest",
             "after the first waypoint has been reached, aircraft heading will always toward to the point of interest.",
             "normal",
             "the flight path will be normal and the aircraft will move from one waypoint to the next in straight lines.",
             "curved",
             "the flight path will be curved and the aircraft will move from one waypoint to the next in a curved motion,  adhering to the `cornerradiusinmeters`, which is set in `waypoint`.",
             "safely",
             "go to the waypoint safely. the aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. it then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
             "point_to_point",
             "go to the waypoint from the current aircraft point to the waypoint directly.",
             "getcoordinate",
             "the aircraft's coordinate when the mission is interrupted.  @return an object of `locationcoordinate2d`.",
             "getaltitude",
             "the aircraft's altitude when the mission is interrupted. this value represents the  absolute height.  @return a float value of the waypoint altitude.",
             "getindex",
             "the waypoint index that aircraft latest reached when the mission is interrupted.  @return an int value of the waypoint index.",
             "getmissionid",
             "missionid of interrupted mission.  @return an int value of the missionid.",
             "iscomplete",
             "when downloading a waypoint mission, the number of waypoints in `getwaypointlist` will be  less than `getwaypointcount` until the download is complete. this property is `true` when all  the information in the waypoint mission is downloaded, and complete in this object.  @return a boolean value.",
             "getmissionid",
             "the mission id.  @return a long value of mission id.",
             "getwaypointcount",
             "number of waypoints in the waypoint mission. note there are some cases when the waypoint count will be different to the  waypoint array length from `getwaypointlist`. this is usually the case when the waypoint  mission is still being downloaded  from the aircraft and the mission object hasn't  existed previously (e.g. when the mobile device is connected to an aircraft  with a previously uploaded mission). in these cases, `iscomplete`  will return `true`.  @return an int value of waypoint count.",
             "getmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getmaxflightspeed`  is this offset when the joystick is pushed  to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. if the remote controller stick is not at  maximum deflection, then the offset speed will be  interpolated between [0, `getmaxflightspeed`] with a resolution of 1000 steps. if the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getmaxflightspeed` has a range of [2,15] m/s.  @return a float value of max flight speed.",
             "getautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the aircraft's actual speed is a combination of the base automatic speed,  and the speed control given by the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual  speed is `getautoflightspeed` + joystick speed (with combined max  of `getmaxflightspeed`) if `getautoflightspeed` =0: actual speed is  controlled only by the remote controller joystick. if `getautoflightspeed` <0 and the aircraft is at the first waypoint,  the aircraft will hover in place until the speed is made positive by the remote controller joystick.  @return a float value of auto flight speed.",
             "getfinishedaction",
             "action the aircraft will take when the waypoint mission is complete.  @return a `missionfinishedaction` enum value.",
             "getgotofirstwaypointmode",
             "defines how the aircraft will go to the first waypoint from its current position. default  is `safely`.  @return a `missiongotowaypointmode` enum value.",
             "isexitmissiononrcsignallostenabled",
             "determines whether the mission should stop when connection between the aircraft and remote controller is lost. default is `false`.  @return a boolean value.",
             "getrepeattimes",
             "mission execution can be repeated more than once. a value of 0 means the mission only executes once, and does not repeat. a value of 1 means the  mission will execute a total of two times.  @return an int value of mission repeart times.",
             "getwaypointatindex",
             "gets the waypoint at the specified index in the mission waypoint array.  @param index index of the waypoint to be retrieved.  @return the `waypointv2` at the specified index.",
             "getwaypointlist",
             "returns an array of all waypoints in the mission.  @return an array of `waypointv2` instances contained in the mission.",
             "waypointv2",
             "the class represents a target point in the waypoint mission. for a waypoint mission, a flight route consists of multiple `waypointv2` objects.",
             "getcoordinate",
             "waypoint coordinate latitude and longitude in degrees.  @return an object of `locationcoordinate2d`.",
             "getaltitude",
             "altitude of the aircraft in meters when it reaches waypoint. the altitude of the aircraft is relative to  the ground at the take-off location, has a  range of [-200,500], and should not be larger than the aircraft's maximum altitude. if two adjacent waypoints have different altitudes, the altitude  will gradually change as the aircraft flies between waypoints.  @return a double type value of the aircraft altitude.",
             "getpointofinterest",
             "property is used when `getheadingmode` is `toward_point_of_interest`. aircraft will always be heading to  point while executing mission. default is kcllocationcoordinate2dinvalid.  @return an object of `locationcoordinate2d`.",
             "getpointofinterestaltitude",
             "property is used when `getheadingmode` is `toward_point_of_interest`. the altitude of the aircraft is relative  to the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude.  @return the value of the point of interest altitude.",
             "getflightpathmode",
             "flight path mode waypoint of the aircraft as it moves between waypoints. default is `goto_point_curve_and_stop`.  @return an enum value of `waypointv2flightpathmode`.",
             "getheadingmode",
             "heading of the aircraft as it moves between waypoints. default is `auto`.  @return an enum value of `waypointv2headingmode`.",
             "getheading",
             "the heading to which the aircraft will rotate by the time it reaches the waypoint. the aircraft heading  will gradually change between two waypoints with different headings if the waypoint mission's `waypointv2headingmode` is set to `waypoint_custom`. a heading has a range  of [-180, 180] degrees, where 0 represents true north.  @return the float type value of aircraft heading.",
             "getturnmode",
             "determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @return an enum value of `waypointv2turnmode`.",
             "isusingwaypointmaxflightspeed",
             "determines whether the aircraft using waypoint max flight speed executing waypoint mission. if `true`, the aircraft will use waypoint max flight speed between two waypoints.  otherwise, will use `getmaxflightspeed` as max flight speed.  @return a boolean value to check if the aircraft use waypoint max flight speed.",
             "getmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. `getmaxflightspeed` is this offset  when the joystick is pushed to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed,  while pushing down will subtract 10 m/s from the aircraft speed. if the remote controller stick is not at maximum deflection, then the offset speed will be interpolated  between [0, `getmaxflightspeed`] with a resolution of 1000 steps. if the offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it  reaches the first waypoint, it will then hover in place until a positive speed is applied. `getmaxflightspeed` has a range of [2,15] m/s.  @return the float value of max flight speed.",
             "isusingwaypointautoflightspeed",
             "determines whether the aircraft using waypoint auto flight speed executing waypoint mission. if `true`, the aircraft will use waypoint auto flight speed between two waypoints. otherwise,  will use `getautoflightspeed` as max flight speed.  @return a boolean value to check if the aircraft use waypoint auto flight speed.",
             "getautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual speed is `getautoflightspeed` + joystick speed (with combined max  of `getmaxflightspeed`) if `getautoflightspeed` =0: actual speed is controlled only by the remote controller joystick. if `getautoflightspeed` <0 and  the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by the remote controller joystick. in flight controller firmware 3.2.10.0 or above,  different speeds between individual waypoints can also be set in waypoint objects which will overwrite `getautoflightspeed`.  @return the float value of auto flight speed.",
             "getdampingdistance",
             "corner radius of the waypoint. when the flight path mode is `coordinate_turn` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. when there is a corner radius, the aircraft will never pass the waypoint. by default, the radius is 0.2 m. if the corner is made of three adjacent waypoints (short for a,b,c).  then the radius of a(short for ra) plus radius of b(short for rb) must be smaller than the distance between  a and b. the radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m). when the flight path mode is `goto_first_point_along_straight_line` when aircraft reaches the first waypoint,  the flight path will be a straight flight with this distance. when the flight path mode is `straight_out` the flight path will be a straight flight with this distance  before until last waypoint.  @return a float value of damping distance.",
             "builder",
             "default constructor of djiwaypointv2.",
             "setcoordinate",
             "altitude of the aircraft in meters when it reaches waypoint. the altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. if two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.  @param coordinate `locationcoordinate2d` object to set.  @return the build of `builder`.",
             "setaltitude",
             "altitude of the aircraft in meters when it reaches waypoint. the altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. if two adjacent waypoints have different altitudes, the altitude will  gradually change as the aircraft flies between waypoints.  @param altitude double type value to set.  @return the build of `builder`.",
             "setpointofinterest",
             "property is used when `getheadingmode` is `toward_point_of_interest`. aircraft will always be heading to point while executing mission. default is kcllocationcoordinate2dinvalid.  @param pointofinterest the object of `locationcoordinate2d`.  @return the build of `builder`.",
             "setpointofinterestaltitude",
             "property is used when `getheadingmode` is `toward_point_of_interest`. the altitude of the aircraft is relative to the ground at the take-off location, has a range of [-200,500],  and should not be larger than the aircraft's maximum altitude.  @param pointofinterestaltitude the float value to set.  @return the build of `builder`.",
             "setflightpathmode",
             "flight path mode waypoint of the aircraft as it moves between waypoints. default is djiwaypointv2_djiwaypointv2flightpathmode_curvaturecontinuousstop</code>.  @param flightpathmode an enum value of `waypointv2flightpathmode`.  @return the build of `builder`.",
             "setheadingmode",
             "heading of the aircraft as it moves between waypoints. default is `auto`.  @param headingmode an enum value of `waypointv2headingmode`.  @return the build of `builder`.",
             "setheading",
             "the heading to which the aircraft will rotate by the time it reaches the waypoint. the aircraft heading will gradually  change between two waypoints with different headings if the waypoint mission's `headingmode` is set to djiwaypointv2_djiwaypointv2headingmode_usingwaypointheading</code>.  a heading has a range of [-180, 180] degrees, where 0 represents true north.  @param heading a float type value of heading.  @return the build of `builder`.",
             "setturnmode",
             "determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @param turnmode an enum value of `waypointv2turnmode`.  @return the build of `builder`.",
             "setusingwaypointautoflightspeed",
             "determines whether the aircraft using waypoint auto flight speed executing waypoint mission. if `true`, the aircraft will use waypoint auto flight speed between two waypoints.  otherwise, will use `getautoflightspeed` as max flight speed.  @param usingwaypointautoflightspeed a boolean type value to set.  @return the build of `builder`.",
             "setusingwaypointmaxflightspeed",
             "determines whether the aircraft using waypoint max flight speed executing waypoint mission. if `true`, the aircraft will use waypoint max flight speed between two waypoints.  otherwise, will use `getmaxflightspeed` as max flight speed.  @param usingwaypointmaxflightspeed a boolean type value to set.  @return the build of `builder`.",
             "setautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. the aircraft's actual speed is a combination of the base automatic speed, and the  speed control given by the throttle joystick on the remote controller. if autoflightspeed >0: actual speed is autoflightspeed + joystick speed (with combined max of maxflightspeed)  if autoflightspeed =0: actual speed is controlled only by the remote controller joystick. if autoflightspeed <0 and the aircraft is at the first waypoint, the aircraft will hover in  place until the speed is made positive by the remote controller joystick. in flight controller firmware 3.2.10.0 or above, different speeds between individual waypoints can also be set in  waypoint objects which will overwrite autoflightspeed.  @param autoflightspeed a float type value to set.  @return the build of `builder`.",
             "setmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. maxflightspeed is this offset when the joystick is  pushed to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed, while pushing down will  subtract 10 m/s from the aircraft speed. if the remote controller stick is not at maximum deflection, then the offset speed will be interpolated between [0, maxflightspeed] with a resolution of 1000 steps. if the offset speed is negative, then the aircraft will fly backwards to previous waypoints. when it reaches the first waypoint, it will then hover in place  until a positive speed is applied. maxflightspeed has a range of [2,15] m/s.  @param maxflightspeed a float type value to set.  @return the build of `builder`.",
             "setdampingdistance",
             "corner radius of the waypoint. when the flight path mode  is `coordinate_turn` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. when there is a corner radius, the aircraft will never pass the waypoint. by default, the radius is 0.2 m. if the corner is made of three adjacent waypoints (short for a,b,c).  then the radius of a(short for ra) plus radius of b(short for rb) must be smaller than the distance between  a and b. the radius of the first and the last waypoint in a mission does not affect  the flight path and it should keep the default value (0.2m). when the flight path mode is `goto_first_point_along_straight_line` when aircraft reaches  the first waypoint, the flight path will be a straight flight with this distance. when the flight path mode is `straight_out` the flight path will be  a straight flight with this distance before until last waypoint.  @param dampingdistance a float type value of damping distance.  @return the build of `builder`.",
             "build",
             "build the object into a `waypointv2` object.  @return the build of `builder`.",
             "waypointv2flightpathmode",
             "waypoint flight path mode.",
             "curvature_continuous_passed",
             "in the mission, the aircraft will go to the waypoint along a curve and fly past the waypoint.",
             "goto_point_curve_and_stop",
             "in the mission, the aircraft will go to the waypoint along a curve and stop at the waypoint.",
             "goto_point_straight_line_and_stop",
             "in the mission, the aircraft will go to the waypoint along a straight line and stop at the waypoint.",
             "coordinate_turn",
             "in the mission, the aircraft will fly from the previous waypoint to the next waypoint along a smooth curve  without stopping at this waypoint. the next in a curved motion, adhering to the `getdampingdistance`,  which is set in `waypointv2`.",
             "goto_first_point_along_straight_line",
             "in the mission, the aircraft will go to the first waypoint along a straight line. this is only valid for the first waypoint.",
             "straight_out",
             "straight exit the last waypoint, only valid for last waypoint.",
             "unknown",
             "unknown.",
             "waypointv2headingmode",
             "represents current aircraft's heading mode on current waypoint.",
             "auto",
             "aircraft's heading will always be in the direction of flight.",
             "fixed",
             "aircraft's heading will be set to the heading when reaching the first waypoint. before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. when the aircraft  reaches the first waypoint, its heading will be fixed.",
             "manual",
             "the aircraft's heading in the mission can be controlled by the remote controller.",
             "waypoint_custom",
             "in the mission, the aircraft's heading will change dynamically and adapt to the heading set at the next waypoint.  see `getheading` to preset the heading.",
             "toward_point_of_interest",
             "after the first waypoint has been reached, aircraft heading will always toward to the point of interest. using `getpointofinterest` and `getpointofinterestaltitude` to set the coordinate of point of interest.",
             "unknown",
             "unknown.",
             "waypointv2turnmode",
             "the direction when the aircraft changes its heading to adapt to the heading at the waypoint.",
             "clockwise",
             "the aircraft's heading rotates clockwise.",
             "counter_clockwise",
             "the aircraft's heading rotates counterclockwise.",
             "unknown",
             "changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
             "builder",
             "this class is used for the developer to build the waypointv2mission.",
             "setmissionid",
             "set mission id.  @param missionid the value of missionid to set.  @return the build of `builder`.",
             "setmaxflightspeed",
             "while the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getmaxflightspeed` is this  offset when the joystick is pushed  to maximum deflection. for example, if maxflightspeed is 10 m/s, then pushing the throttle joystick all the  way up will  add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the  aircraft speed. if the remote controller stick is not at maximum deflection, then  the offset speed will be  interpolated between [0, `getmaxflightspeed`] with a resolution  of 1000 steps. if the  offset speed is negative, then the aircraft will fly backwards  to previous waypoints. when it reaches the  first waypoint, it will then hover in place  until a positive speed is  applied. `getmaxflightspeed` has a range of [2,15] m/s.  @param maxflightspeed the value of the max flight speed.  @return the build of `builder`.",
             "setautoflightspeed",
             "the base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s.  the aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by  the throttle joystick on the remote controller. if `getautoflightspeed` >0: actual  speed is `getautoflightspeed` + joystick speed (with combined max of `getmaxflightspeed`) if `getautoflightspeed` =0:  actual speed is  controlled only by the remote controller joystick. if `getautoflightspeed` <0 and the aircraft  is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoflightspeed the value of the auto flight speed.  @return the build of `builder`.",
             "setfinishedaction",
             "action the aircraft will take when the waypoint mission is complete.  @param finishedaction the enum value of `missionfinishedaction`.  @return the build of `builder`.",
             "setgotofirstwaypointmode",
             "defines how the aircraft will go to the first waypoint from its current position.  default is `safely`.  @param gotofirstwaypointmode the enum value of `missionfinishedaction`.  @return the build of `builder`.",
             "setexitmissiononrcsignallostenabled",
             "determines whether the mission should stop when connection between the aircraft and remote controller is lost. default is `false`.  @param exitmissiononrcsignallostenabled a boolean value.  @return the build of `builder`.",
             "setrepeattimes",
             "repeat times for mission execution. default is 1.  @param repeattimes an int value of mission repeat times.  @return the build of `builder`.",
             "addwaypoints",
             "adds an array of waypoints to the waypoint mission. when the waypoints are added successfully, `getwaypointcount` will increment by the number of added waypoints.  @param waypointlist a list of `waypointv2` objects.  @return the build of `builder`.",
             "addwaypoint",
             "as same as waypoint 1.0 add a waypoint to the waypoint mission. when a waypoint is added  successfully, `getwaypointcount` will increment by 1. a waypoint will only be valid  if the distance (in three dimensions) between two adjacent waypoints is in range [0.5,2000] meters.  @param waypoint a `waypointv2` object.  @return the build of `builder`.",
             "removewaypoint",
             "as same as waypoint 1.0, removes the last waypoint stored in the mission. when the waypoint is removed  successfully, `getwaypointcount` will decrease by 1.  @param waypoint a `waypointv2` object.  @return the build of `builder`.",
             "removewaypoint",
             "as same as waypoint 1.0, removes the last waypoint stored in the mission. when the waypoint is removed  successfully, `getwaypointcount` will decrease by 1.  @param index the index of the waypoint.  @return the build of `builder`.",
             "build",
             "build a `waypointv2mission` object.  @return the object of `waypointv2mission`.",
             "getlatitude",
             "latitude of the mission's initial target location.  @return a double value.",
             "getlongitude",
             "longitude of the mission's initial target location.  @return a double value.",
             "getaltitude",
             "initial altitude (above sea level) in meters.  @return a float value.",
             "getheading",
             "the aircraft's heading during the mission.  @return an enum value of `followmeheading`.",
             "followmeheading",
             "aircraft's heading during a follow me mission.",
             "toward_follow_position",
             "aircraft's heading remains toward the coordinate it is following.",
             "controlled_by_remote_controller",
             "aircraft's heading will be controlled by the remote controller.",
             "getpreviousstate",
             "the previous follow me mission state, check the `followmemissionstate` enum value.  @return an object of `followmemissionstate`.",
             "getcurrentstate",
             "the current follow me mission state, check the `followmemissionstate` enum value.  @return an object of `followmemissionstate`.",
             "getdistancetotarget",
             "get the distance to the target.  @return a float value of the distance to the target.",
             "geterror",
             "the encountered error if there is any. otherwise, it is `null`.  @return an object of `djierror`.",
             "followmemissionstate",
             "all the possible state of `followmemissionoperator`.",
             "unknown",
             "the state of the operator is unknown. it is the initial state when the  operator is just created.",
             "disconnected",
             "the connection between the mobile device and aircraft is lost.",
             "not_supported",
             "the connected product does not support follow me mission.",
             "recovering",
             "the connection between the mobile device and aircraft is built-up. the operator is synchronizing the state from the aircraft.",
             "not_ready",
             "the current state is not ready for uploading a mission.",
             "ready_to_execute",
             "the operator is ready to start a follow me mission.",
             "executing",
             "the mission execution is started successfully.",
             "got_stuck",
             "the mission execution is not executing successfully.",
             "addlistener",
             "add a listener to listen for all events in the tapfly mission operator.  @param listener listener that is interested in the tapfly mission operator.",
             "removelistener",
             "removes listener. the listener will not receive any updates after calling this method.  @param targetlistener listener to be removed.",
             "removealllisteners",
             "remove all listeners.",
             "setupenvironment",
             "setup environment and provide result in callback  @param callback the execution callback with the returned execution result.",
             "startmission",
             "starts to execute a tapfly mission. it can only be called when  the `getcurrentstate`   is `execution_starting`. if the mission is started successfully,  the `getcurrentstate` will  become `executing`.  @param mission an object of `tapflymission`. @param callback the execution callback with the returned execution result.",
             "stopmission",
             "stops the executing mission. it can only be called when  the `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  - `execution_resetting`  after a mission is stopped  successfully, `getcurrentstate` will  become `execution_starting`.  @param callback the execution callback with the returned execution result.",
             "resetheading",
             "resets aircraft heading to the flight direction. it can only be used  when `tapflymode` is `free`.  @param callback the execution callback with the returned execution result.",
             "setautoflightspeed",
             "sets auto flight speed for tapfly mission. it can be changed before or during the  execution of a tapfly mission.  @param speed auto flight speed. @param callback the execution callback with the returned execution result.",
             "getautoflightspeed",
             "gets the auto flight speed for tapfly mission in m/s.  @param callback the execution callback with the returned execution result.",
             "sethorizontalobstaclebypassenabled",
             "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. if `false`, the aircraft will only  go over an obstacle to avoid it. it can be changed before or during the execution  of a tapfly mission.  @param enabled `true` allows aircraft to bypass or move around an obstacle by going to the left or right. @param callback the execution callback with the returned execution result.",
             "gethorizontalobstaclebypassenabled",
             "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. if `false`, the aircraft will only  go over an obstacle to avoid it. it can be changed before or during the execution  of a tapfly mission.  @param callback the execution callback with the returned execution result.",
             "gettapflymode",
             "get the current tracking mode of the aircraft. it is valid when the `tapflymissionstate`  is one of the following:  - `executing`  - `execution_paused`  - `execution_resetting`  for the other states, the value  is `unknown`.  @return an enum value of `tapflymode`.",
             "tapflymissionoperatorlistener",
             "listener interface to receive events from the tapfly mission operator.",
             "onupdate",
             "called when a new event has been updated.  @param aggregation an object of `tapflymissionevent`.",
             "tapflymission",
             "a tapfly mission is initialized with a position target from the live video stream. the 3d direction of the coordinate is calculated, and the aircraft  will proceed to fly in that direction. the aircraft can automatically avoid obstacles when the scene is sufficiently illuminated (more than 300 lux but less than 10,000 lux). the aircraft will stop flying in the direction if it reaches its radius limitation, the mission is stopped, the user pulls back on the pitch stick or if it comes to an obstacle it cannot bypass. the remote controller yaw stick can be used to adjust the heading of the aircraft during mission execution, which also adjusts the direction of flight to the new yaw. using any other stick controls will cancel the mission.",
             "tapflymissionevent",
             "this class encapsulates all the state changes of the tapfly mission operator.",
             "getpreviousstate",
             "the previous state of the operator.  @return a object of `tapflymissionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return a object of `tapflymissionstate`.",
             "getexecutionstate",
             "the detailed state of the executing tapfly mission. it is only valid  when `getcurrentstate` is one of the following:  - `executing`  - `execution_paused`  for the other states, it is `null`.  @return a `tapflyexecutionstate` object.",
             "geterror",
             "the encountered error if any. otherwise, it is `null`.  @return a `djierror` object.",
             "tapflymissionstate",
             "all the possible states of `tapflymissionoperator`.",
             "unknown",
             "the state of the operator is unknown. this is the initial state when the operator is  first created.",
             "idle",
             "the operator is in idle state",
             "execution_starting",
             "the start execution command has been called but the aircraft hasn't yet acknowledged it has started. no other commands should be  called when in this state. the next state is either disconnected,  executing or readytoexecute.",
             "disconnected",
             "the connection between the mobile device and aircraft is broken.",
             "recovering",
             "the connection between the mobile device and aircraft is recovering.  in this state, the operator is synchronizing the state from the aircraft.",
             "not_support",
             "the connected product does not support tapfly mission.",
             "can_not_start",
             "there is an existing error stopping the tapfly mission to start.",
             "executing",
             "the operator is executing a tapfly mission.",
             "execution_paused",
             "the execution of the tapfly mission is paused. user can pause or resume a tapfly mission by pressing the pause button on the physical remote controller.",
             "execution_resetting",
             "the tapfly mission cannot continue the execution. the execution is being stopped automatically.",
             "waypoint",
             "initiate instance with specific waypoint.  @param latitude the latitude of the waypoint. @param longitude the longitude of the waypoint. @param altitude the altitude of the waypoint.",
             "coordinate",
             "waypoint coordinate latitude and longitude in degrees.",
             "altitude",
             "altitude of the aircraft in meters when it reaches waypoint. the altitude of the aircraft is relative to  the ground at the take-off location, and should not be larger than the aircraft's maximum altitude. if  two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.",
             "heading",
             "the heading to which the aircraft will rotate by the time it reaches the waypoint. the aircraft heading  will gradually change between two waypoints with different headings if the waypoint  mission's `getheadingmode` is set  to `using_waypoint_heading`. a heading has a range of  [-180, 180] degrees, where 0 represents true north. `heading` relate to behavior between this waypoint and the next waypoint in the mission.",
             "cornerradiusinmeters",
             "corner radius of the waypoint. when the flight path mode  is `curved` the flight path near a waypoint will be  a curve (rounded corner) with radius [0.2,1000]. when there is a corner radius, the aircraft will never  go through the waypoint. by default, the radius is 0.2 m. if the corner is made of three adjacent waypoints (short for a,b,c)  . then the radius of a(short for ra) plus radius of b(short for rb) must be smaller than the distance between  a and b. the radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m).",
             "turnmode",
             "determines whether the aircraft will turn clockwise or anticlockwise when changing its heading. `turnmode` relate to behavior between this waypoint and the next waypoint in the mission. not supported by mavic 2 series and phantom 4 rtk.",
             "gimbalpitch",
             "gimbal pitch angle when reached this waypoint. this property is used when the `isgimbalpitchrotationenabled` is true.  the range of the pitch angle should be gotten from the `adjust_pitch` or `adjust_pitch_upwards`.",
             "speed",
             "the base automatic speed of the aircraft as it moves between this waypoint and the next waypoint with range  [0, 15] m/s. by default, it is 0.0 and the aircraft will fly with `getautoflightspeed` of  the waypoint mission. if greater than 0, 'speed' will override `getautoflightspeed`.  this 'speed' can only define movement forward through the waypoint mission in comparison  to `getautoflightspeed` which can be both forward and backwards through a waypoint mission.  waypoint mission speed priority from highest to lowest is:  1) manual speed adjustment  with remote controller joy sticks  2) 'speed'  3) djiwaypointmissionoperator_setautoflightspeed</code>   4) `getautoflightspeed`  warning: 'speed', `shootphototimeinterval`  and `shootphotodistanceinterval` relate to behavior between this waypoint and the next  waypoint in the mission. in comparison. only supported by flight controller firmware 3.2.10.0 or above.",
             "shootphototimeinterval",
             "the time interval in seconds when two photos are taken as the aircraft moves between the current waypoint  and the next waypoint. the first photo will be taken as the aircraft leaves the current waypoint. the  maximum value is 6,000.0. the minimum value is above 0.0 and depends on the camera type and the camera  parameters. when the photo file format is jpeg, the recommended minimum value is 2.0. when the photo file  format is raw, the minimum value is 10.0. if the input exceeds the camera's capability, the pictures will  be taken at the maximum possible speed. the default value is 0.0 and no photo will be taken. for a  waypoint, either `shootphototimeinterval` or `shootphotodistanceinterval`  is 0.0. input with precision of greater than 1 decimal places, will be rounded to 1. warning: 'speed', `shootphototimeinterval`  and `shootphotodistanceinterval` relate to behavior between this waypoint and the next waypoint  in the mission. only supported by flight  controller firmware 3.2.10.0 or above.",
             "shootphotodistanceinterval",
             "the distance interval in meters when two photos are taken as the aircraft moves between the current  waypoint and the next waypoint. the maximum value is 6,000.0. the minimum value is above 0.0 and depends  on the camera type, the camera parameters and the flight speed. when the photo file format is jpeg, the time interval between two photos cannot smaller than 2 seconds. when the photo file format is raw, the  time interval between two photos cannot smaller than 10 seconds. if the input exceeds the camera's  capability, the taken photos may be less than expectation. the default value is 0.0 and no photo will be  taken. for a waypoint, either `shootphototimeinterval`  or `shootphotodistanceinterval` is 0.0. input with precision of greater than 1 decimal  places, will be rounded to 1. warning: 'speed', `shootphototimeinterval`  and `shootphotodistanceinterval` relate to behavior between this waypoint and the next  waypoint in the mission. only supported by flight controller firmware 3.2.10.0 or above.",
             "waypointactions",
             "array of all waypoint actions for the respective waypoint. the waypoint actions will be executed  consecutively from the start of the array once the aircraft reaches the waypoint.",
             "getactionatindex",
             "gets the action at the specified index.  @param index the specified index.  @return an instance of `waypointaction`.",
             "adjustactionatindex",
             "switches the action at the specified index.  @param index the specified index. @param action a djiwaypointaction object.  @return a boolean value.",
             "actionrepeattimes",
             "determines how many times the set of waypoint actions are repeated. the default value is one time, and  the maximum is `max_action_repeat_times`.",
             "actiontimeoutinseconds",
             "the maximum time set to execute all the waypoint actions for a waypoint. if the time while executing the  waypoint actions goes above the time set, the aircraft will stop executing the waypoint actions for the  current waypoint and will move on to the next waypoint. the value of this property must be in the range  of [0, 999] seconds. the default value is 60 seconds.",
             "addaction",
             "adds a waypoint action to a waypoint. the number of waypoint actions should not be larger  than `max_action_count`. the action will only be executed when the mission's `getflightpathmode` property is set  to `normal` and will not be executed when the  mission's `getflightpathmode` property is set  to `curved`. the maximum number of waypoint  actions you can add is 15.  @param action waypoint action to be added to the waypoint.  @return `true` if the waypoint action has been added to the waypoint. `false`  if the waypoint action count is too high, or if the waypoint action was incorrectly setup.",
             "insertaction",
             "insert a waypoint action at index. @return `true`, if the waypoint action has been  inserted. `false` if the waypoint action count is too high or the index is invalid.  @param action waypoint action to be inserted to the waypoint. @param index index of the inserted action.  @return a boolean value.",
             "removeaction",
             "removes a waypoint action from the waypoint. @return `true` if the waypoint action  has been removed from the waypoint.  @param action waypoint action to be removed from the waypoint.  @return a boolean value.",
             "removeactionatindex",
             "removes a waypoint action from the waypoint by index. after removal, all actions higher than the index will  be shifted down by one.  @param index the index of the waypoint action to be removed.  @return `true` if waypoint action has been removed from the waypoint.",
             "removeallaction",
             "remove all the actions.",
             "waypointaction",
             "this class represents a waypoint action for `waypoint`. it determines what action is performed when  the aircraft reaches the corresponding waypoint.",
             "waypointturnmode",
             "how the aircraft will turn at a waypoint to transition between headings.",
             "max_action_count",
             "maximum number of actions a single waypoint can have. the maximum supported number is 15.",
             "max_action_repeat_times",
             "maximum number of times a single waypoint action can be repeated. the maximum supported number is 15.",
             "actiontype",
             "waypoint action of type `waypointactiontype` the aircraft will execute this action once  the aircraft reaches the waypoint. all possible actions are defined in the `waypointactiontype` enum.",
             "actionparam",
             "action parameter for a waypoint action. see enum `waypointaction` for details on which  actions use `actionparam`.",
             "waypointaction",
             "initialize the class with a specific action type and corresponding parameter.  @param actiontype a djiwaypointactiontype object. @param actionparam action parameter of a waypoint action.",
             "waypointactiontype",
             "waypoint action types.",
             "stay",
             "keeps the aircraft at the waypoint's location. the `actionparam`  parameter will determine how much time in milliseconds the aircraft will stay at the location with  range of [0, 32767] milliseconds.",
             "start_take_photo",
             "starts to shoot a photo. the `actionparam` for the waypoint action will  be ignored. the maximum time set to execute this waypoint action is 6 seconds. if the time while executing  the waypoint action goes above 6 seconds, the aircraft will stop executing the waypoint action and will  move on to the next waypoint action, if one exists.",
             "start_record",
             "starts recording. the `actionparam` for the waypoint action will be  ignored. the maximum time set to execute this waypoint action is 6 seconds. if the time while executing  the waypoint action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing  the waypoint action and will move on to the next waypoint action, if one exists.",
             "stop_record",
             "stops recording. the `actionparam` for the waypoint action will be ignored.  the maximum time set to execute this waypoint action is 6 seconds. if the time while executing the waypoint  action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing the waypoint  action and will move on to the next waypoint action, if one exists.",
             "rotate_aircraft",
             "rotates the aircraft's yaw. the rotation direction is determined by the waypoint's `turnmode` property.  the `actionparam` value must be in the range of [-180, 180] degrees.",
             "gimbal_pitch",
             "rotates the gimbal's pitch. the range of the pitch angle should be gotten from `adjust_pitch` or `adjust_pitch_upwards`.",
             "clockwise",
             "changes the heading of the aircraft by rotating the aircraft clockwise.",
             "counter_clockwise",
             "changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
             "getcurrentstate",
             "the current state of the executing follow me mission.  @return an object of `followmemissionstate`.",
             "addlistener",
             "adds a new listener of all events.  @param listener an interface of `followmemissionoperatorlistener`.",
             "removelistener",
             "removes listener.  @param targetlistener an interface of `followmemissionoperatorlistener`.",
             "removealllisteners",
             "remove all listeners.",
             "startmission",
             "starts to execute a follow me mission. it can only be called when the `getcurrentstate` is  `ready_to_execute`. after a mission is started successfully, the `getcurrentstate` will become  `executing`.  @param mission an object of `followmemission`. @param callback the execution callback with the execution result returned.",
             "stopmission",
             "stops the executing mission. it can only be called when the  `getcurrentstate` is  `executing`. after a mission is stopped successfully,  `getcurrentstate` will become  `ready_to_execute`.  @param callback the execution callback with the execution result returned.",
             "updatefollowingtarget",
             "update the follow me mission's target location to follow.  @param location a locationcoordinate2d object. @param callback the execution callback with the execution result returned.",
             "getfollowingtarget",
             "get the following target's coordinate location.  @return a location object of locationcoordinate2d.",
             "followmemissionoperatorlistener",
             "listener interface for follow me mission.",
             "onexecutionupdate",
             "all events during mission execution.  @param event an object of `followmemissionevent`.",
             "onexecutionstart",
             "mission started.",
             "onexecutionfinish",
             "mission finished.  @param error error retrieving the value.",
             "followmemission",
             "the class represents a follow me mission. in a follow me mission, the aircraft is programmed to track and maintain a constant distant relative to some object, such as a person or a moving vehicle. you can use it to make the aircraft follow a gps device, such as a remote controller with a gps signal or a mobile device. it is not supported by mavic pro when using wifi connection. it is not supported by spark.",
             "followmemissionevent",
             "this class encapsulates all the state change of the follow me mission operator.",
             "sethotpoint",
             "sets the coordinate of the hotpoint.  @param hotpoint a locationcoordinate2d object of hotpoint.",
             "gethotpoint",
             "gets the coordinate of the hotpoint.  @return a object of `locationcoordinate2d`.",
             "setstartpoint",
             "set aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @param startpoint an enum value of `hotpointstartpoint`.",
             "getstartpoint",
             "get aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @return an enum value of `hotpointstartpoint`.",
             "setheading",
             "aircraft's heading while flying around the hotpoint. it can be pointed toward or away from the hotpoint, forward or backward along its flight route, or can be manually controlled by the remote controller.  @param heading aircraft heading.",
             "getheading",
             "get the aircraft's heading while flying around the hotpoint. it can be pointed toward or  away from the hotpoint, forward or backward along its flight route, and can be  controlled by the remote controller.  @return aircraft heading.",
             "setaltitude",
             "sets the altitude of the hotpoint orbit with a range [5,500] meters.  the altitude is relative to the ground altitude from which the aircraft took off.  @param altitude a double value of altitude to set.",
             "getaltitude",
             "gets the altitude of the hotpoint orbit with a range [5,500] meters.  the altitude is relative to the ground altitude from which the aircraft took off.  @return a double value of altitude.",
             "setradius",
             "sets the circular flight path radius with which the aircraft will fly around the hotpoint. the value of this property should be in the range  of [`min_radius`, `max_radius`] meters.  @param radius a double value of radius to set.",
             "getradius",
             "gets the circular flight path radius with which the aircraft will fly around the hotpoint. the value of this property should be in the range  of [`min_radius`, `max_radius`] meters.  @return a double value of radius.",
             "setangularvelocity",
             "sets the angular velocity in degrees/s of the aircraft as it orbits the hot point. the default value is 20 degrees/s. the maximum angular velocity allowed is relative to the orbit radius.  @param angularvelocity angular velocity in degrees/s.",
             "getangularvelocity",
             "gets the angular velocity (in degrees/second) of the aircraft as it orbits the hot  point. the default value is 20 degrees/s. the angular velocity is relative to the  orbit radius.  @return an int value of angular velocity.",
             "isclockwise",
             "`true` if the aircraft will move in a clockwise direction around the hotpoint.  @return a boolean value to check if is clockwise.",
             "setclockwise",
             "set to `true` if the aircraft should move in a clockwise direction around the hotpoint.  @param clockwise `true` for clockwise direction.",
             "hotpointmission",
             "constructor method for the djihotpointmission.  @param hotpoint location of the hotpoint. @param altitude altitude of the orbit in meters @param radius radius of the orbit in meters @param angularvelocity angular velocity of the aircraft in degrees/s @param isclockwise `true` if the aircraft should move in a clockwise direction around the hotpoint. @param startpoint initial location on the orbit to start @param heading aircraft heading during the mission",
             "resetmissionwithdata",
             "reset mission with hotpoint mission data.  @param data an object of `hotpointmission`.",
             "max_radius",
             "maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. currently 500m.",
             "min_radius",
             "minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
             "max_altitude",
             "maximum altitude in meters for a hotpoint mission.",
             "min_altitude",
             "minimum altitude in meters for a hotpoint mission.",
             "hotpointstartpoint",
             "aircraft starting point relative to the hotpoint.",
             "north",
             "start from the north.",
             "south",
             "start from the south.",
             "west",
             "start from the west.",
             "east",
             "start from the east.",
             "nearest",
             "start the circle surrounding the hotpoint at the nearest point on the  circle to the aircraft's current location.",
             "hotpointheading",
             "heading of the aircraft while orbiting the hotpoint.",
             "along_circle_looking_forwards",
             "heading is in the forward direction of travel along the circular path.",
             "along_circle_looking_backwards",
             "heading is in the backward direction of travel along the circular path.",
             "towards_hot_point",
             "heading is toward the hotpoint.",
             "away_from_hot_point",
             "heading of the aircraft is looking away from the hotpoint. it is in the direction of the vector defined from the hotpoint to the aircraft.",
             "controlled_by_remote_controller",
             "heading is controlled by the remote controller.",
             "using_initial_heading",
             "the heading remains the same as the heading of the aircraft when the mission started.",
             "isrunning",
             "`true` if the action is running.  @return a boolean value.",
             "takeoffaction",
             "this class represents a take-off action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline,  the aircraft will take-off when the timeline reaches the action. note: this action  has 60 seconds time_out mechanism. before invoking this action, please make sure the  aircraft's motors are turned off.",
             "aircraftyawaction",
             "this class represents an aircraft yaw rotation action to be scheduled on the mission  control timeline. by creating an object of this class and adding it to the timeline,  an aircraft will rotate around yaw by the specified angle with the specified speed  when the timeline reaches the action.",
             "gotoaction",
             "this class represents a go-to action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline, the aircraft will go to a specified location when the timeline reaches the action.",
             "gohomeaction",
             "this class represents a go-home action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline, the aircraft will go home when the timeline reaches the action.",
             "hotpointaction",
             "this class represents a hotpoint action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline,  the aircraft will fly along a portion of a circle centered on a location of interest when the timeline reaches the action.",
             "gimbalattitudeaction",
             "this class represents a gimbal movement action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline,  the camera's gimbal will move to the specified attitude when the timeline reaches the action. please be notified that the pitchrangeextensionenabled of gimbal is set to true by  default if the pitch value in user specified attitude is bigger than 0.",
             "recordvideoaction",
             "this class represents a video recording action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline,  the camera can start or stop video recording when the timeline reaches the action.",
             "shootphotoaction",
             "this class represents a shoot photo action used as an element in a timeline mission. by creating an object of this class and adding it to mission control's timeline,  the camera can shoot a photo when the timeline reaches the action.",
             "landaction",
             "this class represents a land action used as an element in a timeline mission. by creating  an object of this class and adding it to mission control's timeline, the aircraft will  land at its current location when the timeline reaches the action.",
             "setautoconfirmlandingenabled",
             "`true` to enable automatic confirmation during landing. for flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue  (see `confirmlanding`). enabling this auto confirmation, allows the  aircraft to continue landing without the user's confirmation during the timeline execution.  for firmware that does not require landing confirmation, the value is ignored. the default  value is `true`.  @param enable enable automatic confirmation during landing.",
             "getautoconfirmlandingenabled",
             "for flight controller firmware version 3.2.0.0 or above, when the clearance between the aircraft  and the ground is less than 0.3m, the aircraft will pause landing and wait for the user's  confirmation to continue. enabling the auto confirmation, allows the aircraft to  continue  landing without the user's confirmation during the timeline execution. for firmware that does  not require landing confirmation, the value is ignored. the default value  is `true`.  @return a boolean value.",
             "aircraftyawaction",
             "initialize with a yaw angle relative to current heading and an angular velocity. the angular velocity has a range of [0, 100] degrees/s and a default value of 20 degrees/s.  @param angle angle in degrees. @param velocity velocity in degrees/s.",
             "aircraftyawaction",
             "initialize with a yaw angle relative to current heading or absolute heading against true north.  the range of angle is [-180, 180]. this initializer should be preferred when accuracy of the angle  is more of a priority than smooth yaw movement.  @param angle angle in degrees. @param isabsolute `true` means angle is the absolute heading against true north. `false` means  angle is relative to the current heading.",
             "aircraftyawactionerror",
             "the error domain used to describe errors produced by the `aircraftyawaction` object.",
             "invalid_rotation_speed",
             "set rotation speed is not within valid range [0, 100].",
             "invalid_angle_value",
             "set angle value is not within valid range [-180, 180].",
             "cannot_run_virtual_stick",
             "aircraft currently in virtual sticks mode.",
             "gimbalattitudeaction",
             "initialize instance with gimbal target attitude. the value of `gimbalmode` is `unknown`.  @param attitude gimbal target attitude.",
             "setgimbalindex",
             "set the expected action gimbal index. for example there are two gimbals in m210, if you want to run action on gimbal i, you can either set  the index as 0 or do nothing because of the default index is 0; if you want to run action on gimbal ii, you need set the index as 1. default  index is 0 if user does not call this method to specify the index.  @param index index of the gimbal on which the action is expected to run.",
             "setcompletiontime",
             "completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. default is 1 second.  @param completiontime a double value of completion time.",
             "getgimbalmode",
             "current gimbal working mode.  @return gimbal mode.",
             "setgimbalmode",
             "for the gimbalattitudeaction, either free or yaw_follow mode is recommended.  if the gimbal mode is not set, the default mode is yaw_follow. check the  details on the description of each work mode in `gimbalmode` enum definition.  @param mode one of the work mode in `gimbalmode`.",
             "getcompletiontime",
             "completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. default is 1 second.  @return time in seconds.",
             "gettargetattitude",
             "target gimbal attitude.  @return a `attitude` object.",
             "gimbalattitudeactionerror",
             "a list of all errors relative to the gimbal attitude action.",
             "yaw_outside_max_capabilities",
             "yaw value passed is beyond the max capabilities of the gimbal.",
             "pitch_outside_max_capabilities",
             "pitch value passed is beyond the max capabilities of the gimbal.",
             "roll_outside_max_capabilities",
             "roll value passed is beyond the max capabilities of the gimbal.",
             "completion_time_invalid",
             "completion time value passed is invalid (less than 0).",
             "setautoconfirmlandingenabled",
             "`true` to enable automatic confirmation during landing. for flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue.  enabling the auto confirmation, allows the aircraft to continue landing without the user's  confirmation during the timeline execution. for firmware that does not require landing  confirmation, the value is ignored. the default value is `true`.  @param enable enable automatic confirmation during landing.",
             "getautoconfirmlandingenabled",
             "for flight controller firmware version 3.2.0.0 or above, when the clearance between the  aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for the  user's confirmation to continue. enabling the auto confirmation, allows the aircraft to  continue landing without the user's confirmation during the timeline execution. for firmware that  does not require landing confirmation, the value is ignored. the default value  is `true`.  @return a boolean value.",
             "gotoaction",
             "go to the specified coordinate from the current aircraft position.  the actiontype of this object is set to gotoactiontype.coordinate.  @param coordinate target coordinate.",
             "gotoaction",
             "go to the specified altitude (in meters) from the current aircraft position. the actiontype of this object is set to gotoactiontype.altitude.  @param altitude target altitude in meters.",
             "gotoaction",
             "go to the specified coordinate and altitude (in meters) from the current aircraft position.   the actiontype of this object is set to gotoactiontype.coordinate_and_altitude.  @param coordinate target coordinate. @param altitude target altitude in meters.",
             "setflightspeed",
             "flight speed of the aircraft when going to the target location. default is 8 m/s.  @param flightspeed a float value of the flight speed.",
             "getflightspeed",
             "flight speed of the aircraft when going to the target location. default is 8 m/s.  @return a float value of flight speed.",
             "gotoactionerror",
             "the error codes for the `gotoaction`.",
             "invalid_altitude",
             "altitude of the `gotoaction` waypoint mission is not valid, its value should  be in the range [-200, 500].",
             "invalid_coordinate",
             "gps coordinates of the gotoaction waypoint is not valid. latitude value should be in  the range [-90f, 90f] and longitude value should be in the range [-180f, 180f].",
             "invalid_flight_speed",
             "flight speed of the gotoaction waypoint is not valid. value should be in range [2, 15] m/s.",
             "newrecordvideoactionwithduration",
             "initialize instance with video recording duration in seconds.  @param duration time in seconds.  @return an instance of `recordvideoaction`",
             "newstartrecordvideoaction",
             "initialize instance for start video recording only.  @return an instance of `recordvideoaction`",
             "newstoprecordvideoaction",
             "initialize instance for stop video recording only.  @return an instance of `recordvideoaction`",
             "setcameraindex",
             "set the expected action camera index. for example there are two  cameras in m210, if you want to run action on camera i, you can  either set the index as 0 or do nothing because of the default  index is 0; if you want to run action on camera ii, you need set  the index as 1. default index is 0 if user does not call this method  to specify the index.  @param index index of the camera on which the action is expected to run.",
             "recordvideoactionerror",
             "error codes for record video actions.",
             "invalid_duration",
             "duration value is invalid (less than 0).",
             "newshootsinglephotoaction",
             "initialize object to shoot a single photo.  @return an instance of `shootphotoaction`.",
             "newshootintervalphotoaction",
             "initialize object to shoot multiple photos.  @param count photo count. @param interval time interval in seconds between shooting photos.  @return an instance of `shootphotoaction`.",
             "newstopintervalphotoaction",
             "initialize object to stop shooting photos. only works if there was a  previous `shootphotoaction` in the timeline which started shooting photos using  the `newshootintervalphotoaction` initializer with `wait` set to `false`.  @return an instance of `shootphotoaction`.",
             "setcameraindex",
             "set the expected action camera index. for example there are two cameras in m210, if you want to run action  on camera i, you can either set the index as 0 or do nothing because of the default index is 0; if you want  to run action on camera ii, you need set the index as 1. default index is 0 if user does not call this method  to specify the index.  @param index index of the camera on which the action is expected to run.",
             "shootphotoactionerror",
             "error codes for `shootphotoaction` specific errors.",
             "invalid_photo_count",
             "invalid value for photo count.",
             "invalid_time_interval",
             "invalid value for time interval.",
             "hotpointaction",
             "initialize with hotpoint mission. the hotpoint action  will automatically stop after one complete orbit (360 degrees).  @param hotpointmission an object of `hotpointmission`.",
             "hotpointaction",
             "initialize with a hotpoint mission and the angular distance the  aircraft should travel within the orbit.  @param mission an object of `hotpointmission`. @param surroundingangle angle in degrees.",
             "setsurroundingangle",
             "the angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. the default is 360 degrees.  @param surroundingangle angle in degrees",
             "gethotpointmission",
             "the hotpoint mission which is associated with this action.  @return a `hotpointmission` object.",
             "getsurroundingangle",
             "the angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. the default is 360 degrees.  @return angle in degrees.",
             "elementfromwaypointmission",
             "create timelineelement from a waypointmission. this element  then can be used in timeline.  @param mission a `waypointmission` object.  @return a `timelineelement` object.",
             "getmissionobject",
             "get the mission object that is being contained inside the wrapper class.  @return get the mission object.",
             "getwaypointmissionoperator",
             "returns the operator for waypoint missions.  @return a waypoint mission operator object.",
             "gethotpointmissionoperator",
             "returns the operator for hotpoint missions.  @return a hotpoint mission operator object.",
             "getfollowmemissionoperator",
             "returns the operator for follow me missions.  @return a follow me mission operator object.",
             "getactivetrackoperator",
             "returns the operator for activetrack missions.  @return an activetrack mission operator object.",
             "gettapflymissionoperator",
             "returns the operator for tapfly missions.  @return a tapfly mission operator object.",
             "getpanoramamissionoperator",
             "returns the operator for panorama missions.  @return a panorama mission operator object.",
             "getintelligenthotpointmissionoperator",
             "returns the operator for intelligent hotpoint missions.  @return an intelligent hotpoint mission operator object.",
             "getwaypointmissionv2operator",
             "returns the operator for waypoint v2 mission. only supported by matrice 300 rtk.  @return an waypoint v2 mission operator object.",
             "scheduleelement",
             "adds an element to the end of the timeline.  @param element a `timelineelement` element.  @return the first error if one occurred.",
             "scheduleelements",
             "adds a list of elements to the end of the timeline.  @param elements a list of `timelineelement` elements.  @return the first error if one occurred. ",
             "scheduleelementatindex",
             "insert an element into the timeline at an index.  @param element a `timelineelement` element @param index the element index to insert the new element before.  @return the first error if one occurred.",
             "unscheduleelement",
             "remove element from the timeline. if the same element was used more than once in the  timeline, then the first one will be removed.  @param element a `timelineelement` element that is already in the timeline.",
             "unscheduleelementatindex",
             "removes the element at an index in the timeline.  @param index index of element to remove.",
             "scheduledelementatindex",
             "returns the element at a given index in the timeline.  @param index an element index in the timeline.  @return either a mission, an element or `null` if nothing was at the given index.",
             "scheduledcount",
             "returns the number of elements within the timeline.  @return element count.",
             "unscheduleeverything",
             "clears the timeline, removing all elements.",
             "settriggers",
             "set the triggers for the timeline.  @param triggers list of `trigger` objects.",
             "gettriggers",
             "returns the list of triggers which are dependents of the timeline.  @return `trigger` list.",
             "starttimeline",
             "start timeline execution from the current element index `getcurrenttimelinemarker`.",
             "pausetimeline",
             "pause execution of the timeline, and current element (if pausible). if the current element is not pausible then this method will do nothing.",
             "resumetimeline",
             "resume element and timeline execution.",
             "stoptimeline",
             "stops the execution of the timeline, resets the marker index to 0.  release thread resources of timeline.",
             "istimelinerunning",
             "`true` if the timeline is running.  @return a boolean value that is `true` if timeline is running.",
             "getcurrenttimelinemarker",
             "tells the index in the timeline array that marks where the timeline is currently at.  changing this value will reposition where the timeline will resume/start work.  @return timeline element index.",
             "setcurrenttimelinemarker",
             "sets the element index within the timeline to start execution.  this value can be set only when a timeline is stopped (not executing or paused).  @param currenttimelinemaker timeline element index.",
             "istimelinepaused",
             "`true` if timeline is paused.  @return `true` if timeline is paused.",
             "getrunningelement",
             "the current element that is running in the timeline. if the timeline is not running, then this is `null`.  @return timeline element",
             "addlistener",
             "adds a listener to all timeline events.  @param listener a listener object.",
             "removelistener",
             "removes the listener from the timeline events listeners pool.  @param listener a previously added listener object.",
             "removealllisteners",
             "removes all listeners from the timeline events listeners pool.",
             "triggerable",
             "interface for object which support triggers.",
             "gettriggers",
             "get list of `trigger` objects.  @return a list of `trigger` objects.",
             "settriggers",
             "set the `trigger` objects list.  @param triggers list of `trigger` objects to set.",
             "timelineelement",
             "required behavior of elements that run in a timeline.  in addition to implementing this behavior, a timeline element must communicate with mission control to let it know its state. mission control will wait for updates from the timeline element before it itself progresses. refer to `timelineelementfeedback` for the methods mission control exposes for the timeline element to use to communicate.",
             "onevent",
             "listener used to process timeline events.  @param element the timeline element associated with the event, or `null` if the  event is global to the whole timeline (e.g. start, finish the  timeline). @param event event. @param error the optional error if the event was error-related.",
             "listener",
             "listener used to process timeline events.",
             "timelineevent",
             "events that can initiate a call to the mission control listener.",
             "timelineelementfeedback",
             "this protocol defines how the timeline element may contact mission control  to notify it of its own execution. this protocol is not intended to be  implemented by any other object and the use of a protocol is primarily  organizational.",
             "missioncontrolerror",
             "defines all missioncontrol related errors.",
             "gettriggers",
             "if implemented, mission control loads and activates the triggers for the duration that the timeline element is executing.  @return a list of `trigger` object.",
             "settriggers",
             "set the triggers array list to the timeline.  @param triggers a list of `trigger` objects.",
             "ispausable",
             "`true` if the element can be paused. if `false`, then when the timeline is asked to pause when this element is running, nothing will happen.  @return `true` if the element can be paused.",
             "checkvalidity",
             "returns an error if there is a configuration or parameter error in the element. returns `null` if there is no issue.  @return a `djierror` object.",
             "willrun",
             "if implemented, this is called by mission control right before running the element.",
             "run",
             "starts execution of timeline element. missions adopting this behavior are being run with their respective operators.",
             "pause",
             "pauses the execution of the element. must be implemented if `ispausable` returns `true`.",
             "resume",
             "resumes the execution of the element. must be implemented if `ispausable` returns `true`.",
             "stop",
             "stops execution of the element.",
             "didrun",
             "called after element execution, regardless of whether or not it was successful.",
             "setdelaytime",
             "sets the time you want to delay before element execution which is used for asynchronous processing scenarios. for example, if you want to execute `gimbalattitudeaction` after `shootphotoaction`, you should set delay time in `gimbalattitudeaction`. because it takes 1 to 2 seconds to take a photo, the gimbal's commands will not be responded during this period,  so we need to delay 2 seconds before turning the gimbal to ensure that the gimbal movement is executed correctly.  @param delaytime the time you want to delay before element execution, unit:second.",
             "getdelaytime",
             "gets the time you want to delay before element execution.  @return the time you set to delay before element execution.",
             "onstart",
             "used by elements to notify mission control of their successful start.  @param element a previously scheduled element. should also be the element running.",
             "onstartwitherror",
             "used by elements to notify mission control of a failure preventing to start.  @param element a previously scheduled element. should also be the element running. @param error a valid error object.",
             "onprogresswitherror",
             "used by elements to notify mission control of a progress in the execution. additional information may be pulled by mission control depending on the element. calling this method with an error means the element is still running and the error did not cause it to stop.  @param element a previously scheduled element. should also be the element running. @param error an optional error if something went wrong.",
             "onpause",
             "used by elements to notify mission control of a successful pausing.  @param element a previously scheduled element. should also be the element running.",
             "onpausewitherror",
             "used by elements to notify mission control of a failure to pause. the element is expected to be still running.  @param element a previously scheduled element. should also be the element running. @param error a valid error object.",
             "onresume",
             "used by elements to notify mission control of a successful resuming of a previously paused element.  @param element a previously scheduled element. should also be the element running.",
             "onresumewitherror",
             "used by elements to notify mission control of a failure to resume. the element is expected to be still paused.  @param element a previously scheduled element. should also be the element running. @param error a valid error object.",
             "onfinishwitherror",
             "used by elements to notify mission control of the end of the execution of it.  @param element a previously scheduled element. should also be the element running. @param error an optional error if the execution end was the result of it.",
             "onstopwitherror",
             "used by elements to notify mission control of a failure to stop the execution of the element. this should only be used to handle error after stoprun is called.  @param element a previously scheduled element. should also be the element running. @param error a valid error object.",
             "cannot_schedule_while_running",
             "tried to schedule new element while the timeline was running.",
             "not_pausable",
             "unsupported feature error. where possible: this error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
             "not_resumable",
             "unsupported feature error. where possible: this error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
             "timeline_element_out_of_bounds",
             "cannot start the timeline because the index of to be executed item is out of bounds.",
             "already_running",
             "cannot start the timeline while the timeline is running.",
             "not_running",
             "timeline is not running.",
             "action_is_null",
             "trigger action is triggered, but the action object is null.",
             "unknown",
             "unknown event type. this is a default value if no other event is matching.",
             "started",
             "timeline successfully started.",
             "start_error",
             "timeline failed to start.",
             "progressed",
             "timeline element progressed.",
             "paused",
             "timeline successfully paused.",
             "pause_error",
             "timeline failed to be paused.",
             "resumed",
             "timeline successfully resumed.",
             "resume_error",
             "timeline failed to resume.",
             "stopped",
             "timeline stopped successfully.",
             "stop_error",
             "timeline failed to stop and is still continuing in its previous state.",
             "finished",
             "timeline completed its execution normally.",
             "getcurrentstate",
             "the current state of the executing hotpoint mission executing.  @return the state of the hotpoint mission.",
             "addlistener",
             "adds listener to receive all of the hotpoint mission operator events.  @param listener listener that is interested in the hotpoint mission operator.",
             "removelistener",
             "removes listener.  @param targetlistener listener to be removed.",
             "removealllisteners",
             "remove all listeners from listener pool.",
             "startmission",
             "starts to execute a hotpoint mission. this only be called when the `getcurrentstate` is `ready_to_execute`. after a mission is started successfully, the `getcurrentstate` will become `initial_phase` or `executing`.  @param mission an object of `hotpointmission`. @param callback the execution callback with the execution result returned.",
             "pause",
             "pauses the executing mission. it can only be called when the `getcurrentstate` is  `initial_phase` or `executing`.  if this method is called in the `initial_phase` state, the aircraft will continue flying to the start point but it will not continue to circle around the hotpoint until the user resumes the mission. after a mission is paused successfully, the `getcurrentstate` will become `execution_paused`.  @param callback the execution callback with the execution result returned.",
             "resume",
             "resumes the paused mission. it can only be called when the `getcurrentstate` is `execution_paused`. after a mission is resumed successfully, the `getcurrentstate` will become `initial_phase` or `executing`.  @param callback the execution callback with the execution result returned.",
             "stop",
             "stops the executing or paused mission. it can only be called when `getcurrentstate` is one of the following:  - `initial_phase`  - `executing`  - `execution_paused`  after a mission is stopped successfully, `getcurrentstate` will become `ready_to_execute`.  @param callback the execution callback with the execution result returned.",
             "getexecutingmission",
             "gets the executing mission from the aircraft. it can only be called when `getcurrentstate` is one of the following:  - `initial_phase`  - `executing`  - `execution_paused`  @param mission detailed information of the mission being executed. `setaltitude` and `setradius` may be different from the initial settings when starting the mission. it is `null` if there is an error encountered when trying to get the mission. @param callback the execution callback with the execution result returned.",
             "setangularvelocity",
             "sets angular velocity for the executing mission. it can only be called when `getcurrentstate` is one of the following:  - `initial_phase`  - `executing`  - `execution_paused`  @param angularvelocity angular velocity to set. @param callback the execution callback with the execution result returned.",
             "setradius",
             "sets radius for the executing mission. it can only be called when the `getcurrentstate` is one of the following:  - `initial_phase`  - `executing`  - `execution_paused`  @param radius radius to set. @param callback the execution callback with the execution result returned.",
             "resetheading",
             "resets aircraft's heading to the direction defined by `setheading` of `hotpointmission`. it can only be called when the `getcurrentstate` is one of the following:  - `initial_phase`  - `executing`  - `execution_paused`  @param callback the execution callback with the execution result returned.",
             "getmaxangularvelocityforradius",
             "returns the maximum supported angular velocity, in degrees/s, for a given hotpoint mission radius in meters. returns 0 if an unsupported radius is specified.  @param radius hotpoint radius with a range of [5,500] meters. this is used to calculate the  maximum angular velocity. @param callback the execution callback with the execution result returned.",
             "hotpointmission",
             "this class represents a hotpoint mission. in a hotpoint mission, the aircraft will repeatedly fly circles of a constant radius around a specified point called a hot point. the user can control the aircraft to fly around the hotpoint with a specific radius and altitude. during execution, the user can also use the physical remote controller to modify its radius and speed. it is not supported by mavic pro when using wifi connection. it is not supported by spark, mavic mini, mavic air 2, dji air 2s and matrice 300 rtk.",
             "hotpointmissionoperatorlistener",
             "listener interface for listening to hotpoint mission events.",
             "onexecutionupdate",
             "called when a new hotpoint mission event occurs.  @param event updated event.",
             "onexecutionstart",
             "called when the hotpoint mission starts.",
             "onexecutionfinish",
             "called when the hotpoint mission ends.  @param error used when mission is finishes in an unexpected way.",
             "hotpointmissionevent",
             "this class encapsulates all the state changes of the hotpoint mission operator.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `hotpointmissionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `hotpointmissionstate`.",
             "getradius",
             "the hotpoint radius in meters of the mission. if there is no executing mission, it is 0.  @return a float value of radius.",
             "getmaxangularvelocity",
             "the hotpoint max angular velocity from current radius.  @return a float value of velocity.",
             "geterror",
             "the encountered error if there is any. otherwise, it is `null`.  @return a object of `djierror`.",
             "hotpointmissionstate",
             "states of `hotpointmissionoperator`.",
             "unknown",
             "the state of the operator is unknown. this is the initial state when the operator has just been created.",
             "disconnected",
             "the connection between the mobile device and aircraft is broken.",
             "recovering",
             "the connection between the mobile device and aircraft is recovering. at this time, the operator is synchronizing the state from the aircraft.",
             "not_supported",
             "the connected product does not support hotpoint mission.",
             "ready_to_execute",
             "mission is uploaded completely and the aircraft is ready to start the execution.",
             "initial_phase",
             "the aircraft is moving towards the start point of the hotpoint mission.",
             "executing",
             "the execution is started successfully.",
             "execution_paused",
             "hotpoint mission is paused successfully. user can call `resume` to continue the execution.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `activetrackstate`.",
             "isgesturemodeenabled",
             "`true` if gesture mode is enabled.  @return `true` if gesture mode is enabled.  ",
             "isautosensingenabled",
             "`true` if auto sensing is enabled.  @return `true` if auto sensing is enabled. ",
             "isautosensingforquickshotenabled",
             "`true` if auto sensing for quickshot is enabled. not supported by mavic air 2, dji air.  @return `true` if auto sensing for quickshot is enabled. ",
             "addlistener",
             "add a listener to listen to events in the activetrack operator.  @param listener listener that is interested in the activetrack mission operator events.",
             "removelistener",
             "removes listener. the listener will not receive any update after calling this method.  @param listener listener to be removed.",
             "removealllisteners",
             "remove all listeners.",
             "setgesturemodeenabled",
             "enables/disables gesture mode.  - a human subject can be automatically detected if they are moving a little (instead of requiring a defining rectangle)  - the human subject can accept the confirmation to track when a wave gesture is detected(wave with a single hand and the elbow higher than the shoulder)  - the tracked human can make the camera shoot a photo by showing a rectangle with their thumbs and index fingers to the aircraft.  - for mavic air 2 and dji air 2s, the human subject will enter `spotlight` mode when a wave gesture is detected. you can use `switchmode` to switch the mode you want to use.  gesture mode can only be enabled when the aircraft is flying but not tracking a target. the `getcurrentstate` should be one of the following:  - `idle`  - `cannot_start` after the gesture mode is enabled, `getcurrentstate` will become `detecting_human`.  gesture mode can be disabled when `getcurrentstate` is not any of the following:  - `unknown`  - `disconnected`  - `recovering`  - `not_support`  if the aircraft is already tracking a target, disabling gesture mode will stop the activetrack mission.  @param enabled `true` to enable gesture mode. @param callback the execution callback with the returned execution result.",
             "isautosensingsupported",
             "checks if the connected product supports auto sensing. when the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @return `true` if the product supports auto sensing.",
             "enableautosensing",
             "starts auto sensing. after auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getautosensedsubjects` in the updated event. quickshot requires a special auto sensing mode, therefore, use `enableautosensingforquickshot` if a quickshot mission will be performed. it is only supported when `isautosensingsupported` returns `true`. when the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @param callback the execution callback with the returned execution result.",
             "enableautosensingforquickshot",
             "starts auto sensing specifically for quickshot. after auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getautosensedsubjects` in the updated event. this interface is specific for quickshot, therefore, use `enableautosensing` for missions other than quickshot. it is only supported when `isautosensingsupported` returns `true`. when the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track. not supported by mavic air 2, dji air 2s.  @param callback the execution callback with the returned execution result.",
             "disableautosensing",
             "stops auto sensing (either for quickshot or the other active track modes). it is only supported when `isautosensingsupported` returns `true`.  @param callback the execution callback with the returned execution result.",
             "canstarttracking",
             "checks if the operator can start the mission.  @param mission an activetrack mission.  @return the possible error if the operator tries to start the mission.",
             "starttracking",
             "starts to execute an activetrack mission. it can only be called when the `getcurrentstate` is `idle` or `auto_sensing`. if a mission with `trace` or `profile` is started successfully, the `getcurrentstate` will become one of the following:  - `waiting_for_confirmation`  - `cannot_confirm`  (for mavic air 2, dji air 2s, there is no need to confirm when you start `trace` or `profile` mission.) if a mission with `spotlight` or `spotlight_pro` is started successfully, the `getcurrentstate` will become `only_camera_following`.  when the product supports auto sensing, enabling auto sensing is the pre- condition of starting active track.  @param mission the activetrack mission to check. @param callback the execution callback with the returned execution result.",
             "startautosensingmission",
             "starts to execute an activetrack mission after auto sensing (either for quickshot or the other active track modes) is started. the aircraft will start to track the subject defined by `settargetindex`. if auto sensing for active track modes other than quickshot is enabled, the active track mode to start is defined by `activetrackmission`'s `setmode`. `getquickshotmode` of `activetrackmission` will be ignored. if auto sensing specifically for quickshot is enabled, the quickshot mode to start is defined by `activetrackmission`'s `getquickshotmode`. `getquickshotmode` of `activetrackmission` will be ignored. it can only be called when the `getcurrentstate` is one of the following: - `auto_sensing` - `auto_sensing_for_quick_shot` if the aircraft has high confidence about the auto-sensed subject, confirmation is not required and the state will change to `aircraft_following` or `only_camera_following` (determined by the active track mode). otherwise, the state will change to `waiting_for_confirmation` and user need to perform `acceptconfirmation`.  @param mission the activetrack mission to check. @param callback the execution callback with the returned execution result.",
             "stoptracking",
             "stops the executing mission. it can only be called when the `getcurrentstate` is one of the following:  - `waiting_for_confirmation`  - `cannot_confirm`  - `aircraft_following`  - `only_camera_following`  - `finding_tracked_target`  after a mission is stopped successfully, `getcurrentstate` will become `idle` or `detecting_human` if gesture mode is enabled. if autosensing is enabled, the state will be `auto_sensing`.  @param callback the execution callback with the returned execution result.",
             "acceptconfirmation",
             "when the vision system is not sure the tracking rectangle is around the user's desired target, it will need confirmation before starting to fly relative to the target. the vision system will need confirmation when `getcurrentstate` is `idle`. `gettargetrect` of `activetracktrackingstate` can be used to show the user the rectangle the vision system is using. if the user agrees the rectangle represents the target they want to track, this method can be called to start flying relative to the target. for mavic air 2, dji air 2s, there is only circle mode need to confirm.  @param callback the execution callback with the returned execution result.",
             "rejectconfirmation",
             "rejects the target rectangle from the aircraft.  @param callback the execution callback with the returned execution result.",
             "stopaircraftfollowing",
             "stops the aircraft from following the target and ask for user confirmation again. it can only be called when the `getcurrentstate` is `aircraft_following`. after it is called successfully, `getcurrentstate` will become `waiting_for_confirmation`. not supported by mavic air 2, dji air 2s, it is recommended to switch to `spotlight` to replace this function.  @param callback the execution callback with the returned execution result.",
             "setcircularspeed",
             "setting a non-zero speed starts the aircraft circling the target. speed can be set within the range [-5, 5] m/s(for mavic air 2 and dji air 2s the value of circular speed is only a relative value, like 5 means to circle according to the maximum flight speed of the aircraft under the current radius, it's not measured in m/s) where a positive speed is a counter-clockwise movement (when viewing from the top). reverting the speed to 0 m/s ends the circling movement. it can only be called when the `getcurrentstate` is `aircraft_following` .  @param speed circular speed to set in m/s. @param callback the execution callback with the returned execution result.",
             "getcircularspeed",
             "in an activetrack mission, the aircraft can be set to circle the target while following it. this method returns the circular speed of the aircraft in m/s. (for mavic air 2 and dji air 2s, the value of circular speed is only a relative value, 5 means to circle according to the maximum flight speed of the aircraft under the current radius, but it's not measured in m/s.)  @param callback the execution callback with the returned execution result.",
             "switchmode",
             "changes the activetrack mode on the currently executing mission. it can only be called when the `getcurrentstate` is one of the following:  - `waiting_for_confirmation`  - `cannot_confirm`  - `only_camera_following`  - `finding_tracked_target`  - `idle` - `auto_sensing`  - `aircraft_following`  if the current state is `aircraft_following`, `stopaircraftfollowing` should be called before switching the mode. also, the activetrack mode can only be changed when gesture mode is disabled.  for mavic air 2 and dji air 2s, there are no these two restrictions.  mavic 2 series does not support this interface, you should stop the mission and start a new mission to replace this function.  @param mode active track mode to change. @param callback the execution callback with the returned execution result.",
             "switchquickshotmode",
             "changes the quickshot sbmode on the currently executing mission. it is only supported by spark.  @param mode quickshot submode to change. @param callback the execution callback with the returned execution result.",
             "switchspotlightmode",
             "changes the spotlight submode on the currently executing mission, it is only supported by matrice 300 rtk.  @param spotlightmode spotlight submode to change. @param callback the execution callback with the returned execution result.",
             "setrecommendedconfiguration",
             "sets the recommended camera and gimbal configuration that optimizes performance for the activetrack mission in most environments.  @param callback the execution callback with the returned execution result.",
             "setretreatenabled",
             "enables/disable if the aircraft can retreat (fly backwards) when the target comes toward it. when it is disabled, the aircraft will not retreat and instead rotate the gimbal pitch down to track the target as it goes underneath. if the target goes beyond the gimbal's pitch stop, the target will be lost and the mission will stop. not supported by mavic air 2, dji air 2s.  @param enabled `true` to enable retreat during activetrack mission. @param callback the execution callback with the returned execution result.",
             "getretreatenabled",
             "determines whether retreat is enabled in activetrack mission. not supported by mavic air 2 and dji air 2s.  @param callback the execution callback with the returned execution result.",
             "activetrackmission",
             "activetrack mission allows an aircraft to track a moving subject using the vision system and without a gps tracker on the subject.",
             "activetrackmissionevent",
             "this class encapsulates all the state changes of the activetrack mission operator.",
             "activetrackmissionoperatorlistener",
             "listener interface used to listen to activetrack mission events.",
             "onupdate",
             "called when an event occurs in the activetrack mission.  @param event an object of `activetrackmissionevent`.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `activetrackstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `activetrackstate`.",
             "gettrackingstate",
             "the tracking state of the executing activetrack mission. it is only valid when `getcurrentstate` is one of the following:  - `waiting_for_confirmation`  - `cannot_confirm`  - `aircraft_following`  - `only_camera_following`  for the other states, it is `null`.  @return an object of `activetracktrackingstate`.",
             "geterror",
             "the encountered error if there is any. otherwise, it is `null`.  @return an error of `djierror`.",
             "activetrackstate",
             "all the possible states of `activetrackoperator`.",
             "unknown",
             "the state of the operator is unknown. it is the initial state when the operator is just created.",
             "disconnected",
             "the connection between the mobile device and aircraft is broken.",
             "recovering",
             "the connection between the mobile device and aircraft is recovering. in this state, the operator is synchronizing the state from the aircraft.",
             "not_support",
             "the connected product does not support activetrack mission.",
             "cannot_start",
             "there is existing error stopping any activetrack mission to start.",
             "auto_sensing",
             "the active track sensor is enabled and the aircraft is detecting the targets automatically. if there is target found, user can choose the right tracking subject. in this state, user can still manually draw the rectangle.",
             "auto_sensing_for_quick_shot",
             "the quick shot sensor is enabled. not supported by mavic air 2, dji air 2s.",
             "detecting_human",
             "gesture mode is enabled and the aircraft is looking for a target automatically. if a target is found, the operator will go to state `waiting_for_confirmation` or `cannot_confirm`. not supported by mavic 2, mavic 2 pro, mavic 2 zoom, mavic air 2, dji air 2s.",
             "waiting_for_confirmation",
             "target is found. camera is already tracking the target. in order to make the aircraft follow the target, the confirmation from user is required. once the target is confirmed, the state will become `aircraft_following`. for mavic air 2, dji air 2s, only circle mode supprt this state, trace mode and profile mode do not require confirmation.",
             "cannot_confirm",
             "target is found. camera is already tracking the target but there is an error stopping the aircraft to follow the target. use `getreason` in `activetracktrackingstate` to check the reason.",
             "aircraft_following",
             "target is found. camera is already tracking the target and the aircraft is following the target.",
             "only_camera_following",
             "the operator is executing an activetrack mission in splotlight mode or spotlight pro mode. the target is found and camera is following the target.",
             "performing_quick_shot",
             "the operator is executing a quickshot activetrack mission. not supported by mavic air 2, dji air 2s.",
             "finding_tracked_target",
             "activetrack is started but the target is lost. the vision system is detecting the previously found target.",
             "idle",
             "the mission is idle.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `panoramamissionstate`.",
             "addlistener",
             "adds listener to receive all events of the panorama mission operator.  @param listener an interface of `panoramamissionoperatorlistener`.",
             "removelistener",
             "removes listener. the listener will not receive any update after calling this method.  @param listener listener to be removed.",
             "removealllisteners",
             "remove all listeners.",
             "setup",
             "sets up the panorama mission with the specific mode. it can only be called  when the `getcurrentstate` is one of the  following:  - `ready_to_setup`  - `ready_to_execute`  if the setup starts  successfully, `getcurrentstate` will become  `setting_up`. normally, it will take seconds to  complete the setup. once setup is completed successfully,  `getcurrentstate` will become  `ready_to_execute`.  @param mode an enum value of `panoramamode`. @param callback the execution callback with the returned execution result.",
             "startmission",
             "starts to execute the mission that has been setup.  it can only be called when  the `getcurrentstate` is `ready_to_execute`.  if the mission is started successfully, the  `getcurrentstate` will become `executing`.  @param callback the execution callback with the returned execution result.",
             "stopmission",
             "stops the executing mission. it can only be called when the  `getcurrentstate` is  `executing`. after a mission is stopped successfully,  `getcurrentstate` will become  `ready_to_execute`.  @param callback the execution callback with the returned execution result.",
             "getrecentpanoramamediafile",
             "retrieves the `mediafile` object for the recently finished panorama  mission.  @param callback the execution callback with the returned execution result.",
             "panoramamissionoperatorlistener",
             "listener interface for panorama mission events.",
             "onexecutionupdate",
             "called when received a new panorama mission event.  @param event an object of `panoramamissionevent`.",
             "panoramamissionevent",
             "this class encapsulates all the state changes of the panorama mission operator.",
             "getpreviousstate",
             "the previous state of the operator.  @return an object of `panoramamissionstate`.",
             "getcurrentstate",
             "the current state of the operator.  @return an object of `panoramamissionstate`.",
             "getexecutionstate",
             "the detailed state of the executing panorama mission. it is only valid when `getcurrentstate` is  `executing`. for the other states, it is `null`.  @return an object of `panoramamissionexecutionstate`.",
             "geterror",
             "the error of djipanoramamissionevent.  @return an object of `djierror`.",
             "panoramamissionstate",
             "panorama mission state.",
             "unknown",
             "the state of the operator is unknown. this is the initial state when the operator  has just been created.",
             "disconnected",
             "the connection between the mobile device and osmo is broken.",
             "not_supported",
             "the connected product does not support panorama mission.",
             "ready_to_setup",
             "the operator is ready to setup a panorama mission.",
             "setting_up",
             "the operator is setting up for a panorama mission.",
             "ready_to_execute",
             "the setup for the panorama mission is complete. the operator is ready to  start the execution.",
             "executing",
             "the operator is executing a panorama mission.",
             "panoramamissionexecutionstate",
             "this class provides the real-time status of an executing panorama mission.",
             "gettotalnumber",
             "the total number of photos that will be shot during the mission. in full circle mode,  the number should be 8. in the half circle mode, the number should be 5.  @return an int value of total shot photo number.",
             "getcurrentshotnumber",
             "the number of photos that have been shot.  @return an int value of current shot photo number.",
             "getcurrentsavednumber",
             "the number of photos that have been saved to sd card.  @return an int value of current saved photo number.",
             "panoramamode",
             "defines options for different types of modes for panorama mission.",
             "full_circle",
             "360 degree panorama mode.",
             "half_circle",
             "180 degree panorama mode. also known as selfie mode.",
             "unknown",
             "unknown mode.",
             "intelligenthotpointmission",
             "constructor method for the djiintelligenthotpointmission.  @param hotpoint location of the hotpoint.",
             "checkparameters",
             "checks if the configuration for mission is valid before calling `startmission` of `intelligenthotpointmissionoperator`.  @return null if everything is ok, a djierror if at least one is invalid.",
             "sethotpoint",
             "sets the coordinate of the hotpoint.  @param hotpoint a `locationcoordinate2d` object of hotpoint.",
             "gethotpoint",
             "gets the coordinate of the hotpoint.  @return a `locationcoordinate2d` object of hotpoint.",
             "max_radius",
             "maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. currently 500m.",
             "min_radius",
             "minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
             "max_altitude",
             "maximum altitude in meters for an intelligent hotpoint mission.",
             "min_altitude",
             "minimum altitude in meters for an intelligent hotpoint mission.",
             "intelligenthotpointmissionmode",
             "this enum defines the mission mode.",
             "gps_based",
             "this mode means current mission is started by `startmission`.",
             "vision_based",
             "this mode means current mission is started by `startrecognizetargetinrect`  and `acceptconfirmation`. in this mode, you  can `resetgimbaltocenter` while mission is executing or paused.",
             "unknown",
             "the mission mode is unknown.",
             "settargetrect",
             "a bounding box for the target. the rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right. the `size` parameter of `cgrect` can be set to 0 to initialize the mission with a point instead of a rectangle. if the mission is initialized with a point, the vision system will try to recognize the object around the point and return the representative rect in the status delegate.  this property is used when the `activetrackmission` object is passed to `starttracking`. if the object is passed to `startautosensingmission`, this property will be ignored. use `settargetindex` to select the target to track instead.  @param targetrect a rectf object.",
             "settargetindex",
             "the index of the subject to track. after starting auto sensing (by calling `enableautosensing` or `enableautosensingforquickshot`), the aircraft will push the sensed subjects (`getautosensedsubjects`). select the subject to track by passing the index of the subject. this property is used when the `activetrackmission` object is passed to `startautosensingmission`. if the object is passed to `starttracking`, this property will be ignored. use `settargetrect` to define the target to track.  @param targetindex the index of the subject to track.",
             "gettargetrect",
             "get rectf object that represents target  @return a rectf object.",
             "setmode",
             "activetrack mission mode. defaults to `trace`.  @param mode an enum value of `activetrackmode`.",
             "getquickshotmode",
             "the quickshot mode determines the preset flight path. it is only used when `setmode` is `quick_shot`.  defaults to `unknown`. it is only supported by spark.  @return an enum value of `quickshotmode`.",
             "setquickshotmode",
             "set the quickshot mode. it is only supported by spark.  @param quickshotmode an enum value of `quickshotmode`.",
             "getspotlightmode",
             "gets the spotlight mode. it is only used when `setmode`  is `spotlight`. defaults to `unknown`.  @return an enum value of `spotlightmode`.",
             "setspotlightmode",
             "set the spotlight mode.  @param spotlightmode an enum value of `spotlightmode`.",
             "activetrackmission",
             "a constructor method for activetrackmission. the first param can be nullable if the object is passed to `startautosensingmission`.  @param targetrect the target rect. @param mode an enum value of `activetrackmode`.",
             "getmode",
             "get the current activetrack mode for activetrack mission.  @return an enum value of `activetrackmode`.",
             "gettargetindex",
             "get target index.  @return an int value of target index.",
             "activetracktrackingstate",
             "the tracking state of the activetrack mission that is executing.",
             "getstate",
             "the state of the target being tracked.  @return an enum value of `activetracktargetstate`.",
             "gettype",
             "the type of the target being tracked.  @return an enum value of `activetracktargettype`.",
             "gettargetrect",
             "a rectangle in the live video view image that represents the target being tracked. the rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return a rectf object.",
             "gettargetindex",
             "an int value of target index.  @return an int value of target index.",
             "getreason",
             "reason why the target cannot be confirmed by the user. it is useful when `getstate` is `cannot_confirm`.  otherwise, it is `none`. not supported by mavic air 2, dji air 2s.  @return an enum value of `activetrackcannotconfirmreason`.",
             "getcompletionpercentage",
             "the progress of the executing quickshot mission. only applicable when `setmode` is `quick_shot`. for other modes, it is always 0.  @return an int value of the progress.",
             "getautosensedsubjects",
             "the auto-sensed subjects after enabling auto sensing.  @return an array of `subjectsensingstate`",
             "subjectsensingstate",
             "the state of one of the auto-sensed subject after enabling auto sensing. only supported by dji mavic air.",
             "getindex",
             "index of the auto-sensed subjects. after enabling auto sensing, the aircraft may find multiple subjects and an index will be assigned to each subject. use this index to select the subject to track.  @return an int value of target index.",
             "getstate",
             "the target state of the auto-sensed subject.  @return an enum value of `activetracktargetstate`.",
             "gettargettype",
             "the type of the auto-sensed subject.  @return an enum value of `activetracktargettype`.",
             "gettargetrect",
             "a rectangle in the live video view image that represents the auto-sensed subject. the rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return a rectf object.",
             "activetrackcannotconfirmreason",
             "the reason why user is not allowed to confirm the current target.",
             "none",
             "none.",
             "unstable_target",
             "the target is unstable.",
             "target_too_high",
             "the target position is too high.",
             "blocked_by_obstacle",
             "there is an obstacle between the aircraft and the target that is blocking the target.",
             "gimbal_attitude_error",
             "the gimbal's attitude is pointing to the ground.",
             "target_too_far",
             "the target is too far away from the aircraft.",
             "target_too_close",
             "the target is too close to the aircraft.",
             "aircraft_too_high",
             "the altitude of the aircraft is too high.",
             "aircraft_too_low",
             "the altitude of the aircraft is too low.",
             "obstacle_sensor_error",
             "the obstacle vision sensor has errors.",
             "unknown",
             "unknown.",
             "activetrackmode",
             "different modes of the activetrack mission. defaults to `trace`, set to others to enable the feature.",
             "active_track_mode",
             "sdk key for activetrackmode: different modes of the activetrack mission. defaults to `trace`, set to others to enable the feature.",
             "trace",
             "aircraft moves in behind the subject keeping a constant distance to it. mission with this mode can only be started when the aircraft is flying.",
             "profile",
             "aircraft moves in parallel with the subject in the frame instead of behind. mission with this mode can only be started when the aircraft is flying.",
             "spotlight",
             "in spotlight mode, the aircraft camera automatically follows the subject by rotating the aircraft's yaw, but the aircraft does not automatically keep a constant distance with the subject. mission with this mode can only be started when the aircraft is flying.",
             "spotlight_pro",
             "in spotlight pro mode, the aircraft camera automatically follows the subject by rotating the gimbal's yaw, but the aircraft does not automatically keep a constant distance with the subject. not supported by mavic air 2, dji air 2s.",
             "quick_shot",
             "in quickshot mode, the aircraft will fly in one of four preset paths (see `quickshotmode`) while tracking the object recording a video. when a quickshot mission ends, a 10-second video will be generated. supported by spark and mavic 2 series.",
             "circle",
             "aircraft will circle around the object it is tracking. only supported by mavic air 2 and mavic 2 series.",
             "unknown",
             "the active track mode is unknown.",
             "quickshotmode",
             "quickshot modes, which define different preset path for a quickshot mission.",
             "circle",
             "aircraft will circle around the object it is tracking.",
             "dronie",
             "aircraft will fly backward and upward with camera locked on the object it is tracking.",
             "helix",
             "aircraft will fly upward, spiraling around the object it is tracking.",
             "rocket",
             "the aircraft will ascend with the camera pointing downward on the object it is tracking.",
             "boomerang",
             "the aircraft will fly around the tracking object in an upwardly sloped oval with the video finishing at the start point. supported by dji mavic air, mavic 2 zoom and mavic 2 pro.",
             "asteroid",
             "the aircraft will fly backward and upward while recording video, capture a sphere panorama at the end of the flight path, then combine the footage and panorama into a short video. supported by dji mavic air, mavic 2 zoom and mavic 2 pro.",
             "dolly_zoom",
             "the aircraft will fly backward and upward. it will adjust the zoom during flight to keep the selected subject the same while the background changes. ensure there is sufficient space when using dolly zoom. allow at least triple distance from aircraft to the subject behind the aircraft. only supported by mavic 2 zoom.",
             "unknown",
             "unknown.",
             "spotlightmode",
             "spotlight modes, which define different submode for a spotlight mission.",
             "zoom_gimbal_following",
             "in gimbal follow mode, the orientation of the aircraft heading is always consitent with the gimbal, both aiming at the target. at this time, the attitude of the gimbal will be automatically adjusted so that the target can be in the center of the screen, and the user can fine-tune the field of view by triming the gimbal dial; the camera will automatically adjust the zoom to make the size of the target suitable.",
             "zoom_gimbal_free",
             "in gimbal free mode, the spot light tracking will only control the gimbal to track the target instead of the drone so that the landing gear of the aircraft may appear in the view and the gimbal rotation range is limited by the gimbal mechanical limit.",
             "activetracktargettype",
             "the type of activetrack target.",
             "human",
             "the activetrack target is a human being.",
             "car",
             "the activetrack target is a car.",
             "van",
             "the activetrack target is a van.",
             "bike",
             "the activetrack target is a bike.",
             "boat",
             "the activetrack target is a boat.",
             "unknown",
             "the aircraft cannot recognize the target type.",
             "activetracktargetstate",
             "the state of the target being tracked by the aircraft.",
             "cannot_confirm",
             "the aircraft has recognized the target but the user is not allowed to confirm the target. check `getreason` to get more information.",
             "waiting_for_confirmation",
             "the aircraft has recognized the target and is waiting for user's confirmation. if this state, the aircraft will hover in the current position while the camera is tracking the target (by rotating aircraft's yaw or gimbal's altitude). if user confirms the target, the aircraft will start to following the movement of the target.",
             "tracking_with_high_confidence",
             "the aircraft has recognized the target with high confidence.",
             "tracking_with_low_confidence",
             "the activetrack mission is tracking a target with low confidence. this is only an indication that either the aircraft will soon ask for confirmation that the target is correct, or may loose tracking the target entirely if confidence doesn't improve.",
             "unknown",
             "unknown.",
             "interruptrecoveractiontype",
             "determines the recover mission flying to which point. call `recovermission` to recover mission.  the waypoint mission is interrupted by invoking `interruptmission`. the waypoint mission is  interrupted by moving remote controller's joystick. other interruption such as obstacle avoidance.",
             "gobacktorecordpoint",
             "when the mission is recovered, the aircraft flying to the recorded point.",
             "gobacktonextpoint",
             "when the mission is recovered, the aircraft flying to next waypoint.",
             "missionfinishedaction",
             "actions will be taken when the waypoint mission is finished.",
             "no_action",
             "no further action will be taken. the aircraft can be controlled by the remote controller.",
             "go_home",
             "goes home when the mission is finished. the aircraft will land directly if it is within 20  meters away from the home point.",
             "auto_land",
             "the aircraft will land automatically at the last waypoint.",
             "go_first_waypoint",
             "the aircraft will go back to the first waypoint and hover.",
             "continue_until_stop",
             "when the aircraft reaches its final waypoint, it will hover without ending the mission. the joystick  can still be used to pull the aircraft back along its previous waypoints. the only way this mission  can end is if stopmission is called.",
             "missiongotowaypointmode",
             "possible flight mode to executes the mission.",
             "safely",
             "go to the waypoint safely. the aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. it then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
             "point_to_point",
             "go to the waypoint from the current aircraft point to the waypoint directly.",
             "actiontypes",
             "manage all the action types.",
             "associatedtimingtype",
             "the type of `waypointv2associatetriggerparam`,  determines the time to execute the trigger associated with another one.",
             "simultaneously",
             "the trigger starts simultaneously with the trigger that is associated.",
             "after_finished",
             "the trigger starts after the trigger associated has finished.",
             "unknown",
             "unkown timing type.",
             "actionintervaltype",
             "the type of `waypointintervaltriggerparam`,  determines the interval type of how action repeats.",
             "distance",
             "the action will be repeated after a particular distance.",
             "time",
             "the action will be repeated after a particular period of time.",
             "unknown",
             "unknown action trigger type.",
             "actiontriggertype",
             "possible types of action trigger.",
             "reach_point",
             "the action will be trigger when the aircraft reach the waypoint point. the parameters should be setting  by `waypointreachpointtriggerparam`.",
             "associate",
             "the action will be triggered when action associated executes. the parameters should be defined  by `waypointv2associatetriggerparam`.",
             "trajectory",
             "the action will be triggered when the aircraft flies from one waypoint to the next.  this trigger applies only to `aircraft_control_gimbal`.  when this is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index. the parameters should be defined by `waypointtrajectorytriggerparam`.",
             "simple_interval",
             "the action will be triggered when the aircraft flies between two waypoints the parameters should be defined by `waypointintervaltriggerparam`.",
             "unknown",
             "unknown.",
             "actionactuatortype",
             "possible types of action actuator.",
             "camera",
             "the action will be executed by the camera. the parameters should be defined by `waypointcameraactuatorparam`.",
             "gimbal",
             "the action will be executed by the gimbal. the parameters should be defined by `waypointgimbalactuatorparam`.",
             "aircraft_control",
             "the action will executes by controlling aircraft. the parameters should be defined by `waypointaircraftcontrolparam`.",
             "lidar",
             "the action will executes by the lidar. the parameters should be defined by `waypointlidaractuatorparam`.",
             "unknown",
             "unknown actuator type.",
             "gimbaloperationtype",
             "the type of gimbal actuator operation.",
             "rotate_gimbal",
             "rotates the gimbal. the range of the pitch angle should be gotten from `adjust_pitch` or `adjust_pitch_upwards`.  only valid when the trigger type is `reach_point`.",
             "aircraft_control_gimbal",
             "rotates the gimbal. only valid when the trigger type is `trajectory`.",
             "path_shooting",
             "rotates the gimbal then take photos. this type is only supported by zenmuse p1. you can use this type to achieve smart oblique capture.  elevate the efficiency of your oblique photography mission using smart oblique capture, where the gimbal automatically rotates to take photos at the different angles needed. only photos essential to the reconstruction will be taken at the edge of the flight area, increasing the efficiency of post processing by 20% to 50%. only valid when the trigger types are `reach_point` and `associate`.",
             "unknown",
             "unknown.",
             "cameraoperationtype",
             "possible types of camera actuator operation.",
             "shoot_single_photo",
             "starts to shoot a photo.",
             "start_record_video",
             "starts to record a video.",
             "stop_record_video",
             "stops to record a video.",
             "custom_name",
             "custom expand file or directory name. you can use this actuator type to customize the file name and folder name of photos during the flight route,  it is convenient for users to manage the files after exporting media files from camera. this type should be set in `setcameraoperationtype`. meanwhile you should set the param for `setcustomnameparam` which used to determine whether you need to customize the file name or folder.",
             "focus",
             "you can use this type to point focus or rectangle focus.",
             "zoom",
             "adjust the camera focal length. only support those support zoom cameras.",
             "focus_mode",
             "set the camera focus mode. we currently support auto and manual modes.",
             "unknown",
             "unknown.",
             "gimbalpathshootingtype",
             "possible types of gimbal path shootting operation.",
             "start_path_shooting",
             "start path shooting.",
             "stop_path_shooting",
             "stop path shooting.",
             "unknown",
             "unknown type.",
             "gimbalpathcyclemode",
             "possible types of gimbal path cycle mode operation.",
             "once",
             "path shooting will be executed once.",
             "unlimited",
             "path shooting will be executed countless times.",
             "lidaroperationtype",
             "possible types of lidar operation.",
             "record_point_cloud",
             "point cloud record opration. you can use this type to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
             "pointcloudrecordtype",
             "possible types of point cloud record operation.",
             "stop_record_point_cloud",
             "stop point cloud recording.",
             "start_record_point_cloud",
             "start point cloud recording.",
             "pause_record_point_cloud",
             "pause point cloud recording.",
             "resume_record_point_cloud",
             "resume point cloud recording.",
             "aircraftcontroltype",
             "possible types of aircraft control actuator operation.",
             "rotate_yaw",
             "rotates the aircraft's yaw.",
             "start_stop_fly",
             "keeps the aircraft stop flying or start flying.",
             "cameracustomnametype",
             "possible types of custom expand name actuator operation.",
             "file",
             "custom expand file name. when your set this type in waypoint action, after aircraft trigger the action,  the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. for example, the default photo name is dji_2020012091415_999_wide.jpg, you could append waypoint1 after the default photo name, so the new photo's name will be dji_2020012091415_999_wide_waypoint1.jpg. this action will only take effect once, if you want to append the same name for all photos in one mission,  you need to set this action before taking each photo. only supported by zenmuse p1, zenmuse h20 series.",
             "dir",
             "custom expand directory name. when your set this type in waypoint action, after aircraft trigger the action, the newly generated media files (videos or photos) will be stored in the new folder when taking photo or record video,  this new folder's name will be appended by your custom directory name. for example by default, the default folder name is dji_202001012359_01,  you could append mission1 after it, so the new folder's name will be dji_202001012359_01_mission1.  please notice that the default folder's name also would be updated automatically when the drone completes the landing,  the camera will update the last two digits in dji_202001012359_01 to dji_202001012359_02, so before your drone taking off again,  if you need to append the same custom folder name, you need to set the same name with the action again. this type is only supported by zenmuse p1, zenmuse l1, zenmuse h20 series.",
             "camerafocusmode",
             "possible types of camera focus mode.",
             "manual",
             "manual focus mode",
             "auto",
             "auto focus mode",
             "camerafocusregiontype",
             "possible types of camera focus region.",
             "point",
             "the focus region is a point.",
             "rectangle",
             "the focus region is a prectangle.",
             "waypointv2missionexecutestate",
             "current waypoint mission executing state.",
             "initializing",
             "waypoint mission is initializing, which means the mission has started.",
             "go_to_first_waypoint",
             "aircraft is currently is going to the first waypoint.",
             "moving",
             "aircraft is currently moving.",
             "interrupted",
             "aircraft is currently interrupted by user.",
             "finished",
             "the aircraft finished the waypoint mission and is leaving from the last waypoint.",
             "go_home",
             "aircraft has returned to the home point. this happens when the `setfinishedaction`  is set to `go_home`.",
             "landing",
             "aircraft has been landing. this happens when the `setfinishedaction` is set  to `auto_land`.",
             "return_to_first_waypoint",
             "aircraft has returned to the first waypoint. this happens when the `setfinishedaction`  is set to `go_first_waypoint`.",
             "unknown",
             "unknown execution state.",
             "waypointv2uploadprogress",
             "the upload progress of the waypoint mission operator.",
             "issummaryuploaded",
             "the waypoint mission operator has uploaded the mission's summary (information except waypoints).  @return a boolean value to check summary uploaded.",
             "getlastuploadedwaypointindex",
             "the last uploaded waypoint's index. waypoint is uploaded in ascending order. if no waypoint has been uploaded,  the value should be -1.  @return an int value of last uploaded waypoint index.",
             "gettotalwaypointcount",
             "the total count of waypoints in the waypoint mission.  @return an int value of total waypoint count.",
             "waypointv2downloadprogress",
             "the download progress of the waypoint mission operator.",
             "issummarydownloaded",
             "`true` if waypoint summary is downloaded.  @return a boolean value to check summary downloaded.",
             "getlastdownloadedwaypointindex",
             "the last index of downloaded waypoint. waypoint is downloaded in ascending order. if no waypoint has been  downloaded, the value shoud be -1.  @return an int value of the last downloaded waypoint index.",
             "gettotalwaypointcount",
             "the total count of waypoints in the waypoint mission.  @return an int value of the total waypoint count.",
             "waypointv2executionprogress",
             "the mission execution progress of the waypoint mission operator.",
             "gettargetwaypointindex",
             "the index of the waypoint in the mission to which the aircraft will proceed.  @return an int value of the target waypoint index.",
             "iswaypointreached",
             "`true` when the aircraft reaches a waypoint. after the waypoint actions and heading change are complete,  the `gettargetwaypointindex` will increment and this property will become `false`.  @return a boolean value to check waypoint reached.",
             "getexecutestate",
             "current execution state of the aircraft.  @return an enum value of the `waypointv2missionexecutestate`.",
             "slow_motion",
             "sets the camera to slow motion video recording mode. only supported by mavic air 2, dji air 2s.",
             "video_normal",
             "sets the camera to record normal videos.",
             "photo_time_lapse",
             "sets the camera to take a picture (or multiple pictures) continuously at a set time interval. the camera will merge the photo sequence and the output is a video. the minimum interval for video only format is 1 s. the minimum interval for video+photo format is 2 s.",
             "photo_aeb",
             "automatic exposure bracketing (aeb) capture. in this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames.",
             "photo_single",
             "sets the camera to take a single photo.",
             "photo_burst",
             "set the camera to take multiple photos at once.",
             "photo_hdr",
             "sets the camera to take photos in hdr mode.",
             "video_hdr",
             "sets the camera to hdr video recording mode. only supported by mavic air 2.",
             "photo_interval",
             "sets the camera to take a picture (or multiple pictures) continuously at a set time interval. the minimum interval for jpeg format of any quality is 2s.",
             "photo_hyper_light",
             "sets the camera to take photos in hyperlight mode. it is a setting for low-light environment to enhance the photo quality while reducing noise significantly.",
             "photo_panorama",
             "sets the camera to take photos in panorama mode. the aircraft takes a series of photos with different gimbal and aircraft heading positions. the photos can be stitched with a third-party library.",
             "photo_ehdr",
             "sets the camera to take an enhanced-hdr photo. it blends a sequence of photos for ghost-free high dynamic range photos.",
             "photo_high_resolution",
             "sets the camera to the high resolution mode. in this mode, the camera will take photos with a resolution of 48mp. only supported by mavic air 2.",
             "photo_super_resolution",
             "sets the camera to the super resolution mode. in this mode, drag to select an area in the wide camera view, the gimbal will move automatically and take a series of 20mp photos of the selected area at the current zoom ratio by the zoom camera. all photos will be saved in the same sub-folder in the microsd card, and an html file will be created. to view the wide and close-up images, open the html file using a browser on a pc. if you want to view the close-up images in app, please refer to the sample implementation. using `setsuperresolutioncapturearea` to set the super resolution capture area. using `setsuperresolutioninfocallback` to listen the super resolution state. only supported by matrice 300 rtk.",
             "photo_smart",
             "sets the camera to the smart mode. in this mode, when shooting photo, the camera can automatically recognize the scene, and use the built-in algorithm to optimize the scene. only supported by mavic air 2, dji air 2s.",
             "internal_ai_spot_checking",
             "internal work mode during smart inspection and it cannot be set manually. this mode might last for less than 10 seconds, during when the user cannot take photo, record a video, enter media playback mode, set spot metering target of `zoom` lens type, and set zoom focus length with any lens type. only `auto` can be set with `zoom` lens type. in this mode, remote controller also cannot be used to take photo, record video and adjust focus. it's only supported by matrice 300 rtk.",
             "unknown",
             "the camera work mode is unknown.",
             "zoom",
             "zoom lens.",
             "wide",
             "wide lens.",
             "infrared_thermal",
             "infrared thermal lens.",
             "unknown",
             "unknown.",
             "rgb_only",
             "displays only the video feed from the rgb sensor.",
             "ndvi",
             "displays the nvdi (normalized difference vegetation index) frames as video feed produced by the multispectral camera.",
             "unknown",
             "the multispectral camera video feed display mode is unknown.",
             "blue",
             "the blue spectrum.",
             "green",
             "the green spectrum.",
             "red",
             "the red spectrum.",
             "near_infrared",
             "the near infrared spectrum.",
             "red_edge",
             "the red edge spectrum.",
             "unknown",
             "unknown.",
             "shoot_photo",
             "capture mode. in this mode, the user can capture pictures.",
             "record_video",
             "record mode. in this mode, the user can record videos.",
             "playback",
             "playback mode. in this mode, the user can preview photos and videos, and can delete files. it is supported by phantom 3 professional camera, x3, x5 and x5r cameras on aircraft and phantom 4 camera. playback mode is not supported by z30, x5s, x4s, phantom 4 pro, mavic pro, phantom 3 standard, phantom 3 advanced, phantom 3 4k and osmo series.",
             "media_download",
             "in this mode, the user can download media to the mobile device. not supported by x5 camera nor x5r camera while mounted on aircraft.",
             "broadcast",
             "in this mode, live stream resolution and frame rate will be 1080i50 (pal) or 720p60 (ntsc). in this mode videos can be recorded. still photos can also be taken only when video is recording. the only way to exit broadcast mode is to change modes to `record_video`. only supported by inspire 2.",
             "unknown",
             "the camera work mode is unknown.",
             "callback",
             "updates the camera's current state. in order to begin updates, call the startcamerastateupdates method for the respective aircraft.",
             "getmode",
             "the current mode of the camera.  @return an enum value of `cameramode`",
             "camerakey.mode",
             "sdk key for getmode: the current mode of the camera.  @return an enum value of `cameramode`",
             "getflatmode",
             "gets current flat mode of the camera. this is available only when `isflatcameramodesupported` returns `true`.  @return an enum value of `flatcameramode`.",
             "isinplayback",
             "`true` if the camera is in playback mode. this is available only when `isflatcameramodesupported` returns `true`.  @return a bolean value.",
             "isshootingsinglephoto",
             "`true` when the camera is performing any photo capture in any `shootphotomode`. between photo capture in interval and time lapse mode, this property will be `false`. the camera is shooting a single photo.  @return a boolean value.",
             "is_shooting_single_photo",
             "sdk key for isshootingsinglephoto: `true` when the camera is performing any photo capture in any `shootphotomode`. between photo capture in interval and time lapse mode, this property will be `false`. the camera is shooting a single photo.  @return a boolean value.",
             "isshootingsinglephotoinrawformat",
             "`true` when the camera is performing a photo capture in raw or raw+jpeg format. between photo capture in interval and time lapse mode, this property will be `false`. if saving the photo in jpeg only, this property will always be `false`.  @return a boolean value.",
             "is_shooting_single_photo_in_raw_format",
             "sdk key for isshootingsinglephotoinrawformat: `true` when the camera is performing a photo capture in raw or raw+jpeg format. between photo capture in interval and time lapse mode, this property will be `false`. if saving the photo in jpeg only, this property will always be `false`.  @return a boolean value.",
             "isshootingintervalphoto",
             "`true` when the camera is performing an interval capture. `true` after `startshootphoto` is called, and `false` after `stopshootphoto` is called.  @return a boolean value.",
             "is_shooting_interval_photo",
             "sdk key for isshootingintervalphoto: `true` when the camera is performing an interval capture. `true` after `startshootphoto` is called, and `false` after `stopshootphoto` is called.  @return a boolean value.",
             "isshootingburstphoto",
             "`true` when the camera is performing a burst capture. `true` after `startshootphoto` is called, and `false` after the burst is complete. the camera is shooting burst photos.  @return a boolean value.",
             "is_shooting_burst_photo",
             "sdk key for isshootingburstphoto: `true` when the camera is performing a burst capture. `true` after `startshootphoto` is called, and `false` after the burst is complete. the camera is shooting burst photos.  @return a boolean value.",
             "isshootingrawburstphoto",
             "`true` when the camera is performing a raw burst capture. `true` after `startshootphoto` is called, and `false` after the raw burst is complete. the camera is shooting raw burst photos.  @return a boolean value.",
             "is_shooting_raw_burst_photo",
             "sdk key for isshootingrawburstphoto: `true` when the camera is performing a raw burst capture. `true` after `startshootphoto` is called, and `false` after the raw burst is complete. the camera is shooting raw burst photos.  @return a boolean value.",
             "getcurrentpanoramaphotocount",
             "the current completed photo count of the executing panorama shot.  @return an int value.",
             "getpanoramaprogress",
             "the progress of the executing panorama shot. it is `null` if there is no executing panorama shot.  @return an int value.",
             "isshootingshallowfocusphoto",
             "`true` when the camera is performing a shallowfocus capture.  @return a boolean value.",
             "isshootingpanoramaphoto",
             "`true` when the camera is performing a panorama capture.  @return a boolean value.",
             "isstoringphoto",
             "`true` if the camera is storing a photo. when `isstoringphoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return a boolean value.",
             "is_storing_photo",
             "sdk key for isstoringphoto: `true` if the camera is storing a photo. when `isstoringphoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return a boolean value.",
             "isrecording",
             "`true` if the camera is recording video.  @return a boolean value.",
             "is_recording",
             "sdk key for isrecording: `true` if the camera is recording video.  @return a boolean value.",
             "getcurrentvideorecordingtimeinseconds",
             "the duration, in seconds, of the video currently being recorded by the camera.  @return an int value.",
             "current_video_recording_time_in_seconds",
             "sdk key for getcurrentvideorecordingtimeinseconds: the duration, in seconds, of the video currently being recorded by the camera.  @return an int value.",
             "isoverheating",
             "`true` if the camera is too hot.  @return a boolean value.",
             "is_overheating",
             "sdk key for isoverheating: `true` if the camera is too hot.  @return a boolean value.",
             "haserror",
             "`true` if there is a camera sensor error.  @return a boolean value.",
             "has_error",
             "sdk key for haserror: `true` if there is a camera sensor error.  @return a boolean value.",
             "callback",
             "this interface provides updated information about the lens and focus.",
             "islensmounted",
             "`true` if lens is installed on the camera.  @return a boolean value.",
             "lens_is_installed",
             "sdk key for islensmounted: `true` if lens is installed on the camera.  @return a boolean value.",
             "getfocusstatus",
             "the current focus status of the lens. if the lens is not installed, the value is undefined.  @return a `focusstatus` enum value.",
             "focus_status",
             "sdk key for getfocusstatus: the current focus status of the lens. if the lens is not installed, the value is undefined.  @return a `focusstatus` enum value.",
             "isafswitchon",
             "`true` if the lens auto focus (af) switch is on. if the lens is not installed, the value is undefined. if `true`, `setfocusmode` can be used to control the focal point.  @return a boolean value.",
             "lens_is_af_switch_on",
             "sdk key for isafswitchon: `true` if the lens auto focus (af) switch is on. if the lens is not installed, the value is undefined. if `true`, `setfocusmode` can be used to control the focal point.  @return a boolean value.",
             "getfocusmode",
             "the current focus mode. if the lens is not installed, the value is undefined.  @return a `focusmode` enum value.",
             "focus_mode",
             "sdk key for getfocusmode: the current focus mode. if the lens is not installed, the value is undefined.  @return a `focusmode` enum value.",
             "isfocusassistantenabledformf",
             "`true` if the focus assistant is enabled for manual focus mode. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "focus_assistant_settings",
             "sdk key for isfocusassistantenabledformf: `true` if the focus assistant is enabled for manual focus mode. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "isfocusassistantenabledforaf",
             "`true` if the focus assistant is enabled for auto focus mode. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "focus_assistant_settings",
             "sdk key for isfocusassistantenabledforaf: `true` if the focus assistant is enabled for auto focus mode. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "isfocusassistantworking",
             "`true` if the focus target is zooming out. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "lens_is_focus_assistant_working",
             "sdk key for isfocusassistantworking: `true` if the focus target is zooming out. if the lens is not installed, the value is undefined.  @return a boolean value.",
             "getsensorcleaningstate",
             "get the sensor cleaning state.  @return a `sensorcleaningstate` enum value.",
             "gettargetfocallength",
             "the focal length that user wants to set. supported by zenmuse h20 series. the unit is millimeter.  @return a targetfocuslength int value.",
             "callback",
             "this interface provides general information and current statuses on the storage.",
             "isinserted",
             "`true` if the sd card is inserted in the camera. it is always `true` when it is the internal storage.  @return a boolean value.",
             "sdcard_is_inserted",
             "sdk key for isinserted: `true` if the sd card is inserted in the camera. it is always `true` when it is the internal storage.  @return a boolean value.",
             "getstoragelocation",
             "the location of the storage.  @return a enum value of `storagelocation`.",
             "isinitializing",
             "`true` if the storage is initializing. note that if the storage is initializing, the value for other properties in `storagestate` is undefined.  @return a boolean value.",
             "sdcard_is_initializing",
             "sdk key for isinitializing: `true` if the storage is initializing. note that if the storage is initializing, the value for other properties in `storagestate` is undefined.  @return a boolean value.",
             "isreadonly",
             "`true` if the storage is read-only.  @return a boolean value.",
             "sdcard_is_read_only",
             "sdk key for isreadonly: `true` if the storage is read-only.  @return a boolean value.",
             "isformatted",
             "`true` if the storage is formatted.  @return a boolean value.",
             "sdcard_is_formatted",
             "sdk key for isformatted: `true` if the storage is formatted.  @return a boolean value.",
             "isformatting",
             "`true` if the storage is formatting.  @return a boolean value.",
             "sdcard_is_formatting",
             "sdk key for isformatting: `true` if the storage is formatting.  @return a boolean value.",
             "isfull",
             "`true` if the storage cannot save any more media.  @return a boolean value.",
             "sdcard_is_full",
             "sdk key for isfull: `true` if the storage cannot save any more media.  @return a boolean value.",
             "isverified",
             "`true` if the sd card is verified as genuine. the sd card is not valid if it is fake, which can be a problem if the sd card was purchased by a non-reputable retailer. it is always `true` when it is the internal storage.  @return a boolean value.",
             "sdcard_is_verified",
             "sdk key for isverified: `true` if the sd card is verified as genuine. the sd card is not valid if it is fake, which can be a problem if the sd card was purchased by a non-reputable retailer. it is always `true` when it is the internal storage.  @return a boolean value.",
             "isinvalidformat",
             "`true` if the storage filesystem format is invalid.  @return a boolean value.",
             "sdcard_is_invalid_format",
             "sdk key for isinvalidformat: `true` if the storage filesystem format is invalid.  @return a boolean value.",
             "haserror",
             "`true` if there is an error with the storage.  @return a boolean value.",
             "sdcard_has_error",
             "sdk key for haserror: `true` if there is an error with the storage.  @return a boolean value.",
             "gettotalspaceinmb",
             "total space in megabytes (mb) available on the storage.  @return a boolean value.",
             "sdcard_total_space_in_mb",
             "sdk key for gettotalspaceinmb: total space in megabytes (mb) available on the storage.  @return a boolean value.",
             "getremainingspaceinmb",
             "remaining space in megabytes (mb) on the storage.  @return an int value.",
             "sdcard_remaining_space_in_mb",
             "sdk key for getremainingspaceinmb: remaining space in megabytes (mb) on the storage.  @return an int value.",
             "getavailablecapturecount",
             "returns the number of pictures that can be taken with the remaining space available on the storage.  @return a long value.",
             "sdcard_available_capture_count",
             "sdk key for getavailablecapturecount: returns the number of pictures that can be taken with the remaining space available on the storage.  @return a long value.",
             "getavailablerecordingtimeinseconds",
             "returns the number of seconds available for recording with the remaining space available on the storage.  @return an int value.",
             "sdcard_available_recording_time_in_seconds",
             "sdk key for getavailablerecordingtimeinseconds: returns the number of seconds available for recording with the remaining space available on the storage.  @return an int value.",
             "callback",
             "this interface provides general information and current status of the ssd.",
             "getssdoperationstate",
             "ssd state information for currently executing operations.  @return an instance of `ssdoperationstate`.",
             "ssd_operation_state",
             "sdk key for getssdoperationstate: ssd state information for currently executing operations.  @return an instance of `ssdoperationstate`.",
             "isconnected",
             "`true` if the ssd is connected. note, if the camera is disconnected, the values for other properties in `ssdstate` are undefined.  @return a boolean value.",
             "ssd_is_connected",
             "sdk key for isconnected: `true` if the ssd is connected. note, if the camera is disconnected, the values for other properties in `ssdstate` are undefined.  @return a boolean value.",
             "getcapacity",
             "ssd's total capacity. @return total ssd capacity.  @return an instance of `ssdcapacity`.",
             "ssd_total_space",
             "sdk key for getcapacity: ssd's total capacity. @return total ssd capacity.  @return an instance of `ssdcapacity`.",
             "getavailablerecordingtimeinseconds",
             "ssd's remaining time in seconds, based on the current `videoresolution` and `videoframerate`. @return ssd's remaining time measured in seconds.  @return an int value.",
             "ssd_available_recording_time_in_seconds",
             "sdk key for getavailablerecordingtimeinseconds: ssd's remaining time in seconds, based on the current `videoresolution` and `videoframerate`. @return ssd's remaining time measured in seconds.  @return an int value.",
             "getremainingspaceinmb",
             "ssd's remaining capacity in mb. @return ssd's remaining capacity measured in mb.  @return a long value.",
             "ssd_remaining_space_in_mb",
             "sdk key for getremainingspaceinmb: ssd's remaining capacity in mb. @return ssd's remaining capacity measured in mb.  @return a long value.",
             "getvideoresolution",
             "video resolution to be saved to ssd. @return ssd's video resolution.  @return a `videoresolution` enum value.",
             "ssd_video_resolution_and_frame_rate",
             "sdk key for getvideoresolution: video resolution to be saved to ssd. @return ssd's video resolution.  @return a `videoresolution` enum value.",
             "getvideoframerate",
             "video framerate to be saved to ssd.  @return a `videoframerate` enum value.",
             "ssd_video_resolution_and_frame_rate",
             "sdk key for getvideoframerate: video framerate to be saved to ssd.  @return a `videoframerate` enum value.",
             "getrawphotoburstcount",
             "number of photos that are shot in raw burst mode.  @return an int value.",
             "raw_photo_burst_count",
             "sdk key for getrawphotoburstcount: number of photos that are shot in raw burst mode.  @return an int value.",
             "single",
             "sets the camera to take a single photo.",
             "hdr",
             "sets the camera to take an hdr photo. x5 camera, x5r camera, xt camera, z30 camera, phantom 4 pro camera, x4s camera and x5s camera do not support hdr mode.",
             "burst",
             "set the camera to take multiple photos at once. xt camera does not support burst mode.",
             "aeb",
             "automatic exposure bracketing (aeb) capture. in this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames. xt camera and z30 camera does not support aeb mode.",
             "interval",
             "sets the camera to take a picture (or multiple pictures) continuously at a set time interval. the minimum interval for jpeg format of any quality is 2s. for all cameras except x4s, x5s and phantom 4 pro camera: the minimum interval for raw or raw+jpeg format is 10s. for the x4s, x5s and phantom 4 pro cameras the minimum interval for raw or raw+jpeg dformat is 5s.",
             "time_lapse",
             "sets the camera to take a picture (or multiple pictures) continuously at a set time interval. the camera will merge the photo sequence and the output is a video. the minimum interval for video only format is 1 s. the minimum interval for video+photo format is 2 s. for the new osmo firmware version, no video feed will be received if the camera is shooting photos with time-lapse mode. instead, user can receive a sequence of preview images using the delegate method `ongenerate`. supported only by osmo camera (z3 and x3).",
             "panorama",
             "in panorama mode, the aircraft takes a series of photos with different gimbal and aircraft heading positions. the photos can be stitched with a third-party library. it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.",
             "ehdr",
             "sets the camera to take an enhanced-hdr photo. it blends a sequence of photos for ghost-free high dynamic range photos. it is supported by mavic 2 zoom and mavic 2 pro.",
             "hyper_light",
             "sets the camera to take photos in hyperlight mode. it is a setting for low-light environment to enhance the photo quality while reducing noise significantly. it is supported by mavic 2 zoom and mavic 2 pro.",
             "high_resolution",
             "indicates that the photo was taken in high resolution mode(48 mp 8000×6000 pixel). supported by mavic air 2.",
             "raw_burst",
             "sets the camera to take a burst of raw photos. use `getrawphotoburstcount` to check how many photos have been shot. only supported by x5s.",
             "shallow_focus",
             "sets the camera to take a series of photos while the aircraft moves up and down automatically. the image's depth of field can be computed with a third-party library to produce a photo with the bokeh effect. note:  1. it is only suitable for shooting still scenes.  2. the aircraft will ascend about 20cm before shooting. ensure that there is no obstacle about the aircraft.  3. the suitable range of shooting is within 30m.  it is only supported by spark.",
             "unknown",
             "the shoot photo mode is unknown.",
             "program",
             "program mode.",
             "shutter_priority",
             "shutter priority mode.",
             "aperture_priority",
             "aperture priority mode.",
             "manual",
             "manual mode.",
             "unknown",
             "the camera exposure mode is unknown.",
             "mov",
             "the video storage format is mov.",
             "mp4",
             "the video storage format is mp4.",
             "tiff_seq",
             "the video storage format is tiff sequence.",
             "seq",
             "the video storage format is seq. the raw data from the infrared camera is stored.",
             "unknown",
             "the video storage format is unknown.",
             "resolution_336x256",
             "the camera's video resolution is 336x256.",
             "resolution_640x360",
             "the camera's video resolution is 640x360. supported by mavic 2 enterprise dual thermal camera.",
             "resolution_720x576",
             "the camera's video resolution is 720x576.",
             "resolution_640x480",
             "the camera's video resolution is 640x480.",
             "resolution_640x512",
             "the camera's video resolution is 640x512.",
             "resolution_1280x720",
             "the camera's video resolution is 1280x720.",
             "resolution_1920x1080",
             "the camera's video resolution is 1920x1080.",
             "resolution_2704x1520",
             "the camera's video resolution is 2704x1520.",
             "resolution_2720x1530",
             "the camera's video resolution is 2720x1530.",
             "resolution_3712x2088",
             "the camera's video resolution is 3712x2088. it's only used by x7 camera.",
             "resolution_3840x1572",
             "the camera's video resolution is 3840x1572.",
             "resolution_3840x2160",
             "the camera's video resolution is 3840x2160.",
             "resolution_3944x2088",
             "the camera's video resolution is 3944x2088. it's only used by x7 camera.",
             "resolution_4096x2160",
             "the camera's video resolution is 4096x2160.",
             "resolution_4608x2160",
             "the camera's video resolution is 4608x2160.",
             "resolution_4608x2592",
             "the camera's video resolution is 4608x2592.",
             "resolution_5280x2160",
             "the camera's video resolution is 5280x2160.",
             "resolution_5472x3078",
             "the camera's video resolution is 5472x3078.",
             "resolution_5760x3240",
             "the camera's video resolution is 5760x3240.",
             "resolution_6016x3200",
             "the camera's video resolution is 6016x3200.",
             "resolution_max",
             "the camera's video resolution will be maximum resolution supported by the camera sensor. for x5s and x4s, the maximum resolution is 5280x2972.",
             "no_ssd_video",
             "the camera's ssd video resolution is unset. when the ssd resolution is unset, camera will not store video to ssd. ssd's resolution is determined by both license key and sd card's video frame rate. if there is no supported resolution with the current configuration, djicameravideoresolutionunset</code> will be selected and user should adjust either the license or the frame rate.",
             "resolution_2048x1080",
             "the camera's video resolution is 2048x1080.",
             "resolution_2688x1512",
             "the camera's video resolution is 2688x1512.",
             "resolution_5280x2972",
             "the camera's video resolution is 5280x2972.",
             "unknown",
             "the camera's video resolution is unknown.",
             "frame_rate_23_dot_976_fps",
             "the camera's video frame rate is 23.976fps (frames per second).",
             "frame_rate_24_fps",
             "the camera's video frame rate is 24fps (frames per second).",
             "frame_rate_25_fps",
             "the camera's video frame rate is 25fps (frames per second).",
             "frame_rate_29_dot_970_fps",
             "the camera's video frame rate is 29.97fps (frames per second).",
             "frame_rate_30_fps",
             "the camera's video frame rate is 30fps (frames per second).",
             "frame_rate_47_dot_950_fps",
             "the camera's video frame rate is 47.95fps (frames per second).",
             "frame_rate_48_fps",
             "the camera's video frame rate is 48fps (frames per second).",
             "frame_rate_50_fps",
             "the camera's video frame rate is 50fps (frames per second).",
             "frame_rate_59_dot_940_fps",
             "the camera's video frame rate is 59.94fps (frames per second).",
             "frame_rate_60_fps",
             "the camera's video frame rate is 60fps (frames per second).",
             "frame_rate_90_fps",
             "the camera's video frame rate is 90fps (frames per second).",
             "frame_rate_96_fps",
             "the camera's video frame rate is 96fps (frames per second).",
             "frame_rate_100_fps",
             "the camera's video frame rate is 100fps (frames per second). this frame rate can only be used when `isslowmotionsupported` returns `true`.",
             "frame_rate_120_fps",
             "the camera's video frame rate is 120fps (frames per second). this frame rate can only be used when `isslowmotionsupported` returns `true`.",
             "frame_rate_240_fps",
             "the camera's video frame rate is 240fps (frames per second). this frame rate can only be used when `isslowmotionsupported` returns `true`.",
             "frame_rate_8_dot_7_fps",
             "the camera's video frame rate is 8.7fps (frames per second). supported by mavic 2 enterprise dual thermal camera.",
             "unknown",
             "the camera's video frame rate is unknown.",
             "default",
             "the default fov. use this value if the fov is not configurable for the camera.",
             "narrow",
             "use a narrow fov to record videos.",
             "wide",
             "use a wide fov to record videos.",
             "unknown",
             "unknown",
             "getresolution",
             "returns the camera's current video resolution.  @return returns resolution",
             "getframerate",
             "returns the camera's current video frame rate.  @return returns framerate",
             "getfov",
             "the fov for recording videos.  @return returns framerate",
             "resolutionandframerate",
             "creates a `djicameravideoresolutionandframerate` instance with a preset camera video resolution and frame rate. the value of `getfov` is `default`.  @param resolution the specific resolution. @param framerate the specific frame rate.",
             "resolutionandframerate",
             "creates a `resolutionandframerate` instance with a preset camera video resolution, frame rate and fov. fov is only configurable for mavic 2 pro and it is only configurable when the resolution is `resolution_3840x2160` (4k). use `default` when fov is not configurable.  @param resolution the specific resolution. @param framerate the specific frame rate. @param fov the specific fov.",
             "pal",
             "the camera video standard value is set to pal.",
             "ntsc",
             "the camera video standard value is set to ntsc.",
             "unknown",
             "the camera video standard value is unknown.",
             "raw",
             "the camera's photo storage format is raw.",
             "jpeg",
             "the camera's photo storage format is jpeg.",
             "raw_and_jpeg",
             "the camera stores both the raw and jpeg formats of the photo.",
             "tiff_14_bit",
             "the camera's photo storage format is tiff (14bit).",
             "radiometric_jpeg",
             "the camera's photo storage format is radiometric jpeg (a special jpeg format with temperature information). a radiometric jpeg has the .jpg suffix and can be viewed as a normal jpeg file would. at the same time, the temperature data is also stored in the file as meta data. pc software is required to analyze the file and it is accessible at flir's website http://www.flir.com/instruments/display/?id=54865. only supported by xt camera with firmware version 1.16.1.70 or above.",
             "tiff_14_bit_linear_low_temp_resolution",
             "the camera's photo storage format is tiff linear low. in this mode each pixel is 14 bits and linearly proportional with temperature, covering a high dynamic range of temperature which results in a lower temperature resolution. supported only by zenmuse xt containing advanced radiometry capabilities with firmware version 1.17.1.80 or lower. for newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
             "tiff_14_bit_linear_high_temp_resolution",
             "the camera's photo storage format is tiff linear high. in this mode each pixel is 14 bits and linearly proportional with temperature, covering a low dynamic range of temperature which results in a higher temperature resolution. supported only by zenmuse xt containing advanced radiometry capabilities with firmware version 1.17.1.80 or lower. for newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
             "unknown",
             "the camera's photo storage format is unknown.",
             "video",
             "the camera in time-lapse mode will generate video.",
             "jpeg_and_video",
             "the camera in time-lapse mode will generate video and jpeg.",
             "unknown",
             "the file format is unknown.",
             "ratio_4_3",
             "the camera's photo ratio is 4 : 3.",
             "ratio_16_9",
             "the camera's photo ratio is 16 : 9.",
             "ratio_3_2",
             "the camera's photo ratio is 3:2.",
             "ratio_5_4",
             "the camera's photo ratio is 5:4.",
             "unknown",
             "the camera's photo ratio is unknown.",
             "burst_count_2",
             "the camera burst shoot count is set to capture 2 pictures at once when the camera shoots a photo.",
             "burst_count_3",
             "the camera burst shoot count is set to capture 3 pictures at once when the camera shoots a photo.",
             "burst_count_5",
             "the camera burst shoot count is set to capture 5 pictures at once when the camera takes a photo.",
             "burst_count_7",
             "the camera burst shoot count is set to capture 7 pictures at once when the camera takes a photo. it is not supported by z30 camera.",
             "burst_count_10",
             "the camera burst shoot count is set to capture 10 pictures at once when the camera takes a photo. only supported by x4s camera, x5s camera and phantom 4 pro camera.",
             "burst_count_14",
             "the camera burst shoot count is set to capture 14 pictures at once when the camera takes a photo. only supported by x4s camera, x5s camera and phantom 4 pro camera.",
             "continuous",
             "the camera burst shoot count is set to capture raw pictures continuously until `stopshootphoto` command is sent. it is only supported by inspire 2 when the photo shoot mode is raw burst.",
             "unknown",
             "the camera burst shoot count value is unknown.",
             "aeb_count_3",
             "the number of pictures to continuously take at one time in aeb mode is 3.",
             "aeb_count_5",
             "the number of pictures to continuously take at one time in aeb mode is 5.",
             "aeb_count_7",
             "the number of pictures to continuously take at one time in aeb mode is 7.",
             "unknown",
             "the number of pictures to continuously take at one time in aeb mode is unknown.",
             "phototimeintervalsettings",
             "constructor.  @param capturecount number of photos to take. @param timeintervalinseconds time interval in seconds between taking photos.",
             "getcapturecount",
             "the number of photos to capture. the value range is [2, 255]. if 255 is selected, then the camera will continue to take pictures until stopshootphotowithcompletion is called. for thermal imaging camera and z30 camera, it can only be set to 255.  @return number of photos to capture",
             "gettimeintervalinseconds",
             "the time interval between when two photos are taken. the range for this parameter depends the photo file format(djicameraphotofileformat). for xt camera, the range is [1, 60] seconds. for all other products, when the file format is jpeg, the range is [2, 2^16 - 1] seconds; when the file format is raw or raw+jpeg, the range is [10, 2^16 - 1] seconds.  @return time interval in seconds.",
             "getinterval",
             "the time interval between when two photos are taken.  @return return interval value from settings",
             "getduration",
             "the total duration for which the camera will take pictures.  @return return duration value from settings",
             "getfileformat",
             "the file format for captured photos during time lapse.  @return return file format value from settings",
             "panorama_mode_3x3",
             "camera will shoot 3 rows of 3 photos. each photo in a row will be taken with a different aircraft heading. each row of photos is taken with a different gimbal pitch.",
             "panorama_mode_3x1",
             "camera will shoot 3 photos with the same aircraft heading and different gimbal pitch.",
             "panorama_mode_sphere",
             "camera will shoot 8 rows of 3 photos and 1 extra photo (facing downward). each photo in a row will be taken with a different aircraft heading. each row of photos is taken with a different gimbal pitch.",
             "panorama_mode_180",
             "camera will shoot 3 photos with the same gimbal pitch (facing forward) and different aircraft headings.",
             "panorama_mode_super_resolution",
             "the camera will capture and patch nine photos resulting in a 48-megapixel super resolution photo. it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.",
             "unknown",
             "unknown.",
             "shutter_speed_1_20000",
             "camera's shutter speed 1/20000 s.",
             "shutter_speed_1_16000",
             "camera's shutter speed 1/16000 s.",
             "shutter_speed_1_12800",
             "camera's shutter speed 1/12800 s.",
             "shutter_speed_1_10000",
             "camera's shutter speed 1/10000 s.",
             "shutter_speed_1_8000",
             "camera's shutter speed 1/8000 s.",
             "shutter_speed_1_6400",
             "camera's shutter speed 1/6400 s.",
             "shutter_speed_1_6000",
             "camera's shutter speed 1/6000 s.",
             "shutter_speed_1_5000",
             "camera's shutter speed 1/5000 s.",
             "shutter_speed_1_4000",
             "camera's shutter speed 1/4000 s.",
             "shutter_speed_1_3200",
             "camera's shutter speed 1/3200 s.",
             "shutter_speed_1_3000",
             "camera's shutter speed 1/3000 s.",
             "shutter_speed_1_2500",
             "camera's shutter speed 1/2500 s.",
             "shutter_speed_1_2000",
             "camera's shutter speed 1/2000 s.",
             "shutter_speed_1_1600",
             "camera's shutter speed 1/1600 s.",
             "shutter_speed_1_1500",
             "camera's shutter speed 1/1500 s.",
             "shutter_speed_1_1250",
             "camera's shutter speed 1/1250 s.",
             "shutter_speed_1_1000",
             "camera's shutter speed 1/1000 s.",
             "shutter_speed_1_800",
             "camera's shutter speed 1/800 s.",
             "shutter_speed_1_725",
             "camera's shutter speed 1/725 s.",
             "shutter_speed_1_640",
             "camera's shutter speed 1/640 s.",
             "shutter_speed_1_500",
             "camera's shutter speed 1/500 s.",
             "shutter_speed_1_400",
             "camera's shutter speed 1/400 s.",
             "shutter_speed_1_350",
             "camera's shutter speed 1/350 s.",
             "shutter_speed_1_320",
             "camera's shutter speed 1/320 s.",
             "shutter_speed_1_250",
             "camera's shutter speed 1/250 s.",
             "shutter_speed_1_240",
             "camera's shutter speed 1/240 s.",
             "shutter_speed_1_200",
             "camera's shutter speed 1/200 s.",
             "shutter_speed_1_180",
             "camera's shutter speed 1/180 s.",
             "shutter_speed_1_160",
             "camera's shutter speed 1/160 s.",
             "shutter_speed_1_125",
             "camera's shutter speed 1/125 s.",
             "shutter_speed_1_120",
             "camera's shutter speed 1/120 s.",
             "shutter_speed_1_100",
             "camera's shutter speed 1/100 s.",
             "shutter_speed_1_90",
             "camera's shutter speed 1/90 s.",
             "shutter_speed_1_80",
             "camera's shutter speed 1/80 s.",
             "shutter_speed_1_60",
             "camera's shutter speed 1/60 s.",
             "shutter_speed_1_50",
             "camera's shutter speed 1/50 s.",
             "shutter_speed_1_40",
             "camera's shutter speed 1/40 s.",
             "shutter_speed_1_30",
             "camera's shutter speed 1/30 s.",
             "shutter_speed_1_25",
             "camera's shutter speed 1/25 s.",
             "shutter_speed_1_20",
             "camera's shutter speed 1/20 s.",
             "shutter_speed_1_15",
             "camera's shutter speed 1/15 s.",
             "shutter_speed_1_12_dot_5",
             "camera's shutter speed 1/12.5 s.",
             "shutter_speed_1_10",
             "camera's shutter speed 1/10 s.",
             "shutter_speed_1_8",
             "camera's shutter speed 1/8 s.",
             "shutter_speed_1_6_dot_25",
             "camera's shutter speed 1/6.25 s.",
             "shutter_speed_1_5",
             "camera's shutter speed 1/5 s.",
             "shutter_speed_1_4",
             "camera's shutter speed 1/4 s.",
             "shutter_speed_1_3",
             "camera's shutter speed 1/3 s.",
             "shutter_speed_1_2_dot_5",
             "camera's shutter speed 1/2.5 s.",
             "shutter_speed_1_2",
             "camera's shutter speed 1/2 s.",
             "shutter_speed_1_1_dot_67",
             "camera's shutter speed 1/1.67 s.",
             "shutter_speed_1_1_dot_25",
             "camera's shutter speed 1/1.25 s.",
             "shutter_speed_1",
             "camera's shutter speed 1.0 s.",
             "shutter_speed_1_dot_3",
             "camera's shutter speed 1.3 s.",
             "shutter_speed_1_dot_6",
             "camera's shutter speed 1.6 s.",
             "shutter_speed_2",
             "camera's shutter speed 2.0 s.",
             "shutter_speed_2_dot_5",
             "camera's shutter speed 2.5 s.",
             "shutter_speed_3",
             "camera's shutter speed 3.0 s.",
             "shutter_speed_3_dot_2",
             "camera's shutter speed 3.2 s.",
             "shutter_speed_4",
             "camera's shutter speed 4.0 s.",
             "shutter_speed_5",
             "camera's shutter speed 5.0 s.",
             "shutter_speed_6",
             "camera's shutter speed 6.0 s.",
             "shutter_speed_7",
             "camera's shutter speed 7.0 s.",
             "shutter_speed_8",
             "camera's shutter speed 8.0 s.",
             "shutter_speed_9",
             "camera's shutter speed 9.0 s.",
             "shutter_speed_10",
             "camera's shutter speed 10.0 s.",
             "shutter_speed_13",
             "camera's shutter speed 13.0 s.",
             "shutter_speed_15",
             "camera's shutter speed 15.0 s.",
             "shutter_speed_20",
             "camera's shutter speed 20.0 s.",
             "shutter_speed_25",
             "camera's shutter speed 25.0 s.",
             "shutter_speed_30",
             "camera's shutter speed 30.0 s.",
             "unknown",
             "camera's shutter speed unknown.",
             "auto",
             "the iso value is automatically set. this cannot be used for all cameras when in manual mode.",
             "iso_50",
             "the iso value is set to 50.",
             "iso_100",
             "the iso value is set to 100.",
             "iso_200",
             "the iso value is set to 200.",
             "iso_400",
             "the iso value is set to 400.",
             "iso_800",
             "the iso value is set to 800.",
             "iso_1600",
             "the iso value is set to 1600.",
             "iso_3200",
             "the iso value is set to 3200.",
             "iso_6400",
             "the iso value is set to 6400.",
             "iso_12800",
             "the iso value is set to 12800.",
             "iso_25600",
             "the iso value is set to 25600.",
             "iso_51200",
             "the iso value is set to 51200.",
             "iso_102400",
             "the iso value is set to 102400.",
             "fixed",
             "iso value is fixed by the camera firmware. when the camera color is set to `d_log`, camera will fix the iso to a specific value in order to optimize the performance. the value set by camera can be accessed from `getiso`.",
             "unknown",
             "the iso value is set to unknown value.",
             "f_1",
             "the aperture value is f/1.",
             "f_1_dot_2",
             "the aperture value is f/1.2.",
             "f_1_dot_3",
             "the aperture value is f/1.3.",
             "f_1_dot_4",
             "the aperture value is f/1.4.",
             "f_1_dot_6",
             "the aperture value is f/1.6. it is only supported by z30 camera.",
             "f_1_dot_7",
             "the aperture value is f/1.7.",
             "f_1_dot_8",
             "the aperture value is f/1.8.",
             "f_2",
             "the aperture value is f/2.",
             "f_2_dot_2",
             "the aperture value is f/2.2.",
             "f_2_dot_4",
             "the aperture value is f/2.4. it is only supported by z30 camera.",
             "f_2_dot_5",
             "the aperture value is f/2.5.",
             "f_2_dot_6",
             "the aperture value is f/2.6.",
             "f_2_dot_8",
             "the aperture value is f/2.8.",
             "f_3_dot_2",
             "the aperture value is f/3.2.",
             "f_3_dot_4",
             "the aperture value is f/3.4.",
             "f_3_dot_5",
             "the aperture value is f/3.5.",
             "f_4",
             "the aperture value is f/4.",
             "f_4_dot_5",
             "the aperture value is f/4.5.",
             "f_4_dot_8",
             "the aperture value is f/4.8.",
             "f_5",
             "the aperture value is f/5.",
             "f_5_dot_6",
             "the aperture value is f/5.6.",
             "f_6_dot_3",
             "the aperture value is f/6.3.",
             "f_6_dot_8",
             "the aperture value is f/6.8.",
             "f_7_dot_1",
             "the aperture value is f/7.1.",
             "f_8",
             "the aperture value is f/8.",
             "f_9",
             "the aperture value is f/9.",
             "f_9_dot_6",
             "the aperture value is f/9.6.",
             "f_10",
             "the aperture value is f/10.",
             "f_11",
             "the aperture value is f/11.",
             "f_13",
             "the aperture value is f/13.",
             "f_14",
             "the aperture value is f/14.",
             "f_16",
             "the aperture value is f/16.",
             "f_18",
             "the aperture value is f/18.",
             "f_19",
             "the aperture value is f/19.",
             "f_20",
             "the aperture value is f/20.",
             "f_22",
             "the aperture value is f/22.",
             "f_25",
             "the aperture value is f/25.",
             "f_28",
             "the aperture value is f/28.",
             "f_32",
             "the aperture value is f/32.",
             "f_37",
             "the aperture value is f/37.",
             "f_41",
             "the aperture value is f/41.",
             "f_45",
             "the aperture value is f/45.",
             "f_52",
             "the aperture value is f/52.",
             "f_58",
             "the aperture value is f/58.",
             "f_64",
             "the aperture value is f/64.",
             "unknown",
             "the aperture value is unknown.",
             "getwhitebalancepreset",
             "the current preset for white balance.  @return white balance preset.",
             "getcolortemperature",
             "the current setting for color temperature. real color temperature value (k) = value * 100. for example, 50 -> 5000k.  @return color temperature.",
             "whitebalance",
             "create a `whitebalance` instance with a white balance preset.  @param preset white balance preset that is not `custom`.",
             "whitebalance",
             "create a `whitebalance` instance with white balance preset and temperature.  @param preset white balance preset. @param temperature color temperature value to be set in the range of [20, 100]. real color temperature value (k) = value * 100. for example, 50 -> 5000k.",
             "watermarksettings",
             "creates an instance of the settings to control the watermark on photos and videos.  @param enabledforvideos `true` if the watermark (timestamp and location stamp) is enabled for videos. @param enabledforphotos `true` if the watermark (timestamp and location stamp) is enabled for photos.",
             "isenabledforphotos",
             "`true` if the timestamp and the location stamp is added to photos.  @return `true` if the watermark (timestamp and location stamp) is enabled for photos.",
             "isenabledforvideos",
             "`true` if the timestamp and the location stamp is added to videos. the stamps are updated during the videos.  @return `true` if the watermark (timestamp and location stamp) is enabled for videos.",
             "gettargetlocation",
             "gets the target object's location measured by the laser sensor.  @return an object of `locationcoordinate3d`.",
             "gettargetdistance",
             "gets the range to the target object.  @return a float value.",
             "gettargetpoint",
             "gets the relative target point base the lens origin point which measures by the laser sensor. the range for x and y is from 0 to 1000. the point [0, 0] represents the top-left angle of the screen.  @return an object of `pointf`.",
             "getlasererror",
             "gets the laser error from the laser sensor.  @return an object of `lasererror`.",
             "callback",
             "updates the laser sensor state information.",
             "onupdate",
             "called when the laser sensor state information has been updated.  @param lasermeasureinformation an object of `lasermeasureinformation`.",
             "lasererror",
             "the enum class represents laser sensor's measuring state.",
             "normal",
             "the laser sensor's measuring state is normal.",
             "too_close",
             "the laser sensor is too close to the target object.",
             "too_far",
             "the laser sensor is too far away from the target object.",
             "no_signal",
             "the laser sensor has no data signal.",
             "unknown",
             "unknown state.",
             "shouldsaveoriginalphotos",
             "`true` if the camera should save the original photos.  @return `true` if the camera should save the original photos.",
             "getformat",
             "the format for the original photos if the user decides to save them. mavic air cannot change this setting and it will ignore this property.  @return an enum value of `photofileformat`.",
             "originalphotosettings",
             "creates an instance of the configuration to decide whether or not to save the original photos or not. `getformat` will be `jpeg`. use this constructor for mavic air.  @param shouldsaveoriginalphotos `true` to save the original photos.",
             "originalphotosettings",
             "creates an instance of the configuration to decide whether or not to save the original photos and the format in which to save them.  @param shouldsaveoriginalphotos `true` to save the original photos. @param format the format to save the original photos.",
             "storagephotocamerasparambuilder",
             "the builder of the multispectralstoragephotosettings.",
             "setisstoragergbcamera",
             "`true` if the photos in the rgb band sensor should be stored.  @param isstoragergbcamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "setisstoragebluecamera",
             "`true` if the photos in the blue spectrum band should be stored.  @param isstoragebluecamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "setisstoragegreencamera",
             "`true` if the photos in the green spectrum band should be stored.  @param isstoragegreencamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "setisstorageredcamera",
             "`true` if the photos in the red spectrum band should be stored.  @param isstorageredcamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "setisstoragenearinfraredcamera",
             "`true` if the photos in the near infrared spectrum band should be stored.  @param isstoragenearinfraredcamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "setisstoragerededgecamera",
             "`true` if the photos in the red edge spectrum band should be stored.  @param isstoragerededgecamera a boolean value to set.  @return the builder of `storagephotocamerasparambuilder`.",
             "getspectrumband",
             "the spectrum for which this exposure state is.  @return an enum value of `spectrumband`.",
             "getshutterspeed",
             "the shutter speed of the single band sensor.  @return an enum value of `shutterspeed`.",
             "getsensorgain",
             "the gain of the sensor.  @return a float value of sensor gain.",
             "callback",
             "called when the multispectral camera's exposure state changes.",
             "onupdate",
             "callback function that updates the multispectral camera's exposure state.  @param multispectralexposurestates the multispectral camera's exposure state array.",
             "getequipmentlabel",
             "a single captical character represents the equipment. the possible value is from 'a' to 'z'.  @return a string value of the equipment label.",
             "getreelid",
             "the reel id. the possible value is from 0 to 999.  @return an int value of the reel id.",
             "getclipid",
             "the clip id. the possible value is from 0 to 999.  @return an int value of the clip id.",
             "ssdclipfilename",
             "create a ssd clip name instance.  @param label the equipment label of the clip. the valid input is from 'a' to 'z'. @param reelid the reel id. the valid input is from 0 to 999. @param clipid the clip id. the valid input is from 0 to 999.",
             "auto",
             "the camera's white balance is automatically set.",
             "sunny",
             "the camera's white balance is set to sunny.",
             "cloudy",
             "the camera's white balance is set to cloudy.",
             "water_surface",
             "the camera's white balance is set to water surface.",
             "indoor_incandescent",
             "the camera's white balance is set to indoors and incandescent light.",
             "indoor_fluorescent",
             "the camera's white balance is set to indoors and fluorescent light.",
             "custom",
             "the camera's white balance is set to custom color temperature. by using this white balance value, user can set a specific value for the color temperature.",
             "preset_neutral",
             "the camera's white balance is set to neutral. it is only supported by the x7.",
             "unknown",
             "the camera's white balance is unknown.",
             "center",
             "the camera's exposure metering is set to the center.",
             "average",
             "the camera's exposure metering is set to average.",
             "spot",
             "the camera's exposure metering is set to a single spot.",
             "unknown",
             "the camera's exposure metering is unknown.",
             "n_5_0",
             "the camera's exposure compensation is -5.0ev.",
             "n_4_7",
             "the camera's exposure compensation is -4.7ev.",
             "n_4_3",
             "the camera's exposure compensation is -4.3ev.",
             "n_4_0",
             "the camera's exposure compensation is -4.0ev.",
             "n_3_7",
             "the camera's exposure compensation is -3.7ev.",
             "n_3_3",
             "the camera's exposure compensation is -3.3ev.",
             "n_3_0",
             "the camera's exposure compensation is -3.0ev.",
             "n_2_7",
             "the camera's exposure compensation is -2.7ev.",
             "n_2_3",
             "the camera's exposure compensation is -2.3ev.",
             "n_2_0",
             "the camera's exposure compensation is -2.0ev.",
             "n_1_7",
             "the camera's exposure compensation is -1.7ev.",
             "n_1_3",
             "the camera's exposure compensation is -1.3ev.",
             "n_1_0",
             "the camera's exposure compensation is -1.0ev.",
             "n_0_7",
             "the camera's exposure compensation is -0.7ev.",
             "n_0_3",
             "the camera's exposure compensation is -0.3ev.",
             "n_0_0",
             "the camera's exposure compensation is 0.0ev.",
             "p_0_3",
             "the camera's exposure compensation is +0.3ev.",
             "p_0_7",
             "the camera's exposure compensation is +0.7ev.",
             "p_1_0",
             "the camera's exposure compensation is +1.0ev.",
             "p_1_3",
             "the camera's exposure compensation is +1.3ev.",
             "p_1_7",
             "the camera's exposure compensation is +1.7ev.",
             "p_2_0",
             "the camera's exposure compensation is +2.0ev.",
             "p_2_3",
             "the camera's exposure compensation is +2.3ev.",
             "p_2_7",
             "the camera's exposure compensation is +2.7ev.",
             "p_3_0",
             "the camera's exposure compensation is +3.0ev.",
             "p_3_3",
             "the camera's exposure compensation is +3.3ev.",
             "p_3_7",
             "the camera's exposure compensation is +3.7ev.",
             "p_4_0",
             "the camera's exposure compensation is +4.0ev.",
             "p_4_3",
             "the camera's exposure compensation is +4.3ev.",
             "p_4_7",
             "the camera's exposure compensation is +4.7ev.",
             "p_5_0",
             "the camera's exposure compensation is +5.0ev.",
             "fixed",
             "the camera's exposure compensation is fixed by the camera.",
             "unknown",
             "the camera's exposure compensation is unknown.",
             "auto",
             "the camera's anti-flicker is automatically set. it is not supported by z30 camera.",
             "manual_60hz",
             "the camera's anti-flicker is 60 hz.",
             "manual_50hz",
             "the camera's anti-flicker is 50 hz.",
             "disabled",
             "the anti-flicker is disabled. only supported by mavic air.",
             "unknown",
             "the camera's anti-flicker is unknown.",
             "normal",
             "the camera exposure state is normal.",
             "underexposed",
             "the camera exposure state is underexposed.",
             "overexposed",
             "the camera exposure state is overexposed.",
             "unknown",
             "the camera exposure state is unknown.",
             "getaperture",
             "returns the current aperture value being used by the camera. a larger aperture results in a higher exposure and shallower depth of field. for cameras that do not support adjustable aperture (e.g. zenmuse x3), the real aperture value is fixed.  @return the enum value of `aperture`",
             "getshutterspeed",
             "returns the current shutter speed being used by the camera. a slower shutter speed results in a higher exposure, but more blurring in areas of the scene that are moving.  @return the enum value of `shutterspeed`",
             "getiso",
             "returns the current iso value being used by the camera. `iso` defines the number of the iso values separated by one exposure stop. however, when the iso is in automatic mode, the camera can select iso values less than one stop apart, and therefore this property is the actual iso value being used by the camera. a higher iso results in a higher exposure, and more noise in the resulting image.  @return the enum value of `iso`",
             "getexposurecompensation",
             "returns the camera's current exposure compensation. in program, aperture priority and shutter priority modes, the exposure compensation value changes the exposure target the camera is using to calculate correct exposure and is set by the user. for example, aperture priority mode indicates that the priority is to maintain the aperture setting and adjusting the exposure by varying the iso and shutter speed. in manual mode, this value is reported from the camera and reports how much the  exposure needs to be compensated for to get to what the camera thinks is the correct exposure. in manual mode, the range of exposure compensation reported by the camera is -2.0 ev to 2.0 ev. in program, aperture priority and shutter priority modes, the range of exposure compensation is -3.0 ev to + 3.0 ev. for the z30 camera in manual mode, exposurecompensation is not used and the value is always 'djicameraexposurecompensationn00'.  @return the enum value of `exposurecompensation`",
             "manual",
             "the camera's focus mode is set to manual. in this mode, user sets the focus ring value to adjust the focal distance.",
             "auto",
             "the camera's focus mode is set to auto. for the z30 camera, the focus is calculated completely automatically. for all other cameras, a focus target can be set by the user, which is used to calculate focus automatically.",
             "afc",
             "the camera's focus mode is set to continuous af. it is only supported by mavic pro with firmware version v01.03.0000 or above, x4s camera, mavic 2 zoom camera and mavic 2 pro camera, dji air 2s.",
             "unknown",
             "the camera's focus mode is unknown.",
             "idle",
             "the lens is idle. no focus target has been set.",
             "focusing",
             "the lens is focusing on the target.",
             "successful",
             "the lens succeeded to focus on the target.",
             "failed",
             "the lens failed to focus on the target. this happens when the target is too close, or the camera cannot distinguish the object to focus (e.g. a white wall).",
             "unknown",
             "the lens focus status is unknown.",
             "idle",
             "not in sensor cleaning mode.",
             "initiating",
             "the camera is initiating sensor cleaning mode.",
             "waiting_for_lens_removal",
             "remove the lens from the camera to continue cleaning operation.",
             "ready",
             "the camera is ready to start the sensor cleaning. call `startsensorcleaning` to start the operation.",
             "cleaning",
             "the camera is executing sensor cleaning.",
             "finishing",
             "the sensor cleaning process is finishing. no action is required in this state and the state will change to `waiting_for_lens_remount` automatically.",
             "waiting_for_lens_remount",
             "the sensor cleaning is finished and the camera is waiting for the lens to be remounted. when the lens is mounted, the state will change to `idle`.",
             "unknown",
             "unknown.",
             "isenabledmf",
             "`true` if the lens focus assistant is enabled for manual focusing.  @return `true` if mf is enabled.",
             "isenabledaf",
             "`true` if the lens focus assistant is enabled for auto focusing.  @return true if af is enabled.",
             "not_found",
             "ssd is not found.",
             "idle",
             "ssd is idle.",
             "saving",
             "ssd is saving.",
             "formatting",
             "ssd is formatting.",
             "initializing",
             "ssd is initializing.",
             "error",
             "ssd validation error.",
             "full",
             "ssd is full.",
             "poor_connection",
             "communication to ssd is not stable. user can re-plugin ssd. it is supported by x5s.",
             "switching_license",
             "ssd is switching the license key. it is supported by x5s.",
             "formatting_required",
             "formatting is required. it is supported by x5s.",
             "not_initialized",
             "not initialized yet. it is supported by x7.",
             "invalid_file_system",
             "the file system is not supported. it is supported by x7.",
             "unknown",
             "ssd state is unknown. this happens in the first 2 seconds after turning the camera power on as during this time the camera cannot check the state of the ssd.",
             "capacity_256_gb",
             "ssd capacity is 256g.",
             "capacity_512_gb",
             "ssd capacity is 512g.",
             "capacity_1_tb",
             "ssd capacity is 1t.",
             "unknown",
             "ssd capacity is unknown.",
             "licensekeytypecinemadng",
             "cinemadng.",
             "licensekeytypeprores422hq",
             "apple prores 422 hq.",
             "licensekeytypeprores4444xq",
             "apple prores 4444 xq(no alpha).",
             "unknown",
             "unknown.",
             "full",
             "causes the color spectrum to be evenly distributed across the entire image depending the default settings.",
             "sky_excluded_33",
             "ignores areas of the sky 33% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
             "sky_excluded_50",
             "ignores areas of the sky 50% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
             "unknown",
             "the roi type is unknown.",
             "white_hot",
             "without isotherm enabled, the palette type is whitehot. with isotherm enabled, the palette type is whitehotiso.",
             "black_hot",
             "without isotherm enabled, the palette type is blackhot. with isotherm enabled, the palette type is blackhotiso.",
             "red_hot",
             "without isotherm enabled, the palette type is redhot. with isotherm enabled, the palette type is redhotiso. shown as tint in dji pilot.",
             "green_hot",
             "without isotherm enabled, the palette type is greenhot. with isotherm enabled, the palette type is greenhotiso. shown as medical in dji pilot.",
             "fusion",
             "without isotherm enabled, the palette type is fusion. with isotherm enabled, the palette type is fusioniso.",
             "rainbow",
             "without isotherm enabled, the palette type is rainbow. with isotherm enabled, the palette type is rainbowiso.  shown as rainbow1 in dji pilot.",
             "ironbow_1",
             "without isotherm enabled, the palette type is ironbow1. with isotherm enabled, the palette type is ironbowwhiso. shown as ironred in dji pilot.",
             "ironbow_2",
             "without isotherm enabled, the palette type is ironbow2. with isotherm enabled, the palette type is ironbowbhiso.",
             "ice_fire",
             "without isotherm enabled, the palette type is icefire. with isotherm enabled, the palette type is icefireiso. shown as arctic in dji pilot.",
             "sepia",
             "without isotherm enabled, the palette type is sepia. with isotherm enabled, the palette type is sepiaiso.",
             "glowbow",
             "without isotherm enabled, the palette type is glowbow. with isotherm enabled, the palette type is glowbowiso.",
             "color_1",
             "without isotherm enabled, the palette type is color1. with isotherm enabled, the palette type is midrangewhiso. shown as fulgurite in dji pilot.",
             "color_2",
             "without isotherm enabled, the palette type is color2. with isotherm enabled, the palette type is midrangebhiso. shown as hotiron in dji pilot.",
             "rain",
             "without isotherm enabled, the palette type is rain. with isotherm enabled, the palette type is rainbowhciso. shown as rainbow2 in dji pilot.",
             "hot_spot",
             "without isotherm enabled, the palette type is hotspot. with isotherm enabled, the palette type is hotspotiso. only supported by mavic 2 enterprise dual.",
             "rainbow2",
             "without isotherm enabled, the palette type is rainbow2. with isotherm enabled, the palette type is rainbow2iso. only supported by mavic 2 enterprise dual.",
             "gray",
             "without isotherm enabled, the palette type is gray. with isotherm enabled, the palette type is grayiso. only supported by mavic 2 enterprise dual.",
             "hot_metal",
             "without isotherm enabled, the palette type is hotmetal. with isotherm enabled, the palette type is hotmetaliso. only supported by mavic 2 enterprise dual.",
             "cold_spot",
             "without isotherm enabled, the palette type is coldspot. with isotherm enabled, the palette type is coldspotiso. only supported by mavic 2 enterprise dual.",
             "unknown",
             "the palette type is unknown.",
             "linear",
             "linearly transforms the 14-bit sensor pixel data to 8-bit jpeg/mp4 pixel data.",
             "default",
             "automatically adjusts dde, ace, sso, brightness and contrast.",
             "sea_sky",
             "automatically adjusts dde, ace, sso, brightness and contrast with presets optimized for scenes composed of the sea and the sky scenes.",
             "outdoor",
             "automatically adjusts dde, ace, sso, brightness and contrast with presets optimized for outdoor scenes.",
             "indoor",
             "automatically adjusts dde, ace, sso, brightness and contrast with presets optimized for indoor scenes.",
             "manual",
             "allows manual setting of dde, ace, sso, brightness and contrast.",
             "profile_1",
             "first saved settings of dde, ace, sso, brightness and contrast.",
             "profile_2",
             "second saved settings of dde, ace, sso, brightness and contrast.",
             "profile_3",
             "third saved settings of dde, ace, sso, brightness and contrast.",
             "inspection",
             "automatically adjusts dde, ace, sso, brightness and contrast with presets optimized for inspection scenes.",
             "unknown",
             "the scene type is unknown.",
             "percentage",
             "the unit type is percentage. the allowed range is [0, 100].",
             "celsius",
             "the unit type is degrees celsius. the allowed range is [-40, 1000].",
             "unknown",
             "the unit type is unknown.",
             "auto",
             "the camera will automatically select the optimal gain mode according to the temperature range of the image.",
             "low",
             "the camera covers a wider temperature range but is less sensitive to temperature differences.",
             "high",
             "the camera covers a smaller temperature range but is more sensitive to temperature differences.",
             "unknown",
             "the gain mode is unknown.",
             "resolution_336x256",
             "the thermal imaging camera resolution is 336x256.",
             "resolution_640x512",
             "the thermal imaging camera resolution is 640x512.",
             "resolution_384x288",
             "the thermal imaging camera resolution is 384x288.",
             "resolution_1024x768",
             "the thermal imaging camera resolution is 1024x768.",
             "unknown",
             "the thermal imaging camera resolution is unknown.",
             "upper_bound_8_dot_3_hz",
             "the thermal imaging camera frame rate upper bound is 8.3hz.",
             "upper_bound_30_hz",
             "the thermal imaging camera frame rate upper bound is 30hz.",
             "unknown",
             "the thermal imaging camera frame rate upper bound is unknown.",
             "length_6_dot_8_mm",
             "the thermal imaging camera's lens focal length is 6.8 mm.",
             "length_7_dot_5_mm",
             "the thermal imaging camera lens focal length is 7.5mm.",
             "length_9_mm",
             "the thermal imaging camera's lens focal length is 9 mm.",
             "length_13_mm",
             "the thermal imaging camera's lens focal length is 13 mm.",
             "length_19_mm",
             "the thermal imaging camera's lens focal length is 19 mm.",
             "unknown",
             "the thermal imaging camera's lens focal length is unknown.",
             "xt_standard",
             "the thermal camera is zenmuse xt standard version.",
             "xt_advanced_radiometry_enabled",
             "the thermal camera is zenmuse xt advanced radiometry version.",
             "profile_1",
             "custom thermal external scene settings for user 1.",
             "profile_2",
             "custom thermal external scene settings for user 2.",
             "profile_3",
             "custom thermal external scene settings for user 3.",
             "unknown",
             "the user is unknown.",
             "auto",
             "automatic flat-field correction mode.",
             "manual",
             "manual flat-field correction mode.",
             "unknown",
             "unknown flat-field correction mode.",
             "getresolution",
             "get the supported resolution of the thermal imaging camera.  @return the enum value of the `thermalresolution`",
             "getframerateupperbound",
             "get the supported frame rate upper bound of the thermal imaging camera.  @return the enum value of the `thermalframerateupperbound`",
             "getfocallength",
             "the lens model of the thermal imaging camera.  @return the enum value of the `thermallensfocallength`",
             "getversion",
             "get the version of the thermal imaging camera.  @return the enum value of the `thermalversion`",
             "x_1",
             "digital zoom factor x1.",
             "x_2",
             "digital zoom factor is x2.",
             "x_4",
             "digital zoom factor is x4.",
             "x_8",
             "digital zoom factor is x8. not support by mavic 2 enterprise dual light camera.",
             "x_16",
             "digital zoom factor is x16. not support by mavic 2 enterprise dual light camera.",
             "x_32",
             "digital zoom factor is x32. not support by mavic 2 enterprise dual light camera.",
             "unknown",
             "digital zoom factor is unknown.",
             "disabled",
             "disable temperature measuring.",
             "spot_metering",
             "enable temperature measurement and set mode to spot metering. use `setthermaltemperaturecallback` to receive the updated temperature data. in this mode, the advanced radiometry version xt camera can change the metering point using `setthermalspotmeteringtargetpoint`.",
             "area_metering",
             "enable temperature measurement and set mode to area metering. use `onupdate` to receive the updated temperature data. only supported by the advanced radiometry version xt camera.",
             "unknown",
             "thermal camera's temperature measurement mode is unknown.",
             "getaverageareatemperature",
             "get the average temperature of the selected metering area.  @return a float value.",
             "getminareatemperature",
             "get the minimum temperature of the selected metering area.  @return a float value for the minimal temperature of the metering area.",
             "getmintemperaturepoint",
             "the minimum temperature coordinate of the selected metering area.  @return minimum temperature position.",
             "getmaxareatemperature",
             "get the maximum temperature of the selected metering area.  @return a float value for the maximal temperature of the metering area.",
             "getmaxtemperaturepoint",
             "the maximum temperature coordinate of the selected metering area.  @return maximum temperature position.",
             "getatmospherictemperature",
             "atmospheric temperature, can be between -50 and 327.67 degrees celsius.  @return atmospheric temperature",
             "thermal_atmospheric_temperature",
             "sdk key for getatmospherictemperature: atmospheric temperature, can be between -50 and 327.67 degrees celsius.  @return atmospheric temperature",
             "getatmospherictransmissioncoefficient",
             "transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return transmission coefficient",
             "thermal_atmospheric_transmission_coefficient",
             "sdk key for getatmospherictransmissioncoefficient: transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return transmission coefficient",
             "getbackgroundtemperature",
             "background temperature (reflected by the scene), can be between -50 and 327.67 degrees celsius.  @return background temperature",
             "thermal_background_temperature",
             "sdk key for getbackgroundtemperature: background temperature (reflected by the scene), can be between -50 and 327.67 degrees celsius.  @return background temperature",
             "getsceneemissivity",
             "emissivity of the scene, can be between 50 and 100.  @return emissivity of the scene",
             "thermal_scene_emissivity",
             "sdk key for getsceneemissivity: emissivity of the scene, can be between 50 and 100.  @return emissivity of the scene",
             "getwindowreflection",
             "window reflection, can be between 50 and 100-x where x is the window transmission coefficient parameter.  @return window reflection value.",
             "thermal_window_reflection",
             "sdk key for getwindowreflection: window reflection, can be between 50 and 100-x where x is the window transmission coefficient parameter.  @return window reflection value.",
             "getwindowreflectedtemperature",
             "temperature reflected in the window, can be between -50 and 327.67 degrees celsius.  @return temperature reflected in window.",
             "thermal_window_reflected_temperature",
             "sdk key for getwindowreflectedtemperature: temperature reflected in the window, can be between -50 and 327.67 degrees celsius.  @return temperature reflected in window.",
             "getwindowtemperature",
             "window temperature, can be between -50 and 327.67 degrees celsius.  @return window temperature.",
             "thermal_window_temperature",
             "sdk key for getwindowtemperature: window temperature, can be between -50 and 327.67 degrees celsius.  @return window temperature.",
             "getwindowtransmissioncoefficient",
             "transmission coefficient of the window, can be between 50 and 100-x where x is the window reflection.  @return window transmission coefficient.",
             "thermal_window_transmission_coefficient",
             "sdk key for getwindowtransmissioncoefficient: transmission coefficient of the window, can be between 50 and 100-x where x is the window reflection.  @return window transmission coefficient.",
             "visual_only",
             "displays only the video feed from the visual camera.",
             "thermal_only",
             "displays only the video feed from the thermal camera.",
             "pip",
             "displays the video feed from the visual camera as the main subject, and the video from the thermal camera in a window not bigger than the main subject. the position of the thermal camera window can be adjusted with `pipposition`. not supported by mavic 2 enterprise dual.",
             "msx",
             "multi-spectral dynamic imaging. fuse the video feeds from both the visual camera and the thermal camera as one. adds visible spectrum definition to ir images by detecting the edges of objects and including that detail in the thermal image.",
             "other",
             "the thermal video feed display mode is unknown.",
             "ir_center",
             "position the window to the vertical center and the horizontal center.",
             "ir_bottom_right",
             "position the window to be bottom right.",
             "ir_center_right",
             "position the window to be centered on the right.",
             "ir_top_right",
             "position the window to be top right.",
             "ir_bottom_center",
             "position the window to be centered at bottom.",
             "ir_top_center",
             "position the window to be centered at top.",
             "ir_bottom_left",
             "position the window to be bottom left.",
             "ir_center_left",
             "position the window to be centered on the left.",
             "ir_top_left",
             "position the window to be top left.",
             "side_by_side",
             "position the thermal window on the right side of the main window (the visual camera video feed). scale both windows with the same height.",
             "align",
             "position the thermal window on top of the main window (the visual camera video feed). then align the object in the thermal window with the same object in the main window. the alignment offset can be adjusted by `setdualfeedhorizontalalignmentoffset` and `setdualfeedverticalalignmentoffset`.",
             "other",
             "unknown.",
             "getmaxfocallength",
             "the maximum focal length of the lens in units of 0.1mm.  @return maximum focal length of lens.",
             "getminfocallength",
             "the minimum focal length of the lens in units of 0.1mm.  @return minimum focal length of lens.",
             "getfocallengthstep",
             "the minimum interval of focal length change in units of 0.1mm.  @return focal length step.",
             "getmaxhybridfocallength",
             "the maximum hybrid zoom focal length of the lens in units of 0.1mm.  @return maximum focal length of lens.",
             "getminhybridfocallength",
             "the minimum hybrid zoom focal length of the lens in units of 0.1mm.  @return minimum focal length of lens.",
             "getmaxopticalfocallength",
             "the maximum optical zoom focal length of the lens in units of 0.1mm.  @return minimum focal length of lens.",
             "getfocallengthstep",
             "the minimum interval of focal length change in units of 0.1mm.  @return focal length step.",
             "zoom_in",
             "lens will zoom in. the focal length increases, field of view becomes narrower and magnification is higher.",
             "zoom_out",
             "lens will zoom out. the focal length decreases, field of view becomes wider and magnification is lower.",
             "slowest",
             "lens zooms very in slowest speed.",
             "slow",
             "lens zooms in slow speed.",
             "moderately_slow",
             "lens zooms in speed slightly slower than normal speed.",
             "normal",
             "lens zooms in normal speed.",
             "moderately_fast",
             "lens zooms very in speed slightly faster than normal speed.",
             "fast",
             "lens zooms very in fast speed.",
             "fastest",
             "lens zooms very in fastest speed.",
             "idle",
             "the tap zoom is not triggered yet. it will always push `idle` if camera is not zooming.",
             "zoom_in",
             "the camera is zooming in. the focal length increases, field of view becomes narrower and magnification is higher.",
             "zoom_out",
             "the camera is zooming in the focal length decreases, field of view becomes wider and magnification is lower.",
             "zoom_limited",
             "it means the camera has reached its maximum focus length. it will always push `zoom_limited` if the camera reaches its maximum focus length.",
             "reset",
             "camera will reset the newest file's index to be one larger than the largest number of photos taken on the sd card.",
             "sequence",
             "camera will set the newest file's index to the larger of either the maximum number of photos taken on the sd card or the camera.",
             "unknown",
             "the mode is unknown.",
             "auto",
             "auto. nd filter will be enabled or disabled automatically by the camera.",
             "on",
             "the nd filter is on.",
             "off",
             "the nd filter is off.",
             "unknown",
             "unknown.",
             "default",
             "default user.",
             "profile_1",
             "settings for user 1.",
             "profile_2",
             "settings for user 2.",
             "profile_3",
             "settings for user 3.",
             "profile_4",
             "settings for user 4.",
             "unknown",
             "the user is unknown.",
             "none",
             "the camera color is set to none or no filter.",
             "art",
             "the camera color is set to art.",
             "black_and_white",
             "the camera color is set to black and white.",
             "bright",
             "the camera color is set to bright.",
             "d_cinelike",
             "the camera color is set to d-cinelike (called movie before).",
             "portrait",
             "the camera color is set to portrait. only supported by osmo with x3 camera.",
             "m_31",
             "the camera color is set to m31.",
             "k_dx",
             "the camera color is set to kdx.",
             "prismo",
             "the camera color is set to prismo.",
             "jugo",
             "the camera color is set to jugo.",
             "d_log",
             "the camera color is set to d-log (called neutral before). for mavic 2 pro, setting to this color can enable 10-bit dlog-m color profile.",
             "true_color",
             "the camera color is set to true color. it is only supported by phantom 4 with firmware v1.2.503 or above.",
             "inverse",
             "the camera color is set to inverse.",
             "reminiscence",
             "the camera color is set to reminiscence.",
             "solarize",
             "the camera color is set to solarize.",
             "posterize",
             "the camera color is set to posterize.",
             "whiteboard",
             "the camera color is set to whiteboard.",
             "blackboard",
             "the camera color is set to blackboard.",
             "aqua",
             "the camera color is set to aqua.",
             "delta",
             "the camera color is set to delta.",
             "dk79",
             "the camera color is set to dk79.",
             "vision_4",
             "the camera color is set to vision4.",
             "vision_6",
             "the camera color is set to vision6.",
             "true_color_ext",
             "the camera color is set to true color extend.",
             "film_a",
             "the camera color is set to film a.",
             "film_b",
             "the camera color is set to film b.",
             "film_c",
             "the camera color is set to film c.",
             "film_d",
             "the camera color is set to film d.",
             "film_e",
             "the camera color is set to film e.",
             "film_f",
             "the camera color is set to film f.",
             "film_g",
             "the camera color is set to film g.",
             "film_h",
             "the camera color is set to film h.",
             "film_i",
             "the camera color is set to film i.",
             "hlg",
             "the camera color is set to hlg (hybrid log-gamma).",
             "unknown",
             "the camera color is unknown.",
             "d_log",
             "the ei color is set to d-log.",
             "rec_709",
             "the ei color is set to rec.709.",
             "unknown",
             "unknown.",
             "none",
             "the camera color is set to none. it is only supported by x5s on inspire 2.",
             "d_cinelike",
             "the camera color is set to dcinelike. it is only supported by x5s on inspire 2.",
             "d_log",
             "the camera color is set to dlog. it is only supported by x5s on inspire 2.",
             "d_color_1",
             "the camera color is set to dcolor1. it is only supported by x5s on inspire 2.",
             "d_color_2",
             "the camera color is set to dcolor2. it is only supported by x5s on inspire 2.",
             "d_color_3",
             "the camera color is set to dcolor3. it is only supported by x5s on inspire 2.",
             "unknown",
             "the camera color is unknown.",
             "standard",
             "standard. it is available when the camera is in iso mode and the ssd license is `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`.",
             "dlog",
             "d-log. it is available when the camera is in ei mode and the ssd license is `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`.",
             "rec709",
             "rec.709. it is available when the camera is in ei mode and the ssd license is `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`.",
             "cine_like",
             "cine-like. it is available when the camera is in iso mode and the ssd license is `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`.",
             "raw_color",
             "raw color. this is the only for `licensekeytypecinemadng`.",
             "unknown",
             "unknown.",
             "iso",
             "iso mode.",
             "ei",
             "ei (exposure index) mode. in this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. this mode only takes effect when the camera mode is in `record_video`.",
             "unknown",
             "unknown.",
             "landscape",
             "by default, the camera is in landscape orientation.",
             "portrait",
             "the camera is in the portrait orientation, which is rotated 90 degrees in the clockwise direction from the default landscape orientation.",
             "unknown",
             "unknown.",
             "h264",
             "h.264 compression standard.",
             "h265",
             "h.265 compression standard.",
             "unknown",
             "unknown.",
             "standard",
             "saturation 0, contrast 0, sharpness 0.",
             "landscape",
             "saturation 0, contrast 1, sharpness 1.",
             "soft",
             "saturation 0, contrast 0, sharpness -1.",
             "custom",
             "custom preset type",
             "unknown",
             "unknown preset type",
             "fahrenheit",
             "use degree fahrenheit as the unit.",
             "celsius",
             "use degree celsius as the unit.",
             "other",
             "unknown.",
             "sdcard",
             "sd card.",
             "internal_storage",
             "the internal storage embedded in the aircraft. when it is available, the camera can shoot photos or record videos without sd card. it is only supported by mavic air.",
             "unknown",
             "unknown.",
             "default",
             "the default video stream channel.",
             "wide",
             "wide stream. only supported by zenmuse h20 series and mavic 2 enterprise advanced.",
             "zoom",
             "zoom stream. only supported by zenmuse h20 series and mavic 2 enterprise advanced.",
             "infrared_thermal",
             "infrared thermal stream. only supported by zenmuse h20t and h20n.and mavic 2 enterprise advanced.",
             "unknown",
             "unknown.",
             "callback",
             "when the video stream source has been changed, the interface will invoke the `onupdate` method to notify all subscribers to update.",
             "onupdate",
             "when the video stream source has been changed, the method will be invoked.  @param streamsource an object of `cameravideostreamsource`.",
             "getsaturation",
             "an nsinteger value of saturation.  @return saturation value of preset",
             "getcontrast",
             "an nsinteger value of contrast.  @return contrast value of preset",
             "getsharpness",
             "an nsinteger value of sharpness.  @return sharpness value of preset",
             "presettype",
             "an enum value of `picturestylepresettype`.  @return preset type",
             "colorwaveformdisplaymode",
             "camera work modes.",
             "mix",
             "mix mode.",
             "separate",
             "separate mode.",
             "unknown",
             "unknown mode.",
             "colorwaveformdisplaystate",
             "color waveform display state.",
             "color_waveform_display_state",
             "sdk key for colorwaveformdisplaystate: color waveform display state.",
             "exposure",
             "switch to exp event.",
             "color",
             "switch to color event.",
             "unknown",
             "switch to unknown.",
             "setsystemstatecallback",
             "sets the camera's system state callback. the onupdate function has a camerasystemstate object as its parameter.  precondition:  a callback object must be implemented and passed in as a parameter.  postcondition:  the callback object that was passed in as a parameter will call its onupdate function at regular intervals.  @param updatedsystemstatecallback the callback object to set as the callback. <br> callback implements an `onupdate` method.</br> the camerasdcardstate object contains information about the sd card inserted into the aircraft's camera.",
             "setexposuresettingscallback",
             "sets the callback for updated exposure parameters. the callback's `onupdate` method will be called each time the exposure parameters (iso, exposure compensation, shutter speed and aperture) are updated. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback.",
             "setmediafilecallback",
             "sets the camera's new generated media file callback.  note:because the firmware cannot return some information correctly, so the interface is deprecated, please use `setnewgeneratedmediafileinfocallback` insteaded.  @param callback the callback object to set as the callback. the callback's method `onnewfile` has a `mediafile` object as it's parameter from which information about the media type, index, file size and the created time can be obtained.",
             "setnewgeneratedmediafileinfocallback",
             "sets the camera's new generated media file info callback.  @param callback the callback object to set as the callback. the callback's method `onnewfileinfo` has a `mediafileinfo` object as it's parameter from which information about the media type, index, file size, created time and stream source can be obtained.",
             "settimelapsepreviewcallback",
             "sets the generated preview image callback. the callback's `ongenerate` method will be called each time a photo has been taken.  @param generatedtimelapsecallback the execution callback.",
             "setthermaltemperaturecallback",
             "sets the thermal camera's temperature update callback. callback is used when there is a new temperature value available for the set spot metering target point. supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param updatecentertemperaturecallback the callback object to set as the callback. <br> callback implements an `onupdate` method.</br> the float object contains information about the updated temperature value.",
             "setfocusstatecallback",
             "callback for updating the lens state. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param updatedlensstatecallback the callback.",
             "setthermalareatemperatureaggregationscallback",
             "sets the thermal camera's temperature aggregation update callback. callback will be called when there are new min, max, and average values available for the set spot metering area. supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param areatemperatureaggregationsupdatedcallback the callback object to set as the callback.",
             "setthermalexternalscenesettingscallback",
             "sets the thermal camera's external scene settings update callback. callback will get called when updated external scene settings are available. supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher, only supported by xt2.  @param thermalexternalscenesettingsupdatedcallback the callback object to set as the callback.",
             "setsdcardstatecallback",
             "sets the camera's sd card information callback. deprecated, please use `onupdate` instead.  @param updatedsdcardstatecallback the callback object to set as the callback.",
             "setstoragestatecallback",
             "called when the camera's storage state has been updated. use `storagestate`'s `getstoragelocation` to determine if the updated state is for sd card or the internal storage.  @param storagestatecallback the callback object to set as the callback.",
             "setssdstatecallback",
             "callback for updating the ssd state.  @param updatedssdstatecallback the callback.",
             "sethistogramcallback",
             "sets the histogram callback.  @param callback the execution callback.",
             "setcameravideostreamsourcecallback",
             "sets the camera video stream source callback. when the camera video stream source been changed, the interface of `callback` would be triggered. it is only supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "setmultispectralexposurestatecallback",
             "called when the multispectral camera's exposure status changes. only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the result.",
             "iscaptureinvideosupported",
             "this method is used to determine whether the video recording supports photographing.  @return a boolean value.",
             "getdisplayname",
             "return string that represents name of the camera.  @return an instance of display name string.",
             "camerakey.display_name",
             "sdk key for getdisplayname: return string that represents name of the camera.  @return an instance of display name string.",
             "getcapabilities",
             "camera capabilities. return `nil` when the camera is multiple lenses camera. instead, user can access lens' capabilities through its lens object.  @return an object of `capabilities`.",
             "getlens",
             "gets camera lens by lensindex.  @param lensindex lens index.  @return an object of `lens`.",
             "getlenses",
             "camera's own lenses.  @return a list of `lens`.",
             "isflatcameramodesupported",
             "determines if current camera supports flat camera mode. returns `true` if the `cameramode` and `shootphotomode` flatten into `flatcameramode`. the `flatcameramode` and `setflatmode` can be used to set the camera mode directly. the user does not need to use `setmode` and `setshootphotomode` to set the camera mode by two steps. besides, the `media_download` is decoupled from the `cameramode`. determine what the last camera mode was by checking `getmode` before entering the playback.  @return a boolean value.",
             "setflatmode",
             "sets the camera's flat mode to take photo, record video, or enter intelligent camera modes. please note that you cannot change the mode when a certain task is executing. this is available only when `isflatcameramodesupported` returns `true`.  @param mode camera flat mode. see `flatcameramode` to find details. @param callback the execution callback with the returned execution result.",
             "getflatmode",
             "gets the camera's current flat mode. this is available only when `isflatcameramodesupported` returns `true`.  @param callback the execution callback with the returned value(s).",
             "enterplayback",
             "enter playback mode, in which users can preview photos or videos, begin the video playback, and download media to the mobile device. this is available only when `isflatcameramodesupported` returns `true`. please note that only after exiting playback mode, last flat camera mode will be recovered.  @param callback the execution callback with result of the action.",
             "exitplayback",
             "exit play back mode. this is available only when `isflatcameramodesupported` returns `true`.  @param callback the execution callback with result of the action.",
             "setmode",
             "sets the camera's work mode to taking pictures, video, playback or download. please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. also supported by thermal imaging camera.  @param mode camera work mode. see enum named cameramode in settingsdefinitions to find details on camera work modes. @param callback the execution callback with the returned execution result.",
             "camerakey.mode",
             "sdk key for setmode: sets the camera's work mode to taking pictures, video, playback or download. please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. also supported by thermal imaging camera.  @param mode camera work mode. see enum named cameramode in settingsdefinitions to find details on camera work modes. @param callback the execution callback with the returned execution result.",
             "getmode",
             "gets the camera's current work mode. also supported by thermal imaging camera.  @param callback the execution callback with the returned value(s).",
             "camerakey.mode",
             "sdk key for getmode: gets the camera's current work mode. also supported by thermal imaging camera.  @param callback the execution callback with the returned value(s).",
             "startrecordvideo",
             "starts recording video.  precondition:  camera must be in `record_video` mode. for thermal imaging camera, user can take single photo when recording video.  @param callback the execution callback with the returned value(s).",
             "start_record_video",
             "sdk key for startrecordvideo: starts recording video.  precondition:  camera must be in `record_video` mode. for thermal imaging camera, user can take single photo when recording video.  @param callback the execution callback with the returned value(s).",
             "stoprecordvideo",
             "stops recording video.  precondition:  the camera is recording currently.  @param callback the execution callback with the returned execution result.",
             "stop_record_video",
             "sdk key for stoprecordvideo: stops recording video.  precondition:  the camera is recording currently.  @param callback the execution callback with the returned execution result.",
             "startshootphoto",
             "camera starts to take photo with one of the camera capture modes (shoot photo modes).also,  precondition:  1. camera must be in shootphoto mode. check the enum named camerashootphotomode in djicamerasettingsdef to find all possible camera capture modes. for thermal imaging camera, single photo can be taken while recording video. 2. the sd card state should be checked before this method is used to ensure sufficient space exists.  post condition:  if the capture mode is either burst or interval, calling stopshootphoto will be required for the camera to stop taking photos.  @param callback the execution callback with the returned execution result.",
             "start_shoot_photo",
             "sdk key for startshootphoto: camera starts to take photo with one of the camera capture modes (shoot photo modes).also,  precondition:  1. camera must be in shootphoto mode. check the enum named camerashootphotomode in djicamerasettingsdef to find all possible camera capture modes. for thermal imaging camera, single photo can be taken while recording video. 2. the sd card state should be checked before this method is used to ensure sufficient space exists.  post condition:  if the capture mode is either burst or interval, calling stopshootphoto will be required for the camera to stop taking photos.  @param callback the execution callback with the returned execution result.",
             "stopshootphoto",
             "camera stops taking photos.  precondition:  1. `startshootphoto` has been invoked and the shoot mode is either interval or time-lapse.  2. if the capture mode is set to single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback the execution callback with the returned execution result.",
             "stop_shoot_photo",
             "sdk key for stopshootphoto: camera stops taking photos.  precondition:  1. `startshootphoto` has been invoked and the shoot mode is either interval or time-lapse.  2. if the capture mode is set to single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback the execution callback with the returned execution result.",
             "setshootphotomode",
             "sets the photo shooting mode for the camera.  @param mode `shootphotomode` enum value. @param callback asynchronous execution result.",
             "shoot_photo_mode",
             "sdk key for setshootphotomode: sets the photo shooting mode for the camera.  @param mode `shootphotomode` enum value. @param callback asynchronous execution result.",
             "getshootphotomode",
             "returns the current photo shooting mode of the camera.  @param callback asynchronous execution result.",
             "shoot_photo_mode",
             "sdk key for getshootphotomode: returns the current photo shooting mode of the camera.  @param callback asynchronous execution result.",
             "istimelapsesupported",
             "check if the current device supports time-lapse shoot mode. supported only on the osmo camera.  @return `true` if timelapse is supported.",
             "is_time_lapse_supported",
             "sdk key for istimelapsesupported: check if the current device supports time-lapse shoot mode. supported only on the osmo camera.  @return `true` if timelapse is supported.",
             "issuperresolutionsupported",
             "check if the current device supports super resolution shoot mode. supported only on the zenmuse h20 series.  @return `true` if super resolution is supported.",
             "setsuperresolutioninfocallback",
             "callback for updating the super resolution state.  @param superresstatecallback callback method.",
             "setsuperresolutioncapturearea",
             "sets the capture area of super resolution. the area range must be within the range:`getmaxarea`.  @param area a recf value of super resolution capture area. @param callback callback method.",
             "superresolutioninfo",
             "stores the super resolution information.",
             "callback",
             "updates the super resolution state. in order to begin updates.",
             "onupdate",
             "called when the super resolution state has been updated.",
             "getmaxarea",
             "gets the max area of super resolution. depends with the camera angle, calculated automatically by the camera.  @return the max area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
             "getzoomtotalcount",
             "gets the total count of super resolution.  @return the total count of super resolution.",
             "getcapturearea",
             "gets the area of super resolution.  @return the area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
             "getcapturecolnum",
             "gets the column number of super resolution.  @return the column number of capture.",
             "getcapturerownum",
             "gets the row number of super resolution.  @return the row number of capture.",
             "isstorageoverflow",
             "gets whether the memory card is full.  @return `true` if the memory card is full. please replace the sd card.",
             "getcaptureremainingtime",
             "gets the remaining time of super resolution capture.  @return the remaining time of super resolution capture.",
             "getprogress",
             "gets the captured progress percentage of super resolution.  @return the captured progress percentage of super resolution.",
             "getzoomcapturedcount",
             "gets the captured count of super resolution.  @return the captured count of super resolution.",
             "getstatus",
             "gets the state of super resolution.  @return the state of super resolution.",
             "superresolutionstatus",
             "the states of super resolution.",
             "selecting",
             "selecting. you could adjust super resolution area with `setsuperresolutioncapturearea`.",
             "in_progress",
             "super resolution shooting in progress.",
             "finish",
             "super resolution shooting completed.",
             "exit_out_of_storage",
             "stop shooting because there is no storage.",
             "exit_shoot_fail",
             "stop shooting because the shooting failed.",
             "exit_gimbal_block",
             "stop shooting because the gimbal is blocked.",
             "exit_gimbal_abnormal_move",
             "stop shooting because the gimbal did not move or move abnormally.",
             "tip_gimbal_out_of_range",
             "stop shooting because the angle of gimbal exceeds the maximum range.",
             "tip_out_of_zoom",
             "the zoom of camera out of the maximum range.",
             "unknown",
             "unknown error.",
             "ismediadownloadmodesupported",
             "check if the current device supports media download mode.  @return `true` if the current device supports media download mode, `false` otherwise.",
             "is_media_download_mode_supported",
             "sdk key for ismediadownloadmodesupported: check if the current device supports media download mode.  @return `true` if the current device supports media download mode, `false` otherwise.",
             "getmediamanager",
             "media manager is used for interaction when camera is in `media_download`. the user can only access the manager when `ismediadownloadmodesupported` returns `true`. @return the `mediamanager` object if the aircraft supports media list feature. otherwise, returns `null`.  @return an instance of `mediamanager`.",
             "isplaybacksupported",
             "check if the current device supports playback mode.  @return a boolean value.",
             "is_playback_supported",
             "sdk key for isplaybacksupported: check if the current device supports playback mode.  @return a boolean value.",
             "getplaybackmanager",
             "gets the playback manager object. playback manager is used for interaction when camera is in `playback`. user can only access to the manager when `isplaybacksupported` returns `true`.  @return an instance of `playbackmanager`.",
             "setexposuremode",
             "sets the camera's exposure mode. check `exposuremode` to view all possible camera exposure modes. please note that in different exposure mode, it will have different values for the same setting. for mavic 2 enterprise dual, the exposure mode is always `program`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param mode camera exposure mode to set. @param callback the execution callback with the returned execution result.",
             "exposure_mode",
             "sdk key for setexposuremode: sets the camera's exposure mode. check `exposuremode` to view all possible camera exposure modes. please note that in different exposure mode, it will have different values for the same setting. for mavic 2 enterprise dual, the exposure mode is always `program`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param mode camera exposure mode to set. @param callback the execution callback with the returned execution result.",
             "getexposuremode",
             "gets the camera's exposure mode. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "exposure_mode",
             "sdk key for getexposuremode: gets the camera's exposure mode. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setiso",
             "sets the camera's iso value. see `iso` to view all possible iso settings for the camera. for the x5, x5r, phantom 4 pro camera, x4s and x5s, the iso value can be set for all modes. for the other cameras, the iso value can only be set when the camera exposure mode is in manual mode. see the `setexposuremode` method for how to set exposure mode. for mavic 2 enterprise dual, the iso value is always `auto`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param iso the iso value to set the camera to use. please check the enum cameraisoe in djicamerasettingsdef to find all possible iso values that the camera can be set to. @param callback the execution callback with the returned execution result.",
             "iso",
             "sdk key for setiso: sets the camera's iso value. see `iso` to view all possible iso settings for the camera. for the x5, x5r, phantom 4 pro camera, x4s and x5s, the iso value can be set for all modes. for the other cameras, the iso value can only be set when the camera exposure mode is in manual mode. see the `setexposuremode` method for how to set exposure mode. for mavic 2 enterprise dual, the iso value is always `auto`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param iso the iso value to set the camera to use. please check the enum cameraisoe in djicamerasettingsdef to find all possible iso values that the camera can be set to. @param callback the execution callback with the returned execution result.",
             "getiso",
             "gets the camera's iso value. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "iso",
             "sdk key for getiso: gets the camera's iso value. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setshutterspeed",
             "sets the camera shutter speed. to see all available shutterspeed</code> value settings, see `shutterspeed`. the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate is 30fps, the shutterspeed</code> must be <= 1/30. precondition: the shutter speed can be set only when the camera exposure mode is shutter mode or manual mode. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param shutterspeed the iso value to set the camera to use. please check the enum cameraisoe in djicamerasettingsdef to find all possible iso values that the camera can be set to. @param callback the execution callback with the returned execution result.",
             "shutter_speed",
             "sdk key for setshutterspeed: sets the camera shutter speed. to see all available shutterspeed</code> value settings, see `shutterspeed`. the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate is 30fps, the shutterspeed</code> must be <= 1/30. precondition: the shutter speed can be set only when the camera exposure mode is shutter mode or manual mode. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param shutterspeed the iso value to set the camera to use. please check the enum cameraisoe in djicamerasettingsdef to find all possible iso values that the camera can be set to. @param callback the execution callback with the returned execution result.",
             "getshutterspeed",
             "gets the camera's shutter speed. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "shutter_speed",
             "sdk key for getshutterspeed: gets the camera's shutter speed. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "isadjustableaperturesupported",
             "gets whether the camera supports an adjustable aperture. currently adjustable aperture is supported only by the x5, x5r, x4s, x5s cameras and mavic 2 pro. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "is_adjustable_aperture_supported",
             "sdk key for isadjustableaperturesupported: gets whether the camera supports an adjustable aperture. currently adjustable aperture is supported only by the x5, x5r, x4s, x5s cameras and mavic 2 pro. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "setaperture",
             "sets the aperture value. this feature is available only when `isadjustableaperturesupported` returns `true`.  precondition:  the exposure mode `exposuremode` must be in `manual` or `aperture_priority`. </br> supported only by the x5, x5r, x4s, x5s camera and mavic 2 pro. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param aperture the aperture to set. check enum cameralensfocusmode in djicamerasettingsdef. @param callback the execution callback with the returned execution result.",
             "aperture",
             "sdk key for setaperture: sets the aperture value. this feature is available only when `isadjustableaperturesupported` returns `true`.  precondition:  the exposure mode `exposuremode` must be in `manual` or `aperture_priority`. </br> supported only by the x5, x5r, x4s, x5s camera and mavic 2 pro. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param aperture the aperture to set. check enum cameralensfocusmode in djicamerasettingsdef. @param callback the execution callback with the returned execution result.",
             "getaperture",
             "gets the lens aperture. this feature is available only when `isadjustableaperturesupported` returns `true`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "aperture",
             "sdk key for getaperture: gets the lens aperture. this feature is available only when `isadjustableaperturesupported` returns `true`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setmeteringmode",
             "sets the camera's exposure metering. see `meteringmode` to view all possible exposure metering settings for the camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param mode exposure metering to be set. check the enum `meteringmode` to find all possible exposure metering the camera can be set to. @param callback the execution callback with the execution result",
             "metering_mode",
             "sdk key for setmeteringmode: sets the camera's exposure metering. see `meteringmode` to view all possible exposure metering settings for the camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param mode exposure metering to be set. check the enum `meteringmode` to find all possible exposure metering the camera can be set to. @param callback the execution callback with the execution result",
             "getmeteringmode",
             "gets the camera's exposure metering. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "metering_mode",
             "sdk key for getmeteringmode: gets the camera's exposure metering. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setspotmeteringtarget",
             "sets the spot metering area index. the camera image is divided into 96 spots defined by 12 columns and 8 rows. the row index range is [0,7], where the values increase top to bottom across the image. the column index range is [0, 11], where the values increase left to right. in order to make the method work, the camera exposure mode should be program</code>, shutter</code> or aperture</code>, the exposure metering mode must be `spot`, and `setaelock` must be `false`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param spotindex spot metering point coordinate (x, y).  x is column index to be set. the value should falls in [0, 11], where the values increase left to right. y is row index to be set. the value should falls in [0, 7], where the values increase top to bottom across the image. @param callback the execution callback with the returned execution result.",
             "spot_metering_target",
             "sdk key for setspotmeteringtarget: sets the spot metering area index. the camera image is divided into 96 spots defined by 12 columns and 8 rows. the row index range is [0,7], where the values increase top to bottom across the image. the column index range is [0, 11], where the values increase left to right. in order to make the method work, the camera exposure mode should be program</code>, shutter</code> or aperture</code>, the exposure metering mode must be `spot`, and `setaelock` must be `false`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param spotindex spot metering point coordinate (x, y).  x is column index to be set. the value should falls in [0, 11], where the values increase left to right. y is row index to be set. the value should falls in [0, 7], where the values increase top to bottom across the image. @param callback the execution callback with the returned execution result.",
             "getspotmeteringtarget",
             "gets the spot metering area row index and column index. in order to make the method work, the camera exposure mode should be `program`, `shutter_priority` or `aperture_priority`, the exposure metering mode must be `spot`, and `getaelock` must be `false`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "spot_metering_target",
             "sdk key for getspotmeteringtarget: gets the spot metering area row index and column index. in order to make the method work, the camera exposure mode should be `program`, `shutter_priority` or `aperture_priority`, the exposure metering mode must be `spot`, and `getaelock` must be `false`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setexposurecompensation",
             "sets the camera's exposure compensation. see `exposurecompensation` to view all possible exposure compensations to which the camera can be set. in order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param compensation exposure compensation value to be set for the camera. @param callback the execution callback with the returned execution result.",
             "exposure_compensation",
             "sdk key for setexposurecompensation: sets the camera's exposure compensation. see `exposurecompensation` to view all possible exposure compensations to which the camera can be set. in order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param compensation exposure compensation value to be set for the camera. @param callback the execution callback with the returned execution result.",
             "getexposurecompensation",
             "gets the camera's exposure compensation. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "exposure_compensation",
             "sdk key for getexposurecompensation: gets the camera's exposure compensation. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setaelock",
             "locks or unlocks the camera's ae (auto exposure).  post condition:  if the ae lock is enabled, the spot metering area cannot be set. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param islocked `true` if the camera ae is locked, `false` if it is unlocked. @param callback the execution callback with the returned execution result.",
             "ae_lock",
             "sdk key for setaelock: locks or unlocks the camera's ae (auto exposure).  post condition:  if the ae lock is enabled, the spot metering area cannot be set. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param islocked `true` if the camera ae is locked, `false` if it is unlocked. @param callback the execution callback with the returned execution result.",
             "getaelock",
             "determines if the camera's ae (auto exposure) is locked. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "ae_lock",
             "sdk key for getaelock: determines if the camera's ae (auto exposure) is locked. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setautoaeunlockenabled",
             "enables/disables auto-unlocking of ae lock after shooting a photo. if it is enabled, the auto exposure will unlock after each shot. if disabled, auto exposure will change when calling `setaelock`. it is only supported x4s, x5s and phantom 4 pro cameras. for the other products, auto-unlocking is always enabled. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param enabled `true` if the camera ae will automatically unlock. @param callback the execution callback with the returned execution result.",
             "auto_ae_unlock_enabled",
             "sdk key for setautoaeunlockenabled: enables/disables auto-unlocking of ae lock after shooting a photo. if it is enabled, the auto exposure will unlock after each shot. if disabled, auto exposure will change when calling `setaelock`. it is only supported x4s, x5s and phantom 4 pro cameras. for the other products, auto-unlocking is always enabled. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param enabled `true` if the camera ae will automatically unlock. @param callback the execution callback with the returned execution result.",
             "getautoaeunlockenabled",
             "determines whether auto-unlocking of ae lock is enabled. it is only supported by x4s, x5s and phantom 4 pro cameras. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "auto_ae_unlock_enabled",
             "sdk key for getautoaeunlockenabled: determines whether auto-unlocking of ae lock is enabled. it is only supported by x4s, x5s and phantom 4 pro cameras. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setphotoaebcount",
             "sets the camera's auto exposure bracketing (aeb) capture parameters.  @param count aeb capture count to be set for the camera. @param callback the execution callback with the returned execution result.",
             "photo_aeb_count",
             "sdk key for setphotoaebcount: sets the camera's auto exposure bracketing (aeb) capture parameters.  @param count aeb capture count to be set for the camera. @param callback the execution callback with the returned execution result.",
             "getphotoaebcount",
             "gets the camera's aeb capture parameters.  @param callback the execution callback with the returned value(s).",
             "photo_aeb_count",
             "sdk key for getphotoaebcount: gets the camera's aeb capture parameters.  @param callback the execution callback with the returned value(s).",
             "setwhitebalance",
             "sets the camera's white balance (color temperature). when white balance is `custom`, the colortemperature argument is used. for all other values, the colortemperature argument is ignored. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param whitebalance white balance value to be set. @param callback the execution callback with the returned execution result.  see also: `whitebalancepreset` to view all possible white balance setting options for the camera.",
             "white_balance",
             "sdk key for setwhitebalance: sets the camera's white balance (color temperature). when white balance is `custom`, the colortemperature argument is used. for all other values, the colortemperature argument is ignored. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param whitebalance white balance value to be set. @param callback the execution callback with the returned execution result.  see also: `whitebalancepreset` to view all possible white balance setting options for the camera.",
             "getwhitebalance",
             "gets the camera's white balance and color temperature. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "white_balance",
             "sdk key for getwhitebalance: gets the camera's white balance and color temperature. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "isinterchangeablelenssupported",
             "`true` if the changeable lens is supported by the camera. currently a changeable lens is supported only by the x5, x5r and x5s cameras. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "is_interchangeable_lens_supported",
             "sdk key for isinterchangeablelenssupported: `true` if the changeable lens is supported by the camera. currently a changeable lens is supported only by the x5, x5r and x5s cameras. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "getlensinformation",
             "gets details of the installed lens. supported only by the x5, x5r, x5s and x7 cameras. this is available only when `isinterchangeablelenssupported` returns `true`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "lens_information",
             "sdk key for getlensinformation: gets details of the installed lens. supported only by the x5, x5r, x5s and x7 cameras. this is available only when `isinterchangeablelenssupported` returns `true`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "isdigitalzoomsupported",
             "check if the current device supports digital zoom scale. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "is_digital_zoom_supported",
             "sdk key for isdigitalzoomsupported: check if the current device supports digital zoom scale. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "setdigitalzoomfactor",
             "adjusts the digital zoom. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and xt 2 camera, dji mini 2. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param factor the valid range is from 1.0 to 4.0. @param callback the execution callback with the returned execution result.",
             "digital_zoom_factor",
             "sdk key for setdigitalzoomfactor: adjusts the digital zoom. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and xt 2 camera, dji mini 2. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param factor the valid range is from 1.0 to 4.0. @param callback the execution callback with the returned execution result.",
             "getdigitalzoomfactor",
             "gets current digital zoom. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and z30 camera. note z30 cannot set the digital zoom scale, but will use digital zoom when using `startcontinuousopticalzoom` and the optical zoom has reached its limit. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "digital_zoom_factor",
             "sdk key for getdigitalzoomfactor: gets current digital zoom. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and z30 camera. note z30 cannot set the digital zoom scale, but will use digital zoom when using `startcontinuousopticalzoom` and the optical zoom has reached its limit. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "isopticalzoomsupported",
             "check if camera supports optical zoom. it is only supported by x5, x5r and x5s camera with the olympus m.zuiko ed 14-42mm f/3.5-5.6 ez lens, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return `true` if camera supports optical zoom.",
             "is_optical_zoom_supported",
             "sdk key for isopticalzoomsupported: check if camera supports optical zoom. it is only supported by x5, x5r and x5s camera with the olympus m.zuiko ed 14-42mm f/3.5-5.6 ez lens, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return `true` if camera supports optical zoom.",
             "getopticalzoomspec",
             "gets the specification of the zoom lens. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "optical_zoom_spec",
             "sdk key for getopticalzoomspec: gets the specification of the zoom lens. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setopticalzoomfocallength",
             "sets focal length of the zoom lens. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, x5s camera with panasonic lumix 14-42mm/3.5-5.6 hd or olympus m.zuiko 9-18mm/4.0-5.6, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focallength focal length of zoom lens. valid range is [`getminfocallength`, `getmaxfocallength`] and must be a multiple of `getfocallengthstep`. @param callback the execution callback with the returned execution result.",
             "optical_zoom_focal_length",
             "sdk key for setopticalzoomfocallength: sets focal length of the zoom lens. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, x5s camera with panasonic lumix 14-42mm/3.5-5.6 hd or olympus m.zuiko 9-18mm/4.0-5.6, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focallength focal length of zoom lens. valid range is [`getminfocallength`, `getmaxfocallength`] and must be a multiple of `getfocallengthstep`. @param callback the execution callback with the returned execution result.",
             "getopticalzoomfocallength",
             "gets zoom lens focal length in units of 0.1mm. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "optical_zoom_focal_length",
             "sdk key for getopticalzoomfocallength: gets zoom lens focal length in units of 0.1mm. it is only supported by x5, x5r and x5s camera with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "getopticalzoomfactor",
             "gets current optical zoom factor with range [1, 30]. it is only supported z30 camera. the z30 zoom factor can be changed with `setopticalzoomfocallength` and `startcontinuousopticalzoom`. the zoom factor is then calculated and given through this method. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "optical_zoom_scale",
             "sdk key for getopticalzoomfactor: gets current optical zoom factor with range [1, 30]. it is only supported z30 camera. the z30 zoom factor can be changed with `setopticalzoomfocallength` and `startcontinuousopticalzoom`. the zoom factor is then calculated and given through this method. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "startcontinuousopticalzoom",
             "start changing the focal length of the lens in specified direction with specified speed. focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopcontinuousopticalzoom` is called. it is only supported by x5, x5r and x5s camera on osmo with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series, please use class `lens`.  @param direction direction to zoom. @param speed zoom speed. @param callback the execution callback with the returned execution result.",
             "start_continuous_optical_zoom",
             "sdk key for startcontinuousopticalzoom: start changing the focal length of the lens in specified direction with specified speed. focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopcontinuousopticalzoom` is called. it is only supported by x5, x5r and x5s camera on osmo with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series, please use class `lens`.  @param direction direction to zoom. @param speed zoom speed. @param callback the execution callback with the returned execution result.",
             "stopcontinuousopticalzoom",
             "called to stop focal length changing, when it currently is from calling `startcontinuousopticalzoom`. it is only supported by x5, x5r and x5s camera on osmo with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "stop_continuous_optical_zoom",
             "sdk key for stopcontinuousopticalzoom: called to stop focal length changing, when it currently is from calling `startcontinuousopticalzoom`. it is only supported by x5, x5r and x5s camera on osmo with lens olympus m.zuiko ed 14-42mm f/3.5-5.6 ez, z3 camera, z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "ishybridzoomsupported",
             "hybrid zoom is combining optical and digital zoom. camera will automatically switch over to digital zoom when optical zoom range is exceeded. check if camera supports hybrid zoom. it is only supported by mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return `true` if camera supports hybrid zoom.",
             "gethybridzoomspec",
             "hybrid zoom is combining optical and digital zoom. camera will automatically switch over to digital zoom when optical zoom range is exceeded. gets the specification of the zoom lens. it is only supported by mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "sethybridzoomfocallength",
             "hybrid zoom is combining optical and digital zoom. camera will automatically switch over to digital zoom when optical zoom range is exceeded. sets focal length of the zoom lens. it is only supported by mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focallength focal length of zoom lens. valid range is [`getminhybridfocallength`, `getmaxhybridfocallength`] and must be a multiple of `getfocallengthstep`. @param callback the execution callback with the returned execution result.",
             "gethybridzoomfocallength",
             "hybrid zoom is combining optical and digital zoom. camera will automatically switch over to digital zoom when optical zoom range is exceeded. gets zoom lens focal length in units of 0.1mm. it is only supported by mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "istapzoomsupported",
             "determines whether the current camera supports tapzoom feature. tapzoom is only supported by z30 camera. @return `true` if the camera supports tapzoom. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "is_tap_zoom_supported",
             "sdk key for istapzoomsupported: determines whether the current camera supports tapzoom feature. tapzoom is only supported by z30 camera. @return `true` if the camera supports tapzoom. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "settapzoomenabled",
             "enable/disable tapzoom. `tapzoomattarget` can only be called when tapzoom is enabled. it is only supported z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param enabled the execution callback with the returned execution result. @param callback the execution callback with the returned execution result.",
             "tap_zoom_enabled",
             "sdk key for settapzoomenabled: enable/disable tapzoom. `tapzoomattarget` can only be called when tapzoom is enabled. it is only supported z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param enabled the execution callback with the returned execution result. @param callback the execution callback with the returned execution result.",
             "gettapzoomenabled",
             "determines whether tapzoom is enabled. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "tap_zoom_enabled",
             "sdk key for gettapzoomenabled: determines whether tapzoom is enabled. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "settapzoommultiplier",
             "tapzoom uses a multiplier to change the zoom scale when called. the final zoom scale for a tapzoom will be: current zoom scale x multiplier. the multiplier range is [1,5]. a multiplier of 1 will not change the zoom. when the multiplier is 1, the zoom scale will not change during tapzoom. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param multiplier multiplier of tapzoom. @param callback the execution callback with the returned execution result.",
             "tap_zoom_multiplier",
             "sdk key for settapzoommultiplier: tapzoom uses a multiplier to change the zoom scale when called. the final zoom scale for a tapzoom will be: current zoom scale x multiplier. the multiplier range is [1,5]. a multiplier of 1 will not change the zoom. when the multiplier is 1, the zoom scale will not change during tapzoom. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param multiplier multiplier of tapzoom. @param callback the execution callback with the returned execution result.",
             "gettapzoommultiplier",
             "gets the multiplier for tapzoom. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "tap_zoom_multiplier",
             "sdk key for gettapzoommultiplier: gets the multiplier for tapzoom. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "tapzoomattarget",
             "tapzoom at the target. it can be called only when tapzoom is enabled.  when a new target is set, the gimbal will rotate and locate the target in the center of the screen. at the same time, the camera will zoom by multiplying the tapzoom multiplier. it is only supported z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param target the cameratapzoomtargetpoint to zoom. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left corner of the screen. @param callback the execution callback with the returned execution result.",
             "tap_zoom_at_target",
             "sdk key for tapzoomattarget: tapzoom at the target. it can be called only when tapzoom is enabled.  when a new target is set, the gimbal will rotate and locate the target in the center of the screen. at the same time, the camera will zoom by multiplying the tapzoom multiplier. it is only supported z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param target the cameratapzoomtargetpoint to zoom. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left corner of the screen. @param callback the execution callback with the returned execution result.",
             "settapzoomstatecallback",
             "sets the tap zoom state callback. the callback's `onupdate` method will be called when the camera's zoom state is updated. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback completion callback that receives the execution result.",
             "isadjustablefocalpointsupported",
             "determines whether the camera supports an adjustable focal point. currently, the adjustable focal point is supported by the x5, x5r, z3, mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "is_adjustable_focal_point_supported",
             "sdk key for isadjustablefocalpointsupported: determines whether the camera supports an adjustable focal point. currently, the adjustable focal point is supported by the x5, x5r, z3, mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "setfocusmode",
             "sets the lens focus mode. see `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the x5, x5r, z3 cameras (z3 camera can only support `auto`), the mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focusmode focus mode to set. check `focusmode` for more detail. @param callback the execution callback with the returned execution result.",
             "focus_mode",
             "sdk key for setfocusmode: sets the lens focus mode. see `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the x5, x5r, z3 cameras (z3 camera can only support `auto`), the mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focusmode focus mode to set. check `focusmode` for more detail. @param callback the execution callback with the returned execution result.",
             "getfocusmode",
             "gets the lens focus mode. please check `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "focus_mode",
             "sdk key for getfocusmode: gets the lens focus mode. please check `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera, z30, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setfocustarget",
             "sets the lens focus target point. when the focus mode is auto, the target point is the focal point. when the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera, phantom 4 pro camera, mavic 2 pro, mavic 2 zoom camera, mavic 2 enterprise camera, x4s and x5s. camera, x4s and x5s. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focustarget the focus target to set. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left angle of the screen. @param callback the execution callback with the returned execution result.",
             "focus_target",
             "sdk key for setfocustarget: sets the lens focus target point. when the focus mode is auto, the target point is the focal point. when the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera, phantom 4 pro camera, mavic 2 pro, mavic 2 zoom camera, mavic 2 enterprise camera, x4s and x5s. camera, x4s and x5s. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param focustarget the focus target to set. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left angle of the screen. @param callback the execution callback with the returned execution result.",
             "getfocustarget",
             "gets the lens focus target point. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera and phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "focus_target",
             "sdk key for getfocustarget: gets the lens focus target point. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, mavic pro camera and phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setfocusassistantsettings",
             "used to enable/disable the lens focus assistant. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3, phantom 4 pro camera, x4s and x5s. because z3 only supports af mode, `isenabledmf` will be ignored.  @param settings sets whether the lens focus assistant for af and mf mode is enabled. @param callback the execution callback with the returned execution result.",
             "focus_assistant_settings",
             "sdk key for setfocusassistantsettings: used to enable/disable the lens focus assistant. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3, phantom 4 pro camera, x4s and x5s. because z3 only supports af mode, `isenabledmf` will be ignored.  @param settings sets whether the lens focus assistant for af and mf mode is enabled. @param callback the execution callback with the returned execution result.",
             "getfocusassistantsettings",
             "determines whether the lens focus assistant is enabled. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro, x4s and x5s. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "focus_assistant_settings",
             "sdk key for getfocusassistantsettings: determines whether the lens focus assistant is enabled. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro, x4s and x5s. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "getfocusringvalueupperbound",
             "gets the lens focusing ring value's max value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "focus_ring_value_upper_bound",
             "sdk key for getfocusringvalueupperbound: gets the lens focusing ring value's max value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro camera, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setfocusringvalue",
             "set the focal distance by simulating the focus ring adjustment. value can have a range of 0, `getfocusringvalueupperbound`], which represents infinity and the closest possible focal distance. it is available only when `isadjustablefocalpointsupported` returns `true`. for some lenses, the minimum focus ring value is larger than 0. for example the minimum of dji mft 15mm f/1.7 asph is 270. to retrieve the minimum value, perform the following steps: - call `setfocusmode` with `auto`. - call `setfocustarget` with the furthest target (>30m). - call `getfocusringvalue` to get the current focus ring value. this is the minimum value. the maximum value can be retrieved using `getfocusringvalueupperbound`. supported only by x5, x5r, z3 cameras, phantom 4 pro, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param value value to adjust focus ring to. the minimum value is 0, the maximum value depends on the installed lens. please use method `getfocusringvalueupperbound` to ensure the input argument is valid. @param callback the execution callback with the returned execution result.",
             "focus_ring_value",
             "sdk key for setfocusringvalue: set the focal distance by simulating the focus ring adjustment. value can have a range of 0, `getfocusringvalueupperbound`], which represents infinity and the closest possible focal distance. it is available only when `isadjustablefocalpointsupported` returns `true`. for some lenses, the minimum focus ring value is larger than 0. for example the minimum of dji mft 15mm f/1.7 asph is 270. to retrieve the minimum value, perform the following steps: - call `setfocusmode` with `auto`. - call `setfocustarget` with the furthest target (>30m). - call `getfocusringvalue` to get the current focus ring value. this is the minimum value. the maximum value can be retrieved using `getfocusringvalueupperbound`. supported only by x5, x5r, z3 cameras, phantom 4 pro, x4s, x5s, mavic 2 pro, mavic 2 zoom camera and mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param value value to adjust focus ring to. the minimum value is 0, the maximum value depends on the installed lens. please use method `getfocusringvalueupperbound` to ensure the input argument is valid. @param callback the execution callback with the returned execution result.",
             "getfocusringvalue",
             "gets the lens focus ring value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro, x4s, x5s, mavic 2 pro, mavic 2 zoom camera, mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "focus_ring_value",
             "sdk key for getfocusringvalue: gets the lens focus ring value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported only by the x5, x5r, z3 cameras, phantom 4 pro, x4s, x5s, mavic 2 pro, mavic 2 zoom camera, mavic 2 enterprise camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "success_but_out_of_screen",
             "success to get the pin point location, but point is out of liveview, should show as side indicator, please reference to dji pilot.",
             "success",
             "success to get the pin point location, the point is insde the liveview.",
             "failed",
             "failed to get the pin point location.",
             "invalid_drone_position",
             "failed to get the pin point location, because the drone position is invalid.",
             "invalid_point_position",
             "failed to get the pin point location, because the input gps location is invalid.",
             "gimbal_atti_error",
             "failed to get the pin point location, because of gimbal attitude error.",
             "camear_error",
             "failed to get the pin point location, because of camera error.",
             "result",
             "defines the result of pin point callback.",
             "getx",
             "gets the horizontal position of liveview.  @return x position.",
             "gety",
             "gets the vertical position of liveview.  @return x position.",
             "pinpoint",
             "pin point of the liveview. the point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
             "getpinpoints",
             "gets the pin points location. if the `setdisplaymode` is `pip`:`side_by_side`, it will return two pin points.  @return calculated pin points.",
             "getresult",
             "gets the result of the callback.  @return result of the callback",
             "pinpointinfo",
             "pin point information, include the pin points location in the liveview and callback result.  supported by zenmuse h20 series.",
             "getliveviewlocationwithgps",
             "gets the pinpoint information with gps which is used to show pinpoint in the liveview. supported by zenmuse h20 series.  @param pointpos the gps location, you could get the location from `gettargetlocation` or get the location with map. @param physicalsource the physical source of a video feed. @param callback the execution callback with the returned value(s).",
             "setlinkzoomenabled",
             "enable or disable the link zoom function. after enabling the link zoom function, call `setthermaldigitalzoomfactor` to achieve synchronous zooming of the infrared lens and the zoom lens.  in the split-screen mode pip, the user can compare the images of the infrared lens and the zoom lens more efficiently.  supported by zenmuse h20 series.  @param enabled true to enable link zoom. @param callback the execution callback with the returned value(s).",
             "getlinkzoomenabled",
             "gets the link zoom status. supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "restorefactorysettings",
             "load the camera's factory settings.  post condition: the camera will reboot itself.  @param callback the execution callback with the returned value(s).",
             "camerakey.restore_factory_settings",
             "sdk key for restorefactorysettings: load the camera's factory settings.  post condition: the camera will reboot itself.  @param callback the execution callback with the returned value(s).",
             "savesettingstoprofile",
             "saves the current camera settings permanently to the specified profile. see `customsettingsprofile` to view all possible camera users.  @param profile camera profile for which to store camera settings. @param callback the execution callback with the returned execution result.",
             "save_settings_to_profile",
             "sdk key for savesettingstoprofile: saves the current camera settings permanently to the specified profile. see `customsettingsprofile` to view all possible camera users.  @param profile camera profile for which to store camera settings. @param callback the execution callback with the returned execution result.",
             "loadsettingsfromprofile",
             "load camera settings from the specified user.  post condition:  the camera will reboot itself.  @param profile camera profile to load camera settings from. @param callback the execution callback with the returned execution result.",
             "load_settings_from_profile",
             "sdk key for loadsettingsfromprofile: load camera settings from the specified user.  post condition:  the camera will reboot itself.  @param profile camera profile to load camera settings from. @param callback the execution callback with the returned execution result.",
             "setphotoaspectratio",
             "sets the camera's aspect ratio for photos. see `photoaspectratio` to view all possible ratios. not supported by z30 camera as the aspect ratio of z30 is always `ratio_16_9`. not supported by xts camera as the aspect ratio of xts is always `ratio_4_3`. for zenmuse h20 and zenmuse h20t, please use class `lens`.  @param aspectratio aspect ratio for photos to be taken by camera. @param callback the execution callback with the returned execution result.",
             "photo_aspect_ratio",
             "sdk key for setphotoaspectratio: sets the camera's aspect ratio for photos. see `photoaspectratio` to view all possible ratios. not supported by z30 camera as the aspect ratio of z30 is always `ratio_16_9`. not supported by xts camera as the aspect ratio of xts is always `ratio_4_3`. for zenmuse h20 and zenmuse h20t, please use class `lens`.  @param aspectratio aspect ratio for photos to be taken by camera. @param callback the execution callback with the returned execution result.",
             "getphotoaspectratio",
             "gets the camera's aspect ratio for photos. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "photo_aspect_ratio",
             "sdk key for getphotoaspectratio: gets the camera's aspect ratio for photos. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setphotofileformat",
             "sets the camera's photo file format. see `photofileformat` to view all possible photo formats to which the camera can be set. also supported by thermal imaging camera. not supported by z30 camera and mavic 2 enterprise dual as the photo file format for z30 is always `jpeg`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param format photo file format used when the camera takes a photo. check the enum `photofileformat` to find all possible photo formats the camera can be set to. @param callback the execution callback with the returned execution result.",
             "photo_file_format",
             "sdk key for setphotofileformat: sets the camera's photo file format. see `photofileformat` to view all possible photo formats to which the camera can be set. also supported by thermal imaging camera. not supported by z30 camera and mavic 2 enterprise dual as the photo file format for z30 is always `jpeg`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param format photo file format used when the camera takes a photo. check the enum `photofileformat` to find all possible photo formats the camera can be set to. @param callback the execution callback with the returned execution result.",
             "getphotofileformat",
             "gets the camera's photo file format. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "photo_file_format",
             "sdk key for getphotofileformat: gets the camera's photo file format. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setphotoburstcount",
             "sets the burst shoot count for the camera when the user wants to use that feature. check `photoburstcount` to view all possible burst count values to which the camera can be set.  @param count the number of photos to take in one  burst shot. please check the enum `photoburstcount` to find all possible burst count values the camera can be set to. @param callback the execution callback with the returned execution result.",
             "photo_burst_count",
             "sdk key for setphotoburstcount: sets the burst shoot count for the camera when the user wants to use that feature. check `photoburstcount` to view all possible burst count values to which the camera can be set.  @param count the number of photos to take in one  burst shot. please check the enum `photoburstcount` to find all possible burst count values the camera can be set to. @param callback the execution callback with the returned execution result.",
             "getphotoburstcount",
             "gets the burst count type.  @param callback the execution callback with the returned value(s).",
             "photo_burst_count",
             "sdk key for getphotoburstcount: gets the burst count type.  @param callback the execution callback with the returned value(s).",
             "setphotorawburstcount",
             "sets the raw image burst shoot count for the camera when the user wants to use that feature. see `photoburstcount` to view all possible burst count values to which the camera can be set. it is only supported inspire 2.  @param count the number of photos to take in one raw burst shoot. @param callback the execution callback with the returned value(s).",
             "photo_raw_burst_count",
             "sdk key for setphotorawburstcount: sets the raw image burst shoot count for the camera when the user wants to use that feature. see `photoburstcount` to view all possible burst count values to which the camera can be set. it is only supported inspire 2.  @param count the number of photos to take in one raw burst shoot. @param callback the execution callback with the returned value(s).",
             "getphotorawburstcount",
             "gets the raw image burst count. it is only supported inspire 2.  @param callback the execution callback with the returned value(s).",
             "photo_raw_burst_count",
             "sdk key for getphotorawburstcount: gets the raw image burst count. it is only supported inspire 2.  @param callback the execution callback with the returned value(s).",
             "setphototimeintervalsettings",
             "sets the interval shoot parameters. the camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. also supported by thermal imaging camera.  @param settings an instance of `phototimeintervalsettings`. @param callback the execution callback with the returned execution result.",
             "photo_time_interval_settings",
             "sdk key for setphototimeintervalsettings: sets the interval shoot parameters. the camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. also supported by thermal imaging camera.  @param settings an instance of `phototimeintervalsettings`. @param callback the execution callback with the returned execution result.",
             "getphototimeintervalsettings",
             "gets the camera's interval shoot parameters. </br></br>also supported by thermal imaging camera.  @param callback the execution callback with the returned value(s).",
             "photo_time_interval_settings",
             "sdk key for getphototimeintervalsettings: gets the camera's interval shoot parameters. </br></br>also supported by thermal imaging camera.  @param callback the execution callback with the returned value(s).",
             "setphototimelapsesettings",
             "sets the timelapse parameters, including interval, duration and file format when saving. precondition: camera should be in `time_lapse` mode of `shootphotomode`.  @param settings the time between image captures. an integer falls in the range, [10, 1000]. <br>the unit is 100ms. please note that when the format is jpeg+video,<br> the minimum interval is 20(2 seconds). @param callback the execution block with the returned execution result.",
             "photo_time_lapse_settings",
             "sdk key for setphototimelapsesettings: sets the timelapse parameters, including interval, duration and file format when saving. precondition: camera should be in `time_lapse` mode of `shootphotomode`.  @param settings the time between image captures. an integer falls in the range, [10, 1000]. <br>the unit is 100ms. please note that when the format is jpeg+video,<br> the minimum interval is 20(2 seconds). @param callback the execution block with the returned execution result.",
             "getphototimelapsesettings",
             "gets the timelapse parameters including interval, duration and file format when saving. precondition: the camera must be in `time_lapse` mode of `shootphotomode`.  @param callback the execution callback with the returned value(s).",
             "photo_time_lapse_settings",
             "sdk key for getphototimelapsesettings: gets the timelapse parameters including interval, duration and file format when saving. precondition: the camera must be in `time_lapse` mode of `shootphotomode`.  @param callback the execution callback with the returned value(s).",
             "setphotopanoramamode",
             "sets the panorama mode. it is used when `setshootphotomode` is called with `panorama`.  it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.  @param mode the panorama mode to set. @param callback `completion callback` to receive the result.",
             "photo_panorama_mode",
             "sdk key for setphotopanoramamode: sets the panorama mode. it is used when `setshootphotomode` is called with `panorama`.  it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.  @param mode the panorama mode to set. @param callback `completion callback` to receive the result.",
             "getphotopanoramamode",
             "gets the panorama mode.  it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.  @param callback `completion callback` to receive the result.",
             "photo_panorama_mode",
             "sdk key for getphotopanoramamode: gets the panorama mode.  it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual.  @param callback `completion callback` to receive the result.",
             "setpanooriginalphotosettings",
             "change the original image configuration when shooting panorama photos. caution: enabling this may consume 500 mb in the sd card or the internal storage for each panorama. it is supported by spark, mavic air, mavic 2, mavic 2 pro, mavic 2 zoom, mavic 2 eneterprise, mavic 2 enterprise dual. for mavic air, `getformat` is not used and it will ignore the value.  @param settings an object of `originalphotosettings`. @param callback the execution callback with the returned execution result.",
             "getpanooriginalphotosettings",
             "gets the configuration, which determines the behavior for the original images when shooting panorama photos. caution: if this is enabled, it may consume 500 mb in the sd card or the internal storage for each panorama. it is supported by mavic air and mavic 2. however, mavic air cannot change the format to save the original images. `getformat` will be ignored by mavic air.  @param callback the execution callback with the returned execution result.",
             "sethighqualitypreviewenabled",
             "enables this before photo capture to download high quality preview image. only supported by phantom 4 rtk.  @param enabled `true` to enable the feature. @param callback the execution callback with the returned execution result.",
             "gethighqualitypreviewenabled",
             "gets if high quality preview image downloading is enabled. only supported by phantom 4 rtk.  @param callback the execution callback with the returned value(s).",
             "setvideoresolutionandframerate",
             "sets the camera's video resolution and frame rate. @warning the supported resolutions and frame rates for the two different analog television standards pal and ntsc are below:  <b>ntsc:</b>  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_30fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_30fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_60fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_30fps  resolution_1920x1080, framerate_24fps  resolution_1280x720,  framerate_60fps  resolution_1280x720,  framerate_48fps  resolution_1280x720,  framerate_30fps  resolution_1280x720,  framerate_24fps  <b>pal:</b>  resolution_4096x2160, framerate_25fps  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_25fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_25fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_50fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_25fps  resolution_1920x1080, framerate_24fps  resolution_1280x720, framerate_50fps  resolution_1280x720, framerate_48fps  resolution_1280x720, framerate_25fps  resolution_1280x720, framerate_24fps for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param resolutionandframerate resolution to be set for the video. @param callback the execution callback with the returned execution result.",
             "resolution_frame_rate",
             "sdk key for setvideoresolutionandframerate: sets the camera's video resolution and frame rate. @warning the supported resolutions and frame rates for the two different analog television standards pal and ntsc are below:  <b>ntsc:</b>  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_30fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_30fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_60fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_30fps  resolution_1920x1080, framerate_24fps  resolution_1280x720,  framerate_60fps  resolution_1280x720,  framerate_48fps  resolution_1280x720,  framerate_30fps  resolution_1280x720,  framerate_24fps  <b>pal:</b>  resolution_4096x2160, framerate_25fps  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_25fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_25fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_50fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_25fps  resolution_1920x1080, framerate_24fps  resolution_1280x720, framerate_50fps  resolution_1280x720, framerate_48fps  resolution_1280x720, framerate_25fps  resolution_1280x720, framerate_24fps for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param resolutionandframerate resolution to be set for the video. @param callback the execution callback with the returned execution result.",
             "getvideoresolutionandframerate",
             "gets the camera's video resolution and frame rate values. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "resolution_frame_rate",
             "sdk key for getvideoresolutionandframerate: gets the camera's video resolution and frame rate values. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setvideofileformat",
             "sets the camera's video file format. the default value is `mov`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param format video file format to be set for videos. @param callback the execution callback with the returned execution result.",
             "video_file_format",
             "sdk key for setvideofileformat: sets the camera's video file format. the default value is `mov`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param format video file format to be set for videos. @param callback the execution callback with the returned execution result.",
             "getvideofileformat",
             "gets the camera's video file format. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "video_file_format",
             "sdk key for getvideofileformat: gets the camera's video file format. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setvideostandard",
             "sets the camera's analog video standard. setting the video standard to pal or ntsc will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videostandard video standard value to be set for the camera. @param callback the execution callback with the returned execution result.",
             "video_standard",
             "sdk key for setvideostandard: sets the camera's analog video standard. setting the video standard to pal or ntsc will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videostandard video standard value to be set for the camera. @param callback the execution callback with the returned execution result.",
             "getvideostandard",
             "gets the camera's video standard value.  @param callback the execution callback with the returned value(s).",
             "video_standard",
             "sdk key for getvideostandard: gets the camera's video standard value.  @param callback the execution callback with the returned value(s).",
             "setvideocaptionenabled",
             "enables recording position, time and camera information into a video caption file (.srt) saved on the sd card. the information is updated at 1hz. currently the .srt file can only be downloaded directly from the sd card.  @param enabled `true` to enable video caption. @param callback the execution callback with the returned execution result.",
             "video_caption_enabled",
             "sdk key for setvideocaptionenabled: enables recording position, time and camera information into a video caption file (.srt) saved on the sd card. the information is updated at 1hz. currently the .srt file can only be downloaded directly from the sd card.  @param enabled `true` to enable video caption. @param callback the execution callback with the returned execution result.",
             "getvideocaptionenabled",
             "gets whether the video caption is enabled.  @param callback the execution callback with the returned value(s).",
             "video_caption_enabled",
             "sdk key for getvideocaptionenabled: gets whether the video caption is enabled.  @param callback the execution callback with the returned value(s).",
             "sethistogramenabled",
             "enables the histogram.  @param enabled true to enable histogram. @param callback the execution callback with the returned execution result.",
             "histogram_enabled",
             "sdk key for sethistogramenabled: enables the histogram.  @param enabled true to enable histogram. @param callback the execution callback with the returned execution result.",
             "gethistogramenabled",
             "gets whether the histogram is enabled.  @param callback the execution callback with the returned value(s).",
             "histogram_enabled",
             "sdk key for gethistogramenabled: gets whether the histogram is enabled.  @param callback the execution callback with the returned value(s).",
             "setvideofilecompressionstandard",
             "sets the video file compression standard. it is only supported x4s camera, x5s camera and phantom 4 pro. for all other products, h.264 is used.  @param standard the compression standard to use. @param callback the execution callback with the returned value(s).",
             "video_file_compression_standard",
             "sdk key for setvideofilecompressionstandard: sets the video file compression standard. it is only supported x4s camera, x5s camera and phantom 4 pro. for all other products, h.264 is used.  @param standard the compression standard to use. @param callback the execution callback with the returned value(s).",
             "getvideofilecompressionstandard",
             "gets the video file compression standard. it is only supported x4s camera, x5s camera and phantom 4 pro.  @param callback the execution callback with the returned value(s).",
             "video_file_compression_standard",
             "sdk key for getvideofilecompressionstandard: gets the video file compression standard. it is only supported x4s camera, x5s camera and phantom 4 pro.  @param callback the execution callback with the returned value(s).",
             "setssdvideorecordingenabled",
             "enables/disables the recording of raw video. it is supported by x5s. user can use the other ssd interfaces only when it is enabled. for x5r, raw recording is always enabled if there is ssd inserted.  @param enabled `true` to enable the raw video recording. @param callback the execution callback with the returned execution result.",
             "ssd_video_recording_enabled",
             "sdk key for setssdvideorecordingenabled: enables/disables the recording of raw video. it is supported by x5s. user can use the other ssd interfaces only when it is enabled. for x5r, raw recording is always enabled if there is ssd inserted.  @param enabled `true` to enable the raw video recording. @param callback the execution callback with the returned execution result.",
             "getssdvideorecordingenabled",
             "determines whether the recording of raw video is enabled. it is supported by x5s.  @param callback the execution callback with the returned value(s).",
             "ssd_video_recording_enabled",
             "sdk key for getssdvideorecordingenabled: determines whether the recording of raw video is enabled. it is supported by x5s.  @param callback the execution callback with the returned value(s).",
             "setautolockgimbalenabled",
             "enables this to lock the gimbal when the camera is shooting a photo. the gimbal will keep the attitude when starting to shoot the photo.  @param enabled `true` to enable the feature. @param callback the execution callback with the returned value(s).",
             "getautolockgimbalenabled",
             "determines whether the gimbal will be locked automatically during shooting photos.  @param callback the execution callback with the returned value(s).",
             "setwatermarksettings",
             "sets the watermark configuration. enables this to add timestamp and location stamp to the newly generated photos or videos. it is only supported by mavic 2 enterprise series. for mavic 2 enterprise dual, the watermark is only applied to photos and videos generated by the visual camera.  @param config the watermark configuration to set. @param callback the execution callback with the returned execution result.",
             "getwatermarksettings",
             "gets the watermark settings. if it is enabled, timestamp and location stamp will be added to the newly generated photos or videos. it is only supported by mavic 2 enterprise series. for mavic 2 enterprise dual, the watermark is only applied to photos and videos generated by the visual camera.  @param callback the execution callback with the returned value(s).",
             "setssdvideoresolutionandframerate",
             "set raw video resolution and frame rate of the ssd. note, only raw video is saved to the ssd. compressed video, compressed pictures and raw pictures are all saved to the sd card. during video capture, raw video and compressed video are saved simultaneously to the ssd and sd card respectively. @warning the supported resolutions and frame rates for ssd raw videos are shown below:  <b>ntsc:</b>  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_24fps  resolution_3840x2160, framerate_30fps  resolution_2704x1520, framerate_24fps  resolution_2704x1520, framerate_30fps  resolution_1920x1080, framerate_60fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_30fps  resolution_1920x1080, framerate_24fps  <b>pal:</b>  resolution_4096x2160, framerate_25fps  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_25fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_25fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_50fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_25fps  resolution_1920x1080, framerate_24fps  for x5s, the frame rate of ssd has to be the same as the video to be stored in sd card, so framerate</code> is ignored. the possible resolutions are determined by sd card video's frame rate and the ssd video license (`camerassdvideolicense`) being used. the supported resolutions in the current configuration can be queried by using `ssdvideoresolutionrange` in `capabilities`.  @param resolutionandframerate resolution and frame rate to be set for the video. @param callback the execution callback with the returned execution result.",
             "ssd_video_resolution_and_frame_rate",
             "sdk key for setssdvideoresolutionandframerate: set raw video resolution and frame rate of the ssd. note, only raw video is saved to the ssd. compressed video, compressed pictures and raw pictures are all saved to the sd card. during video capture, raw video and compressed video are saved simultaneously to the ssd and sd card respectively. @warning the supported resolutions and frame rates for ssd raw videos are shown below:  <b>ntsc:</b>  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_24fps  resolution_3840x2160, framerate_30fps  resolution_2704x1520, framerate_24fps  resolution_2704x1520, framerate_30fps  resolution_1920x1080, framerate_60fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_30fps  resolution_1920x1080, framerate_24fps  <b>pal:</b>  resolution_4096x2160, framerate_25fps  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_25fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_25fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_50fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_25fps  resolution_1920x1080, framerate_24fps  for x5s, the frame rate of ssd has to be the same as the video to be stored in sd card, so framerate</code> is ignored. the possible resolutions are determined by sd card video's frame rate and the ssd video license (`camerassdvideolicense`) being used. the supported resolutions in the current configuration can be queried by using `ssdvideoresolutionrange` in `capabilities`.  @param resolutionandframerate resolution and frame rate to be set for the video. @param callback the execution callback with the returned execution result.",
             "getssdvideoresolutionandframerate",
             "get raw video format and frame rate of the ssd.  @param callback the execution callback with the returned value(s).",
             "ssd_video_resolution_and_frame_rate",
             "sdk key for getssdvideoresolutionandframerate: get raw video format and frame rate of the ssd.  @param callback the execution callback with the returned value(s).",
             "setssdlegacycolor",
             "sets the camera color for video that will be stored in ssd. it is only applied when the selected license key is either `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`. this is the legacy version of ssd color and it is only supported by inspire 2 with firmware package versions (`getfirmwarepackageversion`) lower than 01.0.0240. for newer firmware package versions, use `setssdcolor` instead.  @param color ssd legacy color to set. @param callback the execution callback with the returned value(s).",
             "ssd_legacy_color",
             "sdk key for setssdlegacycolor: sets the camera color for video that will be stored in ssd. it is only applied when the selected license key is either `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`. this is the legacy version of ssd color and it is only supported by inspire 2 with firmware package versions (`getfirmwarepackageversion`) lower than 01.0.0240. for newer firmware package versions, use `setssdcolor` instead.  @param color ssd legacy color to set. @param callback the execution callback with the returned value(s).",
             "getssdlegacycolor",
             "gets the camera color for video that will store in ssd. this is the legacy version of ssd color and it is only supported by inspire 2 with firmware package versions (`getfirmwarepackageversion`) lower than 01.0.0240. for newer firmware package versions, use `getssdcolor` instead.  @param callback the execution callback with the returned value(s).",
             "ssd_legacy_color",
             "sdk key for getssdlegacycolor: gets the camera color for video that will store in ssd. this is the legacy version of ssd color and it is only supported by inspire 2 with firmware package versions (`getfirmwarepackageversion`) lower than 01.0.0240. for newer firmware package versions, use `getssdcolor` instead.  @param callback the execution callback with the returned value(s).",
             "setssdcolor",
             "sets the color for videos that will be stored in ssd. it is only applied when the selected license key is either `licensekeytypeprores422hq` or `licensekeytypeprores4444xq`. for `licensekeytypecinemadng`, the color is always `raw_color`. it is only supported inspire 2 with the firmware package version (`getfirmwarepackageversion`) 01.0.0240 or later. for older firmware package versions, use `setssdlegacycolor` instead.  @param color video color to set. @param callback the execution callback with the returned execution result.",
             "getssdcolor",
             "gets the color for videos that will be stored in ssd. it is only supported inspire 2 with the firmware package version (`getfirmwarepackageversion`) 01.0.0240 or later. for older firmware package versions, use `getssdlegacycolor` instead.  @param callback the execution callback with the returned `ssdcolor` enum value.",
             "getssdvideolicenses",
             "gets purchased license key(s). an inspire 2 license key activates the usage permission of cinemadng or apple prores inside cinecore 2.0. user can purchase a license key on dji's website. it is supported by inspire 2. the digital filter for video that will store in ssd. it is only supported inspire 2.  @param callback the execution callback with the returned value(s).",
             "ssd_video_licenses",
             "sdk key for getssdvideolicenses: gets purchased license key(s). an inspire 2 license key activates the usage permission of cinemadng or apple prores inside cinecore 2.0. user can purchase a license key on dji's website. it is supported by inspire 2. the digital filter for video that will store in ssd. it is only supported inspire 2.  @param callback the execution callback with the returned value(s).",
             "activatessdvideolicense",
             "sets the ssd video license to be used. if an unpurchased license is selected then only sd video will be recorded.  @param license license to used. @param callback the execution callback with the returned value(s).",
             "activate_ssd_video_license",
             "sdk key for activatessdvideolicense: sets the ssd video license to be used. if an unpurchased license is selected then only sd video will be recorded.  @param license license to used. @param callback the execution callback with the returned value(s).",
             "getssdvideolicense",
             "gets the license key being used. it is supported by inspire 2.  @param callback the execution callback with the returned value(s).",
             "activate_ssd_video_license",
             "sdk key for getssdvideolicense: gets the license key being used. it is supported by inspire 2.  @param callback the execution callback with the returned value(s).",
             "setcustomexpanddirectoryname",
             "custom expand directory name settings. after calling this interface, the newly generated media files (videos or photos) will be stored in the new folder, this new folder's name will be appended by your custom directory name. for example, the default folder name is dji_202001012359_01, you could append mission1 after it, so the new folder's name will be dji_202001012359_01_mission1. in one flight, you can set multiple expand directory names to create multiple custom folders. only supported by zenmuse p1, zenmuse l1, zenmuse h20 series.  @param name custom directory name to set. @param callback the completion callback that receives the execution result.",
             "getcustomexpanddirectoryname",
             "gets custom expand directory name. only supported by zenmuse p1, zenmuse l1, zenmuse h20 series.  @param callback the completion callback that receives the execution result.",
             "setcustomexpandfilename",
             "custom expand file name settings. by calling this interface, the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. for example, the default photo name is dji_2020012091415_999_wide.jpg, you could append waypoint1 after the default photo name, so the new photo's name will be dji_2020012091415_999_wide_waypoint1.jpg, this action will only take effect once. if you want to have the same name for all media files in one flight, you need to set this action before taking each photo. only supported by zenmmuse p1, zenmuse h20 series.  @param name custom file name to set. @param callback the completion callback that receives the execution result.",
             "getcustomexpandfilename",
             "gets custom expand file name. only supported by zenmuse p1, zenmuse h20 series.  @param callback the completion callback that receives the execution result.",
             "setfileindexmode",
             "sets the camera's file index mode for the sd card. the default value of `fileindexmode` is set to `reset`.  @param mode file index mode to be set for the camera's sd card. the default value of camerafileindexmode is set to reset. @param callback the execution callback with the returned execution result.",
             "file_index_mode",
             "sdk key for setfileindexmode: sets the camera's file index mode for the sd card. the default value of `fileindexmode` is set to `reset`.  @param mode file index mode to be set for the camera's sd card. the default value of camerafileindexmode is set to reset. @param callback the execution callback with the returned execution result.",
             "getfileindexmode",
             "gets the camera's file index mode.  @param callback the execution callback with the returned value(s).",
             "setlaserenabled",
             "sets the laser enabled. laser sensor turns on ranging function. set `true` to enable the laser distance sensor with measuring ranges to natural object. the laser sensor must be at least 3m from the target point. it is only supported for zenmuse h20 series.  @param enabled `true` to enable video caption. @param callback the execution callback with the returned value(s).",
             "getlaserenabled",
             "gets whether the laser is enabled. the laser sensor must be at least 3m from the target point. it is only supported for zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "formatsdcard",
             "formats the sd card by deleting all the data on the sd card. this does not change any settings the user may have set on the sd card.  @param callback the execution callback with the returned execution result.",
             "format_sd_card",
             "sdk key for formatsdcard: formats the sd card by deleting all the data on the sd card. this does not change any settings the user may have set on the sd card.  @param callback the execution callback with the returned execution result.",
             "formatstorage",
             "formats the storage by deleting all the data on it. it is supported by mavic 2 series, mavic 2 enterprise series, mavic air and matrice 200 v2 series.  @param storage the storage (either sd card or the internal storage) to format. when it is `sdcard`, this interface has the same effect as `formatsdcard`. @param callback the execution callback with the returned execution result.",
             "isssdsupported",
             "determines whether the ssd is supported by the camera. currently, the ssd is supported only by x5r, x4s and x5s camera. @return `true` if ssd is supported, otherwise `false`.  @return a boolean value.",
             "is_ssd_supported",
             "sdk key for isssdsupported: determines whether the ssd is supported by the camera. currently, the ssd is supported only by x5r, x4s and x5s camera. @return `true` if ssd is supported, otherwise `false`.  @return a boolean value.",
             "formatssd",
             "formats the ssd by deleting all the data on the ssd. this does not change any settings the user may have set on the ssd.  @param callback the execution callback with the returned execution result.",
             "format_ssd",
             "sdk key for formatssd: formats the ssd by deleting all the data on the ssd. this does not change any settings the user may have set on the ssd.  @param callback the execution callback with the returned execution result.",
             "setantiflickerfrequency",
             "sets the camera's anti-flicker frequency for video recording. precondition: the exposure mode must be program. note: for the z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. it is not supported by zenmuse h20 series.  @param antiflickerfrequency anti-flicker value to set for the camera. see `antiflickerfrequency` to view all the possible anti-flicker type settings for the camera. @param callback the execution callback with the returned execution result.",
             "anti_flicker_frequency",
             "sdk key for setantiflickerfrequency: sets the camera's anti-flicker frequency for video recording. precondition: the exposure mode must be program. note: for the z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. it is not supported by zenmuse h20 series.  @param antiflickerfrequency anti-flicker value to set for the camera. see `antiflickerfrequency` to view all the possible anti-flicker type settings for the camera. @param callback the execution callback with the returned execution result.",
             "getantiflickerfrequency",
             "gets the camera's anti-flicker. it is not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "anti_flicker_frequency",
             "sdk key for getantiflickerfrequency: gets the camera's anti-flicker. it is not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "setsharpness",
             "sets the camera's sharpness. the default value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param sharpness sharpness value to be set in the range of [-3, 3]. @param callback asynchronous execution result.",
             "sharpness",
             "sdk key for setsharpness: sets the camera's sharpness. the default value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param sharpness sharpness value to be set in the range of [-3, 3]. @param callback asynchronous execution result.",
             "getsharpness",
             "gets the camera's sharpness. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value of sharpness with range [-3, 3].",
             "sharpness",
             "sdk key for getsharpness: gets the camera's sharpness. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value of sharpness with range [-3, 3].",
             "setcontrast",
             "sets the camera's contrast. the default saturation value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param contrast contrast value to be set in the range of [-3, 3]. @param callback the execution callback with the returned execution result.",
             "contrast",
             "sdk key for setcontrast: sets the camera's contrast. the default saturation value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param contrast contrast value to be set in the range of [-3, 3]. @param callback the execution callback with the returned execution result.",
             "getcontrast",
             "gets the camera's contrast. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value of contrast with range [-3, 3].",
             "contrast",
             "sdk key for getcontrast: gets the camera's contrast. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value of contrast with range [-3, 3].",
             "setdefogenabled",
             "enable/disable defog feature. when defog feature is enabled, the contrast will be enhanced extraordinarily. it is only supported z30.  @param enabled `true` to enable defog feature. @param callback the execution callback with the returned value(s).",
             "defog_enabled",
             "sdk key for setdefogenabled: enable/disable defog feature. when defog feature is enabled, the contrast will be enhanced extraordinarily. it is only supported z30.  @param enabled `true` to enable defog feature. @param callback the execution callback with the returned value(s).",
             "getdefogenabled",
             "determines whether defog feature is enabled. it is only supported by z30 camera.  @param callback the execution callback with the returned value(s).",
             "defog_enabled",
             "sdk key for getdefogenabled: determines whether defog feature is enabled. it is only supported by z30 camera.  @param callback the execution callback with the returned value(s).",
             "setirfilterenabled",
             "enables/disables the ir filter (infared filter). disabling the ir filter can enhance the image in low light environments. enabling the ir filter can reduce the color distortion caused by the infared light. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param enabled `true` to enable ir-cut filter. @param callback the execution callback that receives the setter result.",
             "getirfilterenabled",
             "determines whether ir filter (infared filter) is enabled. disabling the ir filter can enhance the image in low light environments. enabling the ir filter can reduce the color distortion caused by the infared light. it is only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setsaturation",
             "sets the camera's saturation. the default saturation value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param saturation saturation value to be set in the range of [-3, 3]. the default value of the saturation value is 0. @param callback the execution callback with the returned execution result.",
             "saturation",
             "sdk key for setsaturation: sets the camera's saturation. the default saturation value is 0. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param saturation saturation value to be set in the range of [-3, 3]. the default value of the saturation value is 0. @param callback the execution callback with the returned execution result.",
             "getsaturation",
             "gets the camera's saturation. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "saturation",
             "sdk key for getsaturation: gets the camera's saturation. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setcolor",
             "sets the camera's color. the default value is `none`. for a list of all possible camera colors, see `cameracolor`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param color camera color to be applied to the camera. @param callback the execution callback with the returned execution result.",
             "camera_color",
             "sdk key for setcolor: sets the camera's color. the default value is `none`. for a list of all possible camera colors, see `cameracolor`. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param color camera color to be applied to the camera. @param callback the execution callback with the returned execution result.",
             "getcolor",
             "gets the camera's color. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "camera_color",
             "sdk key for getcolor: gets the camera's color. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setorientation",
             "sets the camera's orientation. the gimbal will rotate the roll axis based on the orientation. supported only by mavic pro.  @param orientation camera's orientation. @param callback the execution callback with the returned execution result.",
             "orientation",
             "sdk key for setorientation: sets the camera's orientation. the gimbal will rotate the roll axis based on the orientation. supported only by mavic pro.  @param orientation camera's orientation. @param callback the execution callback with the returned execution result.",
             "getorientation",
             "gets the camera's orientation. supported only by mavic pro.  @param callback the execution callback with the returned value(s).",
             "orientation",
             "sdk key for getorientation: gets the camera's orientation. supported only by mavic pro.  @param callback the execution callback with the returned value(s).",
             "setvisionstabilizationenabled",
             "enables vision stabilization for z30 camera on m200 series. the vision system in the m200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. drift in the gimbal will be most noticeable at higher zoom factors. it is only supported z30 on m200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
             "vision_stabilization_enabled",
             "sdk key for setvisionstabilizationenabled: enables vision stabilization for z30 camera on m200 series. the vision system in the m200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. drift in the gimbal will be most noticeable at higher zoom factors. it is only supported z30 on m200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
             "getvisionstabilizationenabled",
             "determines whether vision stabilization is enabled. it is only supported z30 on m200 series.  @param callback `completion callback` to receive the result.",
             "vision_stabilization_enabled",
             "sdk key for getvisionstabilizationenabled: determines whether vision stabilization is enabled. it is only supported z30 on m200 series.  @param callback `completion callback` to receive the result.",
             "setmediafilecustominformation",
             "custom information can be stored in media file's xmp meta data. the custom information is written to the media file automatically after the media file is created. this method defines the information to write. the same information will be written to all media files until the information is changed again by this method. custom information written to each file can be retrieved through `fetchcustominformation` or from the image itself when processed on a separate system. it is supported by phantom 4 pro, phantom 4 advanced, phantom 4 pro v2.0, zenmuse p1, zenmuse l1, zenmuse x4s, zenmuse x5s, zenmuse x7, mavic 2 enterprise camera and mavic 2 enterprise dual camera.  @param information custom information to set. use utf-8 encoding with a length equal to or less than 31 characters. @param callback the execution callback to receive the result.",
             "custom_information",
             "sdk key for setmediafilecustominformation: custom information can be stored in media file's xmp meta data. the custom information is written to the media file automatically after the media file is created. this method defines the information to write. the same information will be written to all media files until the information is changed again by this method. custom information written to each file can be retrieved through `fetchcustominformation` or from the image itself when processed on a separate system. it is supported by phantom 4 pro, phantom 4 advanced, phantom 4 pro v2.0, zenmuse p1, zenmuse l1, zenmuse x4s, zenmuse x5s, zenmuse x7, mavic 2 enterprise camera and mavic 2 enterprise dual camera.  @param information custom information to set. use utf-8 encoding with a length equal to or less than 31 characters. @param callback the execution callback to receive the result.",
             "getmediafilecustominformation",
             "custom information can be stored in media file's xmp meta data. this method retrieves the information that will be written to future media files. the information written to individual files can be retrieved through `fetchcustominformation`. it is only supported phantom 4 pro, phantom 4 advanced, phantom 4 pro v2.0, zenmuse p1, zenmse l1, zenmuse x4s, zenmuse x5s, zenmuse x7, mavic 2 enterprise camera and mavic 2 enterprise dual camera.  @param callback the execution callback to receive the result.",
             "custom_information",
             "sdk key for getmediafilecustominformation: custom information can be stored in media file's xmp meta data. this method retrieves the information that will be written to future media files. the information written to individual files can be retrieved through `fetchcustominformation`. it is only supported phantom 4 pro, phantom 4 advanced, phantom 4 pro v2.0, zenmuse p1, zenmse l1, zenmuse x4s, zenmuse x5s, zenmuse x7, mavic 2 enterprise camera and mavic 2 enterprise dual camera.  @param callback the execution callback to receive the result.",
             "setdewarpingenabled",
             "enables/disables dewarping (lens distortion correction) for video recorded to sd card. supported by phantom 4 pro camera, x4s, x5s and x7.  @param enabled `true` to enable video dewarping. @param callback the execution callback with the returned execution result.",
             "getdewarpingenabled",
             "determines whether dewarping (lens distortion correction) is enabled. supported by phantom 4 pro camera, x4s, x5s and x7.  @param callback the execution callback with the returned boolean value(s).",
             "initsensorcleaningmode",
             "initiates the sensor cleaning mode. calling this will change `getsensorcleaningstate` from `idle` to `initiating`. to start the sensor dedusting operation, the workflow should be:  1. call `initsensorcleaningmode`.  2. remove the lens from the camera.  3. call `startsensorcleaning`.  4. when `getsensorcleaningstate` becomes `waiting_for_lens_remount`, mount the lens back to the camera.  it is only supported zenmuse x7.  @param callback the execution callback with the returned execution result.",
             "startsensorcleaning",
             "starts cleaning the sensor. the sensor cleaning should only be started when the lens is removed from the camera. it is only supported zenmuse x7.  @param callback the execution callback with the returned execution result.",
             "exitsensorcleaningmode",
             "exits sensor cleaning mode. calling this will stop the current executing operation and change `getsensorcleaningstate` to `idle`.  @param callback the execution callback with the returned execution result.",
             "iseimodesupported",
             "determines whether the ei (exposure index) mode is supported by the camera. in this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. this mode only takes effect when the camera mode is in `record_video`. the ei mode is supported by x4s, x5s and x7. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object.  @return `true` if the ei mode is supported, otherwise `false`.",
             "setexposuresensitivitymode",
             "sets the exposure sensitivity mode. it is only supported when `iseimodesupported` returns `true`. it is supported by x4s, x5s and x7. for other cameras, only iso mode is supported.  @param mode the exposure sensitivity mode to set. @param callback the execution callback with the returned execution result.",
             "getexposuresensitivitymode",
             "gets the exposure sensitivity mode. it is only supported when `iseimodesupported` returns `true`. it is supported by x4s, x5s and x7. for other cameras, only iso mode is supported.  @param callback the execution callback with the returned `exposuresensitivitymode` enum value.",
             "setei",
             "sets ei value. the valid range can be fetched from `geteirange`. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param ei the ei value to set. @param callback the execution callback with the returned execution result.",
             "getei",
             "gets ei value. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param callback the execution callback with the returned integer value.",
             "getrecommendedei",
             "gets the ei value recommended by the camera. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param callback the execution callback with the returned integer value.",
             "geteirange",
             "gets the valid range of ei values. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param callback the execution callback with the returned int value.",
             "seteicolor",
             "sets the camera color for ei mode. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param color the camera color to set. @param callback the execution callback with the returned execution result.",
             "geteicolor",
             "gets the camera color for ei mode. it is only valid when exposure sensitivity mode is `ei`. it is only supported by x4s, x5s and x7.  @param callback the execution callback with the returned `eicolor` enum value.",
             "ismechanicalshuttersupported",
             "determines whether the mechanical shutter speed is supported by the camera or the lens (for x7). the mechanical shutter is supported by zenmuse p1, phantom 4 pro camera, x4s and x7 with dl lenses. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
             "setmechanicalshutterenabled",
             "enables the mechanical shutter. it is only valid when `ismechanicalshuttersupported` returns `true`. for zenmuse l1, this interface can not enabled in video mode.  @param enabled `true` to enable the mechanical shutter. @param callback the execution callback with the returned execution result.",
             "getmechanicalshutterenabled",
             "determines whether the mechanical shutter is enabled. it is only valid when `ismechanicalshuttersupported` returns `true`.  @param callback the execution callback with the returned boolean value.",
             "isndfiltermodesupported",
             "determines whether the nd filter mode is supported by the camera and the lens. only the dl-s 16mm f2.8 nd asph lens for x7 has a built-in nd4 filter and supports changing the modes through an application. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object.  @return `true` if the nd filter mode is supported, otherwise `false`.",
             "setndfiltermode",
             "sets the mode of nd filter. it is only valid when `isndfiltermodesupported` returns `true`.  @param mode the nd filter mode to set. @param callback the execution callback with the returned execution result.",
             "getndfiltermode",
             "gets the nd filter mode. it is only valid when `isndfiltermodesupported` returns `true`.  @param callback the execution callback with the returned `ndfiltermode` enum value.",
             "setssdclipfilename",
             "sets the clip name for the video to be stored in ssd. the clip name will be applied to the next video file stored in ssd. after saving a video file, `getclipid` will increase by 1 automatically.  it is only supported by inspire 2.  @param name the clip name to set. @param callback the execution callback with the returned execution result.",
             "getssdclipfilename",
             "gets the clip name for video to be stored in ssd. it is only supported by inspire 2.  @param callback the execution callback with the returned `ssdclipfilename` class.",
             "isphotoquickviewsupported",
             "determines whether the device supports the quick view. quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object.  @return a boolean value.",
             "is_photo_quick_view_supported",
             "sdk key for isphotoquickviewsupported: determines whether the device supports the quick view. quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. in multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. user can only access the parameters through the lens object.  @return a boolean value.",
             "setphotoquickviewduration",
             "sets the camera's quick view duration. the valid range is [0, 10] seconds. when duration is 0, it means that the quick view is disabled. the default value is 0 second. call `isphotoquickviewsupported` before using this method.  @param duration quick view duration to be set for the camera. this value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. this value must be set in the range of [0, 10] seconds. when the value is 0, quick view is disabled. the default value is 0 second. @param callback the execution callback with the returned execution result.",
             "photo_quick_view_duration",
             "sdk key for setphotoquickviewduration: sets the camera's quick view duration. the valid range is [0, 10] seconds. when duration is 0, it means that the quick view is disabled. the default value is 0 second. call `isphotoquickviewsupported` before using this method.  @param duration quick view duration to be set for the camera. this value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. this value must be set in the range of [0, 10] seconds. when the value is 0, quick view is disabled. the default value is 0 second. @param callback the execution callback with the returned execution result.",
             "getphotoquickviewduration",
             "gets the camera's quick view duration.  @param callback the execution callback with the returned value(s).",
             "photo_quick_view_duration",
             "sdk key for getphotoquickviewduration: gets the camera's quick view duration.  @param callback the execution callback with the returned value(s).",
             "sethdliveviewenabled",
             "enables hd (high-definition) live view. when it is enabled, the live view resolution is 1080p with frame rate 30 fps. the settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. if recording video in 4k, then the live stream will be limited to 720p. supported by mavic air 2, dji air 2s, mavic pro, mavic 2 pro, mavic 2 zoom and phantom 4 pro v2.0.  @param enabled enable or disable hd live view. @param callback the execution callback with the returned execution result.",
             "hd_live_view_enabled",
             "sdk key for sethdliveviewenabled: enables hd (high-definition) live view. when it is enabled, the live view resolution is 1080p with frame rate 30 fps. the settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. if recording video in 4k, then the live stream will be limited to 720p. supported by mavic air 2, dji air 2s, mavic pro, mavic 2 pro, mavic 2 zoom and phantom 4 pro v2.0.  @param enabled enable or disable hd live view. @param callback the execution callback with the returned execution result.",
             "gethdliveviewenabled",
             "`true` if 1080p live view is enabled. this will return the value of the setter, and not necessarily the actual live view resolution. for example, if recording in 4k and hd live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. supported only by , dji air 2s, mavic pro, mavic 2 pro, mavic 2 zoom and phantom 4 pro v2.0.  @param callback the execution callback with the returned value(s).",
             "hd_live_view_enabled",
             "sdk key for gethdliveviewenabled: `true` if 1080p live view is enabled. this will return the value of the setter, and not necessarily the actual live view resolution. for example, if recording in 4k and hd live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. supported only by , dji air 2s, mavic pro, mavic 2 pro, mavic 2 zoom and phantom 4 pro v2.0.  @param callback the execution callback with the returned value(s).",
             "setledautoturnoffenabled",
             "enables the automatic control of the front-arm leds. the camera can turn off the front-arm leds automatically when it shoots photos or records videos. the leds will be turned on after the shooting or recording is finished. supported only by mavic pro, mavic air, and mavic 2 series.  @param enabled enable the automatic control of the front-arm leds. @param callback the execution callback with the returned execution result.",
             "led_auto_turn_off_enabled",
             "sdk key for setledautoturnoffenabled: enables the automatic control of the front-arm leds. the camera can turn off the front-arm leds automatically when it shoots photos or records videos. the leds will be turned on after the shooting or recording is finished. supported only by mavic pro, mavic air, and mavic 2 series.  @param enabled enable the automatic control of the front-arm leds. @param callback the execution callback with the returned execution result.",
             "getledautoturnoffenabled",
             "determines whether the automatic control of the front-arm leds is enabled. supported only by mavic pro, mavic air, and mavic 2 series.  @param callback the execution callback with the returned value(s).",
             "led_auto_turn_off_enabled",
             "sdk key for getledautoturnoffenabled: determines whether the automatic control of the front-arm leds is enabled. supported only by mavic pro, mavic air, and mavic 2 series.  @param callback the execution callback with the returned value(s).",
             "setbeaconautoturnoffenabled",
             "enables the automatic control of the beacon. the camera can turn off the beacon automatically when it shoots photos or records videos. the leds will be turned on after the shooting or recording is finished. only supported by matrice 200 series v2 and zenmuse h20 series mounted on matrice 300 rtk.  @param enabled enable the automatic control of the beacon. @param callback the execution callback with the returned value(s).",
             "getbeaconautoturnoffenabled",
             "determines whether the automatic control of the beacon is enabled. only supported by m200 series v2 and zenmuse h20 series mounted on matrice 300 rtk.  @param callback the execution callback with the returned value(s).",
             "isinternalstoragesupported",
             "determines if the camera supports the internal storage or not. when it is supported, the camera shoot photos or record videos without sd card. the newly generated photos or videos will be stored in the internal storage.  @return `true` if internal storage is supported.",
             "setstoragelocation",
             "sets the storage location for the newly generated photos or videos. it is only supported when `isinternalstoragesupported` returns `true`. not supported by mavic mini, dji mini 2, dji mini se.  @param location the storage location to set. @param callback the execution callback with the returned execution result.",
             "getstoragelocation",
             "gets the storage location for the newly generated photos or videos. when `isinternalstoragesupported` returns `false`, this setting is always `sdcard`.  @param callback the execution callback with the returned execution result.",
             "isaudiorecordingsupported",
             "determines whether the current device supports audio recording. currently audio recording is supported only by the osmo camera.  @return the boolean value.",
             "is_audio_recording_supported",
             "sdk key for isaudiorecordingsupported: determines whether the current device supports audio recording. currently audio recording is supported only by the osmo camera.  @return the boolean value.",
             "setaudiorecordingenabled",
             "enables audio recording when capturing video. supported only by osmo camera.  @param enabled enable or disable audio recording. @param callback the execution callback with the returned execution result.",
             "audio_recording_enabled",
             "sdk key for setaudiorecordingenabled: enables audio recording when capturing video. supported only by osmo camera.  @param enabled enable or disable audio recording. @param callback the execution callback with the returned execution result.",
             "getaudiorecordingenabled",
             "determines whether the audio record is enabled.  @param callback the execution callback with the returned value(s).",
             "audio_recording_enabled",
             "sdk key for getaudiorecordingenabled: determines whether the audio record is enabled.  @param callback the execution callback with the returned value(s).",
             "setaudiogain",
             "sets the microphone recording gain.  @param value recording gain with range [0, 100]. @param callback the execution callback with the returned execution result.",
             "audio_gain",
             "sdk key for setaudiogain: sets the microphone recording gain.  @param value recording gain with range [0, 100]. @param callback the execution callback with the returned execution result.",
             "getaudiogain",
             "gets the microphone recording gain.  @param callback the execution callback with the returned value(s).",
             "audio_gain",
             "sdk key for getaudiogain: gets the microphone recording gain.  @param callback the execution callback with the returned value(s).",
             "setturnofffanwhenpossible",
             "this method will turn off the camera's cooling fan whenever the camera is cool enough to do so. this allows better audio recording from the internal microphone in the camera.  @param turnoffwhenpossible `true` to turn fan off whenever possible. @param callback the execution callback with the returned execution result.",
             "turn_off_fan_when_possible",
             "sdk key for setturnofffanwhenpossible: this method will turn off the camera's cooling fan whenever the camera is cool enough to do so. this allows better audio recording from the internal microphone in the camera.  @param turnoffwhenpossible `true` to turn fan off whenever possible. @param callback the execution callback with the returned execution result.",
             "getturnofffanwhenpossible",
             "determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback the execution callback with the returned value(s).",
             "turn_off_fan_when_possible",
             "sdk key for getturnofffanwhenpossible: determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback the execution callback with the returned value(s).",
             "isthermalcamera",
             "`true` if the current connected device is a thermal imaging camera. @return bool `true` if current connected device is thermal imaging camera. for zenmuse h20t and h20n, please use class `lens`.  @return a boolean value.",
             "is_thermal_camera",
             "sdk key for isthermalcamera: `true` if the current connected device is a thermal imaging camera. @return bool `true` if current connected device is thermal imaging camera. for zenmuse h20t and h20n, please use class `lens`.  @return a boolean value.",
             "setthermalroi",
             "sets the region of interest (roi). used to manage color range distribution across the screen to maximize contrast for regions of highest interest. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param roi an enum type of the region of interest to be used. please refer to `thermalroi`. @param callback the execution callback with the returned execution result.",
             "thermal_roi",
             "sdk key for setthermalroi: sets the region of interest (roi). used to manage color range distribution across the screen to maximize contrast for regions of highest interest. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param roi an enum type of the region of interest to be used. please refer to `thermalroi`. @param callback the execution callback with the returned execution result.",
             "getthermalroi",
             "gets the region of interest. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_roi",
             "sdk key for getthermalroi: gets the region of interest. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalpalette",
             "sets the palette. each palette is a unique look-up table that maps 8-bit temperature values to different colors. different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. the valid range can be fetched from `thermalpaletterange`. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param palette an enum type of the `thermalpalette` to be used. @param callback the execution callback with the returned execution result.",
             "thermal_palette",
             "sdk key for setthermalpalette: sets the palette. each palette is a unique look-up table that maps 8-bit temperature values to different colors. different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. the valid range can be fetched from `thermalpaletterange`. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param palette an enum type of the `thermalpalette` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalpalette",
             "gets the palette. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_palette",
             "sdk key for getthermalpalette: gets the palette. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalscene",
             "sets the scene to instantly enhance your image. in all modes except manual and user modes, the dde, ace, sso,  brightness and contrast are set automatically to obtain the best result. in user modes, the contrast and brightness are set automatically to obtain the best results. any settings that are made in these modes are retained if the scene is changed. in manual mode, dde, contrast and brightness are set manually. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param scene an enum type for the `thermalscene` to be used. @param callback the execution callback with the returned execution result.",
             "thermal_scene",
             "sdk key for setthermalscene: sets the scene to instantly enhance your image. in all modes except manual and user modes, the dde, ace, sso,  brightness and contrast are set automatically to obtain the best result. in user modes, the contrast and brightness are set automatically to obtain the best results. any settings that are made in these modes are retained if the scene is changed. in manual mode, dde, contrast and brightness are set manually. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param scene an enum type for the `thermalscene` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalscene",
             "gets current scene. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_scene",
             "sdk key for getthermalscene: gets current scene. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermaldde",
             "sets the digital data enhancement index (for dde dynamic mode). dde can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). it can be set manually only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value integer in range [-20, 100]. values less than 0 soften the image and filter fixed pattern noise. values greater than 0 sharpen the details in the image. value of 0 results in no enhancement. @param callback the execution callback with the returned execution result.",
             "thermal_dde",
             "sdk key for setthermaldde: sets the digital data enhancement index (for dde dynamic mode). dde can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). it can be set manually only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value integer in range [-20, 100]. values less than 0 soften the image and filter fixed pattern noise. values greater than 0 sharpen the details in the image. value of 0 results in no enhancement. @param callback the execution callback with the returned execution result.",
             "getthermaldde",
             "gets the value of digital data enhancement. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_dde",
             "sdk key for getthermaldde: gets the value of digital data enhancement. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalace",
             "set the value of active contrast enhancement. active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. it can be set manually only when the scene mode is user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback the execution callback with the returned execution result.",
             "thermal_ace",
             "sdk key for setthermalace: set the value of active contrast enhancement. active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. it can be set manually only when the scene mode is user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback the execution callback with the returned execution result.",
             "getthermalace",
             "gets the value of active contrast enhancement. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_ace",
             "sdk key for getthermalace: gets the value of active contrast enhancement. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalsso",
             "sets the value of smart scene optimization. when using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. sso allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. this is particularly useful for bi-modal scenes. it can be set manually only when the scene mode is user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value percentage of histogram to map linearly [0, 100]. @param callback the execution callback with the returned execution result.",
             "thermal_sso",
             "sdk key for setthermalsso: sets the value of smart scene optimization. when using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. sso allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. this is particularly useful for bi-modal scenes. it can be set manually only when the scene mode is user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value percentage of histogram to map linearly [0, 100]. @param callback the execution callback with the returned execution result.",
             "getthermalsso",
             "gets the value of smart scene optimization. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_sso",
             "sdk key for getthermalsso: gets the value of smart scene optimization. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalbrightness",
             "sets the brightness of the image. it can be set manually only when the scene mode is manual. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param brightness the integer value falls in [0, 16383]. @param callback the execution callback with the returned execution result.",
             "thermal_brightness",
             "sdk key for setthermalbrightness: sets the brightness of the image. it can be set manually only when the scene mode is manual. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param brightness the integer value falls in [0, 16383]. @param callback the execution callback with the returned execution result.",
             "getthermalbrightness",
             "gets the value of brightness. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_brightness",
             "sdk key for getthermalbrightness: gets the value of brightness. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalcontrast",
             "sets the value of contrast, with larger values having higher contrast. it can be set manually only when the scene mode is manual. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param contrast contrast value as an integer with range [0, 255]. @param callback the execution callback with the returned execution result.",
             "thermal_contrast",
             "sdk key for setthermalcontrast: sets the value of contrast, with larger values having higher contrast. it can be set manually only when the scene mode is manual. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param contrast contrast value as an integer with range [0, 255]. @param callback the execution callback with the returned execution result.",
             "getthermalcontrast",
             "gets contrast value. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_contrast",
             "sdk key for getthermalcontrast: gets contrast value. the value is available only when the scene mode is manual, user1, user2 or user3. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermenabled",
             "enable or disable isotherms. isotherms can be used to highlight specific temperature ranges: when disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. when enabled, only 128 values (0-127) are mapped linearly to temperature. then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. using some of the false color palettes (like rainbowiso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param enabled `true` if isotherms are enabled. @param callback the execution callback with the returned execution result.",
             "thermal_isotherm_enabled",
             "sdk key for setthermalisothermenabled: enable or disable isotherms. isotherms can be used to highlight specific temperature ranges: when disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. when enabled, only 128 values (0-127) are mapped linearly to temperature. then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. using some of the false color palettes (like rainbowiso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param enabled `true` if isotherms are enabled. @param callback the execution callback with the returned execution result.",
             "getthermalisothermenabled",
             "determines whether isotherms are enabled. `true` if isotherms are enabled. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_isotherm_enabled",
             "sdk key for getthermalisothermenabled: determines whether isotherms are enabled. `true` if isotherms are enabled. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermunit",
             "sets the unit of the isotherm ranges to either celsius or percent. different units results in different value ranges for isotherms. supported only by thermal imaging cameras except mavic 2 enterprise dual thermal camera. for mavic 2 enterprise dual, the isotherm unit is always `celsius`. for zenmuse h20t and h20n, please use class `lens`.  @param unit an enum type of the camerathermalisothermunit to be used. please refer to djicamerathermalisothermunit. @param callback the execution callback with the returned execution result.",
             "thermal_isotherm_unit",
             "sdk key for setthermalisothermunit: sets the unit of the isotherm ranges to either celsius or percent. different units results in different value ranges for isotherms. supported only by thermal imaging cameras except mavic 2 enterprise dual thermal camera. for mavic 2 enterprise dual, the isotherm unit is always `celsius`. for zenmuse h20t and h20n, please use class `lens`.  @param unit an enum type of the camerathermalisothermunit to be used. please refer to djicamerathermalisothermunit. @param callback the execution callback with the returned execution result.",
             "getthermalisothermunit",
             "gets the units for isotherm ranges. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for mavic 2 enterprise dual, the isotherm unit is always `celsius`. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_isotherm_unit",
             "sdk key for getthermalisothermunit: gets the units for isotherm ranges. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for mavic 2 enterprise dual, the isotherm unit is always `celsius`. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermuppervalue",
             "sets the upper threshold value for isotherm. all temperature values above this will use colors 224-255 from the palette. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the allowed range is [0,100]. if the unit is celsius, for mavic 2 enterprise dual thermal camera, the value range is [-10, 400]. for other thermal imaging cameras, the value range is [-40, 500]. the value can only be equal or larger than middle isotherm threshold. @param callback the execution callback with the returned execution result.",
             "thermal_isotherm_upper_value",
             "sdk key for setthermalisothermuppervalue: sets the upper threshold value for isotherm. all temperature values above this will use colors 224-255 from the palette. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the allowed range is [0,100]. if the unit is celsius, for mavic 2 enterprise dual thermal camera, the value range is [-10, 400]. for other thermal imaging cameras, the value range is [-40, 500]. the value can only be equal or larger than middle isotherm threshold. @param callback the execution callback with the returned execution result.",
             "getthermalisothermuppervalue",
             "gets the upper threshold value for isotherm. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_isotherm_upper_value",
             "sdk key for getthermalisothermuppervalue: gets the upper threshold value for isotherm. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermmiddlevalue",
             "sets the middle threshold value for isotherm. temperature values between the middle and upper isotherm threshold will be displayed with colors 176-223 from the palette. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the value falls in [0,100]. if the unit is celsius, the value range is [-40, 550]. the value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback the execution callback with the returned execution result.",
             "thermal_isotherm_middle_value",
             "sdk key for setthermalisothermmiddlevalue: sets the middle threshold value for isotherm. temperature values between the middle and upper isotherm threshold will be displayed with colors 176-223 from the palette. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the value falls in [0,100]. if the unit is celsius, the value range is [-40, 550]. the value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback the execution callback with the returned execution result.",
             "getthermalisothermmiddlevalue",
             "gets the middle threshold value for isotherm. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_isotherm_middle_value",
             "sdk key for getthermalisothermmiddlevalue: gets the middle threshold value for isotherm. supported only by thermal imaging cameras, except mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermlowervalue",
             "sets the lower threshold value for isotherm. temperature values between the lower and middle isotherm threshold will be displayed with colors 128-175 from the palette. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the value falls in [0,100]. if the unit is celsius, for mavic 2 enterprise dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. the value can only be equal or smaller than upper threshold. @param callback the execution callback with the returned execution result.",
             "thermal_isotherm_lower_value",
             "sdk key for setthermalisothermlowervalue: sets the lower threshold value for isotherm. temperature values between the lower and middle isotherm threshold will be displayed with colors 128-175 from the palette. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param value if the unit is percentage, the value falls in [0,100]. if the unit is celsius, for mavic 2 enterprise dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. the value can only be equal or smaller than upper threshold. @param callback the execution callback with the returned execution result.",
             "getthermalisothermlowervalue",
             "gets the lower threshold value for isotherm. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_isotherm_lower_value",
             "sdk key for getthermalisothermlowervalue: gets the lower threshold value for isotherm. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalgainmode",
             "sets the gain mode. low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees celsius. for higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees celsius for the 640x512 camera and -25 to 100 degrees celsius for 324 x 256 camera. mavic 2 enterprise dual has different temperature range from other thermal imaging cameras. therefore, for mavic 2 enterprise dual, the low gain mode can be used from -10 to 140 degrees celsius. the high gain mode can be used from -10 to 400 degree celsius. supported by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param mode an enum type of the `thermalgainmode` to be used. @param callback the execution callback with the returned execution result.",
             "thermal_gain_mode",
             "sdk key for setthermalgainmode: sets the gain mode. low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees celsius. for higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees celsius for the 640x512 camera and -25 to 100 degrees celsius for 324 x 256 camera. mavic 2 enterprise dual has different temperature range from other thermal imaging cameras. therefore, for mavic 2 enterprise dual, the low gain mode can be used from -10 to 140 degrees celsius. the high gain mode can be used from -10 to 400 degree celsius. supported by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param mode an enum type of the `thermalgainmode` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalgainmode",
             "gets the gain mode. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_gain_mode",
             "sdk key for getthermalgainmode: gets the gain mode. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalmeasurementmode",
             "sets the mode for thermal measurement. use callback method  `onupdate` to receive the measurement result. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param mode the desired measurement mode. @param callback execution callback that receives the getter execution result.",
             "thermal_measurement_mode",
             "sdk key for setthermalmeasurementmode: sets the mode for thermal measurement. use callback method  `onupdate` to receive the measurement result. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param mode the desired measurement mode. @param callback execution callback that receives the getter execution result.",
             "getthermalmeasurementmode",
             "gets the mode for thermal measurement. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_measurement_mode",
             "sdk key for getthermalmeasurementmode: gets the mode for thermal measurement. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermaldigitalzoomfactor",
             "adjusts the digital zoom. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param factor for resolution 640 x 512, x1,x2,x4,x8 can be set. for resolution 336 x 256, only x1,x2,x4 can be set. please refer to camerathermaldigitalzoomscale in djicamerasettingsdef. @param callback the execution callback with the returned execution result.",
             "thermal_digital_zoom_factor",
             "sdk key for setthermaldigitalzoomfactor: adjusts the digital zoom. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param factor for resolution 640 x 512, x1,x2,x4,x8 can be set. for resolution 336 x 256, only x1,x2,x4 can be set. please refer to camerathermaldigitalzoomscale in djicamerasettingsdef. @param callback the execution callback with the returned execution result.",
             "getthermaldigitalzoomfactor",
             "gets current digital zoom. supported only by thermal imaging cameras. for zenmuse h20t, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_digital_zoom_factor",
             "sdk key for getthermaldigitalzoomfactor: gets current digital zoom. supported only by thermal imaging cameras. for zenmuse h20t, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "getthermalprofile",
             "gets the thermal imaging camera profile. the profile includes information about resolution, frame rate and focal length. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_profile",
             "sdk key for getthermalprofile: gets the thermal imaging camera profile. the profile includes information about resolution, frame rate and focal length. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalspotmeteringtargetpoint",
             "sets the spot metering target point which then invoke the callback from `setthermaltemperaturecallback` with the temperature at a specific coordinate in the scene. this method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param targetpoint the desired target point. @param callback the execution callback with the returned execution result.",
             "thermal_spot_metering_target_point",
             "sdk key for setthermalspotmeteringtargetpoint: sets the spot metering target point which then invoke the callback from `setthermaltemperaturecallback` with the temperature at a specific coordinate in the scene. this method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param targetpoint the desired target point. @param callback the execution callback with the returned execution result.",
             "getthermalspotmeteringtargetpoint",
             "gets the spot metering target point if one is set, if not then returns cgpointzero. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_spot_metering_target_point",
             "sdk key for getthermalspotmeteringtargetpoint: gets the spot metering target point if one is set, if not then returns cgpointzero. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalmeteringarea",
             "set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onupdate` callback method. see `thermalareatemperatureaggregations` for the statistical values that are available. this method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t, please use class `lens`.  @param area the desired thermal metering area. @param callback the execution callback with the returned execution result.",
             "thermal_metering_area",
             "sdk key for setthermalmeteringarea: set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onupdate` callback method. see `thermalareatemperatureaggregations` for the statistical values that are available. this method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t, please use class `lens`.  @param area the desired thermal metering area. @param callback the execution callback with the returned execution result.",
             "getthermalmeteringarea",
             "get a rect representing the currently set metering area for the thermal scene. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_metering_area",
             "sdk key for getthermalmeteringarea: get a rect representing the currently set metering area for the thermal scene. supported only by xt2, mavic 2 enterprise dual and zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalffcmode",
             "set the flat-field correction (ffc) mode. supported only by thermal imaging cameras. for mavic 2 enterprise dual thermal camera, the `thermalffcmode` is always `auto`. for mavic 2 enterprise advanced camera, support `auto` and `manual`. for zenmuse h20t and h20n, please use class `lens`.  @param mode the desired ffc mode. @param callback the execution callback with the returned execution result.",
             "thermal_ffc_mode",
             "sdk key for setthermalffcmode: set the flat-field correction (ffc) mode. supported only by thermal imaging cameras. for mavic 2 enterprise dual thermal camera, the `thermalffcmode` is always `auto`. for mavic 2 enterprise advanced camera, support `auto` and `manual`. for zenmuse h20t and h20n, please use class `lens`.  @param mode the desired ffc mode. @param callback the execution callback with the returned execution result.",
             "getthermalffcmode",
             "get the currently set flat-field correction (ffc) mode. supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. for mavic 2 enterprise dual thermal camera, the `djicamera_djicamerathermalffcmode` is always `djicamera_djicamerathermalffcmode_auto`. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_ffc_mode",
             "sdk key for getthermalffcmode: get the currently set flat-field correction (ffc) mode. supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. for mavic 2 enterprise dual thermal camera, the `djicamera_djicamerathermalffcmode` is always `djicamera_djicamerathermalffcmode_auto`. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "triggerthermalffc",
             "trigger flat-field correction. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with result of the trigger action.",
             "trigger_thermal_ffc",
             "sdk key for triggerthermalffc: trigger flat-field correction. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with result of the trigger action.",
             "setthermalcustomexternalscenesettingsprofile",
             "set the custom user profile. this profile represents user-set external scene parameters for the thermal scene. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param profile the desired user profile setting. @param callback the execution callback with the returned execution result.",
             "thermal_custom_external_scene_settings_profile",
             "sdk key for setthermalcustomexternalscenesettingsprofile: set the custom user profile. this profile represents user-set external scene parameters for the thermal scene. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param profile the desired user profile setting. @param callback the execution callback with the returned execution result.",
             "getthermalcustomexternalscenesettingsprofile",
             "get the currently set custom user profile. this profile represents user-set external scene parameters for the thermal scene. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "thermal_custom_external_scene_settings_profile",
             "sdk key for getthermalcustomexternalscenesettingsprofile: get the currently set custom user profile. this profile represents user-set external scene parameters for the thermal scene. supported only by thermal imaging cameras. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned value(s).",
             "setthermalatmospherictemperature",
             "set the temperature of the atmosphere between the scene and the camera. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees celsius. @param callback the execution callback with the returned execution result.",
             "thermal_atmospheric_temperature",
             "sdk key for setthermalatmospherictemperature: set the temperature of the atmosphere between the scene and the camera. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees celsius. @param callback the execution callback with the returned execution result.",
             "setthermalatmospherictransmissioncoefficient",
             "set the transmission coefficient of the atmosphere between the scene and the camera. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param coefficient the desired atmospheric temperature, can be between 50 and 100. @param callback the execution callback with the returned execution result.",
             "thermal_atmospheric_temperature",
             "sdk key for setthermalatmospherictransmissioncoefficient: set the transmission coefficient of the atmosphere between the scene and the camera. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param coefficient the desired atmospheric temperature, can be between 50 and 100. @param callback the execution callback with the returned execution result.",
             "setthermalbackgroundtemperature",
             "set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired background reflected temperature. @param callback the execution callback with the returned execution result.",
             "thermal_background_temperature",
             "sdk key for setthermalbackgroundtemperature: set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired background reflected temperature. @param callback the execution callback with the returned execution result.",
             "setthermalsceneemissivity",
             "set the emissivity of the thermal scene, can be between 50 and 100. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param emissivity the desired scene emissivity. @param callback the execution callback with the returned execution result.",
             "thermal_scene_emissivity",
             "sdk key for setthermalsceneemissivity: set the emissivity of the thermal scene, can be between 50 and 100. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param emissivity the desired scene emissivity. @param callback the execution callback with the returned execution result.",
             "setthermalwindowreflection",
             "set assumed window reflection coefficient, can be between 0 and x where x is the window transmission coefficient parameter. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param reflection the desired window reflection coefficient. @param callback the execution callback with the returned execution result.",
             "thermal_window_reflection",
             "sdk key for setthermalwindowreflection: set assumed window reflection coefficient, can be between 0 and x where x is the window transmission coefficient parameter. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param reflection the desired window reflection coefficient. @param callback the execution callback with the returned execution result.",
             "setthermalwindowreflectedtemperature",
             "set the temperature reflected in the window, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired window reflected temperature. @param callback the execution callback with the returned execution result.",
             "thermal_window_reflected_temperature",
             "sdk key for setthermalwindowreflectedtemperature: set the temperature reflected in the window, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired window reflected temperature. @param callback the execution callback with the returned execution result.",
             "setthermalwindowtemperature",
             "set the window temperature, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired window temperature. @param callback the execution callback with the returned execution result.",
             "thermal_window_temperature",
             "sdk key for setthermalwindowtemperature: set the window temperature, can be between -50 and 327.67 degrees celsius. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param temperature the desired window temperature. @param callback the execution callback with the returned execution result.",
             "setthermalwindowtransmissioncoefficient",
             "set the window transmission coefficient, can be between 50 and 100-x where x is the window reflection. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param coefficient the desired window transmission coefficient. @param callback the execution callback with the returned execution result.",
             "thermal_window_transmission_coefficient",
             "sdk key for setthermalwindowtransmissioncoefficient: set the window transmission coefficient, can be between 50 and 100-x where x is the window reflection. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20t and h20n, please use class `lens`.  @param coefficient the desired window transmission coefficient. @param callback the execution callback with the returned execution result.",
             "setthermaltemperatureunit",
             "sets the temperature unit. only supported by xt2 and mavic 2 enterprise dual. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param temperatureunit an enum value of `temperatureunit`. @param callback the execution callback with the returned execution result.",
             "getthermaltemperatureunit",
             "gets the temperature unit. only supported by xt2 and mavic 2 enterprise dual thermal camera. for zenmuse h20t and h20n, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "setdisplaymode",
             "sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. only supported by xt2 camera and mavic 2 enterprise dual thermal camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param mode the display mode to set. @param callback the execution callback with the returned execution result.",
             "getdisplaymode",
             "gets the display mode. the display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera. only supported by xt2 camera and mavic 2 enterprise dual thermal camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "setpipposition",
             "set the picture in picture mode of xt2 camera.for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param position could be one of the enum settingsdefinitions.pipposition @param callback the execution callback with the returned execution result.",
             "getpipposition",
             "get picture in picture mode of xt2 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "setmsxlevel",
             "sets the level for msx display mode. the range for level is [0, 100]. when it is 0, the visible spectrum definition is invisible. when it is 100, the visual spectrum definition is the most obvious. only supported by xt2 camera and mavic 2 enterprise dual. mavic 2 enterprise dual does not support with firmware version lower than 01.01.0520. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param level the msx level to set with range [0, 100]. @param callback the execution callback with the returned execution result.",
             "getmsxlevel",
             "gets the level for msx display mode. the range for level is [0, 100]. when it is 0, the visible spectrum definition is invisible. when it is 100, the visual spectrum definition is the most obvious. only supported by xt2 camera and mavic 2 enterprise dual. mavic 2 enterprise dual does not support with firmware version lower than 01.01.0520. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param callback the execution callback with the returned execution result.",
             "setdualfeedverticalalignmentoffset",
             "sets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. the alignment is applied to the msx display mode. different camera results in different value ranges. for xt2 camera, the valid range is [-8, 8]. for mavic 2 enterprise dual, the valid range is [-40, 40]. positive value will move the thermal window up. use this setting to fine-tune the performance of msx display mode and the align pip mode. only supported by xt2 camera and mavic 2 enterprise dual.  @param offset range from -8 to 8 for xt2, from -40 to 40 for mavic 2 enterprise dual. @param callback the execution callback with the returned execution result.",
             "getdualfeedverticalalignmentoffset",
             "gets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. the alignment is applied to the msx display mode. different camera results in different value ranges. for xt2 camera, the valid range is [-8, 8]. for mavic 2 enterprise dual, the valid range is [-40, 40]. positive value will move the thermal window up. only supported by xt2 camera and mavic 2 enterprise dual camera.  @param callback the execution callback with the returned execution result.",
             "setdualfeedhorizontalalignmentoffset",
             "sets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. the alignment is applied to the msx display mode. different camera results in different value ranges. for xt2 camera, the valid range is [-100, 100]. for mavic 2 enterprise dual, the valid range is [-40, 40]. positive value will move the thermal window to the right. use this setting to fine-tune the performance of msx display mode and the align pip mode. only supported by xt2 camera and mavic 2 enterprise dual.  @param offset range from -100 to 100 for xt2, from -40 to 40 for mavic 2 enterprise dual. @param callback the execution callback with the returned execution result.",
             "getdualfeedhorizontalalignmentoffset",
             "gets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. the alignment is applied to the msx display mode. different camera results in different value ranges. for xt2 camera, the valid range is [-100, 100]. for mavic 2 enterprise dual, the valid range is [-40, 40]. positive value will move the thermal window to the right. only supported by xt2 camera and mavic 2 enterprise dual.  @param callback the execution callback with the returned execution result.",
             "ismultilenscamerasupported",
             "determines if the camera supports the multiple lens.  @return `true` if the multiple lens is supported.",
             "ismultivideostreamsourcesupported",
             "determines whether the camera supports multi video stream source or not.  @return a boolean value.",
             "setcameravideostreamsource",
             "sets the camera video stream source. for multi-lens cameras, the camera stream has different sources. `cameravideostreamsource` is used to represents the camera video stream source. when the source of the camera video stream is set, the current live view stream will also been changed to corresponding source. it is only supported by zenmuse h20 series.  @param cameravideostreamsource the camera video stream source. @param callback the execution callback with the returned value(s).",
             "getcameravideostreamsource",
             "gets the camera video stream source. for multi-lens cameras, the camera stream has different sources. `cameravideostreamsource` is used to represents the camera video stream source. when the source of the camera video stream is set, the image transmission will also been changed to corresponding source. it is only supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "setcapturecamerastreamsettings",
             "by default, all lenses of this camera will take photos. by using this interface, you can select your interested lens to take photos. before calling this interface, you should set the camera mode to photo mode. only supported by zenmuse h20 series.  @param streamsettings an object of `camerastreamsettings`. @param callback callback that receives the setter execution result.",
             "getcapturecamerastreamsettings",
             "gets the capture camera stream settings for taking photo. only supported by zenmuse h20 series.  @param callback callback to receive the result.",
             "setrecordcamerastreamsettings",
             "sets the camera stream settings for recording video. when recording video, it will been determined whether if current screen is recorded and which camera stream sources are recorded according the camera settings. the class of `camerastreamsettings` is used to set the camera stream settings. before calling this interface, you should set the camera mode to video mode. only supported by zenmuse h20 series.  @param streamsettings an object of `camerastreamsettings`. @param callback callback that receives the setter execution result.",
             "getrecordcamerastreamsettings",
             "gets the capture camera stream settings for recording video. only supported by zenmuse h20 series.  @param callback callback to receive the result.",
             "setmultispectraldisplaymode",
             "sets the display mode to coordinate the video feeds from both the rgb sensor and single-band sensors. only supported by multispectral camera of p4 multispectral.  @param displaymode the display mode to set. @param callback callback that receives the setter execution result.",
             "getmultispectraldisplaymode",
             "gets the display mode. the display mode determines the way to coordinate the video feeds from both the rgb sensor and single-band sensors. only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the result.",
             "setmultispectralstoragephotosettings",
             "sets the storage settings for the multispectral camera. the settings control if the photos created by different sensors will be saved or not. only supported by multispectral camera of p4 multispectral.  @param settings an object of `multispectralstoragephotosettings`. @param callback callback to receive the setter result.",
             "getmultispectralstoragephotosettings",
             "gets the storage settings for the multispectral camera. only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the getter result.",
             "setmultispectralmeteringmode",
             "sets the metering mode for the single-band sensors on the multispectral camera. the same metering mode will be applied to all single-band sensors (sensors except the rgb one). only `center` and `average` mode to be set. only supported by multispectral camera of p4 multispectral.  @param mode exposure metering to set. @param callback callback to receive the result.",
             "getmultispectralmeteringmode",
             "gets the metering mode for all single-band sensors (sensors except the rgb one). only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the result.",
             "setmultispectralexposuremode",
             "sets the exposure mode for the single-band sensors on the multispectral camera. the same exposure mode will be applied to all single-band sensors (sensors except the rgb one). exposure mode must be `program` or `shutter_priority`. only supported by multispectral camera of p4 multispectral.  @param mode camera exposure mode to set. @param callback remote execution result error block.",
             "getmultispectralexposuremode",
             "gets the exposure mode for all single-band sensors (sensors except the rgb one). only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the result.",
             "setmultispectralexposurecompensation",
             "sets the exposure compensation for the single-band sensors on the multispectral camera. the same exposure compensation will be applied to all single-band sensors (sensors except the rgb one). see `exposurecompensation` to view all possible exposure compensations to which the single-band sensors can be set. in order to use this function, set the camera exposure mode to `program` or `shutter_priority` only supported by multispectral camera of p4 multispectral.  @param compensation exposure compensation value to be set for the single-band sensors's. @param callback callback to receive the result.",
             "getmultispectralexposurecompensation",
             "gets the exposure compensation for all single-band sensors (sensors except the rgb one). only supported by multispectral camera of p4 multispectral.  @param callback callback to receive the result.",
             "setmultispectralshutterspeed",
             "sets the shutter speed for the single-band sensors on the multispectral camera. the same shutter speed will be applied to all single-band sensors (sensors except the rgb one). to see all available shutter speed value settings, see `shutterspeed`. the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate is 30fps, the shutter speed must be <= 1/30. precondition: the shutter speed can be set only when the camera exposure mode is `shutter_priority` mode. only supported by multispectral camera of p4 multispectral.  @param shutterspeed shutter speed value to be set for the single-band sensors. for all available values shutterspeed can be set to, please check `shutterspeed`. <br> the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate = 30fps, then the shutterspeed must be <= 1/30. @param callback remote execution result error block.",
             "getmultispectralshutterspeed",
             "gets the shutter speed for all single-band sensors (sensors except the rgb one). the shutter speed is only available when the camera exposure mode is `shutter_priority` mode.  @param callback callback to receive the result.",
             "setmultispectralaelock",
             "locks or unlocks the single-band sensors on the multispectral camera aelock ae (auto exposure). the same lock state will be applied to all single-band sensors (sensors except the rgb one).  @param islocked `true` if the the single-band sensors ae is locked, `false` if it is unlocked. @param callback the execution callback with the returned execution result.",
             "getmultispectralaelock",
             "determines if all the single-band (sensors except the rgb one) sensors on the multispectral camera ae (auto exposure) is locked.  @param callback callback to receive the result.",
             "djicameracalibratestate",
             "the calibration status of the camera's lens.",
             "not_calibrate",
             "if the camera lenses are not calibrated. focusing action will be influenced. please use calibration interface if you need.",
             "calibrated",
             "camera lens calibrated. do not need to calibrate.",
             "calibrating",
             "calibration is in progress.",
             "waiting_for_calibrate",
             "waiting for the calibration.",
             "other",
             "the camera lens's state is unknown.",
             "djicameracalibrateresult",
             "the calibration result of the camera's lens.",
             "idle",
             "no calibration.",
             "completed",
             "the calibration is successful.",
             "fail_normal",
             "the calibration is failed. please retry.",
             "data_error",
             "the calibration is failed because of the data error. please retry.",
             "other",
             "the calibration is failed with the unknown error.",
             "calibrationcallback",
             "an interface for obtaining camera calibration state and result.",
             "onstateupdate",
             "callback function that updates the camera calibartion state.  @param state the camera calibration state.",
             "onresultupdate",
             "callback function that updates the camera calibartion result.  @param result the camera calibration result.",
             "startcalibration",
             "if you encounter the following situation, please call this interface for camera calibration. only supported by zemmuse p1.  1. zemmuse p1 supports the replacement of a variety of fixed focus lenses, so when the lens is replaced, it is recommended that you recalibrate.  2. please listen the `onstateupdate`, if the status is `not_calibrate`, please recalibrate.  3. please listen the hms error code, if you listen to the following error code, please recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1c000d02: the camera calibration file failed to load, please perform infinity calibration.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1c000d03: infinity focus calibration data expired. recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1c000d04: infinity focus calibration data expired. recalibrate.  the following are the calibration steps:  1. take off and ascend to 102 meters (335ft) or higher to start calibration. fly with caution.  2. call `startcalibration` interface. the state will change to `waiting_for_calibrate`.  3. set gimbal angle as -90 degrees(perpendicular to the ground). call `setfocustarget` interface to set the object with multiple distinct visual patterns at the center of the camera view as focus. then the state will change to `calibrating`.  4. after finish the calibration, the state will change to `calibrated`. you can use `djicameracalibrateresult` to listen the calibration result.  @param callback the execution callback with the returned value(s).",
             "stopcalibration",
             "stop camera calibraion.  @param callback the execution callback with the returned value(s).",
             "calibratedinfinityfocus",
             "make sure you have calibrated the lens' infinity focusing with `startcalibration`. when in use, the lens uses infinity focus as calibrated. to help ensure focusing accuracy, recalibrate the infinity focus when there is a large temperature difference between the mission environment and the calibration environment (>15 degrees celsius).  @param callback the execution callback with the returned value(s).",
             "callback",
             "tells that a new media file (photo or video) is generated.  note:because the firmware cannot return some information correctly, so the interface is deprecated, please use `newfileinfocallback` insteaded.",
             "newfileinfocallback",
             "tells that a new media file (photo or video) is generated.",
             "timelapsepreviewcallback",
             "tells the callback that a preview image for the time-lapse is generated. this method is available only when istimelapsesupported returns true.",
             "histogramcallback",
             "called whenever the camera histogram's light values change.",
             "tapzoomstatecallback",
             "called when the camera's zoom state is updated. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.",
             "temperaturedatacallback",
             "received temperature in degrees celsius of image. for the xt, the temperature measurement data is the average of the center four pixels of the image. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.",
             "thermal_temperature_data",
             "sdk key for temperaturedatacallback: received temperature in degrees celsius of image. for the xt, the temperature measurement data is the average of the center four pixels of the image. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.",
             "systemstate",
             "this class provides general information and current status of the camera.",
             "focusstate",
             "this class contains information about the lens' current state, including lens type, focus status, focus mode, focus assistant state, and auto focus (af) switch state.",
             "storagestate",
             "this class provides the general information and state of the storage (sd card or the internal storage).",
             "ssdstate",
             "this class contains the information about camera's solid state drive (ssd) information, including state, whether it is connected, its capacity, video size and rate, etc.",
             "mediamanager",
             "the media manager is used to interact with the file system on the sd card or the internal storage. by using the media manager, the user can get the metadata for all the multimedia files, and has access to each individual multimedia file.",
             "playbackmanager",
             "the playback manager is used to interact with the playback system of the camera. by using the playback manager, the user can control the playback system.",
             "capabilities",
             "some of the camera's parameters have dynamic ranges. the `capabilities` class allows you to query the valid range for a parameter. type-casting is required to get the corresponding enumerator value for each range element.",
             "settingsdefinitions",
             "this class contains all the enums and setting classes for the dji camera.",
             "flatcameramode",
             "flat camera mode can be used to set the mode to camera directly. the benefit is no need to set the camera mode to shoot photo mode or the record video first. please use `setflatmode` to set the flat mode. this is available only when `isflatcameramodesupported` returns `true`.",
             "lenstype",
             "camera lens type. only supported by zenmuse h20 series.",
             "multispectraldisplaymode",
             "display modes to coordinate the video feeds from both the rgb sensor and single- band sensors. only supported by multispectral camera of p4 multispectral.",
             "spectrumband",
             "enums represent the spectrum bands of a multispectral camera. for p4 multispectral, the camera supports 5 bands. only supported by multispectral camera of p4 multispectral.",
             "cameramode",
             "camera work modes.",
             "camerakey.mode",
             "sdk key for cameramode: camera work modes.",
             "mode_range",
             "sdk key for cameramode: camera work modes.",
             "shootphotomode",
             "the shootphoto mode itself can have several modes. the default value is `single`.",
             "shoot_photo_mode",
             "sdk key for shootphotomode: the shootphoto mode itself can have several modes. the default value is `single`.",
             "shoot_photo_mode_range",
             "sdk key for shootphotomode: the shootphoto mode itself can have several modes. the default value is `single`.",
             "exposuremode",
             "camera exposure modes. the default value is `program`. the different exposure modes define whether aperture, shutter speed, iso can be set automatically or manually. exposure compensation can be changed in all modes except manual mode where it is not settable. x5, x5r, phantom 4 pro camera, x4s and x5s:  program mode:       shutter: auto     aperture: auto     iso: manual or auto  shutter priority: shutter: manual   aperture: auto     iso: manual or auto  aperture priority:  shutter: auto     aperture: manual iso: manual or auto  manual mode:        shutter: manual   aperture: manual   iso: manual all other cameras:</b>  program mode:       shutter: auto     aperture: fixed    iso: auto  shutter priority: shutter: manual   aperture: fixed    iso: auto  aperture priority:  na  manual mode:        shutter: manual aperture: manual   iso: manual",
             "exposure_mode",
             "sdk key for exposuremode: camera exposure modes. the default value is `program`. the different exposure modes define whether aperture, shutter speed, iso can be set automatically or manually. exposure compensation can be changed in all modes except manual mode where it is not settable. x5, x5r, phantom 4 pro camera, x4s and x5s:  program mode:       shutter: auto     aperture: auto     iso: manual or auto  shutter priority: shutter: manual   aperture: auto     iso: manual or auto  aperture priority:  shutter: auto     aperture: manual iso: manual or auto  manual mode:        shutter: manual   aperture: manual   iso: manual all other cameras:</b>  program mode:       shutter: auto     aperture: fixed    iso: auto  shutter priority: shutter: manual   aperture: fixed    iso: auto  aperture priority:  na  manual mode:        shutter: manual aperture: manual   iso: manual",
             "exposure_mode_range",
             "sdk key for exposuremode: camera exposure modes. the default value is `program`. the different exposure modes define whether aperture, shutter speed, iso can be set automatically or manually. exposure compensation can be changed in all modes except manual mode where it is not settable. x5, x5r, phantom 4 pro camera, x4s and x5s:  program mode:       shutter: auto     aperture: auto     iso: manual or auto  shutter priority: shutter: manual   aperture: auto     iso: manual or auto  aperture priority:  shutter: auto     aperture: manual iso: manual or auto  manual mode:        shutter: manual   aperture: manual   iso: manual all other cameras:</b>  program mode:       shutter: auto     aperture: fixed    iso: auto  shutter priority: shutter: manual   aperture: fixed    iso: auto  aperture priority:  na  manual mode:        shutter: manual aperture: manual   iso: manual",
             "shutterspeed",
             "camera's shutter speed options.",
             "shutter_speed",
             "sdk key for shutterspeed: camera's shutter speed options.",
             "shutter_speed_range",
             "sdk key for shutterspeed: camera's shutter speed options.",
             "iso",
             "camera iso values.",
             "iso",
             "sdk key for iso: camera iso values.",
             "iso_range",
             "sdk key for iso: camera iso values.",
             "aperture",
             "camera aperture values. zenmuse p1, x5, x5r, z30, phantom 4 pro camera, x4s and x5s support this setting.",
             "aperture",
             "sdk key for aperture: camera aperture values. zenmuse p1, x5, x5r, z30, phantom 4 pro camera, x4s and x5s support this setting.",
             "aperture_range",
             "sdk key for aperture: camera aperture values. zenmuse p1, x5, x5r, z30, phantom 4 pro camera, x4s and x5s support this setting.",
             "whitebalance",
             "this class contains current values for some camera parameters related to white balance. values for the camera's current white balance preset and color temperature can be obtained from this class.",
             "white_balance",
             "sdk key for whitebalance: this class contains current values for some camera parameters related to white balance. values for the camera's current white balance preset and color temperature can be obtained from this class.",
             "ssdclipfilename",
             "the name of a video file stored in ssd.",
             "originalphotosettings",
             "settings to determine the behavior for the original photos created when doing composite shooting (e.g. panorama).",
             "multispectralstoragephotosettings",
             "the settings for storing photos produced by a multispectral camera. use the mutable class if modification of the settings is required. only supported by multispectral camera of p4 multispectral.",
             "multispectralexposurestate",
             "the exposure state of a single-band sensor on the multispectral camera. the parameters in the state determines the relationship between exposure and sensor data values. when the camera is in different exposure modes, parameters may be changed by the camera automatically to optimize the exposure.",
             "watermarksettings",
             "the watermark configuration to decide if timestamp and location stamp will be added to photos or videos.",
             "lasermeasureinformation",
             "the class is used to save laser sensor information which includes the laser sensor switch status, the target object information and laser state. the laser sensor must be at least 3m from the target point. only supported by zenmuse h20 series.",
             "whitebalancepreset",
             "camera white balance. the default value is auto.",
             "white_balance",
             "sdk key for whitebalancepreset: camera white balance. the default value is auto.",
             "white_balance_present_range",
             "sdk key for whitebalancepreset: camera white balance. the default value is auto.",
             "meteringmode",
             "camera exposure metering. the default value is center.",
             "metering_mode",
             "sdk key for meteringmode: camera exposure metering. the default value is center.",
             "exposurecompensation",
             "camera exposure compensation.",
             "exposure_compensation",
             "sdk key for exposurecompensation: camera exposure compensation.",
             "exposure_compensation_range",
             "sdk key for exposurecompensation: camera exposure compensation.",
             "exposuresettings",
             "this class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the iso value, the shutter speed, and the aperture value. when the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in program, shutter priority and aperture priority modes), or report back the current exposure (in manual mode). the current values of these parameters used by the camera are contained in this class.",
             "exposure_settings",
             "sdk key for exposuresettings: this class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the iso value, the shutter speed, and the aperture value. when the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in program, shutter priority and aperture priority modes), or report back the current exposure (in manual mode). the current values of these parameters used by the camera are contained in this class.",
             "displaymode",
             "display modes to coordinate the video feeds from both the visual camera and the thermal camera. only supported by xt2 camera and and mavic 2 enterprise dual camera.",
             "camerakey.display_mode",
             "sdk key for displaymode: display modes to coordinate the video feeds from both the visual camera and the thermal camera. only supported by xt2 camera and and mavic 2 enterprise dual camera.",
             "pipposition",
             "possible positions to place the window of the thermal camera video feed when the display mode is `pip`. only supported by xt2 camera and mavic 2 enterprise dual light camera.",
             "camerakey.pip_position",
             "sdk key for pipposition: possible positions to place the window of the thermal camera video feed when the display mode is `pip`. only supported by xt2 camera and mavic 2 enterprise dual light camera.",
             "opticalzoomspec",
             "zoom lens profile. includes focal length range and minimum focal length step. supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "optical_zoom_spec",
             "sdk key for opticalzoomspec: zoom lens profile. includes focal length range and minimum focal length step. supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "zoomdirection",
             "the direction to adjust the camera zoom (camera focal length). supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "start_continuous_optical_zoom",
             "sdk key for zoomdirection: the direction to adjust the camera zoom (camera focal length). supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "hybridzoomspec",
             "hybrid zoom lens profile. includes focal length range and maximum optical focal length and minimum focal length step. supported by mavic 2 zoom camera and mavic 2 enterprise camera.",
             "zoomspeed",
             "the speed of lens to zoom. the speed of lens to zoom. supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "start_continuous_optical_zoom",
             "sdk key for zoomspeed: the speed of lens to zoom. the speed of lens to zoom. supported by x5, x5r and x5s with zoom lens, z3 camera and z30 camera.",
             "tapzoomstate",
             "the state of the tap zoom action. only supported by z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please access the value through class `lens`.",
             "focusmode",
             "camera focus mode. it is settable only when `isadjustablefocalpointsupported` returns `true` and the physical af switch on the camera is set to auto.",
             "focus_mode",
             "sdk key for focusmode: camera focus mode. it is settable only when `isadjustablefocalpointsupported` returns `true` and the physical af switch on the camera is set to auto.",
             "focusstatus",
             "the focusing status of the camera's lens.",
             "focus_status",
             "sdk key for focusstatus: the focusing status of the camera's lens.",
             "sensorcleaningstate",
             "the states of the sensor cleaning operation.",
             "sensor_cleaning_state",
             "sdk key for sensorcleaningstate: the states of the sensor cleaning operation.",
             "focusassistantsettings",
             "stores the focus settings",
             "focus_assistant_settings",
             "sdk key for focusassistantsettings: stores the focus settings",
             "photofileformat",
             "camera photo file formats. the default value is jpeg.",
             "photo_file_format",
             "sdk key for photofileformat: camera photo file formats. the default value is jpeg.",
             "photo_file_format_range",
             "sdk key for photofileformat: camera photo file formats. the default value is jpeg.",
             "pano_original_images_format_range",
             "sdk key for photofileformat: camera photo file formats. the default value is jpeg.",
             "photoaebcount",
             "the number of pictures to continuously take at one time in aeb mode. use with `djicameraphotoaebparam`.",
             "photo_aeb_count",
             "sdk key for photoaebcount: the number of pictures to continuously take at one time in aeb mode. use with `djicameraphotoaebparam`.",
             "photoaspectratio",
             "photo aspect ratio, where the first value is the width and the second value is the height. the default value is `ratio_4_3`.",
             "photo_aspect_ratio",
             "sdk key for photoaspectratio: photo aspect ratio, where the first value is the width and the second value is the height. the default value is `ratio_4_3`.",
             "photo_aspect_ratio_range",
             "sdk key for photoaspectratio: photo aspect ratio, where the first value is the width and the second value is the height. the default value is `ratio_4_3`.",
             "photoburstcount",
             "the number of photos taken in one burst shot (shooting photo in burst mode).",
             "photo_burst_count",
             "sdk key for photoburstcount: the number of photos taken in one burst shot (shooting photo in burst mode).",
             "photo_raw_burst_count",
             "sdk key for photoburstcount: the number of photos taken in one burst shot (shooting photo in burst mode).",
             "phototimelapsefileformat",
             "file format for camera when it is in time-lapse mode. the default file format is video. if video+jpeg is selected the minimum interval will be 2 seconds.",
             "photo_time_lapse_settings",
             "sdk key for phototimelapsefileformat: file format for camera when it is in time-lapse mode. the default file format is video. if video+jpeg is selected the minimum interval will be 2 seconds.",
             "phototimeintervalsettings",
             "sets the number of pictures, and sets the time interval between pictures for the interval shoot photo mode.",
             "photo_time_interval_settings",
             "sdk key for phototimeintervalsettings: sets the number of pictures, and sets the time interval between pictures for the interval shoot photo mode.",
             "phototimelapsesettings",
             "stores the time lapse settings.",
             "photo_time_lapse_settings",
             "sdk key for phototimelapsesettings: stores the time lapse settings.",
             "photopanoramamode",
             "panorama photo modes.",
             "photo_panorama_mode",
             "sdk key for photopanoramamode: panorama photo modes.",
             "videofileformat",
             "video storage formats.",
             "video_file_format",
             "sdk key for videofileformat: video storage formats.",
             "video_file_format_range",
             "sdk key for videofileformat: video storage formats.",
             "videoresolution",
             "camera video resolution values. the resolutions available for a product are in `videoresolutionandframeraterange`.",
             "video_resolution_frame_rate_range",
             "sdk key for videoresolution: camera video resolution values. the resolutions available for a product are in `videoresolutionandframeraterange`.",
             "ssd_video_resolution_range",
             "sdk key for videoresolution: camera video resolution values. the resolutions available for a product are in `videoresolutionandframeraterange`.",
             "videoframerate",
             "camera video frame rate values. the frame rates available for a product are in `videoresolutionandframeraterange`.",
             "video_resolution_frame_rate_range",
             "sdk key for videoframerate: camera video frame rate values. the frame rates available for a product are in `videoresolutionandframeraterange`.",
             "videofov",
             "fov (field-of-view) to use for recording a video.",
             "resolutionandframerate",
             "this class contains current values for camera parameters related to video resolution and video frame rate.",
             "videostandard",
             "video standard values. the default value is ntsc. for zenmuse h20 series, please access the value through class `lens`.",
             "video_standard",
             "sdk key for videostandard: video standard values. the default value is ntsc. for zenmuse h20 series, please access the value through class `lens`.",
             "video_standard_range",
             "sdk key for videostandard: video standard values. the default value is ntsc. for zenmuse h20 series, please access the value through class `lens`.",
             "videofilecompressionstandard",
             "the compression standard used to store the video files. it is only supported x4s, x5s and phantom 4 pro cameras.",
             "video_file_compression_standard",
             "sdk key for videofilecompressionstandard: the compression standard used to store the video files. it is only supported x4s, x5s and phantom 4 pro cameras.",
             "camerassdvideolicense",
             "dji camera's license keys. an inspire 2 license key activates the usage permission of cinemadng or apple prores inside cinecore 2.0. license keys are obtained by by purchase from the dji store website using the inspire 2 serial number. the inspire 2 is then connected to dji assistant 2, and the license keys downloaded to it. it is only supported x5s and x7 cameras.",
             "activate_ssd_video_license",
             "sdk key for camerassdvideolicense: dji camera's license keys. an inspire 2 license key activates the usage permission of cinemadng or apple prores inside cinecore 2.0. license keys are obtained by by purchase from the dji store website using the inspire 2 serial number. the inspire 2 is then connected to dji assistant 2, and the license keys downloaded to it. it is only supported x5s and x7 cameras.",
             "ssd_video_licenses",
             "sdk key for camerassdvideolicense: dji camera's license keys. an inspire 2 license key activates the usage permission of cinemadng or apple prores inside cinecore 2.0. license keys are obtained by by purchase from the dji store website using the inspire 2 serial number. the inspire 2 is then connected to dji assistant 2, and the license keys downloaded to it. it is only supported x5s and x7 cameras.",
             "ssdlegacycolor",
             "the legacy camera color for videos that will be stored in ssd. the default value is `none`. it is only supported inspire 2 with firmware package versions lower than 01.0.0240.",
             "ssd_legacy_color",
             "sdk key for ssdlegacycolor: the legacy camera color for videos that will be stored in ssd. the default value is `none`. it is only supported inspire 2 with firmware package versions lower than 01.0.0240.",
             "ssdcolor",
             "camera colors for videos that will be stored in ssd. it is only supported inspire 2 with the firmware package version 01.0.0240 or later.",
             "ssd_color",
             "sdk key for ssdcolor: camera colors for videos that will be stored in ssd. it is only supported inspire 2 with the firmware package version 01.0.0240 or later.",
             "ssd_color_range",
             "sdk key for ssdcolor: camera colors for videos that will be stored in ssd. it is only supported inspire 2 with the firmware package version 01.0.0240 or later.",
             "exposuresensitivitymode",
             "the exposure sensitivity modes.",
             "exposure_sensitivity_mode",
             "sdk key for exposuresensitivitymode: the exposure sensitivity modes.",
             "antiflickerfrequency",
             "camera anti-flickers. the default value is `manual_50hz`.",
             "anti_flicker_frequency",
             "sdk key for antiflickerfrequency: camera anti-flickers. the default value is `manual_50hz`.",
             "anti_flicker_range",
             "sdk key for antiflickerfrequency: camera anti-flickers. the default value is `manual_50hz`.",
             "exposurestate",
             "camera exposure state.",
             "ssdoperationstate",
             "solid state drive (ssd) state.",
             "ssd_operation_state",
             "sdk key for ssdoperationstate: solid state drive (ssd) state.",
             "ssdcapacity",
             "solid state drive (ssd) capacity.",
             "ssd_total_space",
             "sdk key for ssdcapacity: solid state drive (ssd) capacity.",
             "fileindexmode",
             "file index modes.",
             "file_index_mode",
             "sdk key for fileindexmode: file index modes.",
             "ndfiltermode",
             "modes of nd filter.",
             "ndfilter_mode",
             "sdk key for ndfiltermode: modes of nd filter.",
             "customsettingsprofile",
             "camera user settings. a user can save or load camera settings to or from the specified user.",
             "save_settings_to_profile",
             "sdk key for customsettingsprofile: camera user settings. a user can save or load camera settings to or from the specified user.",
             "load_settings_from_profile",
             "sdk key for customsettingsprofile: camera user settings. a user can save or load camera settings to or from the specified user.",
             "cameracolor",
             "camera color. the default value is `none`. z30 camera only supports `none`, `black_and_white` and `inverse`.",
             "camera_color",
             "sdk key for cameracolor: camera color. the default value is `none`. z30 camera only supports `none`, `black_and_white` and `inverse`.",
             "camera_color_range",
             "sdk key for cameracolor: camera color. the default value is `none`. z30 camera only supports `none`, `black_and_white` and `inverse`.",
             "eicolor",
             "camera colors for ei mode.",
             "ei_color",
             "sdk key for eicolor: camera colors for ei mode.",
             "orientation",
             "physical orientation of the camera.",
             "orientation",
             "sdk key for orientation: physical orientation of the camera.",
             "orientation_range",
             "sdk key for orientation: physical orientation of the camera.",
             "picturestylepresettype",
             "camera preset type, a combine of saturation, contrast, sharpness.",
             "picture_style_preset",
             "sdk key for picturestylepresettype: camera preset type, a combine of saturation, contrast, sharpness.",
             "temperatureunit",
             "the temperature units.",
             "temperature_unit",
             "sdk key for temperatureunit: the temperature units.",
             "picturestylepreset",
             "camera preset type that stores saturation, contrast and sharpness",
             "picture_style_preset",
             "sdk key for picturestylepreset: camera preset type that stores saturation, contrast and sharpness",
             "storagelocation",
             "different storage locations supported by the camera.",
             "camera_storage_location",
             "sdk key for storagelocation: different storage locations supported by the camera.",
             "cameravideostreamsource",
             "the enumeration represents which lens the camera stream comes from. the camera video stream will been used to transfer to image transmission to display and determine which lens were taken photo or recording. it is only supported by zenmuse h20 series camera.",
             "camerastreamsettings",
             "the class is used to save camera video stream settings during taking photo or recording video.`needcurrentliveviewstream` is used to determine whether if current live view stream(set by `setcameravideostreamsource`) will be captured or recorded when taking photo or recording video. `getcameravideostreamsources` is used to determine which camera stream source will be captured or recorded. only supported by zenmuse h20 series camera.",
             "needcurrentliveviewstream",
             "determines whether if current live view stream need to been captured or recorded when taking photo or recording video.  @return `true` if needed to save current liveview stream.",
             "getcameravideostreamsources",
             "determines which camera video stream source will been captured or recorded when taking photo or recording video. the camera video stream source came from `cameravideostreamsource`.  @return a list of `cameravideostreamsource`.",
             "colorwaveformsettings",
             "stores the focus settings.",
             "thermalroi",
             "region of interest. use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
             "thermal_roi",
             "sdk key for thermalroi: region of interest. use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
             "thermalpalette",
             "the different colors are used to show various temperatures in the thermal imagery image. the colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
             "thermal_palette",
             "sdk key for thermalpalette: the different colors are used to show various temperatures in the thermal imagery image. the colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
             "thermalscene",
             "uses the scene option to instantly enhance your image.",
             "thermal_scene",
             "sdk key for thermalscene: uses the scene option to instantly enhance your image.",
             "thermalisothermunit",
             "the unit for isotherm. for zenmuse h20t and h20n, please access the value through class `lens`.",
             "thermal_isotherm_unit",
             "sdk key for thermalisothermunit: the unit for isotherm. for zenmuse h20t and h20n, please access the value through class `lens`.",
             "thermalgainmode",
             "the gain mode.",
             "thermal_gain_mode",
             "sdk key for thermalgainmode: the gain mode.",
             "thermalresolution",
             "the resolution of thermal imaging camera.",
             "thermal_profile",
             "sdk key for thermalresolution: the resolution of thermal imaging camera.",
             "thermalframerateupperbound",
             "the frame rate upper bound supported by the thermal camera.",
             "thermallensfocallength",
             "the focal length of the thermal imaging camera.",
             "thermal_profile",
             "sdk key for thermallensfocallength: the focal length of the thermal imaging camera.",
             "thermalversion",
             "there is a standard version and version with advanced radiometry capabilities of the zenmuse xt thermal camera. this enum defines the versions.",
             "thermalcustomexternalscenesettingsprofile",
             "user defined parameters.",
             "thermal_custom_external_scene_settings_profile",
             "sdk key for thermalcustomexternalscenesettingsprofile: user defined parameters.",
             "thermalffcmode",
             "flat-field correction mods.",
             "thermal_ffc_mode",
             "sdk key for thermalffcmode: flat-field correction mods.",
             "thermalprofile",
             "the profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
             "thermal_profile",
             "sdk key for thermalprofile: the profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
             "thermaldigitalzoomfactor",
             "thermal camera digital zoom scale. the default value is x1.",
             "thermal_digital_zoom_factor",
             "sdk key for thermaldigitalzoomfactor: thermal camera digital zoom scale. the default value is x1.",
             "thermalmeasurementmode",
             "thermal camera temperature measurement mode. the default value is  disabled.",
             "thermal_measurement_mode",
             "sdk key for thermalmeasurementmode: thermal camera temperature measurement mode. the default value is  disabled.",
             "thermalareatemperatureaggregations",
             "the aggregate temperature measurements for a selected metering area.",
             "thermal_area_temperature_aggregations",
             "sdk key for thermalareatemperatureaggregations: the aggregate temperature measurements for a selected metering area.",
             "thermalexternalscenesettings",
             "thermal cameras measure the apparent surface temperature of a given object. this is done by taking the amount of infrared radiation an object emits and calculating the surface temperature by applying a formula that adjusts for external factors. this struct includes all of the external scene parameters that the thermal camera firmware allows  to be customized. there are two types of parameters, optical parameters which specify how much infrared  radiation is transmitted from the surface to the thermal sensor, as well as parameters that specify sources of thermal radiance other than the object. for a more in-depth overview of the physics behind thermal imaging, see https://en.wikipedia.org/wiki/thermography.",
             "displaynamephantom3standardcamera",
             "the display name for phantom 3 standard camera.",
             "displaynamephantom3advancedcamera",
             "the display name for phantom 3 advanced camera.",
             "displaynamephantom3professionalcamera",
             "the display name for phantom 3 professional camera.",
             "displaynamephantom34kcamera",
             "the display name for phantom 3 4k camera.",
             "displaynamex3",
             "the display name for x3 camera.",
             "displaynamex5",
             "the display name for x5 camera.",
             "displaynamex5r",
             "the display name for x5r camera.",
             "displaynamephantom4camera",
             "the display name for phantom 4 camera.",
             "displaynamephantom4procamera",
             "the display name for phantom 4 pro camera.",
             "displaynamext",
             "the display name for zenmuse xt camera.",
             "displaynamexts",
             "the display name for zenmuse xt s camera.",
             "displaynamez3",
             "the display name for z3 camera.",
             "displaynamemavicprocamera",
             "the display name for mavic pro camera.",
             "displaynamesparkcamera",
             "the display name for spark camera.",
             "displaynamephantom4pv2camera",
             "the display name for phantom 4 pro v2 camera.",
             "displaynamephantom4rtkcamera",
             "the display name for phantom 4 rtk camera.",
             "displaynamex7",
             "the display name for x7 camera.",
             "displaynamext2_ir",
             "the display name for xt2 thermal camera.",
             "displaynamext2_vl",
             "the display name for xt2 visual camera.",
             "displaynamemavicaircamera",
             "the display name for mavic air camera.",
             "displaynamemavic2zoomcamera",
             "the display name for mavic 2 zoom camera.",
             "displaynamemavic2procamera",
             "the display name for mavic 2 pro camera.",
             "displaynamemavic2enterprisecamera",
             "the display name for mavic 2 enterprise.",
             "displaynamemavic2enterprisedual_ir",
             "the display name for mavic 2 enterprise dual thermal camera.",
             "displaynamemavic2enterprisedual_vl",
             "the display name for mavic 2 enterprise dual visual camera.",
             "displaynamep4mcamera",
             "the display name for p4 multispectral camera.",
             "displaynamemavicminicamera",
             "the display name for mavic mini camera.",
             "displaynamemavicair2camera",
             "the display name for mavic air 2 camera.",
             "displaynamezenmuseh20",
             "the display name for zenmuse h20.",
             "displaynamezenmuseh20t",
             "the display name for zenmuse h20t.",
             "displaynamezenmuseh20n",
             "the display name for zenmuse h20n.",
             "displaynamemavic2enterpriseadvancedcamera",
             "the display name for mavic 2 enterprise advanced camera.",
             "xt2_ir_camera_index",
             "index for the xt2 camera.",
             "displaynamez30",
             "the display name for z30 camera.",
             "displaynamex4s",
             "the display name for x4s camera.",
             "displaynamex5s",
             "the display name for x5s camera.",
             "displaynamephantom4advancedcamera",
             "the display name for phantom 4 advanced camera.",
             "callback",
             "this interface provides information about the aggregate temperature of metering area.",
             "thermal_area_temperature_aggregations",
             "sdk key for callback: this interface provides information about the aggregate temperature of metering area.",
             "callback",
             "this interface provides information about the external scene settings.",
             "callback",
             "called whenever the camera parameters change. in automatic exposure modes (program, shutter priority and aperture priority) the camera may be automatically changing aperture, shutter speed and iso (depending on the mode and camera) when lighting conditions change. in manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
             "exposure_settings",
             "sdk key for callback: called whenever the camera parameters change. in automatic exposure modes (program, shutter priority and aperture priority) the camera may be automatically changing aperture, shutter speed and iso (depending on the mode and camera) when lighting conditions change. in manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
             "onupdate",
             "called when the camera's current state has been updated.  @param systemstate the system state of camera.",
             "onupdate",
             "called when the camera's lens and focus state has been updated. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param state the camera lens and focus state information.",
             "onnewfile",
             "called when a new media file (photo or video) has been generated.  in this callback method, the `mediafile` instance properties `getdurationinseconds` and `getvideoorientation` require special consideration. the thumbnail property normally has a pointer to a uiimage of the thumbnail, but this is only available when the camera is in `media_download` work mode. additionally, for this instance of `mediafile`, the `getdurationinseconds` property is 0 and the `getvideoorientation` property is `landscape`. not supported by zenmuse z30 and zenmuse xt2.  note:because the firmware cannot return some information correctly, so the interface is deprecated, please use `onnewfileinfo` insteaded.  @param mediafile the new media file.",
             "onnewfileinfo",
             "return the media file info when a new media file (photo or video) has been generated. only supported by znmuse h20 series.  @param mediafileinfo the new media file info.",
             "ongenerate",
             "called when a time-lapse preview image has been generated. this method is only available on osmo with firmware version v1.5.2.0 or above.  @param previewimage the new generated preview image.",
             "onupdate",
             "called when the camera's storage state has been updated. use `storagestate`'s `getstoragelocation` to determine if the updated state is for sd card or the internal storage.  @param state the camera storage state. if the camera supports internal storage (e.g. mavic air),   use `getstoragelocation` to determine whether the state is   for sd card or internal storage.",
             "onupdate",
             "called when the camera's ssd state has been updated. this method is available only when `isssdsupported` is `true`.  @param state the ssd's information.",
             "onupdate",
             "called when there are new min, max, and average temperature values available for the set spot metering area. supported by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param aggregations the thermalareatemperatureaggregations.",
             "thermal_area_temperature_aggregations",
             "sdk key for onupdate: called when there are new min, max, and average temperature values available for the set spot metering area. supported by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param aggregations the thermalareatemperatureaggregations.",
             "onupdate",
             "called when updated external scene settings are available. supported only by zenmuse xt containing advanced radiometry capabilities. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @param settings the thermalexternalscenesettings.",
             "onupdate",
             "called whenever the camera parameters change. in automatic exposure modes (program, shutter priority and aperture priority) the camera may be automatically changing aperture, shutter speed and iso (depending on the mode and camera) when lighting conditions change. in manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `djilens`.  @param values the updated values for parameters.",
             "exposure_settings",
             "sdk key for onupdate: called whenever the camera parameters change. in automatic exposure modes (program, shutter priority and aperture priority) the camera may be automatically changing aperture, shutter speed and iso (depending on the mode and camera) when lighting conditions change. in manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `djilens`.  @param values the updated values for parameters.",
             "onupdate",
             "update the histogram's light values.  @param lightvalues the histogram's light values.",
             "histogram_light_values",
             "sdk key for onupdate: update the histogram's light values.  @param lightvalues the histogram's light values.",
             "onupdate",
             "update tap zoom state.  @param tapzoomstate the tap zoom state values.",
             "onupdate",
             "received temperature in degrees celsius of image. the thermal imaging camera will only update the temperature if the temperature data is enabled. for the xt standard version, the temperature measurement data is the average of the center four pixels of the image. for the xt advanced radiometry version, the temperature measurement point can be set using `setthermalspotmeteringtargetpoint`.  @param temperature the camera's temperature data in degrees celsius.",
             "stabilizationstate",
             "the state of the vision stabilization.",
             "stabilizationstate",
             "constructor method for the stabilizationstate.  @param isactive the stabilization is active or not. @param ispaused the stabilization is paused or not. @param reason if paused, the reason on the pause.",
             "isactive",
             "check if the stabilization is active or not.  @return yes if the stabilization is active.",
             "ispaused",
             "check if the stabilization is paused or not.  @return yes if the stabilization is paused.",
             "getpausereason",
             "check if the stabilization is paused or not.  @return yes if the stabilization is paused.",
             "stabilizationpausereason",
             "the reason on the stabilization pause.",
             "uncharacteristic",
             "no characteristic.",
             "camera_changing",
             "the camera is changing.",
             "gimbal_moving",
             "the gimbal is moving.",
             "drone_moving",
             "the drone is moving.",
             "tracking",
             "in tracking mode.",
             "tap_go",
             "in tap go mode.",
             "other",
             "other.",
             "camerapeakthreshold",
             "a container for the low, normal, and high values for the camera peak threshold.",
             "camerapeakthreshold",
             "create a `camerapeakthreshold` instance with the default camera peak threshold values.  @param lowcamerapeakthreshold a float value representing the lowest camera peak threshold. @param normalcamerapeakthreshold a float value representing the normal camera peak threshold. @param highcamerapeakthreshold a float value representing the highest camera peak threshold.",
             "getlowcamerapeakthreshold",
             "gets the low value to be used for the camera peak threshold.  @return a float value representing the lowest camera peak threshold.",
             "getnormalcamerapeakthreshold",
             "gets the normal value to be used for the camera peak threshold.  @return a float value representing the normal camera peak threshold.",
             "gethighcamerapeakthreshold",
             "gets the high value to be used for the camera peak threshold.  @return a float value representing the highest camera peak threshold.",
             "lens",
             "the class is used to manage all lens feature. it is only supported by zenmuse h20 series and mavic 2 enterprise advanced.",
             "gettype",
             "gets the type of the current lens.  @return an object value of `lenstype`",
             "getcameraindex",
             "gets the index of the camera where the lens is located.  @return an int value.",
             "getindex",
             "gets the index of the current lens.  @return an int value.",
             "getdisplayname",
             "gets the name of the current lens.  @return an string instance of display name.",
             "getcapabilities",
             "lens capabilities. supported by zenmuse h20 series.  @return an object of `lenscapabilities`.",
             "setvideostandard",
             "sets the lens' analog video standard. setting the video standard to pal or ntsc will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videostandard video standard value to be set for the lens. @param callback the execution callback with the returned execution result.",
             "getvideostandard",
             "gets the lens' video standard value.  @param callback the execution callback with the returned value(s).",
             "setvideoresolutionandframerate",
             "sets the video resolution and frame rate of the current lens. @warning the supported resolutions and frame rates for the two different analog television standards pal and ntsc are below:  <b>ntsc:</b>  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_30fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_30fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_60fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_30fps  resolution_1920x1080, framerate_24fps  resolution_1280x720,  framerate_60fps  resolution_1280x720,  framerate_48fps  resolution_1280x720,  framerate_30fps  resolution_1280x720,  framerate_24fps  <b>pal:</b>  resolution_4096x2160, framerate_25fps  resolution_4096x2160, framerate_24fps  resolution_3840x2160, framerate_25fps  resolution_3840x2160, framerate_24fps  resolution_2704x1520, framerate_25fps  resolution_2704x1520, framerate_24fps  resolution_1920x1080, framerate_120fps (slow motion)  resolution_1920x1080, framerate_50fps  resolution_1920x1080, framerate_48fps  resolution_1920x1080, framerate_25fps  resolution_1920x1080, framerate_24fps  resolution_1280x720, framerate_50fps  resolution_1280x720, framerate_48fps  resolution_1280x720, framerate_25fps  resolution_1280x720, framerate_24fps  @param resolutionandframerate resolution to be set for the video. @param callback the execution callback with the returned execution result.",
             "getvideoresolutionandframerate",
             "gets the video resolution and frame rate values of the current lens.  @param callback the execution callback with the returned value(s).",
             "setvideofileformat",
             "sets the video file format of the current lens. the default value is `mov`.  @param format video file format to be set for videos. @param callback the execution callback with the returned execution result.",
             "getvideofileformat",
             "gets the video file format of the current lens.  @param callback the execution callback with the returned value(s).",
             "setphotoaspectratio",
             "sets the aspect ratio for photos of the current lens. see `photoaspectratio` to view all possible ratios.  @param aspectratio aspect ratio for photos to be taken by camera. @param callback the execution callback with the returned execution result.",
             "getphotoaspectratio",
             "gets the aspect ratio for photos of the current lens.  @param callback the execution callback with the returned value(s).",
             "setphotofileformat",
             "sets the photo file format of the current lens. see `photofileformat` to view all possible photo formats to which the lens can be set. not supported by zenmuse h20 series.  @param format photo file format used when the camera takes a photo. @param callback the execution callback with the returned execution result.",
             "getphotofileformat",
             "gets the photo file format of the current lens.  @param callback the execution callback with the returned value(s).",
             "setexposuremode",
             "sets the exposure mode of the current lens. check `djicameraexposuremode` to view all possible camera exposure modes. please note that in different exposure mode, it will have different values for the same setting.  @param mode camera exposure mode to set. @param callback the execution callback with the returned execution result.",
             "getexposuremode",
             "gets the exposure mode of the current lens.  @param callback the execution callback with the returned value(s).",
             "setiso",
             "sets the iso value of the current lens. see `djicameraiso` to view all possible iso settings for the lens.  @param iso iso value to be set. @param callback the execution callback with the returned execution result.",
             "getiso",
             "gets the iso value of the current lens.  @param callback the execution callback with the returned value(s).",
             "setshutterspeed",
             "sets the shutter speed of the current lens. to see all available shutterspeed value settings, see `shutterspeed`. the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate is 30fps, the `shutterspeed` must be <= 1/30. precondition: the shutter speed can be set only when the lens exposure mode is shutter mode or manual mode.  @param shutterspeed shutter speed value to be set for the lens. for all available values shutterspeed can be set to, please check `shutterspeed`. <br> the shutter speed should not be set slower than the video frame rate when the camera's mode is `record_video`. for example, if the video frame rate = 30fps, then the shutterspeed must be <= 1/30. @param callback the execution callback with the returned execution result.",
             "getshutterspeed",
             "gets the shutter speed of the current lens.  @param callback the execution callback with the returned value(s).",
             "setmeteringmode",
             "sets the exposure metering of the current lens. see `meteringmode` to view all possible exposure metering settings for the lens.  @param mode exposure metering to be set. check the enum `meteringmode` to find all possible exposure metering the camera can be set to. @param callback the execution callback with the execution result.",
             "getmeteringmode",
             "gets the exposure metering of the current lens.  @param callback the execution callback with the returned value(s).",
             "setspotmeteringtarget",
             "sets the spot metering area index of the current lens. the lens image is divided into 225 spots defined by 15 columns and 15 rows. the row index range is [0,14], where the values increase top to bottom across the image. the column index range is [0, 14], where the values increase left to right. in order to make the method work, the camera exposure mode should be `program`, `shutter` or `aperture`, the exposure metering mode must be `spot`, and `setaelock` must be `no`.  @param spotindex spot metering point coordinate (x, y).  x is column index to be set. the value should falls in [0, 14], where the values increase left to right. y is row index to be set. the value should falls in [0, 14], where the values increase top to bottom across the image. @param callback the execution callback with the returned execution result.",
             "getspotmeteringtarget",
             "gets the spot metering area row index and column index of the current lens. in order to make the method work, the lens exposure mode should be `program`, `shutter_priority` or `aperture_priority`, the exposure metering mode must be `spot`, and `getaelock` must be `false`.  @param callback the execution callback with the returned value(s).",
             "setexposurecompensation",
             "sets the exposure compensation of the current lens. see `exposurecompensation` to view all possible exposure compensations to which the camera can be set. in order to use this function, set the lens exposure mode to `shutter`, `program` or `aperture`.  @param compensation exposure compensation value to be set for the camera. @param callback the execution callback with the returned execution result.",
             "getexposurecompensation",
             "gets the exposure compensation of the current lens.  @param callback the execution callback with the returned value(s).",
             "setaelock",
             "locks or unlocks the lens' ae (auto exposure). post condition: if the ae lock is enabled, the spot metering area cannot be set.  @param islocked `true` if the camera ae is locked, `no` if it is unlocked. @param callback the execution callback with the returned execution result.",
             "getaelock",
             "determines if the lens' ae (auto exposure) is locked.  @param callback the execution callback with the returned value(s).",
             "setautoaeunlockenabled",
             "enables/disables auto-unlocking of ae lock after shooting a photo. if it is enabled, the auto exposure will unlock after each shot. if disabled, auto exposure will change when calling `setaelock`.  @param enabled `true` if the camera ae will automatically unlock. @param callback the execution callback with the returned execution result.",
             "getautoaeunlockenabled",
             "determines whether auto-unlocking of ae lock is enabled.  @param callback the execution callback with the returned value(s).",
             "setwhitebalance",
             "sets the white balance of the current lens. when the white balance is a preset value (values except `custom`), the `colortemperature` argument does not take effect. when the white balance is `custom`, the `getcolortemperature` value is used instead. see also: `whitebalancepreset` to view all possible white balance setting options for the camera.  @param whitebalance white balance value to be set. @param callback the execution callback with the returned execution result.",
             "getwhitebalance",
             "gets the white balance and color temperature of the current lens.  @param callback the execution callback with the returned value(s).",
             "setsharpness",
             "sets the sharpness of the current lens. the default value is 0.  @param sharpness sharpness value to be set in the range of [-3, 3]. @param callback asynchronous execution result.",
             "getsharpness",
             "gets the sharpness of the current lens.  @param callback the execution callback with the returned value of sharpness with range [-3, 3].",
             "setcontrast",
             "sets the contrast of the current lens. the default saturation value is 0.  @param contrast contrast value to be set in the range of [-3, 3]. @param callback the execution callback with the returned execution result.",
             "getcontrast",
             "gets the contrast of the current lens.  @param callback the execution callback with the returned value of contrast with range [-3, 3].",
             "setsaturation",
             "sets the saturation of the current lens. the default saturation value is 0.  @param saturation saturation value to be set in the range of [-3, 3]. the default value of the saturation value is 0. @param callback the execution callback with the returned execution result.",
             "getsaturation",
             "gets the saturation of the current lens.  @param callback the execution callback with the returned value(s).",
             "setcolor",
             "sets the color of the current lens. the default value is `none`. for a list of all possible camera colors, see `cameracolor`.  @param color camera color to be applied to the camera. @param callback the execution callback with the returned execution result.",
             "getcolor",
             "gets the color of the current lens.  @param callback the execution callback with the returned value(s).",
             "setirfilterenabled",
             "enables/disables the ir filter (infared filter). disabling the ir filter can enhance the image in low light environments. enabling the ir filter can reduce the color distortion caused by the infared light. supported by the zoom lens of zenmuse h20 series.  @param enabled `true` to enable ir-cut filter. @param callback callback that receives the setter result.",
             "getirfilterenabled",
             "determines whether ir filter (infared filter) is enabled. disabling the ir filter can enhance the image in low light environments. enabling the ir filter can reduce the color distortion caused by the infared light. supported by the zoom lens of zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "off",
             "off.",
             "on",
             "on.",
             "auto",
             "auto.",
             "irfiltermode",
             "the ir filter mode.",
             "setirfiltermode",
             "sets the ir filter mode of the current lens. on to reduce the color distortion caused by the infared light,  off to enhance the image in low light environments, or auto to up to the system to decide whether to switch. supported by the zoom lens of zenmuse h20 series.  @param irfiltermode an enum type of the `irfiltermode` to be used. @param callback the execution callback with the returned execution result.",
             "getirfiltermode",
             "gets the ir filter mode of the current lens. supported by the zoom lens of zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "isdigitalzoomsupported",
             "check if the current device supports digital zoom scale. it is supported by osmo with x3 camera, phantom 4 camera, z3 camera, mavic pro camera and z30 camera. for zenmuse h20 series and mavic 2 enterprise advanced, please use class `lens`.  @return a boolean value.",
             "setdigitalzoomfactor",
             "sets the digital zoom factor of the current lens. not supported by zenmuse h20 series.  @param factor the valid range is from 1.0 to 2.0. @param callback the execution callback with the returned execution result.",
             "getdigitalzoomfactor",
             "gets current digital zoom factor of the current lens. note z30 cannot set the digital zoom scale, but will use digital zoom when using `startcontinuousopticalzoom` and the optical zoom has reached its limit. not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "isopticalzoomsupported",
             "determine if the current lens supports optical zoom. not supported by zenmuse h20 series.  @return `true` if lens supports optical zoom.",
             "getopticalzoomspec",
             "gets the specification of the current lens. not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "setopticalzoomfocallength",
             "sets focal length of the current lens. not supported by zenmuse h20 series.  @param focallength focal length of zoom lens. valid range is [`getminfocallength`, `getmaxfocallength`] and must be a multiple of `getfocallengthstep`. @param callback the execution callback with the returned execution result.",
             "getopticalzoomfocallength",
             "gets the optical zoom focal length of the current lens in units of 0.1mm. not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "startcontinuousopticalzoom",
             "start changing the focal length of the lens in specified direction with specified speed. focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopcontinuousopticalzoom` is called. supported by the zoom lens of zenmuse h20 series and mavic 2 enterprise advanced.  @param direction direction to zoom. @param speed zoom speed. @param callback the execution callback with the returned execution result.",
             "stopcontinuousopticalzoom",
             "called to stop focal length changing, when it currently is from calling `startcontinuousopticalzoom`. supported by the zoom lens of zenmuse h20 series and mavic 2 enterprise advanced.  @param callback the execution callback with the returned execution result.",
             "ishybridzoomsupported",
             "hybrid zoom is combining optical and digital zoom. lens will automatically switch over to digital zoom when optical zoom range is exceeded. check if lens supports hybrid zoom. supported by the zoom lens of zenmuse h20 series.  @return `true` if camera supports hybrid zoom.",
             "gethybridzoomspec",
             "hybrid zoom is combining optical and digital zoom. lens will automatically switch over to digital zoom when optical zoom range is exceeded. gets the specification of the zoom lens. supported by the zoom lens of zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "sethybridzoomfocallength",
             "hybrid zoom is combining optical and digital zoom. lens will automatically switch over to digital zoom when optical zoom range is exceeded. sets focal length of the zoom lens. supported by the zoom lens of zenmuse h20 series.  @param focallength focal length of zoom lens. valid range is [`getminhybridfocallength`, `getmaxhybridfocallength`] and must be a multiple of `getfocallengthstep`. @param callback the execution callback with the returned execution result.",
             "gethybridzoomfocallength",
             "hybrid zoom is combining optical and digital zoom. lens will automatically switch over to digital zoom when optical zoom range is exceeded.  gets zoom lens focal length in units of 0.1mm. supported by the zoom lens of zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "istapzoomsupported",
             "determines if the current lens supports tapzoom feature.  @return `true` if camera supports tap zoom.",
             "settapzoomenabled",
             "enable/disable tapzoom. `tapzoomattarget` can only be called when tapzoom is enabled. supported by mavic 2 enterprise advanced, the zoom lens and the wide lens of zenmuse h20 series.  @param enabled `true` to enable tapzoom feature. @param callback the execution callback with the returned execution result.",
             "gettapzoomenabled",
             "determines if tapzoom is enabled.  @param callback the execution callback with the returned value(s).",
             "settapzoommultiplier",
             "tapzoom uses a multiplier to change the zoom scale when called. the final zoom scale for a tapzoom will be: current zoom scale x multiplier. the multiplier range is [1,5]. a multiplier of 1 will not change the zoom. when the multiplier is 1, the zoom scale will not change during tapzoom. supported by the zoom lens and the wide lens of zenmuse h20 series. the tap zoom multiplier of zenmuse h20 series must be 1.  @param multiplier multiplier of tapzoom. @param callback the execution callback with the returned execution result.",
             "gettapzoommultiplier",
             "gets the multiplier for tapzoom. supported by the zoom lens and the wide lens of zenmuse h20 series. the tap zoom multiplier of zenmuse h20 series must be 1.  @param callback the execution callback with the returned value(s).",
             "tapzoomattarget",
             "tapzoom at the target. it can be called only when tapzoom is enabled.  when a new target is set, the gimbal will rotate and locate the target in the center of the screen. at the same time, the camera will zoom by multiplying the tapzoom multiplier. supported by mavic 2 enterprise advanced, the zoom lens and the wide lens of zenmuse h20 series. it will only work when the tap zoom multiplier of zenmuse h20 series is 1.  @param target the target to zoom. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left corner of the screen. @param callback the execution callback with the returned execution result.",
             "isadjustableaperturesupported",
             "gets whether the lens supports an adjustable aperture. currently adjustable aperture is supported only by the zoom lens of zenmuse h20 series.  @return a boolean value.",
             "setaperture",
             "sets the aperture value of the current lens. this feature is available only when `isadjustableaperturesupported` returns `true`. precondition: the exposure mode `exposuremode` must be in `manual` or `aperture_priority`. </br> supported only by the zoom lens of zenmuse h20 series and mavic 2 enterprise advanced.  @param aperture the aperture to set. see `focusmode`. @param callback the execution callback with the returned execution result.",
             "getaperture",
             "gets the aperture of the current lens. this feature is available only when `isadjustableaperturesupported` returns `true`.  @param callback the execution callback with the returned value(s).",
             "isadjustablefocalpointsupported",
             "determines whether the lens supports an adjustable focal point. currently, the adjustable focal point is supported by the zoom lens of zenmuse h20 series.  @return a boolean value.",
             "setfocusmode",
             "sets the focus mode of the current lens. see `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param focusmode focus mode to set. check `focusmode` for more detail. @param callback the execution callback with the returned execution result.",
             "getfocusmode",
             "gets the focus mode of the current lens. please check `focusmode`. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "setfocustarget",
             "sets the lens focus target point. when the focus mode is auto, the target point is the focal point. when the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param focustarget the focus target to set. the range for x and y is from 0.0 to 1.0. the point [0.0, 0.0] represents the top-left angle of the screen. @param callback the execution callback with the returned execution result.",
             "getfocustarget",
             "gets the lens focus target point. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "setfocusassistantsettings",
             "used to enable/disable the lens focus assistant. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. not supported by mavic 2 enterprise advanced.  @param settings sets whether the lens focus assistant for af and mf mode is enabled. @param callback the execution callback with the returned execution result.",
             "getfocusassistantsettings",
             "determines whether the lens focus assistant is enabled. when the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. focus assistant can be used for both manual focus (mf) and auto focus (af). it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "getfocusringvalueupperbound",
             "gets the lens focusing ring value's max value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "setfocusringvalue",
             "set the focal distance by simulating the focus ring adjustment. value can have a range of 0, `getfocusringvalueupperbound`], which represents infinity and the closest possible focal distance. it is available only when `isadjustablefocalpointsupported` returns `true`. for some lenses, the minimum focus ring value is larger than 0. for example the minimum of dji mft 15mm f/1.7 asph is 270. to retrieve the minimum value, perform the following steps: - call `setfocusmode` with `auto`. - call `setfocustarget` with the furthest target (>30m). - call `getfocusringvalue` to get the current focus ring value. this is the minimum value. the maximum value can be retrieved using `getfocusringvalueupperbound`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param value value to adjust focus ring to. the minimum value is 0, the maximum value depends on the installed lens. please use method `getfocusringvalueupperbound` to ensure the input argument is valid. @param callback the execution callback with the returned execution result.",
             "getfocusringvalue",
             "gets the lens focus ring value. it is available only when `isadjustablefocalpointsupported` returns `true`. supported by the zoom lens of zenmuse h20 series. not supported by mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "ismechanicalshuttersupported",
             "determines whether the mechanical shutter speed is supported by the camera or the lens.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
             "setmechanicalshutterenabled",
             "enables the mechanical shutter. it is only valid when `ismechanicalshuttersupported` returns `true`.  @param enabled `true` to enable the mechanical shutter. @param callback the execution callback with the returned execution result.",
             "getmechanicalshutterenabled",
             "determines whether the mechanical shutter is enabled. it is only valid when `ismechanicalshuttersupported` returns `true`.  @param callback the execution callback with the returned boolean value.",
             "setantiflickerfrequency",
             "sets the lens anti-flicker frequency for video recording. precondition: the exposure mode must be program. note: for the z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. it is not supported by zenmuse h20 series.  @param antiflickerfrequency anti-flicker value to set for the camera. see `antiflickerfrequency` to view all the possible anti-flicker type settings for the camera. @param callback the execution callback with the returned execution result.",
             "getantiflickerfrequency",
             "gets the lens anti-flicker. it is not supported by zenmuse h20 series.  @param callback the execution callback with the returned value(s).",
             "isthermallens",
             "return `true` if the current connected device is a thermal imaging lens.  @return a boolean value.",
             "setthermalroi",
             "sets the region of interest (roi). used to manage color range distribution across the screen to maximize contrast for regions of highest interest. supported by the thermal lens of zenmuse h20t and h20n.  @param roi an enum type of the region of interest to be used. please refer to `thermalroi`. @param callback the execution callback with the returned execution result.",
             "getthermalroi",
             "gets the region of interest.  @param callback the execution callback with the returned value(s).",
             "setthermalpalette",
             "sets the palette. each palette is a unique look-up table that maps 8-bit temperature values to different colors. different palettes can be used to help the user better visualize temperature contrast or specific temperature bands.  @param palette an enum type of the `thermalpalette` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalpalette",
             "gets the palette. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalscene",
             "sets the scene to instantly enhance your image. in all modes except manual and user modes, the dde, ace, sso, brightness and contrast are set automatically to obtain the best result. in user modes, the contrast and brightness are set automatically to obtain the best results. any settings that are made in these modes are retained if the scene is changed. in manual mode, dde, contrast and brightness are set manually.  @param scene an enum type for the `thermalscene` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalscene",
             "gets current scene.  @param callback the execution callback with the returned value(s).",
             "setthermaldde",
             "sets the digital data enhancement index (for dde dynamic mode). dde can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). it can be set manually only when the scene mode is manual, user1, user2 or user3.  @param value integer in range [-20, 100]. values less than 0 soften the image and filter fixed pattern noise. values greater than 0 sharpen the details in the image. value of 0 results in no enhancement. @param callback the execution callback with the returned execution result.",
             "getthermaldde",
             "gets the value of digital data enhancement. the value is available only when the scene mode is manual, user1, user2 or user3.  @param callback the execution callback with the returned value(s).",
             "setthermalace",
             "set the value of active contrast enhancement. active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. it can be set manually only when the scene mode is user1, user2 or user3. not supported by zenmuse h20t and h20n.  @param value integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use. @param callback the execution callback with the returned execution result.",
             "getthermalace",
             "gets the value of active contrast enhancement. the value is available only when the scene mode is manual, user1, user2 or user3. not supported by zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalsso",
             "sets the value of smart scene optimization. when using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. sso allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. this is particularly useful for bi-modal scenes. it can be set manually only when the scene mode is user1, user2 or user3. not supported by zenmuse h20t and h20n.  @param value percentage of histogram to map linearly [0, 100]. @param callback the execution callback with the returned execution result.",
             "getthermalsso",
             "gets the value of smart scene optimization. the value is available only when the scene mode is manual, user1, user2 or user3. not supported by zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalbrightness",
             "sets the brightness of the image. it can be set manually only when the scene mode is manual.  @param brightness the integer value falls in [0, 16383]. @param callback the execution callback with the returned execution result.",
             "getthermalbrightness",
             "gets the value of brightness. the value is available only when the scene mode is manual, user1, user2 or user3.  @param callback the execution callback with the returned value(s).",
             "setthermalcontrast",
             "sets the value of contrast, with larger values having higher contrast. it can be set manually only when the scene mode is manual.  @param contrast contrast value as an integer with range [0, 255]. @param callback the execution callback with the returned execution result.",
             "getthermalcontrast",
             "gets contrast value. the value is available only when the scene mode is manual, user1, user2 or user3.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermenabled",
             "enable or disable isotherms. isotherms can be used to highlight specific temperature ranges: when disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. when enabled, only 128 values (0-127) are mapped linearly to temperature. then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. using some of the false color palettes (like rainbowiso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. not supported by mavic 2 enterprise advanced.  @param enabled `true` if isotherms are enabled. @param callback the execution callback with the returned execution result.",
             "getthermalisothermenabled",
             "determines whether isotherms are enabled. `true` if isotherms are enabled. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermunit",
             "sets the unit of the isotherm ranges to either celsius or percent. different units results in different value ranges for isotherms.  @param unit an enum type of the `thermalisothermunit` to be used. please refer to `thermalisothermunit`. @param callback the execution callback with the returned execution result.",
             "getthermalisothermunit",
             "gets the units for isotherm ranges.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermuppervalue",
             "sets the upper threshold value for isotherm. all temperature values above this will use colors 224-255 from the palette.  @param value if the unit is percentage, the allowed range is [0,100]. @param callback the execution callback with the returned execution result.",
             "getthermalisothermuppervalue",
             "gets the upper threshold value for isotherm. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermmiddlevalue",
             "sets the middle threshold value for isotherm. temperature values between the middle and upper isotherm threshold will be displayed with colors 176-223 from the palette. not supported by zenmuse h20t and h20n.  @param value if the unit is percentage, the value falls in [0,100]. if the unit is celsius, the value range is [-40, 550]. the value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback the execution callback with the returned execution result.",
             "getthermalisothermmiddlevalue",
             "gets the middle threshold value for isotherm. not supported by zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalisothermlowervalue",
             "sets the lower threshold value for isotherm. temperature values between the lower and middle isotherm threshold will be displayed with colors 128-175 from the palette. supported by the thermal lens of zenmuse h20t and h20n.  @param value if the unit is percentage, the value falls in [0,100]. @param callback the execution callback with the returned execution result.",
             "getthermalisothermlowervalue",
             "gets the lower threshold value for isotherm. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalgainmode",
             "sets the gain mode. low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees celsius. for higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees celsius for the 640x512 camera and -25 to 100 degrees celsius for 324 x 256 camera. mavic 2 enterprise dual has different temperature range from other thermal imaging cameras. therefore, for mavic 2 enterprise dual, the low gain mode can be used from -10 to 140 degrees celsius. the high gain mode can be used from -10 to 400 degree celsius, for mavic 2 enterprise advanced, the low gain mode can be used from -20 to 450 degrees celsius. the high gain mode can be used from -20 to 150 degree celsius  @param mode an enum type of the `thermalgainmode` to be used. @param callback the execution callback with the returned execution result.",
             "getthermalgainmode",
             "gets the gain mode. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalmeasurementmode",
             "sets the mode for thermal measurement.  supported only by thermal imaging cameras. supported by the thermal lens of zenmuse h20t and h20n and mavic 2 enterprise advanced.  @param mode the desired measurement mode. @param callback completion block that receives the getter execution result.",
             "getthermalmeasurementmode",
             "gets the mode for thermal measurement. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermaldigitalzoomfactor",
             "adjusts the digital zoom. supported by the thermal lens of zenmuse h20t and h20n.  @param factor for resolution 640 x 512, x1,x2,x4,x8 can be set. for resolution 336 x 256, only x1,x2,x4 can be set. please refer to `thermaldigitalzoomfactor` in djicamerasettingsdef. @param callback the execution callback with the returned execution result.",
             "getthermaldigitalzoomfactor",
             "gets current digital zoom.  @param callback the execution callback with the returned value(s).",
             "getthermalprofile",
             "gets the thermal imaging camera profile. the profile includes information about resolution, frame rate and focal length. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "getthermalspotmeteringtargetpoint",
             "gets the spot metering target point if one is set, if not then returns cgpointzero.  supported by the thermal lens of zenmuse h20t and h20n and mavic 2 enterprise advanced.  @param callback the execution callback with the returned value(s).",
             "setthermalspotmeteringtargetpoint",
             "sets the spot metering target point which then invoke the callback from `setthermaltemperaturecallback`. this method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. you should call `setthermalmeasurementmode` to set  the measurement mode to `spot_metering` first. supported by the thermal lens of zenmuse h20t and h20n and mavic 2 enterprise advanced.  @param targetpoint the desired target point. @param callback the execution callback with the returned execution result.",
             "getthermalmeteringarea",
             "get a rect representing the currently set metering area for the thermal scene. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalmeteringarea",
             "set the metering area for a rectangle inside the thermal ismage scene, which allows the camera to transmit aggregate temperature computations via the `onupdate` delegate method. see `thermalareatemperatureaggregations` for the statistical values that are available. this method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. you should call `setthermalmeasurementmode` to set  the measurement mode to `area_metering` first. supported by the thermal lens of zenmuse h20t and h20n and mavic 2 enterprise advanced.  @param area the desired thermal metering area. @param callback the execution callback with the returned execution result.",
             "getthermalffcmode",
             "get the currently set flat-field correction (ffc) mode.  @param callback the execution callback with the returned value(s).",
             "setthermalffcmode",
             "set the flat-field correction (ffc) mode. supported by the thermal lens of zenmuse h20t and h20n.  @param mode the desired ffc mode. @param callback the execution callback with the returned execution result.",
             "triggerthermalffc",
             "trigger flat-field correction. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with result of the trigger action.",
             "getthermalcustomexternalscenesettingsprofile",
             "gets the currently set custom user profile. this profile represents user-set external scene parameters for the thermal scene. not supported by zenmuse h20t and h20n.  @param callback the execution callback with the returned value(s).",
             "setthermalcustomexternalscenesettingsprofile",
             "sets the custom user profile. this profile represents user-set external scene parameters for the thermal scene. not supported by zenmuse h20t and h20n.  @param profile the desired user profile setting. @param callback the execution callback with the returned execution result.",
             "setthermaltemperatureunit",
             "sets the temperature unit. not supported by mavic 2 enterprise advanced.  @param temperatureunit temperature unit to set. @param callback the execution callback with the returned execution result.",
             "getthermaltemperatureunit",
             "gets the temperature unit.  @param callback the execution callback with the returned execution result.",
             "setdisplaymode",
             "sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. only applies to the thermal infrared video feed. for zemmuse h20t and h20n, you should set `setcameravideostreamsource` with `infrared_thermal` first. only supported by zenmuse h20t and h20n.and mavic 2 enterprise advanced.  @param mode the display mode to set. @param callback the execution callback with the returned execution result.",
             "getdisplaymode",
             "gets the display mode. the display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera.  @param callback the execution callback with the returned execution result.",
             "setpipposition",
             "sets the thermal window's position relative to the visual window. only applies to the thermal infrared video feed. the setting is valid when the display mode is `pip`. refer to `setdisplaymode` and `getdisplaymode`.  @param position the position to set. @param callback the execution callback with the returned execution result.",
             "getpipposition",
             "gets the pip position which determines the thermal window's position relative to the visual window. the setting is valid when the display mode is `pip`. refer to `setdisplaymode` and `getdisplaymode`.  @param callback the execution callback with the returned execution result.",
             "setmsxlevel",
             "sets the level for msx display mode. the range for level is [0, 100]. when it is 0, the visible spectrum definition is invisible. when it is 100, the visual spectrum definition is the most obvious. only applies to the thermal infrared video feed.  @param level the msx level to set with range [0, 100]. @param callback the execution callback with the returned execution result.",
             "getmsxlevel",
             "gets the level for msx display mode. the range for level is [0, 100]. when it is 0, the visible spectrum definition is invisible. when it is 100, the visual spectrum definition is the most obvious. supported by the thermal lens of zenmuse h20t and h20n.  @param callback the execution callback with the returned execution result.",
             "setdualfeedhorizontalalignmentoffset",
             "sets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. the alignment is applied to the msx display mode. different camera results in different value ranges.  @param offset range from -100 to 100 for xt2, from -40 to 40 for mavic 2 enterprise dual. @param callback the execution callback with the returned execution result.",
             "getdualfeedhorizontalalignmentoffset",
             "gets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. the alignment is applied to the msx display mode. different camera results in different value ranges.  @param callback the execution callback with the returned execution result.",
             "setdualfeedverticalalignmentoffset",
             "sets the vertical alignment offset between the video feeds from both the visual lens and the thermal lens. the alignment is applied to the msx display mode. different camera results in different value ranges.  @param offset range from -8 to 8 for xt2, from -40 to 40 for mavic 2 enterprise dual. @param callback the execution callback with the returned execution result.",
             "getdualfeedverticalalignmentoffset",
             "gets the vertical alignment offset between the video feeds from both the visual lens and the thermal lens. the alignment is applied to the msx display mode. different camera results in different value ranges.  @param callback the execution callback with the returned execution result.",
             "setthermalareatemperatureaggregationscallback",
             "sets the thermal lens temperature aggregation update callback. callback will be called when there are new min, max, and average values available for the set spot metering area. supported by the thermal lens of zenmuse h20t and h20n.  @param areatemperatureaggregationsupdatedcallback the callback object to set as the callback.",
             "setthermalexternalscenesettingscallback",
             "sets the thermal lens external scene settings update callback. callback will get called when updated external scene settings are available. only supported by xt2.  @param thermalexternalscenesettingsupdatedcallback the callback object to set as the callback.",
             "setthermaltemperaturecallback",
             "sets the thermal lens temperature update callback. callback is used when there is a new temperature value available for the set spot metering target point. supported by the thermal lens of zenmuse h20t and h20n.  @param updatecentertemperaturecallback the callback object to set as the callback. <br> callback implements an `onupdate` method.</br> the float object contains information about the updated temperature value.",
             "setthermalatmospherictemperature",
             "sets the temperature of the atmosphere between the scene and the camera. not supported by zenmuse h20t and h20n.  @param temperature the assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees celsius. @param callback the execution callback with the returned execution result.",
             "setthermalatmospherictransmissioncoefficient",
             "sets the transmission coefficient of the atmosphere between the scene and the camera. not supported by zenmuse h20t and h20n.  @param coefficient the desired atmospheric temperature, can be between 50 and 100. @param callback the execution callback with the returned execution result.",
             "setthermalbackgroundtemperature",
             "sets the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees celsius. not supported by zenmuse h20t and h20n.  @param temperature the desired background reflected temperature. @param callback the execution callback with the returned execution result.",
             "setthermalsceneemissivity",
             "sets the emissivity of the thermal scene, can be between 50 and 100. not supported by zenmuse h20t and h20n.  @param emissivity the desired scene emissivity. @param callback the execution callback with the returned execution result.",
             "setthermalwindowreflection",
             "sets assumed window reflection coefficient, can be between 0 and x where x is the window transmission coefficient parameter. not supported by zenmuse h20t and h20n.  @param reflection the desired window reflection coefficient. @param callback the execution callback with the returned execution result.",
             "setthermalwindowreflectedtemperature",
             "sets the temperature reflected in the window, can be between -50 and 327.67 degrees celsius. not supported by zenmuse h20t and h20n.  @param temperature the desired window reflected temperature. @param callback the execution callback with the returned execution result.",
             "setthermalwindowtemperature",
             "sets the window temperature, can be between -50 and 327.67 degrees celsius. not supported by zenmuse h20t and h20n.  @param temperature the desired window temperature. @param callback the execution callback with the returned execution result.",
             "setthermalwindowtransmissioncoefficient",
             "sets the window transmission coefficient, can be between 50 and 100-x where x is the window reflection. not supported by zenmuse h20t and h20n.  @param coefficient the desired window transmission coefficient. @param callback the execution callback with the returned execution result.",
             "getzoomboxrelativefov",
             "get the fov after camera's focal distance changed.  @param callback the execution callback with the returned value(s).",
             "getthermalgainmoderange",
             "gets temperature range of specific gain mode. only supported by zenmuse h20t and h20n.  @param mode given camera gain mode. @param callback completion block to receive the result.the temperature measurement range of given gain mode.",
             "setinfraredthermalcamerasensorburningprotectionenabled",
             "enables or disables the infrared sensor protection. if the sensor protection is enabled, the infrared thermal camera shutter might be closed. only supported by zenmuse h20t and h20n.  @param isenabled enable or disable infrared sensor protection. @param callback the execution callback with the returned execution result.",
             "setinfraredthermalcamerashutterenabled",
             "enables the infrared thermal camera. infrared thermal camera shutter may be closed, if the sensor protection is enabled. only supported by zenmuse h20t and h20n.  @param callback the execution callback with the returned execution result.",
             "setexposuresettingscallback",
             "sets the callback for updated exposure parameters. the callback's `onupdate` method will be called each time the exposure parameters (iso, exposure compensation, shutter speed and aperture) are updated.  @param callback the execution callback.",
             "setfocusstatecallback",
             "callback for updating the state of the current lens.  @param updatedlensstatecallback the execution callback.",
             "settapzoomstatecallback",
             "sets the tap zoom state callback. the callback's `djicamera_djilens_tapzoomstatecallbackinterface_onupdate` method will be called when the lens zoom state is updated. supported by the zoom lens and the wide lens of zenmuse h20 series and mavic 2 enterprise advanced.  @param callback completion block that receives the execution result.",
             "setthermalglobaltemperaturecallback",
             "callback to update current global minimum temperature and maximum temperature.  @param callback completion callback that receives the execution result.",
             "setlasermeasureinformationcallback",
             "sets the laser measure information callback. when laser information would been updated, it call `callback` to update the laser state information. the laser sensor must be at least 3m from the target point. it is only supported by zenmuse h20 series.  @param lasermeasureinformationcallback completion block that receives the execution result.",
             "tapzoomstatecallback",
             "called when the lens zoom state is updated.",
             "onupdate",
             "update tap zoom state.  @param tapzoomstate the tap zoom state values.",
             "temperaturedatacallback",
             "received temperature in degrees celsius of image. for the thermal lens, the temperature measurement data is the average of the center four pixels of the image. supported by the thermal lens of zenmuse h20t and h20n.",
             "onupdate",
             "received temperature in degrees celsius of image. the thermal imaging lens will only update the temperature if the temperature data is enabled. for the thermal lens standard version, the temperature measurement data is the average of the center four pixels of the image.  @param temperature the thermal lens temperature data in degrees celsius.",
             "thermalglobaltemperaturecallback",
             "called when the temperature range changed. only supported by the thermal lens of zenmuse h20t and h20n.",
             "onupdate",
             "update the global temperature range.  @param min the minimum temperature. @param max the maximum temperature.",
             "lenscapabilities",
             "some of the camera's lens parameters have dynamic ranges. the `lenscapabilities` class allows you to query the valid range for a parameter.",
             "adddjilensparameterslistener",
             "adds the listener for the lens' range change events.  @param listener lens range change listener.",
             "removedjilensparameterslistener",
             "removes the listener for the lens range change.  @param listener an instance of djilensparameterslistener.",
             "removealllistener",
             "remove all listeners.",
             "djilensparameterslistener",
             "defines the listeners of the camera parameters range.",
             "onlensisorangechange",
             "when the lens iso range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensexposuremoderangechange",
             "when the lens exposure mode range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensshutterspeedrangechange",
             "when the lens shutter speed range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensaperturerangechange",
             "when the lens aperture range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensexposurecompensationrangechange",
             "when the lens exposure compensation range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensvideoresolutionandframeraterangechange",
             "when the lens video resolution and frame rate range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onlensthermalpaletterangechange",
             "when the lens thermal palette range is changed, the listener will receive this callback.  @param newrange the new range.",
             "setthermalgainmodetemperaturerangecallback",
             "adds the listener for the supported temperature range when current gain mode changes.  @param callback gain mode change listener.",
             "isorange",
             "returns the current valid range for camera's iso (see `iso`). returns `null` if current camera does not support any iso value or the camera is disconnected. @return a cameraiso array. each element represents one current supported iso value.  @return array of `iso`. each element represents one current supported iso value.",
             "shutterspeedrange",
             "returns the current valid range for camera's shutter speed (see `shutterspeed`). returns `null` if current camera does not support any shutter speed value or the camera is disconnected. @return array of camerashutterspeed. each element represents one current supported shutter speed value.  @return array of `shutterspeed`. each element represents one current supported shutter speed value.",
             "aperturerange",
             "returns the current valid range for camera's aperture (see `aperture`). returns `null` if current camera does not support any aperture value or the camera is disconnected. @return array of cameraaperture. each element represents one current supported aperture value.  @return array of `aperture`. each element represents one current supported aperture value.",
             "exposurecompensationrange",
             "returns the current valid range for camera's exposure compensation (see `exposurecompensation`). returns `null` if current camera does not support any exposure compensation value or the camera is disconnected. @return array of cameraexposurecompensation. each element represents one current supported exposure compensation value.  @return array of `exposurecompensation`. each element represents one current supported exposure compensation value.",
             "videoresolutionandframeraterange",
             "returns the current valid range for video resolution cameravideoresolution and frame rate `videoframerate`. returns `null` if the current camera does not support any video resolution or frame rate setting, or if the camera is disconnected.  @return array of pairs. each pair represents a valid `videoresolution` value and `videoframerate` value.",
             "thermalpaletterange",
             "returns the current valid range for thermal camera's palette (see `thermalpalette`). returns `nil` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return array of `thermalpalette` elements. each element represents one current palette value.",
             "thermalgainmodetemperaturerangecallback",
             "called when the temperature range changes. only supported by the infrared thermal lens of zenmuse h20t and h20n.",
             "onupdate",
             "updates the temperature range in current gain mode.  @param range the temperature range. the array contains min value, max value.",
             "adddjicameraparameterslistener",
             "adds the listener for the camera range change.  @param listener camera range change listener.",
             "removelistener",
             "remove listener which is listening to the camera range change.  @param listener an instance of djicameraparameterslistener.",
             "removealllistener",
             "remove all listeners.",
             "setmultispectralshutterspeedrangecallback",
             "use this to listen the shutter speed supported by the multispectral camera single-band sensors (sensors except the rgb one).  only supported by multispectral camera of p4 multispectral.  @param listener the interface of `multispectralshutterspeedrangecallback`.",
             "setmultispectralexposurecompensationrangecallback",
             "use this to listen the exposure compensation supported by the multispectral camera single-band sensors (sensors except the rgb one).  only supported by multispectral camera of p4 multispectral.  @param listener the interface of `multispectralexposurecompensationrangecallback`.",
             "moderange",
             "returns the current valid range for camera mode (`cameramode`). returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return array of `cameramode` elements. each element represents one current supported camera mode.",
             "mode_range",
             "sdk key for moderange: returns the current valid range for camera mode (`cameramode`). returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return array of `cameramode` elements. each element represents one current supported camera mode.",
             "exposuremoderange",
             "returns the current valid range for camera's exposure mode (`exposuremode`). returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return array of nsnumber. each element represents one current supported exposure mode.  @return array of `exposuremode`. each element represents one current supported exposure mode.",
             "exposure_mode_range",
             "sdk key for exposuremoderange: returns the current valid range for camera's exposure mode (`exposuremode`). returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return array of nsnumber. each element represents one current supported exposure mode.  @return array of `exposuremode`. each element represents one current supported exposure mode.",
             "isorange",
             "returns the current valid range for camera's iso (see `iso`). returns `null` if current camera does not support any iso value or the camera is disconnected. @return a cameraiso array. each element represent one current supported iso value.  @return array of `iso`. each element represents one current supported iso value.",
             "iso_range",
             "sdk key for isorange: returns the current valid range for camera's iso (see `iso`). returns `null` if current camera does not support any iso value or the camera is disconnected. @return a cameraiso array. each element represent one current supported iso value.  @return array of `iso`. each element represents one current supported iso value.",
             "shutterspeedrange",
             "returns the current valid range for camera's shutter speed (see `shutterspeed`). returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return array of camerashutterspeed. each element represents one current  supported shutter speed value.  @return array of `shutterspeed`. each element represents one current supported shutter speed value.",
             "shutter_speed_range",
             "sdk key for shutterspeedrange: returns the current valid range for camera's shutter speed (see `shutterspeed`). returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return array of camerashutterspeed. each element represents one current  supported shutter speed value.  @return array of `shutterspeed`. each element represents one current supported shutter speed value.",
             "aperturerange",
             "returns the current valid range for camera's aperture (see `aperture`). returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return array of cameraaperture. each element represents one current supported aperture  value.  @return array of `aperture`. each element represents one current supported aperture value.",
             "aperture_range",
             "sdk key for aperturerange: returns the current valid range for camera's aperture (see `aperture`). returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return array of cameraaperture. each element represents one current supported aperture  value.  @return array of `aperture`. each element represents one current supported aperture value.",
             "exposurecompensationrange",
             "returns the current valid range for camera's exposure compensation (see `exposurecompensation`).  returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return array of cameraexposurecompensation. each element represents one  current supported exposure compensation value.  @return array of `exposurecompensation`. each element represents one current supported exposure compensation value.",
             "exposure_compensation_range",
             "sdk key for exposurecompensationrange: returns the current valid range for camera's exposure compensation (see `exposurecompensation`).  returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return array of cameraexposurecompensation. each element represents one  current supported exposure compensation value.  @return array of `exposurecompensation`. each element represents one current supported exposure compensation value.",
             "videoresolutionandframeraterange",
             "returns the current valid range for video resolution cameravideoresolution  and frame rate `videoframerate`. returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return array of pairs. each pair represents a valid `videoresolution` value and `videoframerate` value.",
             "video_resolution_frame_rate_range",
             "sdk key for videoresolutionandframeraterange: returns the current valid range for video resolution cameravideoresolution  and frame rate `videoframerate`. returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return array of pairs. each pair represents a valid `videoresolution` value and `videoframerate` value.",
             "ssdvideoresolutionrange",
             "returns the current valid range for camera's raw video resolution. returns 'nil' if current  camera does not support any raw video resolution or the camera is disconnected.  @return array of pairs. each pair represents a valid `videoresolution` value and `videoframerate` value.",
             "thermalpaletterange",
             "returns the current valid range for thermal camera's palette (see `thermalpalette`).  returns `null` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return array of `thermalpalette` elements. each element represents one current palette value.",
             "multispectralshutterspeedrange",
             "returns the current valid range for multispectral camera's single-band sensors's (sensors except the rgb one). shutter speed (see `shutterspeed`).  returns `null` if current camera does not support any shutter speed value or the camera is disconnected. only supported by multispectral camera of p4 multispectral.  @return array of the `shutterspeed` enum values. each element represents one current supported shutter speed value.",
             "multispectralexposurecompensationrange",
             "returns the current valid range for multispectral camera's single-band sensors's (sensors except the rgb one). exposure compensation (see `exposurecompensation`).   returns `null` if current camera does not support any exposure compensation value or the multispectral camera is disconnected. only supported by multispectral camera of p4 multispectral.  @return array of the `exposurecompensation` enum value. each element represents one current supported exposure compensation value.",
             "djicameraparameterslistener",
             "defines the listeners of the camera parameters range.",
             "oncameraisorangechange",
             "when the camera iso range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncameraexposurecompensationrangechange",
             "when the camera exposure compensation range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncameraexposuremoderangechange",
             "when the camera exposure mode range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncamerashutterspeedrangechange",
             "when the camera shutter speed range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncameramoderangechange",
             "when the camera mode range is changed, the listener will receive this callback.  @param newrange the new range.",
             "onflatcameramoderangechange",
             "when the flat camera mode range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncameravideoresolutionandframeraterangechange",
             "when the camera video resolution and frame rate range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncameraaperturerangechange",
             "when the camera aperture range is changed, the listener will receive this callback.  @param newrange the new range.",
             "oncamerassdrawvideoresolutionrangechange",
             "when the camera ssd raw video resolution and frame rate range is changed, the listener will receive this callback.  @param newrange the new range.",
             "flatcameramoderange",
             "returns the current valid range for flat camera mode (`flatcameramode`). returns null</code>  if `isflatcameramodesupported` return `false` or the camera is disconnected.  @return array of `flatcameramode` elements. each element represents one current supported flat camera mode.",
             "multispectralshutterspeedrangecallback",
             "defines multispectral shutter speed range.",
             "onrangechange",
             "when the range is changed, the listener will receive this callback.  @param newrange the new range.",
             "multispectralexposurecompensationrangecallback",
             "defines multispectral exposure compensation range.",
             "onrangechange",
             "when the range is changed, the listener will receive this callback.  @param newrange the new range.",
             "addmediaupdatedvideoplaybackstatelistener",
             "sets the callback object for updating the video playback state of the media manager.  @param callback callback object of updating the vision detection state.",
             "getscheduler",
             "fetch media task scheduler. this can be used to queue the download of the previews, thumbnails and xml custom data from multiple media files.  @return an object of `fetchmediataskscheduler`.",
             "getsdcardfileliststate",
             "the file list state of the sd card.  @return an enum value of `fileliststate`.",
             "getsdcardfilelistsnapshot",
             "returns a copy of the current file list on the sd card after you call `refreshfilelistofstoragelocation`. returns `null` if `getsdcardfileliststate` is reset.  @return an array of `mediafile` objects.",
             "getinternalstoragefileliststate",
             "the file list state of the internal storage.  @return an enum value of `fileliststate`.",
             "getinternalstoragefilelistsnapshot",
             "returns a copy of the current file list on the internal storage after you call `refreshfilelistofstoragelocation`. returns `nil` if `getinternalstoragefileliststate` is reset or unknown.  @return an array of `mediafile` objects.",
             "refreshfilelistofstoragelocation",
             "refreshes the file list of the storage. if the current state is `reset`, the media manager will try to fetch the complete file list. if the current state  is `incomplete`, the media manager will only fetch the missing list of files. if the file list is refreshed successfully, the corresponding file list state (either `getsdcardfileliststate` or `getinternalstoragefileliststate`) will become `up_to_date`.  @param storagelocation the storage location of the file list to refresh. @param callback completion callback to receive the result.",
             "deletefiles",
             "delete media files from storages. if the operation is started successfully, `fileliststate` will become  `deleting`. if there is error or  failedfiles is not empty, `fileliststate` will become `reset`.  @param files a list of `mediafile` objects. @param callback a completion callback of completioncallbackwithtwoparam<list<mediafile>.",
             "exitmediadownloading",
             "this will entirely stop the downloading process and of course clean the downloading thread pool. the camera will exit the media_download mode and enter the shoot_photo mode.  precondition:  the camera enters the mediadownload mode. post condition:  after this function invoked, the camera mode will shift to takephoto mode.",
             "addupdatefileliststatelistener",
             "start listen to the update of file list state.  @param listener a `fileliststatelistener` interface.",
             "addupdatestoragelocationlistener",
             "start listen to the update of file list state.  @param storagelocation the storage location of the file list. @param listener a `fileliststatelistener` interface.",
             "removefileliststatecallback",
             "stop listen to the update of file list state.  @param listener a `fileliststatelistener` interface.",
             "isvideoplaybacksupported",
             "checks if the media manager supports video playback or not. @return `true` if the media manager supports video playback.  @return `true` if the media manager supports video playback.",
             "playvideomediafile",
             "start video playback through `mediamanager`. when the media manager is playing a video,  playback state received from `onupdate`. video playback through `mediamanager` is fixed at 720p.  @param videomediafile the video to play. @param callback the execution callback with the returned execution result.",
             "resume",
             "the media manager resumes the paused video.  @param callback the execution callback with the returned execution result.",
             "pause",
             "the media manager pauses the playing video.  @param callback the execution callback with the returned execution result.",
             "stop",
             "the media manager stops the playing video.  @param callback the execution callback with the returned execution result.",
             "movetoposition",
             "video playback is skipped to the new position in seconds from the start of the video.  @param position new position to play in seconds from start of video. input with precision of greater than 3 decimal places, will be rounded to 3. @param callback the execution callback with the returned execution result.",
             "iscustomizedcffilesupported",
             "checks if the media manager supports customize dcf file naming rule or not. it is only supported by zenmuse h20 series.  @return `true` if the camera supports customize dcf file.",
             "fileliststate",
             "states of the file list in `mediamanager`.",
             "up_to_date",
             "the file list is up-to-date: it is synchronized with the sd card in the aircraft.",
             "incomplete",
             "new files have been generated since the last call of `refreshfilelistofstoragelocation`. calling `refreshfilelistofstoragelocation` can synchronize the newly generated files and append them to the end of the file list.",
             "reset",
             "the file list is reset. the file list will be reset in one of the following cases:  - camera is disconnected.  - sd card is formatted.  - sd card is not inserted.  - error occurs when deleting files from sd card.  in this state, `getsdcardfilelistsnapshot` will return `null`.",
             "deleting",
             "`deletefiles` has been called and the operation is still in progress.",
             "renaming",
             "a renaming operation is in progress.",
             "syncing",
             "the media manager is synchronizing the file list from the sd card.",
             "unknown",
             "unknown.",
             "videoplaybackstatelistener",
             "updates the video playback state of the media manager. this update method will only be called when the media manager is playing a video.",
             "downloadlistener<e>",
             "this callback will notify the app when the media download executed.",
             "fileliststatelistener",
             "received file list state of the media manager.",
             "mediafile",
             "this class contains information about a multi-media file on the sd card. it also provides methods to retrieve the data in the file.",
             "mediafileinfo",
             "this class contains information about newly generated media file.",
             "videoplaybackstate",
             "the playback state of the media manager.",
             "stopped",
             "the playback is stopped. no media is playing.",
             "playing",
             "the media manager is playing a video.",
             "paused",
             "the playing video is paused.",
             "unknown",
             "the playing video is unknown.",
             "getplayingmediafile",
             "the video media file that is playing.  @return an instance of `mediafile`.",
             "getplaybackstatus",
             "the status of the playback (e.g. playing or paused).  @return an enum value of `videoplaybackstatus`.",
             "getplayingposition",
             "the playing position in seconds.  @return a float value of the playing position in seconds.",
             "videoplaybackstatus",
             "the playback status.",
             "getmediatype",
             "returns the type of media file.  @return an enum value of `mediatype`.",
             "getindex",
             "returns the index of media file. this is the only identifier of the media file. you can use this index to match the index obtained by the `getsdcardfilelistsnapshot` or `getinternalstoragefilelistsnapshot`,   and then you can get more information about the new media file, such as the file name, etc.  @return an int value of media file index.",
             "getfilesize",
             "returns the size, in bytes, of the media file.  @return size of media file.",
             "gettimecreated",
             "returns the time when the media file was created as a long type, unit: second. you can convert the second to date and time format on your own.  @return a long value of the media file created date.",
             "getstreamsourcecamera",
             "returns the stream source of media file.  @return an enum value of `cameravideostreamsource`.",
             "getfilename",
             "returns the name of the media file in the sd card.  @return a string instance of the name of the media file.",
             "isvalid",
             "`true` if the media file is still valid. if a media file is from the file list of the media manager, the file will become invalid after the file list is reset.  @return a boolean value to check if the media file is still valid.",
             "getindex",
             "get the file index used in the camera.  @return an int value of the file index.",
             "getmediatype",
             "returns the type of media file.  @return an enum value of `mediatype`.",
             "getquickshotvideotype",
             "returns the type of quickshot video media file. it is valid when `getvideofiletype` is `quick_shot`.  @return an enum value of `quickshotvideotype`.",
             "getshootphotomode",
             "returns the `shootphotomode` of a photo. returns `null` if `getmediatype` is  `mov` or `mp4`.  @return an enum value of `shootphotomode`.",
             "getpanoramamode",
             "returns the `photopanoramamode` of a photo. it is valid when `getshootphotomode` is `panorama`.  @return an enum value of `photopanoramamode`.",
             "getdownloadedsize",
             "downloaded size in bytes of the media file.  @return a long value of downloaded size.",
             "getfilesize",
             "returns the size, in bytes, of the media file.  @return size of media file.",
             "getdatecreated",
             "returns the time when the media file was created as a string in the format yyyy-mm-dd kk:mm:ss.  @return a string instance of the media file created date.",
             "gettimecreated",
             "returns the time when the media file was created as a long type.  @return a long value of the media file created date.",
             "getdurationinseconds",
             "if the media file is a video, this property returns the duration of the video in seconds. will be 0s if the media file is a photo.  @return media duration.",
             "getframerate",
             "frame rate when the media file is a video.  @return an int value.",
             "getstoragelocation",
             "storage location of the media file.  @return an enum value of `storagelocation`.",
             "getvideofiletype",
             "returns the type of video media file. this property is only valid when the `getmediatype`  is `mov` or `mp4`. returns `null` for other media types.  @return an enum value of `videofiletype`.",
             "getcustominformation",
             "custom information can be stored in media file's xmp meta data using `setmediafilecustominformation` this property contains the information that was written to this media file. if this property returns `null`, use `fetchcustominformation` to populate it. supported by zenmuse p1, zenmuse l1, phantom 4 rtk, phantom 4 pro, phantom 4 advanced and inspire 2 with firmware versions from after may 23 2017.  @return a string value.",
             "getxmpfiledata",
             "this property contains the xmp data which was written to this media file. if this property returns `null`, use `fetchxmpfiledata` to populate it. only supported phantom 4 rtk, zenmuse p1, zenmuse l1.",
             "getresolution",
             "camera video resolution. only supported by video.  @return an enum value of `videoresolution`.",
             "getvideoorientation",
             "the orientation of the camera when the video file was first recorded. if the camera orientation changes during a video capture, this will report the initial orientation. will be `landscape` if the media file is a photo. only mavic pro supports this property. will be `landscape` for other products.  @return an enum value of `orientation`",
             "getthumbnail",
             "returns the thumbnail for this media. if this property returns nil, call `fetchthumbnail`.  @return a bitmap object.",
             "getpreview",
             "returns the preview image for this media. if this property returns `null`, call `fetchpreview`.  @return a bitmap object.",
             "fetchthumbnail",
             "fetches this media's thumbnail with a resolution (99 x 99) from the sd card. this method can be used to fetch either a photo or a video, where the first frame of the video is the thumbnail that is fetched. it is not available if the media type is panorama.  precondition:  the camera mode is mediadownload mode.  post condition:  this method will start to download the media thumbnail in the sd card. the content can be videos or images.  @param callback the `completion callback` with the returned execution result.",
             "resetthumbnail",
             "resets the cached thumbnail to `null` to release the memory usage.  @param callback completion callback with the returned execution result.",
             "fetchpreview",
             "fetch media's preview image. the preview image is a lower resolution (960 x 540) version of a photo. the `mediatype` of this media object should be `jpeg` or `tiff`. the preview will be stored in `getpreview`.  @param callback the `completion callback` with the returned execution result.",
             "resetpreview",
             "resets the cached preview image to `null` to release the memory usage.  @param callback the `completion callback` with the returned execution result.",
             "fetchcustominformation",
             "custom information can be stored in media file's xmp meta data using `setmediafilecustominformation`. the information will be stored in `getcustominformation`. only supported by phantom 4 pro, phantom 4 advanced, phantom 4 pro v2.0, zenmuse p1, zenmuse l1, zenmuse x4s, zenmuse x5s, zenmuse x7 and mavic 2 enterprise camera.  @param callback the `completion callback` with the returned execution result.",
             "fetchxmpfiledata",
             "fetch the xmp data stored in the media file. the data will be stored in `getxmpfiledata`. only supported by zenmuse p1, zenmuse l1, phantom 4 rtk.  @param callback the `completion callback` with the returned execution result.",
             "fetchfilebytedata",
             "fetches this media file's full resolution data from camera by byte.  you can get the media file data with `onrealtimedataupdate`. the difference between fetching the media data and fetching the thumbnail is that fetching the thumbnail will return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. if last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param offset the byte offset strarting to download media file. @param callback completion callback that receives the execution result.",
             "fetchfiledata",
             "fetches this media file's full resolution data from camera. the difference between  fetching the media data and fetching the thumbnail is that fetching the thumbnail will  return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. if last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param destdir file instance of location to save the files, which can not be null. @param filenamewithoutextension the filename to store in mobile devices, without the file extension.<br> if it is null, the file name in the camera's sdcard will be used. @param callback completion callback that receives the execution result.",
             "stopfetchingfiledata",
             "stops a currently executing call of `fetchfiledata`.  @param callback the `completion callback` with the returned execution result.",
             "fetchsubfiledatalist",
             "fetches the file data of the sub media files. it is available only when `getmediatype` is `panorama` or `shallow_focus`.  @param callback completion callback that receives the execution result.",
             "fetchsuperresjson",
             "super resolution json file was used to save super resolution photo coordinate info.  @param callback completion callback that receives the execution result.",
             "mediatype",
             "media types.",
             "videofiletype",
             "video file types. it is not supported by `onnewfile` return `mediafile` media file object.",
             "quickshotvideotype",
             "the quickshot modes of the video file when its type is `quick_shot`.",
             "audiomediafile",
             "this class represents the information of an audio file in the aircraft. the audio  file is not accessible if the aircraft is connected to a pc with the usb port.  for m2e speaker, it only supports audio files with the following conditions:  the audio channel is mono. the audio sample rate is 44,100 hz. the pcm (pulse-code modulation)  sample depth is 16 bit per sample. the `audiomediafile` contains  following properties:  - `getfilename`  - `getdurationinseconds` - `getindex`  - `getstoragelocation`",
             "getaudiostoragelocation",
             "the storage location to store the file in the aircraft.  @return an enum value of the `audiostoragelocation`.",
             "audiostoragelocation",
             "storage types of audio files. the storage types will determine the strategy of the aircraft to keep the file.",
             "temporary",
             "the audio file is stored to a temporary space. files with temporary storage location will be automatically deleted when the aircraft reboots.",
             "persistent",
             "the audio file is stored to a persistent space. files with persistent storage location should be deleted manually by calling `delete`.",
             "unknown",
             "unknown.",
             "unknown",
             "unknown file type.",
             "jpeg",
             "image of jpeg format.",
             "mp4",
             "video of mp4 format.",
             "mov",
             "video of mov format.",
             "raw_dng",
             "image of dng format.",
             "panorama",
             "panorama file type.",
             "tiff",
             "tiff file type.",
             "shallow_focus",
             "shallowfocus file type. shallowfocus files have a shallow depth of field.",
             "seq",
             "tiff sequence file type. it is a video format for infrared cameras.",
             "tiff_seq",
             "seq file type. it is a video format for infrared cameras.",
             "json",
             "json file type. it is a json format for save image information. it is used to storage the coordinate information for super resolution in zenmuse h20 series.",
             "photo_folder",
             "photo folder. it is a folder for save image files.",
             "video_folder",
             "video folder. it is a folder for save video files.",
             "normal",
             "the video file is recorded in normal mode.",
             "time_lapse",
             "the video file is recorded in time-lapse mode.",
             "slow_motion",
             "the video file is recorded as slow motion video.",
             "quick_shot",
             "the video file is recorded during a quickshot mission.  use `quick_shot`  to check the detail quickshot mode of the video file.",
             "hyperlapse",
             "the video is recorded when the aircraft is in hyper-lapse mode.  it is only supported by mavic 2 zoom and mavic 2 pro. hyper-lapse  is only supported by dji go 4.",
             "unknown",
             "unknown.",
             "none",
             "the video file is not a quickshot video.",
             "circle",
             "the quickshot video file is recorded in circle mode.",
             "dronie",
             "the quickshot video file is recorded in dronie mode.",
             "helix",
             "the quickshot video file is recorded in helix mode.",
             "rocket",
             "the quickshot video file is recorded in rocket mode.",
             "boomerang",
             "the quickshot video file is recorded in boomerang mode.",
             "asteroid",
             "the quickshot video file is recorded in asteroid mode.",
             "dolly_zoom",
             "the quickshot video file is recorded in dollyzoom mode.",
             "unknown",
             "unknown.",
             "onupdate",
             "updates the video playback state of the media manager. this update method will only be called when the media manager is playing a video.  @param videoplaybackstate videoplaybackstate object.",
             "onstart",
             "called when the file download begins.",
             "onrateupdate",
             "called to show the download rate. it is called every 1 second. hence, the persize which is the download size among two calls is the download rate.  @param total the total size. @param current the current download size. @param persize the download size between two calls.",
             "onrealtimedataupdate",
             "called to get the media file data download from camera by byte in real time.  @param data the media file data download from camera by byte. @param position the byte offset into the meida file at which the data starts. @param islastpack `true` if the pack is the last one.",
             "onprogress",
             "called to update the download progress. it is called every time there is data received.  @param total the total size of the file being downloaded. @param current the current download data size.",
             "onsuccess",
             "called when the media download is completed.  @param data the media that was successfully downloaded",
             "onfailure",
             "called when the media download failed.  @param error the error information.",
             "onfileliststatechange",
             "updates the file list state of the media manager.  @param state the new file list state.",
             "fetchmediataskscheduler",
             "the camera stores the media it captures to sd or ssd storage on the product. when the mobile device wants to access the media, it needs to download it from the product over the wireless link between the product, remote controller and mobile device (depending on the product). each media file captured by the camera can have several types of content associated with it including the full resolution media content, a lower resolution preview, a lower resolution again thumbnail, and custom data within the file's xml meta data. the full resolution content can take a long time to download over the wireless link, so it is often useful to download previews or thumbnails of many media files, and then only download the full resolution content of fewer select media files. this scheduler conveniently allows the small content types of media files (preview, thumbnail and custom data) to be downloaded to the mobile device. the scheduler can be used to queue and download content from a series of files, as well as used to re-prioritize files during the download process. the scheduler holds a list of pending tasks and it completes them one by one in first-in-first-out order. to prioritize a new task, `movetasktonext` can be used. each task relates to a media file and can download multiple content types sequentially. when the last content type of a task starts being downloaded, the task is removed from the list. note, the scheduler cannot be used to queue the download of full resolution media content. only `fetchfiledata` can be used for this.",
             "getstate",
             "state of the scheduler.  @return an enum value of `fetchmediataskschedulerstate`.",
             "getpendingtasks",
             "gets a copy of the pending tasks.  @return a list of `fetchmediatask` objects.",
             "movetasktoend",
             "pushes a task to the back of the queue. the task will be executed after all other tasks are complete.  @param task task to schedule.",
             "movetasktonext",
             "pushes a task to the front of the queue. the task will be executed after the executing task is complete.  @param task task to schedule.",
             "removetask",
             "remove content from tasks, and tasks from the scheduler. if all content is removed from a task, then the task is removed from the scheduler.  @param file an object of `mediafile`. @param content an enum value of `fetchmediataskcontent`.",
             "removealltasks",
             "removes all the pending tasks.",
             "suspend",
             "suspends the scheduler. the scheduler will not continue to execute tasks in the queue.  @param callback the `completion callback` with the returned execution result.",
             "resume",
             "resumes the scheduler. the scheduler will execute tasks in the queue sequentially.  @param callback the `completion callback` with the returned execution result.",
             "issuspendaftersinglefetchtaskfailure",
             "determines whether suspend the scheduler when an error occurs during the execution.  @return a boolean value.",
             "setsuspendaftersinglefetchtaskfailure",
             "sets if suspend the scheduler when an error occurs during the execution.  @param suspendaftersinglefetchtaskfailure a boolean value.",
             "fetchmediataskschedulerstate",
             "states of the fetch media file task scheduler `fetchmediataskscheduler`.",
             "idle",
             "scheduler is waiting for tasks.",
             "executing",
             "scheduler is executing tasks.",
             "suspended",
             "scheduler is suspended. use `resume` to resume the scheduler.",
             "unknown",
             "unknown.",
             "fetchmediatask",
             "task to fetch contents of a media file. to make `fetchmediataskscheduler` fetch the thumbnail, preview or custom information of a media file, a task should be created by using `fetchmediatask`.",
             "fetchmediatask",
             "creates a task instance.  @param file media file to execute task on. @param content content to fetch. @param callback the `completion callback` with the returned execution result.",
             "fetchmediatask",
             "creates a task instance without callback.  @param file media file to execute task on. @param content content to fetch.",
             "callback",
             "callback that is called when the scheduler finishes downloading content for a fetch media file task. if multiple content types are defined for a file, this completion block will be called at the completion of each content type being downloaded. the order content types will be downloaded in is first `thumbnail`, then `preview`.",
             "onupdate",
             "called each time the scheduler finishes downloading content.  @param file file to execute task on. @param option an enum value of `fetchmediataskcontent`. @param error error retrieving the value.",
             "fetchmediataskcontent",
             "the content to download in a fetch media file task.",
             "none",
             "none.",
             "thumbnail",
             "the scheduler will download the thumbnail of the media file.",
             "preview",
             "the scheduler will download the preview image of the media file.",
             "custom_information",
             "the scheduler will download the custom information of the media file.",
             "setplaybackstatecallback",
             "sets the camera's playback state callback. called according to the camera's update timer.  precondition:  you must first define a callback object to pass in as a parameter.  post  condition:  every time the playback state changes, the callback interface that was passed in as a parameter will call its onresult function.  the onresult function takes in a djicameraplaybackstate  object, which provides playback information such as the number of photos currently selected, the video playback  progress (if a video is being played), and much more.  @param cameraplaybackstatecb the callback object to set as the callback interface for when the playback state changes.  <br> the callback interface implements an onresult function, which takes in a  djicameraplaybackstate object from the aircraft. <br>",
             "entersinglepreviewmodewithindex",
             "enters single file preview mode for a file at the specified index. in order for this method to be called,  the camera work mode must be `playback`.  @return  djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @param index file to be previewed at the specified index. the value falls in [1,8].  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "proceedtonextsinglepreviewpage",
             "goes to the next page.  precondition:  the camera must enter single file preview mode.   special case:  if it is the last image, it will go to the first image. @return djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "proceedtoprevioussinglepreviewpage",
             "goes back to the previous page.  precondition:  the camera must enter single file preview mode.  special case:  if it is the first image, it will go to the last image. @return djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "playvideo",
             "starts video playback. the selected file must be a video file.  precondition:  the camera must enter  single preview mode.  post condition:  if the video finishes playing, it will stop and go back to the  beginning of the file. @return djicameraerror shows the possible error during the execution. if there is no error,  it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "pausevideo",
             "pauses a video during playback.  precondition:  the video is being played.  @return  djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "stopvideo",
             "stops a video during playback.  precondition:  the video is being played.  post condition:   the file will stop and go back to the beginning of the file. @return djicameraerror shows the possible error during  the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "playvideofrompositioninpercent",
             "plays a video from the specified location. the selected file must be a video file.  precondition:   the camera must enter single file preview mode.  post condition:  the file will play from a specific location immediately. this command can only be called if the video is currently playing or is paused. if paused, the playback position will be updated and playing will resume.  @return djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @param location location from which to play the video must be in the range of [0, 100]. this value  represents at what percent of the entire video it should start playing.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "deletecurrentpreviewfile",
             "deletes the current file being previewed.  precondition:  the camera must enter single file preview  mode.  post condition:  the image will be deleted from the sd card. @return djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "entermultiplepreviewmode",
             "enables the user to preview multiple files when the camera is in playback mode.  precondition:  the  camera work mode should be set to playback mode.  post condition:  there will be 8 images on one page.  @return djicameraerror shows the possible error during the execution. if there is no error, it returns  null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "proceedtonextmultiplepreviewpage",
             "goes to the next page when there are multiple pages.  precondition:  the camera must enter multiple  preview mode.  special case:  if it is the last page, it will stay at the last page.  @return djicameraerrorr shows the possible error during the execution. if there is no error, it  returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "proceedtopreviousmultiplepreviewpage",
             "goes back to the previous page when there are multiple pages.  precondition:   the camera must enter multiple preview mode.  special case:  if it is the first page, it will  stay at the first page. @return djicameraerror shows the possible error during the execution. if there is  no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "entermultipleeditmode",
             "this enables the user to select, download, or delete multiple media files when the camera is in playback mode.  precondition:  the camera work mode must be set to camera play back mode and then multiple preview mode.  post condition:  multiple photos can be selected to be downloaded or deleted. @return djicameraerror shows the  possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "exitmultipleeditmode",
             "exits multiple edit mode. @return djicameraerror shows the possible error during the execution. if there is no error, it returns null.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "togglefileselectionatindex",
             "selects or unselects a file at the specified index of the current page. this index is unrelated to the filename,  and is used in multiple edit mode.  precondition:  the camera must enter multiple edit mode.   @return djicameraerror shows the possible error during the execution. if there is no error, it returns  null</code>.  @param index index at which to select a file. the value falls in [1,8]. however, the exact range should depends on how many photos totally in current page.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "selectallfiles",
             "selects all the files on the sd card.  precondition:  the camera must enter multi edit mode.  @return djicameraerror shows the possible error during the execution. if there is no error, it  returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "unselectallfiles",
             "unselects all the files on the sd card.  precondition:  the camera must enter multiple edit mode.  @return djicameraerror shows the possible error during the execution. if there is no error,  it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "selectallfilesinpage",
             "selects all the file(s) on the current page.  precondition:  the camera must enter multiple edit mode.   @return djicameraerror shows the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "unselectallfilesinpage",
             "unselects all the file(s) on the current page.  precondition:  the camera must enter multiple edit  mode. @return djicameraerror shows the possible error during the execution. if there is no error, it  returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "deleteallselectedfiles",
             "deletes all selected files from the sd card.  precondition:  the camera must enter multiple edit mode.  post condition:  the images will be deleted from the sd card.  @return djicameraerror shows  the possible error during the execution. if there is no error, it returns null</code>.  @return `djicameraerror` shows the possible error during the execution. if there is no error, it returns null.",
             "downloadselectedfiles",
             "downloads the currently selected media files.  precondition:  the camera must enter multiple preview mode.  @param destdir the destination file directory, e.g., sdcardpath/folder/ @param callback the execution callback.",
             "filedownloadcallback",
             "this callback will notify the process of downloading selected files.",
             "playbackstate",
             "this class provides the current state of the playback manager, which includes the numbers of thumbnail and media files, video duration, video play progress, and file download state.",
             "onupdate",
             "updates the playback state of the camera. this update method will only be called when the camera's work mode is  set to `playback`.  @param state contains the state information when the camera in the playback state, such as numbers of photos in the sd card, numbers of videos in the sd card and the media file type.",
             "onstart",
             "called as a file is about to start downloading.",
             "onend",
             "called when a file has completed downloading.",
             "onerror",
             "called when there is an error during download.  @param exception the error exception.",
             "onprogressupdate",
             "called to update the progress on downloading a file in percent. range is [0, 100].  @param progress the progress of downloading.",
             "getplaybackmode",
             "the current mode of the playback manager.  @return playback manager current mode.",
             "getnumberofmediafiles",
             "the total number of media files on the sd card, including photos and videos.  @return number of media files.",
             "getnumberofthumbnails",
             "the total number of thumbnails for both the photos and videos being viewed on the page. the value of the property  is valid when the `playbackmode`  is `multiple_media_file_preview` .  @return number of thumbnails.",
             "getphotocount",
             "the total number of photos on the sd card.  @return number of photos.",
             "getvideocount",
             "the total number of videos on the sd card.  @return number of videos.",
             "getfiletype",
             "the type of the current file. the cameramediafiletype includes  types of jpeg, dng and video.  the value of this property is valid when the playbackmode  is `single_photo_preview`, `single_video_playback_start` .  @return media file type.",
             "getvideoduration",
             "the duration in second of the playing video. the value of the property is valid only when `playbackmode`  is `single_video_playback_start`  .  @return duration of video.",
             "getvideoplayprogress",
             "the progress, in percentage, of the playing video. the valid range is [0, 100]. the value the property is valid  only when `playbackmode`  is `single_video_playback_start`  .  @return percentage progress of view playback.",
             "getvideoplayposition",
             "the played duration, in seconds, of the playing video. the value the property is valid only when `playbackmode`  is `single_video_playback_start` .  @return current play position of video.",
             "getphotowidth",
             "the width of the photo.  @return width of photo.",
             "getphotoheight",
             "the dimension of the previewing photo. the value of the property is valid only when `playbackmode`  is `single_photo_preview`  and `getfiletype`  is `jpeg`.  @return height of photo.",
             "getcurrentselectedfileindex",
             "the index of the current selected file.  @return index of selected file.",
             "getselectedfilecount",
             "the total number of the selected files. the value is valid while `playbackmode` is in djicameraplaybackmodemultiplefilesedit</code>.  @return number of selected files.",
             "areallfilesinpageselected",
             "`true` if all the files on the current page are selected.  @return response of all files being selected on page.",
             "isselectedfilevalid",
             "`true` if the previewing file is a valid photo or video. the value of the property is valid  only when `playbackmode`  is `single_photo_preview`.  @return if file being previewed is a valid photo or video file.",
             "getplaybackdeletionstate",
             "the current status of a file when the user tries to delete it.  @return status of file being deleted.",
             "isfiledownloaded",
             "`true` if the previewing file has been downloaded. the value of the property is valid only when `playbackmode`  is `single_photo_preview`.  @return `true` if the previewing file has been downloaded.",
             "tostring",
             "gets a string containing information about the playback state. @return a string of playback state.  @return a string instance of playback state.",
             "callback",
             "the interface provides the method to receive the updated state of the playback manager.",
             "filetype",
             "showing media file types when the camera is in playback mode.",
             "playbackmode",
             "a playback mode represents a task that the playback manager is executing.",
             "playbackdeletionstate",
             "the file deletion status when deleting a file as the camera is in playback mode.",
             "jpeg",
             "the jpeg media file type.",
             "dng",
             "the dng media file type.",
             "video",
             "the video media file type.",
             "unknown",
             "the playback file format is unknown.",
             "single_photo_preview",
             "single file preview mode.",
             "single_video_playback_start",
             "single video playback start.",
             "single_video_playback_paused",
             "single video playback pause.",
             "multiple_files_edit",
             "multiple file edit.",
             "multiple_media_file_preview",
             "multiple media file preview.",
             "media_file_download",
             "download media files.",
             "unknown",
             "unknown playback mode.",
             "none",
             "camera is not deleting files.",
             "failed",
             "media file delete failed.",
             "deleting",
             "media file is deleting.",
             "successful",
             "delete media file successfully.",
             "unknown",
             "media file unknown delete status.",
             "setvisiondetectionstateupdatedcallback",
             "set intelligent flight assistant state update callback.  @param callback the execution callback with the execution result returned.",
             "setvisioncontrolstateupdatedcallback",
             "callback function that updates aircraft state. controlled by the intelligent flight assistant.  @param callback the execution callback with the execution result returned.",
             "setfaceawarestatecallback",
             "starts to receive the update of faceawarestate.  @param callback faceawarestate update callback.",
             "setpalmcontrolstatecallback",
             "starts to receive the update of palmcontrolstate.  @param callback palmcontrolstate update callback.",
             "setsmartcapturestatecallback",
             "starts to receive the update of smartcapturestate.  @param callback smartcapturestate update callback.",
             "setvisualperceptioninformationcallback",
             "updates the visual perception information. only supported by matrice 300 rtk, mavic air 2, dji air 2s.  @param callback completion block that receives the execution result.",
             "settofperceptioninformationcallback",
             "updates the tof perception information. only supported by matrice 300 rtk, mavic air 2, dji air 2s.  @param callback the execution callback with the returned execution result.",
             "setobstacleavoidancesensorstatelistener",
             "updates the obstacle avoidance sensor's state.  @param callback completion block that receives the execution result.",
             "setcollisionavoidanceenabled",
             "enable collision avoidance. when enabled, the aircraft will stop and try to go around detected obstacles.  @param enable a boolean value. @param callback completion callback.",
             "collision_avoidance_enabled",
             "sdk key for setcollisionavoidanceenabled: enable collision avoidance. when enabled, the aircraft will stop and try to go around detected obstacles.  @param enable a boolean value. @param callback completion callback.",
             "getcollisionavoidanceenabled",
             "gets collision avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "collision_avoidance_enabled",
             "sdk key for getcollisionavoidanceenabled: gets collision avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "setactiveobstacleavoidanceenabled",
             "enables/disables active obstacle avoidance. when enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. if while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setcollisionavoidanceenabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback completion callback that receives the setter result.",
             "active_obstacle_avoidance_enabled",
             "sdk key for setactiveobstacleavoidanceenabled: enables/disables active obstacle avoidance. when enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. if while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setcollisionavoidanceenabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback completion callback that receives the setter result.",
             "getactiveobstacleavoidanceenabled",
             "gets active obstacle avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "active_obstacle_avoidance_enabled",
             "sdk key for getactiveobstacleavoidanceenabled: gets active obstacle avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "setupwardvisionobstacleavoidanceenabled",
             "enables/disables upward avoidance. when the inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. the sensor has a 10-degree horizontal field of view (fov) and 10-degree vertical fov. the maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback completion callback that receives the setter result.",
             "upwards_avoidance_enabled",
             "sdk key for setupwardvisionobstacleavoidanceenabled: enables/disables upward avoidance. when the inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. the sensor has a 10-degree horizontal field of view (fov) and 10-degree vertical fov. the maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback completion callback that receives the setter result.",
             "getupwardvisionobstacleavoidanceenabled",
             "gets upward avoidance status (enabled/disabled). it is only supported by matrice 300 rtk.  @param callback the execution callback with the returned value(s).",
             "setadvancedgesturecontrolenabled",
             "enables/disables advanced gesture control. when enabled, users can use palmlaunch, palmland, palmcontrol and beckon. when enabled, the various modes can be initiated by the user. in summary:  - aircraft starts idle on users hand  - user double clicks the power button and faceaware becomes active  - once a face is recogized, palmlaunch will happen  - when flying, the user can control the aircraft position by moving their palm  - if the user waves one hand, the aircraft will fly up and backwards and start following the user.  - if the user waves both hands, the aircraft will execute beckon and return to the user.  it is only supported by spark.  @param enabled `true` to enable advanced gesture control. @param callback the `completion callback` with the returned execution result.",
             "getadvancedgesturecontrolenabled",
             "determines whether advanced gesture control is enabled. when enabled, users can use palmlaunch, palmland, palmcontrol and beckon. it is only supported by spark.  @param callback the `completion callback` with the returned execution result.",
             "issmartcapturesupported",
             "determines if smartcapture is supported. this feature is only supported by mavic air.  @return `true` if smart capture is supported.",
             "setsmartcaptureenabled",
             "enables/disables smartcapture. when enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (gesturelaunch, follow and gestureland) using simple hand gestures. it is only supported when `issmartcapturesupported` returns `true`.  @param enabled `true` to enable smartcapture. @param callback completion block with the returned execution result.",
             "getsmartcaptureenabled",
             "determines whether smartcapture is enabled. when enabled, users can when enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (gesturelaunch, follow and gestureland) using simple hand gestures. it is only supported when `issmartcapturesupported` returns `true`.  @param callback completion block with the returned execution result.",
             "setsmartcapturefollowingmode",
             "sets the following mode for smartcapture. it is only valid when smartcapture is enabled.  @param mode the following mode to set. @param callback completion block with the returned execution result.",
             "getsmartcapturefollowingmode",
             "gets the following mode for smartcapture. it is only valid when smartcapture is enabled.  @param callback completion block with the returned execution result.",
             "setadvancedpilotassistancesystemenabled",
             "enables the advanced pilot assistance system (apas). when apas is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. apas makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. it is only valid when the aircraft is in p-mode. it is only supported by mavic air, mavic 2 pro, mavic 2 zoom, mavic 2 enterprise.  @param enabled `true` to enable apas. @param callback the completion callback with the returned execution result.",
             "getadvancedpilotassistancesystemenabled",
             "determines whether the advanced pilot assistance system (apas) is enabled or not. when apas is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. apas makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. it it is only supported by mavic air, mavic 2 pro, mavic 2 zoom, mavic 2 enterprise.  @param callback the completion callback with the returned execution result.",
             "setforbidsideflyenable",
             "enables/disabled the forbid side fly switch. in apas mode when the forbid side fly switch is turned on, the aircraft cannot fly sideways. supported by dji air 2s.  @param enabled `true` to enable forbid side fly. @param callback the completion callback with the returned execution result.",
             "getforbidsideflyenable",
             "determines whether the forbid side fly switch is enabled or not.  @param callback the completion callback with the returned execution result.",
             "setrthobstacleavoidanceenabled",
             "enables obstacle avoidance during rth. this is only active when the environment is bright enough. it is not active when the aircraft is landing. caution: if rth obstacle avoidance is disabled, aircraft will not check obstacles during rth or ascend to avoid obstacles, which may cause great risks.  @param enabled `true` to enable obstacle avoidance during rth. @param callback completion callback that receives the setter result.",
             "getrthobstacleavoidanceenabled",
             "determines if obstacle avoidance is enabled during rth. this is only active when the environment is bright enough. it is not active when the aircraft is landing. caution: if rth obstacle avoidance is disabled, aircraft will not check obstacles during rth or ascend to avoid obstacles, which may cause great risks.  @param callback completion callback with the returned value(s).",
             "setrthremoteobstacleavoidanceenabled",
             "enables remote obstacle avoidance during rth. enabling this, the aircraft will adjust its rth route automatically to avoid obstacles in far distance. the gimbal will not respond to any commands from the application or the remote controller.  @param enabled `true` to enable remote obstacle avoidance during rth. @param callback completion callback that receives the setter result.",
             "getrthremoteobstacleavoidanceenabled",
             "determines if rth remote obstacle avoidance is enabled or not. when it is enabled, the aircraft will adjust its rth route automatically to avoid obstacles in far distance. the gimbal will not respond to any commands from the application or the remote controller.  @param callback completion callback with the returned value(s).",
             "setdownwardfilllightmode",
             "sets the downward fill light mode. it is supported by mavic 2 series and matrice 300 rtk.  @param mode see enum `filllightmode`. @param callback completion block to receive the result.",
             "getdownwardfilllightmode",
             "gets the downward fill light mode. it is supported by mavic 2 series and matrice 300 rtk.  @param callback completion block to receive the result.",
             "setupwardfilllightmode",
             "sets the upward fill light mode. it is only supported by matrice 300 rtk. the distance range for `horizontal` is 1m~5m. the distance range for `upward` is 1m~10m. the distance range for `downward` is 1dm~30dm.  @param mode see enum `filllightmode`. @param callback completion block to receive the result.",
             "getupwardfilllightmode",
             "gets upward fill light mode. it is only supported by matrice 300 rtk.  @param callback completion block to receive the result.",
             "setmaxperceptiondistance",
             "sets the maximum perception distance that could be measured. it is supported only by matrice 300 rtk. the distance range is 5m~45m for all direction.  @param distance the maximum perception distance that could be measured. @param direction the perception direction.",
             "getmaxperceptiondistance",
             "gets the maximum perception distance that could be measured. it is supported only by matrice 300 rtk.  @param direction the maximum perception distance that could be measured. @param callback completion block that receives the execution result.",
             "sethorizontalvisionobstacleavoidanceenabled",
             "set to enable or disable horizontal vision obstacle avoidance. it is supported only by matrice 300 rtk.  @param enabled `true` to enable horizontal vision obstacle avoidance. @param callback completion block that receives the execution result.",
             "gethorizontalvisionobstacleavoidanceenabled",
             "gets horizontal vision obstacle avoidance (enabled/disabled). it is supported only by matrice 300 rtk.  @param callback completion block that receives the execution result.",
             "setvisualobstaclesavoidancedistance",
             "sets the distance to engage active brake for obstacles avoidance.  @param distance the distance to engage active brake. @param direction the perception direction. if is `djiflightcontroller_djiflightassistantobstaclesensingdirection_downward`, the distance range is [0.1, 3], for matrice 300 rtk the range is [0.4, 3]. if is `djiflightcontroller_djiflightassistantobstaclesensingdirection_upward`, the distance range is [1.0, 10]. if is `djiflightcontroller_djiflightassistantobstaclesensingdirection_horizontal`, the distance range is [1.0, 5]. @param callback completion block to receive the result.",
             "getvisualobstaclesavoidancedistance",
             "gets current distance to engage active brake for obstacles avoidance.  @param direction the perception direction. @param callback completion block that receives the execution result.",
             "setvisionassistedpositioningenabled",
             "enable vision positioning. vision positioning is used to augment gps to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback completion callback.",
             "vision_assisted_positioning_enabled",
             "sdk key for setvisionassistedpositioningenabled: enable vision positioning. vision positioning is used to augment gps to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback completion callback.",
             "getvisionassistedpositioningenabled",
             "gets vision positioning status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "vision_assisted_positioning_enabled",
             "sdk key for getvisionassistedpositioningenabled: gets vision positioning status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "setprecisionlandingenabled",
             "enables/disables precision landing. when enabled, the aircraft will record its take-off location visually (as well as with gps). on a return-to-home action the aircraft will attempt to perform a precision landing using the additional visual information. this method only works on a return-to-home action when the home location is successfully recorded during take-off, and not changed during flight, it will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
             "precision_landing_enabled",
             "sdk key for setprecisionlandingenabled: enables/disables precision landing. when enabled, the aircraft will record its take-off location visually (as well as with gps). on a return-to-home action the aircraft will attempt to perform a precision landing using the additional visual information. this method only works on a return-to-home action when the home location is successfully recorded during take-off, and not changed during flight, it will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
             "getprecisionlandingenabled",
             "gets precision landing status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "precision_landing_enabled",
             "sdk key for getprecisionlandingenabled: gets precision landing status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "setlandingprotectionenabled",
             "enables/disables landing protection. during auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. if it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:callback> that receives the setter result.",
             "landing_protection_enabled",
             "sdk key for setlandingprotectionenabled: enables/disables landing protection. during auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. if it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:callback> that receives the setter result.",
             "getlandingprotectionenabled",
             "gets landing protection status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "landing_protection_enabled",
             "sdk key for getlandingprotectionenabled: gets landing protection status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "callback",
             "callback to update the faceawarestate.",
             "callback",
             "callback to update the palmcontrolstate.",
             "callback",
             "callback to update the smartcapturestate.",
             "visiondetectionstate",
             "this class gives state information about the product's vision sensors used for obstacle detection. the two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (tof) sensors. note, inspire 2's upwards-facing infrared tof sensor is not returned in this state. it is accessed through `visioncontrolstate`.",
             "vision_detection_state",
             "sdk key for visiondetectionstate: this class gives state information about the product's vision sensors used for obstacle detection. the two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (tof) sensors. note, inspire 2's upwards-facing infrared tof sensor is not returned in this state. it is accessed through `visioncontrolstate`.",
             "visioncontrolstate",
             "this class gives the aircraft's state, which is controlled by the intelligent flight assistant.",
             "smartcapturestate",
             "the object includes all information related to smartcapture.",
             "perceptioninformation",
             "this class contains the aircraft's perception information. it is supported only by matrice 300 rtk.",
             "getdatapackageindex",
             "the perception package count.  @return an int value of the perception package index.",
             "getangleinterval",
             "distance value detected away from the obstacles are at an interval of angle around the aircraft in 360 degrees horizontally.  @return a float value of angle interval.",
             "getdistances",
             "each value represents the distance in millimeters away from the obstacles detected around in 360 degrees horizontally at an interval of angle. please refer to `getdatapackageindex` to get the interval of angle. 0 degree points to the aircraft's heading. 90 degrees point to the right of the aircraft. 180 degrees point to the aircraft's tail.  @return an array of int values.",
             "getupwardobstacledistance",
             "the upward obstacle distance.  @return an int value of the upward obstacle distance.",
             "getdownwardobstacledistance",
             "the downward obstacle distance. not supported by mavic air 2 and dji air 2s  @return an int value of downward obstacle distance.",
             "obstacleavoidancesensorstate",
             "current state of obstacle avoidance sensor.",
             "isupwardvisualobstacleavoidancesensorworking",
             "determines if upward visual obstacle avoidance sensor is working.  @return a boolean value to check upward obstacle avoidance sensor working.",
             "isleftsidevisualobstacleavoidancesensorworking",
             "determines if left side visual obstacle avoidance sensor is working.  @return a boolean value to check left side obstacle avoidance sensor working.",
             "isrightsidevisualobstacleavoidancesensorworking",
             "determines if right side visual obstacle avoidance sensor is working.  @return a boolean value to check right side obstacle avoidance sensor working.",
             "isbackwardvisualobstacleavoidancesensorworking",
             "determines if backward visual obstacle avoidance sensor is working.  @return a boolean value to check backward obstacle avoidance sensor working.",
             "isforwardvisualobstacleavoidancesensorworking",
             "determines if forward visual obstacle avoidance sensor is working.  @return a boolean value to check forward obstacle avoidance sensor working.",
             "isdownwardvisualobstacleavoidancesensorworking",
             "determines if downward visual obstacle avoidance sensor is working.  @return a boolean value to check downward obstacle avoidance sensor working.",
             "arevisualobstacleavoidancesensorsinverticaldirectionworking",
             "determines if visual obstacle avoidance sensors in vertical direction are working.  @return a boolean value to check obstacle avoidance sensors in vertical direction.",
             "arevisualobstacleavoidancesensorsinhorizontaldirectionworking",
             "determines if visual obstacle avoidance sensors in horizontal direction are working.  @return a boolean value to check obstacle avoidance sensors in horizontal direction.",
             "isupwardvisualobstacleavoidancesensorenabled",
             "whether the upward visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check upward obstacle avoidance sensor enabled or not.",
             "isleftsidevisualobstacleavoidancesensorenabled",
             "whether the left side visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check left side obstacle avoidance sensor enabled or not.",
             "isrightsidevisualobstacleavoidancesensorenabled",
             "whether the right side visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check right side obstacle avoidance sensor enabled or not.",
             "isbackwardvisualobstacleavoidancesensorenabled",
             "whether the backward visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check the backward obstacle avoidance sensor is enabled or not.",
             "isforwardvisualobstacleavoidancesensorenabled",
             "whether the forward visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check the forward obstacle avoidance sensor is enabled or not.",
             "isdownwardvisualobstacleavoidancesensorenabled",
             "whether the downward visual obstacle avoidance sensor is enabled or not.  @return a boolean value to check the downward obstacle avoidance sensor is enabled or not.",
             "arevisualobstacleavoidancesensorsinverticaldirectionenabled",
             "whether the visual obstacle avoidance sensors in vertical direction are enabled or not.  @return a boolean value to check the obstacle avoidance sensor in vertical direction is enabled or not.",
             "arevisualobstacleavoidancesensorsinhorizontaldirectionenabled",
             "whether the visual obstacle avoidance sensors in horizontal direction are enabled or not.  @return a boolean value to check the obstacle avoidance sensor in horizontal direction is enabled or not.",
             "setstatecallback",
             "set rtk state update callback.  @param callback the execution callback with the execution result returned.",
             "addreferencestationsourcecallback",
             "adds a listener to receive the reference station source.  @param callback callback to receive reference station source.",
             "removereferencestationsourcecallback",
             "removes a listener that receives the reference station source.  @param callback callback to receive reference station source.",
             "rtkbasestationlistcallback",
             "callback interface that updates the array of the rtk base station scanned information. if you  call `startsearchbasestation`, each base station while push it's information once. if  you call `stopsearchbasestation`, this callback function will stop updates.",
             "onupdate",
             "provides the list of dji base station that can be connected with. callback will continue to receive an updated list  after `startsearchbasestation` is called. invoke `stopsearchbasestation` to stop searching.  @param basestationinformations an array contains base station scan information.",
             "setrtkbasestationlistcallback",
             "sets rtk base station scanned information update rtkbasestationlistcallback.  @param callback callback to receive the information of rtk base station scanned.",
             "rtkconnectionstatewithbasestationreferencesourcecallback",
             "callback interface that updates rtk connection state and connected base station information.",
             "onupdate",
             "updates rtk connection state and connected base station information. aircraft will try to connect to the base station  connected last time after it restarts. stops to reconnect after 10 seconds. if current connection state  is `scanning` or `idle`,  this method still updates the base station information connected last time. only can be used when current `referencestationsource`  is `base_station`. it is supported only by matrice 300 rtk.  @param connectionstate rtk with base station connection state. @param information base station connection information.",
             "setrtkconnectionstatewithbasestationcallback",
             "set rtk base station connection state and information update rtkbasestationconnectioninformationcallback.  @param callback callback to receive the information of the connection between rtk and base station.",
             "ppkmodestate",
             "ppk mode status.",
             "idle",
             "ppk mode is idle.",
             "running",
             "ppk mode is running.",
             "unknown",
             "unknown error.",
             "setppkmodestatelistener",
             "set listener for the ppk mode which is used to listen the status changes. only supported by phantom 4 rtk.  @param callback the execution callback with the execution result returned.",
             "setppkmodeenabled",
             "in ppk mode, the camera will automatically create a folder before the next photo taking, and start to record ppk data.  the camera will not store the data in the created folder until ppk mode disabled. to use this interface, you must insert sd card and set camera mode to photo mode.  only supported by phantom 4 rtk.  @param enabled `true` to enable ppk mode. @param callback the execution callback with the execution result returned.",
             "getppkmodeenabled",
             "gets the ppk mode status. only supported by phantom 4 rtk.  @param callback the execution callback with the execution result returned.",
             "setrtkenabled",
             "enables rtk positioning. disable rtk when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. can only be set when the motors are off.  @param enabled `true` to enable rtk positioning. @param callback the execution callback with the execution result returned.",
             "rtk_enabled",
             "sdk key for setrtkenabled: enables rtk positioning. disable rtk when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. can only be set when the motors are off.  @param enabled `true` to enable rtk positioning. @param callback the execution callback with the execution result returned.",
             "isconnected",
             "`true` if rtk is connected to the aircraft.  @return a boolean value.",
             "getrtkenabled",
             "determines if rtk is enabled. phantom 4 rtk has different behavior from the other products that supports rtk:  - for aircrafts except phantom 4 rtk,  disabling rtk will stop rtk from pushing valid position.  - for phantom  4 rtk, rtk will continue to push latest rtk coordinate if there is strong  satellite signal after disabling rtk. however, the flight controller will  not use the rtk coordinate for navigation.  @param callback the completion block that receives the result.",
             "setreferencestationsource",
             "sets the reference station source that provides real-time corrections for the rtk air system. it is only supported by phantom 4 rtk. for matrice 210 rtk, matrice 600 series and mavic 2 enterprise advanced, the reference station is always the physical base station.  @param source reference station source to set. @param callback the completion block that receives the result.",
             "startsearchbasestation",
             "used to start searching for dji base station that can be controlled with the mobile  sdk.  searching  will automatically stop after a base station is connected. only can be used when  current `referencestationsource` is `base_station`.  it is supported only by matrice 300 rtk.  @param callback the completion block that receives the result.",
             "stopsearchbasestation",
             "used to stop searching for dji base station that can be controlled with the mobile sdk.  if searching is stopped without selecting a base station, the last connected base station will be reconnected.  only can be used when current `referencestationsource`  is  `base_station`. it is supported only by matrice 300 rtk.  @param callback the completion block that receives the result.",
             "connecttobasestation",
             "choose a base station to connect by base station's id. only can be used when current `referencestationsource`  is `base_station`. it is supported only by matrice 300 rtk.  @param basestationid the base station's id that chosen to be connected. @param callback the completion block that receives the result.",
             "setrtkmaintainpositioningaccuracymodeenabled",
             "sets rtk maintain position accuracy mode enable. when enabled is ``true`, the aircraft will maintain position accuracy about 10 minutes after losing rtk signal. only supported by phantom 4 rtk. when the aircraft is in maintain positioning accuracy mode: 1. the aircraft positioning accuracy will decrease gradually. be sure to fly with caution. stop the flight or reconnect to the rtk signal source immediately to avoid flight hazards. 2. flying the aircraft for a long distance (for example, automatically performing operations alongside the planned flight route), or controlling the aircraft with a large stick movement will lead to faster positioning accuracy decrease. 3. the rtkflag of the images the aircraft captured is 16(point positioning), which cannot meet the requirements for mapping. it is not recommended to use maintain positioning accuracy mode in flight route operations, especially in operations with an absolute altitude. this mode is more suitable for inspection or waypoint operations.  @param enabled `true` to enable rtk maintain positioning accuracy mode. @param callback the execution callback with the returned execution result.",
             "getrtkmaintainpositioningaccuracymodeenabled",
             "gets rtk maintain positioning accuracy mode status. only supported by phantom 4 rtk.  @param callback the execution callback with the returned value(s).",
             "onupdate",
             "callback function that updates the rtk state data.  @param state current state of the rtk.",
             "rtkstate",
             "this class holds the state of the rtk system, including position, positioning solution, and receiver information.  receiver 1 is used for positioning. receiver 2 is used for orienteering.",
             "rtk_state",
             "sdk key for rtkstate: this class holds the state of the rtk system, including position, positioning solution, and receiver information.  receiver 1 is used for positioning. receiver 2 is used for orienteering.",
             "datasource",
             "this enum defines the data source (either gps or rtk) of a recorded location, e.g. home point. only support by phantom 4 rtk.",
             "rtknetworkserviceprovider",
             "this class is used to control the rtk network service. the djirtknetworkserviceprovider can  initiate the communication to a third-party rtk network server. the information from the server can  be streamed to the rtk airsystem. sdk will not cache the settings to the disk. the provider should be configured in each life cycle of sdk. the life cycle of the network service provider is independent  from the aircraft. therefore, it can be configured before connecting to dji aircrafts. it is only supported  by phantom 4 rtk, p4 multispectral, mavic 2 enterprse advanced, matrice 210 rtk v2 and matrice 300 rtk.",
             "coordinatesystem",
             "coordinate system for network rtk. it is supported by phantom 4 rtk.",
             "networkserviceaccountstate",
             "all the possible state of `coordinatesystem`. it is supported by phantom 4 rtk.",
             "networkserviceplantype",
             "network rtk service plan type.",
             "networkserviceplanstate",
             "network rtk service plan's state.",
             "referencestationsource",
             "all the possible state of `referencestationsource`.",
             "none",
             "not using any reference station source.",
             "base_station",
             "rtk is using the d-rtk 2 base station as the reference station. it is supported by phantom 4 rtk, p4 multispectral and matrice 300 rtk.",
             "custom_network_service",
             "rtk is using third-party network service as the reference station. the network service should use  ntrip(networked transport of rtcm via  internet protocol). it is supported by phantom 4 rtk, p4 multispectral, matrice 210 rtk v2 and matrice 300 rtk.",
             "network_rtk",
             "default virtual reference station solution to provide cm level accurate position.  the frame can be either wgs84 or cgcs 2000. please note that this default solution can only be used  in china. please add the djinetworkrtkhelper to the project via gradle:  implementation 'com.dji:library-networkrtk-helper:2.0.2'. it is only supported by matrice 300 rtk and matrice 350 rtk.",
             "ntrip_network_service",
             "ntrip network service which is used for cmcc network rtk service. it is only supported matrice 300 rtk and matrice 350 rtk.",
             "unknown",
             "unknown reference station source.",
             "callback",
             "updates the rtk reference station source.",
             "onreferencestationsourceupdate",
             "callback function that updates the rtk reference station source.  @param referencestationsource the source of the reference station.",
             "ismaintainingpositionaccuracy",
             "whether aircraft is maintaining position accuracy after losing rtk signal. if return `true`, the aircraft will maintain position accuracy about 10 minutes after losing rtk signal.",
             "isrtkbeingused",
             "it will be true when the positioning solution is fixed and the rtk location data received period is between 2 seconds. the flight controller will use rtk data when isrtkbeingused is true.  @return a boolean value.",
             "getmobilestation1satellitecount",
             "get the total number of satellites from mobile station (aircraft) receiver 1.  @return an int value.",
             "getmobilestation2satellitecount",
             "get the total number of satellites from mobile station (aircraft) receiver 2.  @return an int value.",
             "distancetohomepointdatasource",
             "distance to home point data source. only supported by phantom 4 rtk.  @return an enum value of `datasource`.",
             "istakeoffaltituderecorded",
             "`true` if the altitude is recorded by the flight controller when the aircraft takes off. only supported by phantom 4 rtk.  @return a boolean value to check if take off altitude has been recorded.",
             "homepointdatasource",
             "home point data source. only supported by phantom 4 rtk.  @return an enum value of `datasource`.",
             "getsatellitecount",
             "gps or rtk satellite count. only supported by phantom 4 rtk.  @return satellite count.",
             "homepointlocation",
             "home point location. only supported by phantom 4 rtk.  @return a `locationcoordinate2d` object of the home point location.",
             "gettakeoffaltitude",
             "takeoff altitude. only supported by phantom 4 rtk.  @return a float value of the takeoff altitude.",
             "getdistancetohomepoint",
             "distance to home point. only supported by phantom 4 rtk.  @return a float value of the distance to home point.",
             "getellipsoidheight",
             "ellipsoid height. an absolute altitude above sea level read from gps. only supported by matrice 300 rtk.  @return a float value of the ellipsoid height.",
             "getaircraftaltitude",
             "aircraft altitude. aircraft's absolute altitude above sea level.  when rtk is used and valid, this value will be a fusion rtk altitude.  otherwise, it is a fusion barometer altitude.  supported by matrice 300 rtk, phantom 4 rtk and p4 multispectral.  @return a float value of the aircraft altitude.",
             "getpositioningsolution",
             "the positioning solution describes the method used to determine positioning. the solutions vary in accuracy, from `none` (no positioning) to `fixed_point`.  @return an enum value of `positioningsolution`",
             "geterror",
             "gets rtk errors, if any. returns `null` when rtk is normal.  @return an instance of `djierror`.",
             "isheadingvalid",
             "`true` if heading value is valid. heading is invalid when a satellite fix hasn't been obtained.  @return a boolean value.",
             "getheading",
             "heading relative to true north as defined by the vector formed from antenna 2 to antenna 1 on the mobile station. unit is degrees.  @return a float value.",
             "getheadingsolution",
             "the heading solution describes the method used to determine heading. the solutions vary in accuracy,  from `none` (no heading) to `fixed_point`. it's supported by matrice  200 series v2 and phantom 4 rtk.  @return an enum value of `getheadingsolution`.",
             "getmobilestationlocation",
             "always indicate rtk location data. location information of the mobile station's receiver 1 antenna. this location  information is relative to the base station's location and is in degrees when `getpositioningsolution`  is `fixed_point`.  @return an instance of `locationcoordinate2d`.",
             "getmobilestationaltitude",
             "altitude of the mobile station's receiver 1 antenna relative, to the ground system location. units are meters.  @return a float value.",
             "getmobilestationstandarddeviation",
             "standard deviation of location accuracy in meters. returns `null` when the aircraft receives no signal.  only supported by phantom 4 rtk.  @return a `locationstandarddeviation` object of the mobile station standard deviation.",
             "getfusionmobilestationlocation",
             "the fusion location of the mobile station (in degrees). it is the combination of gps and rtk. the flight controller uses this location for navigation (e.g. waypoint mission) when rtk is available.  @return an instance of `locationcoordinate2d`.",
             "getfusionmobilestationaltitude",
             "the fusion altitude of the mobile station. the flight controller fuses the data from gps, rtk and the barometer.  the flight controller uses this altitude for navigation (e.g. waypoint mission) when rtk is available.  @return a float value.",
             "getfusionheading",
             "the fusion heading of the mobile station. it is the combination of rtk and the compass. the flight controller uses this heading for navigation (e.g. waypoint mission) when rtk is available.  @return a float value.",
             "getbasestationlocation",
             "base station's location coordinates, in degrees.  @return an instance of `locationcoordinate2d`.",
             "getbasestationaltitude",
             "altitude of the base station above sea level, in meters.  @return a float value.",
             "getmobilestationreceiver1gpsinfo",
             "mobile station (aircraft) receiver 1 gps info.  @return an instance of `receiverinfo`",
             "getmobilestationreceiver1beidouinfo",
             "mobile station (aircraft) receiver 1 beidou info.  @return an instance of `receiverinfo`",
             "getmobilestationreceiver1glonassinfo",
             "mobile station (aircraft) receiver 1 glonass info.  @return an instance of `receiverinfo`",
             "getmobilestationreceiver1galileoinfo",
             "mobile station (aircraft) receiver 1 galileo info. only supported by phantom 4 rtk.  @return an instance of `receiverinfo`",
             "getmobilestationreceiver2gpsinfo",
             "mobile station (aircraft) receiver 2 gps info.  @return an instance of `receiverinfo`",
             "getmobilestationreceiver2beidouinfo",
             "mobile station (aircraft) receiver 2 beidou info.  @return an instance of `receiverinfo`.",
             "getmobilestationreceiver2glonassinfo",
             "mobile station (aircraft) receiver 2 glonass info.  @return an instance of `receiverinfo`.",
             "getmobilestationreceiver2galileoinfo",
             "mobile station (aircraft) receiver 2 galileo info. only supported by phantom 4 rtk.  @return an instance of `receiverinfo`.",
             "getbasestationreceivergpsinfo",
             "base station receiver gps info.  @return an instance of `receiverinfo`",
             "getbasestationreceiverbeidouinfo",
             "base station receiver beidou info.  @return an instance of `receiverinfo`.",
             "getbasestationreceiverglonassinfo",
             "base station receiver glonass info.  @return an instance of `receiverinfo`.",
             "getbasestationreceivergalileoinfo",
             "base station receiver galileo info. only supported by phantom 4 rtk.  @return an instance of `receiverinfo`.",
             "callback",
             "this interface provides a delegate method to update the rtk state.",
             "positioningsolution",
             "this enum defines the positioning solution currently being used.",
             "none",
             "no positioning solution. this can be caused by an insufficient number of satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
             "single_point",
             "rtk point positioning.",
             "float",
             "float solution positioning.",
             "fixed_point",
             "fixed-point solution positioning (most accurate).",
             "unknown",
             "unknown.",
             "headingsolution",
             "this enum defines the heading solution currently being used. the  heading solution describes the method used to determine heading. and  indicates the accuracy of the `getheading`. it is  supported by phantom 4 rtk and matrice 200 series v2.",
             "none",
             "no heading solution. this can be caused by an insufficient number of  satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
             "single_point",
             "rtk point heading.",
             "float",
             "float solution heading.",
             "fixed_point",
             "fixed-point solution direction (most accurate).",
             "unknown",
             "unknown.",
             "gps",
             "the location coordinate is from gps.",
             "rtk",
             "the location coordinate is from rtk.",
             "unknown",
             "data source is unknown.",
             "wgs84",
             "the coordinate system is world geodetic system 1984.",
             "cgcs2000",
             "the coordinate system is china geodetic coordinate system 2000.",
             "unknown",
             "the coordinate system is unknown.",
             "not_purchased",
             "network rtk service is not purchased.",
             "unbound",
             "device is not bound.",
             "bound",
             "device is bound.",
             "unknown",
             "network rtk service account state is unknown.",
             "a",
             "plan type a.",
             "b",
             "plan type b.",
             "unknown",
             "unknown plan type.",
             "unactivated",
             "the plan has not activated.",
             "activated",
             "the plan has activated.",
             "expired",
             "the plan has expired.",
             "unknown",
             "the plan state is unknown.",
             "receiverinfo",
             "single rtk receiver information. each receiver is connected to a single antenna.",
             "isconstellationsupported",
             "`true` if constellation is supported. the european and american versions of rtk support gps and glonass, while the asia pacific version supports gps and beidou.  @return a boolean value.",
             "getsatellitecount",
             "valid satellite count for this receiver.  @return an int value.",
             "locationstandarddeviation",
             "standard deviation of location accuracy in meters. only supported by phantom 4 rtk.",
             "getstdlatitude",
             "latitude standard deviation in meters.  @return a float value of the latitude.",
             "getstdlongitude",
             "longitude standard deviation in meters.  @return a float value of the longitude.",
             "getstdaltitude",
             "altitude standard deviation in meters.  @return a float value of the altitude.",
             "setstatecallback",
             "sets the callback function that updates the flight controller's current state data. this method is called 10 times per second.  @param callback the execution callback with the execution result returned.",
             "setimustatecallback",
             "sets the imu state callback, which will receive the changed state of the imu.  @param callback the callback for receiving the changed state of imu.",
             "setasbinformationcallback",
             "sets the airsensesysteminformation callback, which will receive the airsensesysteminformation.  @param callback the callback for receiving the `airsensesysteminformation`.",
             "setonboardsdkdevicedatacallback",
             "sets the callback function that updates the data received from an external device (e.g. the onboard device).  @param callback the execution callback with the execution result returned.",
             "getstate",
             "returns the current state of flight controller.  @return an instance of `flightcontrollerstate`.",
             "getcompass",
             "compass object.  @return an instance of `compass`.",
             "getcompasscount",
             "number of compass modules in the flight controller.  @return an int value.",
             "getrtk",
             "rtk positioning object.  @return an instance of `rtk`.",
             "savepipelineslog",
             "sets true to save log for pipelines. in order to improve developer's experience on sdk interconnectivity, djipipeline</code> is designed to save log files locally when files are transferred, during which the speed is 475kb per minute. please be careful with the device storage.  @param enabled `true` to save log files.",
             "getpipelines",
             "the pipelines to transmit data between onboard device and dji mobile sdk. it's only supported by matrice 300 rtk.  @return an instance of djipipelines</code>.",
             "getimucount",
             "number of imu modules in the flight controller. most products have one imu.  exceptions:  - phantom 4, phantom 4 pro, mavic pro, and inspire 2 each have two imus  - a3, matrice 600, and matrice 600 pro each have one inner imu and can have at most two external imus.  - n3 has two inner imus and can have one external imu.  @return an int value.",
             "imu_count",
             "sdk key for getimucount: number of imu modules in the flight controller. most products have one imu.  exceptions:  - phantom 4, phantom 4 pro, mavic pro, and inspire 2 each have two imus  - a3, matrice 600, and matrice 600 pro each have one inner imu and can have at most two external imus.  - n3 has two inner imus and can have one external imu.  @return an int value.",
             "startimucalibration",
             "starts imu calibration. for aircraft with multiple imus, this method will start the calibration of all imus. keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. the completion block will be called once the calibration is started. use the `onupdate` method to check the execution status of the imu calibration. it is recommended to reboot the device after imu calibration. it is recommended to invoke `reboot` after imu calibration.  @param callback completion callback.",
             "start_imu_calibration",
             "sdk key for startimucalibration: starts imu calibration. for aircraft with multiple imus, this method will start the calibration of all imus. keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. the completion block will be called once the calibration is started. use the `onupdate` method to check the execution status of the imu calibration. it is recommended to reboot the device after imu calibration. it is recommended to invoke `reboot` after imu calibration.  @param callback completion callback.",
             "startimucalibration",
             "starts the calibration for imu with a specific id. keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. the completion block will be called once the calibration is started. use the `onupdate` method to check the execution status of the imu calibration. it is recommended to reboot the device after imu calibration.  @param index the imu with the specific id to calibrate. @param callback completion callback to check if the calibration starts successfully.",
             "start_imu_calibration_with_id",
             "sdk key for startimucalibration: starts the calibration for imu with a specific id. keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. the completion block will be called once the calibration is started. use the `onupdate` method to check the execution status of the imu calibration. it is recommended to reboot the device after imu calibration.  @param index the imu with the specific id to calibrate. @param callback completion callback to check if the calibration starts successfully.",
             "startgravitycentercalibration",
             "starts gravity center calibration. keep the aircraft hover without wind during calibration. the completion block will be called once the calibration is started.  @param callback the execution callback with the returned value(s).",
             "stopgravitycentercalibration",
             "stop gravity center calibration.  @param callback the execution callback with the returned value(s).",
             "getlandinggear",
             "landing gear object. for products with movable landing gear only.  @return an instance of `landinggear`.",
             "islandinggearmovable",
             "`true` if landing gear is supported for the connected aircraft.  @return a boolean value.",
             "is_landing_gear_movable",
             "sdk key for islandinggearmovable: `true` if landing gear is supported for the connected aircraft.  @return a boolean value.",
             "getsimulator",
             "simulator object.  @return an instance of `simulator`.",
             "isonboardsdkdeviceavailable",
             "returns if the onboard sdk feature is available on the connected product.  @return a boolean value.",
             "is_on_board_sdk_available",
             "sdk key for isonboardsdkdeviceavailable: returns if the onboard sdk feature is available on the connected product.  @return a boolean value.",
             "senddatatoonboardsdkdevice",
             "if there is a device connected to the aircraft using the onboard sdk, this method will send data to that device. the size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. this method is only supported on products that support the onboard sdk (matrice 210 v1, matrice 210 v2, matrice 300 rtk, matrice 100, matrice 600, matrice 600 pro, a3, a3 pro, and n3).  @param data data to be sent to the external device. the size of the data should not be larger than 100 bytes. @param callback the execution callback with the returned execution result.",
             "send_data_to_on_board_sdk_device",
             "sdk key for senddatatoonboardsdkdevice: if there is a device connected to the aircraft using the onboard sdk, this method will send data to that device. the size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. this method is only supported on products that support the onboard sdk (matrice 210 v1, matrice 210 v2, matrice 300 rtk, matrice 100, matrice 600, matrice 600 pro, a3, a3 pro, and n3).  @param data data to be sent to the external device. the size of the data should not be larger than 100 bytes. @param callback the execution callback with the returned execution result.",
             "turnonmotors",
             "turns on the aircraft's motors. supported by flight controller firmware 3.1.0.0 or above.  @param callback the execution callback with the returned execution result.",
             "turn_on_motors",
             "sdk key for turnonmotors: turns on the aircraft's motors. supported by flight controller firmware 3.1.0.0 or above.  @param callback the execution callback with the returned execution result.",
             "turnoffmotors",
             "turns off the aircraft's motors. the method can only be called when the aircraft is on the ground.  @param callback the execution callback with the returned execution result.",
             "turn_off_motors",
             "sdk key for turnoffmotors: turns off the aircraft's motors. the method can only be called when the aircraft is on the ground.  @param callback the execution callback with the returned execution result.",
             "seturgentstopmodeenabled",
             "enables urgent stop mode. when urgent stop mode is enabled, the motor can be stopped by pushing sticks inner/outer simultaneously at any time. use with caution. supported only by phantom 4 rtk.  @param enabled `true` to enable urgent stop mode. @param callback callback that receives the setter execution result.",
             "geturgentstopmodeenabled",
             "gets if urgent stop mode is enabled or not. supported only by phantom 4 rtk.  @param callback completion callback that receives the execution result.",
             "setescbeepenabled",
             "enables esc beeping.  @param enabled `true` to enable esc beeping. @param callback the execution callback with the execution result returned.",
             "getescbeepenabled",
             "determines if esc beeping is enabled.  @param callback the execution callback with the returned value(s).",
             "setgravitycenterstatecallback",
             "sets the callback function that updates the gravity calibration's current state data.  @param callback the execution callback with the execution result returned.",
             "starttakeoff",
             "starts aircraft takeoff. takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. completion block is called when aircraft crosses 0.5 meters (1.6 feet). if the motors are already on, this command cannot be executed.  @param callback the execution callback with the returned execution result.",
             "take_off",
             "sdk key for starttakeoff: starts aircraft takeoff. takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. completion block is called when aircraft crosses 0.5 meters (1.6 feet). if the motors are already on, this command cannot be executed.  @param callback the execution callback with the returned execution result.",
             "startprecisiontakeoff",
             "starts aircraft precision takeoff. precision takeoff is considered complete when the aircraft is hovering 6 meters (20 feet) above the ground. completion block is called when aircraft crosses 0.5 meters (1.6 feet). if the motors are already on, this command cannot be executed.  this feature need vision assisted positioning enabled on.  @param callback the execution callback with the returned execution result.",
             "canceltakeoff",
             "stops aircraft takeoff. if called before `starttakeoff` is complete, the aircraft will cancel takeoff (`starttakeoff` completion block will return an error) and hover at the current height.  @param callback the execution callback with the returned execution result.",
             "cancel_take_off",
             "sdk key for canceltakeoff: stops aircraft takeoff. if called before `starttakeoff` is complete, the aircraft will cancel takeoff (`starttakeoff` completion block will return an error) and hover at the current height.  @param callback the execution callback with the returned execution result.",
             "startlanding",
             "starts auto-landing of the aircraft. returns completion block once aircraft begins to descend for auto-land.  @param callback the execution callback with the returned execution result.",
             "start_landing",
             "sdk key for startlanding: starts auto-landing of the aircraft. returns completion block once aircraft begins to descend for auto-land.  @param callback the execution callback with the returned execution result.",
             "cancellanding",
             "stops auto-landing of the aircraft. if called before `startlanding` is complete, then the auto landing will be canceled (`startlanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback the execution callback with the returned execution result.",
             "cancel_landing",
             "sdk key for cancellanding: stops auto-landing of the aircraft. if called before `startlanding` is complete, then the auto landing will be canceled (`startlanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback the execution callback with the returned execution result.",
             "confirmlanding",
             "confirms continuation of landing action. when the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. can use `islandingconfirmationneeded` in `flightcontrollerstate` to check if confirmation is needed. it is supported by flight controller firmware 3.2.0.0 and above.  @param callback the execution callback with the returned value(s).",
             "confirm_landing",
             "sdk key for confirmlanding: confirms continuation of landing action. when the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. can use `islandingconfirmationneeded` in `flightcontrollerstate` to check if confirmation is needed. it is supported by flight controller firmware 3.2.0.0 and above.  @param callback the execution callback with the returned value(s).",
             "setledsenabledsettings",
             "turns on/off different sets of leds on the aircraft. all the leds are on by default.  @param ledssettings settings to control leds. @param callback completion callback that receives the setter execution result.",
             "leds_enabled_settings",
             "sdk key for setledsenabledsettings: turns on/off different sets of leds on the aircraft. all the leds are on by default.  @param ledssettings settings to control leds. @param callback completion callback that receives the setter execution result.",
             "getledsenabledsettings",
             "determines the status of leds on the aircraft.  @param callback the execution callback with the returned value(s).",
             "isvirtualstickcontrolmodeavailable",
             "indicates whether the virtual stick control interface can be used. virtual stick mode is only available when all of the follow requirements are met:  - virtual stick mode is enabled.  - no waypoint, hotpoint, or follow-me mission is running.  - `flightorientationmode` is set to `aircraft_heading`  - terrain-follow is disabled if the aircraft supports this feature.  - tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
             "is_virtual_stick_control_mode_available",
             "sdk key for isvirtualstickcontrolmodeavailable: indicates whether the virtual stick control interface can be used. virtual stick mode is only available when all of the follow requirements are met:  - virtual stick mode is enabled.  - no waypoint, hotpoint, or follow-me mission is running.  - `flightorientationmode` is set to `aircraft_heading`  - terrain-follow is disabled if the aircraft supports this feature.  - tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
             "setvirtualstickmodeenabled",
             "enables/disables virtual stick control mode. by enabling virtual stick control mode, the aircraft can be controlled using `sendvirtualstickflightcontroldata`. not supported by mavic pro when using the wifi connection.  @param enabled `true` to enable virtual stick mode. @param callback the execution callback with the returned execution result.",
             "virtual_stick_control_mode_enabled",
             "sdk key for setvirtualstickmodeenabled: enables/disables virtual stick control mode. by enabling virtual stick control mode, the aircraft can be controlled using `sendvirtualstickflightcontroldata`. not supported by mavic pro when using the wifi connection.  @param enabled `true` to enable virtual stick mode. @param callback the execution callback with the returned execution result.",
             "getvirtualstickmodeenabled",
             "gets virtual stick mode status (enabled/disabled). not supported by mavic pro when using the wifi connection.  @param callback the execution callback with the returned execution result.",
             "virtual_stick_control_mode_enabled",
             "sdk key for getvirtualstickmodeenabled: gets virtual stick mode status (enabled/disabled). not supported by mavic pro when using the wifi connection.  @param callback the execution callback with the returned execution result.",
             "isvirtualstickadvancedmodeenabled",
             "`true` if virtual stick advanced mode is enabled. by default, it is `false`. assuming gps signal is good, advanced mode will allow aircraft to compensate for wind when hovering. for the phantom 4, collision avoidance can be enabled for virtual stick control if advanced mode is on, and collision avoidance is enabled in `flightassistant`. only supported by flight controller firmware versions 3.1.x.x or above. caution: it will be reset to `false` when the flight controller is reconnected.  @return a boolean value.",
             "setvirtualstickadvancedmodeenabled",
             "set `true` to enable virtual stick advanced mode. by default, it is `false`. assuming gps signal is good, advanced mode will allow aircraft to compensate for wind when hovering.   for the phantom 4, collision avoidance can be enabled for virtual stick   control if advanced mode is on, and collision avoidance is enabled in `flightassistant`.   only supported by flight controller firmware versions 3.1.0.0 or above.  @param virtualstickadvancedmodeenabled true</code> for enabling advanced mode.",
             "getverticalcontrolmode",
             "the vertical control mode for virtual stick. caution: it will be reset to `velocity` when the flight controller is reconnected.  @return an enum value of `verticalcontrolmode`.",
             "setverticalcontrolmode",
             "sets whether virtual stick vertical controller changes aircraft's altitude or vertical velocity.  @param verticalcontrolmode a specific djivirtualstickverticalcontrolmode object.",
             "getrollpitchcontrolmode",
             "the roll and pitch control mode for virtual stick. caution: it will be reset to `angle` when the flight controller is reconnected.  @return an enum value of `rollpitchcontrolmode`.",
             "setrollpitchcontrolmode",
             "sets whether roll/pitch virtual controllers change aircraft's angle relative to level orientation, or aircraft's velocity on horizontal axes.  @param rollpitchcontrolmode a specific djivirtualstickrollpitchcontrolmode object.",
             "getyawcontrolmode",
             "the yaw control mode for virtual stick. caution: it will be reset to `angle` when the flight controller is reconnected.  @return an enum value of `yawcontrolmode`.",
             "setyawcontrolmode",
             "sets whether virtual stick yaw controller changes aircraft's heading by angle or by angular velocity.  @param yawcontrolmode a specific djivirtualstickyawcontrolmode object.",
             "getrollpitchcoordinatesystem",
             "the coordinate system for virtual stick. caution: it will be reset to `ground` when the flight controller is reconnected.  @return coordinate system object.",
             "setrollpitchcoordinatesystem",
             "sets whether horizontal axes are fixed relative to the ground or to the aircraft.  @param rollpitchcoordinatesystem a specific rollpitchcoordinatesystem object.",
             "sendvirtualstickflightcontroldata",
             "sends flight control data using virtual stick commands. the `isvirtualstickcontrolmodeavailable` method must return `true` to use virtual stick commands. virtual stick commands should be sent to the aircraft between 5 hz and 25 hz. if virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controldata flight control data @param callback the execution callback with the returned execution result.",
             "send_virtual_stick_flight_control_data",
             "sdk key for sendvirtualstickflightcontroldata: sends flight control data using virtual stick commands. the `isvirtualstickcontrolmodeavailable` method must return `true` to use virtual stick commands. virtual stick commands should be sent to the aircraft between 5 hz and 25 hz. if virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controldata flight control data @param callback the execution callback with the returned execution result.",
             "isflightassistantsupported",
             "`true` if the product supports intelligentflightassistant.  @return a boolean value.",
             "is_flight_assistant_supported",
             "sdk key for isflightassistantsupported: `true` if the product supports intelligentflightassistant.  @return a boolean value.",
             "getflightassistant",
             "intelligent flight assistant.  @return an instance of `flightassistant`.",
             "getaccesslocker",
             "gets the instance of the access locker. it is used to encapsulate the access protection features on the aircraft.  @return instance of the access locker. `null` if it is not supported by the aircraft.",
             "isaccesslockersupported",
             "`true` if the product supports accesslocker.  @return a boolean value.",
             "setflightorientationmode",
             "sets the aircraft flight orientation relative to the aircraft heading, course lock, or home lock. see the <i>flight controller user guide</i> for more information about flight orientation. not supported by mavic mini, dji mini 2, dji mini se and mavic air 2, dji air 2s.  @param type the orientation mode. @param callback the execution callback with the returned execution result.",
             "orientation_mode",
             "sdk key for setflightorientationmode: sets the aircraft flight orientation relative to the aircraft heading, course lock, or home lock. see the <i>flight controller user guide</i> for more information about flight orientation. not supported by mavic mini, dji mini 2, dji mini se and mavic air 2, dji air 2s.  @param type the orientation mode. @param callback the execution callback with the returned execution result.",
             "lockcourseusingcurrentheading",
             "locks the current heading of the aircraft as the course lock. used when flight orientation mode is `course_lock`.  @param callback the execution callback with the returned execution result. please refer to djibasecomponent for more information about the block",
             "lock_course_using_current_heading",
             "sdk key for lockcourseusingcurrentheading: locks the current heading of the aircraft as the course lock. used when flight orientation mode is `course_lock`.  @param callback the execution callback with the returned execution result. please refer to djibasecomponent for more information about the block",
             "settripodmodeenabled",
             "enables/disables tripod mode. tripod mode drops the aircraft's maximum speed to 2.2mph (3.6kph), and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. when tripod mode is enabled, missions, terrain follow mode, course lock, and home lock are not allowed. tripod mode is not allowed if the aircraft is running a mission. if gps or vision positioning aren't available, tripod mode cannot be enabled. if the gps and/or the vision system is providing the flight controller with velocity information, the aircraft will be able to automatically compensate for wind. if however, position information is not available, manual intervention will be required. user should beware that any manual compensation will be limited due to the reduced maximum velocity and sensitivity. if gps and vision position become unavailable while in tripod mode, it is advisable to alert the user and disable tripod mode. not supported by mavic 2 enterprise advanced.  @param enabled `true` to enable tripod mode. @param callback the execution callback with the returned execution result.",
             "gettripodmodeenabled",
             "gets tripod mode status (enabled/disabled). it is supported by mavic pro, mavic mini, dji mini 2, dji mini se.  @param callback the execution callback with the returned value(s).",
             "setcinematicmodeenabled",
             "enables/disables cinematic mode. in cinematic mode, you can shoot more stable and smooth photos and videos. aircraft yaw speed will be lower and braking distance will be longer. it's only supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param enabled `true` to enable cinematic mode. @param callback the execution callback with the returned value(s).",
             "getcinematicmodeenabled",
             "gets cinematic mode status (enabled/disabled). it's only supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param callback the execution callback with the returned boolean value.",
             "setcinematicbrakesensitivity",
             "adjusts the braking sensitivity when cinematic mode is enabled. higher sensitivity can shorten the braking distance in cinematic mode. it's supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param brakesensitivity brake sensitivity in cinematic mode. @param callback the execution callback with the returned execution result.",
             "getcinematicbrakesensitivity",
             "gets the braking sensitivity when cinematic mode is enabled. higher sensitivity can shorten the braking distance in cinematic mode. it's supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param callback the execution callback with the returned value(s).",
             "setcinematicyawspeed",
             "adjusts the aircraft's yaw speed when cinematic mode is enabled. it's supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param yawspeed the aircraft's yaw speed in cinematic mode. @param callback the execution callback with the returned execution result.",
             "getcinematicyawspeed",
             "gets the aircraft's yaw speed when cinematic mode is enabled. it's supported by mavic pro, spark, mavic 2 zoom and mavic 2 pro.  @param callback the execution callback with the returned value(s).",
             "setterrainfollowmodeenabled",
             "enable/disable terrain follow mode. the aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback the execution callback with the returned execution result.",
             "terrain_follow_mode_enabled",
             "sdk key for setterrainfollowmodeenabled: enable/disable terrain follow mode. the aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback the execution callback with the returned execution result.",
             "getterrainfollowmodeenabled",
             "gets terrain mode status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "terrain_follow_mode_enabled",
             "sdk key for getterrainfollowmodeenabled: gets terrain mode status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "setcontrolmode",
             "sets the control mode of the flight controller. it is highly recommended you keep the default value of `smart`. see `controlmode` for details. only supported by stand-alone a3.  @param mode control mode to set. @param callback completion callback that receives the setter execution result.",
             "control_mode",
             "sdk key for setcontrolmode: sets the control mode of the flight controller. it is highly recommended you keep the default value of `smart`. see `controlmode` for details. only supported by stand-alone a3.  @param mode control mode to set. @param callback completion callback that receives the setter execution result.",
             "getcontrolmode",
             "gets the control mode of the flight controller.  @param callback the execution callback with the returned value(s).",
             "control_mode",
             "sdk key for getcontrolmode: gets the control mode of the flight controller.  @param callback the execution callback with the returned value(s).",
             "setautoquickspinenabled",
             "enable/disable auto quick spin. when the gimbal reaches a yaw movement limit, the aircraft will automatically rotate 360 degrees to unwind the gimbal, allowing it to continue moving in the yaw direction. this method is only available when the aircraft is flying at least 3m above the ground. it is only supported by inspire 2.  @param enabled `true` to enable auto quick spin. @param callback the execution callback with the returned value(s).",
             "getquickspinenabled",
             "gets current auto quick spin mode (enabled/disabled). it is only supported by inspire 2.  @param callback the execution callback with the returned execution result.",
             "quick_spin_enabled",
             "sdk key for getquickspinenabled: gets current auto quick spin mode (enabled/disabled). it is only supported by inspire 2.  @param callback the execution callback with the returned execution result.",
             "setaircraftheadingturningspeed",
             "setting a larger value increases the yaw speed of the aircraft when the control sticks are pressed. the settable range of speed changes according to the mode. when the mode is normal, the speed range is (20,90). when the mode is sport, the speed range is (20,130). when the mode is tripod, the speed range is (20,30). only supported by mavic air 2, dji air 2s.  @param mode the mode that the setting will be applied to. @param speed the speed to set for aircraft heading turning. @param callback the execution callback with the returned execution result.",
             "getaircraftheadingturningspeed",
             "gets the heading turning speed of the aircraft according to the mode. only supported by mavic air 2, dji air 2s.  @param mode the mode to query. @param callback the completion callback that receives the execution result.",
             "setaircraftheadingturningsmoothness",
             "setting a larger angle increases the yaw buffer when the control sticks are pressed. the value should be in the range [1, 100]. only supported by mavic air 2, dji air 2s.  @param mode the mode that the setting will be applied to. @param smoothingvalue the smoothness that the setting will be applied to. @param callback the execution callback with the returned execution result.",
             "getaircraftheadingturningsmoothness",
             "gets the smoothness of the aircraft heading turn according to the mode. only supported by mavic air 2, dji air 2s.  @param mode the mode to query. @param callback the completion callback that receives the execution result.",
             "startgohome",
             "the aircraft will start to go home. the `completion callback` will return execution result once this method is invoked.  @param callback the execution callback with the returned execution result.",
             "start_go_home",
             "sdk key for startgohome: the aircraft will start to go home. the `completion callback` will return execution result once this method is invoked.  @param callback the execution callback with the returned execution result.",
             "cancelgohome",
             "the aircraft will stop going home and will hover in place.  @param callback the execution callback with the returned execution result.",
             "cancel_go_home",
             "sdk key for cancelgohome: the aircraft will stop going home and will hover in place.  @param callback the execution callback with the returned execution result.",
             "sethomelocation",
             "sets the home location of the aircraft. the home location is where the aircraft returns when commanded by `startgohome`, when its signal is lost or when the battery is below the lowbatterywarning threshold. the user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. a home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kcllocationaccuracynearesttenmeters accuracy level  - current remote controller's location as shown by rc gps.  @param homelocation home location latitude and longitude in degrees. @param callback the execution callback with the returned execution result.",
             "home_location",
             "sdk key for sethomelocation: sets the home location of the aircraft. the home location is where the aircraft returns when commanded by `startgohome`, when its signal is lost or when the battery is below the lowbatterywarning threshold. the user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. a home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kcllocationaccuracynearesttenmeters accuracy level  - current remote controller's location as shown by rc gps.  @param homelocation home location latitude and longitude in degrees. @param callback the execution callback with the returned execution result.",
             "sethomelocationusingaircraftcurrentlocation",
             "sets the home location of the aircraft to the current location of the aircraft. see `sethomelocation` for details on home point use.  @param callback the execution callback with the returned execution result.",
             "home_location_using_current_aircraft_location",
             "sdk key for sethomelocationusingaircraftcurrentlocation: sets the home location of the aircraft to the current location of the aircraft. see `sethomelocation` for details on home point use.  @param callback the execution callback with the returned execution result.",
             "gethomelocation",
             "gets the home point of the aircraft.  @param callback the execution callback with the returned value(s).",
             "home_location",
             "sdk key for gethomelocation: gets the home point of the aircraft.  @param callback the execution callback with the returned value(s).",
             "setgohomeheightinmeters",
             "sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. this can be useful when the user foresees obstacles in the aircraft's flight path. if the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. the valid range for the altitude is from 20m to 500m. but if the aircraft is m300 rtk or m350 rtk, the limit can beyond 500m.  @param height the aircraft's default go home altitude. @param callback the execution callback with the returned execution result.",
             "go_home_height_in_meters",
             "sdk key for setgohomeheightinmeters: sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. this can be useful when the user foresees obstacles in the aircraft's flight path. if the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. the valid range for the altitude is from 20m to 500m. but if the aircraft is m300 rtk or m350 rtk, the limit can beyond 500m.  @param height the aircraft's default go home altitude. @param callback the execution callback with the returned execution result.",
             "getgohomeheightinmeters",
             "gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback the execution callback with the returned value(s).",
             "go_home_height_in_meters",
             "sdk key for getgohomeheightinmeters: gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback the execution callback with the returned value(s).",
             "setconnectionfailsafebehavior",
             "sets the failsafe action for when the connection between remote controller and aircraft is lost. it is supported by mavic mini, dji mini 2, dji mini se and maivic air 2.  @param behavior the `connectionfailsafebehavior` object. @param callback the execution callback with the returned value(s).",
             "connection_fail_safe_behavior",
             "sdk key for setconnectionfailsafebehavior: sets the failsafe action for when the connection between remote controller and aircraft is lost. it is supported by mavic mini, dji mini 2, dji mini se and maivic air 2.  @param behavior the `connectionfailsafebehavior` object. @param callback the execution callback with the returned value(s).",
             "getconnectionfailsafebehavior",
             "gets the failsafe action for when the connection between remote controller and aircraft is lost.  @param callback the execution callback with the returned value(s).",
             "connection_fail_safe_behavior",
             "sdk key for getconnectionfailsafebehavior: gets the failsafe action for when the connection between remote controller and aircraft is lost.  @param callback the execution callback with the returned value(s).",
             "setlowbatterywarningthreshold",
             "sets the low battery warning threshold as a percentage. the percentage must be in the range of [15, 50]. it is not supported by mavic mini, dji mini 2, dji mini se, mavic air 2 and dji air 2s.  @param percent low battery warning percentage. @param callback the execution callback with the returned execution result.",
             "low_battery_warning_threshold",
             "sdk key for setlowbatterywarningthreshold: sets the low battery warning threshold as a percentage. the percentage must be in the range of [15, 50]. it is not supported by mavic mini, dji mini 2, dji mini se, mavic air 2 and dji air 2s.  @param percent low battery warning percentage. @param callback the execution callback with the returned execution result.",
             "getlowbatterywarningthreshold",
             "gets the low battery warning threshold as a percentage.  @param callback the execution callback with the returned value(s).",
             "low_battery_warning_threshold",
             "sdk key for getlowbatterywarningthreshold: gets the low battery warning threshold as a percentage.  @param callback the execution callback with the returned value(s).",
             "setseriouslowbatterywarningthreshold",
             "sets the serious low battery warning threshold as a percentage. the minimum value is 10. the maximum value is value from `getlowbatterywarningthreshold` minus 5. it is supported by mavic mini, dji mini 2, dji mini se.  @param percent serious low battery warning percentage. @param callback the execution callback with the returned execution result.",
             "serious_low_battery_warning_threshold",
             "sdk key for setseriouslowbatterywarningthreshold: sets the serious low battery warning threshold as a percentage. the minimum value is 10. the maximum value is value from `getlowbatterywarningthreshold` minus 5. it is supported by mavic mini, dji mini 2, dji mini se.  @param percent serious low battery warning percentage. @param callback the execution callback with the returned execution result.",
             "getseriouslowbatterywarningthreshold",
             "gets the serious low battery warning threshold in percentage.  @param callback the execution callback with the value(s) returned.",
             "serious_low_battery_warning_threshold",
             "sdk key for getseriouslowbatterywarningthreshold: gets the serious low battery warning threshold in percentage.  @param callback the execution callback with the value(s) returned.",
             "setsmartreturntohomeenabled",
             "enables/disables smart return-to-home (rth) feature. when it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action. for mavic mini, dji mini 2, dji mini se, the aircraft will return to home point when the remaning battery is low.  @param enabled `true` to enable smart rth. @param callback completion block that receives the setter execution result.",
             "getsmartreturntohomeenabled",
             "determines whether smart return-to-home (rth) feature is enabled or not. when it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action.  @param callback completion callback that receives the execution result.",
             "confirmsmartreturntohomerequest",
             "confirms or cancels the smart return-to-home (rth) request. when smart rth is enabled, the aircraft will request to go home when the battery is only enough for going home. before executing the go-home action, the aircraft will wait for the confirmation from users with 10 seconds count-down. if the confirmed parameter is `false`, the request is canceled and the aircraft will not execute go-home action. otherwise, go-home action will start. smart rth will be triggered only once during the same flight. flight controller with firmware version lower than 3.0.0.0 does not support confirming the smart rth request. user can either cancel the request or wait for the countdown to start go-home action. it is supported by mavic mini, dji mini 2, dji mini se, dji air 2s and mavic air 2.  @param confirmed `true` to confirm the request and the aircraft will start go-home immediately. @param callback completion block to receive the result.",
             "getrcswitchflightmodemapping",
             "gets the mapping between the flight modes and the flight mode switch positions on the remote controller. elements 0, 1, and 2 of the returned array map to `position_one`, `position_two`, and `position_three` of the `getflightmodeswitch`. the value of each enum item represents the corresponding value of the `remotecontrollerflightmode` enum representing the flight mode. the mapping is fixed for the phantom series, inspire series, mavic pro, and m100. for n3, a3, matrice 600, and matrice 600 pro the mapping is firmware dependent. with firmware version 3.2.11.0 or above, the mapping can be customized in dji assistant 2.  @param callback completion callback that receives the getter result. each element of array is an instance with a value of `remotecontrollerflightmode`.",
             "setmultipleflightmodeenabled",
             "enables/disables multiple-flight mode. when multiple-flight mode is enabled, user can change the aircraft's mode to p/f/a/s mode by toggling the switch on the remote controller. if it is disabled, the aircraft will be in p mode.  @param enabled `true` to enable multiple-flight mode. @param callback completion callback that receives the execution result.",
             "getmultipleflightmodeenabled",
             "determines whether multiple-flight mode is enabled. when multiple-flight mode is enabled, user can change the aircraft's mode to p/f/a/s mode by toggling the switch on the remote controller. if it is disabled, the aircraft will be in p mode.  @param callback completion callback that receives the execution result.",
             "setnovicemodeenabled",
             "enables novice mode. when novice mode is enabled, the flight speed will become slower and less responsive handling. for phantom 4 pro, enabling novice mode will enable the infrared time-of-flight (tof) sensors on the left and right.  @param enabled `true` to enable novice mode. @param callback completion block that receives the execution result.",
             "getnovicemodeenabled",
             "determines whether novice mode is enabled or not. if novice mode is enabled, the flight speed is slower and less responsive handling. for phantom 4 pro, enabling novice mode will enable the infrared time-of-flight (tof) sensors on the left and right.  @param callback completion callback that receives the execution result.",
             "reboot",
             "reboot the core component of the aircraft. it is recommended to invoke this method after imu calibration.  for matrice 300 rtk, reboot the aircraft.  for mavic mini, dji mini se, reboot the airlink.  for maivc air 2, reboot the battery.  others, reboot the flight controller.  @param callback completion callback that receives the execution result.",
             "setpowersupplyportenabled",
             "enables the power supply port. it is only supported by m200 series and m200 series v2.  @param enabled `true` if power supply port is enabled. @param callback callback that receives the execution result.",
             "getpowersupplyportenabled",
             "determines whether the power supply port is enabled or not. it is only supported by m200 series and m200 series v2.  @param callback completion block that receives the execution result.",
             "setpropellercageprotectionenabled",
             "do not turn on the propeller cage switch if propeller cages are not mounted. by enabling the propeller cage switch, you will set the force landing battery level to 15% and disable wind check and propeller check. when propeller cages are installed, no other accessories (except for official nd filters) can be attached. only supported by mavic mini, dji mini 2, dji mini se.  @param enabled `true` to enable propeller cage protection. @param callback callback that receives the execution result.",
             "getpropellercageprotectionenabled",
             "gets whether the propeller cage switch is turned on.  @param callback completion block that receives the execution result.",
             "toggleattitudeflightmode",
             "`true` to change the tripod(t) mode toggle to attitude mode toggle from the remote controller. you should called `setmultipleflightmodeenabled` to enable multiple flight mode first, otherwise this interfaces take no effect. if this mode is enabled, once you switch the mode toggle on remote controller to tripod(t) mode, aircraft will enter attitude mode, in this mode, aircraft is easily distured and drifts horizontally in consequence, you have to manully hover the aircraft. also, the active braking system is inactive. it is supported only by matrice 300 rtk.  @param isopen `true` to change the tripod(t) mode toggle to attitude mode toggle from the remote controller.",
             "getisattitudeflightmodeopen",
             "`true` if custom the tripod(t) mode to attitude mode on the remote controller is enabled. it is supported only by matrice 300 rtk.",
             "locktakeoffwithoutgps",
             "when gps signal low, aircraft unable to auto hover and takeoff restricted. if you want to unlock takeoff without gps , ensure there no people or obstacles within 2 m around the aircraft, and pay close attention to operating the remote controller at all times to avoid collisions.  @param lock `false` to unlock takeoff without gps. @param callback callback that receives the execution result.",
             "islocktakeoffwithoutgps",
             "return `false` if unlock takeoff without gps.  @param callback callback that receives the execution result.",
             "getpropellercoverlimitenabled",
             "return `true` if propeller cover limit mode is enabled.  @param callback callback that receives the execution result.",
             "setpropellercoverlimitenabled",
             "this mode should only be enabled when using accessories like propeller guards and the aircraft is flying in wind-free environments. shown as payload mode in dji fly. only supported by dji mini 2.  @param enabled `true` to enable the propeller cover limit. @param callback callback that receives the execution result.",
             "setcoordinatedturnenabled",
             "enables the coordinated turn. improves aerodynamic efficiency. the aircraft is flying in the direction of the turn, without sideslipping. only supported by m300 rtk and m350 rtk.  @param enabled `true` to enable the coordinated turn. @param callback callback that receives the execution result.",
             "getcoordinatedturnenabled",
             "get whether the coordinated turn switch is on.  only supported by m300 rtk and m350 rtk.  @param callback completion block that receives the execution result.",
             "setnavigationsatellitesystem",
             "the selection of satellite positioning system is only supported when the rtk positioning function is turned off, and cannot be modified in the air. if rtk positioning function is turned on, aircraft uses gps, glonass, galileo, and bds data to determine location. only supported by m300 rtk and m350 rtk.  @param system navigation satellite system. @param callback callback that receives the execution result.",
             "getnavigationsatellitesystem",
             "get the navigation satellite system. only supported by m300 rtk and m350 rtk.  @param callback callback that receives the execution result.",
             "navigationsatellitesystem",
             "this enum defines the navigation satellite system currently being used.",
             "gps_glonass",
             "using gsp and glonss satellite data.",
             "beidou",
             "only use beidou satellite navigation system.",
             "onboardsdkdevicedatacallback",
             "callback function that updates the data received from an external device (e.g.the onboard device).",
             "flightcontrollerstate",
             "this class represents the current state of the flight controller.",
             "gravitycenterstate",
             "this class provides the gravity state information.",
             "onupdate",
             "called when the flight controller's current state data has been updated. this method is called 10 times per second.  @param state current state of the flight controller.",
             "onreceive",
             "called when the data received from an external device (e.g. the onboard device) has been updated.  @param data data received from an external device. the size of the data will not be larger than 100 bytes.",
             "onupdate",
             "called when the flight controller pushes an imu state update. the callback method would not be called if the aircraft is flying.  @param state information about the imu state pushed by the flight controller.",
             "imu_state",
             "sdk key for onupdate: called when the flight controller pushes an imu state update. the callback method would not be called if the aircraft is flying.  @param state information about the imu state pushed by the flight controller.",
             "compass",
             "this class provides compass status information and compass calibration methods. products with multiple compasses (like the phantom 4) have their compass state fused into one compass class for simplicity.",
             "rtk",
             "real time kinematic",
             "landinggear",
             "this class controls and gives state of the landing gear. please check `islandinggearmovable` before calling the methods in this class.",
             "flightassistant",
             "this class contains components of the intelligent flight assistant and provides methods to change its settings.",
             "accesslocker",
             "the access locker provides methods to control the permission to access the aircraft. for an aircraft with advanced security features, the aircraft is locked after a user account is set up: the storage is not accessible; the live view is not available; the aircraft cannot take off. the user can unlock the aircraft with the security code to access all features of the aircraft. the security code is encrypted in the aircraft. dji will not be able to fetch the security code. if the security code is forgotten, the user has to format the storage to reset the protection system. all the files in the internal storage and the user account information will be deleted. the access locker is only supported by mavic 2 enterprise.",
             "radar",
             "this class contains components of the radar and provides methods to change its settings.",
             "simulator",
             "dji aircraft can be put into simulation mode using this class. developers can start and stop the simulation, as well as monitor basic aircraft attitude and location information.",
             "imustate",
             "this class provides the inertial measurement unit's (imu) state information.",
             "imu_state",
             "sdk key for imustate: this class provides the inertial measurement unit's (imu) state information.",
             "flightcontroldata",
             "contains all the virtual stick control data needed to move the aircraft in all directions.",
             "getpitch",
             "gets aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. use `rollpitchcontrolmode` to set the velocity or angle mode. note that the argument has different meanings in different coordinate systems. see the <i>flight controller user guide</i> for more information.  @return the velocity (m/s) or angle (degrees) value for pitch.",
             "setpitch",
             "sets the aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. use `rollpitchcontrolmode` to set the velocity or angle mode. note that the argument has different meanings in different coordinate systems. see the <i>flight controller user guide</i> for more information.  @param pitch the velocity (m/s) or angle (degrees) value for pitch",
             "getroll",
             "gets aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. use `rollpitchcontrolmode` to set the velocity or angle mode. note that the argument has different meanings in different coordinate systems. see the <i>flight controller user guide</i> for more information.  @return the velocity (m/s) or angle (degrees) value for roll.",
             "setroll",
             "sets the aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. use `rollpitchcontrolmode` to set the velocity or angle mode. note that the argument has different meanings in different coordinate systems. see the <i>flight controller user guide</i> for more information.  @param roll the velocity (m/s) or angle (degrees) value for roll.",
             "getyaw",
             "angular velocity (degrees/s) or angle (degrees) value for yaw. use `yawcontrolmode` to set angular velocity or angle mode.  @return the angular velocity (degrees/s) or angle (degrees) value for yaw.",
             "setyaw",
             "sets the angular velocity (degrees/s) or angle (degrees) value for yaw. use `yawcontrolmode` to set angular velocity or angle mode.  @param yaw the angular velocity (degrees/s) or angle (degrees) value for yaw.",
             "getverticalthrottle",
             "gets aircraft's velocity (m/s) or altitude (m) value for verticalcontrol. use `verticalcontrolmode` to set velocity or altitude mode.  @return the velocity (m/s) or altitude (m) value for verticalcontrol.",
             "setverticalthrottle",
             "sets the aircraft's velocity (m/s) or altitude (m) value for verticalcontrol. use `verticalcontrolmode` to set velocity or altitude mode.  @param verticalthrottle the velocity (m/s) or altitude (m) value for verticalcontrol.",
             "flightcontroldata",
             "constructor for the flight control data to send through virtual sticks.  @param pitch the velocity (m/s) or angle (degrees) value for pitch @param roll the velocity (m/s) or angle (degrees) value for roll. @param yaw the angular velocity (degrees/s) or angle (degrees) value for yaw. @param verticalthrottle the velocity (m/s) or altitude (m) value for verticalcontrol.",
             "verticalcontrolmode",
             "defines how vertical control values are interpreted by the aircraft.",
             "velocity",
             "sets the virtual stick vertical control values to be a vertical velocity. positive and negative vertical velocity is for the aircraft ascending and descending respectively. maximum vertical velocity is defined as 4 m/s. minimum vertical velocity is defined as -4 m/s.",
             "position",
             "sets the virtual stick vertical control values to be an altitude. maximum position is defined as 500 m. minimum position is defined as 0 m.",
             "rollpitchcontrolmode",
             "defines how manual roll and pitch values are interpreted by the aircraft.",
             "angle",
             "sets the roll and pitch values to be an angle relative to a level aircraft. in the body coordinate system, positive and negative pitch angle is for the aircraft rotating about the y-axis in the positive direction or negative direction, respectively. positive and negative roll angle is the positive direction or negative direction rotation angle about the x-axis, respectively. however in the ground coordinate system, positive and negative pitch angle is the angle value for the aircraft moving south and north, respectively. positive and negative roll angle is the angle when the aircraft is moving east and west, respectively. maximum angle is defined as 30 degrees. minimum angle is defined as -30 degrees.",
             "velocity",
             "sets the roll and pitch values to be a velocity. in the body coordinate system, positive and negative pitch velocity is for the aircraft moving towards the positive direction or negative direction along the pitch axis and y-axis, respectively. positive and negative roll velocity is when the aircraft is moving towards the positive direction or negative direction along the roll axis and x-axis, respectively. however, in the ground coordinate system, positive and negative pitch velocity is for the aircraft moving east and west, respectively. positive and negative roll velocity is when the aircraft is moving north and south, respectively. maximum velocity is defined as 15 meters/s. minimum velocity is defined as -15 meters/s.",
             "yawcontrolmode",
             "defines how manual yaw values are interpreted by the aircraft.",
             "angle",
             "sets the yaw values to be an angle relative to the north. positive and negative yaw angle is for the aircraft rotating clockwise and counterclockwise, respectively. maximum yaw angle is defined as 180 degrees. minimum yaw angle is defined as -180 degrees.",
             "angular_velocity",
             "sets the yaw values to be an angular velocity. positive and negative angular velocity is for the aircraft rotating clockwise and counterclockwise, respectively. maximum yaw angular velocity is defined as 100 degrees/s. minimum yaw angular velocity is defined as -100 degrees/s.",
             "flightcoordinatesystem",
             "flight control coordinate system.",
             "ground",
             "ground coordinate system.",
             "body",
             "body coordinate system.",
             "controlmode",
             "control mode of the flight controller. it determines how the pilot can control the aircraft. by default, it is in smart control mode.",
             "control_mode",
             "sdk key for controlmode: control mode of the flight controller. it determines how the pilot can control the aircraft. by default, it is in smart control mode.",
             "smart",
             "smart control mode. the aircraft can stabilize its altitude and attitude in smart mode.",
             "manual",
             "manual control mode. the aircraft will not stabilize its altitude and attitude in manual mode. this mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. any damage to the product when operating in this mode will not be covered under warranty.",
             "unknown",
             "unknown control mode.",
             "flightorientationmode",
             "tells the aircraft how to interpret flight commands for forward, backward, left and right. see the <i>flight controller user guide</i> for more information.",
             "orientation_mode",
             "sdk key for flightorientationmode: tells the aircraft how to interpret flight commands for forward, backward, left and right. see the <i>flight controller user guide</i> for more information.",
             "course_lock",
             "the aircraft should move relative to a locked course heading.",
             "home_lock",
             "the aircraft should move relative radially to the home point.",
             "aircraft_heading",
             "the aircraft should move relative to the front of the aircraft.",
             "flightwindwarning",
             "warning caused by the strong wind.",
             "flight_wind_warning",
             "sdk key for flightwindwarning: warning caused by the strong wind.",
             "level_0",
             "no wind warning.",
             "level_1",
             "the wind speed is high. fly with caution and ensure the aircraft remains within the line of sight.",
             "level_2",
             "strong wind. fly with caution and ensure the aircraft remains within line of sight. it is more serious than `level_1`.",
             "unknown",
             "unknown.",
             "djiflightassistantobstaclesensingdirection",
             "obstacle sensing direction. it is only supported by matrice 300 rtk.",
             "upward",
             "upward sensing. the upward distance range is 1.1m~30m",
             "downward",
             "downward sensing. the downward distance range is 0.6m~30m",
             "horizontal",
             "horizontal field. the horizontal distance range is 1.1m~40m",
             "locationcoordinate2d",
             "a class representing 2-dimensional location coordinate",
             "locationcoordinate2d",
             "construct a `djilocationcoordinate2d` object with latitude and longitude.  @param latitude latitude in degrees. @param longitude longitude in degrees.",
             "getlatitude",
             "returns `djilocationcoordinate2d` object, which could be used as an input parameter for flight controller's interfaces.  @return the double value of latitude.",
             "getlongitude",
             "returns the longitude.  @return the double value of longitude.",
             "connectionfailsafebehavior",
             "defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
             "connection_fail_safe_behavior",
             "sdk key for connectionfailsafebehavior: defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
             "hover",
             "hover.",
             "landing",
             "landing.",
             "go_home",
             "return-to-home.",
             "unknown",
             "unknown.",
             "remotecontrollerflightmode",
             "flight modes that map to the flight mode switch on the remote controller.",
             "current_mode",
             "sdk key for remotecontrollerflightmode: flight modes that map to the flight mode switch on the remote controller.",
             "p",
             "positioning mode. gnss and vision positioning systems are used for positioning if they are available. for products without f mode, intelligent functions such as missions and intelligent orientation control can be performed in p-mode.",
             "s",
             "sport mode. the maximum flight speed and responsiveness of the aircraft is increased in this mode.",
             "a",
             "attitude mode. the gnss and vision positioning systems are not used for positioning. the aircraft only uses the barometer to maintain altitude. if receiving a gnss signal, the aircraft can automatically return home if the remote controller signal is lost and if the home point has been recorded successfully.",
             "g",
             "gentle mode. the sensitivity and speed of aircraft will be substantially decreased in gentle mode.",
             "m",
             "manual mode. the aircraft will not stabilize its altitude nor attitude in manual mode. this mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. any damage to the product when operating in this mode will not be covered under warranty. it is supported by stand-alone a3 and n3 and can be enabled in assistant 2.",
             "f",
             "function mode. performs the same as positioning mode with intelligent functions such as missions and intelligent orientation control enabled.",
             "t",
             "tripod mode. this mode drops the aircraft's maximum speed and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. it is only supported by mavic 2.",
             "unknown",
             "unknown mode.",
             "smartrthstate",
             "state of smart return-to-home (rth). it is only used when smart rth is enabled.",
             "idle",
             "smart rth is not triggered yet in the current flight. the smart rth state will be reset to this value when the aircraft lands.",
             "counting_down",
             "smart rth is triggered and the aircraft is counting down. if no response is received within 10 seconds or the user confirms the request, the aircraft will start to go home and the state will change to `executed`. if user cancels the request, the state will change to `cancelled`.",
             "executed",
             "smart rth is already executed in the current flight. the state will not be reset until the aircraft lands.",
             "cancelled",
             "smart rth request is cancelled by the user. the state will not be reset until the aircraft lands.",
             "unknown",
             "unknown.",
             "airsensesysteminformation",
             "the state of dji airsense system. it contains the overall warning level and the detailed state of each detected airplane.",
             "getwarninglevel",
             "the overall system warning level. this will be the worst case of all individual aircraft warning levels.  @return an enum value of `airsensewarninglevel`.",
             "getairplanestates",
             "the state of all airplanes detected by dji airsense system.  @return an array of `airsenseairplanestate` objects.",
             "callback",
             "an interface for obtaining `airsensesysteminformation` infos.",
             "onupdate",
             "callback method of air sense airplane state.  @param information an object of `airsensesysteminformation`.",
             "airsenseairplanestate",
             "the airsense state of an airplane. dji airsense only sends out warnings of nearby civil aircraft under certain circumstances; it will not control dji aircraft to avoid other aircraft automatically. make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. after receiving warnings, lower your aircraft to a safe height. in addition, dji airsense has the following limitations: 1. dji airsense can only receive messages sent from civil aircraft equipped with an ads-b out device under 1090es (rtca do-260) or uat (rtca do-282) standards. for civil aircraft without ads-b outs or with malfunctioning ads-b outs, dji airsense cannot receive related broadcasted messages or send out warnings. 2. when there are obstacles in between a civil aircraft and dji aircraft, dji airsense will fail to receive ads-b messages sent from civil aircraft or to send out warnings. 3. dji airsense may fail to receive ads-b messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. it is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. dji airsense cannot send out warnings when the dji aircraft cannot accurately determine its location. 5. dji airsense cannot receive ads-b messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
             "air_sense_airplane_states",
             "sdk key for airsenseairplanestate: the airsense state of an airplane. dji airsense only sends out warnings of nearby civil aircraft under certain circumstances; it will not control dji aircraft to avoid other aircraft automatically. make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. after receiving warnings, lower your aircraft to a safe height. in addition, dji airsense has the following limitations: 1. dji airsense can only receive messages sent from civil aircraft equipped with an ads-b out device under 1090es (rtca do-260) or uat (rtca do-282) standards. for civil aircraft without ads-b outs or with malfunctioning ads-b outs, dji airsense cannot receive related broadcasted messages or send out warnings. 2. when there are obstacles in between a civil aircraft and dji aircraft, dji airsense will fail to receive ads-b messages sent from civil aircraft or to send out warnings. 3. dji airsense may fail to receive ads-b messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. it is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. dji airsense cannot send out warnings when the dji aircraft cannot accurately determine its location. 5. dji airsense cannot receive ads-b messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
             "getcode",
             "the unique code (icao) of the airplane.  @return string of the unique code (icao).",
             "getwarninglevel",
             "the warning level determined by dji airsense system.  @return an enum value of `airsensewarninglevel`.",
             "getrelativedirection",
             "the direction of the airplane relative to the dji aircraft.  @return an enum value of `airsensedirection`.",
             "getheading",
             "the heading of the airplane.  @return a float value of heading.",
             "getdistance",
             "the distance between the airplane and dji aircraft in meters.  @return an int value of distance.",
             "callback",
             "an interface for obtaining `airsenseairplanestate` infos.",
             "onupdate",
             "callback method of air sense airplane state.  @param information array of `airsenseairplanestate`.",
             "airsensewarninglevel",
             "the warning level determined by the dji airsense system. the warning level is based on the distance between the airplane and the dji aircraft, and the heading of the airplane.",
             "air_sense_system_warning_level",
             "sdk key for airsensewarninglevel: the warning level determined by the dji airsense system. the warning level is based on the distance between the airplane and the dji aircraft, and the heading of the airplane.",
             "level_0",
             "the system detects the airplane but the dji aircraft is either far away from the airplane or is in the opposite direction of the airplane's heading.",
             "level_1",
             "the system detects the airplane. the probability that it will pass through the location of the dji aircraft is considered low.",
             "level_2",
             "the system detects the airplane. the probability that it will pass through the location of the dji aircraft is considered medium.",
             "level_3",
             "the system detects the airplane. the probability that it will pass through the location of the dji aircraft is considered high.",
             "level_4",
             "the system detects the airplane. the probability that it will pass through the location of the dji aircraft is very high.",
             "unknown",
             "unknown.",
             "airsensedirection",
             "directions.",
             "north",
             "north.",
             "north_east",
             "north east.",
             "east",
             "east.",
             "south_east",
             "south east.",
             "south",
             "south.",
             "south_west",
             "south west.",
             "west",
             "west.",
             "north_west",
             "north west.",
             "unknown",
             "unknown.",
             "ledssettings",
             "settings for the aircraft's leds.",
             "arefrontledson",
             "`true` if the leds on the front arms are turned on.  @return a boolean value.",
             "arerearledson",
             "`true` if the leds on the rear arms are turned on. it is supported by inspire 2, matrice 200 series and mavic 2 series. the other products will ignore this property.  @return a boolean value.",
             "arebeaconson",
             "`true` if the beacons on the top and bottom are turned on. it is supported by matrice 300 rtk. the other products will ignore this property.  @return a boolean value.",
             "isstatusindicatoron",
             "`true` if the status indicator is on. it is supported by inspire 2, matrice 200 series and mavic 2 series. the other products will ignore this property. for mavic 2 series, there are two status indicators and they are on the rear arms.  @return a boolean value.",
             "builder",
             "used to create `ledssettings` instance.",
             "frontledson",
             "`true` to turn on the leds on the front arms.  @param frontledson `true` to turn on the leds on the front arms.  @return a `builder` object.",
             "rearledson",
             "`true` to turn on the leds on the rear arms. it is supported by inspire 2 and matrice 200 series. the other products will always return `false`.  @param rearledson `true` to turn on the leds on the rear arms.  @return a `builder` object.",
             "statusindicatoron",
             "`true` to turn on the leds on the rear arms. it is supported by inspire 2, matrice 200 series and mavic 2 series. the other products will always return `false`.  @param statusindicatoron `true` to turn on the leds on the rear arms.  @return a `builder` object.",
             "beaconson",
             "`true` to turn on the beacons on the top and bottom of aircraft. it is supported by matrice 300 rtk. the other products will ignore this property.  @param beaconson `true` to turn on the beacons.  @return a `builder` object.",
             "limits",
             "this class provides max and min values for flight controller virtual stick.",
             "vertical_control_min_velocity",
             "vertical control velocity min value -4 m/s in virtualstickcontrolmode. negative velocity is down.",
             "vertical_control_max_velocity",
             "vertical control velocity max value 4 m/s in virtualstickcontrolmode. positive velocity is up.",
             "vertical_control_min_height",
             "vertical control position min for virtualstickverticalcontrolmodeposition. the default value is 0m.",
             "vertical_control_max_height",
             "vertical control position max for virtualstickverticalcontrolmodeposition. the default value is 500m.",
             "roll_pitch_control_max_velocity",
             "roll/pitch control velocity max value 15m/s.",
             "roll_pitch_control_min_velocity",
             "roll/pitch control velocity min value -15m/s.",
             "roll_pitch_control_max_angle",
             "roll/pitch control angle max value 30 degrees.",
             "roll_pitch_control_min_angle",
             "roll/pitch control angle min value -30 degrees.",
             "yaw_control_max_angle",
             "yaw control angle max value 180 degrees.",
             "yaw_control_min_angle",
             "yaw control angle min value -180 degrees.",
             "yaw_control_max_angular_velocity",
             "yaw control angular velocity max value 100 degree/s.",
             "yaw_control_min_angular_velocity",
             "yaw control angular velocity min value -100 degree/s.",
             "fixedwingcontrol",
             "the aircraft will fly forward automatically at a certain speed after entering fixed-wing mode. push the left stick up to ascend and down to descend. push either stick left or right to rotate the aircraft. push the right stick up to accelerate and pushing down will exit fixed-wing mode. see the <i>flight controller user guide</i> for more information.",
             "fixed_wing_control",
             "sdk key for fixedwingcontrol: the aircraft will fly forward automatically at a certain speed after entering fixed-wing mode. push the left stick up to ascend and down to descend. push either stick left or right to rotate the aircraft. push the right stick up to accelerate and pushing down will exit fixed-wing mode. see the <i>flight controller user guide</i> for more information.",
             "ready",
             "prepare fixed-wing mode.",
             "enter",
             "enter fixed-wing mode.",
             "exit",
             "exit fixed-wing mode.",
             "other",
             "other reservations.",
             "visiondrawheadingmode",
             "the heading mode of the camera used in the vision drawing the 3d orbit data.",
             "draw_heading_mode",
             "sdk key for visiondrawheadingmode: the heading mode of the camera used in the vision drawing the 3d orbit data.",
             "free",
             "free mode - camera direction can be freely adjusted in flight.",
             "forward",
             "regular mode - camera direction consistent with course direction.",
             "unknown",
             "unknown.",
             "visiondrawstatus",
             "state of the vision drawing the 3d orbit data.",
             "draw_status",
             "sdk key for visiondrawstatus: state of the vision drawing the 3d orbit data.",
             "init",
             "initializing.",
             "prepare",
             "vision got the orbit data, and preparing to calculate the 3d orbit.",
             "ready_to_go",
             "vision has generated the 3d orbit data, and start to download.",
             "start_auto",
             "starting state (auto mode).",
             "start_manual",
             "staring state (manual mode).",
             "pause",
             "pause state.",
             "other",
             "other unknown state.",
             "urgentstopmotormode",
             "the mode enum to urgent stop motor.",
             "urgent_stop_motor_mode",
             "sdk key for urgentstopmotormode: the mode enum to urgent stop motor.",
             "csc",
             "command only for inspire 2, phantom 4, phantom 4 professional, phantom 4 advanced and m200 series.",
             "never",
             "command only for inspire 2, phantom 4, phantom 4 professional, phantom 4 advanced and m200 series.",
             "in_out_always",
             "command only for dji mavic pro and mavic air.",
             "in_out_when_breakdown",
             "command only for dji mavic pro and mavic air.",
             "unknown",
             "unknown.",
             "setstatecallback",
             "sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback the execution callback with the execution result returned.",
             "simulator_state",
             "sdk key for setstatecallback: sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback the execution callback with the execution result returned.",
             "issimulatoractive",
             "`true` if the simulator is started.  @return a boolean value.",
             "is_simulator_active",
             "sdk key for issimulatoractive: `true` if the simulator is started.  @return a boolean value.",
             "start",
             "start simulator. will result in error if simulation is already started.  @param data the data with which to initialize the simulator. @param callback the execution callback with the execution result returned.",
             "start_simulator",
             "sdk key for start: start simulator. will result in error if simulation is already started.  @param data the data with which to initialize the simulator. @param callback the execution callback with the execution result returned.",
             "stop",
             "stop the simulator.  @param callback the execution callback with the execution result returned.",
             "stop_simulator",
             "sdk key for stop: stop the simulator.  @param callback the execution callback with the execution result returned.",
             "setflyzonelimitationenabled",
             "enable/disable the fly zone system in the simulator. by default, fly zone is disabled in the simulator.  rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback the execution callback with the returned value(s).",
             "fly_zone_limitation_enabled",
             "sdk key for setflyzonelimitationenabled: enable/disable the fly zone system in the simulator. by default, fly zone is disabled in the simulator.  rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback the execution callback with the returned value(s).",
             "getflyzonelimitationenabled",
             "gets fly zone system simulator status (enabled/disabled). by default, fly zone is disabled in the simulator.  @param callback the execution callback with the returned value(s).",
             "fly_zone_limitation_enabled",
             "sdk key for getflyzonelimitationenabled: gets fly zone system simulator status (enabled/disabled). by default, fly zone is disabled in the simulator.  @param callback the execution callback with the returned value(s).",
             "initializationdata",
             "data to initialize the simulator with.",
             "start_simulator",
             "sdk key for initializationdata: data to initialize the simulator with.",
             "simulatorstate",
             "aircraft simulator state data.",
             "simulator_state",
             "sdk key for simulatorstate: aircraft simulator state data.",
             "callback",
             "simulator's callback interface. when the sdk receives the `simulatorstate`, the override  method will be called.",
             "simulator_state",
             "sdk key for callback: simulator's callback interface. when the sdk receives the `simulatorstate`, the override  method will be called.",
             "onupdate",
             "updates the simulator's current state.  @param state an instance of `simulatorstate`.",
             "simulator_state",
             "sdk key for onupdate: updates the simulator's current state.  @param state an instance of `simulatorstate`.",
             "aremotorson",
             "true if motors are on in the simulator.  @return a boolean value.",
             "isflying",
             "true if aircraft is flying in the simulator.  @return a boolean value.",
             "getlocation",
             "simulated aircraft location.  @return location object.",
             "getpositionx",
             "gets east-west distance from initial simulator location, where east is positive, and  north-east-down coordinate system is used.  @return a float value.",
             "getpositiony",
             "gets north-south distance from initial simulator location, where north is positive, and  north-east-down coordinate system is used.  @return a float value.",
             "getpositionz",
             "gets vertical distance from initial simulator location. the value should be negative if the height of aircraft is higher  than initial home point's height.  @return a float value.",
             "getpitch",
             "simulated aircraft pitch with range [-30, 30] degrees.  @return a float value.",
             "getroll",
             "simulated aircraft roll with range [-30, 30] degrees.  @return a float value.",
             "getyaw",
             "simulated aircraft yaw with range [-180, 180] degrees.  @return a float value.",
             "createinstance",
             "create the initialization data for the simulator.  @param location simulator coordinate latitude and longitude in degrees. @param updatefrequency aircraft simulator state push frequency in hz with range [2, 150]. a setting of 10 hz will result in delegate method being called, 10 times per second. @param satellitecount the initial number of gps satellites with range [0, 20].  @return initialization data object.",
             "getupdatefrequency",
             "aircraft simulator state push frequency in hz with range [2, 150]. a setting of 10 hz will result in  `onupdate` being called 10 times per second.  @return frequency.",
             "getsatellitecount",
             "the initial number of gnss satellites with range [0, 20]  @return number of satellites.",
             "getlocation",
             "location to begin simulation.  @return location object",
             "getheading",
             "represents the heading, in degrees. true north is 0 degrees, positive heading is east of north, and negative  heading is west of north. heading bounds are [-180, 180].  @return a double value of the heading, in degrees.",
             "compass_heading",
             "sdk key for getheading: represents the heading, in degrees. true north is 0 degrees, positive heading is east of north, and negative  heading is west of north. heading bounds are [-180, 180].  @return a double value of the heading, in degrees.",
             "haserror",
             "`true` if the compass has an error. if `true`, the compass  needs calibration.  @return a boolean value.",
             "compass_has_error",
             "sdk key for haserror: `true` if the compass has an error. if `true`, the compass  needs calibration.  @return a boolean value.",
             "iscalibrating",
             "`true` if the compass is currently calibrating.  @return a boolean value.",
             "compass_is_calibrating",
             "sdk key for iscalibrating: `true` if the compass is currently calibrating.  @return a boolean value.",
             "getcalibrationstate",
             "shows the calibration status.  @return an enum value of `compasscalibrationstate`.",
             "compass_calibration_status",
             "sdk key for getcalibrationstate: shows the calibration status.  @return an enum value of `compasscalibrationstate`.",
             "startcalibration",
             "starts compass calibration. make sure there are no magnets or metal objects near the compass.  @param callback completion callback. see djibasecomponent for more information about the callback and what is  recommended be done with it.",
             "compass_start_calibration",
             "sdk key for startcalibration: starts compass calibration. make sure there are no magnets or metal objects near the compass.  @param callback completion callback. see djibasecomponent for more information about the callback and what is  recommended be done with it.",
             "stopcalibration",
             "stops compass calibration.  @param callback completion callback. see djibasecomponent for more information about the callback and what is recommended  be done with it.",
             "compass_stop_calibration",
             "sdk key for stopcalibration: stops compass calibration.  @param callback completion callback. see djibasecomponent for more information about the callback and what is recommended  be done with it.",
             "setcalibrationstatecallback",
             "sets the callback for compass calibration.  @param callback the callback with compass calibration state",
             "compass_calibration_status",
             "sdk key for setcalibrationstatecallback: sets the callback for compass calibration.  @param callback the callback with compass calibration state",
             "compasscalibrationstate",
             "an enum class representing compass calibration.",
             "compass_calibration_status",
             "sdk key for compasscalibrationstate: an enum class representing compass calibration.",
             "not_calibrating",
             "normal state. compass not in calibration.",
             "horizontal",
             "compass horizontal calibration. the user should hold the aircraft horizontally and rotate it 360 degrees.",
             "vertical",
             "compass vertical calibration. the user should hold the aircraft vertically, with the nose pointed towards the  ground, and rotate the aircraft 360 degrees.",
             "successful",
             "compass calibration succeeded.",
             "failed",
             "compass calibration failed. make sure there are no magnets or metal objects near the compass and retry.",
             "unknown",
             "compass calibration status unknown.",
             "callback",
             "updates compass calibration state",
             "compass_calibration_status",
             "sdk key for callback: updates compass calibration state",
             "onupdate",
             "called when calibration state is updated.  @param state the updated calibration state",
             "compass_calibration_status",
             "sdk key for onupdate: called when calibration state is updated.  @param state the updated calibration state",
             "callback",
             "callback function that updates the flight controller's current state data. this method gets called 10 times per second.",
             "aremotorson",
             "`true` if motors are on.  @return a boolean value.",
             "are_motor_on",
             "sdk key for aremotorson: `true` if motors are on.  @return a boolean value.",
             "isflying",
             "`true` if aircraft is flying.  @return a boolean value.",
             "is_flying",
             "sdk key for isflying: `true` if aircraft is flying.  @return a boolean value.",
             "getaircraftlocation",
             "gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return the current location of the aircraft as a coordinate.",
             "aircraft_location_latitude",
             "sdk key for getaircraftlocation: gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return the current location of the aircraft as a coordinate.",
             "aircraft_location_longitude",
             "sdk key for getaircraftlocation: gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return the current location of the aircraft as a coordinate.",
             "altitude",
             "sdk key for getaircraftlocation: gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return the current location of the aircraft as a coordinate.",
             "gettakeofflocationaltitude",
             "relative altitude of the aircraft home location relative to sea level, in meters.  @return a float value of the altitude.",
             "getattitude",
             "gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. if its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a true north heading.  @return the attitude of the aircraft.",
             "attitude_pitch",
             "sdk key for getattitude: gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. if its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a true north heading.  @return the attitude of the aircraft.",
             "attitude_roll",
             "sdk key for getattitude: gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. if its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a true north heading.  @return the attitude of the aircraft.",
             "attitude_yaw",
             "sdk key for getattitude: gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. if its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a true north heading.  @return the attitude of the aircraft.",
             "getvelocityx",
             "current speed of the aircraft in the x direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the x direction.",
             "velocity_x",
             "sdk key for getvelocityx: current speed of the aircraft in the x direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the x direction.",
             "getvelocityy",
             "current speed of the aircraft in the y direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the y direction.",
             "velocity_y",
             "sdk key for getvelocityy: current speed of the aircraft in the y direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the y direction.",
             "getvelocityz",
             "current speed of the aircraft in the z direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the z direction.",
             "velocity_z",
             "sdk key for getvelocityz: current speed of the aircraft in the z direction, in meters per second, using the n-e-d (north-east-down) coordinate system.  @return a float value of the current speed of the aircraft in the z direction.",
             "getflighttimeinseconds",
             "the accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return an int value of the flight time.",
             "fly_time_in_seconds",
             "sdk key for getflighttimeinseconds: the accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return an int value of the flight time.",
             "islandingconfirmationneeded",
             "`true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. when the confirmation is needed, `confirmlanding` in `flightcontroller` can be used to continue landing. it is  supported by flight controller firmware 3.2.0.0 or above.  @return whether confirmation is needed or not.",
             "is_landing_confirmation_needed",
             "sdk key for islandingconfirmationneeded: `true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. when the confirmation is needed, `confirmlanding` in `flightcontroller` can be used to continue landing. it is  supported by flight controller firmware 3.2.0.0 or above.  @return whether confirmation is needed or not.",
             "getflightmode",
             "flight controller flight mode. for more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the flight mode part.  @return an enum value of the `flightmode`.",
             "flight_mode",
             "sdk key for getflightmode: flight controller flight mode. for more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the flight mode part.  @return an enum value of the `flightmode`.",
             "ismultiplemodeopen",
             "determines whether multiple flight modes are open. this will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
             "multi_mode_open",
             "sdk key for ismultiplemodeopen: determines whether multiple flight modes are open. this will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
             "getsatellitecount",
             "returns the gps satellite count.  @return the double value of the gps satellite count.",
             "satellite_count",
             "sdk key for getsatellitecount: returns the gps satellite count.  @return the double value of the gps satellite count.",
             "getgpssignallevel",
             "gets the aircraft's current gps signal quality. if the return value is in [6,10], which means the rtk signal is strong.  @return the aircraft's current gps signal quality.",
             "gps_signal_level",
             "sdk key for getgpssignallevel: gets the aircraft's current gps signal quality. if the return value is in [6,10], which means the rtk signal is strong.  @return the aircraft's current gps signal quality.",
             "isimupreheating",
             "`true` if imu is preheating.  @return a boolean value.",
             "is_imu_preheating",
             "sdk key for isimupreheating: `true` if imu is preheating.  @return a boolean value.",
             "isultrasonicbeingused",
             "`true` if the ultrasonic sensor is being used. variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return a boolean value.",
             "is_ultrasonic_being_used",
             "sdk key for isultrasonicbeingused: `true` if the ultrasonic sensor is being used. variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return a boolean value.",
             "getultrasonicheightinmeters",
             "height of aircraft measured by the ultrasonic sensor in meters. the data will only be available if `isultrasonicbeingused` returns `true`. height has a precision of 0.1m. this value has reference significance when the height is below 5 meters.  @return a float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
             "ultrasonic_height_in_meters",
             "sdk key for getultrasonicheightinmeters: height of aircraft measured by the ultrasonic sensor in meters. the data will only be available if `isultrasonicbeingused` returns `true`. height has a precision of 0.1m. this value has reference significance when the height is below 5 meters.  @return a float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
             "doesultrasonichaveerror",
             "`true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
             "ultrasonic_error",
             "sdk key for doesultrasonichaveerror: `true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
             "isvisionpositioningsensorbeingused",
             "`true` if a vision sensor is being used. variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). usually, the vision sensor works when the aircraft is less than 3m above ground.  @return a boolean value.",
             "is_vision_positioning_sensor_being_used",
             "sdk key for isvisionpositioningsensorbeingused: `true` if a vision sensor is being used. variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). usually, the vision sensor works when the aircraft is less than 3m above ground.  @return a boolean value.",
             "getorientationmode",
             "the aircraft's current orientation mode.  @return an enum value of `flightorientationmode`.",
             "orientation_mode",
             "sdk key for getorientationmode: the aircraft's current orientation mode.  @return an enum value of `flightorientationmode`.",
             "isfailsafeenabled",
             "`true` if the signal is lost between remote controller and aircraft, and failsafe is enabled.  @return a boolean value.",
             "is_fail_safe",
             "sdk key for isfailsafeenabled: `true` if the signal is lost between remote controller and aircraft, and failsafe is enabled.  @return a boolean value.",
             "getbatterythresholdbehavior",
             "recommended action based on remaining battery life. not supported by mavic air 2, dji air 2s.  @return an enum value of `batterythresholdbehavior`.",
             "battery_threshold_behavior",
             "sdk key for getbatterythresholdbehavior: recommended action based on remaining battery life. not supported by mavic air 2, dji air 2s.  @return an enum value of `batterythresholdbehavior`.",
             "islowerthanbatterywarningthreshold",
             "`true` if the battery is lower than the low battery warning threshold.  @return a boolean value.",
             "islowerthanseriousbatterywarningthreshold",
             "`true` if the battery is lower than the serious low battery warning threshold.  @return a boolean value.",
             "getflightwindwarning",
             "warning related to high winds.  @return an enum value of `flightwindwarning`.",
             "getflightcount",
             "the count of flights within the battery life cycle. cleared when power-on.  @return an int value of flight count.",
             "getflightlogindex",
             "the current index of the flight log on the aircraft. it is useful to find the corresponding flight log.  @return an int value of the flight log index.",
             "isactivebrakeengaged",
             "`true` when active brake is enaged to avoid obstacles. it is supported only by matrice 300 rtk.  @return `true` if active brake is engaged.",
             "ishomelocationset",
             "`true` if the home point has been set.  @return a boolean value.",
             "is_home_location_set",
             "sdk key for ishomelocationset: `true` if the home point has been set.  @return a boolean value.",
             "gethomelocation",
             "returns the home location of the aircraft as a coordinate.  @return an instance of `locationcoordinate2d`.",
             "home_location",
             "sdk key for gethomelocation: returns the home location of the aircraft as a coordinate.  @return an instance of `locationcoordinate2d`.",
             "home_location_latitude",
             "sdk key for gethomelocation: returns the home location of the aircraft as a coordinate.  @return an instance of `locationcoordinate2d`.",
             "home_location_longitude",
             "sdk key for gethomelocation: returns the home location of the aircraft as a coordinate.  @return an instance of `locationcoordinate2d`.",
             "getgohomeassessment",
             "gets the aircraft's smart go home data. if smart go home is enabled, all the smart go home data will be available in `gohomeassessment`.  @return an instance of `gohomeassessment`.",
             "getgohomeexecutionstate",
             "the current status of go-home execution.  @return an enum value of `gohomeexecutionstate`.",
             "go_home_status",
             "sdk key for getgohomeexecutionstate: the current status of go-home execution.  @return an enum value of `gohomeexecutionstate`.",
             "isgoinghome",
             "`true` if the aircraft is going home.  @return a boolean value.",
             "is_going_home",
             "sdk key for isgoinghome: `true` if the aircraft is going home.  @return a boolean value.",
             "getgohomeheight",
             "gets the height when the aircraft is going home in meters.  @return an int value of the height when the aircraft is going home.",
             "go_home_height_in_meters",
             "sdk key for getgohomeheight: gets the height when the aircraft is going home in meters.  @return an int value of the height when the aircraft is going home.",
             "attitude",
             "the attitude of the aircraft where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. if its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a true north heading.",
             "pitch",
             "the pitch value of the aircraft: forward is positive, backward is negative. units are in degrees.",
             "roll",
             "the roll value of the aircraft: forward is positive, backward is negative. units are in degrees.",
             "yaw",
             "the yaw value of the aircraft, where 0 corresponds to a true north heading. yawing clockwise will increase yaw value.",
             "batterythresholdbehavior",
             "remaining battery life state. this state describes the recommended action based on remaining battery life.",
             "battery_threshold_behavior",
             "sdk key for batterythresholdbehavior: remaining battery life state. this state describes the recommended action based on remaining battery life.",
             "fly_normally",
             "remaining battery life sufficient for normal flying.",
             "go_home",
             "remaining battery life sufficient to go home.",
             "land_immediately",
             "remaining battery life sufficient to land immediately.",
             "unknown",
             "unknown.",
             "gohomeexecutionstate",
             "an enum used to identify the different stages of the go-home command. some aircraft only support part of the state depending on the firmware.  for exampele:  phantom 4 pro v2.0 and mavic 2 enterprise dual only support `go_down_to_ground`.  matrice 300 rtk only suppoort `go_up_to_height`, `auto_fly_to_home_point` and `go_down_to_ground`.",
             "go_home_status",
             "sdk key for gohomeexecutionstate: an enum used to identify the different stages of the go-home command. some aircraft only support part of the state depending on the firmware.  for exampele:  phantom 4 pro v2.0 and mavic 2 enterprise dual only support `go_down_to_ground`.  matrice 300 rtk only suppoort `go_up_to_height`, `auto_fly_to_home_point` and `go_down_to_ground`.",
             "not_executing",
             "the aircraft is not executing a go-home command.",
             "turn_direction_to_home_point",
             "the aircraft is turning the heading direction to the home point.",
             "go_up_to_height",
             "the aircraft is going up to the height for go-home command.",
             "auto_fly_to_home_point",
             "the aircraft is flying horizontally to home point.",
             "go_down_to_ground",
             "the aircraft is going down after arriving at the home point.",
             "braking",
             "the aircraft is braking to avoid collision.",
             "bypassing",
             "the aircraft is bypassing over the obstacle.",
             "completed",
             "the go-home command is completed.",
             "unknown",
             "the go-home status is unknown.",
             "locationcoordinate3d",
             "this is a structure for presenting the location, latitude, longitude, altitude.",
             "locationcoordinate3d",
             "constructs the 3d coordinate with latitude, longitude and altitude.  @param latitude latitude in degrees @param longitude longitude in degrees @param altitude altitude in meters",
             "getlatitude",
             "returns the latitude.  @return a double value of the latitude.",
             "getlongitude",
             "returns the longitude.  @return a double value of the longitude.",
             "getaltitude",
             "returns the relative altitude of the aircraft relative to take off location, measured by barometer, in meters.  @return a float value of the relative altitude of the aircraft relative to take off location.",
             "gohomeassessment",
             "class for smart go home status.",
             "getremainingflighttime",
             "the estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. this time includes landing the aircraft. if the aircraft is using the simulator, this value will be 0.  @return an int value.",
             "remaining_flight_time",
             "sdk key for getremainingflighttime: the estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. this time includes landing the aircraft. if the aircraft is using the simulator, this value will be 0.  @return an int value.",
             "gettimeneededtogohome",
             "the estimated time, in seconds, needed for the aircraft to go home from its current location.  @return an int value.",
             "time_needed_to_go_home",
             "sdk key for gettimeneededtogohome: the estimated time, in seconds, needed for the aircraft to go home from its current location.  @return an int value.",
             "gettimeneededtolandfromcurrentheight",
             "the estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return an int value.",
             "time_needed_to_land_from_current_height",
             "sdk key for gettimeneededtolandfromcurrentheight: the estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return an int value.",
             "getbatterypercentageneededtogohome",
             "the estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. this includes landing of the aircraft.  @return an int value.",
             "battery_percentage_needed_to_go_home",
             "sdk key for getbatterypercentageneededtogohome: the estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. this includes landing of the aircraft.  @return an int value.",
             "getbatterypercentageneededtolandfromcurrentheight",
             "the battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return battery percentage.",
             "current_land_immediately_battery",
             "sdk key for getbatterypercentageneededtolandfromcurrentheight: the battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return battery percentage.",
             "getmaxradiusaircraftcanflyandgohome",
             "the maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. if the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. if the aircraft is using the simulator, this value will be 0.  @return a float value.",
             "max_radius_aircraft_can_fly_and_go_home",
             "sdk key for getmaxradiusaircraftcanflyandgohome: the maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. if the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. if the aircraft is using the simulator, this value will be 0.  @return a float value.",
             "getsmartrthstate",
             "the smart return-to-home (rth) state for the current flight.  @return an enum value of `smartrthstate`.",
             "getsmartrthcountdown",
             "the countdown (in seconds) for the smart return-to-home (rth). once the countdown reaches 0, the aircraft will execute an automatic go-home procedure. it is only valid when `getsmartrthstate` is `counting_down`.  @return the countdown for the smart return-to-home (rth).",
             "gpssignallevel",
             "a enum class representing gps signal levels, which are used to measure the signal quality.",
             "gps_signal_level",
             "sdk key for gpssignallevel: a enum class representing gps signal levels, which are used to measure the signal quality.",
             "level_0",
             "the gps has almost no signal, which is very bad.",
             "level_1",
             "the gps signal is very weak.",
             "level_2",
             "the gps signal is weak. at this level, the aircraft's go home functionality will still work.",
             "level_3",
             "the gps signal is good. at this level, the aircraft can hover in the air.",
             "level_4",
             "the gps signal is very good. at this level, the aircraft can record the home point.",
             "level_5",
             "the gps signal is very strong.",
             "none",
             "there is no gps signal.",
             "flightmode",
             "flight controller flight modes. if the current flight mode means p-gps, it will show opti in dji app if the vision system is working. if the current flight mode contains gps and also the rtk signal is healthy, it will show rtk in dji app.",
             "flight_mode",
             "sdk key for flightmode: flight controller flight modes. if the current flight mode means p-gps, it will show opti in dji app if the vision system is working. if the current flight mode contains gps and also the rtk signal is healthy, it will show rtk in dji app.",
             "manual",
             "manual mode. shown as manual in dji app.",
             "atti",
             "attitude mode. shown as atti in dji app.",
             "atti_course_lock",
             "attitude course lock mode. shown as atti in dji app.",
             "atti_hover",
             "attitude hover mode. shown as atti in dji app.",
             "hover",
             "hover mode. shown as p-gps in dji app.",
             "gps_blake",
             "gps blake mode. shown as p-gps in dji app.",
             "gps_atti",
             "gps attitude mode. shown as p-gps in dji app.",
             "gps_course_lock",
             "gps course lock mode. shown as cl/p-cl/f-cl in dji app.",
             "gps_home_lock",
             "gps home mode. shown as hl/p-hl/f-hl in dji app.",
             "gps_hot_point",
             "gps hotpoint mode. show as poi/f-poi in dji app.",
             "assisted_takeoff",
             "assisted takeoff mode. shown as takeoff in dji app.",
             "auto_takeoff",
             "auto takeoff mode. shown as takeoff in dji app.",
             "auto_landing",
             "auto landing mode. shown as landing in dji app.",
             "atti_landing",
             "attitude landing mode. shown as landing in dji app.",
             "gps_waypoint",
             "gps waypoint mode. shown as wp/f-wp in dji app.",
             "go_home",
             "go home mode. shown as gohome in dji app.",
             "joystick",
             "joystick mode. hown as joystick in dji app.",
             "atti_limited",
             "attitude limited mode. shown as atti in dji app.",
             "draw",
             "draw mode. shown as draw in dji app.",
             "gps_follow_me",
             "gps follow me mode. shown as fm/f-fm in dji app.",
             "active_track",
             "activetrack mode. shown as activetrack in dji app.",
             "tap_fly",
             "tapfly mode. shown as tapfly in dji app.",
             "gps_sport",
             "sport mode. shown as sport in dji app.",
             "unknown",
             "the main controller flight mode is unknown.",
             "confirm_landing",
             "confirm landing mode. shown as landing in dji app.",
             "terrain_follow",
             "the aircraft should move following the terrain. shown as terraintracking in dji app.",
             "tripod",
             "tripod mode. shown as tripod in dji app.",
             "track_spotlight",
             "active track mode, corresponds to spotlight active track mode. shown as quickshot/activetrack in dji app.",
             "motors_just_started",
             "the motors are just started. shown as takeoff in dji app.",
             "callback",
             "this protocol provides an interface to update the intelligent flight assistant current state.",
             "onupdate",
             "callback function that updates the vision detection state. the frequency of this method is 10hz.  @param state the state of vision sensor.",
             "issensorbeingused",
             "`true` if the vision sensor is working.  @return a boolean value.",
             "is_vision_positioning_sensor_being_used",
             "sdk key for issensorbeingused: `true` if the vision sensor is working.  @return a boolean value.",
             "getsystemwarning",
             "distance warning level between the obstacle and the aircraft. this is a combination of warning levels from each sector.  @return an enum value of `visionsystemwarning`",
             "vision_system_warning",
             "sdk key for getsystemwarning: distance warning level between the obstacle and the aircraft. this is a combination of warning levels from each sector.  @return an enum value of `visionsystemwarning`",
             "getposition",
             "the vision sensor's position on the aircraft. for phantom 4 pro, there are 4 vision sensors on the aircraft.  the sensors on the nose and tail are dual- camera sensors. the sensors on the left and right are infrared  time-of-flight (tof) sensors.  @return an enum value of `visionsensorposition`",
             "getobstacledistanceinmeters",
             "the distance to the closest detected obstacle, in meters. it is only used when the sensor is an infrared tof  sensor. the valid range is [0.3, 5.0]. phantom 4 pro has two infrared sensors on its left and right. both sensors have a 70-degree horizontal field of view (fov) and 20-degree vertical fov. the value is always 0.0 if the sensor is a dual-camera sensor or the sensor is not working properly.  @return a double value.",
             "getdetectionsectors",
             "the vision system can see in front of the aircraft with a 70 degree horizontal field of view (fov) and 55-degree  vertical fov for the phantom 4. the horizontal fov is split into four equal sectors and this array contains the distance and warning information for each sector. for phantom 4, the horizontal fov is separated into 4 sectors.  @return an instance of list<djivisiondetectionsector>. ",
             "detection_sectors",
             "sdk key for getdetectionsectors: the vision system can see in front of the aircraft with a 70 degree horizontal field of view (fov) and 55-degree  vertical fov for the phantom 4. the horizontal fov is split into four equal sectors and this array contains the distance and warning information for each sector. for phantom 4, the horizontal fov is separated into 4 sectors.  @return an instance of list<djivisiondetectionsector>. ",
             "isdisabled",
             "`true` if the vision sensor is disabled.  @return a boolean value.",
             "obstacledetectionsector",
             "the vision system can see in front of the aircraft with a 60 degree horizontal field of view (fov) and 55 degree  vertical fov. the horizontal fov is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
             "detection_sectors",
             "sdk key for obstacledetectionsector: the vision system can see in front of the aircraft with a 60 degree horizontal field of view (fov) and 55 degree  vertical fov. the horizontal fov is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
             "visionsensorposition",
             "position of the sensor on the aircraft.",
             "nose",
             "the sensor is on the front or nose of the aircraft.",
             "tail",
             "the sensor is on the back or tail of the aircraft.",
             "right",
             "the sensor is on the right or starboard side of the aircraft.",
             "left",
             "the sensor is on the left or port side of the aircraft.",
             "unknown",
             "unknown.",
             "visionsystemwarning",
             "distance warning returned by the front vision system. warning level 4 is the most serious level.",
             "vision_system_warning",
             "sdk key for visionsystemwarning: distance warning returned by the front vision system. warning level 4 is the most serious level.",
             "invalid",
             "the warning is invalid. the front vision system cannot determine depth of the scene in front of it.",
             "safe",
             "the distance between the obstacle detected by the vision system and the aircraft is safe (over 2 meters).",
             "dangerous",
             "the distance between the obstacle detected by the vision system and the aircraft is dangerous (less than 2 meters).",
             "unknown",
             "the distance warning is unknown. this warning is returned when an exception occurs.",
             "getwarninglevel",
             "the warning level based on distance.  @return an enum value of `obstacledetectionsectorwarning`",
             "getobstacledistanceinmeters",
             "the detected obstacle distance to the aircraft in meters. the left and right obstacle avoidance system is a monocular vision system,  so it can only detect whether there are obstacles. 0 represents no obstacles and 1 represents obstacles.  for mavic 2 series, it only supports returning this value in t mode.  @return a float value.",
             "obstacledetectionsectorwarning",
             "distance warning returned by each sector of the front vision system. warning level 6 is the most serious level. for different aircraft, the same warning level will refer to different distances. spark only supports the follow warning levels:     - `invalid`     - `level_1`     - `level_2`     - `level_3`     - `unknown`",
             "invalid",
             "the warning level is invalid. the sector cannot determine depth of the scene in front of it.",
             "level_1",
             "warning level 1.  - phantom 4 and mavic pro: the distance between the obstacle detected by  the sector and the aircraft is over 10 meters.  - spark: the distance between the obstacle  detected by the sector and the aircraft is over 4 meters.  - others: the distance between  the obstacle detected by the sector and the aircraft is over 20 meters.",
             "level_2",
             "warning level 2.  - phantom 4 and mavic pro: the distance between the obstacle detected by the sector and the aircraft is between 8 - 10 meters.  - spark: the distance between the obstacle  detected by the sector and the aircraft is between 2 - 4 meters.  - others: the distance between  the obstacle detected by the sector and the aircraft is between 15 - 20 meters.",
             "level_3",
             "warning level 3.  - phantom 4 and mavic pro: the distance between the obstacle detected by the sector  and the aircraft is between 6 - 8 meters.  - spark: the distance between the obstacle detected by the  sector and the aircraft is less than 2 meters.  - others: the distance between the obstacle detected  by the sector and the aircraft is between 10 - 15 meters.",
             "level_4",
             "warning level 4.  - phantom 4 and mavic pro: the distance between the obstacle detected by the sector and the  aircraft is between 4 - 6 meters.  - others: the distance between the obstacle detected by the sector and the aircraft is between 6 - 10 meters. spark does not support this warning level.",
             "level_5",
             "warning level 5.  - phantom 4 and mavic pro: the distance between the obstacle detected by the sector and the  aircraft is between 2 - 4 meters.  - others: the distance between the obstacle detected by the sector and the aircraft is between 3 - 6 meters. spark does not support this warning level.",
             "level_6",
             "warning level 6.  - phantom 4 and mavic pro: the distance between the obstacle detected by the sector and the  aircraft is less than 2 meters.  - others: the distance between the obstacle detected by the sector and the aircraft is less than 3 meters. spark does not support this warning level.",
             "unknown",
             "the distance warning is unknown. this warning is returned when an exception occurs.",
             "faceawarestate",
             "faceaware states. faceaware is a step of palmlaunch. tapping the battery battery power  button twice, faceaware will start to work automatically. if faceaware is activated successfully,  the aircraft will takeoff from the palm.",
             "idle",
             "the aircraft is not executing faceaware.",
             "activating",
             "the aircraft is in the process of detecting a human face in front of the camera.",
             "activated",
             "faceaware has been activated. the aircraft will beep twice and the motors will start spinning.",
             "failed_no_face_detected",
             "faceaware has failed to activate because no face was detected.",
             "unknown",
             "unknown.",
             "palmcontrolstate",
             "states of palmcontrol.",
             "initializing",
             "the aircraft is initializing for palmcontrol.",
             "recognizing_palm",
             "the aircraft is recognizing the palm.",
             "starting_follow",
             "the aircraft is moving into position for the palmcontrol follow command. in this state, the  aircraft is ascending and flying backward to a position that is 3m horizontally away from  the user and 2.3m above the ground. once it has reached this position, the state will move  to `following` and the aircraft will then follow the user. the  follow command can be initiated by raising one arm and quickly waving your hand at the camera.",
             "following",
             "the aircraft is currently following the user. to reach this state, the user first raises  one arm and quickly waves their hand at the aircraft's camera. the aircraft will then move  into position (3m from the user and 2.3m above the ground), and reach this state.",
             "adjusting_position",
             "the aircraft's position is being adjusted by the moving palm.",
             "palm_control_stopped",
             "palmcontrol is stopped. palmcontrol can be stopped by moving the sticks on the physical remote  controller or sending commands through `mobileremotecontroller` when the physical remote  controller is absent.",
             "unknown",
             "unknown.",
             "getindex",
             "the imu's id. starts at 0.  @return an int value.",
             "getgyroscopestate",
             "returns the gyroscopic sensor's state value.  @return an enum value of `sensorstate`",
             "getaccelerometerstate",
             "returns the accelerometers sensor state value.  @return an enum value of `sensorstate`",
             "getcalibrationprogress",
             "returns the imu's calibration progress, its range being [1, 100]. if the imu is not calibrating, the value of the calibration progress will be -1.  @return an int value.",
             "getcalibrationstate",
             "returns the status of the imu's calibration.  @return an enum value of `calibrationstate`",
             "getmultipleorientationcalibrationhint",
             "for products that require the user to orient the aircraft during the imu calibration, this method can be used to  inform the user when each orientation is done. it is supported by flight controller firmware 3.2.0.0 or above.  @return an instance of `multipleorientationcalibrationhint`",
             "callback",
             "callback interface that is used to receive imu state from flight controller.",
             "sensorstate",
             "enum for imu calibration status.",
             "calibrationstate",
             "enum for imu calibration status.",
             "calibrationorientation",
             "the different orientations the aircraft needs for a multi-orientation imu calibration.",
             "orientationcalibrationstate",
             "imu calibration status for the current aircraft orientation.",
             "multipleorientationcalibrationhint",
             "this class is used to lead the user through an imu calibration for products that require calibration at multiple  orientations. an example workflow is:   <ol> - direct the user to orient the aircraft in one of the uncalibrated orientations in `getorientationstocalibrate`.  - monitor `getstate`  until `calibrating` turns  to `completed`.  - repeat until `getorientationstocalibrate` is empty.  </ol>",
             "nose_down",
             "the front/nose of the aircraft should be pointed down.",
             "tail_down",
             "the back/tail of the aircraft should be pointed down.",
             "right_down",
             "the right/starboard side of the aircraft should be pointed down.",
             "left_down",
             "the left/port side of the aircraft should be pointed down.",
             "bottom_down",
             "the bottom/underbelly of the aircraft should be pointed down.",
             "top_down",
             "the top of the aircraft should be pointed down.",
             "calibrating",
             "calibration of current aircraft orientation is in progress.",
             "completed",
             "calibration of current aircraft orientation is done. the orientation will be added  to `getorientationscalibrated`. the aircraft should be  rotated to a remaining orientation  in `getorientationstocalibrate`.",
             "unknown",
             "unknown. used by products that do not require imu multi-orientation calibration.",
             "getstate",
             "gets the calibration status of the current orientation.  @return an enum value of `orientationcalibrationstate`",
             "getorientationstocalibrate",
             "gets an array with the aircraft orientations that have not been calibrated yet. each element  is a  `calibrationorientation` enum value.  @return an instance of hashset `calibrationorientation`.",
             "getorientationscalibrated",
             "gets an array with the aircraft orientations that have been calibrated. each element is  a  `calibrationorientation` enum value.  @return an instance of hashset`calibrationorientation`.",
             "none",
             "imu not in calibration; no calibration is executing.",
             "calibrating",
             "imu calibration is in progress.",
             "successful",
             "imu calibration succeeded.",
             "failed",
             "imu calibration failed.",
             "unknown",
             "unknown calibration status.",
             "disconnected",
             "the imu sensor is disconnected from the flight controller.",
             "calibrating",
             "the imu sensor is calibrating",
             "calibration_failed",
             "calibrate of the imu sensor failed.",
             "data_exception",
             "the imu sensor has a data exception. calibrate the imu and restart the aircraft. if afterwards the status still  exists, you may need to contact dji for further assistance.",
             "warming_up",
             "the imu sensor is warming up.",
             "in_motion",
             "the imu sensor is not static; the aircraft may not be stable enough to calculate sensor data correctly.",
             "normal_bias",
             "the imu's bias value is normal; the aircraft can safely take off.",
             "medium_bias",
             "the imu's bias value is medium; the aircraft can safely take off.",
             "large_bias",
             "the imu's bias value is large; the aircraft cannot take off. imu calibration is needed.",
             "unknown",
             "the imu sensor's status is unknown.",
             "getstate",
             "the current state/position of the landing gear.  @return an enum value of `landinggearstate`",
             "landing_gear_status",
             "sdk key for getstate: the current state/position of the landing gear.  @return an enum value of `landinggearstate`",
             "getmode",
             "the current mode of the landing gear.  @return an enum value of `landinggearmode`",
             "landing_gear_mode",
             "sdk key for getmode: the current mode of the landing gear.  @return an enum value of `landinggearmode`",
             "setautomaticmovementenabled",
             "turns on/off self-adaptive landing gear. when turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. after take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. if self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled yes if automatic movement is enabled. @param callback asynchronous execution result.",
             "landing_gear_automatic_movement_enabled",
             "sdk key for setautomaticmovementenabled: turns on/off self-adaptive landing gear. when turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. after take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. if self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled yes if automatic movement is enabled. @param callback asynchronous execution result.",
             "getautomaticmovementenabled",
             "gets self-adaptive landing gear state (on/off). when turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. after take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. if self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback completion callback that receives the execution result.",
             "landing_gear_automatic_movement_enabled",
             "sdk key for getautomaticmovementenabled: gets self-adaptive landing gear state (on/off). when turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. after take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. if self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback completion callback that receives the execution result.",
             "entertransportmode",
             "enters transport mode, moving the landing gear to its optimal position for transportation. note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback the execution callback with the execution result returned.",
             "enter_transport_mode",
             "sdk key for entertransportmode: enters transport mode, moving the landing gear to its optimal position for transportation. note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback the execution callback with the execution result returned.",
             "exittransportmode",
             "exits transport mode. note that if the ground is not flat, exit transport mode will fail.  @param callback the execution callback with the execution result returned.",
             "exit_transport_mode",
             "sdk key for exittransportmode: exits transport mode. note that if the ground is not flat, exit transport mode will fail.  @param callback the execution callback with the execution result returned.",
             "retract",
             "retracts the landing gear. should only be used when `getmode`  is `manual`. for matrice 600 and matrice 600 pro, landing gear  cannot be controlled through the sdk, only automatically by the aircraft or manually by the remote controller.  @param callback the execution callback with the execution result returned.",
             "retract_landing_gear",
             "sdk key for retract: retracts the landing gear. should only be used when `getmode`  is `manual`. for matrice 600 and matrice 600 pro, landing gear  cannot be controlled through the sdk, only automatically by the aircraft or manually by the remote controller.  @param callback the execution callback with the execution result returned.",
             "deploy",
             "deploys landing gear. should only be used when `getmode`  is `manual`. for matrice 600 and matrice 600 pro, the landing gear cannot  be controlled through the sdk, only automatically by the aircraft or manually by the remote controller.  @param callback the execution callback with the execution result returned.",
             "deploy_landing_gear",
             "sdk key for deploy: deploys landing gear. should only be used when `getmode`  is `manual`. for matrice 600 and matrice 600 pro, the landing gear cannot  be controlled through the sdk, only automatically by the aircraft or manually by the remote controller.  @param callback the execution callback with the execution result returned.",
             "landinggearstate",
             "current state of landing gear.",
             "landing_gear_status",
             "sdk key for landinggearstate: current state of landing gear.",
             "unknown",
             "landing gear is in unknown state. this will be returned if the aircraft can't get the landing gear status.",
             "deployed",
             "landing gear is fully deployed (ready for landing)",
             "retracted",
             "landing gear is fully retracted (ready for flying).",
             "deploying",
             "landing gear is deploying (getting ready for landing).",
             "retracting",
             "landing gear is retracting (getting ready for flying).",
             "stopped",
             "landing gear is stopped.",
             "landinggearmode",
             "current mode of the landing gear.",
             "landing_gear_mode",
             "sdk key for landinggearmode: current mode of the landing gear.",
             "manual",
             "landing gear can be deployed and retracted through function calls.",
             "transport",
             "landing gear is in transport mode (either it is moving into, moving out of, or stopped in transport position).",
             "auto",
             "landing gear automatically transitions between deployed and retracted depending on altitude. during take-off,  the transition point is 1.2m above ground. after take-off (during flight or when landing), the transition point  is 0.5m above ground.",
             "unknown",
             "landing gear is in an unknown mode.",
             "setflyzonestatecallback",
             "sets up the `setflyzonestatecallback` for  obtaining `flyzonestate`.  @param callback flyforbidstatusupdatedcallback callback.",
             "setflysafenotificationcallback",
             "sets up the `setflyzonestatecallback` for  obtaining `flysafenotification`.  @param callback an object value of `flysafenotification`.",
             "setbasicdatabaseupgradeprogressupdatedcallback",
             "sets up the `setbasicdatabaseupgradeprogressupdatedcallback` for  obtaining the basic database upgrade progress.  @param callback `basicdatabaseupgradeprogressupdatedcallback` callback.",
             "getflyzonesinsurroundingarea",
             "gets all the fly zones within 20km of the aircraft. during simulation, this method is available only when the aircraft location is within 50km of (37.460484, -122.115312) or within 50km of (22.5726, 113.8124499). use of the geographic information provided by djiflyzonemanager is restricted. refer to the dji developer policy.  @param callback the execution callback with the returned value(s).",
             "getunlockedflyzonesforaircraft",
             "gets a list of authorization fly zones unlocked by  the account for the connected aircraft. it includes fly zones unlocked by  the flight planner (http://www.dji.com/flysafe/geo-system#planner), and the  ones unlocked during flight using dji go or any dji mobile sdk based application.  this list does not include fly zones unlocked by custom unlocking. for inspire 1  and phantom 3 series, the list is fetched from the server.  if the internet is not accessible, the cached local data will be used. for the other products, the list is  fetched from the aircraft.  @param callback the execution callback with the returned value(s).",
             "unlockflyzones",
             "unlocks the selected fly zones. this method can be used to unlock  authorization zones. after unlocking the zones, flight will be  unrestricted in those zones until the unlock expires.  the unlocking record will be linked to the user's account and will  be accessible to dji go and other dji mobile sdk based applications.  data protection notes - calling this method will send the following  protected data to dji server:  - user account information  - the  serial number of the connected aircraft.  @param ids the ids of `authorization` zones. @param callback the execution callback with the returned execution result.",
             "unlockauthorizationflyzone",
             "unlock the authorization fly zone. after unlocking the authorization fly zone, the aircraft will be able to take off normally in the authorization fly zone, and the authorization fly zone will continue to be banned after reboot the aircraft.  @param id the id of `authorization` zone. @param callback the execution callback with the returned execution result.",
             "reloadunlockedzonegroupsfromserver",
             "reloads the unlocked zone groups unlocked by the current user's account from the server.  for all products besides phantom 3 and inspire 1 series this includes both self unlocked  and custom unlocked zones. each unlocked zone group corresponds to one aircraft serial number.  after launch, sdk will call this method once. it will call this method again when either  the network connection or the current account state changes  (e.g. when a new user  successfully logs in). call this method any other time to trigger the reloading manually.  calling this method will not synchronize the loaded zone groups onto the aircraft.  to get a list of groups currently loaded from the server, call `getloadedunlockedzonegroups`. user will need to manually call `syncunlockedzonegrouptoaircraft`  to synchronize the unlocked group to the connected aircraft after the unlocked zone groups are reloaded. this feature is not supported by inspire 1 or phantom 3 series. for the other  products, it can be used when `iscustomunlockzonesupported`  returns `true`.  @param callback `completion callback` to receive the result.",
             "getloadedunlockedzonegroups",
             "gets the unlocked zone groups loaded from the server. each zone group corresponds to one aircraft.  the loaded zone groups will not be synchronized to the aircraft automatically. user need to manually  invoke `syncunlockedzonegrouptoaircraft` to synchronize the unlocked zone group  to the connected aircraft. invoke `reloadunlockedzonegroupsfromserver` to trigger  the reloading of unlocked zone groups manually. this feature is not supported by inspire 1 or phantom 3  series. for the other products, it can be used when `iscustomunlockzonesupported`  returns `true`.  @param callback the execution callback with the returned result.",
             "syncunlockedzonegrouptoaircraft",
             "synchronizes the unlocked zone group to the connected aircraft. sdk will select the unlocked zone group that  matches the serial number of the connected aircraft. after the unlocked zone group is synchronized to the  aircraft successfully, the latest unlocked fly zones and the custom unlock zones on the aircraft can be  checked by the follow methods:  - unlocked fly zones: `getunlockedflyzonesforaircraft` - custom unlock zones: `getcustomunlockzonesfromaircraft` this feature is not supported  by inspire 1 or phantom 3 series. for the other products, it can be used when  `iscustomunlockzonesupported` returns `true`.  @param callback the `completion callback` with the returned result.",
             "getcustomunlockzonesfromaircraft",
             "gets the custom unlock zones currently on the aircraft. this method can only be used  when `iscustomunlockzonesupported` is `true`.  @param callback completion callback that receives the execution result.",
             "enablecustomunlockzone",
             "enables an custom unlock zones that is on the aircraft. all custom unlock zones on the  aircraft can be retrieved with `getcustomunlockzonesfromaircraft`.  at any time,  only one custom unlock zone can be enabled. enabling an custom unlock zone will  disable the previously enabled zone. this method can only be used when  `iscustomunlockzonesupported` is `true`.  @param zone custom unlock zone to enabled. if `zone` is `nil`, only the  previously enabled zone will be disabled. @param callback `completion callback` to receive the result.",
             "getenabledcustomunlockzone",
             "gets the currently enabled custom unlock zone. this method can only be used when `iscustomunlockzonesupported` is `true`.  @param callback completion callback that receives the execution result.",
             "iscustomunlockzonesupported",
             "`true` if an aircraft is connected with flight controller firmware that supports custom unlock zones. aircraft that support custom unlock  zones are also able to disable unlocked fly zones temporarily.  @return a boolean value to check if custom unlock zone supported.",
             "deleteallunlockinglicenses",
             "deletes all unlocking licenses in the aircraft. supported only by mavic mini, dji mini 2, dji mini se and matrice 300 rtk.  @param callback the execution callback.",
             "getprecisedatabaseversion",
             "the version of the precise fly zone database in the firmware of the aircraft. it is `null` if `getprecisedatabasestate` is `initializing`.  the precise database is supported by phantom 4 series, inspire 2, m200 series, mavic and spark.  @param callback the execution callback.",
             "getprecisedatabasestate",
             "the fly zone database state in the firmware of the aircraft. the sdk will compare the version of the database on the aircraft against  the latest one online. when the aircraft database is out-of-date, the user should use dji go or assistant 2 to update the firmware. this  database is supported by phantom 4 series, inspire 2, m200 series, mavic and spark.  @param callback the execution callback.",
             "getbasicdatabasestate",
             "get the state of the basic fly zone database on the mobile device. the sdk will compare the version  of the local database against the latest one online. when the local database is out-of-date,  call `startbasicdatabaseupgrade` to start updating the database. if the update  is compulsory (for safety reasons), sdk will start the update automatically. the basic database is used  by dji aircraft that do not support the precise database (e.g. phantom 3 series, inspire 1 series).  @param callback the execution callback with the returned `flyzonedatabasestate` enum value(s).",
             "getbasicdatabaseversion",
             "the version of the basic fly zone database on the mobile device. it is `null` if the local file cannot  be parsed by sdk. the basic database is used by dji aircraft that do not support the precise database (e.g.  phantom 3 series, inspire 1 series).  @param callback the execution callback with the returned string value.",
             "startbasicdatabaseupgrade",
             "starts the upgrde of the basic database. internet access is required. when the upgrade is started successfully,  use `onupdate` to monitor the progress.  @param callback `completion callback` to receive the result.",
             "stopbasicdatabaseupgrade",
             "stops the in-progress upgrade of the basic database.  @param callback `completion callback` to receive the result.",
             "unlockedzonegroup",
             "an unlocked zone group contains the self-unlocked fly zones and custom unlock zones for an aircraft.",
             "getsn",
             "the serial number of the aircraft.  @return a string instance of the unlocked zone group serial number.",
             "getselfunlockedflyzones",
             "the self-unlocked authorization fly zones for the aircraft.  @return a list of `flyzoneinformation` objects.",
             "getcustomunlockzones",
             "the custom unlock zones for the aircraft.  @return a list of `customunlockzone` objects.",
             "flyzoneinformation",
             "this class contains information about a fly zone. `getflyzonetype`  should be used to understand the type of fly zone to know which information in this class is valid.",
             "flyzonedatabasestate",
             "the state of the fly zone database on the aircraft.",
             "flyzonestate",
             "this enum describes whether the aircraft is clear of, near, or actually in a fly zone.",
             "initializing",
             "sdk is fetching the information of the database.",
             "no_internet_connection",
             "sdk cannot access the internet, so it cannot compare the database version with the latest one on the internet.",
             "out_of_date",
             "aircraft's database version is older than the latest one.  user should use dji go or assistant 2 to upgrade the firmware in order  to keep the database up to date.",
             "up_to_date",
             "the database in the aircraft is up to date.",
             "unknown",
             "unknown state",
             "getflyzonetype",
             "returns the type fly zone.  @return the type of fly zone.",
             "getflyzoneid",
             "returns the fly zone's id. this is required if unlocking a fly zone.  @return an int value.",
             "getname",
             "returns the name of the fly zone.  @return a string instance of the name of the fly zone.",
             "getreason",
             "returns the reason of the fly zone `flyzonereason`.  @return an enum value of `flyzonereason`.",
             "getcoordinate",
             "the coordinate of the fly zone's center. only used for geo and nfz fly zones.  @return coordinate of fly zone center.",
             "getradius",
             "the radius of the fly zone in meters. if the fly zone is a truncated cone, then the radius is the bottom of the cone. only used for geo and nfz fly zones.  @return a double value of the radius of the fly zone in meters.",
             "getshape",
             "the shape of the fly zone. this shape is only used for geo (always cylinder) and nfz fly zones.  @return an enum value of `flyzoneshape`.",
             "getcategory",
             "the category of the fly zone.  @return an enum value of `flyzonecategory`.",
             "getsubflyzones",
             "information about the sub fly zones. if empty, then the fly zone is a circle fly zone. if  populated, this fly zone is a poly fly zone and the sub fly zone information will take  precedence over information in `flyzoneinformation`. `flyzoneinformation` should only be used for fly zone identifying information.  @return an array of `subflyzoneinformation` objects.",
             "setunlockingenabled",
             "disables the unlocked fly zones. this is useful if the aircraft is shared between users. it is not  supported by inspire 1 series or phantom 3 series. for the other products, it is supported  when `iscustomunlockzonesupported` is `true`.  @param enabled `true` to enable the unlocked fly zone. @param callback `completion callback` to receive the result.",
             "getunlockingenabled",
             "`true` if the unlocked fly zone is enabled. it is not supported by inspire 1 series or phantom 3  series. for the other products, it is supported when `iscustomunlockzonesupported` is `true`.  @param callback completion callback that receives the execution result.",
             "getstarttime",
             "the timestamp of when the flight warning or flight restriction begins, formatted in utc (yyyy-mm-dd hh:mm:ss). this is used for temporary flight  restrictions.  @return an instance of string.",
             "getendtime",
             "the timestamp of when the flight warning or flight restriction ends, formatted in utc (yyyy-mm-dd hh:mm:ss).  @return a string instance of the timestamp when the flight warning or flight restriction ends.",
             "getunlockstarttime",
             "the timestamp when the fly zone is unlocked, formatted in utc (yyyy-mm-dd hh:mm:ss).  @return a string instance of the timestamp when the fly zone is unlocked.",
             "getunlockendtime",
             "the timestamp the unlocked zone expires, formatted in utc (yyyy-mm-dd hh:mm:ss).  @return a string instance of the timestamp when the unlocked zone expires.",
             "flyzonetype",
             "there are three types of fly zones, nfz, geo and poly.",
             "circle",
             "the circle fly zone is a cylinder or truncated cone volume (see `getshape`) with one of the four restriction levels (see `getcategory`). some  restrictions can  be unlocked while others cannot. some fly zones also have a 4km buffer around them where flight  height is restricted to 120m.",
             "poly",
             "the poly fly zone consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. a height limitation of 0m means flight is completely restricted. this is used by mavic, phantom 4 pro, inspire 2 and phantom 4.",
             "unknown",
             "the fly zone is of unknown type.",
             "flyzonecategory",
             "an enum class represents the category of fly zone.",
             "warning",
             "warning zones do not restrict flight and are informational to alert the user. in a warning zone, users should be  prompted with a warning message describing the zone.",
             "authorization",
             "authorization zones restrict flight by default, but can be unlocked by a geo authorized user.",
             "restricted",
             "restricted zones restrict flight by default and cannot be unlocked by a geo authorized user.  users should contact flysafe@dji.com if they have authorization to fly in a restricted zone.",
             "enhanced_warning",
             "enhanced warning zones do not restrict flight but are highly recommended to be informational  to alert the user. in an enhanced warning zone, users should be prompted with a warning message  describing the zone.",
             "unknown",
             "unknown.",
             "flyzonereason",
             "an enum class contains the reason for the fly zone.",
             "airport",
             "airport that cannot be unlocked using geo system.",
             "military",
             "military authorized zone. this cannot be unlocked using the geo system.",
             "special",
             "special zone. this cannot be unlocked using the geo system.",
             "commercial_airports",
             "commercial airport.",
             "private_commercial_airports",
             "private commercial airport.",
             "recreational_airports",
             "recreational airport.",
             "national_parks",
             "national park.",
             "noaa",
             "the national oceanic and atmospheric administration.",
             "parcel",
             "parcel.",
             "power_plant",
             "power plant.",
             "prison",
             "prison.",
             "school",
             "school.",
             "stadium",
             "stadium.",
             "prohibited_special_use",
             "prohibited special use.",
             "restricted_special_use",
             "restriction special use.",
             "temporary_flight_restrictions",
             "temporary flight restriction.",
             "class_b_air_space",
             "class b controlled airspace. see http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (class b, c, d, e) in the united states.",
             "class_c_air_space",
             "class c controlled airspace. see http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (class b, c, d, e) in the united states.",
             "class_d_air_space",
             "class d controlled airspace. see http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (class b, c, d, e) in the united states.",
             "class_e_air_space",
             "class e controlled airspace. see http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (class b, c, d, e) in the united states.",
             "unpaved_airport",
             "airport with unpaved runway.",
             "heliport",
             "heliport.",
             "unknown",
             "unknown.",
             "flyzoneshape",
             "an enum class containing the shape of the fly zone.",
             "cylinder",
             "cylinder.",
             "cone",
             "truncated cone that has a smaller radius on the ground and larger radius in the air.",
             "unknown",
             "unknown.",
             "clear",
             "the aircraft is not within 200 meters of any warning, enhanced warning, authorization or restricted zone.",
             "near_restricted_zone",
             "the aircraft is within 200 meters of an authorization or restricted zone.",
             "in_warning_zone_with_height_limitation",
             "the aircraft is currently in a warning or enhanced warning zone and this place will  limit max flight height to 120m.",
             "in_warning_zone",
             "the aircraft is currently in a warning or enhanced warning zone.",
             "in_restricted_zone",
             "the aircraft is currently in an authorization or restricted zone.",
             "unknown",
             "unknown.",
             "subflyzoneinformation",
             "this class contains information about a sub fly zone.",
             "getareaid",
             "the fly zone's identifier.  @return an int value of the sub area's id.",
             "getshape",
             "the shape of the sub-fly-zone.  @return an enum value of `subflyzoneshape`.",
             "getcenter",
             "the location of the fly zone's center. only used when `getshape` is `cylinder`.  @return a locationcoordinate2d object.",
             "getradius",
             "the radius of the fly zone in meters. only used when `getshape` is `cylinder`.  @return a double value of fly zone radius.",
             "getvertices",
             "the vertices (locations) that make up the sub fly zone polygon shape. only used when `getshape` is `polygon`.  @return a list of cllocationcoordinate2d object.",
             "getmaxflightheight",
             "maximum flight height in meters allowed in the sub fly zone. a height of 0m will restrict flight completely within the zone.  @return an int value of maximum flight height.",
             "subflyzoneshape",
             "this type of the geospatial information for the fly zone.",
             "cylinder",
             "circle shape.",
             "polygon",
             "polygon shape.",
             "unknown",
             "unknown.",
             "callback",
             "an interface for obtaining `flyforbidstatus`.",
             "basicdatabaseupgradeprogressupdatedcallback",
             "an interface for obtaining basic database upgrade progress.",
             "onupdate",
             "called when the latest fly zone status is received.  @param state an enum value of `flyzonestate`.",
             "onupdate",
             "called when the basic database upgrade progress changes or an error occurs.  @param progress the upgrade progress of the basic database.",
             "customunlockzone",
             "users can unlock areas of a restricted fly zone through <http://www.dji.com/flysafe/custom-unlock>.  a user needs to show special authorization (usually from a third party such as a regulatory  or managing agency) as part of the process to unlock the area within the restricted fly zone.  therefore each request is unique and customized to the individual. if the request is successful,  the unlocked area is tied to the user's account as an custom unlock zone. this class contains the properties of an custom unlock zone.",
             "getid",
             "the unique id of the custom unlock zone.  @return an int value of the id.",
             "getunlockzonetype",
             "the type of custom unlocking.  @return an enum value of `unlockzonetype`.",
             "getname",
             "name of the custom unlock zone.  @return a string value of the name.",
             "getcenter",
             "the coordinate of the custom unlock zone's center. only used when `getunlockzonetype`  is `circle_unlock_area`.  @return a `locationcoordinate2d` object.",
             "getradius",
             "the radius of the custom unlock zone in meters. valid when `getunlockzonetype` is `circle_unlock_area`.  @return a float value of the radius.",
             "getcountry",
             "check country code (https://www.iso.org/iso-3166-country-codes.html) for the custom unlock zone's shape.  valid when `getunlockzonetype` is `country_unlock`.  @return the string of country code.",
             "getheight",
             "the unlocked max flight altitude limit in the custom unlock zone. valid when `getunlockzonetype`  is `height_unlock`.  @return an int value of max flight altitude.",
             "getpoints",
             "the vertices (locations) that make up the custom unlock zone shape. only used when `getunlockzonetype` is `pentagon_unlock`.  @return a list of `locationcoordinate2d` objects.",
             "getstarttime",
             "the timestamp of when the unlocking begins, formatted in utc (yyyy-mm-dd hh:mm:ss).  @return a string value of start time.",
             "getendtime",
             "the timestamp of when the unlocking ends, formatted in utc (yyyy-mm-dd hh:mm:ss).  @return a string value of the end time.",
             "isexpired",
             "`true` if the custom unlock zone has expired. after a zone is expired,  the location will be locked.  @return a boolean value to check if is expired.",
             "unlockzonetype",
             "an enum class represents the type of custom unlocking.",
             "circle_unlock_area",
             "the custom unlock zone is a circle.",
             "country_unlock",
             "the custom unlock zone is a country.",
             "height_unlock",
             "unlock the max flight altitude limit in the custom unlock zone.",
             "pentagon_unlock",
             "the custom unlock zone is a polygon.",
             "unknown",
             "the custom unlock type is unknown.",
             "flysafewarninginformation",
             "this class contains dji flying safety warning information related to fly zones. the `event` indicates the reason. use `description` method to get detail information.",
             "getevent",
             "returns the event of dji flying safety warning.  @return an enum value of `flysafewarningevent`.",
             "getheightlimit",
             "returns the height limit of current fly zone.  @return an int value of the height limit.",
             "getflyzoneinformation",
             "returns information about the fly zones.  @return a list of `flyzoneinformation` objects.",
             "getdescription",
             "returns the description of fly zone warning information.  @return a string value.",
             "flysafewarningevent",
             "dji fly safe warning events of fly zones.",
             "take_off_failed_in_no_fly_zone",
             "the aircraft was unable to take off in the no-fly zone.",
             "take_off_failed_in_no_fly_zone_without_gps",
             "the mobile device is in the no-fly zone, and the gps signal of the aircraft is not good enough to take off.",
             "take_off_failed_without_custom_unlocking",
             "cannot take off. you have not applied to fly in this zone.",
             "take_off_failed_in_authorized_area_without_gps_and_unlocking",
             "the mobile device is in the authorized area, and the gps signal of the aircraft is not good, and it cannot take off before unlocking.",
             "take_off_failed_in_authorized_zone_without_unlocking",
             "the aircraft is not allowed to take off before being unlocked in the authorized area.",
             "take_off_failed_in_authorized_zone",
             "the aircraft is in the authorized area and you have obtained a flight certificate.",
             "take_off_in_enhanced_warning_zone",
             "the aircraft is in the enhanced warning zone, please pay attention to flight safety.",
             "take_off_near_no_fly_zone",
             "there is a no-fly zone nearby and there are flight restrictions.",
             "limited_restrictions_nearby",
             "there are limited restrictions in the nearby area.",
             "authorized_zone_and_restrictions_nearby",
             "there are authorized areas nearby and you have obtained a flight certificate.",
             "restrictions_in_limited_fly_zone_nearby",
             "there are flight restrictions in the nearby limited flight area.",
             "in_authorization_zone",
             "the aircraft is in the authorized area and you have obtained a flight certificate.",
             "take_off_failed_under_limit_area_with_gps_once",
             "the mobile device is in the no-fly zone, and the gps signal of the aircraft is not good enough to take off.",
             "unknown",
             "unknown.",
             "flysafeseriouswarninginformation",
             "this class contains dji flying safety serious warning information related to fly zones. the aircraft will  land when there is a serious warning. the `event` indicates the reason. use `description` method to get  detail information.",
             "getevent",
             "returns the event of dji flying safety serious warning.  @return return an enum value of `flysafeseriouswarningevent`.",
             "getheightlimit",
             "returns the height limit of current fly zone.  @return return an int value of the height limit.",
             "getcountdown",
             "returns the countdown to start automatically landing.  @return return an int value of count down.",
             "getflyzoneinformation",
             "returns information about the fly zones.  @return return the list of `flyzoneinformation` objects.",
             "getdescription",
             "returns the description of fly zone warning information.  @return return the string of the description.",
             "flysafeseriouswarningevent",
             "fly zone serious warning events.",
             "in_no_fly_zone",
             "the aircraft is in the no-fly zone. after the countdown is over, it will force an automatic drop.  you will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
             "in_limit_height_area",
             "the aircraft is in the height limit zone. after the countdown is over, it will automatically drop to the limit height,  you will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
             "in_authorization_zone_without_unlocking",
             "the aircraft is in the authorized zone. after the countdown is over, it will automatically drop and you will not be able to  control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
             "in_unlocked_authorization_zone",
             "the aircraft is in the authorized area and you have obtained a flight certificate. after the countdown is over, it will  automatically drop and you will not be able to control the throttle, please confirm the fly limit zone and than open it.",
             "unknown",
             "unknown.",
             "flysafetipinformation",
             "this class contains dji flying safety tip related to fly zones. the `event` indicates the reason. use `description`  method to get detail information.",
             "getevent",
             "returns the event of dji flying safety tip.  @return the enum value of `flysafetipevent`.",
             "getheightlimit",
             "returns the height limit of current fly zone.  @return an int value of the height limit.",
             "getflyzoneinformation",
             "returns information about the fly zones.  @return return the list of `flyzoneinformation` objects.",
             "getdescription",
             "returns the description of fly zone tip information.  @return the string of the description.",
             "flysafetipevent",
             "dji flying safety tip.",
             "take_off_in_height_limit_zone_without_gps",
             "the aircraft is below the height limit zone and has no gps signal, please pay attention to flight safety.",
             "take_off_in_height_limit_zone",
             "the aircraft is below the height limit zone, please pay attention to flight safety.",
             "take_off_in_warning_area",
             "the aircraft is in the warning zone, please pay attention to flight safety.",
             "touch_no_fly_zone",
             "the aircraft has touched the no-fly zone, please control the aircraft as far as possible.",
             "touch_authorization_zone",
             "the aircraft has touched the authorized area, please control the aircraft as far as possible.",
             "reach_maximum_flight_height",
             "the aircraft has reached the maximum flight height in the height limit zone.",
             "rth_affected_at_boundary_of_geo_zone",
             "your aircraft is at the boundary of a geo zone, return to home may be affected. please fly away with caution.",
             "at_boundary_of_custom_unlock_zone",
             "your aircraft is at the boundary of an custom unlocking zone.",
             "unknown",
             "unknown.",
             "flysafereturntohomeinformation",
             "this class contains dji flying safety notification related to returning to home. the `event` indicates the reason. use `description` method to get detail information.",
             "getevent",
             "returns the event of dji flying safety notification related to returning to home.  @return get the enum value of `flysafereturntohomeevent`.",
             "getdescription",
             "returns the description of fly zone return to home information.  @return get the string value of the description.",
             "flysafereturntohomeevent",
             "fly zone returntohome events. dji fly safe notification when the aircraft returns to home.",
             "near_no_fly_zone",
             "approaching a no-fly zone. return to home may be affected. fly with caution.",
             "cross_no_fly_zone",
             "current return to home route will pass a no-fly zone. pay attention to the aircraft's position  to avoid return to home failure.",
             "unknown",
             "unknown.",
             "flysafenotification",
             "this class contains dji flying safety notification. the `type` indicates the type of notification.  check corresponding object for detail information.",
             "gettype",
             "returns the type of notification.  @return the enum value of `flysafenotificationtype`.",
             "getnoticeinformation",
             "returns the notice information.  @return the object of `flysafetipinformation`.",
             "getwarninginformation",
             "returns the warning information.  @return the object of `flysafewarninginformation`.",
             "getseriouswarninginformation",
             "returns the serious warning information.  @return the object of `flysafeseriouswarninginformation`.",
             "getreturntohomeinformation",
             "returns the return to home information.  @return the object of `flysafereturntohomeinformation`.",
             "callback",
             "the fly safe notification callback interface.",
             "onupdate",
             "called when the latest fly safe notification is received.  @param notification an object value of `flysafenotification`.",
             "flysafenotificationtype",
             "dji fly safe notification types.",
             "return_to_home",
             "dji fly safe notification related to returning to home.",
             "flying_safety_tip",
             "dji fly safe tip.",
             "warning",
             "dji fly safe warning notification.",
             "serious_warning",
             "dji fly safe serious warning notification.",
             "unknown",
             "dji fly safe unknown notification type.",
             "flyzonereturntohomestate",
             "this enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
             "return_to_home_state",
             "sdk key for flyzonereturntohomestate: this enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
             "clear",
             "the aircraft's return to home route is clear of restricted areas.",
             "near_no_fly_zone",
             "the aircraft's return to home route is near an authorization or restricted zone.",
             "cross_no_fly_zone",
             "the aircraft's return to home route passes through an authorization or restricted zone.",
             "unknown",
             "unknown.",
             "hasreachedmaxflightheight",
             "`true` if the aircraft has reached the maximum flight height.  @return a boolean value.",
             "has_reached_max_flight_height",
             "sdk key for hasreachedmaxflightheight: `true` if the aircraft has reached the maximum flight height.  @return a boolean value.",
             "hasreachedmaxflightradius",
             "`true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
             "has_reached_max_flight_radius",
             "sdk key for hasreachedmaxflightradius: `true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
             "setmaxflightheight",
             "sets the maximum flight height limitation of the aircraft. the maxheight</code> value must be in the  range [20, 500] m.  @param maxheight maximum height of the aircraft. @param callback the execution callback with the execution result returned.",
             "max_flight_height",
             "sdk key for setmaxflightheight: sets the maximum flight height limitation of the aircraft. the maxheight</code> value must be in the  range [20, 500] m.  @param maxheight maximum height of the aircraft. @param callback the execution callback with the execution result returned.",
             "getmaxflightheight",
             "gets the maximum flight height limitation of the aircraft.  @param callback the execution callback with the returned value(s).",
             "max_flight_height",
             "sdk key for getmaxflightheight: gets the maximum flight height limitation of the aircraft.  @param callback the execution callback with the returned value(s).",
             "setmaxflightradius",
             "sets the maximum flight radius limitation of the aircraft. the radius is calculated from the home point.  the maxradius</code> value must be in the range [15, 8000] m.  @param maxradius maximum flight radius of the aircraft. @param callback the execution callback with the execution result returned.",
             "max_flight_radius",
             "sdk key for setmaxflightradius: sets the maximum flight radius limitation of the aircraft. the radius is calculated from the home point.  the maxradius</code> value must be in the range [15, 8000] m.  @param maxradius maximum flight radius of the aircraft. @param callback the execution callback with the execution result returned.",
             "getmaxflightradius",
             "gets the maximum flight radius limitation of the aircraft.  @param callback the execution callback with the returned value(s).",
             "max_flight_radius",
             "sdk key for getmaxflightradius: gets the maximum flight radius limitation of the aircraft.  @param callback the execution callback with the returned value(s).",
             "setmaxflightradiuslimitationenabled",
             "sets whether the maximum flight radius limitation is enabled. if enabled is `false`,  there is no maximum flight radius limitation.  @param enabled maximum flight radius limitation is enabled. @param callback the execution callback with the execution result returned.",
             "max_flight_radius_enabled",
             "sdk key for setmaxflightradiuslimitationenabled: sets whether the maximum flight radius limitation is enabled. if enabled is `false`,  there is no maximum flight radius limitation.  @param enabled maximum flight radius limitation is enabled. @param callback the execution callback with the execution result returned.",
             "getmaxflightradiuslimitationenabled",
             "gets the maximum flight radius limitation status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "max_flight_radius_enabled",
             "sdk key for getmaxflightradiuslimitationenabled: gets the maximum flight radius limitation status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "getcalibrationstate",
             "the status of the gravity's calibration.  @return an enum value of `gravitycentercalibrationstate`.",
             "getcalibrationerror",
             "gets calibration errors. returns `null` when gravity calibration is normal.  @return an instance of `djierror`.",
             "gravitycentercalibrationstate",
             "enum for gravity calibration state.",
             "none",
             "the aircraft is not calibrating the gravity center.",
             "calculating",
             "the aircraft is calibrating the gravity center.",
             "successful",
             "the aircraft calibrates the gravity center successfully.",
             "failed",
             "the aircraft calibrates the gravity center failed.",
             "unknown",
             "unknown calibration status.",
             "callback",
             "callback interface that updates the gravity calibration's current state data.",
             "onupdate",
             "callback function that updates the gravity calibration's current state data.  @param state current state of the gravity calibration.",
             "callback",
             "this protocol provides an interface to update the intelligent flight assistant vision control state.",
             "onupdate",
             "callback function that updates the aircraft state controlled by the intelligent flight assistant.  @param state the vision control state.",
             "onupdate",
             "callback function that updates the faceaware state. when starting a palmlaunch, the aircraft will  start faceaware. if faceaware activates successfully, the motors will start spinning and the  aircraft will hover after releasing it.  @param state the face sware state.",
             "onupdate",
             "callback function that updates the palm control state.  @param state the palm control state.",
             "onupdate",
             "callback function that updates the smartcapture state. it is only supported by mavic air.  @param state the smartcapture state.",
             "isbraking",
             "`true` if the aircraft is braking automatically to avoid collision.  @return a boolean value.",
             "is_braking",
             "sdk key for isbraking: `true` if the aircraft is braking automatically to avoid collision.  @return a boolean value.",
             "isavoidingactiveobstaclecollision",
             "`true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return a boolean value.",
             "is_avoiding_active_obstacle_collision",
             "sdk key for isavoidingactiveobstaclecollision: `true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return a boolean value.",
             "isascentlimitedbyobstacle",
             "yes if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return a boolean value.",
             "is_ascent_limited_by_obstacle",
             "sdk key for isascentlimitedbyobstacle: yes if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return a boolean value.",
             "isperformingprecisionlanding",
             "yes if the aircraft is landing precisely.  @return a boolean value.",
             "is_performing_precision_landing",
             "sdk key for isperformingprecisionlanding: yes if the aircraft is landing precisely.  @return a boolean value.",
             "landingprotectionstate",
             "gets the aircraft's landing protection state. this status is valid when landing protection is enabled.  @return an enum value of `visionlandingprotectionstate`,  which will show the state of landing protection.",
             "landing_protection_state",
             "sdk key for landingprotectionstate: gets the aircraft's landing protection state. this status is valid when landing protection is enabled.  @return an enum value of `visionlandingprotectionstate`,  which will show the state of landing protection.",
             "isadvancedpilotassistancesystemactive",
             "`true` if advanced pilot assistance system (apas) is active. when it is active, the aircraft will change  flight path automatically to avoid obstacles.  @return a boolean value.",
             "getsystemstatus",
             "the system status of smartcapture.  @return an enum value of `smartcapturesystemstatus`.",
             "getaction",
             "the executing smartcapture action.  @return an enum value of `smartcaptureaction`.",
             "getfollowingmode",
             "the following mode of smartcapture.  @return an enum value of `smartcapturefollowingmode`.",
             "getphotocountdown",
             "the countdown for shooting photo.  @return an int value of photo countdown.",
             "gettargetrect",
             "the dimension of the detected target. it is `cgrectnull` when the target is invalid.  @return the detected target's dimension.",
             "visionlandingprotectionstate",
             "landing protection status returned by the downward vision sensor.",
             "landing_protection_state",
             "sdk key for visionlandingprotectionstate: landing protection status returned by the downward vision sensor.",
             "none",
             "the aircraft is not executing auto-landing or the downward vision sensor has not started to analyze the ground yet.",
             "analyzing",
             "the downward vision sensor is analyzing the ground at the landing zone.",
             "analysis_failed",
             "the downward vision sensor's analysis failed. either the auto-landing can be attempted again, or the user needs  to land the aircraft manually.",
             "safe_to_land",
             "the ground is flat and the aircraft is safe to land automatically.",
             "not_safe_to_land",
             "landing area is not flat enough to be considered safe for landing. the aircraft should be moved to an area that  is more flat and an auto-land should be attempted again or the user should land the aircraft manually.",
             "unknown",
             "unknown.",
             "smartcapturesystemstatus",
             "the system status of smartcapture.",
             "initializing",
             "smartcapture is initializing.",
             "not_flying_and_face_aware_activating",
             "the aircraft is not flying and detecting a human face in front of the camera.",
             "not_flying_and_face_aware_activated",
             "the aircraft is not flying and faceaware has been activated. the aircraft will push the dimension of the target through `gettargetrect`  of `smartcapturestate`.",
             "gesture_launch",
             "gesturelaunch is recognized and the aircraft is taking off.",
             "flying_and_face_aware_activating",
             "the aircraft is flying and detecting human faces in front of the camera.",
             "flying_and_face_aware_activated",
             "the aircraft is flying and detected one or more than one human faces in front of the camera.  one of the detected human can raise a hand to confirm the control. then the smartcapture  state will change to `following`.",
             "following",
             "the aircraft is following the target but not smartcapture action is recognized.",
             "palm_control",
             "the aircraft is executing palmcontrol (controlling the position or the distance).  see `getaction` of `smartcapturestate` for more detail.",
             "camera_capture_action",
             "the aircraft is executing camera related action (e.g. shoot photos).  see `getaction` of `smartcapturestate` for more detail.",
             "gesture_land",
             "gestureland is recognized and the aircraft is landing.",
             "unknown",
             "unknown.",
             "smartcaptureaction",
             "different actions supported by smartcapture.",
             "none",
             "no action is being executed.",
             "adjusting_position",
             "the user is adjusting the aircraft's position. move the palm up  or down slowly to control the aircraft's altitude. move the arm  left or right to control the aircraft's orientation.",
             "adjusting_distance",
             "the user is adjusting distance between the aircraft and the user.  move two hands apart and the aircraft will fly away from the user.  the maximum distance is 19.7ft (6m). move two hands together and  the aircraft will fly towards the user. the minimum distance is 6.6ft (2m).",
             "switching_control",
             "the control of the aircraft is being switched from one person to the other.  the current user drops hand towards the floor. the front leds will turn solid green. the person who would like to control the aircraft raise palm in front of the aircraft.  when the front leds blinks green slowly, it indicates the control is switched successfully.",
             "shooting_photo",
             "the camera is shooting photos. make a v gesture with one hand to trigger the action. once the  gesture is recognized, two-second countdown will begin (`getphotocountdown`  of `smartcapturestate`).",
             "recording_video",
             "the camera is recording video. to start this, make a frame gesture with fingers from both hands.  once the gesture is recognized, the aircraft's front leds will turn off and the camera will start  recording. after five seconds, use the same gesture to stop the recording.",
             "unknown",
             "unknown.",
             "smartcapturefollowingmode",
             "different following modes of smartcapture.",
             "trace",
             "aircraft follows the target at constant distance.",
             "profile",
             "aircraft follows the target at constant angle and distance from the side.",
             "unknown",
             "unknown.",
             "filllightmode",
             "modes for the fill light at the bottom or top of the aircraft.",
             "auto",
             "the auto mode. in this mode, the auxiliary light will be turned on automatically when the downward or top vision system is active but the environment is too dark.",
             "on",
             "the auxiliary light is on.",
             "off",
             "the auxiliary light is off.",
             "beacon",
             "beacon mode. in this mode, the auxiliary light will have different behaviors in different conditions: - when the aircraft just takes off, the auxiliary  light will have the same behavior  as ''djifilllightmode_auto''. - when the aircraft ascends above 5.5 meters, the auxiliary light starts to blink in  1hz. - when the aircraft descends below 4.5 meters, the auxiliary light will have the same behavior as ''djifilllightmode_auto''. this mode is only  supported by mavic 2 enterprise.",
             "unknown",
             "unknown.",
             "setaccesslockerstatecallback",
             "set access locker state update callback.  @param callback the execution callback with the execution result returned.",
             "setformattingstatecallback",
             "set formatting state update callback.  @param callback the execution callback with the execution result returned.",
             "getstate",
             "gets the latest state of the access locker.  @return an enum value of `accesslockerstate`.",
             "getversion",
             "gets the version of the security feature.  @param callback the execution callback with the value returned.",
             "getuseraccount",
             "returns the username of the current access locker account.  @param callback the execution callback with the value returned.",
             "setupuseraccount",
             "sets up a user account to enable the access protection of  the aircraft. after setting up a user account, the security  code of the user is required in each power-cycle of the  aircraft or the aircraft is just paired with the remote controller. the security code is also required to access  data in the aircraft through dji assistant 2. this method  is only valid when the state is `not_initialized`. if  the method executes successfully, the state will change to `unlocked`.  @param useraccountinfo the user account information used for setting up the access protection of the aircraft. @param callback the execution callback with the returned execution result.",
             "login",
             "logs in to unlock the access protection of the aircraft.  this method is valid when the state is `locked`.  if the user is logged in successfully, the state will change to `unlocked`.  @param useraccountinfo the user account information used to unlock the protection. @param callback the execution callback with the returned execution result.",
             "modifyuseraccount",
             "modifies the user account. the old user account information will be overridden by the new one. this method is valid when the state is  either `unlocked`  or `locked`. if the user account is  modified, the aircraft will be unlocked and the state will change  to `unlocked`.  @param currentuseraccountinfo current user account info to be set to the access locker system. @param newuseraccountinfo new user account info to be set to the access locker system. @param callback the execution callback with the returned execution result.",
             "resetuseraccount",
             "resets the user account to disable the protection. the user account information (e.g.  user name, security code) will be deleted and the aircraft is accessible without  validating the user. this method is valid when the state is either `unlocked`  or `locked`. if the user account is reset, the state will change  to `not_initialized`.  @param useraccountinfo user account info to be set to the access locker system. @param callback the execution callback with the returned execution result.",
             "format",
             "formats the protected data in the aircraft, including data in the internal storage and the user account information.  this method is only valid when the user account is set up. use `formattingstate`  to check the progress of formatting.  when formatting is done, the state will change to `not_initialized`.  @param callback the execution callback with the returned execution result.",
             "formattingstate",
             "formatting state of the access locker.",
             "getprogressstate",
             "the progress state.  @return an enum value of the `formattingprogressstate`.",
             "getdjidatalockererror",
             "checks if the formatting operation is successfully completed. the  recent formatting operation failure if any. null if the recent formatting operation succeeded.  @return the possible error during the formatting process.",
             "callback",
             "callback to update the `formattingstate`.",
             "onupdate",
             "callback function that updates the formattingstate.  @param state an instance of formattingstate",
             "useraccountinfo",
             "the class represents the user account information of the access locker.",
             "useraccountinfo",
             "constructor method for the useraccountinfo.  @param username the user account name. @param securitycode the security code of the user account.",
             "getusername",
             "gets the user name.  @return a string value.",
             "getsecuritycode",
             "gets the security code of the account.  @return a string value.",
             "accesslockerstate",
             "the aircraft's access locker state.",
             "not_initialized",
             "the access locker is not initialized. set up user account to initialize the system.",
             "locked",
             "the aircraft is locked and protected. in this state, the internal  storage cannot be accessed, the aircraft will stop streaming the  live view and the aircraft cannot take off. use the security code  to unlock the aircraft.",
             "unlocked",
             "the aircraft is unlocked.",
             "unknown",
             "either the aircraft is disconnected or the connected product does not  support the access locker.",
             "callback",
             "an interface for obtaining `accesslockerstate`.",
             "onupdate",
             "callback function that updates the access locker state.  @param state the access locker state. use this state to check if security code is required to  unlock the aircraft.",
             "formattingprogressstate",
             "the aircraft's access locker formatting progress state.",
             "none",
             "no formatting operation is executing or executed in this aircraft's power cycle.",
             "formatting",
             "the aircraft's data is being formatted.",
             "successful",
             "the aircraft has formatted data in the internal storage and the user account set up for the security feature.",
             "failure",
             "the formatting operation is failed. check `formattingstate` for detail.",
             "setradarperceptioninformationcallback",
             "updates the radar perception information. only supported by matrice 300 rtk.  @param callback the execution callback with the returned execution result.",
             "setupwardradarobstacleavoidanceenabled",
             "sets upward radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enable the upward radar obstacle avoidance. @param callback the execution callback with the returned value(s).",
             "getupwardradarobstacleavoidanceenabled",
             "gets upward radar obstacle avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "sethorizontalradarobstacleavoidanceenabled",
             "sets horizontal radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enabled the horizontal radar obstacle avoidance. @param callback the execution callback with the returned value(s).",
             "gethorizontalradarobstacleavoidanceenabled",
             "gets upward horizontal obstacle avoidance status (enabled/disabled).  @param callback the execution callback with the returned value(s).",
             "djipointcloudstatuslistener",
             "defines the listeners of the point cloud status.",
             "onpointcloudrecordstatuschange",
             "when the point cloud record status is changed, the listener will receive this callback.  @param newstatus the new status",
             "onpointcloudrecordstatusrecordingtimechange",
             "when the point cloud recording time is updated, the listener will receive this callback.  @param newrecordingtime the latest recording time",
             "onimupreheatstatuschange",
             "when the imu preheat status is changed, the listener will receive this callback.  @param status the imu preheat status.",
             "djipointcloudlivedatalistener",
             "defines the listeners of the point cloud data.",
             "onreceiveliveviewdata",
             "update point cloud live view data.  @param data the point could live view data @param length the length of the received live view data.",
             "onerror",
             "listener the error status.  @param error the received dji error code.",
             "addpointcloudstatuslistener",
             "adds the listener for the point cloud status change events.  @param listener point cloud status change listener.",
             "removepointcloudstatuslistener",
             "remove the listener for the point cloud status change events.  @param listener point cloud status change listener.",
             "removeallpointcloudstatuslistener",
             "remove all point cloud status listeners.",
             "addpointcloudliveviewdatalistener",
             "adds the listener to receive point cloud data.  @param listener point cloud data listener.",
             "removepointcloudliveviewdatalistener",
             "remove the listener to receive point cloud data.  @param listener point cloud data update listener.",
             "getdisplayname",
             "return string that represents name of the lidar.  @return an instance of display name string.",
             "pointcloudrecord",
             "point cloud record related operations.  @param commandaction an enum value of the `djilidarpointcloudrecord` @param callback the execution callback with the returned value(s).",
             "startreadpointcloudliveviewdata",
             "start to receive the point cloud live view data. using `onreceiveliveviewdata` to receive the data.  @param callback the execution callback with the returned value(s).",
             "stopreadpointcloudliveviewdata",
             "stop to receive the point cloud live view data.  @param callback the execution callback with the returned value(s).",
             "idjilidarliveviewdataprocessor",
             "this processor is provided by dji. we receive the `pointcloudliveviewdata` through `startreadpointcloudliveviewdata` interface, and then use `idjilidarliveviewdataprocessor` to optimize the algorithm so that the point cloud data can be displayed efficiently through djilidarpointcloudview</code>. if you want to display with your own algorithm. you can use `pointcloudliveviewdata` to draw the point cloud live view data by yourself.",
             "bindview",
             "bind the view which is provided by dji.  @param view the view to draw the point cloud live view data. provided by dji.",
             "addpointcloudliveviewdata",
             "add point cloud live view data to the processor.  @param data the point cloud live view data received form `onreceiveliveviewdata`.",
             "setpointcloudliveviewdisplaymode",
             "sets the point cloud live view display mode. we support two display modes:`fpv` and `overall`.  @param mode point cloud live view display mode",
             "setpointcloudliveviewcolormode",
             "sets the point cloud live view color mode.  @param colormode point cloud live view color mode",
             "freshpointcloudliveviewdataprocessedbuffers",
             "refresh the point cloud live view data. only needed in `overall` mode. due to the large amount of data in this mode, we will process the live view data every 10 seconds. if you want to display the point cloud live view data in more real time, you can call this interface to update the buffer in real time.",
             "clearpointcloudliveviewdataprocessedbuffers",
             "clear the point cloud live view data.",
             "destroy",
             "destory the processor. called when exiting the view.",
             "setpointcloudscanmode",
             "set point cloud scan mode.  @param scanmode an enum value of the `djilidarpointcloudscanmode` @param callback the execution callback with the returned value(s).",
             "getpointcloudscanmode",
             "get point cloud scan mode.  @param callback the execution callback with the returned value(s).",
             "setpointcloudreturnmode",
             "set point cloud return mode.  @param scanmode an enum value of the `djilidarpointcloudreturnmode` @param callback the execution callback with the returned value(s).",
             "getpointcloudreturnmode",
             "get point cloud scan mode.  @param callback the execution callback with the returned value(s).",
             "setpointcloudhighsensitivitymode",
             "enables/disables high sensitivity mode. in severe weather conditions such as rain and fog, high sensitivity mode reduces the probability of false detection of atmospheric particles.  @param enabled `yes` to enable the high sensitivity mode. @param callback the execution callback with the returned value(s).",
             "getpointcloudhighsensitivitymode",
             "`yes` if high sensitivity mode is enabled.  @param callback the execution callback with the returned value(s).",
             "getcapabilities",
             "lidar capabilities. you can you this interface to get the sampling rate range.  @return an object of `capabilities`.",
             "setpointcloudsamplingrate",
             "set point cloud sampling rate. the sampling rate represents the number of effective acquisitions of the lidar per second, which can be intuitively understood as the number of point clouds generated in one second. the sampling rate range depend on the `djilidarpointcloudreturnmode`. you can use `onlidarsamplingraterangechange`  to get the current support range when you change the point cloud return mode.  @param lidardatasamplerate an enum value of the `djilidarpointcloudsamplingrate` @param callback the execution callback with the returned value(s).",
             "getpointcloudsamplingrate",
             "get point cloud sampling rate.  @param callback the execution callback with the returned value(s).",
             "setpointcloudvisiblelightpixel",
             "set superimposed visible light pixels for coloring the model  @param visiblelightpixelparam an enum value of the `djilidar_pointcloudvisiblelightpixelmode`` @param callback the execution callback with the returned value(s).",
             "getpointcloudvisiblelightpixelwithcompletion",
             "get point cloud visible light pixel.  @param callback the execution callback with the returned value(s).",
             "capabilities",
             "some of the lidar's parameters have dynamic ranges. the `capabilities` class allows you to query the valid range for a parameter. type-casting is required to get the corresponding enumerator value for each range element.",
             "datasamplerates",
             "returns the current valid range of sampling rate. returns `null` if current lidar has no supported lidar data sample rate or the lidar is disconnected.  @return array of `djilidarpointcloudsamplingrate` elements. each element represents one current supported lidar data sample rate.",
             "djilidarparameterslistener",
             "defines the listeners of the lidar parameters change.",
             "onlidarsamplingraterangechange",
             "when the lidar sampling rate range is changed, the listener will receive this callback.  @param newrange the new range",
             "adddjilidarparameterslistener",
             "adds the listener for lidar parameters change events.  @param listener point cloud status change listener.",
             "removedjilidarparameterslistener",
             "remove the listener for lidar parameters change events.  @param listener point cloud status change listener.",
             "removealllistener",
             "remove all lidar parameters listeners.",
             "djilidarimupreheatstatus",
             "point cloud imu preheat status define for lidar. when the preheating is complete, the status will change to complete.",
             "preheating",
             "imu is preheating.",
             "preheat_completed",
             "imu preheat is complete.",
             "recordingstatus",
             "point cloud record status define for point cloud.",
             "starting",
             "point cloud record is starting.",
             "started",
             "point cloud is recording.",
             "pause",
             "point cloud record is paused.",
             "resume",
             "point cloud record is resumed.",
             "stopped",
             "point cloud record is stoped.",
             "djilidarpointcloudrecord",
             "point cloud record opration type define for point cloud. when you start point cloud recording on successfully, `recordingstatus` will change to `started`. you can use `onreceiveliveviewdata` to receive piont cloud live view data.",
             "start_point_cloud_recording",
             "start point cloud recording.",
             "stop_point_cloud_recording",
             "stop point cloud recording.",
             "pause_point_cloud_recording",
             "pause point cloud recording.",
             "resume_point_cloud_recording",
             "resume point cloud recording.",
             "djilidarpointcloudscanmode",
             "enums represent the point cloud scan mode of lidar. supports two scanning modes: traditional non-repetitive scan mode and repetitive line scan mode. users can choose the appropriate scanning point cloud pattern according to their needs. the repetitive scan mode is a flat fov(70.4 degree * 4.5 degree), and its scanning method is more similar to the traditional scanning lidar, which can obtain a more uniform and higher-precision scanning effect; the non-repetitive scan mode is a unique scanning method of livox, providing a complete near- circular fov(70.4 degree *77.2 degree), which has better scanning static scanning effect and facade effect, and higher efficiency;",
             "repetitive",
             "repetitive scan mode.",
             "non_repetitive",
             "non-repetitive scan mode.",
             "djilidarpointcloudreturnmode",
             "enums represent the point cloud return mode of lidar.",
             "single_return_first",
             "single return first (default).",
             "single_return_strongest",
             "single return strongest.",
             "dual_return",
             "double return.",
             "triple_return",
             "triple return.",
             "djilidarpointcloudsamplingrate",
             "enums represent the point cloud sampling rate of lidar.",
             "rate_240k_hz",
             "sampling rate: 240khz",
             "rate_180k_hz",
             "sampling rate: 180khz",
             "rate_160k_hz",
             "sampling rate: 160khz",
             "rate_120k_hz",
             "sampling rate: 120khz",
             "rate_80k_hz",
             "sampling rate: 80khz",
             "rate_60k_hz",
             "sampling rate: 60khz",
             "djilidarpointcloudvisiblelightpixelmode",
             "enums represent the point visible light pixel mode of lidar.",
             "visible_light_pixel_off",
             "turn off superimposed visible light pixels.",
             "visible_light_pixel_on_timed_shot_on",
             "turn on superimposed visible light pixels. in this mode camera will take a photo every 3 seconds. it is recommended to use when flying aircraft manually.",
             "visible_light_pixel_on_timed_shot_off",
             "turn on superimposed visible light pixels. in this mode camera will not take photo automatically. it is recommended to use in waypoint mission and set the photo interval to 3 seconds.",
             "pointcloudliveviewdata",
             "this class represent the piont cloud live view data.",
             "getx",
             "the x coordinate of the object position measured by the lidar, using the ned(north east down) coordinate system. the position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
             "gety",
             "the xycoordinate of the object position measured by the lidar, using the ned(north east down) coordinate system.  the position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
             "getz",
             "the z coordinate of the object position measured by the lidar, using the ned(north east down) coordinate system.  the position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
             "getintensity",
             "intensity is a measurement index (collected for each point) that reflects the intensity of the lidar pulse echo generated at a certain point. this value is based in part on the reflectivity of the object swept by the lidar pulse.",
             "getred",
             "rgb data of the object measured by the lidar. if you set visible light pixel mode to `visible_light_pixel_off`, the data will be (0, 0, 0).",
             "getgreen",
             "rgb data of the object measured by the lidar. if you set visible light pixel mode to `visible_light_pixel_off`, the data will be (0, 0, 0).",
             "getblue",
             "rgb data of the object measured by the lidar. if you set visible light pixel mode to `visible_light_pixel_off`, the data will be (0, 0, 0).",
             "pointclouddisplaymode",
             "enums represent the point cloud live view display mode of lidar.",
             "fpv",
             "display the point cloud live view data by fpv mode. only the point cloud live view data in the current fpv screen will be displayed.",
             "overall",
             "display the point cloud live view data by overall mode. all point cloud live view data added to `idjilidarliveviewdataprocessor` through `addpointcloudliveviewdata` will be displayed.",
             "responseforgimbalcontrol",
             "constructor of the class.  @param requesterid slave remote controller's identifier. @param isagree true</code> if the master remote controller agrees to give the slave remote controller the right to control the gimbal.",
             "getrequesterid",
             "get the slave remote controller's identifier.  @return the int value of the slave remote controller id.",
             "isagree",
             "true</code> if the master remote controller agrees to give the slave remote controller the right to control the gimbal.  @return agree or disagree to control the gimbal.",
             "getleftstick",
             "get left stick.  @return an instance of `stick`.",
             "left_stick_value",
             "sdk key for getleftstick: get left stick.  @return an instance of `stick`.",
             "getrightstick",
             "get right stick.  @return an instance of `stick`.",
             "right_stick_value",
             "sdk key for getrightstick: get right stick.  @return an instance of `stick`.",
             "getleftdial",
             "gimbal dial's (upper left dial) value in the range of [-660,660], where 0 is untouched and positive is turned in the clockwise direction.  @return gimbal dial value.",
             "getrightdial",
             "current state of the camera settings dial (upper right dial) on the remote controller.  @return an instance of `rightdial`.",
             "gettransformationswitch",
             "current state of the transformation switch on the remote controller.  @return an instance of `transformationswitch`.",
             "transformation_switch",
             "sdk key for gettransformationswitch: current state of the transformation switch on the remote controller.  @return an instance of `transformationswitch`.",
             "getflightmodeswitch",
             "current position of the flight mode switch on the remote controller.  @return an enum value of `flightmodeswitch`",
             "flight_mode_switch_position",
             "sdk key for getflightmodeswitch: current position of the flight mode switch on the remote controller.  @return an enum value of `flightmodeswitch`",
             "getgohomebutton",
             "current state of the return to home button.  @return an instance of `button`.",
             "go_home_button",
             "sdk key for getgohomebutton: current state of the return to home button.  @return an instance of `button`.",
             "getrecordbutton",
             "current state of the video recording button.  @return an instance of `button`.",
             "record_button",
             "sdk key for getrecordbutton: current state of the video recording button.  @return an instance of `button`.",
             "getphotoandvideotogglebutton",
             "current state of the photo and video toggle button.  @return an instance of `button`.",
             "getshootphotoandrecordbutton",
             "current state of the photo and record button.  @return an instance of `button`.",
             "getshutterbutton",
             "current state of the shutter button.  @return an instance of `button`.",
             "shutter_button",
             "sdk key for getshutterbutton: current state of the shutter button.  @return an instance of `button`.",
             "getplaybackbutton",
             "current state of the playback button. the playback button is not supported on phantom 4 remote controllers.  @return an instance of `button`.",
             "playback_button",
             "sdk key for getplaybackbutton: current state of the playback button. the playback button is not supported on phantom 4 remote controllers.  @return an instance of `button`.",
             "getpausebutton",
             "current state of the pause button. the pause button is only supported on phantom 4 remote controllers.  @return an instance of `button`.",
             "pause_button",
             "sdk key for getpausebutton: current state of the pause button. the pause button is only supported on phantom 4 remote controllers.  @return an instance of `button`.",
             "getc1button",
             "current state of custom button 1 (left back button). for mavic air 2 and dji air 2s, there is no custom button 1, we use fn button instead, one click on fn button represents custom button 1. it is not supported by remote controllers for mavic air or spark.  @return an instance of `button`.",
             "custom_button_1",
             "sdk key for getc1button: current state of custom button 1 (left back button). for mavic air 2 and dji air 2s, there is no custom button 1, we use fn button instead, one click on fn button represents custom button 1. it is not supported by remote controllers for mavic air or spark.  @return an instance of `button`.",
             "getc2button",
             "current state of custom button 2 (right back button). for mavic air 2 and dji air 2s, there is no custom button 2, we use fn button instead, double clicks on fn button represents custom button 2.  @return an instance of `button`.",
             "custom_button_2",
             "sdk key for getc2button: current state of custom button 2 (right back button). for mavic air 2 and dji air 2s, there is no custom button 2, we use fn button instead, double clicks on fn button represents custom button 2.  @return an instance of `button`.",
             "getc3button",
             "current state of custom button 3 (right front button). it is only supported by dji smart controller.  @return an instance of `button`.",
             "getfunctionbutton",
             "current state of fn button. it is only supported by remote controllers for spark or mavic air.  @return an instance of `button`.",
             "getfivedbutton",
             "current state of the 5d button. the button can be moved up, down, left and right and can be pressed. the 5d  button is supported by mavic pro and mavic 2 remote controllers.  @return an instance of `fivedbutton`.",
             "five_d_button",
             "sdk key for getfivedbutton: current state of the 5d button. the button can be moved up, down, left and right and can be pressed. the 5d  button is supported by mavic pro and mavic 2 remote controllers.  @return an instance of `fivedbutton`.",
             "hardwarestatecallback",
             "callback function that updates the remote controller's  current hardware state.",
             "rightdial",
             "current state of the camera settings dial (upper right dial on the remote controller).",
             "transformationswitch",
             "transformation switch position. the transformation switch is around the return to home button on inspire,  inspire 1 and m100 remote controllers, and controls the state of the aircraft's landing gear.",
             "transformation_switch",
             "sdk key for transformationswitch: transformation switch position. the transformation switch is around the return to home button on inspire,  inspire 1 and m100 remote controllers, and controls the state of the aircraft's landing gear.",
             "flightmodeswitch",
             "remote controller flight mode switch position.",
             "flight_mode_switch_position",
             "sdk key for flightmodeswitch: remote controller flight mode switch position.",
             "button",
             "remote controller has numerous momentary push buttons, which will use this state.",
             "fivedbutton",
             "state of the 5d button on the remote controller. vertical movement, horizontal movement and if it is pressed are  not exclusive.",
             "five_d_button",
             "sdk key for fivedbutton: state of the 5d button on the remote controller. vertical movement, horizontal movement and if it is pressed are  not exclusive.",
             "aircraftmappingstyle",
             "the mapping style to which the remote controller is set.  @return an enum value of `aircraftmappingstyle`.",
             "leftvertical",
             "the mapping configuration for the left stick on the vertical axis.  @return an instance of `aircraftstickmapping`.",
             "lefthorizontal",
             "the mapping configuration for the left stick on the horizontal axis.  @return an instance of `aircraftstickmapping`.",
             "rightvertical",
             "the mapping configuration for the right stick on the vertical axis.  @return an instance of `aircraftstickmapping`.",
             "righthorizontal",
             "the mapping configuration for the right stick on the horizontal axis.  @return an instance of `aircraftstickmapping`.",
             "aircraftmapping",
             "constructor with a defined mapping style.  @param style the `aircraftmappingstyle` object.",
             "aircraftmapping",
             "constructor with defined mappings.  @param leftvertical the `aircraftmappingstyle` object. @param lefthorizontal the `aircraftmappingstyle` object. @param rightvertical the `aircraftmappingstyle` object. @param righthorizontal the `aircraftmappingstyle` object.",
             "aircraftstickmappingtarget",
             "the list of controls that may be mapped on a stick.",
             "none",
             "none",
             "throttle",
             "controls throttle",
             "pitch",
             "controls pitch",
             "roll",
             "controls roll",
             "yaw",
             "controls yaw",
             "aircraftstickmapping",
             "a struct representing a mapping configuration which includes the particular control and whether or not it is reversed.",
             "getmappingtarget",
             "the defined control to be mapped.  @return an enum value of `aircraftstickmappingtarget`",
             "isreversed",
             "whether or not the control is to be reversed.  @return a boolean value.",
             "aircraftmappingstyle",
             "the predefined mapping styles available to use. custom allow to specify all mapping configurations.",
             "aircraft_mapping_style",
             "sdk key for aircraftmappingstyle: the predefined mapping styles available to use. custom allow to specify all mapping configurations.",
             "style_1",
             "style 1.(japanese mode)",
             "style_2",
             "style 2.(american mode)",
             "style_3",
             "style 3.(chinese mode)",
             "style_custom",
             "custom style. requires all mapping configurations.",
             "unknown",
             "unknown style.",
             "callback",
             "callback function that updates the remote controller's current battery state.",
             "remotecontrollerkey.battery_state",
             "sdk key for callback: callback function that updates the remote controller's current battery state.",
             "getremainingchargeinmah",
             "the remaining power in the remote controller's battery in milliamp hours (mah).  @return an int value.",
             "getremainingchargeinpercent",
             "the remaining power in the remote controller's battery as a percentage in the range of [0, 100].  @return an int value.",
             "ischarging",
             "whether battery of remote controller is charging. the battery may be fully charged when it returns false.  @return an int value.",
             "gettime",
             "the remote controller's gps time.  @return an instance of `gettime`.",
             "getlocation",
             "the remote controller's location.  @return an instance of `gpslocation`.",
             "geteastspeed",
             "the remote controller's speed in the east direction in meters/second. a negative speed means the remote  controller is moving in the west direction.  @return a float value.",
             "getnorthspeed",
             "the remote controller's speed in the north direction in meters/second. a negative speed means the remote  controller is moving in the south direction.  @return a float value.",
             "getsatellitecount",
             "the number of gps satellites the remote controller detects.  @return an int value.",
             "getlocationaccuracy",
             "the the margin of error, in meters, for the gps location.  @return a float value.",
             "isvalid",
             "`true` if the gps data is valid. the data is not valid if there are too few satellites  or the signal strength is too low.  @return a boolean value.",
             "time",
             "remote controller's gps time.",
             "gethour",
             "hour value of remote controller's gps time.  @return a byte value.",
             "getminute",
             "minute value of remote controller's gps time.  @return a byte value.",
             "getsecond",
             "second value of remote controller's gps time.  @return a byte value.",
             "getyear",
             "year value of remote controller's gps time.  @return an int value.",
             "getmonth",
             "month value of remote controller's gps time.  @return a byte value.",
             "getday",
             "day value of remote controller's gps time.  @return a byte value.",
             "gpslocation",
             "location defined by latitude and longitude.",
             "getlongitude",
             "longitude component of a location.  @return a double value.",
             "getlatitude",
             "latitude component of a location.  @return a double value.",
             "gimbalmapping",
             "the mapping styles to control the gimbal.",
             "custom_gimbal_mapping",
             "sdk key for gimbalmapping: the mapping styles to control the gimbal.",
             "leftvertical",
             "the mapping configuration for the left stick on the vertical axis.  @return an instance of `gimbalstickmapping`.",
             "lefthorizontal",
             "the mapping configuration for the left stick on the horizontal axis.  @return an instance of `gimbalstickmapping`.",
             "rightvertical",
             "the mapping configuration for the right stick on the vertical axis.  @return an instance of `gimbalstickmapping`.",
             "righthorizontal",
             "the mapping configuration for the right stick on the horizontal axis.  @return an instance of `gimbalstickmapping`.",
             "gimbalmappingstyle",
             "the control style to which the remote controller is set.  @return an enum value of `gimbalmappingstyle`.",
             "gimbalmappingstyle",
             "the gimbal control stick mapping styles.",
             "gimbal_mapping_style",
             "sdk key for gimbalmappingstyle: the gimbal control stick mapping styles.",
             "default",
             "default",
             "custom",
             "custom",
             "unknown",
             "unknown",
             "gimbalstickmappingtarget",
             "the list of available control to be used when creating custom mapping configurations",
             "none",
             "none",
             "pitch",
             "pitch",
             "roll",
             "roll",
             "yaw",
             "yaw",
             "gimbalstickmapping",
             "a struct representing a custom mapping configuration.",
             "getmappingtarget",
             "the specific control to be mapped.  @return the enum value of `gimbalstickmappingtarget`.",
             "isreversed",
             "whether or not the control is to be reversed.  @return a boolean value.",
             "hdmi",
             "hdmi port.",
             "sdi",
             "sdi port.",
             "unknown",
             "unknown.",
             "source_1_only",
             "displays video from source 1 only. when the current encode  mode is single, the secondary output will display  video from hdmi or av input.  when the current encode mode is dual, the secondary output will display video from hdmi input.",
             "source_2_only",
             "displays video from source 2 only. when the current encode mode is single, the secondary output  will display video from hd gimbal camera. when the current encode mode is dual, the secondary output  will display video from  av input.",
             "source_1_main",
             "displays the video from source 1 as the main subject, and the video from source 2 in a mini  window (picture in  picture, or pip).",
             "source_2_main",
             "displays the video from source 2 as the main subject, and the video from source 1 in a mini window (picture in  picture, or pip).",
             "unknown",
             "unknown output mode.",
             "imperial",
             "imperial.",
             "metric",
             "metric.",
             "unknown",
             "unknown.",
             "resolution_1080i_60fps",
             "1080i 60fps.",
             "resolution_1080i_50fps",
             "1080i 50fps.",
             "resolution_1080p_60fps",
             "1080p 60fps.",
             "resolution_1080p_50fps",
             "1080p 50fps.",
             "resolution_1080p_30fps",
             "1080p 30fps.",
             "resolution_1080p_25fps",
             "1080p 25fps.",
             "resolution_1080p_24fps",
             "1080p 24fps.",
             "resolution_720p_60fps",
             "720p 60fps.",
             "resolution_720p_50fps",
             "720p 50fps.",
             "resolution_720p_30fps",
             "720p 30fps.",
             "resolution_720p_25fps",
             "720p 25fps.",
             "resolution_720p_24fps",
             "720p 24fps.",
             "unknown",
             "unknown.",
             "focuscontrollerstatecallback",
             "callback function that updates the remote focus state.",
             "isworking",
             "`true` if the focus control works. the control can be either changing the aperture or  focal length. if it is `false`, follow  the `direction` to rotate the remote focus device until it  turns to `true` again.  @return a boolean value.",
             "focus_controller_is_working",
             "sdk key for isworking: `true` if the focus control works. the control can be either changing the aperture or  focal length. if it is `false`, follow  the `direction` to rotate the remote focus device until it  turns to `true` again.  @return a boolean value.",
             "getcontroltype",
             "remote focus control type.  @return an enum value of `controltype`",
             "focus_controller_control_type",
             "sdk key for getcontroltype: remote focus control type.  @return an enum value of `controltype`",
             "getdirection",
             "remote focus control direction. use this with  the `isworking` value. it will give you the correct  rotation direction when `isworking` is  `false`.  @return an enum value of `direction`",
             "focus_controller_direction",
             "sdk key for getdirection: remote focus control direction. use this with  the `isworking` value. it will give you the correct  rotation direction when `isworking` is  `false`.  @return an enum value of `direction`",
             "controltype",
             "remote focus control type.",
             "focus_controller_control_type",
             "sdk key for controltype: remote focus control type.",
             "aperture",
             "control aperture.",
             "focal_length",
             "control focal length.",
             "focus_distance",
             "adjust focus distance.",
             "unknown",
             "unknown types.",
             "direction",
             "remote focus control direction.",
             "focus_controller_direction",
             "sdk key for direction: remote focus control direction.",
             "clockwise",
             "clockwise.",
             "counter_clockwise",
             "counterclockwise.",
             "unknown",
             "unknown.",
             "sethardwarestatecallback",
             "set the hardwarestateupdatecallback  @param hardwarestatecallback rchardwarestate.hardwarestatecallback callback.",
             "setchargeremainingcallback",
             "sets the batterystateupdatecallback.  @param callback chargeremaining.batterystatecallback callback.",
             "setgpsdatacallback",
             "set the gpsdataupdatecallback.  @param callback gpsdatacallback callback.",
             "setprorceventcallback",
             "set the prorceventcallback.  @param callback professionalrc callback.",
             "setmasterslavestatecallback",
             "callback that updates the remote controller's state related to the master and slave mode. only supported by inspire 2.  @param callback rcmasterslavestateupdatecallback callback.",
             "setgimbalcontrolrequestfromslavecallback",
             "sets gimbalcontrolrequestfromslavereceivedcallback.  @param controlrequestcallback information.controlrequestcallback callback.",
             "setfocuscontrollerstatecallback",
             "sets rcremotefocusstateupdatecallback.  @param focusstateupdatecallback focuscontrollerstate.focuscontrollerstatecallback callback.",
             "addrtkchannelenabledupdatedcallback",
             "add the rtkchannelenabledupdatedcallback.  @param callback `rtkchannelenabledupdatedcallback` callback.",
             "removertkchannelenabledupdatedcallback",
             "remove the `rtkchannelenabledupdatedcallback` callback.  @param callback `rtkchannelenabledupdatedcallback` callback.",
             "addmultidevicespairingstatecallback",
             "adds `callback`.  @param multideviceaggregationstatecallback `multideviceaggregationstate` callback.",
             "removemultidevicespairingstatecallback",
             "removes `callback`.  @param multideviceaggregationstatecallback `multideviceaggregationstate` callback.",
             "startpairing",
             "enters pairing mode, in which the remote controller starts pairing with the aircraft. this method is used when the remote controller no longer recognizes which aircraft it is paired with.  @param callback the execution callback with the execution result returned. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "start_pairing",
             "sdk key for startpairing: enters pairing mode, in which the remote controller starts pairing with the aircraft. this method is used when the remote controller no longer recognizes which aircraft it is paired with.  @param callback the execution callback with the execution result returned. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "stoppairing",
             "exits pairing mode.  @param callback the execution callback with the execution result returned. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "stop_pairing",
             "sdk key for stoppairing: exits pairing mode.  @param callback the execution callback with the execution result returned. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "getpairingstate",
             "gets the pairing status as the remote controller is pairing with the aircraft.  @param callback the execution callback with the value(s) returned.",
             "remotecontrollerkey.pairing_state",
             "sdk key for getpairingstate: gets the pairing status as the remote controller is pairing with the aircraft.  @param callback the execution callback with the value(s) returned.",
             "ismultidevicepairingsupported",
             "determines if multi-device pairing supported by the remote controller. when the remote controller supports multi-device pairing, it can be paired to more than one device (e.g. aircraft, rtk base station) at the same time. when this feature is supported, use `startmultidevicepairing` and `stopmultidevicepairing` to start and stop pairing instead of using the following methods:  - `startpairing`  - `stoppairing`  - `getpairingstate`. this feature is only supported by phantom 4 rtk.  @return `true` if multi-device pairing is supported.",
             "startmultidevicepairing",
             "starts pairing a target with the specific type (aircraft or rtk base station). this paring method is for phantom 4 rtk only. to use rtk feature with a base station, the phantom 4 rtk remote controller need to pair both the base station and the aircraft at the same time.  caution: pairing an rtk base station will unpair the paired aircraft. therefore, to use the base station properly, the user needs to pair the base station first, and the aircraft after. it is only supported when `ismultidevicepairingsupported` returns `true`.  @param target the device target to start multi-device pairing. @param callback completion block.",
             "stopmultidevicepairing",
             "stops the multi-device pairing. it is used after the pairing is started and before the remote controller is paired to a device successfully. it is not necessary to call this method if the remote controller is paired to a device successfully. only supported by phantom 4 rtk.  @param callback completion block.",
             "setrtkchannelenabled",
             "enables the rtk channel on the remote controller. when rtk air system is using the base station as the reference station, the remote controller should enable the rtk channel and reserve some bandwidth for data transmission between the base station and the air system.  caution: toggling rtk channel will reset the airlink between the remote controller and the aircraft. the airlink may take 3 seconds to recover. do not enable/disable the channel when the aircraft is flying. if the base station is reconnected, you need to call this interface to enabled the rtk channel again. only supported by phantom 4 rtk.  @param enabled `true` to enable the rtk channel on the remote controller. @param callback completion block.",
             "setcustomaircraftmapping",
             "set the mapping of custom style. it will change the current mapping style to `style_custom`. the setting will only take effect when the remote controller is in master mode.  @param mapping the remote controller aircraft mapping. @param callback the execution callback with the value(s) returned.",
             "aircraft_custom_mapping",
             "sdk key for setcustomaircraftmapping: set the mapping of custom style. it will change the current mapping style to `style_custom`. the setting will only take effect when the remote controller is in master mode.  @param mapping the remote controller aircraft mapping. @param callback the execution callback with the value(s) returned.",
             "getcustomaircraftmapping",
             "retrieves the stick mapping associated with the custom style.  @param callback the execution callback with the value(s) returned.",
             "aircraft_custom_mapping",
             "sdk key for getcustomaircraftmapping: retrieves the stick mapping associated with the custom style.  @param callback the execution callback with the value(s) returned.",
             "setaircraftmappingstyle",
             "sets the remote controller's control mode.  @param style remote controller control mode to be set. @param callback the execution callback with the execution result returned.",
             "aircraft_mapping_style",
             "sdk key for setaircraftmappingstyle: sets the remote controller's control mode.  @param style remote controller control mode to be set. @param callback the execution callback with the execution result returned.",
             "getaircraftmappingstyle",
             "gets the remote controller's control mode.  @param callback the execution callback with the execution result returned.",
             "aircraft_mapping_style",
             "sdk key for getaircraftmappingstyle: gets the remote controller's control mode.  @param callback the execution callback with the execution result returned.",
             "setleftdialgimbalcontrolaxis",
             "sets which of the gimbal directions the top left dial (gimbal dial) on the remote controller will control. the three options (pitch, roll, and yaw) are outlined in the enum named `gimbalaxis`.  @param axis gimbal direction to be set that the top left dial on the remote controller will control. @param callback remote execution result error callback. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "getleftdialgimbalcontrolaxis",
             "gets which of the gimbal directions the top left wheel (gimbal dial) on the remote controller will control.  @param callback the execution callback with the value(s) returned.",
             "setleftdialgimbalcontrolspeedcoefficient",
             "sets gimbal rotation speed of the top left wheel (gimbal dial) on the remote controller. the valid range is [0, 100].  @param coefficient gimbal control speed coefficient to be set. setting it to zero can disable the gimbal control by the top left wheel. @param callback the execution callback with the execution result returned.",
             "getleftdialgimbalcontrolspeedcoefficient",
             "gets gimbal rotation speed of the top left wheel (gimbal dial) on the remote controller. the valid range is [0, 100].  @param callback the execution callback with the execution result returned.",
             "setcustombuttontags",
             "sets custom button tags, which can be used by the user to record user settings. moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the c1 and c2 buttons on the remote controller.  @param tags back buttons' custom tags, the value should in the range of [0, 255]. @param callback remote execution result error callback.",
             "custom_button_tags",
             "sdk key for setcustombuttontags: sets custom button tags, which can be used by the user to record user settings. moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the c1 and c2 buttons on the remote controller.  @param tags back buttons' custom tags, the value should in the range of [0, 255]. @param callback remote execution result error callback.",
             "getcustombuttontags",
             "gets the custom button's (back button's) tags.  @param callback the execution callback with the value(s) returned.",
             "custom_button_tags",
             "sdk key for getcustombuttontags: gets the custom button's (back button's) tags.  @param callback the execution callback with the value(s) returned.",
             "setshutterbuttonbindingenabled",
             "enables invoking shooting photo interface when the shutter button is pressed. mavic 2 series remote controller's shutter button will not work physically when connecting to mobile sdk. this setting will be stored in software application localized storage paired with the rc sn key, which means, if the application is killed, it will be set to enabled by default when the application is relaunched. it is only supported by mavic 2 series.  @param enabled `true` to enable invoking shooting photo interface when the shutter button is pressed. @param callback the execution callback with the value(s) returned.",
             "getshutterbuttonbindingenabled",
             "gets if shooting photo interface is involved when the shutter button is pressed. it is only supported by mavic 2 series.  @param callback the execution callback with the value(s) returned.",
             "setrecordbuttonbindingenabled",
             "enables invoking video record interface when the record button is pressed. mavic 2 series remote controller's record button will not work physically when connecting to mobile sdk. this setting will be stored in software application localized storage paired with the rc sn key. only supported by mavic 2 series.  @param enabled `true` to enable invoking video record interface when the record button is pressed. @param callback the execution callback with the value(s) returned.",
             "getrecordbuttonbindingenabled",
             "gets if video record interface is involved when the record button is pressed. it is only supported by mavic 2 series.  @param callback the execution callback with the value(s) returned.",
             "setphotoandvideotogglebuttonbindingenabled",
             "`true` to switch camera flat mode between photo and video when the `getphotoandvideotogglebutton` button is pressed. `false` when `getphotoandvideotogglebutton` button is pressed, we will not bind any event. you can monitor the button and handle custom events by yourself. this setting will be stored in software application localized storage paired with the rc sn key, which means. only supported by mavic air 2, dji air 2s.  @param enabled `true` to switch camera flat mode between photo and video when the `getphotoandvideotogglebutton` button is pressed. @param callback the execution callback with the value(s) returned.",
             "getphotoandvideotogglebuttonbindingenabled",
             "gets whether switching camera flat mode between photo and video is enabled when the `getphotoandvideotogglebutton` button is pressed. it is only supported by mavic air 2.  @param callback the execution callback with the value(s) returned.",
             "setshootphotoandrecordbuttonbindingenabled",
             "`true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getphotoandvideotogglebutton` button state. `false` when `getphotoandvideotogglebutton` button is pressed, we will not bind any event. you can monitor the button and handle custom events by yourself. this setting will be stored in software application localized storage paired with the rc sn key. only supported by mavic air 2, dji air 2s.  @param enabled `true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getphotoandvideotogglebutton` button state. @param callback the execution callback with the value(s) returned.",
             "getshootphotoandrecordbuttonbindingenabled",
             "gets if shoot photo or video record interface is involved when the `getphotoandvideotogglebutton` button is pressed. it is only supported by mavic air 2, dji air 2s.  @param callback the execution callback with the value(s) returned.",
             "setchargemobilemode",
             "sets the charge mode of a connected ios device.  note: android devices are always charging when connected to the remote controller. it is only supported by inspire 2, m200 series, cendence and mavic 2 series.  @param mode charge mobile mode. @param callback the execution callback with the execution result returned.",
             "getchargemobilemode",
             "gets the mode to charge the connected ios device. note that android devices are always charging when connected to the remote controller. it is only supported by inspire 2, m200 series, cendence, and mavic 2 series.  @param callback the execution callback with the value(s) returned.",
             "charge_mobile_mode",
             "sdk key for getchargemobilemode: gets the mode to charge the connected ios device. note that android devices are always charging when connected to the remote controller. it is only supported by inspire 2, m200 series, cendence, and mavic 2 series.  @param callback the execution callback with the value(s) returned.",
             "ismasterslavemodesupported",
             "query method to check if the remote controller supports master/slave mode. master-slave mode is supported by the inspire 1, inspire 1 pro, matrice 100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2. inspire 2 is using a new set of interfaces to control the master and slave connection.  - similar to other products, inspire 2's remote controller also use set/get `rcmode` to change the mode. - a slave remote controller can use `getmasters` and `connecttomaster` to join a master remote controller. - a master remote controller can use `setmasterauthorizationcode` to change the authentication code.  @return a boolean value.",
             "is_master_slave_mode_supported",
             "sdk key for ismasterslavemodesupported: query method to check if the remote controller supports master/slave mode. master-slave mode is supported by the inspire 1, inspire 1 pro, matrice 100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2. inspire 2 is using a new set of interfaces to control the master and slave connection.  - similar to other products, inspire 2's remote controller also use set/get `rcmode` to change the mode. - a slave remote controller can use `getmasters` and `connecttomaster` to join a master remote controller. - a master remote controller can use `setmasterauthorizationcode` to change the authentication code.  @return a boolean value.",
             "setmode",
             "sets the remote controller's mode. see the `rcmode` enum for all possible remote controller modes. the master and slave modes are only supported for the inspire 1, inspire 1 pro, m100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2. it's not supported by matrice 300 rtk.  @param mode mode of type `rcmode` to be set for the remote controller. @param callback the execution callback with the returned execution result.",
             "remotecontrollerkey.mode",
             "sdk key for setmode: sets the remote controller's mode. see the `rcmode` enum for all possible remote controller modes. the master and slave modes are only supported for the inspire 1, inspire 1 pro, m100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2. it's not supported by matrice 300 rtk.  @param mode mode of type `rcmode` to be set for the remote controller. @param callback the execution callback with the returned execution result.",
             "getmode",
             "gets the remote controller's work mode. it is supported by the inspire 1, inspire 1 pro, matrice 100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "remotecontrollerkey.mode",
             "sdk key for getmode: gets the remote controller's work mode. it is supported by the inspire 1, inspire 1 pro, matrice 100, lightbridge 2 (including matrice 600, matrice 600 pro, a3 and n3) and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setname",
             "sets the remote controller's name.  @param name remote controller name to be set. six characters at most. @param callback the execution callback with the execution result returned.",
             "name",
             "sdk key for setname: sets the remote controller's name.  @param name remote controller name to be set. six characters at most. @param callback the execution callback with the execution result returned.",
             "getname",
             "gets the remote controller's name.  @param callback the execution callback with the value(s) returned.",
             "name",
             "sdk key for getname: gets the remote controller's name.  @param callback the execution callback with the value(s) returned.",
             "setpassword",
             "sets the remote controller's password.  @param password remote controller password to be set, using a string consisted by 4 digits. @param callback the execution callback with the value(s) returned. see `basecomponent` for more information about the callback and what is recommended to be done with it.",
             "remotecontrollerkey.password",
             "sdk key for setpassword: sets the remote controller's password.  @param password remote controller password to be set, using a string consisted by 4 digits. @param callback the execution callback with the value(s) returned. see `basecomponent` for more information about the callback and what is recommended to be done with it.",
             "getpassword",
             "gets the remote controller's password.  @param callback the execution callback with the value(s) returned.",
             "remotecontrollerkey.password",
             "sdk key for getpassword: gets the remote controller's password.  @param callback the execution callback with the value(s) returned.",
             "getslavelist",
             "used by the current master remote controller to get all the slaves connected to it.  @param callback the execution callback with the returned value(s).",
             "slave_list",
             "sdk key for getslavelist: used by the current master remote controller to get all the slaves connected to it.  @param callback the execution callback with the returned value(s).",
             "startmastersearching",
             "starts a search by slave remote controller for nearby master remote controllers. to get the list of master remote controllers, first call `getavailablemasters`, then call `stopmastersearching` to end the search.  @param callback remote execution result error callback. please refer to `basecomponent` for more information about the callback and what is recommended be done with it.",
             "start_search_master",
             "sdk key for startmastersearching: starts a search by slave remote controller for nearby master remote controllers. to get the list of master remote controllers, first call `getavailablemasters`, then call `stopmastersearching` to end the search.  @param callback remote execution result error callback. please refer to `basecomponent` for more information about the callback and what is recommended be done with it.",
             "stopmastersearching",
             "used by a slave remote controller to stop the search for nearby master remote controllers.  @param callback remote execution result error callback. please refer to `basecomponent` for more information about the callback and what is recommended be done with it.",
             "stop_master_searching",
             "sdk key for stopmastersearching: used by a slave remote controller to stop the search for nearby master remote controllers.  @param callback remote execution result error callback. please refer to `basecomponent` for more information about the callback and what is recommended be done with it.",
             "getavailablemasters",
             "starts search by slave remote controller for nearby master remote controllers. to get the list of master remote controllers use getavailablemasterswithcallbackblock then call stopmasterrcsearch to end th search.  @param callback the execution callback with the value(s) returned. the array of masters contains objects of type information.",
             "available_masters",
             "sdk key for getavailablemasters: starts search by slave remote controller for nearby master remote controllers. to get the list of master remote controllers use getavailablemasterswithcallbackblock then call stopmasterrcsearch to end th search.  @param callback the execution callback with the value(s) returned. the array of masters contains objects of type information.",
             "getmastersearchingstate",
             "returns the state of the master remote controller search. the search is initiated by the mobile device, but performed by the remote controller. therefore, if the mobile device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the remote controller state.  @param callback the execution callback with the value(s) returned.",
             "master_searching_state",
             "sdk key for getmastersearchingstate: returns the state of the master remote controller search. the search is initiated by the mobile device, but performed by the remote controller. therefore, if the mobile device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the remote controller state.  @param callback the execution callback with the value(s) returned.",
             "connecttomaster",
             "used by a slave remote controller to request to join a master remote controller and be able to control the gimbal. if the master remote controller accepts the request, the master remote controller will control the aircraft and the slave remote controller will control the gimbal.  @param credentials include master's name and master's password. @param callback the execution callback with the value(s) returned.",
             "connect_to_master",
             "sdk key for connecttomaster: used by a slave remote controller to request to join a master remote controller and be able to control the gimbal. if the master remote controller accepts the request, the master remote controller will control the aircraft and the slave remote controller will control the gimbal.  @param credentials include master's name and master's password. @param callback the execution callback with the value(s) returned.",
             "getconnectedmastercredentials",
             "returns the master remote controller's information, which includes the unique identifier, name, and password.  @param callback the execution callback with the value(s) returned.",
             "connected_master_credentials",
             "sdk key for getconnectedmastercredentials: returns the master remote controller's information, which includes the unique identifier, name, and password.  @param callback the execution callback with the value(s) returned.",
             "setmasterauthorizationcode",
             "sets the authorization code of a master remote controller. the slave remote controller needs to know the authorization code in order to join the master. a valid input is a string with 6 digits. the default value is 888888. it can only be called when the remote controller is in master mode.  @param authorizationcode authorization code to set. @param callback the execution callback with the value(s) returned.",
             "set_master_auth_code",
             "sdk key for setmasterauthorizationcode: sets the authorization code of a master remote controller. the slave remote controller needs to know the authorization code in order to join the master. a valid input is a string with 6 digits. the default value is 888888. it can only be called when the remote controller is in master mode.  @param authorizationcode authorization code to set. @param callback the execution callback with the value(s) returned.",
             "getmasters",
             "gets a list of the nearby remote controllers in master mode. it can only be called when the remote controller is in slave mode.  @param callback the execution callback with the returned value(s).",
             "master_list",
             "sdk key for getmasters: gets a list of the nearby remote controllers in master mode. it can only be called when the remote controller is in slave mode.  @param callback the execution callback with the returned value(s).",
             "connecttomaster",
             "joins the master remote controller with the specific id. if the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. in this case, code</code> can be `null`. it can only be called when the remote controller is in slave mode.  @param info joinmasterdata object. @param callback the execution callback with the returned value(s).",
             "connect_to_master_with_id",
             "sdk key for connecttomaster: joins the master remote controller with the specific id. if the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. in this case, code</code> can be `null`. it can only be called when the remote controller is in slave mode.  @param info joinmasterdata object. @param callback the execution callback with the returned value(s).",
             "requestgimbalcontrol",
             "requests the gimbal control from the other remote controller. different from `requestlegacygimbalcontrol`, the gimbal control permission is transferred to the remote controller without the reply from the master remote controller. the master remote controller can attain the gimbal control back by calling the same method. it is only supported by inspire 2, m200 series and cendence.  @param callback the execution callback with the value(s) returned.",
             "respondtorequestforgimbalcontrol",
             "when a slave remote controller requests a master remote controller to control the gimbal, this method is used by a master remote controller to respond to the slave remote controller's request.  @param response the response object of responseforgimbalcontrol to the slave remote controller.",
             "response_to_request_for_gimbal_control",
             "sdk key for respondtorequestforgimbalcontrol: when a slave remote controller requests a master remote controller to control the gimbal, this method is used by a master remote controller to respond to the slave remote controller's request.  @param response the response object of responseforgimbalcontrol to the slave remote controller.",
             "requestlegacygimbalcontrol",
             "called by the slave remote controller to request gimbal control from the master remote controller. it is only supported by inspire 1 and dji lightbridge 2.  @param callback the execution callback with the value(s) returned.",
             "setcustomgimbalmapping",
             "sets the remote controller's slave control mode.  @param mapping the djircgimbalmapping object. @param callback the execution callback with the value(s) returned.",
             "custom_gimbal_mapping",
             "sdk key for setcustomgimbalmapping: sets the remote controller's slave control mode.  @param mapping the djircgimbalmapping object. @param callback the execution callback with the value(s) returned.",
             "getcustomgimbalmapping",
             "gets the remote controller's slave control mode.  @param callback the execution callback with the value(s) returned.",
             "custom_gimbal_mapping",
             "sdk key for getcustomgimbalmapping: gets the remote controller's slave control mode.  @param callback the execution callback with the value(s) returned.",
             "setgimbalmappingstyle",
             "sets the remote controller's slave control mode.  @param style control mode to be set. @param callback remote execution result error callback.",
             "gimbal_mapping_style",
             "sdk key for setgimbalmappingstyle: sets the remote controller's slave control mode.  @param style control mode to be set. @param callback remote execution result error callback.",
             "getgimbalmappingstyle",
             "gets the remote controller's slave control mode.  @param callback the execution callback with the value(s) returned.",
             "gimbal_mapping_style",
             "sdk key for getgimbalmappingstyle: gets the remote controller's slave control mode.  @param callback the execution callback with the value(s) returned.",
             "setgimbalcontrolspeedcoefficient",
             "called by the slave remote controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedcoefficient speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback remote execution result error callback. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "gimbal_control_speed_coefficient",
             "sdk key for setgimbalcontrolspeedcoefficient: called by the slave remote controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedcoefficient speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback remote execution result error callback. see `basecomponent` for more information about the callback and what is recommended be done with it.",
             "getgimbalcontrolspeedcoefficient",
             "gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback the execution callback with the value(s) returned.",
             "gimbal_control_speed_coefficient",
             "sdk key for getgimbalcontrolspeedcoefficient: gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback the execution callback with the value(s) returned.",
             "iscustomizablebuttonsupported",
             "`true` if the remote controller supports customizable buttons. with the customizable buttons, the user can define the action bound to a button. when the button is clicked, the corresponding action can be received from the .   only cendence supports customizable buttons. this is distinct from remote   controllers with buttons c1 and c2 that support custom tags and a binding to dji go.  @return true to support customizable button.",
             "getbuttonprofilegroups",
             "gets the names of the customizable button profile groups. the configurations of the customizable buttons are organized as groups. the maximum number of groups is 5 and each group contains 3 profiles. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param callback the execution callback with the execution result returned.",
             "addbuttonprofilegroup",
             "adds a group of customizable button profiles. three default profiles will be created for the newly added group. the default profile can accessed through `getbuttonactions`. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param groupname the name of the group to be added. @param callback the execution callback with the execution result returned.",
             "removebuttonprofilegroup",
             "removes a group from the customizable button profiles. there must be at least one group, therefore, the removal of the last group will fail. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param groupname the name of the group to be removed. @param callback the execution callback with the execution result returned.",
             "renamebuttonprofilegroup",
             "renames a profile group to a new name. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param oldprofilename the name of the group to be renamed. @param newprofilename the new profile group name. @param callback the execution callback with the execution result returned.",
             "selectbuttonprofilegroup",
             "selects the customizable button profile group. the profile with 0 configindex in the group will be applied. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param groupname the name of the group to select. @param callback the execution callback with the execution result returned.",
             "getselectedbuttonprofilegroup",
             "gets the name of the selected customizable button profile group. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param callback the execution callback with the execution result returned.",
             "selectbuttonprofile",
             "selects the customizable button profile with the specific index in the selected profile group. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param profileindex the index of the profile to select. the valid range is [0, 2]. @param callback the execution callback with the execution result returned.",
             "getselectedbuttonprofile",
             "gets the index of the selected button profile in the selected group. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param callback the execution callback with the execution result returned.",
             "setbuttonconfig",
             "customizes the button configuration. the configuration will be applied to the remote controller immediately and will be stored into the selected profile of the selected profile group. it is only valid when `iscustomizablebuttonsupported` returns `true`. supported by the cendence remote controller.  @param config the configuration to be set. @param callback the execution callback with the execution result returned.",
             "getbuttonconfig",
             "gets the button configuration being applied to the remote controller. it is only valid when `iscustomizablebuttonsupported` returns `true`. supported by the cendence remote controller.  @param callback the execution callback with the execution result returned.",
             "resetbuttonconfig",
             "resets the selected button configuration to the default settings. the default configuration will be applied to the remote controller and will be stored into the selected index of the activated user. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param callback the execution callback with the execution result returned.",
             "customizebutton",
             "customizes the action of a button. the new setting will be applied to the remote controller and will be stored into the selected profile index of the selected profile group. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param button the customizable button. @param action the action to be bound to the button. @param callback the execution callback with the execution result returned.",
             "fetchcustomizedactionofbutton",
             "fetches the customized action of a button in the selected configuration. it is only valid when `iscustomizablebuttonsupported` returns `true`.  @param button the customizable button. @param callback the execution callback with the execution result returned.",
             "setcontrollinggimbalindex",
             "directs commands of the physical buttons on the remote controller (rotating gimbal, shoot photo, record video, etc.) to the specific gimbal, when there are multiple gimbals connected. if there is only one gimbal connected, this setting is reset to the remaining gimbal. enabling `setattitudesynchronizationenabled` will reset this setting to index 0 and when `setattitudesynchronizationenabled` is enabled, index can only be set to 0. it is only supported by m210, m210 rtk and matrice 300 rtk.  @param index index of the gimbal to receive the remote controller commands. @param callback the execution callback with the execution result returned.",
             "getcontrollinggimbalindex",
             "the index of the gimbal that the remote controller is controlling. commands of the physical buttons (rotating gimbal, shoot photo, record video, etc.) will be directed to the specific gimbal. if there is only one gimbal connected, this setting is reset to the remaining gimbal's index. enabling `setattitudesynchronizationenabled` will reset the value to 0. for product that supports only one gimbal, the value is always 0.  @param callback the execution callback with the execution result returned.",
             "issecondaryvideooutputsupported",
             "return whether secondary video output supported. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @return a boolean value.",
             "setsecondaryvideooutputenabled",
             "enable secondary video output on remote controller. the remote controller outputs video to the mobile device by default. this will enable a secondary video stream to one of the remote controller's physical hdmi and sdi ports. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param enabled enables secondary video output. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideooutputenabled",
             "gets whether secondary video output on remote controller is enabled. the remote controller outputs video to the mobile device by default, but a secondary video can be routed to its hdmi or sdi port. use `setsecondaryvideooutputenabled` to enable or disable,  and `setsecondaryvideooutputport` to choose the port. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideooutputport",
             "sets secondary video output port on remote controller. hdmi or sdi are possible. only one port can be active at once. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param port secondary video output port. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideooutputport",
             "gets the secondary video output port on remote controller. hdmi or sdi are possible. only one port can be active at once. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideodisplay",
             "sets the secondary video output picture in picture (pip) display mode. the remote controller module can connect to both an fpv camera (through the hdmi and av ports) and a camera mounted on the hd gimbal (through the gimbal port). the output video can then be a combination of the two video sources. either a single video source can be  displayed, or one can be displayed within the other (as a picture in picture, or pip). if the mode is set incorrectly,  then no output video will be displayed. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param mode picture in picture (pip) display mode. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideodisplay",
             "gets the secondary video output picture in picture (pip) display mode. the air link module can connect to both an  fpv camera (through the hdmi and av ports) and a camera mounted on the hd gimbal (through the gimbal port). the  output video can then be a combination of the two video sources. either a single video source can be displayed, or  one can be displayed within the other (as a picture in picture, or pip). it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdenabled",
             "enables and disables on screen display (osd) overlay on the secondary video. osd is flight data like altitude, attitude etc. and can be overlayed on the pip video. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param enabled determines whether to display osd on screen. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdenabled",
             "determines whether on screen display (osd) is overlayed on the video feed.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdtopmargin",
             "sets the osd top margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param margin top margin of osd. the range is [0, 50]. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdtopmargin",
             "gets the osd top margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdleftmargin",
             "sets the osd left margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param margin left margin of osd. the range is [0, 50]. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdleftmargin",
             "gets the osd left margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdbottommargin",
             "sets the osd bottom margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param margin bottom margin of osd. the range is [0, 50]. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdbottommargin",
             "gets the osd bottom margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdrightmargin",
             "sets the osd right margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param margin right margin of osd. the range is [0, 50]. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdrightmargin",
             "gets the osd right margin in video pixels. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideoosdunit",
             "sets the osd units to either metric or imperial. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param unit osd units. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideoosdunit",
             "gets the osd units (metric or imperial). it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setsecondaryvideooutputformatforhdmi",
             "sets the remote controller hdmi video port output video format. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param format the value of the `secondaryvideoformat` enum. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideooutputformatforhdmi",
             "gets the remote controller hdmi video port output video format. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the execution result returned.",
             "setsecondaryvideooutputformatforsdi",
             "sets the remote controller sdi video port output video format. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param format the value of the `secondaryvideoformat` enum. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideooutputformatforsdi",
             "gets the remote controller sdi video port output video format. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the execution result returned.",
             "setsecondaryvideopipposition",
             "sets the pip (picture in picture) position relative to the top left corner of the main subject video feed. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param position position of the pip on the screen. @param callback the execution callback with the execution result returned.",
             "getsecondaryvideopipposition",
             "gets the pip (picture in picture) position relative to the top left corner of the main subject video feed. it is supported by phantom 4 professional, matrice 200, matrice 200 series v2, inspire 1 and inspire 2.  @param callback the execution callback with the value(s) returned.",
             "setliveviewsimultaneousoutputenabled",
             "enables the setting to output video to both the mobile device and the hdmi port on the remote controller simultaneously. when it is disabled and the remote controller is connected to a hdmi display, the mobile device will not receive the live view. it is only supported by inspire 1 and m100.  @param enabled `true` to enable live view simultaneous output. @param callback the execution callback with the value(s) returned.",
             "getliveviewsimultaneousoutputenabled",
             "determines whether the setting to output video to both the mobile device and the hdmi port on the remote controller simultaneously is enabled or not. when it is disabled and the remote controller is connected to a hdmi display, the mobile device will not receive the live view. it is only supported by inspire 1 and m100.  @param callback the execution callback with the value(s) returned.",
             "isfocuscontrollersupported",
             "query method to check if the remote controller supports remote focus state checking.  @return a boolean value.",
             "is_focus_controller_supported",
             "sdk key for isfocuscontrollersupported: query method to check if the remote controller supports remote focus state checking.  @return a boolean value.",
             "callback",
             "callback function that updates the remote controller's current gps data.",
             "gps_data",
             "sdk key for callback: callback function that updates the remote controller's current gps data.",
             "mastersearchingcallback",
             "receives the information of available master remote controllers. `onmasterlistupdate` will be called repeated with 1 second interval once master searching is started successfully. it will stop when the searching is stopped either by the remote controller itself or by calling `stopmastersearching`.",
             "rtkchannelenabledupdatedcallback",
             "interface to receive the current rtk channel enabled from the remote controller that supporting multi-device pairing.",
             "onupdate",
             "callback function that updates the remote controller's current hardware state (e.g. the state of the physical buttons and joysticks).  @param hardwarestate current state of the remote controller's hardware state.",
             "onupdate",
             "callback function that updates the remote controller's current gps data.  @param gpsdata current state of the remote controller's gps data.",
             "gps_data",
             "sdk key for onupdate: callback function that updates the remote controller's current gps data.  @param gpsdata current state of the remote controller's gps data.",
             "onupdate",
             "callback function that updates the remote controller's current battery state.  @param batterystate current state of the remote controller's battery state.",
             "onreceive",
             "callback function that gets called when a slave remote controller makes a request to a master remote controller to control the gimbal using the method requestgimbalcontrolrightwithcallbackblock.  @param information information of the slave making the request to the master remote controller.",
             "onupdate",
             "callback function that updates the remote focus state, only support focus product. if the isrcremotefocuscheckingsupported is `true`, this  callback function will be called.  @param remotefocusstate current state of the remote focus state.",
             "onupdate",
             "callback function that updates the remote controller's state related to the master and slave mode. only supported by inspire 2.  @param masterslavestate the remote controller's state related to the master and slave mode.",
             "master_slave_state",
             "sdk key for onupdate: callback function that updates the remote controller's state related to the master and slave mode. only supported by inspire 2.  @param masterslavestate the remote controller's state related to the master and slave mode.",
             "onresult",
             "execution result of `startmastersearching`.  @param error error retrieving the value.",
             "onmasterlistupdate",
             "called every 1 seconds to get available master remote controllers' information.  @param informationlist information list array.",
             "onrtkchannelenabledupdate",
             "method to receive the current rtk channel enabled from the remote controller that supporting multi-device pairing.  @param enabled the current rtk channel enabled.",
             "hardwarestate",
             "remote controller's current state.",
             "secondaryvideooutputport",
             "remote controller port to which to send secondary video (in addition to usb video sent to the mobile device).",
             "secondaryvideodisplaymode",
             "defines the combination of video sources to form the secondary output video. the secondary output can display video streams from one or two input sources. when the encode mode is single: source 1 represents video from one of the source1only input ports (hdmi or av). source 2 represents video from ext input port  (hd gimbal camera). when the encode mode is dual: source 1 represents video from hdmi input port.  source 2 represents video from av input port.",
             "secondaryvideoosdunit",
             "osd data units.",
             "secondaryvideoformat",
             "secondary output video resolution and frame rate.",
             "pipposition",
             "pip (picture in picture) position on the screen relative to the main subject video.",
             "gpsdata",
             "remote controller's gps data. only supported by remote controller using dji lightbridge.",
             "gps_data",
             "sdk key for gpsdata: remote controller's gps data. only supported by remote controller using dji lightbridge.",
             "batterystate",
             "remote controller's battery information. only supported by dji smart controller enterprise with firmware version v01.00.01.01 and above.",
             "remotecontrollerkey.battery_state",
             "sdk key for batterystate: remote controller's battery information. only supported by dji smart controller enterprise with firmware version v01.00.01.01 and above.",
             "focuscontrollerstate",
             "remote controller's remote focus state. the focus product has one dial (focus control) that controls two separate parts of the camera: focal length and aperture. however it can only control one of these at any one time and is an absolute dial, meaning that a specific rotational position of the dial corresponds to a specific focal length or aperture. this means that whenever the dial control mode is changed, the dial first has to be reset to the new mode's previous dial position before the dial can be used to adjust the setting of the new mode. example workflow:<br/><ol> - use dial to set an aperture of f2.2  - change dial control mode to focal length (set `controltype`) - use the dial to change the focal length - change dial control mode back to aperture -  set `controltype`  - `isworking` will now be no -  adjust dial back to f2.2 - `direction` is the direction the dial should be rotated - `isworking` will become yes when set back to f2.2 - now the dial can be used to adjust the aperture.</ol>",
             "pairingstate",
             "remote controller pairing state.",
             "remotecontrollerkey.pairing_state",
             "sdk key for pairingstate: remote controller pairing state.",
             "aircraftmapping",
             "the object representing the stick mapping configuration of the remote controller.",
             "aircraft_custom_mapping",
             "sdk key for aircraftmapping: the object representing the stick mapping configuration of the remote controller.",
             "gimbalaxis",
             "defines what the gimbal dial (upper left dial on the remote controller) will control.",
             "custombuttontags",
             "tags for c1 and c2 buttons on the remote controller",
             "custom_button_tags",
             "sdk key for custombuttontags: tags for c1 and c2 buttons on the remote controller",
             "chargemobilemode",
             "modes to charge an ios mobile device. only supported by inspire 2.",
             "charge_mobile_mode",
             "sdk key for chargemobilemode: modes to charge an ios mobile device. only supported by inspire 2.",
             "buttonaction",
             "actions that can be assigned to a customizable button. some of the actions are reserved and the firmware will execute the corresponding actions even when the application is not connected. some of the actions are defined by the mobile applications. the application is responsible for implementing the non firmware actions. the definitions used in dji go are provided. it is usually recommended to follow dji go's definitions for compability so if dji go is used at the same time as the sdk application the actions will be expected in both applications.",
             "customizablebutton",
             "the customizable buttons.",
             "remotecontrollerkey.fetch_customized_action_of_button",
             "sdk key for customizablebutton: the customizable buttons.",
             "pairingdevice",
             "types of the device that the remote controller can pair with. it is only used when the remote controller supports multi-device pairing. only supported by phantom 4 rtk.",
             "multidevicestate",
             "the state (e.g. unpaired, paired, connected, etc.) of a device that may connected to the remote controller. it is only used when the remote controller supports multi-device pairing. only supported by dji phantom 4 rtk.",
             "softswitchjoystickmode",
             "joy stick mode on the remote controller. it is only used when the remote controller doesn't have a mode switch. only supported by mavic mini, dji mini se.",
             "setsoftswitchjoystickmode",
             "sets the joy stick mode on the remote controller. it is only used when the remote controller doesn't have a mode switch. only supported by mavic mini, dji mini se.",
             "getsoftswitchjoystickmode",
             "gets the joy stick mode on the remote controller. it is only used when the remote controller doesn't have a mode switch. only supported by mavic mini, dji mini se.",
             "rcmode",
             "remote controller mode of operation can be normal (single rc connected to aircraft), master, slave, or unknown.",
             "remotecontrollerkey.mode",
             "sdk key for rcmode: remote controller mode of operation can be normal (single rc connected to aircraft), master, slave, or unknown.",
             "calibrationstate",
             "remote controller's calibration mode.",
             "information",
             "this class contains the information for a remote controller.",
             "available_masters",
             "sdk key for information: this class contains the information for a remote controller.",
             "slave_list",
             "sdk key for information: this class contains the information for a remote controller.",
             "connecttomasterresult",
             "result when a slave remote controller tries to join a master remote controller.",
             "masterslavestate",
             "state of the remote controller related to the master and slave mode.",
             "master_slave_state",
             "sdk key for masterslavestate: state of the remote controller related to the master and slave mode.",
             "gimbalcontrolspeedcoefficient",
             "remote controller's gimbal control speed.",
             "gimbal_control_speed_coefficient",
             "sdk key for gimbalcontrolspeedcoefficient: remote controller's gimbal control speed.",
             "requestgimbalcontrolresult",
             "result when a slave remote controller requests permission to control the gimbal.",
             "request_gimbal_control",
             "sdk key for requestgimbalcontrolresult: result when a slave remote controller requests permission to control the gimbal.",
             "responseforgimbalcontrol",
             "data object that master remote controller to respond to the slave remote controller's request.",
             "response_to_request_for_gimbal_control",
             "sdk key for responseforgimbalcontrol: data object that master remote controller to respond to the slave remote controller's request.",
             "authorizationinfo",
             "joins the master remote controller with the specific id. if the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. in this case, `code` can be `null`. it can only be called when the remote controller is in slave mode. it is only supported by inspire 2.",
             "connect_to_master_with_id",
             "sdk key for authorizationinfo: joins the master remote controller with the specific id. if the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. in this case, `code` can be `null`. it can only be called when the remote controller is in slave mode. it is only supported by inspire 2.",
             "credentials",
             "remote controller credentials.",
             "connected_master_credentials",
             "sdk key for credentials: remote controller credentials.",
             "connect_to_master",
             "sdk key for credentials: remote controller credentials.",
             "getid",
             "remote controller id.  @return an int value.",
             "getname",
             "remote controller name.  @return an instance of string.",
             "getpassword",
             "remote controller password.  @return an instance of string.",
             "professionalrc",
             "class for the professional cendence remote controller.",
             "event",
             "the event for the professional cendence remote controller class.",
             "remotecontrollerkey.button_event_of_professional_rc",
             "sdk key for event: the event for the professional cendence remote controller class.",
             "getcustomizablebutton",
             "get the customizable button type.  @return an enum value of `customizablebutton`.",
             "getcurrentvalue",
             "get the current value of the event.  @return an enum value of `customizablebutton`.",
             "buttonconfiguration",
             "button configuration for the professional cendence remote controller.",
             "remotecontrollerkey.button_config",
             "sdk key for buttonconfiguration: button configuration for the professional cendence remote controller.",
             "buttonconfigurationbuilder",
             "this class is for generating the instance of buttonconfiguration",
             "build",
             "the build method for generating `buttonconfiguration`.  @return an object of `buttonconfiguration`.",
             "getbuttonactions",
             "fetch a map representing the mapping between a customizable button and its action.  @return a map representing the mapping between a customizable button and its action.",
             "builddefaultbuttonconfiguration",
             "build `buttonconfiguration` with default configuration.  @return an object of `buttonconfiguration` class.",
             "buildbuttonconfigurationwithmap",
             "build `buttonconfiguration` with a map<customizablebutton, buttonaction>.  @param map a map<customizablebutton, buttonaction>.  @return an object of `buttonconfigurationbuilder` class.",
             "configbutton",
             "configure one button with a buttonaction, need be called after the calling of `buildbuttonconfigurationwithmap` or `builddefaultbuttonconfiguration`.  @param button an enum value of `customizablebutton`. @param buttonaction an enum value of `buttonaction`.  @return an object of `buttonconfigurationbuilder` class.",
             "getvalidactionsforbutton",
             "return the array list of `buttonaction` enum values could be configured to one button.  @param button an enum value of `customizablebutton`.  @return an array of the `buttonaction` enum values.",
             "callback",
             "the professional cendence rc callback interface.",
             "onevent",
             "callback function that updates the `event`.  @param event `event` event.",
             "displaynamemavicpro",
             "the display name of mavic pro's remote controller.",
             "displaynameinspire1",
             "the display name of the remote controller for inspire 1 series and matrice 100.",
             "displaynamelightbridge2",
             "the display name of the remote controller for lightbridge 2 wireless module. the module is used by stand-alone lightbridge 2, a3, n3 and matrice 600 series.",
             "displaynameinspire2",
             "the display name of the remote controller for inspire 2 and matrice 200 series.",
             "displaynamecendence",
             "the display name of the cendence remote controller.",
             "displaynamecendencesdr",
             "the display name of the cendence sdr remote controller.",
             "displaynamephantom3professinal",
             "the display name of the remote controller for phantom 3 professional, phantom 3 advanced and phantom 4.",
             "displaynamephantom3standard",
             "the display name of phantom 3 standard's remote controller.",
             "displaynamephantom4pro",
             "the display name of phantom 4 pro's remote controller.",
             "displaynamephantom4advanced",
             "the display name of phantom 4 advanced's remote controller.",
             "displaynamephantom4prov2",
             "the display name of the remote controller for phantom 4 pro v2.",
             "displaynamespark",
             "the display name of spark's remote controller.",
             "displaynamemavicair",
             "the display name of mavic air's remote controller.",
             "displaynamemavic2",
             "the display name of mavic 2's remote controller.",
             "displaynamemavic2enterprise",
             "the display name of mavic 2 enterprise's remote controller.",
             "displaynamedjismartcontroller",
             "the display name of dji smart controller.",
             "displaynamedjismartcontrollerenterprisecontroller",
             "the display name of dji smart controller enterprise.",
             "displaynamemavicmini",
             "the display name of mavic mini/dji mini se's remote controller.",
             "displaynamemavicair2",
             "the display name of mavic air 2's remote controller.",
             "displaynamedjimini2",
             "the display name of dji mini 2's remote controller.",
             "displaynamedjiair2s",
             "the display name of dji air 2s's remote controller.",
             "multideviceaggregationstate",
             "the aggregation state related to devices that can pair to the remote controller. it contains the pairing  state and the connection state of the device (aircraft or rtk base station). it is only used when the remote controller supports multi- device pairing. only supported by phantom 4 rtk.",
             "getaircraftstate",
             "the device state of aircraft.  @return an enum value of the `multidevicestate`.",
             "getrtkbasestationstate",
             "the device state of rtk base station.  @return an enum value of the `multidevicestate`.",
             "callback",
             "interface to receive the latest pairing state from the remote controller that supporting multi-device pairing.",
             "onmultideviceaggregationstatechanged",
             "delegate method to receive the latest pairing state from the remote controller that supporting multi-device pairing.  @param state the latest pairing state.",
             "unpaired",
             "the remote controller is not pairing.",
             "pairing",
             "the remote controller is currently pairing.",
             "firmwareswitching",
             "the remote controller is switching rc firmware.",
             "firmwareswitched",
             "the remote control has finished switching rc firmware.",
             "paired",
             "the remote controller's pairing was completed.",
             "unknown",
             "the remote controller's pairing state is unknown.",
             "pitch",
             "the upper left dial will control the gimbal's pitch.",
             "roll",
             "the upper left dial will control the gimbal's roll.",
             "yaw",
             "the upper left dial will control the gimbal's yaw.",
             "getc1buttontag",
             "button tag for custom button 2.  @return value that is the tag",
             "getc2buttontag",
             "button tag for custom button 2  @return value that is the tag",
             "getc3buttontag",
             "button tag for custom button 3  @return value that is the tag",
             "builder",
             "create a `custombuttontags` instance with values for c1 and c2. a valid tag is an integer in range [0, 255].",
             "c1buttontag",
             "button tag for custom button 2  @param c1buttontag button tag for custom button 1  @return builder object.",
             "c2buttontag",
             "button tag for custom button 2  @param c2buttontag button tag for custom button 2  @return builder object.",
             "c3buttontag",
             "button tag for custom button 3, only supported by dji smart controller.  @param c3buttontag button tag for custom button 3.  @return builder object.",
             "build",
             "button tag for custom button  @return `custombuttontags` object.",
             "never",
             "the remote controller does not charge the mobile device.",
             "always",
             "the remote controller charges the mobile device until the the mobile device is fully charged.",
             "intelligent",
             "the remote controller charges the mobile device in an intelligent mode: the remote controller starts charging when the mobile device's battery is lowered then 20% and stops charging when the mobile device's battery is above 50%. it is only supported by inspire 2.",
             "unknown",
             "the remote controller's charging mode is unknown.",
             "master",
             "remote controller is a master (will route a connected slave remote  controller's commands to the aircraft).",
             "slave",
             "remote controller is currently a slave remote controller (sends commands to aircraft through a master remote controller).",
             "normal",
             "remote controller is not connected to another remote controller.",
             "unknown",
             "the remote controller's mode is unknown.",
             "accepted",
             "the slave remote controller's attempt to join the master remote controller was successful.",
             "password_error",
             "the slave remote controller's attempt to join the master remote controller was unsuccessful due to a password error.",
             "rejected",
             "the slave remote controller's attempt to join the master remote controller was rejected.",
             "maximum_capacity",
             "the slave remote controller's attempt to join the master remote controller was unsuccessful because the master remote controller is at the maximum number of slaves it can have.",
             "timeout",
             "the slave remote controller's attempt to join the master remote controller was unsuccessful because the request timed out.",
             "unknown",
             "the result of the slave remote controller's attempt to join the master remote controller is unknown.",
             "getpitchspeedcoefficient",
             "gimbal's pitch speed with range [0, 100].  @return an int value.",
             "getrollspeedcoefficient",
             "gimbal's roll speed with range [0, 100].  @return an int value.",
             "getyawspeedcoefficient",
             "gimbal's yaw speed with range [0, 100].  @return an int value.",
             "accepted",
             "the master remote controller agrees to the slave's request.",
             "rejected",
             "the master remote controller denies the slave's request. if the slave remote controller wants to control the gimbal, it must send a request to the master remote controller first. then the master remote controller can decide to approve or deny the request.",
             "timeout",
             "the slave remote controller's request timed out.",
             "unknown",
             "the slave remote controller's request is unknown.",
             "camerasetting",
             "toggle the camera setting view. the action has to be implemented by the application itself.",
             "gimbalcenter",
             "resets the gimbal attitude. the pitch and the yaw will point to the origin. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "mapswitch",
             "switch the live view and the map view. the action has to be implemented by the application itself.",
             "clearroute",
             "clear the flight path in the map view. the action has to be implemented by the application itself.",
             "battery",
             "toggle the battery setting view. the action has to be implemented by the application itself.",
             "centermetering",
             "trigger central exposure metering. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "aelock",
             "toggles the ae lock setting. the action has to be implemented by the application itself.",
             "forearm",
             "toggle the leds on the four arms. the action has to be implemented by the application itself.",
             "reset_fpv_gimbal",
             "reset fpv gimbal attitude to the center, the gimbal will rotate 45 degrees in pitch axis up and down when the action is trigger. it is supported by the firmware of matrice 200 series and matrice 200 v2 series. for the other products, the action has to be implemented by the application itself.",
             "liveviewexpand",
             "expand the live view from the fpv camera. the action has to be implemented by the application itself.",
             "quick_spin",
             "trigger a quick spin. it is supported by the firmware of inspire 2. for the other products, the action has to be implemented by the application itself.",
             "playback",
             "toggle the playback view. the action has to be implemented by the application itself.",
             "centerfocus",
             "triggers focusing at the center of the live view. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "getgimbalcontrol",
             "request gimbal control (for the slave remote controller). the action has to be implemented by the application itself.",
             "gimbalmode",
             "toggle `yaw_follow` and `free` for gimbal. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "quicksetting",
             "toggle the customizable button setting view. the action has to be implemented by the application itself.",
             "afmf",
             "toggle af and mf for camera. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "closetips",
             "dismiss the warning tips. the action has to be implemented by the application itself.",
             "smartgear",
             "toggle the automatic movement of the landing gear. the action has to be implemented by the application itself.",
             "reviewwarning",
             "toggle the warning list view. the action has to be implemented by the application itself.",
             "switch_frequency",
             "switch frequency bands of the remote controller. it is supported by the firmware of matrice 200 series. for the other products, the action has to be implemented by the application itself.",
             "updatehomedrone",
             "set the home location of the aircraft to the current location of the aircraft. the action has to be implemented by the application itself.",
             "updatehomerc",
             "set the home location of the aircraft to the current location of the remote controller. the action has to be implemented by the application itself.",
             "focus",
             "trigger the camera focus. it is supported by the firmware of matrice 200 series and matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "compositionmode",
             "toggle the composition mode for the spotlight. the action has to be implemented by the application itself.",
             "focuspeaking",
             "toggle the peak focus. the action has to be implemented by the application itself.",
             "gridline",
             "toggle the display of grid. the action has to be implemented by the application itself.",
             "histogram",
             "toggle the display of histogram. the action has to be implemented by the application itself.",
             "aemfswitch",
             "switch the white balance settings. the action has to be implemented by the application itself.",
             "overexposure",
             "toggle the over-exposure warning. the action has to be implemented by the application itself.",
             "gimbal_yaw_recenter",
             "reset the gimbal yaw to align with the aircraft heading. the action has to be implemented by the application itself.",
             "toggle_landing_gear",
             "retract or deploy the landing gear. it is supported by the firmware of inspire 2. for the other products, the action has to be implemented by the application itself.",
             "closeradarmap",
             "toggle the radar map. the action has to be implemented by the application itself.",
             "closedownvps",
             "toggle the downward vision sensors. the action has to be implemented by the application itself.",
             "closefrontass",
             "toggle the forward obstacle avoidance. the action has to be implemented by the application itself.",
             "switchgimbalfpv",
             "switch the video source of the secondary video feeder between fpv and camera. the action has to be implemented by the application itself.",
             "fullscreen",
             "toggle the full screen mode. the action has to be implemented by the application itself.",
             "custom100",
             "zoom out. it is only supported by z30 camera. it is supported by the firmware of matrice 200 v2 series. for the other products, the action has to be implemented by the application itself.",
             "custom101",
             "zoom in. it is only supported by z30 camera. it is supported by the firmware of matrice 200 v2 series. for the other products, the action has to be implemented by the application itself.",
             "custom102",
             "custom action with value 102. this value is reserved for sdk applications.",
             "custom103",
             "toggle the `displaymode`. it is only supported by xt2 camera. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom104",
             "custom action with value 104. this value is reserved for sdk applications.",
             "custom105",
             "custom action with value 105. this value is reserved for sdk applications.",
             "custom106",
             "custom action with value 106. this value is reserved for sdk applications.",
             "custom107",
             "custom action with value 107. this value is reserved for sdk applications.",
             "custom108",
             "custom action with value 108. this value is reserved for sdk applications.",
             "custom109",
             "custom action with value 109. this value is reserved for sdk applications.",
             "not_defined",
             "not defined. it is used to present that no action is bound to a button.",
             "custom150",
             "triggers the widget of the payload device in the index of 0. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom151",
             "triggers the widget of the payload device in the index of 1. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom152",
             "triggers the widget of the payload device in the index of 2. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom153",
             "triggers the widget of the payload device in the index of 3. it is supported by the firmware of matrice 200 v2 series. for the other products, the action has to be implemented by the application itself.",
             "custom154",
             "triggers the widget of the payload device in the index of 4. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom155",
             "triggers the widget of the payload device in the index of 5. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom156",
             "triggers the widget of the payload device in the index of 6. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom157",
             "triggers the widget of the payload device in the index of 7. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom158",
             "triggers the widget of the payload device in the index of 8. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom159",
             "triggers the widget of the payload device in the index of 9. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom160",
             "triggers the widget of the payload device in the index of 10. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom161",
             "triggers the widget of the payload device in the index of 11. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom162",
             "triggers the widget of the payload device in the index of 12. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom163",
             "triggers the widget of the payload device in the index of 13. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "custom164",
             "triggers the widget of the payload device in the index of 14. it is supported by the firmware of matrice 200 series v2. for the other products, the action has to be implemented by the application itself.",
             "c1",
             "the button with c1 label.",
             "c2",
             "the button with c2 label.",
             "c3",
             "the button with c3 label.",
             "c4",
             "the button with c4 label.",
             "ba",
             "the button with ba label.",
             "bb",
             "the button with bb label.",
             "bc",
             "the button with bc label.",
             "bd",
             "the button with bd label.",
             "be",
             "the button with be label.",
             "bf",
             "the button with bf label.",
             "bg",
             "the button with bg label.",
             "bh",
             "the button with bh label.",
             "td",
             "the button with td label.",
             "menu",
             "the button with menu label.",
             "ls",
             "the button with ls label.",
             "rs",
             "the button with rs label.",
             "lw",
             "the button with lw label.",
             "rw",
             "the button with rw label.",
             "unknown",
             "unknown.",
             "aircraft",
             "the device to be paired with is an aircraft.",
             "rtk_base_station",
             "the device to be paired with is an rtk base station.",
             "unkonwn",
             "unknown.",
             "unpaired",
             "the remote controller is unpaired with the device. this state is for both aircraft and base station.",
             "pairing",
             "the remote controller is pairing with the device. this state is only for aircraft.",
             "paired",
             "the remote controller is paired. this state is only for aircraft.",
             "disconnected",
             "the remote controller is paired with the device but the connection between the device  and the remote controller is broken. the remote controller already remembers the device and the connection will receover automatically when it is possible. this state is only for base station. only supported by phantom 4 rtk.",
             "connected",
             "the remote controller is paired with the device and it is connected to the device. this state is only for base station.",
             "unknown",
             "unknown.",
             "sport",
             "set the joy stick to sport mode. only supported by mavic mini, dji mini se.",
             "position",
             "set the joy stick to position mode. only supported by mavic mini, dji mini se.",
             "tripod",
             "set the joy stick to tripod mode. only supported by mavic mini, dji mini se.",
             "unknown",
             "unknown.",
             "normal",
             "there is currently no remote controller calibration happening.",
             "middle",
             "currently recording the joystick in its center position (joystick is untouched).",
             "limits",
             "currently recording the extreme joystick positions, when joysticks are all the way to their max in any direction (left, right, up, or down).",
             "quit",
             "the remote controller is exiting calibration.",
             "top_left",
             "pip is on the screen's top left.",
             "top_right",
             "pip is on the screen's top right.",
             "bottom_left",
             "pip is on the screen's bottom left.",
             "bottom_right",
             "pip is on the screen's bottom right.",
             "unknown",
             "pip is on the screen's bottom right.",
             "ispresent",
             "`true` if the hardware button is present.  @return a boolean value.",
             "isclicked",
             "`true` if button is pressed down.  @return a boolean value.",
             "isturned",
             "`true` if dial value has changed.  @return a boolean value.",
             "getvalue",
             "dial value in the range of [-660, 660]. the value represents the difference in an operation.  @return an int value.",
             "ispresent",
             "`true` if the transformation switch present.  @return a boolean value.",
             "getstate",
             "current transformation switch state.  @return an enum value of `state`",
             "state",
             "transformation switch position states.",
             "position_one",
             "position one. for all products except mavic pro, this is the left most position of the flight mode switch on a remote controller from the perspective of the pilot. for example, on a phantom 4 remote controller,  position one is labeled a. for mavic pro, spark and mavic air, this is  the position that is furthest away from the pilot and labeled sport.",
             "position_two",
             "position two. for all products except mavic pro, this is the middle position of the flight mode switch on a remote controller from the perspective of the pilot. for example, on a phantom 4 remote controller, position two is labeled s. for mavic pro, spark and mavic air, this is the position that is closest  to the pilot (the p position).",
             "position_three",
             "position three. for all products except mavic pro, this is the right most position of the flight mode switch on a remote controller from the perspective of the pilot. for example, on a phantom 4 remote controller, position two is labeled p. mavic pro, spark or mavic air does not have  a third position for the flight mode switch.",
             "retract",
             "retract landing gear switch state.",
             "deploy",
             "deploy landing gear switch state.",
             "getverticaldirection",
             "get the movement in the vertical direction of the 5d button. up is the positive direction and down is the  negative direction.  @return an enum value of `fivedbuttondirection`",
             "gethorizontaldirection",
             "get the movement in the horizontal direction of the 5d button. right is the positive direction and left is the  negative direction.  @return an enum value of `fivedbuttondirection`",
             "fivedbuttondirection",
             "movement direction of the remote controller's 5d button.",
             "middle",
             "button has no movement in either the vertical direction or the horizontal direction.",
             "positive",
             "button is moved in the positive direction which is up or right.",
             "negative",
             "button is moved in the negative direction which is down or left.",
             "getmasterid",
             "get id of the master remote controller to join.  @return an instance of string.",
             "setmasterid",
             "set the id of the master remote controller to join.  @param masterid id of the master remote controller to join.",
             "getauthcode",
             "authentication code to join the master remote controller.  @return an instance of string.",
             "setauthcode",
             "the mobile device connected to the slave remote controller must know the authorization code of the master remote controller. the master remote controller code is set by using the `setmasterauthorizationcode` method.  @param authcode authentication code to join the master remote controller.",
             "getrcmode",
             "the master/slave mode of the remote controller.  @return an enum value of `rcmode`",
             "isconnected",
             "`true` if a slave remote controller joins a master remote controller.  @return a boolean value.",
             "getmasterid",
             "id of the master remote controller.  @return an instance of string.",
             "getslaveid",
             "id of the slave remote controller.  @return an instance of string.",
             "getauthorizationcode",
             "authorization code of the master remote controller that is a 6 element string of numbers.  @return an instance of string.",
             "master_slave_state",
             "sdk key for getauthorizationcode: authorization code of the master remote controller that is a 6 element string of numbers.  @return an instance of string.",
             "hasgimbalcontrol",
             "`true` if the remote controller has gimbal control.  call `requestgimbalcontrol` to attain the gimbal control.  @return `true` if the remote controller has gimbal control.",
             "callback",
             "callback function that updates the remote controller's master and slave state.",
             "master_slave_state",
             "sdk key for callback: callback function that updates the remote controller's master and slave state.",
             "getid",
             "remote controller's unique identifier.  @return an int value.",
             "getname",
             "remote controller's name.  @return an instance of string.",
             "getpassword",
             "remote controller's password.  @return an instance of string.",
             "getsignalquality",
             "signal quality of a connected master or slave remote controller in percent [0, 100].  @return a short value.",
             "hasgimbalcontrolpermission",
             "`true` if the slave remote controller can control the aircraft's gimbal.  always `true` for a master remote controller.  @return a boolean value to check if the slave remote controller can control the aircraft's gimbal.",
             "controlrequestcallback",
             "the callback will handle the gimbal control request.",
             "iscurrentoverloaded",
             "`true` if the battery should be discharged due to a current overload.  @return a boolean value.",
             "isoverheated",
             "`true` if the battery has overheated.  @return a boolean value.",
             "islowtemperature",
             "`true` if the battery has experienced a temperature that is too low.  @return a boolean value.",
             "isshortcircuited",
             "`true` if the battery has been or is short circuited.  @return a boolean value.",
             "iscustomdischargeenabled",
             "`true` if the battery has been configured to be discharged over a specific number of days. once the battery is fully recharged, the battery will again discharge over the number of days set here. this process is cyclical.  @return a boolean value.",
             "getlowvoltagecellindex",
             "returns the index at which one of the cells in the battery is below the normal voltage. the first cell has an index of 0.  -1 represents no battery cells under voltage. phantom series aircraft have four cell batteries. inspire series aircraft and the m100 have 6 cell batteries.  @return an int value.",
             "getdamagedcellindex",
             "returns the index at which one of the cells in the battery is damaged. the first cell has an index of 0. -1 represents no damaged battery cells. phantom 3 aircraft have 4 cell batteries. inspire series aircraft and the m100 have 6 cell batteries.  @return an int value.",
             "aggregationstate",
             "provides a real time summary of the aggregated battery system.",
             "aggregation_state",
             "sdk key for aggregationstate: provides a real time summary of the aggregated battery system.",
             "getnumberofconnectedbatteries",
             "the number of currently connected batteries.  @return an int value.",
             "number_of_connected_batteries",
             "sdk key for getnumberofconnectedbatteries: the number of currently connected batteries.  @return an int value.",
             "getbatteryoverviews",
             "returns the overview of batteries in the battery group. when a battery is not connected, the `isconnected` property is `false` and the `getchargeremaininginpercent` is zero. for matrice 600, there are 6 elements in this array.  @return the `batteryoverview` instance.",
             "overviews",
             "sdk key for getbatteryoverviews: returns the overview of batteries in the battery group. when a battery is not connected, the `isconnected` property is `false` and the `getchargeremaininginpercent` is zero. for matrice 600, there are 6 elements in this array.  @return the `batteryoverview` instance.",
             "isanybatterydisconnected",
             "`true` if one of the batteries in the group is disconnected. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "is_any_battery_disconnected",
             "sdk key for isanybatterydisconnected: `true` if one of the batteries in the group is disconnected. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "getcurrent",
             "returns the real time current draw through the batteries. a negative value means the batteries are being discharged.  @return an int value.",
             "current",
             "sdk key for getcurrent: returns the real time current draw through the batteries. a negative value means the batteries are being discharged.  @return an int value.",
             "getvoltage",
             "returns the current voltage (mv) provided by the battery group.  @return an int value.",
             "voltage",
             "sdk key for getvoltage: returns the current voltage (mv) provided by the battery group.  @return an int value.",
             "isvoltagedifferencedetected",
             "`true` if there is significant difference between the voltage (above 1.5v) of two batteries. when  `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "is_voltage_difference_detected",
             "sdk key for isvoltagedifferencedetected: `true` if there is significant difference between the voltage (above 1.5v) of two batteries. when  `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "islowcellvoltagedetected",
             "`true` if one of the batteries in the group has cells with low voltage. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "is_low_cell_voltage_detected",
             "sdk key for islowcellvoltagedetected: `true` if one of the batteries in the group has cells with low voltage. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "iscelldamaged",
             "`true` if one of the batteries in the group has damaged cells. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "is_cell_damaged",
             "sdk key for iscelldamaged: `true` if one of the batteries in the group has damaged cells. when `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "getfullchargecapacity",
             "returns the the total amount of energy, in mah (milliamp hours), stored in the batteries when the batteries are fully charged.  @return an int value.",
             "full_charge_capacity",
             "sdk key for getfullchargecapacity: returns the the total amount of energy, in mah (milliamp hours), stored in the batteries when the batteries are fully charged.  @return an int value.",
             "getchargeremaining",
             "returns the remaining energy stored in the batteries in mah (milliamp hours).  @return an int value.",
             "batterykey.charge_remaining",
             "sdk key for getchargeremaining: returns the remaining energy stored in the batteries in mah (milliamp hours).  @return an int value.",
             "getchargeremaininginpercent",
             "returns the percentage of energy left in the battery group with range [0,100].  @return an int value.",
             "batterykey.charge_remaining_in_percent",
             "sdk key for getchargeremaininginpercent: returns the percentage of energy left in the battery group with range [0,100].  @return an int value.",
             "gethighesttemperature",
             "returns the highest temperature (in celsius) among the batteries in the group, with range [-128, 127] degrees.  @return an int value.",
             "highest_temperature",
             "sdk key for gethighesttemperature: returns the highest temperature (in celsius) among the batteries in the group, with range [-128, 127] degrees.  @return an int value.",
             "isfirmwaredifferencedetected",
             "`true` if one of the batteries in the group has a firmware version different from the others. when it is `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "is_firmware_difference_detected",
             "sdk key for isfirmwaredifferencedetected: `true` if one of the batteries in the group has a firmware version different from the others. when it is `true`, the aircraft is not allowed to take off.  @return a boolean value.",
             "callback",
             "this interface provides a callback to update the current aggregated battery state.",
             "aggregation_state",
             "sdk key for callback: this interface provides a callback to update the current aggregated battery state.",
             "batteryoverview",
             "provides an overview of a battery when aircraft is using multiple batteries.",
             "overviews",
             "sdk key for batteryoverview: provides an overview of a battery when aircraft is using multiple batteries.",
             "batterystate",
             "supported by both smart and non-smart batteries, this class keeps track of the real-time state of the battery. non-smart batteries only support the following properties:  - when the connected product is a3 and n3, only `getvoltage` and `getcellvoltagelevel` are valid.  - when the connected product is a2, only `getvoltage` is valid.",
             "getfullchargecapacity",
             "returns the total amount of energy, in mah (milliamp hours), stored in the battery when the battery is fully charged. the energy of the battery at full charge changes over time as the battery continues to get used. over time, as the battery continues to be recharged, the value of `getfullchargecapacity` will decrease.  @return an int value.",
             "full_charge_capacity",
             "sdk key for getfullchargecapacity: returns the total amount of energy, in mah (milliamp hours), stored in the battery when the battery is fully charged. the energy of the battery at full charge changes over time as the battery continues to get used. over time, as the battery continues to be recharged, the value of `getfullchargecapacity` will decrease.  @return an int value.",
             "getdesigncapacity",
             "returns the design capacity of the battery in mah (milliamp hours). it is the ideal capacity when the battery is new. this value will not change over time. it is only supported by smart battery.  @return an int value.",
             "getchargeremaining",
             "returns the remaining energy stored in the battery in mah (milliamp hours).  @return an int value.",
             "batterykey.charge_remaining",
             "sdk key for getchargeremaining: returns the remaining energy stored in the battery in mah (milliamp hours).  @return an int value.",
             "getchargeremaininginpercent",
             "returns the percentage of battery energy left with range [0, 100].  @return an int value.",
             "batterykey.charge_remaining_in_percent",
             "sdk key for getchargeremaininginpercent: returns the percentage of battery energy left with range [0, 100].  @return an int value.",
             "getvoltage",
             "returns the current battery voltage (mv).  @return an int value.",
             "voltage",
             "sdk key for getvoltage: returns the current battery voltage (mv).  @return an int value.",
             "getcurrent",
             "returns the real time current draw of the battery (ma). a negative value means the battery is being discharged, and a positive value means it is being charged.  @return an int value.",
             "current",
             "sdk key for getcurrent: returns the real time current draw of the battery (ma). a negative value means the battery is being discharged, and a positive value means it is being charged.  @return an int value.",
             "getlifetimeremaining",
             "returns the battery's remaining lifetime as a percentage, with range [0, 100]. a new battery will be close to 100%. as a battery experiences charge/discharge cycles, the value will go down. in unsupported products, this value will always be 0.  these products are phantom 4 pro, inspire 2, and phantom 4 advanced.  @return an int value.",
             "lifetime_remaining",
             "sdk key for getlifetimeremaining: returns the battery's remaining lifetime as a percentage, with range [0, 100]. a new battery will be close to 100%. as a battery experiences charge/discharge cycles, the value will go down. in unsupported products, this value will always be 0.  these products are phantom 4 pro, inspire 2, and phantom 4 advanced.  @return an int value.",
             "gettemperature",
             "returns the battery's temperature, in celsius, with range [-128, 127] degrees.  @return a float value.",
             "temperature",
             "sdk key for gettemperature: returns the battery's temperature, in celsius, with range [-128, 127] degrees.  @return a float value.",
             "getnumberofdischarges",
             "returns the total number of discharges the battery has gone through over its lifetime. the total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return an int value.",
             "number_of_discharges",
             "sdk key for getnumberofdischarges: returns the total number of discharges the battery has gone through over its lifetime. the total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return an int value.",
             "getcellvoltagelevel",
             "current cell voltage level of the battery. it is only supported when the connected product is stand-alone a3 or n3.  @return an enum value of the `batterycellvoltagelevel`.",
             "cell_voltage_level",
             "sdk key for getcellvoltagelevel: current cell voltage level of the battery. it is only supported when the connected product is stand-alone a3 or n3.  @return an enum value of the `batterycellvoltagelevel`.",
             "getconnectionstate",
             "get battery connection status.  @return a connectionstate value.",
             "isbeingcharged",
             "`true` if the battery is being charged.  @return the boolean value.",
             "is_being_charged",
             "sdk key for isbeingcharged: `true` if the battery is being charged.  @return the boolean value.",
             "isinsinglebatterymode",
             "`true` if only one battery is inserted on the the right or starboard side of the aircraft. the aircraft can still take off but the flight time will be shorter. it is only supported by inspire 2: inspire 2 must always have a battery in the right/starboard slot.  @return a boolean value.",
             "is_in_single_battery_mode",
             "sdk key for isinsinglebatterymode: `true` if only one battery is inserted on the the right or starboard side of the aircraft. the aircraft can still take off but the flight time will be shorter. it is only supported by inspire 2: inspire 2 must always have a battery in the right/starboard slot.  @return a boolean value.",
             "getselfheatingstate",
             "get self-heating state of the battery. when the temperature of the battery is below 6 celsius degrees, it will warm  up automatically. it is only supported by mavic 2 enterprise.  @return an enum value of the `selfheatingstate`.",
             "callback",
             "this interface provides a callback to update the battery's current state.",
             "batterycellvoltagelevel",
             "battery cell voltage level threshold. different thresholds will initiate different aircraft behaviors or operations. level 3 is the lowest level. it is only supported when the connected product is stand-alone a3 and n3.",
             "cell_voltage_level",
             "sdk key for batterycellvoltagelevel: battery cell voltage level threshold. different thresholds will initiate different aircraft behaviors or operations. level 3 is the lowest level. it is only supported when the connected product is stand-alone a3 and n3.",
             "level_0",
             "the cell voltage is at a safe level; the aircraft can fly normally.",
             "level_1",
             "the cell voltage is equal to or lower than threshold level 1. at this level the level 1 operation will be executed. the threshold value and operation for level 1 can be configured by the user.",
             "level_2",
             "the cell voltage is equal to or lower than threshold level 2. at this level the level 2 operation will be executed. the threshold value and operation for level 2 can be configured by the user.",
             "level_3",
             "the cell voltage is equal to or lower than level 3. at this level, the aircraft will start landing. the threshold for level 3 cannot be configured by the user and is fixed at 3400mv.",
             "unknown",
             "the cell voltage level is unknown.",
             "getindex",
             "index of the battery. index starts from 0. for matrice 600, the number 1 battery compartment relates to index 0.  @return an int value.",
             "isconnected",
             "`true` if the battery is currently connected to the aircraft.  @return a boolean value.",
             "getchargeremaininginpercent",
             "the remaining percentage energy of the battery with range [0, 100].  @return an int value.",
             "connectionstate",
             "battery connection status. 0 means normal, 1 means invalid, and 2 means exception in communication.",
             "connection_state",
             "sdk key for connectionstate: battery connection status. 0 means normal, 1 means invalid, and 2 means exception in communication.",
             "normal",
             "normal.",
             "invalid",
             "invalid.",
             "exception",
             "exception.",
             "unknown",
             "unknown.",
             "setstatecallback",
             "sets the callback that updates battery state.  @param callback callback method.",
             "setaggregationstatecallback",
             "sets the callback that updates aggregated battery state.  @param callback callback method.",
             "aggregation_state",
             "sdk key for setaggregationstatecallback: sets the callback that updates aggregated battery state.  @param callback callback method.",
             "getcellvoltages",
             "gets the battery's cell voltages. there will be a voltage for each cell in the battery.  @param callback asynchronous execution result callback.",
             "cell_voltages",
             "sdk key for getcellvoltages: gets the battery's cell voltages. there will be a voltage for each cell in the battery.  @param callback asynchronous execution result callback.",
             "getnumberofcells",
             "returns the number of battery cells.  @return an int value.",
             "number_of_cells",
             "sdk key for getnumberofcells: returns the number of battery cells.  @return an int value.",
             "setnumberofcells",
             "when the connected battery is not a smart battery, the number of cells needs to be set manually. the flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. the valid range is [3, 12] cells.  @param numberofcells number of cells inside the battery. @param callback asynchronous execution result callback.",
             "number_of_cells",
             "sdk key for setnumberofcells: when the connected battery is not a smart battery, the number of cells needs to be set manually. the flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. the valid range is [3, 12] cells.  @param numberofcells number of cells inside the battery. @param callback asynchronous execution result callback.",
             "issmartbattery",
             "`true` if the battery is a smart battery. when the connected battery is a dji smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
             "is_smart_battery",
             "sdk key for issmartbattery: `true` if the battery is a smart battery. when the connected battery is a dji smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
             "pairbatteries",
             "a battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. when multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  to optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. the operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. this method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getpairingstate` can then be used to determine if the installed battery combination is a previously assigned pair or not. batteries can be repaired.  @param callback completion callback that receives the execution result.",
             "batterykey.pair_batteries",
             "sdk key for pairbatteries: a battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. when multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  to optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. the operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. this method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getpairingstate` can then be used to determine if the installed battery combination is a previously assigned pair or not. batteries can be repaired.  @param callback completion callback that receives the execution result.",
             "getpairingstate",
             "a battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. when multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  to optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. the operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. this method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback callback that receives the pairing state.",
             "batterykey.pairing_state",
             "sdk key for getpairingstate: a battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. when multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  to optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. the operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. this method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback callback that receives the pairing state.",
             "getmanufacturedate",
             "gets the manufacture date of current battery. it it only supported by matrice 300 rtk.  @param callback the execution callback with the returned value(s).",
             "setlevel1cellvoltagethreshold",
             "sets the level 1 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 1 behavior will be executed. the valid range is [3600, 4000] mv. when the new value is not 100 mv higher than the level 2 cell voltage threshold, the level 2 threshold will be set to (new value - 100) mv.  @param voltage level 1 cell voltage threshold to set in mv. @param callback completion block that receives the setter execution result.",
             "level_1_cell_voltage_threshold",
             "sdk key for setlevel1cellvoltagethreshold: sets the level 1 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 1 behavior will be executed. the valid range is [3600, 4000] mv. when the new value is not 100 mv higher than the level 2 cell voltage threshold, the level 2 threshold will be set to (new value - 100) mv.  @param voltage level 1 cell voltage threshold to set in mv. @param callback completion block that receives the setter execution result.",
             "getlevel1cellvoltagethreshold",
             "gets the level 1 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 1 behavior will be executed. the valid range is [3600, 4000] mv.  @param callback asynchronous execution result callback that contains the voltage threshold.",
             "level_1_cell_voltage_threshold",
             "sdk key for getlevel1cellvoltagethreshold: gets the level 1 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 1 behavior will be executed. the valid range is [3600, 4000] mv.  @param callback asynchronous execution result callback that contains the voltage threshold.",
             "setlevel2cellvoltagethreshold",
             "sets the level 2 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 2 behavior will be executed. the valid range is [3500, 3800] mv and must be at least 100 mv lower than the level 1 voltage threshold.  @param voltage level 2 cell voltage threshold to set in mv. @param callback asynchronous execution result callback.",
             "level_2_cell_voltage_threshold",
             "sdk key for setlevel2cellvoltagethreshold: sets the level 2 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 2 behavior will be executed. the valid range is [3500, 3800] mv and must be at least 100 mv lower than the level 1 voltage threshold.  @param voltage level 2 cell voltage threshold to set in mv. @param callback asynchronous execution result callback.",
             "getlevel2cellvoltagethreshold",
             "gets the level 2 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 2 behavior will be executed.  @param callback asynchronous execution result callback that contains the voltage threshold.",
             "level_2_cell_voltage_threshold",
             "sdk key for getlevel2cellvoltagethreshold: gets the level 2 cell voltage threshold in mv. when the cell voltage of the battery crosses below the threshold, level 2 behavior will be executed.  @param callback asynchronous execution result callback that contains the voltage threshold.",
             "setlevel1cellvoltagebehavior",
             "sets the behavior that will be executed when the cell voltage crosses under the level 1 threshold. it can only be set when the motors are off.  @param behavior level 1 behavior. @param callback completion block that receives the setter execution result.",
             "level_1_cell_voltage_behavior",
             "sdk key for setlevel1cellvoltagebehavior: sets the behavior that will be executed when the cell voltage crosses under the level 1 threshold. it can only be set when the motors are off.  @param behavior level 1 behavior. @param callback completion block that receives the setter execution result.",
             "getlevel1cellvoltagebehavior",
             "gets the behavior that will be executed when the cell voltage crosses under the level 1 threshold.  @param callback asynchronous execution result callback that contains the voltage threshold behavior.",
             "level_1_cell_voltage_behavior",
             "sdk key for getlevel1cellvoltagebehavior: gets the behavior that will be executed when the cell voltage crosses under the level 1 threshold.  @param callback asynchronous execution result callback that contains the voltage threshold behavior.",
             "setlevel2cellvoltagebehavior",
             "sets the operation that will be executed when the cell voltage crosses under level 2 threshold. it can only be set when motors are off.  @param behavior level 2 behavior. @param callback asynchronous execution result callback.",
             "level_2_cell_voltage_behavior",
             "sdk key for setlevel2cellvoltagebehavior: sets the operation that will be executed when the cell voltage crosses under level 2 threshold. it can only be set when motors are off.  @param behavior level 2 behavior. @param callback asynchronous execution result callback.",
             "getlevel2cellvoltagebehavior",
             "sets the behavior that will be executed when the cell voltage crosses under the level 2 threshold. it is not supported by mavic air.  @param callback asynchronous execution result callback that contains the voltage threshold behavior.",
             "level_2_cell_voltage_behavior",
             "sdk key for getlevel2cellvoltagebehavior: sets the behavior that will be executed when the cell voltage crosses under the level 2 threshold. it is not supported by mavic air.  @param callback asynchronous execution result callback that contains the voltage threshold behavior.",
             "setledsenabled",
             "enables/disables the led lights on the batteries. if all batteries' leds on the aircraft are turned off, the aircraft's power button led indicator should be off. it's supported only by matrice 300 rtk.  @param enabled `true` to enable the led lights on the batteries. @param callback completion callback that receives the setter execution result.",
             "getledsenabled",
             "determines if the leds on the battery is on. if all batteries' leds on the aircraft are turned off, the aircraft's power button led indicator should be off. it's supported only by matrice 300 rtk.  @param callback the execution callback with the returned value(s).",
             "getbatterytype",
             "determines if the battery is the correct type in current area.  @param callback the execution callback with the returned value(s).",
             "getlatestwarningrecord",
             "gets the battery's most recent warning record. anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback asynchronous execution result callback that contains the latest warning record.",
             "latest_warning_record",
             "sdk key for getlatestwarningrecord: gets the battery's most recent warning record. anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback asynchronous execution result callback that contains the latest warning record.",
             "getwarningrecords",
             "gets the battery's warning records, which are kept for 30 days using objects of type warningrecord</code>. call the issmartbattery()</code> method before using this method. not supported by osmo and non-smart batteries.  @param callback asynchronous execution result callback that contains the batteries warning records.",
             "historical_warning_records",
             "sdk key for getwarningrecords: gets the battery's warning records, which are kept for 30 days using objects of type warningrecord</code>. call the issmartbattery()</code> method before using this method. not supported by osmo and non-smart batteries.  @param callback asynchronous execution result callback that contains the batteries warning records.",
             "setselfdischargeindays",
             "smart batteries can be setup to automatically discharge over a custom period of time. this method sets the battery's self discharge period in days with range [1, 10]. for inspire 2 and m200 series products, the max range value can be 20. not supported by mavic air 2, dji air 2s, non-smart batteries, spark and the osmo series.  @param days day for self-discharge @param callback asynchronous execution result callback.",
             "self_discharge_in_days",
             "sdk key for setselfdischargeindays: smart batteries can be setup to automatically discharge over a custom period of time. this method sets the battery's self discharge period in days with range [1, 10]. for inspire 2 and m200 series products, the max range value can be 20. not supported by mavic air 2, dji air 2s, non-smart batteries, spark and the osmo series.  @param days day for self-discharge @param callback asynchronous execution result callback.",
             "getselfdischargeindays",
             "smart batteries can be setup to automatically discharge over a custom period of time. this method gets the battery's self discharge period in days with range [1, 10]. for inspire 2 and m200 series products, the max range value can be 20. not supported by non-smart batteries and the osmo series.  @param callback asynchronous execution result callback that contains the number of days to discharge over.",
             "self_discharge_in_days",
             "sdk key for getselfdischargeindays: smart batteries can be setup to automatically discharge over a custom period of time. this method gets the battery's self discharge period in days with range [1, 10]. for inspire 2 and m200 series products, the max range value can be 20. not supported by non-smart batteries and the osmo series.  @param callback asynchronous execution result callback that contains the number of days to discharge over.",
             "warningrecord",
             "used to keep a record of any unusual battery statues in the past 30 discharges. for all the properties below, monitor these values frequently to ensure the battery's state is normal. if any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> note: no automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
             "latest_warning_record",
             "sdk key for warningrecord: used to keep a record of any unusual battery statues in the past 30 discharges. for all the properties below, monitor these values frequently to ensure the battery's state is normal. if any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> note: no automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
             "historical_warning_records",
             "sdk key for warningrecord: used to keep a record of any unusual battery statues in the past 30 discharges. for all the properties below, monitor these values frequently to ensure the battery's state is normal. if any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> note: no automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
             "lowvoltagebehavior",
             "defines aircraft's behavior when the cell voltage is low.",
             "level_1_cell_voltage_behavior",
             "sdk key for lowvoltagebehavior: defines aircraft's behavior when the cell voltage is low.",
             "level_2_cell_voltage_behavior",
             "sdk key for lowvoltagebehavior: defines aircraft's behavior when the cell voltage is low.",
             "pairingstate",
             "battery pairing state for batteries that can be paired.",
             "batterykey.pairing_state",
             "sdk key for pairingstate: battery pairing state for batteries that can be paired.",
             "selfheatingstate",
             "provides the self-heating state for the battery. when the temperature of the battery is below a threshold, it will warm up automatically. for mavic 2 enterprise, the self-heating is triggered when the temperature is lower than 6 celsius degrees. when the temperature reaches 8 celsius degrees, the battery will start to preserve the temperature and maintain it between 6 celsius degrees and 8 celsius degrees.",
             "idle",
             "the auto heating feature is idle.",
             "warming_up",
             "the battery is warming itself up automatically.",
             "preserving",
             "the battery is preserving its temperature. for mavic 2 enterprise, the temperature will be maintained between 6 celsius degrees and 8 celsius degrees.",
             "unknown",
             "unknown.",
             "smartbatterytype",
             "defines smart battery type.",
             "other",
             "the smart battery type is other.",
             "mavic_mini_japan",
             "the smart battery type is mavic mini japan, which is legal to use in japan.",
             "unknown",
             "the smart battery type is unknown.",
             "flash_led",
             "led lights go into warning mode.",
             "go_home",
             "return-to-home.",
             "land",
             "land aircraft immediately.",
             "unknown",
             "unknown.",
             "unpaired",
             "the batteries didn't match; they're not paired.",
             "paired",
             "batteries are paired.",
             "unknown",
             "can't get the pair state or the batteries.",
             "onupdate",
             "callback to update battery state.  @param batterystate the battery's state.",
             "onupdate",
             "callback to update aggregated battery state.  @param aggregationstate the aggregated battery state.",
             "aggregation_state",
             "sdk key for onupdate: callback to update aggregated battery state.  @param aggregationstate the aggregated battery state.",
             "setuplinksignalqualitycallback",
             "define a callback to listen for updates on the uplink signal. this link transfers all information from the remote controller to the  aircraft, which is predominantly control information. the callback will be updated when the signal quality changed.  @param callback the `signalqualitycallback` interface.",
             "setdownlinksignalqualitycallback",
             "define a callback to listen for updates on the downlink signal. this link transfers all information from aircraft to remote controller,  which is predominantly video information. signal quality is a function of signal strength, interference and data rate. signal quality  will be more susceptible to weak signal strengths or high interference when the data rate is high.  @param callback the `signalqualitycallback` interface.",
             "setcountrycodecallback",
             "sets the callback for countrycode update.  @param countrycodecallback the `countrycodecallback` interface.",
             "addbasestationsignalqualityupdatedcallback",
             "adds the callback for base station signal quality update.  @param callback the `basestationsignalqualityupdatedcallback` interface.",
             "removebasestationsignalqualityupdatedcallback",
             "removes the callback for base station signal quality update.  @param callback the `basestationsignalqualityupdatedcallback` interface.",
             "islightbridgelinksupported",
             "`true` if lightbridge air link is supported.  @return a boolean value.",
             "is_lightbridge_link_supported",
             "sdk key for islightbridgelinksupported: `true` if lightbridge air link is supported.  @return a boolean value.",
             "getlightbridgelink",
             "returns the lightbridge air link if it is available.  @return an instance of `lightbridgelink`.",
             "isocusynclinksupported",
             "`true` if the ocusync link is supported. ocusync link is only supported by mavic pro.  @return a boolean value.",
             "getocusynclink",
             "returns the ocusync link if it is available.  @return an instance of `ocusynclink`.",
             "iswifilinksupported",
             "`true` if wifi air link is supported.  @return a boolean value.",
             "is_wifi_link_supported",
             "sdk key for iswifilinksupported: `true` if wifi air link is supported.  @return a boolean value.",
             "getwifilink",
             "returns the wifi air link if it is available.  @return an instance of `wifilink`.",
             "updatecountrycode",
             "update/sync the latest countrycode to the dji product.  @param callback the execution callback with the returned execution result.",
             "isupdatecountrycoderequired",
             "checks if we need to update country code to the dji product.  @return `true` if the country code is required to update.",
             "setautoupdatecountrycodeenabled",
             "enable/disable automatic update countrycode feature.  @param enabled `true` to enable auto update of the country code.",
             "getautoupdatecountrycodeenabled",
             "determines if auto update country code is enabled. when it is enabled, sdk will update the country  code to the aircraft automatically when it is required. it is enabled by default and the value is  stored persistently on the device.  @return `true` if auto update country code is enabled.",
             "signalqualitycallback",
             "updated signal quality in percent for the wireless link. signal quality is a function of signal strength, interference and data rate. signal  quality will be more susceptible to weak signal strengths or high  interference when the data rate is high.",
             "countrycodecallback",
             "callback for countrycode related features.",
             "basestationsignalqualityupdatedcallback",
             "callback for updated signal quality in percent for the base station (from remote controller  to the base station). this link transfers all information between the remote controller and  the base station, which is predominantly positioning information.",
             "lightbridgelink",
             "this class contains methods to change settings of the lightbridge air link.",
             "ocusynclink",
             "this class contains methods to change ocusync link settings.",
             "wifilink",
             "this class provides methods to change the setting of the product's wifi. rebooting wifi is required in order to make new settings take effect.",
             "onupdate",
             "update signal quality.  @param quality the signal quality in percent with range [0, 100], where 100 is the best quality.",
             "onrequireupdatecountrycode",
             "invokes when countrycode changes and needs to be updated with dji product.",
             "onbasestationsignalqualityupdated",
             "invokes when base station signal quality changes.  @param quality an int value of the signal quality.",
             "setmagneticinterferencecallback",
             "sets up the callback for wifi magnetic interference level.  @param callback the execution callback with the value(s) returned.",
             "setchannelinterferencecallback",
             "setter for rssi callback  @param channelinterferencecallback your implementation of `channelinterferencecallback`.",
             "channel_interference",
             "sdk key for setchannelinterferencecallback: setter for rssi callback  @param channelinterferencecallback your implementation of `channelinterferencecallback`.",
             "reboot",
             "reboot wifi to enable new settings to take effect.  @param callback the execution callback with the value(s) returned.",
             "reboot",
             "sdk key for reboot: reboot wifi to enable new settings to take effect.  @param callback the execution callback with the value(s) returned.",
             "setssid",
             "sets the wifi ssid. the setting will take effect only after the product reboots.  @param ssid the wifi ssid to change. it should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback remote execution result error callback.",
             "ssid",
             "sdk key for setssid: sets the wifi ssid. the setting will take effect only after the product reboots.  @param ssid the wifi ssid to change. it should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback remote execution result error callback.",
             "getssid",
             "gets the wifi ssid.  @param callback the execution callback with the returned value(s).",
             "ssid",
             "sdk key for getssid: gets the wifi ssid.  @param callback the execution callback with the returned value(s).",
             "setpassword",
             "sets the wifi password.  @param password the new wifi password. it must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback remote execution result error callback.",
             "airlinkkey.password",
             "sdk key for setpassword: sets the wifi password.  @param password the new wifi password. it must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback remote execution result error callback.",
             "getpassword",
             "get the wifi password.  @param callback the execution callback with the returned value(s).",
             "airlinkkey.password",
             "sdk key for getpassword: get the wifi password.  @param callback the execution callback with the returned value(s).",
             "setfrequencyband",
             "it is not supported by spark, mavic air and dji mini 2. for these products, set different channel  numbers to select the frequency band.  @param frequencyband wifi frequency band to change to. @param callback the execution callback with the value(s) returned.",
             "wifi_frequency_band",
             "sdk key for setfrequencyband: it is not supported by spark, mavic air and dji mini 2. for these products, set different channel  numbers to select the frequency band.  @param frequencyband wifi frequency band to change to. @param callback the execution callback with the value(s) returned.",
             "getfrequencyband",
             "gets the current wifi frequency band. it is not supported by spark or mavic air.  @param callback the execution callback with the returned value(s).",
             "wifi_frequency_band",
             "sdk key for getfrequencyband: gets the current wifi frequency band. it is not supported by spark or mavic air.  @param callback the execution callback with the returned value(s).",
             "setselectionmode",
             "sets the channel selection mode. both channel number and bandwidth can be changed.  if the 5 ghz band is available,  then channels from that band can also be used. .  @param mode selection mode to set. @param callback the execution callback with the returned value(s).",
             "getselectionmode",
             "gets the channel selection mode. .  @param callback the execution callback with the returned value(s).",
             "setchannelnumber",
             "sets the wifi channel. `setchannelnumber`  must be used to determine which channels are possible to set. when a new channel is set,  the wifi on the product will reboot. the channel can only be changed when the product is not flying. supported by mavic pro, mavic mini, dji mini se.  @param channelnumber index of the channel to select. @param callback the execution callback with the returned execution result.",
             "channel_number",
             "sdk key for setchannelnumber: sets the wifi channel. `setchannelnumber`  must be used to determine which channels are possible to set. when a new channel is set,  the wifi on the product will reboot. the channel can only be changed when the product is not flying. supported by mavic pro, mavic mini, dji mini se.  @param channelnumber index of the channel to select. @param callback the execution callback with the returned execution result.",
             "getchannelnumber",
             "gets the wifi channel. channels 1-13 are in the 2.4 ghz band. other channels are in the 5 ghz band.  @param callback the execution callback with the returned value(s).",
             "channel_number",
             "sdk key for getchannelnumber: gets the wifi channel. channels 1-13 are in the 2.4 ghz band. other channels are in the 5 ghz band.  @param callback the execution callback with the returned value(s).",
             "getavailablechannelnumbers",
             "gets the channels available for the current frequency band. when `frequency_band_dual` is  selected, channels for both 2.4ghz and 5ghz are available. supported only by mavic pro, mavic mini, dji mini se.  @param callback the completion block with the returned execution result.",
             "available_channel_numbers",
             "sdk key for getavailablechannelnumbers: gets the channels available for the current frequency band. when `frequency_band_dual` is  selected, channels for both 2.4ghz and 5ghz are available. supported only by mavic pro, mavic mini, dji mini se.  @param callback the completion block with the returned execution result.",
             "setdatarate",
             "sets the wifi data rate (throughput). higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. it is not supported by spark or mavic air.  @param rate data rate (throughput). @param callback the execution callback with the value(s) returned.",
             "data_rate",
             "sdk key for setdatarate: sets the wifi data rate (throughput). higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. it is not supported by spark or mavic air.  @param rate data rate (throughput). @param callback the execution callback with the value(s) returned.",
             "getdatarate",
             "gets the current data rate (throughput). it is not supported by spark or mavic air.  @param callback the execution callback with the returned value(s).",
             "data_rate",
             "sdk key for getdatarate: gets the current data rate (throughput). it is not supported by spark or mavic air.  @param callback the execution callback with the returned value(s).",
             "magneticinterferencecallback",
             "this interface provides a method to receive the updated wifi signal quality.",
             "channelinterferencecallback",
             "callback to listen to any changes in interference levels for channels that are not being used for communication.",
             "wififrequencyband",
             "wifi frequency band.",
             "wifi_frequency_band",
             "sdk key for wififrequencyband: wifi frequency band.",
             "wifichannelinterference",
             "the interference power of a wifi channel.",
             "channel_interference",
             "sdk key for wifichannelinterference: the interference power of a wifi channel.",
             "frequency_band_only_2_dot_4",
             "the wifi frequency band is 2.4 ghz.",
             "frequency_band_5_ghz",
             "the wifi frequency band is 5 ghz.",
             "frequency_band_dual",
             "dual frequency band mode. the wifi frequency band can be either 2.4 ghz or 5 ghz.",
             "unknown",
             "the wifi frequency is unknown.",
             "wifimagneticinterferencelevel",
             "wifi magnetic interference - as measured by osmo, phantom 3 4k and phantom 3 standard.",
             "magnetic_interference",
             "sdk key for wifimagneticinterferencelevel: wifi magnetic interference - as measured by osmo, phantom 3 4k and phantom 3 standard.",
             "low",
             "wifi magnetic interference is low.",
             "medium",
             "wifi magnetic interference is medium. at this level, the video quality will be degraded compared to when the signal quality is low.",
             "high",
             "wifi magnetic interference is high. at this level, the video quality will be degraded compared to when the signal quality is medium.",
             "unknown",
             "wifi magnetic interference is unknown.",
             "data_rate",
             "sdk key for unknown: wifi magnetic interference is unknown.",
             "wifidatarate",
             "wifi data rate. lower rates are used for longer ranges, but will have lower video quality.",
             "data_rate",
             "sdk key for wifidatarate: wifi data rate. lower rates are used for longer ranges, but will have lower video quality.",
             "rate_1_mbps",
             "1 mbps.",
             "rate_2_mbps",
             "2 mbps.",
             "rate_4_mbps",
             "4 mbps.",
             "unknown",
             "unknown.",
             "getpower",
             "the interference power with range from [-60, -100] dbm. a smaller, more negative value represents less interference and better communication quality.  @return an int value of the interference power.",
             "getchannel",
             "the channel index.  @return an int value of the channel index.",
             "getband",
             "the frequency band that the channel belongs to.  @return a value of `wififrequencyband` enum.",
             "onresult",
             "updates the wifi signal quality.  @param level the wifi magnetic interference level.",
             "onupdate",
             "this will be invoked when there is a change in rssi. interference power of the available channels.  @param channelinterferences an array of all the current rssis.",
             "setvideodataratecallback",
             "sets the callback for videodatarateupdatedcallback.  @param videodataratecallback an interface of `videodataratecallback`.",
             "setwarningmessagescallback",
             "sets the callback for receivedwarningmessagecallback.  @param warningmessagescallback your implementation of `warningmessagescallback`.",
             "setchannelinterferencecallback",
             "sets the frequencyinterferenceupdatedcallback.  @param callback your implementation of `channelinterferencecallback`.",
             "setchannelselectionmode",
             "sets the channel selection mode. both channel number and bandwidth can be changed. if the 5 ghz band is available,  then channels from that band can also be used.  @param mode selection mode to set. @param callback the execution callback with the returned execution result.",
             "channel_selection_mode",
             "sdk key for setchannelselectionmode: sets the channel selection mode. both channel number and bandwidth can be changed. if the 5 ghz band is available,  then channels from that band can also be used.  @param mode selection mode to set. @param callback the execution callback with the returned execution result.",
             "getchannelselectionmode",
             "gets the channel selection mode.  @param callback the execution callback with the value(s) returned.",
             "channel_selection_mode",
             "sdk key for getchannelselectionmode: gets the channel selection mode.  @param callback the execution callback with the value(s) returned.",
             "setocusyncmagneticinterferencelevelcallback",
             "set the callback of `callback`.  @param callback your implementation of `callback`.",
             "setchannelbandwidth",
             "sets the channel bandwidth of the ocusync link. it can be set only when the selection mode is  `manual`. for mavic air 2, dji air 2s, only supported bandwidth with 20mb.  @param bandwidth bandwidth to set. @param callback the execution callback with the returned execution result.",
             "bandwidth",
             "sdk key for setchannelbandwidth: sets the channel bandwidth of the ocusync link. it can be set only when the selection mode is  `manual`. for mavic air 2, dji air 2s, only supported bandwidth with 20mb.  @param bandwidth bandwidth to set. @param callback the execution callback with the returned execution result.",
             "getchannelbandwidth",
             "gets the channel bandwidth of the ocusync link.  @param callback the execution callback with the returned value(s).",
             "bandwidth",
             "sdk key for getchannelbandwidth: gets the channel bandwidth of the ocusync link.  @param callback the execution callback with the returned value(s).",
             "setchannelnumber",
             "selects the channel number. the ocusync link operates on a  10 mhz or 20 mhz channel between 2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the  band. therefore for a 10 mhz bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1  mhz to 2477.5 mhz. for a 20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the  channel location within the band is specified using the channel number. channel number is defined as the integer  of 0.5 mhz less than the channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered  at 2406.5 mhz (this is only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel  number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth).  use `getchannelnumbervalidrange` to check the valid channel numbers for a given bandwidth. channel  number can only be set when the channel selection mode is `manual`.  @param channelnumber channel number to set ocusync channel to. @param callback callback that receives the setter result.",
             "frequency_point_index",
             "sdk key for setchannelnumber: selects the channel number. the ocusync link operates on a  10 mhz or 20 mhz channel between 2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the  band. therefore for a 10 mhz bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1  mhz to 2477.5 mhz. for a 20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the  channel location within the band is specified using the channel number. channel number is defined as the integer  of 0.5 mhz less than the channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered  at 2406.5 mhz (this is only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel  number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth).  use `getchannelnumbervalidrange` to check the valid channel numbers for a given bandwidth. channel  number can only be set when the channel selection mode is `manual`.  @param channelnumber channel number to set ocusync channel to. @param callback callback that receives the setter result.",
             "getchannelnumber",
             "gets the current ocusync link channel number. the ocusync link operates on a 10 mhz or 20 mhz channel between  2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the band. therefore for a 10 mhz  bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1 mhz to 2477.5 mhz. for a  20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the channel location within  the band is specified using the channel number. channel number is defined as the integer of 0.5 mhz less than the  channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered at 2406.5 mhz (this is  only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth).  @param callback completion block that receives the getter result.",
             "frequency_point_index",
             "sdk key for getchannelnumber: gets the current ocusync link channel number. the ocusync link operates on a 10 mhz or 20 mhz channel between  2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the band. therefore for a 10 mhz  bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1 mhz to 2477.5 mhz. for a  20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the channel location within  the band is specified using the channel number. channel number is defined as the integer of 0.5 mhz less than the  channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered at 2406.5 mhz (this is  only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth).  @param callback completion block that receives the getter result.",
             "getchannelnumbervalidrange",
             "gets the valid range of channel numbers. the ocusync link operates on a 10 mhz or 20 mhz channel between  2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the band. therefore for a 10 mhz  bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1 mhz to 2477.5 mhz. for a  20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the channel location within  the band is specified using the channel number. channel number is defined as the integer of 0.5 mhz less than the  channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered at 2406.5 mhz (this is  only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth). this method should be used to confirm the channel number  to be set with `setchannelnumber` is valid.  @param callback the execution callback with the returned value(s).",
             "frequency_point_index_valid_range",
             "sdk key for getchannelnumbervalidrange: gets the valid range of channel numbers. the ocusync link operates on a 10 mhz or 20 mhz channel between  2400.5 mhz and 2482.5 mhz. the channel can be centered at 1 mhz steps within the band. therefore for a 10 mhz  bandwidth, the ocusync channel can be centered at 2405.5 mhz, 2406.5 mhz and every 1 mhz to 2477.5 mhz. for a  20 mhz bandwidth, channel center can be at 2410.5 mhz to 2472.5 mhz in 1 mhz steps. the channel location within  the band is specified using the channel number. channel number is defined as the integer of 0.5 mhz less than the  channel center frequency. e.g. channel number 2406 represents the 10 mhz channel centered at 2406.5 mhz (this is  only for the 10 mhz bandwidth as 20 mhz bandwidth channels start at 2410.5 mhz). channel number 2450 represents the channel centered at 2450.5 mhz (of any bandwidth). this method should be used to confirm the channel number  to be set with `setchannelnumber` is valid.  @param callback the execution callback with the returned value(s).",
             "getsupportedfrequencybands",
             "gets the frequency bands supported by the product in the current area. it is supported by p4p v2 and mavic 2 series. for  mavic pro, only 2.4ghz is supported.  @param callback the execution callback with the value(s) returned.",
             "ocusync_supported_frequency_bands",
             "sdk key for getsupportedfrequencybands: gets the frequency bands supported by the product in the current area. it is supported by p4p v2 and mavic 2 series. for  mavic pro, only 2.4ghz is supported.  @param callback the execution callback with the value(s) returned.",
             "setfrequencyband",
             "sets the ocusync air link frequency band. it is only supported by phantom 4 pro v2 and mavic 2 series. for mavic pro,  the frequency band is always 2.4 ghz. not supported by mavic air 2.  @param frequencyband frequency band to change to. @param callback the execution callback with the value(s) returned.",
             "getfrequencyband",
             "gets the ocusync air link frequency band. it is only supported by phantom 4 pro v2 and mavic 2 series. for mavic pro, the frequency band is always 2.4 ghz.  @param callback the execution callback with the value(s) returned.",
             "setbandwidthallocationforprimaryvideo",
             "sets the percentage of the primary video bandwidth. the remaining percentage is dedicated to the secondary video. the primary source can only be `left_cam` or `right_cam`.  the secondary source can be `left_cam`, `right_cam`  and `fpv_cam`. it is only supported by m200 series v2.  @param percent percentage downlink bandwidth for the primary video feed. @param callback the execution callback with the value(s) returned.",
             "getbandwidthallocationforprimaryvideo",
             "when a product has multiple main cameras, this method gets the percentage bandwidth allocation dedicated to the primary video. the remaining percentage is dedicated  to the secondary video. it is only supported by m200 series v2.  @param callback the execution callback with the value(s) returned.",
             "assignsourcetoprimarychannel",
             "assign the primary video and the secondary video source. it can be supported by m200 series v2 and matrice 300 rtk. on m200 series v2, the primary source only can  be `left_cam` or `fpv_cam`. the secondary  source can be `left_cam`, `right_cam`  and `fpv_cam`. on matrice 300 rtk, both primary and secondary sources can  be `left_cam`, `right_cam`, `top_cam`  and `fpv_cam`, if you just want to use one video source , you should set the secondary souce with `unknown`.  @param primarysource the primary video source. @param secondarysource the secondary video source. @param callback the execution callback with the value(s) returned.",
             "closeallvideosources",
             "stops all video streaming if there is any active source. it is only supported by matrice 300 rtk.  @param callback the execution callback with the value(s) returned.",
             "videodataratecallback",
             "updated data rate in mbps for the wireless downlink (from aircraft to remote controller). this link transfers all information from aircraft to remote controller, which is predominantly video information.",
             "warningmessagescallback",
             "updated ocusync link warning messages. this delegate method is called only when there are new warning messages on  the ocusync link (either uplink or downlink). if the array has no elements, then all previous warning messages are  no longer in effect.",
             "channelinterferencecallback",
             "updated power for interference signals with frequencies in the 2.4 ghz (2400mhz to 2482 mhz) frequency band incident  on the remote controller. note, measuring the interference reduces effective data rate as the radio is spending time listening to frequencies outside of the communication channel. interference measurements will only be made if  the `setchannelinterferencecallback` property in ocusynclink is assigned to a method that  implements this callback.",
             "frequencyinterference",
             "this class represents the power spectral density of a frequency slice. only supported by mavic pro.",
             "frequency_point_rssis",
             "sdk key for frequencyinterference: this class represents the power spectral density of a frequency slice. only supported by mavic pro.",
             "ocusyncwarningmessage",
             "ocusync link warning messages.",
             "warning_messages",
             "sdk key for ocusyncwarningmessage: ocusync link warning messages.",
             "frequencyfrom",
             "start frequency.",
             "frequencyto",
             "stop frequency.",
             "rssi",
             "signal strength within the band defined by the start and stop frequencies.",
             "ocusyncfrequencyband",
             "the frequency bands for ocusync.",
             "ocusync_frequency_band",
             "sdk key for ocusyncfrequencyband: the frequency bands for ocusync.",
             "ocusync_supported_frequency_bands",
             "sdk key for ocusyncfrequencyband: the frequency bands for ocusync.",
             "frequency_band_2_dot_4_ghz",
             "the frequency band is 2.4 ghz.",
             "frequency_band_5_dot_8_ghz",
             "the frequency band is 5.8 ghz.",
             "frequency_band_dual",
             "dual frequency band mode. the frequency band can be either 2.4 ghz or 5 ghz.",
             "unknown",
             "unknown.",
             "ocusyncbandwidth",
             "the channel bandwidth for the ocusync downlink (from the aircraft to the remote controller). setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
             "bandwidth",
             "sdk key for ocusyncbandwidth: the channel bandwidth for the ocusync downlink (from the aircraft to the remote controller). setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
             "bandwidth20mhz",
             "the frequency band of the ocusync link is 20 mhz (up to 46 mbps).",
             "bandwidth10mhz",
             "the frequency band of the ocusync link is 10 mhz (up to 23 mbps).",
             "bandwidth40mhz",
             "the frequency band of the ocusync link is 40 mhz (up to 80 mbps).  only supported by matrice 300 rtk.",
             "unknown",
             "unknown frequency band.",
             "strong_take_off_interference",
             "warning that interference is high for take-off. when the signal gets weaker as separation between remote  controller and aircraft get larger, there is a change the link will fail.",
             "strong_down_link_interference",
             "there is strong interference on the downlink signal incident on the remote controller. if the channel selection  mode  `manual` is being used, consider changing to   `auto` as the ocusync link can automatically select  channel numbers and bandwidth to mitigate interference on the fly.",
             "strong_up_link_interference",
             "there is strong interference on the uplink signal incident on the aircraft.",
             "weak_signal",
             "weak ocusync signal strength. be aware of anything blocking the signal between the remote controller and aircraft,  adjust the orientation of the antennas on the remote controller, or reduce the distance between remote controller  and aircraft to increase signal strength.",
             "aircraft_link_reboot",
             "the ocusync link on the aircraft is rebooting.",
             "up_link_broken",
             "the uplink from the remote controller to the aircraft is broken. usually if only the uplink disconnects, it is due  to interference on the aircraft's ocusync antennas. try changing the channel number if the interference source  cannot be removed.",
             "down_link_broken",
             "the downlink from the aircraft to the remote controller is broken. usually if only the downlink disconnects, it is  due to interference on the remote controller's ocusync antennas. try changing channel number, or reducing the bandwidth of the channel to make it more robust.",
             "link_unusable",
             "the link between the remote controller and the aircraft is unusable. it is determined to be unusable if signal is  too weak. check to see if the antennas are setup correctly and the path from remote controller to aircraft is unobstructed.",
             "ocusyncmagneticinterferencelevel",
             "ocusync link magnetic interference level.",
             "none",
             "there is no detected ocusync link magnetic interference.",
             "low",
             "there is a low level of detected ocusync link magnetic interference.",
             "medium",
             "there is a medium level of detected ocusync link magnetic interference.",
             "high",
             "there is a high level of detected ocusync link magnetic interference.",
             "unknown",
             "the level of the detected ocusync link magnetic interference is currently unknown.",
             "callback",
             "callback interface for ocusyncmagneticinterferencelevel.",
             "onupdate",
             "updates the ocusync signal quality. it is only supported by mavic pro, mavic 2 series.  @param level the level of ocu magnetic interference level.",
             "onupdate",
             "updated data rate in mbps for the wireless downlink (from aircraft to remote controller). this link transfers  all information from aircraft to remote controller, which is predominantly video information.  @param newvalue the data rate of the downlink in mbps.",
             "onreceive",
             "updated ocusync link warning messages. this delegate method is called only when there are new warning messages  on the ocusync link (either uplink or downlink). if the array has no elements, then all previous warning  messages are no longer in effect.  @param messages the array of `ocusyncwarningmessage` representation of the current warning messages.",
             "onupdate",
             "updated power for interference signals with frequencies in the 2.4 ghz (2400mhz to 2482 mhz) frequency band  incident on the remote controller. note, measuring the interference reduces effective data rate as the radio  is spending time listening to frequencies outside of the communication channel.  @param rssis the updated interference information. the elements in the array  of `frequencyinterference` objects each hold interference information about a small  part of the frequency band. elements are sorted by increasing frequency.",
             "setchannelselectionmode",
             "sets the downlink channel selection mode (automatic or manual).  @param mode channel selection mode for the air link. @param callback the execution callback with the execution result returned.",
             "channel_selection_mode",
             "sdk key for setchannelselectionmode: sets the downlink channel selection mode (automatic or manual).  @param mode channel selection mode for the air link. @param callback the execution callback with the execution result returned.",
             "getchannelselectionmode",
             "gets the downlink channel selection mode.  @param callback the execution callback with the value(s) returned.",
             "channel_selection_mode",
             "sdk key for getchannelselectionmode: gets the downlink channel selection mode.  @param callback the execution callback with the value(s) returned.",
             "getchannelrange",
             "gets the channels available for the current frequency band.  @param callback the execution callback with the value(s) returned.",
             "channel_range",
             "sdk key for getchannelrange: gets the channels available for the current frequency band.  @param callback the execution callback with the value(s) returned.",
             "setchannelnumber",
             "sets the fixed downlink channel. channel selection mode should be set  to `manual`. the valid range  of channel can be obtained from `getchannelrange`.  @param channelnumber specific channel for the air link. @param callback the execution callback with the execution result returned.",
             "channel_number",
             "sdk key for setchannelnumber: sets the fixed downlink channel. channel selection mode should be set  to `manual`. the valid range  of channel can be obtained from `getchannelrange`.  @param channelnumber specific channel for the air link. @param callback the execution callback with the execution result returned.",
             "getchannelnumber",
             "gets current downlink channel of air link.  @param callback the execution callback with the value(s) returned.",
             "channel_number",
             "sdk key for getchannelnumber: gets current downlink channel of air link.  @param callback the execution callback with the value(s) returned.",
             "setdatarate",
             "sets the downlink data rate (throughput). higher data rates increase the quality of video transmission, but can  only be used at shorter ranges.  @param rate fixed rate (throughput). @param callback the execution callback with the execution result returned.",
             "getdatarate",
             "gets the current downlink data rate (throughput).  @param callback the execution callback with the value(s) returned.",
             "settransmissionmode",
             "sets fpv video quality vs latency preference. this mode only affects the fpv camera and not the camera on the hd gimbal.  @param mode quality vs latency tradeoff for the fpv video @param callback the execution callback with the execution result returned.",
             "transmission_mode",
             "sdk key for settransmissionmode: sets fpv video quality vs latency preference. this mode only affects the fpv camera and not the camera on the hd gimbal.  @param mode quality vs latency tradeoff for the fpv video @param callback the execution callback with the execution result returned.",
             "gettransmissionmode",
             "gets fpv video quality vs latency preference. this mode only affects the fpv camera and not the camera on the hd gimbal.  @param callback the execution callback with the value(s) returned.",
             "transmission_mode",
             "sdk key for gettransmissionmode: gets fpv video quality vs latency preference. this mode only affects the fpv camera and not the camera on the hd gimbal.  @param callback the execution callback with the value(s) returned.",
             "setbandwidthallocationforlbvideoinputport",
             "sets the percentage downlink video bandwidth dedicated to the video  feed from one of the lb input ports. the remaining percentage is dedicated  to the video feed from ext input port. setting 100% dedicates all the video bandwidth to lb.  @param percent percentage downlink bandwidth for video feed from lb port. @param callback the execution callback with the execution result returned.",
             "bandwidth_allocation_for_lb_video_input_port",
             "sdk key for setbandwidthallocationforlbvideoinputport: sets the percentage downlink video bandwidth dedicated to the video  feed from one of the lb input ports. the remaining percentage is dedicated  to the video feed from ext input port. setting 100% dedicates all the video bandwidth to lb.  @param percent percentage downlink bandwidth for video feed from lb port. @param callback the execution callback with the execution result returned.",
             "getbandwidthallocationforlbvideoinputport",
             "gets the percentage downlink video bandwidth dedicated to the video feed from one of  the lb input ports. the remaining percentage is dedicated to the video feed from ext input port.  @param callback the execution callback with the value(s) returned.",
             "bandwidth_allocation_for_lb_video_input_port",
             "sdk key for getbandwidthallocationforlbvideoinputport: gets the percentage downlink video bandwidth dedicated to the video feed from one of  the lb input ports. the remaining percentage is dedicated to the video feed from ext input port.  @param callback the execution callback with the value(s) returned.",
             "setbandwidthallocationformaincamera",
             "sets the percentage downlink video bandwidth dedicated to the main camera or main cameras (for  m210 and m210 rtk). the remaining percentage is dedicated to the fpv camera. for m210 and m210  rtk, the bandwidth for main cameras can be further divided by calling  `setbandwidthallocationforleftcamera`. it is only supported by inspire 2  and m200 series.  @param percent percentage downlink bandwidth for main camera(s). @param callback the execution callback with the value(s) returned.",
             "getbandwidthallocationformaincamera",
             "gets the percentage downlink video bandwidth dedicated to the main camera or main cameras  (for m210 and m210 rtk). the remaining percentage is dedicated to the fpv camera. it is  only supported by inspire 2 and m200 series.  @param callback the execution callback with the value(s) returned.",
             "setbandwidthallocationforleftcamera",
             "sets the percentage of the main cameras' bandwidth dedicated to the left camera. the remaining percentage  is dedicated to the right camera. the main cameras' bandwidth is determined by  `setbandwidthallocationformaincamera`.  this setting will influence the physical sources  of video feeds (`getprimaryvideofeed` and `getsecondaryvideofeed`):  - when  bandwidth is 100% on the left camera, the primary source is `left_cam` and the secondary source is `fpv_cam`.  - when bandwidth 0% on  the left camera, the primary source is `right_cam` and the secondary  source is `fpv_cam`.  - when bandwidth is neither 0% nor 100% on  the left camera, the primary source is `left_cam` and the secondary  source is `right_cam`. it is only supported by m210 and m210 rtk.  @param percent percentage downlink bandwidth for fpv camera. @param callback the execution callback with the value(s) returned.",
             "getbandwidthallocationforleftcamera",
             "when a product has multiple main cameras, this method gets the percentage bandwidth allocation  dedicated to the port (left) camera. the remaining percentage is dedicated to the starboard  (right) camera. the total bandwidth allocated to both main cameras (vs the fpv camera) is  determined by `setbandwidthallocationformaincamera`.  this setting will  influence the physical sources of video feeds (`getprimaryvideofeed`  and `getsecondaryvideofeed`):  - when bandwidth is 100% on the left camera,  the primary source is `left_cam` and the secondary source is `fpv_cam`.  - when bandwidth is 0% on the left camera, the primary source is  `right_cam` and the secondary source  is `fpv_cam`.  - when bandwidth is  neither 0% nor 100% on the left camera, the primary source is  `left_cam` and the secondary source is  `right_cam`.  it is only supported  by m210 and m210 rtk.  @param callback the execution callback with the value(s) returned.",
             "isdualencodemodesupported",
             "`true` if lightbridge 2 device supports dual encode mode. dual encode mode allows the  lightbridge module to encode and transmit both it's av and hdmi inputs simultaneously.  @return a boolean value.",
             "setextvideoinputportenabled",
             "sets lightbridge 2 encode mode. it is only available when `isdualencodemodesupported` returns  `true`. for lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled the encode mode to set. @param callback the execution callback with the execution result returned.",
             "is_ext_video_input_port_enabled",
             "sdk key for setextvideoinputportenabled: sets lightbridge 2 encode mode. it is only available when `isdualencodemodesupported` returns  `true`. for lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled the encode mode to set. @param callback the execution callback with the execution result returned.",
             "getextvideoinputportenabled",
             "gets lightbridge 2 encode mode. it is only available when `isdualencodemodesupported` returns  `true`. for lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback the execution callback with the value(s) returned.",
             "is_ext_video_input_port_enabled",
             "sdk key for getextvideoinputportenabled: gets lightbridge 2 encode mode. it is only available when `isdualencodemodesupported` returns  `true`. for lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback the execution callback with the value(s) returned.",
             "setbandwidthallocationforhdmivideoinputport",
             "sets the computational power and bandwidth balance between av and hdmi inputs on the lightbridge 2 module when  dual encode mode is enabled. balance is in percent [0.0,  1.0]. it is only available  when `isdualencodemodesupported` returns `true`. when percent</code> is 0.0,  all resources are allocated for video data from av port. when percent</code> is 1.0, all resources are allocated for video data from hdmi port.  @param percent percentage resources dedicated to hdmi encoding and transmission. @param callback the execution callback with the execution result returned.",
             "bandwidth_allocation_for_hdmi_video_input_port",
             "sdk key for setbandwidthallocationforhdmivideoinputport: sets the computational power and bandwidth balance between av and hdmi inputs on the lightbridge 2 module when  dual encode mode is enabled. balance is in percent [0.0,  1.0]. it is only available  when `isdualencodemodesupported` returns `true`. when percent</code> is 0.0,  all resources are allocated for video data from av port. when percent</code> is 1.0, all resources are allocated for video data from hdmi port.  @param percent percentage resources dedicated to hdmi encoding and transmission. @param callback the execution callback with the execution result returned.",
             "getbandwidthallocationforhdmivideoinputport",
             "gets the computational power and bandwidth balance between av and hdmi inputs on the lightbridge 2 module when  dual encode mode is enabled. it is only available when `isdualencodemodesupported` returns  `true`. when percent</code> is 0.0, all resources are allocated for video data from av  port. when percent</code> is 1.0, all resources are allocated for video data from hdmi port.  @param callback the execution callback with the value(s) returned.",
             "bandwidth_allocation_for_hdmi_video_input_port",
             "sdk key for getbandwidthallocationforhdmivideoinputport: gets the computational power and bandwidth balance between av and hdmi inputs on the lightbridge 2 module when  dual encode mode is enabled. it is only available when `isdualencodemodesupported` returns  `true`. when percent</code> is 0.0, all resources are allocated for video data from av  port. when percent</code> is 1.0, all resources are allocated for video data from hdmi port.  @param callback the execution callback with the value(s) returned.",
             "getsupportedfrequencybands",
             "gets the frequency bands supported by the product in the current area. it is only supported by inspire 2 and  phantom 4 pro. for the other products with lb air link, the frequency band is always 2.4 ghz.  @param callback the execution callback with the value(s) returned.",
             "lb_supported_frequency_bands",
             "sdk key for getsupportedfrequencybands: gets the frequency bands supported by the product in the current area. it is only supported by inspire 2 and  phantom 4 pro. for the other products with lb air link, the frequency band is always 2.4 ghz.  @param callback the execution callback with the value(s) returned.",
             "setfrequencyband",
             "sets the lb air link frequency band. it is only supported by inspire 2 and phantom 4 pro. for the other products  with lb air link, the frequency band is always 2.4 ghz.  @param frequencyband lbairlink frequency band to change to. @param callback the execution callback with the value(s) returned.",
             "lb_frequency_band",
             "sdk key for setfrequencyband: sets the lb air link frequency band. it is only supported by inspire 2 and phantom 4 pro. for the other products  with lb air link, the frequency band is always 2.4 ghz.  @param frequencyband lbairlink frequency band to change to. @param callback the execution callback with the value(s) returned.",
             "getfrequencyband",
             "gets the lb air link frequency band. it is only supported by inspire 2 and phantom 4 pro. for the other products  with lb air link, the frequency band is always 2.4 ghz.  @param callback the execution callback with the value(s) returned.",
             "lb_frequency_band",
             "sdk key for getfrequencyband: gets the lb air link frequency band. it is only supported by inspire 2 and phantom 4 pro. for the other products  with lb air link, the frequency band is always 2.4 ghz.  @param callback the execution callback with the value(s) returned.",
             "channelinterference",
             "the interference power of a lbairlink channel.",
             "getpower",
             "the interference power with range from [-60, -100] dbm. a smaller, more negative value represents less  interference and better communication quality.  @return an int value.",
             "getchannel",
             "the channel number. different frequency bands have different channel index ranges.  @return an int value.",
             "lightbridgefrequencyband",
             "lbairlink frequency band. supported only by phantom 4 professional.",
             "lb_frequency_band",
             "sdk key for lightbridgefrequencyband: lbairlink frequency band. supported only by phantom 4 professional.",
             "lb_supported_frequency_bands",
             "sdk key for lightbridgefrequencyband: lbairlink frequency band. supported only by phantom 4 professional.",
             "frequency_band_2_dot_4_ghz",
             "the lbairlink frequency band is 2.4 ghz.",
             "frequency_band_5_dot_7_ghz",
             "the lbairlink frequency band is 5.7 ghz.",
             "frequency_band_5_dot_8_ghz",
             "the lbairlink frequency band is 5.8 ghz.",
             "unknown",
             "the lbairlink frequency is unknown.",
             "channelselectionmode",
             "downlink channel selection mode (manual or automatic) for the wireless link.",
             "channel_selection_mode",
             "sdk key for channelselectionmode: downlink channel selection mode (manual or automatic) for the wireless link.",
             "auto",
             "air link will automatically select the best physical channel based on the signal environment.",
             "manual",
             "manually select the physical channel.",
             "unknown",
             "unknown physical channel selection mode.",
             "lightbridgetransmissionmode",
             "fpv(first-person view) video can prioritize either quality or latency.",
             "transmission_mode",
             "sdk key for lightbridgetransmissionmode: fpv(first-person view) video can prioritize either quality or latency.",
             "high_quality",
             "high quality priority.",
             "low_latency",
             "low latency priority.",
             "unknown",
             "unknown.",
             "lightbridgedatarate",
             "wireless downlink data rate. lower rates are used for longer ranges, but will have lower video quality.",
             "bandwidth_4_mbps",
             "4 mbps (potential range up to 3 km)",
             "bandwidth_6_mbps",
             "6 mbps (potential range up to 2 km)",
             "bandwidth_8_mbps",
             "8 mbps (potential range up to 1.5 km)",
             "bandwidth_10_mbps",
             "10 mbps (potential range up to 0.7 km)",
             "unknown",
             "unknown.",
             "lightbridgeantennarssi",
             "rssi object (received signal strength indicator).",
             "remote_controller_antenna_rssi",
             "sdk key for lightbridgeantennarssi: rssi object (received signal strength indicator).",
             "aircraft_antenna_rssi",
             "sdk key for lightbridgeantennarssi: rssi object (received signal strength indicator).",
             "getantenna1",
             "antenna1 rssi value  @return an int value of antenna rssi.",
             "getantenna2",
             "antenna2 rssi value  @return an int value of antenna rssi.",
             "setaircraftantennarssicallback",
             "set callback to receive rssi information on each antenna of aircraft.  @param callback the interface of `antennarssicallback`.",
             "aircraft_antenna_rssi",
             "sdk key for setaircraftantennarssicallback: set callback to receive rssi information on each antenna of aircraft.  @param callback the interface of `antennarssicallback`.",
             "setremotecontrollerantennarssicallback",
             "set callback to receive rssi information on each antenna of remote controller.  @param callback the interface of `antennarssicallback`.",
             "remote_controller_antenna_rssi",
             "sdk key for setremotecontrollerantennarssicallback: set callback to receive rssi information on each antenna of remote controller.  @param callback the interface of `antennarssicallback`.",
             "onupdate",
             "method called when antenna rssi information has updated.  @param antennarssi an instance of `lightbridgeantennarssi`.",
             "setchannelinterferencecallback",
             "sets up the djilbairlinkupdatedallchannelinterferencecallback.  @param callback the `channelinterferencecallback`.",
             "onresult",
             "signal strength of all signals present on all available downlink channels. signals  that are not the communication signal are considered interference.  @param channelinterferences the updated interference information. the elements in the array  of `channelinterference` objects each hold the  interference signal strength of a channel. elements are sorted by increasing  channel number.",
             "antennarssicallback",
             "callback of antenna rssi information for each antenna.",
             "channelinterferencecallback",
             "callback of signal strength of all signals present on all available downlink channels. signals that are not the  communication signal are considered interference.",
             "onvaluechange",
             "the callback, called every time the value behind a key is updated.  @param oldvalue the old value. `null` if no value was present before. @param newvalue the new value. `null` if the stored values are being flushed.",
             "getvalue",
             "returns the latest known value if available for the key.  does not pull it from the product if unavailable.  @param key an instance of `djikey`.  @return the value associated with the key.",
             "getvalue",
             "performs a get on a gettable key, pulling the information from the product if necessary.  @param key a valid gettable key @param callback a valid get callback.",
             "setvalue",
             "performs a set on a settable key, changing attributes on the  connected product.  @param value a value object relevant to the given key @param key a valid settable key @param callback a set callback.",
             "performaction",
             "performs an action on an actionable key.  @param key a valid actionable key @param arguments optional arguments relevant to the specific key @param callback an action callback.",
             "addlistener",
             "subscribes the listener object to all changes of value on the given  key.  @param key a valid value-based key (get, set and/or action) @param listener a valid object to hold the subscription",
             "removelistener",
             "stops the subscription to updates of a specific key value for a  specific listener. does not affect other listeners subscribing to  this key or other subscriptions of the `listener`.  @param listener the listener object passed at the moment of calling startlistening.",
             "iskeysupported",
             "determines if a key is supported by the connected product.  @param key key to be check on current product.  @return `true` if the key is supported.",
             "removekey",
             "remove a key's cache value.  @param key key to be removed on current product.",
             "create",
             "creates an airlink key.  @param paramkey a valid paramkey.  @return airlink key",
             "createwifilinkkey",
             "creates a wifilink key. the `wifilinkparamkey` values are listed below: reboot, downlink_signal_quality, uplink_signal_quality, magnetic_interference, channel_interference, channel_number, available_channel_numbers, ssid, password, wifi_frequency_band, data_rate  @param paramkey a valid paramkey.  @return wifilink key",
             "createlightbridgelinkkey",
             "creates a lblink key. the `lightbridgelinkparamkey` values are listed below: bandwidth_allocation_for_hdmi_video_input_port, is_ext_video_input_port_enabled, bandwidth_allocation_for_lb_video_input_port, channel_interference, channel_number, data_rate, secondary_video_output_enabled, secondary_video_output_port, secondary_video_display_mode, secondary_video_osd_enabled, secondary_video_osd_top_margin, secondary_video_osd_left_margin, secondary_video_osd_bottom_margin, secondary_video_osd_right_margin, secondary_video_osd_unit, hdmi_output_format, sdi_output_format, pip_position, channel_selection_mode, uplink_signal_quality, downlink_signal_quality, aircraft_antenna_rssi, remote_controller_antenna_rssi, channel_range, supported_frequency_bands, transmission_mode, lb_frequency_band, bandwidth_allocation_for_left_camera  @param paramkey a valid paramkey.  @return lblink key",
             "createocusynclinkkey",
             "creates an ocusynclink key. the `ocusynclinkparamkey` values are listed below: uplink_signal_quality, downlink_signal_quality, bandwidth, dynamic_data_rate, frequency_point_index, frequency_point_index_valid_range, frequency_point_rssis, warning_messages, channel_selection_mode  @param paramkey a valid paramkey.  @return ocusynclink key",
             "create",
             "creates an accessoryaggregation key.  @param paramkey a valid paramkey  @return accessoryaggregation key",
             "create",
             "creates an accessoryaggregation key.  @param paramkey a valid paramkey @param componentindex the index of the accessoryaggregation component.  @return accessoryaggregation key",
             "createspeakerkey",
             "creates a speaker key.  @param paramkey a valid paramkey.  @return speaker key.",
             "createspotlightkey",
             "creates a spotlight key.  @param paramkey a valid paramkey.  @return speaker key.",
             "createbeaconkey",
             "creates a beacon key.  @param paramkey a valid paramkey.  @return beacon key.",
             "create",
             "creates a battery key.  @param paramkey a valid paramkey.  @return battery key",
             "create",
             "creates a battery key at selected index. use this when the product supports multiple batteries.  @param paramkey a valid paramkey. @param componentindex the index of the battery component.  @return battery key",
             "createbatteryaggregationkey",
             "creates a battery aggregation key.  @param paramkey a valid paramkey.  @return an object of `batterykey`.",
             "create",
             "creates a camera key.  @param paramkey a valid paramkey.  @return camera key",
             "create",
             "creates a camera key at selected index. use this when the product supports multiple cameras.  @param paramkey a valid paramkey. @param componentindex the index of the camera component.  @return camera key",
             "createlenskey",
             "creates a lens key at selected component index and subcomponent index. use this when the product supports camera which has multi lens.  @param paramkey a valid paramkey. @param componentindex the index of the camera component. @param subcomponentindex the index of the camera subcomponent.  @return camera key",
             "create",
             "creates a flightcontroller key.  @param paramkey a valid paramkey.  @return flightcontroller key",
             "createflightassistantkey",
             "creates a flightassistant key. the `intelligentflightassistantparamkey` values are listed below: collision_avoidance_enabled, vision_assisted_positioning_enabled, is_braking, vision_system_warning, detection_sectors, vision_detection_state, active_track_mode, active_track_circular_speed, active_track_gps_assistant_enabled, active_track_gesture_mode_enabled, draw_status, draw_heading_mode, upwards_avoidance_enabled, landing_protection_enabled, precision_landing_enabled, landing_protection_state, set_active_track_camera, active_obstacle_avoidance_enabled, intelligent_flight_assistant_ghavoid_enabled, intelligent_flight_assistant_is_useravoid_enable, is_avoiding_active_obstacle_collision, is_ascent_limited_by_obstacle, is_performing_precision_landing, advanced_gesture_control_enabled  @param paramkey a valid paramkey.  @return flightassistant key",
             "creatertkkey",
             "creates a rtk key.  @param paramkey a valid paramkey.  @return rtk key.",
             "createaccesslockerkey",
             "creates a accesslocker key.  @param paramkey a valid paramkey.  @return accesslocker key.",
             "create",
             "creates a gimbal key.  @param paramkey a valid paramkey.  @return gimbal key",
             "create",
             "creates a product key.  @param paramkey a valid paramkey.  @return product key",
             "create",
             "creates a remotecontrollerkey key.  @param paramkey a valid paramkey.  @return remote controller key",
             "create",
             "creates a handheldcontroller key.  @param paramkey a valid paramkey.  @return handheld controller key",
             "create",
             "creates a diagnostics key.  @param paramkey a valid paramkey.  @return diagnostics key",
             "djikey",
             "base class of all keys to be used with the keyed interface and the `keymanager`.",
             "batterykey",
             "`batterykey` is a key dedicated to accessing battery related attributes.",
             "camerakey",
             "`camerakey` is an object dedicated to providing access to camera  related attributes.",
             "flightcontrollerkey",
             "`flightcontrollerkey` provides dedicated access to flight  controller attributes.",
             "radarkey",
             "`radarkey` provides dedicated access to radar attributes.",
             "payloadkey",
             "`payloadkey` provides dedicated access to flight  controller attributes.",
             "gimbalkey",
             "`gimbalkey` is an object providing access to gimbal attributes.",
             "productkey",
             "`productkey` represent keys which are global to the whole product.",
             "remotecontrollerkey",
             "`remotecontrollerkey` provides dedicated access to remote controller attributes.",
             "handheldcontrollerkey",
             "`handheldcontrollerkey` provides dedicated access to all handheld  controller attributes.",
             "airlinkkey",
             "`airlinkkey` provides dedicated access to all communication  to the product attributes.",
             "accessoryaggregationkey",
             "`accessoryaggregationkey` provides dedicated access to accessories related attributes.",
             "lidarkey",
             "`lidarkey` provides dedicated access to the lidar attributes.",
             "basestationkey",
             "`basestationkey` provides dedicated access to the base station attributes.",
             "create",
             "creates an basestation key.  @param paramkey a valid paramkey.  @return basestation key.",
             "diagnosticskey",
             "`diagnosticskey` provides various diagnostics information.",
             "getcallback",
             "callback called when performing a get on a key.",
             "onsuccess",
             "invoked when getting process is done successfully.  @param value the value returned back.",
             "onfailure",
             "invoked when getting process has failed.  @param error the error that occurred.",
             "setcallback",
             "callback called when performing a set on a key.",
             "onsuccess",
             "invoked when setting process is done successfully.",
             "onfailure",
             "invoked when setting process has failed.  @param error the error that occurred.",
             "actioncallback",
             "callback called when performing an action on a key.",
             "onsuccess",
             "invoked when the action is done successfully.",
             "onfailure",
             "invoked when the action has failed.  @param error the error that occurred.",
             "keylistener",
             "interface to check if the value behind a key is updated.",
             "is_ext_video_input_port_enabled",
             "sdk key description",
             "uplink_signal_quality",
             "sdk key description",
             "bandwidth_allocation_for_primary_video",
             "sdk key description",
             "channel_range",
             "sdk key description",
             "password",
             "sdk key description",
             "disabled_image_transmission",
             "sdk key description",
             "ocusync_frequency_band",
             "sdk key description",
             "eid_broadcast_enable",
             "sdk key description",
             "channel_interference",
             "sdk key description",
             "ssid",
             "sdk key description",
             "warning_messages",
             "sdk key description",
             "bandwidth_allocation_for_left_camera",
             "sdk key description",
             "other_role_video_cameras",
             "sdk key description",
             "ocusync_video_cameras",
             "sdk key description",
             "available_channel_numbers",
             "sdk key description",
             "lb_data_rate",
             "sdk key description",
             "remote_controller_antenna_rssi",
             "sdk key description",
             "frequency_point_rssis",
             "sdk key description",
             "assign_source_to_primary_channel",
             "sdk key description",
             "aircraft_antenna_rssi",
             "sdk key description",
             "left_camera_type",
             "sdk key description",
             "lb_channel",
             "sdk key description",
             "wifi_frequency_band",
             "sdk key description",
             "magnetic_interference",
             "sdk key description",
             "right_camera_type",
             "sdk key description",
             "downlink_signal_quality",
             "sdk key description",
             "reboot",
             "sdk key description",
             "secondary_video_feed_physical_source",
             "sdk key description",
             "master_live_video_camera",
             "sdk key description",
             "ocusync_supported_frequency_bands",
             "sdk key description",
             "sdr_interference",
             "sdk key description",
             "primary_video_priority",
             "sdk key description",
             "hd_offset_param_values",
             "sdk key description",
             "primary_video_feed_physical_source",
             "sdk key description",
             "fpv_camera_type",
             "sdk key description",
             "is_1_dot_4_g_supported",
             "sdk key description",
             "is_lightbridge_link_supported",
             "sdk key description",
             "bandwidth_allocation_for_lb_video_input_port",
             "sdk key description",
             "lb_frequency_band",
             "sdk key description",
             "frequency_point_index",
             "sdk key description",
             "frequency_point_index_valid_range",
             "sdk key description",
             "channel_selection_mode",
             "sdk key description",
             "top_camera_type",
             "sdk key description",
             "data_rate",
             "sdk key description",
             "lb_supported_frequency_bands",
             "sdk key description",
             "transmission_mode",
             "sdk key description",
             "is_dual_band_supported",
             "sdk key description",
             "hd_dist_offset",
             "sdk key description",
             "dynamic_data_rate",
             "sdk key description",
             "country_code",
             "sdk key description",
             "bandwidth_allocation_for_hdmi_video_input_port",
             "sdk key description",
             "is_5_dot_7_g_supported",
             "sdk key description",
             "selection_mode",
             "sdk key description",
             "channel_number",
             "sdk key description",
             "is_wifi_link_supported",
             "sdk key description",
             "available_camera_video_streams",
             "sdk key description",
             "bandwidth",
             "sdk key description",
             "yaw_right_endpoint",
             "sdk key description",
             "pitch_controller_smoothing_factor",
             "sdk key description",
             "start_balance_detection",
             "sdk key description",
             "is_attitude_reset",
             "sdk key description",
             "firmware_version",
             "sdk key description",
             "roll_motor_control_gyro_filtering_factor",
             "sdk key description",
             "rotate",
             "sdk key description",
             "yaw_motor_control_pre_control",
             "sdk key description",
             "balance_state",
             "sdk key description",
             "is_calibrating",
             "sdk key description",
             "motor_enabled",
             "sdk key description",
             "yaw_angle_with_aircraft_in_degree",
             "sdk key description",
             "apply_motor_control_preset",
             "sdk key description",
             "concentricity_check_result",
             "sdk key description",
             "pitch_smooth_track_deadband",
             "sdk key description",
             "yaw_smooth_track_enabled",
             "sdk key description",
             "is_motor_over_loaded",
             "sdk key description",
             "is_gimbal_on_top",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "fine_tune_roll_in_degrees",
             "sdk key description",
             "start_calibration",
             "sdk key description",
             "is_yaw_at_stop",
             "sdk key description",
             "toggle_selfie",
             "sdk key description",
             "roll_motor_control_pre_control",
             "sdk key description",
             "pitch_down_endpoint",
             "sdk key description",
             "pitch_motor_control_gyro_filtering_factor",
             "sdk key description",
             "mode",
             "sdk key description",
             "is_testing_balance",
             "sdk key description",
             "yaw_controller_deadband",
             "sdk key description",
             "yaw_left_endpoint",
             "sdk key description",
             "capabilities",
             "sdk key description",
             "yaw_controller_smoothing_factor",
             "sdk key description",
             "stiffness_self_tuning_result",
             "sdk key description",
             "roll_motor_control_stiffness",
             "sdk key description",
             "connection",
             "sdk key description",
             "movement_settings_profile",
             "sdk key description",
             "roll_fine_tune_in_degrees",
             "sdk key description",
             "pitch_motor_control_strength",
             "sdk key description",
             "yaw_smooth_track_speed",
             "sdk key description",
             "calibration_progress",
             "sdk key description",
             "start_control_parameters_auto_tuning",
             "sdk key description",
             "yaw_inverted_control_enabled",
             "sdk key description",
             "pitch_motor_control_pre_control",
             "sdk key description",
             "roll_test_result",
             "sdk key description",
             "is_stuck",
             "sdk key description",
             "pitch_controller_deadband",
             "sdk key description",
             "gimbal_attitude_synchronization_enabled",
             "sdk key description",
             "fine_tune_pitch_in_degrees",
             "sdk key description",
             "pitch_controller_speed_coefficient",
             "sdk key description",
             "reset_gimbal_with_parameters",
             "sdk key description",
             "start_concentricity_detection",
             "sdk key description",
             "start_balance_test",
             "sdk key description",
             "controller_mode",
             "sdk key description",
             "pitch_range_extension_enabled",
             "sdk key description",
             "is_roll_at_stop",
             "sdk key description",
             "balance_check_result",
             "sdk key description",
             "reset_gimbal_yaw",
             "sdk key description",
             "is_pitch_at_stop",
             "sdk key description",
             "display_name",
             "sdk key description",
             "fine_tune_yaw_in_degrees",
             "sdk key description",
             "pitch_up_endpoint",
             "sdk key description",
             "stop_balance_detection",
             "sdk key description",
             "yaw_motor_control_gyro_filtering_factor",
             "sdk key description",
             "roll_motor_control_strength",
             "sdk key description",
             "pitch_fine_tune_in_degrees",
             "sdk key description",
             "pitch_inverted_control_enabled",
             "sdk key description",
             "stop_control_parameters_auto_tuning",
             "sdk key description",
             "pitch_test_result",
             "sdk key description",
             "yaw_smooth_track_deadband",
             "sdk key description",
             "yaw_fine_tune_in_degrees",
             "sdk key description",
             "yaw_motor_control_strength",
             "sdk key description",
             "is_mobile_device_mounted",
             "sdk key description",
             "reset_gimbal",
             "sdk key description",
             "yaw_motor_control_stiffness",
             "sdk key description",
             "yaw_controller_speed_coefficient",
             "sdk key description",
             "yaw_smooth_track_acceleration",
             "sdk key description",
             "is_calibration_successful",
             "sdk key description",
             "restore_factory_settings",
             "sdk key description",
             "pitch_smooth_track_enabled",
             "sdk key description",
             "pitch_smooth_track_speed",
             "sdk key description",
             "stop_concentricity_detection",
             "sdk key description",
             "attitude_in_degrees",
             "sdk key description",
             "yaw_simultaneous_follow_enabled",
             "sdk key description",
             "pitch_smooth_track_acceleration",
             "sdk key description",
             "reset_control_parameters",
             "sdk key description",
             "pitch_motor_control_stiffness",
             "sdk key description",
             "system_status",
             "sdk key description",
             "radar_obstacle_avoidance_state",
             "sdk key description",
             "connection",
             "sdk key description",
             "radar_upwards_obstacle_avoidance_enabled",
             "sdk key description",
             "radar_horizontal_obstacle_avoidance_enabled",
             "sdk key description",
             "component_key",
             "sdk key description",
             "model_name",
             "sdk key description",
             "firmware_package_version",
             "sdk key description",
             "has_remote_controller",
             "sdk key description",
             "connection",
             "sdk key description",
             "is_osmo",
             "sdk key description",
             "set_master_auth_code",
             "sdk key description",
             "custom_button_1",
             "sdk key description",
             "multi_rc_gimbals_control_auth_owner",
             "sdk key description",
             "focus_controller_is_working",
             "sdk key description",
             "shutter_button",
             "sdk key description",
             "remote_controller_calibration_b_axis_status",
             "sdk key description",
             "is_master_slave_mode_v4_supported",
             "sdk key description",
             "secondary_video_osd_top_margin",
             "sdk key description",
             "rc_upgrade_voice_disable",
             "sdk key description",
             "gimbal_mapping_style",
             "sdk key description",
             "secondary_video_osd_right_margin",
             "sdk key description",
             "remote_controller_calibration_d_axis_status",
             "sdk key description",
             "custom_button_2",
             "sdk key description",
             "second_charge_remaining",
             "sdk key description",
             "select_button_profile_group",
             "sdk key description",
             "aircraft_mapping_style",
             "sdk key description",
             "switch_rc_state",
             "sdk key description",
             "right_stick_value",
             "sdk key description",
             "secondary_video_display_mode",
             "sdk key description",
             "remote_controller_unit",
             "sdk key description",
             "fetch_customized_action_of_button",
             "sdk key description",
             "pip_position",
             "sdk key description",
             "firmware_version",
             "sdk key description",
             "master_list",
             "sdk key description",
             "stop_multi_device_pairing",
             "sdk key description",
             "pause_button",
             "sdk key description",
             "is_master_slave_mode_v2_supported",
             "sdk key description",
             "go_home_button",
             "sdk key description",
             "multi_rc_lost_notice",
             "sdk key description",
             "secondary_video_osd_enabled",
             "sdk key description",
             "secondary_video_osd_unit",
             "sdk key description",
             "get_master_auth_code",
             "sdk key description",
             "is_master_slave_mode_v3_supported",
             "sdk key description",
             "shutter_button_binding_enabled",
             "sdk key description",
             "request_legacy_gimbal_control",
             "sdk key description",
             "right_dial",
             "sdk key description",
             "custom_gimbal_mapping",
             "sdk key description",
             "record_button_binding_enabled",
             "sdk key description",
             "button_profile_groups",
             "sdk key description",
             "connect_to_master",
             "sdk key description",
             "connected_master_credentials",
             "sdk key description",
             "five_d_button",
             "sdk key description",
             "slave_remote_controller_stick_mode",
             "sdk key description",
             "focus_controller_direction",
             "sdk key description",
             "remote_controller_calibration_e_axis_status",
             "sdk key description",
             "stop_master_searching",
             "sdk key description",
             "country_code",
             "sdk key description",
             "stop_pairing",
             "sdk key description",
             "multi_devices_pairing_state",
             "sdk key description",
             "multi_rc_rcs_online_state",
             "sdk key description",
             "left_stick_value",
             "sdk key description",
             "rc_index",
             "sdk key description",
             "remote_controller_calibration_number_of_segment",
             "sdk key description",
             "slave_list",
             "sdk key description",
             "multi_rc_apps_online_state",
             "sdk key description",
             "customize_button",
             "sdk key description",
             "shake_motor",
             "sdk key description",
             "battery_state",
             "sdk key description",
             "remote_controller_calibration_g_axis_status",
             "sdk key description",
             "name",
             "sdk key description",
             "focus_controller_control_type",
             "sdk key description",
             "remove_button_profile_group",
             "sdk key description",
             "record_button",
             "sdk key description",
             "pairing_state",
             "sdk key description",
             "master_searching_state",
             "sdk key description",
             "is_focus_controller_supported",
             "sdk key description",
             "rename_button_profile_group",
             "sdk key description",
             "gimbal_control_speed_coefficient",
             "sdk key description",
             "secondary_video_osd_left_margin",
             "sdk key description",
             "gps_data",
             "sdk key description",
             "secondary_video_output_port",
             "sdk key description",
             "reset_button_config",
             "sdk key description",
             "multi_rc_control_authority_surpass",
             "sdk key description",
             "left_dial",
             "sdk key description",
             "start_pairing",
             "sdk key description",
             "custom_button_tags",
             "sdk key description",
             "function_button",
             "sdk key description",
             "remote_controller_calibration_c_axis_status",
             "sdk key description",
             "flight_mode_switch_position",
             "sdk key description",
             "is_master_slave_mode_supported",
             "sdk key description",
             "multi_rc_rcs_count",
             "sdk key description",
             "master_slave_state",
             "sdk key description",
             "multi_rc_apps_count",
             "sdk key description",
             "secondary_video_osd_bottom_margin",
             "sdk key description",
             "aircraft_custom_mapping",
             "sdk key description",
             "button_config",
             "sdk key description",
             "rc_master_slave_open",
             "sdk key description",
             "start_search_master",
             "sdk key description",
             "available_masters",
             "sdk key description",
             "calibration_state",
             "sdk key description",
             "rc_has_gimbal_control",
             "sdk key description",
             "sdi_output_format",
             "sdk key description",
             "hdmi_output_format",
             "sdk key description",
             "request_gimbal_control",
             "sdk key description",
             "secondary_video_output_enabled",
             "sdk key description",
             "remote_controller_calibration_a_axis_status",
             "sdk key description",
             "start_multi_device_pairing",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "playback_button",
             "sdk key description",
             "is_charge_remaining_low",
             "sdk key description",
             "rtk_channel_enable",
             "sdk key description",
             "response_to_request_for_gimbal_control",
             "sdk key description",
             "mode",
             "sdk key description",
             "display_name",
             "sdk key description",
             "add_button_profile_group",
             "sdk key description",
             "button_event_of_professional_rc",
             "sdk key description",
             "remote_controller_calibration_h_axis_status",
             "sdk key description",
             "connect_to_master_with_id",
             "sdk key description",
             "remote_controller_calibration_f_axis_status",
             "sdk key description",
             "password",
             "sdk key description",
             "select_button_profile",
             "sdk key description",
             "transformation_switch",
             "sdk key description",
             "left_dial_gimbal_control_axis",
             "sdk key description",
             "charge_mobile_mode",
             "sdk key description",
             "controlling_gimbal_index",
             "sdk key description",
             "hdmi_system_setting_output_enabled",
             "sdk key description",
             "config_interface_payload_widgets",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "payload_model",
             "sdk key description",
             "firmware_version",
             "sdk key description",
             "send_data_to_payload",
             "sdk key description",
             "is_accessory_connect",
             "sdk key description",
             "connection",
             "sdk key description",
             "payload_widgets_list_info",
             "sdk key description",
             "get_input_text_param",
             "sdk key description",
             "get_payload_camera_type",
             "sdk key description",
             "is_payload_sdk_ready",
             "sdk key description",
             "get_widget",
             "sdk key description",
             "get_data_from_payload",
             "sdk key description",
             "get_upstream_bandwidth",
             "sdk key description",
             "payload_device_type",
             "sdk key description",
             "configure_widget_value",
             "sdk key description",
             "main_interface_payload_widgets",
             "sdk key description",
             "is_dji_video_streaming_channel_available",
             "sdk key description",
             "payload_product_name",
             "sdk key description",
             "hint_message",
             "sdk key description",
             "log_in_as_device_admin",
             "sdk key description",
             "log_out",
             "sdk key description",
             "has_device_admin_logged_in",
             "sdk key description",
             "base_station_state",
             "sdk key description",
             "name",
             "sdk key description",
             "change_password",
             "sdk key description",
             "base_station_referencing_location",
             "sdk key description",
             "reset_base_station_referencing_location",
             "sdk key description",
             "base_station_battery_state",
             "sdk key description",
             "spotlight_enabled",
             "sdk key description",
             "spotlight_temperature",
             "sdk key description",
             "play_mode",
             "sdk key description",
             "stop",
             "sdk key description",
             "remaining_space",
             "sdk key description",
             "speaker_volume",
             "sdk key description",
             "total_space",
             "sdk key description",
             "speaker_state",
             "sdk key description",
             "beacon_enabled",
             "sdk key description",
             "spotlight_brightness",
             "sdk key description",
             "play",
             "sdk key description",
             "self_discharge_in_days",
             "sdk key description",
             "battery_type",
             "sdk key description",
             "overviews",
             "sdk key description",
             "self_heating_state",
             "sdk key description",
             "aggregation_state",
             "sdk key description",
             "battery_leds_enabled",
             "sdk key description",
             "level_2_cell_voltage_behavior",
             "sdk key description",
             "level_2_cell_voltage_threshold",
             "sdk key description",
             "firmware_version",
             "sdk key description",
             "is_battery_self_heating",
             "sdk key description",
             "current",
             "sdk key description",
             "design_capacity",
             "sdk key description",
             "is_cell_damaged",
             "sdk key description",
             "is_firmware_difference_detected",
             "sdk key description",
             "is_low_cell_voltage_detected",
             "sdk key description",
             "charge_remaining",
             "sdk key description",
             "charge_remaining_in_percent",
             "sdk key description",
             "historical_warning_records",
             "sdk key description",
             "latest_warning_record",
             "sdk key description",
             "manufacture_date",
             "sdk key description",
             "pair_batteries",
             "sdk key description",
             "is_in_single_battery_mode",
             "sdk key description",
             "number_of_discharges",
             "sdk key description",
             "cell_voltages",
             "sdk key description",
             "temperature",
             "sdk key description",
             "voltage",
             "sdk key description",
             "pairing_state",
             "sdk key description",
             "level_1_cell_voltage_behavior",
             "sdk key description",
             "cell_voltage_level",
             "sdk key description",
             "is_big_battery",
             "sdk key description",
             "connection_state",
             "sdk key description",
             "number_of_connected_batteries",
             "sdk key description",
             "full_charge_capacity",
             "sdk key description",
             "battery_embed_ok",
             "sdk key description",
             "is_smart_battery",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "number_of_cells",
             "sdk key description",
             "lifetime_remaining",
             "sdk key description",
             "highest_temperature",
             "sdk key description",
             "level_1_cell_voltage_threshold",
             "sdk key description",
             "is_being_charged",
             "sdk key description",
             "is_any_battery_disconnected",
             "sdk key description",
             "is_voltage_difference_detected",
             "sdk key description",
             "thermal_measurement_mode",
             "sdk key description",
             "start_record_video",
             "sdk key description",
             "format_sd_card",
             "sdk key description",
             "sdcard_is_read_only",
             "sdk key description",
             "photo_quick_view_duration",
             "sdk key description",
             "is_shooting_panorama_photo",
             "sdk key description",
             "ssd_clip_file_name",
             "sdk key description",
             "raw_photo_burst_count",
             "sdk key description",
             "is_adjustable_aperture_supported",
             "sdk key description",
             "camera_storage_location",
             "sdk key description",
             "is_continuous_digital_zoom",
             "sdk key description",
             "thermal_ace",
             "sdk key description",
             "video_file_compression_standard",
             "sdk key description",
             "msx_level",
             "sdk key description",
             "exposure_state",
             "sdk key description",
             "tap_zoom_enabled",
             "sdk key description",
             "shutter_speed",
             "sdk key description",
             "ssd_color",
             "sdk key description",
             "trigger_thermal_ffc",
             "sdk key description",
             "histogram_light_values",
             "sdk key description",
             "is_tap_zoom_supported",
             "sdk key description",
             "display_mode",
             "sdk key description",
             "metering_mode",
             "sdk key description",
             "is_shooting_single_photo_in_raw_format",
             "sdk key description",
             "led_auto_turn_off_enabled",
             "sdk key description",
             "ssd_color_range",
             "sdk key description",
             "demarcate_value",
             "sdk key description",
             "histogram_enabled",
             "sdk key description",
             "thermal_isotherm_middle_value",
             "sdk key description",
             "thermal_brightness",
             "sdk key description",
             "thermal_background_temperature",
             "sdk key description",
             "dewarping_enabled",
             "sdk key description",
             "is_mechanical_shutter_supported",
             "sdk key description",
             "is_forbid_record",
             "sdk key description",
             "ssd_operation_state",
             "sdk key description",
             "pip_position",
             "sdk key description",
             "interval_shoot_countdown",
             "sdk key description",
             "iso",
             "sdk key description",
             "thermal_contrast",
             "sdk key description",
             "start_shoot_photo",
             "sdk key description",
             "infrared_thermal_camera_sensor_burning_protection_enabled",
             "sdk key description",
             "laser_enabled",
             "sdk key description",
             "innerstorage_available_recording_time_in_seconds",
             "sdk key description",
             "is_shooting_shallow_focus_photo",
             "sdk key description",
             "thermal_isotherm_upper_value",
             "sdk key description",
             "laser_measure_information",
             "sdk key description",
             "spot_metering_col_nums",
             "sdk key description",
             "innerstorage_is_initializing",
             "sdk key description",
             "thermal_area_temperature_aggregations",
             "sdk key description",
             "is_photo_quick_view_supported",
             "sdk key description",
             "camera_type",
             "sdk key description",
             "is_thermal_lens",
             "sdk key description",
             "ssd_is_connected",
             "sdk key description",
             "exposure_compensation",
             "sdk key description",
             "ssd_video_resolution_range",
             "sdk key description",
             "sdcard_is_invalid_format",
             "sdk key description",
             "stop_shoot_photo",
             "sdk key description",
             "super_resolution_state",
             "sdk key description",
             "mechanical_shutter_enabled",
             "sdk key description",
             "stop_continuous_optical_zoom",
             "sdk key description",
             "thermal_window_temperature",
             "sdk key description",
             "camera_video_stream_source",
             "sdk key description",
             "sdcard_is_verified",
             "sdk key description",
             "flat_camera_mode",
             "sdk key description",
             "thermal_atmospheric_temperature",
             "sdk key description",
             "audio_gain",
             "sdk key description",
             "exposure_settings",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "payload_e1e_serial_number",
             "sdk key description",
             "aperture",
             "sdk key description",
             "current_video_recording_time_in_seconds",
             "sdk key description",
             "thermal_roi",
             "sdk key description",
             "hyperlapse_original_photo_settings",
             "sdk key description",
             "optical_zoom_focal_length",
             "sdk key description",
             "camera_target_focal_length",
             "sdk key description",
             "sdcard_is_repairing_files",
             "sdk key description",
             "sdcard_is_write_slow",
             "sdk key description",
             "stop_log_export",
             "sdk key description",
             "video_caption_enabled",
             "sdk key description",
             "exposure_compensation_range",
             "sdk key description",
             "is_shooting_super_resolution_photo",
             "sdk key description",
             "camera_mf_demarcate_state",
             "sdk key description",
             "innerstorage_is_invalid_format",
             "sdk key description",
             "is_afc_supported",
             "sdk key description",
             "dual_feed_horizontal_alignment_offset_range",
             "sdk key description",
             "resolution_frame_rate",
             "sdk key description",
             "thermal_window_transmission_coefficient",
             "sdk key description",
             "custom_information",
             "sdk key description",
             "anti_flicker_range",
             "sdk key description",
             "storage_state",
             "sdk key description",
             "color_waveform_display_state",
             "sdk key description",
             "optical_zoom_spec",
             "sdk key description",
             "has_error",
             "sdk key description",
             "innerstorage_is_slow",
             "sdk key description",
             "innerstorage_total_space_in_mb",
             "sdk key description",
             "is_multi_video_stream_source_supported",
             "sdk key description",
             "ssd_video_recording_enabled",
             "sdk key description",
             "thermal_window_reflection",
             "sdk key description",
             "video_file_format_range",
             "sdk key description",
             "hybrid_zoom_spec",
             "sdk key description",
             "focus_status",
             "sdk key description",
             "sdcard_needs_formatting",
             "sdk key description",
             "is_adjustable_focal_point_supported",
             "sdk key description",
             "is_super_resolution_supported",
             "sdk key description",
             "camera_color",
             "sdk key description",
             "hyperlapse_original_images_format_range",
             "sdk key description",
             "is_shooting_raw_burst_photo",
             "sdk key description",
             "audio_recording_enabled",
             "sdk key description",
             "sdcard_is_initializing",
             "sdk key description",
             "lens_is_af_switch_on",
             "sdk key description",
             "rc_wheel_mode",
             "sdk key description",
             "is_shooting_burst_photo",
             "sdk key description",
             "focus_assistant_settings",
             "sdk key description",
             "thermal_gain_mode_temperature_range",
             "sdk key description",
             "thermal_atmospheric_transmission_coefficient",
             "sdk key description",
             "thermal_palette",
             "sdk key description",
             "is_interchangeable_lens_supported",
             "sdk key description",
             "is_sensor_cleaning_supported",
             "sdk key description",
             "thermal_ffc_mode",
             "sdk key description",
             "stop_record_video",
             "sdk key description",
             "temperature_unit",
             "sdk key description",
             "is_media_download_mode_supported",
             "sdk key description",
             "is_recording",
             "sdk key description",
             "white_balance_custom_color_temperature_range",
             "sdk key description",
             "ssd_video_licenses",
             "sdk key description",
             "irc_enable",
             "sdk key description",
             "photo_panorama_mode",
             "sdk key description",
             "last_camera_video_stream_source",
             "sdk key description",
             "mode_range",
             "sdk key description",
             "is_processing_panorama_photo",
             "sdk key description",
             "is_video_playback_supported",
             "sdk key description",
             "sdcard_has_error",
             "sdk key description",
             "thermal_is_ffc_mode_supported",
             "sdk key description",
             "start_sensor_cleaning",
             "sdk key description",
             "log_export_state",
             "sdk key description",
             "digital_zoom_factor",
             "sdk key description",
             "exit_sensor_cleaning_mode",
             "sdk key description",
             "is_shooting_interval_photo",
             "sdk key description",
             "load_settings_from_profile",
             "sdk key description",
             "photo_aspect_ratio_range",
             "sdk key description",
             "is_ssd_supported",
             "sdk key description",
             "photo_raw_burst_count",
             "sdk key description",
             "innerstorage_state",
             "sdk key description",
             "sdcard_available_recording_time_in_seconds",
             "sdk key description",
             "is_shooting_single_photo",
             "sdk key description",
             "focus_target",
             "sdk key description",
             "camera_video_stream_source_range",
             "sdk key description",
             "is_digital_zoom_supported",
             "sdk key description",
             "focus_mode",
             "sdk key description",
             "thermal_global_min_temperature",
             "sdk key description",
             "innerstorage_is_full",
             "sdk key description",
             "innerstorage_is_verified",
             "sdk key description",
             "ei_value_range",
             "sdk key description",
             "video_standard_range",
             "sdk key description",
             "sdcard_total_space_in_mb",
             "sdk key description",
             "clear_log_export",
             "sdk key description",
             "format_internal_storage",
             "sdk key description",
             "capture_camera_stream_settings",
             "sdk key description",
             "sdcard_is_full",
             "sdk key description",
             "camera_color_range",
             "sdk key description",
             "photo_time_lapse_settings",
             "sdk key description",
             "photo_aspect_ratio",
             "sdk key description",
             "exit_playback",
             "sdk key description",
             "watermark_display_content_settings",
             "sdk key description",
             "display_mode_range",
             "sdk key description",
             "dual_feed_horizontal_alignment_offset",
             "sdk key description",
             "shoot_photo_mode",
             "sdk key description",
             "photo_file_format",
             "sdk key description",
             "color_waveform_enabled",
             "sdk key description",
             "start_record_video_in_cache",
             "sdk key description",
             "thermal_digital_zoom_factor",
             "sdk key description",
             "thermal_palette_range",
             "sdk key description",
             "lens_information",
             "sdk key description",
             "infrared_thermal_camera_shutter_enabled",
             "sdk key description",
             "thermal_metering_area",
             "sdk key description",
             "sdcard_is_inserted",
             "sdk key description",
             "sdcard_is_file_index_max",
             "sdk key description",
             "init_sensor_cleaning_mode",
             "sdk key description",
             "mutually_exclusive_status",
             "sdk key description",
             "camera_start_mf_demarcate",
             "sdk key description",
             "start_log_export",
             "sdk key description",
             "is_playback_supported",
             "sdk key description",
             "save_settings_to_profile",
             "sdk key description",
             "spot_metering_target",
             "sdk key description",
             "innerstorage_has_error",
             "sdk key description",
             "ssd_available_recording_time_in_seconds",
             "sdk key description",
             "firmware_version",
             "sdk key description",
             "is_in_playback_mode",
             "sdk key description",
             "aperture_range",
             "sdk key description",
             "ssd_video_resolution_and_frame_rate",
             "sdk key description",
             "sharpness",
             "sdk key description",
             "ssd_remaining_space_in_mb",
             "sdk key description",
             "sdcard_available_capture_count",
             "sdk key description",
             "thermal_profile",
             "sdk key description",
             "stop_record_video_in_cache",
             "sdk key description",
             "ei_color",
             "sdk key description",
             "zoom_box_relative_fov",
             "sdk key description",
             "is_internal_storage_supported",
             "sdk key description",
             "sdcard_state",
             "sdk key description",
             "is_shooting_photo_enabled",
             "sdk key description",
             "iso_range",
             "sdk key description",
             "thermal_dde",
             "sdk key description",
             "thermal_scene_emissivity",
             "sdk key description",
             "video_compression_standard_range",
             "sdk key description",
             "auto_ae_unlock_enabled",
             "sdk key description",
             "focus_ring_value_upper_bound",
             "sdk key description",
             "fast_playback_settings",
             "sdk key description",
             "panorama_capture_result",
             "sdk key description",
             "is_storing_photo",
             "sdk key description",
             "record_camera_stream_settings",
             "sdk key description",
             "is_audio_recording_supported",
             "sdk key description",
             "lens_is_installed",
             "sdk key description",
             "ndfilter_mode",
             "sdk key description",
             "thermal_temperature_data",
             "sdk key description",
             "picture_style_preset",
             "sdk key description",
             "pano_original_photo_settings",
             "sdk key description",
             "is_color_waveform_supported",
             "sdk key description",
             "photo_file_format_range",
             "sdk key description",
             "white_balance_present_range",
             "sdk key description",
             "custom_expand_directory_name_settings",
             "sdk key description",
             "is_log_exporting",
             "sdk key description",
             "dual_feed_vertical_alignment_offset",
             "sdk key description",
             "temp_alarm",
             "sdk key description",
             "display_name",
             "sdk key description",
             "restore_factory_settings",
             "sdk key description",
             "start_continuous_optical_zoom",
             "sdk key description",
             "lens_is_focus_assistant_working",
             "sdk key description",
             "flat_camera_mode_range",
             "sdk key description",
             "video_resolution_frame_rate_range",
             "sdk key description",
             "auto_lock_gimbal_enabled",
             "sdk key description",
             "thermal_custom_external_scene_settings_profile",
             "sdk key description",
             "flat_camera_mode_child_range",
             "sdk key description",
             "is_thermal_camera",
             "sdk key description",
             "orientation",
             "sdk key description",
             "thermal_spot_metering_target_point",
             "sdk key description",
             "camera_peak_threshold",
             "sdk key description",
             "ssd_video_resolution_frame_rate_range",
             "sdk key description",
             "contrast",
             "sdk key description",
             "is_capture_in_video_supported",
             "sdk key description",
             "innerstorage_is_busy",
             "sdk key description",
             "is_multi_lens_camera_supported",
             "sdk key description",
             "recommended_ei_value",
             "sdk key description",
             "dual_feed_vertical_alignment_offset_range",
             "sdk key description",
             "is_hybrid_zoom_supported",
             "sdk key description",
             "innerstorage_is_formatted",
             "sdk key description",
             "innerstorage_remaining_space_in_mb",
             "sdk key description",
             "panorama_progress_in_percent",
             "sdk key description",
             "sdcard_is_formatting",
             "sdk key description",
             "sdcard_remaining_space_in_mb",
             "sdk key description",
             "is_flat_camera_mode_supported",
             "sdk key description",
             "enter_playback",
             "sdk key description",
             "watermark_user_custom_info",
             "sdk key description",
             "ssd_total_space",
             "sdk key description",
             "focus_ring_value",
             "sdk key description",
             "is_nd_filter_mode_supported",
             "sdk key description",
             "activate_ssd_video_license",
             "sdk key description",
             "anti_flicker_frequency",
             "sdk key description",
             "innerstorage_is_inserted",
             "sdk key description",
             "photo_burst_count",
             "sdk key description",
             "ei_value",
             "sdk key description",
             "thermal_global_max_temperature",
             "sdk key description",
             "spot_metering_row_nums",
             "sdk key description",
             "watermark_settings",
             "sdk key description",
             "thermal_isotherm_enabled",
             "sdk key description",
             "multi_spectral_shutter_speed_range",
             "sdk key description",
             "create_subscription",
             "sdk key description",
             "tap_zoom_multiplier",
             "sdk key description",
             "hd_live_view_enabled",
             "sdk key description",
             "turn_off_fan_when_possible",
             "sdk key description",
             "optical_zoom_scale",
             "sdk key description",
             "thermal_gain_mode",
             "sdk key description",
             "multi_spectral_exposure_compensation_range",
             "sdk key description",
             "thermal_isotherm_lower_value",
             "sdk key description",
             "video_file_format",
             "sdk key description",
             "photo_time_interval_settings",
             "sdk key description",
             "ae_lock",
             "sdk key description",
             "format_ssd",
             "sdk key description",
             "mode",
             "sdk key description",
             "exposure_sensitivity_mode",
             "sdk key description",
             "pre_flat_shoot_photo_mode",
             "sdk key description",
             "vision_stabilization_enabled",
             "sdk key description",
             "custom_expand_file_name_settings",
             "sdk key description",
             "innerstorage_available_capture_count",
             "sdk key description",
             "sdcard_is_slow",
             "sdk key description",
             "is_overheating",
             "sdk key description",
             "pano_original_images_format_range",
             "sdk key description",
             "innerstorage_is_formatting",
             "sdk key description",
             "ssd_legacy_color",
             "sdk key description",
             "camera_stop_mf_demarcate",
             "sdk key description",
             "current_thermal_gain_mode_temperature_range",
             "sdk key description",
             "white_balance",
             "sdk key description",
             "defog_enabled",
             "sdk key description",
             "is_ei_mode_supported",
             "sdk key description",
             "innerstorage_is_read_only",
             "sdk key description",
             "hybrid_zoom_focal_length",
             "sdk key description",
             "current_panorama_photo_count",
             "sdk key description",
             "photo_aeb_count",
             "sdk key description",
             "file_index_mode",
             "sdk key description",
             "is_time_lapse_supported",
             "sdk key description",
             "sensor_cleaning_state",
             "sdk key description",
             "thermal_isotherm_unit",
             "sdk key description",
             "super_resolution_capture_area",
             "sdk key description",
             "video_standard",
             "sdk key description",
             "shoot_photo_mode_child_range",
             "sdk key description",
             "laser_service_mode",
             "sdk key description",
             "thermal_measuring_status",
             "sdk key description",
             "recording_state",
             "sdk key description",
             "flat_photo_mode_range",
             "sdk key description",
             "thermal_sso",
             "sdk key description",
             "camera_mf_demarcate_result",
             "sdk key description",
             "hardware_version",
             "sdk key description",
             "shoot_photo_mode_range",
             "sdk key description",
             "is_shooting_photo",
             "sdk key description",
             "is_dewarping_supported",
             "sdk key description",
             "saturation",
             "sdk key description",
             "real_shutter_speed",
             "sdk key description",
             "leds_auto_turn_off_enabled_settings",
             "sdk key description",
             "exposure_mode",
             "sdk key description",
             "shutter_speed_range",
             "sdk key description",
             "thermal_scene",
             "sdk key description",
             "vision_stabilization_state",
             "sdk key description",
             "is_optical_zoom_supported",
             "sdk key description",
             "is_metering_mode_supported",
             "sdk key description",
             "tap_zoom_state",
             "sdk key description",
             "thermal_window_reflected_temperature",
             "sdk key description",
             "sdcard_is_connected_to_pc",
             "sdk key description",
             "sdcard_is_busy",
             "sdk key description",
             "tap_zoom_at_target",
             "sdk key description",
             "exposure_mode_range",
             "sdk key description",
             "total_panorama_photo_count",
             "sdk key description",
             "sdcard_is_formatted",
             "sdk key description",
             "orientation_range",
             "sdk key description",
             "is_home_location_set",
             "sdk key description",
             "hotpoint_min_radius",
             "sdk key description",
             "is_vision_positioning_sensor_being_used",
             "sdk key description",
             "velocity_x",
             "sdk key description",
             "velocity_z",
             "sdk key description",
             "go_home_assessment",
             "sdk key description",
             "is_braking",
             "sdk key description",
             "is_multi_tracking_enabled",
             "sdk key description",
             "reset_motor",
             "sdk key description",
             "single_vision_sensor_enabled",
             "sdk key description",
             "upgrade_voice_open",
             "sdk key description",
             "reset_user_account",
             "sdk key description",
             "is_multi_tracking_executing",
             "sdk key description",
             "down_avoidance_distance",
             "sdk key description",
             "max_flight_height_limit_reason",
             "sdk key description",
             "does_apas_have_temp_error",
             "sdk key description",
             "velocity_y",
             "sdk key description",
             "compass_has_error",
             "sdk key description",
             "redundancy_imu_status",
             "sdk key description",
             "max_flight_radius_range",
             "sdk key description",
             "is_cancel_auto_landing_disabled",
             "sdk key description",
             "active_track_gps_assistant_enabled",
             "sdk key description",
             "turn_on_motors",
             "sdk key description",
             "start_imu_calibration",
             "sdk key description",
             "confirm_in_moving_platform",
             "sdk key description",
             "is_cancel_return_to_home_disabled",
             "sdk key description",
             "vision_system_warning",
             "sdk key description",
             "redundancy_sensor_used_state",
             "sdk key description",
             "lock_motors",
             "sdk key description",
             "home_location_latitude",
             "sdk key description",
             "start_simulator",
             "sdk key description",
             "unsubscribe_pack",
             "sdk key description",
             "deploy_landing_gear",
             "sdk key description",
             "smart_track_set_camera_focal",
             "sdk key description",
             "rtk_fusion_has_set_take_off_altitude",
             "sdk key description",
             "flight_controller_track_mode",
             "sdk key description",
             "is_landing_gear_movable",
             "sdk key description",
             "ultrasonic_error",
             "sdk key description",
             "aircraft_location_latitude",
             "sdk key description",
             "set_data_upgrade_self",
             "sdk key description",
             "waypoint_mission_interruption",
             "sdk key description",
             "omni_perception_radar_down_distance",
             "sdk key description",
             "rth_obstacle_avoidance_enabled",
             "sdk key description",
             "aircraft_go_home_count_down",
             "sdk key description",
             "stop_simulator",
             "sdk key description",
             "is_reboot_in_s_mode",
             "sdk key description",
             "is_performing_precision_landing",
             "sdk key description",
             "home_location_using_current_aircraft_location",
             "sdk key description",
             "out_of_both_control_gimbals_reason",
             "sdk key description",
             "set_home_location_without_limitation",
             "sdk key description",
             "format",
             "sdk key description",
             "multi_tracking_sub_mode",
             "sdk key description",
             "omni_horizontal_avoidance_enabled",
             "sdk key description",
             "custom_function_mode",
             "sdk key description",
             "rth_remote_obstacle_avoidance_enabled",
             "sdk key description",
             "is_absolute_gps_altitude_support",
             "sdk key description",
             "omni_down_radar_distance",
             "sdk key description",
             "landing_gear_mode",
             "sdk key description",
             "multi_rc_flight_control_auth_lock_state",
             "sdk key description",
             "landing_protection_enabled",
             "sdk key description",
             "is_motor_stop_landing_mode",
             "sdk key description",
             "hotpoint_max_acceleration",
             "sdk key description",
             "tap_fly_mode",
             "sdk key description",
             "get_waypoint_break_info",
             "sdk key description",
             "is_fail_safe",
             "sdk key description",
             "tripod_mode_enabled",
             "sdk key description",
             "cinematic_brake_sensitivity_range",
             "sdk key description",
             "take_off",
             "sdk key description",
             "has_internal_beacon_leds",
             "sdk key description",
             "set_up_user",
             "sdk key description",
             "fly_time_in_seconds",
             "sdk key description",
             "start_go_home",
             "sdk key description",
             "open_altitude_flight_mode",
             "sdk key description",
             "temp_motor_locked",
             "sdk key description",
             "multi_rc_flight_control_auth_lock",
             "sdk key description",
             "is_multi_tracking_waiting_confirmation",
             "sdk key description",
             "cancel_take_off",
             "sdk key description",
             "flight_controller_dynamic_home",
             "sdk key description",
             "go_home_status",
             "sdk key description",
             "app_set_param_display_status",
             "sdk key description",
             "imu_count",
             "sdk key description",
             "formatting_state",
             "sdk key description",
             "active_forbid_side_fly_enabled",
             "sdk key description",
             "access_locker_state",
             "sdk key description",
             "landing_gear_status",
             "sdk key description",
             "rtk_activate",
             "sdk key description",
             "waypoint_protocol_version",
             "sdk key description",
             "turn_off_motors",
             "sdk key description",
             "active_track_circular_speed",
             "sdk key description",
             "compass_heading",
             "sdk key description",
             "omni_down_avoidance_distance",
             "sdk key description",
             "motor_start_failed_state",
             "sdk key description",
             "cinematic_brake_sensitivity",
             "sdk key description",
             "start_imu_calibration_with_id",
             "sdk key description",
             "landing_gear_automatic_movement_enabled",
             "sdk key description",
             "is_apas_enabled",
             "sdk key description",
             "rtk_fusion_home_location_data_source",
             "sdk key description",
             "active_track_gesture_mode_enabled",
             "sdk key description",
             "orientation_mode",
             "sdk key description",
             "active_track_camera",
             "sdk key description",
             "remaining_flight_time",
             "sdk key description",
             "is_lower_than_battery_warning_threshold",
             "sdk key description",
             "draw_heading_mode",
             "sdk key description",
             "is_rtk_connected",
             "sdk key description",
             "attitude_pitch",
             "sdk key description",
             "up_avoidance_distance",
             "sdk key description",
             "is_motors_lock_by_app",
             "sdk key description",
             "aircraft_location",
             "sdk key description",
             "advanced_gesture_control_enabled",
             "sdk key description",
             "is_flying",
             "sdk key description",
             "altitude",
             "sdk key description",
             "rtk_enabled",
             "sdk key description",
             "omni_horizontal_avoidance_distance",
             "sdk key description",
             "stop_gravity_center_calibration",
             "sdk key description",
             "home_point_state",
             "sdk key description",
             "is_right_radar_open",
             "sdk key description",
             "takeoff_location_altitude",
             "sdk key description",
             "is_landing",
             "sdk key description",
             "rtk_state",
             "sdk key description",
             "simulator_state",
             "sdk key description",
             "vision_assisted_positioning_enabled",
             "sdk key description",
             "compass_is_calibrating",
             "sdk key description",
             "flight_action",
             "sdk key description",
             "is_no_gps_max_flight_height_supported",
             "sdk key description",
             "enter_navigation_mode",
             "sdk key description",
             "simulator_wind_data",
             "sdk key description",
             "enter_transport_mode",
             "sdk key description",
             "cancel_landing",
             "sdk key description",
             "rtk_serial_number",
             "sdk key description",
             "in_on_limite_area_boundaries",
             "sdk key description",
             "rtk_fusion_mobile_heading",
             "sdk key description",
             "virtual_stick_control_mode_enabled",
             "sdk key description",
             "cinematic_yaw_speed",
             "sdk key description",
             "is_front_radar_open",
             "sdk key description",
             "is_apas_functioning",
             "sdk key description",
             "is_flight_assistant_supported",
             "sdk key description",
             "aircraft_total_flight_distance",
             "sdk key description",
             "exit_transport_mode",
             "sdk key description",
             "cinematic_mode_enabled",
             "sdk key description",
             "rc_mode_channel",
             "sdk key description",
             "is_precision_take_off_supported",
             "sdk key description",
             "stop_search_base_station",
             "sdk key description",
             "binding_state",
             "sdk key description",
             "rtk_device_password",
             "sdk key description",
             "rtk_base_station_connection_state",
             "sdk key description",
             "has_reached_max_flight_height",
             "sdk key description",
             "active_track_mode",
             "sdk key description",
             "is_avoiding_active_obstacle_collision",
             "sdk key description",
             "area_code",
             "sdk key description",
             "propeller_cover_limit_enabled",
             "sdk key description",
             "omni_perception_avoidance_state",
             "sdk key description",
             "start_landing",
             "sdk key description",
             "horizontal_avoidance_distance",
             "sdk key description",
             "top_auxiliary_light_mode",
             "sdk key description",
             "rtk_connected_with_base_station",
             "sdk key description",
             "rtk_connect_type",
             "sdk key description",
             "is_ascent_limited_by_obstacle",
             "sdk key description",
             "lock_course_using_current_heading",
             "sdk key description",
             "aircraft_name",
             "sdk key description",
             "access_locker_supported",
             "sdk key description",
             "is_advanced_pilot_assistant_system_enabled",
             "sdk key description",
             "rtk_reference_station_source",
             "sdk key description",
             "omni_vertical_avoidance_enabled",
             "sdk key description",
             "max_radius_aircraft_can_fly_and_go_home",
             "sdk key description",
             "active_brake_engaged",
             "sdk key description",
             "rtk_base_station_location_state",
             "sdk key description",
             "attitude_yaw",
             "sdk key description",
             "landing_gear_hide_enabled",
             "sdk key description",
             "max_flight_height",
             "sdk key description",
             "landing_protection_state",
             "sdk key description",
             "control_gimbal_behavior",
             "sdk key description",
             "air_sense_system_connected",
             "sdk key description",
             "low_battery_warning_threshold",
             "sdk key description",
             "rtk_fusion_aircraft_to_home_distance",
             "sdk key description",
             "is_virtual_stick_control_mode_available",
             "sdk key description",
             "vision_detection_state",
             "sdk key description",
             "login",
             "sdk key description",
             "start_search_base_station",
             "sdk key description",
             "air_sense_system_warning_level",
             "sdk key description",
             "init_io",
             "sdk key description",
             "is_rtk_supported",
             "sdk key description",
             "config_rth_in_current_altitude",
             "sdk key description",
             "quick_spin_enabled",
             "sdk key description",
             "is_aircraft_hovering",
             "sdk key description",
             "omni_horizontal_radar_distance",
             "sdk key description",
             "urgent_stop_motor_mode",
             "sdk key description",
             "aircraft_location_longitude",
             "sdk key description",
             "force_landing_height",
             "sdk key description",
             "rtk_heading_solution",
             "sdk key description",
             "multi_mode_open",
             "sdk key description",
             "is_simulator_active",
             "sdk key description",
             "set_multi_tracking_enabled_with_video_source",
             "sdk key description",
             "home_location",
             "sdk key description",
             "iostate_4",
             "sdk key description",
             "iostate_2",
             "sdk key description",
             "iostate_3",
             "sdk key description",
             "iostate_0",
             "sdk key description",
             "iostate_1",
             "sdk key description",
             "compass_count",
             "sdk key description",
             "aircraft_total_flight_times",
             "sdk key description",
             "active_obstacle_avoidance_mode",
             "sdk key description",
             "imu_state",
             "sdk key description",
             "omni_perception_radar_full_distance",
             "sdk key description",
             "wind_speed",
             "sdk key description",
             "aircraft_total_flight_duration",
             "sdk key description",
             "fly_zone_limitation_enabled",
             "sdk key description",
             "is_system_upgrade_abnormal",
             "sdk key description",
             "limit_max_flight_height_in_meter",
             "sdk key description",
             "has_reached_max_flight_radius",
             "sdk key description",
             "is_in_landing_mode",
             "sdk key description",
             "aircraft_should_go_home",
             "sdk key description",
             "precision_landing_enabled",
             "sdk key description",
             "connect_to_base_station",
             "sdk key description",
             "access_locker_version",
             "sdk key description",
             "max_flight_height_in_nfz",
             "sdk key description",
             "detection_sectors",
             "sdk key description",
             "flight_mode",
             "sdk key description",
             "air_sense_airplane_states",
             "sdk key description",
             "flight_user_avoid_enabled",
             "sdk key description",
             "force_landing_after_flat_mode",
             "sdk key description",
             "apas_state",
             "sdk key description",
             "time_needed_to_land_from_current_height",
             "sdk key description",
             "omni_perception_radar_bird_view_distance",
             "sdk key description",
             "fixed_wing_control",
             "sdk key description",
             "is_imu_preheating",
             "sdk key description",
             "start_gravity_center_calibration",
             "sdk key description",
             "rtk_positioning_solution",
             "sdk key description",
             "perception_tof_full_distance",
             "sdk key description",
             "redundancy_compass_status",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "novice_mode_enabled",
             "sdk key description",
             "bottom_auxiliary_light_mode",
             "sdk key description",
             "leds_enabled_settings",
             "sdk key description",
             "current_mode",
             "sdk key description",
             "gravity_center_state",
             "sdk key description",
             "rtk_base_station_list",
             "sdk key description",
             "max_waypoint_num",
             "sdk key description",
             "omni_perception_radar_up_distance",
             "sdk key description",
             "send_data_to_on_board_sdk_device",
             "sdk key description",
             "max_flight_radius",
             "sdk key description",
             "is_rtk_fusion_data_usable",
             "sdk key description",
             "collision_avoidance_enabled",
             "sdk key description",
             "max_flight_height_range",
             "sdk key description",
             "connection_fail_safe_behavior",
             "sdk key description",
             "time_needed_to_go_home",
             "sdk key description",
             "flight_mode_string",
             "sdk key description",
             "cancel_go_home",
             "sdk key description",
             "battery_percentage_needed_to_go_home",
             "sdk key description",
             "home_point_altitude",
             "sdk key description",
             "esc_beeping_enabled",
             "sdk key description",
             "active_obstacle_avoidance_enabled",
             "sdk key description",
             "home_location_longitude",
             "sdk key description",
             "need_limit_flight_height",
             "sdk key description",
             "battery_threshold_behavior",
             "sdk key description",
             "max_flight_radius_enabled",
             "sdk key description",
             "absolute_gps_altitude",
             "sdk key description",
             "return_to_home_state",
             "sdk key description",
             "compass_calibration_status",
             "sdk key description",
             "is_ultrasonic_being_used",
             "sdk key description",
             "access_locker_username",
             "sdk key description",
             "rtk_device_name",
             "sdk key description",
             "control_mode",
             "sdk key description",
             "is_left_radar_open",
             "sdk key description",
             "multi_rc_execute_aircraft_lost_logic",
             "sdk key description",
             "send_virtual_stick_flight_control_data",
             "sdk key description",
             "omni_up_avoidance_distance",
             "sdk key description",
             "enable_1860",
             "sdk key description",
             "reset_gravity_center_calibration",
             "sdk key description",
             "power_supply_port_enabled",
             "sdk key description",
             "go_home_height_in_meters",
             "sdk key description",
             "is_in_moving_platform",
             "sdk key description",
             "ultrasonic_height_in_meters",
             "sdk key description",
             "confirm_landing",
             "sdk key description",
             "rid_working_status",
             "sdk key description",
             "confirm_smart_return_to_home_request",
             "sdk key description",
             "draw_status",
             "sdk key description",
             "terrain_follow_mode_enabled",
             "sdk key description",
             "modify_user_account",
             "sdk key description",
             "omni_up_radar_distance",
             "sdk key description",
             "compass_start_calibration",
             "sdk key description",
             "eid_number",
             "sdk key description",
             "wind_direction",
             "sdk key description",
             "is_landing_confirmation_needed",
             "sdk key description",
             "are_motor_on",
             "sdk key description",
             "precision_take_off",
             "sdk key description",
             "attitude_roll",
             "sdk key description",
             "is_going_home",
             "sdk key description",
             "retract_landing_gear",
             "sdk key description",
             "subcomponent_imu_key",
             "sdk key description",
             "rtk_fusion_mobile_location",
             "sdk key description",
             "subscribe_pack",
             "sdk key description",
             "compass_state",
             "sdk key description",
             "gps_signal_level",
             "sdk key description",
             "upwards_avoidance_enabled",
             "sdk key description",
             "omni_upwards_avoidance_enabled",
             "sdk key description",
             "is_back_radar_open",
             "sdk key description",
             "cinematic_yaw_speed_range",
             "sdk key description",
             "serious_low_battery_warning_threshold",
             "sdk key description",
             "smart_return_to_home_enabled",
             "sdk key description",
             "satellite_count",
             "sdk key description",
             "no_gps_max_flight_height",
             "sdk key description",
             "active_track_camera_stream",
             "sdk key description",
             "current_land_immediately_battery",
             "sdk key description",
             "both_control_multi_gimbals",
             "sdk key description",
             "is_lower_than_serious_battery_warning_threshold",
             "sdk key description",
             "rtk_fusion_take_off_altitude",
             "sdk key description",
             "flight_wind_warning",
             "sdk key description",
             "multi_rc_flight_control_auth_owner",
             "sdk key description",
             "compass_stop_calibration",
             "sdk key description",
             "gimbal_attitude_ground_coordinate",
             "sdk key description",
             "is_on_board_sdk_available",
             "sdk key description",
             "intelligent_flight_assistant_is_useravoid_enable",
             "sdk key description",
             "is_poi2_enabled",
             "sdk key description",
             "is_mode_button_being_pressed",
             "sdk key description",
             "mode_button",
             "sdk key description",
             "stick_horizontal_direction",
             "sdk key description",
             "component_key",
             "sdk key description",
             "power_mode",
             "sdk key description",
             "handheld_name",
             "sdk key description",
             "is_trigger_being_pressed",
             "sdk key description",
             "trigger_button",
             "sdk key description",
             "led_command",
             "sdk key description",
             "stick",
             "sdk key description",
             "stick_gimbal_control_enabled",
             "sdk key description",
             "stick_vertical_direction",
             "sdk key description",
             "full_serial_number_hash",
             "sdk key description",
             "record_and_shutter_buttons",
             "sdk key description",
             "serial_number",
             "sdk key description",
             "echo_mode_range",
             "sdk key description",
             "send_command_to_perception",
             "sdk key description",
             "lidar_data_sample_rate_range",
             "sdk key description",
             "payload_pos_status_info",
             "sdk key description",
             "visible_light_pixel",
             "sdk key description",
             "scan_mode",
             "sdk key description",
             "high_sensitivity_mode",
             "sdk key description",
             "scan_mode_range",
             "sdk key description",
             "payload_perception_status",
             "sdk key description",
             "lidar_data_sample_rate",
             "sdk key description",
             "echo_mode",
             "sdk key description",
        ],
        "longSearchIndex": [
        ],
        "info": [
            [
                   "OnLiveErrorStatusListener",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_OnLiveErrorStatusListener.html",
                   "",
                   "Defines the listeners of the live video status.",
            ],
            [
                   "Defines the listeners of the live video status.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_OnLiveErrorStatusListener.html",
                   "",
                   "",
            ],
            [
                   "onError",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_OnLiveErrorStatusListener.html",
                   "#DJILiveStreamManager_onError_inline",
                   "When an error occurs during the live broadcast, the listener will receive this callback.  @param error The error code, currently only support `STATUS_LIVING_INTERRUPTION_ERROR(-3)` @param description Description of the error.",
            ],
            [
                   "When an error occurs during the live broadcast, the listener will receive this callback.  @param error The error code, currently only support `STATUS_LIVING_INTERRUPTION_ERROR(-3)` @param description Description of the error.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_OnLiveErrorStatusListener.html",
                   "#DJILiveStreamManager_onError_inline",
                   "",
            ],
            [
                   "addLiveErrorStatusListener",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_addLiveErrorStatusListener_inline",
                   "Adds the listener for the live video status change events.  @param listener live video status change listener.",
            ],
            [
                   "Adds the listener for the live video status change events.  @param listener live video status change listener.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_addLiveErrorStatusListener_inline",
                   "",
            ],
            [
                   "removeLiveErrorStatusListener",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_removeLiveErrorStatusListener_inline",
                   "Remove the listener for the live video status change events.  @param listener live video status change listener.",
            ],
            [
                   "Remove the listener for the live video status change events.  @param listener live video status change listener.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_removeLiveErrorStatusListener_inline",
                   "",
            ],
            [
                   "isStreaming",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isStreaming_inline",
                   "Determines if the live streaming starts or not. After starting this flag will not be affected by the RTMP server status.  @return `true` if the live stream manager is streaming.",
            ],
            [
                   "Determines if the live streaming starts or not. After starting this flag will not be affected by the RTMP server status.  @return `true` if the live stream manager is streaming.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isStreaming_inline",
                   "",
            ],
            [
                   "setLiveUrl",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveUrl_inline",
                   "Sets the URL address of the RTMP Server. This method should be called before the calling of `startStream`.  @param url The URL address string of the RTMP Server.",
            ],
            [
                   "Sets the URL address of the RTMP Server. This method should be called before the calling of `startStream`.  @param url The URL address string of the RTMP Server.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveUrl_inline",
                   "",
            ],
            [
                   "getLiveUrl",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveUrl_inline",
                   "Gets the current URL address of the RTMP Server.  @return A string of the URL address.",
            ],
            [
                   "Gets the current URL address of the RTMP Server.  @return A string of the URL address.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveUrl_inline",
                   "",
            ],
            [
                   "startStream",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_startStream_inline",
                   "Starts the live streaming. If the manager starts successfully, `isStreaming` will return `true`. The  encoder will start to encoding the video frame if it is needed. The video will be streamed to the RTMP server if the server  is available. The audio can be streamed along with the video if the audio setting is enabled.  @return An int value of the error code. 0 means success. 254 means initialization error. -2，means livestream feature is disabled by LDM. -3 means failure to obtain sps/pps.",
            ],
            [
                   "Starts the live streaming. If the manager starts successfully, `isStreaming` will return `true`. The  encoder will start to encoding the video frame if it is needed. The video will be streamed to the RTMP server if the server  is available. The audio can be streamed along with the video if the audio setting is enabled.  @return An int value of the error code. 0 means success. 254 means initialization error. -2，means livestream feature is disabled by LDM. -3 means failure to obtain sps/pps.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_startStream_inline",
                   "",
            ],
            [
                   "stopStream",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_stopStream_inline",
                   "Stop the live streaming. The operation is asynchronous  and `isStreaming` will return `false`  when the operation is complete.",
            ],
            [
                   "Stop the live streaming. The operation is asynchronous  and `isStreaming` will return `false`  when the operation is complete.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_stopStream_inline",
                   "",
            ],
            [
                   "getStartTime",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getStartTime_inline",
                   "Returns the start time of the live streaming. The start time is  updated when `startStream` is successful.  @return A long value of the start time.",
            ],
            [
                   "Returns the start time of the live streaming. The start time is  updated when `startStream` is successful.  @return A long value of the start time.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getStartTime_inline",
                   "",
            ],
            [
                   "setAudioStreamingEnabled",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setAudioStreamingEnabled_inline",
                   "Enables/disables the audio streaming. When it is enabled, the audio received by the mobile device's microphone will be streamed  to the RTMP server along with the video. This setting will take effect before `startStream` is called. Changing this setting after `startStream` is called requires restarting the streaming. The audio can be  muted during the streaming by calling `setAudioMuted`.  @param enabled Pass `true` to enable the audio streaming, `false` to disable the audio streaming.",
            ],
            [
                   "Enables/disables the audio streaming. When it is enabled, the audio received by the mobile device's microphone will be streamed  to the RTMP server along with the video. This setting will take effect before `startStream` is called. Changing this setting after `startStream` is called requires restarting the streaming. The audio can be  muted during the streaming by calling `setAudioMuted`.  @param enabled Pass `true` to enable the audio streaming, `false` to disable the audio streaming.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setAudioStreamingEnabled_inline",
                   "",
            ],
            [
                   "setAudioMuted",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setAudioMuted_inline",
                   "Mutes the audio or unmutes the audio.  Notes: this method only works when audio function is enabled ( `isLiveAudioEnabled` returns `true`).  @param enable Pass `true` to mute the audio, `false` to unmute the audio.",
            ],
            [
                   "Mutes the audio or unmutes the audio.  Notes: this method only works when audio function is enabled ( `isLiveAudioEnabled` returns `true`).  @param enable Pass `true` to mute the audio, `false` to unmute the audio.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setAudioMuted_inline",
                   "",
            ],
            [
                   "isLiveAudioEnabled",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isLiveAudioEnabled_inline",
                   "Returns `true` if the audio function is enabled, vice versa.  @return A boolean value to check if the audio function is enabled.",
            ],
            [
                   "Returns `true` if the audio function is enabled, vice versa.  @return A boolean value to check if the audio function is enabled.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isLiveAudioEnabled_inline",
                   "",
            ],
            [
                   "isAudioMuted",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isAudioMuted_inline",
                   "Returns `true` if the audio is muted, vice versa.  @return A boolean value to check if the audio is muted.",
            ],
            [
                   "Returns `true` if the audio is muted, vice versa.  @return A boolean value to check if the audio is muted.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isAudioMuted_inline",
                   "",
            ],
            [
                   "setVideoEncodingEnabled",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setVideoEncodingEnabled_inline",
                   "Enables/disables the video encoding by force for the live streaming. The basic workflow to process  the video feed from the aircraft is to decode first and then encode again with a specific bit rate  into H.264 stream. Therefore, video encoding is required in default. For some drones like Mavic Pro,  the original video feed from Mavic Pro remote controller can be streamed to a RTMP server directly,  so the video encoding is disabled for Mavic Pro, however, the bit- rate of the original video is very  high, by enabling this flag, the original video will be decoded and encoded to a lower speed video stream.  @param enable Pass `true` to enable the Video Encoding, `false` to disable the Video Encoding.",
            ],
            [
                   "Enables/disables the video encoding by force for the live streaming. The basic workflow to process  the video feed from the aircraft is to decode first and then encode again with a specific bit rate  into H.264 stream. Therefore, video encoding is required in default. For some drones like Mavic Pro,  the original video feed from Mavic Pro remote controller can be streamed to a RTMP server directly,  so the video encoding is disabled for Mavic Pro, however, the bit- rate of the original video is very  high, by enabling this flag, the original video will be decoded and encoded to a lower speed video stream.  @param enable Pass `true` to enable the Video Encoding, `false` to disable the Video Encoding.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setVideoEncodingEnabled_inline",
                   "",
            ],
            [
                   "isVideoEncodingEnabled",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isVideoEncodingEnabled_inline",
                   "Returns `true` if video encoding is enabled, vice versa.  @return `true` if the force encoding flag is enabled.",
            ],
            [
                   "Returns `true` if video encoding is enabled, vice versa.  @return `true` if the force encoding flag is enabled.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_isVideoEncodingEnabled_inline",
                   "",
            ],
            [
                   "getLiveVideoFps",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoFps_inline",
                   "Returns the real-time live video fps.  @return A float value of the live video fps.",
            ],
            [
                   "Returns the real-time live video fps.  @return A float value of the live video fps.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoFps_inline",
                   "",
            ],
            [
                   "setLiveVideoResolution",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoResolution_inline",
                   "Sets the live video resolution.  @param videoResolution An emun value of the live video resolution.",
            ],
            [
                   "Sets the live video resolution.  @param videoResolution An emun value of the live video resolution.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoResolution_inline",
                   "",
            ],
            [
                   "getLiveVideoResolution",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoResolution_inline",
                   "Returns the live video resolution.  @return An emun value of the live video resolution.",
            ],
            [
                   "Returns the live video resolution.  @return An emun value of the live video resolution.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoResolution_inline",
                   "",
            ],
            [
                   "setLiveVideoBitRateMode",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoBitRateMode_inline",
                   "Sets the live video bit rate mode.  @param bitRateMode An emun value of the live video bit rate mode.",
            ],
            [
                   "Sets the live video bit rate mode.  @param bitRateMode An emun value of the live video bit rate mode.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoBitRateMode_inline",
                   "",
            ],
            [
                   "getLiveVideoBitRateMode",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoBitRateMode_inline",
                   "Returns the live video bit rate mode.  @return An emun value of the live video bit rate mode.",
            ],
            [
                   "Returns the live video bit rate mode.  @return An emun value of the live video bit rate mode.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoBitRateMode_inline",
                   "",
            ],
            [
                   "setLiveVideoBitRate",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoBitRate_inline",
                   "Sets the real-time video stream bit rate in kpbs.  @param bitRate A float value of the live video bit rate. The value should be in the range [0.5*1024, 3.5*1024] kpbs.",
            ],
            [
                   "Sets the real-time video stream bit rate in kpbs.  @param bitRate A float value of the live video bit rate. The value should be in the range [0.5*1024, 3.5*1024] kpbs.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_setLiveVideoBitRate_inline",
                   "",
            ],
            [
                   "getLiveVideoBitRate",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoBitRate_inline",
                   "Returns the real-time video stream bit rate in kpbs.  @return An int value of the live video bit rate.",
            ],
            [
                   "Returns the real-time video stream bit rate in kpbs.  @return An int value of the live video bit rate.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoBitRate_inline",
                   "",
            ],
            [
                   "getLiveAudioBitRate",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveAudioBitRate_inline",
                   "Returns the real-time audio stream bit rate in kpbs.  @return An int value of the live audio bit rate.",
            ],
            [
                   "Returns the real-time audio stream bit rate in kpbs.  @return An int value of the live audio bit rate.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveAudioBitRate_inline",
                   "",
            ],
            [
                   "getLiveVideoCacheSize",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoCacheSize_inline",
                   "Returns the real-time video cache list size, unit: frame.  @return An int value of the live video cache list size.",
            ],
            [
                   "Returns the real-time video cache list size, unit: frame.  @return An int value of the live video cache list size.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_getLiveVideoCacheSize_inline",
                   "",
            ],
            [
                   "LiveVideoResolution",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "",
                   "Enums represent the live video resolution.",
            ],
            [
                   "Enums represent the live video resolution.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_1920_1080",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1920_1080_inline",
                   "The live streaming video resolution is 1920x1080.",
            ],
            [
                   "The live streaming video resolution is 1920x1080.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1920_1080_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_1440_1080",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1440_1080_inline",
                   "The live streaming video resolution is 1440x1080.",
            ],
            [
                   "The live streaming video resolution is 1440x1080.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1440_1080_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_1280_720",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1280_720_inline",
                   "The live streaming video resolution is 1280x720.",
            ],
            [
                   "The live streaming video resolution is 1280x720.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1280_720_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_1280_960",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1280_960_inline",
                   "The live streaming video resolution is 1280x960.",
            ],
            [
                   "The live streaming video resolution is 1280x960.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_1280_960_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_960_720",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_960_720_inline",
                   "The live streaming video resolution is 960x720.",
            ],
            [
                   "The live streaming video resolution is 960x720.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_960_720_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_960_540",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_960_540_inline",
                   "The live streaming video resolution is 960x540.",
            ],
            [
                   "The live streaming video resolution is 960x540.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_960_540_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_720_540",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_720_540_inline",
                   "The live streaming video resolution is 720x540.",
            ],
            [
                   "The live streaming video resolution is 720x540.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_720_540_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_480_360",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_480_360_inline",
                   "The live streaming video resolution is 480x360.",
            ],
            [
                   "The live streaming video resolution is 480x360.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager_LiveVideoResolution.html",
                   "#DJILiveStreamManager_LiveVideoResolution_VIDEO_RESOLUTION_480_360_inline",
                   "",
            ],
            [
                   "LiveVideoBitRateMode",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_inline",
                   "Enums represent the live video bit rate mode.",
            ],
            [
                   "Enums represent the live video bit rate mode.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_AUTO_inline",
                   "The live video bit rate mode is auto. In this mode, the live video bit rate will change as the network changes, and smoothness is preferred.",
            ],
            [
                   "The live video bit rate mode is auto. In this mode, the live video bit rate will change as the network changes, and smoothness is preferred.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_AUTO_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_MANUAL_inline",
                   "The live video bit rate mode is manual. This is the initialization mode of live video. Initial live video bit rate is 2*1024 kbps.",
            ],
            [
                   "The live video bit rate mode is manual. This is the initialization mode of live video. Initial live video bit rate is 2*1024 kbps.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "#DJILiveStreamManager_LiveVideoBitRateMode_MANUAL_inline",
                   "",
            ],
            [
                   "setComponentListener",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_setDJIComponentListener_inline",
                   "Sets the listener for the DJI component.  @param listener The callback of `ComponentListener`.",
            ],
            [
                   "Sets the listener for the DJI component.  @param listener The callback of `ComponentListener`.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_setDJIComponentListener_inline",
                   "",
            ],
            [
                   "onConnectivityChange",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent_DJIComponentListenerInterface.html",
                   "#DJIBaseComponent_ConnectivityChanged_inline",
                   "Called when the connectivity status has changes for the component. This callback will be called when the component disconnects from the product. If the product itself gets disconnected,  this callback method will be called by all of the product component.  @param isConnected `true` if the component is connected.",
            ],
            [
                   "Called when the connectivity status has changes for the component. This callback will be called when the component disconnects from the product. If the product itself gets disconnected,  this callback method will be called by all of the product component.  @param isConnected `true` if the component is connected.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent_DJIComponentListenerInterface.html",
                   "#DJIBaseComponent_ConnectivityChanged_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_index_inline",
                   "Returns the component index. Index is zero based. A component will have an index greater than zero when there  are multiple components of the same type on the DJI product, and one of the components already has the index 0.  For instance, M210 can have two gimbal mounted cameras, and will therefore have two gimbal components with indices  0 and 1, and two camera components with indices 0 and 1. For Matrice 600, there are printed numbers on the battery  boxes. The `Battery` component instance with index 0 corresponds to battery compartment number 1. For Inspire 2  and M200 series, `Battery` with index 0 corresponds to the battery on the port (left hand) side of the aircraft.  For M210, M210 RTK, M300 RTK and M350 RTK, `Camera` and `Gimbal` with index 0 corresponds to the camera and gimbal on the port  (left hand) side of the aircraft. `Lidar` with index 0 corresponds to the lidar(Zenmuse L1) on the port  (left hand) side of the aircraft.  @return An int value of index.",
            ],
            [
                   "Returns the component index. Index is zero based. A component will have an index greater than zero when there  are multiple components of the same type on the DJI product, and one of the components already has the index 0.  For instance, M210 can have two gimbal mounted cameras, and will therefore have two gimbal components with indices  0 and 1, and two camera components with indices 0 and 1. For Matrice 600, there are printed numbers on the battery  boxes. The `Battery` component instance with index 0 corresponds to battery compartment number 1. For Inspire 2  and M200 series, `Battery` with index 0 corresponds to the battery on the port (left hand) side of the aircraft.  For M210, M210 RTK, M300 RTK and M350 RTK, `Camera` and `Gimbal` with index 0 corresponds to the camera and gimbal on the port  (left hand) side of the aircraft. `Lidar` with index 0 corresponds to the lidar(Zenmuse L1) on the port  (left hand) side of the aircraft.  @return An int value of index.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_index_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_connected_inline",
                   "`true` if the component is connected.  @return `true` if the component is connected.",
            ],
            [
                   "`true` if the component is connected.  @return `true` if the component is connected.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_connected_inline",
                   "",
            ],
            [
                   "getSerialNumber",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_getSerialNumber_inline",
                   "Gets the serial number of the component. Depending on the component, this serial number might not match the serial number found  on the physical component.  @param callback The execution callback with the value returned.",
            ],
            [
                   "Gets the serial number of the component. Depending on the component, this serial number might not match the serial number found  on the physical component.  @param callback The execution callback with the value returned.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_getSerialNumber_inline",
                   "",
            ],
            [
                   "getFirmwareVersion",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_getFirmwareVersion_inline",
                   "Returns the firmware version of the component. Each component will  have a different firmware version, the combination of which will  form the package firmware version `getFirmwarePackageVersion` found in `BaseProduct`.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Returns the firmware version of the component. Each component will  have a different firmware version, the combination of which will  form the package firmware version `getFirmwarePackageVersion` found in `BaseProduct`.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "#DJIBaseComponent_getFirmwareVersion_inline",
                   "",
            ],
            [
                   "ComponentListener",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent_DJIComponentListenerInterface.html",
                   "",
                   "Receives notifications of component connectivity changes.",
            ],
            [
                   "Receives notifications of component connectivity changes.",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent_DJIComponentListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "authorizeAccessToDJIDeviceHardwareInfo",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_authorizeAccessToDJIDeviceHardwareInfo_inline",
                   "Authorizes DJI server to access DJI device's hardware information (serial numbers of the aircraft and the remote  controller). The serial number will be sent to DJI server for two purposes:  - DJI SDK analytics: the hashed  serial number is used to distinguish statistics from different DJI devices.  - App Activation: the serial number  is used to request the app activation state from the server. When the user is located in China, the serial number is still sent to DJI server for policy reason even it is not authorized by the user. DJI server is NOT authorized by  default. However, it is highly recommended to ask the user to authorize it, which can help DJI keep improving SDK.  @param hardwareInfoAuthorized `true` to authorize DJI server to access the data.  @return The encountered error if there is any.",
            ],
            [
                   "Authorizes DJI server to access DJI device's hardware information (serial numbers of the aircraft and the remote  controller). The serial number will be sent to DJI server for two purposes:  - DJI SDK analytics: the hashed  serial number is used to distinguish statistics from different DJI devices.  - App Activation: the serial number  is used to request the app activation state from the server. When the user is located in China, the serial number is still sent to DJI server for policy reason even it is not authorized by the user. DJI server is NOT authorized by  default. However, it is highly recommended to ask the user to authorize it, which can help DJI keep improving SDK.  @param hardwareInfoAuthorized `true` to authorize DJI server to access the data.  @return The encountered error if there is any.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_authorizeAccessToDJIDeviceHardwareInfo_inline",
                   "",
            ],
            [
                   "isAccessToDJIDeviceHardwareInfoAuthorized",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAccessToDJIDeviceHardwareInfoAuthorized_inline",
                   "Get the authorization of access to data of type DJI Hardware Information.  @return `true` if it is authorized.",
            ],
            [
                   "Get the authorization of access to data of type DJI Hardware Information.  @return `true` if it is authorized.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAccessToDJIDeviceHardwareInfoAuthorized_inline",
                   "",
            ],
            [
                   "isAccessToObfuscatedLocationAuthorized",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAccessToObfuscatedLocationAuthorized_inline",
                   "Get the authorization of access to data of type Obfuscated Location.  @return `true` if it is authorized.",
            ],
            [
                   "Get the authorization of access to data of type Obfuscated Location.  @return `true` if it is authorized.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAccessToObfuscatedLocationAuthorized_inline",
                   "",
            ],
            [
                   "agreeToProductImprovement",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_agreeToProductImprovement_inline",
                   "Agree or disagree with the product improvement project. Through this project, the DJI device information, mobile device information,  and diagnostic and usage data collected through MSDK will be provided to DJI for analysis.  This analysis helps DJI improve products and services.  DJI will take necessary data protection measures before data analysis.  @param isAgree `true` to ageree product improvement project.  @return The encountered error if there is any.",
            ],
            [
                   "Agree or disagree with the product improvement project. Through this project, the DJI device information, mobile device information,  and diagnostic and usage data collected through MSDK will be provided to DJI for analysis.  This analysis helps DJI improve products and services.  DJI will take necessary data protection measures before data analysis.  @param isAgree `true` to ageree product improvement project.  @return The encountered error if there is any.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_agreeToProductImprovement_inline",
                   "",
            ],
            [
                   "isAgreeToProductImprovement",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAgreeToProductImprovement_inline",
                   "Gets whether to agree to the product improvement project.  @return `true` if it is agreed to product improvement project.",
            ],
            [
                   "Gets whether to agree to the product improvement project.  @return `true` if it is agreed to product improvement project.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_isAgreeToProductImprovement_inline",
                   "",
            ],
            [
                   "getInstance",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_getInstance_inline",
                   "Get the singleton instance of the class.  @return An object of `DataProtectionManager`.",
            ],
            [
                   "Get the singleton instance of the class.  @return An object of `DataProtectionManager`.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "#DJIDataProtectionManager_getInstance_inline",
                   "",
            ],
            [
                   "DJISDKManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "",
                   "This class is the entry point for using the SDK with a DJI product. Most importantly, this class is used to register the SDK, and to connect to and access the product. This class also provides access to important feature managers (such as `getKeyManager`), debugging tools, and threading control of asynchronous callbacks. SDK Registration using `registerApp` must be successful before the SDK can be used with a DJI product.",
            ],
            [
                   "This class is the entry point for using the SDK with a DJI product. Most importantly, this class is used to register the SDK, and to connect to and access the product. This class also provides access to important feature managers (such as `getKeyManager`), debugging tools, and threading control of asynchronous callbacks. SDK Registration using `registerApp` must be successful before the SDK can be used with a DJI product.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "",
                   "",
            ],
            [
                   "KeyManager",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "",
                   "`KeyManager` provides access to the keyed interface using `DJIKey` and corresponding subclass objects. `KeyManager` is accessed from `getKeyManager` in `DJISDKManager`.",
            ],
            [
                   "`KeyManager` provides access to the keyed interface using `DJIKey` and corresponding subclass objects. `KeyManager` is accessed from `getKeyManager` in `DJISDKManager`.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "",
                   "",
            ],
            [
                   "FlyZoneManager",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "",
                   "Fly Zone Manager gives information about nearby fly zones, and APIs to unlock zones that can be unlocked. Depending on location, there are three types of fly zones possible:  - `CIRCLE`: Cylinder or truncated cone volume with four levels of restriction:     - Warning Zones : no restriction     - Enhanced warning zones : Flight restricted, can be unlocked for         flight when the user logs into their DJI account     - Authorization zones : Flight restricted, can be unlocked for         flight when the user logs into their DJI account and the account         has been authorized to unlock authorization zones.     - Restricted zones : Flight restricted - `POLY`: Fly zone that consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. A height limitation of 0 means flight is completely restricted. This is used by Spark, Mavic, Phantom 4 Series, Inspire 2 and Matrice 200 series. On the Phantom 3, Inspire 1, M100, M600, A3/N3 series of products, there can also be a buffer area with radius about 23 km around a restricted fly zone where flight height is limited to 120m.</br> Not supported by DJI Air 2S.</br>",
            ],
            [
                   "Fly Zone Manager gives information about nearby fly zones, and APIs to unlock zones that can be unlocked. Depending on location, there are three types of fly zones possible:  - `CIRCLE`: Cylinder or truncated cone volume with four levels of restriction:     - Warning Zones : no restriction     - Enhanced warning zones : Flight restricted, can be unlocked for         flight when the user logs into their DJI account     - Authorization zones : Flight restricted, can be unlocked for         flight when the user logs into their DJI account and the account         has been authorized to unlock authorization zones.     - Restricted zones : Flight restricted - `POLY`: Fly zone that consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. A height limitation of 0 means flight is completely restricted. This is used by Spark, Mavic, Phantom 4 Series, Inspire 2 and Matrice 200 series. On the Phantom 3, Inspire 1, M100, M600, A3/N3 series of products, there can also be a buffer area with radius about 23 km around a restricted fly zone where flight height is limited to 120m.</br> Not supported by DJI Air 2S.</br>",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "",
                   "",
            ],
            [
                   "AppActivationManager",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "",
                   "DJI aircraft firmware require mobile applications that control DJI aircraft to be activated with the user's DJI account, if that application is being used in China. This will ensure operators use the correct set of geospatial information and flight functions for their aircraft, as determined by their geographical location and user profile.  A summary of the activation system is:  - Users in China are required to activate their application by logging into their DJI account at least once every three months within the application  - Activation will be persistent in the application until the user logs out  - A data connection will be required to log into a DJI account  - Outside of China, the SDK will automatically activate the application without requiring the user to log in  - Additionally, users in china are required to bind their aircraft to their user account in DJI Go. This is required only once.  If an application is not activated, the aircraft not bound (if required), or a legacy version of the SDK (<4.1) is being used, all camera live streams will be disabled, and flight will be limited to a cylinder of 100m diameter and 30m height to ensure the aircraft stays within line of sight.  This class is used to check the state of application activation and aircraft binding.",
            ],
            [
                   "DJI aircraft firmware require mobile applications that control DJI aircraft to be activated with the user's DJI account, if that application is being used in China. This will ensure operators use the correct set of geospatial information and flight functions for their aircraft, as determined by their geographical location and user profile.  A summary of the activation system is:  - Users in China are required to activate their application by logging into their DJI account at least once every three months within the application  - Activation will be persistent in the application until the user logs out  - A data connection will be required to log into a DJI account  - Outside of China, the SDK will automatically activate the application without requiring the user to log in  - Additionally, users in china are required to bind their aircraft to their user account in DJI Go. This is required only once.  If an application is not activated, the aircraft not bound (if required), or a legacy version of the SDK (<4.1) is being used, all camera live streams will be disabled, and flight will be limited to a cylinder of 100m diameter and 30m height to ensure the aircraft stays within line of sight.  This class is used to check the state of application activation and aircraft binding.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "",
                   "",
            ],
            [
                   "UserAccountManager",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "",
                   "Class used to manage the DJI account.",
            ],
            [
                   "Class used to manage the DJI account.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "",
                   "",
            ],
            [
                   "DataProtectionManager",
                   2,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "",
                   "Data Protection Manager. DJI SDK will send data to DJI servers in the background in order to complete logics, including data related to user's information. Data Protection Manager can be used to authorize DJI server to access the user- related data. SDK will NOT send the data to DJI server in the background before the authorization. Internet requests triggered by the user manually are not managed by `DataProtectionManager`. Involved user-related data is listed in the documentation of the interfaces. This class is accessible before calling `registerApp`. The UTMISSManager class needs to report flight dynamic data to the UTMISS server in accordance with the policy requirements of the Civil Aviation Administration of China. It is not in this category of management. For details, please refer to the UTMISSManager interface document.",
            ],
            [
                   "Data Protection Manager. DJI SDK will send data to DJI servers in the background in order to complete logics, including data related to user's information. Data Protection Manager can be used to authorize DJI server to access the user- related data. SDK will NOT send the data to DJI server in the background before the authorization. Internet requests triggered by the user manually are not managed by `DataProtectionManager`. Involved user-related data is listed in the documentation of the interfaces. This class is accessible before calling `registerApp`. The UTMISSManager class needs to report flight dynamic data to the UTMISS server in accordance with the policy requirements of the Civil Aviation Administration of China. It is not in this category of management. For details, please refer to the UTMISSManager interface document.",
                   1,
                   "/Components/DataProtectionManager/DJIDataProtectionManager.html",
                   "",
                   "",
            ],
            [
                   "LDMManager",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "",
                   "Local Data Mode (LDM) manager. When Local Data Mode is enabled, the SDK's access to the internet is restricted. You should use `registerAppForLDM` to register the app. Only application registration (confirming the app key is valid) will be unrestricted. All other SDK services will be restricted. When the SDK's internet access is restricted, all SDK services that require an internet connection will not be available or able to update. For instance, the Fly Zone manager will not be able to update the fly zone data base, retrieve the latest TFRs (temporary flight restrictions) or unlock fly zones. LDM is therefore most appropriate for users that have very stringent data requirements, and are able to accommodate this restricted functionality.  When Local Data Mode is enabled, the UTMISSManager will not report flight dynamic data to the UTMISS server.",
            ],
            [
                   "Local Data Mode (LDM) manager. When Local Data Mode is enabled, the SDK's access to the internet is restricted. You should use `registerAppForLDM` to register the app. Only application registration (confirming the app key is valid) will be unrestricted. All other SDK services will be restricted. When the SDK's internet access is restricted, all SDK services that require an internet connection will not be available or able to update. For instance, the Fly Zone manager will not be able to update the fly zone data base, retrieve the latest TFRs (temporary flight restrictions) or unlock fly zones. LDM is therefore most appropriate for users that have very stringent data requirements, and are able to accommodate this restricted functionality.  When Local Data Mode is enabled, the UTMISSManager will not report flight dynamic data to the UTMISS server.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "",
                   "",
            ],
            [
                   "UTMISSManager",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "",
                   "This class is to manage UTMISS flight data upload. According to the Civil Aviation Administration of China's Light Civil UAV Flight Dynamic Data Management Regulations , relevant units, individuals that operate light, small civil drones and plant protection drones in the airspace provided by the People's Republic of China with air traffic services need Timely, accurate and complete real-time reporting to the Civil Aviation Administration to send real flight dynamic data. If flight dynamic data is not reported or missed in time, it shall be replaced in accordance with relevant regulations on navigation flight control. According to the above requirements, this function will report user flight dynamics data to the UTMISS server. Developers are requested to enable this function after obtaining user authorization.",
            ],
            [
                   "This class is to manage UTMISS flight data upload. According to the Civil Aviation Administration of China's Light Civil UAV Flight Dynamic Data Management Regulations , relevant units, individuals that operate light, small civil drones and plant protection drones in the airspace provided by the People's Republic of China with air traffic services need Timely, accurate and complete real-time reporting to the Civil Aviation Administration to send real flight dynamic data. If flight dynamic data is not reported or missed in time, it shall be replaced in accordance with relevant regulations on navigation flight control. According to the above requirements, this function will report user flight dynamics data to the UTMISS server. Developers are requested to enable this function after obtaining user authorization.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "",
                   "",
            ],
            [
                   "FlightHubManager",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "",
                   "The FlightHubManager class provides methods to interact with DJI FlightHub (https://www.dji.com/flighthub). SDK provides interfaces to upload the states of the connected aircraft to the FlightHub server and download the flight data from the server. To access DJI FlightHub features through SDK, the logged-in user should be already activated with a valid FlightHub license. Use `isUserActivated` to check if the user is activated. Note: Invoke `updateActivationState` before using any other method to verify your accessibility.",
            ],
            [
                   "The FlightHubManager class provides methods to interact with DJI FlightHub (https://www.dji.com/flighthub). SDK provides interfaces to upload the states of the connected aircraft to the FlightHub server and download the flight data from the server. To access DJI FlightHub features through SDK, the logged-in user should be already activated with a valid FlightHub license. Use `isUserActivated` to check if the user is activated. Note: Invoke `updateActivationState` before using any other method to verify your accessibility.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "",
                   "",
            ],
            [
                   "LiveStreamManager",
                   2,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "",
                   "The manager is used to stream the video to a RTMP server to do live streaming with DJI products.",
            ],
            [
                   "The manager is used to stream the video to a RTMP server to do live streaming with DJI products.",
                   1,
                   "/Components/LiveStreamManager/DJILiveStreamManager.html",
                   "",
                   "",
            ],
            [
                   "IUASRemoteIDManager",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "",
                   "RID management class of the drone system. In order to meet the increasingly standardized drone regulatory requirements around the world, The drone in flight should be able to broadcast the identification and location of the operator and the drone.",
            ],
            [
                   "RID management class of the drone system. In order to meet the increasingly standardized drone regulatory requirements around the world, The drone in flight should be able to broadcast the identification and location of the operator and the drone.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "",
                   "",
            ],
            [
                   "UpgradeManager",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "",
                   "This interface is used to manage the component that can be upgraded. It is only supported by Mavic Air, Mavic 2 series and Matrice 300 RTK.",
            ],
            [
                   "This interface is used to manage the component that can be upgraded. It is only supported by Mavic Air, Mavic 2 series and Matrice 300 RTK.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "",
                   "",
            ],
            [
                   "BaseProduct",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "",
                   "Abstract class for all DJI Products. `Aircraft` and `HandHeld` objects are subclasses of `BaseProduct` and can be accessed from `getProduct` in `DJISDKManager`. Additional components can be found in `Aircraft` and `HandHeld` that are unique to those products only.",
            ],
            [
                   "Abstract class for all DJI Products. `Aircraft` and `HandHeld` objects are subclasses of `BaseProduct` and can be accessed from `getProduct` in `DJISDKManager`. Additional components can be found in `Aircraft` and `HandHeld` that are unique to those products only.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "",
                   "",
            ],
            [
                   "BaseComponent",
                   2,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "",
                   "Abstract class for components in a DJI Product. A component can be a camera, gimbal, remote controller, etc. A DJI product consists of several components. All components of a product are subclasses of `BaseComponent` and can be accessed directly from the product objects (`Aircraft` or `HandHeld`).",
            ],
            [
                   "Abstract class for components in a DJI Product. A component can be a camera, gimbal, remote controller, etc. A DJI product consists of several components. All components of a product are subclasses of `BaseComponent` and can be accessed directly from the product objects (`Aircraft` or `HandHeld`).",
                   1,
                   "/Components/BaseComponent/DJIBaseComponent.html",
                   "",
                   "",
            ],
            [
                   "Aircraft",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "",
                   "Aircraft product class, which includes basic product information and access to all components (such as flight controller, battery etc.). This object is accessed from `getProduct` in `DJISDKManager`.",
            ],
            [
                   "Aircraft product class, which includes basic product information and access to all components (such as flight controller, battery etc.). This object is accessed from `getProduct` in `DJISDKManager`.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "",
                   "",
            ],
            [
                   "HandHeld",
                   2,
                   "/Products/Handheld/DJIHandheld.html",
                   "",
                   "Handheld product class, which includes basic product information and access to all components (such as camera, battery etc.). This object is accessed from `getProduct` in `DJISDKManager`.",
            ],
            [
                   "Handheld product class, which includes basic product information and access to all components (such as camera, battery etc.). This object is accessed from `getProduct` in `DJISDKManager`.",
                   1,
                   "/Products/Handheld/DJIHandheld.html",
                   "",
                   "",
            ],
            [
                   "FlightController",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "",
                   "This class contains components of the flight controller and provides methods to send different commands to the flight controller. This object is available from the `Aircraft` object which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class contains components of the flight controller and provides methods to send different commands to the flight controller. This object is available from the `Aircraft` object which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "",
                   "",
            ],
            [
                   "Battery",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "",
                   "This class manages information and real-time status of the connected product's batteries. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class manages information and real-time status of the connected product's batteries. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "",
                   "",
            ],
            [
                   "Camera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "",
                   "This class contains the media manager and playback manager, which manage the camera's media content. It provides methods to change camera settings and perform camera actions. This object is available from the `Aircraft` or `HandHeld` object, which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class contains the media manager and playback manager, which manage the camera's media content. It provides methods to change camera settings and perform camera actions. This object is available from the `Aircraft` or `HandHeld` object, which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "",
                   "",
            ],
            [
                   "Gimbal",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "",
                   "This class provides multiple methods to control the gimbal. These include setting the gimbal work mode, rotating the gimbal with angle, starting the gimbal auto calibration, etc. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class provides multiple methods to control the gimbal. These include setting the gimbal work mode, rotating the gimbal with angle, starting the gimbal auto calibration, etc. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "",
                   "",
            ],
            [
                   "AirLink",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "",
                   "This class contains information about the wireless link between the aircraft and the remote controller, the aircraft and the mobile device or the handheld product and the mobile device. To determine whether a particular wireless link is supported, check the isSupported flag. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class contains information about the wireless link between the aircraft and the remote controller, the aircraft and the mobile device or the handheld product and the mobile device. To determine whether a particular wireless link is supported, check the isSupported flag. This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "",
                   "",
            ],
            [
                   "RemoteController",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "",
                   "This class represents the remote controller of the aircraft. It provides methods to change the settings of the physical remote controller. For some products (e.g. Inspire 1 and Matrice 100), the class provides methods to manager the slave/master mode of the remote controllers. A remote controller is a device that can have a GPS, battery, radio, buttons, sticks, wheels, and output ports for video. The mobile device is connected to the remote controller, which is always sending out information about what everything is doing. The normal remote controller is called the master. A slave wirelessly connects to the master remote controller at 5 GHz, and the aircraft can also download information to the slave. The slave can send gimbal control commands to the master. This configuration allows one person to fly the aircraft while another person controls the gimbal. This object is available from the `Aircraft` subclass off `BaseProduct`.",
            ],
            [
                   "This class represents the remote controller of the aircraft. It provides methods to change the settings of the physical remote controller. For some products (e.g. Inspire 1 and Matrice 100), the class provides methods to manager the slave/master mode of the remote controllers. A remote controller is a device that can have a GPS, battery, radio, buttons, sticks, wheels, and output ports for video. The mobile device is connected to the remote controller, which is always sending out information about what everything is doing. The normal remote controller is called the master. A slave wirelessly connects to the master remote controller at 5 GHz, and the aircraft can also download information to the slave. The slave can send gimbal control commands to the master. This configuration allows one person to fly the aircraft while another person controls the gimbal. This object is available from the `Aircraft` subclass off `BaseProduct`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "",
                   "",
            ],
            [
                   "HandheldController",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "",
                   "This class contains interfaces related to the hand controller of a handheld device (such as Osmo). This object is available from the `HandHeld` subclass off `BaseProduct`.",
            ],
            [
                   "This class contains interfaces related to the hand controller of a handheld device (such as Osmo). This object is available from the `HandHeld` subclass off `BaseProduct`.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "",
                   "",
            ],
            [
                   "MobileRemoteController",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "",
                   "A simulated remote controller on the mobile device to control the aircraft when the physical remote controller is absent. The mobile remote controller only supports Mode 2 control style and flight mode P. It is supported by Mavic Pro using WiFi. This object is available from the `Aircraft` subclass off `BaseProduct`.",
            ],
            [
                   "A simulated remote controller on the mobile device to control the aircraft when the physical remote controller is absent. The mobile remote controller only supports Mode 2 control style and flight mode P. It is supported by Mavic Pro using WiFi. This object is available from the `Aircraft` subclass off `BaseProduct`.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "",
                   "",
            ],
            [
                   "Payload",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "",
                   "Class used to interact with the payload device mounted on DJI aircraft. <b>Note: In the MSDK V4 version, the PSDK payload device cannot be used with Zenmuse L1 and Zenmuse P1 at the same time. If you need to use them at the same time, please upgrade to MSDK V5.</b>",
            ],
            [
                   "Class used to interact with the payload device mounted on DJI aircraft. <b>Note: In the MSDK V4 version, the PSDK payload device cannot be used with Zenmuse L1 and Zenmuse P1 at the same time. If you need to use them at the same time, please upgrade to MSDK V5.</b>",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "",
                   "",
            ],
            [
                   "AccessoryAggregation",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "",
                   "This class contains all possible accessories (spotlight, beacon and speaker) supported by the aircraft. The accessory aggregation component is available when Mavic 2 Enterprise is connected. An accessory becomes available only when the accessory is connected to the aircraft.",
            ],
            [
                   "This class contains all possible accessories (spotlight, beacon and speaker) supported by the aircraft. The accessory aggregation component is available when Mavic 2 Enterprise is connected. An accessory becomes available only when the accessory is connected to the aircraft.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "",
                   "",
            ],
            [
                   "BaseStation",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "",
                   "RTK Base Station.",
            ],
            [
                   "RTK Base Station.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "",
                   "",
            ],
            [
                   "Lidar",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "",
                   "This class represents the lidar of the aircraft which contanis the related functions of livox. Current only supported by Zenmuse L1. Note: Zenmuse L1 can only be set at Gimbal position 0 where it is at the left side of the aircraft.  The Zenmuse L1 integrates a Livox Lidar module, a high-accuracy IMU, and a camera with a 1-inch CMOS on a 3-axis stabilized gimbal. When used with Matrice 300 RTK and DJI Terra, the L1 forms a complete solution that gives you real-time 3D data throughout the day, efficiently capturing the details of complex structures and delivering highly accurate reconstructed models.  This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
            ],
            [
                   "This class represents the lidar of the aircraft which contanis the related functions of livox. Current only supported by Zenmuse L1. Note: Zenmuse L1 can only be set at Gimbal position 0 where it is at the left side of the aircraft.  The Zenmuse L1 integrates a Livox Lidar module, a high-accuracy IMU, and a camera with a 1-inch CMOS on a 3-axis stabilized gimbal. When used with Matrice 300 RTK and DJI Terra, the L1 forms a complete solution that gives you real-time 3D data throughout the day, efficiently capturing the details of complex structures and delivering highly accurate reconstructed models.  This object is available from the `Aircraft` or `HandHeld` object which is a subclass of `BaseProduct`.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "",
                   "",
            ],
            [
                   "MissionControl",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "",
                   "Mission Control handles execution of missions. Either single missions can be run through dedicated mission operators, or a series of missions and actions can be run serially using the Timeline.  Mission operators look after execution of a single mission. A mission operator has APIs to control the mission (e.g. start, stop, pause etc.) and provides mission state through listeners.  Mission Control's Timeline is made up of a series of Timeline elements which can be Waypoint missions, Hotpoint missions (through the Hotpoint action `HotpointAction`) or objects that follow the `TimelineElement` protocol. `MissionAction` is a Timeline element, with `AircraftYawAction` and `GimbalAttitudeAction` subclasses being examples of specific actions. If a mission is being executed in a Timeline, the mission operator can still be used to get state information of the mission as well as change mission execution parameters.  Timeline elements can also have triggers (`Trigger`) associated with them. Triggers are separate objects that are run in parallel with a Timeline element. The trigger object is used to initiate actions if a set of criteria are met. For example, a trigger could be used to monitor battery level, and then initiate an action once a threshold is passed. Mission Control's Timeline is only supported by aircrafts. Handheld devices (e.g. OSMO) do not support this feature.  > Mission Control is accessed from `getMissionControl` in `DJISDKManager`.",
            ],
            [
                   "Mission Control handles execution of missions. Either single missions can be run through dedicated mission operators, or a series of missions and actions can be run serially using the Timeline.  Mission operators look after execution of a single mission. A mission operator has APIs to control the mission (e.g. start, stop, pause etc.) and provides mission state through listeners.  Mission Control's Timeline is made up of a series of Timeline elements which can be Waypoint missions, Hotpoint missions (through the Hotpoint action `HotpointAction`) or objects that follow the `TimelineElement` protocol. `MissionAction` is a Timeline element, with `AircraftYawAction` and `GimbalAttitudeAction` subclasses being examples of specific actions. If a mission is being executed in a Timeline, the mission operator can still be used to get state information of the mission as well as change mission execution parameters.  Timeline elements can also have triggers (`Trigger`) associated with them. Triggers are separate objects that are run in parallel with a Timeline element. The trigger object is used to initiate actions if a set of criteria are met. For example, a trigger could be used to monitor battery level, and then initiate an action once a threshold is passed. Mission Control's Timeline is only supported by aircrafts. Handheld devices (e.g. OSMO) do not support this feature.  > Mission Control is accessed from `getMissionControl` in `DJISDKManager`.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "",
                   "",
            ],
            [
                   "MissionAction",
                   2,
                   "/Components/Missions/DJIMissionAction.html",
                   "",
                   "Base class for all Mission Control Timeline based actions.",
            ],
            [
                   "Base class for all Mission Control Timeline based actions.",
                   1,
                   "/Components/Missions/DJIMissionAction.html",
                   "",
                   "",
            ],
            [
                   "TimelineMission",
                   2,
                   "/Components/Missions/TimelineMission.html",
                   "",
                   "Wrapper class for the different types of Mission to be compatible with Timeline.",
            ],
            [
                   "Wrapper class for the different types of Mission to be compatible with Timeline.",
                   1,
                   "/Components/Missions/TimelineMission.html",
                   "",
                   "",
            ],
            [
                   "Trigger",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "",
                   "Mission Triggers can be used to trigger an action during the execution of a Timeline element if a set of criteria is met. The subclass of `Trigger` should implement the logic for collecting and judging the criteria, and then executing the action. Mission Triggers are used in the Timeline element `TimelineElement`.  Trigger actions can be listened to, so when subclassing this class, `notifyListenersOfEvent` should be used to notify listeners of trigger events.  See Also: DJIMissionControl",
            ],
            [
                   "Mission Triggers can be used to trigger an action during the execution of a Timeline element if a set of criteria is met. The subclass of `Trigger` should implement the logic for collecting and judging the criteria, and then executing the action. Mission Triggers are used in the Timeline element `TimelineElement`.  Trigger actions can be listened to, so when subclassing this class, `notifyListenersOfEvent` should be used to notify listeners of trigger events.  See Also: DJIMissionControl",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionOperator",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "",
                   "The waypoint operator is the only object that controls, runs and monitors Waypoint Missions. It can be accessed from `MissionControl`. For Matrice 300 RTK,  it is recommended that you use `WaypointV2MissionOperator`. `WaypointMissionOperator` Will no longer be maintained.",
            ],
            [
                   "The waypoint operator is the only object that controls, runs and monitors Waypoint Missions. It can be accessed from `MissionControl`. For Matrice 300 RTK,  it is recommended that you use `WaypointV2MissionOperator`. `WaypointMissionOperator` Will no longer be maintained.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "WaypointV2MissionOperator",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "",
                   "The waypoint operator is the only object that controls, runs and monitors Waypoint V2 Missions. It can be accessed from `MissionControl`.",
            ],
            [
                   "The waypoint operator is the only object that controls, runs and monitors Waypoint V2 Missions. It can be accessed from `MissionControl`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "",
                   "",
            ],
            [
                   "FollowMeMissionOperator",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "",
                   "The follow me mission operator is the only object that controls, runs and monitors FollowMe Missions. It can be accessed from `MissionControl`.",
            ],
            [
                   "The follow me mission operator is the only object that controls, runs and monitors FollowMe Missions. It can be accessed from `MissionControl`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "PanoramaMissionOperator",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "",
                   "The panorama mission operator is the only object that controls, runs and monitors Panorama Missions. It can be accessed from `MissionControl`.",
            ],
            [
                   "The panorama mission operator is the only object that controls, runs and monitors Panorama Missions. It can be accessed from `MissionControl`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "HotpointMissionOperator",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "",
                   "The hotpoint mission operator is the only object that controls, runs and monitors Hotpoint Missions. It can be accessed from `MissionControl`.",
            ],
            [
                   "The hotpoint mission operator is the only object that controls, runs and monitors Hotpoint Missions. It can be accessed from `MissionControl`.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "IntelligentHotpointMissionOperator",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "",
                   "The Intelligent hotpoint mission operator is the only object that controls, runs and monitors Intelligent Hotpoint Missions. It can be accessed from `MissionControl`. `IntelligentHotpointMissionOperator` has two ways to start an Intelligent hotpoint mission: One is to start a `DJIIntelligentHotpointMission`, which will repeatedly around a specified point called hotpoint. The other you will target a rect in your FPV view, and send it to Vision system to track, when the state change to `DJIIntelligentHotpointMissionOperator_WaitingForConfirmation`, you can `acceptConfirmation`, then the aircraft will fly around the object. When mission executing, it will not need target object, actually track mode only help to set hotpoint at a target object.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "The Intelligent hotpoint mission operator is the only object that controls, runs and monitors Intelligent Hotpoint Missions. It can be accessed from `MissionControl`. `IntelligentHotpointMissionOperator` has two ways to start an Intelligent hotpoint mission: One is to start a `DJIIntelligentHotpointMission`, which will repeatedly around a specified point called hotpoint. The other you will target a rect in your FPV view, and send it to Vision system to track, when the state change to `DJIIntelligentHotpointMissionOperator_WaitingForConfirmation`, you can `acceptConfirmation`, then the aircraft will fly around the object. When mission executing, it will not need target object, actually track mode only help to set hotpoint at a target object.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "TapFlyMissionOperator",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "",
                   "The operator for TapFly mission. It is used to execute a TapFly mission.",
            ],
            [
                   "The operator for TapFly mission. It is used to execute a TapFly mission.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "ActiveTrackOperator",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "",
                   "The active track mission operator is the only object that controls, runs and monitors ActiveTrack Missions. It can be accessed from `MissionControl`.  An ActiveTrack Mission allows an aircraft to track a moving subject using the vision system and without a GPS tracker on the subject. To use an ActiveTrack mission:  - Prepare a mission with the rectangle that best represents the target to track  - Start the mission to initiate tracking of the object and begin the state updates (`getCurrentState`)  - At this point, the aircraft will track the target while hovering in place.  - Give confirmation that the tracked target is correct with `acceptConfirmation` and the aircraft will begin flying relative to the target. For Mavic Air 2 and DJI Air 2S, only CIRCLE mode need to be confirmation.  - If the tracking algorithm looses sufficient confidence in tracking the target, then the aircraft will stop flying relative to the object and either notify the user (through execution state) that the target is lost or it needs another confirmation that the target is correct.  - If you want to pause the mission, you can swith the mission mode to `SPOTLIGHT`, the aircraft will hover in place, but continue tracking the target by adjusting gimbal pitch and aircraft yaw.  - If you want to resume the mission, You can switch the mission mode to track mode again, confirmation of tracking rectangle will need to be sent through to start flying relative to target. (For Mavic Air 2 and DJI Air 2S, there is no need to confirm when you switch mode, Since there is no obstacle avoidance system on the left and right sides, be especially careful in the CIRCLE mode.)  - The mission can be canceled with `stopTracking` at any time. - `stopTracking` should also be used to reject tracking confirmation if the camera is tracking the wrong target. After stopping the mission, the mission needs to be recreated with a new rectangle and loaded into the operator.  - The main camera is used to track the target, so gimbal cannot be adjusted during an ActiveTrack mission.  - During the mission the aircraft can be manually flown with roll and throttle. Pitch,yaw and gimbal are automatically controlled to continue tracking the target.  - If the mission is executing, and after confirmation of the tracking rectangle has been sent, the aircraft can be manually controlled horizontally similar to a `HOME_LOCK` where the home is the tracked target. If aircraft is manually controlled upward, the aircraft will lift and retreat, and if it is controlled downward, it will go down and get closer to the target.  - For Mavic Air 2 and DJI Air 2S, you can use the ActiveTrack Mission in the Normal, Sport, Tripod flight modes. Because obstacle sensing is disabled in sport mode, so please use ActiveTrack Mission in an open area.  - For Matrice 300 RTK, only support Spotlight mode. You can use `setSpotlightMode` to set the spotlight mode which support `ZOOM_GIMBAL_FOLLOWING` and `ZOOM_GIMBAL_FREE` .",
            ],
            [
                   "The active track mission operator is the only object that controls, runs and monitors ActiveTrack Missions. It can be accessed from `MissionControl`.  An ActiveTrack Mission allows an aircraft to track a moving subject using the vision system and without a GPS tracker on the subject. To use an ActiveTrack mission:  - Prepare a mission with the rectangle that best represents the target to track  - Start the mission to initiate tracking of the object and begin the state updates (`getCurrentState`)  - At this point, the aircraft will track the target while hovering in place.  - Give confirmation that the tracked target is correct with `acceptConfirmation` and the aircraft will begin flying relative to the target. For Mavic Air 2 and DJI Air 2S, only CIRCLE mode need to be confirmation.  - If the tracking algorithm looses sufficient confidence in tracking the target, then the aircraft will stop flying relative to the object and either notify the user (through execution state) that the target is lost or it needs another confirmation that the target is correct.  - If you want to pause the mission, you can swith the mission mode to `SPOTLIGHT`, the aircraft will hover in place, but continue tracking the target by adjusting gimbal pitch and aircraft yaw.  - If you want to resume the mission, You can switch the mission mode to track mode again, confirmation of tracking rectangle will need to be sent through to start flying relative to target. (For Mavic Air 2 and DJI Air 2S, there is no need to confirm when you switch mode, Since there is no obstacle avoidance system on the left and right sides, be especially careful in the CIRCLE mode.)  - The mission can be canceled with `stopTracking` at any time. - `stopTracking` should also be used to reject tracking confirmation if the camera is tracking the wrong target. After stopping the mission, the mission needs to be recreated with a new rectangle and loaded into the operator.  - The main camera is used to track the target, so gimbal cannot be adjusted during an ActiveTrack mission.  - During the mission the aircraft can be manually flown with roll and throttle. Pitch,yaw and gimbal are automatically controlled to continue tracking the target.  - If the mission is executing, and after confirmation of the tracking rectangle has been sent, the aircraft can be manually controlled horizontally similar to a `HOME_LOCK` where the home is the tracked target. If aircraft is manually controlled upward, the aircraft will lift and retreat, and if it is controlled downward, it will go down and get closer to the target.  - For Mavic Air 2 and DJI Air 2S, you can use the ActiveTrack Mission in the Normal, Sport, Tripod flight modes. Because obstacle sensing is disabled in sport mode, so please use ActiveTrack Mission in an open area.  - For Matrice 300 RTK, only support Spotlight mode. You can use `setSpotlightMode` to set the spotlight mode which support `ZOOM_GIMBAL_FOLLOWING` and `ZOOM_GIMBAL_FREE` .",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "",
                   "",
            ],
            [
                   "CommonCallbacks",
                   2,
                   "/Utils/DJICommonCallbacks.html",
                   "",
                   "Interfaces of common callbacks used to return results of asynchronous operations.",
            ],
            [
                   "Interfaces of common callbacks used to return results of asynchronous operations.",
                   1,
                   "/Utils/DJICommonCallbacks.html",
                   "",
                   "",
            ],
            [
                   "WarningStatusItem",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "",
                   "This class wraps the required elements of the status into one WarningStatusItem.",
            ],
            [
                   "This class wraps the required elements of the status into one WarningStatusItem.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "",
                   "",
            ],
            [
                   "VideoSizeCalculatorUtil",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "",
                   "Utility class for calculating the appropriate size of the video based on screen type and video type defined by aircraft's mode and resolution settings",
            ],
            [
                   "Utility class for calculating the appropriate size of the video based on screen type and video type defined by aircraft's mode and resolution settings",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "",
                   "",
            ],
            [
                   "LocationUtil",
                   2,
                   "/Utils/DJILocationUtil.html",
                   "",
                   "Util class to get location based information.",
            ],
            [
                   "Util class to get location based information.",
                   1,
                   "/Utils/DJILocationUtil.html",
                   "",
                   "",
            ],
            [
                   "DJIParamCapability",
                   2,
                   "/Components/ParamCapability/DJIParamCapability.html",
                   "",
                   "Represents the capability of a parameter of a component or product. This class can be sub-classed to include additional information on the parameter. `DJIParamMinMaxCapability` includes the maximum and minimum possible values of the parameter.",
            ],
            [
                   "Represents the capability of a parameter of a component or product. This class can be sub-classed to include additional information on the parameter. `DJIParamMinMaxCapability` includes the maximum and minimum possible values of the parameter.",
                   1,
                   "/Components/ParamCapability/DJIParamCapability.html",
                   "",
                   "",
            ],
            [
                   "DJIError",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "",
                   "Class that handles all errors that are not handled by individual components.",
            ],
            [
                   "Class that handles all errors that are not handled by individual components.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "",
                   "",
            ],
            [
                   "DJIDiagnostics",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "",
                   "Product Diagnostics.",
            ],
            [
                   "Product Diagnostics.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "",
                   "",
            ],
            [
                   "DJICodecManager",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "",
                   "Class that handles encoding and decoding of media.",
            ],
            [
                   "Class that handles encoding and decoding of media.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "",
                   "",
            ],
            [
                   "Stick",
                   2,
                   "/Components/Stick/DJIStick.html",
                   "",
                   "DJI hardware stick. For example, the joystick on a remote controller, or the gimbal control stick on a handheld controller.",
            ],
            [
                   "DJI hardware stick. For example, the joystick on a remote controller, or the gimbal control stick on a handheld controller.",
                   1,
                   "/Components/Stick/DJIStick.html",
                   "",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalStateUpdateCallback_inline",
                   "Sets up the gimbal state update callback.  @param callback The execution callback.",
            ],
            [
                   "Sets up the gimbal state update callback.  @param callback The execution callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalStateUpdateCallback_inline",
                   "",
            ],
            [
                   "setMovementSettingsCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalAdvancedSettingsStateUpdateCallback_inline",
                   "Sets up the gimbal advanced setting state update callback.  @param callback The execution callback.",
            ],
            [
                   "Sets up the gimbal advanced setting state update callback.  @param callback The execution callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalAdvancedSettingsStateUpdateCallback_inline",
                   "",
            ],
            [
                   "setBatteryChargeRemainingCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalBatteryRemainingEnergyUpdateCallback_inline",
                   "Sets the gimbal remaining energy callback. The unit is percentage.  @param callback The execution callback.",
            ],
            [
                   "Sets the gimbal remaining energy callback. The unit is percentage.  @param callback The execution callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalBatteryRemainingEnergyUpdateCallback_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_stateUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateGimbalState_inline",
                   "Updates the gimbal's current state.  @param gimbalState The gimbal state.",
            ],
            [
                   "Updates the gimbal's current state.  @param gimbalState The gimbal state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_stateUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateGimbalState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsStateUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateMovementSettingsState_inline",
                   "Update the gimbal's user configuration data. This method is only supported by Osmo series.  @param settings An instance of `MovementSettings`.",
            ],
            [
                   "Update the gimbal's user configuration data. This method is only supported by Osmo series.  @param settings An instance of `MovementSettings`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsStateUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateMovementSettingsState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateBatteryRemainingCharge_inline",
                   "Update the gimbal's remaining energy in percentage.  @param remainingChargeInPercent An int value.",
            ],
            [
                   "Update the gimbal's remaining energy in percentage.  @param remainingChargeInPercent An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_UpdateBatteryRemainingCharge_inline",
                   "",
            ],
            [
                   "setStiffnessSelfTuningCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateControlParametersAutoTuningState_inline",
                   "Set listener for updating the gimbal's control parameters auto tuning state.  @param callback A `GimbalControlParametersAutoTuningState` callback.",
            ],
            [
                   "Set listener for updating the gimbal's control parameters auto tuning state.  @param callback A `GimbalControlParametersAutoTuningState` callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateControlParametersAutoTuningState_inline",
                   "",
            ],
            [
                   "setBalanceCheckCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateBalanceDetectionState_inline",
                   "Set listener for updating the gimbal's balance detection state.  @param callback A `GimbalBalanceDetectionState` callback.",
            ],
            [
                   "Set listener for updating the gimbal's balance detection state.  @param callback A `GimbalBalanceDetectionState` callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateBalanceDetectionState_inline",
                   "",
            ],
            [
                   "setConcentricityCheckCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateCoaxialityDetectionState_inline",
                   "Set listener for updating the gimbal's coaxiality detection state.  @param callback A `GimbalCoaxialityDetectionState` callback.",
            ],
            [
                   "Set listener for updating the gimbal's coaxiality detection state.  @param callback A `GimbalCoaxialityDetectionState` callback.",
                   1,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "#DJIGimbal_didUpdateCoaxialityDetectionState_inline",
                   "",
            ],
            [
                   "getCapabilities",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_gimbalCapabilities_inline",
                   "Returns the gimbal's features and possible range of settings. Each key is a possible gimbal feature and is in `CapabilityKey` enum. The value for each key is an instance of `DJIParamCapability` or its sub-classes. The `isSupported` property can be used to query if a feature is supported by the gimbal and the `getMin` and `getMax` properties of `DJIParamMinMaxCapability` can be used to query the valid range for the setting. When a feature is not supported, the values for `getMin` and `getMax` are undefined.  @return A Map<CapabilityKey, DJIParamCapability> instance.",
            ],
            [
                   "Returns the gimbal's features and possible range of settings. Each key is a possible gimbal feature and is in `CapabilityKey` enum. The value for each key is an instance of `DJIParamCapability` or its sub-classes. The `isSupported` property can be used to query if a feature is supported by the gimbal and the `getMin` and `getMax` properties of `DJIParamMinMaxCapability` can be used to query the valid range for the setting. When a feature is not supported, the values for `getMin` and `getMax` are undefined.  @return A Map<CapabilityKey, DJIParamCapability> instance.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_gimbalCapabilities_inline",
                   "",
            ],
            [
                   "CAPABILITIES",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_gimbalCapabilities_inline",
                   "SDK Key for getCapabilities: Returns the gimbal's features and possible range of settings. Each key is a possible gimbal feature and is in `CapabilityKey` enum. The value for each key is an instance of `DJIParamCapability` or its sub-classes. The `isSupported` property can be used to query if a feature is supported by the gimbal and the `getMin` and `getMax` properties of `DJIParamMinMaxCapability` can be used to query the valid range for the setting. When a feature is not supported, the values for `getMin` and `getMax` are undefined.  @return A Map<CapabilityKey, DJIParamCapability> instance.",
            ],
            [
                   "SDK Key for getCapabilities: Returns the gimbal's features and possible range of settings. Each key is a possible gimbal feature and is in `CapabilityKey` enum. The value for each key is an instance of `DJIParamCapability` or its sub-classes. The `isSupported` property can be used to query if a feature is supported by the gimbal and the `getMin` and `getMax` properties of `DJIParamMinMaxCapability` can be used to query the valid range for the setting. When a feature is not supported, the values for `getMin` and `getMax` are undefined.  @return A Map<CapabilityKey, DJIParamCapability> instance.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_gimbalCapabilities_inline",
                   "",
            ],
            [
                   "getYawRelativeToAircraftHeading",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_yawRelativeToAircraftHeading_inline",
                   "This function will return the angle between gimbal and the drone heading.  @return A float value of yaw angle.",
            ],
            [
                   "This function will return the angle between gimbal and the drone heading.  @return A float value of yaw angle.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_yawRelativeToAircraftHeading_inline",
                   "",
            ],
            [
                   "YAW_ANGLE_WITH_AIRCRAFT_IN_DEGREE",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_yawRelativeToAircraftHeading_inline",
                   "SDK Key for getYawRelativeToAircraftHeading: This function will return the angle between gimbal and the drone heading.  @return A float value of yaw angle.",
            ],
            [
                   "SDK Key for getYawRelativeToAircraftHeading: This function will return the angle between gimbal and the drone heading.  @return A float value of yaw angle.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_yawRelativeToAircraftHeading_inline",
                   "",
            ],
            [
                   "setMode",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalWorkMode_inline",
                   "Sets the gimbal's work mode.  @param mode Gimbal work mode to be set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the gimbal's work mode.  @param mode Gimbal work mode to be set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalWorkMode_inline",
                   "",
            ],
            [
                   "GimbalKey.MODE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalWorkMode_inline",
                   "SDK Key for setMode: Sets the gimbal's work mode.  @param mode Gimbal work mode to be set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setMode: Sets the gimbal's work mode.  @param mode Gimbal work mode to be set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setGimbalWorkMode_inline",
                   "",
            ],
            [
                   "reset",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbal_inline",
                   "Resets the gimbal. The behaviors are product-dependent. Osmo series (e.g. Osmo, Osmo Pro): The gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. Phantom series (e.g. Phantom 3 Professional, Phantom 4 series): The first call sets gimbal to point down vertically to the earth. The second call sets gimbal to the standard position. Other products (e.g. Inspire 1): Only the gimbal's pitch will the set to the origin.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Resets the gimbal. The behaviors are product-dependent. Osmo series (e.g. Osmo, Osmo Pro): The gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. Phantom series (e.g. Phantom 3 Professional, Phantom 4 series): The first call sets gimbal to point down vertically to the earth. The second call sets gimbal to the standard position. Other products (e.g. Inspire 1): Only the gimbal's pitch will the set to the origin.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbal_inline",
                   "",
            ],
            [
                   "RESET_GIMBAL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbal_inline",
                   "SDK Key for reset: Resets the gimbal. The behaviors are product-dependent. Osmo series (e.g. Osmo, Osmo Pro): The gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. Phantom series (e.g. Phantom 3 Professional, Phantom 4 series): The first call sets gimbal to point down vertically to the earth. The second call sets gimbal to the standard position. Other products (e.g. Inspire 1): Only the gimbal's pitch will the set to the origin.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for reset: Resets the gimbal. The behaviors are product-dependent. Osmo series (e.g. Osmo, Osmo Pro): The gimbal's pitch and yaw will be set to the origin, which is the standard position for the gimbal. Phantom series (e.g. Phantom 3 Professional, Phantom 4 series): The first call sets gimbal to point down vertically to the earth. The second call sets gimbal to the standard position. Other products (e.g. Inspire 1): Only the gimbal's pitch will the set to the origin.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbal_inline",
                   "",
            ],
            [
                   "reset",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbalWithAxisAndResetDirection_inline",
                   "Resets the gimbal. The behaviors are dependent on the selected axis and reset direction.  Supported by:  Zenmuse H20 and Zenmuse H20T (firmware version v01.00.06.98 and above)  DJI X-port (firmware version v02.00.07.60 and above)  Zenmuse Z30 (firmware version v01.01.03.00 and above)  Zenmuse X5S (firmware version v01.01.03.00 and above)  Zenmuse X7 (firmware version v00.02.05.68 and above)  Zenmuse XT2 (firmware version v00.02.06.46 and above)  Zenmuse XTS (firmware version v00.02.32.82 and above)  @param axis The axis to reset. @param resetDirection The direction on axis to reset. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Resets the gimbal. The behaviors are dependent on the selected axis and reset direction.  Supported by:  Zenmuse H20 and Zenmuse H20T (firmware version v01.00.06.98 and above)  DJI X-port (firmware version v02.00.07.60 and above)  Zenmuse Z30 (firmware version v01.01.03.00 and above)  Zenmuse X5S (firmware version v01.01.03.00 and above)  Zenmuse X7 (firmware version v00.02.05.68 and above)  Zenmuse XT2 (firmware version v00.02.06.46 and above)  Zenmuse XTS (firmware version v00.02.32.82 and above)  @param axis The axis to reset. @param resetDirection The direction on axis to reset. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetGimbalWithAxisAndResetDirection_inline",
                   "",
            ],
            [
                   "rotate",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_rotateGimbalWithRotation_inline",
                   "Rotate gimbal's pitch, roll, and yaw with `DJIGimbalRotation`. For X5S, X4S and X7, rotating the gimbal with mode `RELATIVE_ANGLE` or `ABSOLUTE_ANGLE`, will reset the gimbal mode to `FREE`.  @param rotation An instance of `Rotation`. @param callback The callback of `CompletionCallback<T`.",
            ],
            [
                   "Rotate gimbal's pitch, roll, and yaw with `DJIGimbalRotation`. For X5S, X4S and X7, rotating the gimbal with mode `RELATIVE_ANGLE` or `ABSOLUTE_ANGLE`, will reset the gimbal mode to `FREE`.  @param rotation An instance of `Rotation`. @param callback The callback of `CompletionCallback<T`.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_rotateGimbalWithRotation_inline",
                   "",
            ],
            [
                   "ROTATE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_rotateGimbalWithRotation_inline",
                   "SDK Key for rotate: Rotate gimbal's pitch, roll, and yaw with `DJIGimbalRotation`. For X5S, X4S and X7, rotating the gimbal with mode `RELATIVE_ANGLE` or `ABSOLUTE_ANGLE`, will reset the gimbal mode to `FREE`.  @param rotation An instance of `Rotation`. @param callback The callback of `CompletionCallback<T`.",
            ],
            [
                   "SDK Key for rotate: Rotate gimbal's pitch, roll, and yaw with `DJIGimbalRotation`. For X5S, X4S and X7, rotating the gimbal with mode `RELATIVE_ANGLE` or `ABSOLUTE_ANGLE`, will reset the gimbal mode to `FREE`.  @param rotation An instance of `Rotation`. @param callback The callback of `CompletionCallback<T`.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_rotateGimbalWithRotation_inline",
                   "",
            ],
            [
                   "lookAt",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_lookAt_inline",
                   "The aircraft will look at the GPS point you set up，it is only supported by Zenmuse H20 Series.  @param locationCoordinate3D The GPS location you want to look at. you could get the location from `getTargetLocation` or get the location with map. @param mode The look at mode. @param callback The callback of `CompletionCallback<T`.",
            ],
            [
                   "The aircraft will look at the GPS point you set up，it is only supported by Zenmuse H20 Series.  @param locationCoordinate3D The GPS location you want to look at. you could get the location from `getTargetLocation` or get the location with map. @param mode The look at mode. @param callback The callback of `CompletionCallback<T`.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_lookAt_inline",
                   "",
            ],
            [
                   "LookAtMode",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_inline",
                   "Gimbal LookAt mode. include gimbal free mode and gimbal following mode.",
            ],
            [
                   "Gimbal LookAt mode. include gimbal free mode and gimbal following mode.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_inline",
                   "",
            ],
            [
                   "LOOK_AT_GIMBAL_FREE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_LookAtGimbalFree_inline",
                   "Gimbal free mode, only control the gimbal to look at the target, it will automatically exit after completion.",
            ],
            [
                   "Gimbal free mode, only control the gimbal to look at the target, it will automatically exit after completion.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_LookAtGimbalFree_inline",
                   "",
            ],
            [
                   "LOOK_AT_GIMBAL_FOLLOWING",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_LookAtGimbalFollowing_inline",
                   "Gimbal following mode, control gimbal and aircraft to look at the target, it will automatically exit after completion.",
            ],
            [
                   "Gimbal following mode, control gimbal and aircraft to look at the target, it will automatically exit after completion.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_LookAtMode_LookAtGimbalFollowing_inline",
                   "",
            ],
            [
                   "startCalibration",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalAutoCalibration_inline",
                   "Starts calibrating the gimbal. The product should be stationary (not flying, or being held) and horizontal during calibration. For gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. For Osmo Mobile series, user should double-click the trigger (or mode button on Osmo Mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts calibrating the gimbal. The product should be stationary (not flying, or being held) and horizontal during calibration. For gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. For Osmo Mobile series, user should double-click the trigger (or mode button on Osmo Mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalAutoCalibration_inline",
                   "",
            ],
            [
                   "START_CALIBRATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalAutoCalibration_inline",
                   "SDK Key for startCalibration: Starts calibrating the gimbal. The product should be stationary (not flying, or being held) and horizontal during calibration. For gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. For Osmo Mobile series, user should double-click the trigger (or mode button on Osmo Mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startCalibration: Starts calibrating the gimbal. The product should be stationary (not flying, or being held) and horizontal during calibration. For gimbal's with adjustable payloads, the payload should be present and balanced before doing a calibration. For Osmo Mobile series, user should double-click the trigger (or mode button on Osmo Mobile 2) or restart the device to re-center the gimbal after the calibration.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalAutoCalibration_inline",
                   "",
            ],
            [
                   "fineTuneRollInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalRollInDegrees_inline",
                   "The gimbal roll can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The gimbal roll can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalRollInDegrees_inline",
                   "",
            ],
            [
                   "FINE_TUNE_ROLL_IN_DEGREES",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalRollInDegrees_inline",
                   "SDK Key for fineTuneRollInDegrees: The gimbal roll can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for fineTuneRollInDegrees: The gimbal roll can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalRollInDegrees_inline",
                   "",
            ],
            [
                   "fineTunePitchInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalPitchInDegrees_inline",
                   "The gimbal pitch can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. It is only supported by Spark, Mavic 2 Series and Mavic Air 2, DJI Air 2S.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The gimbal pitch can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. It is only supported by Spark, Mavic 2 Series and Mavic Air 2, DJI Air 2S.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneGimbalPitchInDegrees_inline",
                   "",
            ],
            [
                   "fineTuneYawInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneYawInDegrees_inline",
                   "The gimbal yaw can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. It is only supported by Mavic Air and Mavic 2 Series.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The gimbal yaw can be fine tuned with a custom offset. The range for the custom offset is [-2.0, 2.0] degrees. If the offset is negative, the gimbal will be fine tuned the specified number of degrees in the counterclockwise direction. It is only supported by Mavic Air and Mavic 2 Series.  @param offset Fine-tuned offset, in degrees, to be tuned. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_fineTuneYawInDegrees_inline",
                   "",
            ],
            [
                   "startBalanceTest",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalBalanceTest_inline",
                   "Starts testing the balance of the gimbal payload. For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. The product should be stationary (not flying, or being held) and horizontal during testing. See `GimbalState` for the test result.  @param callback The execution callback with the returned value(s). The callback will execute when the balance test is successfully started.",
            ],
            [
                   "Starts testing the balance of the gimbal payload. For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. The product should be stationary (not flying, or being held) and horizontal during testing. See `GimbalState` for the test result.  @param callback The execution callback with the returned value(s). The callback will execute when the balance test is successfully started.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalBalanceTest_inline",
                   "",
            ],
            [
                   "START_BALANCE_TEST",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalBalanceTest_inline",
                   "SDK Key for startBalanceTest: Starts testing the balance of the gimbal payload. For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. The product should be stationary (not flying, or being held) and horizontal during testing. See `GimbalState` for the test result.  @param callback The execution callback with the returned value(s). The callback will execute when the balance test is successfully started.",
            ],
            [
                   "SDK Key for startBalanceTest: Starts testing the balance of the gimbal payload. For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly. The product should be stationary (not flying, or being held) and horizontal during testing. See `GimbalState` for the test result.  @param callback The execution callback with the returned value(s). The callback will execute when the balance test is successfully started.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startGimbalBalanceTest_inline",
                   "",
            ],
            [
                   "setMovementSettingsProfile",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMovementSettingsProfile_inline",
                   "Sets the movement settings profile. The movement settings profile has options for both preset and custom profiles for SmoothTrack and Controller settings. Settings for SmoothTrack and Controller can only be set manually when using a custom profile.  @param profile Profile to set. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the movement settings profile. The movement settings profile has options for both preset and custom profiles for SmoothTrack and Controller settings. Settings for SmoothTrack and Controller can only be set manually when using a custom profile.  @param profile Profile to set. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMovementSettingsProfile_inline",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS_PROFILE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMovementSettingsProfile_inline",
                   "SDK Key for setMovementSettingsProfile: Sets the movement settings profile. The movement settings profile has options for both preset and custom profiles for SmoothTrack and Controller settings. Settings for SmoothTrack and Controller can only be set manually when using a custom profile.  @param profile Profile to set. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setMovementSettingsProfile: Sets the movement settings profile. The movement settings profile has options for both preset and custom profiles for SmoothTrack and Controller settings. Settings for SmoothTrack and Controller can only be set manually when using a custom profile.  @param profile Profile to set. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMovementSettingsProfile_inline",
                   "",
            ],
            [
                   "getMovementSettingsProfile",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMovementSettingsProfile_inline",
                   "Gets the advanced settings profile. Use `MovementSettingsProfile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
            ],
            [
                   "Gets the advanced settings profile. Use `MovementSettingsProfile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMovementSettingsProfile_inline",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS_PROFILE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMovementSettingsProfile_inline",
                   "SDK Key for getMovementSettingsProfile: Gets the advanced settings profile. Use `MovementSettingsProfile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMovementSettingsProfile: Gets the advanced settings profile. Use `MovementSettingsProfile` to check if it is supported by the gimbal.  @param callback callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMovementSettingsProfile_inline",
                   "",
            ],
            [
                   "restoreFactorySettings",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadFactorySettings_inline",
                   "Restores the gimbal's settings to factory settings.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Restores the gimbal's settings to factory settings.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadFactorySettings_inline",
                   "",
            ],
            [
                   "GimbalKey.RESTORE_FACTORY_SETTINGS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadFactorySettings_inline",
                   "SDK Key for restoreFactorySettings: Restores the gimbal's settings to factory settings.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for restoreFactorySettings: Restores the gimbal's settings to factory settings.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadFactorySettings_inline",
                   "",
            ],
            [
                   "setPitchRangeExtensionEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setPitchRangeExtensionEnabled_inline",
                   "Extends the pitch range of gimbal. If extended, The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`. Otherwise, the angle will be limited to avoid seeing the arm. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param isEnabled Whether the pitch range should be extended. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Extends the pitch range of gimbal. If extended, The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`. Otherwise, the angle will be limited to avoid seeing the arm. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param isEnabled Whether the pitch range should be extended. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setPitchRangeExtensionEnabled_inline",
                   "",
            ],
            [
                   "PITCH_RANGE_EXTENSION_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setPitchRangeExtensionEnabled_inline",
                   "SDK Key for setPitchRangeExtensionEnabled: Extends the pitch range of gimbal. If extended, The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`. Otherwise, the angle will be limited to avoid seeing the arm. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param isEnabled Whether the pitch range should be extended. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setPitchRangeExtensionEnabled: Extends the pitch range of gimbal. If extended, The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`. Otherwise, the angle will be limited to avoid seeing the arm. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param isEnabled Whether the pitch range should be extended. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setPitchRangeExtensionEnabled_inline",
                   "",
            ],
            [
                   "getPitchRangeExtensionEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getPitchRangeExtensionEnabled_inline",
                   "Get the extend gimbal pitch range state. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Get the extend gimbal pitch range state. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getPitchRangeExtensionEnabled_inline",
                   "",
            ],
            [
                   "PITCH_RANGE_EXTENSION_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getPitchRangeExtensionEnabled_inline",
                   "SDK Key for getPitchRangeExtensionEnabled: Get the extend gimbal pitch range state. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getPitchRangeExtensionEnabled: Get the extend gimbal pitch range state. Use `PITCH_RANGE_EXTENSION` to check if it is supported by the gimbal.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getPitchRangeExtensionEnabled_inline",
                   "",
            ],
            [
                   "applyMotorControlPreset",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_configureMotorControlWithPreset_inline",
                   "Configures gimbal's motor control with a preset configuration applicable for most popular cameras. In order to the optimize the performance, motor control tuning is still required.  @param preset The preset configuration to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Configures gimbal's motor control with a preset configuration applicable for most popular cameras. In order to the optimize the performance, motor control tuning is still required.  @param preset The preset configuration to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_configureMotorControlWithPreset_inline",
                   "",
            ],
            [
                   "APPLY_MOTOR_CONTROL_PRESET",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_configureMotorControlWithPreset_inline",
                   "SDK Key for applyMotorControlPreset: Configures gimbal's motor control with a preset configuration applicable for most popular cameras. In order to the optimize the performance, motor control tuning is still required.  @param preset The preset configuration to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for applyMotorControlPreset: Configures gimbal's motor control with a preset configuration applicable for most popular cameras. In order to the optimize the performance, motor control tuning is still required.  @param preset The preset configuration to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_configureMotorControlWithPreset_inline",
                   "",
            ],
            [
                   "setMotorControlStiffness",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStiffness: Sets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param stiffness The stiffness value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "getMotorControlStiffness",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStiffness: Gets the coefficient of speed error control. It can be seen as the coefficient for the proportional term in the PID controller. Use `PITCH_MOTOR_CONTROL_STIFFNESS`, `YAW_MOTOR_CONTROL_STIFFNESS` and `ROLL_MOTOR_CONTROL_STIFFNESS` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStiffnessOnAxis_inline",
                   "",
            ],
            [
                   "setMotorControlStrength",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setMotorControlStrength: Sets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param strength The strength value to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "getMotorControlStrength",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlStrength: Gets the coefficient of attitude accuracy control. It can be seen as the coefficient for the integral term in the PID controller. Use `PITCH_MOTOR_CONTROL_STRENGTH`, `YAW_MOTOR_CONTROL_STRENGTH` and `ROLL_MOTOR_CONTROL_STRENGTH` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlStrengthOnAxis_inline",
                   "",
            ],
            [
                   "setMotorControlGyroFilteringFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlGyroFilteringFactor: Sets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param filteringFactor The gyro filtering value to set. @param axis The axis that the setting is applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "getMotorControlGyroFilteringFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlGyroFilteringFactor: Gets the coefficient of denoising the output. Use `PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR`, `YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` and `ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlGyroFilteringOnAxis_inline",
                   "",
            ],
            [
                   "setMotorControlPreControl",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setMotorControlPreControl: Sets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting is applied to. @param preControl The Precontrol value to set. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "getMotorControlPreControl",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getMotorControlPreControl: Gets the value for pre-adjust. It can be seen as the coefficient for the derivative term in the PID controller. Only supported by Ronin-MX. Use `PITCH_MOTOR_CONTROL_PRE_CONTROL`, `YAW_MOTOR_CONTROL_PRE_CONTROL` and `ROLL_MOTOR_CONTROL_PRE_CONTROL` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorControlPreControlOnAxis_inline",
                   "",
            ],
            [
                   "setControllerDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "SDK Key for setControllerDeadband: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerDeadband: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "SDK Key for setControllerDeadband: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerDeadband: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) deadband on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param deadband The deadband value to be set. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "getControllerDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "SDK Key for getControllerDeadband: Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerDeadband: Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "SDK Key for getControllerDeadband: Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerDeadband: Gets physical controller deadband value on an axis. A larger deadband requires more controller movement to start gimbal motion. Use `YAW_CONTROLLER_DEADBAND` and `PITCH_CONTROLLER_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param direction The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "setControllerSpeedCoefficient",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "SDK Key for setControllerSpeedCoefficient: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setControllerSpeedCoefficient: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "SDK Key for setControllerSpeedCoefficient: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setControllerSpeedCoefficient: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) speed on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param speedCoefficient The speed value to be set. @param axis The axis that the setting will be applied to. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "getControllerSpeedCoefficient",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "SDK Key for getControllerSpeedCoefficient: Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSpeedCoefficient: Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "SDK Key for getControllerSpeedCoefficient: Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSpeedCoefficient: Gets physical controller speed value on an axis. Speed setting controls the mapping between the movement of the controller and the gimbal speed. Use `YAW_CONTROLLER_SPEED_COEFFICIENT` and `PITCH_CONTROLLER_SPEED_COEFFICIENT` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSpeedOnAxis_inline",
                   "",
            ],
            [
                   "setControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
            ],
            [
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "setControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "SDK Key for setControllerSmoothingFactor: Sets physical controller (e.g. the joystick on Osmo or the remote controller of the aircraft) smoothing on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param smoothingFactor The smoothing value to be set. @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "getControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value on an axis. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxis_inline",
                   "",
            ],
            [
                   "getControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
            ],
            [
                   "SDK Key for getControllerSmoothingFactor: Gets physical controller smoothing value with axis and mode. Smoothing controls the deceleration of the gimbal. Use `YAW_CONTROLLER_SMOOTHING_FACTOR` and `PITCH_CONTROLLER_SMOOTHING_FACTOR` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The execution callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerSmoothingOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "setControllerMaxSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMaxSpeedOnAxis_inline",
                   "Sets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting will be applied to. @param maxSpeed The maximum speed to set for one axis. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Sets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis that the setting will be applied to. @param maxSpeed The maximum speed to set for one axis. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMaxSpeedOnAxis_inline",
                   "",
            ],
            [
                   "setControllerMaxSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMaxSpeedOnAxisOnDifferentMode_inline",
                   "Sets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param maxSpeed The maximum speed to set for one axis. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Sets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis that the setting will be applied to. @param mode The mode that the setting will be applied to. @param maxSpeed The maximum speed to set for one axis. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMaxSpeedOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "getControllerMaxSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMaxSpeedOnAxis_inline",
                   "Gets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMaxSpeedOnAxis_inline",
                   "",
            ],
            [
                   "getControllerMaxSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMaxSpeedOnAxisOnDifferentMode_inline",
                   "Gets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets physical controller max speed value on an axis. It controls the mapping between the movement of the controller and the gimbal speed. Use `PITCH_CONTROLLER_MAX_SPEED` and `YAW_CONTROLLER_MAX_SPEED` with capabilities to check if the gimbal supports this feature and the range of possible values (unitless). Only supported by Mavic Air 2, DJI Air 2S.  @param axis The axis to query. @param mode The mode to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMaxSpeedOnAxisOnDifferentMode_inline",
                   "",
            ],
            [
                   "setSmoothTrackEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "SDK Key for setSmoothTrackEnabled: Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackEnabled: Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "SDK Key for setSmoothTrackEnabled: Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackEnabled: Enables SmoothTrack for the axis. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param enabled `true` to enable SmoothTrack on the axis. @param axis The axis that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "getSmoothTrackEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "SDK Key for getSmoothTrackEnabled: Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackEnabled: Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "SDK Key for getSmoothTrackEnabled: Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackEnabled: Gets whether an axis has SmoothTrack enabled. Only supported by Osmo. Ronin-MX supports SmoothTrack but it is always enabled for both pitch axis and yaw axis. Use `PITCH_SMOOTH_TRACK_ENABLED` and `YAW_SMOOTH_TRACK_ENABLED` with `getCapabilities` to check if the gimbal supports this feature.  @param axis The axis to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackEnabledOnAxis_inline",
                   "",
            ],
            [
                   "setSmoothTrackSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "SDK Key for setSmoothTrackSpeed: Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackSpeed: Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "SDK Key for setSmoothTrackSpeed: Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackSpeed: Sets gimbal SmoothTrack catch up speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param speed SmoothTrack speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "getSmoothTrackSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "SDK Key for getSmoothTrackSpeed: Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSmoothTrackSpeed: Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "SDK Key for getSmoothTrackSpeed: Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSmoothTrackSpeed: Gets gimbal SmoothTrack speed on an axis. SmoothTrack speed determines how fast the gimbal will catch up with a large, translated handle movement. Use `PITCH_SMOOTH_TRACK_SPEED` and `YAW_SMOOTH_TRACK_SPEED` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackSpeedOnAxis_inline",
                   "",
            ],
            [
                   "setSmoothTrackDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "SDK Key for setSmoothTrackDeadband: Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackDeadband: Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "SDK Key for setSmoothTrackDeadband: Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackDeadband: Sets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param deadband SmoothTrack deadband [0,90]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "getSmoothTrackDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "SDK Key for getSmoothTrackDeadband: Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackDeadband: Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "SDK Key for getSmoothTrackDeadband: Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackDeadband: Gets SmoothTrack deadband on an axis. A larger deadband requires more handle movement to translate into gimbal motion. Use `PITCH_SMOOTH_TRACK_DEADBAND` and `YAW_SMOOTH_TRACK_DEADBAND` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values in degrees.  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackDeadbandOnAxis_inline",
                   "",
            ],
            [
                   "setSmoothTrackAcceleration",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "SDK Key for setSmoothTrackAcceleration: Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackAcceleration: Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "SDK Key for setSmoothTrackAcceleration: Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSmoothTrackAcceleration: Sets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param acceleration SmoothTrack acceleration [0,30]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "getSmoothTrackAcceleration",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "SDK Key for getSmoothTrackAcceleration: Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackAcceleration: Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "SDK Key for getSmoothTrackAcceleration: Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getSmoothTrackAcceleration: Gets SmoothTrack acceleration on an axis. Acceleration determines how closely the camera will follow the translated yaw handle movement. Use `PITCH_SMOOTH_TRACK_ACCELERATION` and `YAW_SMOOTH_TRACK_ACCELERATION` with `getCapabilities` to check if the gimbal supports this feature and the range of possible values (unitless).  @param axis Gimbal axis. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getSmoothTrackAccelerationOnAxis_inline",
                   "",
            ],
            [
                   "setEndpoint",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "PITCH_UP_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_LEFT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "PITCH_DOWN_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for setEndpoint: Endpoint settings determine the farthest points to which the gimbal will rotate during manual controller input. Only supported by Ronin-MX. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` in `getCapabilities` to check if the gimbal supports this feature and what the valid range of endpoints are.  @param endpoint The endpoint value to set. @param direction The direction that the setting will be applied to. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setEndpointInDirection_inline",
                   "",
            ],
            [
                   "getEndpoint",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "",
            ],
            [
                   "PITCH_UP_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "",
            ],
            [
                   "YAW_LEFT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getEndpoint: Gets the farthest points to which the gimbal will rotate during manual controller input. Use `PITCH_UP_ENDPOINT`, `PITCH_DOWN_ENDPOINT`, `YAW_LEFT_ENDPOINT` and `YAW_RIGHT_ENDPOINT` with `getCapabilities` to check if the gimbal supports this feature.  @param direction The endpoint direction. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getEndpointInDirection_inline",
                   "",
            ],
            [
                   "setMotorEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorEnabled_inline",
                   "Turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorEnabled_inline",
                   "",
            ],
            [
                   "MOTOR_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorEnabled_inline",
                   "SDK Key for setMotorEnabled: Turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setMotorEnabled: Turns on and off the gimbal motors. `false` means the gimbal power remains on, however the motors will not work.  @param enabled `true` to enable the motor. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setMotorEnabled_inline",
                   "",
            ],
            [
                   "getMotorEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorEnabled_inline",
                   "Determines whether the gimbal motors are enabled to work or not.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the gimbal motors are enabled to work or not.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorEnabled_inline",
                   "",
            ],
            [
                   "MOTOR_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorEnabled_inline",
                   "SDK Key for getMotorEnabled: Determines whether the gimbal motors are enabled to work or not.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMotorEnabled: Determines whether the gimbal motors are enabled to work or not.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMotorEnabled_inline",
                   "",
            ],
            [
                   "toggleSelfie",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_toggleGimbalSelfie_inline",
                   "Resets gimbal position to selfie setup. If the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). If the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. It's only supported by DJI OSMO, OSMO Pro and OSMO Raw.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Resets gimbal position to selfie setup. If the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). If the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. It's only supported by DJI OSMO, OSMO Pro and OSMO Raw.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_toggleGimbalSelfie_inline",
                   "",
            ],
            [
                   "TOGGLE_SELFIE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_toggleGimbalSelfie_inline",
                   "SDK Key for toggleSelfie: Resets gimbal position to selfie setup. If the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). If the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. It's only supported by DJI OSMO, OSMO Pro and OSMO Raw.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for toggleSelfie: Resets gimbal position to selfie setup. If the gimbal yaw is not at 180 degrees, then calling this method will rotate the gimbal yaw to 180 degrees (effectively pointing the camera to the person holding the gimbal). If the gimbal yaw is at 180 degrees, then the gimbal will rotate in yaw to 0 degrees. It's only supported by DJI OSMO, OSMO Pro and OSMO Raw.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_toggleGimbalSelfie_inline",
                   "",
            ],
            [
                   "setControllerMode",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerMode_inline",
                   "Sets the gimbal's controller mode. The control mode for the gimbal controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode See enum named `ControllerMode` in DJIGimbal to find details on different gimbal stick control modes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the gimbal's controller mode. The control mode for the gimbal controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode See enum named `ControllerMode` in DJIGimbal to find details on different gimbal stick control modes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerMode_inline",
                   "",
            ],
            [
                   "CONTROLLER_MODE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerMode_inline",
                   "SDK Key for setControllerMode: Sets the gimbal's controller mode. The control mode for the gimbal controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode See enum named `ControllerMode` in DJIGimbal to find details on different gimbal stick control modes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setControllerMode: Sets the gimbal's controller mode. The control mode for the gimbal controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.  @param mode See enum named `ControllerMode` in DJIGimbal to find details on different gimbal stick control modes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setControllerMode_inline",
                   "",
            ],
            [
                   "getControllerMode",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerMode_inline",
                   "Gets the gimbal's controller mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the gimbal's controller mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerMode_inline",
                   "",
            ],
            [
                   "CONTROLLER_MODE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerMode_inline",
                   "SDK Key for getControllerMode: Gets the gimbal's controller mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getControllerMode: Gets the gimbal's controller mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getControllerMode_inline",
                   "",
            ],
            [
                   "setInvertedControlEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "YAW_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "SDK Key for setInvertedControlEnabled: Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setInvertedControlEnabled: Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "PITCH_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "SDK Key for setInvertedControlEnabled: Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setInvertedControlEnabled: Inverts the physical control for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param enabled `true` to enable inverted control. @param axis The axis that the setting will be applied to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "getInvertedControlEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "YAW_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "SDK Key for getInvertedControlEnabled: Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getInvertedControlEnabled: Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "PITCH_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "SDK Key for getInvertedControlEnabled: Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getInvertedControlEnabled: Determines whether the physical control is inverted for gimbal movement on an axis. The setting can only be applied to the pitch or yaw axis.  @param axis The axis to query. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getInvertedControlEnabled_inline",
                   "",
            ],
            [
                   "setAttitudeSynchronizationEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setAttitudeSynchronizationEnabled_inline",
                   "Synchronizes the attitude of port (left) gimbal and starboard (right) gimbal. It is only valid when both gimbals are connected. If only 1 gimbal is connected, this setting will be reset to `false`. Enables this setting will reset `getControllingGimbalIndex` to index 0. It is only supported by M210 and M210 RTK, not supported by DJI X-Port.  @param enabled `true` to enable the synchronization. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Synchronizes the attitude of port (left) gimbal and starboard (right) gimbal. It is only valid when both gimbals are connected. If only 1 gimbal is connected, this setting will be reset to `false`. Enables this setting will reset `getControllingGimbalIndex` to index 0. It is only supported by M210 and M210 RTK, not supported by DJI X-Port.  @param enabled `true` to enable the synchronization. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setAttitudeSynchronizationEnabled_inline",
                   "",
            ],
            [
                   "getAttitudeSynchronizationEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getAttitudeSynchronizationEnabled_inline",
                   "Determines whether both gimbals' attitudes are synchronized. If only 1 gimbal is connected, this setting will be reset to `false`. It is only supported by M210 and M210 RTK.  @param axis An enum value of `Axis`. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether both gimbals' attitudes are synchronized. If only 1 gimbal is connected, this setting will be reset to `false`. It is only supported by M210 and M210 RTK.  @param axis An enum value of `Axis`. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getAttitudeSynchronizationEnabled_inline",
                   "",
            ],
            [
                   "startMultiGimbalAttitudeSynchronization",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startMultiGimbalAttitudeSynchronization_inline",
                   "Selects two to three gimbals to run with Multi-Gimbal Connection, which can be controlled by a single user. Please check if payloads have been connected with gimbal. The left gimbal, the right gimbal and the upper gimbal can be chosen. You should call `setControllingGimbalIndex` to  set the control of the remote controller to the gimbal you want to synchronize. It is only supported by Matrice 300 RTK.  @param gimbals Array of gimbal indexes, in which 0 represents the left gimbal, 1 represents the right gimbal and 2 stands for the upper one. nil</code> if this function is disabled. @param callback The completion block that receives the execution result.",
            ],
            [
                   "Selects two to three gimbals to run with Multi-Gimbal Connection, which can be controlled by a single user. Please check if payloads have been connected with gimbal. The left gimbal, the right gimbal and the upper gimbal can be chosen. You should call `setControllingGimbalIndex` to  set the control of the remote controller to the gimbal you want to synchronize. It is only supported by Matrice 300 RTK.  @param gimbals Array of gimbal indexes, in which 0 represents the left gimbal, 1 represents the right gimbal and 2 stands for the upper one. nil</code> if this function is disabled. @param callback The completion block that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startMultiGimbalAttitudeSynchronization_inline",
                   "",
            ],
            [
                   "stopMultiGimbalAttitudeSynchronization",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopMultiGimbalAttitudeSynchronization_inline",
                   "Stops the gimbals to run with Multi-Gimbal Connection. Please check if payloads have been connected with gimbal. It is only supported by Matrice 300 RTK.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Stops the gimbals to run with Multi-Gimbal Connection. Please check if payloads have been connected with gimbal. It is only supported by Matrice 300 RTK.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopMultiGimbalAttitudeSynchronization_inline",
                   "",
            ],
            [
                   "getMultiGimbalAttitudeSynchronizationStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMultiGimbalAttitudeSynchronizationStatus_inline",
                   "Gets the working status of Multi-Gimbal Connection. It is only supported by Matrice 300 RTK.  @return Multiple gimbal synchronization status.",
            ],
            [
                   "Gets the working status of Multi-Gimbal Connection. It is only supported by Matrice 300 RTK.  @return Multiple gimbal synchronization status.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getMultiGimbalAttitudeSynchronizationStatus_inline",
                   "",
            ],
            [
                   "setYawSimultaneousFollowEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setYawSimultaneousFollowEnabled_inline",
                   "Enables this to make the gimbal respond to the controller command to rotate aircraft's heading. Enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param isEnabled `true` to enable yaw simultaneous follow. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enables this to make the gimbal respond to the controller command to rotate aircraft's heading. Enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param isEnabled `true` to enable yaw simultaneous follow. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_setYawSimultaneousFollowEnabled_inline",
                   "",
            ],
            [
                   "getYawSimultaneousFollowEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getYawSimultaneousFollowEnabled_inline",
                   "Determines whether yaw simultaneous follow is enabled. Enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether yaw simultaneous follow is enabled. Enabling this setting makes gimbal rotate simultaneously with aircraft's heading when the user is controlling the aircraft's heading with the remote controller.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_getYawSimultaneousFollowEnabled_inline",
                   "",
            ],
            [
                   "startBalanceDetection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startBalanceDetection_inline",
                   "Starts the balance detection.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis should be between -30 and -20 degrees. Please fit the screw on the auxiliary arm after the balance detection. Invoked before `startConcentricityDetection` and `startControlParametersAutoTuning`. Or start balance detection with default control parameters.  This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Starts the balance detection.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis should be between -30 and -20 degrees. Please fit the screw on the auxiliary arm after the balance detection. Invoked before `startConcentricityDetection` and `startControlParametersAutoTuning`. Or start balance detection with default control parameters.  This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startBalanceDetection_inline",
                   "",
            ],
            [
                   "stopBalanceDetection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopBalanceDetection_inline",
                   "Stops the balance detection. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Stops the balance detection. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopBalanceDetection_inline",
                   "",
            ],
            [
                   "startConcentricityDetection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startCoaxialityDetection_inline",
                   "Starts the coaxiality detection.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis cannot be greater than 5 degrees. Please start coaxiality detection after gimbal's balance detection and fitting the screw on the auxiliary arm. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Starts the coaxiality detection.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis cannot be greater than 5 degrees. Please start coaxiality detection after gimbal's balance detection and fitting the screw on the auxiliary arm. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startCoaxialityDetection_inline",
                   "",
            ],
            [
                   "stopConcentricityDetection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopCoaxialityDetection_inline",
                   "Stops the coaxiality detection. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Stops the coaxiality detection. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopCoaxialityDetection_inline",
                   "",
            ],
            [
                   "startControlParametersAutoTuning",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startControlParametersAutoTuning_inline",
                   "Starts the control parameters auto tuning.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis cannot be greater than 5 degrees. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Starts the control parameters auto tuning.  Note:  Please DO NOT turn on the motors. The tilt angle of the pitch and roll axis cannot be greater than 5 degrees. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_startControlParametersAutoTuning_inline",
                   "",
            ],
            [
                   "stopControlParametersAutoTuning",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopControlParametersAutoTuning_inline",
                   "Stops the control parameters auto tuning. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Stops the control parameters auto tuning. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_stopControlParametersAutoTuning_inline",
                   "",
            ],
            [
                   "resetControlParameters",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetControlParameters_inline",
                   "Restores gimbal's control parameters coefficient.  Note:  Please DO NOT turn on the motors. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
            ],
            [
                   "Restores gimbal's control parameters coefficient.  Note:  Please DO NOT turn on the motors. This can only be invoked during `DEVELOPMENT` phase.  @param callback The callback that receives the execution result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_resetControlParameters_inline",
                   "",
            ],
            [
                   "GimbalState",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "",
                   "This class provides the current state of the gimbal.",
            ],
            [
                   "This class provides the current state of the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "",
                   "",
            ],
            [
                   "getAttitudeInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_attitude_inline",
                   "The current gimbal attitude in degrees. Roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of North Pole.  @return An `Attitude` instance.",
            ],
            [
                   "The current gimbal attitude in degrees. Roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of North Pole.  @return An `Attitude` instance.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_attitude_inline",
                   "",
            ],
            [
                   "ATTITUDE_IN_DEGREES",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_attitude_inline",
                   "SDK Key for getAttitudeInDegrees: The current gimbal attitude in degrees. Roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of North Pole.  @return An `Attitude` instance.",
            ],
            [
                   "SDK Key for getAttitudeInDegrees: The current gimbal attitude in degrees. Roll, pitch and yaw are 0 if the gimbal is level with the aircraft and points in the forward direction of North Pole.  @return An `Attitude` instance.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_attitude_inline",
                   "",
            ],
            [
                   "getRollFineTuneInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollFineTuneInDegrees_inline",
                   "Returns the gimbal's roll fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return A float value.",
            ],
            [
                   "Returns the gimbal's roll fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollFineTuneInDegrees_inline",
                   "",
            ],
            [
                   "ROLL_FINE_TUNE_IN_DEGREES",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollFineTuneInDegrees_inline",
                   "SDK Key for getRollFineTuneInDegrees: Returns the gimbal's roll fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return A float value.",
            ],
            [
                   "SDK Key for getRollFineTuneInDegrees: Returns the gimbal's roll fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the counterclockwise direction.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollFineTuneInDegrees_inline",
                   "",
            ],
            [
                   "getPitchFineTuneInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchFineTuneInDegrees_inline",
                   "Returns the gimbal's pitch fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine-tuned to the specified number of degrees in the downward direction. It is only supported by Spark.  @return A float value.",
            ],
            [
                   "Returns the gimbal's pitch fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine-tuned to the specified number of degrees in the downward direction. It is only supported by Spark.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchFineTuneInDegrees_inline",
                   "",
            ],
            [
                   "getYawFineTuneInDegrees",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_fineTunedYaw_inline",
                   "Returns the gimbal's yaw fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the port (left) direction. Only supported by DJI Mavic Air.  @return A float value.",
            ],
            [
                   "Returns the gimbal's yaw fine-tuned value. The range for the fine-tuned value is [-10, 10] degrees. If the fine-tune value is negative, the gimbal will be fine- tuned to the specified number of degrees in the port (left) direction. Only supported by DJI Mavic Air.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_fineTunedYaw_inline",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_workMode_inline",
                   "Returns the gimbal's current work mode.  @return A `GimbalMode` enum value.",
            ],
            [
                   "Returns the gimbal's current work mode.  @return A `GimbalMode` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_workMode_inline",
                   "",
            ],
            [
                   "GimbalKey.MODE",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_workMode_inline",
                   "SDK Key for getMode: Returns the gimbal's current work mode.  @return A `GimbalMode` enum value.",
            ],
            [
                   "SDK Key for getMode: Returns the gimbal's current work mode.  @return A `GimbalMode` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_workMode_inline",
                   "",
            ],
            [
                   "isMobileDeviceMounted",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMobileDeviceMounted_inline",
                   "`true` if the mobile device is mounted on the gimbal.  @return A boolean value.",
            ],
            [
                   "`true` if the mobile device is mounted on the gimbal.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMobileDeviceMounted_inline",
                   "",
            ],
            [
                   "IS_MOBILE_DEVICE_MOUNTED",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMobileDeviceMounted_inline",
                   "SDK Key for isMobileDeviceMounted: `true` if the mobile device is mounted on the gimbal.  @return A boolean value.",
            ],
            [
                   "SDK Key for isMobileDeviceMounted: `true` if the mobile device is mounted on the gimbal.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMobileDeviceMounted_inline",
                   "",
            ],
            [
                   "isMotorOverloaded",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMotorOverloaded_inline",
                   "`true` if one of the gimbal motors is overloaded.  @return A boolean value.",
            ],
            [
                   "`true` if one of the gimbal motors is overloaded.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMotorOverloaded_inline",
                   "",
            ],
            [
                   "IS_MOTOR_OVER_LOADED",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMotorOverloaded_inline",
                   "SDK Key for isMotorOverloaded: `true` if one of the gimbal motors is overloaded.  @return A boolean value.",
            ],
            [
                   "SDK Key for isMotorOverloaded: `true` if one of the gimbal motors is overloaded.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMotorOverloaded_inline",
                   "",
            ],
            [
                   "isCalibrationSuccessful",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrationSuccessful_inline",
                   "`true` if the gimbal calibration succeeded.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal calibration succeeded.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrationSuccessful_inline",
                   "",
            ],
            [
                   "IS_CALIBRATION_SUCCESSFUL",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrationSuccessful_inline",
                   "SDK Key for isCalibrationSuccessful: `true` if the gimbal calibration succeeded.  @return A boolean value.",
            ],
            [
                   "SDK Key for isCalibrationSuccessful: `true` if the gimbal calibration succeeded.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrationSuccessful_inline",
                   "",
            ],
            [
                   "isCalibrating",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrating_inline",
                   "`true` if the gimbal is calibrating.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal is calibrating.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrating_inline",
                   "",
            ],
            [
                   "IS_CALIBRATING",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrating_inline",
                   "SDK Key for isCalibrating: `true` if the gimbal is calibrating.  @return A boolean value.",
            ],
            [
                   "SDK Key for isCalibrating: `true` if the gimbal is calibrating.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isCalibrating_inline",
                   "",
            ],
            [
                   "getCalibrationProgress",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_calibrationProgress_inline",
                   "Current progress (percentage) for calibration.  @return An int value.",
            ],
            [
                   "Current progress (percentage) for calibration.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_calibrationProgress_inline",
                   "",
            ],
            [
                   "CALIBRATION_PROGRESS",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_calibrationProgress_inline",
                   "SDK Key for getCalibrationProgress: Current progress (percentage) for calibration.  @return An int value.",
            ],
            [
                   "SDK Key for getCalibrationProgress: Current progress (percentage) for calibration.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_calibrationProgress_inline",
                   "",
            ],
            [
                   "isPitchAtStop",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isPitchAtStop_inline",
                   "`true` if the gimbal's pitch value is at its limit.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal's pitch value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isPitchAtStop_inline",
                   "",
            ],
            [
                   "IS_PITCH_AT_STOP",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isPitchAtStop_inline",
                   "SDK Key for isPitchAtStop: `true` if the gimbal's pitch value is at its limit.  @return A boolean value.",
            ],
            [
                   "SDK Key for isPitchAtStop: `true` if the gimbal's pitch value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isPitchAtStop_inline",
                   "",
            ],
            [
                   "isRollAtStop",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isRollAtStop_inline",
                   "`true` if the gimbal's roll value is at its limit.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal's roll value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isRollAtStop_inline",
                   "",
            ],
            [
                   "IS_ROLL_AT_STOP",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isRollAtStop_inline",
                   "SDK Key for isRollAtStop: `true` if the gimbal's roll value is at its limit.  @return A boolean value.",
            ],
            [
                   "SDK Key for isRollAtStop: `true` if the gimbal's roll value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isRollAtStop_inline",
                   "",
            ],
            [
                   "isYawAtStop",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isYawAtStop_inline",
                   "`true` if the gimbal's yaw value is at its limit.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal's yaw value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isYawAtStop_inline",
                   "",
            ],
            [
                   "IS_YAW_AT_STOP",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isYawAtStop_inline",
                   "SDK Key for isYawAtStop: `true` if the gimbal's yaw value is at its limit.  @return A boolean value.",
            ],
            [
                   "SDK Key for isYawAtStop: `true` if the gimbal's yaw value is at its limit.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isYawAtStop_inline",
                   "",
            ],
            [
                   "isBalanceTesting",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isTestingBalance_inline",
                   "`true` if the gimbal is currently testing payload balance.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal is currently testing payload balance.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isTestingBalance_inline",
                   "",
            ],
            [
                   "IS_TESTING_BALANCE",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isTestingBalance_inline",
                   "SDK Key for isBalanceTesting: `true` if the gimbal is currently testing payload balance.  @return A boolean value.",
            ],
            [
                   "SDK Key for isBalanceTesting: `true` if the gimbal is currently testing payload balance.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isTestingBalance_inline",
                   "",
            ],
            [
                   "getPitchBalanceTestResult",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchTestResult_inline",
                   "Returns the pitch axis balance test result.  @return A `BalanceTestResult` enum value.",
            ],
            [
                   "Returns the pitch axis balance test result.  @return A `BalanceTestResult` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchTestResult_inline",
                   "",
            ],
            [
                   "PITCH_TEST_RESULT",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchTestResult_inline",
                   "SDK Key for getPitchBalanceTestResult: Returns the pitch axis balance test result.  @return A `BalanceTestResult` enum value.",
            ],
            [
                   "SDK Key for getPitchBalanceTestResult: Returns the pitch axis balance test result.  @return A `BalanceTestResult` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_pitchTestResult_inline",
                   "",
            ],
            [
                   "getRollBalanceTestResult",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollTestResult_inline",
                   "Returns the roll axis balance test result.  @return A `BalanceTestResult` enum value.",
            ],
            [
                   "Returns the roll axis balance test result.  @return A `BalanceTestResult` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollTestResult_inline",
                   "",
            ],
            [
                   "ROLL_TEST_RESULT",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollTestResult_inline",
                   "SDK Key for getRollBalanceTestResult: Returns the roll axis balance test result.  @return A `BalanceTestResult` enum value.",
            ],
            [
                   "SDK Key for getRollBalanceTestResult: Returns the roll axis balance test result.  @return A `BalanceTestResult` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_rollTestResult_inline",
                   "",
            ],
            [
                   "getBalanceState",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_balanceState_inline",
                   "Returns the balance status of the gimbal.  @return A `BalanceState` enum value.",
            ],
            [
                   "Returns the balance status of the gimbal.  @return A `BalanceState` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_balanceState_inline",
                   "",
            ],
            [
                   "BALANCE_STATE",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_balanceState_inline",
                   "SDK Key for getBalanceState: Returns the balance status of the gimbal.  @return A `BalanceState` enum value.",
            ],
            [
                   "SDK Key for getBalanceState: Returns the balance status of the gimbal.  @return A `BalanceState` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_balanceState_inline",
                   "",
            ],
            [
                   "isMountedUpwards",
                   2,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMountedUpwards_inline",
                   "`true` if the gimbal is mounted upwards on the aircraft. It is only supported by M210 and M210 RTK.  @return A boolean value.",
            ],
            [
                   "`true` if the gimbal is mounted upwards on the aircraft. It is only supported by M210 and M210 RTK.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_GimbalState.html",
                   "#DJIGimbal_GimbalState_isMountedUpwards_inline",
                   "",
            ],
            [
                   "MovementSettings",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "",
                   "The current movement settings of the gimbal. These include settings for SmoothTrack and the Controller.",
            ],
            [
                   "The current movement settings of the gimbal. These include settings for SmoothTrack and the Controller.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "",
                   "",
            ],
            [
                   "getProfile",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_profile_inline",
                   "Advanced settings profile.  @return A `MovementSettingsProfile` enum value.",
            ],
            [
                   "Advanced settings profile.  @return A `MovementSettingsProfile` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_profile_inline",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS_PROFILE",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_profile_inline",
                   "SDK Key for getProfile: Advanced settings profile.  @return A `MovementSettingsProfile` enum value.",
            ],
            [
                   "SDK Key for getProfile: Advanced settings profile.  @return A `MovementSettingsProfile` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_profile_inline",
                   "",
            ],
            [
                   "isYawSmoothTrackEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledYaw_inline",
                   "`true` if gimbal SmoothTrack is enabled for the yaw axis.  @return A boolean value.",
            ],
            [
                   "`true` if gimbal SmoothTrack is enabled for the yaw axis.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledYaw_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledYaw_inline",
                   "SDK Key for isYawSmoothTrackEnabled: `true` if gimbal SmoothTrack is enabled for the yaw axis.  @return A boolean value.",
            ],
            [
                   "SDK Key for isYawSmoothTrackEnabled: `true` if gimbal SmoothTrack is enabled for the yaw axis.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledYaw_inline",
                   "",
            ],
            [
                   "isPitchSmoothTrackEnabled",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledPitch_inline",
                   "`true` if gimbal SmoothTrack is enabled for the pitch axis.  @return A boolean value.",
            ],
            [
                   "`true` if gimbal SmoothTrack is enabled for the pitch axis.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledPitch_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledPitch_inline",
                   "SDK Key for isPitchSmoothTrackEnabled: `true` if gimbal SmoothTrack is enabled for the pitch axis.  @return A boolean value.",
            ],
            [
                   "SDK Key for isPitchSmoothTrackEnabled: `true` if gimbal SmoothTrack is enabled for the pitch axis.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_isSmoothTrackEnabledPitch_inline",
                   "",
            ],
            [
                   "getYawSmoothTrackSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedYaw_inline",
                   "SmoothTrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SmoothTrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedYaw_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedYaw_inline",
                   "SDK Key for getYawSmoothTrackSpeed: SmoothTrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SDK Key for getYawSmoothTrackSpeed: SmoothTrack yaw axis speed determines how fast the gimbal will catch up with the translated yaw handle movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedYaw_inline",
                   "",
            ],
            [
                   "getPitchSmoothTrackSpeed",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedPitch_inline",
                   "SmoothTrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SmoothTrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedPitch_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedPitch_inline",
                   "SDK Key for getPitchSmoothTrackSpeed: SmoothTrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SDK Key for getPitchSmoothTrackSpeed: SmoothTrack pitch axis speed determines how fast the gimbal will catch up with the translated pitch handle movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackSpeedPitch_inline",
                   "",
            ],
            [
                   "getYawSmoothTrackDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandYaw_inline",
                   "A larger SmoothTrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
            ],
            [
                   "A larger SmoothTrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandYaw_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandYaw_inline",
                   "SDK Key for getYawSmoothTrackDeadband: A larger SmoothTrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
            ],
            [
                   "SDK Key for getYawSmoothTrackDeadband: A larger SmoothTrack yaw axis deadband requires more yaw handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandYaw_inline",
                   "",
            ],
            [
                   "getPitchSmoothTrackDeadband",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandPitch_inline",
                   "A larger SmoothTrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
            ],
            [
                   "A larger SmoothTrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandPitch_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandPitch_inline",
                   "SDK Key for getPitchSmoothTrackDeadband: A larger SmoothTrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
            ],
            [
                   "SDK Key for getPitchSmoothTrackDeadband: A larger SmoothTrack pitch axis deadband requires more pitch handle movement to translate into gimbal motion. Range is [0,90] degrees.  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackDeadbandPitch_inline",
                   "",
            ],
            [
                   "getYawSmoothTrackAcceleration",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationYaw_inline",
                   "SmoothTrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. Range is [0,30].  @return An int value.",
            ],
            [
                   "SmoothTrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationYaw_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationYaw_inline",
                   "SDK Key for getYawSmoothTrackAcceleration: SmoothTrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. Range is [0,30].  @return An int value.",
            ],
            [
                   "SDK Key for getYawSmoothTrackAcceleration: SmoothTrack yaw axis acceleration determines how closely the gimbal's yaw axis will follow the translated controller movement. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationYaw_inline",
                   "",
            ],
            [
                   "getPitchSmoothTrackAcceleration",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationPitch_inline",
                   "SmoothTrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. Range is [0,30].  @return An int value.",
            ],
            [
                   "SmoothTrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationPitch_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationPitch_inline",
                   "SDK Key for getPitchSmoothTrackAcceleration: SmoothTrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. Range is [0,30].  @return An int value.",
            ],
            [
                   "SDK Key for getPitchSmoothTrackAcceleration: SmoothTrack pitch axis acceleration determines how closely the camera will follow the translated pitch handle movement. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_smoothTrackAccelerationPitch_inline",
                   "",
            ],
            [
                   "getYawControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingYaw_inline",
                   "Controller yaw axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
            ],
            [
                   "Controller yaw axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingYaw_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingYaw_inline",
                   "SDK Key for getYawControllerSmoothingFactor: Controller yaw axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
            ],
            [
                   "SDK Key for getYawControllerSmoothingFactor: Controller yaw axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingYaw_inline",
                   "",
            ],
            [
                   "getPitchControllerSmoothingFactor",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingPitch_inline",
                   "Controller pitch axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
            ],
            [
                   "Controller pitch axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingPitch_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingPitch_inline",
                   "SDK Key for getPitchControllerSmoothingFactor: Controller pitch axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
            ],
            [
                   "SDK Key for getPitchControllerSmoothingFactor: Controller pitch axis smoothing controls the deceleration of the gimbal. A small value will cause the gimbal to stop abruptly. Range is [0,30].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSmoothingPitch_inline",
                   "",
            ],
            [
                   "getYawControllerSpeedCoefficient",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedYaw_inline",
                   "Controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "Controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedYaw_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedYaw_inline",
                   "SDK Key for getYawControllerSpeedCoefficient: Controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SDK Key for getYawControllerSpeedCoefficient: Controller yaw axis speed determines how sensitively the gimbal's yaw axis will follow the controller movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedYaw_inline",
                   "",
            ],
            [
                   "getPitchControllerSpeedCoefficient",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedPitch_inline",
                   "Controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "Controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedPitch_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedPitch_inline",
                   "SDK Key for getPitchControllerSpeedCoefficient: Controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. Range is [0,100].  @return An int value.",
            ],
            [
                   "SDK Key for getPitchControllerSpeedCoefficient: Controller pitch axis speed determines how sensitively the gimbal's pitch axis will follow the controller movement. Range is [0,100].  @return An int value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsState.html",
                   "#DJIGimbal_movementSettingsState_controllerSpeedPitch_inline",
                   "",
            ],
            [
                   "Attitude",
                   2,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "",
                   "The gimbal's attitude in degrees relative to the aircraft. If you don't want a specific axis to get rotated, invoke the `GimbalAttitudeAction` method and set the value of the axis to `NO_ROTATION` in the `Attitude` object. By default, the values of pitch, roll, and yaw in the `Attitude` are set to `NO_ROTATION`.",
            ],
            [
                   "The gimbal's attitude in degrees relative to the aircraft. If you don't want a specific axis to get rotated, invoke the `GimbalAttitudeAction` method and set the value of the axis to `NO_ROTATION` in the `Attitude` object. By default, the values of pitch, roll, and yaw in the `Attitude` are set to `NO_ROTATION`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "",
                   "",
            ],
            [
                   "ATTITUDE_IN_DEGREES",
                   2,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "",
                   "SDK Key for Attitude: The gimbal's attitude in degrees relative to the aircraft. If you don't want a specific axis to get rotated, invoke the `GimbalAttitudeAction` method and set the value of the axis to `NO_ROTATION` in the `Attitude` object. By default, the values of pitch, roll, and yaw in the `Attitude` are set to `NO_ROTATION`.",
            ],
            [
                   "SDK Key for Attitude: The gimbal's attitude in degrees relative to the aircraft. If you don't want a specific axis to get rotated, invoke the `GimbalAttitudeAction` method and set the value of the axis to `NO_ROTATION` in the `Attitude` object. By default, the values of pitch, roll, and yaw in the `Attitude` are set to `NO_ROTATION`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "",
                   "",
            ],
            [
                   "getPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_pitch_inline",
                   "Pitch value in degrees.  @return A float value.",
            ],
            [
                   "Pitch value in degrees.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_pitch_inline",
                   "",
            ],
            [
                   "getRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_roll_inline",
                   "Roll value in degrees.  @return <<android:A float value.>",
            ],
            [
                   "Roll value in degrees.  @return <<android:A float value.>",
                   1,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_roll_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_yaw_inline",
                   "Yaw value in degrees.  @return <<android:A float value.>",
            ],
            [
                   "Yaw value in degrees.  @return <<android:A float value.>",
                   1,
                   "/Components/Gimbal/DJIGimbal_attitude.html",
                   "#DJIGimbal_attitude_yaw_inline",
                   "",
            ],
            [
                   "Axis",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_inline",
                   "Gimbal Axis.",
            ],
            [
                   "Gimbal Axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_inline",
                   "",
            ],
            [
                   "YAW",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_yaw_inline",
                   "Gimbal's yaw axis.",
            ],
            [
                   "Gimbal's yaw axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_yaw_inline",
                   "",
            ],
            [
                   "PITCH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_pitch_inline",
                   "Gimbal's pitch axis.",
            ],
            [
                   "Gimbal's pitch axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_pitch_inline",
                   "",
            ],
            [
                   "ROLL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_roll_inline",
                   "Gimbal's roll axis. Not available in DJIGimbal_resetWithAxisAndResetDirection</code>.",
            ],
            [
                   "Gimbal's roll axis. Not available in DJIGimbal_resetWithAxisAndResetDirection</code>.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_roll_inline",
                   "",
            ],
            [
                   "YAW_AND_PITCH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_yaw_and_pitch_inline",
                   "Gimbal's yaw and pitch axis.",
            ],
            [
                   "Gimbal's yaw and pitch axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_axis_yaw_and_pitch_inline",
                   "",
            ],
            [
                   "GimbalMode",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_inline",
                   "Gimbal work modes.",
            ],
            [
                   "Gimbal work modes.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_inline",
                   "",
            ],
            [
                   "GimbalKey.MODE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_inline",
                   "SDK Key for GimbalMode: Gimbal work modes.",
            ],
            [
                   "SDK Key for GimbalMode: Gimbal work modes.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_inline",
                   "",
            ],
            [
                   "FREE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_freeMode_inline",
                   "The gimbal can move independently of the aircraft's yaw. In this mode, even if the aircraft yaw changes, the camera will continue pointing in the same world direction. This mode is only available for the Ronin-MX when the M600 or M600 Pro landing gear is retracted.",
            ],
            [
                   "The gimbal can move independently of the aircraft's yaw. In this mode, even if the aircraft yaw changes, the camera will continue pointing in the same world direction. This mode is only available for the Ronin-MX when the M600 or M600 Pro landing gear is retracted.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_freeMode_inline",
                   "",
            ],
            [
                   "FPV",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_fpvMode_inline",
                   "The gimbal's work mode is FPV mode. In this mode, the gimbal yaw will follow the aircraft's heading, and the gimbal roll will follow the RC's roll channel value. The pitch will be available to move. This mode is only available for the Ronin- MX when the M600 landing gear is retracted.",
            ],
            [
                   "The gimbal's work mode is FPV mode. In this mode, the gimbal yaw will follow the aircraft's heading, and the gimbal roll will follow the RC's roll channel value. The pitch will be available to move. This mode is only available for the Ronin- MX when the M600 landing gear is retracted.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_fpvMode_inline",
                   "",
            ],
            [
                   "YAW_FOLLOW",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_yawFollowMode_inline",
                   "The gimbal's work mode is such that it will follow the yaw. In this mode, the gimbal yaw will be fixed, while pitch and roll will be available to move.",
            ],
            [
                   "The gimbal's work mode is such that it will follow the yaw. In this mode, the gimbal yaw will be fixed, while pitch and roll will be available to move.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_yawFollowMode_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_unknown_inline",
                   "The gimbal's work mode is unknown.",
            ],
            [
                   "The gimbal's work mode is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_workMode_unknown_inline",
                   "",
            ],
            [
                   "BalanceTestResult",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
            ],
            [
                   "For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "",
            ],
            [
                   "PITCH_TEST_RESULT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "SDK Key for BalanceTestResult: For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
            ],
            [
                   "SDK Key for BalanceTestResult: For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "",
            ],
            [
                   "ROLL_TEST_RESULT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "SDK Key for BalanceTestResult: For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
            ],
            [
                   "SDK Key for BalanceTestResult: For gimbals that allow payloads to be changed, a balance test should be performed to ensure the camera is mounted correctly.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_inline",
                   "",
            ],
            [
                   "PASS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_great_inline",
                   "The balance test result is great.",
            ],
            [
                   "The balance test result is great.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_great_inline",
                   "",
            ],
            [
                   "MARGINAL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_good_inline",
                   "The balance test result is good. When this result is returned, it is possible there was some noise in the balance measurement. For best results, it is recommended to run the balance test again and adjust the payload position until the result becomes great.",
            ],
            [
                   "The balance test result is good. When this result is returned, it is possible there was some noise in the balance measurement. For best results, it is recommended to run the balance test again and adjust the payload position until the result becomes great.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_good_inline",
                   "",
            ],
            [
                   "FAIL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_bad_inline",
                   "The balance test result is bad. The payload should be adjusted when this result is returned.",
            ],
            [
                   "The balance test result is bad. The payload should be adjusted when this result is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_bad_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_unknown_inline",
                   "The balance test result is unknown.",
            ],
            [
                   "The balance test result is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_balanceTestResult_unknown_inline",
                   "",
            ],
            [
                   "MovementSettingsProfile",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_inline",
                   "The Movement Settings Profile contains presets for SmoothTrack and the Physical Controller sensitivity. SmoothTrack and Controller settings can only be manually changed if Custom1 or Custom2 profiles are selected.",
            ],
            [
                   "The Movement Settings Profile contains presets for SmoothTrack and the Physical Controller sensitivity. SmoothTrack and Controller settings can only be manually changed if Custom1 or Custom2 profiles are selected.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_inline",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS_PROFILE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_inline",
                   "SDK Key for MovementSettingsProfile: The Movement Settings Profile contains presets for SmoothTrack and the Physical Controller sensitivity. SmoothTrack and Controller settings can only be manually changed if Custom1 or Custom2 profiles are selected.",
            ],
            [
                   "SDK Key for MovementSettingsProfile: The Movement Settings Profile contains presets for SmoothTrack and the Physical Controller sensitivity. SmoothTrack and Controller settings can only be manually changed if Custom1 or Custom2 profiles are selected.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_inline",
                   "",
            ],
            [
                   "FAST",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_fast_inline",
                   "The gimbal's SmoothTrack and Controller sensitivity is high. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
            ],
            [
                   "The gimbal's SmoothTrack and Controller sensitivity is high. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_fast_inline",
                   "",
            ],
            [
                   "MEDIUM",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_medium_inline",
                   "The gimbal's SmoothTrack and Controller sensitivity is medium. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
            ],
            [
                   "The gimbal's SmoothTrack and Controller sensitivity is medium. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_medium_inline",
                   "",
            ],
            [
                   "SLOW",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_slow_inline",
                   "The gimbal's SmoothTrack and Controller sensitivity is slow. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
            ],
            [
                   "The gimbal's SmoothTrack and Controller sensitivity is slow. When the gimbal is using this profile, user cannot change the Movement Settings manually.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_slow_inline",
                   "",
            ],
            [
                   "CUSTOM_1",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_custom1_inline",
                   "The gimbal uses a custom configuration in memory slot 1 where the yaw and pitch speed, deadband, and acceleration can be defined.",
            ],
            [
                   "The gimbal uses a custom configuration in memory slot 1 where the yaw and pitch speed, deadband, and acceleration can be defined.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_custom1_inline",
                   "",
            ],
            [
                   "CUSTOM_2",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_custom2_inline",
                   "The gimbal uses a custom configuration in memory slot 2 where the yaw and pitch speed, deadband, and acceleration can be defined.",
            ],
            [
                   "The gimbal uses a custom configuration in memory slot 2 where the yaw and pitch speed, deadband, and acceleration can be defined.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_custom2_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_unknown_inline",
                   "The gimbal's user config type is unknown.",
            ],
            [
                   "The gimbal's user config type is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_movementSettingsProfile_unknown_inline",
                   "",
            ],
            [
                   "MotorControlPreset",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_inline",
                   "Different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
            ],
            [
                   "Different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_inline",
                   "",
            ],
            [
                   "APPLY_MOTOR_CONTROL_PRESET",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_inline",
                   "SDK Key for MotorControlPreset: Different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
            ],
            [
                   "SDK Key for MotorControlPreset: Different cameras have different preset parameters for gimbal motor stiffness, strength, gyro filtering and pre-control.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_inline",
                   "",
            ],
            [
                   "RED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_red_inline",
                   "The gimbal's motor control configuration is optimized for RED cameras.",
            ],
            [
                   "The gimbal's motor control configuration is optimized for RED cameras.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_red_inline",
                   "",
            ],
            [
                   "DSLR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_DSLRCamera_inline",
                   "The gimbal's motor control configuration is optimized for most DSLR cameras.",
            ],
            [
                   "The gimbal's motor control configuration is optimized for most DSLR cameras.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_DSLRCamera_inline",
                   "",
            ],
            [
                   "MIRRORLESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_mirrorlessCamera_inline",
                   "The gimbal's motor control configuration is optimized for most mirrorless cameras.",
            ],
            [
                   "The gimbal's motor control configuration is optimized for most mirrorless cameras.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_motorControlPreset_mirrorlessCamera_inline",
                   "",
            ],
            [
                   "EndpointDirection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_inline",
                   "Gimbal endpoint setting.",
            ],
            [
                   "Gimbal endpoint setting.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_inline",
                   "",
            ],
            [
                   "PITCH_UP",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_pitchUp_inline",
                   "Pitch (also called tilt) endpoint setting in the upwards direction.",
            ],
            [
                   "Pitch (also called tilt) endpoint setting in the upwards direction.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_pitchUp_inline",
                   "",
            ],
            [
                   "PITCH_DOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_pitchDown_inline",
                   "Pitch (also called tilt) endpoint setting in the downwards direction.",
            ],
            [
                   "Pitch (also called tilt) endpoint setting in the downwards direction.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_pitchDown_inline",
                   "",
            ],
            [
                   "YAW_LEFT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_yawLeft_inline",
                   "Yaw (also called pan) endpoint setting in the left direction.",
            ],
            [
                   "Yaw (also called pan) endpoint setting in the left direction.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_yawLeft_inline",
                   "",
            ],
            [
                   "YAW_RIGHT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_yawRight_inline",
                   "Yaw (also called pan) endpoint setting in the right direction.",
            ],
            [
                   "Yaw (also called pan) endpoint setting in the right direction.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_endpointDirection_yawRight_inline",
                   "",
            ],
            [
                   "BalanceState",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_inline",
                   "The loading balance status of the gimbal. The gimbal loading is changeable for Osmo Mobile. When the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
            ],
            [
                   "The loading balance status of the gimbal. The gimbal loading is changeable for Osmo Mobile. When the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_inline",
                   "",
            ],
            [
                   "BALANCE_STATE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_inline",
                   "SDK Key for BalanceState: The loading balance status of the gimbal. The gimbal loading is changeable for Osmo Mobile. When the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
            ],
            [
                   "SDK Key for BalanceState: The loading balance status of the gimbal. The gimbal loading is changeable for Osmo Mobile. When the mounted mobile device is changed, in order to  optimize the gimbal performance, user can adjust the gimbal physically based on the status.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_inline",
                   "",
            ],
            [
                   "BALANCED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_balanced_inline",
                   "The gimbal is balanced.",
            ],
            [
                   "The gimbal is balanced.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_balanced_inline",
                   "",
            ],
            [
                   "TILTING_LEFT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_tiltingLeft_inline",
                   "The gimbal is tilting left. Adjust the photo to the right hand side to balance the gimbal.",
            ],
            [
                   "The gimbal is tilting left. Adjust the photo to the right hand side to balance the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_tiltingLeft_inline",
                   "",
            ],
            [
                   "TILTING_RIGHT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_tiltingRight_inline",
                   "The gimbal is tilting right. Adjust the photo to the left hand side to balance the gimbal.",
            ],
            [
                   "The gimbal is tilting right. Adjust the photo to the left hand side to balance the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_tiltingRight_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_unknown_inline",
                   "The balance status is unknown.",
            ],
            [
                   "The balance status is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_loadingBalanceStatus_unknown_inline",
                   "",
            ],
            [
                   "DetectionResultOnAxis",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_inline",
                   "Gimbal's balance or coaxiality detection result on axis.",
            ],
            [
                   "Gimbal's balance or coaxiality detection result on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_inline",
                   "",
            ],
            [
                   "GREAT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Great_inline",
                   "Balance or coaxiality detection result is great.",
            ],
            [
                   "Balance or coaxiality detection result is great.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Great_inline",
                   "",
            ],
            [
                   "GOOD",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Good_inline",
                   "Balance or coaxiality detection result is good.",
            ],
            [
                   "Balance or coaxiality detection result is good.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Good_inline",
                   "",
            ],
            [
                   "BAD",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Bad_inline",
                   "Balance or coaxiality detection result is bad. Please adjust gimbal's balance or coaxiality according to corresponding result.",
            ],
            [
                   "Balance or coaxiality detection result is bad. Please adjust gimbal's balance or coaxiality according to corresponding result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Bad_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Unknown_inline",
                   "The gimbal detection result is unknown.",
            ],
            [
                   "The gimbal detection result is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDetectionResultOnAxis_Unknown_inline",
                   "",
            ],
            [
                   "BalanceDetectionProgressStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_inline",
                   "Current balance detection progress status of balance detection.",
            ],
            [
                   "Current balance detection progress status of balance detection.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_inline",
                   "",
            ],
            [
                   "IN_PROCESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_InProcess_inline",
                   "Gimbal's balance detection is in process.",
            ],
            [
                   "Gimbal's balance detection is in process.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_InProcess_inline",
                   "",
            ],
            [
                   "FINISHED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Finished_inline",
                   "Gimbal's balance detection has finished.",
            ],
            [
                   "Gimbal's balance detection has finished.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Finished_inline",
                   "",
            ],
            [
                   "ERROR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Error_inline",
                   "Gimbal's balance balance detection has stopped with error.",
            ],
            [
                   "Gimbal's balance balance detection has stopped with error.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Error_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Unknown_inline",
                   "Gimbal's balance detection status is unknown.",
            ],
            [
                   "Gimbal's balance detection status is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionProgressStatus_Unknown_inline",
                   "",
            ],
            [
                   "CoaxialityDetectionProgressStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_inline",
                   "Current coaxiality detection progress status of balance detection.",
            ],
            [
                   "Current coaxiality detection progress status of balance detection.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_inline",
                   "",
            ],
            [
                   "IN_PROCESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_InProcess_inline",
                   "Gimbal's coaxiality detection is in process.",
            ],
            [
                   "Gimbal's coaxiality detection is in process.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_InProcess_inline",
                   "",
            ],
            [
                   "FINISHED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Finished_inline",
                   "Gimbal's coaxiality detection has finished.",
            ],
            [
                   "Gimbal's coaxiality detection has finished.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Finished_inline",
                   "",
            ],
            [
                   "ERROR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Error_inline",
                   "Gimbal's coaxiality detection has stopped with error.",
            ],
            [
                   "Gimbal's coaxiality detection has stopped with error.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Error_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Unknown_inline",
                   "Gimbal's coaxiality detection status is unknown.",
            ],
            [
                   "Gimbal's coaxiality detection status is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionProgressStatus_Unknown_inline",
                   "",
            ],
            [
                   "DirectionAdjustmentResult",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_inline",
                   "Gimbal's direction adjustment result.",
            ],
            [
                   "Gimbal's direction adjustment result.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_inline",
                   "",
            ],
            [
                   "GOOD",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Good_inline",
                   "The direction check result is good.",
            ],
            [
                   "The direction check result is good.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Good_inline",
                   "",
            ],
            [
                   "BAD",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Bad_inline",
                   "Gimbal's direction adjustment result is bad.",
            ],
            [
                   "Gimbal's direction adjustment result is bad.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Bad_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Unknown_inline",
                   "Gimbal's direction adjustment result is unknown.",
            ],
            [
                   "Gimbal's direction adjustment result is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalDirectionAdjustmentResult_Unknown_inline",
                   "",
            ],
            [
                   "SuggestedDirectionAdjustment",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_inline",
                   "The suggested direction adjustment of gimbal.",
            ],
            [
                   "The suggested direction adjustment of gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_None_inline",
                   "No need to adjust.",
            ],
            [
                   "No need to adjust.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_None_inline",
                   "",
            ],
            [
                   "LEFT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Left_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Left_inline",
                   "",
            ],
            [
                   "RIGHT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Right_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Right_inline",
                   "",
            ],
            [
                   "UPWARDS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Upwards_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Upwards_inline",
                   "",
            ],
            [
                   "DOWNWARDS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Downwards_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Downwards_inline",
                   "",
            ],
            [
                   "FORWARDS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Forwards_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Forwards_inline",
                   "",
            ],
            [
                   "BACKWARDS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Backwards_inline",
                   "Manually adjust the camera to the corresponding direction on axis.",
            ],
            [
                   "Manually adjust the camera to the corresponding direction on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalSuggestedDirectionAdjustment_Backwards_inline",
                   "",
            ],
            [
                   "ControlParametersAutoTuningStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_inline",
                   "The control parameters auto tuning status of the gimbal.",
            ],
            [
                   "The control parameters auto tuning status of the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_inline",
                   "",
            ],
            [
                   "IN_PROCESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_InProcess_inline",
                   "Control parameters auto-tuning is in progress.",
            ],
            [
                   "Control parameters auto-tuning is in progress.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_InProcess_inline",
                   "",
            ],
            [
                   "FINISHED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Finished_inline",
                   "Control parameters auto-tuning is finished.",
            ],
            [
                   "Control parameters auto-tuning is finished.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Finished_inline",
                   "",
            ],
            [
                   "ERROR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Error_inline",
                   "The control parameters auto tuning occurs error.",
            ],
            [
                   "The control parameters auto tuning occurs error.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Error_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Unknown_inline",
                   "Unknown control parameters auto-tuning state.",
            ],
            [
                   "Unknown control parameters auto-tuning state.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningStatus_Unknown_inline",
                   "",
            ],
            [
                   "RotationalInertiaState",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_inline",
                   "Gimbal's rotational inertia state.",
            ],
            [
                   "Gimbal's rotational inertia state.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_Normal_inline",
                   "The rotational inertia of axis is normal.",
            ],
            [
                   "The rotational inertia of axis is normal.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_Normal_inline",
                   "",
            ],
            [
                   "SMALLER",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_TooSmall_inline",
                   "The rotational inertia is too small. PayLoad need to be added.",
            ],
            [
                   "The rotational inertia is too small. PayLoad need to be added.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_TooSmall_inline",
                   "",
            ],
            [
                   "TOO_LARGER",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_TooLarge_inline",
                   "The rotational inertia is too large. Payload need to be reduced.",
            ],
            [
                   "The rotational inertia is too large. Payload need to be reduced.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_TooLarge_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalRotationalInertiaState_Unknown_inline",
                   "",
            ],
            [
                   "AxialStiffnessState",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_inline",
                   "Gimbal's stiffness on axis.",
            ],
            [
                   "Gimbal's stiffness on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Normal_inline",
                   "Normal stiffness on axis.",
            ],
            [
                   "Normal stiffness on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Normal_inline",
                   "",
            ],
            [
                   "LOW",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Low_inline",
                   "Low stiffness on axis.",
            ],
            [
                   "Low stiffness on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Low_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Unknown_inline",
                   "The stiffness on axis is unknown.",
            ],
            [
                   "The stiffness on axis is unknown.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_DJIGimbalAxialStiffnessState_Unknown_inline",
                   "",
            ],
            [
                   "ResetDirection",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_inline",
                   "Gimbal reset direction.",
            ],
            [
                   "Gimbal reset direction.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_inline",
                   "",
            ],
            [
                   "UP_OR_DOWN",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_UP_OR_DOWN_inline",
                   "The standard position for the upper gimbal is pointing up vertically to the sky. The standard position for the downward gimbal is pointing down vertically to the earth.",
            ],
            [
                   "The standard position for the upper gimbal is pointing up vertically to the sky. The standard position for the downward gimbal is pointing down vertically to the earth.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_UP_OR_DOWN_inline",
                   "",
            ],
            [
                   "CENTER",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_CENTER_inline",
                   "Applies only to the yaw. The standard position is pointing to the center.",
            ],
            [
                   "Applies only to the yaw. The standard position is pointing to the center.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ResetDirection_CENTER_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Gimbal/DJIGimbal_stateUpdateCallbackInterface.html",
                   "",
                   "Callback for updating the gimbal's current state.",
            ],
            [
                   "Callback for updating the gimbal's current state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_stateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Gimbal/DJIGimbal_movementSettingsStateUpdateCallbackInterface.html",
                   "",
                   "This interface provides the method to receive the updated state and user configuration.",
            ],
            [
                   "This interface provides the method to receive the updated state and user configuration.",
                   1,
                   "/Components/Gimbal/DJIGimbal_movementSettingsStateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BatteryChargeRemainingCallback",
                   2,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "",
                   "Gimbal energy remaining of Ronin MX in percent.",
            ],
            [
                   "Gimbal energy remaining of Ronin MX in percent.",
                   1,
                   "/Components/Gimbal/DJIGimbal_batteryRemainingEnergyUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "CapabilityKey",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_GimbalCapabilityKey_inline",
                   "These enums are keys for gimbal capability map.",
            ],
            [
                   "These enums are keys for gimbal capability map.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_GimbalCapabilityKey_inline",
                   "",
            ],
            [
                   "ADJUST_PITCH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustPitch_inline",
                   "Key enum in the `getCapabilities` dictionary that holds the complete capability of the gimbal. The value is capability range of the gimbal is placed downwards, A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
            ],
            [
                   "Key enum in the `getCapabilities` dictionary that holds the complete capability of the gimbal. The value is capability range of the gimbal is placed downwards, A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustPitch_inline",
                   "",
            ],
            [
                   "ADJUST_PITCH_UPWARDS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustPitchUpwards_inline",
                   "Key enum in the `getCapabilities` dictionary that holds the complete capability of the gimbal. The value is capability range of the gimbal is placed upwards, A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
            ],
            [
                   "Key enum in the `getCapabilities` dictionary that holds the complete capability of the gimbal. The value is capability range of the gimbal is placed upwards, A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustPitchUpwards_inline",
                   "",
            ],
            [
                   "ADJUST_YAW",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal supports yaw axis adjustment. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned. A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation. For Gimbal's that allow a pitch range extension (see `PITCH_RANGE_EXTENSION`, the range will be representative of the extended range whether it is enabled or not.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal supports yaw axis adjustment. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned. A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation. For Gimbal's that allow a pitch range extension (see `PITCH_RANGE_EXTENSION`, the range will be representative of the extended range whether it is enabled or not.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustYaw_inline",
                   "",
            ],
            [
                   "ADJUST_ROLL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustRoll_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal supports roll axis adjustment. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned. A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal supports roll axis adjustment. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned. A negative value in the valid range represents counter-clockwise rotation. A positive value in the valid range represents clockwise rotation.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamAdjustRoll_inline",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMovementSettingsProfile_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal supports Advanced Settings Profiles. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal supports Advanced Settings Profiles. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMovementSettingsProfile_inline",
                   "",
            ],
            [
                   "PITCH_RANGE_EXTENSION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamPitchRangeExtensionEnabled_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal supports a range extension in pitch. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal supports a range extension in pitch. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range in degrees is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamPitchRangeExtensionEnabled_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSpeedPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis response speed to manual control can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis response speed to manual control can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSpeedPitch_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSpeedYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis response speed to manual control can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis response speed to manual control can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSpeedYaw_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSmoothingPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis smoothing can be adjusted when using manual control. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis smoothing can be adjusted when using manual control. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSmoothingPitch_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSmoothingYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis smoothing can be adjusted when using manual control. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis smoothing can be adjusted when using manual control. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerSmoothingYaw_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerDeadbandPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's manual control pitch axis deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's manual control pitch axis deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerDeadbandPitch_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerDeadbandYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's manual control yaw axis deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's manual control yaw axis deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamControllerDeadbandYaw_inline",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_MAX_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamPitchControllerMaxSpeed_inline",
                   "Key  in `getCapabilities` associated with whether the gimbal's manual control pitch axis max speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key  in `getCapabilities` associated with whether the gimbal's manual control pitch axis max speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamPitchControllerMaxSpeed_inline",
                   "",
            ],
            [
                   "YAW_CONTROLLER_MAX_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamYawControllerMaxSpeed_inline",
                   "Key  in `getCapabilities` associated with whether the gimbal's manual control yaw axis max speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key  in `getCapabilities` associated with whether the gimbal's manual control yaw axis max speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamYawControllerMaxSpeed_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackEnabledPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack can be toggled. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`. Ronin-MX cannot toggle the SmoothTrack functionality and it is always enabled.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack can be toggled. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`. Ronin-MX cannot toggle the SmoothTrack functionality and it is always enabled.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackEnabledPitch_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackEnabledYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack can be toggled. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`. Ronin-MX cannot toggle the SmoothTrack functionality and it is always enabled.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack can be toggled. The corresponding value in `getCapabilities` is an instance of `DJIParamCapability`. Ronin-MX cannot toggle the SmoothTrack functionality and it is always enabled.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackEnabledYaw_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackAccelerationPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack acceleration can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack acceleration can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackAccelerationPitch_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackAccelerationYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack acceleration can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack acceleration can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackAccelerationYaw_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackSpeedPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackSpeedPitch_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackSpeedYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack speed can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackSpeedYaw_inline",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackDeadbandPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis SmoothTrack deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackDeadbandPitch_inline",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackDeadbandYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis SmoothTrack deadband can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamSmoothTrackDeadbandYaw_inline",
                   "",
            ],
            [
                   "PITCH_UP_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointPitchUp_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch up endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch up endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointPitchUp_inline",
                   "",
            ],
            [
                   "PITCH_DOWN_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointPitchDown_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch down endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch down endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointPitchDown_inline",
                   "",
            ],
            [
                   "YAW_LEFT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointYawLeft_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw left endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw left endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointYawLeft_inline",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointYawRight_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw right endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw right endpoint can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamEndpointYawRight_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessPitch_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessYaw_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessRoll_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control stiffness can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStiffnessRoll_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthPitch_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthYaw_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthRoll_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control strength can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlStrengthRoll_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringPitch_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringYaw_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringRoll_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control gyro filtering can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlGyroFilteringRoll_inline",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolPitch_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's pitch axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolPitch_inline",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolYaw_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's yaw axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolYaw_inline",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolRoll_inline",
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
            ],
            [
                   "Key enum in `getCapabilities` associated with whether the gimbal's roll axis motor control precontrol can be adjusted. The corresponding value in `getCapabilities` is an instance of `DJIParamMinMaxCapability` meaning both the feature's existence as well as its possible range (unitless) is returned.",
                   1,
                   "/Components/Gimbal/DJIGimbal.html",
                   "#DJIGimbal_ParamMotorControlPrecontrolRoll_inline",
                   "",
            ],
            [
                   "Rotation",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "",
                   "Represents a gimbal speed or angular rotation operation. If you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `NO_ROTATION` in the `Rotation` object. By default, the values of pitch, roll, and yaw in the `Rotation` are set to `NO_ROTATION`.",
            ],
            [
                   "Represents a gimbal speed or angular rotation operation. If you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `NO_ROTATION` in the `Rotation` object. By default, the values of pitch, roll, and yaw in the `Rotation` are set to `NO_ROTATION`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "",
                   "",
            ],
            [
                   "ROTATE",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "",
                   "SDK Key for Rotation: Represents a gimbal speed or angular rotation operation. If you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `NO_ROTATION` in the `Rotation` object. By default, the values of pitch, roll, and yaw in the `Rotation` are set to `NO_ROTATION`.",
            ],
            [
                   "SDK Key for Rotation: Represents a gimbal speed or angular rotation operation. If you don't want a specific axis to get rotated, invoke the `rotate` method and set the value of the axis to `NO_ROTATION` in the `Rotation` object. By default, the values of pitch, roll, and yaw in the `Rotation` are set to `NO_ROTATION`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_mode_inline",
                   "Type of gimbal rotation operation mode.  @return A `RotationMode` enum value.",
            ],
            [
                   "Type of gimbal rotation operation mode.  @return A `RotationMode` enum value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_mode_inline",
                   "",
            ],
            [
                   "getPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_pitch_inline",
                   "The pitch property of a gimbal rotation operation, how much the gimbal rotates on the pitch axis. When it is `null`, no operation will be applied to the pitch axis.  @return A float value.",
            ],
            [
                   "The pitch property of a gimbal rotation operation, how much the gimbal rotates on the pitch axis. When it is `null`, no operation will be applied to the pitch axis.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_pitch_inline",
                   "",
            ],
            [
                   "getRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_roll_inline",
                   "The roll property of a gimbal rotation operation, how much the gimbal rotates on the roll axis. When it is `null`, no operation will be applied to the roll axis.  @return A float value.",
            ],
            [
                   "The roll property of a gimbal rotation operation, how much the gimbal rotates on the roll axis. When it is `null`, no operation will be applied to the roll axis.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_roll_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_yaw_inline",
                   "The yaw property of a gimbal rotation operation, how much the gimbal rotates on the yaw axis. When the rotation mode is `ABSOLUTE_ANGLE`, the yaw value is relative to the aircraft's heading. When it is `null`, no operation will be applied to the yaw axis.  @return A float value.",
            ],
            [
                   "The yaw property of a gimbal rotation operation, how much the gimbal rotates on the yaw axis. When the rotation mode is `ABSOLUTE_ANGLE`, the yaw value is relative to the aircraft's heading. When it is `null`, no operation will be applied to the yaw axis.  @return A float value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_yaw_inline",
                   "",
            ],
            [
                   "getTime",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_time_inline",
                   "The time of the gimbal speed rotation operation(unit: second). Does not take effect in waypoint mission.  @return A double value. Should set a value greater than 0.",
            ],
            [
                   "The time of the gimbal speed rotation operation(unit: second). Does not take effect in waypoint mission.  @return A double value. Should set a value greater than 0.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_time_inline",
                   "",
            ],
            [
                   "getIgnore",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_ignore_inline",
                   "Sets true to ignore remote controller gimbal stick control.  @return A boolean value.",
            ],
            [
                   "Sets true to ignore remote controller gimbal stick control.  @return A boolean value.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_ignore_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "",
                   "Object builder.",
            ],
            [
                   "Object builder.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_builder_void_inline",
                   "Default rotation constructor method.",
            ],
            [
                   "Default rotation constructor method.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_builder_void_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_builder_rotation_inline",
                   "Constructor method that clones a rotation object.  @param rotation An instance of `Rotation`.",
            ],
            [
                   "Constructor method that clones a rotation object.  @param rotation An instance of `Rotation`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_builder_rotation_inline",
                   "",
            ],
            [
                   "mode",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_mode_inline",
                   "Constructor method.  @param mode An enum value of `RotationMode`.  @return Builder object for mode",
            ],
            [
                   "Constructor method.  @param mode An enum value of `RotationMode`.  @return Builder object for mode",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_mode_inline",
                   "",
            ],
            [
                   "pitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_pitch_inline",
                   "Constructor method.  @param pitch A float value of pitch.  @return Builder object for pitch",
            ],
            [
                   "Constructor method.  @param pitch A float value of pitch.  @return Builder object for pitch",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_pitch_inline",
                   "",
            ],
            [
                   "roll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_roll_inline",
                   "Constructor method.  @param roll A float value of roll.  @return Builder object for roll",
            ],
            [
                   "Constructor method.  @param roll A float value of roll.  @return Builder object for roll",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_roll_inline",
                   "",
            ],
            [
                   "yaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_yaw_inline",
                   "Constructor method.  @param yaw A float value of yaw.  @return Builder object for yaw",
            ],
            [
                   "Constructor method.  @param yaw A float value of yaw.  @return Builder object for yaw",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_yaw_inline",
                   "",
            ],
            [
                   "time",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_time_inline",
                   "Sets the completion time in seconds to complete an action to control the gimbal. If the the rotation mode is `ABSOLUTE_ANGLE` then the time determines the duration of time the gimbal should rotate to its new position. For example, if a value of 2.0 is used, then the gimbal will rotate to its target position in 2.0 seconds. Range is [0.1,25.5] seconds. Does not take effect in waypoint mission.  @param time A double value of time.  @return Builder object for time",
            ],
            [
                   "Sets the completion time in seconds to complete an action to control the gimbal. If the the rotation mode is `ABSOLUTE_ANGLE` then the time determines the duration of time the gimbal should rotate to its new position. For example, if a value of 2.0 is used, then the gimbal will rotate to its target position in 2.0 seconds. Range is [0.1,25.5] seconds. Does not take effect in waypoint mission.  @param time A double value of time.  @return Builder object for time",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_time_inline",
                   "",
            ],
            [
                   "ignore",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_ignore_inline",
                   "Set whether the app can control the gimbal.  @param ignore `true` if the app can control the gimbal.  @return Builder object.",
            ],
            [
                   "Set whether the app can control the gimbal.  @param ignore `true` if the app can control the gimbal.  @return Builder object.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_ignore_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_build_inline",
                   "Build the object.  @return Instance of `Rotation`.",
            ],
            [
                   "Build the object.  @return Instance of `Rotation`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation_Constructor.html",
                   "#DJIGimbal_DJIGimbalRotation_Constructor_build_inline",
                   "",
            ],
            [
                   "RotationMode",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_inline",
                   "The mode of the gimbal rotation operation.",
            ],
            [
                   "The mode of the gimbal rotation operation.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_inline",
                   "",
            ],
            [
                   "RELATIVE_ANGLE",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_RelativeAngle_inline",
                   "The angle value, when the gimbal is rotating, relative to the current angle.",
            ],
            [
                   "The angle value, when the gimbal is rotating, relative to the current angle.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_RelativeAngle_inline",
                   "",
            ],
            [
                   "ABSOLUTE_ANGLE",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_AbsoluteAngle_inline",
                   "The angle value, when the gimbal is rotating, relative to 0 degrees (aircraft heading). For Inspire 1, using X3, X3 Zoom and Z3 cameras will be relative to true north. Using X5, XT and X5R will be relative to the aircraft heading.  For Inspire 2, using X4S and X5S cameras will be relative to true north. Using X7 and Z30 will be relative to the aircraft heading.  For Matrice 300 RTK with H20 series and Zenmuse P1 camera, the angle rotation is relative to the aircraft heading if you rotate the gimbal directly. The angle rotation is relative to true North if you use it in `WaypointV2MissionAction`.",
            ],
            [
                   "The angle value, when the gimbal is rotating, relative to 0 degrees (aircraft heading). For Inspire 1, using X3, X3 Zoom and Z3 cameras will be relative to true north. Using X5, XT and X5R will be relative to the aircraft heading.  For Inspire 2, using X4S and X5S cameras will be relative to true north. Using X7 and Z30 will be relative to the aircraft heading.  For Matrice 300 RTK with H20 series and Zenmuse P1 camera, the angle rotation is relative to the aircraft heading if you rotate the gimbal directly. The angle rotation is relative to true North if you use it in `WaypointV2MissionAction`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_AbsoluteAngle_inline",
                   "",
            ],
            [
                   "SPEED",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_Speed_inline",
                   "Rotate the gimbal's pitch, roll, and yaw in SPEED Mode. The direction can either be set to clockwise or counter-clockwise.  For Phantom 3 Professional, Phantom 3 Advanced and Phantom 3 Standard, roll and yaw rotations are not available.  For Inspire 1, Inspire Pro and M100, pitch, roll and yaw rotations are available.  For Osmo, roll rotation is not available. The yaw angleVelocity of DJIGimbalSpeedRotation range is (-120, 120).",
            ],
            [
                   "Rotate the gimbal's pitch, roll, and yaw in SPEED Mode. The direction can either be set to clockwise or counter-clockwise.  For Phantom 3 Professional, Phantom 3 Advanced and Phantom 3 Standard, roll and yaw rotations are not available.  For Inspire 1, Inspire Pro and M100, pitch, roll and yaw rotations are available.  For Osmo, roll rotation is not available. The yaw angleVelocity of DJIGimbalSpeedRotation range is (-120, 120).",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalRotation.html",
                   "#DJIGimbal_DJIGimbalRotation_DJIGimbalRotationMode_Speed_inline",
                   "",
            ],
            [
                   "MultiGimbalConnectionWorkingStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "",
                   "This class describes which gimbal is running with Multi-Gimbal Connection.",
            ],
            [
                   "This class describes which gimbal is running with Multi-Gimbal Connection.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "",
                   "",
            ],
            [
                   "isMultiGimbalConnectionWorking",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isMultiGimbalConnectionWorking_inline",
                   "`true` if Multi-Gimbal Connection is currently enabled.  @return A boolean value to check Multi-Gimbal Connection.",
            ],
            [
                   "`true` if Multi-Gimbal Connection is currently enabled.  @return A boolean value to check Multi-Gimbal Connection.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isMultiGimbalConnectionWorking_inline",
                   "",
            ],
            [
                   "isLeftGimbalRunningWithMultiGimbalConnection",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isLeftGimbalRunningWithMultiGimbalConnection_inline",
                   "`true` if the left gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check left gimbal running with multi-gimbal connection.",
            ],
            [
                   "`true` if the left gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check left gimbal running with multi-gimbal connection.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isLeftGimbalRunningWithMultiGimbalConnection_inline",
                   "",
            ],
            [
                   "isRightGimbalRunningWithMultiGimbalConnection",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isRightGimbalRunningWithMultiGimbalConnection_inline",
                   "`true` if the right gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check right gimbal running with multi-gimbal connection.",
            ],
            [
                   "`true` if the right gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check right gimbal running with multi-gimbal connection.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isRightGimbalRunningWithMultiGimbalConnection_inline",
                   "",
            ],
            [
                   "isUpperGimbalRunningWithMultiGimbalConnection",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isUpperGimbalRunningWithMultiGimbalConnection_inline",
                   "`true` if the upper gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check upper gimbal running with multi-gimbal connection.",
            ],
            [
                   "`true` if the upper gimbal is currently running with Multi-Gimbal Connection.  @return A boolean value to check upper gimbal running with multi-gimbal connection.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIMultiGimbalConnectionWorkingStatus.html",
                   "#DJIGimbal_DJIMultiGimbalConnectionWorkingStatus_isUpperGimbalRunningWithMultiGimbalConnection_inline",
                   "",
            ],
            [
                   "GimbalBalanceDetectionState",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "",
                   "This class provides current balance detection information of the gimbal.",
            ],
            [
                   "This class provides current balance detection information of the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "",
                   "",
            ],
            [
                   "getStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_balanceDetectionStatus_inline",
                   "The balance detection status.  @return An enum value of `BalanceDetectionProgressStatus`.",
            ],
            [
                   "The balance detection status.  @return An enum value of `BalanceDetectionProgressStatus`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_balanceDetectionStatus_inline",
                   "",
            ],
            [
                   "getResultOnPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnPitch_inline",
                   "Gimbal balance detection result on pitch.  @return An enum value of `DetectionResultOnAxis`.",
            ],
            [
                   "Gimbal balance detection result on pitch.  @return An enum value of `DetectionResultOnAxis`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnPitch_inline",
                   "",
            ],
            [
                   "getResultOnRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnRoll_inline",
                   "Gimbal balance detection result on roll.  @return An enum value of `DetectionResultOnAxis`.",
            ],
            [
                   "Gimbal balance detection result on roll.  @return An enum value of `DetectionResultOnAxis`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnRoll_inline",
                   "",
            ],
            [
                   "getResultOnYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnYaw_inline",
                   "Gimbal balance detection result on yaw.  @return An enum value of `DetectionResultOnAxis`.",
            ],
            [
                   "Gimbal balance detection result on yaw.  @return An enum value of `DetectionResultOnAxis`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_resultOnYaw_inline",
                   "",
            ],
            [
                   "getDirectionAdjustmentStateOnPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnPitch_inline",
                   "Direction adjustment state on Pitch.  @return Return an object of `DirectionState`.",
            ],
            [
                   "Direction adjustment state on Pitch.  @return Return an object of `DirectionState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnPitch_inline",
                   "",
            ],
            [
                   "getDirectionAdjustmentStateOnRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnRoll_inline",
                   "Direction adjustment state on roll.  @return Return an object of `DirectionState`.",
            ],
            [
                   "Direction adjustment state on roll.  @return Return an object of `DirectionState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnRoll_inline",
                   "",
            ],
            [
                   "getDirectionAdjustmentStateOnYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnYaw_inline",
                   "Direction adjustment state on yaw.  @return Return an object of `DirectionState`.",
            ],
            [
                   "Direction adjustment state on yaw.  @return Return an object of `DirectionState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_directionAdjustmentStateOnYaw_inline",
                   "",
            ],
            [
                   "getProcess",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_progress_inline",
                   "Gimbal's balance detection progress percentage.  @return An int value of detection progress.",
            ],
            [
                   "Gimbal's balance detection progress percentage.  @return An int value of detection progress.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_progress_inline",
                   "",
            ],
            [
                   "isAircraftStabilitySatisfied",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isAircraftStabilitySatisfied_inline",
                   "`false` if aircraft stability does not meet requirements.  @return A boolean value to check the aircraft's stability.",
            ],
            [
                   "`false` if aircraft stability does not meet requirements.  @return A boolean value to check the aircraft's stability.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isAircraftStabilitySatisfied_inline",
                   "",
            ],
            [
                   "isAircraftMotorOn",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isAircraftMotorOn_inline",
                   "Turn off aircraft motor and run balance detection again if this is `true`.  @return A boolean value to check the aircraft's motor on.",
            ],
            [
                   "Turn off aircraft motor and run balance detection again if this is `true`.  @return A boolean value to check the aircraft's motor on.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isAircraftMotorOn_inline",
                   "",
            ],
            [
                   "isGimbalMotorOverloaded",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isGimbalMotorOverloaded_inline",
                   "`true` if the gimbal motor is overloaded. Unable to test normally.  @return A boolean value to check if the gimbal motor is overloaed.",
            ],
            [
                   "`true` if the gimbal motor is overloaded. Unable to test normally.  @return A boolean value to check if the gimbal motor is overloaed.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_isGimbalMotorOverloaded_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState_callbackInterface.html",
                   "",
                   "Callback for updating the gimbal's balance detection state.",
            ],
            [
                   "Callback for updating the gimbal's balance detection state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState_callbackInterface.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_onUpdate_inline",
                   "Update the gimbal's balance detection state.  @param state The gimbal balance detection state.",
            ],
            [
                   "Update the gimbal's balance detection state.  @param state The gimbal balance detection state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalBalanceDetectionState_callbackInterface.html",
                   "#DJIGimbal_DJIGimbalBalanceDetectionState_onUpdate_inline",
                   "",
            ],
            [
                   "DirectionState",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "",
                   "This class provides gimbal direction adjustment result and adjustment suggestion on axis.",
            ],
            [
                   "This class provides gimbal direction adjustment result and adjustment suggestion on axis.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "",
                   "",
            ],
            [
                   "getAdjustmentResultLR",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultLR_inline",
                   "Gimbal direction adjustment result for direction left and right.  @return An enum value of `DirectionAdjustmentResult`.",
            ],
            [
                   "Gimbal direction adjustment result for direction left and right.  @return An enum value of `DirectionAdjustmentResult`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultLR_inline",
                   "",
            ],
            [
                   "getAdjustmentSuggestionLR",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionLR_inline",
                   "Suggestion for adjusting the gimbal to the left or to the right.  @return An enum value of `SuggestedDirectionAdjustment`.",
            ],
            [
                   "Suggestion for adjusting the gimbal to the left or to the right.  @return An enum value of `SuggestedDirectionAdjustment`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionLR_inline",
                   "",
            ],
            [
                   "getAdjustmentResultUD",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultUD_inline",
                   "Gimbal direction adjustment result for direction upwards or downwards.  @return An enum value of `DirectionAdjustmentResult`.",
            ],
            [
                   "Gimbal direction adjustment result for direction upwards or downwards.  @return An enum value of `DirectionAdjustmentResult`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultUD_inline",
                   "",
            ],
            [
                   "getAdjustmentSuggestionUD",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionUD_inline",
                   "Suggestion for adjusting the gimbal upwards or downwards.  @return Get the enum value of `SuggestedDirectionAdjustment`.",
            ],
            [
                   "Suggestion for adjusting the gimbal upwards or downwards.  @return Get the enum value of `SuggestedDirectionAdjustment`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionUD_inline",
                   "",
            ],
            [
                   "getAdjustmentResultFB",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultFB_inline",
                   "Gimbal direction adjustment result for direction forwards or backwards.  @return Get the enum value of `DirectionAdjustmentResult`.",
            ],
            [
                   "Gimbal direction adjustment result for direction forwards or backwards.  @return Get the enum value of `DirectionAdjustmentResult`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentResultFB_inline",
                   "",
            ],
            [
                   "getAdjustmentSuggestionFB",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionFB_inline",
                   "Suggestion for adjusting the camera forwards or backwards.  @return Get the enum value of `SuggestedDirectionAdjustment`.",
            ],
            [
                   "Suggestion for adjusting the camera forwards or backwards.  @return Get the enum value of `SuggestedDirectionAdjustment`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalDirectionState.html",
                   "#DJIGimbal_DJIGimbalDirectionState_adjustmentSuggestionFB_inline",
                   "",
            ],
            [
                   "GimbalControlParametersAutoTuningState",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "",
                   "This class provides gimbal's control parameters auto-tuning state.",
            ],
            [
                   "This class provides gimbal's control parameters auto-tuning state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "",
                   "",
            ],
            [
                   "getStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_controlParametersAutoTuningStatus_inline",
                   "The control parameters auto tuning status.  @return Return an enum value of `ControlParametersAutoTuningStatus`.",
            ],
            [
                   "The control parameters auto tuning status.  @return Return an enum value of `ControlParametersAutoTuningStatus`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_controlParametersAutoTuningStatus_inline",
                   "",
            ],
            [
                   "getProcess",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_progress_inline",
                   "Gimbal's control parameters auto-tuning progress in percentage.  @return An int value the auto-tuning progress.",
            ],
            [
                   "Gimbal's control parameters auto-tuning progress in percentage.  @return An int value the auto-tuning progress.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_progress_inline",
                   "",
            ],
            [
                   "isLoadInstalled",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isLoadInstalled_inline",
                   "Checks if the load has been installed.  @return A boolean value to check if the load has been installed.",
            ],
            [
                   "Checks if the load has been installed.  @return A boolean value to check if the load has been installed.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isLoadInstalled_inline",
                   "",
            ],
            [
                   "isBaseAttitudeNormal",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isBaseAttitudeNormal_inline",
                   "Checks if the attitude of gimbal base is normal. Returns `false` if the base is not placed horizontally.  @return A boolean value to check if the attitude of gimbal base is normal.",
            ],
            [
                   "Checks if the attitude of gimbal base is normal. Returns `false` if the base is not placed horizontally.  @return A boolean value to check if the attitude of gimbal base is normal.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isBaseAttitudeNormal_inline",
                   "",
            ],
            [
                   "isGyroDriftNormal",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isGyroDriftNormal_inline",
                   "Checks if gyro drift is normal. Returns `false` if the gyro drift is too large.  @return A boolean value to check if the gyro drift is too large.",
            ],
            [
                   "Checks if gyro drift is normal. Returns `false` if the gyro drift is too large.  @return A boolean value to check if the gyro drift is too large.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isGyroDriftNormal_inline",
                   "",
            ],
            [
                   "isJointAngleDeviationNormal",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isJointAngleDeviationNormal_inline",
                   "Checks if joint angle deviation is normal. Returns `false` if the joint angle deviation is high.  @return A boolean value to check if joint angle deviation is normal.",
            ],
            [
                   "Checks if joint angle deviation is normal. Returns `false` if the joint angle deviation is high.  @return A boolean value to check if joint angle deviation is normal.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isJointAngleDeviationNormal_inline",
                   "",
            ],
            [
                   "getRotationalInertiaOnRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnRoll_inline",
                   "Rotational inertia on roll axis.  @return Return an enum value of `RotationalInertiaState`.",
            ],
            [
                   "Rotational inertia on roll axis.  @return Return an enum value of `RotationalInertiaState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnRoll_inline",
                   "",
            ],
            [
                   "getRotationalInertiaOnPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnPitch_inline",
                   "Rotational inertia on pitch axis.  @return Return an enum value of `RotationalInertiaState`.",
            ],
            [
                   "Rotational inertia on pitch axis.  @return Return an enum value of `RotationalInertiaState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnPitch_inline",
                   "",
            ],
            [
                   "getRotationalInertiaOnYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnYaw_inline",
                   "Rotational inertia on yaw axis.  @return Return an enum value of `RotationalInertiaState`.",
            ],
            [
                   "Rotational inertia on yaw axis.  @return Return an enum value of `RotationalInertiaState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_rotationalInertiaOnYaw_inline",
                   "",
            ],
            [
                   "getStiffnessOnRoll",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnRoll_inline",
                   "Stiffness on roll axis.  @return Return an enum value of `AxialStiffnessState`.",
            ],
            [
                   "Stiffness on roll axis.  @return Return an enum value of `AxialStiffnessState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnRoll_inline",
                   "",
            ],
            [
                   "getStiffnessOnPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnPitch_inline",
                   "Stiffness on pitch axis.  @return Return an enum value of `AxialStiffnessState`.",
            ],
            [
                   "Stiffness on pitch axis.  @return Return an enum value of `AxialStiffnessState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnPitch_inline",
                   "",
            ],
            [
                   "getStiffnessOnYaw",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnYaw_inline",
                   "Stiffness on yaw axis.  @return Return an enum value of `AxialStiffnessState`.",
            ],
            [
                   "Stiffness on yaw axis.  @return Return an enum value of `AxialStiffnessState`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_stiffnessOnYaw_inline",
                   "",
            ],
            [
                   "isRollLocked",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isRollLocked_inline",
                   "`true` if gimbal's roll axis is locked.  @return A boolean value to check roll locked.",
            ],
            [
                   "`true` if gimbal's roll axis is locked.  @return A boolean value to check roll locked.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isRollLocked_inline",
                   "",
            ],
            [
                   "isPitchLocked",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isPitchLocked_inline",
                   "`true` if gimbal's pitch axis is locked.  @return A boolean value to check pitch locked.",
            ],
            [
                   "`true` if gimbal's pitch axis is locked.  @return A boolean value to check pitch locked.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isPitchLocked_inline",
                   "",
            ],
            [
                   "isYawLocked",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isYawLocked_inline",
                   "`true` if gimbal's yaw axis is locked.  @return A boolean value to check yaw locked.",
            ],
            [
                   "`true` if gimbal's yaw axis is locked.  @return A boolean value to check yaw locked.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isYawLocked_inline",
                   "",
            ],
            [
                   "isProtectingGimbalMotorLockedRotor",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isProtectingGimbalMotorLockedRotor_inline",
                   "`true` if gimbal motor is locked-rotor and is being protected.  @return A boolean value to check gimbal motor status.",
            ],
            [
                   "`true` if gimbal motor is locked-rotor and is being protected.  @return A boolean value to check gimbal motor status.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isProtectingGimbalMotorLockedRotor_inline",
                   "",
            ],
            [
                   "isAircraftMotorOn",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isAircraftMotorOn_inline",
                   "`true` if the aircraft's motor is on.  @return A boolean value to check if aircraft motor is on.",
            ],
            [
                   "`true` if the aircraft's motor is on.  @return A boolean value to check if aircraft motor is on.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_isAircraftMotorOn_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState_CallbackInterface.html",
                   "",
                   "Callback for updating the gimbal's control parameters auto tuning state.",
            ],
            [
                   "Callback for updating the gimbal's control parameters auto tuning state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState_CallbackInterface.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_onUpdate_inline",
                   "Update the gimbal's control parameters auto tuning state.  @param state The gimbal control parameters auto tuning state.",
            ],
            [
                   "Update the gimbal's control parameters auto tuning state.  @param state The gimbal control parameters auto tuning state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalControlParametersAutoTuningState_CallbackInterface.html",
                   "#DJIGimbal_DJIGimbalControlParametersAutoTuningState_onUpdate_inline",
                   "",
            ],
            [
                   "GimbalCoaxialityDetectionState",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "",
                   "This class provides current coaxiality detection information of the gimbal.",
            ],
            [
                   "This class provides current coaxiality detection information of the gimbal.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "",
                   "",
            ],
            [
                   "getStatus",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_coaxialityDetectionStatus_inline",
                   "Get the coaxiality detection status.  @return An enum value of `CoaxialityDetectionProgressStatus`.",
            ],
            [
                   "Get the coaxiality detection status.  @return An enum value of `CoaxialityDetectionProgressStatus`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_coaxialityDetectionStatus_inline",
                   "",
            ],
            [
                   "getResultOnPitch",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_resultOnPitch_inline",
                   "Get the Gimbal coaxiality detection result on pitch.  @return An enum value of `DetectionResultOnAxis`.",
            ],
            [
                   "Get the Gimbal coaxiality detection result on pitch.  @return An enum value of `DetectionResultOnAxis`.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_resultOnPitch_inline",
                   "",
            ],
            [
                   "getProcess",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_progress_inline",
                   "Get the Gimbal's coaxiality detection progress percentage.  @return An int value of the process..",
            ],
            [
                   "Get the Gimbal's coaxiality detection progress percentage.  @return An int value of the process..",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_progress_inline",
                   "",
            ],
            [
                   "isAircraftStabilitySatisfied",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isAircraftStabilitySatisfied_inline",
                   "`false` if aircraft stability does not meet requirements.  @return A boolean value to check aircraft's stability.",
            ],
            [
                   "`false` if aircraft stability does not meet requirements.  @return A boolean value to check aircraft's stability.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isAircraftStabilitySatisfied_inline",
                   "",
            ],
            [
                   "isAircraftMotorOn",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isAircraftMotorOn_inline",
                   "Turn off aircraft motor and run coaxiality detection again if this is `true`.  @return A boolean value to check aircraft motor on status.",
            ],
            [
                   "Turn off aircraft motor and run coaxiality detection again if this is `true`.  @return A boolean value to check aircraft motor on status.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isAircraftMotorOn_inline",
                   "",
            ],
            [
                   "isGimbalMotorOverloaded",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isGimbalMotorOverloaded_inline",
                   "`true` if the gimbal motor is overloaded. Unable to test normally.  @return A boolean value to check gimbal motor overloaded.",
            ],
            [
                   "`true` if the gimbal motor is overloaded. Unable to test normally.  @return A boolean value to check gimbal motor overloaded.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_isGimbalMotorOverloaded_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState_CallbackInterface.html",
                   "",
                   "Callback for updating the gimbal's coaxiality detection state.",
            ],
            [
                   "Callback for updating the gimbal's coaxiality detection state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState_CallbackInterface.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_onUpdate_inline",
                   "Updates the gimbal's coaxiality detection state.  @param state The gimbal coaxiality detection state.",
            ],
            [
                   "Updates the gimbal's coaxiality detection state.  @param state The gimbal coaxiality detection state.",
                   1,
                   "/Components/Gimbal/DJIGimbal_DJIGimbalCoaxialityDetectionState_CallbackInterface.html",
                   "#DJIGimbal_DJIGimbalCoaxialityDetectionState_onUpdate_inline",
                   "",
            ],
            [
                   "getAircraftUpgradeComponent",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_aircraft_inline",
                   "The upgrade component is aircraft. Upgrade this component when gimbal, battery, flight  controller and other internal modules' firmware versions are inconsistent. It is only  supported by Mavic Air, Mavic 2 series.  @return An object of `UpgradeComponent`.",
            ],
            [
                   "The upgrade component is aircraft. Upgrade this component when gimbal, battery, flight  controller and other internal modules' firmware versions are inconsistent. It is only  supported by Mavic Air, Mavic 2 series.  @return An object of `UpgradeComponent`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_aircraft_inline",
                   "",
            ],
            [
                   "getRemoteControllerUpgradeComponent",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_remoteController_inline",
                   "The upgrade component is remote controller. Upgrade this component when its internal  modules' firmware versions are inconsistent. It is only supported by Mavic 2 series.  @return An object of `UpgradeComponent`.",
            ],
            [
                   "The upgrade component is remote controller. Upgrade this component when its internal  modules' firmware versions are inconsistent. It is only supported by Mavic 2 series.  @return An object of `UpgradeComponent`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_remoteController_inline",
                   "",
            ],
            [
                   "UpgradeComponent",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "",
                   "This class is used to control components' upgrade. It also provides methods to receive  firmware consistency upgrade state and the latest firmware version information. It is  only supported by Mavic Air, Mavic 2 series, Matrice 300 RTK.",
            ],
            [
                   "This class is used to control components' upgrade. It also provides methods to receive  firmware consistency upgrade state and the latest firmware version information. It is  only supported by Mavic Air, Mavic 2 series, Matrice 300 RTK.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "",
                   "",
            ],
            [
                   "getComponentType",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_componentType_inline",
                   "Component to upgrade.  @return An enum value of `UpgradeComponentType`.",
            ],
            [
                   "Component to upgrade.  @return An enum value of `UpgradeComponentType`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_componentType_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_componentIndex_inline",
                   "Returns the upgrade component index. Index is zero based.  Please refer to `getIndex` to get the component index. For instance, if Matrice 300 RTK can have three gimbal mounted cameras, the three camera components are with indices 0, 1 and 4.  @return An int value of index.",
            ],
            [
                   "Returns the upgrade component index. Index is zero based.  Please refer to `getIndex` to get the component index. For instance, if Matrice 300 RTK can have three gimbal mounted cameras, the three camera components are with indices 0, 1 and 4.  @return An int value of index.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_componentIndex_inline",
                   "",
            ],
            [
                   "getUpgradeState",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_upgradeState_inline",
                   "Current firmware upgrade state.  @return An enum value of `UpgradeFirmwareState`.",
            ],
            [
                   "Current firmware upgrade state.  @return An enum value of `UpgradeFirmwareState`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_upgradeState_inline",
                   "",
            ],
            [
                   "getLatestFirmwareInformation",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_latestFirmwareInformation_inline",
                   "The latest firmware information.  @return An enum value of `FirmwareInformation`.",
            ],
            [
                   "The latest firmware information.  @return An enum value of `FirmwareInformation`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_latestFirmwareInformation_inline",
                   "",
            ],
            [
                   "addUpgradeFirmwareListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_addUpgradeFirmwareListenerWithQueue_inline",
                   "Adds a listener to receive the `UpgradeFirmwareListener`..  @param listener Listener to receive the `UpgradeFirmwareListener`..  It is used to distinguish different listener and the listener will be retained.",
            ],
            [
                   "Adds a listener to receive the `UpgradeFirmwareListener`..  @param listener Listener to receive the `UpgradeFirmwareListener`..  It is used to distinguish different listener and the listener will be retained.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_addUpgradeFirmwareListenerWithQueue_inline",
                   "",
            ],
            [
                   "removeUpgradeFirmwareListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_removeUpgradeFirmwareListener_inline",
                   "Removes a listener that is added by passing to `addUpgradeFirmwareListener`.  @param listener The listener to remove.",
            ],
            [
                   "Removes a listener that is added by passing to `addUpgradeFirmwareListener`.  @param listener The listener to remove.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_removeUpgradeFirmwareListener_inline",
                   "",
            ],
            [
                   "removeAllUpgradeFirmwareListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_removeAllUpgradeFirmwareListener_inline",
                   "Remove all the listeners are added by passing to `addUpgradeFirmwareListener`.",
            ],
            [
                   "Remove all the listeners are added by passing to `addUpgradeFirmwareListener`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_removeAllUpgradeFirmwareListener_inline",
                   "",
            ],
            [
                   "canCancelConsistencyUpgrade",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_canCancelConsistencyUpgrade_inline",
                   "Check if the consistency upgrade can be canceled. If false, please check the consistency of the firmware to ensure flight safety.  It is only supported by Mavic Air, Mavic 2 series.  @return A boolean value.",
            ],
            [
                   "Check if the consistency upgrade can be canceled. If false, please check the consistency of the firmware to ensure flight safety.  It is only supported by Mavic Air, Mavic 2 series.  @return A boolean value.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_canCancelConsistencyUpgrade_inline",
                   "",
            ],
            [
                   "startFirmwareConsistencyUpgrade",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_startFirmwareConsistencyUpgrade_inline",
                   "Starts firmware consistency upgrade. If the firmware version of some modules in the device is not compatible with the firmware version of other modules,  the firmware will send a request for consistent upgrade. After you start firmware consistency upgrade, You should Invoke `onFirmwareUpgradeProgressUpdated` to receive upgrade progress  information. Before invoking this method, please make sure that the motors are turned off and `getWiFiLink` is not using. It  is only supported by Mavic Air, Mavic 2 series.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts firmware consistency upgrade. If the firmware version of some modules in the device is not compatible with the firmware version of other modules,  the firmware will send a request for consistent upgrade. After you start firmware consistency upgrade, You should Invoke `onFirmwareUpgradeProgressUpdated` to receive upgrade progress  information. Before invoking this method, please make sure that the motors are turned off and `getWiFiLink` is not using. It  is only supported by Mavic Air, Mavic 2 series.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_startFirmwareConsistencyUpgrade_inline",
                   "",
            ],
            [
                   "stopFirmwareConsistencyUpgrade",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_stopFirmwareConsistencyUpgrade_inline",
                   "Cancels firmware consistency upgrade. `onConsistencyUpgradeRequestReceived` will stop to notify. Before  invoking this method, please make sure that the motors are turned off and `getWiFiLink` is not using. It is only supported  by Mavic Air, Mavic 2 series.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Cancels firmware consistency upgrade. `onConsistencyUpgradeRequestReceived` will stop to notify. Before  invoking this method, please make sure that the motors are turned off and `getWiFiLink` is not using. It is only supported  by Mavic Air, Mavic 2 series.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_stopFirmwareConsistencyUpgrade_inline",
                   "",
            ],
            [
                   "UpgradeFirmwareListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "",
                   "This listener provides methods to receive the upgrade information, the upgrade firmware state and the upgrade progress.",
            ],
            [
                   "This listener provides methods to receive the upgrade information, the upgrade firmware state and the upgrade progress.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpgradeFirmwareStateUpdated",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateUpgradeFirmwareState_inline",
                   "Called when the upgrade firmware state has been changed.  @param component The component of which the upgrade firmware state has been changed. @param state The upgrade firmware state.",
            ],
            [
                   "Called when the upgrade firmware state has been changed.  @param component The component of which the upgrade firmware state has been changed. @param state The upgrade firmware state.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateUpgradeFirmwareState_inline",
                   "",
            ],
            [
                   "onFirmwareUpgradeProgressUpdated",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateFirmwareUpgradeProgress_inline",
                   "Called when the upgrade is in progress.  @param component The component of which the upgrade progress is updating. @param progress The upgrade progress information.",
            ],
            [
                   "Called when the upgrade is in progress.  @param component The component of which the upgrade progress is updating. @param progress The upgrade progress information.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateFirmwareUpgradeProgress_inline",
                   "",
            ],
            [
                   "onConsistencyUpgradeRequestReceived",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didReceiveConsistencyUpgradeRequest_inline",
                   "Raised when the firmware version is inconsistent among modules in component.   See `UpgradeComponent`. Invoke `startFirmwareConsistencyUpgrade`  to start consistency upgrade.  The update frequency is 1Hz.  Stop to notify in  following situation:  - Firmware version among modules in component is  consistent.  - Firmware consistency upgrade stops.  - DJIUpgradeComponent_cancelConsistencyUpgrade  is invoked. Reboot the device to receive this notification again.",
            ],
            [
                   "Raised when the firmware version is inconsistent among modules in component.   See `UpgradeComponent`. Invoke `startFirmwareConsistencyUpgrade`  to start consistency upgrade.  The update frequency is 1Hz.  Stop to notify in  following situation:  - Firmware version among modules in component is  consistent.  - Firmware consistency upgrade stops.  - DJIUpgradeComponent_cancelConsistencyUpgrade  is invoked. Reboot the device to receive this notification again.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didReceiveConsistencyUpgradeRequest_inline",
                   "",
            ],
            [
                   "onLatestFirmwareInformationUpdated",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateLatestFirmareInformation_inline",
                   "Updates the latest firmware version information when the user is logged in. Please use DJI GO/DJI Pilot to upgrade to the latest firmware.  @param component The component of which the latest firmware version information have been updated. @param firmwareInformation The latest firmware information.",
            ],
            [
                   "Updates the latest firmware version information when the user is logged in. Please use DJI GO/DJI Pilot to upgrade to the latest firmware.  @param component The component of which the latest firmware version information have been updated. @param firmwareInformation The latest firmware information.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_UpgradeFirmwareListenerInterface.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_didUpdateLatestFirmareInformation_inline",
                   "",
            ],
            [
                   "getDetectedComponentsToUpgrade",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_getDetectedComponentsToUpgrade_inline",
                   "Get the list of detected components that can be upgraded. The list will change when a component is added or removed.  Upgrade a component in the list when its internal modules' firmware versions are inconsistent.  It is only supported by Matrice 300 RTK.  @return A list of `UpgradeComponent`.",
            ],
            [
                   "Get the list of detected components that can be upgraded. The list will change when a component is added or removed.  Upgrade a component in the list when its internal modules' firmware versions are inconsistent.  It is only supported by Matrice 300 RTK.  @return A list of `UpgradeComponent`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_getDetectedComponentsToUpgrade_inline",
                   "",
            ],
            [
                   "addUpgradeComponentChangeListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_addUpgradeComponentChangeListener_inline",
                   "Adds a listener to receive the `UpgradeComponentChangeListener`.  It is only supported by Matrice 300 RTK.  @param listener An object of `UpgradeComponentChangeListener` to be added in the internal listener map.",
            ],
            [
                   "Adds a listener to receive the `UpgradeComponentChangeListener`.  It is only supported by Matrice 300 RTK.  @param listener An object of `UpgradeComponentChangeListener` to be added in the internal listener map.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_addUpgradeComponentChangeListener_inline",
                   "",
            ],
            [
                   "removeUpgradeComponentChangeListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_removeUpgradeComponentChangeListener_inline",
                   "Removes a listener that is added by passing to `addUpgradeComponentChangeListener`. It is only supported by Matrice 300 RTK.  @param listener The listener to be removed in the internal listener map.",
            ],
            [
                   "Removes a listener that is added by passing to `addUpgradeComponentChangeListener`. It is only supported by Matrice 300 RTK.  @param listener The listener to be removed in the internal listener map.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_removeUpgradeComponentChangeListener_inline",
                   "",
            ],
            [
                   "removeAllUpgradeComponentChangeListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_removeAllUpgradeComponentChangeListener_inline",
                   "Remove all the listeners are added by passing to `addUpgradeComponentChangeListener`. It is only supported by Matrice 300 RTK.  @param listener The listener to be removed in the internal listener map.",
            ],
            [
                   "Remove all the listeners are added by passing to `addUpgradeComponentChangeListener`. It is only supported by Matrice 300 RTK.  @param listener The listener to be removed in the internal listener map.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager.html",
                   "#DJIUpgradeManager_removeAllUpgradeComponentChangeListener_inline",
                   "",
            ],
            [
                   "UpgradeComponentChangeListener",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_UpgradeComponentChangeListener.html",
                   "",
                   "This listener provides method to receive the change of detected component which can be upgraded.",
            ],
            [
                   "This listener provides method to receive the change of detected component which can be upgraded.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_UpgradeComponentChangeListener.html",
                   "",
                   "",
            ],
            [
                   "onUpgradeComponentChanged",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_UpgradeComponentChangeListener.html",
                   "#DJIUpgradeManager_onUpgradeComponentChanged_inline",
                   "Called when a dynamic upgrade component is added, or is removed.  @param type The type of the upgrade component. @param component The dynamic upgrade component. @param isConnected The connecting state of the component.",
            ],
            [
                   "Called when a dynamic upgrade component is added, or is removed.  @param type The type of the upgrade component. @param component The dynamic upgrade component. @param isConnected The connecting state of the component.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_UpgradeComponentChangeListener.html",
                   "#DJIUpgradeManager_onUpgradeComponentChanged_inline",
                   "",
            ],
            [
                   "FirmwareUpgradeProgress",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "",
                   "Firmware upgrade progress.",
            ],
            [
                   "Firmware upgrade progress.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress_progress_inline",
                   "The progress of upgrading firmware.  @return A float value.",
            ],
            [
                   "The progress of upgrading firmware.  @return A float value.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress_progress_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress_state_inline",
                   "The state of upgrading firmware.  @return An enum value of `UpgradingProgressState`.",
            ],
            [
                   "The state of upgrading firmware.  @return An enum value of `UpgradingProgressState`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareUpgradeProgress_state_inline",
                   "",
            ],
            [
                   "FirmwareInformation",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "",
                   "Firmware information.",
            ],
            [
                   "Firmware information.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "",
                   "",
            ],
            [
                   "getVersion",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_version_inline",
                   "The version of the firmware.  @return The string value of firmware version.",
            ],
            [
                   "The version of the firmware.  @return The string value of firmware version.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_version_inline",
                   "",
            ],
            [
                   "getReleaseNote",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_releaseNote_inline",
                   "Firmware release notes.  @return The string value of firmware release notes.",
            ],
            [
                   "Firmware release notes.  @return The string value of firmware release notes.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_releaseNote_inline",
                   "",
            ],
            [
                   "getReleaseDate",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_releaseDate_inline",
                   "Firmware release date.  @return The string value of firmware release date.",
            ],
            [
                   "Firmware release date.  @return The string value of firmware release date.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_releaseDate_inline",
                   "",
            ],
            [
                   "getFileSize",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_fileSize_inline",
                   "Firmware file size.  @return A long value of firmware file size.",
            ],
            [
                   "Firmware file size.  @return A long value of firmware file size.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIFirmwareInformation_fileSize_inline",
                   "",
            ],
            [
                   "UpgradeComponentType",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_inline",
                   "Upgrade component.",
            ],
            [
                   "Upgrade component.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_RemoteController_inline",
                   "The upgrade component is remote controller.",
            ],
            [
                   "The upgrade component is remote controller.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_RemoteController_inline",
                   "",
            ],
            [
                   "AIRCRAFT",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Aircraft_inline",
                   "The upgrade component is aircraft.",
            ],
            [
                   "The upgrade component is aircraft.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Aircraft_inline",
                   "",
            ],
            [
                   "CAMERA",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Camera_inline",
                   "The upgrade component is camera.",
            ],
            [
                   "The upgrade component is camera.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Camera_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Unknown_inline",
                   "The upgrade component is unknown.",
            ],
            [
                   "The upgrade component is unknown.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeComponentType_Unknown_inline",
                   "",
            ],
            [
                   "UpgradeFirmwareState",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_inline",
                   "Upgrade firmware state.",
            ],
            [
                   "Upgrade firmware state.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Initializating_inline",
                   "Initializating.",
            ],
            [
                   "Initializating.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Initializating_inline",
                   "",
            ],
            [
                   "CHECKING",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Checking_inline",
                   "Checking firmware information.",
            ],
            [
                   "Checking firmware information.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Checking_inline",
                   "",
            ],
            [
                   "UP_TO_DATE",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_UpToDate_inline",
                   "Firmware version is up to date.",
            ],
            [
                   "Firmware version is up to date.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_UpToDate_inline",
                   "",
            ],
            [
                   "UPGRADE_STRONGLY_RECOMMENDED",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_UpgradeStronglyRecommended_inline",
                   "To ensure flight safety, upgrade device is strongly recommended. Check DJI GO for  available firmware updates. Find more details in `FirmwareInformation`.",
            ],
            [
                   "To ensure flight safety, upgrade device is strongly recommended. Check DJI GO for  available firmware updates. Find more details in `FirmwareInformation`.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_UpgradeStronglyRecommended_inline",
                   "",
            ],
            [
                   "OPTIONAL_UPGRADE_AVAILABLE",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_OptionalUpgradeAvailable_inline",
                   "Optional upgrade is available. Check DJI GO for any available firmware updates.",
            ],
            [
                   "Optional upgrade is available. Check DJI GO for any available firmware updates.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_OptionalUpgradeAvailable_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradeFirmwareState_Unknown_inline",
                   "",
            ],
            [
                   "UpgradingProgressState",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_inline",
                   "Device's firmware upgrading progress state.",
            ],
            [
                   "Device's firmware upgrading progress state.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_inline",
                   "",
            ],
            [
                   "UPGRADING",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_Upgrading_inline",
                   "Upgrading.",
            ],
            [
                   "Upgrading.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_Upgrading_inline",
                   "",
            ],
            [
                   "UPGRADE_FAILED",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_UpgradeFailed_inline",
                   "Upgrade failed.",
            ],
            [
                   "Upgrade failed.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_UpgradeFailed_inline",
                   "",
            ],
            [
                   "UPGRADE_SUCCESSFULLY",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_UpgradeSuccessfully_inline",
                   "Upgrade Successfully.",
            ],
            [
                   "Upgrade Successfully.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_UpgradeSuccessfully_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Upgrade/DJIUpgradeManager_DJIUpgradeComponent.html",
                   "#DJIUpgradeManager_DJIUpgradeComponent_DJIUpgradingProgressState_Unknown_inline",
                   "",
            ],
            [
                   "getFlightDataUploadInterval",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_uploadTimeInterval_inline",
                   "Current interval for uploading real-time flight data.  @return An int value of the interval.",
            ],
            [
                   "Current interval for uploading real-time flight data.  @return An int value of the interval.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_uploadTimeInterval_inline",
                   "",
            ],
            [
                   "getUploadState",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_uploadState_inline",
                   "Gets current upload state.  @return Upload state.",
            ],
            [
                   "Gets current upload state.  @return Upload state.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_uploadState_inline",
                   "",
            ],
            [
                   "isUserActivated",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_isUserActivated_inline",
                   "Determines if the user has been activated. It is a cached data and it will be refreshed  when `updateActivationState` is called.  @return `true` if `updateActivationState` is invoked at least once. `false` if `updateActivationState` is never invoked.",
            ],
            [
                   "Determines if the user has been activated. It is a cached data and it will be refreshed  when `updateActivationState` is called.  @return `true` if `updateActivationState` is invoked at least once. `false` if `updateActivationState` is never invoked.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_isUserActivated_inline",
                   "",
            ],
            [
                   "setFlightDataUploadInterval",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_setFlightDataUploadInterval_inline",
                   "Sets the interval for uploading real-time flight data. By default, the interval is 5 seconds.  @param interval Interval in seconds. The value should be in the range [1, 10].  @return Error if the input is invalid.",
            ],
            [
                   "Sets the interval for uploading real-time flight data. By default, the interval is 5 seconds.  @param interval Interval in seconds. The value should be in the range [1, 10].  @return Error if the input is invalid.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_setFlightDataUploadInterval_inline",
                   "",
            ],
            [
                   "setUploadFlightDataEnabled",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_setUploadFlightDataEnabled_inline",
                   "Set `true` to enable SDK to upload real-time flight data of the connected aircraft to DJI  FlightHub server. When it is enabled, SDK will start uploading flight data automatically when  the aircraft is flying. FlightHub user can access the uploaded flight data on the FlightHub  online system. Stop uploading data by setting `false` as parameter. Use `getUploadState`  to check current uploading state.  @param enabled Interval in seconds. The value should be in the range [1, 10].",
            ],
            [
                   "Set `true` to enable SDK to upload real-time flight data of the connected aircraft to DJI  FlightHub server. When it is enabled, SDK will start uploading flight data automatically when  the aircraft is flying. FlightHub user can access the uploaded flight data on the FlightHub  online system. Stop uploading data by setting `false` as parameter. Use `getUploadState`  to check current uploading state.  @param enabled Interval in seconds. The value should be in the range [1, 10].",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_setUploadFlightDataEnabled_inline",
                   "",
            ],
            [
                   "updateActivationState",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_updateActivationState_inline",
                   "Updates the logged-in user's activation state for DJI FlightHub. This method is only valid when the user  is logged in. When the state is updated, the state will be cached to `isUserActivated`. Please invoke the `authorizeAccessToDJIDeviceHardwareInfo` to authorize DJI server to access DJI device's hardware information.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Updates the logged-in user's activation state for DJI FlightHub. This method is only valid when the user  is logged in. When the state is updated, the state will be cached to `isUserActivated`. Please invoke the `authorizeAccessToDJIDeviceHardwareInfo` to authorize DJI server to access DJI device's hardware information.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_updateActivationState_inline",
                   "",
            ],
            [
                   "getTeamsInformation",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getTeamsInformation_inline",
                   "Gets the teams' information that is visible for the user.  @param callback The execution callback with the returned a list of Team objects.",
            ],
            [
                   "Gets the teams' information that is visible for the user.  @param callback The execution callback with the returned a list of Team objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getTeamsInformation_inline",
                   "",
            ],
            [
                   "getHistoricalFlightPath",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getHistoricalFlightPath_inline",
                   "Gets the flight path nodes of a historical flight path with the specific path ID. This information is  only visible for the administrator of the group and the captain of the team.  @param orderId Corresponding order id that the user wants to check with the flight path. @param callback The execution callback with the returned a list of FlightPathNode objects.",
            ],
            [
                   "Gets the flight path nodes of a historical flight path with the specific path ID. This information is  only visible for the administrator of the group and the captain of the team.  @param orderId Corresponding order id that the user wants to check with the flight path. @param callback The execution callback with the returned a list of FlightPathNode objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getHistoricalFlightPath_inline",
                   "",
            ],
            [
                   "getFlightStatistics",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getFlightStatistics_inline",
                   "Gets flight statistics over a period of time. Specify the account to get the statistics related to one  user. Otherwise, statistics for the whole team will be fetched. Only `ADMINISTRATOR`  and `CAPTAIN` can access the flight statistics.  @param startTime Chosen start time of milliseconds. @param endTime Chosen end time of milliseconds. @param account The account that the user wants to check. Set to be null if whole team flight statistics is expected. @param teamId Team id that the user wants to check. @param callback The execution callback with the returned HistoricalFlight objects.",
            ],
            [
                   "Gets flight statistics over a period of time. Specify the account to get the statistics related to one  user. Otherwise, statistics for the whole team will be fetched. Only `ADMINISTRATOR`  and `CAPTAIN` can access the flight statistics.  @param startTime Chosen start time of milliseconds. @param endTime Chosen end time of milliseconds. @param account The account that the user wants to check. Set to be null if whole team flight statistics is expected. @param teamId Team id that the user wants to check. @param callback The execution callback with the returned HistoricalFlight objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getFlightStatistics_inline",
                   "",
            ],
            [
                   "bindAircraft",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_bindAircraftToTeam_inline",
                   "Bind the connected aircraft to DJI FlightHub system. Specify the team ID that the aircraft will belongs to.  @param teamId Team ID that current aircraft is expected to bind to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Bind the connected aircraft to DJI FlightHub system. Specify the team ID that the aircraft will belongs to.  @param teamId Team ID that current aircraft is expected to bind to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_bindAircraftToTeam_inline",
                   "",
            ],
            [
                   "unbindAircraft",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_unbindAircraft_inline",
                   "Unbinds current aircraft from the certain team. Only `ADMINISTRATOR`  and `CAPTAIN` can do this operation.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Unbinds current aircraft from the certain team. Only `ADMINISTRATOR`  and `CAPTAIN` can do this operation.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_unbindAircraft_inline",
                   "",
            ],
            [
                   "getLiveViewStreamSource",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getLiveViewStreamSourceWithSN_inline",
                   "Gets the live view stream sourcing by the other aircraft to DJI FlightHub. The stream is using RTMP  (Real-Time Messaging Protocol). External libraries are required to decode and render the live view.  Only `ADMINISTRATOR` and `CAPTAIN` can do this operation.  @param sn Serial number of the aircraft sourcing the live view stream. @param callback The execution callback with the returned LiveStream objects.",
            ],
            [
                   "Gets the live view stream sourcing by the other aircraft to DJI FlightHub. The stream is using RTMP  (Real-Time Messaging Protocol). External libraries are required to decode and render the live view.  Only `ADMINISTRATOR` and `CAPTAIN` can do this operation.  @param sn Serial number of the aircraft sourcing the live view stream. @param callback The execution callback with the returned LiveStream objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getLiveViewStreamSourceWithSN_inline",
                   "",
            ],
            [
                   "getLiveViewStreamDestination",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getLiveViewStreamDestination_inline",
                   "Gets RTMP (Real-Time Messaging Protocol) url that the connected aircraft should stream to.  @param callback The execution callback with the returned UpStream objects.",
            ],
            [
                   "Gets RTMP (Real-Time Messaging Protocol) url that the connected aircraft should stream to.  @param callback The execution callback with the returned UpStream objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getLiveViewStreamDestination_inline",
                   "",
            ],
            [
                   "isLiveStreamStable",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_isLiveStreamStable_inline",
                   "Determines whether the live stream is stable from the server perspective.  @param callback The execution callback with the returned boolean result representing if the stream is healthy or not.",
            ],
            [
                   "Determines whether the live stream is stable from the server perspective.  @param callback The execution callback with the returned boolean result representing if the stream is healthy or not.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_isLiveStreamStable_inline",
                   "",
            ],
            [
                   "getStreamingDevices",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getStreamingDevices_inline",
                   "Gets the list of devices streaming live video to DJI FlightHubManager.  @param callback The execution callback with the returned a list of OnlineDevice objects.",
            ],
            [
                   "Gets the list of devices streaming live video to DJI FlightHubManager.  @param callback The execution callback with the returned a list of OnlineDevice objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getStreamingDevices_inline",
                   "",
            ],
            [
                   "getOnlineDevices",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getOnlineDevices_inline",
                   "Gets the list of online devices visiable in DJI FlightHub.  @param callback The execution callback with the returned a list of OnlineDevice objects.",
            ],
            [
                   "Gets the list of online devices visiable in DJI FlightHub.  @param callback The execution callback with the returned a list of OnlineDevice objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getOnlineDevices_inline",
                   "",
            ],
            [
                   "getAircraftRealTimeFlightData",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getRealTimeDataWithSNs_inline",
                   "Gets real time flight data of the given aircraft(s).  @param sns Serial numbers of aircraft expected. @param callback The execution callback with the returned a list of `RealTimeFlightData` objects.",
            ],
            [
                   "Gets real time flight data of the given aircraft(s).  @param sns Serial numbers of aircraft expected. @param callback The execution callback with the returned a list of `RealTimeFlightData` objects.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_getRealTimeDataWithSNs_inline",
                   "",
            ],
            [
                   "addUpdatedUploadStateCallback",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_addUpdatedUploadStateCallback_inline",
                   "Add upload state callback.  @param callback The `UpdatedUploadStateCallback` object to receive upload state.",
            ],
            [
                   "Add upload state callback.  @param callback The `UpdatedUploadStateCallback` object to receive upload state.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_addUpdatedUploadStateCallback_inline",
                   "",
            ],
            [
                   "removeUpdatedUploadStateCallback",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_removeUpdatedUploadStateCallback_inline",
                   "Remove upload state callback.  @param callback The `UpdatedUploadStateCallback` object to receive upload state.",
            ],
            [
                   "Remove upload state callback.  @param callback The `UpdatedUploadStateCallback` object to receive upload state.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_removeUpdatedUploadStateCallback_inline",
                   "",
            ],
            [
                   "UploadState",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_inline",
                   "The uploading state of the flight data for DJI FlightHub system.",
            ],
            [
                   "The uploading state of the flight data for DJI FlightHub system.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_inline",
                   "",
            ],
            [
                   "DISABLED",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Disabled_inline",
                   "The uploading process is disabled.",
            ],
            [
                   "The uploading process is disabled.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Disabled_inline",
                   "",
            ],
            [
                   "NETWORK_NOT_REACHABLE",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_NetworkNotReachable_inline",
                   "The uploading process is enabled but it is not started because the network is not reachable.",
            ],
            [
                   "The uploading process is enabled but it is not started because the network is not reachable.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_NetworkNotReachable_inline",
                   "",
            ],
            [
                   "NOT_LOGGED_IN",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_NotLoggedIn_inline",
                   "The uploading process is enabled but it is not started because no account is logged in.",
            ],
            [
                   "The uploading process is enabled but it is not started because no account is logged in.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_NotLoggedIn_inline",
                   "",
            ],
            [
                   "AIRCRAFT_DISCONNECTED",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_AircraftDisconnected_inline",
                   "The uploading process is enabled but it is not started because the aircraft is disconnected.",
            ],
            [
                   "The uploading process is enabled but it is not started because the aircraft is disconnected.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_AircraftDisconnected_inline",
                   "",
            ],
            [
                   "REJECTED_BY_SERVER",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_RejectedByServer_inline",
                   "The uploading process is enabled but the uploading request is rejected by the server.",
            ],
            [
                   "The uploading process is enabled but the uploading request is rejected by the server.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_RejectedByServer_inline",
                   "",
            ],
            [
                   "READY_TO_UPLOAD",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_ReadyToUpload_inline",
                   "The uploading process is enabled and it will start when the aircraft takes off.",
            ],
            [
                   "The uploading process is enabled and it will start when the aircraft takes off.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_ReadyToUpload_inline",
                   "",
            ],
            [
                   "UPLOADING",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Uploading_inline",
                   "SDK is uploading flight data to DJI FlightHub system.",
            ],
            [
                   "SDK is uploading flight data to DJI FlightHub system.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Uploading_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubUploadState_Unknown_inline",
                   "",
            ],
            [
                   "Role",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_inline",
                   "Different roles of members in a FlightHub group. Different roles will have different  permissions to access data in the sytem.",
            ],
            [
                   "Different roles of members in a FlightHub group. Different roles will have different  permissions to access data in the sytem.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_inline",
                   "",
            ],
            [
                   "ADMINISTRATOR",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Administrator_inline",
                   "The administrator is the leader of a group (a group consists of several teams). This role  will appear in the member list of all the teams and this role can access all the data of the group.",
            ],
            [
                   "The administrator is the leader of a group (a group consists of several teams). This role  will appear in the member list of all the teams and this role can access all the data of the group.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Administrator_inline",
                   "",
            ],
            [
                   "CAPTAIN",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Captain_inline",
                   "A captain is the leader of a team. `ADMINISTRATOR` can define a captain for a team in the group but it is not compulsory for a team to have a captain. The captain can access the data of the team.",
            ],
            [
                   "A captain is the leader of a team. `ADMINISTRATOR` can define a captain for a team in the group but it is not compulsory for a team to have a captain. The captain can access the data of the team.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Captain_inline",
                   "",
            ],
            [
                   "PILOT",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Pilot_inline",
                   "A pilot is a member in the team without special permissions.",
            ],
            [
                   "A pilot is a member in the team without special permissions.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Pilot_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager.html",
                   "#DJIFlightHubManager_DJIFlightHubRole_Unknown_inline",
                   "",
            ],
            [
                   "OnlineDevice",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "",
                   "Device information in the DJIFlightHubManager, including serial number and team id.",
            ],
            [
                   "Device information in the DJIFlightHubManager, including serial number and team id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "",
                   "",
            ],
            [
                   "getSn",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubOnlineDevice_sn_inline",
                   "Gets the serial number of current device.  @return Device's serial number.",
            ],
            [
                   "Gets the serial number of current device.  @return Device's serial number.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubOnlineDevice_sn_inline",
                   "",
            ],
            [
                   "getTeamId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubOnlineDevice_teamID_inline",
                   "Gets the team ID that online device belongs to.  @return Team id.",
            ],
            [
                   "Gets the team ID that online device belongs to.  @return Team id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubOnlineDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubOnlineDevice_teamID_inline",
                   "",
            ],
            [
                   "BoundDevice",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "",
                   "The device bound in DJI FlightHub.",
            ],
            [
                   "The device bound in DJI FlightHub.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "",
                   "",
            ],
            [
                   "getSn",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_sn_inline",
                   "Gets the serial number of the device.  @return Serial number of the device.",
            ],
            [
                   "Gets the serial number of the device.  @return Serial number of the device.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_sn_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_name_inline",
                   "Gets device name.  @return Name of the device.",
            ],
            [
                   "Gets device name.  @return Name of the device.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_name_inline",
                   "",
            ],
            [
                   "getModel",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_model_inline",
                   "Gets device model.  @return Model of the device.",
            ],
            [
                   "Gets device model.  @return Model of the device.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubBoundDevice.html",
                   "#DJIFlightHubManager_DJIFlightHubBoundDevice_model_inline",
                   "",
            ],
            [
                   "User",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "",
                   "A user in FlightHub.",
            ],
            [
                   "A user in FlightHub.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "",
                   "",
            ],
            [
                   "getAccount",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_account_inline",
                   "Gets the account of the user.  @return The string of the account.",
            ],
            [
                   "Gets the account of the user.  @return The string of the account.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_account_inline",
                   "",
            ],
            [
                   "getNickname",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_nickName_inline",
                   "Gets the nick name of the user.  @return The string of the nick name.",
            ],
            [
                   "Gets the nick name of the user.  @return The string of the nick name.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_nickName_inline",
                   "",
            ],
            [
                   "getRole",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_role_inline",
                   "Gets the role of the user. Different roles will have different permissions to access the  data in DJI FlightHub.  @return An enum value of `Role`.",
            ],
            [
                   "Gets the role of the user. Different roles will have different permissions to access the  data in DJI FlightHub.  @return An enum value of `Role`.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUser.html",
                   "#DJIFlightHubManager_DJIFlightHubUser_role_inline",
                   "",
            ],
            [
                   "Team",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "",
                   "A team in DJI FlightHub. A group can contain several teams.",
            ],
            [
                   "A team in DJI FlightHub. A group can contain several teams.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "",
                   "",
            ],
            [
                   "getTeamId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_teamID_inline",
                   "Gets the ID of the team. Each team in a group will have a unique ID.  @return An Integer of team id.",
            ],
            [
                   "Gets the ID of the team. Each team in a group will have a unique ID.  @return An Integer of team id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_teamID_inline",
                   "",
            ],
            [
                   "getGroupId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_groupID_inline",
                   "Gets group's ID that current team belongs to.  @return An Integer of group id.",
            ],
            [
                   "Gets group's ID that current team belongs to.  @return An Integer of group id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_groupID_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_name_inline",
                   "Gets the team's name.  @return A String of team name.",
            ],
            [
                   "Gets the team's name.  @return A String of team name.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_name_inline",
                   "",
            ],
            [
                   "getDevices",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_devices_inline",
                   "Get devices of the team.  @return A list of Devices that belongs to current team.",
            ],
            [
                   "Get devices of the team.  @return A list of Devices that belongs to current team.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_devices_inline",
                   "",
            ],
            [
                   "getMembers",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_members_inline",
                   "Gets members of the team.  @return A list of User.",
            ],
            [
                   "Gets members of the team.  @return A list of User.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubTeam.html",
                   "#DJIFlightHubManager_DJIFlightHubTeam_members_inline",
                   "",
            ],
            [
                   "UpStream",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUpStream.html",
                   "",
                   "This class contains RTMP URL of up stream.",
            ],
            [
                   "This class contains RTMP URL of up stream.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUpStream.html",
                   "",
                   "",
            ],
            [
                   "getUpStreamUrl",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUpStream.html",
                   "#DJIFlightHubManager_DJIFlightHubUpStream_rtmpURL_inline",
                   "Gets up stream RTMP URL of live stream.  @return Live up stream URL.",
            ],
            [
                   "Gets up stream RTMP URL of live stream.  @return Live up stream URL.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubUpStream.html",
                   "#DJIFlightHubManager_DJIFlightHubUpStream_rtmpURL_inline",
                   "",
            ],
            [
                   "LiveStream",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "",
                   "This class represents the live stream information of devices in the same team.",
            ],
            [
                   "This class represents the live stream information of devices in the same team.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "",
                   "",
            ],
            [
                   "getRtmpURL",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "#DJIFlightHubManager_DJIFlightHubLiveStream_rtmpURL_inline",
                   "Gets the RTMP(Real-Time Messaging Protocol) URL of the live stream. When the device is broadcasting, user can receive the live stream's video data and audio data through RTMP.  @return A URL string.",
            ],
            [
                   "Gets the RTMP(Real-Time Messaging Protocol) URL of the live stream. When the device is broadcasting, user can receive the live stream's video data and audio data through RTMP.  @return A URL string.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "#DJIFlightHubManager_DJIFlightHubLiveStream_rtmpURL_inline",
                   "",
            ],
            [
                   "isValid",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "#DJIFlightHubManager_DJIFlightHubLiveStream_isValid_inline",
                   "Determines if the live stream is valid. When the team member stops live streaming or the device  is disconnected, the live stream will become invalid.  @return `true` if the live stream is valid.",
            ],
            [
                   "Determines if the live stream is valid. When the team member stops live streaming or the device  is disconnected, the live stream will become invalid.  @return `true` if the live stream is valid.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubLiveStream.html",
                   "#DJIFlightHubManager_DJIFlightHubLiveStream_isValid_inline",
                   "",
            ],
            [
                   "FlightPathNode",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "",
                   "The class provide flight information of a node in flight path.",
            ],
            [
                   "The class provide flight information of a node in flight path.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "",
                   "",
            ],
            [
                   "getDate",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_date_inline",
                   "Gets the flight date.  @return Date of the flight.",
            ],
            [
                   "Gets the flight date.  @return Date of the flight.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_date_inline",
                   "",
            ],
            [
                   "getDeviceModel",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_deviceModel_inline",
                   "Gets flight device's model.  @return Device's model.",
            ],
            [
                   "Gets flight device's model.  @return Device's model.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_deviceModel_inline",
                   "",
            ],
            [
                   "getFlightTime",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_flightTime_inline",
                   "Gets the flight time.  @return Flight time in seconds.",
            ],
            [
                   "Gets the flight time.  @return Flight time in seconds.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_flightTime_inline",
                   "",
            ],
            [
                   "getLocationCoordinate",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_coordinate_inline",
                   "Gets the location coordinate of the flight node.  @return A LocationCoordinate3D object.",
            ],
            [
                   "Gets the location coordinate of the flight node.  @return A LocationCoordinate3D object.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_coordinate_inline",
                   "",
            ],
            [
                   "getSpeed",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_speed_inline",
                   "Gets the flight speed (m/s).  @return Speed in m/s.",
            ],
            [
                   "Gets the flight speed (m/s).  @return Speed in m/s.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_speed_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_yaw_inline",
                   "Gets flight yaw in degree.  @return Flight yaw.",
            ],
            [
                   "Gets flight yaw in degree.  @return Flight yaw.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightPathNode.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightPathNode_yaw_inline",
                   "",
            ],
            [
                   "FlightHistoricalDetail",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "",
                   "This class provides the detail information for one flight. It includes aircraft information,  flight location and statistics data.",
            ],
            [
                   "This class provides the detail information for one flight. It includes aircraft information,  flight location and statistics data.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "",
                   "",
            ],
            [
                   "getOrderId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_orderID_inline",
                   "Gets the order ID of the flight.  @return The order id.",
            ],
            [
                   "Gets the order ID of the flight.  @return The order id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_orderID_inline",
                   "",
            ],
            [
                   "getSn",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_sn_inline",
                   "Gets the aircraft's serial number of the flight.  @return The aircraft's serial number.",
            ],
            [
                   "Gets the aircraft's serial number of the flight.  @return The aircraft's serial number.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_sn_inline",
                   "",
            ],
            [
                   "getDeviceModel",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_deviceModel_inline",
                   "Gets the device model of the flight.  @return The product name.",
            ],
            [
                   "Gets the device model of the flight.  @return The product name.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_deviceModel_inline",
                   "",
            ],
            [
                   "getTeamId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_teamID_inline",
                   "Gets the team ID of the flight.  @return The team id.",
            ],
            [
                   "Gets the team ID of the flight.  @return The team id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_teamID_inline",
                   "",
            ],
            [
                   "getAccount",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_account_inline",
                   "Gets the account of the flight.  @return The account of the flight.",
            ],
            [
                   "Gets the account of the flight.  @return The account of the flight.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_account_inline",
                   "",
            ],
            [
                   "getAddress",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_address_inline",
                   "Gets the address of the flight.  @return The address of the flight.",
            ],
            [
                   "Gets the address of the flight.  @return The address of the flight.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_address_inline",
                   "",
            ],
            [
                   "getStartTime",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_startTime_inline",
                   "Gets the start time of the flight.  @return The start time of the flight.",
            ],
            [
                   "Gets the start time of the flight.  @return The start time of the flight.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_startTime_inline",
                   "",
            ],
            [
                   "getContact",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_contact_inline",
                   "Gets flight account's contact.  @return The flight account's contact.",
            ],
            [
                   "Gets flight account's contact.  @return The flight account's contact.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_contact_inline",
                   "",
            ],
            [
                   "getMaxFlightTime",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_maxFlightTime_inline",
                   "Gets the maximum flight time during the flight in seconds.  @return The maximum flight time in seconds.",
            ],
            [
                   "Gets the maximum flight time during the flight in seconds.  @return The maximum flight time in seconds.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_maxFlightTime_inline",
                   "",
            ],
            [
                   "getMinFlightTime",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_minFlightTime_inline",
                   "Gets the minimum flight time during the flight in seconds.  @return The minimum flight time in seconds.",
            ],
            [
                   "Gets the minimum flight time during the flight in seconds.  @return The minimum flight time in seconds.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_minFlightTime_inline",
                   "",
            ],
            [
                   "getDistance",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_distance_inline",
                   "Gets the flight distance in meters.  @return The distance in meters.",
            ],
            [
                   "Gets the flight distance in meters.  @return The distance in meters.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_distance_inline",
                   "",
            ],
            [
                   "getDuration",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_duration_inline",
                   "Gets flight duration in seconds.  @return Duration in seconds.",
            ],
            [
                   "Gets flight duration in seconds.  @return Duration in seconds.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_duration_inline",
                   "",
            ],
            [
                   "getPeakHeight",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_peakHeight_inline",
                   "Gets the peak height in meters during the flight.  @return The peak height in meters.",
            ],
            [
                   "Gets the peak height in meters during the flight.  @return The peak height in meters.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail.html",
                   "#DJIFlightHubManager_DJIFlightHubFlightHistoricalDetail_peakHeight_inline",
                   "",
            ],
            [
                   "Statistics",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "",
                   "The flight statistics includes total and average flight duration. It also provides a distributed  diagram data of flight duration.",
            ],
            [
                   "The flight statistics includes total and average flight duration. It also provides a distributed  diagram data of flight duration.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "",
                   "",
            ],
            [
                   "getTotalDuration",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_totalDuration_inline",
                   "Gets total flight duration over a period of time in minutes.  @return The total flight duration.",
            ],
            [
                   "Gets total flight duration over a period of time in minutes.  @return The total flight duration.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_totalDuration_inline",
                   "",
            ],
            [
                   "getAverageDuration",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_averageDuration_inline",
                   "Gets average flight duration over a period of time in minutes.  @return The average flight duration.",
            ],
            [
                   "Gets average flight duration over a period of time in minutes.  @return The average flight duration.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_averageDuration_inline",
                   "",
            ],
            [
                   "getDurationDistribution",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_durationDistribution_inline",
                   "Gets the histogram distribution of the flight durations (in minutes). The duration intervals  are [0, 5), [5, 10), [10, 15), [15, 20) and [20, +&#x221E;).  @return A LinkedHashMap with string keys 0-5, 5-10, 10-15, 15-20 and 20+ in order. The values are the number of flights in the duration range.",
            ],
            [
                   "Gets the histogram distribution of the flight durations (in minutes). The duration intervals  are [0, 5), [5, 10), [10, 15), [15, 20) and [20, +&#x221E;).  @return A LinkedHashMap with string keys 0-5, 5-10, 10-15, 15-20 and 20+ in order. The values are the number of flights in the duration range.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubStatistics.html",
                   "#DJIFlightHubManager_DJIFlightHubStatistics_durationDistribution_inline",
                   "",
            ],
            [
                   "HistoricalFlight",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "",
                   "Class that constructed with flight statistics data and flight history in FlightHubManager.",
            ],
            [
                   "Class that constructed with flight statistics data and flight history in FlightHubManager.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "",
                   "",
            ],
            [
                   "getStatistics",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "#DJIFlightHubManager_DJIFlightHubHistoricalFlight_statistics_inline",
                   "Gets the statistics of flights.  @return A Statistics object.",
            ],
            [
                   "Gets the statistics of flights.  @return A Statistics object.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "#DJIFlightHubManager_DJIFlightHubHistoricalFlight_statistics_inline",
                   "",
            ],
            [
                   "getHistory",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "#DJIFlightHubManager_DJIFlightHubHistoricalFlight_history_inline",
                   "Gets the history of flight.  @return A HistoricalData object.",
            ],
            [
                   "Gets the history of flight.  @return A HistoricalData object.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubHistoricalFlight.html",
                   "#DJIFlightHubManager_DJIFlightHubHistoricalFlight_history_inline",
                   "",
            ],
            [
                   "RealTimeFlightData",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "",
                   "This class includes detail of current flight.",
            ],
            [
                   "This class includes detail of current flight.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "",
                   "",
            ],
            [
                   "getSn",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_sn_inline",
                   "Gets current device's serial number.  @return Current device's serial number.",
            ],
            [
                   "Gets current device's serial number.  @return Current device's serial number.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_sn_inline",
                   "",
            ],
            [
                   "getDevice",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_deviceModel_inline",
                   "Gets the model of the device.  @return The product name.",
            ],
            [
                   "Gets the model of the device.  @return The product name.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_deviceModel_inline",
                   "",
            ],
            [
                   "getTeamId",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_teamID_inline",
                   "Gets the team's id that current device belongs to.  @return Team id.",
            ],
            [
                   "Gets the team's id that current device belongs to.  @return Team id.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_teamID_inline",
                   "",
            ],
            [
                   "getDate",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_date_inline",
                   "Gets flight date.  @return The flight date.",
            ],
            [
                   "Gets flight date.  @return The flight date.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_date_inline",
                   "",
            ],
            [
                   "getLocationCoordinate",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_coordinate_inline",
                   "Gets current location coordinate.  @return A LocationCoordinate3D object.",
            ],
            [
                   "Gets current location coordinate.  @return A LocationCoordinate3D object.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_coordinate_inline",
                   "",
            ],
            [
                   "getSpeed",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_speed_inline",
                   "Gets flight speed.  @return An integer value of the flight speed in m/s.",
            ],
            [
                   "Gets flight speed.  @return An integer value of the flight speed in m/s.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_speed_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_yaw_inline",
                   "Gets flight yaw.  @return An integer value of flight yaw.",
            ],
            [
                   "Gets flight yaw.  @return An integer value of flight yaw.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_DJIFlightHubRealTimeFlightData.html",
                   "#DJIFlightHubManager_DJIFlightHubRealTimeFlightData_yaw_inline",
                   "",
            ],
            [
                   "UpdatedUploadStateCallback",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_UpdatedUploadStateCallbackInterface.html",
                   "",
                   "Updates current state of uploading flight data. In order to  begin updates, call the `onUpdate`  addUpdatedUploadStateCallback} method.",
            ],
            [
                   "Updates current state of uploading flight data. In order to  begin updates, call the `onUpdate`  addUpdatedUploadStateCallback} method.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_UpdatedUploadStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlightHubManager/DJIFlightHubManager_UpdatedUploadStateCallbackInterface.html",
                   "#DJIFlightHubManager_flightHubManagerDidUpdateUploadState_inline",
                   "Updates states for the uploading progress of flight data.  @param uploadState An enum value of `UploadState`. @param error Error when uploading data failed.",
            ],
            [
                   "Updates states for the uploading progress of flight data.  @param uploadState An enum value of `UploadState`. @param error Error when uploading data failed.",
                   1,
                   "/Components/FlightHubManager/DJIFlightHubManager_UpdatedUploadStateCallbackInterface.html",
                   "#DJIFlightHubManager_flightHubManagerDidUpdateUploadState_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJISDKFlightHubErrorForCode_inline",
                   "Returns the specific error in the `DJIFlightHubError` according to the error code.  @param errorCode errorCode for `DJIFlightHubError`.  @return An NSError object initialized with errorCode. If the errorCode was 0, returns nil.",
            ],
            [
                   "Returns the specific error in the `DJIFlightHubError` according to the error code.  @param errorCode errorCode for `DJIFlightHubError`.  @return An NSError object initialized with errorCode. If the errorCode was 0, returns nil.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJISDKFlightHubErrorForCode_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJIUTMISSErrorForCodeWithErrorCode_inline",
                   "Get DJIUTMISSError.  @param errorCode An int value of error code.  @return An object of `DJIError`.",
            ],
            [
                   "Get DJIUTMISSError.  @param errorCode An int value of error code.  @return An object of `DJIError`.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJIUTMISSErrorForCodeWithErrorCode_inline",
                   "",
            ],
            [
                   "getDescription",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_getDescription_inline",
                   "Returns the description of the error code.  @return The description of the error code.",
            ],
            [
                   "Returns the description of the error code.  @return The description of the error code.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_getDescription_inline",
                   "",
            ],
            [
                   "setDescription",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_setDescription_inline",
                   "Sets the description for the error code.  @param desc Description string.",
            ],
            [
                   "Sets the description for the error code.  @param desc Description string.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_setDescription_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_getDJIError_inline",
                   "Returns the specific error in DJIGeoError according to the error code.  @param ccode Error code.  @return The DJIError object.",
            ],
            [
                   "Returns the specific error in DJIGeoError according to the error code.  @param ccode Error code.  @return The DJIError object.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_getDJIError_inline",
                   "",
            ],
            [
                   "COULD_NOT_CONNECT_TO_INTERNET_FOR_PULLING_DATA",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_CONNECT_TO_INTERNET_FOR_PULLING_DATA_inline",
                   "Could not connect to the Internet while SDK try to pull the latest cached data from server.",
            ],
            [
                   "Could not connect to the Internet while SDK try to pull the latest cached data from server.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_CONNECT_TO_INTERNET_FOR_PULLING_DATA_inline",
                   "",
            ],
            [
                   "COULD_NOT_FIND_UNLOCKED_RECORD_IN_THE_SERVER",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_FIND_UNLOCKED_RECORD_IN_THE_SERVER_inline",
                   "Could not find unlocked record in the server.",
            ],
            [
                   "Could not find unlocked record in the server.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_FIND_UNLOCKED_RECORD_IN_THE_SERVER_inline",
                   "",
            ],
            [
                   "UNLOCKED_RECORD_NOT_FIND_ON_AIRCRAFT",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_UNLOCKED_RECORD_NOT_FIND_ON_AIRCRAFT_inline",
                   "Could not find unlocked record on the aircraft.",
            ],
            [
                   "Could not find unlocked record on the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_UNLOCKED_RECORD_NOT_FIND_ON_AIRCRAFT_inline",
                   "",
            ],
            [
                   "NO_DATA_IN_DATABASE",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_NO_DATA_IN_DATABASE_inline",
                   "No data in database.",
            ],
            [
                   "No data in database.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_NO_DATA_IN_DATABASE_inline",
                   "",
            ],
            [
                   "ACCOUNT_NOT_LOGGED_IN_OR_NOT_AUTHORIZED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_ACCOUNT_NOT_LOG_IN_OR_NOT_AUTHORIZED_inline",
                   "Not logged in account or account did not get authorization.",
            ],
            [
                   "Not logged in account or account did not get authorization.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_ACCOUNT_NOT_LOG_IN_OR_NOT_AUTHORIZED_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_SERIAL_NUMBER_IS_NOT_READY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_FLIGHT_CONTROLLER_SERIAL_NUMBER_IS_NOT_READY_inline",
                   "The flight controller SN is not ready.",
            ],
            [
                   "The flight controller SN is not ready.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_FLIGHT_CONTROLLER_SERIAL_NUMBER_IS_NOT_READY_inline",
                   "",
            ],
            [
                   "COULD_NOT_ENABLE_OR_DISABLE_GEO_SYSTEM_WHILE_AIRCRAFT_IS_IN_THE_SKY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_ENABLE_OR_DISABLE_GEO_SYSTEM_WHILE_AIRCRAFT_IS_IN_THE_SKY_inline",
                   "Could not enable or disable the GEO system while the aircraft is flying.",
            ],
            [
                   "Could not enable or disable the GEO system while the aircraft is flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJIGeoError_COULD_NOT_ENABLE_OR_DISABLE_GEO_SYSTEM_WHILE_AIRCRAFT_IS_IN_THE_SKY_inline",
                   "",
            ],
            [
                   "NOT_LOGGED_IN",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NotLoggedIn_inline",
                   "No user account recorded.",
            ],
            [
                   "No user account recorded.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NotLoggedIn_inline",
                   "",
            ],
            [
                   "INVALID_SIMULATED_LOCATION",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidSimulatedLocation_inline",
                   "The simulated aircraft location is not valid. During the simulation, a location is valid if it is within 50km of (37.460484, -122.115312).",
            ],
            [
                   "The simulated aircraft location is not valid. During the simulation, a location is valid if it is within 50km of (37.460484, -122.115312).",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidSimulatedLocation_inline",
                   "",
            ],
            [
                   "NO_MCSN",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoMCSN_inline",
                   "No MCSN Error.",
            ],
            [
                   "No MCSN Error.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoMCSN_inline",
                   "",
            ],
            [
                   "FC_QUERY_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_FCQueryFailed_inline",
                   "Unlock error, can't get license from the drone.",
            ],
            [
                   "Unlock error, can't get license from the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_FCQueryFailed_inline",
                   "",
            ],
            [
                   "FC_SET_ENABLE_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_FCSetEnableFailed_inline",
                   "Unlock error, can't enable license.",
            ],
            [
                   "Unlock error, can't enable license.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_FCSetEnableFailed_inline",
                   "",
            ],
            [
                   "INVALID_USER_ID",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableWithInvalidUserId_inline",
                   "Set enabled with invalid user id.",
            ],
            [
                   "Set enabled with invalid user id.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableWithInvalidUserId_inline",
                   "",
            ],
            [
                   "NO_SUCH_LICENSE",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableWithNoExistLicense_inline",
                   "License error, can't find the correct license.",
            ],
            [
                   "License error, can't find the correct license.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableWithNoExistLicense_inline",
                   "",
            ],
            [
                   "VERSION_MISMATCH",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableVersionNotMatch_inline",
                   "License error, incorrect length of request data.",
            ],
            [
                   "License error, incorrect length of request data.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableVersionNotMatch_inline",
                   "",
            ],
            [
                   "REQUEST_PARAM_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableParamError_inline",
                   "License error, incorrect value of request data.",
            ],
            [
                   "License error, incorrect value of request data.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableParamError_inline",
                   "",
            ],
            [
                   "SET_CERTIFICATE_NOT_ALLOWED_WHEN_DRONE_IN_SKY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableDroneInSky_inline",
                   "License error, can't set license when the drone is flying.",
            ],
            [
                   "License error, can't set license when the drone is flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_SetEnableDroneInSky_inline",
                   "",
            ],
            [
                   "USER_ID_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataUserIdError_inline",
                   "License error, incorrect checksum.",
            ],
            [
                   "License error, incorrect checksum.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataUserIdError_inline",
                   "",
            ],
            [
                   "LICENSE_DATA_INDEX_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataIndexError_inline",
                   "License error, wrong index please retry.",
            ],
            [
                   "License error, wrong index please retry.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataIndexError_inline",
                   "",
            ],
            [
                   "LICENSE_DATA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataError_inline",
                   "Upload license data with error data.",
            ],
            [
                   "Upload license data with error data.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataError_inline",
                   "",
            ],
            [
                   "CRC_CHECK_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataCrcCheckFailed_inline",
                   "License error, incorrect crc.",
            ],
            [
                   "License error, incorrect crc.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataCrcCheckFailed_inline",
                   "",
            ],
            [
                   "SN_CHECK_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataSNCheckFailed_inline",
                   "SLicense error, incorrect serial number.",
            ],
            [
                   "SLicense error, incorrect serial number.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataSNCheckFailed_inline",
                   "",
            ],
            [
                   "VERSION_CHECKE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataVersionCheckError_inline",
                   "License error, wrong version, please try to update the firmware of the drone.",
            ],
            [
                   "License error, wrong version, please try to update the firmware of the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataVersionCheckError_inline",
                   "",
            ],
            [
                   "RENEW_CERTIFICATE_NOT_ALLOWED_WHEN_DRONE_IN_SKY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataDroneInSky_inline",
                   "License error, can't update license when the drone is flying.",
            ],
            [
                   "License error, can't update license when the drone is flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UploadLicenseDataDroneInSky_inline",
                   "",
            ],
            [
                   "LICENSE_UNLOCK_NOT_SUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LicenseUnlockNotSupported_inline",
                   "Unlock error, not supported by the drone.",
            ],
            [
                   "Unlock error, not supported by the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LicenseUnlockNotSupported_inline",
                   "",
            ],
            [
                   "REMOVE_LICENSES_NOT_ALLOWED_WHEN_DRONE_IN_SKY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_RemoveLicensesFailedForAircraftInAir_inline",
                   "License error, can't delete license when the drone is flying.",
            ],
            [
                   "License error, can't delete license when the drone is flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_RemoveLicensesFailedForAircraftInAir_inline",
                   "",
            ],
            [
                   "REMOVE_LICENSES_NOT_SUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_RemoveLicensesNotSupport_inline",
                   "License error, not supported by the drone.",
            ],
            [
                   "License error, not supported by the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_RemoveLicensesNotSupport_inline",
                   "",
            ],
            [
                   "LICENSE_DATA_NO_DATA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoDataError_inline",
                   "License error, no data.",
            ],
            [
                   "License error, no data.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoDataError_inline",
                   "",
            ],
            [
                   "LOW_FIRMWARE_VERSION_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LowFirmwareVersionError_inline",
                   "License error, please update the firmware of the drone.",
            ],
            [
                   "License error, please update the firmware of the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LowFirmwareVersionError_inline",
                   "",
            ],
            [
                   "UNLOCK_VERSION_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockVersionError_inline",
                   "Unlock error, incorrect unlock version.",
            ],
            [
                   "Unlock error, incorrect unlock version.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockVersionError_inline",
                   "",
            ],
            [
                   "OLD_DATA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_OldDataError_inline",
                   "License error, local data is obsolete.",
            ],
            [
                   "License error, local data is obsolete.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_OldDataError_inline",
                   "",
            ],
            [
                   "INVALID_KEY_VERSION_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidKeyVersionError_inline",
                   "License error, invalid key version.",
            ],
            [
                   "License error, invalid key version.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidKeyVersionError_inline",
                   "",
            ],
            [
                   "QUERY_AREA_ID_NO_EXIST_LICENSE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_QueryAreaIdNoExistLicenseError_inline",
                   "License error, license ID is not exist.",
            ],
            [
                   "License error, license ID is not exist.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_QueryAreaIdNoExistLicenseError_inline",
                   "",
            ],
            [
                   "SERVER_INVALID_TOKEN_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidTokenOnServerError_inline",
                   "Server error, invalid token.",
            ],
            [
                   "Server error, invalid token.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidTokenOnServerError_inline",
                   "",
            ],
            [
                   "SERVER_UNIDENTIFIED_PHONE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnidentifiedPhone_inline",
                   "Server error, unknown phone.",
            ],
            [
                   "Server error, unknown phone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnidentifiedPhone_inline",
                   "",
            ],
            [
                   "SERVER_NOT_UNLOCKABLE_AREA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockNotUnlockableArea_inline",
                   "Server error, invalid area.",
            ],
            [
                   "Server error, invalid area.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockNotUnlockableArea_inline",
                   "",
            ],
            [
                   "SERVER_UNLOCK_TOO_MANY_AREAS_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockTooManyAreas_inline",
                   "Server error, too many areas.",
            ],
            [
                   "Server error, too many areas.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UnlockTooManyAreas_inline",
                   "",
            ],
            [
                   "SERVER_TOO_MUCH_LICENSE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_TooMuchLicense_inline",
                   "Server error, too many licenses.",
            ],
            [
                   "Server error, too many licenses.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_TooMuchLicense_inline",
                   "",
            ],
            [
                   "NO_NETWORK",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoNetwork_inline",
                   "Network error, invalid network.",
            ],
            [
                   "Network error, invalid network.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NoNetwork_inline",
                   "",
            ],
            [
                   "NETWORK_SERVER_DATA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkServerDataError_inline",
                   "Network error, data parsing failed in server.",
            ],
            [
                   "Network error, data parsing failed in server.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkServerDataError_inline",
                   "",
            ],
            [
                   "LOCAL_USER_TOKEN_IS_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LocalUserTokenIsInvalid_inline",
                   "Network error, invalid token.",
            ],
            [
                   "Network error, invalid token.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_LocalUserTokenIsInvalid_inline",
                   "",
            ],
            [
                   "NETWORK_PAGE_NOT_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkPageNotFound_inline",
                   "Network error, page not found(deprecated).",
            ],
            [
                   "Network error, page not found(deprecated).",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkPageNotFound_inline",
                   "",
            ],
            [
                   "PM_WRONG_SERIAL_NUMBER",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongSerialNumber_inline",
                   "Package error, wrong serial number of the drone.",
            ],
            [
                   "Package error, wrong serial number of the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongSerialNumber_inline",
                   "",
            ],
            [
                   "DB_FILE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseFileError_inline",
                   "Database error, can't unzip the database.",
            ],
            [
                   "Database error, can't unzip the database.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseFileError_inline",
                   "",
            ],
            [
                   "DB_INVALID_PARAMS",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseInvalidParams_inline",
                   "Database error, invalid parameters when updating database.",
            ],
            [
                   "Database error, invalid parameters when updating database.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseInvalidParams_inline",
                   "",
            ],
            [
                   "DB_NOT_READY",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseNotReady_inline",
                   "Database error, load database fail.",
            ],
            [
                   "Database error, load database fail.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_DataBaseNotReady_inline",
                   "",
            ],
            [
                   "SERVER_JSON_DATA_PARSE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_ServerJsonDataParseError_inline",
                   "Server error, incorrect Json data.",
            ],
            [
                   "Server error, incorrect Json data.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_ServerJsonDataParseError_inline",
                   "",
            ],
            [
                   "NETWORK_SIGNATURE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkSignatureError_inline",
                   "Network error, invalid signature.",
            ],
            [
                   "Network error, invalid signature.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkSignatureError_inline",
                   "",
            ],
            [
                   "NETWORK_CHECK_SIGNATURE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkCheckServerSignatureError_inline",
                   "Network error, invalid signature (deprecated).",
            ],
            [
                   "Network error, invalid signature (deprecated).",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkCheckServerSignatureError_inline",
                   "",
            ],
            [
                   "NETWORK_INVALID_REQUESET",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkInvalidRequeset_inline",
                   "Network error, invalid request.",
            ],
            [
                   "Network error, invalid request.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkInvalidRequeset_inline",
                   "",
            ],
            [
                   "NETWORK_USER_IS_NOT_LOGIN",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkUserIsNotLogin_inline",
                   "Network error, user is not login.",
            ],
            [
                   "Network error, user is not login.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkUserIsNotLogin_inline",
                   "",
            ],
            [
                   "NETWORK_OPERATION_CANCEL_BY_USER",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkOperationCancelByUser_inline",
                   "Network error, canceled by user(deprecated).",
            ],
            [
                   "Network error, canceled by user(deprecated).",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_NetworkOperationCancelByUser_inline",
                   "",
            ],
            [
                   "PM_TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerTimeout_inline",
                   "Package error, time out when waiting for the Ack package from the drone.",
            ],
            [
                   "Package error, time out when waiting for the Ack package from the drone.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerTimeout_inline",
                   "",
            ],
            [
                   "PM_WRONG_UNLOCK_VERSION",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongUnlockVersion_inline",
                   "Unlock error, unlock version from the drone should be 0, 1, or 2.",
            ],
            [
                   "Unlock error, unlock version from the drone should be 0, 1, or 2.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongUnlockVersion_inline",
                   "",
            ],
            [
                   "PM_WRONG_DEVICE_ID",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongDeviceId_inline",
                   "Package error, wrong device ID.",
            ],
            [
                   "Package error, wrong device ID.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_PackManagerWrongDeviceId_inline",
                   "",
            ],
            [
                   "INVALID_AREA_IDS",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidAreaIds_inline",
                   "Unlock error, area ID is not exist in the license.",
            ],
            [
                   "Unlock error, area ID is not exist in the license.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_InvalidAreaIds_inline",
                   "",
            ],
            [
                   "USER_MISMATCH",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UserMismatch_inline",
                   "License error, the user is not matching.",
            ],
            [
                   "License error, the user is not matching.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "#DJIError_DJISDKGEOError_UserMismatch_inline",
                   "",
            ],
            [
                   "MISSION_NOT_STARTED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionNotStarted_inline",
                   "Mission is not started yet.",
            ],
            [
                   "Mission is not started yet.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionNotStarted_inline",
                   "",
            ],
            [
                   "COMMON_STATE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_CommonStateError_inline",
                   "The command is not supported in current state.",
            ],
            [
                   "The command is not supported in current state.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_CommonStateError_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_SPEED_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorMaxFlightSpeed_inline",
                   "Max Flight speed value provided is invalid.",
            ],
            [
                   "Max Flight speed value provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "AUTO_FLIGHT_SPEED_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorAutoFlightSpeed_inline",
                   "Auto flight speed value provided is invalid.",
            ],
            [
                   "Auto flight speed value provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "REPEAT_TIME_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorRepeatTime_inline",
                   "Repeat time value provided is invalid.",
            ],
            [
                   "Repeat time value provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorRepeatTime_inline",
                   "",
            ],
            [
                   "WAYPOINT_COUNT_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorWaypointCount_inline",
                   "Waypoint count exceeds the maximum limit.",
            ],
            [
                   "Waypoint count exceeds the maximum limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorWaypointCount_inline",
                   "",
            ],
            [
                   "WAYPOINT_LIST_SIZE_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorWaypointListSize_inline",
                   "Waypoint list size is invalid.",
            ],
            [
                   "Waypoint list size is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointMissionErrorWaypointListSize_inline",
                   "",
            ],
            [
                   "WAYPOINT_COORDINATE_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorCoordinate_inline",
                   "Waypoint coordinate provided is invalid.",
            ],
            [
                   "Waypoint coordinate provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorCoordinate_inline",
                   "",
            ],
            [
                   "ALTITUDE_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorAltitude_inline",
                   "Waypoint altitude provided is invalid.",
            ],
            [
                   "Waypoint altitude provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorAltitude_inline",
                   "",
            ],
            [
                   "HEADING_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorHeading_inline",
                   "Waypoint heading provided is invalid.",
            ],
            [
                   "Waypoint heading provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorHeading_inline",
                   "",
            ],
            [
                   "ACTION_REPEAT_TIME_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRepeatTime_inline",
                   "Waypoint repeat time provided is invalid.",
            ],
            [
                   "Waypoint repeat time provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRepeatTime_inline",
                   "",
            ],
            [
                   "ACTION_TIMEOUT_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorActionTimeout_inline",
                   "Waypoint action timeout provided is invalid.",
            ],
            [
                   "Waypoint action timeout provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorActionTimeout_inline",
                   "",
            ],
            [
                   "CORNER_RADIUS_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorCornerRadius_inline",
                   "Waypoint corner radius provided is invalid.",
            ],
            [
                   "Waypoint corner radius provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorCornerRadius_inline",
                   "",
            ],
            [
                   "GIMBAL_PITCH_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorGimbalPitch_inline",
                   "Waypoint gimbal pitch provided is invalid.",
            ],
            [
                   "Waypoint gimbal pitch provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorGimbalPitch_inline",
                   "",
            ],
            [
                   "WAYPOINT_SPEED_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorSpeed_inline",
                   "Waypoint speed provided is invalid.",
            ],
            [
                   "Waypoint speed provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorSpeed_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorShootPhotoDistance_inline",
                   "Waypoint shoot photo distance provided is invalid.",
            ],
            [
                   "Waypoint shoot photo distance provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorShootPhotoDistance_inline",
                   "",
            ],
            [
                   "STAY_ACTION_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorStayActionParam_inline",
                   "Waypoint stay action param provided is invalid.",
            ],
            [
                   "Waypoint stay action param provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorStayActionParam_inline",
                   "",
            ],
            [
                   "ROTATE_GIMBAL_ACTION_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRotateGimbalActionParam_inline",
                   "Waypoint rotate gimbal action param provided is invalid.",
            ],
            [
                   "Waypoint rotate gimbal action param provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRotateGimbalActionParam_inline",
                   "",
            ],
            [
                   "ROTATE_AIRCRAFT_ACTION_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRotateAircraftActionParam_inline",
                   "Waypoint rotate aircraft action param provided is invalid.",
            ],
            [
                   "Waypoint rotate aircraft action param provided is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointErrorRotateAircraftActionParam_inline",
                   "",
            ],
            [
                   "INDICES_ARE_DISCONTINUOUS",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_IndicesAreDiscontinuous_inline",
                   "Waypoint indecies are discontinuous.",
            ],
            [
                   "Waypoint indecies are discontinuous.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_IndicesAreDiscontinuous_inline",
                   "",
            ],
            [
                   "INDEX_OUT_OF_RANGE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_IndexOutOfRange_inline",
                   "Waypoint index out of range.",
            ],
            [
                   "Waypoint index out of range.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_IndexOutOfRange_inline",
                   "",
            ],
            [
                   "INVALID_DATA_SIZE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_InvalidDataSize_inline",
                   "Waypoint data size is invalid. It is for internal usage.",
            ],
            [
                   "Waypoint data size is invalid. It is for internal usage.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_InvalidDataSize_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILURE_CAUSED_BY_ATTITUDE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TakeoffFailureCausedByAttitude_inline",
                   "The aircraft cannot take off because of improper aircraft's attitude.",
            ],
            [
                   "The aircraft cannot take off because of improper aircraft's attitude.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TakeoffFailureCausedByAttitude_inline",
                   "",
            ],
            [
                   "WAYPOINT_GET_INTERRUPTION_FAILURE_FOR_COMPLETE_MISSION",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointGetInterruptionFailureForCompleteMission_inline",
                   "The waypoint mission interruption is not available because the last mission completed successfully.",
            ],
            [
                   "The waypoint mission interruption is not available because the last mission completed successfully.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointGetInterruptionFailureForCompleteMission_inline",
                   "",
            ],
            [
                   "WAYPOINT_GET_INTERRUPTION_FAILURE_WITHOUT_REACHING_FIRST_WAYPOINT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointGetInterruptionFailureWithoutReachingFirstWaypoint_inline",
                   "The waypoint mission interruption is not available because the aircraft didn't reach the first waypoint in the last mission.",
            ],
            [
                   "The waypoint mission interruption is not available because the aircraft didn't reach the first waypoint in the last mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WaypointGetInterruptionFailureWithoutReachingFirstWaypoint_inline",
                   "",
            ],
            [
                   "SYSTEM_ABNORMAL",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_SystemAbnormal_inline",
                   "System error, please try again. If the error continues, restart the aircraft.",
            ],
            [
                   "System error, please try again. If the error continues, restart the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_SystemAbnormal_inline",
                   "",
            ],
            [
                   "TARGET_AREA_IS_TOO_SMALL",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetAreaIsTooSmall_inline",
                   "Frame selection subject too small.",
            ],
            [
                   "Frame selection subject too small.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetAreaIsTooSmall_inline",
                   "",
            ],
            [
                   "INSUFFICIENT_FEATURES_IN_TARGET_AREA",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_InsufficientFeaturesInTargetArea_inline",
                   "Frame selection subject texture not obvious.",
            ],
            [
                   "Frame selection subject texture not obvious.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_InsufficientFeaturesInTargetArea_inline",
                   "",
            ],
            [
                   "LOST_TARGET_WHILE_WATCHING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostTargetWhileWatching_inline",
                   "Tracking subject lost while watching.",
            ],
            [
                   "Tracking subject lost while watching.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostTargetWhileWatching_inline",
                   "",
            ],
            [
                   "LOST_TARGET_WHILE_EXECUTING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostTargetWhileExecuting_inline",
                   "Tracking subject lost while executing.",
            ],
            [
                   "Tracking subject lost while executing.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostTargetWhileExecuting_inline",
                   "",
            ],
            [
                   "REPROJECTION_FAILED_WHILE_EXECUTING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReprojectionFailedWhileExecuting_inline",
                   "Failed to estimate, please try again.",
            ],
            [
                   "Failed to estimate, please try again.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReprojectionFailedWhileExecuting_inline",
                   "",
            ],
            [
                   "TARGET_TOO_CLOSE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetTooClose_inline",
                   "Frame subject too close.",
            ],
            [
                   "Frame subject too close.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetTooClose_inline",
                   "",
            ],
            [
                   "TARGET_SIZE_CHANGED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetSizeChanged_inline",
                   "Target size changed, please try again. If the error persists, restart the aircraft.",
            ],
            [
                   "Target size changed, please try again. If the error persists, restart the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetSizeChanged_inline",
                   "",
            ],
            [
                   "GPS_ABNORMAL",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_GPSAbnormal_inline",
                   "GPS signal weak. Please try again in an open area.",
            ],
            [
                   "GPS signal weak. Please try again in an open area.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_GPSAbnormal_inline",
                   "",
            ],
            [
                   "HOT_POINT_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_HotpointInvalid_inline",
                   "Hotpoint parameter do not meet requirements.",
            ],
            [
                   "Hotpoint parameter do not meet requirements.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_HotpointInvalid_inline",
                   "",
            ],
            [
                   "WATCH_TARGET_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WatchTargetFailed_inline",
                   "Gimbal reached movement limit, subjecting failed. Please try again.",
            ],
            [
                   "Gimbal reached movement limit, subjecting failed. Please try again.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_WatchTargetFailed_inline",
                   "",
            ],
            [
                   "ESTIMATE_TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_EstimateTimeout_inline",
                   "Estimate timeout, mission exit.",
            ],
            [
                   "Estimate timeout, mission exit.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_EstimateTimeout_inline",
                   "",
            ],
            [
                   "ESTIMATE_RESULT_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_EstimateResultInvalid_inline",
                   "Failed to estimate subject location.",
            ],
            [
                   "Failed to estimate subject location.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_EstimateResultInvalid_inline",
                   "",
            ],
            [
                   "EXIT_BY_USER_BUTTON",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ExitByUserButton_inline",
                   "Current mission exit by user button.",
            ],
            [
                   "Current mission exit by user button.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ExitByUserButton_inline",
                   "",
            ],
            [
                   "RADIUS_LIMIT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_RadiusLimit_inline",
                   "The aircraft reach the distance limit. Please operate the aircraft within the distance limit.",
            ],
            [
                   "The aircraft reach the distance limit. Please operate the aircraft within the distance limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_RadiusLimit_inline",
                   "",
            ],
            [
                   "ALTITUDE_LIMIT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AltitudeLimit_inline",
                   "The aircraft reach the altitude limit. Please operate the aircraft within the Altitude limit.",
            ],
            [
                   "The aircraft reach the altitude limit. Please operate the aircraft within the Altitude limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AltitudeLimit_inline",
                   "",
            ],
            [
                   "CONTROL_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ControlFailed_inline",
                   "Intelligent Hotpoint mission execute failed, the description is the fail reason.",
            ],
            [
                   "Intelligent Hotpoint mission execute failed, the description is the fail reason.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ControlFailed_inline",
                   "",
            ],
            [
                   "LOST_CONNECTION_WITH_REMOTE_CONTROLLER",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostConnectionWithRemoteController_inline",
                   "Lost connection with remoteController.",
            ],
            [
                   "Lost connection with remoteController.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_LostConnectionWithRemoteController_inline",
                   "",
            ],
            [
                   "OBSTACLE_ENCOUNTERED_WHILE_ESTIMATING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleEncounteredWhileEstimating_inline",
                   "Obstacles encountered while estimating, current mission quitted.",
            ],
            [
                   "Obstacles encountered while estimating, current mission quitted.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleEncounteredWhileEstimating_inline",
                   "",
            ],
            [
                   "OBSTACLE_ENCOUNTERED_WHILE_SURROUNDING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleEncounteredWhileSurrounding_inline",
                   "Obstacles encountered while surrounding, current mission suspended.",
            ],
            [
                   "Obstacles encountered while surrounding, current mission suspended.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleEncounteredWhileSurrounding_inline",
                   "",
            ],
            [
                   "TARGET_IS_TOO_FAR_AWAY",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetIsTooFaraway_inline",
                   "Target is too faraway, the aircraft needs to continue to measure distance.",
            ],
            [
                   "Target is too faraway, the aircraft needs to continue to measure distance.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TargetIsTooFaraway_inline",
                   "",
            ],
            [
                   "HOTPOINT_ALTITUDE_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AltitudeTooLow_inline",
                   "Aircraft's altitude is too low to execute hotpoint mission.",
            ],
            [
                   "Aircraft's altitude is too low to execute hotpoint mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AltitudeTooLow_inline",
                   "",
            ],
            [
                   "MULTI_MODE_DISABLED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MultiModeDisabled_inline",
                   "The mission cannot start when multi-mode is disabled.",
            ],
            [
                   "The mission cannot start when multi-mode is disabled.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MultiModeDisabled_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_getDJIError_inline",
                   "Returns the specific error in DJIMissionManagerError according to the error code.  @param ccode Error code.  @return The DJIError object.",
            ],
            [
                   "Returns the specific error in DJIMissionManagerError according to the error code.  @param ccode Error code.  @return The DJIError object.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_getDJIError_inline",
                   "",
            ],
            [
                   "COMMON_UNSUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_COMMON_UNSUPPORTED_inline",
                   "Unsupported feature error. Where possible:  This error will be returned by the function for a special feature interface when the feature is not supported by the device.",
            ],
            [
                   "Unsupported feature error. Where possible:  This error will be returned by the function for a special feature interface when the feature is not supported by the device.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_COMMON_UNSUPPORTED_inline",
                   "",
            ],
            [
                   "COMMON_DISCONNECTED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_COMMON_DISCONNECTED_inline",
                   "Disconnected.",
            ],
            [
                   "Disconnected.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_COMMON_DISCONNECTED_inline",
                   "",
            ],
            [
                   "BEGAN",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_BEGAN_inline",
                   "Mission began (Phantom 2 series).",
            ],
            [
                   "Mission began (Phantom 2 series).",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_BEGAN_inline",
                   "",
            ],
            [
                   "CANCELED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_CANCELED_inline",
                   "Mission canceled.",
            ],
            [
                   "Mission canceled.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_CANCELED_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FAILED_inline",
                   "Mission failed.",
            ],
            [
                   "Mission failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FAILED_inline",
                   "",
            ],
            [
                   "NO_MISSION_RUNNING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_NOT_EXISTED_inline",
                   "Mission not existed.",
            ],
            [
                   "Mission not existed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_NOT_EXISTED_inline",
                   "",
            ],
            [
                   "TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_TIMEOUT_inline",
                   "Mission timeout.",
            ],
            [
                   "Mission timeout.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_TIMEOUT_inline",
                   "",
            ],
            [
                   "GPS_NOT_READY",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_GPS_NOT_READY_inline",
                   "The GPS of the aircraft is not ready.  Maybe the aircraft haven't got the home point location.",
            ],
            [
                   "The GPS of the aircraft is not ready.  Maybe the aircraft haven't got the home point location.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_GPS_NOT_READY_inline",
                   "",
            ],
            [
                   "MOTORS_DID_NOT_START",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MOTOR_NOT_START_inline",
                   "The aircraft's motor has not started.",
            ],
            [
                   "The aircraft's motor has not started.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MOTOR_NOT_START_inline",
                   "",
            ],
            [
                   "TAKE_OFF",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_TAKEOFF_inline",
                   "The aircraft is taking off.",
            ],
            [
                   "The aircraft is taking off.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_TAKEOFF_inline",
                   "",
            ],
            [
                   "IS_FLYING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IS_FLYING_inline",
                   "The aircraft is flying.",
            ],
            [
                   "The aircraft is flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IS_FLYING_inline",
                   "",
            ],
            [
                   "NOT_AUTO_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_NOT_AUTO_MODE_inline",
                   "The aircraft is not in auto mode.",
            ],
            [
                   "The aircraft is not in auto mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_NOT_AUTO_MODE_inline",
                   "",
            ],
            [
                   "MAX_NUMBER_OF_WAYPOINTS_UPLOAD_LIMIT_REACHED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UPLOAD_WAYPOINT_NUM_MAX_LIMIT_inline",
                   "Waypoint mission has reached the maximum points limit.  1. Phantom 2 Vision/Vision+: the max points limit is 16.  2. Inspire1/ Phantom 3 series: the max points limit is 99.",
            ],
            [
                   "Waypoint mission has reached the maximum points limit.  1. Phantom 2 Vision/Vision+: the max points limit is 16.  2. Inspire1/ Phantom 3 series: the max points limit is 99.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UPLOAD_WAYPOINT_NUM_MAX_LIMIT_inline",
                   "",
            ],
            [
                   "UPLOADING_WAYPOINT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_UPLOADING_inline",
                   "Waypoint is uploading.",
            ],
            [
                   "Waypoint is uploading.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_UPLOADING_inline",
                   "",
            ],
            [
                   "KEY_LEVEL_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_KEY_LEVEL_LOW_inline",
                   "The API key provided to you is not at the correct permission level.  Check whether your key is a level 2 application key in your AndroidManifest.xml.",
            ],
            [
                   "The API key provided to you is not at the correct permission level.  Check whether your key is a level 2 application key in your AndroidManifest.xml.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_KEY_LEVEL_LOW_inline",
                   "",
            ],
            [
                   "NAVIGATION_MODE_DISABLED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_NAVIGATION_IS_NOT_OPEN_inline",
                   "Navigation is not open.",
            ],
            [
                   "Navigation is not open.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_NAVIGATION_IS_NOT_OPEN_inline",
                   "",
            ],
            [
                   "IOC_TYPE_UNKNOWN",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IOC_TYPE_UNKNOWN_inline",
                   "The type of IOC is unknown.",
            ],
            [
                   "The type of IOC is unknown.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IOC_TYPE_UNKNOWN_inline",
                   "",
            ],
            [
                   "HOME_POINT_VALUE_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_VALUE_INVALID_inline",
                   "The homepoint is not a valid float value.",
            ],
            [
                   "The homepoint is not a valid float value.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_VALUE_INVALID_inline",
                   "",
            ],
            [
                   "HOME_POINT_LOCATION_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_LOCATION_INVALID_inline",
                   "The latitude and longitude of the homepoint are invalid.",
            ],
            [
                   "The latitude and longitude of the homepoint are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_LOCATION_INVALID_inline",
                   "",
            ],
            [
                   "HOME_POINT_DIRECTION_UNKNOWN",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_DIRECTION_UNKNOWN_inline",
                   "The direction of the homepoint is unknown.",
            ],
            [
                   "The direction of the homepoint is unknown.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_DIRECTION_UNKNOWN_inline",
                   "",
            ],
            [
                   "HOME_POINT_MISSION_PAUSED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_PAUSED_inline",
                   "Homepoint is paused.",
            ],
            [
                   "Homepoint is paused.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_PAUSED_inline",
                   "",
            ],
            [
                   "HOME_POINT_MISSION_NOT_PAUSED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_NOT_PAUSED_inline",
                   "The homepoint is not paused.",
            ],
            [
                   "The homepoint is not paused.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HOMEPOINT_NOT_PAUSED_inline",
                   "",
            ],
            [
                   "FOLLOW_ME_DISTANCE_TOO_LARGE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_DISTANCE_TOO_LARGE_inline",
                   "The distance between the aircraft and mobile phone is too large (must be lower than 20000m). This error will be returned when initializing the follow me task.",
            ],
            [
                   "The distance between the aircraft and mobile phone is too large (must be lower than 20000m). This error will be returned when initializing the follow me task.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_DISTANCE_TOO_LARGE_inline",
                   "",
            ],
            [
                   "FOLLOW_ME_DISCONNECT_TIME_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_DISCONNECT_TIME_TOOLONG_inline",
                   "The disconnect time of the Follow Me mission is too long.",
            ],
            [
                   "The disconnect time of the Follow Me mission is too long.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_DISCONNECT_TIME_TOOLONG_inline",
                   "",
            ],
            [
                   "FOLLOW_ME_GIMBAL_PITCH_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_GIMBAL_PITCH_ERROR_inline",
                   "The initial pitch angle of the gimbal is too large.",
            ],
            [
                   "The initial pitch angle of the gimbal is too large.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_FOLLOWME_GIMBAL_PITCH_ERROR_inline",
                   "",
            ],
            [
                   "ALTITUDE_TOO_HIGH",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_ALTITUDE_TOO_HIGH_inline",
                   "The altitude is too high. The range of the altitude should be [-200,500].",
            ],
            [
                   "The altitude is too high. The range of the altitude should be [-200,500].",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_ALTITUDE_TOO_HIGH_inline",
                   "",
            ],
            [
                   "ALTITUDE_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_ALTITUDE_TOO_LOW_inline",
                   "The altitude is too low. The range of the altitude should be [-200,500].",
            ],
            [
                   "The altitude is too low. The range of the altitude should be [-200,500].",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_ALTITUDE_TOO_LOW_inline",
                   "",
            ],
            [
                   "MISSION_RADIUS_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_RADIUS_INVALID_inline",
                   "The radius of mission is invalid.",
            ],
            [
                   "The radius of mission is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_RADIUS_INVALID_inline",
                   "",
            ],
            [
                   "MISSION_SPEED_TOO_HIGH",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_SPEED_TOO_LARGE_inline",
                   "The speed of the mission is too high.",
            ],
            [
                   "The speed of the mission is too high.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_SPEED_TOO_LARGE_inline",
                   "",
            ],
            [
                   "MISSION_ENTRY_POINT_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ENTRYPOINT_INVALID_inline",
                   "The entry point of the mission is invalid.",
            ],
            [
                   "The entry point of the mission is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ENTRYPOINT_INVALID_inline",
                   "",
            ],
            [
                   "MISSION_HEADING_MODE_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_HEADING_MODE_INVALID_inline",
                   "The heading mode of the mission is invalid.",
            ],
            [
                   "The heading mode of the mission is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_HEADING_MODE_INVALID_inline",
                   "",
            ],
            [
                   "MISSION_RADIUS_OVER_LIMIT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_RADIUS_OVERLIMITED_inline",
                   "The radius of the mission is over the acceptable limit.",
            ],
            [
                   "The radius of the mission is over the acceptable limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_RADIUS_OVERLIMITED_inline",
                   "",
            ],
            [
                   "NAVIGATION_MODE_NOT_SUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UNSUPPORTED_NAVIGATION_FOR_THE_PRODUCT_inline",
                   "Navigation in the product is unsupported.",
            ],
            [
                   "Navigation in the product is unsupported.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UNSUPPORTED_NAVIGATION_FOR_THE_PRODUCT_inline",
                   "",
            ],
            [
                   "DISTANCE_FROM_MISSION_TARGET_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_DISTANCE_FROM_MISSION_TARGET_TOO_LONG_inline",
                   "The distance from the mission target is too long.  For example, the distance from hotpoint target position is too long,  or the distance from the first waypoint target position is too long",
            ],
            [
                   "The distance from the mission target is too long.  For example, the distance from hotpoint target position is too long,  or the distance from the first waypoint target position is too long",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_DISTANCE_FROM_MISSION_TARGET_TOO_LONG_inline",
                   "",
            ],
            [
                   "RC_MODE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_RC_MODE_ERROR_inline",
                   "Remote controller mode error.  You should put the remote controller's mode selection bar to F position.",
            ],
            [
                   "Remote controller mode error.  You should put the remote controller's mode selection bar to F position.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_RC_MODE_ERROR_inline",
                   "",
            ],
            [
                   "IOC_WORKING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IOC_WORKING_inline",
                   "The IOC mode is working.",
            ],
            [
                   "The IOC mode is working.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_IOC_WORKING_inline",
                   "",
            ],
            [
                   "MISSION_NOT_INITIALIZED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_NOT_INIT_inline",
                   "The mission is not initialized.",
            ],
            [
                   "The mission is not initialized.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_NOT_INIT_inline",
                   "",
            ],
            [
                   "MISSION_NOT_EXIST",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_NOT_EXIST_inline",
                   "The mission does not exist.",
            ],
            [
                   "The mission does not exist.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_NOT_EXIST_inline",
                   "",
            ],
            [
                   "MISSION_CONFLICT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_CONFLICT_inline",
                   "There is a conflicting setting in the mission.",
            ],
            [
                   "There is a conflicting setting in the mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_CONFLICT_inline",
                   "",
            ],
            [
                   "MISSION_ESTIMATE_TIME_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ESTIMATE_TIME_TOO_LONG_inline",
                   "The estimated time for the mission is too long.",
            ],
            [
                   "The estimated time for the mission is too long.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ESTIMATE_TIME_TOO_LONG_inline",
                   "",
            ],
            [
                   "RTK_IS_NOT_READY",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_RTK_IS_NOT_READY_inline",
                   "RTK is not ready.",
            ],
            [
                   "RTK is not ready.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_RTK_IS_NOT_READY_inline",
                   "",
            ],
            [
                   "MULTI_MODE_IS_OFF",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_MULTI_MODE_IS_OFF_inline",
                   "Multi-mode switch is not turned on.",
            ],
            [
                   "Multi-mode switch is not turned on.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_MULTI_MODE_IS_OFF_inline",
                   "",
            ],
            [
                   "HIGH_PRIORITY_MISSION_EXECUTING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HIGH_PRIORITY_MISSION_EXECUTING_inline",
                   "A higher priority mission is executing.",
            ],
            [
                   "A higher priority mission is executing.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_HIGH_PRIORITY_MISSION_EXECUTING_inline",
                   "",
            ],
            [
                   "MISSION_CONDITION_NOT_SATISFIED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_CONDITION_NOT_SATISFIED_inline",
                   "The condition of the mission is not satisfied.",
            ],
            [
                   "The condition of the mission is not satisfied.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_CONDITION_NOT_SATISFIED_inline",
                   "",
            ],
            [
                   "MISSION_ACROSS_NO_FLY_ZONE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ACROSS_NOFLYZONE_inline",
                   "The mission is across a no fly zone.",
            ],
            [
                   "The mission is across a no fly zone.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_ACROSS_NOFLYZONE_inline",
                   "",
            ],
            [
                   "MISSION_INFO_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_INFO_INVALID_inline",
                   "The information for the mission is invalid.",
            ],
            [
                   "The information for the mission is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_MISSION_INFO_INVALID_inline",
                   "",
            ],
            [
                   "WAYPOINT_INFO_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_INFO_INVALID_inline",
                   "The information for the waypoint is invalid.",
            ],
            [
                   "The information for the waypoint is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_INFO_INVALID_inline",
                   "",
            ],
            [
                   "WAYPOINT_TRACE_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_TRACE_TOO_LONG_inline",
                   "The waypoint trace is too long. The maximum waypoint trace is 30km. The waypoint trace is the sum of all distances between waypoints in a mission.",
            ],
            [
                   "The waypoint trace is too long. The maximum waypoint trace is 30km. The waypoint trace is the sum of all distances between waypoints in a mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_TRACE_TOO_LONG_inline",
                   "",
            ],
            [
                   "WAYPOINT_TOTAL_TRACE_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_TOTAL_TRACE_TOO_LONG_inline",
                   "The total waypoint mission distance is too long. The maximum total distance is 40km. The total distance includes the sum of:   - Distance from current aircraft location to first waypoint   - Sum of all distances between waypoints   - Distance from last waypoint to the homepoint.",
            ],
            [
                   "The total waypoint mission distance is too long. The maximum total distance is 40km. The total distance includes the sum of:   - Distance from current aircraft location to first waypoint   - Sum of all distances between waypoints   - Distance from last waypoint to the homepoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_TOTAL_TRACE_TOO_LONG_inline",
                   "",
            ],
            [
                   "WAYPOINT_INDEX_OVER_RANGE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_INDEX_OVERRANGE_inline",
                   "The index of the waypoint is out of range.",
            ],
            [
                   "The index of the waypoint is out of range.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_INDEX_OVERRANGE_inline",
                   "",
            ],
            [
                   "WAYPOINT_DISTANCE_TOO_CLOSE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DISTANCE_TOO_CLOSE_inline",
                   "The waypoint distance is too close.",
            ],
            [
                   "The waypoint distance is too close.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DISTANCE_TOO_CLOSE_inline",
                   "",
            ],
            [
                   "WAYPOINT_DISTANCE_TOO_LONG",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DISTANCE_TOO_LONG_inline",
                   "The waypoint distance is too long. A valid distance between two adjacent waypoints is less than 2km and greater than 0.5m.",
            ],
            [
                   "The waypoint distance is too long. A valid distance between two adjacent waypoints is less than 2km and greater than 0.5m.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DISTANCE_TOO_LONG_inline",
                   "",
            ],
            [
                   "WAYPOINT_DAMPING_CHECK_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DAMPING_CHECK_FAILED_inline",
                   "The damping check failed.",
            ],
            [
                   "The damping check failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_DAMPING_CHECK_FAILED_inline",
                   "",
            ],
            [
                   "WAYPOINT_ACTION_PARAMETER_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_ACTION_PARAM_INVALID_inline",
                   "The parameter of the waypoint action is invalid.",
            ],
            [
                   "The parameter of the waypoint action is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_ACTION_PARAM_INVALID_inline",
                   "",
            ],
            [
                   "WAYPOINT_MISSION_INFO_NOT_UPLOADED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_MISSION_INFO_NOT_UPLOADED_inline",
                   "The information for the waypoint mission is not completely uploaded.",
            ],
            [
                   "The information for the waypoint mission is not completely uploaded.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_MISSION_INFO_NOT_UPLOADED_inline",
                   "",
            ],
            [
                   "WAYPOINT_UPLOAD_NOT_COMPLETE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_UPLOAD_NOT_COMPLETE_inline",
                   "The waypoint uploading is not complete.",
            ],
            [
                   "The waypoint uploading is not complete.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_UPLOAD_NOT_COMPLETE_inline",
                   "",
            ],
            [
                   "WAYPOINT_REQUEST_IS_RUNNING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_REQUEST_IS_RUNNING_inline",
                   "The waypoint mission is running.",
            ],
            [
                   "The waypoint mission is running.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_REQUEST_IS_RUNNING_inline",
                   "",
            ],
            [
                   "WAYPOINT_NOT_RUNNING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_NOT_RUNNING_inline",
                   "The waypoint mission is not running.",
            ],
            [
                   "The waypoint mission is not running.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_NOT_RUNNING_inline",
                   "",
            ],
            [
                   "WAYPOINT_IDLE_VELOCITY_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_IDLE_VELOCITY_INVALID_inline",
                   "The idle velocity is invalid.",
            ],
            [
                   "The idle velocity is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WAYPOINT_IDLE_VELOCITY_INVALID_inline",
                   "",
            ],
            [
                   "AIRCRAFT_STARTING_MOTOR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_AIRCRAFT_STARTING_MOTOR_inline",
                   "The aircraft is starting the motor.",
            ],
            [
                   "The aircraft is starting the motor.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_AIRCRAFT_STARTING_MOTOR_inline",
                   "",
            ],
            [
                   "WRONG_CMD",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WRONG_CMD_inline",
                   "The command is wrong.",
            ],
            [
                   "The command is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_WRONG_CMD_inline",
                   "",
            ],
            [
                   "POINTING_AIRCRAFT_NOT_IN_THE_AIR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_POINTING_AIRCRAFT_NOT_IN_THE_AIR_inline",
                   "The aircraft is not in the air. Please take off first.",
            ],
            [
                   "The aircraft is not in the air. Please take off first.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_POINTING_AIRCRAFT_NOT_IN_THE_AIR_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_LOW_QUALITY",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_VISION_SENSOR_LOW_QUALITY_inline",
                   "The quality of vision sensor is low.",
            ],
            [
                   "The quality of vision sensor is low.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_VISION_SENSOR_LOW_QUALITY_inline",
                   "",
            ],
            [
                   "Z30_ONLY_SUPPORT_SPOTLIGHT_PRO",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_Z30_ONLY_SUPPORT_SPOTLIGHT_PRO_inline",
                   "The camera only supports spotlight pro mode.",
            ],
            [
                   "The camera only supports spotlight pro mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_Z30_ONLY_SUPPORT_SPOTLIGHT_PRO_inline",
                   "",
            ],
            [
                   "USER_CANCEL_UPLOADING_MISSION",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_USER_CANCEL_UPLOADING_MISSION_inline",
                   "The uploading mission has been canceled by the user.",
            ],
            [
                   "The uploading mission has been canceled by the user.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_USER_CANCEL_UPLOADING_MISSION_inline",
                   "",
            ],
            [
                   "ALREADY_IN_OTHER_NAVIGATION_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_ALREADY_IN_OTHER_NAVIGATION_MODE_inline",
                   "Already in other navigation mode(such as: Go home, Landing,etc.). Please exit navigation mode to start ActiveTrack Mission.",
            ],
            [
                   "Already in other navigation mode(such as: Go home, Landing,etc.). Please exit navigation mode to start ActiveTrack Mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_ALREADY_IN_OTHER_NAVIGATION_MODE_inline",
                   "",
            ],
            [
                   "UNKNOWN_OBJECT_TARGET",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_UNKNOWN_OBJECT_TARGET_inline",
                   "Unknown object target do not support tracking. You can check `ActiveTrackTargetType` to get supported target type.",
            ],
            [
                   "Unknown object target do not support tracking. You can check `ActiveTrackTargetType` to get supported target type.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_UNKNOWN_OBJECT_TARGET_inline",
                   "",
            ],
            [
                   "AIRCRAFT_AUTO_LANDING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_AIRCRAFT_AUTO_LANDING_inline",
                   "Aircraft landing automatically. Unable to use ActiveTrack.",
            ],
            [
                   "Aircraft landing automatically. Unable to use ActiveTrack.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_AIRCRAFT_AUTO_LANDING_inline",
                   "",
            ],
            [
                   "IN_SMART_PHOTO_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_SMART_PHOTO_MODE_inline",
                   "Spotlight unavailable in SmartPhoto mode.",
            ],
            [
                   "Spotlight unavailable in SmartPhoto mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_SMART_PHOTO_MODE_inline",
                   "",
            ],
            [
                   "IN_BURST_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_BURST_MODE_inline",
                   "Spotlight unavailable in Burst mode.",
            ],
            [
                   "Spotlight unavailable in Burst mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_BURST_MODE_inline",
                   "",
            ],
            [
                   "IN_TIMED_SHOT_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_TIMED_SHOT_MODE_inline",
                   "Spotlight unavailable in Timed Shot mode.",
            ],
            [
                   "Spotlight unavailable in Timed Shot mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_TIMED_SHOT_MODE_inline",
                   "",
            ],
            [
                   "IN_AEB_SHOT_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_AEB_SHOT_MODE_inline",
                   "Spotlight unavailable in AEB Shooting mode.",
            ],
            [
                   "Spotlight unavailable in AEB Shooting mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_AEB_SHOT_MODE_inline",
                   "",
            ],
            [
                   "IN_48MP_SHOT_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_48MP_SHOT_MODE_inline",
                   "Spotlight unavailable in 48MP Shooting mode.",
            ],
            [
                   "Spotlight unavailable in 48MP Shooting mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_48MP_SHOT_MODE_inline",
                   "",
            ],
            [
                   "IN_SLOW_MOTION_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_SLOW_MOTION_MODE_inline",
                   "Spotlight unavailable in Slot Motion mode.",
            ],
            [
                   "Spotlight unavailable in Slot Motion mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_IN_SLOW_MOTION_MODE_inline",
                   "",
            ],
            [
                   "CAMERA_IS_SHOOTING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_CAMERA_IS_SHOOTING_inline",
                   "Camera is shooting, unable to use ActiveTrack.",
            ],
            [
                   "Camera is shooting, unable to use ActiveTrack.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_CAMERA_IS_SHOOTING_inline",
                   "",
            ],
            [
                   "AUTOSENSING_MUST_ENABLE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_AUTOSENSING_MUST_ENABLE_inline",
                   "AutoSensing must be enabled.",
            ],
            [
                   "AutoSensing must be enabled.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIMissionError_AUTOSENSING_MUST_ENABLE_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UNKNOWN_inline",
                   "Unknown result.",
            ],
            [
                   "Unknown result.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJIMissionManagerError_MISSION_RESULT_UNKNOWN_inline",
                   "",
            ],
            [
                   "MODE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ModeError_inline",
                   "Cannot execute in the current mode. For products and flight controller firmware versions that support 'F' mode (e.g. Phantom 3 Professional, Inspire 1, A3 with flight controller firmware version lower than 3.2.10.0, etc), please make sure the remote controller's mode switch is in 'F' mode. For the others, please make sure the remote controller's mode switch is in 'P' mode.",
            ],
            [
                   "Cannot execute in the current mode. For products and flight controller firmware versions that support 'F' mode (e.g. Phantom 3 Professional, Inspire 1, A3 with flight controller firmware version lower than 3.2.10.0, etc), please make sure the remote controller's mode switch is in 'F' mode. For the others, please make sure the remote controller's mode switch is in 'P' mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ModeError_inline",
                   "",
            ],
            [
                   "GPS_SIGNAL_WEAK",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftBadGPS_inline",
                   "The GPS signal of the aircraft is weak.",
            ],
            [
                   "The GPS signal of the aircraft is weak.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftBadGPS_inline",
                   "",
            ],
            [
                   "LOW_BATTERY",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftLowBattery_inline",
                   "Low battery level warning.",
            ],
            [
                   "Low battery level warning.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftLowBattery_inline",
                   "",
            ],
            [
                   "AIRCRAFT_NOT_IN_THE_AIR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftNotInTheAir_inline",
                   "The aircraft is not in the air.",
            ],
            [
                   "The aircraft is not in the air.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftNotInTheAir_inline",
                   "",
            ],
            [
                   "AIRCRAFT_ALTITUDE_TOO_HIGH",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftAltitudeTooHigh_inline",
                   "The aircraft's altitude is too high.",
            ],
            [
                   "The aircraft's altitude is too high.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftAltitudeTooHigh_inline",
                   "",
            ],
            [
                   "AIRCRAFT_ALTITUDE_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftAltitudeTooLow_inline",
                   "The aircraft's altitude is too low.",
            ],
            [
                   "The aircraft's altitude is too low.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftAltitudeTooLow_inline",
                   "",
            ],
            [
                   "AIRCRAFT_TAKING_OFF",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftTakingoff_inline",
                   "Aircraft is taking off.",
            ],
            [
                   "Aircraft is taking off.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftTakingoff_inline",
                   "",
            ],
            [
                   "AIRCRAFT_LANDING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftLanding_inline",
                   "Aircraft is landing.",
            ],
            [
                   "Aircraft is landing.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftLanding_inline",
                   "",
            ],
            [
                   "AIRCRAFT_GOING_HOME",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftGoingHome_inline",
                   "Aircraft is going home.",
            ],
            [
                   "Aircraft is going home.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftGoingHome_inline",
                   "",
            ],
            [
                   "HOME_POINT_NOT_RECORDED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftHomePointNotRecorded_inline",
                   "The home point of the aircraft is not recorded.",
            ],
            [
                   "The home point of the aircraft is not recorded.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftHomePointNotRecorded_inline",
                   "",
            ],
            [
                   "IN_NOVICE_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftInNoviceMode_inline",
                   "Aircraft is in novice mode.",
            ],
            [
                   "Aircraft is in novice mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftInNoviceMode_inline",
                   "",
            ],
            [
                   "AIRCRAFT_IN_NO_FLY_ZONE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftInNoFlyZone_inline",
                   "Aircraft is in a no fly zone.",
            ],
            [
                   "Aircraft is in a no fly zone.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftInNoFlyZone_inline",
                   "",
            ],
            [
                   "REACH_FLIGHT_LIMITATION",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReachFlightLimitation_inline",
                   "The aircraft has reached the flight limitation.",
            ],
            [
                   "The aircraft has reached the flight limitation.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReachFlightLimitation_inline",
                   "",
            ],
            [
                   "RUNNING_MISSION",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftRunningMission_inline",
                   "The aircraft is running a mission.",
            ],
            [
                   "The aircraft is running a mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftRunningMission_inline",
                   "",
            ],
            [
                   "TOO_CLOSE_TO_HOME_POINT",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftNearHomePoint_inline",
                   "Aircraft is too close to the home point.",
            ],
            [
                   "Aircraft is too close to the home point.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_AircraftNearHomePoint_inline",
                   "",
            ],
            [
                   "MISSION_PARAMETERS_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionParametersInvalid_inline",
                   "The parameters of the mission are invalid.",
            ],
            [
                   "The parameters of the mission are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionParametersInvalid_inline",
                   "",
            ],
            [
                   "MISSION_RESUME_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionResumeFailed_inline",
                   "Mission resume failed.",
            ],
            [
                   "Mission resume failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionResumeFailed_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_LOST",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetLost_inline",
                   "The tracking target is lost.",
            ],
            [
                   "The tracking target is lost.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetLost_inline",
                   "",
            ],
            [
                   "NO_VIDEO_FEED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_NoVideoFeed_inline",
                   "No live video feed is captured for the ActiveTrack Mission.",
            ],
            [
                   "No live video feed is captured for the ActiveTrack Mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_NoVideoFeed_inline",
                   "",
            ],
            [
                   "VIDEO_FRAME_RATE_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VideoFrameRateTooLow_inline",
                   "The frame rate of the live video feed is too low.",
            ],
            [
                   "The frame rate of the live video feed is too low.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VideoFrameRateTooLow_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_NOT_AUTHORIZED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemNotAuthorized_inline",
                   "The vision system cannot get the authorization to control the aircraft.",
            ],
            [
                   "The vision system cannot get the authorization to control the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemNotAuthorized_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemError_inline",
                   "The vision system encounters system error.",
            ],
            [
                   "The vision system encounters system error.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemError_inline",
                   "",
            ],
            [
                   "CANNOT_BYPASS_OBSTACLE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_CannotBypassObstacle_inline",
                   "The aircraft cannot bypass the obstacle.",
            ],
            [
                   "The aircraft cannot bypass the obstacle.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_CannotBypassObstacle_inline",
                   "",
            ],
            [
                   "STOPPED_BY_USER",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_StoppedByUser_inline",
                   "Mission was stopped by the user.",
            ],
            [
                   "Mission was stopped by the user.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_StoppedByUser_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_NEEDS_CALIBRATION",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemNeedCalibration_inline",
                   "The vision system requires calibration.",
            ],
            [
                   "The vision system requires calibration.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSystemNeedCalibration_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_OVEREXPOSED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSensorOverexposed_inline",
                   "The vision sensors are overexposed.",
            ],
            [
                   "The vision sensors are overexposed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSensorOverexposed_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_UNDEREXPOSED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSensorUnderexposed_inline",
                   "The vision sensors are underexposed.",
            ],
            [
                   "The vision sensors are underexposed.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionSensorUnderexposed_inline",
                   "",
            ],
            [
                   "VISION_DATA_ABNORMAL",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionDataAbnormal_inline",
                   "The data from the vision system is abnormal.",
            ],
            [
                   "The data from the vision system is abnormal.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_VisionDataAbnormal_inline",
                   "",
            ],
            [
                   "FEATURE_POINT_CANNOT_MATCH",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_FeaturePointCannotMatch_inline",
                   "The feature points found by both vision sensors cannot match.",
            ],
            [
                   "The feature points found by both vision sensors cannot match.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_FeaturePointCannotMatch_inline",
                   "",
            ],
            [
                   "TRACKING_RECT_TOO_SMALL",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingRectTooSmall_inline",
                   "The tracking rectangle is too small.",
            ],
            [
                   "The tracking rectangle is too small.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingRectTooSmall_inline",
                   "",
            ],
            [
                   "TRACKING_RECT_TOO_LARGE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingRectTooLarge_inline",
                   "The tracking rectangle is too large.",
            ],
            [
                   "The tracking rectangle is too large.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingRectTooLarge_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_NOT_ENOUGH_FEATURES",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetNotEnoughFeature_inline",
                   "The tracking target doesn't have enough features to lock onto.",
            ],
            [
                   "The tracking target doesn't have enough features to lock onto.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetNotEnoughFeature_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_TOO_CLOSE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooClose_inline",
                   "The Tracking target is too close to the aircraft.",
            ],
            [
                   "The Tracking target is too close to the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooClose_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_TOO_FAR",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooFar_inline",
                   "The tracking target is too far away from the aircraft.",
            ],
            [
                   "The tracking target is too far away from the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooFar_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_TOO_HIGH",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooHigh_inline",
                   "The tracking target is too high.",
            ],
            [
                   "The tracking target is too high.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetTooHigh_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_SHAKING",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetShaking_inline",
                   "The tracking target is shaking too much.",
            ],
            [
                   "The tracking target is shaking too much.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetShaking_inline",
                   "",
            ],
            [
                   "TRACKING_TARGET_LOW_CONFIDENCE",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetLowConfidence_inline",
                   "The ActiveTrack mission is too unsure the tracking object and confirmation is required.",
            ],
            [
                   "The ActiveTrack mission is too unsure the tracking object and confirmation is required.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_TrackingTargetLowConfidence_inline",
                   "",
            ],
            [
                   "TRACKING_PAUSED_BY_USER",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionPausedByUser_inline",
                   "Mission is paused by user.",
            ],
            [
                   "Mission is paused by user.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_MissionPausedByUser_inline",
                   "",
            ],
            [
                   "TRACKING_GIMBAL_PITCH_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_GimbalPitchTooLow_inline",
                   "Gimbal pitch is too low.",
            ],
            [
                   "Gimbal pitch is too low.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_GimbalPitchTooLow_inline",
                   "",
            ],
            [
                   "TRACKING_OBSTACLE_DETECTED",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleDetected_inline",
                   "Encounter an obstacle.",
            ],
            [
                   "Encounter an obstacle.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ObstacleDetected_inline",
                   "",
            ],
            [
                   "REACH_ALTITUDE_LOWER_BOUND",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReachAltitudeLowerBound_inline",
                   "The aircraft reaches the altitude lower bound of the TapFly Mission.",
            ],
            [
                   "The aircraft reaches the altitude lower bound of the TapFly Mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "#DJIError_DJISDKMissionError_ReachAltitudeLowerBound_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_getDJIError_inline",
                   "Returns the specific error in DJIFlightControllerError according to the error code.  @param ccode Error code.  @return The DJIError object.",
            ],
            [
                   "Returns the specific error in DJIFlightControllerError according to the error code.  @param ccode Error code.  @return The DJIError object.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_getDJIError_inline",
                   "",
            ],
            [
                   "NOT_LOGGED_IN",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_NOT_LOGGED_IN_inline",
                   "No user is logged in.",
            ],
            [
                   "No user is logged in.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_NOT_LOGGED_IN_inline",
                   "",
            ],
            [
                   "FAIL_TO_ENTER_TRANSPORT_MODE_WHEN_MOTORS_ON",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_FAIL_TO_ENTER_TRANSPORT_MODE_WHEN_MOTORS_ON_inline",
                   "When the motors are on, the aircraft could not get into transport mode.",
            ],
            [
                   "When the motors are on, the aircraft could not get into transport mode.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_FAIL_TO_ENTER_TRANSPORT_MODE_WHEN_MOTORS_ON_inline",
                   "",
            ],
            [
                   "IMU_CALIBRATION_ERROR_IN_THE_AIR_OR_MOTORS_ON",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_IMU_CALIBRATION_ERROR_IN_THE_AIR_OR_MOTORS_ON_inline",
                   "IMU calibration is not allowed if the aircraft's motors are on or the aircraft is in the air.",
            ],
            [
                   "IMU calibration is not allowed if the aircraft's motors are on or the aircraft is in the air.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_IMU_CALIBRATION_ERROR_IN_THE_AIR_OR_MOTORS_ON_inline",
                   "",
            ],
            [
                   "INVALID_PARAMETER",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_FLIGHT_CONTROLLER_INVALID_PARAMETER_inline",
                   "The parameter is not a valid value.",
            ],
            [
                   "The parameter is not a valid value.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJIFlightControllerError_FLIGHT_CONTROLLER_INVALID_PARAMETER_inline",
                   "",
            ],
            [
                   "GPS_SIGNAL_WEAK",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_BadGPS_inline",
                   "GPS level is not high enough to allow flight controller to obtain accurate location.",
            ],
            [
                   "GPS level is not high enough to allow flight controller to obtain accurate location.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_BadGPS_inline",
                   "",
            ],
            [
                   "COULD_NOT_ENTER_TRANSPORT_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GimbalNotRemoved_inline",
                   "Aircraft could not enter transport mode, since the gimbal is still connected.",
            ],
            [
                   "Aircraft could not enter transport mode, since the gimbal is still connected.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GimbalNotRemoved_inline",
                   "",
            ],
            [
                   "CANNOT_TURN_OFF_MOTORS_WHILE_AIRCRAFT_FLYING",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_AircraftFlying_inline",
                   "The aircraft is flying. For safety consideration, the motors could not be shut down.",
            ],
            [
                   "The aircraft is flying. For safety consideration, the motors could not be shut down.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_AircraftFlying_inline",
                   "",
            ],
            [
                   "HOME_POINT_TOO_FAR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_HomePointTooFar_inline",
                   "The new home point is too far.",
            ],
            [
                   "The new home point is too far.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_HomePointTooFar_inline",
                   "",
            ],
            [
                   "GO_HOME_ALTITUDE_TOO_LOW",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeTooLow_inline",
                   "The new home altitude is too low. (Lower than 20m).",
            ],
            [
                   "The new home altitude is too low. (Lower than 20m).",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeTooLow_inline",
                   "",
            ],
            [
                   "GO_HOME_ALTITUDE_TOO_HIGH",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeTooHigh_inline",
                   "The new home altitude is too high. (higher than 500m).",
            ],
            [
                   "The new home altitude is too high. (higher than 500m).",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeTooHigh_inline",
                   "",
            ],
            [
                   "GO_HOME_ALTITUDE_HIGHER_THAN_MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeHigherThanMaxFlightHeight_inline",
                   "The go home altitude is too high (higher than max flight height).",
            ],
            [
                   "The go home altitude is too high (higher than max flight height).",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GoHomeAltitudeHigherThanMaxFlightHeight_inline",
                   "",
            ],
            [
                   "RTK_CANNOT_START",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKStartError_inline",
                   "RTK cannot start properly. Please reboot.",
            ],
            [
                   "RTK cannot start properly. Please reboot.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKStartError_inline",
                   "",
            ],
            [
                   "RTK_CONNECTION_BROKEN",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKConnectionBroken_inline",
                   "Connection between base station and mobile station is broken.",
            ],
            [
                   "Connection between base station and mobile station is broken.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKConnectionBroken_inline",
                   "",
            ],
            [
                   "RTK_BS_ANTENNA_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBSAntennaError_inline",
                   "RTK base station antenna error. Check if the antenna is connected to the correct port.",
            ],
            [
                   "RTK base station antenna error. Check if the antenna is connected to the correct port.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBSAntennaError_inline",
                   "",
            ],
            [
                   "RTK_BS_COORDINATE_RESET",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBSCoordinatesReset_inline",
                   "RTK base station's coordinate resets.",
            ],
            [
                   "RTK base station's coordinate resets.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBSCoordinatesReset_inline",
                   "",
            ],
            [
                   "BASE_STATION_NOT_ACTIVATED",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemNotActivated_inline",
                   "The base station isn't activated.",
            ],
            [
                   "The base station isn't activated.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemNotActivated_inline",
                   "",
            ],
            [
                   "BASE_STATION_IS_MOVED",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemIsMoved_inline",
                   "The base station is moved. Land the aircraft to re-establish the connection to the ground station.",
            ],
            [
                   "The base station is moved. Land the aircraft to re-establish the connection to the ground station.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemIsMoved_inline",
                   "",
            ],
            [
                   "BASE_STATION_FELL",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemFell_inline",
                   "The base station fell. Land the aircraft to re-establish the connection to the base station.",
            ],
            [
                   "The base station fell. Land the aircraft to re-establish the connection to the base station.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GroundSystemFell_inline",
                   "",
            ],
            [
                   "NAVIGATION_SATELLITE_SYSTEM_CAN_NOT_SET",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_NavigationSatelliteSystemCanNotSet_inline",
                   "The selection of navigation satellite system is only supported when the RTK function is turned off, and cannot be modified in the air.",
            ],
            [
                   "The selection of navigation satellite system is only supported when the RTK function is turned off, and cannot be modified in the air.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_NavigationSatelliteSystemCanNotSet_inline",
                   "",
            ],
            [
                   "BASE_STATION_PARAMETER_NUMBER_NOT_MATCH",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBaseStationParameterNumberNotMatch_inline",
                   "Base station internal error. Parameter numbers do not match. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
            ],
            [
                   "Base station internal error. Parameter numbers do not match. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBaseStationParameterNumberNotMatch_inline",
                   "",
            ],
            [
                   "BASE_STATION_PARAMETER_LENGTH_NOT_MATCH",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBaseStationParameterLengthNotMatch_inline",
                   "Base station internal error. Parameters' length do not match. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
            ],
            [
                   "Base station internal error. Parameters' length do not match. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBaseStationParameterLengthNotMatch_inline",
                   "",
            ],
            [
                   "BASE_STATION_PARAMETER_READ_ONLY",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationParameterReadOnly_inline",
                   "Base station internal error. Parameters read only. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
            ],
            [
                   "Base station internal error. Parameters read only. Please contact <https://djisdksupport.zendesk.com/hc/requests/new>.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationParameterReadOnly_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_NOT_FLYING",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCenterCalibrationNotFlying_inline",
                   "The aircraft cannot start the gravity center calibration because it is not flying.",
            ],
            [
                   "The aircraft cannot start the gravity center calibration because it is not flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCenterCalibrationNotFlying_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_NOT_FLYING_NOT_WORK_IN_SIMULATOR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCenterCalibrationCanNotWorkInSimulator_inline",
                   "The aircraft cannot start the gravity center calibration because the simulator starts.",
            ],
            [
                   "The aircraft cannot start the gravity center calibration because the simulator starts.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCenterCalibrationCanNotWorkInSimulator_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_IS_RUNNING",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationIsRunning_inline",
                   "The aircraft cannot start the gravity center calibration before the previous calibration finishes.",
            ],
            [
                   "The aircraft cannot start the gravity center calibration before the previous calibration finishes.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationIsRunning_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_NOT_HOVERING",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationNotHovering_inline",
                   "The aircraft cannot start the gravity center calibration because it is not hovering.",
            ],
            [
                   "The aircraft cannot start the gravity center calibration because it is not hovering.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationNotHovering_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_STOPPED_BY_USER",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationStoppedByUser_inline",
                   "The gravity center calibration is stopped by the user.",
            ],
            [
                   "The gravity center calibration is stopped by the user.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationStoppedByUser_inline",
                   "",
            ],
            [
                   "GRAVITY_CENTER_CALIBRATION_FAILED_IN_BIG_WIND",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationFailedInBigWind_inline",
                   "The gravity center calibration is interrupted because the wind is too strong.",
            ],
            [
                   "The gravity center calibration is interrupted because the wind is too strong.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_GravityCalibrationFailedInBigWind_inline",
                   "",
            ],
            [
                   "OWNER_OFFLINE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_OwnerOfflineError_inline",
                   "Owner offline error.",
            ],
            [
                   "Owner offline error.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_OwnerOfflineError_inline",
                   "",
            ],
            [
                   "DEVICE_LOCKED_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_DeviceLockedError_inline",
                   "Device locked error.",
            ],
            [
                   "Device locked error.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_DeviceLockedError_inline",
                   "",
            ],
            [
                   "OWNER_OUT_CONTROL_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_OwnerOutControlError_inline",
                   "Owner out control error.",
            ],
            [
                   "Owner out control error.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_OwnerOutControlError_inline",
                   "",
            ],
            [
                   "COMMAND_NOT_SUPPORTED_BY_CURRENT_ATTITUDE",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_CannotBeExecutedWithCurrentAttitude_inline",
                   "The command cannot be executed with the current attitude.",
            ],
            [
                   "The command cannot be executed with the current attitude.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_CannotBeExecutedWithCurrentAttitude_inline",
                   "",
            ],
            [
                   "BASE_STATION_NEED_LOGIN",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationNeedLogin_inline",
                   "For Matrice 300 RTK, you must login before you can set name, or use `setBaseStationReferencingLocation` etc.",
            ],
            [
                   "For Matrice 300 RTK, you must login before you can set name, or use `setBaseStationReferencingLocation` etc.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationNeedLogin_inline",
                   "",
            ],
            [
                   "CANNOT_BASE_STATION_SCAN_IN_FLYING",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_CannotBaseStationScanInFlying_inline",
                   "For Matrice 300 RTK, you cannot scan fro a base station while flying.",
            ],
            [
                   "For Matrice 300 RTK, you cannot scan fro a base station while flying.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_CannotBaseStationScanInFlying_inline",
                   "",
            ],
            [
                   "BASE_STATION_PASSWORD_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationPasswordInvalid_inline",
                   "Base station administrator account password is invalid. Please login again. If you reset your password, please use the default password.",
            ],
            [
                   "Base station administrator account password is invalid. Please login again. If you reset your password, please use the default password.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "#DJIError_DJISDKFlightControllerError_RTKBasestationPasswordInvalid_inline",
                   "",
            ],
            [
                   "FEATURE_NOT_SUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SDKFeatureNotSupported_inline",
                   "Feature not supported error.",
            ],
            [
                   "Feature not supported error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SDKFeatureNotSupported_inline",
                   "",
            ],
            [
                   "APPLICATION_NOT_ACTIVATED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ApplicationNotActivated_inline",
                   "Application not activated error.",
            ],
            [
                   "Application not activated error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ApplicationNotActivated_inline",
                   "",
            ],
            [
                   "SYSTEM_BUSY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SystemBusy_inline",
                   "System busy error.",
            ],
            [
                   "System busy error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SystemBusy_inline",
                   "",
            ],
            [
                   "INVALID_PARAMETERS",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_InvalidParameters_inline",
                   "Parameters invalid error.",
            ],
            [
                   "Parameters invalid error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_InvalidParameters_inline",
                   "",
            ],
            [
                   "PARAMETER_GET_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ParameterGetFailed_inline",
                   "Get parameter failed error.",
            ],
            [
                   "Get parameter failed error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ParameterGetFailed_inline",
                   "",
            ],
            [
                   "PARAMETER_SET_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ParameterSetFailed_inline",
                   "Setting parameters operation failed.",
            ],
            [
                   "Setting parameters operation failed.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ParameterSetFailed_inline",
                   "",
            ],
            [
                   "COMMAND_EXECUTION_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_CommandExecutionFailed_inline",
                   "Command execute failed error.",
            ],
            [
                   "Command execute failed error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_CommandExecutionFailed_inline",
                   "",
            ],
            [
                   "SEND_DATA_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SendDataFailed_inline",
                   "Send data failed error.",
            ],
            [
                   "Send data failed error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_SendDataFailed_inline",
                   "",
            ],
            [
                   "CONNECTION_TO_SDK_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ConnectionToSDKFailed_inline",
                   "Connection to SDK failed error.",
            ],
            [
                   "Connection to SDK failed error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_ConnectionToSDKFailed_inline",
                   "",
            ],
            [
                   "DEVICE_NOT_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_DeviceNotFound_inline",
                   "Device not found.",
            ],
            [
                   "Device not found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_DeviceNotFound_inline",
                   "",
            ],
            [
                   "NOT_DEFINED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_NotDefined_inline",
                   "Not defined error.",
            ],
            [
                   "Not defined error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_NotDefined_inline",
                   "",
            ],
            [
                   "COULD_NOT_CONNECT_TO_INTERNET",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ErrorCouldNotConnectToInternet_inline",
                   "The application is not able to connect to the Internet the first time it tries to register the API Key.",
            ],
            [
                   "The application is not able to connect to the Internet the first time it tries to register the API Key.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ErrorCouldNotConnectToInternet_inline",
                   "",
            ],
            [
                   "INVALID_APP_KEY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidAppKey_inline",
                   "The application key you provided is incorrect.",
            ],
            [
                   "The application key you provided is incorrect.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidAppKey_inline",
                   "",
            ],
            [
                   "HTTP_TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_HTTPTimeout_inline",
                   "The network you are trying to reach is busy, or the server is unreachable.",
            ],
            [
                   "The network you are trying to reach is busy, or the server is unreachable.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_HTTPTimeout_inline",
                   "",
            ],
            [
                   "DEVICE_NOT_MATCH",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_DeviceDoesNotMatch_inline",
                   "The attempt to copy metadata from another registered device to a device that is currently connected is not permitted. For example, if a developer has two devices and the application is activated with the app key on one of the devices and if the other device is plugged in and tries to register the application, this error will occur.",
            ],
            [
                   "The attempt to copy metadata from another registered device to a device that is currently connected is not permitted. For example, if a developer has two devices and the application is activated with the app key on one of the devices and if the other device is plugged in and tries to register the application, this error will occur.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_DeviceDoesNotMatch_inline",
                   "",
            ],
            [
                   "BUNDLE_NOT_MATCH",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_BundleIdDoesNotMatch_inline",
                   "The bundle identifier of your application does not match the bundle identifier you registered on the developer website when you applied to obtain an application key.",
            ],
            [
                   "The bundle identifier of your application does not match the bundle identifier you registered on the developer website when you applied to obtain an application key.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_BundleIdDoesNotMatch_inline",
                   "",
            ],
            [
                   "APP_KEY_PROHIBITED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyProhibited_inline",
                   "The application key is prohibited. This occurs when an application key that has already been released by DJI is revoked. Please contact DJI for assistance.",
            ],
            [
                   "The application key is prohibited. This occurs when an application key that has already been released by DJI is revoked. Please contact DJI for assistance.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyProhibited_inline",
                   "",
            ],
            [
                   "MAX_ACTIVATION_COUNT_REACHED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_MaxActivationCountReached_inline",
                   "There is a maximum number of devices one application key can be used to activate. The maximum number of devices is given when an application is registered on the DJI developer website. This error will occur if the maximum number of activations has been reached.",
            ],
            [
                   "There is a maximum number of devices one application key can be used to activate. The maximum number of devices is given when an application is registered on the DJI developer website. This error will occur if the maximum number of activations has been reached.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_MaxActivationCountReached_inline",
                   "",
            ],
            [
                   "APP_KEY_INVALID_PLATFORM",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyInvalidPlatformError_inline",
                   "This error occurs when an application key was given for a specific platform and is trying to be used to activate an application for another platform. For instance, if an application key was given for an iOS application and is used to activate an Android application, this error will occur.",
            ],
            [
                   "This error occurs when an application key was given for a specific platform and is trying to be used to activate an application for another platform. For instance, if an application key was given for an iOS application and is used to activate an Android application, this error will occur.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyInvalidPlatformError_inline",
                   "",
            ],
            [
                   "APP_KEY_NOT_EXIST",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyDoesNotExist_inline",
                   "The application key does not exist. Please make sure the application key you are entering is correct.",
            ],
            [
                   "The application key does not exist. Please make sure the application key you are entering is correct.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyDoesNotExist_inline",
                   "",
            ],
            [
                   "APP_KEY_LEVEL_NOT_PERMITTED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyLevelNotPermitted_inline",
                   "There are two levels for the SDK framework, level 1 and level 2. If an application key was given under one level and is trying to be used to active an application using another level SDK framework, this error will occur.",
            ],
            [
                   "There are two levels for the SDK framework, level 1 and level 2. If an application key was given under one level and is trying to be used to active an application using another level SDK framework, this error will occur.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyLevelNotPermitted_inline",
                   "",
            ],
            [
                   "SERVER_PARSE_FAILURE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerParseFailure_inline",
                   "There is a server error. Please contact DJI for assistance.",
            ],
            [
                   "There is a server error. Please contact DJI for assistance.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerParseFailure_inline",
                   "",
            ],
            [
                   "SERVER_WRITE_FAILURE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerWriteError_inline",
                   "There is a server error. Please contact DJI for assistance.",
            ],
            [
                   "There is a server error. Please contact DJI for assistance.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerWriteError_inline",
                   "",
            ],
            [
                   "SERVER_DATA_ABNORMAL",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerDataAbnormal_inline",
                   "There is a server error. Please contact DJI for assistance.",
            ],
            [
                   "There is a server error. Please contact DJI for assistance.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ServerDataAbnormal_inline",
                   "",
            ],
            [
                   "INVALID_METADATA",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidMetaData_inline",
                   "The activation data received from server is invalid. Please reconnect to the internet and try again.",
            ],
            [
                   "The activation data received from server is invalid. Please reconnect to the internet and try again.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidMetaData_inline",
                   "",
            ],
            [
                   "EMPTY_APP_KEY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_EmptyAppKey_inline",
                   "No application key was provided.",
            ],
            [
                   "No application key was provided.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_EmptyAppKey_inline",
                   "",
            ],
            [
                   "OVER_MAX_ACTIVATIONS_COUNT",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_OverMaxActivationsCount_inline",
                   "Applications under basic develop account could only have the maximum of 20 unique activations. Visit DJI developer center <https://developer.dji.com/user/membership/> to upgrade the membership.",
            ],
            [
                   "Applications under basic develop account could only have the maximum of 20 unique activations. Visit DJI developer center <https://developer.dji.com/user/membership/> to upgrade the membership.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_OverMaxActivationsCount_inline",
                   "",
            ],
            [
                   "APP_KEY_NOT_ENROLLED_BY_BETA_SDK",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyNotEnrolledByBataSDK_inline",
                   "The application is not enrolled in the Beta Program. Use an app key under the Beta Program instead.",
            ],
            [
                   "The application is not enrolled in the Beta Program. Use an app key under the Beta Program instead.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyNotEnrolledByBataSDK_inline",
                   "",
            ],
            [
                   "INVALID_APP_KEY_FOR_BETA_VERSION",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidAppKeyForBetaVersion_inline",
                   "The app key is invalid for this beta version.",
            ],
            [
                   "The app key is invalid for this beta version.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_InvalidAppKeyForBetaVersion_inline",
                   "",
            ],
            [
                   "DOWNLOAD_FLYSAFE_DATABASE_FAILED_WITH_LDM_ON",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_DownloadFlySafeDatabaseFailedWithLDMModeOn_inline",
                   "Download flysafe database failed. You can close LDM model to retry register App or implementation FlySafeDataBase-release.aar in your app build.gradle before compile it.",
            ],
            [
                   "Download flysafe database failed. You can close LDM model to retry register App or implementation FlySafeDataBase-release.aar in your app build.gradle before compile it.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_DownloadFlySafeDatabaseFailedWithLDMModeOn_inline",
                   "",
            ],
            [
                   "SDK_VERSION_BLOCKED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_SDKVersionBlocked_inline",
                   "SDK Version is blocked.",
            ],
            [
                   "SDK Version is blocked.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_SDKVersionBlocked_inline",
                   "",
            ],
            [
                   "ACTIVATE_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ActivateFailed_inline",
                   "App activation failed.",
            ],
            [
                   "App activation failed.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_ActivateFailed_inline",
                   "",
            ],
            [
                   "APP_KEY_BLOCKED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyBlocked_inline",
                   "App key is blocked.",
            ],
            [
                   "App key is blocked.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_AppKeyBlocked_inline",
                   "",
            ],
            [
                   "CAN_NOT_EXECUTE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_CAN_NOT_EXECUTE_inline",
                   "The operation can't be executed in current state.",
            ],
            [
                   "The operation can't be executed in current state.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_CAN_NOT_EXECUTE_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_Unknown_inline",
                   "An unknown error occurred when the application was trying to register. Please contact DJI for assistance.",
            ],
            [
                   "An unknown error occurred when the application was trying to register. Please contact DJI for assistance.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKRegistrationError_Unknown_inline",
                   "",
            ],
            [
                   "KEY_UNSUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_KEY_UNSUPPORTED_inline",
                   "The key is not supported.",
            ],
            [
                   "The key is not supported.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_KEY_UNSUPPORTED_inline",
                   "",
            ],
            [
                   "INVALID_VALUE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_INVALID_VALUE_inline",
                   "Invalid parameters.  This error will be returned when the sent parameters are invalid.",
            ],
            [
                   "Invalid parameters.  This error will be returned when the sent parameters are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_INVALID_VALUE_inline",
                   "",
            ],
            [
                   "INVALID_KEY_FORMAT",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_InvalidKeyFormat_inline",
                   "The key does not match the format: component/index/key with index being a number or *.",
            ],
            [
                   "The key does not match the format: component/index/key with index being a number or *.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_InvalidKeyFormat_inline",
                   "",
            ],
            [
                   "INVALID_KEY_FOR_COMPONENT",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_InvalidKeyForComponent_inline",
                   "The key does not exist in component abstraction.",
            ],
            [
                   "The key does not exist in component abstraction.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_InvalidKeyForComponent_inline",
                   "",
            ],
            [
                   "NO_GET_FOR_KEY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoGetForKey_inline",
                   "The key is not gettable.",
            ],
            [
                   "The key is not gettable.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoGetForKey_inline",
                   "",
            ],
            [
                   "NO_SET_FOR_KEY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoSetForKey_inline",
                   "The key is not settable.",
            ],
            [
                   "The key is not settable.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoSetForKey_inline",
                   "",
            ],
            [
                   "UNKNOWN_ACCESS_TYPE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_UnknowAccessType_inline",
                   "The access type requested for the key is unknown. This is an implementation error in the cache as only valid types should be exposed to the public interface.",
            ],
            [
                   "The access type requested for the key is unknown. This is an implementation error in the cache as only valid types should be exposed to the public interface.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_UnknowAccessType_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_Disconnected_inline",
                   "The abstraction is no longer connected to real hardware.",
            ],
            [
                   "The abstraction is no longer connected to real hardware.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_Disconnected_inline",
                   "",
            ],
            [
                   "NO_STORAGE_ACCESS",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoStorageAccess_inline",
                   "Can not access to component storage.",
            ],
            [
                   "Can not access to component storage.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoStorageAccess_inline",
                   "",
            ],
            [
                   "NO_ACTION_FOR_KEY",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoActionForKey_inline",
                   "The key is not actionable.",
            ],
            [
                   "The key is not actionable.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_NoActionForKey_inline",
                   "",
            ],
            [
                   "SETTER_VALUE_TYPE_MISMATCH",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_SetterValueTypeMismatch_inline",
                   "The key does not match the format: component/index/key with index being a number of *.",
            ],
            [
                   "The key does not match the format: component/index/key with index being a number of *.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "#DJIError_DJISDKCacheError_ErrorEnum_SetterValueTypeMismatch_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_getDJIErrorConstructor1_inline",
                   "Constructor Method 1.  @param ccode Error code.  @return The DJIError object.",
            ],
            [
                   "Constructor Method 1.  @param ccode Error code.  @return The DJIError object.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_getDJIErrorConstructor1_inline",
                   "",
            ],
            [
                   "UNKNOWN_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_COMMON_CAMERA_UNKNOWN_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_COMMON_CAMERA_UNKNOWN_inline",
                   "",
            ],
            [
                   "CHECK_PERMISSION_LEVEL1_IS_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CHECK_PERMISSION_LEVEL1_IS_INVALID_inline",
                   "Level 1 API permission is invalid. This error indicates that the API Key's level 1 permission is invalid.",
            ],
            [
                   "Level 1 API permission is invalid. This error indicates that the API Key's level 1 permission is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CHECK_PERMISSION_LEVEL1_IS_INVALID_inline",
                   "",
            ],
            [
                   "MEDIA_INVALID_REQUEST_TYPE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_INVALID_REQUEST_TYPE_inline",
                   "Result of media downloading request type is invalid.",
            ],
            [
                   "Result of media downloading request type is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_INVALID_REQUEST_TYPE_inline",
                   "",
            ],
            [
                   "MEDIA_NO_SUBMEDIA_FILES",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_NO_SUBMEDIA_FILES_inline",
                   "No sub media files.",
            ],
            [
                   "No sub media files.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_NO_SUBMEDIA_FILES_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_CLIENT_ABORT",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_CLIENT_ABORT_inline",
                   "Result of media downloading: the client aborted the download.",
            ],
            [
                   "Result of media downloading: the client aborted the download.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_CLIENT_ABORT_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_SERVER_ABORT",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_SERVER_ABORT_inline",
                   "Result of media downloading: the server aborted the download.",
            ],
            [
                   "Result of media downloading: the server aborted the download.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_SERVER_ABORT_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_DISCONNECT",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_DISCONNECT_inline",
                   "Result of media downloading: the download link disconnected.",
            ],
            [
                   "Result of media downloading: the download link disconnected.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_MEDIA_REQUEST_DISCONNECT_inline",
                   "",
            ],
            [
                   "COULD_NOT_DELETE_ALL_FILES",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_COULD_NOT_DELETE_ALL_FILES_inline",
                   "Could not delete all files.",
            ],
            [
                   "Could not delete all files.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_COULD_NOT_DELETE_ALL_FILES_inline",
                   "",
            ],
            [
                   "CANNOT_SET_PARAMETERS_IN_THIS_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "Cannot set the parameters in this state.",
            ],
            [
                   "Cannot set the parameters in this state.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "",
            ],
            [
                   "CANNOT_SHOOT_PHOTO_WHEN_NOT_FLY",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CANNOT_SHOOT_PHOTO_WHEN_NOT_FLY_inline",
                   "Cannot take panorama photo when aircraft is not flying.",
            ],
            [
                   "Cannot take panorama photo when aircraft is not flying.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CANNOT_SHOOT_PHOTO_WHEN_NOT_FLY_inline",
                   "",
            ],
            [
                   "GET_REMOTE_MEDIA_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_GET_REMOTE_MEDIA_FAILED_inline",
                   "Failed to get remote media data.",
            ],
            [
                   "Failed to get remote media data.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_GET_REMOTE_MEDIA_FAILED_inline",
                   "",
            ],
            [
                   "GET_THUMBNAIL_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_GET_THUMBNAIL_FAILED_inline",
                   "Get thumbnail picture failed.",
            ],
            [
                   "Get thumbnail picture failed.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_GET_THUMBNAIL_FAILED_inline",
                   "",
            ],
            [
                   "NOT_CONNECTED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_CONNECTION_NOT_OK_inline",
                   "Camera connection isn't ok.",
            ],
            [
                   "Camera connection isn't ok.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_CONNECTION_NOT_OK_inline",
                   "",
            ],
            [
                   "EXEC_TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_EXEC_TIMEOUT_inline",
                   "The camera action executed a timeout.",
            ],
            [
                   "The camera action executed a timeout.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_EXEC_TIMEOUT_inline",
                   "",
            ],
            [
                   "INVALID_PARAMETERS",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_INVALID_PARAM_inline",
                   "Camera invalid parameters.  This error will be returned when the sent parameters are invalid.",
            ],
            [
                   "Camera invalid parameters.  This error will be returned when the sent parameters are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_INVALID_PARAM_inline",
                   "",
            ],
            [
                   "UNSUPPORTED_CMD_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_UNSUPPORTED_CMD_STATE_inline",
                   "The camera does not support the command in the current state.  This error is returned when the camera is busy and the camera is unsupported for the command in the current state.",
            ],
            [
                   "The camera does not support the command in the current state.  This error is returned when the camera is busy and the camera is unsupported for the command in the current state.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_UNSUPPORTED_CMD_STATE_inline",
                   "",
            ],
            [
                   "DIGITAL_ZOOM_NOT_SUPPORTED_RESOLUTION",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_DIGITAL_ZOOM_NOT_SUPPORTED_RESOLUTION_inline",
                   "Failed to set digital zoom, because the resolution is over 4K.",
            ],
            [
                   "Failed to set digital zoom, because the resolution is over 4K.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_DIGITAL_ZOOM_NOT_SUPPORTED_RESOLUTION_inline",
                   "",
            ],
            [
                   "DIGITAL_ZOOM_NOT_SUPPORTED_VIEW_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_DIGITAL_ZOOM_NOT_SUPPORTED_VIEW_MODE_inline",
                   "Failed to set digital zoom, because app is in full view mode.",
            ],
            [
                   "Failed to set digital zoom, because app is in full view mode.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_DIGITAL_ZOOM_NOT_SUPPORTED_VIEW_MODE_inline",
                   "",
            ],
            [
                   "PARAMETERS_SET_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_SET_FAILED_inline",
                   "Failed to set the parameters.  This error will be returned when setting the camera parameters fails.",
            ],
            [
                   "Failed to set the parameters.  This error will be returned when setting the camera parameters fails.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_SET_FAILED_inline",
                   "",
            ],
            [
                   "PARAMETERS_GET_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_GET_FAILED_inline",
                   "Failed to get the parameters.  This error will be returned when getting the camera parameters fails.",
            ],
            [
                   "Failed to get the parameters.  This error will be returned when getting the camera parameters fails.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_GET_FAILED_inline",
                   "",
            ],
            [
                   "PARAMETERS_NOT_AVAILABLE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_NOT_AVAILABLE_inline",
                   "The parameters are not available.  This error will be returned when there are some errors with the parameters submitted to the camera.",
            ],
            [
                   "The parameters are not available.  This error will be returned when there are some errors with the parameters submitted to the camera.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_PARAMETERS_NOT_AVAILABLE_inline",
                   "",
            ],
            [
                   "MEDIA_FILE_RESET",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_MEDIA_FILE_RESET_inline",
                   "Media file is reset. The operation can be executed.",
            ],
            [
                   "Media file is reset. The operation can be executed.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CAMERA_MEDIA_FILE_RESET_inline",
                   "",
            ],
            [
                   "CUSTOM_INFO_LENGTH_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CUSTOM_INFO_LENGTH_ERROR_inline",
                   "Custom info should not be null and no more than 32 bytes.",
            ],
            [
                   "Custom info should not be null and no more than 32 bytes.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CUSTOM_INFO_LENGTH_ERROR_inline",
                   "",
            ],
            [
                   "CANNOT_SET_PARAMETERS_IN_SUPER_RESOLUTION_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CANNOT_SET_PARAMETERS_IN_SUPER_RESOLUTION_STATE_inline",
                   "Cannot set the parameters in Super Resolution state.",
            ],
            [
                   "Cannot set the parameters in Super Resolution state.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJICameraError_CANNOT_SET_PARAMETERS_IN_SUPER_RESOLUTION_STATE_inline",
                   "",
            ],
            [
                   "SD_CARD_NOT_INSERTED",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardNotInserted_inline",
                   "No SD card.",
            ],
            [
                   "No SD card.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardNotInserted_inline",
                   "",
            ],
            [
                   "SD_CARD_FULL",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardFull_inline",
                   "SD card full.",
            ],
            [
                   "SD card full.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardFull_inline",
                   "",
            ],
            [
                   "SD_CARD_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardError_inline",
                   "SD card error.",
            ],
            [
                   "SD card error.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SDCardError_inline",
                   "",
            ],
            [
                   "SENSOR_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SensorError_inline",
                   "Camera sensor error.",
            ],
            [
                   "Camera sensor error.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SensorError_inline",
                   "",
            ],
            [
                   "SYSTEM_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SystemError_inline",
                   "Camera system error.",
            ],
            [
                   "Camera system error.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_SystemError_inline",
                   "",
            ],
            [
                   "NO_SUCH_MEDIA_FILE",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_NoSuchMediaFile_inline",
                   "The media file is not found in SD card.",
            ],
            [
                   "The media file is not found in SD card.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_NoSuchMediaFile_inline",
                   "",
            ],
            [
                   "PANORAMA_NOT_FLYING",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_PanoramaNotFlying_inline",
                   "Panorama mode cannot work until the aircraft takes off.",
            ],
            [
                   "Panorama mode cannot work until the aircraft takes off.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "#DJIError_DJISDKCameraError_PanoramaNotFlying_inline",
                   "",
            ],
            [
                   "SIGNATURE_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_SignatureInvalid_inline",
                   "Server rejected the request because the signature is invalid.",
            ],
            [
                   "Server rejected the request because the signature is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_SignatureInvalid_inline",
                   "",
            ],
            [
                   "NO_RIGHT_TO_ACCESS",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoRightToAccess_inline",
                   "Server rejected the request because the user does not have the permission.",
            ],
            [
                   "Server rejected the request because the user does not have the permission.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoRightToAccess_inline",
                   "",
            ],
            [
                   "PARAMETERS_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ParametersInvalid_inline",
                   "Invalid parameter(s).",
            ],
            [
                   "Invalid parameter(s).",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ParametersInvalid_inline",
                   "",
            ],
            [
                   "NO_AUTHORIZATION_INFORMATION_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoAuthorizationInformationFound_inline",
                   "No authorization information found.",
            ],
            [
                   "No authorization information found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoAuthorizationInformationFound_inline",
                   "",
            ],
            [
                   "USER_NOT_FOUND_IN_USER_CENTER",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserNotFoundInUserCenter_inline",
                   "The account information is not found.",
            ],
            [
                   "The account information is not found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserNotFoundInUserCenter_inline",
                   "",
            ],
            [
                   "AUTHORIZATION_EXPIRED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AuthorizationExpired_inline",
                   "Authorization information has expired. Please authorize again.",
            ],
            [
                   "Authorization information has expired. Please authorize again.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AuthorizationExpired_inline",
                   "",
            ],
            [
                   "USER_NOT_FOUND_IN_FLIGHT_HUB",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserNotFoundInFlightHub_inline",
                   "User not found in DJI FlightHub system.",
            ],
            [
                   "User not found in DJI FlightHub system.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserNotFoundInFlightHub_inline",
                   "",
            ],
            [
                   "SERVICE_PACKAGE_EXPIRED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ServicePackageExpired_inline",
                   "The service package has been expired.",
            ],
            [
                   "The service package has been expired.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ServicePackageExpired_inline",
                   "",
            ],
            [
                   "SERVICE_PACKAGE_LIMITATION_REACHED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ServicePackageLimitationReached_inline",
                   "The service package has reached the limit of device numbers.",
            ],
            [
                   "The service package has reached the limit of device numbers.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_ServicePackageLimitationReached_inline",
                   "",
            ],
            [
                   "NO_SDK_PERMISSION_FOR_SERVICE_PACKAGE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserHasNoSDKPermissionForServicePackage_inline",
                   "The service package does not have permission to access SDK service.",
            ],
            [
                   "The service package does not have permission to access SDK service.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_UserHasNoSDKPermissionForServicePackage_inline",
                   "",
            ],
            [
                   "NO_TEAM_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoTeamFound_inline",
                   "No team found.",
            ],
            [
                   "No team found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoTeamFound_inline",
                   "",
            ],
            [
                   "NO_AIRCRAFT_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoAircraftFound_inline",
                   "No aircraft found.",
            ],
            [
                   "No aircraft found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoAircraftFound_inline",
                   "",
            ],
            [
                   "AIRCRAFT_ALREADY_BOUND_IN_TEAM_CHOSEN",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftAlreadyBoundInTeamChosen_inline",
                   "The aircraft has already been bound in the chosen team.",
            ],
            [
                   "The aircraft has already been bound in the chosen team.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftAlreadyBoundInTeamChosen_inline",
                   "",
            ],
            [
                   "NO_RECORD_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoRecordFound_inline",
                   "No record found.",
            ],
            [
                   "No record found.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NoRecordFound_inline",
                   "",
            ],
            [
                   "NOT_LOGGED_IN",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NotLoggedIn_inline",
                   "No user is logged in.",
            ],
            [
                   "No user is logged in.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_NotLoggedIn_inline",
                   "",
            ],
            [
                   "AIRCRAFT_SERIAL_NUMBER_IS_NOT_AVAILABLE",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftSerialNumberNotAvailable_inline",
                   "Aircraft's serial number is not available.",
            ],
            [
                   "Aircraft's serial number is not available.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftSerialNumberNotAvailable_inline",
                   "",
            ],
            [
                   "BOUND_DEVICE_LIMITATION_REACHED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_BoundDeviceLimitationReached_inline",
                   "Bound device number has reached the limit of your service package.",
            ],
            [
                   "Bound device number has reached the limit of your service package.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_BoundDeviceLimitationReached_inline",
                   "",
            ],
            [
                   "AIRCRAFT_ALREADY_BOUND_IN_OTHER_TEAM",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftAlreadyBoundInTeamChosenInOtherTeam_inline",
                   "The aircraft has already been bound in the other team. Please unbind it first.",
            ],
            [
                   "The aircraft has already been bound in the other team. Please unbind it first.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "#DJIError_DJISDKFlightHubError_AircraftAlreadyBoundInTeamChosenInOtherTeam_inline",
                   "",
            ],
            [
                   "AUTHENTICATION_FAILURE",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AuthenticationFailure_inline",
                   "The authentication failed when trying to access to the server.",
            ],
            [
                   "The authentication failed when trying to access to the server.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AuthenticationFailure_inline",
                   "",
            ],
            [
                   "INVALID_SETTINGS",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidSettings_inline",
                   "Network settings are not configured yet or invalid.",
            ],
            [
                   "Network settings are not configured yet or invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidSettings_inline",
                   "",
            ],
            [
                   "ALREADY_STARTED",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AlreadyStarted_inline",
                   "The service is already started. Stop it first to re-start the service.",
            ],
            [
                   "The service is already started. Stop it first to re-start the service.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AlreadyStarted_inline",
                   "",
            ],
            [
                   "INVALID_GPS_DATA",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidGPSData_inline",
                   "The GPS location of the aircraft is invalid. The RTK network service requires the location of the air system.",
            ],
            [
                   "The GPS location of the aircraft is invalid. The RTK network service requires the location of the air system.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidGPSData_inline",
                   "",
            ],
            [
                   "INCORRECT_REFERENCE_STATION_SOURCE",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_IncorrectReferenceStationSource_inline",
                   "Please choose correct reference station srouce.",
            ],
            [
                   "Please choose correct reference station srouce.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_IncorrectReferenceStationSource_inline",
                   "",
            ],
            [
                   "ACCOUNT_NOT_LOGGED_IN_OR_EXPIRED",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountNotLoginOrExpired_inline",
                   "No logged in account or the login session has expired, please login DJI Account and try again.",
            ],
            [
                   "No logged in account or the login session has expired, please login DJI Account and try again.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountNotLoginOrExpired_inline",
                   "",
            ],
            [
                   "ACCOUNT_UNACTIVATED",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountUnactivated_inline",
                   "Account not activated, please contact DJI Support. Use `activateNetworkService` to activate your account.",
            ],
            [
                   "Account not activated, please contact DJI Support. Use `activateNetworkService` to activate your account.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountUnactivated_inline",
                   "",
            ],
            [
                   "INVALID_REQUEST",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidRequest_inline",
                   "Invalid request for the RTK service. Please check if the network RTK service is purchased or activated. After purchasing, within 3 minutes, you might also get this error.",
            ],
            [
                   "Invalid request for the RTK service. Please check if the network RTK service is purchased or activated. After purchasing, within 3 minutes, you might also get this error.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_InvalidRequest_inline",
                   "",
            ],
            [
                   "SERVER_NOT_REACHABLE",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_ServerNotReachable_inline",
                   "Unable to connect to server.",
            ],
            [
                   "Unable to connect to server.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_ServerNotReachable_inline",
                   "",
            ],
            [
                   "ACCOUNT_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountError_inline",
                   "Unknown account error, please contact DJI Support.",
            ],
            [
                   "Unknown account error, please contact DJI Support.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "#DJIError_DJIRTKNetworkServiceError_AccountError_inline",
                   "",
            ],
            [
                   "ACCESSORY_NOT_CONNECTED_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_NotConnected_inline",
                   "The accessory is not connected. Also update the implementation.",
            ],
            [
                   "The accessory is not connected. Also update the implementation.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_NotConnected_inline",
                   "",
            ],
            [
                   "FILE_NAME_LENGTH_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameLengthInvalid_inline",
                   "The file name exceeds the maximum length (20 characters).",
            ],
            [
                   "The file name exceeds the maximum length (20 characters).",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameLengthInvalid_inline",
                   "",
            ],
            [
                   "DUPLICATION_OF_FILE_NAME",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameDuplicated_inline",
                   "The file name is already taken in the aircraft. Choose a different file name.",
            ],
            [
                   "The file name is already taken in the aircraft. Choose a different file name.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameDuplicated_inline",
                   "",
            ],
            [
                   "FILE_NAME_EMPTY_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameEmpty_inline",
                   "A file name cannot be empty.",
            ],
            [
                   "A file name cannot be empty.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNameEmpty_inline",
                   "",
            ],
            [
                   "FILE_NOT_EXIST_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNotExist_inline",
                   "The file does not exist in the aircraft.",
            ],
            [
                   "The file does not exist in the aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileNotExist_inline",
                   "",
            ],
            [
                   "FILE_CREATED_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileCreated_inline",
                   "An error occurs when creating the file.",
            ],
            [
                   "An error occurs when creating the file.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileCreated_inline",
                   "",
            ],
            [
                   "FILE_INDEX_UNAVAIABLE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileIndexUnavailable_inline",
                   "There is no more file index available for the file.",
            ],
            [
                   "There is no more file index available for the file.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_FileIndexUnavailable_inline",
                   "",
            ],
            [
                   "RENAME_FILE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_RenameFile_inline",
                   "Error occurs when renaming the file.",
            ],
            [
                   "Error occurs when renaming the file.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_RenameFile_inline",
                   "",
            ],
            [
                   "DATA_TRANSMISSION_DISCONNECTION_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_DataTransmissionDisconnection_inline",
                   "The connection of the speaker is broken and data transmission cannot start.",
            ],
            [
                   "The connection of the speaker is broken and data transmission cannot start.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_DataTransmissionDisconnection_inline",
                   "",
            ],
            [
                   "WRONG_DATA_TRANSIMISSION_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_WrongDataTransmissionState_inline",
                   "The data transimission operation cannot be executed in the current state.",
            ],
            [
                   "The data transimission operation cannot be executed in the current state.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_WrongDataTransmissionState_inline",
                   "",
            ],
            [
                   "DATA_CORRUPTION_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_DataCorruption_inline",
                   "Data validation failed. Data is corrupted during the transmission.",
            ],
            [
                   "Data validation failed. Data is corrupted during the transmission.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_DataCorruption_inline",
                   "",
            ],
            [
                   "CANCELED_BY_USER",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_CancelledByUser_inline",
                   "The ongoing data transmission is cancelled.",
            ],
            [
                   "The ongoing data transmission is cancelled.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_CancelledByUser_inline",
                   "",
            ],
            [
                   "INTERRUPTED_BY_TIMEOUT_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_InterruptedByTimeout_inline",
                   "The ongoing data transmission is interrupted by timeout error.",
            ],
            [
                   "The ongoing data transmission is interrupted by timeout error.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_InterruptedByTimeout_inline",
                   "",
            ],
            [
                   "STORAGE_FULL",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_StorageFull_inline",
                   "The storage is full.",
            ],
            [
                   "The storage is full.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_StorageFull_inline",
                   "",
            ],
            [
                   "REJECTED_BY_FIRMWARE",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_RejectedByFirmware_inline",
                   "The operation is rejected by the firmware because state error.",
            ],
            [
                   "The operation is rejected by the firmware because state error.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "#DJIError_DJIAccessoryAggregationError_RejectedByFirmware_inline",
                   "",
            ],
            [
                   "ORDER_OF_FUNC",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_WrongFunctionOrder_inline",
                   "Wrong order of invoking functions. Failed to initialize.",
            ],
            [
                   "Wrong order of invoking functions. Failed to initialize.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_WrongFunctionOrder_inline",
                   "",
            ],
            [
                   "INVALID_DB",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_InvalidDB_inline",
                   "Failed to create database.",
            ],
            [
                   "Failed to create database.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_InvalidDB_inline",
                   "",
            ],
            [
                   "CACHE_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_CacheFailed_inline",
                   "Failed to insert the data. The data has been lost.",
            ],
            [
                   "Failed to insert the data. The data has been lost.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_CacheFailed_inline",
                   "",
            ],
            [
                   "EMPTY_DB",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_EmptyDB_inline",
                   "The database is currently empty.",
            ],
            [
                   "The database is currently empty.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_EmptyDB_inline",
                   "",
            ],
            [
                   "UPLOAD_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_UploadFailed_inline",
                   "Failed to upload. Request code is bigger than 299.",
            ],
            [
                   "Failed to upload. Request code is bigger than 299.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_UploadFailed_inline",
                   "",
            ],
            [
                   "AREA_NOT_SUPPORTED",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_AreaNotSupport_inline",
                   "Current area does not support this function.",
            ],
            [
                   "Current area does not support this function.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_AreaNotSupport_inline",
                   "",
            ],
            [
                   "UTMISS_HAD_STARTED",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_UTMISSHadStarted_inline",
                   "UTMISS has started already.",
            ],
            [
                   "UTMISS has started already.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "#DJIError_DJIUTMISSError_UTMISSHadStarted_inline",
                   "",
            ],
            [
                   "NETWORK_ACCESS_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_NetworkAccessFailed_inline",
                   "Network access failed.",
            ],
            [
                   "Network access failed.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_NetworkAccessFailed_inline",
                   "",
            ],
            [
                   "SIGN_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_SignError_inline",
                   "Signature error.",
            ],
            [
                   "Signature error.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_SignError_inline",
                   "",
            ],
            [
                   "AREA_CODE_RESTRICTED",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_AreaCodeRestricted_inline",
                   "LDM is not supported in the current area.",
            ],
            [
                   "LDM is not supported in the current area.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_AreaCodeRestricted_inline",
                   "",
            ],
            [
                   "APP_NOT_FOUND",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_AppNotFound_inline",
                   "App does not exist.",
            ],
            [
                   "App does not exist.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_AppNotFound_inline",
                   "",
            ],
            [
                   "LDM_LICENSE_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMLicenseNotValid_inline",
                   "No valid LDM certificate exists.",
            ],
            [
                   "No valid LDM certificate exists.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMLicenseNotValid_inline",
                   "",
            ],
            [
                   "CLIENT_TIME_NOT_VALID",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_ClientTimeNotValid_inline",
                   "Client's current time is invalid.",
            ],
            [
                   "Client's current time is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_ClientTimeNotValid_inline",
                   "",
            ],
            [
                   "LICENSE_OUTDATED",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LicenseOutDated_inline",
                   "License has expired.",
            ],
            [
                   "License has expired.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LicenseOutDated_inline",
                   "",
            ],
            [
                   "UNAVAILABLE",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_Unavailable_inline",
                   "Only available when the Local Data Mode is enabled.",
            ],
            [
                   "Only available when the Local Data Mode is enabled.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_Unavailable_inline",
                   "",
            ],
            [
                   "LDM_NETWORK_ACCESS_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMNetworkAccessFailed_inline",
                   "In Local Data Mode. Network access failed!",
            ],
            [
                   "In Local Data Mode. Network access failed!",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMNetworkAccessFailed_inline",
                   "",
            ],
            [
                   "LDM_UNKNOWN_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMUnknownError_inline",
                   "LDM unknown error.",
            ],
            [
                   "LDM unknown error.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "#DJIError_DJILDMError_LDMUnknownError_inline",
                   "",
            ],
            [
                   "INVALID_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_InvalidState_inline",
                   "The command is not valid in current state.",
            ],
            [
                   "The command is not valid in current state.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_InvalidState_inline",
                   "",
            ],
            [
                   "FIRMWARE_WRITE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_FirmwareWrite_inline",
                   "Write failure when updating data in the firmware.",
            ],
            [
                   "Write failure when updating data in the firmware.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_FirmwareWrite_inline",
                   "",
            ],
            [
                   "FIRMWARE_READ_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_FirmwareRead_inline",
                   "Read failure when accessing data in the firmware.",
            ],
            [
                   "Read failure when accessing data in the firmware.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_FirmwareRead_inline",
                   "",
            ],
            [
                   "SECURITY_CODE_INCORRECT",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrect_inline",
                   "The Security Code is incorrect.",
            ],
            [
                   "The Security Code is incorrect.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrect_inline",
                   "",
            ],
            [
                   "NOT_SET_UP_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_NotSetUp_inline",
                   "The user account is not set up for the security feature yet.",
            ],
            [
                   "The user account is not set up for the security feature yet.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_NotSetUp_inline",
                   "",
            ],
            [
                   "ALREADY_UNLOCKED",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_AlreadyUnlocked_inline",
                   "The aircraft is already unlocked.",
            ],
            [
                   "The aircraft is already unlocked.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_AlreadyUnlocked_inline",
                   "",
            ],
            [
                   "SECURITY_CODE_INCORRECT_FIVE_TIMES",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrectFiveTimes_inline",
                   "Attempt with wrong Security Code more than 5 times. The aircraft is disable and try again in 1 minute.",
            ],
            [
                   "Attempt with wrong Security Code more than 5 times. The aircraft is disable and try again in 1 minute.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrectFiveTimes_inline",
                   "",
            ],
            [
                   "SECURITY_CODE_INCORRECT_TWENTY_TIMES",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrectTwentyTimes_inline",
                   "Attempt with wrong Security Code more than 20 times. The aircraft is disable and try again in 24 hours.",
            ],
            [
                   "Attempt with wrong Security Code more than 20 times. The aircraft is disable and try again in 24 hours.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeIncorrectTwentyTimes_inline",
                   "",
            ],
            [
                   "USERNAME_NOT_EXIST",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_UsernameNotExist_inline",
                   "The username does not exist.",
            ],
            [
                   "The username does not exist.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_UsernameNotExist_inline",
                   "",
            ],
            [
                   "SECURITY_CODE_FORMAT_INVALID",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeFormatInvalid_inline",
                   "The new security code is not valid. A valid security code should contain only numbers and letters and its length is not less than 4 characters and not longer than 8 characters.",
            ],
            [
                   "The new security code is not valid. A valid security code should contain only numbers and letters and its length is not less than 4 characters and not longer than 8 characters.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "#DJIError_DJIAccessLockerError_SecurityCodeFormatInvalid_inline",
                   "",
            ],
            [
                   "INVALID_FORMAT_OF_WIDGET_CONFIGURATION",
                   2,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "#DJIError_DJIPayloadError_InvalidFormatOfWidgetConfiguration_inline",
                   "The format of widget configuration is invalid.",
            ],
            [
                   "The format of widget configuration is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "#DJIError_DJIPayloadError_InvalidFormatOfWidgetConfiguration_inline",
                   "",
            ],
            [
                   "COMMAND_CAN_NOT_BE_EXECUTED_IN_CURRENT_MODE",
                   2,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "#DJIError_DJIPayloadError_CommandCannotBeExecutedInCurrentMode_inline",
                   "The command cannot be executed in current payload mode. See `PayloadProductPhase`.",
            ],
            [
                   "The command cannot be executed in current payload mode. See `PayloadProductPhase`.",
                   1,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "#DJIError_DJIPayloadError_CommandCannotBeExecutedInCurrentMode_inline",
                   "",
            ],
            [
                   "IN_WIFI_LINK",
                   2,
                   "/Components/SDKError/DJIError_DJIUpgradeError.html",
                   "#DJIError_DJIUpgradeError_InWifiLink_inline",
                   "Cannot upgrade when using `WiFiLink`.",
            ],
            [
                   "Cannot upgrade when using `WiFiLink`.",
                   1,
                   "/Components/SDKError/DJIError_DJIUpgradeError.html",
                   "#DJIError_DJIUpgradeError_InWifiLink_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_getErrorType_inline",
                   "Get the mission waypoint error type.  @param errorCode An int value of the error code.  @return Value of the `DJIWaypointV2Error` enum.",
            ],
            [
                   "Get the mission waypoint error type.  @param errorCode An int value of the error code.  @return Value of the `DJIWaypointV2Error` enum.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_getErrorType_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCountOverRange_inline",
                   "The mission waypoint count is larger than max waypoint count 65535.",
            ],
            [
                   "The mission waypoint count is larger than max waypoint count 65535.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCountOverRange_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCountTooFew_inline",
                   "The mission waypoint count is less than min waypoint count 2.",
            ],
            [
                   "The mission waypoint count is less than min waypoint count 2.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCountTooFew_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionMaxFlightSpeedInvalid_inline",
                   "The mission DJIMutableWaypointV2Mission_maxFlightSpeed</code> is greater than 15m/s or less than 2m/s. See DJIMutableWaypointV2Mission_maxFlightSpeed</code>.",
            ],
            [
                   "The mission DJIMutableWaypointV2Mission_maxFlightSpeed</code> is greater than 15m/s or less than 2m/s. See DJIMutableWaypointV2Mission_maxFlightSpeed</code>.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionMaxFlightSpeedInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAutoFlightSpeedInvalid_inline",
                   "The mission DJIMutableWaypointV2Mission_autoFlightSpeed</code> is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code>.",
            ],
            [
                   "The mission DJIMutableWaypointV2Mission_autoFlightSpeed</code> is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code>.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAutoFlightSpeedInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionGotoFirstWaypointModeInvalid_inline",
                   "The mission DJIMutableWaypointV2Mission_gotoFirstWaypointMode</code> is out of range of `MissionGotoWaypointMode`.",
            ],
            [
                   "The mission DJIMutableWaypointV2Mission_gotoFirstWaypointMode</code> is out of range of `MissionGotoWaypointMode`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionGotoFirstWaypointModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionFinishedActionInvalid_inline",
                   "The mission `setFinishedAction` is out of range of `MissionFinishedAction`.",
            ],
            [
                   "The mission `setFinishedAction` is out of range of `MissionFinishedAction`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionFinishedActionInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionExitMissionOnRCSignalLostInvalid_inline",
                   "The mission DJIMutableWaypointV2Mission_exitMissionOnRCSignalLost</code> is invalid.",
            ],
            [
                   "The mission DJIMutableWaypointV2Mission_exitMissionOnRCSignalLost</code> is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionExitMissionOnRCSignalLostInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyExecuting_inline",
                   "There is already a mission executing when trying to upload a new mission.",
            ],
            [
                   "There is already a mission executing when trying to upload a new mission.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyExecuting_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadWaypointCountOverMissionWaypointCount_inline",
                   "The upload waypoint count is bigger than mission waypoint count.",
            ],
            [
                   "The upload waypoint count is bigger than mission waypoint count.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadWaypointCountOverMissionWaypointCount_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointDistanceTooClose_inline",
                   "Waypoint is too close to two adjacent waypoints. The min distance is 0.5m.",
            ],
            [
                   "Waypoint is too close to two adjacent waypoints. The min distance is 0.5m.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointDistanceTooClose_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointDistanceToFar_inline",
                   "Waypoint is too far from two adjacent waypoints, The max distance is 5km.",
            ],
            [
                   "Waypoint is too far from two adjacent waypoints, The max distance is 5km.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointDistanceToFar_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointMaxFlightSpeedOverMissionMaxFlightSpeed_inline",
                   "The upload waypoints have a `getMaxFlightSpeed` is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code> waypoint.",
            ],
            [
                   "The upload waypoints have a `getMaxFlightSpeed` is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code> waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointMaxFlightSpeedOverMissionMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointAutoFlightSpeedOverWaypointMaxFlightSpeed_inline",
                   "The upload waypoint has a `getAutoFlightSpeed` is greater than `getMaxFlightSpeed` waypoint.",
            ],
            [
                   "The upload waypoint has a `getAutoFlightSpeed` is greater than `getMaxFlightSpeed` waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointAutoFlightSpeedOverWaypointMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointAutoFlightSpeedOverMissionMaxFlightSpeed_inline",
                   "The upload waypoints have a  `getAutoFlightSpeed` is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code> waypoint.",
            ],
            [
                   "The upload waypoints have a  `getAutoFlightSpeed` is greater than DJIMutableWaypointV2Mission_maxFlightSpeed</code> waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointAutoFlightSpeedOverMissionMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointHeadingModeInvalid_inline",
                   "The waypoint `getHeadingMode` is invalid.",
            ],
            [
                   "The waypoint `getHeadingMode` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointHeadingModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointHeadingInvalid_inline",
                   "The waypoint `getHeading` is invalid. See `getHeading`.",
            ],
            [
                   "The waypoint `getHeading` is invalid. See `getHeading`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointHeadingInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointTurnModeInvalid_inline",
                   "The waypoint `getTurnMode` is invalid.",
            ],
            [
                   "The waypoint `getTurnMode` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointTurnModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointFlightPathModeInvalid_inline",
                   "The waypoint `getFlightPathMode` is invalid.",
            ],
            [
                   "The waypoint `getFlightPathMode` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointFlightPathModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointDampingDistanceInvalid_inline",
                   "The waypoint `getDampingDistance` is greater than or equal to the distance of adjacent waypoint.",
            ],
            [
                   "The waypoint `getDampingDistance` is greater than or equal to the distance of adjacent waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointDampingDistanceInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_LastWaypointFlightPathModeInvalid_inline",
                   "The waypoint `getFlightPathMode` is invalid for last waypoint.",
            ],
            [
                   "The waypoint `getFlightPathMode` is invalid for last waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_LastWaypointFlightPathModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadWaypointIndexNotContinue_inline",
                   "The index of upload waypoint is not continue after the stored waypoint.",
            ],
            [
                   "The index of upload waypoint is not continue after the stored waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadWaypointIndexNotContinue_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_FirstWaypointFlightPathModeInvalid_inline",
                   "The waypoint `getFlightPathMode` is invalid for first waypoint.",
            ],
            [
                   "The waypoint `getFlightPathMode` is invalid for first waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_FirstWaypointFlightPathModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointCoordinateInvalid_inline",
                   "The waypoint position coordinate exceeds rational range.",
            ],
            [
                   "The waypoint position coordinate exceeds rational range.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_WaypointCoordinateInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ExceedFlyingRadiusLimit_inline",
                   "The waypoint position exceeds radius limit.",
            ],
            [
                   "The waypoint position exceeds radius limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ExceedFlyingRadiusLimit_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ExceedFlyingHeightLimit_inline",
                   "The waypoint position exceeds height limit.",
            ],
            [
                   "The waypoint position exceeds height limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ExceedFlyingHeightLimit_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_SDKVersionNotMatched_inline",
                   "The version of the SDK doesn't match the firmware version.",
            ],
            [
                   "The version of the SDK doesn't match the firmware version.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_SDKVersionNotMatched_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadMissionRangeOverStorageCount_inline",
                   "The index of first and last waypoint expected to download is not in range of waypoints stored in aircraft.",
            ],
            [
                   "The index of first and last waypoint expected to download is not in range of waypoints stored in aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadMissionRangeOverStorageCount_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoMissionUploadedInAircraft_inline",
                   "There is no mission uploaded in aircraft.",
            ],
            [
                   "There is no mission uploaded in aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoMissionUploadedInAircraft_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadWaypointNotUploaded_inline",
                   "The mission info is not uploaded yet.",
            ],
            [
                   "The mission info is not uploaded yet.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadWaypointNotUploaded_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftCurrentPostionToFirstWaypointTooFar_inline",
                   "The aircraft current position is too far away from the first waypoint.",
            ],
            [
                   "The aircraft current position is too far away from the first waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftCurrentPostionToFirstWaypointTooFar_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadedWaypointsTooFew_inline",
                   "The uploaded waypoints are too few.",
            ],
            [
                   "The uploaded waypoints are too few.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadedWaypointsTooFew_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoMissionExecuting_inline",
                   "There is no mission executing.",
            ],
            [
                   "There is no mission executing.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoMissionExecuting_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyStarted_inline",
                   "The mission has already started by calling `startMission`.",
            ],
            [
                   "The mission has already started by calling `startMission`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyStarted_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyStopped_inline",
                   "The mission has already stopped by calling `stopMission`.",
            ],
            [
                   "The mission has already stopped by calling `stopMission`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyStopped_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoExecutingMissionToRecover_inline",
                   "There is no executing mission to recover when calling `recoverMission`.",
            ],
            [
                   "There is no executing mission to recover when calling `recoverMission`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_NoExecutingMissionToRecover_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyInterrupted_inline",
                   "The mission has already been interrupted by calling `interruptMission`.",
            ],
            [
                   "The mission has already been interrupted by calling `interruptMission`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionAlreadyInterrupted_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoRecordedPoint_inline",
                   "There is no waypoint recorded to recover the mission when `recoverMission` is called.",
            ],
            [
                   "There is no waypoint recorded to recover the mission when `recoverMission` is called.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoRecordedPoint_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftFlyingStatusError_inline",
                   "The aircraft flying status is bad.",
            ],
            [
                   "The aircraft flying status is bad.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftFlyingStatusError_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftStateHomePointNotRecord_inline",
                   "The aircraft home point is not recorded yet.",
            ],
            [
                   "The aircraft home point is not recorded yet.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftStateHomePointNotRecord_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftGPSSignalWeak_inline",
                   "The aircraft GPS signal is weak.",
            ],
            [
                   "The aircraft GPS signal is weak.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftGPSSignalWeak_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftRTKNotReady_inline",
                   "The aircraft RTK is not ready.",
            ],
            [
                   "The aircraft RTK is not ready.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftRTKNotReady_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCrossNoFlyZone_inline",
                   "The mission is across the no-fly zone.",
            ],
            [
                   "The mission is across the no-fly zone.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionCrossNoFlyZone_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftLowBattery_inline",
                   "The aircraft battery is low.",
            ],
            [
                   "The aircraft battery is low.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_AircraftLowBattery_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadedActionIdDuplicated_inline",
                   "The uploaded action ID is duplicated.",
            ],
            [
                   "The uploaded action ID is duplicated.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadedActionIdDuplicated_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionStorageNotEnough_inline",
                   "There is not enough space to store actions in aircraft.",
            ],
            [
                   "There is not enough space to store actions in aircraft.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionStorageNotEnough_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadActionsFailed_inline",
                   "Download actions failed.",
            ],
            [
                   "Download actions failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_DownloadActionsFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerTypeInvalid_inline",
                   "The upload action trigger type is invalid.",
            ],
            [
                   "The upload action trigger type is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerTypeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionAssociateTriggerTypeInvalid_inline",
                   "The action associate trigger `getAssociateType` is invalid.",
            ],
            [
                   "The action associate trigger `getAssociateType` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionAssociateTriggerTypeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionIntervalTriggerTypeInvalid_inline",
                   "The action associate trigger `getType` is invalid.",
            ],
            [
                   "The action associate trigger `getType` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionIntervalTriggerTypeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionTriggerWayPointIndexInvalid_inline",
                   "The action associate trigger waypoint index invalid.",
            ],
            [
                   "The action associate trigger waypoint index invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionTriggerWayPointIndexInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorStatusNotMatchAction_inline",
                   "The actuator state does not match action.",
            ],
            [
                   "The actuator state does not match action.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorStatusNotMatchAction_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorOperationIndexInvalid_inline",
                   "The action actuator operation index is invalid.",
            ],
            [
                   "The action actuator operation index is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorOperationIndexInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraExcuteFailed_inline",
                   "Camera failed to execute coressponding command.",
            ],
            [
                   "Camera failed to execute coressponding command.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraExcuteFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNotSupport_inline",
                   "The action actuator is not supported.",
            ],
            [
                   "The action actuator is not supported.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNotSupport_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorTypeInvalid_inline",
                   "The action actuator `getActuatorType` is invalid.",
            ],
            [
                   "The action actuator `getActuatorType` is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorTypeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorOperationTypeInvalid_inline",
                   "The action actuator operation type is invalid. See `getCameraOperationType` or `getAircraftControlType` or `getOperationType`.",
            ],
            [
                   "The action actuator operation type is invalid. See `getCameraOperationType` or `getAircraftControlType` or `getOperationType`.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorOperationTypeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorGimbalParamInvalid_inline",
                   "The action gimbal actuator parameters are invalid.",
            ],
            [
                   "The action gimbal actuator parameters are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorGimbalParamInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateGimbalFailed_inline",
                   "The action actuator rotate gimbal failed.",
            ],
            [
                   "The action actuator rotate gimbal failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateGimbalFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionStopGimbalUniformControl_inline",
                   "Gimbal is not mounted or unable to execute stop rotation command.",
            ],
            [
                   "Gimbal is not mounted or unable to execute stop rotation command.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionStopGimbalUniformControl_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionFlightTypeNotSupportHover_inline",
                   "The current waypoint type(Coordinated turn or Curved route Aircraft continues) does not support setting the action when the waypoint is reached.",
            ],
            [
                   "The current waypoint type(Coordinated turn or Curved route Aircraft continues) does not support setting the action when the waypoint is reached.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionFlightTypeNotSupportHover_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonFailtoPreciseShootPhoto_inline",
                   "Failed to take precise photos.",
            ],
            [
                   "Failed to take precise photos.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonFailtoPreciseShootPhoto_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonPreciseShootPhotoTimeout_inline",
                   "Timeout for taking precise photos.",
            ],
            [
                   "Timeout for taking precise photos.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonPreciseShootPhotoTimeout_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateAircraftYawParamInvalid_inline",
                   "The action `WaypointAircraftControlParam` parameters are invalid.",
            ],
            [
                   "The action `WaypointAircraftControlParam` parameters are invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateAircraftYawParamInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonExecuteFailed_inline",
                   "Failed to execute navigation command.",
            ],
            [
                   "Failed to execute navigation command.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorNavigatonExecuteFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendSingleShotCmdFail_inline",
                   "Failed to send shoot photo command to camera cause of no camera or camera is busy.",
            ],
            [
                   "Failed to send shoot photo command to camera cause of no camera or camera is busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendSingleShotCmdFail_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendVideoStartCmdFail_inline",
                   "Failed to send start record command to camera cause of no camera or camera is busy.",
            ],
            [
                   "Failed to send start record command to camera cause of no camera or camera is busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendVideoStartCmdFail_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendVideoStopCmdFail_inline",
                   "Failed to send video stop command to camera cause of no camera or camera is not busy.",
            ],
            [
                   "Failed to send video stop command to camera cause of no camera or camera is not busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendVideoStopCmdFail_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraFocusParamXYInvalid_inline",
                   "Camera focus param xy exceed valid range [0, 1].",
            ],
            [
                   "Camera focus param xy exceed valid range [0, 1].",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraFocusParamXYInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendForcusCmdFail_inline",
                   "Failed to send camera focus command cause of no camera or camera is busy.",
            ],
            [
                   "Failed to send camera focus command cause of no camera or camera is busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendForcusCmdFail_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendFocalizeCmdFail_inline",
                   "Failed to send camera zoom command cause of no camera or camera is busy.",
            ],
            [
                   "Failed to send camera zoom command cause of no camera or camera is busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraSendFocalizeCmdFail_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraFocalDistanceInvalid_inline",
                   "Illegal zoom focal length.",
            ],
            [
                   "Illegal zoom focal length.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorCameraFocalDistanceInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateAircraftYawFailed_inline",
                   "The action actuator rotate aircraft yaw execute failed.",
            ],
            [
                   "The action actuator rotate aircraft yaw execute failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionRotateAircraftYawFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionAircraftStartStopFlyFailed_inline",
                   "The action actuator aircraft start or stop fly execute failed. For example: when the aircraft is flying, an error will occur when the `isStartFly`(TRUE) action is executed. You should execute `isStartFly`(FALSE) first.",
            ],
            [
                   "The action actuator aircraft start or stop fly execute failed. For example: when the aircraft is flying, an error will occur when the `isStartFly`(TRUE) action is executed. You should execute `isStartFly`(FALSE) first.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionAircraftStartStopFlyFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoid_inline",
                   "The waypoint mission is interrupted by by obstacle avoidance system.",
            ],
            [
                   "The waypoint mission is interrupted by by obstacle avoidance system.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidRadiusLimit_inline",
                   "The waypoint mission is interrupted because of radius limit.",
            ],
            [
                   "The waypoint mission is interrupted because of radius limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidRadiusLimit_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidHeightLimit_inline",
                   "The waypoint mission is interrupted because of height limit.",
            ],
            [
                   "The waypoint mission is interrupted because of height limit.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidHeightLimit_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidRTKUnhealthy_inline",
                   "The waypoint mission is interrupted because of RTK week signal.",
            ],
            [
                   "The waypoint mission is interrupted because of RTK week signal.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidRTKUnhealthy_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidUserReqBreak_inline",
                   "The waypoint mission is interrupted because of user request.",
            ],
            [
                   "The waypoint mission is interrupted because of user request.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInterruptReasonAvoidUserReqBreak_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommandCannotExecute_inline",
                   "Command cannot execute.",
            ],
            [
                   "Command cannot execute.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommandCannotExecute_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommandExecutionFailed_inline",
                   "Command execution failed.",
            ],
            [
                   "Command execution failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommandExecutionFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidParameters_inline",
                   "Invalid parameters.",
            ],
            [
                   "Invalid parameters.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidParameters_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommonTimeout_inline",
                   "Common timeout.",
            ],
            [
                   "Common timeout.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCommonTimeout_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointProductConnectFailed_inline",
                   "Product connection failed.",
            ],
            [
                   "Product connection failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointProductConnectFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSystemBusy_inline",
                   "System busy.",
            ],
            [
                   "System busy.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSystemBusy_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointOperationCancelByUser_inline",
                   "Operation cancel by user.",
            ],
            [
                   "Operation cancel by user.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointOperationCancelByUser_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointUploadMediaFileFailed_inline",
                   "Upload media file failed.",
            ],
            [
                   "Upload media file failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointUploadMediaFileFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSdrReserveFailed_inline",
                   "SDR reserve failed.",
            ],
            [
                   "SDR reserve failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSdrReserveFailed_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCheckPhotoStoragePackError_inline",
                   "Check photo storage pack error.",
            ],
            [
                   "Check photo storage pack error.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointCheckPhotoStoragePackError_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSdrLinkReserveFailedCauseMotorOn_inline",
                   "SDR link reserve failed because motor is on.",
            ],
            [
                   "SDR link reserve failed because motor is on.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointSdrLinkReserveFailedCauseMotorOn_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointActionTriggerNotMatchActuator_inline",
                   "The action actuator and the trigger type do not match.",
            ],
            [
                   "The action actuator and the trigger type do not match.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointActionTriggerNotMatchActuator_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayInvalidLocation_inline",
                   "The trajectory replay's location is invalid.",
            ],
            [
                   "The trajectory replay's location is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayInvalidLocation_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayNoWaypointToRemove_inline",
                   "The trajectory replay has no waypoint to remove.",
            ],
            [
                   "The trajectory replay has no waypoint to remove.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayNoWaypointToRemove_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayGimbalAttiError_inline",
                   "The trajectory replay's gimbal attitude has error.",
            ],
            [
                   "The trajectory replay's gimbal attitude has error.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointTrajectoryReplayGimbalAttiError_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidInputDataFCLength_inline",
                   "Data transmission does not match protocols.",
            ],
            [
                   "Data transmission does not match protocols.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidInputDataFCLength_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidInputDataFloatNumber_inline",
                   "Invalid floating number.",
            ],
            [
                   "Invalid floating number.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointInvalidInputDataFloatNumber_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionEndIndexInvalid_inline",
                   "Last waypoint index is invalid.",
            ],
            [
                   "Last waypoint index is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionEndIndexInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointIndexInvalid_inline",
                   "Invalid waypoint index, please check your waypoint index with waypoint count.",
            ],
            [
                   "Invalid waypoint index, please check your waypoint index with waypoint count.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointIndexInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointStartIndexNotInEndOfLastUpload_inline",
                   "The upload waypoint start index isn't in the given range.",
            ],
            [
                   "The upload waypoint start index isn't in the given range.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionWaypointStartIndexNotInEndOfLastUpload_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlStartStopInvalid_inline",
                   "The aircraft start waypoint is too far away from the stop waypoint.",
            ],
            [
                   "The aircraft start waypoint is too far away from the stop waypoint.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlStartStopInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlPauseResumeInvalid_inline",
                   "Invalid pause resume operation.",
            ],
            [
                   "Invalid pause resume operation.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlPauseResumeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlInterruptRecoverInvalid_inline",
                   "Invalid interrupt recover operation.",
            ],
            [
                   "Invalid interrupt recover operation.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlInterruptRecoverInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlMissionAlreadyPaused_inline",
                   "The mission is already paused.",
            ],
            [
                   "The mission is already paused.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlMissionAlreadyPaused_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNoRunningMissionForResume_inline",
                   "The mission cannot resume because it is not running.",
            ],
            [
                   "The mission cannot resume because it is not running.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNoRunningMissionForResume_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNotSupportPauseResume_inline",
                   "The mission cannot be paused or resumed now.",
            ],
            [
                   "The mission cannot be paused or resumed now.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNotSupportPauseResume_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNotSupportInterruptResume_inline",
                   "The mission cannot be interrupted or recovered now.",
            ],
            [
                   "The mission cannot be interrupted or recovered now.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_MissionControlNotSupportInterruptResume_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoCurrentProjectionPoint_inline",
                   "No recorded waypoint for recovery currently.",
            ],
            [
                   "No recorded waypoint for recovery currently.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoCurrentProjectionPoint_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoNextProjectionPoint_inline",
                   "No recorded waypoint for next waypoint recovery.",
            ],
            [
                   "No recorded waypoint for next waypoint recovery.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_RecoverNoNextProjectionPoint_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachEndIndexLessStartIndex_inline",
                   "Uploaded reach trigger invalid.",
            ],
            [
                   "Uploaded reach trigger invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachEndIndexLessStartIndex_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachIntervalCountInvalid_inline",
                   "Uploaded reach trigger invalid.",
            ],
            [
                   "Uploaded reach trigger invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachIntervalCountInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachAutoTerminateInvalid_inline",
                   "Uploaded reach trigger invalid.",
            ],
            [
                   "Uploaded reach trigger invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionTriggerReachAutoTerminateInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayExternalSprayModeInvalid_inline",
                   "Uploaded spray actuator is invalid.",
            ],
            [
                   "Uploaded spray actuator is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayExternalSprayModeInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayFlowSpeedInvalid_inline",
                   "Uploaded spray actuator is invalid.",
            ],
            [
                   "Uploaded spray actuator is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayFlowSpeedInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayFlowSpeedPreMuInvalid_inline",
                   "Uploaded spray actuator is invalid.",
            ],
            [
                   "Uploaded spray actuator is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_UploadActionActuatorSprayFlowSpeedPreMuInvalid_inline",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorPayloadFailToSendCMDToPayload_inline",
                   "Uploaded payload actuator is invalid.",
            ],
            [
                   "Uploaded payload actuator is invalid.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "#DJIError_DJIWaypointV2Error_ActionActuatorPayloadFailToSendCMDToPayload_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "#DJIError_DJIAirLinkError_getDJIError_inline",
                   "Returns the specific error in DJIAirLinkError according to the error code.  @param ccode Error code.  @return The DJIError object.",
            ],
            [
                   "Returns the specific error in DJIAirLinkError according to the error code.  @param ccode Error code.  @return The DJIError object.",
                   1,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "#DJIError_DJIAirLinkError_getDJIError_inline",
                   "",
            ],
            [
                   "IMAGE_TRANSMITTER_CANNOT_SET_PARAMETERS_IN_THIS_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "#DJIError_DJIAirLinkError_IMAGE_TRANSMITTER_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "Cannot set the parameters in this state.",
            ],
            [
                   "Cannot set the parameters in this state.",
                   1,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "#DJIError_DJIAirLinkError_IMAGE_TRANSMITTER_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "",
            ],
            [
                   "GET_SMART_BATTERY_INFO_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "#DJIError_DJIBatteryError_BATTERY_GET_SMART_BATTERY_INFO_FAILED_inline",
                   "Get smart battery failure information. This error is returned by functions when retrieving failure information for the DJIPhantomBattery and DJIAircraftBattery, including:  public void getSmartBatteryRestTimeForAll(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForGoHome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForLand(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryGohomeBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryLandBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRadiusForGohome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRequestGohomeFlag(DJISmartBatteryExecuteResultCallback mCallBack)",
            ],
            [
                   "Get smart battery failure information. This error is returned by functions when retrieving failure information for the DJIPhantomBattery and DJIAircraftBattery, including:  public void getSmartBatteryRestTimeForAll(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForGoHome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForLand(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryGohomeBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryLandBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRadiusForGohome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRequestGohomeFlag(DJISmartBatteryExecuteResultCallback mCallBack)",
                   1,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "#DJIError_DJIBatteryError_BATTERY_GET_SMART_BATTERY_INFO_FAILED_inline",
                   "",
            ],
            [
                   "UPDATE_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "#DJIError_DJIBatteryError_UPDATE_WRONG_inline",
                   "The update process is wrong.",
            ],
            [
                   "The update process is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "#DJIError_DJIBatteryError_UPDATE_WRONG_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_getDJIError_inline",
                   "Returns the specific error in DJIRemoteControllerError according to the error code.  @param ccode Error code.  @return A DJIError instance of the specific error.",
            ],
            [
                   "Returns the specific error in DJIRemoteControllerError according to the error code.  @param ccode Error code.  @return A DJIError instance of the specific error.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_getDJIError_inline",
                   "",
            ],
            [
                   "FIRMWARE_NON_SEQUENCE",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_NON_SEQUENCE_inline",
                   "The sequence number of the firmware is not continuous.",
            ],
            [
                   "The sequence number of the firmware is not continuous.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_NON_SEQUENCE_inline",
                   "",
            ],
            [
                   "FIRMWARE_LENGTH_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_LENGTH_WRONG_inline",
                   "The file size of the firmware is wrong.",
            ],
            [
                   "The file size of the firmware is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_LENGTH_WRONG_inline",
                   "",
            ],
            [
                   "FIRMWARE_CRC_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_CRC_WRONG_inline",
                   "The check number of the firmware is wrong.",
            ],
            [
                   "The check number of the firmware is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_CRC_WRONG_inline",
                   "",
            ],
            [
                   "FLASH_CLEAR_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_CLEAR_WRONG_inline",
                   "The clear action of the flash is wrong.",
            ],
            [
                   "The clear action of the flash is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_CLEAR_WRONG_inline",
                   "",
            ],
            [
                   "FLASH_WRITE_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_WRITE_WRONG_inline",
                   "The write action of the flash is wrong.",
            ],
            [
                   "The write action of the flash is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_WRITE_WRONG_inline",
                   "",
            ],
            [
                   "UPDATE_WRONG",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_UPDATE_WRONG_inline",
                   "The update process is wrong.",
            ],
            [
                   "The update process is wrong.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_UPDATE_WRONG_inline",
                   "",
            ],
            [
                   "FIRMWARE_MATCH_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_MATCH_ERROR_inline",
                   "The firmware does not matched.",
            ],
            [
                   "The firmware does not matched.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FIRMWARE_MATCH_ERROR_inline",
                   "",
            ],
            [
                   "FLASH_FLUSHING",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_FLUSHING_inline",
                   "The flash is flushing.",
            ],
            [
                   "The flash is flushing.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_FLASH_FLUSHING_inline",
                   "",
            ],
            [
                   "OWNER_OFFLINE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_OWNER_OFFLINE_ERROR_inline",
                   "Owner offline.",
            ],
            [
                   "Owner offline.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_OWNER_OFFLINE_ERROR_inline",
                   "",
            ],
            [
                   "DEVICE_OFFLINE_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_DEVICE_OFFLINE_ERROR_inline",
                   "Device offline.",
            ],
            [
                   "Device offline.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_DEVICE_OFFLINE_ERROR_inline",
                   "",
            ],
            [
                   "IS_OWNER_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_IS_OWNER_ERROR_inline",
                   "Is owner.",
            ],
            [
                   "Is owner.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_IS_OWNER_ERROR_inline",
                   "",
            ],
            [
                   "DEVICE_LOCKED_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_DEVICE_LOCKED_ERROR_inline",
                   "Device locked.",
            ],
            [
                   "Device locked.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "#DJIError_DJIRemoteControllerError_DEVICE_LOCKED_ERROR_inline",
                   "",
            ],
            [
                   "getDJIError",
                   2,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_getDJIError_inline",
                   "Returns the specific error in DJIGimbalError according to the error code.  @param ccode Error code.  @return A DJIError instance of the specific error.",
            ],
            [
                   "Returns the specific error in DJIGimbalError according to the error code.  @param ccode Error code.  @return A DJIError instance of the specific error.",
                   1,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_getDJIError_inline",
                   "",
            ],
            [
                   "DJIGimbalError",
                   2,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "",
                   "Defines all gimbal related errors.",
            ],
            [
                   "Defines all gimbal related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "",
                   "",
            ],
            [
                   "RESULT_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_GIMBAL_RESULT_FAILED_inline",
                   "Gimbal Result Failed.",
            ],
            [
                   "Gimbal Result Failed.",
                   1,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_GIMBAL_RESULT_FAILED_inline",
                   "",
            ],
            [
                   "CANNOT_SET_PARAMETERS_IN_THIS_STATE",
                   2,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_GIMBAL_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "Cannot set the parameters in this state.",
            ],
            [
                   "Cannot set the parameters in this state.",
                   1,
                   "/Components/SDKError/DJIError_DJIGimbalError.html",
                   "#DJIError_DJIGimbalError_GIMBAL_CANNOT_SET_PARAMETERS_IN_THIS_STATE_inline",
                   "",
            ],
            [
                   "DataProtectionError",
                   2,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "",
                   "The class for all errors related to data protection.",
            ],
            [
                   "The class for all errors related to data protection.",
                   1,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "",
                   "",
            ],
            [
                   "CANNOT_ADD_AUTHORIZATION",
                   2,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_CANNOT_ADD_AUTHORIZATION_inline",
                   "The authorization of this type of data has failed.",
            ],
            [
                   "The authorization of this type of data has failed.",
                   1,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_CANNOT_ADD_AUTHORIZATION_inline",
                   "",
            ],
            [
                   "CANNOT_REMOVE_AUTHORIZATION",
                   2,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_CANNOT_REMOVE_AUTHORIZATION_inline",
                   "The removal of this type of data's authorization has failed.",
            ],
            [
                   "The removal of this type of data's authorization has failed.",
                   1,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_CANNOT_REMOVE_AUTHORIZATION_inline",
                   "",
            ],
            [
                   "NO_HARDWARE_INFO_AUTHORIZATION",
                   2,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_NO_HARDWARE_INFO_AUTHORIZATION_inline",
                   "SDK does not have authorization to access hardware information.",
            ],
            [
                   "SDK does not have authorization to access hardware information.",
                   1,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_NO_HARDWARE_INFO_AUTHORIZATION_inline",
                   "",
            ],
            [
                   "NOT_ENOUGH_AUTHORIZATION",
                   2,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_NOT_ENOUGH_AUTHORIZATION_inline",
                   "SDK does not have authorization to access some privacy related information.",
            ],
            [
                   "SDK does not have authorization to access some privacy related information.",
                   1,
                   "/Components/SDKError/DJIError_DataProtectionError.html",
                   "#DJIError_DataProtectionError_NOT_ENOUGH_AUTHORIZATION_inline",
                   "",
            ],
            [
                   "REGISTRATION_SUCCESS",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJISDKError_REGISTRATION_SUCCESS_inline",
                   "API Key successfully registered.",
            ],
            [
                   "API Key successfully registered.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DJISDKError_REGISTRATION_SUCCESS_inline",
                   "",
            ],
            [
                   "DJIFlightHubError",
                   2,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "",
                   "DJI SDK FlightHub Error.",
            ],
            [
                   "DJI SDK FlightHub Error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKFlightHubError.html",
                   "",
                   "",
            ],
            [
                   "DJIRTKNetworkServiceError",
                   2,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "",
                   "Errors related to RTK network services.",
            ],
            [
                   "Errors related to RTK network services.",
                   1,
                   "/Components/SDKError/DJIError_DJIRTKNetworkServiceError.html",
                   "",
                   "",
            ],
            [
                   "DJIAccessoryAggregationError",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "",
                   "Errors related to accessories on the aircraft (e.g. spotlights, speakers).",
            ],
            [
                   "Errors related to accessories on the aircraft (e.g. spotlights, speakers).",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessoryAggregationError.html",
                   "",
                   "",
            ],
            [
                   "DJIAccessLockerError",
                   2,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "",
                   "Errors related to the access locker.",
            ],
            [
                   "Errors related to the access locker.",
                   1,
                   "/Components/SDKError/DJIError_DJIAccessLockerError.html",
                   "",
                   "",
            ],
            [
                   "DJIPayloadError",
                   2,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "",
                   "Errors related to the payload.",
            ],
            [
                   "Errors related to the payload.",
                   1,
                   "/Components/SDKError/DJIError_DJIPayloadError.html",
                   "",
                   "",
            ],
            [
                   "DJIUTMISSError",
                   2,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "",
                   "Errors related to the UTMISS.",
            ],
            [
                   "Errors related to the UTMISS.",
                   1,
                   "/Components/SDKError/DJIError_DJIUTMISSError.html",
                   "",
                   "",
            ],
            [
                   "DJILDMError",
                   2,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "",
                   "Errors related to the LDM.",
            ],
            [
                   "Errors related to the LDM.",
                   1,
                   "/Components/SDKError/DJIError_DJILDMError.html",
                   "",
                   "",
            ],
            [
                   "DJIUpgradeError",
                   2,
                   "/Components/SDKError/DJIError_DJIUpgradeError.html",
                   "",
                   "Errors related to the upgrade.",
            ],
            [
                   "Errors related to the upgrade.",
                   1,
                   "/Components/SDKError/DJIError_DJIUpgradeError.html",
                   "",
                   "",
            ],
            [
                   "DJIWaypointV2Error",
                   2,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "",
                   "Errors related to the payload.",
            ],
            [
                   "Errors related to the payload.",
                   1,
                   "/Components/SDKError/DJIError_DJIWaypointV2Error.html",
                   "",
                   "",
            ],
            [
                   "DJISDKError",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "",
                   "DJI SDK Error.",
            ],
            [
                   "DJI SDK Error.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "",
                   "",
            ],
            [
                   "DJISDKCacheError",
                   2,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "",
                   "Class that handles all errors about SDK Cache.",
            ],
            [
                   "Class that handles all errors about SDK Cache.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKCacheError.html",
                   "",
                   "",
            ],
            [
                   "CANNOT_PAUSE_STABILIZATION",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_EXECUTION_FAILED_inline",
                   "The execution could not be performed.",
            ],
            [
                   "The execution could not be performed.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_EXECUTION_FAILED_inline",
                   "",
            ],
            [
                   "COMMON_SYSTEM_BUSY",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_SYSTEM_BUSY_inline",
                   "The system is too busy to execute the action.",
            ],
            [
                   "The system is too busy to execute the action.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_SYSTEM_BUSY_inline",
                   "",
            ],
            [
                   "COMMON_UNKNOWN",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNKNOWN_inline",
                   "Catch all for various errors.",
            ],
            [
                   "Catch all for various errors.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNKNOWN_inline",
                   "",
            ],
            [
                   "COMMON_DATA_ERROR",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_DATA_ERROR_inline",
                   "Data error. Shown as N/A in DJI APP.",
            ],
            [
                   "Data error. Shown as N/A in DJI APP.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_DATA_ERROR_inline",
                   "",
            ],
            [
                   "COMMON_INVALID_AUTHORIZATION_ID",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_INVALID_AUTHORIZATION_ID_inline",
                   "Invalid authorization ID.",
            ],
            [
                   "Invalid authorization ID.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_INVALID_AUTHORIZATION_ID_inline",
                   "",
            ],
            [
                   "COMMON_UNDEFINED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNDEFINED_inline",
                   "Undefined error.  This error will be returned when the error is undefined.  public void setMultiControlMode(boolean value,final DJIExecuteResultCallback mCallBack)",
            ],
            [
                   "Undefined error.  This error will be returned when the error is undefined.  public void setMultiControlMode(boolean value,final DJIExecuteResultCallback mCallBack)",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNDEFINED_inline",
                   "",
            ],
            [
                   "COMMON_TIMEOUT",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_TIMEOUT_inline",
                   "Execution timeout.  This error will be returned when the execution times out.  public void sendDataToExternalDevice(byte[] data,final DJIExecuteResultCallback mCallBack)  public void setMultiControlMode(boolean value,final DJIExecuteResultCallback mCallBack)",
            ],
            [
                   "Execution timeout.  This error will be returned when the execution times out.  public void sendDataToExternalDevice(byte[] data,final DJIExecuteResultCallback mCallBack)  public void setMultiControlMode(boolean value,final DJIExecuteResultCallback mCallBack)",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_TIMEOUT_inline",
                   "",
            ],
            [
                   "COMMON_PARAM_ILLEGAL",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_PARAM_ILLEGAL_inline",
                   "Illegal parameters.  This error will be returned by the function for setting camera parameters in DJIPhantomCamera and DJIInspireCamera, when illegal parameters are used.",
            ],
            [
                   "Illegal parameters.  This error will be returned by the function for setting camera parameters in DJIPhantomCamera and DJIInspireCamera, when illegal parameters are used.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_PARAM_ILLEGAL_inline",
                   "",
            ],
            [
                   "COMMON_PARAM_INVALID",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_PARAM_INVALID_inline",
                   "Invalid parameters.  This error will be returned by the function for setting camera parameters when invalid parameters are used.",
            ],
            [
                   "Invalid parameters.  This error will be returned by the function for setting camera parameters when invalid parameters are used.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_PARAM_INVALID_inline",
                   "",
            ],
            [
                   "COMMON_UNSUPPORTED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNSUPPORTED_inline",
                   "Unsupported feature.  This error will be returned by the function for some special feature interface when the feature isn't supported by the device.",
            ],
            [
                   "Unsupported feature.  This error will be returned by the function for some special feature interface when the feature isn't supported by the device.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_UNSUPPORTED_inline",
                   "",
            ],
            [
                   "COMMON_DISCONNECTED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_DISCONNECTED_inline",
                   "Disconnected error.  This error will be returned by the function for some special interface when the DJI product is not connected to the mobile device.",
            ],
            [
                   "Disconnected error.  This error will be returned by the function for some special interface when the DJI product is not connected to the mobile device.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMON_DISCONNECTED_inline",
                   "",
            ],
            [
                   "FIRMWARE_NON_SEQUENCE",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_NON_SEQUENCE_inline",
                   "Inspire only.  The sequence number of firmware is not continuous.",
            ],
            [
                   "Inspire only.  The sequence number of firmware is not continuous.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_NON_SEQUENCE_inline",
                   "",
            ],
            [
                   "FIRMWARE_LENGTH_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_LENGTH_WRONG_inline",
                   "The file size of the firmware is invalid.",
            ],
            [
                   "The file size of the firmware is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_LENGTH_WRONG_inline",
                   "",
            ],
            [
                   "FIRMWARE_CRC_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_CRC_WRONG_inline",
                   "Inspire only.  The check number of the firmware is invalid.",
            ],
            [
                   "Inspire only.  The check number of the firmware is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_CRC_WRONG_inline",
                   "",
            ],
            [
                   "FLASH_CLEAR_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_CLEAR_WRONG_inline",
                   "The clear action of the flash is invalid.",
            ],
            [
                   "The clear action of the flash is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_CLEAR_WRONG_inline",
                   "",
            ],
            [
                   "FLASH_WRITE_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_WRITE_WRONG_inline",
                   "The write action of the flash is invalid.",
            ],
            [
                   "The write action of the flash is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_WRITE_WRONG_inline",
                   "",
            ],
            [
                   "UPDATE_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UPDATE_WRONG_inline",
                   "The update process is invalid.",
            ],
            [
                   "The update process is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UPDATE_WRONG_inline",
                   "",
            ],
            [
                   "FIRMWARE_MATCH_WRONG",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_MATCH_WRONG_inline",
                   "There is a firmware match error.",
            ],
            [
                   "There is a firmware match error.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FIRMWARE_MATCH_WRONG_inline",
                   "",
            ],
            [
                   "FLASH_FLUSHING",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_FLUSHING_inline",
                   "The flash is flushing.",
            ],
            [
                   "The flash is flushing.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_FLASH_FLUSHING_inline",
                   "",
            ],
            [
                   "MEDIA_INVALID_REQUEST_TYPE",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_INVALID_REQUEST_TYPE_inline",
                   "The media download request type is invalid.",
            ],
            [
                   "The media download request type is invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_INVALID_REQUEST_TYPE_inline",
                   "",
            ],
            [
                   "MEDIA_NO_SUCH_FILE",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_NO_SUCH_FILE_inline",
                   "Media download error: no such file.",
            ],
            [
                   "Media download error: no such file.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_NO_SUCH_FILE_inline",
                   "",
            ],
            [
                   "COMMAND_REPEAT",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_REPEAT_inline",
                   "Execution of this process is sent repeatedly",
            ],
            [
                   "Execution of this process is sent repeatedly",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_REPEAT_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_CLIENT_ABORT",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_CLIENT_ABORT_inline",
                   "Media download error: the client aborted the downloading.",
            ],
            [
                   "Media download error: the client aborted the downloading.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_CLIENT_ABORT_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_DISCONNECT",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_DISCONNECT_inline",
                   "Result of media downloading: the downloading link disconnects.",
            ],
            [
                   "Result of media downloading: the downloading link disconnects.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_DISCONNECT_inline",
                   "",
            ],
            [
                   "IMAGE_TRANSMITTER_INVALID_PARAMETER",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_IMAGE_TRANSMITTER_INVALID_PARAMETER_inline",
                   "The input parameters is out of bound or invalid.",
            ],
            [
                   "The input parameters is out of bound or invalid.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_IMAGE_TRANSMITTER_INVALID_PARAMETER_inline",
                   "",
            ],
            [
                   "COMMAND_NOT_SUPPORTED_BY_FIRMWARE",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_NOT_SUPPORTED_BY_FIRMWARE_inline",
                   "The command is not supported by the current firmware version.",
            ],
            [
                   "The command is not supported by the current firmware version.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_NOT_SUPPORTED_BY_FIRMWARE_inline",
                   "",
            ],
            [
                   "COMMAND_NOT_SUPPORTED_BY_HARDWARE",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_NOT_SUPPORTED_BY_HARDWARE_inline",
                   "The command is not supported by the current hardware version.",
            ],
            [
                   "The command is not supported by the current hardware version.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_COMMAND_NOT_SUPPORTED_BY_HARDWARE_inline",
                   "",
            ],
            [
                   "UNABLE_TO_GET_FIRMWARE_VERSION",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FIRMWARE_VERSION_inline",
                   "Unable to get the firmware version. Note: The SDK gets the firmware version table from the server. Ensure Internet connectivity before you invoke getVersion().",
            ],
            [
                   "Unable to get the firmware version. Note: The SDK gets the firmware version table from the server. Ensure Internet connectivity before you invoke getVersion().",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FIRMWARE_VERSION_inline",
                   "",
            ],
            [
                   "UNABLE_TO_GET_FLAGS",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FLAGS_inline",
                   "Unable to get the analytics flags from server. Note: Ensure Internet connectivity before you invoke this method.",
            ],
            [
                   "Unable to get the analytics flags from server. Note: Ensure Internet connectivity before you invoke this method.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FLAGS_inline",
                   "",
            ],
            [
                   "UNABLE_TO_GET_FLAG_BUT_RETRY",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FLAG_BUT_RETRY_inline",
                   "Unable to get the analytics flags from server, but retrying.",
            ],
            [
                   "Unable to get the analytics flags from server, but retrying.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_UNABLE_TO_GET_FLAG_BUT_RETRY_inline",
                   "",
            ],
            [
                   "SET_PARAM_FAILED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_SET_PARAM_FAILED_inline",
                   "Set param failed.",
            ],
            [
                   "Set param failed.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_SET_PARAM_FAILED_inline",
                   "",
            ],
            [
                   "BATTERY_PAIR_FAILED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_BATTERY_PAIR_FAILED_inline",
                   "Unable to pair the batteries.",
            ],
            [
                   "Unable to pair the batteries.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_BATTERY_PAIR_FAILED_inline",
                   "",
            ],
            [
                   "BATTERY_GET_SMART_BATTERY_INFO_FAILED",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_BATTERY_GET_SMART_BATTERY_INFO_FAILED_inline",
                   "Get smart battery information failed.  This error will be returned by the functions for getting information in DJIPhantomBattery and DJIAircraftBattery when the request to get information failed.  public void getSmartBatteryRestTimeForAll(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForGoHome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForLand(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryGohomeBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryLandBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRadiusForGohome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRequestGohomeFlag(DJISmartBatteryExecuteResultCallback mCallBack)",
            ],
            [
                   "Get smart battery information failed.  This error will be returned by the functions for getting information in DJIPhantomBattery and DJIAircraftBattery when the request to get information failed.  public void getSmartBatteryRestTimeForAll(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForGoHome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryNeedTimeForLand(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryGohomeBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryLandBatteryLevel(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRadiusForGohome(DJISmartBatteryExecuteResultCallback mCallBack)  public void getSmartBatteryRequestGohomeFlag(DJISmartBatteryExecuteResultCallback mCallBack)",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_BATTERY_GET_SMART_BATTERY_INFO_FAILED_inline",
                   "",
            ],
            [
                   "NO_NETWORK",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_NO_NETWORK_inline",
                   "No network access.",
            ],
            [
                   "No network access.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_NO_NETWORK_inline",
                   "",
            ],
            [
                   "DATABASE_IS_NOT_READY",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DATABASE_IS_NOT_READY_inline",
                   "Database is not ready.",
            ],
            [
                   "Database is not ready.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_DATABASE_IS_NOT_READY_inline",
                   "",
            ],
            [
                   "AREA_CODE_NOT_SAME",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_AREA_CODE_NOT_SAME_inline",
                   "The set area code is inconsistent with the local area code.",
            ],
            [
                   "The set area code is inconsistent with the local area code.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_AREA_CODE_NOT_SAME_inline",
                   "",
            ],
            [
                   "DJICameraError",
                   2,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "",
                   "Defines all camera-related errors.",
            ],
            [
                   "Defines all camera-related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJICameraError.html",
                   "",
                   "",
            ],
            [
                   "DJIFlightControllerError",
                   2,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "",
                   "Defines all flight controller errors.",
            ],
            [
                   "Defines all flight controller errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIFlightControllerError.html",
                   "",
                   "",
            ],
            [
                   "DJIMissionError",
                   2,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "",
                   "Defines all mission manager related errors.",
            ],
            [
                   "Defines all mission manager related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIMissionManagerError.html",
                   "",
                   "",
            ],
            [
                   "DJIAirLinkError",
                   2,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "",
                   "Defines all AirLink related errors.",
            ],
            [
                   "Defines all AirLink related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIAirLinkError.html",
                   "",
                   "",
            ],
            [
                   "DJIBatteryError",
                   2,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "",
                   "Defines all battery related errors.",
            ],
            [
                   "Defines all battery related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIBatteryError.html",
                   "",
                   "",
            ],
            [
                   "DJIFlySafeError",
                   2,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "",
                   "This class contains the error type for GEO feature.",
            ],
            [
                   "This class contains the error type for GEO feature.",
                   1,
                   "/Components/SDKError/DJIError_DJIGeoError.html",
                   "",
                   "",
            ],
            [
                   "DJIRemoteControllerError",
                   2,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "",
                   "Defines all remote controller related errors.",
            ],
            [
                   "Defines all remote controller related errors.",
                   1,
                   "/Components/SDKError/DJIError_DJIRemoteControllerError.html",
                   "",
                   "",
            ],
            [
                   "REGISTRATION_AESENCRYPT_FAILED",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_AESENCRYPT_FAILED_inline",
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
            ],
            [
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_AESENCRYPT_FAILED_inline",
                   "",
            ],
            [
                   "REGISTRATION_AESENCRYPT_ERROR",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_AESENCRYPT_ERROR_inline",
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
            ],
            [
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_AESENCRYPT_ERROR_inline",
                   "",
            ],
            [
                   "REGISTRATION_INVALID_UUID",
                   2,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_INVALID_UUID_inline",
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
            ],
            [
                   "Server error, please contact <https://djisdksupport.zendesk.com/hc/requests/new> for help.",
                   1,
                   "/Components/SDKError/DJIError_DJISDKError.html",
                   "#DJIError_DJISDKError_REGISTRATION_INVALID_UUID_inline",
                   "",
            ],
            [
                   "MEDIA_REQUEST_SERVER_ABORT",
                   2,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_SERVER_ABORT_inline",
                   "Media download error: the server aborted the downloading.",
            ],
            [
                   "Media download error: the server aborted the downloading.",
                   1,
                   "/Components/SDKError/DJIError.html",
                   "#DJIError_MEDIA_REQUEST_SERVER_ABORT_inline",
                   "",
            ],
            [
                   "Stick",
                   2,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_constructor_inline",
                   "Constructor of the stick object.  @param horizontalPosition stick's horizontal position value, the value it's in the range of [-660, 660]. @param verticalPosition stick's vertical position value, the value it's in the range of [-660, 660].",
            ],
            [
                   "Constructor of the stick object.  @param horizontalPosition stick's horizontal position value, the value it's in the range of [-660, 660]. @param verticalPosition stick's vertical position value, the value it's in the range of [-660, 660].",
                   1,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_constructor_inline",
                   "",
            ],
            [
                   "getHorizontalPosition",
                   2,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_getHorizontalPosition_inline",
                   "Get the stick's horizontal position value, the value it's in the range of [-660, 660].  @return An int value.",
            ],
            [
                   "Get the stick's horizontal position value, the value it's in the range of [-660, 660].  @return An int value.",
                   1,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_getHorizontalPosition_inline",
                   "",
            ],
            [
                   "getVerticalPosition",
                   2,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_getVerticalPosition_inline",
                   "Get the stick's vertical position value, the value it's in the range of [-660, 660].  @return An int value.",
            ],
            [
                   "Get the stick's vertical position value, the value it's in the range of [-660, 660].  @return An int value.",
                   1,
                   "/Components/Stick/DJIStick.html",
                   "#DJIStick_getVerticalPosition_inline",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_type_inline",
                   "Gets diagnostics type.  @return An enum value of `DJIDiagnosticsType`.",
            ],
            [
                   "Gets diagnostics type.  @return An enum value of `DJIDiagnosticsType`.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_type_inline",
                   "",
            ],
            [
                   "getCode",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_code_inline",
                   "Get diagnostics error code.  @return Diagnostics error code.",
            ],
            [
                   "Get diagnostics error code.  @return Diagnostics error code.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_code_inline",
                   "",
            ],
            [
                   "getReason",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_reason_inline",
                   "The reason of the error.  @return Reason of the error.",
            ],
            [
                   "The reason of the error.  @return Reason of the error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_reason_inline",
                   "",
            ],
            [
                   "getSolution",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_solution_inline",
                   "The suggested solution for the error.  @return The suggest solution for the error.",
            ],
            [
                   "The suggested solution for the error.  @return The suggest solution for the error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_solution_inline",
                   "",
            ],
            [
                   "getHealthInformation",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_healthInformation_inline",
                   "The device healthy information, only available when the component is DJIDi agnostics_DJIDiagnosticsWarningComponent_DeviceHealthInformation</code>.  @return An object of `DeviceHealthInformation`.",
            ],
            [
                   "The device healthy information, only available when the component is DJIDi agnostics_DJIDiagnosticsWarningComponent_DeviceHealthInformation</code>.  @return An object of `DeviceHealthInformation`.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_healthInformation_inline",
                   "",
            ],
            [
                   "CAMERA_UPGRADE_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraUpgradeError_inline",
                   "Camera upgrade error.",
            ],
            [
                   "Camera upgrade error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraUpgradeError_inline",
                   "",
            ],
            [
                   "CAMERA_SENSOR_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSensorError_inline",
                   "Camera sensor error.",
            ],
            [
                   "Camera sensor error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSensorError_inline",
                   "",
            ],
            [
                   "CAMERA_OVER_HEAT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraOverHeat_inline",
                   "Camera is overheated.",
            ],
            [
                   "Camera is overheated.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraOverHeat_inline",
                   "",
            ],
            [
                   "CAMERA_ENCRYPTION_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraEncryptionError_inline",
                   "Camera encryption error.",
            ],
            [
                   "Camera encryption error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraEncryptionError_inline",
                   "",
            ],
            [
                   "CAMERA_NO_SD_CARD",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraNoSDCard_inline",
                   "NO SD card.",
            ],
            [
                   "NO SD card.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraNoSDCard_inline",
                   "",
            ],
            [
                   "CAMERA_SD_CARD_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardError_inline",
                   "SD card error. For more detail, please refer to the reason and the solution.",
            ],
            [
                   "SD card error. For more detail, please refer to the reason and the solution.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardError_inline",
                   "",
            ],
            [
                   "CAMERA_SD_CARD_NO_SPACE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardNoSpace_inline",
                   "Remaining SD card capacity is not enough.",
            ],
            [
                   "Remaining SD card capacity is not enough.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardNoSpace_inline",
                   "",
            ],
            [
                   "CAMERA_SD_CARD_FULL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardFull_inline",
                   "SD card is full.",
            ],
            [
                   "SD card is full.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardFull_inline",
                   "",
            ],
            [
                   "CAMERA_SD_CARD_READ_ONLY",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardReadOnly_inline",
                   "SD card is readonly.",
            ],
            [
                   "SD card is readonly.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardReadOnly_inline",
                   "",
            ],
            [
                   "CAMERA_SD_CARD_NOT_FORMATTED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardNotFormatted_inline",
                   "SD card not formatted.",
            ],
            [
                   "SD card not formatted.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CameraSDCardNotFormatted_inline",
                   "",
            ],
            [
                   "CAMERA_CHIP_OVER_HEAT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipOverHeat_inline",
                   "Chip Over Heat.",
            ],
            [
                   "Chip Over Heat.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipOverHeat_inline",
                   "",
            ],
            [
                   "CAMERA_TemperaturesTooHighToStopRecord",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_TemperaturesTooHighToStopRecord_inline",
                   "Temperatures Too High To Stop Record.",
            ],
            [
                   "Temperatures Too High To Stop Record.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_TemperaturesTooHighToStopRecord_inline",
                   "",
            ],
            [
                   "GIMBAL_GYROSCOPE_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalGyroscopeError_inline",
                   "Gimbal gyroscope error.",
            ],
            [
                   "Gimbal gyroscope error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalGyroscopeError_inline",
                   "",
            ],
            [
                   "GIMBAL_PITCH_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalPitchError_inline",
                   "Gimbal pitch error.",
            ],
            [
                   "Gimbal pitch error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalPitchError_inline",
                   "",
            ],
            [
                   "GIMBAL_ROLL_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalRollError_inline",
                   "Gimbal roll error.",
            ],
            [
                   "Gimbal roll error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalRollError_inline",
                   "",
            ],
            [
                   "GIMBAL_YAW_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalYawError_inline",
                   "Gimbal yaw error.",
            ],
            [
                   "Gimbal yaw error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalYawError_inline",
                   "",
            ],
            [
                   "GIMBAL_CONNECT_TO_FC_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalConnectToFCError_inline",
                   "Gimbal cannot receive flight controller data.",
            ],
            [
                   "Gimbal cannot receive flight controller data.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalConnectToFCError_inline",
                   "",
            ],
            [
                   "BATTERY_DISCHARGE_OVER_CURRENT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryDischargeOverCurrent_inline",
                   "Battery current too high during discharge.",
            ],
            [
                   "Battery current too high during discharge.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryDischargeOverCurrent_inline",
                   "",
            ],
            [
                   "BATTERY_DISCHARGE_OVER_HEAT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryDischargeOverHeat_inline",
                   "Battery too hot during discharge.",
            ],
            [
                   "Battery too hot during discharge.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryDischargeOverHeat_inline",
                   "",
            ],
            [
                   "BATTERY_LOW_TEMPERATURE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryLowTemperature_inline",
                   "Low temperature environment: Battery not suitable for flight.",
            ],
            [
                   "Low temperature environment: Battery not suitable for flight.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryLowTemperature_inline",
                   "",
            ],
            [
                   "BATTERY_CELL_BROKEN",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryCellBroken_inline",
                   "Battery cell is broken.",
            ],
            [
                   "Battery cell is broken.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryCellBroken_inline",
                   "",
            ],
            [
                   "BATTERY_NEED_STUDY",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryNeedStudy_inline",
                   "Battery needs a complete charge and discharge cycle.",
            ],
            [
                   "Battery needs a complete charge and discharge cycle.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryNeedStudy_inline",
                   "",
            ],
            [
                   "BATTERY_ILLEGAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryIllegal_inline",
                   "Battery is not a DJI battery.",
            ],
            [
                   "Battery is not a DJI battery.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_BatteryIllegal_inline",
                   "",
            ],
            [
                   "SINGLE_BATTERY_MODE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_SingleBatteryMode_inline",
                   "Battery is in single battery mode.",
            ],
            [
                   "Battery is in single battery mode.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_SingleBatteryMode_inline",
                   "",
            ],
            [
                   "FAKE_BATTERY_MODE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FakeBatteryMode_inline",
                   "Battery is in fake battery mode.",
            ],
            [
                   "Battery is in fake battery mode.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FakeBatteryMode_inline",
                   "",
            ],
            [
                   "BATTERY_CYCLE_TIME_OVER",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CycleTimeOver_inline",
                   "Battery's cycle times is over",
            ],
            [
                   "Battery's cycle times is over",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CycleTimeOver_inline",
                   "",
            ],
            [
                   "BATTERY_DIFF_USAGE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_DiffUsage_inline",
                   "Old battery and new battery.",
            ],
            [
                   "Old battery and new battery.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_DiffUsage_inline",
                   "",
            ],
            [
                   "BATTERY_OVER_LOAD",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Overload_inline",
                   "Overload.",
            ],
            [
                   "Overload.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Overload_inline",
                   "",
            ],
            [
                   "BATTERY_LOW_VOLTAGE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltage_inline",
                   "Battery voltage is low.",
            ],
            [
                   "Battery voltage is low.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltage_inline",
                   "",
            ],
            [
                   "BATTERY_DANGEROUS_WARNING_SERIOUS",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_DangerousWarningSerious_inline",
                   "Dangerous Warning Serious.",
            ],
            [
                   "Dangerous Warning Serious.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_DangerousWarningSerious_inline",
                   "",
            ],
            [
                   "BATTERY_COMMUNICATION_FAIL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CommunicationFailed_inline",
                   "Battery communication failed.",
            ],
            [
                   "Battery communication failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CommunicationFailed_inline",
                   "",
            ],
            [
                   "BATTERY_SHORT_CUT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Shortcut_inline",
                   "Battery short-circuit.",
            ],
            [
                   "Battery short-circuit.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Shortcut_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_FPGA_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerFPGAError_inline",
                   "RC FPGA error.",
            ],
            [
                   "RC FPGA error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerFPGAError_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_TRANSMITTER_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerTransmitterError_inline",
                   "RC transmitter error.",
            ],
            [
                   "RC transmitter error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerTransmitterError_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_BATTERY_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerBatteryError_inline",
                   "RC battery error.",
            ],
            [
                   "RC battery error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerBatteryError_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_GPS_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerGPSError_inline",
                   "RC GPS error.",
            ],
            [
                   "RC GPS error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerGPSError_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_ENCRYPTION_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerEncryptionError_inline",
                   "RC encryption error.",
            ],
            [
                   "RC encryption error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerEncryptionError_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_NEED_CALIBRATION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerNeedCalibration_inline",
                   "RC is not calibrated.",
            ],
            [
                   "RC is not calibrated.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerNeedCalibration_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_BATTERY_LOW",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerBatteryLow_inline",
                   "RC battery low.",
            ],
            [
                   "RC battery low.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerBatteryLow_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_IDLE_TOO_LONG",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerIdleTooLong_inline",
                   "RC idle for too long.",
            ],
            [
                   "RC idle for too long.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerIdleTooLong_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_RESET",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerReset_inline",
                   "RC is reset, please check RC settings",
            ],
            [
                   "RC is reset, please check RC settings",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerReset_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_OVER_HEAT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerOverHeat_inline",
                   "RC overheated.",
            ],
            [
                   "RC overheated.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RemoteControllerOverHeat_inline",
                   "",
            ],
            [
                   "CENTRAL_BOARD_CONNECT_TO_BATTERY_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToBatteryError_inline",
                   "Battery connection to the center board has failed.",
            ],
            [
                   "Battery connection to the center board has failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToBatteryError_inline",
                   "",
            ],
            [
                   "CENTRAL_BOARD_CONNECT_TO_GPS_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToGPSError_inline",
                   "GPS connection to the center board has failed.",
            ],
            [
                   "GPS connection to the center board has failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToGPSError_inline",
                   "",
            ],
            [
                   "CENTRAL_BOARD_CONNECT_TO_FC_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToFCError_inline",
                   "Flight controller connection to the center board has failed.",
            ],
            [
                   "Flight controller connection to the center board has failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CentralBoardConnectToFCError_inline",
                   "",
            ],
            [
                   "VIDEO_DECODER_ENCRYPTION_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VideoDecoderEncryptionError_inline",
                   "Video decoder encryption error.",
            ],
            [
                   "Video decoder encryption error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VideoDecoderEncryptionError_inline",
                   "",
            ],
            [
                   "VIDEO_DECODER_CONNECT_TO_DESERIALIZER_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VideoDecoderConnectToDeserializerError_inline",
                   "Deserializer disconnected.",
            ],
            [
                   "Deserializer disconnected.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VideoDecoderConnectToDeserializerError_inline",
                   "",
            ],
            [
                   "AIR_ENCODER_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AirEncoderError_inline",
                   "Aircraft Encoder Error.",
            ],
            [
                   "Aircraft Encoder Error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AirEncoderError_inline",
                   "",
            ],
            [
                   "AIR_ENCODER_UPGRADE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AirEncoderUpgrade_inline",
                   "Aircraft updating.",
            ],
            [
                   "Aircraft updating.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AirEncoderUpgrade_inline",
                   "",
            ],
            [
                   "AIR_LINK_NO_SIGNAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoSignal_inline",
                   "No Signal.",
            ],
            [
                   "No Signal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoSignal_inline",
                   "",
            ],
            [
                   "AIR_LINK_LOW_RC_SIGNAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowRCSignal_inline",
                   "Low RC Signal.",
            ],
            [
                   "Low RC Signal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowRCSignal_inline",
                   "",
            ],
            [
                   "AIR_LINK_STRONG_RC_RADIO_SIGNAL_NOISE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongRCRadioSignalNoise_inline",
                   "Strong RC Radio Signal Noise.",
            ],
            [
                   "Strong RC Radio Signal Noise.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongRCRadioSignalNoise_inline",
                   "",
            ],
            [
                   "AIR_LINK_LOW_RADIO_SIGNAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowRadioSignal_inline",
                   "Low Radio Signal.",
            ],
            [
                   "Low Radio Signal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowRadioSignal_inline",
                   "",
            ],
            [
                   "AIR_LINK_STRONG_RADIO_SIGNAL_NOISE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongRadioSignalNoise_inline",
                   "Strong Radio Signal Noise.",
            ],
            [
                   "Strong Radio Signal Noise.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongRadioSignalNoise_inline",
                   "",
            ],
            [
                   "AIR_LINK_WIFI_MAGNETIC_INTERFERENCE_HIGH",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WiFiMagneticInterferenceHigh_inline",
                   "WiFi Magnetic Interference High.",
            ],
            [
                   "WiFi Magnetic Interference High.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WiFiMagneticInterferenceHigh_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_NEED_CALIBRATION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUNeedCalibration_inline",
                   "IMU calibration required.",
            ],
            [
                   "IMU calibration required.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUNeedCalibration_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_CALIBRATION_INCOMPLETE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUCalibrationIncomplete_inline",
                   "IMU calibration incomplete.",
            ],
            [
                   "IMU calibration incomplete.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUCalibrationIncomplete_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_DATA_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUDataError_inline",
                   "IMU data error.",
            ],
            [
                   "IMU data error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUDataError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUError_inline",
                   "General IMU error.",
            ],
            [
                   "General IMU error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_INIT_FAILED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUInitFailed_inline",
                   "IMU initialization failed.",
            ],
            [
                   "IMU initialization failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerIMUInitFailed_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_BAROMETER_INIT_FAILED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerBarometerInitFailed_inline",
                   "Barometer initialization failed.",
            ],
            [
                   "Barometer initialization failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerBarometerInitFailed_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_BAROMETER_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerBarometerError_inline",
                   "Barometer error.",
            ],
            [
                   "Barometer error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerBarometerError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ACCELEROMETER_INIT_FAILED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerAccelerometerInitFailed_inline",
                   "Accelerometer failed.",
            ],
            [
                   "Accelerometer failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerAccelerometerInitFailed_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_GYROSCOPE_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerGyroscopeError_inline",
                   "Gyroscope error.",
            ],
            [
                   "Gyroscope error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerGyroscopeError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ATTITUDE_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerAttitudeError_inline",
                   "Aircraft attitude angle is too large.",
            ],
            [
                   "Aircraft attitude angle is too large.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerAttitudeError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_DATA_RECORD_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerDataRecordError_inline",
                   "Data recorder errors.",
            ],
            [
                   "Data recorder errors.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerDataRecordError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_TAKEOFF_FAILED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerTakeoffFailed_inline",
                   "Take-off failure.",
            ],
            [
                   "Take-off failure.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerTakeoffFailed_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_SYSTEM_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerSystemError_inline",
                   "Unknown flight controller error.",
            ],
            [
                   "Unknown flight controller error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerSystemError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_IMU_HEATING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerImuHeating_inline",
                   "Imu is heating.",
            ],
            [
                   "Imu is heating.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerImuHeating_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_COMPASS_NEED_RESTART",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerCompassNeedRestart_inline",
                   "Compass needs restart.",
            ],
            [
                   "Compass needs restart.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerCompassNeedRestart_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_COMPASS_ABNORMAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerCompassAbnormal_inline",
                   "Compass abnormal.",
            ],
            [
                   "Compass abnormal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerCompassAbnormal_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_USING_WRONG_PROPELLERS",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerUsingWrongPropellers_inline",
                   "Using the wrong propellers. Inspire 2 has propellers for high altitudes and low altitudes. This error will be present when the wrong propellers are being used at the wrong altitude.",
            ],
            [
                   "Using the wrong propellers. Inspire 2 has propellers for high altitudes and low altitudes. This error will be present when the wrong propellers are being used at the wrong altitude.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightControllerUsingWrongPropellers_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_NEED_CALIBRATION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSystemNeedCalibration_inline",
                   "Vision system calibration is required.",
            ],
            [
                   "Vision system calibration is required.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSystemNeedCalibration_inline",
                   "",
            ],
            [
                   "VISION_PROPELLER_GUARD",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionPropellerGuard_inline",
                   "Propeller Guard Mounted.",
            ],
            [
                   "Propeller Guard Mounted.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionPropellerGuard_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorError_inline",
                   "Vision sensor error.",
            ],
            [
                   "Vision sensor error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorError_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_CALIBRATION_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorCalibrationError_inline",
                   "Vision sensor calibration error.",
            ],
            [
                   "Vision sensor calibration error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorCalibrationError_inline",
                   "",
            ],
            [
                   "VISION_SENSOR_COMMUNICATION_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorCommunicationError_inline",
                   "Vision sensor communication error.",
            ],
            [
                   "Vision sensor communication error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSensorCommunicationError_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSystemError_inline",
                   "Vision system error.",
            ],
            [
                   "Vision system error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_VisionSystemError_inline",
                   "",
            ],
            [
                   "GIMBAL_LOCATE_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalLocateError_inline",
                   "Gimbal locate error.",
            ],
            [
                   "Gimbal locate error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GimbalLocateError_inline",
                   "",
            ],
            [
                   "RTK_POSITIONING_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RTKPositioningError_inline",
                   "RTK Positioning error.",
            ],
            [
                   "RTK Positioning error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RTKPositioningError_inline",
                   "",
            ],
            [
                   "RTK_ORIENTEERING_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RTKOrienteeringError_inline",
                   "RTK Orienteering error.",
            ],
            [
                   "RTK Orienteering error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_RTKOrienteeringError_inline",
                   "",
            ],
            [
                   "VISION_WEAK_AMBIENT_LIGHT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WeakAmbientLight_inline",
                   "Weak Ambient Light error.",
            ],
            [
                   "Weak Ambient Light error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WeakAmbientLight_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MC_READING_DATA",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MCReadingData_inline",
                   "MC is reading flight data.",
            ],
            [
                   "MC is reading flight data.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MCReadingData_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MC_DATA_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MCDataError_inline",
                   "MC data error.",
            ],
            [
                   "MC data error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MCDataError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_BATTERY_NOT_IN_POSITION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NotInPosition_inline",
                   "Not in Position error.",
            ],
            [
                   "Not in Position error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NotInPosition_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_NOT_ENOUGH_FORCE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NotEnoughForce_inline",
                   "Aircraft has not enough force.",
            ],
            [
                   "Aircraft has not enough force.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NotEnoughForce_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_GO_HOME_FAIL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GoHomeFailed_inline",
                   "Go home failed.",
            ],
            [
                   "Go home failed.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GoHomeFailed_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_OUT_OF_CONTROL_GOING_HOME",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OutOfControlGoingHome_inline",
                   "Remote controller out of controller, except when aircraft go home.",
            ],
            [
                   "Remote controller out of controller, except when aircraft go home.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OutOfControlGoingHome_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_GPS_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GPSError_inline",
                   "Aircraft GPS Error.",
            ],
            [
                   "Aircraft GPS Error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GPSError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_COMPASS_INSTALL_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CompassInstallError_inline",
                   "Compass Install Error.",
            ],
            [
                   "Compass Install Error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CompassInstallError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ONLY_SUPPORT_ATTI_MODE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OnlySupportAttiMode_inline",
                   "Only Support Atti Mode.",
            ],
            [
                   "Only Support Atti Mode.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OnlySupportAttiMode_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_WATER_SURFACE_WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WaterSurfaceWarning_inline",
                   "Water Surface Warning.",
            ],
            [
                   "Water Surface Warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_WaterSurfaceWarning_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_KERNEL_BOARD_HIGH_TEMPERATURE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_KernelBoardHighTemperature_inline",
                   "Kernel Board High Temperature.",
            ],
            [
                   "Kernel Board High Temperature.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_KernelBoardHighTemperature_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ENABLE_NEAR_GROUND_ALERT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnableNearGroundAlert_inline",
                   "Enable Near Ground Alert.",
            ],
            [
                   "Enable Near Ground Alert.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnableNearGroundAlert_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_HEADING_CONTROL_ABNORMAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeadingControlAbnormal_inline",
                   "Heading Control Abnormal.",
            ],
            [
                   "Heading Control Abnormal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeadingControlAbnormal_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_TILT_CONTROL_ABNORMAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_TiltControlAbnormal_inline",
                   "Tilt Control Abnormal.",
            ],
            [
                   "Tilt Control Abnormal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_TiltControlAbnormal_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_AIRCRAFT_VIBRATION_ABNORMAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftVibrationAbnormal_inline",
                   "Aircraft Vibration Abnormal.",
            ],
            [
                   "Aircraft Vibration Abnormal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftVibrationAbnormal_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_PADDLE_HAS_ICE_ON_IT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_PaddleHasIceOnIt_inline",
                   "Paddle Has Ice On It.",
            ],
            [
                   "Paddle Has Ice On It.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_PaddleHasIceOnIt_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_GPS_SIGNAL_BLOCKED_BY_GIMBAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GPSSignalBlockedByGimbal_inline",
                   "GPS Signal Blocked By Gimbal.",
            ],
            [
                   "GPS Signal Blocked By Gimbal.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_GPSSignalBlockedByGimbal_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MOTOR_BLOCKED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorBlocked_inline",
                   "Motor Blocked.",
            ],
            [
                   "Motor Blocked.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorBlocked_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_SMART_LOW_POWER_GO_HOME",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_SmartLowPowerGoHome_inline",
                   "Smart Low Power Go Home.",
            ],
            [
                   "Smart Low Power Go Home.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_SmartLowPowerGoHome_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_OVER_HEAT_GO_HOME",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OverHeatGoHome_inline",
                   "Over Heat Go Home.",
            ],
            [
                   "Over Heat Go Home.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OverHeatGoHome_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_OUT_OF_FLIGHT_RADIUS_LIMIT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OutOfFlightRadiusLimit_inline",
                   "Out Of Flight Radius Limit.",
            ],
            [
                   "Out Of Flight Radius Limit.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_OutOfFlightRadiusLimit_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_LOW_VOLTAGE_GOING_HOME",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltageGoingHome_inline",
                   "Low Voltage GoingHome.",
            ],
            [
                   "Low Voltage GoingHome.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltageGoingHome_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_LOW_VOLTAGE_LANDING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltageLanding_inline",
                   "Low Voltage Landing.",
            ],
            [
                   "Low Voltage Landing.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LowVoltageLanding_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_HEIGHT_LIMIT_MOVE_TO_OPEN_FIELD",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitMoveToOpenField_inline",
                   "GPS initialization, the flying altitude is limited.",
            ],
            [
                   "GPS initialization, the flying altitude is limited.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitMoveToOpenField_inline",
                   "",
            ],
            [
                   "PRODUCT_AIRCRAFT_DISCONNECTED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ProductAircraftDisconnected_inline",
                   "Aircraft is disconnected.",
            ],
            [
                   "Aircraft is disconnected.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ProductAircraftDisconnected_inline",
                   "",
            ],
            [
                   "PRODUCT_RC_DISCONNECTED",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ProductRCDisconnected_inline",
                   "Remote controller is disconnected.",
            ],
            [
                   "Remote controller is disconnected.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ProductRCDisconnected_inline",
                   "",
            ],
            [
                   "CAMERA_CHIP_OVER_HEAT_STOP_RECORD_WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipOverHeatStopRecordWarning_inline",
                   "Chip over heat warning.",
            ],
            [
                   "Chip over heat warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipOverHeatStopRecordWarning_inline",
                   "",
            ],
            [
                   "AIR_LINK_CHIPS_TEMPERATURE_WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureWarning_inline",
                   "Chip Temperature Warning.",
            ],
            [
                   "Chip Temperature Warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureWarning_inline",
                   "",
            ],
            [
                   "AIR_LINK_CHIPS_TEMPERATURE_DANGEREROUS",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureDangerous_inline",
                   "Chip Temperature Dangerous.",
            ],
            [
                   "Chip Temperature Dangerous.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureDangerous_inline",
                   "",
            ],
            [
                   "AIR_LINK_CHIPS_TEMPERATURE_WARNING_IN_AIR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureWarningInAir_inline",
                   "Chip Temperature Warning.",
            ],
            [
                   "Chip Temperature Warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureWarningInAir_inline",
                   "",
            ],
            [
                   "AIR_LINK_CHIPS_TEMPERATURE_DANGEREROUS_IN_AIR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureDangerousInAir_inline",
                   "Chip Temperature Dangerous.",
            ],
            [
                   "Chip Temperature Dangerous.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ChipsTemperatureDangerousInAir_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MOTOR_START_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStartError_inline",
                   "Motor start error.",
            ],
            [
                   "Motor start error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStartError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_NO_PROPELLER",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoPropeller_inline",
                   "Aircraft propeller damage.",
            ],
            [
                   "Aircraft propeller damage.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoPropeller_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MOTOR_STOP_REASON",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStopReason_inline",
                   "Motor stop error.",
            ],
            [
                   "Motor stop error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStopReason_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_FORBID_SIDE_FLY_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ForbidSideFlyError_inline",
                   "In APAS mode the forbid side fly switch is turned on, Cannot fly sideways.",
            ],
            [
                   "In APAS mode the forbid side fly switch is turned on, Cannot fly sideways.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ForbidSideFlyError_inline",
                   "",
            ],
            [
                   "CAMERA_ABNORMAL_REBOOT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Abnormalreboot_inline",
                   "Abnormal reboot.",
            ],
            [
                   "Abnormal reboot.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_Abnormalreboot_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_AIRCRAFT_NORMAL_FLIGHT_ATTI",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftNormalFlightAtti_inline",
                   "Aircraft in Attitude mode. Unable to hover.",
            ],
            [
                   "Aircraft in Attitude mode. Unable to hover.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftNormalFlightAtti_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MOTOR_POWER_ABNORMAL_NEED_CHECK",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorPowerAbnormalNeedCheck_inline",
                   "The motor power is abnormal, and the propeller needs to be checked.",
            ],
            [
                   "The motor power is abnormal, and the propeller needs to be checked.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorPowerAbnormalNeedCheck_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_FLIGHT_ACTION_FLY_LIMIT_ZONE_LANDING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightActionFlyLimitZoneLanding_inline",
                   "Aircraft is in the no fly zone and can't fly.",
            ],
            [
                   "Aircraft is in the no fly zone and can't fly.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_FlightActionFlyLimitZoneLanding_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_HEIGHT_LIMIT_REASON_NO_GPS",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitReasonNoGPS_inline",
                   "Height Limit Reason No GPS.",
            ],
            [
                   "Height Limit Reason No GPS.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitReasonNoGPS_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_HEIGHT_LIMIT_REASON_COMPASS_INTERRUPT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitReasonCompassInterrupt_inline",
                   "Height Limit Reason Compass Interrupt.",
            ],
            [
                   "Height Limit Reason Compass Interrupt.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_HeightLimitReasonCompassInterrupt_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ENV_STATE_TEMP_TOO_HIGH",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnvStateTempTooHigh_inline",
                   "Env State Temp Too High.",
            ],
            [
                   "Env State Temp Too High.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnvStateTempTooHigh_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_ENV_STATE_TEMP_TOO_LOW",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnvStateTempTooLow_inline",
                   "Env State Temp Too Low.",
            ],
            [
                   "Env State Temp Too Low.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_EnvStateTempTooLow_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_COVER_FLIGHT_ENABLE_LIMIT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CoverFlightEnableLimit_inline",
                   "Cover Flight Enable Limit.",
            ],
            [
                   "Cover Flight Enable Limit.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_CoverFlightEnableLimit_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_MOTOR_STOP_FOR_ESC_SHORT_CIRCUIT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStopForEscShortCircuit_inline",
                   "Motor Stop For Esc Short Circuit.",
            ],
            [
                   "Motor Stop For Esc Short Circuit.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_MotorStopForEscShortCircuit_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_NO_REAL_NAME_HEIGHT_LIMIT",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoRealNameHeightLimit_inline",
                   "No Real Name Height Limit.",
            ],
            [
                   "No Real Name Height Limit.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_NoRealNameHeightLimit_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_THREE_PROPELLER_EMERGENCY_LANDING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ThreePropellerEmergencyLanding_inline",
                   "Three Propeller Emergency Landing.",
            ],
            [
                   "Three Propeller Emergency Landing.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_ThreePropellerEmergencyLanding_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_LANDING_PROTECTION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LandingProtection_inline",
                   "Landing Protection.",
            ],
            [
                   "Landing Protection.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_LandingProtection_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_AIRCRAFT_PROPULSION_SYSTEM_ERROR",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftPropulsionSystemError_inline",
                   "Aircraft Propulsion System Error.",
            ],
            [
                   "Aircraft Propulsion System Error.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_AircraftPropulsionSystemError_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_STRONG_GALE_WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongGaleWarning_inline",
                   "Strong gale warning.",
            ],
            [
                   "Strong gale warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_StrongGaleWarning_inline",
                   "",
            ],
            [
                   "DJIDiagnosticsError",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_inline",
                   "DJIDiagnosticsError.",
            ],
            [
                   "DJIDiagnosticsError.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsError_inline",
                   "",
            ],
            [
                   "DJIDiagnosticsType",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_inline",
                   "Diagnostics components type.",
            ],
            [
                   "Diagnostics components type.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_inline",
                   "",
            ],
            [
                   "BATTERY",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_BATTERY_inline",
                   "Battery component.",
            ],
            [
                   "Battery component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_BATTERY_inline",
                   "",
            ],
            [
                   "CAMERA",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_CAMERA_inline",
                   "Camera component.",
            ],
            [
                   "Camera component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_CAMERA_inline",
                   "",
            ],
            [
                   "CENTER_BOARD",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_CENTER_BOARD_inline",
                   "Center board component.",
            ],
            [
                   "Center board component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_CENTER_BOARD_inline",
                   "",
            ],
            [
                   "ON_SCREEN_DISPLAY",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_ON_SCREEN_DISPLAY_inline",
                   "Components' error often shown on the main screen.",
            ],
            [
                   "Components' error often shown on the main screen.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_ON_SCREEN_DISPLAY_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_FLIGHT_CONTROLLER_inline",
                   "Flight controller component.",
            ],
            [
                   "Flight controller component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_FLIGHT_CONTROLLER_inline",
                   "",
            ],
            [
                   "GIMBAL",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_GIMBAL_inline",
                   "Gimbal component.",
            ],
            [
                   "Gimbal component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_GIMBAL_inline",
                   "",
            ],
            [
                   "LIGHTBRIDGE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_LIGHTBRIDGE_inline",
                   "Lightbridge component.",
            ],
            [
                   "Lightbridge component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_LIGHTBRIDGE_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_REMOTE_CONTROLLER_inline",
                   "Remote controller component.",
            ],
            [
                   "Remote controller component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_REMOTE_CONTROLLER_inline",
                   "",
            ],
            [
                   "VISION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_VISION_inline",
                   "Vision component.",
            ],
            [
                   "Vision component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_VISION_inline",
                   "",
            ],
            [
                   "RTK",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_RTK_inline",
                   "RTK component.",
            ],
            [
                   "RTK component.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_RTK_inline",
                   "",
            ],
            [
                   "DEVICE_HEALTH_INFORMATION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_DEVICE_HEALTH_INFORMATION_inline",
                   "Device health information. Only supported by some components of Matrice 300 RTK and Zenmuse H20 series. It is recommended to use device health information to replace old diagnostics for flight controller and RTK. There will be a few duplicated component error for gimbal, battery, perception module on Matrice 300 RTK. Find error code and detailed description information in the Readme file on Github (https://github.com/dji-sdk/Mobile-SDK-Android/blob/master/README.md)",
            ],
            [
                   "Device health information. Only supported by some components of Matrice 300 RTK and Zenmuse H20 series. It is recommended to use device health information to replace old diagnostics for flight controller and RTK. There will be a few duplicated component error for gimbal, battery, perception module on Matrice 300 RTK. Find error code and detailed description information in the Readme file on Github (https://github.com/dji-sdk/Mobile-SDK-Android/blob/master/README.md)",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_DEVICE_HEALTH_INFORMATION_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_OTHER_inline",
                   "Other.",
            ],
            [
                   "Other.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DJIDiagnosticsType_OTHER_inline",
                   "",
            ],
            [
                   "WarningLevel",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_inline",
                   "Warning level for components' health information.",
            ],
            [
                   "Warning level for components' health information.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_None_inline",
                   "No warning.",
            ],
            [
                   "No warning.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_None_inline",
                   "",
            ],
            [
                   "NOTICE",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Notice_inline",
                   "Device health information notice.",
            ],
            [
                   "Device health information notice.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Notice_inline",
                   "",
            ],
            [
                   "CAUTION",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Caution_inline",
                   "Warning message. Fly with caution.",
            ],
            [
                   "Warning message. Fly with caution.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Caution_inline",
                   "",
            ],
            [
                   "WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Warning_inline",
                   "Warning message.",
            ],
            [
                   "Warning message.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Warning_inline",
                   "",
            ],
            [
                   "SERIOUS_WARNING",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformation_WarningLevel_SeriousWarning_inline",
                   "Serious warning message.",
            ],
            [
                   "Serious warning message.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformation_WarningLevel_SeriousWarning_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics.html",
                   "#DJIDiagnostics_DeviceHealthInformationWarningLevel_Unknown_inline",
                   "",
            ],
            [
                   "DiagnosticsInformationCallback",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DiagnosticsInformationCallbackInterface.html",
                   "",
                   "Callback interface that updates the product's current diagnostics information.",
            ],
            [
                   "Callback interface that updates the product's current diagnostics information.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DiagnosticsInformationCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DiagnosticsInformationCallbackInterface.html",
                   "#DJIDiagnostics_onUpdateDiagnosticsList_inline",
                   "Callback interface that updates the product's current diagnostics information.  @param diagnosticsList The List of `DJIDiagnostics` instance.",
            ],
            [
                   "Callback interface that updates the product's current diagnostics information.  @param diagnosticsList The List of `DJIDiagnostics` instance.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DiagnosticsInformationCallbackInterface.html",
                   "#DJIDiagnostics_onUpdateDiagnosticsList_inline",
                   "",
            ],
            [
                   "DeviceHealthInformation",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "",
                   "Product Diagnostics device healthy information. Only supported by some components of Matrice 300 RTK and Zenmuse H20 series. It is recommended to use device health information to replace old diagnostics for flight controller and RTK. There will be a few duplicated component error for gimbal, battery, perception module on Matrice 300 RTK. Find error code and detailed description on Github (https://github.com/dji-sdk/Mobile-SDK-Android).",
            ],
            [
                   "Product Diagnostics device healthy information. Only supported by some components of Matrice 300 RTK and Zenmuse H20 series. It is recommended to use device health information to replace old diagnostics for flight controller and RTK. There will be a few duplicated component error for gimbal, battery, perception module on Matrice 300 RTK. Find error code and detailed description on Github (https://github.com/dji-sdk/Mobile-SDK-Android).",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "",
                   "",
            ],
            [
                   "informationId",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_informationId_inline",
                   "A unique code. You can find the detailed information at Github (https://github.com/dji-sdk/Mobile-SDK-Android).  @return A long value of the information id.",
            ],
            [
                   "A unique code. You can find the detailed information at Github (https://github.com/dji-sdk/Mobile-SDK-Android).  @return A long value of the information id.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_informationId_inline",
                   "",
            ],
            [
                   "sensorIndex",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_sensorIndex_inline",
                   "Sensor index of a certain device module.  @return An int value of the sensor index.",
            ],
            [
                   "Sensor index of a certain device module.  @return An int value of the sensor index.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_sensorIndex_inline",
                   "",
            ],
            [
                   "componentId",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_componentIndex_inline",
                   "Added for double camera and double gimbal, this method could return the index of Component.  @return An int value of the component id.",
            ],
            [
                   "Added for double camera and double gimbal, this method could return the index of Component.  @return An int value of the component id.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_componentIndex_inline",
                   "",
            ],
            [
                   "getWarningLevel",
                   2,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_warningLevel_inline",
                   "Warning level.  @return An enum value of `WarningLevel`.",
            ],
            [
                   "Warning level.  @return An enum value of `WarningLevel`.",
                   1,
                   "/Components/Diagnostics/DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation.html",
                   "#DJIDiagnostics_DJIDiagnosticsDeviceHealthInformation_warningLevel_inline",
                   "",
            ],
            [
                   "getBaseStationReferencingLocation",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_getBaseStationReferencingLocation_inline",
                   "Gets the referencing location manually configured to the  base station. When a user can get a more accurate  location (coordinate with less absolute error) of the base  station by using external tools, the accurate location can  be set to the base station to improve the accuracy of the  aircraft location. If the offset between the referencing  location and the location detected by the ground system is  larger than 5 meters, the base station will ignore the referencing location. It is only supported by Phantom 4 RTK and M200 series v2 and Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets the referencing location manually configured to the  base station. When a user can get a more accurate  location (coordinate with less absolute error) of the base  station by using external tools, the accurate location can  be set to the base station to improve the accuracy of the  aircraft location. If the offset between the referencing  location and the location detected by the ground system is  larger than 5 meters, the base station will ignore the referencing location. It is only supported by Phantom 4 RTK and M200 series v2 and Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_getBaseStationReferencingLocation_inline",
                   "",
            ],
            [
                   "setBaseStationReferencingLocation",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_setBaseStationReferencingLocation_inline",
                   "Sets the referencing location of the base station to improve the accuracy.  When a user  can get a more accurate location (coordinate with less absolute error) of the base station  by using external tools, the accurate location can be set to the  base station to improve  the accuracy of the aircraft location. If the offset between  the referencing location and  the location detected by the base station is larger than  5 meters, the base station will ignore the referencing location. It is only supported  by Phantom 4 RTK and M200 series v2 and Matrice 300 RTK. For Matrice 300 RTK, device  administrator authentication is required before invoking this method.  @param location The referencing location of the base station. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Sets the referencing location of the base station to improve the accuracy.  When a user  can get a more accurate location (coordinate with less absolute error) of the base station  by using external tools, the accurate location can be set to the  base station to improve  the accuracy of the aircraft location. If the offset between  the referencing location and  the location detected by the base station is larger than  5 meters, the base station will ignore the referencing location. It is only supported  by Phantom 4 RTK and M200 series v2 and Matrice 300 RTK. For Matrice 300 RTK, device  administrator authentication is required before invoking this method.  @param location The referencing location of the base station. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_setBaseStationReferencingLocation_inline",
                   "",
            ],
            [
                   "resetBaseStationReferencingLocation",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_resetRTKBaseStationLocation_inline",
                   "Reset RTK base station's location. This will make base station's location type became `AUTO`. The previously set location  by `setBaseStationReferencingLocation` will be invalid. For Matrice 300 RTK, device administrator authentication is required before invoking this method.  @param callback Callback that receives the execution result.",
            ],
            [
                   "Reset RTK base station's location. This will make base station's location type became `AUTO`. The previously set location  by `setBaseStationReferencingLocation` will be invalid. For Matrice 300 RTK, device administrator authentication is required before invoking this method.  @param callback Callback that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_resetRTKBaseStationLocation_inline",
                   "",
            ],
            [
                   "hasDeviceAdminLoggedIn",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_hasDeviceAdminLoggedIn_inline",
                   "`true` if device administrator has logged in. For Matrice 300 RTK, device administrator authentication is required before  changing any settings, including base station's name, base station's password, and base station's referencing location.  Device administrator login is required every time when the application is relaunched. Please login with default password  123456, if the base station's password is reset. Supported only by Matrice 300 RTK.  @return The result whether login or not.",
            ],
            [
                   "`true` if device administrator has logged in. For Matrice 300 RTK, device administrator authentication is required before  changing any settings, including base station's name, base station's password, and base station's referencing location.  Device administrator login is required every time when the application is relaunched. Please login with default password  123456, if the base station's password is reset. Supported only by Matrice 300 RTK.  @return The result whether login or not.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_hasDeviceAdminLoggedIn_inline",
                   "",
            ],
            [
                   "logInAsDeviceAdmin",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_logInAsDeviceAdmin_inline",
                   "Log in as base station administrator account with password to change setting. User will need to login again in the following scenarios:  -  Enter the application for the first time.  - Re-enter after the application restarts.  - Reset password via the button on the base  station.  - Switch and connect other base stations.  The default password is `123456`. It is only supported by Matrice 300 RTK.  @param password The password of base station. @param callback The completion callback block that receives the result.",
            ],
            [
                   "Log in as base station administrator account with password to change setting. User will need to login again in the following scenarios:  -  Enter the application for the first time.  - Re-enter after the application restarts.  - Reset password via the button on the base  station.  - Switch and connect other base stations.  The default password is `123456`. It is only supported by Matrice 300 RTK.  @param password The password of base station. @param callback The completion callback block that receives the result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_logInAsDeviceAdmin_inline",
                   "",
            ],
            [
                   "logOut",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_logOut_inline",
                   "Log out of the base station. It is only supported by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Log out of the base station. It is only supported by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_logOut_inline",
                   "",
            ],
            [
                   "changePassword",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_changePassword_inline",
                   "Change the password for current base station. The password must be 6 digits. It is only supported by Matrice 300 RTK.  @param oldPassword The old password. @param newPassword The new password that you want to change. @param callback The completion callback that receives the result.",
            ],
            [
                   "Change the password for current base station. The password must be 6 digits. It is only supported by Matrice 300 RTK.  @param oldPassword The old password. @param newPassword The new password that you want to change. @param callback The completion callback that receives the result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_changePassword_inline",
                   "",
            ],
            [
                   "setName",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_setName_inline",
                   "Change the name of the base station. The name is composed of maximum 4 characters or numbers.  Please log in before invoking this method. It is only supported by Matrice 300 RTK.  @param name The name of the base station set by the user. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Change the name of the base station. The name is composed of maximum 4 characters or numbers.  Please log in before invoking this method. It is only supported by Matrice 300 RTK.  @param name The name of the base station set by the user. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_setName_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_getName_inline",
                   "Gets the name of the base station. Please log in before invoking this method. It is only supported by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets the name of the base station. Please log in before invoking this method. It is only supported by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_getName_inline",
                   "",
            ],
            [
                   "addBaseStationBatteryStateUpdatedCallback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_addBaseStationBatteryStateUpdatedCallback_inline",
                   "Adds a callback to receive the latest base station battery state. Only Supported by Phantom  4 RTK and M200 series v2.  @param callback Callback to receive base station battery state.",
            ],
            [
                   "Adds a callback to receive the latest base station battery state. Only Supported by Phantom  4 RTK and M200 series v2.  @param callback Callback to receive base station battery state.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_addBaseStationBatteryStateUpdatedCallback_inline",
                   "",
            ],
            [
                   "removeBaseStationBatteryStateUpdatedCallback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_removeBaseStationBatteryStateUpdatedCallback_inline",
                   "Removes a callback that receives the latest base station battery state. Only Supported by  Phantom 4 RTK and M200 series v2.  @param callback Callback to receive base station battery state.",
            ],
            [
                   "Removes a callback that receives the latest base station battery state. Only Supported by  Phantom 4 RTK and M200 series v2.  @param callback Callback to receive base station battery state.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_removeBaseStationBatteryStateUpdatedCallback_inline",
                   "",
            ],
            [
                   "addBaseStationStateUpdatedCallback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_addBaseStationStateUpdatedCallback_inline",
                   "Adds a callback to receive the latest base station state. Only Supported by Phantom 4 RTK and M200 series v2.  @param callback Callback to receive base station state.",
            ],
            [
                   "Adds a callback to receive the latest base station state. Only Supported by Phantom 4 RTK and M200 series v2.  @param callback Callback to receive base station state.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_addBaseStationStateUpdatedCallback_inline",
                   "",
            ],
            [
                   "removeBaseStationStateUpdatedCallback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_removeBaseStationStateUpdatedCallback_inline",
                   "Removes a callback that receives the latest base station state.  @param callback Callback to receive base station state.",
            ],
            [
                   "Removes a callback that receives the latest base station state.  @param callback Callback to receive base station state.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_removeBaseStationStateUpdatedCallback_inline",
                   "",
            ],
            [
                   "BaseStationLocationType",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_inline",
                   "All the possible basestation location type of `BaseStationLocationType`.",
            ],
            [
                   "All the possible basestation location type of `BaseStationLocationType`.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Auto_inline",
                   "BaseStation current location is auto calculateed by BaseStation itself.",
            ],
            [
                   "BaseStation current location is auto calculateed by BaseStation itself.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Auto_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Manual_inline",
                   "BaseStation current location is manually set by user.",
            ],
            [
                   "BaseStation current location is manually set by user.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Manual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Unknown_inline",
                   "Unknown BaseStation location type.",
            ],
            [
                   "Unknown BaseStation location type.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationLocationType_Unknown_inline",
                   "",
            ],
            [
                   "BaseStationBatteryState",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "",
                   "RTK Base Station Current Battery State.",
            ],
            [
                   "RTK Base Station Current Battery State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "",
                   "",
            ],
            [
                   "getVoltage",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_voltage_inline",
                   "Returns the current RTK base station battery voltage (mV).  @return An int value of the current RTK base station battery voltage.",
            ],
            [
                   "Returns the current RTK base station battery voltage (mV).  @return An int value of the current RTK base station battery voltage.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_voltage_inline",
                   "",
            ],
            [
                   "getCurrent",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_current_inline",
                   "Returns the real time current draw of the RTK base station battery (mA).  @return An int value of the current draw of the RTK base station battery.",
            ],
            [
                   "Returns the real time current draw of the RTK base station battery (mA).  @return An int value of the current draw of the RTK base station battery.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_current_inline",
                   "",
            ],
            [
                   "getTemperature",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_temperature_inline",
                   "Returns the current RTK base station battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value of the current RTK base station battery's temperature.",
            ],
            [
                   "Returns the current RTK base station battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value of the current RTK base station battery's temperature.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_temperature_inline",
                   "",
            ],
            [
                   "getCapacityPercent",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_capacityPercent_inline",
                   "Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close  to 100%. As a battery experiences charge/discharge cycles, the value will go down.  @return An int value of the battery's remaining lifetime as a percentage.",
            ],
            [
                   "Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close  to 100%. As a battery experiences charge/discharge cycles, the value will go down.  @return An int value of the battery's remaining lifetime as a percentage.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_capacityPercent_inline",
                   "",
            ],
            [
                   "BaseStationState",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "",
                   "RTK Base Station Current State.",
            ],
            [
                   "RTK Base Station Current State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "",
                   "",
            ],
            [
                   "isAllowedToUse",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_isAllowedToUse_inline",
                   "Gets if the base station is allowed to use in current country.  @return A boolean value.",
            ],
            [
                   "Gets if the base station is allowed to use in current country.  @return A boolean value.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_isAllowedToUse_inline",
                   "",
            ],
            [
                   "getBaseStationLocationType",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_baseStationLocationType_inline",
                   "Gets RTK baseStation location type. See `BaseStationLocationType`.  @return An enum value of `BaseStationLocationType`.",
            ],
            [
                   "Gets RTK baseStation location type. See `BaseStationLocationType`.  @return An enum value of `BaseStationLocationType`.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationState.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_baseStationLocationType_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationStateCallbackInterface.html",
                   "",
                   "Callback Interface for RTK Base Station State.",
            ],
            [
                   "Callback Interface for RTK Base Station State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdateBaseStationState",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationStateCallbackInterface.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_onUpdateBaseStationState_inline",
                   "Callback function that updates the RTK base station state. Only Supported  by Phantom 4 RTK and M200 series V2. This is only available on D-RTK 2 with firmware version v01.00.0300 or above.  @param baseStationState Base Station State.",
            ],
            [
                   "Callback function that updates the RTK base station state. Only Supported  by Phantom 4 RTK and M200 series V2. This is only available on D-RTK 2 with firmware version v01.00.0300 or above.  @param baseStationState Base Station State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationStateCallbackInterface.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationState_onUpdateBaseStationState_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryStateCallbackInterface.html",
                   "",
                   "Callback Interface for RTK Base Station Battery State.",
            ],
            [
                   "Callback Interface for RTK Base Station Battery State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdateBaseStationBatteryState",
                   2,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryStateCallbackInterface.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_onUpdateBaseStationBatteryState_inline",
                   "Callback function that updates the RTK base station battery state. Only Supported by Phantom 4 RTK and M200 series v2.  @param state Base Station Battery State.",
            ],
            [
                   "Callback function that updates the RTK base station battery state. Only Supported by Phantom 4 RTK and M200 series v2.  @param state Base Station Battery State.",
                   1,
                   "/Components/RTKBaseStation/DJIRTKBaseStation_DJIRTKBaseStationBatteryStateCallbackInterface.html",
                   "#DJIRTKBaseStation_DJIRTKBaseStationBatteryState_onUpdateBaseStationBatteryState_inline",
                   "",
            ],
            [
                   "getInstance",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getInstance_inline",
                   "Accessor for `RTKNetworkServiceProvider` object.  @return An instance of the `RTKNetworkServiceProvider` object.",
            ],
            [
                   "Accessor for `RTKNetworkServiceProvider` object.  @return An instance of the `RTKNetworkServiceProvider` object.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getInstance_inline",
                   "",
            ],
            [
                   "setCustomNetworkSettings",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_setNetworkServiceSettings_inline",
                   "Sets the configuration for the network service that provides network reference stations.  The network service should use NTRIP (Networked Transport of RTCM via Internet Protocol).  @param settings The configuration to set.",
            ],
            [
                   "Sets the configuration for the network service that provides network reference stations.  The network service should use NTRIP (Networked Transport of RTCM via Internet Protocol).  @param settings The configuration to set.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_setNetworkServiceSettings_inline",
                   "",
            ],
            [
                   "getCustomNetworkSettings",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_networkServiceSettings_inline",
                   "Gets the configuration for the network service that provides network reference stations.  The network service should use NTRIP(Networked Transport of RTCM via Internet Protocol).  @return An instance of `NetworkServiceSettings`.",
            ],
            [
                   "Gets the configuration for the network service that provides network reference stations.  The network service should use NTRIP(Networked Transport of RTCM via Internet Protocol).  @return An instance of `NetworkServiceSettings`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_networkServiceSettings_inline",
                   "",
            ],
            [
                   "startNetworkService",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_startNetworkService_inline",
                   "Starts the network service as the reference station. This should be called after setting the  network service (`setCustomNetworkSettings`).  @param callback The completion block that receives the result.",
            ],
            [
                   "Starts the network service as the reference station. This should be called after setting the  network service (`setCustomNetworkSettings`).  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_startNetworkService_inline",
                   "",
            ],
            [
                   "startNetworkService",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_startNetworkServiceWithCoordinateSystem_inline",
                   "Starts the network service as the reference station. This should be called after setting the  network service (`setCustomNetworkSettings`).  @param coordinateSystem The coordinateSystem to set when init rtk service @param callback The completion block that receives the result.",
            ],
            [
                   "Starts the network service as the reference station. This should be called after setting the  network service (`setCustomNetworkSettings`).  @param coordinateSystem The coordinateSystem to set when init rtk service @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_startNetworkServiceWithCoordinateSystem_inline",
                   "",
            ],
            [
                   "stopNetworkService",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_stopNetworkService_inline",
                   "Stops the network service.  @param callback The completion block that receives the result.",
            ],
            [
                   "Stops the network service.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_stopNetworkService_inline",
                   "",
            ],
            [
                   "addNetworkServiceStateCallback",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_addNetworkServiceStateListener_inline",
                   "Adds a listener to receive the latest network service state.  @param callback The completion block that receives the result.",
            ],
            [
                   "Adds a listener to receive the latest network service state.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_addNetworkServiceStateListener_inline",
                   "",
            ],
            [
                   "removeNetworkServiceStateCallback",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_removeNetworkServiceStateListener_inline",
                   "Removes a listener that is added by passing to `addNetworkServiceStateCallback`.  @param callback The completion block that receives the result.",
            ],
            [
                   "Removes a listener that is added by passing to `addNetworkServiceStateCallback`.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_removeNetworkServiceStateListener_inline",
                   "",
            ],
            [
                   "setNetworkServiceCoordinateSystem",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_setCoordinateSystem_inline",
                   "Sets coordinate system for rtk network service. Only can be used when  current `ReferenceStationSource` is `NETWORK_RTK`,  and please make sure the `getChannelState` is `TRANSMITTING`.  @param coordinateSystem The `DJIRTK_DJIRTKNetworkServiceCoordinateSystem` to set. @param callback The completion block that receives the result.",
            ],
            [
                   "Sets coordinate system for rtk network service. Only can be used when  current `ReferenceStationSource` is `NETWORK_RTK`,  and please make sure the `getChannelState` is `TRANSMITTING`.  @param coordinateSystem The `DJIRTK_DJIRTKNetworkServiceCoordinateSystem` to set. @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_setCoordinateSystem_inline",
                   "",
            ],
            [
                   "getNetworkServiceCoordinateSystem",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getCoordinateSystem_inline",
                   "Gets current network RTK coordinate system. Only can be used when  current `ReferenceStationSource` is `NETWORK_RTK`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current network RTK coordinate system. Only can be used when  current `ReferenceStationSource` is `NETWORK_RTK`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getCoordinateSystem_inline",
                   "",
            ],
            [
                   "activateNetworkService",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_activateNetworkService_inline",
                   "Activates network RTK `activateNetworkService`.  @param planType Plan type to activate. @param callback The completion block that receives the result.",
            ],
            [
                   "Activates network RTK `activateNetworkService`.  @param planType Plan type to activate. @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_activateNetworkService_inline",
                   "",
            ],
            [
                   "getNetworkServiceOrderPlans",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getNetworkServiceOrderPlans_inline",
                   "Gets network service plans.  @param callback The completion block that receives the result.",
            ],
            [
                   "Gets network service plans.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_getNetworkServiceOrderPlans_inline",
                   "",
            ],
            [
                   "NetworkServiceChannelState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_inline",
                   "All the possible state of `NetworkServiceChannelState`.",
            ],
            [
                   "All the possible state of `NetworkServiceChannelState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_inline",
                   "",
            ],
            [
                   "DISABLED",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Disabled_inline",
                   "The network service is not started.",
            ],
            [
                   "The network service is not started.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Disabled_inline",
                   "",
            ],
            [
                   "ACCOUNT_EXPIRED",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Expired_inline",
                   "User account has expired.",
            ],
            [
                   "User account has expired.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Expired_inline",
                   "",
            ],
            [
                   "NETWORK_NOT_REACHABLE",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_NetworkNotReachable_inline",
                   "The network is not reachable from the mobile device.",
            ],
            [
                   "The network is not reachable from the mobile device.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_NetworkNotReachable_inline",
                   "",
            ],
            [
                   "AIRCRAFT_DISCONNECTED",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_AircraftDisconnected_inline",
                   "The aircraft is not connected.",
            ],
            [
                   "The aircraft is not connected.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_AircraftDisconnected_inline",
                   "",
            ],
            [
                   "RTK_DONGLE_DISCONNECTED",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_RTKDongleDisconnected_inline",
                   "TThe RTK Dongle is not connected.",
            ],
            [
                   "TThe RTK Dongle is not connected.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_RTKDongleDisconnected_inline",
                   "",
            ],
            [
                   "LOGIN_FAILURE",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_LoginFailure_inline",
                   "SDK cannot login with the provided username and password.  Check `getError`.",
            ],
            [
                   "SDK cannot login with the provided username and password.  Check `getError`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_LoginFailure_inline",
                   "",
            ],
            [
                   "TRANSMITTING",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Transmitting_inline",
                   "Data is transmitting through the channel.",
            ],
            [
                   "Data is transmitting through the channel.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Transmitting_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Disconnected_inline",
                   "The channel is disconnected and the server is not reachable now. Check `getError`.",
            ],
            [
                   "The channel is disconnected and the server is not reachable now. Check `getError`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Disconnected_inline",
                   "",
            ],
            [
                   "ACCOUNT_ERROR",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_AccountError_inline",
                   "User account error. Check `getError`.",
            ],
            [
                   "User account error. Check `getError`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_AccountError_inline",
                   "",
            ],
            [
                   "SERVER_NOT_REACHABLE",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_ServerNotReachable_inline",
                   "Unable to connect to server.",
            ],
            [
                   "Unable to connect to server.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_ServerNotReachable_inline",
                   "",
            ],
            [
                   "CONNECTING",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Connecting_inline",
                   "Connecting to server.",
            ],
            [
                   "Connecting to server.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Connecting_inline",
                   "",
            ],
            [
                   "SERVICE_SUSPENSION",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_ServiceSuspension_inline",
                   "The account for network RTK plan A has been expired, please activate plan B.",
            ],
            [
                   "The account for network RTK plan A has been expired, please activate plan B.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_ServiceSuspension_inline",
                   "",
            ],
            [
                   "INVALID_REQUEST",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_InvalidRequest_inline",
                   "The invalid request is rejected by the server.",
            ],
            [
                   "The invalid request is rejected by the server.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_InvalidRequest_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceChannelState_Unknown_inline",
                   "",
            ],
            [
                   "NetworkServiceState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "",
                   "The state of network service that provides reference station information.",
            ],
            [
                   "The state of network service that provides reference station information.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "",
                   "",
            ],
            [
                   "getChannelState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_channelState_inline",
                   "The state of the channel from the aircraft to the server that provides RTK network service.  @return The enum value of `NetworkServiceChannelState`.",
            ],
            [
                   "The state of the channel from the aircraft to the server that provides RTK network service.  @return The enum value of `NetworkServiceChannelState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_channelState_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_error_inline",
                   "The encountered error if any when building up the channel from the aircraft to the server  that provides RTK network service.  @return The object of `DJIRTKNetworkServiceError`.",
            ],
            [
                   "The encountered error if any when building up the channel from the aircraft to the server  that provides RTK network service.  @return The object of `DJIRTKNetworkServiceError`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_error_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback.html",
                   "",
                   "Callback that receives the network service state.",
            ],
            [
                   "Callback that receives the network service state.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback.html",
                   "",
                   "",
            ],
            [
                   "onNetworkServiceStateUpdate",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback_onNetworkServiceStateUpdate_inline",
                   "Called when the network service state has been updated.  @param networkServiceState The state of the network service.",
            ],
            [
                   "Called when the network service state has been updated.  @param networkServiceState The state of the network service.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceState_callback_onNetworkServiceStateUpdate_inline",
                   "",
            ],
            [
                   "NetworkServicePlan",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "",
                   "Network service Plan information.",
            ],
            [
                   "Network service Plan information.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "",
                   "",
            ],
            [
                   "getPlanState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_state_inline",
                   "Gets network RTK plan state.  @return An enum value of `NetworkServicePlanState`.",
            ],
            [
                   "Gets network RTK plan state.  @return An enum value of `NetworkServicePlanState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_state_inline",
                   "",
            ],
            [
                   "getActivationDate",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_activationDate_inline",
                   "Gets network RTK plan activation date.  @return A String value of activation date.",
            ],
            [
                   "Gets network RTK plan activation date.  @return A String value of activation date.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_activationDate_inline",
                   "",
            ],
            [
                   "getExpirationDate",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_expirationDate_inline",
                   "Gets network RTK plan expiration date.  @return A String value of expiration date.",
            ],
            [
                   "Gets network RTK plan expiration date.  @return A String value of expiration date.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_expirationDate_inline",
                   "",
            ],
            [
                   "getPlanName",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_planType_inline",
                   "Gets network RTK plan type.  @return A enum value of `NetworkServicePlanType`.",
            ],
            [
                   "Gets network RTK plan type.  @return A enum value of `NetworkServicePlanType`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlan_planType_inline",
                   "",
            ],
            [
                   "NetworkServicePlansState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "",
                   "Gets state of network service plans.",
            ],
            [
                   "Gets state of network service plans.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_state_inline",
                   "Gets current account state.  @return An enum value of `NetworkServiceAccountState`.",
            ],
            [
                   "Gets current account state.  @return An enum value of `NetworkServiceAccountState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_state_inline",
                   "",
            ],
            [
                   "getSupportedRenewalTimes",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_supportedRenewalTimes_inline",
                   "Gets current account supported renewal times.  @return An int value.",
            ],
            [
                   "Gets current account supported renewal times.  @return An int value.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_supportedRenewalTimes_inline",
                   "",
            ],
            [
                   "getPlans",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_plans_inline",
                   "Gets network RTK plans.  @return An enum value of `NetworkServiceAccountState`.",
            ],
            [
                   "Gets network RTK plans.  @return An enum value of `NetworkServiceAccountState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_plans_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "",
                   "The class is used to build a `NetworkServicePlansState` instance.",
            ],
            [
                   "The class is used to build a `NetworkServicePlansState` instance.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "",
                   "",
            ],
            [
                   "state",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_state_inline",
                   "Sets current account state.  @param state An enum value of `NetworkServiceAccountState`.  @return A builder instance.",
            ],
            [
                   "Sets current account state.  @param state An enum value of `NetworkServiceAccountState`.  @return A builder instance.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_state_inline",
                   "",
            ],
            [
                   "supportedRenewalTimes",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_supportedRenewalTimes_inline",
                   "Sets network RTK supported renewal times.  @param supportedRenewalTimes An int value.  @return A builder instance.",
            ],
            [
                   "Sets network RTK supported renewal times.  @param supportedRenewalTimes An int value.  @return A builder instance.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_supportedRenewalTimes_inline",
                   "",
            ],
            [
                   "plans",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_plans_inline",
                   "Sets network RTK plans.  @param plans A List of `NetworkServicePlan`.  @return A builder instance.",
            ],
            [
                   "Sets network RTK plans.  @param plans A List of `NetworkServicePlan`.  @return A builder instance.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_plans_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_build_inline",
                   "Builds an instance of `NetworkServicePlansState`.  @return An instance of `NetworkServicePlansState`.",
            ],
            [
                   "Builds an instance of `NetworkServicePlansState`.  @return An instance of `NetworkServicePlansState`.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServicePlansState_Builder_build_inline",
                   "",
            ],
            [
                   "RTKBaseStationInformation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "",
                   "The class is used to save the information of the base station. Only supported by Matrice 300 RTK series.",
            ],
            [
                   "The class is used to save the information of the base station. Only supported by Matrice 300 RTK series.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "",
                   "",
            ],
            [
                   "getBaseStationID",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_baseStationID_inline",
                   "Gets the scanned base station's ID.  @return A long value of the base station id.",
            ],
            [
                   "Gets the scanned base station's ID.  @return A long value of the base station id.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_baseStationID_inline",
                   "",
            ],
            [
                   "getBaseStationName",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_baseStationName_inline",
                   "Gets the scanned base station's name.  @return A String value.",
            ],
            [
                   "Gets the scanned base station's name.  @return A String value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_baseStationName_inline",
                   "",
            ],
            [
                   "getSignalLevel",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_signalLevel_inline",
                   "Gets the signal level of the base station. The signal is in range [0, 5], where 5 is the strongest signal.  @return An int value.",
            ],
            [
                   "Gets the signal level of the base station. The signal is in range [0, 5], where 5 is the strongest signal.  @return An int value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKBaseStationInformation.html",
                   "#DJIRTK_DJIRTKBaseStationInformation_signalLevel_inline",
                   "",
            ],
            [
                   "RTKConnectionStateWithBaseStationReferenceSource",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_inline",
                   "All the possible connection state of DJIRTKConnectionStateWithBaseStationReferenceSource  when `ReferenceStationSource`  is  `BASE_STATION`.  It is only supported by Matrice 300 RTK.",
            ],
            [
                   "All the possible connection state of DJIRTKConnectionStateWithBaseStationReferenceSource  when `ReferenceStationSource`  is  `BASE_STATION`.  It is only supported by Matrice 300 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_AircraftRTKIdle_inline",
                   "Aircraft RTK is in idle state.",
            ],
            [
                   "Aircraft RTK is in idle state.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_AircraftRTKIdle_inline",
                   "",
            ],
            [
                   "SCANNING",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_AircraftRTKScanning_inline",
                   "Aircraft is scanning all base stations that are possible to be connected.",
            ],
            [
                   "Aircraft is scanning all base stations that are possible to be connected.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_AircraftRTKScanning_inline",
                   "",
            ],
            [
                   "CONNECTING",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationConnecting_inline",
                   "The aircraft is connecting with the base station.",
            ],
            [
                   "The aircraft is connecting with the base station.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationConnecting_inline",
                   "",
            ],
            [
                   "CONNECTED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationConnected_inline",
                   "The aircraft is connected with the base station.",
            ],
            [
                   "The aircraft is connected with the base station.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationConnected_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationDisconnected_inline",
                   "The aircraft is disconnected from the base station.",
            ],
            [
                   "The aircraft is disconnected from the base station.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_BaseStationDisconnected_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_Unknown_inline",
                   "Unknown base station location connection state.",
            ],
            [
                   "Unknown base station location connection state.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKConnectionStateWithBaseStationReferenceSource_Unknown_inline",
                   "",
            ],
            [
                   "NetworkServiceSettings",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "",
                   "Settings for the network service that provides RTK reference station information.",
            ],
            [
                   "Settings for the network service that provides RTK reference station information.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "",
                   "",
            ],
            [
                   "getServerAddress",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_serverAddress_inline",
                   "The IP address or the domain name of the server that provides RTK network services.  @return A String value of the IP address or the domain name of the server.",
            ],
            [
                   "The IP address or the domain name of the server that provides RTK network services.  @return A String value of the IP address or the domain name of the server.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_serverAddress_inline",
                   "",
            ],
            [
                   "getPort",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_port_inline",
                   "The port number that SDK should connect to.  @return The int value of port number.",
            ],
            [
                   "The port number that SDK should connect to.  @return The int value of port number.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_port_inline",
                   "",
            ],
            [
                   "getUserName",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_userName_inline",
                   "User name to access the network service.  @return String value of the account user name.",
            ],
            [
                   "User name to access the network service.  @return String value of the account user name.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_userName_inline",
                   "",
            ],
            [
                   "getPassword",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_password_inline",
                   "Password to access the network service.  @return String value of the account password.",
            ],
            [
                   "Password to access the network service.  @return String value of the account password.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_password_inline",
                   "",
            ],
            [
                   "getMountPoint",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_mountpoint_inline",
                   "Mountpoint of the network service, which is a source ID for every streamed NtripSource.  @return String value of the MountPoint.",
            ],
            [
                   "Mountpoint of the network service, which is a source ID for every streamed NtripSource.  @return String value of the MountPoint.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings.html",
                   "#DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_mountpoint_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_Builder.html",
                   "",
                   "The class is used to build a `NetworkServiceSettings` instance.",
            ],
            [
                   "The class is used to build a `NetworkServiceSettings` instance.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider_DJIRTKNetworkServiceSettings_Builder.html",
                   "",
                   "",
            ],
            [
                   "getAppActivationState",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_appActivationState_inline",
                   "Current App Activation state.  @return An enum value of `AppActivationState`.",
            ],
            [
                   "Current App Activation state.  @return An enum value of `AppActivationState`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_appActivationState_inline",
                   "",
            ],
            [
                   "getAircraftBindingState",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_aircraftBindingState_inline",
                   "Current aircraft binding state. Users in China need to bind additional account details with  the aircraft one-time through DJI Go. These details need to be bound and the application  needs to be activated by logging into their DJI Go account to lift the flight restrictions.  @return An enum value of `AircraftBindingState`.",
            ],
            [
                   "Current aircraft binding state. Users in China need to bind additional account details with  the aircraft one-time through DJI Go. These details need to be bound and the application  needs to be activated by logging into their DJI Go account to lift the flight restrictions.  @return An enum value of `AircraftBindingState`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_aircraftBindingState_inline",
                   "",
            ],
            [
                   "addAircraftBindingStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_addAircraftBindingStateListener_inline",
                   "Add the Aircraft binding state listener.  @param listener A listener of `AircraftBindingStateListener`.",
            ],
            [
                   "Add the Aircraft binding state listener.  @param listener A listener of `AircraftBindingStateListener`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_addAircraftBindingStateListener_inline",
                   "",
            ],
            [
                   "addAppActivationStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_addAppActivationStateListener_inline",
                   "Add listener for the app activation state update.  @param listener A listener of `AppActivationStateListener`.",
            ],
            [
                   "Add listener for the app activation state update.  @param listener A listener of `AppActivationStateListener`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_addAppActivationStateListener_inline",
                   "",
            ],
            [
                   "removeAircraftBindingStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_removeAircraftBindingStateListener_inline",
                   "Remove the aircraft binding state listener.  @param listener A listener of `AircraftBindingStateListener`.",
            ],
            [
                   "Remove the aircraft binding state listener.  @param listener A listener of `AircraftBindingStateListener`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_removeAircraftBindingStateListener_inline",
                   "",
            ],
            [
                   "removeAppActivationStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_removeAppActivationStateListener_inline",
                   "Remove activation state listener.  @param listener A listener of `AppActivationStateListener`.",
            ],
            [
                   "Remove activation state listener.  @param listener A listener of `AppActivationStateListener`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_removeAppActivationStateListener_inline",
                   "",
            ],
            [
                   "AircraftBindingState",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_inline",
                   "The aircraft's binding state.",
            ],
            [
                   "The aircraft's binding state.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_inline",
                   "",
            ],
            [
                   "INITIAL",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Initial_inline",
                   "The binding state of the aircraft is not yet determined. The aircraft will only be in this  state until DJI Go or a DJI Mobile SDK based application rights the binding information to  the aircraft. Binding is only required if the user is in China. If the user is not in China,  then this state will become `NOT_REQUIRED` after the  country code check is complete. If country code check has been disabled, the user will need  to use DJI Go to move to the `NOT_REQUIRED` state. In  this state, the aircraft will have the 30m height and 50m radius limitation.",
            ],
            [
                   "The binding state of the aircraft is not yet determined. The aircraft will only be in this  state until DJI Go or a DJI Mobile SDK based application rights the binding information to  the aircraft. Binding is only required if the user is in China. If the user is not in China,  then this state will become `NOT_REQUIRED` after the  country code check is complete. If country code check has been disabled, the user will need  to use DJI Go to move to the `NOT_REQUIRED` state. In  this state, the aircraft will have the 30m height and 50m radius limitation.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Initial_inline",
                   "",
            ],
            [
                   "UNBOUND",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Unbound_inline",
                   "The aircraft is not currently bound, and needs to be (as it is in China). In this state, the  aircraft will have 30m max flight height and 50m max flight distance limitation. User should  finish the one-off binding process with DJI Go to remove the flight limitation.",
            ],
            [
                   "The aircraft is not currently bound, and needs to be (as it is in China). In this state, the  aircraft will have 30m max flight height and 50m max flight distance limitation. User should  finish the one-off binding process with DJI Go to remove the flight limitation.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Unbound_inline",
                   "",
            ],
            [
                   "UNBOUND_BUT_CANNOT_SYNC",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_UnboundButCannotSync_inline",
                   "The aircraft is flying inside China and is unbound. The aircraft can be bound using DJI Go.  If DJI Go is connected to the aircraft, then the binding will be stored in the aircraft. If  DJI Go is not connected to the aircraft during the binding process, then the binding result  will be stored on a server. The SDK can query this server to see if the binding has already  happened, and if it has, download the binding to the aircraft. However, if the aircraft is  unbound, and the server is not reachable, then this state will be presented. The user should  connect the mobile device to the Internet to refresh this state.",
            ],
            [
                   "The aircraft is flying inside China and is unbound. The aircraft can be bound using DJI Go.  If DJI Go is connected to the aircraft, then the binding will be stored in the aircraft. If  DJI Go is not connected to the aircraft during the binding process, then the binding result  will be stored on a server. The SDK can query this server to see if the binding has already  happened, and if it has, download the binding to the aircraft. However, if the aircraft is  unbound, and the server is not reachable, then this state will be presented. The user should  connect the mobile device to the Internet to refresh this state.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_UnboundButCannotSync_inline",
                   "",
            ],
            [
                   "BOUND",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Bound_inline",
                   "The aircraft is bound.",
            ],
            [
                   "The aircraft is bound.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Bound_inline",
                   "",
            ],
            [
                   "NOT_REQUIRED",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_NotRequired_inline",
                   "The aircraft is not bound but it is not currently located in China. Therefore, binding the aircraft is not required.",
            ],
            [
                   "The aircraft is not bound but it is not currently located in China. Therefore, binding the aircraft is not required.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_NotRequired_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_NotSupported_inline",
                   "The aircraft's firmware does not support the App Activation system.",
            ],
            [
                   "The aircraft's firmware does not support the App Activation system.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_NotSupported_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Unknown_inline",
                   "Either the aircraft is disconnected or the connected product is not a DJI aircraft.",
            ],
            [
                   "Either the aircraft is disconnected or the connected product is not a DJI aircraft.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationAircraftBindingState_Unknown_inline",
                   "",
            ],
            [
                   "AppActivationState",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_inline",
                   "The App Activation state.",
            ],
            [
                   "The App Activation state.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_NotSupported_inline",
                   "The aircraft's firmware does not support the App Activation System.",
            ],
            [
                   "The aircraft's firmware does not support the App Activation System.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_NotSupported_inline",
                   "",
            ],
            [
                   "LOGIN_REQUIRED",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_LoginRequired_inline",
                   "The application needs to be activated by the user through their DJI account. Use `UserAccountManager` to enable the user to log in. Log in is only required if the  aircraft is located in China.",
            ],
            [
                   "The application needs to be activated by the user through their DJI account. Use `UserAccountManager` to enable the user to log in. Log in is only required if the  aircraft is located in China.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_LoginRequired_inline",
                   "",
            ],
            [
                   "ACTIVATED",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_Activated_inline",
                   "The application is activated and flight restrictions turned off.",
            ],
            [
                   "The application is activated and flight restrictions turned off.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_Activated_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_Unknown_inline",
                   "Either the aircraft is disconnected or the connected product is not a DJI aircraft.",
            ],
            [
                   "Either the aircraft is disconnected or the connected product is not a DJI aircraft.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager.html",
                   "#DJIAppActivationManager_DJIAppActivationState_Unknown_inline",
                   "",
            ],
            [
                   "AircraftBindingStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager_AircraftBindingStateListenerInterface.html",
                   "",
                   "An interface for obtaining `AircraftBindingState`.",
            ],
            [
                   "An interface for obtaining `AircraftBindingState`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager_AircraftBindingStateListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "AppActivationStateListener",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager_AppActivationStateListenerInterface.html",
                   "",
                   "An interface for obtaining `AppActivationState`.",
            ],
            [
                   "An interface for obtaining `AppActivationState`.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager_AppActivationStateListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager_AppActivationStateListenerInterface.html",
                   "#DJIAppActivationManager_AppActivationStateOnUpdateCallback_inline",
                   "Called when the App Activation state changes.  @param state The App Activation state. Use this state to check if login is required to  unrestrict the flight limitation.",
            ],
            [
                   "Called when the App Activation state changes.  @param state The App Activation state. Use this state to check if login is required to  unrestrict the flight limitation.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager_AppActivationStateListenerInterface.html",
                   "#DJIAppActivationManager_AppActivationStateOnUpdateCallback_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AppActivationManager/DJIAppActivationManager_AircraftBindingStateListenerInterface.html",
                   "#DJIAppActivationManager_AircraftBindingStateOnUpdateCallback_inline",
                   "Called when the App Activation manager updates the aircraft binding state.  @param state The aircraft binding state. Use this state to check if it is required to use  DJI Go to bind the aircraft.",
            ],
            [
                   "Called when the App Activation manager updates the aircraft binding state.  @param state The aircraft binding state. Use this state to check if it is required to use  DJI Go to bind the aircraft.",
                   1,
                   "/Components/AppActivationManager/DJIAppActivationManager_AircraftBindingStateListenerInterface.html",
                   "#DJIAppActivationManager_AircraftBindingStateOnUpdateCallback_inline",
                   "",
            ],
            [
                   "getWidgetType",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_type_inline",
                   "Get the type of the widget. Different types have different type of values.  @return The type of the payload widget.",
            ],
            [
                   "Get the type of the widget. Different types have different type of values.  @return The type of the payload widget.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_type_inline",
                   "",
            ],
            [
                   "getWidgetIndex",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_index_inline",
                   "Get the index of the widget. An index is used to differentiate widgets of the same type.  @return The index of the payload widget, same type of widgets must have different index.",
            ],
            [
                   "Get the index of the widget. An index is used to differentiate widgets of the same type.  @return The index of the payload widget, same type of widgets must have different index.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_index_inline",
                   "",
            ],
            [
                   "getWidgetValue",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_value_inline",
                   "Get the value of the payload widget.  @return The value of the payload widget, the widget of INPUT type will return an int value of 0(normal) or 1(pressed), SWITCH  type will return a int value of 0(switch off) or 1(switch on), RANGE type will return a int value from 0 to 100 (inclusive),  LIST type will return a int value from 0 to N (N is determined by firmware), INPUT type will return any int value which is set previously.",
            ],
            [
                   "Get the value of the payload widget.  @return The value of the payload widget, the widget of INPUT type will return an int value of 0(normal) or 1(pressed), SWITCH  type will return a int value of 0(switch off) or 1(switch on), RANGE type will return a int value from 0 to 100 (inclusive),  LIST type will return a int value from 0 to N (N is determined by firmware), INPUT type will return any int value which is set previously.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_value_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_name_inline",
                   "Get the name of the widget. This is determined by the payload device and not configurable  through the mobile device.  @return The name of the payload widget.",
            ],
            [
                   "Get the name of the widget. This is determined by the payload device and not configurable  through the mobile device.  @return The name of the payload widget.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_name_inline",
                   "",
            ],
            [
                   "getHintMsg",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_getHintMsg_inline",
                   "Get the hint message of the payload widget.  @return The hint message of the payload widget, INPUT type of widget might has a hint message which describe the function of the widget.",
            ],
            [
                   "Get the hint message of the payload widget.  @return The hint message of the payload widget, INPUT type of widget might has a hint message which describe the function of the widget.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_getHintMsg_inline",
                   "",
            ],
            [
                   "getSubItems",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_getSubItems_inline",
                   "Get the sub items list of the payload widget.  @return The sub items list of the payload widget, LIST type widget could return the sub items, which describe the options or different functions  related with the widget value, for example, if the widget has a list of sub items with size of 5, then the widget could accept the  widget value between 0 to 4 (inclusive), the string with index of 0 will describe the function if the widget value of 0 is set.",
            ],
            [
                   "Get the sub items list of the payload widget.  @return The sub items list of the payload widget, LIST type widget could return the sub items, which describe the options or different functions  related with the widget value, for example, if the widget has a list of sub items with size of 5, then the widget could accept the  widget value between 0 to 4 (inclusive), the string with index of 0 will describe the function if the widget value of 0 is set.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_getSubItems_inline",
                   "",
            ],
            [
                   "PayloadWidget",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_inline",
                   "Common widget information.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name.",
            ],
            [
                   "Common widget information.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_inline",
                   "",
            ],
            [
                   "PayloadWidget",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_WithHint_inline",
                   "Common widget information with message hint.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param hintMsg A hint message string.",
            ],
            [
                   "Common widget information with message hint.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param hintMsg A hint message string.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_WithHint_inline",
                   "",
            ],
            [
                   "PayloadWidget",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_list_inline",
                   "List widget information with the sub items.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param subItems A list of sub items strings.",
            ],
            [
                   "List widget information with the sub items.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param subItems A list of sub items strings.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_list_inline",
                   "",
            ],
            [
                   "PayloadWidget",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_List_WithHint_inline",
                   "List widget information with the sub items and message hint.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param hintMsg A hint message string. @param subItems A list of sub items strings.",
            ],
            [
                   "List widget information with the sub items and message hint.  @param widgetType An enum value of `PayloadWidgetType`. @param widgetIndex The widget index. @param widgetValue The value of the widget. @param name The widget name. @param hintMsg A hint message string. @param subItems A list of sub items strings.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_Constructor_List_WithHint_inline",
                   "",
            ],
            [
                   "PayloadWidgetType",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_inline",
                   "Types of widgets on the payload device.",
            ],
            [
                   "Types of widgets on the payload device.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_None_inline",
                   "Other unknown widget type.",
            ],
            [
                   "Other unknown widget type.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_None_inline",
                   "",
            ],
            [
                   "BUTTON",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Button_inline",
                   "Button, button widget could return the widget value of 1 or 0, normally it's widget value is 0, when  the button is being pressed the widget value will change to 1.",
            ],
            [
                   "Button, button widget could return the widget value of 1 or 0, normally it's widget value is 0, when  the button is being pressed the widget value will change to 1.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Button_inline",
                   "",
            ],
            [
                   "SWITCH",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Switch_inline",
                   "Switch, switch widget could return the widget value of 1 or 0, when the switch is changed  to ON state, the widget value will change to 1, if the switch is changed to OFF state,  the widget value will change to 0.",
            ],
            [
                   "Switch, switch widget could return the widget value of 1 or 0, when the switch is changed  to ON state, the widget value will change to 1, if the switch is changed to OFF state,  the widget value will change to 0.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Switch_inline",
                   "",
            ],
            [
                   "RANGE",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Range_inline",
                   "Range, range widget could return the widget value between 0 - 100 (inclusive).",
            ],
            [
                   "Range, range widget could return the widget value between 0 - 100 (inclusive).",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Range_inline",
                   "",
            ],
            [
                   "LIST",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_List_inline",
                   "List, list widget could return the int value between 0 and N, N is determined by the firmware,  the size of sub items returned by getSubItems() method in PayloadWidget will be N+1",
            ],
            [
                   "List, list widget could return the int value between 0 and N, N is determined by the firmware,  the size of sub items returned by getSubItems() method in PayloadWidget will be N+1",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_List_inline",
                   "",
            ],
            [
                   "INPUT",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Input_inline",
                   "Input widget could be set with any int value, the default value is determined by the firmware.",
            ],
            [
                   "Input widget could be set with any int value, the default value is determined by the firmware.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "#DJIPayload_PayloadWidget_WidgetType_Input_inline",
                   "",
            ],
            [
                   "PayloadWidgetListener",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetListener.html",
                   "",
                   "Payload widgets listener.",
            ],
            [
                   "Payload widgets listener.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetListener.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetListener.html",
                   "#DJIPayload_PayloadWidgetListener_onUpdate_inline",
                   "Updates a set of payload widgets.  @param widgets The updated value for widgets.",
            ],
            [
                   "Updates a set of payload widgets.  @param widgets The updated value for widgets.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetListener.html",
                   "#DJIPayload_PayloadWidgetListener_onUpdate_inline",
                   "",
            ],
            [
                   "PayloadWidgetDownloadListener",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "",
                   "Payload widget Download listener.",
            ],
            [
                   "Payload widget Download listener.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "",
                   "",
            ],
            [
                   "onProgress",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onProgress_inline",
                   "Called when fetching widget data is in progress.  @param process The value is from 0 to 100.",
            ],
            [
                   "Called when fetching widget data is in progress.  @param process The value is from 0 to 100.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onProgress_inline",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onSuccess_inline",
                   "Called when fetching widget data successful.",
            ],
            [
                   "Called when fetching widget data successful.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onFailure_inline",
                   "Called when the payload file download failed.  @param error The error information.",
            ],
            [
                   "Called when the payload file download failed.  @param error The error information.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidgetDownloadListener.html",
                   "#DJIPayload_PayloadWidgetDownloadListener_onFailure_inline",
                   "",
            ],
            [
                   "destroyCodec",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_destroyCodec_inline",
                   "Destroys the media codec.",
            ],
            [
                   "Destroys the media codec.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_destroyCodec_inline",
                   "",
            ],
            [
                   "DJICodecManager",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_constructor_inline",
                   "Constructor for the class.  @param context The context. @param surfaceTexture The surface texture view. @param width The width of surface texture view. @param height The height of surface texture view.",
            ],
            [
                   "Constructor for the class.  @param context The context. @param surfaceTexture The surface texture view. @param width The width of surface texture view. @param height The height of surface texture view.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_constructor_inline",
                   "",
            ],
            [
                   "DJICodecManager",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_constructor_surfaceHolder_inline",
                   "Constructor for the class.  @param context The context. @param surfaceHolder The surface view. @param width The width of surface texture view. @param height The height of surface texture view.",
            ],
            [
                   "Constructor for the class.  @param context The context. @param surfaceHolder The surface view. @param width The width of surface texture view. @param height The height of surface texture view.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_constructor_surfaceHolder_inline",
                   "",
            ],
            [
                   "cleanSurface",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_cleanSurface_inline",
                   "Cleans the surface from the codec manager.",
            ],
            [
                   "Cleans the surface from the codec manager.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_cleanSurface_inline",
                   "",
            ],
            [
                   "switchSource",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_switchSource_inline",
                   "Switches the video source of the decoder.  @param source The new video source.",
            ],
            [
                   "Switches the video source of the decoder.  @param source The new video source.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_switchSource_inline",
                   "",
            ],
            [
                   "isDecoderOK",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_isDecoderOK_inline",
                   "Determines whether the decoding status is normal.  @return `true` if the decoding status is normal, false otherwise.",
            ],
            [
                   "Determines whether the decoding status is normal.  @return `true` if the decoding status is normal, false otherwise.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_isDecoderOK_inline",
                   "",
            ],
            [
                   "sendDataToDecoder",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoder_inline",
                   "Sends H264 raw video data to the decoder.  @param videoBuffer The video buffer data. @param size The data size.",
            ],
            [
                   "Sends H264 raw video data to the decoder.  @param videoBuffer The video buffer data. @param size The data size.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoder_inline",
                   "",
            ],
            [
                   "sendDataToDecoder",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoderWithSource_inline",
                   "Sends H264 raw video data to the decoder.  @param videoBuffer The video buffer data. @param size The data size. @param source The source of the data.",
            ],
            [
                   "Sends H264 raw video data to the decoder.  @param videoBuffer The video buffer data. @param size The data size. @param source The source of the data.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoderWithSource_inline",
                   "",
            ],
            [
                   "sendDataToDecoder",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoderWithSourceId_inline",
                   "Sends H264 raw video data to the decoder with source id.  @param videoBuffer The video buffer data. @param size The data size. @param source source id.",
            ],
            [
                   "Sends H264 raw video data to the decoder with source id.  @param videoBuffer The video buffer data. @param size The data size. @param source source id.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_sendDataToDecoderWithSourceId_inline",
                   "",
            ],
            [
                   "getVideoWidth",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getVideoWidth_inline",
                   "Get the video width.  @return Video width Integer value.",
            ],
            [
                   "Get the video width.  @return Video width Integer value.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getVideoWidth_inline",
                   "",
            ],
            [
                   "getVideoHeight",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getVideoHeight_inline",
                   "Get the video height.  @return Video height Integer value.",
            ],
            [
                   "Get the video height.  @return Video height Integer value.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getVideoHeight_inline",
                   "",
            ],
            [
                   "onSurfaceSizeChanged",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_onSurfaceSizeChanged_inline",
                   "Resizes the surface when the size of the surface texture view has changed.  @param width The new width of the surface @param height The new height of the surface @param degree The new degree of the surface",
            ],
            [
                   "Resizes the surface when the size of the surface texture view has changed.  @param width The new width of the surface @param height The new height of the surface @param degree The new degree of the surface",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_onSurfaceSizeChanged_inline",
                   "",
            ],
            [
                   "enabledYuvData",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_enabledYuvData_inline",
                   "To enable the YUV data output to user which must set the surface  as null to avoid native buffer.  @param enabled The YUV data callback.",
            ],
            [
                   "To enable the YUV data output to user which must set the surface  as null to avoid native buffer.  @param enabled The YUV data callback.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_enabledYuvData_inline",
                   "",
            ],
            [
                   "setPeakFocusThresholdEnabled",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setPeakFocusThresholdEnabled_inline",
                   "Enable Peak Focus Threshold.  @param isEnabled Enable/disable focus threshold.",
            ],
            [
                   "Enable Peak Focus Threshold.  @param isEnabled Enable/disable focus threshold.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setPeakFocusThresholdEnabled_inline",
                   "",
            ],
            [
                   "setPeakFocusThreshold",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setPeakFocusThreshold_inline",
                   "Set the peak focus threshold value.  @param peakFocusThresholdValue A float value representing peak focus threshold.",
            ],
            [
                   "Set the peak focus threshold value.  @param peakFocusThresholdValue A float value representing peak focus threshold.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setPeakFocusThreshold_inline",
                   "",
            ],
            [
                   "setOverexposureWarningEnabled",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setOverexposureWarningEnabled_inline",
                   "Enable or disable the over exposure warning.  @param isEnabled Enable/Disable the over exposure warning.",
            ],
            [
                   "Enable or disable the over exposure warning.  @param isEnabled Enable/Disable the over exposure warning.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setOverexposureWarningEnabled_inline",
                   "",
            ],
            [
                   "setCodecName",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setCodecName_inline",
                   "Set the codec name. For some mobile phones that cannot display video stream normally. You can set the codec name through this interface so that MSDK can call the correct decoder for decoding and display. You can call android API:MediaCodecList to get available codec names for testing.  @param codecName ",
            ],
            [
                   "Set the codec name. For some mobile phones that cannot display video stream normally. You can set the codec name through this interface so that MSDK can call the correct decoder for decoding and display. You can call android API:MediaCodecList to get available codec names for testing.  @param codecName ",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setCodecName_inline",
                   "",
            ],
            [
                   "setYuvDataCallback",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setYuvDataCallback_inline",
                   "Sends YUV data from hardware decoder.  @param callback The YUV data callback.",
            ],
            [
                   "Sends YUV data from hardware decoder.  @param callback The YUV data callback.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_setYuvDataCallback_inline",
                   "",
            ],
            [
                   "getYuvDataCallback",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getYuvDataCallback_inline",
                   "Sends YUV data from hardware decoder.  @return The YUV data callback.",
            ],
            [
                   "Sends YUV data from hardware decoder.  @return The YUV data callback.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getYuvDataCallback_inline",
                   "",
            ],
            [
                   "getYuvData",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getYuvData_inline",
                   "Gets YUV data from hardware decoder. The obtained data of format is MediaCodecInfo.CodecCapabilities.COLOR_FormatYUV420Planar</code> and the width and height must be even.  @param width width of the video. @param height height of the video.  @return The YUV data from the hardware decoder.",
            ],
            [
                   "Gets YUV data from hardware decoder. The obtained data of format is MediaCodecInfo.CodecCapabilities.COLOR_FormatYUV420Planar</code> and the width and height must be even.  @param width width of the video. @param height height of the video.  @return The YUV data from the hardware decoder.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getYuvData_inline",
                   "",
            ],
            [
                   "getRgbaData",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getRgbaData_inline",
                   "Gets RGBA data from hardware decoder.  @param width width of the video. @param height height of the video.  @return The RGBA data from the hardware decoder.",
            ],
            [
                   "Gets RGBA data from hardware decoder.  @param width width of the video. @param height height of the video.  @return The RGBA data from the hardware decoder.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_getRgbaData_inline",
                   "",
            ],
            [
                   "YuvDataCallback",
                   2,
                   "/Components/CodecManager/DJICodecManager_YuvDataCallbackInterface.html",
                   "",
                   "Interface for the YUV data callback.",
            ],
            [
                   "Interface for the YUV data callback.",
                   1,
                   "/Components/CodecManager/DJICodecManager_YuvDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onYuvDataReceived",
                   2,
                   "/Components/CodecManager/DJICodecManager_YuvDataCallbackInterface.html",
                   "#DJICodecManager_onYuvDataReceived_inline",
                   "Callback method for processing the yuv frame data from hardware decoder.  Only works well after `enabledYuvData` is invoked and set as `true`.  @param format the format of YUV. @param yuvFrame YUV data buffer in the codec. @param dataSize size of the YUV data @param width width of the video @param height height of the video",
            ],
            [
                   "Callback method for processing the yuv frame data from hardware decoder.  Only works well after `enabledYuvData` is invoked and set as `true`.  @param format the format of YUV. @param yuvFrame YUV data buffer in the codec. @param dataSize size of the YUV data @param width width of the video @param height height of the video",
                   1,
                   "/Components/CodecManager/DJICodecManager_YuvDataCallbackInterface.html",
                   "#DJICodecManager_onYuvDataReceived_inline",
                   "",
            ],
            [
                   "VideoSource",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_inline",
                   "The source of the video feed.",
            ],
            [
                   "The source of the video feed.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_inline",
                   "",
            ],
            [
                   "CAMERA",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_CAMERA_inline",
                   "The source of the video feed is the main camera.",
            ],
            [
                   "The source of the video feed is the main camera.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_CAMERA_inline",
                   "",
            ],
            [
                   "FPV",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_FPV_inline",
                   "The source of the video feed is the FPV camera.",
            ],
            [
                   "The source of the video feed is the FPV camera.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_FPV_inline",
                   "",
            ],
            [
                   "SECONDARY_CAMERA",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_SECONDARY_CAMERA_inline",
                   "The source of the video feed is the secondary camera.",
            ],
            [
                   "The source of the video feed is the secondary camera.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_SECONDARY_CAMERA_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_UNKNOWN_inline",
                   "The source of the video feed is unknown.",
            ],
            [
                   "The source of the video feed is unknown.",
                   1,
                   "/Components/CodecManager/DJICodecManager.html",
                   "#DJICodecManager_VideoSource_UNKNOWN_inline",
                   "",
            ],
            [
                   "getInstance",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_getInstance_inline",
                   "The instance of `VideoFeeder`.  @return An object of `VideoFeeder`.",
            ],
            [
                   "The instance of `VideoFeeder`.  @return An object of `VideoFeeder`.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_getInstance_inline",
                   "",
            ],
            [
                   "addPhysicalSourceListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_addPhysicalSourceListener_inline",
                   "Add physical source listener.  @param listener An interface of `PhysicalSourceListener`.",
            ],
            [
                   "Add physical source listener.  @param listener An interface of `PhysicalSourceListener`.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_addPhysicalSourceListener_inline",
                   "",
            ],
            [
                   "removePhysicalSourceListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_removePhysicalSourceListener_inline",
                   "Remove physical source listener.  @param listener An interface of `PhysicalSourceListener`.",
            ],
            [
                   "Remove physical source listener.  @param listener An interface of `PhysicalSourceListener`.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_removePhysicalSourceListener_inline",
                   "",
            ],
            [
                   "getPrimaryVideoFeed",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_primaryVideoFeed_inline",
                   "The primary video feed.  The possible physical sources for the primary video feed include:  - `MAIN_CAM`  -  `LB`  -  `HDMI`  -  `LEFT_CAM`  -  `RIGHT_CAM`  For M210 and M210 RTK, the  physical sources are controlled by the bandwidth allocation between the port (left) and starboard  (right) main cameras (`setBandwidthAllocationForLeftCamera`):  - When bandwidth  is 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is 0%  on the left camera, the primary source is `RIGHT_CAM` and the secondary source is `FPV_CAM`.  - When  bandwidth is neither 0% nor 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `RIGHT_CAM`.  For Matrice 300 RTK, the physical  source can be:  `LEFT_CAM`,  `RIGHT_CAM`,  `TOP_CAM`  and  `FPV_CAM`.  Please note that video playback stream will be received as primary or secondary video feed, if video playback starts on Zenmuse H20 Series.  Video feed channel could be assigned by `assignSourceToPrimaryChannel` in `OcuSyncLink`.  @return A `VideoFeed` object.",
            ],
            [
                   "The primary video feed.  The possible physical sources for the primary video feed include:  - `MAIN_CAM`  -  `LB`  -  `HDMI`  -  `LEFT_CAM`  -  `RIGHT_CAM`  For M210 and M210 RTK, the  physical sources are controlled by the bandwidth allocation between the port (left) and starboard  (right) main cameras (`setBandwidthAllocationForLeftCamera`):  - When bandwidth  is 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is 0%  on the left camera, the primary source is `RIGHT_CAM` and the secondary source is `FPV_CAM`.  - When  bandwidth is neither 0% nor 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `RIGHT_CAM`.  For Matrice 300 RTK, the physical  source can be:  `LEFT_CAM`,  `RIGHT_CAM`,  `TOP_CAM`  and  `FPV_CAM`.  Please note that video playback stream will be received as primary or secondary video feed, if video playback starts on Zenmuse H20 Series.  Video feed channel could be assigned by `assignSourceToPrimaryChannel` in `OcuSyncLink`.  @return A `VideoFeed` object.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_primaryVideoFeed_inline",
                   "",
            ],
            [
                   "getSecondaryVideoFeed",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_secondaryVideoFeed_inline",
                   "The secondary video feed.  The possible physical sources for the secondary video feed include:  - `FPV_CAM`  -  `EXT`  -  `AV`  - `RIGHT_CAM`. For M210 and M210 RTK, the physical  sources are controlled by the bandwidth allocation between the port (left) and starboard (right) main cameras  (`setBandwidthAllocationForLeftCamera`):  - When bandwidth is 100% on the left camera, the primary  source is `LEFT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is 0% on the left camera,  the primary source is `RIGHT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is neither 0% nor 100% on  the left camera, the primary source is `LEFT_CAM` and the  secondary source is `RIGHT_CAM`.  For Matrice 300 RTK, the  physical source can be: `LEFT_CAM`, `RIGHT_CAM`, `TOP_CAM`  and `FPV_CAM`. Please note that video playback stream will be received as primary or secondary video feed,  if video playback starts on Zenmuse H20 Series. Video feed channel could be assigned by `assignSourceToPrimaryChannel` in `OcuSyncLink`.  @return A `VideoFeed` object.",
            ],
            [
                   "The secondary video feed.  The possible physical sources for the secondary video feed include:  - `FPV_CAM`  -  `EXT`  -  `AV`  - `RIGHT_CAM`. For M210 and M210 RTK, the physical  sources are controlled by the bandwidth allocation between the port (left) and starboard (right) main cameras  (`setBandwidthAllocationForLeftCamera`):  - When bandwidth is 100% on the left camera, the primary  source is `LEFT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is 0% on the left camera,  the primary source is `RIGHT_CAM` and the secondary source is  `FPV_CAM`.  - When bandwidth is neither 0% nor 100% on  the left camera, the primary source is `LEFT_CAM` and the  secondary source is `RIGHT_CAM`.  For Matrice 300 RTK, the  physical source can be: `LEFT_CAM`, `RIGHT_CAM`, `TOP_CAM`  and `FPV_CAM`. Please note that video playback stream will be received as primary or secondary video feed,  if video playback starts on Zenmuse H20 Series. Video feed channel could be assigned by `assignSourceToPrimaryChannel` in `OcuSyncLink`.  @return A `VideoFeed` object.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_secondaryVideoFeed_inline",
                   "",
            ],
            [
                   "provideTranscodedVideoFeed",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_provideTranscodedVideoFeed_inline",
                   "Returns a new VideoFeed instance to receive the transcoded video feed from the main camera. The original video feed from the main camera is transcoded (using MediaCodec)  to generate H.264 video feed for more general usages. The encoder will use the calibrated  decoded feed when lens distortion calibration is needed. Setting the callback of VideoFeed  to null can stop the transcoding.  @return A `VideoFeed` object.",
            ],
            [
                   "Returns a new VideoFeed instance to receive the transcoded video feed from the main camera. The original video feed from the main camera is transcoded (using MediaCodec)  to generate H.264 video feed for more general usages. The encoder will use the calibrated  decoded feed when lens distortion calibration is needed. Setting the callback of VideoFeed  to null can stop the transcoding.  @return A `VideoFeed` object.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_provideTranscodedVideoFeed_inline",
                   "",
            ],
            [
                   "setTranscodingDataRate",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_setTranscodingDataRate_inline",
                   "Sets the destination data rate for the transcoded video feed. The valid range is [0.3, 20] in Mbps.  CAUTION: Changing the data rate during transcoding may re- start the internal encoder. The  transcoded video feed will get interrupted for a few seconds.  @param rate The destination data rate for the transcoded video feed.",
            ],
            [
                   "Sets the destination data rate for the transcoded video feed. The valid range is [0.3, 20] in Mbps.  CAUTION: Changing the data rate during transcoding may re- start the internal encoder. The  transcoded video feed will get interrupted for a few seconds.  @param rate The destination data rate for the transcoded video feed.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_setTranscodingDataRate_inline",
                   "",
            ],
            [
                   "getTranscodingDataRate",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_getTranscodingDataRate_inline",
                   "Gets the data rate of all transcoded video feeder, in Mbps.  @return A float value of the data rate of all transcoded video feeder.",
            ],
            [
                   "Gets the data rate of all transcoded video feeder, in Mbps.  @return A float value of the data rate of all transcoded video feeder.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_getTranscodingDataRate_inline",
                   "",
            ],
            [
                   "isLensDistortionCalibrationNeeded",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_isLensDistortionCalibrationNeeded_inline",
                   "Determines if the original video feed requires lens distortion calibration. When calibration is needed,  it is not recommended to use the original video feed with the decoding  sample (https://github.com/DJI-Mobile-SDK-Tutorials/Android- VideoStreamDecodingSample). Use the transcoded  video feed instead and also the module: 'library-anti-distortion' should be included.  @return `true` if the video need anti-distortion feature.",
            ],
            [
                   "Determines if the original video feed requires lens distortion calibration. When calibration is needed,  it is not recommended to use the original video feed with the decoding  sample (https://github.com/DJI-Mobile-SDK-Tutorials/Android- VideoStreamDecodingSample). Use the transcoded  video feed instead and also the module: 'library-anti-distortion' should be included.  @return `true` if the video need anti-distortion feature.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_isLensDistortionCalibrationNeeded_inline",
                   "",
            ],
            [
                   "isFetchKeyFrameNeeded",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_isFetchKeyFrameNeeded_inline",
                   "Determines if the original video feed requires SDK to fetch key frame. When fetch key frame is needed, it is  not recommended to use the original video feed with the decoding  sample (https://github.com/DJI-Mobile-SDK-Tutorials/Android- VideoStreamDecodingSample). Use the transcoded video feed instead.  @return `true` if the video need anti-distortion feature.",
            ],
            [
                   "Determines if the original video feed requires SDK to fetch key frame. When fetch key frame is needed, it is  not recommended to use the original video feed with the decoding  sample (https://github.com/DJI-Mobile-SDK-Tutorials/Android- VideoStreamDecodingSample). Use the transcoded video feed instead.  @return `true` if the video need anti-distortion feature.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "#DJIVideoFeeder_isFetchKeyFrameNeeded_inline",
                   "",
            ],
            [
                   "VideoDataListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_VideoDataListenerInterface.html",
                   "",
                   "Video data listener.",
            ],
            [
                   "Video data listener.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_VideoDataListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onReceive",
                   2,
                   "/BaseClasses/DJIVideoFeeder_VideoDataListenerInterface.html",
                   "#DJIVideoFeeder_VideoDataListenerInterface_onReceive_inline",
                   "Listener that is called when video data is received, but if `isLensDistortionCalibrationNeeded` return true, the callback will never be called.  For Matrice 300 RTK, you must use `assignSourceToPrimaryChannel` to assign or reassign the channel when you restart the aircraft or the aircraft is reconnected with the remote controller, otherwise you will not receive any data from this callback.  @param videoBuffer An array containing video buffer. @param size The size of the buffer that contains valid data.",
            ],
            [
                   "Listener that is called when video data is received, but if `isLensDistortionCalibrationNeeded` return true, the callback will never be called.  For Matrice 300 RTK, you must use `assignSourceToPrimaryChannel` to assign or reassign the channel when you restart the aircraft or the aircraft is reconnected with the remote controller, otherwise you will not receive any data from this callback.  @param videoBuffer An array containing video buffer. @param size The size of the buffer that contains valid data.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_VideoDataListenerInterface.html",
                   "#DJIVideoFeeder_VideoDataListenerInterface_onReceive_inline",
                   "",
            ],
            [
                   "VideoActiveStatusListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_VideoActiveStatusListenerInterface.html",
                   "",
                   "Video active status listener.",
            ],
            [
                   "Video active status listener.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_VideoActiveStatusListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/BaseClasses/DJIVideoFeeder_VideoActiveStatusListenerInterface.html",
                   "#DJIVideoFeeder_VideoActiveStatusListenerInterface_onUpdate_inline",
                   "Listener that is called when a video feed has changed active status.  @param active Boolean value indicates if the feed is active.",
            ],
            [
                   "Listener that is called when a video feed has changed active status.  @param active Boolean value indicates if the feed is active.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_VideoActiveStatusListenerInterface.html",
                   "#DJIVideoFeeder_VideoActiveStatusListenerInterface_onUpdate_inline",
                   "",
            ],
            [
                   "VideoFeed",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "",
                   "Video feed. Use it to receive video data from a physical source.",
            ],
            [
                   "Video feed. Use it to receive video data from a physical source.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "",
                   "",
            ],
            [
                   "setPriority",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_setPriority_inline",
                   "Set the channel priority of the video feed. Priority will affect the bandwidth allocation if it is  not `UNKNOWN`, which is the default value. For example,  if the data comes from the payload device mounted on left gimbal is prefer, please set the priority to `HIGH`,  and physicalSource is `LEFT_CAM`. The others should be  set to `MEDIUM` or `LOW`.  Only supported by Matrice 300 RTK.  @param priority Priority for the primary video feed. @param callback callback The execution callback with the value(s) returned.",
            ],
            [
                   "Set the channel priority of the video feed. Priority will affect the bandwidth allocation if it is  not `UNKNOWN`, which is the default value. For example,  if the data comes from the payload device mounted on left gimbal is prefer, please set the priority to `HIGH`,  and physicalSource is `LEFT_CAM`. The others should be  set to `MEDIUM` or `LOW`.  Only supported by Matrice 300 RTK.  @param priority Priority for the primary video feed. @param callback callback The execution callback with the value(s) returned.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_setPriority_inline",
                   "",
            ],
            [
                   "getPriority",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getPriority_inline",
                   "Get the channel priority of the video feed. Only supported by Matrice 300 RTK.  @param callback callback The execution callback with the value(s) returned.",
            ],
            [
                   "Get the channel priority of the video feed. Only supported by Matrice 300 RTK.  @param callback callback The execution callback with the value(s) returned.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getPriority_inline",
                   "",
            ],
            [
                   "PhysicalSource",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_inline",
                   "The physical source of a video feed.",
            ],
            [
                   "The physical source of a video feed.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_inline",
                   "",
            ],
            [
                   "MAIN_CAM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_MainCamera_inline",
                   "The video feed is from the main camera. It is the physical source used by most of DJI products.  `LEFT_CAM`  and `RIGHT_CAM` are used instead in  M210 series and M210 V2 series.",
            ],
            [
                   "The video feed is from the main camera. It is the physical source used by most of DJI products.  `LEFT_CAM`  and `RIGHT_CAM` are used instead in  M210 series and M210 V2 series.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_MainCamera_inline",
                   "",
            ],
            [
                   "FPV_CAM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_FPVCamera_inline",
                   "The video feed is from the FPV camera on Inspire 2, M200 series and M200 series v2 and Matrice 300 RTK.",
            ],
            [
                   "The video feed is from the FPV camera on Inspire 2, M200 series and M200 series v2 and Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_FPVCamera_inline",
                   "",
            ],
            [
                   "EXT",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_EXT_inline",
                   "The video feed is from EXT port while EXT port is enabled. It is only used for Lightbridge 2 or aircrafts with Lightbridge 2 (e.g. M600).",
            ],
            [
                   "The video feed is from EXT port while EXT port is enabled. It is only used for Lightbridge 2 or aircrafts with Lightbridge 2 (e.g. M600).",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_EXT_inline",
                   "",
            ],
            [
                   "LB",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_LB_inline",
                   "The video feed is from one of the LB ports (AV or HDMI) while EXT Port is enabled.  It is only used for stand-alone Lightbridge 2 or aircraft with stand- alone Lightbridge 2 modules (e.g. M600).",
            ],
            [
                   "The video feed is from one of the LB ports (AV or HDMI) while EXT Port is enabled.  It is only used for stand-alone Lightbridge 2 or aircraft with stand- alone Lightbridge 2 modules (e.g. M600).",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_LB_inline",
                   "",
            ],
            [
                   "HDMI",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_HDMI_inline",
                   "The video feed is from the HDMI port while EXT port is disabled.  It is only used for stand-alone Lightbridge 2 or aircraft with stand-alone Lightbridge 2 modules.",
            ],
            [
                   "The video feed is from the HDMI port while EXT port is disabled.  It is only used for stand-alone Lightbridge 2 or aircraft with stand-alone Lightbridge 2 modules.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_HDMI_inline",
                   "",
            ],
            [
                   "AV",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_AV_inline",
                   "The video feed is from AV port while EXT port is disabled. It is only used for stand-alone Lightbridge 2 or aircraft with stand-alone Lightbridge 2 modules.",
            ],
            [
                   "The video feed is from AV port while EXT port is disabled. It is only used for stand-alone Lightbridge 2 or aircraft with stand-alone Lightbridge 2 modules.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_AV_inline",
                   "",
            ],
            [
                   "LEFT_CAM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_LeftCamera_inline",
                   "The video feed is from the port (left) main camera. It is only used for M210 series and M210 V2 series and Matrice 300 RTK.",
            ],
            [
                   "The video feed is from the port (left) main camera. It is only used for M210 series and M210 V2 series and Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_LeftCamera_inline",
                   "",
            ],
            [
                   "RIGHT_CAM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_RightCamera_inline",
                   "The video feed is from the starboard (right) main camera. It is only used for M210 series and M210 V2 series and Matrice 300 RTK.",
            ],
            [
                   "The video feed is from the starboard (right) main camera. It is only used for M210 series and M210 V2 series and Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_RightCamera_inline",
                   "",
            ],
            [
                   "TOP_CAM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_TopCamera_inline",
                   "The video feed is from the camera above the aircraft. It is only used for Matrice 300 RTK.",
            ],
            [
                   "The video feed is from the camera above the aircraft. It is only used for Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_TopCamera_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_Unknown_inline",
                   "Unknown video physical source.",
            ],
            [
                   "Unknown video physical source.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSource_Unknown_inline",
                   "",
            ],
            [
                   "VideoFeedPriority",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_inline",
                   "The enum is used to represent priority of a stream channel. It is supported only by Matrice 300 RTK.",
            ],
            [
                   "The enum is used to represent priority of a stream channel. It is supported only by Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_inline",
                   "",
            ],
            [
                   "HIGH",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_High_inline",
                   "The stream channel's priority is high.",
            ],
            [
                   "The stream channel's priority is high.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_High_inline",
                   "",
            ],
            [
                   "MEDIUM",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Medium_inline",
                   "The stream channel's priority is medium.",
            ],
            [
                   "The stream channel's priority is medium.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Medium_inline",
                   "",
            ],
            [
                   "LOW",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Low_inline",
                   "The stream channel's priority is low.",
            ],
            [
                   "The stream channel's priority is low.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Low_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Unknown_inline",
                   "The stream channel's priority is unknown.",
            ],
            [
                   "The stream channel's priority is unknown.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPriority_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceCallbackInterface.html",
                   "",
                   "Callback Interface for image transmission source.",
            ],
            [
                   "Callback Interface for image transmission source.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceCallbackInterface.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceOnUpdate_inline",
                   "Callback function that updates the image transmission source.  @param source Image transmission Source.",
            ],
            [
                   "Callback function that updates the image transmission source.  @param source Image transmission Source.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceCallbackInterface.html",
                   "#DJIVideoFeeder_DJIVideoFeed_DJIVideoFeedPhysicalSourceOnUpdate_inline",
                   "",
            ],
            [
                   "PhysicalSourceListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_PhysicalSourceListener.html",
                   "",
                   "Physical source listener.",
            ],
            [
                   "Physical source listener.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_PhysicalSourceListener.html",
                   "",
                   "",
            ],
            [
                   "onChange",
                   2,
                   "/BaseClasses/DJIVideoFeeder_PhysicalSourceListener.html",
                   "#DJIVideoFeeder_PhysicalSourceListener_onChange_inline",
                   "Called when the physical source changes.  @param videoFeed An interface of `VideoFeed`. @param newPhysicalSource An int value.",
            ],
            [
                   "Called when the physical source changes.  @param videoFeed An interface of `VideoFeed`. @param newPhysicalSource An int value.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_PhysicalSourceListener.html",
                   "#DJIVideoFeeder_PhysicalSourceListener_onChange_inline",
                   "",
            ],
            [
                   "getVideoSource",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getVideoSource_inline",
                   "Gets the physical sources of the video data.  @return An enum value of `PhysicalSource`.",
            ],
            [
                   "Gets the physical sources of the video data.  @return An enum value of `PhysicalSource`.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getVideoSource_inline",
                   "",
            ],
            [
                   "addVideoDataListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_addVideoDataListener_inline",
                   "Adds a listener to access the video data that is being shown by the VideoFeed.  @param listener The listener to be added to the VideoFeed.  @return `true` if listener was added successfully.",
            ],
            [
                   "Adds a listener to access the video data that is being shown by the VideoFeed.  @param listener The listener to be added to the VideoFeed.  @return `true` if listener was added successfully.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_addVideoDataListener_inline",
                   "",
            ],
            [
                   "removeVideoDataListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_removeVideoDataListener_inline",
                   "Removes the specified listener from the VideoFeed, if it is present (optional operation).  If this VideoFeed does not contain the listener, it is unchanged.  @param listener The listener to be removed from the VideoFeed.  @return `true` if the listener was removed successfully.",
            ],
            [
                   "Removes the specified listener from the VideoFeed, if it is present (optional operation).  If this VideoFeed does not contain the listener, it is unchanged.  @param listener The listener to be removed from the VideoFeed.  @return `true` if the listener was removed successfully.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_removeVideoDataListener_inline",
                   "",
            ],
            [
                   "getListeners",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getListeners_inline",
                   "Returns the list of the existing video data listeners.  @return A list of existing `VideoDataListener`.",
            ],
            [
                   "Returns the list of the existing video data listeners.  @return A list of existing `VideoDataListener`.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_getListeners_inline",
                   "",
            ],
            [
                   "addVideoActiveStatusListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_addVideoActiveStatusListener_inline",
                   "Adds a listener to access the video active status that is being shown by the VideoFeed.  @param listener The listener to be added to the VideoFeed.  @return `true` if the listener was added successfully.",
            ],
            [
                   "Adds a listener to access the video active status that is being shown by the VideoFeed.  @param listener The listener to be added to the VideoFeed.  @return `true` if the listener was added successfully.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_addVideoActiveStatusListener_inline",
                   "",
            ],
            [
                   "removeVideoActiveStatusListener",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_removeVideoActiveStatusListener_inline",
                   "Removes the specified listener from the VideoFeed, if it is present (optional operation).  If this VideoFeed does not contain the listener, it is unchanged.  @param listener The listener to be removed from the VideoFeed.  @return `true` if the listener was removed successfully.",
            ],
            [
                   "Removes the specified listener from the VideoFeed, if it is present (optional operation).  If this VideoFeed does not contain the listener, it is unchanged.  @param listener The listener to be removed from the VideoFeed.  @return `true` if the listener was removed successfully.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_removeVideoActiveStatusListener_inline",
                   "",
            ],
            [
                   "destroy",
                   2,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_destroy_inline",
                   "Destroy all the listeners associated with this VideoFeed.",
            ],
            [
                   "Destroy all the listeners associated with this VideoFeed.",
                   1,
                   "/BaseClasses/DJIVideoFeeder_DJIVideoFeed.html",
                   "#DJIVideoFeeder_DJIVideoFeed_destroy_inline",
                   "",
            ],
            [
                   "setBluetoothDevicesListCallback",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_setBluetoothProductConnectorListener_inline",
                   "Set DJIBluetoothProductConnector Listener.  @param callback The callback of `BluetoothDevicesListCallback`.",
            ],
            [
                   "Set DJIBluetoothProductConnector Listener.  @param callback The callback of `BluetoothDevicesListCallback`.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_setBluetoothProductConnectorListener_inline",
                   "",
            ],
            [
                   "searchBluetoothProducts",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_searchBluetoothProducts_inline",
                   "Used to start searching for DJI Products that are near the mobile device and can be controlled with the Mobile  SDK using Bluetooth. Use `onUpdate` to receive the product list.  @param callback Completion block returns the command execution result. It is called once the searching is started.",
            ],
            [
                   "Used to start searching for DJI Products that are near the mobile device and can be controlled with the Mobile  SDK using Bluetooth. Use `onUpdate` to receive the product list.  @param callback Completion block returns the command execution result. It is called once the searching is started.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_searchBluetoothProducts_inline",
                   "",
            ],
            [
                   "connect",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_connectProductWithCompletion_inline",
                   "Connects to the DJI product using Bluetooth. Once it is connected, `DJISDKManager` can be used to access the product.  @param product The Bluetooth product to connect to. @param callback The completion block returns the command execution result.",
            ],
            [
                   "Connects to the DJI product using Bluetooth. Once it is connected, `DJISDKManager` can be used to access the product.  @param product The Bluetooth product to connect to. @param callback The completion block returns the command execution result.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_connectProductWithCompletion_inline",
                   "",
            ],
            [
                   "disconnect",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_disconnectProduct_inline",
                   "Disconnects connected Bluetooth product.  @param callback The completion block returns the command execution result.",
            ],
            [
                   "Disconnects connected Bluetooth product.  @param callback The completion block returns the command execution result.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "#DJIBluetoothProductConnector_disconnectProduct_inline",
                   "",
            ],
            [
                   "BluetoothDevicesListCallback",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_BluetoothProductConnectorListenerInterface.html",
                   "",
                   "Delegate that receives the product list found by the connector.",
            ],
            [
                   "Delegate that receives the product list found by the connector.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_BluetoothProductConnectorListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "BluetoothDevice",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "",
                   "This class contains information for a DJI Bluetooth device.",
            ],
            [
                   "This class contains information for a DJI Bluetooth device.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getName_inline",
                   "Returns the name of the Bluetooth device.  @return A string representing the name.",
            ],
            [
                   "Returns the name of the Bluetooth device.  @return A string representing the name.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getName_inline",
                   "",
            ],
            [
                   "getStatus",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getStatus_inline",
                   "Returns connection status for the Bluetooth device.  @return The enum value of `BluetoothDeviceStatus`.",
            ],
            [
                   "Returns connection status for the Bluetooth device.  @return The enum value of `BluetoothDeviceStatus`.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getStatus_inline",
                   "",
            ],
            [
                   "getRssi",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getRssi_inline",
                   "Returns the signal quality.  @return An Integer representing the signal quality.",
            ],
            [
                   "Returns the signal quality.  @return An Integer representing the signal quality.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_getRssi_inline",
                   "",
            ],
            [
                   "BluetoothDeviceStatus",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_inline",
                   "DJI Bluetooth device status enum.",
            ],
            [
                   "DJI Bluetooth device status enum.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_inline",
                   "",
            ],
            [
                   "CONNECTED",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_CONNECTED_inline",
                   "Bluetooth device connected.",
            ],
            [
                   "Bluetooth device connected.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_CONNECTED_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_DISCONNECTED_inline",
                   "Bluetooth device disconnected.",
            ],
            [
                   "Bluetooth device disconnected.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_DISCONNECTED_inline",
                   "",
            ],
            [
                   "CONNECTING",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_CONNECTING_inline",
                   "Bluetooth device connecting.",
            ],
            [
                   "Bluetooth device connecting.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_DJIBluetoothDevice.html",
                   "#DJIBluetoothProductConnector_DJIBluetoothDevice_DJIBluetoothDeviceStatus_CONNECTING_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector_BluetoothProductConnectorListenerInterface.html",
                   "#DJIBluetoothProductConnector_ConnectorDidFindProducts_inline",
                   "Provides the list of DJI products that can be connected with the mobile device over Bluetooth. Delegate will  continue to receive an updated list after `searchBluetoothProducts` is called  until the searching is finished (either product is connected or after 10s).  @param devices A list of DJI products found by the connector.",
            ],
            [
                   "Provides the list of DJI products that can be connected with the mobile device over Bluetooth. Delegate will  continue to receive an updated list after `searchBluetoothProducts` is called  until the searching is finished (either product is connected or after 10s).  @param devices A list of DJI products found by the connector.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector_BluetoothProductConnectorListenerInterface.html",
                   "#DJIBluetoothProductConnector_ConnectorDidFindProducts_inline",
                   "",
            ],
            [
                   "getFlightController",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_flightController_inline",
                   "Returns an instance of the aircraft's flight controller.  @return DJIFlightController component.",
            ],
            [
                   "Returns an instance of the aircraft's flight controller.  @return DJIFlightController component.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_flightController_inline",
                   "",
            ],
            [
                   "getCameras",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_cameras_inline",
                   "Retrieves instances of the product's cameras. This is used when the aircraft has multiple DJI cameras, e.g. M210 and  M210 RTK. Note, when two cameras do exist, camera order within the array will not always the same. For example: On the M210, the port side (left) camera will have an index of 0 and the starboard side (right)  camera will have an index of 1. However, the first object of `getCameras` will not  necessarily always be the camera with `getIndex` of 0.  @return A list of the aircraft's cameras.",
            ],
            [
                   "Retrieves instances of the product's cameras. This is used when the aircraft has multiple DJI cameras, e.g. M210 and  M210 RTK. Note, when two cameras do exist, camera order within the array will not always the same. For example: On the M210, the port side (left) camera will have an index of 0 and the starboard side (right)  camera will have an index of 1. However, the first object of `getCameras` will not  necessarily always be the camera with `getIndex` of 0.  @return A list of the aircraft's cameras.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_cameras_inline",
                   "",
            ],
            [
                   "getCameraWithComponentIndex",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_getCameraWithComponentIndex_inline",
                   "Retrieves an instance of the device's camera with inputted index.  @param index An int value.  @return An instance of the aircraft's camera.",
            ],
            [
                   "Retrieves an instance of the device's camera with inputted index.  @param index An int value.  @return An instance of the aircraft's camera.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_getCameraWithComponentIndex_inline",
                   "",
            ],
            [
                   "getGimbals",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_gimbals_inline",
                   "Retrieves instances of the product's gimbals. This is used when the aircraft has multiple DJI gimbals, e.g. M210  and M210 RTK. Note, when two gimbals do exist, gimbal order within the array will not always the same. For example:  On the M210, the port side (left) gimbal will have an index of 0 and the starboard side (right) gimbal will have an index of 1. However, the first object of `getGimbals`  will not necessarily always be the gimbal with `getIndex` of 0.  @return A list of the aircraft's gimbals.",
            ],
            [
                   "Retrieves instances of the product's gimbals. This is used when the aircraft has multiple DJI gimbals, e.g. M210  and M210 RTK. Note, when two gimbals do exist, gimbal order within the array will not always the same. For example:  On the M210, the port side (left) gimbal will have an index of 0 and the starboard side (right) gimbal will have an index of 1. However, the first object of `getGimbals`  will not necessarily always be the gimbal with `getIndex` of 0.  @return A list of the aircraft's gimbals.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_gimbals_inline",
                   "",
            ],
            [
                   "getRemoteController",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_remoteController_inline",
                   "Returns an instance of the aircraft's remote controller.  @return DJIRemoteController component.",
            ],
            [
                   "Returns an instance of the aircraft's remote controller.  @return DJIRemoteController component.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_remoteController_inline",
                   "",
            ],
            [
                   "getMobileRemoteController",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_mobileRemoteController_inline",
                   "A simulated remote controller on the mobile device. It is supported by Mavic Pro and Spark using WiFi.  @return DJIMobileRemoteController component.",
            ],
            [
                   "A simulated remote controller on the mobile device. It is supported by Mavic Pro and Spark using WiFi.  @return DJIMobileRemoteController component.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_mobileRemoteController_inline",
                   "",
            ],
            [
                   "getBaseStation",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_baseStation_inline",
                   "The connected base station instance. It is supported by Phantom 4 RTK and Matrice 210 RTK V2.  @return An instance of `BaseStation`.",
            ],
            [
                   "The connected base station instance. It is supported by Phantom 4 RTK and Matrice 210 RTK V2.  @return An instance of `BaseStation`.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_baseStation_inline",
                   "",
            ],
            [
                   "getRadar",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_radar_inline",
                   "Retrieves an instance of the device's radar.",
            ],
            [
                   "Retrieves an instance of the device's radar.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_radar_inline",
                   "",
            ],
            [
                   "getLidars",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_lidars_inline",
                   "Retrieves instances of the product's lidars. This is used when the aircraft has multiple DJI lidars, e.g. M300 RTK and M350 RTK.  Note, when two Zenmuse L1 do exist, lidar order within the array will not always the same. For example: On the  M300 RTK and M350 RTK, the port side (left) Zenmuse L1 will have an index of 0 and the starboard side (right)  Zenmuse will have an index of 1. However, the first object of `getLidars` will not  necessarily always be the lidar with `getIndex` of 0.  @return A list of the aircraft's lidars.",
            ],
            [
                   "Retrieves instances of the product's lidars. This is used when the aircraft has multiple DJI lidars, e.g. M300 RTK and M350 RTK.  Note, when two Zenmuse L1 do exist, lidar order within the array will not always the same. For example: On the  M300 RTK and M350 RTK, the port side (left) Zenmuse L1 will have an index of 0 and the starboard side (right)  Zenmuse will have an index of 1. However, the first object of `getLidars` will not  necessarily always be the lidar with `getIndex` of 0.  @return A list of the aircraft's lidars.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_lidars_inline",
                   "",
            ],
            [
                   "UNKNOWN_AIRCRAFT",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameUnknownAircraft_inline",
                   "The Aircraft's model name is unknown.",
            ],
            [
                   "The Aircraft's model name is unknown.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameUnknownAircraft_inline",
                   "",
            ],
            [
                   "INSPIRE_1",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1_inline",
                   "The aircraft's model name is Inspire 1.",
            ],
            [
                   "The aircraft's model name is Inspire 1.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1_inline",
                   "",
            ],
            [
                   "INSPIRE_1_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1Pro_inline",
                   "The aircraft's model name is Inspire 1 Pro.",
            ],
            [
                   "The aircraft's model name is Inspire 1 Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1Pro_inline",
                   "",
            ],
            [
                   "INSPIRE_1_RAW",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1RAW_inline",
                   "The aircraft's model name is Inspire 1 Raw.",
            ],
            [
                   "The aircraft's model name is Inspire 1 Raw.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire1RAW_inline",
                   "",
            ],
            [
                   "INSPIRE_2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire2_inline",
                   "The aircraft's model name is Inspire 2.",
            ],
            [
                   "The aircraft's model name is Inspire 2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameInspire2_inline",
                   "",
            ],
            [
                   "PHANTOM_3_PROFESSIONAL",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Professional_inline",
                   "The aircraft's model name is Phantom 3 Professional.",
            ],
            [
                   "The aircraft's model name is Phantom 3 Professional.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Professional_inline",
                   "",
            ],
            [
                   "PHANTOM_3_ADVANCED",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Advanced_inline",
                   "The aircraft's model name is Phantom 3 Advanced.",
            ],
            [
                   "The aircraft's model name is Phantom 3 Advanced.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Advanced_inline",
                   "",
            ],
            [
                   "PHANTOM_3_STANDARD",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Standard_inline",
                   "The aircraft's model name is Phantom 3 Standard.",
            ],
            [
                   "The aircraft's model name is Phantom 3 Standard.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom3Standard_inline",
                   "",
            ],
            [
                   "Phantom_3_4K",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom34K_inline",
                   "The aircraft's model name is Phantom 3 4K.",
            ],
            [
                   "The aircraft's model name is Phantom 3 4K.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom34K_inline",
                   "",
            ],
            [
                   "PHANTOM_4",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4_inline",
                   "The aircraft's model name is Phantom 4.",
            ],
            [
                   "The aircraft's model name is Phantom 4.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4_inline",
                   "",
            ],
            [
                   "PHANTOM_4_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Pro_inline",
                   "The aircraft's model name is Phantom 4 Pro.",
            ],
            [
                   "The aircraft's model name is Phantom 4 Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Pro_inline",
                   "",
            ],
            [
                   "PHANTOM_4_PRO_V2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4ProV2_inline",
                   "The aircraft's model name is Phantom 4 Pro V2.",
            ],
            [
                   "The aircraft's model name is Phantom 4 Pro V2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4ProV2_inline",
                   "",
            ],
            [
                   "P_4_MULTISPECTRAL",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Multispectral_inline",
                   "The aircraft's model name is P4 Multispectral.",
            ],
            [
                   "The aircraft's model name is P4 Multispectral.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Multispectral_inline",
                   "",
            ],
            [
                   "MAVIC_AIR_2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicAir2_inline",
                   "The aircraft's model name is Mavic Air 2.",
            ],
            [
                   "The aircraft's model name is Mavic Air 2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicAir2_inline",
                   "",
            ],
            [
                   "DJI_MINI_SE",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIMiniSE_inline",
                   "The aircraft's model name is DJI Mini SE.",
            ],
            [
                   "The aircraft's model name is DJI Mini SE.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIMiniSE_inline",
                   "",
            ],
            [
                   "DJI_MINI_2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIMini2_inline",
                   "The aircraft's model name is DJI Mini 2.",
            ],
            [
                   "The aircraft's model name is DJI Mini 2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIMini2_inline",
                   "",
            ],
            [
                   "MAVIC_2_ENTERPRISE_ADVANCED",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2EnterpriseAdvanced_inline",
                   "The aircraft's model name is Mavic 2 Enterprise Advanced.",
            ],
            [
                   "The aircraft's model name is Mavic 2 Enterprise Advanced.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2EnterpriseAdvanced_inline",
                   "",
            ],
            [
                   "MATRICE_100",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice100_inline",
                   "The aircraft's model name is Matrice 100.",
            ],
            [
                   "The aircraft's model name is Matrice 100.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice100_inline",
                   "",
            ],
            [
                   "MATRICE_200",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice200_inline",
                   "The aircraft's model name is Matrice 200.",
            ],
            [
                   "The aircraft's model name is Matrice 200.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice200_inline",
                   "",
            ],
            [
                   "PHANTOM_4_ADVANCED",
                   2,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Advanced_inline",
                   "The aircraft's model name is Phantom 4 Advanced.",
            ],
            [
                   "The aircraft's model name is Phantom 4 Advanced.",
                   1,
                   "/Products/Aircraft/DJIAircraft.html",
                   "#DJIAircraft_DJIAircraftModelNamePhantom4Advanced_inline",
                   "",
            ],
            [
                   "MATRICE_600",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice600_inline",
                   "The aircraft's model name is Matrice 600.",
            ],
            [
                   "The aircraft's model name is Matrice 600.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice600_inline",
                   "",
            ],
            [
                   "MATRICE_600_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice600Pro_inline",
                   "The aircraft's model name is Matrice 600 Pro.",
            ],
            [
                   "The aircraft's model name is Matrice 600 Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice600Pro_inline",
                   "",
            ],
            [
                   "A3",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameA3_inline",
                   "The aircraft flight controller's model name is A3.",
            ],
            [
                   "The aircraft flight controller's model name is A3.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameA3_inline",
                   "",
            ],
            [
                   "MAVIC_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicPro_inline",
                   "The aircraft's model name is Mavic Pro.",
            ],
            [
                   "The aircraft's model name is Mavic Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicPro_inline",
                   "",
            ],
            [
                   "Spark",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameSpark_inline",
                   "The aircraft's model name is Spark.",
            ],
            [
                   "The aircraft's model name is Spark.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameSpark_inline",
                   "",
            ],
            [
                   "MATRICE_210",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210_inline",
                   "The aircraft's model name is Matrice 210.",
            ],
            [
                   "The aircraft's model name is Matrice 210.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210_inline",
                   "",
            ],
            [
                   "MATRICE_210_RTK",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210RTK_inline",
                   "The aircraft's model name is Matrice 210 RTK.",
            ],
            [
                   "The aircraft's model name is Matrice 210 RTK.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210RTK_inline",
                   "",
            ],
            [
                   "MATRICE_200_V2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice200V2_inline",
                   "The aircraft's model name is Matrice 200 V2.",
            ],
            [
                   "The aircraft's model name is Matrice 200 V2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice200V2_inline",
                   "",
            ],
            [
                   "MATRICE_210_V2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210V2_inline",
                   "The aircraft's model name is Matrice 210 V2.",
            ],
            [
                   "The aircraft's model name is Matrice 210 V2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210V2_inline",
                   "",
            ],
            [
                   "MATRICE_210_RTK_V2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210RTKV2_inline",
                   "The aircraft's model name is Matrice 210 RTK V2.",
            ],
            [
                   "The aircraft's model name is Matrice 210 RTK V2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice210RTKV2_inline",
                   "",
            ],
            [
                   "MATRICE_300_RTK",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice300RTK_inline",
                   "The aircraft's model name is Matrice 300 RTK.",
            ],
            [
                   "The aircraft's model name is Matrice 300 RTK.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMatrice300RTK_inline",
                   "",
            ],
            [
                   "MAVIC_AIR",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicAir_inline",
                   "The aircraft's model name is Mavic Air.",
            ],
            [
                   "The aircraft's model name is Mavic Air.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicAir_inline",
                   "",
            ],
            [
                   "MAVIC_2_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Pro_inline",
                   "The aircraft's model name is Mavic 2 Pro.",
            ],
            [
                   "The aircraft's model name is Mavic 2 Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Pro_inline",
                   "",
            ],
            [
                   "MAVIC_2_ZOOM",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Zoom_inline",
                   "The aircraft's model name is Mavic 2 Zoom.",
            ],
            [
                   "The aircraft's model name is Mavic 2 Zoom.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Zoom_inline",
                   "",
            ],
            [
                   "MAVIC_2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2_inline",
                   "The aircraft's model name is either Mavic 2 Pro or Mavic 2 Zoom.  The camera is not recognized yet.",
            ],
            [
                   "The aircraft's model name is either Mavic 2 Pro or Mavic 2 Zoom.  The camera is not recognized yet.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2_inline",
                   "",
            ],
            [
                   "MAVIC_2_ENTERPRISE",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Enterprise_inline",
                   "The aircraft's model name is Mavic 2 Enterprise.",
            ],
            [
                   "The aircraft's model name is Mavic 2 Enterprise.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2Enterprise_inline",
                   "",
            ],
            [
                   "MAVIC_2_ENTERPRISE_DUAL",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2EnterpriseDual_inline",
                   "The aircraft's model name is Mavic 2 Enterprise Dual.",
            ],
            [
                   "The aircraft's model name is Mavic 2 Enterprise Dual.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavic2EnterpriseDual_inline",
                   "",
            ],
            [
                   "MAVIC_MINI",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicMini_inline",
                   "The aircraft's model name is Mavic Mini.",
            ],
            [
                   "The aircraft's model name is Mavic Mini.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameMavicMini_inline",
                   "",
            ],
            [
                   "DJI_AIR_2S",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIAir2S_inline",
                   "The aircraft's model name is DJI Air 2S.",
            ],
            [
                   "The aircraft's model name is DJI Air 2S.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameDJIAir2S_inline",
                   "",
            ],
            [
                   "N3",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameN3_inline",
                   "The aircraft flight controller's model name is N3.",
            ],
            [
                   "The aircraft flight controller's model name is N3.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIAircraft_DJIAircraftModelNameN3_inline",
                   "",
            ],
            [
                   "getLoggedInDJIUserAccountName",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_loggedInDJIUserAccountName_inline",
                   "The name of the currently logged in user account.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The name of the currently logged in user account.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_loggedInDJIUserAccountName_inline",
                   "",
            ],
            [
                   "getUserAccountState",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_getUserAccountState_inline",
                   "Gets the DJI user account state.  @return An enum value of `UserAccountState`.",
            ],
            [
                   "Gets the DJI user account state.  @return An enum value of `UserAccountState`.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_getUserAccountState_inline",
                   "",
            ],
            [
                   "logIntoDJIUserAccount",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_logIntoDJIUserAccountWithAuthorizationRequired_inline",
                   "After invoking this method, a dialog redirecting users to log into their DJI account  will be shown. For users outside of China, authorization is required to unlock  authorization zones. After the login process, if `authorizationRequired` is `true`,  and the user is currently out of China and the account has not been authorized to  unlock authorization zones, the dialog will then redirect users to authorize their account.  @param context The android activity's or view's context. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "After invoking this method, a dialog redirecting users to log into their DJI account  will be shown. For users outside of China, authorization is required to unlock  authorization zones. After the login process, if `authorizationRequired` is `true`,  and the user is currently out of China and the account has not been authorized to  unlock authorization zones, the dialog will then redirect users to authorize their account.  @param context The android activity's or view's context. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_logIntoDJIUserAccountWithAuthorizationRequired_inline",
                   "",
            ],
            [
                   "logoutOfDJIUserAccount",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_logOutOfDJIUserAccount_inline",
                   "Logs out the DJI user that is logged in.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Logs out the DJI user that is logged in.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_logOutOfDJIUserAccount_inline",
                   "",
            ],
            [
                   "addUserAccountStateChangeListener",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_addUserAccountStateChangeListener_inline",
                   "Start listen to the update of the user account state.  @param listener A `UserAccountStateChangeListener` interface.",
            ],
            [
                   "Start listen to the update of the user account state.  @param listener A `UserAccountStateChangeListener` interface.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_addUserAccountStateChangeListener_inline",
                   "",
            ],
            [
                   "removeUserAccountStateChangeListener",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_removeUserAccountStateChangeListener_inline",
                   "Remove the listener.  @param listener A `UserAccountStateChangeListener` interface.",
            ],
            [
                   "Remove the listener.  @param listener A `UserAccountStateChangeListener` interface.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_removeUserAccountStateChangeListener_inline",
                   "",
            ],
            [
                   "UserAccountStateChangeListener",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountStateChangeListenerInterface.html",
                   "",
                   "Receive user account state and user account information of the user account manager.",
            ],
            [
                   "Receive user account state and user account information of the user account manager.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountStateChangeListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onUserAccountStateChanged",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountStateChangeListenerInterface.html",
                   "#DJIUserAccountManager_UserAccountStateChangeListenerInterface_onUserAccountStateChanged_inline",
                   "Called when the user account manager update the user account information.  @param state Provides the user account states. @param information Provides the account information of the user account.",
            ],
            [
                   "Called when the user account manager update the user account information.  @param state Provides the user account states. @param information Provides the account information of the user account.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountStateChangeListenerInterface.html",
                   "#DJIUserAccountManager_UserAccountStateChangeListenerInterface_onUserAccountStateChanged_inline",
                   "",
            ],
            [
                   "UserAccountInformation",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "",
                   "Account information for a logged-in user.",
            ],
            [
                   "Account information for a logged-in user.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "",
                   "",
            ],
            [
                   "getAccount",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "#DJIUserAccountManager_UserAccountInformation_getAccount_inline",
                   "The username of the account.  @return The username of the account.",
            ],
            [
                   "The username of the account.  @return The username of the account.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "#DJIUserAccountManager_UserAccountInformation_getAccount_inline",
                   "",
            ],
            [
                   "isVerified",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "#DJIUserAccountManager_UserAccountInformation_isVerified_inline",
                   "Whether the account is verified.  @return `true` if the account is verified, false otherwise.",
            ],
            [
                   "Whether the account is verified.  @return `true` if the account is verified, false otherwise.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager_UserAccountInformation.html",
                   "#DJIUserAccountManager_UserAccountInformation_isVerified_inline",
                   "",
            ],
            [
                   "UserAccountState",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_inline",
                   "User account status. Users need to be logged in.",
            ],
            [
                   "User account status. Users need to be logged in.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_inline",
                   "",
            ],
            [
                   "NOT_LOGGED_IN",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_NotLoggedIn_inline",
                   "User is not logged in. User needs to be logged in to retrieve currently unlocked,  and unlock authorization zones.",
            ],
            [
                   "User is not logged in. User needs to be logged in to retrieve currently unlocked,  and unlock authorization zones.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_NotLoggedIn_inline",
                   "",
            ],
            [
                   "NOT_AUTHORIZED",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_NotAuthorized_inline",
                   "User is logged in but has not been authorized to unlock authorization zones.",
            ],
            [
                   "User is logged in but has not been authorized to unlock authorization zones.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_NotAuthorized_inline",
                   "",
            ],
            [
                   "AUTHORIZED",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_Authorized_inline",
                   "User is logged in and has been authorized to unlock authorization zones.",
            ],
            [
                   "User is logged in and has been authorized to unlock authorization zones.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_Authorized_inline",
                   "",
            ],
            [
                   "TOKEN_OUT_OF_DATE",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_TokenOutOfDate_inline",
                   "The token of the user account is out of date.",
            ],
            [
                   "The token of the user account is out of date.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_TokenOutOfDate_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/UserAccountManager/DJIUserAccountManager.html",
                   "#DJIUserAccountManager_DJIUserAccountState_Unknown_inline",
                   "",
            ],
            [
                   "getSDKVersion",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getSDKVersion_inline",
                   "Gets the DJI Mobile SDK Version. Returns SDK version as a string.  @return A SDK version String instance.",
            ],
            [
                   "Gets the DJI Mobile SDK Version. Returns SDK version as a string.  @return A SDK version String instance.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getSDKVersion_inline",
                   "",
            ],
            [
                   "registerApp",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_registerApp_inline",
                   "The first time the app is initialized after installation, the app connects to a DJI Server through the internet to verify the Application Key. The request will include the following information:  - App key  - Bundle ID  - Device UUID generated from hashed mobile device ID (`getDeviceID`), hashed SIM serial number (`getSIMSerialNumber`) and hashed ANDROID ID (`Secure.ANDROID_ID`). If `READ_PHONE_STATE` permission is not permitted, a random UUID is generated.  - System platform, version and name  - UUID generated by platform's API (`[UIDevice currentDevice] identifierForVendor]`)  - Mobile device model  - Internet related feature initialisation.  Subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context Android context. @param callback Callback used for both the registration result, and when the products changes.",
            ],
            [
                   "The first time the app is initialized after installation, the app connects to a DJI Server through the internet to verify the Application Key. The request will include the following information:  - App key  - Bundle ID  - Device UUID generated from hashed mobile device ID (`getDeviceID`), hashed SIM serial number (`getSIMSerialNumber`) and hashed ANDROID ID (`Secure.ANDROID_ID`). If `READ_PHONE_STATE` permission is not permitted, a random UUID is generated.  - System platform, version and name  - UUID generated by platform's API (`[UIDevice currentDevice] identifierForVendor]`)  - Mobile device model  - Internet related feature initialisation.  Subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context Android context. @param callback Callback used for both the registration result, and when the products changes.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_registerApp_inline",
                   "",
            ],
            [
                   "registerAppForLDM",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_registerAppForLDM_inline",
                   "Designed for LDM feature `LDMManager`. The first time the app is initialized after installation, the app connects to a DJI Server through the internet to verify the Application Key. The request will include the following information:  - App key  - Bundle ID  - Device UUID generated from hashed mobile device ID (`getDeviceID`), hashed SIM serial number (`getSIMSerialNumber`) and hashed ANDROID ID (`Secure.ANDROID_ID`). If `READ_PHONE_STATE` permission is not permitted, a random UUID is generated.  - System platform, version and name  - UUID generated by platform's API (`[UIDevice currentDevice] identifierForVendor]`)  - Mobile device model <strong> - Internet related feature initialisation (not included)</strong>  After successfully registered, the app will enter LDM mode. Subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context Android context. @param callback Callback used for both the registration result, and when the products changes.",
            ],
            [
                   "Designed for LDM feature `LDMManager`. The first time the app is initialized after installation, the app connects to a DJI Server through the internet to verify the Application Key. The request will include the following information:  - App key  - Bundle ID  - Device UUID generated from hashed mobile device ID (`getDeviceID`), hashed SIM serial number (`getSIMSerialNumber`) and hashed ANDROID ID (`Secure.ANDROID_ID`). If `READ_PHONE_STATE` permission is not permitted, a random UUID is generated.  - System platform, version and name  - UUID generated by platform's API (`[UIDevice currentDevice] identifierForVendor]`)  - Mobile device model <strong> - Internet related feature initialisation (not included)</strong>  After successfully registered, the app will enter LDM mode. Subsequent app starts will use locally cached verification information to register the app when the cached information is still valid.  @param context Android context. @param callback Callback used for both the registration result, and when the products changes.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_registerAppForLDM_inline",
                   "",
            ],
            [
                   "hasSDKRegistered",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_hasSDKRegistered_inline",
                   "Registration state.  @return `true` if SDK is registered.",
            ],
            [
                   "Registration state.  @return `true` if SDK is registered.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_hasSDKRegistered_inline",
                   "",
            ],
            [
                   "USB_ACCESSORY_ATTACHED",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_USB_ACCESSORY_ATTACHED_inline",
                   "When this string is received in a broadcast, the SDK will attempt to connect to USB accessory.",
            ],
            [
                   "When this string is received in a broadcast, the SDK will attempt to connect to USB accessory.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_USB_ACCESSORY_ATTACHED_inline",
                   "",
            ],
            [
                   "getInstance",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getInstance_inline",
                   "Accessor for `DJISDKManager` object.  @return An instance of `DJISDKManager` object.",
            ],
            [
                   "Accessor for `DJISDKManager` object.  @return An instance of `DJISDKManager` object.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getInstance_inline",
                   "",
            ],
            [
                   "setCallbackRunInUIThread",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_setCallbackRunInUIThread_inline",
                   "Determines whether asynchronous getter and setter method callbacks should be invoked in UIThread or BackgroundThread. This method is only for setters and getters, as push data callbacks (typically state data) always return in the BackgroundThread.  @param enable A boolean value.",
            ],
            [
                   "Determines whether asynchronous getter and setter method callbacks should be invoked in UIThread or BackgroundThread. This method is only for setters and getters, as push data callbacks (typically state data) always return in the BackgroundThread.  @param enable A boolean value.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_setCallbackRunInUIThread_inline",
                   "",
            ],
            [
                   "closeAOAConnection",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_closeAoaConnection_inline",
                   "This method is used to close the AOA connection during development and should not be used in the final application. When using AS or Eclipse to build and run the application, the AOA connection is not properly closed if the application is terminated. As a result, the next time the application is run, the SDK will not be able to connect to the product without first disconnecting and reconnecting the USB cable. AS and Eclipse can be configured to invoke this method before compiling the application, closing the link before the application is run, and overcoming this problem.",
            ],
            [
                   "This method is used to close the AOA connection during development and should not be used in the final application. When using AS or Eclipse to build and run the application, the AOA connection is not properly closed if the application is terminated. As a result, the next time the application is run, the SDK will not be able to connect to the product without first disconnecting and reconnecting the USB cable. AS and Eclipse can be configured to invoke this method before compiling the application, closing the link before the application is run, and overcoming this problem.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_closeAoaConnection_inline",
                   "",
            ],
            [
                   "getAppActivationManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_appActivationManager_inline",
                   "Used to check the states related to the App Activation.  @return An instance of `AppActivationManager`.",
            ],
            [
                   "Used to check the states related to the App Activation.  @return An instance of `AppActivationManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_appActivationManager_inline",
                   "",
            ],
            [
                   "getRTKNetworkServiceProvider",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_rtkNetworkServiceProvider_inline",
                   "Accesses the RTK network service provider.  @return An instance of `RTKNetworkServiceProvider`.",
            ],
            [
                   "Accesses the RTK network service provider.  @return An instance of `RTKNetworkServiceProvider`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_rtkNetworkServiceProvider_inline",
                   "",
            ],
            [
                   "getUpgradeManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_upgradeManager_inline",
                   "Provide access to UpgradeManager used to manage components upgrade.  @return An instance of `UpgradeManager`.",
            ],
            [
                   "Provide access to UpgradeManager used to manage components upgrade.  @return An instance of `UpgradeManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_upgradeManager_inline",
                   "",
            ],
            [
                   "getUasRemoteIDManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_UASRemoteIDManager_inline",
                   "Provide access to UASRemoteIDManager used to manage UA SRemote ID.  @return An instance of DJIUASRemoteIDManager</code>.",
            ],
            [
                   "Provide access to UASRemoteIDManager used to manage UA SRemote ID.  @return An instance of DJIUASRemoteIDManager</code>.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_UASRemoteIDManager_inline",
                   "",
            ],
            [
                   "getProduct",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_product_inline",
                   "The DJI product which is connected to the mobile device, only available after successful registration of the app.  @return An instance of `BaseProduct`.",
            ],
            [
                   "The DJI product which is connected to the mobile device, only available after successful registration of the app.  @return An instance of `BaseProduct`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_product_inline",
                   "",
            ],
            [
                   "getBluetoothProductConnector",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_bluetoothConnector_inline",
                   "Used to establish the Bluetooth connection between the mobile device and the DJI product. The Bluetooth connection needs to be established before a connection between the SDK and the DJI product can be made using `startConnectionToProduct`.  @return A `BluetoothProductConnector` instance.",
            ],
            [
                   "Used to establish the Bluetooth connection between the mobile device and the DJI product. The Bluetooth connection needs to be established before a connection between the SDK and the DJI product can be made using `startConnectionToProduct`.  @return A `BluetoothProductConnector` instance.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_bluetoothConnector_inline",
                   "",
            ],
            [
                   "startConnectionToProduct",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_startConnectionToProduct_inline",
                   "Starts a connection between the SDK and the DJI product. This method should be called after successful registration of the app and once there is a data connection between the mobile device and DJI product. This data connection is either a USB cable connection, a WiFi connection (that needs to be established outside of the SDK) or a Bluetooth connection (that needs to be established with `getBluetoothProductConnector`). If the connection succeeds, `onProductConnect` will be called if the connection succeeded. Returns `true` if the connection is started successfully. For products which connect to the mobile device using Bluetooth, `getBluetoothProductConnector` should be used to get a `BluetoothProductConnector` object which can handle Bluetooth device connection.  @return `true` if the connection is started successfully.",
            ],
            [
                   "Starts a connection between the SDK and the DJI product. This method should be called after successful registration of the app and once there is a data connection between the mobile device and DJI product. This data connection is either a USB cable connection, a WiFi connection (that needs to be established outside of the SDK) or a Bluetooth connection (that needs to be established with `getBluetoothProductConnector`). If the connection succeeds, `onProductConnect` will be called if the connection succeeded. Returns `true` if the connection is started successfully. For products which connect to the mobile device using Bluetooth, `getBluetoothProductConnector` should be used to get a `BluetoothProductConnector` object which can handle Bluetooth device connection.  @return `true` if the connection is started successfully.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_startConnectionToProduct_inline",
                   "",
            ],
            [
                   "stopConnectionToProduct",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_stopConnectionToProduct_inline",
                   "Disconnect from the connected DJI product.",
            ],
            [
                   "Disconnect from the connected DJI product.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_stopConnectionToProduct_inline",
                   "",
            ],
            [
                   "setSupportOnlyForBluetoothDevice",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_setSupportOnlyForBluetoothDevice_inline",
                   "If only Bluetooth devices will be connected, then this should be set to `true`.  @param isBluetoothDevice `true` if only Bluetooth devices will be connected.",
            ],
            [
                   "If only Bluetooth devices will be connected, then this should be set to `true`.  @param isBluetoothDevice `true` if only Bluetooth devices will be connected.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_setSupportOnlyForBluetoothDevice_inline",
                   "",
            ],
            [
                   "enableBridgeModeWithBridgeAppIP",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_enterDebugMode_inline",
                   "Enter debug mode with debug IP.  @param bridgeAppIP Debug IP of the DJI Bridge App.",
            ],
            [
                   "Enter debug mode with debug IP.  @param bridgeAppIP Debug IP of the DJI Bridge App.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_enterDebugMode_inline",
                   "",
            ],
            [
                   "getLogPath",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getLogPath_inline",
                   "Gets the path that flight logs are stored to. Flight logs are automatically defineed by MSDK and stored on the mobile device. The SDK does nothing with these logs, and they are provided only as a convenience for developers and users. Users can use these flight logs with DJI service centers if they are making a warranty claim. Only developers using the SDK, and users of the mobile device can access these logs. Older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs.  @return An NSString object of the flight log path.",
            ],
            [
                   "Gets the path that flight logs are stored to. Flight logs are automatically defineed by MSDK and stored on the mobile device. The SDK does nothing with these logs, and they are provided only as a convenience for developers and users. Users can use these flight logs with DJI service centers if they are making a warranty claim. Only developers using the SDK, and users of the mobile device can access these logs. Older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs.  @return An NSString object of the flight log path.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getLogPath_inline",
                   "",
            ],
            [
                   "getFlycLogPath",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getFlycLogPath_inline",
                   "Gets the path that flight control compact logs are stored to. Flight control compact logs are defined by flight controller and stored on the mobile device. The SDK does nothing with these logs, and they are provided only as a convenience for developers and users. Users can use these flight logs with DJI service centers if they are making a warranty claim. Only developers using the SDK, and users of the mobile device can access these logs. Older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs. Supported by DJI Air 2S, DJI Mini 2, DJI Mini SE, Mavic Air 2, Mavic Mini, Mavic Pro, Phantom 4 Pro, Matrice 300 RTK.  @return An NSString object of the flight control compact log path.",
            ],
            [
                   "Gets the path that flight control compact logs are stored to. Flight control compact logs are defined by flight controller and stored on the mobile device. The SDK does nothing with these logs, and they are provided only as a convenience for developers and users. Users can use these flight logs with DJI service centers if they are making a warranty claim. Only developers using the SDK, and users of the mobile device can access these logs. Older flight logs are overwritten by newer flight logs over time, so the flight log path is given in case an application needs to store all logs. Supported by DJI Air 2S, DJI Mini 2, DJI Mini SE, Mavic Air 2, Mavic Mini, Mavic Pro, Phantom 4 Pro, Matrice 300 RTK.  @return An NSString object of the flight control compact log path.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getFlycLogPath_inline",
                   "",
            ],
            [
                   "getFlyZoneManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_flyZoneManager_inline",
                   "Provide access to `FlyZoneManager` used to manage DJI's GEO system for no fly zones.  @return An instance of `FlyZoneManager`.",
            ],
            [
                   "Provide access to `FlyZoneManager` used to manage DJI's GEO system for no fly zones.  @return An instance of `FlyZoneManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_flyZoneManager_inline",
                   "",
            ],
            [
                   "getKeyManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_keyManager_inline",
                   "Provide access to the SDK Key interface.  @return An instance of `KeyManager`.",
            ],
            [
                   "Provide access to the SDK Key interface.  @return An instance of `KeyManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_keyManager_inline",
                   "",
            ],
            [
                   "getMissionControl",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_missionControl_inline",
                   "Provide access to `MissionControl` used to manage missions.  @return An instance of `MissionControl`.",
            ],
            [
                   "Provide access to `MissionControl` used to manage missions.  @return An instance of `MissionControl`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_missionControl_inline",
                   "",
            ],
            [
                   "getFlightHubManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_flightHubManager_inline",
                   "Provide access to `FlightHubManager`. It can be used to interact with DJI FlightHub (https://www.dji.com/flighthub).  @return An instance of `FlightHubManager`.",
            ],
            [
                   "Provide access to `FlightHubManager`. It can be used to interact with DJI FlightHub (https://www.dji.com/flighthub).  @return An instance of `FlightHubManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_flightHubManager_inline",
                   "",
            ],
            [
                   "getLiveStreamManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_liveStreamManager_inline",
                   "Provides access to `getLiveStreamManager`. It can be used to stream the video to a RTMP server to do live streaming with DJI products.  @return An instance of `getLiveStreamManager`.",
            ],
            [
                   "Provides access to `getLiveStreamManager`. It can be used to stream the video to a RTMP server to do live streaming with DJI products.  @return An instance of `getLiveStreamManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_liveStreamManager_inline",
                   "",
            ],
            [
                   "getLDMManager",
                   2,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getLDMManager_inline",
                   "Manages Local Data Mode (LDM) functionality. Local data mode gives the developer the option to put the SDK into airplane mode, restricting its access to the internet. See `LDMManager` for details on when and where this is possible, and what is restricted.  @return An instance of `LDMManager`.",
            ],
            [
                   "Manages Local Data Mode (LDM) functionality. Local data mode gives the developer the option to put the SDK into airplane mode, restricting its access to the internet. See `LDMManager` for details on when and where this is possible, and what is restricted.  @return An instance of `LDMManager`.",
                   1,
                   "/Components/SDKManager/DJISDKManager.html",
                   "#DJISDKManager_getLDMManager_inline",
                   "",
            ],
            [
                   "SDKManagerCallback",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "",
                   "Callback interface for SDK manager.",
            ],
            [
                   "Callback interface for SDK manager.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BluetoothProductConnector",
                   2,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "",
                   "Some DJI products can be controlled using the Mobile SDK over a Bluetooth wireless connection. This class contains methods to search for, connect to, and disconnect from such products.",
            ],
            [
                   "Some DJI products can be controlled using the Mobile SDK over a Bluetooth wireless connection. This class contains methods to search for, connect to, and disconnect from such products.",
                   1,
                   "/Components/SDKManager/DJIBluetoothProductConnector.html",
                   "",
                   "",
            ],
            [
                   "onRegister",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_didRegisterAppWithError_inline",
                   "Callback method after the application attempts to register.  @param error `REGISTRATION_SUCCESS` if registration is successful.",
            ],
            [
                   "Callback method after the application attempts to register.  @param error `REGISTRATION_SUCCESS` if registration is successful.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_didRegisterAppWithError_inline",
                   "",
            ],
            [
                   "onProductConnect",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productConnectedUpdate_inline",
                   "Called when the product is connected.  @param product Product object. nil if the USB link or WiFi link between the product and phone is disconnected.",
            ],
            [
                   "Called when the product is connected.  @param product Product object. nil if the USB link or WiFi link between the product and phone is disconnected.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productConnectedUpdate_inline",
                   "",
            ],
            [
                   "ProductKey.CONNECTION",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productConnectedUpdate_inline",
                   "SDK Key for onProductConnect: Called when the product is connected.  @param product Product object. nil if the USB link or WiFi link between the product and phone is disconnected.",
            ],
            [
                   "SDK Key for onProductConnect: Called when the product is connected.  @param product Product object. nil if the USB link or WiFi link between the product and phone is disconnected.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productConnectedUpdate_inline",
                   "",
            ],
            [
                   "onProductDisconnect",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productDisconnectedUpdate_inline",
                   "Called when the product is disconnected.",
            ],
            [
                   "Called when the product is disconnected.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productDisconnectedUpdate_inline",
                   "",
            ],
            [
                   "ProductKey.CONNECTION",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productDisconnectedUpdate_inline",
                   "SDK Key for onProductDisconnect: Called when the product is disconnected.",
            ],
            [
                   "SDK Key for onProductDisconnect: Called when the product is disconnected.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productDisconnectedUpdate_inline",
                   "",
            ],
            [
                   "onProductChanged",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productChanged_inline",
                   "Called when the connected product is changed. The product will be updated when the aircraft connected changes from only remote controller connected.  @param product An instance of `BaseProduct`.",
            ],
            [
                   "Called when the connected product is changed. The product will be updated when the aircraft connected changes from only remote controller connected.  @param product An instance of `BaseProduct`.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_productChanged_inline",
                   "",
            ],
            [
                   "onComponentChange",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onComponentChange_inline",
                   "Called when a component object changes. Note: if the component is disconnected, this method will not be called, pls use ComponentListener to listen the disconnect event of any component.  @param key An enum value of the `ComponentKey`. @param oldComponent An instance of `BaseComponent`. @param newComponent An instance of `BaseComponent`.",
            ],
            [
                   "Called when a component object changes. Note: if the component is disconnected, this method will not be called, pls use ComponentListener to listen the disconnect event of any component.  @param key An enum value of the `ComponentKey`. @param oldComponent An instance of `BaseComponent`. @param newComponent An instance of `BaseComponent`.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onComponentChange_inline",
                   "",
            ],
            [
                   "ProductKey.CONNECTION",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onComponentChange_inline",
                   "SDK Key for onComponentChange: Called when a component object changes. Note: if the component is disconnected, this method will not be called, pls use ComponentListener to listen the disconnect event of any component.  @param key An enum value of the `ComponentKey`. @param oldComponent An instance of `BaseComponent`. @param newComponent An instance of `BaseComponent`.",
            ],
            [
                   "SDK Key for onComponentChange: Called when a component object changes. Note: if the component is disconnected, this method will not be called, pls use ComponentListener to listen the disconnect event of any component.  @param key An enum value of the `ComponentKey`. @param oldComponent An instance of `BaseComponent`. @param newComponent An instance of `BaseComponent`.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onComponentChange_inline",
                   "",
            ],
            [
                   "onInitProcess",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onInitProcess_inline",
                   "Called when load sdk resource.  @param event An event that show what resource is loading. @param totalProcess The totalProcess of load resource, from 0 to 100.",
            ],
            [
                   "Called when load sdk resource.  @param event An event that show what resource is loading. @param totalProcess The totalProcess of load resource, from 0 to 100.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onInitProcess_inline",
                   "",
            ],
            [
                   "onDatabaseDownloadProgress",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onDatabaseDownloadProgress_inline",
                   "Called when Fly Safe database download progress is updated. Mobile SDK will download the database when `registerApp`  is invoked, if fly-safe-database is excluded in build.gradle. Please find `onRegister` for updated error.  @param current The current download data size. @param total The total size of the file being downloaded.",
            ],
            [
                   "Called when Fly Safe database download progress is updated. Mobile SDK will download the database when `registerApp`  is invoked, if fly-safe-database is excluded in build.gradle. Please find `onRegister` for updated error.  @param current The current download data size. @param total The total size of the file being downloaded.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKManagerCallbackInterface.html",
                   "#DJISDKManager_onDatabaseDownloadProgress_inline",
                   "",
            ],
            [
                   "DJISDKInitEvent",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "",
                   "The loading status of the DJI SDK.",
            ],
            [
                   "The loading status of the DJI SDK.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "",
                   "",
            ],
            [
                   "getInitializationState",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_getInitializationState_inline",
                   "Get the SDK initialization state.  @return An enum value of `DJISDKInitEvent`.",
            ],
            [
                   "Get the SDK initialization state.  @return An enum value of `DJISDKInitEvent`.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_getInitializationState_inline",
                   "",
            ],
            [
                   "InitializationState",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_inline",
                   "SDK Initialization States.",
            ],
            [
                   "SDK Initialization States.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_inline",
                   "",
            ],
            [
                   "START_TO_INITIALIZE",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_START_TO_INITIALIZE_inline",
                   "DJI SDK initialization starts.",
            ],
            [
                   "DJI SDK initialization starts.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_START_TO_INITIALIZE_inline",
                   "",
            ],
            [
                   "ASSETS_LOADED",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_ASSETS_LOADED_inline",
                   "DJI SDK assets has loaded.",
            ],
            [
                   "DJI SDK assets has loaded.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_ASSETS_LOADED_inline",
                   "",
            ],
            [
                   "DATABASE_LOADED",
                   2,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_DATABASE_LOADED_inline",
                   "DJI SDK Fly Safe database has loaded.",
            ],
            [
                   "DJI SDK Fly Safe database has loaded.",
                   1,
                   "/Components/SDKManager/DJISDKManager_DJISDKInitEvent.html",
                   "#DJISDKManager_DJISDKInitEvent_InitializationState_DATABASE_LOADED_inline",
                   "",
            ],
            [
                   "setLeftStickVertical",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_leftStickVertical_inline",
                   "Simulates the vertical movement of the left stick, which changes the aircraft's thrust causing it to raise or  lower in elevation. The valid range is [-1, 1].  @param data A float value of the left stick vertical movement.",
            ],
            [
                   "Simulates the vertical movement of the left stick, which changes the aircraft's thrust causing it to raise or  lower in elevation. The valid range is [-1, 1].  @param data A float value of the left stick vertical movement.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_leftStickVertical_inline",
                   "",
            ],
            [
                   "setLeftStickHorizontal",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_leftStickHorizontal_inline",
                   "Simulates the horizontal movement of the left stick, which changes the yaw of the aircraft causing it to rotate  horizontally. The valid range is [-1, 1].  @param data A float value of the left stick horizontal movement.",
            ],
            [
                   "Simulates the horizontal movement of the left stick, which changes the yaw of the aircraft causing it to rotate  horizontally. The valid range is [-1, 1].  @param data A float value of the left stick horizontal movement.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_leftStickHorizontal_inline",
                   "",
            ],
            [
                   "setRightStickVertical",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_rightStickVertical_inline",
                   "Simulates the vertical movement of the right stick, which changes the the aircraft's pitch causing it to fly  forward or backward. The valid range is [-1, 1].  @param data A float value of the right stick vertical movement.",
            ],
            [
                   "Simulates the vertical movement of the right stick, which changes the the aircraft's pitch causing it to fly  forward or backward. The valid range is [-1, 1].  @param data A float value of the right stick vertical movement.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_rightStickVertical_inline",
                   "",
            ],
            [
                   "setRightStickHorizontal",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_rightStickHorizontal_inline",
                   "Simulates the horizontal movement of the right stick, which changes the the aircraft's roll causing it to fly  left or right. The valid range is  [-1, 1].  @param data A float value of the left stick horizontal movement.",
            ],
            [
                   "Simulates the horizontal movement of the right stick, which changes the the aircraft's roll causing it to fly  left or right. The valid range is  [-1, 1].  @param data A float value of the left stick horizontal movement.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_rightStickHorizontal_inline",
                   "",
            ],
            [
                   "getLeftStickVertical",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getLeftStickVertical_inline",
                   "Gets the vertical movement value of the left stick.  @return A float value.",
            ],
            [
                   "Gets the vertical movement value of the left stick.  @return A float value.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getLeftStickVertical_inline",
                   "",
            ],
            [
                   "getLeftStickHorizontal",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getLeftStickHorizontal_inline",
                   "Gets the horizontal movement value of the left stick.  @return A float value.",
            ],
            [
                   "Gets the horizontal movement value of the left stick.  @return A float value.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getLeftStickHorizontal_inline",
                   "",
            ],
            [
                   "getRightStickVertical",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getRightStickVertical_inline",
                   "Gets the vertical movement value of the right stick.  @return A float value.",
            ],
            [
                   "Gets the vertical movement value of the right stick.  @return A float value.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getRightStickVertical_inline",
                   "",
            ],
            [
                   "getRightStickHorizontal",
                   2,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getRightStickHorizontal_inline",
                   "Gets the horizontal movement value of the right stick.  @return A float value.",
            ],
            [
                   "Gets the horizontal movement value of the right stick.  @return A float value.",
                   1,
                   "/Components/MobileRemoteController/DJIMobileRemoteController.html",
                   "#DJIMobileRemoteController_getRightStickHorizontal_inline",
                   "",
            ],
            [
                   "isLDMSupported",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isLDMSupported_inline",
                   "`true` if LDM is supported in the current context. The SDK locally uses GPS location and MCC (mobile country code) to determine the country  of operation. If LDM is not enabled and the internet is accessible, the IP address is also used to determine the country of operation. The default value is `true` after the first installation.  @return A bool value to check if LDM is supported.",
            ],
            [
                   "`true` if LDM is supported in the current context. The SDK locally uses GPS location and MCC (mobile country code) to determine the country  of operation. If LDM is not enabled and the internet is accessible, the IP address is also used to determine the country of operation. The default value is `true` after the first installation.  @return A bool value to check if LDM is supported.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isLDMSupported_inline",
                   "",
            ],
            [
                   "isLDMEnabled",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isLDMEnabled_inline",
                   "`true` if LDM is already enabled.  @return A boolean value to check if LDM is enabled.",
            ],
            [
                   "`true` if LDM is already enabled.  @return A boolean value to check if LDM is enabled.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isLDMEnabled_inline",
                   "",
            ],
            [
                   "getLDMSupported",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_getLDMSupported_inline",
                   "`true` if LDM is supported. The SDK will get whether your app supports LDM from the remote server.  @param callback The execution callback.",
            ],
            [
                   "`true` if LDM is supported. The SDK will get whether your app supports LDM from the remote server.  @param callback The execution callback.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_getLDMSupported_inline",
                   "",
            ],
            [
                   "enableLDM",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_enableLDM_inline",
                   "Enables LDM. Can only be enabled if `isLDMSupported` is `true`. Please call `getLDMSupported` methods firstly.  Call this method before calling the other methods of SDK (including `registerApp`) to restrict the internet access  of SDK (SDK registration is unrestricted).  @param callback The execution callback.  @return The error occurred. NULL if LDM is enabled successfully.",
            ],
            [
                   "Enables LDM. Can only be enabled if `isLDMSupported` is `true`. Please call `getLDMSupported` methods firstly.  Call this method before calling the other methods of SDK (including `registerApp`) to restrict the internet access  of SDK (SDK registration is unrestricted).  @param callback The execution callback.  @return The error occurred. NULL if LDM is enabled successfully.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_enableLDM_inline",
                   "",
            ],
            [
                   "disableLDM",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_disableLDM_inline",
                   "Disables LDM.",
            ],
            [
                   "Disables LDM.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_disableLDM_inline",
                   "",
            ],
            [
                   "setModuleNetworkServiceEnabled",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_setModuleNetworkServiceEnabled_inline",
                   "In LDM mode, You can use this interface to enable network service of the selected module.  @param modules The array of the modules need to be enabled.",
            ],
            [
                   "In LDM mode, You can use this interface to enable network service of the selected module.  @param modules The array of the modules need to be enabled.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_setModuleNetworkServiceEnabled_inline",
                   "",
            ],
            [
                   "isModuleNetworkServiceEnabled",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isModuleNetworkServiceEnabled_inline",
                   "`true` if the network service of the module is enabled.  @param moduleType The type of module that needs to be checked.  @return `true` if the network service of the module is enabled.",
            ],
            [
                   "`true` if the network service of the module is enabled.  @param moduleType The type of module that needs to be checked.  @return `true` if the network service of the module is enabled.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_isModuleNetworkServiceEnabled_inline",
                   "",
            ],
            [
                   "setCallback",
                   2,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_setCallback_inline",
                   "Sets the LDM callback.  @param ldmCallback The execution callback with the returned value.",
            ],
            [
                   "Sets the LDM callback.  @param ldmCallback The execution callback with the returned value.",
                   1,
                   "/Components/LDMManager/DJILDMManager.html",
                   "#DJILDMManager_setCallback_inline",
                   "",
            ],
            [
                   "LDMModule",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "",
                   "Module definition.",
            ],
            [
                   "Module definition.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "",
                   "Default constructor of `LDMModule`.",
            ],
            [
                   "Default constructor of `LDMModule`.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_build_inline",
                   "Generate an object for `LDMModule`.  @return The object of `LDMModule`.",
            ],
            [
                   "Generate an object for `LDMModule`.  @return The object of `LDMModule`.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_build_inline",
                   "",
            ],
            [
                   "enabled",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_enabled_inline",
                   "`true` to enable the network service.  @param enabled `true` to enable the network service.  @return The build of `Builder`.",
            ],
            [
                   "`true` to enable the network service.  @param enabled `true` to enable the network service.  @return The build of `Builder`.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_enabled_inline",
                   "",
            ],
            [
                   "moduleType",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_moduleType_inline",
                   "The type of module. The module that you want to enable network service in LDM mode.  @param moduleType `LDMModuleType` object to set.  @return The build of `Builder`.",
            ],
            [
                   "The type of module. The module that you want to enable network service in LDM mode.  @param moduleType `LDMModuleType` object to set.  @return The build of `Builder`.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule_Builder.html",
                   "#DJILDMManager_LDMModule_Builder_moduleType_inline",
                   "",
            ],
            [
                   "isEnabled",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModule_enabled_inline",
                   "`true` if the network service is enabled.",
            ],
            [
                   "`true` if the network service is enabled.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModule_enabled_inline",
                   "",
            ],
            [
                   "getModuleType",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModule_moduleType_inline",
                   "The type of module. The module that you set to enable the network service.",
            ],
            [
                   "The type of module. The module that you set to enable the network service.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModule_moduleType_inline",
                   "",
            ],
            [
                   "LDMModuleType",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_inline",
                   "The type of module. The modules that support network service in LDM mode.",
            ],
            [
                   "The type of module. The modules that support network service in LDM mode.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_inline",
                   "",
            ],
            [
                   "RTK",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_RTK_inline",
                   "The module of RTK. In LDM mode, You can use this type to enable the network service for RTK, so that you can using the RTK function as normal.",
            ],
            [
                   "The module of RTK. In LDM mode, You can use this type to enable the network service for RTK, so that you can using the RTK function as normal.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_RTK_inline",
                   "",
            ],
            [
                   "USER_ACCOUNT",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_UserAccount_inline",
                   "The module of User Account. In LDM mode, You can use this type to enable the network service for User Account, so that you can using the Login function as normal. After login your DJI account, you can remove the height and distance limit in LDM mode.",
            ],
            [
                   "The module of User Account. In LDM mode, You can use this type to enable the network service for User Account, so that you can using the Login function as normal. After login your DJI account, you can remove the height and distance limit in LDM mode.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_UserAccount_inline",
                   "",
            ],
            [
                   "LIVE_STREAMING",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_LiveStreaming_inline",
                   "The module of Live Streaming. In LDM mode, You can use this type to enable the network service for live streaming, so that you can using the Live Streaming function as normal.",
            ],
            [
                   "The module of Live Streaming. In LDM mode, You can use this type to enable the network service for live streaming, so that you can using the Live Streaming function as normal.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_LiveStreaming_inline",
                   "",
            ],
            [
                   "FIRMWARE_UPGRADE",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_FirmwareUpgrade_inline",
                   "The module of FirmwareUpgrade. In LDM mode, You can use this type to enable the network service for FirmwareUpgrade, so that you can using the FirmwareUpgrade function as normal.",
            ],
            [
                   "The module of FirmwareUpgrade. In LDM mode, You can use this type to enable the network service for FirmwareUpgrade, so that you can using the FirmwareUpgrade function as normal.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMModule.html",
                   "#DJILDMManager_LDMModuleType_FirmwareUpgrade_inline",
                   "",
            ],
            [
                   "LDMCallback",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "",
                   "LDM callback interface, callback will always be invoked in background thread.",
            ],
            [
                   "LDM callback interface, callback will always be invoked in background thread.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onLDMEnabledChange",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "#DJILDMManager_onLDMEnabledChangeCallback_inline",
                   "Called when the LDM availability is changed.  @param isEnabled TRUE if LDM enabled.",
            ],
            [
                   "Called when the LDM availability is changed.  @param isEnabled TRUE if LDM enabled.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "#DJILDMManager_onLDMEnabledChangeCallback_inline",
                   "",
            ],
            [
                   "onLDMSupportedChange",
                   2,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "#DJILDMManager_onLDMSupportedChangeCallback_inline",
                   "If the value changes to false, LDM will be disable after 5 minutes  @param isSupported TRUE if LDM is supported.",
            ],
            [
                   "If the value changes to false, LDM will be disable after 5 minutes  @param isSupported TRUE if LDM is supported.",
                   1,
                   "/Components/LDMManager/DJILDMManager_LDMCallbackInterface.html",
                   "#DJILDMManager_onLDMSupportedChangeCallback_inline",
                   "",
            ],
            [
                   "getHandHeldController",
                   2,
                   "/Products/Handheld/DJIHandheld.html",
                   "#DJIHandheld_handheldController_inline",
                   "Returns an instance of the handheld device's handheld controller.  @return An instance of the `HandheldController`",
            ],
            [
                   "Returns an instance of the handheld device's handheld controller.  @return An instance of the `HandheldController`",
                   1,
                   "/Products/Handheld/DJIHandheld.html",
                   "#DJIHandheld_handheldController_inline",
                   "",
            ],
            [
                   "UNKNOWN_HANDHELD",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameUnknownHandheld_inline",
                   "Handheld device model name unknown.",
            ],
            [
                   "Handheld device model name unknown.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameUnknownHandheld_inline",
                   "",
            ],
            [
                   "OSMO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmo_inline",
                   "Handheld device model name Osmo.",
            ],
            [
                   "Handheld device model name Osmo.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmo_inline",
                   "",
            ],
            [
                   "OSMO_PRO",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoPro_inline",
                   "Handheld device model name Osmo Pro.",
            ],
            [
                   "Handheld device model name Osmo Pro.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoPro_inline",
                   "",
            ],
            [
                   "OSMO_RAW",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoRAW_inline",
                   "Handheld device model name Osmo RAW.",
            ],
            [
                   "Handheld device model name Osmo RAW.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoRAW_inline",
                   "",
            ],
            [
                   "OSMO_MOBILE",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoMobile_inline",
                   "Handheld device model name Osmo Mobile.",
            ],
            [
                   "Handheld device model name Osmo Mobile.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoMobile_inline",
                   "",
            ],
            [
                   "OSMO_PLUS",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoPlus_inline",
                   "Handheld device model name Osmo+.",
            ],
            [
                   "Handheld device model name Osmo+.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoPlus_inline",
                   "",
            ],
            [
                   "OSMO_MOBILE_2",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoMobile2_inline",
                   "Handheld device model name Osmo Mobile 2.",
            ],
            [
                   "Handheld device model name Osmo Mobile 2.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIHandheld_DJIHandheldModelNameOsmoMobile2_inline",
                   "",
            ],
            [
                   "setAreaCode",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_setAreaCode_inline",
                   "Set the area code of country or area. The following functions can not be used unless the corresponding area code is set. Currently the supported country or area list and the supported function list is as follows: - USA: remote identification broadcast of drone  @param areaCode Area code of country or area.  @return Return the setting execution result of area code.",
            ],
            [
                   "Set the area code of country or area. The following functions can not be used unless the corresponding area code is set. Currently the supported country or area list and the supported function list is as follows: - USA: remote identification broadcast of drone  @param areaCode Area code of country or area.  @return Return the setting execution result of area code.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_setAreaCode_inline",
                   "",
            ],
            [
                   "getUASRemoteIDStatus",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_getUASRemoteIDStatus_inline",
                   "Get the remote identification status of the drone system.  @return Return the remote identification status of the drone system.",
            ],
            [
                   "Get the remote identification status of the drone system.  @return Return the remote identification status of the drone system.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_getUASRemoteIDStatus_inline",
                   "",
            ],
            [
                   "addUASRemoteIDStatusListener",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_addUASRemoteIDStatusListener_inline",
                   "Add the remote identification status listener of the drone system.  @param listener The remote identification status listener of the drone system",
            ],
            [
                   "Add the remote identification status listener of the drone system.  @param listener The remote identification status listener of the drone system",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_addUASRemoteIDStatusListener_inline",
                   "",
            ],
            [
                   "removeUASRemoteIDStatusListener",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_removeUASRemoteIDStatusListener_inline",
                   "Remove the remote identification status listener of the drone system.  @param listener The remote identification status listener of the drone system",
            ],
            [
                   "Remove the remote identification status listener of the drone system.  @param listener The remote identification status listener of the drone system",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_removeUASRemoteIDStatusListener_inline",
                   "",
            ],
            [
                   "clearUASRemoteIDStatusListener",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_clearUASRemoteIDStatusListener_inline",
                   "Remove all the remote identification status listeners of the drone system.",
            ],
            [
                   "Remove all the remote identification status listeners of the drone system.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_clearUASRemoteIDStatusListener_inline",
                   "",
            ],
            [
                   "isBroadcastRemoteIdEnabled",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatus_isBroadcastRemoteIdEnabled_inline",
                   "Get whether the RID broadcast function of the drone is enabled.  @return Return whether the RID broadcast function of the drone is enabled.",
            ],
            [
                   "Get whether the RID broadcast function of the drone is enabled.  @return Return whether the RID broadcast function of the drone is enabled.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatus_isBroadcastRemoteIdEnabled_inline",
                   "",
            ],
            [
                   "getRemoteIdWorkingState",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatus_getRemoteIdWorkingState_inline",
                   "Get the working state of UAS remote identification(RID).  @return Return the working state of UAS remote identification(RID).",
            ],
            [
                   "Get the working state of UAS remote identification(RID).  @return Return the working state of UAS remote identification(RID).",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatus_getRemoteIdWorkingState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatusListener.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatusListener_onUpdate_inline",
                   "When the RID status of the drone changes, this method will be called back.  @param uasRemoteIDStatus The RID status of the drone.",
            ],
            [
                   "When the RID status of the drone changes, this method will be called back.  @param uasRemoteIDStatus The RID status of the drone.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatusListener.html",
                   "#IUASRemoteIDManager_UASRemoteIDStatusListener_onUpdate_inline",
                   "",
            ],
            [
                   "RemoteIdWorkingState",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_inline",
                   "The remote identification working status of the drone.",
            ],
            [
                   "The remote identification working status of the drone.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_inline",
                   "",
            ],
            [
                   "UASRemoteIDStatus",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "",
                   "The remote identification status of the drone.",
            ],
            [
                   "The remote identification status of the drone.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatus.html",
                   "",
                   "",
            ],
            [
                   "UASRemoteIDStatusListener",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatusListener.html",
                   "",
                   "The remote identification status listener of the drone.",
            ],
            [
                   "The remote identification status listener of the drone.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager_UASRemoteIDStatusListener.html",
                   "",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_IDLE_inline",
                   "Idle, initialization state.",
            ],
            [
                   "Idle, initialization state.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_IDLE_inline",
                   "",
            ],
            [
                   "WORKING",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_WORKING_inline",
                   "Working, it indicates that Remote ID is broadcasting.",
            ],
            [
                   "Working, it indicates that Remote ID is broadcasting.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_WORKING_inline",
                   "",
            ],
            [
                   "OPERATOR_LOCATION_LOST_ERROR",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_OPERATOR_LOCATION_LOST_ERROR_inline",
                   "Not working, because the operator's position is lost, resulting in the Remote ID not being broadcast.",
            ],
            [
                   "Not working, because the operator's position is lost, resulting in the Remote ID not being broadcast.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_OPERATOR_LOCATION_LOST_ERROR_inline",
                   "",
            ],
            [
                   "FIRMWARE_ERROR",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_FIRMWARE_ERROR_inline",
                   "Not working, because the firmware error, resulting in the Remote ID not being broadcast.",
            ],
            [
                   "Not working, because the firmware error, resulting in the Remote ID not being broadcast.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_FIRMWARE_ERROR_inline",
                   "",
            ],
            [
                   "UNKNOWN_ERROR",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_UNKNOWN_ERROR_inline",
                   "Not working, because the unknown error, resulting in the Remote ID not being broadcast.",
            ],
            [
                   "Not working, because the unknown error, resulting in the Remote ID not being broadcast.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IUASRemoteIDManager_RemoteIdWorkingState_UNKNOWN_ERROR_inline",
                   "",
            ],
            [
                   "AreaCode",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IAreaCodeManager_AreaCode_inline",
                   "Enums represent the aera code.",
            ],
            [
                   "Enums represent the aera code.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IAreaCodeManager_AreaCode_inline",
                   "",
            ],
            [
                   "US",
                   2,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IAreaCodeManager_AreaCode_US_inline",
                   "America.",
            ],
            [
                   "America.",
                   1,
                   "/Components/UASRemoteIDManager/IUASRemoteIDManager.html",
                   "#IAreaCodeManager_AreaCode_US_inline",
                   "",
            ],
            [
                   "setPowerModeCallback",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setDJIHandheldPowerModeListener_inline",
                   "Setup the callback that returns changed power mode state information.  @param callback The callback for the power mode state.",
            ],
            [
                   "Setup the callback that returns changed power mode state information.  @param callback The callback for the power mode state.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setDJIHandheldPowerModeListener_inline",
                   "",
            ],
            [
                   "POWER_MODE",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setDJIHandheldPowerModeListener_inline",
                   "SDK Key for setPowerModeCallback: Setup the callback that returns changed power mode state information.  @param callback The callback for the power mode state.",
            ],
            [
                   "SDK Key for setPowerModeCallback: Setup the callback that returns changed power mode state information.  @param callback The callback for the power mode state.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setDJIHandheldPowerModeListener_inline",
                   "",
            ],
            [
                   "setHardwareStateCallback",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setUpdateHardwareStateCallback_inline",
                   "Set up the callback for the handheld's hardware state.  @param callback Callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
            ],
            [
                   "Set up the callback for the handheld's hardware state.  @param callback Callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setUpdateHardwareStateCallback_inline",
                   "",
            ],
            [
                   "setPowerMode",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setHandheldPowerMode_inline",
                   "Set the power mode for the handheld controller.  @param mode The power mode to set. CAUTION! When the mode is `OFF`, the handheld product will be shut down and the connection will be broken. The user must then power on the device manually. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set the power mode for the handheld controller.  @param mode The power mode to set. CAUTION! When the mode is `OFF`, the handheld product will be shut down and the connection will be broken. The user must then power on the device manually. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setHandheldPowerMode_inline",
                   "",
            ],
            [
                   "POWER_MODE",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setHandheldPowerMode_inline",
                   "SDK Key for setPowerMode: Set the power mode for the handheld controller.  @param mode The power mode to set. CAUTION! When the mode is `OFF`, the handheld product will be shut down and the connection will be broken. The user must then power on the device manually. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setPowerMode: Set the power mode for the handheld controller.  @param mode The power mode to set. CAUTION! When the mode is `OFF`, the handheld product will be shut down and the connection will be broken. The user must then power on the device manually. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setHandheldPowerMode_inline",
                   "",
            ],
            [
                   "controlLEDWithCommand",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_controlLEDWithCommand_inline",
                   "Controls the LED of the handheld controller.  @param command The command to control the LED. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Controls the LED of the handheld controller.  @param command The command to control the LED. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_controlLEDWithCommand_inline",
                   "",
            ],
            [
                   "LED_COMMAND",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_controlLEDWithCommand_inline",
                   "SDK Key for controlLEDWithCommand: Controls the LED of the handheld controller.  @param command The command to control the LED. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for controlLEDWithCommand: Controls the LED of the handheld controller.  @param command The command to control the LED. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_controlLEDWithCommand_inline",
                   "",
            ],
            [
                   "setStickGimbalControlEnabled",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setStickGimbalControlEnabled_inline",
                   "Enables/disables the gimbal control with the joystick. By default, it is enabled. The handheld will be reset to the default value  when it reboots or SDK reinitializes. When gimbal control is disabled, the joystick can be used for other purposes in an SDK application by reading its position values with `StickVerticalDirection` and `StickHorizontalDirection`. Only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enables/disables the gimbal control with the joystick. By default, it is enabled. The handheld will be reset to the default value  when it reboots or SDK reinitializes. When gimbal control is disabled, the joystick can be used for other purposes in an SDK application by reading its position values with `StickVerticalDirection` and `StickHorizontalDirection`. Only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setStickGimbalControlEnabled_inline",
                   "",
            ],
            [
                   "STICK_GIMBAL_CONTROL_ENABLED",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setStickGimbalControlEnabled_inline",
                   "SDK Key for setStickGimbalControlEnabled: Enables/disables the gimbal control with the joystick. By default, it is enabled. The handheld will be reset to the default value  when it reboots or SDK reinitializes. When gimbal control is disabled, the joystick can be used for other purposes in an SDK application by reading its position values with `StickVerticalDirection` and `StickHorizontalDirection`. Only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setStickGimbalControlEnabled: Enables/disables the gimbal control with the joystick. By default, it is enabled. The handheld will be reset to the default value  when it reboots or SDK reinitializes. When gimbal control is disabled, the joystick can be used for other purposes in an SDK application by reading its position values with `StickVerticalDirection` and `StickHorizontalDirection`. Only supported in firmware version 1.2.0.40 or above.  @param enabled `true` to enable the gimbal control. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_setStickGimbalControlEnabled_inline",
                   "",
            ],
            [
                   "getStickGimbalControlEnabled",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_getStickGimbalControlEnabled_inline",
                   "`true` if gimbal control with the joystick is enabled. Only supported in firmware version 1.2.0.40 or above.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "`true` if gimbal control with the joystick is enabled. Only supported in firmware version 1.2.0.40 or above.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_getStickGimbalControlEnabled_inline",
                   "",
            ],
            [
                   "STICK_GIMBAL_CONTROL_ENABLED",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_getStickGimbalControlEnabled_inline",
                   "SDK Key for getStickGimbalControlEnabled: `true` if gimbal control with the joystick is enabled. Only supported in firmware version 1.2.0.40 or above.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getStickGimbalControlEnabled: `true` if gimbal control with the joystick is enabled. Only supported in firmware version 1.2.0.40 or above.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_getStickGimbalControlEnabled_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "#DJIHandheldController_updatePowerMode_inline",
                   "Called when the handheld controller's power mode has been updated.  @param powerMode Handheld controller's current power mode.",
            ],
            [
                   "Called when the handheld controller's power mode has been updated.  @param powerMode Handheld controller's current power mode.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "#DJIHandheldController_updatePowerMode_inline",
                   "",
            ],
            [
                   "POWER_MODE",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "#DJIHandheldController_updatePowerMode_inline",
                   "SDK Key for onUpdate: Called when the handheld controller's power mode has been updated.  @param powerMode Handheld controller's current power mode.",
            ],
            [
                   "SDK Key for onUpdate: Called when the handheld controller's power mode has been updated.  @param powerMode Handheld controller's current power mode.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "#DJIHandheldController_updatePowerMode_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIUpdateHardwareStateCallbackInterface.html",
                   "#DJIHandheldController_updateHardwareState_inline",
                   "Called when the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks) has been updated.  @param state An object of `HardwareState`.",
            ],
            [
                   "Called when the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks) has been updated.  @param state An object of `HardwareState`.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIUpdateHardwareStateCallbackInterface.html",
                   "#DJIHandheldController_updateHardwareState_inline",
                   "",
            ],
            [
                   "ON",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Awake_inline",
                   "The handheld product is awake. For Osmo, when it is in this mode, all the components in `HandHeld` are accessible.",
            ],
            [
                   "The handheld product is awake. For Osmo, when it is in this mode, all the components in `HandHeld` are accessible.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Awake_inline",
                   "",
            ],
            [
                   "SLEEPING",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Sleeping_inline",
                   "The handheld product is sleeping. The handheld controller keeps the wireless connection to the mobile device alive but most other components are off. The power consumption is low in this mode. For Osmo in this mode, only the `HandheldController`, `AirLink`, and `Battery` are accessible.",
            ],
            [
                   "The handheld product is sleeping. The handheld controller keeps the wireless connection to the mobile device alive but most other components are off. The power consumption is low in this mode. For Osmo in this mode, only the `HandheldController`, `AirLink`, and `Battery` are accessible.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Sleeping_inline",
                   "",
            ],
            [
                   "OFF",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_PowerOff_inline",
                   "The handheld product is powered off. Once this mode is set the callback will receive this mode until the handheld device is shut down completely. It is not supported by Osmo Mobile.",
            ],
            [
                   "The handheld product is powered off. Once this mode is set the callback will receive this mode until the handheld device is shut down completely. It is not supported by Osmo Mobile.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_PowerOff_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Unknown_inline",
                   "The Handheld Power Mode in unknown.",
            ],
            [
                   "The Handheld Power Mode in unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_Unknown_inline",
                   "",
            ],
            [
                   "getRecordAndShutterButtons",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_handheldButtonStatus_inline",
                   "Status of the shutter button and record button.  @return A `RecordAndShutterButtons` enum value.",
            ],
            [
                   "Status of the shutter button and record button.  @return A `RecordAndShutterButtons` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_handheldButtonStatus_inline",
                   "",
            ],
            [
                   "RECORD_AND_SHUTTER_BUTTONS",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_handheldButtonStatus_inline",
                   "SDK Key for getRecordAndShutterButtons: Status of the shutter button and record button.  @return A `RecordAndShutterButtons` enum value.",
            ],
            [
                   "SDK Key for getRecordAndShutterButtons: Status of the shutter button and record button.  @return A `RecordAndShutterButtons` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_handheldButtonStatus_inline",
                   "",
            ],
            [
                   "getTriggerButton",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_triggerState_inline",
                   "Status of the trigger button.  @return A `HandheldButtonClickEvent` enum value.",
            ],
            [
                   "Status of the trigger button.  @return A `HandheldButtonClickEvent` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_triggerState_inline",
                   "",
            ],
            [
                   "TRIGGER_BUTTON",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_triggerState_inline",
                   "SDK Key for getTriggerButton: Status of the trigger button.  @return A `HandheldButtonClickEvent` enum value.",
            ],
            [
                   "SDK Key for getTriggerButton: Status of the trigger button.  @return A `HandheldButtonClickEvent` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_triggerState_inline",
                   "",
            ],
            [
                   "getModeButton",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_modeButton_inline",
                   "Status of the mode button. It is only supported by Osmo Mobile 2.  @return A `HandheldButtonClickEvent` enum value.",
            ],
            [
                   "Status of the mode button. It is only supported by Osmo Mobile 2.  @return A `HandheldButtonClickEvent` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_modeButton_inline",
                   "",
            ],
            [
                   "isTriggerBeingPressed",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isTriggerBeingPressed_inline",
                   "`true` when the trigger is being pressed. It is only supported in firmware version 1.2.0.40 or above.  @return A boolean value.",
            ],
            [
                   "`true` when the trigger is being pressed. It is only supported in firmware version 1.2.0.40 or above.  @return A boolean value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isTriggerBeingPressed_inline",
                   "",
            ],
            [
                   "IS_TRIGGER_BEING_PRESSED",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isTriggerBeingPressed_inline",
                   "SDK Key for isTriggerBeingPressed: `true` when the trigger is being pressed. It is only supported in firmware version 1.2.0.40 or above.  @return A boolean value.",
            ],
            [
                   "SDK Key for isTriggerBeingPressed: `true` when the trigger is being pressed. It is only supported in firmware version 1.2.0.40 or above.  @return A boolean value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isTriggerBeingPressed_inline",
                   "",
            ],
            [
                   "isModeButtonBeingPressed",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isModeButtonBeingPressed_inline",
                   "`true` when the mode button is being pressed. It is only supported by OSMO Mobile 2.  @return A boolean value.",
            ],
            [
                   "`true` when the mode button is being pressed. It is only supported by OSMO Mobile 2.  @return A boolean value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_isModeButtonBeingPressed_inline",
                   "",
            ],
            [
                   "getStickVerticalDirection",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickVerticalDirection_inline",
                   "Status of the joystick in vertical direction.  @return A `StickVerticalDirection` enum value.",
            ],
            [
                   "Status of the joystick in vertical direction.  @return A `StickVerticalDirection` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickVerticalDirection_inline",
                   "",
            ],
            [
                   "STICK_VERTICAL_DIRECTION",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickVerticalDirection_inline",
                   "SDK Key for getStickVerticalDirection: Status of the joystick in vertical direction.  @return A `StickVerticalDirection` enum value.",
            ],
            [
                   "SDK Key for getStickVerticalDirection: Status of the joystick in vertical direction.  @return A `StickVerticalDirection` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickVerticalDirection_inline",
                   "",
            ],
            [
                   "getStickHorizontalDirection",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickHorizontalDirection_inline",
                   "Status of the joystick in horizontal direction.  @return A `StickHorizontalDirection` enum value.",
            ],
            [
                   "Status of the joystick in horizontal direction.  @return A `StickHorizontalDirection` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickHorizontalDirection_inline",
                   "",
            ],
            [
                   "STICK_HORIZONTAL_DIRECTION",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickHorizontalDirection_inline",
                   "SDK Key for getStickHorizontalDirection: Status of the joystick in horizontal direction.  @return A `StickHorizontalDirection` enum value.",
            ],
            [
                   "SDK Key for getStickHorizontalDirection: Status of the joystick in horizontal direction.  @return A `StickHorizontalDirection` enum value.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_joystickHorizontalDirection_inline",
                   "",
            ],
            [
                   "getStick",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_stickPosition_inline",
                   "Position of the stick in both vertical and horizontal direction. Only supported in firmware version 1.2.0.40 or above.  @return An object of `Stick`.",
            ],
            [
                   "Position of the stick in both vertical and horizontal direction. Only supported in firmware version 1.2.0.40 or above.  @return An object of `Stick`.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_stickPosition_inline",
                   "",
            ],
            [
                   "STICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_stickPosition_inline",
                   "SDK Key for getStick: Position of the stick in both vertical and horizontal direction. Only supported in firmware version 1.2.0.40 or above.  @return An object of `Stick`.",
            ],
            [
                   "SDK Key for getStick: Position of the stick in both vertical and horizontal direction. Only supported in firmware version 1.2.0.40 or above.  @return An object of `Stick`.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_stickPosition_inline",
                   "",
            ],
            [
                   "getZoomState",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_zoomSlider_inline",
                   "Status of the zoom slider. It is only supported by Osmo Mobile 2.  @return An enum value of `ZoomState`.",
            ],
            [
                   "Status of the zoom slider. It is only supported by Osmo Mobile 2.  @return An enum value of `ZoomState`.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandhelpControllerHardwareState_zoomSlider_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_Idle_inline",
                   "No buttons have been pressed.",
            ],
            [
                   "No buttons have been pressed.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_Idle_inline",
                   "",
            ],
            [
                   "SHUTTER_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ShutterButtonPressed_inline",
                   "Only the shutter button was pressed and released.",
            ],
            [
                   "Only the shutter button was pressed and released.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ShutterButtonPressed_inline",
                   "",
            ],
            [
                   "RECORD_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_RecordButtonPressed_inline",
                   "Only the record button was pressed and released.",
            ],
            [
                   "Only the record button was pressed and released.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_RecordButtonPressed_inline",
                   "",
            ],
            [
                   "SHUTTER_LONG_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ShutterButtonLongPress_inline",
                   "The shutter button is being pressed without release.",
            ],
            [
                   "The shutter button is being pressed without release.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ShutterButtonLongPress_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ModeUnknown_inline",
                   "The button status is unknown.",
            ],
            [
                   "The button status is unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_ModeUnknown_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_Idle_inline",
                   "Trigger button status is idle.",
            ],
            [
                   "Trigger button status is idle.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_Idle_inline",
                   "",
            ],
            [
                   "SINGLE_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_SingleClick_inline",
                   "Trigger button is pressed and released.",
            ],
            [
                   "Trigger button is pressed and released.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_SingleClick_inline",
                   "",
            ],
            [
                   "DOUBLE_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_DoubleClick_inline",
                   "Trigger button is pressed twice quickly.",
            ],
            [
                   "Trigger button is pressed twice quickly.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_DoubleClick_inline",
                   "",
            ],
            [
                   "TRIPLE_CLICK",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_TripleClick_inline",
                   "Trigger button is pressed three times quickly.",
            ],
            [
                   "Trigger button is pressed three times quickly.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_TripleClick_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_Unknown_inline",
                   "Trigger button status is unknown.",
            ],
            [
                   "Trigger button status is unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_Unknown_inline",
                   "",
            ],
            [
                   "CENTER",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Middle_inline",
                   "Joystick has no movement in the vertical direction.",
            ],
            [
                   "Joystick has no movement in the vertical direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Middle_inline",
                   "",
            ],
            [
                   "UP",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Up_inline",
                   "Joystick is moved up in the vertical direction.",
            ],
            [
                   "Joystick is moved up in the vertical direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Up_inline",
                   "",
            ],
            [
                   "DOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Down_inline",
                   "Joystick is moved down in the vertical direction.",
            ],
            [
                   "Joystick is moved down in the vertical direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Down_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Unknown_inline",
                   "Joystick status in the vertical direction is unknown.",
            ],
            [
                   "Joystick status in the vertical direction is unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_Unknown_inline",
                   "",
            ],
            [
                   "CENTER",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Middle_inline",
                   "Joystick has no movement in the horizontal direction.",
            ],
            [
                   "Joystick has no movement in the horizontal direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Middle_inline",
                   "",
            ],
            [
                   "LEFT",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Left_inline",
                   "Joystick is moved left in the horizontal direction.",
            ],
            [
                   "Joystick is moved left in the horizontal direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Left_inline",
                   "",
            ],
            [
                   "RIGHT",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Right_inline",
                   "Joystick is moved right in the horizontal direction.",
            ],
            [
                   "Joystick is moved right in the horizontal direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Right_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Unknown_inline",
                   "Joystick status in the horizontal direction is unknown.",
            ],
            [
                   "Joystick status in the horizontal direction is unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_Unknown_inline",
                   "",
            ],
            [
                   "ONE_AXIS",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_OneAxis_inline",
                   "Gimbal movement will be exclusively in yaw or pitch depending on whether the controller horizontal or vertical deflection is greater respectively.",
            ],
            [
                   "Gimbal movement will be exclusively in yaw or pitch depending on whether the controller horizontal or vertical deflection is greater respectively.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_OneAxis_inline",
                   "",
            ],
            [
                   "TWO_AXIS",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_TwoAxis_inline",
                   "Gimbal movement will be in both yaw and pitch simultaneously relative to the horizontal and vertical deflection of the controller respectively.",
            ],
            [
                   "Gimbal movement will be in both yaw and pitch simultaneously relative to the horizontal and vertical deflection of the controller respectively.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_TwoAxis_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_Unknown_inline",
                   "The gimbal controller control mode is unknown.",
            ],
            [
                   "The gimbal controller control mode is unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_Unknown_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_Idle_inline",
                   "Zoom slider is idle.",
            ],
            [
                   "Zoom slider is idle.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_Idle_inline",
                   "",
            ],
            [
                   "ZOOM_IN",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_ZoomIn_inline",
                   "The slider is pushed up and the camera should zoom in.",
            ],
            [
                   "The slider is pushed up and the camera should zoom in.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_ZoomIn_inline",
                   "",
            ],
            [
                   "ZOOM_OUT",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_ZoomOut_inline",
                   "The slider is pushed down and the camera should zoom out.",
            ],
            [
                   "The slider is pushed down and the camera should zoom out.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_ZoomOut_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_Unknown_inline",
                   "",
            ],
            [
                   "red",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_red_inline",
                   "Pattern to control the red color.",
            ],
            [
                   "Pattern to control the red color.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_red_inline",
                   "",
            ],
            [
                   "green",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_green_inline",
                   "Pattern to control the green color.",
            ],
            [
                   "Pattern to control the green color.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_green_inline",
                   "",
            ],
            [
                   "blue",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_blue_inline",
                   "Pattern to control the blue color.",
            ],
            [
                   "Pattern to control the blue color.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_blue_inline",
                   "",
            ],
            [
                   "pattern",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern_pattern_inline",
                   "Pattern to control the time varying behaviour of the LED color. Each element of pattern</code> is a boolean  representing the LED on/off state for 0.125 seconds where `true` means the LED is on. The length of the pattern cannot exceed 32. By default, the array is empty, which will turn the LED color off.",
            ],
            [
                   "Pattern to control the time varying behaviour of the LED color. Each element of pattern</code> is a boolean  representing the LED on/off state for 0.125 seconds where `true` means the LED is on. The length of the pattern cannot exceed 32. By default, the array is empty, which will turn the LED color off.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern_pattern_inline",
                   "",
            ],
            [
                   "repeatTimes",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern_repeatTimes_inline",
                   "The number of times to repeat the sequence with range [1, 255]. A value of 255 will repeat the sequence indefinitely until a new  command is sent. The default value is 255.",
            ],
            [
                   "The number of times to repeat the sequence with range [1, 255]. A value of 255 will repeat the sequence indefinitely until a new  command is sent. The default value is 255.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "#DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern_repeatTimes_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "",
                   "Callback to receive the updated power mode of the handheld controller.",
            ],
            [
                   "Callback to receive the updated power mode of the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldPowerModeListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIUpdateHardwareStateCallbackInterface.html",
                   "",
                   "Callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
            ],
            [
                   "Callback for the handheld controller's current hardware state (e.g. the state of the physical buttons and joysticks).",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIUpdateHardwareStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "PowerMode",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_inline",
                   "Handheld Power Mode.",
            ],
            [
                   "Handheld Power Mode.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_inline",
                   "",
            ],
            [
                   "POWER_MODE",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_inline",
                   "SDK Key for PowerMode: Handheld Power Mode.",
            ],
            [
                   "SDK Key for PowerMode: Handheld Power Mode.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldPowerMode_inline",
                   "",
            ],
            [
                   "HardwareState",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "",
                   "The status of the shutter button and record button on the handheld controller. Used by Osmo Mobile only.",
            ],
            [
                   "The status of the shutter button and record button on the handheld controller. Used by Osmo Mobile only.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "",
                   "",
            ],
            [
                   "RecordAndShutterButtons",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_inline",
                   "The status of the shutter button and record button on the handheld controller.",
            ],
            [
                   "The status of the shutter button and record button on the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_inline",
                   "",
            ],
            [
                   "RECORD_AND_SHUTTER_BUTTONS",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_inline",
                   "SDK Key for RecordAndShutterButtons: The status of the shutter button and record button on the handheld controller.",
            ],
            [
                   "SDK Key for RecordAndShutterButtons: The status of the shutter button and record button on the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldButtonStatus_inline",
                   "",
            ],
            [
                   "HandheldButtonClickEvent",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "The status of the shutter button and record button on the handheld controller.",
            ],
            [
                   "The status of the shutter button and record button on the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "",
            ],
            [
                   "TRIGGER_BUTTON",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "SDK Key for HandheldButtonClickEvent: The status of the shutter button and record button on the handheld controller.",
            ],
            [
                   "SDK Key for HandheldButtonClickEvent: The status of the shutter button and record button on the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "",
            ],
            [
                   "MODE_BUTTON",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "SDK Key for HandheldButtonClickEvent: The status of the shutter button and record button on the handheld controller.",
            ],
            [
                   "SDK Key for HandheldButtonClickEvent: The status of the shutter button and record button on the handheld controller.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldTriggerStatus_inline",
                   "",
            ],
            [
                   "StickVerticalDirection",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_inline",
                   "Status of the handheld joystick in vertical direction.",
            ],
            [
                   "Status of the handheld joystick in vertical direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_inline",
                   "",
            ],
            [
                   "STICK_VERTICAL_DIRECTION",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_inline",
                   "SDK Key for StickVerticalDirection: Status of the handheld joystick in vertical direction.",
            ],
            [
                   "SDK Key for StickVerticalDirection: Status of the handheld joystick in vertical direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickVerticalDirection_inline",
                   "",
            ],
            [
                   "StickHorizontalDirection",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_inline",
                   "Status of the handheld joystick in horizontal direction.",
            ],
            [
                   "Status of the handheld joystick in horizontal direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_inline",
                   "",
            ],
            [
                   "STICK_HORIZONTAL_DIRECTION",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_inline",
                   "SDK Key for StickHorizontalDirection: Status of the handheld joystick in horizontal direction.",
            ],
            [
                   "SDK Key for StickHorizontalDirection: Status of the handheld joystick in horizontal direction.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerHardwareState.html",
                   "#DJIHandheldController_DJIHandheldControllerHardwareState_DJIHandheldJoystickHorizontalDirection_inline",
                   "",
            ],
            [
                   "ControllerMode",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_inline",
                   "The control mode for the gimbal physical controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
            ],
            [
                   "The control mode for the gimbal physical controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_inline",
                   "",
            ],
            [
                   "CONTROLLER_MODE",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_inline",
                   "SDK Key for ControllerMode: The control mode for the gimbal physical controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
            ],
            [
                   "SDK Key for ControllerMode: The control mode for the gimbal physical controller (joystick for Osmo). The total controller deflection is a combination of horizontal and vertical deflection. This translates to gimbal movement around the yaw and pitch axes. The gimbal can be set to either move in both yaw and pitch simultaneously based on horizontal and vertical deflection of the controller, or move in only yaw or pitch exclusively based on whether horizontal or vertical deflection is larger.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldControllerStickControlMode_inline",
                   "",
            ],
            [
                   "ZoomState",
                   2,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_inline",
                   "The state of the zoom slider on the handheld controller. Used by Osmo Mobile 2 only.",
            ],
            [
                   "The state of the zoom slider on the handheld controller. Used by Osmo Mobile 2 only.",
                   1,
                   "/Components/HandheldController/DJIHandheldController.html",
                   "#DJIHandheldController_DJIHandheldZoomSlider_inline",
                   "",
            ],
            [
                   "LEDCommand",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "",
                   "Command used to control different colors (red, green and blue) of the handheld controller's LED.",
            ],
            [
                   "Command used to control different colors (red, green and blue) of the handheld controller's LED.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "",
                   "",
            ],
            [
                   "LED_COMMAND",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "",
                   "SDK Key for LEDCommand: Command used to control different colors (red, green and blue) of the handheld controller's LED.",
            ],
            [
                   "SDK Key for LEDCommand: Command used to control different colors (red, green and blue) of the handheld controller's LED.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand.html",
                   "",
                   "",
            ],
            [
                   "LEDColorPattern",
                   2,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "",
                   "Pattern used to control a single color (red, green or blue) of the handheld controller's LED.",
            ],
            [
                   "Pattern used to control a single color (red, green or blue) of the handheld controller's LED.",
                   1,
                   "/Components/HandheldController/DJIHandheldController_DJIHandheldControllerLEDCommand_DJIHandheldControllerLEDColorPattern.html",
                   "",
                   "",
            ],
            [
                   "isSupported",
                   2,
                   "/Components/ParamCapability/DJIParamCapability.html",
                   "#DJIParamCapability_isSupported_inline",
                   "`true` if the component or product supports the parameter.  @return A boolean value.",
            ],
            [
                   "`true` if the component or product supports the parameter.  @return A boolean value.",
                   1,
                   "/Components/ParamCapability/DJIParamCapability.html",
                   "#DJIParamCapability_isSupported_inline",
                   "",
            ],
            [
                   "DJIParamMinMaxCapability",
                   2,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "",
                   "Adds the maximum and minimum possible values of the parameter to  the `DJIParamCapability` base class.",
            ],
            [
                   "Adds the maximum and minimum possible values of the parameter to  the `DJIParamCapability` base class.",
                   1,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "",
                   "",
            ],
            [
                   "getMin",
                   2,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "#DJIParamCapability_DJIParamCapabilityMinMax_min_inline",
                   "Return the valid minimum value of the  parameter for the product. If `isSupported`  returns `false`, the value is undefined.  @return A Number object.",
            ],
            [
                   "Return the valid minimum value of the  parameter for the product. If `isSupported`  returns `false`, the value is undefined.  @return A Number object.",
                   1,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "#DJIParamCapability_DJIParamCapabilityMinMax_min_inline",
                   "",
            ],
            [
                   "getMax",
                   2,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "#DJIParamCapability_DJIParamCapabilityMinMax_max_inline",
                   "Return the valid maximum value of the  parameter for the product. If `isSupported`  returns `false`, the value is undefined.  @return A Number object.",
            ],
            [
                   "Return the valid maximum value of the  parameter for the product. If `isSupported`  returns `false`, the value is undefined.  @return A Number object.",
                   1,
                   "/Components/ParamCapability/DJIParamCapability_DJIParamCapabilityMinMax.html",
                   "#DJIParamCapability_DJIParamCapabilityMinMax_max_inline",
                   "",
            ],
            [
                   "setDiagnosticsInformationCallback",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_setUpdateDiagnosticsListCallback_inline",
                   "Sets up the diagnostics list update callback.  @param callback The callback of `DiagnosticsInformationCallback`.",
            ],
            [
                   "Sets up the diagnostics list update callback.  @param callback The callback of `DiagnosticsInformationCallback`.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_setUpdateDiagnosticsListCallback_inline",
                   "",
            ],
            [
                   "getFirmwarePackageVersion",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getFirmwarePackageVersion_inline",
                   "Gets the product's firmware package version. Products other than Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2, require internet connection. The execution time for this method depends on the speed of internet connectivity.  @return The product's firmware package version string.",
            ],
            [
                   "Gets the product's firmware package version. Products other than Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2, require internet connection. The execution time for this method depends on the speed of internet connectivity.  @return The product's firmware package version string.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getFirmwarePackageVersion_inline",
                   "",
            ],
            [
                   "FIRMWARE_PACKAGE_VERSION",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getFirmwarePackageVersion_inline",
                   "SDK Key for getFirmwarePackageVersion: Gets the product's firmware package version. Products other than Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2, require internet connection. The execution time for this method depends on the speed of internet connectivity.  @return The product's firmware package version string.",
            ],
            [
                   "SDK Key for getFirmwarePackageVersion: Gets the product's firmware package version. Products other than Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2, require internet connection. The execution time for this method depends on the speed of internet connectivity.  @return The product's firmware package version string.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getFirmwarePackageVersion_inline",
                   "",
            ],
            [
                   "setName",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_setName_inline",
                   "Retrieves the model of the product.  @param name Name to be set to the aircraft. @param callback Asynchronous execution result.",
            ],
            [
                   "Retrieves the model of the product.  @param name Name to be set to the aircraft. @param callback Asynchronous execution result.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_setName_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getName_inline",
                   "Retrieves the model of the product.  @param callback The execution callback with the returned value.",
            ],
            [
                   "Retrieves the model of the product.  @param callback The execution callback with the returned value.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getName_inline",
                   "",
            ],
            [
                   "getModel",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_model_inline",
                   "Retrieves the model of the product. See `Aircraft` and `HandHeld` for the possible strings that can be returned.  @return The model of the product.",
            ],
            [
                   "Retrieves the model of the product. See `Aircraft` and `HandHeld` for the possible strings that can be returned.  @return The model of the product.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_model_inline",
                   "",
            ],
            [
                   "MODEL_NAME",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_model_inline",
                   "SDK Key for getModel: Retrieves the model of the product. See `Aircraft` and `HandHeld` for the possible strings that can be returned.  @return The model of the product.",
            ],
            [
                   "SDK Key for getModel: Retrieves the model of the product. See `Aircraft` and `HandHeld` for the possible strings that can be returned.  @return The model of the product.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_model_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_connected_inline",
                   "`true` if the device is connected.  @return `true` if the device is connected.",
            ],
            [
                   "`true` if the device is connected.  @return `true` if the device is connected.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_connected_inline",
                   "",
            ],
            [
                   "ProductKey.CONNECTION",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_connected_inline",
                   "SDK Key for isConnected: `true` if the device is connected.  @return `true` if the device is connected.",
            ],
            [
                   "SDK Key for isConnected: `true` if the device is connected.  @return `true` if the device is connected.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_connected_inline",
                   "",
            ],
            [
                   "getCamera",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getCamera_inline",
                   "Retrieves an instance of the device's camera. Only supported by the product with single gimbal, except Zenmuse XT2 and Mavic 2 Enterprise Camera.  @return An instance of the aircraft's camera.",
            ],
            [
                   "Retrieves an instance of the device's camera. Only supported by the product with single gimbal, except Zenmuse XT2 and Mavic 2 Enterprise Camera.  @return An instance of the aircraft's camera.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getCamera_inline",
                   "",
            ],
            [
                   "getBattery",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getBattery_inline",
                   "Retrieves an instance of the product's smart battery. When using products with multiple batteries, such as the M600 or Inspire 2, use `getBatteries`, as this method will only return a single battery.  @return An instance of the aircraft's smart battery.",
            ],
            [
                   "Retrieves an instance of the product's smart battery. When using products with multiple batteries, such as the M600 or Inspire 2, use `getBatteries`, as this method will only return a single battery.  @return An instance of the aircraft's smart battery.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getBattery_inline",
                   "",
            ],
            [
                   "getBatteries",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getBatteries_inline",
                   "Returns an array of aircraft's batteries. It is used when the aircraft has multiple batteries, e.g. Matrice 600.  @return A List of `Battery` objects.",
            ],
            [
                   "Returns an array of aircraft's batteries. It is used when the aircraft has multiple batteries, e.g. Matrice 600.  @return A List of `Battery` objects.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getBatteries_inline",
                   "",
            ],
            [
                   "getGimbal",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getGimbal_inline",
                   "Retrieves an instance of the device's gimbal.  @return An instance of the aircraft's gimbal.",
            ],
            [
                   "Retrieves an instance of the device's gimbal.  @return An instance of the aircraft's gimbal.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getGimbal_inline",
                   "",
            ],
            [
                   "getAirLink",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getAirLink_inline",
                   "Retrieves an instance of the device's AirLink.  @return An instance of the aircraft's AirLink.",
            ],
            [
                   "Retrieves an instance of the device's AirLink.  @return An instance of the aircraft's AirLink.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getAirLink_inline",
                   "",
            ],
            [
                   "getAccessoryAggregation",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getAccessoryAggregation_inline",
                   "Retrieves an instance of the accessory aggregation.  @return 'NULL' if the product does not support accessories (e.g. spotlight, speaker or beacon).",
            ],
            [
                   "Retrieves an instance of the accessory aggregation.  @return 'NULL' if the product does not support accessories (e.g. spotlight, speaker or beacon).",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_getAccessoryAggregation_inline",
                   "",
            ],
            [
                   "ComponentKey",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_inline",
                   "Specifies all the components.",
            ],
            [
                   "Specifies all the components.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_inline",
                   "",
            ],
            [
                   "CAMERA",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_camera_inline",
                   "Camera component.",
            ],
            [
                   "Camera component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_camera_inline",
                   "",
            ],
            [
                   "GIMBAL",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_gimbal_inline",
                   "Gimbal component.",
            ],
            [
                   "Gimbal component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_gimbal_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_remoteController_inline",
                   "Remote Controller component.",
            ],
            [
                   "Remote Controller component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_remoteController_inline",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_flightController_inline",
                   "Flight Controller component.",
            ],
            [
                   "Flight Controller component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_flightController_inline",
                   "",
            ],
            [
                   "BATTERY",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_battery_inline",
                   "Battery component.",
            ],
            [
                   "Battery component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_battery_inline",
                   "",
            ],
            [
                   "HAND_HELD_CONTROLLER",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_handheldController_inline",
                   "Handheld Controller component.",
            ],
            [
                   "Handheld Controller component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_handheldController_inline",
                   "",
            ],
            [
                   "AIR_LINK",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_airLink_inline",
                   "AirLink component.",
            ],
            [
                   "AirLink component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_airLink_inline",
                   "",
            ],
            [
                   "MOBILE_REMOTE_CONTROLLER",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_mobileRemoteController_inline",
                   "Mobile remote controller component.",
            ],
            [
                   "Mobile remote controller component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_mobileRemoteController_inline",
                   "",
            ],
            [
                   "ACCESSORY_AGGREGATION",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_AccessoryAggregation_inline",
                   "Accessory aggregation component.",
            ],
            [
                   "Accessory aggregation component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_AccessoryAggregation_inline",
                   "",
            ],
            [
                   "BASE_STATION",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_BaseStation_inline",
                   "The RTK base station component.",
            ],
            [
                   "The RTK base station component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_BaseStation_inline",
                   "",
            ],
            [
                   "RADAR",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_Radar_inline",
                   "The Radar component.",
            ],
            [
                   "The Radar component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_Radar_inline",
                   "",
            ],
            [
                   "LIDAR",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_Lidar_inline",
                   "The Lidar component.",
            ],
            [
                   "The Lidar component.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIBaseProduct_componentKey_Lidar_inline",
                   "",
            ],
            [
                   "Model",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIModelNameString_inline",
                   "Class containing all product strings.",
            ],
            [
                   "Class containing all product strings.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIModelNameString_inline",
                   "",
            ],
            [
                   "MODEL_NAME",
                   2,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIModelNameString_inline",
                   "SDK Key for Model: Class containing all product strings.",
            ],
            [
                   "SDK Key for Model: Class containing all product strings.",
                   1,
                   "/BaseClasses/DJIBaseProduct.html",
                   "#DJIModelNameString_inline",
                   "",
            ],
            [
                   "VideoFeeder",
                   2,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "",
                   "Class that manages live video feed from DJI products to the mobile device.",
            ],
            [
                   "Class that manages live video feed from DJI products to the mobile device.",
                   1,
                   "/BaseClasses/DJIVideoFeeder.html",
                   "",
                   "",
            ],
            [
                   "getPipelines",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_pipelines_inline",
                   "The pipelines to transmit data between DJI Payload device and DJI mobile SDK. This function does not support dual controllers scenarios.  It's only supported by Matrice 300 RTK.  @return The DJIPipelines</code> objects.",
            ],
            [
                   "The pipelines to transmit data between DJI Payload device and DJI mobile SDK. This function does not support dual controllers scenarios.  It's only supported by Matrice 300 RTK.  @return The DJIPipelines</code> objects.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_pipelines_inline",
                   "",
            ],
            [
                   "getUpstreamBandwidth",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getUpstreamBandwidth_inline",
                   "Gets the bandwidth of the upstream (from Mobile SDK to Payload). The unit is bytes/s.  The bandwidth is determined by the firmware and currently it is not larger than 500 bytes/s.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the bandwidth of the upstream (from Mobile SDK to Payload). The unit is bytes/s.  The bandwidth is determined by the firmware and currently it is not larger than 500 bytes/s.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getUpstreamBandwidth_inline",
                   "",
            ],
            [
                   "getPayloadProductName",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getPayloadProductName_inline",
                   "Gets the product name defined by the manufacturer of the payload device.  @return The product name of the payload device.",
            ],
            [
                   "Gets the product name defined by the manufacturer of the payload device.  @return The product name of the payload device.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getPayloadProductName_inline",
                   "",
            ],
            [
                   "isDJIVideoStreamingChannelAvailable",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_isDJIVideoStreamingChannelAvailable_inline",
                   "When it returns `true`, video stream type on PSDK is set to DJI video streaming channel. Please use `VideoDataListener` in `DJIVideoFeeder` to receive the video data. When it returns `false`, video stream type on PSDK is set to custom video streaming channel.  Please use `onVideoDataReceived` to receive custom video data.  @return `true` if DJI video streaming channel is available.",
            ],
            [
                   "When it returns `true`, video stream type on PSDK is set to DJI video streaming channel. Please use `VideoDataListener` in `DJIVideoFeeder` to receive the video data. When it returns `false`, video stream type on PSDK is set to custom video streaming channel.  Please use `onVideoDataReceived` to receive custom video data.  @return `true` if DJI video streaming channel is available.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_isDJIVideoStreamingChannelAvailable_inline",
                   "",
            ],
            [
                   "configureWidgetValue",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_configureWidgetValue_inline",
                   "Set the value for a widget of the payload device.  @param index Index of the widget. @param type Type of the widget. @param value Value of the widget. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Set the value for a widget of the payload device.  @param index Index of the widget. @param type Type of the widget. @param value Value of the widget. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_configureWidgetValue_inline",
                   "",
            ],
            [
                   "getWidget",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getWidget_inline",
                   "Gets a widget by specifying the widget type and the index.  @param widgetIndex The index of the widget. @param widgetType The type of the widget.  @return The widget corresponding to the widget type and the index. `null` if the widgets are not ready or there is no widget corresponding  to the widget type and the index.",
            ],
            [
                   "Gets a widget by specifying the widget type and the index.  @param widgetIndex The index of the widget. @param widgetType The type of the widget.  @return The widget corresponding to the widget type and the index. `null` if the widgets are not ready or there is no widget corresponding  to the widget type and the index.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getWidget_inline",
                   "",
            ],
            [
                   "getWidgets",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getWidgets_inline",
                   "Gets the full list of widgets on the payload device. A new instance of NSArray is returned when one of the widget is updated. Please use `getConfigInterfaceWidgets` instead.  @return The full list of widgets. `null` if the widgets are not fetched yet.",
            ],
            [
                   "Gets the full list of widgets on the payload device. A new instance of NSArray is returned when one of the widget is updated. Please use `getConfigInterfaceWidgets` instead.  @return The full list of widgets. `null` if the widgets are not fetched yet.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getWidgets_inline",
                   "",
            ],
            [
                   "getMainInterfaceWidgets",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getMainInterfaceWidgets_inline",
                   "Gets the main interface widget list on the payload device. An empty array will be returned if the payload's data is regarded as invalid.  @return A list of widgets. Returns nil if no widgets are fetched.",
            ],
            [
                   "Gets the main interface widget list on the payload device. An empty array will be returned if the payload's data is regarded as invalid.  @return A list of widgets. Returns nil if no widgets are fetched.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getMainInterfaceWidgets_inline",
                   "",
            ],
            [
                   "getConfigInterfaceWidgets",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getConfigInterfaceWidgets_inline",
                   "Gets the configuration interface widget list on the payload device. An empty array will be returned if the payload's data is regarded as invalid.  @return A list of widgets. Returns nil if no widgets are fetched.",
            ],
            [
                   "Gets the configuration interface widget list on the payload device. An empty array will be returned if the payload's data is regarded as invalid.  @return A list of widgets. Returns nil if no widgets are fetched.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getConfigInterfaceWidgets_inline",
                   "",
            ],
            [
                   "sendDataToPayload",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_sendDataToPayload_inline",
                   "Sends data to payload.  - The length of the data to send cannot exceed 32 bytes for Matrice 200 series.  - The length of the  data to send cannot exceed 128 bytes for Matrice 200 V2 series. The throughput cannot exceed the bandwidth returned by `getUpstreamBandwidth`.  @param data Data that will be sent to the payload device. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sends data to payload.  - The length of the data to send cannot exceed 32 bytes for Matrice 200 series.  - The length of the  data to send cannot exceed 128 bytes for Matrice 200 V2 series. The throughput cannot exceed the bandwidth returned by `getUpstreamBandwidth`.  @param data Data that will be sent to the payload device. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_sendDataToPayload_inline",
                   "",
            ],
            [
                   "getDeviceType",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getDeviceType_inline",
                   "Gets the device type.  @return Get an enum value of `PayloadDeviceType`.",
            ],
            [
                   "Gets the device type.  @return Get an enum value of `PayloadDeviceType`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getDeviceType_inline",
                   "",
            ],
            [
                   "isFeatureOpened",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_isFeatureOpened_inline",
                   "Gets the product feature open status. If the product's feature isn't fully opened, there are several  possibilities.  - Payload status is abnormal.  - PSDK is not bound.  - Encryption chip  exception.  - The aircraft doesn't support this Payload model.  @return `true` if the product is activated.",
            ],
            [
                   "Gets the product feature open status. If the product's feature isn't fully opened, there are several  possibilities.  - Payload status is abnormal.  - PSDK is not bound.  - Encryption chip  exception.  - The aircraft doesn't support this Payload model.  @return `true` if the product is activated.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_isFeatureOpened_inline",
                   "",
            ],
            [
                   "getProductPhase",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getProductPhase_inline",
                   "Gets current payload product phase.  @return Get the enum value of `PayloadProductPhase`.",
            ],
            [
                   "Gets current payload product phase.  @return Get the enum value of `PayloadProductPhase`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getProductPhase_inline",
                   "",
            ],
            [
                   "setMessageCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setMessageCallback_inline",
                   "Set the message callback, message is a string, the content of string is determined by firmware,  it could be changed dynamically.  @param callback The interface of `HintMessageCallback`.",
            ],
            [
                   "Set the message callback, message is a string, the content of string is determined by firmware,  it could be changed dynamically.  @param callback The interface of `HintMessageCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setMessageCallback_inline",
                   "",
            ],
            [
                   "setCommandDataCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setCommandDataCallback_inline",
                   "Set the command data callback, the command data typically sent by payload in UART/CAN channel, the max bandwidth  of this channel is 3KBytes/s on M200.  @param callback The interface of `CommandDataCallback`.",
            ],
            [
                   "Set the command data callback, the command data typically sent by payload in UART/CAN channel, the max bandwidth  of this channel is 3KBytes/s on M200.  @param callback The interface of `CommandDataCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setCommandDataCallback_inline",
                   "",
            ],
            [
                   "setVideoDataReceivedCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setVideoDataReceivedCallback_inline",
                   "Set the video data callback, the video data from the payload device. The data may be live view or playback.  Only supported by Matrice 300 RTK.  @param callback The interface of `VideoDataReceivedCallback`.",
            ],
            [
                   "Set the video data callback, the video data from the payload device. The data may be live view or playback.  Only supported by Matrice 300 RTK.  @param callback The interface of `VideoDataReceivedCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setVideoDataReceivedCallback_inline",
                   "",
            ],
            [
                   "setStreamDataCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setStreamDataCallback_inline",
                   "Set the UDP data callback, this callback is for receiving the Non-Video data in UDP channel, the max bandwidth of  this channel is 8Mbps in M200, 4Mbps in M210.  @param callback The interface of `StreamDataCallback`.",
            ],
            [
                   "Set the UDP data callback, this callback is for receiving the Non-Video data in UDP channel, the max bandwidth of  this channel is 8Mbps in M200, 4Mbps in M210.  @param callback The interface of `StreamDataCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setStreamDataCallback_inline",
                   "",
            ],
            [
                   "onGetCommandData",
                   2,
                   "/Components/Payload/DJIPayload_CommandDataCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveCommandData_inline",
                   "When the payload send some command bytes to the Mobile SDK, this method will be called.  @param data The received command data.",
            ],
            [
                   "When the payload send some command bytes to the Mobile SDK, this method will be called.  @param data The received command data.",
                   1,
                   "/Components/Payload/DJIPayload_CommandDataCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveCommandData_inline",
                   "",
            ],
            [
                   "onGetStreamData",
                   2,
                   "/Components/Payload/DJIPayload_StreamDataCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveStreamData_inline",
                   "When the payload send the bytes to the Mobile SDK by UDP channel, this method will be called,  note that if dealing of the data block the data feeder, the byte might lost.  @param data The received stream data. @param len Valid length of the data.",
            ],
            [
                   "When the payload send the bytes to the Mobile SDK by UDP channel, this method will be called,  note that if dealing of the data block the data feeder, the byte might lost.  @param data The received stream data. @param len Valid length of the data.",
                   1,
                   "/Components/Payload/DJIPayload_StreamDataCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveStreamData_inline",
                   "",
            ],
            [
                   "onVideoDataReceived",
                   2,
                   "/Components/Payload/DJIPayload_VideoDataReceivedCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveVideoData_inline",
                   "Receives the video data sent from the payload device. The data may be live view or playback.  Only supported by Matrice 300 RTK.  @param data The received stream data. @param len Valid length of the data.",
            ],
            [
                   "Receives the video data sent from the payload device. The data may be live view or playback.  Only supported by Matrice 300 RTK.  @param data The received stream data. @param len Valid length of the data.",
                   1,
                   "/Components/Payload/DJIPayload_VideoDataReceivedCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveVideoData_inline",
                   "",
            ],
            [
                   "onGetMessage",
                   2,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveMessage_inline",
                   "when the payload send some message string to the Mobile SDK, this method will be called.  @param str Hint message string.",
            ],
            [
                   "when the payload send some message string to the Mobile SDK, this method will be called.  @param str Hint message string.",
                   1,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didReceiveMessage_inline",
                   "",
            ],
            [
                   "setMainInterfaceWidgetsListener",
                   2,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateMainInterfaceWidgets_inline",
                   "Updates a set of payload shortcuts in main interface. if the pay load's data is invalid, an  empty array will be updated. It is only supported by DJI Skyport 2.0 and DJI X-Port.  @param listener The listener received the updated widget values.",
            ],
            [
                   "Updates a set of payload shortcuts in main interface. if the pay load's data is invalid, an  empty array will be updated. It is only supported by DJI Skyport 2.0 and DJI X-Port.  @param listener The listener received the updated widget values.",
                   1,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateMainInterfaceWidgets_inline",
                   "",
            ],
            [
                   "setConfigWidgetsListener",
                   2,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateConfigInterfaceWidgets_inline",
                   "Updates setting for payload widgets. If the pay load's data is invalid, an empty array will be updated.  @param listener The listener received the updated widget values.",
            ],
            [
                   "Updates setting for payload widgets. If the pay load's data is invalid, an empty array will be updated.  @param listener The listener received the updated widget values.",
                   1,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateConfigInterfaceWidgets_inline",
                   "",
            ],
            [
                   "onWidgetValueChanged",
                   2,
                   "/Components/Payload/DJIPayload_WidgetValueChangedCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateWidgets_inline",
                   "Called when the value of the widget is changed.  @param type The enum value of `PayloadWidgetType`. @param index The index of the widget. @param newValue An int value.",
            ],
            [
                   "Called when the value of the widget is changed.  @param type The enum value of `PayloadWidgetType`. @param index The index of the widget. @param newValue An int value.",
                   1,
                   "/Components/Payload/DJIPayload_WidgetValueChangedCallbackInterface.html",
                   "#DJIPayload_DJIPayloadDelegate_didUpdateWidgets_inline",
                   "",
            ],
            [
                   "addWidgetValueChangedCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_addWidgetValueChangedCallback_inline",
                   "Set a callback for the specific widget, if the value of the widget is changed, the callback will be called.  @param index The index of the widget. @param type An enum value of `PayloadWidgetType`. @param callback The interface of `WidgetValueChangedCallback`.",
            ],
            [
                   "Set a callback for the specific widget, if the value of the widget is changed, the callback will be called.  @param index The index of the widget. @param type An enum value of `PayloadWidgetType`. @param callback The interface of `WidgetValueChangedCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_addWidgetValueChangedCallback_inline",
                   "",
            ],
            [
                   "removeWidgetValueChangedCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_removeWidgetValueChangedCallbackWithIndexAndType_inline",
                   "Remove a callback for the widget.  @param index The index of the widget. @param type An enum value of `PayloadWidgetType`. @param callback The interface of `WidgetValueChangedCallback`.",
            ],
            [
                   "Remove a callback for the widget.  @param index The index of the widget. @param type An enum value of `PayloadWidgetType`. @param callback The interface of `WidgetValueChangedCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_removeWidgetValueChangedCallbackWithIndexAndType_inline",
                   "",
            ],
            [
                   "removeWidgetValueChangedCallback",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_removeWidgetValueChangedCallback_inline",
                   "Remove a callback for the widget.  @param callback The interface of `WidgetValueChangedCallback`.",
            ],
            [
                   "Remove a callback for the widget.  @param callback The interface of `WidgetValueChangedCallback`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_removeWidgetValueChangedCallback_inline",
                   "",
            ],
            [
                   "PayloadWidget",
                   2,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "",
                   "Class to represent the properties of a payload widget. Payload SDK defines different types of widgets for the interaction between the payload device  and the mobile device.",
            ],
            [
                   "Class to represent the properties of a payload widget. Payload SDK defines different types of widgets for the interaction between the payload device  and the mobile device.",
                   1,
                   "/Components/Payload/DJIPayload_PayloadWidget.html",
                   "",
                   "",
            ],
            [
                   "HintMessageCallback",
                   2,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "",
                   "This interface provides a callback to get messages sent from payload to the Mobile SDK.",
            ],
            [
                   "This interface provides a callback to get messages sent from payload to the Mobile SDK.",
                   1,
                   "/Components/Payload/DJIPayload_HintMessageCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "CommandDataCallback",
                   2,
                   "/Components/Payload/DJIPayload_CommandDataCallbackInterface.html",
                   "",
                   "This interface provides a callback to get command data sent from payload to the Mobile SDK.",
            ],
            [
                   "This interface provides a callback to get command data sent from payload to the Mobile SDK.",
                   1,
                   "/Components/Payload/DJIPayload_CommandDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "VideoDataReceivedCallback",
                   2,
                   "/Components/Payload/DJIPayload_VideoDataReceivedCallbackInterface.html",
                   "",
                   "This interface provides a callback to receive video data sent from the payload.",
            ],
            [
                   "This interface provides a callback to receive video data sent from the payload.",
                   1,
                   "/Components/Payload/DJIPayload_VideoDataReceivedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "StreamDataCallback",
                   2,
                   "/Components/Payload/DJIPayload_StreamDataCallbackInterface.html",
                   "",
                   "This interface provides a callback to get stream data sent from payload to the Mobile SDK.",
            ],
            [
                   "This interface provides a callback to get stream data sent from payload to the Mobile SDK.",
                   1,
                   "/Components/Payload/DJIPayload_StreamDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "WidgetValueChangedCallback",
                   2,
                   "/Components/Payload/DJIPayload_WidgetValueChangedCallbackInterface.html",
                   "",
                   "This interface provides a callback to get value of the widget when changed.",
            ],
            [
                   "This interface provides a callback to get value of the widget when changed.",
                   1,
                   "/Components/Payload/DJIPayload_WidgetValueChangedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "fetchPayloadWidgetsFile",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_fetchWidgetConfiguration_inline",
                   "Fetches widget configuration. Mobile SDK will fetch the configuration when it first launches.  Returns nil if initial fetching failed. It is only supported by DJI SKYPORT 2.0.  @param listener The listener of `PayloadWidgetDownloadListener`.",
            ],
            [
                   "Fetches widget configuration. Mobile SDK will fetch the configuration when it first launches.  Returns nil if initial fetching failed. It is only supported by DJI SKYPORT 2.0.  @param listener The listener of `PayloadWidgetDownloadListener`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_fetchWidgetConfiguration_inline",
                   "",
            ],
            [
                   "setPayloadChannelPriority",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setPayloadChannelPriority_inline",
                   "Set the channel priority of the payload. Priority will affect the bandwidth allocation if it is not `UNKNOWN`,  which is the default value. For example, if the data that comes from the payload device mounted on left gimbal is preferred, please set the priority  to `HIGH`, and physicalSource is `LEFT_CAM`.  The others should be set to `MEDIUM` or `LOW`.  Only supported by Matrice 300 RTK.  @param priority The priority to be set, see `VideoFeedPriority`. @param physicalSource See `PhysicalSource`. @param callback Callback to receive the execution result.",
            ],
            [
                   "Set the channel priority of the payload. Priority will affect the bandwidth allocation if it is not `UNKNOWN`,  which is the default value. For example, if the data that comes from the payload device mounted on left gimbal is preferred, please set the priority  to `HIGH`, and physicalSource is `LEFT_CAM`.  The others should be set to `MEDIUM` or `LOW`.  Only supported by Matrice 300 RTK.  @param priority The priority to be set, see `VideoFeedPriority`. @param physicalSource See `PhysicalSource`. @param callback Callback to receive the execution result.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_setPayloadChannelPriority_inline",
                   "",
            ],
            [
                   "getPayloadChannelPriority",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getPayloadChannelPriorityOnPhysicalSource_inline",
                   "Get the channel priority of the payload. Only supported by Matrice 300 RTK.  @param physicalSource See `PhysicalSource`. @param callback Callback to receive the execution result.",
            ],
            [
                   "Get the channel priority of the payload. Only supported by Matrice 300 RTK.  @param physicalSource See `PhysicalSource`. @param callback Callback to receive the execution result.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_getPayloadChannelPriorityOnPhysicalSource_inline",
                   "",
            ],
            [
                   "PayloadProductPhase",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_inline",
                   "Development phase has more settings than product phase, including control parameters auto-tuning,  coaxiality detection, balance detection, stiffness adjustment. Please note that this phase should be  used with DJI Assistant 2, which has bound with Payload SDK developer account. Product phase means  that the product is in the stage ready to sell. During this stage, development settings, i.e., control  parameters auto-tuning, coaxiality detection, balance detection, stiffness adjustment, should be hidden from user interface.",
            ],
            [
                   "Development phase has more settings than product phase, including control parameters auto-tuning,  coaxiality detection, balance detection, stiffness adjustment. Please note that this phase should be  used with DJI Assistant 2, which has bound with Payload SDK developer account. Product phase means  that the product is in the stage ready to sell. During this stage, development settings, i.e., control  parameters auto-tuning, coaxiality detection, balance detection, stiffness adjustment, should be hidden from user interface.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_inline",
                   "",
            ],
            [
                   "DEVELOPMENT",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Development_inline",
                   "The product is in the development phase.",
            ],
            [
                   "The product is in the development phase.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Development_inline",
                   "",
            ],
            [
                   "RELEASE",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Release_inline",
                   "The product is in the release phase.",
            ],
            [
                   "The product is in the release phase.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Release_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadProductPhase_Unknown_inline",
                   "",
            ],
            [
                   "PayloadDeviceType",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_inline",
                   "All the possible mode of `PayloadDeviceType`.",
            ],
            [
                   "All the possible mode of `PayloadDeviceType`.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_inline",
                   "",
            ],
            [
                   "DJI_SKYPORT_1",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_Skyport_1_inline",
                   "DJI Skyport 1.0.",
            ],
            [
                   "DJI Skyport 1.0.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_Skyport_1_inline",
                   "",
            ],
            [
                   "DJI_SKYPORT_2",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_Skyport_2_inline",
                   "DJI Skyport 2.0.",
            ],
            [
                   "DJI Skyport 2.0.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_Skyport_2_inline",
                   "",
            ],
            [
                   "DJI_X_PORT",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_X_Port_inline",
                   "DJI X-Port.",
            ],
            [
                   "DJI X-Port.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_DJI_X_Port_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Payload/DJIPayload.html",
                   "#DJIPayload_DJIPayloadDeviceType_Unknown_inline",
                   "",
            ],
            [
                   "ActivateInfo",
                   2,
                   "/Components/Payload/DJIPayload_ActivateInfo.html",
                   "",
                   "This class provides the activation information of the payload.",
            ],
            [
                   "This class provides the activation information of the payload.",
                   1,
                   "/Components/Payload/DJIPayload_ActivateInfo.html",
                   "",
                   "",
            ],
            [
                   "isActivated",
                   2,
                   "/Components/Payload/DJIPayload_ActivateInfo.html",
                   "#DJIPayload_ActivateInfo_isActivated_inline",
                   "`true` if the current payload is activated.  @return A boolean value to check if payload is activated.",
            ],
            [
                   "`true` if the current payload is activated.  @return A boolean value to check if payload is activated.",
                   1,
                   "/Components/Payload/DJIPayload_ActivateInfo.html",
                   "#DJIPayload_ActivateInfo_isActivated_inline",
                   "",
            ],
            [
                   "setUTMISSFlightDataUpdatedUploadStatusCallback",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_setUTMISSFlightDataUpdatedUploadStatusCallback_inline",
                   "Called when the UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status has been updated.  @param callback The callback of `Callback`.",
            ],
            [
                   "Called when the UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status has been updated.  @param callback The callback of `Callback`.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_setUTMISSFlightDataUpdatedUploadStatusCallback_inline",
                   "",
            ],
            [
                   "getUploadStatus",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_currentStatus_inline",
                   "The current UTMISS upload status.  @return An enum value of `UTMISSFlightDataUploadStatus`.",
            ],
            [
                   "The current UTMISS upload status.  @return An enum value of `UTMISSFlightDataUploadStatus`.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_currentStatus_inline",
                   "",
            ],
            [
                   "startToUpload",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_startToUpload_inline",
                   "Start UTMISS flight data upload.  @param param An object of `UTMISSParam`.  @return An object of `DJIError`.",
            ],
            [
                   "Start UTMISS flight data upload.  @param param An object of `UTMISSParam`.  @return An object of `DJIError`.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_startToUpload_inline",
                   "",
            ],
            [
                   "isStarted",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_isStarted_inline",
                   "Start UTMISS flight data upload.  @return A boolean value to check if the data upload is started.",
            ],
            [
                   "Start UTMISS flight data upload.  @return A boolean value to check if the data upload is started.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_isStarted_inline",
                   "",
            ],
            [
                   "getUtmissLogPath",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_getUtmissLogPath_inline",
                   "UTMISS Log save path.  @return A String value.",
            ],
            [
                   "UTMISS Log save path.  @return A String value.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_getUtmissLogPath_inline",
                   "",
            ],
            [
                   "stopToUpload",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_stopToUpload_inline",
                   "Stop UTMISS flight data upload.",
            ],
            [
                   "Stop UTMISS flight data upload.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSManager_stopToUpload_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_UTMISSFlightDataUpdatedUploadStatusCallbackInterface.html",
                   "",
                   "This interface provides delegate methods to receive the UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status.",
            ],
            [
                   "This interface provides delegate methods to receive the UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_UTMISSFlightDataUpdatedUploadStatusCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_UTMISSFlightDataUpdatedUploadStatusCallbackInterface.html",
                   "#DJIUTMISSManager_didUpdateUTMISSFlightDataUploadStatus_inline",
                   "Callback to update UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status.  @param status An enum value of `UTMISSFlightDataUploadStatus`.",
            ],
            [
                   "Callback to update UTMISS (Unmanned Aircraft System Traffic Management Information Service System) flight data upload status.  @param status An enum value of `UTMISSFlightDataUploadStatus`.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_UTMISSFlightDataUpdatedUploadStatusCallbackInterface.html",
                   "#DJIUTMISSManager_didUpdateUTMISSFlightDataUploadStatus_inline",
                   "",
            ],
            [
                   "UTMISSParam",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "",
                   "This class provides necessary infomation to start UTMISS flight data uploading.",
            ],
            [
                   "This class provides necessary infomation to start UTMISS flight data uploading.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "",
                   "",
            ],
            [
                   "getDbPath",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_savePath_inline",
                   "Get the local save path of flight data to be uploaded.  @return The string value of the save path.",
            ],
            [
                   "Get the local save path of flight data to be uploaded.  @return The string value of the save path.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_savePath_inline",
                   "",
            ],
            [
                   "getTokenKey",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_tokenKey_inline",
                   "Get the token key applied from CAAC.  @return The string value of the token key.",
            ],
            [
                   "Get the token key applied from CAAC.  @return The string value of the token key.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_tokenKey_inline",
                   "",
            ],
            [
                   "getManufactureId",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_manufactureId_inline",
                   "Get the manufacture ID of the drone.  @return The string value of the manufacture Id.",
            ],
            [
                   "Get the manufacture ID of the drone.  @return The string value of the manufacture Id.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_manufactureId_inline",
                   "",
            ],
            [
                   "getUasId",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_uasID_inline",
                   "Get the UAS ID of the drone.  @return The string value of the uas Id.",
            ],
            [
                   "Get the UAS ID of the drone.  @return The string value of the uas Id.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager_DJIUTMISSParam.html",
                   "#DJIUTMISSManager_DJIUTMISSParam_uasID_inline",
                   "",
            ],
            [
                   "UTMISSFlightDataUploadStatus",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_inline",
                   "The UTMISS flight data upload status.",
            ],
            [
                   "The UTMISS flight data upload status.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Idle_inline",
                   "The UTMISS flight data upload status is idle.",
            ],
            [
                   "The UTMISS flight data upload status is idle.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Idle_inline",
                   "",
            ],
            [
                   "UPLOADING",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Uploading_inline",
                   "The UTMISS flight data upload status is uploading.",
            ],
            [
                   "The UTMISS flight data upload status is uploading.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Uploading_inline",
                   "",
            ],
            [
                   "CACHING",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Caching_inline",
                   "The UTMISS flight data upload status is caching.",
            ],
            [
                   "The UTMISS flight data upload status is caching.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Caching_inline",
                   "",
            ],
            [
                   "OUT_OF_DATA_STORAGE_SPACE",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_OutOfDataStorageSpace_inline",
                   "Out of data storage space. No more data can be written.",
            ],
            [
                   "Out of data storage space. No more data can be written.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_OutOfDataStorageSpace_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Unknown_inline",
                   "The UTMISS flight data upload status is unknown.",
            ],
            [
                   "The UTMISS flight data upload status is unknown.",
                   1,
                   "/Components/UTMISSManager/DJIUTMISSManager.html",
                   "#DJIUTMISSFlightDataUploadStatus_Unknown_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_setStateCallback_inline",
                   "Set Accessory Aggregation state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set Accessory Aggregation state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_setStateCallback_inline",
                   "",
            ],
            [
                   "getSpotlight",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_spotlight_inline",
                   "Gets the spotlight instance if it is connected.  @return The connected spotlight instance. `NULL` if no splotlight is connected.",
            ],
            [
                   "Gets the spotlight instance if it is connected.  @return The connected spotlight instance. `NULL` if no splotlight is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_spotlight_inline",
                   "",
            ],
            [
                   "getBeacon",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_beacon_inline",
                   "Gets the beacon instance if it is connected.  @return The connected beacon instance. `NULL` if no beacon is connected.",
            ],
            [
                   "Gets the beacon instance if it is connected.  @return The connected beacon instance. `NULL` if no beacon is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_beacon_inline",
                   "",
            ],
            [
                   "getSpeaker",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_speaker_inline",
                   "Gets the speaker instance if it is connected.  @return The connected speaker instance. `NULL` if no speaker is connected.",
            ],
            [
                   "Gets the speaker instance if it is connected.  @return The connected speaker instance. `NULL` if no speaker is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_speaker_inline",
                   "",
            ],
            [
                   "getRTKDongle",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_RTKDongle_inline",
                   "Gets the RTK Dongle instance if it is connected.  @return The connected RTK Dongle instance. `NULL` if no RTK Dongle is connected.",
            ],
            [
                   "Gets the RTK Dongle instance if it is connected.  @return The connected RTK Dongle instance. `NULL` if no RTK Dongle is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_RTKDongle_inline",
                   "",
            ],
            [
                   "getAccessoryAggregationState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_getAccessoryAggregationState_inline",
                   "Gets the accessory aggregation state.  @return An instance of `AccessoryAggregationState`.",
            ],
            [
                   "Gets the accessory aggregation state.  @return An instance of `AccessoryAggregationState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation.html",
                   "#DJIAccessoryAggregation_getAccessoryAggregationState_inline",
                   "",
            ],
            [
                   "Spotlight",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "",
                   "This class represents the spotlight accessory mounted on the aircraft. It provides methods to control the spotlight and get the related states.",
            ],
            [
                   "This class represents the spotlight accessory mounted on the aircraft. It provides methods to control the spotlight and get the related states.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "",
                   "",
            ],
            [
                   "Beacon",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "",
                   "The class represents the beacon accessory mounted on the aircraft.",
            ],
            [
                   "The class represents the beacon accessory mounted on the aircraft.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "",
                   "",
            ],
            [
                   "Speaker",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "",
                   "The class represents the speaker accessory on the aircraft. Used transmit audio files and control the speaker.",
            ],
            [
                   "The class represents the speaker accessory on the aircraft. Used transmit audio files and control the speaker.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "",
                   "",
            ],
            [
                   "AccessoryAggregationState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "",
                   "This class contains the latest connectivity state of accessories.",
            ],
            [
                   "This class contains the latest connectivity state of accessories.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "",
                   "",
            ],
            [
                   "isSpotlightConnected",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isSpotlightConnected_inline",
                   "`true` if the spotlight is connected.  @return A boolean value to check if spotlight is connected.",
            ],
            [
                   "`true` if the spotlight is connected.  @return A boolean value to check if spotlight is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isSpotlightConnected_inline",
                   "",
            ],
            [
                   "isBeaconConnected",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isBeaconConnected_inline",
                   "`true` if the beacon is connected.  @return A boolean value to check if beacon is connected.",
            ],
            [
                   "`true` if the beacon is connected.  @return A boolean value to check if beacon is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isBeaconConnected_inline",
                   "",
            ],
            [
                   "isSpeakerConnected",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isSpeakerConnected_inline",
                   "`true` if the speaker is connected.  @return A boolean value to check if speaker is connected.",
            ],
            [
                   "`true` if the speaker is connected.  @return A boolean value to check if speaker is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isSpeakerConnected_inline",
                   "",
            ],
            [
                   "isRtkDongleConnected",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isRtkDongleConnected_inline",
                   "`true` if the RTK Dongle is connected.  @return A boolean value to check if RTK Dongle is connected.",
            ],
            [
                   "`true` if the RTK Dongle is connected.  @return A boolean value to check if RTK Dongle is connected.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState.html",
                   "#DJIAccessoryAggregation_AggregationState_isRtkDongleConnected_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState_callbackInterface.html",
                   "",
                   "An interface for obtaining `AccessoryAggregationState`.",
            ],
            [
                   "An interface for obtaining `AccessoryAggregationState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState_callbackInterface.html",
                   "#DJIAccessoryAggregation_AggregationState_callbackInterface_onUpdate_inline",
                   "Callback function that updates the accessory aggregation state.  @param state The accessory aggregation state.",
            ],
            [
                   "Callback function that updates the accessory aggregation state.  @param state The accessory aggregation state.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_AggregationState_callbackInterface.html",
                   "#DJIAccessoryAggregation_AggregationState_callbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "getFileListState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_fileListState_inline",
                   "Current file list state of the speaker.  @return An enum value of `FileListState`.",
            ],
            [
                   "Current file list state of the speaker.  @return An enum value of `FileListState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_fileListState_inline",
                   "",
            ],
            [
                   "getDataTransmissionState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_dataTransmissionState_inline",
                   "The data transmission state of the speaker.  @return An enum value of `SpeakerDataTransmissionState`.",
            ],
            [
                   "The data transmission state of the speaker.  @return An enum value of `SpeakerDataTransmissionState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_dataTransmissionState_inline",
                   "",
            ],
            [
                   "setVolume",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setVolume_inline",
                   "Sets the volume to play audio. The valid range is [0, 100]. 100 means loudest.  @param value Volume value to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the volume to play audio. The valid range is [0, 100]. 100 means loudest.  @param value Volume value to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setVolume_inline",
                   "",
            ],
            [
                   "setPlayMode",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setPlayMode_inline",
                   "Sets the play mode of the speaker to control the behavior after finishing playing a file.  @param mode The play mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the play mode of the speaker to control the behavior after finishing playing a file.  @param mode The play mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setPlayMode_inline",
                   "",
            ],
            [
                   "startTransmission",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_startTransmission_inline",
                   "Starts to send a complete audio file to the aircraft, which can be played by the speaker.  A transmission session can only be started when the transmission state is in `IDLE`.  If the transmission is started successfully, the state will change  to `READY_TO_TRANSMIT`. Then  call `paceData` to send data to SDK.  Call `markEOF` when all data has been sent to SDK. SDK will maintain a  buffer to hold all the data and transmit it to the aircraft. For M2E Speaker, the audio file to transmit  should fulfill the following configurations:  - The speaker only receives raw PCM(Pulse-code modulation) data of an audio file,  if the audio file is compressed, PCM extraction is needed before the transmission.  - The audio channel is mono.  -  The audio sample rate is 44,100 Hz.  - The PCM (Pulse-code modulation) sample  depth is 16 bit per sample.  - The audio file is stored in the aircraft instead  of the speaker.  @param info The information of the file to transmit. It is also used to determine the  location the file will be stored in the aircraft. @param listener Inform the progress of the data transfer.",
            ],
            [
                   "Starts to send a complete audio file to the aircraft, which can be played by the speaker.  A transmission session can only be started when the transmission state is in `IDLE`.  If the transmission is started successfully, the state will change  to `READY_TO_TRANSMIT`. Then  call `paceData` to send data to SDK.  Call `markEOF` when all data has been sent to SDK. SDK will maintain a  buffer to hold all the data and transmit it to the aircraft. For M2E Speaker, the audio file to transmit  should fulfill the following configurations:  - The speaker only receives raw PCM(Pulse-code modulation) data of an audio file,  if the audio file is compressed, PCM extraction is needed before the transmission.  - The audio channel is mono.  -  The audio sample rate is 44,100 Hz.  - The PCM (Pulse-code modulation) sample  depth is 16 bit per sample.  - The audio file is stored in the aircraft instead  of the speaker.  @param info The information of the file to transmit. It is also used to determine the  location the file will be stored in the aircraft. @param listener Inform the progress of the data transfer.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_startTransmission_inline",
                   "",
            ],
            [
                   "paceData",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_paceData_inline",
                   "Sends raw PCM data of the audio file to SDK internal logic.  For Mavic 2 Enterprise, the transmission rate is limited to 80kB/s by sdk.  Therefore, SDK will cache the paced data to a local file when the rate of pacing data is over 80kB/s. The paced data will be appended  to the local file. Call `markEOF` when all data of the data has been paced to SDK.  @param data Raw PCM data stream in bytes.  @return `true` if data is paced successfully. Otherwise, pacing data is not in the current state or the data size is illegal.",
            ],
            [
                   "Sends raw PCM data of the audio file to SDK internal logic.  For Mavic 2 Enterprise, the transmission rate is limited to 80kB/s by sdk.  Therefore, SDK will cache the paced data to a local file when the rate of pacing data is over 80kB/s. The paced data will be appended  to the local file. Call `markEOF` when all data of the data has been paced to SDK.  @param data Raw PCM data stream in bytes.  @return `true` if data is paced successfully. Otherwise, pacing data is not in the current state or the data size is illegal.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_paceData_inline",
                   "",
            ],
            [
                   "markEOF",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_markEOF_inline",
                   "Marks EOF (end-of-file). It is used to inform SDK that all data of the file has been paced. SDK will continue  to transmit data to the aircraft. The state will change to `IDLE` when all data is transmitted.  After calling this method, `paceData` is invalid until a new transmission session starts. If no  data is paced before calling this method, the transmission session will end immediately.  @return The occurred error if any.",
            ],
            [
                   "Marks EOF (end-of-file). It is used to inform SDK that all data of the file has been paced. SDK will continue  to transmit data to the aircraft. The state will change to `IDLE` when all data is transmitted.  After calling this method, `paceData` is invalid until a new transmission session starts. If no  data is paced before calling this method, the transmission session will end immediately.  @return The occurred error if any.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_markEOF_inline",
                   "",
            ],
            [
                   "cancelTransmission",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_cancelTransmission_inline",
                   "This will entirely stop the data transfer process and of course clean the transfer thread pool.",
            ],
            [
                   "This will entirely stop the data transfer process and of course clean the transfer thread pool.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_cancelTransmission_inline",
                   "",
            ],
            [
                   "play",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_play_inline",
                   "Starts to play the audio file with the specific index.  @param fileIndex The file index of the `AudioMediaFile` to play. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts to play the audio file with the specific index.  @param fileIndex The file index of the `AudioMediaFile` to play. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_play_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_stopAudioPlayWithCompletion_inline",
                   "Stops the speaker from playing audio. The method is only valid when  the playing state is `PLAYING`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops the speaker from playing audio. The method is only valid when  the playing state is `PLAYING`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_stopAudioPlayWithCompletion_inline",
                   "",
            ],
            [
                   "rename",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_rename_inline",
                   "Renames the audio file with the specific index. If the operation is started successfully, FileListState will become `RENAMING`.  @param index The index of the audio file to rename. @param filename The new file name of the audio file. The file name should not exceed 128 characters. @param callback Completion callback to receive the result.",
            ],
            [
                   "Renames the audio file with the specific index. If the operation is started successfully, FileListState will become `RENAMING`.  @param index The index of the audio file to rename. @param filename The new file name of the audio file. The file name should not exceed 128 characters. @param callback Completion callback to receive the result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_rename_inline",
                   "",
            ],
            [
                   "getFileListSnapshot",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_filelistSnapshot_inline",
                   "Returns a copy of the current audio file list from the storage. Returns `null` if `getFileListState` is reset.  @return An array of `AudioMediaFile` objects.",
            ],
            [
                   "Returns a copy of the current audio file list from the storage. Returns `null` if `getFileListState` is reset.  @return An array of `AudioMediaFile` objects.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_filelistSnapshot_inline",
                   "",
            ],
            [
                   "refreshFileList",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_refreshFileList_inline",
                   "Refresh the audio file list in the aircraft.  - If the current state  is `RESET`, SDK  will try to fetch the complete file list.  - If the current state is `INCOMPLETE`, SDK  will only fetch the missing list of files.  - If the operation is started successfully,  the `FileListState`  will become `SYNCING`.  - When the  file list is refreshed successfully, the `FileListState` will become `UP_TO_DATE`.  @param callback Completion callback to receive the result.",
            ],
            [
                   "Refresh the audio file list in the aircraft.  - If the current state  is `RESET`, SDK  will try to fetch the complete file list.  - If the current state is `INCOMPLETE`, SDK  will only fetch the missing list of files.  - If the operation is started successfully,  the `FileListState`  will become `SYNCING`.  - When the  file list is refreshed successfully, the `FileListState` will become `UP_TO_DATE`.  @param callback Completion callback to receive the result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_refreshFileList_inline",
                   "",
            ],
            [
                   "delete",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_deleteFiles_inline",
                   "Deletes audio files in the aircraft. If the operation is started successfully, `getFileListState` will  become `DELETING`. If there is error or  failedFiles is not empty, `getFileListState`  will become `RESET`.  @param fileIndices A list of AudioMediaFile's index. @param callback Completion callback to receive the result.",
            ],
            [
                   "Deletes audio files in the aircraft. If the operation is started successfully, `getFileListState` will  become `DELETING`. If there is error or  failedFiles is not empty, `getFileListState`  will become `RESET`.  @param fileIndices A list of AudioMediaFile's index. @param callback Completion callback to receive the result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_deleteFiles_inline",
                   "",
            ],
            [
                   "addFileListStateListener",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_addFileListStateListener_inline",
                   "Start listen to the update of `getFileListState`.  @param listener A `FileListStateListener` interface.",
            ],
            [
                   "Start listen to the update of `getFileListState`.  @param listener A `FileListStateListener` interface.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_addFileListStateListener_inline",
                   "",
            ],
            [
                   "removeFileListStateListener",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_removeFileListStateListener_inline",
                   "Stop listen to the update of `getFileListState`.  @param listener Listener to be removed.",
            ],
            [
                   "Stop listen to the update of `getFileListState`.  @param listener Listener to be removed.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_removeFileListStateListener_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setStateCallback_inline",
                   "Sets the callback that updates speaker state.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the callback that updates speaker state.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_setStateCallback_inline",
                   "",
            ],
            [
                   "SpeakerState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "",
                   "State of the speaker accessory.",
            ],
            [
                   "State of the speaker accessory.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "",
                   "",
            ],
            [
                   "getVolume",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_volume_inline",
                   "The volume of the speaker to play audio.  @return An int value.",
            ],
            [
                   "The volume of the speaker to play audio.  @return An int value.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_volume_inline",
                   "",
            ],
            [
                   "getPlayingState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingState_inline",
                   "Get the audio playing state.  @return An enum value of the `SpeakerPlayingState`.",
            ],
            [
                   "Get the audio playing state.  @return An enum value of the `SpeakerPlayingState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingState_inline",
                   "",
            ],
            [
                   "getPlayingMode",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingMode_inline",
                   "The playing mode of the speaker.  @return An enum value of the `PlayMode`.",
            ],
            [
                   "The playing mode of the speaker.  @return An enum value of the `PlayMode`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingMode_inline",
                   "",
            ],
            [
                   "getPlayingIndex",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingIndex_inline",
                   "The index of the audio media file being played. If the speaker is not  playing any files, -1 will be returned.  @return An int value.",
            ],
            [
                   "The index of the audio media file being played. If the speaker is not  playing any files, -1 will be returned.  @return An int value.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_playingIndex_inline",
                   "",
            ],
            [
                   "getStorageLocation",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_audioStorageLocation_inline",
                   "The storage location of the file that is being played by the speaker.  @return An enum value of the `AudioStorageLocation`.",
            ],
            [
                   "The storage location of the file that is being played by the speaker.  @return An enum value of the `AudioStorageLocation`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_audioStorageLocation_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface.html",
                   "",
                   "This interface provides a callback to update the speaker's state.",
            ],
            [
                   "This interface provides a callback to update the speaker's state.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface_onUpdate_inline",
                   "Callback to update spotlight state.  @param state The spotlight's state.",
            ],
            [
                   "Callback to update spotlight state.  @param state The spotlight's state.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerState_CallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "AudioFileInfo",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "",
                   "The class contains the basic information of an audio file.",
            ],
            [
                   "The class contains the basic information of an audio file.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "",
                   "",
            ],
            [
                   "AudioFileInfo",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_constructor_inline",
                   "Creates an `AudioFileInfo` instance with a file name and the  storage location on the aircraft.  @param fileName The file name of the file. It will be used by the aircraft to store the file  after it is successfully transmitted. A file name should not exceed 20 characters. @param storageLocation The storage location of the file. The aircraft will use it to determine where  to store the file.",
            ],
            [
                   "Creates an `AudioFileInfo` instance with a file name and the  storage location on the aircraft.  @param fileName The file name of the file. It will be used by the aircraft to store the file  after it is successfully transmitted. A file name should not exceed 20 characters. @param storageLocation The storage location of the file. The aircraft will use it to determine where  to store the file.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_constructor_inline",
                   "",
            ],
            [
                   "getFileName",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_fileName_inline",
                   "The file name of the audio file. The aircraft will store the audio file with this file name.  @return A String value.",
            ],
            [
                   "The file name of the audio file. The aircraft will store the audio file with this file name.  @return A String value.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_fileName_inline",
                   "",
            ],
            [
                   "getStorageLocation",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_storageLocation_inline",
                   "The storage type of the audio file. The storage types will determine the strategy of  the aircraft to keep the file.  @return An enum value of the `AudioStorageLocation`.",
            ],
            [
                   "The storage type of the audio file. The storage types will determine the strategy of  the aircraft to keep the file.  @return An enum value of the `AudioStorageLocation`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJIAudioFileInfo_storageLocation_inline",
                   "",
            ],
            [
                   "PlayMode",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_inline",
                   "The speaker's play mode. It determines the behavior of the speaker when it finishes playing a file.",
            ],
            [
                   "The speaker's play mode. It determines the behavior of the speaker when it finishes playing a file.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_inline",
                   "",
            ],
            [
                   "SINGLE_ONCE",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_SingleOnce_inline",
                   "The speaker will play the selected file once. The speaker will stop playing after  finishing playing the file.",
            ],
            [
                   "The speaker will play the selected file once. The speaker will stop playing after  finishing playing the file.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_SingleOnce_inline",
                   "",
            ],
            [
                   "REPEAT_SINGLE",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_RepeatSingle_inline",
                   "The speaker will play the selected file repeatedly.",
            ],
            [
                   "The speaker will play the selected file repeatedly.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_RepeatSingle_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayMode_Unknown_inline",
                   "",
            ],
            [
                   "SpeakerPlayingState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_inline",
                   "The speaker's Playing State.",
            ],
            [
                   "The speaker's Playing State.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_inline",
                   "",
            ],
            [
                   "PLAYING",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Playing_inline",
                   "The speaker is playing the voice.",
            ],
            [
                   "The speaker is playing the voice.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Playing_inline",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Stopped_inline",
                   "The speaker is stopped and playing nothing.",
            ],
            [
                   "The speaker is stopped and playing nothing.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Stopped_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerPlayingState_Unknown_inline",
                   "",
            ],
            [
                   "SpeakerDataTransmissionState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_inline",
                   "Data transmission state of the speaker.",
            ],
            [
                   "Data transmission state of the speaker.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Idle_inline",
                   "The speaker is in idle state and is ready for receiving data from the mobile device.  Call `startTransmission` to start the data transmission.",
            ],
            [
                   "The speaker is in idle state and is ready for receiving data from the mobile device.  Call `startTransmission` to start the data transmission.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Idle_inline",
                   "",
            ],
            [
                   "READY_TO_TRANSMIT",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_ReadyToTransmit_inline",
                   "The data transmission from the mobile device to the speaker is started.  Call `paceData` to transmit data.",
            ],
            [
                   "The data transmission from the mobile device to the speaker is started.  Call `paceData` to transmit data.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_ReadyToTransmit_inline",
                   "",
            ],
            [
                   "TRANSMITING",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Transmitting_inline",
                   "The mobile device is transmitting data to the speaker.",
            ],
            [
                   "The mobile device is transmitting data to the speaker.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Transmitting_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Unknown_inline",
                   "Unknown state, either the speaker is disconnected or not recognized.",
            ],
            [
                   "Unknown state, either the speaker is disconnected or not recognized.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker.html",
                   "#DJIAccessoryAggregation_DJISpeaker_DJISpeakerDataTransmissionState_Unknown_inline",
                   "",
            ],
            [
                   "TransmissionListener",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "",
                   "The listener will be notified when the transmission for the audio file starts.",
            ],
            [
                   "The listener will be notified when the transmission for the audio file starts.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onStart",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onStart_inline",
                   "Called when the transmission starts and the aircraft is ready to receive data of the audio file from the mobile device.",
            ],
            [
                   "Called when the transmission starts and the aircraft is ready to receive data of the audio file from the mobile device.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onStart_inline",
                   "",
            ],
            [
                   "onProgress",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onProgress_inline",
                   "Called to update the transmission progress. The progress is updated when a chunk of data is received successfully by the aircraft.  @param dataSize The accumulated data size of the audio file received by the aircraft.",
            ],
            [
                   "Called to update the transmission progress. The progress is updated when a chunk of data is received successfully by the aircraft.  @param dataSize The accumulated data size of the audio file received by the aircraft.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onProgress_inline",
                   "",
            ],
            [
                   "onFinish",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onFinish_inline",
                   "Called when the transmission finishes successfully.  @param index The index assigned by the aircraft for the new audio file.",
            ],
            [
                   "Called when the transmission finishes successfully.  @param index The index assigned by the aircraft for the new audio file.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onFinish_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onFailure_inline",
                   "Called when the transmission is interrupted by an error.  @param error The possible error during the transmission.",
            ],
            [
                   "Called when the transmission is interrupted by an error.  @param error The possible error during the transmission.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface.html",
                   "#DJIAccessoryAggregation_DJISpeaker_TransmissionListenerInterface_onFailure_inline",
                   "",
            ],
            [
                   "getEnabled",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "#DJIAccessoryAggregation_DJIBeacon_getEnabled_inline",
                   "Determines if the beacon is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if the beacon is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "#DJIAccessoryAggregation_DJIBeacon_getEnabled_inline",
                   "",
            ],
            [
                   "setEnabled",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "#DJIAccessoryAggregation_DJIBeacon_setEnabled_inline",
                   "Enables the beacon to turn it on. The beacon will start blink.  @param enabled `true` to turn on the beacon. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the beacon to turn it on. The beacon will start blink.  @param enabled `true` to turn on the beacon. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJIBeacon.html",
                   "#DJIAccessoryAggregation_DJIBeacon_setEnabled_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setStateCallback_inline",
                   "Set spotlight state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set spotlight state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setStateCallback_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_state_inline",
                   "Gets the state of the spotlight.  @return An instance of `SpotlightState`.",
            ],
            [
                   "Gets the state of the spotlight.  @return An instance of `SpotlightState`.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_state_inline",
                   "",
            ],
            [
                   "getEnabled",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_getEnabled_inline",
                   "Gets on/off status of Spotlight.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets on/off status of Spotlight.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_getEnabled_inline",
                   "",
            ],
            [
                   "setEnabled",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setEnabled_inline",
                   "Enables the spotlight to turn it on.  @param enabled `true` to turn on the spotlight. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the spotlight to turn it on.  @param enabled `true` to turn on the spotlight. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setEnabled_inline",
                   "",
            ],
            [
                   "setBrightness",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setBrightness_inline",
                   "Sets the brightness of the spotlight. The valid range is [1, 100]. 100 means the brightest.  @param value Brightness value to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the brightness of the spotlight. The valid range is [1, 100]. 100 means the brightest.  @param value Brightness value to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight.html",
                   "#DJIAccessoryAggregation_DJISpotlight_setBrightness_inline",
                   "",
            ],
            [
                   "SpotlightState",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "",
                   "The state of the spotlight accessory.",
            ],
            [
                   "The state of the spotlight accessory.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "",
                   "",
            ],
            [
                   "getTemperature",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_temperature_inline",
                   "Returns the temperature of the Spotlight in Celsius.  @return An float value.",
            ],
            [
                   "Returns the temperature of the Spotlight in Celsius.  @return An float value.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_temperature_inline",
                   "",
            ],
            [
                   "getBrightness",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_brightness_inline",
                   "The configurable brightness of the spotlight.  @return An int value.",
            ],
            [
                   "The configurable brightness of the spotlight.  @return An int value.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_brightness_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface.html",
                   "",
                   "This interface provides a callback to update the spotlight's current state.",
            ],
            [
                   "This interface provides a callback to update the spotlight's current state.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface_onUpdate_inline",
                   "Callback to update spotlight state.  @param state The spotlight's state.",
            ],
            [
                   "Callback to update spotlight state.  @param state The spotlight's state.",
                   1,
                   "/Components/AccessoryAggregation/DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface.html",
                   "#DJIAccessoryAggregation_DJISpotlight_DJISpotlightState_CallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "WarningLevel",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_inline",
                   "The warning level of the status",
            ],
            [
                   "The warning level of the status",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_NONE_inline",
                   "The status has an undetermined warning level.",
            ],
            [
                   "The status has an undetermined warning level.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_NONE_inline",
                   "",
            ],
            [
                   "OFFLINE",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_OFFLINE_inline",
                   "The status is offline.",
            ],
            [
                   "The status is offline.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_OFFLINE_inline",
                   "",
            ],
            [
                   "GOOD",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_GOOD_inline",
                   "The status is good.",
            ],
            [
                   "The status is good.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_GOOD_inline",
                   "",
            ],
            [
                   "WARNING",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_WARNING_inline",
                   "The status is a warning.",
            ],
            [
                   "The status is a warning.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_WARNING_inline",
                   "",
            ],
            [
                   "ERROR",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_ERROR_inline",
                   "The status is an error.",
            ],
            [
                   "The status is an error.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_WarningLevel_ERROR_inline",
                   "",
            ],
            [
                   "isUrgentMessage",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_isUrgentMessage_inline",
                   "Get the urgency of the message.  @return `true` if message is urgent, `false` otherwise.",
            ],
            [
                   "Get the urgency of the message.  @return `true` if message is urgent, `false` otherwise.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_isUrgentMessage_inline",
                   "",
            ],
            [
                   "getWarningLevel",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getWarningLevel_inline",
                   "Get the warning level of the message.  @return WarningLevel type of the warning level.",
            ],
            [
                   "Get the warning level of the message.  @return WarningLevel type of the warning level.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getWarningLevel_inline",
                   "",
            ],
            [
                   "getMessage",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getMessage_inline",
                   "Get the message of the warning status item.  @return String message for the WarningStatusItem.",
            ],
            [
                   "Get the message of the warning status item.  @return String message for the WarningStatusItem.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getMessage_inline",
                   "",
            ],
            [
                   "getDefaultItem",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getDefaultItem_inline",
                   "Get a default warning status item with  - Warning level: WarningLevel.OFFLINE  - urgentMessage: false  - message:  (Empty string)  This can be used for initialization.  @return Default WarningStatusItem.",
            ],
            [
                   "Get a default warning status item with  - Warning level: WarningLevel.OFFLINE  - urgentMessage: false  - message:  (Empty string)  This can be used for initialization.  @return Default WarningStatusItem.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getDefaultItem_inline",
                   "",
            ],
            [
                   "getTestItem",
                   2,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getTestItem_inline",
                   "Get a test warning status item with  - Warning level: WarningLevel.ERROR  -  urgentMessage: true  - message: Test Warning Status Logic Item  This can be used for unit and integration testing as required.  @return Default WarningStatusItem.",
            ],
            [
                   "Get a test warning status item with  - Warning level: WarningLevel.ERROR  -  urgentMessage: true  - message: Test Warning Status Logic Item  This can be used for unit and integration testing as required.  @return Default WarningStatusItem.",
                   1,
                   "/Utils/DJIWarningStatusItem.html",
                   "#DJIWarningStatusItem_getTestItem_inline",
                   "",
            ],
            [
                   "isInMacau",
                   2,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInMacau_inline",
                   "Check if the drone location is in Macau.  @return `true` if current location is Macau.",
            ],
            [
                   "Check if the drone location is in Macau.  @return `true` if current location is Macau.",
                   1,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInMacau_inline",
                   "",
            ],
            [
                   "isInHongKong",
                   2,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInHongKong_inline",
                   "Check if the drone location is in Hong Kong.  @return `true` if current location is Hong Kong.",
            ],
            [
                   "Check if the drone location is in Hong Kong.  @return `true` if current location is Hong Kong.",
                   1,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInHongKong_inline",
                   "",
            ],
            [
                   "isInChina",
                   2,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInChina_inline",
                   "Check if the drone location is in China.  @return `true` if current location is in China.",
            ],
            [
                   "Check if the drone location is in China.  @return `true` if current location is in China.",
                   1,
                   "/Utils/DJILocationUtil.html",
                   "#DJILocationUtil_isInChina_inline",
                   "",
            ],
            [
                   "setListener",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setListener_inline",
                   "Set a listener of the VideoSizeListener interface.  @param listener A listener for the VideoSizeListener interface.",
            ],
            [
                   "Set a listener of the VideoSizeListener interface.  @param listener A listener for the VideoSizeListener interface.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setListener_inline",
                   "",
            ],
            [
                   "setVideoTypeBySize",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setVideoTypeBySize_inline",
                   "Set Video type by video size and camera index.  @param videoWidth Width of the video as received from the DJICodecManager. @param videoHeight Height of the video as received from the DJICodecManager. @param cameraIndex Index of the camera which is the source of the video.",
            ],
            [
                   "Set Video type by video size and camera index.  @param videoWidth Width of the video as received from the DJICodecManager. @param videoHeight Height of the video as received from the DJICodecManager. @param cameraIndex Index of the camera which is the source of the video.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setVideoTypeBySize_inline",
                   "",
            ],
            [
                   "setVideoIsRotated",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setVideoIsRotated_inline",
                   "Set video orientation.  @param isRotated `true` for portrait orientation and False for landscape.",
            ],
            [
                   "Set video orientation.  @param isRotated `true` for portrait orientation and False for landscape.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setVideoIsRotated_inline",
                   "",
            ],
            [
                   "setScreenTypeBySize",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setScreenTypeBySize_inline",
                   "Set screen type by screen size using the view width and height.  @param viewWidth Width of the view in which the video is being displayed. @param viewHeight Height of the view in which the video is being displayed.",
            ],
            [
                   "Set screen type by screen size using the view width and height.  @param viewWidth Width of the view in which the video is being displayed. @param viewHeight Height of the view in which the video is being displayed.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_setScreenTypeBySize_inline",
                   "",
            ],
            [
                   "calculateVideoSize",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_calculateVideoSize_inline",
                   "Calculate the video size with the set options.",
            ],
            [
                   "Calculate the video size with the set options.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil.html",
                   "#DJIVideoSizeCalculatorUtil_calculateVideoSize_inline",
                   "",
            ],
            [
                   "VideoSizeListener",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil_Interface.html",
                   "",
                   "Interface for listening to changes in video size",
            ],
            [
                   "Interface for listening to changes in video size",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil_Interface.html",
                   "",
                   "",
            ],
            [
                   "onVideoSizeChanged",
                   2,
                   "/Utils/DJIVideoSizeCalculatorUtil_Interface.html",
                   "#DJIVideoSizeCalculatorUtil_OnVideoSizeChanged_inline",
                   "Invoked when the video size is changed.  @param width The width of the video size. @param height The height of the video size. @param relativeWidth The relative width of the video size. @param relativeHeight The relative height of the video size.",
            ],
            [
                   "Invoked when the video size is changed.  @param width The width of the video size. @param height The height of the video size. @param relativeWidth The relative width of the video size. @param relativeHeight The relative height of the video size.",
                   1,
                   "/Utils/DJIVideoSizeCalculatorUtil_Interface.html",
                   "#DJIVideoSizeCalculatorUtil_OnVideoSizeChanged_inline",
                   "",
            ],
            [
                   "CompletionCallback<T",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallback_Interface.html",
                   "",
                   "Completion callback for asynchronous operations when no information needs to be returned from the operation.",
            ],
            [
                   "Completion callback for asynchronous operations when no information needs to be returned from the operation.",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallback_Interface.html",
                   "",
                   "",
            ],
            [
                   "onResult",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallback_Interface.html",
                   "#DJICommonCallbacks_CompletionCallback_Interface_onResult_inline",
                   "Invoked when the asynchronous operation completes. If the operation  completes successfully, `error` will be `null`. Override to handle in your own code.  @param error The DJI error result",
            ],
            [
                   "Invoked when the asynchronous operation completes. If the operation  completes successfully, `error` will be `null`. Override to handle in your own code.  @param error The DJI error result",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallback_Interface.html",
                   "#DJICommonCallbacks_CompletionCallback_Interface_onResult_inline",
                   "",
            ],
            [
                   "CompletionCallbackWith<T>",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "",
                   "Completion callback for asynchronous operations when information that requires one parameter (T) needs to be returned from the operation. The parameter T will be defined where the operation called.",
            ],
            [
                   "Completion callback for asynchronous operations when information that requires one parameter (T) needs to be returned from the operation. The parameter T will be defined where the operation called.",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWith_Interface_onSuccess_inline",
                   "Invoked when the asynchronous operation completes successfully. Override to handle in your own code.  @param t The parameter being returned.",
            ],
            [
                   "Invoked when the asynchronous operation completes successfully. Override to handle in your own code.  @param t The parameter being returned.",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWith_Interface_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWith_Interface_onFailure_inline",
                   "Invoked when the asynchronous operation fails to complete normally. Override to handle in your own code.  @param error The DJI error result",
            ],
            [
                   "Invoked when the asynchronous operation fails to complete normally. Override to handle in your own code.  @param error The DJI error result",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWith_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWith_Interface_onFailure_inline",
                   "",
            ],
            [
                   "Y>",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "",
                   "Completion callback for asynchronous operations when information that requires two parameters (X, Y) needs to be returned from the  operation. The parameters X and Y will be defined where the operation is called.",
            ],
            [
                   "Completion callback for asynchronous operations when information that requires two parameters (X, Y) needs to be returned from the  operation. The parameters X and Y will be defined where the operation is called.",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface_onSuccess_inline",
                   "Invoked when the asynchronous operation completes successfully. Override to handle in your own code.  @param x The first parameter being returned. @param y The second parameter being returned.",
            ],
            [
                   "Invoked when the asynchronous operation completes successfully. Override to handle in your own code.  @param x The first parameter being returned. @param y The second parameter being returned.",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface_onFailure_inline",
                   "Invoked when the asynchronous operation fails to complete normally. Override to handle in your own code.  @param error The DJI error result",
            ],
            [
                   "Invoked when the asynchronous operation fails to complete normally. Override to handle in your own code.  @param error The DJI error result",
                   1,
                   "/Utils/DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface.html",
                   "#DJICommonCallbacks_CompletionCallbackWithTwoParam_Interface_onFailure_inline",
                   "",
            ],
            [
                   "loadMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_loadMission_inline",
                   "Loads the WaypointMission into device memory. This also verifies all the information of `mission`. If something is incorrect, callback.result() will be called with an Error. Otherwise, callback.result() will be called with a `null` value. The `mission` object will remain in device memory even after the WaypointMission execution has finished.  @param mission Waypoint mission to load.  @return Returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
            ],
            [
                   "Loads the WaypointMission into device memory. This also verifies all the information of `mission`. If something is incorrect, callback.result() will be called with an Error. Otherwise, callback.result() will be called with a `null` value. The `mission` object will remain in device memory even after the WaypointMission execution has finished.  @param mission Waypoint mission to load.  @return Returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_loadMission_inline",
                   "",
            ],
            [
                   "getLoadedMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_loadedMission_inline",
                   "Gets the currently loaded mission of the operator. There are two ways to load a mission. 1. A mission can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission when SDK is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. In that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. User can call `downloadMission` to get all the information for the loaded mission. The `getLoadedMission` will be reset to `null` when the execution of the loadedMission is stopped, finished or interrupted.  @return A object of `WaypointMission`.",
            ],
            [
                   "Gets the currently loaded mission of the operator. There are two ways to load a mission. 1. A mission can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission when SDK is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. In that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. User can call `downloadMission` to get all the information for the loaded mission. The `getLoadedMission` will be reset to `null` when the execution of the loadedMission is stopped, finished or interrupted.  @return A object of `WaypointMission`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_loadedMission_inline",
                   "",
            ],
            [
                   "getPreviousInterruption",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_getPreviousInterruption_inline",
                   "Gets the interruption of the last waypoint mission. If a waypoint mission is interrupted before the completion, the aircraft will record the interruption information. This information is only available when the last waypoint mission is incomplete and the first waypoint of the mission has been reached. The interruption will also be recorded if the mission is stopped by the user. The interruption information is recorded in the aircraft and the information persists even after the aircraft's reboot. Supported only by Phantom 4 RTK.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the interruption of the last waypoint mission. If a waypoint mission is interrupted before the completion, the aircraft will record the interruption information. This information is only available when the last waypoint mission is incomplete and the first waypoint of the mission has been reached. The interruption will also be recorded if the mission is stopped by the user. The interruption information is recorded in the aircraft and the information persists even after the aircraft's reboot. Supported only by Phantom 4 RTK.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_getPreviousInterruption_inline",
                   "",
            ],
            [
                   "uploadMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_uploadMission_inline",
                   "Starts to upload the `getLoadedMission` to the aircraft. It can only be called when the `getLoadedMission` is complete and the `getCurrentState` is `READY_TO_UPLOAD`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the `WaypointMissionState` will become `READY_TO_EXECUTE`.  @param callback Completion block that will be called when the upload operation succeeds or fails to start. ",
            ],
            [
                   "Starts to upload the `getLoadedMission` to the aircraft. It can only be called when the `getLoadedMission` is complete and the `getCurrentState` is `READY_TO_UPLOAD`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the `WaypointMissionState` will become `READY_TO_EXECUTE`.  @param callback Completion block that will be called when the upload operation succeeds or fails to start. ",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_uploadMission_inline",
                   "",
            ],
            [
                   "retryUploadMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_retryUploadMission_inline",
                   "Retry upload waypoint mission.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Retry upload waypoint mission.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_retryUploadMission_inline",
                   "",
            ],
            [
                   "downloadMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_downloadMission_inline",
                   "Downloads information of each waypoint from aircraft and save it to `getLoadedMission`. If a download operation is started, the operator will download the information of waypoints missing in `getLoadedMission` one-by-one in ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the `getCurrentState` is one of the following: - `EXECUTING` - `EXECUTION_PAUSED`  @param callback Completion callback that will be called when the download operation succeeds or fails to start. ",
            ],
            [
                   "Downloads information of each waypoint from aircraft and save it to `getLoadedMission`. If a download operation is started, the operator will download the information of waypoints missing in `getLoadedMission` one-by-one in ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the `getCurrentState` is one of the following: - `EXECUTING` - `EXECUTION_PAUSED`  @param callback Completion callback that will be called when the download operation succeeds or fails to start. ",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_downloadMission_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_startMission_inline",
                   "Starts the execution of the uploaded mission. It can only be called when the `getCurrentState` is `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become `EXECUTING`.  @param callback Completion block that will be called when the operator succeeds or fails to start the execution. If it fails, an error will be returned.",
            ],
            [
                   "Starts the execution of the uploaded mission. It can only be called when the `getCurrentState` is `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become `EXECUTING`.  @param callback Completion block that will be called when the operator succeeds or fails to start the execution. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "resumeMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_resumeMission_inline",
                   "Resumes the paused mission. It can only be called when the `getCurrentState` is `EXECUTION_PAUSED`. After a mission is resumed successfully, the `getCurrentState` will become `EXECUTING`.  @param callback Completion block that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
            ],
            [
                   "Resumes the paused mission. It can only be called when the `getCurrentState` is `EXECUTION_PAUSED`. After a mission is resumed successfully, the `getCurrentState` will become `EXECUTING`.  @param callback Completion block that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_resumeMission_inline",
                   "",
            ],
            [
                   "pauseMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_pauseMission_inline",
                   "Pauses the executing mission. It can only be called when the `WaypointMissionState` is `EXECUTING`. After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback Completion block that will be called when the operator succeeds or fails to pause the mission. If it fails, an error will be returned.",
            ],
            [
                   "Pauses the executing mission. It can only be called when the `WaypointMissionState` is `EXECUTING`. After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback Completion block that will be called when the operator succeeds or fails to pause the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_pauseMission_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_stopMission_inline",
                   "Stops the executing or paused mission. It can only be called when the `getCurrentState` is one of the following: - `EXECUTING` - `EXECUTION_PAUSED` After a mission is stopped successfully, `getCurrentState` will become `READY_TO_UPLOAD`.  @param callback Completion block that will be called when the operator succeeds or fails to stop the mission. If it fails, an error will be returned.",
            ],
            [
                   "Stops the executing or paused mission. It can only be called when the `getCurrentState` is one of the following: - `EXECUTING` - `EXECUTION_PAUSED` After a mission is stopped successfully, `getCurrentState` will become `READY_TO_UPLOAD`.  @param callback Completion block that will be called when the operator succeeds or fails to stop the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_currentState_inline",
                   "The current state of the operator.  @return A object of `WaypointMissionState`.",
            ],
            [
                   "The current state of the operator.  @return A object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_addListener_inline",
                   "Add listener to listen for events.  @param listener An object of `WaypointMissionOperatorListener`.",
            ],
            [
                   "Add listener to listen for events.  @param listener An object of `WaypointMissionOperatorListener`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_addListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_removeListener_inline",
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
            ],
            [
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "WaypointMission",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "",
                   "In the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. Waypoints are physical locations to which the aircraft will fly. Creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. Actions can also be added to waypoints, which will be carried out when the aircraft reaches the waypoint. The aircraft travels between waypoints automatically at a base speed. However, the user can change the speed by using the pitch joystick. If the stick is pushed up, the speed will increase. If the stick is pushed down, the speed will slow down. The stick can be pushed down to stop the aircraft and further pushed to start making the aircraft travel back along the path it came. When the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each waypoint. If the stick is released, the aircraft will again travel through the waypoints in the original order, and continue to execute waypoint actions (even if executed previously). If the aircraft is pulled back along the waypoint mission all the way to the first waypoint, then it will hover in place until the stick is released enough for it to again progress through the mission from start to finish. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark, Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2, DJI Air 2S and Matrice 300 RTK.",
            ],
            [
                   "In the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. Waypoints are physical locations to which the aircraft will fly. Creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. Actions can also be added to waypoints, which will be carried out when the aircraft reaches the waypoint. The aircraft travels between waypoints automatically at a base speed. However, the user can change the speed by using the pitch joystick. If the stick is pushed up, the speed will increase. If the stick is pushed down, the speed will slow down. The stick can be pushed down to stop the aircraft and further pushed to start making the aircraft travel back along the path it came. When the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each waypoint. If the stick is released, the aircraft will again travel through the waypoints in the original order, and continue to execute waypoint actions (even if executed previously). If the aircraft is pulled back along the waypoint mission all the way to the first waypoint, then it will hover in place until the stick is released enough for it to again progress through the mission from start to finish. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark, Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2, DJI Air 2S and Matrice 300 RTK.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "",
                   "",
            ],
            [
                   "WaypointV2Mission",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "",
                   "In the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. Waypoints are physical locations to which the aircraft  will fly. Creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. Actions can also be added to waypoints, which will be carried out when the aircraft reaches the  waypoint. The aircraft travels between waypoints automatically at a base speed. However, the user can  change the speed by using the pitch joystick. If the stick is pushed up, the speed will increase. If the stick is pushed down, the speed will slow down. The stick can be pushed down to stop the aircraft  and further pushed to start making the aircraft travel back along the path it came. When the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each  waypoint. If the stick is released, the aircraft will again travel through the waypoints in the original  order, and continue to execute waypoint actions (even if executed previously). If the aircraft is pulled  back along the waypoint mission all the way to the first waypoint, then it will hover in place until the  stick is released enough for it to again progress through the mission from start to finish. It is only supported by `MATRICE_300_RTK`.",
            ],
            [
                   "In the waypoint mission, the aircraft will travel between waypoints, execute actions at waypoints, and adjust heading and altitude between waypoints. Waypoints are physical locations to which the aircraft  will fly. Creating a series of waypoints, in effect, will program a flight route for the aircraft to follow. Actions can also be added to waypoints, which will be carried out when the aircraft reaches the  waypoint. The aircraft travels between waypoints automatically at a base speed. However, the user can  change the speed by using the pitch joystick. If the stick is pushed up, the speed will increase. If the stick is pushed down, the speed will slow down. The stick can be pushed down to stop the aircraft  and further pushed to start making the aircraft travel back along the path it came. When the aircraft is travelling through waypoints in the reverse order, it will not execute waypoint actions at each  waypoint. If the stick is released, the aircraft will again travel through the waypoints in the original  order, and continue to execute waypoint actions (even if executed previously). If the aircraft is pulled  back along the waypoint mission all the way to the first waypoint, then it will hover in place until the  stick is released enough for it to again progress through the mission from start to finish. It is only supported by `MATRICE_300_RTK`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionEvent",
                   2,
                   "/Components/Missions/DJIWaypointMissionEvent.html",
                   "",
                   "Waypoint event base class.",
            ],
            [
                   "Waypoint event base class.",
                   1,
                   "/Components/Missions/DJIWaypointMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionUploadEvent",
                   2,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "",
                   "The upload event of a waypoint mission.",
            ],
            [
                   "The upload event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionDownloadEvent",
                   2,
                   "/Components/Missions/DJIWaypointMissionDownloadEvent.html",
                   "",
                   "The download event of a waypoint mission.",
            ],
            [
                   "The download event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMissionDownloadEvent.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionExecutionEvent",
                   2,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "",
                   "The execution event of a waypoint mission.",
            ],
            [
                   "The execution event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionState",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "",
                   "All the possible state of `WaypointMissionOperator`.",
            ],
            [
                   "All the possible state of `WaypointMissionOperator`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_NotSupported_inline",
                   "The connected product does not support waypoint mission.",
            ],
            [
                   "The connected product does not support waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "READY_TO_UPLOAD",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ReadyToUpload_inline",
                   "The aircraft is ready to upload a mission.",
            ],
            [
                   "The aircraft is ready to upload a mission.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ReadyToUpload_inline",
                   "",
            ],
            [
                   "UPLOADING",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Uploading_inline",
                   "The uploading is started successfully. Detail information for each waypoint is being uploaded one by one.",
            ],
            [
                   "The uploading is started successfully. Detail information for each waypoint is being uploaded one by one.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Uploading_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ReadyToExecute_inline",
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
            ],
            [
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ReadyToExecute_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Executing_inline",
                   "The execution is started successfully.",
            ],
            [
                   "The execution is started successfully.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Executing_inline",
                   "",
            ],
            [
                   "EXECUTION_PAUSED",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ExecutionPaused_inline",
                   "Waypoint mission is paused successfully. User can call `resumeMission` to continue the execution.",
            ],
            [
                   "Waypoint mission is paused successfully. User can call `resumeMission` to continue the execution.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_ExecutionPaused_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Disconnected_inline",
                   "The connection between the mobile device, remote controller and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is broken.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Recovering_inline",
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Recovering_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Unknown_inline",
                   "The state of the operator is unknown. It is the initial state when the operator is just created.",
            ],
            [
                   "The state of the operator is unknown. It is the initial state when the operator is just created.",
                   1,
                   "/Components/Missions/DJIWaypointMissionState.html",
                   "#DJIWaypointMissionState_Unknown_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointMissionEvent.html",
                   "#DJIWaypointMissionEvent_getError_inline",
                   "Error for Waypoint mission event.  @return An object of `DJIError`.",
            ],
            [
                   "Error for Waypoint mission event.  @return An object of `DJIError`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionEvent.html",
                   "#DJIWaypointMissionEvent_getError_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_progress_inline",
                   "The upload progress of the mission. It is `null` if there is an error during upload.  @return An object of `WaypointUploadProgress`.",
            ],
            [
                   "The upload progress of the mission. It is `null` if there is an error during upload.  @return An object of `WaypointUploadProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_progress_inline",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `WaypointMissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionUploadEvent.html",
                   "#DJIWaypointMissionUploadEvent_currentState_inline",
                   "",
            ],
            [
                   "WaypointUploadProgress",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "",
                   "The upload progress of the waypoint mission operator.",
            ],
            [
                   "The upload progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointMissionDownloadEvent.html",
                   "#DJIWaypointMissionDownloadEvent_progress_inline",
                   "The download progress of the mission. It is `null` if there is an error during download.  @return A object of `WaypointDownloadProgress`.",
            ],
            [
                   "The download progress of the mission. It is `null` if there is an error during download.  @return A object of `WaypointDownloadProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionDownloadEvent.html",
                   "#DJIWaypointMissionDownloadEvent_progress_inline",
                   "",
            ],
            [
                   "WaypointDownloadProgress",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "",
                   "The download progress of the waypoint mission operator.",
            ],
            [
                   "The download progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_progress_inline",
                   "The execution progress of the mission. It is `null` if there is an error during the execution.  @return An object of `WaypointExecutionProgress`.",
            ],
            [
                   "The execution progress of the mission. It is `null` if there is an error during the execution.  @return An object of `WaypointExecutionProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_progress_inline",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `WaypointMissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointMissionExecutionEvent.html",
                   "#DJIWaypointMissionExecutionEvent_currentState_inline",
                   "",
            ],
            [
                   "WaypointExecutionProgress",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "",
                   "The mission execution progress of the waypoint mission operator.",
            ],
            [
                   "The mission execution progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionExecuteState",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_inline",
                   "Current waypoint mission state.",
            ],
            [
                   "Current waypoint mission state.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_inline",
                   "",
            ],
            [
                   "WaypointMissionOperatorListener",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "",
                   "Listener interface for Waypoint mission operator events.",
            ],
            [
                   "Listener interface for Waypoint mission operator events.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "",
                   "",
            ],
            [
                   "onUploadUpdate",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onUploadUpdate_inline",
                   "Called when an upload event happens.  @param uploadEvent Upload event",
            ],
            [
                   "Called when an upload event happens.  @param uploadEvent Upload event",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onUploadUpdate_inline",
                   "",
            ],
            [
                   "onDownloadUpdate",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onDownloadUpdate_inline",
                   "Called when an download event happens.  @param downloadEvent Download event",
            ],
            [
                   "Called when an download event happens.  @param downloadEvent Download event",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onDownloadUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onStart_inline",
                   "Called when the waypoint mission starts.",
            ],
            [
                   "Called when the waypoint mission starts.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onStart_inline",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onExecutionUpdate_inline",
                   "Called when there is an execution update for the waypoint mission operator.  @param executionEvent Execution event.",
            ],
            [
                   "Called when there is an execution update for the waypoint mission operator.  @param executionEvent Execution event.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onFinish_inline",
                   "Called when the waypoint mission ends.  @param error Error if the waypoint mission didn't end as expected.",
            ],
            [
                   "Called when the waypoint mission ends.  @param error Error if the waypoint mission didn't end as expected.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator_Listener.html",
                   "#DJIWaypointMissionOperator_Listener_onFinish_inline",
                   "",
            ],
            [
                   "uploadedWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_uploadedWaypointIndex_inline",
                   "The index of the last uploaded waypoint. Information for each waypoint is uploaded one by one in ascending order. If no waypoint has been uploaded, the value will be -1.",
            ],
            [
                   "The index of the last uploaded waypoint. Information for each waypoint is uploaded one by one in ascending order. If no waypoint has been uploaded, the value will be -1.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_uploadedWaypointIndex_inline",
                   "",
            ],
            [
                   "totalWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_totalWaypointCount_inline",
                   "The total count of waypoints in the waypoint mission.",
            ],
            [
                   "The total count of waypoints in the waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_totalWaypointCount_inline",
                   "",
            ],
            [
                   "isSummaryUploaded",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_isWaypointSummaryUploaded_inline",
                   "The waypoint mission operator has uploaded the the mission's summary (information except waypoints).",
            ],
            [
                   "The waypoint mission operator has uploaded the the mission's summary (information except waypoints).",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointUploadProgress.html",
                   "#DJIWaypointMission_DJIWaypointUploadProgress_isWaypointSummaryUploaded_inline",
                   "",
            ],
            [
                   "isSummaryDownloaded",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_isSummaryDownloaded_inline",
                   "`true` if Waypoint summary is downloaded.",
            ],
            [
                   "`true` if Waypoint summary is downloaded.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_isSummaryDownloaded_inline",
                   "",
            ],
            [
                   "totalWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_totalWaypointCount_inline",
                   "The total count of waypoints in the waypoint mission.",
            ],
            [
                   "The total count of waypoints in the waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_totalWaypointCount_inline",
                   "",
            ],
            [
                   "downloadedWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_downloadedWaypointIndex_inline",
                   "The index of the last downloaded waypoint. Information for each waypoint is downloaded one by one in ascending order. If no waypoint has been downloaded, the value will be -1.",
            ],
            [
                   "The index of the last downloaded waypoint. Information for each waypoint is downloaded one by one in ascending order. If no waypoint has been downloaded, the value will be -1.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointDownloadProgress.html",
                   "#DJIWaypointMission_DJIWaypointDownloadProgress_downloadedWaypointIndex_inline",
                   "",
            ],
            [
                   "targetWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_targetWaypointIndex_inline",
                   "Index of the waypoint for the next mission to which the aircraft will proceed.",
            ],
            [
                   "Index of the waypoint for the next mission to which the aircraft will proceed.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_targetWaypointIndex_inline",
                   "",
            ],
            [
                   "isWaypointReached",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_isWaypointReached_inline",
                   "YES when the aircraft reaches a waypoint. After the waypoint actions and heading change is complete, the `targetWaypointIndex` will increment and this property will become NO.",
            ],
            [
                   "YES when the aircraft reaches a waypoint. After the waypoint actions and heading change is complete, the `targetWaypointIndex` will increment and this property will become NO.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_isWaypointReached_inline",
                   "",
            ],
            [
                   "executeState",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_execState_inline",
                   "Current execution state of the aircraft.",
            ],
            [
                   "Current execution state of the aircraft.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointExecutionProgress.html",
                   "#DJIWaypointMission_DJIWaypointExecutionProgress_execState_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Initializing_inline",
                   "Waypoint mission is initializing, which means the mission has started and the aircraft is going to the first waypoint.",
            ],
            [
                   "Waypoint mission is initializing, which means the mission has started and the aircraft is going to the first waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Initializing_inline",
                   "",
            ],
            [
                   "MOVING",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Moving_inline",
                   "Aircraft is currently moving toward the mission's next waypoint. This happens when the `WaypointMissionFlightPathMode` is set to `NORMAL`.",
            ],
            [
                   "Aircraft is currently moving toward the mission's next waypoint. This happens when the `WaypointMissionFlightPathMode` is set to `NORMAL`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Moving_inline",
                   "",
            ],
            [
                   "CURVE_MODE_MOVING",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_CurveModeMoving_inline",
                   "Aircraft is currently moving. This happens when the `WaypointMissionFlightPathMode` is set to `CURVED`.",
            ],
            [
                   "Aircraft is currently moving. This happens when the `WaypointMissionFlightPathMode` is set to `CURVED`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_CurveModeMoving_inline",
                   "",
            ],
            [
                   "CURVE_MODE_TURNING",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_CurveModeTurning_inline",
                   "Aircraft is currently turning. This happens when the `WaypointMissionFlightPathMode` is set to `CURVED`.",
            ],
            [
                   "Aircraft is currently turning. This happens when the `WaypointMissionFlightPathMode` is set to `CURVED`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_CurveModeTurning_inline",
                   "",
            ],
            [
                   "BEGIN_ACTION",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_BeginAction_inline",
                   "Aircraft has reached a waypoint, has rotated to the new heading and is now processing actions. This state will be called before the waypoint actions starts executing and will occur for each waypoint action.",
            ],
            [
                   "Aircraft has reached a waypoint, has rotated to the new heading and is now processing actions. This state will be called before the waypoint actions starts executing and will occur for each waypoint action.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_BeginAction_inline",
                   "",
            ],
            [
                   "DOING_ACTION",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_DoingAction_inline",
                   "Aircraft is at a waypoint and is executing an action.",
            ],
            [
                   "Aircraft is at a waypoint and is executing an action.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_DoingAction_inline",
                   "",
            ],
            [
                   "FINISHED_ACTION",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_FinishedAction_inline",
                   "Aircraft is at a waypoint and has finished executing the current waypoint action. This state occurs once for each waypoint action.",
            ],
            [
                   "Aircraft is at a waypoint and has finished executing the current waypoint action. This state occurs once for each waypoint action.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_FinishedAction_inline",
                   "",
            ],
            [
                   "RETURN_TO_FIRST_WAYPOINT",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_ReturnToFirstWaypoint_inline",
                   "Aircraft has returned to the first waypoint. This happens when the `getFinishedAction` is set to `RETURN_TO_FIRST_WAYPOINT`.",
            ],
            [
                   "Aircraft has returned to the first waypoint. This happens when the `getFinishedAction` is set to `RETURN_TO_FIRST_WAYPOINT`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_ReturnToFirstWaypoint_inline",
                   "",
            ],
            [
                   "PAUSED",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Paused_inline",
                   "The mission is currently paused by the user.",
            ],
            [
                   "The mission is currently paused by the user.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionExecuteState_Paused_inline",
                   "",
            ],
            [
                   "getLoadedMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedMission_inline",
                   "Gets the currently loaded mission of the operator. There are two ways to load a mission. 1. A mission can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission when SDK is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. In that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. User can call `downloadMission` to get all the information for the loaded mission. The `getLoadedMission` will be reset to `null` when the execution of the loadedMission is stopped, finished.  @return An object of `WaypointV2Mission`.",
            ],
            [
                   "Gets the currently loaded mission of the operator. There are two ways to load a mission. 1. A mission can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission when SDK is re-connected, the operator will download part of the mission's information from the aircraft and load it automatically. In that case, the loaded mission will only contain the summary of the executing mission but information for each waypoint is absent. User can call `downloadMission` to get all the information for the loaded mission. The `getLoadedMission` will be reset to `null` when the execution of the loadedMission is stopped, finished.  @return An object of `WaypointV2Mission`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedMission_inline",
                   "",
            ],
            [
                   "loadMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadMission_inline",
                   "Loads a waypoint mission into the operator. A mission can be loaded only when the `WaypointV2MissionState` is one of the following :  - `READY_TO_UPLOAD`  - `READY_TO_EXECUTE`  Calling `loadMission` when the current state is `READY_TO_EXECUTE` will change the state to `READY_TO_UPLOAD`. After calling `getLoadedMission`,  @param mission Waypoint mission to load. @param callback Returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
            ],
            [
                   "Loads a waypoint mission into the operator. A mission can be loaded only when the `WaypointV2MissionState` is one of the following :  - `READY_TO_UPLOAD`  - `READY_TO_EXECUTE`  Calling `loadMission` when the current state is `READY_TO_EXECUTE` will change the state to `READY_TO_UPLOAD`. After calling `getLoadedMission`,  @param mission Waypoint mission to load. @param callback Returns an error when mission data is invalid or the mission cannot be loaded in the current state.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadMission_inline",
                   "",
            ],
            [
                   "getLoadedActionCount",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedActionCount_inline",
                   "Gets the currently loaded actions count of the operator. There are two ways to load a mission. 1. Actions can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission and it has uploaded actions when SDK is re-connected, the operator will recover uploaded action count.  @return An int value of loaded action count.",
            ],
            [
                   "Gets the currently loaded actions count of the operator. There are two ways to load a mission. 1. Actions can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission and it has uploaded actions when SDK is re-connected, the operator will recover uploaded action count.  @return An int value of loaded action count.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedActionCount_inline",
                   "",
            ],
            [
                   "getLoadedActions",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedActions_inline",
                   "Gets the count of loaded actions in current operator. There are two ways to load a mission. 1. Actions can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission and it has uploaded actions when SDK is re-connected, the operator will recover uploaded action count. load it automatically. In that case, the loaded actions will be `null`, if user want get summary of the executing actions user can call `downloadMission` to get all the information for the loaded actions. The `getLoadedActions` will be reset to `null` when the execution of the getLoadedMission is stopped, finished.  @return A list of `WaypointV2Action` objects.",
            ],
            [
                   "Gets the count of loaded actions in current operator. There are two ways to load a mission. 1. Actions can be loaded by user through `loadMission`. 2. If the aircraft is already executing a waypoint mission and it has uploaded actions when SDK is re-connected, the operator will recover uploaded action count. load it automatically. In that case, the loaded actions will be `null`, if user want get summary of the executing actions user can call `downloadMission` to get all the information for the loaded actions. The `getLoadedActions` will be reset to `null` when the execution of the getLoadedMission is stopped, finished.  @return A list of `WaypointV2Action` objects.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_loadedActions_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_currentState_inline",
                   "The current state of the operator.  @return An object of `WaypointV2MissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `WaypointV2MissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_currentState_inline",
                   "",
            ],
            [
                   "getCurrentActionState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_currentActionState_inline",
                   "The current action state of the operator.  @return An object of `ActionState`.",
            ],
            [
                   "The current action state of the operator.  @return An object of `ActionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_currentActionState_inline",
                   "",
            ],
            [
                   "addWaypointEventListener",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_addWaypointEventListener_inline",
                   "Add listener to listen for waypoint events.  @param listener An object of DJIWaypointV2MissionOperator_Listener</code>.",
            ],
            [
                   "Add listener to listen for waypoint events.  @param listener An object of DJIWaypointV2MissionOperator_Listener</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_addWaypointEventListener_inline",
                   "",
            ],
            [
                   "removeWaypointListener",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_removeWaypointListener_inline",
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
            ],
            [
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_removeWaypointListener_inline",
                   "",
            ],
            [
                   "addActionListener",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_addActionListener_inline",
                   "Add listener to listen the events.  @param listener An object of DJIWaypointV2MissionOperator_ActionListener</code>.",
            ],
            [
                   "Add listener to listen the events.  @param listener An object of DJIWaypointV2MissionOperator_ActionListener</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_addActionListener_inline",
                   "",
            ],
            [
                   "removeActionListener",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_removeActionListener_inline",
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
            ],
            [
                   "Removes listener. If the same listener is listening to multiple events and notifications (e.g. upload event and download event), it will not receive any update of them.  @param listener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_removeActionListener_inline",
                   "",
            ],
            [
                   "WaypointV2MissionOperatorListener",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "",
                   "Listen mission event.",
            ],
            [
                   "Listen mission event.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onDownloadUpdate",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onDownloadUpdate_inline",
                   "Called when an download event happens.  @param downloadEvent The download event.",
            ],
            [
                   "Called when an download event happens.  @param downloadEvent The download event.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onDownloadUpdate_inline",
                   "",
            ],
            [
                   "onUploadUpdate",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onUploadUpdate_inline",
                   "Called when an upload event happens.  @param uploadEvent The upload event.",
            ],
            [
                   "Called when an upload event happens.  @param uploadEvent The upload event.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onUploadUpdate_inline",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionUpdate_inline",
                   "Called when there is an execution update for the waypoint mission operator.  @param executionEvent Execution event.",
            ],
            [
                   "Called when there is an execution update for the waypoint mission operator.  @param executionEvent Execution event.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionStart_inline",
                   "Called when the waypoint mission starts.",
            ],
            [
                   "Called when the waypoint mission starts.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionStart_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionFinish_inline",
                   "Called when the waypoint mission ends.  @param error Error if the waypoint mission didn't end as expected.",
            ],
            [
                   "Called when the waypoint mission ends.  @param error Error if the waypoint mission didn't end as expected.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionFinish_inline",
                   "",
            ],
            [
                   "onExecutionStopped",
                   2,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionStop_inline",
                   "Called when the waypoint mission is stopped by the user.",
            ],
            [
                   "Called when the waypoint mission is stopped by the user.",
                   1,
                   "/Components/Missions/WaypointV2MissionOperatorListenerInterface.html",
                   "#WaypointV2MissionOperatorListenerInterface_onExecutionStop_inline",
                   "",
            ],
            [
                   "WaypointV2ActionListener",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "",
                   "Listener that is interested on action event.",
            ],
            [
                   "Listener that is interested on action event.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onDownloadUpdate",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onDownloadUpdate_inline",
                   "Called when a download event happens.  @param downloadEvent The callback interface of `ActionDownloadEvent`.",
            ],
            [
                   "Called when a download event happens.  @param downloadEvent The callback interface of `ActionDownloadEvent`.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onDownloadUpdate_inline",
                   "",
            ],
            [
                   "onUploadUpdate",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onUploadUpdate_inline",
                   "Called when an upload event happens.  @param uploadEvent Upload event.",
            ],
            [
                   "Called when an upload event happens.  @param uploadEvent Upload event.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onUploadUpdate_inline",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionUpdate_inline",
                   "Called when an execution update event happens.  @param executionEvent Execution event.",
            ],
            [
                   "Called when an execution update event happens.  @param executionEvent Execution event.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionStart_inline",
                   "Called when an execution start event happens.  @param actionId An int value of the execution action index.",
            ],
            [
                   "Called when an execution start event happens.  @param actionId An int value of the execution action index.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionStart_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionFinish_inline",
                   "Called when an execution finish event happens.  @param actionId An int value of the execution action index. @param error An object of `DJIWaypointV2Error`.",
            ],
            [
                   "Called when an execution finish event happens.  @param actionId An int value of the execution action index. @param error An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/WaypointV2ActionListenerInterface.html",
                   "#WaypointV2ActionListenerInterface_onExecutionFinish_inline",
                   "",
            ],
            [
                   "ActionDownloadEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "",
                   "The download event of a waypoint mission.",
            ],
            [
                   "The download event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "#DJIWaypointV2ActionDownloadEventInterface_getProgress_inline",
                   "The download progress of the mission. It is `null` if there is an error during download.  @return An object of DJIWaypointV2Action_DJIWaypointV2ActionDownloadProgress</code>.",
            ],
            [
                   "The download progress of the mission. It is `null` if there is an error during download.  @return An object of DJIWaypointV2Action_DJIWaypointV2ActionDownloadProgress</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "#DJIWaypointV2ActionDownloadEventInterface_getProgress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "#DJIWaypointV2ActionDownloadEventInterface_getError_inline",
                   "The encountered error during download if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during download if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadEventInterface.html",
                   "#DJIWaypointV2ActionDownloadEventInterface_getError_inline",
                   "",
            ],
            [
                   "ActionUploadEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "",
                   "The upload event of a waypoint mission.",
            ],
            [
                   "The upload event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getPreviousState_inline",
                   "The previous state of the Action.  @return An object of `ActionState`.",
            ],
            [
                   "The previous state of the Action.  @return An object of `ActionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getPreviousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getCurrentState_inline",
                   "The current state of the Action.  @return An object of `ActionState`.",
            ],
            [
                   "The current state of the Action.  @return An object of `ActionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getCurrentState_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getProgress_inline",
                   "The upload progress of the mission. It is `null` if there is an error during upload.  @return An object of `ActionUploadProgress`.",
            ],
            [
                   "The upload progress of the mission. It is `null` if there is an error during upload.  @return An object of `ActionUploadProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getProgress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getError_inline",
                   "The encountered error during upload if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during upload if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadEventInterface.html",
                   "#DJIWaypointV2ActionUploadEventInterface_getError_inline",
                   "",
            ],
            [
                   "ActionExecutionEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "",
                   "The execution event of a waypoint mission.",
            ],
            [
                   "The execution event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getPreviousState_inline",
                   "The previous state of the operator.  @return An object of `ActionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `ActionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getPreviousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getCurrentState_inline",
                   "The current state of the operator.  @return An object of `ActionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `ActionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getCurrentState_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getProgress_inline",
                   "The execution progress of the mission. It is `null` if there is an error during the execution.  @return An object of `ActionExecutionProgress`.",
            ],
            [
                   "The execution progress of the mission. It is `null` if there is an error during the execution.  @return An object of `ActionExecutionProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getProgress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getError_inline",
                   "The encountered error during the execution if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during the execution if there is any. Otherwise, it is `null`.  @return An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionEvent.html",
                   "#DJIWaypointV2ActionExecutionEvent_getError_inline",
                   "",
            ],
            [
                   "ActionUploadProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "",
                   "The upload progress of the waypoint mission operator.",
            ],
            [
                   "The upload progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "",
                   "",
            ],
            [
                   "getLastUploadedWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "#DJIWaypointV2ActionUploadProgressInterface_getLastUploadedWaypointIndex_inline",
                   "The upload progress of the waypoint mission operator.  @return An int value.",
            ],
            [
                   "The upload progress of the waypoint mission operator.  @return An int value.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "#DJIWaypointV2ActionUploadProgressInterface_getLastUploadedWaypointIndex_inline",
                   "",
            ],
            [
                   "getTotalActionCount",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "#DJIWaypointV2ActionUploadProgressInterface_getTotalActionCount_inline",
                   "The total count of actions in the waypoint mission.  @return An int value.",
            ],
            [
                   "The total count of actions in the waypoint mission.  @return An int value.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionUploadProgressInterface.html",
                   "#DJIWaypointV2ActionUploadProgressInterface_getTotalActionCount_inline",
                   "",
            ],
            [
                   "uploadMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_uploadMission_inline",
                   "Starts to upload the `getLoadedMission` to the aircraft. It can only be called when the `getLoadedMission` is complete and the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_UPLOAD`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the `WaypointV2MissionState` will become `READY_TO_EXECUTE`.  If it is started successfully, use DJIWaypointV2MissionOperator_Listener_onUploadUpdate</code> to receive the detailed progress.  @param callback Callback will be invoked with the result if the upload command has been received successfully by the aircraft. If the upload command is successfully sent, use `addWaypointEventListener` to check the detailed progress.",
            ],
            [
                   "Starts to upload the `getLoadedMission` to the aircraft. It can only be called when the `getLoadedMission` is complete and the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_UPLOAD`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the `WaypointV2MissionState` will become `READY_TO_EXECUTE`.  If it is started successfully, use DJIWaypointV2MissionOperator_Listener_onUploadUpdate</code> to receive the detailed progress.  @param callback Callback will be invoked with the result if the upload command has been received successfully by the aircraft. If the upload command is successfully sent, use `addWaypointEventListener` to check the detailed progress.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_uploadMission_inline",
                   "",
            ],
            [
                   "uploadWaypointActions",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_uploadWaypointActions_inline",
                   "Starts to upload the `getLoadedActions` to the aircraft. It can only be called when the `getLoadedActions` is complete and the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_EXECUTE`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the DJIWaypointV2MissionActionState</code> will become `READY_TO_EXECUTE`.  @param actions A list of `WaypointV2Action` objects. @param callback Callback will be invoked with the result if the upload action command has been received successfully by the aircraft. If the upload command is successfully sent, use `addActionListener` to check the detailed progress.",
            ],
            [
                   "Starts to upload the `getLoadedActions` to the aircraft. It can only be called when the `getLoadedActions` is complete and the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_EXECUTE`. If a timeout error occurs during the previous upload, the upload operation will resume from the previous break-point. After a mission is uploaded successfully, the DJIWaypointV2MissionActionState</code> will become `READY_TO_EXECUTE`.  @param actions A list of `WaypointV2Action` objects. @param callback Callback will be invoked with the result if the upload action command has been received successfully by the aircraft. If the upload command is successfully sent, use `addActionListener` to check the detailed progress.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_uploadWaypointActions_inline",
                   "",
            ],
            [
                   "downloadMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_downloadMission_inline",
                   "Downloads information of each waypoint from aircraft and save it to `getLoadedMission`. If a download operation starts, the operator will download the information of waypoints missing in `getLoadedMission` one-by-one in ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED`.  @param callback Callback that will be called when the download operation succeeds or fails to start. If it is started successfully, use DJIWaypointV2MissionOperator_Listener_onDownloadUpdate</code> to receive the detailed progress.",
            ],
            [
                   "Downloads information of each waypoint from aircraft and save it to `getLoadedMission`. If a download operation starts, the operator will download the information of waypoints missing in `getLoadedMission` one-by-one in ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED`.  @param callback Callback that will be called when the download operation succeeds or fails to start. If it is started successfully, use DJIWaypointV2MissionOperator_Listener_onDownloadUpdate</code> to receive the detailed progress.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_downloadMission_inline",
                   "",
            ],
            [
                   "downloadActions",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_downloadActions_inline",
                   "Downloads information of Actions from startActionID to endActionID. The information of waypoints missing in `getLoadedMission` ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED`  @param callback Callback that will be called when the download operation succeeds or fails to start. If it is started successfully, use DJIWaypointV2MissionOperator_addListenerToDownloadEvent</code> to receive the detailed progress.",
            ],
            [
                   "Downloads information of Actions from startActionID to endActionID. The information of waypoints missing in `getLoadedMission` ascending order. If `getLoadedMission` is already complete (containing all the waypoints), this method will call `completion` immediately without error. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED`  @param callback Callback that will be called when the download operation succeeds or fails to start. If it is started successfully, use DJIWaypointV2MissionOperator_addListenerToDownloadEvent</code> to receive the detailed progress.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_downloadActions_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_startMission_inline",
                   "Starts the execution of the uploaded mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_EXECUTE`. After a mission is started successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param callback Completion block that will be called when the operator succeeds or fails to start the execution. If it fails, an error will be returned.",
            ],
            [
                   "Starts the execution of the uploaded mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `READY_TO_EXECUTE`. After a mission is started successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param callback Completion block that will be called when the operator succeeds or fails to start the execution. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_startMission_inline",
                   "",
            ],
            [
                   "interruptMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_interruptMission_inline",
                   "Pauses the executing mission. It can only be called when the `WaypointV2MissionState` is `Executing`. After a mission is paused successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `INTERRUPTED`.  @param callback Callback that will be called when the operator succeeds or fails to pause the mission. If it fails, an error will be returned.",
            ],
            [
                   "Pauses the executing mission. It can only be called when the `WaypointV2MissionState` is `Executing`. After a mission is paused successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `INTERRUPTED`.  @param callback Callback that will be called when the operator succeeds or fails to pause the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_interruptMission_inline",
                   "",
            ],
            [
                   "recoverMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_recoverMission_inline",
                   "Resumes the paused mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `INTERRUPTED`. After a mission is resumed successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param callback Callback that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
            ],
            [
                   "Resumes the paused mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `INTERRUPTED`. After a mission is resumed successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param callback Callback that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_recoverMission_inline",
                   "",
            ],
            [
                   "recoverMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_recoverMissionWithRecoverType_inline",
                   "Resumes the paused mission with recover type. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `INTERRUPTED`. After a mission is resumed successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param type An enum value of `InterruptRecoverActionType` @param callback Callback that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
            ],
            [
                   "Resumes the paused mission with recover type. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is `INTERRUPTED`. After a mission is resumed successfully, the DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `Executing`.  @param type An enum value of `InterruptRecoverActionType` @param callback Callback that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_recoverMissionWithRecoverType_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_stopMission_inline",
                   "Stops the executing or paused mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED` After a mission finishes successfully, DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `READY_TO_UPLOAD`.  @param callback Completion block that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
            ],
            [
                   "Stops the executing or paused mission. It can only be called when the DJIWaypointV2MissionActionExecutionEvent_currentState</code> is one of the following:  - `Executing`  - `INTERRUPTED` After a mission finishes successfully, DJIWaypointV2MissionActionExecutionEvent_currentState</code> will become `READY_TO_UPLOAD`.  @param callback Completion block that will be called when the operator succeeds or fails to resume the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "setAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointV2MissionOperator_setAutoFlightSpeed_inline",
                   "Set the flight speed while the mission is executing automatically (without manual joystick speed input). This is the only property or method in this class that can communicate with the aircraft during a mission. All other properties and methods are used offline to prepare the mission which is then uploaded to the aircraft.  @param speed Auto flight speed to be set. The absolute value of the auto flight speed should be less than or equal to the `getMaxFlightSpeed`. Its range is [-`getMaxFlightSpeed`, `getMaxFlightSpeed`] m/s. @param callback Callback.",
            ],
            [
                   "Set the flight speed while the mission is executing automatically (without manual joystick speed input). This is the only property or method in this class that can communicate with the aircraft during a mission. All other properties and methods are used offline to prepare the mission which is then uploaded to the aircraft.  @param speed Auto flight speed to be set. The absolute value of the auto flight speed should be less than or equal to the `getMaxFlightSpeed`. Its range is [-`getMaxFlightSpeed`, `getMaxFlightSpeed`] m/s. @param callback Callback.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointV2MissionOperator_setAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointV2MissionOperator_getAutoFlightSpeed_inline",
                   "Get the flight speed while the mission is executing.  @param callback Callback.",
            ],
            [
                   "Get the flight speed while the mission is executing.  @param callback Callback.",
                   1,
                   "/Components/Missions/DJIWaypointMissionOperator.html",
                   "#DJIWaypointV2MissionOperator_getAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "WaypointV2MissionExecutionEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "",
                   "The execution event of a waypoint mission.",
            ],
            [
                   "The execution event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `WaypointV2MissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `WaypointV2MissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `WaypointMissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_currentState_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_progress_inline",
                   "The execution progress of the mission. It is `nil` if there is an error during the execution.  @return An object of `WaypointV2ExecutionProgress`.",
            ],
            [
                   "The execution progress of the mission. It is `nil` if there is an error during the execution.  @return An object of `WaypointV2ExecutionProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_progress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_error_inline",
                   "The encountered error during the execution if there is any. Otherwise, it is `nil`.  @return An object of `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during the execution if there is any. Otherwise, it is `nil`.  @return An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionExecutionEvent.html",
                   "#DJIWaypointV2MissionExecutionEvent_error_inline",
                   "",
            ],
            [
                   "WaypointV2MissionDownloadEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "",
                   "The download event of a waypoint mission.",
            ],
            [
                   "The download event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "#DJIWaypointV2MissionDownloadEvent_progress_inline",
                   "The download progress of the mission. It is `nil` if there is an error during download.  @return An object of `WaypointV2DownloadProgress`.",
            ],
            [
                   "The download progress of the mission. It is `nil` if there is an error during download.  @return An object of `WaypointV2DownloadProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "#DJIWaypointV2MissionDownloadEvent_progress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "#DJIWaypointV2MissionDownloadEvent_error_inline",
                   "The encountered error during download if there is any. Otherwise, it is `nil`.  @return An object of `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during download if there is any. Otherwise, it is `nil`.  @return An object of `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionDownloadEvent.html",
                   "#DJIWaypointV2MissionDownloadEvent_error_inline",
                   "",
            ],
            [
                   "WaypointV2MissionUploadEvent",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "",
                   "The upload event of a waypoint mission.",
            ],
            [
                   "The upload event of a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_previousState_inline",
                   "The previous state of the operator.  @return An enum value of the `WaypointV2MissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An enum value of the `WaypointV2MissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_currentState_inline",
                   "The current state of the operator.  @return An enum value of the `WaypointV2MissionState`.",
            ],
            [
                   "The current state of the operator.  @return An enum value of the `WaypointV2MissionState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_currentState_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_progress_inline",
                   "The upload progress of the mission. It is `null` if there is an error during uploading.  @return An object of the `WaypointV2UploadProgress`.",
            ],
            [
                   "The upload progress of the mission. It is `null` if there is an error during uploading.  @return An object of the `WaypointV2UploadProgress`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_progress_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_error_inline",
                   "The encountered error during upload if there is any. Otherwise, it is `nil`.  @return An object of the `DJIWaypointV2Error`.",
            ],
            [
                   "The encountered error during upload if there is any. Otherwise, it is `nil`.  @return An object of the `DJIWaypointV2Error`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionUploadEvent.html",
                   "#DJIWaypointV2MissionUploadEvent_error_inline",
                   "",
            ],
            [
                   "WaypointV2MissionState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_inline",
                   "All the possible state of `WaypointV2MissionOperator`.",
            ],
            [
                   "All the possible state of `WaypointV2MissionOperator`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Unknown_inline",
                   "The state of the operator is unknown.",
            ],
            [
                   "The state of the operator is unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Disconnected_inline",
                   "The connection between the mobile device, remote controller and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is broken.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Recovering_inline",
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_NotSupported_inline",
                   "The connected product does not support waypoint mission 2.0.",
            ],
            [
                   "The connected product does not support waypoint mission 2.0.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_NotSupported_inline",
                   "",
            ],
            [
                   "READY_TO_UPLOAD",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_ReadyToUpload_inline",
                   "The aircraft is ready to upload a mission.",
            ],
            [
                   "The aircraft is ready to upload a mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_ReadyToUpload_inline",
                   "",
            ],
            [
                   "UPLOADING",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Uploading_inline",
                   "The uploading is started successfully. Detail information for each waypoint is being uploaded one by one.",
            ],
            [
                   "The uploading is started successfully. Detail information for each waypoint is being uploaded one by one.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Uploading_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_ReadyToExecute_inline",
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
            ],
            [
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_ReadyToExecute_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Executing_inline",
                   "The execution is started successfully.",
            ],
            [
                   "The execution is started successfully.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Executing_inline",
                   "",
            ],
            [
                   "INTERRUPTED",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Interrupted_inline",
                   "Waypoint mission is paused successfully. User can call `interruptMission` to continue the execution.",
            ],
            [
                   "Waypoint mission is paused successfully. User can call `interruptMission` to continue the execution.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionState_Interrupted_inline",
                   "",
            ],
            [
                   "ActionState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_inline",
                   "All the possible action state of `WaypointV2MissionOperator`.",
            ],
            [
                   "All the possible action state of `WaypointV2MissionOperator`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Unknown_inline",
                   "The state of the operator is unknown. It is the initial action state when the operator is just created.",
            ],
            [
                   "The state of the operator is unknown. It is the initial action state when the operator is just created.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Disconnected_inline",
                   "The connection between the mobile device, remote controller and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is broken.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Recovering_inline",
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the action state from the aircraft.",
            ],
            [
                   "The connection between the mobile device, remote controller and aircraft is built-up. The operator is synchronizing the action state from the aircraft.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_NotSupported_inline",
                   "The connected product does not support waypoint mission 2.0.",
            ],
            [
                   "The connected product does not support waypoint mission 2.0.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_NotSupported_inline",
                   "",
            ],
            [
                   "READY_TO_UPLOAD",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_ReadyToUpload_inline",
                   "The aircraft is ready to upload actions.",
            ],
            [
                   "The aircraft is ready to upload actions.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_ReadyToUpload_inline",
                   "",
            ],
            [
                   "UPLOADING",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Uploading_inline",
                   "The uploading is started successfully. Detail information for each action is being uploaded one by one.",
            ],
            [
                   "The uploading is started successfully. Detail information for each action is being uploaded one by one.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Uploading_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_ReadyToExecute_inline",
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
            ],
            [
                   "Waypoint mission is uploaded completely and the aircraft is ready to start the execution.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_ReadyToExecute_inline",
                   "",
            ],
            [
                   "Executing",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Executing_inline",
                   "The execution is started successfully.",
            ],
            [
                   "The execution is started successfully.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Executing_inline",
                   "",
            ],
            [
                   "Interrupted",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Interrupted_inline",
                   "Waypoint mission is interrupted successfully. User can call `interruptMission` to continue the execution.",
            ],
            [
                   "Waypoint mission is interrupted successfully. User can call `interruptMission` to continue the execution.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2MissionActionState_Interrupted_inline",
                   "",
            ],
            [
                   "WaypointV2Action",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "",
                   "This class represents an action for `WaypointV2Mission`. It determines how action is performed when a waypoint mission is executed.",
            ],
            [
                   "This class represents an action for `WaypointV2Mission`. It determines how action is performed when a waypoint mission is executed.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "",
                   "",
            ],
            [
                   "getActionID",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_actionId_inline",
                   "The ID of Action.  @return An int value of Action ID.",
            ],
            [
                   "The ID of Action.  @return An int value of Action ID.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_actionId_inline",
                   "",
            ],
            [
                   "getTrigger",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_trigger_inline",
                   "The trigger of action.  @return An object of `WaypointTrigger`.",
            ],
            [
                   "The trigger of action.  @return An object of `WaypointTrigger`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_trigger_inline",
                   "",
            ],
            [
                   "getActuator",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_actuator_inline",
                   "The actuator of action.  @return An object of `WaypointActuator`.",
            ],
            [
                   "The actuator of action.  @return An object of `WaypointActuator`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_actuator_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointV2Action`.",
            ],
            [
                   "The class is used to create the instance of `WaypointV2Action`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "",
                   "",
            ],
            [
                   "setActionID",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setActionID_inline",
                   "Sets the action id.  @param actionID The value of action id.  @return The build of `Builder`.",
            ],
            [
                   "Sets the action id.  @param actionID The value of action id.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setActionID_inline",
                   "",
            ],
            [
                   "setTrigger",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setTrigger_inline",
                   "Sets the trigger.  @param trigger The object of `WaypointTrigger`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the trigger.  @param trigger The object of `WaypointTrigger`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setTrigger_inline",
                   "",
            ],
            [
                   "setActuator",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setActuator_inline",
                   "Sets the actuator.  @param actuator The object of `WaypointActuator`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the actuator.  @param actuator The object of `WaypointActuator`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_setActuator_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_build_inline",
                   "Create an object of `WaypointV2Action`.  @return The object of `WaypointV2Action`.",
            ],
            [
                   "Create an object of `WaypointV2Action`.  @return The object of `WaypointV2Action`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_Builder.html",
                   "#DJIWaypointV2Action_Builder_build_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "",
                   "This class represents an Intelligent Hotpoint mission. In an Intelligent Hotpoint mission, the aircraft will  repeatedly fly circles of a constant radius around a specified point called a Hotpoint. The user can control  the aircraft to fly around the Hotpoint with a specific radius and altitude. During execution, the user can  also use the physical remote controller to modify its radius and speed. It is only supported by Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "This class represents an Intelligent Hotpoint mission. In an Intelligent Hotpoint mission, the aircraft will  repeatedly fly circles of a constant radius around a specified point called a Hotpoint. The user can control  the aircraft to fly around the Hotpoint with a specific radius and altitude. During execution, the user can  also use the physical remote controller to modify its radius and speed. It is only supported by Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "",
                   "",
            ],
            [
                   "isPOIModeEnabled",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_isPOIModeEnabled_inline",
                   "`true` if POI mode is enabled. Value is undefined if  the `getCurrentState` is one of the  following:  - `NOT_SUPPORTED`  - `DISCONNECTED`  - `RECOVERING`.  Now only  supported by Mavic 2 Zoom and Mavic 2 Pro.  @return A boolean value to check if POI Mode is enabled.",
            ],
            [
                   "`true` if POI mode is enabled. Value is undefined if  the `getCurrentState` is one of the  following:  - `NOT_SUPPORTED`  - `DISCONNECTED`  - `RECOVERING`.  Now only  supported by Mavic 2 Zoom and Mavic 2 Pro.  @return A boolean value to check if POI Mode is enabled.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_isPOIModeEnabled_inline",
                   "",
            ],
            [
                   "enablePOIMode",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_enablePOIMode_inline",
                   "Enable POI mode. enabling POI mode is the pre-condition of starting Intelligent Hotpoint Mission.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.  @param callback CompletionCallback callback that receives the execution result.",
            ],
            [
                   "Enable POI mode. enabling POI mode is the pre-condition of starting Intelligent Hotpoint Mission.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.  @param callback CompletionCallback callback that receives the execution result.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_enablePOIMode_inline",
                   "",
            ],
            [
                   "disablePOIMode",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_disablePOIMode_inline",
                   "Disable POI mode. When POI mode is disabled, you can not starting Intelligent Hotpoint mission.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Disable POI mode. When POI mode is disabled, you can not starting Intelligent Hotpoint mission.  Now only supported by Mavic 2 Zoom and Mavic 2 Pro.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_disablePOIMode_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_currentState_inline",
                   "The current state of the executing Intelligent Hotpoint mission.  @return An object of `IntelligentHotpointMissionState`.",
            ],
            [
                   "The current state of the executing Intelligent Hotpoint mission.  @return An object of `IntelligentHotpointMissionState`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_addListenerToEvents_inline",
                   "Adds listener to receive all of the Intelligent Hotpoint mission operator events.  @param listener Listener that is interested in the intelligent hotpoint mission operator.",
            ],
            [
                   "Adds listener to receive all of the Intelligent Hotpoint mission operator events.  @param listener Listener that is interested in the intelligent hotpoint mission operator.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_addListenerToEvents_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_removeListener_inline",
                   "Removes listener. If the listener is listening to events and notifications, then it will stop listening to  all if called with this method.  @param targetListener Listener to be removed.",
            ],
            [
                   "Removes listener. If the listener is listening to events and notifications, then it will stop listening to  all if called with this method.  @param targetListener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_removeAllListeners_inline",
                   "Remove all listeners from listener pool.",
            ],
            [
                   "Remove all listeners from listener pool.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_startMission_inline",
                   "Starts to execute an Intelligent Hotpoint mission. This only be called when the `getCurrentState`  is `READY_TO_START`. After a mission is started successfully, the `getCurrentState` will become `EXECUTING`.  If the mission starts successful, the aircraft will fly arround the hotpoint of the mission. The current horizontal distance between the aircraft and the hotpoint must  be [5,500]. The current vertical distance between the aircraft and the relative takeoff altitude must be [5,500].  @param mission An object of `IntelligentHotpointMission`. @param callback Completion callback that will be called when the operator succeeds or fails to start the mission. If it fails, an error will be returned.",
            ],
            [
                   "Starts to execute an Intelligent Hotpoint mission. This only be called when the `getCurrentState`  is `READY_TO_START`. After a mission is started successfully, the `getCurrentState` will become `EXECUTING`.  If the mission starts successful, the aircraft will fly arround the hotpoint of the mission. The current horizontal distance between the aircraft and the hotpoint must  be [5,500]. The current vertical distance between the aircraft and the relative takeoff altitude must be [5,500].  @param mission An object of `IntelligentHotpointMission`. @param callback Completion callback that will be called when the operator succeeds or fails to start the mission. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "startRecognizeTargetInRect",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_startRecognizeTargetInRect_inline",
                   "Send a target rect in video stream to aircraft, the vision system will recognize the target in the rect. This only be called when  the `getCurrentState` is `READY_TO_START`.  After recognize target success, the `getCurrentState` will become `WAITING_FOR_CONFIRMATION`  means recognize the target successfully or `READY_TO_START` means can not recognize the target.  @param rectF The tracking target rect in video stream. @param callback Completion callback that will be called when the operator succeeds or fails to start recognize target. If it fails, an error will be returned.",
            ],
            [
                   "Send a target rect in video stream to aircraft, the vision system will recognize the target in the rect. This only be called when  the `getCurrentState` is `READY_TO_START`.  After recognize target success, the `getCurrentState` will become `WAITING_FOR_CONFIRMATION`  means recognize the target successfully or `READY_TO_START` means can not recognize the target.  @param rectF The tracking target rect in video stream. @param callback Completion callback that will be called when the operator succeeds or fails to start recognize target. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_startRecognizeTargetInRect_inline",
                   "",
            ],
            [
                   "acceptConfirmation",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_acceptConfirmationWithCompletion_inline",
                   "Confirm the recognized target, only be called when the `getCurrentState`  is `WAITING_FOR_CONFIRMATION`. If accept successfully,  the `getCurrentState` will become `MEASURING_TARGET`,  the aircraft will measure the the target and calculate surrounding path. Then the aircraft will start circle around the target on the surrounding path and `getCurrentState`  will become `EXECUTING`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Confirm the recognized target, only be called when the `getCurrentState`  is `WAITING_FOR_CONFIRMATION`. If accept successfully,  the `getCurrentState` will become `MEASURING_TARGET`,  the aircraft will measure the the target and calculate surrounding path. Then the aircraft will start circle around the target on the surrounding path and `getCurrentState`  will become `EXECUTING`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_acceptConfirmationWithCompletion_inline",
                   "",
            ],
            [
                   "pauseMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_pauseMission_inline",
                   "Pauses the executing mission. It can only be called when the `getCurrentState` is `EXECUTING`.  After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Pauses the executing mission. It can only be called when the `getCurrentState` is `EXECUTING`.  After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_pauseMission_inline",
                   "",
            ],
            [
                   "resumeMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_resumeMission_inline",
                   "Resumes the paused mission. It can only be called when the `getCurrentState`  is `EXECUTION_PAUSED`. After a mission is resumed successfully,  the `getCurrentState` will become `EXECUTING`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Resumes the paused mission. It can only be called when the `getCurrentState`  is `EXECUTION_PAUSED`. After a mission is resumed successfully,  the `getCurrentState` will become `EXECUTING`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_resumeMission_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_stopMission_inline",
                   "Stops the executing or paused mission. It can only be called when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  After a mission is stopped successfully, `getCurrentState` will become `READY_TO_START`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Stops the executing or paused mission. It can only be called when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  After a mission is stopped successfully, `getCurrentState` will become `READY_TO_START`.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "setAngularVelocity",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setAngularVelocity_inline",
                   "Sets angular velocity for the executing mission. It can only be called when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param angularVelocity Angular velocity to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Sets angular velocity for the executing mission. It can only be called when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param angularVelocity Angular velocity to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setAngularVelocity_inline",
                   "",
            ],
            [
                   "setRadius",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setRadius_inline",
                   "Sets radius for the executing mission. It can only be called when the `getCurrentState` is one of the  following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param radius Radius to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Sets radius for the executing mission. It can only be called when the `getCurrentState` is one of the  following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param radius Radius to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setRadius_inline",
                   "",
            ],
            [
                   "setAltitude",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setAltitude_inline",
                   "Sets altitude for the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param altitude altitude to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Sets altitude for the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  @param altitude altitude to set. @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_setAltitude_inline",
                   "",
            ],
            [
                   "resetGimbalToCenter",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_resetGimbalToCenter_inline",
                   "Reset gimbal to center for the executing mission, the camera will direct to the target. It can only be called when the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  This feature is only avaliable in recognize mission.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
            ],
            [
                   "Reset gimbal to center for the executing mission, the camera will direct to the target. It can only be called when the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  This feature is only avaliable in recognize mission.  @param callback Completion callback that will be called when the operator succeeds or fails. If it fails, an error will be returned.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator.html",
                   "#DJIIntelligentHotpointMissionOperator_resetGimbalToCenter_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMissionOperatorListener",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "",
                   "Listener interface for listening to intelligent hotpoint mission events.",
            ],
            [
                   "Listener interface for listening to intelligent hotpoint mission events.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionUpdate_inline",
                   "Called when a new intelligent hotpoint mission event occurs.  @param event Updated event.",
            ],
            [
                   "Called when a new intelligent hotpoint mission event occurs.  @param event Updated event.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionStart_inline",
                   "Called when the intelligent hotpoint mission starts.",
            ],
            [
                   "Called when the intelligent hotpoint mission starts.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionStart_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionFinish_inline",
                   "Called when the intelligent hotpoint mission ends.  @param error Used when mission is finishes in an unexpected way.",
            ],
            [
                   "Called when the intelligent hotpoint mission ends.  @param error Used when mission is finishes in an unexpected way.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperatorListenerInterface.html",
                   "#DJIIntelligentHotpointMissionOperatorListenerInterface_onExecutionFinish_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMissionState",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "",
                   "The states of the `IntelligentHotpointMissionOperator`.",
            ],
            [
                   "The states of the `IntelligentHotpointMissionOperator`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Unknown_inline",
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
            ],
            [
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Disconnected_inline",
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
            ],
            [
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Recovering_inline",
                   "The connection between the mobile device and aircraft is recovering. At this time, the operator is  synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device and aircraft is recovering. At this time, the operator is  synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_NotSupported_inline",
                   "The connected product does not support Hotpoint mission.",
            ],
            [
                   "The connected product does not support Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "NOT_READY",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_NoReady_inline",
                   "The operator is not ready to start an Intelligent Hotpoint mission.",
            ],
            [
                   "The operator is not ready to start an Intelligent Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_NoReady_inline",
                   "",
            ],
            [
                   "READY_TO_START",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_ReadyToStart_inline",
                   "The operator is ready to start an Intelligent Hotpoint mission.",
            ],
            [
                   "The operator is ready to start an Intelligent Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_ReadyToStart_inline",
                   "",
            ],
            [
                   "RECOGNIZING_TARGET",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_RecognizingTarget_inline",
                   "The aircraft's Vision system is recognizing the track object. If recognized the target, the state will change to `WAITING_FOR_CONFIRMATION`.",
            ],
            [
                   "The aircraft's Vision system is recognizing the track object. If recognized the target, the state will change to `WAITING_FOR_CONFIRMATION`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_RecognizingTarget_inline",
                   "",
            ],
            [
                   "WAITING_FOR_CONFIRMATION",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_WaitingForConfirmation_inline",
                   "The aircraft has recognized the target and is waiting for confirmation.",
            ],
            [
                   "The aircraft has recognized the target and is waiting for confirmation.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_WaitingForConfirmation_inline",
                   "",
            ],
            [
                   "MEASURING_TARGET",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_MeasuringTarget_inline",
                   "Confirm success and when a tracking mission started, The Vision system will measure the track object and calculate the surrounding path. Then it will begin to surround the track target. The state will change  to `EXECUTING`.",
            ],
            [
                   "Confirm success and when a tracking mission started, The Vision system will measure the track object and calculate the surrounding path. Then it will begin to surround the track target. The state will change  to `EXECUTING`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_MeasuringTarget_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Executing_inline",
                   "The execution is started successfully.",
            ],
            [
                   "The execution is started successfully.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_Executing_inline",
                   "",
            ],
            [
                   "EXECUTION_PAUSED",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_ExecutionPaused_inline",
                   "Hotpoint mission is paused successfully. User can call `resumeMission` to continue the execution.",
            ],
            [
                   "Hotpoint mission is paused successfully. User can call `resumeMission` to continue the execution.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionState_ExecutionPaused_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMissionEvent",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "",
                   "This class encapsulates all the state changes of the Intelligent Hotpoint mission operator.",
            ],
            [
                   "This class encapsulates all the state changes of the Intelligent Hotpoint mission operator.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_previousState_inline",
                   "Get the previous state of the operator.  @return An object of `IntelligentHotpointMissionState`.",
            ],
            [
                   "Get the previous state of the operator.  @return An object of `IntelligentHotpointMissionState`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentState_inline",
                   "Get the current state of the operator.  @return An object of `IntelligentHotpointMissionState`.",
            ],
            [
                   "Get the current state of the operator.  @return An object of `IntelligentHotpointMissionState`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getMissionMode",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_missionMode_inline",
                   "Gets the current mission mode.  @return An enum value of `IntelligentHotpointMissionMode`.",
            ],
            [
                   "Gets the current mission mode.  @return An enum value of `IntelligentHotpointMissionMode`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_missionMode_inline",
                   "",
            ],
            [
                   "getTargetRectF",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetRect_inline",
                   "Get a bounding box for the target. The rectangle is normalized to [0,1] where (0,0) is the top left of  the video preview and (1,1) is the bottom right. When send target rect to Vision system, it will  recognize the target and push modified target bounding box. Value is available if  the `getCurrentState`  is `RECOGNIZING_TARGET`,  `WAITING_FOR_CONFIRMATION`,  `MEASURING_TARGET`.  @return An object of RectF",
            ],
            [
                   "Get a bounding box for the target. The rectangle is normalized to [0,1] where (0,0) is the top left of  the video preview and (1,1) is the bottom right. When send target rect to Vision system, it will  recognize the target and push modified target bounding box. Value is available if  the `getCurrentState`  is `RECOGNIZING_TARGET`,  `WAITING_FOR_CONFIRMATION`,  `MEASURING_TARGET`.  @return An object of RectF",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetRect_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentRadius_inline",
                   "Gets the intelligent hotpoint radius in meters of the mission. If there is no executing mission, it is 0.  @return A float value of current radius.",
            ],
            [
                   "Gets the intelligent hotpoint radius in meters of the mission. If there is no executing mission, it is 0.  @return A float value of current radius.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentRadius_inline",
                   "",
            ],
            [
                   "getTargetRadius",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetRadius_inline",
                   "Gets the target intelligent hotpoint radius in meters of the mission. Set by user, and the `getRadius`  will change to `getTargetRadius`. If there is no executing mission, it is 0.  @return A float value of target radius.",
            ],
            [
                   "Gets the target intelligent hotpoint radius in meters of the mission. Set by user, and the `getRadius`  will change to `getTargetRadius`. If there is no executing mission, it is 0.  @return A float value of target radius.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetRadius_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentAltitude_inline",
                   "Gets the current intelligent hotpoint altitude in meters of the mission.  @return A float value of current altitude.",
            ],
            [
                   "Gets the current intelligent hotpoint altitude in meters of the mission.  @return A float value of current altitude.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_currentAltitude_inline",
                   "",
            ],
            [
                   "getTargetAltitude",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetAltitude_inline",
                   "Gets the target intelligent hotpoint altitude in meters of the mission. Setted by user, and the `getAltitude`  will change to `getTargetAltitude`.  @return A float value of target altitude.",
            ],
            [
                   "Gets the target intelligent hotpoint altitude in meters of the mission. Setted by user, and the `getAltitude`  will change to `getTargetAltitude`.  @return A float value of target altitude.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_targetAltitude_inline",
                   "",
            ],
            [
                   "getMaxAngularVelocity",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_maxAngularVelocity_inline",
                   "Gets the intelligent hotpoint max angular velocity from current radius. This value depends on the current situation of the aircraft.  @return A float value of max angularVelocity.",
            ],
            [
                   "Gets the intelligent hotpoint max angular velocity from current radius. This value depends on the current situation of the aircraft.  @return A float value of max angularVelocity.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_maxAngularVelocity_inline",
                   "",
            ],
            [
                   "getAngularVelocity",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_angularVelocity_inline",
                   "Gets the current intelligent hotpoint angular velocity from current radius.  @return A float value of angularVelocity.",
            ],
            [
                   "Gets the current intelligent hotpoint angular velocity from current radius.  @return A float value of angularVelocity.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_angularVelocity_inline",
                   "",
            ],
            [
                   "getHotpoint",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_hotpoint_inline",
                   "Gets the intelligent hotpoint's coordinate of the mission.  @return An object of `LocationCoordinate2D`.",
            ],
            [
                   "Gets the intelligent hotpoint's coordinate of the mission.  @return An object of `LocationCoordinate2D`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_hotpoint_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_error_inline",
                   "Gets the intelligent hotpoint's encountered error if there is any. Otherwise, it is `null`.  @return An object of `DJIError`.",
            ],
            [
                   "Gets the intelligent hotpoint's encountered error if there is any. Otherwise, it is `null`.  @return An object of `DJIError`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent.html",
                   "#DJIIntelligentHotpointMissionOperator_DJIIntelligentHotpointMissionEvent_error_inline",
                   "",
            ],
            [
                   "isActive",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_isActive_inline",
                   "`true` if the trigger is currently active. The trigger is active when the Timeline element it is associated with is being executed in the Timeline.  @return `true` if active.",
            ],
            [
                   "`true` if the trigger is currently active. The trigger is active when the Timeline element it is associated with is being executed in the Timeline.  @return `true` if active.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_isActive_inline",
                   "",
            ],
            [
                   "setAction",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_setAction_inline",
                   "The action to execute. It is up to the trigger's implementation to decide when to call this action. The action should never be called by anything but the trigger. Actions can be implemented without using this property, but in addition `notifyListenersOfEvent` needs to be used to notify any listeners of the Trigger that an action was executed.  In future subclasses of this property to be provided, this action  block will be used to give developers control of an action when a  set of criteria has been met. For example, a subclass of this may  be a battery threshold trigger. Once the battery passes some threshold developers will be able to define the action they want to trigger.  @param action Action to trigger.",
            ],
            [
                   "The action to execute. It is up to the trigger's implementation to decide when to call this action. The action should never be called by anything but the trigger. Actions can be implemented without using this property, but in addition `notifyListenersOfEvent` needs to be used to notify any listeners of the Trigger that an action was executed.  In future subclasses of this property to be provided, this action  block will be used to give developers control of an action when a  set of criteria has been met. For example, a subclass of this may  be a battery threshold trigger. Once the battery passes some threshold developers will be able to define the action they want to trigger.  @param action Action to trigger.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_setAction_inline",
                   "",
            ],
            [
                   "start",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_start_inline",
                   "Begins trigger activity including monitoring the criteria required to  trigger the action. When subclassing,  the super class's start</code> method should be called on the first line.",
            ],
            [
                   "Begins trigger activity including monitoring the criteria required to  trigger the action. When subclassing,  the super class's start</code> method should be called on the first line.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_start_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_stop_inline",
                   "Ends all trigger activities including monitoring the criteria required to trigger the action. When subclassing,  the super class's stop</code> method should be called at the end.",
            ],
            [
                   "Ends all trigger activities including monitoring the criteria required to trigger the action. When subclassing,  the super class's stop</code> method should be called at the end.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_stop_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_addListener_inline",
                   "Adds a listener to all trigger events  @param listener A listener object",
            ],
            [
                   "Adds a listener to all trigger events  @param listener A listener object",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_addListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_removeListener_inline",
                   "Removes the listener from the listeners pool of all trigger events.  @param listener A previously added listener object.",
            ],
            [
                   "Removes the listener from the listeners pool of all trigger events.  @param listener A previously added listener object.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_removeAllListeners_inline",
                   "Removes all listeners from the listeners pool of all trigger events.",
            ],
            [
                   "Removes all listeners from the listeners pool of all trigger events.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_removeAllListeners_inline",
                   "",
            ],
            [
                   "notifyListenersOfEvent",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_notifyListenersOfEventError_inline",
                   "Notifies listeners about a trigger event. Should be used in subclasses especially after calling the action.  @param event A valid DJIMissionTriggerEvent. @param error An optional error.",
            ],
            [
                   "Notifies listeners about a trigger event. Should be used in subclasses especially after calling the action.  @param event A valid DJIMissionTriggerEvent. @param error An optional error.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_notifyListenersOfEventError_inline",
                   "",
            ],
            [
                   "Action",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIMissionTriggerActionInterface.html",
                   "",
                   "The type for the block being called when the trigger is triggered.",
            ],
            [
                   "The type for the block being called when the trigger is triggered.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIMissionTriggerActionInterface.html",
                   "",
                   "",
            ],
            [
                   "onCall",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIMissionTriggerActionInterface.html",
                   "#DJIMissionTrigger_DJIMissionTriggerActionCallback_inline",
                   "Call the action.",
            ],
            [
                   "Call the action.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIMissionTriggerActionInterface.html",
                   "#DJIMissionTrigger_DJIMissionTriggerActionCallback_inline",
                   "",
            ],
            [
                   "Listener",
                   2,
                   "/Components/Missions/DJIMissionTrigger_listenerInterface.html",
                   "",
                   "Listener interface for Trigger events.",
            ],
            [
                   "Listener interface for Trigger events.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_listenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onEvent",
                   2,
                   "/Components/Missions/DJIMissionTrigger_listenerInterface.html",
                   "#DJIMissionTrigger_onEventCallback_inline",
                   "Called when a trigger event occurs.  @param trigger The instance of the trigger. @param event The event type which caused the call. @param error An optional error.",
            ],
            [
                   "Called when a trigger event occurs.  @param trigger The instance of the trigger. @param event The event type which caused the call. @param error An optional error.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_listenerInterface.html",
                   "#DJIMissionTrigger_onEventCallback_inline",
                   "",
            ],
            [
                   "TriggerEvent",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEvent_inline",
                   "Events that may occur during the lifecycle of a mission trigger.",
            ],
            [
                   "Events that may occur during the lifecycle of a mission trigger.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEvent_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventUnknown_inline",
                   "The default event if no other event matches the situation.",
            ],
            [
                   "The default event if no other event matches the situation.",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventUnknown_inline",
                   "",
            ],
            [
                   "STARTED",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventStarted_inline",
                   "The trigger has started to monitor for its triggering criteria",
            ],
            [
                   "The trigger has started to monitor for its triggering criteria",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventStarted_inline",
                   "",
            ],
            [
                   "ACTION_TRIGGERED",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventActionTriggered_inline",
                   "The action block has been called as a result of matching the triggers' criteria",
            ],
            [
                   "The action block has been called as a result of matching the triggers' criteria",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventActionTriggered_inline",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventStopped_inline",
                   "The trigger no longer monitors data for its triggering criteria",
            ],
            [
                   "The trigger no longer monitors data for its triggering criteria",
                   1,
                   "/Components/Missions/DJIMissionTrigger.html",
                   "#DJIMissionTrigger_DJIMissionTriggerEventStopped_inline",
                   "",
            ],
            [
                   "BatteryPowerLevelTrigger",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIBatteryLevelMissionTrigger.html",
                   "",
                   "The class can be used to trigger an action during the execution of a  timeline if the aircraft battery goes below a certain level.",
            ],
            [
                   "The class can be used to trigger an action during the execution of a  timeline if the aircraft battery goes below a certain level.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIBatteryLevelMissionTrigger.html",
                   "",
                   "",
            ],
            [
                   "setPowerPercentageTriggerValue",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIBatteryLevelMissionTrigger.html",
                   "#DJIMissionTrigger_DJIBatteryLevelMissionTrigger_batteryPercentageTriggerValue_inline",
                   "If the remaining percentage drops below or equal to this value, the action will be triggered.  @param powerPercentageTriggerValue The power percentage trigger value to set.",
            ],
            [
                   "If the remaining percentage drops below or equal to this value, the action will be triggered.  @param powerPercentageTriggerValue The power percentage trigger value to set.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIBatteryLevelMissionTrigger.html",
                   "#DJIMissionTrigger_DJIBatteryLevelMissionTrigger_batteryPercentageTriggerValue_inline",
                   "",
            ],
            [
                   "WaypointReachedTrigger",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "",
                   "This class can be used to trigger an action during the execution of a waypoint mission when the aircraft reaches a certain waypoint index.",
            ],
            [
                   "This class can be used to trigger an action during the execution of a waypoint mission when the aircraft reaches a certain waypoint index.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "",
                   "",
            ],
            [
                   "getWaypointIndex",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "#DJIMissionTrigger_DJIWaypointReachedMissionTrigger_waypointIndex_inline",
                   "Get the index of waypoint.  @return The index of the waypoint.",
            ],
            [
                   "Get the index of waypoint.  @return The index of the waypoint.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "#DJIMissionTrigger_DJIWaypointReachedMissionTrigger_waypointIndex_inline",
                   "",
            ],
            [
                   "setWaypointIndex",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "#DJIMissionTrigger_DJIWaypointReachedMissionTrigger_setWaypointIndex_inline",
                   "If the waypoint mission reaches this index, the action will be triggered.  @param waypointIndex The index of the waypoint.",
            ],
            [
                   "If the waypoint mission reaches this index, the action will be triggered.  @param waypointIndex The index of the waypoint.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIWaypointReachedMissionTrigger.html",
                   "#DJIMissionTrigger_DJIWaypointReachedMissionTrigger_setWaypointIndex_inline",
                   "",
            ],
            [
                   "AircraftLandedTrigger",
                   2,
                   "/Components/Missions/DJIMissionTrigger_DJIAircraftLandedMissionTrigger.html",
                   "",
                   "It can be used to trigger an action during the execution  of a timeline if the aircraft lands.",
            ],
            [
                   "It can be used to trigger an action during the execution  of a timeline if the aircraft lands.",
                   1,
                   "/Components/Missions/DJIMissionTrigger_DJIAircraftLandedMissionTrigger.html",
                   "",
                   "",
            ],
            [
                   "WaypointActuator",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "",
                   "This class defines an actuator for `WaypointV2Action`. It determines how the action is performed when a waypoint mission is executed. You can add multiple actions with `uploadWaypointActions`.  There are two scenarios for it. Parallel execution: In parallel scenario, You can excute multiple actions with one trigger at the same time, the actions must be sent to different modules. For example, since gimbal and camera are different modules, you can use a trigger to rotate gimbal pitch and you can also use another triger  with identical parameters as the previous triger to take photos in order to execute these two actions at the same time.  You can not use two triggers with identical parameters to take photos and record videos at the same time, because these two actions are excuted with the same mudule. Serial execution: In serial scenario, You can excute multiple actions one by one. For example, if you want to add actions for camera to take photo and record video, you should add action with `WaypointV2AssociateTriggerParam`.  and set the associated action ID with previous action, the `getAssociateType` should be DJIWaypointV2TriggerAssociatedTimingTypeAfterFinished</code>.",
            ],
            [
                   "This class defines an actuator for `WaypointV2Action`. It determines how the action is performed when a waypoint mission is executed. You can add multiple actions with `uploadWaypointActions`.  There are two scenarios for it. Parallel execution: In parallel scenario, You can excute multiple actions with one trigger at the same time, the actions must be sent to different modules. For example, since gimbal and camera are different modules, you can use a trigger to rotate gimbal pitch and you can also use another triger  with identical parameters as the previous triger to take photos in order to execute these two actions at the same time.  You can not use two triggers with identical parameters to take photos and record videos at the same time, because these two actions are excuted with the same mudule. Serial execution: In serial scenario, You can excute multiple actions one by one. For example, if you want to add actions for camera to take photo and record video, you should add action with `WaypointV2AssociateTriggerParam`.  and set the associated action ID with previous action, the `getAssociateType` should be DJIWaypointV2TriggerAssociatedTimingTypeAfterFinished</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "",
                   "",
            ],
            [
                   "getActuatorType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_type_inline",
                   "The type of actuator.  @return An enum value of `ActionActuatorType`.",
            ],
            [
                   "The type of actuator.  @return An enum value of `ActionActuatorType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_type_inline",
                   "",
            ],
            [
                   "getActuatorIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_actuatorIndex_inline",
                   "The index of actuator. It is valid when the diagnostics is related to camera  or gimbal and the connected product has multiple gimbals and cameras.  @return An int value of actuator index.",
            ],
            [
                   "The index of actuator. It is valid when the diagnostics is related to camera  or gimbal and the connected product has multiple gimbals and cameras.  @return An int value of actuator index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_actuatorIndex_inline",
                   "",
            ],
            [
                   "getCameraActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_cameraActuatorParam_inline",
                   "The camera actuator param, It is valid only when the `getActuatorType`  is `CAMERA`.  @return An object of `WaypointCameraActuatorParam`.",
            ],
            [
                   "The camera actuator param, It is valid only when the `getActuatorType`  is `CAMERA`.  @return An object of `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_cameraActuatorParam_inline",
                   "",
            ],
            [
                   "getGimbalActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_gimbalActuatorParam_inline",
                   "Parameters for gimbal actuator. It is valid only when the `getActuatorType`  is `GIMBAL`.  @return An object of `WaypointGimbalActuatorParam`.",
            ],
            [
                   "Parameters for gimbal actuator. It is valid only when the `getActuatorType`  is `GIMBAL`.  @return An object of `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_gimbalActuatorParam_inline",
                   "",
            ],
            [
                   "getAircraftControlActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_aircraftControlActuatorParam_inline",
                   "Parameters for lidar actuator. It is valid only when the `getActuatorType`  is `AIRCRAFT_CONTROL`.  @return An object of `WaypointGimbalActuatorParam`.",
            ],
            [
                   "Parameters for lidar actuator. It is valid only when the `getActuatorType`  is `AIRCRAFT_CONTROL`.  @return An object of `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_aircraftControlActuatorParam_inline",
                   "",
            ],
            [
                   "getLidarActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_lidarActuatorParam_inline",
                   "Parameters for aircraft control actuator. It is valid only when the `getActuatorType`  is `LIDAR`.  @return An object of `WaypointLidarActuatorParam`.",
            ],
            [
                   "Parameters for aircraft control actuator. It is valid only when the `getActuatorType`  is `LIDAR`.  @return An object of `WaypointLidarActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_lidarActuatorParam_inline",
                   "",
            ],
            [
                   "WaypointGimbalActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "",
                   "This class defines the parameters for `WaypointActuator`. It determines how the gimbal actuator will be performed when a waypoint mission is executed.",
            ],
            [
                   "This class defines the parameters for `WaypointActuator`. It determines how the gimbal actuator will be performed when a waypoint mission is executed.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "",
                   "",
            ],
            [
                   "getOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_operationType_inline",
                   "The operation type of gimbal actuator. See `GimbalOperationType`.  @return An enum value of `GimbalOperationType`.",
            ],
            [
                   "The operation type of gimbal actuator. See `GimbalOperationType`.  @return An enum value of `GimbalOperationType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_operationType_inline",
                   "",
            ],
            [
                   "getRotation",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_rotation_inline",
                   "The rotation of gimbal actuator.  @return An object of `Rotation`.",
            ],
            [
                   "The rotation of gimbal actuator.  @return An object of `Rotation`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_rotation_inline",
                   "",
            ],
            [
                   "WaypointGimbalPathPointInfo",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "",
                   "This class defines the gimbal path point info parameters.",
            ],
            [
                   "This class defines the gimbal path point info parameters.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "",
                   "",
            ],
            [
                   "getRunningTime",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_runningTime_inline",
                   "The rotation time of the gimbal(unit: second). The gimbal will rotate at its maximum speed when the value is set to 0.  @return A float value to get the rotation time of the gimbal.",
            ],
            [
                   "The rotation time of the gimbal(unit: second). The gimbal will rotate at its maximum speed when the value is set to 0.  @return A float value to get the rotation time of the gimbal.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_runningTime_inline",
                   "",
            ],
            [
                   "getStayTime",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_stayTime_inline",
                   "The time stays at the target location including the time of photo taken(unit: second). For example: the Zenmuse P1 takes about 0.7s to take a photo. If you set stay time with 1s, the gimbal will stay for 0.3s after the camera has finished taking a photo. If the stay time is less than the photo time, the next PathPoint will be executed immediately after the photo is taken.  @return A float value to get the stay time of the gimbal.",
            ],
            [
                   "The time stays at the target location including the time of photo taken(unit: second). For example: the Zenmuse P1 takes about 0.7s to take a photo. If you set stay time with 1s, the gimbal will stay for 0.3s after the camera has finished taking a photo. If the stay time is less than the photo time, the next PathPoint will be executed immediately after the photo is taken.  @return A float value to get the stay time of the gimbal.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_stayTime_inline",
                   "",
            ],
            [
                   "getEulerRoll",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerRoll_inline",
                   "Euler target angle for roll (North East Down coordinate system). Unit: degree. You should use `ADJUST_ROLL` to get the adjustable roll range.  @return A float value to get the euler target angle for roll.",
            ],
            [
                   "Euler target angle for roll (North East Down coordinate system). Unit: degree. You should use `ADJUST_ROLL` to get the adjustable roll range.  @return A float value to get the euler target angle for roll.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerRoll_inline",
                   "",
            ],
            [
                   "getEulerPitch",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerPitch_inline",
                   "Euler target angle for pitch(North East Down coordinate system). Unit: degree. You should use `ADJUST_PITCH` to get the adjustable pitch range.  @return A float value to get the euler target angle for pitch.",
            ],
            [
                   "Euler target angle for pitch(North East Down coordinate system). Unit: degree. You should use `ADJUST_PITCH` to get the adjustable pitch range.  @return A float value to get the euler target angle for pitch.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerPitch_inline",
                   "",
            ],
            [
                   "getEulerYaw",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerYaw_inline",
                   "Euler target angle for yaw (Unit: degree). The yaw angle is relative to the aircraft heading. If you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  You should use `ADJUST_YAW` to get the adjustable yaw range.  @return A float value to get the euler target angle for yaw.",
            ],
            [
                   "Euler target angle for yaw (Unit: degree). The yaw angle is relative to the aircraft heading. If you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  You should use `ADJUST_YAW` to get the adjustable yaw range.  @return A float value to get the euler target angle for yaw.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_eulerYaw_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointGimbalPathPointInfo`.",
            ],
            [
                   "The class is used to create the instance of `WaypointGimbalPathPointInfo`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "",
                   "",
            ],
            [
                   "runningTime",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_runningTime_inline",
                   "Sets the running time.  @param runningTime A float value of running time. (unit:second)  @return The build of `Builder`.",
            ],
            [
                   "Sets the running time.  @param runningTime A float value of running time. (unit:second)  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_runningTime_inline",
                   "",
            ],
            [
                   "stayTime",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_stayTime_inline",
                   "Sets the stay time.  @param stayTime A float value of stay time.(unit:second)  @return The build of `Builder`.",
            ],
            [
                   "Sets the stay time.  @param stayTime A float value of stay time.(unit:second)  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_stayTime_inline",
                   "",
            ],
            [
                   "eulerRoll",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerRoll_inline",
                   "Sets the roll angle.  @param eulerRoll Euler target angle for roll(North East Down coordinate system). Unit:degree.  @return The build of `Builder`.",
            ],
            [
                   "Sets the roll angle.  @param eulerRoll Euler target angle for roll(North East Down coordinate system). Unit:degree.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerRoll_inline",
                   "",
            ],
            [
                   "eulerPitch",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerPitch_inline",
                   "Sets the pitch angle.  @param eulerPitch Euler target angle for pitch(North East Down coordinate system). Unit:degree.  @return The build of `Builder`.",
            ],
            [
                   "Sets the pitch angle.  @param eulerPitch Euler target angle for pitch(North East Down coordinate system). Unit:degree.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerPitch_inline",
                   "",
            ],
            [
                   "eulerYaw",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerYaw_inline",
                   "Sets the yaw angle.  @param eulerYaw Euler target angle for yaw (Unit:degree). The yaw angle is relative to the aircraft heading. If you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  @return The build of `Builder`.",
            ],
            [
                   "Sets the yaw angle.  @param eulerYaw Euler target angle for yaw (Unit:degree). The yaw angle is relative to the aircraft heading. If you set yaw angle to 0 degree, the direction of the gimbal will be the same as the aircraft heading.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_eulerYaw_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `Builder`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathPointInfo_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointGimbalStartPathShootingParam",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "",
                   "This class defines the gimbal start path shooting parameters.",
            ],
            [
                   "This class defines the gimbal start path shooting parameters.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "",
                   "",
            ],
            [
                   "getPathCycleMode",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pathCycleMode_inline",
                   "Determines whether path shooting is executed once or countless times.  @return An enum value of the `GimbalPathCycleMode`.",
            ],
            [
                   "Determines whether path shooting is executed once or countless times.  @return An enum value of the `GimbalPathCycleMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pathCycleMode_inline",
                   "",
            ],
            [
                   "getPointNum",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pointNum_inline",
                   "The point number, it is the size of the `getPointInfo` list.  @return An int value of point number.",
            ],
            [
                   "The point number, it is the size of the `getPointInfo` list.  @return An int value of point number.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pointNum_inline",
                   "",
            ],
            [
                   "getPointInfo",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pointInfo_inline",
                   "Path shooting point information list which contain parameters for path shooting.  @return The list of point information",
            ],
            [
                   "Path shooting point information list which contain parameters for path shooting.  @return The list of point information",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_pointInfo_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointGimbalStartPathShootingParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointGimbalStartPathShootingParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "pathCycleMode",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pathCycleMode_inline",
                   "Sets path cycle mode.  @param pathCycleMode An enum value of the `GimbalPathCycleMode`.  @return The build of `Builder`.",
            ],
            [
                   "Sets path cycle mode.  @param pathCycleMode An enum value of the `GimbalPathCycleMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pathCycleMode_inline",
                   "",
            ],
            [
                   "pointNum",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pointNum_inline",
                   "Sets the point number, indicates the number of point you wish to execute. Usually, it is the size of the `getPointInfo` list.  @param pointNum An int value of point number.  @return The build of `Builder`.",
            ],
            [
                   "Sets the point number, indicates the number of point you wish to execute. Usually, it is the size of the `getPointInfo` list.  @param pointNum An int value of point number.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pointNum_inline",
                   "",
            ],
            [
                   "pointInfo",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pointInfo_inline",
                   "Sets the list of the point information.  @param pointInfo The list of point information  @return The build of `Builder`.",
            ],
            [
                   "Sets the list of the point information.  @param pointInfo The list of point information  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_pointInfo_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `Builder`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStartPathShootingParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointGimbalStopPathShootingParam",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam.html",
                   "",
                   "This class defines the gimbal stop path shooting parameters.",
            ],
            [
                   "This class defines the gimbal stop path shooting parameters.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam.html",
                   "",
                   "",
            ],
            [
                   "getPathCycleMode",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_pathCycleMode_inline",
                   "Determines whether path shooting is executed once or countless times.  @return An enum value of the `GimbalPathCycleMode`.",
            ],
            [
                   "Determines whether path shooting is executed once or countless times.  @return An enum value of the `GimbalPathCycleMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_pathCycleMode_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointGimbalStopPathShootingParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointGimbalStopPathShootingParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "pathCycleMode",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder_pathCycleMode_inline",
                   " @param pathCycleMode An enum value of the `GimbalPathCycleMode`, please set the mode which you set at start path shooting..  @return The build of `Builder`.",
            ],
            [
                   " @param pathCycleMode An enum value of the `GimbalPathCycleMode`, please set the mode which you set at start path shooting..  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder_pathCycleMode_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `Builder`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalStopPathShootingParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointGimbalPathShooting",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "",
                   "This class defines the parameters for `WaypointGimbalActuatorParam`. It determines how the  gimbal actuator will be performed when a waypoint mission is executed.",
            ],
            [
                   "This class defines the parameters for `WaypointGimbalActuatorParam`. It determines how the  gimbal actuator will be performed when a waypoint mission is executed.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "",
                   "",
            ],
            [
                   "getPathShootingType",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_pathShootingType_inline",
                   "The operation type of gimbal actuator. See `GimbalPathShootingType`.  @return A value of `GimbalPathShootingType` enum.",
            ],
            [
                   "The operation type of gimbal actuator. See `GimbalPathShootingType`.  @return A value of `GimbalPathShootingType` enum.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_pathShootingType_inline",
                   "",
            ],
            [
                   "getStartPathShootingParam",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_startPathShootingParam_inline",
                   "The parameter for start path shooting. It's valid only when `GimbalPathShootingType` is `START_PATH_SHOOTING`  @return The object of `WaypointAircraftControlRotateYawParam`.",
            ],
            [
                   "The parameter for start path shooting. It's valid only when `GimbalPathShootingType` is `START_PATH_SHOOTING`  @return The object of `WaypointAircraftControlRotateYawParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_startPathShootingParam_inline",
                   "",
            ],
            [
                   "getStopPathShootingParam",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_stopPathShootingParam_inline",
                   "The parameters for stop path shooting.  It's valid only when `GimbalPathShootingType` is `STOP_PATH_SHOOTING`.  @return The object of `WaypointAircraftControlStartStopFlyParam`.",
            ],
            [
                   "The parameters for stop path shooting.  It's valid only when `GimbalPathShootingType` is `STOP_PATH_SHOOTING`.  @return The object of `WaypointAircraftControlStartStopFlyParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_stopPathShootingParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointGimbalPathShooting`.",
            ],
            [
                   "The class is used to create the instance of `WaypointGimbalPathShooting`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "pathShootingType",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_pathShootingType_inline",
                   " @param type An enum value of the `GimbalPathShootingType`.  @return The build of `Builder`.",
            ],
            [
                   " @param type An enum value of the `GimbalPathShootingType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_pathShootingType_inline",
                   "",
            ],
            [
                   "startPathShooting",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_startPathShooting_inline",
                   " @param param The object of `WaypointGimbalStartPathShootingParam`.  @return The build of `Builder`.",
            ],
            [
                   " @param param The object of `WaypointGimbalStartPathShootingParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_startPathShooting_inline",
                   "",
            ],
            [
                   "stopPathShooting",
                   2,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_stopPathShooting_inline",
                   " @param param The object of `GimbalPathShootingType`.  @return The build of `Builder`.",
            ],
            [
                   " @param param The object of `GimbalPathShootingType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder.html",
                   "#DJIWaypointV2GimbalActuatorParam_DJIWaypointV2GimbalPathShootingParam_Builder_stopPathShooting_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointGimbalActuatorParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "operationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_operationType_inline",
                   "Sets the operation type.  @param val An enum value of `GimbalOperationType`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the operation type.  @param val An enum value of `GimbalOperationType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_operationType_inline",
                   "",
            ],
            [
                   "rotation",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_rotation_inline",
                   "Sets the rotation.  @param val The object of `Rotation`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the rotation.  @param val The object of `Rotation`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_rotation_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointGimbalActuatorParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2GimbalActuatorParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointAircraftControlParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "",
                   "This class defines the parameters for `WaypointActuator`. It determines how the aircraft control actuator will be performed when a waypoint mission is executed.",
            ],
            [
                   "This class defines the parameters for `WaypointActuator`. It determines how the aircraft control actuator will be performed when a waypoint mission is executed.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "",
                   "",
            ],
            [
                   "getAircraftControlType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_operationType_inline",
                   "The operation type of aircraft control actuator. See `AircraftControlType`.  @return A value of `AircraftControlType` enum.",
            ],
            [
                   "The operation type of aircraft control actuator. See `AircraftControlType`.  @return A value of `AircraftControlType` enum.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_operationType_inline",
                   "",
            ],
            [
                   "getRotateYawParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_yawRotatingParam_inline",
                   "The parameter for rotating the aircraft's heading. It's valid only when `getAircraftControlType`  is `ROTATE_YAW`  @return The object of `WaypointAircraftControlRotateYawParam`.",
            ],
            [
                   "The parameter for rotating the aircraft's heading. It's valid only when `getAircraftControlType`  is `ROTATE_YAW`  @return The object of `WaypointAircraftControlRotateYawParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_yawRotatingParam_inline",
                   "",
            ],
            [
                   "getFlyControlParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_flyControlParam_inline",
                   "The parameters to control flying behavior.  It's valid only when `getAircraftControlType`  is `START_STOP_FLY`.  @return The object of `WaypointAircraftControlStartStopFlyParam`.",
            ],
            [
                   "The parameters to control flying behavior.  It's valid only when `getAircraftControlType`  is `START_STOP_FLY`.  @return The object of `WaypointAircraftControlStartStopFlyParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_flyControlParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "",
                   "The class is used to create the instance of `Builder`.",
            ],
            [
                   "The class is used to create the instance of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setRotateYawParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setRotateYawParam_inline",
                   "Sets the rotate yaw param.  @param rotateYawParam The object of `WaypointAircraftControlRotateYawParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the rotate yaw param.  @param rotateYawParam The object of `WaypointAircraftControlRotateYawParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setRotateYawParam_inline",
                   "",
            ],
            [
                   "setFlyControlParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setFlyControlParam_inline",
                   "Sets the flyControlParam.  @param flyControlParam The object of `WaypointAircraftControlStartStopFlyParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the flyControlParam.  @param flyControlParam The object of `WaypointAircraftControlStartStopFlyParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setFlyControlParam_inline",
                   "",
            ],
            [
                   "setAircraftControlType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setAircraftControlType_inline",
                   "Sets the aircraftControlType.  @param aircraftControlType An enum value of `AircraftControlType`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the aircraftControlType.  @param aircraftControlType An enum value of `AircraftControlType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_setAircraftControlType_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2AircraftControlParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointAircraftControlStartStopFlyParam",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam.html",
                   "",
                   "This class defines if the aircraft starts or stops the flight.",
            ],
            [
                   "This class defines if the aircraft starts or stops the flight.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam.html",
                   "",
                   "",
            ],
            [
                   "isStartFly",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_isStartFlying_inline",
                   "Determines the aircraft start flying or stop flying. `true` for the aircraft to start flying.  @return A boolean value to check aircraft start flying.",
            ],
            [
                   "Determines the aircraft start flying or stop flying. `true` for the aircraft to start flying.  @return A boolean value to check aircraft start flying.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_isStartFlying_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointAircraftControlStartStopFlyParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointAircraftControlStartStopFlyParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setStartFly",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder_setStartFly_inline",
                   "Set the param isStartFly.  @param startFly The boolean value of startFly.  @return The build of `Builder`.",
            ],
            [
                   "Set the param isStartFly.  @param startFly The boolean value of startFly.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder_setStartFly_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlStartStopFlyParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlStartStopFlyParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlFlyingParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointAircraftControlRotateYawParam",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "",
                   "This class defines how the aircraft rotates on the yaw axis.",
            ],
            [
                   "This class defines how the aircraft rotates on the yaw axis.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "",
                   "",
            ],
            [
                   "isRelative",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_isRelative_inline",
                   "Determines the aircraft rotate heading relative. If `true`, when the aircraft is rotating, relative to the current angle.  @return A boolean value to check aircraft rotate heading relative.",
            ],
            [
                   "Determines the aircraft rotate heading relative. If `true`, when the aircraft is rotating, relative to the current angle.  @return A boolean value to check aircraft rotate heading relative.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_isRelative_inline",
                   "",
            ],
            [
                   "getDirection",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_direction_inline",
                   "Determines the direction how aircraft changes its heading.  @return An enum value of `WaypointV2TurnMode`.",
            ],
            [
                   "Determines the direction how aircraft changes its heading.  @return An enum value of `WaypointV2TurnMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_direction_inline",
                   "",
            ],
            [
                   "getYawAngle",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_heading_inline",
                   "The heading in degrees to which the aircraft will rotate control by action. If isRelative is `true` A heading has a range of [-180, 180]  degrees, where 0 represents True North.  @return A float value of yaw angle.",
            ],
            [
                   "The heading in degrees to which the aircraft will rotate control by action. If isRelative is `true` A heading has a range of [-180, 180]  degrees, where 0 represents True North.  @return A float value of yaw angle.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_heading_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointAircraftControlRotateYawParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointAircraftControlRotateYawParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setRelative",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setRelative_inline",
                   "Sets the relative.  @param relative A boolean value of relative.  @return The build of `Builder`.",
            ],
            [
                   "Sets the relative.  @param relative A boolean value of relative.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setRelative_inline",
                   "",
            ],
            [
                   "setDirection",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setDirection_inline",
                   "Sets the direction.  @param direction An enum value of the `WaypointV2TurnMode`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the direction.  @param direction An enum value of the `WaypointV2TurnMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setDirection_inline",
                   "",
            ],
            [
                   "setYawAngle",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setYawAngle_inline",
                   "Sets the yaw angle.  @param yawAngle A float value of yaw angle.  @return The build of `Builder`.",
            ],
            [
                   "Sets the yaw angle.  @param yawAngle A float value of yaw angle.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_setYawAngle_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlRotateYawParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointAircraftControlRotateYawParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder.html",
                   "#DJIWaypointV2AircraftControlParam_DJIWaypointV2AircraftControlRotateHeadingParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointPointCloudRecordActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam.html",
                   "",
                   "This class defines the parameters for `WaypointPointCloudRecordActuatorParam`.  You can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
            ],
            [
                   "This class defines the parameters for `WaypointPointCloudRecordActuatorParam`.  You can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam.html",
                   "",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam.html",
                   "#DJIWaypointV2Actuator_PointCloudRecordActuatorParam_pointCloudRecordType_inline",
                   "The operation type of lidar actuator. See `PointCloudRecordType`.  @return An enum value of ``DJIWaypointV2_PointCloudRecordType`.",
            ],
            [
                   "The operation type of lidar actuator. See `PointCloudRecordType`.  @return An enum value of ``DJIWaypointV2_PointCloudRecordType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam.html",
                   "#DJIWaypointV2Actuator_PointCloudRecordActuatorParam_pointCloudRecordType_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder.html",
                   "",
                   "Generates the immutable object.",
            ],
            [
                   "Generates the immutable object.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "type",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder_type_inline",
                   "Sets the point cloud record operation type.  @param type The value of `PointCloudRecordType` enum.  @return The build of `Builder`.",
            ],
            [
                   "Sets the point cloud record operation type.  @param type The value of `PointCloudRecordType` enum.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_PointCloudRecordActuatorParam_Builder_type_inline",
                   "",
            ],
            [
                   "WaypointLidarActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "",
                   "This class defines the parameters for `WaypointActuator`.  You can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
            ],
            [
                   "This class defines the parameters for `WaypointActuator`.  You can use this actuator to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "",
                   "",
            ],
            [
                   "getLidarOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_lidarOperationType_inline",
                   "The operation type of lidar actuator. See `LidarOperationType`.  @return An enum value of `LidarOperationType`.",
            ],
            [
                   "The operation type of lidar actuator. See `LidarOperationType`.  @return An enum value of `LidarOperationType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_lidarOperationType_inline",
                   "",
            ],
            [
                   "getPointCloudRecordParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_pointCloudRecordParam_inline",
                   "The parameter for record point cloud. It's valid only when `LidarOperationType` is `RECORD_POINT_CLOUD`  @return The object of ``DJIWaypointV2Actuator_PointCloudRecordActuatorParam`.",
            ],
            [
                   "The parameter for record point cloud. It's valid only when `LidarOperationType` is `RECORD_POINT_CLOUD`  @return The object of ``DJIWaypointV2Actuator_PointCloudRecordActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_pointCloudRecordParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointLidarActuatorParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointLidarActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "lidarOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder_lidarOperationType_inline",
                   "Sets the lidar operation type The action lidar to execute.  @param type The value of `LidarOperationType` enum.  @return The build of `Builder`.",
            ],
            [
                   "Sets the lidar operation type The action lidar to execute.  @param type The value of `LidarOperationType` enum.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2LidarActuatorParam_Builder_lidarOperationType_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder_build_inline",
                   "Generates the immutable object.  @return The object of `WaypointCameraActuatorParam`.",
            ],
            [
                   "Generates the immutable object.  @return The object of `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "",
                   "This class defines the parameters for `WaypointActuator`. This determines how the camera  will be performed when a waypoint mission is executing.",
            ],
            [
                   "This class defines the parameters for `WaypointActuator`. This determines how the camera  will be performed when a waypoint mission is executing.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "",
                   "",
            ],
            [
                   "getCameraOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_operationType_inline",
                   "The operation type of camera actuator. See `CameraOperationType`.  @return An enum value of `CameraOperationType`.",
            ],
            [
                   "The operation type of camera actuator. See `CameraOperationType`.  @return An enum value of `CameraOperationType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_operationType_inline",
                   "",
            ],
            [
                   "getCustomNameParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_customNameParam_inline",
                   "The parameter for custom name. It's valid only when `getAircraftControlType`  is `CUSTOM_NAME`  @return The object of `WaypointCameraCustomNameParam`.",
            ],
            [
                   "The parameter for custom name. It's valid only when `getAircraftControlType`  is `CUSTOM_NAME`  @return The object of `WaypointCameraCustomNameParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_customNameParam_inline",
                   "",
            ],
            [
                   "getFocusModeParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_focusModeParam_inline",
                   "The parameter for camera focus mode. It's valid only when `getAircraftControlType`  is `FOCUS_MODE`  @return The object of DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusModeParam</code>.",
            ],
            [
                   "The parameter for camera focus mode. It's valid only when `getAircraftControlType`  is `FOCUS_MODE`  @return The object of DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusModeParam</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_focusModeParam_inline",
                   "",
            ],
            [
                   "getZoomParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_zoomParam_inline",
                   "The parameter for camera zoom. It's valid only when `getAircraftControlType`  is `ZOOM`  @return The object of `WaypointCameraZoomParam`.",
            ],
            [
                   "The parameter for camera zoom. It's valid only when `getAircraftControlType`  is `ZOOM`  @return The object of `WaypointCameraZoomParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_zoomParam_inline",
                   "",
            ],
            [
                   "getFocusParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_focusParam_inline",
                   "The parameter for camrea focus. It's valid only when `getAircraftControlType` is `FOCUS`  @return The object of DJIWaypointV2Actuator_DJIWaypointCameraFocusParam</code>.",
            ],
            [
                   "The parameter for camrea focus. It's valid only when `getAircraftControlType` is `FOCUS`  @return The object of DJIWaypointV2Actuator_DJIWaypointCameraFocusParam</code>.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_focusParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointCameraActuatorParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setCameraOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder_setCameraOperationType_inline",
                   "Sets the camera operation type The action camera to execute.  @param type The value of `CameraOperationType` enum.  @return The build of `Builder`.",
            ],
            [
                   "Sets the camera operation type The action camera to execute.  @param type The value of `CameraOperationType` enum.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraActuatorParam_Builder_setCameraOperationType_inline",
                   "",
            ],
            [
                   "WaypointCameraZoomParam",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam.html",
                   "",
                   "This class defines a camera focal length operation for `WaypointCameraActuatorParam`.",
            ],
            [
                   "This class defines a camera focal length operation for `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam.html",
                   "",
                   "",
            ],
            [
                   "getFocalLength",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_focalLength_inline",
                   "Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMinFocalLength`]  and must be a multiple of `getFocalLengthStep`. Only support by those camera `isOpticalZoomSupported` return `true`.  @return An int value of the zoom lens' focal length.",
            ],
            [
                   "Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMinFocalLength`]  and must be a multiple of `getFocalLengthStep`. Only support by those camera `isOpticalZoomSupported` return `true`.  @return An int value of the zoom lens' focal length.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_focalLength_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "",
                   "The class is used to create the obejct of `WaypointCameraZoomParam`.",
            ],
            [
                   "The class is used to create the obejct of `WaypointCameraZoomParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setFocalLength",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder_setFocalLength_inline",
                   "Sets focal length of the zoom lens in units of 0.1mm.  @param focalLength An int value of focal length.  @return The build of `Builder`.",
            ],
            [
                   "Sets focal length of the zoom lens in units of 0.1mm.  @param focalLength An int value of focal length.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder_setFocalLength_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder_build_inline",
                   "Generates the immutable object.  @return An object of `WaypointCameraZoomParam`.",
            ],
            [
                   "Generates the immutable object.  @return An object of `WaypointCameraZoomParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocalLengthParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraFocusModeParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraFocusModeParam.html",
                   "",
                   "This class defines a camera focus mode operation for `WaypointCameraActuatorParam`.",
            ],
            [
                   "This class defines a camera focus mode operation for `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraFocusModeParam.html",
                   "",
                   "",
            ],
            [
                   "getCameraFocusMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraFocusModeParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_cameraFocusMode_inline",
                   "Get the camera focus mode.  @return An enum value of `CameraFocusMode`.",
            ],
            [
                   "Get the camera focus mode.  @return An enum value of `CameraFocusMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraFocusModeParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_cameraFocusMode_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "",
                   "The class is used to create the obejct of `WaypointCameraFocusModeParam`.",
            ],
            [
                   "The class is used to create the obejct of `WaypointCameraFocusModeParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "cameraFocusMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder_cameraFocusMode_inline",
                   "Set the camera focus mode.  @param cameraFocusMode An enum value of `CameraFocusMode`.  @return The build of `Builder`.",
            ],
            [
                   "Set the camera focus mode.  @param cameraFocusMode An enum value of `CameraFocusMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder_cameraFocusMode_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder_build_inline",
                   "Generates the immutable object.  @return An object of `WaypointCameraFocusModeParam`.",
            ],
            [
                   "Generates the immutable object.  @return An object of `WaypointCameraFocusModeParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointV2CameraFocusModeParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraFocusRectangleTargetParam",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "",
                   "This class defines a camera rectangle focus target for `WaypointCameraFocusParam`.",
            ],
            [
                   "This class defines a camera rectangle focus target for `WaypointCameraFocusParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "",
                   "",
            ],
            [
                   "getReferencePoint",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_referencePoint_inline",
                   "The point at the upper left corner of the rectangle. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen.  @return An object of PointF.",
            ],
            [
                   "The point at the upper left corner of the rectangle. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen.  @return An object of PointF.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_referencePoint_inline",
                   "",
            ],
            [
                   "getWidth",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_width_inline",
                   "The width of the rectangle. The range of the width is (0.0, 1.0]. The value increses from left to right from the `getReferencePoint`.  @return The width of the rectangle.",
            ],
            [
                   "The width of the rectangle. The range of the width is (0.0, 1.0]. The value increses from left to right from the `getReferencePoint`.  @return The width of the rectangle.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_width_inline",
                   "",
            ],
            [
                   "getHeight",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_height_inline",
                   "The height of the rectangle. The range of the height is (0.0, 1.0]. The value increases from top to botton from the `getReferencePoint`.  @return The height of the rectangle.",
            ],
            [
                   "The height of the rectangle. The range of the height is (0.0, 1.0]. The value increases from top to botton from the `getReferencePoint`.  @return The height of the rectangle.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_height_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder.html",
                   "",
                   "This class is used to create the instance of `WaypointCameraFocusRectangleTargetParam`.",
            ],
            [
                   "This class is used to create the instance of `WaypointCameraFocusRectangleTargetParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointCameraFocusRectangleTargetParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointCameraFocusRectangleTargetParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_RectangleTargetParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraFocusPointTargetParam",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam.html",
                   "",
                   "This class defines a camera point focus target for `WaypointCameraFocusParam`.",
            ],
            [
                   "This class defines a camera point focus target for `WaypointCameraFocusParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam.html",
                   "",
                   "",
            ],
            [
                   "getFocusPoint",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_focusPoint_inline",
                   "The lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant  is enabled for the manual mode. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen.  @return An object of PointF.",
            ],
            [
                   "The lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant  is enabled for the manual mode. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen.  @return An object of PointF.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_focusPoint_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder.html",
                   "",
                   "This class is used to create the instance of `WaypointCameraFocusPointTargetParam`.",
            ],
            [
                   "This class is used to create the instance of `WaypointCameraFocusPointTargetParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of ``DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of ``DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder.html",
                   "#DJIWaypointV2ActionActuatorParam_DJIWaypointV2CameraFocus_PointTargetParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraFocusParam",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "",
                   "This class defines a camera focus operation for `WaypointCameraActuatorParam`.",
            ],
            [
                   "This class defines a camera focus operation for `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "",
                   "",
            ],
            [
                   "getCameraFocusRegionType",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_cameraFocusRegionType_inline",
                   "Focus region type of camera.  @return An enum value of `CameraFocusRegionType`",
            ],
            [
                   "Focus region type of camera.  @return An enum value of `CameraFocusRegionType`",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_cameraFocusRegionType_inline",
                   "",
            ],
            [
                   "getPoint",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_pointTargetParam_inline",
                   "The parameter for point focus. It's valid only when `getCameraFocusRegionType`   is `POINT`  @return The object of `getPoint`.",
            ],
            [
                   "The parameter for point focus. It's valid only when `getCameraFocusRegionType`   is `POINT`  @return The object of `getPoint`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_pointTargetParam_inline",
                   "",
            ],
            [
                   "getRectangle",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_rectangleTargetParam_inline",
                   "The parameter for rectangle focus. It's valid only when `getCameraFocusRegionType`   is `RECTANGLE`  @return The object of `getRectangle`.",
            ],
            [
                   "The parameter for rectangle focus. It's valid only when `getCameraFocusRegionType`   is `RECTANGLE`  @return The object of `getRectangle`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_rectangleTargetParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder.html",
                   "",
                   "This class is used to create the instance of `WaypointCameraFocusParam`.",
            ],
            [
                   "This class is used to create the instance of `WaypointCameraFocusParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointCameraFocusParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointCameraFocusParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder.html",
                   "#DJIWaypointV2CameraActuatorParam_DJIWaypointV2CameraFocusParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointCameraCustomNameParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "",
                   "This class defines a camera expand name operation for `WaypointCameraActuatorParam`.",
            ],
            [
                   "This class defines a camera expand name operation for `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_type_inline",
                   "Gets the type of camera custom expand name type.  @return An object of `getType`.",
            ],
            [
                   "Gets the type of camera custom expand name type.  @return An object of `getType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_type_inline",
                   "",
            ],
            [
                   "getCustomName",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_customName_inline",
                   "Gets the camera custom expand name.  @return A string value.",
            ],
            [
                   "Gets the camera custom expand name.  @return A string value.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_customName_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointCameraCustomNameParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointCameraCustomNameParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "type",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_type_inline",
                   "Sets the camera operation type the action camera to execute.  @param type The value of `CameraCustomNameType` enum.  @return The build of `Builder`.",
            ],
            [
                   "Sets the camera operation type the action camera to execute.  @param type The value of `CameraCustomNameType` enum.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_type_inline",
                   "",
            ],
            [
                   "customName",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_customName_inline",
                   "Sets the camera custom expand name the action camera to execute.  @param name A string value.  @return The build of `Builder`.",
            ],
            [
                   "Sets the camera custom expand name the action camera to execute.  @param name A string value.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_customName_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_build_inline",
                   "Generates the immutable object.  @return The object of `WaypointCameraCustomNameParam`.",
            ],
            [
                   "Generates the immutable object.  @return The object of `WaypointCameraCustomNameParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder.html",
                   "#DJIWaypointV2Actuator_DJIWaypointCameraCustomNameParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointTrigger",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "",
                   "It determines when an action will be performed while the aircraft executes a waypoint mission.",
            ],
            [
                   "It determines when an action will be performed while the aircraft executes a waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "",
                   "",
            ],
            [
                   "getTriggerType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_actionTriggerType_inline",
                   "The type of trigger.  @return An enum value of `ActionTriggerType`.",
            ],
            [
                   "The type of trigger.  @return An enum value of `ActionTriggerType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_actionTriggerType_inline",
                   "",
            ],
            [
                   "getReachPointParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_reachPointTriggerParam_inline",
                   "The parameters of `REACH_POINT`. It's  valid only when the `getTriggerType`  is `REACH_POINT`.  @return An object of `WaypointReachPointTriggerParam`.",
            ],
            [
                   "The parameters of `REACH_POINT`. It's  valid only when the `getTriggerType`  is `REACH_POINT`.  @return An object of `WaypointReachPointTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_reachPointTriggerParam_inline",
                   "",
            ],
            [
                   "getAssociateParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_associateTriggerParam_inline",
                   "The parameters of `ASSOCIATE`. It's valid  only when the `getTriggerType`  is `ASSOCIATE`.  @return An object of `WaypointV2AssociateTriggerParam`.",
            ],
            [
                   "The parameters of `ASSOCIATE`. It's valid  only when the `getTriggerType`  is `ASSOCIATE`.  @return An object of `WaypointV2AssociateTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_associateTriggerParam_inline",
                   "",
            ],
            [
                   "getTrajectoryParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_trajectoryTriggerParam_inline",
                   "The parameters of `TRAJECTORY`. It's valid only  when the `getTriggerType` is `TRAJECTORY`. This trigger applies only to `AIRCRAFT_CONTROL_GIMBAL`.  If this action is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index.  @return An object of `WaypointTrajectoryTriggerParam`.",
            ],
            [
                   "The parameters of `TRAJECTORY`. It's valid only  when the `getTriggerType` is `TRAJECTORY`. This trigger applies only to `AIRCRAFT_CONTROL_GIMBAL`.  If this action is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index.  @return An object of `WaypointTrajectoryTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_trajectoryTriggerParam_inline",
                   "",
            ],
            [
                   "getIntervalTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_intervalTriggerParam_inline",
                   "The parameters of `SIMPLE_INTERVAL`. It's valid only when the `getTriggerType` is `SIMPLE_INTERVAL`.  @return An object of `WaypointIntervalTriggerParam`.",
            ],
            [
                   "The parameters of `SIMPLE_INTERVAL`. It's valid only when the `getTriggerType` is `SIMPLE_INTERVAL`.  @return An object of `WaypointIntervalTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_intervalTriggerParam_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointTrigger`.",
            ],
            [
                   "The class is used to create the instance of `WaypointTrigger`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "",
                   "",
            ],
            [
                   "setTriggerType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setTriggerType_inline",
                   "Set Waypoint trigger type.  @param triggerType An enum value of `ActionTriggerType`.  @return The build of `Builder`.",
            ],
            [
                   "Set Waypoint trigger type.  @param triggerType An enum value of `ActionTriggerType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setTriggerType_inline",
                   "",
            ],
            [
                   "setAssociateParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setAssociateParam_inline",
                   "Sets the associate param.  @param associateParam The Object of `WaypointV2AssociateTriggerParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the associate param.  @param associateParam The Object of `WaypointV2AssociateTriggerParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setAssociateParam_inline",
                   "",
            ],
            [
                   "setTrajectoryParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setTrajectoryParam_inline",
                   "Sets the trajectory param.  @param trajectoryParam The Object of `WaypointTrajectoryTriggerParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the trajectory param.  @param trajectoryParam The Object of `WaypointTrajectoryTriggerParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setTrajectoryParam_inline",
                   "",
            ],
            [
                   "setReachPointParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setSimpleReachPointParam_inline",
                   "Sets the simple reach point param.  @param simpleReachPointParam The Object of `WaypointReachPointTriggerParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the simple reach point param.  @param simpleReachPointParam The Object of `WaypointReachPointTriggerParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setSimpleReachPointParam_inline",
                   "",
            ],
            [
                   "setIntervalTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setSimpleIntervalTriggerParam_inline",
                   "Sets the simple interval trigger param.  @param intervalTriggerParam The Object of `WaypointIntervalTriggerParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the simple interval trigger param.  @param intervalTriggerParam The Object of `WaypointIntervalTriggerParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_setSimpleIntervalTriggerParam_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_build_inline",
                   "Create an object of `WaypointTrigger`.  @return The build of `WaypointTrigger`.",
            ],
            [
                   "Create an object of `WaypointTrigger`.  @return The build of `WaypointTrigger`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Trigger_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Trigger_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointIntervalTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "",
                   "This class defines `TRAJECTORY`. This class only support the parameters of `WaypointCameraActuatorParam`.  You can add multiple actions to the trigger, For example, if you want to add actions for camera to take photo and record video, you should add action with `WaypointV2AssociateTriggerParam`, and set the associated action ID with another action,  the `getAssociateType` should be `AFTER_FINISHED`.",
            ],
            [
                   "This class defines `TRAJECTORY`. This class only support the parameters of `WaypointCameraActuatorParam`.  You can add multiple actions to the trigger, For example, if you want to add actions for camera to take photo and record video, you should add action with `WaypointV2AssociateTriggerParam`, and set the associated action ID with another action,  the `getAssociateType` should be `AFTER_FINISHED`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "",
                   "",
            ],
            [
                   "getStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_startIndex_inline",
                   "It determines the index of the waypoint at which the trigger starts.  @return An int value of start index.",
            ],
            [
                   "It determines the index of the waypoint at which the trigger starts.  @return An int value of start index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_startIndex_inline",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_actionIntervalType_inline",
                   "The type of interval trigger. See `ActionIntervalType`.  @return An enum value of `ActionIntervalType`.",
            ],
            [
                   "The type of interval trigger. See `ActionIntervalType`.  @return An enum value of `ActionIntervalType`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_actionIntervalType_inline",
                   "",
            ],
            [
                   "getInterval",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_interval_inline",
                   "If the `getType`  is `TIME` The time interval in seconds  when two action are executed as the aircraft moves from the current waypoint to the next waypoint. If the `getType`  is `DISTANCE` The distance interval in meters  when two action are executed as the aircraft moves from the current waypoint to the next waypoint.  @return A float value of the interval.",
            ],
            [
                   "If the `getType`  is `TIME` The time interval in seconds  when two action are executed as the aircraft moves from the current waypoint to the next waypoint. If the `getType`  is `DISTANCE` The distance interval in meters  when two action are executed as the aircraft moves from the current waypoint to the next waypoint.  @return A float value of the interval.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_interval_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointIntervalTriggerParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointIntervalTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setStartIndex_inline",
                   "Sets the waypoint index to start.  @param startIndex The start index of waypoint.  @return The build of `Builder`.",
            ],
            [
                   "Sets the waypoint index to start.  @param startIndex The start index of waypoint.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setStartIndex_inline",
                   "",
            ],
            [
                   "setType",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setType_inline",
                   "Sets the waypoint action trigger type.  @param type The enum value of `ActionTriggerType`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the waypoint action trigger type.  @param type The enum value of `ActionTriggerType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setType_inline",
                   "",
            ],
            [
                   "setInterval",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setInterval_inline",
                   "Sets the interval.  @param interval A float value of interval.  @return The build of `Builder`.",
            ],
            [
                   "Sets the interval.  @param interval A float value of interval.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_setInterval_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointIntervalTriggerParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointIntervalTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2IntervalTriggerParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointTrajectoryTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "",
                   "This class represents a trajectory trigger action when should be trigger. This trigger only supported `WaypointGimbalActuatorParam`.",
            ],
            [
                   "This class represents a trajectory trigger action when should be trigger. This trigger only supported `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "",
                   "",
            ],
            [
                   "getStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_startIndex_inline",
                   "It determines the index of the waypoint at which the trigger starts.  @return An int value of start index.",
            ],
            [
                   "It determines the index of the waypoint at which the trigger starts.  @return An int value of start index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_startIndex_inline",
                   "",
            ],
            [
                   "getEndIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_endIndex_inline",
                   "It determines the waypoint when the trigger stops.  @return An int value of end index.",
            ],
            [
                   "It determines the waypoint when the trigger stops.  @return An int value of end index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_endIndex_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "",
                   "It determines the index of the waypoint at which the trigger starts.",
            ],
            [
                   "It determines the index of the waypoint at which the trigger starts.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_setStartIndex_inline",
                   "Sets the start index.  @param startIndex An int value of start index.  @return The build of `Builder`.",
            ],
            [
                   "Sets the start index.  @param startIndex An int value of start index.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_setStartIndex_inline",
                   "",
            ],
            [
                   "setEndIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_setEndIndex_inline",
                   "Sets the end index.  @param endIndex An int value of end index.  @return The build of `Builder`.",
            ],
            [
                   "Sets the end index.  @param endIndex An int value of end index.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_setEndIndex_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointTrajectoryTriggerParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointTrajectoryTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2TrajectoryTriggerParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointV2AssociateTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "",
                   "This class defines `ASSOCIATE`.",
            ],
            [
                   "This class defines `ASSOCIATE`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "",
                   "",
            ],
            [
                   "getAssociateActionId",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_actionIdAssociated_inline",
                   "Associated action ID.  @return An int value of associate action id.",
            ],
            [
                   "Associated action ID.  @return An int value of associate action id.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_actionIdAssociated_inline",
                   "",
            ],
            [
                   "getAssociateType",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_actionAssociatedType_inline",
                   "The type of assciate trigger.  @return An object of `ActionTypes`.",
            ],
            [
                   "The type of assciate trigger.  @return An object of `ActionTypes`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_actionAssociatedType_inline",
                   "",
            ],
            [
                   "getWaitingTime",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_waitingTime_inline",
                   "Waiting time in seconds after ActionTrigger starts.  @return A float value of waiting time.",
            ],
            [
                   "Waiting time in seconds after ActionTrigger starts.  @return A float value of waiting time.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_waitingTime_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointV2AssociateTriggerParam`.",
            ],
            [
                   "The class is used to create the instance of `WaypointV2AssociateTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setAssociateType",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setAssociateType_inline",
                   "Sets the AssociateType of the trigger. The AssociateType determines the time and the way to trigger the action  to execute.  @param associateType An enum value of `AssociatedTimingType`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the AssociateType of the trigger. The AssociateType determines the time and the way to trigger the action  to execute.  @param associateType An enum value of `AssociatedTimingType`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setAssociateType_inline",
                   "",
            ],
            [
                   "setWaitingTime",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setWaitingTime_inline",
                   "Sets the waiting time.  @param waitingTimeInSec A float value of the waiting time in sec.  @return The build of `Builder`.",
            ],
            [
                   "Sets the waiting time.  @param waitingTimeInSec A float value of the waiting time in sec.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setWaitingTime_inline",
                   "",
            ],
            [
                   "setAssociateActionID",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setAssociateActionID_inline",
                   "Sets the action id the trigger associated with.  @param associateActionID An int value of the associate action ID.  @return The build of `Builder`.",
            ],
            [
                   "Sets the action id the trigger associated with.  @param associateActionID An int value of the associate action ID.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_setAssociateActionID_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_build_inline",
                   "Generate the immutable class.  @return The build of `WaypointV2AssociateTriggerParam`.",
            ],
            [
                   "Generate the immutable class.  @return The build of `WaypointV2AssociateTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2AssociateTriggerParam_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointReachPointTriggerParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "",
                   "This class defines `REACH_POINT`. It describes  an action will be triggered when the aircraft reach the certain waypoint. We suggest you use `WaypointAircraftControlStartStopFlyParam`  to stop flying before the action you want to excute. After the action is completed, you should use `WaypointAircraftControlStartStopFlyParam` to start flying.",
            ],
            [
                   "This class defines `REACH_POINT`. It describes  an action will be triggered when the aircraft reach the certain waypoint. We suggest you use `WaypointAircraftControlStartStopFlyParam`  to stop flying before the action you want to excute. After the action is completed, you should use `WaypointAircraftControlStartStopFlyParam` to start flying.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "",
                   "",
            ],
            [
                   "getStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_startIndex_inline",
                   "It determines the index of the waypoint at which the action will be triggered.  @return An int value of the waypoint start index.",
            ],
            [
                   "It determines the index of the waypoint at which the action will be triggered.  @return An int value of the waypoint start index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_startIndex_inline",
                   "",
            ],
            [
                   "getAutoTerminateCount",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_waypointCountToTerminate_inline",
                   "It determines the waypoint count till the action triggered stops.  @return An int value of auto terminate count.",
            ],
            [
                   "It determines the waypoint count till the action triggered stops.  @return An int value of auto terminate count.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_waypointCountToTerminate_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "",
                   "This class is used to create the object for `WaypointReachPointTriggerParam`.",
            ],
            [
                   "This class is used to create the object for `WaypointReachPointTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "",
                   "",
            ],
            [
                   "setStartIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_setStartIndex_inline",
                   "Sets the start index.  @param startIndex An int value of start index.  @return The build of `Builder`.",
            ],
            [
                   "Sets the start index.  @param startIndex An int value of start index.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_setStartIndex_inline",
                   "",
            ],
            [
                   "setAutoTerminateCount",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_setAutoTerminateCount_inline",
                   "Sets the auto terminate count.  @param autoTerminateCount An int value of auto terminate count.  @return The build of `Builder`.",
            ],
            [
                   "Sets the auto terminate count.  @param autoTerminateCount An int value of auto terminate count.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_setAutoTerminateCount_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_build_inline",
                   "Generates the immutable object.  @return The build of `WaypointReachPointTriggerParam`.",
            ],
            [
                   "Generates the immutable object.  @return The build of `WaypointReachPointTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder.html",
                   "#DJIWaypointV2Trigger_DJIWaypointV2ReachPointTriggerParam_Builder_build_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "",
                   "The class is used to create the instance of `WaypointActuator`.",
            ],
            [
                   "The class is used to create the instance of `WaypointActuator`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "",
                   "",
            ],
            [
                   "setActuatorType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setActuatorType_inline",
                   "Sets the `DJIWaypointV2Action_DJIWaypointV2Actuator_type`.  @param actuatorType The value of missionID to set.  @return The build of `Builder`.",
            ],
            [
                   "Sets the `DJIWaypointV2Action_DJIWaypointV2Actuator_type`.  @param actuatorType The value of missionID to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setActuatorType_inline",
                   "",
            ],
            [
                   "setCameraActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setCameraActuatorParam_inline",
                   "Sets the camera actuator param, it's only valid when `ActionActuatorType` is `CAMERA`.  @param cameraActuatorParam The object of `WaypointCameraActuatorParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the camera actuator param, it's only valid when `ActionActuatorType` is `CAMERA`.  @param cameraActuatorParam The object of `WaypointCameraActuatorParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setCameraActuatorParam_inline",
                   "",
            ],
            [
                   "setGimbalActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setGimbalActuatorParam_inline",
                   "Sets the gimbal actuator param, it's only valid when `ActionActuatorType` is `GIMBAL`.  @param gimbalActuatorParam The object of `WaypointGimbalActuatorParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the gimbal actuator param, it's only valid when `ActionActuatorType` is `GIMBAL`.  @param gimbalActuatorParam The object of `WaypointGimbalActuatorParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setGimbalActuatorParam_inline",
                   "",
            ],
            [
                   "setAircraftControlActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setAircraftControlActuatorParam_inline",
                   "Sets the aircraft actuator param, it's only valid when `ActionActuatorType` is `AIRCRAFT_CONTROL`.  @param aircraftControlActuatorParam The object of `WaypointAircraftControlParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the aircraft actuator param, it's only valid when `ActionActuatorType` is `AIRCRAFT_CONTROL`.  @param aircraftControlActuatorParam The object of `WaypointAircraftControlParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setAircraftControlActuatorParam_inline",
                   "",
            ],
            [
                   "setLidarActuatorParam",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setLidarActuatorParam_inline",
                   "Sets the lidar param, it's only valid when `ActionActuatorType` is `LIDAR`.  @param lidarActuatorParam The object of `WaypointLidarActuatorParam`.  @return The build of `Builder`.",
            ],
            [
                   "Sets the lidar param, it's only valid when `ActionActuatorType` is `LIDAR`.  @param lidarActuatorParam The object of `WaypointLidarActuatorParam`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setLidarActuatorParam_inline",
                   "",
            ],
            [
                   "setActuatorIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setActuatorIndex_inline",
                   "Sets the `DJIWaypointV2Action_DJIWaypointV2Actuator_actuatorIndex`.  @param index The actuator index.  @return The build of `Builder`.",
            ],
            [
                   "Sets the `DJIWaypointV2Action_DJIWaypointV2Actuator_actuatorIndex`.  @param index The actuator index.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_setActuatorIndex_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_build_inline",
                   "Generates the immutable class.  @return The object of `WaypointActuator`.",
            ],
            [
                   "Generates the immutable class.  @return The object of `WaypointActuator`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_DJIWaypointV2Actuator_Builder.html",
                   "#DJIWaypointV2Action_DJIWaypointV2Actuator_Builder_build_inline",
                   "",
            ],
            [
                   "ActionDownloadProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "",
                   "The download progress of the actions operator.",
            ],
            [
                   "The download progress of the actions operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "",
                   "",
            ],
            [
                   "getLastDownloadedActionIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "#DJIWaypointV2ActionDownloadProgressInterface_getLastDownloadedActionIndex_inline",
                   "The last index of downloaded action. Information for action is downloaded in ascending order. If no action has been downloaded, the value should be -1.  @return An int value of download action index.",
            ],
            [
                   "The last index of downloaded action. Information for action is downloaded in ascending order. If no action has been downloaded, the value should be -1.  @return An int value of download action index.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "#DJIWaypointV2ActionDownloadProgressInterface_getLastDownloadedActionIndex_inline",
                   "",
            ],
            [
                   "getTotalActionCount",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "#DJIWaypointV2ActionDownloadProgressInterface_getTotalActionCount_inline",
                   "The total count of actions in the waypoint mission.  @return An int value of total action count.",
            ],
            [
                   "The total count of actions in the waypoint mission.  @return An int value of total action count.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionDownloadProgressInterface.html",
                   "#DJIWaypointV2ActionDownloadProgressInterface_getTotalActionCount_inline",
                   "",
            ],
            [
                   "ActionExecutionProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "",
                   "The mission action execution progress of the waypoint mission operator.",
            ],
            [
                   "The mission action execution progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "",
                   "",
            ],
            [
                   "getExecutionActionID",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "#DJIWaypointV2ActionExecutionProgressInterface_getExecutionActionID_inline",
                   "The ID of Action.  @return An int value of the execution action index.",
            ],
            [
                   "The ID of Action.  @return An int value of the execution action index.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "#DJIWaypointV2ActionExecutionProgressInterface_getExecutionActionID_inline",
                   "",
            ],
            [
                   "isSuccess",
                   2,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "#DJIWaypointV2ActionExecutionProgressInterface_isSuccess_inline",
                   "The execution result of action.  @return A boolean value of the execution result of action.",
            ],
            [
                   "The execution result of action.  @return A boolean value of the execution result of action.",
                   1,
                   "/Components/Missions/DJIWaypointV2ActionExecutionProgressInterface.html",
                   "#DJIWaypointV2ActionExecutionProgressInterface_isSuccess_inline",
                   "",
            ],
            [
                   "target",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_imageLocationToCalculateDirection_inline",
                   "The image point from the video feed where the vision system should calculate the flight direction from. The image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
            ],
            [
                   "The image point from the video feed where the vision system should calculate the flight direction from. The image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_imageLocationToCalculateDirection_inline",
                   "",
            ],
            [
                   "tapFlyMode",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_tapFlyMode_inline",
                   "TapFly Mission mode. Defaults to `FORWARD`.  Additional modes only supported by the Phantom 4 Pro.",
            ],
            [
                   "TapFly Mission mode. Defaults to `FORWARD`.  Additional modes only supported by the Phantom 4 Pro.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_tapFlyMode_inline",
                   "",
            ],
            [
                   "isHorizontalObstacleAvoidanceEnabled",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_isHorizontalObstacleAvoidanceEnabled_inline",
                   "`true` to enable horizontal obstacle avoidance.",
            ],
            [
                   "`true` to enable horizontal obstacle avoidance.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_isHorizontalObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "speed",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_speed_inline",
                   "Speed in m/s during tap fly mission.",
            ],
            [
                   "Speed in m/s during tap fly mission.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_speed_inline",
                   "",
            ],
            [
                   "TapFlyExecutionState",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "",
                   "This class provides the detailed state of a TapFly Mission that is executing.",
            ],
            [
                   "This class provides the detailed state of a TapFly Mission that is executing.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "",
                   "",
            ],
            [
                   "getDirection",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_direction_inline",
                   "The direction vector the aircraft is travelling in using the N-E-D  (North-East- Down) coordinate system.  @return A Vector object.",
            ],
            [
                   "The direction vector the aircraft is travelling in using the N-E-D  (North-East- Down) coordinate system.  @return A Vector object.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_direction_inline",
                   "",
            ],
            [
                   "getImageLocation",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_imageLocation_inline",
                   "The image point from the video feed where the vision system should calculate the flight direction from. The image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.  @return A PointF object.",
            ],
            [
                   "The image point from the video feed where the vision system should calculate the flight direction from. The image point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.  @return A PointF object.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_imageLocation_inline",
                   "",
            ],
            [
                   "getSpeed",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_speed_inline",
                   "The real-time speed of the aircraft in m/s.  @return A float value of speed.",
            ],
            [
                   "The real-time speed of the aircraft in m/s.  @return A float value of speed.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_speed_inline",
                   "",
            ],
            [
                   "getBypassDirection",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_bypassDirection_inline",
                   "The direction the aircraft is moving around or bypassing an obstacle in. Will be `NONE` if the aircraft is not executing  an avoidance maneuver.  @return An enum value of `BypassDirection`",
            ],
            [
                   "The direction the aircraft is moving around or bypassing an obstacle in. Will be `NONE` if the aircraft is not executing  an avoidance maneuver.  @return An enum value of `BypassDirection`",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_bypassDirection_inline",
                   "",
            ],
            [
                   "getRelativeHeading",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_relativeHeading_inline",
                   "Aircraft's heading relative to the flight direction.  @return A float value of relative heading.",
            ],
            [
                   "Aircraft's heading relative to the flight direction.  @return A float value of relative heading.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJITapFlyExecutionState.html",
                   "#DJITapFlyMission_DJITapFlyExecutionState_relativeHeading_inline",
                   "",
            ],
            [
                   "Vector",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "",
                   "A cartesian vector in 3D space.",
            ],
            [
                   "A cartesian vector in 3D space.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "",
                   "",
            ],
            [
                   "getX",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_x_inline",
                   "X-value of the cartesian vector.  @return A float value of X value.",
            ],
            [
                   "X-value of the cartesian vector.  @return A float value of X value.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_x_inline",
                   "",
            ],
            [
                   "getY",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_y_inline",
                   "Y-value of the cartesian vector.  @return A float value of Y value.",
            ],
            [
                   "Y-value of the cartesian vector.  @return A float value of Y value.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_y_inline",
                   "",
            ],
            [
                   "getZ",
                   2,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_z_inline",
                   "Z-value of the cartesian vector.  @return A float value of Z value.",
            ],
            [
                   "Z-value of the cartesian vector.  @return A float value of Z value.",
                   1,
                   "/Components/Missions/DJITapFlyMission_DJIVector.html",
                   "#DJITapFlyMission_DJIVector_z_inline",
                   "",
            ],
            [
                   "BypassDirection",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_inline",
                   "Direction aircraft is moving around or bypassing an obstacle in.",
            ],
            [
                   "Direction aircraft is moving around or bypassing an obstacle in.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_None_inline",
                   "Flying normally, no obstacle to be avoided.",
            ],
            [
                   "Flying normally, no obstacle to be avoided.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_None_inline",
                   "",
            ],
            [
                   "OVER",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Over_inline",
                   "Avoiding the obstacle by going over the top of it.",
            ],
            [
                   "Avoiding the obstacle by going over the top of it.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Over_inline",
                   "",
            ],
            [
                   "LEFT",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Left_inline",
                   "Avoiding the obstacle by going to the left of it.",
            ],
            [
                   "Avoiding the obstacle by going to the left of it.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Left_inline",
                   "",
            ],
            [
                   "RIGHT",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Right_inline",
                   "Avoiding the obstacle by going to the right of it.",
            ],
            [
                   "Avoiding the obstacle by going to the right of it.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Right_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Unknown_inline",
                   "Unknown obstacle avoidance direction",
            ],
            [
                   "Unknown obstacle avoidance direction",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJIBypassDirection_Unknown_inline",
                   "",
            ],
            [
                   "TapFlyMode",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_inline",
                   "Different modes of the TapFly Mission. Defaults to  `FORWARD`, set to others to enable  the feature.",
            ],
            [
                   "Different modes of the TapFly Mission. Defaults to  `FORWARD`, set to others to enable  the feature.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_inline",
                   "",
            ],
            [
                   "FORWARD",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Forward_inline",
                   "Aircraft will fly towards the target. Forward Obstacle  Sensing System is active.",
            ],
            [
                   "Aircraft will fly towards the target. Forward Obstacle  Sensing System is active.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Forward_inline",
                   "",
            ],
            [
                   "BACKWARD",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Backward_inline",
                   "Aircraft will fly in the opposite direction from the target.  Backward Obstacle Sensing System is active.",
            ],
            [
                   "Aircraft will fly in the opposite direction from the target.  Backward Obstacle Sensing System is active.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Backward_inline",
                   "",
            ],
            [
                   "FREE",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Free_inline",
                   "Aircraft will fly towards the target. User can control the heading  by remote controller's stick. Obstacle Sensing Systems may fail to  work when aircraft is flying sideward.",
            ],
            [
                   "Aircraft will fly towards the target. User can control the heading  by remote controller's stick. Obstacle Sensing Systems may fail to  work when aircraft is flying sideward.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Free_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Unknown_inline",
                   "The TapFly mode is unknown.",
            ],
            [
                   "The TapFly mode is unknown.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "#DJITapFlyMission_DJITapFlyMode_Unknown_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "",
                   "Class builder.",
            ],
            [
                   "Class builder.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "",
                   "",
            ],
            [
                   "checkParameters",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_checkParameters_inline",
                   "Checks if the configuration for the mission is valid before loading it into `WaypointMissionOperator`.  @return Error found when checking parameters of the waypoint. `null` if all the parameters are valid.",
            ],
            [
                   "Checks if the configuration for the mission is valid before loading it into `WaypointMissionOperator`.  @return Error found when checking parameters of the waypoint. `null` if all the parameters are valid.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_checkParameters_inline",
                   "",
            ],
            [
                   "getWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_waypointCount_inline",
                   "Number of waypoints in the waypoint mission.  @return Waypoint count.",
            ],
            [
                   "Number of waypoints in the waypoint mission.  @return Waypoint count.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_waypointCount_inline",
                   "",
            ],
            [
                   "getMissionID",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_getMissionID_inline",
                   "Get the mission id.  @return Mission ID.",
            ],
            [
                   "Get the mission id.  @return Mission ID.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_getMissionID_inline",
                   "",
            ],
            [
                   "getWaypointList",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_allWaypoints_inline",
                   "Returns an list of all waypoints in the mission.  @return A List of `Waypoint` instances contained in the mission.",
            ],
            [
                   "Returns an list of all waypoints in the mission.  @return A List of `Waypoint` instances contained in the mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_allWaypoints_inline",
                   "",
            ],
            [
                   "getMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_maxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return Flight speed in m/s",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return Flight speed in m/s",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_maxFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_autoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return Flight speed in m/s",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return Flight speed in m/s",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_autoFlightSpeed_inline",
                   "",
            ],
            [
                   "getGotoFirstWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_gotoFirstWaypointMode_inline",
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return The behavior of the aircraft at the begining of the mission",
            ],
            [
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return The behavior of the aircraft at the begining of the mission",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_gotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "getFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_finishedAction_inline",
                   "Action the aircraft will take when the waypoint mission is complete.  @return The action to execute when the waypoint mission finishes",
            ],
            [
                   "Action the aircraft will take when the waypoint mission is complete.  @return The action to execute when the waypoint mission finishes",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_finishedAction_inline",
                   "",
            ],
            [
                   "getHeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_headingMode_inline",
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @return Heading mode.",
            ],
            [
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @return Heading mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_headingMode_inline",
                   "",
            ],
            [
                   "getPointOfInterest",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_pointOfInterest_inline",
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @return Point of interest location.",
            ],
            [
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @return Point of interest location.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_pointOfInterest_inline",
                   "",
            ],
            [
                   "getFlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_flightPathMode_inline",
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return The flight path mode.",
            ],
            [
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return The flight path mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_flightPathMode_inline",
                   "",
            ],
            [
                   "isExitMissionOnRCSignalLostEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_exitMissionOnRCSignalLost_inline",
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @return `true` if mission should stop when connection is lost.",
            ],
            [
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @return `true` if mission should stop when connection is lost.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_exitMissionOnRCSignalLost_inline",
                   "",
            ],
            [
                   "isGimbalPitchRotationEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_rotateGimbalPitch_inline",
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
            ],
            [
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_rotateGimbalPitch_inline",
                   "",
            ],
            [
                   "getRepeatTimes",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_repeatTimes_inline",
                   "Gets the repeat times of the mission.  @return Number of times to repeat mission",
            ],
            [
                   "Gets the repeat times of the mission.  @return Number of times to repeat mission",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_repeatTimes_inline",
                   "",
            ],
            [
                   "Waypoint",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "",
                   "The class represents a target point in the waypoint mission. For a waypoint mission, a flight route  consists of multiple `Waypoint` objects. The user can also define the actions to perform for  each `Waypoint`.",
            ],
            [
                   "The class represents a target point in the waypoint mission. For a waypoint mission, a flight route  consists of multiple `Waypoint` objects. The user can also define the actions to perform for  each `Waypoint`.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "",
                   "",
            ],
            [
                   "WaypointMissionFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_inline",
                   "Actions taken when the waypoint mission has finished.",
            ],
            [
                   "Actions taken when the waypoint mission has finished.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_inline",
                   "",
            ],
            [
                   "WaypointMissionHeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_inline",
                   "Current waypoint mission heading mode.",
            ],
            [
                   "Current waypoint mission heading mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_inline",
                   "",
            ],
            [
                   "WaypointMissionFlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_inline",
                   "Waypoint mission flight path mode.",
            ],
            [
                   "Waypoint mission flight path mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_inline",
                   "",
            ],
            [
                   "WaypointMissionGotoWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_inline",
                   "This enum will determine the goto point mode while the drone executes the flight.",
            ],
            [
                   "This enum will determine the goto point mode while the drone executes the flight.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_inline",
                   "",
            ],
            [
                   "WaypointMissionInterruption",
                   2,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointMissionInterruption.html",
                   "",
                   "The class provides information of the latest interrupted waypoint mission.",
            ],
            [
                   "The class provides information of the latest interrupted waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission_DJIWaypointMissionInterruption.html",
                   "",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_Auto_inline",
                   "Default constructor of waypoint mission with 0 waypoints.",
            ],
            [
                   "Default constructor of waypoint mission with 0 waypoints.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_Auto_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_WaypointMission_inline",
                   "Waypoint mission constructor that clones this waypoint mission from another.  @param waypointMissionToClone Waypoint mission to clone",
            ],
            [
                   "Waypoint mission constructor that clones this waypoint mission from another.  @param waypointMissionToClone Waypoint mission to clone",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_WaypointMission_inline",
                   "",
            ],
            [
                   "addWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_addWaypoint_inline",
                   "Add a waypoint to the waypoint mission.  @param waypoint Waypoint to add.  @return A `Builder` object",
            ],
            [
                   "Add a waypoint to the waypoint mission.  @param waypoint Waypoint to add.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_addWaypoint_inline",
                   "",
            ],
            [
                   "removeWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_removeWaypoint_inline",
                   "Remove a waypoint from the waypoint mission.  @param waypoint Waypoint to remove.  @return A `Builder` object",
            ],
            [
                   "Remove a waypoint from the waypoint mission.  @param waypoint Waypoint to remove.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_removeWaypoint_inline",
                   "",
            ],
            [
                   "removeWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_removeWaypointWithIndex_inline",
                   "Remove a waypoint by index from the waypoint mission.  @param index Index of waypoint to remove.  @return A `Builder` object",
            ],
            [
                   "Remove a waypoint by index from the waypoint mission.  @param index Index of waypoint to remove.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_removeWaypointWithIndex_inline",
                   "",
            ],
            [
                   "waypointList",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_waypointList_inline",
                   "List of waypoints that will define this mission  @param waypointList List of waypoints  @return A `Builder` object",
            ],
            [
                   "List of waypoints that will define this mission  @param waypointList List of waypoints  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_waypointList_inline",
                   "",
            ],
            [
                   "getWaypointList",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getWaypointList_inline",
                   "List of waypoints that will define this mission  @return List of waypoints",
            ],
            [
                   "List of waypoints that will define this mission  @return List of waypoints",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getWaypointList_inline",
                   "",
            ],
            [
                   "getMissionID",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getMissionID_inline",
                   "Get mission id.  @return Mission id.",
            ],
            [
                   "Get mission id.  @return Mission id.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getMissionID_inline",
                   "",
            ],
            [
                   "setMissionID",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setMissionID_inline",
                   "Set mission id.  @param id The id of mission. The valid range is [0, 65535].  @return A `Builder` object.",
            ],
            [
                   "Set mission id.  @param id The id of mission. The valid range is [0, 65535].  @return A `Builder` object.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setMissionID_inline",
                   "",
            ],
            [
                   "calculateTotalDistance",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_calculateTotalDistance_inline",
                   "Calculate the total distance of the waypoint list.  @return The total distance of the waypoint list.",
            ],
            [
                   "Calculate the total distance of the waypoint list.  @return The total distance of the waypoint list.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_calculateTotalDistance_inline",
                   "",
            ],
            [
                   "calculateTotalTime",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_calculateTotalTime_inline",
                   "Calculate the total time of the waypoint list.  @return The total time of the waypoint list.",
            ],
            [
                   "Calculate the total time of the waypoint list.  @return The total time of the waypoint list.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_calculateTotalTime_inline",
                   "",
            ],
            [
                   "getLastCalculatedTotalDistance",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getLastCalculatedTotalDistance_inline",
                   "Get the last calculated total distance of the waypoint list.  @return The last calculated total distance of the waypoint list.",
            ],
            [
                   "Get the last calculated total distance of the waypoint list.  @return The last calculated total distance of the waypoint list.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getLastCalculatedTotalDistance_inline",
                   "",
            ],
            [
                   "getLastCalculatedTotalTime",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getLastCalculatedTotalTime_inline",
                   "Get the last calculated total time of the waypoint list.  @return The last calculated total time of the waypoint list.",
            ],
            [
                   "Get the last calculated total time of the waypoint list.  @return The last calculated total time of the waypoint list.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getLastCalculatedTotalTime_inline",
                   "",
            ],
            [
                   "insertWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_insertWaypoint_inline",
                   "Insert a waypoint to the waypoint mission.  @param waypoint Waypoint to insert. @param index index to insert the waypoint.  @return A `Builder` object",
            ],
            [
                   "Insert a waypoint to the waypoint mission.  @param waypoint Waypoint to insert. @param index index to insert the waypoint.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_insertWaypoint_inline",
                   "",
            ],
            [
                   "waypointCount",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_waypointCount_inline",
                   "Number of waypoints in the waypoint mission. This must be set to the correct number of waypoints added to the mission.  @param waypointCount Waypoint count.  @return A `Builder` object",
            ],
            [
                   "Number of waypoints in the waypoint mission. This must be set to the correct number of waypoints added to the mission.  @param waypointCount Waypoint count.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_waypointCount_inline",
                   "",
            ],
            [
                   "getWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getWaypointCount_inline",
                   "Number of waypoints in the waypoint mission.  @return Waypoint count.",
            ],
            [
                   "Number of waypoints in the waypoint mission.  @return Waypoint count.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getWaypointCount_inline",
                   "",
            ],
            [
                   "maxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_maxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @param maxFlightSpeed Flight speed in m/s  @return A `Builder` object",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @param maxFlightSpeed Flight speed in m/s  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_maxFlightSpeed_inline",
                   "",
            ],
            [
                   "getMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getMaxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return Flight speed in m/s",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return Flight speed in m/s",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "autoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_autoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoFlightSpeed Flight speed in m/s  @return A `Builder` object",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoFlightSpeed Flight speed in m/s  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_autoFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getAutoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return Flight speed in m/s",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The  aircraft's actual speed is a combination of the base automatic speed, and the speed control given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @return Flight speed in m/s",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "gotoFirstWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_gotoFirstWaypointMode_inline",
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @param gotoFirstWaypointMode Behavior prior to mission start.  @return A `Builder` object",
            ],
            [
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @param gotoFirstWaypointMode Behavior prior to mission start.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_gotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "getGotoFirstWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getGotoFirstWaypointMode_inline",
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return The behavior of the aircraft at the begining of the mission",
            ],
            [
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return The behavior of the aircraft at the begining of the mission",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getGotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "finishedAction",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_finishedAction_inline",
                   "Action the aircraft will take when the waypoint mission is complete.  @param finishedAction Behavior of aircraft when mission is complete.  @return A `Builder` object",
            ],
            [
                   "Action the aircraft will take when the waypoint mission is complete.  @param finishedAction Behavior of aircraft when mission is complete.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_finishedAction_inline",
                   "",
            ],
            [
                   "getFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getFinishedAction_inline",
                   "Action the aircraft will take when the waypoint mission is complete.  @return The action to execute when the waypoint mission finishes",
            ],
            [
                   "Action the aircraft will take when the waypoint mission is complete.  @return The action to execute when the waypoint mission finishes",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getFinishedAction_inline",
                   "",
            ],
            [
                   "headingMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_headingMode_inline",
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @param headingMode The heading mode.  @return A `Builder` object",
            ],
            [
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @param headingMode The heading mode.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_headingMode_inline",
                   "",
            ],
            [
                   "getHeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getHeadingMode_inline",
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @return Heading mode.",
            ],
            [
                   "Heading of the aircraft as it moves between waypoints. Default  is `AUTO`.  @return Heading mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getHeadingMode_inline",
                   "",
            ],
            [
                   "setPointOfInterest",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setPointOfInterest_inline",
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @param pointOfInterest Point of interest location.  @return A `Builder` object",
            ],
            [
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @param pointOfInterest Point of interest location.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setPointOfInterest_inline",
                   "",
            ],
            [
                   "getPointOfInterest",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getPointOfInterest_inline",
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @return Point of interest location.",
            ],
            [
                   "Aircraft heading will be fixed to the point of interest location during the waypoint mission. Used when `getHeadingMode`  is `TOWARD_POINT_OF_INTEREST`.  @return Point of interest location.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getPointOfInterest_inline",
                   "",
            ],
            [
                   "flightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_flightPathMode_inline",
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @param flightPathMode The flight path mode.  @return A `Builder` object",
            ],
            [
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @param flightPathMode The flight path mode.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_flightPathMode_inline",
                   "",
            ],
            [
                   "getFlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getFlightPathMode_inline",
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return The flight path mode.",
            ],
            [
                   "The path the aircraft follows between waypoints. The aircraft can either fly directly between waypoints in a straight line, or turn near a waypoint in the curve where the waypoint location defines a part of the curve.  @return The flight path mode.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getFlightPathMode_inline",
                   "",
            ],
            [
                   "setExitMissionOnRCSignalLostEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setExitMissionOnRCSignalLostEnabled_inline",
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @param enabled `true` if mission should stop when connection is lost.  @return A `Builder` object",
            ],
            [
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @param enabled `true` if mission should stop when connection is lost.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setExitMissionOnRCSignalLostEnabled_inline",
                   "",
            ],
            [
                   "isExitMissionOnRCSignalLostEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isExitMissionOnRCSignalLostEnabled_inline",
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @return `true` if mission should stop when connection is lost.",
            ],
            [
                   "Determines whether the mission should stop when connection between the  aircraft and remote controller is lost. Default is `false`.  @return `true` if mission should stop when connection is lost.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isExitMissionOnRCSignalLostEnabled_inline",
                   "",
            ],
            [
                   "setGimbalPitchRotationEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setGimbalPitchRotationEnabled_inline",
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @param gimbalPitchRotationEnabled `true` if gimbal pitch can be controlled.  @return A `Builder` object",
            ],
            [
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @param gimbalPitchRotationEnabled `true` if gimbal pitch can be controlled.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_setGimbalPitchRotationEnabled_inline",
                   "",
            ],
            [
                   "isGimbalPitchRotationEnabled",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isGimbalPitchRotationEnabled_inline",
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
            ],
            [
                   "`true` if the gimbal pitch rotation can be controlled during the waypoint mission. When `true`, `gimbalPitch` in `Waypoint` is used to control gimbal pitch.  @return `true` if gimbal pitch can be controlled.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isGimbalPitchRotationEnabled_inline",
                   "",
            ],
            [
                   "repeatTimes",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_repeatTimes_inline",
                   "Mission execution can be repeated more than once. The value range is [1, 255]. If 255 is selected,  then the mission will continue to be executed until `stopMission` is  called or any error occurs. Other values represent the exact execution times of the mission.  @param repeatTimes Number of times to repeat mission, the value should be larger than 0.  @return A `Builder` object",
            ],
            [
                   "Mission execution can be repeated more than once. The value range is [1, 255]. If 255 is selected,  then the mission will continue to be executed until `stopMission` is  called or any error occurs. Other values represent the exact execution times of the mission.  @param repeatTimes Number of times to repeat mission, the value should be larger than 0.  @return A `Builder` object",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_repeatTimes_inline",
                   "",
            ],
            [
                   "getRepeatTimes",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getRepeatTimes_inline",
                   "Gets the repeat times of the mission builder.  @return Number of times to repeat mission.",
            ],
            [
                   "Gets the repeat times of the mission builder.  @return Number of times to repeat mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_getRepeatTimes_inline",
                   "",
            ],
            [
                   "isMissionComplete",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isMissionComplete_inline",
                   "When downloading a waypoint mission, the number of waypoints in `getWaypointList` will be less than  `getWaypointCount` until the download is complete. This property is `true` when all the information in the waypoint mission is downloaded, and complete in this object.  @return `true` if mission information is complete.",
            ],
            [
                   "When downloading a waypoint mission, the number of waypoints in `getWaypointList` will be less than  `getWaypointCount` until the download is complete. This property is `true` when all the information in the waypoint mission is downloaded, and complete in this object.  @return `true` if mission information is complete.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_isMissionComplete_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_build_inline",
                   "Build the object into a `WaypointMission` object.  @return Waypoint mission.",
            ],
            [
                   "Build the object into a `WaypointMission` object.  @return Waypoint mission.",
                   1,
                   "/Components/Missions/DJIWaypointMission_Builder.html",
                   "#DJIWaypointMission_Builder_build_inline",
                   "",
            ],
            [
                   "NO_ACTION",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_NoAction_inline",
                   "No further action will be taken on completion of mission. At this point, the aircraft can be  controlled by the remote controller.",
            ],
            [
                   "No further action will be taken on completion of mission. At this point, the aircraft can be  controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_NoAction_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_GoHome_inline",
                   "The aircraft will go home when the mission is complete. If the aircraft is more than 20m away from  the home point it will go home and land. Otherwise, it will land directly at the current location.",
            ],
            [
                   "The aircraft will go home when the mission is complete. If the aircraft is more than 20m away from  the home point it will go home and land. Otherwise, it will land directly at the current location.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_GoHome_inline",
                   "",
            ],
            [
                   "AUTO_LAND",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_AutoLand_inline",
                   "The aircraft will land automatically at the last waypoint.",
            ],
            [
                   "The aircraft will land automatically at the last waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_AutoLand_inline",
                   "",
            ],
            [
                   "GO_FIRST_WAYPOINT",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_GoFirstWaypoint_inline",
                   "The aircraft will go back to its first waypoint and hover in position.",
            ],
            [
                   "The aircraft will go back to its first waypoint and hover in position.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_GoFirstWaypoint_inline",
                   "",
            ],
            [
                   "CONTINUE_UNTIL_END",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_ContinueUntilStop_inline",
                   "When the aircraft reaches its final waypoint, it will hover without ending the mission. The joystick  can still be used to pull the aircraft back along its previous waypoints. The only way this mission  can end is if stopMission is called.",
            ],
            [
                   "When the aircraft reaches its final waypoint, it will hover without ending the mission. The joystick  can still be used to pull the aircraft back along its previous waypoints. The only way this mission  can end is if stopMission is called.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFinishedAction_ContinueUntilStop_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_Auto_inline",
                   "Aircraft's heading will always be in the direction of flight.",
            ],
            [
                   "Aircraft's heading will always be in the direction of flight.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_Auto_inline",
                   "",
            ],
            [
                   "USING_INITIAL_DIRECTION",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_UsingInitialDirection_inline",
                   "Aircraft's heading will be set to the heading when reaching the first waypoint. Before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. When the aircraft  reaches the first waypoint, its heading will be fixed.",
            ],
            [
                   "Aircraft's heading will be set to the heading when reaching the first waypoint. Before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. When the aircraft  reaches the first waypoint, its heading will be fixed.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_UsingInitialDirection_inline",
                   "",
            ],
            [
                   "CONTROL_BY_REMOTE_CONTROLLER",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_ControledByRemoteController_inline",
                   "Aircraft's heading will be controlled by the remote controller.",
            ],
            [
                   "Aircraft's heading will be controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_ControledByRemoteController_inline",
                   "",
            ],
            [
                   "USING_WAYPOINT_HEADING",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_UsingWaypointHeading_inline",
                   "Aircraft will rotate its heading after the waypoint has been reached. You should use this interface `heading` to set aircraft heading.",
            ],
            [
                   "Aircraft will rotate its heading after the waypoint has been reached. You should use this interface `heading` to set aircraft heading.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_UsingWaypointHeading_inline",
                   "",
            ],
            [
                   "TOWARD_POINT_OF_INTEREST",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_TowardPointOfInterest_inline",
                   "After the first waypoint has been reached, aircraft heading will always toward to the point of interest.",
            ],
            [
                   "After the first waypoint has been reached, aircraft heading will always toward to the point of interest.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionHeadingMode_TowardPointOfInterest_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_Normal_inline",
                   "The flight path will be normal and the aircraft will move from one waypoint to the next in straight lines.",
            ],
            [
                   "The flight path will be normal and the aircraft will move from one waypoint to the next in straight lines.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_Normal_inline",
                   "",
            ],
            [
                   "CURVED",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_Curved_inline",
                   "The flight path will be curved and the aircraft will move from one waypoint to the next in a curved motion,  adhering to the `cornerRadiusInMeters`, which is set in `Waypoint`.",
            ],
            [
                   "The flight path will be curved and the aircraft will move from one waypoint to the next in a curved motion,  adhering to the `cornerRadiusInMeters`, which is set in `Waypoint`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionFlightPathMode_Curved_inline",
                   "",
            ],
            [
                   "SAFELY",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_Safely_inline",
                   "Go to the waypoint safely. The aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. It then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
            ],
            [
                   "Go to the waypoint safely. The aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. It then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_Safely_inline",
                   "",
            ],
            [
                   "POINT_TO_POINT",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_PointToPoint_inline",
                   "Go to the waypoint from the current aircraft point to the waypoint directly.",
            ],
            [
                   "Go to the waypoint from the current aircraft point to the waypoint directly.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionGotoWaypointMode_PointToPoint_inline",
                   "",
            ],
            [
                   "getCoordinate",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_coordinate_inline",
                   "The aircraft's coordinate when the mission is interrupted.  @return An object of `LocationCoordinate2D`.",
            ],
            [
                   "The aircraft's coordinate when the mission is interrupted.  @return An object of `LocationCoordinate2D`.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_coordinate_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_altitude_inline",
                   "The aircraft's altitude when the mission is interrupted. This value represents the  absolute height.  @return A float value of the waypoint altitude.",
            ],
            [
                   "The aircraft's altitude when the mission is interrupted. This value represents the  absolute height.  @return A float value of the waypoint altitude.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_altitude_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_index_inline",
                   "The waypoint index that aircraft latest reached when the mission is interrupted.  @return An int value of the waypoint index.",
            ],
            [
                   "The waypoint index that aircraft latest reached when the mission is interrupted.  @return An int value of the waypoint index.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_index_inline",
                   "",
            ],
            [
                   "getMissionID",
                   2,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_missionID_inline",
                   "MissionID of interrupted mission.  @return An int value of the MissionID.",
            ],
            [
                   "MissionID of interrupted mission.  @return An int value of the MissionID.",
                   1,
                   "/Components/Missions/DJIWaypointMission.html",
                   "#DJIWaypointMission_DJIWaypointMissionInterruption_missionID_inline",
                   "",
            ],
            [
                   "isComplete",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_isComplete_inline",
                   "When downloading a waypoint mission, the number of waypoints in `getWaypointList` will be  less than `getWaypointCount` until the download is complete. This property is `true` when all  the information in the waypoint mission is downloaded, and complete in this object.  @return A boolean value.",
            ],
            [
                   "When downloading a waypoint mission, the number of waypoints in `getWaypointList` will be  less than `getWaypointCount` until the download is complete. This property is `true` when all  the information in the waypoint mission is downloaded, and complete in this object.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_isComplete_inline",
                   "",
            ],
            [
                   "getMissionID",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_missionID_inline",
                   "The Mission ID.  @return A long value of Mission ID.",
            ],
            [
                   "The Mission ID.  @return A long value of Mission ID.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_missionID_inline",
                   "",
            ],
            [
                   "getWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_waypointCount_inline",
                   "Number of waypoints in the waypoint mission. Note there are some cases when the waypoint count will be different to the  waypoint array length from `getWaypointList`. This is usually the case when the waypoint  mission is still being downloaded  from the aircraft and the mission object hasn't  existed previously (e.g. when the mobile device is connected to an aircraft  with a previously uploaded mission). In these cases, `isComplete`  will return `true`.  @return An int value of waypoint count.",
            ],
            [
                   "Number of waypoints in the waypoint mission. Note there are some cases when the waypoint count will be different to the  waypoint array length from `getWaypointList`. This is usually the case when the waypoint  mission is still being downloaded  from the aircraft and the mission object hasn't  existed previously (e.g. when the mobile device is connected to an aircraft  with a previously uploaded mission). In these cases, `isComplete`  will return `true`.  @return An int value of waypoint count.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_waypointCount_inline",
                   "",
            ],
            [
                   "getMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_maxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed`  is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at  maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return A float value of max flight speed.",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed`  is this offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the aircraft  speed. If the remote controller stick is not at  maximum deflection, then the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the  first waypoint, it will then hover in place until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return A float value of max flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_maxFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_autoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed,  and the speed control given by the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint,  the aircraft will hover in place until the speed is made positive by the remote controller joystick.  @return A float value of auto flight speed.",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed,  and the speed control given by the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft is at the first waypoint,  the aircraft will hover in place until the speed is made positive by the remote controller joystick.  @return A float value of auto flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_autoFlightSpeed_inline",
                   "",
            ],
            [
                   "getFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_finishedAction_inline",
                   "Action the aircraft will take when the waypoint mission is complete.  @return A `MissionFinishedAction` enum value.",
            ],
            [
                   "Action the aircraft will take when the waypoint mission is complete.  @return A `MissionFinishedAction` enum value.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_finishedAction_inline",
                   "",
            ],
            [
                   "getGotoFirstWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_gotoFirstWaypointMode_inline",
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return A `MissionGotoWaypointMode` enum value.",
            ],
            [
                   "Defines how the aircraft will go to the first waypoint from its current position. Default  is `SAFELY`.  @return A `MissionGotoWaypointMode` enum value.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_gotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "isExitMissionOnRCSignalLostEnabled",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_exitMissionOnRCSignalLost_inline",
                   "Determines whether the mission should stop when connection between the aircraft and remote controller is lost. Default is `false`.  @return A boolean value.",
            ],
            [
                   "Determines whether the mission should stop when connection between the aircraft and remote controller is lost. Default is `false`.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_exitMissionOnRCSignalLost_inline",
                   "",
            ],
            [
                   "getRepeatTimes",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_repeatTimes_inline",
                   "Mission execution can be repeated more than once. A value of 0 means the mission only executes once, and does not repeat. A value of 1 means the  mission will execute a total of two times.  @return An int value of mission repeart times.",
            ],
            [
                   "Mission execution can be repeated more than once. A value of 0 means the mission only executes once, and does not repeat. A value of 1 means the  mission will execute a total of two times.  @return An int value of mission repeart times.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_repeatTimes_inline",
                   "",
            ],
            [
                   "getWaypointAtIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_getWaypointAtIndex_inline",
                   "Gets the waypoint at the specified index in the mission waypoint array.  @param index Index of the waypoint to be retrieved.  @return The `WaypointV2` at the specified index.",
            ],
            [
                   "Gets the waypoint at the specified index in the mission waypoint array.  @param index Index of the waypoint to be retrieved.  @return The `WaypointV2` at the specified index.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_getWaypointAtIndex_inline",
                   "",
            ],
            [
                   "getWaypointList",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_allWaypoints_inline",
                   "Returns an array of all waypoints in the mission.  @return An array of `WaypointV2` instances contained in the mission.",
            ],
            [
                   "Returns an array of all waypoints in the mission.  @return An array of `WaypointV2` instances contained in the mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_allWaypoints_inline",
                   "",
            ],
            [
                   "WaypointV2",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "",
                   "The class represents a target point in the waypoint mission. For a waypoint mission, a flight route consists of multiple `WaypointV2` objects.",
            ],
            [
                   "The class represents a target point in the waypoint mission. For a waypoint mission, a flight route consists of multiple `WaypointV2` objects.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "",
                   "",
            ],
            [
                   "getCoordinate",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_coordinate_inline",
                   "Waypoint coordinate latitude and longitude in degrees.  @return An object of `LocationCoordinate2D`.",
            ],
            [
                   "Waypoint coordinate latitude and longitude in degrees.  @return An object of `LocationCoordinate2D`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_coordinate_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_altitude_inline",
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a  range of [-200,500], and should not be larger than the aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude  will gradually change as the aircraft flies between waypoints.  @return A double type value of the aircraft altitude.",
            ],
            [
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a  range of [-200,500], and should not be larger than the aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude  will gradually change as the aircraft flies between waypoints.  @return A double type value of the aircraft altitude.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_altitude_inline",
                   "",
            ],
            [
                   "getPointOfInterest",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_pointOfInterest_inline",
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. Aircraft will always be heading to  point while executing mission. Default is kCLLocationCoordinate2DInvalid.  @return An object of `LocationCoordinate2D`.",
            ],
            [
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. Aircraft will always be heading to  point while executing mission. Default is kCLLocationCoordinate2DInvalid.  @return An object of `LocationCoordinate2D`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_pointOfInterest_inline",
                   "",
            ],
            [
                   "getPointOfInterestAltitude",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_pointOfInterestAltitude_inline",
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. The altitude of the aircraft is relative  to the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude.  @return The value of the point of interest altitude.",
            ],
            [
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. The altitude of the aircraft is relative  to the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude.  @return The value of the point of interest altitude.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_pointOfInterestAltitude_inline",
                   "",
            ],
            [
                   "getFlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_flightPathMode_inline",
                   "Flight path mode waypoint of the aircraft as it moves between waypoints. Default is `GOTO_POINT_CURVE_AND_STOP`.  @return An enum value of `WaypointV2FlightPathMode`.",
            ],
            [
                   "Flight path mode waypoint of the aircraft as it moves between waypoints. Default is `GOTO_POINT_CURVE_AND_STOP`.  @return An enum value of `WaypointV2FlightPathMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_flightPathMode_inline",
                   "",
            ],
            [
                   "getHeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_headingMode_inline",
                   "Heading of the aircraft as it moves between waypoints. Default is `AUTO`.  @return An enum value of `WaypointV2HeadingMode`.",
            ],
            [
                   "Heading of the aircraft as it moves between waypoints. Default is `AUTO`.  @return An enum value of `WaypointV2HeadingMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_headingMode_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_heading_inline",
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading  will gradually change between two waypoints with different headings if the waypoint mission's `WaypointV2HeadingMode` is set to `WAYPOINT_CUSTOM`. A heading has a range  of [-180, 180] degrees, where 0 represents True North.  @return The float type value of aircraft heading.",
            ],
            [
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading  will gradually change between two waypoints with different headings if the waypoint mission's `WaypointV2HeadingMode` is set to `WAYPOINT_CUSTOM`. A heading has a range  of [-180, 180] degrees, where 0 represents True North.  @return The float type value of aircraft heading.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_heading_inline",
                   "",
            ],
            [
                   "getTurnMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_turnMode_inline",
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @return An enum value of `WaypointV2TurnMode`.",
            ],
            [
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @return An enum value of `WaypointV2TurnMode`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_turnMode_inline",
                   "",
            ],
            [
                   "isUsingWaypointMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_isUsingWaypointMaxFlightSpeed_inline",
                   "Determines whether the aircraft using waypoint max flight speed executing waypoint mission. If `true`, the aircraft will use waypoint max flight speed between two waypoints.  Otherwise, will use `getMaxFlightSpeed` as max flight speed.  @return A boolean value to check if the aircraft use waypoint max flight speed.",
            ],
            [
                   "Determines whether the aircraft using waypoint max flight speed executing waypoint mission. If `true`, the aircraft will use waypoint max flight speed between two waypoints.  Otherwise, will use `getMaxFlightSpeed` as max flight speed.  @return A boolean value to check if the aircraft use waypoint max flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_isUsingWaypointMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "getMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_maxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. `getMaxFlightSpeed` is this offset  when the joystick is pushed to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed,  while pushing down will subtract 10 m/s from the aircraft speed. If the remote controller stick is not at maximum deflection, then the offset speed will be interpolated  between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it  reaches the first waypoint, it will then hover in place until a positive speed is applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return The float value of max flight speed.",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. `getMaxFlightSpeed` is this offset  when the joystick is pushed to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed,  while pushing down will subtract 10 m/s from the aircraft speed. If the remote controller stick is not at maximum deflection, then the offset speed will be interpolated  between [0, `getMaxFlightSpeed`] with a resolution of 1000 steps. If the offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it  reaches the first waypoint, it will then hover in place until a positive speed is applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @return The float value of max flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_maxFlightSpeed_inline",
                   "",
            ],
            [
                   "isUsingWaypointAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_isUsingWaypointAutoFlightSpeed_inline",
                   "Determines whether the aircraft using waypoint auto flight speed executing waypoint mission. If `true`, the aircraft will use waypoint auto flight speed between two waypoints. Otherwise,  will use `getAutoFlightSpeed` as max flight speed.  @return A boolean value to check if the aircraft use waypoint auto flight speed.",
            ],
            [
                   "Determines whether the aircraft using waypoint auto flight speed executing waypoint mission. If `true`, the aircraft will use waypoint auto flight speed between two waypoints. Otherwise,  will use `getAutoFlightSpeed` as max flight speed.  @return A boolean value to check if the aircraft use waypoint auto flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_isUsingWaypointAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_autoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and  the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by the remote controller joystick. In flight controller firmware 3.2.10.0 or above,  different speeds between individual waypoints can also be set in waypoint objects which will overwrite `getAutoFlightSpeed`.  @return The float value of auto flight speed.",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual speed is `getAutoFlightSpeed` + Joystick Speed (with combined max  of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0: Actual speed is controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and  the aircraft is at the first waypoint, the aircraft will hover in place until the speed is made positive by the remote controller joystick. In flight controller firmware 3.2.10.0 or above,  different speeds between individual waypoints can also be set in waypoint objects which will overwrite `getAutoFlightSpeed`.  @return The float value of auto flight speed.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_autoFlightSpeed_inline",
                   "",
            ],
            [
                   "getDampingDistance",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_dampingDistance_inline",
                   "Corner radius of the waypoint. When the flight path mode is `COORDINATE_TURN` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. When there is a corner radius, the aircraft will never pass the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C).  Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m). When the flight path mode is `GOTO_FIRST_POINT_ALONG_STRAIGHT_LINE` When aircraft reaches the first waypoint,  The flight path will be a straight flight with this distance. When the flight path mode is `STRAIGHT_OUT` The flight path will be a straight flight with this distance  before until last waypoint.  @return A float value of Damping Distance.",
            ],
            [
                   "Corner radius of the waypoint. When the flight path mode is `COORDINATE_TURN` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. When there is a corner radius, the aircraft will never pass the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C).  Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m). When the flight path mode is `GOTO_FIRST_POINT_ALONG_STRAIGHT_LINE` When aircraft reaches the first waypoint,  The flight path will be a straight flight with this distance. When the flight path mode is `STRAIGHT_OUT` The flight path will be a straight flight with this distance  before until last waypoint.  @return A float value of Damping Distance.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_dampingDistance_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "",
                   "Default constructor of DJIWaypointV2.",
            ],
            [
                   "Default constructor of DJIWaypointV2.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "",
                   "",
            ],
            [
                   "setCoordinate",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setCoordinate_inline",
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.  @param coordinate `LocationCoordinate2D` object to set.  @return The build of `Builder`.",
            ],
            [
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.  @param coordinate `LocationCoordinate2D` object to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setCoordinate_inline",
                   "",
            ],
            [
                   "setAltitude",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setAltitude_inline",
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude will  gradually change as the aircraft flies between waypoints.  @param altitude Double type value to set.  @return The build of `Builder`.",
            ],
            [
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, has a range of [-200,500], and should not be larger than the  aircraft's maximum altitude. If two adjacent waypoints have different altitudes, the altitude will  gradually change as the aircraft flies between waypoints.  @param altitude Double type value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setAltitude_inline",
                   "",
            ],
            [
                   "setPointOfInterest",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setPointOfInterest_inline",
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. Aircraft will always be heading to point while executing mission. Default is kCLLocationCoordinate2DInvalid.  @param pointOfInterest The object of `LocationCoordinate2D`.  @return The build of `Builder`.",
            ],
            [
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. Aircraft will always be heading to point while executing mission. Default is kCLLocationCoordinate2DInvalid.  @param pointOfInterest The object of `LocationCoordinate2D`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setPointOfInterest_inline",
                   "",
            ],
            [
                   "setPointOfInterestAltitude",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setPointOfInterestAltitude_inline",
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. The altitude of the aircraft is relative to the ground at the take-off location, has a range of [-200,500],  and should not be larger than the aircraft's maximum altitude.  @param pointOfInterestAltitude The float value to set.  @return The build of `Builder`.",
            ],
            [
                   "Property is used when `getHeadingMode` is `TOWARD_POINT_OF_INTEREST`. The altitude of the aircraft is relative to the ground at the take-off location, has a range of [-200,500],  and should not be larger than the aircraft's maximum altitude.  @param pointOfInterestAltitude The float value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setPointOfInterestAltitude_inline",
                   "",
            ],
            [
                   "setFlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setFlightPathMode_inline",
                   "Flight path mode waypoint of the aircraft as it moves between waypoints. Default is DJIWaypointV2_DJIWaypointV2FlightPathMode_CurvatureContinuousStop</code>.  @param flightPathMode An enum value of `WaypointV2FlightPathMode`.  @return The build of `Builder`.",
            ],
            [
                   "Flight path mode waypoint of the aircraft as it moves between waypoints. Default is DJIWaypointV2_DJIWaypointV2FlightPathMode_CurvatureContinuousStop</code>.  @param flightPathMode An enum value of `WaypointV2FlightPathMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setFlightPathMode_inline",
                   "",
            ],
            [
                   "setHeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setHeadingMode_inline",
                   "Heading of the aircraft as it moves between waypoints. Default is `AUTO`.  @param headingMode An enum value of `WaypointV2HeadingMode`.  @return The build of `Builder`.",
            ],
            [
                   "Heading of the aircraft as it moves between waypoints. Default is `AUTO`.  @param headingMode An enum value of `WaypointV2HeadingMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setHeadingMode_inline",
                   "",
            ],
            [
                   "setHeading",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setHeading_inline",
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading will gradually  change between two waypoints with different headings if the waypoint mission's `headingMode` is set to DJIWaypointV2_DJIWaypointV2HeadingMode_UsingWaypointHeading</code>.  A heading has a range of [-180, 180] degrees, where 0 represents True North.  @param heading A float type value of heading.  @return The build of `Builder`.",
            ],
            [
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading will gradually  change between two waypoints with different headings if the waypoint mission's `headingMode` is set to DJIWaypointV2_DJIWaypointV2HeadingMode_UsingWaypointHeading</code>.  A heading has a range of [-180, 180] degrees, where 0 represents True North.  @param heading A float type value of heading.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setHeading_inline",
                   "",
            ],
            [
                   "setTurnMode",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setTurnMode_inline",
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @param turnMode An enum value of `WaypointV2TurnMode`.  @return The build of `Builder`.",
            ],
            [
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading.  @param turnMode An enum value of `WaypointV2TurnMode`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setTurnMode_inline",
                   "",
            ],
            [
                   "setUsingWaypointAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setUsingWaypointAutoFlightSpeed_inline",
                   "Determines whether the aircraft using waypoint auto flight speed executing waypoint mission. If `true`, the aircraft will use waypoint auto flight speed between two waypoints.  Otherwise, will use `getAutoFlightSpeed` as max flight speed.  @param usingWaypointAutoFlightSpeed A boolean type value to set.  @return The build of `Builder`.",
            ],
            [
                   "Determines whether the aircraft using waypoint auto flight speed executing waypoint mission. If `true`, the aircraft will use waypoint auto flight speed between two waypoints.  Otherwise, will use `getAutoFlightSpeed` as max flight speed.  @param usingWaypointAutoFlightSpeed A boolean type value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setUsingWaypointAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "setUsingWaypointMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setUsingWaypointMaxFlightSpeed_inline",
                   "Determines whether the aircraft using waypoint max flight speed executing waypoint mission. If `true`, the aircraft will use waypoint max flight speed between two waypoints.  Otherwise, will use `getMaxFlightSpeed` as max flight speed.  @param usingWaypointMaxFlightSpeed A boolean type value to set.  @return The build of `Builder`.",
            ],
            [
                   "Determines whether the aircraft using waypoint max flight speed executing waypoint mission. If `true`, the aircraft will use waypoint max flight speed between two waypoints.  Otherwise, will use `getMaxFlightSpeed` as max flight speed.  @param usingWaypointMaxFlightSpeed A boolean type value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setUsingWaypointMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "setAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setAutoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed, and the  speed control given by the throttle joystick on the remote controller. If autoFlightSpeed >0: Actual speed is autoFlightSpeed + Joystick Speed (with combined max of maxFlightSpeed)  If autoFlightSpeed =0: Actual speed is controlled only by the remote controller joystick. If autoFlightSpeed <0 and the aircraft is at the first waypoint, the aircraft will hover in  place until the speed is made positive by the remote controller joystick. In flight controller firmware 3.2.10.0 or above, different speeds between individual waypoints can also be set in  waypoint objects which will overwrite autoFlightSpeed.  @param autoFlightSpeed A float type value to set.  @return The build of `Builder`.",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s. The aircraft's actual speed is a combination of the base automatic speed, and the  speed control given by the throttle joystick on the remote controller. If autoFlightSpeed >0: Actual speed is autoFlightSpeed + Joystick Speed (with combined max of maxFlightSpeed)  If autoFlightSpeed =0: Actual speed is controlled only by the remote controller joystick. If autoFlightSpeed <0 and the aircraft is at the first waypoint, the aircraft will hover in  place until the speed is made positive by the remote controller joystick. In flight controller firmware 3.2.10.0 or above, different speeds between individual waypoints can also be set in  waypoint objects which will overwrite autoFlightSpeed.  @param autoFlightSpeed A float type value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "setMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setMaxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. maxFlightSpeed is this offset when the joystick is  pushed to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed, while pushing down will  subtract 10 m/s from the aircraft speed. If the remote controller stick is not at maximum deflection, then the offset speed will be interpolated between [0, maxFlightSpeed] with a resolution of 1000 steps. If the offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the first waypoint, it will then hover in place  until a positive speed is applied. maxFlightSpeed has a range of [2,15] m/s.  @param maxFlightSpeed A float type value to set.  @return The build of `Builder`.",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick on the remote controller. maxFlightSpeed is this offset when the joystick is  pushed to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the way up will add 10 m/s to the aircraft speed, while pushing down will  subtract 10 m/s from the aircraft speed. If the remote controller stick is not at maximum deflection, then the offset speed will be interpolated between [0, maxFlightSpeed] with a resolution of 1000 steps. If the offset speed is negative, then the aircraft will fly backwards to previous waypoints. When it reaches the first waypoint, it will then hover in place  until a positive speed is applied. maxFlightSpeed has a range of [2,15] m/s.  @param maxFlightSpeed A float type value to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "setDampingDistance",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setDampingDistance_inline",
                   "Corner radius of the waypoint. When the flight path mode  is `COORDINATE_TURN` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. When there is a corner radius, the aircraft will never pass the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C).  Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect  the flight path and it should keep the default value (0.2m). When the flight path mode is `GOTO_FIRST_POINT_ALONG_STRAIGHT_LINE` When aircraft reaches  the first waypoint, The flight path will be a straight flight with this distance. When the flight path mode is `STRAIGHT_OUT` The flight path will be  a straight flight with this distance before until last waypoint.  @param dampingDistance A float type value of damping distance.  @return The build of `Builder`.",
            ],
            [
                   "Corner radius of the waypoint. When the flight path mode  is `COORDINATE_TURN` the flight path near a waypoint will be acurve (rounded corner) with  radius [0.2,1000]. When there is a corner radius, the aircraft will never pass the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C).  Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect  the flight path and it should keep the default value (0.2m). When the flight path mode is `GOTO_FIRST_POINT_ALONG_STRAIGHT_LINE` When aircraft reaches  the first waypoint, The flight path will be a straight flight with this distance. When the flight path mode is `STRAIGHT_OUT` The flight path will be  a straight flight with this distance before until last waypoint.  @param dampingDistance A float type value of damping distance.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_setDampingDistance_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_build_inline",
                   "Build the object into a `WaypointV2` object.  @return The build of `Builder`.",
            ],
            [
                   "Build the object into a `WaypointV2` object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2_Builder.html",
                   "#DJIWaypointV2_Builder_build_inline",
                   "",
            ],
            [
                   "WaypointV2FlightPathMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_inline",
                   "Waypoint flight path mode.",
            ],
            [
                   "Waypoint flight path mode.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_inline",
                   "",
            ],
            [
                   "CURVATURE_CONTINUOUS_PASSED",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointAlongACurve_inline",
                   "In the mission, the aircraft will go to the waypoint along a curve and fly past the waypoint.",
            ],
            [
                   "In the mission, the aircraft will go to the waypoint along a curve and fly past the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointAlongACurve_inline",
                   "",
            ],
            [
                   "GOTO_POINT_CURVE_AND_STOP",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointAlongACurveAndStop_inline",
                   "In the mission, the aircraft will go to the waypoint along a curve and stop at the waypoint.",
            ],
            [
                   "In the mission, the aircraft will go to the waypoint along a curve and stop at the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointAlongACurveAndStop_inline",
                   "",
            ],
            [
                   "GOTO_POINT_STRAIGHT_LINE_AND_STOP",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointInAStraightLineAndStop_inline",
                   "In the mission, the aircraft will go to the waypoint along a straight line and stop at the waypoint.",
            ],
            [
                   "In the mission, the aircraft will go to the waypoint along a straight line and stop at the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToPointInAStraightLineAndStop_inline",
                   "",
            ],
            [
                   "COORDINATE_TURN",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_CoordinateTurn_inline",
                   "In the mission, the aircraft will fly from the previous waypoint to the next waypoint along a smooth curve  without stopping at this waypoint. the next in a curved motion, adhering to the `getDampingDistance`,  which is set in `WaypointV2`.",
            ],
            [
                   "In the mission, the aircraft will fly from the previous waypoint to the next waypoint along a smooth curve  without stopping at this waypoint. the next in a curved motion, adhering to the `getDampingDistance`,  which is set in `WaypointV2`.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_CoordinateTurn_inline",
                   "",
            ],
            [
                   "GOTO_FIRST_POINT_ALONG_STRAIGHT_LINE",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToFirstPointAlongAStraightLine_inline",
                   "In the mission, the aircraft will go to the first waypoint along a straight line. This is only valid for the first waypoint.",
            ],
            [
                   "In the mission, the aircraft will go to the first waypoint along a straight line. This is only valid for the first waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_GoToFirstPointAlongAStraightLine_inline",
                   "",
            ],
            [
                   "STRAIGHT_OUT",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_StraightOut_inline",
                   "Straight exit the Last waypoint, Only valid for last waypoint.",
            ],
            [
                   "Straight exit the Last waypoint, Only valid for last waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_StraightOut_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2FlightPathMode_Unknown_inline",
                   "",
            ],
            [
                   "WaypointV2HeadingMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_inline",
                   "Represents current aircraft's heading mode on current waypoint.",
            ],
            [
                   "Represents current aircraft's heading mode on current waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Auto_inline",
                   "Aircraft's heading will always be in the direction of flight.",
            ],
            [
                   "Aircraft's heading will always be in the direction of flight.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Auto_inline",
                   "",
            ],
            [
                   "FIXED",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Fixed_inline",
                   "Aircraft's heading will be set to the heading when reaching the first waypoint. Before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. When the aircraft  reaches the first waypoint, its heading will be fixed.",
            ],
            [
                   "Aircraft's heading will be set to the heading when reaching the first waypoint. Before reaching the  first waypoint, the aircraft's heading can be controlled by the remote controller. When the aircraft  reaches the first waypoint, its heading will be fixed.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Fixed_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Manual_inline",
                   "The aircraft's heading in the mission can be controlled by the remote controller.",
            ],
            [
                   "The aircraft's heading in the mission can be controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Manual_inline",
                   "",
            ],
            [
                   "WAYPOINT_CUSTOM",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_WaypointCustom_inline",
                   "In the mission, the aircraft's heading will change dynamically and adapt to the heading set at the next waypoint.  See `getHeading` to preset the heading.",
            ],
            [
                   "In the mission, the aircraft's heading will change dynamically and adapt to the heading set at the next waypoint.  See `getHeading` to preset the heading.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_WaypointCustom_inline",
                   "",
            ],
            [
                   "TOWARD_POINT_OF_INTEREST",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_TowardPointOfInterest_inline",
                   "After the first waypoint has been reached, aircraft heading will always toward to the point of interest. Using `getPointOfInterest` and `getPointOfInterestAltitude` to set the coordinate of point of interest.",
            ],
            [
                   "After the first waypoint has been reached, aircraft heading will always toward to the point of interest. Using `getPointOfInterest` and `getPointOfInterestAltitude` to set the coordinate of point of interest.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_TowardPointOfInterest_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2HeadingMode_Unknown_inline",
                   "",
            ],
            [
                   "WaypointV2TurnMode",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_inline",
                   "The direction when the aircraft changes its heading to adapt to the heading at the waypoint.",
            ],
            [
                   "The direction when the aircraft changes its heading to adapt to the heading at the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_inline",
                   "",
            ],
            [
                   "CLOCKWISE",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_Clockwise_inline",
                   "The aircraft's heading rotates clockwise.",
            ],
            [
                   "The aircraft's heading rotates clockwise.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_Clockwise_inline",
                   "",
            ],
            [
                   "COUNTER_CLOCKWISE",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_CounterClockwise_inline",
                   "The aircraft's heading rotates counterclockwise.",
            ],
            [
                   "The aircraft's heading rotates counterclockwise.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_CounterClockwise_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_Unknown_inline",
                   "Changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
            ],
            [
                   "Changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
                   1,
                   "/Components/Missions/DJIWaypointV2.html",
                   "#DJIWaypointV2_DJIWaypointV2TurnMode_Unknown_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "",
                   "This class is used for the developer to build the WaypointV2Mission.",
            ],
            [
                   "This class is used for the developer to build the WaypointV2Mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "",
                   "",
            ],
            [
                   "setMissionID",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setMissionID_inline",
                   "Set Mission ID.  @param missionID The value of missionID to set.  @return The build of `Builder`.",
            ],
            [
                   "Set Mission ID.  @param missionID The value of missionID to set.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setMissionID_inline",
                   "",
            ],
            [
                   "setMaxFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setMaxFlightSpeed_inline",
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this  offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will  add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the  aircraft speed. If the remote controller stick is not at maximum deflection, then  the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution  of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards  to previous waypoints. When it reaches the  first waypoint, it will then hover in place  until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @param maxFlightSpeed The value of the max flight speed.  @return The build of `Builder`.",
            ],
            [
                   "While the aircraft is travelling between waypoints, you can offset its speed by using the throttle joystick  on the remote controller. `getMaxFlightSpeed` is this  offset when the joystick is pushed  to maximum deflection. For example, If maxFlightSpeed is 10 m/s, then pushing the throttle joystick all the  way up will  add 10 m/s to the aircraft speed, while pushing down will subtract 10 m/s from the  aircraft speed. If the remote controller stick is not at maximum deflection, then  the offset speed will be  interpolated between [0, `getMaxFlightSpeed`] with a resolution  of 1000 steps. If the  offset speed is negative, then the aircraft will fly backwards  to previous waypoints. When it reaches the  first waypoint, it will then hover in place  until a positive speed is  applied. `getMaxFlightSpeed` has a range of [2,15] m/s.  @param maxFlightSpeed The value of the max flight speed.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setMaxFlightSpeed_inline",
                   "",
            ],
            [
                   "setAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setAutoFlightSpeed_inline",
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s.  The aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0:  Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft  is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoFlightSpeed The value of the auto flight speed.  @return The build of `Builder`.",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between waypoints with range [-15, 15] m/s.  The aircraft's actual speed is a combination of the base automatic speed, and the speed control  given by  the throttle joystick on the remote controller. If `getAutoFlightSpeed` >0: Actual  speed is `getAutoFlightSpeed` + Joystick Speed (with combined max of `getMaxFlightSpeed`) If `getAutoFlightSpeed` =0:  Actual speed is  controlled only by the remote controller joystick. If `getAutoFlightSpeed` <0 and the aircraft  is at the first waypoint, the aircraft will hover in place until the speed is made positive by  the remote controller joystick.  @param autoFlightSpeed The value of the auto flight speed.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "setFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setFinishedAction_inline",
                   "Action the aircraft will take when the waypoint mission is complete.  @param finishedAction The enum value of `MissionFinishedAction`.  @return The build of `Builder`.",
            ],
            [
                   "Action the aircraft will take when the waypoint mission is complete.  @param finishedAction The enum value of `MissionFinishedAction`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setFinishedAction_inline",
                   "",
            ],
            [
                   "setGotoFirstWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setGotoFirstWaypointMode_inline",
                   "Defines how the aircraft will go to the first waypoint from its current position.  Default is `SAFELY`.  @param gotoFirstWaypointMode The enum value of `MissionFinishedAction`.  @return The build of `Builder`.",
            ],
            [
                   "Defines how the aircraft will go to the first waypoint from its current position.  Default is `SAFELY`.  @param gotoFirstWaypointMode The enum value of `MissionFinishedAction`.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setGotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "setExitMissionOnRCSignalLostEnabled",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setExitMissionOnRCSignalLostEnabled_inline",
                   "Determines whether the mission should stop when connection between the aircraft and remote controller is lost. Default is `false`.  @param exitMissionOnRCSignalLostEnabled A boolean value.  @return The build of `Builder`.",
            ],
            [
                   "Determines whether the mission should stop when connection between the aircraft and remote controller is lost. Default is `false`.  @param exitMissionOnRCSignalLostEnabled A boolean value.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setExitMissionOnRCSignalLostEnabled_inline",
                   "",
            ],
            [
                   "setRepeatTimes",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setRepeatTimes_inline",
                   "Repeat times for mission execution. Default is 1.  @param repeatTimes An int value of mission repeat times.  @return The build of `Builder`.",
            ],
            [
                   "Repeat times for mission execution. Default is 1.  @param repeatTimes An int value of mission repeat times.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_setRepeatTimes_inline",
                   "",
            ],
            [
                   "addwaypoints",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_addwaypoints_inline",
                   "Adds an array of waypoints to the waypoint mission. When the waypoints are added successfully, `getWaypointCount` will increment by the number of added waypoints.  @param waypointList A list of `WaypointV2` objects.  @return The build of `Builder`.",
            ],
            [
                   "Adds an array of waypoints to the waypoint mission. When the waypoints are added successfully, `getWaypointCount` will increment by the number of added waypoints.  @param waypointList A list of `WaypointV2` objects.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_addwaypoints_inline",
                   "",
            ],
            [
                   "addWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_addWaypoint_inline",
                   "As same as Waypoint 1.0 Add a waypoint to the waypoint mission. When a waypoint is added  successfully, `getWaypointCount` will increment by 1. A waypoint will only be valid  if the distance (in three dimensions) between two adjacent waypoints is in range [0.5,2000] meters.  @param waypoint A `WaypointV2` object.  @return The build of `Builder`.",
            ],
            [
                   "As same as Waypoint 1.0 Add a waypoint to the waypoint mission. When a waypoint is added  successfully, `getWaypointCount` will increment by 1. A waypoint will only be valid  if the distance (in three dimensions) between two adjacent waypoints is in range [0.5,2000] meters.  @param waypoint A `WaypointV2` object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_addWaypoint_inline",
                   "",
            ],
            [
                   "removeWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_removeWaypoint_inline",
                   "As same as Waypoint 1.0, removes the last waypoint stored in the mission. When the waypoint is removed  successfully, `getWaypointCount` will decrease by 1.  @param waypoint A `WaypointV2` object.  @return The build of `Builder`.",
            ],
            [
                   "As same as Waypoint 1.0, removes the last waypoint stored in the mission. When the waypoint is removed  successfully, `getWaypointCount` will decrease by 1.  @param waypoint A `WaypointV2` object.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_removeWaypoint_inline",
                   "",
            ],
            [
                   "removeWaypoint",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_removeWaypointByIndex_inline",
                   "As same as Waypoint 1.0, removes the last waypoint stored in the mission. When the waypoint is removed  successfully, `getWaypointCount` will decrease by 1.  @param index The index of the waypoint.  @return The build of `Builder`.",
            ],
            [
                   "As same as Waypoint 1.0, removes the last waypoint stored in the mission. When the waypoint is removed  successfully, `getWaypointCount` will decrease by 1.  @param index The index of the waypoint.  @return The build of `Builder`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_removeWaypointByIndex_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_build_inline",
                   "Build a `WaypointV2Mission` object.  @return The object of `WaypointV2Mission`.",
            ],
            [
                   "Build a `WaypointV2Mission` object.  @return The object of `WaypointV2Mission`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission_Builder.html",
                   "#DJIWaypointV2Mission_Builder_build_inline",
                   "",
            ],
            [
                   "getLatitude",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeLatitude_inline",
                   "Latitude of the mission's initial target location.  @return A double value.",
            ],
            [
                   "Latitude of the mission's initial target location.  @return A double value.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeLatitude_inline",
                   "",
            ],
            [
                   "getLongitude",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeLongitude_inline",
                   "Longitude of the mission's initial target location.  @return A double value.",
            ],
            [
                   "Longitude of the mission's initial target location.  @return A double value.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeLongitude_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeAltitude_inline",
                   "Initial altitude (above sea level) in meters.  @return A float value.",
            ],
            [
                   "Initial altitude (above sea level) in meters.  @return A float value.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_followMeAltitude_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_heading_inline",
                   "The aircraft's heading during the mission.  @return An enum value of `FollowMeHeading`.",
            ],
            [
                   "The aircraft's heading during the mission.  @return An enum value of `FollowMeHeading`.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_heading_inline",
                   "",
            ],
            [
                   "FollowMeHeading",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_inline",
                   "Aircraft's heading during a follow me mission.",
            ],
            [
                   "Aircraft's heading during a follow me mission.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_inline",
                   "",
            ],
            [
                   "TOWARD_FOLLOW_POSITION",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_TowardFollowPosition_inline",
                   "Aircraft's heading remains toward the coordinate it is following.",
            ],
            [
                   "Aircraft's heading remains toward the coordinate it is following.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_TowardFollowPosition_inline",
                   "",
            ],
            [
                   "CONTROLLED_BY_REMOTE_CONTROLLER",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_ControlledByRemoteController_inline",
                   "Aircraft's heading will be controlled by the remote controller.",
            ],
            [
                   "Aircraft's heading will be controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "#DJIFollowMeMission_DJIFollowMeHeading_ControlledByRemoteController_inline",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_previousState_inline",
                   "The previous follow me mission state, check the `FollowMeMissionState` enum value.  @return An object of `FollowMeMissionState`.",
            ],
            [
                   "The previous follow me mission state, check the `FollowMeMissionState` enum value.  @return An object of `FollowMeMissionState`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_currentState_inline",
                   "The current follow me mission state, check the `FollowMeMissionState` enum value.  @return An object of `FollowMeMissionState`.",
            ],
            [
                   "The current follow me mission state, check the `FollowMeMissionState` enum value.  @return An object of `FollowMeMissionState`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getDistanceToTarget",
                   2,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_distanceToTarget_inline",
                   "Get the distance to the target.  @return A float value of the distance to the target.",
            ],
            [
                   "Get the distance to the target.  @return A float value of the distance to the target.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_distanceToTarget_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_error_inline",
                   "The encountered error if there is any. Otherwise, it is `null`.  @return An object of `DJIError`.",
            ],
            [
                   "The encountered error if there is any. Otherwise, it is `null`.  @return An object of `DJIError`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "#DJIFollowMeMissionEvent_error_inline",
                   "",
            ],
            [
                   "FollowMeMissionState",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "",
                   "All the possible state of `FollowMeMissionOperator`.",
            ],
            [
                   "All the possible state of `FollowMeMissionOperator`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Unknown_inline",
                   "The state of the operator is unknown. It is the initial state when the  operator is just created.",
            ],
            [
                   "The state of the operator is unknown. It is the initial state when the  operator is just created.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Disconnected_inline",
                   "The connection between the mobile device and aircraft is lost.",
            ],
            [
                   "The connection between the mobile device and aircraft is lost.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_NotSupported_inline",
                   "The connected product does not support Follow Me mission.",
            ],
            [
                   "The connected product does not support Follow Me mission.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Recovering_inline",
                   "The connection between the mobile device and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device and aircraft is built-up. The operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_READY",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_notReady_inline",
                   "The current state is not ready for uploading a mission.",
            ],
            [
                   "The current state is not ready for uploading a mission.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_notReady_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_ReadyToStart_inline",
                   "The operator is ready to start a Follow Me mission.",
            ],
            [
                   "The operator is ready to start a Follow Me mission.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_ReadyToStart_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Executing_inline",
                   "The mission execution is started successfully.",
            ],
            [
                   "The mission execution is started successfully.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_Executing_inline",
                   "",
            ],
            [
                   "GOT_STUCK",
                   2,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_GotStuck_inline",
                   "The mission execution is not executing successfully.",
            ],
            [
                   "The mission execution is not executing successfully.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionState.html",
                   "#DJIFollowMeMissionState_GotStuck_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_addListener_inline",
                   "Add a listener to listen for all events in the TapFly mission operator.  @param listener Listener that is interested in the TapFly mission operator.",
            ],
            [
                   "Add a listener to listen for all events in the TapFly mission operator.  @param listener Listener that is interested in the TapFly mission operator.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_addListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_removeListener_inline",
                   "Removes listener. The listener will not receive any updates after calling this method.  @param targetListener Listener to be removed.",
            ],
            [
                   "Removes listener. The listener will not receive any updates after calling this method.  @param targetListener Listener to be removed.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_removeAllListeners_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "setupEnvironment",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setupEnvironment_inline",
                   "Setup environment and provide result in callback  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Setup environment and provide result in callback  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setupEnvironment_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_startMission_inline",
                   "Starts to execute a TapFly mission. It can only be called when  the `getCurrentState`   is `EXECUTION_STARTING`. If the mission is started successfully,  the `getCurrentState` will  become `EXECUTING`.  @param mission An object of `TapFlyMission`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts to execute a TapFly mission. It can only be called when  the `getCurrentState`   is `EXECUTION_STARTING`. If the mission is started successfully,  the `getCurrentState` will  become `EXECUTING`.  @param mission An object of `TapFlyMission`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_stopMission_inline",
                   "Stops the executing mission. It can only be called when  the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  - `EXECUTION_RESETTING`  After a mission is stopped  successfully, `getCurrentState` will  become `EXECUTION_STARTING`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops the executing mission. It can only be called when  the `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  - `EXECUTION_RESETTING`  After a mission is stopped  successfully, `getCurrentState` will  become `EXECUTION_STARTING`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "resetHeading",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_resetHeading_inline",
                   "Resets aircraft heading to the flight direction. It can only be used  when `tapFlyMode` is `FREE`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Resets aircraft heading to the flight direction. It can only be used  when `tapFlyMode` is `FREE`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_resetHeading_inline",
                   "",
            ],
            [
                   "setAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setAutoFlightSpeed_inline",
                   "Sets auto flight speed for TapFly mission. It can be changed before or during the  execution of a TapFly mission.  @param speed Auto flight speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets auto flight speed for TapFly mission. It can be changed before or during the  execution of a TapFly mission.  @param speed Auto flight speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "getAutoFlightSpeed",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getAutoFlightSpeed_inline",
                   "Gets the auto flight speed for TapFly mission in m/s.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the auto flight speed for TapFly mission in m/s.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getAutoFlightSpeed_inline",
                   "",
            ],
            [
                   "setHorizontalObstacleBypassEnabled",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setHorizontalObstacleBypassEnabled_inline",
                   "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. If `false`, the aircraft will only  go over an obstacle to avoid it. It can be changed before or during the execution  of a TapFly mission.  @param enabled `true` allows aircraft to bypass or move around an obstacle by going to the left or right. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. If `false`, the aircraft will only  go over an obstacle to avoid it. It can be changed before or during the execution  of a TapFly mission.  @param enabled `true` allows aircraft to bypass or move around an obstacle by going to the left or right. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_setHorizontalObstacleBypassEnabled_inline",
                   "",
            ],
            [
                   "getHorizontalObstacleBypassEnabled",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getHorizontalObstacleBypassEnabled_inline",
                   "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. If `false`, the aircraft will only  go over an obstacle to avoid it. It can be changed before or during the execution  of a TapFly mission.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "`true` allows the aircraft to bypass or move around an obstacle by going to  the left or right of the obstacle. If `false`, the aircraft will only  go over an obstacle to avoid it. It can be changed before or during the execution  of a TapFly mission.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getHorizontalObstacleBypassEnabled_inline",
                   "",
            ],
            [
                   "getTapFlyMode",
                   2,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getTapFlyMode_inline",
                   "Get the current tracking mode of the aircraft. It is valid when the `TapFlyMissionState`  is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  - `EXECUTION_RESETTING`  For the other states, the value  is `UNKNOWN`.  @return An enum value of `TapFlyMode`.",
            ],
            [
                   "Get the current tracking mode of the aircraft. It is valid when the `TapFlyMissionState`  is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  - `EXECUTION_RESETTING`  For the other states, the value  is `UNKNOWN`.  @return An enum value of `TapFlyMode`.",
                   1,
                   "/Components/Missions/DJITapFlyMissionOperator.html",
                   "#DJITapFlyMissionOperator_getTapFlyMode_inline",
                   "",
            ],
            [
                   "TapFlyMissionOperatorListener",
                   2,
                   "/Components/Missions/TapFlyMissionOperatorListener.html",
                   "",
                   "Listener interface to receive events from the TapFly mission operator.",
            ],
            [
                   "Listener interface to receive events from the TapFly mission operator.",
                   1,
                   "/Components/Missions/TapFlyMissionOperatorListener.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Missions/TapFlyMissionOperatorListener.html",
                   "#TapFlyMissionOperatorListener_onUpdate_inline",
                   "Called when a new event has been updated.  @param aggregation An object of `TapFlyMissionEvent`.",
            ],
            [
                   "Called when a new event has been updated.  @param aggregation An object of `TapFlyMissionEvent`.",
                   1,
                   "/Components/Missions/TapFlyMissionOperatorListener.html",
                   "#TapFlyMissionOperatorListener_onUpdate_inline",
                   "",
            ],
            [
                   "TapFlyMission",
                   2,
                   "/Components/Missions/DJITapFlyMission.html",
                   "",
                   "A TapFly Mission is initialized with a position target from the live video stream. The 3D direction of the coordinate is calculated, and the aircraft  will proceed to fly in that direction. The aircraft can automatically avoid obstacles when the scene is sufficiently illuminated (more than 300 lux but less than 10,000 lux). The aircraft will stop flying in the direction if it reaches its radius limitation, the mission is stopped, the user pulls back on the pitch stick or if it comes to an obstacle it cannot bypass. The Remote Controller yaw stick can be used to adjust the heading of the aircraft during mission execution, which also adjusts the direction of flight to the new yaw. Using any other stick controls will cancel the mission.",
            ],
            [
                   "A TapFly Mission is initialized with a position target from the live video stream. The 3D direction of the coordinate is calculated, and the aircraft  will proceed to fly in that direction. The aircraft can automatically avoid obstacles when the scene is sufficiently illuminated (more than 300 lux but less than 10,000 lux). The aircraft will stop flying in the direction if it reaches its radius limitation, the mission is stopped, the user pulls back on the pitch stick or if it comes to an obstacle it cannot bypass. The Remote Controller yaw stick can be used to adjust the heading of the aircraft during mission execution, which also adjusts the direction of flight to the new yaw. Using any other stick controls will cancel the mission.",
                   1,
                   "/Components/Missions/DJITapFlyMission.html",
                   "",
                   "",
            ],
            [
                   "TapFlyMissionEvent",
                   2,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "",
                   "This class encapsulates all the state changes of the TapFly mission operator.",
            ],
            [
                   "This class encapsulates all the state changes of the TapFly mission operator.",
                   1,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_previousState_inline",
                   "The previous state of the operator.  @return A object of `TapFlyMissionState`.",
            ],
            [
                   "The previous state of the operator.  @return A object of `TapFlyMissionState`.",
                   1,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_currentState_inline",
                   "The current state of the operator.  @return A object of `TapFlyMissionState`.",
            ],
            [
                   "The current state of the operator.  @return A object of `TapFlyMissionState`.",
                   1,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getExecutionState",
                   2,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_executionState_inline",
                   "The detailed state of the executing TapFly mission. It is only valid  when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  For the other states, it is `null`.  @return A `TapFlyExecutionState` object.",
            ],
            [
                   "The detailed state of the executing TapFly mission. It is only valid  when `getCurrentState` is one of the following:  - `EXECUTING`  - `EXECUTION_PAUSED`  For the other states, it is `null`.  @return A `TapFlyExecutionState` object.",
                   1,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_executionState_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_error_inline",
                   "The encountered error if any. Otherwise, it is `null`.  @return A `DJIError` object.",
            ],
            [
                   "The encountered error if any. Otherwise, it is `null`.  @return A `DJIError` object.",
                   1,
                   "/Components/Missions/DJITapFlyMissionEvent.html",
                   "#DJITapFlyMissionEvent_error_inline",
                   "",
            ],
            [
                   "TapFlyMissionState",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "",
                   "All the possible states of `TapFlyMissionOperator`.",
            ],
            [
                   "All the possible states of `TapFlyMissionOperator`.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Unknown_inline",
                   "The state of the operator is unknown. This is the initial state when the operator is  first created.",
            ],
            [
                   "The state of the operator is unknown. This is the initial state when the operator is  first created.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Unknown_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_IDLE_inline",
                   "The operator is in idle state",
            ],
            [
                   "The operator is in idle state",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_IDLE_inline",
                   "",
            ],
            [
                   "EXECUTION_STARTING",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionStarting_inline",
                   "The start execution command has been called but the aircraft hasn't yet acknowledged it has started. No other commands should be  called when in this state. The next state is either disconnected,  executing or readyToExecute.",
            ],
            [
                   "The start execution command has been called but the aircraft hasn't yet acknowledged it has started. No other commands should be  called when in this state. The next state is either disconnected,  executing or readyToExecute.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionStarting_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Disconnected_inline",
                   "The connection between the mobile device and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device and aircraft is broken.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Recovering_inline",
                   "The connection between the mobile device and aircraft is recovering.  In this state, the operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device and aircraft is recovering.  In this state, the operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORT",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_NotSupported_inline",
                   "The connected product does not support TapFly mission.",
            ],
            [
                   "The connected product does not support TapFly mission.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "CAN_NOT_START",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_CannotStart_inline",
                   "There is an existing error stopping the TapFly mission to start.",
            ],
            [
                   "There is an existing error stopping the TapFly mission to start.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_CannotStart_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Executing_inline",
                   "The operator is executing a TapFly mission.",
            ],
            [
                   "The operator is executing a TapFly mission.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_Executing_inline",
                   "",
            ],
            [
                   "EXECUTION_PAUSED",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionPaused_inline",
                   "The execution of the TapFly mission is paused. User can pause or resume a TapFly mission by pressing the pause button on the physical remote controller.",
            ],
            [
                   "The execution of the TapFly mission is paused. User can pause or resume a TapFly mission by pressing the pause button on the physical remote controller.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionPaused_inline",
                   "",
            ],
            [
                   "EXECUTION_RESETTING",
                   2,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionResetting_inline",
                   "The TapFly mission cannot continue the execution. The execution is being stopped automatically.",
            ],
            [
                   "The TapFly mission cannot continue the execution. The execution is being stopped automatically.",
                   1,
                   "/Components/Missions/DJITapFlyMissionState.html",
                   "#DJITapFlyMissionState_ExecutionResetting_inline",
                   "",
            ],
            [
                   "Waypoint",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_initWithCoordinate_inline",
                   "Initiate instance with specific waypoint.  @param latitude The latitude of the waypoint. @param longitude The longitude of the waypoint. @param altitude The altitude of the waypoint.",
            ],
            [
                   "Initiate instance with specific waypoint.  @param latitude The latitude of the waypoint. @param longitude The longitude of the waypoint. @param altitude The altitude of the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_initWithCoordinate_inline",
                   "",
            ],
            [
                   "coordinate",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_coordinate_inline",
                   "Waypoint coordinate latitude and longitude in degrees.",
            ],
            [
                   "Waypoint coordinate latitude and longitude in degrees.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_coordinate_inline",
                   "",
            ],
            [
                   "altitude",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_altitude_inline",
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, and should not be larger than the aircraft's maximum altitude. If  two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.",
            ],
            [
                   "Altitude of the aircraft in meters when it reaches waypoint. The altitude of the aircraft is relative to  the ground at the take-off location, and should not be larger than the aircraft's maximum altitude. If  two adjacent waypoints have different altitudes, the altitude will gradually change as the aircraft flies between waypoints.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_altitude_inline",
                   "",
            ],
            [
                   "heading",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_heading_inline",
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading  will gradually change between two waypoints with different headings if the waypoint  mission's `getHeadingMode` is set  to `USING_WAYPOINT_HEADING`. A heading has a range of  [-180, 180] degrees, where 0 represents True North. `heading` relate to behavior between this waypoint and the next waypoint in the mission.",
            ],
            [
                   "The heading to which the aircraft will rotate by the time it reaches the waypoint. The aircraft heading  will gradually change between two waypoints with different headings if the waypoint  mission's `getHeadingMode` is set  to `USING_WAYPOINT_HEADING`. A heading has a range of  [-180, 180] degrees, where 0 represents True North. `heading` relate to behavior between this waypoint and the next waypoint in the mission.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_heading_inline",
                   "",
            ],
            [
                   "cornerRadiusInMeters",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_cornerRadiusInMeters_inline",
                   "Corner radius of the waypoint. When the flight path mode  is `CURVED` the flight path near a waypoint will be  a curve (rounded corner) with radius [0.2,1000]. When there is a corner radius, the aircraft will never  go through the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C)  . Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m).",
            ],
            [
                   "Corner radius of the waypoint. When the flight path mode  is `CURVED` the flight path near a waypoint will be  a curve (rounded corner) with radius [0.2,1000]. When there is a corner radius, the aircraft will never  go through the waypoint. By default, the radius is 0.2 m. If the corner is made of three adjacent waypoints (Short for A,B,C)  . Then the radius of A(short for Ra) plus radius of B(short for Rb) must be smaller than the distance between  A and B. The radius of the first and the last waypoint in a mission does not affect the flight path and it should keep the default value (0.2m).",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_cornerRadiusInMeters_inline",
                   "",
            ],
            [
                   "turnMode",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_turnMode_inline",
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading. `turnMode` relate to behavior between this waypoint and the next waypoint in the mission. Not supported by Mavic 2 Series and Phantom 4 RTK.",
            ],
            [
                   "Determines whether the aircraft will turn clockwise or anticlockwise when changing its heading. `turnMode` relate to behavior between this waypoint and the next waypoint in the mission. Not supported by Mavic 2 Series and Phantom 4 RTK.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_turnMode_inline",
                   "",
            ],
            [
                   "gimbalPitch",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_gimbalPitch_inline",
                   "Gimbal pitch angle when reached this waypoint. This property is used when the `isGimbalPitchRotationEnabled` is TRUE.  The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.",
            ],
            [
                   "Gimbal pitch angle when reached this waypoint. This property is used when the `isGimbalPitchRotationEnabled` is TRUE.  The range of the pitch angle should be gotten from the `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_gimbalPitch_inline",
                   "",
            ],
            [
                   "speed",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_speed_inline",
                   "The base automatic speed of the aircraft as it moves between this waypoint and the next waypoint with range  [0, 15] m/s. By default, it is 0.0 and the aircraft will fly with `getAutoFlightSpeed` of  the waypoint mission. If greater than 0, 'speed' will override `getAutoFlightSpeed`.  This 'speed' can only define movement forward through the waypoint mission in comparison  to `getAutoFlightSpeed` which can be both forward and backwards through a waypoint mission.  Waypoint mission speed priority from highest to lowest is:  1) manual speed adjustment  with remote controller joy sticks  2) 'speed'  3) DJIWaypointMissionOperator_setAutoFlightSpeed</code>   4) `getAutoFlightSpeed`  Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next  waypoint in the mission. In comparison. Only supported by flight controller firmware 3.2.10.0 or above.",
            ],
            [
                   "The base automatic speed of the aircraft as it moves between this waypoint and the next waypoint with range  [0, 15] m/s. By default, it is 0.0 and the aircraft will fly with `getAutoFlightSpeed` of  the waypoint mission. If greater than 0, 'speed' will override `getAutoFlightSpeed`.  This 'speed' can only define movement forward through the waypoint mission in comparison  to `getAutoFlightSpeed` which can be both forward and backwards through a waypoint mission.  Waypoint mission speed priority from highest to lowest is:  1) manual speed adjustment  with remote controller joy sticks  2) 'speed'  3) DJIWaypointMissionOperator_setAutoFlightSpeed</code>   4) `getAutoFlightSpeed`  Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next  waypoint in the mission. In comparison. Only supported by flight controller firmware 3.2.10.0 or above.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_speed_inline",
                   "",
            ],
            [
                   "shootPhotoTimeInterval",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_shootPhotoTimeInterval_inline",
                   "The time interval in seconds when two photos are taken as the aircraft moves between the current waypoint  and the next waypoint. The first photo will be taken as the aircraft leaves the current waypoint. The  maximum value is 6,000.0. The minimum value is above 0.0 and depends on the camera type and the camera  parameters. When the photo file format is JPEG, the recommended minimum value is 2.0. When the photo file  format is RAW, the minimum value is 10.0. If the input exceeds the camera's capability, the pictures will  be taken at the maximum possible speed. The default value is 0.0 and no photo will be taken. For a  waypoint, either `shootPhotoTimeInterval` or `shootPhotoDistanceInterval`  is 0.0. Input with precision of greater than 1 decimal places, will be rounded to 1. Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next waypoint  in the mission. Only supported by flight  controller firmware 3.2.10.0 or above.",
            ],
            [
                   "The time interval in seconds when two photos are taken as the aircraft moves between the current waypoint  and the next waypoint. The first photo will be taken as the aircraft leaves the current waypoint. The  maximum value is 6,000.0. The minimum value is above 0.0 and depends on the camera type and the camera  parameters. When the photo file format is JPEG, the recommended minimum value is 2.0. When the photo file  format is RAW, the minimum value is 10.0. If the input exceeds the camera's capability, the pictures will  be taken at the maximum possible speed. The default value is 0.0 and no photo will be taken. For a  waypoint, either `shootPhotoTimeInterval` or `shootPhotoDistanceInterval`  is 0.0. Input with precision of greater than 1 decimal places, will be rounded to 1. Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next waypoint  in the mission. Only supported by flight  controller firmware 3.2.10.0 or above.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_shootPhotoTimeInterval_inline",
                   "",
            ],
            [
                   "shootPhotoDistanceInterval",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_shootPhotoDistanceInterval_inline",
                   "The distance interval in meters when two photos are taken as the aircraft moves between the current  waypoint and the next waypoint. The maximum value is 6,000.0. The minimum value is above 0.0 and depends  on the camera type, the camera parameters and the flight speed. When the photo file format is JPEG, the time interval between two photos cannot smaller than 2 seconds. When the photo file format is RAW, the  time interval between two photos cannot smaller than 10 seconds. If the input exceeds the camera's  capability, the taken photos may be less than expectation. The default value is 0.0 and no photo will be  taken. For a waypoint, either `shootPhotoTimeInterval`  or `shootPhotoDistanceInterval` is 0.0. Input with precision of greater than 1 decimal  places, will be rounded to 1. Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next  waypoint in the mission. Only supported by flight controller firmware 3.2.10.0 or above.",
            ],
            [
                   "The distance interval in meters when two photos are taken as the aircraft moves between the current  waypoint and the next waypoint. The maximum value is 6,000.0. The minimum value is above 0.0 and depends  on the camera type, the camera parameters and the flight speed. When the photo file format is JPEG, the time interval between two photos cannot smaller than 2 seconds. When the photo file format is RAW, the  time interval between two photos cannot smaller than 10 seconds. If the input exceeds the camera's  capability, the taken photos may be less than expectation. The default value is 0.0 and no photo will be  taken. For a waypoint, either `shootPhotoTimeInterval`  or `shootPhotoDistanceInterval` is 0.0. Input with precision of greater than 1 decimal  places, will be rounded to 1. Warning: 'speed', `shootPhotoTimeInterval`  and `shootPhotoDistanceInterval` relate to behavior between this waypoint and the next  waypoint in the mission. Only supported by flight controller firmware 3.2.10.0 or above.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_shootPhotoDistanceInterval_inline",
                   "",
            ],
            [
                   "waypointActions",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_waypointActions_inline",
                   "Array of all waypoint actions for the respective waypoint. The waypoint actions will be executed  consecutively from the start of the array once the aircraft reaches the waypoint.",
            ],
            [
                   "Array of all waypoint actions for the respective waypoint. The waypoint actions will be executed  consecutively from the start of the array once the aircraft reaches the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_waypointActions_inline",
                   "",
            ],
            [
                   "getActionAtIndex",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_getActionAtIndex_inline",
                   "Gets the action at the specified index.  @param index The specified index.  @return An instance of `WaypointAction`.",
            ],
            [
                   "Gets the action at the specified index.  @param index The specified index.  @return An instance of `WaypointAction`.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_getActionAtIndex_inline",
                   "",
            ],
            [
                   "adjustActionAtIndex",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_adjustActionAtIndex_inline",
                   "Switches the action at the specified index.  @param index The specified index. @param action A DJIWaypointAction object.  @return A boolean value.",
            ],
            [
                   "Switches the action at the specified index.  @param index The specified index. @param action A DJIWaypointAction object.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_adjustActionAtIndex_inline",
                   "",
            ],
            [
                   "actionRepeatTimes",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_actionRepeatTimes_inline",
                   "Determines how many times the set of waypoint actions are repeated. The default value is one time, and  the maximum is `MAX_ACTION_REPEAT_TIMES`.",
            ],
            [
                   "Determines how many times the set of waypoint actions are repeated. The default value is one time, and  the maximum is `MAX_ACTION_REPEAT_TIMES`.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_actionRepeatTimes_inline",
                   "",
            ],
            [
                   "actionTimeoutInSeconds",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_actionTimeoutInSeconds_inline",
                   "The maximum time set to execute all the waypoint actions for a waypoint. If the time while executing the  waypoint actions goes above the time set, the aircraft will stop executing the waypoint actions for the  current waypoint and will move on to the next waypoint. The value of this property must be in the range  of [0, 999] seconds. The default value is 60 seconds.",
            ],
            [
                   "The maximum time set to execute all the waypoint actions for a waypoint. If the time while executing the  waypoint actions goes above the time set, the aircraft will stop executing the waypoint actions for the  current waypoint and will move on to the next waypoint. The value of this property must be in the range  of [0, 999] seconds. The default value is 60 seconds.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_actionTimeoutInSeconds_inline",
                   "",
            ],
            [
                   "addAction",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_addAction_inline",
                   "Adds a waypoint action to a waypoint. The number of waypoint actions should not be larger  than `MAX_ACTION_COUNT`. The action will only be executed when the mission's `getFlightPathMode` property is set  to `NORMAL` and will not be executed when the  mission's `getFlightPathMode` property is set  to `CURVED`. The maximum number of waypoint  actions you can add is 15.  @param action Waypoint action to be added to the waypoint.  @return `true` if the waypoint action has been added to the waypoint. `false`  if the waypoint action count is too high, or if the waypoint action was incorrectly setup.",
            ],
            [
                   "Adds a waypoint action to a waypoint. The number of waypoint actions should not be larger  than `MAX_ACTION_COUNT`. The action will only be executed when the mission's `getFlightPathMode` property is set  to `NORMAL` and will not be executed when the  mission's `getFlightPathMode` property is set  to `CURVED`. The maximum number of waypoint  actions you can add is 15.  @param action Waypoint action to be added to the waypoint.  @return `true` if the waypoint action has been added to the waypoint. `false`  if the waypoint action count is too high, or if the waypoint action was incorrectly setup.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_addAction_inline",
                   "",
            ],
            [
                   "insertAction",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_insertAction_inline",
                   "Insert a waypoint action at index. @return `true`, if the waypoint action has been  inserted. `false` if the waypoint action count is too high or the index is invalid.  @param action Waypoint action to be inserted to the waypoint. @param index Index of the inserted action.  @return A boolean value.",
            ],
            [
                   "Insert a waypoint action at index. @return `true`, if the waypoint action has been  inserted. `false` if the waypoint action count is too high or the index is invalid.  @param action Waypoint action to be inserted to the waypoint. @param index Index of the inserted action.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_insertAction_inline",
                   "",
            ],
            [
                   "removeAction",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeAction_inline",
                   "Removes a waypoint action from the waypoint. @return `true` if the waypoint action  has been removed from the waypoint.  @param action Waypoint action to be removed from the waypoint.  @return A boolean value.",
            ],
            [
                   "Removes a waypoint action from the waypoint. @return `true` if the waypoint action  has been removed from the waypoint.  @param action Waypoint action to be removed from the waypoint.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeAction_inline",
                   "",
            ],
            [
                   "removeActionAtIndex",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeActionAtIndex_inline",
                   "Removes a waypoint action from the waypoint by index. After removal, all actions higher than the index will  be shifted down by one.  @param index The index of the waypoint action to be removed.  @return `true` if waypoint action has been removed from the waypoint.",
            ],
            [
                   "Removes a waypoint action from the waypoint by index. After removal, all actions higher than the index will  be shifted down by one.  @param index The index of the waypoint action to be removed.  @return `true` if waypoint action has been removed from the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeActionAtIndex_inline",
                   "",
            ],
            [
                   "removeAllAction",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeAllActions_inline",
                   "Remove all the actions.",
            ],
            [
                   "Remove all the actions.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_removeAllActions_inline",
                   "",
            ],
            [
                   "WaypointAction",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "",
                   "This class represents a waypoint action for `Waypoint`. It determines what action is performed when  the aircraft reaches the corresponding waypoint.",
            ],
            [
                   "This class represents a waypoint action for `Waypoint`. It determines what action is performed when  the aircraft reaches the corresponding waypoint.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "",
                   "",
            ],
            [
                   "WaypointTurnMode",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_inline",
                   "How the aircraft will turn at a waypoint to transition between headings.",
            ],
            [
                   "How the aircraft will turn at a waypoint to transition between headings.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_inline",
                   "",
            ],
            [
                   "MAX_ACTION_COUNT",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIMaxActionCount_inline",
                   "Maximum number of actions a single waypoint can have. The maximum supported number is 15.",
            ],
            [
                   "Maximum number of actions a single waypoint can have. The maximum supported number is 15.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIMaxActionCount_inline",
                   "",
            ],
            [
                   "MAX_ACTION_REPEAT_TIMES",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIMaxActionRepeatTimes_inline",
                   "Maximum number of times a single waypoint action can be repeated. The maximum supported number is 15.",
            ],
            [
                   "Maximum number of times a single waypoint action can be repeated. The maximum supported number is 15.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIMaxActionRepeatTimes_inline",
                   "",
            ],
            [
                   "actionType",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_actionType_inline",
                   "Waypoint action of type `WaypointActionType` the aircraft will execute this action once  the aircraft reaches the waypoint. All possible actions are defined in the `WaypointActionType` enum.",
            ],
            [
                   "Waypoint action of type `WaypointActionType` the aircraft will execute this action once  the aircraft reaches the waypoint. All possible actions are defined in the `WaypointActionType` enum.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_actionType_inline",
                   "",
            ],
            [
                   "actionParam",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_actionParam_inline",
                   "Action parameter for a waypoint action. See enum `WaypointAction` for details on which  actions use `actionParam`.",
            ],
            [
                   "Action parameter for a waypoint action. See enum `WaypointAction` for details on which  actions use `actionParam`.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_actionParam_inline",
                   "",
            ],
            [
                   "WaypointAction",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_initWithActionType_inline",
                   "Initialize the class with a specific action type and corresponding parameter.  @param actionType A DJIWaypointActionType object. @param actionParam Action parameter of a waypoint action.",
            ],
            [
                   "Initialize the class with a specific action type and corresponding parameter.  @param actionType A DJIWaypointActionType object. @param actionParam Action parameter of a waypoint action.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointAction_initWithActionType_inline",
                   "",
            ],
            [
                   "WaypointActionType",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_inline",
                   "Waypoint action types.",
            ],
            [
                   "Waypoint action types.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_inline",
                   "",
            ],
            [
                   "STAY",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_Stay_inline",
                   "Keeps the aircraft at the waypoint's location. The `actionParam`  parameter will determine how much time in milliseconds the aircraft will stay at the location with  range of [0, 32767] milliseconds.",
            ],
            [
                   "Keeps the aircraft at the waypoint's location. The `actionParam`  parameter will determine how much time in milliseconds the aircraft will stay at the location with  range of [0, 32767] milliseconds.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_Stay_inline",
                   "",
            ],
            [
                   "START_TAKE_PHOTO",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_ShootPhoto_inline",
                   "Starts to shoot a photo. The `actionParam` for the waypoint action will  be ignored. The maximum time set to execute this waypoint action is 6 seconds. If the time while executing  the waypoint action goes above 6 seconds, the aircraft will stop executing the waypoint action and will  move on to the next waypoint action, if one exists.",
            ],
            [
                   "Starts to shoot a photo. The `actionParam` for the waypoint action will  be ignored. The maximum time set to execute this waypoint action is 6 seconds. If the time while executing  the waypoint action goes above 6 seconds, the aircraft will stop executing the waypoint action and will  move on to the next waypoint action, if one exists.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_ShootPhoto_inline",
                   "",
            ],
            [
                   "START_RECORD",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_StartRecord_inline",
                   "Starts recording. The `actionParam` for the waypoint action will be  ignored. The maximum time set to execute this waypoint action is 6 seconds. If the time while executing  the waypoint action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing  the waypoint action and will move on to the next waypoint action, if one exists.",
            ],
            [
                   "Starts recording. The `actionParam` for the waypoint action will be  ignored. The maximum time set to execute this waypoint action is 6 seconds. If the time while executing  the waypoint action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing  the waypoint action and will move on to the next waypoint action, if one exists.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_StartRecord_inline",
                   "",
            ],
            [
                   "STOP_RECORD",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_StopRecord_inline",
                   "Stops recording. The `actionParam` for the waypoint action will be ignored.  The maximum time set to execute this waypoint action is 6 seconds. If the time while executing the waypoint  action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing the waypoint  action and will move on to the next waypoint action, if one exists.",
            ],
            [
                   "Stops recording. The `actionParam` for the waypoint action will be ignored.  The maximum time set to execute this waypoint action is 6 seconds. If the time while executing the waypoint  action goes above 6 seconds (e.g. the camera is not present) the aircraft will stop executing the waypoint  action and will move on to the next waypoint action, if one exists.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_StopRecord_inline",
                   "",
            ],
            [
                   "ROTATE_AIRCRAFT",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_RotateAircraft_inline",
                   "Rotates the aircraft's yaw. The rotation direction is determined by the waypoint's `turnMode` property.  The `actionParam` value must be in the range of [-180, 180] degrees.",
            ],
            [
                   "Rotates the aircraft's yaw. The rotation direction is determined by the waypoint's `turnMode` property.  The `actionParam` value must be in the range of [-180, 180] degrees.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_RotateAircraft_inline",
                   "",
            ],
            [
                   "GIMBAL_PITCH",
                   2,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_RotateGimbalPitch_inline",
                   "Rotates the gimbal's pitch. The range of the pitch angle should be gotten from `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.",
            ],
            [
                   "Rotates the gimbal's pitch. The range of the pitch angle should be gotten from `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.",
                   1,
                   "/Components/Missions/DJIWaypoint_DJIWaypointAction.html",
                   "#DJIWaypoint_DJIWaypointActionType_RotateGimbalPitch_inline",
                   "",
            ],
            [
                   "CLOCKWISE",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_Clockwise_inline",
                   "Changes the heading of the aircraft by rotating the aircraft clockwise.",
            ],
            [
                   "Changes the heading of the aircraft by rotating the aircraft clockwise.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_Clockwise_inline",
                   "",
            ],
            [
                   "COUNTER_CLOCKWISE",
                   2,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_CounterClockwise_inline",
                   "Changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
            ],
            [
                   "Changes the heading of the aircraft by rotating the aircraft anti-clockwise.",
                   1,
                   "/Components/Missions/DJIWaypoint.html",
                   "#DJIWaypoint_DJIWaypointTurnMode_CounterClockwise_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_currentState_inline",
                   "The current state of the executing Follow Me mission.  @return An object of `FollowMeMissionState`.",
            ],
            [
                   "The current state of the executing Follow Me mission.  @return An object of `FollowMeMissionState`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_addListener_inline",
                   "Adds a new listener of all events.  @param listener An interface of `FollowMeMissionOperatorListener`.",
            ],
            [
                   "Adds a new listener of all events.  @param listener An interface of `FollowMeMissionOperatorListener`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_addListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_removeListener_inline",
                   "Removes listener.  @param targetListener An interface of `FollowMeMissionOperatorListener`.",
            ],
            [
                   "Removes listener.  @param targetListener An interface of `FollowMeMissionOperatorListener`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_removeAllListeners_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_startMission_inline",
                   "Starts to execute a Follow Me mission. It can only be called when the `getCurrentState` is  `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become  `EXECUTING`.  @param mission An object of `FollowMeMission`. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Starts to execute a Follow Me mission. It can only be called when the `getCurrentState` is  `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become  `EXECUTING`.  @param mission An object of `FollowMeMission`. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_stopMission_inline",
                   "Stops the executing mission. It can only be called when the  `getCurrentState` is  `EXECUTING`. After a mission is stopped successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Stops the executing mission. It can only be called when the  `getCurrentState` is  `EXECUTING`. After a mission is stopped successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "updateFollowingTarget",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_updateFollowingTarget_inline",
                   "Update the Follow Me mission's target location to follow.  @param location A LocationCoordinate2D object. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Update the Follow Me mission's target location to follow.  @param location A LocationCoordinate2D object. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_updateFollowingTarget_inline",
                   "",
            ],
            [
                   "getFollowingTarget",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_getFollowingTarget_inline",
                   "Get the following target's coordinate location.  @return A location object of LocationCoordinate2D.",
            ],
            [
                   "Get the following target's coordinate location.  @return A location object of LocationCoordinate2D.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperator.html",
                   "#DJIFollowMeMissionOperator_getFollowingTarget_inline",
                   "",
            ],
            [
                   "FollowMeMissionOperatorListener",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "",
                   "Listener interface for Follow Me mission.",
            ],
            [
                   "Listener interface for Follow Me mission.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionUpdate_inline",
                   "All events during mission execution.  @param event An object of `FollowMeMissionEvent`.",
            ],
            [
                   "All events during mission execution.  @param event An object of `FollowMeMissionEvent`.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionStart_inline",
                   "Mission started.",
            ],
            [
                   "Mission started.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionStart_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionFinish_inline",
                   "Mission finished.  @param error Error retrieving the value.",
            ],
            [
                   "Mission finished.  @param error Error retrieving the value.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionOperatorListener.html",
                   "#DJIFollowMeMissionOperatorListener_onExecutionFinish_inline",
                   "",
            ],
            [
                   "FollowMeMission",
                   2,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "",
                   "The class represents a Follow Me mission. In a Follow Me mission, the aircraft is programmed to track and maintain a constant distant relative to some object, such as a person or a moving vehicle. You can use it to make the aircraft follow a GPS device, such as a remote controller with a GPS signal or a mobile device. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark.",
            ],
            [
                   "The class represents a Follow Me mission. In a Follow Me mission, the aircraft is programmed to track and maintain a constant distant relative to some object, such as a person or a moving vehicle. You can use it to make the aircraft follow a GPS device, such as a remote controller with a GPS signal or a mobile device. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark.",
                   1,
                   "/Components/Missions/DJIFollowMeMission.html",
                   "",
                   "",
            ],
            [
                   "FollowMeMissionEvent",
                   2,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "",
                   "This class encapsulates all the state change of the Follow Me mission operator.",
            ],
            [
                   "This class encapsulates all the state change of the Follow Me mission operator.",
                   1,
                   "/Components/Missions/DJIFollowMeMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "setHotpoint",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_hotpoint_inline",
                   "Sets the coordinate of the hotpoint.  @param hotpoint A LocationCoordinate2D object of hotpoint.",
            ],
            [
                   "Sets the coordinate of the hotpoint.  @param hotpoint A LocationCoordinate2D object of hotpoint.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_hotpoint_inline",
                   "",
            ],
            [
                   "getHotpoint",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getHotpoint_inline",
                   "Gets the coordinate of the hotpoint.  @return A object of `LocationCoordinate2D`.",
            ],
            [
                   "Gets the coordinate of the hotpoint.  @return A object of `LocationCoordinate2D`.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getHotpoint_inline",
                   "",
            ],
            [
                   "setStartPoint",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_startPoint_inline",
                   "Set aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @param startPoint An enum value of `HotpointStartPoint`.",
            ],
            [
                   "Set aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @param startPoint An enum value of `HotpointStartPoint`.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_startPoint_inline",
                   "",
            ],
            [
                   "getStartPoint",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getStartPoint_inline",
                   "Get aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @return An enum value of `HotpointStartPoint`.",
            ],
            [
                   "Get aircraft's initial point on the circular flight path when starting the hotpoint  mission.  @return An enum value of `HotpointStartPoint`.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getStartPoint_inline",
                   "",
            ],
            [
                   "setHeading",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_heading_inline",
                   "Aircraft's heading while flying around the hotpoint. It can be pointed toward or away from the hotpoint, forward or backward along its flight route, or can be manually controlled by the remote controller.  @param heading Aircraft heading.",
            ],
            [
                   "Aircraft's heading while flying around the hotpoint. It can be pointed toward or away from the hotpoint, forward or backward along its flight route, or can be manually controlled by the remote controller.  @param heading Aircraft heading.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_heading_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getHeading_inline",
                   "Get the aircraft's heading while flying around the hotpoint. It can be pointed toward or  away from the hotpoint, forward or backward along its flight route, and can be  controlled by the remote controller.  @return Aircraft heading.",
            ],
            [
                   "Get the aircraft's heading while flying around the hotpoint. It can be pointed toward or  away from the hotpoint, forward or backward along its flight route, and can be  controlled by the remote controller.  @return Aircraft heading.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getHeading_inline",
                   "",
            ],
            [
                   "setAltitude",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_altitude_inline",
                   "Sets the altitude of the hotpoint orbit with a range [5,500] meters.  The altitude is relative to the ground altitude from which the aircraft took off.  @param altitude A double value of altitude to set.",
            ],
            [
                   "Sets the altitude of the hotpoint orbit with a range [5,500] meters.  The altitude is relative to the ground altitude from which the aircraft took off.  @param altitude A double value of altitude to set.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_altitude_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getAltitude_inline",
                   "Gets the altitude of the hotpoint orbit with a range [5,500] meters.  The altitude is relative to the ground altitude from which the aircraft took off.  @return A double value of altitude.",
            ],
            [
                   "Gets the altitude of the hotpoint orbit with a range [5,500] meters.  The altitude is relative to the ground altitude from which the aircraft took off.  @return A double value of altitude.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getAltitude_inline",
                   "",
            ],
            [
                   "setRadius",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_radius_inline",
                   "Sets the circular flight path radius with which the aircraft will fly around the hotpoint. The value of this property should be in the range  of [`MIN_RADIUS`, `MAX_RADIUS`] meters.  @param radius A double value of radius to set.",
            ],
            [
                   "Sets the circular flight path radius with which the aircraft will fly around the hotpoint. The value of this property should be in the range  of [`MIN_RADIUS`, `MAX_RADIUS`] meters.  @param radius A double value of radius to set.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_radius_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getRadius_inline",
                   "Gets the circular flight path radius with which the aircraft will fly around the hotpoint. The value of this property should be in the range  of [`MIN_RADIUS`, `MAX_RADIUS`] meters.  @return A double value of radius.",
            ],
            [
                   "Gets the circular flight path radius with which the aircraft will fly around the hotpoint. The value of this property should be in the range  of [`MIN_RADIUS`, `MAX_RADIUS`] meters.  @return A double value of radius.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getRadius_inline",
                   "",
            ],
            [
                   "setAngularVelocity",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_angularVelocity_inline",
                   "Sets the angular velocity in degrees/s of the aircraft as it orbits the hot point. The default value is 20 degrees/s. The maximum angular velocity allowed is relative to the orbit radius.  @param angularVelocity Angular velocity in degrees/s.",
            ],
            [
                   "Sets the angular velocity in degrees/s of the aircraft as it orbits the hot point. The default value is 20 degrees/s. The maximum angular velocity allowed is relative to the orbit radius.  @param angularVelocity Angular velocity in degrees/s.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_angularVelocity_inline",
                   "",
            ],
            [
                   "getAngularVelocity",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getAngularVelocity_inline",
                   "Gets the angular velocity (in degrees/second) of the aircraft as it orbits the hot  point. The default value is 20 degrees/s. The angular velocity is relative to the  orbit radius.  @return An int value of angular velocity.",
            ],
            [
                   "Gets the angular velocity (in degrees/second) of the aircraft as it orbits the hot  point. The default value is 20 degrees/s. The angular velocity is relative to the  orbit radius.  @return An int value of angular velocity.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_getAngularVelocity_inline",
                   "",
            ],
            [
                   "isClockwise",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_isClockwise_inline",
                   "`true` if the aircraft will move in a clockwise direction around the hotpoint.  @return A boolean value to check if is clockwise.",
            ],
            [
                   "`true` if the aircraft will move in a clockwise direction around the hotpoint.  @return A boolean value to check if is clockwise.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_isClockwise_inline",
                   "",
            ],
            [
                   "setClockwise",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_setClockwise_inline",
                   "Set to `true` if the aircraft should move in a clockwise direction around the hotpoint.  @param clockwise `true` for clockwise direction.",
            ],
            [
                   "Set to `true` if the aircraft should move in a clockwise direction around the hotpoint.  @param clockwise `true` for clockwise direction.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_setClockwise_inline",
                   "",
            ],
            [
                   "HotpointMission",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_constructor_inline",
                   "Constructor method for the DJIHotPointMission.  @param hotpoint Location of the hotpoint. @param altitude Altitude of the orbit in meters @param radius Radius of the orbit in meters @param angularVelocity Angular velocity of the aircraft in degrees/s @param isClockwise `true` if the aircraft should move in a clockwise direction around the hotpoint. @param startPoint Initial location on the orbit to start @param heading Aircraft heading during the mission",
            ],
            [
                   "Constructor method for the DJIHotPointMission.  @param hotpoint Location of the hotpoint. @param altitude Altitude of the orbit in meters @param radius Radius of the orbit in meters @param angularVelocity Angular velocity of the aircraft in degrees/s @param isClockwise `true` if the aircraft should move in a clockwise direction around the hotpoint. @param startPoint Initial location on the orbit to start @param heading Aircraft heading during the mission",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_constructor_inline",
                   "",
            ],
            [
                   "resetMissionWithData",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_resetMissionWithData_inline",
                   "Reset Mission with Hotpoint Mission data.  @param data An object of `HotpointMission`.",
            ],
            [
                   "Reset Mission with Hotpoint Mission data.  @param data An object of `HotpointMission`.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_resetMissionWithData_inline",
                   "",
            ],
            [
                   "MAX_RADIUS",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMaxRadius_inline",
                   "Maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. Currently 500m.",
            ],
            [
                   "Maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. Currently 500m.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMaxRadius_inline",
                   "",
            ],
            [
                   "MIN_RADIUS",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMinRadius_inline",
                   "Minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
            ],
            [
                   "Minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMinRadius_inline",
                   "",
            ],
            [
                   "MAX_ALTITUDE",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMaxAltitude_inline",
                   "Maximum altitude in meters for a Hotpoint mission.",
            ],
            [
                   "Maximum altitude in meters for a Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMaxAltitude_inline",
                   "",
            ],
            [
                   "MIN_ALTITUDE",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMinAltitude_inline",
                   "Minimum altitude in meters for a Hotpoint mission.",
            ],
            [
                   "Minimum altitude in meters for a Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointMinAltitude_inline",
                   "",
            ],
            [
                   "HotpointStartPoint",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_inline",
                   "Aircraft starting point relative to the hotpoint.",
            ],
            [
                   "Aircraft starting point relative to the hotpoint.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_inline",
                   "",
            ],
            [
                   "NORTH",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_North_inline",
                   "Start from the North.",
            ],
            [
                   "Start from the North.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_North_inline",
                   "",
            ],
            [
                   "SOUTH",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_South_inline",
                   "Start from the South.",
            ],
            [
                   "Start from the South.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_South_inline",
                   "",
            ],
            [
                   "WEST",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_West_inline",
                   "Start from the West.",
            ],
            [
                   "Start from the West.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_West_inline",
                   "",
            ],
            [
                   "EAST",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_East_inline",
                   "Start from the East.",
            ],
            [
                   "Start from the East.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_East_inline",
                   "",
            ],
            [
                   "NEAREST",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_Nearest_inline",
                   "Start the circle surrounding the hotpoint at the nearest point on the  circle to the aircraft's current location.",
            ],
            [
                   "Start the circle surrounding the hotpoint at the nearest point on the  circle to the aircraft's current location.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointStartPoint_Nearest_inline",
                   "",
            ],
            [
                   "HotpointHeading",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_inline",
                   "Heading of the aircraft while orbiting the hotpoint.",
            ],
            [
                   "Heading of the aircraft while orbiting the hotpoint.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_inline",
                   "",
            ],
            [
                   "ALONG_CIRCLE_LOOKING_FORWARDS",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AlongCircleLookingForward_inline",
                   "Heading is in the forward direction of travel along the circular path.",
            ],
            [
                   "Heading is in the forward direction of travel along the circular path.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AlongCircleLookingForward_inline",
                   "",
            ],
            [
                   "ALONG_CIRCLE_LOOKING_BACKWARDS",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AlongCircleLookingBackward_inline",
                   "Heading is in the backward direction of travel along the circular path.",
            ],
            [
                   "Heading is in the backward direction of travel along the circular path.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AlongCircleLookingBackward_inline",
                   "",
            ],
            [
                   "TOWARDS_HOT_POINT",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_TowardHotPoint_inline",
                   "Heading is toward the hotpoint.",
            ],
            [
                   "Heading is toward the hotpoint.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_TowardHotPoint_inline",
                   "",
            ],
            [
                   "AWAY_FROM_HOT_POINT",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AwayFromHotPoint_inline",
                   "Heading of the aircraft is looking away from the hotpoint. It is in the direction of the vector defined from the hotpoint to the aircraft.",
            ],
            [
                   "Heading of the aircraft is looking away from the hotpoint. It is in the direction of the vector defined from the hotpoint to the aircraft.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_AwayFromHotPoint_inline",
                   "",
            ],
            [
                   "CONTROLLED_BY_REMOTE_CONTROLLER",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_ControlledByRemoteController_inline",
                   "Heading is controlled by the remote controller.",
            ],
            [
                   "Heading is controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_ControlledByRemoteController_inline",
                   "",
            ],
            [
                   "USING_INITIAL_HEADING",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_UsingInitialHeading_inline",
                   "The heading remains the same as the heading of the aircraft when the mission started.",
            ],
            [
                   "The heading remains the same as the heading of the aircraft when the mission started.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "#DJIHotPointMission_DJIHotPointHeading_UsingInitialHeading_inline",
                   "",
            ],
            [
                   "isRunning",
                   2,
                   "/Components/Missions/DJIMissionAction.html",
                   "#DJIMissionAction_isRunning_inline",
                   "`true` if the action is running.  @return A boolean value.",
            ],
            [
                   "`true` if the action is running.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIMissionAction.html",
                   "#DJIMissionAction_isRunning_inline",
                   "",
            ],
            [
                   "TakeOffAction",
                   2,
                   "/Components/Missions/DJITakeOffAction.html",
                   "",
                   "This class represents a take-off action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the aircraft will take-off when the Timeline reaches the action. Note: This action  has 60 seconds TIME_OUT mechanism. Before invoking this action, please make sure the  aircraft's motors are turned off.",
            ],
            [
                   "This class represents a take-off action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the aircraft will take-off when the Timeline reaches the action. Note: This action  has 60 seconds TIME_OUT mechanism. Before invoking this action, please make sure the  aircraft's motors are turned off.",
                   1,
                   "/Components/Missions/DJITakeOffAction.html",
                   "",
                   "",
            ],
            [
                   "AircraftYawAction",
                   2,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "",
                   "This class represents an aircraft yaw rotation action to be scheduled on the Mission  Control timeline. By creating an object of this class and adding it to the timeline,  an aircraft will rotate around yaw by the specified angle with the specified speed  when the Timeline reaches the action.",
            ],
            [
                   "This class represents an aircraft yaw rotation action to be scheduled on the Mission  Control timeline. By creating an object of this class and adding it to the timeline,  an aircraft will rotate around yaw by the specified angle with the specified speed  when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "",
                   "",
            ],
            [
                   "GoToAction",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "",
                   "This class represents a go-to action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline, the aircraft will go to a specified location when the Timeline reaches the action.",
            ],
            [
                   "This class represents a go-to action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline, the aircraft will go to a specified location when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "",
                   "",
            ],
            [
                   "GoHomeAction",
                   2,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "",
                   "This class represents a go-home action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline, the aircraft will go home when the Timeline reaches the action.",
            ],
            [
                   "This class represents a go-home action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline, the aircraft will go home when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "",
                   "",
            ],
            [
                   "HotpointAction",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "",
                   "This class represents a hotpoint action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the aircraft will fly along a portion of a circle centered on a location of interest when the Timeline reaches the action.",
            ],
            [
                   "This class represents a hotpoint action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the aircraft will fly along a portion of a circle centered on a location of interest when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "",
                   "",
            ],
            [
                   "GimbalAttitudeAction",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "",
                   "This class represents a gimbal movement action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera's gimbal will move to the specified attitude when the Timeline reaches the action. Please be notified that the PitchRangeExtensionEnabled of Gimbal is set to true by  default if the pitch value in user specified attitude is bigger than 0.",
            ],
            [
                   "This class represents a gimbal movement action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera's gimbal will move to the specified attitude when the Timeline reaches the action. Please be notified that the PitchRangeExtensionEnabled of Gimbal is set to true by  default if the pitch value in user specified attitude is bigger than 0.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "",
                   "",
            ],
            [
                   "RecordVideoAction",
                   2,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "",
                   "This class represents a video recording action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera can start or stop video recording when the Timeline reaches the action.",
            ],
            [
                   "This class represents a video recording action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera can start or stop video recording when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "",
                   "",
            ],
            [
                   "ShootPhotoAction",
                   2,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "",
                   "This class represents a shoot photo action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera can shoot a photo when the Timeline reaches the action.",
            ],
            [
                   "This class represents a shoot photo action used as an element in a Timeline mission. By creating an object of this class and adding it to Mission Control's Timeline,  the camera can shoot a photo when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "",
                   "",
            ],
            [
                   "LandAction",
                   2,
                   "/Components/Missions/DJILandAction.html",
                   "",
                   "This class represents a land action used as an element in a Timeline mission. By creating  an object of this class and adding it to Mission Control's Timeline, the aircraft will  land at its current location when the Timeline reaches the action.",
            ],
            [
                   "This class represents a land action used as an element in a Timeline mission. By creating  an object of this class and adding it to Mission Control's Timeline, the aircraft will  land at its current location when the Timeline reaches the action.",
                   1,
                   "/Components/Missions/DJILandAction.html",
                   "",
                   "",
            ],
            [
                   "setAutoConfirmLandingEnabled",
                   2,
                   "/Components/Missions/DJILandAction.html",
                   "#DJILandAction_autoConfirmLandingEnabled_inline",
                   "`true` to enable automatic confirmation during landing. For flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue  (see `confirmLanding`). Enabling this auto confirmation, allows the  aircraft to continue landing without the user's confirmation during the Timeline execution.  For firmware that does not require landing confirmation, the value is ignored. The default  value is `true`.  @param enable Enable automatic confirmation during landing.",
            ],
            [
                   "`true` to enable automatic confirmation during landing. For flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue  (see `confirmLanding`). Enabling this auto confirmation, allows the  aircraft to continue landing without the user's confirmation during the Timeline execution.  For firmware that does not require landing confirmation, the value is ignored. The default  value is `true`.  @param enable Enable automatic confirmation during landing.",
                   1,
                   "/Components/Missions/DJILandAction.html",
                   "#DJILandAction_autoConfirmLandingEnabled_inline",
                   "",
            ],
            [
                   "getAutoConfirmLandingEnabled",
                   2,
                   "/Components/Missions/DJILandAction.html",
                   "#DJILandAction_getAutoConfirmLandingEnabled_inline",
                   "For flight controller firmware version 3.2.0.0 or above, when the clearance between the aircraft  and the ground is less than 0.3m, the aircraft will pause landing and wait for the user's  confirmation to continue. Enabling the auto confirmation, allows the aircraft to  continue  landing without the user's confirmation during the timeline execution. For firmware that does  not require landing confirmation, the value is ignored. The default value  is `true`.  @return A boolean value.",
            ],
            [
                   "For flight controller firmware version 3.2.0.0 or above, when the clearance between the aircraft  and the ground is less than 0.3m, the aircraft will pause landing and wait for the user's  confirmation to continue. Enabling the auto confirmation, allows the aircraft to  continue  landing without the user's confirmation during the timeline execution. For firmware that does  not require landing confirmation, the value is ignored. The default value  is `true`.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJILandAction.html",
                   "#DJILandAction_getAutoConfirmLandingEnabled_inline",
                   "",
            ],
            [
                   "AircraftYawAction",
                   2,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "#DJIAircraftYawAction_initWithRelativeAngleAndAngularVelocity_inline",
                   "Initialize with a yaw angle relative to current heading and an angular velocity. The angular velocity has a range of [0, 100] degrees/s and a default value of 20 degrees/s.  @param angle Angle in degrees. @param velocity Velocity in degrees/s.",
            ],
            [
                   "Initialize with a yaw angle relative to current heading and an angular velocity. The angular velocity has a range of [0, 100] degrees/s and a default value of 20 degrees/s.  @param angle Angle in degrees. @param velocity Velocity in degrees/s.",
                   1,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "#DJIAircraftYawAction_initWithRelativeAngleAndAngularVelocity_inline",
                   "",
            ],
            [
                   "AircraftYawAction",
                   2,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "#DJIAircraftYawAction_initWithAngleAndIsAbsolute_inline",
                   "Initialize with a yaw angle relative to current heading or absolute heading against true north.  The range of angle is [-180, 180]. This initializer should be preferred when accuracy of the angle  is more of a priority than smooth yaw movement.  @param angle Angle in degrees. @param isAbsolute `true` means angle is the absolute heading against true north. `false` means  angle is relative to the current heading.",
            ],
            [
                   "Initialize with a yaw angle relative to current heading or absolute heading against true north.  The range of angle is [-180, 180]. This initializer should be preferred when accuracy of the angle  is more of a priority than smooth yaw movement.  @param angle Angle in degrees. @param isAbsolute `true` means angle is the absolute heading against true north. `false` means  angle is relative to the current heading.",
                   1,
                   "/Components/Missions/DJIAircraftYawAction.html",
                   "#DJIAircraftYawAction_initWithAngleAndIsAbsolute_inline",
                   "",
            ],
            [
                   "AircraftYawActionError",
                   2,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "",
                   "The error domain used to describe errors produced by the `AircraftYawAction` object.",
            ],
            [
                   "The error domain used to describe errors produced by the `AircraftYawAction` object.",
                   1,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "",
                   "",
            ],
            [
                   "INVALID_ROTATION_SPEED",
                   2,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_InvalidRotationSpeed_inline",
                   "Set rotation speed is not within valid range [0, 100].",
            ],
            [
                   "Set rotation speed is not within valid range [0, 100].",
                   1,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_InvalidRotationSpeed_inline",
                   "",
            ],
            [
                   "INVALID_ANGLE_VALUE",
                   2,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_InvalidAngleValue_inline",
                   "Set angle value is not within valid range [-180, 180].",
            ],
            [
                   "Set angle value is not within valid range [-180, 180].",
                   1,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_InvalidAngleValue_inline",
                   "",
            ],
            [
                   "CANNOT_RUN_VIRTUAL_STICK",
                   2,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_CannotRunVirtualStick_inline",
                   "Aircraft currently in virtual sticks mode.",
            ],
            [
                   "Aircraft currently in virtual sticks mode.",
                   1,
                   "/Components/Missions/DJIAircraftYawAction_DJIAircraftYawActionError.html",
                   "#DJIAircraftYawAction_DJIAircraftYawActionError_CannotRunVirtualStick_inline",
                   "",
            ],
            [
                   "GimbalAttitudeAction",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_initWithAttitude_inline",
                   "Initialize instance with gimbal target attitude. The value of `GimbalMode` is `UNKNOWN`.  @param attitude Gimbal target attitude.",
            ],
            [
                   "Initialize instance with gimbal target attitude. The value of `GimbalMode` is `UNKNOWN`.  @param attitude Gimbal target attitude.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_initWithAttitude_inline",
                   "",
            ],
            [
                   "setGimbalIndex",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setGimbalIndex_inline",
                   "Set the expected action gimbal index. For example there are two gimbals in M210, if you want to run action on Gimbal I, you can either set  the index as 0 or do nothing because of the default index is 0; if you want to run action on Gimbal II, you need set the index as 1. Default  index is 0 if user does not call this method to specify the index.  @param index Index of the gimbal on which the action is expected to run.",
            ],
            [
                   "Set the expected action gimbal index. For example there are two gimbals in M210, if you want to run action on Gimbal I, you can either set  the index as 0 or do nothing because of the default index is 0; if you want to run action on Gimbal II, you need set the index as 1. Default  index is 0 if user does not call this method to specify the index.  @param index Index of the gimbal on which the action is expected to run.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setGimbalIndex_inline",
                   "",
            ],
            [
                   "setCompletionTime",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setCompletionTime_inline",
                   "Completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. Default is 1 second.  @param completionTime A double value of completion time.",
            ],
            [
                   "Completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. Default is 1 second.  @param completionTime A double value of completion time.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setCompletionTime_inline",
                   "",
            ],
            [
                   "getGimbalMode",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_getGimbalMode_inline",
                   "Current gimbal working mode.  @return Gimbal Mode.",
            ],
            [
                   "Current gimbal working mode.  @return Gimbal Mode.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_getGimbalMode_inline",
                   "",
            ],
            [
                   "setGimbalMode",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setGimbalMode_inline",
                   "For the GimbalAttitudeAction, either FREE or YAW_FOLLOW mode is recommended.  If the gimbal mode is not set, the default mode is YAW_FOLLOW. Check the  details on the description of each work mode in `GimbalMode` enum definition.  @param mode One of the work mode in `GimbalMode`.",
            ],
            [
                   "For the GimbalAttitudeAction, either FREE or YAW_FOLLOW mode is recommended.  If the gimbal mode is not set, the default mode is YAW_FOLLOW. Check the  details on the description of each work mode in `GimbalMode` enum definition.  @param mode One of the work mode in `GimbalMode`.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_setGimbalMode_inline",
                   "",
            ],
            [
                   "getCompletionTime",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_getCompletionTime_inline",
                   "Completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. Default is 1 second.  @return Time in seconds.",
            ],
            [
                   "Completion time, in seconds, for the gimbal to go to the target attitude  from current attitude. Default is 1 second.  @return Time in seconds.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_getCompletionTime_inline",
                   "",
            ],
            [
                   "getTargetAttitude",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_targetAttitude_inline",
                   "Target gimbal attitude.  @return A `Attitude` object.",
            ],
            [
                   "Target gimbal attitude.  @return A `Attitude` object.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction.html",
                   "#DJIGimbalAttitudeAction_targetAttitude_inline",
                   "",
            ],
            [
                   "GimbalAttitudeActionError",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "",
                   "A list of all errors relative to the gimbal attitude action.",
            ],
            [
                   "A list of all errors relative to the gimbal attitude action.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "",
                   "",
            ],
            [
                   "YAW_OUTSIDE_MAX_CAPABILITIES",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_YawOutsideMaxCapabilities_inline",
                   "Yaw value passed is beyond the max capabilities of the gimbal.",
            ],
            [
                   "Yaw value passed is beyond the max capabilities of the gimbal.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_YawOutsideMaxCapabilities_inline",
                   "",
            ],
            [
                   "PITCH_OUTSIDE_MAX_CAPABILITIES",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_PitchOutsideMaxCapabilities_inline",
                   "Pitch value passed is beyond the max capabilities of the gimbal.",
            ],
            [
                   "Pitch value passed is beyond the max capabilities of the gimbal.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_PitchOutsideMaxCapabilities_inline",
                   "",
            ],
            [
                   "ROLL_OUTSIDE_MAX_CAPABILITIES",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_RollOutsideMaxCapabilities_inline",
                   "Roll value passed is beyond the max capabilities of the gimbal.",
            ],
            [
                   "Roll value passed is beyond the max capabilities of the gimbal.",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_RollOutsideMaxCapabilities_inline",
                   "",
            ],
            [
                   "COMPLETION_TIME_INVALID",
                   2,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_CompletionTimeInvalid_inline",
                   "Completion Time value passed is invalid (less than 0).",
            ],
            [
                   "Completion Time value passed is invalid (less than 0).",
                   1,
                   "/Components/Missions/DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError.html",
                   "#DJIGimbalAttitudeAction_DJIGimbalAttitudeActionError_CompletionTimeInvalid_inline",
                   "",
            ],
            [
                   "setAutoConfirmLandingEnabled",
                   2,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "#DJIGoHomeAction_setAutoConfirmLandingEnabled_inline",
                   "`true` to enable automatic confirmation during landing. For flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue.  Enabling the auto confirmation, allows the aircraft to continue landing without the user's  confirmation during the timeline execution. For firmware that does not require landing  confirmation, the value is ignored. The default value is `true`.  @param enable Enable automatic confirmation during landing.",
            ],
            [
                   "`true` to enable automatic confirmation during landing. For flight controller firmware  version 3.2.0.0 or above, when the clearance between the aircraft and the ground is less  than 0.3m, the aircraft will pause landing and wait for the user's confirmation to continue.  Enabling the auto confirmation, allows the aircraft to continue landing without the user's  confirmation during the timeline execution. For firmware that does not require landing  confirmation, the value is ignored. The default value is `true`.  @param enable Enable automatic confirmation during landing.",
                   1,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "#DJIGoHomeAction_setAutoConfirmLandingEnabled_inline",
                   "",
            ],
            [
                   "getAutoConfirmLandingEnabled",
                   2,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "#DJIGoHomeAction_getAutoConfirmLandingEnabled_inline",
                   "For flight controller firmware version 3.2.0.0 or above, when the clearance between the  aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for the  user's confirmation to continue. Enabling the auto confirmation, allows the aircraft to  continue landing without the user's confirmation during the timeline execution. For firmware that  does not require landing confirmation, the value is ignored. The default value  is `true`.  @return A boolean value.",
            ],
            [
                   "For flight controller firmware version 3.2.0.0 or above, when the clearance between the  aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for the  user's confirmation to continue. Enabling the auto confirmation, allows the aircraft to  continue landing without the user's confirmation during the timeline execution. For firmware that  does not require landing confirmation, the value is ignored. The default value  is `true`.  @return A boolean value.",
                   1,
                   "/Components/Missions/DJIGoHomeAction.html",
                   "#DJIGoHomeAction_getAutoConfirmLandingEnabled_inline",
                   "",
            ],
            [
                   "GoToAction",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithCoordinate_inline",
                   "Go to the specified coordinate from the current aircraft position.  The actionType of this object is set to GoToActionType.COORDINATE.  @param coordinate Target coordinate.",
            ],
            [
                   "Go to the specified coordinate from the current aircraft position.  The actionType of this object is set to GoToActionType.COORDINATE.  @param coordinate Target coordinate.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithCoordinate_inline",
                   "",
            ],
            [
                   "GoToAction",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithAltitude_inline",
                   "Go to the specified altitude (in meters) from the current aircraft position. The actionType of this object is set to GoToActionType.ALTITUDE.  @param altitude Target altitude in meters.",
            ],
            [
                   "Go to the specified altitude (in meters) from the current aircraft position. The actionType of this object is set to GoToActionType.ALTITUDE.  @param altitude Target altitude in meters.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithAltitude_inline",
                   "",
            ],
            [
                   "GoToAction",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithCoordinateWithAltitude_inline",
                   "Go to the specified coordinate and altitude (in meters) from the current aircraft position.   The actionType of this object is set to GoToActionType.COORDINATE_AND_ALTITUDE.  @param coordinate Target coordinate. @param altitude Target altitude in meters.",
            ],
            [
                   "Go to the specified coordinate and altitude (in meters) from the current aircraft position.   The actionType of this object is set to GoToActionType.COORDINATE_AND_ALTITUDE.  @param coordinate Target coordinate. @param altitude Target altitude in meters.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_initWithCoordinateWithAltitude_inline",
                   "",
            ],
            [
                   "setFlightSpeed",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_setFlightSpeed_inline",
                   "Flight speed of the aircraft when going to the target location. Default is 8 m/s.  @param flightSpeed A float value of the flight speed.",
            ],
            [
                   "Flight speed of the aircraft when going to the target location. Default is 8 m/s.  @param flightSpeed A float value of the flight speed.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_setFlightSpeed_inline",
                   "",
            ],
            [
                   "getFlightSpeed",
                   2,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_getFlightSpeed_inline",
                   "Flight speed of the aircraft when going to the target location. Default is 8 m/s.  @return A float value of flight speed.",
            ],
            [
                   "Flight speed of the aircraft when going to the target location. Default is 8 m/s.  @return A float value of flight speed.",
                   1,
                   "/Components/Missions/DJIGoToAction.html",
                   "#DJIGoToAction_getFlightSpeed_inline",
                   "",
            ],
            [
                   "GoToActionError",
                   2,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "",
                   "The error codes for the `GoToAction`.",
            ],
            [
                   "The error codes for the `GoToAction`.",
                   1,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "",
                   "",
            ],
            [
                   "INVALID_ALTITUDE",
                   2,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidAltitude_inline",
                   "Altitude of the `GoToAction` Waypoint mission is not valid, its value should  be in the range [-200, 500].",
            ],
            [
                   "Altitude of the `GoToAction` Waypoint mission is not valid, its value should  be in the range [-200, 500].",
                   1,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidAltitude_inline",
                   "",
            ],
            [
                   "INVALID_COORDINATE",
                   2,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidCoordinates_inline",
                   "GPS Coordinates of the GoToAction Waypoint is not valid. Latitude value should be in  the range [-90f, 90f] and longitude value should be in the range [-180f, 180f].",
            ],
            [
                   "GPS Coordinates of the GoToAction Waypoint is not valid. Latitude value should be in  the range [-90f, 90f] and longitude value should be in the range [-180f, 180f].",
                   1,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidCoordinates_inline",
                   "",
            ],
            [
                   "INVALID_FLIGHT_SPEED",
                   2,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidFlightSpeed_inline",
                   "Flight speed of the GoToAction Waypoint is not valid. Value should be in range [2, 15] m/s.",
            ],
            [
                   "Flight speed of the GoToAction Waypoint is not valid. Value should be in range [2, 15] m/s.",
                   1,
                   "/Components/Missions/DJIGoToAction_DJIGoToActionError.html",
                   "#DJIGoToAction_DJIGoToActionError_InvalidFlightSpeed_inline",
                   "",
            ],
            [
                   "newRecordVideoActionWithDuration",
                   2,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithDuration_inline",
                   "Initialize instance with video recording duration in seconds.  @param duration Time in seconds.  @return An instance of `RecordVideoAction`",
            ],
            [
                   "Initialize instance with video recording duration in seconds.  @param duration Time in seconds.  @return An instance of `RecordVideoAction`",
                   1,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithDuration_inline",
                   "",
            ],
            [
                   "newStartRecordVideoAction",
                   2,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithStartRecordVideo_inline",
                   "Initialize instance for start video recording only.  @return An instance of `RecordVideoAction`",
            ],
            [
                   "Initialize instance for start video recording only.  @return An instance of `RecordVideoAction`",
                   1,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithStartRecordVideo_inline",
                   "",
            ],
            [
                   "newStopRecordVideoAction",
                   2,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithStopRecordVideo_inline",
                   "Initialize instance for stop video recording only.  @return An instance of `RecordVideoAction`",
            ],
            [
                   "Initialize instance for stop video recording only.  @return An instance of `RecordVideoAction`",
                   1,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_initWithStopRecordVideo_inline",
                   "",
            ],
            [
                   "setCameraIndex",
                   2,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_setCameraIndex_inline",
                   "Set the expected action camera index. For example there are two  cameras in M210, if you want to run action on camera I, you can  either set the index as 0 or do nothing because of the default  index is 0; if you want to run action on camera II, you need set  the index as 1. Default index is 0 if user does not call this method  to specify the index.  @param index Index of the camera on which the action is expected to run.",
            ],
            [
                   "Set the expected action camera index. For example there are two  cameras in M210, if you want to run action on camera I, you can  either set the index as 0 or do nothing because of the default  index is 0; if you want to run action on camera II, you need set  the index as 1. Default index is 0 if user does not call this method  to specify the index.  @param index Index of the camera on which the action is expected to run.",
                   1,
                   "/Components/Missions/DJIRecordVideoAction.html",
                   "#DJIRecordVideoAction_setCameraIndex_inline",
                   "",
            ],
            [
                   "RecordVideoActionError",
                   2,
                   "/Components/Missions/DJIRecordVideoAction_DJIRecordVideoActionError.html",
                   "",
                   "Error codes for record video actions.",
            ],
            [
                   "Error codes for record video actions.",
                   1,
                   "/Components/Missions/DJIRecordVideoAction_DJIRecordVideoActionError.html",
                   "",
                   "",
            ],
            [
                   "INVALID_DURATION",
                   2,
                   "/Components/Missions/DJIRecordVideoAction_DJIRecordVideoActionError.html",
                   "#DJIRecordVideoAction_DJIRecordVideoActionError_InvalidDuration_inline",
                   "Duration value is invalid (less than 0).",
            ],
            [
                   "Duration value is invalid (less than 0).",
                   1,
                   "/Components/Missions/DJIRecordVideoAction_DJIRecordVideoActionError.html",
                   "#DJIRecordVideoAction_DJIRecordVideoActionError_InvalidDuration_inline",
                   "",
            ],
            [
                   "newShootSinglePhotoAction",
                   2,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithSingleShootPhoto_inline",
                   "Initialize object to shoot a single photo.  @return An instance of `ShootPhotoAction`.",
            ],
            [
                   "Initialize object to shoot a single photo.  @return An instance of `ShootPhotoAction`.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithSingleShootPhoto_inline",
                   "",
            ],
            [
                   "newShootIntervalPhotoAction",
                   2,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithPhotoCountAndTimeInterval_inline",
                   "Initialize object to shoot multiple photos.  @param count Photo count. @param interval Time interval in seconds between shooting photos.  @return An instance of `ShootPhotoAction`.",
            ],
            [
                   "Initialize object to shoot multiple photos.  @param count Photo count. @param interval Time interval in seconds between shooting photos.  @return An instance of `ShootPhotoAction`.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithPhotoCountAndTimeInterval_inline",
                   "",
            ],
            [
                   "newStopIntervalPhotoAction",
                   2,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithStopShootPhoto_inline",
                   "Initialize object to stop shooting photos. Only works if there was a  previous `ShootPhotoAction` in the timeline which started shooting photos using  the `newShootIntervalPhotoAction` initializer with `wait` set to `false`.  @return An instance of `ShootPhotoAction`.",
            ],
            [
                   "Initialize object to stop shooting photos. Only works if there was a  previous `ShootPhotoAction` in the timeline which started shooting photos using  the `newShootIntervalPhotoAction` initializer with `wait` set to `false`.  @return An instance of `ShootPhotoAction`.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_initWithStopShootPhoto_inline",
                   "",
            ],
            [
                   "setCameraIndex",
                   2,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_setCameraIndex_inline",
                   "Set the expected action camera index. For example there are two cameras in M210, if you want to run action  on camera I, you can either set the index as 0 or do nothing because of the default index is 0; if you want  to run action on camera II, you need set the index as 1. Default index is 0 if user does not call this method  to specify the index.  @param index Index of the camera on which the action is expected to run.",
            ],
            [
                   "Set the expected action camera index. For example there are two cameras in M210, if you want to run action  on camera I, you can either set the index as 0 or do nothing because of the default index is 0; if you want  to run action on camera II, you need set the index as 1. Default index is 0 if user does not call this method  to specify the index.  @param index Index of the camera on which the action is expected to run.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction.html",
                   "#DJIShootPhotoAction_setCameraIndex_inline",
                   "",
            ],
            [
                   "ShootPhotoActionError",
                   2,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "",
                   "Error codes for `ShootPhotoAction` specific errors.",
            ],
            [
                   "Error codes for `ShootPhotoAction` specific errors.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "",
                   "",
            ],
            [
                   "INVALID_PHOTO_COUNT",
                   2,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "#DJIShootPhotoAction_DJIShootPhotoActionError_InvalidPhotoCount_inline",
                   "Invalid value for photo count.",
            ],
            [
                   "Invalid value for photo count.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "#DJIShootPhotoAction_DJIShootPhotoActionError_InvalidPhotoCount_inline",
                   "",
            ],
            [
                   "INVALID_TIME_INTERVAL",
                   2,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "#DJIShootPhotoAction_DJIShootPhotoActionError_InvalidTimeInterval_inline",
                   "Invalid value for time interval.",
            ],
            [
                   "Invalid value for time interval.",
                   1,
                   "/Components/Missions/DJIShootPhotoAction_DJIShootPhotoActionError.html",
                   "#DJIShootPhotoAction_DJIShootPhotoActionError_InvalidTimeInterval_inline",
                   "",
            ],
            [
                   "HotpointAction",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_initWithMission_inline",
                   "Initialize with hotpoint mission. The Hotpoint action  will automatically stop after one complete orbit (360 degrees).  @param hotpointMission An object of `HotpointMission`.",
            ],
            [
                   "Initialize with hotpoint mission. The Hotpoint action  will automatically stop after one complete orbit (360 degrees).  @param hotpointMission An object of `HotpointMission`.",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_initWithMission_inline",
                   "",
            ],
            [
                   "HotpointAction",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_initWithMissionSurroundingAngle_inline",
                   "Initialize with a hotpoint mission and the angular distance the  aircraft should travel within the orbit.  @param mission An object of `HotpointMission`. @param surroundingAngle Angle in degrees.",
            ],
            [
                   "Initialize with a hotpoint mission and the angular distance the  aircraft should travel within the orbit.  @param mission An object of `HotpointMission`. @param surroundingAngle Angle in degrees.",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_initWithMissionSurroundingAngle_inline",
                   "",
            ],
            [
                   "setSurroundingAngle",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_surroundingAngle_inline",
                   "The angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. The default is 360 degrees.  @param surroundingAngle Angle in degrees",
            ],
            [
                   "The angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. The default is 360 degrees.  @param surroundingAngle Angle in degrees",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_surroundingAngle_inline",
                   "",
            ],
            [
                   "getHotpointMission",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_mission_inline",
                   "The hotpoint mission which is associated with this action.  @return A `HotpointMission` object.",
            ],
            [
                   "The hotpoint mission which is associated with this action.  @return A `HotpointMission` object.",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_mission_inline",
                   "",
            ],
            [
                   "getSurroundingAngle",
                   2,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_getSurroundingAngle_inline",
                   "The angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. The default is 360 degrees.  @return Angle in degrees.",
            ],
            [
                   "The angular distance in degrees the aircraft will travel in the  orbit of the hotpoint. The default is 360 degrees.  @return Angle in degrees.",
                   1,
                   "/Components/Missions/DJIHotpointAction.html",
                   "#DJIHotpointAction_getSurroundingAngle_inline",
                   "",
            ],
            [
                   "elementFromWaypointMission",
                   2,
                   "/Components/Missions/TimelineMission.html",
                   "#TimelineMission_elementFromWaypointMission_inline",
                   "Create TimelineElement from a WaypointMission. This Element  then can be used in Timeline.  @param mission A `WaypointMission` object.  @return A `TimelineElement` object.",
            ],
            [
                   "Create TimelineElement from a WaypointMission. This Element  then can be used in Timeline.  @param mission A `WaypointMission` object.  @return A `TimelineElement` object.",
                   1,
                   "/Components/Missions/TimelineMission.html",
                   "#TimelineMission_elementFromWaypointMission_inline",
                   "",
            ],
            [
                   "getMissionObject",
                   2,
                   "/Components/Missions/TimelineMission.html",
                   "#TimelineMission_getMissionObject_inline",
                   "Get the Mission object that is being contained inside the wrapper class.  @return Get the Mission object.",
            ],
            [
                   "Get the Mission object that is being contained inside the wrapper class.  @return Get the Mission object.",
                   1,
                   "/Components/Missions/TimelineMission.html",
                   "#TimelineMission_getMissionObject_inline",
                   "",
            ],
            [
                   "getWaypointMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_waypointMissionOperator_inline",
                   "Returns the operator for waypoint missions.  @return A Waypoint mission operator object.",
            ],
            [
                   "Returns the operator for waypoint missions.  @return A Waypoint mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_waypointMissionOperator_inline",
                   "",
            ],
            [
                   "getHotpointMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_hotpointMissionOperator_inline",
                   "Returns the operator for Hotpoint missions.  @return A Hotpoint mission operator object.",
            ],
            [
                   "Returns the operator for Hotpoint missions.  @return A Hotpoint mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_hotpointMissionOperator_inline",
                   "",
            ],
            [
                   "getFollowMeMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_followMeMissionOperator_inline",
                   "Returns the operator for Follow Me missions.  @return A Follow Me mission operator object.",
            ],
            [
                   "Returns the operator for Follow Me missions.  @return A Follow Me mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_followMeMissionOperator_inline",
                   "",
            ],
            [
                   "getActiveTrackOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_activeTrackMissionOperator_inline",
                   "Returns the operator for ActiveTrack missions.  @return An ActiveTrack mission operator object.",
            ],
            [
                   "Returns the operator for ActiveTrack missions.  @return An ActiveTrack mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_activeTrackMissionOperator_inline",
                   "",
            ],
            [
                   "getTapFlyMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_tapFlyMissionOperator_inline",
                   "Returns the operator for TapFly missions.  @return A TapFly mission operator object.",
            ],
            [
                   "Returns the operator for TapFly missions.  @return A TapFly mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_tapFlyMissionOperator_inline",
                   "",
            ],
            [
                   "getPanoramaMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_panoramaMissionOperator_inline",
                   "Returns the operator for Panorama missions.  @return A Panorama mission operator object.",
            ],
            [
                   "Returns the operator for Panorama missions.  @return A Panorama mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_panoramaMissionOperator_inline",
                   "",
            ],
            [
                   "getIntelligentHotpointMissionOperator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_intelligentHotpointMissionOperator_inline",
                   "Returns the operator for Intelligent Hotpoint missions.  @return An Intelligent Hotpoint mission operator object.",
            ],
            [
                   "Returns the operator for Intelligent Hotpoint missions.  @return An Intelligent Hotpoint mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_intelligentHotpointMissionOperator_inline",
                   "",
            ],
            [
                   "getWaypointMissionV2Operator",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_waypointV2MissionOperator_inline",
                   "Returns the operator for waypoint v2 mission. Only Supported by Matrice 300 RTK.  @return An waypoint v2 mission operator object.",
            ],
            [
                   "Returns the operator for waypoint v2 mission. Only Supported by Matrice 300 RTK.  @return An waypoint v2 mission operator object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_waypointV2MissionOperator_inline",
                   "",
            ],
            [
                   "scheduleElement",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElement_inline",
                   "Adds an element to the end of the Timeline.  @param element A `TimelineElement` element.  @return The first error if one occurred.",
            ],
            [
                   "Adds an element to the end of the Timeline.  @param element A `TimelineElement` element.  @return The first error if one occurred.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElement_inline",
                   "",
            ],
            [
                   "scheduleElements",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElements_inline",
                   "Adds a list of elements to the end of the Timeline.  @param elements A list of `TimelineElement` elements.  @return The first error if one occurred. ",
            ],
            [
                   "Adds a list of elements to the end of the Timeline.  @param elements A list of `TimelineElement` elements.  @return The first error if one occurred. ",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElements_inline",
                   "",
            ],
            [
                   "scheduleElementAtIndex",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElementAtIndex_inline",
                   "Insert an element into the Timeline at an index.  @param element A `TimelineElement` element @param index The element index to insert the new element before.  @return The first error if one occurred.",
            ],
            [
                   "Insert an element into the Timeline at an index.  @param element A `TimelineElement` element @param index The element index to insert the new element before.  @return The first error if one occurred.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleElementAtIndex_inline",
                   "",
            ],
            [
                   "unscheduleElement",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleElement_inline",
                   "Remove element from the Timeline. If the same element was used more than once in the  Timeline, then the first one will be removed.  @param element A `TimelineElement` element that is already in the Timeline.",
            ],
            [
                   "Remove element from the Timeline. If the same element was used more than once in the  Timeline, then the first one will be removed.  @param element A `TimelineElement` element that is already in the Timeline.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleElement_inline",
                   "",
            ],
            [
                   "unscheduleElementAtIndex",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleElementAtIndex_inline",
                   "Removes the Element at an index in the Timeline.  @param index Index of element to remove.",
            ],
            [
                   "Removes the Element at an index in the Timeline.  @param index Index of element to remove.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleElementAtIndex_inline",
                   "",
            ],
            [
                   "scheduledElementAtIndex",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduledElementAtIndex_inline",
                   "Returns the element at a given index in the Timeline.  @param index An element index in the Timeline.  @return Either a mission, an element or `null` if nothing was at the given index.",
            ],
            [
                   "Returns the element at a given index in the Timeline.  @param index An element index in the Timeline.  @return Either a mission, an element or `null` if nothing was at the given index.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduledElementAtIndex_inline",
                   "",
            ],
            [
                   "scheduledCount",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduledCount_inline",
                   "Returns the number of elements within the Timeline.  @return Element count.",
            ],
            [
                   "Returns the number of elements within the Timeline.  @return Element count.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduledCount_inline",
                   "",
            ],
            [
                   "unscheduleEverything",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleEverything_inline",
                   "Clears the Timeline, removing all elements.",
            ],
            [
                   "Clears the Timeline, removing all elements.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_unscheduleEverything_inline",
                   "",
            ],
            [
                   "setTriggers",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleTriggers_inline",
                   "Set the triggers for the Timeline.  @param triggers List of `Trigger` objects.",
            ],
            [
                   "Set the triggers for the Timeline.  @param triggers List of `Trigger` objects.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_scheduleTriggers_inline",
                   "",
            ],
            [
                   "getTriggers",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_getScheduleTriggers_inline",
                   "Returns the list of triggers which are dependents of the Timeline.  @return `Trigger` list.",
            ],
            [
                   "Returns the list of triggers which are dependents of the Timeline.  @return `Trigger` list.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_getScheduleTriggers_inline",
                   "",
            ],
            [
                   "startTimeline",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_startTimeline_inline",
                   "Start Timeline execution from the current element index `getCurrentTimelineMarker`.",
            ],
            [
                   "Start Timeline execution from the current element index `getCurrentTimelineMarker`.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_startTimeline_inline",
                   "",
            ],
            [
                   "pauseTimeline",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_pauseTimeline_inline",
                   "Pause execution of the Timeline, and current element (if pausible). If the current element is not pausible then this method will do nothing.",
            ],
            [
                   "Pause execution of the Timeline, and current element (if pausible). If the current element is not pausible then this method will do nothing.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_pauseTimeline_inline",
                   "",
            ],
            [
                   "resumeTimeline",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_resumeTimeline_inline",
                   "Resume element and Timeline execution.",
            ],
            [
                   "Resume element and Timeline execution.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_resumeTimeline_inline",
                   "",
            ],
            [
                   "stopTimeline",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_stopTimeline_inline",
                   "Stops the execution of the Timeline, resets the marker index to 0.  Release thread resources of timeline.",
            ],
            [
                   "Stops the execution of the Timeline, resets the marker index to 0.  Release thread resources of timeline.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_stopTimeline_inline",
                   "",
            ],
            [
                   "isTimelineRunning",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_isTimelineRunning_inline",
                   "`true` if the Timeline is running.  @return A boolean value that is `true` if Timeline is running.",
            ],
            [
                   "`true` if the Timeline is running.  @return A boolean value that is `true` if Timeline is running.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_isTimelineRunning_inline",
                   "",
            ],
            [
                   "getCurrentTimelineMarker",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_currentTimelineMarker_inline",
                   "Tells the index in the timeline array that marks where the timeline is currently at.  Changing this value will reposition where the timeline will resume/start work.  @return Timeline element index.",
            ],
            [
                   "Tells the index in the timeline array that marks where the timeline is currently at.  Changing this value will reposition where the timeline will resume/start work.  @return Timeline element index.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_currentTimelineMarker_inline",
                   "",
            ],
            [
                   "setCurrentTimelineMarker",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_setCurrentTimelineMarker_inline",
                   "Sets the element index within the Timeline to start execution.  This value can be set only when a Timeline is stopped (not executing or paused).  @param currentTimelineMaker Timeline element index.",
            ],
            [
                   "Sets the element index within the Timeline to start execution.  This value can be set only when a Timeline is stopped (not executing or paused).  @param currentTimelineMaker Timeline element index.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_setCurrentTimelineMarker_inline",
                   "",
            ],
            [
                   "isTimelinePaused",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_isTimelinePaused_inline",
                   "`true` if Timeline is paused.  @return `true` if Timeline is paused.",
            ],
            [
                   "`true` if Timeline is paused.  @return `true` if Timeline is paused.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_isTimelinePaused_inline",
                   "",
            ],
            [
                   "getRunningElement",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_runningElement_inline",
                   "The current element that is running in the Timeline. If the Timeline is not running, then this is `null`.  @return Timeline element",
            ],
            [
                   "The current element that is running in the Timeline. If the Timeline is not running, then this is `null`.  @return Timeline element",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_runningElement_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_addListenerToTimelineProgressWithBlock_inline",
                   "Adds a listener to all Timeline events.  @param listener A listener object.",
            ],
            [
                   "Adds a listener to all Timeline events.  @param listener A listener object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_addListenerToTimelineProgressWithBlock_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_removeListener_inline",
                   "Removes the listener from the Timeline events listeners pool.  @param listener A previously added listener object.",
            ],
            [
                   "Removes the listener from the Timeline events listeners pool.  @param listener A previously added listener object.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_removeAllListeners_inline",
                   "Removes all listeners from the Timeline events listeners pool.",
            ],
            [
                   "Removes all listeners from the Timeline events listeners pool.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_removeAllListeners_inline",
                   "",
            ],
            [
                   "Triggerable",
                   2,
                   "/Components/Missions/DJITriggerable.html",
                   "",
                   "Interface for object which support triggers.",
            ],
            [
                   "Interface for object which support triggers.",
                   1,
                   "/Components/Missions/DJITriggerable.html",
                   "",
                   "",
            ],
            [
                   "getTriggers",
                   2,
                   "/Components/Missions/DJITriggerable.html",
                   "#DJITriggerable_getTriggers_inline",
                   "Get List of `Trigger` objects.  @return A list of `Trigger` objects.",
            ],
            [
                   "Get List of `Trigger` objects.  @return A list of `Trigger` objects.",
                   1,
                   "/Components/Missions/DJITriggerable.html",
                   "#DJITriggerable_getTriggers_inline",
                   "",
            ],
            [
                   "setTriggers",
                   2,
                   "/Components/Missions/DJITriggerable.html",
                   "#DJITriggerable_setTriggers_inline",
                   "Set the `Trigger` objects list.  @param triggers List of `Trigger` objects to set.",
            ],
            [
                   "Set the `Trigger` objects list.  @param triggers List of `Trigger` objects to set.",
                   1,
                   "/Components/Missions/DJITriggerable.html",
                   "#DJITriggerable_setTriggers_inline",
                   "",
            ],
            [
                   "TimelineElement",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "",
                   "Required behavior of elements that run in a Timeline.  In addition to implementing this behavior, a Timeline element must communicate with Mission Control to let it know its state. Mission Control will wait for updates from the Timeline element before it itself progresses. Refer to `TimelineElementFeedback` for the methods Mission Control exposes for the Timeline element to use to communicate.",
            ],
            [
                   "Required behavior of elements that run in a Timeline.  In addition to implementing this behavior, a Timeline element must communicate with Mission Control to let it know its state. Mission Control will wait for updates from the Timeline element before it itself progresses. Refer to `TimelineElementFeedback` for the methods Mission Control exposes for the Timeline element to use to communicate.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "",
                   "",
            ],
            [
                   "onEvent",
                   2,
                   "/Components/Missions/DJIMissionControl_DJIMissionControlTimelineEventBlockInterface.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEventBlock_inline",
                   "Listener used to process Timeline events.  @param element The Timeline element associated with the event, or `null` if the  event is global to the whole Timeline (e.g. start, finish the  Timeline). @param event Event. @param error The optional error if the event was error-related.",
            ],
            [
                   "Listener used to process Timeline events.  @param element The Timeline element associated with the event, or `null` if the  event is global to the whole Timeline (e.g. start, finish the  Timeline). @param event Event. @param error The optional error if the event was error-related.",
                   1,
                   "/Components/Missions/DJIMissionControl_DJIMissionControlTimelineEventBlockInterface.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEventBlock_inline",
                   "",
            ],
            [
                   "Listener",
                   2,
                   "/Components/Missions/DJIMissionControl_DJIMissionControlTimelineEventBlockInterface.html",
                   "",
                   "Listener used to process Timeline events.",
            ],
            [
                   "Listener used to process Timeline events.",
                   1,
                   "/Components/Missions/DJIMissionControl_DJIMissionControlTimelineEventBlockInterface.html",
                   "",
                   "",
            ],
            [
                   "TimelineEvent",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_inline",
                   "Events that can initiate a call to the Mission Control listener.",
            ],
            [
                   "Events that can initiate a call to the Mission Control listener.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_inline",
                   "",
            ],
            [
                   "TimelineElementFeedback",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "",
                   "This protocol defines how the timeline element may contact mission control  to notify it of its own execution. This protocol is not intended to be  implemented by any other object and the use of a protocol is primarily  organizational.",
            ],
            [
                   "This protocol defines how the timeline element may contact mission control  to notify it of its own execution. This protocol is not intended to be  implemented by any other object and the use of a protocol is primarily  organizational.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "",
                   "",
            ],
            [
                   "MissionControlError",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "",
                   "Defines all MissionControl related errors.",
            ],
            [
                   "Defines all MissionControl related errors.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "",
                   "",
            ],
            [
                   "getTriggers",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_triggers_inline",
                   "If implemented, Mission Control loads and activates the triggers for the duration that the Timeline element is executing.  @return A List of `Trigger` object.",
            ],
            [
                   "If implemented, Mission Control loads and activates the triggers for the duration that the Timeline element is executing.  @return A List of `Trigger` object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_triggers_inline",
                   "",
            ],
            [
                   "setTriggers",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_setTriggers_inline",
                   "Set the triggers array list to the timeline.  @param triggers A list of `Trigger` objects.",
            ],
            [
                   "Set the triggers array list to the timeline.  @param triggers A list of `Trigger` objects.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_setTriggers_inline",
                   "",
            ],
            [
                   "isPausable",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_isPausable_inline",
                   "`true` if the element can be paused. If `false`, then when the Timeline is asked to pause when this element is running, nothing will happen.  @return `true` if the element can be paused.",
            ],
            [
                   "`true` if the element can be paused. If `false`, then when the Timeline is asked to pause when this element is running, nothing will happen.  @return `true` if the element can be paused.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_isPausable_inline",
                   "",
            ],
            [
                   "checkValidity",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_checkValidity_inline",
                   "Returns an error if there is a configuration or parameter error in the element. Returns `null` if there is no issue.  @return A `DJIError` object.",
            ],
            [
                   "Returns an error if there is a configuration or parameter error in the element. Returns `null` if there is no issue.  @return A `DJIError` object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_checkValidity_inline",
                   "",
            ],
            [
                   "willRun",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_willRun_inline",
                   "If Implemented, this is called by Mission Control right before running the element.",
            ],
            [
                   "If Implemented, this is called by Mission Control right before running the element.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_willRun_inline",
                   "",
            ],
            [
                   "run",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_run_inline",
                   "Starts execution of Timeline element. Missions adopting this behavior are being run with their respective operators.",
            ],
            [
                   "Starts execution of Timeline element. Missions adopting this behavior are being run with their respective operators.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_run_inline",
                   "",
            ],
            [
                   "pause",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_pauseRun_inline",
                   "Pauses the execution of the element. Must be implemented if `isPausable` returns `true`.",
            ],
            [
                   "Pauses the execution of the element. Must be implemented if `isPausable` returns `true`.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_pauseRun_inline",
                   "",
            ],
            [
                   "resume",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_resumeRun_inline",
                   "Resumes the execution of the element. Must be implemented if `isPausable` returns `true`.",
            ],
            [
                   "Resumes the execution of the element. Must be implemented if `isPausable` returns `true`.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_resumeRun_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_stopRun_inline",
                   "Stops execution of the element.",
            ],
            [
                   "Stops execution of the element.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_stopRun_inline",
                   "",
            ],
            [
                   "didRun",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_didRun_inline",
                   "Called after element execution, regardless of whether or not it was successful.",
            ],
            [
                   "Called after element execution, regardless of whether or not it was successful.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_didRun_inline",
                   "",
            ],
            [
                   "setDelayTime",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_setDelayTime_inline",
                   "Sets the time you want to delay before element execution which is used for asynchronous processing scenarios. For example, if you want to execute `GimbalAttitudeAction` after `ShootPhotoAction`, you should set delay time in `GimbalAttitudeAction`. Because it takes 1 to 2 seconds to take a photo, the gimbal's commands will not be responded during this period,  so we need to delay 2 seconds before turning the gimbal to ensure that the gimbal movement is executed correctly.  @param delayTime The time you want to delay before element execution, unit:second.",
            ],
            [
                   "Sets the time you want to delay before element execution which is used for asynchronous processing scenarios. For example, if you want to execute `GimbalAttitudeAction` after `ShootPhotoAction`, you should set delay time in `GimbalAttitudeAction`. Because it takes 1 to 2 seconds to take a photo, the gimbal's commands will not be responded during this period,  so we need to delay 2 seconds before turning the gimbal to ensure that the gimbal movement is executed correctly.  @param delayTime The time you want to delay before element execution, unit:second.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_setDelayTime_inline",
                   "",
            ],
            [
                   "getDelayTime",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_getDelayTime_inline",
                   "Gets the time you want to delay before element execution.  @return The time you set to delay before element execution.",
            ],
            [
                   "Gets the time you want to delay before element execution.  @return The time you set to delay before element execution.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElement.html",
                   "#DJIMissionControlTimelineElement_getDelayTime_inline",
                   "",
            ],
            [
                   "onStart",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidStartRunning_inline",
                   "Used by elements to notify Mission Control of their successful start.  @param element A previously scheduled element. Should also be the element running.",
            ],
            [
                   "Used by elements to notify Mission Control of their successful start.  @param element A previously scheduled element. Should also be the element running.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidStartRunning_inline",
                   "",
            ],
            [
                   "onStartWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedStartingWithError_inline",
                   "Used by elements to notify Mission Control of a failure preventing to start.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
            ],
            [
                   "Used by elements to notify Mission Control of a failure preventing to start.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedStartingWithError_inline",
                   "",
            ],
            [
                   "onProgressWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementProgressedWithError_inline",
                   "Used by elements to notify Mission Control of a progress in the execution. Additional information may be pulled by mission control depending on the element. Calling this method with an error means the element is still running and the error did not cause it to stop.  @param element A previously scheduled element. Should also be the element running. @param error An optional error if something went wrong.",
            ],
            [
                   "Used by elements to notify Mission Control of a progress in the execution. Additional information may be pulled by mission control depending on the element. Calling this method with an error means the element is still running and the error did not cause it to stop.  @param element A previously scheduled element. Should also be the element running. @param error An optional error if something went wrong.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementProgressedWithError_inline",
                   "",
            ],
            [
                   "onPause",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidPause_inline",
                   "Used by elements to notify Mission Control of a successful pausing.  @param element A previously scheduled element. Should also be the element running.",
            ],
            [
                   "Used by elements to notify Mission Control of a successful pausing.  @param element A previously scheduled element. Should also be the element running.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidPause_inline",
                   "",
            ],
            [
                   "onPauseWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedPausingWithError_inline",
                   "Used by elements to notify Mission Control of a failure to pause. The element is expected to be still running.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
            ],
            [
                   "Used by elements to notify Mission Control of a failure to pause. The element is expected to be still running.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedPausingWithError_inline",
                   "",
            ],
            [
                   "onResume",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidResume_inline",
                   "Used by elements to notify Mission Control of a successful resuming of a previously paused element.  @param element A previously scheduled element. Should also be the element running.",
            ],
            [
                   "Used by elements to notify Mission Control of a successful resuming of a previously paused element.  @param element A previously scheduled element. Should also be the element running.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidResume_inline",
                   "",
            ],
            [
                   "onResumeWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedResumingWithError_inline",
                   "Used by elements to notify Mission Control of a failure to resume. The element is expected to be still paused.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
            ],
            [
                   "Used by elements to notify Mission Control of a failure to resume. The element is expected to be still paused.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedResumingWithError_inline",
                   "",
            ],
            [
                   "onFinishWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidFinishRunningWithError_inline",
                   "Used by elements to notify Mission Control of the end of the execution of it.  @param element A previously scheduled element. Should also be the element running. @param error An optional error if the execution end was the result of it.",
            ],
            [
                   "Used by elements to notify Mission Control of the end of the execution of it.  @param element A previously scheduled element. Should also be the element running. @param error An optional error if the execution end was the result of it.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementDidFinishRunningWithError_inline",
                   "",
            ],
            [
                   "onStopWithError",
                   2,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedStoppingWithError_inline",
                   "Used by elements to notify Mission Control of a failure to stop the execution of the element. This should only be used to handle error after stopRun is called.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
            ],
            [
                   "Used by elements to notify Mission Control of a failure to stop the execution of the element. This should only be used to handle error after stopRun is called.  @param element A previously scheduled element. Should also be the element running. @param error A valid error object.",
                   1,
                   "/Components/Missions/DJIMissionControlTimelineElementFeedback.html",
                   "#DJIMissionControlTimelineElementFeedback_elementFailedStoppingWithError_inline",
                   "",
            ],
            [
                   "CANNOT_SCHEDULE_WHILE_RUNNING",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorCantScheduleWhileRunning_inline",
                   "Tried to schedule new element while the Timeline was running.",
            ],
            [
                   "Tried to schedule new element while the Timeline was running.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorCantScheduleWhileRunning_inline",
                   "",
            ],
            [
                   "NOT_PAUSABLE",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotPausable_inline",
                   "Unsupported feature error. Where possible: This error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
            ],
            [
                   "Unsupported feature error. Where possible: This error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotPausable_inline",
                   "",
            ],
            [
                   "NOT_RESUMABLE",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotResumable_inline",
                   "Unsupported feature error. Where possible: This error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
            ],
            [
                   "Unsupported feature error. Where possible: This error will be returned by the function for a  special feature interface when the feature is not supported by the device.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotResumable_inline",
                   "",
            ],
            [
                   "TIMELINE_ELEMENT_OUT_OF_BOUNDS",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorOutOfBounds_inline",
                   "Cannot start the timeline because the index of to be executed item is out of bounds.",
            ],
            [
                   "Cannot start the timeline because the index of to be executed item is out of bounds.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorOutOfBounds_inline",
                   "",
            ],
            [
                   "ALREADY_RUNNING",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorAlreadyRunning_inline",
                   "Cannot start the timeline while the Timeline is running.",
            ],
            [
                   "Cannot start the timeline while the Timeline is running.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorAlreadyRunning_inline",
                   "",
            ],
            [
                   "NOT_RUNNING",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotRunning_inline",
                   "Timeline is not running.",
            ],
            [
                   "Timeline is not running.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TimelineErrorNotRunning_inline",
                   "",
            ],
            [
                   "ACTION_IS_NULL",
                   2,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TriggerErrorActionNull_inline",
                   "Trigger action is triggered, but the action object is null.",
            ],
            [
                   "Trigger action is triggered, but the action object is null.",
                   1,
                   "/Components/Missions/DJIMissionControlError.html",
                   "#DJIMissionControlError_TriggerErrorActionNull_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Unknown_inline",
                   "Unknown event type. This is a default value if no other event is matching.",
            ],
            [
                   "Unknown event type. This is a default value if no other event is matching.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Unknown_inline",
                   "",
            ],
            [
                   "STARTED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Started_inline",
                   "Timeline successfully started.",
            ],
            [
                   "Timeline successfully started.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Started_inline",
                   "",
            ],
            [
                   "START_ERROR",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_StartError_inline",
                   "Timeline failed to start.",
            ],
            [
                   "Timeline failed to start.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_StartError_inline",
                   "",
            ],
            [
                   "PROGRESSED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Progressed_inline",
                   "Timeline element progressed.",
            ],
            [
                   "Timeline element progressed.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Progressed_inline",
                   "",
            ],
            [
                   "PAUSED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Paused_inline",
                   "Timeline successfully paused.",
            ],
            [
                   "Timeline successfully paused.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Paused_inline",
                   "",
            ],
            [
                   "PAUSE_ERROR",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_PauseError_inline",
                   "Timeline failed to be paused.",
            ],
            [
                   "Timeline failed to be paused.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_PauseError_inline",
                   "",
            ],
            [
                   "RESUMED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Resumed_inline",
                   "Timeline successfully resumed.",
            ],
            [
                   "Timeline successfully resumed.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Resumed_inline",
                   "",
            ],
            [
                   "RESUME_ERROR",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_ResumeError_inline",
                   "Timeline failed to resume.",
            ],
            [
                   "Timeline failed to resume.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_ResumeError_inline",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Stopped_inline",
                   "Timeline Stopped successfully.",
            ],
            [
                   "Timeline Stopped successfully.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Stopped_inline",
                   "",
            ],
            [
                   "STOP_ERROR",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_StopError_inline",
                   "Timeline failed to stop and is still continuing in its previous state.",
            ],
            [
                   "Timeline failed to stop and is still continuing in its previous state.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_StopError_inline",
                   "",
            ],
            [
                   "FINISHED",
                   2,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Finished_inline",
                   "Timeline completed its execution normally.",
            ],
            [
                   "Timeline completed its execution normally.",
                   1,
                   "/Components/Missions/DJIMissionControl.html",
                   "#DJIMissionControl_DJIMissionControlTimelineEvent_Finished_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_currentState_inline",
                   "The current state of the executing Hotpoint mission executing.  @return The state of the Hotpoint mission.",
            ],
            [
                   "The current state of the executing Hotpoint mission executing.  @return The state of the Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_addListenerToEvents_inline",
                   "Adds listener to receive all of the Hotpoint mission operator events.  @param listener Listener that is interested in the Hotpoint mission operator.",
            ],
            [
                   "Adds listener to receive all of the Hotpoint mission operator events.  @param listener Listener that is interested in the Hotpoint mission operator.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_addListenerToEvents_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_removeListener_inline",
                   "Removes listener.  @param targetListener Listener to be removed.",
            ],
            [
                   "Removes listener.  @param targetListener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_removeAllListeners_inline",
                   "Remove all listeners from listener pool.",
            ],
            [
                   "Remove all listeners from listener pool.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_startMission_inline",
                   "Starts to execute a Hotpoint mission. This only be called when the `getCurrentState` is `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become `INITIAL_PHASE` or `EXECUTING`.  @param mission An object of `HotpointMission`. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Starts to execute a Hotpoint mission. This only be called when the `getCurrentState` is `READY_TO_EXECUTE`. After a mission is started successfully, the `getCurrentState` will become `INITIAL_PHASE` or `EXECUTING`.  @param mission An object of `HotpointMission`. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "pause",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_pauseMission_inline",
                   "Pauses the executing mission. It can only be called when the `getCurrentState` is  `INITIAL_PHASE` or `EXECUTING`.  If this method is called in the `INITIAL_PHASE` state, the aircraft will continue flying to the start point but it will not continue to circle around the hotpoint until the user resumes the mission. After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Pauses the executing mission. It can only be called when the `getCurrentState` is  `INITIAL_PHASE` or `EXECUTING`.  If this method is called in the `INITIAL_PHASE` state, the aircraft will continue flying to the start point but it will not continue to circle around the hotpoint until the user resumes the mission. After a mission is paused successfully, the `getCurrentState` will become `EXECUTION_PAUSED`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_pauseMission_inline",
                   "",
            ],
            [
                   "resume",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_resumeMission_inline",
                   "Resumes the paused mission. It can only be called when the `getCurrentState` is `EXECUTION_PAUSED`. After a mission is resumed successfully, the `getCurrentState` will become `INITIAL_PHASE` or `EXECUTING`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Resumes the paused mission. It can only be called when the `getCurrentState` is `EXECUTION_PAUSED`. After a mission is resumed successfully, the `getCurrentState` will become `INITIAL_PHASE` or `EXECUTING`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_resumeMission_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_stopMission_inline",
                   "Stops the executing or paused mission. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  After a mission is stopped successfully, `getCurrentState` will become `READY_TO_EXECUTE`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Stops the executing or paused mission. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  After a mission is stopped successfully, `getCurrentState` will become `READY_TO_EXECUTE`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "getExecutingMission",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_getExecutingMission_inline",
                   "Gets the executing mission from the aircraft. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param mission Detailed information of the mission being executed. `setAltitude` and `setRadius` may be different from the initial settings when starting the mission. It is `null` if there is an error encountered when trying to get the mission. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the executing mission from the aircraft. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param mission Detailed information of the mission being executed. `setAltitude` and `setRadius` may be different from the initial settings when starting the mission. It is `null` if there is an error encountered when trying to get the mission. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_getExecutingMission_inline",
                   "",
            ],
            [
                   "setAngularVelocity",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_setAngularVelocity_inline",
                   "Sets angular velocity for the executing mission. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param angularVelocity Angular velocity to set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets angular velocity for the executing mission. It can only be called when `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param angularVelocity Angular velocity to set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_setAngularVelocity_inline",
                   "",
            ],
            [
                   "setRadius",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_setRadius_inline",
                   "Sets radius for the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param radius Radius to set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets radius for the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param radius Radius to set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_setRadius_inline",
                   "",
            ],
            [
                   "resetHeading",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_resetMissionHeading_inline",
                   "Resets aircraft's heading to the direction defined by `setHeading` of `HotpointMission`. It can only be called when the `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Resets aircraft's heading to the direction defined by `setHeading` of `HotpointMission`. It can only be called when the `getCurrentState` is one of the following:  - `INITIAL_PHASE`  - `EXECUTING`  - `EXECUTION_PAUSED`  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_resetMissionHeading_inline",
                   "",
            ],
            [
                   "getMaxAngularVelocityForRadius",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_maxAngularVelocityForRadius_inline",
                   "Returns the maximum supported angular velocity, in degrees/s, for a given Hotpoint mission radius in meters. Returns 0 if an unsupported radius is specified.  @param radius Hotpoint radius with a range of [5,500] meters. This is used to calculate the  maximum angular velocity. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Returns the maximum supported angular velocity, in degrees/s, for a given Hotpoint mission radius in meters. Returns 0 if an unsupported radius is specified.  @param radius Hotpoint radius with a range of [5,500] meters. This is used to calculate the  maximum angular velocity. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperator.html",
                   "#DJIHotpointMissionOperator_maxAngularVelocityForRadius_inline",
                   "",
            ],
            [
                   "HotpointMission",
                   2,
                   "/Components/Missions/DJIHotPointMission.html",
                   "",
                   "This class represents a Hotpoint mission. In a Hotpoint mission, the aircraft will repeatedly fly circles of a constant radius around a specified point called a Hot Point. The user can control the aircraft to fly around the Hotpoint with a specific radius and altitude. During execution, the user can also use the physical remote controller to modify its radius and speed. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark, Mavic Mini, Mavic Air 2, DJI Air 2S and Matrice 300 RTK.",
            ],
            [
                   "This class represents a Hotpoint mission. In a Hotpoint mission, the aircraft will repeatedly fly circles of a constant radius around a specified point called a Hot Point. The user can control the aircraft to fly around the Hotpoint with a specific radius and altitude. During execution, the user can also use the physical remote controller to modify its radius and speed. It is not supported by Mavic Pro when using WiFi connection. It is not supported by Spark, Mavic Mini, Mavic Air 2, DJI Air 2S and Matrice 300 RTK.",
                   1,
                   "/Components/Missions/DJIHotPointMission.html",
                   "",
                   "",
            ],
            [
                   "HotpointMissionOperatorListener",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "",
                   "Listener interface for listening to Hotpoint mission events.",
            ],
            [
                   "Listener interface for listening to Hotpoint mission events.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionUpdate_inline",
                   "Called when a new Hotpoint mission event occurs.  @param event Updated event.",
            ],
            [
                   "Called when a new Hotpoint mission event occurs.  @param event Updated event.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionUpdate_inline",
                   "",
            ],
            [
                   "onExecutionStart",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionStart_inline",
                   "Called when the Hotpoint mission starts.",
            ],
            [
                   "Called when the Hotpoint mission starts.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionStart_inline",
                   "",
            ],
            [
                   "onExecutionFinish",
                   2,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionFinish_inline",
                   "Called when the Hotpoint mission ends.  @param error Used when mission is finishes in an unexpected way.",
            ],
            [
                   "Called when the Hotpoint mission ends.  @param error Used when mission is finishes in an unexpected way.",
                   1,
                   "/Components/Missions/DJIHotpointMissionOperatorListener.html",
                   "#DJIHotpointMissionOperatorListener_onExecutionFinish_inline",
                   "",
            ],
            [
                   "HotpointMissionEvent",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "",
                   "This class encapsulates all the state changes of the Hotpoint mission operator.",
            ],
            [
                   "This class encapsulates all the state changes of the Hotpoint mission operator.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `HotpointMissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `HotpointMissionState`.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `HotpointMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `HotpointMissionState`.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_radius_inline",
                   "The Hotpoint radius in meters of the mission. If there is no executing mission, it is 0.  @return A float value of radius.",
            ],
            [
                   "The Hotpoint radius in meters of the mission. If there is no executing mission, it is 0.  @return A float value of radius.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_radius_inline",
                   "",
            ],
            [
                   "getMaxAngularVelocity",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_maxAngularVelocity_inline",
                   "The Hotpoint max angular velocity from current radius.  @return A float value of velocity.",
            ],
            [
                   "The Hotpoint max angular velocity from current radius.  @return A float value of velocity.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_maxAngularVelocity_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_error_inline",
                   "The encountered error if there is any. Otherwise, it is `null`.  @return A object of `DJIError`.",
            ],
            [
                   "The encountered error if there is any. Otherwise, it is `null`.  @return A object of `DJIError`.",
                   1,
                   "/Components/Missions/DJIHotpointMissionEvent.html",
                   "#DJIHotpointMissionEvent_error_inline",
                   "",
            ],
            [
                   "HotpointMissionState",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "",
                   "States of `HotpointMissionOperator`.",
            ],
            [
                   "States of `HotpointMissionOperator`.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Unknown_inline",
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
            ],
            [
                   "The state of the operator is unknown. This is the initial state when the operator has just been created.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Disconnected_inline",
                   "The connection between the mobile device and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device and aircraft is broken.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Recovering_inline",
                   "The connection between the mobile device and aircraft is recovering. At this time, the operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device and aircraft is recovering. At this time, the operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_NotSupported_inline",
                   "The connected product does not support Hotpoint mission.",
            ],
            [
                   "The connected product does not support Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_ReadyToExecute_inline",
                   "Mission is uploaded completely and the aircraft is ready to start the execution.",
            ],
            [
                   "Mission is uploaded completely and the aircraft is ready to start the execution.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_ReadyToExecute_inline",
                   "",
            ],
            [
                   "INITIAL_PHASE",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_InitialPhase_inline",
                   "The aircraft is moving towards the start point of the Hotpoint mission.",
            ],
            [
                   "The aircraft is moving towards the start point of the Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_InitialPhase_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Executing_inline",
                   "The execution is started successfully.",
            ],
            [
                   "The execution is started successfully.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_Executing_inline",
                   "",
            ],
            [
                   "EXECUTION_PAUSED",
                   2,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_ExecutionPaused_inline",
                   "Hotpoint mission is paused successfully. User can call `resume` to continue the execution.",
            ],
            [
                   "Hotpoint mission is paused successfully. User can call `resume` to continue the execution.",
                   1,
                   "/Components/Missions/DJIHotpointMissionState.html",
                   "#DJIHotpointMissionState_ExecutionPaused_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_currentState_inline",
                   "The current state of the operator.  @return An object of `ActiveTrackState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `ActiveTrackState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "isGestureModeEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isGestureModeEnabled_inline",
                   "`true` if gesture mode is enabled.  @return `true` if gesture mode is enabled.  ",
            ],
            [
                   "`true` if gesture mode is enabled.  @return `true` if gesture mode is enabled.  ",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isGestureModeEnabled_inline",
                   "",
            ],
            [
                   "isAutoSensingEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingEnabled_inline",
                   "`true` if auto sensing is enabled.  @return `true` if auto sensing is enabled. ",
            ],
            [
                   "`true` if auto sensing is enabled.  @return `true` if auto sensing is enabled. ",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingEnabled_inline",
                   "",
            ],
            [
                   "isAutoSensingForQuickShotEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingForQuickShotEnabled_inline",
                   "`true` if auto sensing for QuickShot is enabled. Not supported by Mavic Air 2, DJI Air.  @return `true` if auto sensing for QuickShot is enabled. ",
            ],
            [
                   "`true` if auto sensing for QuickShot is enabled. Not supported by Mavic Air 2, DJI Air.  @return `true` if auto sensing for QuickShot is enabled. ",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingForQuickShotEnabled_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_addListener_inline",
                   "Add a listener to listen to events in the ActiveTrack operator.  @param listener Listener that is interested in the ActiveTrack mission operator events.",
            ],
            [
                   "Add a listener to listen to events in the ActiveTrack operator.  @param listener Listener that is interested in the ActiveTrack mission operator events.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_addListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_removeListener_inline",
                   "Removes listener. The listener will not receive any update after calling this method.  @param listener Listener to be removed.",
            ],
            [
                   "Removes listener. The listener will not receive any update after calling this method.  @param listener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_removeAllListeners_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "setGestureModeEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setGestureModeEnabled_inline",
                   "Enables/disables gesture mode.  - A human subject can be automatically detected if they are moving a little (instead of requiring a defining rectangle)  - The human subject can accept the confirmation to track when a wave gesture is detected(wave with a single hand and the elbow higher than the shoulder)  - The tracked human can make the camera shoot a photo by showing a rectangle with their thumbs and index fingers to the aircraft.  - For Mavic Air 2 and DJI Air 2S, the human subject will enter `SPOTLIGHT` mode when a wave gesture is detected. You can use `switchMode` to switch the mode you want to use.  Gesture mode can only be enabled when the aircraft is flying but not tracking a target. The `getCurrentState` should be one of the following:  - `IDLE`  - `CANNOT_START` After the gesture mode is enabled, `getCurrentState` will become `DETECTING_HUMAN`.  Gesture mode can be disabled when `getCurrentState` is not any of the following:  - `UNKNOWN`  - `DISCONNECTED`  - `RECOVERING`  - `NOT_SUPPORT`  If the aircraft is already tracking a target, disabling gesture mode will stop the ActiveTrack mission.  @param enabled `true` to enable gesture mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables gesture mode.  - A human subject can be automatically detected if they are moving a little (instead of requiring a defining rectangle)  - The human subject can accept the confirmation to track when a wave gesture is detected(wave with a single hand and the elbow higher than the shoulder)  - The tracked human can make the camera shoot a photo by showing a rectangle with their thumbs and index fingers to the aircraft.  - For Mavic Air 2 and DJI Air 2S, the human subject will enter `SPOTLIGHT` mode when a wave gesture is detected. You can use `switchMode` to switch the mode you want to use.  Gesture mode can only be enabled when the aircraft is flying but not tracking a target. The `getCurrentState` should be one of the following:  - `IDLE`  - `CANNOT_START` After the gesture mode is enabled, `getCurrentState` will become `DETECTING_HUMAN`.  Gesture mode can be disabled when `getCurrentState` is not any of the following:  - `UNKNOWN`  - `DISCONNECTED`  - `RECOVERING`  - `NOT_SUPPORT`  If the aircraft is already tracking a target, disabling gesture mode will stop the ActiveTrack mission.  @param enabled `true` to enable gesture mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setGestureModeEnabled_inline",
                   "",
            ],
            [
                   "isAutoSensingSupported",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingSupported_inline",
                   "Checks if the connected product supports auto sensing. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @return `true` if the product supports auto sensing.",
            ],
            [
                   "Checks if the connected product supports auto sensing. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @return `true` if the product supports auto sensing.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_isAutoSensingSupported_inline",
                   "",
            ],
            [
                   "enableAutoSensing",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_enableAutoSensing_inline",
                   "Starts auto sensing. After auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getAutoSensedSubjects` in the updated event. QuickShot requires a special auto sensing mode, therefore, use `enableAutoSensingForQuickShot` if a QuickShot mission will be performed. It is only supported when `isAutoSensingSupported` returns `true`. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts auto sensing. After auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getAutoSensedSubjects` in the updated event. QuickShot requires a special auto sensing mode, therefore, use `enableAutoSensingForQuickShot` if a QuickShot mission will be performed. It is only supported when `isAutoSensingSupported` returns `true`. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_enableAutoSensing_inline",
                   "",
            ],
            [
                   "enableAutoSensingForQuickShot",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_enableAutoSensingForQuickShot_inline",
                   "Starts auto sensing specifically for QuickShot. After auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getAutoSensedSubjects` in the updated event. This interface is specific for QuickShot, therefore, use `enableAutoSensing` for missions other than QuickShot. It is only supported when `isAutoSensingSupported` returns `true`. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track. Not supported by Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts auto sensing specifically for QuickShot. After auto sensing starts, the aircraft will sense humans captured by the camera and return the detected subjects by `getAutoSensedSubjects` in the updated event. This interface is specific for QuickShot, therefore, use `enableAutoSensing` for missions other than QuickShot. It is only supported when `isAutoSensingSupported` returns `true`. When the product supports auto sensing, enabling auto sensing is the pre-condition of starting active track. Not supported by Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_enableAutoSensingForQuickShot_inline",
                   "",
            ],
            [
                   "disableAutoSensing",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_disableAutoSensing_inline",
                   "Stops auto sensing (either for QuickShot or the other active track modes). It is only supported when `isAutoSensingSupported` returns `true`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops auto sensing (either for QuickShot or the other active track modes). It is only supported when `isAutoSensingSupported` returns `true`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_disableAutoSensing_inline",
                   "",
            ],
            [
                   "canStartTracking",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_canStartMission_inline",
                   "Checks if the operator can start the mission.  @param mission An ActiveTrack mission.  @return The possible error if the operator tries to start the mission.",
            ],
            [
                   "Checks if the operator can start the mission.  @param mission An ActiveTrack mission.  @return The possible error if the operator tries to start the mission.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_canStartMission_inline",
                   "",
            ],
            [
                   "startTracking",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_startMission_inline",
                   "Starts to execute an ActiveTrack mission. It can only be called when the `getCurrentState` is `IDLE` or `AUTO_SENSING`. If a mission with `TRACE` or `PROFILE` is started successfully, the `getCurrentState` will become one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  (For Mavic Air 2, DJI Air 2S, there is no need to confirm when you start `TRACE` or `PROFILE` mission.) If a mission with `SPOTLIGHT` or `SPOTLIGHT_PRO` is started successfully, the `getCurrentState` will become `ONLY_CAMERA_FOLLOWING`.  When the product supports auto sensing, enabling auto sensing is the pre- condition of starting active track.  @param mission The ActiveTrack mission to check. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts to execute an ActiveTrack mission. It can only be called when the `getCurrentState` is `IDLE` or `AUTO_SENSING`. If a mission with `TRACE` or `PROFILE` is started successfully, the `getCurrentState` will become one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  (For Mavic Air 2, DJI Air 2S, there is no need to confirm when you start `TRACE` or `PROFILE` mission.) If a mission with `SPOTLIGHT` or `SPOTLIGHT_PRO` is started successfully, the `getCurrentState` will become `ONLY_CAMERA_FOLLOWING`.  When the product supports auto sensing, enabling auto sensing is the pre- condition of starting active track.  @param mission The ActiveTrack mission to check. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "startAutoSensingMission",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_startAutoSensingMission_inline",
                   "Starts to execute an ActiveTrack mission after auto sensing (either for QuickShot or the other active track modes) is started. The aircraft will start to track the subject defined by `setTargetIndex`. If auto sensing for active track modes other than QuickShot is enabled, the active track mode to start is defined by `ActiveTrackMission`'s `setMode`. `getQuickShotMode` of `ActiveTrackMission` will be ignored. If auto sensing specifically for QuickShot is enabled, The QuickShot mode to start is defined by `ActiveTrackMission`'s `getQuickShotMode`. `getQuickShotMode` of `ActiveTrackMission` will be ignored. It can only be called when the `getCurrentState` is one of the following: - `AUTO_SENSING` - `AUTO_SENSING_FOR_QUICK_SHOT` If the aircraft has high confidence about the auto-sensed subject, confirmation is not required and the state will change to `AIRCRAFT_FOLLOWING` or `ONLY_CAMERA_FOLLOWING` (determined by the active track mode). Otherwise, the state will change to `WAITING_FOR_CONFIRMATION` and user need to perform `acceptConfirmation`.  @param mission The ActiveTrack mission to check. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts to execute an ActiveTrack mission after auto sensing (either for QuickShot or the other active track modes) is started. The aircraft will start to track the subject defined by `setTargetIndex`. If auto sensing for active track modes other than QuickShot is enabled, the active track mode to start is defined by `ActiveTrackMission`'s `setMode`. `getQuickShotMode` of `ActiveTrackMission` will be ignored. If auto sensing specifically for QuickShot is enabled, The QuickShot mode to start is defined by `ActiveTrackMission`'s `getQuickShotMode`. `getQuickShotMode` of `ActiveTrackMission` will be ignored. It can only be called when the `getCurrentState` is one of the following: - `AUTO_SENSING` - `AUTO_SENSING_FOR_QUICK_SHOT` If the aircraft has high confidence about the auto-sensed subject, confirmation is not required and the state will change to `AIRCRAFT_FOLLOWING` or `ONLY_CAMERA_FOLLOWING` (determined by the active track mode). Otherwise, the state will change to `WAITING_FOR_CONFIRMATION` and user need to perform `acceptConfirmation`.  @param mission The ActiveTrack mission to check. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_startAutoSensingMission_inline",
                   "",
            ],
            [
                   "stopTracking",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_stopMission_inline",
                   "Stops the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `AIRCRAFT_FOLLOWING`  - `ONLY_CAMERA_FOLLOWING`  - `FINDING_TRACKED_TARGET`  After a mission is stopped successfully, `getCurrentState` will become `IDLE` or `DETECTING_HUMAN` if gesture mode is enabled. If AutoSensing is enabled, the state will be `AUTO_SENSING`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops the executing mission. It can only be called when the `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `AIRCRAFT_FOLLOWING`  - `ONLY_CAMERA_FOLLOWING`  - `FINDING_TRACKED_TARGET`  After a mission is stopped successfully, `getCurrentState` will become `IDLE` or `DETECTING_HUMAN` if gesture mode is enabled. If AutoSensing is enabled, the state will be `AUTO_SENSING`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "acceptConfirmation",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_acceptConfirmation_inline",
                   "When the vision system is not sure the tracking rectangle is around the user's desired target, it will need confirmation before starting to fly relative to the target. The vision system will need confirmation when `getCurrentState` is `IDLE`. `getTargetRect` of `ActiveTrackTrackingState` can be used to show the user the rectangle the vision system is using. If the user agrees the rectangle represents the target they want to track, this method can be called to start flying relative to the target. For Mavic Air 2, DJI Air 2S, there is only CIRCLE mode need to confirm.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "When the vision system is not sure the tracking rectangle is around the user's desired target, it will need confirmation before starting to fly relative to the target. The vision system will need confirmation when `getCurrentState` is `IDLE`. `getTargetRect` of `ActiveTrackTrackingState` can be used to show the user the rectangle the vision system is using. If the user agrees the rectangle represents the target they want to track, this method can be called to start flying relative to the target. For Mavic Air 2, DJI Air 2S, there is only CIRCLE mode need to confirm.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_acceptConfirmation_inline",
                   "",
            ],
            [
                   "rejectConfirmation",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_rejectConfirmation_inline",
                   "Rejects the target rectangle from the aircraft.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Rejects the target rectangle from the aircraft.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_rejectConfirmation_inline",
                   "",
            ],
            [
                   "stopAircraftFollowing",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_stopAircraftFollowing_inline",
                   "Stops the aircraft from following the target and ask for user confirmation again. It can only be called when the `getCurrentState` is `AIRCRAFT_FOLLOWING`. After it is called successfully, `getCurrentState` will become `WAITING_FOR_CONFIRMATION`. Not supported by Mavic Air 2, DJI Air 2S, it is recommended to switch to `SPOTLIGHT` to replace this function.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops the aircraft from following the target and ask for user confirmation again. It can only be called when the `getCurrentState` is `AIRCRAFT_FOLLOWING`. After it is called successfully, `getCurrentState` will become `WAITING_FOR_CONFIRMATION`. Not supported by Mavic Air 2, DJI Air 2S, it is recommended to switch to `SPOTLIGHT` to replace this function.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_stopAircraftFollowing_inline",
                   "",
            ],
            [
                   "setCircularSpeed",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setCircularSpeed_inline",
                   "Setting a non-zero speed starts the aircraft circling the target. Speed can be set within the range [-5, 5] m/s(For Mavic Air 2 and DJI Air 2S the value of circular speed is only a relative value, like 5 means to circle according to the maximum flight speed of the aircraft under the current radius, it's not measured in m/s) where a positive speed is a counter-clockwise movement (when viewing from the top). Reverting the speed to 0 m/s ends the circling movement. It can only be called when the `getCurrentState` is `AIRCRAFT_FOLLOWING` .  @param speed Circular speed to set in m/s. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Setting a non-zero speed starts the aircraft circling the target. Speed can be set within the range [-5, 5] m/s(For Mavic Air 2 and DJI Air 2S the value of circular speed is only a relative value, like 5 means to circle according to the maximum flight speed of the aircraft under the current radius, it's not measured in m/s) where a positive speed is a counter-clockwise movement (when viewing from the top). Reverting the speed to 0 m/s ends the circling movement. It can only be called when the `getCurrentState` is `AIRCRAFT_FOLLOWING` .  @param speed Circular speed to set in m/s. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setCircularSpeed_inline",
                   "",
            ],
            [
                   "getCircularSpeed",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_getCircularSpeed_inline",
                   "In an ActiveTrack mission, the aircraft can be set to circle the target while following it. This method returns the circular speed of the aircraft in m/s. (For Mavic Air 2 and DJI Air 2S, the value of circular speed is only a relative value, 5 means to circle according to the maximum flight speed of the aircraft under the current radius, but it's not measured in m/s.)  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "In an ActiveTrack mission, the aircraft can be set to circle the target while following it. This method returns the circular speed of the aircraft in m/s. (For Mavic Air 2 and DJI Air 2S, the value of circular speed is only a relative value, 5 means to circle according to the maximum flight speed of the aircraft under the current radius, but it's not measured in m/s.)  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_getCircularSpeed_inline",
                   "",
            ],
            [
                   "switchMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchMode_inline",
                   "Changes the ActiveTrack mode on the currently executing mission. It can only be called when the `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `ONLY_CAMERA_FOLLOWING`  - `FINDING_TRACKED_TARGET`  - `IDLE` - `AUTO_SENSING`  - `AIRCRAFT_FOLLOWING`  If the current state is `AIRCRAFT_FOLLOWING`, `stopAircraftFollowing` should be called before switching the mode. Also, The ActiveTrack mode can only be changed when gesture mode is disabled.  For Mavic Air 2 and DJI Air 2S, there are no these two restrictions.  Mavic 2 Series does not support this interface, you should stop the mission and start a new mission to replace this function.  @param mode Active track mode to change. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Changes the ActiveTrack mode on the currently executing mission. It can only be called when the `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `ONLY_CAMERA_FOLLOWING`  - `FINDING_TRACKED_TARGET`  - `IDLE` - `AUTO_SENSING`  - `AIRCRAFT_FOLLOWING`  If the current state is `AIRCRAFT_FOLLOWING`, `stopAircraftFollowing` should be called before switching the mode. Also, The ActiveTrack mode can only be changed when gesture mode is disabled.  For Mavic Air 2 and DJI Air 2S, there are no these two restrictions.  Mavic 2 Series does not support this interface, you should stop the mission and start a new mission to replace this function.  @param mode Active track mode to change. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchMode_inline",
                   "",
            ],
            [
                   "switchQuickShotMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchQuickShotMode_inline",
                   "Changes the Quickshot sbmode on the currently executing mission. It is only supported by Spark.  @param mode Quickshot submode to change. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Changes the Quickshot sbmode on the currently executing mission. It is only supported by Spark.  @param mode Quickshot submode to change. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchQuickShotMode_inline",
                   "",
            ],
            [
                   "switchSpotlightMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchSpotlightMode_inline",
                   "Changes the spotlight submode on the currently executing mission, It is only supported by Matrice 300 RTK.  @param spotlightMode Spotlight submode to change. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Changes the spotlight submode on the currently executing mission, It is only supported by Matrice 300 RTK.  @param spotlightMode Spotlight submode to change. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_switchSpotlightMode_inline",
                   "",
            ],
            [
                   "setRecommendedConfiguration",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setRecommendedConfiguration_inline",
                   "Sets the recommended camera and gimbal configuration that optimizes performance for the ActiveTrack Mission in most environments.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the recommended camera and gimbal configuration that optimizes performance for the ActiveTrack Mission in most environments.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setRecommendedConfiguration_inline",
                   "",
            ],
            [
                   "setRetreatEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setRetreatEnabled_inline",
                   "Enables/disable if the aircraft can retreat (fly backwards) when the target comes toward it. When it is disabled, the aircraft will not retreat and instead rotate the gimbal pitch down to track the target as it goes underneath. If the target goes beyond the gimbal's pitch stop, the target will be lost and the mission will stop. Not supported by Mavic Air 2, DJI Air 2S.  @param enabled `true` to enable retreat during ActiveTrack mission. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disable if the aircraft can retreat (fly backwards) when the target comes toward it. When it is disabled, the aircraft will not retreat and instead rotate the gimbal pitch down to track the target as it goes underneath. If the target goes beyond the gimbal's pitch stop, the target will be lost and the mission will stop. Not supported by Mavic Air 2, DJI Air 2S.  @param enabled `true` to enable retreat during ActiveTrack mission. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_setRetreatEnabled_inline",
                   "",
            ],
            [
                   "getRetreatEnabled",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_getRetreatEanbled_inline",
                   "Determines whether retreat is enabled in ActiveTrack mission. Not supported by Mavic Air 2 and DJI Air 2S.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Determines whether retreat is enabled in ActiveTrack mission. Not supported by Mavic Air 2 and DJI Air 2S.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionOperator.html",
                   "#DJIActiveTrackMissionOperator_getRetreatEanbled_inline",
                   "",
            ],
            [
                   "ActiveTrackMission",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "",
                   "ActiveTrack Mission allows an aircraft to track a moving subject using the vision system and without a GPS tracker on the subject.",
            ],
            [
                   "ActiveTrack Mission allows an aircraft to track a moving subject using the vision system and without a GPS tracker on the subject.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "",
                   "",
            ],
            [
                   "ActiveTrackMissionEvent",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "",
                   "This class encapsulates all the state changes of the ActiveTrack mission operator.",
            ],
            [
                   "This class encapsulates all the state changes of the ActiveTrack mission operator.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "ActiveTrackMissionOperatorListener",
                   2,
                   "/Components/Missions/ActiveTrackMissionOperatorListener.html",
                   "",
                   "Listener interface used to listen to ActiveTrack mission events.",
            ],
            [
                   "Listener interface used to listen to ActiveTrack mission events.",
                   1,
                   "/Components/Missions/ActiveTrackMissionOperatorListener.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Missions/ActiveTrackMissionOperatorListener.html",
                   "#ActiveTrackMissionOperatorListener_onUpdate_inline",
                   "Called when an event occurs in the ActiveTrack mission.  @param event An object of `ActiveTrackMissionEvent`.",
            ],
            [
                   "Called when an event occurs in the ActiveTrack mission.  @param event An object of `ActiveTrackMissionEvent`.",
                   1,
                   "/Components/Missions/ActiveTrackMissionOperatorListener.html",
                   "#ActiveTrackMissionOperatorListener_onUpdate_inline",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `ActiveTrackState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `ActiveTrackState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `ActiveTrackState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `ActiveTrackState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getTrackingState",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_trackingState_inline",
                   "The tracking state of the executing ActiveTrack mission. It is only valid when `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `AIRCRAFT_FOLLOWING`  - `ONLY_CAMERA_FOLLOWING`  For the other states, it is `null`.  @return An object of `ActiveTrackTrackingState`.",
            ],
            [
                   "The tracking state of the executing ActiveTrack mission. It is only valid when `getCurrentState` is one of the following:  - `WAITING_FOR_CONFIRMATION`  - `CANNOT_CONFIRM`  - `AIRCRAFT_FOLLOWING`  - `ONLY_CAMERA_FOLLOWING`  For the other states, it is `null`.  @return An object of `ActiveTrackTrackingState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_trackingState_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_error_inline",
                   "The encountered error if there is any. Otherwise, it is `null`.  @return An error of `DJIError`.",
            ],
            [
                   "The encountered error if there is any. Otherwise, it is `null`.  @return An error of `DJIError`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionEvent.html",
                   "#DJIActiveTrackMissionEvent_error_inline",
                   "",
            ],
            [
                   "ActiveTrackState",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "",
                   "All the possible states of `ActiveTrackOperator`.",
            ],
            [
                   "All the possible states of `ActiveTrackOperator`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Unknown_inline",
                   "The state of the operator is unknown. It is the initial state when the operator is just created.",
            ],
            [
                   "The state of the operator is unknown. It is the initial state when the operator is just created.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Disconnected_inline",
                   "The connection between the mobile device and aircraft is broken.",
            ],
            [
                   "The connection between the mobile device and aircraft is broken.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "RECOVERING",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Recovering_inline",
                   "The connection between the mobile device and aircraft is recovering. In this state, the operator is synchronizing the state from the aircraft.",
            ],
            [
                   "The connection between the mobile device and aircraft is recovering. In this state, the operator is synchronizing the state from the aircraft.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_Recovering_inline",
                   "",
            ],
            [
                   "NOT_SUPPORT",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_NotSupported_inline",
                   "The connected product does not support ActiveTrack mission.",
            ],
            [
                   "The connected product does not support ActiveTrack mission.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "CANNOT_START",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_CannotStart_inline",
                   "There is existing error stopping any ActiveTrack mission to start.",
            ],
            [
                   "There is existing error stopping any ActiveTrack mission to start.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_CannotStart_inline",
                   "",
            ],
            [
                   "AUTO_SENSING",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AutoSensing_inline",
                   "The active track sensor is enabled and the aircraft is detecting the targets automatically. If there is target found, user can choose the right tracking subject. In this state, user can still manually draw the rectangle.",
            ],
            [
                   "The active track sensor is enabled and the aircraft is detecting the targets automatically. If there is target found, user can choose the right tracking subject. In this state, user can still manually draw the rectangle.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AutoSensing_inline",
                   "",
            ],
            [
                   "AUTO_SENSING_FOR_QUICK_SHOT",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AutoSensingForQuickShot_inline",
                   "The quick shot sensor is enabled. Not supported by Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "The quick shot sensor is enabled. Not supported by Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AutoSensingForQuickShot_inline",
                   "",
            ],
            [
                   "DETECTING_HUMAN",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_DetectingHuman_inline",
                   "Gesture mode is enabled and the aircraft is looking for a target automatically. If a target is found, the operator will go to state `WAITING_FOR_CONFIRMATION` or `CANNOT_CONFIRM`. Not supported by Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "Gesture mode is enabled and the aircraft is looking for a target automatically. If a target is found, the operator will go to state `WAITING_FOR_CONFIRMATION` or `CANNOT_CONFIRM`. Not supported by Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_DetectingHuman_inline",
                   "",
            ],
            [
                   "WAITING_FOR_CONFIRMATION",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_WaitingForConfirmation_inline",
                   "Target is found. Camera is already tracking the target. In order to make the aircraft follow the target, the confirmation from user is required. Once the target is confirmed, the state will become `AIRCRAFT_FOLLOWING`. For Mavic Air 2, DJI Air 2S, only CIRCLE mode supprt this state, TRACE mode and PROFILE mode do not require confirmation.",
            ],
            [
                   "Target is found. Camera is already tracking the target. In order to make the aircraft follow the target, the confirmation from user is required. Once the target is confirmed, the state will become `AIRCRAFT_FOLLOWING`. For Mavic Air 2, DJI Air 2S, only CIRCLE mode supprt this state, TRACE mode and PROFILE mode do not require confirmation.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_WaitingForConfirmation_inline",
                   "",
            ],
            [
                   "CANNOT_CONFIRM",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_CannotConfirm_inline",
                   "Target is found. Camera is already tracking the target but there is an error stopping the aircraft to follow the target. Use `getReason` in `ActiveTrackTrackingState` to check the reason.",
            ],
            [
                   "Target is found. Camera is already tracking the target but there is an error stopping the aircraft to follow the target. Use `getReason` in `ActiveTrackTrackingState` to check the reason.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_CannotConfirm_inline",
                   "",
            ],
            [
                   "AIRCRAFT_FOLLOWING",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AircraftFollowing_inline",
                   "Target is found. Camera is already tracking the target and the aircraft is following the target.",
            ],
            [
                   "Target is found. Camera is already tracking the target and the aircraft is following the target.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_AircraftFollowing_inline",
                   "",
            ],
            [
                   "ONLY_CAMERA_FOLLOWING",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_OnlyCameraFollowing_inline",
                   "The operator is executing an ActiveTrack mission in Splotlight mode or Spotlight Pro mode. The target is found and camera is following the target.",
            ],
            [
                   "The operator is executing an ActiveTrack mission in Splotlight mode or Spotlight Pro mode. The target is found and camera is following the target.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_OnlyCameraFollowing_inline",
                   "",
            ],
            [
                   "PERFORMING_QUICK_SHOT",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_QuickShot_inline",
                   "The operator is executing a QuickShot ActiveTrack mission. Not supported by Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "The operator is executing a QuickShot ActiveTrack mission. Not supported by Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_QuickShot_inline",
                   "",
            ],
            [
                   "FINDING_TRACKED_TARGET",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_FindingTrackedTarget_inline",
                   "ActiveTrack is started but the target is lost. The vision system is detecting the previously found target.",
            ],
            [
                   "ActiveTrack is started but the target is lost. The vision system is detecting the previously found target.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_FindingTrackedTarget_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_IDLE_inline",
                   "The mission is idle.",
            ],
            [
                   "The mission is idle.",
                   1,
                   "/Components/Missions/DJIActiveTrackMissionState.html",
                   "#DJIActiveTrackMissionState_IDLE_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_currentState_inline",
                   "The current state of the operator.  @return An object of `PanoramaMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `PanoramaMissionState`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_currentState_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_addListenerToEvents_inline",
                   "Adds listener to receive all events of the Panorama mission operator.  @param listener An interface of `PanoramaMissionOperatorListener`.",
            ],
            [
                   "Adds listener to receive all events of the Panorama mission operator.  @param listener An interface of `PanoramaMissionOperatorListener`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_addListenerToEvents_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_removeListener_inline",
                   "Removes listener. The listener will not receive any update after calling this method.  @param listener Listener to be removed.",
            ],
            [
                   "Removes listener. The listener will not receive any update after calling this method.  @param listener Listener to be removed.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListeners",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_removeAllListeners_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_removeAllListeners_inline",
                   "",
            ],
            [
                   "setup",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_setupWithMode_inline",
                   "Sets up the Panorama mission with the specific mode. It can only be called  when the `getCurrentState` is one of the  following:  - `READY_TO_SETUP`  - `READY_TO_EXECUTE`  If the setup starts  successfully, `getCurrentState` will become  `SETTING_UP`. Normally, it will take seconds to  complete the setup. Once setup is completed successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param mode An enum value of `PanoramaMode`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets up the Panorama mission with the specific mode. It can only be called  when the `getCurrentState` is one of the  following:  - `READY_TO_SETUP`  - `READY_TO_EXECUTE`  If the setup starts  successfully, `getCurrentState` will become  `SETTING_UP`. Normally, it will take seconds to  complete the setup. Once setup is completed successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param mode An enum value of `PanoramaMode`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_setupWithMode_inline",
                   "",
            ],
            [
                   "startMission",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_startMission_inline",
                   "Starts to execute the mission that has been setup.  It can only be called when  the `getCurrentState` is `READY_TO_EXECUTE`.  If the mission is started successfully, the  `getCurrentState` will become `EXECUTING`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts to execute the mission that has been setup.  It can only be called when  the `getCurrentState` is `READY_TO_EXECUTE`.  If the mission is started successfully, the  `getCurrentState` will become `EXECUTING`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_startMission_inline",
                   "",
            ],
            [
                   "stopMission",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_stopMission_inline",
                   "Stops the executing mission. It can only be called when the  `getCurrentState` is  `EXECUTING`. After a mission is stopped successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops the executing mission. It can only be called when the  `getCurrentState` is  `EXECUTING`. After a mission is stopped successfully,  `getCurrentState` will become  `READY_TO_EXECUTE`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_stopMission_inline",
                   "",
            ],
            [
                   "getRecentPanoramaMediaFile",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_getPanoramaMediaFile_inline",
                   "Retrieves the `MediaFile` object for the recently finished panorama  mission.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Retrieves the `MediaFile` object for the recently finished panorama  mission.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMissionOperator_getPanoramaMediaFile_inline",
                   "",
            ],
            [
                   "PanoramaMissionOperatorListener",
                   2,
                   "/Components/Missions/PanoramaMissionOperatorListener.html",
                   "",
                   "Listener interface for Panorama mission events.",
            ],
            [
                   "Listener interface for Panorama mission events.",
                   1,
                   "/Components/Missions/PanoramaMissionOperatorListener.html",
                   "",
                   "",
            ],
            [
                   "onExecutionUpdate",
                   2,
                   "/Components/Missions/PanoramaMissionOperatorListener.html",
                   "#PanoramaMissionOperatorListener_onReceive_inline",
                   "Called when received a new Panorama mission event.  @param event An object of `PanoramaMissionEvent`.",
            ],
            [
                   "Called when received a new Panorama mission event.  @param event An object of `PanoramaMissionEvent`.",
                   1,
                   "/Components/Missions/PanoramaMissionOperatorListener.html",
                   "#PanoramaMissionOperatorListener_onReceive_inline",
                   "",
            ],
            [
                   "PanoramaMissionEvent",
                   2,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "",
                   "This class encapsulates all the state changes of the Panorama mission operator.",
            ],
            [
                   "This class encapsulates all the state changes of the Panorama mission operator.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "",
                   "",
            ],
            [
                   "getPreviousState",
                   2,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_previousState_inline",
                   "The previous state of the operator.  @return An object of `PanoramaMissionState`.",
            ],
            [
                   "The previous state of the operator.  @return An object of `PanoramaMissionState`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_previousState_inline",
                   "",
            ],
            [
                   "getCurrentState",
                   2,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_currentState_inline",
                   "The current state of the operator.  @return An object of `PanoramaMissionState`.",
            ],
            [
                   "The current state of the operator.  @return An object of `PanoramaMissionState`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_currentState_inline",
                   "",
            ],
            [
                   "getExecutionState",
                   2,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_status_inline",
                   "The detailed state of the executing Panorama mission. It is only valid when `getCurrentState` is  `EXECUTING`. For the other states, it is `null`.  @return An object of `PanoramaMissionExecutionState`.",
            ],
            [
                   "The detailed state of the executing Panorama mission. It is only valid when `getCurrentState` is  `EXECUTING`. For the other states, it is `null`.  @return An object of `PanoramaMissionExecutionState`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_status_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_error_inline",
                   "The error of DJIPanoramaMissionEvent.  @return An object of `DJIError`.",
            ],
            [
                   "The error of DJIPanoramaMissionEvent.  @return An object of `DJIError`.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionEvent.html",
                   "#DJIPanoramaMissionEvent_error_inline",
                   "",
            ],
            [
                   "PanoramaMissionState",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "",
                   "Panorama Mission State.",
            ],
            [
                   "Panorama Mission State.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Unknown_inline",
                   "The state of the operator is unknown. This is the initial state when the operator  has just been created.",
            ],
            [
                   "The state of the operator is unknown. This is the initial state when the operator  has just been created.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Disconnected_inline",
                   "The connection between the mobile device and Osmo is broken.",
            ],
            [
                   "The connection between the mobile device and Osmo is broken.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Disconnected_inline",
                   "",
            ],
            [
                   "NOT_SUPPORTED",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_NotSupported_inline",
                   "The connected product does not support Panorama mission.",
            ],
            [
                   "The connected product does not support Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_NotSupported_inline",
                   "",
            ],
            [
                   "READY_TO_SETUP",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_ReadyToSetup_inline",
                   "The operator is ready to setup a Panorama mission.",
            ],
            [
                   "The operator is ready to setup a Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_ReadyToSetup_inline",
                   "",
            ],
            [
                   "SETTING_UP",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_SettingUp_inline",
                   "The operator is setting up for a Panorama mission.",
            ],
            [
                   "The operator is setting up for a Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_SettingUp_inline",
                   "",
            ],
            [
                   "READY_TO_EXECUTE",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_ReadyToExecute_inline",
                   "The setup for the Panorama mission is complete. The operator is ready to  start the execution.",
            ],
            [
                   "The setup for the Panorama mission is complete. The operator is ready to  start the execution.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_ReadyToExecute_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Executing_inline",
                   "The operator is executing a Panorama mission.",
            ],
            [
                   "The operator is executing a Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionState.html",
                   "#DJIPanoramaMissionState_Executing_inline",
                   "",
            ],
            [
                   "PanoramaMissionExecutionState",
                   2,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "",
                   "This class provides the real-time status of an executing Panorama mission.",
            ],
            [
                   "This class provides the real-time status of an executing Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "",
                   "",
            ],
            [
                   "getTotalNumber",
                   2,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_totalNumber_inline",
                   "The total number of photos that will be shot during the mission. In full circle mode,  the number should be 8. In the half circle mode, the number should be 5.  @return An int value of total shot photo number.",
            ],
            [
                   "The total number of photos that will be shot during the mission. In full circle mode,  the number should be 8. In the half circle mode, the number should be 5.  @return An int value of total shot photo number.",
                   1,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_totalNumber_inline",
                   "",
            ],
            [
                   "getCurrentShotNumber",
                   2,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_currentShotNumber_inline",
                   "The number of photos that have been shot.  @return An int value of current shot photo number.",
            ],
            [
                   "The number of photos that have been shot.  @return An int value of current shot photo number.",
                   1,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_currentShotNumber_inline",
                   "",
            ],
            [
                   "getCurrentSavedNumber",
                   2,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_currentSavedNumber_inline",
                   "The number of photos that have been saved to SD card.  @return An int value of current saved photo number.",
            ],
            [
                   "The number of photos that have been saved to SD card.  @return An int value of current saved photo number.",
                   1,
                   "/Components/Missions/DJIPanoramaMission_DJIPanoramaMissionStatus.html",
                   "#DJIPanoramaMission_DJIPanoramaMissionStatus_currentSavedNumber_inline",
                   "",
            ],
            [
                   "PanoramaMode",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_inline",
                   "Defines options for different types of modes for Panorama mission.",
            ],
            [
                   "Defines options for different types of modes for Panorama mission.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_inline",
                   "",
            ],
            [
                   "FULL_CIRCLE",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_FullCircle_inline",
                   "360 Degree Panorama mode.",
            ],
            [
                   "360 Degree Panorama mode.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_FullCircle_inline",
                   "",
            ],
            [
                   "HALF_CIRCLE",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_HalfCircle_inline",
                   "180 Degree Panorama mode. Also known as selfie mode.",
            ],
            [
                   "180 Degree Panorama mode. Also known as selfie mode.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_HalfCircle_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_Unknown_inline",
                   "Unknown mode.",
            ],
            [
                   "Unknown mode.",
                   1,
                   "/Components/Missions/DJIPanoramaMissionOperator.html",
                   "#DJIPanoramaMission_DJIPanoramaMode_Unknown_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMission",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_constructor_inline",
                   "Constructor method for the DJIIntelligentHotpointMission.  @param hotpoint Location of the hotpoint.",
            ],
            [
                   "Constructor method for the DJIIntelligentHotpointMission.  @param hotpoint Location of the hotpoint.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_constructor_inline",
                   "",
            ],
            [
                   "checkParameters",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_checkParameters_inline",
                   "Checks if the configuration for mission is valid before calling `startMission` of `IntelligentHotpointMissionOperator`.  @return Null if everything is OK, a DJIError if at least one is invalid.",
            ],
            [
                   "Checks if the configuration for mission is valid before calling `startMission` of `IntelligentHotpointMissionOperator`.  @return Null if everything is OK, a DJIError if at least one is invalid.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_checkParameters_inline",
                   "",
            ],
            [
                   "setHotpoint",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_hotpoint_inline",
                   "Sets the coordinate of the hotpoint.  @param hotpoint A `LocationCoordinate2D` object of hotpoint.",
            ],
            [
                   "Sets the coordinate of the hotpoint.  @param hotpoint A `LocationCoordinate2D` object of hotpoint.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_hotpoint_inline",
                   "",
            ],
            [
                   "getHotpoint",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_getHotpoint_inline",
                   "Gets the coordinate of the hotpoint.  @return A `LocationCoordinate2D` object of hotpoint.",
            ],
            [
                   "Gets the coordinate of the hotpoint.  @return A `LocationCoordinate2D` object of hotpoint.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_getHotpoint_inline",
                   "",
            ],
            [
                   "MAX_RADIUS",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMaxRadius_inline",
                   "Maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. Currently 500m.",
            ],
            [
                   "Maximum radius, in meters, of the circular path the aircraft will fly around the point of interest. Currently 500m.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMaxRadius_inline",
                   "",
            ],
            [
                   "MIN_RADIUS",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMinRadius_inline",
                   "Minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
            ],
            [
                   "Minimum radius, in meters, of the circular path the aircraft will fly around the point of interest.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMinRadius_inline",
                   "",
            ],
            [
                   "MAX_ALTITUDE",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMaxAltitude_inline",
                   "Maximum altitude in meters for an Intelligent Hotpoint mission.",
            ],
            [
                   "Maximum altitude in meters for an Intelligent Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMaxAltitude_inline",
                   "",
            ],
            [
                   "MIN_ALTITUDE",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMinAltitude_inline",
                   "Minimum altitude in meters for an Intelligent Hotpoint mission.",
            ],
            [
                   "Minimum altitude in meters for an Intelligent Hotpoint mission.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMinAltitude_inline",
                   "",
            ],
            [
                   "IntelligentHotpointMissionMode",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_inline",
                   "This enum defines the mission mode.",
            ],
            [
                   "This enum defines the mission mode.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_inline",
                   "",
            ],
            [
                   "GPS_BASED",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_GPS_inline",
                   "This mode means current mission is started by `startMission`.",
            ],
            [
                   "This mode means current mission is started by `startMission`.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_GPS_inline",
                   "",
            ],
            [
                   "VISION_BASED",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_Vision_inline",
                   "This mode means current mission is started by `startRecognizeTargetInRect`  and `acceptConfirmation`. In this mode, you  can `resetGimbalToCenter` while mission is executing or paused.",
            ],
            [
                   "This mode means current mission is started by `startRecognizeTargetInRect`  and `acceptConfirmation`. In this mode, you  can `resetGimbalToCenter` while mission is executing or paused.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_Vision_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_Unknown_inline",
                   "The mission mode is unknown.",
            ],
            [
                   "The mission mode is unknown.",
                   1,
                   "/Components/Missions/DJIIntelligentHotpointMission.html",
                   "#DJIIntelligentHotpointMission_DJIIntelligentHotpointMissionMode_Unknown_inline",
                   "",
            ],
            [
                   "setTargetRect",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_targetRect_inline",
                   "A bounding box for the target. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right. The `size` parameter of `CGRect` can be set to 0 to initialize the mission with a point instead of a rectangle. If the mission is initialized with a point, the vision system will try to recognize the object around the point and return the representative rect in the status delegate.  This property is used when the `ActiveTrackMission` object is passed to `startTracking`. If the object is passed to `startAutoSensingMission`, this property will be ignored. Use `setTargetIndex` to select the target to track instead.  @param targetRect A RectF object.",
            ],
            [
                   "A bounding box for the target. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right. The `size` parameter of `CGRect` can be set to 0 to initialize the mission with a point instead of a rectangle. If the mission is initialized with a point, the vision system will try to recognize the object around the point and return the representative rect in the status delegate.  This property is used when the `ActiveTrackMission` object is passed to `startTracking`. If the object is passed to `startAutoSensingMission`, this property will be ignored. Use `setTargetIndex` to select the target to track instead.  @param targetRect A RectF object.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_targetRect_inline",
                   "",
            ],
            [
                   "setTargetIndex",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_subjectIndex_inline",
                   "The index of the subject to track. After starting auto sensing (by calling `enableAutoSensing` or `enableAutoSensingForQuickShot`), the aircraft will push the sensed subjects (`getAutoSensedSubjects`). Select the subject to track by passing the index of the subject. This property is used when the `ActiveTrackMission` object is passed to `startAutoSensingMission`. If the object is passed to `startTracking`, this property will be ignored. Use `setTargetRect` to define the target to track.  @param targetIndex The index of the subject to track.",
            ],
            [
                   "The index of the subject to track. After starting auto sensing (by calling `enableAutoSensing` or `enableAutoSensingForQuickShot`), the aircraft will push the sensed subjects (`getAutoSensedSubjects`). Select the subject to track by passing the index of the subject. This property is used when the `ActiveTrackMission` object is passed to `startAutoSensingMission`. If the object is passed to `startTracking`, this property will be ignored. Use `setTargetRect` to define the target to track.  @param targetIndex The index of the subject to track.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_subjectIndex_inline",
                   "",
            ],
            [
                   "getTargetRect",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getTargetRect_inline",
                   "Get RectF object that represents target  @return A RectF object.",
            ],
            [
                   "Get RectF object that represents target  @return A RectF object.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getTargetRect_inline",
                   "",
            ],
            [
                   "setMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_mode_inline",
                   "ActiveTrack Mission mode. Defaults to `TRACE`.  @param mode An enum value of `ActiveTrackMode`.",
            ],
            [
                   "ActiveTrack Mission mode. Defaults to `TRACE`.  @param mode An enum value of `ActiveTrackMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_mode_inline",
                   "",
            ],
            [
                   "getQuickShotMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_quickShotMode_inline",
                   "The QuickShot mode determines the preset flight path. It is only used when `setMode` is `QUICK_SHOT`.  Defaults to `UNKNOWN`. It is only supported by Spark.  @return An enum value of `QuickShotMode`.",
            ],
            [
                   "The QuickShot mode determines the preset flight path. It is only used when `setMode` is `QUICK_SHOT`.  Defaults to `UNKNOWN`. It is only supported by Spark.  @return An enum value of `QuickShotMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_quickShotMode_inline",
                   "",
            ],
            [
                   "setQuickShotMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_setQuickShotMode_inline",
                   "Set the QuickShot mode. It is only supported by Spark.  @param quickShotMode An enum value of `QuickShotMode`.",
            ],
            [
                   "Set the QuickShot mode. It is only supported by Spark.  @param quickShotMode An enum value of `QuickShotMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_setQuickShotMode_inline",
                   "",
            ],
            [
                   "getSpotlightMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getSpotlightMode_inline",
                   "Gets the spotlight mode. It is only used when `setMode`  is `SPOTLIGHT`. Defaults to `UNKNOWN`.  @return An enum value of `SpotlightMode`.",
            ],
            [
                   "Gets the spotlight mode. It is only used when `setMode`  is `SPOTLIGHT`. Defaults to `UNKNOWN`.  @return An enum value of `SpotlightMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getSpotlightMode_inline",
                   "",
            ],
            [
                   "setSpotlightMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_setSpotlightMode_inline",
                   "Set the Spotlight mode.  @param spotlightMode An enum value of `SpotlightMode`.",
            ],
            [
                   "Set the Spotlight mode.  @param spotlightMode An enum value of `SpotlightMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_setSpotlightMode_inline",
                   "",
            ],
            [
                   "ActiveTrackMission",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_constructor_inline",
                   "A constructor method for ActiveTrackMission. The first param can be nullable if the object is passed to `startAutoSensingMission`.  @param targetRect The target rect. @param mode An enum value of `ActiveTrackMode`.",
            ],
            [
                   "A constructor method for ActiveTrackMission. The first param can be nullable if the object is passed to `startAutoSensingMission`.  @param targetRect The target rect. @param mode An enum value of `ActiveTrackMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_constructor_inline",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getMode_inline",
                   "Get the current ActiveTrack mode for ActiveTrack mission.  @return An enum value of `ActiveTrackMode`.",
            ],
            [
                   "Get the current ActiveTrack mode for ActiveTrack mission.  @return An enum value of `ActiveTrackMode`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getMode_inline",
                   "",
            ],
            [
                   "getTargetIndex",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getTargetIndex_inline",
                   "Get Target Index.  @return An int value of target index.",
            ],
            [
                   "Get Target Index.  @return An int value of target index.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_getTargetIndex_inline",
                   "",
            ],
            [
                   "ActiveTrackTrackingState",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "",
                   "The tracking state of the ActiveTrack mission that is executing.",
            ],
            [
                   "The tracking state of the ActiveTrack mission that is executing.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_state_inline",
                   "The state of the target being tracked.  @return An enum value of `ActiveTrackTargetState`.",
            ],
            [
                   "The state of the target being tracked.  @return An enum value of `ActiveTrackTargetState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_state_inline",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetType_inline",
                   "The type of the target being tracked.  @return An enum value of `ActiveTrackTargetType`.",
            ],
            [
                   "The type of the target being tracked.  @return An enum value of `ActiveTrackTargetType`.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetType_inline",
                   "",
            ],
            [
                   "getTargetRect",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetRect_inline",
                   "A rectangle in the live video view image that represents the target being tracked. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return A RectF object.",
            ],
            [
                   "A rectangle in the live video view image that represents the target being tracked. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return A RectF object.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetRect_inline",
                   "",
            ],
            [
                   "getTargetIndex",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetIndex_inline",
                   "An int value of target index.  @return An int value of target index.",
            ],
            [
                   "An int value of target index.  @return An int value of target index.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_targetIndex_inline",
                   "",
            ],
            [
                   "getReason",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_cannotConfirmReason_inline",
                   "Reason why the target cannot be confirmed by the user. It is useful when `getState` is `CANNOT_CONFIRM`.  Otherwise, it is `NONE`. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `ActiveTrackCannotConfirmReason`.",
            ],
            [
                   "Reason why the target cannot be confirmed by the user. It is useful when `getState` is `CANNOT_CONFIRM`.  Otherwise, it is `NONE`. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `ActiveTrackCannotConfirmReason`.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_cannotConfirmReason_inline",
                   "",
            ],
            [
                   "getCompletionPercentage",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_progress_inline",
                   "The progress of the executing QuickShot mission. Only applicable when `setMode` is `QUICK_SHOT`. For other modes, it is always 0.  @return An int value of the progress.",
            ],
            [
                   "The progress of the executing QuickShot mission. Only applicable when `setMode` is `QUICK_SHOT`. For other modes, it is always 0.  @return An int value of the progress.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_progress_inline",
                   "",
            ],
            [
                   "getAutoSensedSubjects",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_autoSensedSubjects_inline",
                   "The auto-sensed subjects after enabling auto sensing.  @return An array of `SubjectSensingState`",
            ],
            [
                   "The auto-sensed subjects after enabling auto sensing.  @return An array of `SubjectSensingState`",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTrackingState_autoSensedSubjects_inline",
                   "",
            ],
            [
                   "SubjectSensingState",
                   2,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "",
                   "The state of one of the auto-sensed subject after enabling auto sensing. Only supported by DJI Mavic Air.",
            ],
            [
                   "The state of one of the auto-sensed subject after enabling auto sensing. Only supported by DJI Mavic Air.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_index_inline",
                   "Index of the auto-sensed subjects. After enabling auto sensing, the aircraft may find multiple subjects and an index will be assigned to each subject. Use this index to select the subject to track.  @return An int value of target index.",
            ],
            [
                   "Index of the auto-sensed subjects. After enabling auto sensing, the aircraft may find multiple subjects and an index will be assigned to each subject. Use this index to select the subject to track.  @return An int value of target index.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_index_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_state_inline",
                   "The target state of the auto-sensed subject.  @return An enum value of `ActiveTrackTargetState`.",
            ],
            [
                   "The target state of the auto-sensed subject.  @return An enum value of `ActiveTrackTargetState`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_state_inline",
                   "",
            ],
            [
                   "getTargetType",
                   2,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_targetType_inline",
                   "The type of the auto-sensed subject.  @return An enum value of `ActiveTrackTargetType`.",
            ],
            [
                   "The type of the auto-sensed subject.  @return An enum value of `ActiveTrackTargetType`.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_targetType_inline",
                   "",
            ],
            [
                   "getTargetRect",
                   2,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_targetRect_inline",
                   "A rectangle in the live video view image that represents the auto-sensed subject. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return A RectF object.",
            ],
            [
                   "A rectangle in the live video view image that represents the auto-sensed subject. The rectangle is normalized to [0,1] where (0,0) is the top left of the video preview and (1,1) is the bottom right.  @return A RectF object.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission_DJISubjectSensingState.html",
                   "#DJIActiveTrackMission_DJISubjectSensingState_targetRect_inline",
                   "",
            ],
            [
                   "ActiveTrackCannotConfirmReason",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_inline",
                   "The reason why user is not allowed to confirm the current target.",
            ],
            [
                   "The reason why user is not allowed to confirm the current target.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_None_inline",
                   "None.",
            ],
            [
                   "None.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_None_inline",
                   "",
            ],
            [
                   "UNSTABLE_TARGET",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_UnstableTarget_inline",
                   "The target is unstable.",
            ],
            [
                   "The target is unstable.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_UnstableTarget_inline",
                   "",
            ],
            [
                   "TARGET_TOO_HIGH",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooHigh_inline",
                   "The target position is too high.",
            ],
            [
                   "The target position is too high.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooHigh_inline",
                   "",
            ],
            [
                   "BLOCKED_BY_OBSTACLE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_BlockedByObstacle_inline",
                   "There is an obstacle between the aircraft and the target that is blocking the target.",
            ],
            [
                   "There is an obstacle between the aircraft and the target that is blocking the target.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_BlockedByObstacle_inline",
                   "",
            ],
            [
                   "GIMBAL_ATTITUDE_ERROR",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_GimbalAttitudeError_inline",
                   "The gimbal's attitude is pointing to the ground.",
            ],
            [
                   "The gimbal's attitude is pointing to the ground.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_GimbalAttitudeError_inline",
                   "",
            ],
            [
                   "TARGET_TOO_FAR",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooFar_inline",
                   "The target is too far away from the aircraft.",
            ],
            [
                   "The target is too far away from the aircraft.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooFar_inline",
                   "",
            ],
            [
                   "TARGET_TOO_CLOSE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooClose_inline",
                   "The target is too close to the aircraft.",
            ],
            [
                   "The target is too close to the aircraft.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_TargetTooClose_inline",
                   "",
            ],
            [
                   "AIRCRAFT_TOO_HIGH",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_AircraftTooHigh_inline",
                   "The altitude of the aircraft is too high.",
            ],
            [
                   "The altitude of the aircraft is too high.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_AircraftTooHigh_inline",
                   "",
            ],
            [
                   "AIRCRAFT_TOO_LOW",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_AircraftTooLow_inline",
                   "The altitude of the aircraft is too low.",
            ],
            [
                   "The altitude of the aircraft is too low.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_AircraftTooLow_inline",
                   "",
            ],
            [
                   "OBSTACLE_SENSOR_ERROR",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_ObstacleSensorError_inline",
                   "The obstacle vision sensor has errors.",
            ],
            [
                   "The obstacle vision sensor has errors.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_ObstacleSensorError_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackCannotConfirmReason_Unknown_inline",
                   "",
            ],
            [
                   "ActiveTrackMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_inline",
                   "Different modes of the ActiveTrack Mission. Defaults to `TRACE`, set to others to enable the feature.",
            ],
            [
                   "Different modes of the ActiveTrack Mission. Defaults to `TRACE`, set to others to enable the feature.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_inline",
                   "",
            ],
            [
                   "ACTIVE_TRACK_MODE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_inline",
                   "SDK Key for ActiveTrackMode: Different modes of the ActiveTrack Mission. Defaults to `TRACE`, set to others to enable the feature.",
            ],
            [
                   "SDK Key for ActiveTrackMode: Different modes of the ActiveTrack Mission. Defaults to `TRACE`, set to others to enable the feature.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_inline",
                   "",
            ],
            [
                   "TRACE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Trace_inline",
                   "Aircraft moves in behind the subject keeping a constant distance to it. Mission with this mode can only be started when the aircraft is flying.",
            ],
            [
                   "Aircraft moves in behind the subject keeping a constant distance to it. Mission with this mode can only be started when the aircraft is flying.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Trace_inline",
                   "",
            ],
            [
                   "PROFILE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Profile_inline",
                   "Aircraft moves in parallel with the subject in the frame instead of behind. Mission with this mode can only be started when the aircraft is flying.",
            ],
            [
                   "Aircraft moves in parallel with the subject in the frame instead of behind. Mission with this mode can only be started when the aircraft is flying.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Profile_inline",
                   "",
            ],
            [
                   "SPOTLIGHT",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Spotlight_inline",
                   "In Spotlight mode, the aircraft camera automatically follows the subject by rotating the aircraft's yaw, but the aircraft does not automatically keep a constant distance with the subject. Mission with this mode can only be started when the aircraft is flying.",
            ],
            [
                   "In Spotlight mode, the aircraft camera automatically follows the subject by rotating the aircraft's yaw, but the aircraft does not automatically keep a constant distance with the subject. Mission with this mode can only be started when the aircraft is flying.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Spotlight_inline",
                   "",
            ],
            [
                   "SPOTLIGHT_PRO",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_SpotlightPro_inline",
                   "In Spotlight Pro mode, the aircraft camera automatically follows the subject by rotating the gimbal's yaw, but the aircraft does not automatically keep a constant distance with the subject. Not Supported by Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "In Spotlight Pro mode, the aircraft camera automatically follows the subject by rotating the gimbal's yaw, but the aircraft does not automatically keep a constant distance with the subject. Not Supported by Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_SpotlightPro_inline",
                   "",
            ],
            [
                   "QUICK_SHOT",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_QuickShot_inline",
                   "In QuickShot mode, the aircraft will fly in one of four preset paths (see `QuickShotMode`) while tracking the object recording a video. When a QuickShot mission ends, a 10-second video will be generated. Supported by Spark and Mavic 2 Series.",
            ],
            [
                   "In QuickShot mode, the aircraft will fly in one of four preset paths (see `QuickShotMode`) while tracking the object recording a video. When a QuickShot mission ends, a 10-second video will be generated. Supported by Spark and Mavic 2 Series.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_QuickShot_inline",
                   "",
            ],
            [
                   "CIRCLE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Circle_inline",
                   "Aircraft will circle around the object it is tracking. Only Supported by Mavic Air 2 and Mavic 2 Series.",
            ],
            [
                   "Aircraft will circle around the object it is tracking. Only Supported by Mavic Air 2 and Mavic 2 Series.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Circle_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Unknown_inline",
                   "The active track mode is unknown.",
            ],
            [
                   "The active track mode is unknown.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackMode_Unknown_inline",
                   "",
            ],
            [
                   "QuickShotMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_inline",
                   "QuickShot modes, which define different preset path for a QuickShot mission.",
            ],
            [
                   "QuickShot modes, which define different preset path for a QuickShot mission.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_inline",
                   "",
            ],
            [
                   "CIRCLE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Circle_inline",
                   "Aircraft will circle around the object it is tracking.",
            ],
            [
                   "Aircraft will circle around the object it is tracking.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Circle_inline",
                   "",
            ],
            [
                   "DRONIE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Dronie_inline",
                   "Aircraft will fly backward and upward with camera locked on the object it is tracking.",
            ],
            [
                   "Aircraft will fly backward and upward with camera locked on the object it is tracking.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Dronie_inline",
                   "",
            ],
            [
                   "HELIX",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Helix_inline",
                   "Aircraft will fly upward, spiraling around the object it is tracking.",
            ],
            [
                   "Aircraft will fly upward, spiraling around the object it is tracking.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Helix_inline",
                   "",
            ],
            [
                   "ROCKET",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Rocket_inline",
                   "The aircraft will ascend with the camera pointing downward on the object it is tracking.",
            ],
            [
                   "The aircraft will ascend with the camera pointing downward on the object it is tracking.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Rocket_inline",
                   "",
            ],
            [
                   "BOOMERANG",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Boomerang_inline",
                   "The aircraft will fly around the tracking object in an upwardly sloped oval with the video finishing at the start point. Supported by DJI Mavic Air, Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "The aircraft will fly around the tracking object in an upwardly sloped oval with the video finishing at the start point. Supported by DJI Mavic Air, Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Boomerang_inline",
                   "",
            ],
            [
                   "ASTEROID",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Asteroid_inline",
                   "The aircraft will fly backward and upward while recording video, capture a sphere panorama at the end of the flight path, then combine the footage and panorama into a short video. Supported by DJI Mavic Air, Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "The aircraft will fly backward and upward while recording video, capture a sphere panorama at the end of the flight path, then combine the footage and panorama into a short video. Supported by DJI Mavic Air, Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Asteroid_inline",
                   "",
            ],
            [
                   "DOLLY_ZOOM",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_DollyZoom_inline",
                   "The aircraft will fly backward and upward. It will adjust the zoom during flight to keep the selected subject the same while the background changes. Ensure there is sufficient space when using Dolly Zoom. Allow at least triple distance from aircraft to the subject behind the aircraft. Only supported by Mavic 2 Zoom.",
            ],
            [
                   "The aircraft will fly backward and upward. It will adjust the zoom during flight to keep the selected subject the same while the background changes. Ensure there is sufficient space when using Dolly Zoom. Allow at least triple distance from aircraft to the subject behind the aircraft. Only supported by Mavic 2 Zoom.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_DollyZoom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackQuickShotMode_Unknown_inline",
                   "",
            ],
            [
                   "SpotlightMode",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_inline",
                   "Spotlight modes, which define different submode for a Spotlight mission.",
            ],
            [
                   "Spotlight modes, which define different submode for a Spotlight mission.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_inline",
                   "",
            ],
            [
                   "ZOOM_GIMBAL_FOLLOWING",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_ZoomGimbalFollowing_inline",
                   "In gimbal follow mode, the orientation of the aircraft heading is always consitent with the gimbal, both aiming at the target. At this time, the attitude of the gimbal will be automatically adjusted so that the target can be in the center of the screen, and the user can fine-tune the field of view by triming the gimbal dial; the camera will automatically adjust the zoom to make the size of the target suitable.",
            ],
            [
                   "In gimbal follow mode, the orientation of the aircraft heading is always consitent with the gimbal, both aiming at the target. At this time, the attitude of the gimbal will be automatically adjusted so that the target can be in the center of the screen, and the user can fine-tune the field of view by triming the gimbal dial; the camera will automatically adjust the zoom to make the size of the target suitable.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_ZoomGimbalFollowing_inline",
                   "",
            ],
            [
                   "ZOOM_GIMBAL_FREE",
                   2,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_ZoomGimbalFree_inline",
                   "In gimbal free mode, the spot light tracking will only control the gimbal to track the target instead of the drone so that the landing gear of the aircraft may appear in the view and the gimbal rotation range is limited by the gimbal mechanical limit.",
            ],
            [
                   "In gimbal free mode, the spot light tracking will only control the gimbal to track the target instead of the drone so that the landing gear of the aircraft may appear in the view and the gimbal rotation range is limited by the gimbal mechanical limit.",
                   1,
                   "/Components/Missions/DJIActiveTrackMission.html",
                   "#DJIActiveTrackMission_DJIActiveTrackSpotlightMode_ZoomGimbalFree_inline",
                   "",
            ],
            [
                   "ActiveTrackTargetType",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_inline",
                   "The type of ActiveTrack target.",
            ],
            [
                   "The type of ActiveTrack target.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_inline",
                   "",
            ],
            [
                   "HUMAN",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Human_inline",
                   "The ActiveTrack target is a human being.",
            ],
            [
                   "The ActiveTrack target is a human being.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Human_inline",
                   "",
            ],
            [
                   "CAR",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Car_inline",
                   "The ActiveTrack target is a car.",
            ],
            [
                   "The ActiveTrack target is a car.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Car_inline",
                   "",
            ],
            [
                   "VAN",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Van_inline",
                   "The ActiveTrack target is a van.",
            ],
            [
                   "The ActiveTrack target is a van.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Van_inline",
                   "",
            ],
            [
                   "BIKE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Bike_inline",
                   "The ActiveTrack target is a bike.",
            ],
            [
                   "The ActiveTrack target is a bike.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Bike_inline",
                   "",
            ],
            [
                   "BOAT",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Boat_inline",
                   "The ActiveTrack target is a boat.",
            ],
            [
                   "The ActiveTrack target is a boat.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Boat_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Unknown_inline",
                   "The aircraft cannot recognize the target type.",
            ],
            [
                   "The aircraft cannot recognize the target type.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetType_Unknown_inline",
                   "",
            ],
            [
                   "ActiveTrackTargetState",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_inline",
                   "The state of the target being tracked by the aircraft.",
            ],
            [
                   "The state of the target being tracked by the aircraft.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_inline",
                   "",
            ],
            [
                   "CANNOT_CONFIRM",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_CannotConfirm_inline",
                   "The aircraft has recognized the target but the user is not allowed to confirm the target. Check `getReason` to get more information.",
            ],
            [
                   "The aircraft has recognized the target but the user is not allowed to confirm the target. Check `getReason` to get more information.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_CannotConfirm_inline",
                   "",
            ],
            [
                   "WAITING_FOR_CONFIRMATION",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_WaitingForConfirmation_inline",
                   "The aircraft has recognized the target and is waiting for user's confirmation. If this state, the aircraft will hover in the current position while the camera is tracking the target (by rotating aircraft's yaw or gimbal's altitude). If user confirms the target, the aircraft will start to following the movement of the target.",
            ],
            [
                   "The aircraft has recognized the target and is waiting for user's confirmation. If this state, the aircraft will hover in the current position while the camera is tracking the target (by rotating aircraft's yaw or gimbal's altitude). If user confirms the target, the aircraft will start to following the movement of the target.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_WaitingForConfirmation_inline",
                   "",
            ],
            [
                   "TRACKING_WITH_HIGH_CONFIDENCE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_TrackingWithHighConfidence_inline",
                   "The aircraft has recognized the target with high confidence.",
            ],
            [
                   "The aircraft has recognized the target with high confidence.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_TrackingWithHighConfidence_inline",
                   "",
            ],
            [
                   "TRACKING_WITH_LOW_CONFIDENCE",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_TrackingWithLowConfidence_inline",
                   "The ActiveTrack Mission is tracking a target with low confidence. This is only an indication that either the aircraft will soon ask for confirmation that the target is correct, or may loose tracking the target entirely if confidence doesn't improve.",
            ],
            [
                   "The ActiveTrack Mission is tracking a target with low confidence. This is only an indication that either the aircraft will soon ask for confirmation that the target is correct, or may loose tracking the target entirely if confidence doesn't improve.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_TrackingWithLowConfidence_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIActiveTrackTrackingState.html",
                   "#DJIActiveTrackTargetState_Unknown_inline",
                   "",
            ],
            [
                   "InterruptRecoverActionType",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_inline",
                   "Determines the recover mission flying to which point. call `recoverMission` to recover mission.  The waypoint mission is interrupted by invoking `interruptMission`. The waypoint mission is  interrupted by moving remote controller's joystick. Other interruption such as obstacle avoidance.",
            ],
            [
                   "Determines the recover mission flying to which point. call `recoverMission` to recover mission.  The waypoint mission is interrupted by invoking `interruptMission`. The waypoint mission is  interrupted by moving remote controller's joystick. Other interruption such as obstacle avoidance.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_inline",
                   "",
            ],
            [
                   "GoBackToRecordPoint",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_GoBackToRecordedPoint_inline",
                   "When the mission is recovered, the aircraft flying to the recorded point.",
            ],
            [
                   "When the mission is recovered, the aircraft flying to the recorded point.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_GoBackToRecordedPoint_inline",
                   "",
            ],
            [
                   "GoBackToNextPoint",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_GoBackToNextWaypoint_inline",
                   "When the mission is recovered, the aircraft flying to next waypoint.",
            ],
            [
                   "When the mission is recovered, the aircraft flying to next waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2InterruptRecoverAction_GoBackToNextWaypoint_inline",
                   "",
            ],
            [
                   "MissionFinishedAction",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_inline",
                   "Actions will be taken when the waypoint mission is finished.",
            ],
            [
                   "Actions will be taken when the waypoint mission is finished.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_inline",
                   "",
            ],
            [
                   "NO_ACTION",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_NoAction_inline",
                   "No further action will be taken. The aircraft can be controlled by the remote controller.",
            ],
            [
                   "No further action will be taken. The aircraft can be controlled by the remote controller.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_NoAction_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_GoHome_inline",
                   "Goes home when the mission is finished. The aircraft will land directly if it is within 20  meters away from the home point.",
            ],
            [
                   "Goes home when the mission is finished. The aircraft will land directly if it is within 20  meters away from the home point.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_GoHome_inline",
                   "",
            ],
            [
                   "AUTO_LAND",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_AutoLanding_inline",
                   "The aircraft will land automatically at the last waypoint.",
            ],
            [
                   "The aircraft will land automatically at the last waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_AutoLanding_inline",
                   "",
            ],
            [
                   "GO_FIRST_WAYPOINT",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_GoToFirstWaypoint_inline",
                   "The aircraft will go back to the first waypoint and hover.",
            ],
            [
                   "The aircraft will go back to the first waypoint and hover.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_GoToFirstWaypoint_inline",
                   "",
            ],
            [
                   "CONTINUE_UNTIL_STOP",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_ContinueUntilStop_inline",
                   "When the aircraft reaches its final waypoint, it will hover without ending the mission. The joystick  can still be used to pull the aircraft back along its previous waypoints. The only way this mission  can end is if stopMission is called.",
            ],
            [
                   "When the aircraft reaches its final waypoint, it will hover without ending the mission. The joystick  can still be used to pull the aircraft back along its previous waypoints. The only way this mission  can end is if stopMission is called.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionFinishedAction_ContinueUntilStop_inline",
                   "",
            ],
            [
                   "MissionGotoWaypointMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_inline",
                   "Possible flight mode to executes the mission.",
            ],
            [
                   "Possible flight mode to executes the mission.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_inline",
                   "",
            ],
            [
                   "SAFELY",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_Safely_inline",
                   "Go to the waypoint safely. The aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. It then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
            ],
            [
                   "Go to the waypoint safely. The aircraft will rise to the same altitude of the waypoint if the current  altitude is lower then the waypoint altitude. It then goes to the waypoint coordinate from the current  altitude, and proceeds to the altitude of the waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_Safely_inline",
                   "",
            ],
            [
                   "POINT_TO_POINT",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_PointToPoint_inline",
                   "Go to the waypoint from the current aircraft point to the waypoint directly.",
            ],
            [
                   "Go to the waypoint from the current aircraft point to the waypoint directly.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2MissionGotoFirstWaypointMode_PointToPoint_inline",
                   "",
            ],
            [
                   "ActionTypes",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "",
                   "Manage all the action types.",
            ],
            [
                   "Manage all the action types.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "",
                   "",
            ],
            [
                   "AssociatedTimingType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_inline",
                   "The type of `WaypointV2AssociateTriggerParam`,  Determines the time to execute the trigger associated with another one.",
            ],
            [
                   "The type of `WaypointV2AssociateTriggerParam`,  Determines the time to execute the trigger associated with another one.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_inline",
                   "",
            ],
            [
                   "SIMULTANEOUSLY",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_Simultaneously_inline",
                   "The trigger starts simultaneously with the trigger that is associated.",
            ],
            [
                   "The trigger starts simultaneously with the trigger that is associated.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_Simultaneously_inline",
                   "",
            ],
            [
                   "AFTER_FINISHED",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_AfterFinished_inline",
                   "The trigger starts after the trigger associated has finished.",
            ],
            [
                   "The trigger starts after the trigger associated has finished.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_AfterFinished_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_Unknown_inline",
                   "Unkown timing type.",
            ],
            [
                   "Unkown timing type.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action_ActionTypes.html",
                   "#DJIWaypointV2TriggerAssociatedTimingType_Unknown_inline",
                   "",
            ],
            [
                   "ActionIntervalType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_inline",
                   "The type of `WaypointIntervalTriggerParam`,  Determines the interval type of how action repeats.",
            ],
            [
                   "The type of `WaypointIntervalTriggerParam`,  Determines the interval type of how action repeats.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_inline",
                   "",
            ],
            [
                   "DISTANCE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Distance_inline",
                   "The action will be repeated after a particular distance.",
            ],
            [
                   "The action will be repeated after a particular distance.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Distance_inline",
                   "",
            ],
            [
                   "TIME",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Time_inline",
                   "The action will be repeated after a particular period of time.",
            ],
            [
                   "The action will be repeated after a particular period of time.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Time_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Unknown_inline",
                   "Unknown action trigger type.",
            ],
            [
                   "Unknown action trigger type.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionIntervalType_Unknown_inline",
                   "",
            ],
            [
                   "ActionTriggerType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_inline",
                   "Possible types of action trigger.",
            ],
            [
                   "Possible types of action trigger.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_inline",
                   "",
            ],
            [
                   "REACH_POINT",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_ReachPoint_inline",
                   "The action will be trigger when the aircraft reach the waypoint point. The parameters should be setting  by `WaypointReachPointTriggerParam`.",
            ],
            [
                   "The action will be trigger when the aircraft reach the waypoint point. The parameters should be setting  by `WaypointReachPointTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_ReachPoint_inline",
                   "",
            ],
            [
                   "ASSOCIATE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_ActionAssociated_inline",
                   "The action will be triggered when action associated executes. The parameters should be defined  by `WaypointV2AssociateTriggerParam`.",
            ],
            [
                   "The action will be triggered when action associated executes. The parameters should be defined  by `WaypointV2AssociateTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_ActionAssociated_inline",
                   "",
            ],
            [
                   "TRAJECTORY",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Trajectory_inline",
                   "The action will be triggered when the aircraft flies from one waypoint to the next.  This trigger applies only to `AIRCRAFT_CONTROL_GIMBAL`.  When this is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index. The parameters should be defined by `WaypointTrajectoryTriggerParam`.",
            ],
            [
                   "The action will be triggered when the aircraft flies from one waypoint to the next.  This trigger applies only to `AIRCRAFT_CONTROL_GIMBAL`.  When this is triggered, the gimbal will rotate at a constant speed from the start waypoint index to the end waypoint index. The parameters should be defined by `WaypointTrajectoryTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Trajectory_inline",
                   "",
            ],
            [
                   "SIMPLE_INTERVAL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Interval_inline",
                   "The action will be triggered when the aircraft flies between two waypoints The parameters should be defined by `WaypointIntervalTriggerParam`.",
            ],
            [
                   "The action will be triggered when the aircraft flies between two waypoints The parameters should be defined by `WaypointIntervalTriggerParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Interval_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionTriggerType_Unknown_inline",
                   "",
            ],
            [
                   "ActionActuatorType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_inline",
                   "Possible types of action actuator.",
            ],
            [
                   "Possible types of action actuator.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_inline",
                   "",
            ],
            [
                   "CAMERA",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Camera_inline",
                   "The action will be executed by the camera. The parameters should be defined by `WaypointCameraActuatorParam`.",
            ],
            [
                   "The action will be executed by the camera. The parameters should be defined by `WaypointCameraActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Camera_inline",
                   "",
            ],
            [
                   "GIMBAL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Gimbal_inline",
                   "The action will be executed by the gimbal. The parameters should be defined by `WaypointGimbalActuatorParam`.",
            ],
            [
                   "The action will be executed by the gimbal. The parameters should be defined by `WaypointGimbalActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Gimbal_inline",
                   "",
            ],
            [
                   "AIRCRAFT_CONTROL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_AircraftControl_inline",
                   "The action will executes by controlling aircraft. The parameters should be defined by `WaypointAircraftControlParam`.",
            ],
            [
                   "The action will executes by controlling aircraft. The parameters should be defined by `WaypointAircraftControlParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_AircraftControl_inline",
                   "",
            ],
            [
                   "LIDAR",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Lidar_inline",
                   "The action will executes by the lidar. The parameters should be defined by `WaypointLidarActuatorParam`.",
            ],
            [
                   "The action will executes by the lidar. The parameters should be defined by `WaypointLidarActuatorParam`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Lidar_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Unknown_inline",
                   "Unknown actuator type.",
            ],
            [
                   "Unknown actuator type.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_DJIWaypointV2ActionActuatorType_Unknown_inline",
                   "",
            ],
            [
                   "GimbalOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_inline",
                   "The type of gimbal actuator operation.",
            ],
            [
                   "The type of gimbal actuator operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_inline",
                   "",
            ],
            [
                   "ROTATE_GIMBAL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_RotateGimbal_inline",
                   "Rotates the gimbal. The range of the pitch angle should be gotten from `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.  Only valid when the trigger type is `REACH_POINT`.",
            ],
            [
                   "Rotates the gimbal. The range of the pitch angle should be gotten from `ADJUST_PITCH` or `ADJUST_PITCH_UPWARDS`.  Only valid when the trigger type is `REACH_POINT`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_RotateGimbal_inline",
                   "",
            ],
            [
                   "AIRCRAFT_CONTROL_GIMBAL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_AircraftControlGimbal_inline",
                   "Rotates the gimbal. Only valid when the trigger type is `TRAJECTORY`.",
            ],
            [
                   "Rotates the gimbal. Only valid when the trigger type is `TRAJECTORY`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_AircraftControlGimbal_inline",
                   "",
            ],
            [
                   "PATH_SHOOTING",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_PathShooting_inline",
                   "Rotates the gimbal then take photos. This type is only Supported by Zenmuse P1. You can use this type to achieve Smart Oblique Capture.  Elevate the efficiency of your oblique photography mission using Smart Oblique Capture, where the gimbal automatically rotates to take photos at the different angles needed. Only photos essential to the reconstruction will be taken at the edge of the flight area, increasing the efficiency of post processing by 20% to 50%. Only valid when the trigger types are `REACH_POINT` and `ASSOCIATE`.",
            ],
            [
                   "Rotates the gimbal then take photos. This type is only Supported by Zenmuse P1. You can use this type to achieve Smart Oblique Capture.  Elevate the efficiency of your oblique photography mission using Smart Oblique Capture, where the gimbal automatically rotates to take photos at the different angles needed. Only photos essential to the reconstruction will be taken at the edge of the flight area, increasing the efficiency of post processing by 20% to 50%. Only valid when the trigger types are `REACH_POINT` and `ASSOCIATE`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_PathShooting_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorGimbalOperationType_Unknown_inline",
                   "",
            ],
            [
                   "CameraOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_inline",
                   "Possible types of camera actuator operation.",
            ],
            [
                   "Possible types of camera actuator operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_inline",
                   "",
            ],
            [
                   "SHOOT_SINGLE_PHOTO",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_TakePhoto_inline",
                   "Starts to shoot a photo.",
            ],
            [
                   "Starts to shoot a photo.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_TakePhoto_inline",
                   "",
            ],
            [
                   "START_RECORD_VIDEO",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_StartRecordVideo_inline",
                   "Starts to record a video.",
            ],
            [
                   "Starts to record a video.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_StartRecordVideo_inline",
                   "",
            ],
            [
                   "STOP_RECORD_VIDEO",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_StopRecordVideo_inline",
                   "Stops to record a video.",
            ],
            [
                   "Stops to record a video.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_StopRecordVideo_inline",
                   "",
            ],
            [
                   "CUSTOM_NAME",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CustomName_inline",
                   "Custom Expand File or directory name. You can use this actuator type to customize the file name and folder name of photos during the flight route,  it is convenient for users to manage the files after exporting media files from camera. This type should be set in `setCameraOperationType`. meanwhile you should set the param for `setCustomNameParam` which used to determine whether you need to customize the file name or folder.",
            ],
            [
                   "Custom Expand File or directory name. You can use this actuator type to customize the file name and folder name of photos during the flight route,  it is convenient for users to manage the files after exporting media files from camera. This type should be set in `setCameraOperationType`. meanwhile you should set the param for `setCustomNameParam` which used to determine whether you need to customize the file name or folder.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CustomName_inline",
                   "",
            ],
            [
                   "FOCUS",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Focus_inline",
                   "You can use this type to point focus or rectangle focus.",
            ],
            [
                   "You can use this type to point focus or rectangle focus.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Focus_inline",
                   "",
            ],
            [
                   "ZOOM",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Zoom_inline",
                   "Adjust the camera focal length. Only support those support zoom cameras.",
            ],
            [
                   "Adjust the camera focal length. Only support those support zoom cameras.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Zoom_inline",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_FocusMode_inline",
                   "Set the camera focus mode. We currently support auto and manual modes.",
            ],
            [
                   "Set the camera focus mode. We currently support auto and manual modes.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_FocusMode_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_Unknown_inline",
                   "",
            ],
            [
                   "GimbalPathShootingType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2_GimbalPathShootingType_inline",
                   "Possible types of gimbal path shootting operation.",
            ],
            [
                   "Possible types of gimbal path shootting operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2_GimbalPathShootingType_inline",
                   "",
            ],
            [
                   "START_PATH_SHOOTING",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_StartPathShooting_inline",
                   "Start path shooting.",
            ],
            [
                   "Start path shooting.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_StartPathShooting_inline",
                   "",
            ],
            [
                   "STOP_PATH_SHOOTING",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_StopPathShooting_inline",
                   "Stop path shooting.",
            ],
            [
                   "Stop path shooting.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_StopPathShooting_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_PathShootingTypeUnknown_inline",
                   "Unknown type.",
            ],
            [
                   "Unknown type.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Gimbal_PathShootingTypeUnknown_inline",
                   "",
            ],
            [
                   "GimbalPathCycleMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_inline",
                   "Possible types of gimbal path cycle mode operation.",
            ],
            [
                   "Possible types of gimbal path cycle mode operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_inline",
                   "",
            ],
            [
                   "ONCE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_Once_inline",
                   "Path shooting will be executed once.",
            ],
            [
                   "Path shooting will be executed once.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_Once_inline",
                   "",
            ],
            [
                   "UNLIMITED",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_Unlimited_inline",
                   "Path shooting will be executed countless times.",
            ],
            [
                   "Path shooting will be executed countless times.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_GimbalPathCycleMode_Unlimited_inline",
                   "",
            ],
            [
                   "LidarOperationType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_LidarOperationType_inline",
                   "Possible types of lidar operation.",
            ],
            [
                   "Possible types of lidar operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_LidarOperationType_inline",
                   "",
            ],
            [
                   "RECORD_POINT_CLOUD",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_LidarOperationType_PointCloudRecord_inline",
                   "Point cloud record opration. You can use this type to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
            ],
            [
                   "Point cloud record opration. You can use this type to start,stop,pause,resume record point cloud when a waypoint mission is executing.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuator_LidarOperationType_PointCloudRecord_inline",
                   "",
            ],
            [
                   "PointCloudRecordType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2_PointCloudRecordType_inline",
                   "Possible types of point cloud record operation.",
            ],
            [
                   "Possible types of point cloud record operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2_PointCloudRecordType_inline",
                   "",
            ],
            [
                   "STOP_RECORD_POINT_CLOUD",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_StopPointCloudRecording_inline",
                   "Stop point cloud recording.",
            ],
            [
                   "Stop point cloud recording.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_StopPointCloudRecording_inline",
                   "",
            ],
            [
                   "START_RECORD_POINT_CLOUD",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_StartPointCloudRecording_inline",
                   "Start point cloud recording.",
            ],
            [
                   "Start point cloud recording.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_StartPointCloudRecording_inline",
                   "",
            ],
            [
                   "PAUSE_RECORD_POINT_CLOUD",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_PausePointCloudRecording_inline",
                   "Pause point cloud recording.",
            ],
            [
                   "Pause point cloud recording.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_PausePointCloudRecording_inline",
                   "",
            ],
            [
                   "RESUME_RECORD_POINT_CLOUD",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_ResumePointCloudRecording_inline",
                   "Resume point cloud recording.",
            ],
            [
                   "Resume point cloud recording.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Lidar_ResumePointCloudRecording_inline",
                   "",
            ],
            [
                   "AircraftControlType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_inline",
                   "Possible types of aircraft control actuator operation.",
            ],
            [
                   "Possible types of aircraft control actuator operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_inline",
                   "",
            ],
            [
                   "ROTATE_YAW",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_RotateYaw_inline",
                   "Rotates the aircraft's yaw.",
            ],
            [
                   "Rotates the aircraft's yaw.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_RotateYaw_inline",
                   "",
            ],
            [
                   "START_STOP_FLY",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_FlyingControl_inline",
                   "Keeps the aircraft stop flying or start flying.",
            ],
            [
                   "Keeps the aircraft stop flying or start flying.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorAircraftControlOperationType_FlyingControl_inline",
                   "",
            ],
            [
                   "CameraCustomNameType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_inline",
                   "Possible types of custom expand name actuator operation.",
            ],
            [
                   "Possible types of custom expand name actuator operation.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_inline",
                   "",
            ],
            [
                   "FILE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_File_inline",
                   "Custom expand file name. When your set this type in waypoint action, after aircraft trigger the action,  the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. For example, the default photo name is DJI_2020012091415_999_WIDE.JPG, you could append Waypoint1 after the default photo name, so the new photo's name will be DJI_2020012091415_999_WIDE_Waypoint1.JPG. This action will only take effect once, if you want to append the same name for all photos in one mission,  you need to set this action before taking each photo. Only Supported by Zenmuse P1, Zenmuse H20 Series.",
            ],
            [
                   "Custom expand file name. When your set this type in waypoint action, after aircraft trigger the action,  the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. For example, the default photo name is DJI_2020012091415_999_WIDE.JPG, you could append Waypoint1 after the default photo name, so the new photo's name will be DJI_2020012091415_999_WIDE_Waypoint1.JPG. This action will only take effect once, if you want to append the same name for all photos in one mission,  you need to set this action before taking each photo. Only Supported by Zenmuse P1, Zenmuse H20 Series.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_File_inline",
                   "",
            ],
            [
                   "DIR",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_Dir_inline",
                   "Custom expand directory name. When your set this type in waypoint action, after aircraft trigger the action, the newly generated media files (videos or photos) will be stored in the new folder when taking photo or record video,  this new folder's name will be appended by your custom directory name. for example by default, the default folder name is DJI_202001012359_01,  you could append Mission1 after it, so the new folder's name will be DJI_202001012359_01_Mission1.  Please notice that the default folder's name also would be updated automatically when the drone completes the landing,  the camera will update the last two digits in DJI_202001012359_01 to DJI_202001012359_02, so before your drone taking off again,  if you need to append the same custom folder name, you need to set the same name with the action again. This type is only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.",
            ],
            [
                   "Custom expand directory name. When your set this type in waypoint action, after aircraft trigger the action, the newly generated media files (videos or photos) will be stored in the new folder when taking photo or record video,  this new folder's name will be appended by your custom directory name. for example by default, the default folder name is DJI_202001012359_01,  you could append Mission1 after it, so the new folder's name will be DJI_202001012359_01_Mission1.  Please notice that the default folder's name also would be updated automatically when the drone completes the landing,  the camera will update the last two digits in DJI_202001012359_01 to DJI_202001012359_02, so before your drone taking off again,  if you need to append the same custom folder name, you need to set the same name with the action again. This type is only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2Action_ActionTypes_CameraCustomNameType_Dir_inline",
                   "",
            ],
            [
                   "CameraFocusMode",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_inline",
                   "Possible types of camera focus mode.",
            ],
            [
                   "Possible types of camera focus mode.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_Manual_inline",
                   "Manual focus mode",
            ],
            [
                   "Manual focus mode",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_Manual_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_Auto_inline",
                   "Auto focus mode",
            ],
            [
                   "Auto focus mode",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusMode_Auto_inline",
                   "",
            ],
            [
                   "CameraFocusRegionType",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_inline",
                   "Possible types of camera focus region.",
            ],
            [
                   "Possible types of camera focus region.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_inline",
                   "",
            ],
            [
                   "POINT",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_Point_inline",
                   "The focus region is a point.",
            ],
            [
                   "The focus region is a point.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_Point_inline",
                   "",
            ],
            [
                   "RECTANGLE",
                   2,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_Rectangle_inline",
                   "The focus region is a prectangle.",
            ],
            [
                   "The focus region is a prectangle.",
                   1,
                   "/Components/Missions/DJIWaypointV2Action.html",
                   "#DJIWaypointV2ActionActuatorCameraOperationType_CameraFocusRegionType_Rectangle_inline",
                   "",
            ],
            [
                   "WaypointV2MissionExecuteState",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_inline",
                   "Current waypoint mission executing state.",
            ],
            [
                   "Current waypoint mission executing state.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Initializing_inline",
                   "Waypoint mission is initializing, which means the mission has started.",
            ],
            [
                   "Waypoint mission is initializing, which means the mission has started.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Initializing_inline",
                   "",
            ],
            [
                   "GO_TO_FIRST_WAYPOINT",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_GoToFirstWaypoint_inline",
                   "Aircraft is currently is going to the first waypoint.",
            ],
            [
                   "Aircraft is currently is going to the first waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_GoToFirstWaypoint_inline",
                   "",
            ],
            [
                   "MOVING",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Moving_inline",
                   "Aircraft is currently moving.",
            ],
            [
                   "Aircraft is currently moving.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Moving_inline",
                   "",
            ],
            [
                   "INTERRUPTED",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Interrupted_inline",
                   "Aircraft is currently interrupted by user.",
            ],
            [
                   "Aircraft is currently interrupted by user.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Interrupted_inline",
                   "",
            ],
            [
                   "FINISHED",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Finished_inline",
                   "The aircraft finished the waypoint mission and is leaving from the last waypoint.",
            ],
            [
                   "The aircraft finished the waypoint mission and is leaving from the last waypoint.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Finished_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_GoHome_inline",
                   "Aircraft has returned to the home point. This happens when the `setFinishedAction`  is set to `GO_HOME`.",
            ],
            [
                   "Aircraft has returned to the home point. This happens when the `setFinishedAction`  is set to `GO_HOME`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_GoHome_inline",
                   "",
            ],
            [
                   "LANDING",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Landing_inline",
                   "Aircraft has been landing. This happens when the `setFinishedAction` is set  to `AUTO_LAND`.",
            ],
            [
                   "Aircraft has been landing. This happens when the `setFinishedAction` is set  to `AUTO_LAND`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Landing_inline",
                   "",
            ],
            [
                   "RETURN_TO_FIRST_WAYPOINT",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_ReturnToFirstWaypoint_inline",
                   "Aircraft has returned to the first waypoint. This happens when the `setFinishedAction`  is set to `GO_FIRST_WAYPOINT`.",
            ],
            [
                   "Aircraft has returned to the first waypoint. This happens when the `setFinishedAction`  is set to `GO_FIRST_WAYPOINT`.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_ReturnToFirstWaypoint_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Unknown_inline",
                   "Unknown execution state.",
            ],
            [
                   "Unknown execution state.",
                   1,
                   "/Components/Missions/DJIWaypointV2Mission.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2MissionExecutionState_Unknown_inline",
                   "",
            ],
            [
                   "WaypointV2UploadProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "",
                   "The upload progress of the waypoint mission operator.",
            ],
            [
                   "The upload progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "",
                   "",
            ],
            [
                   "isSummaryUploaded",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_isWaypointSummaryUploaded_inline",
                   "The waypoint mission operator has uploaded the mission's summary (information except waypoints).  @return A boolean value to check summary uploaded.",
            ],
            [
                   "The waypoint mission operator has uploaded the mission's summary (information except waypoints).  @return A boolean value to check summary uploaded.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_isWaypointSummaryUploaded_inline",
                   "",
            ],
            [
                   "getLastUploadedWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_lastUploadedWaypointIndex_inline",
                   "The last uploaded waypoint's index. Waypoint is uploaded in ascending order. If no waypoint has been uploaded,  the value should be -1.  @return An int value of last uploaded waypoint index.",
            ],
            [
                   "The last uploaded waypoint's index. Waypoint is uploaded in ascending order. If no waypoint has been uploaded,  the value should be -1.  @return An int value of last uploaded waypoint index.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_lastUploadedWaypointIndex_inline",
                   "",
            ],
            [
                   "getTotalWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_totalWaypointCount_inline",
                   "The total count of waypoints in the waypoint mission.  @return An int value of total waypoint count.",
            ],
            [
                   "The total count of waypoints in the waypoint mission.  @return An int value of total waypoint count.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2UploadProgress_totalWaypointCount_inline",
                   "",
            ],
            [
                   "WaypointV2DownloadProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "",
                   "The download progress of the waypoint mission operator.",
            ],
            [
                   "The download progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "",
                   "",
            ],
            [
                   "isSummaryDownloaded",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2DownloadProgress_isSummaryDownloaded_inline",
                   "`true` if Waypoint summary is downloaded.  @return A boolean value to check summary downloaded.",
            ],
            [
                   "`true` if Waypoint summary is downloaded.  @return A boolean value to check summary downloaded.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2Mission_DJIWaypointV2DownloadProgress_isSummaryDownloaded_inline",
                   "",
            ],
            [
                   "getLastDownloadedWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress_lastDownloadedWaypointIndex_inline",
                   "The last index of downloaded waypoint. Waypoint is downloaded in ascending order. If no waypoint has been  downloaded, the value shoud be -1.  @return An int value of the last downloaded waypoint index.",
            ],
            [
                   "The last index of downloaded waypoint. Waypoint is downloaded in ascending order. If no waypoint has been  downloaded, the value shoud be -1.  @return An int value of the last downloaded waypoint index.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress_lastDownloadedWaypointIndex_inline",
                   "",
            ],
            [
                   "getTotalWaypointCount",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress_totalWaypointCount_inline",
                   "The total count of waypoints in the waypoint mission.  @return An int value of the total waypoint count.",
            ],
            [
                   "The total count of waypoints in the waypoint mission.  @return An int value of the total waypoint count.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2DownloadProgress_totalWaypointCount_inline",
                   "",
            ],
            [
                   "WaypointV2ExecutionProgress",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "",
                   "The mission execution progress of the waypoint mission operator.",
            ],
            [
                   "The mission execution progress of the waypoint mission operator.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "",
                   "",
            ],
            [
                   "getTargetWaypointIndex",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_targetWaypointIndex_inline",
                   "The index of the waypoint in the mission to which the aircraft will proceed.  @return An int value of the target waypoint index.",
            ],
            [
                   "The index of the waypoint in the mission to which the aircraft will proceed.  @return An int value of the target waypoint index.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_targetWaypointIndex_inline",
                   "",
            ],
            [
                   "isWaypointReached",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_isWaypointReached_inline",
                   "`true` when the aircraft reaches a waypoint. After the waypoint actions and heading change are complete,  the `getTargetWaypointIndex` will increment and this property will become `false`.  @return A boolean value to check waypoint reached.",
            ],
            [
                   "`true` when the aircraft reaches a waypoint. After the waypoint actions and heading change are complete,  the `getTargetWaypointIndex` will increment and this property will become `false`.  @return A boolean value to check waypoint reached.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_isWaypointReached_inline",
                   "",
            ],
            [
                   "getExecuteState",
                   2,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_executionState_inline",
                   "Current execution state of the aircraft.  @return An enum value of the `WaypointV2MissionExecuteState`.",
            ],
            [
                   "Current execution state of the aircraft.  @return An enum value of the `WaypointV2MissionExecuteState`.",
                   1,
                   "/Components/Missions/DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress.html",
                   "#DJIWaypointV2MissionOperator_DJIWaypointV2ExecutionProgress_executionState_inline",
                   "",
            ],
            [
                   "SLOW_MOTION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_SlowMotion_inline",
                   "Sets the camera to slow motion video recording mode. Only supported by Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "Sets the camera to slow motion video recording mode. Only supported by Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_SlowMotion_inline",
                   "",
            ],
            [
                   "VIDEO_NORMAL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_VideoNormal_inline",
                   "Sets the camera to record normal videos.",
            ],
            [
                   "Sets the camera to record normal videos.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_VideoNormal_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoTimeLapse_inline",
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The camera will merge the photo sequence and the output is a video. The minimum interval for Video only format is 1 s. The minimum interval for Video+Photo format is 2 s.",
            ],
            [
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The camera will merge the photo sequence and the output is a video. The minimum interval for Video only format is 1 s. The minimum interval for Video+Photo format is 2 s.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoTimeLapse_inline",
                   "",
            ],
            [
                   "PHOTO_AEB",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoAEB_inline",
                   "Automatic Exposure Bracketing (AEB) capture. In this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames.",
            ],
            [
                   "Automatic Exposure Bracketing (AEB) capture. In this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoAEB_inline",
                   "",
            ],
            [
                   "PHOTO_SINGLE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSingle_inline",
                   "Sets the camera to take a single photo.",
            ],
            [
                   "Sets the camera to take a single photo.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSingle_inline",
                   "",
            ],
            [
                   "PHOTO_BURST",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoBurst_inline",
                   "Set the camera to take multiple photos at once.",
            ],
            [
                   "Set the camera to take multiple photos at once.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoBurst_inline",
                   "",
            ],
            [
                   "PHOTO_HDR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHDR_inline",
                   "Sets the camera to take photos in HDR mode.",
            ],
            [
                   "Sets the camera to take photos in HDR mode.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHDR_inline",
                   "",
            ],
            [
                   "VIDEO_HDR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_VideoHDR_inline",
                   "Sets the camera to HDR video recording mode. Only supported by Mavic Air 2.",
            ],
            [
                   "Sets the camera to HDR video recording mode. Only supported by Mavic Air 2.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_VideoHDR_inline",
                   "",
            ],
            [
                   "PHOTO_INTERVAL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoInterval_inline",
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The minimum interval for JPEG format of any quality is 2s.",
            ],
            [
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The minimum interval for JPEG format of any quality is 2s.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoInterval_inline",
                   "",
            ],
            [
                   "PHOTO_HYPER_LIGHT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHyperLight_inline",
                   "Sets the camera to take photos in HyperLight mode. It is a setting for low-light environment to enhance the photo quality while reducing noise significantly.",
            ],
            [
                   "Sets the camera to take photos in HyperLight mode. It is a setting for low-light environment to enhance the photo quality while reducing noise significantly.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHyperLight_inline",
                   "",
            ],
            [
                   "PHOTO_PANORAMA",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoPanorama_inline",
                   "Sets the camera to take photos in panorama mode. the aircraft takes a series of photos with different gimbal and aircraft heading positions. The photos can be stitched with a third-party library.",
            ],
            [
                   "Sets the camera to take photos in panorama mode. the aircraft takes a series of photos with different gimbal and aircraft heading positions. The photos can be stitched with a third-party library.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoPanorama_inline",
                   "",
            ],
            [
                   "PHOTO_EHDR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoEHDR_inline",
                   "Sets the camera to take an enhanced-HDR photo. It blends a sequence of photos for ghost-free high dynamic range photos.",
            ],
            [
                   "Sets the camera to take an enhanced-HDR photo. It blends a sequence of photos for ghost-free high dynamic range photos.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoEHDR_inline",
                   "",
            ],
            [
                   "PHOTO_HIGH_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHighResolution_inline",
                   "Sets the camera to the high resolution mode. In this mode, the camera will take photos with a resolution of 48MP. Only supported by Mavic Air 2.",
            ],
            [
                   "Sets the camera to the high resolution mode. In this mode, the camera will take photos with a resolution of 48MP. Only supported by Mavic Air 2.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoHighResolution_inline",
                   "",
            ],
            [
                   "PHOTO_SUPER_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSuperResolution_inline",
                   "Sets the camera to the super resolution mode. In this mode, drag to select an area in the wide camera view, the gimbal will move automatically and take a series of 20MP photos of the selected area at the current zoom ratio by the zoom camera. All photos will be saved in the same sub-folder in the microSD card, and an HTML file will be created. To view the wide and close-up images, open the HTML file using a browser on a PC. If you want to view the close-up images in app, please refer to the sample implementation. Using `setSuperResolutionCaptureArea` to set the super resolution capture area. Using `setSuperResolutionInfoCallback` to listen the super resolution state. Only supported by Matrice 300 RTK.",
            ],
            [
                   "Sets the camera to the super resolution mode. In this mode, drag to select an area in the wide camera view, the gimbal will move automatically and take a series of 20MP photos of the selected area at the current zoom ratio by the zoom camera. All photos will be saved in the same sub-folder in the microSD card, and an HTML file will be created. To view the wide and close-up images, open the HTML file using a browser on a PC. If you want to view the close-up images in app, please refer to the sample implementation. Using `setSuperResolutionCaptureArea` to set the super resolution capture area. Using `setSuperResolutionInfoCallback` to listen the super resolution state. Only supported by Matrice 300 RTK.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSuperResolution_inline",
                   "",
            ],
            [
                   "PHOTO_SMART",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSmart_inline",
                   "Sets the camera to the smart mode. In this mode, when shooting photo, the camera can automatically recognize the scene, and use the built-in algorithm to optimize the scene. Only supported by Mavic Air 2, DJI Air 2S.",
            ],
            [
                   "Sets the camera to the smart mode. In this mode, when shooting photo, the camera can automatically recognize the scene, and use the built-in algorithm to optimize the scene. Only supported by Mavic Air 2, DJI Air 2S.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_PhotoSmart_inline",
                   "",
            ],
            [
                   "INTERNAL_AI_SPOT_CHECKING",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_INTERNAL_AI_SPOT_CHECKING_inline",
                   "Internal work mode during smart inspection and it cannot be set manually. This mode might last for less than 10 seconds, during when the user cannot take photo, record a video, enter media playback mode, set spot metering target of `ZOOM` lens type, and set zoom focus length with any lens type. Only `AUTO` can be set with `ZOOM` lens type. In this mode, remote controller also cannot be used to take photo, record video and adjust focus. It's only supported by Matrice 300 RTK.",
            ],
            [
                   "Internal work mode during smart inspection and it cannot be set manually. This mode might last for less than 10 seconds, during when the user cannot take photo, record a video, enter media playback mode, set spot metering target of `ZOOM` lens type, and set zoom focus length with any lens type. Only `AUTO` can be set with `ZOOM` lens type. In this mode, remote controller also cannot be used to take photo, record video and adjust focus. It's only supported by Matrice 300 RTK.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_INTERNAL_AI_SPOT_CHECKING_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_Unknown_inline",
                   "The camera work mode is unknown.",
            ],
            [
                   "The camera work mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_Unknown_inline",
                   "",
            ],
            [
                   "ZOOM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Zoom_inline",
                   "Zoom lens.",
            ],
            [
                   "Zoom lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Zoom_inline",
                   "",
            ],
            [
                   "WIDE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Wide_inline",
                   "Wide lens.",
            ],
            [
                   "Wide lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Wide_inline",
                   "",
            ],
            [
                   "INFRARED_THERMAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Thermal_inline",
                   "Infrared Thermal lens.",
            ],
            [
                   "Infrared Thermal lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Thermal_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_Unknown_inline",
                   "",
            ],
            [
                   "RGB_ONLY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_RGB_ONLY_inline",
                   "Displays only the video feed from the RGB sensor.",
            ],
            [
                   "Displays only the video feed from the RGB sensor.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_RGB_ONLY_inline",
                   "",
            ],
            [
                   "NDVI",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_NDVI_inline",
                   "Displays the NVDI (normalized difference vegetation index) frames as video feed produced by the multispectral camera.",
            ],
            [
                   "Displays the NVDI (normalized difference vegetation index) frames as video feed produced by the multispectral camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_NDVI_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_Unknown_inline",
                   "The multispectral camera video feed display mode is unknown.",
            ],
            [
                   "The multispectral camera video feed display mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_Unknown_inline",
                   "",
            ],
            [
                   "BLUE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Blue_inline",
                   "The blue spectrum.",
            ],
            [
                   "The blue spectrum.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Blue_inline",
                   "",
            ],
            [
                   "GREEN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Green_inline",
                   "The green spectrum.",
            ],
            [
                   "The green spectrum.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Green_inline",
                   "",
            ],
            [
                   "RED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Red_inline",
                   "The red spectrum.",
            ],
            [
                   "The red spectrum.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_Red_inline",
                   "",
            ],
            [
                   "NEAR_INFRARED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_NEAR_INFRARED_inline",
                   "The near infrared spectrum.",
            ],
            [
                   "The near infrared spectrum.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_NEAR_INFRARED_inline",
                   "",
            ],
            [
                   "RED_EDGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_RED_EDGE_inline",
                   "The red edge spectrum.",
            ],
            [
                   "The red edge spectrum.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_RED_EDGE_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_UNKNOWN_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_UNKNOWN_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeShootPhoto_inline",
                   "Capture mode. In this mode, the user can capture pictures.",
            ],
            [
                   "Capture mode. In this mode, the user can capture pictures.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeShootPhoto_inline",
                   "",
            ],
            [
                   "RECORD_VIDEO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeRecordVideo_inline",
                   "Record mode. In this mode, the user can record videos.",
            ],
            [
                   "Record mode. In this mode, the user can record videos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeRecordVideo_inline",
                   "",
            ],
            [
                   "PLAYBACK",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModePlayback_inline",
                   "Playback mode. In this mode, the user can preview photos and videos, and can delete files. It is supported by Phantom 3 Professional camera, X3, X5 and X5R cameras on aircraft and Phantom 4 camera. Playback mode is not supported by Z30, X5S, X4S, Phantom 4 Pro, Mavic Pro, Phantom 3 Standard, Phantom 3 Advanced, Phantom 3 4K and Osmo series.",
            ],
            [
                   "Playback mode. In this mode, the user can preview photos and videos, and can delete files. It is supported by Phantom 3 Professional camera, X3, X5 and X5R cameras on aircraft and Phantom 4 camera. Playback mode is not supported by Z30, X5S, X4S, Phantom 4 Pro, Mavic Pro, Phantom 3 Standard, Phantom 3 Advanced, Phantom 3 4K and Osmo series.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModePlayback_inline",
                   "",
            ],
            [
                   "MEDIA_DOWNLOAD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeMediaDownload_inline",
                   "In this mode, the user can download media to the Mobile Device. Not supported by X5 camera nor X5R camera while mounted on aircraft.",
            ],
            [
                   "In this mode, the user can download media to the Mobile Device. Not supported by X5 camera nor X5R camera while mounted on aircraft.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeMediaDownload_inline",
                   "",
            ],
            [
                   "BROADCAST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeBroadcast_inline",
                   "In this mode, live stream resolution and frame rate will be 1080i50 (PAL) or 720p60 (NTSC). In this mode videos can be recorded. Still photos can also be taken only when video is recording. The only way to exit broadcast mode is to change modes to `RECORD_VIDEO`. Only supported by Inspire 2.",
            ],
            [
                   "In this mode, live stream resolution and frame rate will be 1080i50 (PAL) or 720p60 (NTSC). In this mode videos can be recorded. Still photos can also be taken only when video is recording. The only way to exit broadcast mode is to change modes to `RECORD_VIDEO`. Only supported by Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeBroadcast_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeUnknown_inline",
                   "The camera work mode is unknown.",
            ],
            [
                   "The camera work mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_DJICameraModeUnknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedSystemStateCallbackInterface.html",
                   "",
                   "Updates the camera's current state. In order to begin updates, call the startCameraStateUpdates method for the respective aircraft.",
            ],
            [
                   "Updates the camera's current state. In order to begin updates, call the startCameraStateUpdates method for the respective aircraft.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedSystemStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_mode_inline",
                   "The current mode of the camera.  @return An enum value of `CameraMode`",
            ],
            [
                   "The current mode of the camera.  @return An enum value of `CameraMode`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_mode_inline",
                   "",
            ],
            [
                   "CameraKey.MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_mode_inline",
                   "SDK Key for getMode: The current mode of the camera.  @return An enum value of `CameraMode`",
            ],
            [
                   "SDK Key for getMode: The current mode of the camera.  @return An enum value of `CameraMode`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_mode_inline",
                   "",
            ],
            [
                   "getFlatMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_flatCameraMode_inline",
                   "Gets current flat mode of the camera. This is available only when `isFlatCameraModeSupported` returns `true`.  @return An enum value of `FlatCameraMode`.",
            ],
            [
                   "Gets current flat mode of the camera. This is available only when `isFlatCameraModeSupported` returns `true`.  @return An enum value of `FlatCameraMode`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_flatCameraMode_inline",
                   "",
            ],
            [
                   "isInPlayback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isPlayingback_inline",
                   "`true` If the camera is in playback mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @return A bolean value.",
            ],
            [
                   "`true` If the camera is in playback mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @return A bolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isPlayingback_inline",
                   "",
            ],
            [
                   "isShootingSinglePhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhoto_inline",
                   "`true` when the camera is performing any photo capture in any `ShootPhotoMode`. Between photo capture in interval and time lapse mode, this property will be `false`. The camera is shooting a single photo.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing any photo capture in any `ShootPhotoMode`. Between photo capture in interval and time lapse mode, this property will be `false`. The camera is shooting a single photo.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhoto_inline",
                   "",
            ],
            [
                   "IS_SHOOTING_SINGLE_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhoto_inline",
                   "SDK Key for isShootingSinglePhoto: `true` when the camera is performing any photo capture in any `ShootPhotoMode`. Between photo capture in interval and time lapse mode, this property will be `false`. The camera is shooting a single photo.  @return A boolean value.",
            ],
            [
                   "SDK Key for isShootingSinglePhoto: `true` when the camera is performing any photo capture in any `ShootPhotoMode`. Between photo capture in interval and time lapse mode, this property will be `false`. The camera is shooting a single photo.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhoto_inline",
                   "",
            ],
            [
                   "isShootingSinglePhotoInRAWFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhotoInRAWFormat_inline",
                   "`true` when the camera is performing a photo capture in RAW or RAW+JPEG format. Between photo capture in interval and time lapse mode, this property will be `false`. If saving the photo in JPEG only, this property will always be `false`.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing a photo capture in RAW or RAW+JPEG format. Between photo capture in interval and time lapse mode, this property will be `false`. If saving the photo in JPEG only, this property will always be `false`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhotoInRAWFormat_inline",
                   "",
            ],
            [
                   "IS_SHOOTING_SINGLE_PHOTO_IN_RAW_FORMAT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhotoInRAWFormat_inline",
                   "SDK Key for isShootingSinglePhotoInRAWFormat: `true` when the camera is performing a photo capture in RAW or RAW+JPEG format. Between photo capture in interval and time lapse mode, this property will be `false`. If saving the photo in JPEG only, this property will always be `false`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isShootingSinglePhotoInRAWFormat: `true` when the camera is performing a photo capture in RAW or RAW+JPEG format. Between photo capture in interval and time lapse mode, this property will be `false`. If saving the photo in JPEG only, this property will always be `false`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingSinglePhotoInRAWFormat_inline",
                   "",
            ],
            [
                   "isShootingIntervalPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingIntervalPhoto_inline",
                   "`true` when the camera is performing an interval capture. `true` after `startShootPhoto` is called, and `false` after `stopShootPhoto` is called.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing an interval capture. `true` after `startShootPhoto` is called, and `false` after `stopShootPhoto` is called.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingIntervalPhoto_inline",
                   "",
            ],
            [
                   "IS_SHOOTING_INTERVAL_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingIntervalPhoto_inline",
                   "SDK Key for isShootingIntervalPhoto: `true` when the camera is performing an interval capture. `true` after `startShootPhoto` is called, and `false` after `stopShootPhoto` is called.  @return A boolean value.",
            ],
            [
                   "SDK Key for isShootingIntervalPhoto: `true` when the camera is performing an interval capture. `true` after `startShootPhoto` is called, and `false` after `stopShootPhoto` is called.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingIntervalPhoto_inline",
                   "",
            ],
            [
                   "isShootingBurstPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingBurstPhoto_inline",
                   "`true` when the camera is performing a burst capture. `true` after `startShootPhoto` is called, and `false` after the burst is complete. The camera is shooting burst photos.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing a burst capture. `true` after `startShootPhoto` is called, and `false` after the burst is complete. The camera is shooting burst photos.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingBurstPhoto_inline",
                   "",
            ],
            [
                   "IS_SHOOTING_BURST_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingBurstPhoto_inline",
                   "SDK Key for isShootingBurstPhoto: `true` when the camera is performing a burst capture. `true` after `startShootPhoto` is called, and `false` after the burst is complete. The camera is shooting burst photos.  @return A boolean value.",
            ],
            [
                   "SDK Key for isShootingBurstPhoto: `true` when the camera is performing a burst capture. `true` after `startShootPhoto` is called, and `false` after the burst is complete. The camera is shooting burst photos.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingBurstPhoto_inline",
                   "",
            ],
            [
                   "isShootingRAWBurstPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingRAWBurstPhoto_inline",
                   "`true` when the camera is performing a RAW burst capture. `true` after `startShootPhoto` is called, and `false` after the RAW burst is complete. The camera is shooting RAW burst photos.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing a RAW burst capture. `true` after `startShootPhoto` is called, and `false` after the RAW burst is complete. The camera is shooting RAW burst photos.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingRAWBurstPhoto_inline",
                   "",
            ],
            [
                   "IS_SHOOTING_RAW_BURST_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingRAWBurstPhoto_inline",
                   "SDK Key for isShootingRAWBurstPhoto: `true` when the camera is performing a RAW burst capture. `true` after `startShootPhoto` is called, and `false` after the RAW burst is complete. The camera is shooting RAW burst photos.  @return A boolean value.",
            ],
            [
                   "SDK Key for isShootingRAWBurstPhoto: `true` when the camera is performing a RAW burst capture. `true` after `startShootPhoto` is called, and `false` after the RAW burst is complete. The camera is shooting RAW burst photos.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingRAWBurstPhoto_inline",
                   "",
            ],
            [
                   "getCurrentPanoramaPhotoCount",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentPanoramaPhotoCount_inline",
                   "The current completed photo count of the executing panorama shot.  @return An int value.",
            ],
            [
                   "The current completed photo count of the executing panorama shot.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentPanoramaPhotoCount_inline",
                   "",
            ],
            [
                   "getPanoramaProgress",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_panoramaProgress_inline",
                   "The progress of the executing panorama shot. It is `null` if there is no executing panorama shot.  @return An int value.",
            ],
            [
                   "The progress of the executing panorama shot. It is `null` if there is no executing panorama shot.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_panoramaProgress_inline",
                   "",
            ],
            [
                   "isShootingShallowFocusPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingShallowFocusPhoto_inline",
                   "`true` when the camera is performing a ShallowFocus capture.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing a ShallowFocus capture.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingShallowFocusPhoto_inline",
                   "",
            ],
            [
                   "isShootingPanoramaPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingPanoramaPhoto_inline",
                   "`true` when the camera is performing a Panorama capture.  @return A boolean value.",
            ],
            [
                   "`true` when the camera is performing a Panorama capture.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isShootingPanoramaPhoto_inline",
                   "",
            ],
            [
                   "isStoringPhoto",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isStoringPhoto_inline",
                   "`true` if the camera is storing a photo. When `isStoringPhoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return A boolean value.",
            ],
            [
                   "`true` if the camera is storing a photo. When `isStoringPhoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isStoringPhoto_inline",
                   "",
            ],
            [
                   "IS_STORING_PHOTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isStoringPhoto_inline",
                   "SDK Key for isStoringPhoto: `true` if the camera is storing a photo. When `isStoringPhoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return A boolean value.",
            ],
            [
                   "SDK Key for isStoringPhoto: `true` if the camera is storing a photo. When `isStoringPhoto` is `true`, the user cannot change the camera mode or start to shoot another photo.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isStoringPhoto_inline",
                   "",
            ],
            [
                   "isRecording",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isRecording_inline",
                   "`true` if the camera is recording video.  @return A boolean value.",
            ],
            [
                   "`true` if the camera is recording video.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isRecording_inline",
                   "",
            ],
            [
                   "IS_RECORDING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isRecording_inline",
                   "SDK Key for isRecording: `true` if the camera is recording video.  @return A boolean value.",
            ],
            [
                   "SDK Key for isRecording: `true` if the camera is recording video.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isRecording_inline",
                   "",
            ],
            [
                   "getCurrentVideoRecordingTimeInSeconds",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentVideoRecordingTimeInSeconds_inline",
                   "The duration, in seconds, of the video currently being recorded by the camera.  @return An int value.",
            ],
            [
                   "The duration, in seconds, of the video currently being recorded by the camera.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentVideoRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "CURRENT_VIDEO_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentVideoRecordingTimeInSeconds_inline",
                   "SDK Key for getCurrentVideoRecordingTimeInSeconds: The duration, in seconds, of the video currently being recorded by the camera.  @return An int value.",
            ],
            [
                   "SDK Key for getCurrentVideoRecordingTimeInSeconds: The duration, in seconds, of the video currently being recorded by the camera.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_currentVideoRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "isOverheating",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraOverHeated_inline",
                   "`true` if the camera is too hot.  @return A boolean value.",
            ],
            [
                   "`true` if the camera is too hot.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraOverHeated_inline",
                   "",
            ],
            [
                   "IS_OVERHEATING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraOverHeated_inline",
                   "SDK Key for isOverheating: `true` if the camera is too hot.  @return A boolean value.",
            ],
            [
                   "SDK Key for isOverheating: `true` if the camera is too hot.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraOverHeated_inline",
                   "",
            ],
            [
                   "hasError",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraError_inline",
                   "`true` if there is a camera sensor error.  @return A boolean value.",
            ],
            [
                   "`true` if there is a camera sensor error.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraError_inline",
                   "",
            ],
            [
                   "HAS_ERROR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraError_inline",
                   "SDK Key for hasError: `true` if there is a camera sensor error.  @return A boolean value.",
            ],
            [
                   "SDK Key for hasError: `true` if there is a camera sensor error.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "#DJICamera_DJICameraSystemState_isCameraError_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedLensStateCallbackInterface.html",
                   "",
                   "This interface provides updated information about the lens and focus.",
            ],
            [
                   "This interface provides updated information about the lens and focus.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedLensStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "isLensMounted",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isLensInstalled_inline",
                   "`true` if lens is installed on the camera.  @return A boolean value.",
            ],
            [
                   "`true` if lens is installed on the camera.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isLensInstalled_inline",
                   "",
            ],
            [
                   "LENS_IS_INSTALLED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isLensInstalled_inline",
                   "SDK Key for isLensMounted: `true` if lens is installed on the camera.  @return A boolean value.",
            ],
            [
                   "SDK Key for isLensMounted: `true` if lens is installed on the camera.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isLensInstalled_inline",
                   "",
            ],
            [
                   "getFocusStatus",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusStatus_inline",
                   "The current focus status of the lens. If the lens is not installed, the value is undefined.  @return A `FocusStatus` enum value.",
            ],
            [
                   "The current focus status of the lens. If the lens is not installed, the value is undefined.  @return A `FocusStatus` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusStatus_inline",
                   "",
            ],
            [
                   "FOCUS_STATUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusStatus_inline",
                   "SDK Key for getFocusStatus: The current focus status of the lens. If the lens is not installed, the value is undefined.  @return A `FocusStatus` enum value.",
            ],
            [
                   "SDK Key for getFocusStatus: The current focus status of the lens. If the lens is not installed, the value is undefined.  @return A `FocusStatus` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusStatus_inline",
                   "",
            ],
            [
                   "isAFSwitchOn",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isAFSwitchOn_inline",
                   "`true` if the lens Auto Focus (AF) switch is on. If the lens is not installed, the value is undefined. If `true`, `setFocusMode` can be used to control the focal point.  @return A boolean value.",
            ],
            [
                   "`true` if the lens Auto Focus (AF) switch is on. If the lens is not installed, the value is undefined. If `true`, `setFocusMode` can be used to control the focal point.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isAFSwitchOn_inline",
                   "",
            ],
            [
                   "LENS_IS_AF_SWITCH_ON",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isAFSwitchOn_inline",
                   "SDK Key for isAFSwitchOn: `true` if the lens Auto Focus (AF) switch is on. If the lens is not installed, the value is undefined. If `true`, `setFocusMode` can be used to control the focal point.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAFSwitchOn: `true` if the lens Auto Focus (AF) switch is on. If the lens is not installed, the value is undefined. If `true`, `setFocusMode` can be used to control the focal point.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isAFSwitchOn_inline",
                   "",
            ],
            [
                   "getFocusMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusMode_inline",
                   "The current focus mode. If the lens is not installed, the value is undefined.  @return A `FocusMode` enum value.",
            ],
            [
                   "The current focus mode. If the lens is not installed, the value is undefined.  @return A `FocusMode` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusMode_inline",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusMode_inline",
                   "SDK Key for getFocusMode: The current focus mode. If the lens is not installed, the value is undefined.  @return A `FocusMode` enum value.",
            ],
            [
                   "SDK Key for getFocusMode: The current focus mode. If the lens is not installed, the value is undefined.  @return A `FocusMode` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_focusMode_inline",
                   "",
            ],
            [
                   "isFocusAssistantEnabledForMF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForMF_inline",
                   "`true` if the focus assistant is enabled for Manual focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "`true` if the focus assistant is enabled for Manual focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForMF_inline",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForMF_inline",
                   "SDK Key for isFocusAssistantEnabledForMF: `true` if the focus assistant is enabled for Manual focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFocusAssistantEnabledForMF: `true` if the focus assistant is enabled for Manual focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForMF_inline",
                   "",
            ],
            [
                   "isFocusAssistantEnabledForAF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForAF_inline",
                   "`true` if the focus assistant is enabled for Auto focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "`true` if the focus assistant is enabled for Auto focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForAF_inline",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForAF_inline",
                   "SDK Key for isFocusAssistantEnabledForAF: `true` if the focus assistant is enabled for Auto focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFocusAssistantEnabledForAF: `true` if the focus assistant is enabled for Auto focus mode. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantEnabledForAF_inline",
                   "",
            ],
            [
                   "isFocusAssistantWorking",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantWorking_inline",
                   "`true` if the focus target is zooming out. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "`true` if the focus target is zooming out. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantWorking_inline",
                   "",
            ],
            [
                   "LENS_IS_FOCUS_ASSISTANT_WORKING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantWorking_inline",
                   "SDK Key for isFocusAssistantWorking: `true` if the focus target is zooming out. If the lens is not installed, the value is undefined.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFocusAssistantWorking: `true` if the focus target is zooming out. If the lens is not installed, the value is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_isFocusAssistantWorking_inline",
                   "",
            ],
            [
                   "getSensorCleaningState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_sensorCleaningState_inline",
                   "Get the sensor cleaning state.  @return A `SensorCleaningState` enum value.",
            ],
            [
                   "Get the sensor cleaning state.  @return A `SensorCleaningState` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_sensorCleaningState_inline",
                   "",
            ],
            [
                   "getTargetFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_targetFocalLength_inline",
                   "The focal length that user wants to set. Supported by Zenmuse H20 Series. The unit is millimeter.  @return A targetFocusLength int value.",
            ],
            [
                   "The focal length that user wants to set. Supported by Zenmuse H20 Series. The unit is millimeter.  @return A targetFocusLength int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "#DJICamera_DJICameraLensState_targetFocalLength_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedStorageStateCallbackInterface.html",
                   "",
                   "This interface provides general information and current statuses on the storage.",
            ],
            [
                   "This interface provides general information and current statuses on the storage.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedStorageStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "isInserted",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInserted_inline",
                   "`true` if the SD card is inserted in the camera. It is always `true` when it is the internal storage.  @return A boolean value.",
            ],
            [
                   "`true` if the SD card is inserted in the camera. It is always `true` when it is the internal storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInserted_inline",
                   "",
            ],
            [
                   "SDCARD_IS_INSERTED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInserted_inline",
                   "SDK Key for isInserted: `true` if the SD card is inserted in the camera. It is always `true` when it is the internal storage.  @return A boolean value.",
            ],
            [
                   "SDK Key for isInserted: `true` if the SD card is inserted in the camera. It is always `true` when it is the internal storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInserted_inline",
                   "",
            ],
            [
                   "getStorageLocation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_location_inline",
                   "The location of the storage.  @return A enum value of `StorageLocation`.",
            ],
            [
                   "The location of the storage.  @return A enum value of `StorageLocation`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_location_inline",
                   "",
            ],
            [
                   "isInitializing",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInitializing_inline",
                   "`true` if the storage is initializing. Note that if the storage is initializing, the value for other properties in `StorageState` is undefined.  @return A boolean value.",
            ],
            [
                   "`true` if the storage is initializing. Note that if the storage is initializing, the value for other properties in `StorageState` is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInitializing_inline",
                   "",
            ],
            [
                   "SDCARD_IS_INITIALIZING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInitializing_inline",
                   "SDK Key for isInitializing: `true` if the storage is initializing. Note that if the storage is initializing, the value for other properties in `StorageState` is undefined.  @return A boolean value.",
            ],
            [
                   "SDK Key for isInitializing: `true` if the storage is initializing. Note that if the storage is initializing, the value for other properties in `StorageState` is undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInitializing_inline",
                   "",
            ],
            [
                   "isReadOnly",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isReadOnly_inline",
                   "`true` if the storage is read-only.  @return A boolean value.",
            ],
            [
                   "`true` if the storage is read-only.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isReadOnly_inline",
                   "",
            ],
            [
                   "SDCARD_IS_READ_ONLY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isReadOnly_inline",
                   "SDK Key for isReadOnly: `true` if the storage is read-only.  @return A boolean value.",
            ],
            [
                   "SDK Key for isReadOnly: `true` if the storage is read-only.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isReadOnly_inline",
                   "",
            ],
            [
                   "isFormatted",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatted_inline",
                   "`true` if the storage is formatted.  @return A boolean value.",
            ],
            [
                   "`true` if the storage is formatted.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatted_inline",
                   "",
            ],
            [
                   "SDCARD_IS_FORMATTED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatted_inline",
                   "SDK Key for isFormatted: `true` if the storage is formatted.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFormatted: `true` if the storage is formatted.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatted_inline",
                   "",
            ],
            [
                   "isFormatting",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatting_inline",
                   "`true` if the storage is formatting.  @return A boolean value.",
            ],
            [
                   "`true` if the storage is formatting.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatting_inline",
                   "",
            ],
            [
                   "SDCARD_IS_FORMATTING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatting_inline",
                   "SDK Key for isFormatting: `true` if the storage is formatting.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFormatting: `true` if the storage is formatting.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFormatting_inline",
                   "",
            ],
            [
                   "isFull",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFull_inline",
                   "`true` if the storage cannot save any more media.  @return A boolean value.",
            ],
            [
                   "`true` if the storage cannot save any more media.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFull_inline",
                   "",
            ],
            [
                   "SDCARD_IS_FULL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFull_inline",
                   "SDK Key for isFull: `true` if the storage cannot save any more media.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFull: `true` if the storage cannot save any more media.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isFull_inline",
                   "",
            ],
            [
                   "isVerified",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isVerified_inline",
                   "`true` if the SD card is verified as genuine. The SD card is not valid if it is fake, which can be a problem if the SD card was purchased by a non-reputable retailer. It is always `true` when it is the internal storage.  @return A boolean value.",
            ],
            [
                   "`true` if the SD card is verified as genuine. The SD card is not valid if it is fake, which can be a problem if the SD card was purchased by a non-reputable retailer. It is always `true` when it is the internal storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isVerified_inline",
                   "",
            ],
            [
                   "SDCARD_IS_VERIFIED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isVerified_inline",
                   "SDK Key for isVerified: `true` if the SD card is verified as genuine. The SD card is not valid if it is fake, which can be a problem if the SD card was purchased by a non-reputable retailer. It is always `true` when it is the internal storage.  @return A boolean value.",
            ],
            [
                   "SDK Key for isVerified: `true` if the SD card is verified as genuine. The SD card is not valid if it is fake, which can be a problem if the SD card was purchased by a non-reputable retailer. It is always `true` when it is the internal storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isVerified_inline",
                   "",
            ],
            [
                   "isInvalidFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInvalidFormat_inline",
                   "`true` if the storage filesystem format is invalid.  @return A boolean value.",
            ],
            [
                   "`true` if the storage filesystem format is invalid.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInvalidFormat_inline",
                   "",
            ],
            [
                   "SDCARD_IS_INVALID_FORMAT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInvalidFormat_inline",
                   "SDK Key for isInvalidFormat: `true` if the storage filesystem format is invalid.  @return A boolean value.",
            ],
            [
                   "SDK Key for isInvalidFormat: `true` if the storage filesystem format is invalid.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_isInvalidFormat_inline",
                   "",
            ],
            [
                   "hasError",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_hasError_inline",
                   "`true` if there is an error with the storage.  @return A boolean value.",
            ],
            [
                   "`true` if there is an error with the storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_hasError_inline",
                   "",
            ],
            [
                   "SDCARD_HAS_ERROR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_hasError_inline",
                   "SDK Key for hasError: `true` if there is an error with the storage.  @return A boolean value.",
            ],
            [
                   "SDK Key for hasError: `true` if there is an error with the storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_hasError_inline",
                   "",
            ],
            [
                   "getTotalSpaceInMB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_totalSpaceInMegaBytes_inline",
                   "Total space in Megabytes (MB) available on the storage.  @return A boolean value.",
            ],
            [
                   "Total space in Megabytes (MB) available on the storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_totalSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "SDCARD_TOTAL_SPACE_IN_MB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_totalSpaceInMegaBytes_inline",
                   "SDK Key for getTotalSpaceInMB: Total space in Megabytes (MB) available on the storage.  @return A boolean value.",
            ],
            [
                   "SDK Key for getTotalSpaceInMB: Total space in Megabytes (MB) available on the storage.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_totalSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "getRemainingSpaceInMB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_remainingSpaceInMegaBytes_inline",
                   "Remaining space in Megabytes (MB) on the storage.  @return An int value.",
            ],
            [
                   "Remaining space in Megabytes (MB) on the storage.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_remainingSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "SDCARD_REMAINING_SPACE_IN_MB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_remainingSpaceInMegaBytes_inline",
                   "SDK Key for getRemainingSpaceInMB: Remaining space in Megabytes (MB) on the storage.  @return An int value.",
            ],
            [
                   "SDK Key for getRemainingSpaceInMB: Remaining space in Megabytes (MB) on the storage.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_remainingSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "getAvailableCaptureCount",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableCaptureCount_inline",
                   "Returns the number of pictures that can be taken with the remaining space available on the storage.  @return A long value.",
            ],
            [
                   "Returns the number of pictures that can be taken with the remaining space available on the storage.  @return A long value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableCaptureCount_inline",
                   "",
            ],
            [
                   "SDCARD_AVAILABLE_CAPTURE_COUNT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableCaptureCount_inline",
                   "SDK Key for getAvailableCaptureCount: Returns the number of pictures that can be taken with the remaining space available on the storage.  @return A long value.",
            ],
            [
                   "SDK Key for getAvailableCaptureCount: Returns the number of pictures that can be taken with the remaining space available on the storage.  @return A long value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableCaptureCount_inline",
                   "",
            ],
            [
                   "getAvailableRecordingTimeInSeconds",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableRecordingTimeInSeconds_inline",
                   "Returns the number of seconds available for recording with the remaining space available on the storage.  @return An int value.",
            ],
            [
                   "Returns the number of seconds available for recording with the remaining space available on the storage.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "SDCARD_AVAILABLE_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableRecordingTimeInSeconds_inline",
                   "SDK Key for getAvailableRecordingTimeInSeconds: Returns the number of seconds available for recording with the remaining space available on the storage.  @return An int value.",
            ],
            [
                   "SDK Key for getAvailableRecordingTimeInSeconds: Returns the number of seconds available for recording with the remaining space available on the storage.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "#DJICamera_DJICameraSDCardState_availableRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedSSDStateCallbackInterface.html",
                   "",
                   "This interface provides general information and current status of the SSD.",
            ],
            [
                   "This interface provides general information and current status of the SSD.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedSSDStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "getSSDOperationState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_operationState_inline",
                   "SSD state information for currently executing operations.  @return An instance of `SSDOperationState`.",
            ],
            [
                   "SSD state information for currently executing operations.  @return An instance of `SSDOperationState`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_operationState_inline",
                   "",
            ],
            [
                   "SSD_OPERATION_STATE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_operationState_inline",
                   "SDK Key for getSSDOperationState: SSD state information for currently executing operations.  @return An instance of `SSDOperationState`.",
            ],
            [
                   "SDK Key for getSSDOperationState: SSD state information for currently executing operations.  @return An instance of `SSDOperationState`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_operationState_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_isConnected_inline",
                   "`true` if the SSD is connected. Note, if the camera is disconnected, the values for other properties in `SSDState` are undefined.  @return A boolean value.",
            ],
            [
                   "`true` if the SSD is connected. Note, if the camera is disconnected, the values for other properties in `SSDState` are undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_isConnected_inline",
                   "",
            ],
            [
                   "SSD_IS_CONNECTED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_isConnected_inline",
                   "SDK Key for isConnected: `true` if the SSD is connected. Note, if the camera is disconnected, the values for other properties in `SSDState` are undefined.  @return A boolean value.",
            ],
            [
                   "SDK Key for isConnected: `true` if the SSD is connected. Note, if the camera is disconnected, the values for other properties in `SSDState` are undefined.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_isConnected_inline",
                   "",
            ],
            [
                   "getCapacity",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_totalSpace_inline",
                   "SSD's total capacity. @return Total SSD capacity.  @return An instance of `SSDCapacity`.",
            ],
            [
                   "SSD's total capacity. @return Total SSD capacity.  @return An instance of `SSDCapacity`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_totalSpace_inline",
                   "",
            ],
            [
                   "SSD_TOTAL_SPACE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_totalSpace_inline",
                   "SDK Key for getCapacity: SSD's total capacity. @return Total SSD capacity.  @return An instance of `SSDCapacity`.",
            ],
            [
                   "SDK Key for getCapacity: SSD's total capacity. @return Total SSD capacity.  @return An instance of `SSDCapacity`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_totalSpace_inline",
                   "",
            ],
            [
                   "getAvailableRecordingTimeInSeconds",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_availableRecordingTimeInSeconds_inline",
                   "SSD's remaining time in seconds, based on the current `VideoResolution` and `VideoFrameRate`. @return SSD's remaining time measured in seconds.  @return An int value.",
            ],
            [
                   "SSD's remaining time in seconds, based on the current `VideoResolution` and `VideoFrameRate`. @return SSD's remaining time measured in seconds.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_availableRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "SSD_AVAILABLE_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_availableRecordingTimeInSeconds_inline",
                   "SDK Key for getAvailableRecordingTimeInSeconds: SSD's remaining time in seconds, based on the current `VideoResolution` and `VideoFrameRate`. @return SSD's remaining time measured in seconds.  @return An int value.",
            ],
            [
                   "SDK Key for getAvailableRecordingTimeInSeconds: SSD's remaining time in seconds, based on the current `VideoResolution` and `VideoFrameRate`. @return SSD's remaining time measured in seconds.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_availableRecordingTimeInSeconds_inline",
                   "",
            ],
            [
                   "getRemainingSpaceInMB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_remainingSpaceInMegaBytes_inline",
                   "SSD's remaining capacity in MB. @return SSD's remaining capacity measured in MB.  @return A long value.",
            ],
            [
                   "SSD's remaining capacity in MB. @return SSD's remaining capacity measured in MB.  @return A long value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_remainingSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "SSD_REMAINING_SPACE_IN_MB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_remainingSpaceInMegaBytes_inline",
                   "SDK Key for getRemainingSpaceInMB: SSD's remaining capacity in MB. @return SSD's remaining capacity measured in MB.  @return A long value.",
            ],
            [
                   "SDK Key for getRemainingSpaceInMB: SSD's remaining capacity in MB. @return SSD's remaining capacity measured in MB.  @return A long value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_remainingSpaceInMegaBytes_inline",
                   "",
            ],
            [
                   "getVideoResolution",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoResolution_inline",
                   "Video resolution to be saved to SSD. @return SSD's video resolution.  @return A `VideoResolution` enum value.",
            ],
            [
                   "Video resolution to be saved to SSD. @return SSD's video resolution.  @return A `VideoResolution` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoResolution_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_AND_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoResolution_inline",
                   "SDK Key for getVideoResolution: Video resolution to be saved to SSD. @return SSD's video resolution.  @return A `VideoResolution` enum value.",
            ],
            [
                   "SDK Key for getVideoResolution: Video resolution to be saved to SSD. @return SSD's video resolution.  @return A `VideoResolution` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoResolution_inline",
                   "",
            ],
            [
                   "getVideoFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoFrameRate_inline",
                   "Video framerate to be saved to SSD.  @return A `VideoFrameRate` enum value.",
            ],
            [
                   "Video framerate to be saved to SSD.  @return A `VideoFrameRate` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoFrameRate_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_AND_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoFrameRate_inline",
                   "SDK Key for getVideoFrameRate: Video framerate to be saved to SSD.  @return A `VideoFrameRate` enum value.",
            ],
            [
                   "SDK Key for getVideoFrameRate: Video framerate to be saved to SSD.  @return A `VideoFrameRate` enum value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_videoFrameRate_inline",
                   "",
            ],
            [
                   "getRAWPhotoBurstCount",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_rawPhotoBurstCount_inline",
                   "Number of photos that are shot in RAW burst mode.  @return An int value.",
            ],
            [
                   "Number of photos that are shot in RAW burst mode.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_rawPhotoBurstCount_inline",
                   "",
            ],
            [
                   "RAW_PHOTO_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_rawPhotoBurstCount_inline",
                   "SDK Key for getRAWPhotoBurstCount: Number of photos that are shot in RAW burst mode.  @return An int value.",
            ],
            [
                   "SDK Key for getRAWPhotoBurstCount: Number of photos that are shot in RAW burst mode.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "#DJICamera_DJICameraSSDState_rawPhotoBurstCount_inline",
                   "",
            ],
            [
                   "SINGLE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeSingle_inline",
                   "Sets the camera to take a single photo.",
            ],
            [
                   "Sets the camera to take a single photo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeSingle_inline",
                   "",
            ],
            [
                   "HDR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHDR_inline",
                   "Sets the camera to take an HDR photo. X5 camera, X5R camera, XT camera, Z30 camera, Phantom 4 Pro camera, X4S camera and X5S camera do not support HDR mode.",
            ],
            [
                   "Sets the camera to take an HDR photo. X5 camera, X5R camera, XT camera, Z30 camera, Phantom 4 Pro camera, X4S camera and X5S camera do not support HDR mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHDR_inline",
                   "",
            ],
            [
                   "BURST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeBurst_inline",
                   "Set the camera to take multiple photos at once. XT camera does not support Burst mode.",
            ],
            [
                   "Set the camera to take multiple photos at once. XT camera does not support Burst mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeBurst_inline",
                   "",
            ],
            [
                   "AEB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeAEB_inline",
                   "Automatic Exposure Bracketing (AEB) capture. In this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames. XT camera and Z30 camera does not support AEB mode.",
            ],
            [
                   "Automatic Exposure Bracketing (AEB) capture. In this mode you can quickly take multiple shots (the default is 3) at different exposures without having to manually change any settings between frames. XT camera and Z30 camera does not support AEB mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeAEB_inline",
                   "",
            ],
            [
                   "INTERVAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeInterval_inline",
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The minimum interval for JPEG format of any quality is 2s. For all cameras except X4S, X5S and Phantom 4 Pro camera: The minimum interval for RAW or RAW+JPEG format is 10s. For the X4S, X5S and Phantom 4 Pro cameras the minimum interval for RAW or RAW+JPEG dformat is 5s.",
            ],
            [
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The minimum interval for JPEG format of any quality is 2s. For all cameras except X4S, X5S and Phantom 4 Pro camera: The minimum interval for RAW or RAW+JPEG format is 10s. For the X4S, X5S and Phantom 4 Pro cameras the minimum interval for RAW or RAW+JPEG dformat is 5s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeInterval_inline",
                   "",
            ],
            [
                   "TIME_LAPSE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeTimeLapse_inline",
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The camera will merge the photo sequence and the output is a video. The minimum interval for Video only format is 1 s. The minimum interval for Video+Photo format is 2 s. For the new Osmo firmware version, no video feed will be received if the camera is shooting photos with Time-lapse mode. Instead, user can receive a sequence of preview images using the delegate method `onGenerate`. Supported only by Osmo camera (Z3 and X3).",
            ],
            [
                   "Sets the camera to take a picture (or multiple pictures) continuously at a set time interval. The camera will merge the photo sequence and the output is a video. The minimum interval for Video only format is 1 s. The minimum interval for Video+Photo format is 2 s. For the new Osmo firmware version, no video feed will be received if the camera is shooting photos with Time-lapse mode. Instead, user can receive a sequence of preview images using the delegate method `onGenerate`. Supported only by Osmo camera (Z3 and X3).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeTimeLapse_inline",
                   "",
            ],
            [
                   "PANORAMA",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModePanorama_inline",
                   "In panorama mode, the aircraft takes a series of photos with different gimbal and aircraft heading positions. The photos can be stitched with a third-party library. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.",
            ],
            [
                   "In panorama mode, the aircraft takes a series of photos with different gimbal and aircraft heading positions. The photos can be stitched with a third-party library. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModePanorama_inline",
                   "",
            ],
            [
                   "EHDR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeEHDR_inline",
                   "Sets the camera to take an enhanced-HDR photo. It blends a sequence of photos for ghost-free high dynamic range photos. It is supported by Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "Sets the camera to take an enhanced-HDR photo. It blends a sequence of photos for ghost-free high dynamic range photos. It is supported by Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeEHDR_inline",
                   "",
            ],
            [
                   "HYPER_LIGHT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHyperLight_inline",
                   "Sets the camera to take photos in HyperLight mode. It is a setting for low-light environment to enhance the photo quality while reducing noise significantly. It is supported by Mavic 2 Zoom and Mavic 2 Pro.",
            ],
            [
                   "Sets the camera to take photos in HyperLight mode. It is a setting for low-light environment to enhance the photo quality while reducing noise significantly. It is supported by Mavic 2 Zoom and Mavic 2 Pro.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHyperLight_inline",
                   "",
            ],
            [
                   "HIGH_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHighResolution_inline",
                   "Indicates that the photo was taken in high resolution mode(48 MP 8000×6000 pixel). Supported by Mavic Air 2.",
            ],
            [
                   "Indicates that the photo was taken in high resolution mode(48 MP 8000×6000 pixel). Supported by Mavic Air 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeHighResolution_inline",
                   "",
            ],
            [
                   "RAW_BURST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeRAWBurst_inline",
                   "Sets the camera to take a burst of RAW photos. Use `getRAWPhotoBurstCount` to check how many photos have been shot. Only supported by X5S.",
            ],
            [
                   "Sets the camera to take a burst of RAW photos. Use `getRAWPhotoBurstCount` to check how many photos have been shot. Only supported by X5S.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeRAWBurst_inline",
                   "",
            ],
            [
                   "SHALLOW_FOCUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeShallowFocus_inline",
                   "Sets the camera to take a series of photos while the aircraft moves up and down automatically. The image's depth of field can be computed with a third-party library to produce a photo with the bokeh effect. Note:  1. It is only suitable for shooting still scenes.  2. The aircraft will ascend about 20cm before shooting. Ensure that there is no obstacle about the aircraft.  3. The suitable range of shooting is within 30m.  It is only supported by Spark.",
            ],
            [
                   "Sets the camera to take a series of photos while the aircraft moves up and down automatically. The image's depth of field can be computed with a third-party library to produce a photo with the bokeh effect. Note:  1. It is only suitable for shooting still scenes.  2. The aircraft will ascend about 20cm before shooting. Ensure that there is no obstacle about the aircraft.  3. The suitable range of shooting is within 30m.  It is only supported by Spark.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeShallowFocus_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeUnknown_inline",
                   "The shoot photo mode is unknown.",
            ],
            [
                   "The shoot photo mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_DJICameraShootPhotoModeUnknown_inline",
                   "",
            ],
            [
                   "PROGRAM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Program_inline",
                   "Program mode.",
            ],
            [
                   "Program mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Program_inline",
                   "",
            ],
            [
                   "SHUTTER_PRIORITY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Shutter_inline",
                   "Shutter priority mode.",
            ],
            [
                   "Shutter priority mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Shutter_inline",
                   "",
            ],
            [
                   "APERTURE_PRIORITY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Aperture_inline",
                   "Aperture priority mode.",
            ],
            [
                   "Aperture priority mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Aperture_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Manual_inline",
                   "Manual mode.",
            ],
            [
                   "Manual mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Manual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Unknown_inline",
                   "The camera exposure mode is unknown.",
            ],
            [
                   "The camera exposure mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_Unknown_inline",
                   "",
            ],
            [
                   "MOV",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_MOV_inline",
                   "The video storage format is MOV.",
            ],
            [
                   "The video storage format is MOV.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_MOV_inline",
                   "",
            ],
            [
                   "MP4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_MP4_inline",
                   "The video storage format is MP4.",
            ],
            [
                   "The video storage format is MP4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_MP4_inline",
                   "",
            ],
            [
                   "TIFF_SEQ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_TIFFSequence_inline",
                   "The video storage format is TIFF Sequence.",
            ],
            [
                   "The video storage format is TIFF Sequence.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_TIFFSequence_inline",
                   "",
            ],
            [
                   "SEQ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_SEQ_inline",
                   "The video storage format is SEQ. The raw data from the infrared camera is stored.",
            ],
            [
                   "The video storage format is SEQ. The raw data from the infrared camera is stored.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_SEQ_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_Unknown_inline",
                   "The video storage format is unknown.",
            ],
            [
                   "The video storage format is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_Unknown_inline",
                   "",
            ],
            [
                   "RESOLUTION_336x256",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_336x256_inline",
                   "The camera's video resolution is 336x256.",
            ],
            [
                   "The camera's video resolution is 336x256.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_336x256_inline",
                   "",
            ],
            [
                   "RESOLUTION_640x360",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x360_inline",
                   "The camera's video resolution is 640x360. Supported by Mavic 2 Enterprise Dual thermal camera.",
            ],
            [
                   "The camera's video resolution is 640x360. Supported by Mavic 2 Enterprise Dual thermal camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x360_inline",
                   "",
            ],
            [
                   "RESOLUTION_720x576",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_720x576_inline",
                   "The camera's video resolution is 720x576.",
            ],
            [
                   "The camera's video resolution is 720x576.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_720x576_inline",
                   "",
            ],
            [
                   "RESOLUTION_640x480",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x480_inline",
                   "The camera's video resolution is 640x480.",
            ],
            [
                   "The camera's video resolution is 640x480.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x480_inline",
                   "",
            ],
            [
                   "RESOLUTION_640x512",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x512_inline",
                   "The camera's video resolution is 640x512.",
            ],
            [
                   "The camera's video resolution is 640x512.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_640x512_inline",
                   "",
            ],
            [
                   "RESOLUTION_1280x720",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_1280x720_inline",
                   "The camera's video resolution is 1280x720.",
            ],
            [
                   "The camera's video resolution is 1280x720.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_1280x720_inline",
                   "",
            ],
            [
                   "RESOLUTION_1920x1080",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_1920x1080_inline",
                   "The camera's video resolution is 1920x1080.",
            ],
            [
                   "The camera's video resolution is 1920x1080.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_1920x1080_inline",
                   "",
            ],
            [
                   "RESOLUTION_2704x1520",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2704x1520_inline",
                   "The camera's video resolution is 2704x1520.",
            ],
            [
                   "The camera's video resolution is 2704x1520.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2704x1520_inline",
                   "",
            ],
            [
                   "RESOLUTION_2720x1530",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2720x1530_inline",
                   "The camera's video resolution is 2720x1530.",
            ],
            [
                   "The camera's video resolution is 2720x1530.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2720x1530_inline",
                   "",
            ],
            [
                   "RESOLUTION_3712x2088",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3712x2088_inline",
                   "The camera's video resolution is 3712x2088. It's only used by X7 camera.",
            ],
            [
                   "The camera's video resolution is 3712x2088. It's only used by X7 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3712x2088_inline",
                   "",
            ],
            [
                   "RESOLUTION_3840x1572",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3840x1572_inline",
                   "The camera's video resolution is 3840x1572.",
            ],
            [
                   "The camera's video resolution is 3840x1572.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3840x1572_inline",
                   "",
            ],
            [
                   "RESOLUTION_3840x2160",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3840x2160_inline",
                   "The camera's video resolution is 3840x2160.",
            ],
            [
                   "The camera's video resolution is 3840x2160.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3840x2160_inline",
                   "",
            ],
            [
                   "RESOLUTION_3944x2088",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3944x2088_inline",
                   "The camera's video resolution is 3944x2088. It's only used by X7 camera.",
            ],
            [
                   "The camera's video resolution is 3944x2088. It's only used by X7 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_3944x2088_inline",
                   "",
            ],
            [
                   "RESOLUTION_4096x2160",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4096x2160_inline",
                   "The camera's video resolution is 4096x2160.",
            ],
            [
                   "The camera's video resolution is 4096x2160.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4096x2160_inline",
                   "",
            ],
            [
                   "RESOLUTION_4608x2160",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4608x2160_inline",
                   "The camera's video resolution is 4608x2160.",
            ],
            [
                   "The camera's video resolution is 4608x2160.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4608x2160_inline",
                   "",
            ],
            [
                   "RESOLUTION_4608x2592",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4608x2592_inline",
                   "The camera's video resolution is 4608x2592.",
            ],
            [
                   "The camera's video resolution is 4608x2592.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_4608x2592_inline",
                   "",
            ],
            [
                   "RESOLUTION_5280x2160",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5280x2160_inline",
                   "The camera's video resolution is 5280x2160.",
            ],
            [
                   "The camera's video resolution is 5280x2160.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5280x2160_inline",
                   "",
            ],
            [
                   "RESOLUTION_5472x3078",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5472x3078_inline",
                   "The camera's video resolution is 5472x3078.",
            ],
            [
                   "The camera's video resolution is 5472x3078.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5472x3078_inline",
                   "",
            ],
            [
                   "RESOLUTION_5760X3240",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5760x3240_inline",
                   "The camera's video resolution is 5760x3240.",
            ],
            [
                   "The camera's video resolution is 5760x3240.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5760x3240_inline",
                   "",
            ],
            [
                   "RESOLUTION_6016X3200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_6016x3200_inline",
                   "The camera's video resolution is 6016x3200.",
            ],
            [
                   "The camera's video resolution is 6016x3200.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_6016x3200_inline",
                   "",
            ],
            [
                   "RESOLUTION_MAX",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_MaxResolution_inline",
                   "The camera's video resolution will be maximum resolution supported by the camera sensor. For X5S and X4S, the maximum resolution is 5280x2972.",
            ],
            [
                   "The camera's video resolution will be maximum resolution supported by the camera sensor. For X5S and X4S, the maximum resolution is 5280x2972.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_MaxResolution_inline",
                   "",
            ],
            [
                   "NO_SSD_VIDEO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_NoSSDVideo_inline",
                   "The camera's SSD video resolution is unset. When the SSD resolution is unset, camera will not store video to SSD. SSD's resolution is determined by both license key and SD card's video frame rate. If there is no supported resolution with the current configuration, DJICameraVideoResolutionUnset</code> will be selected and user should adjust either the license or the frame rate.",
            ],
            [
                   "The camera's SSD video resolution is unset. When the SSD resolution is unset, camera will not store video to SSD. SSD's resolution is determined by both license key and SD card's video frame rate. If there is no supported resolution with the current configuration, DJICameraVideoResolutionUnset</code> will be selected and user should adjust either the license or the frame rate.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_NoSSDVideo_inline",
                   "",
            ],
            [
                   "RESOLUTION_2048x1080",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2048x1080_inline",
                   "The camera's video resolution is 2048x1080.",
            ],
            [
                   "The camera's video resolution is 2048x1080.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2048x1080_inline",
                   "",
            ],
            [
                   "RESOLUTION_2688x1512",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2688x1512_inline",
                   "The camera's video resolution is 2688x1512.",
            ],
            [
                   "The camera's video resolution is 2688x1512.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_2688x1512_inline",
                   "",
            ],
            [
                   "RESOLUTION_5280x2972",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5280x2972_inline",
                   "The camera's video resolution is 5280x2972.",
            ],
            [
                   "The camera's video resolution is 5280x2972.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_5280x2972_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_Unknown_inline",
                   "The camera's video resolution is unknown.",
            ],
            [
                   "The camera's video resolution is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_Unknown_inline",
                   "",
            ],
            [
                   "FRAME_RATE_23_DOT_976_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_23p976fps_inline",
                   "The camera's video frame rate is 23.976fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 23.976fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_23p976fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_24_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_24fps_inline",
                   "The camera's video frame rate is 24fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 24fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_24fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_25_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_25fps_inline",
                   "The camera's video frame rate is 25fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 25fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_25fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_29_DOT_970_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_29p970fps_inline",
                   "The camera's video frame rate is 29.97fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 29.97fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_29p970fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_30_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_30fps_inline",
                   "The camera's video frame rate is 30fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 30fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_30fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_47_DOT_950_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_47p950fps_inline",
                   "The camera's video frame rate is 47.95fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 47.95fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_47p950fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_48_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_48fps_inline",
                   "The camera's video frame rate is 48fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 48fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_48fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_50_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_50fps_inline",
                   "The camera's video frame rate is 50fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 50fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_50fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_59_DOT_940_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_59p940fps_inline",
                   "The camera's video frame rate is 59.94fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 59.94fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_59p940fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_60_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_60fps_inline",
                   "The camera's video frame rate is 60fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 60fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_60fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_90_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_90fps_inline",
                   "The camera's video frame rate is 90fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 90fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_90fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_96_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_96fps_inline",
                   "The camera's video frame rate is 96fps (frames per second).",
            ],
            [
                   "The camera's video frame rate is 96fps (frames per second).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_96fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_100_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_100fps_inline",
                   "The camera's video frame rate is 100fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
            ],
            [
                   "The camera's video frame rate is 100fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_100fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_120_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_120fps_inline",
                   "The camera's video frame rate is 120fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
            ],
            [
                   "The camera's video frame rate is 120fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_120fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_240_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_240fps_inline",
                   "The camera's video frame rate is 240fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
            ],
            [
                   "The camera's video frame rate is 240fps (frames per second). This frame rate can only be used when `isSlowMotionSupported` returns `true`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_240fps_inline",
                   "",
            ],
            [
                   "FRAME_RATE_8_DOT_7_FPS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_8dot7fps_inline",
                   "The camera's video frame rate is 8.7fps (frames per second). Supported by Mavic 2 Enterprise Dual thermal camera.",
            ],
            [
                   "The camera's video frame rate is 8.7fps (frames per second). Supported by Mavic 2 Enterprise Dual thermal camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_8dot7fps_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_Unknown_inline",
                   "The camera's video frame rate is unknown.",
            ],
            [
                   "The camera's video frame rate is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_Unknown_inline",
                   "",
            ],
            [
                   "DEFAULT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_default_inline",
                   "The default FOV. Use this value if the FOV is not configurable for the camera.",
            ],
            [
                   "The default FOV. Use this value if the FOV is not configurable for the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_default_inline",
                   "",
            ],
            [
                   "NARROW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_narrow_inline",
                   "Use a narrow FOV to record videos.",
            ],
            [
                   "Use a narrow FOV to record videos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_narrow_inline",
                   "",
            ],
            [
                   "WIDE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_wide_inline",
                   "Use a wide FOV to record videos.",
            ],
            [
                   "Use a wide FOV to record videos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_wide_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_unknown_inline",
                   "UNKNOWN",
            ],
            [
                   "UNKNOWN",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_unknown_inline",
                   "",
            ],
            [
                   "getResolution",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_resolution_inline",
                   "Returns the camera's current video resolution.  @return Returns resolution",
            ],
            [
                   "Returns the camera's current video resolution.  @return Returns resolution",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_resolution_inline",
                   "",
            ],
            [
                   "getFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_frameRate_inline",
                   "Returns the camera's current video frame rate.  @return Returns framerate",
            ],
            [
                   "Returns the camera's current video frame rate.  @return Returns framerate",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_frameRate_inline",
                   "",
            ],
            [
                   "getFov",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_fov_inline",
                   "The FOV for recording videos.  @return Returns framerate",
            ],
            [
                   "The FOV for recording videos.  @return Returns framerate",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_fov_inline",
                   "",
            ],
            [
                   "ResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_initWithResolution_inline",
                   "Creates a `DJICameraVideoResolutionAndFrameRate` instance with a preset camera video resolution and frame rate. The value of `getFov` is `DEFAULT`.  @param resolution The specific resolution. @param frameRate The specific frame rate.",
            ],
            [
                   "Creates a `DJICameraVideoResolutionAndFrameRate` instance with a preset camera video resolution and frame rate. The value of `getFov` is `DEFAULT`.  @param resolution The specific resolution. @param frameRate The specific frame rate.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_initWithResolution_inline",
                   "",
            ],
            [
                   "ResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_initWithResolutionWithFrameRateFOV_inline",
                   "Creates a `ResolutionAndFrameRate` instance with a preset camera video resolution, frame rate and FOV. FOV is only configurable for Mavic 2 Pro and it is only configurable when the resolution is `RESOLUTION_3840x2160` (4K). Use `DEFAULT` when FOV is not configurable.  @param resolution The specific resolution. @param frameRate The specific frame rate. @param fov The specific FOV.",
            ],
            [
                   "Creates a `ResolutionAndFrameRate` instance with a preset camera video resolution, frame rate and FOV. FOV is only configurable for Mavic 2 Pro and it is only configurable when the resolution is `RESOLUTION_3840x2160` (4K). Use `DEFAULT` when FOV is not configurable.  @param resolution The specific resolution. @param frameRate The specific frame rate. @param fov The specific FOV.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "#DJICamera_DJICameraVideoResolutionAndFrameRate_initWithResolutionWithFrameRateFOV_inline",
                   "",
            ],
            [
                   "PAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_PAL_inline",
                   "The camera video standard value is set to PAL.",
            ],
            [
                   "The camera video standard value is set to PAL.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_PAL_inline",
                   "",
            ],
            [
                   "NTSC",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_NTSC_inline",
                   "The camera video standard value is set to NTSC.",
            ],
            [
                   "The camera video standard value is set to NTSC.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_NTSC_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_Unknown_inline",
                   "The camera video standard value is unknown.",
            ],
            [
                   "The camera video standard value is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_Unknown_inline",
                   "",
            ],
            [
                   "RAW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RAW_inline",
                   "The camera's photo storage format is RAW.",
            ],
            [
                   "The camera's photo storage format is RAW.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RAW_inline",
                   "",
            ],
            [
                   "JPEG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_JPEG_inline",
                   "The camera's photo storage format is JPEG.",
            ],
            [
                   "The camera's photo storage format is JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_JPEG_inline",
                   "",
            ],
            [
                   "RAW_AND_JPEG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RAWAndJPEG_inline",
                   "The camera stores both the RAW and JPEG formats of the photo.",
            ],
            [
                   "The camera stores both the RAW and JPEG formats of the photo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RAWAndJPEG_inline",
                   "",
            ],
            [
                   "TIFF_14_BIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14Bit_inline",
                   "The camera's photo storage format is TIFF (14bit).",
            ],
            [
                   "The camera's photo storage format is TIFF (14bit).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14Bit_inline",
                   "",
            ],
            [
                   "RADIOMETRIC_JPEG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RadiometricJPEG_inline",
                   "The camera's photo storage format is Radiometric JPEG (a special JPEG format with temperature information). A radiometric JPEG has the .jpg suffix and can be viewed as a normal JPEG file would. At the same time, the temperature data is also stored in the file as meta data. PC software is required to analyze the file and it is accessible at FLIR's website http://www.flir.com/instruments/display/?id=54865. Only supported by XT camera with firmware version 1.16.1.70 or above.",
            ],
            [
                   "The camera's photo storage format is Radiometric JPEG (a special JPEG format with temperature information). A radiometric JPEG has the .jpg suffix and can be viewed as a normal JPEG file would. At the same time, the temperature data is also stored in the file as meta data. PC software is required to analyze the file and it is accessible at FLIR's website http://www.flir.com/instruments/display/?id=54865. Only supported by XT camera with firmware version 1.16.1.70 or above.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_RadiometricJPEG_inline",
                   "",
            ],
            [
                   "TIFF_14_BIT_LINEAR_LOW_TEMP_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14BitLinearLowTempResolution_inline",
                   "The camera's photo storage format is TIFF Linear Low. In this mode each pixel is 14 bits and linearly proportional with temperature, covering a high dynamic range of temperature which results in a lower temperature resolution. Supported only by Zenmuse XT containing Advanced Radiometry capabilities with firmware version 1.17.1.80 or lower. For newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
            ],
            [
                   "The camera's photo storage format is TIFF Linear Low. In this mode each pixel is 14 bits and linearly proportional with temperature, covering a high dynamic range of temperature which results in a lower temperature resolution. Supported only by Zenmuse XT containing Advanced Radiometry capabilities with firmware version 1.17.1.80 or lower. For newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14BitLinearLowTempResolution_inline",
                   "",
            ],
            [
                   "TIFF_14_BIT_LINEAR_HIGH_TEMP_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14BitLinearHighTempResolution_inline",
                   "The camera's photo storage format is TIFF Linear High. In this mode each pixel is 14 bits and linearly proportional with temperature, covering a low dynamic range of temperature which results in a higher temperature resolution. Supported only by Zenmuse XT containing Advanced Radiometry capabilities with firmware version 1.17.1.80 or lower. For newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
            ],
            [
                   "The camera's photo storage format is TIFF Linear High. In this mode each pixel is 14 bits and linearly proportional with temperature, covering a low dynamic range of temperature which results in a higher temperature resolution. Supported only by Zenmuse XT containing Advanced Radiometry capabilities with firmware version 1.17.1.80 or lower. For newer firmwares, the temperature resolution preference is coupled with the thermal gain mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_TIFF14BitLinearHighTempResolution_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_Unknown_inline",
                   "The camera's photo storage format is unknown.",
            ],
            [
                   "The camera's photo storage format is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_Unknown_inline",
                   "",
            ],
            [
                   "VIDEO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_Video_inline",
                   "The camera in time-lapse mode will generate video.",
            ],
            [
                   "The camera in time-lapse mode will generate video.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_Video_inline",
                   "",
            ],
            [
                   "JPEG_AND_VIDEO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_VideoAndJPEG_inline",
                   "The camera in time-lapse mode will generate video and JPEG.",
            ],
            [
                   "The camera in time-lapse mode will generate video and JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_VideoAndJPEG_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_Unknown_inline",
                   "The file format is unknown.",
            ],
            [
                   "The file format is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_Unknown_inline",
                   "",
            ],
            [
                   "RATIO_4_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_4_3_inline",
                   "The camera's photo ratio is 4 : 3.",
            ],
            [
                   "The camera's photo ratio is 4 : 3.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_4_3_inline",
                   "",
            ],
            [
                   "RATIO_16_9",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_16_9_inline",
                   "The camera's photo ratio is 16 : 9.",
            ],
            [
                   "The camera's photo ratio is 16 : 9.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_16_9_inline",
                   "",
            ],
            [
                   "RATIO_3_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_3_2_inline",
                   "The camera's photo ratio is 3:2.",
            ],
            [
                   "The camera's photo ratio is 3:2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_3_2_inline",
                   "",
            ],
            [
                   "RATIO_5_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_5_4_inline",
                   "The camera's photo ratio is 5:4.",
            ],
            [
                   "The camera's photo ratio is 5:4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_5_4_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_Unknown_inline",
                   "The camera's photo ratio is unknown.",
            ],
            [
                   "The camera's photo ratio is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_Unknown_inline",
                   "",
            ],
            [
                   "BURST_COUNT_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_2_inline",
                   "The camera burst shoot count is set to capture 2 pictures at once when the camera shoots a photo.",
            ],
            [
                   "The camera burst shoot count is set to capture 2 pictures at once when the camera shoots a photo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_2_inline",
                   "",
            ],
            [
                   "BURST_COUNT_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_3_inline",
                   "The camera burst shoot count is set to capture 3 pictures at once when the camera shoots a photo.",
            ],
            [
                   "The camera burst shoot count is set to capture 3 pictures at once when the camera shoots a photo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_3_inline",
                   "",
            ],
            [
                   "BURST_COUNT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_5_inline",
                   "The camera burst shoot count is set to capture 5 pictures at once when the camera takes a photo.",
            ],
            [
                   "The camera burst shoot count is set to capture 5 pictures at once when the camera takes a photo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_5_inline",
                   "",
            ],
            [
                   "BURST_COUNT_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_7_inline",
                   "The camera burst shoot count is set to capture 7 pictures at once when the camera takes a photo. It is not supported by Z30 camera.",
            ],
            [
                   "The camera burst shoot count is set to capture 7 pictures at once when the camera takes a photo. It is not supported by Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_7_inline",
                   "",
            ],
            [
                   "BURST_COUNT_10",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_10_inline",
                   "The camera burst shoot count is set to capture 10 pictures at once when the camera takes a photo. Only supported by X4S camera, X5S camera and Phantom 4 Pro camera.",
            ],
            [
                   "The camera burst shoot count is set to capture 10 pictures at once when the camera takes a photo. Only supported by X4S camera, X5S camera and Phantom 4 Pro camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_10_inline",
                   "",
            ],
            [
                   "BURST_COUNT_14",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_14_inline",
                   "The camera burst shoot count is set to capture 14 pictures at once when the camera takes a photo. Only supported by X4S camera, X5S camera and Phantom 4 Pro camera.",
            ],
            [
                   "The camera burst shoot count is set to capture 14 pictures at once when the camera takes a photo. Only supported by X4S camera, X5S camera and Phantom 4 Pro camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_14_inline",
                   "",
            ],
            [
                   "CONTINUOUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_Continuous_inline",
                   "The camera burst shoot count is set to capture RAW pictures continuously until `stopShootPhoto` command is sent. It is only supported by Inspire 2 when the photo shoot mode is RAW burst.",
            ],
            [
                   "The camera burst shoot count is set to capture RAW pictures continuously until `stopShootPhoto` command is sent. It is only supported by Inspire 2 when the photo shoot mode is RAW burst.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_Continuous_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_Unknown_inline",
                   "The camera burst shoot count value is unknown.",
            ],
            [
                   "The camera burst shoot count value is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_Unknown_inline",
                   "",
            ],
            [
                   "AEB_COUNT_3",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_3_inline",
                   "The number of pictures to continuously take at one time in AEB mode is 3.",
            ],
            [
                   "The number of pictures to continuously take at one time in AEB mode is 3.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_3_inline",
                   "",
            ],
            [
                   "AEB_COUNT_5",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_5_inline",
                   "The number of pictures to continuously take at one time in AEB mode is 5.",
            ],
            [
                   "The number of pictures to continuously take at one time in AEB mode is 5.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_5_inline",
                   "",
            ],
            [
                   "AEB_COUNT_7",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_7_inline",
                   "The number of pictures to continuously take at one time in AEB mode is 7.",
            ],
            [
                   "The number of pictures to continuously take at one time in AEB mode is 7.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_7_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_Unknown_inline",
                   "The number of pictures to continuously take at one time in AEB mode is unknown.",
            ],
            [
                   "The number of pictures to continuously take at one time in AEB mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_Unknown_inline",
                   "",
            ],
            [
                   "PhotoTimeIntervalSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_Contstructor_inline",
                   "Constructor.  @param captureCount Number of photos to take. @param timeIntervalInSeconds Time interval in seconds between taking photos.",
            ],
            [
                   "Constructor.  @param captureCount Number of photos to take. @param timeIntervalInSeconds Time interval in seconds between taking photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_Contstructor_inline",
                   "",
            ],
            [
                   "getCaptureCount",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_captureCount_inline",
                   "The number of photos to capture. The value range is [2, 255]. If 255 is selected, then the camera will continue to take pictures until stopShootPhotoWithCompletion is called. For thermal imaging camera and Z30 camera, it can only be set to 255.  @return Number of photos to capture",
            ],
            [
                   "The number of photos to capture. The value range is [2, 255]. If 255 is selected, then the camera will continue to take pictures until stopShootPhotoWithCompletion is called. For thermal imaging camera and Z30 camera, it can only be set to 255.  @return Number of photos to capture",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_captureCount_inline",
                   "",
            ],
            [
                   "getTimeIntervalInSeconds",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_timeIntervalInSeconds_inline",
                   "The time interval between when two photos are taken. The range for this parameter depends the photo file format(DJICameraPhotoFileFormat). For XT camera, the range is [1, 60] seconds. For all other products, when the file format is JPEG, the range is [2, 2^16 - 1] seconds; when the file format is RAW or RAW+JPEG, the range is [10, 2^16 - 1] seconds.  @return Time interval in seconds.",
            ],
            [
                   "The time interval between when two photos are taken. The range for this parameter depends the photo file format(DJICameraPhotoFileFormat). For XT camera, the range is [1, 60] seconds. For all other products, when the file format is JPEG, the range is [2, 2^16 - 1] seconds; when the file format is RAW or RAW+JPEG, the range is [10, 2^16 - 1] seconds.  @return Time interval in seconds.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "#DJICamera_DJICameraPhotoIntervalParam_timeIntervalInSeconds_inline",
                   "",
            ],
            [
                   "getInterval",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_interval_inline",
                   "The time interval between when two photos are taken.  @return Return interval value from settings",
            ],
            [
                   "The time interval between when two photos are taken.  @return Return interval value from settings",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_interval_inline",
                   "",
            ],
            [
                   "getDuration",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_duration_inline",
                   "The total duration for which the camera will take pictures.  @return Return duration value from settings",
            ],
            [
                   "The total duration for which the camera will take pictures.  @return Return duration value from settings",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_duration_inline",
                   "",
            ],
            [
                   "getFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_fileFormat_inline",
                   "The file format for captured photos during time lapse.  @return Return file format value from settings",
            ],
            [
                   "The file format for captured photos during time lapse.  @return Return file format value from settings",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "#DJICamera_DJICameraPhotoTimeLapseSettings_fileFormat_inline",
                   "",
            ],
            [
                   "PANORAMA_MODE_3X3",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_3X3_inline",
                   "Camera will shoot 3 rows of 3 photos. Each photo in a row will be taken with a different aircraft heading. Each row of photos is taken with a different gimbal pitch.",
            ],
            [
                   "Camera will shoot 3 rows of 3 photos. Each photo in a row will be taken with a different aircraft heading. Each row of photos is taken with a different gimbal pitch.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_3X3_inline",
                   "",
            ],
            [
                   "PANORAMA_MODE_3X1",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_3x1_inline",
                   "Camera will shoot 3 photos with the same aircraft heading and different gimbal pitch.",
            ],
            [
                   "Camera will shoot 3 photos with the same aircraft heading and different gimbal pitch.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_3x1_inline",
                   "",
            ],
            [
                   "PANORAMA_MODE_SPHERE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_Sphere_inline",
                   "Camera will shoot 8 rows of 3 photos and 1 extra photo (facing downward). Each photo in a row will be taken with a different aircraft heading. Each row of photos is taken with a different gimbal pitch.",
            ],
            [
                   "Camera will shoot 8 rows of 3 photos and 1 extra photo (facing downward). Each photo in a row will be taken with a different aircraft heading. Each row of photos is taken with a different gimbal pitch.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_Sphere_inline",
                   "",
            ],
            [
                   "PANORAMA_MODE_180",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_180_inline",
                   "Camera will shoot 3 photos with the same gimbal pitch (facing forward) and different aircraft headings.",
            ],
            [
                   "Camera will shoot 3 photos with the same gimbal pitch (facing forward) and different aircraft headings.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_180_inline",
                   "",
            ],
            [
                   "PANORAMA_MODE_SUPER_RESOLUTION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_SuperResolution_inline",
                   "The camera will capture and patch nine photos resulting in a 48-megapixel super resolution photo. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.",
            ],
            [
                   "The camera will capture and patch nine photos resulting in a 48-megapixel super resolution photo. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_SuperResolution_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_Unknown_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_20000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_20000_inline",
                   "Camera's shutter speed 1/20000 s.",
            ],
            [
                   "Camera's shutter speed 1/20000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_20000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_16000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_16000_inline",
                   "Camera's shutter speed 1/16000 s.",
            ],
            [
                   "Camera's shutter speed 1/16000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_16000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_12800",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_12800_inline",
                   "Camera's shutter speed 1/12800 s.",
            ],
            [
                   "Camera's shutter speed 1/12800 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_12800_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_10000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_10000_inline",
                   "Camera's shutter speed 1/10000 s.",
            ],
            [
                   "Camera's shutter speed 1/10000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_10000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_8000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_8000_inline",
                   "Camera's shutter speed 1/8000 s.",
            ],
            [
                   "Camera's shutter speed 1/8000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_8000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_6400",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6400_inline",
                   "Camera's shutter speed 1/6400 s.",
            ],
            [
                   "Camera's shutter speed 1/6400 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6400_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_6000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6000_inline",
                   "Camera's shutter speed 1/6000 s.",
            ],
            [
                   "Camera's shutter speed 1/6000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_5000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_5000_inline",
                   "Camera's shutter speed 1/5000 s.",
            ],
            [
                   "Camera's shutter speed 1/5000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_5000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_4000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_4000_inline",
                   "Camera's shutter speed 1/4000 s.",
            ],
            [
                   "Camera's shutter speed 1/4000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_4000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_3200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3200_inline",
                   "Camera's shutter speed 1/3200 s.",
            ],
            [
                   "Camera's shutter speed 1/3200 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3200_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_3000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3000_inline",
                   "Camera's shutter speed 1/3000 s.",
            ],
            [
                   "Camera's shutter speed 1/3000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_2500",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2500_inline",
                   "Camera's shutter speed 1/2500 s.",
            ],
            [
                   "Camera's shutter speed 1/2500 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2500_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_2000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2000_inline",
                   "Camera's shutter speed 1/2000 s.",
            ],
            [
                   "Camera's shutter speed 1/2000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1600",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1600_inline",
                   "Camera's shutter speed 1/1600 s.",
            ],
            [
                   "Camera's shutter speed 1/1600 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1600_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1500",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1500_inline",
                   "Camera's shutter speed 1/1500 s.",
            ],
            [
                   "Camera's shutter speed 1/1500 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1500_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1250",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1250_inline",
                   "Camera's shutter speed 1/1250 s.",
            ],
            [
                   "Camera's shutter speed 1/1250 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1250_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1000",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1000_inline",
                   "Camera's shutter speed 1/1000 s.",
            ],
            [
                   "Camera's shutter speed 1/1000 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1000_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_800",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_800_inline",
                   "Camera's shutter speed 1/800 s.",
            ],
            [
                   "Camera's shutter speed 1/800 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_800_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_725",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_725_inline",
                   "Camera's shutter speed 1/725 s.",
            ],
            [
                   "Camera's shutter speed 1/725 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_725_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_640",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_640_inline",
                   "Camera's shutter speed 1/640 s.",
            ],
            [
                   "Camera's shutter speed 1/640 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_640_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_500",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_500_inline",
                   "Camera's shutter speed 1/500 s.",
            ],
            [
                   "Camera's shutter speed 1/500 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_500_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_400",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_400_inline",
                   "Camera's shutter speed 1/400 s.",
            ],
            [
                   "Camera's shutter speed 1/400 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_400_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_350",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_350_inline",
                   "Camera's shutter speed 1/350 s.",
            ],
            [
                   "Camera's shutter speed 1/350 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_350_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_320",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_320_inline",
                   "Camera's shutter speed 1/320 s.",
            ],
            [
                   "Camera's shutter speed 1/320 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_320_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_250",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_250_inline",
                   "Camera's shutter speed 1/250 s.",
            ],
            [
                   "Camera's shutter speed 1/250 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_250_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_240",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_240_inline",
                   "Camera's shutter speed 1/240 s.",
            ],
            [
                   "Camera's shutter speed 1/240 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_240_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_200_inline",
                   "Camera's shutter speed 1/200 s.",
            ],
            [
                   "Camera's shutter speed 1/200 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_200_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_180",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_180_inline",
                   "Camera's shutter speed 1/180 s.",
            ],
            [
                   "Camera's shutter speed 1/180 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_180_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_160",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_160_inline",
                   "Camera's shutter speed 1/160 s.",
            ],
            [
                   "Camera's shutter speed 1/160 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_160_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_125",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_125_inline",
                   "Camera's shutter speed 1/125 s.",
            ],
            [
                   "Camera's shutter speed 1/125 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_125_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_120",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_120_inline",
                   "Camera's shutter speed 1/120 s.",
            ],
            [
                   "Camera's shutter speed 1/120 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_120_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_100",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_100_inline",
                   "Camera's shutter speed 1/100 s.",
            ],
            [
                   "Camera's shutter speed 1/100 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_100_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_90",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_90_inline",
                   "Camera's shutter speed 1/90 s.",
            ],
            [
                   "Camera's shutter speed 1/90 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_90_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_80",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_80_inline",
                   "Camera's shutter speed 1/80 s.",
            ],
            [
                   "Camera's shutter speed 1/80 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_80_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_60",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_60_inline",
                   "Camera's shutter speed 1/60 s.",
            ],
            [
                   "Camera's shutter speed 1/60 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_60_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_50",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_50_inline",
                   "Camera's shutter speed 1/50 s.",
            ],
            [
                   "Camera's shutter speed 1/50 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_50_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_40",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_40_inline",
                   "Camera's shutter speed 1/40 s.",
            ],
            [
                   "Camera's shutter speed 1/40 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_40_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_30",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_30_inline",
                   "Camera's shutter speed 1/30 s.",
            ],
            [
                   "Camera's shutter speed 1/30 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_30_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_25",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_25_inline",
                   "Camera's shutter speed 1/25 s.",
            ],
            [
                   "Camera's shutter speed 1/25 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_25_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_20",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_20_inline",
                   "Camera's shutter speed 1/20 s.",
            ],
            [
                   "Camera's shutter speed 1/20 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_20_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_15",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_15_inline",
                   "Camera's shutter speed 1/15 s.",
            ],
            [
                   "Camera's shutter speed 1/15 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_15_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_12_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_12p5_inline",
                   "Camera's shutter speed 1/12.5 s.",
            ],
            [
                   "Camera's shutter speed 1/12.5 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_12p5_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_10",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_10_inline",
                   "Camera's shutter speed 1/10 s.",
            ],
            [
                   "Camera's shutter speed 1/10 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_10_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_8_inline",
                   "Camera's shutter speed 1/8 s.",
            ],
            [
                   "Camera's shutter speed 1/8 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_8_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_6_DOT_25",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6p25_inline",
                   "Camera's shutter speed 1/6.25 s.",
            ],
            [
                   "Camera's shutter speed 1/6.25 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_6p25_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_5_inline",
                   "Camera's shutter speed 1/5 s.",
            ],
            [
                   "Camera's shutter speed 1/5 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_5_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_4_inline",
                   "Camera's shutter speed 1/4 s.",
            ],
            [
                   "Camera's shutter speed 1/4 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_4_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3_inline",
                   "Camera's shutter speed 1/3 s.",
            ],
            [
                   "Camera's shutter speed 1/3 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_3_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_2_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2p5_inline",
                   "Camera's shutter speed 1/2.5 s.",
            ],
            [
                   "Camera's shutter speed 1/2.5 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2p5_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2_inline",
                   "Camera's shutter speed 1/2 s.",
            ],
            [
                   "Camera's shutter speed 1/2 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_2_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1_DOT_67",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1p67_inline",
                   "Camera's shutter speed 1/1.67 s.",
            ],
            [
                   "Camera's shutter speed 1/1.67 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1p67_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_1_DOT_25",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1p25_inline",
                   "Camera's shutter speed 1/1.25 s.",
            ],
            [
                   "Camera's shutter speed 1/1.25 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1_1p25_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p0_inline",
                   "Camera's shutter speed 1.0 s.",
            ],
            [
                   "Camera's shutter speed 1.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_DOT_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p3_inline",
                   "Camera's shutter speed 1.3 s.",
            ],
            [
                   "Camera's shutter speed 1.3 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p3_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_1_DOT_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p6_inline",
                   "Camera's shutter speed 1.6 s.",
            ],
            [
                   "Camera's shutter speed 1.6 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_1p6_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_2p0_inline",
                   "Camera's shutter speed 2.0 s.",
            ],
            [
                   "Camera's shutter speed 2.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_2p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_2_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_2p5_inline",
                   "Camera's shutter speed 2.5 s.",
            ],
            [
                   "Camera's shutter speed 2.5 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_2p5_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_3p0_inline",
                   "Camera's shutter speed 3.0 s.",
            ],
            [
                   "Camera's shutter speed 3.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_3p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_3_DOT_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_3p2_inline",
                   "Camera's shutter speed 3.2 s.",
            ],
            [
                   "Camera's shutter speed 3.2 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_3p2_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_4p0_inline",
                   "Camera's shutter speed 4.0 s.",
            ],
            [
                   "Camera's shutter speed 4.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_4p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_5p0_inline",
                   "Camera's shutter speed 5.0 s.",
            ],
            [
                   "Camera's shutter speed 5.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_5p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_6p0_inline",
                   "Camera's shutter speed 6.0 s.",
            ],
            [
                   "Camera's shutter speed 6.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_6p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_7p0_inline",
                   "Camera's shutter speed 7.0 s.",
            ],
            [
                   "Camera's shutter speed 7.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_7p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_8p0_inline",
                   "Camera's shutter speed 8.0 s.",
            ],
            [
                   "Camera's shutter speed 8.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_8p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_9",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_9p0_inline",
                   "Camera's shutter speed 9.0 s.",
            ],
            [
                   "Camera's shutter speed 9.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_9p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_10",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_10p0_inline",
                   "Camera's shutter speed 10.0 s.",
            ],
            [
                   "Camera's shutter speed 10.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_10p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_13",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_13p0_inline",
                   "Camera's shutter speed 13.0 s.",
            ],
            [
                   "Camera's shutter speed 13.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_13p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_15",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_15p0_inline",
                   "Camera's shutter speed 15.0 s.",
            ],
            [
                   "Camera's shutter speed 15.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_15p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_20",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_20p0_inline",
                   "Camera's shutter speed 20.0 s.",
            ],
            [
                   "Camera's shutter speed 20.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_20p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_25",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_25p0_inline",
                   "Camera's shutter speed 25.0 s.",
            ],
            [
                   "Camera's shutter speed 25.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_25p0_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_30",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_30p0_inline",
                   "Camera's shutter speed 30.0 s.",
            ],
            [
                   "Camera's shutter speed 30.0 s.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_30p0_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_Unknown_inline",
                   "Camera's shutter speed unknown.",
            ],
            [
                   "Camera's shutter speed unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_Unknown_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Auto_inline",
                   "The ISO value is automatically set. This cannot be used for all cameras when in Manual mode.",
            ],
            [
                   "The ISO value is automatically set. This cannot be used for all cameras when in Manual mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Auto_inline",
                   "",
            ],
            [
                   "ISO_50",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_50_inline",
                   "The ISO value is set to 50.",
            ],
            [
                   "The ISO value is set to 50.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_50_inline",
                   "",
            ],
            [
                   "ISO_100",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_100_inline",
                   "The ISO value is set to 100.",
            ],
            [
                   "The ISO value is set to 100.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_100_inline",
                   "",
            ],
            [
                   "ISO_200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_200_inline",
                   "The ISO value is set to 200.",
            ],
            [
                   "The ISO value is set to 200.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_200_inline",
                   "",
            ],
            [
                   "ISO_400",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_400_inline",
                   "The ISO value is set to 400.",
            ],
            [
                   "The ISO value is set to 400.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_400_inline",
                   "",
            ],
            [
                   "ISO_800",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_800_inline",
                   "The ISO value is set to 800.",
            ],
            [
                   "The ISO value is set to 800.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_800_inline",
                   "",
            ],
            [
                   "ISO_1600",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_1600_inline",
                   "The ISO value is set to 1600.",
            ],
            [
                   "The ISO value is set to 1600.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_1600_inline",
                   "",
            ],
            [
                   "ISO_3200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_3200_inline",
                   "The ISO value is set to 3200.",
            ],
            [
                   "The ISO value is set to 3200.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_3200_inline",
                   "",
            ],
            [
                   "ISO_6400",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_6400_inline",
                   "The ISO value is set to 6400.",
            ],
            [
                   "The ISO value is set to 6400.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_6400_inline",
                   "",
            ],
            [
                   "ISO_12800",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_12800_inline",
                   "The ISO value is set to 12800.",
            ],
            [
                   "The ISO value is set to 12800.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_12800_inline",
                   "",
            ],
            [
                   "ISO_25600",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_25600_inline",
                   "The ISO value is set to 25600.",
            ],
            [
                   "The ISO value is set to 25600.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_25600_inline",
                   "",
            ],
            [
                   "ISO_51200",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_51200_inline",
                   "The ISO value is set to 51200.",
            ],
            [
                   "The ISO value is set to 51200.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_51200_inline",
                   "",
            ],
            [
                   "ISO_102400",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_102400_inline",
                   "The ISO value is set to 102400.",
            ],
            [
                   "The ISO value is set to 102400.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_102400_inline",
                   "",
            ],
            [
                   "FIXED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Fixed_inline",
                   "ISO value is fixed by the camera firmware. When the camera color is set to `D_LOG`, camera will fix the ISO to a specific value in order to optimize the performance. The value set by camera can be accessed from `getISO`.",
            ],
            [
                   "ISO value is fixed by the camera firmware. When the camera color is set to `D_LOG`, camera will fix the ISO to a specific value in order to optimize the performance. The value set by camera can be accessed from `getISO`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Fixed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Unknown_inline",
                   "The ISO value is set to Unknown value.",
            ],
            [
                   "The ISO value is set to Unknown value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_Unknown_inline",
                   "",
            ],
            [
                   "F_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1_inline",
                   "The Aperture value is f/1.",
            ],
            [
                   "The Aperture value is f/1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1_inline",
                   "",
            ],
            [
                   "F_1_DOT_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p2_inline",
                   "The Aperture value is f/1.2.",
            ],
            [
                   "The Aperture value is f/1.2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p2_inline",
                   "",
            ],
            [
                   "F_1_DOT_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p3_inline",
                   "The Aperture value is f/1.3.",
            ],
            [
                   "The Aperture value is f/1.3.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p3_inline",
                   "",
            ],
            [
                   "F_1_DOT_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p4_inline",
                   "The Aperture value is f/1.4.",
            ],
            [
                   "The Aperture value is f/1.4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p4_inline",
                   "",
            ],
            [
                   "F_1_DOT_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p6_inline",
                   "The Aperture value is f/1.6. It is only supported by Z30 camera.",
            ],
            [
                   "The Aperture value is f/1.6. It is only supported by Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p6_inline",
                   "",
            ],
            [
                   "F_1_DOT_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p7_inline",
                   "The Aperture value is f/1.7.",
            ],
            [
                   "The Aperture value is f/1.7.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p7_inline",
                   "",
            ],
            [
                   "F_1_DOT_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p8_inline",
                   "The Aperture value is f/1.8.",
            ],
            [
                   "The Aperture value is f/1.8.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F1p8_inline",
                   "",
            ],
            [
                   "F_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p0_inline",
                   "The Aperture value is f/2.",
            ],
            [
                   "The Aperture value is f/2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p0_inline",
                   "",
            ],
            [
                   "F_2_DOT_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p2_inline",
                   "The Aperture value is f/2.2.",
            ],
            [
                   "The Aperture value is f/2.2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p2_inline",
                   "",
            ],
            [
                   "F_2_DOT_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p4_inline",
                   "The Aperture value is f/2.4. It is only supported by Z30 camera.",
            ],
            [
                   "The Aperture value is f/2.4. It is only supported by Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p4_inline",
                   "",
            ],
            [
                   "F_2_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p5_inline",
                   "The Aperture value is f/2.5.",
            ],
            [
                   "The Aperture value is f/2.5.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p5_inline",
                   "",
            ],
            [
                   "F_2_DOT_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p6_inline",
                   "The Aperture value is f/2.6.",
            ],
            [
                   "The Aperture value is f/2.6.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p6_inline",
                   "",
            ],
            [
                   "F_2_DOT_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p8_inline",
                   "The Aperture value is f/2.8.",
            ],
            [
                   "The Aperture value is f/2.8.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F2p8_inline",
                   "",
            ],
            [
                   "F_3_DOT_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p2_inline",
                   "The Aperture value is f/3.2.",
            ],
            [
                   "The Aperture value is f/3.2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p2_inline",
                   "",
            ],
            [
                   "F_3_DOT_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p4_inline",
                   "The Aperture value is f/3.4.",
            ],
            [
                   "The Aperture value is f/3.4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p4_inline",
                   "",
            ],
            [
                   "F_3_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p5_inline",
                   "The Aperture value is f/3.5.",
            ],
            [
                   "The Aperture value is f/3.5.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F3p5_inline",
                   "",
            ],
            [
                   "F_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p0_inline",
                   "The Aperture value is f/4.",
            ],
            [
                   "The Aperture value is f/4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p0_inline",
                   "",
            ],
            [
                   "F_4_DOT_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p5_inline",
                   "The Aperture value is f/4.5.",
            ],
            [
                   "The Aperture value is f/4.5.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p5_inline",
                   "",
            ],
            [
                   "F_4_DOT_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p8_inline",
                   "The Aperture value is f/4.8.",
            ],
            [
                   "The Aperture value is f/4.8.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F4p8_inline",
                   "",
            ],
            [
                   "F_5",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F5p0_inline",
                   "The Aperture value is f/5.",
            ],
            [
                   "The Aperture value is f/5.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F5p0_inline",
                   "",
            ],
            [
                   "F_5_DOT_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F5p6_inline",
                   "The Aperture value is f/5.6.",
            ],
            [
                   "The Aperture value is f/5.6.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F5p6_inline",
                   "",
            ],
            [
                   "F_6_DOT_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F6p3_inline",
                   "The Aperture value is f/6.3.",
            ],
            [
                   "The Aperture value is f/6.3.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F6p3_inline",
                   "",
            ],
            [
                   "F_6_DOT_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F6p8_inline",
                   "The Aperture value is f/6.8.",
            ],
            [
                   "The Aperture value is f/6.8.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F6p8_inline",
                   "",
            ],
            [
                   "F_7_DOT_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F7p1_inline",
                   "The Aperture value is f/7.1.",
            ],
            [
                   "The Aperture value is f/7.1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F7p1_inline",
                   "",
            ],
            [
                   "F_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F8p0_inline",
                   "The Aperture value is f/8.",
            ],
            [
                   "The Aperture value is f/8.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F8p0_inline",
                   "",
            ],
            [
                   "F_9",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F9p0_inline",
                   "The Aperture value is f/9.",
            ],
            [
                   "The Aperture value is f/9.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F9p0_inline",
                   "",
            ],
            [
                   "F_9_DOT_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F9p6_inline",
                   "The Aperture value is f/9.6.",
            ],
            [
                   "The Aperture value is f/9.6.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F9p6_inline",
                   "",
            ],
            [
                   "F_10",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F10_inline",
                   "The Aperture value is f/10.",
            ],
            [
                   "The Aperture value is f/10.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F10_inline",
                   "",
            ],
            [
                   "F_11",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F11_inline",
                   "The Aperture value is f/11.",
            ],
            [
                   "The Aperture value is f/11.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F11_inline",
                   "",
            ],
            [
                   "F_13",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F13_inline",
                   "The Aperture value is f/13.",
            ],
            [
                   "The Aperture value is f/13.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F13_inline",
                   "",
            ],
            [
                   "F_14",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F14_inline",
                   "The Aperture value is f/14.",
            ],
            [
                   "The Aperture value is f/14.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F14_inline",
                   "",
            ],
            [
                   "F_16",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F16_inline",
                   "The Aperture value is f/16.",
            ],
            [
                   "The Aperture value is f/16.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F16_inline",
                   "",
            ],
            [
                   "F_18",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F18_inline",
                   "The Aperture value is f/18.",
            ],
            [
                   "The Aperture value is f/18.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F18_inline",
                   "",
            ],
            [
                   "F_19",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F19_inline",
                   "The Aperture value is f/19.",
            ],
            [
                   "The Aperture value is f/19.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F19_inline",
                   "",
            ],
            [
                   "F_20",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F20_inline",
                   "The Aperture value is f/20.",
            ],
            [
                   "The Aperture value is f/20.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F20_inline",
                   "",
            ],
            [
                   "F_22",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F22_inline",
                   "The Aperture value is f/22.",
            ],
            [
                   "The Aperture value is f/22.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F22_inline",
                   "",
            ],
            [
                   "F_25",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F25_inline",
                   "The Aperture value is f/25.",
            ],
            [
                   "The Aperture value is f/25.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F25_inline",
                   "",
            ],
            [
                   "F_28",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F28_inline",
                   "The Aperture value is f/28.",
            ],
            [
                   "The Aperture value is f/28.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F28_inline",
                   "",
            ],
            [
                   "F_32",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F32_inline",
                   "The Aperture value is f/32.",
            ],
            [
                   "The Aperture value is f/32.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F32_inline",
                   "",
            ],
            [
                   "F_37",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F37_inline",
                   "The Aperture value is f/37.",
            ],
            [
                   "The Aperture value is f/37.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F37_inline",
                   "",
            ],
            [
                   "F_41",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F41_inline",
                   "The Aperture value is f/41.",
            ],
            [
                   "The Aperture value is f/41.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F41_inline",
                   "",
            ],
            [
                   "F_45",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F45_inline",
                   "The Aperture value is f/45.",
            ],
            [
                   "The Aperture value is f/45.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F45_inline",
                   "",
            ],
            [
                   "F_52",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F52_inline",
                   "The Aperture value is f/52.",
            ],
            [
                   "The Aperture value is f/52.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F52_inline",
                   "",
            ],
            [
                   "F_58",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F58_inline",
                   "The Aperture value is f/58.",
            ],
            [
                   "The Aperture value is f/58.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F58_inline",
                   "",
            ],
            [
                   "F_64",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F64_inline",
                   "The Aperture value is f/64.",
            ],
            [
                   "The Aperture value is f/64.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_F64_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_Unknown_inline",
                   "The Aperture value is Unknown.",
            ],
            [
                   "The Aperture value is Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_Unknown_inline",
                   "",
            ],
            [
                   "getWhiteBalancePreset",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_preset_inline",
                   "The current preset for white balance.  @return White balance preset.",
            ],
            [
                   "The current preset for white balance.  @return White balance preset.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_preset_inline",
                   "",
            ],
            [
                   "getColorTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_colorTemperature_inline",
                   "The current setting for color temperature. Real color temperature value (K) = value * 100. For example, 50 -> 5000K.  @return Color temperature.",
            ],
            [
                   "The current setting for color temperature. Real color temperature value (K) = value * 100. For example, 50 -> 5000K.  @return Color temperature.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_colorTemperature_inline",
                   "",
            ],
            [
                   "WhiteBalance",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_initWithPreset_inline",
                   "Create a `WhiteBalance` instance with a white balance preset.  @param preset White balance preset that is not `CUSTOM`.",
            ],
            [
                   "Create a `WhiteBalance` instance with a white balance preset.  @param preset White balance preset that is not `CUSTOM`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_initWithPreset_inline",
                   "",
            ],
            [
                   "WhiteBalance",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_initWithCustomColorTemperature_inline",
                   "Create a `WhiteBalance` instance with white balance preset and temperature.  @param preset White balance preset. @param temperature Color temperature value to be set in the range of [20, 100]. Real color temperature value (K) = value * 100. For example, 50 -> 5000K.",
            ],
            [
                   "Create a `WhiteBalance` instance with white balance preset and temperature.  @param preset White balance preset. @param temperature Color temperature value to be set in the range of [20, 100]. Real color temperature value (K) = value * 100. For example, 50 -> 5000K.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "#DJICamera_DJICameraWhiteBalanceInterface_initWithCustomColorTemperature_inline",
                   "",
            ],
            [
                   "WatermarkSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_constructor_inline",
                   "Creates an instance of the settings to control the watermark on photos and videos.  @param enabledForVideos `true` if the watermark (timestamp and location stamp) is enabled for videos. @param enabledForPhotos `true` if the watermark (timestamp and location stamp) is enabled for photos.",
            ],
            [
                   "Creates an instance of the settings to control the watermark on photos and videos.  @param enabledForVideos `true` if the watermark (timestamp and location stamp) is enabled for videos. @param enabledForPhotos `true` if the watermark (timestamp and location stamp) is enabled for photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_constructor_inline",
                   "",
            ],
            [
                   "isEnabledForPhotos",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_enabledForPhotos_inline",
                   "`true` if the timestamp and the location stamp is added to photos.  @return `true` if the watermark (timestamp and location stamp) is enabled for photos.",
            ],
            [
                   "`true` if the timestamp and the location stamp is added to photos.  @return `true` if the watermark (timestamp and location stamp) is enabled for photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_enabledForPhotos_inline",
                   "",
            ],
            [
                   "isEnabledForVideos",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_enabledForVideos_inline",
                   "`true` if the timestamp and the location stamp is added to videos. The stamps are updated during the videos.  @return `true` if the watermark (timestamp and location stamp) is enabled for videos.",
            ],
            [
                   "`true` if the timestamp and the location stamp is added to videos. The stamps are updated during the videos.  @return `true` if the watermark (timestamp and location stamp) is enabled for videos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "#DJICamera_DJICameraWatermarkSettings_enabledForVideos_inline",
                   "",
            ],
            [
                   "getTargetLocation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetLocation_inline",
                   "Gets the target object's location measured by the laser sensor.  @return An object of `LocationCoordinate3D`.",
            ],
            [
                   "Gets the target object's location measured by the laser sensor.  @return An object of `LocationCoordinate3D`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetLocation_inline",
                   "",
            ],
            [
                   "getTargetDistance",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetDistance_inline",
                   "Gets the range to the target object.  @return A float value.",
            ],
            [
                   "Gets the range to the target object.  @return A float value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetDistance_inline",
                   "",
            ],
            [
                   "getTargetPoint",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetPoint_inline",
                   "Gets the relative target point base the lens origin point which measures by the laser sensor. The range for x and y is from 0 to 1000. The point [0, 0] represents the top-left angle of the screen.  @return An object of `PointF`.",
            ],
            [
                   "Gets the relative target point base the lens origin point which measures by the laser sensor. The range for x and y is from 0 to 1000. The point [0, 0] represents the top-left angle of the screen.  @return An object of `PointF`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_targetPoint_inline",
                   "",
            ],
            [
                   "getLaserError",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_error_inline",
                   "Gets the laser error from the laser sensor.  @return An object of `LaserError`.",
            ],
            [
                   "Gets the laser error from the laser sensor.  @return An object of `LaserError`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_error_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation_CallbackInterface.html",
                   "",
                   "Updates the laser sensor state information.",
            ],
            [
                   "Updates the laser sensor state information.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation_CallbackInterface.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_CallbackInterface_onUpdate_inline",
                   "Called when the laser sensor state information has been updated.  @param laserMeasureInformation An object of `LaserMeasureInformation`.",
            ],
            [
                   "Called when the laser sensor state information has been updated.  @param laserMeasureInformation An object of `LaserMeasureInformation`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation_CallbackInterface.html",
                   "#DJICamera_DJICameraLaserMeasureInformation_CallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "LaserError",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_inline",
                   "The enum class represents laser sensor's measuring state.",
            ],
            [
                   "The enum class represents laser sensor's measuring state.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_Normal_inline",
                   "The laser sensor's measuring state is normal.",
            ],
            [
                   "The laser sensor's measuring state is normal.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_Normal_inline",
                   "",
            ],
            [
                   "TOO_CLOSE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_TooClose_inline",
                   "The laser sensor is too close to the target object.",
            ],
            [
                   "The laser sensor is too close to the target object.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_TooClose_inline",
                   "",
            ],
            [
                   "TOO_FAR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_TooFar_inline",
                   "The laser sensor is too far away from the target object.",
            ],
            [
                   "The laser sensor is too far away from the target object.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_TooFar_inline",
                   "",
            ],
            [
                   "NO_SIGNAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_NoSignal_inline",
                   "The laser sensor has no data signal.",
            ],
            [
                   "The laser sensor has no data signal.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_NoSignal_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_Unknown_inline",
                   "Unknown State.",
            ],
            [
                   "Unknown State.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "#DJILaserError_Unknown_inline",
                   "",
            ],
            [
                   "shouldSaveOriginalPhotos",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_shouldSaveOriginalPhotos_inline",
                   "`true` if the camera should save the original photos.  @return `true` if the camera should save the original photos.",
            ],
            [
                   "`true` if the camera should save the original photos.  @return `true` if the camera should save the original photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_shouldSaveOriginalPhotos_inline",
                   "",
            ],
            [
                   "getFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_format_inline",
                   "The format for the original photos if the user decides to save them. Mavic Air cannot change this setting and it will ignore this property.  @return An enum value of `PhotoFileFormat`.",
            ],
            [
                   "The format for the original photos if the user decides to save them. Mavic Air cannot change this setting and it will ignore this property.  @return An enum value of `PhotoFileFormat`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_format_inline",
                   "",
            ],
            [
                   "OriginalPhotoSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_constructor_inline",
                   "Creates an instance of the configuration to decide whether or not to save the original photos or not. `getFormat` will be `JPEG`. Use this constructor for Mavic Air.  @param shouldSaveOriginalPhotos `true` to save the original photos.",
            ],
            [
                   "Creates an instance of the configuration to decide whether or not to save the original photos or not. `getFormat` will be `JPEG`. Use this constructor for Mavic Air.  @param shouldSaveOriginalPhotos `true` to save the original photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_constructor_inline",
                   "",
            ],
            [
                   "OriginalPhotoSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_constructorWithFormat_inline",
                   "Creates an instance of the configuration to decide whether or not to save the original photos and the format in which to save them.  @param shouldSaveOriginalPhotos `true` to save the original photos. @param format The format to save the original photos.",
            ],
            [
                   "Creates an instance of the configuration to decide whether or not to save the original photos and the format in which to save them.  @param shouldSaveOriginalPhotos `true` to save the original photos. @param format The format to save the original photos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "#DJICamera_DJICameraOriginalPhotoSettings_constructorWithFormat_inline",
                   "",
            ],
            [
                   "StoragePhotoCamerasParamBuilder",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings_StoragePhotoCamerasParamBuilder.html",
                   "",
                   "The builder of the MultispectralStoragePhotoSettings.",
            ],
            [
                   "The builder of the MultispectralStoragePhotoSettings.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings_StoragePhotoCamerasParamBuilder.html",
                   "",
                   "",
            ],
            [
                   "setIsStorageRgbCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRGB_inline",
                   "`true` if the photos in the RGB band sensor should be stored.  @param isStorageRgbCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the RGB band sensor should be stored.  @param isStorageRgbCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRGB_inline",
                   "",
            ],
            [
                   "setIsStorageBlueCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreBlue_inline",
                   "`true` if the photos in the blue spectrum band should be stored.  @param isStorageBlueCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the blue spectrum band should be stored.  @param isStorageBlueCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreBlue_inline",
                   "",
            ],
            [
                   "setIsStorageGreenCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreGreen_inline",
                   "`true` if the photos in the green spectrum band should be stored.  @param isStorageGreenCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the green spectrum band should be stored.  @param isStorageGreenCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreGreen_inline",
                   "",
            ],
            [
                   "setIsStorageRedCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRed_inline",
                   "`true` if the photos in the red spectrum band should be stored.  @param isStorageRedCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the red spectrum band should be stored.  @param isStorageRedCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRed_inline",
                   "",
            ],
            [
                   "setIsStorageNearInfraredCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreNearInfrared_inline",
                   "`true` if the photos in the near infrared spectrum band should be stored.  @param isStorageNearInfraredCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the near infrared spectrum band should be stored.  @param isStorageNearInfraredCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreNearInfrared_inline",
                   "",
            ],
            [
                   "setIsStorageRedEdgeCamera",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRedEdge_inline",
                   "`true` if the photos in the red edge spectrum band should be stored.  @param isStorageRedEdgeCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
            ],
            [
                   "`true` if the photos in the red edge spectrum band should be stored.  @param isStorageRedEdgeCamera A boolean value to set.  @return The builder of `StoragePhotoCamerasParamBuilder`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "#DJICamera_DJICameraMultispectralStorageSettings_shouldStoreRedEdge_inline",
                   "",
            ],
            [
                   "getSpectrumBand",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_band_inline",
                   "The spectrum for which this exposure state is.  @return An enum value of `SpectrumBand`.",
            ],
            [
                   "The spectrum for which this exposure state is.  @return An enum value of `SpectrumBand`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_band_inline",
                   "",
            ],
            [
                   "getShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_shutterSpeed_inline",
                   "The shutter speed of the single band sensor.  @return An enum value of `ShutterSpeed`.",
            ],
            [
                   "The shutter speed of the single band sensor.  @return An enum value of `ShutterSpeed`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_shutterSpeed_inline",
                   "",
            ],
            [
                   "getSensorGain",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_sensorGain_inline",
                   "The gain of the sensor.  @return A float value of sensor gain.",
            ],
            [
                   "The gain of the sensor.  @return A float value of sensor gain.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "#DJICamera_DJICameraMultispectralExposureState_sensorGain_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureStateCallbackInterface.html",
                   "",
                   "Called when the Multispectral camera's exposure state changes.",
            ],
            [
                   "Called when the Multispectral camera's exposure state changes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureStateCallbackInterface.html",
                   "#DJICamera_DJICameraMultispectralExposureState_OnUpdate_inline",
                   "Callback function that updates the Multispectral camera's exposure state.  @param multispectralExposureStates The Multispectral camera's exposure state array.",
            ],
            [
                   "Callback function that updates the Multispectral camera's exposure state.  @param multispectralExposureStates The Multispectral camera's exposure state array.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureStateCallbackInterface.html",
                   "#DJICamera_DJICameraMultispectralExposureState_OnUpdate_inline",
                   "",
            ],
            [
                   "getEquipmentLabel",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_equipmentLabel_inline",
                   "A single captical character represents the equipment. The possible value is from 'A' to 'Z'.  @return A string value of the equipment label.",
            ],
            [
                   "A single captical character represents the equipment. The possible value is from 'A' to 'Z'.  @return A string value of the equipment label.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_equipmentLabel_inline",
                   "",
            ],
            [
                   "getReelID",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_reelID_inline",
                   "The reel ID. The possible value is from 0 to 999.  @return An int value of the reel ID.",
            ],
            [
                   "The reel ID. The possible value is from 0 to 999.  @return An int value of the reel ID.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_reelID_inline",
                   "",
            ],
            [
                   "getClipID",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_clipID_inline",
                   "The clip ID. The possible value is from 0 to 999.  @return An int value of the clip ID.",
            ],
            [
                   "The clip ID. The possible value is from 0 to 999.  @return An int value of the clip ID.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_clipID_inline",
                   "",
            ],
            [
                   "SSDClipFileName",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_initWithEquipmentLabel_inline",
                   "Create a SSD clip name instance.  @param label The equipment label of the clip. The valid input is from 'A' to 'Z'. @param reelID The reel ID. The valid input is from 0 to 999. @param clipID The clip ID. The valid input is from 0 to 999.",
            ],
            [
                   "Create a SSD clip name instance.  @param label The equipment label of the clip. The valid input is from 'A' to 'Z'. @param reelID The reel ID. The valid input is from 0 to 999. @param clipID The clip ID. The valid input is from 0 to 999.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "#DJICamera_DJICameraSSDClipFileNameInterface_initWithEquipmentLabel_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Auto_inline",
                   "The camera's white balance is automatically set.",
            ],
            [
                   "The camera's white balance is automatically set.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Auto_inline",
                   "",
            ],
            [
                   "SUNNY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Sunny_inline",
                   "The camera's white balance is set to sunny.",
            ],
            [
                   "The camera's white balance is set to sunny.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Sunny_inline",
                   "",
            ],
            [
                   "CLOUDY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Cloudy_inline",
                   "The camera's white balance is set to cloudy.",
            ],
            [
                   "The camera's white balance is set to cloudy.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Cloudy_inline",
                   "",
            ],
            [
                   "WATER_SURFACE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_WaterSuface_inline",
                   "The camera's white balance is set to water surface.",
            ],
            [
                   "The camera's white balance is set to water surface.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_WaterSuface_inline",
                   "",
            ],
            [
                   "INDOOR_INCANDESCENT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_IndoorsIncandescent_inline",
                   "The camera's white balance is set to indoors and incandescent light.",
            ],
            [
                   "The camera's white balance is set to indoors and incandescent light.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_IndoorsIncandescent_inline",
                   "",
            ],
            [
                   "INDOOR_FLUORESCENT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_IndoorsFluorescent_inline",
                   "The camera's white balance is set to indoors and fluorescent light.",
            ],
            [
                   "The camera's white balance is set to indoors and fluorescent light.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_IndoorsFluorescent_inline",
                   "",
            ],
            [
                   "CUSTOM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_CustomColorTemperature_inline",
                   "The camera's white balance is set to custom color temperature. By using this white balance value, user can set a specific value for the color temperature.",
            ],
            [
                   "The camera's white balance is set to custom color temperature. By using this white balance value, user can set a specific value for the color temperature.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_CustomColorTemperature_inline",
                   "",
            ],
            [
                   "PRESET_NEUTRAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Neutral_inline",
                   "The camera's white balance is set to neutral. It is only supported by the X7.",
            ],
            [
                   "The camera's white balance is set to neutral. It is only supported by the X7.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Neutral_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Unknown_inline",
                   "The camera's white balance is unknown.",
            ],
            [
                   "The camera's white balance is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_Unknown_inline",
                   "",
            ],
            [
                   "CENTER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Center_inline",
                   "The camera's exposure metering is set to the center.",
            ],
            [
                   "The camera's exposure metering is set to the center.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Center_inline",
                   "",
            ],
            [
                   "AVERAGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Average_inline",
                   "The camera's exposure metering is set to average.",
            ],
            [
                   "The camera's exposure metering is set to average.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Average_inline",
                   "",
            ],
            [
                   "SPOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Spot_inline",
                   "The camera's exposure metering is set to a single spot.",
            ],
            [
                   "The camera's exposure metering is set to a single spot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Spot_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Unknown_inline",
                   "The camera's exposure metering is unknown.",
            ],
            [
                   "The camera's exposure metering is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_Unknown_inline",
                   "",
            ],
            [
                   "N_5_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N50_inline",
                   "The camera's exposure compensation is -5.0ev.",
            ],
            [
                   "The camera's exposure compensation is -5.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N50_inline",
                   "",
            ],
            [
                   "N_4_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N47_inline",
                   "The camera's exposure compensation is -4.7ev.",
            ],
            [
                   "The camera's exposure compensation is -4.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N47_inline",
                   "",
            ],
            [
                   "N_4_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N43_inline",
                   "The camera's exposure compensation is -4.3ev.",
            ],
            [
                   "The camera's exposure compensation is -4.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N43_inline",
                   "",
            ],
            [
                   "N_4_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N40_inline",
                   "The camera's exposure compensation is -4.0ev.",
            ],
            [
                   "The camera's exposure compensation is -4.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N40_inline",
                   "",
            ],
            [
                   "N_3_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N37_inline",
                   "The camera's exposure compensation is -3.7ev.",
            ],
            [
                   "The camera's exposure compensation is -3.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N37_inline",
                   "",
            ],
            [
                   "N_3_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N33_inline",
                   "The camera's exposure compensation is -3.3ev.",
            ],
            [
                   "The camera's exposure compensation is -3.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N33_inline",
                   "",
            ],
            [
                   "N_3_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N30_inline",
                   "The camera's exposure compensation is -3.0ev.",
            ],
            [
                   "The camera's exposure compensation is -3.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N30_inline",
                   "",
            ],
            [
                   "N_2_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N27_inline",
                   "The camera's exposure compensation is -2.7ev.",
            ],
            [
                   "The camera's exposure compensation is -2.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N27_inline",
                   "",
            ],
            [
                   "N_2_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N23_inline",
                   "The camera's exposure compensation is -2.3ev.",
            ],
            [
                   "The camera's exposure compensation is -2.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N23_inline",
                   "",
            ],
            [
                   "N_2_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N20_inline",
                   "The camera's exposure compensation is -2.0ev.",
            ],
            [
                   "The camera's exposure compensation is -2.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N20_inline",
                   "",
            ],
            [
                   "N_1_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N17_inline",
                   "The camera's exposure compensation is -1.7ev.",
            ],
            [
                   "The camera's exposure compensation is -1.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N17_inline",
                   "",
            ],
            [
                   "N_1_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N13_inline",
                   "The camera's exposure compensation is -1.3ev.",
            ],
            [
                   "The camera's exposure compensation is -1.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N13_inline",
                   "",
            ],
            [
                   "N_1_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N10_inline",
                   "The camera's exposure compensation is -1.0ev.",
            ],
            [
                   "The camera's exposure compensation is -1.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N10_inline",
                   "",
            ],
            [
                   "N_0_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N07_inline",
                   "The camera's exposure compensation is -0.7ev.",
            ],
            [
                   "The camera's exposure compensation is -0.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N07_inline",
                   "",
            ],
            [
                   "N_0_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N03_inline",
                   "The camera's exposure compensation is -0.3ev.",
            ],
            [
                   "The camera's exposure compensation is -0.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N03_inline",
                   "",
            ],
            [
                   "N_0_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N00_inline",
                   "The camera's exposure compensation is 0.0ev.",
            ],
            [
                   "The camera's exposure compensation is 0.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_N00_inline",
                   "",
            ],
            [
                   "P_0_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P03_inline",
                   "The camera's exposure compensation is +0.3ev.",
            ],
            [
                   "The camera's exposure compensation is +0.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P03_inline",
                   "",
            ],
            [
                   "P_0_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P07_inline",
                   "The camera's exposure compensation is +0.7ev.",
            ],
            [
                   "The camera's exposure compensation is +0.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P07_inline",
                   "",
            ],
            [
                   "P_1_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P10_inline",
                   "The camera's exposure compensation is +1.0ev.",
            ],
            [
                   "The camera's exposure compensation is +1.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P10_inline",
                   "",
            ],
            [
                   "P_1_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P13_inline",
                   "The camera's exposure compensation is +1.3ev.",
            ],
            [
                   "The camera's exposure compensation is +1.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P13_inline",
                   "",
            ],
            [
                   "P_1_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P17_inline",
                   "The camera's exposure compensation is +1.7ev.",
            ],
            [
                   "The camera's exposure compensation is +1.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P17_inline",
                   "",
            ],
            [
                   "P_2_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P20_inline",
                   "The camera's exposure compensation is +2.0ev.",
            ],
            [
                   "The camera's exposure compensation is +2.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P20_inline",
                   "",
            ],
            [
                   "P_2_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P23_inline",
                   "The camera's exposure compensation is +2.3ev.",
            ],
            [
                   "The camera's exposure compensation is +2.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P23_inline",
                   "",
            ],
            [
                   "P_2_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P27_inline",
                   "The camera's exposure compensation is +2.7ev.",
            ],
            [
                   "The camera's exposure compensation is +2.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P27_inline",
                   "",
            ],
            [
                   "P_3_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P30_inline",
                   "The camera's exposure compensation is +3.0ev.",
            ],
            [
                   "The camera's exposure compensation is +3.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P30_inline",
                   "",
            ],
            [
                   "P_3_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P33_inline",
                   "The camera's exposure compensation is +3.3ev.",
            ],
            [
                   "The camera's exposure compensation is +3.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P33_inline",
                   "",
            ],
            [
                   "P_3_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P37_inline",
                   "The camera's exposure compensation is +3.7ev.",
            ],
            [
                   "The camera's exposure compensation is +3.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P37_inline",
                   "",
            ],
            [
                   "P_4_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P40_inline",
                   "The camera's exposure compensation is +4.0ev.",
            ],
            [
                   "The camera's exposure compensation is +4.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P40_inline",
                   "",
            ],
            [
                   "P_4_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P43_inline",
                   "The camera's exposure compensation is +4.3ev.",
            ],
            [
                   "The camera's exposure compensation is +4.3ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P43_inline",
                   "",
            ],
            [
                   "P_4_7",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P47_inline",
                   "The camera's exposure compensation is +4.7ev.",
            ],
            [
                   "The camera's exposure compensation is +4.7ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P47_inline",
                   "",
            ],
            [
                   "P_5_0",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P50_inline",
                   "The camera's exposure compensation is +5.0ev.",
            ],
            [
                   "The camera's exposure compensation is +5.0ev.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_P50_inline",
                   "",
            ],
            [
                   "FIXED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_Fixed_inline",
                   "The camera's exposure compensation is fixed by the camera.",
            ],
            [
                   "The camera's exposure compensation is fixed by the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_Fixed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_Unknown_inline",
                   "The camera's exposure compensation is unknown.",
            ],
            [
                   "The camera's exposure compensation is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_Unknown_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Auto_inline",
                   "The camera's anti-flicker is automatically set. It is not supported by Z30 camera.",
            ],
            [
                   "The camera's anti-flicker is automatically set. It is not supported by Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Auto_inline",
                   "",
            ],
            [
                   "MANUAL_60HZ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_60Hz_inline",
                   "The camera's anti-flicker is 60 Hz.",
            ],
            [
                   "The camera's anti-flicker is 60 Hz.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_60Hz_inline",
                   "",
            ],
            [
                   "MANUAL_50HZ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_50Hz_inline",
                   "The camera's anti-flicker is 50 Hz.",
            ],
            [
                   "The camera's anti-flicker is 50 Hz.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_50Hz_inline",
                   "",
            ],
            [
                   "DISABLED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Disabled_inline",
                   "The anti-flicker is disabled. Only supported by Mavic Air.",
            ],
            [
                   "The anti-flicker is disabled. Only supported by Mavic Air.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Disabled_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Unknown_inline",
                   "The camera's anti-flicker is unknown.",
            ],
            [
                   "The camera's anti-flicker is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_Unknown_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Normal_inline",
                   "The camera exposure state is normal.",
            ],
            [
                   "The camera exposure state is normal.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Normal_inline",
                   "",
            ],
            [
                   "UNDEREXPOSED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Underexposed_inline",
                   "The camera exposure state is underexposed.",
            ],
            [
                   "The camera exposure state is underexposed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Underexposed_inline",
                   "",
            ],
            [
                   "OVEREXPOSED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Overexposed_inline",
                   "The camera exposure state is overexposed.",
            ],
            [
                   "The camera exposure state is overexposed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Overexposed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Unknown_inline",
                   "The camera exposure state is unknown.",
            ],
            [
                   "The camera exposure state is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_Unknown_inline",
                   "",
            ],
            [
                   "getAperture",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_aperture_inline",
                   "Returns the current aperture value being used by the camera. A larger aperture results in a higher exposure and shallower depth of field. For cameras that do not support adjustable aperture (e.g. Zenmuse X3), the real aperture value is fixed.  @return The enum value of `Aperture`",
            ],
            [
                   "Returns the current aperture value being used by the camera. A larger aperture results in a higher exposure and shallower depth of field. For cameras that do not support adjustable aperture (e.g. Zenmuse X3), the real aperture value is fixed.  @return The enum value of `Aperture`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_aperture_inline",
                   "",
            ],
            [
                   "getShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_shutterSpeed_inline",
                   "Returns the current shutter speed being used by the camera. A slower shutter speed results in a higher exposure, but more blurring in areas of the scene that are moving.  @return The enum value of `ShutterSpeed`",
            ],
            [
                   "Returns the current shutter speed being used by the camera. A slower shutter speed results in a higher exposure, but more blurring in areas of the scene that are moving.  @return The enum value of `ShutterSpeed`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_shutterSpeed_inline",
                   "",
            ],
            [
                   "getISO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_iso_inline",
                   "Returns the current ISO value being used by the camera. `ISO` defines the number of the ISO values separated by one exposure stop. However, when the ISO is in automatic mode, the camera can select ISO values less than one stop apart, and therefore this property is the actual ISO value being used by the camera. A higher ISO results in a higher exposure, and more noise in the resulting image.  @return The enum value of `ISO`",
            ],
            [
                   "Returns the current ISO value being used by the camera. `ISO` defines the number of the ISO values separated by one exposure stop. However, when the ISO is in automatic mode, the camera can select ISO values less than one stop apart, and therefore this property is the actual ISO value being used by the camera. A higher ISO results in a higher exposure, and more noise in the resulting image.  @return The enum value of `ISO`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_iso_inline",
                   "",
            ],
            [
                   "getExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_exposureCompensation_inline",
                   "Returns the camera's current exposure compensation. In Program, Aperture Priority and Shutter Priority modes, the exposure compensation value changes the exposure target the camera is using to calculate correct exposure and is set by the user. For example, Aperture Priority mode indicates that the priority is to maintain the aperture setting and adjusting the exposure by varying the ISO and shutter speed. In Manual mode, this value is reported from the camera and reports how much the  exposure needs to be compensated for to get to what the camera thinks is the correct exposure. In Manual mode, the range of exposure compensation reported by the camera is -2.0 EV to 2.0 EV. In Program, Aperture Priority and Shutter Priority modes, the range of exposure compensation is -3.0 EV to + 3.0 EV. For the Z30 camera in manual mode, exposureCompensation is not used and the value is always 'DJICameraExposureCompensationN00'.  @return The enum value of `ExposureCompensation`",
            ],
            [
                   "Returns the camera's current exposure compensation. In Program, Aperture Priority and Shutter Priority modes, the exposure compensation value changes the exposure target the camera is using to calculate correct exposure and is set by the user. For example, Aperture Priority mode indicates that the priority is to maintain the aperture setting and adjusting the exposure by varying the ISO and shutter speed. In Manual mode, this value is reported from the camera and reports how much the  exposure needs to be compensated for to get to what the camera thinks is the correct exposure. In Manual mode, the range of exposure compensation reported by the camera is -2.0 EV to 2.0 EV. In Program, Aperture Priority and Shutter Priority modes, the range of exposure compensation is -3.0 EV to + 3.0 EV. For the Z30 camera in manual mode, exposureCompensation is not used and the value is always 'DJICameraExposureCompensationN00'.  @return The enum value of `ExposureCompensation`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "#DJICamera_DJICameraExposureParameters_exposureCompensation_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Manual_inline",
                   "The camera's focus mode is set to manual. In this mode, user sets the focus ring value to adjust the focal distance.",
            ],
            [
                   "The camera's focus mode is set to manual. In this mode, user sets the focus ring value to adjust the focal distance.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Manual_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Auto_inline",
                   "The camera's focus mode is set to auto. For the Z30 camera, the focus is calculated completely automatically. For all other cameras, a focus target can be set by the user, which is used to calculate focus automatically.",
            ],
            [
                   "The camera's focus mode is set to auto. For the Z30 camera, the focus is calculated completely automatically. For all other cameras, a focus target can be set by the user, which is used to calculate focus automatically.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Auto_inline",
                   "",
            ],
            [
                   "AFC",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_AFC_inline",
                   "The camera's focus mode is set to Continuous AF. It is only supported by Mavic Pro with firmware version V01.03.0000 or above, X4S camera, Mavic 2 Zoom camera and Mavic 2 Pro camera, DJI Air 2S.",
            ],
            [
                   "The camera's focus mode is set to Continuous AF. It is only supported by Mavic Pro with firmware version V01.03.0000 or above, X4S camera, Mavic 2 Zoom camera and Mavic 2 Pro camera, DJI Air 2S.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_AFC_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Unknown_inline",
                   "The camera's focus mode is unknown.",
            ],
            [
                   "The camera's focus mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_Unknown_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Idle_inline",
                   "The lens is idle. No focus target has been set.",
            ],
            [
                   "The lens is idle. No focus target has been set.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Idle_inline",
                   "",
            ],
            [
                   "FOCUSING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Focusing_inline",
                   "The lens is focusing on the target.",
            ],
            [
                   "The lens is focusing on the target.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Focusing_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Success_inline",
                   "The lens succeeded to focus on the target.",
            ],
            [
                   "The lens succeeded to focus on the target.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Success_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Failure_inline",
                   "The lens failed to focus on the target. This happens when the target is too close, or the camera cannot distinguish the object to focus (e.g. a white wall).",
            ],
            [
                   "The lens failed to focus on the target. This happens when the target is too close, or the camera cannot distinguish the object to focus (e.g. a white wall).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Failure_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Unknown_inline",
                   "The lens focus status is unknown.",
            ],
            [
                   "The lens focus status is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_Unknown_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Idle_inline",
                   "Not in sensor cleaning mode.",
            ],
            [
                   "Not in sensor cleaning mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Idle_inline",
                   "",
            ],
            [
                   "INITIATING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Initiating_inline",
                   "The camera is initiating sensor cleaning mode.",
            ],
            [
                   "The camera is initiating sensor cleaning mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Initiating_inline",
                   "",
            ],
            [
                   "WAITING_FOR_LENS_REMOVAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_WaitingForLensRemoval_inline",
                   "Remove the lens from the camera to continue cleaning operation.",
            ],
            [
                   "Remove the lens from the camera to continue cleaning operation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_WaitingForLensRemoval_inline",
                   "",
            ],
            [
                   "READY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Ready_inline",
                   "The camera is ready to start the sensor cleaning. Call `startSensorCleaning` to start the operation.",
            ],
            [
                   "The camera is ready to start the sensor cleaning. Call `startSensorCleaning` to start the operation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Ready_inline",
                   "",
            ],
            [
                   "CLEANING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Cleaning_inline",
                   "The camera is executing sensor cleaning.",
            ],
            [
                   "The camera is executing sensor cleaning.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Cleaning_inline",
                   "",
            ],
            [
                   "FINISHING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Finishing_inline",
                   "The sensor cleaning process is finishing. No action is required in this state and the state will change to `WAITING_FOR_LENS_REMOUNT` automatically.",
            ],
            [
                   "The sensor cleaning process is finishing. No action is required in this state and the state will change to `WAITING_FOR_LENS_REMOUNT` automatically.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_Finishing_inline",
                   "",
            ],
            [
                   "WAITING_FOR_LENS_REMOUNT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_WaitingForLensRemount_inline",
                   "The sensor cleaning is finished and the camera is waiting for the lens to be remounted. When the lens is mounted, the state will change to `IDLE`.",
            ],
            [
                   "The sensor cleaning is finished and the camera is waiting for the lens to be remounted. When the lens is mounted, the state will change to `IDLE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_WaitingForLensRemount_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_unknown_inline",
                   "",
            ],
            [
                   "isEnabledMF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "#DJICamera_DJICameraFocusAssistantSettings_enabledForMF_inline",
                   "`true` if the lens focus assistant is enabled for Manual Focusing.  @return `true` if MF is enabled.",
            ],
            [
                   "`true` if the lens focus assistant is enabled for Manual Focusing.  @return `true` if MF is enabled.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "#DJICamera_DJICameraFocusAssistantSettings_enabledForMF_inline",
                   "",
            ],
            [
                   "isEnabledAF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "#DJICamera_DJICameraFocusAssistantSettings_enabledForAF_inline",
                   "`true` if the lens focus assistant is enabled for Auto Focusing.  @return true if AF is enabled.",
            ],
            [
                   "`true` if the lens focus assistant is enabled for Auto Focusing.  @return true if AF is enabled.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "#DJICamera_DJICameraFocusAssistantSettings_enabledForAF_inline",
                   "",
            ],
            [
                   "NOT_FOUND",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_NotFound_inline",
                   "SSD is not found.",
            ],
            [
                   "SSD is not found.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_NotFound_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Idle_inline",
                   "SSD is idle.",
            ],
            [
                   "SSD is idle.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Idle_inline",
                   "",
            ],
            [
                   "SAVING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Saving_inline",
                   "SSD is Saving.",
            ],
            [
                   "SSD is Saving.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Saving_inline",
                   "",
            ],
            [
                   "FORMATTING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Formatting_inline",
                   "SSD is formatting.",
            ],
            [
                   "SSD is formatting.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Formatting_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Initializing_inline",
                   "SSD is initializing.",
            ],
            [
                   "SSD is initializing.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Initializing_inline",
                   "",
            ],
            [
                   "ERROR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Error_inline",
                   "SSD validation error.",
            ],
            [
                   "SSD validation error.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Error_inline",
                   "",
            ],
            [
                   "FULL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Full_inline",
                   "SSD is full.",
            ],
            [
                   "SSD is full.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Full_inline",
                   "",
            ],
            [
                   "POOR_CONNECTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_PoorConnection_inline",
                   "Communication to SSD is not stable. User can re-plugin SSD. It is supported by X5S.",
            ],
            [
                   "Communication to SSD is not stable. User can re-plugin SSD. It is supported by X5S.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_PoorConnection_inline",
                   "",
            ],
            [
                   "SWITCHING_LICENSE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_SwitchingLicense_inline",
                   "SSD is switching the license key. It is supported by X5S.",
            ],
            [
                   "SSD is switching the license key. It is supported by X5S.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_SwitchingLicense_inline",
                   "",
            ],
            [
                   "FORMATTING_REQUIRED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_FormattingRequired_inline",
                   "Formatting is required. It is supported by X5S.",
            ],
            [
                   "Formatting is required. It is supported by X5S.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_FormattingRequired_inline",
                   "",
            ],
            [
                   "NOT_INITIALIZED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_NotInitialized_inline",
                   "Not initialized yet. It is supported by X7.",
            ],
            [
                   "Not initialized yet. It is supported by X7.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_NotInitialized_inline",
                   "",
            ],
            [
                   "INVALID_FILE_SYSTEM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_InvalidFileSystem_inline",
                   "The file system is not supported. It is supported by X7.",
            ],
            [
                   "The file system is not supported. It is supported by X7.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_InvalidFileSystem_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Unknown_inline",
                   "SSD state is unknown. This happens in the first 2 seconds after turning the camera power on as during this time the camera cannot check the state of the SSD.",
            ],
            [
                   "SSD state is unknown. This happens in the first 2 seconds after turning the camera power on as during this time the camera cannot check the state of the SSD.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_Unknown_inline",
                   "",
            ],
            [
                   "CAPACITY_256_GB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_256G_inline",
                   "SSD capacity is 256G.",
            ],
            [
                   "SSD capacity is 256G.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_256G_inline",
                   "",
            ],
            [
                   "CAPACITY_512_GB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_512G_inline",
                   "SSD capacity is 512G.",
            ],
            [
                   "SSD capacity is 512G.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_512G_inline",
                   "",
            ],
            [
                   "CAPACITY_1_TB",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_1T_inline",
                   "SSD capacity is 1T.",
            ],
            [
                   "SSD capacity is 1T.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_1T_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_Unknown_inline",
                   "SSD capacity is unknown.",
            ],
            [
                   "SSD capacity is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_Unknown_inline",
                   "",
            ],
            [
                   "LicenseKeyTypeCinemaDNG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseCinemaDNG_inline",
                   "CinemaDNG.",
            ],
            [
                   "CinemaDNG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseCinemaDNG_inline",
                   "",
            ],
            [
                   "LicenseKeyTypeProRes422HQ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseProRes422HQ_inline",
                   "Apple ProRes 422 HQ.",
            ],
            [
                   "Apple ProRes 422 HQ.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseProRes422HQ_inline",
                   "",
            ],
            [
                   "LicenseKeyTypeProRes4444XQ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseProRes4444XQ_inline",
                   "Apple ProRes 4444 XQ(no alpha).",
            ],
            [
                   "Apple ProRes 4444 XQ(no alpha).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseProRes4444XQ_inline",
                   "",
            ],
            [
                   "Unknown",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseUnknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicenseUnknown_inline",
                   "",
            ],
            [
                   "FULL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_Full_inline",
                   "Causes the color spectrum to be evenly distributed across the entire image depending the default settings.",
            ],
            [
                   "Causes the color spectrum to be evenly distributed across the entire image depending the default settings.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_Full_inline",
                   "",
            ],
            [
                   "SKY_EXCLUDED_33",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_SkyExluded33_inline",
                   "Ignores areas of the sky 33% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
            ],
            [
                   "Ignores areas of the sky 33% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_SkyExluded33_inline",
                   "",
            ],
            [
                   "SKY_EXCLUDED_50",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_SkyExcluded50_inline",
                   "Ignores areas of the sky 50% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
            ],
            [
                   "Ignores areas of the sky 50% so that most of the spectrum can be allocated to remaining areas, providing higher contrast and utility for analysis.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_SkyExcluded50_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_Unknown_inline",
                   "The ROI type is unknown.",
            ],
            [
                   "The ROI type is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_Unknown_inline",
                   "",
            ],
            [
                   "WHITE_HOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_WhiteHot_inline",
                   "Without Isotherm enabled, the Palette type is WhiteHot. With Isotherm enabled, the Palette type is WhiteHotIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is WhiteHot. With Isotherm enabled, the Palette type is WhiteHotIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_WhiteHot_inline",
                   "",
            ],
            [
                   "BLACK_HOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_BlackHot_inline",
                   "Without Isotherm enabled, the Palette type is BlackHot. With Isotherm enabled, the Palette type is BlackHotIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is BlackHot. With Isotherm enabled, the Palette type is BlackHotIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_BlackHot_inline",
                   "",
            ],
            [
                   "RED_HOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_RedHot_inline",
                   "Without Isotherm enabled, the Palette type is RedHot. With Isotherm enabled, the Palette type is RedHotIso. Shown as Tint in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is RedHot. With Isotherm enabled, the Palette type is RedHotIso. Shown as Tint in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_RedHot_inline",
                   "",
            ],
            [
                   "GREEN_HOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_GreenHot_inline",
                   "Without Isotherm enabled, the Palette type is GreenHot. With Isotherm enabled, the Palette type is GreenHotIso. Shown as Medical in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is GreenHot. With Isotherm enabled, the Palette type is GreenHotIso. Shown as Medical in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_GreenHot_inline",
                   "",
            ],
            [
                   "FUSION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Fusion_inline",
                   "Without Isotherm enabled, the Palette type is Fusion. With Isotherm enabled, the Palette type is FusionIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Fusion. With Isotherm enabled, the Palette type is FusionIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Fusion_inline",
                   "",
            ],
            [
                   "RAINBOW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rainbow_inline",
                   "Without Isotherm enabled, the Palette type is Rainbow. With Isotherm enabled, the Palette type is RainbowIso.  Shown as Rainbow1 in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Rainbow. With Isotherm enabled, the Palette type is RainbowIso.  Shown as Rainbow1 in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rainbow_inline",
                   "",
            ],
            [
                   "IRONBOW_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Ironbow1_inline",
                   "Without Isotherm enabled, the Palette type is Ironbow1. With Isotherm enabled, the Palette type is IronbowWHIso. Shown as IronRed in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Ironbow1. With Isotherm enabled, the Palette type is IronbowWHIso. Shown as IronRed in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Ironbow1_inline",
                   "",
            ],
            [
                   "IRONBOW_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Ironbow2_inline",
                   "Without Isotherm enabled, the Palette type is Ironbow2. With Isotherm enabled, the Palette type is IronbowBHIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Ironbow2. With Isotherm enabled, the Palette type is IronbowBHIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Ironbow2_inline",
                   "",
            ],
            [
                   "ICE_FIRE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_IceFire_inline",
                   "Without Isotherm enabled, the Palette type is IceFire. With Isotherm enabled, the Palette type is IceFireIso. Shown as Arctic in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is IceFire. With Isotherm enabled, the Palette type is IceFireIso. Shown as Arctic in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_IceFire_inline",
                   "",
            ],
            [
                   "SEPIA",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Sepia_inline",
                   "Without Isotherm enabled, the Palette type is Sepia. With Isotherm enabled, the Palette type is SepiaIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Sepia. With Isotherm enabled, the Palette type is SepiaIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Sepia_inline",
                   "",
            ],
            [
                   "GLOWBOW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Glowbow_inline",
                   "Without Isotherm enabled, the Palette type is Glowbow. With Isotherm enabled, the Palette type is GlowbowIso.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Glowbow. With Isotherm enabled, the Palette type is GlowbowIso.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Glowbow_inline",
                   "",
            ],
            [
                   "COLOR_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Color1_inline",
                   "Without Isotherm enabled, the Palette type is Color1. With Isotherm enabled, the Palette type is MidRangeWHIso. Shown as Fulgurite in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Color1. With Isotherm enabled, the Palette type is MidRangeWHIso. Shown as Fulgurite in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Color1_inline",
                   "",
            ],
            [
                   "COLOR_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Color2_inline",
                   "Without Isotherm enabled, the Palette type is Color2. With Isotherm enabled, the Palette type is MidRangeBHIso. Shown as HotIron in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Color2. With Isotherm enabled, the Palette type is MidRangeBHIso. Shown as HotIron in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Color2_inline",
                   "",
            ],
            [
                   "RAIN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rain_inline",
                   "Without Isotherm enabled, the Palette type is Rain. With Isotherm enabled, the Palette type is RainbowHCIso. Shown as Rainbow2 in DJI Pilot.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Rain. With Isotherm enabled, the Palette type is RainbowHCIso. Shown as Rainbow2 in DJI Pilot.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rain_inline",
                   "",
            ],
            [
                   "HOT_SPOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_HotSpot_inline",
                   "Without Isotherm enabled, the Palette type is HotSpot. With Isotherm enabled, the Palette type is HotSpotIso. Only supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is HotSpot. With Isotherm enabled, the Palette type is HotSpotIso. Only supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_HotSpot_inline",
                   "",
            ],
            [
                   "RAINBOW2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rainbow2_inline",
                   "Without Isotherm enabled, the Palette type is Rainbow2. With Isotherm enabled, the Palette type is Rainbow2Iso. Only supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Rainbow2. With Isotherm enabled, the Palette type is Rainbow2Iso. Only supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Rainbow2_inline",
                   "",
            ],
            [
                   "GRAY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Gray_inline",
                   "Without Isotherm enabled, the Palette type is Gray. With Isotherm enabled, the Palette type is GrayIso. Only supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is Gray. With Isotherm enabled, the Palette type is GrayIso. Only supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Gray_inline",
                   "",
            ],
            [
                   "HOT_METAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_HotMetal_inline",
                   "Without Isotherm enabled, the Palette type is HotMetal. With Isotherm enabled, the Palette type is HotMetalIso. Only supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is HotMetal. With Isotherm enabled, the Palette type is HotMetalIso. Only supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_HotMetal_inline",
                   "",
            ],
            [
                   "COLD_SPOT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_ColdSpot_inline",
                   "Without Isotherm enabled, the Palette type is ColdSpot. With Isotherm enabled, the Palette type is ColdSpotIso. Only supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Without Isotherm enabled, the Palette type is ColdSpot. With Isotherm enabled, the Palette type is ColdSpotIso. Only supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_ColdSpot_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Unknown_inline",
                   "The palette type is unknown.",
            ],
            [
                   "The palette type is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_Unknown_inline",
                   "",
            ],
            [
                   "LINEAR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Linear_inline",
                   "Linearly transforms the 14-bit sensor pixel data to 8-bit JPEG/MP4 pixel data.",
            ],
            [
                   "Linearly transforms the 14-bit sensor pixel data to 8-bit JPEG/MP4 pixel data.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Linear_inline",
                   "",
            ],
            [
                   "DEFAULT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Default_inline",
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast.",
            ],
            [
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Default_inline",
                   "",
            ],
            [
                   "SEA_SKY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_SeaSky_inline",
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for scenes composed of the sea and the sky scenes.",
            ],
            [
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for scenes composed of the sea and the sky scenes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_SeaSky_inline",
                   "",
            ],
            [
                   "OUTDOOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Outdoor_inline",
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for outdoor scenes.",
            ],
            [
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for outdoor scenes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Outdoor_inline",
                   "",
            ],
            [
                   "INDOOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Indoor_inline",
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for indoor scenes.",
            ],
            [
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for indoor scenes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Indoor_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Manual_inline",
                   "Allows manual setting of DDE, ACE, SSO, brightness and contrast.",
            ],
            [
                   "Allows manual setting of DDE, ACE, SSO, brightness and contrast.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Manual_inline",
                   "",
            ],
            [
                   "PROFILE_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User1_inline",
                   "First saved settings of DDE, ACE, SSO, brightness and contrast.",
            ],
            [
                   "First saved settings of DDE, ACE, SSO, brightness and contrast.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User1_inline",
                   "",
            ],
            [
                   "PROFILE_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User2_inline",
                   "Second saved settings of DDE, ACE, SSO, brightness and contrast.",
            ],
            [
                   "Second saved settings of DDE, ACE, SSO, brightness and contrast.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User2_inline",
                   "",
            ],
            [
                   "PROFILE_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User3_inline",
                   "Third saved settings of DDE, ACE, SSO, brightness and contrast.",
            ],
            [
                   "Third saved settings of DDE, ACE, SSO, brightness and contrast.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_User3_inline",
                   "",
            ],
            [
                   "INSPECTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Inspection_inline",
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for inspection scenes.",
            ],
            [
                   "Automatically adjusts DDE, ACE, SSO, brightness and contrast with presets optimized for inspection scenes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Inspection_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Unknown_inline",
                   "The Scene type is unknown.",
            ],
            [
                   "The Scene type is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_Unknown_inline",
                   "",
            ],
            [
                   "PERCENTAGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Percentage_inline",
                   "The unit type is percentage. The allowed range is [0, 100].",
            ],
            [
                   "The unit type is percentage. The allowed range is [0, 100].",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Percentage_inline",
                   "",
            ],
            [
                   "CELSIUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Celsius_inline",
                   "The unit type is degrees Celsius. The allowed range is [-40, 1000].",
            ],
            [
                   "The unit type is degrees Celsius. The allowed range is [-40, 1000].",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Celsius_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Unknown_inline",
                   "The unit type is unknown.",
            ],
            [
                   "The unit type is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_Unknown_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Auto_inline",
                   "The camera will automatically select the optimal gain mode according to the temperature range of the image.",
            ],
            [
                   "The camera will automatically select the optimal gain mode according to the temperature range of the image.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Auto_inline",
                   "",
            ],
            [
                   "LOW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Low_inline",
                   "The camera covers a wider temperature range but is less sensitive to temperature differences.",
            ],
            [
                   "The camera covers a wider temperature range but is less sensitive to temperature differences.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Low_inline",
                   "",
            ],
            [
                   "HIGH",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_High_inline",
                   "The camera covers a smaller temperature range but is more sensitive to temperature differences.",
            ],
            [
                   "The camera covers a smaller temperature range but is more sensitive to temperature differences.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_High_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Unknown_inline",
                   "The gain mode is unknown.",
            ],
            [
                   "The gain mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_Unknown_inline",
                   "",
            ],
            [
                   "RESOLUTION_336x256",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_336x256_inline",
                   "The thermal imaging camera resolution is 336x256.",
            ],
            [
                   "The thermal imaging camera resolution is 336x256.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_336x256_inline",
                   "",
            ],
            [
                   "RESOLUTION_640x512",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_640x512_inline",
                   "The thermal imaging camera resolution is 640x512.",
            ],
            [
                   "The thermal imaging camera resolution is 640x512.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_640x512_inline",
                   "",
            ],
            [
                   "RESOLUTION_384x288",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_384x288_inline",
                   "The thermal imaging camera resolution is 384x288.",
            ],
            [
                   "The thermal imaging camera resolution is 384x288.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_384x288_inline",
                   "",
            ],
            [
                   "RESOLUTION_1024x768",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_1024x768_inline",
                   "The thermal imaging camera resolution is 1024x768.",
            ],
            [
                   "The thermal imaging camera resolution is 1024x768.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_1024x768_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_Unknown_inline",
                   "The thermal imaging camera resolution is unknown.",
            ],
            [
                   "The thermal imaging camera resolution is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_Unknown_inline",
                   "",
            ],
            [
                   "UPPER_BOUND_8_DOT_3_HZ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_8p3Hz_inline",
                   "The thermal imaging camera frame rate upper bound is 8.3Hz.",
            ],
            [
                   "The thermal imaging camera frame rate upper bound is 8.3Hz.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_8p3Hz_inline",
                   "",
            ],
            [
                   "UPPER_BOUND_30_HZ",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_30Hz_inline",
                   "The thermal imaging camera frame rate upper bound is 30Hz.",
            ],
            [
                   "The thermal imaging camera frame rate upper bound is 30Hz.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_30Hz_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_Unknown_inline",
                   "The thermal imaging camera frame rate upper bound is unknown.",
            ],
            [
                   "The thermal imaging camera frame rate upper bound is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_Unknown_inline",
                   "",
            ],
            [
                   "LENGTH_6_DOT_8_MM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_6p8mm_inline",
                   "The thermal imaging camera's lens focal length is 6.8 mm.",
            ],
            [
                   "The thermal imaging camera's lens focal length is 6.8 mm.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_6p8mm_inline",
                   "",
            ],
            [
                   "LENGTH_7_DOT_5_MM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_7p5mm_inline",
                   "The thermal imaging camera lens focal length is 7.5mm.",
            ],
            [
                   "The thermal imaging camera lens focal length is 7.5mm.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_7p5mm_inline",
                   "",
            ],
            [
                   "LENGTH_9_MM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_9mm_inline",
                   "The thermal imaging camera's lens focal length is 9 mm.",
            ],
            [
                   "The thermal imaging camera's lens focal length is 9 mm.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_9mm_inline",
                   "",
            ],
            [
                   "LENGTH_13_MM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_13mm_inline",
                   "The thermal imaging camera's lens focal length is 13 mm.",
            ],
            [
                   "The thermal imaging camera's lens focal length is 13 mm.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_13mm_inline",
                   "",
            ],
            [
                   "LENGTH_19_MM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_19mm_inline",
                   "The thermal imaging camera's lens focal length is 19 mm.",
            ],
            [
                   "The thermal imaging camera's lens focal length is 19 mm.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_19mm_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_Unknown_inline",
                   "The thermal imaging camera's lens focal length is unknown.",
            ],
            [
                   "The thermal imaging camera's lens focal length is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_Unknown_inline",
                   "",
            ],
            [
                   "XT_STANDARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_XTStandard_inline",
                   "The thermal camera is Zenmuse XT Standard version.",
            ],
            [
                   "The thermal camera is Zenmuse XT Standard version.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_XTStandard_inline",
                   "",
            ],
            [
                   "XT_ADVANCED_RADIOMETRY_ENABLED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_XTAdvancedRadiometry_inline",
                   "The thermal camera is Zenmuse XT Advanced Radiometry version.",
            ],
            [
                   "The thermal camera is Zenmuse XT Advanced Radiometry version.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_XTAdvancedRadiometry_inline",
                   "",
            ],
            [
                   "PROFILE_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile1_inline",
                   "Custom thermal external scene settings for user 1.",
            ],
            [
                   "Custom thermal external scene settings for user 1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile1_inline",
                   "",
            ],
            [
                   "PROFILE_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile2_inline",
                   "Custom thermal external scene settings for user 2.",
            ],
            [
                   "Custom thermal external scene settings for user 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile2_inline",
                   "",
            ],
            [
                   "PROFILE_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile3_inline",
                   "Custom thermal external scene settings for user 3.",
            ],
            [
                   "Custom thermal external scene settings for user 3.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_Profile3_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_ProfileUnknown_inline",
                   "The user is unknown.",
            ],
            [
                   "The user is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_ProfileUnknown_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Auto_inline",
                   "Automatic flat-field correction mode.",
            ],
            [
                   "Automatic flat-field correction mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Auto_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Manual_inline",
                   "Manual flat-field correction mode.",
            ],
            [
                   "Manual flat-field correction mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Manual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Unknown_inline",
                   "Unknown flat-field correction mode.",
            ],
            [
                   "Unknown flat-field correction mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_Unknown_inline",
                   "",
            ],
            [
                   "getResolution",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_resolution_inline",
                   "Get the supported resolution of the thermal imaging camera.  @return The enum value of the `ThermalResolution`",
            ],
            [
                   "Get the supported resolution of the thermal imaging camera.  @return The enum value of the `ThermalResolution`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_resolution_inline",
                   "",
            ],
            [
                   "getFrameRateUpperBound",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_frameRateUpperBound_inline",
                   "Get the supported frame rate upper bound of the thermal imaging camera.  @return The enum value of the `ThermalFrameRateUpperBound`",
            ],
            [
                   "Get the supported frame rate upper bound of the thermal imaging camera.  @return The enum value of the `ThermalFrameRateUpperBound`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_frameRateUpperBound_inline",
                   "",
            ],
            [
                   "getFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_getFocalLength_inline",
                   "The lens model of the thermal imaging camera.  @return The enum value of the `ThermalLensFocalLength`",
            ],
            [
                   "The lens model of the thermal imaging camera.  @return The enum value of the `ThermalLensFocalLength`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_getFocalLength_inline",
                   "",
            ],
            [
                   "getVersion",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_version_inline",
                   "Get the version of the thermal imaging camera.  @return The enum value of the `ThermalVersion`",
            ],
            [
                   "Get the version of the thermal imaging camera.  @return The enum value of the `ThermalVersion`",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "#DJICamera_DJICameraThermalProfile_version_inline",
                   "",
            ],
            [
                   "X_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x1_inline",
                   "Digital zoom factor x1.",
            ],
            [
                   "Digital zoom factor x1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x1_inline",
                   "",
            ],
            [
                   "X_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x2_inline",
                   "Digital Zoom factor is x2.",
            ],
            [
                   "Digital Zoom factor is x2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x2_inline",
                   "",
            ],
            [
                   "X_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x4_inline",
                   "Digital Zoom factor is x4.",
            ],
            [
                   "Digital Zoom factor is x4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x4_inline",
                   "",
            ],
            [
                   "X_8",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x8_inline",
                   "Digital Zoom factor is x8. Not support by Mavic 2 Enterprise Dual Light Camera.",
            ],
            [
                   "Digital Zoom factor is x8. Not support by Mavic 2 Enterprise Dual Light Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x8_inline",
                   "",
            ],
            [
                   "X_16",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x16_inline",
                   "Digital Zoom factor is x16. Not support by Mavic 2 Enterprise Dual Light Camera.",
            ],
            [
                   "Digital Zoom factor is x16. Not support by Mavic 2 Enterprise Dual Light Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x16_inline",
                   "",
            ],
            [
                   "X_32",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x32_inline",
                   "Digital Zoom factor is x32. Not support by Mavic 2 Enterprise Dual Light Camera.",
            ],
            [
                   "Digital Zoom factor is x32. Not support by Mavic 2 Enterprise Dual Light Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_x32_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_Unknown_inline",
                   "Digital Zoom factor is unknown.",
            ],
            [
                   "Digital Zoom factor is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_Unknown_inline",
                   "",
            ],
            [
                   "DISABLED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_Disabled_inline",
                   "Disable temperature measuring.",
            ],
            [
                   "Disable temperature measuring.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_Disabled_inline",
                   "",
            ],
            [
                   "SPOT_METERING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_SpotMetering_inline",
                   "Enable temperature measurement and set mode to spot metering. Use `setThermalTemperatureCallback` to receive the updated temperature data. In this mode, the advanced radiometry version XT camera can change the metering point using `setThermalSpotMeteringTargetPoint`.",
            ],
            [
                   "Enable temperature measurement and set mode to spot metering. Use `setThermalTemperatureCallback` to receive the updated temperature data. In this mode, the advanced radiometry version XT camera can change the metering point using `setThermalSpotMeteringTargetPoint`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_SpotMetering_inline",
                   "",
            ],
            [
                   "AREA_METERING",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_AreaMetering_inline",
                   "Enable temperature measurement and set mode to area metering. Use `onUpdate` to receive the updated temperature data. Only supported by the advanced radiometry version XT camera.",
            ],
            [
                   "Enable temperature measurement and set mode to area metering. Use `onUpdate` to receive the updated temperature data. Only supported by the advanced radiometry version XT camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_AreaMetering_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_Unknown_inline",
                   "Thermal camera's temperature measurement mode is unknown.",
            ],
            [
                   "Thermal camera's temperature measurement mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_Unknown_inline",
                   "",
            ],
            [
                   "getAverageAreaTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_averageAreaTemperature_inline",
                   "Get the average temperature of the selected metering area.  @return A float value.",
            ],
            [
                   "Get the average temperature of the selected metering area.  @return A float value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_averageAreaTemperature_inline",
                   "",
            ],
            [
                   "getMinAreaTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_minAreaTemperature_inline",
                   "Get the minimum temperature of the selected metering area.  @return A float value for the minimal temperature of the metering area.",
            ],
            [
                   "Get the minimum temperature of the selected metering area.  @return A float value for the minimal temperature of the metering area.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_minAreaTemperature_inline",
                   "",
            ],
            [
                   "getMinTemperaturePoint",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_minTemperaturePoint_inline",
                   "The minimum temperature coordinate of the selected metering area.  @return Minimum temperature position.",
            ],
            [
                   "The minimum temperature coordinate of the selected metering area.  @return Minimum temperature position.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_minTemperaturePoint_inline",
                   "",
            ],
            [
                   "getMaxAreaTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_maxAreaTemperature_inline",
                   "Get the maximum temperature of the selected metering area.  @return A float value for the maximal temperature of the metering area.",
            ],
            [
                   "Get the maximum temperature of the selected metering area.  @return A float value for the maximal temperature of the metering area.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_maxAreaTemperature_inline",
                   "",
            ],
            [
                   "getMaxTemperaturePoint",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_maxTemperaturePoint_inline",
                   "The maximum temperature coordinate of the selected metering area.  @return Maximum temperature position.",
            ],
            [
                   "The maximum temperature coordinate of the selected metering area.  @return Maximum temperature position.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "#DJICamera_DJICameraThermalAreaTemperatureAggregations_maxTemperaturePoint_inline",
                   "",
            ],
            [
                   "getAtmosphericTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTemperature_inline",
                   "Atmospheric temperature, can be between -50 and 327.67 degrees Celsius.  @return Atmospheric temperature",
            ],
            [
                   "Atmospheric temperature, can be between -50 and 327.67 degrees Celsius.  @return Atmospheric temperature",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTemperature_inline",
                   "SDK Key for getAtmosphericTemperature: Atmospheric temperature, can be between -50 and 327.67 degrees Celsius.  @return Atmospheric temperature",
            ],
            [
                   "SDK Key for getAtmosphericTemperature: Atmospheric temperature, can be between -50 and 327.67 degrees Celsius.  @return Atmospheric temperature",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTemperature_inline",
                   "",
            ],
            [
                   "getAtmosphericTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTransmissionCoefficient_inline",
                   "Transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return Transmission coefficient",
            ],
            [
                   "Transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return Transmission coefficient",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TRANSMISSION_COEFFICIENT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTransmissionCoefficient_inline",
                   "SDK Key for getAtmosphericTransmissionCoefficient: Transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return Transmission coefficient",
            ],
            [
                   "SDK Key for getAtmosphericTransmissionCoefficient: Transmission coefficient of the atmosphere between the scene and the camera, can be between 50 and 100.  @return Transmission coefficient",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_atmosphericTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "getBackgroundTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_backgroundTemperature_inline",
                   "Background temperature (reflected by the scene), can be between -50 and 327.67 degrees Celsius.  @return Background temperature",
            ],
            [
                   "Background temperature (reflected by the scene), can be between -50 and 327.67 degrees Celsius.  @return Background temperature",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_backgroundTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_BACKGROUND_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_backgroundTemperature_inline",
                   "SDK Key for getBackgroundTemperature: Background temperature (reflected by the scene), can be between -50 and 327.67 degrees Celsius.  @return Background temperature",
            ],
            [
                   "SDK Key for getBackgroundTemperature: Background temperature (reflected by the scene), can be between -50 and 327.67 degrees Celsius.  @return Background temperature",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_backgroundTemperature_inline",
                   "",
            ],
            [
                   "getSceneEmissivity",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_sceneEmissivity_inline",
                   "Emissivity of the scene, can be between 50 and 100.  @return Emissivity of the scene",
            ],
            [
                   "Emissivity of the scene, can be between 50 and 100.  @return Emissivity of the scene",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_sceneEmissivity_inline",
                   "",
            ],
            [
                   "THERMAL_SCENE_EMISSIVITY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_sceneEmissivity_inline",
                   "SDK Key for getSceneEmissivity: Emissivity of the scene, can be between 50 and 100.  @return Emissivity of the scene",
            ],
            [
                   "SDK Key for getSceneEmissivity: Emissivity of the scene, can be between 50 and 100.  @return Emissivity of the scene",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_sceneEmissivity_inline",
                   "",
            ],
            [
                   "getWindowReflection",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflection_inline",
                   "Window reflection, can be between 50 and 100-X where X is the window transmission coefficient parameter.  @return Window reflection value.",
            ],
            [
                   "Window reflection, can be between 50 and 100-X where X is the window transmission coefficient parameter.  @return Window reflection value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflection_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflection_inline",
                   "SDK Key for getWindowReflection: Window reflection, can be between 50 and 100-X where X is the window transmission coefficient parameter.  @return Window reflection value.",
            ],
            [
                   "SDK Key for getWindowReflection: Window reflection, can be between 50 and 100-X where X is the window transmission coefficient parameter.  @return Window reflection value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflection_inline",
                   "",
            ],
            [
                   "getWindowReflectedTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflectedTemperature_inline",
                   "Temperature reflected in the window, can be between -50 and 327.67 degrees Celsius.  @return Temperature reflected in window.",
            ],
            [
                   "Temperature reflected in the window, can be between -50 and 327.67 degrees Celsius.  @return Temperature reflected in window.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflectedTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTED_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflectedTemperature_inline",
                   "SDK Key for getWindowReflectedTemperature: Temperature reflected in the window, can be between -50 and 327.67 degrees Celsius.  @return Temperature reflected in window.",
            ],
            [
                   "SDK Key for getWindowReflectedTemperature: Temperature reflected in the window, can be between -50 and 327.67 degrees Celsius.  @return Temperature reflected in window.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowReflectedTemperature_inline",
                   "",
            ],
            [
                   "getWindowTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTemperature_inline",
                   "Window temperature, can be between -50 and 327.67 degrees Celsius.  @return Window temperature.",
            ],
            [
                   "Window temperature, can be between -50 and 327.67 degrees Celsius.  @return Window temperature.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTemperature_inline",
                   "SDK Key for getWindowTemperature: Window temperature, can be between -50 and 327.67 degrees Celsius.  @return Window temperature.",
            ],
            [
                   "SDK Key for getWindowTemperature: Window temperature, can be between -50 and 327.67 degrees Celsius.  @return Window temperature.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTemperature_inline",
                   "",
            ],
            [
                   "getWindowTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTransmissionCoefficient_inline",
                   "Transmission coefficient of the window, can be between 50 and 100-X where X is the window reflection.  @return Window transmission coefficient.",
            ],
            [
                   "Transmission coefficient of the window, can be between 50 and 100-X where X is the window reflection.  @return Window transmission coefficient.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TRANSMISSION_COEFFICIENT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTransmissionCoefficient_inline",
                   "SDK Key for getWindowTransmissionCoefficient: Transmission coefficient of the window, can be between 50 and 100-X where X is the window reflection.  @return Window transmission coefficient.",
            ],
            [
                   "SDK Key for getWindowTransmissionCoefficient: Transmission coefficient of the window, can be between 50 and 100-X where X is the window reflection.  @return Window transmission coefficient.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "#DJICamera_DJICameraThermalExternalSceneSettings_windowTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "VISUAL_ONLY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_VisualOnly_inline",
                   "Displays only the video feed from the visual camera.",
            ],
            [
                   "Displays only the video feed from the visual camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_VisualOnly_inline",
                   "",
            ],
            [
                   "THERMAL_ONLY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_ThermalOnly_inline",
                   "Displays only the video feed from the thermal camera.",
            ],
            [
                   "Displays only the video feed from the thermal camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_ThermalOnly_inline",
                   "",
            ],
            [
                   "PIP",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_PIP_inline",
                   "Displays the video feed from the visual camera as the main subject, and the video from the thermal camera in a window not bigger than the main subject. The position of the thermal camera window can be adjusted with `PIPPosition`. Not supported by Mavic 2 Enterprise Dual.",
            ],
            [
                   "Displays the video feed from the visual camera as the main subject, and the video from the thermal camera in a window not bigger than the main subject. The position of the thermal camera window can be adjusted with `PIPPosition`. Not supported by Mavic 2 Enterprise Dual.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_PIP_inline",
                   "",
            ],
            [
                   "MSX",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_MSX_inline",
                   "Multi-Spectral Dynamic Imaging. Fuse the video feeds from both the visual camera and the thermal camera as one. Adds visible spectrum definition to IR images by detecting the edges of objects and including that detail in the thermal image.",
            ],
            [
                   "Multi-Spectral Dynamic Imaging. Fuse the video feeds from both the visual camera and the thermal camera as one. Adds visible spectrum definition to IR images by detecting the edges of objects and including that detail in the thermal image.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_MSX_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_Unknown_inline",
                   "The thermal video feed display mode is unknown.",
            ],
            [
                   "The thermal video feed display mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_Unknown_inline",
                   "",
            ],
            [
                   "IR_CENTER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Center_inline",
                   "Position the window to the vertical center and the horizontal center.",
            ],
            [
                   "Position the window to the vertical center and the horizontal center.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Center_inline",
                   "",
            ],
            [
                   "IR_BOTTOM_RIGHT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomRight_inline",
                   "Position the window to be bottom right.",
            ],
            [
                   "Position the window to be bottom right.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomRight_inline",
                   "",
            ],
            [
                   "IR_CENTER_RIGHT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_CenterRight_inline",
                   "Position the window to be centered on the right.",
            ],
            [
                   "Position the window to be centered on the right.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_CenterRight_inline",
                   "",
            ],
            [
                   "IR_TOP_RIGHT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopRight_inline",
                   "Position the window to be top right.",
            ],
            [
                   "Position the window to be top right.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopRight_inline",
                   "",
            ],
            [
                   "IR_BOTTOM_CENTER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomCenter_inline",
                   "Position the window to be centered at bottom.",
            ],
            [
                   "Position the window to be centered at bottom.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomCenter_inline",
                   "",
            ],
            [
                   "IR_TOP_CENTER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopCenter_inline",
                   "Position the window to be centered at top.",
            ],
            [
                   "Position the window to be centered at top.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopCenter_inline",
                   "",
            ],
            [
                   "IR_BOTTOM_LEFT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomLeft_inline",
                   "Position the window to be bottom left.",
            ],
            [
                   "Position the window to be bottom left.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_BottomLeft_inline",
                   "",
            ],
            [
                   "IR_CENTER_LEFT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_CenterLeft_inline",
                   "Position the window to be centered on the left.",
            ],
            [
                   "Position the window to be centered on the left.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_CenterLeft_inline",
                   "",
            ],
            [
                   "IR_TOP_LEFT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopLeft_inline",
                   "Position the window to be top left.",
            ],
            [
                   "Position the window to be top left.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_TopLeft_inline",
                   "",
            ],
            [
                   "SIDE_BY_SIDE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_SideBySide_inline",
                   "Position the thermal window on the right side of the main window (the visual camera video feed). Scale both windows with the same height.",
            ],
            [
                   "Position the thermal window on the right side of the main window (the visual camera video feed). Scale both windows with the same height.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_SideBySide_inline",
                   "",
            ],
            [
                   "ALIGN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Align_inline",
                   "Position the thermal window on top of the main window (the visual camera video feed). Then align the object in the thermal window with the same object in the main window. The alignment offset can be adjusted by `setDualFeedHorizontalAlignmentOffset` and `setDualFeedVerticalAlignmentOffset`.",
            ],
            [
                   "Position the thermal window on top of the main window (the visual camera video feed). Then align the object in the thermal window with the same object in the main window. The alignment offset can be adjusted by `setDualFeedHorizontalAlignmentOffset` and `setDualFeedVerticalAlignmentOffset`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Align_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_Unknown_inline",
                   "",
            ],
            [
                   "getMaxFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_maxFocalLength_inline",
                   "The maximum focal length of the lens in units of 0.1mm.  @return Maximum focal length of lens.",
            ],
            [
                   "The maximum focal length of the lens in units of 0.1mm.  @return Maximum focal length of lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_maxFocalLength_inline",
                   "",
            ],
            [
                   "getMinFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_minFocalLength_inline",
                   "The minimum focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
            ],
            [
                   "The minimum focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_minFocalLength_inline",
                   "",
            ],
            [
                   "getFocalLengthStep",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_focalLengthStep_inline",
                   "The minimum interval of focal length change in units of 0.1mm.  @return Focal length step.",
            ],
            [
                   "The minimum interval of focal length change in units of 0.1mm.  @return Focal length step.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "#DJICamera_DJICameraOpticalZoomSpec_focalLengthStep_inline",
                   "",
            ],
            [
                   "getMaxHybridFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_maxHybridFocalLength_inline",
                   "The maximum hybrid zoom focal length of the lens in units of 0.1mm.  @return Maximum focal length of lens.",
            ],
            [
                   "The maximum hybrid zoom focal length of the lens in units of 0.1mm.  @return Maximum focal length of lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_maxHybridFocalLength_inline",
                   "",
            ],
            [
                   "getMinHybridFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_minHybridFocalLength_inline",
                   "The minimum hybrid zoom focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
            ],
            [
                   "The minimum hybrid zoom focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_minHybridFocalLength_inline",
                   "",
            ],
            [
                   "getMaxOpticalFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_maxOpticalFocalLength_inline",
                   "The maximum optical zoom focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
            ],
            [
                   "The maximum optical zoom focal length of the lens in units of 0.1mm.  @return Minimum focal length of lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_maxOpticalFocalLength_inline",
                   "",
            ],
            [
                   "getFocalLengthStep",
                   2,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_focalLengthStep_inline",
                   "The minimum interval of focal length change in units of 0.1mm.  @return Focal length step.",
            ],
            [
                   "The minimum interval of focal length change in units of 0.1mm.  @return Focal length step.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "#DJICamera_DJICameraHybridZoomSpec_focalLengthStep_inline",
                   "",
            ],
            [
                   "ZOOM_IN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_ZoomIn_inline",
                   "Lens will zoom in. The focal length increases, field of view becomes narrower and magnification is higher.",
            ],
            [
                   "Lens will zoom in. The focal length increases, field of view becomes narrower and magnification is higher.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_ZoomIn_inline",
                   "",
            ],
            [
                   "ZOOM_OUT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_ZoomOut_inline",
                   "Lens will zoom out. The focal length decreases, field of view becomes wider and magnification is lower.",
            ],
            [
                   "Lens will zoom out. The focal length decreases, field of view becomes wider and magnification is lower.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_ZoomOut_inline",
                   "",
            ],
            [
                   "SLOWEST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Slowest_inline",
                   "Lens zooms very in slowest speed.",
            ],
            [
                   "Lens zooms very in slowest speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Slowest_inline",
                   "",
            ],
            [
                   "SLOW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Slow_inline",
                   "Lens zooms in slow speed.",
            ],
            [
                   "Lens zooms in slow speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Slow_inline",
                   "",
            ],
            [
                   "MODERATELY_SLOW",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_ModeratelySlow_inline",
                   "Lens zooms in speed slightly slower than normal speed.",
            ],
            [
                   "Lens zooms in speed slightly slower than normal speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_ModeratelySlow_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Normal_inline",
                   "Lens zooms in normal speed.",
            ],
            [
                   "Lens zooms in normal speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Normal_inline",
                   "",
            ],
            [
                   "MODERATELY_FAST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_ModeratelyFast_inline",
                   "Lens zooms very in speed slightly faster than normal speed.",
            ],
            [
                   "Lens zooms very in speed slightly faster than normal speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_ModeratelyFast_inline",
                   "",
            ],
            [
                   "FAST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Fast_inline",
                   "Lens zooms very in fast speed.",
            ],
            [
                   "Lens zooms very in fast speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Fast_inline",
                   "",
            ],
            [
                   "FASTEST",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Fastest_inline",
                   "Lens zooms very in fastest speed.",
            ],
            [
                   "Lens zooms very in fastest speed.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_Fastest_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_Idle_inline",
                   "The tap zoom is not triggered yet. It will always push `IDLE` if camera is not zooming.",
            ],
            [
                   "The tap zoom is not triggered yet. It will always push `IDLE` if camera is not zooming.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_Idle_inline",
                   "",
            ],
            [
                   "ZOOM_IN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomIn_inline",
                   "The camera is zooming in. The focal length increases, field of view becomes narrower and magnification is higher.",
            ],
            [
                   "The camera is zooming in. The focal length increases, field of view becomes narrower and magnification is higher.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomIn_inline",
                   "",
            ],
            [
                   "ZOOM_OUT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomOut_inline",
                   "The camera is zooming in the focal length decreases, field of view becomes wider and magnification is lower.",
            ],
            [
                   "The camera is zooming in the focal length decreases, field of view becomes wider and magnification is lower.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomOut_inline",
                   "",
            ],
            [
                   "ZOOM_LIMITED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomLimited_inline",
                   "It means the camera has reached its maximum focus length. It will always push `ZOOM_LIMITED` if the camera reaches its maximum focus length.",
            ],
            [
                   "It means the camera has reached its maximum focus length. It will always push `ZOOM_LIMITED` if the camera reaches its maximum focus length.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_ZoomLimited_inline",
                   "",
            ],
            [
                   "RESET",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Reset_inline",
                   "Camera will reset the newest file's index to be one larger than the largest number of photos taken on the SD card.",
            ],
            [
                   "Camera will reset the newest file's index to be one larger than the largest number of photos taken on the SD card.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Reset_inline",
                   "",
            ],
            [
                   "SEQUENCE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Sequence_inline",
                   "Camera will set the newest file's index to the larger of either the maximum number of photos taken on the SD card or the camera.",
            ],
            [
                   "Camera will set the newest file's index to the larger of either the maximum number of photos taken on the SD card or the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Sequence_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Unknown_inline",
                   "The mode is unknown.",
            ],
            [
                   "The mode is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_Unknown_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Auto_inline",
                   "Auto. ND filter will be enabled or disabled automatically by the camera.",
            ],
            [
                   "Auto. ND filter will be enabled or disabled automatically by the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Auto_inline",
                   "",
            ],
            [
                   "ON",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_On_inline",
                   "The ND filter is on.",
            ],
            [
                   "The ND filter is on.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_On_inline",
                   "",
            ],
            [
                   "OFF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Off_inline",
                   "The ND filter is off.",
            ],
            [
                   "The ND filter is off.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Off_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_Unknown_inline",
                   "",
            ],
            [
                   "DEFAULT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Default_inline",
                   "Default user.",
            ],
            [
                   "Default user.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Default_inline",
                   "",
            ],
            [
                   "PROFILE_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile1_inline",
                   "Settings for user 1.",
            ],
            [
                   "Settings for user 1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile1_inline",
                   "",
            ],
            [
                   "PROFILE_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile2_inline",
                   "Settings for user 2.",
            ],
            [
                   "Settings for user 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile2_inline",
                   "",
            ],
            [
                   "PROFILE_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile3_inline",
                   "Settings for user 3.",
            ],
            [
                   "Settings for user 3.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile3_inline",
                   "",
            ],
            [
                   "PROFILE_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile4_inline",
                   "Settings for user 4.",
            ],
            [
                   "Settings for user 4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Profile4_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Unknown_inline",
                   "The user is unknown.",
            ],
            [
                   "The user is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_Unknown_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_None_inline",
                   "The camera color is set to none or no filter.",
            ],
            [
                   "The camera color is set to none or no filter.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_None_inline",
                   "",
            ],
            [
                   "ART",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Art_inline",
                   "The camera color is set to art.",
            ],
            [
                   "The camera color is set to art.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Art_inline",
                   "",
            ],
            [
                   "BLACK_AND_WHITE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_BlackAndWhite_inline",
                   "The camera color is set to black and white.",
            ],
            [
                   "The camera color is set to black and white.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_BlackAndWhite_inline",
                   "",
            ],
            [
                   "BRIGHT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Bright_inline",
                   "The camera color is set to bright.",
            ],
            [
                   "The camera color is set to bright.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Bright_inline",
                   "",
            ],
            [
                   "D_CINELIKE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Dcinelike_inline",
                   "The camera color is set to D-Cinelike (called movie before).",
            ],
            [
                   "The camera color is set to D-Cinelike (called movie before).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Dcinelike_inline",
                   "",
            ],
            [
                   "PORTRAIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Portrait_inline",
                   "The camera color is set to portrait. Only supported by Osmo with X3 camera.",
            ],
            [
                   "The camera color is set to portrait. Only supported by Osmo with X3 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Portrait_inline",
                   "",
            ],
            [
                   "M_31",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_M31_inline",
                   "The camera color is set to M31.",
            ],
            [
                   "The camera color is set to M31.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_M31_inline",
                   "",
            ],
            [
                   "K_DX",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_kDX_inline",
                   "The camera color is set to kDX.",
            ],
            [
                   "The camera color is set to kDX.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_kDX_inline",
                   "",
            ],
            [
                   "PRISMO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Prismo_inline",
                   "The camera color is set to prismo.",
            ],
            [
                   "The camera color is set to prismo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Prismo_inline",
                   "",
            ],
            [
                   "JUGO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Jugo_inline",
                   "The camera color is set to jugo.",
            ],
            [
                   "The camera color is set to jugo.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Jugo_inline",
                   "",
            ],
            [
                   "D_LOG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Dlog_inline",
                   "The camera color is set to D-Log (called neutral before). For Mavic 2 Pro, setting to this color can enable 10-bit DLog-M color profile.",
            ],
            [
                   "The camera color is set to D-Log (called neutral before). For Mavic 2 Pro, setting to this color can enable 10-bit DLog-M color profile.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Dlog_inline",
                   "",
            ],
            [
                   "TRUE_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_TrueColor_inline",
                   "The camera color is set to true color. It is only supported by Phantom 4 with firmware v1.2.503 or above.",
            ],
            [
                   "The camera color is set to true color. It is only supported by Phantom 4 with firmware v1.2.503 or above.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_TrueColor_inline",
                   "",
            ],
            [
                   "INVERSE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Inverse_inline",
                   "The camera color is set to inverse.",
            ],
            [
                   "The camera color is set to inverse.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Inverse_inline",
                   "",
            ],
            [
                   "REMINISCENCE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Reminiscence_inline",
                   "The camera color is set to reminiscence.",
            ],
            [
                   "The camera color is set to reminiscence.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Reminiscence_inline",
                   "",
            ],
            [
                   "SOLARIZE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Solarize_inline",
                   "The camera color is set to solarize.",
            ],
            [
                   "The camera color is set to solarize.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Solarize_inline",
                   "",
            ],
            [
                   "POSTERIZE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Posterize_inline",
                   "The camera color is set to posterize.",
            ],
            [
                   "The camera color is set to posterize.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Posterize_inline",
                   "",
            ],
            [
                   "WHITEBOARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Whiteboard_inline",
                   "The camera color is set to whiteboard.",
            ],
            [
                   "The camera color is set to whiteboard.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Whiteboard_inline",
                   "",
            ],
            [
                   "BLACKBOARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Blackboard_inline",
                   "The camera color is set to blackboard.",
            ],
            [
                   "The camera color is set to blackboard.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Blackboard_inline",
                   "",
            ],
            [
                   "AQUA",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Aqua_inline",
                   "The camera color is set to aqua.",
            ],
            [
                   "The camera color is set to aqua.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Aqua_inline",
                   "",
            ],
            [
                   "DELTA",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Delta_inline",
                   "The camera color is set to delta.",
            ],
            [
                   "The camera color is set to delta.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Delta_inline",
                   "",
            ],
            [
                   "DK79",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_DK79_inline",
                   "The camera color is set to dk79.",
            ],
            [
                   "The camera color is set to dk79.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_DK79_inline",
                   "",
            ],
            [
                   "VISION_4",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Vision4_inline",
                   "The camera color is set to vision4.",
            ],
            [
                   "The camera color is set to vision4.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Vision4_inline",
                   "",
            ],
            [
                   "VISION_6",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Vision6_inline",
                   "The camera color is set to vision6.",
            ],
            [
                   "The camera color is set to vision6.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Vision6_inline",
                   "",
            ],
            [
                   "TRUE_COLOR_EXT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_TrueColorExt_inline",
                   "The camera color is set to true color extend.",
            ],
            [
                   "The camera color is set to true color extend.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_TrueColorExt_inline",
                   "",
            ],
            [
                   "FILM_A",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmA_inline",
                   "The camera color is set to Film A.",
            ],
            [
                   "The camera color is set to Film A.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmA_inline",
                   "",
            ],
            [
                   "FILM_B",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmB_inline",
                   "The camera color is set to Film B.",
            ],
            [
                   "The camera color is set to Film B.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmB_inline",
                   "",
            ],
            [
                   "FILM_C",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmC_inline",
                   "The camera color is set to Film C.",
            ],
            [
                   "The camera color is set to Film C.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmC_inline",
                   "",
            ],
            [
                   "FILM_D",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmD_inline",
                   "The camera color is set to Film D.",
            ],
            [
                   "The camera color is set to Film D.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmD_inline",
                   "",
            ],
            [
                   "FILM_E",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmE_inline",
                   "The camera color is set to Film E.",
            ],
            [
                   "The camera color is set to Film E.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmE_inline",
                   "",
            ],
            [
                   "FILM_F",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmF_inline",
                   "The camera color is set to Film F.",
            ],
            [
                   "The camera color is set to Film F.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmF_inline",
                   "",
            ],
            [
                   "FILM_G",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmG_inline",
                   "The camera color is set to Film G.",
            ],
            [
                   "The camera color is set to Film G.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmG_inline",
                   "",
            ],
            [
                   "FILM_H",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmH_inline",
                   "The camera color is set to Film H.",
            ],
            [
                   "The camera color is set to Film H.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmH_inline",
                   "",
            ],
            [
                   "FILM_I",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmI_inline",
                   "The camera color is set to Film I.",
            ],
            [
                   "The camera color is set to Film I.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_FilmI_inline",
                   "",
            ],
            [
                   "HLG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_HLG_inline",
                   "The camera color is set to HLG (Hybrid Log-Gamma).",
            ],
            [
                   "The camera color is set to HLG (Hybrid Log-Gamma).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_HLG_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Unknown_inline",
                   "The camera color is unknown.",
            ],
            [
                   "The camera color is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_Unknown_inline",
                   "",
            ],
            [
                   "D_LOG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_DLog_inline",
                   "The EI color is set to D-Log.",
            ],
            [
                   "The EI color is set to D-Log.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_DLog_inline",
                   "",
            ],
            [
                   "REC_709",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_Rec709_inline",
                   "The EI color is set to Rec.709.",
            ],
            [
                   "The EI color is set to Rec.709.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_Rec709_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_Unknown_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterNone_inline",
                   "The camera color is set to none. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to none. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterNone_inline",
                   "",
            ],
            [
                   "D_CINELIKE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDCinelike_inline",
                   "The camera color is set to DCinelike. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to DCinelike. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDCinelike_inline",
                   "",
            ],
            [
                   "D_LOG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDLog_inline",
                   "The camera color is set to DLog. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to DLog. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDLog_inline",
                   "",
            ],
            [
                   "D_COLOR_1",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor1_inline",
                   "The camera color is set to DColor1. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to DColor1. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor1_inline",
                   "",
            ],
            [
                   "D_Color_2",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor2_inline",
                   "The camera color is set to DColor2. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to DColor2. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor2_inline",
                   "",
            ],
            [
                   "D_COLOR_3",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor3_inline",
                   "The camera color is set to DColor3. It is only supported by X5S on Inspire 2.",
            ],
            [
                   "The camera color is set to DColor3. It is only supported by X5S on Inspire 2.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterDColor3_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterUnknown_inline",
                   "The camera color is unknown.",
            ],
            [
                   "The camera color is unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilterUnknown_inline",
                   "",
            ],
            [
                   "STANDARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Standard_inline",
                   "Standard. It is available when the camera is in ISO mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
            ],
            [
                   "Standard. It is available when the camera is in ISO mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Standard_inline",
                   "",
            ],
            [
                   "DLOG",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_DLog_inline",
                   "D-Log. It is available when the camera is in EI mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
            ],
            [
                   "D-Log. It is available when the camera is in EI mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_DLog_inline",
                   "",
            ],
            [
                   "REC709",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Rec709_inline",
                   "Rec.709. It is available when the camera is in EI mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
            ],
            [
                   "Rec.709. It is available when the camera is in EI mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Rec709_inline",
                   "",
            ],
            [
                   "CINE_LIKE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_CineLike_inline",
                   "Cine-like. It is available when the camera is in ISO mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
            ],
            [
                   "Cine-like. It is available when the camera is in ISO mode and the SSD license is `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_CineLike_inline",
                   "",
            ],
            [
                   "RAW_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_RawColor_inline",
                   "Raw color. This is the only for `LicenseKeyTypeCinemaDNG`.",
            ],
            [
                   "Raw color. This is the only for `LicenseKeyTypeCinemaDNG`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_RawColor_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_Unknown_inline",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_ISO_inline",
                   "ISO mode.",
            ],
            [
                   "ISO mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_ISO_inline",
                   "",
            ],
            [
                   "EI",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_EI_inline",
                   "EI (exposure index) mode. In this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. This mode only takes effect when the camera mode is in `RECORD_VIDEO`.",
            ],
            [
                   "EI (exposure index) mode. In this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. This mode only takes effect when the camera mode is in `RECORD_VIDEO`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_EI_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_Unknown_inline",
                   "",
            ],
            [
                   "LANDSCAPE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Landscape_inline",
                   "By default, the camera is in landscape orientation.",
            ],
            [
                   "By default, the camera is in landscape orientation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Landscape_inline",
                   "",
            ],
            [
                   "PORTRAIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Portrait_inline",
                   "The camera is in the portrait orientation, which is rotated 90 degrees in the clockwise direction from the default landscape orientation.",
            ],
            [
                   "The camera is in the portrait orientation, which is rotated 90 degrees in the clockwise direction from the default landscape orientation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Portrait_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_Unknown_inline",
                   "",
            ],
            [
                   "H264",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_H264_inline",
                   "H.264 compression standard.",
            ],
            [
                   "H.264 compression standard.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_H264_inline",
                   "",
            ],
            [
                   "H265",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_H265_inline",
                   "H.265 compression standard.",
            ],
            [
                   "H.265 compression standard.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_H265_inline",
                   "",
            ],
            [
                   "Unknown",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_Unknown_inline",
                   "",
            ],
            [
                   "STANDARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Standard_inline",
                   "Saturation 0, Contrast 0, Sharpness 0.",
            ],
            [
                   "Saturation 0, Contrast 0, Sharpness 0.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Standard_inline",
                   "",
            ],
            [
                   "LANDSCAPE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Landscape_inline",
                   "Saturation 0, Contrast 1, Sharpness 1.",
            ],
            [
                   "Saturation 0, Contrast 1, Sharpness 1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Landscape_inline",
                   "",
            ],
            [
                   "SOFT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Soft_inline",
                   "Saturation 0, Contrast 0, Sharpness -1.",
            ],
            [
                   "Saturation 0, Contrast 0, Sharpness -1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Soft_inline",
                   "",
            ],
            [
                   "CUSTOM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Custom_inline",
                   "Custom preset type",
            ],
            [
                   "Custom preset type",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Custom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Unknown_inline",
                   "Unknown preset type",
            ],
            [
                   "Unknown preset type",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_Unknown_inline",
                   "",
            ],
            [
                   "FAHRENHEIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Fahrenheit_inline",
                   "Use degree Fahrenheit as the unit.",
            ],
            [
                   "Use degree Fahrenheit as the unit.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Fahrenheit_inline",
                   "",
            ],
            [
                   "CELSIUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Celsius_inline",
                   "Use degree Celsius as the unit.",
            ],
            [
                   "Use degree Celsius as the unit.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Celsius_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_Unknown_inline",
                   "",
            ],
            [
                   "SDCARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_SDCard_inline",
                   "SD card.",
            ],
            [
                   "SD card.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_SDCard_inline",
                   "",
            ],
            [
                   "INTERNAL_STORAGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_InternalStorage_inline",
                   "The internal storage embedded in the aircraft. When it is available, the camera can shoot photos or record videos without SD card. It is only supported by Mavic Air.",
            ],
            [
                   "The internal storage embedded in the aircraft. When it is available, the camera can shoot photos or record videos without SD card. It is only supported by Mavic Air.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_InternalStorage_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_Unknown_inline",
                   "",
            ],
            [
                   "DEFAULT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Default_inline",
                   "The default video stream channel.",
            ],
            [
                   "The default video stream channel.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Default_inline",
                   "",
            ],
            [
                   "WIDE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Wide_inline",
                   "Wide stream. Only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
            ],
            [
                   "Wide stream. Only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Wide_inline",
                   "",
            ],
            [
                   "ZOOM",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Zoom_inline",
                   "Zoom stream. Only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
            ],
            [
                   "Zoom stream. Only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Zoom_inline",
                   "",
            ],
            [
                   "INFRARED_THERMAL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_IR_inline",
                   "Infrared thermal stream. Only supported by Zenmuse H20T and H20N.and Mavic 2 Enterprise Advanced.",
            ],
            [
                   "Infrared thermal stream. Only supported by Zenmuse H20T and H20N.and Mavic 2 Enterprise Advanced.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_IR_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraVideoStreamSource_CallbackInterface.html",
                   "",
                   "When the video stream source has been changed, the interface will invoke the `onUpdate` method to notify all subscribers to update.",
            ],
            [
                   "When the video stream source has been changed, the interface will invoke the `onUpdate` method to notify all subscribers to update.",
                   1,
                   "/Components/Camera/DJICamera_CameraVideoStreamSource_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraVideoStreamSource_CallbackInterface.html",
                   "#DJICamera_CameraVideoStreamSource_CallbackInterface_onUpdate_inline",
                   "When the video stream source has been changed, the method will be invoked.  @param streamSource An object of `CameraVideoStreamSource`.",
            ],
            [
                   "When the video stream source has been changed, the method will be invoked.  @param streamSource An object of `CameraVideoStreamSource`.",
                   1,
                   "/Components/Camera/DJICamera_CameraVideoStreamSource_CallbackInterface.html",
                   "#DJICamera_CameraVideoStreamSource_CallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "getSaturation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_saturation_inline",
                   "An NSInteger value of saturation.  @return Saturation value of preset",
            ],
            [
                   "An NSInteger value of saturation.  @return Saturation value of preset",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_saturation_inline",
                   "",
            ],
            [
                   "getContrast",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_contrast_inline",
                   "An NSInteger value of contrast.  @return Contrast value of preset",
            ],
            [
                   "An NSInteger value of contrast.  @return Contrast value of preset",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_contrast_inline",
                   "",
            ],
            [
                   "getSharpness",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_sharpness_inline",
                   "An NSInteger value of sharpness.  @return Sharpness value of preset",
            ],
            [
                   "An NSInteger value of sharpness.  @return Sharpness value of preset",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_sharpness_inline",
                   "",
            ],
            [
                   "presetType",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_presetType_inline",
                   "An enum value of `PictureStylePresetType`.  @return Preset type",
            ],
            [
                   "An enum value of `PictureStylePresetType`.  @return Preset type",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "#DJICamera_DJICameraPictureStylePreset_presetType_inline",
                   "",
            ],
            [
                   "ColorWaveformDisplayMode",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_inline",
                   "Camera work modes.",
            ],
            [
                   "Camera work modes.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_inline",
                   "",
            ],
            [
                   "MIX",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_MIX_inline",
                   "Mix mode.",
            ],
            [
                   "Mix mode.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_MIX_inline",
                   "",
            ],
            [
                   "SEPARATE",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_SEPARATE_inline",
                   "SEPARATE mode.",
            ],
            [
                   "SEPARATE mode.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_SEPARATE_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_UNKNOWN_inline",
                   "Unknown mode.",
            ],
            [
                   "Unknown mode.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayMode_UNKNOWN_inline",
                   "",
            ],
            [
                   "ColorWaveformDisplayState",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_inline",
                   "Color waveform display state.",
            ],
            [
                   "Color waveform display state.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_inline",
                   "",
            ],
            [
                   "COLOR_WAVEFORM_DISPLAY_STATE",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_inline",
                   "SDK Key for ColorWaveformDisplayState: Color waveform display state.",
            ],
            [
                   "SDK Key for ColorWaveformDisplayState: Color waveform display state.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_inline",
                   "",
            ],
            [
                   "EXPOSURE",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_SWITCH_TO_EXP_inline",
                   "Switch to Exp event.",
            ],
            [
                   "Switch to Exp event.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_SWITCH_TO_EXP_inline",
                   "",
            ],
            [
                   "COLOR",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_SWITCH_TO_COLOR_inline",
                   "Switch to Color event.",
            ],
            [
                   "Switch to Color event.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_SWITCH_TO_COLOR_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_UNKNOWN_inline",
                   "Switch to Unknown.",
            ],
            [
                   "Switch to Unknown.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "#DJICamera_ColorWaveformSettings_ColorWaveformDisplayState_UNKNOWN_inline",
                   "",
            ],
            [
                   "setSystemStateCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraUpdatedSystemStateCallback_inline",
                   "Sets the camera's system state callback. The onUpdate function has a CameraSystemState object as its parameter.  Precondition:  A Callback object must be implemented and passed in as a parameter.  Postcondition:  The Callback object that was passed in as a parameter will call its onUpdate function at regular intervals.  @param updatedSystemStateCallBack The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The CameraSDCardState object contains information about the SD card inserted into the aircraft's camera.",
            ],
            [
                   "Sets the camera's system state callback. The onUpdate function has a CameraSystemState object as its parameter.  Precondition:  A Callback object must be implemented and passed in as a parameter.  Postcondition:  The Callback object that was passed in as a parameter will call its onUpdate function at regular intervals.  @param updatedSystemStateCallBack The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The CameraSDCardState object contains information about the SD card inserted into the aircraft's camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraUpdatedSystemStateCallback_inline",
                   "",
            ],
            [
                   "setExposureSettingsCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraUpdatedCurrentExposureValuesCallback_inline",
                   "Sets the callback for updated exposure parameters. The callback's `onUpdate` method will be called each time the exposure parameters (ISO, Exposure Compensation, Shutter Speed and Aperture) are updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback.",
            ],
            [
                   "Sets the callback for updated exposure parameters. The callback's `onUpdate` method will be called each time the exposure parameters (ISO, Exposure Compensation, Shutter Speed and Aperture) are updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraUpdatedCurrentExposureValuesCallback_inline",
                   "",
            ],
            [
                   "setMediaFileCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraGeneratedNewMediaFileCallback_inline",
                   "Sets the camera's new generated media file callback.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `setNewGeneratedMediaFileInfoCallback` insteaded.  @param callback The Callback object to set as the callback. The callback's method `onNewFile` has a `MediaFile` object as it's parameter from which information about the media type, index, file size and the created time can be obtained.",
            ],
            [
                   "Sets the camera's new generated media file callback.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `setNewGeneratedMediaFileInfoCallback` insteaded.  @param callback The Callback object to set as the callback. The callback's method `onNewFile` has a `MediaFile` object as it's parameter from which information about the media type, index, file size and the created time can be obtained.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraGeneratedNewMediaFileCallback_inline",
                   "",
            ],
            [
                   "setNewGeneratedMediaFileInfoCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraNewGeneratedMediaFileInfoCallback_inline",
                   "Sets the camera's new generated media file info callback.  @param callback The Callback object to set as the callback. The callback's method `onNewFileInfo` has a `MediaFileInfo` object as it's parameter from which information about the media type, index, file size, created time and stream source can be obtained.",
            ],
            [
                   "Sets the camera's new generated media file info callback.  @param callback The Callback object to set as the callback. The callback's method `onNewFileInfo` has a `MediaFileInfo` object as it's parameter from which information about the media type, index, file size, created time and stream source can be obtained.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraNewGeneratedMediaFileInfoCallback_inline",
                   "",
            ],
            [
                   "setTimeLapsePreviewCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraGeneratedTimeLapsePreviewCallback_inline",
                   "Sets the generated preview image callback. The callback's `onGenerate` method will be called each time a photo has been taken.  @param generatedTimeLapseCallBack The execution callback.",
            ],
            [
                   "Sets the generated preview image callback. The callback's `onGenerate` method will be called each time a photo has been taken.  @param generatedTimeLapseCallBack The execution callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJICameraGeneratedTimeLapsePreviewCallback_inline",
                   "",
            ],
            [
                   "setThermalTemperatureCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalTemperatureCallback_inline",
                   "Sets the thermal camera's temperature update callback. Callback is used when there is a new temperature value available for the set spot metering target point. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param updateCenterTemperatureCallback The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The Float object contains information about the updated temperature value.",
            ],
            [
                   "Sets the thermal camera's temperature update callback. Callback is used when there is a new temperature value available for the set spot metering target point. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param updateCenterTemperatureCallback The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The Float object contains information about the updated temperature value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalTemperatureCallback_inline",
                   "",
            ],
            [
                   "setFocusStateCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraLensStateCallBack_inline",
                   "Callback for updating the lens state. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param updatedLensStateCallback The callback.",
            ],
            [
                   "Callback for updating the lens state. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param updatedLensStateCallback The callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraLensStateCallBack_inline",
                   "",
            ],
            [
                   "setThermalAreaTemperatureAggregationsCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalAreaTemperatureAggregationsCallback_inline",
                   "Sets the thermal camera's temperature aggregation update callback. Callback will be called when there are new min, max, and average values available for the set spot metering area. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param areaTemperatureAggregationsUpdatedCallback The Callback object to set as the callback.",
            ],
            [
                   "Sets the thermal camera's temperature aggregation update callback. Callback will be called when there are new min, max, and average values available for the set spot metering area. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param areaTemperatureAggregationsUpdatedCallback The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalAreaTemperatureAggregationsCallback_inline",
                   "",
            ],
            [
                   "setThermalExternalSceneSettingsCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalExternalSceneSettingsCallback_inline",
                   "Sets the thermal camera's external scene settings update callback. Callback will get called when updated external scene settings are available. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher, Only supported by XT2.  @param thermalExternalSceneSettingsUpdatedCallback The Callback object to set as the callback.",
            ],
            [
                   "Sets the thermal camera's external scene settings update callback. Callback will get called when updated external scene settings are available. Supported only by thermal imaging cameras with installed firmware version of 1.20.0.00 or higher, Only supported by XT2.  @param thermalExternalSceneSettingsUpdatedCallback The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setThermalExternalSceneSettingsCallback_inline",
                   "",
            ],
            [
                   "setSDCardStateCallBack",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraSDCardStateCallBack_inline",
                   "Sets the camera's SD card information callback. Deprecated, please use `onUpdate` instead.  @param updatedSDCardStateCallback The Callback object to set as the callback.",
            ],
            [
                   "Sets the camera's SD card information callback. Deprecated, please use `onUpdate` instead.  @param updatedSDCardStateCallback The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraSDCardStateCallBack_inline",
                   "",
            ],
            [
                   "setStorageStateCallBack",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraStorageStateCallBack_inline",
                   "Called when the camera's storage state has been updated. Use `StorageState`'s `getStorageLocation` to determine if the updated state is for SD card or the internal storage.  @param storageStateCallBack The Callback object to set as the callback.",
            ],
            [
                   "Called when the camera's storage state has been updated. Use `StorageState`'s `getStorageLocation` to determine if the updated state is for SD card or the internal storage.  @param storageStateCallBack The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraStorageStateCallBack_inline",
                   "",
            ],
            [
                   "setSSDStateCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraSSDStateCallBack_inline",
                   "Callback for updating the SSD state.  @param updatedSSDStateCallback The Callback.",
            ],
            [
                   "Callback for updating the SSD state.  @param updatedSSDStateCallback The Callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setDJIUpdateCameraSSDStateCallBack_inline",
                   "",
            ],
            [
                   "setHistogramCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setHistogramCallback_inline",
                   "Sets the histogram callback.  @param callback The execution callback.",
            ],
            [
                   "Sets the histogram callback.  @param callback The execution callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setHistogramCallback_inline",
                   "",
            ],
            [
                   "setCameraVideoStreamSourceCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCameraVideoStreamSourceCallback_inline",
                   "Sets the camera video stream source callback. When the camera video stream source been changed, the interface of `Callback` would be triggered. It is only supported by Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the camera video stream source callback. When the camera video stream source been changed, the interface of `Callback` would be triggered. It is only supported by Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCameraVideoStreamSourceCallback_inline",
                   "",
            ],
            [
                   "setMultispectralExposureStateCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setMultispectralExposureStateCallback_inline",
                   "Called when the Multispectral camera's exposure status changes. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
            ],
            [
                   "Called when the Multispectral camera's exposure status changes. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setMultispectralExposureStateCallback_inline",
                   "",
            ],
            [
                   "isCaptureInVideoSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isCaptureInVideoSupported_inline",
                   "This method is used to determine whether the video recording supports photographing.  @return A boolean value.",
            ],
            [
                   "This method is used to determine whether the video recording supports photographing.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isCaptureInVideoSupported_inline",
                   "",
            ],
            [
                   "getDisplayName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_displayName_inline",
                   "Return string that represents name of the camera.  @return An instance of display name String.",
            ],
            [
                   "Return string that represents name of the camera.  @return An instance of display name String.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_displayName_inline",
                   "",
            ],
            [
                   "CameraKey.DISPLAY_NAME",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_displayName_inline",
                   "SDK Key for getDisplayName: Return string that represents name of the camera.  @return An instance of display name String.",
            ],
            [
                   "SDK Key for getDisplayName: Return string that represents name of the camera.  @return An instance of display name String.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_displayName_inline",
                   "",
            ],
            [
                   "getCapabilities",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_capabilities_inline",
                   "Camera capabilities. Return `nil` when the camera is multiple lenses camera. Instead, user can access lens' capabilities through its lens object.  @return An object of `Capabilities`.",
            ],
            [
                   "Camera capabilities. Return `nil` when the camera is multiple lenses camera. Instead, user can access lens' capabilities through its lens object.  @return An object of `Capabilities`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_capabilities_inline",
                   "",
            ],
            [
                   "getLens",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getLens_inline",
                   "Gets camera lens by lensIndex.  @param lensIndex Lens index.  @return An object of `Lens`.",
            ],
            [
                   "Gets camera lens by lensIndex.  @param lensIndex Lens index.  @return An object of `Lens`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getLens_inline",
                   "",
            ],
            [
                   "getLenses",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_lens_inline",
                   "Camera's own lenses.  @return A list of `Lens`.",
            ],
            [
                   "Camera's own lenses.  @return A list of `Lens`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_lens_inline",
                   "",
            ],
            [
                   "isFlatCameraModeSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isFlatCameraModeSupported_inline",
                   "Determines if current camera supports Flat Camera Mode. Returns `true` if the `CameraMode` and `ShootPhotoMode` flatten into `FlatCameraMode`. The `FlatCameraMode` and `setFlatMode` can be used to set the camera mode directly. The user does not need to use `setMode` and `setShootPhotoMode` to set the camera mode by two steps. Besides, the `MEDIA_DOWNLOAD` is decoupled from the `CameraMode`. Determine what the last camera mode was by checking `getMode` before entering the playback.  @return A boolean value.",
            ],
            [
                   "Determines if current camera supports Flat Camera Mode. Returns `true` if the `CameraMode` and `ShootPhotoMode` flatten into `FlatCameraMode`. The `FlatCameraMode` and `setFlatMode` can be used to set the camera mode directly. The user does not need to use `setMode` and `setShootPhotoMode` to set the camera mode by two steps. Besides, the `MEDIA_DOWNLOAD` is decoupled from the `CameraMode`. Determine what the last camera mode was by checking `getMode` before entering the playback.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isFlatCameraModeSupported_inline",
                   "",
            ],
            [
                   "setFlatMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setFlatMode_inline",
                   "Sets the camera's flat mode to take photo, record video, or enter intelligent camera modes. Please note that you cannot change the mode when a certain task is executing. This is available only when `isFlatCameraModeSupported` returns `true`.  @param mode Camera flat mode. See `FlatCameraMode` to find details. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's flat mode to take photo, record video, or enter intelligent camera modes. Please note that you cannot change the mode when a certain task is executing. This is available only when `isFlatCameraModeSupported` returns `true`.  @param mode Camera flat mode. See `FlatCameraMode` to find details. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setFlatMode_inline",
                   "",
            ],
            [
                   "getFlatMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getFlatMode_inline",
                   "Gets the camera's current flat mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's current flat mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getFlatMode_inline",
                   "",
            ],
            [
                   "enterPlayback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_enterPlayback_inline",
                   "Enter playback mode, in which users can preview photos or videos, begin the video playback, and download media to the mobile device. This is available only when `isFlatCameraModeSupported` returns `true`. Please note that only after exiting playback mode, last flat camera mode will be recovered.  @param callback The execution callback with result of the action.",
            ],
            [
                   "Enter playback mode, in which users can preview photos or videos, begin the video playback, and download media to the mobile device. This is available only when `isFlatCameraModeSupported` returns `true`. Please note that only after exiting playback mode, last flat camera mode will be recovered.  @param callback The execution callback with result of the action.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_enterPlayback_inline",
                   "",
            ],
            [
                   "exitPlayback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_exitPlayback_inline",
                   "Exit play back mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @param callback The execution callback with result of the action.",
            ],
            [
                   "Exit play back mode. This is available only when `isFlatCameraModeSupported` returns `true`.  @param callback The execution callback with result of the action.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_exitPlayback_inline",
                   "",
            ],
            [
                   "setMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraMode_inline",
                   "Sets the camera's work mode to taking pictures, video, playback or download. Please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. Also supported by thermal imaging camera.  @param mode Camera work mode. See enum named CameraMode in SettingsDefinitions to find details on camera work modes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's work mode to taking pictures, video, playback or download. Please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. Also supported by thermal imaging camera.  @param mode Camera work mode. See enum named CameraMode in SettingsDefinitions to find details on camera work modes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraMode_inline",
                   "",
            ],
            [
                   "CameraKey.MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraMode_inline",
                   "SDK Key for setMode: Sets the camera's work mode to taking pictures, video, playback or download. Please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. Also supported by thermal imaging camera.  @param mode Camera work mode. See enum named CameraMode in SettingsDefinitions to find details on camera work modes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setMode: Sets the camera's work mode to taking pictures, video, playback or download. Please note that you cannot change the mode when a certain task is executing, such as taking photo(s), recording video, or downloading and saving files. Also supported by thermal imaging camera.  @param mode Camera work mode. See enum named CameraMode in SettingsDefinitions to find details on camera work modes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setCameraMode_inline",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getCameraMode_inline",
                   "Gets the camera's current work mode. Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's current work mode. Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getCameraMode_inline",
                   "",
            ],
            [
                   "CameraKey.MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getCameraMode_inline",
                   "SDK Key for getMode: Gets the camera's current work mode. Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMode: Gets the camera's current work mode. Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getCameraMode_inline",
                   "",
            ],
            [
                   "startRecordVideo",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startRecordVideo_inline",
                   "Starts recording video.  Precondition:  Camera must be in `RECORD_VIDEO` mode. For thermal imaging camera, user can take Single photo when recording video.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Starts recording video.  Precondition:  Camera must be in `RECORD_VIDEO` mode. For thermal imaging camera, user can take Single photo when recording video.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startRecordVideo_inline",
                   "",
            ],
            [
                   "START_RECORD_VIDEO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startRecordVideo_inline",
                   "SDK Key for startRecordVideo: Starts recording video.  Precondition:  Camera must be in `RECORD_VIDEO` mode. For thermal imaging camera, user can take Single photo when recording video.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for startRecordVideo: Starts recording video.  Precondition:  Camera must be in `RECORD_VIDEO` mode. For thermal imaging camera, user can take Single photo when recording video.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startRecordVideo_inline",
                   "",
            ],
            [
                   "stopRecordVideo",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopRecordVideo_inline",
                   "Stops recording video.  Precondition:  The camera is recording currently.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops recording video.  Precondition:  The camera is recording currently.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopRecordVideo_inline",
                   "",
            ],
            [
                   "STOP_RECORD_VIDEO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopRecordVideo_inline",
                   "SDK Key for stopRecordVideo: Stops recording video.  Precondition:  The camera is recording currently.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for stopRecordVideo: Stops recording video.  Precondition:  The camera is recording currently.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopRecordVideo_inline",
                   "",
            ],
            [
                   "startShootPhoto",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startShootPhoto_inline",
                   "Camera starts to take photo with one of the camera capture modes (shoot photo modes).Also,  Precondition:  1. Camera must be in ShootPhoto mode. Check the enum named CameraShootPhotoMode in DJICameraSettingsDef to find all possible camera capture modes. For thermal imaging camera, Single photo can be taken while recording video. 2. The SD card state should be checked before this method is used to ensure sufficient space exists.  Post condition:  If the capture mode is either Burst or Interval, calling stopShootPhoto will be required for the camera to stop taking photos.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Camera starts to take photo with one of the camera capture modes (shoot photo modes).Also,  Precondition:  1. Camera must be in ShootPhoto mode. Check the enum named CameraShootPhotoMode in DJICameraSettingsDef to find all possible camera capture modes. For thermal imaging camera, Single photo can be taken while recording video. 2. The SD card state should be checked before this method is used to ensure sufficient space exists.  Post condition:  If the capture mode is either Burst or Interval, calling stopShootPhoto will be required for the camera to stop taking photos.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startShootPhoto_inline",
                   "",
            ],
            [
                   "START_SHOOT_PHOTO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startShootPhoto_inline",
                   "SDK Key for startShootPhoto: Camera starts to take photo with one of the camera capture modes (shoot photo modes).Also,  Precondition:  1. Camera must be in ShootPhoto mode. Check the enum named CameraShootPhotoMode in DJICameraSettingsDef to find all possible camera capture modes. For thermal imaging camera, Single photo can be taken while recording video. 2. The SD card state should be checked before this method is used to ensure sufficient space exists.  Post condition:  If the capture mode is either Burst or Interval, calling stopShootPhoto will be required for the camera to stop taking photos.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startShootPhoto: Camera starts to take photo with one of the camera capture modes (shoot photo modes).Also,  Precondition:  1. Camera must be in ShootPhoto mode. Check the enum named CameraShootPhotoMode in DJICameraSettingsDef to find all possible camera capture modes. For thermal imaging camera, Single photo can be taken while recording video. 2. The SD card state should be checked before this method is used to ensure sufficient space exists.  Post condition:  If the capture mode is either Burst or Interval, calling stopShootPhoto will be required for the camera to stop taking photos.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_startShootPhoto_inline",
                   "",
            ],
            [
                   "stopShootPhoto",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopShootPhoto_inline",
                   "Camera stops taking photos.  Precondition:  1. `startShootPhoto` has been invoked and the shoot mode is either Interval or Time-lapse.  2. If the capture mode is set to Single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Camera stops taking photos.  Precondition:  1. `startShootPhoto` has been invoked and the shoot mode is either Interval or Time-lapse.  2. If the capture mode is set to Single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopShootPhoto_inline",
                   "",
            ],
            [
                   "STOP_SHOOT_PHOTO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopShootPhoto_inline",
                   "SDK Key for stopShootPhoto: Camera stops taking photos.  Precondition:  1. `startShootPhoto` has been invoked and the shoot mode is either Interval or Time-lapse.  2. If the capture mode is set to Single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for stopShootPhoto: Camera stops taking photos.  Precondition:  1. `startShootPhoto` has been invoked and the shoot mode is either Interval or Time-lapse.  2. If the capture mode is set to Single, the camera will automatically stop taking the photo once the individual photo is taken.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_stopShootPhoto_inline",
                   "",
            ],
            [
                   "setShootPhotoMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setShootPhotoMode_inline",
                   "Sets the photo shooting mode for the camera.  @param mode `ShootPhotoMode` enum value. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets the photo shooting mode for the camera.  @param mode `ShootPhotoMode` enum value. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setShootPhotoMode_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setShootPhotoMode_inline",
                   "SDK Key for setShootPhotoMode: Sets the photo shooting mode for the camera.  @param mode `ShootPhotoMode` enum value. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setShootPhotoMode: Sets the photo shooting mode for the camera.  @param mode `ShootPhotoMode` enum value. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setShootPhotoMode_inline",
                   "",
            ],
            [
                   "getShootPhotoMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getShootPhotoMode_inline",
                   "Returns the current photo shooting mode of the camera.  @param callback Asynchronous execution result.",
            ],
            [
                   "Returns the current photo shooting mode of the camera.  @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getShootPhotoMode_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getShootPhotoMode_inline",
                   "SDK Key for getShootPhotoMode: Returns the current photo shooting mode of the camera.  @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for getShootPhotoMode: Returns the current photo shooting mode of the camera.  @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getShootPhotoMode_inline",
                   "",
            ],
            [
                   "isTimeLapseSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isTimeLapseSupported_inline",
                   "Check if the current device supports time-lapse shoot mode. Supported only on the Osmo camera.  @return `true` if timelapse is supported.",
            ],
            [
                   "Check if the current device supports time-lapse shoot mode. Supported only on the Osmo camera.  @return `true` if timelapse is supported.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isTimeLapseSupported_inline",
                   "",
            ],
            [
                   "IS_TIME_LAPSE_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isTimeLapseSupported_inline",
                   "SDK Key for isTimeLapseSupported: Check if the current device supports time-lapse shoot mode. Supported only on the Osmo camera.  @return `true` if timelapse is supported.",
            ],
            [
                   "SDK Key for isTimeLapseSupported: Check if the current device supports time-lapse shoot mode. Supported only on the Osmo camera.  @return `true` if timelapse is supported.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isTimeLapseSupported_inline",
                   "",
            ],
            [
                   "isSuperResolutionSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSuperResolutionSupported_inline",
                   "Check if the current device supports super resolution shoot mode. Supported only on the Zenmuse H20 Series.  @return `true` if Super Resolution is supported.",
            ],
            [
                   "Check if the current device supports super resolution shoot mode. Supported only on the Zenmuse H20 Series.  @return `true` if Super Resolution is supported.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSuperResolutionSupported_inline",
                   "",
            ],
            [
                   "setSuperResolutionInfoCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSuperResolutionStateCallback_inline",
                   "Callback for updating the super resolution state.  @param superResStateCallback Callback method.",
            ],
            [
                   "Callback for updating the super resolution state.  @param superResStateCallback Callback method.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSuperResolutionStateCallback_inline",
                   "",
            ],
            [
                   "setSuperResolutionCaptureArea",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSuperResolutionCaptureArea_inline",
                   "Sets the capture area of super resolution. The area range must be within the range:`getMaxArea`.  @param area A RecF value of super resolution capture area. @param callback Callback method.",
            ],
            [
                   "Sets the capture area of super resolution. The area range must be within the range:`getMaxArea`.  @param area A RecF value of super resolution capture area. @param callback Callback method.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSuperResolutionCaptureArea_inline",
                   "",
            ],
            [
                   "SuperResolutionInfo",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "",
                   "Stores the super resolution information.",
            ],
            [
                   "Stores the super resolution information.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo_Callback.html",
                   "",
                   "Updates the super resolution state. In order to begin updates.",
            ],
            [
                   "Updates the super resolution state. In order to begin updates.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo_Callback.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo_Callback.html",
                   "#DJICamera_SuperResolutionInfo_Callback_onUpdate_inline",
                   "Called when the super resolution state has been updated.",
            ],
            [
                   "Called when the super resolution state has been updated.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo_Callback.html",
                   "#DJICamera_SuperResolutionInfo_Callback_onUpdate_inline",
                   "",
            ],
            [
                   "getMaxArea",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getMaxArea_inline",
                   "Gets the max area of super resolution. Depends with the camera angle, calculated automatically by the camera.  @return The max area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
            ],
            [
                   "Gets the max area of super resolution. Depends with the camera angle, calculated automatically by the camera.  @return The max area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getMaxArea_inline",
                   "",
            ],
            [
                   "getZoomTotalCount",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getZoomTotalCount_inline",
                   "Gets the total count of super resolution.  @return The total count of super resolution.",
            ],
            [
                   "Gets the total count of super resolution.  @return The total count of super resolution.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getZoomTotalCount_inline",
                   "",
            ],
            [
                   "getCaptureArea",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureArea_inline",
                   "Gets the area of super resolution.  @return The area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
            ],
            [
                   "Gets the area of super resolution.  @return The area of super resolution where (0,0) is the top left of the video preview and (1,1) is the bottom right.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureArea_inline",
                   "",
            ],
            [
                   "getCaptureColNum",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureColNum_inline",
                   "Gets the column number of super resolution.  @return The column number of capture.",
            ],
            [
                   "Gets the column number of super resolution.  @return The column number of capture.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureColNum_inline",
                   "",
            ],
            [
                   "getCaptureRowNum",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureRowNum_inline",
                   "Gets the row number of super resolution.  @return The row number of capture.",
            ],
            [
                   "Gets the row number of super resolution.  @return The row number of capture.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureRowNum_inline",
                   "",
            ],
            [
                   "isStorageOverFlow",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_isStorageOverFlow_inline",
                   "Gets whether the memory card is full.  @return `true` if the memory card is full. Please replace the SD card.",
            ],
            [
                   "Gets whether the memory card is full.  @return `true` if the memory card is full. Please replace the SD card.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_isStorageOverFlow_inline",
                   "",
            ],
            [
                   "getCaptureRemainingTime",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureRemainingTime_inline",
                   "Gets the remaining time of super resolution capture.  @return The remaining time of super resolution capture.",
            ],
            [
                   "Gets the remaining time of super resolution capture.  @return The remaining time of super resolution capture.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getCaptureRemainingTime_inline",
                   "",
            ],
            [
                   "getProgress",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getProgress_inline",
                   "Gets the captured progress percentage of super resolution.  @return The captured progress percentage of super resolution.",
            ],
            [
                   "Gets the captured progress percentage of super resolution.  @return The captured progress percentage of super resolution.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getProgress_inline",
                   "",
            ],
            [
                   "getZoomCapturedCount",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getZoomCapturedCount_inline",
                   "Gets the captured count of super resolution.  @return The captured count of super resolution.",
            ],
            [
                   "Gets the captured count of super resolution.  @return The captured count of super resolution.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getZoomCapturedCount_inline",
                   "",
            ],
            [
                   "getStatus",
                   2,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getStatus_inline",
                   "Gets the state of super resolution.  @return The state of super resolution.",
            ],
            [
                   "Gets the state of super resolution.  @return The state of super resolution.",
                   1,
                   "/Components/Camera/DJICamera_SuperResolutionInfo.html",
                   "#DJICamera_SuperResolutionInfo_getStatus_inline",
                   "",
            ],
            [
                   "SuperResolutionStatus",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_inline",
                   "The states of Super resolution.",
            ],
            [
                   "The states of Super resolution.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_inline",
                   "",
            ],
            [
                   "SELECTING",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Selecting_inline",
                   "Selecting. You could adjust super resolution area with `setSuperResolutionCaptureArea`.",
            ],
            [
                   "Selecting. You could adjust super resolution area with `setSuperResolutionCaptureArea`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Selecting_inline",
                   "",
            ],
            [
                   "IN_PROGRESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_InProgress_inline",
                   "Super resolution shooting in progress.",
            ],
            [
                   "Super resolution shooting in progress.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_InProgress_inline",
                   "",
            ],
            [
                   "FINISH",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Finish_inline",
                   "Super resolution shooting completed.",
            ],
            [
                   "Super resolution shooting completed.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Finish_inline",
                   "",
            ],
            [
                   "EXIT_OUT_OF_STORAGE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitOutOfStorage_inline",
                   "Stop shooting because there is no storage.",
            ],
            [
                   "Stop shooting because there is no storage.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitOutOfStorage_inline",
                   "",
            ],
            [
                   "EXIT_SHOOT_FAIL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitShootFail_inline",
                   "Stop shooting because the shooting failed.",
            ],
            [
                   "Stop shooting because the shooting failed.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitShootFail_inline",
                   "",
            ],
            [
                   "EXIT_GIMBAL_BLOCK",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitGimbalBlock_inline",
                   "Stop shooting because the gimbal is blocked.",
            ],
            [
                   "Stop shooting because the gimbal is blocked.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitGimbalBlock_inline",
                   "",
            ],
            [
                   "EXIT_GIMBAL_ABNORMAL_MOVE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitGimbalAbnormalMove_inline",
                   "Stop shooting because the gimbal did not move or move abnormally.",
            ],
            [
                   "Stop shooting because the gimbal did not move or move abnormally.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_ExitGimbalAbnormalMove_inline",
                   "",
            ],
            [
                   "TIP_GIMBAL_OUT_OF_RANGE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_TipGimbalOutOfRange_inline",
                   "Stop shooting because the angle of gimbal exceeds the maximum range.",
            ],
            [
                   "Stop shooting because the angle of gimbal exceeds the maximum range.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_TipGimbalOutOfRange_inline",
                   "",
            ],
            [
                   "TIP_OUT_OF_ZOOM",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_TipOutOfZoom_inline",
                   "The zoom of camera out of the maximum range.",
            ],
            [
                   "The zoom of camera out of the maximum range.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_TipOutOfZoom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Unknown_inline",
                   "Unknown error.",
            ],
            [
                   "Unknown error.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SuperResolutionStatus_Unknown_inline",
                   "",
            ],
            [
                   "isMediaDownloadModeSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isMediaDownloadModeSupported_inline",
                   "Check if the current device supports Media Download Mode.  @return `true` if the current device supports Media Download Mode, `false` otherwise.",
            ],
            [
                   "Check if the current device supports Media Download Mode.  @return `true` if the current device supports Media Download Mode, `false` otherwise.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isMediaDownloadModeSupported_inline",
                   "",
            ],
            [
                   "IS_MEDIA_DOWNLOAD_MODE_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isMediaDownloadModeSupported_inline",
                   "SDK Key for isMediaDownloadModeSupported: Check if the current device supports Media Download Mode.  @return `true` if the current device supports Media Download Mode, `false` otherwise.",
            ],
            [
                   "SDK Key for isMediaDownloadModeSupported: Check if the current device supports Media Download Mode.  @return `true` if the current device supports Media Download Mode, `false` otherwise.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isMediaDownloadModeSupported_inline",
                   "",
            ],
            [
                   "getMediaManager",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_mediaManager_inline",
                   "Media Manager is used for interaction when camera is in `MEDIA_DOWNLOAD`. The user can only access the manager when `isMediaDownloadModeSupported` returns `true`. @return The `MediaManager` object if the aircraft supports media list feature. Otherwise, returns `null`.  @return An instance of `MediaManager`.",
            ],
            [
                   "Media Manager is used for interaction when camera is in `MEDIA_DOWNLOAD`. The user can only access the manager when `isMediaDownloadModeSupported` returns `true`. @return The `MediaManager` object if the aircraft supports media list feature. Otherwise, returns `null`.  @return An instance of `MediaManager`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_mediaManager_inline",
                   "",
            ],
            [
                   "isPlaybackSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isPlaybackSupported_inline",
                   "Check if the current device supports Playback Mode.  @return A boolean value.",
            ],
            [
                   "Check if the current device supports Playback Mode.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isPlaybackSupported_inline",
                   "",
            ],
            [
                   "IS_PLAYBACK_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isPlaybackSupported_inline",
                   "SDK Key for isPlaybackSupported: Check if the current device supports Playback Mode.  @return A boolean value.",
            ],
            [
                   "SDK Key for isPlaybackSupported: Check if the current device supports Playback Mode.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_Media_isPlaybackSupported_inline",
                   "",
            ],
            [
                   "getPlaybackManager",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_playbackManager_inline",
                   "Gets the playback manager object. Playback Manager is used for interaction when camera is in `PLAYBACK`. User can only access to the manager when `isPlaybackSupported` returns `true`.  @return An instance of `PlaybackManager`.",
            ],
            [
                   "Gets the playback manager object. Playback Manager is used for interaction when camera is in `PLAYBACK`. User can only access to the manager when `isPlaybackSupported` returns `true`.  @return An instance of `PlaybackManager`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_playbackManager_inline",
                   "",
            ],
            [
                   "setExposureMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureMode_inline",
                   "Sets the camera's exposure mode. Check `ExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting. For Mavic 2 Enterprise Dual, the exposure mode is always `PROGRAM`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's exposure mode. Check `ExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting. For Mavic 2 Enterprise Dual, the exposure mode is always `PROGRAM`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureMode_inline",
                   "",
            ],
            [
                   "EXPOSURE_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureMode_inline",
                   "SDK Key for setExposureMode: Sets the camera's exposure mode. Check `ExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting. For Mavic 2 Enterprise Dual, the exposure mode is always `PROGRAM`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setExposureMode: Sets the camera's exposure mode. Check `ExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting. For Mavic 2 Enterprise Dual, the exposure mode is always `PROGRAM`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureMode_inline",
                   "",
            ],
            [
                   "getExposureMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureMode_inline",
                   "Gets the camera's exposure mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's exposure mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureMode_inline",
                   "",
            ],
            [
                   "EXPOSURE_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureMode_inline",
                   "SDK Key for getExposureMode: Gets the camera's exposure mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getExposureMode: Gets the camera's exposure mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureMode_inline",
                   "",
            ],
            [
                   "setISO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setISO_inline",
                   "Sets the camera's ISO value. See `ISO` to view all possible ISO settings for the camera. For the X5, X5R, Phantom 4 Pro camera, X4S and X5S, the ISO value can be set for all modes. For the other cameras, the ISO value can only be set when the camera exposure mode is in Manual mode. See the `setExposureMode` method for how to set exposure mode. For Mavic 2 Enterprise Dual, the ISO value is always `AUTO`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param iso The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's ISO value. See `ISO` to view all possible ISO settings for the camera. For the X5, X5R, Phantom 4 Pro camera, X4S and X5S, the ISO value can be set for all modes. For the other cameras, the ISO value can only be set when the camera exposure mode is in Manual mode. See the `setExposureMode` method for how to set exposure mode. For Mavic 2 Enterprise Dual, the ISO value is always `AUTO`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param iso The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setISO_inline",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setISO_inline",
                   "SDK Key for setISO: Sets the camera's ISO value. See `ISO` to view all possible ISO settings for the camera. For the X5, X5R, Phantom 4 Pro camera, X4S and X5S, the ISO value can be set for all modes. For the other cameras, the ISO value can only be set when the camera exposure mode is in Manual mode. See the `setExposureMode` method for how to set exposure mode. For Mavic 2 Enterprise Dual, the ISO value is always `AUTO`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param iso The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setISO: Sets the camera's ISO value. See `ISO` to view all possible ISO settings for the camera. For the X5, X5R, Phantom 4 Pro camera, X4S and X5S, the ISO value can be set for all modes. For the other cameras, the ISO value can only be set when the camera exposure mode is in Manual mode. See the `setExposureMode` method for how to set exposure mode. For Mavic 2 Enterprise Dual, the ISO value is always `AUTO`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param iso The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setISO_inline",
                   "",
            ],
            [
                   "getISO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getISO_inline",
                   "Gets the camera's ISO value. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's ISO value. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getISO_inline",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getISO_inline",
                   "SDK Key for getISO: Gets the camera's ISO value. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getISO: Gets the camera's ISO value. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getISO_inline",
                   "",
            ],
            [
                   "setShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setShutterSpeed_inline",
                   "Sets the camera shutter speed. To see all available shutterSpeed</code> value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutterSpeed</code> must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is Shutter mode or Manual mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param shutterSpeed The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera shutter speed. To see all available shutterSpeed</code> value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutterSpeed</code> must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is Shutter mode or Manual mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param shutterSpeed The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setShutterSpeed_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setShutterSpeed_inline",
                   "SDK Key for setShutterSpeed: Sets the camera shutter speed. To see all available shutterSpeed</code> value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutterSpeed</code> must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is Shutter mode or Manual mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param shutterSpeed The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setShutterSpeed: Sets the camera shutter speed. To see all available shutterSpeed</code> value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutterSpeed</code> must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is Shutter mode or Manual mode. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param shutterSpeed The ISO value to set the camera to use. Please check the enum CameraISOe in DJICameraSettingsDef to find all possible ISO values that the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setShutterSpeed_inline",
                   "",
            ],
            [
                   "getShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getShutterSpeed_inline",
                   "Gets the camera's shutter speed. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's shutter speed. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getShutterSpeed_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getShutterSpeed_inline",
                   "SDK Key for getShutterSpeed: Gets the camera's shutter speed. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getShutterSpeed: Gets the camera's shutter speed. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getShutterSpeed_inline",
                   "",
            ],
            [
                   "isAdjustableApertureSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableApertureSupported_inline",
                   "Gets whether the camera supports an adjustable aperture. Currently adjustable aperture is supported only by the X5, X5R, X4S, X5S cameras and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "Gets whether the camera supports an adjustable aperture. Currently adjustable aperture is supported only by the X5, X5R, X4S, X5S cameras and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableApertureSupported_inline",
                   "",
            ],
            [
                   "IS_ADJUSTABLE_APERTURE_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableApertureSupported_inline",
                   "SDK Key for isAdjustableApertureSupported: Gets whether the camera supports an adjustable aperture. Currently adjustable aperture is supported only by the X5, X5R, X4S, X5S cameras and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAdjustableApertureSupported: Gets whether the camera supports an adjustable aperture. Currently adjustable aperture is supported only by the X5, X5R, X4S, X5S cameras and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableApertureSupported_inline",
                   "",
            ],
            [
                   "setAperture",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAperture_inline",
                   "Sets the aperture value. This feature is available only when `isAdjustableApertureSupported` returns `true`.  Precondition:  The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the X5, X5R, X4S, X5S camera and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aperture The aperture to set. Check enum CameraLensFocusMode in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the aperture value. This feature is available only when `isAdjustableApertureSupported` returns `true`.  Precondition:  The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the X5, X5R, X4S, X5S camera and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aperture The aperture to set. Check enum CameraLensFocusMode in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAperture_inline",
                   "",
            ],
            [
                   "APERTURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAperture_inline",
                   "SDK Key for setAperture: Sets the aperture value. This feature is available only when `isAdjustableApertureSupported` returns `true`.  Precondition:  The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the X5, X5R, X4S, X5S camera and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aperture The aperture to set. Check enum CameraLensFocusMode in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAperture: Sets the aperture value. This feature is available only when `isAdjustableApertureSupported` returns `true`.  Precondition:  The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the X5, X5R, X4S, X5S camera and Mavic 2 Pro. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aperture The aperture to set. Check enum CameraLensFocusMode in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAperture_inline",
                   "",
            ],
            [
                   "getAperture",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAperture_inline",
                   "Gets the lens aperture. This feature is available only when `isAdjustableApertureSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens aperture. This feature is available only when `isAdjustableApertureSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAperture_inline",
                   "",
            ],
            [
                   "APERTURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAperture_inline",
                   "SDK Key for getAperture: Gets the lens aperture. This feature is available only when `isAdjustableApertureSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAperture: Gets the lens aperture. This feature is available only when `isAdjustableApertureSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAperture_inline",
                   "",
            ],
            [
                   "setMeteringMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMeteringMode_inline",
                   "Sets the camera's exposure metering. See `MeteringMode` to view all possible exposure metering settings for the camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result",
            ],
            [
                   "Sets the camera's exposure metering. See `MeteringMode` to view all possible exposure metering settings for the camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMeteringMode_inline",
                   "",
            ],
            [
                   "METERING_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMeteringMode_inline",
                   "SDK Key for setMeteringMode: Sets the camera's exposure metering. See `MeteringMode` to view all possible exposure metering settings for the camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result",
            ],
            [
                   "SDK Key for setMeteringMode: Sets the camera's exposure metering. See `MeteringMode` to view all possible exposure metering settings for the camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMeteringMode_inline",
                   "",
            ],
            [
                   "getMeteringMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMeteringMode_inline",
                   "Gets the camera's exposure metering. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's exposure metering. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMeteringMode_inline",
                   "",
            ],
            [
                   "METERING_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMeteringMode_inline",
                   "SDK Key for getMeteringMode: Gets the camera's exposure metering. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMeteringMode: Gets the camera's exposure metering. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMeteringMode_inline",
                   "",
            ],
            [
                   "setSpotMeteringTarget",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSpotMeteringAreaIndex_inline",
                   "Sets the spot metering area index. The camera image is divided into 96 spots defined by 12 columns and 8 rows. The row index range is [0,7], where the values increase top to bottom across the image. The column index range is [0, 11], where the values increase left to right. In order to make the method work, The camera exposure mode should be Program</code>, Shutter</code> or Aperture</code>, the exposure metering mode must be `SPOT`, and `setAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 11], where the values increase left to right. y is row index to be set. The value should falls in [0, 7], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the spot metering area index. The camera image is divided into 96 spots defined by 12 columns and 8 rows. The row index range is [0,7], where the values increase top to bottom across the image. The column index range is [0, 11], where the values increase left to right. In order to make the method work, The camera exposure mode should be Program</code>, Shutter</code> or Aperture</code>, the exposure metering mode must be `SPOT`, and `setAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 11], where the values increase left to right. y is row index to be set. The value should falls in [0, 7], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSpotMeteringAreaIndex_inline",
                   "",
            ],
            [
                   "SPOT_METERING_TARGET",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSpotMeteringAreaIndex_inline",
                   "SDK Key for setSpotMeteringTarget: Sets the spot metering area index. The camera image is divided into 96 spots defined by 12 columns and 8 rows. The row index range is [0,7], where the values increase top to bottom across the image. The column index range is [0, 11], where the values increase left to right. In order to make the method work, The camera exposure mode should be Program</code>, Shutter</code> or Aperture</code>, the exposure metering mode must be `SPOT`, and `setAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 11], where the values increase left to right. y is row index to be set. The value should falls in [0, 7], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSpotMeteringTarget: Sets the spot metering area index. The camera image is divided into 96 spots defined by 12 columns and 8 rows. The row index range is [0,7], where the values increase top to bottom across the image. The column index range is [0, 11], where the values increase left to right. In order to make the method work, The camera exposure mode should be Program</code>, Shutter</code> or Aperture</code>, the exposure metering mode must be `SPOT`, and `setAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 11], where the values increase left to right. y is row index to be set. The value should falls in [0, 7], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSpotMeteringAreaIndex_inline",
                   "",
            ],
            [
                   "getSpotMeteringTarget",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSpotMeteringAreaIndex_inline",
                   "Gets the spot metering area row index and column index. In order to make the method work, The camera exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the spot metering area row index and column index. In order to make the method work, The camera exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSpotMeteringAreaIndex_inline",
                   "",
            ],
            [
                   "SPOT_METERING_TARGET",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSpotMeteringAreaIndex_inline",
                   "SDK Key for getSpotMeteringTarget: Gets the spot metering area row index and column index. In order to make the method work, The camera exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSpotMeteringTarget: Gets the spot metering area row index and column index. In order to make the method work, The camera exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSpotMeteringAreaIndex_inline",
                   "",
            ],
            [
                   "setExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureCompensation_inline",
                   "Sets the camera's exposure compensation. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's exposure compensation. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureCompensation_inline",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureCompensation_inline",
                   "SDK Key for setExposureCompensation: Sets the camera's exposure compensation. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setExposureCompensation: Sets the camera's exposure compensation. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the camera exposure mode to shutter</code>, program</code> or aperture</code>. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureCompensation_inline",
                   "",
            ],
            [
                   "getExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureCompensation_inline",
                   "Gets the camera's exposure compensation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's exposure compensation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureCompensation_inline",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureCompensation_inline",
                   "SDK Key for getExposureCompensation: Gets the camera's exposure compensation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getExposureCompensation: Gets the camera's exposure compensation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureCompensation_inline",
                   "",
            ],
            [
                   "setAELock",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAELock_inline",
                   "Locks or unlocks the camera's AE (auto exposure).  Post condition:  If the AE lock is enabled, the spot metering area cannot be set. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param isLocked `true` if the camera AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Locks or unlocks the camera's AE (auto exposure).  Post condition:  If the AE lock is enabled, the spot metering area cannot be set. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param isLocked `true` if the camera AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAELock_inline",
                   "",
            ],
            [
                   "AE_LOCK",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAELock_inline",
                   "SDK Key for setAELock: Locks or unlocks the camera's AE (auto exposure).  Post condition:  If the AE lock is enabled, the spot metering area cannot be set. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param isLocked `true` if the camera AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAELock: Locks or unlocks the camera's AE (auto exposure).  Post condition:  If the AE lock is enabled, the spot metering area cannot be set. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param isLocked `true` if the camera AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAELock_inline",
                   "",
            ],
            [
                   "getAELock",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAELock_inline",
                   "Determines if the camera's AE (auto exposure) is locked. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if the camera's AE (auto exposure) is locked. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAELock_inline",
                   "",
            ],
            [
                   "AE_LOCK",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAELock_inline",
                   "SDK Key for getAELock: Determines if the camera's AE (auto exposure) is locked. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAELock: Determines if the camera's AE (auto exposure) is locked. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAELock_inline",
                   "",
            ],
            [
                   "setAutoAEUnlockEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoAEUnlockEnabled_inline",
                   "Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`. It is only supported X4S, X5S and Phantom 4 Pro cameras. For the other products, auto-unlocking is always enabled. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`. It is only supported X4S, X5S and Phantom 4 Pro cameras. For the other products, auto-unlocking is always enabled. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "AUTO_AE_UNLOCK_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoAEUnlockEnabled_inline",
                   "SDK Key for setAutoAEUnlockEnabled: Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`. It is only supported X4S, X5S and Phantom 4 Pro cameras. For the other products, auto-unlocking is always enabled. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAutoAEUnlockEnabled: Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`. It is only supported X4S, X5S and Phantom 4 Pro cameras. For the other products, auto-unlocking is always enabled. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "getAutoAEUnlockEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoAEUnlockEnabled_inline",
                   "Determines whether auto-unlocking of AE lock is enabled. It is only supported by X4S, X5S and Phantom 4 Pro cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether auto-unlocking of AE lock is enabled. It is only supported by X4S, X5S and Phantom 4 Pro cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "AUTO_AE_UNLOCK_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoAEUnlockEnabled_inline",
                   "SDK Key for getAutoAEUnlockEnabled: Determines whether auto-unlocking of AE lock is enabled. It is only supported by X4S, X5S and Phantom 4 Pro cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAutoAEUnlockEnabled: Determines whether auto-unlocking of AE lock is enabled. It is only supported by X4S, X5S and Phantom 4 Pro cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "setPhotoAEBCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoAEBParam_inline",
                   "Sets the camera's auto exposure bracketing (AEB) capture parameters.  @param count AEB capture count to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's auto exposure bracketing (AEB) capture parameters.  @param count AEB capture count to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoAEBParam_inline",
                   "",
            ],
            [
                   "PHOTO_AEB_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoAEBParam_inline",
                   "SDK Key for setPhotoAEBCount: Sets the camera's auto exposure bracketing (AEB) capture parameters.  @param count AEB capture count to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoAEBCount: Sets the camera's auto exposure bracketing (AEB) capture parameters.  @param count AEB capture count to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoAEBParam_inline",
                   "",
            ],
            [
                   "getPhotoAEBCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoAEBParam_inline",
                   "Gets the camera's AEB capture parameters.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's AEB capture parameters.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoAEBParam_inline",
                   "",
            ],
            [
                   "PHOTO_AEB_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoAEBParam_inline",
                   "SDK Key for getPhotoAEBCount: Gets the camera's AEB capture parameters.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoAEBCount: Gets the camera's AEB capture parameters.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoAEBParam_inline",
                   "",
            ],
            [
                   "setWhiteBalance",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setWhiteBalanceAndColorTemperature_inline",
                   "Sets the camera's white balance (color temperature). When white balance is `CUSTOM`, the colorTemperature argument is used. For all other values, the colorTemperature argument is ignored. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.  See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.",
            ],
            [
                   "Sets the camera's white balance (color temperature). When white balance is `CUSTOM`, the colorTemperature argument is used. For all other values, the colorTemperature argument is ignored. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.  See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setWhiteBalanceAndColorTemperature_inline",
                   "",
            ],
            [
                   "WHITE_BALANCE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setWhiteBalanceAndColorTemperature_inline",
                   "SDK Key for setWhiteBalance: Sets the camera's white balance (color temperature). When white balance is `CUSTOM`, the colorTemperature argument is used. For all other values, the colorTemperature argument is ignored. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.  See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.",
            ],
            [
                   "SDK Key for setWhiteBalance: Sets the camera's white balance (color temperature). When white balance is `CUSTOM`, the colorTemperature argument is used. For all other values, the colorTemperature argument is ignored. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.  See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setWhiteBalanceAndColorTemperature_inline",
                   "",
            ],
            [
                   "getWhiteBalance",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getWhiteBalanceAndColorTemperature_inline",
                   "Gets the camera's white balance and color temperature. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's white balance and color temperature. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getWhiteBalanceAndColorTemperature_inline",
                   "",
            ],
            [
                   "WHITE_BALANCE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getWhiteBalanceAndColorTemperature_inline",
                   "SDK Key for getWhiteBalance: Gets the camera's white balance and color temperature. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getWhiteBalance: Gets the camera's white balance and color temperature. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getWhiteBalanceAndColorTemperature_inline",
                   "",
            ],
            [
                   "isInterchangeableLensSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isChangeableLensSupported_inline",
                   "`true` if the changeable lens is supported by the camera. Currently a changeable lens is supported only by the X5, X5R and X5S cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "`true` if the changeable lens is supported by the camera. Currently a changeable lens is supported only by the X5, X5R and X5S cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isChangeableLensSupported_inline",
                   "",
            ],
            [
                   "IS_INTERCHANGEABLE_LENS_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isChangeableLensSupported_inline",
                   "SDK Key for isInterchangeableLensSupported: `true` if the changeable lens is supported by the camera. Currently a changeable lens is supported only by the X5, X5R and X5S cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isInterchangeableLensSupported: `true` if the changeable lens is supported by the camera. Currently a changeable lens is supported only by the X5, X5R and X5S cameras. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isChangeableLensSupported_inline",
                   "",
            ],
            [
                   "getLensInformation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensInformation_inline",
                   "Gets details of the installed lens. Supported only by the X5, X5R, X5S and X7 cameras. This is available only when `isInterchangeableLensSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets details of the installed lens. Supported only by the X5, X5R, X5S and X7 cameras. This is available only when `isInterchangeableLensSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensInformation_inline",
                   "",
            ],
            [
                   "LENS_INFORMATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensInformation_inline",
                   "SDK Key for getLensInformation: Gets details of the installed lens. Supported only by the X5, X5R, X5S and X7 cameras. This is available only when `isInterchangeableLensSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getLensInformation: Gets details of the installed lens. Supported only by the X5, X5R, X5S and X7 cameras. This is available only when `isInterchangeableLensSupported` returns `true`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensInformation_inline",
                   "",
            ],
            [
                   "isDigitalZoomSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isDigitalZoomScaleSupported_inline",
                   "Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isDigitalZoomScaleSupported_inline",
                   "",
            ],
            [
                   "IS_DIGITAL_ZOOM_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isDigitalZoomScaleSupported_inline",
                   "SDK Key for isDigitalZoomSupported: Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isDigitalZoomSupported: Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isDigitalZoomScaleSupported_inline",
                   "",
            ],
            [
                   "setDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalZoomScale_inline",
                   "Adjusts the digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and XT 2 camera, DJI Mini 2. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param factor The valid range is from 1.0 to 4.0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Adjusts the digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and XT 2 camera, DJI Mini 2. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param factor The valid range is from 1.0 to 4.0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalZoomScale_inline",
                   "",
            ],
            [
                   "DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalZoomScale_inline",
                   "SDK Key for setDigitalZoomFactor: Adjusts the digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and XT 2 camera, DJI Mini 2. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param factor The valid range is from 1.0 to 4.0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setDigitalZoomFactor: Adjusts the digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and XT 2 camera, DJI Mini 2. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param factor The valid range is from 1.0 to 4.0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalZoomScale_inline",
                   "",
            ],
            [
                   "getDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalZoomScale_inline",
                   "Gets current digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalZoomScale_inline",
                   "",
            ],
            [
                   "DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalZoomScale_inline",
                   "SDK Key for getDigitalZoomFactor: Gets current digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getDigitalZoomFactor: Gets current digital zoom. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalZoomScale_inline",
                   "",
            ],
            [
                   "isOpticalZoomSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isOpticalZoomSupported_inline",
                   "Check if camera supports optical zoom. It is only supported by X5, X5R and X5S camera with the Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ lens, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports optical zoom.",
            ],
            [
                   "Check if camera supports optical zoom. It is only supported by X5, X5R and X5S camera with the Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ lens, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports optical zoom.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isOpticalZoomSupported_inline",
                   "",
            ],
            [
                   "IS_OPTICAL_ZOOM_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isOpticalZoomSupported_inline",
                   "SDK Key for isOpticalZoomSupported: Check if camera supports optical zoom. It is only supported by X5, X5R and X5S camera with the Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ lens, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports optical zoom.",
            ],
            [
                   "SDK Key for isOpticalZoomSupported: Check if camera supports optical zoom. It is only supported by X5, X5R and X5S camera with the Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ lens, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports optical zoom.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isOpticalZoomSupported_inline",
                   "",
            ],
            [
                   "getOpticalZoomSpec",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomSpec_inline",
                   "Gets the specification of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the specification of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomSpec_inline",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_SPEC",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomSpec_inline",
                   "SDK Key for getOpticalZoomSpec: Gets the specification of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getOpticalZoomSpec: Gets the specification of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomSpec_inline",
                   "",
            ],
            [
                   "setOpticalZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOpticalZoomFocalLength_inline",
                   "Sets focal length of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, X5S camera with Panasonic Lumix 14-42mm/3.5-5.6 HD or Olympus M.Zuiko 9-18mm/4.0-5.6, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets focal length of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, X5S camera with Panasonic Lumix 14-42mm/3.5-5.6 HD or Olympus M.Zuiko 9-18mm/4.0-5.6, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_FOCAL_LENGTH",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOpticalZoomFocalLength_inline",
                   "SDK Key for setOpticalZoomFocalLength: Sets focal length of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, X5S camera with Panasonic Lumix 14-42mm/3.5-5.6 HD or Olympus M.Zuiko 9-18mm/4.0-5.6, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setOpticalZoomFocalLength: Sets focal length of the zoom lens. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, X5S camera with Panasonic Lumix 14-42mm/3.5-5.6 HD or Olympus M.Zuiko 9-18mm/4.0-5.6, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "getOpticalZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomFocalLength_inline",
                   "Gets zoom lens focal length in units of 0.1mm. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets zoom lens focal length in units of 0.1mm. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_FOCAL_LENGTH",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomFocalLength_inline",
                   "SDK Key for getOpticalZoomFocalLength: Gets zoom lens focal length in units of 0.1mm. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getOpticalZoomFocalLength: Gets zoom lens focal length in units of 0.1mm. It is only supported by X5, X5R and X5S camera with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "getOpticalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomScale_inline",
                   "Gets current optical zoom factor with range [1, 30]. It is only supported Z30 camera. The Z30 zoom factor can be changed with `setOpticalZoomFocalLength` and `startContinuousOpticalZoom`. The zoom factor is then calculated and given through this method. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current optical zoom factor with range [1, 30]. It is only supported Z30 camera. The Z30 zoom factor can be changed with `setOpticalZoomFocalLength` and `startContinuousOpticalZoom`. The zoom factor is then calculated and given through this method. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomScale_inline",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_SCALE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomScale_inline",
                   "SDK Key for getOpticalZoomFactor: Gets current optical zoom factor with range [1, 30]. It is only supported Z30 camera. The Z30 zoom factor can be changed with `setOpticalZoomFocalLength` and `startContinuousOpticalZoom`. The zoom factor is then calculated and given through this method. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getOpticalZoomFactor: Gets current optical zoom factor with range [1, 30]. It is only supported Z30 camera. The Z30 zoom factor can be changed with `setOpticalZoomFocalLength` and `startContinuousOpticalZoom`. The zoom factor is then calculated and given through this method. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOpticalZoomScale_inline",
                   "",
            ],
            [
                   "startContinuousOpticalZoom",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_startContinuousOpticalZoom_inline",
                   "Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series, please use class `Lens`.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series, please use class `Lens`.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_startContinuousOpticalZoom_inline",
                   "",
            ],
            [
                   "START_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_startContinuousOpticalZoom_inline",
                   "SDK Key for startContinuousOpticalZoom: Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series, please use class `Lens`.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startContinuousOpticalZoom: Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series, please use class `Lens`.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_startContinuousOpticalZoom_inline",
                   "",
            ],
            [
                   "stopContinuousOpticalZoom",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_stopContinuousOpticalZoom_inline",
                   "Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_stopContinuousOpticalZoom_inline",
                   "",
            ],
            [
                   "STOP_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_stopContinuousOpticalZoom_inline",
                   "SDK Key for stopContinuousOpticalZoom: Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for stopContinuousOpticalZoom: Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. It is only supported by X5, X5R and X5S camera on Osmo with lens Olympus M.Zuiko ED 14-42mm f/3.5-5.6 EZ, Z3 camera, Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_stopContinuousOpticalZoom_inline",
                   "",
            ],
            [
                   "isHybridZoomSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isHybridZoomSupported_inline",
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Check if camera supports hybrid zoom. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports hybrid zoom.",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Check if camera supports hybrid zoom. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return `true` if camera supports hybrid zoom.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isHybridZoomSupported_inline",
                   "",
            ],
            [
                   "getHybridZoomSpec",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHybridZoomSpecWithCompletion_inline",
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Gets the specification of the zoom lens. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Gets the specification of the zoom lens. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHybridZoomSpecWithCompletion_inline",
                   "",
            ],
            [
                   "setHybridZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHybridZoomFocalLength_inline",
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Sets focal length of the zoom lens. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinHybridFocalLength`, `getMaxHybridFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Sets focal length of the zoom lens. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focalLength Focal length of zoom lens. Valid range is [`getMinHybridFocalLength`, `getMaxHybridFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHybridZoomFocalLength_inline",
                   "",
            ],
            [
                   "getHybridZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHybridZoomFocalLength_inline",
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Gets zoom lens focal length in units of 0.1mm. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Camera will automatically switch over to digital zoom when optical zoom range is exceeded. Gets zoom lens focal length in units of 0.1mm. It is only supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHybridZoomFocalLength_inline",
                   "",
            ],
            [
                   "isTapZoomSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isTapZoomSupported_inline",
                   "Determines whether the current camera supports TapZoom feature. TapZoom is only supported by Z30 camera. @return `true` if the camera supports TapZoom. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "Determines whether the current camera supports TapZoom feature. TapZoom is only supported by Z30 camera. @return `true` if the camera supports TapZoom. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isTapZoomSupported_inline",
                   "",
            ],
            [
                   "IS_TAP_ZOOM_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isTapZoomSupported_inline",
                   "SDK Key for isTapZoomSupported: Determines whether the current camera supports TapZoom feature. TapZoom is only supported by Z30 camera. @return `true` if the camera supports TapZoom. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isTapZoomSupported: Determines whether the current camera supports TapZoom feature. TapZoom is only supported by Z30 camera. @return `true` if the camera supports TapZoom. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isTapZoomSupported_inline",
                   "",
            ],
            [
                   "setTapZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomEnabled_inline",
                   "Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled The execution callback with the returned execution result. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled The execution callback with the returned execution result. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomEnabled_inline",
                   "",
            ],
            [
                   "TAP_ZOOM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomEnabled_inline",
                   "SDK Key for setTapZoomEnabled: Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled The execution callback with the returned execution result. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setTapZoomEnabled: Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled The execution callback with the returned execution result. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomEnabled_inline",
                   "",
            ],
            [
                   "getTapZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomEnabled_inline",
                   "Determines whether TapZoom is enabled. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether TapZoom is enabled. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomEnabled_inline",
                   "",
            ],
            [
                   "TAP_ZOOM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomEnabled_inline",
                   "SDK Key for getTapZoomEnabled: Determines whether TapZoom is enabled. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getTapZoomEnabled: Determines whether TapZoom is enabled. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomEnabled_inline",
                   "",
            ],
            [
                   "setTapZoomMultiplier",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomMultiplier_inline",
                   "TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "TAP_ZOOM_MULTIPLIER",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomMultiplier_inline",
                   "SDK Key for setTapZoomMultiplier: TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setTapZoomMultiplier: TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "getTapZoomMultiplier",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomMultiplier_inline",
                   "Gets the multiplier for TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the multiplier for TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "TAP_ZOOM_MULTIPLIER",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomMultiplier_inline",
                   "SDK Key for getTapZoomMultiplier: Gets the multiplier for TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getTapZoomMultiplier: Gets the multiplier for TapZoom. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "tapZoomAtTarget",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_tapZoomAtTarget_inline",
                   "TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param target The CameraTapZoomTargetPoint to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param target The CameraTapZoomTargetPoint to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_tapZoomAtTarget_inline",
                   "",
            ],
            [
                   "TAP_ZOOM_AT_TARGET",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_tapZoomAtTarget_inline",
                   "SDK Key for tapZoomAtTarget: TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param target The CameraTapZoomTargetPoint to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for tapZoomAtTarget: TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. It is only supported Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param target The CameraTapZoomTargetPoint to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_tapZoomAtTarget_inline",
                   "",
            ],
            [
                   "setTapZoomStateCallback",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomStateCallback_inline",
                   "Sets the tap zoom state callback. The callback's `onUpdate` method will be called when the camera's zoom state is updated. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Sets the tap zoom state callback. The callback's `onUpdate` method will be called when the camera's zoom state is updated. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTapZoomStateCallback_inline",
                   "",
            ],
            [
                   "isAdjustableFocalPointSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableFocalPointSupported_inline",
                   "Determines whether the camera supports an adjustable focal point. Currently, the adjustable focal point is supported by the X5, X5R, Z3, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "Determines whether the camera supports an adjustable focal point. Currently, the adjustable focal point is supported by the X5, X5R, Z3, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableFocalPointSupported_inline",
                   "",
            ],
            [
                   "IS_ADJUSTABLE_FOCAL_POINT_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableFocalPointSupported_inline",
                   "SDK Key for isAdjustableFocalPointSupported: Determines whether the camera supports an adjustable focal point. Currently, the adjustable focal point is supported by the X5, X5R, Z3, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAdjustableFocalPointSupported: Determines whether the camera supports an adjustable focal point. Currently, the adjustable focal point is supported by the X5, X5R, Z3, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAdjustableFocalPointSupported_inline",
                   "",
            ],
            [
                   "setFocusMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusMode_inline",
                   "Sets the lens focus mode. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the X5, X5R, Z3 cameras (Z3 camera can only support `AUTO`), the Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lens focus mode. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the X5, X5R, Z3 cameras (Z3 camera can only support `AUTO`), the Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusMode_inline",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusMode_inline",
                   "SDK Key for setFocusMode: Sets the lens focus mode. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the X5, X5R, Z3 cameras (Z3 camera can only support `AUTO`), the Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFocusMode: Sets the lens focus mode. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the X5, X5R, Z3 cameras (Z3 camera can only support `AUTO`), the Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusMode_inline",
                   "",
            ],
            [
                   "getFocusMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusMode_inline",
                   "Gets the lens focus mode. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focus mode. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusMode_inline",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusMode_inline",
                   "SDK Key for getFocusMode: Gets the lens focus mode. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFocusMode: Gets the lens focus mode. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Z30, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusMode_inline",
                   "",
            ],
            [
                   "setFocusTarget",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusTarget_inline",
                   "Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Phantom 4 Pro camera, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera, X4S and X5S. camera, X4S and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Phantom 4 Pro camera, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera, X4S and X5S. camera, X4S and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusTarget_inline",
                   "",
            ],
            [
                   "FOCUS_TARGET",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusTarget_inline",
                   "SDK Key for setFocusTarget: Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Phantom 4 Pro camera, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera, X4S and X5S. camera, X4S and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFocusTarget: Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera, Phantom 4 Pro camera, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera, X4S and X5S. camera, X4S and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusTarget_inline",
                   "",
            ],
            [
                   "getFocusTarget",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusTarget_inline",
                   "Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera and Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera and Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusTarget_inline",
                   "",
            ],
            [
                   "FOCUS_TARGET",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusTarget_inline",
                   "SDK Key for getFocusTarget: Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera and Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFocusTarget: Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Mavic Pro camera and Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusTarget_inline",
                   "",
            ],
            [
                   "setFocusAssistantSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusAssistantEnabled_inline",
                   "Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3, Phantom 4 Pro camera, X4S and X5S. Because Z3 only supports AF mode, `isEnabledMF` will be ignored.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3, Phantom 4 Pro camera, X4S and X5S. Because Z3 only supports AF mode, `isEnabledMF` will be ignored.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusAssistantEnabled_inline",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusAssistantEnabled_inline",
                   "SDK Key for setFocusAssistantSettings: Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3, Phantom 4 Pro camera, X4S and X5S. Because Z3 only supports AF mode, `isEnabledMF` will be ignored.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFocusAssistantSettings: Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3, Phantom 4 Pro camera, X4S and X5S. Because Z3 only supports AF mode, `isEnabledMF` will be ignored.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusAssistantEnabled_inline",
                   "",
            ],
            [
                   "getFocusAssistantSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusAssistantEnabled_inline",
                   "Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4s and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4s and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusAssistantEnabled_inline",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusAssistantEnabled_inline",
                   "SDK Key for getFocusAssistantSettings: Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4s and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFocusAssistantSettings: Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4s and X5S. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusAssistantEnabled_inline",
                   "",
            ],
            [
                   "getFocusRingValueUpperBound",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValueUpperBound_inline",
                   "Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValueUpperBound_inline",
                   "",
            ],
            [
                   "FOCUS_RING_VALUE_UPPER_BOUND",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValueUpperBound_inline",
                   "SDK Key for getFocusRingValueUpperBound: Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFocusRingValueUpperBound: Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro camera, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValueUpperBound_inline",
                   "",
            ],
            [
                   "setFocusRingValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusRingValue_inline",
                   "Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported only by X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported only by X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusRingValue_inline",
                   "",
            ],
            [
                   "FOCUS_RING_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusRingValue_inline",
                   "SDK Key for setFocusRingValue: Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported only by X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFocusRingValue: Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported only by X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLensFocusRingValue_inline",
                   "",
            ],
            [
                   "getFocusRingValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValue_inline",
                   "Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValue_inline",
                   "",
            ],
            [
                   "FOCUS_RING_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValue_inline",
                   "SDK Key for getFocusRingValue: Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFocusRingValue: Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported only by the X5, X5R, Z3 cameras, Phantom 4 Pro, X4S, X5S, Mavic 2 Pro, Mavic 2 Zoom Camera, Mavic 2 Enterprise Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLensFocusRingValue_inline",
                   "",
            ],
            [
                   "SUCCESS_BUT_OUT_OF_SCREEN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Success_But_Out_Of_Screen_inline",
                   "Success to get the pin point location, but point is out of liveview, should show as side indicator, please reference to DJI pilot.",
            ],
            [
                   "Success to get the pin point location, but point is out of liveview, should show as side indicator, please reference to DJI pilot.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Success_But_Out_Of_Screen_inline",
                   "",
            ],
            [
                   "SUCCESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Success_inline",
                   "Success to get the pin point location, the point is insde the liveview.",
            ],
            [
                   "Success to get the pin point location, the point is insde the liveview.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Success_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Failed_inline",
                   "Failed to get the pin point location.",
            ],
            [
                   "Failed to get the pin point location.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Failed_inline",
                   "",
            ],
            [
                   "INVALID_DRONE_POSITION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Invalid_Drone_Position_inline",
                   "Failed to get the pin point location, because the drone position is invalid.",
            ],
            [
                   "Failed to get the pin point location, because the drone position is invalid.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Invalid_Drone_Position_inline",
                   "",
            ],
            [
                   "INVALID_POINT_POSITION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Invalid_Point_Position_inline",
                   "Failed to get the pin point location, because the input GPS location is invalid.",
            ],
            [
                   "Failed to get the pin point location, because the input GPS location is invalid.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Invalid_Point_Position_inline",
                   "",
            ],
            [
                   "GIMBAL_ATTI_ERROR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Gimbal_Atti_Error_inline",
                   "Failed to get the pin point location, because of gimbal attitude error.",
            ],
            [
                   "Failed to get the pin point location, because of gimbal attitude error.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Gimbal_Atti_Error_inline",
                   "",
            ],
            [
                   "CAMEAR_ERROR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Camera_Error_inline",
                   "Failed to get the pin point location, because of camera error.",
            ],
            [
                   "Failed to get the pin point location, because of camera error.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_Camera_Error_inline",
                   "",
            ],
            [
                   "Result",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_inline",
                   "Defines the result of pin point callback.",
            ],
            [
                   "Defines the result of pin point callback.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_PinPointResult_inline",
                   "",
            ],
            [
                   "getX",
                   2,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "#DJICamera_PinPoint_GetX_inline",
                   "Gets the horizontal position of liveview.  @return X position.",
            ],
            [
                   "Gets the horizontal position of liveview.  @return X position.",
                   1,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "#DJICamera_PinPoint_GetX_inline",
                   "",
            ],
            [
                   "getY",
                   2,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "#DJICamera_PinPoint_GetY_inline",
                   "Gets the vertical position of liveview.  @return X position.",
            ],
            [
                   "Gets the vertical position of liveview.  @return X position.",
                   1,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "#DJICamera_PinPoint_GetY_inline",
                   "",
            ],
            [
                   "PinPoint",
                   2,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "",
                   "Pin point of the liveview. The point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
            ],
            [
                   "Pin point of the liveview. The point is normalized to [0,1] where (0,0) is the top left corner and (1,1) is the bottom right.",
                   1,
                   "/Components/Camera/DJICamera_PinPoint.html",
                   "",
                   "",
            ],
            [
                   "getPinPoints",
                   2,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "#DJICamera_PinPointInfo_GetPinPoints_inline",
                   "Gets the pin points location. If the `setDisplayMode` is `PIP`:`SIDE_BY_SIDE`, it will return two pin points.  @return calculated pin points.",
            ],
            [
                   "Gets the pin points location. If the `setDisplayMode` is `PIP`:`SIDE_BY_SIDE`, it will return two pin points.  @return calculated pin points.",
                   1,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "#DJICamera_PinPointInfo_GetPinPoints_inline",
                   "",
            ],
            [
                   "getResult",
                   2,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "#DJICamera_PinPointInfo_GetResult_inline",
                   "Gets the result of the callback.  @return result of the callback",
            ],
            [
                   "Gets the result of the callback.  @return result of the callback",
                   1,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "#DJICamera_PinPointInfo_GetResult_inline",
                   "",
            ],
            [
                   "PinPointInfo",
                   2,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "",
                   "Pin point information, include the pin points location in the liveview and callback result.  Supported by Zenmuse H20 Series.",
            ],
            [
                   "Pin point information, include the pin points location in the liveview and callback result.  Supported by Zenmuse H20 Series.",
                   1,
                   "/Components/Camera/DJICamera_PinPointInfo.html",
                   "",
                   "",
            ],
            [
                   "getLiveviewLocationWithGPS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_GetLiveviewLocationWithGPS_inline",
                   "Gets the PinPoint information with GPS which is used to show PinPoint in the liveview. Supported by Zenmuse H20 Series.  @param pointPos The GPS location, you could get the location from `getTargetLocation` or get the location with map. @param physicalSource The physical source of a video feed. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the PinPoint information with GPS which is used to show PinPoint in the liveview. Supported by Zenmuse H20 Series.  @param pointPos The GPS location, you could get the location from `getTargetLocation` or get the location with map. @param physicalSource The physical source of a video feed. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_GetLiveviewLocationWithGPS_inline",
                   "",
            ],
            [
                   "setLinkZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SetLinkZoomEnabled_inline",
                   "Enable or disable the link zoom function. After enabling the link zoom function, call `setThermalDigitalZoomFactor` to achieve synchronous zooming of the infrared lens and the zoom lens.  In the split-screen mode PIP, the user can compare the images of the infrared lens and the zoom lens more efficiently.  Supported by Zenmuse H20 Series.  @param enabled True to enable link zoom. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enable or disable the link zoom function. After enabling the link zoom function, call `setThermalDigitalZoomFactor` to achieve synchronous zooming of the infrared lens and the zoom lens.  In the split-screen mode PIP, the user can compare the images of the infrared lens and the zoom lens more efficiently.  Supported by Zenmuse H20 Series.  @param enabled True to enable link zoom. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SetLinkZoomEnabled_inline",
                   "",
            ],
            [
                   "getLinkZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_GetLinkZoomEnabled_inline",
                   "Gets the link zoom status. Supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the link zoom status. Supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_GetLinkZoomEnabled_inline",
                   "",
            ],
            [
                   "restoreFactorySettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadFactorySettings_inline",
                   "Load the camera's factory settings.  Post condition: The camera will reboot itself.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Load the camera's factory settings.  Post condition: The camera will reboot itself.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadFactorySettings_inline",
                   "",
            ],
            [
                   "CameraKey.RESTORE_FACTORY_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadFactorySettings_inline",
                   "SDK Key for restoreFactorySettings: Load the camera's factory settings.  Post condition: The camera will reboot itself.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for restoreFactorySettings: Load the camera's factory settings.  Post condition: The camera will reboot itself.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadFactorySettings_inline",
                   "",
            ],
            [
                   "saveSettingsToProfile",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_saveSettings_inline",
                   "Saves the current camera settings permanently to the specified profile. See `CustomSettingsProfile` to view all possible camera users.  @param profile Camera profile for which to store camera settings. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Saves the current camera settings permanently to the specified profile. See `CustomSettingsProfile` to view all possible camera users.  @param profile Camera profile for which to store camera settings. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_saveSettings_inline",
                   "",
            ],
            [
                   "SAVE_SETTINGS_TO_PROFILE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_saveSettings_inline",
                   "SDK Key for saveSettingsToProfile: Saves the current camera settings permanently to the specified profile. See `CustomSettingsProfile` to view all possible camera users.  @param profile Camera profile for which to store camera settings. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for saveSettingsToProfile: Saves the current camera settings permanently to the specified profile. See `CustomSettingsProfile` to view all possible camera users.  @param profile Camera profile for which to store camera settings. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_saveSettings_inline",
                   "",
            ],
            [
                   "loadSettingsFromProfile",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadSettings_inline",
                   "Load camera settings from the specified user.  Post condition:  The camera will reboot itself.  @param profile Camera profile to load camera settings from. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Load camera settings from the specified user.  Post condition:  The camera will reboot itself.  @param profile Camera profile to load camera settings from. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadSettings_inline",
                   "",
            ],
            [
                   "LOAD_SETTINGS_FROM_PROFILE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadSettings_inline",
                   "SDK Key for loadSettingsFromProfile: Load camera settings from the specified user.  Post condition:  The camera will reboot itself.  @param profile Camera profile to load camera settings from. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for loadSettingsFromProfile: Load camera settings from the specified user.  Post condition:  The camera will reboot itself.  @param profile Camera profile to load camera settings from. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_loadSettings_inline",
                   "",
            ],
            [
                   "setPhotoAspectRatio",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRatio_inline",
                   "Sets the camera's aspect ratio for photos. See `PhotoAspectRatio` to view all possible ratios. Not supported by Z30 camera as the aspect ratio of Z30 is always `RATIO_16_9`. Not supported by XTS camera as the aspect ratio of XTS is always `RATIO_4_3`. For Zenmuse H20 and Zenmuse H20T, please use class `Lens`.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's aspect ratio for photos. See `PhotoAspectRatio` to view all possible ratios. Not supported by Z30 camera as the aspect ratio of Z30 is always `RATIO_16_9`. Not supported by XTS camera as the aspect ratio of XTS is always `RATIO_4_3`. For Zenmuse H20 and Zenmuse H20T, please use class `Lens`.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRatio_inline",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRatio_inline",
                   "SDK Key for setPhotoAspectRatio: Sets the camera's aspect ratio for photos. See `PhotoAspectRatio` to view all possible ratios. Not supported by Z30 camera as the aspect ratio of Z30 is always `RATIO_16_9`. Not supported by XTS camera as the aspect ratio of XTS is always `RATIO_4_3`. For Zenmuse H20 and Zenmuse H20T, please use class `Lens`.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoAspectRatio: Sets the camera's aspect ratio for photos. See `PhotoAspectRatio` to view all possible ratios. Not supported by Z30 camera as the aspect ratio of Z30 is always `RATIO_16_9`. Not supported by XTS camera as the aspect ratio of XTS is always `RATIO_4_3`. For Zenmuse H20 and Zenmuse H20T, please use class `Lens`.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRatio_inline",
                   "",
            ],
            [
                   "getPhotoAspectRatio",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRatio_inline",
                   "Gets the camera's aspect ratio for photos. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's aspect ratio for photos. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRatio_inline",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRatio_inline",
                   "SDK Key for getPhotoAspectRatio: Gets the camera's aspect ratio for photos. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoAspectRatio: Gets the camera's aspect ratio for photos. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRatio_inline",
                   "",
            ],
            [
                   "setPhotoFileFormat",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoFileFormat_inline",
                   "Sets the camera's photo file format. See `PhotoFileFormat` to view all possible photo formats to which the camera can be set. Also supported by thermal imaging camera. Not supported by Z30 camera and Mavic 2 Enterprise Dual as the photo file format for Z30 is always `JPEG`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Photo file format used when the camera takes a photo. Check the enum `PhotoFileFormat` to find all possible photo formats the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's photo file format. See `PhotoFileFormat` to view all possible photo formats to which the camera can be set. Also supported by thermal imaging camera. Not supported by Z30 camera and Mavic 2 Enterprise Dual as the photo file format for Z30 is always `JPEG`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Photo file format used when the camera takes a photo. Check the enum `PhotoFileFormat` to find all possible photo formats the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoFileFormat_inline",
                   "SDK Key for setPhotoFileFormat: Sets the camera's photo file format. See `PhotoFileFormat` to view all possible photo formats to which the camera can be set. Also supported by thermal imaging camera. Not supported by Z30 camera and Mavic 2 Enterprise Dual as the photo file format for Z30 is always `JPEG`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Photo file format used when the camera takes a photo. Check the enum `PhotoFileFormat` to find all possible photo formats the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoFileFormat: Sets the camera's photo file format. See `PhotoFileFormat` to view all possible photo formats to which the camera can be set. Also supported by thermal imaging camera. Not supported by Z30 camera and Mavic 2 Enterprise Dual as the photo file format for Z30 is always `JPEG`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Photo file format used when the camera takes a photo. Check the enum `PhotoFileFormat` to find all possible photo formats the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoFileFormat_inline",
                   "",
            ],
            [
                   "getPhotoFileFormat",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoFileFormat_inline",
                   "Gets the camera's photo file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's photo file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoFileFormat_inline",
                   "SDK Key for getPhotoFileFormat: Gets the camera's photo file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoFileFormat: Gets the camera's photo file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoFileFormat_inline",
                   "",
            ],
            [
                   "setPhotoBurstCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoBurstCount_inline",
                   "Sets the burst shoot count for the camera when the user wants to use that feature. Check `PhotoBurstCount` to view all possible burst count values to which the camera can be set.  @param count The number of photos to take in one  Burst shot. Please check the enum `PhotoBurstCount` to find all possible burst count values the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the burst shoot count for the camera when the user wants to use that feature. Check `PhotoBurstCount` to view all possible burst count values to which the camera can be set.  @param count The number of photos to take in one  Burst shot. Please check the enum `PhotoBurstCount` to find all possible burst count values the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoBurstCount_inline",
                   "SDK Key for setPhotoBurstCount: Sets the burst shoot count for the camera when the user wants to use that feature. Check `PhotoBurstCount` to view all possible burst count values to which the camera can be set.  @param count The number of photos to take in one  Burst shot. Please check the enum `PhotoBurstCount` to find all possible burst count values the camera can be set to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoBurstCount: Sets the burst shoot count for the camera when the user wants to use that feature. Check `PhotoBurstCount` to view all possible burst count values to which the camera can be set.  @param count The number of photos to take in one  Burst shot. Please check the enum `PhotoBurstCount` to find all possible burst count values the camera can be set to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoBurstCount_inline",
                   "",
            ],
            [
                   "getPhotoBurstCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoBurstCount_inline",
                   "Gets the burst count type.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the burst count type.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoBurstCount_inline",
                   "SDK Key for getPhotoBurstCount: Gets the burst count type.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoBurstCount: Gets the burst count type.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoBurstCount_inline",
                   "",
            ],
            [
                   "setPhotoRAWBurstCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRAWBurstCount_inline",
                   "Sets the RAW image burst shoot count for the camera when the user wants to use that feature. See `PhotoBurstCount` to view all possible burst count values to which the camera can be set. It is only supported Inspire 2.  @param count The number of photos to take in one RAW burst shoot. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the RAW image burst shoot count for the camera when the user wants to use that feature. See `PhotoBurstCount` to view all possible burst count values to which the camera can be set. It is only supported Inspire 2.  @param count The number of photos to take in one RAW burst shoot. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRAWBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_RAW_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRAWBurstCount_inline",
                   "SDK Key for setPhotoRAWBurstCount: Sets the RAW image burst shoot count for the camera when the user wants to use that feature. See `PhotoBurstCount` to view all possible burst count values to which the camera can be set. It is only supported Inspire 2.  @param count The number of photos to take in one RAW burst shoot. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setPhotoRAWBurstCount: Sets the RAW image burst shoot count for the camera when the user wants to use that feature. See `PhotoBurstCount` to view all possible burst count values to which the camera can be set. It is only supported Inspire 2.  @param count The number of photos to take in one RAW burst shoot. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoRAWBurstCount_inline",
                   "",
            ],
            [
                   "getPhotoRAWBurstCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRAWBurstCount_inline",
                   "Gets the RAW image burst count. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the RAW image burst count. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRAWBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_RAW_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRAWBurstCount_inline",
                   "SDK Key for getPhotoRAWBurstCount: Gets the RAW image burst count. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoRAWBurstCount: Gets the RAW image burst count. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoRAWBurstCount_inline",
                   "",
            ],
            [
                   "setPhotoTimeIntervalSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoIntervalParam_inline",
                   "Sets the interval shoot parameters. The camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. Also supported by thermal imaging camera.  @param settings An instance of `PhotoTimeIntervalSettings`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the interval shoot parameters. The camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. Also supported by thermal imaging camera.  @param settings An instance of `PhotoTimeIntervalSettings`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoIntervalParam_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_INTERVAL_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoIntervalParam_inline",
                   "SDK Key for setPhotoTimeIntervalSettings: Sets the interval shoot parameters. The camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. Also supported by thermal imaging camera.  @param settings An instance of `PhotoTimeIntervalSettings`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoTimeIntervalSettings: Sets the interval shoot parameters. The camera will capture a photo, wait a specified interval of time, take another photo, and continue in this manner until it has taken the required number of photos. Also supported by thermal imaging camera.  @param settings An instance of `PhotoTimeIntervalSettings`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoIntervalParam_inline",
                   "",
            ],
            [
                   "getPhotoTimeIntervalSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoIntervalParam_inline",
                   "Gets the camera's interval shoot parameters. </br></br>Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's interval shoot parameters. </br></br>Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoIntervalParam_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_INTERVAL_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoIntervalParam_inline",
                   "SDK Key for getPhotoTimeIntervalSettings: Gets the camera's interval shoot parameters. </br></br>Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoTimeIntervalSettings: Gets the camera's interval shoot parameters. </br></br>Also supported by thermal imaging camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoIntervalParam_inline",
                   "",
            ],
            [
                   "setPhotoTimeLapseSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoTimeLapse_inline",
                   "Sets the TimeLapse parameters, including interval, duration and file format when saving. Precondition: Camera should be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param settings The time between image captures. An integer falls in the range, [10, 1000]. <br>The unit is 100ms. Please note that when the format is JPEG+Video,<br> the minimum interval is 20(2 seconds). @param callback The execution block with the returned execution result.",
            ],
            [
                   "Sets the TimeLapse parameters, including interval, duration and file format when saving. Precondition: Camera should be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param settings The time between image captures. An integer falls in the range, [10, 1000]. <br>The unit is 100ms. Please note that when the format is JPEG+Video,<br> the minimum interval is 20(2 seconds). @param callback The execution block with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoTimeLapse_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoTimeLapse_inline",
                   "SDK Key for setPhotoTimeLapseSettings: Sets the TimeLapse parameters, including interval, duration and file format when saving. Precondition: Camera should be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param settings The time between image captures. An integer falls in the range, [10, 1000]. <br>The unit is 100ms. Please note that when the format is JPEG+Video,<br> the minimum interval is 20(2 seconds). @param callback The execution block with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoTimeLapseSettings: Sets the TimeLapse parameters, including interval, duration and file format when saving. Precondition: Camera should be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param settings The time between image captures. An integer falls in the range, [10, 1000]. <br>The unit is 100ms. Please note that when the format is JPEG+Video,<br> the minimum interval is 20(2 seconds). @param callback The execution block with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoTimeLapse_inline",
                   "",
            ],
            [
                   "getPhotoTimeLapseSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoTimeLapse_inline",
                   "Gets the TimeLapse parameters including interval, duration and file format when saving. Precondition: The camera must be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the TimeLapse parameters including interval, duration and file format when saving. Precondition: The camera must be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoTimeLapse_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoTimeLapse_inline",
                   "SDK Key for getPhotoTimeLapseSettings: Gets the TimeLapse parameters including interval, duration and file format when saving. Precondition: The camera must be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoTimeLapseSettings: Gets the TimeLapse parameters including interval, duration and file format when saving. Precondition: The camera must be in `TIME_LAPSE` mode of `ShootPhotoMode`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoTimeLapse_inline",
                   "",
            ],
            [
                   "setPhotoPanoramaMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoPanoramaMode_inline",
                   "Sets the panorama mode. It is used when `setShootPhotoMode` is called with `PANORAMA`.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param mode The panorama mode to set. @param callback `completion callback` to receive the result.",
            ],
            [
                   "Sets the panorama mode. It is used when `setShootPhotoMode` is called with `PANORAMA`.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param mode The panorama mode to set. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "PHOTO_PANORAMA_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoPanoramaMode_inline",
                   "SDK Key for setPhotoPanoramaMode: Sets the panorama mode. It is used when `setShootPhotoMode` is called with `PANORAMA`.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param mode The panorama mode to set. @param callback `completion callback` to receive the result.",
            ],
            [
                   "SDK Key for setPhotoPanoramaMode: Sets the panorama mode. It is used when `setShootPhotoMode` is called with `PANORAMA`.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param mode The panorama mode to set. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "getPhotoPanoramaMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoPanoramaMode_inline",
                   "Gets the panorama mode.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "Gets the panorama mode.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "PHOTO_PANORAMA_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoPanoramaMode_inline",
                   "SDK Key for getPhotoPanoramaMode: Gets the panorama mode.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "SDK Key for getPhotoPanoramaMode: Gets the panorama mode.  It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "setPanoOriginalPhotoSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPanoOriginalPhotoSettings_inline",
                   "Change the original image configuration when shooting panorama photos. CAUTION: enabling this may consume 500 MB in the SD card or the internal storage for each panorama. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual. For Mavic Air, `getFormat` is not used and it will ignore the value.  @param settings An object of `OriginalPhotoSettings`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Change the original image configuration when shooting panorama photos. CAUTION: enabling this may consume 500 MB in the SD card or the internal storage for each panorama. It is supported by Spark, Mavic Air, Mavic 2, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Eneterprise, Mavic 2 Enterprise Dual. For Mavic Air, `getFormat` is not used and it will ignore the value.  @param settings An object of `OriginalPhotoSettings`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPanoOriginalPhotoSettings_inline",
                   "",
            ],
            [
                   "getPanoOriginalPhotoSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPanoOriginalPhotoSettings_inline",
                   "Gets the configuration, which determines the behavior for the original images when shooting panorama photos. CAUTION: If this is enabled, it may consume 500 MB in the SD card or the internal storage for each panorama. It is supported by Mavic Air and Mavic 2. However, Mavic Air cannot change the format to save the original images. `getFormat` will be ignored by Mavic Air.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the configuration, which determines the behavior for the original images when shooting panorama photos. CAUTION: If this is enabled, it may consume 500 MB in the SD card or the internal storage for each panorama. It is supported by Mavic Air and Mavic 2. However, Mavic Air cannot change the format to save the original images. `getFormat` will be ignored by Mavic Air.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPanoOriginalPhotoSettings_inline",
                   "",
            ],
            [
                   "setHighQualityPreviewEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighQualityPreviewEnabled_inline",
                   "Enables this before photo capture to download high quality preview image. Only supported by Phantom 4 RTK.  @param enabled `true` to enable the feature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables this before photo capture to download high quality preview image. Only supported by Phantom 4 RTK.  @param enabled `true` to enable the feature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighQualityPreviewEnabled_inline",
                   "",
            ],
            [
                   "getHighQualityPreviewEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighQualityPreviewEnabled_inline",
                   "Gets if high quality preview image downloading is enabled. Only supported by Phantom 4 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets if high quality preview image downloading is enabled. Only supported by Phantom 4 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighQualityPreviewEnabled_inline",
                   "",
            ],
            [
                   "setVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoResolutionAndFrameRate_inline",
                   "Sets the camera's video resolution and frame rate. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's video resolution and frame rate. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "RESOLUTION_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoResolutionAndFrameRate_inline",
                   "SDK Key for setVideoResolutionAndFrameRate: Sets the camera's video resolution and frame rate. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setVideoResolutionAndFrameRate: Sets the camera's video resolution and frame rate. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "getVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoResolutionAndFrameRate_inline",
                   "Gets the camera's video resolution and frame rate values. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's video resolution and frame rate values. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "RESOLUTION_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoResolutionAndFrameRate_inline",
                   "SDK Key for getVideoResolutionAndFrameRate: Gets the camera's video resolution and frame rate values. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVideoResolutionAndFrameRate: Gets the camera's video resolution and frame rate values. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "setVideoFileFormat",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileFormat_inline",
                   "Sets the camera's video file format. The default value is `MOV`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's video file format. The default value is `MOV`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileFormat_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileFormat_inline",
                   "SDK Key for setVideoFileFormat: Sets the camera's video file format. The default value is `MOV`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setVideoFileFormat: Sets the camera's video file format. The default value is `MOV`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileFormat_inline",
                   "",
            ],
            [
                   "getVideoFileFormat",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileFormat_inline",
                   "Gets the camera's video file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's video file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileFormat_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileFormat_inline",
                   "SDK Key for getVideoFileFormat: Gets the camera's video file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVideoFileFormat: Gets the camera's video file format. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileFormat_inline",
                   "",
            ],
            [
                   "setVideoStandard",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoStandard_inline",
                   "Sets the camera's analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoStandard_inline",
                   "",
            ],
            [
                   "VIDEO_STANDARD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoStandard_inline",
                   "SDK Key for setVideoStandard: Sets the camera's analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setVideoStandard: Sets the camera's analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoStandard_inline",
                   "",
            ],
            [
                   "getVideoStandard",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoStandard_inline",
                   "Gets the camera's video standard value.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's video standard value.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoStandard_inline",
                   "",
            ],
            [
                   "VIDEO_STANDARD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoStandard_inline",
                   "SDK Key for getVideoStandard: Gets the camera's video standard value.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVideoStandard: Gets the camera's video standard value.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoStandard_inline",
                   "",
            ],
            [
                   "setVideoCaptionEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoCaptionEnabled_inline",
                   "Enables recording position, time and camera information into a video caption file (.srt) saved on the SD card. The information is updated at 1Hz. Currently the .srt file can only be downloaded directly from the SD card.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables recording position, time and camera information into a video caption file (.srt) saved on the SD card. The information is updated at 1Hz. Currently the .srt file can only be downloaded directly from the SD card.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoCaptionEnabled_inline",
                   "",
            ],
            [
                   "VIDEO_CAPTION_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoCaptionEnabled_inline",
                   "SDK Key for setVideoCaptionEnabled: Enables recording position, time and camera information into a video caption file (.srt) saved on the SD card. The information is updated at 1Hz. Currently the .srt file can only be downloaded directly from the SD card.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setVideoCaptionEnabled: Enables recording position, time and camera information into a video caption file (.srt) saved on the SD card. The information is updated at 1Hz. Currently the .srt file can only be downloaded directly from the SD card.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoCaptionEnabled_inline",
                   "",
            ],
            [
                   "getVideoCaptionEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoCaptionEnabled_inline",
                   "Gets whether the video caption is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets whether the video caption is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoCaptionEnabled_inline",
                   "",
            ],
            [
                   "VIDEO_CAPTION_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoCaptionEnabled_inline",
                   "SDK Key for getVideoCaptionEnabled: Gets whether the video caption is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVideoCaptionEnabled: Gets whether the video caption is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoCaptionEnabled_inline",
                   "",
            ],
            [
                   "setHistogramEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHistogramEnabled_inline",
                   "Enables the histogram.  @param enabled True to enable histogram. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the histogram.  @param enabled True to enable histogram. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHistogramEnabled_inline",
                   "",
            ],
            [
                   "HISTOGRAM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHistogramEnabled_inline",
                   "SDK Key for setHistogramEnabled: Enables the histogram.  @param enabled True to enable histogram. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setHistogramEnabled: Enables the histogram.  @param enabled True to enable histogram. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHistogramEnabled_inline",
                   "",
            ],
            [
                   "getHistogramEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHistogramEnabled_inline",
                   "Gets whether the histogram is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets whether the histogram is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHistogramEnabled_inline",
                   "",
            ],
            [
                   "HISTOGRAM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHistogramEnabled_inline",
                   "SDK Key for getHistogramEnabled: Gets whether the histogram is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getHistogramEnabled: Gets whether the histogram is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHistogramEnabled_inline",
                   "",
            ],
            [
                   "setVideoFileCompressionStandard",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileCompressionStandard_inline",
                   "Sets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro. For all other products, H.264 is used.  @param standard The compression standard to use. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro. For all other products, H.264 is used.  @param standard The compression standard to use. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_COMPRESSION_STANDARD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileCompressionStandard_inline",
                   "SDK Key for setVideoFileCompressionStandard: Sets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro. For all other products, H.264 is used.  @param standard The compression standard to use. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setVideoFileCompressionStandard: Sets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro. For all other products, H.264 is used.  @param standard The compression standard to use. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "getVideoFileCompressionStandard",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileCompressionStandard_inline",
                   "Gets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_COMPRESSION_STANDARD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileCompressionStandard_inline",
                   "SDK Key for getVideoFileCompressionStandard: Gets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVideoFileCompressionStandard: Gets the video file compression standard. It is only supported X4S camera, X5S camera and Phantom 4 Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "setSSDVideoRecordingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoRecordingEnabled_inline",
                   "Enables/disables the recording of RAW video. It is supported by X5S. User can use the other SSD interfaces only when it is enabled. For X5R, RAW recording is always enabled if there is SSD inserted.  @param enabled `true` to enable the RAW video recording. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables the recording of RAW video. It is supported by X5S. User can use the other SSD interfaces only when it is enabled. For X5R, RAW recording is always enabled if there is SSD inserted.  @param enabled `true` to enable the RAW video recording. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoRecordingEnabled_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RECORDING_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoRecordingEnabled_inline",
                   "SDK Key for setSSDVideoRecordingEnabled: Enables/disables the recording of RAW video. It is supported by X5S. User can use the other SSD interfaces only when it is enabled. For X5R, RAW recording is always enabled if there is SSD inserted.  @param enabled `true` to enable the RAW video recording. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSSDVideoRecordingEnabled: Enables/disables the recording of RAW video. It is supported by X5S. User can use the other SSD interfaces only when it is enabled. For X5R, RAW recording is always enabled if there is SSD inserted.  @param enabled `true` to enable the RAW video recording. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoRecordingEnabled_inline",
                   "",
            ],
            [
                   "getSSDVideoRecordingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoRecordingEnabled_inline",
                   "Determines whether the recording of RAW video is enabled. It is supported by X5S.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the recording of RAW video is enabled. It is supported by X5S.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoRecordingEnabled_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RECORDING_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoRecordingEnabled_inline",
                   "SDK Key for getSSDVideoRecordingEnabled: Determines whether the recording of RAW video is enabled. It is supported by X5S.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSDVideoRecordingEnabled: Determines whether the recording of RAW video is enabled. It is supported by X5S.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoRecordingEnabled_inline",
                   "",
            ],
            [
                   "setAutoLockGimbalEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setAutoLockGimbalEnabled_inline",
                   "Enables this to lock the gimbal when the camera is shooting a photo. The gimbal will keep the attitude when starting to shoot the photo.  @param enabled `true` to enable the feature. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enables this to lock the gimbal when the camera is shooting a photo. The gimbal will keep the attitude when starting to shoot the photo.  @param enabled `true` to enable the feature. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setAutoLockGimbalEnabled_inline",
                   "",
            ],
            [
                   "getAutoLockGimbalEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getAutoLockGimbalEnabled_inline",
                   "Determines whether the gimbal will be locked automatically during shooting photos.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the gimbal will be locked automatically during shooting photos.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getAutoLockGimbalEnabled_inline",
                   "",
            ],
            [
                   "setWatermarkSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setWatermarkSettings_inline",
                   "Sets the watermark configuration. Enables this to add timestamp and location stamp to the newly generated photos or videos. It is only supported by Mavic 2 Enterprise series. For Mavic 2 Enterprise Dual, the watermark is only applied to photos and videos generated by the visual camera.  @param config The watermark configuration to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the watermark configuration. Enables this to add timestamp and location stamp to the newly generated photos or videos. It is only supported by Mavic 2 Enterprise series. For Mavic 2 Enterprise Dual, the watermark is only applied to photos and videos generated by the visual camera.  @param config The watermark configuration to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setWatermarkSettings_inline",
                   "",
            ],
            [
                   "getWatermarkSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getWatermarkSettings_inline",
                   "Gets the watermark settings. If it is enabled, timestamp and location stamp will be added to the newly generated photos or videos. It is only supported by Mavic 2 Enterprise series. For Mavic 2 Enterprise Dual, the watermark is only applied to photos and videos generated by the visual camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the watermark settings. If it is enabled, timestamp and location stamp will be added to the newly generated photos or videos. It is only supported by Mavic 2 Enterprise series. For Mavic 2 Enterprise Dual, the watermark is only applied to photos and videos generated by the visual camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getWatermarkSettings_inline",
                   "",
            ],
            [
                   "setSSDVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoResolutionAndFrameRate_inline",
                   "Set Raw Video Resolution and Frame Rate of the SSD. Note, only raw video is saved to the SSD. Compressed video, compressed pictures and raw pictures are all saved to the SD Card. During video capture, Raw video and compressed video are saved simultaneously to the SSD and SD Card respectively. @warning The supported resolutions and frame rates for SSD Raw Videos are shown below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  For X5S, the frame rate of SSD has to be the same as the video to be stored in SD card, so frameRate</code> is ignored. The possible resolutions are determined by SD card video's frame rate and the SSD video license (`CameraSSDVideoLicense`) being used. The supported resolutions in the current configuration can be queried by using `SSDVideoResolutionRange` in `Capabilities`.  @param resolutionAndFrameRate Resolution and frame rate to be set for the video. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set Raw Video Resolution and Frame Rate of the SSD. Note, only raw video is saved to the SSD. Compressed video, compressed pictures and raw pictures are all saved to the SD Card. During video capture, Raw video and compressed video are saved simultaneously to the SSD and SD Card respectively. @warning The supported resolutions and frame rates for SSD Raw Videos are shown below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  For X5S, the frame rate of SSD has to be the same as the video to be stored in SD card, so frameRate</code> is ignored. The possible resolutions are determined by SD card video's frame rate and the SSD video license (`CameraSSDVideoLicense`) being used. The supported resolutions in the current configuration can be queried by using `SSDVideoResolutionRange` in `Capabilities`.  @param resolutionAndFrameRate Resolution and frame rate to be set for the video. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_AND_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoResolutionAndFrameRate_inline",
                   "SDK Key for setSSDVideoResolutionAndFrameRate: Set Raw Video Resolution and Frame Rate of the SSD. Note, only raw video is saved to the SSD. Compressed video, compressed pictures and raw pictures are all saved to the SD Card. During video capture, Raw video and compressed video are saved simultaneously to the SSD and SD Card respectively. @warning The supported resolutions and frame rates for SSD Raw Videos are shown below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  For X5S, the frame rate of SSD has to be the same as the video to be stored in SD card, so frameRate</code> is ignored. The possible resolutions are determined by SD card video's frame rate and the SSD video license (`CameraSSDVideoLicense`) being used. The supported resolutions in the current configuration can be queried by using `SSDVideoResolutionRange` in `Capabilities`.  @param resolutionAndFrameRate Resolution and frame rate to be set for the video. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSSDVideoResolutionAndFrameRate: Set Raw Video Resolution and Frame Rate of the SSD. Note, only raw video is saved to the SSD. Compressed video, compressed pictures and raw pictures are all saved to the SD Card. During video capture, Raw video and compressed video are saved simultaneously to the SSD and SD Card respectively. @warning The supported resolutions and frame rates for SSD Raw Videos are shown below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  For X5S, the frame rate of SSD has to be the same as the video to be stored in SD card, so frameRate</code> is ignored. The possible resolutions are determined by SD card video's frame rate and the SSD video license (`CameraSSDVideoLicense`) being used. The supported resolutions in the current configuration can be queried by using `SSDVideoResolutionRange` in `Capabilities`.  @param resolutionAndFrameRate Resolution and frame rate to be set for the video. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "getSSDVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoResolutionAndFrameRate_inline",
                   "Get Raw Video Format and Frame Rate of the SSD.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get Raw Video Format and Frame Rate of the SSD.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_AND_FRAME_RATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoResolutionAndFrameRate_inline",
                   "SDK Key for getSSDVideoResolutionAndFrameRate: Get Raw Video Format and Frame Rate of the SSD.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSDVideoResolutionAndFrameRate: Get Raw Video Format and Frame Rate of the SSD.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "setSSDLegacyColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoDigitalFilter_inline",
                   "Sets the camera color for video that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `setSSDColor` instead.  @param color SSD legacy color to set. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the camera color for video that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `setSSDColor` instead.  @param color SSD legacy color to set. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "SSD_LEGACY_COLOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoDigitalFilter_inline",
                   "SDK Key for setSSDLegacyColor: Sets the camera color for video that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `setSSDColor` instead.  @param color SSD legacy color to set. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setSSDLegacyColor: Sets the camera color for video that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `setSSDColor` instead.  @param color SSD legacy color to set. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "getSSDLegacyColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoDigitalFilter_inline",
                   "Gets the camera color for video that will store in SSD. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `getSSDColor` instead.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera color for video that will store in SSD. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `getSSDColor` instead.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "SSD_LEGACY_COLOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoDigitalFilter_inline",
                   "SDK Key for getSSDLegacyColor: Gets the camera color for video that will store in SSD. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `getSSDColor` instead.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSDLegacyColor: Gets the camera color for video that will store in SSD. This is the legacy version of SSD Color and it is only supported by Inspire 2 with firmware package versions (`getFirmwarePackageVersion`) lower than 01.0.0240. For newer firmware package versions, use `getSSDColor` instead.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "setSSDColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDColor_inline",
                   "Sets the color for videos that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. For `LicenseKeyTypeCinemaDNG`, the color is always `RAW_COLOR`. It is only supported Inspire 2 with the firmware package version (`getFirmwarePackageVersion`) 01.0.0240 or later. For older firmware package versions, use `setSSDLegacyColor` instead.  @param color Video color to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the color for videos that will be stored in SSD. It is only applied when the selected license key is either `LicenseKeyTypeProRes422HQ` or `LicenseKeyTypeProRes4444XQ`. For `LicenseKeyTypeCinemaDNG`, the color is always `RAW_COLOR`. It is only supported Inspire 2 with the firmware package version (`getFirmwarePackageVersion`) 01.0.0240 or later. For older firmware package versions, use `setSSDLegacyColor` instead.  @param color Video color to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_setSSDColor_inline",
                   "",
            ],
            [
                   "getSSDColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDColor_inline",
                   "Gets the color for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version (`getFirmwarePackageVersion`) 01.0.0240 or later. For older firmware package versions, use `getSSDLegacyColor` instead.  @param callback The execution callback with the returned `SSDColor` enum value.",
            ],
            [
                   "Gets the color for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version (`getFirmwarePackageVersion`) 01.0.0240 or later. For older firmware package versions, use `getSSDLegacyColor` instead.  @param callback The execution callback with the returned `SSDColor` enum value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDColor_inline",
                   "",
            ],
            [
                   "getSSDVideoLicenses",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicenses_inline",
                   "Gets purchased license key(s). An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. User can purchase a license key on DJI's website. It is supported by Inspire 2. the digital filter for video that will store in SSD. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets purchased license key(s). An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. User can purchase a license key on DJI's website. It is supported by Inspire 2. the digital filter for video that will store in SSD. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicenses_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_LICENSES",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicenses_inline",
                   "SDK Key for getSSDVideoLicenses: Gets purchased license key(s). An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. User can purchase a license key on DJI's website. It is supported by Inspire 2. the digital filter for video that will store in SSD. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSDVideoLicenses: Gets purchased license key(s). An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. User can purchase a license key on DJI's website. It is supported by Inspire 2. the digital filter for video that will store in SSD. It is only supported Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicenses_inline",
                   "",
            ],
            [
                   "activateSSDVideoLicense",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_activateSSDVideoLicense_inline",
                   "Sets the SSD video license to be used. If an unpurchased license is selected then only SD video will be recorded.  @param license License to used. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the SSD video license to be used. If an unpurchased license is selected then only SD video will be recorded.  @param license License to used. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_activateSSDVideoLicense_inline",
                   "",
            ],
            [
                   "ACTIVATE_SSD_VIDEO_LICENSE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_activateSSDVideoLicense_inline",
                   "SDK Key for activateSSDVideoLicense: Sets the SSD video license to be used. If an unpurchased license is selected then only SD video will be recorded.  @param license License to used. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for activateSSDVideoLicense: Sets the SSD video license to be used. If an unpurchased license is selected then only SD video will be recorded.  @param license License to used. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_activateSSDVideoLicense_inline",
                   "",
            ],
            [
                   "getSSDVideoLicense",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicense_inline",
                   "Gets the license key being used. It is supported by Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the license key being used. It is supported by Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicense_inline",
                   "",
            ],
            [
                   "ACTIVATE_SSD_VIDEO_LICENSE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicense_inline",
                   "SDK Key for getSSDVideoLicense: Gets the license key being used. It is supported by Inspire 2.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSDVideoLicense: Gets the license key being used. It is supported by Inspire 2.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_getSSDVideoLicense_inline",
                   "",
            ],
            [
                   "setCustomExpandDirectoryName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setCustomExpandDirectoryName_inline",
                   "Custom expand directory name settings. After calling this interface, the newly generated media files (videos or photos) will be stored in the new folder, this new folder's name will be appended by your custom directory name. For example, the default folder name is DJI_202001012359_01, you could append Mission1 after it, so the new folder's name will be DJI_202001012359_01_Mission1. In one flight, you can set multiple expand directory names to create multiple custom folders. Only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.  @param name Custom directory name to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Custom expand directory name settings. After calling this interface, the newly generated media files (videos or photos) will be stored in the new folder, this new folder's name will be appended by your custom directory name. For example, the default folder name is DJI_202001012359_01, you could append Mission1 after it, so the new folder's name will be DJI_202001012359_01_Mission1. In one flight, you can set multiple expand directory names to create multiple custom folders. Only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.  @param name Custom directory name to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setCustomExpandDirectoryName_inline",
                   "",
            ],
            [
                   "getCustomExpandDirectoryName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getCustomExpandDirectoryName_inline",
                   "Gets custom expand directory name. Only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets custom expand directory name. Only Supported by Zenmuse P1, Zenmuse L1, Zenmuse H20 Series.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getCustomExpandDirectoryName_inline",
                   "",
            ],
            [
                   "setCustomExpandFileName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setCustomExpandFileName_inline",
                   "Custom expand file name settings. By calling this interface, the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. For example, the default photo name is DJI_2020012091415_999_WIDE.JPG, you could append Waypoint1 after the default photo name, so the new photo's name will be DJI_2020012091415_999_WIDE_Waypoint1.JPG, This action will only take effect once. If you want to have the same name for all media files in one flight, you need to set this action before taking each photo. Only Supported by Zenmmuse P1, Zenmuse H20 Series.  @param name Custom file name to set. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Custom expand file name settings. By calling this interface, the name of next media file (video or photo) which would be stored in camera will be appended by the custom file name you set. For example, the default photo name is DJI_2020012091415_999_WIDE.JPG, you could append Waypoint1 after the default photo name, so the new photo's name will be DJI_2020012091415_999_WIDE_Waypoint1.JPG, This action will only take effect once. If you want to have the same name for all media files in one flight, you need to set this action before taking each photo. Only Supported by Zenmmuse P1, Zenmuse H20 Series.  @param name Custom file name to set. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setCustomExpandFileName_inline",
                   "",
            ],
            [
                   "getCustomExpandFileName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getCustomExpandFileName_inline",
                   "Gets custom expand file name. Only Supported by Zenmuse P1, Zenmuse H20 Series.  @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets custom expand file name. Only Supported by Zenmuse P1, Zenmuse H20 Series.  @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getCustomExpandFileName_inline",
                   "",
            ],
            [
                   "setFileIndexMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setFileIndexMode_inline",
                   "Sets the camera's file index mode for the SD card. The default value of `FileIndexMode` is set to `RESET`.  @param mode File index mode to be set for the camera's SD card. The default value of CameraFileIndexMode is set to Reset. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's file index mode for the SD card. The default value of `FileIndexMode` is set to `RESET`.  @param mode File index mode to be set for the camera's SD card. The default value of CameraFileIndexMode is set to Reset. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setFileIndexMode_inline",
                   "",
            ],
            [
                   "FILE_INDEX_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setFileIndexMode_inline",
                   "SDK Key for setFileIndexMode: Sets the camera's file index mode for the SD card. The default value of `FileIndexMode` is set to `RESET`.  @param mode File index mode to be set for the camera's SD card. The default value of CameraFileIndexMode is set to Reset. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFileIndexMode: Sets the camera's file index mode for the SD card. The default value of `FileIndexMode` is set to `RESET`.  @param mode File index mode to be set for the camera's SD card. The default value of CameraFileIndexMode is set to Reset. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setFileIndexMode_inline",
                   "",
            ],
            [
                   "getFileIndexMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getFileIndexMode_inline",
                   "Gets the camera's file index mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's file index mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getFileIndexMode_inline",
                   "",
            ],
            [
                   "setLaserEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLaserEnabled_inline",
                   "Sets the laser enabled. Laser sensor turns on ranging function. Set `true` to enable the laser distance sensor with measuring ranges to natural object. The laser sensor must be at least 3m from the target point. It is only supported for Zenmuse H20 series.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the laser enabled. Laser sensor turns on ranging function. Set `true` to enable the laser distance sensor with measuring ranges to natural object. The laser sensor must be at least 3m from the target point. It is only supported for Zenmuse H20 series.  @param enabled `true` to enable video caption. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setLaserEnabled_inline",
                   "",
            ],
            [
                   "getLaserEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLaserEnabled_inline",
                   "Gets whether the laser is enabled. The laser sensor must be at least 3m from the target point. It is only supported for Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets whether the laser is enabled. The laser sensor must be at least 3m from the target point. It is only supported for Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getLaserEnabled_inline",
                   "",
            ],
            [
                   "formatSDCard",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatSDCard_inline",
                   "Formats the SD card by deleting all the data on the SD card. This does not change any settings the user may have set on the SD card.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Formats the SD card by deleting all the data on the SD card. This does not change any settings the user may have set on the SD card.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatSDCard_inline",
                   "",
            ],
            [
                   "FORMAT_SD_CARD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatSDCard_inline",
                   "SDK Key for formatSDCard: Formats the SD card by deleting all the data on the SD card. This does not change any settings the user may have set on the SD card.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for formatSDCard: Formats the SD card by deleting all the data on the SD card. This does not change any settings the user may have set on the SD card.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatSDCard_inline",
                   "",
            ],
            [
                   "formatStorage",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatStorage_inline",
                   "Formats the storage by deleting all the data on it. It is supported by Mavic 2 series, Mavic 2 enterprise series, Mavic air and Matrice 200 V2 series.  @param storage The storage (either SD card or the internal storage) to format. When it is `SDCARD`, this interface has the same effect as `formatSDCard`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Formats the storage by deleting all the data on it. It is supported by Mavic 2 series, Mavic 2 enterprise series, Mavic air and Matrice 200 V2 series.  @param storage The storage (either SD card or the internal storage) to format. When it is `SDCARD`, this interface has the same effect as `formatSDCard`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_SDCardOperations_formatStorage_inline",
                   "",
            ],
            [
                   "isSSDSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSSDSupported_inline",
                   "Determines whether the SSD is supported by the camera. Currently, the SSD is supported only by X5R, X4S and X5S camera. @return `true` if SSD is supported, otherwise `false`.  @return A boolean value.",
            ],
            [
                   "Determines whether the SSD is supported by the camera. Currently, the SSD is supported only by X5R, X4S and X5S camera. @return `true` if SSD is supported, otherwise `false`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSSDSupported_inline",
                   "",
            ],
            [
                   "IS_SSD_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSSDSupported_inline",
                   "SDK Key for isSSDSupported: Determines whether the SSD is supported by the camera. Currently, the SSD is supported only by X5R, X4S and X5S camera. @return `true` if SSD is supported, otherwise `false`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isSSDSupported: Determines whether the SSD is supported by the camera. Currently, the SSD is supported only by X5R, X4S and X5S camera. @return `true` if SSD is supported, otherwise `false`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_isSSDSupported_inline",
                   "",
            ],
            [
                   "formatSSD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_formatSSD_inline",
                   "Formats the SSD by deleting all the data on the SSD. This does not change any settings the user may have set on the SSD.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Formats the SSD by deleting all the data on the SSD. This does not change any settings the user may have set on the SSD.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_formatSSD_inline",
                   "",
            ],
            [
                   "FORMAT_SSD",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_formatSSD_inline",
                   "SDK Key for formatSSD: Formats the SSD by deleting all the data on the SSD. This does not change any settings the user may have set on the SSD.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for formatSSD: Formats the SSD by deleting all the data on the SSD. This does not change any settings the user may have set on the SSD.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_formatSSD_inline",
                   "",
            ],
            [
                   "setAntiFlickerFrequency",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAntiFlicker_inline",
                   "Sets the camera's anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAntiFlicker_inline",
                   "",
            ],
            [
                   "ANTI_FLICKER_FREQUENCY",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAntiFlicker_inline",
                   "SDK Key for setAntiFlickerFrequency: Sets the camera's anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAntiFlickerFrequency: Sets the camera's anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAntiFlicker_inline",
                   "",
            ],
            [
                   "getAntiFlickerFrequency",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAntiFlicker_inline",
                   "Gets the camera's anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAntiFlicker_inline",
                   "",
            ],
            [
                   "ANTI_FLICKER_FREQUENCY",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAntiFlicker_inline",
                   "SDK Key for getAntiFlickerFrequency: Gets the camera's anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAntiFlickerFrequency: Gets the camera's anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAntiFlicker_inline",
                   "",
            ],
            [
                   "setSharpness",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSharpness_inline",
                   "Sets the camera's sharpness. The default value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets the camera's sharpness. The default value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSharpness_inline",
                   "",
            ],
            [
                   "SHARPNESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSharpness_inline",
                   "SDK Key for setSharpness: Sets the camera's sharpness. The default value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setSharpness: Sets the camera's sharpness. The default value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSharpness_inline",
                   "",
            ],
            [
                   "getSharpness",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSharpness_inline",
                   "Gets the camera's sharpness. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
            ],
            [
                   "Gets the camera's sharpness. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSharpness_inline",
                   "",
            ],
            [
                   "SHARPNESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSharpness_inline",
                   "SDK Key for getSharpness: Gets the camera's sharpness. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
            ],
            [
                   "SDK Key for getSharpness: Gets the camera's sharpness. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSharpness_inline",
                   "",
            ],
            [
                   "setContrast",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setContrast_inline",
                   "Sets the camera's contrast. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's contrast. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setContrast_inline",
                   "",
            ],
            [
                   "CONTRAST",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setContrast_inline",
                   "SDK Key for setContrast: Sets the camera's contrast. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setContrast: Sets the camera's contrast. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setContrast_inline",
                   "",
            ],
            [
                   "getContrast",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getContrast_inline",
                   "Gets the camera's contrast. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
            ],
            [
                   "Gets the camera's contrast. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getContrast_inline",
                   "",
            ],
            [
                   "CONTRAST",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getContrast_inline",
                   "SDK Key for getContrast: Gets the camera's contrast. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
            ],
            [
                   "SDK Key for getContrast: Gets the camera's contrast. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getContrast_inline",
                   "",
            ],
            [
                   "setDefogEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDefogEnabled_inline",
                   "Enable/disable defog feature. When defog feature is enabled, the contrast will be enhanced extraordinarily. It is only supported Z30.  @param enabled `true` to enable defog feature. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enable/disable defog feature. When defog feature is enabled, the contrast will be enhanced extraordinarily. It is only supported Z30.  @param enabled `true` to enable defog feature. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDefogEnabled_inline",
                   "",
            ],
            [
                   "DEFOG_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDefogEnabled_inline",
                   "SDK Key for setDefogEnabled: Enable/disable defog feature. When defog feature is enabled, the contrast will be enhanced extraordinarily. It is only supported Z30.  @param enabled `true` to enable defog feature. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setDefogEnabled: Enable/disable defog feature. When defog feature is enabled, the contrast will be enhanced extraordinarily. It is only supported Z30.  @param enabled `true` to enable defog feature. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDefogEnabled_inline",
                   "",
            ],
            [
                   "getDefogEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDefogEnabled_inline",
                   "Determines whether defog feature is enabled. It is only supported by Z30 camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether defog feature is enabled. It is only supported by Z30 camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDefogEnabled_inline",
                   "",
            ],
            [
                   "DEFOG_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDefogEnabled_inline",
                   "SDK Key for getDefogEnabled: Determines whether defog feature is enabled. It is only supported by Z30 camera.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getDefogEnabled: Determines whether defog feature is enabled. It is only supported by Z30 camera.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDefogEnabled_inline",
                   "",
            ],
            [
                   "setIRFilterEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setIRFilterEnabled_inline",
                   "Enables/disables the IR filter (infared filter). Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` to enable IR-Cut filter. @param callback The execution callback that receives the setter result.",
            ],
            [
                   "Enables/disables the IR filter (infared filter). Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param enabled `true` to enable IR-Cut filter. @param callback The execution callback that receives the setter result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setIRFilterEnabled_inline",
                   "",
            ],
            [
                   "getIRFilterEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getIRFilterEnabled_inline",
                   "Determines whether IR filter (infared filter) is enabled. Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether IR filter (infared filter) is enabled. Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. It is only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getIRFilterEnabled_inline",
                   "",
            ],
            [
                   "setSaturation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSaturation_inline",
                   "Sets the camera's saturation. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's saturation. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSaturation_inline",
                   "",
            ],
            [
                   "SATURATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSaturation_inline",
                   "SDK Key for setSaturation: Sets the camera's saturation. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSaturation: Sets the camera's saturation. The default saturation value is 0. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSaturation_inline",
                   "",
            ],
            [
                   "getSaturation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSaturation_inline",
                   "Gets the camera's saturation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's saturation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSaturation_inline",
                   "",
            ],
            [
                   "SATURATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSaturation_inline",
                   "SDK Key for getSaturation: Gets the camera's saturation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSaturation: Gets the camera's saturation. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSaturation_inline",
                   "",
            ],
            [
                   "setColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalFilter_inline",
                   "Sets the camera's color. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's color. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalFilter_inline",
                   "",
            ],
            [
                   "CAMERA_COLOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalFilter_inline",
                   "SDK Key for setColor: Sets the camera's color. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setColor: Sets the camera's color. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setDigitalFilter_inline",
                   "",
            ],
            [
                   "getColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalFilter_inline",
                   "Gets the camera's color. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's color. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalFilter_inline",
                   "",
            ],
            [
                   "CAMERA_COLOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalFilter_inline",
                   "SDK Key for getColor: Gets the camera's color. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getColor: Gets the camera's color. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getDigitalFilter_inline",
                   "",
            ],
            [
                   "setOrientation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOrientation_inline",
                   "Sets the camera's orientation. The gimbal will rotate the roll axis based on the orientation. Supported only by Mavic Pro.  @param orientation Camera's orientation. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's orientation. The gimbal will rotate the roll axis based on the orientation. Supported only by Mavic Pro.  @param orientation Camera's orientation. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOrientation_inline",
                   "",
            ],
            [
                   "ORIENTATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOrientation_inline",
                   "SDK Key for setOrientation: Sets the camera's orientation. The gimbal will rotate the roll axis based on the orientation. Supported only by Mavic Pro.  @param orientation Camera's orientation. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setOrientation: Sets the camera's orientation. The gimbal will rotate the roll axis based on the orientation. Supported only by Mavic Pro.  @param orientation Camera's orientation. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setOrientation_inline",
                   "",
            ],
            [
                   "getOrientation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOrientation_inline",
                   "Gets the camera's orientation. Supported only by Mavic Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's orientation. Supported only by Mavic Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOrientation_inline",
                   "",
            ],
            [
                   "ORIENTATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOrientation_inline",
                   "SDK Key for getOrientation: Gets the camera's orientation. Supported only by Mavic Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getOrientation: Gets the camera's orientation. Supported only by Mavic Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getOrientation_inline",
                   "",
            ],
            [
                   "setVisionStabilizationEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVisionStablizationEnabled_inline",
                   "Enables vision stabilization for Z30 camera on M200 series. The vision system in the M200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. Drift in the gimbal will be most noticeable at higher zoom factors. It is only supported Z30 on M200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
            ],
            [
                   "Enables vision stabilization for Z30 camera on M200 series. The vision system in the M200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. Drift in the gimbal will be most noticeable at higher zoom factors. It is only supported Z30 on M200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVisionStablizationEnabled_inline",
                   "",
            ],
            [
                   "VISION_STABILIZATION_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVisionStablizationEnabled_inline",
                   "SDK Key for setVisionStabilizationEnabled: Enables vision stabilization for Z30 camera on M200 series. The vision system in the M200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. Drift in the gimbal will be most noticeable at higher zoom factors. It is only supported Z30 on M200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
            ],
            [
                   "SDK Key for setVisionStabilizationEnabled: Enables vision stabilization for Z30 camera on M200 series. The vision system in the M200 series of aircraft can be used to compensate for any drift in the gimbal by analyzing the live view when there is no gimbal movement. Drift in the gimbal will be most noticeable at higher zoom factors. It is only supported Z30 on M200 series.  @param enable `true` to enable the vision stabilization. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVisionStablizationEnabled_inline",
                   "",
            ],
            [
                   "getVisionStabilizationEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVisionStablizationEnabled_inline",
                   "Determines whether vision stabilization is enabled. It is only supported Z30 on M200 series.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "Determines whether vision stabilization is enabled. It is only supported Z30 on M200 series.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVisionStablizationEnabled_inline",
                   "",
            ],
            [
                   "VISION_STABILIZATION_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVisionStablizationEnabled_inline",
                   "SDK Key for getVisionStabilizationEnabled: Determines whether vision stabilization is enabled. It is only supported Z30 on M200 series.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "SDK Key for getVisionStabilizationEnabled: Determines whether vision stabilization is enabled. It is only supported Z30 on M200 series.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVisionStablizationEnabled_inline",
                   "",
            ],
            [
                   "setMediaFileCustomInformation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMediaFileCustomInformation_inline",
                   "Custom information can be stored in media file's XMP meta data. The custom information is written to the media file automatically after the media file is created. This method defines the information to write. The same information will be written to all media files until the information is changed again by this method. Custom information written to each file can be retrieved through `fetchCustomInformation` or from the image itself when processed on a separate system. It is supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param information Custom information to set. Use UTF-8 encoding with a length equal to or less than 31 characters. @param callback The execution callback to receive the result.",
            ],
            [
                   "Custom information can be stored in media file's XMP meta data. The custom information is written to the media file automatically after the media file is created. This method defines the information to write. The same information will be written to all media files until the information is changed again by this method. Custom information written to each file can be retrieved through `fetchCustomInformation` or from the image itself when processed on a separate system. It is supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param information Custom information to set. Use UTF-8 encoding with a length equal to or less than 31 characters. @param callback The execution callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMediaFileCustomInformation_inline",
                   "",
            ],
            [
                   "CUSTOM_INFORMATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMediaFileCustomInformation_inline",
                   "SDK Key for setMediaFileCustomInformation: Custom information can be stored in media file's XMP meta data. The custom information is written to the media file automatically after the media file is created. This method defines the information to write. The same information will be written to all media files until the information is changed again by this method. Custom information written to each file can be retrieved through `fetchCustomInformation` or from the image itself when processed on a separate system. It is supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param information Custom information to set. Use UTF-8 encoding with a length equal to or less than 31 characters. @param callback The execution callback to receive the result.",
            ],
            [
                   "SDK Key for setMediaFileCustomInformation: Custom information can be stored in media file's XMP meta data. The custom information is written to the media file automatically after the media file is created. This method defines the information to write. The same information will be written to all media files until the information is changed again by this method. Custom information written to each file can be retrieved through `fetchCustomInformation` or from the image itself when processed on a separate system. It is supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param information Custom information to set. Use UTF-8 encoding with a length equal to or less than 31 characters. @param callback The execution callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMediaFileCustomInformation_inline",
                   "",
            ],
            [
                   "getMediaFileCustomInformation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMediaFileCustomInformation_inline",
                   "Custom information can be stored in media file's XMP meta data. This method retrieves the information that will be written to future media files. The information written to individual files can be retrieved through `fetchCustomInformation`. It is only supported Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback to receive the result.",
            ],
            [
                   "Custom information can be stored in media file's XMP meta data. This method retrieves the information that will be written to future media files. The information written to individual files can be retrieved through `fetchCustomInformation`. It is only supported Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMediaFileCustomInformation_inline",
                   "",
            ],
            [
                   "CUSTOM_INFORMATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMediaFileCustomInformation_inline",
                   "SDK Key for getMediaFileCustomInformation: Custom information can be stored in media file's XMP meta data. This method retrieves the information that will be written to future media files. The information written to individual files can be retrieved through `fetchCustomInformation`. It is only supported Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback to receive the result.",
            ],
            [
                   "SDK Key for getMediaFileCustomInformation: Custom information can be stored in media file's XMP meta data. This method retrieves the information that will be written to future media files. The information written to individual files can be retrieved through `fetchCustomInformation`. It is only supported Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7, Mavic 2 Enterprise camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMediaFileCustomInformation_inline",
                   "",
            ],
            [
                   "setDewarpingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoDewarpingEnabled_inline",
                   "Enables/disables dewarping (lens distortion correction) for video recorded to SD card. Supported by Phantom 4 Pro camera, X4S, X5S and X7.  @param enabled `true` to enable video dewarping. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables dewarping (lens distortion correction) for video recorded to SD card. Supported by Phantom 4 Pro camera, X4S, X5S and X7.  @param enabled `true` to enable video dewarping. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setVideoDewarpingEnabled_inline",
                   "",
            ],
            [
                   "getDewarpingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoDewarpingEnabled_inline",
                   "Determines whether dewarping (lens distortion correction) is enabled. Supported by Phantom 4 Pro camera, X4S, X5S and X7.  @param callback The execution callback with the returned Boolean value(s).",
            ],
            [
                   "Determines whether dewarping (lens distortion correction) is enabled. Supported by Phantom 4 Pro camera, X4S, X5S and X7.  @param callback The execution callback with the returned Boolean value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getVideoDewarpingEnabled_inline",
                   "",
            ],
            [
                   "initSensorCleaningMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_InitSensorCleaningMode_inline",
                   "Initiates the sensor cleaning mode. Calling this will change `getSensorCleaningState` from `IDLE` to `INITIATING`. To start the sensor dedusting operation, the workflow should be:  1. Call `initSensorCleaningMode`.  2. Remove the lens from the camera.  3. Call `startSensorCleaning`.  4. When `getSensorCleaningState` becomes `WAITING_FOR_LENS_REMOUNT`, mount the lens back to the camera.  It is only supported Zenmuse X7.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Initiates the sensor cleaning mode. Calling this will change `getSensorCleaningState` from `IDLE` to `INITIATING`. To start the sensor dedusting operation, the workflow should be:  1. Call `initSensorCleaningMode`.  2. Remove the lens from the camera.  3. Call `startSensorCleaning`.  4. When `getSensorCleaningState` becomes `WAITING_FOR_LENS_REMOUNT`, mount the lens back to the camera.  It is only supported Zenmuse X7.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_InitSensorCleaningMode_inline",
                   "",
            ],
            [
                   "startSensorCleaning",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_StartSensorCleaning_inline",
                   "Starts cleaning the sensor. The sensor cleaning should only be started when the lens is removed from the camera. It is only supported Zenmuse X7.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts cleaning the sensor. The sensor cleaning should only be started when the lens is removed from the camera. It is only supported Zenmuse X7.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_StartSensorCleaning_inline",
                   "",
            ],
            [
                   "exitSensorCleaningMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_ExitSensorCleaningMode_inline",
                   "Exits sensor cleaning mode. Calling this will stop the current executing operation and change `getSensorCleaningState` to `IDLE`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Exits sensor cleaning mode. Calling this will stop the current executing operation and change `getSensorCleaningState` to `IDLE`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_ExitSensorCleaningMode_inline",
                   "",
            ],
            [
                   "isEIModeSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isEIModeSupported_inline",
                   "Determines whether the EI (exposure index) mode is supported by the camera. In this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. This mode only takes effect when the camera mode is in `RECORD_VIDEO`. The EI mode is supported by X4S, X5S and X7. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the EI mode is supported, otherwise `false`.",
            ],
            [
                   "Determines whether the EI (exposure index) mode is supported by the camera. In this mode, the camera mimics the way a film camera works to help cinematographers capture as much information as possible while balancing the dynamic range and noise with different log curves. This mode only takes effect when the camera mode is in `RECORD_VIDEO`. The EI mode is supported by X4S, X5S and X7. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the EI mode is supported, otherwise `false`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isEIModeSupported_inline",
                   "",
            ],
            [
                   "setExposureSensitivityMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureSensitivityMode_inline",
                   "Sets the exposure sensitivity mode. It is only supported when `isEIModeSupported` returns `true`. It is supported by X4S, X5S and X7. For other cameras, only ISO mode is supported.  @param mode The exposure sensitivity mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the exposure sensitivity mode. It is only supported when `isEIModeSupported` returns `true`. It is supported by X4S, X5S and X7. For other cameras, only ISO mode is supported.  @param mode The exposure sensitivity mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setExposureSensitivityMode_inline",
                   "",
            ],
            [
                   "getExposureSensitivityMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureSensitivityMode_inline",
                   "Gets the exposure sensitivity mode. It is only supported when `isEIModeSupported` returns `true`. It is supported by X4S, X5S and X7. For other cameras, only ISO mode is supported.  @param callback The execution callback with the returned `ExposureSensitivityMode` enum value.",
            ],
            [
                   "Gets the exposure sensitivity mode. It is only supported when `isEIModeSupported` returns `true`. It is supported by X4S, X5S and X7. For other cameras, only ISO mode is supported.  @param callback The execution callback with the returned `ExposureSensitivityMode` enum value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getExposureSensitivityMode_inline",
                   "",
            ],
            [
                   "setEI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setEI_inline",
                   "Sets EI value. The valid range can be fetched from `getEIRange`. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param ei The EI value to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets EI value. The valid range can be fetched from `getEIRange`. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param ei The EI value to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setEI_inline",
                   "",
            ],
            [
                   "getEI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEI_inline",
                   "Gets EI value. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned integer value.",
            ],
            [
                   "Gets EI value. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned integer value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEI_inline",
                   "",
            ],
            [
                   "getRecommendedEI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getRecommendedEI_inline",
                   "Gets the EI value recommended by the camera. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned Integer value.",
            ],
            [
                   "Gets the EI value recommended by the camera. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned Integer value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getRecommendedEI_inline",
                   "",
            ],
            [
                   "getEIRange",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEIRange_inline",
                   "Gets the valid range of EI values. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned int value.",
            ],
            [
                   "Gets the valid range of EI values. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned int value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEIRange_inline",
                   "",
            ],
            [
                   "setEIColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setEIColor_inline",
                   "Sets the camera color for EI mode. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param color The camera color to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera color for EI mode. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param color The camera color to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setEIColor_inline",
                   "",
            ],
            [
                   "getEIColor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEIColor_inline",
                   "Gets the camera color for EI mode. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned `EIColor` enum value.",
            ],
            [
                   "Gets the camera color for EI mode. It is only valid when exposure sensitivity mode is `EI`. It is only supported by X4S, X5S and X7.  @param callback The execution callback with the returned `EIColor` enum value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getEIColor_inline",
                   "",
            ],
            [
                   "isMechanicalShutterSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isMechanicalShutterSupported_inline",
                   "Determines whether the mechanical shutter speed is supported by the camera or the lens (for X7). The mechanical shutter is supported by Zenmuse P1, Phantom 4 Pro camera, X4S and X7 with DL lenses. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
            ],
            [
                   "Determines whether the mechanical shutter speed is supported by the camera or the lens (for X7). The mechanical shutter is supported by Zenmuse P1, Phantom 4 Pro camera, X4S and X7 with DL lenses. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isMechanicalShutterSupported_inline",
                   "",
            ],
            [
                   "setMechanicalShutterEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMechanicalShutterEnabled_inline",
                   "Enables the mechanical shutter. It is only valid when `isMechanicalShutterSupported` returns `true`. For Zenmuse L1, this interface can not enabled in video mode.  @param enabled `true` to enable the mechanical shutter. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the mechanical shutter. It is only valid when `isMechanicalShutterSupported` returns `true`. For Zenmuse L1, this interface can not enabled in video mode.  @param enabled `true` to enable the mechanical shutter. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMechanicalShutterEnabled_inline",
                   "",
            ],
            [
                   "getMechanicalShutterEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMechanicalShutterEnabled_inline",
                   "Determines whether the mechanical shutter is enabled. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param callback The execution callback with the returned boolean value.",
            ],
            [
                   "Determines whether the mechanical shutter is enabled. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param callback The execution callback with the returned boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMechanicalShutterEnabled_inline",
                   "",
            ],
            [
                   "isNDFilterModeSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isNDFilterModeSupported_inline",
                   "Determines whether the ND filter mode is supported by the camera and the lens. Only the DL-S 16mm F2.8 ND ASPH lens for X7 has a built-in ND4 filter and supports changing the modes through an application. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the ND filter mode is supported, otherwise `false`.",
            ],
            [
                   "Determines whether the ND filter mode is supported by the camera and the lens. Only the DL-S 16mm F2.8 ND ASPH lens for X7 has a built-in ND4 filter and supports changing the modes through an application. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return `true` if the ND filter mode is supported, otherwise `false`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isNDFilterModeSupported_inline",
                   "",
            ],
            [
                   "setNDFilterMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setNDFilterMode_inline",
                   "Sets the mode of ND filter. It is only valid when `isNDFilterModeSupported` returns `true`.  @param mode The ND filter mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the mode of ND filter. It is only valid when `isNDFilterModeSupported` returns `true`.  @param mode The ND filter mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setNDFilterMode_inline",
                   "",
            ],
            [
                   "getNDFilterMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getNDFilterMode_inline",
                   "Gets the ND filter mode. It is only valid when `isNDFilterModeSupported` returns `true`.  @param callback The execution callback with the returned `NDFilterMode` enum value.",
            ],
            [
                   "Gets the ND filter mode. It is only valid when `isNDFilterModeSupported` returns `true`.  @param callback The execution callback with the returned `NDFilterMode` enum value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getNDFilterMode_inline",
                   "",
            ],
            [
                   "setSSDClipFileName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSSDClipFileName_inline",
                   "Sets the clip name for the video to be stored in SSD. The clip name will be applied to the next video file stored in SSD. After saving a video file, `getClipID` will increase by 1 automatically.  It is only supported by Inspire 2.  @param name The clip name to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the clip name for the video to be stored in SSD. The clip name will be applied to the next video file stored in SSD. After saving a video file, `getClipID` will increase by 1 automatically.  It is only supported by Inspire 2.  @param name The clip name to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setSSDClipFileName_inline",
                   "",
            ],
            [
                   "getSSDClipFileName",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSSDClipFileName_inline",
                   "Gets the clip name for video to be stored in SSD. It is only supported by Inspire 2.  @param callback The execution callback with the returned `SSDClipFileName` class.",
            ],
            [
                   "Gets the clip name for video to be stored in SSD. It is only supported by Inspire 2.  @param callback The execution callback with the returned `SSDClipFileName` class.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getSSDClipFileName_inline",
                   "",
            ],
            [
                   "isPhotoQuickViewSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isPhotoQuickViewSupported_inline",
                   "Determines whether the device supports the quick view. Quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return A boolean value.",
            ],
            [
                   "Determines whether the device supports the quick view. Quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isPhotoQuickViewSupported_inline",
                   "",
            ],
            [
                   "IS_PHOTO_QUICK_VIEW_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isPhotoQuickViewSupported_inline",
                   "SDK Key for isPhotoQuickViewSupported: Determines whether the device supports the quick view. Quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return A boolean value.",
            ],
            [
                   "SDK Key for isPhotoQuickViewSupported: Determines whether the device supports the quick view. Quick view is the period of time a photo is shown as a preview after it is taken and before the camera returns to the live camera view. In multiple lenses camera, if one of its lenses supports this feature, the camera and the lens that can supports both return `true`. User can only access the parameters through the lens object.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isPhotoQuickViewSupported_inline",
                   "",
            ],
            [
                   "setPhotoQuickViewDuration",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoQuickViewDuration_inline",
                   "Sets the camera's quick view duration. The valid range is [0, 10] seconds. When duration is 0, it means that the quick view is disabled. The default value is 0 second. Call `isPhotoQuickViewSupported` before using this method.  @param duration Quick view duration to be set for the camera. This value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. This value must be set in the range of [0, 10] seconds. When the value is 0, quick view is disabled. The default value is 0 second. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the camera's quick view duration. The valid range is [0, 10] seconds. When duration is 0, it means that the quick view is disabled. The default value is 0 second. Call `isPhotoQuickViewSupported` before using this method.  @param duration Quick view duration to be set for the camera. This value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. This value must be set in the range of [0, 10] seconds. When the value is 0, quick view is disabled. The default value is 0 second. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoQuickViewDuration_inline",
                   "",
            ],
            [
                   "PHOTO_QUICK_VIEW_DURATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoQuickViewDuration_inline",
                   "SDK Key for setPhotoQuickViewDuration: Sets the camera's quick view duration. The valid range is [0, 10] seconds. When duration is 0, it means that the quick view is disabled. The default value is 0 second. Call `isPhotoQuickViewSupported` before using this method.  @param duration Quick view duration to be set for the camera. This value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. This value must be set in the range of [0, 10] seconds. When the value is 0, quick view is disabled. The default value is 0 second. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setPhotoQuickViewDuration: Sets the camera's quick view duration. The valid range is [0, 10] seconds. When duration is 0, it means that the quick view is disabled. The default value is 0 second. Call `isPhotoQuickViewSupported` before using this method.  @param duration Quick view duration to be set for the camera. This value defines the amount of time a photo is shown as a preview after it is taken before the camera returns back to the live camera view. This value must be set in the range of [0, 10] seconds. When the value is 0, quick view is disabled. The default value is 0 second. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setPhotoQuickViewDuration_inline",
                   "",
            ],
            [
                   "getPhotoQuickViewDuration",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoQuickViewDuration_inline",
                   "Gets the camera's quick view duration.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera's quick view duration.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoQuickViewDuration_inline",
                   "",
            ],
            [
                   "PHOTO_QUICK_VIEW_DURATION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoQuickViewDuration_inline",
                   "SDK Key for getPhotoQuickViewDuration: Gets the camera's quick view duration.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPhotoQuickViewDuration: Gets the camera's quick view duration.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getPhotoQuickViewDuration_inline",
                   "",
            ],
            [
                   "setHDLiveViewEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighDefinitionLiveViewEnabled_inline",
                   "Enables HD (high-definition) live view. When it is enabled, the live view resolution is 1080p with frame rate 30 fps. The settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. If recording video in 4k, then the live stream will be limited to 720p. Supported by Mavic Air 2, DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro v2.0.  @param enabled Enable or disable HD live view. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables HD (high-definition) live view. When it is enabled, the live view resolution is 1080p with frame rate 30 fps. The settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. If recording video in 4k, then the live stream will be limited to 720p. Supported by Mavic Air 2, DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro v2.0.  @param enabled Enable or disable HD live view. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighDefinitionLiveViewEnabled_inline",
                   "",
            ],
            [
                   "HD_LIVE_VIEW_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighDefinitionLiveViewEnabled_inline",
                   "SDK Key for setHDLiveViewEnabled: Enables HD (high-definition) live view. When it is enabled, the live view resolution is 1080p with frame rate 30 fps. The settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. If recording video in 4k, then the live stream will be limited to 720p. Supported by Mavic Air 2, DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro v2.0.  @param enabled Enable or disable HD live view. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setHDLiveViewEnabled: Enables HD (high-definition) live view. When it is enabled, the live view resolution is 1080p with frame rate 30 fps. The settings will only take effect when the camera is in record-video mode and the video resolution is either 1080p or 2.7k without slow-motion enabled. If recording video in 4k, then the live stream will be limited to 720p. Supported by Mavic Air 2, DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro v2.0.  @param enabled Enable or disable HD live view. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setHighDefinitionLiveViewEnabled_inline",
                   "",
            ],
            [
                   "getHDLiveViewEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighDefinitionLiveViewEnabled_inline",
                   "`true` if 1080p live view is enabled. This will return the value of the setter, and not necessarily the actual live view resolution. For example, if recording in 4K and HD live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. Supported only by , DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro V2.0.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "`true` if 1080p live view is enabled. This will return the value of the setter, and not necessarily the actual live view resolution. For example, if recording in 4K and HD live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. Supported only by , DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro V2.0.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighDefinitionLiveViewEnabled_inline",
                   "",
            ],
            [
                   "HD_LIVE_VIEW_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighDefinitionLiveViewEnabled_inline",
                   "SDK Key for getHDLiveViewEnabled: `true` if 1080p live view is enabled. This will return the value of the setter, and not necessarily the actual live view resolution. For example, if recording in 4K and HD live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. Supported only by , DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro V2.0.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getHDLiveViewEnabled: `true` if 1080p live view is enabled. This will return the value of the setter, and not necessarily the actual live view resolution. For example, if recording in 4K and HD live view has previously been set, then this will return `true` but the actual live view resolution will be 720p. Supported only by , DJI Air 2S, Mavic Pro, Mavic 2 Pro, Mavic 2 Zoom and Phantom 4 Pro V2.0.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getHighDefinitionLiveViewEnabled_inline",
                   "",
            ],
            [
                   "setLEDAutoTurnOffEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoTurnOffLEDEnabled_inline",
                   "Enables the automatic control of the front-arm LEDs. The camera can turn off the front-arm LEDs automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param enabled Enable the automatic control of the front-arm LEDs. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the automatic control of the front-arm LEDs. The camera can turn off the front-arm LEDs automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param enabled Enable the automatic control of the front-arm LEDs. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoTurnOffLEDEnabled_inline",
                   "",
            ],
            [
                   "LED_AUTO_TURN_OFF_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoTurnOffLEDEnabled_inline",
                   "SDK Key for setLEDAutoTurnOffEnabled: Enables the automatic control of the front-arm LEDs. The camera can turn off the front-arm LEDs automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param enabled Enable the automatic control of the front-arm LEDs. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setLEDAutoTurnOffEnabled: Enables the automatic control of the front-arm LEDs. The camera can turn off the front-arm LEDs automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param enabled Enable the automatic control of the front-arm LEDs. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAutoTurnOffLEDEnabled_inline",
                   "",
            ],
            [
                   "getLEDAutoTurnOffEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoTurnOffLEDEnabled_inline",
                   "Determines whether the automatic control of the front-arm LEDs is Enabled. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the automatic control of the front-arm LEDs is Enabled. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoTurnOffLEDEnabled_inline",
                   "",
            ],
            [
                   "LED_AUTO_TURN_OFF_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoTurnOffLEDEnabled_inline",
                   "SDK Key for getLEDAutoTurnOffEnabled: Determines whether the automatic control of the front-arm LEDs is Enabled. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getLEDAutoTurnOffEnabled: Determines whether the automatic control of the front-arm LEDs is Enabled. Supported only by Mavic Pro, Mavic Air, and Mavic 2 series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAutoTurnOffLEDEnabled_inline",
                   "",
            ],
            [
                   "setBeaconAutoTurnOffEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setBeaconAutoTurnOffEnabled_inline",
                   "Enables the automatic control of the beacon. The camera can turn off the beacon automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Only Supported by Matrice 200 series V2 and Zenmuse H20 Series mounted on Matrice 300 RTK.  @param enabled Enable the automatic control of the beacon. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enables the automatic control of the beacon. The camera can turn off the beacon automatically when it shoots photos or records videos. The LEDs will be turned on after the shooting or recording is finished. Only Supported by Matrice 200 series V2 and Zenmuse H20 Series mounted on Matrice 300 RTK.  @param enabled Enable the automatic control of the beacon. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setBeaconAutoTurnOffEnabled_inline",
                   "",
            ],
            [
                   "getBeaconAutoTurnOffEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getBeaconAutoTurnOffEnabled_inline",
                   "Determines whether the automatic control of the beacon is Enabled. Only Supported by M200 series v2 and Zenmuse H20 Series mounted on Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the automatic control of the beacon is Enabled. Only Supported by M200 series v2 and Zenmuse H20 Series mounted on Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getBeaconAutoTurnOffEnabled_inline",
                   "",
            ],
            [
                   "isInternalStorageSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isInternalStorageSupported_inline",
                   "Determines if the camera supports the internal storage or not. When it is supported, the camera shoot photos or record videos without SD card. The newly generated photos or videos will be stored in the internal storage.  @return `true` if internal storage is supported.",
            ],
            [
                   "Determines if the camera supports the internal storage or not. When it is supported, the camera shoot photos or record videos without SD card. The newly generated photos or videos will be stored in the internal storage.  @return `true` if internal storage is supported.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isInternalStorageSupported_inline",
                   "",
            ],
            [
                   "setStorageLocation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setStorageLocation_inline",
                   "Sets the storage location for the newly generated photos or videos. It is only supported when `isInternalStorageSupported` returns `true`. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param location The storage location to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the storage location for the newly generated photos or videos. It is only supported when `isInternalStorageSupported` returns `true`. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param location The storage location to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setStorageLocation_inline",
                   "",
            ],
            [
                   "getStorageLocation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getStorageLocation_inline",
                   "Gets the storage location for the newly generated photos or videos. When `isInternalStorageSupported` returns `false`, this setting is always `SDCARD`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the storage location for the newly generated photos or videos. When `isInternalStorageSupported` returns `false`, this setting is always `SDCARD`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getStorageLocation_inline",
                   "",
            ],
            [
                   "isAudioRecordingSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAudioRecordSupported_inline",
                   "Determines whether the current device supports audio recording. Currently audio recording is supported only by the Osmo camera.  @return The boolean value.",
            ],
            [
                   "Determines whether the current device supports audio recording. Currently audio recording is supported only by the Osmo camera.  @return The boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAudioRecordSupported_inline",
                   "",
            ],
            [
                   "IS_AUDIO_RECORDING_SUPPORTED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAudioRecordSupported_inline",
                   "SDK Key for isAudioRecordingSupported: Determines whether the current device supports audio recording. Currently audio recording is supported only by the Osmo camera.  @return The boolean value.",
            ],
            [
                   "SDK Key for isAudioRecordingSupported: Determines whether the current device supports audio recording. Currently audio recording is supported only by the Osmo camera.  @return The boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_isAudioRecordSupported_inline",
                   "",
            ],
            [
                   "setAudioRecordingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioRecordEnabled_inline",
                   "Enables audio recording when capturing video. Supported only by Osmo camera.  @param enabled Enable or disable audio recording. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables audio recording when capturing video. Supported only by Osmo camera.  @param enabled Enable or disable audio recording. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioRecordEnabled_inline",
                   "",
            ],
            [
                   "AUDIO_RECORDING_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioRecordEnabled_inline",
                   "SDK Key for setAudioRecordingEnabled: Enables audio recording when capturing video. Supported only by Osmo camera.  @param enabled Enable or disable audio recording. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAudioRecordingEnabled: Enables audio recording when capturing video. Supported only by Osmo camera.  @param enabled Enable or disable audio recording. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioRecordEnabled_inline",
                   "",
            ],
            [
                   "getAudioRecordingEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioRecordEnabled_inline",
                   "Determines whether the audio record is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the audio record is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioRecordEnabled_inline",
                   "",
            ],
            [
                   "AUDIO_RECORDING_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioRecordEnabled_inline",
                   "SDK Key for getAudioRecordingEnabled: Determines whether the audio record is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAudioRecordingEnabled: Determines whether the audio record is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioRecordEnabled_inline",
                   "",
            ],
            [
                   "setAudioGain",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioGain_inline",
                   "Sets the microphone recording gain.  @param value Recording gain with range [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the microphone recording gain.  @param value Recording gain with range [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioGain_inline",
                   "",
            ],
            [
                   "AUDIO_GAIN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioGain_inline",
                   "SDK Key for setAudioGain: Sets the microphone recording gain.  @param value Recording gain with range [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setAudioGain: Sets the microphone recording gain.  @param value Recording gain with range [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setAudioGain_inline",
                   "",
            ],
            [
                   "getAudioGain",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioGain_inline",
                   "Gets the microphone recording gain.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the microphone recording gain.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioGain_inline",
                   "",
            ],
            [
                   "AUDIO_GAIN",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioGain_inline",
                   "SDK Key for getAudioGain: Gets the microphone recording gain.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getAudioGain: Gets the microphone recording gain.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getAudioGain_inline",
                   "",
            ],
            [
                   "setTurnOffFanWhenPossible",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTurnOffFanWhenPossible_inline",
                   "This method will turn off the camera's cooling fan whenever the camera is cool enough to do so. This allows better audio recording from the internal microphone in the camera.  @param turnOffWhenPossible `true` to turn fan off whenever possible. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "This method will turn off the camera's cooling fan whenever the camera is cool enough to do so. This allows better audio recording from the internal microphone in the camera.  @param turnOffWhenPossible `true` to turn fan off whenever possible. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTurnOffFanWhenPossible_inline",
                   "",
            ],
            [
                   "TURN_OFF_FAN_WHEN_POSSIBLE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTurnOffFanWhenPossible_inline",
                   "SDK Key for setTurnOffFanWhenPossible: This method will turn off the camera's cooling fan whenever the camera is cool enough to do so. This allows better audio recording from the internal microphone in the camera.  @param turnOffWhenPossible `true` to turn fan off whenever possible. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setTurnOffFanWhenPossible: This method will turn off the camera's cooling fan whenever the camera is cool enough to do so. This allows better audio recording from the internal microphone in the camera.  @param turnOffWhenPossible `true` to turn fan off whenever possible. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setTurnOffFanWhenPossible_inline",
                   "",
            ],
            [
                   "getTurnOffFanWhenPossible",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTurnOffFanWhenPossible_inline",
                   "Determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTurnOffFanWhenPossible_inline",
                   "",
            ],
            [
                   "TURN_OFF_FAN_WHEN_POSSIBLE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTurnOffFanWhenPossible_inline",
                   "SDK Key for getTurnOffFanWhenPossible: Determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getTurnOffFanWhenPossible: Determines whether the fan will turn off whenever it is cool enough to do so to enable better audio recordings from the camera's internal microphone.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getTurnOffFanWhenPossible_inline",
                   "",
            ],
            [
                   "isThermalCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_isThermalImagingCamera_inline",
                   "`true` if the current connected device is a thermal imaging camera. @return BOOL `true` if current connected device is thermal imaging camera. For Zenmuse H20T and H20N, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "`true` if the current connected device is a thermal imaging camera. @return BOOL `true` if current connected device is thermal imaging camera. For Zenmuse H20T and H20N, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_isThermalImagingCamera_inline",
                   "",
            ],
            [
                   "IS_THERMAL_CAMERA",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_isThermalImagingCamera_inline",
                   "SDK Key for isThermalCamera: `true` if the current connected device is a thermal imaging camera. @return BOOL `true` if current connected device is thermal imaging camera. For Zenmuse H20T and H20N, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "SDK Key for isThermalCamera: `true` if the current connected device is a thermal imaging camera. @return BOOL `true` if current connected device is thermal imaging camera. For Zenmuse H20T and H20N, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_isThermalImagingCamera_inline",
                   "",
            ],
            [
                   "setThermalROI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalROI_inline",
                   "Sets the Region of Interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the Region of Interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalROI_inline",
                   "",
            ],
            [
                   "THERMAL_ROI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalROI_inline",
                   "SDK Key for setThermalROI: Sets the Region of Interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalROI: Sets the Region of Interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalROI_inline",
                   "",
            ],
            [
                   "getThermalROI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalROI_inline",
                   "Gets the Region of Interest. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the Region of Interest. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalROI_inline",
                   "",
            ],
            [
                   "THERMAL_ROI",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalROI_inline",
                   "SDK Key for getThermalROI: Gets the Region of Interest. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalROI: Gets the Region of Interest. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalROI_inline",
                   "",
            ],
            [
                   "setThermalPalette",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalPalette_inline",
                   "Sets the Palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. The valid range can be fetched from `thermalPaletteRange`. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the Palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. The valid range can be fetched from `thermalPaletteRange`. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalPalette_inline",
                   "",
            ],
            [
                   "THERMAL_PALETTE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalPalette_inline",
                   "SDK Key for setThermalPalette: Sets the Palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. The valid range can be fetched from `thermalPaletteRange`. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalPalette: Sets the Palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands. The valid range can be fetched from `thermalPaletteRange`. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalPalette_inline",
                   "",
            ],
            [
                   "getThermalPalette",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalPalette_inline",
                   "Gets the Palette. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the Palette. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalPalette_inline",
                   "",
            ],
            [
                   "THERMAL_PALETTE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalPalette_inline",
                   "SDK Key for getThermalPalette: Gets the Palette. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalPalette: Gets the Palette. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalPalette_inline",
                   "",
            ],
            [
                   "setThermalScene",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalScene_inline",
                   "Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO,  brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO,  brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalScene_inline",
                   "",
            ],
            [
                   "THERMAL_SCENE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalScene_inline",
                   "SDK Key for setThermalScene: Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO,  brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalScene: Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO,  brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalScene_inline",
                   "",
            ],
            [
                   "getThermalScene",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalScene_inline",
                   "Gets current scene. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current scene. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalScene_inline",
                   "",
            ],
            [
                   "THERMAL_SCENE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalScene_inline",
                   "SDK Key for getThermalScene: Gets current scene. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalScene: Gets current scene. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalScene_inline",
                   "",
            ],
            [
                   "setThermalDDE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDDE_inline",
                   "Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDDE_inline",
                   "",
            ],
            [
                   "THERMAL_DDE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDDE_inline",
                   "SDK Key for setThermalDDE: Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalDDE: Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDDE_inline",
                   "",
            ],
            [
                   "getThermalDDE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDDE_inline",
                   "Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDDE_inline",
                   "",
            ],
            [
                   "THERMAL_DDE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDDE_inline",
                   "SDK Key for getThermalDDE: Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalDDE: Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDDE_inline",
                   "",
            ],
            [
                   "setThermalACE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalACE_inline",
                   "Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalACE_inline",
                   "",
            ],
            [
                   "THERMAL_ACE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalACE_inline",
                   "SDK Key for setThermalACE: Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalACE: Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalACE_inline",
                   "",
            ],
            [
                   "getThermalACE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalACE_inline",
                   "Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalACE_inline",
                   "",
            ],
            [
                   "THERMAL_ACE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalACE_inline",
                   "SDK Key for getThermalACE: Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalACE: Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalACE_inline",
                   "",
            ],
            [
                   "setThermalSSO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSSO_inline",
                   "Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSSO_inline",
                   "",
            ],
            [
                   "THERMAL_SSO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSSO_inline",
                   "SDK Key for setThermalSSO: Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalSSO: Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSSO_inline",
                   "",
            ],
            [
                   "getThermalSSO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSSO_inline",
                   "Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSSO_inline",
                   "",
            ],
            [
                   "THERMAL_SSO",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSSO_inline",
                   "SDK Key for getThermalSSO: Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalSSO: Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSSO_inline",
                   "",
            ],
            [
                   "setThermalBrightness",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBrightness_inline",
                   "Sets the brightness of the image. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the brightness of the image. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBrightness_inline",
                   "",
            ],
            [
                   "THERMAL_BRIGHTNESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBrightness_inline",
                   "SDK Key for setThermalBrightness: Sets the brightness of the image. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalBrightness: Sets the brightness of the image. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBrightness_inline",
                   "",
            ],
            [
                   "getThermalBrightness",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalBrightness_inline",
                   "Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalBrightness_inline",
                   "",
            ],
            [
                   "THERMAL_BRIGHTNESS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalBrightness_inline",
                   "SDK Key for getThermalBrightness: Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalBrightness: Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalBrightness_inline",
                   "",
            ],
            [
                   "setThermalContrast",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalContrast_inline",
                   "Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalContrast_inline",
                   "",
            ],
            [
                   "THERMAL_CONTRAST",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalContrast_inline",
                   "SDK Key for setThermalContrast: Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalContrast: Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalContrast_inline",
                   "",
            ],
            [
                   "getThermalContrast",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalContrast_inline",
                   "Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalContrast_inline",
                   "",
            ],
            [
                   "THERMAL_CONTRAST",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalContrast_inline",
                   "SDK Key for getThermalContrast: Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalContrast: Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalContrast_inline",
                   "",
            ],
            [
                   "setThermalIsothermEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermEnabled_inline",
                   "Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermEnabled_inline",
                   "SDK Key for setThermalIsothermEnabled: Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalIsothermEnabled: Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "getThermalIsothermEnabled",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermEnabled_inline",
                   "Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_ENABLED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermEnabled_inline",
                   "SDK Key for getThermalIsothermEnabled: Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalIsothermEnabled: Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "setThermalIsothermUnit",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUnit_inline",
                   "Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms. Supported only by thermal imaging cameras except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param unit An enum type of the CameraThermalIsothermUnit to be used. Please refer to DJICameraThermalIsothermUnit. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms. Supported only by thermal imaging cameras except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param unit An enum type of the CameraThermalIsothermUnit to be used. Please refer to DJICameraThermalIsothermUnit. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UNIT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUnit_inline",
                   "SDK Key for setThermalIsothermUnit: Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms. Supported only by thermal imaging cameras except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param unit An enum type of the CameraThermalIsothermUnit to be used. Please refer to DJICameraThermalIsothermUnit. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalIsothermUnit: Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms. Supported only by thermal imaging cameras except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param unit An enum type of the CameraThermalIsothermUnit to be used. Please refer to DJICameraThermalIsothermUnit. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "getThermalIsothermUnit",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUnit_inline",
                   "Gets the units for Isotherm ranges. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the units for Isotherm ranges. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UNIT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUnit_inline",
                   "SDK Key for getThermalIsothermUnit: Gets the units for Isotherm ranges. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalIsothermUnit: Gets the units for Isotherm ranges. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Mavic 2 Enterprise Dual, the Isotherm unit is always `CELSIUS`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "setThermalIsothermUpperValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the allowed range is [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400]. For other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or larger than middle Isotherm threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the allowed range is [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400]. For other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or larger than middle Isotherm threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UPPER_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "SDK Key for setThermalIsothermUpperValue: Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the allowed range is [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400]. For other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or larger than middle Isotherm threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalIsothermUpperValue: Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the allowed range is [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400]. For other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or larger than middle Isotherm threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermUpperValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "Gets the upper threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the upper threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UPPER_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "SDK Key for getThermalIsothermUpperValue: Gets the upper threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalIsothermUpperValue: Gets the upper threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "setThermalIsothermMiddleValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_MIDDLE_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "SDK Key for setThermalIsothermMiddleValue: Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalIsothermMiddleValue: Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermMiddleValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "Gets the middle threshold value for Isotherm. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the middle threshold value for Isotherm. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_MIDDLE_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "SDK Key for getThermalIsothermMiddleValue: Gets the middle threshold value for Isotherm. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalIsothermMiddleValue: Gets the middle threshold value for Isotherm. Supported only by thermal imaging cameras, except Mavic 2 Enterprise Dual thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "setThermalIsothermLowerValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_LOWER_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "SDK Key for setThermalIsothermLowerValue: Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalIsothermLowerValue: Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, for Mavic 2 Enterprise Dual thermal camera, the value range is [-10, 400], for other thermal imaging cameras, the value range is [-40, 500]. The value can only be equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermLowerValue",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "Gets the lower threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lower threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_LOWER_VALUE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "SDK Key for getThermalIsothermLowerValue: Gets the lower threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalIsothermLowerValue: Gets the lower threshold value for Isotherm. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "setThermalGainMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalGainMode_inline",
                   "Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius. Supported by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius. Supported by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalGainMode_inline",
                   "",
            ],
            [
                   "THERMAL_GAIN_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalGainMode_inline",
                   "SDK Key for setThermalGainMode: Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius. Supported by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalGainMode: Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius. Supported by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalGainMode_inline",
                   "",
            ],
            [
                   "getThermalGainMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalGainMode_inline",
                   "Gets the gain mode. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the gain mode. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalGainMode_inline",
                   "",
            ],
            [
                   "THERMAL_GAIN_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalGainMode_inline",
                   "SDK Key for getThermalGainMode: Gets the gain mode. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalGainMode: Gets the gain mode. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalGainMode_inline",
                   "",
            ],
            [
                   "setThermalMeasurementMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeasurementMode_inline",
                   "Sets the mode for thermal measurement. Use callback method  `onUpdate` to receive the measurement result. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired measurement mode. @param callback Execution callback that receives the getter execution result.",
            ],
            [
                   "Sets the mode for thermal measurement. Use callback method  `onUpdate` to receive the measurement result. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired measurement mode. @param callback Execution callback that receives the getter execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "THERMAL_MEASUREMENT_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeasurementMode_inline",
                   "SDK Key for setThermalMeasurementMode: Sets the mode for thermal measurement. Use callback method  `onUpdate` to receive the measurement result. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired measurement mode. @param callback Execution callback that receives the getter execution result.",
            ],
            [
                   "SDK Key for setThermalMeasurementMode: Sets the mode for thermal measurement. Use callback method  `onUpdate` to receive the measurement result. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired measurement mode. @param callback Execution callback that receives the getter execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "getThermalMeasurementMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeasurementMode_inline",
                   "Gets the mode for thermal measurement. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the mode for thermal measurement. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "THERMAL_MEASUREMENT_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeasurementMode_inline",
                   "SDK Key for getThermalMeasurementMode: Gets the mode for thermal measurement. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalMeasurementMode: Gets the mode for thermal measurement. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "setThermalDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDigitalZoomScale_inline",
                   "Adjusts the digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to CameraThermalDigitalZoomScale in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Adjusts the digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to CameraThermalDigitalZoomScale in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "THERMAL_DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDigitalZoomScale_inline",
                   "SDK Key for setThermalDigitalZoomFactor: Adjusts the digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to CameraThermalDigitalZoomScale in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalDigitalZoomFactor: Adjusts the digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to CameraThermalDigitalZoomScale in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "getThermalDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDigitalZoomScale_inline",
                   "Gets current digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "THERMAL_DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDigitalZoomScale_inline",
                   "SDK Key for getThermalDigitalZoomFactor: Gets current digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalDigitalZoomFactor: Gets current digital zoom. Supported only by thermal imaging cameras. For Zenmuse H20T, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "getThermalProfile",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalProfile_inline",
                   "Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalProfile_inline",
                   "",
            ],
            [
                   "THERMAL_PROFILE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalProfile_inline",
                   "SDK Key for getThermalProfile: Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalProfile: Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalProfile_inline",
                   "",
            ],
            [
                   "setThermalSpotMeteringTargetPoint",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback` with the temperature at a specific coordinate in the scene. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback` with the temperature at a specific coordinate in the scene. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "THERMAL_SPOT_METERING_TARGET_POINT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "SDK Key for setThermalSpotMeteringTargetPoint: Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback` with the temperature at a specific coordinate in the scene. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalSpotMeteringTargetPoint: Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback` with the temperature at a specific coordinate in the scene. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "getThermalSpotMeteringTargetPoint",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "Gets the spot metering target point if one is set, if not then returns CGPointZero. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the spot metering target point if one is set, if not then returns CGPointZero. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "THERMAL_SPOT_METERING_TARGET_POINT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "SDK Key for getThermalSpotMeteringTargetPoint: Gets the spot metering target point if one is set, if not then returns CGPointZero. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalSpotMeteringTargetPoint: Gets the spot metering target point if one is set, if not then returns CGPointZero. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "setThermalMeteringArea",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeteringArea_inline",
                   "Set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` callback method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T, please use class `Lens`.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` callback method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T, please use class `Lens`.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeteringArea_inline",
                   "",
            ],
            [
                   "THERMAL_METERING_AREA",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeteringArea_inline",
                   "SDK Key for setThermalMeteringArea: Set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` callback method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T, please use class `Lens`.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalMeteringArea: Set the metering area for a rectangle inside the thermal image scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` callback method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T, please use class `Lens`.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalMeteringArea_inline",
                   "",
            ],
            [
                   "getThermalMeteringArea",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeteringArea_inline",
                   "Get a rect representing the currently set metering area for the thermal scene. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get a rect representing the currently set metering area for the thermal scene. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeteringArea_inline",
                   "",
            ],
            [
                   "THERMAL_METERING_AREA",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeteringArea_inline",
                   "SDK Key for getThermalMeteringArea: Get a rect representing the currently set metering area for the thermal scene. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalMeteringArea: Get a rect representing the currently set metering area for the thermal scene. Supported only by XT2, Mavic 2 Enterprise Dual and Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalMeteringArea_inline",
                   "",
            ],
            [
                   "setThermalFFCMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalFFCMode_inline",
                   "Set the flat-field correction (FFC) mode. Supported only by thermal imaging cameras. For Mavic 2 Enterprise Dual thermal camera, the `ThermalFFCMode` is always `AUTO`. For Mavic 2 Enterprise Advanced camera, support `AUTO` and `MANUAL`. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the flat-field correction (FFC) mode. Supported only by thermal imaging cameras. For Mavic 2 Enterprise Dual thermal camera, the `ThermalFFCMode` is always `AUTO`. For Mavic 2 Enterprise Advanced camera, support `AUTO` and `MANUAL`. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalFFCMode_inline",
                   "",
            ],
            [
                   "THERMAL_FFC_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalFFCMode_inline",
                   "SDK Key for setThermalFFCMode: Set the flat-field correction (FFC) mode. Supported only by thermal imaging cameras. For Mavic 2 Enterprise Dual thermal camera, the `ThermalFFCMode` is always `AUTO`. For Mavic 2 Enterprise Advanced camera, support `AUTO` and `MANUAL`. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalFFCMode: Set the flat-field correction (FFC) mode. Supported only by thermal imaging cameras. For Mavic 2 Enterprise Dual thermal camera, the `ThermalFFCMode` is always `AUTO`. For Mavic 2 Enterprise Advanced camera, support `AUTO` and `MANUAL`. For Zenmuse H20T and H20N, please use class `Lens`.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalFFCMode_inline",
                   "",
            ],
            [
                   "getThermalFFCMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalFFCMode_inline",
                   "Get the currently set flat-field correction (FFC) mode. Supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. For Mavic 2 Enterprise Dual thermal camera, the `DJICamera_DJICameraThermalFFCMode` is always `DJICamera_DJICameraThermalFFCMode_Auto`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get the currently set flat-field correction (FFC) mode. Supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. For Mavic 2 Enterprise Dual thermal camera, the `DJICamera_DJICameraThermalFFCMode` is always `DJICamera_DJICameraThermalFFCMode_Auto`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalFFCMode_inline",
                   "",
            ],
            [
                   "THERMAL_FFC_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalFFCMode_inline",
                   "SDK Key for getThermalFFCMode: Get the currently set flat-field correction (FFC) mode. Supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. For Mavic 2 Enterprise Dual thermal camera, the `DJICamera_DJICameraThermalFFCMode` is always `DJICamera_DJICameraThermalFFCMode_Auto`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalFFCMode: Get the currently set flat-field correction (FFC) mode. Supported only by thermal imaging cameras with installed firmware version of 1.15.1.60 or higher. For Mavic 2 Enterprise Dual thermal camera, the `DJICamera_DJICameraThermalFFCMode` is always `DJICamera_DJICameraThermalFFCMode_Auto`. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalFFCMode_inline",
                   "",
            ],
            [
                   "triggerThermalFFC",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_triggerThermalFFCMode_inline",
                   "Trigger flat-field correction. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with result of the trigger action.",
            ],
            [
                   "Trigger flat-field correction. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with result of the trigger action.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_triggerThermalFFCMode_inline",
                   "",
            ],
            [
                   "TRIGGER_THERMAL_FFC",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_triggerThermalFFCMode_inline",
                   "SDK Key for triggerThermalFFC: Trigger flat-field correction. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with result of the trigger action.",
            ],
            [
                   "SDK Key for triggerThermalFFC: Trigger flat-field correction. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with result of the trigger action.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_triggerThermalFFCMode_inline",
                   "",
            ],
            [
                   "setThermalCustomExternalSceneSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "Set the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "THERMAL_CUSTOM_EXTERNAL_SCENE_SETTINGS_PROFILE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "SDK Key for setThermalCustomExternalSceneSettingsProfile: Set the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalCustomExternalSceneSettingsProfile: Set the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "getThermalCustomExternalSceneSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "Get the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "THERMAL_CUSTOM_EXTERNAL_SCENE_SETTINGS_PROFILE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "SDK Key for getThermalCustomExternalSceneSettingsProfile: Get the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getThermalCustomExternalSceneSettingsProfile: Get the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Supported only by thermal imaging cameras. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "setThermalAtmosphericTemperature",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "Set the temperature of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the temperature of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "SDK Key for setThermalAtmosphericTemperature: Set the temperature of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalAtmosphericTemperature: Set the temperature of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "",
            ],
            [
                   "setThermalAtmosphericTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "Set the transmission coefficient of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the transmission coefficient of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "SDK Key for setThermalAtmosphericTransmissionCoefficient: Set the transmission coefficient of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalAtmosphericTransmissionCoefficient: Set the transmission coefficient of the atmosphere between the scene and the camera. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "setThermalBackgroundTemperature",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "Set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_BACKGROUND_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "SDK Key for setThermalBackgroundTemperature: Set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalBackgroundTemperature: Set the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "",
            ],
            [
                   "setThermalSceneEmissivity",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSceneEmissivity_inline",
                   "Set the emissivity of the thermal scene, can be between 50 and 100. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the emissivity of the thermal scene, can be between 50 and 100. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSceneEmissivity_inline",
                   "",
            ],
            [
                   "THERMAL_SCENE_EMISSIVITY",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSceneEmissivity_inline",
                   "SDK Key for setThermalSceneEmissivity: Set the emissivity of the thermal scene, can be between 50 and 100. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalSceneEmissivity: Set the emissivity of the thermal scene, can be between 50 and 100. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalSceneEmissivity_inline",
                   "",
            ],
            [
                   "setThermalWindowReflection",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflection_inline",
                   "Set assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflection_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTION",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflection_inline",
                   "SDK Key for setThermalWindowReflection: Set assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalWindowReflection: Set assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflection_inline",
                   "",
            ],
            [
                   "setThermalWindowReflectedTemperature",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "Set the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTED_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "SDK Key for setThermalWindowReflectedTemperature: Set the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalWindowReflectedTemperature: Set the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "",
            ],
            [
                   "setThermalWindowTemperature",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTemperature_inline",
                   "Set the window temperature, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the window temperature, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTemperature_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TEMPERATURE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTemperature_inline",
                   "SDK Key for setThermalWindowTemperature: Set the window temperature, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalWindowTemperature: Set the window temperature, can be between -50 and 327.67 degrees Celsius. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTemperature_inline",
                   "",
            ],
            [
                   "setThermalWindowTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "Set the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TRANSMISSION_COEFFICIENT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "SDK Key for setThermalWindowTransmissionCoefficient: Set the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setThermalWindowTransmissionCoefficient: Set the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20T and H20N, please use class `Lens`.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "setThermalTemperatureUnit",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalTemperatureUnit_inline",
                   "Sets the temperature unit. Only supported by XT2 and Mavic 2 Enterprise Dual. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param temperatureUnit An enum value of `TemperatureUnit`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the temperature unit. Only supported by XT2 and Mavic 2 Enterprise Dual. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param temperatureUnit An enum value of `TemperatureUnit`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setThermalTemperatureUnit_inline",
                   "",
            ],
            [
                   "getThermalTemperatureUnit",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalTemperatureUnit_inline",
                   "Gets the temperature unit. Only supported by XT2 and Mavic 2 Enterprise Dual Thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the temperature unit. Only supported by XT2 and Mavic 2 Enterprise Dual Thermal camera. For Zenmuse H20T and H20N, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getThermalTemperatureUnit_inline",
                   "",
            ],
            [
                   "setDisplayMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDisplayMode_inline",
                   "Sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and Mavic 2 Enterprise Dual Thermal Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode The display mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and Mavic 2 Enterprise Dual Thermal Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param mode The display mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDisplayMode_inline",
                   "",
            ],
            [
                   "getDisplayMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDisplayMode_inline",
                   "Gets the display mode. The display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and Mavic 2 Enterprise Dual Thermal Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the display mode. The display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and Mavic 2 Enterprise Dual Thermal Camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDisplayMode_inline",
                   "",
            ],
            [
                   "setPIPPosition",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setPIPPosition_inline",
                   "Set the Picture in picture mode of XT2 camera.For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param position Could be one of the Enum SettingsDefinitions.PIPPosition @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the Picture in picture mode of XT2 camera.For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param position Could be one of the Enum SettingsDefinitions.PIPPosition @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setPIPPosition_inline",
                   "",
            ],
            [
                   "getPIPPosition",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getPIPPosition_inline",
                   "Get picture in picture mode of XT2 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Get picture in picture mode of XT2 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getPIPPosition_inline",
                   "",
            ],
            [
                   "setMSXLevel",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setMSXLevel_inline",
                   "Sets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only supported by XT2 camera and Mavic 2 Enterprise Dual. Mavic 2 Enterprise Dual does not support with firmware version lower than 01.01.0520. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param level The MSX level to set with range [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only supported by XT2 camera and Mavic 2 Enterprise Dual. Mavic 2 Enterprise Dual does not support with firmware version lower than 01.01.0520. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param level The MSX level to set with range [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setMSXLevel_inline",
                   "",
            ],
            [
                   "getMSXLevel",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getMSXLevel_inline",
                   "Gets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only supported by XT2 camera and Mavic 2 Enterprise Dual. Mavic 2 Enterprise Dual does not support with firmware version lower than 01.01.0520. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only supported by XT2 camera and Mavic 2 Enterprise Dual. Mavic 2 Enterprise Dual does not support with firmware version lower than 01.01.0520. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getMSXLevel_inline",
                   "",
            ],
            [
                   "setDualFeedVerticalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDualFeedVerticalAlignmentOffset_inline",
                   "Sets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-8, 8]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window up. Use this setting to fine-tune the performance of MSX display mode and the align PIP mode. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param offset Range from -8 to 8 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-8, 8]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window up. Use this setting to fine-tune the performance of MSX display mode and the align PIP mode. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param offset Range from -8 to 8 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDualFeedVerticalAlignmentOffset_inline",
                   "",
            ],
            [
                   "getDualFeedVerticalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDualFeedVerticalAlignmentOffset_inline",
                   "Gets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-8, 8]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window up. Only supported by XT2 camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the vertical alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-8, 8]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window up. Only supported by XT2 camera and Mavic 2 Enterprise Dual camera.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDualFeedVerticalAlignmentOffset_inline",
                   "",
            ],
            [
                   "setDualFeedHorizontalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDualFeedHorizontalAlignmentOffset_inline",
                   "Sets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-100, 100]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window to the right. Use this setting to fine-tune the performance of MSX display mode and the align PIP mode. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param offset Range from -100 to 100 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-100, 100]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window to the right. Use this setting to fine-tune the performance of MSX display mode and the align PIP mode. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param offset Range from -100 to 100 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_setDualFeedHorizontalAlignmentOffset_inline",
                   "",
            ],
            [
                   "getDualFeedHorizontalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDualFeedHorizontalAlignmentOffset_inline",
                   "Gets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-100, 100]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window to the right. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the horizontal alignment offset between the video feeds from both the visual camera and the thermal camera. The alignment is applied to the MSX display mode. Different camera results in different value ranges. For XT2 camera, the valid range is [-100, 100]. For Mavic 2 Enterprise Dual, the valid range is [-40, 40]. Positive value will move the thermal window to the right. Only supported by XT2 camera and Mavic 2 Enterprise Dual.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_ThermalCamera_getDualFeedHorizontalAlignmentOffset_inline",
                   "",
            ],
            [
                   "isMultiLensCameraSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_isMultiLensCameraSupported_inline",
                   "Determines if the camera supports the multiple lens.  @return `true` if the multiple lens is supported.",
            ],
            [
                   "Determines if the camera supports the multiple lens.  @return `true` if the multiple lens is supported.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_isMultiLensCameraSupported_inline",
                   "",
            ],
            [
                   "isMultiVideoStreamSourceSupported",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_isMultiVideoStreamSourceSupported_inline",
                   "Determines whether the camera supports multi video stream source or not.  @return A boolean value.",
            ],
            [
                   "Determines whether the camera supports multi video stream source or not.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_isMultiVideoStreamSourceSupported_inline",
                   "",
            ],
            [
                   "setCameraVideoStreamSource",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCameraVideoStreamSource_inline",
                   "Sets the camera video stream source. For multi-lens cameras, the camera stream has different sources. `CameraVideoStreamSource` is used to represents the camera video stream source. When the source of the camera video stream is set, the current live view stream will also been changed to corresponding source. It is only supported by Zenmuse H20 Series.  @param cameraVideoStreamSource The camera video stream source. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the camera video stream source. For multi-lens cameras, the camera stream has different sources. `CameraVideoStreamSource` is used to represents the camera video stream source. When the source of the camera video stream is set, the current live view stream will also been changed to corresponding source. It is only supported by Zenmuse H20 Series.  @param cameraVideoStreamSource The camera video stream source. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCameraVideoStreamSource_inline",
                   "",
            ],
            [
                   "getCameraVideoStreamSource",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getCameraVideoStreamSource_inline",
                   "Gets the camera video stream source. For multi-lens cameras, the camera stream has different sources. `CameraVideoStreamSource` is used to represents the camera video stream source. When the source of the camera video stream is set, the image transmission will also been changed to corresponding source. It is only supported by Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the camera video stream source. For multi-lens cameras, the camera stream has different sources. `CameraVideoStreamSource` is used to represents the camera video stream source. When the source of the camera video stream is set, the image transmission will also been changed to corresponding source. It is only supported by Zenmuse H20 series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getCameraVideoStreamSource_inline",
                   "",
            ],
            [
                   "setCaptureCameraStreamSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCaptureCameraStreamSettings_inline",
                   "By default, all lenses of this camera will take photos. by using this interface, you can select your interested lens to take photos. Before calling this interface, you should set the camera mode to photo mode. Only supported by Zenmuse H20 series.  @param streamSettings An object of `CameraStreamSettings`. @param callback Callback that receives the setter execution result.",
            ],
            [
                   "By default, all lenses of this camera will take photos. by using this interface, you can select your interested lens to take photos. Before calling this interface, you should set the camera mode to photo mode. Only supported by Zenmuse H20 series.  @param streamSettings An object of `CameraStreamSettings`. @param callback Callback that receives the setter execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setCaptureCameraStreamSettings_inline",
                   "",
            ],
            [
                   "getCaptureCameraStreamSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getCaptureCameraStreamSettings_inline",
                   "Gets the capture camera stream settings for taking photo. Only supported by Zenmuse H20 series.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the capture camera stream settings for taking photo. Only supported by Zenmuse H20 series.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getCaptureCameraStreamSettings_inline",
                   "",
            ],
            [
                   "setRecordCameraStreamSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setRecordCameraStreamSettings_inline",
                   "Sets the camera stream settings for recording video. When recording video, it will been determined whether if current screen is recorded and which camera stream sources are recorded according the camera settings. The class of `CameraStreamSettings` is used to set the camera stream settings. Before calling this interface, you should set the camera mode to video mode. Only supported by Zenmuse H20 series.  @param streamSettings An object of `CameraStreamSettings`. @param callback Callback that receives the setter execution result.",
            ],
            [
                   "Sets the camera stream settings for recording video. When recording video, it will been determined whether if current screen is recorded and which camera stream sources are recorded according the camera settings. The class of `CameraStreamSettings` is used to set the camera stream settings. Before calling this interface, you should set the camera mode to video mode. Only supported by Zenmuse H20 series.  @param streamSettings An object of `CameraStreamSettings`. @param callback Callback that receives the setter execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_setRecordCameraStreamSettings_inline",
                   "",
            ],
            [
                   "getRecordCameraStreamSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getRecordCameraStreamSettings_inline",
                   "Gets the capture camera stream settings for recording video. Only supported by Zenmuse H20 series.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the capture camera stream settings for recording video. Only supported by Zenmuse H20 series.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_MultiLenses_getRecordCameraStreamSettings_inline",
                   "",
            ],
            [
                   "setMultispectralDisplayMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralDisplayMode_inline",
                   "Sets the display mode to coordinate the video feeds from both the RGB sensor and single-band sensors. Only supported by multispectral camera of P4 Multispectral.  @param displayMode The display mode to set. @param callback Callback that receives the setter execution result.",
            ],
            [
                   "Sets the display mode to coordinate the video feeds from both the RGB sensor and single-band sensors. Only supported by multispectral camera of P4 Multispectral.  @param displayMode The display mode to set. @param callback Callback that receives the setter execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralDisplayMode_inline",
                   "",
            ],
            [
                   "getMultispectralDisplayMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralDisplayMode_inline",
                   "Gets the display mode. The display mode determines the way to coordinate the video feeds from both the RGB sensor and single-band sensors. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the display mode. The display mode determines the way to coordinate the video feeds from both the RGB sensor and single-band sensors. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralDisplayMode_inline",
                   "",
            ],
            [
                   "setMultispectralStoragePhotoSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralStoragePhotoSettings_inline",
                   "Sets the storage settings for the multispectral camera. The settings control if the photos created by different sensors will be saved or not. Only supported by multispectral camera of P4 Multispectral.  @param settings An object of `MultispectralStoragePhotoSettings`. @param callback Callback to receive the setter result.",
            ],
            [
                   "Sets the storage settings for the multispectral camera. The settings control if the photos created by different sensors will be saved or not. Only supported by multispectral camera of P4 Multispectral.  @param settings An object of `MultispectralStoragePhotoSettings`. @param callback Callback to receive the setter result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralStoragePhotoSettings_inline",
                   "",
            ],
            [
                   "getMultispectralStoragePhotoSettings",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralStoragePhotoSettings_inline",
                   "Gets the storage settings for the multispectral camera. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the getter result.",
            ],
            [
                   "Gets the storage settings for the multispectral camera. Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the getter result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralStoragePhotoSettings_inline",
                   "",
            ],
            [
                   "setMultispectralMeteringMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralMeteringMode_inline",
                   "Sets the metering mode for the single-band sensors on the multispectral camera. The same metering mode will be applied to all single-band sensors (sensors except the RGB one). Only `CENTER` and `AVERAGE` mode to be set. Only supported by multispectral camera of P4 Multispectral.  @param mode Exposure metering to set. @param callback Callback to receive the result.",
            ],
            [
                   "Sets the metering mode for the single-band sensors on the multispectral camera. The same metering mode will be applied to all single-band sensors (sensors except the RGB one). Only `CENTER` and `AVERAGE` mode to be set. Only supported by multispectral camera of P4 Multispectral.  @param mode Exposure metering to set. @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralMeteringMode_inline",
                   "",
            ],
            [
                   "getMultispectralMeteringMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralMeteringMode_inline",
                   "Gets the metering mode for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the metering mode for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralMeteringMode_inline",
                   "",
            ],
            [
                   "setMultispectralExposureMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralExposureMode_inline",
                   "Sets the exposure mode for the single-band sensors on the multispectral camera. The same exposure mode will be applied to all single-band sensors (sensors except the RGB one). Exposure mode must be `PROGRAM` or `SHUTTER_PRIORITY`. Only supported by multispectral camera of P4 Multispectral.  @param mode Camera exposure mode to set. @param callback Remote execution result error block.",
            ],
            [
                   "Sets the exposure mode for the single-band sensors on the multispectral camera. The same exposure mode will be applied to all single-band sensors (sensors except the RGB one). Exposure mode must be `PROGRAM` or `SHUTTER_PRIORITY`. Only supported by multispectral camera of P4 Multispectral.  @param mode Camera exposure mode to set. @param callback Remote execution result error block.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralExposureMode_inline",
                   "",
            ],
            [
                   "getMultispectralExposureMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralExposureMode_inline",
                   "Gets the exposure mode for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the exposure mode for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralExposureMode_inline",
                   "",
            ],
            [
                   "setMultispectralExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralExposureCompensation_inline",
                   "Sets the exposure compensation for the single-band sensors on the multispectral camera. The same exposure compensation will be applied to all single-band sensors (sensors except the RGB one). See `ExposureCompensation` to view all possible exposure compensations to which the single-band sensors can be set. In order to use this function, set the camera exposure mode to `PROGRAM` or `SHUTTER_PRIORITY` Only supported by multispectral camera of P4 Multispectral.  @param compensation Exposure compensation value to be set for the single-band sensors's. @param callback Callback to receive the result.",
            ],
            [
                   "Sets the exposure compensation for the single-band sensors on the multispectral camera. The same exposure compensation will be applied to all single-band sensors (sensors except the RGB one). See `ExposureCompensation` to view all possible exposure compensations to which the single-band sensors can be set. In order to use this function, set the camera exposure mode to `PROGRAM` or `SHUTTER_PRIORITY` Only supported by multispectral camera of P4 Multispectral.  @param compensation Exposure compensation value to be set for the single-band sensors's. @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralExposureCompensation_inline",
                   "",
            ],
            [
                   "getMultispectralExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralExposureCompensation_inline",
                   "Gets the exposure compensation for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the exposure compensation for all single-band sensors (sensors except the RGB one). Only supported by multispectral camera of P4 Multispectral.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralExposureCompensation_inline",
                   "",
            ],
            [
                   "setMultispectralShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralShutterSpeed_inline",
                   "Sets the shutter speed for the single-band sensors on the multispectral camera. The same shutter speed will be applied to all single-band sensors (sensors except the RGB one). To see all available shutter speed value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutter speed must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is `SHUTTER_PRIORITY` mode. Only supported by multispectral camera of P4 Multispectral.  @param shutterSpeed Shutter speed value to be set for the single-band sensors. For all available values shutterSpeed can be set to, please check `ShutterSpeed`. <br> The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate = 30fps, then the shutterSpeed must be <= 1/30. @param callback Remote execution result error block.",
            ],
            [
                   "Sets the shutter speed for the single-band sensors on the multispectral camera. The same shutter speed will be applied to all single-band sensors (sensors except the RGB one). To see all available shutter speed value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the shutter speed must be <= 1/30. Precondition: The shutter speed can be set only when the camera exposure mode is `SHUTTER_PRIORITY` mode. Only supported by multispectral camera of P4 Multispectral.  @param shutterSpeed Shutter speed value to be set for the single-band sensors. For all available values shutterSpeed can be set to, please check `ShutterSpeed`. <br> The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate = 30fps, then the shutterSpeed must be <= 1/30. @param callback Remote execution result error block.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralShutterSpeed_inline",
                   "",
            ],
            [
                   "getMultispectralShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralShutterSpeed_inline",
                   "Gets the shutter speed for all single-band sensors (sensors except the RGB one). The shutter speed is only available when the camera exposure mode is `SHUTTER_PRIORITY` mode.  @param callback Callback to receive the result.",
            ],
            [
                   "Gets the shutter speed for all single-band sensors (sensors except the RGB one). The shutter speed is only available when the camera exposure mode is `SHUTTER_PRIORITY` mode.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralShutterSpeed_inline",
                   "",
            ],
            [
                   "setMultispectralAELock",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralAELock_inline",
                   "Locks or unlocks the single-band sensors on the multispectral camera AELock AE (auto exposure). The same lock state will be applied to all single-band sensors (sensors except the RGB one).  @param isLocked `true` if the the single-band sensors AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Locks or unlocks the single-band sensors on the multispectral camera AELock AE (auto exposure). The same lock state will be applied to all single-band sensors (sensors except the RGB one).  @param isLocked `true` if the the single-band sensors AE is locked, `false` if it is unlocked. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_setMultispectralAELock_inline",
                   "",
            ],
            [
                   "getMultispectralAELock",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralAELock_inline",
                   "Determines if all the single-band (sensors except the RGB one) sensors on the multispectral camera AE (auto exposure) is locked.  @param callback Callback to receive the result.",
            ],
            [
                   "Determines if all the single-band (sensors except the RGB one) sensors on the multispectral camera AE (auto exposure) is locked.  @param callback Callback to receive the result.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CameraSettings_getMultispectralAELock_inline",
                   "",
            ],
            [
                   "DJICameraCalibrateState",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_inline",
                   "The calibration status of the camera's lens.",
            ],
            [
                   "The calibration status of the camera's lens.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_inline",
                   "",
            ],
            [
                   "NOT_CALIBRATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_NotCalibrate_inline",
                   "If the camera lenses are not calibrated. Focusing action will be influenced. Please use calibration interface if you need.",
            ],
            [
                   "If the camera lenses are not calibrated. Focusing action will be influenced. Please use calibration interface if you need.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_NotCalibrate_inline",
                   "",
            ],
            [
                   "CALIBRATED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Calibrated_inline",
                   "Camera lens calibrated. Do not need to calibrate.",
            ],
            [
                   "Camera lens calibrated. Do not need to calibrate.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Calibrated_inline",
                   "",
            ],
            [
                   "CALIBRATING",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Calibrating_inline",
                   "Calibration is in progress.",
            ],
            [
                   "Calibration is in progress.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Calibrating_inline",
                   "",
            ],
            [
                   "WAITING_FOR_CALIBRATE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_WaitingForCalibrate_inline",
                   "Waiting for the calibration.",
            ],
            [
                   "Waiting for the calibration.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_WaitingForCalibrate_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Other_inline",
                   "The camera lens's state is unknown.",
            ],
            [
                   "The camera lens's state is unknown.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateState_Other_inline",
                   "",
            ],
            [
                   "DJICameraCalibrateResult",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_inline",
                   "The calibration result of the camera's lens.",
            ],
            [
                   "The calibration result of the camera's lens.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Idle_inline",
                   "No calibration.",
            ],
            [
                   "No calibration.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Idle_inline",
                   "",
            ],
            [
                   "COMPLETED",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Completed_inline",
                   "The calibration is successful.",
            ],
            [
                   "The calibration is successful.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Completed_inline",
                   "",
            ],
            [
                   "FAIL_NORMAL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_FailNormal_inline",
                   "The calibration is failed. Please retry.",
            ],
            [
                   "The calibration is failed. Please retry.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_FailNormal_inline",
                   "",
            ],
            [
                   "DATA_ERROR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_DataError_inline",
                   "The calibration is failed because of the data error. Please retry.",
            ],
            [
                   "The calibration is failed because of the data error. Please retry.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_DataError_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Other_inline",
                   "The calibration is failed with the unknown error.",
            ],
            [
                   "The calibration is failed with the unknown error.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraCalibrateResult_Other_inline",
                   "",
            ],
            [
                   "CalibrationCallback",
                   2,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "",
                   "An interface for obtaining camera calibration state and result.",
            ],
            [
                   "An interface for obtaining camera calibration state and result.",
                   1,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "",
                   "",
            ],
            [
                   "OnStateUpdate",
                   2,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "#DJICamera_CalibrationCallback_OnStateUpdate_inline",
                   "Callback function that updates the camera calibartion state.  @param state The camera calibration state.",
            ],
            [
                   "Callback function that updates the camera calibartion state.  @param state The camera calibration state.",
                   1,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "#DJICamera_CalibrationCallback_OnStateUpdate_inline",
                   "",
            ],
            [
                   "OnResultUpdate",
                   2,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "#DJICamera_CalibrationCallback_OnResultUpdate_inline",
                   "Callback function that updates the camera calibartion result.  @param result The camera calibration result.",
            ],
            [
                   "Callback function that updates the camera calibartion result.  @param result The camera calibration result.",
                   1,
                   "/Components/Camera/DJICamera_CalibrationCallback.html",
                   "#DJICamera_CalibrationCallback_OnResultUpdate_inline",
                   "",
            ],
            [
                   "startCalibration",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_StartCalibration_inline",
                   "If you encounter the following situation, please call this interface for camera calibration. Only supported by Zemmuse P1.  1. Zemmuse P1 supports the replacement of a variety of fixed focus lenses, so when the lens is replaced, it is recommended that you recalibrate.  2. Please listen the `OnStateUpdate`, if the status is `NOT_CALIBRATE`, please recalibrate.  3. Please listen the hms error code, If you listen to the following error code, please recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D02: The camera calibration file failed to load, please perform infinity calibration.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D03: Infinity focus calibration data expired. Recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D04: Infinity focus calibration data expired. Recalibrate.  The following are the calibration steps:  1. Take off and ascend to 102 meters (335ft) or higher to start calibration. Fly with caution.  2. Call `startCalibration` interface. The state will change to `WAITING_FOR_CALIBRATE`.  3. Set gimbal angle as -90 degrees(perpendicular to the ground). Call `setFocusTarget` interface to set the object with multiple distinct visual patterns at the center of the camera view as focus. Then the state will change to `CALIBRATING`.  4. After finish the calibration, the state will change to `CALIBRATED`. You can use `DJICameraCalibrateResult` to listen the calibration result.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "If you encounter the following situation, please call this interface for camera calibration. Only supported by Zemmuse P1.  1. Zemmuse P1 supports the replacement of a variety of fixed focus lenses, so when the lens is replaced, it is recommended that you recalibrate.  2. Please listen the `OnStateUpdate`, if the status is `NOT_CALIBRATE`, please recalibrate.  3. Please listen the hms error code, If you listen to the following error code, please recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D02: The camera calibration file failed to load, please perform infinity calibration.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D03: Infinity focus calibration data expired. Recalibrate.  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; hms_0x1C000D04: Infinity focus calibration data expired. Recalibrate.  The following are the calibration steps:  1. Take off and ascend to 102 meters (335ft) or higher to start calibration. Fly with caution.  2. Call `startCalibration` interface. The state will change to `WAITING_FOR_CALIBRATE`.  3. Set gimbal angle as -90 degrees(perpendicular to the ground). Call `setFocusTarget` interface to set the object with multiple distinct visual patterns at the center of the camera view as focus. Then the state will change to `CALIBRATING`.  4. After finish the calibration, the state will change to `CALIBRATED`. You can use `DJICameraCalibrateResult` to listen the calibration result.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_StartCalibration_inline",
                   "",
            ],
            [
                   "stopCalibration",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_StopCalibration_inline",
                   "Stop camera calibraion.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Stop camera calibraion.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_StopCalibration_inline",
                   "",
            ],
            [
                   "calibratedInfinityFocus",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CalibratedInfinityFocus_inline",
                   "Make sure you have calibrated the lens' infinity focusing with `startCalibration`. When in use, the lens uses infinity focus as calibrated. To help ensure focusing accuracy, recalibrate the infinity focus when there is a large temperature difference between the mission environment and the calibration environment (>15 degrees Celsius).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Make sure you have calibrated the lens' infinity focusing with `startCalibration`. When in use, the lens uses infinity focus as calibrated. To help ensure focusing accuracy, recalibrate the infinity focus when there is a large temperature difference between the mission environment and the calibration environment (>15 degrees Celsius).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_CalibratedInfinityFocus_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraGeneratedNewMediaFileCallbackInterface.html",
                   "",
                   "Tells that a new media file (photo or video) is generated.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `NewFileInfoCallback` insteaded.",
            ],
            [
                   "Tells that a new media file (photo or video) is generated.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `NewFileInfoCallback` insteaded.",
                   1,
                   "/Components/Camera/DJICamera_CameraGeneratedNewMediaFileCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "NewFileInfoCallback",
                   2,
                   "/Components/Camera/DJICamera_CamerNewGeneratedMediaFileInfoCallbackInterface.html",
                   "",
                   "Tells that a new media file (photo or video) is generated.",
            ],
            [
                   "Tells that a new media file (photo or video) is generated.",
                   1,
                   "/Components/Camera/DJICamera_CamerNewGeneratedMediaFileInfoCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "TimeLapsePreviewCallback",
                   2,
                   "/Components/Camera/DJICamera_CameraGeneratedTimeLapsePreviewCallbackInterface.html",
                   "",
                   "Tells the callback that a preview image for the Time-lapse is generated. This method is available only when isTimeLapseSupported returns TRUE.",
            ],
            [
                   "Tells the callback that a preview image for the Time-lapse is generated. This method is available only when isTimeLapseSupported returns TRUE.",
                   1,
                   "/Components/Camera/DJICamera_CameraGeneratedTimeLapsePreviewCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "HistogramCallback",
                   2,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "",
                   "Called whenever the camera histogram's light values change.",
            ],
            [
                   "Called whenever the camera histogram's light values change.",
                   1,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "TapZoomStateCallback",
                   2,
                   "/Components/Camera/DJICamera_TapZoomStateCallbackInterface.html",
                   "",
                   "Called when the camera's zoom state is updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
            ],
            [
                   "Called when the camera's zoom state is updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_TapZoomStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "TemperatureDataCallback",
                   2,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "",
                   "Received temperature in degrees Celsius of image. For the XT, the temperature measurement data is the average of the center four pixels of the image. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
            ],
            [
                   "Received temperature in degrees Celsius of image. For the XT, the temperature measurement data is the average of the center four pixels of the image. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "THERMAL_TEMPERATURE_DATA",
                   2,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "",
                   "SDK Key for TemperatureDataCallback: Received temperature in degrees Celsius of image. For the XT, the temperature measurement data is the average of the center four pixels of the image. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
            ],
            [
                   "SDK Key for TemperatureDataCallback: Received temperature in degrees Celsius of image. For the XT, the temperature measurement data is the average of the center four pixels of the image. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "SystemState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "",
                   "This class provides general information and current status of the camera.",
            ],
            [
                   "This class provides general information and current status of the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSystemState.html",
                   "",
                   "",
            ],
            [
                   "FocusState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "",
                   "This class contains information about the lens' current state, including lens type, focus status, focus mode, focus assistant state, and Auto Focus (AF) switch state.",
            ],
            [
                   "This class contains information about the lens' current state, including lens type, focus status, focus mode, focus assistant state, and Auto Focus (AF) switch state.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLensState.html",
                   "",
                   "",
            ],
            [
                   "StorageState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "",
                   "This class provides the general information and state of the storage (SD card or the internal storage).",
            ],
            [
                   "This class provides the general information and state of the storage (SD card or the internal storage).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSDCardState.html",
                   "",
                   "",
            ],
            [
                   "SSDState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "",
                   "This class contains the information about camera's Solid State Drive (SSD) information, including state, whether it is connected, its capacity, video size and rate, etc.",
            ],
            [
                   "This class contains the information about camera's Solid State Drive (SSD) information, including state, whether it is connected, its capacity, video size and rate, etc.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDState.html",
                   "",
                   "",
            ],
            [
                   "MediaManager",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "",
                   "The media manager is used to interact with the file system on the SD card or the internal storage. By using the media manager, the user can get the metadata for all the multimedia files, and has access to each individual multimedia file.",
            ],
            [
                   "The media manager is used to interact with the file system on the SD card or the internal storage. By using the media manager, the user can get the metadata for all the multimedia files, and has access to each individual multimedia file.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "",
                   "",
            ],
            [
                   "PlaybackManager",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "",
                   "The playback manager is used to interact with the playback system of the camera. By using the playback manager, the user can control the playback system.",
            ],
            [
                   "The playback manager is used to interact with the playback system of the camera. By using the playback manager, the user can control the playback system.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "",
                   "",
            ],
            [
                   "Capabilities",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "",
                   "Some of the camera's parameters have dynamic ranges. The `Capabilities` class allows you to query the valid range for a parameter. Type-casting is required to get the corresponding enumerator value for each range element.",
            ],
            [
                   "Some of the camera's parameters have dynamic ranges. The `Capabilities` class allows you to query the valid range for a parameter. Type-casting is required to get the corresponding enumerator value for each range element.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "",
                   "",
            ],
            [
                   "SettingsDefinitions",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "",
                   "This class contains all the enums and setting classes for the DJI Camera.",
            ],
            [
                   "This class contains all the enums and setting classes for the DJI Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "",
                   "",
            ],
            [
                   "FlatCameraMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_inline",
                   "Flat camera mode can be used to set the mode to camera directly. The benefit is no need to set the camera mode to shoot photo mode or the Record video first. Please use `setFlatMode` to set the flat mode. This is available only when `isFlatCameraModeSupported` returns `true`.",
            ],
            [
                   "Flat camera mode can be used to set the mode to camera directly. The benefit is no need to set the camera mode to shoot photo mode or the Record video first. Please use `setFlatMode` to set the flat mode. This is available only when `isFlatCameraModeSupported` returns `true`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJIFlatCameraMode_inline",
                   "",
            ],
            [
                   "LensType",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_inline",
                   "Camera lens type. Only supported by Zenmuse H20 Series.",
            ],
            [
                   "Camera lens type. Only supported by Zenmuse H20 Series.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJILensType_inline",
                   "",
            ],
            [
                   "MultispectralDisplayMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_inline",
                   "Display modes to coordinate the video feeds from both the RGB sensor and single- band sensors. Only supported by multispectral camera of P4 Multispectral.",
            ],
            [
                   "Display modes to coordinate the video feeds from both the RGB sensor and single- band sensors. Only supported by multispectral camera of P4 Multispectral.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_MultispectralDisplayMode_inline",
                   "",
            ],
            [
                   "SpectrumBand",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_inline",
                   "Enums represent the spectrum bands of a multispectral camera. For P4 Multispectral, the camera supports 5 bands. Only supported by multispectral camera of P4 Multispectral.",
            ],
            [
                   "Enums represent the spectrum bands of a multispectral camera. For P4 Multispectral, the camera supports 5 bands. Only supported by multispectral camera of P4 Multispectral.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_SpectrumBand_inline",
                   "",
            ],
            [
                   "CameraMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "Camera work modes.",
            ],
            [
                   "Camera work modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "",
            ],
            [
                   "CameraKey.MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "SDK Key for CameraMode: Camera work modes.",
            ],
            [
                   "SDK Key for CameraMode: Camera work modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "",
            ],
            [
                   "MODE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "SDK Key for CameraMode: Camera work modes.",
            ],
            [
                   "SDK Key for CameraMode: Camera work modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMode_inline",
                   "",
            ],
            [
                   "ShootPhotoMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
            ],
            [
                   "The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "SDK Key for ShootPhotoMode: The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
            ],
            [
                   "SDK Key for ShootPhotoMode: The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "SDK Key for ShootPhotoMode: The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
            ],
            [
                   "SDK Key for ShootPhotoMode: The ShootPhoto mode itself can have several modes. The default value is `SINGLE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShootPhotoMode_inline",
                   "",
            ],
            [
                   "ExposureMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
            ],
            [
                   "Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "",
            ],
            [
                   "EXPOSURE_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "SDK Key for ExposureMode: Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
            ],
            [
                   "SDK Key for ExposureMode: Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "",
            ],
            [
                   "EXPOSURE_MODE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "SDK Key for ExposureMode: Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
            ],
            [
                   "SDK Key for ExposureMode: Camera exposure modes. The default value is `PROGRAM`. The different exposure modes define whether Aperture, Shutter Speed, ISO can be set automatically or manually. Exposure compensation can be changed in all modes except Manual mode where it is not settable. X5, X5R, Phantom 4 Pro camera, X4S and X5S:  Program Mode:       Shutter: Auto     Aperture: Auto     ISO: Manual or Auto  Shutter Priority: Shutter: Manual   Aperture: Auto     ISO: Manual or Auto  Aperture Priority:  Shutter: Auto     Aperture: Manual ISO: Manual or Auto  Manual Mode:        Shutter: Manual   Aperture: Manual   ISO: Manual All other cameras:</b>  Program Mode:       Shutter: Auto     Aperture: Fixed    ISO: Auto  Shutter Priority: Shutter: Manual   Aperture: Fixed    ISO: Auto  Aperture Priority:  NA  Manual Mode:        Shutter: Manual Aperture: Manual   ISO: Manual",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureMode_inline",
                   "",
            ],
            [
                   "ShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "Camera's shutter speed options.",
            ],
            [
                   "Camera's shutter speed options.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "SDK Key for ShutterSpeed: Camera's shutter speed options.",
            ],
            [
                   "SDK Key for ShutterSpeed: Camera's shutter speed options.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "SDK Key for ShutterSpeed: Camera's shutter speed options.",
            ],
            [
                   "SDK Key for ShutterSpeed: Camera's shutter speed options.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraShutterSpeed_inline",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "Camera ISO values.",
            ],
            [
                   "Camera ISO values.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "SDK Key for ISO: Camera ISO values.",
            ],
            [
                   "SDK Key for ISO: Camera ISO values.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "",
            ],
            [
                   "ISO_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "SDK Key for ISO: Camera ISO values.",
            ],
            [
                   "SDK Key for ISO: Camera ISO values.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraISO_inline",
                   "",
            ],
            [
                   "Aperture",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
            ],
            [
                   "Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "",
            ],
            [
                   "APERTURE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "SDK Key for Aperture: Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
            ],
            [
                   "SDK Key for Aperture: Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "",
            ],
            [
                   "APERTURE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "SDK Key for Aperture: Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
            ],
            [
                   "SDK Key for Aperture: Camera aperture values. Zenmuse P1, X5, X5R, Z30, Phantom 4 Pro camera, X4S and X5S support this setting.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAperture_inline",
                   "",
            ],
            [
                   "WhiteBalance",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "",
                   "This class contains current values for some camera parameters related to white balance. Values for the camera's current white balance preset and color temperature can be obtained from this class.",
            ],
            [
                   "This class contains current values for some camera parameters related to white balance. Values for the camera's current white balance preset and color temperature can be obtained from this class.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "",
                   "",
            ],
            [
                   "WHITE_BALANCE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "",
                   "SDK Key for WhiteBalance: This class contains current values for some camera parameters related to white balance. Values for the camera's current white balance preset and color temperature can be obtained from this class.",
            ],
            [
                   "SDK Key for WhiteBalance: This class contains current values for some camera parameters related to white balance. Values for the camera's current white balance preset and color temperature can be obtained from this class.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWhiteBalanceInterface.html",
                   "",
                   "",
            ],
            [
                   "SSDClipFileName",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "",
                   "The name of a video file stored in SSD.",
            ],
            [
                   "The name of a video file stored in SSD.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSSDClipFileNameInterface.html",
                   "",
                   "",
            ],
            [
                   "OriginalPhotoSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "",
                   "Settings to determine the behavior for the original photos created when doing composite shooting (e.g. panorama).",
            ],
            [
                   "Settings to determine the behavior for the original photos created when doing composite shooting (e.g. panorama).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOriginalPhotoSettings.html",
                   "",
                   "",
            ],
            [
                   "MultispectralStoragePhotoSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "",
                   "The settings for storing photos produced by a multispectral camera. Use the mutable class if modification of the settings is required. Only supported by multispectral camera of P4 Multispectral.",
            ],
            [
                   "The settings for storing photos produced by a multispectral camera. Use the mutable class if modification of the settings is required. Only supported by multispectral camera of P4 Multispectral.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralStorageSettings.html",
                   "",
                   "",
            ],
            [
                   "MultispectralExposureState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "",
                   "The exposure state of a single-band sensor on the multispectral camera. The parameters in the state determines the relationship between exposure and sensor data values. When the camera is in different exposure modes, parameters may be changed by the camera automatically to optimize the exposure.",
            ],
            [
                   "The exposure state of a single-band sensor on the multispectral camera. The parameters in the state determines the relationship between exposure and sensor data values. When the camera is in different exposure modes, parameters may be changed by the camera automatically to optimize the exposure.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraMultispectralExposureState.html",
                   "",
                   "",
            ],
            [
                   "WatermarkSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "",
                   "The watermark configuration to decide if timestamp and location stamp will be added to photos or videos.",
            ],
            [
                   "The watermark configuration to decide if timestamp and location stamp will be added to photos or videos.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraWatermarkSettings.html",
                   "",
                   "",
            ],
            [
                   "LaserMeasureInformation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "",
                   "The class is used to save laser sensor information which includes the laser sensor switch status, the target object information and laser state. The laser sensor must be at least 3m from the target point. Only supported by Zenmuse H20 Series.",
            ],
            [
                   "The class is used to save laser sensor information which includes the laser sensor switch status, the target object information and laser state. The laser sensor must be at least 3m from the target point. Only supported by Zenmuse H20 Series.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraLaserMeasureInformation.html",
                   "",
                   "",
            ],
            [
                   "WhiteBalancePreset",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "Camera white balance. The default value is Auto.",
            ],
            [
                   "Camera white balance. The default value is Auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "",
            ],
            [
                   "WHITE_BALANCE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "SDK Key for WhiteBalancePreset: Camera white balance. The default value is Auto.",
            ],
            [
                   "SDK Key for WhiteBalancePreset: Camera white balance. The default value is Auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "",
            ],
            [
                   "WHITE_BALANCE_PRESENT_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "SDK Key for WhiteBalancePreset: Camera white balance. The default value is Auto.",
            ],
            [
                   "SDK Key for WhiteBalancePreset: Camera white balance. The default value is Auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraWhiteBalance_inline",
                   "",
            ],
            [
                   "MeteringMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_inline",
                   "Camera exposure metering. The default value is Center.",
            ],
            [
                   "Camera exposure metering. The default value is Center.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_inline",
                   "",
            ],
            [
                   "METERING_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_inline",
                   "SDK Key for MeteringMode: Camera exposure metering. The default value is Center.",
            ],
            [
                   "SDK Key for MeteringMode: Camera exposure metering. The default value is Center.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraMeteringMode_inline",
                   "",
            ],
            [
                   "ExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "Camera exposure compensation.",
            ],
            [
                   "Camera exposure compensation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "SDK Key for ExposureCompensation: Camera exposure compensation.",
            ],
            [
                   "SDK Key for ExposureCompensation: Camera exposure compensation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "SDK Key for ExposureCompensation: Camera exposure compensation.",
            ],
            [
                   "SDK Key for ExposureCompensation: Camera exposure compensation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureCompensation_inline",
                   "",
            ],
            [
                   "ExposureSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "",
                   "This class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the ISO value, the shutter speed, and the aperture value. When the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in Program, Shutter Priority and Aperture Priority modes), or report back the current exposure (in Manual mode). The current values of these parameters used by the camera are contained in this class.",
            ],
            [
                   "This class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the ISO value, the shutter speed, and the aperture value. When the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in Program, Shutter Priority and Aperture Priority modes), or report back the current exposure (in Manual mode). The current values of these parameters used by the camera are contained in this class.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "",
                   "",
            ],
            [
                   "EXPOSURE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "",
                   "SDK Key for ExposureSettings: This class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the ISO value, the shutter speed, and the aperture value. When the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in Program, Shutter Priority and Aperture Priority modes), or report back the current exposure (in Manual mode). The current values of these parameters used by the camera are contained in this class.",
            ],
            [
                   "SDK Key for ExposureSettings: This class contains current values for some camera parameters related to exposure, which determines how sensitive the picture is to light and depends on the balance of the ISO value, the shutter speed, and the aperture value. When the camera is in different exposure modes, different parameters are automatically changed by the camera to either get the correct exposure (in Program, Shutter Priority and Aperture Priority modes), or report back the current exposure (in Manual mode). The current values of these parameters used by the camera are contained in this class.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraExposureParameters.html",
                   "",
                   "",
            ],
            [
                   "DisplayMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_inline",
                   "Display modes to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and and Mavic 2 Enterprise Dual Camera.",
            ],
            [
                   "Display modes to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and and Mavic 2 Enterprise Dual Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_inline",
                   "",
            ],
            [
                   "CameraKey.DISPLAY_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_inline",
                   "SDK Key for DisplayMode: Display modes to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and and Mavic 2 Enterprise Dual Camera.",
            ],
            [
                   "SDK Key for DisplayMode: Display modes to coordinate the video feeds from both the visual camera and the thermal camera. Only supported by XT2 camera and and Mavic 2 Enterprise Dual Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDisplayMode_inline",
                   "",
            ],
            [
                   "PIPPosition",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_inline",
                   "Possible positions to place the window of the thermal camera video feed when the display mode is `PIP`. Only supported by XT2 camera and Mavic 2 Enterprise Dual Light Camera.",
            ],
            [
                   "Possible positions to place the window of the thermal camera video feed when the display mode is `PIP`. Only supported by XT2 camera and Mavic 2 Enterprise Dual Light Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_inline",
                   "",
            ],
            [
                   "CameraKey.PIP_POSITION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_inline",
                   "SDK Key for PIPPosition: Possible positions to place the window of the thermal camera video feed when the display mode is `PIP`. Only supported by XT2 camera and Mavic 2 Enterprise Dual Light Camera.",
            ],
            [
                   "SDK Key for PIPPosition: Possible positions to place the window of the thermal camera video feed when the display mode is `PIP`. Only supported by XT2 camera and Mavic 2 Enterprise Dual Light Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPIPPosition_inline",
                   "",
            ],
            [
                   "OpticalZoomSpec",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "",
                   "Zoom lens profile. Includes focal length range and minimum focal length step. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "Zoom lens profile. Includes focal length range and minimum focal length step. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_SPEC",
                   2,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "",
                   "SDK Key for OpticalZoomSpec: Zoom lens profile. Includes focal length range and minimum focal length step. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "SDK Key for OpticalZoomSpec: Zoom lens profile. Includes focal length range and minimum focal length step. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraOpticalZoomSpec.html",
                   "",
                   "",
            ],
            [
                   "ZoomDirection",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_inline",
                   "The direction to adjust the camera zoom (camera focal length). Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "The direction to adjust the camera zoom (camera focal length). Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_inline",
                   "",
            ],
            [
                   "START_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_inline",
                   "SDK Key for ZoomDirection: The direction to adjust the camera zoom (camera focal length). Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "SDK Key for ZoomDirection: The direction to adjust the camera zoom (camera focal length). Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomDirection_inline",
                   "",
            ],
            [
                   "HybridZoomSpec",
                   2,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "",
                   "Hybrid zoom lens profile. Includes focal length range and maximum optical focal length and minimum focal length step. Supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera.",
            ],
            [
                   "Hybrid zoom lens profile. Includes focal length range and maximum optical focal length and minimum focal length step. Supported by Mavic 2 Zoom Camera and Mavic 2 Enterprise Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraHybridZoomSpec.html",
                   "",
                   "",
            ],
            [
                   "ZoomSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_inline",
                   "The speed of lens to zoom. The speed of lens to zoom. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "The speed of lens to zoom. The speed of lens to zoom. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_inline",
                   "",
            ],
            [
                   "START_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_inline",
                   "SDK Key for ZoomSpeed: The speed of lens to zoom. The speed of lens to zoom. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
            ],
            [
                   "SDK Key for ZoomSpeed: The speed of lens to zoom. The speed of lens to zoom. Supported by X5, X5R and X5S with zoom lens, Z3 camera and Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOpticalZoomSpeed_inline",
                   "",
            ],
            [
                   "TapZoomState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_inline",
                   "The state of the tap zoom action. Only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please access the value through class `Lens`.",
            ],
            [
                   "The state of the tap zoom action. Only supported by Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTapZoomState_inline",
                   "",
            ],
            [
                   "FocusMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_inline",
                   "Camera focus mode. It is settable only when `isAdjustableFocalPointSupported` returns `true` and the physical AF switch on the camera is set to auto.",
            ],
            [
                   "Camera focus mode. It is settable only when `isAdjustableFocalPointSupported` returns `true` and the physical AF switch on the camera is set to auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_inline",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_inline",
                   "SDK Key for FocusMode: Camera focus mode. It is settable only when `isAdjustableFocalPointSupported` returns `true` and the physical AF switch on the camera is set to auto.",
            ],
            [
                   "SDK Key for FocusMode: Camera focus mode. It is settable only when `isAdjustableFocalPointSupported` returns `true` and the physical AF switch on the camera is set to auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusMode_inline",
                   "",
            ],
            [
                   "FocusStatus",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_inline",
                   "The focusing status of the camera's lens.",
            ],
            [
                   "The focusing status of the camera's lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_inline",
                   "",
            ],
            [
                   "FOCUS_STATUS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_inline",
                   "SDK Key for FocusStatus: The focusing status of the camera's lens.",
            ],
            [
                   "SDK Key for FocusStatus: The focusing status of the camera's lens.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensFocusStatus_inline",
                   "",
            ],
            [
                   "SensorCleaningState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_inline",
                   "The states of the sensor cleaning operation.",
            ],
            [
                   "The states of the sensor cleaning operation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_inline",
                   "",
            ],
            [
                   "SENSOR_CLEANING_STATE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_inline",
                   "SDK Key for SensorCleaningState: The states of the sensor cleaning operation.",
            ],
            [
                   "SDK Key for SensorCleaningState: The states of the sensor cleaning operation.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSensorCleaningState_inline",
                   "",
            ],
            [
                   "FocusAssistantSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "",
                   "Stores the focus settings",
            ],
            [
                   "Stores the focus settings",
                   1,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "",
                   "SDK Key for FocusAssistantSettings: Stores the focus settings",
            ],
            [
                   "SDK Key for FocusAssistantSettings: Stores the focus settings",
                   1,
                   "/Components/Camera/DJICamera_DJICameraFocusAssistantSettings.html",
                   "",
                   "",
            ],
            [
                   "PhotoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "Camera photo file formats. The default value is JPEG.",
            ],
            [
                   "Camera photo file formats. The default value is JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
            ],
            [
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
            ],
            [
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PANO_ORIGINAL_IMAGES_FORMAT_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
            ],
            [
                   "SDK Key for PhotoFileFormat: Camera photo file formats. The default value is JPEG.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoFileFormat_inline",
                   "",
            ],
            [
                   "PhotoAEBCount",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_inline",
                   "The number of pictures to continuously take at one time in AEB mode. Use with `DJICameraPhotoAEBParam`.",
            ],
            [
                   "The number of pictures to continuously take at one time in AEB mode. Use with `DJICameraPhotoAEBParam`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_inline",
                   "",
            ],
            [
                   "PHOTO_AEB_COUNT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_inline",
                   "SDK Key for PhotoAEBCount: The number of pictures to continuously take at one time in AEB mode. Use with `DJICameraPhotoAEBParam`.",
            ],
            [
                   "SDK Key for PhotoAEBCount: The number of pictures to continuously take at one time in AEB mode. Use with `DJICameraPhotoAEBParam`.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoAEBCount_inline",
                   "",
            ],
            [
                   "PhotoAspectRatio",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
            ],
            [
                   "Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "SDK Key for PhotoAspectRatio: Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
            ],
            [
                   "SDK Key for PhotoAspectRatio: Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "SDK Key for PhotoAspectRatio: Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
            ],
            [
                   "SDK Key for PhotoAspectRatio: Photo aspect ratio, where the first value is the width and the second value is the height. The default value is `RATIO_4_3`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoAspectRatio_inline",
                   "",
            ],
            [
                   "PhotoBurstCount",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "The number of photos taken in one burst shot (shooting photo in burst mode).",
            ],
            [
                   "The number of photos taken in one burst shot (shooting photo in burst mode).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "SDK Key for PhotoBurstCount: The number of photos taken in one burst shot (shooting photo in burst mode).",
            ],
            [
                   "SDK Key for PhotoBurstCount: The number of photos taken in one burst shot (shooting photo in burst mode).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "",
            ],
            [
                   "PHOTO_RAW_BURST_COUNT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "SDK Key for PhotoBurstCount: The number of photos taken in one burst shot (shooting photo in burst mode).",
            ],
            [
                   "SDK Key for PhotoBurstCount: The number of photos taken in one burst shot (shooting photo in burst mode).",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoBurstCount_inline",
                   "",
            ],
            [
                   "PhotoTimeLapseFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_inline",
                   "File format for camera when it is in time-lapse mode. The default file format is video. If video+JPEG is selected the minimum interval will be 2 seconds.",
            ],
            [
                   "File format for camera when it is in time-lapse mode. The default file format is video. If video+JPEG is selected the minimum interval will be 2 seconds.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_inline",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_inline",
                   "SDK Key for PhotoTimeLapseFileFormat: File format for camera when it is in time-lapse mode. The default file format is video. If video+JPEG is selected the minimum interval will be 2 seconds.",
            ],
            [
                   "SDK Key for PhotoTimeLapseFileFormat: File format for camera when it is in time-lapse mode. The default file format is video. If video+JPEG is selected the minimum interval will be 2 seconds.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPhotoTimeLapseFileFormat_inline",
                   "",
            ],
            [
                   "PhotoTimeIntervalSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "",
                   "Sets the number of pictures, and sets the time interval between pictures for the Interval shoot photo mode.",
            ],
            [
                   "Sets the number of pictures, and sets the time interval between pictures for the Interval shoot photo mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "",
                   "",
            ],
            [
                   "PHOTO_TIME_INTERVAL_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "",
                   "SDK Key for PhotoTimeIntervalSettings: Sets the number of pictures, and sets the time interval between pictures for the Interval shoot photo mode.",
            ],
            [
                   "SDK Key for PhotoTimeIntervalSettings: Sets the number of pictures, and sets the time interval between pictures for the Interval shoot photo mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoIntervalParam.html",
                   "",
                   "",
            ],
            [
                   "PhotoTimeLapseSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "",
                   "Stores the time lapse settings.",
            ],
            [
                   "Stores the time lapse settings.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "",
                   "SDK Key for PhotoTimeLapseSettings: Stores the time lapse settings.",
            ],
            [
                   "SDK Key for PhotoTimeLapseSettings: Stores the time lapse settings.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPhotoTimeLapseSettings.html",
                   "",
                   "",
            ],
            [
                   "PhotoPanoramaMode",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_inline",
                   "Panorama photo modes.",
            ],
            [
                   "Panorama photo modes.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "PHOTO_PANORAMA_MODE",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_inline",
                   "SDK Key for PhotoPanoramaMode: Panorama photo modes.",
            ],
            [
                   "SDK Key for PhotoPanoramaMode: Panorama photo modes.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraPhotoPanoramaMode_inline",
                   "",
            ],
            [
                   "VideoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "Video storage formats.",
            ],
            [
                   "Video storage formats.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "SDK Key for VideoFileFormat: Video storage formats.",
            ],
            [
                   "SDK Key for VideoFileFormat: Video storage formats.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "SDK Key for VideoFileFormat: Video storage formats.",
            ],
            [
                   "SDK Key for VideoFileFormat: Video storage formats.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFileFormat_inline",
                   "",
            ],
            [
                   "VideoResolution",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
            ],
            [
                   "Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_FRAME_RATE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "SDK Key for VideoResolution: Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
            ],
            [
                   "SDK Key for VideoResolution: Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "SDK Key for VideoResolution: Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
            ],
            [
                   "SDK Key for VideoResolution: Camera video resolution values. The resolutions available for a product are in `videoResolutionAndFrameRateRange`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoResolution_inline",
                   "",
            ],
            [
                   "VideoFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_inline",
                   "Camera video frame rate values. The frame rates available for a product are in `videoResolutionAndFrameRateRange`.",
            ],
            [
                   "Camera video frame rate values. The frame rates available for a product are in `videoResolutionAndFrameRateRange`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_FRAME_RATE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_inline",
                   "SDK Key for VideoFrameRate: Camera video frame rate values. The frame rates available for a product are in `videoResolutionAndFrameRateRange`.",
            ],
            [
                   "SDK Key for VideoFrameRate: Camera video frame rate values. The frame rates available for a product are in `videoResolutionAndFrameRateRange`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFrameRate_inline",
                   "",
            ],
            [
                   "VideoFov",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_inline",
                   "FOV (field-of-view) to use for recording a video.",
            ],
            [
                   "FOV (field-of-view) to use for recording a video.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoFOV_inline",
                   "",
            ],
            [
                   "ResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "",
                   "This class contains current values for camera parameters related to video resolution and video frame rate.",
            ],
            [
                   "This class contains current values for camera parameters related to video resolution and video frame rate.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraVideoResolutionAndFrameRate.html",
                   "",
                   "",
            ],
            [
                   "VideoStandard",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
            ],
            [
                   "Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "",
            ],
            [
                   "VIDEO_STANDARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "SDK Key for VideoStandard: Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
            ],
            [
                   "SDK Key for VideoStandard: Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "",
            ],
            [
                   "VIDEO_STANDARD_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "SDK Key for VideoStandard: Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
            ],
            [
                   "SDK Key for VideoStandard: Video standard values. The default value is NTSC. For Zenmuse H20 Series, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraVideoStandard_inline",
                   "",
            ],
            [
                   "VideoFileCompressionStandard",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_inline",
                   "The compression standard used to store the video files. It is only supported X4S, X5S and Phantom 4 Pro cameras.",
            ],
            [
                   "The compression standard used to store the video files. It is only supported X4S, X5S and Phantom 4 Pro cameras.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "VIDEO_FILE_COMPRESSION_STANDARD",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_inline",
                   "SDK Key for VideoFileCompressionStandard: The compression standard used to store the video files. It is only supported X4S, X5S and Phantom 4 Pro cameras.",
            ],
            [
                   "SDK Key for VideoFileCompressionStandard: The compression standard used to store the video files. It is only supported X4S, X5S and Phantom 4 Pro cameras.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJIVideoFileCompressionStandard_inline",
                   "",
            ],
            [
                   "CameraSSDVideoLicense",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
            ],
            [
                   "DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "",
            ],
            [
                   "ACTIVATE_SSD_VIDEO_LICENSE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "SDK Key for CameraSSDVideoLicense: DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
            ],
            [
                   "SDK Key for CameraSSDVideoLicense: DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "",
            ],
            [
                   "SSD_VIDEO_LICENSES",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "SDK Key for CameraSSDVideoLicense: DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
            ],
            [
                   "SDK Key for CameraSSDVideoLicense: DJI camera's license keys. An Inspire 2 License Key activates the usage permission of CinemaDNG or Apple ProRes inside CineCore 2.0. License keys are obtained by by purchase from the DJI store website using the Inspire 2 serial number. The Inspire 2 is then connected to DJI Assistant 2, and the license keys downloaded to it. It is only supported X5S and X7 cameras.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoLicense_inline",
                   "",
            ],
            [
                   "SSDLegacyColor",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilter_inline",
                   "The legacy camera color for videos that will be stored in SSD. The default value is `NONE`. It is only supported Inspire 2 with firmware package versions lower than 01.0.0240.",
            ],
            [
                   "The legacy camera color for videos that will be stored in SSD. The default value is `NONE`. It is only supported Inspire 2 with firmware package versions lower than 01.0.0240.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "SSD_LEGACY_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilter_inline",
                   "SDK Key for SSDLegacyColor: The legacy camera color for videos that will be stored in SSD. The default value is `NONE`. It is only supported Inspire 2 with firmware package versions lower than 01.0.0240.",
            ],
            [
                   "SDK Key for SSDLegacyColor: The legacy camera color for videos that will be stored in SSD. The default value is `NONE`. It is only supported Inspire 2 with firmware package versions lower than 01.0.0240.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDVideoDigitalFilter_inline",
                   "",
            ],
            [
                   "SSDColor",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
            ],
            [
                   "Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "",
            ],
            [
                   "SSD_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "SDK Key for SSDColor: Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
            ],
            [
                   "SDK Key for SSDColor: Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "",
            ],
            [
                   "SSD_COLOR_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "SDK Key for SSDColor: Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
            ],
            [
                   "SDK Key for SSDColor: Camera colors for videos that will be stored in SSD. It is only supported Inspire 2 with the firmware package version 01.0.0240 or later.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDColor_inline",
                   "",
            ],
            [
                   "ExposureSensitivityMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_inline",
                   "The exposure sensitivity modes.",
            ],
            [
                   "The exposure sensitivity modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_inline",
                   "",
            ],
            [
                   "EXPOSURE_SENSITIVITY_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_inline",
                   "SDK Key for ExposureSensitivityMode: The exposure sensitivity modes.",
            ],
            [
                   "SDK Key for ExposureSensitivityMode: The exposure sensitivity modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureSensitivityMode_inline",
                   "",
            ],
            [
                   "AntiFlickerFrequency",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "Camera anti-flickers. The default value is `MANUAL_50HZ`.",
            ],
            [
                   "Camera anti-flickers. The default value is `MANUAL_50HZ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "",
            ],
            [
                   "ANTI_FLICKER_FREQUENCY",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "SDK Key for AntiFlickerFrequency: Camera anti-flickers. The default value is `MANUAL_50HZ`.",
            ],
            [
                   "SDK Key for AntiFlickerFrequency: Camera anti-flickers. The default value is `MANUAL_50HZ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "",
            ],
            [
                   "ANTI_FLICKER_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "SDK Key for AntiFlickerFrequency: Camera anti-flickers. The default value is `MANUAL_50HZ`.",
            ],
            [
                   "SDK Key for AntiFlickerFrequency: Camera anti-flickers. The default value is `MANUAL_50HZ`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraAntiFlicker_inline",
                   "",
            ],
            [
                   "ExposureState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_inline",
                   "Camera exposure state.",
            ],
            [
                   "Camera exposure state.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraExposureState_inline",
                   "",
            ],
            [
                   "SSDOperationState",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_inline",
                   "Solid State Drive (SSD) State.",
            ],
            [
                   "Solid State Drive (SSD) State.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_inline",
                   "",
            ],
            [
                   "SSD_OPERATION_STATE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_inline",
                   "SDK Key for SSDOperationState: Solid State Drive (SSD) State.",
            ],
            [
                   "SDK Key for SSDOperationState: Solid State Drive (SSD) State.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDOperationState_inline",
                   "",
            ],
            [
                   "SSDCapacity",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_inline",
                   "Solid State Drive (SSD) Capacity.",
            ],
            [
                   "Solid State Drive (SSD) Capacity.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_inline",
                   "",
            ],
            [
                   "SSD_TOTAL_SPACE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_inline",
                   "SDK Key for SSDCapacity: Solid State Drive (SSD) Capacity.",
            ],
            [
                   "SDK Key for SSDCapacity: Solid State Drive (SSD) Capacity.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraSSDCapacity_inline",
                   "",
            ],
            [
                   "FileIndexMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_inline",
                   "File index modes.",
            ],
            [
                   "File index modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_inline",
                   "",
            ],
            [
                   "FILE_INDEX_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_inline",
                   "SDK Key for FileIndexMode: File index modes.",
            ],
            [
                   "SDK Key for FileIndexMode: File index modes.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraFileIndexMode_inline",
                   "",
            ],
            [
                   "NDFilterMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_inline",
                   "Modes of ND filter.",
            ],
            [
                   "Modes of ND filter.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_inline",
                   "",
            ],
            [
                   "NDFILTER_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_inline",
                   "SDK Key for NDFilterMode: Modes of ND filter.",
            ],
            [
                   "SDK Key for NDFilterMode: Modes of ND filter.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraNDFilterMode_inline",
                   "",
            ],
            [
                   "CustomSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "Camera user settings. A user can save or load camera settings to or from the specified user.",
            ],
            [
                   "Camera user settings. A user can save or load camera settings to or from the specified user.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "",
            ],
            [
                   "SAVE_SETTINGS_TO_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "SDK Key for CustomSettingsProfile: Camera user settings. A user can save or load camera settings to or from the specified user.",
            ],
            [
                   "SDK Key for CustomSettingsProfile: Camera user settings. A user can save or load camera settings to or from the specified user.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "",
            ],
            [
                   "LOAD_SETTINGS_FROM_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "SDK Key for CustomSettingsProfile: Camera user settings. A user can save or load camera settings to or from the specified user.",
            ],
            [
                   "SDK Key for CustomSettingsProfile: Camera user settings. A user can save or load camera settings to or from the specified user.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraCustomSettings_inline",
                   "",
            ],
            [
                   "CameraColor",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
            ],
            [
                   "Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "",
            ],
            [
                   "CAMERA_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "SDK Key for CameraColor: Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
            ],
            [
                   "SDK Key for CameraColor: Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "",
            ],
            [
                   "CAMERA_COLOR_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "SDK Key for CameraColor: Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
            ],
            [
                   "SDK Key for CameraColor: Camera color. The default value is `NONE`. Z30 camera only supports `NONE`, `BLACK_AND_WHITE` and `INVERSE`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraDigitalFilter_inline",
                   "",
            ],
            [
                   "EIColor",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_inline",
                   "Camera colors for EI mode.",
            ],
            [
                   "Camera colors for EI mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_inline",
                   "",
            ],
            [
                   "EI_COLOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_inline",
                   "SDK Key for EIColor: Camera colors for EI mode.",
            ],
            [
                   "SDK Key for EIColor: Camera colors for EI mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraEIColor_inline",
                   "",
            ],
            [
                   "Orientation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "Physical orientation of the camera.",
            ],
            [
                   "Physical orientation of the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "",
            ],
            [
                   "ORIENTATION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "SDK Key for Orientation: Physical orientation of the camera.",
            ],
            [
                   "SDK Key for Orientation: Physical orientation of the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "",
            ],
            [
                   "ORIENTATION_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "SDK Key for Orientation: Physical orientation of the camera.",
            ],
            [
                   "SDK Key for Orientation: Physical orientation of the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraOrientation_inline",
                   "",
            ],
            [
                   "PictureStylePresetType",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_inline",
                   "Camera preset type, a combine of Saturation, Contrast, Sharpness.",
            ],
            [
                   "Camera preset type, a combine of Saturation, Contrast, Sharpness.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_inline",
                   "",
            ],
            [
                   "PICTURE_STYLE_PRESET",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_inline",
                   "SDK Key for PictureStylePresetType: Camera preset type, a combine of Saturation, Contrast, Sharpness.",
            ],
            [
                   "SDK Key for PictureStylePresetType: Camera preset type, a combine of Saturation, Contrast, Sharpness.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraPictureStylePresetType_inline",
                   "",
            ],
            [
                   "TemperatureUnit",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_inline",
                   "The temperature units.",
            ],
            [
                   "The temperature units.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_inline",
                   "",
            ],
            [
                   "TEMPERATURE_UNIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_inline",
                   "SDK Key for TemperatureUnit: The temperature units.",
            ],
            [
                   "SDK Key for TemperatureUnit: The temperature units.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraTemperatureUnit_inline",
                   "",
            ],
            [
                   "PictureStylePreset",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "",
                   "Camera preset type that stores saturation, contrast and sharpness",
            ],
            [
                   "Camera preset type that stores saturation, contrast and sharpness",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "",
                   "",
            ],
            [
                   "PICTURE_STYLE_PRESET",
                   2,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "",
                   "SDK Key for PictureStylePreset: Camera preset type that stores saturation, contrast and sharpness",
            ],
            [
                   "SDK Key for PictureStylePreset: Camera preset type that stores saturation, contrast and sharpness",
                   1,
                   "/Components/Camera/DJICamera_DJICameraPictureStylePreset.html",
                   "",
                   "",
            ],
            [
                   "StorageLocation",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_inline",
                   "Different storage locations supported by the camera.",
            ],
            [
                   "Different storage locations supported by the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_inline",
                   "",
            ],
            [
                   "CAMERA_STORAGE_LOCATION",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_inline",
                   "SDK Key for StorageLocation: Different storage locations supported by the camera.",
            ],
            [
                   "SDK Key for StorageLocation: Different storage locations supported by the camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraStorageLocation_inline",
                   "",
            ],
            [
                   "CameraVideoStreamSource",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_inline",
                   "The enumeration represents which lens the camera stream comes from. The camera video stream will been used to transfer to image transmission to display and determine which lens were taken photo or recording. It is only supported by Zenmuse H20 Series Camera.",
            ],
            [
                   "The enumeration represents which lens the camera stream comes from. The camera video stream will been used to transfer to image transmission to display and determine which lens were taken photo or recording. It is only supported by Zenmuse H20 Series Camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraVideoStreamSource_inline",
                   "",
            ],
            [
                   "CameraStreamSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "",
                   "The class is used to save camera video stream settings during taking photo or recording video.`needCurrentLiveViewStream` is used to determine whether if current live view stream(set by `setCameraVideoStreamSource`) will be captured or recorded when taking photo or recording video. `getCameraVideoStreamSources` is used to determine which camera stream source will be captured or recorded. Only supported by Zenmuse H20 Series Camera.",
            ],
            [
                   "The class is used to save camera video stream settings during taking photo or recording video.`needCurrentLiveViewStream` is used to determine whether if current live view stream(set by `setCameraVideoStreamSource`) will be captured or recorded when taking photo or recording video. `getCameraVideoStreamSources` is used to determine which camera stream source will be captured or recorded. Only supported by Zenmuse H20 Series Camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "",
                   "",
            ],
            [
                   "needCurrentLiveViewStream",
                   2,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "#DJICamera_DJICameraStreamSettings_needCurrentLiveViewStream_inline",
                   "Determines whether if current live view stream need to been captured or recorded when taking photo or recording video.  @return `true` if needed to save current liveview stream.",
            ],
            [
                   "Determines whether if current live view stream need to been captured or recorded when taking photo or recording video.  @return `true` if needed to save current liveview stream.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "#DJICamera_DJICameraStreamSettings_needCurrentLiveViewStream_inline",
                   "",
            ],
            [
                   "getCameraVideoStreamSources",
                   2,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "#DJICamera_DJICameraStreamSettings_cameraVideoStreams_inline",
                   "Determines which camera video stream source will been captured or recorded when taking photo or recording video. The camera video stream source came from `CameraVideoStreamSource`.  @return A List of `CameraVideoStreamSource`.",
            ],
            [
                   "Determines which camera video stream source will been captured or recorded when taking photo or recording video. The camera video stream source came from `CameraVideoStreamSource`.  @return A List of `CameraVideoStreamSource`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraStreamSettings.html",
                   "#DJICamera_DJICameraStreamSettings_cameraVideoStreams_inline",
                   "",
            ],
            [
                   "ColorWaveformSettings",
                   2,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "",
                   "Stores the focus settings.",
            ],
            [
                   "Stores the focus settings.",
                   1,
                   "/Components/Camera/DJICamera_ColorWaveformSettings.html",
                   "",
                   "",
            ],
            [
                   "ThermalROI",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_inline",
                   "Region of interest. Use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
            ],
            [
                   "Region of interest. Use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_inline",
                   "",
            ],
            [
                   "THERMAL_ROI",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_inline",
                   "SDK Key for ThermalROI: Region of interest. Use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
            ],
            [
                   "SDK Key for ThermalROI: Region of interest. Use this feature to manage color range distribution across the screen to maximize contrast for regions of highest interest.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalROI_inline",
                   "",
            ],
            [
                   "ThermalPalette",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_inline",
                   "The different colors are used to show various temperatures in the thermal imagery image. The colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
            ],
            [
                   "The different colors are used to show various temperatures in the thermal imagery image. The colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_inline",
                   "",
            ],
            [
                   "THERMAL_PALETTE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_inline",
                   "SDK Key for ThermalPalette: The different colors are used to show various temperatures in the thermal imagery image. The colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
            ],
            [
                   "SDK Key for ThermalPalette: The different colors are used to show various temperatures in the thermal imagery image. The colors are not actually related to wavelengths of light, but rather the grayscale intensity.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalPalette_inline",
                   "",
            ],
            [
                   "ThermalScene",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_inline",
                   "Uses the Scene option to instantly enhance your image.",
            ],
            [
                   "Uses the Scene option to instantly enhance your image.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_inline",
                   "",
            ],
            [
                   "THERMAL_SCENE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_inline",
                   "SDK Key for ThermalScene: Uses the Scene option to instantly enhance your image.",
            ],
            [
                   "SDK Key for ThermalScene: Uses the Scene option to instantly enhance your image.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalScene_inline",
                   "",
            ],
            [
                   "ThermalIsothermUnit",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_inline",
                   "The unit for Isotherm. For Zenmuse H20T and H20N, please access the value through class `Lens`.",
            ],
            [
                   "The unit for Isotherm. For Zenmuse H20T and H20N, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UNIT",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_inline",
                   "SDK Key for ThermalIsothermUnit: The unit for Isotherm. For Zenmuse H20T and H20N, please access the value through class `Lens`.",
            ],
            [
                   "SDK Key for ThermalIsothermUnit: The unit for Isotherm. For Zenmuse H20T and H20N, please access the value through class `Lens`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "ThermalGainMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_inline",
                   "The gain mode.",
            ],
            [
                   "The gain mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_inline",
                   "",
            ],
            [
                   "THERMAL_GAIN_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_inline",
                   "SDK Key for ThermalGainMode: The gain mode.",
            ],
            [
                   "SDK Key for ThermalGainMode: The gain mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalGainMode_inline",
                   "",
            ],
            [
                   "ThermalResolution",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_inline",
                   "The resolution of thermal imaging camera.",
            ],
            [
                   "The resolution of thermal imaging camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_inline",
                   "",
            ],
            [
                   "THERMAL_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_inline",
                   "SDK Key for ThermalResolution: The resolution of thermal imaging camera.",
            ],
            [
                   "SDK Key for ThermalResolution: The resolution of thermal imaging camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalResolution_inline",
                   "",
            ],
            [
                   "ThermalFrameRateUpperBound",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_inline",
                   "The frame rate upper bound supported by the thermal camera.",
            ],
            [
                   "The frame rate upper bound supported by the thermal camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFrameRateUpperBound_inline",
                   "",
            ],
            [
                   "ThermalLensFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_inline",
                   "The focal length of the thermal imaging camera.",
            ],
            [
                   "The focal length of the thermal imaging camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_inline",
                   "",
            ],
            [
                   "THERMAL_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_inline",
                   "SDK Key for ThermalLensFocalLength: The focal length of the thermal imaging camera.",
            ],
            [
                   "SDK Key for ThermalLensFocalLength: The focal length of the thermal imaging camera.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalLensModel_inline",
                   "",
            ],
            [
                   "ThermalVersion",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_inline",
                   "There is a standard version and version with Advanced Radiometry capabilities of the Zenmuse XT thermal camera. This enum defines the versions.",
            ],
            [
                   "There is a standard version and version with Advanced Radiometry capabilities of the Zenmuse XT thermal camera. This enum defines the versions.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalVersion_inline",
                   "",
            ],
            [
                   "ThermalCustomExternalSceneSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_inline",
                   "User defined parameters.",
            ],
            [
                   "User defined parameters.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_inline",
                   "",
            ],
            [
                   "THERMAL_CUSTOM_EXTERNAL_SCENE_SETTINGS_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_inline",
                   "SDK Key for ThermalCustomExternalSceneSettingsProfile: User defined parameters.",
            ],
            [
                   "SDK Key for ThermalCustomExternalSceneSettingsProfile: User defined parameters.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalCustomExternalSceneSettings_inline",
                   "",
            ],
            [
                   "ThermalFFCMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_inline",
                   "Flat-field correction mods.",
            ],
            [
                   "Flat-field correction mods.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_inline",
                   "",
            ],
            [
                   "THERMAL_FFC_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_inline",
                   "SDK Key for ThermalFFCMode: Flat-field correction mods.",
            ],
            [
                   "SDK Key for ThermalFFCMode: Flat-field correction mods.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalFFCMode_inline",
                   "",
            ],
            [
                   "ThermalProfile",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "",
                   "The profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
            ],
            [
                   "The profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "",
                   "",
            ],
            [
                   "THERMAL_PROFILE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "",
                   "SDK Key for ThermalProfile: The profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
            ],
            [
                   "SDK Key for ThermalProfile: The profile of the thermal imaging camera, which includes information about resolution, frame rate and focal length.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalProfile.html",
                   "",
                   "",
            ],
            [
                   "ThermalDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_inline",
                   "Thermal camera digital zoom scale. The default value is x1.",
            ],
            [
                   "Thermal camera digital zoom scale. The default value is x1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "THERMAL_DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_inline",
                   "SDK Key for ThermalDigitalZoomFactor: Thermal camera digital zoom scale. The default value is x1.",
            ],
            [
                   "SDK Key for ThermalDigitalZoomFactor: Thermal camera digital zoom scale. The default value is x1.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalDigitalZoomScale_inline",
                   "",
            ],
            [
                   "ThermalMeasurementMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_inline",
                   "Thermal camera temperature measurement mode. The default value is  Disabled.",
            ],
            [
                   "Thermal camera temperature measurement mode. The default value is  Disabled.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "THERMAL_MEASUREMENT_MODE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_inline",
                   "SDK Key for ThermalMeasurementMode: Thermal camera temperature measurement mode. The default value is  Disabled.",
            ],
            [
                   "SDK Key for ThermalMeasurementMode: Thermal camera temperature measurement mode. The default value is  Disabled.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "ThermalAreaTemperatureAggregations",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "",
                   "The aggregate temperature measurements for a selected metering area.",
            ],
            [
                   "The aggregate temperature measurements for a selected metering area.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "",
                   "",
            ],
            [
                   "THERMAL_AREA_TEMPERATURE_AGGREGATIONS",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "",
                   "SDK Key for ThermalAreaTemperatureAggregations: The aggregate temperature measurements for a selected metering area.",
            ],
            [
                   "SDK Key for ThermalAreaTemperatureAggregations: The aggregate temperature measurements for a selected metering area.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalAreaTemperatureAggregations.html",
                   "",
                   "",
            ],
            [
                   "ThermalExternalSceneSettings",
                   2,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "",
                   "Thermal cameras measure the apparent surface temperature of a given object. This is done by taking the amount of infrared radiation an object emits and calculating the surface temperature by applying a formula that adjusts for external factors. This struct includes all of the external scene parameters that the thermal camera firmware allows  to be customized. There are two types of parameters, optical parameters which specify how much infrared  radiation is transmitted from the surface to the thermal sensor, as well as parameters that specify sources of thermal radiance other than the object. For a more in-depth overview of the physics behind thermal imaging, see https://en.wikipedia.org/wiki/Thermography.",
            ],
            [
                   "Thermal cameras measure the apparent surface temperature of a given object. This is done by taking the amount of infrared radiation an object emits and calculating the surface temperature by applying a formula that adjusts for external factors. This struct includes all of the external scene parameters that the thermal camera firmware allows  to be customized. There are two types of parameters, optical parameters which specify how much infrared  radiation is transmitted from the surface to the thermal sensor, as well as parameters that specify sources of thermal radiance other than the object. For a more in-depth overview of the physics behind thermal imaging, see https://en.wikipedia.org/wiki/Thermography.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraThermalExternalSceneSettings.html",
                   "",
                   "",
            ],
            [
                   "DisplayNamePhantom3StandardCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3StandardCamera_inline",
                   "The display name for Phantom 3 Standard camera.",
            ],
            [
                   "The display name for Phantom 3 Standard camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3StandardCamera_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom3AdvancedCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3AdvancedCamera_inline",
                   "The display name for Phantom 3 Advanced camera.",
            ],
            [
                   "The display name for Phantom 3 Advanced camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3AdvancedCamera_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom3ProfessionalCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3ProfessionalCamera_inline",
                   "The display name for Phantom 3 Professional camera.",
            ],
            [
                   "The display name for Phantom 3 Professional camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom3ProfessionalCamera_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom34KCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom34KCamera_inline",
                   "The display name for Phantom 3 4K camera.",
            ],
            [
                   "The display name for Phantom 3 4K camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom34KCamera_inline",
                   "",
            ],
            [
                   "DisplayNameX3",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX3_inline",
                   "The display name for X3 camera.",
            ],
            [
                   "The display name for X3 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX3_inline",
                   "",
            ],
            [
                   "DisplayNameX5",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5_inline",
                   "The display name for X5 camera.",
            ],
            [
                   "The display name for X5 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5_inline",
                   "",
            ],
            [
                   "DisplayNameX5R",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5R_inline",
                   "The display name for X5R camera.",
            ],
            [
                   "The display name for X5R camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5R_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom4Camera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4Camera_inline",
                   "The display name for Phantom 4 camera.",
            ],
            [
                   "The display name for Phantom 4 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4Camera_inline",
                   "",
            ],
            [
                   "DisplaynamePhantom4ProCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4ProCamera_inline",
                   "The display name for Phantom 4 Pro camera.",
            ],
            [
                   "The display name for Phantom 4 Pro camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4ProCamera_inline",
                   "",
            ],
            [
                   "DisplayNameXT",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT_inline",
                   "The display name for Zenmuse XT camera.",
            ],
            [
                   "The display name for Zenmuse XT camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT_inline",
                   "",
            ],
            [
                   "DisplayNameXTS",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXTS_inline",
                   "The display name for Zenmuse XT S camera.",
            ],
            [
                   "The display name for Zenmuse XT S camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXTS_inline",
                   "",
            ],
            [
                   "DisplayNameZ3",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZ3_inline",
                   "The display name for Z3 camera.",
            ],
            [
                   "The display name for Z3 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZ3_inline",
                   "",
            ],
            [
                   "DisplayNameMavicProCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicProCamera_inline",
                   "The display name for Mavic Pro camera.",
            ],
            [
                   "The display name for Mavic Pro camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicProCamera_inline",
                   "",
            ],
            [
                   "DisplayNameSparkCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameSparkCamera_inline",
                   "The display name for Spark camera.",
            ],
            [
                   "The display name for Spark camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameSparkCamera_inline",
                   "",
            ],
            [
                   "DisplaynamePhantom4PV2Camera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4ProV2Camera_inline",
                   "The display name for Phantom 4 Pro V2 camera.",
            ],
            [
                   "The display name for Phantom 4 Pro V2 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4ProV2Camera_inline",
                   "",
            ],
            [
                   "DisplaynamePhantom4RTKCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4RTKCamera_inline",
                   "The display name for Phantom 4 RTK camera.",
            ],
            [
                   "The display name for Phantom 4 RTK camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4RTKCamera_inline",
                   "",
            ],
            [
                   "DisplayNameX7",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX7_inline",
                   "The display name for X7 camera.",
            ],
            [
                   "The display name for X7 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX7_inline",
                   "",
            ],
            [
                   "DisplayNameXT2_IR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT2Thermal_inline",
                   "The display name for XT2 thermal camera.",
            ],
            [
                   "The display name for XT2 thermal camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT2Thermal_inline",
                   "",
            ],
            [
                   "DisplayNameXT2_VL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT2Visual_inline",
                   "The display name for XT2 visual camera.",
            ],
            [
                   "The display name for XT2 visual camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameXT2Visual_inline",
                   "",
            ],
            [
                   "DisplayNameMavicAirCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicAirCamera_inline",
                   "The display name for Mavic Air camera.",
            ],
            [
                   "The display name for Mavic Air camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicAirCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2ZoomCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2ZoomCamera_inline",
                   "The display name for Mavic 2 Zoom camera.",
            ],
            [
                   "The display name for Mavic 2 Zoom camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2ZoomCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2ProCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2ProCamera_inline",
                   "The display name for Mavic 2 Pro camera.",
            ],
            [
                   "The display name for Mavic 2 Pro camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2ProCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2EnterpriseCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseCamera_inline",
                   "The display name for Mavic 2 Enterprise.",
            ],
            [
                   "The display name for Mavic 2 Enterprise.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2EnterpriseDual_IR",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseDualThermal_inline",
                   "The display name for Mavic 2 Enterprise Dual thermal camera.",
            ],
            [
                   "The display name for Mavic 2 Enterprise Dual thermal camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseDualThermal_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2EnterpriseDual_VL",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseDualVisual_inline",
                   "The display name for Mavic 2 Enterprise Dual visual camera.",
            ],
            [
                   "The display name for Mavic 2 Enterprise Dual visual camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseDualVisual_inline",
                   "",
            ],
            [
                   "DisplayNameP4MCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4MCamera_inline",
                   "The display name for P4 Multispectral camera.",
            ],
            [
                   "The display name for P4 Multispectral camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4MCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavicMiniCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicMiniCamera_inline",
                   "The display name for Mavic Mini camera.",
            ],
            [
                   "The display name for Mavic Mini camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicMiniCamera_inline",
                   "",
            ],
            [
                   "DisplayNameMavicAir2Camera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicAir2Camera_inline",
                   "The display name for Mavic Air 2 camera.",
            ],
            [
                   "The display name for Mavic Air 2 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavicAir2Camera_inline",
                   "",
            ],
            [
                   "DisplayNameZenmuseH20",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20_inline",
                   "The display name for Zenmuse H20.",
            ],
            [
                   "The display name for Zenmuse H20.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20_inline",
                   "",
            ],
            [
                   "DisplayNameZenmuseH20T",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20T_inline",
                   "The display name for Zenmuse H20T.",
            ],
            [
                   "The display name for Zenmuse H20T.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20T_inline",
                   "",
            ],
            [
                   "DisplayNameZenmuseH20N",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20N_inline",
                   "The display name for Zenmuse H20N.",
            ],
            [
                   "The display name for Zenmuse H20N.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZenmuseH20N_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2EnterpriseAdvancedCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseAdvancedCamera_inline",
                   "The display name for Mavic 2 Enterprise Advanced Camera.",
            ],
            [
                   "The display name for Mavic 2 Enterprise Advanced Camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameMavic2EnterpriseAdvancedCamera_inline",
                   "",
            ],
            [
                   "XT2_IR_CAMERA_INDEX",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraXT2_IR_CAMERA_INDEX_inline",
                   "Index for the XT2 camera.",
            ],
            [
                   "Index for the XT2 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraXT2_IR_CAMERA_INDEX_inline",
                   "",
            ],
            [
                   "DisplayNameZ30",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZ30_inline",
                   "The display name for Z30 camera.",
            ],
            [
                   "The display name for Z30 camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameZ30_inline",
                   "",
            ],
            [
                   "DisplayNameX4S",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX4S_inline",
                   "The display name for X4S camera.",
            ],
            [
                   "The display name for X4S camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX4S_inline",
                   "",
            ],
            [
                   "DisplayNameX5S",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5S_inline",
                   "The display name for X5S camera.",
            ],
            [
                   "The display name for X5S camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNameX5S_inline",
                   "",
            ],
            [
                   "DisplaynamePhantom4AdvancedCamera",
                   2,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4AdvancedCamera_inline",
                   "The display name for Phantom 4 Advanced camera.",
            ],
            [
                   "The display name for Phantom 4 Advanced camera.",
                   1,
                   "/Components/Camera/DJICamera.html",
                   "#DJICamera_DJICameraDisplayNamePhantom4AdvancedCamera_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "",
                   "This interface provides information about the aggregate temperature of metering area.",
            ],
            [
                   "This interface provides information about the aggregate temperature of metering area.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "THERMAL_AREA_TEMPERATURE_AGGREGATIONS",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "",
                   "SDK Key for Callback: This interface provides information about the aggregate temperature of metering area.",
            ],
            [
                   "SDK Key for Callback: This interface provides information about the aggregate temperature of metering area.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraExternalSceneSettingsUpdatedCallbackInterface.html",
                   "",
                   "This interface provides information about the external scene settings.",
            ],
            [
                   "This interface provides information about the external scene settings.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraExternalSceneSettingsUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "",
                   "Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
            ],
            [
                   "Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "EXPOSURE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "",
                   "SDK Key for Callback: Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
            ],
            [
                   "SDK Key for Callback: Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedSystemStateCallbackInterface.html",
                   "#DJICamera_didUpdateSystemState_inline",
                   "Called when the camera's current state has been updated.  @param systemState The system state of camera.",
            ],
            [
                   "Called when the camera's current state has been updated.  @param systemState The system state of camera.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedSystemStateCallbackInterface.html",
                   "#DJICamera_didUpdateSystemState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedLensStateCallbackInterface.html",
                   "#DJICamera_didUpdateLensState_inline",
                   "Called when the camera's lens and focus state has been updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param state The camera lens and focus state information.",
            ],
            [
                   "Called when the camera's lens and focus state has been updated. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param state The camera lens and focus state information.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedLensStateCallbackInterface.html",
                   "#DJICamera_didUpdateLensState_inline",
                   "",
            ],
            [
                   "onNewFile",
                   2,
                   "/Components/Camera/DJICamera_CameraGeneratedNewMediaFileCallbackInterface.html",
                   "#DJICamera_didGenerateNewMediaFile_inline",
                   "Called when a new media file (photo or video) has been generated.  In this callback method, the `MediaFile` instance properties `getDurationInSeconds` and `getVideoOrientation` require special consideration. The thumbnail property normally has a pointer to a UIImage of the thumbnail, but this is only available when the camera is in `MEDIA_DOWNLOAD` work mode. Additionally, for this instance of `MediaFile`, the `getDurationInSeconds` property is 0 and the `getVideoOrientation` property is `LANDSCAPE`. Not supported by Zenmuse Z30 and Zenmuse XT2.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `onNewFileInfo` insteaded.  @param mediaFile The new media file.",
            ],
            [
                   "Called when a new media file (photo or video) has been generated.  In this callback method, the `MediaFile` instance properties `getDurationInSeconds` and `getVideoOrientation` require special consideration. The thumbnail property normally has a pointer to a UIImage of the thumbnail, but this is only available when the camera is in `MEDIA_DOWNLOAD` work mode. Additionally, for this instance of `MediaFile`, the `getDurationInSeconds` property is 0 and the `getVideoOrientation` property is `LANDSCAPE`. Not supported by Zenmuse Z30 and Zenmuse XT2.  Note:Because the firmware cannot return some information correctly, so the interface is deprecated, please use `onNewFileInfo` insteaded.  @param mediaFile The new media file.",
                   1,
                   "/Components/Camera/DJICamera_CameraGeneratedNewMediaFileCallbackInterface.html",
                   "#DJICamera_didGenerateNewMediaFile_inline",
                   "",
            ],
            [
                   "onNewFileInfo",
                   2,
                   "/Components/Camera/DJICamera_CamerNewGeneratedMediaFileInfoCallbackInterface.html",
                   "#DJICamera_didGenerateNewMediaFileInfo_inline",
                   "Return the media file info when a new media file (photo or video) has been generated. Only Supported by Znmuse H20 series.  @param mediaFileInfo The new media file info.",
            ],
            [
                   "Return the media file info when a new media file (photo or video) has been generated. Only Supported by Znmuse H20 series.  @param mediaFileInfo The new media file info.",
                   1,
                   "/Components/Camera/DJICamera_CamerNewGeneratedMediaFileInfoCallbackInterface.html",
                   "#DJICamera_didGenerateNewMediaFileInfo_inline",
                   "",
            ],
            [
                   "onGenerate",
                   2,
                   "/Components/Camera/DJICamera_CameraGeneratedTimeLapsePreviewCallbackInterface.html",
                   "#DJICamera_didGenerateTimeLapsePreview_inline",
                   "Called when a time-lapse preview image has been generated. This method is only available on Osmo with firmware version v1.5.2.0 or above.  @param previewImage The new generated preview image.",
            ],
            [
                   "Called when a time-lapse preview image has been generated. This method is only available on Osmo with firmware version v1.5.2.0 or above.  @param previewImage The new generated preview image.",
                   1,
                   "/Components/Camera/DJICamera_CameraGeneratedTimeLapsePreviewCallbackInterface.html",
                   "#DJICamera_didGenerateTimeLapsePreview_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedStorageStateCallbackInterface.html",
                   "#DJICamera_didUpdateStorageState_inline",
                   "Called when the camera's storage state has been updated. Use `StorageState`'s `getStorageLocation` to determine if the updated state is for SD card or the internal storage.  @param state The camera storage state. If the camera supports internal storage (e.g. Mavic Air),   use `getStorageLocation` to determine whether the state is   for SD card or internal storage.",
            ],
            [
                   "Called when the camera's storage state has been updated. Use `StorageState`'s `getStorageLocation` to determine if the updated state is for SD card or the internal storage.  @param state The camera storage state. If the camera supports internal storage (e.g. Mavic Air),   use `getStorageLocation` to determine whether the state is   for SD card or internal storage.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedStorageStateCallbackInterface.html",
                   "#DJICamera_didUpdateStorageState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedSSDStateCallbackInterface.html",
                   "#DJICamera_didUpdateSSDState_inline",
                   "Called when the camera's SSD state has been updated. This method is available only when `isSSDSupported` is `true`.  @param state The SSD's information.",
            ],
            [
                   "Called when the camera's SSD state has been updated. This method is available only when `isSSDSupported` is `true`.  @param state The SSD's information.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedSSDStateCallbackInterface.html",
                   "#DJICamera_didUpdateSSDState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateAreaTemperatureAggregations_inline",
                   "Called when there are new min, max, and average temperature values available for the set spot metering area. Supported by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aggregations The ThermalAreaTemperatureAggregations.",
            ],
            [
                   "Called when there are new min, max, and average temperature values available for the set spot metering area. Supported by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aggregations The ThermalAreaTemperatureAggregations.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateAreaTemperatureAggregations_inline",
                   "",
            ],
            [
                   "THERMAL_AREA_TEMPERATURE_AGGREGATIONS",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateAreaTemperatureAggregations_inline",
                   "SDK Key for onUpdate: Called when there are new min, max, and average temperature values available for the set spot metering area. Supported by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aggregations The ThermalAreaTemperatureAggregations.",
            ],
            [
                   "SDK Key for onUpdate: Called when there are new min, max, and average temperature values available for the set spot metering area. Supported by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param aggregations The ThermalAreaTemperatureAggregations.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraAreaTemperatureAggregationsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateAreaTemperatureAggregations_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_ThermalCameraExternalSceneSettingsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateExternalSceneSettings_inline",
                   "Called when updated external scene settings are available. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param settings The ThermalExternalSceneSettings.",
            ],
            [
                   "Called when updated external scene settings are available. Supported only by Zenmuse XT containing Advanced Radiometry capabilities. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @param settings The ThermalExternalSceneSettings.",
                   1,
                   "/Components/Camera/DJICamera_ThermalCameraExternalSceneSettingsUpdatedCallbackInterface.html",
                   "#DJICamera_didUpdateExternalSceneSettings_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "#DJICamera_didUpdateCurrentExposureParameters_inline",
                   "Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `DJILens`.  @param values The updated values for parameters.",
            ],
            [
                   "Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `DJILens`.  @param values The updated values for parameters.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "#DJICamera_didUpdateCurrentExposureParameters_inline",
                   "",
            ],
            [
                   "EXPOSURE_SETTINGS",
                   2,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "#DJICamera_didUpdateCurrentExposureParameters_inline",
                   "SDK Key for onUpdate: Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `DJILens`.  @param values The updated values for parameters.",
            ],
            [
                   "SDK Key for onUpdate: Called whenever the camera parameters change. In automatic exposure modes (Program, Shutter Priority and Aperture Priority) the camera may be automatically changing aperture, shutter speed and ISO (depending on the mode and camera) when lighting conditions change. In Manual mode, the exposure compensation is automatically updated to let the user know how much compensation the exposure needs to get to an exposure the camera calculates as correct. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `DJILens`.  @param values The updated values for parameters.",
                   1,
                   "/Components/Camera/DJICamera_CameraUpdatedCurrentExposureValuesCallbackInterface.html",
                   "#DJICamera_didUpdateCurrentExposureParameters_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "#DJICamera_UpdateHistogramLightValue_inline",
                   "Update the histogram's light values.  @param lightValues The histogram's light values.",
            ],
            [
                   "Update the histogram's light values.  @param lightValues The histogram's light values.",
                   1,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "#DJICamera_UpdateHistogramLightValue_inline",
                   "",
            ],
            [
                   "HISTOGRAM_LIGHT_VALUES",
                   2,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "#DJICamera_UpdateHistogramLightValue_inline",
                   "SDK Key for onUpdate: Update the histogram's light values.  @param lightValues The histogram's light values.",
            ],
            [
                   "SDK Key for onUpdate: Update the histogram's light values.  @param lightValues The histogram's light values.",
                   1,
                   "/Components/Camera/DJICamera_histogramUpdateCallbackInterface.html",
                   "#DJICamera_UpdateHistogramLightValue_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_TapZoomStateCallbackInterface.html",
                   "#DJICamera_TapZoomStateCallbackInterface_onUpdate_inline",
                   "Update tap zoom state.  @param tapZoomState The tap zoom state values.",
            ],
            [
                   "Update tap zoom state.  @param tapZoomState The tap zoom state values.",
                   1,
                   "/Components/Camera/DJICamera_TapZoomStateCallbackInterface.html",
                   "#DJICamera_TapZoomStateCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "#DJICamera_TemperatureDataCallbackInterface_onUpdate_inline",
                   "Received temperature in degrees Celsius of image. The thermal imaging camera will only update the temperature if the temperature data is enabled. For the XT Standard version, the temperature measurement data is the average of the center four pixels of the image. For the XT Advanced Radiometry version, the temperature measurement point can be set using `setThermalSpotMeteringTargetPoint`.  @param temperature The camera's temperature data in degrees Celsius.",
            ],
            [
                   "Received temperature in degrees Celsius of image. The thermal imaging camera will only update the temperature if the temperature data is enabled. For the XT Standard version, the temperature measurement data is the average of the center four pixels of the image. For the XT Advanced Radiometry version, the temperature measurement point can be set using `setThermalSpotMeteringTargetPoint`.  @param temperature The camera's temperature data in degrees Celsius.",
                   1,
                   "/Components/Camera/DJICamera_TemperatureDataCallbackInterface.html",
                   "#DJICamera_TemperatureDataCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "StabilizationState",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "",
                   "The state of the vision stabilization.",
            ],
            [
                   "The state of the vision stabilization.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "",
                   "",
            ],
            [
                   "StabilizationState",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_constructor_inline",
                   "Constructor method for the StabilizationState.  @param isActive The stabilization is active or not. @param isPaused The stabilization is paused or not. @param reason If paused, the reason on the pause.",
            ],
            [
                   "Constructor method for the StabilizationState.  @param isActive The stabilization is active or not. @param isPaused The stabilization is paused or not. @param reason If paused, the reason on the pause.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_constructor_inline",
                   "",
            ],
            [
                   "isActive",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_isActive_inline",
                   "Check if the stabilization is active or not.  @return YES if the stabilization is active.",
            ],
            [
                   "Check if the stabilization is active or not.  @return YES if the stabilization is active.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_isActive_inline",
                   "",
            ],
            [
                   "isPaused",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_isPaused_inline",
                   "Check if the stabilization is paused or not.  @return YES if the stabilization is paused.",
            ],
            [
                   "Check if the stabilization is paused or not.  @return YES if the stabilization is paused.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_isPaused_inline",
                   "",
            ],
            [
                   "getPauseReason",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_getPauseReason_inline",
                   "Check if the stabilization is paused or not.  @return YES if the stabilization is paused.",
            ],
            [
                   "Check if the stabilization is paused or not.  @return YES if the stabilization is paused.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_getPauseReason_inline",
                   "",
            ],
            [
                   "StabilizationPauseReason",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_inline",
                   "The reason on the stabilization pause.",
            ],
            [
                   "The reason on the stabilization pause.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_inline",
                   "",
            ],
            [
                   "UNCHARACTERISTIC",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_UNCHARACTERISTIC_inline",
                   "No characteristic.",
            ],
            [
                   "No characteristic.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_UNCHARACTERISTIC_inline",
                   "",
            ],
            [
                   "CAMERA_CHANGING",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_CAMERA_CHANGING_inline",
                   "The camera is changing.",
            ],
            [
                   "The camera is changing.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_CAMERA_CHANGING_inline",
                   "",
            ],
            [
                   "GIMBAL_MOVING",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_GIMBAL_MOVING_inline",
                   "The gimbal is moving.",
            ],
            [
                   "The gimbal is moving.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_GIMBAL_MOVING_inline",
                   "",
            ],
            [
                   "DRONE_MOVING",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_DRONE_MOVING_inline",
                   "The drone is moving.",
            ],
            [
                   "The drone is moving.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_DRONE_MOVING_inline",
                   "",
            ],
            [
                   "TRACKING",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_TRACKING_inline",
                   "In tracking mode.",
            ],
            [
                   "In tracking mode.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_TRACKING_inline",
                   "",
            ],
            [
                   "TAP_GO",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_TAP_GO_inline",
                   "In Tap Go mode.",
            ],
            [
                   "In Tap Go mode.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_TAP_GO_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_OTHER_inline",
                   "Other.",
            ],
            [
                   "Other.",
                   1,
                   "/Components/Camera/DJICamera_StabilizationState.html",
                   "#DJICamera_StabilizationState_StabilizationPauseReason_OTHER_inline",
                   "",
            ],
            [
                   "CameraPeakThreshold",
                   2,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "",
                   "A container for the low, normal, and high values for the camera peak threshold.",
            ],
            [
                   "A container for the low, normal, and high values for the camera peak threshold.",
                   1,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "",
                   "",
            ],
            [
                   "CameraPeakThreshold",
                   2,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_constructor_inline",
                   "Create a `CameraPeakThreshold` instance with the default camera peak threshold values.  @param lowCameraPeakThreshold A float value representing the lowest camera peak threshold. @param normalCameraPeakThreshold A float value representing the normal camera peak threshold. @param highCameraPeakThreshold A float value representing the highest camera peak threshold.",
            ],
            [
                   "Create a `CameraPeakThreshold` instance with the default camera peak threshold values.  @param lowCameraPeakThreshold A float value representing the lowest camera peak threshold. @param normalCameraPeakThreshold A float value representing the normal camera peak threshold. @param highCameraPeakThreshold A float value representing the highest camera peak threshold.",
                   1,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_constructor_inline",
                   "",
            ],
            [
                   "getLowCameraPeakThreshold",
                   2,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getLowCameraPeakThreshold_inline",
                   "Gets the low value to be used for the camera peak threshold.  @return A float value representing the lowest camera peak threshold.",
            ],
            [
                   "Gets the low value to be used for the camera peak threshold.  @return A float value representing the lowest camera peak threshold.",
                   1,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getLowCameraPeakThreshold_inline",
                   "",
            ],
            [
                   "getNormalCameraPeakThreshold",
                   2,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getNormalCameraPeakThreshold_inline",
                   "Gets the normal value to be used for the camera peak threshold.  @return A float value representing the normal camera peak threshold.",
            ],
            [
                   "Gets the normal value to be used for the camera peak threshold.  @return A float value representing the normal camera peak threshold.",
                   1,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getNormalCameraPeakThreshold_inline",
                   "",
            ],
            [
                   "getHighCameraPeakThreshold",
                   2,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getHighCameraPeakThreshold_inline",
                   "Gets the high value to be used for the camera peak threshold.  @return A float value representing the highest camera peak threshold.",
            ],
            [
                   "Gets the high value to be used for the camera peak threshold.  @return A float value representing the highest camera peak threshold.",
                   1,
                   "/Components/Camera/DJICamera_CameraPeakThreshold.html",
                   "#DJICamera_CameraPeakThreshold_getHighCameraPeakThreshold_inline",
                   "",
            ],
            [
                   "Lens",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "",
                   "The class is used to manage all lens feature. It is only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
            ],
            [
                   "The class is used to manage all lens feature. It is only supported by Zenmuse H20 Series and Mavic 2 Enterprise Advanced.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_lensType_inline",
                   "Gets the type of the current lens.  @return An object value of `LensType`",
            ],
            [
                   "Gets the type of the current lens.  @return An object value of `LensType`",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_lensType_inline",
                   "",
            ],
            [
                   "getCameraIndex",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_cameraIndex_inline",
                   "Gets the index of the camera where the lens is located.  @return An int value.",
            ],
            [
                   "Gets the index of the camera where the lens is located.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_cameraIndex_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIndex_inline",
                   "Gets the index of the current lens.  @return An int value.",
            ],
            [
                   "Gets the index of the current lens.  @return An int value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIndex_inline",
                   "",
            ],
            [
                   "getDisplayName",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_displayName_inline",
                   "Gets the name of the current lens.  @return An String instance of display name.",
            ],
            [
                   "Gets the name of the current lens.  @return An String instance of display name.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_displayName_inline",
                   "",
            ],
            [
                   "getCapabilities",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_capabilities_inline",
                   "Lens capabilities. Supported by Zenmuse H20 Series.  @return An object of `LensCapabilities`.",
            ],
            [
                   "Lens capabilities. Supported by Zenmuse H20 Series.  @return An object of `LensCapabilities`.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_capabilities_inline",
                   "",
            ],
            [
                   "setVideoStandard",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoStandard_inline",
                   "Sets the lens' analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the lens. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lens' analog video standard. Setting the video standard to PAL or NTSC will limit the available resolutions and frame rates to those compatible with the chosen video standard.  @param videoStandard Video standard value to be set for the lens. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoStandard_inline",
                   "",
            ],
            [
                   "getVideoStandard",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoStandard_inline",
                   "Gets the lens' video standard value.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens' video standard value.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoStandard_inline",
                   "",
            ],
            [
                   "setVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoResolutionAndFrameRate_inline",
                   "Sets the video resolution and frame rate of the current lens. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the video resolution and frame rate of the current lens. @warning The supported resolutions and frame rates for the two different analog television standards PAL and NTSC are below:  <b>NTSC:</b>  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_30fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_30fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_60fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_30fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720,  FrameRate_60fps  Resolution_1280x720,  FrameRate_48fps  Resolution_1280x720,  FrameRate_30fps  Resolution_1280x720,  FrameRate_24fps  <b>PAL:</b>  Resolution_4096x2160, FrameRate_25fps  Resolution_4096x2160, FrameRate_24fps  Resolution_3840x2160, FrameRate_25fps  Resolution_3840x2160, FrameRate_24fps  Resolution_2704X1520, FrameRate_25fps  Resolution_2704X1520, FrameRate_24fps  Resolution_1920x1080, FrameRate_120fps (Slow Motion)  Resolution_1920x1080, FrameRate_50fps  Resolution_1920x1080, FrameRate_48fps  Resolution_1920x1080, FrameRate_25fps  Resolution_1920x1080, FrameRate_24fps  Resolution_1280x720, FrameRate_50fps  Resolution_1280x720, FrameRate_48fps  Resolution_1280x720, FrameRate_25fps  Resolution_1280x720, FrameRate_24fps  @param resolutionAndFrameRate Resolution to be set for the video. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "getVideoResolutionAndFrameRate",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoResolutionAndFrameRate_inline",
                   "Gets the video resolution and frame rate values of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the video resolution and frame rate values of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoResolutionAndFrameRate_inline",
                   "",
            ],
            [
                   "setVideoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoFileFormat_inline",
                   "Sets the video file format of the current lens. The default value is `MOV`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the video file format of the current lens. The default value is `MOV`.  @param format Video file format to be set for videos. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setVideoFileFormat_inline",
                   "",
            ],
            [
                   "getVideoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoFileFormat_inline",
                   "Gets the video file format of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the video file format of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getVideoFileFormat_inline",
                   "",
            ],
            [
                   "setPhotoAspectRatio",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setPhotoAspectRatio_inline",
                   "Sets the aspect ratio for photos of the current lens. See `PhotoAspectRatio` to view all possible ratios.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the aspect ratio for photos of the current lens. See `PhotoAspectRatio` to view all possible ratios.  @param aspectRatio Aspect ratio for photos to be taken by camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setPhotoAspectRatio_inline",
                   "",
            ],
            [
                   "getPhotoAspectRatio",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getPhotoAspectRatio_inline",
                   "Gets the aspect ratio for photos of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the aspect ratio for photos of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getPhotoAspectRatio_inline",
                   "",
            ],
            [
                   "setPhotoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setPhotoFileFormat_inline",
                   "Sets the photo file format of the current lens. See `PhotoFileFormat` to view all possible photo formats to which the lens can be set. Not supported by Zenmuse H20 Series.  @param format Photo file format used when the camera takes a photo. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the photo file format of the current lens. See `PhotoFileFormat` to view all possible photo formats to which the lens can be set. Not supported by Zenmuse H20 Series.  @param format Photo file format used when the camera takes a photo. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setPhotoFileFormat_inline",
                   "",
            ],
            [
                   "getPhotoFileFormat",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getPhotoFileFormat_inline",
                   "Gets the photo file format of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the photo file format of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getPhotoFileFormat_inline",
                   "",
            ],
            [
                   "setExposureMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureMode_inline",
                   "Sets the exposure mode of the current lens. Check `DJICameraExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the exposure mode of the current lens. Check `DJICameraExposureMode` to view all possible camera exposure modes. Please note that in different exposure mode, it will have different values for the same setting.  @param mode Camera exposure mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureMode_inline",
                   "",
            ],
            [
                   "getExposureMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getExposureMode_inline",
                   "Gets the exposure mode of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the exposure mode of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getExposureMode_inline",
                   "",
            ],
            [
                   "setISO",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setISO_inline",
                   "Sets the ISO value of the current lens. See `DJICameraISO` to view all possible ISO settings for the lens.  @param iso ISO value to be set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the ISO value of the current lens. See `DJICameraISO` to view all possible ISO settings for the lens.  @param iso ISO value to be set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setISO_inline",
                   "",
            ],
            [
                   "getISO",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getISO_inline",
                   "Gets the ISO value of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the ISO value of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getISO_inline",
                   "",
            ],
            [
                   "setShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setShutterSpeed_inline",
                   "Sets the shutter speed of the current lens. To see all available shutterSpeed value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the `shutterSpeed` must be <= 1/30. Precondition: The shutter speed can be set only when the lens exposure mode is Shutter mode or Manual mode.  @param shutterSpeed Shutter speed value to be set for the lens. For all available values shutterSpeed can be set to, please check `ShutterSpeed`. <br> The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate = 30fps, then the shutterSpeed must be <= 1/30. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the shutter speed of the current lens. To see all available shutterSpeed value settings, see `ShutterSpeed`. The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate is 30fps, the `shutterSpeed` must be <= 1/30. Precondition: The shutter speed can be set only when the lens exposure mode is Shutter mode or Manual mode.  @param shutterSpeed Shutter speed value to be set for the lens. For all available values shutterSpeed can be set to, please check `ShutterSpeed`. <br> The shutter speed should not be set slower than the video frame rate when the camera's mode is `RECORD_VIDEO`. For example, if the video frame rate = 30fps, then the shutterSpeed must be <= 1/30. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setShutterSpeed_inline",
                   "",
            ],
            [
                   "getShutterSpeed",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getShutterSpeed_inline",
                   "Gets the shutter speed of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the shutter speed of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getShutterSpeed_inline",
                   "",
            ],
            [
                   "setMeteringMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setMeteringMode_inline",
                   "Sets the exposure metering of the current lens. See `MeteringMode` to view all possible exposure metering settings for the lens.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result.",
            ],
            [
                   "Sets the exposure metering of the current lens. See `MeteringMode` to view all possible exposure metering settings for the lens.  @param mode Exposure metering to be set. Check the enum `MeteringMode` to find all possible exposure metering the camera can be set to. @param callback The execution callback with the execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setMeteringMode_inline",
                   "",
            ],
            [
                   "getMeteringMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getMeteringMode_inline",
                   "Gets the exposure metering of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the exposure metering of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getMeteringMode_inline",
                   "",
            ],
            [
                   "setSpotMeteringTarget",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSpotMeteringTargetRowIndex_inline",
                   "Sets the spot metering area index of the current lens. The lens image is divided into 225 spots defined by 15 columns and 15 rows. The row index range is [0,14], where the values increase top to bottom across the image. The column index range is [0, 14], where the values increase left to right. In order to make the method work, The camera exposure mode should be `Program`, `Shutter` or `Aperture`, the exposure metering mode must be `SPOT`, and `setAELock` must be `NO`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 14], where the values increase left to right. y is row index to be set. The value should falls in [0, 14], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the spot metering area index of the current lens. The lens image is divided into 225 spots defined by 15 columns and 15 rows. The row index range is [0,14], where the values increase top to bottom across the image. The column index range is [0, 14], where the values increase left to right. In order to make the method work, The camera exposure mode should be `Program`, `Shutter` or `Aperture`, the exposure metering mode must be `SPOT`, and `setAELock` must be `NO`.  @param spotIndex Spot metering point coordinate (x, y).  x is column index to be set. The value should falls in [0, 14], where the values increase left to right. y is row index to be set. The value should falls in [0, 14], where the values increase top to bottom across the image. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSpotMeteringTargetRowIndex_inline",
                   "",
            ],
            [
                   "getSpotMeteringTarget",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSpotMeteringTarget_inline",
                   "Gets the spot metering area row index and column index of the current lens. In order to make the method work, The lens exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the spot metering area row index and column index of the current lens. In order to make the method work, The lens exposure mode should be `PROGRAM`, `SHUTTER_PRIORITY` or `APERTURE_PRIORITY`, the exposure metering mode must be `SPOT`, and `getAELock` must be `false`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSpotMeteringTarget_inline",
                   "",
            ],
            [
                   "setExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureCompensation_inline",
                   "Sets the exposure compensation of the current lens. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the lens exposure mode to `shutter`, `program` or `aperture`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the exposure compensation of the current lens. See `ExposureCompensation` to view all possible exposure compensations to which the camera can be set. In order to use this function, set the lens exposure mode to `shutter`, `program` or `aperture`.  @param compensation Exposure compensation value to be set for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureCompensation_inline",
                   "",
            ],
            [
                   "getExposureCompensation",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getExposureCompensation_inline",
                   "Gets the exposure compensation of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the exposure compensation of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getExposureCompensation_inline",
                   "",
            ],
            [
                   "setAELock",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAELock_inline",
                   "Locks or unlocks the lens' AE (auto exposure). Post condition: If the AE lock is enabled, the spot metering area cannot be set.  @param isLocked `true` if the camera AE is locked, `NO` if it is unlocked. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Locks or unlocks the lens' AE (auto exposure). Post condition: If the AE lock is enabled, the spot metering area cannot be set.  @param isLocked `true` if the camera AE is locked, `NO` if it is unlocked. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAELock_inline",
                   "",
            ],
            [
                   "getAELock",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAELock_inline",
                   "Determines if the lens' AE (auto exposure) is locked.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if the lens' AE (auto exposure) is locked.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAELock_inline",
                   "",
            ],
            [
                   "setAutoAEUnlockEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAutoAEUnlockEnabled_inline",
                   "Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables auto-unlocking of AE lock after shooting a photo. If it is enabled, the Auto Exposure will unlock after each shot. If disabled, Auto Exposure will change when calling `setAELock`.  @param enabled `true` if the camera AE will automatically unlock. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "getAutoAEUnlockEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAutoAEUnlockEnabled_inline",
                   "Determines whether auto-unlocking of AE lock is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether auto-unlocking of AE lock is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAutoAEUnlockEnabled_inline",
                   "",
            ],
            [
                   "setWhiteBalance",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setWhiteBalance_inline",
                   "Sets the white balance of the current lens. When the white balance is a preset value (values except `CUSTOM`), the `colorTemperature` argument does not take effect. When the white balance is `CUSTOM`, the `getColorTemperature` value is used instead. See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the white balance of the current lens. When the white balance is a preset value (values except `CUSTOM`), the `colorTemperature` argument does not take effect. When the white balance is `CUSTOM`, the `getColorTemperature` value is used instead. See Also: `WhiteBalancePreset` to view all possible white balance setting options for the camera.  @param whiteBalance White balance value to be set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setWhiteBalance_inline",
                   "",
            ],
            [
                   "getWhiteBalance",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getWhiteBalance_inline",
                   "Gets the white balance and color temperature of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the white balance and color temperature of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getWhiteBalance_inline",
                   "",
            ],
            [
                   "setSharpness",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSharpness_inline",
                   "Sets the sharpness of the current lens. The default value is 0.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
            ],
            [
                   "Sets the sharpness of the current lens. The default value is 0.  @param sharpness Sharpness value to be set in the range of [-3, 3]. @param callback Asynchronous execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSharpness_inline",
                   "",
            ],
            [
                   "getSharpness",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSharpness_inline",
                   "Gets the sharpness of the current lens.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
            ],
            [
                   "Gets the sharpness of the current lens.  @param callback The execution callback with the returned value of sharpness with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSharpness_inline",
                   "",
            ],
            [
                   "setContrast",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setContrast_inline",
                   "Sets the contrast of the current lens. The default saturation value is 0.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the contrast of the current lens. The default saturation value is 0.  @param contrast Contrast value to be set in the range of [-3, 3]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setContrast_inline",
                   "",
            ],
            [
                   "getContrast",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getContrast_inline",
                   "Gets the contrast of the current lens.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
            ],
            [
                   "Gets the contrast of the current lens.  @param callback The execution callback with the returned value of contrast with range [-3, 3].",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getContrast_inline",
                   "",
            ],
            [
                   "setSaturation",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSaturation_inline",
                   "Sets the saturation of the current lens. The default saturation value is 0.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the saturation of the current lens. The default saturation value is 0.  @param saturation Saturation value to be set in the range of [-3, 3]. The default value of the saturation value is 0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setSaturation_inline",
                   "",
            ],
            [
                   "getSaturation",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSaturation_inline",
                   "Gets the saturation of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the saturation of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getSaturation_inline",
                   "",
            ],
            [
                   "setColor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setColor_inline",
                   "Sets the color of the current lens. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the color of the current lens. The default value is `NONE`. For a list of all possible camera colors, see `CameraColor`.  @param color Camera color to be applied to the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setColor_inline",
                   "",
            ],
            [
                   "getColor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getColor_inline",
                   "Gets the color of the current lens.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the color of the current lens.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getColor_inline",
                   "",
            ],
            [
                   "setIRFilterEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setIRFilterEnabled_inline",
                   "Enables/disables the IR filter (infared filter). Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. Supported by the zoom lens of Zenmuse H20 Series.  @param enabled `true` to enable IR-Cut filter. @param callback Callback that receives the setter result.",
            ],
            [
                   "Enables/disables the IR filter (infared filter). Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. Supported by the zoom lens of Zenmuse H20 Series.  @param enabled `true` to enable IR-Cut filter. @param callback Callback that receives the setter result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setIRFilterEnabled_inline",
                   "",
            ],
            [
                   "getIRFilterEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIRFilterEnabled_inline",
                   "Determines whether IR filter (infared filter) is enabled. Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether IR filter (infared filter) is enabled. Disabling the IR filter can enhance the image in low light environments. Enabling the IR filter can reduce the color distortion caused by the infared light. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIRFilterEnabled_inline",
                   "",
            ],
            [
                   "OFF",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_OFF_inline",
                   "Off.",
            ],
            [
                   "Off.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_OFF_inline",
                   "",
            ],
            [
                   "ON",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_ON_inline",
                   "On.",
            ],
            [
                   "On.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_ON_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_AUTO_inline",
                   "Auto.",
            ],
            [
                   "Auto.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_AUTO_inline",
                   "",
            ],
            [
                   "IRFilterMode",
                   2,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_inline",
                   "The IR filter mode.",
            ],
            [
                   "The IR filter mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraSettingsDef.html",
                   "#DJICamera_DJICameraLensIRFilterMode_inline",
                   "",
            ],
            [
                   "setIRFilterMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setIRFilterMode_inline",
                   "Sets the IR filter mode of the current lens. ON to reduce the color distortion caused by the infared light,  OFF to enhance the image in low light environments, or AUTO to up to the system to decide whether to switch. Supported by the zoom lens of Zenmuse H20 Series.  @param irFilterMode An enum type of the `IRFilterMode` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the IR filter mode of the current lens. ON to reduce the color distortion caused by the infared light,  OFF to enhance the image in low light environments, or AUTO to up to the system to decide whether to switch. Supported by the zoom lens of Zenmuse H20 Series.  @param irFilterMode An enum type of the `IRFilterMode` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setIRFilterMode_inline",
                   "",
            ],
            [
                   "getIRFilterMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIRFilterMode_inline",
                   "Gets the IR filter mode of the current lens. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the IR filter mode of the current lens. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getIRFilterMode_inline",
                   "",
            ],
            [
                   "isDigitalZoomSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isDigitalZoomSupported_inline",
                   "Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
            ],
            [
                   "Check if the current device supports digital zoom scale. It is supported by Osmo with X3 camera, Phantom 4 camera, Z3 camera, Mavic Pro camera and Z30 camera. For Zenmuse H20 Series and Mavic 2 Enterprise Advanced, please use class `Lens`.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isDigitalZoomSupported_inline",
                   "",
            ],
            [
                   "setDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setDigitalZoomFactor_inline",
                   "Sets the digital zoom factor of the current lens. Not supported by Zenmuse H20 Series.  @param factor The valid range is from 1.0 to 2.0. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the digital zoom factor of the current lens. Not supported by Zenmuse H20 Series.  @param factor The valid range is from 1.0 to 2.0. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setDigitalZoomFactor_inline",
                   "",
            ],
            [
                   "getDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getDigitalZoomFactor_inline",
                   "Gets current digital zoom factor of the current lens. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current digital zoom factor of the current lens. Note Z30 cannot set the digital zoom scale, but will use digital zoom when using `startContinuousOpticalZoom` and the optical zoom has reached its limit. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getDigitalZoomFactor_inline",
                   "",
            ],
            [
                   "isOpticalZoomSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isOpticalZoomSupported_inline",
                   "Determine if the current lens supports optical zoom. Not supported by Zenmuse H20 Series.  @return `true` if lens supports optical zoom.",
            ],
            [
                   "Determine if the current lens supports optical zoom. Not supported by Zenmuse H20 Series.  @return `true` if lens supports optical zoom.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isOpticalZoomSupported_inline",
                   "",
            ],
            [
                   "getOpticalZoomSpec",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getOpticalZoomSpec_inline",
                   "Gets the specification of the current lens. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the specification of the current lens. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getOpticalZoomSpec_inline",
                   "",
            ],
            [
                   "setOpticalZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setOpticalZoomFocalLength_inline",
                   "Sets focal length of the current lens. Not supported by Zenmuse H20 Series.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets focal length of the current lens. Not supported by Zenmuse H20 Series.  @param focalLength Focal length of zoom lens. Valid range is [`getMinFocalLength`, `getMaxFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "getOpticalZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getOpticalZoomFocalLength_inline",
                   "Gets the optical zoom focal length of the current lens in units of 0.1mm. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the optical zoom focal length of the current lens in units of 0.1mm. Not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getOpticalZoomFocalLength_inline",
                   "",
            ],
            [
                   "startContinuousOpticalZoom",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_startContinuousOpticalZoomInDirection_inline",
                   "Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. Supported by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Start changing the focal length of the lens in specified direction with specified speed. Focal length change (zooming) will halt when maximum or minimum focal lengths are reached, or `stopContinuousOpticalZoom` is called. Supported by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param direction Direction to zoom. @param speed Zoom speed. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_startContinuousOpticalZoomInDirection_inline",
                   "",
            ],
            [
                   "stopContinuousOpticalZoom",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_stopContinuousOpticalZoom_inline",
                   "Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. Supported by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Called to stop focal length changing, when it currently is from calling `startContinuousOpticalZoom`. Supported by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_stopContinuousOpticalZoom_inline",
                   "",
            ],
            [
                   "isHybridZoomSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isHybridZoomSupported_inline",
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Check if lens supports hybrid zoom. Supported by the zoom lens of Zenmuse H20 Series.  @return `true` if camera supports hybrid zoom.",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Check if lens supports hybrid zoom. Supported by the zoom lens of Zenmuse H20 Series.  @return `true` if camera supports hybrid zoom.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isHybridZoomSupported_inline",
                   "",
            ],
            [
                   "getHybridZoomSpec",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getHybridZoomSpec_inline",
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Gets the specification of the zoom lens. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Gets the specification of the zoom lens. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getHybridZoomSpec_inline",
                   "",
            ],
            [
                   "setHybridZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setHybridZoomFocalLength_inline",
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Sets focal length of the zoom lens. Supported by the zoom lens of Zenmuse H20 Series.  @param focalLength Focal length of zoom lens. Valid range is [`getMinHybridFocalLength`, `getMaxHybridFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded. Sets focal length of the zoom lens. Supported by the zoom lens of Zenmuse H20 Series.  @param focalLength Focal length of zoom lens. Valid range is [`getMinHybridFocalLength`, `getMaxHybridFocalLength`] and must be a multiple of `getFocalLengthStep`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setHybridZoomFocalLength_inline",
                   "",
            ],
            [
                   "getHybridZoomFocalLength",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getHybridZoomFocalLength_inline",
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded.  Gets zoom lens focal length in units of 0.1mm. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Hybrid zoom is combining optical and digital zoom. Lens will automatically switch over to digital zoom when optical zoom range is exceeded.  Gets zoom lens focal length in units of 0.1mm. Supported by the zoom lens of Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getHybridZoomFocalLength_inline",
                   "",
            ],
            [
                   "isTapZoomSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isTapZoomSupported_inline",
                   "Determines if the current lens supports TapZoom feature.  @return `true` if camera supports tap zoom.",
            ],
            [
                   "Determines if the current lens supports TapZoom feature.  @return `true` if camera supports tap zoom.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isTapZoomSupported_inline",
                   "",
            ],
            [
                   "setTapZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setTapZoomEnabled_inline",
                   "Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. Supported by Mavic 2 Enterprise Advanced, the zoom lens and the wide lens of Zenmuse H20 Series.  @param enabled `true` to enable TapZoom feature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enable/disable TapZoom. `tapZoomAtTarget` can only be called when TapZoom is enabled. Supported by Mavic 2 Enterprise Advanced, the zoom lens and the wide lens of Zenmuse H20 Series.  @param enabled `true` to enable TapZoom feature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setTapZoomEnabled_inline",
                   "",
            ],
            [
                   "getTapZoomEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getTapZoomEnabled_inline",
                   "Determines if TapZoom is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if TapZoom is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getTapZoomEnabled_inline",
                   "",
            ],
            [
                   "setTapZoomMultiplier",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setTapZoomMultiplier_inline",
                   "TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. Supported by the zoom lens and the wide lens of Zenmuse H20 Series. The tap zoom multiplier of Zenmuse H20 Series must be 1.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "TapZoom uses a multiplier to change the zoom scale when called. The final zoom scale for a TapZoom will be: Current Zoom Scale x Multiplier. The multiplier range is [1,5]. A multiplier of 1 will not change the zoom. When the multiplier is 1, the zoom scale will not change during TapZoom. Supported by the zoom lens and the wide lens of Zenmuse H20 Series. The tap zoom multiplier of Zenmuse H20 Series must be 1.  @param multiplier Multiplier of TapZoom. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "getTapZoomMultiplier",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getTapZoomMultiplier_inline",
                   "Gets the multiplier for TapZoom. Supported by the zoom lens and the wide lens of Zenmuse H20 Series. The tap zoom multiplier of Zenmuse H20 Series must be 1.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the multiplier for TapZoom. Supported by the zoom lens and the wide lens of Zenmuse H20 Series. The tap zoom multiplier of Zenmuse H20 Series must be 1.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getTapZoomMultiplier_inline",
                   "",
            ],
            [
                   "tapZoomAtTarget",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_tapZoomAtTarget_inline",
                   "TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. Supported by Mavic 2 Enterprise Advanced, the zoom lens and the wide lens of Zenmuse H20 Series. It will only work when the tap zoom multiplier of Zenmuse H20 Series is 1.  @param target The target to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "TapZoom at the target. It can be called only when TapZoom is enabled.  When a new target is set, the gimbal will rotate and locate the target in the center of the screen. At the same time, the camera will zoom by multiplying the TapZoom multiplier. Supported by Mavic 2 Enterprise Advanced, the zoom lens and the wide lens of Zenmuse H20 Series. It will only work when the tap zoom multiplier of Zenmuse H20 Series is 1.  @param target The target to zoom. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left corner of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_tapZoomAtTarget_inline",
                   "",
            ],
            [
                   "isAdjustableApertureSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isAdjustableApertureSupported_inline",
                   "Gets whether the lens supports an adjustable aperture. Currently adjustable aperture is supported only by the zoom lens of Zenmuse H20 Series.  @return A boolean value.",
            ],
            [
                   "Gets whether the lens supports an adjustable aperture. Currently adjustable aperture is supported only by the zoom lens of Zenmuse H20 Series.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isAdjustableApertureSupported_inline",
                   "",
            ],
            [
                   "setAperture",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAperture_inline",
                   "Sets the aperture value of the current lens. This feature is available only when `isAdjustableApertureSupported` returns `true`. Precondition: The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param aperture The aperture to set. See `FocusMode`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the aperture value of the current lens. This feature is available only when `isAdjustableApertureSupported` returns `true`. Precondition: The exposure mode `ExposureMode` must be in `MANUAL` or `APERTURE_PRIORITY`. </br> Supported only by the zoom lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param aperture The aperture to set. See `FocusMode`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAperture_inline",
                   "",
            ],
            [
                   "getAperture",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAperture_inline",
                   "Gets the aperture of the current lens. This feature is available only when `isAdjustableApertureSupported` returns `true`.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the aperture of the current lens. This feature is available only when `isAdjustableApertureSupported` returns `true`.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAperture_inline",
                   "",
            ],
            [
                   "isAdjustableFocalPointSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isAdjustableFocalPointSupported_inline",
                   "Determines whether the lens supports an adjustable focal point. Currently, the adjustable focal point is supported by the zoom lens of Zenmuse H20 Series.  @return A boolean value.",
            ],
            [
                   "Determines whether the lens supports an adjustable focal point. Currently, the adjustable focal point is supported by the zoom lens of Zenmuse H20 Series.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isAdjustableFocalPointSupported_inline",
                   "",
            ],
            [
                   "setFocusMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusMode_inline",
                   "Sets the focus mode of the current lens. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the focus mode of the current lens. See `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param focusMode Focus mode to set. Check `FocusMode` for more detail. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusMode_inline",
                   "",
            ],
            [
                   "getFocusMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusMode_inline",
                   "Gets the focus mode of the current lens. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the focus mode of the current lens. Please check `FocusMode`. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusMode_inline",
                   "",
            ],
            [
                   "setFocusTarget",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusTarget_inline",
                   "Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lens focus target point. When the focus mode is auto, the target point is the focal point. When the focus mode is manual, the target point is the zoom out area if the focus assistant is enabled for the manual mode. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param focusTarget The focus target to set. The range for x and y is from 0.0 to 1.0. The point [0.0, 0.0] represents the top-left angle of the screen. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusTarget_inline",
                   "",
            ],
            [
                   "getFocusTarget",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusTarget_inline",
                   "Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focus target point. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusTarget_inline",
                   "",
            ],
            [
                   "setFocusAssistantSettings",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusAssistantSettings_inline",
                   "Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Not supported by Mavic 2 Enterprise Advanced.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Used to enable/disable the lens focus assistant. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Not supported by Mavic 2 Enterprise Advanced.  @param settings Sets whether the lens focus assistant for AF and MF mode is enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusAssistantSettings_inline",
                   "",
            ],
            [
                   "getFocusAssistantSettings",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusAssistantSettings_inline",
                   "Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether the lens focus assistant is enabled. When the focus assistant is enabled, the camera live view will digitally zoom into the focus target area so the user can see the quality of focus. Focus assistant can be used for both manual focus (MF) and auto focus (AF). It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusAssistantSettings_inline",
                   "",
            ],
            [
                   "getFocusRingValueUpperBound",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusRingValueUpperBound_inline",
                   "Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focusing ring value's max value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusRingValueUpperBound_inline",
                   "",
            ],
            [
                   "setFocusRingValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusRingValue_inline",
                   "Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the focal distance by simulating the focus ring adjustment. Value can have a range of 0, `getFocusRingValueUpperBound`], which represents infinity and the closest possible focal distance. It is available only when `isAdjustableFocalPointSupported` returns `true`. For some lenses, the minimum focus ring value is larger than 0. For example the minimum of DJI MFT 15mm f/1.7 ASPH is 270. To retrieve the minimum value, perform the following steps: - Call `setFocusMode` with `AUTO`. - Call `setFocusTarget` with the furthest target (>30m). - Call `getFocusRingValue` to get the current focus ring value. This is the minimum value. The maximum value can be retrieved using `getFocusRingValueUpperBound`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param value Value to adjust focus ring to. The minimum value is 0, the maximum value depends on the installed lens. Please use method `getFocusRingValueUpperBound` to ensure the input argument is valid. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusRingValue_inline",
                   "",
            ],
            [
                   "getFocusRingValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusRingValue_inline",
                   "Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens focus ring value. It is available only when `isAdjustableFocalPointSupported` returns `true`. Supported by the zoom lens of Zenmuse H20 Series. Not supported by Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getFocusRingValue_inline",
                   "",
            ],
            [
                   "isMechanicalShutterSupported",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isMechanicalShutterSupported_inline",
                   "Determines whether the mechanical shutter speed is supported by the camera or the lens.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
            ],
            [
                   "Determines whether the mechanical shutter speed is supported by the camera or the lens.  @return `true` if the mechanical shutter is supported, otherwise `false`.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_isMechanicalShutterSupported_inline",
                   "",
            ],
            [
                   "setMechanicalShutterEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setMechanicalShutterEnabled_inline",
                   "Enables the mechanical shutter. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param enabled `true` to enable the mechanical shutter. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the mechanical shutter. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param enabled `true` to enable the mechanical shutter. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setMechanicalShutterEnabled_inline",
                   "",
            ],
            [
                   "getMechanicalShutterEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getMechanicalShutterEnabled_inline",
                   "Determines whether the mechanical shutter is enabled. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param callback The execution callback with the returned boolean value.",
            ],
            [
                   "Determines whether the mechanical shutter is enabled. It is only valid when `isMechanicalShutterSupported` returns `true`.  @param callback The execution callback with the returned boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getMechanicalShutterEnabled_inline",
                   "",
            ],
            [
                   "setAntiFlickerFrequency",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAntiFlickerFrequency_inline",
                   "Sets the lens anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lens anti-flicker frequency for video recording. Precondition: The exposure mode must be Program. Note: for the Z30 camera, changing anti-flicker will reboot the camera before the setting takes effect. It is not supported by Zenmuse H20 Series.  @param antiFlickerFrequency Anti-flicker value to set for the camera. See `AntiFlickerFrequency` to view all the possible anti-flicker type settings for the camera. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setAntiFlickerFrequency_inline",
                   "",
            ],
            [
                   "getAntiFlickerFrequency",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAntiFlickerFrequency_inline",
                   "Gets the lens anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lens anti-flicker. It is not supported by Zenmuse H20 Series.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_getAntiFlickerFrequency_inline",
                   "",
            ],
            [
                   "isThermalLens",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_isThermalLens_inline",
                   "Return `true` if the current connected device is a thermal imaging lens.  @return A boolean value.",
            ],
            [
                   "Return `true` if the current connected device is a thermal imaging lens.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_isThermalLens_inline",
                   "",
            ],
            [
                   "setThermalROI",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalROI_inline",
                   "Sets the region of interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported by the thermal lens of Zenmuse H20T and H20N.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the region of interest (ROI). Used to manage color range distribution across the screen to maximize contrast for regions of highest interest. Supported by the thermal lens of Zenmuse H20T and H20N.  @param roi An enum type of the Region of Interest to be used. Please refer to `ThermalROI`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalROI_inline",
                   "",
            ],
            [
                   "getThermalROI",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalROI_inline",
                   "Gets the region of interest.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the region of interest.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalROI_inline",
                   "",
            ],
            [
                   "setThermalPalette",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalPalette_inline",
                   "Sets the palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the palette. Each palette is a unique look-up table that maps 8-bit temperature values to different colors. Different palettes can be used to help the user better visualize temperature contrast or specific temperature bands.  @param palette An enum type of the `ThermalPalette` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalPalette_inline",
                   "",
            ],
            [
                   "getThermalPalette",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalPalette_inline",
                   "Gets the palette. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the palette. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalPalette_inline",
                   "",
            ],
            [
                   "setThermalScene",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalScene_inline",
                   "Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO, brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the scene to instantly enhance your image. In all modes except Manual and User modes, the DDE, ACE, SSO, brightness and contrast are set automatically to obtain the best result. In User modes, the contrast and brightness are set automatically to obtain the best results. Any settings that are made in these modes are retained if the scene is changed. In Manual mode, DDE, contrast and brightness are set manually.  @param scene An enum type for the `ThermalScene` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalScene_inline",
                   "",
            ],
            [
                   "getThermalScene",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalScene_inline",
                   "Gets current scene.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current scene.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalScene_inline",
                   "",
            ],
            [
                   "setThermalDDE",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalDDE_inline",
                   "Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the Digital Data Enhancement index (for DDE dynamic mode). DDE can be used to enhance image details (sharpen, higher index) and/or suppress fixed pattern noise (soften, lower index). It can be set manually only when the Scene mode is Manual, User1, User2 or User3.  @param value Integer in range [-20, 100]. Values less than 0 soften the image and filter fixed pattern noise. Values greater than 0 sharpen the details in the image. Value of 0 results in no enhancement. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalDDE_inline",
                   "",
            ],
            [
                   "getThermalDDE",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalDDE_inline",
                   "Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Digital Data Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalDDE_inline",
                   "",
            ],
            [
                   "setThermalACE",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalACE_inline",
                   "Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the value of Active Contrast Enhancement. Active contrast enhancement allows for a contrast trade-off between hotter and colder scenes when using 8-bit pixel data. It can be set manually only when the Scene mode is User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param value Integer in range [-8, 8]. <br> value > 0: more contrast in hotter scene content and less contrast in colder scene content (sky, ocean etc.). <br> value < 0: more contrast in colder scene content and less contrast in hotter scene content. <br> value = 0: neutral <br> value = 3: recommended for generic use. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalACE_inline",
                   "",
            ],
            [
                   "getThermalACE",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalACE_inline",
                   "Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Active Contrast Enhancement. The value is available only when the Scene mode is Manual, User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalACE_inline",
                   "",
            ],
            [
                   "setThermalSSO",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSSO_inline",
                   "Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the value of Smart Scene Optimization. When using non-linear histogram equalization to map the 14-bit sensor pixel values to 8-bit pixel values, it can become difficult to determine the difference in temperature of two objects from their different shades of gray. SSO allows a percentage of the 14-bit histogram to be mapped linearly to the 8-bit histogram, which will compromise local contrast, but allow for more accurate visual radiometric measurements. This is particularly useful for bi-modal scenes. It can be set manually only when the Scene mode is User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param value Percentage of histogram to map linearly [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSSO_inline",
                   "",
            ],
            [
                   "getThermalSSO",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalSSO_inline",
                   "Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of Smart Scene Optimization. The value is available only when the Scene mode is Manual, User1, User2 or User3. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalSSO_inline",
                   "",
            ],
            [
                   "setThermalBrightness",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalBrightness_inline",
                   "Sets the brightness of the image. It can be set manually only when the Scene mode is Manual.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the brightness of the image. It can be set manually only when the Scene mode is Manual.  @param brightness The integer value falls in [0, 16383]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalBrightness_inline",
                   "",
            ],
            [
                   "getThermalBrightness",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalBrightness_inline",
                   "Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the value of brightness. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalBrightness_inline",
                   "",
            ],
            [
                   "setThermalContrast",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalContrast_inline",
                   "Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the value of contrast, with larger values having higher contrast. It can be set manually only when the Scene mode is Manual.  @param contrast Contrast value as an integer with range [0, 255]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalContrast_inline",
                   "",
            ],
            [
                   "getThermalContrast",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalContrast_inline",
                   "Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets contrast value. The value is available only when the Scene mode is Manual, User1, User2 or User3.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalContrast_inline",
                   "",
            ],
            [
                   "setThermalIsothermEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermEnabled_inline",
                   "Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Not supported by Mavic 2 Enterprise Advanced.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enable or disable Isotherms. Isotherms can be used to highlight specific temperature ranges: When disabled, all 256 values (8-bits) are dedicated to the temperature histogram of the scene. When enabled, only 128 values (0-127) are mapped linearly to temperature. Then three bands 128-175, 176-223 and 224-255 can be mapped to the user defined temperatures to highlight them to the user. Using some of the false color palettes (like RainbowIso) results in a thermal image that is grey scale except for three specific bands highlighted by either reds, blues or greens. Not supported by Mavic 2 Enterprise Advanced.  @param enabled `true` if isotherms are enabled. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "getThermalIsothermEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermEnabled_inline",
                   "Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines whether Isotherms are enabled. `true` if Isotherms are enabled. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermEnabled_inline",
                   "",
            ],
            [
                   "setThermalIsothermUnit",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermUnit_inline",
                   "Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms.  @param unit An enum type of the `ThermalIsothermUnit` to be used. Please refer to `ThermalIsothermUnit`. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the unit of the Isotherm ranges to either Celsius or percent. Different units results in different value ranges for Isotherms.  @param unit An enum type of the `ThermalIsothermUnit` to be used. Please refer to `ThermalIsothermUnit`. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "getThermalIsothermUnit",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermUnit_inline",
                   "Gets the units for Isotherm ranges.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the units for Isotherm ranges.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermUnit_inline",
                   "",
            ],
            [
                   "setThermalIsothermUpperValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette.  @param value If the unit is percentage, the allowed range is [0,100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the upper threshold value for Isotherm. All temperature values above this will use colors 224-255 from the palette.  @param value If the unit is percentage, the allowed range is [0,100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermUpperValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "Gets the upper threshold value for Isotherm. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the upper threshold value for Isotherm. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermUpperValue_inline",
                   "",
            ],
            [
                   "setThermalIsothermMiddleValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Not supported by Zenmuse H20T and H20N.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the middle threshold value for Isotherm. Temperature values between the middle and upper Isotherm threshold will be displayed with colors 176-223 from the palette. Not supported by Zenmuse H20T and H20N.  @param value If the unit is percentage, the value falls in [0,100]. If the unit is Celsius, the value range is [-40, 550]. The value can only be equal or larger than lower threshold and equal or smaller than upper threshold. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermMiddleValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "Gets the middle threshold value for Isotherm. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the middle threshold value for Isotherm. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermMiddleValue_inline",
                   "",
            ],
            [
                   "setThermalIsothermLowerValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported by the thermal lens of Zenmuse H20T and H20N.  @param value If the unit is percentage, the value falls in [0,100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the lower threshold value for Isotherm. Temperature values between the lower and middle Isotherm threshold will be displayed with colors 128-175 from the palette. Supported by the thermal lens of Zenmuse H20T and H20N.  @param value If the unit is percentage, the value falls in [0,100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "getThermalIsothermLowerValue",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "Gets the lower threshold value for Isotherm. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the lower threshold value for Isotherm. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalIsothermLowerValue_inline",
                   "",
            ],
            [
                   "setThermalGainMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalGainMode_inline",
                   "Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius, for Mavic 2 Enterprise Advanced, the low gain mode can be used from -20 to 450 degrees Celsius. The high gain mode can be used from -20 to 150 degree Celsius  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the gain mode. Low gain mode can be used for scenes with temperatures ranging from -40 to 550 degrees Celsius. For higher contrast, the high gain mode can be used by for temperatures between -25 to 135 degrees Celsius for the 640x512 camera and -25 to 100 degrees Celsius for 324 x 256 camera. Mavic 2 Enterprise Dual has different temperature range from other thermal imaging cameras. Therefore, for Mavic 2 Enterprise Dual, the low gain mode can be used from -10 to 140 degrees Celsius. The high gain mode can be used from -10 to 400 degree Celsius, for Mavic 2 Enterprise Advanced, the low gain mode can be used from -20 to 450 degrees Celsius. The high gain mode can be used from -20 to 150 degree Celsius  @param mode An enum type of the `ThermalGainMode` to be used. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalGainMode_inline",
                   "",
            ],
            [
                   "getThermalGainMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalGainMode_inline",
                   "Gets the gain mode. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the gain mode. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalGainMode_inline",
                   "",
            ],
            [
                   "setThermalMeasurementMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalMeasurementMode_inline",
                   "Sets the mode for thermal measurement.  Supported only by thermal imaging cameras. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param mode The desired measurement mode. @param callback Completion block that receives the getter execution result.",
            ],
            [
                   "Sets the mode for thermal measurement.  Supported only by thermal imaging cameras. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param mode The desired measurement mode. @param callback Completion block that receives the getter execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "getThermalMeasurementMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalMeasurementMode_inline",
                   "Gets the mode for thermal measurement. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the mode for thermal measurement. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalMeasurementMode_inline",
                   "",
            ],
            [
                   "setThermalDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalDigitalZoomFactor_inline",
                   "Adjusts the digital zoom. Supported by the thermal lens of Zenmuse H20T and H20N.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to `ThermalDigitalZoomFactor` in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Adjusts the digital zoom. Supported by the thermal lens of Zenmuse H20T and H20N.  @param factor For resolution 640 x 512, x1,x2,x4,x8 can be set. For resolution 336 x 256, only x1,x2,x4 can be set. Please refer to `ThermalDigitalZoomFactor` in DJICameraSettingsDef. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalDigitalZoomFactor_inline",
                   "",
            ],
            [
                   "getThermalDigitalZoomFactor",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalDigitalZoomFactor_inline",
                   "Gets current digital zoom.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets current digital zoom.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalDigitalZoomFactor_inline",
                   "",
            ],
            [
                   "getThermalProfile",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalProfile_inline",
                   "Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the thermal imaging camera profile. The profile includes information about resolution, frame rate and focal length. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalProfile_inline",
                   "",
            ],
            [
                   "getThermalSpotMeteringTargetPoint",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "Gets the spot metering target point if one is set, if not then returns CGPointZero.  Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the spot metering target point if one is set, if not then returns CGPointZero.  Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "setThermalSpotMeteringTargetPoint",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback`. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. You should call `setThermalMeasurementMode` to set  the measurement mode to `SPOT_METERING` first. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the spot metering target point which then invoke the callback from `setThermalTemperatureCallback`. This method requires a relative point that is proportional to the dimension of the camera video dimension, the x, and y values must all be between 0 and 1.0. You should call `setThermalMeasurementMode` to set  the measurement mode to `SPOT_METERING` first. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param targetPoint The desired target point. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSpotMeteringTargetPoint_inline",
                   "",
            ],
            [
                   "getThermalMeteringArea",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalMeteringArea_inline",
                   "Get a rect representing the currently set metering area for the thermal scene. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get a rect representing the currently set metering area for the thermal scene. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalMeteringArea_inline",
                   "",
            ],
            [
                   "setThermalMeteringArea",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalMeteringArea_inline",
                   "Set the metering area for a rectangle inside the thermal ismage scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` delegate method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. You should call `setThermalMeasurementMode` to set  the measurement mode to `AREA_METERING` first. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the metering area for a rectangle inside the thermal ismage scene, which allows the camera to transmit aggregate temperature computations via the `onUpdate` delegate method. See `ThermalAreaTemperatureAggregations` for the statistical values that are available. This method requires a relative rect that is proportional to the rect of the thermal scene, the x, y, width, and height values must all be between 0 and 1.0. You should call `setThermalMeasurementMode` to set  the measurement mode to `AREA_METERING` first. Supported by the thermal lens of Zenmuse H20T and H20N and Mavic 2 Enterprise Advanced.  @param area The desired thermal metering area. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalMeteringArea_inline",
                   "",
            ],
            [
                   "getThermalFFCMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalFFCMode_inline",
                   "Get the currently set flat-field correction (FFC) mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get the currently set flat-field correction (FFC) mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalFFCMode_inline",
                   "",
            ],
            [
                   "setThermalFFCMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalFFCMode_inline",
                   "Set the flat-field correction (FFC) mode. Supported by the thermal lens of Zenmuse H20T and H20N.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Set the flat-field correction (FFC) mode. Supported by the thermal lens of Zenmuse H20T and H20N.  @param mode The desired FFC mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalFFCMode_inline",
                   "",
            ],
            [
                   "triggerThermalFFC",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_triggerThermalFFC_inline",
                   "Trigger flat-field correction. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with result of the trigger action.",
            ],
            [
                   "Trigger flat-field correction. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with result of the trigger action.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_triggerThermalFFC_inline",
                   "",
            ],
            [
                   "getThermalCustomExternalSceneSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "Gets the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the currently set custom user profile. This profile represents user-set external scene parameters for the thermal scene. Not supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "setThermalCustomExternalSceneSettingsProfile",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "Sets the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Not supported by Zenmuse H20T and H20N.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the custom user profile. This profile represents user-set external scene parameters for the thermal scene. Not supported by Zenmuse H20T and H20N.  @param profile The desired user profile setting. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalCustomExternalSceneSettingsProfile_inline",
                   "",
            ],
            [
                   "setThermalTemperatureUnit",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalTemperatureUnit_inline",
                   "Sets the temperature unit. Not supported by Mavic 2 Enterprise Advanced.  @param temperatureUnit Temperature unit to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the temperature unit. Not supported by Mavic 2 Enterprise Advanced.  @param temperatureUnit Temperature unit to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalTemperatureUnit_inline",
                   "",
            ],
            [
                   "getThermalTemperatureUnit",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalTemperatureUnit_inline",
                   "Gets the temperature unit.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the temperature unit.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getThermalTemperatureUnit_inline",
                   "",
            ],
            [
                   "setDisplayMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDisplayMode_inline",
                   "Sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. Only applies to the thermal infrared video feed. For Zemmuse H20T and H20N, you should set `setCameraVideoStreamSource` with `INFRARED_THERMAL` first. Only supported by Zenmuse H20T and H20N.and Mavic 2 Enterprise Advanced.  @param mode The display mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the display mode to coordinate the video feeds from both the visual camera and the thermal camera. Only applies to the thermal infrared video feed. For Zemmuse H20T and H20N, you should set `setCameraVideoStreamSource` with `INFRARED_THERMAL` first. Only supported by Zenmuse H20T and H20N.and Mavic 2 Enterprise Advanced.  @param mode The display mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDisplayMode_inline",
                   "",
            ],
            [
                   "getDisplayMode",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDisplayMode_inline",
                   "Gets the display mode. The display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the display mode. The display mode determine the way to coordinate the video feeds from both the visual camera and the thermal camera.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDisplayMode_inline",
                   "",
            ],
            [
                   "setPIPPosition",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setPIPPosition_inline",
                   "Sets the thermal window's position relative to the visual window. Only applies to the thermal infrared video feed. The setting is valid when the display mode is `PIP`. Refer to `setDisplayMode` and `getDisplayMode`.  @param position The position to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the thermal window's position relative to the visual window. Only applies to the thermal infrared video feed. The setting is valid when the display mode is `PIP`. Refer to `setDisplayMode` and `getDisplayMode`.  @param position The position to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setPIPPosition_inline",
                   "",
            ],
            [
                   "getPIPPosition",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getPIPPosition_inline",
                   "Gets the PIP position which determines the thermal window's position relative to the visual window. The setting is valid when the display mode is `PIP`. Refer to `setDisplayMode` and `getDisplayMode`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the PIP position which determines the thermal window's position relative to the visual window. The setting is valid when the display mode is `PIP`. Refer to `setDisplayMode` and `getDisplayMode`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getPIPPosition_inline",
                   "",
            ],
            [
                   "setMSXLevel",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setMSXLevel_inline",
                   "Sets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only applies to the thermal infrared video feed.  @param level The MSX level to set with range [0, 100]. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Only applies to the thermal infrared video feed.  @param level The MSX level to set with range [0, 100]. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setMSXLevel_inline",
                   "",
            ],
            [
                   "getMSXLevel",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getMSXLevel_inline",
                   "Gets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the level for MSX display mode. The range for level is [0, 100]. When it is 0, the visible spectrum definition is invisible. When it is 100, the visual spectrum definition is the most obvious. Supported by the thermal lens of Zenmuse H20T and H20N.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getMSXLevel_inline",
                   "",
            ],
            [
                   "setDualFeedHorizontalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDualFeedHorizontalAlignmentOffset_inline",
                   "Sets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param offset Range from -100 to 100 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param offset Range from -100 to 100 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDualFeedHorizontalAlignmentOffset_inline",
                   "",
            ],
            [
                   "getDualFeedHorizontalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDualFeedHorizontalAlignmentOffset_inline",
                   "Gets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the horizontal alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDualFeedHorizontalAlignmentOffset_inline",
                   "",
            ],
            [
                   "setDualFeedVerticalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDualFeedVerticalAlignmentOffset_inline",
                   "Sets the vertical alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param offset Range from -8 to 8 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the vertical alignment offset between the video feeds from both the visual lens and the thermal lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param offset Range from -8 to 8 for XT2, from -40 to 40 for Mavic 2 Enterprise Dual. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setDualFeedVerticalAlignmentOffset_inline",
                   "",
            ],
            [
                   "getDualFeedVerticalAlignmentOffset",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDualFeedVerticalAlignmentOffset_inline",
                   "Gets the vertical alignment offset between the video feeds from both the visual lens and the thermal Lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets the vertical alignment offset between the video feeds from both the visual lens and the thermal Lens. The alignment is applied to the MSX display mode. Different camera results in different value ranges.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getDualFeedVerticalAlignmentOffset_inline",
                   "",
            ],
            [
                   "setThermalAreaTemperatureAggregationsCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAreaTemperatureAggregationsCallback_inline",
                   "Sets the thermal lens temperature aggregation update callback. Callback will be called when there are new min, max, and average values available for the set spot metering area. Supported by the thermal lens of Zenmuse H20T and H20N.  @param areaTemperatureAggregationsUpdatedCallback The Callback object to set as the callback.",
            ],
            [
                   "Sets the thermal lens temperature aggregation update callback. Callback will be called when there are new min, max, and average values available for the set spot metering area. Supported by the thermal lens of Zenmuse H20T and H20N.  @param areaTemperatureAggregationsUpdatedCallback The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAreaTemperatureAggregationsCallback_inline",
                   "",
            ],
            [
                   "setThermalExternalSceneSettingsCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalExternalSceneSettingsCallback_inline",
                   "Sets the thermal lens external scene settings update callback. Callback will get called when updated external scene settings are available. Only supported by XT2.  @param thermalExternalSceneSettingsUpdatedCallback The Callback object to set as the callback.",
            ],
            [
                   "Sets the thermal lens external scene settings update callback. Callback will get called when updated external scene settings are available. Only supported by XT2.  @param thermalExternalSceneSettingsUpdatedCallback The Callback object to set as the callback.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalExternalSceneSettingsCallback_inline",
                   "",
            ],
            [
                   "setThermalTemperatureCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalTemperatureCallback_inline",
                   "Sets the thermal lens temperature update callback. Callback is used when there is a new temperature value available for the set spot metering target point. Supported by the thermal lens of Zenmuse H20T and H20N.  @param updateCenterTemperatureCallback The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The Float object contains information about the updated temperature value.",
            ],
            [
                   "Sets the thermal lens temperature update callback. Callback is used when there is a new temperature value available for the set spot metering target point. Supported by the thermal lens of Zenmuse H20T and H20N.  @param updateCenterTemperatureCallback The Callback object to set as the callback. <br> Callback implements an `onUpdate` method.</br> The Float object contains information about the updated temperature value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalTemperatureCallback_inline",
                   "",
            ],
            [
                   "setThermalAtmosphericTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "Sets the temperature of the atmosphere between the scene and the camera. Not supported by Zenmuse H20T and H20N.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the temperature of the atmosphere between the scene and the camera. Not supported by Zenmuse H20T and H20N.  @param temperature The assumed temperature of the atmosphere between the camera and the scene, can be between -50 and 327.67 degrees Celsius. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAtmosphericTemperature_inline",
                   "",
            ],
            [
                   "setThermalAtmosphericTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "Sets the transmission coefficient of the atmosphere between the scene and the camera. Not supported by Zenmuse H20T and H20N.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the transmission coefficient of the atmosphere between the scene and the camera. Not supported by Zenmuse H20T and H20N.  @param coefficient The desired atmospheric temperature, can be between 50 and 100. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalAtmosphericTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "setThermalBackgroundTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "Sets the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the assumed temperature reflected by the background of the scene, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired background reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalBackgroundTemperature_inline",
                   "",
            ],
            [
                   "setThermalSceneEmissivity",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSceneEmissivity_inline",
                   "Sets the emissivity of the thermal scene, can be between 50 and 100. Not supported by Zenmuse H20T and H20N.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the emissivity of the thermal scene, can be between 50 and 100. Not supported by Zenmuse H20T and H20N.  @param emissivity The desired scene emissivity. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalSceneEmissivity_inline",
                   "",
            ],
            [
                   "setThermalWindowReflection",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowReflection_inline",
                   "Sets assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Not supported by Zenmuse H20T and H20N.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets assumed window reflection coefficient, can be between 0 and X where X is the window transmission coefficient parameter. Not supported by Zenmuse H20T and H20N.  @param reflection The desired window reflection coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowReflection_inline",
                   "",
            ],
            [
                   "setThermalWindowReflectedTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "Sets the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the temperature reflected in the window, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired window reflected temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowReflectedTemperature_inline",
                   "",
            ],
            [
                   "setThermalWindowTemperature",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowTemperature_inline",
                   "Sets the window temperature, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the window temperature, can be between -50 and 327.67 degrees Celsius. Not supported by Zenmuse H20T and H20N.  @param temperature The desired window temperature. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowTemperature_inline",
                   "",
            ],
            [
                   "setThermalWindowTransmissionCoefficient",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "Sets the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Not supported by Zenmuse H20T and H20N.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the window transmission coefficient, can be between 50 and 100-X where X is the window reflection. Not supported by Zenmuse H20T and H20N.  @param coefficient The desired window transmission coefficient. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setThermalWindowTransmissionCoefficient_inline",
                   "",
            ],
            [
                   "getZoomBoxRelativeFov",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_getZoomBoxRelativeFov_inline",
                   "Get the FOV after camera's focal distance changed.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get the FOV after camera's focal distance changed.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_getZoomBoxRelativeFov_inline",
                   "",
            ],
            [
                   "getThermalGainModeRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getGainTemperatureRange_inline",
                   "Gets temperature range of specific gain mode. Only supported by Zenmuse H20T and H20N.  @param mode Given camera gain mode. @param callback Completion block to receive the result.The temperature measurement range of given gain mode.",
            ],
            [
                   "Gets temperature range of specific gain mode. Only supported by Zenmuse H20T and H20N.  @param mode Given camera gain mode. @param callback Completion block to receive the result.The temperature measurement range of given gain mode.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_getGainTemperatureRange_inline",
                   "",
            ],
            [
                   "setInfraredThermalCameraSensorBurningProtectionEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setInfraredThermalCameraSensorBurningProtectionEnabled_inline",
                   "Enables or disables the infrared sensor protection. If the sensor protection is enabled, the infrared thermal camera shutter might be closed. Only supported by Zenmuse H20T and H20N.  @param isEnabled Enable or disable infrared sensor protection. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables or disables the infrared sensor protection. If the sensor protection is enabled, the infrared thermal camera shutter might be closed. Only supported by Zenmuse H20T and H20N.  @param isEnabled Enable or disable infrared sensor protection. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setInfraredThermalCameraSensorBurningProtectionEnabled_inline",
                   "",
            ],
            [
                   "setInfraredThermalCameraShutterEnabled",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setInfraredThermalCameraShutterEnabled_inline",
                   "Enables the infrared thermal camera. Infrared thermal camera shutter may be closed, if the sensor protection is enabled. Only supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables the infrared thermal camera. Infrared thermal camera shutter may be closed, if the sensor protection is enabled. Only supported by Zenmuse H20T and H20N.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_ThermalCamera_setInfraredThermalCameraShutterEnabled_inline",
                   "",
            ],
            [
                   "setExposureSettingsCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureSettingsCallback_inline",
                   "Sets the callback for updated exposure parameters. The callback's `onUpdate` method will be called each time the exposure parameters (ISO, Exposure Compensation, Shutter Speed and Aperture) are updated.  @param callback The execution callback.",
            ],
            [
                   "Sets the callback for updated exposure parameters. The callback's `onUpdate` method will be called each time the exposure parameters (ISO, Exposure Compensation, Shutter Speed and Aperture) are updated.  @param callback The execution callback.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setExposureSettingsCallback_inline",
                   "",
            ],
            [
                   "setFocusStateCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusStateCallback_inline",
                   "Callback for updating the state of the current lens.  @param updatedLensStateCallback The execution callback.",
            ],
            [
                   "Callback for updating the state of the current lens.  @param updatedLensStateCallback The execution callback.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setFocusStateCallback_inline",
                   "",
            ],
            [
                   "setTapZoomStateCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_setTapZoomStateCallback_inline",
                   "Sets the tap zoom state callback. The callback's `DJICamera_DJILens_TapZoomStateCallbackInterface_onUpdate` method will be called when the lens zoom state is updated. Supported by the zoom lens and the wide lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Sets the tap zoom state callback. The callback's `DJICamera_DJILens_TapZoomStateCallbackInterface_onUpdate` method will be called when the lens zoom state is updated. Supported by the zoom lens and the wide lens of Zenmuse H20 Series and Mavic 2 Enterprise Advanced.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_setTapZoomStateCallback_inline",
                   "",
            ],
            [
                   "setThermalGlobalTemperatureCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_setThermalGlobalTemperatureCallback_inline",
                   "Callback to update current global minimum temperature and maximum temperature.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Callback to update current global minimum temperature and maximum temperature.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_CameraSettings_setThermalGlobalTemperatureCallback_inline",
                   "",
            ],
            [
                   "setLaserMeasureInformationCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setLaserMeasureInformationCallback_inline",
                   "Sets the laser measure information callback. When laser information would been updated, it call `Callback` to update the laser state information. The laser sensor must be at least 3m from the target point. It is only supported by Zenmuse H20 series.  @param laserMeasureInformationCallback Completion block that receives the execution result.",
            ],
            [
                   "Sets the laser measure information callback. When laser information would been updated, it call `Callback` to update the laser state information. The laser sensor must be at least 3m from the target point. It is only supported by Zenmuse H20 series.  @param laserMeasureInformationCallback Completion block that receives the execution result.",
                   1,
                   "/Components/Camera/DJICamera_DJILens.html",
                   "#DJICamera_DJILens_setLaserMeasureInformationCallback_inline",
                   "",
            ],
            [
                   "TapZoomStateCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens_TapZoomStateCallbackInterface.html",
                   "",
                   "Called when the lens zoom state is updated.",
            ],
            [
                   "Called when the lens zoom state is updated.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_TapZoomStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJILens_TapZoomStateCallbackInterface.html",
                   "#DJICamera_DJILens_TapZoomStateCallbackInterface_onUpdate_inline",
                   "Update tap zoom state.  @param tapZoomState The tap zoom state values.",
            ],
            [
                   "Update tap zoom state.  @param tapZoomState The tap zoom state values.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_TapZoomStateCallbackInterface.html",
                   "#DJICamera_DJILens_TapZoomStateCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "TemperatureDataCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens_TemperatureDataCallbackInterface.html",
                   "",
                   "Received temperature in degrees Celsius of image. For the thermal lens, the temperature measurement data is the average of the center four pixels of the image. Supported by the thermal lens of Zenmuse H20T and H20N.",
            ],
            [
                   "Received temperature in degrees Celsius of image. For the thermal lens, the temperature measurement data is the average of the center four pixels of the image. Supported by the thermal lens of Zenmuse H20T and H20N.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_TemperatureDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJILens_TemperatureDataCallbackInterface.html",
                   "#DJICamera_DJILens_TemperatureDataCallbackInterface_onUpdate_inline",
                   "Received temperature in degrees Celsius of image. The thermal imaging lens will only update the temperature if the temperature data is enabled. For the thermal lens Standard version, the temperature measurement data is the average of the center four pixels of the image.  @param temperature The thermal lens temperature data in degrees Celsius.",
            ],
            [
                   "Received temperature in degrees Celsius of image. The thermal imaging lens will only update the temperature if the temperature data is enabled. For the thermal lens Standard version, the temperature measurement data is the average of the center four pixels of the image.  @param temperature The thermal lens temperature data in degrees Celsius.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_TemperatureDataCallbackInterface.html",
                   "#DJICamera_DJILens_TemperatureDataCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "ThermalGlobalTemperatureCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens_ThermalGlobalTemperatureCallback.html",
                   "",
                   "Called when the temperature range changed. Only Supported by the thermal lens of Zenmuse H20T and H20N.",
            ],
            [
                   "Called when the temperature range changed. Only Supported by the thermal lens of Zenmuse H20T and H20N.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_ThermalGlobalTemperatureCallback.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJILens_ThermalGlobalTemperatureCallback.html",
                   "#DJICamera_DJILens_ThermalGlobalTemperatureCallback_onUpdate_inline",
                   "Update the global temperature range.  @param min The minimum temperature. @param max The maximum temperature.",
            ],
            [
                   "Update the global temperature range.  @param min The minimum temperature. @param max The maximum temperature.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_ThermalGlobalTemperatureCallback.html",
                   "#DJICamera_DJILens_ThermalGlobalTemperatureCallback_onUpdate_inline",
                   "",
            ],
            [
                   "LensCapabilities",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "",
                   "Some of the camera's lens parameters have dynamic ranges. The `LensCapabilities` class allows you to query the valid range for a parameter.",
            ],
            [
                   "Some of the camera's lens parameters have dynamic ranges. The `LensCapabilities` class allows you to query the valid range for a parameter.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "",
                   "",
            ],
            [
                   "addDJILensParametersListener",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_addDJILensParametersListener_inline",
                   "Adds the listener for the lens' range change events.  @param listener Lens range change listener.",
            ],
            [
                   "Adds the listener for the lens' range change events.  @param listener Lens range change listener.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_addDJILensParametersListener_inline",
                   "",
            ],
            [
                   "removeDJILensParametersListener",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_removeDJILensParametersListener_inline",
                   "Removes the listener for the lens range change.  @param listener An instance of DJILensParametersListener.",
            ],
            [
                   "Removes the listener for the lens range change.  @param listener An instance of DJILensParametersListener.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_removeDJILensParametersListener_inline",
                   "",
            ],
            [
                   "removeAllListener",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_removeAllListener_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_removeAllListener_inline",
                   "",
            ],
            [
                   "DJILensParametersListener",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "",
                   "Defines the listeners of the Camera parameters range.",
            ],
            [
                   "Defines the listeners of the Camera parameters range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onLensISORangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensISORangeChange_inline",
                   "When the lens ISO range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens ISO range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensISORangeChange_inline",
                   "",
            ],
            [
                   "onLensExposureModeRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensExposureModeRangeChange_inline",
                   "When the lens exposure mode range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens exposure mode range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensExposureModeRangeChange_inline",
                   "",
            ],
            [
                   "onLensShutterSpeedRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensShutterSpeedRangeChange_inline",
                   "When the lens shutter speed range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens shutter speed range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensShutterSpeedRangeChange_inline",
                   "",
            ],
            [
                   "onLensApertureRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensApertureRangeChange_inline",
                   "When the lens aperture range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens aperture range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensApertureRangeChange_inline",
                   "",
            ],
            [
                   "onLensExposureCompensationRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensExposureCompensationRangeChange_inline",
                   "When the lens exposure compensation range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens exposure compensation range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensExposureCompensationRangeChange_inline",
                   "",
            ],
            [
                   "onLensVideoResolutionAndFrameRateRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensVideoResolutionAndFrameRateRangeChange_inline",
                   "When the lens video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensVideoResolutionAndFrameRateRangeChange_inline",
                   "",
            ],
            [
                   "onLensThermalPaletteRangeChange",
                   2,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensThermalPaletteRangeChange_inline",
                   "When the lens thermal palette range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the lens thermal palette range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJILens_DJILensParameters_ListenerInterface.html",
                   "#DJILens_Listener_onLensThermalPaletteRangeChange_inline",
                   "",
            ],
            [
                   "setThermalGainModeTemperatureRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJICamera_DJILens_setThermalGainModeTemperatureRangeCallback_inline",
                   "Adds the listener for the supported temperature range when current gain mode changes.  @param callback Gain mode change listener.",
            ],
            [
                   "Adds the listener for the supported temperature range when current gain mode changes.  @param callback Gain mode change listener.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJICamera_DJILens_setThermalGainModeTemperatureRangeCallback_inline",
                   "",
            ],
            [
                   "ISORange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensISORange_inline",
                   "Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represents one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
            ],
            [
                   "Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represents one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensISORange_inline",
                   "",
            ],
            [
                   "shutterSpeedRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensShutterSpeedRange_inline",
                   "Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns `null` if current camera does not support any shutter speed value or the camera is disconnected. @return Array of CameraShutterSpeed. Each element represents one current supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
            ],
            [
                   "Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns `null` if current camera does not support any shutter speed value or the camera is disconnected. @return Array of CameraShutterSpeed. Each element represents one current supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensShutterSpeedRange_inline",
                   "",
            ],
            [
                   "apertureRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensApertureRange_inline",
                   "Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected. @return Array of CameraAperture. Each element represents one current supported aperture value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
            ],
            [
                   "Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected. @return Array of CameraAperture. Each element represents one current supported aperture value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensApertureRange_inline",
                   "",
            ],
            [
                   "exposureCompensationRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensExposureCompensationRange_inline",
                   "Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`). Returns `null` if current camera does not support any exposure compensation value or the camera is disconnected. @return Array of CameraExposureCompensation. Each element represents one current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
            ],
            [
                   "Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`). Returns `null` if current camera does not support any exposure compensation value or the camera is disconnected. @return Array of CameraExposureCompensation. Each element represents one current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensExposureCompensationRange_inline",
                   "",
            ],
            [
                   "videoResolutionAndFrameRateRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensVideoResolutionAndFrameRateRange_inline",
                   "Returns the current valid range for video resolution CameraVideoResolution and frame rate `VideoFrameRate`. Returns `null` if the current camera does not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
            ],
            [
                   "Returns the current valid range for video resolution CameraVideoResolution and frame rate `VideoFrameRate`. Returns `null` if the current camera does not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_supportedLensVideoResolutionAndFrameRateRange_inline",
                   "",
            ],
            [
                   "thermalPaletteRange",
                   2,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_thermalPaletteRange_inline",
                   "Returns the current valid range for thermal camera's palette (see `ThermalPalette`). Returns `nil` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return Array of `ThermalPalette` elements. Each element represents one current palette value.",
            ],
            [
                   "Returns the current valid range for thermal camera's palette (see `ThermalPalette`). Returns `nil` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return Array of `ThermalPalette` elements. Each element represents one current palette value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_LensCapabilities.html",
                   "#DJILens_DJILensParameters_thermalPaletteRange_inline",
                   "",
            ],
            [
                   "ThermalGainModeTemperatureRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback.html",
                   "",
                   "Called when the temperature range changes. Only supported by the infrared thermal lens of Zenmuse H20T and H20N.",
            ],
            [
                   "Called when the temperature range changes. Only supported by the infrared thermal lens of Zenmuse H20T and H20N.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback.html",
                   "#DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback_onUpdate_inline",
                   "Updates the temperature range in current gain mode.  @param range The temperature range. The array contains min value, max value.",
            ],
            [
                   "Updates the temperature range in current gain mode.  @param range The temperature range. The array contains min value, max value.",
                   1,
                   "/Components/Camera/DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback.html",
                   "#DJICamera_DJILens_ThermalGainModeTemperatureRangeCallback_onUpdate_inline",
                   "",
            ],
            [
                   "addDJICameraParametersListener",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_addDJICameraParametersListener_inline",
                   "Adds the listener for the camera range change.  @param listener Camera range change listener.",
            ],
            [
                   "Adds the listener for the camera range change.  @param listener Camera range change listener.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_addDJICameraParametersListener_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_removeListener_inline",
                   "Remove listener which is listening to the camera range change.  @param listener An instance of DJICameraParametersListener.",
            ],
            [
                   "Remove listener which is listening to the camera range change.  @param listener An instance of DJICameraParametersListener.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_removeListener_inline",
                   "",
            ],
            [
                   "removeAllListener",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_removeAllListener_inline",
                   "Remove all listeners.",
            ],
            [
                   "Remove all listeners.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_removeAllListener_inline",
                   "",
            ],
            [
                   "setMultispectralShutterSpeedRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_setMultispectralShutterSpeedRangeCallback_inline",
                   "Use this to listen the shutter speed supported by the multispectral camera single-band sensors (sensors except the RGB one).  Only supported by multispectral camera of P4 Multispectral.  @param listener The interface of `MultispectralShutterSpeedRangeCallback`.",
            ],
            [
                   "Use this to listen the shutter speed supported by the multispectral camera single-band sensors (sensors except the RGB one).  Only supported by multispectral camera of P4 Multispectral.  @param listener The interface of `MultispectralShutterSpeedRangeCallback`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_setMultispectralShutterSpeedRangeCallback_inline",
                   "",
            ],
            [
                   "setMultispectralExposureCompensationRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_setMultispectralExposureCompensationRangeCallback_inline",
                   "Use this to listen the exposure compensation supported by the multispectral camera single-band sensors (sensors except the RGB one).  Only supported by multispectral camera of P4 Multispectral.  @param listener The interface of `MultispectralExposureCompensationRangeCallback`.",
            ],
            [
                   "Use this to listen the exposure compensation supported by the multispectral camera single-band sensors (sensors except the RGB one).  Only supported by multispectral camera of P4 Multispectral.  @param listener The interface of `MultispectralExposureCompensationRangeCallback`.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_setMultispectralExposureCompensationRangeCallback_inline",
                   "",
            ],
            [
                   "modeRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraModeRange_inline",
                   "Returns the current valid range for camera mode (`CameraMode`). Returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return Array of `CameraMode` elements. Each element represents one current supported camera mode.",
            ],
            [
                   "Returns the current valid range for camera mode (`CameraMode`). Returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return Array of `CameraMode` elements. Each element represents one current supported camera mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraModeRange_inline",
                   "",
            ],
            [
                   "MODE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraModeRange_inline",
                   "SDK Key for modeRange: Returns the current valid range for camera mode (`CameraMode`). Returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return Array of `CameraMode` elements. Each element represents one current supported camera mode.",
            ],
            [
                   "SDK Key for modeRange: Returns the current valid range for camera mode (`CameraMode`). Returns `null` if  current camera has no supported camera mode or the camera is disconnected.  @return Array of `CameraMode` elements. Each element represents one current supported camera mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraModeRange_inline",
                   "",
            ],
            [
                   "exposureModeRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureModeRange_inline",
                   "Returns the current valid range for camera's exposure mode (`ExposureMode`). Returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return Array of NSNumber. Each element represents one current supported exposure mode.  @return Array of `ExposureMode`. Each element represents one current supported exposure mode.",
            ],
            [
                   "Returns the current valid range for camera's exposure mode (`ExposureMode`). Returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return Array of NSNumber. Each element represents one current supported exposure mode.  @return Array of `ExposureMode`. Each element represents one current supported exposure mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureModeRange_inline",
                   "",
            ],
            [
                   "EXPOSURE_MODE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureModeRange_inline",
                   "SDK Key for exposureModeRange: Returns the current valid range for camera's exposure mode (`ExposureMode`). Returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return Array of NSNumber. Each element represents one current supported exposure mode.  @return Array of `ExposureMode`. Each element represents one current supported exposure mode.",
            ],
            [
                   "SDK Key for exposureModeRange: Returns the current valid range for camera's exposure mode (`ExposureMode`). Returns  `null` if current camera does not support any exposure mode or the camera is disconnected.  @return Array of NSNumber. Each element represents one current supported exposure mode.  @return Array of `ExposureMode`. Each element represents one current supported exposure mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureModeRange_inline",
                   "",
            ],
            [
                   "ISORange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraISORange_inline",
                   "Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represent one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
            ],
            [
                   "Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represent one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraISORange_inline",
                   "",
            ],
            [
                   "ISO_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraISORange_inline",
                   "SDK Key for ISORange: Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represent one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
            ],
            [
                   "SDK Key for ISORange: Returns the current valid range for camera's ISO (see `ISO`). Returns `null` if current camera does not support any ISO value or the camera is disconnected. @return A CameraISO array. Each element represent one current supported ISO value.  @return Array of `ISO`. Each element represents one current supported ISO value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraISORange_inline",
                   "",
            ],
            [
                   "shutterSpeedRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraShutterSpeedRange_inline",
                   "Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return Array of CameraShutterSpeed. Each element represents one current  supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
            ],
            [
                   "Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return Array of CameraShutterSpeed. Each element represents one current  supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraShutterSpeedRange_inline",
                   "",
            ],
            [
                   "SHUTTER_SPEED_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraShutterSpeedRange_inline",
                   "SDK Key for shutterSpeedRange: Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return Array of CameraShutterSpeed. Each element represents one current  supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
            ],
            [
                   "SDK Key for shutterSpeedRange: Returns the current valid range for camera's shutter speed (see `ShutterSpeed`). Returns  `null` if current camera does not support any shutter speed value or the camera is  disconnected. @return Array of CameraShutterSpeed. Each element represents one current  supported shutter speed value.  @return Array of `ShutterSpeed`. Each element represents one current supported shutter speed value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraShutterSpeedRange_inline",
                   "",
            ],
            [
                   "apertureRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraApertureRange_inline",
                   "Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return Array of CameraAperture. Each element represents one current supported aperture  value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
            ],
            [
                   "Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return Array of CameraAperture. Each element represents one current supported aperture  value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraApertureRange_inline",
                   "",
            ],
            [
                   "APERTURE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraApertureRange_inline",
                   "SDK Key for apertureRange: Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return Array of CameraAperture. Each element represents one current supported aperture  value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
            ],
            [
                   "SDK Key for apertureRange: Returns the current valid range for camera's aperture (see `Aperture`). Returns `null` if current camera does not support any aperture value or the camera is disconnected.  @return Array of CameraAperture. Each element represents one current supported aperture  value.  @return Array of `Aperture`. Each element represents one current supported aperture value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraApertureRange_inline",
                   "",
            ],
            [
                   "exposureCompensationRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureCompensationRange_inline",
                   "Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`).  Returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return Array of CameraExposureCompensation. Each element represents one  current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
            ],
            [
                   "Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`).  Returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return Array of CameraExposureCompensation. Each element represents one  current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureCompensationRange_inline",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureCompensationRange_inline",
                   "SDK Key for exposureCompensationRange: Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`).  Returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return Array of CameraExposureCompensation. Each element represents one  current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
            ],
            [
                   "SDK Key for exposureCompensationRange: Returns the current valid range for camera's exposure compensation (see `ExposureCompensation`).  Returns `null` if current camera does not support any exposure compensation value or the camera  is disconnected. @return Array of CameraExposureCompensation. Each element represents one  current supported exposure compensation value.  @return Array of `ExposureCompensation`. Each element represents one current supported exposure compensation value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraExposureCompensationRange_inline",
                   "",
            ],
            [
                   "videoResolutionAndFrameRateRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraVideoResolutionAndFrameRateRange_inline",
                   "Returns the current valid range for video resolution CameraVideoResolution  and frame rate `VideoFrameRate`. Returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
            ],
            [
                   "Returns the current valid range for video resolution CameraVideoResolution  and frame rate `VideoFrameRate`. Returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraVideoResolutionAndFrameRateRange_inline",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_FRAME_RATE_RANGE",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraVideoResolutionAndFrameRateRange_inline",
                   "SDK Key for videoResolutionAndFrameRateRange: Returns the current valid range for video resolution CameraVideoResolution  and frame rate `VideoFrameRate`. Returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
            ],
            [
                   "SDK Key for videoResolutionAndFrameRateRange: Returns the current valid range for video resolution CameraVideoResolution  and frame rate `VideoFrameRate`. Returns `null` if the current camera does  not support any video resolution or frame rate setting, or if the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraVideoResolutionAndFrameRateRange_inline",
                   "",
            ],
            [
                   "SSDVideoResolutionRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraSSDVideoResolutionRange_inline",
                   "Returns the current valid range for camera's RAW video resolution. Returns 'nil' if current  camera does not support any RAW video resolution or the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
            ],
            [
                   "Returns the current valid range for camera's RAW video resolution. Returns 'nil' if current  camera does not support any RAW video resolution or the camera is disconnected.  @return Array of pairs. Each pair represents a valid `VideoResolution` value and `VideoFrameRate` value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_supportedCameraSSDVideoResolutionRange_inline",
                   "",
            ],
            [
                   "thermalPaletteRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_thermalPaletteRange_inline",
                   "Returns the current valid range for thermal camera's palette (see `ThermalPalette`).  Returns `NULL` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return Array of `ThermalPalette` elements. Each element represents one current palette value.",
            ],
            [
                   "Returns the current valid range for thermal camera's palette (see `ThermalPalette`).  Returns `NULL` if  current thermal camera has not supported palette or the thermal camera is disconnected.  @return Array of `ThermalPalette` elements. Each element represents one current palette value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_thermalPaletteRange_inline",
                   "",
            ],
            [
                   "multispectralShutterSpeedRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_multispectralShutterSpeedRange_inline",
                   "Returns the current valid range for multispectral camera's single-band sensors's (sensors except the RGB one). shutter speed (see `ShutterSpeed`).  Returns `null` if current camera does not support any shutter speed value or the camera is disconnected. Only supported by multispectral camera of P4 Multispectral.  @return Array of the `ShutterSpeed` enum values. Each element represents one current supported shutter speed value.",
            ],
            [
                   "Returns the current valid range for multispectral camera's single-band sensors's (sensors except the RGB one). shutter speed (see `ShutterSpeed`).  Returns `null` if current camera does not support any shutter speed value or the camera is disconnected. Only supported by multispectral camera of P4 Multispectral.  @return Array of the `ShutterSpeed` enum values. Each element represents one current supported shutter speed value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_multispectralShutterSpeedRange_inline",
                   "",
            ],
            [
                   "multispectralExposureCompensationRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_multispectralExposureCompensationRange_inline",
                   "Returns the current valid range for multispectral camera's single-band sensors's (sensors except the RGB one). Exposure compensation (see `ExposureCompensation`).   Returns `NULL` if current camera does not support any exposure compensation value or the multispectral camera is disconnected. Only supported by multispectral camera of P4 Multispectral.  @return Array of the `ExposureCompensation` enum value. Each element represents one current supported exposure compensation value.",
            ],
            [
                   "Returns the current valid range for multispectral camera's single-band sensors's (sensors except the RGB one). Exposure compensation (see `ExposureCompensation`).   Returns `NULL` if current camera does not support any exposure compensation value or the multispectral camera is disconnected. Only supported by multispectral camera of P4 Multispectral.  @return Array of the `ExposureCompensation` enum value. Each element represents one current supported exposure compensation value.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_multispectralExposureCompensationRange_inline",
                   "",
            ],
            [
                   "DJICameraParametersListener",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "",
                   "Defines the listeners of the Camera parameters range.",
            ],
            [
                   "Defines the listeners of the Camera parameters range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onCameraISORangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraISORangeChange_inline",
                   "When the camera ISO range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera ISO range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraISORangeChange_inline",
                   "",
            ],
            [
                   "onCameraExposureCompensationRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraExposureCompensationRangeChange_inline",
                   "When the camera exposure compensation range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera exposure compensation range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraExposureCompensationRangeChange_inline",
                   "",
            ],
            [
                   "onCameraExposureModeRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraExposureModeRangeChange_inline",
                   "When the camera exposure mode range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera exposure mode range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraExposureModeRangeChange_inline",
                   "",
            ],
            [
                   "onCameraShutterSpeedRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraShutterSpeedRangeChange_inline",
                   "When the camera shutter speed range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera shutter speed range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraShutterSpeedRangeChange_inline",
                   "",
            ],
            [
                   "onCameraModeRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraModeRangeChange_inline",
                   "When the camera mode range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera mode range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraModeRangeChange_inline",
                   "",
            ],
            [
                   "onFlatCameraModeRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onFlatCameraModeRangeChange_inline",
                   "When the flat camera mode range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the flat camera mode range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onFlatCameraModeRangeChange_inline",
                   "",
            ],
            [
                   "onCameraVideoResolutionAndFrameRateRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraVideoResolutionAndFrameRateRangeChange_inline",
                   "When the camera video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraVideoResolutionAndFrameRateRangeChange_inline",
                   "",
            ],
            [
                   "onCameraApertureRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraApertureRangeChange_inline",
                   "When the camera aperture range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera aperture range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#DJICamera_Listener_onCameraApertureRangeChange_inline",
                   "",
            ],
            [
                   "onCameraSSDRawVideoResolutionRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#onCameraSSDRawVideoResolutionRangeChange_inline",
                   "When the camera SSD raw video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the camera SSD raw video resolution and frame rate range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_ListenerInterface.html",
                   "#onCameraSSDRawVideoResolutionRangeChange_inline",
                   "",
            ],
            [
                   "FlatCameraModeRange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_DJISupportedFlatCameraModeRange_inline",
                   "Returns the current valid range for flat camera mode (`FlatCameraMode`). Returns null</code>  if `isFlatCameraModeSupported` return `false` or the camera is disconnected.  @return Array of `FlatCameraMode` elements. Each element represents one current supported flat camera mode.",
            ],
            [
                   "Returns the current valid range for flat camera mode (`FlatCameraMode`). Returns null</code>  if `isFlatCameraModeSupported` return `false` or the camera is disconnected.  @return Array of `FlatCameraMode` elements. Each element represents one current supported flat camera mode.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters.html",
                   "#DJICamera_DJICameraParameters_DJISupportedFlatCameraModeRange_inline",
                   "",
            ],
            [
                   "MultispectralShutterSpeedRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallbackInterface.html",
                   "",
                   "Defines multispectral shutter speed range.",
            ],
            [
                   "Defines multispectral shutter speed range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallbackInterface.html",
                   "#DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallback_onRangeChange_inline",
                   "When the range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallbackInterface.html",
                   "#DJICamera_DJICameraParameters_MultispectralShutterSpeedRangeCallback_onRangeChange_inline",
                   "",
            ],
            [
                   "MultispectralExposureCompensationRangeCallback",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallbackInterface.html",
                   "",
                   "Defines multispectral exposure compensation range.",
            ],
            [
                   "Defines multispectral exposure compensation range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onRangeChange",
                   2,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallbackInterface.html",
                   "#DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallback_onRangeChange_inline",
                   "When the range is changed, the listener will receive this callback.  @param newRange The new range.",
            ],
            [
                   "When the range is changed, the listener will receive this callback.  @param newRange The new range.",
                   1,
                   "/Components/Camera/DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallbackInterface.html",
                   "#DJICamera_DJICameraParameters_MultispectralExposureCompensationRangeCallback_onRangeChange_inline",
                   "",
            ],
            [
                   "addMediaUpdatedVideoPlaybackStateListener",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_updateVideoPlaybackStateCallback_inline",
                   "Sets the callback object for updating the video playback state of the media manager.  @param callback callback object of updating the vision detection state.",
            ],
            [
                   "Sets the callback object for updating the video playback state of the media manager.  @param callback callback object of updating the vision detection state.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_updateVideoPlaybackStateCallback_inline",
                   "",
            ],
            [
                   "getScheduler",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_taskScheduler_inline",
                   "Fetch media task scheduler. This can be used to queue the download of the previews, thumbnails and XML custom data from multiple media files.  @return An object of `FetchMediaTaskScheduler`.",
            ],
            [
                   "Fetch media task scheduler. This can be used to queue the download of the previews, thumbnails and XML custom data from multiple media files.  @return An object of `FetchMediaTaskScheduler`.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_taskScheduler_inline",
                   "",
            ],
            [
                   "getSDCardFileListState",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_sdCardFileListState_inline",
                   "The file list state of the SD card.  @return An enum value of `FileListState`.",
            ],
            [
                   "The file list state of the SD card.  @return An enum value of `FileListState`.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_sdCardFileListState_inline",
                   "",
            ],
            [
                   "getSDCardFileListSnapshot",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_sdCardFileListSnapshot_inline",
                   "Returns a copy of the current file list on the SD card after you call `refreshFileListOfStorageLocation`. Returns `null` if `getSDCardFileListState` is reset.  @return An array of `MediaFile` objects.",
            ],
            [
                   "Returns a copy of the current file list on the SD card after you call `refreshFileListOfStorageLocation`. Returns `null` if `getSDCardFileListState` is reset.  @return An array of `MediaFile` objects.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_sdCardFileListSnapshot_inline",
                   "",
            ],
            [
                   "getInternalStorageFileListState",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_internalStorageFileListState_inline",
                   "The file list state of the internal storage.  @return An enum value of `FileListState`.",
            ],
            [
                   "The file list state of the internal storage.  @return An enum value of `FileListState`.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_internalStorageFileListState_inline",
                   "",
            ],
            [
                   "getInternalStorageFileListSnapshot",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_internalStoragefileListSnapshot_inline",
                   "Returns a copy of the current file list on the internal storage after you call `refreshFileListOfStorageLocation`. Returns `nil` if `getInternalStorageFileListState` is reset or unknown.  @return An array of `MediaFile` objects.",
            ],
            [
                   "Returns a copy of the current file list on the internal storage after you call `refreshFileListOfStorageLocation`. Returns `nil` if `getInternalStorageFileListState` is reset or unknown.  @return An array of `MediaFile` objects.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_internalStoragefileListSnapshot_inline",
                   "",
            ],
            [
                   "refreshFileListOfStorageLocation",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_refreshFileListOfStorageLocation_inline",
                   "Refreshes the file list of the storage. If the current state is `RESET`, the media manager will try to fetch the complete file list. If the current state  is `INCOMPLETE`, the media manager will only fetch the missing list of files. If the file list is refreshed successfully, the corresponding file list state (either `getSDCardFileListState` or `getInternalStorageFileListState`) will become `UP_TO_DATE`.  @param storageLocation The storage location of the file list to refresh. @param callback Completion callback to receive the result.",
            ],
            [
                   "Refreshes the file list of the storage. If the current state is `RESET`, the media manager will try to fetch the complete file list. If the current state  is `INCOMPLETE`, the media manager will only fetch the missing list of files. If the file list is refreshed successfully, the corresponding file list state (either `getSDCardFileListState` or `getInternalStorageFileListState`) will become `UP_TO_DATE`.  @param storageLocation The storage location of the file list to refresh. @param callback Completion callback to receive the result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_refreshFileListOfStorageLocation_inline",
                   "",
            ],
            [
                   "deleteFiles",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_deleteFiles_inline",
                   "Delete media files from storages. If the operation is started successfully, `FileListState` will become  `DELETING`. If there is error or  failedFiles is not empty, `FileListState` will become `RESET`.  @param files A list of `MediaFile` objects. @param callback A completion callback of CompletionCallbackWithTwoParam<List<MediaFile>.",
            ],
            [
                   "Delete media files from storages. If the operation is started successfully, `FileListState` will become  `DELETING`. If there is error or  failedFiles is not empty, `FileListState` will become `RESET`.  @param files A list of `MediaFile` objects. @param callback A completion callback of CompletionCallbackWithTwoParam<List<MediaFile>.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_deleteFiles_inline",
                   "",
            ],
            [
                   "exitMediaDownloading",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_exitMediaDownloading_inline",
                   "This will entirely stop the downloading process and of course clean the downloading thread pool. The camera will exit the MEDIA_DOWNLOAD mode and enter the SHOOT_PHOTO mode.  Precondition:  The camera enters the MediaDownload mode. Post Condition:  After this function invoked, the camera mode will shift to TAKEPHOTO mode.",
            ],
            [
                   "This will entirely stop the downloading process and of course clean the downloading thread pool. The camera will exit the MEDIA_DOWNLOAD mode and enter the SHOOT_PHOTO mode.  Precondition:  The camera enters the MediaDownload mode. Post Condition:  After this function invoked, the camera mode will shift to TAKEPHOTO mode.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_exitMediaDownloading_inline",
                   "",
            ],
            [
                   "addUpdateFileListStateListener",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_addUpdateFileListStateListener_inline",
                   "Start listen to the update of file list state.  @param listener A `FileListStateListener` interface.",
            ],
            [
                   "Start listen to the update of file list state.  @param listener A `FileListStateListener` interface.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_addUpdateFileListStateListener_inline",
                   "",
            ],
            [
                   "addUpdateStorageLocationListener",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_addUpdateStorageLocationListener_inline",
                   "Start listen to the update of file list state.  @param storageLocation The storage location of the file list. @param listener A `FileListStateListener` interface.",
            ],
            [
                   "Start listen to the update of file list state.  @param storageLocation The storage location of the file list. @param listener A `FileListStateListener` interface.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_addUpdateStorageLocationListener_inline",
                   "",
            ],
            [
                   "removeFileListStateCallback",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_removeFileListStateCallback_inline",
                   "Stop listen to the update of file list state.  @param listener A `FileListStateListener` interface.",
            ],
            [
                   "Stop listen to the update of file list state.  @param listener A `FileListStateListener` interface.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_removeFileListStateCallback_inline",
                   "",
            ],
            [
                   "isVideoPlaybackSupported",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_isVideoPlaybackSupported_inline",
                   "Checks if the media manager supports video playback or not. @return `true` if the media manager supports video playback.  @return `true` if the media manager supports video playback.",
            ],
            [
                   "Checks if the media manager supports video playback or not. @return `true` if the media manager supports video playback.  @return `true` if the media manager supports video playback.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_isVideoPlaybackSupported_inline",
                   "",
            ],
            [
                   "playVideoMediaFile",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_playVideo_inline",
                   "Start video playback through `MediaManager`. When the media manager is playing a video,  playback state received from `onUpdate`. Video playback through `MediaManager` is fixed at 720p.  @param videoMediaFile The video to play. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Start video playback through `MediaManager`. When the media manager is playing a video,  playback state received from `onUpdate`. Video playback through `MediaManager` is fixed at 720p.  @param videoMediaFile The video to play. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_playVideo_inline",
                   "",
            ],
            [
                   "resume",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_resume_inline",
                   "The media manager resumes the paused video.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The media manager resumes the paused video.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_resume_inline",
                   "",
            ],
            [
                   "pause",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_pause_inline",
                   "The media manager pauses the playing video.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The media manager pauses the playing video.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_pause_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_stop_inline",
                   "The media manager stops the playing video.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The media manager stops the playing video.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_stop_inline",
                   "",
            ],
            [
                   "moveToPosition",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_moveToPosition_inline",
                   "Video playback is skipped to the new position in seconds from the start of the video.  @param position New position to play in seconds from start of video. Input with precision of greater than 3 decimal places, will be rounded to 3. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Video playback is skipped to the new position in seconds from the start of the video.  @param position New position to play in seconds from start of video. Input with precision of greater than 3 decimal places, will be rounded to 3. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_VideoPlayback_moveToPosition_inline",
                   "",
            ],
            [
                   "isCustomizeDCFFileSupported",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_isCustomizeDCFFileSupported_inline",
                   "Checks if the media manager supports customize DCF file naming rule or not. It is Only supported by Zenmuse H20 series.  @return `true` if the camera supports customize DCF file.",
            ],
            [
                   "Checks if the media manager supports customize DCF file naming rule or not. It is Only supported by Zenmuse H20 series.  @return `true` if the camera supports customize DCF file.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_isCustomizeDCFFileSupported_inline",
                   "",
            ],
            [
                   "FileListState",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_inline",
                   "States of the file list in `MediaManager`.",
            ],
            [
                   "States of the file list in `MediaManager`.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_inline",
                   "",
            ],
            [
                   "UP_TO_DATE",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_UpToDate_inline",
                   "The file list is up-to-date: it is synchronized with the SD card in the aircraft.",
            ],
            [
                   "The file list is up-to-date: it is synchronized with the SD card in the aircraft.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_UpToDate_inline",
                   "",
            ],
            [
                   "INCOMPLETE",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Incomplete_inline",
                   "New files have been generated since the last call of `refreshFileListOfStorageLocation`. Calling `refreshFileListOfStorageLocation` can synchronize the newly generated files and append them to the end of the file list.",
            ],
            [
                   "New files have been generated since the last call of `refreshFileListOfStorageLocation`. Calling `refreshFileListOfStorageLocation` can synchronize the newly generated files and append them to the end of the file list.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Incomplete_inline",
                   "",
            ],
            [
                   "RESET",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Reset_inline",
                   "The file list is reset. The file list will be reset in one of the following cases:  - Camera is disconnected.  - SD card is formatted.  - SD card is not inserted.  - Error occurs when deleting files from SD card.  In this state, `getSDCardFileListSnapshot` will return `null`.",
            ],
            [
                   "The file list is reset. The file list will be reset in one of the following cases:  - Camera is disconnected.  - SD card is formatted.  - SD card is not inserted.  - Error occurs when deleting files from SD card.  In this state, `getSDCardFileListSnapshot` will return `null`.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Reset_inline",
                   "",
            ],
            [
                   "DELETING",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Deleting_inline",
                   "`deleteFiles` has been called and the operation is still in progress.",
            ],
            [
                   "`deleteFiles` has been called and the operation is still in progress.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Deleting_inline",
                   "",
            ],
            [
                   "RENAMING",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Renaming_inline",
                   "A renaming operation is in progress.",
            ],
            [
                   "A renaming operation is in progress.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Renaming_inline",
                   "",
            ],
            [
                   "SYNCING",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Syncing_inline",
                   "The media manager is synchronizing the file list from the SD card.",
            ],
            [
                   "The media manager is synchronizing the file list from the SD card.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Syncing_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMediaFileListState_Unknown_inline",
                   "",
            ],
            [
                   "VideoPlaybackStateListener",
                   2,
                   "/Components/Camera/DJIMediaManager_updateVideoPlaybackStateCallbackInterface.html",
                   "",
                   "Updates the video playback state of the media manager. This update method will only be called when the media manager is playing a video.",
            ],
            [
                   "Updates the video playback state of the media manager. This update method will only be called when the media manager is playing a video.",
                   1,
                   "/Components/Camera/DJIMediaManager_updateVideoPlaybackStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "DownloadListener<E>",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "",
                   "This callback will notify the app when the media download executed.",
            ],
            [
                   "This callback will notify the app when the media download executed.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "FileListStateListener",
                   2,
                   "/Components/Camera/DJIMediaManager_FileListStateListener.html",
                   "",
                   "Received file list state of the media manager.",
            ],
            [
                   "Received file list state of the media manager.",
                   1,
                   "/Components/Camera/DJIMediaManager_FileListStateListener.html",
                   "",
                   "",
            ],
            [
                   "MediaFile",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "",
                   "This class contains information about a multi-media file on the SD card. It also provides methods to retrieve the data in the file.",
            ],
            [
                   "This class contains information about a multi-media file on the SD card. It also provides methods to retrieve the data in the file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "",
                   "",
            ],
            [
                   "MediaFileInfo",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "",
                   "This class contains information about newly generated media file.",
            ],
            [
                   "This class contains information about newly generated media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "",
                   "",
            ],
            [
                   "VideoPlaybackState",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "",
                   "The playback state of the media manager.",
            ],
            [
                   "The playback state of the media manager.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Stopped_inline",
                   "The playback is stopped. No media is playing.",
            ],
            [
                   "The playback is stopped. No media is playing.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Stopped_inline",
                   "",
            ],
            [
                   "PLAYING",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Playing_inline",
                   "The media manager is playing a video.",
            ],
            [
                   "The media manager is playing a video.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Playing_inline",
                   "",
            ],
            [
                   "PAUSED",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Paused_inline",
                   "The playing video is paused.",
            ],
            [
                   "The playing video is paused.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Paused_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Unknown_inline",
                   "The playing video is unknown.",
            ],
            [
                   "The playing video is unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_Unknown_inline",
                   "",
            ],
            [
                   "getPlayingMediaFile",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playingMedia_inline",
                   "The video media file that is playing.  @return An instance of `MediaFile`.",
            ],
            [
                   "The video media file that is playing.  @return An instance of `MediaFile`.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playingMedia_inline",
                   "",
            ],
            [
                   "getPlaybackStatus",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playbackStatus_inline",
                   "The status of the playback (e.g. playing or paused).  @return An Enum value of `VideoPlaybackStatus`.",
            ],
            [
                   "The status of the playback (e.g. playing or paused).  @return An Enum value of `VideoPlaybackStatus`.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playbackStatus_inline",
                   "",
            ],
            [
                   "getPlayingPosition",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playingPosition_inline",
                   "The playing position in seconds.  @return A float value of the playing position in seconds.",
            ],
            [
                   "The playing position in seconds.  @return A float value of the playing position in seconds.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState_playingPosition_inline",
                   "",
            ],
            [
                   "VideoPlaybackStatus",
                   2,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_inline",
                   "The playback status.",
            ],
            [
                   "The playback status.",
                   1,
                   "/Components/Camera/DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackState.html",
                   "#DJIMediaManager_VideoPlayback_DJIMediaVideoPlaybackStatus_inline",
                   "",
            ],
            [
                   "getMediaType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_mediaType_inline",
                   "Returns the type of media file.  @return An enum value of `MediaType`.",
            ],
            [
                   "Returns the type of media file.  @return An enum value of `MediaType`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_mediaType_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_index_inline",
                   "Returns the index of media file. This is the only identifier of the media file. You can use this index to match the index obtained by the `getSDCardFileListSnapshot` or `getInternalStorageFileListSnapshot`,   and then you can get more information about the new media file, such as the file name, etc.  @return An int value of media file index.",
            ],
            [
                   "Returns the index of media file. This is the only identifier of the media file. You can use this index to match the index obtained by the `getSDCardFileListSnapshot` or `getInternalStorageFileListSnapshot`,   and then you can get more information about the new media file, such as the file name, etc.  @return An int value of media file index.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_index_inline",
                   "",
            ],
            [
                   "getFileSize",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_fileSize_inline",
                   "Returns the size, in bytes, of the media file.  @return Size of media file.",
            ],
            [
                   "Returns the size, in bytes, of the media file.  @return Size of media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_fileSize_inline",
                   "",
            ],
            [
                   "getTimeCreated",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_timeCreated_inline",
                   "Returns the time when the media file was created as a long type, unit: second. You can convert the second to date and time format on your own.  @return A long value of the media file created date.",
            ],
            [
                   "Returns the time when the media file was created as a long type, unit: second. You can convert the second to date and time format on your own.  @return A long value of the media file created date.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_timeCreated_inline",
                   "",
            ],
            [
                   "getStreamSourceCamera",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_streamSourceCamera_inline",
                   "Returns the stream source of media file.  @return An enum value of `CameraVideoStreamSource`.",
            ],
            [
                   "Returns the stream source of media file.  @return An enum value of `CameraVideoStreamSource`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMediaInfo.html",
                   "#DJIMediaManager_DJIMediaInfo_streamSourceCamera_inline",
                   "",
            ],
            [
                   "getFileName",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fileName_inline",
                   "Returns the name of the media file in the SD Card.  @return A String instance of the name of the media file.",
            ],
            [
                   "Returns the name of the media file in the SD Card.  @return A String instance of the name of the media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fileName_inline",
                   "",
            ],
            [
                   "isValid",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_valid_inline",
                   "`true` if the media file is still valid. If a media file is from the file list of the media manager, the file will become invalid after the file list is reset.  @return A boolean value to check if the media file is still valid.",
            ],
            [
                   "`true` if the media file is still valid. If a media file is from the file list of the media manager, the file will become invalid after the file list is reset.  @return A boolean value to check if the media file is still valid.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_valid_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getId_inline",
                   "Get the file index used in the camera.  @return An int value of the file index.",
            ],
            [
                   "Get the file index used in the camera.  @return An int value of the file index.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getId_inline",
                   "",
            ],
            [
                   "getMediaType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_mediaType_inline",
                   "Returns the type of media file.  @return An enum value of `MediaType`.",
            ],
            [
                   "Returns the type of media file.  @return An enum value of `MediaType`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_mediaType_inline",
                   "",
            ],
            [
                   "getQuickShotVideoType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_quickShotVideoType_inline",
                   "Returns the type of QuickShot video media file. It is valid when `getVideoFileType` is `QUICK_SHOT`.  @return An enum value of `QuickShotVideoType`.",
            ],
            [
                   "Returns the type of QuickShot video media file. It is valid when `getVideoFileType` is `QUICK_SHOT`.  @return An enum value of `QuickShotVideoType`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_quickShotVideoType_inline",
                   "",
            ],
            [
                   "getShootPhotoMode",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_shootPhotoMode_inline",
                   "Returns the `ShootPhotoMode` of a photo. Returns `null` if `getMediaType` is  `MOV` or `MP4`.  @return An enum value of `ShootPhotoMode`.",
            ],
            [
                   "Returns the `ShootPhotoMode` of a photo. Returns `null` if `getMediaType` is  `MOV` or `MP4`.  @return An enum value of `ShootPhotoMode`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_shootPhotoMode_inline",
                   "",
            ],
            [
                   "getPanoramaMode",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_panoramaMode_inline",
                   "Returns the `PhotoPanoramaMode` of a photo. It is valid when `getShootPhotoMode` is `PANORAMA`.  @return An enum value of `PhotoPanoramaMode`.",
            ],
            [
                   "Returns the `PhotoPanoramaMode` of a photo. It is valid when `getShootPhotoMode` is `PANORAMA`.  @return An enum value of `PhotoPanoramaMode`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_panoramaMode_inline",
                   "",
            ],
            [
                   "getDownloadedSize",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_downloadedSize_inline",
                   "Downloaded size in Bytes of the media file.  @return A long value of downloaded size.",
            ],
            [
                   "Downloaded size in Bytes of the media file.  @return A long value of downloaded size.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_downloadedSize_inline",
                   "",
            ],
            [
                   "getFileSize",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fileSizeInBytes_inline",
                   "Returns the size, in bytes, of the media file.  @return Size of media file.",
            ],
            [
                   "Returns the size, in bytes, of the media file.  @return Size of media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fileSizeInBytes_inline",
                   "",
            ],
            [
                   "getDateCreated",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_timeCreated_inline",
                   "Returns the time when the media file was created as a string in the format yyyy-MM-dd kk:mm:ss.  @return A String instance of the media file created date.",
            ],
            [
                   "Returns the time when the media file was created as a string in the format yyyy-MM-dd kk:mm:ss.  @return A String instance of the media file created date.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_timeCreated_inline",
                   "",
            ],
            [
                   "getTimeCreated",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getTimeCreated_inline",
                   "Returns the time when the media file was created as a long type.  @return A long value of the media file created date.",
            ],
            [
                   "Returns the time when the media file was created as a long type.  @return A long value of the media file created date.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getTimeCreated_inline",
                   "",
            ],
            [
                   "getDurationInSeconds",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_durationInSeconds_inline",
                   "If the media file is a video, this property returns the duration of the video in seconds. Will be 0s if the media file is a photo.  @return Media duration.",
            ],
            [
                   "If the media file is a video, this property returns the duration of the video in seconds. Will be 0s if the media file is a photo.  @return Media duration.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_durationInSeconds_inline",
                   "",
            ],
            [
                   "getFrameRate",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_frameRate_inline",
                   "Frame rate when the media file is a video.  @return An int value.",
            ],
            [
                   "Frame rate when the media file is a video.  @return An int value.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_frameRate_inline",
                   "",
            ],
            [
                   "getStorageLocation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_storageLocation_inline",
                   "Storage location of the media file.  @return An enum value of `StorageLocation`.",
            ],
            [
                   "Storage location of the media file.  @return An enum value of `StorageLocation`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_storageLocation_inline",
                   "",
            ],
            [
                   "getVideoFileType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getVideoFileType_inline",
                   "Returns the type of video media file. This property is only valid when the `getMediaType`  is `MOV` or `MP4`. Returns `null` for other media types.  @return An enum value of `VideoFileType`.",
            ],
            [
                   "Returns the type of video media file. This property is only valid when the `getMediaType`  is `MOV` or `MP4`. Returns `null` for other media types.  @return An enum value of `VideoFileType`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_getVideoFileType_inline",
                   "",
            ],
            [
                   "getCustomInformation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_customInformation_inline",
                   "Custom information can be stored in media file's XMP meta data using `setMediaFileCustomInformation` This property contains the information that was written to this media file. If this property returns `null`, use `fetchCustomInformation` to populate it. Supported by Zenmuse P1, Zenmuse L1, Phantom 4 RTK, Phantom 4 Pro, Phantom 4 Advanced and Inspire 2 with firmware versions from after May 23 2017.  @return A string value.",
            ],
            [
                   "Custom information can be stored in media file's XMP meta data using `setMediaFileCustomInformation` This property contains the information that was written to this media file. If this property returns `null`, use `fetchCustomInformation` to populate it. Supported by Zenmuse P1, Zenmuse L1, Phantom 4 RTK, Phantom 4 Pro, Phantom 4 Advanced and Inspire 2 with firmware versions from after May 23 2017.  @return A string value.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_customInformation_inline",
                   "",
            ],
            [
                   "getXMPFileData",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_XMPFileData_inline",
                   "This property contains the XMP data which was written to this media file. If this property returns `null`, use `fetchXMPFileData` to populate it. Only supported Phantom 4 RTK, Zenmuse P1, Zenmuse L1.",
            ],
            [
                   "This property contains the XMP data which was written to this media file. If this property returns `null`, use `fetchXMPFileData` to populate it. Only supported Phantom 4 RTK, Zenmuse P1, Zenmuse L1.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_XMPFileData_inline",
                   "",
            ],
            [
                   "getResolution",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resolution_inline",
                   "Camera video resolution. Only supported by video.  @return An enum value of `VideoResolution`.",
            ],
            [
                   "Camera video resolution. Only supported by video.  @return An enum value of `VideoResolution`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resolution_inline",
                   "",
            ],
            [
                   "getVideoOrientation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_videoOrientation_inline",
                   "The orientation of the camera when the video file was first recorded. If the camera orientation changes during a video capture, this will report the initial orientation. Will be `LANDSCAPE` if the media file is a photo. Only Mavic Pro supports this property. Will be `LANDSCAPE` for other products.  @return An enum value of `Orientation`",
            ],
            [
                   "The orientation of the camera when the video file was first recorded. If the camera orientation changes during a video capture, this will report the initial orientation. Will be `LANDSCAPE` if the media file is a photo. Only Mavic Pro supports this property. Will be `LANDSCAPE` for other products.  @return An enum value of `Orientation`",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_videoOrientation_inline",
                   "",
            ],
            [
                   "getThumbnail",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_thumbnail_inline",
                   "Returns the thumbnail for this media. If this property returns nil, call `fetchThumbnail`.  @return A Bitmap object.",
            ],
            [
                   "Returns the thumbnail for this media. If this property returns nil, call `fetchThumbnail`.  @return A Bitmap object.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_thumbnail_inline",
                   "",
            ],
            [
                   "getPreview",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_preview_inline",
                   "Returns the preview image for this media. If this property returns `null`, call `fetchPreview`.  @return A Bitmap object.",
            ],
            [
                   "Returns the preview image for this media. If this property returns `null`, call `fetchPreview`.  @return A Bitmap object.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_preview_inline",
                   "",
            ],
            [
                   "fetchThumbnail",
                   2,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMedia_fetchThumbnail_inline",
                   "Fetches this media's thumbnail with a resolution (99 x 99) from the SD card. This method can be used to fetch either a photo or a video, where the first frame of the video is the thumbnail that is fetched. It is not available if the media type is Panorama.  Precondition:  The camera mode is MediaDownload mode.  Post Condition:  This method will start to download the media thumbnail in the SD card. The content can be videos or images.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Fetches this media's thumbnail with a resolution (99 x 99) from the SD card. This method can be used to fetch either a photo or a video, where the first frame of the video is the thumbnail that is fetched. It is not available if the media type is Panorama.  Precondition:  The camera mode is MediaDownload mode.  Post Condition:  This method will start to download the media thumbnail in the SD card. The content can be videos or images.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager.html",
                   "#DJIMediaManager_DJIMedia_fetchThumbnail_inline",
                   "",
            ],
            [
                   "resetThumbnail",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resetThumbnail_inline",
                   "Resets the cached thumbnail to `null` to release the memory usage.  @param callback Completion callback with the returned execution result.",
            ],
            [
                   "Resets the cached thumbnail to `null` to release the memory usage.  @param callback Completion callback with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resetThumbnail_inline",
                   "",
            ],
            [
                   "fetchPreview",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchPreview_inline",
                   "Fetch media's preview image. The preview image is a lower resolution (960 x 540) version of a photo. The `MediaType` of this media object should be `JPEG` or `TIFF`. The preview will be stored in `getPreview`.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Fetch media's preview image. The preview image is a lower resolution (960 x 540) version of a photo. The `MediaType` of this media object should be `JPEG` or `TIFF`. The preview will be stored in `getPreview`.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchPreview_inline",
                   "",
            ],
            [
                   "resetPreview",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resetPreview_inline",
                   "Resets the cached preview image to `null` to release the memory usage.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Resets the cached preview image to `null` to release the memory usage.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_resetPreview_inline",
                   "",
            ],
            [
                   "fetchCustomInformation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchCustomInformation_inline",
                   "Custom information can be stored in media file's XMP meta data using `setMediaFileCustomInformation`. The information will be stored in `getCustomInformation`. Only supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7 and Mavic 2 Enterprise camera.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Custom information can be stored in media file's XMP meta data using `setMediaFileCustomInformation`. The information will be stored in `getCustomInformation`. Only supported by Phantom 4 Pro, Phantom 4 Advanced, Phantom 4 Pro V2.0, Zenmuse P1, Zenmuse L1, Zenmuse X4S, Zenmuse X5S, Zenmuse X7 and Mavic 2 Enterprise camera.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchCustomInformation_inline",
                   "",
            ],
            [
                   "fetchXMPFileData",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchXMPFileData_inline",
                   "Fetch the XMP data stored in the media file. The data will be stored in `getXMPFileData`. Only supported by Zenmuse P1, Zenmuse L1, Phantom 4 RTK.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Fetch the XMP data stored in the media file. The data will be stored in `getXMPFileData`. Only supported by Zenmuse P1, Zenmuse L1, Phantom 4 RTK.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchXMPFileData_inline",
                   "",
            ],
            [
                   "fetchFileByteData",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchFileByteData_inline",
                   "Fetches this media file's full resolution data from camera by byte.  You can get the media file data with `onRealtimeDataUpdate`. The difference between fetching the media data and fetching the thumbnail is that fetching the thumbnail will return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. If last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param offset The byte offset strarting to download media file. @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Fetches this media file's full resolution data from camera by byte.  You can get the media file data with `onRealtimeDataUpdate`. The difference between fetching the media data and fetching the thumbnail is that fetching the thumbnail will return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. If last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param offset The byte offset strarting to download media file. @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchFileByteData_inline",
                   "",
            ],
            [
                   "fetchFileData",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchFileData_inline",
                   "Fetches this media file's full resolution data from camera. The difference between  fetching the media data and fetching the thumbnail is that fetching the thumbnail will  return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. If last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param destDir File instance of location to save the files, which can not be null. @param fileNameWithoutExtension The fileName to store in mobile devices, without the file extension.<br> If it is null, the file name in the camera's SDCard will be used. @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Fetches this media file's full resolution data from camera. The difference between  fetching the media data and fetching the thumbnail is that fetching the thumbnail will  return a low-resolution image of the actual picture, while fetching the media data will  return all data for a video or image. If last download action is aborted, it will continue  to download the data from where the file download has been aborted.  @param destDir File instance of location to save the files, which can not be null. @param fileNameWithoutExtension The fileName to store in mobile devices, without the file extension.<br> If it is null, the file name in the camera's SDCard will be used. @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchFileData_inline",
                   "",
            ],
            [
                   "stopFetchingFileData",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_stopFetchingFileData_inline",
                   "Stops a currently executing call of `fetchFileData`.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Stops a currently executing call of `fetchFileData`.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_stopFetchingFileData_inline",
                   "",
            ],
            [
                   "fetchSubFileDataList",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchSubFileDataList_inline",
                   "Fetches the file data of the sub media files. It is available only when `getMediaType` is `PANORAMA` or `SHALLOW_FOCUS`.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Fetches the file data of the sub media files. It is available only when `getMediaType` is `PANORAMA` or `SHALLOW_FOCUS`.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchSubFileDataList_inline",
                   "",
            ],
            [
                   "fetchSuperResJSON",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchSuperResJSON_inline",
                   "Super Resolution JSON file was used to save super resolution photo coordinate info.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Super Resolution JSON file was used to save super resolution photo coordinate info.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_fetchSuperResJSON_inline",
                   "",
            ],
            [
                   "MediaType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_inline",
                   "Media types.",
            ],
            [
                   "Media types.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_inline",
                   "",
            ],
            [
                   "VideoFileType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_inline",
                   "Video file types. It is not supported by `onNewFile` return `MediaFile` media file object.",
            ],
            [
                   "Video file types. It is not supported by `onNewFile` return `MediaFile` media file object.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_inline",
                   "",
            ],
            [
                   "QuickShotVideoType",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_inline",
                   "The QuickShot modes of the video file when its type is `QUICK_SHOT`.",
            ],
            [
                   "The QuickShot modes of the video file when its type is `QUICK_SHOT`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_inline",
                   "",
            ],
            [
                   "AudioMediaFile",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "",
                   "This class represents the information of an audio file in the aircraft. The audio  file is not accessible if the aircraft is connected to a PC with the USB port.  For M2E Speaker, it only supports audio files with the following conditions:  The audio channel is mono. The audio sample rate is 44,100 Hz. The PCM (Pulse-code modulation)  sample depth is 16 bit per sample. The `AudioMediaFile` contains  following properties:  - `getFileName`  - `getDurationInSeconds` - `getIndex`  - `getStorageLocation`",
            ],
            [
                   "This class represents the information of an audio file in the aircraft. The audio  file is not accessible if the aircraft is connected to a PC with the USB port.  For M2E Speaker, it only supports audio files with the following conditions:  The audio channel is mono. The audio sample rate is 44,100 Hz. The PCM (Pulse-code modulation)  sample depth is 16 bit per sample. The `AudioMediaFile` contains  following properties:  - `getFileName`  - `getDurationInSeconds` - `getIndex`  - `getStorageLocation`",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "",
                   "",
            ],
            [
                   "getAudioStorageLocation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_audioStorageLocation_inline",
                   "The storage location to store the file in the aircraft.  @return An enum value of the `AudioStorageLocation`.",
            ],
            [
                   "The storage location to store the file in the aircraft.  @return An enum value of the `AudioStorageLocation`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_audioStorageLocation_inline",
                   "",
            ],
            [
                   "AudioStorageLocation",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_inline",
                   "Storage types of audio files. The storage types will determine the strategy of the aircraft to keep the file.",
            ],
            [
                   "Storage types of audio files. The storage types will determine the strategy of the aircraft to keep the file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_inline",
                   "",
            ],
            [
                   "TEMPORARY",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Temporary_inline",
                   "The audio file is stored to a temporary space. Files with temporary storage location will be automatically deleted when the aircraft reboots.",
            ],
            [
                   "The audio file is stored to a temporary space. Files with temporary storage location will be automatically deleted when the aircraft reboots.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Temporary_inline",
                   "",
            ],
            [
                   "PERSISTENT",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Persistent_inline",
                   "The audio file is stored to a persistent space. Files with persistent storage location should be deleted manually by calling `delete`.",
            ],
            [
                   "The audio file is stored to a persistent space. Files with persistent storage location should be deleted manually by calling `delete`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Persistent_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia_DJIMediaFile.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaFile_DJIAudioStorageLocation_Unknown_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_Unknown_inline",
                   "Unknown file type.",
            ],
            [
                   "Unknown file type.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_Unknown_inline",
                   "",
            ],
            [
                   "JPEG",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_JPEG_inline",
                   "Image of JPEG format.",
            ],
            [
                   "Image of JPEG format.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_JPEG_inline",
                   "",
            ],
            [
                   "MP4",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_MP4_inline",
                   "Video of MP4 format.",
            ],
            [
                   "Video of MP4 format.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_MP4_inline",
                   "",
            ],
            [
                   "MOV",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_MOV_inline",
                   "Video of MOV format.",
            ],
            [
                   "Video of MOV format.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_MOV_inline",
                   "",
            ],
            [
                   "RAW_DNG",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_RAWDNG_inline",
                   "Image of DNG format.",
            ],
            [
                   "Image of DNG format.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_RAWDNG_inline",
                   "",
            ],
            [
                   "PANORAMA",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_Panorama_inline",
                   "Panorama file type.",
            ],
            [
                   "Panorama file type.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_Panorama_inline",
                   "",
            ],
            [
                   "TIFF",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_TIFF_inline",
                   "TIFF file type.",
            ],
            [
                   "TIFF file type.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_TIFF_inline",
                   "",
            ],
            [
                   "SHALLOW_FOCUS",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_ShallowFocus_inline",
                   "ShallowFocus file type. ShallowFocus files have a shallow depth of field.",
            ],
            [
                   "ShallowFocus file type. ShallowFocus files have a shallow depth of field.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_ShallowFocus_inline",
                   "",
            ],
            [
                   "SEQ",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_TIFFSequence_inline",
                   "TIFF Sequence file type. It is a video format for infrared cameras.",
            ],
            [
                   "TIFF Sequence file type. It is a video format for infrared cameras.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_TIFFSequence_inline",
                   "",
            ],
            [
                   "TIFF_SEQ",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_SEQ_inline",
                   "SEQ file type. It is a video format for infrared cameras.",
            ],
            [
                   "SEQ file type. It is a video format for infrared cameras.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_SEQ_inline",
                   "",
            ],
            [
                   "JSON",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_JSON_inline",
                   "JSON file type. It is a json format for save image information. It is used to storage the coordinate information for Super Resolution in Zenmuse H20 series.",
            ],
            [
                   "JSON file type. It is a json format for save image information. It is used to storage the coordinate information for Super Resolution in Zenmuse H20 series.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_JSON_inline",
                   "",
            ],
            [
                   "PHOTO_FOLDER",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_PHOTO_FOLDER_inline",
                   "Photo Folder. It is a folder for save image files.",
            ],
            [
                   "Photo Folder. It is a folder for save image files.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_PHOTO_FOLDER_inline",
                   "",
            ],
            [
                   "VIDEO_FOLDER",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_VIDEO_FOLDER_inline",
                   "Video Folder. It is a folder for save video files.",
            ],
            [
                   "Video Folder. It is a folder for save video files.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaType_VIDEO_FOLDER_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Normal_inline",
                   "The video file is recorded in normal mode.",
            ],
            [
                   "The video file is recorded in normal mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Normal_inline",
                   "",
            ],
            [
                   "TIME_LAPSE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_TimeLapse_inline",
                   "The video file is recorded in time-lapse mode.",
            ],
            [
                   "The video file is recorded in time-lapse mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_TimeLapse_inline",
                   "",
            ],
            [
                   "SLOW_MOTION",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_SlowMotion_inline",
                   "The video file is recorded as slow motion video.",
            ],
            [
                   "The video file is recorded as slow motion video.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_SlowMotion_inline",
                   "",
            ],
            [
                   "QUICK_SHOT",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_QuickShot_inline",
                   "The video file is recorded during a QuickShot mission.  Use `QUICK_SHOT`  to check the detail QuickShot mode of the video file.",
            ],
            [
                   "The video file is recorded during a QuickShot mission.  Use `QUICK_SHOT`  to check the detail QuickShot mode of the video file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_QuickShot_inline",
                   "",
            ],
            [
                   "HYPERLAPSE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Hyperlapse_inline",
                   "The video is recorded when the aircraft is in hyper-lapse mode.  It is only supported by Mavic 2 Zoom and Mavic 2 Pro. Hyper-lapse  is only supported by DJI GO 4.",
            ],
            [
                   "The video is recorded when the aircraft is in hyper-lapse mode.  It is only supported by Mavic 2 Zoom and Mavic 2 Pro. Hyper-lapse  is only supported by DJI GO 4.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Hyperlapse_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaVideoFileType_Unknown_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_None_inline",
                   "The video file is not a QuickShot video.",
            ],
            [
                   "The video file is not a QuickShot video.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_None_inline",
                   "",
            ],
            [
                   "CIRCLE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Circle_inline",
                   "The QuickShot video file is recorded in Circle mode.",
            ],
            [
                   "The QuickShot video file is recorded in Circle mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Circle_inline",
                   "",
            ],
            [
                   "DRONIE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Dronie_inline",
                   "The QuickShot video file is recorded in Dronie mode.",
            ],
            [
                   "The QuickShot video file is recorded in Dronie mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Dronie_inline",
                   "",
            ],
            [
                   "HELIX",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Helix_inline",
                   "The QuickShot video file is recorded in Helix mode.",
            ],
            [
                   "The QuickShot video file is recorded in Helix mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Helix_inline",
                   "",
            ],
            [
                   "ROCKET",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Rocket_inline",
                   "The QuickShot video file is recorded in Rocket mode.",
            ],
            [
                   "The QuickShot video file is recorded in Rocket mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Rocket_inline",
                   "",
            ],
            [
                   "BOOMERANG",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Boomerang_inline",
                   "The QuickShot video file is recorded in Boomerang mode.",
            ],
            [
                   "The QuickShot video file is recorded in Boomerang mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Boomerang_inline",
                   "",
            ],
            [
                   "ASTEROID",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Asteroid_inline",
                   "The QuickShot video file is recorded in Asteroid mode.",
            ],
            [
                   "The QuickShot video file is recorded in Asteroid mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Asteroid_inline",
                   "",
            ],
            [
                   "DOLLY_ZOOM",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_DollyZoom_inline",
                   "The QuickShot video file is recorded in DollyZoom mode.",
            ],
            [
                   "The QuickShot video file is recorded in DollyZoom mode.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_DollyZoom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIMedia.html",
                   "#DJIMediaManager_DJIMedia_DJIMediaQuickShotVideoType_Unknown_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJIMediaManager_updateVideoPlaybackStateCallbackInterface.html",
                   "#DJIMediaManager_updateVideoPlaybackState_inline",
                   "Updates the video playback state of the media manager. This update method will only be called when the media manager is playing a video.  @param videoPlaybackState VideoPlaybackState object.",
            ],
            [
                   "Updates the video playback state of the media manager. This update method will only be called when the media manager is playing a video.  @param videoPlaybackState VideoPlaybackState object.",
                   1,
                   "/Components/Camera/DJIMediaManager_updateVideoPlaybackStateCallbackInterface.html",
                   "#DJIMediaManager_updateVideoPlaybackState_inline",
                   "",
            ],
            [
                   "onStart",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnStart_inline",
                   "Called when the file download begins.",
            ],
            [
                   "Called when the file download begins.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnStart_inline",
                   "",
            ],
            [
                   "onRateUpdate",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnRateUpdate_inline",
                   "Called to show the download rate. It is called every 1 second. Hence, the persize which is the download size among two calls is the download rate.  @param total The total size. @param current The current download size. @param persize The download size between two calls.",
            ],
            [
                   "Called to show the download rate. It is called every 1 second. Hence, the persize which is the download size among two calls is the download rate.  @param total The total size. @param current The current download size. @param persize The download size between two calls.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnRateUpdate_inline",
                   "",
            ],
            [
                   "onRealtimeDataUpdate",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadonRealtimeDataUpdate_inline",
                   "Called to get the media file data download from camera by byte in real time.  @param data The media file data download from camera by byte. @param position The byte offset into the meida file at which the data starts. @param isLastPack `true` if the pack is the last one.",
            ],
            [
                   "Called to get the media file data download from camera by byte in real time.  @param data The media file data download from camera by byte. @param position The byte offset into the meida file at which the data starts. @param isLastPack `true` if the pack is the last one.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadonRealtimeDataUpdate_inline",
                   "",
            ],
            [
                   "onProgress",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnProgress_inline",
                   "Called to update the download progress. It is called every time there is data received.  @param total The total size of the file being downloaded. @param current The current download data size.",
            ],
            [
                   "Called to update the download progress. It is called every time there is data received.  @param total The total size of the file being downloaded. @param current The current download data size.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnProgress_inline",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnSuccess_inline",
                   "Called when the media download is completed.  @param data The media that was successfully downloaded",
            ],
            [
                   "Called when the media download is completed.  @param data The media that was successfully downloaded",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnFailure_inline",
                   "Called when the media download failed.  @param error The error information.",
            ],
            [
                   "Called when the media download failed.  @param error The error information.",
                   1,
                   "/Components/Camera/DJIMediaManager_CameraDownloadListenerInterface.html",
                   "#DJIMediaManager_CameraDownloadOnFailure_inline",
                   "",
            ],
            [
                   "onFileListStateChange",
                   2,
                   "/Components/Camera/DJIMediaManager_FileListStateListener.html",
                   "#DJIMediaManager_onFileListStateChange_inline",
                   "Updates the file list state of the media manager.  @param state The new file list state.",
            ],
            [
                   "Updates the file list state of the media manager.  @param state The new file list state.",
                   1,
                   "/Components/Camera/DJIMediaManager_FileListStateListener.html",
                   "#DJIMediaManager_onFileListStateChange_inline",
                   "",
            ],
            [
                   "FetchMediaTaskScheduler",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "",
                   "The camera stores the media it captures to SD or SSD storage on the product. When the mobile device wants to access the media, it needs to download it from the product over the wireless link between the product, remote controller and mobile device (depending on the product). Each media file captured by the camera can have several types of content associated with it including the full resolution media content, a lower resolution preview, a lower resolution again thumbnail, and custom data within the file's XML meta data. The full resolution content can take a long time to download over the wireless link, so it is often useful to download previews or thumbnails of many media files, and then only download the full resolution content of fewer select media files. This scheduler conveniently allows the small content types of media files (preview, thumbnail and custom data) to be downloaded to the mobile device. The scheduler can be used to queue and download content from a series of files, as well as used to re-prioritize files during the download process. The scheduler holds a list of pending tasks and it completes them one by one in first-in-first-out order. To prioritize a new task, `moveTaskToNext` can be used. Each task relates to a media file and can download multiple content types sequentially. When the last content type of a task starts being downloaded, the task is removed from the list. Note, the scheduler cannot be used to queue the download of full resolution media content. Only `fetchFileData` can be used for this.",
            ],
            [
                   "The camera stores the media it captures to SD or SSD storage on the product. When the mobile device wants to access the media, it needs to download it from the product over the wireless link between the product, remote controller and mobile device (depending on the product). Each media file captured by the camera can have several types of content associated with it including the full resolution media content, a lower resolution preview, a lower resolution again thumbnail, and custom data within the file's XML meta data. The full resolution content can take a long time to download over the wireless link, so it is often useful to download previews or thumbnails of many media files, and then only download the full resolution content of fewer select media files. This scheduler conveniently allows the small content types of media files (preview, thumbnail and custom data) to be downloaded to the mobile device. The scheduler can be used to queue and download content from a series of files, as well as used to re-prioritize files during the download process. The scheduler holds a list of pending tasks and it completes them one by one in first-in-first-out order. To prioritize a new task, `moveTaskToNext` can be used. Each task relates to a media file and can download multiple content types sequentially. When the last content type of a task starts being downloaded, the task is removed from the list. Note, the scheduler cannot be used to queue the download of full resolution media content. Only `fetchFileData` can be used for this.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_state_inline",
                   "State of the scheduler.  @return An enum value of `FetchMediaTaskSchedulerState`.",
            ],
            [
                   "State of the scheduler.  @return An enum value of `FetchMediaTaskSchedulerState`.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_state_inline",
                   "",
            ],
            [
                   "getPendingTasks",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_pendingTasks_inline",
                   "Gets a copy of the pending tasks.  @return A list of `FetchMediaTask` objects.",
            ],
            [
                   "Gets a copy of the pending tasks.  @return A list of `FetchMediaTask` objects.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_pendingTasks_inline",
                   "",
            ],
            [
                   "moveTaskToEnd",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_moveTaskToEnd_inline",
                   "Pushes a task to the back of the queue. The task will be executed after all other tasks are complete.  @param task Task to schedule.",
            ],
            [
                   "Pushes a task to the back of the queue. The task will be executed after all other tasks are complete.  @param task Task to schedule.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_moveTaskToEnd_inline",
                   "",
            ],
            [
                   "moveTaskToNext",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_moveTaskToNext_inline",
                   "Pushes a task to the front of the queue. The task will be executed after the executing task is complete.  @param task Task to schedule.",
            ],
            [
                   "Pushes a task to the front of the queue. The task will be executed after the executing task is complete.  @param task Task to schedule.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_moveTaskToNext_inline",
                   "",
            ],
            [
                   "removeTask",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_removeTask_inline",
                   "Remove content from tasks, and tasks from the scheduler. If all content is removed from a task, then the task is removed from the scheduler.  @param file An object of `MediaFile`. @param content An enum value of `FetchMediaTaskContent`.",
            ],
            [
                   "Remove content from tasks, and tasks from the scheduler. If all content is removed from a task, then the task is removed from the scheduler.  @param file An object of `MediaFile`. @param content An enum value of `FetchMediaTaskContent`.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_removeTask_inline",
                   "",
            ],
            [
                   "removeAllTasks",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_removeAllTasks_inline",
                   "Removes all the pending tasks.",
            ],
            [
                   "Removes all the pending tasks.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_removeAllTasks_inline",
                   "",
            ],
            [
                   "suspend",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_suspend_inline",
                   "Suspends the scheduler. The scheduler will not continue to execute tasks in the queue.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Suspends the scheduler. The scheduler will not continue to execute tasks in the queue.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_suspend_inline",
                   "",
            ],
            [
                   "resume",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_resume_inline",
                   "Resumes the scheduler. The scheduler will execute tasks in the queue sequentially.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Resumes the scheduler. The scheduler will execute tasks in the queue sequentially.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_resume_inline",
                   "",
            ],
            [
                   "isSuspendAfterSingleFetchTaskFailure",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_isSuspendAfterSingleFetchTaskFailure_inline",
                   "Determines whether suspend the scheduler when an error occurs during the execution.  @return A boolean value.",
            ],
            [
                   "Determines whether suspend the scheduler when an error occurs during the execution.  @return A boolean value.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_isSuspendAfterSingleFetchTaskFailure_inline",
                   "",
            ],
            [
                   "setSuspendAfterSingleFetchTaskFailure",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_setSuspendAfterSingleFetchTaskFailure_inline",
                   "Sets if suspend the scheduler when an error occurs during the execution.  @param suspendAfterSingleFetchTaskFailure A boolean value.",
            ],
            [
                   "Sets if suspend the scheduler when an error occurs during the execution.  @param suspendAfterSingleFetchTaskFailure A boolean value.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_FetchMediaTaskScheduler_setSuspendAfterSingleFetchTaskFailure_inline",
                   "",
            ],
            [
                   "FetchMediaTaskSchedulerState",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_inline",
                   "States of the fetch media file task scheduler `FetchMediaTaskScheduler`.",
            ],
            [
                   "States of the fetch media file task scheduler `FetchMediaTaskScheduler`.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Idle_inline",
                   "Scheduler is waiting for tasks.",
            ],
            [
                   "Scheduler is waiting for tasks.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Idle_inline",
                   "",
            ],
            [
                   "EXECUTING",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Executing_inline",
                   "Scheduler is executing tasks.",
            ],
            [
                   "Scheduler is executing tasks.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Executing_inline",
                   "",
            ],
            [
                   "SUSPENDED",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Suspended_inline",
                   "Scheduler is suspended. Use `resume` to resume the scheduler.",
            ],
            [
                   "Scheduler is suspended. Use `resume` to resume the scheduler.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Suspended_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Camera/DJIMediaManager_FetchMediaTaskScheduler.html",
                   "#DJIMediaManager_DJIFetchMediaTaskSchedulerState_Unknown_inline",
                   "",
            ],
            [
                   "FetchMediaTask",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "",
                   "Task to fetch contents of a media file. To make `FetchMediaTaskScheduler` fetch the thumbnail, preview or custom information of a media file, a task should be created by using `FetchMediaTask`.",
            ],
            [
                   "Task to fetch contents of a media file. To make `FetchMediaTaskScheduler` fetch the thumbnail, preview or custom information of a media file, a task should be created by using `FetchMediaTask`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "",
                   "",
            ],
            [
                   "FetchMediaTask",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTask_constructor_inline",
                   "Creates a task instance.  @param file Media file to execute task on. @param content Content to fetch. @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Creates a task instance.  @param file Media file to execute task on. @param content Content to fetch. @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTask_constructor_inline",
                   "",
            ],
            [
                   "FetchMediaTask",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTask_constructor2_inline",
                   "Creates a task instance without callback.  @param file Media file to execute task on. @param content Content to fetch.",
            ],
            [
                   "Creates a task instance without callback.  @param file Media file to execute task on. @param content Content to fetch.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTask_constructor2_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask_CallbackInterface.html",
                   "",
                   "Callback that is called when the scheduler finishes downloading content for a fetch media file task. If multiple content types are defined for a file, this completion block will be called at the completion of each content type being downloaded. The order content types will be downloaded in is first `THUMBNAIL`, then `PREVIEW`.",
            ],
            [
                   "Callback that is called when the scheduler finishes downloading content for a fetch media file task. If multiple content types are defined for a file, this completion block will be called at the completion of each content type being downloaded. The order content types will be downloaded in is first `THUMBNAIL`, then `PREVIEW`.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask_CallbackInterface.html",
                   "#DJIMediaManager_DJIFetchMediaTask_Callback_inline",
                   "Called each time the scheduler finishes downloading content.  @param file file to execute task on. @param option An enum value of `FetchMediaTaskContent`. @param error Error retrieving the value.",
            ],
            [
                   "Called each time the scheduler finishes downloading content.  @param file file to execute task on. @param option An enum value of `FetchMediaTaskContent`. @param error Error retrieving the value.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask_CallbackInterface.html",
                   "#DJIMediaManager_DJIFetchMediaTask_Callback_inline",
                   "",
            ],
            [
                   "FetchMediaTaskContent",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_inline",
                   "The content to download in a fetch media file task.",
            ],
            [
                   "The content to download in a fetch media file task.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_None_inline",
                   "None.",
            ],
            [
                   "None.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_None_inline",
                   "",
            ],
            [
                   "THUMBNAIL",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_Thumbnail_inline",
                   "The scheduler will download the thumbnail of the media file.",
            ],
            [
                   "The scheduler will download the thumbnail of the media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_Thumbnail_inline",
                   "",
            ],
            [
                   "PREVIEW",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_Preview_inline",
                   "The scheduler will download the preview image of the media file.",
            ],
            [
                   "The scheduler will download the preview image of the media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_Preview_inline",
                   "",
            ],
            [
                   "CUSTOM_INFORMATION",
                   2,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_CustomInformation_inline",
                   "The scheduler will download the custom information of the media file.",
            ],
            [
                   "The scheduler will download the custom information of the media file.",
                   1,
                   "/Components/Camera/DJIMediaManager_DJIFetchMediaTask.html",
                   "#DJIMediaManager_DJIFetchMediaTaskContent_CustomInformation_inline",
                   "",
            ],
            [
                   "setPlaybackStateCallback",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_setDJICameraPlayBackStateCallBack_inline",
                   "Sets the camera's playback state callback. Called according to the camera's update timer.  Precondition:  You must first define a Callback object to pass in as a parameter.  Post  Condition:  Every time the playback state changes, the Callback interface that was passed in as a parameter will call its onResult function.  The onResult function takes in a DJICameraPlayBackState  object, which provides playback information such as the number of photos currently selected, the video playback  progress (if a video is being played), and much more.  @param cameraPlayBackStateCB The Callback object to set as the callback interface for when the playback state changes.  <br> The Callback interface implements an onResult function, which takes in a  DJICameraPlayBackState object from the aircraft. <br>",
            ],
            [
                   "Sets the camera's playback state callback. Called according to the camera's update timer.  Precondition:  You must first define a Callback object to pass in as a parameter.  Post  Condition:  Every time the playback state changes, the Callback interface that was passed in as a parameter will call its onResult function.  The onResult function takes in a DJICameraPlayBackState  object, which provides playback information such as the number of photos currently selected, the video playback  progress (if a video is being played), and much more.  @param cameraPlayBackStateCB The Callback object to set as the callback interface for when the playback state changes.  <br> The Callback interface implements an onResult function, which takes in a  DJICameraPlayBackState object from the aircraft. <br>",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_setDJICameraPlayBackStateCallBack_inline",
                   "",
            ],
            [
                   "enterSinglePreviewModeWithIndex",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterSinglePreviewMode_inline",
                   "Enters single file preview mode for a file at the specified index. In order for this method to be called,  the camera work mode must be `PLAYBACK`.  @return  DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @param index File to be previewed at the specified index. The value falls in [1,8].  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Enters single file preview mode for a file at the specified index. In order for this method to be called,  the camera work mode must be `PLAYBACK`.  @return  DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @param index File to be previewed at the specified index. The value falls in [1,8].  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterSinglePreviewMode_inline",
                   "",
            ],
            [
                   "proceedToNextSinglePreviewPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToNextSinglePreviewPage_inline",
                   "Goes to the next page.  Precondition:  The camera must enter Single File Preview Mode.   Special case:  If it is the last image, it will go to the first image. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Goes to the next page.  Precondition:  The camera must enter Single File Preview Mode.   Special case:  If it is the last image, it will go to the first image. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToNextSinglePreviewPage_inline",
                   "",
            ],
            [
                   "proceedToPreviousSinglePreviewPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToPreviousSinglePreviewPage_inline",
                   "Goes back to the previous page.  Precondition:  The camera must enter Single File Preview Mode.  Special case:  If it is the first image, it will go to the last image. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Goes back to the previous page.  Precondition:  The camera must enter Single File Preview Mode.  Special case:  If it is the first image, it will go to the last image. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToPreviousSinglePreviewPage_inline",
                   "",
            ],
            [
                   "playVideo",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_startVideoPlayback_inline",
                   "Starts video playback. The selected file must be a video file.  Precondition:  The camera must enter  Single Preview Mode.  Post condition:  If the video finishes playing, it will stop and go back to the  beginning of the file. @return DJICameraError Shows the possible error during the execution. If there is no error,  it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Starts video playback. The selected file must be a video file.  Precondition:  The camera must enter  Single Preview Mode.  Post condition:  If the video finishes playing, it will stop and go back to the  beginning of the file. @return DJICameraError Shows the possible error during the execution. If there is no error,  it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_startVideoPlayback_inline",
                   "",
            ],
            [
                   "pauseVideo",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_pauseVideoPlayback_inline",
                   "Pauses a video during playback.  Precondition:  The video is being played.  @return  DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Pauses a video during playback.  Precondition:  The video is being played.  @return  DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_pauseVideoPlayback_inline",
                   "",
            ],
            [
                   "stopVideo",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_stopVideoPlayback_inline",
                   "Stops a video during playback.  Precondition:  The video is being played.  Post condition:   The file will stop and go back to the beginning of the file. @return DJICameraError Shows the possible error during  the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Stops a video during playback.  Precondition:  The video is being played.  Post condition:   The file will stop and go back to the beginning of the file. @return DJICameraError Shows the possible error during  the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_stopVideoPlayback_inline",
                   "",
            ],
            [
                   "playVideoFromPositionInPercent",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_setVideoPlaybackFromLocation_inline",
                   "Plays a video from the specified location. The selected file must be a video file.  Precondition:   The camera must enter Single File Preview Mode.  Post condition:  The file will play from a specific location immediately. This command can only be called if the video is currently playing or is paused. If paused, the playback position will be updated and playing will resume.  @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @param location Location from which to play the video must be in the range of [0, 100]. This value  represents at what percent of the entire video it should start playing.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Plays a video from the specified location. The selected file must be a video file.  Precondition:   The camera must enter Single File Preview Mode.  Post condition:  The file will play from a specific location immediately. This command can only be called if the video is currently playing or is paused. If paused, the playback position will be updated and playing will resume.  @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @param location Location from which to play the video must be in the range of [0, 100]. This value  represents at what percent of the entire video it should start playing.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_setVideoPlaybackFromLocation_inline",
                   "",
            ],
            [
                   "deleteCurrentPreviewFile",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_deleteCurrentPreviewFile_inline",
                   "Deletes the current file being previewed.  Precondition:  The camera must enter single file preview  mode.  Post condition:  The image will be deleted from the SD card. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Deletes the current file being previewed.  Precondition:  The camera must enter single file preview  mode.  Post condition:  The image will be deleted from the SD card. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_deleteCurrentPreviewFile_inline",
                   "",
            ],
            [
                   "enterMultiplePreviewMode",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterMultiplePreviewMode_inline",
                   "Enables the user to preview multiple files when the camera is in Playback mode.  Precondition:  The  camera work mode should be set to Playback mode.  Post condition:  There will be 8 images on one page.  @return DJICameraError Shows the possible error during the execution. If there is no error, it returns  null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Enables the user to preview multiple files when the camera is in Playback mode.  Precondition:  The  camera work mode should be set to Playback mode.  Post condition:  There will be 8 images on one page.  @return DJICameraError Shows the possible error during the execution. If there is no error, it returns  null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterMultiplePreviewMode_inline",
                   "",
            ],
            [
                   "proceedToNextMultiplePreviewPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToNextMultiplePreviewPage_inline",
                   "Goes to the next page when there are multiple pages.  Precondition:  The camera must enter Multiple  Preview Mode.  Special case:  If it is the last page, it will stay at the last page.  @return DJICameraErrorr Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Goes to the next page when there are multiple pages.  Precondition:  The camera must enter Multiple  Preview Mode.  Special case:  If it is the last page, it will stay at the last page.  @return DJICameraErrorr Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToNextMultiplePreviewPage_inline",
                   "",
            ],
            [
                   "proceedToPreviousMultiplePreviewPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToPreviousMultiplePreviewPage_inline",
                   "Goes back to the previous page when there are multiple pages.  Precondition:   The camera must enter Multiple Preview Mode.  Special case:  If it is the first page, it will  stay at the first page. @return DJICameraError Shows the possible error during the execution. If there is  no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Goes back to the previous page when there are multiple pages.  Precondition:   The camera must enter Multiple Preview Mode.  Special case:  If it is the first page, it will  stay at the first page. @return DJICameraError Shows the possible error during the execution. If there is  no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_goToPreviousMultiplePreviewPage_inline",
                   "",
            ],
            [
                   "enterMultipleEditMode",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterMultipleEditMode_inline",
                   "This enables the user to select, download, or delete multiple media files when the camera is in Playback mode.  Precondition:  The camera work mode must be set to Camera Play back mode and then Multiple Preview Mode.  Post condition:  Multiple photos can be selected to be downloaded or deleted. @return DJICameraError Shows the  possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "This enables the user to select, download, or delete multiple media files when the camera is in Playback mode.  Precondition:  The camera work mode must be set to Camera Play back mode and then Multiple Preview Mode.  Post condition:  Multiple photos can be selected to be downloaded or deleted. @return DJICameraError Shows the  possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_enterMultipleEditMode_inline",
                   "",
            ],
            [
                   "exitMultipleEditMode",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_exitMultipleEditMode_inline",
                   "Exits multiple edit mode. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Exits multiple edit mode. @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_exitMultipleEditMode_inline",
                   "",
            ],
            [
                   "toggleFileSelectionAtIndex",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_toggleFileSelectionAtIndex_inline",
                   "Selects or unselects a file at the specified index of the current page. This index is unrelated to the filename,  and is used in multiple edit mode.  Precondition:  The camera must enter Multiple Edit Mode.   @return DJICameraError Shows the possible error during the execution. If there is no error, it returns  null</code>.  @param index Index at which to select a file. The value falls in [1,8]. However, the exact range should depends on how many photos totally in current page.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Selects or unselects a file at the specified index of the current page. This index is unrelated to the filename,  and is used in multiple edit mode.  Precondition:  The camera must enter Multiple Edit Mode.   @return DJICameraError Shows the possible error during the execution. If there is no error, it returns  null</code>.  @param index Index at which to select a file. The value falls in [1,8]. However, the exact range should depends on how many photos totally in current page.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_toggleFileSelectionAtIndex_inline",
                   "",
            ],
            [
                   "selectAllFiles",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_selectAllFiles_inline",
                   "Selects all the files on the SD card.  Precondition:  The camera must enter Multi Edit Mode.  @return DJICameraError Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Selects all the files on the SD card.  Precondition:  The camera must enter Multi Edit Mode.  @return DJICameraError Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_selectAllFiles_inline",
                   "",
            ],
            [
                   "unselectAllFiles",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_unselectAllFiles_inline",
                   "Unselects all the files on the SD card.  Precondition:  The camera must enter Multiple Edit Mode.  @return DJICameraError Shows the possible error during the execution. If there is no error,  it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Unselects all the files on the SD card.  Precondition:  The camera must enter Multiple Edit Mode.  @return DJICameraError Shows the possible error during the execution. If there is no error,  it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_unselectAllFiles_inline",
                   "",
            ],
            [
                   "selectAllFilesInPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_selectAllFilesInPage_inline",
                   "Selects all the file(s) on the current page.  Precondition:  The camera must enter Multiple Edit Mode.   @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Selects all the file(s) on the current page.  Precondition:  The camera must enter Multiple Edit Mode.   @return DJICameraError Shows the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_selectAllFilesInPage_inline",
                   "",
            ],
            [
                   "unselectAllFilesInPage",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_unselectAllFilesInPage_inline",
                   "Unselects all the file(s) on the current page.  Precondition:  The camera must enter Multiple Edit  Mode. @return DJICameraError Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Unselects all the file(s) on the current page.  Precondition:  The camera must enter Multiple Edit  Mode. @return DJICameraError Shows the possible error during the execution. If there is no error, it  returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_unselectAllFilesInPage_inline",
                   "",
            ],
            [
                   "deleteAllSelectedFiles",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_deleteAllSelectedFiles_inline",
                   "Deletes all selected files from the SD card.  Precondition:  The camera must enter Multiple Edit Mode.  Post condition:  The images will be deleted from the SD card.  @return DJICameraError Shows  the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
            ],
            [
                   "Deletes all selected files from the SD card.  Precondition:  The camera must enter Multiple Edit Mode.  Post condition:  The images will be deleted from the SD card.  @return DJICameraError Shows  the possible error during the execution. If there is no error, it returns null</code>.  @return `DJICameraError` shows the possible error during the execution. If there is no error, it returns null.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_deleteAllSelectedFiles_inline",
                   "",
            ],
            [
                   "downloadSelectedFiles",
                   2,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_downloadSelectedFiles_inline",
                   "Downloads the currently selected media files.  Precondition:  The camera must enter multiple preview mode.  @param destDir The destination file directory, e.g., SDCardPath/folder/ @param callback The execution callback.",
            ],
            [
                   "Downloads the currently selected media files.  Precondition:  The camera must enter multiple preview mode.  @param destDir The destination file directory, e.g., SDCardPath/folder/ @param callback The execution callback.",
                   1,
                   "/Components/Camera/DJIPlaybackManager.html",
                   "#DJIPlaybackManager_downloadSelectedFiles_inline",
                   "",
            ],
            [
                   "FileDownloadCallback",
                   2,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "",
                   "This callback will notify the process of downloading selected files.",
            ],
            [
                   "This callback will notify the process of downloading selected files.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "PlaybackState",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "",
                   "This class provides the current state of the Playback manager, which includes the numbers of thumbnail and media files, video duration, video play progress, and file download state.",
            ],
            [
                   "This class provides the current state of the Playback manager, which includes the numbers of thumbnail and media files, video duration, video play progress, and file download state.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlayBackStateCallBackInterface.html",
                   "#DJIPlaybackManager_UpdatePlaybackState_inline",
                   "Updates the playback state of the camera. This update method will only be called when the camera's work mode is  set to `PLAYBACK`.  @param state Contains the state information when the camera in the playback state, such as numbers of photos in the SD card, numbers of videos in the SD card and the media file type.",
            ],
            [
                   "Updates the playback state of the camera. This update method will only be called when the camera's work mode is  set to `PLAYBACK`.  @param state Contains the state information when the camera in the playback state, such as numbers of photos in the SD card, numbers of videos in the SD card and the media file type.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlayBackStateCallBackInterface.html",
                   "#DJIPlaybackManager_UpdatePlaybackState_inline",
                   "",
            ],
            [
                   "onStart",
                   2,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnStart_inline",
                   "Called as a file is about to start downloading.",
            ],
            [
                   "Called as a file is about to start downloading.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnStart_inline",
                   "",
            ],
            [
                   "onEnd",
                   2,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnEnd_inline",
                   "Called when a file has completed downloading.",
            ],
            [
                   "Called when a file has completed downloading.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnEnd_inline",
                   "",
            ],
            [
                   "onError",
                   2,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnError_inline",
                   "Called when there is an error during download.  @param exception The error exception.",
            ],
            [
                   "Called when there is an error during download.  @param exception The error exception.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnError_inline",
                   "",
            ],
            [
                   "onProgressUpdate",
                   2,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnProgressUpdate_inline",
                   "Called to update the progress on downloading a file in percent. Range is [0, 100].  @param progress The progress of downloading.",
            ],
            [
                   "Called to update the progress on downloading a file in percent. Range is [0, 100].  @param progress The progress of downloading.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_CameraFileDownloadCallbackInterface.html",
                   "#DJIPlaybackManager_CameraFileDownloadOnProgressUpdate_inline",
                   "",
            ],
            [
                   "getPlaybackMode",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_playbackMode_inline",
                   "The current mode of the Playback manager.  @return Playback manager current mode.",
            ],
            [
                   "The current mode of the Playback manager.  @return Playback manager current mode.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_playbackMode_inline",
                   "",
            ],
            [
                   "getNumberOfMediaFiles",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfMediaFiles_inline",
                   "The total number of media files on the SD card, including photos and videos.  @return Number of media files.",
            ],
            [
                   "The total number of media files on the SD card, including photos and videos.  @return Number of media files.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfMediaFiles_inline",
                   "",
            ],
            [
                   "getNumberOfThumbnails",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfThumbnails_inline",
                   "The total number of thumbnails for both the photos and videos being viewed on the page. The value of the property  is valid when the `PlaybackMode`  is `MULTIPLE_MEDIA_FILE_PREVIEW` .  @return Number of thumbnails.",
            ],
            [
                   "The total number of thumbnails for both the photos and videos being viewed on the page. The value of the property  is valid when the `PlaybackMode`  is `MULTIPLE_MEDIA_FILE_PREVIEW` .  @return Number of thumbnails.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfThumbnails_inline",
                   "",
            ],
            [
                   "getPhotoCount",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfPhotos_inline",
                   "The total number of photos on the SD card.  @return Number of photos.",
            ],
            [
                   "The total number of photos on the SD card.  @return Number of photos.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfPhotos_inline",
                   "",
            ],
            [
                   "getVideoCount",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfVideos_inline",
                   "The total number of videos on the SD card.  @return Number of videos.",
            ],
            [
                   "The total number of videos on the SD card.  @return Number of videos.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfVideos_inline",
                   "",
            ],
            [
                   "getFileType",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_mediaFileType_inline",
                   "The type of the current file. The CameraMediaFileType includes  types of JPEG, DNG and Video.  The value of this property is valid when the playbackMode  is `SINGLE_PHOTO_PREVIEW`, `SINGLE_VIDEO_PLAYBACK_START` .  @return Media file type.",
            ],
            [
                   "The type of the current file. The CameraMediaFileType includes  types of JPEG, DNG and Video.  The value of this property is valid when the playbackMode  is `SINGLE_PHOTO_PREVIEW`, `SINGLE_VIDEO_PLAYBACK_START` .  @return Media file type.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_mediaFileType_inline",
                   "",
            ],
            [
                   "getVideoDuration",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoDuration_inline",
                   "The duration in second of the playing video. The value of the property is valid only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START`  .  @return Duration of video.",
            ],
            [
                   "The duration in second of the playing video. The value of the property is valid only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START`  .  @return Duration of video.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoDuration_inline",
                   "",
            ],
            [
                   "getVideoPlayProgress",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoPlayProgress_inline",
                   "The progress, in percentage, of the playing video. The valid range is [0, 100]. The value the property is valid  only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START`  .  @return Percentage progress of view playback.",
            ],
            [
                   "The progress, in percentage, of the playing video. The valid range is [0, 100]. The value the property is valid  only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START`  .  @return Percentage progress of view playback.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoPlayProgress_inline",
                   "",
            ],
            [
                   "getVideoPlayPosition",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoPlayPosition_inline",
                   "The played duration, in seconds, of the playing video. The value the property is valid only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START` .  @return Current play position of video.",
            ],
            [
                   "The played duration, in seconds, of the playing video. The value the property is valid only when `PlaybackMode`  is `SINGLE_VIDEO_PLAYBACK_START` .  @return Current play position of video.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_videoPlayPosition_inline",
                   "",
            ],
            [
                   "getPhotoWidth",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_photoWidth_inline",
                   "The width of the photo.  @return Width of photo.",
            ],
            [
                   "The width of the photo.  @return Width of photo.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_photoWidth_inline",
                   "",
            ],
            [
                   "getPhotoHeight",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_photoHeight_inline",
                   "The dimension of the previewing photo. The value of the property is valid only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`  and `getFileType`  is `JPEG`.  @return Height of photo.",
            ],
            [
                   "The dimension of the previewing photo. The value of the property is valid only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`  and `getFileType`  is `JPEG`.  @return Height of photo.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_photoHeight_inline",
                   "",
            ],
            [
                   "getCurrentSelectedFileIndex",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_currentSelectedFileIndex_inline",
                   "The index of the current selected file.  @return Index of selected file.",
            ],
            [
                   "The index of the current selected file.  @return Index of selected file.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_currentSelectedFileIndex_inline",
                   "",
            ],
            [
                   "getSelectedFileCount",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfSelectedFiles_inline",
                   "The total number of the selected files. The value is valid while `PlaybackMode` is in DJICameraPlaybackModeMultipleFilesEdit</code>.  @return Number of selected files.",
            ],
            [
                   "The total number of the selected files. The value is valid while `PlaybackMode` is in DJICameraPlaybackModeMultipleFilesEdit</code>.  @return Number of selected files.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_numberOfSelectedFiles_inline",
                   "",
            ],
            [
                   "areAllFilesInPageSelected",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isAllFilesInPageSelected_inline",
                   "`true` if all the files on the current page are selected.  @return Response of all files being selected on page.",
            ],
            [
                   "`true` if all the files on the current page are selected.  @return Response of all files being selected on page.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isAllFilesInPageSelected_inline",
                   "",
            ],
            [
                   "isSelectedFileValid",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isSelectedFileValid_inline",
                   "`true` if the previewing file is a valid photo or video. The value of the property is valid  only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`.  @return If file being previewed is a valid photo or video file.",
            ],
            [
                   "`true` if the previewing file is a valid photo or video. The value of the property is valid  only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`.  @return If file being previewed is a valid photo or video file.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isSelectedFileValid_inline",
                   "",
            ],
            [
                   "getPlaybackDeletionState",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_fileDeleteStatus_inline",
                   "The current status of a file when the user tries to delete it.  @return Status of file being deleted.",
            ],
            [
                   "The current status of a file when the user tries to delete it.  @return Status of file being deleted.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_fileDeleteStatus_inline",
                   "",
            ],
            [
                   "isFileDownloaded",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isFileDownloaded_inline",
                   "`true` if the previewing file has been downloaded. The value of the property is valid only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`.  @return `true` if the previewing file has been downloaded.",
            ],
            [
                   "`true` if the previewing file has been downloaded. The value of the property is valid only when `PlaybackMode`  is `SINGLE_PHOTO_PREVIEW`.  @return `true` if the previewing file has been downloaded.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_isFileDownloaded_inline",
                   "",
            ],
            [
                   "toString",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_toString_inline",
                   "Gets a string containing information about the playback state. @return A String of playback state.  @return A String instance of playback state.",
            ],
            [
                   "Gets a string containing information about the playback state. @return A String of playback state.  @return A String instance of playback state.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_toString_inline",
                   "",
            ],
            [
                   "CallBack",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlayBackStateCallBackInterface.html",
                   "",
                   "The interface provides the method to receive the updated state of the playback manager.",
            ],
            [
                   "The interface provides the method to receive the updated state of the playback manager.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlayBackStateCallBackInterface.html",
                   "",
                   "",
            ],
            [
                   "FileType",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_inline",
                   "Showing media file types when the camera is in Playback mode.",
            ],
            [
                   "Showing media file types when the camera is in Playback mode.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_inline",
                   "",
            ],
            [
                   "PlaybackMode",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_inline",
                   "A playback mode represents a task that the Playback manager is executing.",
            ],
            [
                   "A playback mode represents a task that the Playback manager is executing.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_inline",
                   "",
            ],
            [
                   "PlaybackDeletionState",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_inline",
                   "The file deletion status when deleting a file as the camera is in playback mode.",
            ],
            [
                   "The file deletion status when deleting a file as the camera is in playback mode.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_inline",
                   "",
            ],
            [
                   "JPEG",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_JPEG_inline",
                   "The JPEG media file type.",
            ],
            [
                   "The JPEG media file type.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_JPEG_inline",
                   "",
            ],
            [
                   "DNG",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_RAWDNG_inline",
                   "The DNG media file type.",
            ],
            [
                   "The DNG media file type.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_RAWDNG_inline",
                   "",
            ],
            [
                   "VIDEO",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_VIDEO_inline",
                   "The Video media file type.",
            ],
            [
                   "The Video media file type.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_VIDEO_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_Unknown_inline",
                   "The playback file format is unknown.",
            ],
            [
                   "The playback file format is unknown.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackFileFormat_Unknown_inline",
                   "",
            ],
            [
                   "SINGLE_PHOTO_PREVIEW",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleFilePreview_inline",
                   "Single file preview mode.",
            ],
            [
                   "Single file preview mode.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleFilePreview_inline",
                   "",
            ],
            [
                   "SINGLE_VIDEO_PLAYBACK_START",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleVideoPlaybackStart_inline",
                   "Single video playback start.",
            ],
            [
                   "Single video playback start.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleVideoPlaybackStart_inline",
                   "",
            ],
            [
                   "SINGLE_VIDEO_PLAYBACK_PAUSED",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleVideoPlaybackPause_inline",
                   "Single video playback pause.",
            ],
            [
                   "Single video playback pause.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_SingleVideoPlaybackPause_inline",
                   "",
            ],
            [
                   "MULTIPLE_FILES_EDIT",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_MultipleFilesEdit_inline",
                   "Multiple file edit.",
            ],
            [
                   "Multiple file edit.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_MultipleFilesEdit_inline",
                   "",
            ],
            [
                   "MULTIPLE_MEDIA_FILE_PREVIEW",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_MultipleFilesPreview_inline",
                   "Multiple media file preview.",
            ],
            [
                   "Multiple media file preview.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_MultipleFilesPreview_inline",
                   "",
            ],
            [
                   "MEDIA_FILE_DOWNLOAD",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_Download_inline",
                   "Download media files.",
            ],
            [
                   "Download media files.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_Download_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_Unknown_inline",
                   "Unknown playback mode.",
            ],
            [
                   "Unknown playback mode.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackMode_Unknown_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_None_inline",
                   "Camera is not deleting files.",
            ],
            [
                   "Camera is not deleting files.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_None_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Failure_inline",
                   "Media file delete failed.",
            ],
            [
                   "Media file delete failed.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Failure_inline",
                   "",
            ],
            [
                   "DELETING",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Deleting_inline",
                   "Media file is deleting.",
            ],
            [
                   "Media file is deleting.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Deleting_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Success_inline",
                   "Delete Media file successfully.",
            ],
            [
                   "Delete Media file successfully.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Success_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Unknown_inline",
                   "Media file unknown delete status.",
            ],
            [
                   "Media file unknown delete status.",
                   1,
                   "/Components/Camera/DJIPlaybackManager_DJICameraPlaybackState.html",
                   "#DJIPlaybackManager_DJICameraPlaybackState_DJICameraPlaybackDeletionStatus_Unknown_inline",
                   "",
            ],
            [
                   "setVisionDetectionStateUpdatedCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionDetectionStateUpdatedCallback_inline",
                   "Set intelligent flight assistant state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set intelligent flight assistant state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionDetectionStateUpdatedCallback_inline",
                   "",
            ],
            [
                   "setVisionControlStateUpdatedcallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_UpdateVisionControlStateCallback_inline",
                   "Callback function that updates aircraft state. Controlled by the intelligent flight assistant.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Callback function that updates aircraft state. Controlled by the intelligent flight assistant.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_UpdateVisionControlStateCallback_inline",
                   "",
            ],
            [
                   "setFaceAwareStateCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setFaceAwareStateCallback_inline",
                   "Starts to receive the update of FaceAwareState.  @param callback FaceAwareState update callback.",
            ],
            [
                   "Starts to receive the update of FaceAwareState.  @param callback FaceAwareState update callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setFaceAwareStateCallback_inline",
                   "",
            ],
            [
                   "setPalmControlStateCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPalmControlStateCallback_inline",
                   "Starts to receive the update of PalmControlState.  @param callback PalmControlState update callback.",
            ],
            [
                   "Starts to receive the update of PalmControlState.  @param callback PalmControlState update callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPalmControlStateCallback_inline",
                   "",
            ],
            [
                   "setSmartCaptureStateCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureStateCallback_inline",
                   "Starts to receive the update of SmartCaptureState.  @param callback SmartCaptureState update callback.",
            ],
            [
                   "Starts to receive the update of SmartCaptureState.  @param callback SmartCaptureState update callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureStateCallback_inline",
                   "",
            ],
            [
                   "setVisualPerceptionInformationCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisualPerceptionInformationCallback_inline",
                   "Updates the visual perception information. Only supported by Matrice 300 RTK, Mavic Air 2, DJI Air 2S.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Updates the visual perception information. Only supported by Matrice 300 RTK, Mavic Air 2, DJI Air 2S.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisualPerceptionInformationCallback_inline",
                   "",
            ],
            [
                   "setToFPerceptionInformationCallback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setToFPerceptionInformationCallback_inline",
                   "Updates the TOF perception information. Only supported by Matrice 300 RTK, Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Updates the TOF perception information. Only supported by Matrice 300 RTK, Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setToFPerceptionInformationCallback_inline",
                   "",
            ],
            [
                   "setObstacleAvoidanceSensorStateListener",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setObstacleAvoidanceSensorStateListener_inline",
                   "Updates the obstacle avoidance sensor's state.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Updates the obstacle avoidance sensor's state.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setObstacleAvoidanceSensorStateListener_inline",
                   "",
            ],
            [
                   "setCollisionAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setCollisionAvoidanceEnabled_inline",
                   "Enable collision avoidance. When enabled, the aircraft will stop and try to go around detected obstacles.  @param enable A boolean value. @param callback Completion callback.",
            ],
            [
                   "Enable collision avoidance. When enabled, the aircraft will stop and try to go around detected obstacles.  @param enable A boolean value. @param callback Completion callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setCollisionAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "COLLISION_AVOIDANCE_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setCollisionAvoidanceEnabled_inline",
                   "SDK Key for setCollisionAvoidanceEnabled: Enable collision avoidance. When enabled, the aircraft will stop and try to go around detected obstacles.  @param enable A boolean value. @param callback Completion callback.",
            ],
            [
                   "SDK Key for setCollisionAvoidanceEnabled: Enable collision avoidance. When enabled, the aircraft will stop and try to go around detected obstacles.  @param enable A boolean value. @param callback Completion callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setCollisionAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getCollisionAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getCollisionAvoidanceEnabled_inline",
                   "Gets collision avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets collision avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getCollisionAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "COLLISION_AVOIDANCE_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getCollisionAvoidanceEnabled_inline",
                   "SDK Key for getCollisionAvoidanceEnabled: Gets collision avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getCollisionAvoidanceEnabled: Gets collision avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getCollisionAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setActiveObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setActiveObstacleAvoidanceEnabled_inline",
                   "Enables/disables active obstacle avoidance. When enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. If while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setCollisionAvoidanceEnabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "Enables/disables active obstacle avoidance. When enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. If while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setCollisionAvoidanceEnabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setActiveObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "ACTIVE_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setActiveObstacleAvoidanceEnabled_inline",
                   "SDK Key for setActiveObstacleAvoidanceEnabled: Enables/disables active obstacle avoidance. When enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. If while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setCollisionAvoidanceEnabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "SDK Key for setActiveObstacleAvoidanceEnabled: Enables/disables active obstacle avoidance. When enabled, and an obstacle is moving toward the aircraft, the aircraft will actively fly away from it. If while actively avoiding a moving obstacle, the aircraft detects another obstacle in its avoidance path, it will stop. `setCollisionAvoidanceEnabled` must also be enabled.  @param enabled `true` to enable the active avoidance. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setActiveObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getActiveObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getActiveObstacleAvoidanceEnabled_inline",
                   "Gets active obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets active obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getActiveObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "ACTIVE_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getActiveObstacleAvoidanceEnabled_inline",
                   "SDK Key for getActiveObstacleAvoidanceEnabled: Gets active obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getActiveObstacleAvoidanceEnabled: Gets active obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getActiveObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setUpwardVisionObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardVisionObstacleAvoidanceEnabled_inline",
                   "Enables/disables upward avoidance. When the Inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. The sensor has a 10-degree horizontal field of view (FOV) and 10-degree vertical FOV. The maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "Enables/disables upward avoidance. When the Inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. The sensor has a 10-degree horizontal field of view (FOV) and 10-degree vertical FOV. The maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardVisionObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "UPWARDS_AVOIDANCE_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardVisionObstacleAvoidanceEnabled_inline",
                   "SDK Key for setUpwardVisionObstacleAvoidanceEnabled: Enables/disables upward avoidance. When the Inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. The sensor has a 10-degree horizontal field of view (FOV) and 10-degree vertical FOV. The maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "SDK Key for setUpwardVisionObstacleAvoidanceEnabled: Enables/disables upward avoidance. When the Inspire 2's upwards-facing infrared sensor detects an obstacle, the aircraft will slow its ascent and maintain a minimum distance of 1 meter from the obstacle. The sensor has a 10-degree horizontal field of view (FOV) and 10-degree vertical FOV. The maximum detection distance is 5m.  @param enabled `true` to enable the upwards avoidance. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardVisionObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getUpwardVisionObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getUpwardVisionObstacleAvoidanceEnabled_inline",
                   "Gets upward avoidance status (enabled/disabled). It is only supported by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets upward avoidance status (enabled/disabled). It is only supported by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getUpwardVisionObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setAdvancedGestureControlEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setAdvancedGestureControlEnabled_inline",
                   "Enables/disables advanced gesture control. When enabled, users can use PalmLaunch, PalmLand, PalmControl and Beckon. When enabled, the various modes can be initiated by the user. In summary:  - Aircraft starts idle on users hand  - User double clicks the power button and FaceAware becomes active  - Once a face is recogized, PalmLaunch will happen  - When flying, the user can control the aircraft position by moving their palm  - If the user waves one hand, the aircraft will fly up and backwards and start following the user.  - If the user waves both hands, the aircraft will execute Beckon and return to the user.  It is only supported by Spark.  @param enabled `true` to enable advanced gesture control. @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Enables/disables advanced gesture control. When enabled, users can use PalmLaunch, PalmLand, PalmControl and Beckon. When enabled, the various modes can be initiated by the user. In summary:  - Aircraft starts idle on users hand  - User double clicks the power button and FaceAware becomes active  - Once a face is recogized, PalmLaunch will happen  - When flying, the user can control the aircraft position by moving their palm  - If the user waves one hand, the aircraft will fly up and backwards and start following the user.  - If the user waves both hands, the aircraft will execute Beckon and return to the user.  It is only supported by Spark.  @param enabled `true` to enable advanced gesture control. @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setAdvancedGestureControlEnabled_inline",
                   "",
            ],
            [
                   "getAdvancedGestureControlEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getAdvancedGestureControlEnabled_inline",
                   "Determines whether advanced gesture control is enabled. When enabled, users can use PalmLaunch, PalmLand, PalmControl and Beckon. It is only supported by Spark.  @param callback The `completion callback` with the returned execution result.",
            ],
            [
                   "Determines whether advanced gesture control is enabled. When enabled, users can use PalmLaunch, PalmLand, PalmControl and Beckon. It is only supported by Spark.  @param callback The `completion callback` with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getAdvancedGestureControlEnabled_inline",
                   "",
            ],
            [
                   "isSmartCaptureSupported",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_isSmartCaptureSupported_inline",
                   "Determines if SmartCapture is supported. This feature is only supported by Mavic Air.  @return `true` if Smart Capture is supported.",
            ],
            [
                   "Determines if SmartCapture is supported. This feature is only supported by Mavic Air.  @return `true` if Smart Capture is supported.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_isSmartCaptureSupported_inline",
                   "",
            ],
            [
                   "setSmartCaptureEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureEnabled_inline",
                   "Enables/disables SmartCapture. When enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (GestureLaunch, Follow and GestureLand) using simple hand gestures. It is only supported when `isSmartCaptureSupported` returns `true`.  @param enabled `true` to enable SmartCapture. @param callback Completion block with the returned execution result.",
            ],
            [
                   "Enables/disables SmartCapture. When enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (GestureLaunch, Follow and GestureLand) using simple hand gestures. It is only supported when `isSmartCaptureSupported` returns `true`.  @param enabled `true` to enable SmartCapture. @param callback Completion block with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureEnabled_inline",
                   "",
            ],
            [
                   "getSmartCaptureEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getSmartCaptureEnabled_inline",
                   "Determines whether SmartCapture is enabled. When enabled, users can When enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (GestureLaunch, Follow and GestureLand) using simple hand gestures. It is only supported when `isSmartCaptureSupported` returns `true`.  @param callback Completion block with the returned execution result.",
            ],
            [
                   "Determines whether SmartCapture is enabled. When enabled, users can When enabled, deep learning gesture recognition allows the user to take selfies, record videos, and control the aircraft (GestureLaunch, Follow and GestureLand) using simple hand gestures. It is only supported when `isSmartCaptureSupported` returns `true`.  @param callback Completion block with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getSmartCaptureEnabled_inline",
                   "",
            ],
            [
                   "setSmartCaptureFollowingMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureFollowingMode_inline",
                   "Sets the following mode for SmartCapture. It is only valid when SmartCapture is enabled.  @param mode The following mode to set. @param callback Completion block with the returned execution result.",
            ],
            [
                   "Sets the following mode for SmartCapture. It is only valid when SmartCapture is enabled.  @param mode The following mode to set. @param callback Completion block with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setSmartCaptureFollowingMode_inline",
                   "",
            ],
            [
                   "getSmartCaptureFollowingMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getSmartCaptureFollowingMode_inline",
                   "Gets the following mode for SmartCapture. It is only valid when SmartCapture is enabled.  @param callback Completion block with the returned execution result.",
            ],
            [
                   "Gets the following mode for SmartCapture. It is only valid when SmartCapture is enabled.  @param callback Completion block with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getSmartCaptureFollowingMode_inline",
                   "",
            ],
            [
                   "setAdvancedPilotAssistanceSystemEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setAdvancedPilotAssistanceSystemEnabled_inline",
                   "Enables the Advanced Pilot Assistance System (APAS). When APAS is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. APAS makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. It is only valid when the aircraft is in P-mode. It is only supported by Mavic Air, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Enterprise.  @param enabled `true` to enable APAS. @param callback The completion callback with the returned execution result.",
            ],
            [
                   "Enables the Advanced Pilot Assistance System (APAS). When APAS is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. APAS makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. It is only valid when the aircraft is in P-mode. It is only supported by Mavic Air, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Enterprise.  @param enabled `true` to enable APAS. @param callback The completion callback with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setAdvancedPilotAssistanceSystemEnabled_inline",
                   "",
            ],
            [
                   "getAdvancedPilotAssistanceSystemEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getAdvancedPilotAssistanceSystemEnabled_inline",
                   "Determines whether the Advanced Pilot Assistance System (APAS) is enabled or not. When APAS is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. APAS makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. It It is only supported by Mavic Air, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Enterprise.  @param callback The completion callback with the returned execution result.",
            ],
            [
                   "Determines whether the Advanced Pilot Assistance System (APAS) is enabled or not. When APAS is enabled, the aircraft continues to respond to user commands and plans its path according to both control stick inputs and the flight environment. APAS makes it easier to avoid obstacles and obtain smoother footage, and gives a better fly experiences. It It is only supported by Mavic Air, Mavic 2 Pro, Mavic 2 Zoom, Mavic 2 Enterprise.  @param callback The completion callback with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getAdvancedPilotAssistanceSystemEnabled_inline",
                   "",
            ],
            [
                   "setForbidSideFlyEnable",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setForbidSideFlyEnable_inline",
                   "Enables/Disabled the Forbid Side Fly Switch. In APAS mode when the Forbid Side Fly Switch is turned on, the aircraft cannot fly sideways. Supported by DJI Air 2S.  @param enabled `true` to enable forbid side fly. @param callback The completion callback with the returned execution result.",
            ],
            [
                   "Enables/Disabled the Forbid Side Fly Switch. In APAS mode when the Forbid Side Fly Switch is turned on, the aircraft cannot fly sideways. Supported by DJI Air 2S.  @param enabled `true` to enable forbid side fly. @param callback The completion callback with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setForbidSideFlyEnable_inline",
                   "",
            ],
            [
                   "getForbidSideFlyEnable",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getForbidSideFlyEnable_inline",
                   "Determines whether the Forbid Side Fly Switch is enabled or not.  @param callback The completion callback with the returned execution result.",
            ],
            [
                   "Determines whether the Forbid Side Fly Switch is enabled or not.  @param callback The completion callback with the returned execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getForbidSideFlyEnable_inline",
                   "",
            ],
            [
                   "setRTHObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setRTHObstacleAvoidanceEnabled_inline",
                   "Enables Obstacle Avoidance during RTH. This is only active when the environment is bright enough. It is not active when the aircraft is landing. CAUTION: If RTH Obstacle Avoidance is disabled, aircraft will not check obstacles during RTH or ascend to avoid obstacles, which may cause great risks.  @param enabled `true` to enable Obstacle Avoidance during RTH. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "Enables Obstacle Avoidance during RTH. This is only active when the environment is bright enough. It is not active when the aircraft is landing. CAUTION: If RTH Obstacle Avoidance is disabled, aircraft will not check obstacles during RTH or ascend to avoid obstacles, which may cause great risks.  @param enabled `true` to enable Obstacle Avoidance during RTH. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setRTHObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getRTHObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getRTHObstacleAvoidanceEnabled_inline",
                   "Determines if Obstacle Avoidance is enabled during RTH. This is only active when the environment is bright enough. It is not active when the aircraft is landing. CAUTION: If RTH Obstacle Avoidance is disabled, aircraft will not check obstacles during RTH or ascend to avoid obstacles, which may cause great risks.  @param callback Completion callback with the returned value(s).",
            ],
            [
                   "Determines if Obstacle Avoidance is enabled during RTH. This is only active when the environment is bright enough. It is not active when the aircraft is landing. CAUTION: If RTH Obstacle Avoidance is disabled, aircraft will not check obstacles during RTH or ascend to avoid obstacles, which may cause great risks.  @param callback Completion callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getRTHObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setRTHRemoteObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setRTHRemoteObstacleAvoidanceEnabled_inline",
                   "Enables Remote Obstacle Avoidance during RTH. Enabling this, the aircraft will adjust its RTH route automatically to avoid obstacles in far distance. The gimbal will not respond to any commands from the application or the remote controller.  @param enabled `true` to enable Remote Obstacle Avoidance during RTH. @param callback Completion callback that receives the setter result.",
            ],
            [
                   "Enables Remote Obstacle Avoidance during RTH. Enabling this, the aircraft will adjust its RTH route automatically to avoid obstacles in far distance. The gimbal will not respond to any commands from the application or the remote controller.  @param enabled `true` to enable Remote Obstacle Avoidance during RTH. @param callback Completion callback that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setRTHRemoteObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getRTHRemoteObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getRTHRemoteObstacleAvoidanceEnabled_inline",
                   "Determines if RTH Remote Obstacle Avoidance is enabled or not. When it is enabled, the aircraft will adjust its RTH route automatically to avoid obstacles in far distance. The gimbal will not respond to any commands from the application or the remote controller.  @param callback Completion callback with the returned value(s).",
            ],
            [
                   "Determines if RTH Remote Obstacle Avoidance is enabled or not. When it is enabled, the aircraft will adjust its RTH route automatically to avoid obstacles in far distance. The gimbal will not respond to any commands from the application or the remote controller.  @param callback Completion callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getRTHRemoteObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setDownwardFillLightMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setDownwardFillLightMode_inline",
                   "Sets the downward fill light mode. It is supported by Mavic 2 series and Matrice 300 RTK.  @param mode See enum `FillLightMode`. @param callback Completion block to receive the result.",
            ],
            [
                   "Sets the downward fill light mode. It is supported by Mavic 2 series and Matrice 300 RTK.  @param mode See enum `FillLightMode`. @param callback Completion block to receive the result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setDownwardFillLightMode_inline",
                   "",
            ],
            [
                   "getDownwardFillLightMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getDownwardFillLightMode_inline",
                   "Gets the downward fill light mode. It is supported by Mavic 2 series and Matrice 300 RTK.  @param callback Completion block to receive the result.",
            ],
            [
                   "Gets the downward fill light mode. It is supported by Mavic 2 series and Matrice 300 RTK.  @param callback Completion block to receive the result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getDownwardFillLightMode_inline",
                   "",
            ],
            [
                   "setUpwardFillLightMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardFillLightMode_inline",
                   "Sets the upward fill light mode. It is only supported by Matrice 300 RTK. The distance range for `Horizontal` is 1m~5m. The distance range for `Upward` is 1m~10m. The distance range for `Downward` is 1dm~30dm.  @param mode See enum `FillLightMode`. @param callback Completion block to receive the result.",
            ],
            [
                   "Sets the upward fill light mode. It is only supported by Matrice 300 RTK. The distance range for `Horizontal` is 1m~5m. The distance range for `Upward` is 1m~10m. The distance range for `Downward` is 1dm~30dm.  @param mode See enum `FillLightMode`. @param callback Completion block to receive the result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setUpwardFillLightMode_inline",
                   "",
            ],
            [
                   "getUpwardFillLightMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getUpwardFillLightMode_inline",
                   "Gets upward fill light mode. It is only supported by Matrice 300 RTK.  @param callback Completion block to receive the result.",
            ],
            [
                   "Gets upward fill light mode. It is only supported by Matrice 300 RTK.  @param callback Completion block to receive the result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getUpwardFillLightMode_inline",
                   "",
            ],
            [
                   "setMaxPerceptionDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setMaxPerceptionDistance_inline",
                   "Sets the maximum perception distance that could be measured. It is supported only by Matrice 300 RTK. The distance range is 5m~45m for all direction.  @param distance The maximum perception distance that could be measured. @param direction The perception direction.",
            ],
            [
                   "Sets the maximum perception distance that could be measured. It is supported only by Matrice 300 RTK. The distance range is 5m~45m for all direction.  @param distance The maximum perception distance that could be measured. @param direction The perception direction.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setMaxPerceptionDistance_inline",
                   "",
            ],
            [
                   "getMaxPerceptionDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getMaxPerceptionDistanceOnDirection_inline",
                   "Gets the maximum perception distance that could be measured. It is supported only by Matrice 300 RTK.  @param direction The maximum perception distance that could be measured. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets the maximum perception distance that could be measured. It is supported only by Matrice 300 RTK.  @param direction The maximum perception distance that could be measured. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getMaxPerceptionDistanceOnDirection_inline",
                   "",
            ],
            [
                   "setHorizontalVisionObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setHorizontalVisionObstacleAvoidanceEnabled_inline",
                   "Set to enable or disable horizontal vision obstacle avoidance. It is supported only by Matrice 300 RTK.  @param enabled `true` to enable horizontal vision obstacle avoidance. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Set to enable or disable horizontal vision obstacle avoidance. It is supported only by Matrice 300 RTK.  @param enabled `true` to enable horizontal vision obstacle avoidance. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setHorizontalVisionObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getHorizontalVisionObstacleAvoidanceEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getHorizontalVisionObstacleAvoidanceEnabled_inline",
                   "Gets horizontal vision obstacle avoidance (enabled/disabled). It is supported only by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets horizontal vision obstacle avoidance (enabled/disabled). It is supported only by Matrice 300 RTK.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getHorizontalVisionObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setVisualObstaclesAvoidanceDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisualObstaclesAvoidanceDistance_inline",
                   "Sets the distance to engage Active Brake for obstacles avoidance.  @param distance The distance to engage Active Brake. @param direction The perception direction. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Downward`, the distance range is [0.1, 3], For Matrice 300 RTK the range is [0.4, 3]. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Upward`, the distance range is [1.0, 10]. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Horizontal`, the distance range is [1.0, 5]. @param callback Completion block to receive the result.",
            ],
            [
                   "Sets the distance to engage Active Brake for obstacles avoidance.  @param distance The distance to engage Active Brake. @param direction The perception direction. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Downward`, the distance range is [0.1, 3], For Matrice 300 RTK the range is [0.4, 3]. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Upward`, the distance range is [1.0, 10]. If is `DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Horizontal`, the distance range is [1.0, 5]. @param callback Completion block to receive the result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisualObstaclesAvoidanceDistance_inline",
                   "",
            ],
            [
                   "getVisualObstaclesAvoidanceDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisualObstaclesAvoidanceDistance_inline",
                   "Gets current distance to engage Active Brake for obstacles avoidance.  @param direction The perception direction. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets current distance to engage Active Brake for obstacles avoidance.  @param direction The perception direction. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisualObstaclesAvoidanceDistance_inline",
                   "",
            ],
            [
                   "setVisionAssistedPositioningEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionPositioningEnabled_inline",
                   "Enable vision positioning. Vision positioning is used to augment GPS to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback Completion callback.",
            ],
            [
                   "Enable vision positioning. Vision positioning is used to augment GPS to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback Completion callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionPositioningEnabled_inline",
                   "",
            ],
            [
                   "VISION_ASSISTED_POSITIONING_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionPositioningEnabled_inline",
                   "SDK Key for setVisionAssistedPositioningEnabled: Enable vision positioning. Vision positioning is used to augment GPS to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback Completion callback.",
            ],
            [
                   "SDK Key for setVisionAssistedPositioningEnabled: Enable vision positioning. Vision positioning is used to augment GPS to improve location accuracy when hovering and improve velocity calculation when flying.  @param enabled `true` to enable vision assisted positioning. @param callback Completion callback.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setVisionPositioningEnabled_inline",
                   "",
            ],
            [
                   "getVisionAssistedPositioningEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisionPositioningEnabled_inline",
                   "Gets vision positioning status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets vision positioning status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisionPositioningEnabled_inline",
                   "",
            ],
            [
                   "VISION_ASSISTED_POSITIONING_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisionPositioningEnabled_inline",
                   "SDK Key for getVisionAssistedPositioningEnabled: Gets vision positioning status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getVisionAssistedPositioningEnabled: Gets vision positioning status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getVisionPositioningEnabled_inline",
                   "",
            ],
            [
                   "setPrecisionLandingEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPrecisionLandingEnabled_inline",
                   "Enables/disables precision landing. When enabled, the aircraft will record its take-off location visually (as well as with GPS). On a Return-To-Home action the aircraft will attempt to perform a precision landing using the additional visual information. This method only works on a Return-To-Home action when the home location is successfully recorded during take-off, and not changed during flight, It will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
            ],
            [
                   "Enables/disables precision landing. When enabled, the aircraft will record its take-off location visually (as well as with GPS). On a Return-To-Home action the aircraft will attempt to perform a precision landing using the additional visual information. This method only works on a Return-To-Home action when the home location is successfully recorded during take-off, and not changed during flight, It will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPrecisionLandingEnabled_inline",
                   "",
            ],
            [
                   "PRECISION_LANDING_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPrecisionLandingEnabled_inline",
                   "SDK Key for setPrecisionLandingEnabled: Enables/disables precision landing. When enabled, the aircraft will record its take-off location visually (as well as with GPS). On a Return-To-Home action the aircraft will attempt to perform a precision landing using the additional visual information. This method only works on a Return-To-Home action when the home location is successfully recorded during take-off, and not changed during flight, It will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
            ],
            [
                   "SDK Key for setPrecisionLandingEnabled: Enables/disables precision landing. When enabled, the aircraft will record its take-off location visually (as well as with GPS). On a Return-To-Home action the aircraft will attempt to perform a precision landing using the additional visual information. This method only works on a Return-To-Home action when the home location is successfully recorded during take-off, and not changed during flight, It will take effect only after flying 10 meters high at the return point.  @param enabled `true` to enable the precise landing. @param callback callback block that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setPrecisionLandingEnabled_inline",
                   "",
            ],
            [
                   "getPrecisionLandingEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getPrecisionLandingEnabled_inline",
                   "Gets precision landing status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets precision landing status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getPrecisionLandingEnabled_inline",
                   "",
            ],
            [
                   "PRECISION_LANDING_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getPrecisionLandingEnabled_inline",
                   "SDK Key for getPrecisionLandingEnabled: Gets precision landing status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPrecisionLandingEnabled: Gets precision landing status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getPrecisionLandingEnabled_inline",
                   "",
            ],
            [
                   "setLandingProtectionEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setLandingProtectionEnabled_inline",
                   "Enables/disables landing protection. During auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. If it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:Callback> that receives the setter result.",
            ],
            [
                   "Enables/disables landing protection. During auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. If it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:Callback> that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setLandingProtectionEnabled_inline",
                   "",
            ],
            [
                   "LANDING_PROTECTION_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setLandingProtectionEnabled_inline",
                   "SDK Key for setLandingProtectionEnabled: Enables/disables landing protection. During auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. If it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:Callback> that receives the setter result.",
            ],
            [
                   "SDK Key for setLandingProtectionEnabled: Enables/disables landing protection. During auto-landing, the downwards facing vision sensor will check if the ground surface is flat enough for a safe landing. If it is not and landing protection is enabled, then landing will abort and need to be manually performed by the user.  @param enabled `true` to enable the landing protection. @param callback <<>android:Callback> that receives the setter result.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_setLandingProtectionEnabled_inline",
                   "",
            ],
            [
                   "getLandingProtectionEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getLandingProtectionEnabled_inline",
                   "Gets landing protection status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets landing protection status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getLandingProtectionEnabled_inline",
                   "",
            ],
            [
                   "LANDING_PROTECTION_ENABLED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getLandingProtectionEnabled_inline",
                   "SDK Key for getLandingProtectionEnabled: Gets landing protection status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getLandingProtectionEnabled: Gets landing protection status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIIntelligentFlightAssistant_getLandingProtectionEnabled_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionFaceAwareStateCallbackInterface.html",
                   "",
                   "Callback to update the FaceAwareState.",
            ],
            [
                   "Callback to update the FaceAwareState.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionFaceAwareStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionPalmControlStateCallbackInterface.html",
                   "",
                   "Callback to update the PalmControlState.",
            ],
            [
                   "Callback to update the PalmControlState.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionPalmControlStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionSmartCaptureStateCallbackInterface.html",
                   "",
                   "Callback to update the SmartCaptureState.",
            ],
            [
                   "Callback to update the SmartCaptureState.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionSmartCaptureStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "VisionDetectionState",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "",
                   "This class gives state information about the product's vision sensors used for obstacle detection. The two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (TOF) sensors. Note, Inspire 2's upwards-facing infrared TOF sensor is not returned in this state. It is accessed through `VisionControlState`.",
            ],
            [
                   "This class gives state information about the product's vision sensors used for obstacle detection. The two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (TOF) sensors. Note, Inspire 2's upwards-facing infrared TOF sensor is not returned in this state. It is accessed through `VisionControlState`.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "",
                   "",
            ],
            [
                   "VISION_DETECTION_STATE",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "",
                   "SDK Key for VisionDetectionState: This class gives state information about the product's vision sensors used for obstacle detection. The two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (TOF) sensors. Note, Inspire 2's upwards-facing infrared TOF sensor is not returned in this state. It is accessed through `VisionControlState`.",
            ],
            [
                   "SDK Key for VisionDetectionState: This class gives state information about the product's vision sensors used for obstacle detection. The two types of sensors used are dual camera sensors operating in the visible spectrum (dual-camera sensor) and infrared time of flight (TOF) sensors. Note, Inspire 2's upwards-facing infrared TOF sensor is not returned in this state. It is accessed through `VisionControlState`.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "",
                   "",
            ],
            [
                   "VisionControlState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "",
                   "This class gives the aircraft's state, which is controlled by the intelligent flight assistant.",
            ],
            [
                   "This class gives the aircraft's state, which is controlled by the intelligent flight assistant.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "",
                   "",
            ],
            [
                   "SmartCaptureState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "",
                   "The object includes all information related to SmartCapture.",
            ],
            [
                   "The object includes all information related to SmartCapture.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "",
                   "",
            ],
            [
                   "PerceptionInformation",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "",
                   "This class contains the aircraft's perception information. It is supported only by Matrice 300 RTK.",
            ],
            [
                   "This class contains the aircraft's perception information. It is supported only by Matrice 300 RTK.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "",
                   "",
            ],
            [
                   "getDataPackageIndex",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_packCount_inline",
                   "The perception package count.  @return An int value of the perception package index.",
            ],
            [
                   "The perception package count.  @return An int value of the perception package index.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_packCount_inline",
                   "",
            ],
            [
                   "getAngleInterval",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_horizontalObjectCount_inline",
                   "Distance value detected away from the obstacles are at an interval of angle around the aircraft in 360 degrees horizontally.  @return A float value of angle interval.",
            ],
            [
                   "Distance value detected away from the obstacles are at an interval of angle around the aircraft in 360 degrees horizontally.  @return A float value of angle interval.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_horizontalObjectCount_inline",
                   "",
            ],
            [
                   "getDistances",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_distanceArray_inline",
                   "Each value represents the distance in millimeters away from the obstacles detected around in 360 degrees horizontally at an interval of angle. Please refer to `getDataPackageIndex` to get the interval of angle. 0 degree points to the aircraft's heading. 90 degrees point to the right of the aircraft. 180 degrees point to the aircraft's tail.  @return An array of int values.",
            ],
            [
                   "Each value represents the distance in millimeters away from the obstacles detected around in 360 degrees horizontally at an interval of angle. Please refer to `getDataPackageIndex` to get the interval of angle. 0 degree points to the aircraft's heading. 90 degrees point to the right of the aircraft. 180 degrees point to the aircraft's tail.  @return An array of int values.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_distanceArray_inline",
                   "",
            ],
            [
                   "getUpwardObstacleDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_upwardObstacleDistance_inline",
                   "The upward obstacle distance.  @return An int value of the upward obstacle distance.",
            ],
            [
                   "The upward obstacle distance.  @return An int value of the upward obstacle distance.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_upwardObstacleDistance_inline",
                   "",
            ],
            [
                   "getDownwardObstacleDistance",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_downwardObstacleDistance_inline",
                   "The downward obstacle distance. Not supported by Mavic Air 2 and DJI Air 2S  @return An int value of downward obstacle distance.",
            ],
            [
                   "The downward obstacle distance. Not supported by Mavic Air 2 and DJI Air 2S  @return An int value of downward obstacle distance.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistantPerceptionState.html",
                   "#DJIFlightAssistantPerceptionState_downwardObstacleDistance_inline",
                   "",
            ],
            [
                   "ObstacleAvoidanceSensorState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "",
                   "Current state of obstacle avoidance sensor.",
            ],
            [
                   "Current state of obstacle avoidance sensor.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "",
                   "",
            ],
            [
                   "isUpwardVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isUpwardVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if upward visual obstacle avoidance sensor is working.  @return A boolean value to check upward obstacle avoidance sensor working.",
            ],
            [
                   "Determines if upward visual obstacle avoidance sensor is working.  @return A boolean value to check upward obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isUpwardVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "isLeftSideVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isLeftSideVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if left side visual obstacle avoidance sensor is working.  @return A boolean value to check left side obstacle avoidance sensor working.",
            ],
            [
                   "Determines if left side visual obstacle avoidance sensor is working.  @return A boolean value to check left side obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isLeftSideVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "isRightSideVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isRightSideVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if right side visual obstacle avoidance sensor is working.  @return A boolean value to check right side obstacle avoidance sensor working.",
            ],
            [
                   "Determines if right side visual obstacle avoidance sensor is working.  @return A boolean value to check right side obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isRightSideVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "isBackwardVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isBackwardVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if backward visual obstacle avoidance sensor is working.  @return A boolean value to check backward obstacle avoidance sensor working.",
            ],
            [
                   "Determines if backward visual obstacle avoidance sensor is working.  @return A boolean value to check backward obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isBackwardVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "isForwardVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isForwardVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if forward visual obstacle avoidance sensor is working.  @return A boolean value to check forward obstacle avoidance sensor working.",
            ],
            [
                   "Determines if forward visual obstacle avoidance sensor is working.  @return A boolean value to check forward obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isForwardVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "isDownwardVisualObstacleAvoidanceSensorWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isDownwardVisualObstacleAvoidanceSensorWorking_inline",
                   "Determines if downward visual obstacle avoidance sensor is working.  @return A boolean value to check downward obstacle avoidance sensor working.",
            ],
            [
                   "Determines if downward visual obstacle avoidance sensor is working.  @return A boolean value to check downward obstacle avoidance sensor working.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isDownwardVisualObstacleAvoidanceSensorWorking_inline",
                   "",
            ],
            [
                   "areVisualObstacleAvoidanceSensorsInVerticalDirectionWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInVerticalDirectionWorking_inline",
                   "Determines if visual obstacle avoidance sensors in vertical direction are working.  @return A boolean value to check obstacle avoidance sensors in vertical direction.",
            ],
            [
                   "Determines if visual obstacle avoidance sensors in vertical direction are working.  @return A boolean value to check obstacle avoidance sensors in vertical direction.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInVerticalDirectionWorking_inline",
                   "",
            ],
            [
                   "areVisualObstacleAvoidanceSensorsInHorizontalDirectionWorking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInHorizontalDirectionWorking_inline",
                   "Determines if visual obstacle avoidance sensors in horizontal direction are working.  @return A boolean value to check obstacle avoidance sensors in horizontal direction.",
            ],
            [
                   "Determines if visual obstacle avoidance sensors in horizontal direction are working.  @return A boolean value to check obstacle avoidance sensors in horizontal direction.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInHorizontalDirectionWorking_inline",
                   "",
            ],
            [
                   "isUpwardVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isUpwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the upward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check upward obstacle avoidance sensor enabled or not.",
            ],
            [
                   "Whether the upward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check upward obstacle avoidance sensor enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isUpwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "isLeftSideVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isLeftSideVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the left side visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check left side obstacle avoidance sensor enabled or not.",
            ],
            [
                   "Whether the left side visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check left side obstacle avoidance sensor enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isLeftSideVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "isRightSideVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isRightSideVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the right side visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check right side obstacle avoidance sensor enabled or not.",
            ],
            [
                   "Whether the right side visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check right side obstacle avoidance sensor enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isRightSideVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "isBackwardVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isBackwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the backward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the backward obstacle avoidance sensor is enabled or not.",
            ],
            [
                   "Whether the backward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the backward obstacle avoidance sensor is enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isBackwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "isForwardVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isForwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the forward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the forward obstacle avoidance sensor is enabled or not.",
            ],
            [
                   "Whether the forward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the forward obstacle avoidance sensor is enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isForwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "isDownwardVisualObstacleAvoidanceSensorEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isDownwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "Whether the downward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the downward obstacle avoidance sensor is enabled or not.",
            ],
            [
                   "Whether the downward visual obstacle avoidance sensor is enabled or not.  @return A boolean value to check the downward obstacle avoidance sensor is enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_isDownwardVisualObstacleAvoidanceSensorEnabled_inline",
                   "",
            ],
            [
                   "areVisualObstacleAvoidanceSensorsInVerticalDirectionEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInVerticalDirectionEnabled_inline",
                   "Whether the visual obstacle avoidance sensors in vertical direction are enabled or not.  @return A boolean value to check the obstacle avoidance sensor in vertical direction is enabled or not.",
            ],
            [
                   "Whether the visual obstacle avoidance sensors in vertical direction are enabled or not.  @return A boolean value to check the obstacle avoidance sensor in vertical direction is enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInVerticalDirectionEnabled_inline",
                   "",
            ],
            [
                   "areVisualObstacleAvoidanceSensorsInHorizontalDirectionEnabled",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInHorizontalDirectionEnabled_inline",
                   "Whether the visual obstacle avoidance sensors in horizontal direction are enabled or not.  @return A boolean value to check the obstacle avoidance sensor in horizontal direction is enabled or not.",
            ],
            [
                   "Whether the visual obstacle avoidance sensors in horizontal direction are enabled or not.  @return A boolean value to check the obstacle avoidance sensor in horizontal direction is enabled or not.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIFlightAssistant_ObstacleAvoidanceSensorState.html",
                   "#DJIFlightAssistant_ObstacleAvoidanceSensorState_areVisualObstacleAvoidanceSensorsInHorizontalDirectionEnabled_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setUpdateRtkStateCallback_inline",
                   "Set RTK state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set RTK state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setUpdateRtkStateCallback_inline",
                   "",
            ],
            [
                   "addReferenceStationSourceCallback",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_addReferenceStationSourceCallback_inline",
                   "Adds a listener to receive the reference station source.  @param callback Callback to receive reference station source.",
            ],
            [
                   "Adds a listener to receive the reference station source.  @param callback Callback to receive reference station source.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_addReferenceStationSourceCallback_inline",
                   "",
            ],
            [
                   "removeReferenceStationSourceCallback",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_removeReferenceStationSourceCallback_inline",
                   "Removes a listener that receives the reference station source.  @param callback Callback to receive reference station source.",
            ],
            [
                   "Removes a listener that receives the reference station source.  @param callback Callback to receive reference station source.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_removeReferenceStationSourceCallback_inline",
                   "",
            ],
            [
                   "RTKBaseStationListCallback",
                   2,
                   "/Components/RTK/DJIRTK_RTKBaseStationListCallbackInterface.html",
                   "",
                   "Callback interface that updates the array of the RTK base station scanned information. If you  call `startSearchBaseStation`, each Base station while push it's information once. If  you call `stopSearchBaseStation`, this callback function will stop updates.",
            ],
            [
                   "Callback interface that updates the array of the RTK base station scanned information. If you  call `startSearchBaseStation`, each Base station while push it's information once. If  you call `stopSearchBaseStation`, this callback function will stop updates.",
                   1,
                   "/Components/RTK/DJIRTK_RTKBaseStationListCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RTK/DJIRTK_RTKBaseStationListCallbackInterface.html",
                   "#DJIRTK_RTKBaseStationListCallbackInterface_onUpdate_inline",
                   "Provides the list of DJI base station that can be connected with. Callback will continue to receive an updated list  after `startSearchBaseStation` is called. Invoke `stopSearchBaseStation` to stop searching.  @param baseStationInformations An array contains Base station scan information.",
            ],
            [
                   "Provides the list of DJI base station that can be connected with. Callback will continue to receive an updated list  after `startSearchBaseStation` is called. Invoke `stopSearchBaseStation` to stop searching.  @param baseStationInformations An array contains Base station scan information.",
                   1,
                   "/Components/RTK/DJIRTK_RTKBaseStationListCallbackInterface.html",
                   "#DJIRTK_RTKBaseStationListCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "setRtkBaseStationListCallback",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRtkBaseStationListCallback_inline",
                   "Sets RTK base station scanned information update rtkBaseStationListCallback.  @param callback Callback to receive the information of rtk base station scanned.",
            ],
            [
                   "Sets RTK base station scanned information update rtkBaseStationListCallback.  @param callback Callback to receive the information of rtk base station scanned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRtkBaseStationListCallback_inline",
                   "",
            ],
            [
                   "RTKConnectionStateWithBaseStationReferenceSourceCallback",
                   2,
                   "/Components/RTK/DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface.html",
                   "",
                   "Callback interface that updates RTK connection state and connected base station information.",
            ],
            [
                   "Callback interface that updates RTK connection state and connected base station information.",
                   1,
                   "/Components/RTK/DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RTK/DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface.html",
                   "#DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface_onUpdate_inline",
                   "Updates RTK connection state and connected base station information. Aircraft will try to connect to the base station  connected last time after it restarts. Stops to reconnect after 10 seconds. If current connection state  is `SCANNING` or `IDLE`,  this method still updates the base station information connected last time. Only can be used when current `ReferenceStationSource`  is `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param connectionState RTK with base station connection state. @param information Base station connection information.",
            ],
            [
                   "Updates RTK connection state and connected base station information. Aircraft will try to connect to the base station  connected last time after it restarts. Stops to reconnect after 10 seconds. If current connection state  is `SCANNING` or `IDLE`,  this method still updates the base station information connected last time. Only can be used when current `ReferenceStationSource`  is `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param connectionState RTK with base station connection state. @param information Base station connection information.",
                   1,
                   "/Components/RTK/DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface.html",
                   "#DJIRTK_RTKConnectionStateWithBaseStationReferenceSourceCallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "setRtkConnectionStateWithBaseStationCallback",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRtkConnectionStateWithBaseStationCallback_inline",
                   "Set RTK base station connection state and information update rtkBaseStationConnectionInformationCallback.  @param callback Callback to receive the information of the connection between RTK and base station.",
            ],
            [
                   "Set RTK base station connection state and information update rtkBaseStationConnectionInformationCallback.  @param callback Callback to receive the information of the connection between RTK and base station.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRtkConnectionStateWithBaseStationCallback_inline",
                   "",
            ],
            [
                   "PPKModeState",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_inline",
                   "PPK mode status.",
            ],
            [
                   "PPK mode status.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_idle_inline",
                   "PPK Mode is idle.",
            ],
            [
                   "PPK Mode is idle.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_idle_inline",
                   "",
            ],
            [
                   "RUNNING",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_running_inline",
                   "PPK Mode is running.",
            ],
            [
                   "PPK Mode is running.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_running_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_unknown_inline",
                   "Unknown error.",
            ],
            [
                   "Unknown error.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_PPKModeState_unknown_inline",
                   "",
            ],
            [
                   "setPPKModeStateListener",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setPPKModeStateListener_inline",
                   "Set listener for the PPK mode which is used to listen the status changes. Only supported by Phantom 4 RTK.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set listener for the PPK mode which is used to listen the status changes. Only supported by Phantom 4 RTK.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setPPKModeStateListener_inline",
                   "",
            ],
            [
                   "setPPKModeEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setPPKModeEnabled_inline",
                   "In PPK mode, the camera will automatically create a folder before the next photo taking, and start to record PPK data.  The camera will not store the data in the created folder until PPK mode disabled. To use this interface, you must insert SD card and set camera mode to photo mode.  Only supported by Phantom 4 RTK.  @param enabled `true` to enable PPK mode. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "In PPK mode, the camera will automatically create a folder before the next photo taking, and start to record PPK data.  The camera will not store the data in the created folder until PPK mode disabled. To use this interface, you must insert SD card and set camera mode to photo mode.  Only supported by Phantom 4 RTK.  @param enabled `true` to enable PPK mode. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setPPKModeEnabled_inline",
                   "",
            ],
            [
                   "getPPKModeEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getPPKModeEnabled_inline",
                   "Gets the PPK mode status. Only supported by Phantom 4 RTK.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the PPK mode status. Only supported by Phantom 4 RTK.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getPPKModeEnabled_inline",
                   "",
            ],
            [
                   "setRtkEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKEnabled_inline",
                   "Enables RTK positioning. Disable RTK when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. Can only be set when the motors are off.  @param enabled `true` to enable RTK positioning. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enables RTK positioning. Disable RTK when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. Can only be set when the motors are off.  @param enabled `true` to enable RTK positioning. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKEnabled_inline",
                   "",
            ],
            [
                   "RTK_ENABLED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKEnabled_inline",
                   "SDK Key for setRtkEnabled: Enables RTK positioning. Disable RTK when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. Can only be set when the motors are off.  @param enabled `true` to enable RTK positioning. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setRtkEnabled: Enables RTK positioning. Disable RTK when in poor signal environments, where incorrect positioning information might make controlling the aircraft difficult. Can only be set when the motors are off.  @param enabled `true` to enable RTK positioning. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKEnabled_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_isConnected_inline",
                   "`true` if RTK is connected to the aircraft.  @return A boolean value.",
            ],
            [
                   "`true` if RTK is connected to the aircraft.  @return A boolean value.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_isConnected_inline",
                   "",
            ],
            [
                   "getRtkEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getRTKEnabled_inline",
                   "Determines if RTK is enabled. Phantom 4 RTK has different behavior from the other products that supports RTK:  - For aircrafts except Phantom 4 RTK,  disabling RTK will stop RTK from pushing valid position.  - For Phantom  4 RTK, RTK will continue to push latest RTK coordinate if there is strong  satellite signal after disabling RTK. However, the flight controller will  not use the RTK coordinate for navigation.  @param callback The completion block that receives the result.",
            ],
            [
                   "Determines if RTK is enabled. Phantom 4 RTK has different behavior from the other products that supports RTK:  - For aircrafts except Phantom 4 RTK,  disabling RTK will stop RTK from pushing valid position.  - For Phantom  4 RTK, RTK will continue to push latest RTK coordinate if there is strong  satellite signal after disabling RTK. However, the flight controller will  not use the RTK coordinate for navigation.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getRTKEnabled_inline",
                   "",
            ],
            [
                   "setReferenceStationSource",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setReferenceStationSource_inline",
                   "Sets the reference station source that provides real-time corrections for the RTK air system. It is only supported by Phantom 4 RTK. For Matrice 210 RTK, Matrice 600 series and Mavic 2 Enterprise Advanced, the reference station is always the physical base station.  @param source Reference station source to set. @param callback The completion block that receives the result.",
            ],
            [
                   "Sets the reference station source that provides real-time corrections for the RTK air system. It is only supported by Phantom 4 RTK. For Matrice 210 RTK, Matrice 600 series and Mavic 2 Enterprise Advanced, the reference station is always the physical base station.  @param source Reference station source to set. @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setReferenceStationSource_inline",
                   "",
            ],
            [
                   "startSearchBaseStation",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_startSearchBaseStation_inline",
                   "Used to start searching for DJI base station that can be controlled with the Mobile  SDK.  Searching  will automatically stop after a base station is connected. Only can be used when  current `ReferenceStationSource` is `BASE_STATION`.  It is supported only by Matrice 300 RTK.  @param callback The completion block that receives the result.",
            ],
            [
                   "Used to start searching for DJI base station that can be controlled with the Mobile  SDK.  Searching  will automatically stop after a base station is connected. Only can be used when  current `ReferenceStationSource` is `BASE_STATION`.  It is supported only by Matrice 300 RTK.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_startSearchBaseStation_inline",
                   "",
            ],
            [
                   "stopSearchBaseStation",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_stopSearchBaseStation_inline",
                   "Used to stop searching for DJI base station that can be controlled with the Mobile SDK.  If searching is stopped without selecting a base station, the last connected base station will be reconnected.  Only can be used when current `ReferenceStationSource`  is  `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param callback The completion block that receives the result.",
            ],
            [
                   "Used to stop searching for DJI base station that can be controlled with the Mobile SDK.  If searching is stopped without selecting a base station, the last connected base station will be reconnected.  Only can be used when current `ReferenceStationSource`  is  `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_stopSearchBaseStation_inline",
                   "",
            ],
            [
                   "connectToBaseStation",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_connectToBaseStation_inline",
                   "Choose a base station to connect by base station's ID. Only can be used when current `ReferenceStationSource`  is `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param baseStationID The base station's ID that chosen to be connected. @param callback The completion block that receives the result.",
            ],
            [
                   "Choose a base station to connect by base station's ID. Only can be used when current `ReferenceStationSource`  is `BASE_STATION`. It is supported only by Matrice 300 RTK.  @param baseStationID The base station's ID that chosen to be connected. @param callback The completion block that receives the result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_connectToBaseStation_inline",
                   "",
            ],
            [
                   "setRTKMaintainPositioningAccuracyModeEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKMaintainPositioningAccuracyModeEnabled_inline",
                   "Sets RTK maintain position accuracy mode enable. When enabled is ``TRUE`, the aircraft will maintain position accuracy about 10 minutes after losing RTK signal. Only supported by Phantom 4 RTK. When the aircraft is in Maintain Positioning Accuracy mode: 1. The aircraft positioning accuracy will decrease gradually. Be sure to fly with caution. Stop the flight or reconnect to the RTK signal source immediately to avoid flight hazards. 2. Flying the aircraft for a long distance (for example, automatically performing operations alongside the planned flight route), or controlling the aircraft with a large stick movement will lead to faster positioning accuracy decrease. 3. The RtkFlag of the images the aircraft captured is 16(Point Positioning), which cannot meet the requirements for mapping. It is not recommended to use Maintain Positioning Accuracy mode in flight route operations, especially in operations with an absolute altitude. This mode is more suitable for inspection or waypoint operations.  @param enabled `true` to enable RTK maintain positioning accuracy mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets RTK maintain position accuracy mode enable. When enabled is ``TRUE`, the aircraft will maintain position accuracy about 10 minutes after losing RTK signal. Only supported by Phantom 4 RTK. When the aircraft is in Maintain Positioning Accuracy mode: 1. The aircraft positioning accuracy will decrease gradually. Be sure to fly with caution. Stop the flight or reconnect to the RTK signal source immediately to avoid flight hazards. 2. Flying the aircraft for a long distance (for example, automatically performing operations alongside the planned flight route), or controlling the aircraft with a large stick movement will lead to faster positioning accuracy decrease. 3. The RtkFlag of the images the aircraft captured is 16(Point Positioning), which cannot meet the requirements for mapping. It is not recommended to use Maintain Positioning Accuracy mode in flight route operations, especially in operations with an absolute altitude. This mode is more suitable for inspection or waypoint operations.  @param enabled `true` to enable RTK maintain positioning accuracy mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_setRTKMaintainPositioningAccuracyModeEnabled_inline",
                   "",
            ],
            [
                   "getRTKMaintainPositioningAccuracyModeEnabled",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getRTKMaintainPositioningAccuracyModeEnabled_inline",
                   "Gets RTK maintain positioning accuracy mode status. Only supported by Phantom 4 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets RTK maintain positioning accuracy mode status. Only supported by Phantom 4 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_getRTKMaintainPositioningAccuracyModeEnabled_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RTK/DJIRTK_updateRtkStateCallbackInterface.html",
                   "#DJIRTK_updateRTKState_inline",
                   "Callback function that updates the RTK state data.  @param state Current state of the RTK.",
            ],
            [
                   "Callback function that updates the RTK state data.  @param state Current state of the RTK.",
                   1,
                   "/Components/RTK/DJIRTK_updateRtkStateCallbackInterface.html",
                   "#DJIRTK_updateRTKState_inline",
                   "",
            ],
            [
                   "RTKState",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "",
                   "This class holds the state of the RTK system, including position, positioning solution, and receiver information.  Receiver 1 is used for positioning. Receiver 2 is used for orienteering.",
            ],
            [
                   "This class holds the state of the RTK system, including position, positioning solution, and receiver information.  Receiver 1 is used for positioning. Receiver 2 is used for orienteering.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "",
                   "",
            ],
            [
                   "RTK_STATE",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "",
                   "SDK Key for RTKState: This class holds the state of the RTK system, including position, positioning solution, and receiver information.  Receiver 1 is used for positioning. Receiver 2 is used for orienteering.",
            ],
            [
                   "SDK Key for RTKState: This class holds the state of the RTK system, including position, positioning solution, and receiver information.  Receiver 1 is used for positioning. Receiver 2 is used for orienteering.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "",
                   "",
            ],
            [
                   "DataSource",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_inline",
                   "This enum defines the data source (either GPS or RTK) of a recorded location, e.g. home point. Only support by Phantom 4 RTK.",
            ],
            [
                   "This enum defines the data source (either GPS or RTK) of a recorded location, e.g. home point. Only support by Phantom 4 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_inline",
                   "",
            ],
            [
                   "RTKNetworkServiceProvider",
                   2,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "",
                   "This class is used to control the RTK network service. The DJIRTKNetworkServiceProvider can  initiate the communication to a third-party RTK network server. The information from the server can  be streamed to the RTK airsystem. SDK will not cache the settings to the disk. The provider should be configured in each life cycle of SDK. The life cycle of the network service provider is independent  from the aircraft. Therefore, it can be configured before connecting to DJI aircrafts. It is only supported  by Phantom 4 RTK, P4 Multispectral, Mavic 2 Enterprse Advanced, Matrice 210 RTK V2 and Matrice 300 RTK.",
            ],
            [
                   "This class is used to control the RTK network service. The DJIRTKNetworkServiceProvider can  initiate the communication to a third-party RTK network server. The information from the server can  be streamed to the RTK airsystem. SDK will not cache the settings to the disk. The provider should be configured in each life cycle of SDK. The life cycle of the network service provider is independent  from the aircraft. Therefore, it can be configured before connecting to DJI aircrafts. It is only supported  by Phantom 4 RTK, P4 Multispectral, Mavic 2 Enterprse Advanced, Matrice 210 RTK V2 and Matrice 300 RTK.",
                   1,
                   "/Components/RTK/DJIRTKNetworkServiceProvider.html",
                   "",
                   "",
            ],
            [
                   "CoordinateSystem",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_inline",
                   "Coordinate System for Network RTK. It is supported by Phantom 4 RTK.",
            ],
            [
                   "Coordinate System for Network RTK. It is supported by Phantom 4 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_inline",
                   "",
            ],
            [
                   "NetworkServiceAccountState",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_inline",
                   "All the possible state of `CoordinateSystem`. It is supported by Phantom 4 RTK.",
            ],
            [
                   "All the possible state of `CoordinateSystem`. It is supported by Phantom 4 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_inline",
                   "",
            ],
            [
                   "NetworkServicePlanType",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_inline",
                   "Network RTK service plan type.",
            ],
            [
                   "Network RTK service plan type.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_inline",
                   "",
            ],
            [
                   "NetworkServicePlanState",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_inline",
                   "Network RTK Service Plan's State.",
            ],
            [
                   "Network RTK Service Plan's State.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_inline",
                   "",
            ],
            [
                   "ReferenceStationSource",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_inline",
                   "All the possible state of `ReferenceStationSource`.",
            ],
            [
                   "All the possible state of `ReferenceStationSource`.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NONE_inline",
                   "Not using any reference station source.",
            ],
            [
                   "Not using any reference station source.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NONE_inline",
                   "",
            ],
            [
                   "BASE_STATION",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_GroundSystem_inline",
                   "RTK is using the D-RTK 2 base station as the reference station. It is supported by Phantom 4 RTK, P4 Multispectral and Matrice 300 RTK.",
            ],
            [
                   "RTK is using the D-RTK 2 base station as the reference station. It is supported by Phantom 4 RTK, P4 Multispectral and Matrice 300 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_GroundSystem_inline",
                   "",
            ],
            [
                   "CUSTOM_NETWORK_SERVICE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NetworkService_inline",
                   "RTK is using third-party network service as the reference station. The network service should use  NTRIP(Networked Transport of RTCM via  Internet Protocol). It is supported by Phantom 4 RTK, P4 Multispectral, Matrice 210 RTK V2 and Matrice 300 RTK.",
            ],
            [
                   "RTK is using third-party network service as the reference station. The network service should use  NTRIP(Networked Transport of RTCM via  Internet Protocol). It is supported by Phantom 4 RTK, P4 Multispectral, Matrice 210 RTK V2 and Matrice 300 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NetworkService_inline",
                   "",
            ],
            [
                   "NETWORK_RTK",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NetworkRTK_inline",
                   "Default virtual reference station solution to provide cm level accurate position.  The frame can be either WGS84 or CGCS 2000. Please note that this default solution can only be used  in China. Please add the djinetworkrtkhelper to the project via gradle:  implementation 'com.dji:library-networkrtk-helper:2.0.2'. It is only supported by Matrice 300 RTK and Matrice 350 RTK.",
            ],
            [
                   "Default virtual reference station solution to provide cm level accurate position.  The frame can be either WGS84 or CGCS 2000. Please note that this default solution can only be used  in China. Please add the djinetworkrtkhelper to the project via gradle:  implementation 'com.dji:library-networkrtk-helper:2.0.2'. It is only supported by Matrice 300 RTK and Matrice 350 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NetworkRTK_inline",
                   "",
            ],
            [
                   "NTRIP_NETWORK_SERVICE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NTRIP_NETWORK_SERVICE_inline",
                   "Ntrip network service which is used for CMCC network RTK service. It is only supported Matrice 300 RTK and Matrice 350 RTK.",
            ],
            [
                   "Ntrip network service which is used for CMCC network RTK service. It is only supported Matrice 300 RTK and Matrice 350 RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_NTRIP_NETWORK_SERVICE_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_Unknown_inline",
                   "Unknown reference station source.",
            ],
            [
                   "Unknown reference station source.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKReferenceStationSource_Callback.html",
                   "",
                   "Updates the RTK reference station source.",
            ],
            [
                   "Updates the RTK reference station source.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKReferenceStationSource_Callback.html",
                   "",
                   "",
            ],
            [
                   "onReferenceStationSourceUpdate",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKReferenceStationSource_Callback.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_Callback_onReferenceStationSourceUpdate_inline",
                   "Callback function that updates the RTK reference station source.  @param referenceStationSource The source of the reference station.",
            ],
            [
                   "Callback function that updates the RTK reference station source.  @param referenceStationSource The source of the reference station.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKReferenceStationSource_Callback.html",
                   "#DJIRTK_DJIRTKReferenceStationSource_Callback_onReferenceStationSourceUpdate_inline",
                   "",
            ],
            [
                   "isMaintainingPositionAccuracy",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isMaintainingPositionAccuracy_inline",
                   "Whether aircraft is maintaining position accuracy after losing RTK signal. If return `true`, the aircraft will maintain position accuracy about 10 minutes after losing RTK signal.",
            ],
            [
                   "Whether aircraft is maintaining position accuracy after losing RTK signal. If return `true`, the aircraft will maintain position accuracy about 10 minutes after losing RTK signal.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isMaintainingPositionAccuracy_inline",
                   "",
            ],
            [
                   "isRTKBeingUsed",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isRTKBeingUsed_inline",
                   "It will be true when the positioning solution is fixed and the RTK location data received period is between 2 seconds. The flight controller will use RTK data when isRTKBeingUsed is true.  @return A boolean value.",
            ],
            [
                   "It will be true when the positioning solution is fixed and the RTK location data received period is between 2 seconds. The flight controller will use RTK data when isRTKBeingUsed is true.  @return A boolean value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isRTKBeingUsed_inline",
                   "",
            ],
            [
                   "getMobileStation1SatelliteCount",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_getMobileStation1SatelliteCount_inline",
                   "Get the total number of satellites from Mobile station (aircraft) receiver 1.  @return An int value.",
            ],
            [
                   "Get the total number of satellites from Mobile station (aircraft) receiver 1.  @return An int value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_getMobileStation1SatelliteCount_inline",
                   "",
            ],
            [
                   "getMobileStation2SatelliteCount",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_getMobileStation2SatelliteCount_inline",
                   "Get the total number of satellites from Mobile station (aircraft) receiver 2.  @return An int value.",
            ],
            [
                   "Get the total number of satellites from Mobile station (aircraft) receiver 2.  @return An int value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_getMobileStation2SatelliteCount_inline",
                   "",
            ],
            [
                   "distanceToHomePointDataSource",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_distanceToHomePointDataSource_inline",
                   "Distance to home point data source. Only Supported by Phantom 4 RTK.  @return An enum value of `DataSource`.",
            ],
            [
                   "Distance to home point data source. Only Supported by Phantom 4 RTK.  @return An enum value of `DataSource`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_distanceToHomePointDataSource_inline",
                   "",
            ],
            [
                   "isTakeoffAltitudeRecorded",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isTakeoffAltitudeRecorded_inline",
                   "`true` if the altitude is recorded by the flight controller when the aircraft takes off. Only Supported by Phantom 4 RTK.  @return A boolean value to check if take off altitude has been recorded.",
            ],
            [
                   "`true` if the altitude is recorded by the flight controller when the aircraft takes off. Only Supported by Phantom 4 RTK.  @return A boolean value to check if take off altitude has been recorded.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isTakeoffAltitudeRecorded_inline",
                   "",
            ],
            [
                   "homePointDataSource",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_homePointDataSource_inline",
                   "Home point data source. Only Supported by Phantom 4 RTK.  @return An enum value of `DataSource`.",
            ],
            [
                   "Home point data source. Only Supported by Phantom 4 RTK.  @return An enum value of `DataSource`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_homePointDataSource_inline",
                   "",
            ],
            [
                   "getSatelliteCount",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_satelliteCount_inline",
                   "Gps or RTK satellite count. Only Supported by Phantom 4 RTK.  @return Satellite count.",
            ],
            [
                   "Gps or RTK satellite count. Only Supported by Phantom 4 RTK.  @return Satellite count.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_satelliteCount_inline",
                   "",
            ],
            [
                   "homePointLocation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_homePointLocation_inline",
                   "Home point location. Only Supported by Phantom 4 RTK.  @return A `LocationCoordinate2D` object of the home point location.",
            ],
            [
                   "Home point location. Only Supported by Phantom 4 RTK.  @return A `LocationCoordinate2D` object of the home point location.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_homePointLocation_inline",
                   "",
            ],
            [
                   "getTakeOffAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_takeoffAltitude_inline",
                   "Takeoff altitude. Only Supported by Phantom 4 RTK.  @return A float value of the takeoff altitude.",
            ],
            [
                   "Takeoff altitude. Only Supported by Phantom 4 RTK.  @return A float value of the takeoff altitude.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_takeoffAltitude_inline",
                   "",
            ],
            [
                   "getDistanceToHomePoint",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_distanceToHomePoint_inline",
                   "Distance to home point. Only Supported by Phantom 4 RTK.  @return A float value of the distance to home point.",
            ],
            [
                   "Distance to home point. Only Supported by Phantom 4 RTK.  @return A float value of the distance to home point.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_distanceToHomePoint_inline",
                   "",
            ],
            [
                   "getEllipsoidHeight",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_ellipsoidHeight_inline",
                   "Ellipsoid height. An absolute altitude above sea level read from GPS. Only Supported by Matrice 300 RTK.  @return A float value of the ellipsoid height.",
            ],
            [
                   "Ellipsoid height. An absolute altitude above sea level read from GPS. Only Supported by Matrice 300 RTK.  @return A float value of the ellipsoid height.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_ellipsoidHeight_inline",
                   "",
            ],
            [
                   "getAircraftAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_aircraftAltitude_inline",
                   "Aircraft altitude. Aircraft's absolute altitude above sea level.  When RTK is used and valid, this value will be a fusion RTK altitude.  Otherwise, it is a fusion barometer altitude.  Supported by Matrice 300 RTK, Phantom 4 RTK and P4 Multispectral.  @return A float value of the aircraft altitude.",
            ],
            [
                   "Aircraft altitude. Aircraft's absolute altitude above sea level.  When RTK is used and valid, this value will be a fusion RTK altitude.  Otherwise, it is a fusion barometer altitude.  Supported by Matrice 300 RTK, Phantom 4 RTK and P4 Multispectral.  @return A float value of the aircraft altitude.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_aircraftAltitude_inline",
                   "",
            ],
            [
                   "getPositioningSolution",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_positioningSolution_inline",
                   "The positioning solution describes the method used to determine positioning. The solutions vary in accuracy, from `NONE` (no positioning) to `FIXED_POINT`.  @return An enum value of `PositioningSolution`",
            ],
            [
                   "The positioning solution describes the method used to determine positioning. The solutions vary in accuracy, from `NONE` (no positioning) to `FIXED_POINT`.  @return An enum value of `PositioningSolution`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_positioningSolution_inline",
                   "",
            ],
            [
                   "getError",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_error_inline",
                   "Gets RTK errors, if any. Returns `null` when RTK is normal.  @return An instance of `DJIError`.",
            ],
            [
                   "Gets RTK errors, if any. Returns `null` when RTK is normal.  @return An instance of `DJIError`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_error_inline",
                   "",
            ],
            [
                   "isHeadingValid",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isHeadingValid_inline",
                   "`true` if heading value is valid. Heading is invalid when a satellite fix hasn't been obtained.  @return A boolean value.",
            ],
            [
                   "`true` if heading value is valid. Heading is invalid when a satellite fix hasn't been obtained.  @return A boolean value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_isHeadingValid_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_heading_inline",
                   "Heading relative to True North as defined by the vector formed from Antenna 2 to Antenna 1 on the mobile station. Unit is degrees.  @return A float value.",
            ],
            [
                   "Heading relative to True North as defined by the vector formed from Antenna 2 to Antenna 1 on the mobile station. Unit is degrees.  @return A float value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_heading_inline",
                   "",
            ],
            [
                   "getHeadingSolution",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_headingSolution_inline",
                   "The heading solution describes the method used to determine heading. The solutions vary in accuracy,  from `NONE` (no heading) to `FIXED_POINT`. It's supported by Matrice  200 series V2 and Phantom 4 RTK.  @return An enum value of `getHeadingSolution`.",
            ],
            [
                   "The heading solution describes the method used to determine heading. The solutions vary in accuracy,  from `NONE` (no heading) to `FIXED_POINT`. It's supported by Matrice  200 series V2 and Phantom 4 RTK.  @return An enum value of `getHeadingSolution`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_headingSolution_inline",
                   "",
            ],
            [
                   "getMobileStationLocation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationAntenna1Location_inline",
                   "Always indicate RTK location data. Location information of the mobile station's receiver 1 antenna. This location  information is relative to the base station's location and is in degrees when `getPositioningSolution`  is `FIXED_POINT`.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "Always indicate RTK location data. Location information of the mobile station's receiver 1 antenna. This location  information is relative to the base station's location and is in degrees when `getPositioningSolution`  is `FIXED_POINT`.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationAntenna1Location_inline",
                   "",
            ],
            [
                   "getMobileStationAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationAntenna1Altitude_inline",
                   "Altitude of the mobile station's receiver 1 antenna relative, to the ground system location. Units are meters.  @return A float value.",
            ],
            [
                   "Altitude of the mobile station's receiver 1 antenna relative, to the ground system location. Units are meters.  @return A float value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationAntenna1Altitude_inline",
                   "",
            ],
            [
                   "getMobileStationStandardDeviation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationStandardDeviation_inline",
                   "Standard deviation of location accuracy in meters. Returns `null` when the aircraft receives no signal.  Only Supported by Phantom 4 RTK.  @return A `LocationStandardDeviation` object of the mobile station standard deviation.",
            ],
            [
                   "Standard deviation of location accuracy in meters. Returns `null` when the aircraft receives no signal.  Only Supported by Phantom 4 RTK.  @return A `LocationStandardDeviation` object of the mobile station standard deviation.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationStandardDeviation_inline",
                   "",
            ],
            [
                   "getFusionMobileStationLocation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionLocation_inline",
                   "The fusion location of the mobile station (in degrees). It is the combination of GPS and RTK. The flight controller uses this location for navigation (e.g. waypoint mission) when RTK is available.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "The fusion location of the mobile station (in degrees). It is the combination of GPS and RTK. The flight controller uses this location for navigation (e.g. waypoint mission) when RTK is available.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionLocation_inline",
                   "",
            ],
            [
                   "getFusionMobileStationAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionAltitude_inline",
                   "The fusion altitude of the mobile station. The flight controller fuses the data from GPS, RTK and the barometer.  The flight controller uses this altitude for navigation (e.g. waypoint mission) when RTK is available.  @return A float value.",
            ],
            [
                   "The fusion altitude of the mobile station. The flight controller fuses the data from GPS, RTK and the barometer.  The flight controller uses this altitude for navigation (e.g. waypoint mission) when RTK is available.  @return A float value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionAltitude_inline",
                   "",
            ],
            [
                   "getFusionHeading",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionHeading_inline",
                   "The fusion heading of the mobile station. It is the combination of RTK and the compass. The flight controller uses this heading for navigation (e.g. waypoint mission) when RTK is available.  @return A float value.",
            ],
            [
                   "The fusion heading of the mobile station. It is the combination of RTK and the compass. The flight controller uses this heading for navigation (e.g. waypoint mission) when RTK is available.  @return A float value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationFusionHeading_inline",
                   "",
            ],
            [
                   "getBaseStationLocation",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemLocation_inline",
                   "Base station's location coordinates, in degrees.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "Base station's location coordinates, in degrees.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemLocation_inline",
                   "",
            ],
            [
                   "getBaseStationAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemAltitude_inline",
                   "Altitude of the base station above sea level, in meters.  @return A float value.",
            ],
            [
                   "Altitude of the base station above sea level, in meters.  @return A float value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemAltitude_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver1GPSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GPSInfo_inline",
                   "Mobile station (aircraft) receiver 1 GPS info.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Mobile station (aircraft) receiver 1 GPS info.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GPSInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver1BeiDouInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1BeiDouInfo_inline",
                   "Mobile station (aircraft) receiver 1 BeiDou info.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Mobile station (aircraft) receiver 1 BeiDou info.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1BeiDouInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver1GLONASSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GLONASSInfo_inline",
                   "Mobile station (aircraft) receiver 1 GLONASS info.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Mobile station (aircraft) receiver 1 GLONASS info.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GLONASSInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver1GalileoInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GalileoInfo_inline",
                   "Mobile station (aircraft) receiver 1 Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Mobile station (aircraft) receiver 1 Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver1GalileoInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver2GPSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GPSInfo_inline",
                   "Mobile station (aircraft) receiver 2 GPS info.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Mobile station (aircraft) receiver 2 GPS info.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GPSInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver2BeiDouInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2BeiDouInfo_inline",
                   "Mobile station (aircraft) receiver 2 BeiDou info.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Mobile station (aircraft) receiver 2 BeiDou info.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2BeiDouInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver2GLONASSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GLONASSInfo_inline",
                   "Mobile station (aircraft) receiver 2 GLONASS info.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Mobile station (aircraft) receiver 2 GLONASS info.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GLONASSInfo_inline",
                   "",
            ],
            [
                   "getMobileStationReceiver2GalileoInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GalileoInfo_inline",
                   "Mobile station (aircraft) receiver 2 Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Mobile station (aircraft) receiver 2 Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_mobileStationReceiver2GalileoInfo_inline",
                   "",
            ],
            [
                   "getBaseStationReceiverGPSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverGPSInfo_inline",
                   "Base station receiver GPS info.  @return An instance of `ReceiverInfo`",
            ],
            [
                   "Base station receiver GPS info.  @return An instance of `ReceiverInfo`",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverGPSInfo_inline",
                   "",
            ],
            [
                   "getBaseStationReceiverBeiDouInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverBeiDouInfo_inline",
                   "Base station receiver BeiDou info.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Base station receiver BeiDou info.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverBeiDouInfo_inline",
                   "",
            ],
            [
                   "getBaseStationReceiverGLONASSInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverGLONASSInfo_inline",
                   "Base station receiver GLONASS info.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Base station receiver GLONASS info.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_groundSystemReceiverGLONASSInfo_inline",
                   "",
            ],
            [
                   "getBaseStationReceiverGalileoInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_baseStationReceiverGalileoInfo_inline",
                   "Base station receiver Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`.",
            ],
            [
                   "Base station receiver Galileo info. Only Supported by Phantom 4 RTK.  @return An instance of `ReceiverInfo`.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKState_baseStationReceiverGalileoInfo_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RTK/DJIRTK_updateRtkStateCallbackInterface.html",
                   "",
                   "This interface provides a delegate method to update the RTK state.",
            ],
            [
                   "This interface provides a delegate method to update the RTK state.",
                   1,
                   "/Components/RTK/DJIRTK_updateRtkStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "PositioningSolution",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_inline",
                   "This enum defines the positioning solution currently being used.",
            ],
            [
                   "This enum defines the positioning solution currently being used.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_None_inline",
                   "No positioning solution. This can be caused by an insufficient number of satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
            ],
            [
                   "No positioning solution. This can be caused by an insufficient number of satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_None_inline",
                   "",
            ],
            [
                   "SINGLE_POINT",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_SinglePoint_inline",
                   "RTK point positioning.",
            ],
            [
                   "RTK point positioning.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_SinglePoint_inline",
                   "",
            ],
            [
                   "FLOAT",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_Float_inline",
                   "Float solution positioning.",
            ],
            [
                   "Float solution positioning.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_Float_inline",
                   "",
            ],
            [
                   "FIXED_POINT",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_FixedPoint_inline",
                   "Fixed-point solution positioning (most accurate).",
            ],
            [
                   "Fixed-point solution positioning (most accurate).",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_FixedPoint_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKState.html",
                   "#DJIRTK_DJIRTKPositioningSolution_Unknown_inline",
                   "",
            ],
            [
                   "HeadingSolution",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_inline",
                   "This enum defines the Heading solution currently being used. The  heading solution describes the method used to determine heading. And  Indicates the accuracy of the `getHeading`. It is  supported by Phantom 4 RTK and Matrice 200 Series V2.",
            ],
            [
                   "This enum defines the Heading solution currently being used. The  heading solution describes the method used to determine heading. And  Indicates the accuracy of the `getHeading`. It is  supported by Phantom 4 RTK and Matrice 200 Series V2.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_None_inline",
                   "No heading solution. This can be caused by an insufficient number of  satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
            ],
            [
                   "No heading solution. This can be caused by an insufficient number of  satellites in view, insufficient time to lock onto the satellites, or a  loss in communication link between the mobile station and base station.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_None_inline",
                   "",
            ],
            [
                   "SINGLE_POINT",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_SinglePoint_inline",
                   "RTK point Heading.",
            ],
            [
                   "RTK point Heading.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_SinglePoint_inline",
                   "",
            ],
            [
                   "FLOAT",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_Float_inline",
                   "Float solution Heading.",
            ],
            [
                   "Float solution Heading.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_Float_inline",
                   "",
            ],
            [
                   "FIXED_POINT",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_FixedPoint_inline",
                   "Fixed-point solution direction (most accurate).",
            ],
            [
                   "Fixed-point solution direction (most accurate).",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_FixedPoint_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKHeadingSolution_Unknown_inline",
                   "",
            ],
            [
                   "GPS",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_GPS_inline",
                   "The location coordinate is from GPS.",
            ],
            [
                   "The location coordinate is from GPS.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_GPS_inline",
                   "",
            ],
            [
                   "RTK",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_RTK_inline",
                   "The location coordinate is from RTK.",
            ],
            [
                   "The location coordinate is from RTK.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_RTK_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_Unknown_inline",
                   "Data source is unknown.",
            ],
            [
                   "Data source is unknown.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKDataSource_Unknown_inline",
                   "",
            ],
            [
                   "WGS84",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_WGS84_inline",
                   "The coordinate system is World Geodetic System 1984.",
            ],
            [
                   "The coordinate system is World Geodetic System 1984.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_WGS84_inline",
                   "",
            ],
            [
                   "CGCS2000",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_CGCS2000_inline",
                   "The coordinate system is China Geodetic Coordinate System 2000.",
            ],
            [
                   "The coordinate system is China Geodetic Coordinate System 2000.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_CGCS2000_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_Unknown_inline",
                   "The coordinate system is unknown.",
            ],
            [
                   "The coordinate system is unknown.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceCoordinateSystem_Unknown_inline",
                   "",
            ],
            [
                   "NOT_PURCHASED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_NotPurchased_inline",
                   "Network RTK service is not purchased.",
            ],
            [
                   "Network RTK service is not purchased.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_NotPurchased_inline",
                   "",
            ],
            [
                   "UNBOUND",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Unbound_inline",
                   "Device is not bound.",
            ],
            [
                   "Device is not bound.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Unbound_inline",
                   "",
            ],
            [
                   "BOUND",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Bound_inline",
                   "Device is bound.",
            ],
            [
                   "Device is bound.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Bound_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Unknown_inline",
                   "Network RTK service account state is unknown.",
            ],
            [
                   "Network RTK service account state is unknown.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServiceAccountState_Unknown_inline",
                   "",
            ],
            [
                   "A",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_A_inline",
                   "Plan type A.",
            ],
            [
                   "Plan type A.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_A_inline",
                   "",
            ],
            [
                   "B",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_B_inline",
                   "Plan type B.",
            ],
            [
                   "Plan type B.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_B_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_Unknown_inline",
                   "Unknown Plan type.",
            ],
            [
                   "Unknown Plan type.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanType_Unknown_inline",
                   "",
            ],
            [
                   "UNACTIVATED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Unactivated_inline",
                   "The plan has not activated.",
            ],
            [
                   "The plan has not activated.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Unactivated_inline",
                   "",
            ],
            [
                   "ACTIVATED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Activated_inline",
                   "The plan has activated.",
            ],
            [
                   "The plan has activated.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Activated_inline",
                   "",
            ],
            [
                   "EXPIRED",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Expired_inline",
                   "The plan has Expired.",
            ],
            [
                   "The plan has Expired.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Expired_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Unknown_inline",
                   "The plan state is unknown.",
            ],
            [
                   "The plan state is unknown.",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "#DJIRTK_DJIRTKNetworkServicePlanState_Unknown_inline",
                   "",
            ],
            [
                   "ReceiverInfo",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "",
                   "Single RTK receiver information. Each receiver is connected to a single antenna.",
            ],
            [
                   "Single RTK receiver information. Each receiver is connected to a single antenna.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "",
                   "",
            ],
            [
                   "isConstellationSupported",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "#DJIRTK_DJIRTKReceiverInfo_isConstellationSupported_inline",
                   "`true` if constellation is supported. The European and American versions of RTK support GPS and GLONASS, while the Asia Pacific version supports GPS and BeiDou.  @return A boolean value.",
            ],
            [
                   "`true` if constellation is supported. The European and American versions of RTK support GPS and GLONASS, while the Asia Pacific version supports GPS and BeiDou.  @return A boolean value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "#DJIRTK_DJIRTKReceiverInfo_isConstellationSupported_inline",
                   "",
            ],
            [
                   "getSatelliteCount",
                   2,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "#DJIRTK_DJIRTKReceiverInfo_satelliteCount_inline",
                   "Valid satellite count for this receiver.  @return An int value.",
            ],
            [
                   "Valid satellite count for this receiver.  @return An int value.",
                   1,
                   "/Components/RTK/DJIRTK_DJIRTKReceiverInfo.html",
                   "#DJIRTK_DJIRTKReceiverInfo_satelliteCount_inline",
                   "",
            ],
            [
                   "LocationStandardDeviation",
                   2,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "",
                   "Standard deviation of location accuracy in meters. Only Supported by Phantom 4 RTK.",
            ],
            [
                   "Standard deviation of location accuracy in meters. Only Supported by Phantom 4 RTK.",
                   1,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "",
                   "",
            ],
            [
                   "getStdLatitude",
                   2,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_latitude_inline",
                   "Latitude standard deviation in meters.  @return A float value of the latitude.",
            ],
            [
                   "Latitude standard deviation in meters.  @return A float value of the latitude.",
                   1,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_latitude_inline",
                   "",
            ],
            [
                   "getStdLongitude",
                   2,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_longtitude_inline",
                   "Longitude standard deviation in meters.  @return A float value of the longitude.",
            ],
            [
                   "Longitude standard deviation in meters.  @return A float value of the longitude.",
                   1,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_longtitude_inline",
                   "",
            ],
            [
                   "getStdAltitude",
                   2,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_altitude_inline",
                   "Altitude standard deviation in meters.  @return A float value of the altitude.",
            ],
            [
                   "Altitude standard deviation in meters.  @return A float value of the altitude.",
                   1,
                   "/Components/RTK/DJIRTK_DJILocationStandardDeviation.html",
                   "#DJIRTK_DJILocationStandardDeviation_altitude_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setUpdateSystemStateCallback_inline",
                   "Sets the callback function that updates the flight controller's current state data. This method is called 10 times per second.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the callback function that updates the flight controller's current state data. This method is called 10 times per second.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setUpdateSystemStateCallback_inline",
                   "",
            ],
            [
                   "setIMUStateCallback",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setOnIMUStateChangedCallback_inline",
                   "Sets the IMU State callback, which will receive the changed state of the IMU.  @param callback The callback for receiving the changed state of IMU.",
            ],
            [
                   "Sets the IMU State callback, which will receive the changed state of the IMU.  @param callback The callback for receiving the changed state of IMU.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setOnIMUStateChangedCallback_inline",
                   "",
            ],
            [
                   "setASBInformationCallback",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setASBInformationCallback_inline",
                   "Sets the AirSenseSystemInformation callback, which will receive the AirSenseSystemInformation.  @param callback The callback for receiving the `AirSenseSystemInformation`.",
            ],
            [
                   "Sets the AirSenseSystemInformation callback, which will receive the AirSenseSystemInformation.  @param callback The callback for receiving the `AirSenseSystemInformation`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setASBInformationCallback_inline",
                   "",
            ],
            [
                   "setOnboardSDKDeviceDataCallback",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setReceiveExternalDeviceDataCallback_inline",
                   "Sets the callback function that updates the data received from an external device (e.g. the onboard device).  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the callback function that updates the data received from an external device (e.g. the onboard device).  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setReceiveExternalDeviceDataCallback_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCurrentState_inline",
                   "Returns the current state of flight controller.  @return An instance of `FlightControllerState`.",
            ],
            [
                   "Returns the current state of flight controller.  @return An instance of `FlightControllerState`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCurrentState_inline",
                   "",
            ],
            [
                   "getCompass",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_compass_inline",
                   "Compass object.  @return An instance of `Compass`.",
            ],
            [
                   "Compass object.  @return An instance of `Compass`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_compass_inline",
                   "",
            ],
            [
                   "getCompassCount",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCompassCount_inline",
                   "Number of Compass modules in the flight controller.  @return An int value.",
            ],
            [
                   "Number of Compass modules in the flight controller.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCompassCount_inline",
                   "",
            ],
            [
                   "getRTK",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_RTK_inline",
                   "RTK positioning object.  @return An instance of `RTK`.",
            ],
            [
                   "RTK positioning object.  @return An instance of `RTK`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_RTK_inline",
                   "",
            ],
            [
                   "savePipelinesLog",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIOnboardSDKDevice_savePipelinesLog_inline",
                   "Sets true to save log for pipelines. In order to improve developer's experience on SDK interconnectivity, DJIPipeline</code> is designed to save log files locally when files are transferred, during which the speed is 475KB per minute. Please be careful with the device storage.  @param enabled `true` to save log files.",
            ],
            [
                   "Sets true to save log for pipelines. In order to improve developer's experience on SDK interconnectivity, DJIPipeline</code> is designed to save log files locally when files are transferred, during which the speed is 475KB per minute. Please be careful with the device storage.  @param enabled `true` to save log files.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIOnboardSDKDevice_savePipelinesLog_inline",
                   "",
            ],
            [
                   "getPipelines",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIOnboardSDKDevice_getPipelines_inline",
                   "The pipelines to transmit data between onboard device and DJI mobile SDK. It's only supported by Matrice 300 RTK.  @return An instance of DJIPipelines</code>.",
            ],
            [
                   "The pipelines to transmit data between onboard device and DJI mobile SDK. It's only supported by Matrice 300 RTK.  @return An instance of DJIPipelines</code>.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIOnboardSDKDevice_getPipelines_inline",
                   "",
            ],
            [
                   "getIMUCount",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_numberOfIMUS_inline",
                   "Number of IMU modules in the flight controller. Most products have one IMU.  Exceptions:  - Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2 each have two IMUs  - A3, Matrice 600, and Matrice 600 Pro each have one inner IMU and can have at most two external IMUs.  - N3 has two inner IMUs and can have one external IMU.  @return An int value.",
            ],
            [
                   "Number of IMU modules in the flight controller. Most products have one IMU.  Exceptions:  - Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2 each have two IMUs  - A3, Matrice 600, and Matrice 600 Pro each have one inner IMU and can have at most two external IMUs.  - N3 has two inner IMUs and can have one external IMU.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_numberOfIMUS_inline",
                   "",
            ],
            [
                   "IMU_COUNT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_numberOfIMUS_inline",
                   "SDK Key for getIMUCount: Number of IMU modules in the flight controller. Most products have one IMU.  Exceptions:  - Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2 each have two IMUs  - A3, Matrice 600, and Matrice 600 Pro each have one inner IMU and can have at most two external IMUs.  - N3 has two inner IMUs and can have one external IMU.  @return An int value.",
            ],
            [
                   "SDK Key for getIMUCount: Number of IMU modules in the flight controller. Most products have one IMU.  Exceptions:  - Phantom 4, Phantom 4 Pro, Mavic Pro, and Inspire 2 each have two IMUs  - A3, Matrice 600, and Matrice 600 Pro each have one inner IMU and can have at most two external IMUs.  - N3 has two inner IMUs and can have one external IMU.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_numberOfIMUS_inline",
                   "",
            ],
            [
                   "startIMUCalibration",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibration_inline",
                   "Starts IMU calibration. For aircraft with multiple IMUs, this method will start the calibration of all IMUs. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration. It is recommended to invoke `reboot` after IMU calibration.  @param callback Completion callback.",
            ],
            [
                   "Starts IMU calibration. For aircraft with multiple IMUs, this method will start the calibration of all IMUs. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration. It is recommended to invoke `reboot` after IMU calibration.  @param callback Completion callback.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibration_inline",
                   "",
            ],
            [
                   "START_IMU_CALIBRATION",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibration_inline",
                   "SDK Key for startIMUCalibration: Starts IMU calibration. For aircraft with multiple IMUs, this method will start the calibration of all IMUs. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration. It is recommended to invoke `reboot` after IMU calibration.  @param callback Completion callback.",
            ],
            [
                   "SDK Key for startIMUCalibration: Starts IMU calibration. For aircraft with multiple IMUs, this method will start the calibration of all IMUs. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration. It is recommended to invoke `reboot` after IMU calibration.  @param callback Completion callback.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibration_inline",
                   "",
            ],
            [
                   "startIMUCalibration",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibrationForID_inline",
                   "Starts the calibration for IMU with a specific ID. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration.  @param index The IMU with the specific ID to calibrate. @param callback Completion callback to check if the calibration starts successfully.",
            ],
            [
                   "Starts the calibration for IMU with a specific ID. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration.  @param index The IMU with the specific ID to calibrate. @param callback Completion callback to check if the calibration starts successfully.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibrationForID_inline",
                   "",
            ],
            [
                   "START_IMU_CALIBRATION_WITH_ID",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibrationForID_inline",
                   "SDK Key for startIMUCalibration: Starts the calibration for IMU with a specific ID. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration.  @param index The IMU with the specific ID to calibrate. @param callback Completion callback to check if the calibration starts successfully.",
            ],
            [
                   "SDK Key for startIMUCalibration: Starts the calibration for IMU with a specific ID. Keep the aircraft stationary and horizontal during calibration, which will take 5 to 10 minutes. The completion block will be called once the calibration is started. Use the `onUpdate` method to check the execution status of the IMU calibration. It is recommended to reboot the device after IMU calibration.  @param index The IMU with the specific ID to calibrate. @param callback Completion callback to check if the calibration starts successfully.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startIMUCalibrationForID_inline",
                   "",
            ],
            [
                   "startGravityCenterCalibration",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startGravityCenterCalibration_inline",
                   "Starts gravity center calibration. Keep the aircraft hover without wind during calibration. The completion block will be called once the calibration is started.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Starts gravity center calibration. Keep the aircraft hover without wind during calibration. The completion block will be called once the calibration is started.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_startGravityCenterCalibration_inline",
                   "",
            ],
            [
                   "stopGravityCenterCalibration",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_stopGravityCenterCalibration_inline",
                   "Stop gravity center calibration.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Stop gravity center calibration.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_stopGravityCenterCalibration_inline",
                   "",
            ],
            [
                   "getLandingGear",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_landingGear_inline",
                   "Landing Gear object. For products with movable landing gear only.  @return An instance of `LandingGear`.",
            ],
            [
                   "Landing Gear object. For products with movable landing gear only.  @return An instance of `LandingGear`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_landingGear_inline",
                   "",
            ],
            [
                   "isLandingGearMovable",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLandingGearMovable_inline",
                   "`true` if landing gear is supported for the connected aircraft.  @return A boolean value.",
            ],
            [
                   "`true` if landing gear is supported for the connected aircraft.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLandingGearMovable_inline",
                   "",
            ],
            [
                   "IS_LANDING_GEAR_MOVABLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLandingGearMovable_inline",
                   "SDK Key for isLandingGearMovable: `true` if landing gear is supported for the connected aircraft.  @return A boolean value.",
            ],
            [
                   "SDK Key for isLandingGearMovable: `true` if landing gear is supported for the connected aircraft.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLandingGearMovable_inline",
                   "",
            ],
            [
                   "getSimulator",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_simulator_inline",
                   "Simulator object.  @return An instance of `Simulator`.",
            ],
            [
                   "Simulator object.  @return An instance of `Simulator`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_simulator_inline",
                   "",
            ],
            [
                   "isOnboardSDKDeviceAvailable",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isOnboardSDKDeviceAvailable_inline",
                   "Returns if the Onboard SDK feature is available on the connected product.  @return A boolean value.",
            ],
            [
                   "Returns if the Onboard SDK feature is available on the connected product.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isOnboardSDKDeviceAvailable_inline",
                   "",
            ],
            [
                   "IS_ON_BOARD_SDK_AVAILABLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isOnboardSDKDeviceAvailable_inline",
                   "SDK Key for isOnboardSDKDeviceAvailable: Returns if the Onboard SDK feature is available on the connected product.  @return A boolean value.",
            ],
            [
                   "SDK Key for isOnboardSDKDeviceAvailable: Returns if the Onboard SDK feature is available on the connected product.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isOnboardSDKDeviceAvailable_inline",
                   "",
            ],
            [
                   "sendDataToOnboardSDKDevice",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_sendDataToOnboardSDKDevice_inline",
                   "If there is a device connected to the aircraft using the Onboard SDK, this method will send data to that device. The size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. This method is only supported on products that support the Onboard SDK (Matrice 210 V1, Matrice 210 V2, Matrice 300 RTK, Matrice 100, Matrice 600, Matrice 600 Pro, A3, A3 Pro, and N3).  @param data Data to be sent to the external device. The size of the data should not be larger than 100 bytes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "If there is a device connected to the aircraft using the Onboard SDK, this method will send data to that device. The size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. This method is only supported on products that support the Onboard SDK (Matrice 210 V1, Matrice 210 V2, Matrice 300 RTK, Matrice 100, Matrice 600, Matrice 600 Pro, A3, A3 Pro, and N3).  @param data Data to be sent to the external device. The size of the data should not be larger than 100 bytes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_sendDataToOnboardSDKDevice_inline",
                   "",
            ],
            [
                   "SEND_DATA_TO_ON_BOARD_SDK_DEVICE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_sendDataToOnboardSDKDevice_inline",
                   "SDK Key for sendDataToOnboardSDKDevice: If there is a device connected to the aircraft using the Onboard SDK, this method will send data to that device. The size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. This method is only supported on products that support the Onboard SDK (Matrice 210 V1, Matrice 210 V2, Matrice 300 RTK, Matrice 100, Matrice 600, Matrice 600 Pro, A3, A3 Pro, and N3).  @param data Data to be sent to the external device. The size of the data should not be larger than 100 bytes. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for sendDataToOnboardSDKDevice: If there is a device connected to the aircraft using the Onboard SDK, this method will send data to that device. The size of the data cannot be greater than 100 bytes, and will be sent in 40 byte increments every 14ms. This method is only supported on products that support the Onboard SDK (Matrice 210 V1, Matrice 210 V2, Matrice 300 RTK, Matrice 100, Matrice 600, Matrice 600 Pro, A3, A3 Pro, and N3).  @param data Data to be sent to the external device. The size of the data should not be larger than 100 bytes. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_sendDataToOnboardSDKDevice_inline",
                   "",
            ],
            [
                   "turnOnMotors",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOnMotors_inline",
                   "Turns on the aircraft's motors. Supported by flight controller firmware 3.1.0.0 or above.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Turns on the aircraft's motors. Supported by flight controller firmware 3.1.0.0 or above.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOnMotors_inline",
                   "",
            ],
            [
                   "TURN_ON_MOTORS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOnMotors_inline",
                   "SDK Key for turnOnMotors: Turns on the aircraft's motors. Supported by flight controller firmware 3.1.0.0 or above.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for turnOnMotors: Turns on the aircraft's motors. Supported by flight controller firmware 3.1.0.0 or above.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOnMotors_inline",
                   "",
            ],
            [
                   "turnOffMotors",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOffMotors_inline",
                   "Turns off the aircraft's motors. The method can only be called when the aircraft is on the ground.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Turns off the aircraft's motors. The method can only be called when the aircraft is on the ground.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOffMotors_inline",
                   "",
            ],
            [
                   "TURN_OFF_MOTORS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOffMotors_inline",
                   "SDK Key for turnOffMotors: Turns off the aircraft's motors. The method can only be called when the aircraft is on the ground.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for turnOffMotors: Turns off the aircraft's motors. The method can only be called when the aircraft is on the ground.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_turnOffMotors_inline",
                   "",
            ],
            [
                   "setUrgentStopModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setUrgentStopModeEnabled_inline",
                   "Enables urgent stop mode. When urgent stop mode is enabled, the motor can be stopped by pushing sticks inner/outer simultaneously at any time. Use with caution. Supported only by Phantom 4 RTK.  @param enabled `true` to enable urgent stop mode. @param callback Callback that receives the setter execution result.",
            ],
            [
                   "Enables urgent stop mode. When urgent stop mode is enabled, the motor can be stopped by pushing sticks inner/outer simultaneously at any time. Use with caution. Supported only by Phantom 4 RTK.  @param enabled `true` to enable urgent stop mode. @param callback Callback that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setUrgentStopModeEnabled_inline",
                   "",
            ],
            [
                   "getUrgentStopModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getUrgentStopModeEnabled_inline",
                   "Gets if urgent stop mode is enabled or not. Supported only by Phantom 4 RTK.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Gets if urgent stop mode is enabled or not. Supported only by Phantom 4 RTK.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getUrgentStopModeEnabled_inline",
                   "",
            ],
            [
                   "setESCBeepEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setESCBeepEnabled_inline",
                   "Enables ESC beeping.  @param enabled `true` to enable ESC beeping. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enables ESC beeping.  @param enabled `true` to enable ESC beeping. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setESCBeepEnabled_inline",
                   "",
            ],
            [
                   "getESCBeepEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getESCBeepEnabled_inline",
                   "Determines if ESC beeping is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if ESC beeping is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getESCBeepEnabled_inline",
                   "",
            ],
            [
                   "setGravityCenterStateCallback",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGravityStateCallback_inline",
                   "Sets the callback function that updates the gravity calibration's current state data.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the callback function that updates the gravity calibration's current state data.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGravityStateCallback_inline",
                   "",
            ],
            [
                   "startTakeoff",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_takeOff_inline",
                   "Starts aircraft takeoff. Takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts aircraft takeoff. Takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_takeOff_inline",
                   "",
            ],
            [
                   "TAKE_OFF",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_takeOff_inline",
                   "SDK Key for startTakeoff: Starts aircraft takeoff. Takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startTakeoff: Starts aircraft takeoff. Takeoff is considered complete when the aircraft is hovering 1.2 meters (4 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_takeOff_inline",
                   "",
            ],
            [
                   "startPrecisionTakeoff",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_precisionTakeOff_inline",
                   "Starts aircraft precision takeoff. Precision Takeoff is considered complete when the aircraft is hovering 6 meters (20 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  This feature need vision assisted positioning enabled on.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts aircraft precision takeoff. Precision Takeoff is considered complete when the aircraft is hovering 6 meters (20 feet) above the ground. Completion block is called when aircraft crosses 0.5 meters (1.6 feet). If the motors are already on, this command cannot be executed.  This feature need vision assisted positioning enabled on.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_precisionTakeOff_inline",
                   "",
            ],
            [
                   "cancelTakeoff",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelTakeOff_inline",
                   "Stops aircraft takeoff. If called before `startTakeoff` is complete, the aircraft will cancel takeoff (`startTakeoff` completion block will return an error) and hover at the current height.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops aircraft takeoff. If called before `startTakeoff` is complete, the aircraft will cancel takeoff (`startTakeoff` completion block will return an error) and hover at the current height.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelTakeOff_inline",
                   "",
            ],
            [
                   "CANCEL_TAKE_OFF",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelTakeOff_inline",
                   "SDK Key for cancelTakeoff: Stops aircraft takeoff. If called before `startTakeoff` is complete, the aircraft will cancel takeoff (`startTakeoff` completion block will return an error) and hover at the current height.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for cancelTakeoff: Stops aircraft takeoff. If called before `startTakeoff` is complete, the aircraft will cancel takeoff (`startTakeoff` completion block will return an error) and hover at the current height.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelTakeOff_inline",
                   "",
            ],
            [
                   "startLanding",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_autoLanding_inline",
                   "Starts auto-landing of the aircraft. Returns completion block once aircraft begins to descend for auto-land.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Starts auto-landing of the aircraft. Returns completion block once aircraft begins to descend for auto-land.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_autoLanding_inline",
                   "",
            ],
            [
                   "START_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_autoLanding_inline",
                   "SDK Key for startLanding: Starts auto-landing of the aircraft. Returns completion block once aircraft begins to descend for auto-land.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startLanding: Starts auto-landing of the aircraft. Returns completion block once aircraft begins to descend for auto-land.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_autoLanding_inline",
                   "",
            ],
            [
                   "cancelLanding",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelAutoLanding_inline",
                   "Stops auto-landing of the aircraft. If called before `startLanding` is complete, then the auto landing will be canceled (`startLanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Stops auto-landing of the aircraft. If called before `startLanding` is complete, then the auto landing will be canceled (`startLanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelAutoLanding_inline",
                   "",
            ],
            [
                   "CANCEL_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelAutoLanding_inline",
                   "SDK Key for cancelLanding: Stops auto-landing of the aircraft. If called before `startLanding` is complete, then the auto landing will be canceled (`startLanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for cancelLanding: Stops auto-landing of the aircraft. If called before `startLanding` is complete, then the auto landing will be canceled (`startLanding` completion block will return an error) and the aircraft will hover at its current location.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelAutoLanding_inline",
                   "",
            ],
            [
                   "confirmLanding",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmLanding_inline",
                   "Confirms continuation of landing action. When the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. Can use `isLandingConfirmationNeeded` in `FlightControllerState` to check if confirmation is needed. It is supported by flight controller firmware 3.2.0.0 and above.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Confirms continuation of landing action. When the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. Can use `isLandingConfirmationNeeded` in `FlightControllerState` to check if confirmation is needed. It is supported by flight controller firmware 3.2.0.0 and above.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmLanding_inline",
                   "",
            ],
            [
                   "CONFIRM_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmLanding_inline",
                   "SDK Key for confirmLanding: Confirms continuation of landing action. When the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. Can use `isLandingConfirmationNeeded` in `FlightControllerState` to check if confirmation is needed. It is supported by flight controller firmware 3.2.0.0 and above.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for confirmLanding: Confirms continuation of landing action. When the clearance between the aircraft and the ground is less than 0.3m, the aircraft will pause landing and wait for user's confirmation. Can use `isLandingConfirmationNeeded` in `FlightControllerState` to check if confirmation is needed. It is supported by flight controller firmware 3.2.0.0 and above.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmLanding_inline",
                   "",
            ],
            [
                   "setLEDsEnabledSettings",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLEDsEnabledSettings_inline",
                   "Turns on/off different sets of LEDs on the aircraft. All the LEDs are on by default.  @param ledsSettings Settings to control LEDs. @param callback Completion callback that receives the setter execution result.",
            ],
            [
                   "Turns on/off different sets of LEDs on the aircraft. All the LEDs are on by default.  @param ledsSettings Settings to control LEDs. @param callback Completion callback that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLEDsEnabledSettings_inline",
                   "",
            ],
            [
                   "LEDS_ENABLED_SETTINGS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLEDsEnabledSettings_inline",
                   "SDK Key for setLEDsEnabledSettings: Turns on/off different sets of LEDs on the aircraft. All the LEDs are on by default.  @param ledsSettings Settings to control LEDs. @param callback Completion callback that receives the setter execution result.",
            ],
            [
                   "SDK Key for setLEDsEnabledSettings: Turns on/off different sets of LEDs on the aircraft. All the LEDs are on by default.  @param ledsSettings Settings to control LEDs. @param callback Completion callback that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLEDsEnabledSettings_inline",
                   "",
            ],
            [
                   "getLEDsEnabledSettings",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLEDsEnabledSettings_inline",
                   "Determines the status of LEDs on the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines the status of LEDs on the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLEDsEnabledSettings_inline",
                   "",
            ],
            [
                   "isVirtualStickControlModeAvailable",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_isVirtualStickControlModeAvailable_inline",
                   "Indicates whether the virtual stick control interface can be used. Virtual stick mode is only available when all of the follow requirements are met:  - Virtual stick mode is enabled.  - No waypoint, hotpoint, or follow-me mission is running.  - `FlightOrientationMode` is set to `AIRCRAFT_HEADING`  - Terrain-follow is disabled if the aircraft supports this feature.  - Tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
            ],
            [
                   "Indicates whether the virtual stick control interface can be used. Virtual stick mode is only available when all of the follow requirements are met:  - Virtual stick mode is enabled.  - No waypoint, hotpoint, or follow-me mission is running.  - `FlightOrientationMode` is set to `AIRCRAFT_HEADING`  - Terrain-follow is disabled if the aircraft supports this feature.  - Tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_isVirtualStickControlModeAvailable_inline",
                   "",
            ],
            [
                   "IS_VIRTUAL_STICK_CONTROL_MODE_AVAILABLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_isVirtualStickControlModeAvailable_inline",
                   "SDK Key for isVirtualStickControlModeAvailable: Indicates whether the virtual stick control interface can be used. Virtual stick mode is only available when all of the follow requirements are met:  - Virtual stick mode is enabled.  - No waypoint, hotpoint, or follow-me mission is running.  - `FlightOrientationMode` is set to `AIRCRAFT_HEADING`  - Terrain-follow is disabled if the aircraft supports this feature.  - Tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
            ],
            [
                   "SDK Key for isVirtualStickControlModeAvailable: Indicates whether the virtual stick control interface can be used. Virtual stick mode is only available when all of the follow requirements are met:  - Virtual stick mode is enabled.  - No waypoint, hotpoint, or follow-me mission is running.  - `FlightOrientationMode` is set to `AIRCRAFT_HEADING`  - Terrain-follow is disabled if the aircraft supports this feature.  - Tripod mode is disabled if the aircraft supports this feature.  @return `true` if virtual stick mode is available.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_isVirtualStickControlModeAvailable_inline",
                   "",
            ],
            [
                   "setVirtualStickModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_setVirtualStickModeEnabled_inline",
                   "Enables/disables virtual stick control mode. By enabling virtual stick control mode, the aircraft can be controlled using `sendVirtualStickFlightControlData`. Not supported by Mavic Pro when using the WiFi connection.  @param enabled `true` to enable virtual stick mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables virtual stick control mode. By enabling virtual stick control mode, the aircraft can be controlled using `sendVirtualStickFlightControlData`. Not supported by Mavic Pro when using the WiFi connection.  @param enabled `true` to enable virtual stick mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_setVirtualStickModeEnabled_inline",
                   "",
            ],
            [
                   "VIRTUAL_STICK_CONTROL_MODE_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_setVirtualStickModeEnabled_inline",
                   "SDK Key for setVirtualStickModeEnabled: Enables/disables virtual stick control mode. By enabling virtual stick control mode, the aircraft can be controlled using `sendVirtualStickFlightControlData`. Not supported by Mavic Pro when using the WiFi connection.  @param enabled `true` to enable virtual stick mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setVirtualStickModeEnabled: Enables/disables virtual stick control mode. By enabling virtual stick control mode, the aircraft can be controlled using `sendVirtualStickFlightControlData`. Not supported by Mavic Pro when using the WiFi connection.  @param enabled `true` to enable virtual stick mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_setVirtualStickModeEnabled_inline",
                   "",
            ],
            [
                   "getVirtualStickModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_getVirtualStickModeEnabled_inline",
                   "Gets virtual stick mode status (enabled/disabled). Not supported by Mavic Pro when using the WiFi connection.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets virtual stick mode status (enabled/disabled). Not supported by Mavic Pro when using the WiFi connection.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_getVirtualStickModeEnabled_inline",
                   "",
            ],
            [
                   "VIRTUAL_STICK_CONTROL_MODE_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_getVirtualStickModeEnabled_inline",
                   "SDK Key for getVirtualStickModeEnabled: Gets virtual stick mode status (enabled/disabled). Not supported by Mavic Pro when using the WiFi connection.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getVirtualStickModeEnabled: Gets virtual stick mode status (enabled/disabled). Not supported by Mavic Pro when using the WiFi connection.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_getVirtualStickModeEnabled_inline",
                   "",
            ],
            [
                   "isVirtualStickAdvancedModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_virtualStickAdvancedModeEnabled_inline",
                   "`true` if Virtual Stick advanced mode is enabled. By default, it is `false`. Assuming GPS signal is good, advanced mode will allow aircraft to compensate for wind when hovering. For the Phantom 4, collision avoidance can be enabled for virtual stick control if advanced mode is on, and collision avoidance is enabled in `FlightAssistant`. Only supported by flight controller firmware versions 3.1.x.x or above. CAUTION: It will be reset to `false` when the flight controller is reconnected.  @return A boolean value.",
            ],
            [
                   "`true` if Virtual Stick advanced mode is enabled. By default, it is `false`. Assuming GPS signal is good, advanced mode will allow aircraft to compensate for wind when hovering. For the Phantom 4, collision avoidance can be enabled for virtual stick control if advanced mode is on, and collision avoidance is enabled in `FlightAssistant`. Only supported by flight controller firmware versions 3.1.x.x or above. CAUTION: It will be reset to `false` when the flight controller is reconnected.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_virtualStickAdvancedModeEnabled_inline",
                   "",
            ],
            [
                   "setVirtualStickAdvancedModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setVirtualStickAdvancedModeEnabled_inline",
                   "Set `true` to enable Virtual Stick advanced mode. By default, it is `false`. Assuming GPS signal is good, advanced mode will allow aircraft to compensate for wind when hovering.   For the Phantom 4, collision avoidance can be enabled for virtual stick   control if advanced mode is on, and collision avoidance is enabled in `FlightAssistant`.   Only supported by flight controller firmware versions 3.1.0.0 or above.  @param virtualStickAdvancedModeEnabled True</code> for enabling advanced mode.",
            ],
            [
                   "Set `true` to enable Virtual Stick advanced mode. By default, it is `false`. Assuming GPS signal is good, advanced mode will allow aircraft to compensate for wind when hovering.   For the Phantom 4, collision avoidance can be enabled for virtual stick   control if advanced mode is on, and collision avoidance is enabled in `FlightAssistant`.   Only supported by flight controller firmware versions 3.1.0.0 or above.  @param virtualStickAdvancedModeEnabled True</code> for enabling advanced mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setVirtualStickAdvancedModeEnabled_inline",
                   "",
            ],
            [
                   "getVerticalControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_verticalControlMode_inline",
                   "The vertical control mode for virtual stick. CAUTION: It will be reset to `VELOCITY` when the flight controller is reconnected.  @return An enum value of `VerticalControlMode`.",
            ],
            [
                   "The vertical control mode for virtual stick. CAUTION: It will be reset to `VELOCITY` when the flight controller is reconnected.  @return An enum value of `VerticalControlMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_verticalControlMode_inline",
                   "",
            ],
            [
                   "setVerticalControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setVerticalControlMode_inline",
                   "Sets whether virtual stick vertical controller changes aircraft's altitude or vertical velocity.  @param verticalControlMode A specific DJIVirtualStickVerticalControlMode object.",
            ],
            [
                   "Sets whether virtual stick vertical controller changes aircraft's altitude or vertical velocity.  @param verticalControlMode A specific DJIVirtualStickVerticalControlMode object.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setVerticalControlMode_inline",
                   "",
            ],
            [
                   "getRollPitchControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rollPitchControlMode_inline",
                   "The roll and pitch control mode for virtual stick. CAUTION: It will be reset to `ANGLE` when the flight controller is reconnected.  @return An enum value of `RollPitchControlMode`.",
            ],
            [
                   "The roll and pitch control mode for virtual stick. CAUTION: It will be reset to `ANGLE` when the flight controller is reconnected.  @return An enum value of `RollPitchControlMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rollPitchControlMode_inline",
                   "",
            ],
            [
                   "setRollPitchControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setRollPitchControlMode_inline",
                   "Sets whether roll/pitch virtual controllers change aircraft's angle relative to level orientation, or aircraft's velocity on horizontal axes.  @param rollPitchControlMode A specific DJIVirtualStickRollPitchControlMode object.",
            ],
            [
                   "Sets whether roll/pitch virtual controllers change aircraft's angle relative to level orientation, or aircraft's velocity on horizontal axes.  @param rollPitchControlMode A specific DJIVirtualStickRollPitchControlMode object.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setRollPitchControlMode_inline",
                   "",
            ],
            [
                   "getYawControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_yawControlMode_inline",
                   "The yaw control mode for virtual stick. CAUTION: It will be reset to `ANGLE` when the flight controller is reconnected.  @return An enum value of `YawControlMode`.",
            ],
            [
                   "The yaw control mode for virtual stick. CAUTION: It will be reset to `ANGLE` when the flight controller is reconnected.  @return An enum value of `YawControlMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_yawControlMode_inline",
                   "",
            ],
            [
                   "setYawControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setYawControlMode_inline",
                   "Sets whether virtual stick yaw controller changes aircraft's heading by angle or by angular velocity.  @param yawControlMode A specific DJIVirtualStickYawControlMode object.",
            ],
            [
                   "Sets whether virtual stick yaw controller changes aircraft's heading by angle or by angular velocity.  @param yawControlMode A specific DJIVirtualStickYawControlMode object.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setYawControlMode_inline",
                   "",
            ],
            [
                   "getRollPitchCoordinateSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rollPitchCoordinateSystem_inline",
                   "The coordinate system for virtual stick. CAUTION: It will be reset to `GROUND` when the flight controller is reconnected.  @return Coordinate system object.",
            ],
            [
                   "The coordinate system for virtual stick. CAUTION: It will be reset to `GROUND` when the flight controller is reconnected.  @return Coordinate system object.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rollPitchCoordinateSystem_inline",
                   "",
            ],
            [
                   "setRollPitchCoordinateSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setRollPitchCoordinateSystem_inline",
                   "Sets whether horizontal axes are fixed relative to the ground or to the aircraft.  @param rollPitchCoordinateSystem A specific rollPitchCoordinateSystem object.",
            ],
            [
                   "Sets whether horizontal axes are fixed relative to the ground or to the aircraft.  @param rollPitchCoordinateSystem A specific rollPitchCoordinateSystem object.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setRollPitchCoordinateSystem_inline",
                   "",
            ],
            [
                   "sendVirtualStickFlightControlData",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_sendVirtualStickFlightControlData_inline",
                   "Sends flight control data using virtual stick commands. The `isVirtualStickControlModeAvailable` method must return `true` to use virtual stick commands. Virtual stick commands should be sent to the aircraft between 5 Hz and 25 Hz. If virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controlData Flight control data @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sends flight control data using virtual stick commands. The `isVirtualStickControlModeAvailable` method must return `true` to use virtual stick commands. Virtual stick commands should be sent to the aircraft between 5 Hz and 25 Hz. If virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controlData Flight control data @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_sendVirtualStickFlightControlData_inline",
                   "",
            ],
            [
                   "SEND_VIRTUAL_STICK_FLIGHT_CONTROL_DATA",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_sendVirtualStickFlightControlData_inline",
                   "SDK Key for sendVirtualStickFlightControlData: Sends flight control data using virtual stick commands. The `isVirtualStickControlModeAvailable` method must return `true` to use virtual stick commands. Virtual stick commands should be sent to the aircraft between 5 Hz and 25 Hz. If virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controlData Flight control data @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for sendVirtualStickFlightControlData: Sends flight control data using virtual stick commands. The `isVirtualStickControlModeAvailable` method must return `true` to use virtual stick commands. Virtual stick commands should be sent to the aircraft between 5 Hz and 25 Hz. If virtual stick commands are not sent frequently enough, the aircraft may regard the connection as broken, which will cause the aircraft to hover in place until the next command comes through.  @param controlData Flight control data @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VirtualStickControlModeCategory_sendVirtualStickFlightControlData_inline",
                   "",
            ],
            [
                   "isFlightAssistantSupported",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isIntelligentFlightAssistantSupported_inline",
                   "`true` if the product supports IntelligentFlightAssistant.  @return A boolean value.",
            ],
            [
                   "`true` if the product supports IntelligentFlightAssistant.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isIntelligentFlightAssistantSupported_inline",
                   "",
            ],
            [
                   "IS_FLIGHT_ASSISTANT_SUPPORTED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isIntelligentFlightAssistantSupported_inline",
                   "SDK Key for isFlightAssistantSupported: `true` if the product supports IntelligentFlightAssistant.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFlightAssistantSupported: `true` if the product supports IntelligentFlightAssistant.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isIntelligentFlightAssistantSupported_inline",
                   "",
            ],
            [
                   "getFlightAssistant",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_intelligentFlightAssistant_inline",
                   "Intelligent flight assistant.  @return An instance of `FlightAssistant`.",
            ],
            [
                   "Intelligent flight assistant.  @return An instance of `FlightAssistant`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_intelligentFlightAssistant_inline",
                   "",
            ],
            [
                   "getAccessLocker",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_accessLocker_inline",
                   "Gets the instance of the access locker. It is used to encapsulate the access protection features on the aircraft.  @return Instance of the access locker. `null` if it is not supported by the aircraft.",
            ],
            [
                   "Gets the instance of the access locker. It is used to encapsulate the access protection features on the aircraft.  @return Instance of the access locker. `null` if it is not supported by the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_accessLocker_inline",
                   "",
            ],
            [
                   "isAccessLockerSupported",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isAccessLockerSupported_inline",
                   "`true` if the product supports AccessLocker.  @return A boolean value.",
            ],
            [
                   "`true` if the product supports AccessLocker.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isAccessLockerSupported_inline",
                   "",
            ],
            [
                   "setFlightOrientationMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_setFlightOrientationMode_inline",
                   "Sets the aircraft flight orientation relative to the Aircraft Heading, Course Lock, or Home Lock. See the <i>Flight Controller User Guide</i> for more information about flight orientation. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Mavic Air 2, DJI Air 2S.  @param type The orientation mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the aircraft flight orientation relative to the Aircraft Heading, Course Lock, or Home Lock. See the <i>Flight Controller User Guide</i> for more information about flight orientation. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Mavic Air 2, DJI Air 2S.  @param type The orientation mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_setFlightOrientationMode_inline",
                   "",
            ],
            [
                   "ORIENTATION_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_setFlightOrientationMode_inline",
                   "SDK Key for setFlightOrientationMode: Sets the aircraft flight orientation relative to the Aircraft Heading, Course Lock, or Home Lock. See the <i>Flight Controller User Guide</i> for more information about flight orientation. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Mavic Air 2, DJI Air 2S.  @param type The orientation mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setFlightOrientationMode: Sets the aircraft flight orientation relative to the Aircraft Heading, Course Lock, or Home Lock. See the <i>Flight Controller User Guide</i> for more information about flight orientation. Not supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Mavic Air 2, DJI Air 2S.  @param type The orientation mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_setFlightOrientationMode_inline",
                   "",
            ],
            [
                   "lockCourseUsingCurrentHeading",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_lockCourseUsingCurrentDirection_inline",
                   "Locks the current heading of the aircraft as the Course Lock. Used when Flight Orientation Mode is `COURSE_LOCK`.  @param callback The execution callback with the returned execution result. Please refer to DJIBaseComponent for more information about the block",
            ],
            [
                   "Locks the current heading of the aircraft as the Course Lock. Used when Flight Orientation Mode is `COURSE_LOCK`.  @param callback The execution callback with the returned execution result. Please refer to DJIBaseComponent for more information about the block",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_lockCourseUsingCurrentDirection_inline",
                   "",
            ],
            [
                   "LOCK_COURSE_USING_CURRENT_HEADING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_lockCourseUsingCurrentDirection_inline",
                   "SDK Key for lockCourseUsingCurrentHeading: Locks the current heading of the aircraft as the Course Lock. Used when Flight Orientation Mode is `COURSE_LOCK`.  @param callback The execution callback with the returned execution result. Please refer to DJIBaseComponent for more information about the block",
            ],
            [
                   "SDK Key for lockCourseUsingCurrentHeading: Locks the current heading of the aircraft as the Course Lock. Used when Flight Orientation Mode is `COURSE_LOCK`.  @param callback The execution callback with the returned execution result. Please refer to DJIBaseComponent for more information about the block",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationModeCategory_lockCourseUsingCurrentDirection_inline",
                   "",
            ],
            [
                   "setTripodModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTripodModeEnabled_inline",
                   "Enables/disables tripod mode. Tripod Mode drops the aircraft's maximum speed to 2.2mph (3.6kph), and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. When tripod mode is enabled, missions, terrain follow mode, course lock, and home lock are not allowed. Tripod mode is not allowed if the aircraft is running a mission. If GPS or vision positioning aren't available, tripod mode cannot be enabled. If the GPS and/or the vision system is providing the flight controller with velocity information, the aircraft will be able to automatically compensate for wind. If however, position information is not available, manual intervention will be required. User should beware that any manual compensation will be limited due to the reduced maximum velocity and sensitivity. If GPS and vision position become unavailable while in tripod mode, it is advisable to alert the user and disable Tripod Mode. Not supported by Mavic 2 Enterprise Advanced.  @param enabled `true` to enable tripod mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enables/disables tripod mode. Tripod Mode drops the aircraft's maximum speed to 2.2mph (3.6kph), and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. When tripod mode is enabled, missions, terrain follow mode, course lock, and home lock are not allowed. Tripod mode is not allowed if the aircraft is running a mission. If GPS or vision positioning aren't available, tripod mode cannot be enabled. If the GPS and/or the vision system is providing the flight controller with velocity information, the aircraft will be able to automatically compensate for wind. If however, position information is not available, manual intervention will be required. User should beware that any manual compensation will be limited due to the reduced maximum velocity and sensitivity. If GPS and vision position become unavailable while in tripod mode, it is advisable to alert the user and disable Tripod Mode. Not supported by Mavic 2 Enterprise Advanced.  @param enabled `true` to enable tripod mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTripodModeEnabled_inline",
                   "",
            ],
            [
                   "getTripodModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTripodModeEnabled_inline",
                   "Gets tripod mode status (enabled/disabled). It is supported by Mavic Pro, Mavic Mini, DJI Mini 2, DJI Mini SE.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets tripod mode status (enabled/disabled). It is supported by Mavic Pro, Mavic Mini, DJI Mini 2, DJI Mini SE.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTripodModeEnabled_inline",
                   "",
            ],
            [
                   "setCinematicModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicModeEnabled_inline",
                   "Enables/disables cinematic mode. In Cinematic Mode, you can shoot more stable and smooth photos and videos. Aircraft yaw speed will be lower and braking distance will be longer. It's only supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param enabled `true` to enable cinematic mode. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enables/disables cinematic mode. In Cinematic Mode, you can shoot more stable and smooth photos and videos. Aircraft yaw speed will be lower and braking distance will be longer. It's only supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param enabled `true` to enable cinematic mode. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicModeEnabled_inline",
                   "",
            ],
            [
                   "getCinematicModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicModeEnabled_inline",
                   "Gets cinematic mode status (enabled/disabled). It's only supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned boolean value.",
            ],
            [
                   "Gets cinematic mode status (enabled/disabled). It's only supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicModeEnabled_inline",
                   "",
            ],
            [
                   "setCinematicBrakeSensitivity",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicBrakeSensitivity_inline",
                   "Adjusts the braking sensitivity when cinematic mode is enabled. Higher sensitivity can shorten the braking distance in cinematic mode. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param brakeSensitivity Brake sensitivity in cinematic mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Adjusts the braking sensitivity when cinematic mode is enabled. Higher sensitivity can shorten the braking distance in cinematic mode. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param brakeSensitivity Brake sensitivity in cinematic mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicBrakeSensitivity_inline",
                   "",
            ],
            [
                   "getCinematicBrakeSensitivity",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicBrakeSensitivity_inline",
                   "Gets the braking sensitivity when cinematic mode is enabled. Higher sensitivity can shorten the braking distance in cinematic mode. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the braking sensitivity when cinematic mode is enabled. Higher sensitivity can shorten the braking distance in cinematic mode. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicBrakeSensitivity_inline",
                   "",
            ],
            [
                   "setCinematicYawSpeed",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicYawSpeed_inline",
                   "Adjusts the aircraft's yaw speed when cinematic mode is enabled. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param yawSpeed The aircraft's yaw speed in cinematic mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Adjusts the aircraft's yaw speed when cinematic mode is enabled. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param yawSpeed The aircraft's yaw speed in cinematic mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCinematicYawSpeed_inline",
                   "",
            ],
            [
                   "getCinematicYawSpeed",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicYawSpeed_inline",
                   "Gets the aircraft's yaw speed when cinematic mode is enabled. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the aircraft's yaw speed when cinematic mode is enabled. It's supported by Mavic Pro, Spark, Mavic 2 Zoom and Mavic 2 Pro.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCinematicYawSpeed_inline",
                   "",
            ],
            [
                   "setTerrainFollowModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTerrainFollowModeEnabled_inline",
                   "Enable/disable terrain follow mode. The aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Enable/disable terrain follow mode. The aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTerrainFollowModeEnabled_inline",
                   "",
            ],
            [
                   "TERRAIN_FOLLOW_MODE_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTerrainFollowModeEnabled_inline",
                   "SDK Key for setTerrainFollowModeEnabled: Enable/disable terrain follow mode. The aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setTerrainFollowModeEnabled: Enable/disable terrain follow mode. The aircraft uses height information gathered by the onboard ultrasonic system and its downward facing cameras to keep flying at the same height above the ground.  @param enabled `true` to enable terrain follow mode. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setTerrainFollowModeEnabled_inline",
                   "",
            ],
            [
                   "getTerrainFollowModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTerrainFollowModeEnabled_inline",
                   "Gets terrain mode status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets terrain mode status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTerrainFollowModeEnabled_inline",
                   "",
            ],
            [
                   "TERRAIN_FOLLOW_MODE_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTerrainFollowModeEnabled_inline",
                   "SDK Key for getTerrainFollowModeEnabled: Gets terrain mode status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getTerrainFollowModeEnabled: Gets terrain mode status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getTerrainFollowModeEnabled_inline",
                   "",
            ],
            [
                   "setControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setControlMode_inline",
                   "Sets the control mode of the flight controller. It is highly recommended you keep the default value of `SMART`. See `ControlMode` for details. Only supported by stand-alone A3.  @param mode Control mode to set. @param callback Completion callback that receives the setter execution result.",
            ],
            [
                   "Sets the control mode of the flight controller. It is highly recommended you keep the default value of `SMART`. See `ControlMode` for details. Only supported by stand-alone A3.  @param mode Control mode to set. @param callback Completion callback that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setControlMode_inline",
                   "",
            ],
            [
                   "CONTROL_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setControlMode_inline",
                   "SDK Key for setControlMode: Sets the control mode of the flight controller. It is highly recommended you keep the default value of `SMART`. See `ControlMode` for details. Only supported by stand-alone A3.  @param mode Control mode to set. @param callback Completion callback that receives the setter execution result.",
            ],
            [
                   "SDK Key for setControlMode: Sets the control mode of the flight controller. It is highly recommended you keep the default value of `SMART`. See `ControlMode` for details. Only supported by stand-alone A3.  @param mode Control mode to set. @param callback Completion callback that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setControlMode_inline",
                   "",
            ],
            [
                   "getControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getControlMode_inline",
                   "Gets the control mode of the flight controller.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the control mode of the flight controller.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getControlMode_inline",
                   "",
            ],
            [
                   "CONTROL_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getControlMode_inline",
                   "SDK Key for getControlMode: Gets the control mode of the flight controller.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getControlMode: Gets the control mode of the flight controller.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getControlMode_inline",
                   "",
            ],
            [
                   "setAutoQuickSpinEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAutoQuickSpinEnabled_inline",
                   "Enable/disable Auto Quick Spin. When the gimbal reaches a yaw movement limit, the aircraft will automatically rotate 360 degrees to unwind the gimbal, allowing it to continue moving in the yaw direction. This method is only available when the aircraft is flying at least 3m above the ground. It is only supported by Inspire 2.  @param enabled `true` to enable Auto Quick Spin. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enable/disable Auto Quick Spin. When the gimbal reaches a yaw movement limit, the aircraft will automatically rotate 360 degrees to unwind the gimbal, allowing it to continue moving in the yaw direction. This method is only available when the aircraft is flying at least 3m above the ground. It is only supported by Inspire 2.  @param enabled `true` to enable Auto Quick Spin. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAutoQuickSpinEnabled_inline",
                   "",
            ],
            [
                   "getQuickSpinEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAutoQuickSpinEnabled_inline",
                   "Gets current Auto Quick Spin mode (enabled/disabled). It is only supported by Inspire 2.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Gets current Auto Quick Spin mode (enabled/disabled). It is only supported by Inspire 2.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAutoQuickSpinEnabled_inline",
                   "",
            ],
            [
                   "QUICK_SPIN_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAutoQuickSpinEnabled_inline",
                   "SDK Key for getQuickSpinEnabled: Gets current Auto Quick Spin mode (enabled/disabled). It is only supported by Inspire 2.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for getQuickSpinEnabled: Gets current Auto Quick Spin mode (enabled/disabled). It is only supported by Inspire 2.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAutoQuickSpinEnabled_inline",
                   "",
            ],
            [
                   "setAircraftHeadingTurningSpeed",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAircraftHeadingTurningSpeed_inline",
                   "Setting a larger value increases the yaw speed of the aircraft when the control sticks are pressed. The settable range of speed changes according to the mode. When the mode is normal, the speed range is (20,90). When the mode is sport, the speed range is (20,130). When the mode is tripod, the speed range is (20,30). Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode that the setting will be applied to. @param speed The speed to set for aircraft heading turning. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Setting a larger value increases the yaw speed of the aircraft when the control sticks are pressed. The settable range of speed changes according to the mode. When the mode is normal, the speed range is (20,90). When the mode is sport, the speed range is (20,130). When the mode is tripod, the speed range is (20,30). Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode that the setting will be applied to. @param speed The speed to set for aircraft heading turning. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAircraftHeadingTurningSpeed_inline",
                   "",
            ],
            [
                   "getAircraftHeadingTurningSpeed",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAircraftHeadingTurningSpeed_inline",
                   "Gets the heading turning speed of the aircraft according to the mode. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the heading turning speed of the aircraft according to the mode. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAircraftHeadingTurningSpeed_inline",
                   "",
            ],
            [
                   "setAircraftHeadingTurningSmoothness",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAircraftHeadingTurningSmoothness_inline",
                   "Setting a larger angle increases the yaw buffer when the control sticks are pressed. The value should be in the range [1, 100]. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode that the setting will be applied to. @param smoothingValue The smoothness that the setting will be applied to. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Setting a larger angle increases the yaw buffer when the control sticks are pressed. The value should be in the range [1, 100]. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode that the setting will be applied to. @param smoothingValue The smoothness that the setting will be applied to. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setAircraftHeadingTurningSmoothness_inline",
                   "",
            ],
            [
                   "getAircraftHeadingTurningSmoothness",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAircraftHeadingTurningSmoothness_inline",
                   "Gets the smoothness of the aircraft heading turn according to the mode. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode to query. @param callback The completion callback that receives the execution result.",
            ],
            [
                   "Gets the smoothness of the aircraft heading turn according to the mode. Only supported by Mavic Air 2, DJI Air 2S.  @param mode The mode to query. @param callback The completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getAircraftHeadingTurningSmoothness_inline",
                   "",
            ],
            [
                   "startGoHome",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_goHome_inline",
                   "The aircraft will start to go home. The `completion callback` will return execution result once this method is invoked.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The aircraft will start to go home. The `completion callback` will return execution result once this method is invoked.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_goHome_inline",
                   "",
            ],
            [
                   "START_GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_goHome_inline",
                   "SDK Key for startGoHome: The aircraft will start to go home. The `completion callback` will return execution result once this method is invoked.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for startGoHome: The aircraft will start to go home. The `completion callback` will return execution result once this method is invoked.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_goHome_inline",
                   "",
            ],
            [
                   "cancelGoHome",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelGoHome_inline",
                   "The aircraft will stop going home and will hover in place.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "The aircraft will stop going home and will hover in place.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelGoHome_inline",
                   "",
            ],
            [
                   "CANCEL_GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelGoHome_inline",
                   "SDK Key for cancelGoHome: The aircraft will stop going home and will hover in place.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for cancelGoHome: The aircraft will stop going home and will hover in place.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_cancelGoHome_inline",
                   "",
            ],
            [
                   "setHomeLocation",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocation_inline",
                   "Sets the home location of the aircraft. The home location is where the aircraft returns when commanded by `startGoHome`, when its signal is lost or when the battery is below the lowBatteryWarning threshold. The user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. A home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kCLLocationAccuracyNearestTenMeters accuracy level  - current remote controller's location as shown by RC GPS.  @param homeLocation Home location latitude and longitude in degrees. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the home location of the aircraft. The home location is where the aircraft returns when commanded by `startGoHome`, when its signal is lost or when the battery is below the lowBatteryWarning threshold. The user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. A home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kCLLocationAccuracyNearestTenMeters accuracy level  - current remote controller's location as shown by RC GPS.  @param homeLocation Home location latitude and longitude in degrees. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocation_inline",
                   "SDK Key for setHomeLocation: Sets the home location of the aircraft. The home location is where the aircraft returns when commanded by `startGoHome`, when its signal is lost or when the battery is below the lowBatteryWarning threshold. The user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. A home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kCLLocationAccuracyNearestTenMeters accuracy level  - current remote controller's location as shown by RC GPS.  @param homeLocation Home location latitude and longitude in degrees. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setHomeLocation: Sets the home location of the aircraft. The home location is where the aircraft returns when commanded by `startGoHome`, when its signal is lost or when the battery is below the lowBatteryWarning threshold. The user should be careful setting a new home point location, as sometimes the product will not be under user control when returning home. A home location is valid if it is within 30m of one of the following:  - initial take-off location  - aircraft's current location  - current mobile location with at least kCLLocationAccuracyNearestTenMeters accuracy level  - current remote controller's location as shown by RC GPS.  @param homeLocation Home location latitude and longitude in degrees. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocation_inline",
                   "",
            ],
            [
                   "setHomeLocationUsingAircraftCurrentLocation",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocationUsingAircraftCurrentLocation_inline",
                   "Sets the home location of the aircraft to the current location of the aircraft. See `setHomeLocation` for details on home point use.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the home location of the aircraft to the current location of the aircraft. See `setHomeLocation` for details on home point use.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocationUsingAircraftCurrentLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION_USING_CURRENT_AIRCRAFT_LOCATION",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocationUsingAircraftCurrentLocation_inline",
                   "SDK Key for setHomeLocationUsingAircraftCurrentLocation: Sets the home location of the aircraft to the current location of the aircraft. See `setHomeLocation` for details on home point use.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setHomeLocationUsingAircraftCurrentLocation: Sets the home location of the aircraft to the current location of the aircraft. See `setHomeLocation` for details on home point use.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setHomeLocationUsingAircraftCurrentLocation_inline",
                   "",
            ],
            [
                   "getHomeLocation",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getHomeLocation_inline",
                   "Gets the home point of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the home point of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getHomeLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getHomeLocation_inline",
                   "SDK Key for getHomeLocation: Gets the home point of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getHomeLocation: Gets the home point of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getHomeLocation_inline",
                   "",
            ],
            [
                   "setGoHomeHeightInMeters",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeAltitude_inline",
                   "Sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. This can be useful when the user foresees obstacles in the aircraft's flight path. If the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. The valid range for the altitude is from 20m to 500m. But if the aircraft is M300 RTK or M350 RTK, the limit can beyond 500m.  @param height The aircraft's default go home altitude. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. This can be useful when the user foresees obstacles in the aircraft's flight path. If the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. The valid range for the altitude is from 20m to 500m. But if the aircraft is M300 RTK or M350 RTK, the limit can beyond 500m.  @param height The aircraft's default go home altitude. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeAltitude_inline",
                   "",
            ],
            [
                   "GO_HOME_HEIGHT_IN_METERS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeAltitude_inline",
                   "SDK Key for setGoHomeHeightInMeters: Sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. This can be useful when the user foresees obstacles in the aircraft's flight path. If the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. The valid range for the altitude is from 20m to 500m. But if the aircraft is M300 RTK or M350 RTK, the limit can beyond 500m.  @param height The aircraft's default go home altitude. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setGoHomeHeightInMeters: Sets the minimum altitude, relative to where the aircraft took off, at which the aircraft must be before going home. This can be useful when the user foresees obstacles in the aircraft's flight path. If the aircraft's current altitude is higher than the minimum go home altitude, it will go home at its current altitude. The valid range for the altitude is from 20m to 500m. But if the aircraft is M300 RTK or M350 RTK, the limit can beyond 500m.  @param height The aircraft's default go home altitude. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeAltitude_inline",
                   "",
            ],
            [
                   "getGoHomeHeightInMeters",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeAltitude_inline",
                   "Gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeAltitude_inline",
                   "",
            ],
            [
                   "GO_HOME_HEIGHT_IN_METERS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeAltitude_inline",
                   "SDK Key for getGoHomeHeightInMeters: Gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getGoHomeHeightInMeters: Gets the minimum altitude (relative to the take-off location in meters) at which the aircraft must be before going home.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeAltitude_inline",
                   "",
            ],
            [
                   "setConnectionFailSafeBehavior",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setFlightFailsafeOperation_inline",
                   "Sets the FailSafe action for when the connection between remote controller and aircraft is lost. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Maivic Air 2.  @param behavior The `ConnectionFailSafeBehavior` object. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the FailSafe action for when the connection between remote controller and aircraft is lost. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Maivic Air 2.  @param behavior The `ConnectionFailSafeBehavior` object. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "CONNECTION_FAIL_SAFE_BEHAVIOR",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setFlightFailsafeOperation_inline",
                   "SDK Key for setConnectionFailSafeBehavior: Sets the FailSafe action for when the connection between remote controller and aircraft is lost. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Maivic Air 2.  @param behavior The `ConnectionFailSafeBehavior` object. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setConnectionFailSafeBehavior: Sets the FailSafe action for when the connection between remote controller and aircraft is lost. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE and Maivic Air 2.  @param behavior The `ConnectionFailSafeBehavior` object. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "getConnectionFailSafeBehavior",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getFlightFailsafeOperation_inline",
                   "Gets the FailSafe action for when the connection between remote controller and aircraft is lost.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the FailSafe action for when the connection between remote controller and aircraft is lost.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "CONNECTION_FAIL_SAFE_BEHAVIOR",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getFlightFailsafeOperation_inline",
                   "SDK Key for getConnectionFailSafeBehavior: Gets the FailSafe action for when the connection between remote controller and aircraft is lost.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getConnectionFailSafeBehavior: Gets the FailSafe action for when the connection between remote controller and aircraft is lost.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "setLowBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeBatteryThreshold_inline",
                   "Sets the low battery warning threshold as a percentage. The percentage must be in the range of [15, 50]. It is not supported by Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2 and DJI Air 2S.  @param percent Low battery warning percentage. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the low battery warning threshold as a percentage. The percentage must be in the range of [15, 50]. It is not supported by Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2 and DJI Air 2S.  @param percent Low battery warning percentage. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeBatteryThreshold_inline",
                   "",
            ],
            [
                   "LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeBatteryThreshold_inline",
                   "SDK Key for setLowBatteryWarningThreshold: Sets the low battery warning threshold as a percentage. The percentage must be in the range of [15, 50]. It is not supported by Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2 and DJI Air 2S.  @param percent Low battery warning percentage. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setLowBatteryWarningThreshold: Sets the low battery warning threshold as a percentage. The percentage must be in the range of [15, 50]. It is not supported by Mavic Mini, DJI Mini 2, DJI Mini SE, Mavic Air 2 and DJI Air 2S.  @param percent Low battery warning percentage. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setGoHomeBatteryThreshold_inline",
                   "",
            ],
            [
                   "getLowBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeBatteryThreshold_inline",
                   "Gets the low battery warning threshold as a percentage.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the low battery warning threshold as a percentage.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeBatteryThreshold_inline",
                   "",
            ],
            [
                   "LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeBatteryThreshold_inline",
                   "SDK Key for getLowBatteryWarningThreshold: Gets the low battery warning threshold as a percentage.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getLowBatteryWarningThreshold: Gets the low battery warning threshold as a percentage.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getGoHomeBatteryThreshold_inline",
                   "",
            ],
            [
                   "setSeriousLowBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLandImmediatelyBatteryThreshold_inline",
                   "Sets the serious low battery warning threshold as a percentage. The minimum value is 10. The maximum value is value from `getLowBatteryWarningThreshold` minus 5. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param percent Serious low battery warning percentage. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the serious low battery warning threshold as a percentage. The minimum value is 10. The maximum value is value from `getLowBatteryWarningThreshold` minus 5. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param percent Serious low battery warning percentage. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLandImmediatelyBatteryThreshold_inline",
                   "",
            ],
            [
                   "SERIOUS_LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLandImmediatelyBatteryThreshold_inline",
                   "SDK Key for setSeriousLowBatteryWarningThreshold: Sets the serious low battery warning threshold as a percentage. The minimum value is 10. The maximum value is value from `getLowBatteryWarningThreshold` minus 5. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param percent Serious low battery warning percentage. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setSeriousLowBatteryWarningThreshold: Sets the serious low battery warning threshold as a percentage. The minimum value is 10. The maximum value is value from `getLowBatteryWarningThreshold` minus 5. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param percent Serious low battery warning percentage. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setLandImmediatelyBatteryThreshold_inline",
                   "",
            ],
            [
                   "getSeriousLowBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLandImmediatelyBatteryThreshold_inline",
                   "Gets the serious low battery warning threshold in percentage.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the serious low battery warning threshold in percentage.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLandImmediatelyBatteryThreshold_inline",
                   "",
            ],
            [
                   "SERIOUS_LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLandImmediatelyBatteryThreshold_inline",
                   "SDK Key for getSeriousLowBatteryWarningThreshold: Gets the serious low battery warning threshold in percentage.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getSeriousLowBatteryWarningThreshold: Gets the serious low battery warning threshold in percentage.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getLandImmediatelyBatteryThreshold_inline",
                   "",
            ],
            [
                   "setSmartReturnToHomeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setSmartReturnToHomeEnabled_inline",
                   "Enables/disables Smart Return-To-Home (RTH) feature. When it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action. For Mavic Mini, DJI Mini 2, DJI Mini SE, the aircraft will return to home point when the remaning battery is low.  @param enabled `true` to enable smart RTH. @param callback Completion block that receives the setter execution result.",
            ],
            [
                   "Enables/disables Smart Return-To-Home (RTH) feature. When it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action. For Mavic Mini, DJI Mini 2, DJI Mini SE, the aircraft will return to home point when the remaning battery is low.  @param enabled `true` to enable smart RTH. @param callback Completion block that receives the setter execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setSmartReturnToHomeEnabled_inline",
                   "",
            ],
            [
                   "getSmartReturnToHomeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getSmartReturnToHomeEnabled_inline",
                   "Determines whether Smart Return-To-Home (RTH) feature is enabled or not. When it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Determines whether Smart Return-To-Home (RTH) feature is enabled or not. When it is enabled, aircraft will request to go home when remaining battery is only enough for completing the go-home action.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getSmartReturnToHomeEnabled_inline",
                   "",
            ],
            [
                   "confirmSmartReturnToHomeRequest",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmSmartReturnToHomeRequest_inline",
                   "Confirms or cancels the Smart Return-To-Home (RTH) request. When Smart RTH is enabled, the aircraft will request to go home when the battery is only enough for going home. Before executing the go-home action, the aircraft will wait for the confirmation from users with 10 seconds count-down. If the confirmed parameter is `false`, the request is canceled and the aircraft will not execute go-home action. Otherwise, go-home action will start. Smart RTH will be triggered only once during the same flight. Flight controller with firmware version lower than 3.0.0.0 does not support confirming the Smart RTH request. User can either cancel the request or wait for the countdown to start go-home action. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE, DJI Air 2S and Mavic Air 2.  @param confirmed `true` to confirm the request and the aircraft will start go-home immediately. @param callback Completion block to receive the result.",
            ],
            [
                   "Confirms or cancels the Smart Return-To-Home (RTH) request. When Smart RTH is enabled, the aircraft will request to go home when the battery is only enough for going home. Before executing the go-home action, the aircraft will wait for the confirmation from users with 10 seconds count-down. If the confirmed parameter is `false`, the request is canceled and the aircraft will not execute go-home action. Otherwise, go-home action will start. Smart RTH will be triggered only once during the same flight. Flight controller with firmware version lower than 3.0.0.0 does not support confirming the Smart RTH request. User can either cancel the request or wait for the countdown to start go-home action. It is supported by Mavic Mini, DJI Mini 2, DJI Mini SE, DJI Air 2S and Mavic Air 2.  @param confirmed `true` to confirm the request and the aircraft will start go-home immediately. @param callback Completion block to receive the result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_confirmSmartReturnToHomeRequest_inline",
                   "",
            ],
            [
                   "getRCSwitchFlightModeMapping",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getRemoteControllerFlightModeMapping_inline",
                   "Gets the mapping between the flight modes and the flight mode switch positions on the remote controller. Elements 0, 1, and 2 of the returned array map to `POSITION_ONE`, `POSITION_TWO`, and `POSITION_THREE` of the `getFlightModeSwitch`. The value of each Enum item represents the corresponding value of the `RemoteControllerFlightMode` Enum representing the flight mode. The mapping is fixed for the Phantom series, Inspire series, Mavic Pro, and M100. For N3, A3, Matrice 600, and Matrice 600 Pro the mapping is firmware dependent. With firmware version 3.2.11.0 or above, the mapping can be customized in DJI Assistant 2.  @param callback Completion callback that receives the getter result. Each element of array is an instance with a value of `RemoteControllerFlightMode`.",
            ],
            [
                   "Gets the mapping between the flight modes and the flight mode switch positions on the remote controller. Elements 0, 1, and 2 of the returned array map to `POSITION_ONE`, `POSITION_TWO`, and `POSITION_THREE` of the `getFlightModeSwitch`. The value of each Enum item represents the corresponding value of the `RemoteControllerFlightMode` Enum representing the flight mode. The mapping is fixed for the Phantom series, Inspire series, Mavic Pro, and M100. For N3, A3, Matrice 600, and Matrice 600 Pro the mapping is firmware dependent. With firmware version 3.2.11.0 or above, the mapping can be customized in DJI Assistant 2.  @param callback Completion callback that receives the getter result. Each element of array is an instance with a value of `RemoteControllerFlightMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getRemoteControllerFlightModeMapping_inline",
                   "",
            ],
            [
                   "setMultipleFlightModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setMultipleFlightModeEnabled_inline",
                   "Enables/disables multiple-flight mode. When multiple-flight mode is enabled, user can change the aircraft's mode to P/F/A/S mode by toggling the switch on the remote controller. If it is disabled, the aircraft will be in P mode.  @param enabled `true` to enable multiple-flight mode. @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Enables/disables multiple-flight mode. When multiple-flight mode is enabled, user can change the aircraft's mode to P/F/A/S mode by toggling the switch on the remote controller. If it is disabled, the aircraft will be in P mode.  @param enabled `true` to enable multiple-flight mode. @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setMultipleFlightModeEnabled_inline",
                   "",
            ],
            [
                   "getMultipleFlightModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getMultipleFlightModeEnabled_inline",
                   "Determines whether multiple-flight mode is enabled. When multiple-flight mode is enabled, user can change the aircraft's mode to P/F/A/S mode by toggling the switch on the remote controller. If it is disabled, the aircraft will be in P mode.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Determines whether multiple-flight mode is enabled. When multiple-flight mode is enabled, user can change the aircraft's mode to P/F/A/S mode by toggling the switch on the remote controller. If it is disabled, the aircraft will be in P mode.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getMultipleFlightModeEnabled_inline",
                   "",
            ],
            [
                   "setNoviceModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setNoviceModeEnabled_inline",
                   "Enables novice mode. When novice mode is enabled, the flight speed will become slower and less responsive handling. For Phantom 4 Pro, enabling novice mode will enable the infrared time-of-flight (TOF) sensors on the left and right.  @param enabled `true` to enable novice mode. @param callback Completion block that receives the execution result.",
            ],
            [
                   "Enables novice mode. When novice mode is enabled, the flight speed will become slower and less responsive handling. For Phantom 4 Pro, enabling novice mode will enable the infrared time-of-flight (TOF) sensors on the left and right.  @param enabled `true` to enable novice mode. @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setNoviceModeEnabled_inline",
                   "",
            ],
            [
                   "getNoviceModeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_GetNoviceModeEnabled_inline",
                   "Determines whether novice mode is enabled or not. If novice mode is enabled, the flight speed is slower and less responsive handling. For Phantom 4 Pro, enabling novice mode will enable the infrared time-of-flight (TOF) sensors on the left and right.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Determines whether novice mode is enabled or not. If novice mode is enabled, the flight speed is slower and less responsive handling. For Phantom 4 Pro, enabling novice mode will enable the infrared time-of-flight (TOF) sensors on the left and right.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_GetNoviceModeEnabled_inline",
                   "",
            ],
            [
                   "reboot",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rebootDrone_inline",
                   "Reboot the core component of the aircraft. It is recommended to invoke this method after IMU calibration.  For Matrice 300 RTK, reboot the aircraft.  For Mavic Mini, DJI Mini SE, reboot the airlink.  For Maivc Air 2, reboot the battery.  Others, reboot the flight controller.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Reboot the core component of the aircraft. It is recommended to invoke this method after IMU calibration.  For Matrice 300 RTK, reboot the aircraft.  For Mavic Mini, DJI Mini SE, reboot the airlink.  For Maivc Air 2, reboot the battery.  Others, reboot the flight controller.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_rebootDrone_inline",
                   "",
            ],
            [
                   "setPowerSupplyPortEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPowerSupplyPortEnabled_inline",
                   "Enables the power supply port. It is only supported by M200 series and M200 series v2.  @param enabled `true` if power supply port is enabled. @param callback Callback that receives the execution result.",
            ],
            [
                   "Enables the power supply port. It is only supported by M200 series and M200 series v2.  @param enabled `true` if power supply port is enabled. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPowerSupplyPortEnabled_inline",
                   "",
            ],
            [
                   "getPowerSupplyPortEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPowerSupplyPortEnabled_inline",
                   "Determines whether the power supply port is enabled or not. It is only supported by M200 series and M200 series v2.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Determines whether the power supply port is enabled or not. It is only supported by M200 series and M200 series v2.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPowerSupplyPortEnabled_inline",
                   "",
            ],
            [
                   "setPropellerCageProtectionEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPropellerCageProtectionEnabled_inline",
                   "Do not turn on the Propeller Cage switch if propeller cages are not mounted. By enabling the Propeller Cage switch, you will set the Force Landing battery level to 15% and disable Wind Check and Propeller Check. When propeller cages are installed, no other accessories (except for official ND filters) can be attached. Only supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param enabled `true` to enable propeller cage protection. @param callback Callback that receives the execution result.",
            ],
            [
                   "Do not turn on the Propeller Cage switch if propeller cages are not mounted. By enabling the Propeller Cage switch, you will set the Force Landing battery level to 15% and disable Wind Check and Propeller Check. When propeller cages are installed, no other accessories (except for official ND filters) can be attached. Only supported by Mavic Mini, DJI Mini 2, DJI Mini SE.  @param enabled `true` to enable propeller cage protection. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPropellerCageProtectionEnabled_inline",
                   "",
            ],
            [
                   "getPropellerCageProtectionEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPropellerCageProtectionEnabled_inline",
                   "Gets whether the propeller cage switch is turned on.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Gets whether the propeller cage switch is turned on.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPropellerCageProtectionEnabled_inline",
                   "",
            ],
            [
                   "toggleAttitudeFlightMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_toggleAttitudeFlightMode_inline",
                   "`true` to change the Tripod(T) mode toggle to Attitude mode toggle from the remote controller. You should called `setMultipleFlightModeEnabled` to enable multiple flight mode first, otherwise this interfaces take no effect. if this mode is enabled, once you switch the mode toggle on remote controller to Tripod(T) mode, aircraft will enter Attitude mode, in this mode, aircraft is easily distured and drifts horizontally in consequence, you have to manully hover the aircraft. Also, the active braking system is inactive. It is supported only by Matrice 300 RTK.  @param isOpen `true` to change the Tripod(T) mode toggle to Attitude mode toggle from the remote controller.",
            ],
            [
                   "`true` to change the Tripod(T) mode toggle to Attitude mode toggle from the remote controller. You should called `setMultipleFlightModeEnabled` to enable multiple flight mode first, otherwise this interfaces take no effect. if this mode is enabled, once you switch the mode toggle on remote controller to Tripod(T) mode, aircraft will enter Attitude mode, in this mode, aircraft is easily distured and drifts horizontally in consequence, you have to manully hover the aircraft. Also, the active braking system is inactive. It is supported only by Matrice 300 RTK.  @param isOpen `true` to change the Tripod(T) mode toggle to Attitude mode toggle from the remote controller.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_toggleAttitudeFlightMode_inline",
                   "",
            ],
            [
                   "getIsAttitudeFlightModeOpen",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getIsAttitudeFlightModeOpen_inline",
                   "`true` if custom the Tripod(T) mode to Attitude mode on the remote controller is enabled. It is supported only by Matrice 300 RTK.",
            ],
            [
                   "`true` if custom the Tripod(T) mode to Attitude mode on the remote controller is enabled. It is supported only by Matrice 300 RTK.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getIsAttitudeFlightModeOpen_inline",
                   "",
            ],
            [
                   "lockTakeoffWithoutGPS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_lockTakeoffWithoutGPS_inline",
                   "When GPS signal low, aircraft unable to auto hover and takeoff restricted. If you want to unlock takeoff without GPS , ensure there no people or obstacles within 2 m around the aircraft, and pay close attention to operating the remote controller at all times to avoid collisions.  @param lock `false` to unlock takeoff without GPS. @param callback Callback that receives the execution result.",
            ],
            [
                   "When GPS signal low, aircraft unable to auto hover and takeoff restricted. If you want to unlock takeoff without GPS , ensure there no people or obstacles within 2 m around the aircraft, and pay close attention to operating the remote controller at all times to avoid collisions.  @param lock `false` to unlock takeoff without GPS. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_lockTakeoffWithoutGPS_inline",
                   "",
            ],
            [
                   "isLockTakeoffWithoutGPS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLockTakeoffWithoutGPS_inline",
                   "Return `false` if unlock takeoff without GPS.  @param callback Callback that receives the execution result.",
            ],
            [
                   "Return `false` if unlock takeoff without GPS.  @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_isLockTakeoffWithoutGPS_inline",
                   "",
            ],
            [
                   "getPropellerCoverLimitEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPropellerCoverLimitEnabled_inline",
                   "Return `true` if propeller cover limit mode is enabled.  @param callback Callback that receives the execution result.",
            ],
            [
                   "Return `true` if propeller cover limit mode is enabled.  @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getPropellerCoverLimitEnabled_inline",
                   "",
            ],
            [
                   "setPropellerCoverLimitEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPropellerCoverLimitEnabled_inline",
                   "This mode should only be enabled when using accessories like propeller guards and the aircraft is flying in wind-free environments. Shown as payload mode in DJI fly. Only Supported by DJI Mini 2.  @param enabled `true` to enable the propeller cover limit. @param callback Callback that receives the execution result.",
            ],
            [
                   "This mode should only be enabled when using accessories like propeller guards and the aircraft is flying in wind-free environments. Shown as payload mode in DJI fly. Only Supported by DJI Mini 2.  @param enabled `true` to enable the propeller cover limit. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setPropellerCoverLimitEnabled_inline",
                   "",
            ],
            [
                   "setCoordinatedTurnEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCoordinatedTurnEnabled_inline",
                   "Enables the coordinated turn. Improves aerodynamic efficiency. The aircraft is flying in the direction of the turn, without sideslipping. Only supported by M300 RTK and M350 RTK.  @param enabled `true` to enable the coordinated turn. @param callback Callback that receives the execution result.",
            ],
            [
                   "Enables the coordinated turn. Improves aerodynamic efficiency. The aircraft is flying in the direction of the turn, without sideslipping. Only supported by M300 RTK and M350 RTK.  @param enabled `true` to enable the coordinated turn. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setCoordinatedTurnEnabled_inline",
                   "",
            ],
            [
                   "getCoordinatedTurnEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCoordinatedTurnEnabled_inline",
                   "Get whether the coordinated turn switch is on.  Only supported by M300 RTK and M350 RTK.  @param callback Completion block that receives the execution result.",
            ],
            [
                   "Get whether the coordinated turn switch is on.  Only supported by M300 RTK and M350 RTK.  @param callback Completion block that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getCoordinatedTurnEnabled_inline",
                   "",
            ],
            [
                   "setNavigationSatelliteSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setNavigationSatelliteSystem_inline",
                   "The selection of satellite positioning system is only supported when the RTK positioning function is turned off, and cannot be modified in the air. If RTK positioning function is turned on, aircraft uses GPS, GLONASS, Galileo, and BDS data to determine location. Only supported by M300 RTK and M350 RTK.  @param system Navigation satellite system. @param callback Callback that receives the execution result.",
            ],
            [
                   "The selection of satellite positioning system is only supported when the RTK positioning function is turned off, and cannot be modified in the air. If RTK positioning function is turned on, aircraft uses GPS, GLONASS, Galileo, and BDS data to determine location. Only supported by M300 RTK and M350 RTK.  @param system Navigation satellite system. @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_setNavigationSatelliteSystem_inline",
                   "",
            ],
            [
                   "getNavigationSatelliteSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getNavigationSatelliteSystem_inline",
                   "Get the navigation satellite system. Only supported by M300 RTK and M350 RTK.  @param callback Callback that receives the execution result.",
            ],
            [
                   "Get the navigation satellite system. Only supported by M300 RTK and M350 RTK.  @param callback Callback that receives the execution result.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_getNavigationSatelliteSystem_inline",
                   "",
            ],
            [
                   "NavigationSatelliteSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_inline",
                   "This enum defines the navigation satellite system currently being used.",
            ],
            [
                   "This enum defines the navigation satellite system currently being used.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_inline",
                   "",
            ],
            [
                   "GPS_GLONASS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_GPS_GLONASS_inline",
                   "Using GSP and GLONSS satellite data.",
            ],
            [
                   "Using GSP and GLONSS satellite data.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_GPS_GLONASS_inline",
                   "",
            ],
            [
                   "BEIDOU",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_BEIDOU_inline",
                   "Only use Beidou satellite navigation system.",
            ],
            [
                   "Only use Beidou satellite navigation system.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_NavigationSatelliteSystem_BEIDOU_inline",
                   "",
            ],
            [
                   "OnboardSDKDeviceDataCallback",
                   2,
                   "/Components/FlightController/DJIFlightController_ReceivedDataFromExternalDeviceCallbackInterface.html",
                   "",
                   "Callback function that updates the data received from an external device (e.g.the onboard device).",
            ],
            [
                   "Callback function that updates the data received from an external device (e.g.the onboard device).",
                   1,
                   "/Components/FlightController/DJIFlightController_ReceivedDataFromExternalDeviceCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "FlightControllerState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "",
                   "This class represents the current state of the flight controller.",
            ],
            [
                   "This class represents the current state of the flight controller.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "",
                   "",
            ],
            [
                   "GravityCenterState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "",
                   "This class provides the gravity state information.",
            ],
            [
                   "This class provides the gravity state information.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlightController/DJIFlightController_UpdateSystemStateCallbackInterface.html",
                   "#DJIFlightController_UpdateSystemState_inline",
                   "Called when the flight controller's current state data has been updated. This method is called 10 times per second.  @param state Current state of the flight controller.",
            ],
            [
                   "Called when the flight controller's current state data has been updated. This method is called 10 times per second.  @param state Current state of the flight controller.",
                   1,
                   "/Components/FlightController/DJIFlightController_UpdateSystemStateCallbackInterface.html",
                   "#DJIFlightController_UpdateSystemState_inline",
                   "",
            ],
            [
                   "onReceive",
                   2,
                   "/Components/FlightController/DJIFlightController_ReceivedDataFromExternalDeviceCallbackInterface.html",
                   "#DJIFlightController_ReceiveDataFromExternalDevice_inline",
                   "Called when the data received from an external device (e.g. the onboard device) has been updated.  @param data Data received from an external device. The size of the data will not be larger than 100 bytes.",
            ],
            [
                   "Called when the data received from an external device (e.g. the onboard device) has been updated.  @param data Data received from an external device. The size of the data will not be larger than 100 bytes.",
                   1,
                   "/Components/FlightController/DJIFlightController_ReceivedDataFromExternalDeviceCallbackInterface.html",
                   "#DJIFlightController_ReceiveDataFromExternalDevice_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "#DJIFlightController_UpdateIMUState_inline",
                   "Called when the flight controller pushes an IMU state update. The callback method would not be called if the aircraft is flying.  @param state Information about the IMU state pushed by the flight controller.",
            ],
            [
                   "Called when the flight controller pushes an IMU state update. The callback method would not be called if the aircraft is flying.  @param state Information about the IMU state pushed by the flight controller.",
                   1,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "#DJIFlightController_UpdateIMUState_inline",
                   "",
            ],
            [
                   "IMU_STATE",
                   2,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "#DJIFlightController_UpdateIMUState_inline",
                   "SDK Key for onUpdate: Called when the flight controller pushes an IMU state update. The callback method would not be called if the aircraft is flying.  @param state Information about the IMU state pushed by the flight controller.",
            ],
            [
                   "SDK Key for onUpdate: Called when the flight controller pushes an IMU state update. The callback method would not be called if the aircraft is flying.  @param state Information about the IMU state pushed by the flight controller.",
                   1,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "#DJIFlightController_UpdateIMUState_inline",
                   "",
            ],
            [
                   "Compass",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "",
                   "This class provides compass status information and compass calibration methods. Products with multiple compasses (like the Phantom 4) have their compass state fused into one compass class for simplicity.",
            ],
            [
                   "This class provides compass status information and compass calibration methods. Products with multiple compasses (like the Phantom 4) have their compass state fused into one compass class for simplicity.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "",
                   "",
            ],
            [
                   "RTK",
                   2,
                   "/Components/RTK/DJIRTK.html",
                   "",
                   "Real Time Kinematic",
            ],
            [
                   "Real Time Kinematic",
                   1,
                   "/Components/RTK/DJIRTK.html",
                   "",
                   "",
            ],
            [
                   "LandingGear",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "",
                   "This class controls and gives state of the landing gear. Please check `isLandingGearMovable` before calling the methods in this class.",
            ],
            [
                   "This class controls and gives state of the landing gear. Please check `isLandingGearMovable` before calling the methods in this class.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "",
                   "",
            ],
            [
                   "FlightAssistant",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "",
                   "This class contains components of the Intelligent Flight Assistant and provides methods to change its settings.",
            ],
            [
                   "This class contains components of the Intelligent Flight Assistant and provides methods to change its settings.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "",
                   "",
            ],
            [
                   "AccessLocker",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "",
                   "The Access Locker provides methods to control the permission to access the aircraft. For an aircraft with advanced security features, the aircraft is locked after a user account is set up: the storage is not accessible; the live view is not available; the aircraft cannot take off. The user can unlock the aircraft with the security code to access all features of the aircraft. The security code is encrypted in the aircraft. DJI will not be able to fetch the security code. If the security code is forgotten, the user has to format the storage to reset the protection system. All the files in the internal storage and the user account information will be deleted. The Access Locker is only supported by Mavic 2 Enterprise.",
            ],
            [
                   "The Access Locker provides methods to control the permission to access the aircraft. For an aircraft with advanced security features, the aircraft is locked after a user account is set up: the storage is not accessible; the live view is not available; the aircraft cannot take off. The user can unlock the aircraft with the security code to access all features of the aircraft. The security code is encrypted in the aircraft. DJI will not be able to fetch the security code. If the security code is forgotten, the user has to format the storage to reset the protection system. All the files in the internal storage and the user account information will be deleted. The Access Locker is only supported by Mavic 2 Enterprise.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "",
                   "",
            ],
            [
                   "Radar",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "",
                   "This class contains components of the Radar and provides methods to change its settings.",
            ],
            [
                   "This class contains components of the Radar and provides methods to change its settings.",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "",
                   "",
            ],
            [
                   "Simulator",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "",
                   "DJI aircraft can be put into simulation mode using this class. Developers can start and stop the simulation, as well as monitor basic aircraft attitude and location information.",
            ],
            [
                   "DJI aircraft can be put into simulation mode using this class. Developers can start and stop the simulation, as well as monitor basic aircraft attitude and location information.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "",
                   "",
            ],
            [
                   "IMUState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "",
                   "This class provides the inertial measurement unit's (IMU) state information.",
            ],
            [
                   "This class provides the inertial measurement unit's (IMU) state information.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "",
                   "",
            ],
            [
                   "IMU_STATE",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "",
                   "SDK Key for IMUState: This class provides the inertial measurement unit's (IMU) state information.",
            ],
            [
                   "SDK Key for IMUState: This class provides the inertial measurement unit's (IMU) state information.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "",
                   "",
            ],
            [
                   "FlightControlData",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "",
                   "Contains all the virtual stick control data needed to move the aircraft in all directions.",
            ],
            [
                   "Contains all the virtual stick control data needed to move the aircraft in all directions.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "",
                   "",
            ],
            [
                   "getPitch",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_pitch_inline",
                   "Gets aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @return The Velocity (m/s) or Angle (degrees) value for pitch.",
            ],
            [
                   "Gets aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @return The Velocity (m/s) or Angle (degrees) value for pitch.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_pitch_inline",
                   "",
            ],
            [
                   "setPitch",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setPitch_inline",
                   "Sets the aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @param pitch The velocity (m/s) or angle (degrees) value for pitch",
            ],
            [
                   "Sets the aircraft's velocity (m/s) along the y-axis or angle value (in degrees) for pitch. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @param pitch The velocity (m/s) or angle (degrees) value for pitch",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setPitch_inline",
                   "",
            ],
            [
                   "getRoll",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_roll_inline",
                   "Gets aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @return The velocity (m/s) or angle (degrees) value for roll.",
            ],
            [
                   "Gets aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @return The velocity (m/s) or angle (degrees) value for roll.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_roll_inline",
                   "",
            ],
            [
                   "setRoll",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setRoll_inline",
                   "Sets the aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @param roll The velocity (m/s) or angle (degrees) value for roll.",
            ],
            [
                   "Sets the aircraft's velocity (m/s) along the x-axis or angle value (in degrees) for roll. Use `RollPitchControlMode` to set the velocity or angle mode. Note that the argument has different meanings in different coordinate systems. See the <i>Flight Controller User Guide</i> for more information.  @param roll The velocity (m/s) or angle (degrees) value for roll.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setRoll_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_yaw_inline",
                   "Angular velocity (degrees/s) or angle (degrees) value for yaw. Use `YawControlMode` to set angular velocity or angle mode.  @return The angular velocity (degrees/s) or angle (degrees) value for yaw.",
            ],
            [
                   "Angular velocity (degrees/s) or angle (degrees) value for yaw. Use `YawControlMode` to set angular velocity or angle mode.  @return The angular velocity (degrees/s) or angle (degrees) value for yaw.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_yaw_inline",
                   "",
            ],
            [
                   "setYaw",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setYaw_inline",
                   "Sets the angular velocity (degrees/s) or angle (degrees) value for yaw. Use `YawControlMode` to set angular velocity or angle mode.  @param yaw The angular velocity (degrees/s) or angle (degrees) value for yaw.",
            ],
            [
                   "Sets the angular velocity (degrees/s) or angle (degrees) value for yaw. Use `YawControlMode` to set angular velocity or angle mode.  @param yaw The angular velocity (degrees/s) or angle (degrees) value for yaw.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setYaw_inline",
                   "",
            ],
            [
                   "getVerticalThrottle",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_verticalThrottle_inline",
                   "Gets aircraft's velocity (m/s) or altitude (m) value for verticalControl. Use `VerticalControlMode` to set velocity or altitude mode.  @return The velocity (m/s) or altitude (m) value for verticalControl.",
            ],
            [
                   "Gets aircraft's velocity (m/s) or altitude (m) value for verticalControl. Use `VerticalControlMode` to set velocity or altitude mode.  @return The velocity (m/s) or altitude (m) value for verticalControl.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_verticalThrottle_inline",
                   "",
            ],
            [
                   "setVerticalThrottle",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setVerticalThrottle_inline",
                   "Sets the aircraft's velocity (m/s) or altitude (m) value for verticalControl. Use `VerticalControlMode` to set velocity or altitude mode.  @param verticalThrottle The velocity (m/s) or altitude (m) value for verticalControl.",
            ],
            [
                   "Sets the aircraft's velocity (m/s) or altitude (m) value for verticalControl. Use `VerticalControlMode` to set velocity or altitude mode.  @param verticalThrottle The velocity (m/s) or altitude (m) value for verticalControl.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_setVerticalThrottle_inline",
                   "",
            ],
            [
                   "FlightControlData",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_constructor_inline",
                   "Constructor for the flight control data to send through virtual sticks.  @param pitch The velocity (m/s) or angle (degrees) value for pitch @param roll The velocity (m/s) or angle (degrees) value for roll. @param yaw The angular velocity (degrees/s) or angle (degrees) value for yaw. @param verticalThrottle The velocity (m/s) or altitude (m) value for verticalControl.",
            ],
            [
                   "Constructor for the flight control data to send through virtual sticks.  @param pitch The velocity (m/s) or angle (degrees) value for pitch @param roll The velocity (m/s) or angle (degrees) value for roll. @param yaw The angular velocity (degrees/s) or angle (degrees) value for yaw. @param verticalThrottle The velocity (m/s) or altitude (m) value for verticalControl.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIVirtualStickFlightControlData.html",
                   "#DJIFlightController_DJIVirtualStickFlightControlData_constructor_inline",
                   "",
            ],
            [
                   "VerticalControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_inline",
                   "Defines how vertical control values are interpreted by the aircraft.",
            ],
            [
                   "Defines how vertical control values are interpreted by the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_inline",
                   "",
            ],
            [
                   "VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_velocity_inline",
                   "Sets the virtual stick vertical control values to be a vertical velocity. Positive and negative vertical velocity is for the aircraft ascending and descending respectively. Maximum vertical velocity is defined as 4 m/s. Minimum vertical velocity is defined as -4 m/s.",
            ],
            [
                   "Sets the virtual stick vertical control values to be a vertical velocity. Positive and negative vertical velocity is for the aircraft ascending and descending respectively. Maximum vertical velocity is defined as 4 m/s. Minimum vertical velocity is defined as -4 m/s.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_velocity_inline",
                   "",
            ],
            [
                   "POSITION",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_position_inline",
                   "Sets the virtual stick vertical control values to be an altitude. Maximum position is defined as 500 m. Minimum position is defined as 0 m.",
            ],
            [
                   "Sets the virtual stick vertical control values to be an altitude. Maximum position is defined as 500 m. Minimum position is defined as 0 m.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickVerticalControlMode_position_inline",
                   "",
            ],
            [
                   "RollPitchControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_inline",
                   "Defines how manual roll and pitch values are interpreted by the aircraft.",
            ],
            [
                   "Defines how manual roll and pitch values are interpreted by the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_inline",
                   "",
            ],
            [
                   "ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_angle_inline",
                   "Sets the roll and pitch values to be an angle relative to a level aircraft. In the body coordinate system, positive and negative pitch angle is for the aircraft rotating about the y-axis in the positive direction or negative direction, respectively. Positive and negative roll angle is the positive direction or negative direction rotation angle about the x-axis, respectively. However in the ground coordinate system, positive and negative pitch angle is the angle value for the aircraft moving south and north, respectively. Positive and negative roll angle is the angle when the aircraft is moving east and west, respectively. Maximum angle is defined as 30 degrees. Minimum angle is defined as -30 degrees.",
            ],
            [
                   "Sets the roll and pitch values to be an angle relative to a level aircraft. In the body coordinate system, positive and negative pitch angle is for the aircraft rotating about the y-axis in the positive direction or negative direction, respectively. Positive and negative roll angle is the positive direction or negative direction rotation angle about the x-axis, respectively. However in the ground coordinate system, positive and negative pitch angle is the angle value for the aircraft moving south and north, respectively. Positive and negative roll angle is the angle when the aircraft is moving east and west, respectively. Maximum angle is defined as 30 degrees. Minimum angle is defined as -30 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_angle_inline",
                   "",
            ],
            [
                   "VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_velocity_inline",
                   "Sets the roll and pitch values to be a velocity. In the body coordinate system, positive and negative pitch velocity is for the aircraft moving towards the positive direction or negative direction along the pitch axis and y-axis, respectively. Positive and negative roll velocity is when the aircraft is moving towards the positive direction or negative direction along the roll axis and x-axis, respectively. However, in the ground coordinate system, positive and negative pitch velocity is for the aircraft moving east and west, respectively. Positive and negative roll velocity is when the aircraft is moving north and south, respectively. Maximum velocity is defined as 15 meters/s. Minimum velocity is defined as -15 meters/s.",
            ],
            [
                   "Sets the roll and pitch values to be a velocity. In the body coordinate system, positive and negative pitch velocity is for the aircraft moving towards the positive direction or negative direction along the pitch axis and y-axis, respectively. Positive and negative roll velocity is when the aircraft is moving towards the positive direction or negative direction along the roll axis and x-axis, respectively. However, in the ground coordinate system, positive and negative pitch velocity is for the aircraft moving east and west, respectively. Positive and negative roll velocity is when the aircraft is moving north and south, respectively. Maximum velocity is defined as 15 meters/s. Minimum velocity is defined as -15 meters/s.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickRollPitchControlMode_velocity_inline",
                   "",
            ],
            [
                   "YawControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_inline",
                   "Defines how manual yaw values are interpreted by the aircraft.",
            ],
            [
                   "Defines how manual yaw values are interpreted by the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_inline",
                   "",
            ],
            [
                   "ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_angle_inline",
                   "Sets the yaw values to be an angle relative to the north. Positive and negative yaw angle is for the aircraft rotating clockwise and counterclockwise, respectively. Maximum yaw angle is defined as 180 degrees. Minimum yaw angle is defined as -180 degrees.",
            ],
            [
                   "Sets the yaw values to be an angle relative to the north. Positive and negative yaw angle is for the aircraft rotating clockwise and counterclockwise, respectively. Maximum yaw angle is defined as 180 degrees. Minimum yaw angle is defined as -180 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_angle_inline",
                   "",
            ],
            [
                   "ANGULAR_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_angularVelocity_inline",
                   "Sets the yaw values to be an angular velocity. Positive and negative angular velocity is for the aircraft rotating clockwise and counterclockwise, respectively. Maximum yaw angular velocity is defined as 100 degrees/s. Minimum yaw angular velocity is defined as -100 degrees/s.",
            ],
            [
                   "Sets the yaw values to be an angular velocity. Positive and negative angular velocity is for the aircraft rotating clockwise and counterclockwise, respectively. Maximum yaw angular velocity is defined as 100 degrees/s. Minimum yaw angular velocity is defined as -100 degrees/s.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickYawControlMode_angularVelocity_inline",
                   "",
            ],
            [
                   "FlightCoordinateSystem",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_inline",
                   "Flight control coordinate system.",
            ],
            [
                   "Flight control coordinate system.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_inline",
                   "",
            ],
            [
                   "GROUND",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_Ground_inline",
                   "Ground coordinate system.",
            ],
            [
                   "Ground coordinate system.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_Ground_inline",
                   "",
            ],
            [
                   "BODY",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_Body_inline",
                   "Body coordinate system.",
            ],
            [
                   "Body coordinate system.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIVirtualStickFlightCoordinateSystem_Body_inline",
                   "",
            ],
            [
                   "ControlMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_inline",
                   "Control mode of the flight controller. It determines how the pilot can control the aircraft. By default, it is in smart control mode.",
            ],
            [
                   "Control mode of the flight controller. It determines how the pilot can control the aircraft. By default, it is in smart control mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_inline",
                   "",
            ],
            [
                   "CONTROL_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_inline",
                   "SDK Key for ControlMode: Control mode of the flight controller. It determines how the pilot can control the aircraft. By default, it is in smart control mode.",
            ],
            [
                   "SDK Key for ControlMode: Control mode of the flight controller. It determines how the pilot can control the aircraft. By default, it is in smart control mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_inline",
                   "",
            ],
            [
                   "SMART",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_smart_inline",
                   "Smart control mode. The aircraft can stabilize its altitude and attitude in smart mode.",
            ],
            [
                   "Smart control mode. The aircraft can stabilize its altitude and attitude in smart mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_smart_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_manual_inline",
                   "Manual control mode. The aircraft will not stabilize its altitude and attitude in manual mode. This mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. Any damage to the product when operating in this mode will not be covered under warranty.",
            ],
            [
                   "Manual control mode. The aircraft will not stabilize its altitude and attitude in manual mode. This mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. Any damage to the product when operating in this mode will not be covered under warranty.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_manual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_unknown_inline",
                   "Unknown control mode.",
            ],
            [
                   "Unknown control mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerControlMode_unknown_inline",
                   "",
            ],
            [
                   "FlightOrientationMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_inline",
                   "Tells the aircraft how to interpret flight commands for forward, backward, left and right. See the <i>Flight Controller User Guide</i> for more information.",
            ],
            [
                   "Tells the aircraft how to interpret flight commands for forward, backward, left and right. See the <i>Flight Controller User Guide</i> for more information.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_inline",
                   "",
            ],
            [
                   "ORIENTATION_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_inline",
                   "SDK Key for FlightOrientationMode: Tells the aircraft how to interpret flight commands for forward, backward, left and right. See the <i>Flight Controller User Guide</i> for more information.",
            ],
            [
                   "SDK Key for FlightOrientationMode: Tells the aircraft how to interpret flight commands for forward, backward, left and right. See the <i>Flight Controller User Guide</i> for more information.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_inline",
                   "",
            ],
            [
                   "COURSE_LOCK",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_CourseLock_inline",
                   "The aircraft should move relative to a locked course heading.",
            ],
            [
                   "The aircraft should move relative to a locked course heading.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_CourseLock_inline",
                   "",
            ],
            [
                   "HOME_LOCK",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_HomeLock_inline",
                   "The aircraft should move relative radially to the Home Point.",
            ],
            [
                   "The aircraft should move relative radially to the Home Point.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_HomeLock_inline",
                   "",
            ],
            [
                   "AIRCRAFT_HEADING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_DefaultAircraftHeading_inline",
                   "The aircraft should move relative to the front of the aircraft.",
            ],
            [
                   "The aircraft should move relative to the front of the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightOrientationMode_DefaultAircraftHeading_inline",
                   "",
            ],
            [
                   "FlightWindWarning",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_inline",
                   "Warning caused by the strong wind.",
            ],
            [
                   "Warning caused by the strong wind.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_inline",
                   "",
            ],
            [
                   "FLIGHT_WIND_WARNING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_inline",
                   "SDK Key for FlightWindWarning: Warning caused by the strong wind.",
            ],
            [
                   "SDK Key for FlightWindWarning: Warning caused by the strong wind.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_inline",
                   "",
            ],
            [
                   "LEVEL_0",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level0_inline",
                   "No wind warning.",
            ],
            [
                   "No wind warning.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level0_inline",
                   "",
            ],
            [
                   "LEVEL_1",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level1_inline",
                   "The wind speed is high. Fly with caution and ensure the aircraft remains within the line of sight.",
            ],
            [
                   "The wind speed is high. Fly with caution and ensure the aircraft remains within the line of sight.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level1_inline",
                   "",
            ],
            [
                   "LEVEL_2",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level2_inline",
                   "Strong Wind. Fly with caution and ensure the aircraft remains within line of sight. It is more serious than `LEVEL_1`.",
            ],
            [
                   "Strong Wind. Fly with caution and ensure the aircraft remains within line of sight. It is more serious than `LEVEL_1`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Level2_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightWindWarning_Unknown_inline",
                   "",
            ],
            [
                   "DJIFlightAssistantObstacleSensingDirection",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_inline",
                   "Obstacle sensing direction. It is only supported by Matrice 300 RTK.",
            ],
            [
                   "Obstacle sensing direction. It is only supported by Matrice 300 RTK.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_inline",
                   "",
            ],
            [
                   "Upward",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Upward_inline",
                   "Upward sensing. The upward distance range is 1.1m~30m",
            ],
            [
                   "Upward sensing. The upward distance range is 1.1m~30m",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Upward_inline",
                   "",
            ],
            [
                   "Downward",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Downward_inline",
                   "Downward sensing. The downward distance range is 0.6m~30m",
            ],
            [
                   "Downward sensing. The downward distance range is 0.6m~30m",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Downward_inline",
                   "",
            ],
            [
                   "Horizontal",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Horizontal_inline",
                   "Horizontal Field. The horizontal distance range is 1.1m~40m",
            ],
            [
                   "Horizontal Field. The horizontal distance range is 1.1m~40m",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightAssistantObstacleSensingDirection_Horizontal_inline",
                   "",
            ],
            [
                   "LocationCoordinate2D",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "",
                   "A class representing 2-dimensional location coordinate",
            ],
            [
                   "A class representing 2-dimensional location coordinate",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "",
                   "",
            ],
            [
                   "LocationCoordinate2D",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_Constructor_inline",
                   "Construct a `DJILocationCoordinate2D` object with Latitude and Longitude.  @param latitude Latitude in degrees. @param longitude Longitude in degrees.",
            ],
            [
                   "Construct a `DJILocationCoordinate2D` object with Latitude and Longitude.  @param latitude Latitude in degrees. @param longitude Longitude in degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_Constructor_inline",
                   "",
            ],
            [
                   "getLatitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_getLatitude_inline",
                   "Returns `DJILocationCoordinate2D` object, which could be used as an input parameter for flight controller's interfaces.  @return The double value of latitude.",
            ],
            [
                   "Returns `DJILocationCoordinate2D` object, which could be used as an input parameter for flight controller's interfaces.  @return The double value of latitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_getLatitude_inline",
                   "",
            ],
            [
                   "getLongitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_getLongitude_inline",
                   "Returns the longitude.  @return The double value of longitude.",
            ],
            [
                   "Returns the longitude.  @return The double value of longitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate2D.html",
                   "#DJIFlightController_DJILocationCoordinate2D_getLongitude_inline",
                   "",
            ],
            [
                   "ConnectionFailSafeBehavior",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_inline",
                   "Defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
            ],
            [
                   "Defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "CONNECTION_FAIL_SAFE_BEHAVIOR",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_inline",
                   "SDK Key for ConnectionFailSafeBehavior: Defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
            ],
            [
                   "SDK Key for ConnectionFailSafeBehavior: Defines aircraft failsafe action when signal between the remote controller and the aircraft is lost.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_inline",
                   "",
            ],
            [
                   "HOVER",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Hover_inline",
                   "Hover.",
            ],
            [
                   "Hover.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Hover_inline",
                   "",
            ],
            [
                   "LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Landing_inline",
                   "Landing.",
            ],
            [
                   "Landing.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Landing_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_GoHome_inline",
                   "Return-to-Home.",
            ],
            [
                   "Return-to-Home.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_GoHome_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightFailsafeOperation_Unknown_inline",
                   "",
            ],
            [
                   "RemoteControllerFlightMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_inline",
                   "Flight modes that map to the flight mode switch on the remote controller.",
            ],
            [
                   "Flight modes that map to the flight mode switch on the remote controller.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_inline",
                   "",
            ],
            [
                   "CURRENT_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_inline",
                   "SDK Key for RemoteControllerFlightMode: Flight modes that map to the flight mode switch on the remote controller.",
            ],
            [
                   "SDK Key for RemoteControllerFlightMode: Flight modes that map to the flight mode switch on the remote controller.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_inline",
                   "",
            ],
            [
                   "P",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_P_inline",
                   "Positioning mode. GNSS and Vision Positioning Systems are used for positioning if they are available. For products without F mode, intelligent functions such as missions and intelligent orientation control can be performed in P-mode.",
            ],
            [
                   "Positioning mode. GNSS and Vision Positioning Systems are used for positioning if they are available. For products without F mode, intelligent functions such as missions and intelligent orientation control can be performed in P-mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_P_inline",
                   "",
            ],
            [
                   "S",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_S_inline",
                   "Sport mode. The maximum flight speed and responsiveness of the aircraft is increased in this mode.",
            ],
            [
                   "Sport mode. The maximum flight speed and responsiveness of the aircraft is increased in this mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_S_inline",
                   "",
            ],
            [
                   "A",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_A_inline",
                   "Attitude mode. The GNSS and Vision Positioning Systems are not used for positioning. The aircraft only uses the barometer to maintain altitude. If receiving a GNSS signal, the aircraft can automatically return home if the Remote Controller signal is lost and if the Home Point has been recorded successfully.",
            ],
            [
                   "Attitude mode. The GNSS and Vision Positioning Systems are not used for positioning. The aircraft only uses the barometer to maintain altitude. If receiving a GNSS signal, the aircraft can automatically return home if the Remote Controller signal is lost and if the Home Point has been recorded successfully.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_A_inline",
                   "",
            ],
            [
                   "G",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_G_inline",
                   "Gentle mode. The sensitivity and speed of aircraft will be substantially decreased in gentle mode.",
            ],
            [
                   "Gentle mode. The sensitivity and speed of aircraft will be substantially decreased in gentle mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_G_inline",
                   "",
            ],
            [
                   "M",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_M_inline",
                   "Manual mode. The aircraft will not stabilize its altitude nor attitude in manual mode. This mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. Any damage to the product when operating in this mode will not be covered under warranty. It is supported by stand-alone A3 and N3 and can be enabled in Assistant 2.",
            ],
            [
                   "Manual mode. The aircraft will not stabilize its altitude nor attitude in manual mode. This mode is for advanced pilots only, and should only be used when the pilot understands the risk of operating in this mode. Any damage to the product when operating in this mode will not be covered under warranty. It is supported by stand-alone A3 and N3 and can be enabled in Assistant 2.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_M_inline",
                   "",
            ],
            [
                   "F",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_F_inline",
                   "Function mode. Performs the same as Positioning mode with intelligent functions such as missions and intelligent orientation control enabled.",
            ],
            [
                   "Function mode. Performs the same as Positioning mode with intelligent functions such as missions and intelligent orientation control enabled.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_F_inline",
                   "",
            ],
            [
                   "T",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_T_inline",
                   "Tripod Mode. This mode drops the aircraft's maximum speed and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. It is only supported by Mavic 2.",
            ],
            [
                   "Tripod Mode. This mode drops the aircraft's maximum speed and significantly reduces the control stick sensitivity of the remote controller to give the user the precision needed for accurate framing. It is only supported by Mavic 2.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_T_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_Unknown_inline",
                   "Unknown mode.",
            ],
            [
                   "Unknown mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerRemoteControllerFlightMode_Unknown_inline",
                   "",
            ],
            [
                   "SmartRTHState",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_inline",
                   "State of Smart Return-To-Home (RTH). It is only used when Smart RTH is enabled.",
            ],
            [
                   "State of Smart Return-To-Home (RTH). It is only used when Smart RTH is enabled.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Idle_inline",
                   "Smart RTH is not triggered yet in the current flight. The Smart RTH state will be reset to this value when the aircraft lands.",
            ],
            [
                   "Smart RTH is not triggered yet in the current flight. The Smart RTH state will be reset to this value when the aircraft lands.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Idle_inline",
                   "",
            ],
            [
                   "COUNTING_DOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_CountingDown_inline",
                   "Smart RTH is triggered and the aircraft is counting down. If no response is received within 10 seconds or the user confirms the request, the aircraft will start to go home and the state will change to `EXECUTED`. If user cancels the request, the state will change to `CANCELLED`.",
            ],
            [
                   "Smart RTH is triggered and the aircraft is counting down. If no response is received within 10 seconds or the user confirms the request, the aircraft will start to go home and the state will change to `EXECUTED`. If user cancels the request, the state will change to `CANCELLED`.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_CountingDown_inline",
                   "",
            ],
            [
                   "EXECUTED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Executed_inline",
                   "Smart RTH is already executed in the current flight. The state will not be reset until the aircraft lands.",
            ],
            [
                   "Smart RTH is already executed in the current flight. The state will not be reset until the aircraft lands.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Executed_inline",
                   "",
            ],
            [
                   "CANCELLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Cancelled_inline",
                   "Smart RTH request is cancelled by the user. The state will not be reset until the aircraft lands.",
            ],
            [
                   "Smart RTH request is cancelled by the user. The state will not be reset until the aircraft lands.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Cancelled_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_DJIFlightControllerSmartRTHState_Unknown_inline",
                   "",
            ],
            [
                   "AirSenseSystemInformation",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "",
                   "The state of DJI AirSense system. It contains the overall warning level and the detailed state of each detected airplane.",
            ],
            [
                   "The state of DJI AirSense system. It contains the overall warning level and the detailed state of each detected airplane.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "",
                   "",
            ],
            [
                   "getWarningLevel",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseSystemInformation_systemWarningLevel_inline",
                   "The overall system warning level. This will be the worst case of all individual aircraft warning levels.  @return An enum value of `AirSenseWarningLevel`.",
            ],
            [
                   "The overall system warning level. This will be the worst case of all individual aircraft warning levels.  @return An enum value of `AirSenseWarningLevel`.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseSystemInformation_systemWarningLevel_inline",
                   "",
            ],
            [
                   "getAirplaneStates",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseSystemInformation_airplaneStates_inline",
                   "The state of all airplanes detected by DJI AirSense system.  @return An array of `AirSenseAirplaneState` objects.",
            ],
            [
                   "The state of all airplanes detected by DJI AirSense system.  @return An array of `AirSenseAirplaneState` objects.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseSystemInformation_airplaneStates_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation_callbackInterface.html",
                   "",
                   "An interface for obtaining `AirSenseSystemInformation` infos.",
            ],
            [
                   "An interface for obtaining `AirSenseSystemInformation` infos.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation_callbackInterface.html",
                   "#DJIAirSenseSystemInformation_callbackMethod_inline",
                   "Callback method of Air Sense Airplane State.  @param information An object of `AirSenseSystemInformation`.",
            ],
            [
                   "Callback method of Air Sense Airplane State.  @param information An object of `AirSenseSystemInformation`.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation_callbackInterface.html",
                   "#DJIAirSenseSystemInformation_callbackMethod_inline",
                   "",
            ],
            [
                   "AirSenseAirplaneState",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "",
                   "The AirSense state of an airplane. DJI AirSense only sends out warnings of nearby civil aircraft under certain circumstances; it will NOT control DJI aircraft to avoid other aircraft automatically. Make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. After receiving warnings, lower your aircraft to a safe height. In addition, DJI AirSense has the following limitations: 1. DJI AirSense can only receive messages sent from civil aircraft equipped with an ADS-B out device under 1090ES (RTCA DO-260) or UAT (RTCA Do-282) standards. For civil aircraft without ADS-B outs or with malfunctioning ADS-B outs, DJI AirSense cannot receive related broadcasted messages or send out warnings. 2. When there are obstacles in between a civil aircraft and DJI aircraft, DJI AirSense will fail to receive ADS-B messages sent from civil aircraft or to send out warnings. 3. DJI AirSense may fail to receive ADS-B messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. It is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. DJI AirSense cannot send out warnings when the DJI aircraft cannot accurately determine its location. 5. DJI AirSense cannot receive ADS-B messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
            ],
            [
                   "The AirSense state of an airplane. DJI AirSense only sends out warnings of nearby civil aircraft under certain circumstances; it will NOT control DJI aircraft to avoid other aircraft automatically. Make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. After receiving warnings, lower your aircraft to a safe height. In addition, DJI AirSense has the following limitations: 1. DJI AirSense can only receive messages sent from civil aircraft equipped with an ADS-B out device under 1090ES (RTCA DO-260) or UAT (RTCA Do-282) standards. For civil aircraft without ADS-B outs or with malfunctioning ADS-B outs, DJI AirSense cannot receive related broadcasted messages or send out warnings. 2. When there are obstacles in between a civil aircraft and DJI aircraft, DJI AirSense will fail to receive ADS-B messages sent from civil aircraft or to send out warnings. 3. DJI AirSense may fail to receive ADS-B messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. It is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. DJI AirSense cannot send out warnings when the DJI aircraft cannot accurately determine its location. 5. DJI AirSense cannot receive ADS-B messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "",
                   "",
            ],
            [
                   "AIR_SENSE_AIRPLANE_STATES",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "",
                   "SDK Key for AirSenseAirplaneState: The AirSense state of an airplane. DJI AirSense only sends out warnings of nearby civil aircraft under certain circumstances; it will NOT control DJI aircraft to avoid other aircraft automatically. Make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. After receiving warnings, lower your aircraft to a safe height. In addition, DJI AirSense has the following limitations: 1. DJI AirSense can only receive messages sent from civil aircraft equipped with an ADS-B out device under 1090ES (RTCA DO-260) or UAT (RTCA Do-282) standards. For civil aircraft without ADS-B outs or with malfunctioning ADS-B outs, DJI AirSense cannot receive related broadcasted messages or send out warnings. 2. When there are obstacles in between a civil aircraft and DJI aircraft, DJI AirSense will fail to receive ADS-B messages sent from civil aircraft or to send out warnings. 3. DJI AirSense may fail to receive ADS-B messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. It is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. DJI AirSense cannot send out warnings when the DJI aircraft cannot accurately determine its location. 5. DJI AirSense cannot receive ADS-B messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
            ],
            [
                   "SDK Key for AirSenseAirplaneState: The AirSense state of an airplane. DJI AirSense only sends out warnings of nearby civil aircraft under certain circumstances; it will NOT control DJI aircraft to avoid other aircraft automatically. Make sure to fly with your aircraft within visual line of sight at all times, and always fly with caution. After receiving warnings, lower your aircraft to a safe height. In addition, DJI AirSense has the following limitations: 1. DJI AirSense can only receive messages sent from civil aircraft equipped with an ADS-B out device under 1090ES (RTCA DO-260) or UAT (RTCA Do-282) standards. For civil aircraft without ADS-B outs or with malfunctioning ADS-B outs, DJI AirSense cannot receive related broadcasted messages or send out warnings. 2. When there are obstacles in between a civil aircraft and DJI aircraft, DJI AirSense will fail to receive ADS-B messages sent from civil aircraft or to send out warnings. 3. DJI AirSense may fail to receive ADS-B messages sent from civil aircraft or send out warnings due to ever changing circumstances and interference. It is highly recommended to fly with caution and stay aware of your surroundings during flight. 4. DJI AirSense cannot send out warnings when the DJI aircraft cannot accurately determine its location. 5. DJI AirSense cannot receive ADS-B messages sent from civil aircraft or send out warnings when it is disabled or misconfigured.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "",
                   "",
            ],
            [
                   "getCode",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_code_inline",
                   "The unique code (ICAO) of the airplane.  @return String of the unique code (ICAO).",
            ],
            [
                   "The unique code (ICAO) of the airplane.  @return String of the unique code (ICAO).",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_code_inline",
                   "",
            ],
            [
                   "getWarningLevel",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_warningLevel_inline",
                   "The warning level determined by DJI AirSense system.  @return An enum value of `AirSenseWarningLevel`.",
            ],
            [
                   "The warning level determined by DJI AirSense system.  @return An enum value of `AirSenseWarningLevel`.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_warningLevel_inline",
                   "",
            ],
            [
                   "getRelativeDirection",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_relativeDirection_inline",
                   "The direction of the airplane relative to the DJI aircraft.  @return An enum value of `AirSenseDirection`.",
            ],
            [
                   "The direction of the airplane relative to the DJI aircraft.  @return An enum value of `AirSenseDirection`.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_relativeDirection_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_heading_inline",
                   "The heading of the airplane.  @return A float value of heading.",
            ],
            [
                   "The heading of the airplane.  @return A float value of heading.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_heading_inline",
                   "",
            ],
            [
                   "getDistance",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_distance_inline",
                   "The distance between the airplane and DJI aircraft in meters.  @return An int value of distance.",
            ],
            [
                   "The distance between the airplane and DJI aircraft in meters.  @return An int value of distance.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseAirplaneState_distance_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState_callbackInterface.html",
                   "",
                   "An interface for obtaining `AirSenseAirplaneState` infos.",
            ],
            [
                   "An interface for obtaining `AirSenseAirplaneState` infos.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState_callbackInterface.html",
                   "#DJIAirSenseAirplaneState_callback_inline",
                   "Callback method of Air Sense Airplane State.  @param information Array of `AirSenseAirplaneState`.",
            ],
            [
                   "Callback method of Air Sense Airplane State.  @param information Array of `AirSenseAirplaneState`.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState_callbackInterface.html",
                   "#DJIAirSenseAirplaneState_callback_inline",
                   "",
            ],
            [
                   "AirSenseWarningLevel",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_inline",
                   "The warning level determined by the DJI AirSense system. The warning level is based on the distance between the airplane and the DJI aircraft, and the heading of the airplane.",
            ],
            [
                   "The warning level determined by the DJI AirSense system. The warning level is based on the distance between the airplane and the DJI aircraft, and the heading of the airplane.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_inline",
                   "",
            ],
            [
                   "AIR_SENSE_SYSTEM_WARNING_LEVEL",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_inline",
                   "SDK Key for AirSenseWarningLevel: The warning level determined by the DJI AirSense system. The warning level is based on the distance between the airplane and the DJI aircraft, and the heading of the airplane.",
            ],
            [
                   "SDK Key for AirSenseWarningLevel: The warning level determined by the DJI AirSense system. The warning level is based on the distance between the airplane and the DJI aircraft, and the heading of the airplane.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_inline",
                   "",
            ],
            [
                   "LEVEL_0",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_0_inline",
                   "The system detects the airplane but the DJI aircraft is either far away from the airplane or is in the opposite direction of the airplane's heading.",
            ],
            [
                   "The system detects the airplane but the DJI aircraft is either far away from the airplane or is in the opposite direction of the airplane's heading.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_0_inline",
                   "",
            ],
            [
                   "LEVEL_1",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_1_inline",
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered low.",
            ],
            [
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered low.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_1_inline",
                   "",
            ],
            [
                   "LEVEL_2",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_2_inline",
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered medium.",
            ],
            [
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered medium.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_2_inline",
                   "",
            ],
            [
                   "LEVEL_3",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_3_inline",
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered high.",
            ],
            [
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is considered high.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_3_inline",
                   "",
            ],
            [
                   "LEVEL_4",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_4_inline",
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is very high.",
            ],
            [
                   "The system detects the airplane. The probability that it will pass through the location of the DJI aircraft is very high.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_4_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIAirSenseSystemInformation.html",
                   "#DJIAirSenseWarningLevel_Unknown_inline",
                   "",
            ],
            [
                   "AirSenseDirection",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_inline",
                   "Directions.",
            ],
            [
                   "Directions.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_inline",
                   "",
            ],
            [
                   "NORTH",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_North_inline",
                   "North.",
            ],
            [
                   "North.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_North_inline",
                   "",
            ],
            [
                   "NORTH_EAST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_NorthEast_inline",
                   "North east.",
            ],
            [
                   "North east.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_NorthEast_inline",
                   "",
            ],
            [
                   "EAST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_East_inline",
                   "East.",
            ],
            [
                   "East.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_East_inline",
                   "",
            ],
            [
                   "SOUTH_EAST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_SouthEast_inline",
                   "South east.",
            ],
            [
                   "South east.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_SouthEast_inline",
                   "",
            ],
            [
                   "SOUTH",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_South_inline",
                   "South.",
            ],
            [
                   "South.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_South_inline",
                   "",
            ],
            [
                   "SOUTH_WEST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_SouthWest_inline",
                   "South west.",
            ],
            [
                   "South west.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_SouthWest_inline",
                   "",
            ],
            [
                   "WEST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_West_inline",
                   "West.",
            ],
            [
                   "West.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_West_inline",
                   "",
            ],
            [
                   "NORTH_WEST",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_NorthWest_inline",
                   "North west.",
            ],
            [
                   "North west.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_NorthWest_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIAirSenseAirplaneState.html",
                   "#DJIAirSenseDirection_Unknown_inline",
                   "",
            ],
            [
                   "LEDsSettings",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "",
                   "Settings for the aircraft's LEDs.",
            ],
            [
                   "Settings for the aircraft's LEDs.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "",
                   "",
            ],
            [
                   "areFrontLEDsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_frontLEDsOn_inline",
                   "`true` if the LEDs on the front arms are turned on.  @return A boolean value.",
            ],
            [
                   "`true` if the LEDs on the front arms are turned on.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_frontLEDsOn_inline",
                   "",
            ],
            [
                   "areRearLEDsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_rearLEDsOn_inline",
                   "`true` if the LEDs on the rear arms are turned on. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will ignore this property.  @return A boolean value.",
            ],
            [
                   "`true` if the LEDs on the rear arms are turned on. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will ignore this property.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_rearLEDsOn_inline",
                   "",
            ],
            [
                   "areBeaconsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_beaconOn_inline",
                   "`true` if the beacons on the top and bottom are turned on. It is supported by Matrice 300 RTK. The other products will ignore this property.  @return A boolean value.",
            ],
            [
                   "`true` if the beacons on the top and bottom are turned on. It is supported by Matrice 300 RTK. The other products will ignore this property.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_beaconOn_inline",
                   "",
            ],
            [
                   "isStatusIndicatorOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_statusIndicatorOn_inline",
                   "`true` if the status indicator is on. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will ignore this property. For Mavic 2 series, there are two status indicators and they are on the rear arms.  @return A boolean value.",
            ],
            [
                   "`true` if the status indicator is on. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will ignore this property. For Mavic 2 series, there are two status indicators and they are on the rear arms.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_statusIndicatorOn_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "",
                   "Used to create `LEDsSettings` instance.",
            ],
            [
                   "Used to create `LEDsSettings` instance.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "",
                   "",
            ],
            [
                   "frontLEDsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_frontLEDsOn_inline",
                   "`true` to turn on the LEDs on the front arms.  @param frontLEDsOn `true` to turn on the LEDs on the front arms.  @return A `Builder` object.",
            ],
            [
                   "`true` to turn on the LEDs on the front arms.  @param frontLEDsOn `true` to turn on the LEDs on the front arms.  @return A `Builder` object.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_frontLEDsOn_inline",
                   "",
            ],
            [
                   "rearLEDsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_rearLEDsOn_inline",
                   "`true` to turn on the LEDs on the rear arms. It is supported by Inspire 2 and Matrice 200 series. The other products will always return `false`.  @param rearLEDsOn `true` to turn on the LEDs on the rear arms.  @return A `Builder` object.",
            ],
            [
                   "`true` to turn on the LEDs on the rear arms. It is supported by Inspire 2 and Matrice 200 series. The other products will always return `false`.  @param rearLEDsOn `true` to turn on the LEDs on the rear arms.  @return A `Builder` object.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_rearLEDsOn_inline",
                   "",
            ],
            [
                   "statusIndicatorOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_statusIndicatorOn_inline",
                   "`true` to turn on the LEDs on the rear arms. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will always return `false`.  @param statusIndicatorOn `true` to turn on the LEDs on the rear arms.  @return A `Builder` object.",
            ],
            [
                   "`true` to turn on the LEDs on the rear arms. It is supported by Inspire 2, Matrice 200 series and Mavic 2 series. The other products will always return `false`.  @param statusIndicatorOn `true` to turn on the LEDs on the rear arms.  @return A `Builder` object.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_statusIndicatorOn_inline",
                   "",
            ],
            [
                   "beaconsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_beaconsOn_inline",
                   "`true` to turn on the beacons on the top and bottom of aircraft. It is supported by Matrice 300 RTK. The other products will ignore this property.  @param beaconsOn `true` to turn on the beacons.  @return A `Builder` object.",
            ],
            [
                   "`true` to turn on the beacons on the top and bottom of aircraft. It is supported by Matrice 300 RTK. The other products will ignore this property.  @param beaconsOn `true` to turn on the beacons.  @return A `Builder` object.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerLEDsSettings_Builder.html",
                   "#DJIFlightController_DJIFlightControllerLEDsSettings_Builder_beaconsOn_inline",
                   "",
            ],
            [
                   "Limits",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "",
                   "This class provides max and min values for flight controller virtual stick.",
            ],
            [
                   "This class provides max and min values for flight controller virtual stick.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "",
                   "",
            ],
            [
                   "VERTICAL_CONTROL_MIN_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MIN_VELOCITY_inline",
                   "Vertical control velocity MIN value -4 m/s in VirtualStickControlMode. Negative velocity is down.",
            ],
            [
                   "Vertical control velocity MIN value -4 m/s in VirtualStickControlMode. Negative velocity is down.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MIN_VELOCITY_inline",
                   "",
            ],
            [
                   "VERTICAL_CONTROL_MAX_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MAX_VELOCITY_inline",
                   "Vertical control velocity MAX value 4 m/s in VirtualStickControlMode. Positive velocity is up.",
            ],
            [
                   "Vertical control velocity MAX value 4 m/s in VirtualStickControlMode. Positive velocity is up.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MAX_VELOCITY_inline",
                   "",
            ],
            [
                   "VERTICAL_CONTROL_MIN_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MIN_HEIGHT_inline",
                   "Vertical control position MIN for VirtualStickVerticalControlModePosition. The default value is 0m.",
            ],
            [
                   "Vertical control position MIN for VirtualStickVerticalControlModePosition. The default value is 0m.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MIN_HEIGHT_inline",
                   "",
            ],
            [
                   "VERTICAL_CONTROL_MAX_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MAX_HEIGHT_inline",
                   "Vertical control position MAX for VirtualStickVerticalControlModePosition. The default value is 500m.",
            ],
            [
                   "Vertical control position MAX for VirtualStickVerticalControlModePosition. The default value is 500m.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_VERTICAL_CONTROL_MAX_HEIGHT_inline",
                   "",
            ],
            [
                   "ROLL_PITCH_CONTROL_MAX_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MAX_VELOCITY_inline",
                   "Roll/Pitch control velocity MAX value 15m/s.",
            ],
            [
                   "Roll/Pitch control velocity MAX value 15m/s.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MAX_VELOCITY_inline",
                   "",
            ],
            [
                   "ROLL_PITCH_CONTROL_MIN_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MIN_VELOCITY_inline",
                   "Roll/Pitch control velocity MIN value -15m/s.",
            ],
            [
                   "Roll/Pitch control velocity MIN value -15m/s.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MIN_VELOCITY_inline",
                   "",
            ],
            [
                   "ROLL_PITCH_CONTROL_MAX_ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MAX_ANGLE_inline",
                   "Roll/Pitch control angle MAX value 30 degrees.",
            ],
            [
                   "Roll/Pitch control angle MAX value 30 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MAX_ANGLE_inline",
                   "",
            ],
            [
                   "ROLL_PITCH_CONTROL_MIN_ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MIN_ANGLE_inline",
                   "Roll/Pitch control angle MIN value -30 degrees.",
            ],
            [
                   "Roll/Pitch control angle MIN value -30 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_ROLL_PITCH_CONTROL_MIN_ANGLE_inline",
                   "",
            ],
            [
                   "YAW_CONTROL_MAX_ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MAX_ANGLE_inline",
                   "Yaw control angle MAX value 180 degrees.",
            ],
            [
                   "Yaw control angle MAX value 180 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MAX_ANGLE_inline",
                   "",
            ],
            [
                   "YAW_CONTROL_MIN_ANGLE",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MIN_ANGLE_inline",
                   "Yaw control angle MIN value -180 degrees.",
            ],
            [
                   "Yaw control angle MIN value -180 degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MIN_ANGLE_inline",
                   "",
            ],
            [
                   "YAW_CONTROL_MAX_ANGULAR_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MAX_ANGULAR_VELOCITY_inline",
                   "Yaw control angular velocity MAX value 100 degree/s.",
            ],
            [
                   "Yaw control angular velocity MAX value 100 degree/s.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MAX_ANGULAR_VELOCITY_inline",
                   "",
            ],
            [
                   "YAW_CONTROL_MIN_ANGULAR_VELOCITY",
                   2,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MIN_ANGULAR_VELOCITY_inline",
                   "Yaw control angular velocity MIN value -100 degree/s.",
            ],
            [
                   "Yaw control angular velocity MIN value -100 degree/s.",
                   1,
                   "/Components/FlightController/DJIFlightController_Limits.html",
                   "#DJIFlightController_Limits_YAW_CONTROL_MIN_ANGULAR_VELOCITY_inline",
                   "",
            ],
            [
                   "FixedWingControl",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_inline",
                   "The aircraft will fly forward automatically at a certain speed after entering Fixed-Wing Mode. Push the left stick up to ascend and down to descend. Push either stick left or right to rotate the aircraft. Push the right stick up to accelerate and pushing down will exit Fixed-Wing Mode. See the <i>Flight Controller User Guide</i> for more information.",
            ],
            [
                   "The aircraft will fly forward automatically at a certain speed after entering Fixed-Wing Mode. Push the left stick up to ascend and down to descend. Push either stick left or right to rotate the aircraft. Push the right stick up to accelerate and pushing down will exit Fixed-Wing Mode. See the <i>Flight Controller User Guide</i> for more information.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_inline",
                   "",
            ],
            [
                   "FIXED_WING_CONTROL",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_inline",
                   "SDK Key for FixedWingControl: The aircraft will fly forward automatically at a certain speed after entering Fixed-Wing Mode. Push the left stick up to ascend and down to descend. Push either stick left or right to rotate the aircraft. Push the right stick up to accelerate and pushing down will exit Fixed-Wing Mode. See the <i>Flight Controller User Guide</i> for more information.",
            ],
            [
                   "SDK Key for FixedWingControl: The aircraft will fly forward automatically at a certain speed after entering Fixed-Wing Mode. Push the left stick up to ascend and down to descend. Push either stick left or right to rotate the aircraft. Push the right stick up to accelerate and pushing down will exit Fixed-Wing Mode. See the <i>Flight Controller User Guide</i> for more information.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_inline",
                   "",
            ],
            [
                   "READY",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_READY_inline",
                   "Prepare fixed-wing mode.",
            ],
            [
                   "Prepare fixed-wing mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_READY_inline",
                   "",
            ],
            [
                   "ENTER",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_ENTER_inline",
                   "Enter fixed-wing mode.",
            ],
            [
                   "Enter fixed-wing mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_ENTER_inline",
                   "",
            ],
            [
                   "EXIT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_EXIT_inline",
                   "Exit fixed-wing mode.",
            ],
            [
                   "Exit fixed-wing mode.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_EXIT_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_OTHER_inline",
                   "Other reservations.",
            ],
            [
                   "Other reservations.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_FixedWingControl_OTHER_inline",
                   "",
            ],
            [
                   "VisionDrawHeadingMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_inline",
                   "The heading mode of the camera used in the vision drawing the 3D orbit data.",
            ],
            [
                   "The heading mode of the camera used in the vision drawing the 3D orbit data.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_inline",
                   "",
            ],
            [
                   "DRAW_HEADING_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_inline",
                   "SDK Key for VisionDrawHeadingMode: The heading mode of the camera used in the vision drawing the 3D orbit data.",
            ],
            [
                   "SDK Key for VisionDrawHeadingMode: The heading mode of the camera used in the vision drawing the 3D orbit data.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_inline",
                   "",
            ],
            [
                   "FREE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_FREE_inline",
                   "Free mode - Camera direction can be freely adjusted in flight.",
            ],
            [
                   "Free mode - Camera direction can be freely adjusted in flight.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_FREE_inline",
                   "",
            ],
            [
                   "FORWARD",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_FORWARD_inline",
                   "Regular mode - camera direction consistent with course direction.",
            ],
            [
                   "Regular mode - camera direction consistent with course direction.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_FORWARD_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_UNKNOWN_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawHeadingMode_UNKNOWN_inline",
                   "",
            ],
            [
                   "VisionDrawStatus",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_inline",
                   "State of the vision drawing the 3D orbit data.",
            ],
            [
                   "State of the vision drawing the 3D orbit data.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_inline",
                   "",
            ],
            [
                   "DRAW_STATUS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_inline",
                   "SDK Key for VisionDrawStatus: State of the vision drawing the 3D orbit data.",
            ],
            [
                   "SDK Key for VisionDrawStatus: State of the vision drawing the 3D orbit data.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_inline",
                   "",
            ],
            [
                   "INIT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_INIT_inline",
                   "Initializing.",
            ],
            [
                   "Initializing.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_INIT_inline",
                   "",
            ],
            [
                   "PREPARE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_PREPARE_inline",
                   "Vision got the orbit data, and preparing to calculate the 3D orbit.",
            ],
            [
                   "Vision got the orbit data, and preparing to calculate the 3D orbit.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_PREPARE_inline",
                   "",
            ],
            [
                   "READY_TO_GO",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_READY_TO_GO_inline",
                   "Vision has generated the 3D orbit data, and start to download.",
            ],
            [
                   "Vision has generated the 3D orbit data, and start to download.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_READY_TO_GO_inline",
                   "",
            ],
            [
                   "START_AUTO",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_START_AUTO_inline",
                   "Starting State (Auto mode).",
            ],
            [
                   "Starting State (Auto mode).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_START_AUTO_inline",
                   "",
            ],
            [
                   "START_MANUAL",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_START_MANUAL_inline",
                   "Staring State (Manual mode).",
            ],
            [
                   "Staring State (Manual mode).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_START_MANUAL_inline",
                   "",
            ],
            [
                   "PAUSE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_PAUSE_inline",
                   "Pause state.",
            ],
            [
                   "Pause state.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_PAUSE_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_OTHER_inline",
                   "Other unknown state.",
            ],
            [
                   "Other unknown state.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_VisionDrawStatus_OTHER_inline",
                   "",
            ],
            [
                   "UrgentStopMotorMode",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_inline",
                   "The Mode enum to urgent stop motor.",
            ],
            [
                   "The Mode enum to urgent stop motor.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_inline",
                   "",
            ],
            [
                   "URGENT_STOP_MOTOR_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_inline",
                   "SDK Key for UrgentStopMotorMode: The Mode enum to urgent stop motor.",
            ],
            [
                   "SDK Key for UrgentStopMotorMode: The Mode enum to urgent stop motor.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_inline",
                   "",
            ],
            [
                   "CSC",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_CSC_inline",
                   "Command only for Inspire 2, Phantom 4, Phantom 4 Professional, Phantom 4 Advanced and M200 series.",
            ],
            [
                   "Command only for Inspire 2, Phantom 4, Phantom 4 Professional, Phantom 4 Advanced and M200 series.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_CSC_inline",
                   "",
            ],
            [
                   "NEVER",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_NEVER_inline",
                   "Command only for Inspire 2, Phantom 4, Phantom 4 Professional, Phantom 4 Advanced and M200 series.",
            ],
            [
                   "Command only for Inspire 2, Phantom 4, Phantom 4 Professional, Phantom 4 Advanced and M200 series.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_NEVER_inline",
                   "",
            ],
            [
                   "IN_OUT_ALWAYS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_IN_OUT_ALWAYS_inline",
                   "Command only for DJI Mavic Pro and Mavic Air.",
            ],
            [
                   "Command only for DJI Mavic Pro and Mavic Air.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_IN_OUT_ALWAYS_inline",
                   "",
            ],
            [
                   "IN_OUT_WHEN_BREAKDOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_IN_OUT_WHEN_BREAKDOWN_inline",
                   "Command only for DJI Mavic Pro and Mavic Air.",
            ],
            [
                   "Command only for DJI Mavic Pro and Mavic Air.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_IN_OUT_WHEN_BREAKDOWN_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_UNKNOWN_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightController_UrgentStopMotorMode_UNKNOWN_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setUpdatedSimulatorStateDataCallback_inline",
                   "Sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setUpdatedSimulatorStateDataCallback_inline",
                   "",
            ],
            [
                   "SIMULATOR_STATE",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setUpdatedSimulatorStateDataCallback_inline",
                   "SDK Key for setStateCallback: Sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setStateCallback: Sets the callback function that updates the state data received from an aircraft in simulation mode.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setUpdatedSimulatorStateDataCallback_inline",
                   "",
            ],
            [
                   "isSimulatorActive",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_isSimulatorStarted_inline",
                   "`true` if the simulator is started.  @return A boolean value.",
            ],
            [
                   "`true` if the simulator is started.  @return A boolean value.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_isSimulatorStarted_inline",
                   "",
            ],
            [
                   "IS_SIMULATOR_ACTIVE",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_isSimulatorStarted_inline",
                   "SDK Key for isSimulatorActive: `true` if the simulator is started.  @return A boolean value.",
            ],
            [
                   "SDK Key for isSimulatorActive: `true` if the simulator is started.  @return A boolean value.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_isSimulatorStarted_inline",
                   "",
            ],
            [
                   "start",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_startSimulator_inline",
                   "Start simulator. Will result in error if simulation is already started.  @param data The data with which to initialize the simulator. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Start simulator. Will result in error if simulation is already started.  @param data The data with which to initialize the simulator. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_startSimulator_inline",
                   "",
            ],
            [
                   "START_SIMULATOR",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_startSimulator_inline",
                   "SDK Key for start: Start simulator. Will result in error if simulation is already started.  @param data The data with which to initialize the simulator. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for start: Start simulator. Will result in error if simulation is already started.  @param data The data with which to initialize the simulator. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_startSimulator_inline",
                   "",
            ],
            [
                   "stop",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_stopSimulator_inline",
                   "Stop the simulator.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Stop the simulator.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_stopSimulator_inline",
                   "",
            ],
            [
                   "STOP_SIMULATOR",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_stopSimulator_inline",
                   "SDK Key for stop: Stop the simulator.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for stop: Stop the simulator.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_stopSimulator_inline",
                   "",
            ],
            [
                   "setFlyZoneLimitationEnabled",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setFlyZoneEnabled_inline",
                   "Enable/disable the fly zone system in the simulator. By default, fly zone is disabled in the simulator.  Rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enable/disable the fly zone system in the simulator. By default, fly zone is disabled in the simulator.  Rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setFlyZoneEnabled_inline",
                   "",
            ],
            [
                   "FLY_ZONE_LIMITATION_ENABLED",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setFlyZoneEnabled_inline",
                   "SDK Key for setFlyZoneLimitationEnabled: Enable/disable the fly zone system in the simulator. By default, fly zone is disabled in the simulator.  Rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for setFlyZoneLimitationEnabled: Enable/disable the fly zone system in the simulator. By default, fly zone is disabled in the simulator.  Rebooting the aircraft is required for the settings to take effect.  @param enabled `true` to enable fly zone in the simulator. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_setFlyZoneEnabled_inline",
                   "",
            ],
            [
                   "getFlyZoneLimitationEnabled",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_getFlyZoneEnabled_inline",
                   "Gets fly zone system simulator status (enabled/disabled). By default, fly zone is disabled in the simulator.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets fly zone system simulator status (enabled/disabled). By default, fly zone is disabled in the simulator.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_getFlyZoneEnabled_inline",
                   "",
            ],
            [
                   "FLY_ZONE_LIMITATION_ENABLED",
                   2,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_getFlyZoneEnabled_inline",
                   "SDK Key for getFlyZoneLimitationEnabled: Gets fly zone system simulator status (enabled/disabled). By default, fly zone is disabled in the simulator.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFlyZoneLimitationEnabled: Gets fly zone system simulator status (enabled/disabled). By default, fly zone is disabled in the simulator.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Simulator/DJISimulator.html",
                   "#DJISimulator_getFlyZoneEnabled_inline",
                   "",
            ],
            [
                   "InitializationData",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "",
                   "Data to initialize the simulator with.",
            ],
            [
                   "Data to initialize the simulator with.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "",
                   "",
            ],
            [
                   "START_SIMULATOR",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "",
                   "SDK Key for InitializationData: Data to initialize the simulator with.",
            ],
            [
                   "SDK Key for InitializationData: Data to initialize the simulator with.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "",
                   "",
            ],
            [
                   "SimulatorState",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "",
                   "Aircraft simulator state data.",
            ],
            [
                   "Aircraft simulator state data.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "",
                   "",
            ],
            [
                   "SIMULATOR_STATE",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "",
                   "SDK Key for SimulatorState: Aircraft simulator state data.",
            ],
            [
                   "SDK Key for SimulatorState: Aircraft simulator state data.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "",
                   "Simulator's callback interface. When the SDK receives the `SimulatorState`, the override  method will be called.",
            ],
            [
                   "Simulator's callback interface. When the SDK receives the `SimulatorState`, the override  method will be called.",
                   1,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "SIMULATOR_STATE",
                   2,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "",
                   "SDK Key for Callback: Simulator's callback interface. When the SDK receives the `SimulatorState`, the override  method will be called.",
            ],
            [
                   "SDK Key for Callback: Simulator's callback interface. When the SDK receives the `SimulatorState`, the override  method will be called.",
                   1,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "#DJISimulator_updateSimulatorState_inline",
                   "Updates the simulator's current state.  @param state An instance of `SimulatorState`.",
            ],
            [
                   "Updates the simulator's current state.  @param state An instance of `SimulatorState`.",
                   1,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "#DJISimulator_updateSimulatorState_inline",
                   "",
            ],
            [
                   "SIMULATOR_STATE",
                   2,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "#DJISimulator_updateSimulatorState_inline",
                   "SDK Key for onUpdate: Updates the simulator's current state.  @param state An instance of `SimulatorState`.",
            ],
            [
                   "SDK Key for onUpdate: Updates the simulator's current state.  @param state An instance of `SimulatorState`.",
                   1,
                   "/Components/Simulator/DJISimulator_UpdatedSimulatorStateDataCallbackInterface.html",
                   "#DJISimulator_updateSimulatorState_inline",
                   "",
            ],
            [
                   "areMotorsOn",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_areMotorsOn_inline",
                   "TRUE if motors are on in the simulator.  @return A boolean value.",
            ],
            [
                   "TRUE if motors are on in the simulator.  @return A boolean value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_areMotorsOn_inline",
                   "",
            ],
            [
                   "isFlying",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_isFlying_inline",
                   "TRUE if aircraft is flying in the simulator.  @return A boolean value.",
            ],
            [
                   "TRUE if aircraft is flying in the simulator.  @return A boolean value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_isFlying_inline",
                   "",
            ],
            [
                   "getLocation",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_location_inline",
                   "Simulated aircraft location.  @return Location object.",
            ],
            [
                   "Simulated aircraft location.  @return Location object.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_location_inline",
                   "",
            ],
            [
                   "getPositionX",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionX_inline",
                   "Gets East-West distance from initial simulator location, where East is positive, and  North-East-Down coordinate system is used.  @return A float value.",
            ],
            [
                   "Gets East-West distance from initial simulator location, where East is positive, and  North-East-Down coordinate system is used.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionX_inline",
                   "",
            ],
            [
                   "getPositionY",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionY_inline",
                   "Gets North-South distance from initial simulator location, where North is positive, and  North-East-Down coordinate system is used.  @return A float value.",
            ],
            [
                   "Gets North-South distance from initial simulator location, where North is positive, and  North-East-Down coordinate system is used.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionY_inline",
                   "",
            ],
            [
                   "getPositionZ",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionZ_inline",
                   "Gets vertical distance from initial simulator location. The value should be negative if the height of aircraft is higher  than initial home point's height.  @return A float value.",
            ],
            [
                   "Gets vertical distance from initial simulator location. The value should be negative if the height of aircraft is higher  than initial home point's height.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_positionZ_inline",
                   "",
            ],
            [
                   "getPitch",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_pitch_inline",
                   "Simulated aircraft pitch with range [-30, 30] degrees.  @return A float value.",
            ],
            [
                   "Simulated aircraft pitch with range [-30, 30] degrees.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_pitch_inline",
                   "",
            ],
            [
                   "getRoll",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_roll_inline",
                   "Simulated aircraft roll with range [-30, 30] degrees.  @return A float value.",
            ],
            [
                   "Simulated aircraft roll with range [-30, 30] degrees.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_roll_inline",
                   "",
            ],
            [
                   "getYaw",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_yaw_inline",
                   "Simulated aircraft yaw with range [-180, 180] degrees.  @return A float value.",
            ],
            [
                   "Simulated aircraft yaw with range [-180, 180] degrees.  @return A float value.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorState.html",
                   "#DJISimulator_DJISimulatorState_yaw_inline",
                   "",
            ],
            [
                   "createInstance",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_createInstance_inline",
                   "Create the initialization data for the simulator.  @param location Simulator coordinate latitude and longitude in degrees. @param updateFrequency Aircraft simulator state push frequency in Hz with range [2, 150]. A setting of 10 Hz will result in delegate method being called, 10 times per second. @param satelliteCount The initial number of GPS satellites with range [0, 20].  @return Initialization data object.",
            ],
            [
                   "Create the initialization data for the simulator.  @param location Simulator coordinate latitude and longitude in degrees. @param updateFrequency Aircraft simulator state push frequency in Hz with range [2, 150]. A setting of 10 Hz will result in delegate method being called, 10 times per second. @param satelliteCount The initial number of GPS satellites with range [0, 20].  @return Initialization data object.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_createInstance_inline",
                   "",
            ],
            [
                   "getUpdateFrequency",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_simulationStateUpdateFrequency_inline",
                   "Aircraft simulator state push frequency in Hz with range [2, 150]. A setting of 10 Hz will result in  `onUpdate` being called 10 times per second.  @return Frequency.",
            ],
            [
                   "Aircraft simulator state push frequency in Hz with range [2, 150]. A setting of 10 Hz will result in  `onUpdate` being called 10 times per second.  @return Frequency.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_simulationStateUpdateFrequency_inline",
                   "",
            ],
            [
                   "getSatelliteCount",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_numOfSatellites_inline",
                   "The initial number of GNSS satellites with range [0, 20]  @return Number of satellites.",
            ],
            [
                   "The initial number of GNSS satellites with range [0, 20]  @return Number of satellites.",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_numOfSatellites_inline",
                   "",
            ],
            [
                   "getLocation",
                   2,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_location_inline",
                   "Location to begin simulation.  @return Location object",
            ],
            [
                   "Location to begin simulation.  @return Location object",
                   1,
                   "/Components/Simulator/DJISimulator_DJISimulatorInitializationData.html",
                   "#DJISimulator_DJISimulatorInitializationData_location_inline",
                   "",
            ],
            [
                   "getHeading",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_heading_inline",
                   "Represents the heading, in degrees. True North is 0 degrees, positive heading is East of North, and negative  heading is West of North. Heading bounds are [-180, 180].  @return A double value of the heading, in degrees.",
            ],
            [
                   "Represents the heading, in degrees. True North is 0 degrees, positive heading is East of North, and negative  heading is West of North. Heading bounds are [-180, 180].  @return A double value of the heading, in degrees.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_heading_inline",
                   "",
            ],
            [
                   "COMPASS_HEADING",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_heading_inline",
                   "SDK Key for getHeading: Represents the heading, in degrees. True North is 0 degrees, positive heading is East of North, and negative  heading is West of North. Heading bounds are [-180, 180].  @return A double value of the heading, in degrees.",
            ],
            [
                   "SDK Key for getHeading: Represents the heading, in degrees. True North is 0 degrees, positive heading is East of North, and negative  heading is West of North. Heading bounds are [-180, 180].  @return A double value of the heading, in degrees.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_heading_inline",
                   "",
            ],
            [
                   "hasError",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_hasError_inline",
                   "`true` if the compass has an error. If `true`, the compass  needs calibration.  @return A boolean value.",
            ],
            [
                   "`true` if the compass has an error. If `true`, the compass  needs calibration.  @return A boolean value.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_hasError_inline",
                   "",
            ],
            [
                   "COMPASS_HAS_ERROR",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_hasError_inline",
                   "SDK Key for hasError: `true` if the compass has an error. If `true`, the compass  needs calibration.  @return A boolean value.",
            ],
            [
                   "SDK Key for hasError: `true` if the compass has an error. If `true`, the compass  needs calibration.  @return A boolean value.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_hasError_inline",
                   "",
            ],
            [
                   "isCalibrating",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_isCalibrating_inline",
                   "`true` if the compass is currently calibrating.  @return A boolean value.",
            ],
            [
                   "`true` if the compass is currently calibrating.  @return A boolean value.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_isCalibrating_inline",
                   "",
            ],
            [
                   "COMPASS_IS_CALIBRATING",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_isCalibrating_inline",
                   "SDK Key for isCalibrating: `true` if the compass is currently calibrating.  @return A boolean value.",
            ],
            [
                   "SDK Key for isCalibrating: `true` if the compass is currently calibrating.  @return A boolean value.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_isCalibrating_inline",
                   "",
            ],
            [
                   "getCalibrationState",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatus_inline",
                   "Shows the calibration status.  @return An enum value of `CompassCalibrationState`.",
            ],
            [
                   "Shows the calibration status.  @return An enum value of `CompassCalibrationState`.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatus_inline",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatus_inline",
                   "SDK Key for getCalibrationState: Shows the calibration status.  @return An enum value of `CompassCalibrationState`.",
            ],
            [
                   "SDK Key for getCalibrationState: Shows the calibration status.  @return An enum value of `CompassCalibrationState`.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatus_inline",
                   "",
            ],
            [
                   "startCalibration",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_startCalibration_inline",
                   "Starts compass calibration. Make sure there are no magnets or metal objects near the compass.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is  recommended be done with it.",
            ],
            [
                   "Starts compass calibration. Make sure there are no magnets or metal objects near the compass.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is  recommended be done with it.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_startCalibration_inline",
                   "",
            ],
            [
                   "COMPASS_START_CALIBRATION",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_startCalibration_inline",
                   "SDK Key for startCalibration: Starts compass calibration. Make sure there are no magnets or metal objects near the compass.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is  recommended be done with it.",
            ],
            [
                   "SDK Key for startCalibration: Starts compass calibration. Make sure there are no magnets or metal objects near the compass.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is  recommended be done with it.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_startCalibration_inline",
                   "",
            ],
            [
                   "stopCalibration",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_stopCalibration_inline",
                   "Stops compass calibration.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is recommended  be done with it.",
            ],
            [
                   "Stops compass calibration.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is recommended  be done with it.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_stopCalibration_inline",
                   "",
            ],
            [
                   "COMPASS_STOP_CALIBRATION",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_stopCalibration_inline",
                   "SDK Key for stopCalibration: Stops compass calibration.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is recommended  be done with it.",
            ],
            [
                   "SDK Key for stopCalibration: Stops compass calibration.  @param callback Completion callback. See DJIBaseComponent for more information about the callback and what is recommended  be done with it.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_stopCalibration_inline",
                   "",
            ],
            [
                   "setCalibrationStateCallback",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatusCallback_inline",
                   "Sets the callback for compass calibration.  @param callback The callback with compass calibration state",
            ],
            [
                   "Sets the callback for compass calibration.  @param callback The callback with compass calibration state",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatusCallback_inline",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatusCallback_inline",
                   "SDK Key for setCalibrationStateCallback: Sets the callback for compass calibration.  @param callback The callback with compass calibration state",
            ],
            [
                   "SDK Key for setCalibrationStateCallback: Sets the callback for compass calibration.  @param callback The callback with compass calibration state",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_calibrationStatusCallback_inline",
                   "",
            ],
            [
                   "CompassCalibrationState",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_inline",
                   "An enum class representing compass calibration.",
            ],
            [
                   "An enum class representing compass calibration.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_inline",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_inline",
                   "SDK Key for CompassCalibrationState: An enum class representing compass calibration.",
            ],
            [
                   "SDK Key for CompassCalibrationState: An enum class representing compass calibration.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_inline",
                   "",
            ],
            [
                   "NOT_CALIBRATING",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Normal_inline",
                   "Normal state. Compass not in calibration.",
            ],
            [
                   "Normal state. Compass not in calibration.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Normal_inline",
                   "",
            ],
            [
                   "HORIZONTAL",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Horizontal_inline",
                   "Compass horizontal calibration. The user should hold the aircraft horizontally and rotate it 360 degrees.",
            ],
            [
                   "Compass horizontal calibration. The user should hold the aircraft horizontally and rotate it 360 degrees.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Horizontal_inline",
                   "",
            ],
            [
                   "VERTICAL",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Vertical_inline",
                   "Compass vertical calibration. The user should hold the aircraft vertically, with the nose pointed towards the  ground, and rotate the aircraft 360 degrees.",
            ],
            [
                   "Compass vertical calibration. The user should hold the aircraft vertically, with the nose pointed towards the  ground, and rotate the aircraft 360 degrees.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Vertical_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Succeeded_inline",
                   "Compass calibration succeeded.",
            ],
            [
                   "Compass calibration succeeded.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Succeeded_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Failed_inline",
                   "Compass calibration failed. Make sure there are no magnets or metal objects near the compass and retry.",
            ],
            [
                   "Compass calibration failed. Make sure there are no magnets or metal objects near the compass and retry.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Failed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Unknown_inline",
                   "Compass calibration status unknown.",
            ],
            [
                   "Compass calibration status unknown.",
                   1,
                   "/Components/Compass/DJICompass.html",
                   "#DJICompass_DJICompassCalibrationStatus_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "",
                   "Updates compass calibration state",
            ],
            [
                   "Updates compass calibration state",
                   1,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "",
                   "SDK Key for Callback: Updates compass calibration state",
            ],
            [
                   "SDK Key for Callback: Updates compass calibration state",
                   1,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "#DJICompass_UpdateCompassCalibrationState_inline",
                   "Called when calibration state is updated.  @param state The updated calibration state",
            ],
            [
                   "Called when calibration state is updated.  @param state The updated calibration state",
                   1,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "#DJICompass_UpdateCompassCalibrationState_inline",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "#DJICompass_UpdateCompassCalibrationState_inline",
                   "SDK Key for onUpdate: Called when calibration state is updated.  @param state The updated calibration state",
            ],
            [
                   "SDK Key for onUpdate: Called when calibration state is updated.  @param state The updated calibration state",
                   1,
                   "/Components/Compass/DJICompass_CompassCalibrationStateCallback.html",
                   "#DJICompass_UpdateCompassCalibrationState_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlightController/DJIFlightController_UpdateSystemStateCallbackInterface.html",
                   "",
                   "Callback function that updates the flight controller's current state data. This method gets called 10 times per second.",
            ],
            [
                   "Callback function that updates the flight controller's current state data. This method gets called 10 times per second.",
                   1,
                   "/Components/FlightController/DJIFlightController_UpdateSystemStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "areMotorsOn",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_areMotorsOn_inline",
                   "`true` if motors are on.  @return A boolean value.",
            ],
            [
                   "`true` if motors are on.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_areMotorsOn_inline",
                   "",
            ],
            [
                   "ARE_MOTOR_ON",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_areMotorsOn_inline",
                   "SDK Key for areMotorsOn: `true` if motors are on.  @return A boolean value.",
            ],
            [
                   "SDK Key for areMotorsOn: `true` if motors are on.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_areMotorsOn_inline",
                   "",
            ],
            [
                   "isFlying",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFlying_inline",
                   "`true` if aircraft is flying.  @return A boolean value.",
            ],
            [
                   "`true` if aircraft is flying.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFlying_inline",
                   "",
            ],
            [
                   "IS_FLYING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFlying_inline",
                   "SDK Key for isFlying: `true` if aircraft is flying.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFlying: `true` if aircraft is flying.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFlying_inline",
                   "",
            ],
            [
                   "getAircraftLocation",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
            ],
            [
                   "Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "",
            ],
            [
                   "AIRCRAFT_LOCATION_LATITUDE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
            ],
            [
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "",
            ],
            [
                   "AIRCRAFT_LOCATION_LONGITUDE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
            ],
            [
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "",
            ],
            [
                   "ALTITUDE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
            ],
            [
                   "SDK Key for getAircraftLocation: Gets the current location of the aircraft as a coordinate. `nil` if the location is invalid.  @return The current location of the aircraft as a coordinate.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_aircraftLocation_inline",
                   "",
            ],
            [
                   "getTakeoffLocationAltitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_takeoffLocationAltitude_inline",
                   "Relative altitude of the aircraft home location relative to sea level, in meters.  @return A float value of the altitude.",
            ],
            [
                   "Relative altitude of the aircraft home location relative to sea level, in meters.  @return A float value of the altitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_takeoffLocationAltitude_inline",
                   "",
            ],
            [
                   "getAttitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
            ],
            [
                   "Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "",
            ],
            [
                   "ATTITUDE_PITCH",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
            ],
            [
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "",
            ],
            [
                   "ATTITUDE_ROLL",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
            ],
            [
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "",
            ],
            [
                   "ATTITUDE_YAW",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
            ],
            [
                   "SDK Key for getAttitude: Gets the attitude of the aircraft, where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.  @return The attitude of the aircraft.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_attitude_inline",
                   "",
            ],
            [
                   "getVelocityX",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityX_inline",
                   "Current speed of the aircraft in the x direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the x direction.",
            ],
            [
                   "Current speed of the aircraft in the x direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the x direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityX_inline",
                   "",
            ],
            [
                   "VELOCITY_X",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityX_inline",
                   "SDK Key for getVelocityX: Current speed of the aircraft in the x direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the x direction.",
            ],
            [
                   "SDK Key for getVelocityX: Current speed of the aircraft in the x direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the x direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityX_inline",
                   "",
            ],
            [
                   "getVelocityY",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityY_inline",
                   "Current speed of the aircraft in the y direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the y direction.",
            ],
            [
                   "Current speed of the aircraft in the y direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the y direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityY_inline",
                   "",
            ],
            [
                   "VELOCITY_Y",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityY_inline",
                   "SDK Key for getVelocityY: Current speed of the aircraft in the y direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the y direction.",
            ],
            [
                   "SDK Key for getVelocityY: Current speed of the aircraft in the y direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the y direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityY_inline",
                   "",
            ],
            [
                   "getVelocityZ",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityZ_inline",
                   "Current speed of the aircraft in the z direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the z direction.",
            ],
            [
                   "Current speed of the aircraft in the z direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the z direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityZ_inline",
                   "",
            ],
            [
                   "VELOCITY_Z",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityZ_inline",
                   "SDK Key for getVelocityZ: Current speed of the aircraft in the z direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the z direction.",
            ],
            [
                   "SDK Key for getVelocityZ: Current speed of the aircraft in the z direction, in meters per second, using the N-E-D (North-East-Down) coordinate system.  @return A float value of the current speed of the aircraft in the z direction.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_velocityZ_inline",
                   "",
            ],
            [
                   "getFlightTimeInSeconds",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightTime_inline",
                   "The accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return An int value of the flight time.",
            ],
            [
                   "The accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return An int value of the flight time.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightTime_inline",
                   "",
            ],
            [
                   "FLY_TIME_IN_SECONDS",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightTime_inline",
                   "SDK Key for getFlightTimeInSeconds: The accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return An int value of the flight time.",
            ],
            [
                   "SDK Key for getFlightTimeInSeconds: The accumulated flight time, in seconds, since the aircraft's motors were turned on.  @return An int value of the flight time.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightTime_inline",
                   "",
            ],
            [
                   "isLandingConfirmationNeeded",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLandingConfirmationNeeded_inline",
                   "`true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. When the confirmation is needed, `confirmLanding` in `FlightController` can be used to continue landing. It is  supported by flight controller firmware 3.2.0.0 or above.  @return Whether confirmation is needed or not.",
            ],
            [
                   "`true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. When the confirmation is needed, `confirmLanding` in `FlightController` can be used to continue landing. It is  supported by flight controller firmware 3.2.0.0 or above.  @return Whether confirmation is needed or not.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLandingConfirmationNeeded_inline",
                   "",
            ],
            [
                   "IS_LANDING_CONFIRMATION_NEEDED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLandingConfirmationNeeded_inline",
                   "SDK Key for isLandingConfirmationNeeded: `true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. When the confirmation is needed, `confirmLanding` in `FlightController` can be used to continue landing. It is  supported by flight controller firmware 3.2.0.0 or above.  @return Whether confirmation is needed or not.",
            ],
            [
                   "SDK Key for isLandingConfirmationNeeded: `true` if the clearance between the aircraft and the ground is less than 0.3m, and confirmation from the user is needed to continue the landing. When the confirmation is needed, `confirmLanding` in `FlightController` can be used to continue landing. It is  supported by flight controller firmware 3.2.0.0 or above.  @return Whether confirmation is needed or not.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLandingConfirmationNeeded_inline",
                   "",
            ],
            [
                   "getFlightMode",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightMode_inline",
                   "Flight controller flight mode. For more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the Flight Mode part.  @return An enum value of the `FlightMode`.",
            ],
            [
                   "Flight controller flight mode. For more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the Flight Mode part.  @return An enum value of the `FlightMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightMode_inline",
                   "",
            ],
            [
                   "FLIGHT_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightMode_inline",
                   "SDK Key for getFlightMode: Flight controller flight mode. For more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the Flight Mode part.  @return An enum value of the `FlightMode`.",
            ],
            [
                   "SDK Key for getFlightMode: Flight controller flight mode. For more info, see https://developer.dji.com/document/a3bd20d1-9f1c-4f76-a9aa-46eb0d23cd82, the Flight Mode part.  @return An enum value of the `FlightMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightMode_inline",
                   "",
            ],
            [
                   "isMultipleModeOpen",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isMultipleModeOpen_inline",
                   "Determines whether multiple flight modes are open. This will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
            ],
            [
                   "Determines whether multiple flight modes are open. This will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isMultipleModeOpen_inline",
                   "",
            ],
            [
                   "MULTI_MODE_OPEN",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isMultipleModeOpen_inline",
                   "SDK Key for isMultipleModeOpen: Determines whether multiple flight modes are open. This will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
            ],
            [
                   "SDK Key for isMultipleModeOpen: Determines whether multiple flight modes are open. This will reflect whether navigation mode (ground station) is enabled.  @return `true` if the navigation mode is enabled.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isMultipleModeOpen_inline",
                   "",
            ],
            [
                   "getSatelliteCount",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_satelliteCount_inline",
                   "Returns the GPS satellite count.  @return The double value of the GPS satellite count.",
            ],
            [
                   "Returns the GPS satellite count.  @return The double value of the GPS satellite count.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_satelliteCount_inline",
                   "",
            ],
            [
                   "SATELLITE_COUNT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_satelliteCount_inline",
                   "SDK Key for getSatelliteCount: Returns the GPS satellite count.  @return The double value of the GPS satellite count.",
            ],
            [
                   "SDK Key for getSatelliteCount: Returns the GPS satellite count.  @return The double value of the GPS satellite count.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_satelliteCount_inline",
                   "",
            ],
            [
                   "getGPSSignalLevel",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_gpsSignalStatus_inline",
                   "Gets the aircraft's current GPS signal quality. If the return value is in [6,10], which means the RTK signal is strong.  @return The aircraft's current GPS signal quality.",
            ],
            [
                   "Gets the aircraft's current GPS signal quality. If the return value is in [6,10], which means the RTK signal is strong.  @return The aircraft's current GPS signal quality.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_gpsSignalStatus_inline",
                   "",
            ],
            [
                   "GPS_SIGNAL_LEVEL",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_gpsSignalStatus_inline",
                   "SDK Key for getGPSSignalLevel: Gets the aircraft's current GPS signal quality. If the return value is in [6,10], which means the RTK signal is strong.  @return The aircraft's current GPS signal quality.",
            ],
            [
                   "SDK Key for getGPSSignalLevel: Gets the aircraft's current GPS signal quality. If the return value is in [6,10], which means the RTK signal is strong.  @return The aircraft's current GPS signal quality.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_gpsSignalStatus_inline",
                   "",
            ],
            [
                   "isIMUPreheating",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isIMUPreheating_inline",
                   "`true` if IMU is preheating.  @return A boolean value.",
            ],
            [
                   "`true` if IMU is preheating.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isIMUPreheating_inline",
                   "",
            ],
            [
                   "IS_IMU_PREHEATING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isIMUPreheating_inline",
                   "SDK Key for isIMUPreheating: `true` if IMU is preheating.  @return A boolean value.",
            ],
            [
                   "SDK Key for isIMUPreheating: `true` if IMU is preheating.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isIMUPreheating_inline",
                   "",
            ],
            [
                   "isUltrasonicBeingUsed",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicBeingUsed_inline",
                   "`true` if the ultrasonic sensor is being used. Variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). Usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return A boolean value.",
            ],
            [
                   "`true` if the ultrasonic sensor is being used. Variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). Usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicBeingUsed_inline",
                   "",
            ],
            [
                   "IS_ULTRASONIC_BEING_USED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicBeingUsed_inline",
                   "SDK Key for isUltrasonicBeingUsed: `true` if the ultrasonic sensor is being used. Variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). Usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return A boolean value.",
            ],
            [
                   "SDK Key for isUltrasonicBeingUsed: `true` if the ultrasonic sensor is being used. Variables that can impact the quality of the ultrasound measurement, or whether it's being used, are height above ground and the type of ground (if it reflects sound waves well). Usually, the ultrasonic sensor works when the aircraft is less than 8m above ground.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicBeingUsed_inline",
                   "",
            ],
            [
                   "getUltrasonicHeightInMeters",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_ultrasonicHeight_inline",
                   "Height of aircraft measured by the ultrasonic sensor in meters. The data will only be available if `isUltrasonicBeingUsed` returns `true`. Height has a precision of 0.1m. This value has reference significance when the height is below 5 meters.  @return A float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
            ],
            [
                   "Height of aircraft measured by the ultrasonic sensor in meters. The data will only be available if `isUltrasonicBeingUsed` returns `true`. Height has a precision of 0.1m. This value has reference significance when the height is below 5 meters.  @return A float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_ultrasonicHeight_inline",
                   "",
            ],
            [
                   "ULTRASONIC_HEIGHT_IN_METERS",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_ultrasonicHeight_inline",
                   "SDK Key for getUltrasonicHeightInMeters: Height of aircraft measured by the ultrasonic sensor in meters. The data will only be available if `isUltrasonicBeingUsed` returns `true`. Height has a precision of 0.1m. This value has reference significance when the height is below 5 meters.  @return A float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
            ],
            [
                   "SDK Key for getUltrasonicHeightInMeters: Height of aircraft measured by the ultrasonic sensor in meters. The data will only be available if `isUltrasonicBeingUsed` returns `true`. Height has a precision of 0.1m. This value has reference significance when the height is below 5 meters.  @return A float value of the height of the aircraft measured by the ultrasonic sensor in meters.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_ultrasonicHeight_inline",
                   "",
            ],
            [
                   "doesUltrasonicHaveError",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicError_inline",
                   "`true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
            ],
            [
                   "`true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicError_inline",
                   "",
            ],
            [
                   "ULTRASONIC_ERROR",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicError_inline",
                   "SDK Key for doesUltrasonicHaveError: `true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
            ],
            [
                   "SDK Key for doesUltrasonicHaveError: `true` if ultrasonic sensor has error.  @return `true` if ultrasonic sensor has error.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isUltrasonicError_inline",
                   "",
            ],
            [
                   "isVisionPositioningSensorBeingUsed",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isVisionSensorBeingUsed_inline",
                   "`true` if a vision sensor is being used. Variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). Usually, the vision sensor works when the aircraft is less than 3m above ground.  @return A boolean value.",
            ],
            [
                   "`true` if a vision sensor is being used. Variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). Usually, the vision sensor works when the aircraft is less than 3m above ground.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isVisionSensorBeingUsed_inline",
                   "",
            ],
            [
                   "IS_VISION_POSITIONING_SENSOR_BEING_USED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isVisionSensorBeingUsed_inline",
                   "SDK Key for isVisionPositioningSensorBeingUsed: `true` if a vision sensor is being used. Variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). Usually, the vision sensor works when the aircraft is less than 3m above ground.  @return A boolean value.",
            ],
            [
                   "SDK Key for isVisionPositioningSensorBeingUsed: `true` if a vision sensor is being used. Variables that can impact the quality of the vision measurement, or whether it's being used, are height above ground and the type of ground (if it has sufficiently rich texture). Usually, the vision sensor works when the aircraft is less than 3m above ground.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isVisionSensorBeingUsed_inline",
                   "",
            ],
            [
                   "getOrientationMode",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_orientationMode_inline",
                   "The aircraft's current orientation mode.  @return An enum value of `FlightOrientationMode`.",
            ],
            [
                   "The aircraft's current orientation mode.  @return An enum value of `FlightOrientationMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_orientationMode_inline",
                   "",
            ],
            [
                   "ORIENTATION_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_orientationMode_inline",
                   "SDK Key for getOrientationMode: The aircraft's current orientation mode.  @return An enum value of `FlightOrientationMode`.",
            ],
            [
                   "SDK Key for getOrientationMode: The aircraft's current orientation mode.  @return An enum value of `FlightOrientationMode`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_orientationMode_inline",
                   "",
            ],
            [
                   "isFailsafeEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFailsafe_inline",
                   "`true` if the signal is lost between remote controller and aircraft, and FailSafe is enabled.  @return A boolean value.",
            ],
            [
                   "`true` if the signal is lost between remote controller and aircraft, and FailSafe is enabled.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFailsafe_inline",
                   "",
            ],
            [
                   "IS_FAIL_SAFE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFailsafe_inline",
                   "SDK Key for isFailsafeEnabled: `true` if the signal is lost between remote controller and aircraft, and FailSafe is enabled.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFailsafeEnabled: `true` if the signal is lost between remote controller and aircraft, and FailSafe is enabled.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isFailsafe_inline",
                   "",
            ],
            [
                   "getBatteryThresholdBehavior",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_remainingBattery_inline",
                   "Recommended action based on remaining battery life. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `BatteryThresholdBehavior`.",
            ],
            [
                   "Recommended action based on remaining battery life. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `BatteryThresholdBehavior`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_remainingBattery_inline",
                   "",
            ],
            [
                   "BATTERY_THRESHOLD_BEHAVIOR",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_remainingBattery_inline",
                   "SDK Key for getBatteryThresholdBehavior: Recommended action based on remaining battery life. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `BatteryThresholdBehavior`.",
            ],
            [
                   "SDK Key for getBatteryThresholdBehavior: Recommended action based on remaining battery life. Not supported by Mavic Air 2, DJI Air 2S.  @return An enum value of `BatteryThresholdBehavior`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_remainingBattery_inline",
                   "",
            ],
            [
                   "isLowerThanBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLowerThanBatteryWarningThreshold_inline",
                   "`true` if the battery is lower than the low battery warning threshold.  @return A boolean value.",
            ],
            [
                   "`true` if the battery is lower than the low battery warning threshold.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLowerThanBatteryWarningThreshold_inline",
                   "",
            ],
            [
                   "isLowerThanSeriousBatteryWarningThreshold",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLowerThanSeriousBatteryWarningThreshold_inline",
                   "`true` if the battery is lower than the serious low battery warning threshold.  @return A boolean value.",
            ],
            [
                   "`true` if the battery is lower than the serious low battery warning threshold.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isLowerThanSeriousBatteryWarningThreshold_inline",
                   "",
            ],
            [
                   "getFlightWindWarning",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_windWarning_inline",
                   "Warning related to high winds.  @return An enum value of `FlightWindWarning`.",
            ],
            [
                   "Warning related to high winds.  @return An enum value of `FlightWindWarning`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_windWarning_inline",
                   "",
            ],
            [
                   "getFlightCount",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_countOfFlights_inline",
                   "The count of flights within the battery life cycle. Cleared when power-on.  @return An int value of flight count.",
            ],
            [
                   "The count of flights within the battery life cycle. Cleared when power-on.  @return An int value of flight count.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_countOfFlights_inline",
                   "",
            ],
            [
                   "getFlightLogIndex",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightLogIndex_inline",
                   "The current index of the flight log on the aircraft. It is useful to find the corresponding flight log.  @return An int value of the flight log index.",
            ],
            [
                   "The current index of the flight log on the aircraft. It is useful to find the corresponding flight log.  @return An int value of the flight log index.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_flightLogIndex_inline",
                   "",
            ],
            [
                   "isActiveBrakeEngaged",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isActiveBrakeEngaged_inline",
                   "`true` when Active Brake is enaged to avoid obstacles. It is supported only by Matrice 300 RTK.  @return `true` if Active Brake is engaged.",
            ],
            [
                   "`true` when Active Brake is enaged to avoid obstacles. It is supported only by Matrice 300 RTK.  @return `true` if Active Brake is engaged.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isActiveBrakeEngaged_inline",
                   "",
            ],
            [
                   "isHomeLocationSet",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isHomePointSet_inline",
                   "`true` if the home point has been set.  @return A boolean value.",
            ],
            [
                   "`true` if the home point has been set.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isHomePointSet_inline",
                   "",
            ],
            [
                   "IS_HOME_LOCATION_SET",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isHomePointSet_inline",
                   "SDK Key for isHomeLocationSet: `true` if the home point has been set.  @return A boolean value.",
            ],
            [
                   "SDK Key for isHomeLocationSet: `true` if the home point has been set.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isHomePointSet_inline",
                   "",
            ],
            [
                   "getHomeLocation",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION_LATITUDE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "",
            ],
            [
                   "HOME_LOCATION_LONGITUDE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
            ],
            [
                   "SDK Key for getHomeLocation: Returns the home location of the aircraft as a coordinate.  @return An instance of `LocationCoordinate2D`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_homeLocation_inline",
                   "",
            ],
            [
                   "getGoHomeAssessment",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_smartGoHomeStatus_inline",
                   "Gets the aircraft's smart go home data. If smart go home is enabled, all the smart go home data will be available in `GoHomeAssessment`.  @return An instance of `GoHomeAssessment`.",
            ],
            [
                   "Gets the aircraft's smart go home data. If smart go home is enabled, all the smart go home data will be available in `GoHomeAssessment`.  @return An instance of `GoHomeAssessment`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_smartGoHomeStatus_inline",
                   "",
            ],
            [
                   "getGoHomeExecutionState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_goHomeExecutionStatus_inline",
                   "The current status of go-home execution.  @return An enum value of `GoHomeExecutionState`.",
            ],
            [
                   "The current status of go-home execution.  @return An enum value of `GoHomeExecutionState`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_goHomeExecutionStatus_inline",
                   "",
            ],
            [
                   "GO_HOME_STATUS",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_goHomeExecutionStatus_inline",
                   "SDK Key for getGoHomeExecutionState: The current status of go-home execution.  @return An enum value of `GoHomeExecutionState`.",
            ],
            [
                   "SDK Key for getGoHomeExecutionState: The current status of go-home execution.  @return An enum value of `GoHomeExecutionState`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_goHomeExecutionStatus_inline",
                   "",
            ],
            [
                   "isGoingHome",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isGoingHome_inline",
                   "`true` if the aircraft is going home.  @return A boolean value.",
            ],
            [
                   "`true` if the aircraft is going home.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isGoingHome_inline",
                   "",
            ],
            [
                   "IS_GOING_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isGoingHome_inline",
                   "SDK Key for isGoingHome: `true` if the aircraft is going home.  @return A boolean value.",
            ],
            [
                   "SDK Key for isGoingHome: `true` if the aircraft is going home.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_isGoingHome_inline",
                   "",
            ],
            [
                   "getGoHomeHeight",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_getGoHomeHeight_inline",
                   "Gets the height when the aircraft is going home in meters.  @return An int value of the height when the aircraft is going home.",
            ],
            [
                   "Gets the height when the aircraft is going home in meters.  @return An int value of the height when the aircraft is going home.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_getGoHomeHeight_inline",
                   "",
            ],
            [
                   "GO_HOME_HEIGHT_IN_METERS",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_getGoHomeHeight_inline",
                   "SDK Key for getGoHomeHeight: Gets the height when the aircraft is going home in meters.  @return An int value of the height when the aircraft is going home.",
            ],
            [
                   "SDK Key for getGoHomeHeight: Gets the height when the aircraft is going home in meters.  @return An int value of the height when the aircraft is going home.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_getGoHomeHeight_inline",
                   "",
            ],
            [
                   "Attitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "",
                   "The attitude of the aircraft where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.",
            ],
            [
                   "The attitude of the aircraft where the pitch, roll, and yaw values will be in the range of [-180, 180] degrees. If its pitch, roll, and yaw values are 0, the aircraft will be hovering level with a True North heading.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "",
                   "",
            ],
            [
                   "pitch",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_pitch_inline",
                   "The pitch value of the aircraft: forward is positive, backward is negative. Units are in degrees.",
            ],
            [
                   "The pitch value of the aircraft: forward is positive, backward is negative. Units are in degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_pitch_inline",
                   "",
            ],
            [
                   "roll",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_roll_inline",
                   "The roll value of the aircraft: forward is positive, backward is negative. Units are in degrees.",
            ],
            [
                   "The roll value of the aircraft: forward is positive, backward is negative. Units are in degrees.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_roll_inline",
                   "",
            ],
            [
                   "yaw",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_yaw_inline",
                   "The yaw value of the aircraft, where 0 corresponds to a True North heading. Yawing clockwise will increase yaw value.",
            ],
            [
                   "The yaw value of the aircraft, where 0 corresponds to a True North heading. Yawing clockwise will increase yaw value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIAttitude.html",
                   "#DJIFlightController_DJIAttitude_yaw_inline",
                   "",
            ],
            [
                   "BatteryThresholdBehavior",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_inline",
                   "Remaining battery life state. This state describes the recommended action based on remaining battery life.",
            ],
            [
                   "Remaining battery life state. This state describes the recommended action based on remaining battery life.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_inline",
                   "",
            ],
            [
                   "BATTERY_THRESHOLD_BEHAVIOR",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_inline",
                   "SDK Key for BatteryThresholdBehavior: Remaining battery life state. This state describes the recommended action based on remaining battery life.",
            ],
            [
                   "SDK Key for BatteryThresholdBehavior: Remaining battery life state. This state describes the recommended action based on remaining battery life.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_inline",
                   "",
            ],
            [
                   "FLY_NORMALLY",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_normal_inline",
                   "Remaining battery life sufficient for normal flying.",
            ],
            [
                   "Remaining battery life sufficient for normal flying.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_normal_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_low_inline",
                   "Remaining battery life sufficient to go home.",
            ],
            [
                   "Remaining battery life sufficient to go home.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_low_inline",
                   "",
            ],
            [
                   "LAND_IMMEDIATELY",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_veryLow_inline",
                   "Remaining battery life sufficient to land immediately.",
            ],
            [
                   "Remaining battery life sufficient to land immediately.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_veryLow_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIAircraftRemainingBatteryState_unknown_inline",
                   "",
            ],
            [
                   "GoHomeExecutionState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_inline",
                   "An enum used to identify the different stages of the go-home command. Some aircraft only support part of the state depending on the firmware.  For exampele:  Phantom 4 Pro V2.0 and Mavic 2 Enterprise Dual only support `GO_DOWN_TO_GROUND`.  Matrice 300 RTK only suppoort `GO_UP_TO_HEIGHT`, `AUTO_FLY_TO_HOME_POINT` and `GO_DOWN_TO_GROUND`.",
            ],
            [
                   "An enum used to identify the different stages of the go-home command. Some aircraft only support part of the state depending on the firmware.  For exampele:  Phantom 4 Pro V2.0 and Mavic 2 Enterprise Dual only support `GO_DOWN_TO_GROUND`.  Matrice 300 RTK only suppoort `GO_UP_TO_HEIGHT`, `AUTO_FLY_TO_HOME_POINT` and `GO_DOWN_TO_GROUND`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_inline",
                   "",
            ],
            [
                   "GO_HOME_STATUS",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_inline",
                   "SDK Key for GoHomeExecutionState: An enum used to identify the different stages of the go-home command. Some aircraft only support part of the state depending on the firmware.  For exampele:  Phantom 4 Pro V2.0 and Mavic 2 Enterprise Dual only support `GO_DOWN_TO_GROUND`.  Matrice 300 RTK only suppoort `GO_UP_TO_HEIGHT`, `AUTO_FLY_TO_HOME_POINT` and `GO_DOWN_TO_GROUND`.",
            ],
            [
                   "SDK Key for GoHomeExecutionState: An enum used to identify the different stages of the go-home command. Some aircraft only support part of the state depending on the firmware.  For exampele:  Phantom 4 Pro V2.0 and Mavic 2 Enterprise Dual only support `GO_DOWN_TO_GROUND`.  Matrice 300 RTK only suppoort `GO_UP_TO_HEIGHT`, `AUTO_FLY_TO_HOME_POINT` and `GO_DOWN_TO_GROUND`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_inline",
                   "",
            ],
            [
                   "NOT_EXECUTING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_notExecuting_inline",
                   "The aircraft is not executing a Go-Home command.",
            ],
            [
                   "The aircraft is not executing a Go-Home command.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_notExecuting_inline",
                   "",
            ],
            [
                   "TURN_DIRECTION_TO_HOME_POINT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_turnDirectionToHomePoint_inline",
                   "The aircraft is turning the heading direction to the home point.",
            ],
            [
                   "The aircraft is turning the heading direction to the home point.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_turnDirectionToHomePoint_inline",
                   "",
            ],
            [
                   "GO_UP_TO_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_goUpToHeight_inline",
                   "The aircraft is going up to the height for go-home command.",
            ],
            [
                   "The aircraft is going up to the height for go-home command.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_goUpToHeight_inline",
                   "",
            ],
            [
                   "AUTO_FLY_TO_HOME_POINT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_autoFlyToHomePoint_inline",
                   "The aircraft is flying horizontally to home point.",
            ],
            [
                   "The aircraft is flying horizontally to home point.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_autoFlyToHomePoint_inline",
                   "",
            ],
            [
                   "GO_DOWN_TO_GROUND",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_goDownToGround_inline",
                   "The aircraft is going down after arriving at the home point.",
            ],
            [
                   "The aircraft is going down after arriving at the home point.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_goDownToGround_inline",
                   "",
            ],
            [
                   "BRAKING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_braking_inline",
                   "The aircraft is braking to avoid collision.",
            ],
            [
                   "The aircraft is braking to avoid collision.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_braking_inline",
                   "",
            ],
            [
                   "BYPASSING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_bypassing_inline",
                   "The aircraft is bypassing over the obstacle.",
            ],
            [
                   "The aircraft is bypassing over the obstacle.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_bypassing_inline",
                   "",
            ],
            [
                   "COMPLETED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_completed_inline",
                   "The go-home command is completed.",
            ],
            [
                   "The go-home command is completed.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_completed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_unknown_inline",
                   "The go-home status is unknown.",
            ],
            [
                   "The go-home status is unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerGoHomeExecutionStatus_unknown_inline",
                   "",
            ],
            [
                   "LocationCoordinate3D",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "",
                   "This is a structure for presenting the location, latitude, longitude, altitude.",
            ],
            [
                   "This is a structure for presenting the location, latitude, longitude, altitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "",
                   "",
            ],
            [
                   "LocationCoordinate3D",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_Constructor_inline",
                   "Constructs the 3D coordinate with latitude, longitude and altitude.  @param latitude Latitude in degrees @param longitude Longitude in degrees @param altitude Altitude in meters",
            ],
            [
                   "Constructs the 3D coordinate with latitude, longitude and altitude.  @param latitude Latitude in degrees @param longitude Longitude in degrees @param altitude Altitude in meters",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_Constructor_inline",
                   "",
            ],
            [
                   "getLatitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getLatitude_inline",
                   "Returns the latitude.  @return A double value of the latitude.",
            ],
            [
                   "Returns the latitude.  @return A double value of the latitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getLatitude_inline",
                   "",
            ],
            [
                   "getLongitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getLongitude_inline",
                   "Returns the longitude.  @return A double value of the longitude.",
            ],
            [
                   "Returns the longitude.  @return A double value of the longitude.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getLongitude_inline",
                   "",
            ],
            [
                   "getAltitude",
                   2,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getAltitude_inline",
                   "Returns the relative altitude of the aircraft relative to take off location, measured by barometer, in meters.  @return A float value of the relative altitude of the aircraft relative to take off location.",
            ],
            [
                   "Returns the relative altitude of the aircraft relative to take off location, measured by barometer, in meters.  @return A float value of the relative altitude of the aircraft relative to take off location.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJILocationCoordinate3D.html",
                   "#DJIFlightController_DJILocationCoordinate3D_getAltitude_inline",
                   "",
            ],
            [
                   "GoHomeAssessment",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "",
                   "Class for smart go home status.",
            ],
            [
                   "Class for smart go home status.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "",
                   "",
            ],
            [
                   "getRemainingFlightTime",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_remainingFlightTime_inline",
                   "The estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. This time includes landing the aircraft. If the aircraft is using the simulator, this value will be 0.  @return An int value.",
            ],
            [
                   "The estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. This time includes landing the aircraft. If the aircraft is using the simulator, this value will be 0.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_remainingFlightTime_inline",
                   "",
            ],
            [
                   "REMAINING_FLIGHT_TIME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_remainingFlightTime_inline",
                   "SDK Key for getRemainingFlightTime: The estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. This time includes landing the aircraft. If the aircraft is using the simulator, this value will be 0.  @return An int value.",
            ],
            [
                   "SDK Key for getRemainingFlightTime: The estimated remaining time, in seconds, it will take the aircraft to go home with a 10% battery buffer remaining. This time includes landing the aircraft. If the aircraft is using the simulator, this value will be 0.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_remainingFlightTime_inline",
                   "",
            ],
            [
                   "getTimeNeededToGoHome",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToGoHome_inline",
                   "The estimated time, in seconds, needed for the aircraft to go home from its current location.  @return An int value.",
            ],
            [
                   "The estimated time, in seconds, needed for the aircraft to go home from its current location.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToGoHome_inline",
                   "",
            ],
            [
                   "TIME_NEEDED_TO_GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToGoHome_inline",
                   "SDK Key for getTimeNeededToGoHome: The estimated time, in seconds, needed for the aircraft to go home from its current location.  @return An int value.",
            ],
            [
                   "SDK Key for getTimeNeededToGoHome: The estimated time, in seconds, needed for the aircraft to go home from its current location.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToGoHome_inline",
                   "",
            ],
            [
                   "getTimeNeededToLandFromCurrentHeight",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToLandFromCurrentHeight_inline",
                   "The estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return An int value.",
            ],
            [
                   "The estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToLandFromCurrentHeight_inline",
                   "",
            ],
            [
                   "TIME_NEEDED_TO_LAND_FROM_CURRENT_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToLandFromCurrentHeight_inline",
                   "SDK Key for getTimeNeededToLandFromCurrentHeight: The estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return An int value.",
            ],
            [
                   "SDK Key for getTimeNeededToLandFromCurrentHeight: The estimated time, in seconds, needed for the aircraft to move downward from its current position and land.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_timeNeededToLandFromCurrentHeight_inline",
                   "",
            ],
            [
                   "getBatteryPercentageNeededToGoHome",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToGoHome_inline",
                   "The estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. This includes landing of the aircraft.  @return An int value.",
            ],
            [
                   "The estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. This includes landing of the aircraft.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToGoHome_inline",
                   "",
            ],
            [
                   "BATTERY_PERCENTAGE_NEEDED_TO_GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToGoHome_inline",
                   "SDK Key for getBatteryPercentageNeededToGoHome: The estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. This includes landing of the aircraft.  @return An int value.",
            ],
            [
                   "SDK Key for getBatteryPercentageNeededToGoHome: The estimated battery percentage, in the range of [0,100], needed for the aircraft to go home and have 10% battery remaining. This includes landing of the aircraft.  @return An int value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToGoHome_inline",
                   "",
            ],
            [
                   "getBatteryPercentageNeededToLandFromCurrentHeight",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToLandFromCurrentHeight_inline",
                   "The battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return Battery percentage.",
            ],
            [
                   "The battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return Battery percentage.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToLandFromCurrentHeight_inline",
                   "",
            ],
            [
                   "CURRENT_LAND_IMMEDIATELY_BATTERY",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToLandFromCurrentHeight_inline",
                   "SDK Key for getBatteryPercentageNeededToLandFromCurrentHeight: The battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return Battery percentage.",
            ],
            [
                   "SDK Key for getBatteryPercentageNeededToLandFromCurrentHeight: The battery percentage, in the range of [0,100], needed for the aircraft to move downward from its current position and land.  @return Battery percentage.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_batteryPercentageNeededToLandFromCurrentHeight_inline",
                   "",
            ],
            [
                   "getMaxRadiusAircraftCanFlyAndGoHome",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_maxRadiusAircraftCanFlyAndGoHome_inline",
                   "The maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. If the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. If the aircraft is using the simulator, this value will be 0.  @return A float value.",
            ],
            [
                   "The maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. If the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. If the aircraft is using the simulator, this value will be 0.  @return A float value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_maxRadiusAircraftCanFlyAndGoHome_inline",
                   "",
            ],
            [
                   "MAX_RADIUS_AIRCRAFT_CAN_FLY_AND_GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_maxRadiusAircraftCanFlyAndGoHome_inline",
                   "SDK Key for getMaxRadiusAircraftCanFlyAndGoHome: The maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. If the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. If the aircraft is using the simulator, this value will be 0.  @return A float value.",
            ],
            [
                   "SDK Key for getMaxRadiusAircraftCanFlyAndGoHome: The maximum radius, in meters, an aircraft can fly from its home location and still make it all the way back home, based on altitude, distance, battery, etc. If the aircraft goes out farther than the max radius, it will fly as far back home as it can and land. If the aircraft is using the simulator, this value will be 0.  @return A float value.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_maxRadiusAircraftCanFlyAndGoHome_inline",
                   "",
            ],
            [
                   "getSmartRTHState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_smartRTHState_inline",
                   "The Smart Return-To-Home (RTH) state for the current flight.  @return An enum value of `SmartRTHState`.",
            ],
            [
                   "The Smart Return-To-Home (RTH) state for the current flight.  @return An enum value of `SmartRTHState`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_smartRTHState_inline",
                   "",
            ],
            [
                   "getSmartRTHCountdown",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_smartRTHCountdown_inline",
                   "The countdown (in seconds) for the Smart Return-To-Home (RTH). Once the countdown reaches 0, the aircraft will execute an automatic go-home procedure. It is only valid when `getSmartRTHState` is `COUNTING_DOWN`.  @return The countdown for the Smart Return-To-Home (RTH).",
            ],
            [
                   "The countdown (in seconds) for the Smart Return-To-Home (RTH). Once the countdown reaches 0, the aircraft will execute an automatic go-home procedure. It is only valid when `getSmartRTHState` is `COUNTING_DOWN`.  @return The countdown for the Smart Return-To-Home (RTH).",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus.html",
                   "#DJIFlightController_DJIFlightControllerCurrentState_DJIFlightControllerSmartGoHomeStatus_smartRTHCountdown_inline",
                   "",
            ],
            [
                   "GPSSignalLevel",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_inline",
                   "A enum class representing GPS signal levels, which are used to measure the signal quality.",
            ],
            [
                   "A enum class representing GPS signal levels, which are used to measure the signal quality.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_inline",
                   "",
            ],
            [
                   "GPS_SIGNAL_LEVEL",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_inline",
                   "SDK Key for GPSSignalLevel: A enum class representing GPS signal levels, which are used to measure the signal quality.",
            ],
            [
                   "SDK Key for GPSSignalLevel: A enum class representing GPS signal levels, which are used to measure the signal quality.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_inline",
                   "",
            ],
            [
                   "LEVEL_0",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level0_inline",
                   "The GPS has almost no signal, which is very bad.",
            ],
            [
                   "The GPS has almost no signal, which is very bad.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level0_inline",
                   "",
            ],
            [
                   "LEVEL_1",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level1_inline",
                   "The GPS signal is very weak.",
            ],
            [
                   "The GPS signal is very weak.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level1_inline",
                   "",
            ],
            [
                   "LEVEL_2",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level2_inline",
                   "The GPS signal is weak. At this level, the aircraft's go home functionality will still work.",
            ],
            [
                   "The GPS signal is weak. At this level, the aircraft's go home functionality will still work.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level2_inline",
                   "",
            ],
            [
                   "LEVEL_3",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level3_inline",
                   "The GPS signal is good. At this level, the aircraft can hover in the air.",
            ],
            [
                   "The GPS signal is good. At this level, the aircraft can hover in the air.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level3_inline",
                   "",
            ],
            [
                   "LEVEL_4",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level4_inline",
                   "The GPS signal is very good. At this level, the aircraft can record the home point.",
            ],
            [
                   "The GPS signal is very good. At this level, the aircraft can record the home point.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level4_inline",
                   "",
            ],
            [
                   "LEVEL_5",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level5_inline",
                   "The GPS signal is very strong.",
            ],
            [
                   "The GPS signal is very strong.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_level5_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_None_inline",
                   "There is no GPS signal.",
            ],
            [
                   "There is no GPS signal.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIGPSSignalStatus_None_inline",
                   "",
            ],
            [
                   "FlightMode",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_inline",
                   "Flight controller flight modes. If the current flight mode means P-GPS, it will show OPTI in DJI app if the vision system is working. If the current flight Mode contains GPS and also the RTK signal is healthy, it will show RTK in DJI app.",
            ],
            [
                   "Flight controller flight modes. If the current flight mode means P-GPS, it will show OPTI in DJI app if the vision system is working. If the current flight Mode contains GPS and also the RTK signal is healthy, it will show RTK in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_inline",
                   "",
            ],
            [
                   "FLIGHT_MODE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_inline",
                   "SDK Key for FlightMode: Flight controller flight modes. If the current flight mode means P-GPS, it will show OPTI in DJI app if the vision system is working. If the current flight Mode contains GPS and also the RTK signal is healthy, it will show RTK in DJI app.",
            ],
            [
                   "SDK Key for FlightMode: Flight controller flight modes. If the current flight mode means P-GPS, it will show OPTI in DJI app if the vision system is working. If the current flight Mode contains GPS and also the RTK signal is healthy, it will show RTK in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_manual_inline",
                   "Manual mode. Shown as Manual in DJI app.",
            ],
            [
                   "Manual mode. Shown as Manual in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_manual_inline",
                   "",
            ],
            [
                   "ATTI",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_atti_inline",
                   "Attitude mode. Shown as Atti in DJI app.",
            ],
            [
                   "Attitude mode. Shown as Atti in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_atti_inline",
                   "",
            ],
            [
                   "ATTI_COURSE_LOCK",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiCourseLock_inline",
                   "Attitude course lock mode. Shown as Atti in DJI app.",
            ],
            [
                   "Attitude course lock mode. Shown as Atti in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiCourseLock_inline",
                   "",
            ],
            [
                   "ATTI_HOVER",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiHover_inline",
                   "Attitude hover mode. Shown as Atti in DJI app.",
            ],
            [
                   "Attitude hover mode. Shown as Atti in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiHover_inline",
                   "",
            ],
            [
                   "HOVER",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Hover_inline",
                   "Hover mode. Shown as P-GPS in DJI app.",
            ],
            [
                   "Hover mode. Shown as P-GPS in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Hover_inline",
                   "",
            ],
            [
                   "GPS_BLAKE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSBlake_inline",
                   "GPS blake mode. Shown as P-GPS in DJI app.",
            ],
            [
                   "GPS blake mode. Shown as P-GPS in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSBlake_inline",
                   "",
            ],
            [
                   "GPS_ATTI",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSAtti_inline",
                   "GPS Attitude mode. Shown as P-GPS in DJI app.",
            ],
            [
                   "GPS Attitude mode. Shown as P-GPS in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSAtti_inline",
                   "",
            ],
            [
                   "GPS_COURSE_LOCK",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSCourseLock_inline",
                   "GPS course lock mode. Shown as CL/P-CL/F-CL in DJI app.",
            ],
            [
                   "GPS course lock mode. Shown as CL/P-CL/F-CL in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSCourseLock_inline",
                   "",
            ],
            [
                   "GPS_HOME_LOCK",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSHomeLock_inline",
                   "GPS Home mode. Shown as HL/P-HL/F-HL in DJI app.",
            ],
            [
                   "GPS Home mode. Shown as HL/P-HL/F-HL in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSHomeLock_inline",
                   "",
            ],
            [
                   "GPS_HOT_POINT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSHotPoint_inline",
                   "GPS hotpoint mode. Show as POI/F-POI in DJI app.",
            ],
            [
                   "GPS hotpoint mode. Show as POI/F-POI in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSHotPoint_inline",
                   "",
            ],
            [
                   "ASSISTED_TAKEOFF",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AssistedTakeOff_inline",
                   "Assisted takeoff mode. Shown as TakeOff in DJI app.",
            ],
            [
                   "Assisted takeoff mode. Shown as TakeOff in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AssistedTakeOff_inline",
                   "",
            ],
            [
                   "AUTO_TAKEOFF",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AutoTakeOff_inline",
                   "Auto takeoff mode. Shown as TakeOff in DJI app.",
            ],
            [
                   "Auto takeoff mode. Shown as TakeOff in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AutoTakeOff_inline",
                   "",
            ],
            [
                   "AUTO_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AutoLanding_inline",
                   "Auto landing mode. Shown as Landing in DJI app.",
            ],
            [
                   "Auto landing mode. Shown as Landing in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AutoLanding_inline",
                   "",
            ],
            [
                   "ATTI_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiLanding_inline",
                   "Attitude landing mode. Shown as Landing in DJI app.",
            ],
            [
                   "Attitude landing mode. Shown as Landing in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiLanding_inline",
                   "",
            ],
            [
                   "GPS_WAYPOINT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSWaypoint_inline",
                   "GPS waypoint mode. Shown as WP/F-WP in DJI app.",
            ],
            [
                   "GPS waypoint mode. Shown as WP/F-WP in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSWaypoint_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GoHome_inline",
                   "Go home mode. Shown as Gohome in DJI app.",
            ],
            [
                   "Go home mode. Shown as Gohome in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GoHome_inline",
                   "",
            ],
            [
                   "JOYSTICK",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Joystick_inline",
                   "Joystick mode. hown as Joystick in DJI app.",
            ],
            [
                   "Joystick mode. hown as Joystick in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Joystick_inline",
                   "",
            ],
            [
                   "ATTI_LIMITED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiLimited_inline",
                   "Attitude limited mode. Shown as Atti in DJI app.",
            ],
            [
                   "Attitude limited mode. Shown as Atti in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_AttiLimited_inline",
                   "",
            ],
            [
                   "DRAW",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Draw_inline",
                   "Draw mode. Shown as Draw in DJI app.",
            ],
            [
                   "Draw mode. Shown as Draw in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Draw_inline",
                   "",
            ],
            [
                   "GPS_FOLLOW_ME",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSFollowMe_inline",
                   "GPS follow me mode. Shown as FM/F-FM in DJI app.",
            ],
            [
                   "GPS follow me mode. Shown as FM/F-FM in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSFollowMe_inline",
                   "",
            ],
            [
                   "ACTIVE_TRACK",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ActiveTrack_inline",
                   "ActiveTrack mode. Shown as ActiveTrack in DJI app.",
            ],
            [
                   "ActiveTrack mode. Shown as ActiveTrack in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ActiveTrack_inline",
                   "",
            ],
            [
                   "TAP_FLY",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_TapFly_inline",
                   "TapFly mode. Shown as TapFly in DJI app.",
            ],
            [
                   "TapFly mode. Shown as TapFly in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_TapFly_inline",
                   "",
            ],
            [
                   "GPS_SPORT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSSport_inline",
                   "Sport mode. Shown as Sport in DJI app.",
            ],
            [
                   "Sport mode. Shown as Sport in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_GPSSport_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Unknown_inline",
                   "The main controller flight mode is unknown.",
            ],
            [
                   "The main controller flight mode is unknown.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Unknown_inline",
                   "",
            ],
            [
                   "CONFIRM_LANDING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ConfirmLanding_inline",
                   "Confirm landing mode. Shown as Landing in DJI app.",
            ],
            [
                   "Confirm landing mode. Shown as Landing in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ConfirmLanding_inline",
                   "",
            ],
            [
                   "TERRAIN_FOLLOW",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_TerrainFollow_inline",
                   "The aircraft should move following the terrain. Shown as TerrainTracking in DJI app.",
            ],
            [
                   "The aircraft should move following the terrain. Shown as TerrainTracking in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_TerrainFollow_inline",
                   "",
            ],
            [
                   "TRIPOD",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Tripod_inline",
                   "Tripod mode. Shown as Tripod in DJI app.",
            ],
            [
                   "Tripod mode. Shown as Tripod in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_Tripod_inline",
                   "",
            ],
            [
                   "TRACK_SPOTLIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ActiveTrackSpotlight_inline",
                   "Active track mode, corresponds to Spotlight active track mode. Shown as QuickShot/ActiveTrack in DJI app.",
            ],
            [
                   "Active track mode, corresponds to Spotlight active track mode. Shown as QuickShot/ActiveTrack in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_ActiveTrackSpotlight_inline",
                   "",
            ],
            [
                   "MOTORS_JUST_STARTED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_MotorsJustStarted_inline",
                   "The motors are just started. Shown as TakeOff in DJI app.",
            ],
            [
                   "The motors are just started. Shown as TakeOff in DJI app.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIFlightControllerCurrentState.html",
                   "#DJIFlightController_DJIFlightControllerFlightMode_MotorsJustStarted_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/VisionDetectionState/DJIIntelligentFlightAssistant_visionDetectionStateUpdatedCallbackInterface.html",
                   "",
                   "This protocol provides an interface to update the Intelligent Flight Assistant current state.",
            ],
            [
                   "This protocol provides an interface to update the Intelligent Flight Assistant current state.",
                   1,
                   "/Components/VisionDetectionState/DJIIntelligentFlightAssistant_visionDetectionStateUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/VisionDetectionState/DJIIntelligentFlightAssistant_visionDetectionStateUpdatedCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionDetectionState_inline",
                   "Callback function that updates the vision detection state. The frequency of this method is 10Hz.  @param state The state of vision sensor.",
            ],
            [
                   "Callback function that updates the vision detection state. The frequency of this method is 10Hz.  @param state The state of vision sensor.",
                   1,
                   "/Components/VisionDetectionState/DJIIntelligentFlightAssistant_visionDetectionStateUpdatedCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionDetectionState_inline",
                   "",
            ],
            [
                   "isSensorBeingUsed",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_isSensorWorking_inline",
                   "`true` if the vision sensor is working.  @return A boolean value.",
            ],
            [
                   "`true` if the vision sensor is working.  @return A boolean value.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_isSensorWorking_inline",
                   "",
            ],
            [
                   "IS_VISION_POSITIONING_SENSOR_BEING_USED",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_isSensorWorking_inline",
                   "SDK Key for isSensorBeingUsed: `true` if the vision sensor is working.  @return A boolean value.",
            ],
            [
                   "SDK Key for isSensorBeingUsed: `true` if the vision sensor is working.  @return A boolean value.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_isSensorWorking_inline",
                   "",
            ],
            [
                   "getSystemWarning",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_systemWarning_inline",
                   "Distance warning level between the obstacle and the aircraft. This is a combination of warning levels from each sector.  @return An enum value of `VisionSystemWarning`",
            ],
            [
                   "Distance warning level between the obstacle and the aircraft. This is a combination of warning levels from each sector.  @return An enum value of `VisionSystemWarning`",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_systemWarning_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_WARNING",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_systemWarning_inline",
                   "SDK Key for getSystemWarning: Distance warning level between the obstacle and the aircraft. This is a combination of warning levels from each sector.  @return An enum value of `VisionSystemWarning`",
            ],
            [
                   "SDK Key for getSystemWarning: Distance warning level between the obstacle and the aircraft. This is a combination of warning levels from each sector.  @return An enum value of `VisionSystemWarning`",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_systemWarning_inline",
                   "",
            ],
            [
                   "getPosition",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_position_inline",
                   "The vision sensor's position on the aircraft. For Phantom 4 Pro, there are 4 vision sensors on the aircraft.  The sensors on the nose and tail are dual- camera sensors. The sensors on the left and right are infrared  time-of-flight (TOF) sensors.  @return An enum value of `VisionSensorPosition`",
            ],
            [
                   "The vision sensor's position on the aircraft. For Phantom 4 Pro, there are 4 vision sensors on the aircraft.  The sensors on the nose and tail are dual- camera sensors. The sensors on the left and right are infrared  time-of-flight (TOF) sensors.  @return An enum value of `VisionSensorPosition`",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_position_inline",
                   "",
            ],
            [
                   "getObstacleDistanceInMeters",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_obstacleDistanceInMeters_inline",
                   "The distance to the closest detected obstacle, in meters. It is only used when the sensor is an infrared TOF  sensor. The valid range is [0.3, 5.0]. Phantom 4 Pro has two infrared sensors on its left and right. Both sensors have a 70-degree horizontal field of view (FOV) and 20-degree vertical FOV. The value is always 0.0 if the sensor is a dual-camera sensor or the sensor is not working properly.  @return A double value.",
            ],
            [
                   "The distance to the closest detected obstacle, in meters. It is only used when the sensor is an infrared TOF  sensor. The valid range is [0.3, 5.0]. Phantom 4 Pro has two infrared sensors on its left and right. Both sensors have a 70-degree horizontal field of view (FOV) and 20-degree vertical FOV. The value is always 0.0 if the sensor is a dual-camera sensor or the sensor is not working properly.  @return A double value.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_obstacleDistanceInMeters_inline",
                   "",
            ],
            [
                   "getDetectionSectors",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_inline",
                   "The vision system can see in front of the aircraft with a 70 degree horizontal field of view (FOV) and 55-degree  vertical FOV for the Phantom 4. The horizontal FOV is split into four equal sectors and this array contains the distance and warning information for each sector. For Phantom 4, the horizontal FOV is separated into 4 sectors.  @return An instance of List<DJIVisionDetectionSector>. ",
            ],
            [
                   "The vision system can see in front of the aircraft with a 70 degree horizontal field of view (FOV) and 55-degree  vertical FOV for the Phantom 4. The horizontal FOV is split into four equal sectors and this array contains the distance and warning information for each sector. For Phantom 4, the horizontal FOV is separated into 4 sectors.  @return An instance of List<DJIVisionDetectionSector>. ",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_inline",
                   "",
            ],
            [
                   "DETECTION_SECTORS",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_inline",
                   "SDK Key for getDetectionSectors: The vision system can see in front of the aircraft with a 70 degree horizontal field of view (FOV) and 55-degree  vertical FOV for the Phantom 4. The horizontal FOV is split into four equal sectors and this array contains the distance and warning information for each sector. For Phantom 4, the horizontal FOV is separated into 4 sectors.  @return An instance of List<DJIVisionDetectionSector>. ",
            ],
            [
                   "SDK Key for getDetectionSectors: The vision system can see in front of the aircraft with a 70 degree horizontal field of view (FOV) and 55-degree  vertical FOV for the Phantom 4. The horizontal FOV is split into four equal sectors and this array contains the distance and warning information for each sector. For Phantom 4, the horizontal FOV is separated into 4 sectors.  @return An instance of List<DJIVisionDetectionSector>. ",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_inline",
                   "",
            ],
            [
                   "isDisabled",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_isDisabled_inline",
                   "`true` if the vision sensor is disabled.  @return A boolean value.",
            ],
            [
                   "`true` if the vision sensor is disabled.  @return A boolean value.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_detectionSectors_isDisabled_inline",
                   "",
            ],
            [
                   "ObstacleDetectionSector",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "",
                   "The vision system can see in front of the aircraft with a 60 degree horizontal field of view (FOV) and 55 degree  vertical FOV. The horizontal FOV is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
            ],
            [
                   "The vision system can see in front of the aircraft with a 60 degree horizontal field of view (FOV) and 55 degree  vertical FOV. The horizontal FOV is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "",
                   "",
            ],
            [
                   "DETECTION_SECTORS",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "",
                   "SDK Key for ObstacleDetectionSector: The vision system can see in front of the aircraft with a 60 degree horizontal field of view (FOV) and 55 degree  vertical FOV. The horizontal FOV is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
            ],
            [
                   "SDK Key for ObstacleDetectionSector: The vision system can see in front of the aircraft with a 60 degree horizontal field of view (FOV) and 55 degree  vertical FOV. The horizontal FOV is split into four equal sectors, and this class gives the distance and warning  level for one sector.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "",
                   "",
            ],
            [
                   "VisionSensorPosition",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_inline",
                   "Position of the sensor on the aircraft.",
            ],
            [
                   "Position of the sensor on the aircraft.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_inline",
                   "",
            ],
            [
                   "NOSE",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Nose_inline",
                   "The sensor is on the front or nose of the aircraft.",
            ],
            [
                   "The sensor is on the front or nose of the aircraft.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Nose_inline",
                   "",
            ],
            [
                   "TAIL",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Tail_inline",
                   "The sensor is on the back or tail of the aircraft.",
            ],
            [
                   "The sensor is on the back or tail of the aircraft.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Tail_inline",
                   "",
            ],
            [
                   "RIGHT",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Right_inline",
                   "The sensor is on the right or starboard side of the aircraft.",
            ],
            [
                   "The sensor is on the right or starboard side of the aircraft.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Right_inline",
                   "",
            ],
            [
                   "LEFT",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Left_inline",
                   "The sensor is on the left or port side of the aircraft.",
            ],
            [
                   "The sensor is on the left or port side of the aircraft.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Left_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_visionSensorPosition_Unknown_inline",
                   "",
            ],
            [
                   "VisionSystemWarning",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_inline",
                   "Distance warning returned by the front vision system. Warning Level 4 is the most serious level.",
            ],
            [
                   "Distance warning returned by the front vision system. Warning Level 4 is the most serious level.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_inline",
                   "",
            ],
            [
                   "VISION_SYSTEM_WARNING",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_inline",
                   "SDK Key for VisionSystemWarning: Distance warning returned by the front vision system. Warning Level 4 is the most serious level.",
            ],
            [
                   "SDK Key for VisionSystemWarning: Distance warning returned by the front vision system. Warning Level 4 is the most serious level.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_inline",
                   "",
            ],
            [
                   "INVALID",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Invalid_inline",
                   "The warning is invalid. The front vision system cannot determine depth of the scene in front of it.",
            ],
            [
                   "The warning is invalid. The front vision system cannot determine depth of the scene in front of it.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Invalid_inline",
                   "",
            ],
            [
                   "SAFE",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Safe_inline",
                   "The distance between the obstacle detected by the vision system and the aircraft is safe (over 2 meters).",
            ],
            [
                   "The distance between the obstacle detected by the vision system and the aircraft is safe (over 2 meters).",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Safe_inline",
                   "",
            ],
            [
                   "DANGEROUS",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Dangerous_inline",
                   "The distance between the obstacle detected by the vision system and the aircraft is dangerous (less than 2 meters).",
            ],
            [
                   "The distance between the obstacle detected by the vision system and the aircraft is dangerous (less than 2 meters).",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Dangerous_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Unknown_inline",
                   "The distance warning is unknown. This warning is returned when an exception occurs.",
            ],
            [
                   "The distance warning is unknown. This warning is returned when an exception occurs.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState.html",
                   "#DJIVisionDetectionState_VisionSystemWarning_Unknown_inline",
                   "",
            ],
            [
                   "getWarningLevel",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_DJIVisionDetectionSector_warningLevel_inline",
                   "The warning level based on distance.  @return An enum value of `ObstacleDetectionSectorWarning`",
            ],
            [
                   "The warning level based on distance.  @return An enum value of `ObstacleDetectionSectorWarning`",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_DJIVisionDetectionSector_warningLevel_inline",
                   "",
            ],
            [
                   "getObstacleDistanceInMeters",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_DJIVisionDetectionSector_obstacleDistanceInMeters_inline",
                   "The detected obstacle distance to the aircraft in meters. The left and right obstacle avoidance system is a monocular vision system,  so it can only detect whether there are obstacles. 0 represents no obstacles and 1 represents obstacles.  For mavic 2 series, it only supports returning this value in T mode.  @return A float value.",
            ],
            [
                   "The detected obstacle distance to the aircraft in meters. The left and right obstacle avoidance system is a monocular vision system,  so it can only detect whether there are obstacles. 0 represents no obstacles and 1 represents obstacles.  For mavic 2 series, it only supports returning this value in T mode.  @return A float value.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_DJIVisionDetectionSector_obstacleDistanceInMeters_inline",
                   "",
            ],
            [
                   "ObstacleDetectionSectorWarning",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_inline",
                   "Distance warning returned by each sector of the front vision system. Warning Level 6 is the most serious level. For different aircraft, the same warning level will refer to different distances. Spark only supports the follow warning levels:     - `INVALID`     - `LEVEL_1`     - `LEVEL_2`     - `LEVEL_3`     - `UNKNOWN`",
            ],
            [
                   "Distance warning returned by each sector of the front vision system. Warning Level 6 is the most serious level. For different aircraft, the same warning level will refer to different distances. Spark only supports the follow warning levels:     - `INVALID`     - `LEVEL_1`     - `LEVEL_2`     - `LEVEL_3`     - `UNKNOWN`",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_inline",
                   "",
            ],
            [
                   "INVALID",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Invalid_inline",
                   "The warning level is invalid. The sector cannot determine depth of the scene in front of it.",
            ],
            [
                   "The warning level is invalid. The sector cannot determine depth of the scene in front of it.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Invalid_inline",
                   "",
            ],
            [
                   "LEVEL_1",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level1_inline",
                   "Warning level 1.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by  the sector and the aircraft is over 10 meters.  - Spark: the distance between the obstacle  detected by the sector and the aircraft is over 4 meters.  - Others: the distance between  the obstacle detected by the sector and the aircraft is over 20 meters.",
            ],
            [
                   "Warning level 1.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by  the sector and the aircraft is over 10 meters.  - Spark: the distance between the obstacle  detected by the sector and the aircraft is over 4 meters.  - Others: the distance between  the obstacle detected by the sector and the aircraft is over 20 meters.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level1_inline",
                   "",
            ],
            [
                   "LEVEL_2",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level2_inline",
                   "Warning level 2.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the aircraft is between 8 - 10 meters.  - Spark: the distance between the obstacle  detected by the sector and the aircraft is between 2 - 4 meters.  - Others: the distance between  the obstacle detected by the sector and the aircraft is between 15 - 20 meters.",
            ],
            [
                   "Warning level 2.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the aircraft is between 8 - 10 meters.  - Spark: the distance between the obstacle  detected by the sector and the aircraft is between 2 - 4 meters.  - Others: the distance between  the obstacle detected by the sector and the aircraft is between 15 - 20 meters.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level2_inline",
                   "",
            ],
            [
                   "LEVEL_3",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level3_inline",
                   "Warning level 3.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector  and the aircraft is between 6 - 8 meters.  - Spark: the distance between the obstacle detected by the  sector and the aircraft is less than 2 meters.  - Others: the distance between the obstacle detected  by the sector and the aircraft is between 10 - 15 meters.",
            ],
            [
                   "Warning level 3.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector  and the aircraft is between 6 - 8 meters.  - Spark: the distance between the obstacle detected by the  sector and the aircraft is less than 2 meters.  - Others: the distance between the obstacle detected  by the sector and the aircraft is between 10 - 15 meters.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level3_inline",
                   "",
            ],
            [
                   "LEVEL_4",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level4_inline",
                   "Warning level 4.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is between 4 - 6 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is between 6 - 10 meters. Spark does not support this warning level.",
            ],
            [
                   "Warning level 4.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is between 4 - 6 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is between 6 - 10 meters. Spark does not support this warning level.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level4_inline",
                   "",
            ],
            [
                   "LEVEL_5",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level5_inline",
                   "Warning level 5.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is between 2 - 4 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is between 3 - 6 meters. Spark does not support this warning level.",
            ],
            [
                   "Warning level 5.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is between 2 - 4 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is between 3 - 6 meters. Spark does not support this warning level.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level5_inline",
                   "",
            ],
            [
                   "LEVEL_6",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level6_inline",
                   "Warning level 6.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is less than 2 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is less than 3 meters. Spark does not support this warning level.",
            ],
            [
                   "Warning level 6.  - Phantom 4 and Mavic Pro: the distance between the obstacle detected by the sector and the  aircraft is less than 2 meters.  - Others: the distance between the obstacle detected by the sector and the aircraft is less than 3 meters. Spark does not support this warning level.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Level6_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Unknown_inline",
                   "The distance warning is unknown. This warning is returned when an exception occurs.",
            ],
            [
                   "The distance warning is unknown. This warning is returned when an exception occurs.",
                   1,
                   "/Components/VisionDetectionState/DJIVisionDetectionState_DJIVisionDetectionSector.html",
                   "#DJIVisionDetectionState_VisionSectorWarning_Unknown_inline",
                   "",
            ],
            [
                   "FaceAwareState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_inline",
                   "FaceAware states. FaceAware is a step of PalmLaunch. Tapping the battery battery power  button twice, FaceAware will start to work automatically. If FaceAware is activated successfully,  the aircraft will takeoff from the palm.",
            ],
            [
                   "FaceAware states. FaceAware is a step of PalmLaunch. Tapping the battery battery power  button twice, FaceAware will start to work automatically. If FaceAware is activated successfully,  the aircraft will takeoff from the palm.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Idle_inline",
                   "The aircraft is not executing FaceAware.",
            ],
            [
                   "The aircraft is not executing FaceAware.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Idle_inline",
                   "",
            ],
            [
                   "ACTIVATING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Activating_inline",
                   "The aircraft is in the process of detecting a human face in front of the camera.",
            ],
            [
                   "The aircraft is in the process of detecting a human face in front of the camera.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Activating_inline",
                   "",
            ],
            [
                   "ACTIVATED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Activated_inline",
                   "FaceAware has been activated. The aircraft will beep twice and the motors will start spinning.",
            ],
            [
                   "FaceAware has been activated. The aircraft will beep twice and the motors will start spinning.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Activated_inline",
                   "",
            ],
            [
                   "FAILED_NO_FACE_DETECTED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_FailedNoFaceDetected_inline",
                   "FaceAware has failed to activate because no face was detected.",
            ],
            [
                   "FaceAware has failed to activate because no face was detected.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_FailedNoFaceDetected_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionFaceAwareState_Unknown_inline",
                   "",
            ],
            [
                   "PalmControlState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_inline",
                   "States of PalmControl.",
            ],
            [
                   "States of PalmControl.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Initializing_inline",
                   "The aircraft is initializing for PalmControl.",
            ],
            [
                   "The aircraft is initializing for PalmControl.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Initializing_inline",
                   "",
            ],
            [
                   "RECOGNIZING_PALM",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_RecognizingPalm_inline",
                   "The aircraft is recognizing the palm.",
            ],
            [
                   "The aircraft is recognizing the palm.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_RecognizingPalm_inline",
                   "",
            ],
            [
                   "STARTING_FOLLOW",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_StartingFollow_inline",
                   "The aircraft is moving into position for the PalmControl Follow command. In this state, the  aircraft is ascending and flying backward to a position that is 3m horizontally away from  the user and 2.3m above the ground. Once it has reached this position, the state will move  to `FOLLOWING` and the aircraft will then follow the user. The  Follow command can be initiated by raising one arm and quickly waving your hand at the camera.",
            ],
            [
                   "The aircraft is moving into position for the PalmControl Follow command. In this state, the  aircraft is ascending and flying backward to a position that is 3m horizontally away from  the user and 2.3m above the ground. Once it has reached this position, the state will move  to `FOLLOWING` and the aircraft will then follow the user. The  Follow command can be initiated by raising one arm and quickly waving your hand at the camera.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_StartingFollow_inline",
                   "",
            ],
            [
                   "FOLLOWING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Following_inline",
                   "The aircraft is currently following the user. To reach this state, the user first raises  one arm and quickly waves their hand at the aircraft's camera. The aircraft will then move  into position (3m from the user and 2.3m above the ground), and reach this state.",
            ],
            [
                   "The aircraft is currently following the user. To reach this state, the user first raises  one arm and quickly waves their hand at the aircraft's camera. The aircraft will then move  into position (3m from the user and 2.3m above the ground), and reach this state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Following_inline",
                   "",
            ],
            [
                   "ADJUSTING_POSITION",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_AdjustingPosition_inline",
                   "The aircraft's position is being adjusted by the moving palm.",
            ],
            [
                   "The aircraft's position is being adjusted by the moving palm.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_AdjustingPosition_inline",
                   "",
            ],
            [
                   "PALM_CONTROL_STOPPED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_PalmControlStopped_inline",
                   "PalmControl is stopped. PalmControl can be stopped by moving the sticks on the physical remote  controller or sending commands through `MobileRemoteController` when the physical remote  controller is absent.",
            ],
            [
                   "PalmControl is stopped. PalmControl can be stopped by moving the sticks on the physical remote  controller or sending commands through `MobileRemoteController` when the physical remote  controller is absent.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_PalmControlStopped_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIVisionDetectionState_DJIVisionPalmControlState_Unknown_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_imuID_inline",
                   "The IMU's ID. Starts at 0.  @return An int value.",
            ],
            [
                   "The IMU's ID. Starts at 0.  @return An int value.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_imuID_inline",
                   "",
            ],
            [
                   "getGyroscopeState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_gyroscopeStatus_inline",
                   "Returns the gyroscopic sensor's state value.  @return An enum value of `SensorState`",
            ],
            [
                   "Returns the gyroscopic sensor's state value.  @return An enum value of `SensorState`",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_gyroscopeStatus_inline",
                   "",
            ],
            [
                   "getAccelerometerState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_accelerometorStatus_inline",
                   "Returns the accelerometers sensor state value.  @return An enum value of `SensorState`",
            ],
            [
                   "Returns the accelerometers sensor state value.  @return An enum value of `SensorState`",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_accelerometorStatus_inline",
                   "",
            ],
            [
                   "getCalibrationProgress",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_calibrationProgress_inline",
                   "Returns the IMU's calibration progress, its range being [1, 100]. If the IMU is not calibrating, the value of the calibration progress will be -1.  @return An int value.",
            ],
            [
                   "Returns the IMU's calibration progress, its range being [1, 100]. If the IMU is not calibrating, the value of the calibration progress will be -1.  @return An int value.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_calibrationProgress_inline",
                   "",
            ],
            [
                   "getCalibrationState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_calibrationStatus_inline",
                   "Returns the status of the IMU's calibration.  @return An enum value of `CalibrationState`",
            ],
            [
                   "Returns the status of the IMU's calibration.  @return An enum value of `CalibrationState`",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_calibrationStatus_inline",
                   "",
            ],
            [
                   "getMultipleOrientationCalibrationHint",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_multiOrientationCalibrationHint_inline",
                   "For products that require the user to orient the aircraft during the IMU calibration, this method can be used to  inform the user when each orientation is done. It is supported by flight controller firmware 3.2.0.0 or above.  @return An instance of `MultipleOrientationCalibrationHint`",
            ],
            [
                   "For products that require the user to orient the aircraft during the IMU calibration, this method can be used to  inform the user when each orientation is done. It is supported by flight controller firmware 3.2.0.0 or above.  @return An instance of `MultipleOrientationCalibrationHint`",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_multiOrientationCalibrationHint_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "",
                   "Callback interface that is used to receive IMU state from flight controller.",
            ],
            [
                   "Callback interface that is used to receive IMU state from flight controller.",
                   1,
                   "/Components/IMUState/DJIFlightController_IMUStateChangedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "SensorState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_inline",
                   "Enum for IMU calibration Status.",
            ],
            [
                   "Enum for IMU calibration Status.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_inline",
                   "",
            ],
            [
                   "CalibrationState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_inline",
                   "Enum for IMU calibration Status.",
            ],
            [
                   "Enum for IMU calibration Status.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_inline",
                   "",
            ],
            [
                   "CalibrationOrientation",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_inline",
                   "The different orientations the aircraft needs for a multi-orientation IMU calibration.",
            ],
            [
                   "The different orientations the aircraft needs for a multi-orientation IMU calibration.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_inline",
                   "",
            ],
            [
                   "OrientationCalibrationState",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_inline",
                   "IMU calibration status for the current aircraft orientation.",
            ],
            [
                   "IMU calibration status for the current aircraft orientation.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_inline",
                   "",
            ],
            [
                   "MultipleOrientationCalibrationHint",
                   2,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "",
                   "This class is used to lead the user through an IMU calibration for products that require calibration at multiple  orientations. An example workflow is:   <ol> - Direct the user to orient the aircraft in one of the uncalibrated orientations in `getOrientationsToCalibrate`.  - Monitor `getState`  until `CALIBRATING` turns  to `COMPLETED`.  - Repeat until `getOrientationsToCalibrate` is empty.  </ol>",
            ],
            [
                   "This class is used to lead the user through an IMU calibration for products that require calibration at multiple  orientations. An example workflow is:   <ol> - Direct the user to orient the aircraft in one of the uncalibrated orientations in `getOrientationsToCalibrate`.  - Monitor `getState`  until `CALIBRATING` turns  to `COMPLETED`.  - Repeat until `getOrientationsToCalibrate` is empty.  </ol>",
                   1,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "",
                   "",
            ],
            [
                   "NOSE_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_NoseDown_inline",
                   "The front/nose of the aircraft should be pointed down.",
            ],
            [
                   "The front/nose of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_NoseDown_inline",
                   "",
            ],
            [
                   "TAIL_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_TailDown_inline",
                   "The back/tail of the aircraft should be pointed down.",
            ],
            [
                   "The back/tail of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_TailDown_inline",
                   "",
            ],
            [
                   "RIGHT_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_RightDown_inline",
                   "The right/starboard side of the aircraft should be pointed down.",
            ],
            [
                   "The right/starboard side of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_RightDown_inline",
                   "",
            ],
            [
                   "LEFT_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_LeftDown_inline",
                   "The left/port side of the aircraft should be pointed down.",
            ],
            [
                   "The left/port side of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_LeftDown_inline",
                   "",
            ],
            [
                   "BOTTOM_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_BottomDown_inline",
                   "The bottom/underbelly of the aircraft should be pointed down.",
            ],
            [
                   "The bottom/underbelly of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_BottomDown_inline",
                   "",
            ],
            [
                   "TOP_DOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_TopDown_inline",
                   "The top of the aircraft should be pointed down.",
            ],
            [
                   "The top of the aircraft should be pointed down.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationOrientation_TopDown_inline",
                   "",
            ],
            [
                   "CALIBRATING",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Calibrating_inline",
                   "Calibration of current aircraft orientation is in progress.",
            ],
            [
                   "Calibration of current aircraft orientation is in progress.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Calibrating_inline",
                   "",
            ],
            [
                   "COMPLETED",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Done_inline",
                   "Calibration of current aircraft orientation is done. The orientation will be added  to `getOrientationsCalibrated`. The aircraft should be  rotated to a remaining orientation  in `getOrientationsToCalibrate`.",
            ],
            [
                   "Calibration of current aircraft orientation is done. The orientation will be added  to `getOrientationsCalibrated`. The aircraft should be  rotated to a remaining orientation  in `getOrientationsToCalibrate`.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Done_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Unknown_inline",
                   "Unknown. Used by products that do not require IMU multi-orientation calibration.",
            ],
            [
                   "Unknown. Used by products that do not require IMU multi-orientation calibration.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationStatus_Unknown_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_status_inline",
                   "Gets the calibration status of the current orientation.  @return An enum value of `OrientationCalibrationState`",
            ],
            [
                   "Gets the calibration status of the current orientation.  @return An enum value of `OrientationCalibrationState`",
                   1,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_status_inline",
                   "",
            ],
            [
                   "getOrientationsToCalibrate",
                   2,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_orientationsToCalibrate_inline",
                   "Gets an array with the aircraft orientations that have not been calibrated yet. Each element  is a  `CalibrationOrientation` enum value.  @return An instance of HashSet `CalibrationOrientation`.",
            ],
            [
                   "Gets an array with the aircraft orientations that have not been calibrated yet. Each element  is a  `CalibrationOrientation` enum value.  @return An instance of HashSet `CalibrationOrientation`.",
                   1,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_orientationsToCalibrate_inline",
                   "",
            ],
            [
                   "getOrientationsCalibrated",
                   2,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_orientationsCalibrated_inline",
                   "Gets an array with the aircraft orientations that have been calibrated. Each element is  a  `CalibrationOrientation` enum value.  @return An instance of HashSet`CalibrationOrientation`.",
            ],
            [
                   "Gets an array with the aircraft orientations that have been calibrated. Each element is  a  `CalibrationOrientation` enum value.  @return An instance of HashSet`CalibrationOrientation`.",
                   1,
                   "/Components/IMUState/DJIIMUState_DJIIMUMultiOrientationCalibrationHint.html",
                   "#DJIIMUState_DJIIMUMultiOrientationCalibrationHint_orientationsCalibrated_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_None_inline",
                   "IMU not in calibration; no calibration is executing.",
            ],
            [
                   "IMU not in calibration; no calibration is executing.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_None_inline",
                   "",
            ],
            [
                   "CALIBRATING",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_InProgress_inline",
                   "IMU calibration is in progress.",
            ],
            [
                   "IMU calibration is in progress.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_InProgress_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Succeeded_inline",
                   "IMU calibration succeeded.",
            ],
            [
                   "IMU calibration succeeded.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Succeeded_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Failed_inline",
                   "IMU calibration failed.",
            ],
            [
                   "IMU calibration failed.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Failed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Unknown_inline",
                   "Unknown calibration status.",
            ],
            [
                   "Unknown calibration status.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUCalibrationStatus_Unknown_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Disconnect_inline",
                   "The IMU sensor is disconnected from the flight controller.",
            ],
            [
                   "The IMU sensor is disconnected from the flight controller.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Disconnect_inline",
                   "",
            ],
            [
                   "CALIBRATING",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Calibrating_inline",
                   "The IMU sensor is calibrating",
            ],
            [
                   "The IMU sensor is calibrating",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Calibrating_inline",
                   "",
            ],
            [
                   "CALIBRATION_FAILED",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_CalibrationFailed_inline",
                   "Calibrate of the IMU sensor failed.",
            ],
            [
                   "Calibrate of the IMU sensor failed.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_CalibrationFailed_inline",
                   "",
            ],
            [
                   "DATA_EXCEPTION",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_DataException_inline",
                   "The IMU sensor has a data exception. Calibrate the IMU and restart the aircraft. If afterwards the status still  exists, you may need to contact DJI for further assistance.",
            ],
            [
                   "The IMU sensor has a data exception. Calibrate the IMU and restart the aircraft. If afterwards the status still  exists, you may need to contact DJI for further assistance.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_DataException_inline",
                   "",
            ],
            [
                   "WARMING_UP",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_WarmingUp_inline",
                   "The IMU sensor is warming up.",
            ],
            [
                   "The IMU sensor is warming up.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_WarmingUp_inline",
                   "",
            ],
            [
                   "IN_MOTION",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Motion_inline",
                   "The IMU sensor is not static; the aircraft may not be stable enough to calculate sensor data correctly.",
            ],
            [
                   "The IMU sensor is not static; the aircraft may not be stable enough to calculate sensor data correctly.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Motion_inline",
                   "",
            ],
            [
                   "NORMAL_BIAS",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasNormal_inline",
                   "The IMU's bias value is normal; the aircraft can safely take off.",
            ],
            [
                   "The IMU's bias value is normal; the aircraft can safely take off.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasNormal_inline",
                   "",
            ],
            [
                   "MEDIUM_BIAS",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasMedium_inline",
                   "The IMU's bias value is medium; the aircraft can safely take off.",
            ],
            [
                   "The IMU's bias value is medium; the aircraft can safely take off.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasMedium_inline",
                   "",
            ],
            [
                   "LARGE_BIAS",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasLarge_inline",
                   "The IMU's bias value is large; the aircraft cannot take off. IMU calibration is needed.",
            ],
            [
                   "The IMU's bias value is large; the aircraft cannot take off. IMU calibration is needed.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_BiasLarge_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Unknown_inline",
                   "The IMU sensor's status is unknown.",
            ],
            [
                   "The IMU sensor's status is unknown.",
                   1,
                   "/Components/IMUState/DJIIMUState.html",
                   "#DJIIMUState_DJIIMUSensorStatus_Unknown_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_status_inline",
                   "The current state/position of the landing gear.  @return An enum value of `LandingGearState`",
            ],
            [
                   "The current state/position of the landing gear.  @return An enum value of `LandingGearState`",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_status_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_STATUS",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_status_inline",
                   "SDK Key for getState: The current state/position of the landing gear.  @return An enum value of `LandingGearState`",
            ],
            [
                   "SDK Key for getState: The current state/position of the landing gear.  @return An enum value of `LandingGearState`",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_status_inline",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_mode_inline",
                   "The current mode of the landing gear.  @return An enum value of `LandingGearMode`",
            ],
            [
                   "The current mode of the landing gear.  @return An enum value of `LandingGearMode`",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_mode_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_MODE",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_mode_inline",
                   "SDK Key for getMode: The current mode of the landing gear.  @return An enum value of `LandingGearMode`",
            ],
            [
                   "SDK Key for getMode: The current mode of the landing gear.  @return An enum value of `LandingGearMode`",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_mode_inline",
                   "",
            ],
            [
                   "setAutomaticMovementEnabled",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_setAutomaticMovementEnabled_inline",
                   "Turns on/off self-adaptive landing gear. When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled YES if automatic movement is enabled. @param callback Asynchronous execution result.",
            ],
            [
                   "Turns on/off self-adaptive landing gear. When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled YES if automatic movement is enabled. @param callback Asynchronous execution result.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_setAutomaticMovementEnabled_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_AUTOMATIC_MOVEMENT_ENABLED",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_setAutomaticMovementEnabled_inline",
                   "SDK Key for setAutomaticMovementEnabled: Turns on/off self-adaptive landing gear. When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled YES if automatic movement is enabled. @param callback Asynchronous execution result.",
            ],
            [
                   "SDK Key for setAutomaticMovementEnabled: Turns on/off self-adaptive landing gear. When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take-off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param enabled YES if automatic movement is enabled. @param callback Asynchronous execution result.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_setAutomaticMovementEnabled_inline",
                   "",
            ],
            [
                   "getAutomaticMovementEnabled",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_getAutomaticMovementEnabled_inline",
                   "Gets self-adaptive landing gear state (on/off). When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Gets self-adaptive landing gear state (on/off). When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_getAutomaticMovementEnabled_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_AUTOMATIC_MOVEMENT_ENABLED",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_getAutomaticMovementEnabled_inline",
                   "SDK Key for getAutomaticMovementEnabled: Gets self-adaptive landing gear state (on/off). When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for getAutomaticMovementEnabled: Gets self-adaptive landing gear state (on/off). When turned on, landing gear will automatically lower  when aircraft is 0.5m above the ground. After take- off, landing gear will automatically rise when  aircraft reaches 0.5m above the ground. If self-adaptive landing gear is turned off, aircraft  will not automatically raise or lower its landing gear.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_getAutomaticMovementEnabled_inline",
                   "",
            ],
            [
                   "enterTransportMode",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_enterTransportMode_inline",
                   "Enters transport mode, moving the landing gear to its optimal position for transportation. Note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enters transport mode, moving the landing gear to its optimal position for transportation. Note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_enterTransportMode_inline",
                   "",
            ],
            [
                   "ENTER_TRANSPORT_MODE",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_enterTransportMode_inline",
                   "SDK Key for enterTransportMode: Enters transport mode, moving the landing gear to its optimal position for transportation. Note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for enterTransportMode: Enters transport mode, moving the landing gear to its optimal position for transportation. Note that if the gimbal is not removed, or the ground is not flat, entering transport mode will fail.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_enterTransportMode_inline",
                   "",
            ],
            [
                   "exitTransportMode",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_exitTransportMode_inline",
                   "Exits transport mode. Note that if the ground is not flat, exit transport mode will fail.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Exits transport mode. Note that if the ground is not flat, exit transport mode will fail.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_exitTransportMode_inline",
                   "",
            ],
            [
                   "EXIT_TRANSPORT_MODE",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_exitTransportMode_inline",
                   "SDK Key for exitTransportMode: Exits transport mode. Note that if the ground is not flat, exit transport mode will fail.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for exitTransportMode: Exits transport mode. Note that if the ground is not flat, exit transport mode will fail.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_exitTransportMode_inline",
                   "",
            ],
            [
                   "retract",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_retractLandingGear_inline",
                   "Retracts the landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, landing gear  cannot be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Retracts the landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, landing gear  cannot be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_retractLandingGear_inline",
                   "",
            ],
            [
                   "RETRACT_LANDING_GEAR",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_retractLandingGear_inline",
                   "SDK Key for retract: Retracts the landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, landing gear  cannot be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for retract: Retracts the landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, landing gear  cannot be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_retractLandingGear_inline",
                   "",
            ],
            [
                   "deploy",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_deployLandingGear_inline",
                   "Deploys landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, the landing gear cannot  be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Deploys landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, the landing gear cannot  be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_deployLandingGear_inline",
                   "",
            ],
            [
                   "DEPLOY_LANDING_GEAR",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_deployLandingGear_inline",
                   "SDK Key for deploy: Deploys landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, the landing gear cannot  be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for deploy: Deploys landing gear. Should only be used when `getMode`  is `MANUAL`. For Matrice 600 and Matrice 600 Pro, the landing gear cannot  be controlled through the SDK, only automatically by the aircraft or manually by the remote controller.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_deployLandingGear_inline",
                   "",
            ],
            [
                   "LandingGearState",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_inline",
                   "Current state of landing gear.",
            ],
            [
                   "Current state of landing gear.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_STATUS",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_inline",
                   "SDK Key for LandingGearState: Current state of landing gear.",
            ],
            [
                   "SDK Key for LandingGearState: Current state of landing gear.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Unknown_inline",
                   "Landing gear is in unknown state. This will be returned if the aircraft can't get the landing gear status.",
            ],
            [
                   "Landing gear is in unknown state. This will be returned if the aircraft can't get the landing gear status.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Unknown_inline",
                   "",
            ],
            [
                   "DEPLOYED",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Deployed_inline",
                   "Landing gear is fully deployed (ready for landing)",
            ],
            [
                   "Landing gear is fully deployed (ready for landing)",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Deployed_inline",
                   "",
            ],
            [
                   "RETRACTED",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Retracted_inline",
                   "Landing gear is fully retracted (ready for flying).",
            ],
            [
                   "Landing gear is fully retracted (ready for flying).",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Retracted_inline",
                   "",
            ],
            [
                   "DEPLOYING",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Deploying_inline",
                   "Landing gear is deploying (getting ready for landing).",
            ],
            [
                   "Landing gear is deploying (getting ready for landing).",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Deploying_inline",
                   "",
            ],
            [
                   "RETRACTING",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Retracting_inline",
                   "Landing gear is retracting (getting ready for flying).",
            ],
            [
                   "Landing gear is retracting (getting ready for flying).",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Retracting_inline",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Stopped_inline",
                   "Landing gear is stopped.",
            ],
            [
                   "Landing gear is stopped.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearStatus_Stopped_inline",
                   "",
            ],
            [
                   "LandingGearMode",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_inline",
                   "Current Mode of the landing gear.",
            ],
            [
                   "Current Mode of the landing gear.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_inline",
                   "",
            ],
            [
                   "LANDING_GEAR_MODE",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_inline",
                   "SDK Key for LandingGearMode: Current Mode of the landing gear.",
            ],
            [
                   "SDK Key for LandingGearMode: Current Mode of the landing gear.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Normal_inline",
                   "Landing gear can be deployed and retracted through function calls.",
            ],
            [
                   "Landing gear can be deployed and retracted through function calls.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Normal_inline",
                   "",
            ],
            [
                   "TRANSPORT",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Transport_inline",
                   "Landing gear is in transport mode (either it is moving into, moving out of, or stopped in transport position).",
            ],
            [
                   "Landing gear is in transport mode (either it is moving into, moving out of, or stopped in transport position).",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Transport_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Auto_inline",
                   "Landing gear automatically transitions between deployed and retracted depending on altitude. During take-off,  the transition point is 1.2m above ground. After take-off (during flight or when landing), the transition point  is 0.5m above ground.",
            ],
            [
                   "Landing gear automatically transitions between deployed and retracted depending on altitude. During take-off,  the transition point is 1.2m above ground. After take-off (during flight or when landing), the transition point  is 0.5m above ground.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Auto_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Unknown_inline",
                   "Landing Gear is in an unknown mode.",
            ],
            [
                   "Landing Gear is in an unknown mode.",
                   1,
                   "/Components/LandingGear/DJILandingGear.html",
                   "#DJILandingGear_DJILandingGearMode_Unknown_inline",
                   "",
            ],
            [
                   "setFlyZoneStateCallback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setFlyForbidStatusUpdatedCallback_inline",
                   "Sets up the `setFlyZoneStateCallback` for  obtaining `FlyZoneState`.  @param callback FlyForbidStatusUpdatedCallback callback.",
            ],
            [
                   "Sets up the `setFlyZoneStateCallback` for  obtaining `FlyZoneState`.  @param callback FlyForbidStatusUpdatedCallback callback.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setFlyForbidStatusUpdatedCallback_inline",
                   "",
            ],
            [
                   "setFlySafeNotificationCallback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setFlySafeNotificationCallback_inline",
                   "Sets up the `setFlyZoneStateCallback` for  obtaining `FlySafeNotification`.  @param callback An object value of `FlySafeNotification`.",
            ],
            [
                   "Sets up the `setFlyZoneStateCallback` for  obtaining `FlySafeNotification`.  @param callback An object value of `FlySafeNotification`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setFlySafeNotificationCallback_inline",
                   "",
            ],
            [
                   "setBasicDatabaseUpgradeProgressUpdatedCallback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setBasicDatabaseUpgradeProgressUpdatedCallback_inline",
                   "Sets up the `setBasicDatabaseUpgradeProgressUpdatedCallback` for  obtaining the basic database upgrade progress.  @param callback `BasicDatabaseUpgradeProgressUpdatedCallback` callback.",
            ],
            [
                   "Sets up the `setBasicDatabaseUpgradeProgressUpdatedCallback` for  obtaining the basic database upgrade progress.  @param callback `BasicDatabaseUpgradeProgressUpdatedCallback` callback.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_setBasicDatabaseUpgradeProgressUpdatedCallback_inline",
                   "",
            ],
            [
                   "getFlyZonesInSurroundingArea",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getFlyZonesInSurroundingArea_inline",
                   "Gets all the fly zones within 20km of the aircraft. During simulation, this method is available only when the aircraft location is within 50km of (37.460484, -122.115312) or within 50km of (22.5726, 113.8124499). Use of the geographic information provided by DJIFlyZoneManager is restricted. Refer to the DJI Developer Policy.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets all the fly zones within 20km of the aircraft. During simulation, this method is available only when the aircraft location is within 50km of (37.460484, -122.115312) or within 50km of (22.5726, 113.8124499). Use of the geographic information provided by DJIFlyZoneManager is restricted. Refer to the DJI Developer Policy.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getFlyZonesInSurroundingArea_inline",
                   "",
            ],
            [
                   "getUnlockedFlyZonesForAircraft",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getUnlockedFlyZones_inline",
                   "Gets a list of authorization fly zones unlocked by  the account for the connected aircraft. It includes fly zones unlocked by  the Flight Planner (http://www.dji.com/flysafe/geo-system#planner), and the  ones unlocked during flight using DJI Go or any DJI Mobile SDK based application.  This list does NOT include fly zones unlocked by custom unlocking. For Inspire 1  and Phantom 3 series, the list is fetched from the server.  If the internet is not accessible, the cached local data will be used. For the other products, the list is  fetched from the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets a list of authorization fly zones unlocked by  the account for the connected aircraft. It includes fly zones unlocked by  the Flight Planner (http://www.dji.com/flysafe/geo-system#planner), and the  ones unlocked during flight using DJI Go or any DJI Mobile SDK based application.  This list does NOT include fly zones unlocked by custom unlocking. For Inspire 1  and Phantom 3 series, the list is fetched from the server.  If the internet is not accessible, the cached local data will be used. For the other products, the list is  fetched from the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getUnlockedFlyZones_inline",
                   "",
            ],
            [
                   "unlockFlyZones",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_unlockFlyZones_inline",
                   "Unlocks the selected fly zones. This method can be used to unlock  authorization zones. After unlocking the zones, flight will be  unrestricted in those zones until the unlock expires.  The unlocking record will be linked to the user's account and will  be accessible to DJI Go and other DJI Mobile SDK based applications.  Data Protection Notes - Calling this method will send the following  protected data to DJI server:  - User account information  - The  serial number of the connected aircraft.  @param ids The IDs of `AUTHORIZATION` zones. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Unlocks the selected fly zones. This method can be used to unlock  authorization zones. After unlocking the zones, flight will be  unrestricted in those zones until the unlock expires.  The unlocking record will be linked to the user's account and will  be accessible to DJI Go and other DJI Mobile SDK based applications.  Data Protection Notes - Calling this method will send the following  protected data to DJI server:  - User account information  - The  serial number of the connected aircraft.  @param ids The IDs of `AUTHORIZATION` zones. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_unlockFlyZones_inline",
                   "",
            ],
            [
                   "unlockAuthorizationFlyZone",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_unlockAuthorizationFlyZone_inline",
                   "Unlock the authorization fly zone. After unlocking the authorization fly zone, the aircraft will be able to take off normally in the authorization fly zone, and the authorization fly zone will continue to be banned after reboot the aircraft.  @param id The ID of `AUTHORIZATION` zone. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Unlock the authorization fly zone. After unlocking the authorization fly zone, the aircraft will be able to take off normally in the authorization fly zone, and the authorization fly zone will continue to be banned after reboot the aircraft.  @param id The ID of `AUTHORIZATION` zone. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_unlockAuthorizationFlyZone_inline",
                   "",
            ],
            [
                   "reloadUnlockedZoneGroupsFromServer",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_loadIndividualUnlockZonesFromServer_inline",
                   "Reloads the unlocked zone groups unlocked by the current user's account from the server.  For all products besides Phantom 3 and Inspire 1 series this includes both self unlocked  and custom unlocked zones. Each unlocked zone group corresponds to one aircraft serial number.  After launch, SDK will call this method once. It will call this method again when either  the network connection or the current account state changes  (e.g. when a new user  successfully logs in). Call this method any other time to trigger the reloading manually.  Calling this method will NOT synchronize the loaded zone groups onto the aircraft.  To get a list of groups currently loaded from the server, call `getLoadedUnlockedZoneGroups`. User will need to manually call `syncUnlockedZoneGroupToAircraft`  to synchronize the unlocked group to the connected aircraft after the unlocked zone groups are reloaded. This feature is not supported by Inspire 1 or Phantom 3 series. For the other  products, it can be used when `isCustomUnlockZoneSupported`  returns `true`.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "Reloads the unlocked zone groups unlocked by the current user's account from the server.  For all products besides Phantom 3 and Inspire 1 series this includes both self unlocked  and custom unlocked zones. Each unlocked zone group corresponds to one aircraft serial number.  After launch, SDK will call this method once. It will call this method again when either  the network connection or the current account state changes  (e.g. when a new user  successfully logs in). Call this method any other time to trigger the reloading manually.  Calling this method will NOT synchronize the loaded zone groups onto the aircraft.  To get a list of groups currently loaded from the server, call `getLoadedUnlockedZoneGroups`. User will need to manually call `syncUnlockedZoneGroupToAircraft`  to synchronize the unlocked group to the connected aircraft after the unlocked zone groups are reloaded. This feature is not supported by Inspire 1 or Phantom 3 series. For the other  products, it can be used when `isCustomUnlockZoneSupported`  returns `true`.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_loadIndividualUnlockZonesFromServer_inline",
                   "",
            ],
            [
                   "getLoadedUnlockedZoneGroups",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getLoadedUnlockedZoneGroups_inline",
                   "Gets the unlocked zone groups loaded from the server. Each zone group corresponds to one aircraft.  The loaded zone groups will NOT be synchronized to the aircraft automatically. User need to manually  invoke `syncUnlockedZoneGroupToAircraft` to synchronize the unlocked zone group  to the connected aircraft. Invoke `reloadUnlockedZoneGroupsFromServer` to trigger  the reloading of unlocked zone groups manually. This feature is not supported by Inspire 1 or Phantom 3  series. For the other products, it can be used when `isCustomUnlockZoneSupported`  returns `true`.  @param callback The execution callback with the returned result.",
            ],
            [
                   "Gets the unlocked zone groups loaded from the server. Each zone group corresponds to one aircraft.  The loaded zone groups will NOT be synchronized to the aircraft automatically. User need to manually  invoke `syncUnlockedZoneGroupToAircraft` to synchronize the unlocked zone group  to the connected aircraft. Invoke `reloadUnlockedZoneGroupsFromServer` to trigger  the reloading of unlocked zone groups manually. This feature is not supported by Inspire 1 or Phantom 3  series. For the other products, it can be used when `isCustomUnlockZoneSupported`  returns `true`.  @param callback The execution callback with the returned result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getLoadedUnlockedZoneGroups_inline",
                   "",
            ],
            [
                   "syncUnlockedZoneGroupToAircraft",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_syncUnlockedZoneGroupToAircraft_inline",
                   "Synchronizes the unlocked zone group to the connected aircraft. SDK will select the unlocked zone group that  matches the serial number of the connected aircraft. After the unlocked zone group is synchronized to the  aircraft successfully, the latest unlocked fly zones and the custom unlock zones on the aircraft can be  checked by the follow methods:  - Unlocked fly zones: `getUnlockedFlyZonesForAircraft` - Custom unlock zones: `getCustomUnlockZonesFromAircraft` This feature is not supported  by Inspire 1 or Phantom 3 series. For the other products, it can be used when  `isCustomUnlockZoneSupported` returns `true`.  @param callback The `completion callback` with the returned result.",
            ],
            [
                   "Synchronizes the unlocked zone group to the connected aircraft. SDK will select the unlocked zone group that  matches the serial number of the connected aircraft. After the unlocked zone group is synchronized to the  aircraft successfully, the latest unlocked fly zones and the custom unlock zones on the aircraft can be  checked by the follow methods:  - Unlocked fly zones: `getUnlockedFlyZonesForAircraft` - Custom unlock zones: `getCustomUnlockZonesFromAircraft` This feature is not supported  by Inspire 1 or Phantom 3 series. For the other products, it can be used when  `isCustomUnlockZoneSupported` returns `true`.  @param callback The `completion callback` with the returned result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_syncUnlockedZoneGroupToAircraft_inline",
                   "",
            ],
            [
                   "getCustomUnlockZonesFromAircraft",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getIndividualUnlockZones_inline",
                   "Gets the Custom Unlock Zones currently on the aircraft. This method can only be used  when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Gets the Custom Unlock Zones currently on the aircraft. This method can only be used  when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getIndividualUnlockZones_inline",
                   "",
            ],
            [
                   "enableCustomUnlockZone",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_enableIndividualUnlockZone_inline",
                   "Enables an Custom Unlock Zones that is on the aircraft. All Custom Unlock Zones on the  aircraft can be retrieved with `getCustomUnlockZonesFromAircraft`.  At any time,  only one Custom Unlock Zone can be enabled. Enabling an Custom Unlock Zone will  disable the previously enabled zone. This method can only be used when  `isCustomUnlockZoneSupported` is `true`.  @param zone Custom Unlock Zone to enabled. If `zone` is `nil`, only the  previously enabled zone will be disabled. @param callback `completion callback` to receive the result.",
            ],
            [
                   "Enables an Custom Unlock Zones that is on the aircraft. All Custom Unlock Zones on the  aircraft can be retrieved with `getCustomUnlockZonesFromAircraft`.  At any time,  only one Custom Unlock Zone can be enabled. Enabling an Custom Unlock Zone will  disable the previously enabled zone. This method can only be used when  `isCustomUnlockZoneSupported` is `true`.  @param zone Custom Unlock Zone to enabled. If `zone` is `nil`, only the  previously enabled zone will be disabled. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_enableIndividualUnlockZone_inline",
                   "",
            ],
            [
                   "getEnabledCustomUnlockZone",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getEnabledIndividualUnlockZone_inline",
                   "Gets the currently enabled Custom Unlock Zone. This method can only be used when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "Gets the currently enabled Custom Unlock Zone. This method can only be used when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getEnabledIndividualUnlockZone_inline",
                   "",
            ],
            [
                   "isCustomUnlockZoneSupported",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_isIndividualUnlockZoneSupported_inline",
                   "`true` if an aircraft is connected with flight controller firmware that supports Custom Unlock Zones. Aircraft that support Custom Unlock  zones are also able to disable unlocked fly zones temporarily.  @return A boolean value to check if Custom Unlock Zone supported.",
            ],
            [
                   "`true` if an aircraft is connected with flight controller firmware that supports Custom Unlock Zones. Aircraft that support Custom Unlock  zones are also able to disable unlocked fly zones temporarily.  @return A boolean value to check if Custom Unlock Zone supported.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_isIndividualUnlockZoneSupported_inline",
                   "",
            ],
            [
                   "deleteAllUnlockingLicenses",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_deleteAllUnlockingLicenses_inline",
                   "Deletes all unlocking licenses in the aircraft. Supported only by Mavic Mini, DJI Mini 2, DJI Mini SE and Matrice 300 RTK.  @param callback The execution callback.",
            ],
            [
                   "Deletes all unlocking licenses in the aircraft. Supported only by Mavic Mini, DJI Mini 2, DJI Mini SE and Matrice 300 RTK.  @param callback The execution callback.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_deleteAllUnlockingLicenses_inline",
                   "",
            ],
            [
                   "getPreciseDatabaseVersion",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_databaseVersion_inline",
                   "The version of the precise fly zone database in the firmware of the aircraft. It is `null` if `getPreciseDatabaseState` is `INITIALIZING`.  The precise database is supported by Phantom 4 series, Inspire 2, M200 series, Mavic and Spark.  @param callback The execution callback.",
            ],
            [
                   "The version of the precise fly zone database in the firmware of the aircraft. It is `null` if `getPreciseDatabaseState` is `INITIALIZING`.  The precise database is supported by Phantom 4 series, Inspire 2, M200 series, Mavic and Spark.  @param callback The execution callback.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_databaseVersion_inline",
                   "",
            ],
            [
                   "getPreciseDatabaseState",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_databaseState_inline",
                   "The fly zone database state in the firmware of the aircraft. The SDK will compare the version of the database on the aircraft against  the latest one online. When the aircraft database is out-of-date, the user should use DJI Go or Assistant 2 to update the firmware. This  database is supported by Phantom 4 series, Inspire 2, M200 series, Mavic and Spark.  @param callback The execution callback.",
            ],
            [
                   "The fly zone database state in the firmware of the aircraft. The SDK will compare the version of the database on the aircraft against  the latest one online. When the aircraft database is out-of-date, the user should use DJI Go or Assistant 2 to update the firmware. This  database is supported by Phantom 4 series, Inspire 2, M200 series, Mavic and Spark.  @param callback The execution callback.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_databaseState_inline",
                   "",
            ],
            [
                   "getBasicDatabaseState",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getBasicDatabaseState_inline",
                   "Get the state of the basic fly zone database on the mobile device. The SDK will compare the version  of the local database against the latest one online. When the local database is out-of-date,  call `startBasicDatabaseUpgrade` to start updating the database. If the update  is compulsory (for safety reasons), SDK will start the update automatically. The basic database is used  by DJI aircraft that do not support the precise database (e.g. Phantom 3 series, Inspire 1 series).  @param callback The execution callback with the returned `FlyZoneDatabaseState` enum value(s).",
            ],
            [
                   "Get the state of the basic fly zone database on the mobile device. The SDK will compare the version  of the local database against the latest one online. When the local database is out-of-date,  call `startBasicDatabaseUpgrade` to start updating the database. If the update  is compulsory (for safety reasons), SDK will start the update automatically. The basic database is used  by DJI aircraft that do not support the precise database (e.g. Phantom 3 series, Inspire 1 series).  @param callback The execution callback with the returned `FlyZoneDatabaseState` enum value(s).",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_getBasicDatabaseState_inline",
                   "",
            ],
            [
                   "getBasicDatabaseVersion",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_basicDatabaseVersion_inline",
                   "The version of the basic fly zone database on the mobile device. It is `null` if the local file cannot  be parsed by SDK. The basic database is used by DJI aircraft that do not support the precise database (e.g.  Phantom 3 series, Inspire 1 series).  @param callback The execution callback with the returned String value.",
            ],
            [
                   "The version of the basic fly zone database on the mobile device. It is `null` if the local file cannot  be parsed by SDK. The basic database is used by DJI aircraft that do not support the precise database (e.g.  Phantom 3 series, Inspire 1 series).  @param callback The execution callback with the returned String value.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_basicDatabaseVersion_inline",
                   "",
            ],
            [
                   "startBasicDatabaseUpgrade",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_startBasicDatabaseUpgrade_inline",
                   "Starts the upgrde of the basic database. Internet access is required. When the upgrade is started successfully,  use `onUpdate` to monitor the progress.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "Starts the upgrde of the basic database. Internet access is required. When the upgrade is started successfully,  use `onUpdate` to monitor the progress.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_startBasicDatabaseUpgrade_inline",
                   "",
            ],
            [
                   "stopBasicDatabaseUpgrade",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_stopBasicDatabaseUpgrade_inline",
                   "Stops the in-progress upgrade of the basic database.  @param callback `completion callback` to receive the result.",
            ],
            [
                   "Stops the in-progress upgrade of the basic database.  @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_stopBasicDatabaseUpgrade_inline",
                   "",
            ],
            [
                   "UnlockedZoneGroup",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "",
                   "An unlocked zone group contains the self-unlocked fly zones and custom unlock zones for an aircraft.",
            ],
            [
                   "An unlocked zone group contains the self-unlocked fly zones and custom unlock zones for an aircraft.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "",
                   "",
            ],
            [
                   "getSn",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_SN_inline",
                   "The serial number of the aircraft.  @return A string instance of the unlocked zone group serial number.",
            ],
            [
                   "The serial number of the aircraft.  @return A string instance of the unlocked zone group serial number.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_SN_inline",
                   "",
            ],
            [
                   "getSelfUnlockedFlyZones",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_selfUnlockedFlyZones_inline",
                   "The self-unlocked authorization fly zones for the aircraft.  @return A list of `FlyZoneInformation` objects.",
            ],
            [
                   "The self-unlocked authorization fly zones for the aircraft.  @return A list of `FlyZoneInformation` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_selfUnlockedFlyZones_inline",
                   "",
            ],
            [
                   "getCustomUnlockZones",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_customUnlockZones_inline",
                   "The custom unlock zones for the aircraft.  @return A list of `CustomUnlockZone` objects.",
            ],
            [
                   "The custom unlock zones for the aircraft.  @return A list of `CustomUnlockZone` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIUnlockedZoneGroup.html",
                   "#DJIFlyZoneManager_DJIUnlockedZoneGroup_customUnlockZones_inline",
                   "",
            ],
            [
                   "FlyZoneInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "",
                   "This class contains information about a fly zone. `getFlyZoneType`  should be used to understand the type of fly zone to know which information in this class is valid.",
            ],
            [
                   "This class contains information about a fly zone. `getFlyZoneType`  should be used to understand the type of fly zone to know which information in this class is valid.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "",
                   "",
            ],
            [
                   "FlyZoneDatabaseState",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_inline",
                   "The state of the fly zone database on the aircraft.",
            ],
            [
                   "The state of the fly zone database on the aircraft.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_inline",
                   "",
            ],
            [
                   "FlyZoneState",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_inline",
                   "This enum describes whether the aircraft is clear of, near, or actually in a fly zone.",
            ],
            [
                   "This enum describes whether the aircraft is clear of, near, or actually in a fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_Initializing_inline",
                   "SDK is fetching the information of the database.",
            ],
            [
                   "SDK is fetching the information of the database.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_Initializing_inline",
                   "",
            ],
            [
                   "NO_INTERNET_CONNECTION",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_NoInternetConnection_inline",
                   "SDK cannot access the Internet, so it cannot compare the database version with the latest one on the Internet.",
            ],
            [
                   "SDK cannot access the Internet, so it cannot compare the database version with the latest one on the Internet.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_NoInternetConnection_inline",
                   "",
            ],
            [
                   "OUT_OF_DATE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_OutOfDate_inline",
                   "Aircraft's database version is older than the latest one.  User should use DJI Go or Assistant 2 to upgrade the firmware in order  to keep the database up to date.",
            ],
            [
                   "Aircraft's database version is older than the latest one.  User should use DJI Go or Assistant 2 to upgrade the firmware in order  to keep the database up to date.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_OutOfDate_inline",
                   "",
            ],
            [
                   "UP_TO_DATE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_UpToDate_inline",
                   "The database in the aircraft is up to date.",
            ],
            [
                   "The database in the aircraft is up to date.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_UpToDate_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_Unknown_inline",
                   "Unknown state",
            ],
            [
                   "Unknown state",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJIFlyZoneDatabaseState_Unknown_inline",
                   "",
            ],
            [
                   "getFlyZoneType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_type_inline",
                   "Returns the type fly zone.  @return The type of fly zone.",
            ],
            [
                   "Returns the type fly zone.  @return The type of fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_type_inline",
                   "",
            ],
            [
                   "getFlyZoneID",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneID_inline",
                   "Returns the fly zone's ID. This is required if unlocking a fly zone.  @return An int value.",
            ],
            [
                   "Returns the fly zone's ID. This is required if unlocking a fly zone.  @return An int value.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneID_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_name_inline",
                   "Returns the name of the fly zone.  @return A string instance of the name of the fly zone.",
            ],
            [
                   "Returns the name of the fly zone.  @return A string instance of the name of the fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_name_inline",
                   "",
            ],
            [
                   "getReason",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_reason_inline",
                   "Returns the reason of the fly zone `FlyZoneReason`.  @return An enum value of `FlyZoneReason`.",
            ],
            [
                   "Returns the reason of the fly zone `FlyZoneReason`.  @return An enum value of `FlyZoneReason`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_reason_inline",
                   "",
            ],
            [
                   "getCoordinate",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_coordinate_inline",
                   "The coordinate of the fly zone's center. Only used for GEO and NFZ fly zones.  @return Coordinate of fly zone center.",
            ],
            [
                   "The coordinate of the fly zone's center. Only used for GEO and NFZ fly zones.  @return Coordinate of fly zone center.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_coordinate_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_radius_inline",
                   "The radius of the fly zone in meters. If the fly zone is a truncated cone, then the radius is the bottom of the cone. Only used for GEO and NFZ fly zones.  @return A double value of the radius of the fly zone in meters.",
            ],
            [
                   "The radius of the fly zone in meters. If the fly zone is a truncated cone, then the radius is the bottom of the cone. Only used for GEO and NFZ fly zones.  @return A double value of the radius of the fly zone in meters.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_radius_inline",
                   "",
            ],
            [
                   "getShape",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_shape_inline",
                   "The shape of the fly zone. This shape is only used for GEO (always cylinder) and NFZ fly zones.  @return An enum value of `FlyZoneShape`.",
            ],
            [
                   "The shape of the fly zone. This shape is only used for GEO (always cylinder) and NFZ fly zones.  @return An enum value of `FlyZoneShape`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_shape_inline",
                   "",
            ],
            [
                   "getCategory",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_category_inline",
                   "The category of the fly zone.  @return An enum value of `FlyZoneCategory`.",
            ],
            [
                   "The category of the fly zone.  @return An enum value of `FlyZoneCategory`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_category_inline",
                   "",
            ],
            [
                   "getSubFlyZones",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_subFlyZones_inline",
                   "Information about the Sub fly zones. If empty, then the fly zone is a circle fly zone. If  populated, this fly zone is a Poly fly zone and the sub fly zone information will take  precedence over information in `FlyZoneInformation`. `FlyZoneInformation` should only be used for fly zone identifying information.  @return An array of `SubFlyZoneInformation` objects.",
            ],
            [
                   "Information about the Sub fly zones. If empty, then the fly zone is a circle fly zone. If  populated, this fly zone is a Poly fly zone and the sub fly zone information will take  precedence over information in `FlyZoneInformation`. `FlyZoneInformation` should only be used for fly zone identifying information.  @return An array of `SubFlyZoneInformation` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_subFlyZones_inline",
                   "",
            ],
            [
                   "setUnlockingEnabled",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_setUnlockingEnabled_inline",
                   "Disables the unlocked fly zones. This is useful if the aircraft is shared between users. It is not  supported by Inspire 1 series or Phantom 3 series. For the other products, it is supported  when `isCustomUnlockZoneSupported` is `true`.  @param enabled `true` to enable the unlocked fly zone. @param callback `completion callback` to receive the result.",
            ],
            [
                   "Disables the unlocked fly zones. This is useful if the aircraft is shared between users. It is not  supported by Inspire 1 series or Phantom 3 series. For the other products, it is supported  when `isCustomUnlockZoneSupported` is `true`.  @param enabled `true` to enable the unlocked fly zone. @param callback `completion callback` to receive the result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_setUnlockingEnabled_inline",
                   "",
            ],
            [
                   "getUnlockingEnabled",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_getUnlockingEnabled_inline",
                   "`true` if the unlocked fly zone is enabled. It is not supported by Inspire 1 series or Phantom 3  series. For the other products, it is supported when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "`true` if the unlocked fly zone is enabled. It is not supported by Inspire 1 series or Phantom 3  series. For the other products, it is supported when `isCustomUnlockZoneSupported` is `true`.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_getUnlockingEnabled_inline",
                   "",
            ],
            [
                   "getStartTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_startTime_inline",
                   "The timestamp of when the flight warning or flight restriction begins, formatted in UTC (yyyy-MM-dd HH:mm:ss). This is used for temporary flight  restrictions.  @return An instance of String.",
            ],
            [
                   "The timestamp of when the flight warning or flight restriction begins, formatted in UTC (yyyy-MM-dd HH:mm:ss). This is used for temporary flight  restrictions.  @return An instance of String.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_startTime_inline",
                   "",
            ],
            [
                   "getEndTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_endTime_inline",
                   "The timestamp of when the flight warning or flight restriction ends, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the flight warning or flight restriction ends.",
            ],
            [
                   "The timestamp of when the flight warning or flight restriction ends, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the flight warning or flight restriction ends.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_endTime_inline",
                   "",
            ],
            [
                   "getUnlockStartTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_unlockStartTime_inline",
                   "The timestamp when the fly zone is unlocked, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the fly zone is unlocked.",
            ],
            [
                   "The timestamp when the fly zone is unlocked, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the fly zone is unlocked.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_unlockStartTime_inline",
                   "",
            ],
            [
                   "getUnlockEndTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_unlockEndTime_inline",
                   "The timestamp the unlocked zone expires, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the unlocked zone expires.",
            ],
            [
                   "The timestamp the unlocked zone expires, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string instance of the timestamp when the unlocked zone expires.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_unlockEndTime_inline",
                   "",
            ],
            [
                   "FlyZoneType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_inline",
                   "There are three types of fly zones, NFZ, GEO and Poly.",
            ],
            [
                   "There are three types of fly zones, NFZ, GEO and Poly.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_inline",
                   "",
            ],
            [
                   "CIRCLE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Circle_inline",
                   "The circle fly zone is a cylinder or truncated cone volume (see `getShape`) with one of the four restriction levels (see `getCategory`). Some  restrictions can  be unlocked while others cannot. Some fly zones also have a 4km buffer around them where flight  height is restricted to 120m.",
            ],
            [
                   "The circle fly zone is a cylinder or truncated cone volume (see `getShape`) with one of the four restriction levels (see `getCategory`). Some  restrictions can  be unlocked while others cannot. Some fly zones also have a 4km buffer around them where flight  height is restricted to 120m.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Circle_inline",
                   "",
            ],
            [
                   "POLY",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Poly_inline",
                   "The Poly fly zone consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. A height limitation of 0m means flight is completely restricted. This is used by Mavic, Phantom 4 Pro, Inspire 2 and Phantom 4.",
            ],
            [
                   "The Poly fly zone consists of one or more sub fly zones that are cylinders or complex volumes with different height limitations. A height limitation of 0m means flight is completely restricted. This is used by Mavic, Phantom 4 Pro, Inspire 2 and Phantom 4.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Poly_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Unknown_inline",
                   "The fly zone is of unknown type.",
            ],
            [
                   "The fly zone is of unknown type.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_ZoneType_Unknown_inline",
                   "",
            ],
            [
                   "FlyZoneCategory",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_inline",
                   "An enum class represents the category of fly zone.",
            ],
            [
                   "An enum class represents the category of fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_inline",
                   "",
            ],
            [
                   "WARNING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_warning_inline",
                   "Warning zones do not restrict flight and are informational to alert the user. In a warning zone, users should be  prompted with a warning message describing the zone.",
            ],
            [
                   "Warning zones do not restrict flight and are informational to alert the user. In a warning zone, users should be  prompted with a warning message describing the zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_warning_inline",
                   "",
            ],
            [
                   "AUTHORIZATION",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_authorization_inline",
                   "Authorization zones restrict flight by default, but can be unlocked by a GEO authorized user.",
            ],
            [
                   "Authorization zones restrict flight by default, but can be unlocked by a GEO authorized user.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_authorization_inline",
                   "",
            ],
            [
                   "RESTRICTED",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_restricted_inline",
                   "Restricted zones restrict flight by default and cannot be unlocked by a GEO authorized user.  Users should contact flysafe@dji.com if they have authorization to fly in a restricted zone.",
            ],
            [
                   "Restricted zones restrict flight by default and cannot be unlocked by a GEO authorized user.  Users should contact flysafe@dji.com if they have authorization to fly in a restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_restricted_inline",
                   "",
            ],
            [
                   "ENHANCED_WARNING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_enhancedWarning_inline",
                   "Enhanced warning zones do not restrict flight but are highly recommended to be informational  to alert the user. In an enhanced warning zone, users should be prompted with a warning message  describing the zone.",
            ],
            [
                   "Enhanced warning zones do not restrict flight but are highly recommended to be informational  to alert the user. In an enhanced warning zone, users should be prompted with a warning message  describing the zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_enhancedWarning_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneCategory_unknown_inline",
                   "",
            ],
            [
                   "FlyZoneReason",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_inline",
                   "An enum class contains the reason for the fly zone.",
            ],
            [
                   "An enum class contains the reason for the fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_inline",
                   "",
            ],
            [
                   "AIRPORT",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_airport_inline",
                   "Airport that cannot be unlocked using GEO system.",
            ],
            [
                   "Airport that cannot be unlocked using GEO system.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_airport_inline",
                   "",
            ],
            [
                   "MILITARY",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_military_inline",
                   "Military authorized zone. This cannot be unlocked using the GEO system.",
            ],
            [
                   "Military authorized zone. This cannot be unlocked using the GEO system.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_military_inline",
                   "",
            ],
            [
                   "SPECIAL",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_special_inline",
                   "Special Zone. This cannot be unlocked using the GEO system.",
            ],
            [
                   "Special Zone. This cannot be unlocked using the GEO system.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_special_inline",
                   "",
            ],
            [
                   "COMMERCIAL_AIRPORTS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_commercialAirport_inline",
                   "Commercial airport.",
            ],
            [
                   "Commercial airport.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_commercialAirport_inline",
                   "",
            ],
            [
                   "PRIVATE_COMMERCIAL_AIRPORTS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_privateCommercialAirport_inline",
                   "Private commercial airport.",
            ],
            [
                   "Private commercial airport.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_privateCommercialAirport_inline",
                   "",
            ],
            [
                   "RECREATIONAL_AIRPORTS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_recreationalAirport_inline",
                   "Recreational airport.",
            ],
            [
                   "Recreational airport.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_recreationalAirport_inline",
                   "",
            ],
            [
                   "NATIONAL_PARKS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_nationalPark_inline",
                   "National park.",
            ],
            [
                   "National park.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_nationalPark_inline",
                   "",
            ],
            [
                   "NOAA",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_NOAA_inline",
                   "The National Oceanic and Atmospheric Administration.",
            ],
            [
                   "The National Oceanic and Atmospheric Administration.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_NOAA_inline",
                   "",
            ],
            [
                   "PARCEL",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_parcel_inline",
                   "Parcel.",
            ],
            [
                   "Parcel.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_parcel_inline",
                   "",
            ],
            [
                   "POWER_PLANT",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_powerPlant_inline",
                   "Power plant.",
            ],
            [
                   "Power plant.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_powerPlant_inline",
                   "",
            ],
            [
                   "PRISON",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_prison_inline",
                   "Prison.",
            ],
            [
                   "Prison.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_prison_inline",
                   "",
            ],
            [
                   "SCHOOL",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_school_inline",
                   "School.",
            ],
            [
                   "School.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_school_inline",
                   "",
            ],
            [
                   "STADIUM",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_stadium_inline",
                   "Stadium.",
            ],
            [
                   "Stadium.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_stadium_inline",
                   "",
            ],
            [
                   "PROHIBITED_SPECIAL_USE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_prohibitedSpecialUse_inline",
                   "Prohibited special use.",
            ],
            [
                   "Prohibited special use.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_prohibitedSpecialUse_inline",
                   "",
            ],
            [
                   "RESTRICTED_SPECIAL_USE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_restrictedSpecialUse_inline",
                   "Restriction special use.",
            ],
            [
                   "Restriction special use.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_restrictedSpecialUse_inline",
                   "",
            ],
            [
                   "TEMPORARY_FLIGHT_RESTRICTIONS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_temporaryFlightRestriction_inline",
                   "Temporary flight restriction.",
            ],
            [
                   "Temporary flight restriction.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_temporaryFlightRestriction_inline",
                   "",
            ],
            [
                   "CLASS_B_AIR_SPACE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classBAirSpace_inline",
                   "Class B controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
            ],
            [
                   "Class B controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classBAirSpace_inline",
                   "",
            ],
            [
                   "CLASS_C_AIR_SPACE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classCAirSpace_inline",
                   "Class C controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
            ],
            [
                   "Class C controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classCAirSpace_inline",
                   "",
            ],
            [
                   "CLASS_D_AIR_SPACE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classDAirSpace_inline",
                   "Class D controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
            ],
            [
                   "Class D controlled airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classDAirSpace_inline",
                   "",
            ],
            [
                   "CLASS_E_AIR_SPACE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classEAirSpace_inline",
                   "Class E Controlled Airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
            ],
            [
                   "Class E Controlled Airspace. See http://www.dji.com/flysafe/geo-system#notes for more information on the  controlled airspace (Class B, C, D, E) in the United States.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_classEAirSpace_inline",
                   "",
            ],
            [
                   "UNPAVED_AIRPORT",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_unpavedAirport_inline",
                   "Airport with unpaved runway.",
            ],
            [
                   "Airport with unpaved runway.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_unpavedAirport_inline",
                   "",
            ],
            [
                   "HELIPORT",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_heliport_inline",
                   "Heliport.",
            ],
            [
                   "Heliport.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_heliport_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_FlyZoneReason_unknown_inline",
                   "",
            ],
            [
                   "FlyZoneShape",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_inline",
                   "An enum class containing the shape of the fly zone.",
            ],
            [
                   "An enum class containing the shape of the fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_inline",
                   "",
            ],
            [
                   "CYLINDER",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_cylinder_inline",
                   "Cylinder.",
            ],
            [
                   "Cylinder.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_cylinder_inline",
                   "",
            ],
            [
                   "CONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_cone_inline",
                   "Truncated cone that has a smaller radius on the ground and larger radius in the air.",
            ],
            [
                   "Truncated cone that has a smaller radius on the ground and larger radius in the air.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_cone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneShape_unknown_inline",
                   "",
            ],
            [
                   "CLEAR",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_clear_inline",
                   "The aircraft is not within 200 meters of any warning, enhanced warning, authorization or restricted zone.",
            ],
            [
                   "The aircraft is not within 200 meters of any warning, enhanced warning, authorization or restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_clear_inline",
                   "",
            ],
            [
                   "NEAR_RESTRICTED_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_nearRestrictedZone_inline",
                   "The aircraft is within 200 meters of an authorization or restricted zone.",
            ],
            [
                   "The aircraft is within 200 meters of an authorization or restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_nearRestrictedZone_inline",
                   "",
            ],
            [
                   "IN_WARNING_ZONE_WITH_HEIGHT_LIMITATION",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_inWarningZoneWithHeightLimitation_inline",
                   "The aircraft is currently in a warning or enhanced warning zone and this place will  limit max flight height to 120m.",
            ],
            [
                   "The aircraft is currently in a warning or enhanced warning zone and this place will  limit max flight height to 120m.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_inWarningZoneWithHeightLimitation_inline",
                   "",
            ],
            [
                   "IN_WARNING_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_warningZone_inline",
                   "The aircraft is currently in a warning or enhanced warning zone.",
            ],
            [
                   "The aircraft is currently in a warning or enhanced warning zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_warningZone_inline",
                   "",
            ],
            [
                   "IN_RESTRICTED_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_restrictedZone_inline",
                   "The aircraft is currently in an authorization or restricted zone.",
            ],
            [
                   "The aircraft is currently in an authorization or restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_restrictedZone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneStatus_unknown_inline",
                   "",
            ],
            [
                   "SubFlyZoneInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "",
                   "This class contains information about a Sub fly zone.",
            ],
            [
                   "This class contains information about a Sub fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "",
                   "",
            ],
            [
                   "getAreaID",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_subAreaID_inline",
                   "The fly zone's identifier.  @return An int value of the sub area's ID.",
            ],
            [
                   "The fly zone's identifier.  @return An int value of the sub area's ID.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_subAreaID_inline",
                   "",
            ],
            [
                   "getShape",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_shape_inline",
                   "The shape of the sub-fly-zone.  @return An enum value of `SubFlyZoneShape`.",
            ],
            [
                   "The shape of the sub-fly-zone.  @return An enum value of `SubFlyZoneShape`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_shape_inline",
                   "",
            ],
            [
                   "getCenter",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_coordinate_inline",
                   "The location of the fly zone's center. Only used when `getShape` is `CYLINDER`.  @return A LocationCoordinate2D object.",
            ],
            [
                   "The location of the fly zone's center. Only used when `getShape` is `CYLINDER`.  @return A LocationCoordinate2D object.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_coordinate_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_radius_inline",
                   "The radius of the fly zone in meters. Only used when `getShape` is `CYLINDER`.  @return A double value of fly zone radius.",
            ],
            [
                   "The radius of the fly zone in meters. Only used when `getShape` is `CYLINDER`.  @return A double value of fly zone radius.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_radius_inline",
                   "",
            ],
            [
                   "getVertices",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_vertices_inline",
                   "The vertices (locations) that make up the sub fly zone polygon shape. Only used when `getShape` is `POLYGON`.  @return A List of CLLocationCoordinate2D object.",
            ],
            [
                   "The vertices (locations) that make up the sub fly zone polygon shape. Only used when `getShape` is `POLYGON`.  @return A List of CLLocationCoordinate2D object.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_vertices_inline",
                   "",
            ],
            [
                   "getMaxFlightHeight",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_maximumFlightHeight_inline",
                   "Maximum flight height in meters allowed in the sub fly zone. A height of 0m will restrict flight completely within the zone.  @return An int value of maximum flight height.",
            ],
            [
                   "Maximum flight height in meters allowed in the sub fly zone. A height of 0m will restrict flight completely within the zone.  @return An int value of maximum flight height.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJISubFlyZoneInformation_maximumFlightHeight_inline",
                   "",
            ],
            [
                   "SubFlyZoneShape",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_inline",
                   "This type of the geospatial information for the fly zone.",
            ],
            [
                   "This type of the geospatial information for the fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_inline",
                   "",
            ],
            [
                   "CYLINDER",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_circle_inline",
                   "Circle shape.",
            ],
            [
                   "Circle shape.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_circle_inline",
                   "",
            ],
            [
                   "POLYGON",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_polygon_inline",
                   "Polygon shape.",
            ],
            [
                   "Polygon shape.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_polygon_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJISubFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_DJISubFlyZoneShape_unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_flyForbidStatusUpdatedCallbackInterface.html",
                   "",
                   "An interface for obtaining `FlyForbidStatus`.",
            ],
            [
                   "An interface for obtaining `FlyForbidStatus`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_flyForbidStatusUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BasicDatabaseUpgradeProgressUpdatedCallback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_basicDatabaseUpgradeProgressUpdatedCallbackInterface.html",
                   "",
                   "An interface for obtaining basic database upgrade progress.",
            ],
            [
                   "An interface for obtaining basic database upgrade progress.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_basicDatabaseUpgradeProgressUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_flyForbidStatusUpdatedCallbackInterface.html",
                   "#DJIFlyZoneManager_UpdateFlyZoneStatus_inline",
                   "Called when the latest fly zone status is received.  @param state An enum value of `FlyZoneState`.",
            ],
            [
                   "Called when the latest fly zone status is received.  @param state An enum value of `FlyZoneState`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_flyForbidStatusUpdatedCallbackInterface.html",
                   "#DJIFlyZoneManager_UpdateFlyZoneStatus_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_basicDatabaseUpgradeProgressUpdatedCallbackInterface.html",
                   "#DJIFlyZoneManager_didUpdateBasicDatabaseUpgradeProgress_inline",
                   "Called when the basic database upgrade progress changes or an error occurs.  @param progress The upgrade progress of the basic database.",
            ],
            [
                   "Called when the basic database upgrade progress changes or an error occurs.  @param progress The upgrade progress of the basic database.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_basicDatabaseUpgradeProgressUpdatedCallbackInterface.html",
                   "#DJIFlyZoneManager_didUpdateBasicDatabaseUpgradeProgress_inline",
                   "",
            ],
            [
                   "CustomUnlockZone",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "",
                   "Users can unlock areas of a restricted fly zone through <http://www.dji.com/flysafe/custom-unlock>.  A user needs to show special authorization (usually from a third party such as a regulatory  or managing agency) as part of the process to unlock the area within the restricted fly zone.  Therefore each request is unique and customized to the individual. If the request is successful,  the unlocked area is tied to the user's account as an Custom Unlock Zone. This class contains the properties of an Custom Unlock Zone.",
            ],
            [
                   "Users can unlock areas of a restricted fly zone through <http://www.dji.com/flysafe/custom-unlock>.  A user needs to show special authorization (usually from a third party such as a regulatory  or managing agency) as part of the process to unlock the area within the restricted fly zone.  Therefore each request is unique and customized to the individual. If the request is successful,  the unlocked area is tied to the user's account as an Custom Unlock Zone. This class contains the properties of an Custom Unlock Zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "",
                   "",
            ],
            [
                   "getID",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_ID_inline",
                   "The unique ID of the Custom Unlock Zone.  @return An int value of the ID.",
            ],
            [
                   "The unique ID of the Custom Unlock Zone.  @return An int value of the ID.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_ID_inline",
                   "",
            ],
            [
                   "getUnlockZoneType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_type_inline",
                   "The type of custom unlocking.  @return An enum value of `UnlockZoneType`.",
            ],
            [
                   "The type of custom unlocking.  @return An enum value of `UnlockZoneType`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_type_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_name_inline",
                   "Name of the Custom Unlock Zone.  @return A string value of the name.",
            ],
            [
                   "Name of the Custom Unlock Zone.  @return A string value of the name.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_name_inline",
                   "",
            ],
            [
                   "getCenter",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_center_inline",
                   "The coordinate of the Custom Unlock Zone's center. Only used when `getUnlockZoneType`  is `CIRCLE_UNLOCK_AREA`.  @return A `LocationCoordinate2D` object.",
            ],
            [
                   "The coordinate of the Custom Unlock Zone's center. Only used when `getUnlockZoneType`  is `CIRCLE_UNLOCK_AREA`.  @return A `LocationCoordinate2D` object.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_center_inline",
                   "",
            ],
            [
                   "getRadius",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_radius_inline",
                   "The radius of the Custom Unlock Zone in meters. Valid when `getUnlockZoneType` is `CIRCLE_UNLOCK_AREA`.  @return A float value of the radius.",
            ],
            [
                   "The radius of the Custom Unlock Zone in meters. Valid when `getUnlockZoneType` is `CIRCLE_UNLOCK_AREA`.  @return A float value of the radius.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_radius_inline",
                   "",
            ],
            [
                   "getCountry",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_countryCode_inline",
                   "Check country code (https://www.iso.org/iso-3166-country-codes.html) for the custom unlock zone's shape.  Valid when `getUnlockZoneType` is `COUNTRY_UNLOCK`.  @return The string of country code.",
            ],
            [
                   "Check country code (https://www.iso.org/iso-3166-country-codes.html) for the custom unlock zone's shape.  Valid when `getUnlockZoneType` is `COUNTRY_UNLOCK`.  @return The string of country code.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_countryCode_inline",
                   "",
            ],
            [
                   "getHeight",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_maxFlightAltitude_inline",
                   "The unlocked max flight altitude limit in the custom unlock zone. Valid when `getUnlockZoneType`  is `HEIGHT_UNLOCK`.  @return An int value of max flight altitude.",
            ],
            [
                   "The unlocked max flight altitude limit in the custom unlock zone. Valid when `getUnlockZoneType`  is `HEIGHT_UNLOCK`.  @return An int value of max flight altitude.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_maxFlightAltitude_inline",
                   "",
            ],
            [
                   "getPoints",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_vertices_inline",
                   "The vertices (locations) that make up the custom unlock zone shape. Only used when `getUnlockZoneType` is `PENTAGON_UNLOCK`.  @return A list of `LocationCoordinate2D` objects.",
            ],
            [
                   "The vertices (locations) that make up the custom unlock zone shape. Only used when `getUnlockZoneType` is `PENTAGON_UNLOCK`.  @return A list of `LocationCoordinate2D` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_vertices_inline",
                   "",
            ],
            [
                   "getStartTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_startTime_inline",
                   "The timestamp of when the unlocking begins, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string value of start time.",
            ],
            [
                   "The timestamp of when the unlocking begins, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A string value of start time.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_startTime_inline",
                   "",
            ],
            [
                   "getEndTime",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_endTime_inline",
                   "The timestamp of when the unlocking ends, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A String value of the end time.",
            ],
            [
                   "The timestamp of when the unlocking ends, formatted in UTC (YYYY-MM-DD hh:mm:ss).  @return A String value of the end time.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_endTime_inline",
                   "",
            ],
            [
                   "isExpired",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_isExpired_inline",
                   "`true` if the Custom Unlock Zone has expired. After a zone is expired,  the location will be locked.  @return A boolean value to check if is expired.",
            ],
            [
                   "`true` if the Custom Unlock Zone has expired. After a zone is expired,  the location will be locked.  @return A boolean value to check if is expired.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJIIndividualUnlockZone_isExpired_inline",
                   "",
            ],
            [
                   "UnlockZoneType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_inline",
                   "An enum class represents the type of custom unlocking.",
            ],
            [
                   "An enum class represents the type of custom unlocking.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_inline",
                   "",
            ],
            [
                   "CIRCLE_UNLOCK_AREA",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Circle_inline",
                   "The custom unlock zone is a circle.",
            ],
            [
                   "The custom unlock zone is a circle.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Circle_inline",
                   "",
            ],
            [
                   "COUNTRY_UNLOCK",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Country_inline",
                   "The custom unlock zone is a country.",
            ],
            [
                   "The custom unlock zone is a country.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Country_inline",
                   "",
            ],
            [
                   "HEIGHT_UNLOCK",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_MaxFlightAltitudeLimit_inline",
                   "Unlock the max flight altitude limit in the custom unlock zone.",
            ],
            [
                   "Unlock the max flight altitude limit in the custom unlock zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_MaxFlightAltitudeLimit_inline",
                   "",
            ],
            [
                   "PENTAGON_UNLOCK",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Polygon_inline",
                   "The custom unlock zone is a polygon.",
            ],
            [
                   "The custom unlock zone is a polygon.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Polygon_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Unknown_inline",
                   "The custom unlock type is unknown.",
            ],
            [
                   "The custom unlock type is unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIIndividualUnlockZone.html",
                   "#DJIFlyZoneManager_DJICustomUnlockType_Unknown_inline",
                   "",
            ],
            [
                   "FlySafeWarningInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "",
                   "This class contains DJI flying safety warning information related to fly zones. The `event` indicates the reason. Use `description` method to get detail information.",
            ],
            [
                   "This class contains DJI flying safety warning information related to fly zones. The `event` indicates the reason. Use `description` method to get detail information.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "",
                   "",
            ],
            [
                   "getEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_event_inline",
                   "Returns the event of DJI flying safety warning.  @return An enum value of `FlySafeWarningEvent`.",
            ],
            [
                   "Returns the event of DJI flying safety warning.  @return An enum value of `FlySafeWarningEvent`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_event_inline",
                   "",
            ],
            [
                   "getHeightLimit",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_heightLimit_inline",
                   "Returns the height limit of current fly zone.  @return An int value of the height limit.",
            ],
            [
                   "Returns the height limit of current fly zone.  @return An int value of the height limit.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_heightLimit_inline",
                   "",
            ],
            [
                   "getFlyZoneInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_flyZoneInformation_inline",
                   "Returns information about the fly zones.  @return A list of `FlyZoneInformation` objects.",
            ],
            [
                   "Returns information about the fly zones.  @return A list of `FlyZoneInformation` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_flyZoneInformation_inline",
                   "",
            ],
            [
                   "getDescription",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_description_inline",
                   "Returns the description of fly zone warning information.  @return A String value.",
            ],
            [
                   "Returns the description of fly zone warning information.  @return A String value.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyWarningInformation_description_inline",
                   "",
            ],
            [
                   "FlySafeWarningEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_inline",
                   "DJI Fly Safe warning events of fly zones.",
            ],
            [
                   "DJI Fly Safe warning events of fly zones.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_IN_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeoffFailedInNoFlyZone_inline",
                   "The aircraft was unable to take off in the no-fly zone.",
            ],
            [
                   "The aircraft was unable to take off in the no-fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeoffFailedInNoFlyZone_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_IN_NO_FLY_ZONE_WITHOUT_GPS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInNoFlyZoneWithoutGps_inline",
                   "The mobile device is in the no-fly zone, and the GPS signal of the aircraft is not good enough to take off.",
            ],
            [
                   "The mobile device is in the no-fly zone, and the GPS signal of the aircraft is not good enough to take off.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInNoFlyZoneWithoutGps_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_WITHOUT_CUSTOM_UNLOCKING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedWithoutCustomUnlocking_inline",
                   "Cannot take off. You have not applied to fly in this zone.",
            ],
            [
                   "Cannot take off. You have not applied to fly in this zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedWithoutCustomUnlocking_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_IN_AUTHORIZED_AREA_WITHOUT_GPS_AND_UNLOCKING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZoneWithoutGpsAndUnlocking_inline",
                   "The mobile device is in the authorized area, and the GPS signal of the aircraft is not good, and it cannot take off before unlocking.",
            ],
            [
                   "The mobile device is in the authorized area, and the GPS signal of the aircraft is not good, and it cannot take off before unlocking.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZoneWithoutGpsAndUnlocking_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_IN_AUTHORIZED_ZONE_WITHOUT_UNLOCKING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZoneWithoutUnlocking_inline",
                   "The aircraft is not allowed to take off before being unlocked in the authorized area.",
            ],
            [
                   "The aircraft is not allowed to take off before being unlocked in the authorized area.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZoneWithoutUnlocking_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_IN_AUTHORIZED_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZone_inline",
                   "The aircraft is in the authorized area and you have obtained a flight certificate.",
            ],
            [
                   "The aircraft is in the authorized area and you have obtained a flight certificate.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInAuthorizedZone_inline",
                   "",
            ],
            [
                   "TAKE_OFF_IN_ENHANCED_WARNING_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffInEnhancedWarningZone_inline",
                   "The aircraft is in the enhanced warning zone, please pay attention to flight safety.",
            ],
            [
                   "The aircraft is in the enhanced warning zone, please pay attention to flight safety.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffInEnhancedWarningZone_inline",
                   "",
            ],
            [
                   "TAKE_OFF_NEAR_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffNearNoFlyZone_inline",
                   "There is a no-fly zone nearby and there are flight restrictions.",
            ],
            [
                   "There is a no-fly zone nearby and there are flight restrictions.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffNearNoFlyZone_inline",
                   "",
            ],
            [
                   "LIMITED_RESTRICTIONS_NEARBY",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_LimitedRestrictionsNearby_inline",
                   "There are limited restrictions in the nearby area.",
            ],
            [
                   "There are limited restrictions in the nearby area.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_LimitedRestrictionsNearby_inline",
                   "",
            ],
            [
                   "AUTHORIZED_ZONE_AND_RESTRICTIONS_NEARBY",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_AuthorizedZoneAndRestrictionsNearby_inline",
                   "There are authorized areas nearby and you have obtained a flight certificate.",
            ],
            [
                   "There are authorized areas nearby and you have obtained a flight certificate.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_AuthorizedZoneAndRestrictionsNearby_inline",
                   "",
            ],
            [
                   "RESTRICTIONS_IN_LIMITED_FLY_ZONE_NEARBY",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_RestrictionsInLimitedFlyZoneNearby_inline",
                   "There are flight restrictions in the nearby limited flight area.",
            ],
            [
                   "There are flight restrictions in the nearby limited flight area.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_RestrictionsInLimitedFlyZoneNearby_inline",
                   "",
            ],
            [
                   "IN_AUTHORIZATION_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_InAuthorizationZone_inline",
                   "The aircraft is in the authorized area and you have obtained a flight certificate.",
            ],
            [
                   "The aircraft is in the authorized area and you have obtained a flight certificate.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_InAuthorizationZone_inline",
                   "",
            ],
            [
                   "TAKE_OFF_FAILED_UNDER_LIMIT_AREA_WITH_GPS_ONCE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInNoFlyZoneWithWeakGps_inline",
                   "The mobile device is in the no-fly zone, and the GPS signal of the aircraft is not good enough to take off.",
            ],
            [
                   "The mobile device is in the no-fly zone, and the GPS signal of the aircraft is not good enough to take off.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_TakeOffFailedInNoFlyZoneWithWeakGps_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeWarningEvent_Unknown_inline",
                   "",
            ],
            [
                   "FlySafeSeriousWarningInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "",
                   "This class contains DJI flying safety serious warning information related to fly zones. The aircraft will  land when there is a serious warning. The `event` indicates the reason. Use `description` method to get  detail information.",
            ],
            [
                   "This class contains DJI flying safety serious warning information related to fly zones. The aircraft will  land when there is a serious warning. The `event` indicates the reason. Use `description` method to get  detail information.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "",
                   "",
            ],
            [
                   "getEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_event_inline",
                   "Returns the event of DJI flying safety serious warning.  @return Return an enum value of `FlySafeSeriousWarningEvent`.",
            ],
            [
                   "Returns the event of DJI flying safety serious warning.  @return Return an enum value of `FlySafeSeriousWarningEvent`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_event_inline",
                   "",
            ],
            [
                   "getHeightLimit",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_heightLimit_inline",
                   "Returns the height limit of current fly zone.  @return Return an int value of the height limit.",
            ],
            [
                   "Returns the height limit of current fly zone.  @return Return an int value of the height limit.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_heightLimit_inline",
                   "",
            ],
            [
                   "getCountdown",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_countDown_inline",
                   "Returns the countdown to start automatically landing.  @return Return an int value of count down.",
            ],
            [
                   "Returns the countdown to start automatically landing.  @return Return an int value of count down.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_countDown_inline",
                   "",
            ],
            [
                   "getFlyZoneInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_flyZoneInformation_inline",
                   "Returns information about the fly zones.  @return Return the list of `FlyZoneInformation` objects.",
            ],
            [
                   "Returns information about the fly zones.  @return Return the list of `FlyZoneInformation` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_flyZoneInformation_inline",
                   "",
            ],
            [
                   "getDescription",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_description_inline",
                   "Returns the description of fly zone warning information.  @return Return the String of the description.",
            ],
            [
                   "Returns the description of fly zone warning information.  @return Return the String of the description.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation_description_inline",
                   "",
            ],
            [
                   "FlySafeSeriousWarningEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_inline",
                   "Fly zone serious warning events.",
            ],
            [
                   "Fly zone serious warning events.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_inline",
                   "",
            ],
            [
                   "IN_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InNoFlyZone_inline",
                   "The aircraft is in the no-fly zone. After the countdown is over, it will force an automatic drop.  You will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
            ],
            [
                   "The aircraft is in the no-fly zone. After the countdown is over, it will force an automatic drop.  You will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InNoFlyZone_inline",
                   "",
            ],
            [
                   "IN_LIMIT_HEIGHT_AREA",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InHeightLimitZone_inline",
                   "The aircraft is in the height limit zone. After the countdown is over, it will automatically drop to the limit height,  you will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
            ],
            [
                   "The aircraft is in the height limit zone. After the countdown is over, it will automatically drop to the limit height,  you will not be able to control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InHeightLimitZone_inline",
                   "",
            ],
            [
                   "IN_AUTHORIZATION_ZONE_WITHOUT_UNLOCKING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InAuthorizationZoneWithoutUnlocking_inline",
                   "The aircraft is in the authorized zone. After the countdown is over, it will automatically drop and you will not be able to  control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
            ],
            [
                   "The aircraft is in the authorized zone. After the countdown is over, it will automatically drop and you will not be able to  control the throttle, but you can adjust the horizontal direction to avoid obstacles.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InAuthorizationZoneWithoutUnlocking_inline",
                   "",
            ],
            [
                   "IN_UNLOCKED_AUTHORIZATION_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InUnlockedAuthorizationZone_inline",
                   "The aircraft is in the authorized area and you have obtained a flight certificate. After the countdown is over, it will  automatically drop and you will not be able to control the throttle, Please confirm the fly limit zone and than open it.",
            ],
            [
                   "The aircraft is in the authorized area and you have obtained a flight certificate. After the countdown is over, it will  automatically drop and you will not be able to control the throttle, Please confirm the fly limit zone and than open it.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_InUnlockedAuthorizationZone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetySeriousWarningInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeSeriousWarningEvent_Unknown_inline",
                   "",
            ],
            [
                   "FlySafeTipInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "",
                   "This class contains DJI flying safety tip related to fly zones. The `event` indicates the reason. Use `description`  method to get detail information.",
            ],
            [
                   "This class contains DJI flying safety tip related to fly zones. The `event` indicates the reason. Use `description`  method to get detail information.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "",
                   "",
            ],
            [
                   "getEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_event_inline",
                   "Returns the event of DJI flying safety tip.  @return The enum value of `FlySafeTipEvent`.",
            ],
            [
                   "Returns the event of DJI flying safety tip.  @return The enum value of `FlySafeTipEvent`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_event_inline",
                   "",
            ],
            [
                   "getHeightLimit",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_heightLimit_inline",
                   "Returns the height limit of current fly zone.  @return An int value of the height limit.",
            ],
            [
                   "Returns the height limit of current fly zone.  @return An int value of the height limit.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_heightLimit_inline",
                   "",
            ],
            [
                   "getFlyZoneInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_flyZoneInformations_inline",
                   "Returns information about the fly zones.  @return Return the list of `FlyZoneInformation` objects.",
            ],
            [
                   "Returns information about the fly zones.  @return Return the list of `FlyZoneInformation` objects.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_flyZoneInformations_inline",
                   "",
            ],
            [
                   "getDescription",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_getDescription_inline",
                   "Returns the description of fly zone tip information.  @return The String of the description.",
            ],
            [
                   "Returns the description of fly zone tip information.  @return The String of the description.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTip_getDescription_inline",
                   "",
            ],
            [
                   "FlySafeTipEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_inline",
                   "DJI Flying safety tip.",
            ],
            [
                   "DJI Flying safety tip.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_inline",
                   "",
            ],
            [
                   "TAKE_OFF_IN_HEIGHT_LIMIT_ZONE_WITHOUT_GPS",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInHeightLimitZoneWithoutGps_inline",
                   "The aircraft is below the height limit zone and has no GPS signal, please pay attention to flight safety.",
            ],
            [
                   "The aircraft is below the height limit zone and has no GPS signal, please pay attention to flight safety.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInHeightLimitZoneWithoutGps_inline",
                   "",
            ],
            [
                   "TAKE_OFF_IN_HEIGHT_LIMIT_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInHeightLimitZone_inline",
                   "The aircraft is below the height limit zone, please pay attention to flight safety.",
            ],
            [
                   "The aircraft is below the height limit zone, please pay attention to flight safety.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInHeightLimitZone_inline",
                   "",
            ],
            [
                   "TAKE_OFF_IN_WARNING_AREA",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInWarningArea_inline",
                   "The aircraft is in the warning zone, please pay attention to flight safety.",
            ],
            [
                   "The aircraft is in the warning zone, please pay attention to flight safety.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TakeOffInWarningArea_inline",
                   "",
            ],
            [
                   "TOUCH_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TouchNoFlyZone_inline",
                   "The aircraft has touched the no-fly zone, please control the aircraft as far as possible.",
            ],
            [
                   "The aircraft has touched the no-fly zone, please control the aircraft as far as possible.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TouchNoFlyZone_inline",
                   "",
            ],
            [
                   "TOUCH_AUTHORIZATION_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TouchAuthorizationZone_inline",
                   "The aircraft has touched the authorized area, please control the aircraft as far as possible.",
            ],
            [
                   "The aircraft has touched the authorized area, please control the aircraft as far as possible.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_TouchAuthorizationZone_inline",
                   "",
            ],
            [
                   "REACH_MAXIMUM_FLIGHT_HEIGHT",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_ReachMaximumFlightHeight_inline",
                   "The aircraft has reached the maximum flight height in the height limit zone.",
            ],
            [
                   "The aircraft has reached the maximum flight height in the height limit zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_ReachMaximumFlightHeight_inline",
                   "",
            ],
            [
                   "RTH_AFFECTED_AT_BOUNDARY_OF_GEO_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_RTHAffectedAtBoundaryOfGEOZone_inline",
                   "Your aircraft is at the boundary of a GEO Zone, Return To Home may be affected. Please fly away with caution.",
            ],
            [
                   "Your aircraft is at the boundary of a GEO Zone, Return To Home may be affected. Please fly away with caution.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_RTHAffectedAtBoundaryOfGEOZone_inline",
                   "",
            ],
            [
                   "AT_BOUNDARY_OF_CUSTOM_UNLOCK_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_AtBoundaryOfCustomUnlockZone_inline",
                   "Your aircraft is at the boundary of an Custom Unlocking Zone.",
            ],
            [
                   "Your aircraft is at the boundary of an Custom Unlocking Zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_AtBoundaryOfCustomUnlockZone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyingSafetyTip.html",
                   "#DJIFlyZoneManager_DJIFlyingSafetyTipEvent_Unknown_inline",
                   "",
            ],
            [
                   "FlySafeReturnToHomeInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "",
                   "This class contains DJI flying safety notification related to returning to home. The `event` indicates the reason. Use `description` method to get detail information.",
            ],
            [
                   "This class contains DJI flying safety notification related to returning to home. The `event` indicates the reason. Use `description` method to get detail information.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "",
                   "",
            ],
            [
                   "getEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation_event_inline",
                   "Returns the event of DJI flying safety notification related to returning to home.  @return Get the enum value of `FlySafeReturnToHomeEvent`.",
            ],
            [
                   "Returns the event of DJI flying safety notification related to returning to home.  @return Get the enum value of `FlySafeReturnToHomeEvent`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation_event_inline",
                   "",
            ],
            [
                   "getDescription",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation_description_inline",
                   "Returns the description of fly zone return to home information.  @return Get the String value of the description.",
            ],
            [
                   "Returns the description of fly zone return to home information.  @return Get the String value of the description.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation_description_inline",
                   "",
            ],
            [
                   "FlySafeReturnToHomeEvent",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_inline",
                   "Fly zone ReturnToHome events. DJI Fly Safe notification when the aircraft returns to home.",
            ],
            [
                   "Fly zone ReturnToHome events. DJI Fly Safe notification when the aircraft returns to home.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_inline",
                   "",
            ],
            [
                   "NEAR_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_NearNoFlyZone_inline",
                   "Approaching a No-Fly Zone. Return to home may be affected. Fly with caution.",
            ],
            [
                   "Approaching a No-Fly Zone. Return to home may be affected. Fly with caution.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_NearNoFlyZone_inline",
                   "",
            ],
            [
                   "CROSS_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_CrossNoFlyZone_inline",
                   "Current Return to home route will pass a No-Fly zone. Pay attention to the aircraft's position  to avoid Return to home failure.",
            ],
            [
                   "Current Return to home route will pass a No-Fly zone. Pay attention to the aircraft's position  to avoid Return to home failure.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_CrossNoFlyZone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeReturnToHomeInformation.html",
                   "#DJIFlyZoneManager_DJIFlySafeReturnToHomeEvent_Unknown_inline",
                   "",
            ],
            [
                   "FlySafeNotification",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "",
                   "This class contains DJI flying safety notification. The `type` indicates the type of notification.  Check corresponding object for detail information.",
            ],
            [
                   "This class contains DJI flying safety notification. The `type` indicates the type of notification.  Check corresponding object for detail information.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "",
                   "",
            ],
            [
                   "getType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_type_inline",
                   "Returns the type of notification.  @return The enum value of `FlySafeNotificationType`.",
            ],
            [
                   "Returns the type of notification.  @return The enum value of `FlySafeNotificationType`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_type_inline",
                   "",
            ],
            [
                   "getNoticeInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_noticeInformation_inline",
                   "Returns the notice information.  @return The object of `FlySafeTipInformation`.",
            ],
            [
                   "Returns the notice information.  @return The object of `FlySafeTipInformation`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_noticeInformation_inline",
                   "",
            ],
            [
                   "getWarningInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_warningInformation_inline",
                   "Returns the warning information.  @return The object of `FlySafeWarningInformation`.",
            ],
            [
                   "Returns the warning information.  @return The object of `FlySafeWarningInformation`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_warningInformation_inline",
                   "",
            ],
            [
                   "getSeriousWarningInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_seriousWarningInformation_inline",
                   "Returns the serious warning information.  @return The object of `FlySafeSeriousWarningInformation`.",
            ],
            [
                   "Returns the serious warning information.  @return The object of `FlySafeSeriousWarningInformation`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_seriousWarningInformation_inline",
                   "",
            ],
            [
                   "getReturnToHomeInformation",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_returnToHomeInformation_inline",
                   "Returns the return to home information.  @return The object of `FlySafeReturnToHomeInformation`.",
            ],
            [
                   "Returns the return to home information.  @return The object of `FlySafeReturnToHomeInformation`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_returnToHomeInformation_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotificationCallbackInterface.html",
                   "",
                   "The Fly Safe Notification callback interface.",
            ],
            [
                   "The Fly Safe Notification callback interface.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotificationCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotificationCallbackInterface.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_onUpdateCallback_inline",
                   "Called when the latest fly safe notification is received.  @param notification An object value of `FlySafeNotification`.",
            ],
            [
                   "Called when the latest fly safe notification is received.  @param notification An object value of `FlySafeNotification`.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotificationCallbackInterface.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotification_onUpdateCallback_inline",
                   "",
            ],
            [
                   "FlySafeNotificationType",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_inline",
                   "DJI Fly Safe notification types.",
            ],
            [
                   "DJI Fly Safe notification types.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_inline",
                   "",
            ],
            [
                   "RETURN_TO_HOME",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_ReturnToHome_inline",
                   "DJI Fly Safe notification related to returning to home.",
            ],
            [
                   "DJI Fly Safe notification related to returning to home.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_ReturnToHome_inline",
                   "",
            ],
            [
                   "FLYING_SAFETY_TIP",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_FlyingSafetyTip_inline",
                   "DJI Fly Safe tip.",
            ],
            [
                   "DJI Fly Safe tip.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_FlyingSafetyTip_inline",
                   "",
            ],
            [
                   "WARNING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_Warning_inline",
                   "DJI Fly Safe warning notification.",
            ],
            [
                   "DJI Fly Safe warning notification.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_Warning_inline",
                   "",
            ],
            [
                   "SERIOUS_WARNING",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_SeriousWarning_inline",
                   "DJI Fly Safe serious warning notification.",
            ],
            [
                   "DJI Fly Safe serious warning notification.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_SeriousWarning_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_Unknown_inline",
                   "DJI Fly Safe unknown notification type.",
            ],
            [
                   "DJI Fly Safe unknown notification type.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlySafeNotification.html",
                   "#DJIFlyZoneManager_DJIFlySafeNotificationType_Unknown_inline",
                   "",
            ],
            [
                   "FlyZoneReturnToHomeState",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_inline",
                   "This enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
            ],
            [
                   "This enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_inline",
                   "",
            ],
            [
                   "RETURN_TO_HOME_STATE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_inline",
                   "SDK Key for FlyZoneReturnToHomeState: This enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
            ],
            [
                   "SDK Key for FlyZoneReturnToHomeState: This enum describes whether the aircraft's route when returning to home is clear of, near, or passes through a fly zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_inline",
                   "",
            ],
            [
                   "CLEAR",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_clear_inline",
                   "The aircraft's return to home route is clear of restricted areas.",
            ],
            [
                   "The aircraft's return to home route is clear of restricted areas.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_clear_inline",
                   "",
            ],
            [
                   "NEAR_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_nearNoFlyZone_inline",
                   "The aircraft's return to home route is near an authorization or restricted zone.",
            ],
            [
                   "The aircraft's return to home route is near an authorization or restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_nearNoFlyZone_inline",
                   "",
            ],
            [
                   "CROSS_NO_FLY_ZONE",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_crossNoFlyZone_inline",
                   "The aircraft's return to home route passes through an authorization or restricted zone.",
            ],
            [
                   "The aircraft's return to home route passes through an authorization or restricted zone.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_crossNoFlyZone_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/FlyZoneManager/DJIFlyZoneManager_DJIFlyZoneInformation.html",
                   "#DJIFlyZoneManager_DJIFlyZoneInformation_flyZoneReturnToHomeState_unknown_inline",
                   "",
            ],
            [
                   "hasReachedMaxFlightHeight",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightHeight_inline",
                   "`true` if the aircraft has reached the maximum flight height.  @return A boolean value.",
            ],
            [
                   "`true` if the aircraft has reached the maximum flight height.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightHeight_inline",
                   "",
            ],
            [
                   "HAS_REACHED_MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightHeight_inline",
                   "SDK Key for hasReachedMaxFlightHeight: `true` if the aircraft has reached the maximum flight height.  @return A boolean value.",
            ],
            [
                   "SDK Key for hasReachedMaxFlightHeight: `true` if the aircraft has reached the maximum flight height.  @return A boolean value.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightHeight_inline",
                   "",
            ],
            [
                   "hasReachedMaxFlightRadius",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightRadius_inline",
                   "`true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
            ],
            [
                   "`true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightRadius_inline",
                   "",
            ],
            [
                   "HAS_REACHED_MAX_FLIGHT_RADIUS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightRadius_inline",
                   "SDK Key for hasReachedMaxFlightRadius: `true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
            ],
            [
                   "SDK Key for hasReachedMaxFlightRadius: `true` if the aircraft has reached the maximum flight radius.  @return `true` if the aircraft has reached the maximum flight radius.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_hasReachedMaxFlightRadius_inline",
                   "",
            ],
            [
                   "setMaxFlightHeight",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightHeight_inline",
                   "Sets the maximum flight height limitation of the aircraft. The maxHeight</code> value must be in the  range [20, 500] m.  @param maxHeight Maximum height of the aircraft. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the maximum flight height limitation of the aircraft. The maxHeight</code> value must be in the  range [20, 500] m.  @param maxHeight Maximum height of the aircraft. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightHeight_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightHeight_inline",
                   "SDK Key for setMaxFlightHeight: Sets the maximum flight height limitation of the aircraft. The maxHeight</code> value must be in the  range [20, 500] m.  @param maxHeight Maximum height of the aircraft. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setMaxFlightHeight: Sets the maximum flight height limitation of the aircraft. The maxHeight</code> value must be in the  range [20, 500] m.  @param maxHeight Maximum height of the aircraft. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightHeight_inline",
                   "",
            ],
            [
                   "getMaxFlightHeight",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightHeight_inline",
                   "Gets the maximum flight height limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the maximum flight height limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightHeight_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightHeight_inline",
                   "SDK Key for getMaxFlightHeight: Gets the maximum flight height limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMaxFlightHeight: Gets the maximum flight height limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightHeight_inline",
                   "",
            ],
            [
                   "setMaxFlightRadius",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadius_inline",
                   "Sets the maximum flight radius limitation of the aircraft. The radius is calculated from the home point.  The maxRadius</code> value must be in the range [15, 8000] m.  @param maxRadius Maximum flight radius of the aircraft. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the maximum flight radius limitation of the aircraft. The radius is calculated from the home point.  The maxRadius</code> value must be in the range [15, 8000] m.  @param maxRadius Maximum flight radius of the aircraft. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadius_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadius_inline",
                   "SDK Key for setMaxFlightRadius: Sets the maximum flight radius limitation of the aircraft. The radius is calculated from the home point.  The maxRadius</code> value must be in the range [15, 8000] m.  @param maxRadius Maximum flight radius of the aircraft. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setMaxFlightRadius: Sets the maximum flight radius limitation of the aircraft. The radius is calculated from the home point.  The maxRadius</code> value must be in the range [15, 8000] m.  @param maxRadius Maximum flight radius of the aircraft. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadius_inline",
                   "",
            ],
            [
                   "getMaxFlightRadius",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadius_inline",
                   "Gets the maximum flight radius limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the maximum flight radius limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadius_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadius_inline",
                   "SDK Key for getMaxFlightRadius: Gets the maximum flight radius limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMaxFlightRadius: Gets the maximum flight radius limitation of the aircraft.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadius_inline",
                   "",
            ],
            [
                   "setMaxFlightRadiusLimitationEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadiusLimitationEnabled_inline",
                   "Sets whether the maximum flight radius limitation is enabled. If enabled is `false`,  there is no maximum flight radius limitation.  @param enabled Maximum flight radius limitation is enabled. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets whether the maximum flight radius limitation is enabled. If enabled is `false`,  there is no maximum flight radius limitation.  @param enabled Maximum flight radius limitation is enabled. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadiusLimitationEnabled_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadiusLimitationEnabled_inline",
                   "SDK Key for setMaxFlightRadiusLimitationEnabled: Sets whether the maximum flight radius limitation is enabled. If enabled is `false`,  there is no maximum flight radius limitation.  @param enabled Maximum flight radius limitation is enabled. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setMaxFlightRadiusLimitationEnabled: Sets whether the maximum flight radius limitation is enabled. If enabled is `false`,  there is no maximum flight radius limitation.  @param enabled Maximum flight radius limitation is enabled. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_setMaxFlightRadiusLimitationEnabled_inline",
                   "",
            ],
            [
                   "getMaxFlightRadiusLimitationEnabled",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadiusLimitationEnabled_inline",
                   "Gets the maximum flight radius limitation status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the maximum flight radius limitation status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadiusLimitationEnabled_inline",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS_ENABLED",
                   2,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadiusLimitationEnabled_inline",
                   "SDK Key for getMaxFlightRadiusLimitationEnabled: Gets the maximum flight radius limitation status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMaxFlightRadiusLimitationEnabled: Gets the maximum flight radius limitation status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/FlightController/DJIFlightController.html",
                   "#DJIFlightLimitation_getMaxFlightRadiusLimitationEnabled_inline",
                   "",
            ],
            [
                   "getCalibrationState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_calibrationState_inline",
                   "The status of the gravity's calibration.  @return An enum value of `GravityCenterCalibrationState`.",
            ],
            [
                   "The status of the gravity's calibration.  @return An enum value of `GravityCenterCalibrationState`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_calibrationState_inline",
                   "",
            ],
            [
                   "getCalibrationError",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_calibrationError_inline",
                   "Gets calibration errors. Returns `null` when gravity calibration is normal.  @return An instance of `DJIError`.",
            ],
            [
                   "Gets calibration errors. Returns `null` when gravity calibration is normal.  @return An instance of `DJIError`.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_calibrationError_inline",
                   "",
            ],
            [
                   "GravityCenterCalibrationState",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_inline",
                   "Enum for gravity calibration State.",
            ],
            [
                   "Enum for gravity calibration State.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_None_inline",
                   "The aircraft is not calibrating the gravity center.",
            ],
            [
                   "The aircraft is not calibrating the gravity center.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_None_inline",
                   "",
            ],
            [
                   "CALCULATING",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Calibrating_inline",
                   "The aircraft is calibrating the gravity center.",
            ],
            [
                   "The aircraft is calibrating the gravity center.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Calibrating_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Successful_inline",
                   "The aircraft calibrates the gravity center successfully.",
            ],
            [
                   "The aircraft calibrates the gravity center successfully.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Successful_inline",
                   "",
            ],
            [
                   "FAILED",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Failed_inline",
                   "The aircraft calibrates the gravity center failed.",
            ],
            [
                   "The aircraft calibrates the gravity center failed.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Failed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Unknown_inline",
                   "Unknown calibration status.",
            ],
            [
                   "Unknown calibration status.",
                   1,
                   "/Components/FlightController/DJIFlightController_DJIGravityCenterState.html",
                   "#DJIFlightController_DJIGravityCenterState_DJIGravityCenterCalibrationState_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/FlightHubManager/DJIFlightController_DJIGravityCenterStateInterfaceCallback.html",
                   "",
                   "Callback interface that updates the gravity calibration's current state data.",
            ],
            [
                   "Callback interface that updates the gravity calibration's current state data.",
                   1,
                   "/Components/FlightHubManager/DJIFlightController_DJIGravityCenterStateInterfaceCallback.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/FlightHubManager/DJIFlightController_DJIGravityCenterStateInterfaceCallback.html",
                   "#DJIFlightController_DJIGravityCenterOnUpdateCalibrationState_inline",
                   "Callback function that updates the gravity calibration's current state data.  @param state Current state of the gravity calibration.",
            ],
            [
                   "Callback function that updates the gravity calibration's current state data.  @param state Current state of the gravity calibration.",
                   1,
                   "/Components/FlightHubManager/DJIFlightController_DJIGravityCenterStateInterfaceCallback.html",
                   "#DJIFlightController_DJIGravityCenterOnUpdateCalibrationState_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_UpdateVisionControlStateCallbackInterface.html",
                   "",
                   "This protocol provides an interface to update the Intelligent Flight Assistant vision control state.",
            ],
            [
                   "This protocol provides an interface to update the Intelligent Flight Assistant vision control state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_UpdateVisionControlStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_UpdateVisionControlStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_UpdateVisionControlState_inline",
                   "Callback function that updates the aircraft state controlled by the intelligent flight assistant.  @param state The vision control state.",
            ],
            [
                   "Callback function that updates the aircraft state controlled by the intelligent flight assistant.  @param state The vision control state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_UpdateVisionControlStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_UpdateVisionControlState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionFaceAwareStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionFaceAwareState_inline",
                   "Callback function that updates the FaceAware state. When starting a PalmLaunch, the aircraft will  start FaceAware. If FaceAware activates successfully, the motors will start spinning and the  aircraft will hover after releasing it.  @param state The face sware state.",
            ],
            [
                   "Callback function that updates the FaceAware state. When starting a PalmLaunch, the aircraft will  start FaceAware. If FaceAware activates successfully, the motors will start spinning and the  aircraft will hover after releasing it.  @param state The face sware state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionFaceAwareStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionFaceAwareState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionPalmControlStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionPalmControlState_inline",
                   "Callback function that updates the palm control state.  @param state The palm control state.",
            ],
            [
                   "Callback function that updates the palm control state.  @param state The palm control state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionPalmControlStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionPalmControlState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionSmartCaptureStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionSmartCaptureState_inline",
                   "Callback function that updates the SmartCapture state. It is only supported by Mavic Air.  @param state The SmartCapture state.",
            ],
            [
                   "Callback function that updates the SmartCapture state. It is only supported by Mavic Air.  @param state The SmartCapture state.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant_updateVisionSmartCaptureStateCallbackInterface.html",
                   "#DJIIntelligentFlightAssistant_updateVisionSmartCaptureState_inline",
                   "",
            ],
            [
                   "isBraking",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isBraking_inline",
                   "`true` if the aircraft is braking automatically to avoid collision.  @return A boolean value.",
            ],
            [
                   "`true` if the aircraft is braking automatically to avoid collision.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isBraking_inline",
                   "",
            ],
            [
                   "IS_BRAKING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isBraking_inline",
                   "SDK Key for isBraking: `true` if the aircraft is braking automatically to avoid collision.  @return A boolean value.",
            ],
            [
                   "SDK Key for isBraking: `true` if the aircraft is braking automatically to avoid collision.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isBraking_inline",
                   "",
            ],
            [
                   "isAvoidingActiveObstacleCollision",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAvoidingActiveObstacleCollision_inline",
                   "`true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return A boolean value.",
            ],
            [
                   "`true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAvoidingActiveObstacleCollision_inline",
                   "",
            ],
            [
                   "IS_AVOIDING_ACTIVE_OBSTACLE_COLLISION",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAvoidingActiveObstacleCollision_inline",
                   "SDK Key for isAvoidingActiveObstacleCollision: `true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAvoidingActiveObstacleCollision: `true` if the aircraft is avoiding collision from an obstacle moving towards the aircraft.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAvoidingActiveObstacleCollision_inline",
                   "",
            ],
            [
                   "isAscentLimitedByObstacle",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAscentLimitedByObstacle_inline",
                   "YES if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return A boolean value.",
            ],
            [
                   "YES if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAscentLimitedByObstacle_inline",
                   "",
            ],
            [
                   "IS_ASCENT_LIMITED_BY_OBSTACLE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAscentLimitedByObstacle_inline",
                   "SDK Key for isAscentLimitedByObstacle: YES if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAscentLimitedByObstacle: YES if the aircraft will not ascend further because of an obstacle detected within 1m above it.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAscentLimitedByObstacle_inline",
                   "",
            ],
            [
                   "isPerformingPrecisionLanding",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isPerformingPrecisionLanding_inline",
                   "YES if the aircraft is landing precisely.  @return A boolean value.",
            ],
            [
                   "YES if the aircraft is landing precisely.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isPerformingPrecisionLanding_inline",
                   "",
            ],
            [
                   "IS_PERFORMING_PRECISION_LANDING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isPerformingPrecisionLanding_inline",
                   "SDK Key for isPerformingPrecisionLanding: YES if the aircraft is landing precisely.  @return A boolean value.",
            ],
            [
                   "SDK Key for isPerformingPrecisionLanding: YES if the aircraft is landing precisely.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isPerformingPrecisionLanding_inline",
                   "",
            ],
            [
                   "landingProtectionState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_landingProtectionStatus_inline",
                   "Gets the aircraft's landing protection state. This status is valid when landing protection is enabled.  @return An enum value of `VisionLandingProtectionState`,  which will show the state of landing protection.",
            ],
            [
                   "Gets the aircraft's landing protection state. This status is valid when landing protection is enabled.  @return An enum value of `VisionLandingProtectionState`,  which will show the state of landing protection.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_landingProtectionStatus_inline",
                   "",
            ],
            [
                   "LANDING_PROTECTION_STATE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_landingProtectionStatus_inline",
                   "SDK Key for landingProtectionState: Gets the aircraft's landing protection state. This status is valid when landing protection is enabled.  @return An enum value of `VisionLandingProtectionState`,  which will show the state of landing protection.",
            ],
            [
                   "SDK Key for landingProtectionState: Gets the aircraft's landing protection state. This status is valid when landing protection is enabled.  @return An enum value of `VisionLandingProtectionState`,  which will show the state of landing protection.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_landingProtectionStatus_inline",
                   "",
            ],
            [
                   "isAdvancedPilotAssistanceSystemActive",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAdvancedPilotAssistanceSystemActive_inline",
                   "`true` if Advanced Pilot Assistance System (APAS) is active. When it is active, the aircraft will change  flight path automatically to avoid obstacles.  @return A boolean value.",
            ],
            [
                   "`true` if Advanced Pilot Assistance System (APAS) is active. When it is active, the aircraft will change  flight path automatically to avoid obstacles.  @return A boolean value.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_isAdvancedPilotAssistanceSystemActive_inline",
                   "",
            ],
            [
                   "getSystemStatus",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_systemStatus_inline",
                   "The system status of SmartCapture.  @return An enum value of `SmartCaptureSystemStatus`.",
            ],
            [
                   "The system status of SmartCapture.  @return An enum value of `SmartCaptureSystemStatus`.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_systemStatus_inline",
                   "",
            ],
            [
                   "getAction",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_action_inline",
                   "The executing SmartCapture action.  @return An enum value of `SmartCaptureAction`.",
            ],
            [
                   "The executing SmartCapture action.  @return An enum value of `SmartCaptureAction`.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_action_inline",
                   "",
            ],
            [
                   "getFollowingMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_followingMode_inline",
                   "The following mode of SmartCapture.  @return An enum value of `SmartCaptureFollowingMode`.",
            ],
            [
                   "The following mode of SmartCapture.  @return An enum value of `SmartCaptureFollowingMode`.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_followingMode_inline",
                   "",
            ],
            [
                   "getPhotoCountdown",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_photoCountdown_inline",
                   "The countdown for shooting photo.  @return An int value of photo countdown.",
            ],
            [
                   "The countdown for shooting photo.  @return An int value of photo countdown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_photoCountdown_inline",
                   "",
            ],
            [
                   "getTargetRect",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_targetRect_inline",
                   "The dimension of the detected target. It is `CGRectNull` when the target is invalid.  @return The detected target's dimension.",
            ],
            [
                   "The dimension of the detected target. It is `CGRectNull` when the target is invalid.  @return The detected target's dimension.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_targetRect_inline",
                   "",
            ],
            [
                   "VisionLandingProtectionState",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_inline",
                   "Landing protection status returned by the downward vision sensor.",
            ],
            [
                   "Landing protection status returned by the downward vision sensor.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_inline",
                   "",
            ],
            [
                   "LANDING_PROTECTION_STATE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_inline",
                   "SDK Key for VisionLandingProtectionState: Landing protection status returned by the downward vision sensor.",
            ],
            [
                   "SDK Key for VisionLandingProtectionState: Landing protection status returned by the downward vision sensor.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_None_inline",
                   "The aircraft is not executing auto-landing or the downward vision sensor has not started to analyze the ground yet.",
            ],
            [
                   "The aircraft is not executing auto-landing or the downward vision sensor has not started to analyze the ground yet.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_None_inline",
                   "",
            ],
            [
                   "ANALYZING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_Analyzing_inline",
                   "The downward vision sensor is analyzing the ground at the landing zone.",
            ],
            [
                   "The downward vision sensor is analyzing the ground at the landing zone.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_Analyzing_inline",
                   "",
            ],
            [
                   "ANALYSIS_FAILED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_AnalysisFailed_inline",
                   "The downward vision sensor's analysis failed. Either the auto-landing can be attempted again, or the user needs  to land the aircraft manually.",
            ],
            [
                   "The downward vision sensor's analysis failed. Either the auto-landing can be attempted again, or the user needs  to land the aircraft manually.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_AnalysisFailed_inline",
                   "",
            ],
            [
                   "SAFE_TO_LAND",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_SafeToLand_inline",
                   "The ground is flat and the aircraft is safe to land automatically.",
            ],
            [
                   "The ground is flat and the aircraft is safe to land automatically.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_SafeToLand_inline",
                   "",
            ],
            [
                   "NOT_SAFE_TO_LAND",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_NotSafeToLand_inline",
                   "Landing area is not flat enough to be considered safe for landing. The aircraft should be moved to an area that  is more flat and an auto-land should be attempted again or the user should land the aircraft manually.",
            ],
            [
                   "Landing area is not flat enough to be considered safe for landing. The aircraft should be moved to an area that  is more flat and an auto-land should be attempted again or the user should land the aircraft manually.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_NotSafeToLand_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIVisionDetectionState_DJIVisionControlState.html",
                   "#DJIVisionDetectionState_DJIVisionControlState_DJIVisionLandingProtectionStatus_Unknown_inline",
                   "",
            ],
            [
                   "SmartCaptureSystemStatus",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_inline",
                   "The system status of SmartCapture.",
            ],
            [
                   "The system status of SmartCapture.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_inline",
                   "",
            ],
            [
                   "INITIALIZING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Initializing_inline",
                   "SmartCapture is initializing.",
            ],
            [
                   "SmartCapture is initializing.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Initializing_inline",
                   "",
            ],
            [
                   "NOT_FLYING_AND_FACE_AWARE_ACTIVATING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_NotFlyingAndFaceAwareActivating_inline",
                   "The aircraft is not flying and detecting a human face in front of the camera.",
            ],
            [
                   "The aircraft is not flying and detecting a human face in front of the camera.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_NotFlyingAndFaceAwareActivating_inline",
                   "",
            ],
            [
                   "NOT_FLYING_AND_FACE_AWARE_ACTIVATED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_NotFlyingAndFaceAwareActivated_inline",
                   "The aircraft is not flying and FaceAware has been activated. The aircraft will push the dimension of the target through `getTargetRect`  of `SmartCaptureState`.",
            ],
            [
                   "The aircraft is not flying and FaceAware has been activated. The aircraft will push the dimension of the target through `getTargetRect`  of `SmartCaptureState`.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_NotFlyingAndFaceAwareActivated_inline",
                   "",
            ],
            [
                   "GESTURE_LAUNCH",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_GestureLaunch_inline",
                   "GestureLaunch is recognized and the aircraft is taking off.",
            ],
            [
                   "GestureLaunch is recognized and the aircraft is taking off.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_GestureLaunch_inline",
                   "",
            ],
            [
                   "FLYING_AND_FACE_AWARE_ACTIVATING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_FlyingAndFaceAwareActivating_inline",
                   "The aircraft is flying and detecting human faces in front of the camera.",
            ],
            [
                   "The aircraft is flying and detecting human faces in front of the camera.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_FlyingAndFaceAwareActivating_inline",
                   "",
            ],
            [
                   "FLYING_AND_FACE_AWARE_ACTIVATED",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_FlyingAndFaceAwareActivated_inline",
                   "The aircraft is flying and detected one or more than one human faces in front of the camera.  One of the detected human can raise a hand to confirm the control. Then the SmartCapture  state will change to `FOLLOWING`.",
            ],
            [
                   "The aircraft is flying and detected one or more than one human faces in front of the camera.  One of the detected human can raise a hand to confirm the control. Then the SmartCapture  state will change to `FOLLOWING`.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_FlyingAndFaceAwareActivated_inline",
                   "",
            ],
            [
                   "FOLLOWING",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Following_inline",
                   "The aircraft is following the target but not SmartCapture action is recognized.",
            ],
            [
                   "The aircraft is following the target but not SmartCapture action is recognized.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Following_inline",
                   "",
            ],
            [
                   "PALM_CONTROL",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_PalmControl_inline",
                   "The aircraft is executing PalmControl (controlling the position or the distance).  See `getAction` of `SmartCaptureState` for more detail.",
            ],
            [
                   "The aircraft is executing PalmControl (controlling the position or the distance).  See `getAction` of `SmartCaptureState` for more detail.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_PalmControl_inline",
                   "",
            ],
            [
                   "CAMERA_CAPTURE_ACTION",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_CameraCaptureAction_inline",
                   "The aircraft is executing camera related action (e.g. shoot photos).  See `getAction` of `SmartCaptureState` for more detail.",
            ],
            [
                   "The aircraft is executing camera related action (e.g. shoot photos).  See `getAction` of `SmartCaptureState` for more detail.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_CameraCaptureAction_inline",
                   "",
            ],
            [
                   "GESTURE_LAND",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_GestureLand_inline",
                   "GestureLand is recognized and the aircraft is landing.",
            ],
            [
                   "GestureLand is recognized and the aircraft is landing.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_GestureLand_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureSystemStatus_Unknown_inline",
                   "",
            ],
            [
                   "SmartCaptureAction",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_inline",
                   "Different actions supported by SmartCapture.",
            ],
            [
                   "Different actions supported by SmartCapture.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_None_inline",
                   "No action is being executed.",
            ],
            [
                   "No action is being executed.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_None_inline",
                   "",
            ],
            [
                   "ADJUSTING_POSITION",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_AdjustingPosition_inline",
                   "The user is adjusting the aircraft's position. Move the palm up  or down slowly to control the aircraft's altitude. Move the arm  left or right to control the aircraft's orientation.",
            ],
            [
                   "The user is adjusting the aircraft's position. Move the palm up  or down slowly to control the aircraft's altitude. Move the arm  left or right to control the aircraft's orientation.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_AdjustingPosition_inline",
                   "",
            ],
            [
                   "ADJUSTING_DISTANCE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_AdjustingDistance_inline",
                   "The user is adjusting distance between the aircraft and the user.  Move two hands apart and the aircraft will fly away from the user.  The maximum distance is 19.7ft (6m). Move two hands together and  the aircraft will fly towards the user. The minimum distance is 6.6ft (2m).",
            ],
            [
                   "The user is adjusting distance between the aircraft and the user.  Move two hands apart and the aircraft will fly away from the user.  The maximum distance is 19.7ft (6m). Move two hands together and  the aircraft will fly towards the user. The minimum distance is 6.6ft (2m).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_AdjustingDistance_inline",
                   "",
            ],
            [
                   "SWITCHING_CONTROL",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_SwitchingControl_inline",
                   "The control of the aircraft is being switched from one person to the other.  The current user drops hand towards the floor. The Front LEDs will turn solid green. The person who would like to control the aircraft raise palm in front of the aircraft.  When the Front LEDs blinks green slowly, it indicates the control is switched successfully.",
            ],
            [
                   "The control of the aircraft is being switched from one person to the other.  The current user drops hand towards the floor. The Front LEDs will turn solid green. The person who would like to control the aircraft raise palm in front of the aircraft.  When the Front LEDs blinks green slowly, it indicates the control is switched successfully.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_SwitchingControl_inline",
                   "",
            ],
            [
                   "SHOOTING_PHOTO",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_ShootingPhoto_inline",
                   "The camera is shooting photos. Make a V gesture with one hand to trigger the action. Once the  gesture is recognized, two-second countdown will begin (`getPhotoCountdown`  of `SmartCaptureState`).",
            ],
            [
                   "The camera is shooting photos. Make a V gesture with one hand to trigger the action. Once the  gesture is recognized, two-second countdown will begin (`getPhotoCountdown`  of `SmartCaptureState`).",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_ShootingPhoto_inline",
                   "",
            ],
            [
                   "RECORDING_VIDEO",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_RecordingVideo_inline",
                   "The camera is recording video. To start this, make a frame gesture with fingers from both hands.  Once the gesture is recognized, the aircraft's front LEDs will turn off and the camera will start  recording. After five seconds, use the same gesture to stop the recording.",
            ],
            [
                   "The camera is recording video. To start this, make a frame gesture with fingers from both hands.  Once the gesture is recognized, the aircraft's front LEDs will turn off and the camera will start  recording. After five seconds, use the same gesture to stop the recording.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_RecordingVideo_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureAction_Unknown_inline",
                   "",
            ],
            [
                   "SmartCaptureFollowingMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_inline",
                   "Different following modes of SmartCapture.",
            ],
            [
                   "Different following modes of SmartCapture.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_inline",
                   "",
            ],
            [
                   "TRACE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Trace_inline",
                   "Aircraft follows the target at constant distance.",
            ],
            [
                   "Aircraft follows the target at constant distance.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Trace_inline",
                   "",
            ],
            [
                   "PROFILE",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Profile_inline",
                   "Aircraft follows the target at constant angle and distance from the side.",
            ],
            [
                   "Aircraft follows the target at constant angle and distance from the side.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Profile_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJISmartCaptureState.html",
                   "#DJISmartCaptureState_DJISmartCaptureFollowingMode_Unknown_inline",
                   "",
            ],
            [
                   "FillLightMode",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_inline",
                   "Modes for the fill light at the bottom or top of the aircraft.",
            ],
            [
                   "Modes for the fill light at the bottom or top of the aircraft.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Auto_inline",
                   "The auto mode. In this mode, the auxiliary light will be turned on automatically when the downward or top vision system is active but the environment is too dark.",
            ],
            [
                   "The auto mode. In this mode, the auxiliary light will be turned on automatically when the downward or top vision system is active but the environment is too dark.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Auto_inline",
                   "",
            ],
            [
                   "ON",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_On_inline",
                   "The auxiliary light is on.",
            ],
            [
                   "The auxiliary light is on.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_On_inline",
                   "",
            ],
            [
                   "OFF",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Off_inline",
                   "The auxiliary light is off.",
            ],
            [
                   "The auxiliary light is off.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Off_inline",
                   "",
            ],
            [
                   "BEACON",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Beacon_inline",
                   "Beacon mode. In this mode, the auxiliary light will have different behaviors in different conditions: - When the aircraft just takes off, the auxiliary  light will have the same behavior  as ''DJIFillLightMode_Auto''. - When the aircraft ascends above 5.5 meters, the auxiliary light starts to blink in  1Hz. - When the aircraft descends below 4.5 meters, the auxiliary light will have the same behavior as ''DJIFillLightMode_Auto''. This mode is only  supported by Mavic 2 Enterprise.",
            ],
            [
                   "Beacon mode. In this mode, the auxiliary light will have different behaviors in different conditions: - When the aircraft just takes off, the auxiliary  light will have the same behavior  as ''DJIFillLightMode_Auto''. - When the aircraft ascends above 5.5 meters, the auxiliary light starts to blink in  1Hz. - When the aircraft descends below 4.5 meters, the auxiliary light will have the same behavior as ''DJIFillLightMode_Auto''. This mode is only  supported by Mavic 2 Enterprise.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Beacon_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/IntelligentFlightAssistant/DJIIntelligentFlightAssistant.html",
                   "#DJIFillLightMode_Unknown_inline",
                   "",
            ],
            [
                   "setAccessLockerStateCallback",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setAccessLockerStateCallback_inline",
                   "Set Access Locker state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set Access Locker state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setAccessLockerStateCallback_inline",
                   "",
            ],
            [
                   "setFormattingStateCallback",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setFormattingStateCallback_inline",
                   "Set Formatting state update callback.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Set Formatting state update callback.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setFormattingStateCallback_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_state_inline",
                   "Gets the latest state of the Access Locker.  @return An enum value of `AccessLockerState`.",
            ],
            [
                   "Gets the latest state of the Access Locker.  @return An enum value of `AccessLockerState`.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_state_inline",
                   "",
            ],
            [
                   "getVersion",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_getVersion_inline",
                   "Gets the version of the security feature.  @param callback The execution callback with the value returned.",
            ],
            [
                   "Gets the version of the security feature.  @param callback The execution callback with the value returned.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_getVersion_inline",
                   "",
            ],
            [
                   "getUserAccount",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_getUsername_inline",
                   "Returns the username of the current Access Locker account.  @param callback The execution callback with the value returned.",
            ],
            [
                   "Returns the username of the current Access Locker account.  @param callback The execution callback with the value returned.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_getUsername_inline",
                   "",
            ],
            [
                   "setUpUserAccount",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setUpUserAccount_inline",
                   "Sets up a user account to enable the access protection of  the aircraft. After setting up a user account, the security  code of the user is required in each power-cycle of the  aircraft or the aircraft is just paired with the remote controller. The security code is also required to access  data in the aircraft through DJI Assistant 2. This method  is only valid when the state is `NOT_INITIALIZED`. If  the method executes successfully, the state will change to `UNLOCKED`.  @param userAccountInfo The user account information used for setting up the access protection of the aircraft. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets up a user account to enable the access protection of  the aircraft. After setting up a user account, the security  code of the user is required in each power-cycle of the  aircraft or the aircraft is just paired with the remote controller. The security code is also required to access  data in the aircraft through DJI Assistant 2. This method  is only valid when the state is `NOT_INITIALIZED`. If  the method executes successfully, the state will change to `UNLOCKED`.  @param userAccountInfo The user account information used for setting up the access protection of the aircraft. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_setUpUserAccount_inline",
                   "",
            ],
            [
                   "login",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_login_inline",
                   "Logs in to unlock the access protection of the aircraft.  This method is valid when the state is `LOCKED`.  If the user is logged in successfully, the state will change to `UNLOCKED`.  @param userAccountInfo The user account information used to unlock the protection. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Logs in to unlock the access protection of the aircraft.  This method is valid when the state is `LOCKED`.  If the user is logged in successfully, the state will change to `UNLOCKED`.  @param userAccountInfo The user account information used to unlock the protection. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_login_inline",
                   "",
            ],
            [
                   "modifyUserAccount",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_modifyUserAccount_inline",
                   "Modifies the user account. The old user account information will be overridden by the new one. This method is valid when the state is  either `UNLOCKED`  or `LOCKED`. If the user account is  modified, the aircraft will be unlocked and the state will change  to `UNLOCKED`.  @param currentUserAccountInfo Current user account info to be set to the Access Locker system. @param newUserAccountInfo New user account info to be set to the Access Locker system. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Modifies the user account. The old user account information will be overridden by the new one. This method is valid when the state is  either `UNLOCKED`  or `LOCKED`. If the user account is  modified, the aircraft will be unlocked and the state will change  to `UNLOCKED`.  @param currentUserAccountInfo Current user account info to be set to the Access Locker system. @param newUserAccountInfo New user account info to be set to the Access Locker system. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_modifyUserAccount_inline",
                   "",
            ],
            [
                   "resetUserAccount",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_resetUserAccount_inline",
                   "Resets the user account to disable the protection. The user account information (e.g.  user name, security code) will be deleted and the aircraft is accessible without  validating the user. This method is valid when the state is either `UNLOCKED`  or `LOCKED`. If the user account is reset, the state will change  to `NOT_INITIALIZED`.  @param userAccountInfo User account info to be set to the Access Locker system. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Resets the user account to disable the protection. The user account information (e.g.  user name, security code) will be deleted and the aircraft is accessible without  validating the user. This method is valid when the state is either `UNLOCKED`  or `LOCKED`. If the user account is reset, the state will change  to `NOT_INITIALIZED`.  @param userAccountInfo User account info to be set to the Access Locker system. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_resetUserAccount_inline",
                   "",
            ],
            [
                   "format",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_format_inline",
                   "Formats the protected data in the aircraft, including data in the internal storage and the user account information.  This method is only valid when the user account is set up. Use `FormattingState`  to check the progress of formatting.  When formatting is done, the state will change to `NOT_INITIALIZED`.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Formats the protected data in the aircraft, including data in the internal storage and the user account information.  This method is only valid when the user account is set up. Use `FormattingState`  to check the progress of formatting.  When formatting is done, the state will change to `NOT_INITIALIZED`.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_format_inline",
                   "",
            ],
            [
                   "FormattingState",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "",
                   "Formatting state of the access locker.",
            ],
            [
                   "Formatting state of the access locker.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "",
                   "",
            ],
            [
                   "getProgressState",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_progressState_inline",
                   "The progress state.  @return An enum value of the `FormattingProgressState`.",
            ],
            [
                   "The progress state.  @return An enum value of the `FormattingProgressState`.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_progressState_inline",
                   "",
            ],
            [
                   "getDJIDataLockerError",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_error_inline",
                   "Checks if the formatting operation is successfully completed. The  recent formatting operation failure if any. NULL if the recent formatting operation succeeded.  @return The possible error during the formatting process.",
            ],
            [
                   "Checks if the formatting operation is successfully completed. The  recent formatting operation failure if any. NULL if the recent formatting operation succeeded.  @return The possible error during the formatting process.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_error_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface.html",
                   "",
                   "Callback to update the `FormattingState`.",
            ],
            [
                   "Callback to update the `FormattingState`.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface_onUpdate_inline",
                   "Callback function that updates the FormattingState.  @param state An instance of FormattingState",
            ],
            [
                   "Callback function that updates the FormattingState.  @param state An instance of FormattingState",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingState_callbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "UserAccountInfo",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "",
                   "The class represents the user account information of the access locker.",
            ],
            [
                   "The class represents the user account information of the access locker.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "",
                   "",
            ],
            [
                   "UserAccountInfo",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_constructor_inline",
                   "Constructor method for the UserAccountInfo.  @param username The user account name. @param securityCode The security code of the user account.",
            ],
            [
                   "Constructor method for the UserAccountInfo.  @param username The user account name. @param securityCode The security code of the user account.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_constructor_inline",
                   "",
            ],
            [
                   "getUsername",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_username_inline",
                   "Gets the user name.  @return A string value.",
            ],
            [
                   "Gets the user name.  @return A string value.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_username_inline",
                   "",
            ],
            [
                   "getSecurityCode",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_securityCode_inline",
                   "Gets the security code of the account.  @return A string value.",
            ],
            [
                   "Gets the security code of the account.  @return A string value.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerUserAccountInfo.html",
                   "#DJIAccessLocker_DJIAccessLockerUserAccountInfo_securityCode_inline",
                   "",
            ],
            [
                   "AccessLockerState",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_inline",
                   "The aircraft's access locker state.",
            ],
            [
                   "The aircraft's access locker state.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_inline",
                   "",
            ],
            [
                   "NOT_INITIALIZED",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_NotInitialized_inline",
                   "The access locker is not initialized. Set up user account to initialize the system.",
            ],
            [
                   "The access locker is not initialized. Set up user account to initialize the system.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_NotInitialized_inline",
                   "",
            ],
            [
                   "LOCKED",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Locked_inline",
                   "The aircraft is locked and protected. In this state, the internal  storage cannot be accessed, the aircraft will stop streaming the  live view and the aircraft cannot take off. Use the Security Code  to unlock the aircraft.",
            ],
            [
                   "The aircraft is locked and protected. In this state, the internal  storage cannot be accessed, the aircraft will stop streaming the  live view and the aircraft cannot take off. Use the Security Code  to unlock the aircraft.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Locked_inline",
                   "",
            ],
            [
                   "UNLOCKED",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Unlocked_inline",
                   "The aircraft is unlocked.",
            ],
            [
                   "The aircraft is unlocked.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Unlocked_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Unknown_inline",
                   "Either the aircraft is disconnected or the connected product does not  support the access locker.",
            ],
            [
                   "Either the aircraft is disconnected or the connected product does not  support the access locker.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerState_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerState_CallbackInterface.html",
                   "",
                   "An interface for obtaining `AccessLockerState`.",
            ],
            [
                   "An interface for obtaining `AccessLockerState`.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerState_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerState_CallbackInterface.html",
                   "#DJIAccessLocker_DJIAccessLockerState_CallbackInterface_onUpdate_inline",
                   "Callback function that updates the access locker state.  @param state The access locker state. Use this state to check if security code is required to  unlock the aircraft.",
            ],
            [
                   "Callback function that updates the access locker state.  @param state The access locker state. Use this state to check if security code is required to  unlock the aircraft.",
                   1,
                   "/Components/Simulator/DJIAccessLocker_DJIAccessLockerState_CallbackInterface.html",
                   "#DJIAccessLocker_DJIAccessLockerState_CallbackInterface_onUpdate_inline",
                   "",
            ],
            [
                   "FormattingProgressState",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_inline",
                   "The aircraft's access locker formatting progress state.",
            ],
            [
                   "The aircraft's access locker formatting progress state.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Initial_inline",
                   "No formatting operation is executing or executed in this aircraft's power cycle.",
            ],
            [
                   "No formatting operation is executing or executed in this aircraft's power cycle.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Initial_inline",
                   "",
            ],
            [
                   "FORMATTING",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Formatting_inline",
                   "The aircraft's data is being formatted.",
            ],
            [
                   "The aircraft's data is being formatted.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Formatting_inline",
                   "",
            ],
            [
                   "SUCCESSFUL",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Successful_inline",
                   "The aircraft has formatted data in the internal storage and the user account set up for the security feature.",
            ],
            [
                   "The aircraft has formatted data in the internal storage and the user account set up for the security feature.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Successful_inline",
                   "",
            ],
            [
                   "FAILURE",
                   2,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Failure_inline",
                   "The formatting operation is failed. Check `FormattingState` for detail.",
            ],
            [
                   "The formatting operation is failed. Check `FormattingState` for detail.",
                   1,
                   "/Components/Simulator/DJIAccessLocker.html",
                   "#DJIAccessLocker_DJIAccessLockerFormattingProgressState_Failure_inline",
                   "",
            ],
            [
                   "setRadarPerceptionInformationCallback",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setRadarPerceptionInformationCallback_inline",
                   "Updates the radar perception information. Only supported by Matrice 300 RTK.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Updates the radar perception information. Only supported by Matrice 300 RTK.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setRadarPerceptionInformationCallback_inline",
                   "",
            ],
            [
                   "setUpwardRadarObstacleAvoidanceEnabled",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setUpwardRadarObstacleAvoidanceEnabled_inline",
                   "Sets upward radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enable the upward radar obstacle avoidance. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets upward radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enable the upward radar obstacle avoidance. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setUpwardRadarObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getUpwardRadarObstacleAvoidanceEnabled",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_getUpwardRadarObstacleAvoidanceEnabled_inline",
                   "Gets upward radar obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets upward radar obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_getUpwardRadarObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "setHorizontalRadarObstacleAvoidanceEnabled",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setHorizontalRadarObstacleAvoidanceEnabled_inline",
                   "Sets horizontal radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enabled the horizontal radar obstacle avoidance. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets horizontal radar obstacle avoidance status (enabled/disabled).  @param enabled `true` to enabled the horizontal radar obstacle avoidance. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_setHorizontalRadarObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "getHorizontalRadarObstacleAvoidanceEnabled",
                   2,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_getHorizontalRadarObstacleAvoidanceEnabled_inline",
                   "Gets upward horizontal obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets upward horizontal obstacle avoidance status (enabled/disabled).  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Radar/DJIRadar.html",
                   "#DJIRadar_getHorizontalRadarObstacleAvoidanceEnabled_inline",
                   "",
            ],
            [
                   "DJIPointCloudStatusListener",
                   2,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "",
                   "Defines the listeners of the point cloud status.",
            ],
            [
                   "Defines the listeners of the point cloud status.",
                   1,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "",
                   "",
            ],
            [
                   "onPointCloudRecordStatusChange",
                   2,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_RecordStatus_inline",
                   "When the point cloud record status is changed, the listener will receive this callback.  @param newStatus The new status",
            ],
            [
                   "When the point cloud record status is changed, the listener will receive this callback.  @param newStatus The new status",
                   1,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_RecordStatus_inline",
                   "",
            ],
            [
                   "onPointCloudRecordStatusRecordingTimeChange",
                   2,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_RecordStatus_RecordingTime_inline",
                   "When the point cloud recording time is updated, the listener will receive this callback.  @param newRecordingTime The latest recording time",
            ],
            [
                   "When the point cloud recording time is updated, the listener will receive this callback.  @param newRecordingTime The latest recording time",
                   1,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_RecordStatus_RecordingTime_inline",
                   "",
            ],
            [
                   "onIMUPreHeatStatusChange",
                   2,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_IMUPreHeatStatusChange_inline",
                   "When the IMU preheat status is changed, the listener will receive this callback.  @param status The IMU preheat status.",
            ],
            [
                   "When the IMU preheat status is changed, the listener will receive this callback.  @param status The IMU preheat status.",
                   1,
                   "/Components/Lidar/DJILidar_PointCloud_RecordStatus_ListenerInterface.html",
                   "#DJILidar_PointCloud_IMUPreHeatStatusChange_inline",
                   "",
            ],
            [
                   "DJIPointCloudLiveDataListener",
                   2,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "",
                   "Defines the listeners of the point cloud data.",
            ],
            [
                   "Defines the listeners of the point cloud data.",
                   1,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "",
                   "",
            ],
            [
                   "onReceiveLiveViewData",
                   2,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "#DJILidar_DJIPointCloudLiveDataListener_onReceiveLiveViewData_inline",
                   "Update point cloud live view data.  @param data The point could live view data @param length The length of the received live view data.",
            ],
            [
                   "Update point cloud live view data.  @param data The point could live view data @param length The length of the received live view data.",
                   1,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "#DJILidar_DJIPointCloudLiveDataListener_onReceiveLiveViewData_inline",
                   "",
            ],
            [
                   "onError",
                   2,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "#DJILidar_DJIPointCloudLiveDataListener_onError_inline",
                   "Listener the error status.  @param error The received DJI error code.",
            ],
            [
                   "Listener the error status.  @param error The received DJI error code.",
                   1,
                   "/Components/Lidar/DJILidar_DJIPointCloudLiveDataListener.html",
                   "#DJILidar_DJIPointCloudLiveDataListener_onError_inline",
                   "",
            ],
            [
                   "addPointCloudStatusListener",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_addPointCloudStatusListener_inline",
                   "Adds the listener for the point cloud status change events.  @param listener Point cloud status change listener.",
            ],
            [
                   "Adds the listener for the point cloud status change events.  @param listener Point cloud status change listener.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_addPointCloudStatusListener_inline",
                   "",
            ],
            [
                   "removePointCloudStatusListener",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removePointCloudStatusListener_inline",
                   "Remove the listener for the point cloud status change events.  @param listener Point cloud status change listener.",
            ],
            [
                   "Remove the listener for the point cloud status change events.  @param listener Point cloud status change listener.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removePointCloudStatusListener_inline",
                   "",
            ],
            [
                   "removeAllPointCloudStatusListener",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removeAllPointCloudStatusListener_inline",
                   "Remove all point cloud status listeners.",
            ],
            [
                   "Remove all point cloud status listeners.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removeAllPointCloudStatusListener_inline",
                   "",
            ],
            [
                   "addPointCloudLiveViewDataListener",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_addPointCloudLiveViewDataListener_inline",
                   "Adds the listener to receive point cloud data.  @param listener Point cloud data listener.",
            ],
            [
                   "Adds the listener to receive point cloud data.  @param listener Point cloud data listener.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_addPointCloudLiveViewDataListener_inline",
                   "",
            ],
            [
                   "removePointCloudLiveViewDataListener",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removePointCloudLiveViewDataListener_inline",
                   "Remove the listener to receive point cloud data.  @param listener Point cloud data update listener.",
            ],
            [
                   "Remove the listener to receive point cloud data.  @param listener Point cloud data update listener.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_removePointCloudLiveViewDataListener_inline",
                   "",
            ],
            [
                   "getDisPlayName",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_displayName_inline",
                   "Return string that represents name of the Lidar.  @return An instance of display name String.",
            ],
            [
                   "Return string that represents name of the Lidar.  @return An instance of display name String.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_displayName_inline",
                   "",
            ],
            [
                   "pointCloudRecord",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_pointCloudRecord_inline",
                   "Point cloud record related operations.  @param commandAction An enum value of the `DJILidarPointCloudRecord` @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Point cloud record related operations.  @param commandAction An enum value of the `DJILidarPointCloudRecord` @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_pointCloudRecord_inline",
                   "",
            ],
            [
                   "startReadPointCloudLiveViewData",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_startReadPointCloudLiveViewData_inline",
                   "Start to receive the point cloud live view data. Using `onReceiveLiveViewData` to receive the data.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Start to receive the point cloud live view data. Using `onReceiveLiveViewData` to receive the data.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_startReadPointCloudLiveViewData_inline",
                   "",
            ],
            [
                   "stopReadPointCloudLiveViewData",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_stopReadPointCloudLiveViewData_inline",
                   "Stop to receive the point cloud live view data.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Stop to receive the point cloud live view data.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_stopReadPointCloudLiveViewData_inline",
                   "",
            ],
            [
                   "IDJILidarLiveViewDataProcessor",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "",
                   "This processor is provided by DJI. We receive the `PointCloudLiveViewData` through `startReadPointCloudLiveViewData` interface, and then use `IDJILidarLiveViewDataProcessor` to optimize the algorithm so that the point cloud data can be displayed efficiently through DJILidarPointCloudView</code>. If you want to display with your own algorithm. You can use `PointCloudLiveViewData` to draw the point cloud live view data by yourself.",
            ],
            [
                   "This processor is provided by DJI. We receive the `PointCloudLiveViewData` through `startReadPointCloudLiveViewData` interface, and then use `IDJILidarLiveViewDataProcessor` to optimize the algorithm so that the point cloud data can be displayed efficiently through DJILidarPointCloudView</code>. If you want to display with your own algorithm. You can use `PointCloudLiveViewData` to draw the point cloud live view data by yourself.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "",
                   "",
            ],
            [
                   "bindView",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_bindView_inline",
                   "bind the view which is provided by DJI.  @param view The view to draw the point cloud live view data. Provided by DJI.",
            ],
            [
                   "bind the view which is provided by DJI.  @param view The view to draw the point cloud live view data. Provided by DJI.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_bindView_inline",
                   "",
            ],
            [
                   "addPointCloudLiveViewData",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_addPointCloudLiveViewData_inline",
                   "Add point cloud live view data to the processor.  @param data The point cloud live view data received form `onReceiveLiveViewData`.",
            ],
            [
                   "Add point cloud live view data to the processor.  @param data The point cloud live view data received form `onReceiveLiveViewData`.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_addPointCloudLiveViewData_inline",
                   "",
            ],
            [
                   "setPointCloudLiveViewDisplayMode",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_setPointCloudLiveViewDisplayMode_inline",
                   "Sets the point cloud live view display mode. We support two display modes:`FPV` and `OVERALL`.  @param mode Point cloud live view display mode",
            ],
            [
                   "Sets the point cloud live view display mode. We support two display modes:`FPV` and `OVERALL`.  @param mode Point cloud live view display mode",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_setPointCloudLiveViewDisplayMode_inline",
                   "",
            ],
            [
                   "setPointCloudLiveViewColorMode",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_setPointCloudLiveViewColorMode_inline",
                   "Sets the point cloud live view color mode.  @param colorMode Point cloud live view color mode",
            ],
            [
                   "Sets the point cloud live view color mode.  @param colorMode Point cloud live view color mode",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_setPointCloudLiveViewColorMode_inline",
                   "",
            ],
            [
                   "freshPointCloudLiveViewDataProcessedBuffers",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_freshPointCloudLiveViewDataProcessedBuffers_inline",
                   "Refresh the point cloud live view data. Only needed in `OVERALL` mode. Due to the large amount of data in this mode, we will process the live view data every 10 seconds. If you want to display the point cloud live view data in more real time, you can call this interface to update the buffer in real time.",
            ],
            [
                   "Refresh the point cloud live view data. Only needed in `OVERALL` mode. Due to the large amount of data in this mode, we will process the live view data every 10 seconds. If you want to display the point cloud live view data in more real time, you can call this interface to update the buffer in real time.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_freshPointCloudLiveViewDataProcessedBuffers_inline",
                   "",
            ],
            [
                   "clearPointCloudLiveViewDataProcessedBuffers",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_clearPointCloudLiveViewDataProcessedBuffers_inline",
                   "Clear the point cloud live view data.",
            ],
            [
                   "Clear the point cloud live view data.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_clearPointCloudLiveViewDataProcessedBuffers_inline",
                   "",
            ],
            [
                   "destroy",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_destroy_inline",
                   "Destory the processor. Called when exiting the view.",
            ],
            [
                   "Destory the processor. Called when exiting the view.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidarLiveViewDataProcessor_destroy_inline",
                   "",
            ],
            [
                   "setPointCloudScanMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudScanMode_inline",
                   "Set point cloud scan mode.  @param scanMode An enum value of the `DJILidarPointCloudScanMode` @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Set point cloud scan mode.  @param scanMode An enum value of the `DJILidarPointCloudScanMode` @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudScanMode_inline",
                   "",
            ],
            [
                   "getPointCloudScanMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudScanMode_inline",
                   "Get point cloud scan mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get point cloud scan mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudScanMode_inline",
                   "",
            ],
            [
                   "setPointCloudReturnMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudReturnMode_inline",
                   "Set point cloud return mode.  @param scanMode An enum value of the `DJILidarPointCloudReturnMode` @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Set point cloud return mode.  @param scanMode An enum value of the `DJILidarPointCloudReturnMode` @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudReturnMode_inline",
                   "",
            ],
            [
                   "getPointCloudReturnMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudReturnMode_inline",
                   "Get point cloud scan mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get point cloud scan mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudReturnMode_inline",
                   "",
            ],
            [
                   "setPointCloudHighSensitivityMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setHighSensitivityModeEnabled_inline",
                   "Enables/Disables high sensitivity mode. In severe weather conditions such as rain and fog, high sensitivity mode reduces the probability of false detection of atmospheric particles.  @param enabled `YES` to enable the high sensitivity mode. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Enables/Disables high sensitivity mode. In severe weather conditions such as rain and fog, high sensitivity mode reduces the probability of false detection of atmospheric particles.  @param enabled `YES` to enable the high sensitivity mode. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setHighSensitivityModeEnabled_inline",
                   "",
            ],
            [
                   "getPointCloudHighSensitivityMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getHighSensitivityModeEnabled_inline",
                   "`YES` if high sensitivity mode is enabled.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "`YES` if high sensitivity mode is enabled.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getHighSensitivityModeEnabled_inline",
                   "",
            ],
            [
                   "getCapabilities",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_capabilities_inline",
                   "Lidar capabilities. You can you this interface to get the sampling rate range.  @return An object of `Capabilities`.",
            ],
            [
                   "Lidar capabilities. You can you this interface to get the sampling rate range.  @return An object of `Capabilities`.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_capabilities_inline",
                   "",
            ],
            [
                   "setPointCloudSamplingRate",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudSamplingRate_inline",
                   "Set point cloud sampling rate. The sampling rate represents the number of effective acquisitions of the lidar per second, which can be intuitively understood as the number of point clouds generated in one second. The sampling rate range depend on the `DJILidarPointCloudReturnMode`. You can use `onLidarSamplingRateRangeChange`  to get the current support range when you change the point cloud return mode.  @param lidarDataSampleRate An enum value of the `DJILidarPointCloudSamplingRate` @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Set point cloud sampling rate. The sampling rate represents the number of effective acquisitions of the lidar per second, which can be intuitively understood as the number of point clouds generated in one second. The sampling rate range depend on the `DJILidarPointCloudReturnMode`. You can use `onLidarSamplingRateRangeChange`  to get the current support range when you change the point cloud return mode.  @param lidarDataSampleRate An enum value of the `DJILidarPointCloudSamplingRate` @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudSamplingRate_inline",
                   "",
            ],
            [
                   "getPointCloudSamplingRate",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudSamplingRate_inline",
                   "Get point cloud sampling rate.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get point cloud sampling rate.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudSamplingRate_inline",
                   "",
            ],
            [
                   "setPointCloudVisibleLightPixel",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudVisibleLightPixel_inline",
                   "Set superimposed visible light pixels for coloring the model  @param visibleLightPixelParam An enum value of the `DJILidar_PointCloudVisibleLightPixelMode`` @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Set superimposed visible light pixels for coloring the model  @param visibleLightPixelParam An enum value of the `DJILidar_PointCloudVisibleLightPixelMode`` @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_setPointCloudVisibleLightPixel_inline",
                   "",
            ],
            [
                   "getPointCloudVisibleLightPixelWithCompletion",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudVisibleLightPixel_inline",
                   "Get point cloud visible light pixel.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get point cloud visible light pixel.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_getPointCloudVisibleLightPixel_inline",
                   "",
            ],
            [
                   "Capabilities",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "",
                   "Some of the lidar's parameters have dynamic ranges. The `Capabilities` class allows you to query the valid range for a parameter. Type-casting is required to get the corresponding enumerator value for each range element.",
            ],
            [
                   "Some of the lidar's parameters have dynamic ranges. The `Capabilities` class allows you to query the valid range for a parameter. Type-casting is required to get the corresponding enumerator value for each range element.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "",
                   "",
            ],
            [
                   "dataSampleRates",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_PointCloudSamplingRateRange_inline",
                   "Returns the current valid range of sampling rate. Returns `null` if current lidar has no supported lidar data sample rate or the lidar is disconnected.  @return Array of `DJILidarPointCloudSamplingRate` elements. Each element represents one current supported lidar data sample rate.",
            ],
            [
                   "Returns the current valid range of sampling rate. Returns `null` if current lidar has no supported lidar data sample rate or the lidar is disconnected.  @return Array of `DJILidarPointCloudSamplingRate` elements. Each element represents one current supported lidar data sample rate.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_PointCloudSamplingRateRange_inline",
                   "",
            ],
            [
                   "DJILidarParametersListener",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarParametersListener_Interface.html",
                   "",
                   "Defines the listeners of the lidar parameters change.",
            ],
            [
                   "Defines the listeners of the lidar parameters change.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarParametersListener_Interface.html",
                   "",
                   "",
            ],
            [
                   "onLidarSamplingRateRangeChange",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_Listener_onLidarSamplingRateRangeChange_inline",
                   "When the lidar sampling rate range is changed, the listener will receive this callback.  @param newRange The new range",
            ],
            [
                   "When the lidar sampling rate range is changed, the listener will receive this callback.  @param newRange The new range",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_Listener_onLidarSamplingRateRangeChange_inline",
                   "",
            ],
            [
                   "addDJILidarParametersListener",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_addDJILidarParametersListener_inline",
                   "Adds the listener for lidar parameters change events.  @param listener Point cloud status change listener.",
            ],
            [
                   "Adds the listener for lidar parameters change events.  @param listener Point cloud status change listener.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_addDJILidarParametersListener_inline",
                   "",
            ],
            [
                   "removeDJILidarParametersListener",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_removeDJILidarParametersListener_inline",
                   "Remove the listener for lidar parameters change events.  @param listener Point cloud status change listener.",
            ],
            [
                   "Remove the listener for lidar parameters change events.  @param listener Point cloud status change listener.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_removeDJILidarParametersListener_inline",
                   "",
            ],
            [
                   "removeAllListener",
                   2,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_removeAllListener_inline",
                   "Remove all lidar parameters listeners.",
            ],
            [
                   "Remove all lidar parameters listeners.",
                   1,
                   "/Components/Lidar/DJILidar_DJILidarCapabilities.html",
                   "#DJILidar_DJILidarParameters_removeAllListener_inline",
                   "",
            ],
            [
                   "DJILidarIMUPreheatStatus",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_inline",
                   "Point cloud IMU preheat status define for lidar. When the preheating is complete, the status will change to complete.",
            ],
            [
                   "Point cloud IMU preheat status define for lidar. When the preheating is complete, the status will change to complete.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_inline",
                   "",
            ],
            [
                   "PREHEATING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_Preheating_inline",
                   "IMU is Preheating.",
            ],
            [
                   "IMU is Preheating.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_Preheating_inline",
                   "",
            ],
            [
                   "PREHEAT_COMPLETED",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_Preheat_Completed_inline",
                   "IMU preheat is Complete.",
            ],
            [
                   "IMU preheat is Complete.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_IMUPreheatStatus_Preheat_Completed_inline",
                   "",
            ],
            [
                   "RecordingStatus",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloud_RecordingStatus_inline",
                   "Point cloud record status define for point cloud.",
            ],
            [
                   "Point cloud record status define for point cloud.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloud_RecordingStatus_inline",
                   "",
            ],
            [
                   "STARTING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Starting_inline",
                   "Point cloud record is starting.",
            ],
            [
                   "Point cloud record is starting.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Starting_inline",
                   "",
            ],
            [
                   "STARTED",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Started_inline",
                   "Point cloud is recording.",
            ],
            [
                   "Point cloud is recording.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Started_inline",
                   "",
            ],
            [
                   "PAUSE",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Pause_inline",
                   "Point cloud record is paused.",
            ],
            [
                   "Point cloud record is paused.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Pause_inline",
                   "",
            ],
            [
                   "RESUME",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Resume_inline",
                   "Point cloud record is resumed.",
            ],
            [
                   "Point cloud record is resumed.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Resume_inline",
                   "",
            ],
            [
                   "STOPPED",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Stoped_inline",
                   "Point cloud record is stoped.",
            ],
            [
                   "Point cloud record is stoped.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordingStatus_Stoped_inline",
                   "",
            ],
            [
                   "DJILidarPointCloudRecord",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_inline",
                   "Point cloud record opration type define for point cloud. When you start point cloud recording on successfully, `RecordingStatus` will change to `STARTED`. You can use `onReceiveLiveViewData` to receive piont cloud live view data.",
            ],
            [
                   "Point cloud record opration type define for point cloud. When you start point cloud recording on successfully, `RecordingStatus` will change to `STARTED`. You can use `onReceiveLiveViewData` to receive piont cloud live view data.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_inline",
                   "",
            ],
            [
                   "START_POINT_CLOUD_RECORDING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Start_inline",
                   "Start point cloud recording.",
            ],
            [
                   "Start point cloud recording.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Start_inline",
                   "",
            ],
            [
                   "STOP_POINT_CLOUD_RECORDING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Stop_inline",
                   "Stop point cloud recording.",
            ],
            [
                   "Stop point cloud recording.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Stop_inline",
                   "",
            ],
            [
                   "PAUSE_POINT_CLOUD_RECORDING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Pause_inline",
                   "Pause point cloud recording.",
            ],
            [
                   "Pause point cloud recording.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Pause_inline",
                   "",
            ],
            [
                   "RESUME_POINT_CLOUD_RECORDING",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Resume_inline",
                   "Resume point cloud recording.",
            ],
            [
                   "Resume point cloud recording.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudRecordOperationType_Resume_inline",
                   "",
            ],
            [
                   "DJILidarPointCloudScanMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_inline",
                   "Enums represent the point cloud scan mode of lidar. Supports two scanning modes: traditional non-repetitive scan mode and repetitive line scan mode. Users can choose the appropriate scanning point cloud pattern according to their needs. The repetitive scan mode is a flat FOV(70.4 degree * 4.5 degree), and its scanning method is more similar to the traditional scanning lidar, which can obtain a more uniform and higher-precision scanning effect; The non-repetitive scan mode is a unique scanning method of livox, providing a complete near- circular FOV(70.4 degree *77.2 degree), which has better scanning static scanning effect and facade effect, and higher efficiency;",
            ],
            [
                   "Enums represent the point cloud scan mode of lidar. Supports two scanning modes: traditional non-repetitive scan mode and repetitive line scan mode. Users can choose the appropriate scanning point cloud pattern according to their needs. The repetitive scan mode is a flat FOV(70.4 degree * 4.5 degree), and its scanning method is more similar to the traditional scanning lidar, which can obtain a more uniform and higher-precision scanning effect; The non-repetitive scan mode is a unique scanning method of livox, providing a complete near- circular FOV(70.4 degree *77.2 degree), which has better scanning static scanning effect and facade effect, and higher efficiency;",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_inline",
                   "",
            ],
            [
                   "REPETITIVE",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_Repeeat_inline",
                   "Repetitive scan mode.",
            ],
            [
                   "Repetitive scan mode.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_Repeeat_inline",
                   "",
            ],
            [
                   "NON_REPETITIVE",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_Non_Repetitive_inline",
                   "Non-repetitive scan mode.",
            ],
            [
                   "Non-repetitive scan mode.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudScanMode_Non_Repetitive_inline",
                   "",
            ],
            [
                   "DJILidarPointCloudReturnMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_inline",
                   "Enums represent the point cloud return mode of lidar.",
            ],
            [
                   "Enums represent the point cloud return mode of lidar.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_inline",
                   "",
            ],
            [
                   "SINGLE_RETURN_FIRST",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Single_Return_First_inline",
                   "Single return first (default).",
            ],
            [
                   "Single return first (default).",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Single_Return_First_inline",
                   "",
            ],
            [
                   "SINGLE_RETURN_STRONGEST",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Single_Return_Strongest_inline",
                   "Single return strongest.",
            ],
            [
                   "Single return strongest.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Single_Return_Strongest_inline",
                   "",
            ],
            [
                   "DUAL_RETURN",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Double_Return_inline",
                   "Double return.",
            ],
            [
                   "Double return.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Double_Return_inline",
                   "",
            ],
            [
                   "TRIPLE_RETURN",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Triple_Return_inline",
                   "Triple return.",
            ],
            [
                   "Triple return.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudReturnMode_Triple_Return_inline",
                   "",
            ],
            [
                   "DJILidarPointCloudSamplingRate",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_inline",
                   "Enums represent the point cloud sampling rate of lidar.",
            ],
            [
                   "Enums represent the point cloud sampling rate of lidar.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_inline",
                   "",
            ],
            [
                   "RATE_240K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_240KHZ_inline",
                   "Sampling rate: 240KHZ",
            ],
            [
                   "Sampling rate: 240KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_240KHZ_inline",
                   "",
            ],
            [
                   "RATE_180K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_180KHZ_inline",
                   "Sampling rate: 180KHZ",
            ],
            [
                   "Sampling rate: 180KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_180KHZ_inline",
                   "",
            ],
            [
                   "RATE_160K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_160KHZ_inline",
                   "Sampling rate: 160KHZ",
            ],
            [
                   "Sampling rate: 160KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_160KHZ_inline",
                   "",
            ],
            [
                   "RATE_120K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_120KHZ_inline",
                   "Sampling rate: 120KHZ",
            ],
            [
                   "Sampling rate: 120KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_120KHZ_inline",
                   "",
            ],
            [
                   "RATE_80K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_80KHZ_inline",
                   "Sampling rate: 80KHZ",
            ],
            [
                   "Sampling rate: 80KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_80KHZ_inline",
                   "",
            ],
            [
                   "RATE_60K_HZ",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_60KHZ_inline",
                   "Sampling rate: 60KHZ",
            ],
            [
                   "Sampling rate: 60KHZ",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudSamplingRate_60KHZ_inline",
                   "",
            ],
            [
                   "DJILidarPointCloudVisibleLightPixelMode",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_inline",
                   "Enums represent the point visible light pixel mode of lidar.",
            ],
            [
                   "Enums represent the point visible light pixel mode of lidar.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_inline",
                   "",
            ],
            [
                   "VISIBLE_LIGHT_PIXEL_OFF",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOff_inline",
                   "Turn off superimposed visible light pixels.",
            ],
            [
                   "Turn off superimposed visible light pixels.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOff_inline",
                   "",
            ],
            [
                   "VISIBLE_LIGHT_PIXEL_ON_TIMED_SHOT_ON",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOnTimedShotOn_inline",
                   "Turn on superimposed visible light pixels. In this mode camera will take a photo every 3 seconds. It is recommended to use when flying aircraft manually.",
            ],
            [
                   "Turn on superimposed visible light pixels. In this mode camera will take a photo every 3 seconds. It is recommended to use when flying aircraft manually.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOnTimedShotOn_inline",
                   "",
            ],
            [
                   "VISIBLE_LIGHT_PIXEL_ON_TIMED_SHOT_OFF",
                   2,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOnTimedShotOff_inline",
                   "Turn on superimposed visible light pixels. In this mode camera will not take photo automatically. It is recommended to use in Waypoint Mission and set the photo interval to 3 seconds.",
            ],
            [
                   "Turn on superimposed visible light pixels. In this mode camera will not take photo automatically. It is recommended to use in Waypoint Mission and set the photo interval to 3 seconds.",
                   1,
                   "/Components/Lidar/DJILidar.html",
                   "#DJILidar_PointCloudVisibleLightPixelMode_PixelOnTimedShotOff_inline",
                   "",
            ],
            [
                   "PointCloudLiveViewData",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "",
                   "This class represent the piont cloud live view data.",
            ],
            [
                   "This class represent the piont cloud live view data.",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "",
                   "",
            ],
            [
                   "getX",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_x_inline",
                   "The X coordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system. The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
            ],
            [
                   "The X coordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system. The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_x_inline",
                   "",
            ],
            [
                   "getY",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_y_inline",
                   "The XYcoordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system.  The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
            ],
            [
                   "The XYcoordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system.  The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_y_inline",
                   "",
            ],
            [
                   "getZ",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_z_inline",
                   "The Z coordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system.  The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
            ],
            [
                   "The Z coordinate of the object position measured by the lidar, using the NED(North East Down) coordinate system.  The position of lidar when starting to record the point cloud is the origin of the coordinate system(0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_z_inline",
                   "",
            ],
            [
                   "getIntensity",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_intensity_inline",
                   "Intensity is a measurement index (collected for each point) that reflects the intensity of the lidar pulse echo generated at a certain point. This value is based in part on the reflectivity of the object swept by the lidar pulse.",
            ],
            [
                   "Intensity is a measurement index (collected for each point) that reflects the intensity of the lidar pulse echo generated at a certain point. This value is based in part on the reflectivity of the object swept by the lidar pulse.",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_intensity_inline",
                   "",
            ],
            [
                   "getRed",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_red_inline",
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
            ],
            [
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_red_inline",
                   "",
            ],
            [
                   "getGreen",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_green_inline",
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
            ],
            [
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_green_inline",
                   "",
            ],
            [
                   "getBlue",
                   2,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_blue_inline",
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
            ],
            [
                   "RGB data of the object measured by the lidar. If you set visible light pixel mode to `VISIBLE_LIGHT_PIXEL_OFF`, the Data will be (0, 0, 0).",
                   1,
                   "/Components/Lidar/DJILidar_pointCloudLiveViewData.html",
                   "#DJILidar_pointCloudLiveViewData_blue_inline",
                   "",
            ],
            [
                   "PointCloudDisplayMode",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_inline",
                   "Enums represent the point cloud live view display mode of lidar.",
            ],
            [
                   "Enums represent the point cloud live view display mode of lidar.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_inline",
                   "",
            ],
            [
                   "FPV",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_FPV_inline",
                   "Display the point cloud live view data by FPV mode. Only the point cloud live view data in the current FPV screen will be displayed.",
            ],
            [
                   "Display the point cloud live view data by FPV mode. Only the point cloud live view data in the current FPV screen will be displayed.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_FPV_inline",
                   "",
            ],
            [
                   "OVERALL",
                   2,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_OVERALL_inline",
                   "Display the point cloud live view data by overall mode. All point cloud live view data added to `IDJILidarLiveViewDataProcessor` through `addPointCloudLiveViewData` will be displayed.",
            ],
            [
                   "Display the point cloud live view data by overall mode. All point cloud live view data added to `IDJILidarLiveViewDataProcessor` through `addPointCloudLiveViewData` will be displayed.",
                   1,
                   "/Components/Lidar/DJILidarLiveViewDataProcessor.html",
                   "#DJILidar_PointCloudDisplayMode_OVERALL_inline",
                   "",
            ],
            [
                   "ResponseForGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_Constructor_inline",
                   "Constructor of the class.  @param requesterId Slave Remote Controller's identifier. @param isAgree true</code> if the master Remote Controller agrees to give the slave Remote Controller the right to control the gimbal.",
            ],
            [
                   "Constructor of the class.  @param requesterId Slave Remote Controller's identifier. @param isAgree true</code> if the master Remote Controller agrees to give the slave Remote Controller the right to control the gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_Constructor_inline",
                   "",
            ],
            [
                   "getRequesterId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_getRequesterId_inline",
                   "Get the slave Remote Controller's identifier.  @return The int value of the slave Remote Controller ID.",
            ],
            [
                   "Get the slave Remote Controller's identifier.  @return The int value of the slave Remote Controller ID.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_getRequesterId_inline",
                   "",
            ],
            [
                   "isAgree",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_isAgree_inline",
                   "true</code> if the master Remote Controller agrees to give the slave Remote Controller the right to control the gimbal.  @return Agree or disagree to control the gimbal.",
            ],
            [
                   "true</code> if the master Remote Controller agrees to give the slave Remote Controller the right to control the gimbal.  @return Agree or disagree to control the gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "#DJIRemoteController_ResponseForGimbalControl_isAgree_inline",
                   "",
            ],
            [
                   "getLeftStick",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_left_inline",
                   "Get left stick.  @return An instance of `Stick`.",
            ],
            [
                   "Get left stick.  @return An instance of `Stick`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_left_inline",
                   "",
            ],
            [
                   "LEFT_STICK_VALUE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_left_inline",
                   "SDK Key for getLeftStick: Get left stick.  @return An instance of `Stick`.",
            ],
            [
                   "SDK Key for getLeftStick: Get left stick.  @return An instance of `Stick`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_left_inline",
                   "",
            ],
            [
                   "getRightStick",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_right_inline",
                   "Get right stick.  @return An instance of `Stick`.",
            ],
            [
                   "Get right stick.  @return An instance of `Stick`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_right_inline",
                   "",
            ],
            [
                   "RIGHT_STICK_VALUE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_right_inline",
                   "SDK Key for getRightStick: Get right stick.  @return An instance of `Stick`.",
            ],
            [
                   "SDK Key for getRightStick: Get right stick.  @return An instance of `Stick`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_right_inline",
                   "",
            ],
            [
                   "getLeftDial",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_leftWheel_inline",
                   "Gimbal Dial's (upper left dial) value in the range of [-660,660], where 0 is untouched and positive is turned in the clockwise direction.  @return Gimbal dial value.",
            ],
            [
                   "Gimbal Dial's (upper left dial) value in the range of [-660,660], where 0 is untouched and positive is turned in the clockwise direction.  @return Gimbal dial value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_leftWheel_inline",
                   "",
            ],
            [
                   "getRightDial",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_rightWheel_inline",
                   "Current state of the Camera Settings Dial (upper right dial) on the Remote Controller.  @return An instance of `RightDial`.",
            ],
            [
                   "Current state of the Camera Settings Dial (upper right dial) on the Remote Controller.  @return An instance of `RightDial`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_rightWheel_inline",
                   "",
            ],
            [
                   "getTransformationSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_transformationSwitch_inline",
                   "Current state of the Transformation Switch on the Remote Controller.  @return An instance of `TransformationSwitch`.",
            ],
            [
                   "Current state of the Transformation Switch on the Remote Controller.  @return An instance of `TransformationSwitch`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_transformationSwitch_inline",
                   "",
            ],
            [
                   "TRANSFORMATION_SWITCH",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_transformationSwitch_inline",
                   "SDK Key for getTransformationSwitch: Current state of the Transformation Switch on the Remote Controller.  @return An instance of `TransformationSwitch`.",
            ],
            [
                   "SDK Key for getTransformationSwitch: Current state of the Transformation Switch on the Remote Controller.  @return An instance of `TransformationSwitch`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_transformationSwitch_inline",
                   "",
            ],
            [
                   "getFlightModeSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_flightModeSwitch_inline",
                   "Current position of the Flight Mode Switch on the Remote Controller.  @return An enum value of `FlightModeSwitch`",
            ],
            [
                   "Current position of the Flight Mode Switch on the Remote Controller.  @return An enum value of `FlightModeSwitch`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_flightModeSwitch_inline",
                   "",
            ],
            [
                   "FLIGHT_MODE_SWITCH_POSITION",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_flightModeSwitch_inline",
                   "SDK Key for getFlightModeSwitch: Current position of the Flight Mode Switch on the Remote Controller.  @return An enum value of `FlightModeSwitch`",
            ],
            [
                   "SDK Key for getFlightModeSwitch: Current position of the Flight Mode Switch on the Remote Controller.  @return An enum value of `FlightModeSwitch`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_flightModeSwitch_inline",
                   "",
            ],
            [
                   "getGoHomeButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_goHomeButton_inline",
                   "Current state of the Return To Home Button.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Return To Home Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_goHomeButton_inline",
                   "",
            ],
            [
                   "GO_HOME_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_goHomeButton_inline",
                   "SDK Key for getGoHomeButton: Current state of the Return To Home Button.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getGoHomeButton: Current state of the Return To Home Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_goHomeButton_inline",
                   "",
            ],
            [
                   "getRecordButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_recordButton_inline",
                   "Current state of the Video Recording Button.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Video Recording Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_recordButton_inline",
                   "",
            ],
            [
                   "RECORD_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_recordButton_inline",
                   "SDK Key for getRecordButton: Current state of the Video Recording Button.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getRecordButton: Current state of the Video Recording Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_recordButton_inline",
                   "",
            ],
            [
                   "getPhotoAndVideoToggleButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_photoAndVideoToggleButton_inline",
                   "Current state of the Photo and Video Toggle Button.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Photo and Video Toggle Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_photoAndVideoToggleButton_inline",
                   "",
            ],
            [
                   "getShootPhotoAndRecordButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shootPhotoAndRecordButton_inline",
                   "Current state of the Photo and Record Button.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Photo and Record Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shootPhotoAndRecordButton_inline",
                   "",
            ],
            [
                   "getShutterButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shutterButton_inline",
                   "Current state of the Shutter Button.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Shutter Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shutterButton_inline",
                   "",
            ],
            [
                   "SHUTTER_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shutterButton_inline",
                   "SDK Key for getShutterButton: Current state of the Shutter Button.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getShutterButton: Current state of the Shutter Button.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_shutterButton_inline",
                   "",
            ],
            [
                   "getPlaybackButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_playbackButton_inline",
                   "Current state of the Playback Button. The Playback Button is not supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Playback Button. The Playback Button is not supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_playbackButton_inline",
                   "",
            ],
            [
                   "PLAYBACK_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_playbackButton_inline",
                   "SDK Key for getPlaybackButton: Current state of the Playback Button. The Playback Button is not supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getPlaybackButton: Current state of the Playback Button. The Playback Button is not supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_playbackButton_inline",
                   "",
            ],
            [
                   "getPauseButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_pauseButton_inline",
                   "Current state of the Pause Button. The Pause button is only supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
            ],
            [
                   "Current state of the Pause Button. The Pause button is only supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_pauseButton_inline",
                   "",
            ],
            [
                   "PAUSE_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_pauseButton_inline",
                   "SDK Key for getPauseButton: Current state of the Pause Button. The Pause button is only supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getPauseButton: Current state of the Pause Button. The Pause button is only supported on Phantom 4 remote controllers.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_pauseButton_inline",
                   "",
            ],
            [
                   "getC1Button",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton1_inline",
                   "Current state of custom button 1 (left Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 1, we use Fn button instead, one click on Fn button represents custom button 1. It is not supported by remote controllers for Mavic Air or Spark.  @return An instance of `Button`.",
            ],
            [
                   "Current state of custom button 1 (left Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 1, we use Fn button instead, one click on Fn button represents custom button 1. It is not supported by remote controllers for Mavic Air or Spark.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton1_inline",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_1",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton1_inline",
                   "SDK Key for getC1Button: Current state of custom button 1 (left Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 1, we use Fn button instead, one click on Fn button represents custom button 1. It is not supported by remote controllers for Mavic Air or Spark.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getC1Button: Current state of custom button 1 (left Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 1, we use Fn button instead, one click on Fn button represents custom button 1. It is not supported by remote controllers for Mavic Air or Spark.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton1_inline",
                   "",
            ],
            [
                   "getC2Button",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton2_inline",
                   "Current state of custom button 2 (right Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 2, we use Fn button instead, double clicks on Fn button represents custom button 2.  @return An instance of `Button`.",
            ],
            [
                   "Current state of custom button 2 (right Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 2, we use Fn button instead, double clicks on Fn button represents custom button 2.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton2_inline",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_2",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton2_inline",
                   "SDK Key for getC2Button: Current state of custom button 2 (right Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 2, we use Fn button instead, double clicks on Fn button represents custom button 2.  @return An instance of `Button`.",
            ],
            [
                   "SDK Key for getC2Button: Current state of custom button 2 (right Back Button). For Mavic Air 2 and DJI Air 2S, There is no custom button 2, we use Fn button instead, double clicks on Fn button represents custom button 2.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton2_inline",
                   "",
            ],
            [
                   "getC3Button",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton3_inline",
                   "Current state of custom button 3 (right Front Button). It is only supported by DJI Smart Controller.  @return An instance of `Button`.",
            ],
            [
                   "Current state of custom button 3 (right Front Button). It is only supported by DJI Smart Controller.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_customButton3_inline",
                   "",
            ],
            [
                   "getFunctionButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fnButton_inline",
                   "Current state of fn button. It is only supported by remote controllers for Spark or Mavic Air.  @return An instance of `Button`.",
            ],
            [
                   "Current state of fn button. It is only supported by remote controllers for Spark or Mavic Air.  @return An instance of `Button`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fnButton_inline",
                   "",
            ],
            [
                   "getFiveDButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fiveDButton_inline",
                   "Current state of the 5D button. The button can be moved up, down, left and right and can be pressed. The 5D  button is supported by Mavic Pro and Mavic 2 remote controllers.  @return An instance of `FiveDButton`.",
            ],
            [
                   "Current state of the 5D button. The button can be moved up, down, left and right and can be pressed. The 5D  button is supported by Mavic Pro and Mavic 2 remote controllers.  @return An instance of `FiveDButton`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fiveDButton_inline",
                   "",
            ],
            [
                   "FIVE_D_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fiveDButton_inline",
                   "SDK Key for getFiveDButton: Current state of the 5D button. The button can be moved up, down, left and right and can be pressed. The 5D  button is supported by Mavic Pro and Mavic 2 remote controllers.  @return An instance of `FiveDButton`.",
            ],
            [
                   "SDK Key for getFiveDButton: Current state of the 5D button. The button can be moved up, down, left and right and can be pressed. The 5D  button is supported by Mavic Pro and Mavic 2 remote controllers.  @return An instance of `FiveDButton`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRCHardwareState_fiveDButton_inline",
                   "",
            ],
            [
                   "HardwareStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCHardwareStateUpdateCallbackInterface.html",
                   "",
                   "Callback function that updates the Remote Controller's  current hardware state.",
            ],
            [
                   "Callback function that updates the Remote Controller's  current hardware state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCHardwareStateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "RightDial",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "",
                   "Current state of the Camera Settings Dial (upper right dial on the Remote Controller).",
            ],
            [
                   "Current state of the Camera Settings Dial (upper right dial on the Remote Controller).",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "",
                   "",
            ],
            [
                   "TransformationSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "",
                   "Transformation Switch position. The Transformation Switch is around the Return To Home Button on Inspire,  Inspire 1 and M100 Remote Controllers, and controls the state of the aircraft's landing gear.",
            ],
            [
                   "Transformation Switch position. The Transformation Switch is around the Return To Home Button on Inspire,  Inspire 1 and M100 Remote Controllers, and controls the state of the aircraft's landing gear.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "",
                   "",
            ],
            [
                   "TRANSFORMATION_SWITCH",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "",
                   "SDK Key for TransformationSwitch: Transformation Switch position. The Transformation Switch is around the Return To Home Button on Inspire,  Inspire 1 and M100 Remote Controllers, and controls the state of the aircraft's landing gear.",
            ],
            [
                   "SDK Key for TransformationSwitch: Transformation Switch position. The Transformation Switch is around the Return To Home Button on Inspire,  Inspire 1 and M100 Remote Controllers, and controls the state of the aircraft's landing gear.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "",
                   "",
            ],
            [
                   "FlightModeSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPosition_inline",
                   "Remote Controller Flight Mode switch position.",
            ],
            [
                   "Remote Controller Flight Mode switch position.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPosition_inline",
                   "",
            ],
            [
                   "FLIGHT_MODE_SWITCH_POSITION",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPosition_inline",
                   "SDK Key for FlightModeSwitch: Remote Controller Flight Mode switch position.",
            ],
            [
                   "SDK Key for FlightModeSwitch: Remote Controller Flight Mode switch position.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPosition_inline",
                   "",
            ],
            [
                   "Button",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "",
                   "Remote Controller has numerous momentary push buttons, which will use this state.",
            ],
            [
                   "Remote Controller has numerous momentary push buttons, which will use this state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "",
                   "",
            ],
            [
                   "FiveDButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "",
                   "State of the 5D button on the remote controller. Vertical movement, horizontal movement and if it is pressed are  not exclusive.",
            ],
            [
                   "State of the 5D button on the remote controller. Vertical movement, horizontal movement and if it is pressed are  not exclusive.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "",
                   "",
            ],
            [
                   "FIVE_D_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "",
                   "SDK Key for FiveDButton: State of the 5D button on the remote controller. Vertical movement, horizontal movement and if it is pressed are  not exclusive.",
            ],
            [
                   "SDK Key for FiveDButton: State of the 5D button on the remote controller. Vertical movement, horizontal movement and if it is pressed are  not exclusive.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "",
                   "",
            ],
            [
                   "aircraftMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_aircraftMappingStyle_inline",
                   "The mapping style to which the Remote Controller is set.  @return An enum value of `AircraftMappingStyle`.",
            ],
            [
                   "The mapping style to which the Remote Controller is set.  @return An enum value of `AircraftMappingStyle`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_aircraftMappingStyle_inline",
                   "",
            ],
            [
                   "leftVertical",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_leftVertical_inline",
                   "The mapping configuration for the left stick on the vertical axis.  @return An instance of `AircraftStickMapping`.",
            ],
            [
                   "The mapping configuration for the left stick on the vertical axis.  @return An instance of `AircraftStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_leftVertical_inline",
                   "",
            ],
            [
                   "leftHorizontal",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_leftHorizontal_inline",
                   "The mapping configuration for the left stick on the horizontal axis.  @return An instance of `AircraftStickMapping`.",
            ],
            [
                   "The mapping configuration for the left stick on the horizontal axis.  @return An instance of `AircraftStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_leftHorizontal_inline",
                   "",
            ],
            [
                   "rightVertical",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_rightVertical_inline",
                   "The mapping configuration for the right stick on the vertical axis.  @return An instance of `AircraftStickMapping`.",
            ],
            [
                   "The mapping configuration for the right stick on the vertical axis.  @return An instance of `AircraftStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_rightVertical_inline",
                   "",
            ],
            [
                   "rightHorizontal",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_rightHorizontal_inline",
                   "The mapping configuration for the right stick on the horizontal axis.  @return An instance of `AircraftStickMapping`.",
            ],
            [
                   "The mapping configuration for the right stick on the horizontal axis.  @return An instance of `AircraftStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_rightHorizontal_inline",
                   "",
            ],
            [
                   "AircraftMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_constructor1_inline",
                   "Constructor with a defined mapping style.  @param style The `AircraftMappingStyle` object.",
            ],
            [
                   "Constructor with a defined mapping style.  @param style The `AircraftMappingStyle` object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_constructor1_inline",
                   "",
            ],
            [
                   "AircraftMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_constructor2_inline",
                   "Constructor with defined mappings.  @param leftVertical The `AircraftMappingStyle` object. @param leftHorizontal The `AircraftMappingStyle` object. @param rightVertical The `AircraftMappingStyle` object. @param rightHorizontal The `AircraftMappingStyle` object.",
            ],
            [
                   "Constructor with defined mappings.  @param leftVertical The `AircraftMappingStyle` object. @param leftHorizontal The `AircraftMappingStyle` object. @param rightVertical The `AircraftMappingStyle` object. @param rightHorizontal The `AircraftMappingStyle` object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMapping_constructor2_inline",
                   "",
            ],
            [
                   "AircraftStickMappingTarget",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_inline",
                   "The list of controls that may be mapped on a stick.",
            ],
            [
                   "The list of controls that may be mapped on a stick.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_None_inline",
                   "None",
            ],
            [
                   "None",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_None_inline",
                   "",
            ],
            [
                   "THROTTLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Throttle_inline",
                   "Controls Throttle",
            ],
            [
                   "Controls Throttle",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Throttle_inline",
                   "",
            ],
            [
                   "PITCH",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Pitch_inline",
                   "Controls Pitch",
            ],
            [
                   "Controls Pitch",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Pitch_inline",
                   "",
            ],
            [
                   "ROLL",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Roll_inline",
                   "Controls Roll",
            ],
            [
                   "Controls Roll",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Roll_inline",
                   "",
            ],
            [
                   "YAW",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Yaw_inline",
                   "Controls Yaw",
            ],
            [
                   "Controls Yaw",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMappingTarget_Yaw_inline",
                   "",
            ],
            [
                   "AircraftStickMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "",
                   "A struct representing a mapping configuration which includes the particular control and whether or not it is reversed.",
            ],
            [
                   "A struct representing a mapping configuration which includes the particular control and whether or not it is reversed.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "",
                   "",
            ],
            [
                   "getMappingTarget",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMapping_target_inline",
                   "The defined control to be mapped.  @return An enum value of `AircraftStickMappingTarget`",
            ],
            [
                   "The defined control to be mapped.  @return An enum value of `AircraftStickMappingTarget`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMapping_target_inline",
                   "",
            ],
            [
                   "isReversed",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMapping_isReversed_inline",
                   "whether or not the control is to be reversed.  @return A boolean value.",
            ],
            [
                   "whether or not the control is to be reversed.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftStickMapping.html",
                   "#DJIRemoteController_DJIRCAircraftStickMapping_isReversed_inline",
                   "",
            ],
            [
                   "AircraftMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_inline",
                   "The predefined mapping styles available to use. Custom allow to specify all mapping configurations.",
            ],
            [
                   "The predefined mapping styles available to use. Custom allow to specify all mapping configurations.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_inline",
                   "",
            ],
            [
                   "AIRCRAFT_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_inline",
                   "SDK Key for AircraftMappingStyle: The predefined mapping styles available to use. Custom allow to specify all mapping configurations.",
            ],
            [
                   "SDK Key for AircraftMappingStyle: The predefined mapping styles available to use. Custom allow to specify all mapping configurations.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_inline",
                   "",
            ],
            [
                   "STYLE_1",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_1_inline",
                   "Style 1.(Japanese Mode)",
            ],
            [
                   "Style 1.(Japanese Mode)",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_1_inline",
                   "",
            ],
            [
                   "STYLE_2",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_2_inline",
                   "Style 2.(American Mode)",
            ],
            [
                   "Style 2.(American Mode)",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_2_inline",
                   "",
            ],
            [
                   "STYLE_3",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_3_inline",
                   "Style 3.(Chinese Mode)",
            ],
            [
                   "Style 3.(Chinese Mode)",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_3_inline",
                   "",
            ],
            [
                   "STYLE_CUSTOM",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_Custom_inline",
                   "Custom Style. Requires all mapping configurations.",
            ],
            [
                   "Custom Style. Requires all mapping configurations.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_Custom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_Unknown_inline",
                   "Unknown style.",
            ],
            [
                   "Unknown style.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "#DJIRemoteController_DJIRCAircraftMappingStyle_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "",
                   "Callback function that updates the Remote Controller's current battery state.",
            ],
            [
                   "Callback function that updates the Remote Controller's current battery state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "RemoteControllerKey.BATTERY_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "",
                   "SDK Key for Callback: Callback function that updates the Remote Controller's current battery state.",
            ],
            [
                   "SDK Key for Callback: Callback function that updates the Remote Controller's current battery state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "getRemainingChargeInmAh",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_remainingEnergyInMAh_inline",
                   "The remaining power in the Remote Controller's battery in milliamp hours (mAh).  @return An int value.",
            ],
            [
                   "The remaining power in the Remote Controller's battery in milliamp hours (mAh).  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_remainingEnergyInMAh_inline",
                   "",
            ],
            [
                   "getRemainingChargeInPercent",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_remainingEnergyInPercent_inline",
                   "The remaining power in the Remote Controller's battery as a percentage in the range of [0, 100].  @return An int value.",
            ],
            [
                   "The remaining power in the Remote Controller's battery as a percentage in the range of [0, 100].  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_remainingEnergyInPercent_inline",
                   "",
            ],
            [
                   "isCharging",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_isCharging_inline",
                   "Whether battery of remote controller is charging. The battery may be fully charged when it returns false.  @return An int value.",
            ],
            [
                   "Whether battery of remote controller is charging. The battery may be fully charged when it returns false.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "#DJIRemoteController_DJIRCBatteryInfo_isCharging_inline",
                   "",
            ],
            [
                   "getTime",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_time_inline",
                   "The Remote Controller's GPS time.  @return An instance of `getTime`.",
            ],
            [
                   "The Remote Controller's GPS time.  @return An instance of `getTime`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_time_inline",
                   "",
            ],
            [
                   "getLocation",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_location_inline",
                   "The Remote Controller's location.  @return An instance of `GPSLocation`.",
            ],
            [
                   "The Remote Controller's location.  @return An instance of `GPSLocation`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_location_inline",
                   "",
            ],
            [
                   "getEastSpeed",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_speedEast_inline",
                   "The Remote Controller's speed in the East direction in meters/second. A negative speed means the Remote  Controller is moving in the West direction.  @return A float value.",
            ],
            [
                   "The Remote Controller's speed in the East direction in meters/second. A negative speed means the Remote  Controller is moving in the West direction.  @return A float value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_speedEast_inline",
                   "",
            ],
            [
                   "getNorthSpeed",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_speedNorth_inline",
                   "The Remote Controller's speed in the North direction in meters/second. A negative speed means the Remote  Controller is moving in the South direction.  @return A float value.",
            ],
            [
                   "The Remote Controller's speed in the North direction in meters/second. A negative speed means the Remote  Controller is moving in the South direction.  @return A float value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_speedNorth_inline",
                   "",
            ],
            [
                   "getSatelliteCount",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_satelliteCount_inline",
                   "The number of GPS satellites the Remote Controller detects.  @return An int value.",
            ],
            [
                   "The number of GPS satellites the Remote Controller detects.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_satelliteCount_inline",
                   "",
            ],
            [
                   "getLocationAccuracy",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_accuracy_inline",
                   "The the margin of error, in meters, for the GPS location.  @return A float value.",
            ],
            [
                   "The the margin of error, in meters, for the GPS location.  @return A float value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_accuracy_inline",
                   "",
            ],
            [
                   "isValid",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_isValid_inline",
                   "`true` if the GPS data is valid. The data is not valid if there are too few satellites  or the signal strength is too low.  @return A boolean value.",
            ],
            [
                   "`true` if the GPS data is valid. The data is not valid if there are too few satellites  or the signal strength is too low.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "#DJIRemoteController_DJIRCGPSData_isValid_inline",
                   "",
            ],
            [
                   "Time",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "",
                   "Remote Controller's GPS time.",
            ],
            [
                   "Remote Controller's GPS time.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "",
                   "",
            ],
            [
                   "getHour",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_hour_inline",
                   "Hour value of Remote Controller's GPS time.  @return A byte value.",
            ],
            [
                   "Hour value of Remote Controller's GPS time.  @return A byte value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_hour_inline",
                   "",
            ],
            [
                   "getMinute",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_minute_inline",
                   "Minute value of Remote Controller's GPS time.  @return A byte value.",
            ],
            [
                   "Minute value of Remote Controller's GPS time.  @return A byte value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_minute_inline",
                   "",
            ],
            [
                   "getSecond",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_second_inline",
                   "Second value of Remote Controller's GPS time.  @return A byte value.",
            ],
            [
                   "Second value of Remote Controller's GPS time.  @return A byte value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_second_inline",
                   "",
            ],
            [
                   "getYear",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_year_inline",
                   "Year value of Remote Controller's GPS time.  @return An int value.",
            ],
            [
                   "Year value of Remote Controller's GPS time.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_year_inline",
                   "",
            ],
            [
                   "getMonth",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_month_inline",
                   "Month value of Remote Controller's GPS time.  @return A byte value.",
            ],
            [
                   "Month value of Remote Controller's GPS time.  @return A byte value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_month_inline",
                   "",
            ],
            [
                   "getDay",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_day_inline",
                   "Day value of Remote Controller's GPS time.  @return A byte value.",
            ],
            [
                   "Day value of Remote Controller's GPS time.  @return A byte value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGpsTime.html",
                   "#DJIRemoteController_DJIRCGpsTime_day_inline",
                   "",
            ],
            [
                   "GPSLocation",
                   2,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "",
                   "Location defined by latitude and longitude.",
            ],
            [
                   "Location defined by latitude and longitude.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "",
                   "",
            ],
            [
                   "getLongitude",
                   2,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "#DJIRemoteController_GPSLocation_getLongitude_inline",
                   "Longitude component of a location.  @return A double value.",
            ],
            [
                   "Longitude component of a location.  @return A double value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "#DJIRemoteController_GPSLocation_getLongitude_inline",
                   "",
            ],
            [
                   "getLatitude",
                   2,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "#DJIRemoteController_GPSLocation_getLatitude_inline",
                   "Latitude component of a location.  @return A double value.",
            ],
            [
                   "Latitude component of a location.  @return A double value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_GPSLocation.html",
                   "#DJIRemoteController_GPSLocation_getLatitude_inline",
                   "",
            ],
            [
                   "GimbalMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "",
                   "The mapping styles to control the Gimbal.",
            ],
            [
                   "The mapping styles to control the Gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "",
                   "",
            ],
            [
                   "CUSTOM_GIMBAL_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "",
                   "SDK Key for GimbalMapping: The mapping styles to control the Gimbal.",
            ],
            [
                   "SDK Key for GimbalMapping: The mapping styles to control the Gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "",
                   "",
            ],
            [
                   "leftVertical",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_leftVertical_inline",
                   "The mapping configuration for the left stick on the vertical axis.  @return An instance of `GimbalStickMapping`.",
            ],
            [
                   "The mapping configuration for the left stick on the vertical axis.  @return An instance of `GimbalStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_leftVertical_inline",
                   "",
            ],
            [
                   "leftHorizontal",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_leftHorizontal_inline",
                   "The mapping configuration for the left stick on the horizontal axis.  @return An instance of `GimbalStickMapping`.",
            ],
            [
                   "The mapping configuration for the left stick on the horizontal axis.  @return An instance of `GimbalStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_leftHorizontal_inline",
                   "",
            ],
            [
                   "rightVertical",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_rightVertical_inline",
                   "The mapping configuration for the right stick on the vertical axis.  @return An instance of `GimbalStickMapping`.",
            ],
            [
                   "The mapping configuration for the right stick on the vertical axis.  @return An instance of `GimbalStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_rightVertical_inline",
                   "",
            ],
            [
                   "rightHorizontal",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_rightHorizontal_inline",
                   "The mapping configuration for the right stick on the horizontal axis.  @return An instance of `GimbalStickMapping`.",
            ],
            [
                   "The mapping configuration for the right stick on the horizontal axis.  @return An instance of `GimbalStickMapping`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_rightHorizontal_inline",
                   "",
            ],
            [
                   "gimbalMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_gimbalMappingStyle_inline",
                   "The control style to which the Remote Controller is set.  @return An enum value of `GimbalMappingStyle`.",
            ],
            [
                   "The control style to which the Remote Controller is set.  @return An enum value of `GimbalMappingStyle`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalMapping_gimbalMappingStyle_inline",
                   "",
            ],
            [
                   "GimbalMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_inline",
                   "The gimbal control stick mapping styles.",
            ],
            [
                   "The gimbal control stick mapping styles.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_inline",
                   "",
            ],
            [
                   "GIMBAL_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_inline",
                   "SDK Key for GimbalMappingStyle: The gimbal control stick mapping styles.",
            ],
            [
                   "SDK Key for GimbalMappingStyle: The gimbal control stick mapping styles.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_inline",
                   "",
            ],
            [
                   "DEFAULT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Default_inline",
                   "Default",
            ],
            [
                   "Default",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Default_inline",
                   "",
            ],
            [
                   "CUSTOM",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Custom_inline",
                   "Custom",
            ],
            [
                   "Custom",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Custom_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Unknown_inline",
                   "Unknown",
            ],
            [
                   "Unknown",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalMappingStyle_Unknown_inline",
                   "",
            ],
            [
                   "GimbalStickMappingTarget",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_inline",
                   "The list of available control to be used when creating custom mapping configurations",
            ],
            [
                   "The list of available control to be used when creating custom mapping configurations",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_None_inline",
                   "None",
            ],
            [
                   "None",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_None_inline",
                   "",
            ],
            [
                   "PITCH",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Pitch_inline",
                   "Pitch",
            ],
            [
                   "Pitch",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Pitch_inline",
                   "",
            ],
            [
                   "ROLL",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Roll_inline",
                   "Roll",
            ],
            [
                   "Roll",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Roll_inline",
                   "",
            ],
            [
                   "YAW",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Yaw_inline",
                   "Yaw",
            ],
            [
                   "Yaw",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMappingTarget_Yaw_inline",
                   "",
            ],
            [
                   "GimbalStickMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "",
                   "A struct representing a custom mapping configuration.",
            ],
            [
                   "A struct representing a custom mapping configuration.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "",
                   "",
            ],
            [
                   "getMappingTarget",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMapping_target_inline",
                   "The specific control to be mapped.  @return The enum value of `GimbalStickMappingTarget`.",
            ],
            [
                   "The specific control to be mapped.  @return The enum value of `GimbalStickMappingTarget`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMapping_target_inline",
                   "",
            ],
            [
                   "isReversed",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMapping_isReversed_inline",
                   "whether or not the control is to be reversed.  @return A boolean value.",
            ],
            [
                   "whether or not the control is to be reversed.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalStickMapping.html",
                   "#DJIRemoteController_DJIRCGimbalStickMapping_isReversed_inline",
                   "",
            ],
            [
                   "HDMI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_HDMI_inline",
                   "HDMI port.",
            ],
            [
                   "HDMI port.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_HDMI_inline",
                   "",
            ],
            [
                   "SDI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_SDI_inline",
                   "SDI port.",
            ],
            [
                   "SDI port.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_SDI_inline",
                   "",
            ],
            [
                   "Unknown",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_Unknown_inline",
                   "",
            ],
            [
                   "SOURCE_1_ONLY",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Source1Only_inline",
                   "Displays video from Source 1 only. When the current encode  mode is single, the secondary output will display  video from HDMI or AV input.  When the current encode mode is dual, the secondary output will display video from HDMI input.",
            ],
            [
                   "Displays video from Source 1 only. When the current encode  mode is single, the secondary output will display  video from HDMI or AV input.  When the current encode mode is dual, the secondary output will display video from HDMI input.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Source1Only_inline",
                   "",
            ],
            [
                   "SOURCE_2_ONLY",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Source2Only_inline",
                   "Displays video from Source 2 only. When the current encode mode is single, the secondary output  will display video from HD Gimbal camera. When the current encode mode is dual, the secondary output  will display video from  AV input.",
            ],
            [
                   "Displays video from Source 2 only. When the current encode mode is single, the secondary output  will display video from HD Gimbal camera. When the current encode mode is dual, the secondary output  will display video from  AV input.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Source2Only_inline",
                   "",
            ],
            [
                   "SOURCE_1_MAIN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_PIPSource1Main_inline",
                   "Displays the video from Source 1 as the main subject, and the video from Source 2 in a mini  window (Picture in  Picture, or PIP).",
            ],
            [
                   "Displays the video from Source 1 as the main subject, and the video from Source 2 in a mini  window (Picture in  Picture, or PIP).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_PIPSource1Main_inline",
                   "",
            ],
            [
                   "SOURCE_2_MAIN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_PIPSource2Main_inline",
                   "Displays the video from Source 2 as the main subject, and the video from Source 1 in a mini window (Picture in  Picture, or PIP).",
            ],
            [
                   "Displays the video from Source 2 as the main subject, and the video from Source 1 in a mini window (Picture in  Picture, or PIP).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_PIPSource2Main_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Unknown_inline",
                   "Unknown output mode.",
            ],
            [
                   "Unknown output mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_Unknown_inline",
                   "",
            ],
            [
                   "IMPERIAL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Imperial_inline",
                   "Imperial.",
            ],
            [
                   "Imperial.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Imperial_inline",
                   "",
            ],
            [
                   "METRIC",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Metric_inline",
                   "Metric.",
            ],
            [
                   "Metric.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Metric_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_Unknown_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080I_60FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080I60FPS_inline",
                   "1080I 60FPS.",
            ],
            [
                   "1080I 60FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080I60FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080I_50FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080I50FPS_inline",
                   "1080I 50FPS.",
            ],
            [
                   "1080I 50FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080I50FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080P_60FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P60FPS_inline",
                   "1080P 60FPS.",
            ],
            [
                   "1080P 60FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P60FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080P_50FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P50FPS_inline",
                   "1080P 50FPS.",
            ],
            [
                   "1080P 50FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P50FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080P_30FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P30FPS_inline",
                   "1080P 30FPS.",
            ],
            [
                   "1080P 30FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P30FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080P_25FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P25FPS_inline",
                   "1080P 25FPS.",
            ],
            [
                   "1080P 25FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P25FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_1080P_24FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P24FPS_inline",
                   "1080P 24FPS.",
            ],
            [
                   "1080P 24FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_1080P24FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_720P_60FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P60FPS_inline",
                   "720P 60FPS.",
            ],
            [
                   "720P 60FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P60FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_720P_50FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P50FPS_inline",
                   "720P 50FPS.",
            ],
            [
                   "720P 50FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P50FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_720P_30FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P30FPS_inline",
                   "720P 30FPS.",
            ],
            [
                   "720P 30FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P30FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_720P_25FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P25FPS_inline",
                   "720P 25FPS.",
            ],
            [
                   "720P 25FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P25FPS_inline",
                   "",
            ],
            [
                   "RESOLUTION_720P_24FPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P24FPS_inline",
                   "720P 24FPS.",
            ],
            [
                   "720P 24FPS.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_720P24FPS_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_Unknown_inline",
                   "",
            ],
            [
                   "FocusControllerStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCRemoteFocusStateUpdateCallbackInterface.html",
                   "",
                   "Callback function that updates the Remote Focus State.",
            ],
            [
                   "Callback function that updates the Remote Focus State.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCRemoteFocusStateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "isWorking",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_isFocusControlWorks_inline",
                   "`true` if the focus control works. The control can be either changing the Aperture or  Focal Length. If it is `false`, follow  the `Direction` to rotate the Remote Focus Device until it  turns to `true` again.  @return A boolean value.",
            ],
            [
                   "`true` if the focus control works. The control can be either changing the Aperture or  Focal Length. If it is `false`, follow  the `Direction` to rotate the Remote Focus Device until it  turns to `true` again.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_isFocusControlWorks_inline",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_IS_WORKING",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_isFocusControlWorks_inline",
                   "SDK Key for isWorking: `true` if the focus control works. The control can be either changing the Aperture or  Focal Length. If it is `false`, follow  the `Direction` to rotate the Remote Focus Device until it  turns to `true` again.  @return A boolean value.",
            ],
            [
                   "SDK Key for isWorking: `true` if the focus control works. The control can be either changing the Aperture or  Focal Length. If it is `false`, follow  the `Direction` to rotate the Remote Focus Device until it  turns to `true` again.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_isFocusControlWorks_inline",
                   "",
            ],
            [
                   "getControlType",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_controlType_inline",
                   "Remote Focus Control Type.  @return An enum value of `ControlType`",
            ],
            [
                   "Remote Focus Control Type.  @return An enum value of `ControlType`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_controlType_inline",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_CONTROL_TYPE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_controlType_inline",
                   "SDK Key for getControlType: Remote Focus Control Type.  @return An enum value of `ControlType`",
            ],
            [
                   "SDK Key for getControlType: Remote Focus Control Type.  @return An enum value of `ControlType`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_controlType_inline",
                   "",
            ],
            [
                   "getDirection",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_direction_inline",
                   "Remote Focus Control Direction. Use this with  the `isWorking` value. It will give you the correct  rotation direction when `isWorking` is  `false`.  @return An enum value of `Direction`",
            ],
            [
                   "Remote Focus Control Direction. Use this with  the `isWorking` value. It will give you the correct  rotation direction when `isWorking` is  `false`.  @return An enum value of `Direction`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_direction_inline",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_DIRECTION",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_direction_inline",
                   "SDK Key for getDirection: Remote Focus Control Direction. Use this with  the `isWorking` value. It will give you the correct  rotation direction when `isWorking` is  `false`.  @return An enum value of `Direction`",
            ],
            [
                   "SDK Key for getDirection: Remote Focus Control Direction. Use this with  the `isWorking` value. It will give you the correct  rotation direction when `isWorking` is  `false`.  @return An enum value of `Direction`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusState_direction_inline",
                   "",
            ],
            [
                   "ControlType",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_inline",
                   "Remote Focus Control Type.",
            ],
            [
                   "Remote Focus Control Type.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_inline",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_CONTROL_TYPE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_inline",
                   "SDK Key for ControlType: Remote Focus Control Type.",
            ],
            [
                   "SDK Key for ControlType: Remote Focus Control Type.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_inline",
                   "",
            ],
            [
                   "APERTURE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_Aperture_inline",
                   "Control Aperture.",
            ],
            [
                   "Control Aperture.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_Aperture_inline",
                   "",
            ],
            [
                   "FOCAL_LENGTH",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_FocalLength_inline",
                   "Control Focal Length.",
            ],
            [
                   "Control Focal Length.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_FocalLength_inline",
                   "",
            ],
            [
                   "FOCUS_DISTANCE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_FocusDistance_inline",
                   "Adjust focus distance.",
            ],
            [
                   "Adjust focus distance.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_FocusDistance_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_Unknown_inline",
                   "Unknown types.",
            ],
            [
                   "Unknown types.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlType_Unknown_inline",
                   "",
            ],
            [
                   "Direction",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_inline",
                   "Remote Focus Control Direction.",
            ],
            [
                   "Remote Focus Control Direction.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_inline",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_DIRECTION",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_inline",
                   "SDK Key for Direction: Remote Focus Control Direction.",
            ],
            [
                   "SDK Key for Direction: Remote Focus Control Direction.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_inline",
                   "",
            ],
            [
                   "CLOCKWISE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_Clockwise_inline",
                   "Clockwise.",
            ],
            [
                   "Clockwise.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_Clockwise_inline",
                   "",
            ],
            [
                   "COUNTER_CLOCKWISE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_CounterClockwise_inline",
                   "CounterClockwise.",
            ],
            [
                   "CounterClockwise.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_CounterClockwise_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "#DJIRemoteController_DJIRCRemoteFocusControlDirection_Unknown_inline",
                   "",
            ],
            [
                   "setHardwareStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setHardwareStateUpdateCallback_inline",
                   "Set the HardwareStateUpdateCallback  @param hardwareStateCallback RCHardwareState.HardwareStateCallback callback.",
            ],
            [
                   "Set the HardwareStateUpdateCallback  @param hardwareStateCallback RCHardwareState.HardwareStateCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setHardwareStateUpdateCallback_inline",
                   "",
            ],
            [
                   "setChargeRemainingCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setBatteryStateUpdateCallback_inline",
                   "Sets the BatteryStateUpdateCallback.  @param callback ChargeRemaining.BatteryStateCallback callback.",
            ],
            [
                   "Sets the BatteryStateUpdateCallback.  @param callback ChargeRemaining.BatteryStateCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setBatteryStateUpdateCallback_inline",
                   "",
            ],
            [
                   "setGPSDataCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_updateGpsDataCallback_inline",
                   "Set the GPSDataUpdateCallback.  @param callback GPSDataCallback callback.",
            ],
            [
                   "Set the GPSDataUpdateCallback.  @param callback GPSDataCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_updateGpsDataCallback_inline",
                   "",
            ],
            [
                   "setProRCEventCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setProRCEventCallback_inline",
                   "Set the ProRCEventCallback.  @param callback ProfessionalRC callback.",
            ],
            [
                   "Set the ProRCEventCallback.  @param callback ProfessionalRC callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setProRCEventCallback_inline",
                   "",
            ],
            [
                   "setMasterSlaveStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_didUpdateMasterSlaveStateCallback_inline",
                   "Callback that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param callback RCMasterSlaveStateUpdateCallback callback.",
            ],
            [
                   "Callback that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param callback RCMasterSlaveStateUpdateCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_didUpdateMasterSlaveStateCallback_inline",
                   "",
            ],
            [
                   "setGimbalControlRequestFromSlaveCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setGimbalControlRequestFromSlaveReceivedCallback_inline",
                   "Sets GimbalControlRequestFromSlaveReceivedCallback.  @param controlRequestCallback Information.ControlRequestCallback callback.",
            ],
            [
                   "Sets GimbalControlRequestFromSlaveReceivedCallback.  @param controlRequestCallback Information.ControlRequestCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setGimbalControlRequestFromSlaveReceivedCallback_inline",
                   "",
            ],
            [
                   "setFocusControllerStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCRemoteFocusStateUpdateCallback_inline",
                   "Sets RCRemoteFocusStateUpdateCallback.  @param focusStateUpdateCallback FocusControllerState.FocusControllerStateCallback callback.",
            ],
            [
                   "Sets RCRemoteFocusStateUpdateCallback.  @param focusStateUpdateCallback FocusControllerState.FocusControllerStateCallback callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCRemoteFocusStateUpdateCallback_inline",
                   "",
            ],
            [
                   "addRTKChannelEnabledUpdatedCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addRTKChannelEnabledUpdatedCallback_inline",
                   "Add the RTKChannelEnabledUpdatedCallback.  @param callback `RTKChannelEnabledUpdatedCallback` callback.",
            ],
            [
                   "Add the RTKChannelEnabledUpdatedCallback.  @param callback `RTKChannelEnabledUpdatedCallback` callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addRTKChannelEnabledUpdatedCallback_inline",
                   "",
            ],
            [
                   "removeRTKChannelEnabledUpdatedCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeRTKChannelEnabledUpdatedCallback_inline",
                   "Remove the `RTKChannelEnabledUpdatedCallback` callback.  @param callback `RTKChannelEnabledUpdatedCallback` callback.",
            ],
            [
                   "Remove the `RTKChannelEnabledUpdatedCallback` callback.  @param callback `RTKChannelEnabledUpdatedCallback` callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeRTKChannelEnabledUpdatedCallback_inline",
                   "",
            ],
            [
                   "addMultiDevicesPairingStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addMultiDevicesPairingStateCallback_inline",
                   "Adds `Callback`.  @param multiDeviceAggregationStateCallback `MultiDeviceAggregationState` callback.",
            ],
            [
                   "Adds `Callback`.  @param multiDeviceAggregationStateCallback `MultiDeviceAggregationState` callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addMultiDevicesPairingStateCallback_inline",
                   "",
            ],
            [
                   "removeMultiDevicesPairingStateCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeMultiDevicesPairingStateCallback_inline",
                   "Removes `Callback`.  @param multiDeviceAggregationStateCallback `MultiDeviceAggregationState` callback.",
            ],
            [
                   "Removes `Callback`.  @param multiDeviceAggregationStateCallback `MultiDeviceAggregationState` callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeMultiDevicesPairingStateCallback_inline",
                   "",
            ],
            [
                   "startPairing",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_enterPairingMode_inline",
                   "Enters pairing mode, in which the Remote Controller starts pairing with the aircraft. This method is used when the Remote Controller no longer recognizes which aircraft it is paired with.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Enters pairing mode, in which the Remote Controller starts pairing with the aircraft. This method is used when the Remote Controller no longer recognizes which aircraft it is paired with.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_enterPairingMode_inline",
                   "",
            ],
            [
                   "START_PAIRING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_enterPairingMode_inline",
                   "SDK Key for startPairing: Enters pairing mode, in which the Remote Controller starts pairing with the aircraft. This method is used when the Remote Controller no longer recognizes which aircraft it is paired with.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "SDK Key for startPairing: Enters pairing mode, in which the Remote Controller starts pairing with the aircraft. This method is used when the Remote Controller no longer recognizes which aircraft it is paired with.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_enterPairingMode_inline",
                   "",
            ],
            [
                   "stopPairing",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_exitPairingMode_inline",
                   "Exits pairing mode.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Exits pairing mode.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_exitPairingMode_inline",
                   "",
            ],
            [
                   "STOP_PAIRING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_exitPairingMode_inline",
                   "SDK Key for stopPairing: Exits pairing mode.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "SDK Key for stopPairing: Exits pairing mode.  @param callback The execution callback with the execution result returned. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_exitPairingMode_inline",
                   "",
            ],
            [
                   "getPairingState",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPairingState_inline",
                   "Gets the pairing status as the Remote Controller is pairing with the aircraft.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the pairing status as the Remote Controller is pairing with the aircraft.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPairingState_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.PAIRING_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPairingState_inline",
                   "SDK Key for getPairingState: Gets the pairing status as the Remote Controller is pairing with the aircraft.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getPairingState: Gets the pairing status as the Remote Controller is pairing with the aircraft.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPairingState_inline",
                   "",
            ],
            [
                   "isMultiDevicePairingSupported",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMultiDevicePairingSupported_inline",
                   "Determines if multi-device pairing supported by the remote controller. When the remote controller supports multi-device pairing, it can be paired to more than one device (e.g. aircraft, RTK base station) at the same time. When this feature is supported, use `startMultiDevicePairing` and `stopMultiDevicePairing` to start and stop pairing instead of using the following methods:  - `startPairing`  - `stopPairing`  - `getPairingState`. This feature is only supported by Phantom 4 RTK.  @return `true` if multi-device pairing is supported.",
            ],
            [
                   "Determines if multi-device pairing supported by the remote controller. When the remote controller supports multi-device pairing, it can be paired to more than one device (e.g. aircraft, RTK base station) at the same time. When this feature is supported, use `startMultiDevicePairing` and `stopMultiDevicePairing` to start and stop pairing instead of using the following methods:  - `startPairing`  - `stopPairing`  - `getPairingState`. This feature is only supported by Phantom 4 RTK.  @return `true` if multi-device pairing is supported.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMultiDevicePairingSupported_inline",
                   "",
            ],
            [
                   "startMultiDevicePairing",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMultiDevicePairingWithTarget_inline",
                   "Starts pairing a target with the specific type (aircraft or RTK base station). This paring method is for Phantom 4 RTK only. To use RTK feature with a base station, the Phantom 4 RTK remote controller need to pair both the base station and the aircraft at the same time.  CAUTION: pairing an RTK base station will unpair the paired aircraft. Therefore, to use the base station properly, the user needs to pair the base station first, and the aircraft after. It is only supported when `isMultiDevicePairingSupported` returns `true`.  @param target The device target to start multi-device pairing. @param callback Completion block.",
            ],
            [
                   "Starts pairing a target with the specific type (aircraft or RTK base station). This paring method is for Phantom 4 RTK only. To use RTK feature with a base station, the Phantom 4 RTK remote controller need to pair both the base station and the aircraft at the same time.  CAUTION: pairing an RTK base station will unpair the paired aircraft. Therefore, to use the base station properly, the user needs to pair the base station first, and the aircraft after. It is only supported when `isMultiDevicePairingSupported` returns `true`.  @param target The device target to start multi-device pairing. @param callback Completion block.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMultiDevicePairingWithTarget_inline",
                   "",
            ],
            [
                   "stopMultiDevicePairing",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMultiDevicePairing_inline",
                   "Stops the multi-device pairing. It is used after the pairing is started and before the remote controller is paired to a device successfully. It is not necessary to call this method if the remote controller is paired to a device successfully. Only Supported by Phantom 4 RTK.  @param callback Completion block.",
            ],
            [
                   "Stops the multi-device pairing. It is used after the pairing is started and before the remote controller is paired to a device successfully. It is not necessary to call this method if the remote controller is paired to a device successfully. Only Supported by Phantom 4 RTK.  @param callback Completion block.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMultiDevicePairing_inline",
                   "",
            ],
            [
                   "setRTKChannelEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRTKChannelEnabled_inline",
                   "Enables the RTK channel on the remote controller. When RTK air system is using the base station as the reference station, the remote controller should enable the RTK channel and reserve some bandwidth for data transmission between the base station and the air system.  CAUTION: toggling RTK channel will reset the airlink between the remote controller and the aircraft. The airlink may take 3 seconds to recover. DO NOT enable/disable the channel when the aircraft is flying. If the base station is reconnected, you need to call this interface to enabled the RTK channel again. Only Supported by Phantom 4 RTK.  @param enabled `true` to enable the RTK channel on the remote controller. @param callback Completion block.",
            ],
            [
                   "Enables the RTK channel on the remote controller. When RTK air system is using the base station as the reference station, the remote controller should enable the RTK channel and reserve some bandwidth for data transmission between the base station and the air system.  CAUTION: toggling RTK channel will reset the airlink between the remote controller and the aircraft. The airlink may take 3 seconds to recover. DO NOT enable/disable the channel when the aircraft is flying. If the base station is reconnected, you need to call this interface to enabled the RTK channel again. Only Supported by Phantom 4 RTK.  @param enabled `true` to enable the RTK channel on the remote controller. @param callback Completion block.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRTKChannelEnabled_inline",
                   "",
            ],
            [
                   "setCustomAircraftMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomAircraftMapping_inline",
                   "Set the mapping of custom style. It will change the current mapping style to `STYLE_CUSTOM`. The setting will only take effect when the remote controller is in master mode.  @param mapping The remote controller aircraft mapping. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Set the mapping of custom style. It will change the current mapping style to `STYLE_CUSTOM`. The setting will only take effect when the remote controller is in master mode.  @param mapping The remote controller aircraft mapping. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomAircraftMapping_inline",
                   "",
            ],
            [
                   "AIRCRAFT_CUSTOM_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomAircraftMapping_inline",
                   "SDK Key for setCustomAircraftMapping: Set the mapping of custom style. It will change the current mapping style to `STYLE_CUSTOM`. The setting will only take effect when the remote controller is in master mode.  @param mapping The remote controller aircraft mapping. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setCustomAircraftMapping: Set the mapping of custom style. It will change the current mapping style to `STYLE_CUSTOM`. The setting will only take effect when the remote controller is in master mode.  @param mapping The remote controller aircraft mapping. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomAircraftMapping_inline",
                   "",
            ],
            [
                   "getCustomAircraftMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomAircraftMapping_inline",
                   "Retrieves the stick mapping associated with the custom style.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Retrieves the stick mapping associated with the custom style.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomAircraftMapping_inline",
                   "",
            ],
            [
                   "AIRCRAFT_CUSTOM_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomAircraftMapping_inline",
                   "SDK Key for getCustomAircraftMapping: Retrieves the stick mapping associated with the custom style.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getCustomAircraftMapping: Retrieves the stick mapping associated with the custom style.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomAircraftMapping_inline",
                   "",
            ],
            [
                   "setAircraftMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCControlMode_inline",
                   "Sets the Remote Controller's control mode.  @param style Remote controller control mode to be set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the Remote Controller's control mode.  @param style Remote controller control mode to be set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCControlMode_inline",
                   "",
            ],
            [
                   "AIRCRAFT_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCControlMode_inline",
                   "SDK Key for setAircraftMappingStyle: Sets the Remote Controller's control mode.  @param style Remote controller control mode to be set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setAircraftMappingStyle: Sets the Remote Controller's control mode.  @param style Remote controller control mode to be set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCControlMode_inline",
                   "",
            ],
            [
                   "getAircraftMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCControlMode_inline",
                   "Gets the Remote Controller's control mode.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the Remote Controller's control mode.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCControlMode_inline",
                   "",
            ],
            [
                   "AIRCRAFT_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCControlMode_inline",
                   "SDK Key for getAircraftMappingStyle: Gets the Remote Controller's control mode.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for getAircraftMappingStyle: Gets the Remote Controller's control mode.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCControlMode_inline",
                   "",
            ],
            [
                   "setLeftDialGimbalControlAxis",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setControlGimbalDirection_inline",
                   "Sets which of the gimbal directions the top left dial (Gimbal Dial) on the Remote Controller will control. The three options (pitch, roll, and yaw) are outlined in the enum named `GimbalAxis`.  @param axis Gimbal direction to be set that the top left dial on the Remote Controller will control. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Sets which of the gimbal directions the top left dial (Gimbal Dial) on the Remote Controller will control. The three options (pitch, roll, and yaw) are outlined in the enum named `GimbalAxis`.  @param axis Gimbal direction to be set that the top left dial on the Remote Controller will control. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setControlGimbalDirection_inline",
                   "",
            ],
            [
                   "getLeftDialGimbalControlAxis",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getControlGimbalDirection_inline",
                   "Gets which of the gimbal directions the top left wheel (Gimbal Dial) on the Remote Controller will control.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets which of the gimbal directions the top left wheel (Gimbal Dial) on the Remote Controller will control.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getControlGimbalDirection_inline",
                   "",
            ],
            [
                   "setLeftDialGimbalControlSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setLeftWheelGimbalControlSpeedCoefficient_inline",
                   "Sets gimbal rotation speed of the top left wheel (Gimbal Dial) on the Remote Controller. The valid range is [0, 100].  @param coefficient Gimbal control speed coefficient to be set. Setting it to zero can disable the gimbal control by the top left wheel. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets gimbal rotation speed of the top left wheel (Gimbal Dial) on the Remote Controller. The valid range is [0, 100].  @param coefficient Gimbal control speed coefficient to be set. Setting it to zero can disable the gimbal control by the top left wheel. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setLeftWheelGimbalControlSpeedCoefficient_inline",
                   "",
            ],
            [
                   "getLeftDialGimbalControlSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getLeftWheelGimbalControlSpeedCoefficient_inline",
                   "Gets gimbal rotation speed of the top left wheel (Gimbal Dial) on the Remote Controller. The valid range is [0, 100].  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets gimbal rotation speed of the top left wheel (Gimbal Dial) on the Remote Controller. The valid range is [0, 100].  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getLeftWheelGimbalControlSpeedCoefficient_inline",
                   "",
            ],
            [
                   "setCustomButtonTags",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCCustomButtonTag_inline",
                   "Sets custom button tags, which can be used by the user to record user settings. Moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the C1 and C2 buttons on the Remote Controller.  @param tags Back buttons' custom tags, the value should in the range of [0, 255]. @param callback Remote execution result error callback.",
            ],
            [
                   "Sets custom button tags, which can be used by the user to record user settings. Moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the C1 and C2 buttons on the Remote Controller.  @param tags Back buttons' custom tags, the value should in the range of [0, 255]. @param callback Remote execution result error callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCCustomButtonTag_inline",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_TAGS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCCustomButtonTag_inline",
                   "SDK Key for setCustomButtonTags: Sets custom button tags, which can be used by the user to record user settings. Moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the C1 and C2 buttons on the Remote Controller.  @param tags Back buttons' custom tags, the value should in the range of [0, 255]. @param callback Remote execution result error callback.",
            ],
            [
                   "SDK Key for setCustomButtonTags: Sets custom button tags, which can be used by the user to record user settings. Moreover, this method will make it easier for developers to set custom tags for buttons in the user interface, will make it easier to use the C1 and C2 buttons on the Remote Controller.  @param tags Back buttons' custom tags, the value should in the range of [0, 255]. @param callback Remote execution result error callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCCustomButtonTag_inline",
                   "",
            ],
            [
                   "getCustomButtonTags",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCCustomButtonTag_inline",
                   "Gets the custom button's (Back Button's) tags.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the custom button's (Back Button's) tags.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCCustomButtonTag_inline",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_TAGS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCCustomButtonTag_inline",
                   "SDK Key for getCustomButtonTags: Gets the custom button's (Back Button's) tags.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getCustomButtonTags: Gets the custom button's (Back Button's) tags.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCCustomButtonTag_inline",
                   "",
            ],
            [
                   "setShutterButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setShutterButtonBindingEnabled_inline",
                   "Enables invoking shooting photo interface when the shutter button is pressed. Mavic 2 series remote controller's shutter button will not work physically when connecting to Mobile SDK. This setting will be stored in software application localized storage paired with the RC SN key, which means, if the application is killed, it will be set to enabled by default when the application is relaunched. It is only supported by Mavic 2 series.  @param enabled `true` to enable invoking shooting photo interface when the shutter button is pressed. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Enables invoking shooting photo interface when the shutter button is pressed. Mavic 2 series remote controller's shutter button will not work physically when connecting to Mobile SDK. This setting will be stored in software application localized storage paired with the RC SN key, which means, if the application is killed, it will be set to enabled by default when the application is relaunched. It is only supported by Mavic 2 series.  @param enabled `true` to enable invoking shooting photo interface when the shutter button is pressed. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setShutterButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "getShutterButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getShutterButtonBindingEnabled_inline",
                   "Gets if shooting photo interface is involved when the shutter button is pressed. It is only supported by Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets if shooting photo interface is involved when the shutter button is pressed. It is only supported by Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getShutterButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "setRecordButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRecordButtonBindingEnabled_inline",
                   "Enables invoking video record interface when the record button is pressed. Mavic 2 series remote controller's record button will not work physically when connecting to Mobile SDK. This setting will be stored in software application localized storage paired with the RC SN key. Only supported by Mavic 2 series.  @param enabled `true` to enable invoking video record interface when the record button is pressed. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Enables invoking video record interface when the record button is pressed. Mavic 2 series remote controller's record button will not work physically when connecting to Mobile SDK. This setting will be stored in software application localized storage paired with the RC SN key. Only supported by Mavic 2 series.  @param enabled `true` to enable invoking video record interface when the record button is pressed. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRecordButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "getRecordButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRecordButtonBindingEnabled_inline",
                   "Gets if video record interface is involved when the record button is pressed. It is only supported by Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets if video record interface is involved when the record button is pressed. It is only supported by Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRecordButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "setPhotoAndVideoToggleButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setPhotoAndVideoToggleButtonBindingEnabled_inline",
                   "`true` to switch camera flat mode between photo and video when the `getPhotoAndVideoToggleButton` button is pressed. `false` when `getPhotoAndVideoToggleButton` button is pressed, we will not bind any event. You can monitor the button and handle custom events by yourself. This setting will be stored in software application localized storage paired with the RC SN key, which means. Only supported by Mavic Air 2, DJI Air 2S.  @param enabled `true` to switch camera flat mode between photo and video when the `getPhotoAndVideoToggleButton` button is pressed. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "`true` to switch camera flat mode between photo and video when the `getPhotoAndVideoToggleButton` button is pressed. `false` when `getPhotoAndVideoToggleButton` button is pressed, we will not bind any event. You can monitor the button and handle custom events by yourself. This setting will be stored in software application localized storage paired with the RC SN key, which means. Only supported by Mavic Air 2, DJI Air 2S.  @param enabled `true` to switch camera flat mode between photo and video when the `getPhotoAndVideoToggleButton` button is pressed. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setPhotoAndVideoToggleButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "getPhotoAndVideoToggleButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPhotoAndVideoToggleButtonBindingEnabled_inline",
                   "Gets whether switching camera flat mode between photo and video is enabled when the `getPhotoAndVideoToggleButton` button is pressed. It is only supported by Mavic Air 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets whether switching camera flat mode between photo and video is enabled when the `getPhotoAndVideoToggleButton` button is pressed. It is only supported by Mavic Air 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getPhotoAndVideoToggleButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "setShootPhotoAndRecordButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setShootPhotoAndRecordButtonBindingEnabled_inline",
                   "`true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getPhotoAndVideoToggleButton` button state. `false` when `getPhotoAndVideoToggleButton` button is pressed, we will not bind any event. You can monitor the button and handle custom events by yourself. This setting will be stored in software application localized storage paired with the RC SN key. Only supported by Mavic AIr 2, DJI Air 2S.  @param enabled `true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getPhotoAndVideoToggleButton` button state. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "`true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getPhotoAndVideoToggleButton` button state. `false` when `getPhotoAndVideoToggleButton` button is pressed, we will not bind any event. You can monitor the button and handle custom events by yourself. This setting will be stored in software application localized storage paired with the RC SN key. Only supported by Mavic AIr 2, DJI Air 2S.  @param enabled `true` to enable invoking shoot photo or record interface when the record button is pressed depend on the `getPhotoAndVideoToggleButton` button state. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setShootPhotoAndRecordButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "getShootPhotoAndRecordButtonBindingEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getShootPhotoAndRecordButtonBindingEnabled_inline",
                   "Gets if shoot photo or video record interface is involved when the `getPhotoAndVideoToggleButton` button is pressed. It is only supported by Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets if shoot photo or video record interface is involved when the `getPhotoAndVideoToggleButton` button is pressed. It is only supported by Mavic Air 2, DJI Air 2S.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getShootPhotoAndRecordButtonBindingEnabled_inline",
                   "",
            ],
            [
                   "setChargeMobileMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setChargeMobileMode_inline",
                   "Sets the charge mode of a connected iOS device.  Note: Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence and Mavic 2 series.  @param mode Charge Mobile mode. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the charge mode of a connected iOS device.  Note: Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence and Mavic 2 series.  @param mode Charge Mobile mode. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setChargeMobileMode_inline",
                   "",
            ],
            [
                   "getChargeMobileMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getChargeMobileMode_inline",
                   "Gets the mode to charge the connected iOS device. Note that Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence, and Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the mode to charge the connected iOS device. Note that Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence, and Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getChargeMobileMode_inline",
                   "",
            ],
            [
                   "CHARGE_MOBILE_MODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getChargeMobileMode_inline",
                   "SDK Key for getChargeMobileMode: Gets the mode to charge the connected iOS device. Note that Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence, and Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getChargeMobileMode: Gets the mode to charge the connected iOS device. Note that Android devices are always charging when connected to the remote controller. It is only supported by Inspire 2, M200 series, Cendence, and Mavic 2 series.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getChargeMobileMode_inline",
                   "",
            ],
            [
                   "isMasterSlaveModeSupported",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMasterSlaveModeSupported_inline",
                   "Query method to check if the Remote Controller supports master/slave mode. Master-slave mode is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. Inspire 2 is using a new set of interfaces to control the master and slave connection.  - Similar to other products, Inspire 2's remote controller also use set/get `RCMode` to change the mode. - A slave remote controller can use `getMasters` and `connectToMaster` to join a master remote controller. - A master remote controller can use `setMasterAuthorizationCode` to change the authentication code.  @return A boolean value.",
            ],
            [
                   "Query method to check if the Remote Controller supports master/slave mode. Master-slave mode is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. Inspire 2 is using a new set of interfaces to control the master and slave connection.  - Similar to other products, Inspire 2's remote controller also use set/get `RCMode` to change the mode. - A slave remote controller can use `getMasters` and `connectToMaster` to join a master remote controller. - A master remote controller can use `setMasterAuthorizationCode` to change the authentication code.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMasterSlaveModeSupported_inline",
                   "",
            ],
            [
                   "IS_MASTER_SLAVE_MODE_SUPPORTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMasterSlaveModeSupported_inline",
                   "SDK Key for isMasterSlaveModeSupported: Query method to check if the Remote Controller supports master/slave mode. Master-slave mode is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. Inspire 2 is using a new set of interfaces to control the master and slave connection.  - Similar to other products, Inspire 2's remote controller also use set/get `RCMode` to change the mode. - A slave remote controller can use `getMasters` and `connectToMaster` to join a master remote controller. - A master remote controller can use `setMasterAuthorizationCode` to change the authentication code.  @return A boolean value.",
            ],
            [
                   "SDK Key for isMasterSlaveModeSupported: Query method to check if the Remote Controller supports master/slave mode. Master-slave mode is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. Inspire 2 is using a new set of interfaces to control the master and slave connection.  - Similar to other products, Inspire 2's remote controller also use set/get `RCMode` to change the mode. - A slave remote controller can use `getMasters` and `connectToMaster` to join a master remote controller. - A master remote controller can use `setMasterAuthorizationCode` to change the authentication code.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isMasterSlaveModeSupported_inline",
                   "",
            ],
            [
                   "setMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRemoteControllerMode_inline",
                   "Sets the Remote Controller's mode. See the `RCMode` enum for all possible Remote Controller modes. The master and slave modes are only supported for the Inspire 1, Inspire 1 Pro, M100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. It's not supported by Matrice 300 RTK.  @param mode Mode of type `RCMode` to be set for the Remote Controller. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the Remote Controller's mode. See the `RCMode` enum for all possible Remote Controller modes. The master and slave modes are only supported for the Inspire 1, Inspire 1 Pro, M100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. It's not supported by Matrice 300 RTK.  @param mode Mode of type `RCMode` to be set for the Remote Controller. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRemoteControllerMode_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.MODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRemoteControllerMode_inline",
                   "SDK Key for setMode: Sets the Remote Controller's mode. See the `RCMode` enum for all possible Remote Controller modes. The master and slave modes are only supported for the Inspire 1, Inspire 1 Pro, M100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. It's not supported by Matrice 300 RTK.  @param mode Mode of type `RCMode` to be set for the Remote Controller. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setMode: Sets the Remote Controller's mode. See the `RCMode` enum for all possible Remote Controller modes. The master and slave modes are only supported for the Inspire 1, Inspire 1 Pro, M100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2. It's not supported by Matrice 300 RTK.  @param mode Mode of type `RCMode` to be set for the Remote Controller. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRemoteControllerMode_inline",
                   "",
            ],
            [
                   "getMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRemoteControllerMode_inline",
                   "Gets the Remote Controller's work mode. It is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the Remote Controller's work mode. It is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRemoteControllerMode_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.MODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRemoteControllerMode_inline",
                   "SDK Key for getMode: Gets the Remote Controller's work mode. It is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getMode: Gets the Remote Controller's work mode. It is supported by the Inspire 1, Inspire 1 Pro, Matrice 100, Lightbridge 2 (including Matrice 600, Matrice 600 Pro, A3 and N3) and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRemoteControllerMode_inline",
                   "",
            ],
            [
                   "setName",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCName_inline",
                   "Sets the Remote Controller's name.  @param name Remote controller name to be set. Six characters at most. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the Remote Controller's name.  @param name Remote controller name to be set. Six characters at most. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCName_inline",
                   "",
            ],
            [
                   "NAME",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCName_inline",
                   "SDK Key for setName: Sets the Remote Controller's name.  @param name Remote controller name to be set. Six characters at most. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setName: Sets the Remote Controller's name.  @param name Remote controller name to be set. Six characters at most. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCName_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCName_inline",
                   "Gets the Remote Controller's name.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the Remote Controller's name.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCName_inline",
                   "",
            ],
            [
                   "NAME",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCName_inline",
                   "SDK Key for getName: Gets the Remote Controller's name.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getName: Gets the Remote Controller's name.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCName_inline",
                   "",
            ],
            [
                   "setPassword",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCPassword_inline",
                   "Sets the Remote Controller's password.  @param password Remote controller password to be set, using a string consisted by 4 digits. @param callback The execution callback with the value(s) returned. See `BaseComponent` for more information about the callback and what is recommended to be done with it.",
            ],
            [
                   "Sets the Remote Controller's password.  @param password Remote controller password to be set, using a string consisted by 4 digits. @param callback The execution callback with the value(s) returned. See `BaseComponent` for more information about the callback and what is recommended to be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCPassword_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.PASSWORD",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCPassword_inline",
                   "SDK Key for setPassword: Sets the Remote Controller's password.  @param password Remote controller password to be set, using a string consisted by 4 digits. @param callback The execution callback with the value(s) returned. See `BaseComponent` for more information about the callback and what is recommended to be done with it.",
            ],
            [
                   "SDK Key for setPassword: Sets the Remote Controller's password.  @param password Remote controller password to be set, using a string consisted by 4 digits. @param callback The execution callback with the value(s) returned. See `BaseComponent` for more information about the callback and what is recommended to be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setRCPassword_inline",
                   "",
            ],
            [
                   "getPassword",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCPassword_inline",
                   "Gets the Remote Controller's password.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the Remote Controller's password.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCPassword_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.PASSWORD",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCPassword_inline",
                   "SDK Key for getPassword: Gets the Remote Controller's password.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getPassword: Gets the Remote Controller's password.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getRCPassword_inline",
                   "",
            ],
            [
                   "getSlaveList",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveRCList_inline",
                   "Used by the current master Remote Controller to get all the slaves connected to it.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Used by the current master Remote Controller to get all the slaves connected to it.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveRCList_inline",
                   "",
            ],
            [
                   "SLAVE_LIST",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveRCList_inline",
                   "SDK Key for getSlaveList: Used by the current master Remote Controller to get all the slaves connected to it.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSlaveList: Used by the current master Remote Controller to get all the slaves connected to it.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveRCList_inline",
                   "",
            ],
            [
                   "startMasterSearching",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMasterRCSearch_inline",
                   "Starts a search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers, first call `getAvailableMasters`, then call `stopMasterSearching` to end the search.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Starts a search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers, first call `getAvailableMasters`, then call `stopMasterSearching` to end the search.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMasterRCSearch_inline",
                   "",
            ],
            [
                   "START_SEARCH_MASTER",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMasterRCSearch_inline",
                   "SDK Key for startMasterSearching: Starts a search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers, first call `getAvailableMasters`, then call `stopMasterSearching` to end the search.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "SDK Key for startMasterSearching: Starts a search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers, first call `getAvailableMasters`, then call `stopMasterSearching` to end the search.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_startMasterRCSearch_inline",
                   "",
            ],
            [
                   "stopMasterSearching",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMasterRCSearch_inline",
                   "Used by a slave Remote Controller to stop the search for nearby master Remote Controllers.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Used by a slave Remote Controller to stop the search for nearby master Remote Controllers.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMasterRCSearch_inline",
                   "",
            ],
            [
                   "STOP_MASTER_SEARCHING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMasterRCSearch_inline",
                   "SDK Key for stopMasterSearching: Used by a slave Remote Controller to stop the search for nearby master Remote Controllers.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "SDK Key for stopMasterSearching: Used by a slave Remote Controller to stop the search for nearby master Remote Controllers.  @param callback Remote execution result error callback. Please refer to `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_stopMasterRCSearch_inline",
                   "",
            ],
            [
                   "getAvailableMasters",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getAvailableMastersRCs_inline",
                   "Starts search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers use getAvailableMastersWithCallbackBlock then call stopMasterRCSearch to end th search.  @param callback The execution callback with the value(s) returned. The array of masters contains objects of type Information.",
            ],
            [
                   "Starts search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers use getAvailableMastersWithCallbackBlock then call stopMasterRCSearch to end th search.  @param callback The execution callback with the value(s) returned. The array of masters contains objects of type Information.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getAvailableMastersRCs_inline",
                   "",
            ],
            [
                   "AVAILABLE_MASTERS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getAvailableMastersRCs_inline",
                   "SDK Key for getAvailableMasters: Starts search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers use getAvailableMastersWithCallbackBlock then call stopMasterRCSearch to end th search.  @param callback The execution callback with the value(s) returned. The array of masters contains objects of type Information.",
            ],
            [
                   "SDK Key for getAvailableMasters: Starts search by slave Remote Controller for nearby master Remote Controllers. To get the list of master Remote Controllers use getAvailableMastersWithCallbackBlock then call stopMasterRCSearch to end th search.  @param callback The execution callback with the value(s) returned. The array of masters contains objects of type Information.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getAvailableMastersRCs_inline",
                   "",
            ],
            [
                   "getMasterSearchingState",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasterRCSearchState_inline",
                   "Returns the state of the master Remote Controller search. The search is initiated by the Mobile Device, but performed by the Remote Controller. Therefore, if the Mobile Device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the Remote Controller state.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Returns the state of the master Remote Controller search. The search is initiated by the Mobile Device, but performed by the Remote Controller. Therefore, if the Mobile Device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the Remote Controller state.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasterRCSearchState_inline",
                   "",
            ],
            [
                   "MASTER_SEARCHING_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasterRCSearchState_inline",
                   "SDK Key for getMasterSearchingState: Returns the state of the master Remote Controller search. The search is initiated by the Mobile Device, but performed by the Remote Controller. Therefore, if the Mobile Device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the Remote Controller state.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getMasterSearchingState: Returns the state of the master Remote Controller search. The search is initiated by the Mobile Device, but performed by the Remote Controller. Therefore, if the Mobile Device's application crashes while a search is ongoing, this method can be used to let the new instance of the application understand the Remote Controller state.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasterRCSearchState_inline",
                   "",
            ],
            [
                   "connectToMaster",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterRC_inline",
                   "Used by a slave Remote Controller to request to join a master Remote Controller and be able to control the gimbal. If the master Remote Controller accepts the request, the master Remote Controller will control the aircraft and the slave Remote Controller will control the gimbal.  @param credentials Include master's name and master's password. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Used by a slave Remote Controller to request to join a master Remote Controller and be able to control the gimbal. If the master Remote Controller accepts the request, the master Remote Controller will control the aircraft and the slave Remote Controller will control the gimbal.  @param credentials Include master's name and master's password. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterRC_inline",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterRC_inline",
                   "SDK Key for connectToMaster: Used by a slave Remote Controller to request to join a master Remote Controller and be able to control the gimbal. If the master Remote Controller accepts the request, the master Remote Controller will control the aircraft and the slave Remote Controller will control the gimbal.  @param credentials Include master's name and master's password. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for connectToMaster: Used by a slave Remote Controller to request to join a master Remote Controller and be able to control the gimbal. If the master Remote Controller accepts the request, the master Remote Controller will control the aircraft and the slave Remote Controller will control the gimbal.  @param credentials Include master's name and master's password. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterRC_inline",
                   "",
            ],
            [
                   "getConnectedMasterCredentials",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getJoinedMasterRCInfos_inline",
                   "Returns the master Remote Controller's information, which includes the unique identifier, name, and password.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Returns the master Remote Controller's information, which includes the unique identifier, name, and password.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getJoinedMasterRCInfos_inline",
                   "",
            ],
            [
                   "CONNECTED_MASTER_CREDENTIALS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getJoinedMasterRCInfos_inline",
                   "SDK Key for getConnectedMasterCredentials: Returns the master Remote Controller's information, which includes the unique identifier, name, and password.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getConnectedMasterCredentials: Returns the master Remote Controller's information, which includes the unique identifier, name, and password.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getJoinedMasterRCInfos_inline",
                   "",
            ],
            [
                   "setMasterAuthorizationCode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setMasterAuthorizationCode_inline",
                   "Sets the authorization code of a master remote controller. The slave remote controller needs to know the authorization code in order to join the master. A valid input is a string with 6 digits. The default value is 888888. It can only be called when the remote controller is in master mode.  @param authorizationCode Authorization code to set. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the authorization code of a master remote controller. The slave remote controller needs to know the authorization code in order to join the master. A valid input is a string with 6 digits. The default value is 888888. It can only be called when the remote controller is in master mode.  @param authorizationCode Authorization code to set. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setMasterAuthorizationCode_inline",
                   "",
            ],
            [
                   "SET_MASTER_AUTH_CODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setMasterAuthorizationCode_inline",
                   "SDK Key for setMasterAuthorizationCode: Sets the authorization code of a master remote controller. The slave remote controller needs to know the authorization code in order to join the master. A valid input is a string with 6 digits. The default value is 888888. It can only be called when the remote controller is in master mode.  @param authorizationCode Authorization code to set. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setMasterAuthorizationCode: Sets the authorization code of a master remote controller. The slave remote controller needs to know the authorization code in order to join the master. A valid input is a string with 6 digits. The default value is 888888. It can only be called when the remote controller is in master mode.  @param authorizationCode Authorization code to set. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setMasterAuthorizationCode_inline",
                   "",
            ],
            [
                   "getMasters",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasters_inline",
                   "Gets a list of the nearby remote controllers in master mode. It can only be called when the remote controller is in slave mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets a list of the nearby remote controllers in master mode. It can only be called when the remote controller is in slave mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasters_inline",
                   "",
            ],
            [
                   "MASTER_LIST",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasters_inline",
                   "SDK Key for getMasters: Gets a list of the nearby remote controllers in master mode. It can only be called when the remote controller is in slave mode.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getMasters: Gets a list of the nearby remote controllers in master mode. It can only be called when the remote controller is in slave mode.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getMasters_inline",
                   "",
            ],
            [
                   "connectToMaster",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterWithIDAndAuthenticationCode_inline",
                   "Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. In this case, code</code> can be `null`. It can only be called when the remote controller is in slave mode.  @param info JoinMasterData object. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. In this case, code</code> can be `null`. It can only be called when the remote controller is in slave mode.  @param info JoinMasterData object. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterWithIDAndAuthenticationCode_inline",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER_WITH_ID",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterWithIDAndAuthenticationCode_inline",
                   "SDK Key for connectToMaster: Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. In this case, code</code> can be `null`. It can only be called when the remote controller is in slave mode.  @param info JoinMasterData object. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for connectToMaster: Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authorization code is not required until the master remote controller changes its authorization code. In this case, code</code> can be `null`. It can only be called when the remote controller is in slave mode.  @param info JoinMasterData object. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_joinMasterWithIDAndAuthenticationCode_inline",
                   "",
            ],
            [
                   "requestGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_requestGimbalControl_inline",
                   "Requests the gimbal control from the other remote controller. Different from `requestLegacyGimbalControl`, the gimbal control permission is transferred to the remote controller without the reply from the master remote controller. The master remote controller can attain the gimbal control back by calling the same method. It is only supported by Inspire 2, M200 series and Cendence.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Requests the gimbal control from the other remote controller. Different from `requestLegacyGimbalControl`, the gimbal control permission is transferred to the remote controller without the reply from the master remote controller. The master remote controller can attain the gimbal control back by calling the same method. It is only supported by Inspire 2, M200 series and Cendence.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_requestGimbalControl_inline",
                   "",
            ],
            [
                   "respondToRequestForGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_responseRequester_inline",
                   "When a slave Remote Controller requests a master Remote Controller to control the gimbal, this method is used by a master Remote Controller to respond to the slave Remote Controller's request.  @param response The response object of ResponseForGimbalControl to the slave Remote Controller.",
            ],
            [
                   "When a slave Remote Controller requests a master Remote Controller to control the gimbal, this method is used by a master Remote Controller to respond to the slave Remote Controller's request.  @param response The response object of ResponseForGimbalControl to the slave Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_responseRequester_inline",
                   "",
            ],
            [
                   "RESPONSE_TO_REQUEST_FOR_GIMBAL_CONTROL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_responseRequester_inline",
                   "SDK Key for respondToRequestForGimbalControl: When a slave Remote Controller requests a master Remote Controller to control the gimbal, this method is used by a master Remote Controller to respond to the slave Remote Controller's request.  @param response The response object of ResponseForGimbalControl to the slave Remote Controller.",
            ],
            [
                   "SDK Key for respondToRequestForGimbalControl: When a slave Remote Controller requests a master Remote Controller to control the gimbal, this method is used by a master Remote Controller to respond to the slave Remote Controller's request.  @param response The response object of ResponseForGimbalControl to the slave Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_responseRequester_inline",
                   "",
            ],
            [
                   "requestLegacyGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_requestGimbalControlRight_inline",
                   "Called by the slave Remote Controller to request gimbal control from the master Remote Controller. It is only supported by Inspire 1 and DJI Lightbridge 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Called by the slave Remote Controller to request gimbal control from the master Remote Controller. It is only supported by Inspire 1 and DJI Lightbridge 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_requestGimbalControlRight_inline",
                   "",
            ],
            [
                   "setCustomGimbalMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomGimbalMapping_inline",
                   "Sets the Remote Controller's slave control mode.  @param mapping The DJIRCGimbalMapping object. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the Remote Controller's slave control mode.  @param mapping The DJIRCGimbalMapping object. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomGimbalMapping_inline",
                   "",
            ],
            [
                   "CUSTOM_GIMBAL_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomGimbalMapping_inline",
                   "SDK Key for setCustomGimbalMapping: Sets the Remote Controller's slave control mode.  @param mapping The DJIRCGimbalMapping object. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setCustomGimbalMapping: Sets the Remote Controller's slave control mode.  @param mapping The DJIRCGimbalMapping object. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setCustomGimbalMapping_inline",
                   "",
            ],
            [
                   "getCustomGimbalMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomGimbalMapping_inline",
                   "Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomGimbalMapping_inline",
                   "",
            ],
            [
                   "CUSTOM_GIMBAL_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomGimbalMapping_inline",
                   "SDK Key for getCustomGimbalMapping: Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getCustomGimbalMapping: Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getCustomGimbalMapping_inline",
                   "",
            ],
            [
                   "setGimbalMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveControlMode_inline",
                   "Sets the Remote Controller's slave control mode.  @param style Control mode to be set. @param callback Remote execution result error callback.",
            ],
            [
                   "Sets the Remote Controller's slave control mode.  @param style Control mode to be set. @param callback Remote execution result error callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveControlMode_inline",
                   "",
            ],
            [
                   "GIMBAL_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveControlMode_inline",
                   "SDK Key for setGimbalMappingStyle: Sets the Remote Controller's slave control mode.  @param style Control mode to be set. @param callback Remote execution result error callback.",
            ],
            [
                   "SDK Key for setGimbalMappingStyle: Sets the Remote Controller's slave control mode.  @param style Control mode to be set. @param callback Remote execution result error callback.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveControlMode_inline",
                   "",
            ],
            [
                   "getGimbalMappingStyle",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveControlMode_inline",
                   "Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveControlMode_inline",
                   "",
            ],
            [
                   "GIMBAL_MAPPING_STYLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveControlMode_inline",
                   "SDK Key for getGimbalMappingStyle: Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getGimbalMappingStyle: Gets the Remote Controller's slave control mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveControlMode_inline",
                   "",
            ],
            [
                   "setGimbalControlSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveJoystickControlGimbalSpeed_inline",
                   "Called by the slave Remote Controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedCoefficient Speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "Called by the slave Remote Controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedCoefficient Speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveJoystickControlGimbalSpeed_inline",
                   "",
            ],
            [
                   "GIMBAL_CONTROL_SPEED_COEFFICIENT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveJoystickControlGimbalSpeed_inline",
                   "SDK Key for setGimbalControlSpeedCoefficient: Called by the slave Remote Controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedCoefficient Speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
            ],
            [
                   "SDK Key for setGimbalControlSpeedCoefficient: Called by the slave Remote Controller to set the gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param speedCoefficient Speed to be set for gimbal's pitch, roll, and yaw, which should be in the range of [0, 100]. @param callback Remote execution result error callback. See `BaseComponent` for more information about the callback and what is recommended be done with it.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSlaveJoystickControlGimbalSpeed_inline",
                   "",
            ],
            [
                   "getGimbalControlSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveJoystickControlGimbalSpeed_inline",
                   "Gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveJoystickControlGimbalSpeed_inline",
                   "",
            ],
            [
                   "GIMBAL_CONTROL_SPEED_COEFFICIENT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveJoystickControlGimbalSpeed_inline",
                   "SDK Key for getGimbalControlSpeedCoefficient: Gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getGimbalControlSpeedCoefficient: Gets the current slave's gimbal's pitch, roll, and yaw speed with a range of [0, 100].  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSlaveJoystickControlGimbalSpeed_inline",
                   "",
            ],
            [
                   "isCustomizableButtonSupported",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isCustomizableButtonSupported_inline",
                   "`true` if the remote controller supports customizable buttons. With the customizable buttons, the user can define the action bound to a button. When the button is clicked, the corresponding action can be received from the .   Only Cendence supports customizable buttons. This is distinct from remote   controllers with buttons C1 and C2 that support custom tags and a binding to DJI Go.  @return TRUE to support customizable button.",
            ],
            [
                   "`true` if the remote controller supports customizable buttons. With the customizable buttons, the user can define the action bound to a button. When the button is clicked, the corresponding action can be received from the .   Only Cendence supports customizable buttons. This is distinct from remote   controllers with buttons C1 and C2 that support custom tags and a binding to DJI Go.  @return TRUE to support customizable button.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isCustomizableButtonSupported_inline",
                   "",
            ],
            [
                   "getButtonProfileGroups",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getButtonProfileGroups_inline",
                   "Gets the names of the customizable button profile groups. The configurations of the customizable buttons are organized as groups. The maximum number of groups is 5 and each group contains 3 profiles. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the names of the customizable button profile groups. The configurations of the customizable buttons are organized as groups. The maximum number of groups is 5 and each group contains 3 profiles. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getButtonProfileGroups_inline",
                   "",
            ],
            [
                   "addButtonProfileGroup",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addButtonProfileGroup_inline",
                   "Adds a group of customizable button profiles. Three default profiles will be created for the newly added group. The default profile can accessed through `getButtonActions`. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to be added. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Adds a group of customizable button profiles. Three default profiles will be created for the newly added group. The default profile can accessed through `getButtonActions`. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to be added. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_addButtonProfileGroup_inline",
                   "",
            ],
            [
                   "removeButtonProfileGroup",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeButtonProfileGroup_inline",
                   "Removes a group from the customizable button profiles. There must be at least one group, therefore, the removal of the last group will fail. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to be removed. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Removes a group from the customizable button profiles. There must be at least one group, therefore, the removal of the last group will fail. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to be removed. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_removeButtonProfileGroup_inline",
                   "",
            ],
            [
                   "renameButtonProfileGroup",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_renameButtonProfileGroup_inline",
                   "Renames a profile group to a new name. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param oldProfileName The name of the group to be renamed. @param newProfileName The new profile group name. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Renames a profile group to a new name. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param oldProfileName The name of the group to be renamed. @param newProfileName The new profile group name. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_renameButtonProfileGroup_inline",
                   "",
            ],
            [
                   "selectButtonProfileGroup",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_selectButtonProfileGroup_inline",
                   "Selects the customizable button profile group. The profile with 0 configIndex in the group will be applied. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to select. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Selects the customizable button profile group. The profile with 0 configIndex in the group will be applied. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param groupName The name of the group to select. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_selectButtonProfileGroup_inline",
                   "",
            ],
            [
                   "getSelectedButtonProfileGroup",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSelectedButtonProfileGroup_inline",
                   "Gets the name of the selected customizable button profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the name of the selected customizable button profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSelectedButtonProfileGroup_inline",
                   "",
            ],
            [
                   "selectButtonProfile",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_selectButtonProfile_inline",
                   "Selects the customizable button profile with the specific index in the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param profileIndex The index of the profile to select. The valid range is [0, 2]. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Selects the customizable button profile with the specific index in the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param profileIndex The index of the profile to select. The valid range is [0, 2]. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_selectButtonProfile_inline",
                   "",
            ],
            [
                   "getSelectedButtonProfile",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSelectedButtonProfile_inline",
                   "Gets the index of the selected button profile in the selected group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the index of the selected button profile in the selected group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSelectedButtonProfile_inline",
                   "",
            ],
            [
                   "setButtonConfig",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setButtonConfig_inline",
                   "Customizes the button configuration. The configuration will be applied to the remote controller immediately and will be stored into the selected profile of the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`. Supported by the Cendence remote controller.  @param config The configuration to be set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Customizes the button configuration. The configuration will be applied to the remote controller immediately and will be stored into the selected profile of the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`. Supported by the Cendence remote controller.  @param config The configuration to be set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setButtonConfig_inline",
                   "",
            ],
            [
                   "getButtonConfig",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getButtonConfig_inline",
                   "Gets the button configuration being applied to the remote controller. It is only valid when `isCustomizableButtonSupported` returns `true`. Supported by the Cendence remote controller.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the button configuration being applied to the remote controller. It is only valid when `isCustomizableButtonSupported` returns `true`. Supported by the Cendence remote controller.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getButtonConfig_inline",
                   "",
            ],
            [
                   "resetButtonConfig",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_resetButtonConfig_inline",
                   "Resets the selected button configuration to the default settings. The default configuration will be applied to the remote controller and will be stored into the selected index of the activated user. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Resets the selected button configuration to the default settings. The default configuration will be applied to the remote controller and will be stored into the selected index of the activated user. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_resetButtonConfig_inline",
                   "",
            ],
            [
                   "customizeButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_customizeButton_inline",
                   "Customizes the action of a button. The new setting will be applied to the remote controller and will be stored into the selected profile index of the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param button The customizable button. @param action The action to be bound to the button. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Customizes the action of a button. The new setting will be applied to the remote controller and will be stored into the selected profile index of the selected profile group. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param button The customizable button. @param action The action to be bound to the button. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_customizeButton_inline",
                   "",
            ],
            [
                   "fetchCustomizedActionOfButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_fetchCustomizedActionOfButton_inline",
                   "Fetches the customized action of a button in the selected configuration. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param button The customizable button. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Fetches the customized action of a button in the selected configuration. It is only valid when `isCustomizableButtonSupported` returns `true`.  @param button The customizable button. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_fetchCustomizedActionOfButton_inline",
                   "",
            ],
            [
                   "setControllingGimbalIndex",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setControllingGimbalIndex_inline",
                   "Directs commands of the physical buttons on the remote controller (rotating gimbal, shoot photo, record video, etc.) to the specific gimbal, when there are multiple gimbals connected. If there is only one gimbal connected, this setting is reset to the remaining gimbal. Enabling `setAttitudeSynchronizationEnabled` will reset this setting to index 0 and when `setAttitudeSynchronizationEnabled` is enabled, index can only be set to 0. It is only supported by M210, M210 RTK and Matrice 300 RTK.  @param index Index of the gimbal to receive the remote controller commands. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Directs commands of the physical buttons on the remote controller (rotating gimbal, shoot photo, record video, etc.) to the specific gimbal, when there are multiple gimbals connected. If there is only one gimbal connected, this setting is reset to the remaining gimbal. Enabling `setAttitudeSynchronizationEnabled` will reset this setting to index 0 and when `setAttitudeSynchronizationEnabled` is enabled, index can only be set to 0. It is only supported by M210, M210 RTK and Matrice 300 RTK.  @param index Index of the gimbal to receive the remote controller commands. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setControllingGimbalIndex_inline",
                   "",
            ],
            [
                   "getControllingGimbalIndex",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getControllingGimbalIndex_inline",
                   "The index of the gimbal that the remote controller is controlling. Commands of the physical buttons (rotating gimbal, shoot photo, record video, etc.) will be directed to the specific gimbal. If there is only one gimbal connected, this setting is reset to the remaining gimbal's index. Enabling `setAttitudeSynchronizationEnabled` will reset the value to 0. For product that supports only one gimbal, the value is always 0.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "The index of the gimbal that the remote controller is controlling. Commands of the physical buttons (rotating gimbal, shoot photo, record video, etc.) will be directed to the specific gimbal. If there is only one gimbal connected, this setting is reset to the remaining gimbal's index. Enabling `setAttitudeSynchronizationEnabled` will reset the value to 0. For product that supports only one gimbal, the value is always 0.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getControllingGimbalIndex_inline",
                   "",
            ],
            [
                   "isSecondaryVideoOutputSupported",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isSecondaryVideoOutputSupported_inline",
                   "Return whether secondary video output supported. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @return A boolean value.",
            ],
            [
                   "Return whether secondary video output supported. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_isSecondaryVideoOutputSupported_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOutputEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputEnabled_inline",
                   "Enable secondary video output on Remote Controller. The remote controller outputs video to the Mobile Device by default. This will enable a secondary video stream to one of the Remote Controller's physical HDMI and SDI ports. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param enabled Enables secondary video output. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enable secondary video output on Remote Controller. The remote controller outputs video to the Mobile Device by default. This will enable a secondary video stream to one of the Remote Controller's physical HDMI and SDI ports. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param enabled Enables secondary video output. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputEnabled_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOutputEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputEnabled_inline",
                   "Gets whether secondary video output on Remote Controller is enabled. The Remote Controller outputs video to the Mobile Device by default, but a secondary video can be routed to its HDMI or SDI port. Use `setSecondaryVideoOutputEnabled` to enable or disable,  and `setSecondaryVideoOutputPort` to choose the port. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets whether secondary video output on Remote Controller is enabled. The Remote Controller outputs video to the Mobile Device by default, but a secondary video can be routed to its HDMI or SDI port. Use `setSecondaryVideoOutputEnabled` to enable or disable,  and `setSecondaryVideoOutputPort` to choose the port. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputEnabled_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOutputPort",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputPort_inline",
                   "Sets secondary video output port on Remote Controller. HDMI or SDI are possible. Only one port can be active at once. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param port Secondary video output port. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets secondary video output port on Remote Controller. HDMI or SDI are possible. Only one port can be active at once. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param port Secondary video output port. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputPort_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOutputPort",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputPort_inline",
                   "Gets the secondary video output port on Remote Controller. HDMI or SDI are possible. Only one port can be active at once. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the secondary video output port on Remote Controller. HDMI or SDI are possible. Only one port can be active at once. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputPort_inline",
                   "",
            ],
            [
                   "setSecondaryVideoDisplay",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoDisplayMode_inline",
                   "Sets the secondary video output Picture in Picture (PIP) display mode. The remote controller module can connect to both an FPV camera (through the HDMI and AV ports) and a camera mounted on the HD Gimbal (through the Gimbal port). The output video can then be a combination of the two video sources. Either a single video source can be  displayed, or one can be displayed within the other (as a Picture in Picture, or PIP). If the mode is set incorrectly,  then no output video will be displayed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param mode Picture in Picture (PIP) display mode. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the secondary video output Picture in Picture (PIP) display mode. The remote controller module can connect to both an FPV camera (through the HDMI and AV ports) and a camera mounted on the HD Gimbal (through the Gimbal port). The output video can then be a combination of the two video sources. Either a single video source can be  displayed, or one can be displayed within the other (as a Picture in Picture, or PIP). If the mode is set incorrectly,  then no output video will be displayed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param mode Picture in Picture (PIP) display mode. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoDisplayMode_inline",
                   "",
            ],
            [
                   "getSecondaryVideoDisplay",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoDisplayMode_inline",
                   "Gets the secondary video output Picture in Picture (PIP) display mode. The air link module can connect to both an  FPV camera (through the HDMI and AV ports) and a camera mounted on the HD Gimbal (through the Gimbal port). The  output video can then be a combination of the two video sources. Either a single video source can be displayed, or  one can be displayed within the other (as a Picture in Picture, or PIP). It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the secondary video output Picture in Picture (PIP) display mode. The air link module can connect to both an  FPV camera (through the HDMI and AV ports) and a camera mounted on the HD Gimbal (through the Gimbal port). The  output video can then be a combination of the two video sources. Either a single video source can be displayed, or  one can be displayed within the other (as a Picture in Picture, or PIP). It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoDisplayMode_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDEnabled_inline",
                   "Enables and disables On Screen Display (OSD) overlay on the secondary video. OSD is flight data like altitude, attitude etc. And can be overlayed on the PIP video. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param enabled Determines whether to display OSD on screen. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Enables and disables On Screen Display (OSD) overlay on the secondary video. OSD is flight data like altitude, attitude etc. And can be overlayed on the PIP video. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param enabled Determines whether to display OSD on screen. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDEnabled_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDEnabled_inline",
                   "Determines whether On Screen Display (OSD) is overlayed on the video feed.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Determines whether On Screen Display (OSD) is overlayed on the video feed.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDEnabled_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDTopMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDTopMargin_inline",
                   "Sets the OSD top margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Top margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the OSD top margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Top margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDTopMargin_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDTopMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDTopMargin_inline",
                   "Gets the OSD top margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OSD top margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDTopMargin_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDLeftMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDLeftMargin_inline",
                   "Sets the OSD left margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Left margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the OSD left margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Left margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDLeftMargin_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDLeftMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDLeftMargin_inline",
                   "Gets the OSD left margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OSD left margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDLeftMargin_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDBottomMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDBottomMargin_inline",
                   "Sets the OSD bottom margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Bottom margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the OSD bottom margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Bottom margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDBottomMargin_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDBottomMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDBottomMargin_inline",
                   "Gets the OSD bottom margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OSD bottom margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDBottomMargin_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDRightMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDRightMargin_inline",
                   "Sets the OSD right margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Right margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the OSD right margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param margin Right margin of OSD. The range is [0, 50]. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDRightMargin_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDRightMargin",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDRightMargin_inline",
                   "Gets the OSD right margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OSD right margin in video pixels. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDRightMargin_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOSDUnit",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDUnit_inline",
                   "Sets the OSD units to either metric or imperial. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param unit OSD units. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the OSD units to either metric or imperial. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param unit OSD units. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOSDUnit_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOSDUnit",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDUnit_inline",
                   "Gets the OSD units (metric or imperial). It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OSD units (metric or imperial). It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOSDUnit_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOutputFormatForHDMI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputFormatForHDMI_inline",
                   "Sets the Remote Controller HDMI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param format The value of the `SecondaryVideoFormat` Enum. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the Remote Controller HDMI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param format The value of the `SecondaryVideoFormat` Enum. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputFormatForHDMI_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOutputFormatForHDMI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputFormatForHDMI_inline",
                   "Gets the Remote Controller HDMI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the Remote Controller HDMI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputFormatForHDMI_inline",
                   "",
            ],
            [
                   "setSecondaryVideoOutputFormatForSDI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputFormatForSDI_inline",
                   "Sets the Remote Controller SDI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param format The value of the `SecondaryVideoFormat` Enum. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the Remote Controller SDI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param format The value of the `SecondaryVideoFormat` Enum. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoOutputFormatForSDI_inline",
                   "",
            ],
            [
                   "getSecondaryVideoOutputFormatForSDI",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputFormatForSDI_inline",
                   "Gets the Remote Controller SDI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Gets the Remote Controller SDI video port output video format. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoOutputFormatForSDI_inline",
                   "",
            ],
            [
                   "setSecondaryVideoPIPPosition",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoPIPPosition_inline",
                   "Sets the PIP (Picture In Picture) position relative to the top left corner of the main subject video feed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param position Position of the PIP on the screen. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the PIP (Picture In Picture) position relative to the top left corner of the main subject video feed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param position Position of the PIP on the screen. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSecondaryVideoPIPPosition_inline",
                   "",
            ],
            [
                   "getSecondaryVideoPIPPosition",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoPIPPosition_inline",
                   "Gets the PIP (Picture In Picture) position relative to the top left corner of the main subject video feed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the PIP (Picture In Picture) position relative to the top left corner of the main subject video feed. It is supported by Phantom 4 Professional, Matrice 200, Matrice 200 series V2, Inspire 1 and Inspire 2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSecondaryVideoPIPPosition_inline",
                   "",
            ],
            [
                   "setLiveViewSimultaneousOutputEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setLiveViewSimultaneousOutputEnabled_inline",
                   "Enables the setting to output video to both the mobile device and the HDMI port on the remote controller simultaneously. When it is disabled and the remote controller is connected to a HDMI display, the mobile device will not receive the live view. It is only supported by Inspire 1 and M100.  @param enabled `true` to enable live view simultaneous output. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Enables the setting to output video to both the mobile device and the HDMI port on the remote controller simultaneously. When it is disabled and the remote controller is connected to a HDMI display, the mobile device will not receive the live view. It is only supported by Inspire 1 and M100.  @param enabled `true` to enable live view simultaneous output. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setLiveViewSimultaneousOutputEnabled_inline",
                   "",
            ],
            [
                   "getLiveViewSimultaneousOutputEnabled",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getLiveViewSimultaneousOutputEnabled_inline",
                   "Determines whether the setting to output video to both the mobile device and the HDMI port on the remote controller simultaneously is enabled or not. When it is disabled and the remote controller is connected to a HDMI display, the mobile device will not receive the live view. It is only supported by Inspire 1 and M100.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Determines whether the setting to output video to both the mobile device and the HDMI port on the remote controller simultaneously is enabled or not. When it is disabled and the remote controller is connected to a HDMI display, the mobile device will not receive the live view. It is only supported by Inspire 1 and M100.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getLiveViewSimultaneousOutputEnabled_inline",
                   "",
            ],
            [
                   "isFocusControllerSupported",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_remoteFocusSupportChecking_inline",
                   "Query method to check if the Remote Controller supports Remote Focus State Checking.  @return A boolean value.",
            ],
            [
                   "Query method to check if the Remote Controller supports Remote Focus State Checking.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_remoteFocusSupportChecking_inline",
                   "",
            ],
            [
                   "IS_FOCUS_CONTROLLER_SUPPORTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_remoteFocusSupportChecking_inline",
                   "SDK Key for isFocusControllerSupported: Query method to check if the Remote Controller supports Remote Focus State Checking.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFocusControllerSupported: Query method to check if the Remote Controller supports Remote Focus State Checking.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_remoteFocusSupportChecking_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "",
                   "Callback function that updates the Remote Controller's current GPS data.",
            ],
            [
                   "Callback function that updates the Remote Controller's current GPS data.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "GPS_DATA",
                   2,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "",
                   "SDK Key for Callback: Callback function that updates the Remote Controller's current GPS data.",
            ],
            [
                   "SDK Key for Callback: Callback function that updates the Remote Controller's current GPS data.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "MasterSearchingCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "",
                   "Receives the information of available master remote controllers. `onMasterListUpdate` will be called repeated with 1 second interval once master searching is started successfully. It will stop when the searching is stopped either by the remote controller itself or by calling `stopMasterSearching`.",
            ],
            [
                   "Receives the information of available master remote controllers. `onMasterListUpdate` will be called repeated with 1 second interval once master searching is started successfully. It will stop when the searching is stopped either by the remote controller itself or by calling `stopMasterSearching`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "RTKChannelEnabledUpdatedCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RTKChannelEnabledUpdatedCallbackInterface.html",
                   "",
                   "Interface to receive the current RTK channel enabled from the remote controller that supporting multi-device pairing.",
            ],
            [
                   "Interface to receive the current RTK channel enabled from the remote controller that supporting multi-device pairing.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RTKChannelEnabledUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCHardwareStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateHardwareState_inline",
                   "Callback function that updates the Remote Controller's current hardware state (e.g. the state of the physical buttons and joysticks).  @param hardwareState Current state of the Remote Controller's hardware state.",
            ],
            [
                   "Callback function that updates the Remote Controller's current hardware state (e.g. the state of the physical buttons and joysticks).  @param hardwareState Current state of the Remote Controller's hardware state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCHardwareStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateHardwareState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "#DJIRemoteController_updateGpsData_inline",
                   "Callback function that updates the Remote Controller's current GPS data.  @param gpsData Current state of the Remote Controller's GPS data.",
            ],
            [
                   "Callback function that updates the Remote Controller's current GPS data.  @param gpsData Current state of the Remote Controller's GPS data.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "#DJIRemoteController_updateGpsData_inline",
                   "",
            ],
            [
                   "GPS_DATA",
                   2,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "#DJIRemoteController_updateGpsData_inline",
                   "SDK Key for onUpdate: Callback function that updates the Remote Controller's current GPS data.  @param gpsData Current state of the Remote Controller's GPS data.",
            ],
            [
                   "SDK Key for onUpdate: Callback function that updates the Remote Controller's current GPS data.  @param gpsData Current state of the Remote Controller's GPS data.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_updateGpsDataCallbackInterface.html",
                   "#DJIRemoteController_updateGpsData_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateBatteryState_inline",
                   "Callback function that updates the Remote Controller's current battery state.  @param batteryState Current state of the Remote Controller's battery state.",
            ],
            [
                   "Callback function that updates the Remote Controller's current battery state.  @param batteryState Current state of the Remote Controller's battery state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCBatteryStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateBatteryState_inline",
                   "",
            ],
            [
                   "onReceive",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCReceiveGimbalControlRequestFromSlaveCallbackInterface.html",
                   "#DJIRemoteController_receiveGimbalControlRequestFromSlave_inline",
                   "Callback function that gets called when a slave Remote Controller makes a request to a master Remote Controller to control the gimbal using the method requestGimbalControlRightWithCallbackBlock.  @param information Information of the slave making the request to the master Remote Controller.",
            ],
            [
                   "Callback function that gets called when a slave Remote Controller makes a request to a master Remote Controller to control the gimbal using the method requestGimbalControlRightWithCallbackBlock.  @param information Information of the slave making the request to the master Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCReceiveGimbalControlRequestFromSlaveCallbackInterface.html",
                   "#DJIRemoteController_receiveGimbalControlRequestFromSlave_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCRemoteFocusStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateRemoteFocusState_inline",
                   "Callback function that updates the Remote Focus State, only support Focus product. If the isRCRemoteFocusCheckingSupported is `true`, this  callback function will be called.  @param remoteFocusState Current state of the Remote Focus state.",
            ],
            [
                   "Callback function that updates the Remote Focus State, only support Focus product. If the isRCRemoteFocusCheckingSupported is `true`, this  callback function will be called.  @param remoteFocusState Current state of the Remote Focus state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCRemoteFocusStateUpdateCallbackInterface.html",
                   "#DJIRemoteController_updateRemoteFocusState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "#DJIRemoteController_didUpdateMasterSlaveState_inline",
                   "Callback function that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param masterSlaveState The remote controller's state related to the master and slave mode.",
            ],
            [
                   "Callback function that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param masterSlaveState The remote controller's state related to the master and slave mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "#DJIRemoteController_didUpdateMasterSlaveState_inline",
                   "",
            ],
            [
                   "MASTER_SLAVE_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "#DJIRemoteController_didUpdateMasterSlaveState_inline",
                   "SDK Key for onUpdate: Callback function that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param masterSlaveState The remote controller's state related to the master and slave mode.",
            ],
            [
                   "SDK Key for onUpdate: Callback function that updates the remote controller's state related to the master and slave mode. Only supported by Inspire 2.  @param masterSlaveState The remote controller's state related to the master and slave mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "#DJIRemoteController_didUpdateMasterSlaveState_inline",
                   "",
            ],
            [
                   "onResult",
                   2,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "#DJIRemoteController_MasterSearchingCallback_onResult_inline",
                   "Execution result of `startMasterSearching`.  @param error Error retrieving the value.",
            ],
            [
                   "Execution result of `startMasterSearching`.  @param error Error retrieving the value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "#DJIRemoteController_MasterSearchingCallback_onResult_inline",
                   "",
            ],
            [
                   "onMasterListUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "#DJIRemoteController_MasterSearchingCallback_onMasterListUpdate_inline",
                   "Called every 1 seconds to get available master remote controllers' information.  @param informationList Information list array.",
            ],
            [
                   "Called every 1 seconds to get available master remote controllers' information.  @param informationList Information list array.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_MasterSearchingCallbackInterface.html",
                   "#DJIRemoteController_MasterSearchingCallback_onMasterListUpdate_inline",
                   "",
            ],
            [
                   "onRTKChannelEnabledUpdate",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RTKChannelEnabledUpdatedCallbackInterface.html",
                   "#DJIRemoteController_RTKChannelEnabledUpdatedCallback_onRTKChannelEnabledUpdate_inline",
                   "Method to receive the current RTK channel enabled from the remote controller that supporting multi-device pairing.  @param enabled The current RTK channel enabled.",
            ],
            [
                   "Method to receive the current RTK channel enabled from the remote controller that supporting multi-device pairing.  @param enabled The current RTK channel enabled.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RTKChannelEnabledUpdatedCallbackInterface.html",
                   "#DJIRemoteController_RTKChannelEnabledUpdatedCallback_onRTKChannelEnabledUpdate_inline",
                   "",
            ],
            [
                   "HardwareState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "",
                   "Remote Controller's current state.",
            ],
            [
                   "Remote Controller's current state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "",
                   "",
            ],
            [
                   "SecondaryVideoOutputPort",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_inline",
                   "Remote Controller port to which to send secondary video (in addition to USB video sent to the Mobile Device).",
            ],
            [
                   "Remote Controller port to which to send secondary video (in addition to USB video sent to the Mobile Device).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOutputPort_inline",
                   "",
            ],
            [
                   "SecondaryVideoDisplayMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_inline",
                   "Defines the combination of video sources to form the secondary output video. The secondary output can display video streams from one or two input sources. When the encode mode is single: Source 1 represents video from one of the Source1Only input ports (HDMI or AV). Source 2 represents video from EXT input port  (HD Gimbal Camera). When the encode mode is dual: Source 1 represents video from HDMI input port.  Source 2 represents video from AV input port.",
            ],
            [
                   "Defines the combination of video sources to form the secondary output video. The secondary output can display video streams from one or two input sources. When the encode mode is single: Source 1 represents video from one of the Source1Only input ports (HDMI or AV). Source 2 represents video from EXT input port  (HD Gimbal Camera). When the encode mode is dual: Source 1 represents video from HDMI input port.  Source 2 represents video from AV input port.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoDisplayMode_inline",
                   "",
            ],
            [
                   "SecondaryVideoOSDUnit",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_inline",
                   "OSD data units.",
            ],
            [
                   "OSD data units.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoOSDUnit_inline",
                   "",
            ],
            [
                   "SecondaryVideoFormat",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_inline",
                   "Secondary output video resolution and frame rate.",
            ],
            [
                   "Secondary output video resolution and frame rate.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSecondaryVideoFormat_inline",
                   "",
            ],
            [
                   "PIPPosition",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_inline",
                   "PIP (Picture In Picture) position on the screen relative to the main subject video.",
            ],
            [
                   "PIP (Picture In Picture) position on the screen relative to the main subject video.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_inline",
                   "",
            ],
            [
                   "GPSData",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "",
                   "Remote Controller's GPS data. Only supported by Remote Controller using DJI Lightbridge.",
            ],
            [
                   "Remote Controller's GPS data. Only supported by Remote Controller using DJI Lightbridge.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "",
                   "",
            ],
            [
                   "GPS_DATA",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "",
                   "SDK Key for GPSData: Remote Controller's GPS data. Only supported by Remote Controller using DJI Lightbridge.",
            ],
            [
                   "SDK Key for GPSData: Remote Controller's GPS data. Only supported by Remote Controller using DJI Lightbridge.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGPSData.html",
                   "",
                   "",
            ],
            [
                   "BatteryState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "",
                   "Remote Controller's battery information. Only supported by DJI Smart Controller Enterprise with firmware version v01.00.01.01 and above.",
            ],
            [
                   "Remote Controller's battery information. Only supported by DJI Smart Controller Enterprise with firmware version v01.00.01.01 and above.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "",
                   "",
            ],
            [
                   "RemoteControllerKey.BATTERY_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "",
                   "SDK Key for BatteryState: Remote Controller's battery information. Only supported by DJI Smart Controller Enterprise with firmware version v01.00.01.01 and above.",
            ],
            [
                   "SDK Key for BatteryState: Remote Controller's battery information. Only supported by DJI Smart Controller Enterprise with firmware version v01.00.01.01 and above.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCBatteryInfo.html",
                   "",
                   "",
            ],
            [
                   "FocusControllerState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "",
                   "Remote Controller's Remote Focus State. The focus product has one dial (focus control) that controls two separate parts of the camera: focal length and aperture. However it can only control one of these at any one time and is an absolute dial, meaning that a specific rotational position of the dial corresponds to a specific focal length or aperture. This means that whenever the dial control mode is changed, the dial first has to be reset to the new mode's previous dial position before the dial can be used to adjust the setting of the new mode. Example workflow:<br/><ol> - Use dial to set an Aperture of f2.2  - Change dial control mode to focal length (set `ControlType`) - Use the dial to change the focal length - Change dial control mode back to aperture -  set `ControlType`  - `isWorking` will now be NO -  Adjust dial back to f2.2 - `Direction` is the direction the dial should be rotated - `isWorking` will become YES when set back to f2.2 - Now the dial can be used to adjust the aperture.</ol>",
            ],
            [
                   "Remote Controller's Remote Focus State. The focus product has one dial (focus control) that controls two separate parts of the camera: focal length and aperture. However it can only control one of these at any one time and is an absolute dial, meaning that a specific rotational position of the dial corresponds to a specific focal length or aperture. This means that whenever the dial control mode is changed, the dial first has to be reset to the new mode's previous dial position before the dial can be used to adjust the setting of the new mode. Example workflow:<br/><ol> - Use dial to set an Aperture of f2.2  - Change dial control mode to focal length (set `ControlType`) - Use the dial to change the focal length - Change dial control mode back to aperture -  set `ControlType`  - `isWorking` will now be NO -  Adjust dial back to f2.2 - `Direction` is the direction the dial should be rotated - `isWorking` will become YES when set back to f2.2 - Now the dial can be used to adjust the aperture.</ol>",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCRemoteFocusState.html",
                   "",
                   "",
            ],
            [
                   "PairingState",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_inline",
                   "Remote Controller pairing state.",
            ],
            [
                   "Remote Controller pairing state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.PAIRING_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_inline",
                   "SDK Key for PairingState: Remote Controller pairing state.",
            ],
            [
                   "SDK Key for PairingState: Remote Controller pairing state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_inline",
                   "",
            ],
            [
                   "AircraftMapping",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "",
                   "The object representing the stick mapping configuration of the remote controller.",
            ],
            [
                   "The object representing the stick mapping configuration of the remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "",
                   "",
            ],
            [
                   "AIRCRAFT_CUSTOM_MAPPING",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "",
                   "SDK Key for AircraftMapping: The object representing the stick mapping configuration of the remote controller.",
            ],
            [
                   "SDK Key for AircraftMapping: The object representing the stick mapping configuration of the remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCAircraftMapping.html",
                   "",
                   "",
            ],
            [
                   "GimbalAxis",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_inline",
                   "Defines what the Gimbal Dial (upper left dial on the Remote Controller) will control.",
            ],
            [
                   "Defines what the Gimbal Dial (upper left dial on the Remote Controller) will control.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_inline",
                   "",
            ],
            [
                   "CustomButtonTags",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "",
                   "Tags for C1 and C2 buttons on the remote controller",
            ],
            [
                   "Tags for C1 and C2 buttons on the remote controller",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_TAGS",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "",
                   "SDK Key for CustomButtonTags: Tags for C1 and C2 buttons on the remote controller",
            ],
            [
                   "SDK Key for CustomButtonTags: Tags for C1 and C2 buttons on the remote controller",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "",
                   "",
            ],
            [
                   "ChargeMobileMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_inline",
                   "Modes to charge an iOS mobile device. Only supported by Inspire 2.",
            ],
            [
                   "Modes to charge an iOS mobile device. Only supported by Inspire 2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_inline",
                   "",
            ],
            [
                   "CHARGE_MOBILE_MODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_inline",
                   "SDK Key for ChargeMobileMode: Modes to charge an iOS mobile device. Only supported by Inspire 2.",
            ],
            [
                   "SDK Key for ChargeMobileMode: Modes to charge an iOS mobile device. Only supported by Inspire 2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_inline",
                   "",
            ],
            [
                   "ButtonAction",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_inline",
                   "Actions that can be assigned to a customizable button. Some of the actions are reserved and the firmware will execute the corresponding actions even when the application is not connected. Some of the actions are defined by the mobile applications. The application is responsible for implementing the non firmware actions. The definitions used in DJI Go are provided. It is usually recommended to follow DJI Go's definitions for compability so if DJI Go is used at the same time as the SDK application the actions will be expected in both applications.",
            ],
            [
                   "Actions that can be assigned to a customizable button. Some of the actions are reserved and the firmware will execute the corresponding actions even when the application is not connected. Some of the actions are defined by the mobile applications. The application is responsible for implementing the non firmware actions. The definitions used in DJI Go are provided. It is usually recommended to follow DJI Go's definitions for compability so if DJI Go is used at the same time as the SDK application the actions will be expected in both applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_inline",
                   "",
            ],
            [
                   "CustomizableButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_inline",
                   "The customizable buttons.",
            ],
            [
                   "The customizable buttons.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.FETCH_CUSTOMIZED_ACTION_OF_BUTTON",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_inline",
                   "SDK Key for CustomizableButton: The customizable buttons.",
            ],
            [
                   "SDK Key for CustomizableButton: The customizable buttons.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_inline",
                   "",
            ],
            [
                   "PairingDevice",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_inline",
                   "Types of the device that the remote controller can pair with. It is only used when the remote controller supports multi-device pairing. Only Supported by Phantom 4 RTK.",
            ],
            [
                   "Types of the device that the remote controller can pair with. It is only used when the remote controller supports multi-device pairing. Only Supported by Phantom 4 RTK.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_inline",
                   "",
            ],
            [
                   "MultiDeviceState",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_inline",
                   "The state (e.g. unpaired, paired, connected, etc.) of a device that may connected to the remote controller. It is only used when the remote controller supports multi-device pairing. Only supported by DJI Phantom 4 RTK.",
            ],
            [
                   "The state (e.g. unpaired, paired, connected, etc.) of a device that may connected to the remote controller. It is only used when the remote controller supports multi-device pairing. Only supported by DJI Phantom 4 RTK.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_inline",
                   "",
            ],
            [
                   "SoftSwitchJoyStickMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_inline",
                   "Joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_inline",
                   "",
            ],
            [
                   "setSoftSwitchJoyStickMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSoftSwitchJoyStickMode_inline",
                   "Sets the joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Sets the joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_setSoftSwitchJoyStickMode_inline",
                   "",
            ],
            [
                   "getSoftSwitchJoyStickMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSoftSwitchJoyStickMode_inline",
                   "Gets the joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Gets the joy stick mode on the remote controller. It is only used when the remote controller doesn't have a mode switch. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_getSoftSwitchJoyStickMode_inline",
                   "",
            ],
            [
                   "RCMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_inline",
                   "Remote Controller mode of operation can be normal (single RC connected to aircraft), master, slave, or unknown.",
            ],
            [
                   "Remote Controller mode of operation can be normal (single RC connected to aircraft), master, slave, or unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_inline",
                   "",
            ],
            [
                   "RemoteControllerKey.MODE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_inline",
                   "SDK Key for RCMode: Remote Controller mode of operation can be normal (single RC connected to aircraft), master, slave, or unknown.",
            ],
            [
                   "SDK Key for RCMode: Remote Controller mode of operation can be normal (single RC connected to aircraft), master, slave, or unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_inline",
                   "",
            ],
            [
                   "CalibrationState",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_inline",
                   "Remote Controller's calibration mode.",
            ],
            [
                   "Remote Controller's calibration mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_inline",
                   "",
            ],
            [
                   "Information",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "This class contains the information for a remote controller.",
            ],
            [
                   "This class contains the information for a remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "",
            ],
            [
                   "AVAILABLE_MASTERS",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "SDK Key for Information: This class contains the information for a remote controller.",
            ],
            [
                   "SDK Key for Information: This class contains the information for a remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "",
            ],
            [
                   "SLAVE_LIST",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "SDK Key for Information: This class contains the information for a remote controller.",
            ],
            [
                   "SDK Key for Information: This class contains the information for a remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "",
                   "",
            ],
            [
                   "ConnectToMasterResult",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_inline",
                   "Result when a slave Remote Controller tries to join a master Remote Controller.",
            ],
            [
                   "Result when a slave Remote Controller tries to join a master Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_inline",
                   "",
            ],
            [
                   "MasterSlaveState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "",
                   "State of the remote controller related to the master and slave mode.",
            ],
            [
                   "State of the remote controller related to the master and slave mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "",
                   "",
            ],
            [
                   "MASTER_SLAVE_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "",
                   "SDK Key for MasterSlaveState: State of the remote controller related to the master and slave mode.",
            ],
            [
                   "SDK Key for MasterSlaveState: State of the remote controller related to the master and slave mode.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "",
                   "",
            ],
            [
                   "GimbalControlSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "",
                   "Remote Controller's gimbal control speed.",
            ],
            [
                   "Remote Controller's gimbal control speed.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "",
                   "",
            ],
            [
                   "GIMBAL_CONTROL_SPEED_COEFFICIENT",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "",
                   "SDK Key for GimbalControlSpeedCoefficient: Remote Controller's gimbal control speed.",
            ],
            [
                   "SDK Key for GimbalControlSpeedCoefficient: Remote Controller's gimbal control speed.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "",
                   "",
            ],
            [
                   "RequestGimbalControlResult",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_inline",
                   "Result when a slave Remote Controller requests permission to control the gimbal.",
            ],
            [
                   "Result when a slave Remote Controller requests permission to control the gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_inline",
                   "",
            ],
            [
                   "REQUEST_GIMBAL_CONTROL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_inline",
                   "SDK Key for RequestGimbalControlResult: Result when a slave Remote Controller requests permission to control the gimbal.",
            ],
            [
                   "SDK Key for RequestGimbalControlResult: Result when a slave Remote Controller requests permission to control the gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_inline",
                   "",
            ],
            [
                   "ResponseForGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "",
                   "Data object that master Remote Controller to respond to the slave Remote Controller's request.",
            ],
            [
                   "Data object that master Remote Controller to respond to the slave Remote Controller's request.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "",
                   "",
            ],
            [
                   "RESPONSE_TO_REQUEST_FOR_GIMBAL_CONTROL",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "",
                   "SDK Key for ResponseForGimbalControl: Data object that master Remote Controller to respond to the slave Remote Controller's request.",
            ],
            [
                   "SDK Key for ResponseForGimbalControl: Data object that master Remote Controller to respond to the slave Remote Controller's request.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ResponseForGimbalControl.html",
                   "",
                   "",
            ],
            [
                   "AuthorizationInfo",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "",
                   "Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. In this case, `code` can be `null`. It can only be called when the remote controller is in slave mode. It is only supported by Inspire 2.",
            ],
            [
                   "Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. In this case, `code` can be `null`. It can only be called when the remote controller is in slave mode. It is only supported by Inspire 2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER_WITH_ID",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "",
                   "SDK Key for AuthorizationInfo: Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. In this case, `code` can be `null`. It can only be called when the remote controller is in slave mode. It is only supported by Inspire 2.",
            ],
            [
                   "SDK Key for AuthorizationInfo: Joins the master remote controller with the specific ID. If the remote controller has joined the same master before, the authentication code is not required until the master remote controller changes its authentication code. In this case, `code` can be `null`. It can only be called when the remote controller is in slave mode. It is only supported by Inspire 2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "",
                   "",
            ],
            [
                   "Credentials",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "Remote controller credentials.",
            ],
            [
                   "Remote controller credentials.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "",
            ],
            [
                   "CONNECTED_MASTER_CREDENTIALS",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "SDK Key for Credentials: Remote controller credentials.",
            ],
            [
                   "SDK Key for Credentials: Remote controller credentials.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "SDK Key for Credentials: Remote controller credentials.",
            ],
            [
                   "SDK Key for Credentials: Remote controller credentials.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "",
                   "",
            ],
            [
                   "getID",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_id_inline",
                   "Remote controller ID.  @return An int value.",
            ],
            [
                   "Remote controller ID.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_id_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_name_inline",
                   "Remote controller Name.  @return An instance of String.",
            ],
            [
                   "Remote controller Name.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_name_inline",
                   "",
            ],
            [
                   "getPassword",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_password_inline",
                   "Remote controller Password.  @return An instance of String.",
            ],
            [
                   "Remote controller Password.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinedMasterNameAndPasswordResult.html",
                   "#DJIRemoteController_JoinedMasterNameAndPasswordResult_password_inline",
                   "",
            ],
            [
                   "ProfessionalRC",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC.html",
                   "",
                   "Class for the Professional Cendence Remote Controller.",
            ],
            [
                   "Class for the Professional Cendence Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC.html",
                   "",
                   "",
            ],
            [
                   "Event",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "",
                   "The event for the Professional Cendence Remote Controller class.",
            ],
            [
                   "The event for the Professional Cendence Remote Controller class.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "",
                   "",
            ],
            [
                   "RemoteControllerKey.BUTTON_EVENT_OF_PROFESSIONAL_RC",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "",
                   "SDK Key for Event: The event for the Professional Cendence Remote Controller class.",
            ],
            [
                   "SDK Key for Event: The event for the Professional Cendence Remote Controller class.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "",
                   "",
            ],
            [
                   "getCustomizableButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "#DJIRemoteController_ProfessionalRC_getCustomizableButton_inline",
                   "Get the customizable button type.  @return An enum value of `CustomizableButton`.",
            ],
            [
                   "Get the customizable button type.  @return An enum value of `CustomizableButton`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "#DJIRemoteController_ProfessionalRC_getCustomizableButton_inline",
                   "",
            ],
            [
                   "getCurrentValue",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "#DJIRemoteController_ProfessionalRC_getCurrentValue_inline",
                   "Get the current value of the event.  @return An enum value of `CustomizableButton`.",
            ],
            [
                   "Get the current value of the event.  @return An enum value of `CustomizableButton`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_Event.html",
                   "#DJIRemoteController_ProfessionalRC_getCurrentValue_inline",
                   "",
            ],
            [
                   "ButtonConfiguration",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "",
                   "Button configuration for the Professional Cendence Remote Controller.",
            ],
            [
                   "Button configuration for the Professional Cendence Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "",
                   "",
            ],
            [
                   "RemoteControllerKey.BUTTON_CONFIG",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "",
                   "SDK Key for ButtonConfiguration: Button configuration for the Professional Cendence Remote Controller.",
            ],
            [
                   "SDK Key for ButtonConfiguration: Button configuration for the Professional Cendence Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "",
                   "",
            ],
            [
                   "ButtonConfigurationBuilder",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "",
                   "This class is for generating the instance of ButtonConfiguration",
            ],
            [
                   "This class is for generating the instance of ButtonConfiguration",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_build_inline",
                   "The build method for generating `ButtonConfiguration`.  @return An object of `ButtonConfiguration`.",
            ],
            [
                   "The build method for generating `ButtonConfiguration`.  @return An object of `ButtonConfiguration`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_build_inline",
                   "",
            ],
            [
                   "getButtonActions",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "#DJIRemoteController_ProfessionalRC_getButtonActions_inline",
                   "Fetch a Map representing the mapping between a customizable button and its action.  @return A Map representing the mapping between a customizable button and its action.",
            ],
            [
                   "Fetch a Map representing the mapping between a customizable button and its action.  @return A Map representing the mapping between a customizable button and its action.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration.html",
                   "#DJIRemoteController_ProfessionalRC_getButtonActions_inline",
                   "",
            ],
            [
                   "buildDefaultButtonConfiguration",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_buildDefaultButtonConfiguration_inline",
                   "Build `ButtonConfiguration` with default configuration.  @return An object of `ButtonConfiguration` class.",
            ],
            [
                   "Build `ButtonConfiguration` with default configuration.  @return An object of `ButtonConfiguration` class.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_buildDefaultButtonConfiguration_inline",
                   "",
            ],
            [
                   "buildButtonConfigurationWithMap",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_buildButtonConfigurationWithMap_inline",
                   "Build `ButtonConfiguration` with a Map<CustomizableButton, ButtonAction>.  @param map A Map<CustomizableButton, ButtonAction>.  @return An object of `ButtonConfigurationBuilder` class.",
            ],
            [
                   "Build `ButtonConfiguration` with a Map<CustomizableButton, ButtonAction>.  @param map A Map<CustomizableButton, ButtonAction>.  @return An object of `ButtonConfigurationBuilder` class.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_buildButtonConfigurationWithMap_inline",
                   "",
            ],
            [
                   "configButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_configButton_inline",
                   "Configure one button with a buttonAction, need be called after the calling of `buildButtonConfigurationWithMap` or `buildDefaultButtonConfiguration`.  @param button An enum value of `CustomizableButton`. @param buttonAction An enum value of `ButtonAction`.  @return An object of `ButtonConfigurationBuilder` class.",
            ],
            [
                   "Configure one button with a buttonAction, need be called after the calling of `buildButtonConfigurationWithMap` or `buildDefaultButtonConfiguration`.  @param button An enum value of `CustomizableButton`. @param buttonAction An enum value of `ButtonAction`.  @return An object of `ButtonConfigurationBuilder` class.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_configButton_inline",
                   "",
            ],
            [
                   "getValidActionsForButton",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_getValidActionsForButton_inline",
                   "Return the array list of `ButtonAction` enum values could be configured to one button.  @param button An enum value of `CustomizableButton`.  @return An array of the `ButtonAction` enum values.",
            ],
            [
                   "Return the array list of `ButtonAction` enum values could be configured to one button.  @param button An enum value of `CustomizableButton`.  @return An array of the `ButtonAction` enum values.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder.html",
                   "#DJIRemoteController_ProfessionalRC_ButtonConfiguration_Builder_getValidActionsForButton_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_CallbackInterface.html",
                   "",
                   "The Professional Cendence RC callback interface.",
            ],
            [
                   "The Professional Cendence RC callback interface.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_CallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onEvent",
                   2,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_CallbackInterface.html",
                   "#DJIRemoteController_ProfessionalRC_onEventCallback_inline",
                   "Callback function that updates the `Event`.  @param event `Event` event.",
            ],
            [
                   "Callback function that updates the `Event`.  @param event `Event` event.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_ProfessionalRC_CallbackInterface.html",
                   "#DJIRemoteController_ProfessionalRC_onEventCallback_inline",
                   "",
            ],
            [
                   "DisplayNameMavicPro",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicPro_inline",
                   "The display name of Mavic Pro's remote controller.",
            ],
            [
                   "The display name of Mavic Pro's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicPro_inline",
                   "",
            ],
            [
                   "DisplayNameInspire1",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameInspire1_inline",
                   "The display name of the remote controller for Inspire 1 series and Matrice 100.",
            ],
            [
                   "The display name of the remote controller for Inspire 1 series and Matrice 100.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameInspire1_inline",
                   "",
            ],
            [
                   "DisplayNameLightbridge2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameLightbridge2_inline",
                   "The display name of the remote controller for Lightbridge 2 wireless module. The module is used by stand-alone Lightbridge 2, A3, N3 and Matrice 600 series.",
            ],
            [
                   "The display name of the remote controller for Lightbridge 2 wireless module. The module is used by stand-alone Lightbridge 2, A3, N3 and Matrice 600 series.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameLightbridge2_inline",
                   "",
            ],
            [
                   "DisplayNameInspire2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameInspire2_inline",
                   "The display name of the remote controller for Inspire 2 and Matrice 200 series.",
            ],
            [
                   "The display name of the remote controller for Inspire 2 and Matrice 200 series.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameInspire2_inline",
                   "",
            ],
            [
                   "DisplayNameCendence",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameCendence_inline",
                   "The display name of the Cendence remote controller.",
            ],
            [
                   "The display name of the Cendence remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameCendence_inline",
                   "",
            ],
            [
                   "DisplayNameCendenceSDR",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameCendenceSDR_inline",
                   "The display name of the Cendence SDR remote controller.",
            ],
            [
                   "The display name of the Cendence SDR remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameCendenceSDR_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom3Professinal",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom3Professinal_inline",
                   "The display name of the remote controller for Phantom 3 Professional, Phantom 3 Advanced and Phantom 4.",
            ],
            [
                   "The display name of the remote controller for Phantom 3 Professional, Phantom 3 Advanced and Phantom 4.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom3Professinal_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom3Standard",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom3Standard_inline",
                   "The display name of Phantom 3 Standard's remote controller.",
            ],
            [
                   "The display name of Phantom 3 Standard's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom3Standard_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom4Pro",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4Pro_inline",
                   "The display name of Phantom 4 Pro's remote controller.",
            ],
            [
                   "The display name of Phantom 4 Pro's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4Pro_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom4Advanced",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4Advanced_inline",
                   "The display name of Phantom 4 Advanced's remote controller.",
            ],
            [
                   "The display name of Phantom 4 Advanced's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4Advanced_inline",
                   "",
            ],
            [
                   "DisplayNamePhantom4ProV2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4ProV2_inline",
                   "The display name of the remote controller for Phantom 4 Pro V2.",
            ],
            [
                   "The display name of the remote controller for Phantom 4 Pro V2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNamePhantom4ProV2_inline",
                   "",
            ],
            [
                   "DisplayNameSpark",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameSpark_inline",
                   "The display name of Spark's remote controller.",
            ],
            [
                   "The display name of Spark's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameSpark_inline",
                   "",
            ],
            [
                   "DisplayNameMavicAir",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicAir_inline",
                   "The display name of Mavic Air's remote controller.",
            ],
            [
                   "The display name of Mavic Air's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicAir_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavic2_inline",
                   "The display name of Mavic 2's remote controller.",
            ],
            [
                   "The display name of Mavic 2's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavic2_inline",
                   "",
            ],
            [
                   "DisplayNameMavic2Enterprise",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavic2Enterprise_inline",
                   "The display name of Mavic 2 Enterprise's remote controller.",
            ],
            [
                   "The display name of Mavic 2 Enterprise's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavic2Enterprise_inline",
                   "",
            ],
            [
                   "DisplayNameDJISmartController",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJISmartController_inline",
                   "The display name of DJI Smart Controller.",
            ],
            [
                   "The display name of DJI Smart Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJISmartController_inline",
                   "",
            ],
            [
                   "DisplayNameDJISmartControllerEnterpriseController",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJISmartControllerEnterpriseController_inline",
                   "The display name of DJI Smart Controller Enterprise.",
            ],
            [
                   "The display name of DJI Smart Controller Enterprise.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJISmartControllerEnterpriseController_inline",
                   "",
            ],
            [
                   "DisplayNameMavicMini",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicMini_inline",
                   "The display name of Mavic Mini/DJI Mini SE's remote controller.",
            ],
            [
                   "The display name of Mavic Mini/DJI Mini SE's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicMini_inline",
                   "",
            ],
            [
                   "DisplayNameMavicAir2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicAir2_inline",
                   "The display name of Mavic Air 2's remote controller.",
            ],
            [
                   "The display name of Mavic Air 2's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameMavicAir2_inline",
                   "",
            ],
            [
                   "DisplayNameDJIMini2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJIMini2_inline",
                   "The display name of DJI Mini 2's remote controller.",
            ],
            [
                   "The display name of DJI Mini 2's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJIMini2_inline",
                   "",
            ],
            [
                   "DisplayNameDJIAir2s",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJIAir2s_inline",
                   "The display name of DJI Air 2S's remote controller.",
            ],
            [
                   "The display name of DJI Air 2S's remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerDisplayNameDJIAir2s_inline",
                   "",
            ],
            [
                   "MultiDeviceAggregationState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "",
                   "The aggregation state related to devices that can pair to the remote controller. It contains the pairing  state and the connection state of the device (aircraft or RTK base station). It is only used when the remote controller supports multi- device pairing. Only Supported by Phantom 4 RTK.",
            ],
            [
                   "The aggregation state related to devices that can pair to the remote controller. It contains the pairing  state and the connection state of the device (aircraft or RTK base station). It is only used when the remote controller supports multi- device pairing. Only Supported by Phantom 4 RTK.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "",
                   "",
            ],
            [
                   "getAircraftState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_aircraftState_inline",
                   "The device state of aircraft.  @return An enum value of the `MultiDeviceState`.",
            ],
            [
                   "The device state of aircraft.  @return An enum value of the `MultiDeviceState`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_aircraftState_inline",
                   "",
            ],
            [
                   "getRtkBaseStationState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_RTKGroundSystemState_inline",
                   "The device state of RTK base station.  @return An enum value of the `MultiDeviceState`.",
            ],
            [
                   "The device state of RTK base station.  @return An enum value of the `MultiDeviceState`.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_RTKGroundSystemState_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState_callbackInterface.html",
                   "",
                   "Interface to receive the latest pairing state from the remote controller that supporting multi-device pairing.",
            ],
            [
                   "Interface to receive the latest pairing state from the remote controller that supporting multi-device pairing.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState_callbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onMultiDeviceAggregationStateChanged",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState_callbackInterface.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_onMultiDeviceAggregationStateChanged_inline",
                   "Delegate method to receive the latest pairing state from the remote controller that supporting multi-device pairing.  @param state The latest pairing state.",
            ],
            [
                   "Delegate method to receive the latest pairing state from the remote controller that supporting multi-device pairing.  @param state The latest pairing state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMultiDeviceAggregationState_callbackInterface.html",
                   "#DJIRemoteController_DJIRCMultiDeviceAggregationState_onMultiDeviceAggregationStateChanged_inline",
                   "",
            ],
            [
                   "UNPAIRED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_NotParing_inline",
                   "The Remote Controller is not pairing.",
            ],
            [
                   "The Remote Controller is not pairing.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_NotParing_inline",
                   "",
            ],
            [
                   "PAIRING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Paring_inline",
                   "The Remote Controller is currently pairing.",
            ],
            [
                   "The Remote Controller is currently pairing.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Paring_inline",
                   "",
            ],
            [
                   "FirmwareSwitching",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_SWITCHING_inline",
                   "The Remote Controller is switching rc firmware.",
            ],
            [
                   "The Remote Controller is switching rc firmware.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_SWITCHING_inline",
                   "",
            ],
            [
                   "FirmwareSwitched",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_SWITCHEND_inline",
                   "The remote control has finished switching RC firmware.",
            ],
            [
                   "The remote control has finished switching RC firmware.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_SWITCHEND_inline",
                   "",
            ],
            [
                   "PAIRED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Completed_inline",
                   "The Remote Controller's pairing was completed.",
            ],
            [
                   "The Remote Controller's pairing was completed.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Completed_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Unknown_inline",
                   "The Remote Controller's pairing state is unknown.",
            ],
            [
                   "The Remote Controller's pairing state is unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCToAircraftPairingState_Unknown_inline",
                   "",
            ],
            [
                   "PITCH",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Pitch_inline",
                   "The upper left dial will control the gimbal's pitch.",
            ],
            [
                   "The upper left dial will control the gimbal's pitch.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Pitch_inline",
                   "",
            ],
            [
                   "ROLL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Roll_inline",
                   "The upper left dial will control the gimbal's roll.",
            ],
            [
                   "The upper left dial will control the gimbal's roll.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Roll_inline",
                   "",
            ],
            [
                   "YAW",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Yaw_inline",
                   "The upper left dial will control the gimbal's yaw.",
            ],
            [
                   "The upper left dial will control the gimbal's yaw.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCGimbalControlDirection_Yaw_inline",
                   "",
            ],
            [
                   "getC1ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag1_inline",
                   "Button tag for custom button 2.  @return Value that is the tag",
            ],
            [
                   "Button tag for custom button 2.  @return Value that is the tag",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag1_inline",
                   "",
            ],
            [
                   "getC2ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag2_inline",
                   "Button tag for custom button 2  @return Value that is the tag",
            ],
            [
                   "Button tag for custom button 2  @return Value that is the tag",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag2_inline",
                   "",
            ],
            [
                   "getC3ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag3_inline",
                   "Button tag for custom button 3  @return Value that is the tag",
            ],
            [
                   "Button tag for custom button 3  @return Value that is the tag",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_tag3_inline",
                   "",
            ],
            [
                   "Builder",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "",
                   "Create a `CustomButtonTags` instance with values for C1 and C2. A valid tag is an integer in range [0, 255].",
            ],
            [
                   "Create a `CustomButtonTags` instance with values for C1 and C2. A valid tag is an integer in range [0, 255].",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "",
                   "",
            ],
            [
                   "c1ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c1_inline",
                   "Button tag for custom button 2  @param c1ButtonTag Button tag for custom button 1  @return Builder object.",
            ],
            [
                   "Button tag for custom button 2  @param c1ButtonTag Button tag for custom button 1  @return Builder object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c1_inline",
                   "",
            ],
            [
                   "c2ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c2_inline",
                   "Button tag for custom button 2  @param c2ButtonTag Button tag for custom button 2  @return Builder object.",
            ],
            [
                   "Button tag for custom button 2  @param c2ButtonTag Button tag for custom button 2  @return Builder object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c2_inline",
                   "",
            ],
            [
                   "c3ButtonTag",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c3_inline",
                   "Button tag for custom button 3, only supported by DJI Smart Controller.  @param c3ButtonTag Button tag for custom button 3.  @return Builder object.",
            ],
            [
                   "Button tag for custom button 3, only supported by DJI Smart Controller.  @param c3ButtonTag Button tag for custom button 3.  @return Builder object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_c3_inline",
                   "",
            ],
            [
                   "build",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_build_inline",
                   "Button tag for custom button  @return `CustomButtonTags` object.",
            ],
            [
                   "Button tag for custom button  @return `CustomButtonTags` object.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCCustomButtonTagParam_Constructor.html",
                   "#DJIRemoteController_RCCustomButtonTagParam_Constructor_build_inline",
                   "",
            ],
            [
                   "NEVER",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Never_inline",
                   "The remote controller does not charge the mobile device.",
            ],
            [
                   "The remote controller does not charge the mobile device.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Never_inline",
                   "",
            ],
            [
                   "ALWAYS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Always_inline",
                   "The remote controller charges the mobile device until the the mobile device is fully charged.",
            ],
            [
                   "The remote controller charges the mobile device until the the mobile device is fully charged.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Always_inline",
                   "",
            ],
            [
                   "INTELLIGENT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Intelligent_inline",
                   "The remote controller charges the mobile device in an intelligent mode: The remote controller starts charging when the mobile device's battery is lowered then 20% and stops charging when the mobile device's battery is above 50%. It is only supported by Inspire 2.",
            ],
            [
                   "The remote controller charges the mobile device in an intelligent mode: The remote controller starts charging when the mobile device's battery is lowered then 20% and stops charging when the mobile device's battery is above 50%. It is only supported by Inspire 2.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Intelligent_inline",
                   "",
            ],
            [
                   "Unknown",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Unknown_inline",
                   "The Remote Controller's charging mode is unknown.",
            ],
            [
                   "The Remote Controller's charging mode is unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerChargeMobileMode_Unknown_inline",
                   "",
            ],
            [
                   "MASTER",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Master_inline",
                   "Remote Controller is a master (will route a connected slave Remote  Controller's commands to the aircraft).",
            ],
            [
                   "Remote Controller is a master (will route a connected slave Remote  Controller's commands to the aircraft).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Master_inline",
                   "",
            ],
            [
                   "SLAVE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Slave_inline",
                   "Remote Controller is currently a slave Remote Controller (sends commands to aircraft through a master Remote Controller).",
            ],
            [
                   "Remote Controller is currently a slave Remote Controller (sends commands to aircraft through a master Remote Controller).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Slave_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Normal_inline",
                   "Remote Controller is not connected to another Remote Controller.",
            ],
            [
                   "Remote Controller is not connected to another Remote Controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Normal_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Unknown_inline",
                   "The Remote Controller's mode is unknown.",
            ],
            [
                   "The Remote Controller's mode is unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRemoteControllerMode_Unknown_inline",
                   "",
            ],
            [
                   "ACCEPTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Successful_inline",
                   "The slave Remote Controller's attempt to join the master Remote Controller was successful.",
            ],
            [
                   "The slave Remote Controller's attempt to join the master Remote Controller was successful.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Successful_inline",
                   "",
            ],
            [
                   "PASSWORD_ERROR",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_PasswordError_inline",
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful due to a password error.",
            ],
            [
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful due to a password error.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_PasswordError_inline",
                   "",
            ],
            [
                   "REJECTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Rejected_inline",
                   "The slave Remote Controller's attempt to join the master Remote Controller was rejected.",
            ],
            [
                   "The slave Remote Controller's attempt to join the master Remote Controller was rejected.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Rejected_inline",
                   "",
            ],
            [
                   "MAXIMUM_CAPACITY",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_ReachMaximum_inline",
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful because the master Remote Controller is at the maximum number of slaves it can have.",
            ],
            [
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful because the master Remote Controller is at the maximum number of slaves it can have.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_ReachMaximum_inline",
                   "",
            ],
            [
                   "TIMEOUT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Timeout_inline",
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful because the request timed out.",
            ],
            [
                   "The slave Remote Controller's attempt to join the master Remote Controller was unsuccessful because the request timed out.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Timeout_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Unknown_inline",
                   "The result of the slave Remote Controller's attempt to join the master Remote Controller is unknown.",
            ],
            [
                   "The result of the slave Remote Controller's attempt to join the master Remote Controller is unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCJoinMasterResult_Unknown_inline",
                   "",
            ],
            [
                   "getPitchSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_pitchSpeed_inline",
                   "Gimbal's pitch speed with range [0, 100].  @return An int value.",
            ],
            [
                   "Gimbal's pitch speed with range [0, 100].  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_pitchSpeed_inline",
                   "",
            ],
            [
                   "getRollSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_rollSpeed_inline",
                   "Gimbal's roll speed with range [0, 100].  @return An int value.",
            ],
            [
                   "Gimbal's roll speed with range [0, 100].  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_rollSpeed_inline",
                   "",
            ],
            [
                   "getYawSpeedCoefficient",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_yawSpeed_inline",
                   "Gimbal's yaw speed with range [0, 100].  @return An int value.",
            ],
            [
                   "Gimbal's yaw speed with range [0, 100].  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCGimbalControlSpeed.html",
                   "#DJIRemoteController_DJIRCGimbalControlSpeed_yawSpeed_inline",
                   "",
            ],
            [
                   "ACCEPTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Agree_inline",
                   "The master Remote Controller agrees to the slave's request.",
            ],
            [
                   "The master Remote Controller agrees to the slave's request.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Agree_inline",
                   "",
            ],
            [
                   "REJECTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Deny_inline",
                   "The master Remote Controller denies the slave's request. If the slave Remote Controller wants to control the gimbal, it must send a request to the master Remote Controller first. Then the master Remote Controller can decide to approve or deny the request.",
            ],
            [
                   "The master Remote Controller denies the slave's request. If the slave Remote Controller wants to control the gimbal, it must send a request to the master Remote Controller first. Then the master Remote Controller can decide to approve or deny the request.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Deny_inline",
                   "",
            ],
            [
                   "TIMEOUT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Timeout_inline",
                   "The slave Remote Controller's request timed out.",
            ],
            [
                   "The slave Remote Controller's request timed out.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Timeout_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Unknown_inline",
                   "The slave Remote Controller's request is unknown.",
            ],
            [
                   "The slave Remote Controller's request is unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCRequestGimbalControlResult_Unknown_inline",
                   "",
            ],
            [
                   "CameraSetting",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom0_inline",
                   "Toggle the camera setting view. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the camera setting view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom0_inline",
                   "",
            ],
            [
                   "GimbalCenter",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ResetGimbal_inline",
                   "Resets the gimbal attitude. The pitch and the yaw will point to the origin. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Resets the gimbal attitude. The pitch and the yaw will point to the origin. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ResetGimbal_inline",
                   "",
            ],
            [
                   "MapSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom3_inline",
                   "Switch the live view and the map view. The action has to be implemented by the application itself.",
            ],
            [
                   "Switch the live view and the map view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom3_inline",
                   "",
            ],
            [
                   "ClearRoute",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom4_inline",
                   "Clear the flight path in the map view. The action has to be implemented by the application itself.",
            ],
            [
                   "Clear the flight path in the map view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom4_inline",
                   "",
            ],
            [
                   "Battery",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom5_inline",
                   "Toggle the battery setting view. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the battery setting view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom5_inline",
                   "",
            ],
            [
                   "CenterMetering",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom7_inline",
                   "Trigger central exposure metering. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Trigger central exposure metering. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom7_inline",
                   "",
            ],
            [
                   "AeLock",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom8_inline",
                   "Toggles the AE Lock setting. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggles the AE Lock setting. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom8_inline",
                   "",
            ],
            [
                   "ForeArm",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom9_inline",
                   "Toggle the LEDs on the four arms. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the LEDs on the four arms. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom9_inline",
                   "",
            ],
            [
                   "RESET_FPV_GIMBAL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ResetFPVGimbal_inline",
                   "Reset FPV gimbal attitude to the center, the gimbal will rotate 45 degrees in pitch axis up and down when the action is trigger. It is supported by the firmware of Matrice 200 series and Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Reset FPV gimbal attitude to the center, the gimbal will rotate 45 degrees in pitch axis up and down when the action is trigger. It is supported by the firmware of Matrice 200 series and Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ResetFPVGimbal_inline",
                   "",
            ],
            [
                   "LiveViewExpand",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom13_inline",
                   "Expand the live view from the FPV camera. The action has to be implemented by the application itself.",
            ],
            [
                   "Expand the live view from the FPV camera. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom13_inline",
                   "",
            ],
            [
                   "QUICK_SPIN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom14_inline",
                   "Trigger a Quick Spin. It is supported by the firmware of Inspire 2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Trigger a Quick Spin. It is supported by the firmware of Inspire 2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom14_inline",
                   "",
            ],
            [
                   "PlayBack",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom16_inline",
                   "Toggle the playback view. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the playback view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom16_inline",
                   "",
            ],
            [
                   "CenterFocus",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_CenterFocus_inline",
                   "Triggers focusing at the center of the live view. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers focusing at the center of the live view. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_CenterFocus_inline",
                   "",
            ],
            [
                   "GetGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom23_inline",
                   "Request gimbal control (for the slave remote controller). The action has to be implemented by the application itself.",
            ],
            [
                   "Request gimbal control (for the slave remote controller). The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom23_inline",
                   "",
            ],
            [
                   "GimbalMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleGimbalMode_inline",
                   "Toggle `YAW_FOLLOW` and `FREE` for gimbal. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Toggle `YAW_FOLLOW` and `FREE` for gimbal. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleGimbalMode_inline",
                   "",
            ],
            [
                   "QuickSetting",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom25_inline",
                   "Toggle the customizable button setting view. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the customizable button setting view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom25_inline",
                   "",
            ],
            [
                   "AFMF",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleFocus_inline",
                   "Toggle AF and MF for camera. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Toggle AF and MF for camera. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleFocus_inline",
                   "",
            ],
            [
                   "CloseTips",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom27_inline",
                   "Dismiss the warning tips. The action has to be implemented by the application itself.",
            ],
            [
                   "Dismiss the warning tips. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom27_inline",
                   "",
            ],
            [
                   "SmartGear",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom28_inline",
                   "Toggle the automatic movement of the landing gear. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the automatic movement of the landing gear. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom28_inline",
                   "",
            ],
            [
                   "ReviewWarning",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom29_inline",
                   "Toggle the warning list view. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the warning list view. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom29_inline",
                   "",
            ],
            [
                   "SWITCH_FREQUENCY",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_SwitchFrequency_inline",
                   "Switch frequency bands of the remote controller. It is supported by the firmware of Matrice 200 series. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Switch frequency bands of the remote controller. It is supported by the firmware of Matrice 200 series. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_SwitchFrequency_inline",
                   "",
            ],
            [
                   "UpdateHomeDrone",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom31_inline",
                   "Set the home location of the aircraft to the current location of the aircraft. The action has to be implemented by the application itself.",
            ],
            [
                   "Set the home location of the aircraft to the current location of the aircraft. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom31_inline",
                   "",
            ],
            [
                   "UpdateHomeRC",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom32_inline",
                   "Set the home location of the aircraft to the current location of the remote controller. The action has to be implemented by the application itself.",
            ],
            [
                   "Set the home location of the aircraft to the current location of the remote controller. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom32_inline",
                   "",
            ],
            [
                   "Focus",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Focus_inline",
                   "Trigger the camera focus. It is supported by the firmware of Matrice 200 series and Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Trigger the camera focus. It is supported by the firmware of Matrice 200 series and Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Focus_inline",
                   "",
            ],
            [
                   "CompositionMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom41_inline",
                   "Toggle the composition mode for the Spotlight. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the composition mode for the Spotlight. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom41_inline",
                   "",
            ],
            [
                   "FocusPeaking",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom43_inline",
                   "Toggle the peak focus. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the peak focus. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom43_inline",
                   "",
            ],
            [
                   "GridLine",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom44_inline",
                   "Toggle the display of grid. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the display of grid. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom44_inline",
                   "",
            ],
            [
                   "Histogram",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom45_inline",
                   "Toggle the display of histogram. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the display of histogram. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom45_inline",
                   "",
            ],
            [
                   "AEMFSwitch",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom46_inline",
                   "Switch the white balance settings. The action has to be implemented by the application itself.",
            ],
            [
                   "Switch the white balance settings. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom46_inline",
                   "",
            ],
            [
                   "OverExposure",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom47_inline",
                   "Toggle the over-exposure warning. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the over-exposure warning. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom47_inline",
                   "",
            ],
            [
                   "GIMBAL_YAW_RECENTER",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom52_inline",
                   "Reset the gimbal yaw to align with the aircraft heading. The action has to be implemented by the application itself.",
            ],
            [
                   "Reset the gimbal yaw to align with the aircraft heading. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom52_inline",
                   "",
            ],
            [
                   "TOGGLE_LANDING_GEAR",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleLandingGear_inline",
                   "Retract or deploy the landing gear. It is supported by the firmware of Inspire 2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Retract or deploy the landing gear. It is supported by the firmware of Inspire 2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ToggleLandingGear_inline",
                   "",
            ],
            [
                   "CloseRadarMap",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom59_inline",
                   "Toggle the radar map. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the radar map. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom59_inline",
                   "",
            ],
            [
                   "CloseDownVPS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom60_inline",
                   "Toggle the downward vision sensors. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the downward vision sensors. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom60_inline",
                   "",
            ],
            [
                   "CloseFrontAss",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom61_inline",
                   "Toggle the forward obstacle avoidance. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the forward obstacle avoidance. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom61_inline",
                   "",
            ],
            [
                   "SwitchGimbalFpv",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom62_inline",
                   "Switch the video source of the secondary video feeder between fpv and camera. The action has to be implemented by the application itself.",
            ],
            [
                   "Switch the video source of the secondary video feeder between fpv and camera. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom62_inline",
                   "",
            ],
            [
                   "FullScreen",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom63_inline",
                   "Toggle the full screen mode. The action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the full screen mode. The action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom63_inline",
                   "",
            ],
            [
                   "CUSTOM100",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ZoomOut_inline",
                   "Zoom out. It is only supported by Z30 camera. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Zoom out. It is only supported by Z30 camera. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ZoomOut_inline",
                   "",
            ],
            [
                   "CUSTOM101",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ZoomIn_inline",
                   "Zoom in. It is only supported by Z30 camera. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Zoom in. It is only supported by Z30 camera. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_ZoomIn_inline",
                   "",
            ],
            [
                   "CUSTOM102",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom102_inline",
                   "Custom action with value 102. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 102. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom102_inline",
                   "",
            ],
            [
                   "CUSTOM103",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom103_inline",
                   "Toggle the `DisplayMode`. It is only supported by XT2 camera. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Toggle the `DisplayMode`. It is only supported by XT2 camera. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom103_inline",
                   "",
            ],
            [
                   "CUSTOM104",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom104_inline",
                   "Custom action with value 104. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 104. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom104_inline",
                   "",
            ],
            [
                   "CUSTOM105",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom105_inline",
                   "Custom action with value 105. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 105. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom105_inline",
                   "",
            ],
            [
                   "CUSTOM106",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom106_inline",
                   "Custom action with value 106. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 106. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom106_inline",
                   "",
            ],
            [
                   "CUSTOM107",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom107_inline",
                   "Custom action with value 107. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 107. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom107_inline",
                   "",
            ],
            [
                   "CUSTOM108",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom108_inline",
                   "Custom action with value 108. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 108. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom108_inline",
                   "",
            ],
            [
                   "CUSTOM109",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom109_inline",
                   "Custom action with value 109. This value is reserved for SDK applications.",
            ],
            [
                   "Custom action with value 109. This value is reserved for SDK applications.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom109_inline",
                   "",
            ],
            [
                   "NOT_DEFINED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_NotDefined_inline",
                   "Not defined. It is used to present that no action is bound to a button.",
            ],
            [
                   "Not defined. It is used to present that no action is bound to a button.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_NotDefined_inline",
                   "",
            ],
            [
                   "CUSTOM150",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom150_inline",
                   "Triggers the widget of the payload device in the index of 0. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 0. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom150_inline",
                   "",
            ],
            [
                   "CUSTOM151",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom151_inline",
                   "Triggers the widget of the payload device in the index of 1. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 1. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom151_inline",
                   "",
            ],
            [
                   "CUSTOM152",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom152_inline",
                   "Triggers the widget of the payload device in the index of 2. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 2. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom152_inline",
                   "",
            ],
            [
                   "CUSTOM153",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom153_inline",
                   "Triggers the widget of the payload device in the index of 3. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 3. It is supported by the firmware of Matrice 200 V2 series. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom153_inline",
                   "",
            ],
            [
                   "CUSTOM154",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom154_inline",
                   "Triggers the widget of the payload device in the index of 4. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 4. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom154_inline",
                   "",
            ],
            [
                   "CUSTOM155",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom155_inline",
                   "Triggers the widget of the payload device in the index of 5. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 5. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom155_inline",
                   "",
            ],
            [
                   "CUSTOM156",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom156_inline",
                   "Triggers the widget of the payload device in the index of 6. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 6. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom156_inline",
                   "",
            ],
            [
                   "CUSTOM157",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom157_inline",
                   "Triggers the widget of the payload device in the index of 7. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 7. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom157_inline",
                   "",
            ],
            [
                   "CUSTOM158",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom158_inline",
                   "Triggers the widget of the payload device in the index of 8. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 8. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom158_inline",
                   "",
            ],
            [
                   "CUSTOM159",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom159_inline",
                   "Triggers the widget of the payload device in the index of 9. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 9. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom159_inline",
                   "",
            ],
            [
                   "CUSTOM160",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom160_inline",
                   "Triggers the widget of the payload device in the index of 10. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 10. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom160_inline",
                   "",
            ],
            [
                   "CUSTOM161",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom161_inline",
                   "Triggers the widget of the payload device in the index of 11. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 11. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom161_inline",
                   "",
            ],
            [
                   "CUSTOM162",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom162_inline",
                   "Triggers the widget of the payload device in the index of 12. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 12. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom162_inline",
                   "",
            ],
            [
                   "CUSTOM163",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom163_inline",
                   "Triggers the widget of the payload device in the index of 13. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 13. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom163_inline",
                   "",
            ],
            [
                   "CUSTOM164",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom164_inline",
                   "Triggers the widget of the payload device in the index of 14. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
            ],
            [
                   "Triggers the widget of the payload device in the index of 14. It is supported by the firmware of Matrice 200 series v2. For the other products, the action has to be implemented by the application itself.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCButtonAction_Custom164_inline",
                   "",
            ],
            [
                   "C1",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C1_inline",
                   "The button with C1 label.",
            ],
            [
                   "The button with C1 label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C1_inline",
                   "",
            ],
            [
                   "C2",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C2_inline",
                   "The button with C2 label.",
            ],
            [
                   "The button with C2 label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C2_inline",
                   "",
            ],
            [
                   "C3",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C3_inline",
                   "The button with C3 label.",
            ],
            [
                   "The button with C3 label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C3_inline",
                   "",
            ],
            [
                   "C4",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C4_inline",
                   "The button with C4 label.",
            ],
            [
                   "The button with C4 label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_C4_inline",
                   "",
            ],
            [
                   "BA",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BA_inline",
                   "The button with BA label.",
            ],
            [
                   "The button with BA label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BA_inline",
                   "",
            ],
            [
                   "BB",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BB_inline",
                   "The button with BB label.",
            ],
            [
                   "The button with BB label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BB_inline",
                   "",
            ],
            [
                   "BC",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BC_inline",
                   "The button with BC label.",
            ],
            [
                   "The button with BC label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BC_inline",
                   "",
            ],
            [
                   "BD",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BD_inline",
                   "The button with BD label.",
            ],
            [
                   "The button with BD label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BD_inline",
                   "",
            ],
            [
                   "BE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BE_inline",
                   "The button with BE label.",
            ],
            [
                   "The button with BE label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BE_inline",
                   "",
            ],
            [
                   "BF",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BF_inline",
                   "The button with BF label.",
            ],
            [
                   "The button with BF label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BF_inline",
                   "",
            ],
            [
                   "BG",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BG_inline",
                   "The button with BG label.",
            ],
            [
                   "The button with BG label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BG_inline",
                   "",
            ],
            [
                   "BH",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BH_inline",
                   "The button with BH label.",
            ],
            [
                   "The button with BH label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_BH_inline",
                   "",
            ],
            [
                   "TD",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_TD_inline",
                   "The button with TD label.",
            ],
            [
                   "The button with TD label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_TD_inline",
                   "",
            ],
            [
                   "Menu",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_MENU_inline",
                   "The button with MENU label.",
            ],
            [
                   "The button with MENU label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_MENU_inline",
                   "",
            ],
            [
                   "LS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_LS_inline",
                   "The button with LS label.",
            ],
            [
                   "The button with LS label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_LS_inline",
                   "",
            ],
            [
                   "RS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_RS_inline",
                   "The button with RS label.",
            ],
            [
                   "The button with RS label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_RS_inline",
                   "",
            ],
            [
                   "LW",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_LW_inline",
                   "The button with LW label.",
            ],
            [
                   "The button with LW label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_LW_inline",
                   "",
            ],
            [
                   "RW",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_RW_inline",
                   "The button with RW label.",
            ],
            [
                   "The button with RW label.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_RW_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCustomizableButton_Unknown_inline",
                   "",
            ],
            [
                   "AIRCRAFT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_Aircraft_inline",
                   "The device to be paired with is an aircraft.",
            ],
            [
                   "The device to be paired with is an aircraft.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_Aircraft_inline",
                   "",
            ],
            [
                   "RTK_BASE_STATION",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_RTKGroundSystem_inline",
                   "The device to be paired with is an RTK base station.",
            ],
            [
                   "The device to be paired with is an RTK base station.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_RTKGroundSystem_inline",
                   "",
            ],
            [
                   "UNKONWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPairingDevice_Unknown_inline",
                   "",
            ],
            [
                   "UNPAIRED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Unpaired_inline",
                   "The remote controller is unpaired with the device. This state is for both aircraft and base station.",
            ],
            [
                   "The remote controller is unpaired with the device. This state is for both aircraft and base station.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Unpaired_inline",
                   "",
            ],
            [
                   "PAIRING",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Pairing_inline",
                   "The remote controller is pairing with the device. This state is only for aircraft.",
            ],
            [
                   "The remote controller is pairing with the device. This state is only for aircraft.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Pairing_inline",
                   "",
            ],
            [
                   "PAIRED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Paired_inline",
                   "The remote controller is paired. This state is only for aircraft.",
            ],
            [
                   "The remote controller is paired. This state is only for aircraft.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Paired_inline",
                   "",
            ],
            [
                   "DISCONNECTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Disconnected_inline",
                   "The remote controller is paired with the device but the connection between the device  and the remote controller is broken. The remote controller already remembers the device and the connection will receover automatically when it is possible. This state is only for base station. Only Supported by Phantom 4 RTK.",
            ],
            [
                   "The remote controller is paired with the device but the connection between the device  and the remote controller is broken. The remote controller already remembers the device and the connection will receover automatically when it is possible. This state is only for base station. Only Supported by Phantom 4 RTK.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Disconnected_inline",
                   "",
            ],
            [
                   "CONNECTED",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Connected_inline",
                   "The remote controller is paired with the device and it is connected to the device. This state is only for base station.",
            ],
            [
                   "The remote controller is paired with the device and it is connected to the device. This state is only for base station.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Connected_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCMultiDeviceState_Unknown_inline",
                   "",
            ],
            [
                   "SPORT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Sport_inline",
                   "Set the joy stick to sport mode. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Set the joy stick to sport mode. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Sport_inline",
                   "",
            ],
            [
                   "POSITION",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Position_inline",
                   "Set the joy stick to position mode. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Set the joy stick to position mode. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Position_inline",
                   "",
            ],
            [
                   "TRIPOD",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Tripod_inline",
                   "Set the joy stick to tripod mode. Only Supported by Mavic Mini, DJI Mini SE.",
            ],
            [
                   "Set the joy stick to tripod mode. Only Supported by Mavic Mini, DJI Mini SE.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Tripod_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCSoftSwitchJoyStickMode_Unknown_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_NotCalibrating_inline",
                   "There is currently no Remote Controller calibration happening.",
            ],
            [
                   "There is currently no Remote Controller calibration happening.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_NotCalibrating_inline",
                   "",
            ],
            [
                   "MIDDLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_RecordingCenterPosition_inline",
                   "Currently recording the joystick in its center position (joystick is untouched).",
            ],
            [
                   "Currently recording the joystick in its center position (joystick is untouched).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_RecordingCenterPosition_inline",
                   "",
            ],
            [
                   "LIMITS",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_RecordingExtremePositions_inline",
                   "Currently recording the extreme joystick positions, when joysticks are all the way to their max in any direction (left, right, up, or down).",
            ],
            [
                   "Currently recording the extreme joystick positions, when joysticks are all the way to their max in any direction (left, right, up, or down).",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_RecordingExtremePositions_inline",
                   "",
            ],
            [
                   "QUIT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_Exit_inline",
                   "The Remote Controller is exiting calibration.",
            ],
            [
                   "The Remote Controller is exiting calibration.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCCalibrationState_Exit_inline",
                   "",
            ],
            [
                   "TOP_LEFT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_TopLeft_inline",
                   "PIP is on the screen's top left.",
            ],
            [
                   "PIP is on the screen's top left.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_TopLeft_inline",
                   "",
            ],
            [
                   "TOP_RIGHT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_TopRight_inline",
                   "PIP is on the screen's top right.",
            ],
            [
                   "PIP is on the screen's top right.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_TopRight_inline",
                   "",
            ],
            [
                   "BOTTOM_LEFT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_BottomLeft_inline",
                   "PIP is on the screen's bottom left.",
            ],
            [
                   "PIP is on the screen's bottom left.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_BottomLeft_inline",
                   "",
            ],
            [
                   "BOTTOM_RIGHT",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_BottomRight_inline",
                   "PIP is on the screen's bottom right.",
            ],
            [
                   "PIP is on the screen's bottom right.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_BottomRight_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_Unknown_inline",
                   "PIP is on the screen's bottom right.",
            ],
            [
                   "PIP is on the screen's bottom right.",
                   1,
                   "/Components/RemoteController/DJIRemoteController.html",
                   "#DJIRemoteController_DJIRCPIPPosition_Unknown_inline",
                   "",
            ],
            [
                   "isPresent",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "#DJIRemoteController_DJIRCHardwareState_Button_isPresent_inline",
                   "`true` if the hardware button is present.  @return A boolean value.",
            ],
            [
                   "`true` if the hardware button is present.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "#DJIRemoteController_DJIRCHardwareState_Button_isPresent_inline",
                   "",
            ],
            [
                   "isClicked",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "#DJIRemoteController_DJIRCHardwareState_Button_buttonDown_inline",
                   "`true` if button is pressed down.  @return A boolean value.",
            ],
            [
                   "`true` if button is pressed down.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState_Button.html",
                   "#DJIRemoteController_DJIRCHardwareState_Button_buttonDown_inline",
                   "",
            ],
            [
                   "isTurned",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "#DJIRemoteController_DJIRCHardwareRightWheel_wheelChanged_inline",
                   "`true` if dial value has changed.  @return A boolean value.",
            ],
            [
                   "`true` if dial value has changed.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "#DJIRemoteController_DJIRCHardwareRightWheel_wheelChanged_inline",
                   "",
            ],
            [
                   "getValue",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "#DJIRemoteController_DJIRCHardwareRightWheel_value_inline",
                   "Dial value in the range of [-660, 660]. The value represents the difference in an operation.  @return An int value.",
            ],
            [
                   "Dial value in the range of [-660, 660]. The value represents the difference in an operation.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareRightWheel.html",
                   "#DJIRemoteController_DJIRCHardwareRightWheel_value_inline",
                   "",
            ],
            [
                   "isPresent",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitch_isPresent_inline",
                   "`true` if the Transformation Switch present.  @return A boolean value.",
            ],
            [
                   "`true` if the Transformation Switch present.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitch_isPresent_inline",
                   "",
            ],
            [
                   "getState",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitch_transformationSwitchState_inline",
                   "Current transformation switch state.  @return An enum value of `State`",
            ],
            [
                   "Current transformation switch state.  @return An enum value of `State`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitch_transformationSwitchState_inline",
                   "",
            ],
            [
                   "State",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_inline",
                   "Transformation Switch position states.",
            ],
            [
                   "Transformation Switch position states.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_inline",
                   "",
            ],
            [
                   "POSITION_ONE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionOne_inline",
                   "Position One. For all products except Mavic Pro, this is the left most position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller,  Position One is labeled A. For Mavic Pro, Spark and Mavic Air, this is  the position that is furthest away from the pilot and labeled Sport.",
            ],
            [
                   "Position One. For all products except Mavic Pro, this is the left most position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller,  Position One is labeled A. For Mavic Pro, Spark and Mavic Air, this is  the position that is furthest away from the pilot and labeled Sport.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionOne_inline",
                   "",
            ],
            [
                   "POSITION_TWO",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionTwo_inline",
                   "Position Two. For all products except Mavic Pro, this is the middle position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller, Position Two is labeled S. For Mavic Pro, Spark and Mavic Air, this is the position that is closest  to the pilot (the P position).",
            ],
            [
                   "Position Two. For all products except Mavic Pro, this is the middle position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller, Position Two is labeled S. For Mavic Pro, Spark and Mavic Air, this is the position that is closest  to the pilot (the P position).",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionTwo_inline",
                   "",
            ],
            [
                   "POSITION_THREE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionThree_inline",
                   "Position Three. For all products except Mavic Pro, this is the right most position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller, Position Two is labeled P. Mavic Pro, Spark or Mavic Air does not have  a third position for the flight mode switch.",
            ],
            [
                   "Position Three. For all products except Mavic Pro, this is the right most position of the flight mode switch on a remote controller from the perspective of the pilot. For example, on a Phantom 4 remote controller, Position Two is labeled P. Mavic Pro, Spark or Mavic Air does not have  a third position for the flight mode switch.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareState.html",
                   "#DJIRemoteController_DJIRemoteControllerFlightModeSwitchPositionThree_inline",
                   "",
            ],
            [
                   "RETRACT",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_Retract_inline",
                   "Retract landing gear switch state.",
            ],
            [
                   "Retract landing gear switch state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_Retract_inline",
                   "",
            ],
            [
                   "DEPLOY",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_Deploy_inline",
                   "Deploy landing gear switch state.",
            ],
            [
                   "Deploy landing gear switch state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCHardwareTransformationSwitch.html",
                   "#DJIRemoteController_DJIRCHardwareTransformationSwitchState_Deploy_inline",
                   "",
            ],
            [
                   "getVerticalDirection",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButton_verticalMovement_inline",
                   "Get the movement in the vertical direction of the 5D button. Up is the positive direction and down is the  negative direction.  @return An enum value of `FiveDButtonDirection`",
            ],
            [
                   "Get the movement in the vertical direction of the 5D button. Up is the positive direction and down is the  negative direction.  @return An enum value of `FiveDButtonDirection`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButton_verticalMovement_inline",
                   "",
            ],
            [
                   "getHorizontalDirection",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButton_horizontalMovement_inline",
                   "Get the movement in the horizontal direction of the 5D button. Right is the positive direction and left is the  negative direction.  @return An enum value of `FiveDButtonDirection`",
            ],
            [
                   "Get the movement in the horizontal direction of the 5D button. Right is the positive direction and left is the  negative direction.  @return An enum value of `FiveDButtonDirection`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButton_horizontalMovement_inline",
                   "",
            ],
            [
                   "FiveDButtonDirection",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_inline",
                   "Movement direction of the remote controller's 5D button.",
            ],
            [
                   "Movement direction of the remote controller's 5D button.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_inline",
                   "",
            ],
            [
                   "MIDDLE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Middle_inline",
                   "Button has no movement in either the vertical direction or the horizontal direction.",
            ],
            [
                   "Button has no movement in either the vertical direction or the horizontal direction.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Middle_inline",
                   "",
            ],
            [
                   "POSITIVE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Positive_inline",
                   "Button is moved in the positive direction which is up or right.",
            ],
            [
                   "Button is moved in the positive direction which is up or right.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Positive_inline",
                   "",
            ],
            [
                   "NEGATIVE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Negative_inline",
                   "Button is moved in the negative direction which is down or left.",
            ],
            [
                   "Button is moved in the negative direction which is down or left.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCFiveDButton.html",
                   "#DJIRemoteController_DJIRCFiveDButtonDirection_Negative_inline",
                   "",
            ],
            [
                   "getMasterId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_getMasterId_inline",
                   "Get ID of the master remote controller to join.  @return An instance of String.",
            ],
            [
                   "Get ID of the master remote controller to join.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_getMasterId_inline",
                   "",
            ],
            [
                   "setMasterId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_setMasterId_inline",
                   "Set the id of the master remote controller to join.  @param masterId ID of the master remote controller to join.",
            ],
            [
                   "Set the id of the master remote controller to join.  @param masterId ID of the master remote controller to join.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_setMasterId_inline",
                   "",
            ],
            [
                   "getAuthCode",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_getAuthCode_inline",
                   "Authentication code to join the master remote controller.  @return An instance of String.",
            ],
            [
                   "Authentication code to join the master remote controller.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_getAuthCode_inline",
                   "",
            ],
            [
                   "setAuthCode",
                   2,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_setAuthCode_inline",
                   "The mobile device connected to the slave remote controller must know the authorization code of the master remote controller. The master remote controller code is set by using the `setMasterAuthorizationCode` method.  @param authCode Authentication code to join the master remote controller.",
            ],
            [
                   "The mobile device connected to the slave remote controller must know the authorization code of the master remote controller. The master remote controller code is set by using the `setMasterAuthorizationCode` method.  @param authCode Authentication code to join the master remote controller.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_JoinMasterAuthorizationInfo.html",
                   "#DJIRemoteController_JoinMasterAuthorizationInfo_setAuthCode_inline",
                   "",
            ],
            [
                   "getRcMode",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_mode_inline",
                   "The master/slave mode of the remote controller.  @return An enum value of `RCMode`",
            ],
            [
                   "The master/slave mode of the remote controller.  @return An enum value of `RCMode`",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_mode_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_isConnected_inline",
                   "`true` if a slave remote controller joins a master remote controller.  @return A boolean value.",
            ],
            [
                   "`true` if a slave remote controller joins a master remote controller.  @return A boolean value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_isConnected_inline",
                   "",
            ],
            [
                   "getMasterId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_masterID_inline",
                   "ID of the master remote controller.  @return An instance of String.",
            ],
            [
                   "ID of the master remote controller.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_masterID_inline",
                   "",
            ],
            [
                   "getSlaveId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_slaveID_inline",
                   "ID of the slave remote controller.  @return An instance of String.",
            ],
            [
                   "ID of the slave remote controller.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_slaveID_inline",
                   "",
            ],
            [
                   "getAuthorizationCode",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_authorizationCode_inline",
                   "Authorization code of the master remote controller that is a 6 element string of numbers.  @return An instance of String.",
            ],
            [
                   "Authorization code of the master remote controller that is a 6 element string of numbers.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_authorizationCode_inline",
                   "",
            ],
            [
                   "MASTER_SLAVE_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_authorizationCode_inline",
                   "SDK Key for getAuthorizationCode: Authorization code of the master remote controller that is a 6 element string of numbers.  @return An instance of String.",
            ],
            [
                   "SDK Key for getAuthorizationCode: Authorization code of the master remote controller that is a 6 element string of numbers.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_authorizationCode_inline",
                   "",
            ],
            [
                   "hasGimbalControl",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_hasGimbalControl_inline",
                   "`true` if the remote controller has gimbal control.  Call `requestGimbalControl` to attain the gimbal control.  @return `true` if the remote controller has gimbal control.",
            ],
            [
                   "`true` if the remote controller has gimbal control.  Call `requestGimbalControl` to attain the gimbal control.  @return `true` if the remote controller has gimbal control.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCMasterSlaveState.html",
                   "#DJIRemoteController_DJIRCMasterSlaveState_hasGimbalControl_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "",
                   "Callback function that updates the Remote Controller's master and slave state.",
            ],
            [
                   "Callback function that updates the Remote Controller's master and slave state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "MASTER_SLAVE_STATE",
                   2,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "",
                   "SDK Key for Callback: Callback function that updates the Remote Controller's master and slave state.",
            ],
            [
                   "SDK Key for Callback: Callback function that updates the Remote Controller's master and slave state.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_didUpdateMasterSlaveStateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "getId",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_Identifier_inline",
                   "Remote Controller's unique identifier.  @return An int value.",
            ],
            [
                   "Remote Controller's unique identifier.  @return An int value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_Identifier_inline",
                   "",
            ],
            [
                   "getName",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_name_inline",
                   "Remote Controller's name.  @return An instance of String.",
            ],
            [
                   "Remote Controller's name.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_name_inline",
                   "",
            ],
            [
                   "getPassword",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_password_inline",
                   "Remote Controller's password.  @return An instance of String.",
            ],
            [
                   "Remote Controller's password.  @return An instance of String.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_password_inline",
                   "",
            ],
            [
                   "getSignalQuality",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_signalQuality_inline",
                   "Signal quality of a connected master or slave Remote Controller in percent [0, 100].  @return A short value.",
            ],
            [
                   "Signal quality of a connected master or slave Remote Controller in percent [0, 100].  @return A short value.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_signalQuality_inline",
                   "",
            ],
            [
                   "hasGimbalControlPermission",
                   2,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_hasGimbalControlPermission_inline",
                   "`true` if the slave remote controller can control the aircraft's gimbal.  Always `true` for a master remote controller.  @return A boolean value to check if the slave remote controller can control the aircraft's gimbal.",
            ],
            [
                   "`true` if the slave remote controller can control the aircraft's gimbal.  Always `true` for a master remote controller.  @return A boolean value to check if the slave remote controller can control the aircraft's gimbal.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_DJIRCInfo.html",
                   "#DJIRemoteController_DJIRCInfo_hasGimbalControlPermission_inline",
                   "",
            ],
            [
                   "ControlRequestCallback",
                   2,
                   "/Components/RemoteController/DJIRemoteController_RCReceiveGimbalControlRequestFromSlaveCallbackInterface.html",
                   "",
                   "The callback will handle the gimbal control request.",
            ],
            [
                   "The callback will handle the gimbal control request.",
                   1,
                   "/Components/RemoteController/DJIRemoteController_RCReceiveGimbalControlRequestFromSlaveCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "isCurrentOverloaded",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isCurrentOverloaded_inline",
                   "`true` if the battery should be discharged due to a current overload.  @return A boolean value.",
            ],
            [
                   "`true` if the battery should be discharged due to a current overload.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isCurrentOverloaded_inline",
                   "",
            ],
            [
                   "isOverHeated",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isOverHeated_inline",
                   "`true` if the battery has overheated.  @return A boolean value.",
            ],
            [
                   "`true` if the battery has overheated.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isOverHeated_inline",
                   "",
            ],
            [
                   "isLowTemperature",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isLowTemperature_inline",
                   "`true` if the battery has experienced a temperature that is too low.  @return A boolean value.",
            ],
            [
                   "`true` if the battery has experienced a temperature that is too low.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isLowTemperature_inline",
                   "",
            ],
            [
                   "isShortCircuited",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isShortCircuited_inline",
                   "`true` if the battery has been or is short circuited.  @return A boolean value.",
            ],
            [
                   "`true` if the battery has been or is short circuited.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isShortCircuited_inline",
                   "",
            ],
            [
                   "isCustomDischargeEnabled",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isCustomDischargeEnabled_inline",
                   "`true` if the battery has been configured to be discharged over a specific number of days. Once the battery is fully recharged, the battery will again discharge over the number of days set here. This process is cyclical.  @return A boolean value.",
            ],
            [
                   "`true` if the battery has been configured to be discharged over a specific number of days. Once the battery is fully recharged, the battery will again discharge over the number of days set here. This process is cyclical.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_isCustomDischargeEnabled_inline",
                   "",
            ],
            [
                   "getLowVoltageCellIndex",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_lowVoltageCellIndex_inline",
                   "Returns the index at which one of the cells in the battery is below the normal voltage. The first cell has an index of 0.  -1 represents no battery cells under voltage. Phantom Series Aircraft have four cell batteries. Inspire series aircraft and the M100 have 6 cell batteries.  @return An int value.",
            ],
            [
                   "Returns the index at which one of the cells in the battery is below the normal voltage. The first cell has an index of 0.  -1 represents no battery cells under voltage. Phantom Series Aircraft have four cell batteries. Inspire series aircraft and the M100 have 6 cell batteries.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_lowVoltageCellIndex_inline",
                   "",
            ],
            [
                   "getDamagedCellIndex",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_damagedCellIndex_inline",
                   "Returns the index at which one of the cells in the battery is damaged. The first cell has an index of 0. -1 represents no damaged battery cells. Phantom 3 aircraft have 4 cell batteries. Inspire series aircraft and the M100 have 6 cell batteries.  @return An int value.",
            ],
            [
                   "Returns the index at which one of the cells in the battery is damaged. The first cell has an index of 0. -1 represents no damaged battery cells. Phantom 3 aircraft have 4 cell batteries. Inspire series aircraft and the M100 have 6 cell batteries.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "#DJIBattery_WarningRecord_damagedCellIndex_inline",
                   "",
            ],
            [
                   "AggregationState",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "",
                   "Provides a real time summary of the aggregated battery system.",
            ],
            [
                   "Provides a real time summary of the aggregated battery system.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "",
                   "",
            ],
            [
                   "AGGREGATION_STATE",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "",
                   "SDK Key for AggregationState: Provides a real time summary of the aggregated battery system.",
            ],
            [
                   "SDK Key for AggregationState: Provides a real time summary of the aggregated battery system.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "",
                   "",
            ],
            [
                   "getNumberOfConnectedBatteries",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_numberOfConnectedBatteries_inline",
                   "The number of currently connected batteries.  @return An int value.",
            ],
            [
                   "The number of currently connected batteries.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_numberOfConnectedBatteries_inline",
                   "",
            ],
            [
                   "NUMBER_OF_CONNECTED_BATTERIES",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_numberOfConnectedBatteries_inline",
                   "SDK Key for getNumberOfConnectedBatteries: The number of currently connected batteries.  @return An int value.",
            ],
            [
                   "SDK Key for getNumberOfConnectedBatteries: The number of currently connected batteries.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_numberOfConnectedBatteries_inline",
                   "",
            ],
            [
                   "getBatteryOverviews",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_batteryOverviews_inline",
                   "Returns the overview of batteries in the battery group. When a battery is not connected, the `isConnected` property is `false` and the `getChargeRemainingInPercent` is zero. For Matrice 600, there are 6 elements in this array.  @return The `BatteryOverview` instance.",
            ],
            [
                   "Returns the overview of batteries in the battery group. When a battery is not connected, the `isConnected` property is `false` and the `getChargeRemainingInPercent` is zero. For Matrice 600, there are 6 elements in this array.  @return The `BatteryOverview` instance.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_batteryOverviews_inline",
                   "",
            ],
            [
                   "OVERVIEWS",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_batteryOverviews_inline",
                   "SDK Key for getBatteryOverviews: Returns the overview of batteries in the battery group. When a battery is not connected, the `isConnected` property is `false` and the `getChargeRemainingInPercent` is zero. For Matrice 600, there are 6 elements in this array.  @return The `BatteryOverview` instance.",
            ],
            [
                   "SDK Key for getBatteryOverviews: Returns the overview of batteries in the battery group. When a battery is not connected, the `isConnected` property is `false` and the `getChargeRemainingInPercent` is zero. For Matrice 600, there are 6 elements in this array.  @return The `BatteryOverview` instance.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_batteryOverviews_inline",
                   "",
            ],
            [
                   "isAnyBatteryDisconnected",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isDisconnected_inline",
                   "`true` if one of the batteries in the group is disconnected. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "`true` if one of the batteries in the group is disconnected. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isDisconnected_inline",
                   "",
            ],
            [
                   "IS_ANY_BATTERY_DISCONNECTED",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isDisconnected_inline",
                   "SDK Key for isAnyBatteryDisconnected: `true` if one of the batteries in the group is disconnected. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "SDK Key for isAnyBatteryDisconnected: `true` if one of the batteries in the group is disconnected. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isDisconnected_inline",
                   "",
            ],
            [
                   "getCurrent",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_current_inline",
                   "Returns the real time current draw through the batteries. A negative value means the batteries are being discharged.  @return An int value.",
            ],
            [
                   "Returns the real time current draw through the batteries. A negative value means the batteries are being discharged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_current_inline",
                   "",
            ],
            [
                   "CURRENT",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_current_inline",
                   "SDK Key for getCurrent: Returns the real time current draw through the batteries. A negative value means the batteries are being discharged.  @return An int value.",
            ],
            [
                   "SDK Key for getCurrent: Returns the real time current draw through the batteries. A negative value means the batteries are being discharged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_current_inline",
                   "",
            ],
            [
                   "getVoltage",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_voltage_inline",
                   "Returns the current voltage (mV) provided by the battery group.  @return An int value.",
            ],
            [
                   "Returns the current voltage (mV) provided by the battery group.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_voltage_inline",
                   "",
            ],
            [
                   "VOLTAGE",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_voltage_inline",
                   "SDK Key for getVoltage: Returns the current voltage (mV) provided by the battery group.  @return An int value.",
            ],
            [
                   "SDK Key for getVoltage: Returns the current voltage (mV) provided by the battery group.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_voltage_inline",
                   "",
            ],
            [
                   "isVoltageDifferenceDetected",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isVoltageDifferenceDetected_inline",
                   "`true` if there is significant difference between the voltage (above 1.5V) of two batteries. When  `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "`true` if there is significant difference between the voltage (above 1.5V) of two batteries. When  `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isVoltageDifferenceDetected_inline",
                   "",
            ],
            [
                   "IS_VOLTAGE_DIFFERENCE_DETECTED",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isVoltageDifferenceDetected_inline",
                   "SDK Key for isVoltageDifferenceDetected: `true` if there is significant difference between the voltage (above 1.5V) of two batteries. When  `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "SDK Key for isVoltageDifferenceDetected: `true` if there is significant difference between the voltage (above 1.5V) of two batteries. When  `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isVoltageDifferenceDetected_inline",
                   "",
            ],
            [
                   "isLowCellVoltageDetected",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isLowCellVoltageDetected_inline",
                   "`true` if one of the batteries in the group has cells with low voltage. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "`true` if one of the batteries in the group has cells with low voltage. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isLowCellVoltageDetected_inline",
                   "",
            ],
            [
                   "IS_LOW_CELL_VOLTAGE_DETECTED",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isLowCellVoltageDetected_inline",
                   "SDK Key for isLowCellVoltageDetected: `true` if one of the batteries in the group has cells with low voltage. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "SDK Key for isLowCellVoltageDetected: `true` if one of the batteries in the group has cells with low voltage. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isLowCellVoltageDetected_inline",
                   "",
            ],
            [
                   "isCellDamaged",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isCellDamaged_inline",
                   "`true` if one of the batteries in the group has damaged cells. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "`true` if one of the batteries in the group has damaged cells. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isCellDamaged_inline",
                   "",
            ],
            [
                   "IS_CELL_DAMAGED",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isCellDamaged_inline",
                   "SDK Key for isCellDamaged: `true` if one of the batteries in the group has damaged cells. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "SDK Key for isCellDamaged: `true` if one of the batteries in the group has damaged cells. When `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isCellDamaged_inline",
                   "",
            ],
            [
                   "getFullChargeCapacity",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_fullChargeCapacity_inline",
                   "Returns the the total amount of energy, in mAh (milliamp hours), stored in the batteries when the batteries are fully charged.  @return An int value.",
            ],
            [
                   "Returns the the total amount of energy, in mAh (milliamp hours), stored in the batteries when the batteries are fully charged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_fullChargeCapacity_inline",
                   "",
            ],
            [
                   "FULL_CHARGE_CAPACITY",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_fullChargeCapacity_inline",
                   "SDK Key for getFullChargeCapacity: Returns the the total amount of energy, in mAh (milliamp hours), stored in the batteries when the batteries are fully charged.  @return An int value.",
            ],
            [
                   "SDK Key for getFullChargeCapacity: Returns the the total amount of energy, in mAh (milliamp hours), stored in the batteries when the batteries are fully charged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_fullChargeCapacity_inline",
                   "",
            ],
            [
                   "getChargeRemaining",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemaining_inline",
                   "Returns the remaining energy stored in the batteries in mAh (milliamp hours).  @return An int value.",
            ],
            [
                   "Returns the remaining energy stored in the batteries in mAh (milliamp hours).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemaining_inline",
                   "",
            ],
            [
                   "BatteryKey.CHARGE_REMAINING",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemaining_inline",
                   "SDK Key for getChargeRemaining: Returns the remaining energy stored in the batteries in mAh (milliamp hours).  @return An int value.",
            ],
            [
                   "SDK Key for getChargeRemaining: Returns the remaining energy stored in the batteries in mAh (milliamp hours).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemaining_inline",
                   "",
            ],
            [
                   "getChargeRemainingInPercent",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemainingInPercent_inline",
                   "Returns the percentage of energy left in the battery group with range [0,100].  @return An int value.",
            ],
            [
                   "Returns the percentage of energy left in the battery group with range [0,100].  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemainingInPercent_inline",
                   "",
            ],
            [
                   "BatteryKey.CHARGE_REMAINING_IN_PERCENT",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemainingInPercent_inline",
                   "SDK Key for getChargeRemainingInPercent: Returns the percentage of energy left in the battery group with range [0,100].  @return An int value.",
            ],
            [
                   "SDK Key for getChargeRemainingInPercent: Returns the percentage of energy left in the battery group with range [0,100].  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_chargeRemainingInPercent_inline",
                   "",
            ],
            [
                   "getHighestTemperature",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_highestTemperature_inline",
                   "Returns the highest temperature (in Celsius) among the batteries in the group, with range [-128, 127] degrees.  @return An int value.",
            ],
            [
                   "Returns the highest temperature (in Celsius) among the batteries in the group, with range [-128, 127] degrees.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_highestTemperature_inline",
                   "",
            ],
            [
                   "HIGHEST_TEMPERATURE",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_highestTemperature_inline",
                   "SDK Key for getHighestTemperature: Returns the highest temperature (in Celsius) among the batteries in the group, with range [-128, 127] degrees.  @return An int value.",
            ],
            [
                   "SDK Key for getHighestTemperature: Returns the highest temperature (in Celsius) among the batteries in the group, with range [-128, 127] degrees.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_highestTemperature_inline",
                   "",
            ],
            [
                   "isFirmwareDifferenceDetected",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isFirmwareDifferenceDetected_inline",
                   "`true` if one of the batteries in the group has a firmware version different from the others. When it is `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "`true` if one of the batteries in the group has a firmware version different from the others. When it is `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isFirmwareDifferenceDetected_inline",
                   "",
            ],
            [
                   "IS_FIRMWARE_DIFFERENCE_DETECTED",
                   2,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isFirmwareDifferenceDetected_inline",
                   "SDK Key for isFirmwareDifferenceDetected: `true` if one of the batteries in the group has a firmware version different from the others. When it is `true`, the aircraft is not allowed to take off.  @return A boolean value.",
            ],
            [
                   "SDK Key for isFirmwareDifferenceDetected: `true` if one of the batteries in the group has a firmware version different from the others. When it is `true`, the aircraft is not allowed to take off.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_AggregationState.html",
                   "#DJIBattery_AggregationState_isFirmwareDifferenceDetected_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "",
                   "This interface provides a callback to update the current aggregated battery state.",
            ],
            [
                   "This interface provides a callback to update the current aggregated battery state.",
                   1,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "AGGREGATION_STATE",
                   2,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "",
                   "SDK Key for Callback: This interface provides a callback to update the current aggregated battery state.",
            ],
            [
                   "SDK Key for Callback: This interface provides a callback to update the current aggregated battery state.",
                   1,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BatteryOverview",
                   2,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "",
                   "Provides an overview of a battery when aircraft is using multiple batteries.",
            ],
            [
                   "Provides an overview of a battery when aircraft is using multiple batteries.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "",
                   "",
            ],
            [
                   "OVERVIEWS",
                   2,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "",
                   "SDK Key for BatteryOverview: Provides an overview of a battery when aircraft is using multiple batteries.",
            ],
            [
                   "SDK Key for BatteryOverview: Provides an overview of a battery when aircraft is using multiple batteries.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "",
                   "",
            ],
            [
                   "BatteryState",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "",
                   "Supported by both smart and non-smart batteries, this class keeps track of the real-time state of the battery. Non-smart batteries only support the following properties:  - When the connected product is A3 and N3, only `getVoltage` and `getCellVoltageLevel` are valid.  - When the connected product is A2, only `getVoltage` is valid.",
            ],
            [
                   "Supported by both smart and non-smart batteries, this class keeps track of the real-time state of the battery. Non-smart batteries only support the following properties:  - When the connected product is A3 and N3, only `getVoltage` and `getCellVoltageLevel` are valid.  - When the connected product is A2, only `getVoltage` is valid.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "",
                   "",
            ],
            [
                   "getFullChargeCapacity",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_fullChargeCapacity_inline",
                   "Returns the total amount of energy, in mAh (milliamp hours), stored in the battery when the battery is fully charged. The energy of the battery at full charge changes over time as the battery continues to get used. Over time, as the battery continues to be recharged, the value of `getFullChargeCapacity` will decrease.  @return An int value.",
            ],
            [
                   "Returns the total amount of energy, in mAh (milliamp hours), stored in the battery when the battery is fully charged. The energy of the battery at full charge changes over time as the battery continues to get used. Over time, as the battery continues to be recharged, the value of `getFullChargeCapacity` will decrease.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_fullChargeCapacity_inline",
                   "",
            ],
            [
                   "FULL_CHARGE_CAPACITY",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_fullChargeCapacity_inline",
                   "SDK Key for getFullChargeCapacity: Returns the total amount of energy, in mAh (milliamp hours), stored in the battery when the battery is fully charged. The energy of the battery at full charge changes over time as the battery continues to get used. Over time, as the battery continues to be recharged, the value of `getFullChargeCapacity` will decrease.  @return An int value.",
            ],
            [
                   "SDK Key for getFullChargeCapacity: Returns the total amount of energy, in mAh (milliamp hours), stored in the battery when the battery is fully charged. The energy of the battery at full charge changes over time as the battery continues to get used. Over time, as the battery continues to be recharged, the value of `getFullChargeCapacity` will decrease.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_fullChargeCapacity_inline",
                   "",
            ],
            [
                   "getDesignCapacity",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_designCapacity_inline",
                   "Returns the design capacity of the battery in mAh (milliamp hours). It is the ideal capacity when the battery is new. This value will not change over time. It is only supported by smart battery.  @return An int value.",
            ],
            [
                   "Returns the design capacity of the battery in mAh (milliamp hours). It is the ideal capacity when the battery is new. This value will not change over time. It is only supported by smart battery.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_designCapacity_inline",
                   "",
            ],
            [
                   "getChargeRemaining",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemaining_inline",
                   "Returns the remaining energy stored in the battery in mAh (milliamp hours).  @return An int value.",
            ],
            [
                   "Returns the remaining energy stored in the battery in mAh (milliamp hours).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemaining_inline",
                   "",
            ],
            [
                   "BatteryKey.CHARGE_REMAINING",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemaining_inline",
                   "SDK Key for getChargeRemaining: Returns the remaining energy stored in the battery in mAh (milliamp hours).  @return An int value.",
            ],
            [
                   "SDK Key for getChargeRemaining: Returns the remaining energy stored in the battery in mAh (milliamp hours).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemaining_inline",
                   "",
            ],
            [
                   "getChargeRemainingInPercent",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemainingInPercent_inline",
                   "Returns the percentage of battery energy left with range [0, 100].  @return An int value.",
            ],
            [
                   "Returns the percentage of battery energy left with range [0, 100].  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemainingInPercent_inline",
                   "",
            ],
            [
                   "BatteryKey.CHARGE_REMAINING_IN_PERCENT",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemainingInPercent_inline",
                   "SDK Key for getChargeRemainingInPercent: Returns the percentage of battery energy left with range [0, 100].  @return An int value.",
            ],
            [
                   "SDK Key for getChargeRemainingInPercent: Returns the percentage of battery energy left with range [0, 100].  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_chargeRemainingInPercent_inline",
                   "",
            ],
            [
                   "getVoltage",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_voltage_inline",
                   "Returns the current battery voltage (mV).  @return An int value.",
            ],
            [
                   "Returns the current battery voltage (mV).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_voltage_inline",
                   "",
            ],
            [
                   "VOLTAGE",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_voltage_inline",
                   "SDK Key for getVoltage: Returns the current battery voltage (mV).  @return An int value.",
            ],
            [
                   "SDK Key for getVoltage: Returns the current battery voltage (mV).  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_voltage_inline",
                   "",
            ],
            [
                   "getCurrent",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_current_inline",
                   "Returns the real time current draw of the battery (mA). A negative value means the battery is being discharged, and a positive value means it is being charged.  @return An int value.",
            ],
            [
                   "Returns the real time current draw of the battery (mA). A negative value means the battery is being discharged, and a positive value means it is being charged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_current_inline",
                   "",
            ],
            [
                   "CURRENT",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_current_inline",
                   "SDK Key for getCurrent: Returns the real time current draw of the battery (mA). A negative value means the battery is being discharged, and a positive value means it is being charged.  @return An int value.",
            ],
            [
                   "SDK Key for getCurrent: Returns the real time current draw of the battery (mA). A negative value means the battery is being discharged, and a positive value means it is being charged.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_current_inline",
                   "",
            ],
            [
                   "getLifetimeRemaining",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_lifetimeRemaining_inline",
                   "Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close to 100%. As a battery experiences charge/discharge cycles, the value will go down. In unsupported products, this value will always be 0.  These products are Phantom 4 Pro, Inspire 2, and Phantom 4 Advanced.  @return An int value.",
            ],
            [
                   "Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close to 100%. As a battery experiences charge/discharge cycles, the value will go down. In unsupported products, this value will always be 0.  These products are Phantom 4 Pro, Inspire 2, and Phantom 4 Advanced.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_lifetimeRemaining_inline",
                   "",
            ],
            [
                   "LIFETIME_REMAINING",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_lifetimeRemaining_inline",
                   "SDK Key for getLifetimeRemaining: Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close to 100%. As a battery experiences charge/discharge cycles, the value will go down. In unsupported products, this value will always be 0.  These products are Phantom 4 Pro, Inspire 2, and Phantom 4 Advanced.  @return An int value.",
            ],
            [
                   "SDK Key for getLifetimeRemaining: Returns the battery's remaining lifetime as a percentage, with range [0, 100]. A new battery will be close to 100%. As a battery experiences charge/discharge cycles, the value will go down. In unsupported products, this value will always be 0.  These products are Phantom 4 Pro, Inspire 2, and Phantom 4 Advanced.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_lifetimeRemaining_inline",
                   "",
            ],
            [
                   "getTemperature",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_temperature_inline",
                   "Returns the battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value.",
            ],
            [
                   "Returns the battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_temperature_inline",
                   "",
            ],
            [
                   "TEMPERATURE",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_temperature_inline",
                   "SDK Key for getTemperature: Returns the battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value.",
            ],
            [
                   "SDK Key for getTemperature: Returns the battery's temperature, in Celsius, with range [-128, 127] degrees.  @return A float value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_temperature_inline",
                   "",
            ],
            [
                   "getNumberOfDischarges",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_numberOfDischarges_inline",
                   "Returns the total number of discharges the battery has gone through over its lifetime. The total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return An int value.",
            ],
            [
                   "Returns the total number of discharges the battery has gone through over its lifetime. The total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_numberOfDischarges_inline",
                   "",
            ],
            [
                   "NUMBER_OF_DISCHARGES",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_numberOfDischarges_inline",
                   "SDK Key for getNumberOfDischarges: Returns the total number of discharges the battery has gone through over its lifetime. The total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return An int value.",
            ],
            [
                   "SDK Key for getNumberOfDischarges: Returns the total number of discharges the battery has gone through over its lifetime. The total number of discharges includes discharges that happen through normal use and discharges that are manually set.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_numberOfDischarges_inline",
                   "",
            ],
            [
                   "getCellVoltageLevel",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_cellVoltageLevel_inline",
                   "Current cell voltage level of the battery. It is only supported when the connected product is stand-alone A3 or N3.  @return An enum value of the `BatteryCellVoltageLevel`.",
            ],
            [
                   "Current cell voltage level of the battery. It is only supported when the connected product is stand-alone A3 or N3.  @return An enum value of the `BatteryCellVoltageLevel`.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_cellVoltageLevel_inline",
                   "",
            ],
            [
                   "CELL_VOLTAGE_LEVEL",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_cellVoltageLevel_inline",
                   "SDK Key for getCellVoltageLevel: Current cell voltage level of the battery. It is only supported when the connected product is stand-alone A3 or N3.  @return An enum value of the `BatteryCellVoltageLevel`.",
            ],
            [
                   "SDK Key for getCellVoltageLevel: Current cell voltage level of the battery. It is only supported when the connected product is stand-alone A3 or N3.  @return An enum value of the `BatteryCellVoltageLevel`.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_cellVoltageLevel_inline",
                   "",
            ],
            [
                   "getConnectionState",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_getConnectionState_inline",
                   "Get battery connection status.  @return A ConnectionState value.",
            ],
            [
                   "Get battery connection status.  @return A ConnectionState value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_getConnectionState_inline",
                   "",
            ],
            [
                   "isBeingCharged",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isBeingCharged_inline",
                   "`true` if the battery is being charged.  @return The boolean value.",
            ],
            [
                   "`true` if the battery is being charged.  @return The boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isBeingCharged_inline",
                   "",
            ],
            [
                   "IS_BEING_CHARGED",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isBeingCharged_inline",
                   "SDK Key for isBeingCharged: `true` if the battery is being charged.  @return The boolean value.",
            ],
            [
                   "SDK Key for isBeingCharged: `true` if the battery is being charged.  @return The boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isBeingCharged_inline",
                   "",
            ],
            [
                   "isInSingleBatteryMode",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isInSingleBatteryMode_inline",
                   "`true` if only one battery is inserted on the the right or starboard side of the aircraft. The aircraft can still take off but the flight time will be shorter. It is only supported by Inspire 2: Inspire 2 must always have a battery in the right/starboard slot.  @return A boolean value.",
            ],
            [
                   "`true` if only one battery is inserted on the the right or starboard side of the aircraft. The aircraft can still take off but the flight time will be shorter. It is only supported by Inspire 2: Inspire 2 must always have a battery in the right/starboard slot.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isInSingleBatteryMode_inline",
                   "",
            ],
            [
                   "IS_IN_SINGLE_BATTERY_MODE",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isInSingleBatteryMode_inline",
                   "SDK Key for isInSingleBatteryMode: `true` if only one battery is inserted on the the right or starboard side of the aircraft. The aircraft can still take off but the flight time will be shorter. It is only supported by Inspire 2: Inspire 2 must always have a battery in the right/starboard slot.  @return A boolean value.",
            ],
            [
                   "SDK Key for isInSingleBatteryMode: `true` if only one battery is inserted on the the right or starboard side of the aircraft. The aircraft can still take off but the flight time will be shorter. It is only supported by Inspire 2: Inspire 2 must always have a battery in the right/starboard slot.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_isInSingleBatteryMode_inline",
                   "",
            ],
            [
                   "getSelfHeatingState",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_selfHeatingState_inline",
                   "Get self-heating state of the battery. When the temperature of the battery is below 6 celsius degrees, it will warm  up automatically. It is only supported by Mavic 2 Enterprise.  @return An enum value of the `SelfHeatingState`.",
            ],
            [
                   "Get self-heating state of the battery. When the temperature of the battery is below 6 celsius degrees, it will warm  up automatically. It is only supported by Mavic 2 Enterprise.  @return An enum value of the `SelfHeatingState`.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_BatteryState_selfHeatingState_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/Battery/DJIBattery_StateUpdateCallbackInterface.html",
                   "",
                   "This interface provides a callback to update the battery's current state.",
            ],
            [
                   "This interface provides a callback to update the battery's current state.",
                   1,
                   "/Components/Battery/DJIBattery_StateUpdateCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BatteryCellVoltageLevel",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_inline",
                   "Battery cell voltage level threshold. Different thresholds will initiate different aircraft behaviors or operations. Level 3 is the lowest level. It is only supported when the connected product is stand-alone A3 and N3.",
            ],
            [
                   "Battery cell voltage level threshold. Different thresholds will initiate different aircraft behaviors or operations. Level 3 is the lowest level. It is only supported when the connected product is stand-alone A3 and N3.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_inline",
                   "",
            ],
            [
                   "CELL_VOLTAGE_LEVEL",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_inline",
                   "SDK Key for BatteryCellVoltageLevel: Battery cell voltage level threshold. Different thresholds will initiate different aircraft behaviors or operations. Level 3 is the lowest level. It is only supported when the connected product is stand-alone A3 and N3.",
            ],
            [
                   "SDK Key for BatteryCellVoltageLevel: Battery cell voltage level threshold. Different thresholds will initiate different aircraft behaviors or operations. Level 3 is the lowest level. It is only supported when the connected product is stand-alone A3 and N3.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_inline",
                   "",
            ],
            [
                   "LEVEL_0",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level0_inline",
                   "The cell voltage is at a safe level; the aircraft can fly normally.",
            ],
            [
                   "The cell voltage is at a safe level; the aircraft can fly normally.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level0_inline",
                   "",
            ],
            [
                   "LEVEL_1",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level1_inline",
                   "The cell voltage is equal to or lower than threshold Level 1. At this level the Level 1 operation will be executed. The threshold value and operation for Level 1 can be configured by the user.",
            ],
            [
                   "The cell voltage is equal to or lower than threshold Level 1. At this level the Level 1 operation will be executed. The threshold value and operation for Level 1 can be configured by the user.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level1_inline",
                   "",
            ],
            [
                   "LEVEL_2",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level2_inline",
                   "The cell voltage is equal to or lower than threshold Level 2. At this level the Level 2 operation will be executed. The threshold value and operation for Level 2 can be configured by the user.",
            ],
            [
                   "The cell voltage is equal to or lower than threshold Level 2. At this level the Level 2 operation will be executed. The threshold value and operation for Level 2 can be configured by the user.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level2_inline",
                   "",
            ],
            [
                   "LEVEL_3",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level3_inline",
                   "The cell voltage is equal to or lower than Level 3. At this level, the aircraft will start landing. The threshold for Level 3 cannot be configured by the user and is fixed at 3400mV.",
            ],
            [
                   "The cell voltage is equal to or lower than Level 3. At this level, the aircraft will start landing. The threshold for Level 3 cannot be configured by the user and is fixed at 3400mV.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Level3_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Unknown_inline",
                   "The cell voltage level is unknown.",
            ],
            [
                   "The cell voltage level is unknown.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryState.html",
                   "#DJIBattery_DJIBatteryCellVoltageLevel_Unknown_inline",
                   "",
            ],
            [
                   "getIndex",
                   2,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_index_inline",
                   "Index of the battery. Index starts from 0. For Matrice 600, the number 1 battery compartment relates to index 0.  @return An int value.",
            ],
            [
                   "Index of the battery. Index starts from 0. For Matrice 600, the number 1 battery compartment relates to index 0.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_index_inline",
                   "",
            ],
            [
                   "isConnected",
                   2,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_isConnected_inline",
                   "`true` if the battery is currently connected to the aircraft.  @return A boolean value.",
            ],
            [
                   "`true` if the battery is currently connected to the aircraft.  @return A boolean value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_isConnected_inline",
                   "",
            ],
            [
                   "getChargeRemainingInPercent",
                   2,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_chargeRemainingInPercent_inline",
                   "The remaining percentage energy of the battery with range [0, 100].  @return An int value.",
            ],
            [
                   "The remaining percentage energy of the battery with range [0, 100].  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery_BatteryOverview.html",
                   "#DJIBattery_BatteryOverview_chargeRemainingInPercent_inline",
                   "",
            ],
            [
                   "ConnectionState",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_inline",
                   "Battery connection status. 0 means NORMAL, 1 means INVALID, and 2 means EXCEPTION in communication.",
            ],
            [
                   "Battery connection status. 0 means NORMAL, 1 means INVALID, and 2 means EXCEPTION in communication.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_inline",
                   "",
            ],
            [
                   "CONNECTION_STATE",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_inline",
                   "SDK Key for ConnectionState: Battery connection status. 0 means NORMAL, 1 means INVALID, and 2 means EXCEPTION in communication.",
            ],
            [
                   "SDK Key for ConnectionState: Battery connection status. 0 means NORMAL, 1 means INVALID, and 2 means EXCEPTION in communication.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_inline",
                   "",
            ],
            [
                   "NORMAL",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Normal_inline",
                   "Normal.",
            ],
            [
                   "Normal.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Normal_inline",
                   "",
            ],
            [
                   "INVALID",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Invalid_inline",
                   "Invalid.",
            ],
            [
                   "Invalid.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Invalid_inline",
                   "",
            ],
            [
                   "EXCEPTION",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Exception_inline",
                   "Exception.",
            ],
            [
                   "Exception.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Exception_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_BatteryConnectionState_Unknown_inline",
                   "",
            ],
            [
                   "setStateCallback",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setStateUpdateCallback_inline",
                   "Sets the callback that updates battery state.  @param callback Callback method.",
            ],
            [
                   "Sets the callback that updates battery state.  @param callback Callback method.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setStateUpdateCallback_inline",
                   "",
            ],
            [
                   "setAggregationStateCallback",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_Aggregation_setStateUpdateCallback_inline",
                   "Sets the callback that updates aggregated battery state.  @param callback Callback method.",
            ],
            [
                   "Sets the callback that updates aggregated battery state.  @param callback Callback method.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_Aggregation_setStateUpdateCallback_inline",
                   "",
            ],
            [
                   "AGGREGATION_STATE",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_Aggregation_setStateUpdateCallback_inline",
                   "SDK Key for setAggregationStateCallback: Sets the callback that updates aggregated battery state.  @param callback Callback method.",
            ],
            [
                   "SDK Key for setAggregationStateCallback: Sets the callback that updates aggregated battery state.  @param callback Callback method.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_Aggregation_setStateUpdateCallback_inline",
                   "",
            ],
            [
                   "getCellVoltages",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getCellVoltages_inline",
                   "Gets the battery's cell voltages. There will be a voltage for each cell in the battery.  @param callback Asynchronous execution result callback.",
            ],
            [
                   "Gets the battery's cell voltages. There will be a voltage for each cell in the battery.  @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getCellVoltages_inline",
                   "",
            ],
            [
                   "CELL_VOLTAGES",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getCellVoltages_inline",
                   "SDK Key for getCellVoltages: Gets the battery's cell voltages. There will be a voltage for each cell in the battery.  @param callback Asynchronous execution result callback.",
            ],
            [
                   "SDK Key for getCellVoltages: Gets the battery's cell voltages. There will be a voltage for each cell in the battery.  @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getCellVoltages_inline",
                   "",
            ],
            [
                   "getNumberOfCells",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_numberOfCells_inline",
                   "Returns the number of battery cells.  @return An int value.",
            ],
            [
                   "Returns the number of battery cells.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_numberOfCells_inline",
                   "",
            ],
            [
                   "NUMBER_OF_CELLS",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_numberOfCells_inline",
                   "SDK Key for getNumberOfCells: Returns the number of battery cells.  @return An int value.",
            ],
            [
                   "SDK Key for getNumberOfCells: Returns the number of battery cells.  @return An int value.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_numberOfCells_inline",
                   "",
            ],
            [
                   "setNumberOfCells",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setNumberOfCells_inline",
                   "When the connected battery is not a smart battery, the number of cells needs to be set manually. The flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. The valid range is [3, 12] cells.  @param numberOfCells Number of cells inside the battery. @param callback Asynchronous execution result callback.",
            ],
            [
                   "When the connected battery is not a smart battery, the number of cells needs to be set manually. The flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. The valid range is [3, 12] cells.  @param numberOfCells Number of cells inside the battery. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setNumberOfCells_inline",
                   "",
            ],
            [
                   "NUMBER_OF_CELLS",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setNumberOfCells_inline",
                   "SDK Key for setNumberOfCells: When the connected battery is not a smart battery, the number of cells needs to be set manually. The flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. The valid range is [3, 12] cells.  @param numberOfCells Number of cells inside the battery. @param callback Asynchronous execution result callback.",
            ],
            [
                   "SDK Key for setNumberOfCells: When the connected battery is not a smart battery, the number of cells needs to be set manually. The flight controller uses the number of cells and the cell voltage threshold to determine if the aircraft should go home or land. The valid range is [3, 12] cells.  @param numberOfCells Number of cells inside the battery. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setNumberOfCells_inline",
                   "",
            ],
            [
                   "isSmartBattery",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_isSmartBattery_inline",
                   "`true` if the battery is a smart battery. When the connected battery is a DJI smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
            ],
            [
                   "`true` if the battery is a smart battery. When the connected battery is a DJI smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_isSmartBattery_inline",
                   "",
            ],
            [
                   "IS_SMART_BATTERY",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_isSmartBattery_inline",
                   "SDK Key for isSmartBattery: `true` if the battery is a smart battery. When the connected battery is a DJI smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
            ],
            [
                   "SDK Key for isSmartBattery: `true` if the battery is a smart battery. When the connected battery is a DJI smart battery, more information can be obtained by communicating with the battery.  @return >true</code> if battery is smart battery.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_isSmartBattery_inline",
                   "",
            ],
            [
                   "pairBatteries",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_pairBatteries_inline",
                   "A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getPairingState` can then be used to determine if the installed battery combination is a previously assigned pair or not. Batteries can be repaired.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getPairingState` can then be used to determine if the installed battery combination is a previously assigned pair or not. Batteries can be repaired.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_pairBatteries_inline",
                   "",
            ],
            [
                   "BatteryKey.PAIR_BATTERIES",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_pairBatteries_inline",
                   "SDK Key for pairBatteries: A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getPairingState` can then be used to determine if the installed battery combination is a previously assigned pair or not. Batteries can be repaired.  @param callback Completion callback that receives the execution result.",
            ],
            [
                   "SDK Key for pairBatteries: A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with the lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method will pair two batteries by recording the aggregate of their serial numbers in each of their firmwares. `getPairingState` can then be used to determine if the installed battery combination is a previously assigned pair or not. Batteries can be repaired.  @param callback Completion callback that receives the execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_pairBatteries_inline",
                   "",
            ],
            [
                   "getPairingState",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryPairStatus_inline",
                   "A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback Callback that receives the pairing state.",
            ],
            [
                   "A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback Callback that receives the pairing state.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryPairStatus_inline",
                   "",
            ],
            [
                   "BatteryKey.PAIRING_STATE",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryPairStatus_inline",
                   "SDK Key for getPairingState: A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback Callback that receives the pairing state.",
            ],
            [
                   "SDK Key for getPairingState: A battery's full charge capacity reduces a little every time it goes through a discharge and recharge cycle. Therefore, older batteries that have gone through many cycles will have lower full charge capacity than newer batteries. When multiple batteries are used simultaneously in a product, the aggregate full charge capacity will be limited by the battery with lowest full charge capacity.  To optimize the amount of energy delivered by a battery over its lifetime to a product, batteries should be matched or paired with other batteries of similar full charge capacity. The operational challenges of always using paired batteries can be alleviated using the battery pairing interfaces. This method can then be used to determine if the installed battery combination is a previously assigned pair or not.  @param callback Callback that receives the pairing state.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryPairStatus_inline",
                   "",
            ],
            [
                   "getManufactureDate",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getManufactureDate_inline",
                   "Gets the manufacture date of current battery. It it only supported by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the manufacture date of current battery. It it only supported by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getManufactureDate_inline",
                   "",
            ],
            [
                   "setLevel1CellVoltageThreshold",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageThreshold_inline",
                   "Sets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV. When the new value is not 100 mV higher than the Level 2 cell voltage threshold, the Level 2 threshold will be set to (new value - 100) mV.  @param voltage Level 1 cell voltage threshold to set in mV. @param callback Completion block that receives the setter execution result.",
            ],
            [
                   "Sets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV. When the new value is not 100 mV higher than the Level 2 cell voltage threshold, the Level 2 threshold will be set to (new value - 100) mV.  @param voltage Level 1 cell voltage threshold to set in mV. @param callback Completion block that receives the setter execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageThreshold_inline",
                   "SDK Key for setLevel1CellVoltageThreshold: Sets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV. When the new value is not 100 mV higher than the Level 2 cell voltage threshold, the Level 2 threshold will be set to (new value - 100) mV.  @param voltage Level 1 cell voltage threshold to set in mV. @param callback Completion block that receives the setter execution result.",
            ],
            [
                   "SDK Key for setLevel1CellVoltageThreshold: Sets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV. When the new value is not 100 mV higher than the Level 2 cell voltage threshold, the Level 2 threshold will be set to (new value - 100) mV.  @param voltage Level 1 cell voltage threshold to set in mV. @param callback Completion block that receives the setter execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "getLevel1CellVoltageThreshold",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageThreshold_inline",
                   "Gets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
            ],
            [
                   "Gets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageThreshold_inline",
                   "SDK Key for getLevel1CellVoltageThreshold: Gets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
            ],
            [
                   "SDK Key for getLevel1CellVoltageThreshold: Gets the Level 1 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 1 behavior will be executed. The valid range is [3600, 4000] mV.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "setLevel2CellVoltageThreshold",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageThreshold_inline",
                   "Sets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed. The valid range is [3500, 3800] mV and must be at least 100 mV lower than the Level 1 voltage threshold.  @param voltage Level 2 cell voltage threshold to set in mV. @param callback Asynchronous execution result callback.",
            ],
            [
                   "Sets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed. The valid range is [3500, 3800] mV and must be at least 100 mV lower than the Level 1 voltage threshold.  @param voltage Level 2 cell voltage threshold to set in mV. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageThreshold_inline",
                   "SDK Key for setLevel2CellVoltageThreshold: Sets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed. The valid range is [3500, 3800] mV and must be at least 100 mV lower than the Level 1 voltage threshold.  @param voltage Level 2 cell voltage threshold to set in mV. @param callback Asynchronous execution result callback.",
            ],
            [
                   "SDK Key for setLevel2CellVoltageThreshold: Sets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed. The valid range is [3500, 3800] mV and must be at least 100 mV lower than the Level 1 voltage threshold.  @param voltage Level 2 cell voltage threshold to set in mV. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "getLevel2CellVoltageThreshold",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageThreshold_inline",
                   "Gets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
            ],
            [
                   "Gets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageThreshold_inline",
                   "SDK Key for getLevel2CellVoltageThreshold: Gets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
            ],
            [
                   "SDK Key for getLevel2CellVoltageThreshold: Gets the Level 2 cell voltage threshold in mV. When the cell voltage of the battery crosses below the threshold, Level 2 behavior will be executed.  @param callback Asynchronous execution result callback that contains the voltage threshold.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageThreshold_inline",
                   "",
            ],
            [
                   "setLevel1CellVoltageBehavior",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageBehavior_inline",
                   "Sets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold. It can only be set when the motors are off.  @param behavior Level 1 behavior. @param callback Completion block that receives the setter execution result.",
            ],
            [
                   "Sets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold. It can only be set when the motors are off.  @param behavior Level 1 behavior. @param callback Completion block that receives the setter execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageBehavior_inline",
                   "SDK Key for setLevel1CellVoltageBehavior: Sets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold. It can only be set when the motors are off.  @param behavior Level 1 behavior. @param callback Completion block that receives the setter execution result.",
            ],
            [
                   "SDK Key for setLevel1CellVoltageBehavior: Sets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold. It can only be set when the motors are off.  @param behavior Level 1 behavior. @param callback Completion block that receives the setter execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel1CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "getLevel1CellVoltageBehavior",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageBehavior_inline",
                   "Gets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
            ],
            [
                   "Gets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageBehavior_inline",
                   "SDK Key for getLevel1CellVoltageBehavior: Gets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
            ],
            [
                   "SDK Key for getLevel1CellVoltageBehavior: Gets the behavior that will be executed when the cell voltage crosses under the Level 1 threshold.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel1CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "setLevel2CellVoltageBehavior",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageBehavior_inline",
                   "Sets the operation that will be executed when the cell voltage crosses under Level 2 threshold. It can only be set when motors are off.  @param behavior Level 2 behavior. @param callback Asynchronous execution result callback.",
            ],
            [
                   "Sets the operation that will be executed when the cell voltage crosses under Level 2 threshold. It can only be set when motors are off.  @param behavior Level 2 behavior. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageBehavior_inline",
                   "SDK Key for setLevel2CellVoltageBehavior: Sets the operation that will be executed when the cell voltage crosses under Level 2 threshold. It can only be set when motors are off.  @param behavior Level 2 behavior. @param callback Asynchronous execution result callback.",
            ],
            [
                   "SDK Key for setLevel2CellVoltageBehavior: Sets the operation that will be executed when the cell voltage crosses under Level 2 threshold. It can only be set when motors are off.  @param behavior Level 2 behavior. @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLevel2CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "getLevel2CellVoltageBehavior",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageBehavior_inline",
                   "Sets the behavior that will be executed when the cell voltage crosses under the Level 2 threshold. It is not supported by Mavic Air.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
            ],
            [
                   "Sets the behavior that will be executed when the cell voltage crosses under the Level 2 threshold. It is not supported by Mavic Air.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageBehavior_inline",
                   "SDK Key for getLevel2CellVoltageBehavior: Sets the behavior that will be executed when the cell voltage crosses under the Level 2 threshold. It is not supported by Mavic Air.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
            ],
            [
                   "SDK Key for getLevel2CellVoltageBehavior: Sets the behavior that will be executed when the cell voltage crosses under the Level 2 threshold. It is not supported by Mavic Air.  @param callback Asynchronous execution result callback that contains the voltage threshold behavior.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLevel2CellVoltageBehavior_inline",
                   "",
            ],
            [
                   "setLEDsEnabled",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLEDsEnabled_inline",
                   "Enables/disables the LED lights on the batteries. If all batteries' LEDs on the aircraft are turned off, the aircraft's power button LED indicator should be off. It's supported only by Matrice 300 RTK.  @param enabled `true` to enable the LED lights on the batteries. @param callback Completion callback that receives the setter execution result.",
            ],
            [
                   "Enables/disables the LED lights on the batteries. If all batteries' LEDs on the aircraft are turned off, the aircraft's power button LED indicator should be off. It's supported only by Matrice 300 RTK.  @param enabled `true` to enable the LED lights on the batteries. @param callback Completion callback that receives the setter execution result.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setLEDsEnabled_inline",
                   "",
            ],
            [
                   "getLEDsEnabled",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLEDsEnabled_inline",
                   "Determines if the LEDs on the battery is on. If all batteries' LEDs on the aircraft are turned off, the aircraft's power button LED indicator should be off. It's supported only by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if the LEDs on the battery is on. If all batteries' LEDs on the aircraft are turned off, the aircraft's power button LED indicator should be off. It's supported only by Matrice 300 RTK.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLEDsEnabled_inline",
                   "",
            ],
            [
                   "getBatteryType",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryType_inline",
                   "Determines if the battery is the correct type in current area.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Determines if the battery is the correct type in current area.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getBatteryType_inline",
                   "",
            ],
            [
                   "getLatestWarningRecord",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLatestWarningRecord_inline",
                   "Gets the battery's most recent warning record. Anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback Asynchronous execution result callback that contains the latest warning record.",
            ],
            [
                   "Gets the battery's most recent warning record. Anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback Asynchronous execution result callback that contains the latest warning record.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLatestWarningRecord_inline",
                   "",
            ],
            [
                   "LATEST_WARNING_RECORD",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLatestWarningRecord_inline",
                   "SDK Key for getLatestWarningRecord: Gets the battery's most recent warning record. Anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback Asynchronous execution result callback that contains the latest warning record.",
            ],
            [
                   "SDK Key for getLatestWarningRecord: Gets the battery's most recent warning record. Anytime the battery experiences a significant exception, it will get recorded as a warning record.  @param callback Asynchronous execution result callback that contains the latest warning record.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getLatestWarningRecord_inline",
                   "",
            ],
            [
                   "getWarningRecords",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getHistoricalWarningRecords_inline",
                   "Gets the battery's warning records, which are kept for 30 days using objects of type WarningRecord</code>. Call the isSmartBattery()</code> method before using this method. Not supported by Osmo and non-smart batteries.  @param callback Asynchronous execution result callback that contains the batteries warning records.",
            ],
            [
                   "Gets the battery's warning records, which are kept for 30 days using objects of type WarningRecord</code>. Call the isSmartBattery()</code> method before using this method. Not supported by Osmo and non-smart batteries.  @param callback Asynchronous execution result callback that contains the batteries warning records.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getHistoricalWarningRecords_inline",
                   "",
            ],
            [
                   "HISTORICAL_WARNING_RECORDS",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getHistoricalWarningRecords_inline",
                   "SDK Key for getWarningRecords: Gets the battery's warning records, which are kept for 30 days using objects of type WarningRecord</code>. Call the isSmartBattery()</code> method before using this method. Not supported by Osmo and non-smart batteries.  @param callback Asynchronous execution result callback that contains the batteries warning records.",
            ],
            [
                   "SDK Key for getWarningRecords: Gets the battery's warning records, which are kept for 30 days using objects of type WarningRecord</code>. Call the isSmartBattery()</code> method before using this method. Not supported by Osmo and non-smart batteries.  @param callback Asynchronous execution result callback that contains the batteries warning records.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getHistoricalWarningRecords_inline",
                   "",
            ],
            [
                   "setSelfDischargeInDays",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setSelfDischargeInDays_inline",
                   "Smart batteries can be setup to automatically discharge over a custom period of time. This method sets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by Mavic Air 2, DJI Air 2S, non-smart batteries, Spark and the Osmo series.  @param days Day for self-discharge @param callback Asynchronous execution result callback.",
            ],
            [
                   "Smart batteries can be setup to automatically discharge over a custom period of time. This method sets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by Mavic Air 2, DJI Air 2S, non-smart batteries, Spark and the Osmo series.  @param days Day for self-discharge @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setSelfDischargeInDays_inline",
                   "",
            ],
            [
                   "SELF_DISCHARGE_IN_DAYS",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setSelfDischargeInDays_inline",
                   "SDK Key for setSelfDischargeInDays: Smart batteries can be setup to automatically discharge over a custom period of time. This method sets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by Mavic Air 2, DJI Air 2S, non-smart batteries, Spark and the Osmo series.  @param days Day for self-discharge @param callback Asynchronous execution result callback.",
            ],
            [
                   "SDK Key for setSelfDischargeInDays: Smart batteries can be setup to automatically discharge over a custom period of time. This method sets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by Mavic Air 2, DJI Air 2S, non-smart batteries, Spark and the Osmo series.  @param days Day for self-discharge @param callback Asynchronous execution result callback.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_setSelfDischargeInDays_inline",
                   "",
            ],
            [
                   "getSelfDischargeInDays",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getSelfDischargeInDays_inline",
                   "Smart batteries can be setup to automatically discharge over a custom period of time. This method gets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by non-smart batteries and the Osmo series.  @param callback Asynchronous execution result callback that contains the number of days to discharge over.",
            ],
            [
                   "Smart batteries can be setup to automatically discharge over a custom period of time. This method gets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by non-smart batteries and the Osmo series.  @param callback Asynchronous execution result callback that contains the number of days to discharge over.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getSelfDischargeInDays_inline",
                   "",
            ],
            [
                   "SELF_DISCHARGE_IN_DAYS",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getSelfDischargeInDays_inline",
                   "SDK Key for getSelfDischargeInDays: Smart batteries can be setup to automatically discharge over a custom period of time. This method gets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by non-smart batteries and the Osmo series.  @param callback Asynchronous execution result callback that contains the number of days to discharge over.",
            ],
            [
                   "SDK Key for getSelfDischargeInDays: Smart batteries can be setup to automatically discharge over a custom period of time. This method gets the battery's self discharge period in days with range [1, 10]. For Inspire 2 and M200 series products, the max range value can be 20. Not supported by non-smart batteries and the Osmo series.  @param callback Asynchronous execution result callback that contains the number of days to discharge over.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_getSelfDischargeInDays_inline",
                   "",
            ],
            [
                   "WarningRecord",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
            ],
            [
                   "Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "",
            ],
            [
                   "LATEST_WARNING_RECORD",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "SDK Key for WarningRecord: Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
            ],
            [
                   "SDK Key for WarningRecord: Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "",
            ],
            [
                   "HISTORICAL_WARNING_RECORDS",
                   2,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "SDK Key for WarningRecord: Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
            ],
            [
                   "SDK Key for WarningRecord: Used to keep a record of any unusual battery statues in the past 30 discharges. For all the properties below, monitor these values frequently to ensure the battery's state is normal. If any of the properties below indicate there is an issue with the battery, notifying the user is recommended. </br></br> NOTE: No automatic action will be taken if any of the properties below return `true`, which is why it is imperative that the user is notified of the issue.",
                   1,
                   "/Components/Battery/DJIBattery_WarningRecord.html",
                   "",
                   "",
            ],
            [
                   "LowVoltageBehavior",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "Defines aircraft's behavior when the cell voltage is low.",
            ],
            [
                   "Defines aircraft's behavior when the cell voltage is low.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "SDK Key for LowVoltageBehavior: Defines aircraft's behavior when the cell voltage is low.",
            ],
            [
                   "SDK Key for LowVoltageBehavior: Defines aircraft's behavior when the cell voltage is low.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "SDK Key for LowVoltageBehavior: Defines aircraft's behavior when the cell voltage is low.",
            ],
            [
                   "SDK Key for LowVoltageBehavior: Defines aircraft's behavior when the cell voltage is low.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_inline",
                   "",
            ],
            [
                   "PairingState",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_inline",
                   "Battery pairing state for batteries that can be paired.",
            ],
            [
                   "Battery pairing state for batteries that can be paired.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_inline",
                   "",
            ],
            [
                   "BatteryKey.PAIRING_STATE",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_inline",
                   "SDK Key for PairingState: Battery pairing state for batteries that can be paired.",
            ],
            [
                   "SDK Key for PairingState: Battery pairing state for batteries that can be paired.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_inline",
                   "",
            ],
            [
                   "SelfHeatingState",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_inline",
                   "Provides the self-heating state for the battery. When the temperature of the battery is below a threshold, it will warm up automatically. For Mavic 2 Enterprise, the self-heating is triggered when the temperature is lower than 6 Celsius degrees. When the temperature reaches 8 Celsius degrees, the battery will start to preserve the temperature and maintain it between 6 Celsius degrees and 8 Celsius degrees.",
            ],
            [
                   "Provides the self-heating state for the battery. When the temperature of the battery is below a threshold, it will warm up automatically. For Mavic 2 Enterprise, the self-heating is triggered when the temperature is lower than 6 Celsius degrees. When the temperature reaches 8 Celsius degrees, the battery will start to preserve the temperature and maintain it between 6 Celsius degrees and 8 Celsius degrees.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_inline",
                   "",
            ],
            [
                   "IDLE",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Idle_inline",
                   "The auto heating feature is idle.",
            ],
            [
                   "The auto heating feature is idle.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Idle_inline",
                   "",
            ],
            [
                   "WARMING_UP",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_WarmingUp_inline",
                   "The battery is warming itself up automatically.",
            ],
            [
                   "The battery is warming itself up automatically.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_WarmingUp_inline",
                   "",
            ],
            [
                   "PRESERVING",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Preserving_inline",
                   "The battery is preserving its temperature. For Mavic 2 Enterprise, the temperature will be maintained between 6 Celsius degrees and 8 Celsius degrees.",
            ],
            [
                   "The battery is preserving its temperature. For Mavic 2 Enterprise, the temperature will be maintained between 6 Celsius degrees and 8 Celsius degrees.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Preserving_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatterySelfHeatingState_Unknown_inline",
                   "",
            ],
            [
                   "SmartBatteryType",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_inline",
                   "Defines smart battery type.",
            ],
            [
                   "Defines smart battery type.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_inline",
                   "",
            ],
            [
                   "OTHER",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_Other_inline",
                   "The smart battery type is other.",
            ],
            [
                   "The smart battery type is other.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_Other_inline",
                   "",
            ],
            [
                   "MAVIC_MINI_JAPAN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_MavicMiniJapan_inline",
                   "The smart battery type is Mavic Mini Japan, which is legal to use in Japan.",
            ],
            [
                   "The smart battery type is Mavic Mini Japan, which is legal to use in Japan.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_MavicMiniJapan_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_Unknown_inline",
                   "The smart battery type is unknown.",
            ],
            [
                   "The smart battery type is unknown.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJISmartBatteryType_Unknown_inline",
                   "",
            ],
            [
                   "FLASH_LED",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_FlashLEDWarning_inline",
                   "LED lights go into warning mode.",
            ],
            [
                   "LED lights go into warning mode.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_FlashLEDWarning_inline",
                   "",
            ],
            [
                   "GO_HOME",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_GoHome_inline",
                   "Return-to-Home.",
            ],
            [
                   "Return-to-Home.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_GoHome_inline",
                   "",
            ],
            [
                   "LAND",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_Land_inline",
                   "Land aircraft immediately.",
            ],
            [
                   "Land aircraft immediately.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_Land_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryCellVoltageThresholdBehavior_Unknown_inline",
                   "",
            ],
            [
                   "UNPAIRED",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Unpaired_inline",
                   "The batteries didn't match; they're not paired.",
            ],
            [
                   "The batteries didn't match; they're not paired.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Unpaired_inline",
                   "",
            ],
            [
                   "PAIRED",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Paired_inline",
                   "Batteries are paired.",
            ],
            [
                   "Batteries are paired.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Paired_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Unknown_inline",
                   "Can't get the pair state or the batteries.",
            ],
            [
                   "Can't get the pair state or the batteries.",
                   1,
                   "/Components/Battery/DJIBattery.html",
                   "#DJIBattery_DJIBatteryPairStatus_Unknown_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Battery/DJIBattery_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateBatteryState_inline",
                   "Callback to update battery state.  @param batteryState The battery's state.",
            ],
            [
                   "Callback to update battery state.  @param batteryState The battery's state.",
                   1,
                   "/Components/Battery/DJIBattery_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateBatteryState_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateAggregationState_inline",
                   "Callback to update aggregated battery state.  @param aggregationState The aggregated battery state.",
            ],
            [
                   "Callback to update aggregated battery state.  @param aggregationState The aggregated battery state.",
                   1,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateAggregationState_inline",
                   "",
            ],
            [
                   "AGGREGATION_STATE",
                   2,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateAggregationState_inline",
                   "SDK Key for onUpdate: Callback to update aggregated battery state.  @param aggregationState The aggregated battery state.",
            ],
            [
                   "SDK Key for onUpdate: Callback to update aggregated battery state.  @param aggregationState The aggregated battery state.",
                   1,
                   "/Components/Battery/DJIBattery_Aggregation_StateUpdateCallbackInterface.html",
                   "#DJIBattery_UpdateAggregationState_inline",
                   "",
            ],
            [
                   "setUplinkSignalQualityCallback",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setUplinkSignalQualityCallback_inline",
                   "Define a callback to listen for updates on the uplink signal. This link transfers all information from the remote controller to the  aircraft, which is predominantly control information. The callback will be updated when the signal quality changed.  @param callback The `SignalQualityCallback` interface.",
            ],
            [
                   "Define a callback to listen for updates on the uplink signal. This link transfers all information from the remote controller to the  aircraft, which is predominantly control information. The callback will be updated when the signal quality changed.  @param callback The `SignalQualityCallback` interface.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setUplinkSignalQualityCallback_inline",
                   "",
            ],
            [
                   "setDownlinkSignalQualityCallback",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setDownlinkSignalQualityCallback_inline",
                   "Define a callback to listen for updates on the downlink signal. This link transfers all information from aircraft to remote controller,  which is predominantly video information. Signal quality is a function of signal strength, interference and data rate. Signal quality  will be more susceptible to weak signal strengths or high interference when the data rate is high.  @param callback The `SignalQualityCallback` interface.",
            ],
            [
                   "Define a callback to listen for updates on the downlink signal. This link transfers all information from aircraft to remote controller,  which is predominantly video information. Signal quality is a function of signal strength, interference and data rate. Signal quality  will be more susceptible to weak signal strengths or high interference when the data rate is high.  @param callback The `SignalQualityCallback` interface.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setDownlinkSignalQualityCallback_inline",
                   "",
            ],
            [
                   "setCountryCodeCallback",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setCountryCodeCallback_inline",
                   "Sets the Callback for CountryCode update.  @param countryCodeCallback The `CountryCodeCallback` interface.",
            ],
            [
                   "Sets the Callback for CountryCode update.  @param countryCodeCallback The `CountryCodeCallback` interface.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setCountryCodeCallback_inline",
                   "",
            ],
            [
                   "addBaseStationSignalQualityUpdatedCallback",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_addBaseStationSignalQualityUpdatedCallback_inline",
                   "Adds the Callback for base station signal quality update.  @param callback The `BaseStationSignalQualityUpdatedCallback` interface.",
            ],
            [
                   "Adds the Callback for base station signal quality update.  @param callback The `BaseStationSignalQualityUpdatedCallback` interface.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_addBaseStationSignalQualityUpdatedCallback_inline",
                   "",
            ],
            [
                   "removeBaseStationSignalQualityUpdatedCallback",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_removeBaseStationSignalQualityUpdatedCallback_inline",
                   "Removes the Callback for base station signal quality update.  @param callback The `BaseStationSignalQualityUpdatedCallback` interface.",
            ],
            [
                   "Removes the Callback for base station signal quality update.  @param callback The `BaseStationSignalQualityUpdatedCallback` interface.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_removeBaseStationSignalQualityUpdatedCallback_inline",
                   "",
            ],
            [
                   "isLightbridgeLinkSupported",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isLBAirLinkSupported_inline",
                   "`true` if Lightbridge Air Link is supported.  @return A boolean value.",
            ],
            [
                   "`true` if Lightbridge Air Link is supported.  @return A boolean value.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isLBAirLinkSupported_inline",
                   "",
            ],
            [
                   "IS_LIGHTBRIDGE_LINK_SUPPORTED",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isLBAirLinkSupported_inline",
                   "SDK Key for isLightbridgeLinkSupported: `true` if Lightbridge Air Link is supported.  @return A boolean value.",
            ],
            [
                   "SDK Key for isLightbridgeLinkSupported: `true` if Lightbridge Air Link is supported.  @return A boolean value.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isLBAirLinkSupported_inline",
                   "",
            ],
            [
                   "getLightbridgeLink",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_lbAirLink_inline",
                   "Returns the Lightbridge Air Link if it is available.  @return An instance of `LightbridgeLink`.",
            ],
            [
                   "Returns the Lightbridge Air Link if it is available.  @return An instance of `LightbridgeLink`.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_lbAirLink_inline",
                   "",
            ],
            [
                   "isOcuSyncLinkSupported",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isOcuSyncLinkSupported_inline",
                   "`true` if the OcuSync Link is supported. OcuSync Link is only supported by Mavic Pro.  @return A boolean value.",
            ],
            [
                   "`true` if the OcuSync Link is supported. OcuSync Link is only supported by Mavic Pro.  @return A boolean value.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isOcuSyncLinkSupported_inline",
                   "",
            ],
            [
                   "getOcuSyncLink",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_ocuSyncLink_inline",
                   "Returns the OcuSync Link if it is available.  @return An instance of `OcuSyncLink`.",
            ],
            [
                   "Returns the OcuSync Link if it is available.  @return An instance of `OcuSyncLink`.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_ocuSyncLink_inline",
                   "",
            ],
            [
                   "isWiFiLinkSupported",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isWifiLinkSupported_inline",
                   "`true` if WiFi Air Link is supported.  @return A boolean value.",
            ],
            [
                   "`true` if WiFi Air Link is supported.  @return A boolean value.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isWifiLinkSupported_inline",
                   "",
            ],
            [
                   "IS_WIFI_LINK_SUPPORTED",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isWifiLinkSupported_inline",
                   "SDK Key for isWiFiLinkSupported: `true` if WiFi Air Link is supported.  @return A boolean value.",
            ],
            [
                   "SDK Key for isWiFiLinkSupported: `true` if WiFi Air Link is supported.  @return A boolean value.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isWifiLinkSupported_inline",
                   "",
            ],
            [
                   "getWiFiLink",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_wifiLink_inline",
                   "Returns the WiFi Air Link if it is available.  @return An instance of `WiFiLink`.",
            ],
            [
                   "Returns the WiFi Air Link if it is available.  @return An instance of `WiFiLink`.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_wifiLink_inline",
                   "",
            ],
            [
                   "updateCountryCode",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_updateCountryCodeWithCompletion_inline",
                   "Update/Sync the latest CountryCode to the DJI Product.  @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Update/Sync the latest CountryCode to the DJI Product.  @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_updateCountryCodeWithCompletion_inline",
                   "",
            ],
            [
                   "isUpdateCountryCodeRequired",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isUpdateCountryCodeRequired_inline",
                   "Checks if we need to update country code to the DJI Product.  @return `true` if the country code is required to update.",
            ],
            [
                   "Checks if we need to update country code to the DJI Product.  @return `true` if the country code is required to update.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_isUpdateCountryCodeRequired_inline",
                   "",
            ],
            [
                   "setAutoUpdateCountryCodeEnabled",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setAutoUpdateCountryCodeEnabled_inline",
                   "Enable/Disable automatic update CountryCode feature.  @param enabled `true` to enable auto update of the country code.",
            ],
            [
                   "Enable/Disable automatic update CountryCode feature.  @param enabled `true` to enable auto update of the country code.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_setAutoUpdateCountryCodeEnabled_inline",
                   "",
            ],
            [
                   "getAutoUpdateCountryCodeEnabled",
                   2,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_getAutoUpdateCountryCodeEnabled_inline",
                   "Determines if auto update country code is enabled. When it is enabled, SDK will update the country  code to the aircraft automatically when it is required. It is enabled by default and the value is  stored persistently on the device.  @return `true` if auto update country code is enabled.",
            ],
            [
                   "Determines if auto update country code is enabled. When it is enabled, SDK will update the country  code to the aircraft automatically when it is required. It is enabled by default and the value is  stored persistently on the device.  @return `true` if auto update country code is enabled.",
                   1,
                   "/Components/AirLink/DJIAirLink.html",
                   "#DJIAirLink_getAutoUpdateCountryCodeEnabled_inline",
                   "",
            ],
            [
                   "SignalQualityCallback",
                   2,
                   "/Components/AirLink/DJIAirlink_SignalQualityCallbackInterface.html",
                   "",
                   "Updated signal quality in percent for the wireless link. Signal quality is a function of signal strength, interference and data rate. Signal  quality will be more susceptible to weak signal strengths or high  interference when the data rate is high.",
            ],
            [
                   "Updated signal quality in percent for the wireless link. Signal quality is a function of signal strength, interference and data rate. Signal  quality will be more susceptible to weak signal strengths or high  interference when the data rate is high.",
                   1,
                   "/Components/AirLink/DJIAirlink_SignalQualityCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "CountryCodeCallback",
                   2,
                   "/Components/AirLink/DJIAirLink_CountryCodeCallbackInterface.html",
                   "",
                   "Callback for CountryCode related features.",
            ],
            [
                   "Callback for CountryCode related features.",
                   1,
                   "/Components/AirLink/DJIAirLink_CountryCodeCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "BaseStationSignalQualityUpdatedCallback",
                   2,
                   "/Components/AirLink/DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface.html",
                   "",
                   "Callback for updated signal quality in percent for the base station (from remote controller  to the base station). This link transfers all information between the remote controller and  the base station, which is predominantly positioning information.",
            ],
            [
                   "Callback for updated signal quality in percent for the base station (from remote controller  to the base station). This link transfers all information between the remote controller and  the base station, which is predominantly positioning information.",
                   1,
                   "/Components/AirLink/DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "LightbridgeLink",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "",
                   "This class contains methods to change settings of the Lightbridge Air Link.",
            ],
            [
                   "This class contains methods to change settings of the Lightbridge Air Link.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "",
                   "",
            ],
            [
                   "OcuSyncLink",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "",
                   "This class contains methods to change OcuSync link settings.",
            ],
            [
                   "This class contains methods to change OcuSync link settings.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "",
                   "",
            ],
            [
                   "WiFiLink",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "",
                   "This class provides methods to change the setting of the product's WiFi. Rebooting WiFi is required in order to make new settings take effect.",
            ],
            [
                   "This class provides methods to change the setting of the product's WiFi. Rebooting WiFi is required in order to make new settings take effect.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/AirLink/DJIAirlink_SignalQualityCallbackInterface.html",
                   "#DJIAirlink_SignalQualityCallbackUpdate_inline",
                   "Update signal quality.  @param quality The signal quality in percent with range [0, 100], where 100 is the best quality.",
            ],
            [
                   "Update signal quality.  @param quality The signal quality in percent with range [0, 100], where 100 is the best quality.",
                   1,
                   "/Components/AirLink/DJIAirlink_SignalQualityCallbackInterface.html",
                   "#DJIAirlink_SignalQualityCallbackUpdate_inline",
                   "",
            ],
            [
                   "onRequireUpdateCountryCode",
                   2,
                   "/Components/AirLink/DJIAirLink_CountryCodeCallbackInterface.html",
                   "#DJIAirLink_CountryCodeCallbackInterface_onRequireUpdateCountryCode_inline",
                   "Invokes when CountryCode changes and needs to be updated with DJI Product.",
            ],
            [
                   "Invokes when CountryCode changes and needs to be updated with DJI Product.",
                   1,
                   "/Components/AirLink/DJIAirLink_CountryCodeCallbackInterface.html",
                   "#DJIAirLink_CountryCodeCallbackInterface_onRequireUpdateCountryCode_inline",
                   "",
            ],
            [
                   "onBaseStationSignalQualityUpdated",
                   2,
                   "/Components/AirLink/DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface.html",
                   "#DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface_onBaseStationSignalQualityUpdated_inline",
                   "Invokes when base station signal quality changes.  @param quality An int value of the signal quality.",
            ],
            [
                   "Invokes when base station signal quality changes.  @param quality An int value of the signal quality.",
                   1,
                   "/Components/AirLink/DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface.html",
                   "#DJIAirLink_BaseStationSignalQualityUpdatedCallbackInterface_onBaseStationSignalQualityUpdated_inline",
                   "",
            ],
            [
                   "setMagneticInterferenceCallback",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDJIWiFiSignalQualityChangedCallback_inline",
                   "Sets up the callback for WiFi magnetic interference level.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets up the callback for WiFi magnetic interference level.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDJIWiFiSignalQualityChangedCallback_inline",
                   "",
            ],
            [
                   "setChannelInterferenceCallback",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setRSSICallback_inline",
                   "Setter for RSSI callback  @param channelInterferenceCallback your implementation of `ChannelInterferenceCallback`.",
            ],
            [
                   "Setter for RSSI callback  @param channelInterferenceCallback your implementation of `ChannelInterferenceCallback`.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setRSSICallback_inline",
                   "",
            ],
            [
                   "CHANNEL_INTERFERENCE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setRSSICallback_inline",
                   "SDK Key for setChannelInterferenceCallback: Setter for RSSI callback  @param channelInterferenceCallback your implementation of `ChannelInterferenceCallback`.",
            ],
            [
                   "SDK Key for setChannelInterferenceCallback: Setter for RSSI callback  @param channelInterferenceCallback your implementation of `ChannelInterferenceCallback`.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setRSSICallback_inline",
                   "",
            ],
            [
                   "reboot",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_rebootWiFi_inline",
                   "Reboot WiFi to enable new settings to take effect.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Reboot WiFi to enable new settings to take effect.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_rebootWiFi_inline",
                   "",
            ],
            [
                   "REBOOT",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_rebootWiFi_inline",
                   "SDK Key for reboot: Reboot WiFi to enable new settings to take effect.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for reboot: Reboot WiFi to enable new settings to take effect.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_rebootWiFi_inline",
                   "",
            ],
            [
                   "setSSID",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiSSID_inline",
                   "Sets the WiFi SSID. The setting will take effect only after the product reboots.  @param ssid The WiFi SSID to change. It should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback Remote execution result error callback.",
            ],
            [
                   "Sets the WiFi SSID. The setting will take effect only after the product reboots.  @param ssid The WiFi SSID to change. It should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback Remote execution result error callback.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiSSID_inline",
                   "",
            ],
            [
                   "SSID",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiSSID_inline",
                   "SDK Key for setSSID: Sets the WiFi SSID. The setting will take effect only after the product reboots.  @param ssid The WiFi SSID to change. It should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback Remote execution result error callback.",
            ],
            [
                   "SDK Key for setSSID: Sets the WiFi SSID. The setting will take effect only after the product reboots.  @param ssid The WiFi SSID to change. It should only include alphabetic characters, numbers, spaces, '-' and should not be  more than 30 characters. @param callback Remote execution result error callback.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiSSID_inline",
                   "",
            ],
            [
                   "getSSID",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiSSID_inline",
                   "Gets the WiFi SSID.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the WiFi SSID.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiSSID_inline",
                   "",
            ],
            [
                   "SSID",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiSSID_inline",
                   "SDK Key for getSSID: Gets the WiFi SSID.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getSSID: Gets the WiFi SSID.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiSSID_inline",
                   "",
            ],
            [
                   "setPassword",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiPassword_inline",
                   "Sets the WiFi Password.  @param password The new WiFi password. It must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback Remote execution result error callback.",
            ],
            [
                   "Sets the WiFi Password.  @param password The new WiFi password. It must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback Remote execution result error callback.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiPassword_inline",
                   "",
            ],
            [
                   "AirLinkKey.PASSWORD",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiPassword_inline",
                   "SDK Key for setPassword: Sets the WiFi Password.  @param password The new WiFi password. It must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback Remote execution result error callback.",
            ],
            [
                   "SDK Key for setPassword: Sets the WiFi Password.  @param password The new WiFi password. It must be at least 8 characters and can only includes alphabetic characters and numbers. @param callback Remote execution result error callback.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiPassword_inline",
                   "",
            ],
            [
                   "getPassword",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiPassword_inline",
                   "Get the WiFi Password.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Get the WiFi Password.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiPassword_inline",
                   "",
            ],
            [
                   "AirLinkKey.PASSWORD",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiPassword_inline",
                   "SDK Key for getPassword: Get the WiFi Password.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getPassword: Get the WiFi Password.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiPassword_inline",
                   "",
            ],
            [
                   "setFrequencyBand",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiFrequencyBand_inline",
                   "It is not supported by Spark, Mavic Air and DJI Mini 2. For these products, set different channel  numbers to select the frequency band.  @param frequencyBand WiFi frequency band to change to. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "It is not supported by Spark, Mavic Air and DJI Mini 2. For these products, set different channel  numbers to select the frequency band.  @param frequencyBand WiFi frequency band to change to. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "WIFI_FREQUENCY_BAND",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiFrequencyBand_inline",
                   "SDK Key for setFrequencyBand: It is not supported by Spark, Mavic Air and DJI Mini 2. For these products, set different channel  numbers to select the frequency band.  @param frequencyBand WiFi frequency band to change to. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setFrequencyBand: It is not supported by Spark, Mavic Air and DJI Mini 2. For these products, set different channel  numbers to select the frequency band.  @param frequencyBand WiFi frequency band to change to. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "getFrequencyBand",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiFrequencyBand_inline",
                   "Gets the current WiFi frequency band. It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the current WiFi frequency band. It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "WIFI_FREQUENCY_BAND",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiFrequencyBand_inline",
                   "SDK Key for getFrequencyBand: Gets the current WiFi frequency band. It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getFrequencyBand: Gets the current WiFi frequency band. It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "setSelectionMode",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setChannelSelectionMode_inline",
                   "Sets the channel selection mode. Both channel number and bandwidth can be changed.  If the 5 GHz band is available,  then channels from that band can also be used. .  @param mode Selection mode to set. @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Sets the channel selection mode. Both channel number and bandwidth can be changed.  If the 5 GHz band is available,  then channels from that band can also be used. .  @param mode Selection mode to set. @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setChannelSelectionMode_inline",
                   "",
            ],
            [
                   "getSelectionMode",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getChannelSelectionMode_inline",
                   "Gets the channel selection mode. .  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the channel selection mode. .  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getChannelSelectionMode_inline",
                   "",
            ],
            [
                   "setChannelNumber",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiChannel_inline",
                   "Sets the WiFi channel. `setChannelNumber`  must be used to determine which channels are possible to set. When a new channel is set,  the WiFi on the product will reboot. The channel can only be changed when the product is not flying. Supported by Mavic Pro, Mavic Mini, DJI Mini SE.  @param channelNumber Index of the channel to select. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the WiFi channel. `setChannelNumber`  must be used to determine which channels are possible to set. When a new channel is set,  the WiFi on the product will reboot. The channel can only be changed when the product is not flying. Supported by Mavic Pro, Mavic Mini, DJI Mini SE.  @param channelNumber Index of the channel to select. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiChannel_inline",
                   "",
            ],
            [
                   "CHANNEL_NUMBER",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiChannel_inline",
                   "SDK Key for setChannelNumber: Sets the WiFi channel. `setChannelNumber`  must be used to determine which channels are possible to set. When a new channel is set,  the WiFi on the product will reboot. The channel can only be changed when the product is not flying. Supported by Mavic Pro, Mavic Mini, DJI Mini SE.  @param channelNumber Index of the channel to select. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setChannelNumber: Sets the WiFi channel. `setChannelNumber`  must be used to determine which channels are possible to set. When a new channel is set,  the WiFi on the product will reboot. The channel can only be changed when the product is not flying. Supported by Mavic Pro, Mavic Mini, DJI Mini SE.  @param channelNumber Index of the channel to select. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setWiFiChannel_inline",
                   "",
            ],
            [
                   "getChannelNumber",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiChannel_inline",
                   "Gets the WiFi channel. Channels 1-13 are in the 2.4 GHz band. Other channels are in the 5 GHz band.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the WiFi channel. Channels 1-13 are in the 2.4 GHz band. Other channels are in the 5 GHz band.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiChannel_inline",
                   "",
            ],
            [
                   "CHANNEL_NUMBER",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiChannel_inline",
                   "SDK Key for getChannelNumber: Gets the WiFi channel. Channels 1-13 are in the 2.4 GHz band. Other channels are in the 5 GHz band.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getChannelNumber: Gets the WiFi channel. Channels 1-13 are in the 2.4 GHz band. Other channels are in the 5 GHz band.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getWiFiChannel_inline",
                   "",
            ],
            [
                   "getAvailableChannelNumbers",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getAvailableChannels_inline",
                   "Gets the channels available for the current frequency band. When `FREQUENCY_BAND_DUAL` is  selected, channels for both 2.4GHz and 5GHz are available. Supported only by Mavic Pro, Mavic Mini, DJI Mini SE.  @param callback The completion block with the returned execution result.",
            ],
            [
                   "Gets the channels available for the current frequency band. When `FREQUENCY_BAND_DUAL` is  selected, channels for both 2.4GHz and 5GHz are available. Supported only by Mavic Pro, Mavic Mini, DJI Mini SE.  @param callback The completion block with the returned execution result.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getAvailableChannels_inline",
                   "",
            ],
            [
                   "AVAILABLE_CHANNEL_NUMBERS",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getAvailableChannels_inline",
                   "SDK Key for getAvailableChannelNumbers: Gets the channels available for the current frequency band. When `FREQUENCY_BAND_DUAL` is  selected, channels for both 2.4GHz and 5GHz are available. Supported only by Mavic Pro, Mavic Mini, DJI Mini SE.  @param callback The completion block with the returned execution result.",
            ],
            [
                   "SDK Key for getAvailableChannelNumbers: Gets the channels available for the current frequency band. When `FREQUENCY_BAND_DUAL` is  selected, channels for both 2.4GHz and 5GHz are available. Supported only by Mavic Pro, Mavic Mini, DJI Mini SE.  @param callback The completion block with the returned execution result.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getAvailableChannels_inline",
                   "",
            ],
            [
                   "setDataRate",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDataRate_inline",
                   "Sets the WiFi data rate (throughput). Higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. It is not supported by Spark or Mavic Air.  @param rate Data rate (throughput). @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the WiFi data rate (throughput). Higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. It is not supported by Spark or Mavic Air.  @param rate Data rate (throughput). @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDataRate_inline",
                   "",
            ],
            [
                   "DATA_RATE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDataRate_inline",
                   "SDK Key for setDataRate: Sets the WiFi data rate (throughput). Higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. It is not supported by Spark or Mavic Air.  @param rate Data rate (throughput). @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setDataRate: Sets the WiFi data rate (throughput). Higher data rates increase the quality of video transmission, but can only be  used at shorter ranges. It is not supported by Spark or Mavic Air.  @param rate Data rate (throughput). @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_setDataRate_inline",
                   "",
            ],
            [
                   "getDataRate",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getDataRate_inline",
                   "Gets the current data rate (throughput). It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the current data rate (throughput). It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getDataRate_inline",
                   "",
            ],
            [
                   "DATA_RATE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getDataRate_inline",
                   "SDK Key for getDataRate: Gets the current data rate (throughput). It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getDataRate: Gets the current data rate (throughput). It is not supported by Spark or Mavic Air.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_getDataRate_inline",
                   "",
            ],
            [
                   "MagneticInterferenceCallback",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiSignalQualityChangedCallbackInterface.html",
                   "",
                   "This interface provides a method to receive the updated WiFi signal quality.",
            ],
            [
                   "This interface provides a method to receive the updated WiFi signal quality.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiSignalQualityChangedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "ChannelInterferenceCallback",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_RSSICallbackInterface.html",
                   "",
                   "Callback to listen to any changes in interference levels for channels that are not being used for communication.",
            ],
            [
                   "Callback to listen to any changes in interference levels for channels that are not being used for communication.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_RSSICallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "WiFiFrequencyBand",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_inline",
                   "WiFi frequency band.",
            ],
            [
                   "WiFi frequency band.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "WIFI_FREQUENCY_BAND",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_inline",
                   "SDK Key for WiFiFrequencyBand: WiFi frequency band.",
            ],
            [
                   "SDK Key for WiFiFrequencyBand: WiFi frequency band.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_inline",
                   "",
            ],
            [
                   "WifiChannelInterference",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "",
                   "The interference power of a WiFi channel.",
            ],
            [
                   "The interference power of a WiFi channel.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "",
                   "",
            ],
            [
                   "CHANNEL_INTERFERENCE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "",
                   "SDK Key for WifiChannelInterference: The interference power of a WiFi channel.",
            ],
            [
                   "SDK Key for WifiChannelInterference: The interference power of a WiFi channel.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "",
                   "",
            ],
            [
                   "FREQUENCY_BAND_ONLY_2_DOT_4",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_2Dot4G_inline",
                   "The WiFi Frequency band is 2.4 GHz.",
            ],
            [
                   "The WiFi Frequency band is 2.4 GHz.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_2Dot4G_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_5_GHZ",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_5G_inline",
                   "The WiFi Frequency band is 5 GHz.",
            ],
            [
                   "The WiFi Frequency band is 5 GHz.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_5G_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_DUAL",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_DualBand_inline",
                   "Dual frequency band mode. The WiFi frequency band can be either 2.4 GHz or 5 GHz.",
            ],
            [
                   "Dual frequency band mode. The WiFi frequency band can be either 2.4 GHz or 5 GHz.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_DualBand_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_Unknown_inline",
                   "The WiFi Frequency is unknown.",
            ],
            [
                   "The WiFi Frequency is unknown.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiFrequencyBand_Unknown_inline",
                   "",
            ],
            [
                   "WiFiMagneticInterferenceLevel",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_inline",
                   "WiFi magnetic interference - as measured by Osmo, Phantom 3 4K and Phantom 3 Standard.",
            ],
            [
                   "WiFi magnetic interference - as measured by Osmo, Phantom 3 4K and Phantom 3 Standard.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_inline",
                   "",
            ],
            [
                   "MAGNETIC_INTERFERENCE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_inline",
                   "SDK Key for WiFiMagneticInterferenceLevel: WiFi magnetic interference - as measured by Osmo, Phantom 3 4K and Phantom 3 Standard.",
            ],
            [
                   "SDK Key for WiFiMagneticInterferenceLevel: WiFi magnetic interference - as measured by Osmo, Phantom 3 4K and Phantom 3 Standard.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_inline",
                   "",
            ],
            [
                   "LOW",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Good_inline",
                   "WiFi magnetic interference is low.",
            ],
            [
                   "WiFi magnetic interference is low.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Good_inline",
                   "",
            ],
            [
                   "MEDIUM",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Medium_inline",
                   "WiFi magnetic interference is medium. At this level, the video quality will be degraded compared to when the signal quality is low.",
            ],
            [
                   "WiFi magnetic interference is medium. At this level, the video quality will be degraded compared to when the signal quality is low.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Medium_inline",
                   "",
            ],
            [
                   "HIGH",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Bad_inline",
                   "WiFi magnetic interference is high. At this level, the video quality will be degraded compared to when the signal quality is medium.",
            ],
            [
                   "WiFi magnetic interference is high. At this level, the video quality will be degraded compared to when the signal quality is medium.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Bad_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Unknown_inline",
                   "WiFi magnetic interference is Unknown.",
            ],
            [
                   "WiFi magnetic interference is Unknown.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Unknown_inline",
                   "",
            ],
            [
                   "DATA_RATE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Unknown_inline",
                   "SDK Key for UNKNOWN: WiFi magnetic interference is Unknown.",
            ],
            [
                   "SDK Key for UNKNOWN: WiFi magnetic interference is Unknown.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiSignalQuality_Unknown_inline",
                   "",
            ],
            [
                   "WifiDataRate",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_inline",
                   "WiFi data rate. Lower rates are used for longer ranges, but will have lower video quality.",
            ],
            [
                   "WiFi data rate. Lower rates are used for longer ranges, but will have lower video quality.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_inline",
                   "",
            ],
            [
                   "DATA_RATE",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_inline",
                   "SDK Key for WifiDataRate: WiFi data rate. Lower rates are used for longer ranges, but will have lower video quality.",
            ],
            [
                   "SDK Key for WifiDataRate: WiFi data rate. Lower rates are used for longer ranges, but will have lower video quality.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_inline",
                   "",
            ],
            [
                   "RATE_1_MBPS",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_1Mbps_inline",
                   "1 Mbps.",
            ],
            [
                   "1 Mbps.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_1Mbps_inline",
                   "",
            ],
            [
                   "RATE_2_MBPS",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_2Mbps_inline",
                   "2 Mbps.",
            ],
            [
                   "2 Mbps.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_2Mbps_inline",
                   "",
            ],
            [
                   "RATE_4_MBPS",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_4Mbps_inline",
                   "4 Mbps.",
            ],
            [
                   "4 Mbps.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_4Mbps_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink.html",
                   "#DJIWiFiLink_DJIWiFiDataRate_Unknown_inline",
                   "",
            ],
            [
                   "getPower",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_power_inline",
                   "The interference power with range from [-60, -100] dBm. A smaller, more negative value represents less interference and better communication quality.  @return An int value of the interference power.",
            ],
            [
                   "The interference power with range from [-60, -100] dBm. A smaller, more negative value represents less interference and better communication quality.  @return An int value of the interference power.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_power_inline",
                   "",
            ],
            [
                   "getChannel",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_channel_inline",
                   "The channel index.  @return An int value of the channel index.",
            ],
            [
                   "The channel index.  @return An int value of the channel index.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_channel_inline",
                   "",
            ],
            [
                   "getBand",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_band_inline",
                   "The frequency band that the channel belongs to.  @return A value of `WiFiFrequencyBand` Enum.",
            ],
            [
                   "The frequency band that the channel belongs to.  @return A value of `WiFiFrequencyBand` Enum.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiChannelInterference.html",
                   "#DJIWiFiLink_DJIWiFiChannelInterference_band_inline",
                   "",
            ],
            [
                   "onResult",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiSignalQualityChangedCallbackInterface.html",
                   "#DJIWiFiLink_didUpdateWiFiSignalQuality_inline",
                   "Updates the WiFi Signal Quality.  @param level The WiFi magnetic interference level.",
            ],
            [
                   "Updates the WiFi Signal Quality.  @param level The WiFi magnetic interference level.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_DJIWiFiSignalQualityChangedCallbackInterface.html",
                   "#DJIWiFiLink_didUpdateWiFiSignalQuality_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/WiFiLink/DJIWiFiLink_RSSICallbackInterface.html",
                   "#DJIWiFiLink_didUpdateChannelInterferencePowers_inline",
                   "This will be invoked when there is a change in RSSI. Interference power of the available channels.  @param channelInterferences An array of all the current RSSIs.",
            ],
            [
                   "This will be invoked when there is a change in RSSI. Interference power of the available channels.  @param channelInterferences An array of all the current RSSIs.",
                   1,
                   "/Components/WiFiLink/DJIWiFiLink_RSSICallbackInterface.html",
                   "#DJIWiFiLink_didUpdateChannelInterferencePowers_inline",
                   "",
            ],
            [
                   "setVideoDataRateCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setVideoDataRateUpdatedCallback_inline",
                   "Sets the callback for VideoDataRateUpdatedCallback.  @param videoDataRateCallback An interface of `VideoDataRateCallback`.",
            ],
            [
                   "Sets the callback for VideoDataRateUpdatedCallback.  @param videoDataRateCallback An interface of `VideoDataRateCallback`.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setVideoDataRateUpdatedCallback_inline",
                   "",
            ],
            [
                   "setWarningMessagesCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setReceivedWarningMessageCallback_inline",
                   "Sets the callback for ReceivedWarningMessageCallback.  @param warningMessagesCallback Your implementation of `WarningMessagesCallback`.",
            ],
            [
                   "Sets the callback for ReceivedWarningMessageCallback.  @param warningMessagesCallback Your implementation of `WarningMessagesCallback`.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setReceivedWarningMessageCallback_inline",
                   "",
            ],
            [
                   "setChannelInterferenceCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setFrequencyInterferenceUpdatedCallback_inline",
                   "Sets the FrequencyInterferenceUpdatedCallback.  @param callback Your implementation of `ChannelInterferenceCallback`.",
            ],
            [
                   "Sets the FrequencyInterferenceUpdatedCallback.  @param callback Your implementation of `ChannelInterferenceCallback`.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setFrequencyInterferenceUpdatedCallback_inline",
                   "",
            ],
            [
                   "setChannelSelectionMode",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelSelectionMode_inline",
                   "Sets the channel selection mode. Both channel number and bandwidth can be changed. If the 5 GHz band is available,  then channels from that band can also be used.  @param mode Selection mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the channel selection mode. Both channel number and bandwidth can be changed. If the 5 GHz band is available,  then channels from that band can also be used.  @param mode Selection mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelSelectionMode_inline",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelSelectionMode_inline",
                   "SDK Key for setChannelSelectionMode: Sets the channel selection mode. Both channel number and bandwidth can be changed. If the 5 GHz band is available,  then channels from that band can also be used.  @param mode Selection mode to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setChannelSelectionMode: Sets the channel selection mode. Both channel number and bandwidth can be changed. If the 5 GHz band is available,  then channels from that band can also be used.  @param mode Selection mode to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelSelectionMode_inline",
                   "",
            ],
            [
                   "getChannelSelectionMode",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelSelectionMode_inline",
                   "Gets the channel selection mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the channel selection mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelSelectionMode_inline",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelSelectionMode_inline",
                   "SDK Key for getChannelSelectionMode: Gets the channel selection mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getChannelSelectionMode: Gets the channel selection mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelSelectionMode_inline",
                   "",
            ],
            [
                   "setOcuSyncMagneticInterferenceLevelCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setOcuSyncMagneticInterferenceLevelCallback_inline",
                   "Set the callback of `Callback`.  @param callback Your implementation of `Callback`.",
            ],
            [
                   "Set the callback of `Callback`.  @param callback Your implementation of `Callback`.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setOcuSyncMagneticInterferenceLevelCallback_inline",
                   "",
            ],
            [
                   "setChannelBandwidth",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelBandwidth_inline",
                   "Sets the channel bandwidth of the OcuSync link. It can be set only when the selection mode is  `MANUAL`. For Mavic Air 2, DJI Air 2S, only supported bandwidth with 20MB.  @param bandwidth Bandwidth to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "Sets the channel bandwidth of the OcuSync link. It can be set only when the selection mode is  `MANUAL`. For Mavic Air 2, DJI Air 2S, only supported bandwidth with 20MB.  @param bandwidth Bandwidth to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelBandwidth_inline",
                   "",
            ],
            [
                   "BANDWIDTH",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelBandwidth_inline",
                   "SDK Key for setChannelBandwidth: Sets the channel bandwidth of the OcuSync link. It can be set only when the selection mode is  `MANUAL`. For Mavic Air 2, DJI Air 2S, only supported bandwidth with 20MB.  @param bandwidth Bandwidth to set. @param callback The execution callback with the returned execution result.",
            ],
            [
                   "SDK Key for setChannelBandwidth: Sets the channel bandwidth of the OcuSync link. It can be set only when the selection mode is  `MANUAL`. For Mavic Air 2, DJI Air 2S, only supported bandwidth with 20MB.  @param bandwidth Bandwidth to set. @param callback The execution callback with the returned execution result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelBandwidth_inline",
                   "",
            ],
            [
                   "getChannelBandwidth",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelBandwidth_inline",
                   "Gets the channel bandwidth of the OcuSync link.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the channel bandwidth of the OcuSync link.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelBandwidth_inline",
                   "",
            ],
            [
                   "BANDWIDTH",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelBandwidth_inline",
                   "SDK Key for getChannelBandwidth: Gets the channel bandwidth of the OcuSync link.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getChannelBandwidth: Gets the channel bandwidth of the OcuSync link.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelBandwidth_inline",
                   "",
            ],
            [
                   "setChannelNumber",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelNumber_inline",
                   "Selects the channel number. The OcuSync link operates on a  10 MHz or 20 MHz channel between 2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the  band. Therefore for a 10 MHz bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1  MHz to 2477.5 MHz. For a 20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The  channel location within the band is specified using the Channel Number. Channel Number is defined as the integer  of 0.5 MHz less than the channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered  at 2406.5 MHz (this is only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel  Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  Use `getChannelNumberValidRange` to check the valid Channel Numbers for a given bandwidth. Channel  Number can only be set when the channel selection mode is `MANUAL`.  @param channelNumber Channel number to set OcuSync channel to. @param callback Callback that receives the setter result.",
            ],
            [
                   "Selects the channel number. The OcuSync link operates on a  10 MHz or 20 MHz channel between 2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the  band. Therefore for a 10 MHz bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1  MHz to 2477.5 MHz. For a 20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The  channel location within the band is specified using the Channel Number. Channel Number is defined as the integer  of 0.5 MHz less than the channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered  at 2406.5 MHz (this is only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel  Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  Use `getChannelNumberValidRange` to check the valid Channel Numbers for a given bandwidth. Channel  Number can only be set when the channel selection mode is `MANUAL`.  @param channelNumber Channel number to set OcuSync channel to. @param callback Callback that receives the setter result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelNumber_inline",
                   "",
            ],
            [
                   "FREQUENCY_POINT_INDEX",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelNumber_inline",
                   "SDK Key for setChannelNumber: Selects the channel number. The OcuSync link operates on a  10 MHz or 20 MHz channel between 2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the  band. Therefore for a 10 MHz bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1  MHz to 2477.5 MHz. For a 20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The  channel location within the band is specified using the Channel Number. Channel Number is defined as the integer  of 0.5 MHz less than the channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered  at 2406.5 MHz (this is only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel  Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  Use `getChannelNumberValidRange` to check the valid Channel Numbers for a given bandwidth. Channel  Number can only be set when the channel selection mode is `MANUAL`.  @param channelNumber Channel number to set OcuSync channel to. @param callback Callback that receives the setter result.",
            ],
            [
                   "SDK Key for setChannelNumber: Selects the channel number. The OcuSync link operates on a  10 MHz or 20 MHz channel between 2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the  band. Therefore for a 10 MHz bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1  MHz to 2477.5 MHz. For a 20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The  channel location within the band is specified using the Channel Number. Channel Number is defined as the integer  of 0.5 MHz less than the channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered  at 2406.5 MHz (this is only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel  Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  Use `getChannelNumberValidRange` to check the valid Channel Numbers for a given bandwidth. Channel  Number can only be set when the channel selection mode is `MANUAL`.  @param channelNumber Channel number to set OcuSync channel to. @param callback Callback that receives the setter result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setChannelNumber_inline",
                   "",
            ],
            [
                   "getChannelNumber",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumber_inline",
                   "Gets the current OcuSync Link Channel Number. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  @param callback Completion block that receives the getter result.",
            ],
            [
                   "Gets the current OcuSync Link Channel Number. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  @param callback Completion block that receives the getter result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumber_inline",
                   "",
            ],
            [
                   "FREQUENCY_POINT_INDEX",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumber_inline",
                   "SDK Key for getChannelNumber: Gets the current OcuSync Link Channel Number. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  @param callback Completion block that receives the getter result.",
            ],
            [
                   "SDK Key for getChannelNumber: Gets the current OcuSync Link Channel Number. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth).  @param callback Completion block that receives the getter result.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumber_inline",
                   "",
            ],
            [
                   "getChannelNumberValidRange",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumberValidRange_inline",
                   "Gets the valid range of Channel Numbers. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth). This method should be used to confirm the Channel Number  to be set with `setChannelNumber` is valid.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "Gets the valid range of Channel Numbers. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth). This method should be used to confirm the Channel Number  to be set with `setChannelNumber` is valid.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumberValidRange_inline",
                   "",
            ],
            [
                   "FREQUENCY_POINT_INDEX_VALID_RANGE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumberValidRange_inline",
                   "SDK Key for getChannelNumberValidRange: Gets the valid range of Channel Numbers. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth). This method should be used to confirm the Channel Number  to be set with `setChannelNumber` is valid.  @param callback The execution callback with the returned value(s).",
            ],
            [
                   "SDK Key for getChannelNumberValidRange: Gets the valid range of Channel Numbers. The OcuSync link operates on a 10 MHz or 20 MHz channel between  2400.5 MHz and 2482.5 MHz. The channel can be centered at 1 MHz steps within the band. Therefore for a 10 MHz  bandwidth, the OcuSync channel can be centered at 2405.5 MHz, 2406.5 MHz and every 1 MHz to 2477.5 MHz. For a  20 MHz bandwidth, channel center can be at 2410.5 MHz to 2472.5 MHz in 1 MHz steps. The channel location within  the band is specified using the Channel Number. Channel Number is defined as the integer of 0.5 MHz less than the  channel center frequency. E.g. Channel Number 2406 represents the 10 MHz channel centered at 2406.5 MHz (this is  only for the 10 MHz bandwidth as 20 MHz bandwidth channels start at 2410.5 MHz). Channel Number 2450 represents the channel centered at 2450.5 MHz (of any bandwidth). This method should be used to confirm the Channel Number  to be set with `setChannelNumber` is valid.  @param callback The execution callback with the returned value(s).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getChannelNumberValidRange_inline",
                   "",
            ],
            [
                   "getSupportedFrequencyBands",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getSupportedFrequencyBandsWithCompletion_inline",
                   "Gets the frequency bands supported by the product in the current area. It is supported by P4P V2 and Mavic 2 Series. For  Mavic Pro, only 2.4GHz is supported.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the frequency bands supported by the product in the current area. It is supported by P4P V2 and Mavic 2 Series. For  Mavic Pro, only 2.4GHz is supported.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getSupportedFrequencyBandsWithCompletion_inline",
                   "",
            ],
            [
                   "OCUSYNC_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getSupportedFrequencyBandsWithCompletion_inline",
                   "SDK Key for getSupportedFrequencyBands: Gets the frequency bands supported by the product in the current area. It is supported by P4P V2 and Mavic 2 Series. For  Mavic Pro, only 2.4GHz is supported.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getSupportedFrequencyBands: Gets the frequency bands supported by the product in the current area. It is supported by P4P V2 and Mavic 2 Series. For  Mavic Pro, only 2.4GHz is supported.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getSupportedFrequencyBandsWithCompletion_inline",
                   "",
            ],
            [
                   "setFrequencyBand",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setFrequencyBand_inline",
                   "Sets the OcuSync air link frequency band. It is only supported by Phantom 4 Pro V2 and Mavic 2 Series. For Mavic Pro,  the frequency band is always 2.4 GHz. Not supported by Mavic Air 2.  @param frequencyBand Frequency band to change to. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the OcuSync air link frequency band. It is only supported by Phantom 4 Pro V2 and Mavic 2 Series. For Mavic Pro,  the frequency band is always 2.4 GHz. Not supported by Mavic Air 2.  @param frequencyBand Frequency band to change to. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setFrequencyBand_inline",
                   "",
            ],
            [
                   "getFrequencyBand",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getFrequencyBandWithCompletion_inline",
                   "Gets the OcuSync air link frequency band. It is only supported by Phantom 4 Pro V2 and Mavic 2 Series. For Mavic Pro, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the OcuSync air link frequency band. It is only supported by Phantom 4 Pro V2 and Mavic 2 Series. For Mavic Pro, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getFrequencyBandWithCompletion_inline",
                   "",
            ],
            [
                   "setBandwidthAllocationForPrimaryVideo",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setBandwidthAllocationForPrimaryVideo_inline",
                   "Sets the percentage of the primary video bandwidth. The remaining percentage is dedicated to the secondary video. The primary source can only be `LEFT_CAM` or `RIGHT_CAM`.  The secondary source can be `LEFT_CAM`, `RIGHT_CAM`  and `FPV_CAM`. It is only supported by M200 series v2.  @param percent Percentage downlink bandwidth for the primary video feed. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the percentage of the primary video bandwidth. The remaining percentage is dedicated to the secondary video. The primary source can only be `LEFT_CAM` or `RIGHT_CAM`.  The secondary source can be `LEFT_CAM`, `RIGHT_CAM`  and `FPV_CAM`. It is only supported by M200 series v2.  @param percent Percentage downlink bandwidth for the primary video feed. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_setBandwidthAllocationForPrimaryVideo_inline",
                   "",
            ],
            [
                   "getBandwidthAllocationForPrimaryVideo",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getBandwidthAllocationForPrimaryVideo_inline",
                   "When a product has multiple main cameras, this method gets the percentage bandwidth allocation dedicated to the primary video. The remaining percentage is dedicated  to the secondary video. It is only supported by M200 series v2.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "When a product has multiple main cameras, this method gets the percentage bandwidth allocation dedicated to the primary video. The remaining percentage is dedicated  to the secondary video. It is only supported by M200 series v2.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_getBandwidthAllocationForPrimaryVideo_inline",
                   "",
            ],
            [
                   "assignSourceToPrimaryChannel",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_assignSourceToPrimaryChannel_inline",
                   "Assign the primary video and the secondary video source. It can be supported by M200 series V2 and Matrice 300 RTK. On M200 series v2, the primary source only can  be `LEFT_CAM` or `FPV_CAM`. The secondary  source can be `LEFT_CAM`, `RIGHT_CAM`  and `FPV_CAM`. On Matrice 300 RTK, both primary and secondary sources can  be `LEFT_CAM`, `RIGHT_CAM`, `TOP_CAM`  and `FPV_CAM`, if you just want to use one video source , you should set the secondary souce with `UNKNOWN`.  @param primarySource The primary video source. @param secondarySource The secondary video source. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Assign the primary video and the secondary video source. It can be supported by M200 series V2 and Matrice 300 RTK. On M200 series v2, the primary source only can  be `LEFT_CAM` or `FPV_CAM`. The secondary  source can be `LEFT_CAM`, `RIGHT_CAM`  and `FPV_CAM`. On Matrice 300 RTK, both primary and secondary sources can  be `LEFT_CAM`, `RIGHT_CAM`, `TOP_CAM`  and `FPV_CAM`, if you just want to use one video source , you should set the secondary souce with `UNKNOWN`.  @param primarySource The primary video source. @param secondarySource The secondary video source. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_assignSourceToPrimaryChannel_inline",
                   "",
            ],
            [
                   "closeAllVideoSources",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_closeAllVideoSources_inline",
                   "Stops all video streaming if there is any active source. It is only supported by Matrice 300 RTK.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Stops all video streaming if there is any active source. It is only supported by Matrice 300 RTK.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_closeAllVideoSources_inline",
                   "",
            ],
            [
                   "VideoDataRateCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_VideoDataRateUpdatedCallbackInterface.html",
                   "",
                   "Updated data rate in Mbps for the wireless downlink (from aircraft to remote controller). This link transfers all information from aircraft to remote controller, which is predominantly video information.",
            ],
            [
                   "Updated data rate in Mbps for the wireless downlink (from aircraft to remote controller). This link transfers all information from aircraft to remote controller, which is predominantly video information.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_VideoDataRateUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "WarningMessagesCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_ReceivedWarningMessageCallbackInterface.html",
                   "",
                   "Updated OcuSync link warning messages. This delegate method is called only when there are new warning messages on  the OcuSync link (either uplink or downlink). If the array has no elements, then all previous warning messages are  no longer in effect.",
            ],
            [
                   "Updated OcuSync link warning messages. This delegate method is called only when there are new warning messages on  the OcuSync link (either uplink or downlink). If the array has no elements, then all previous warning messages are  no longer in effect.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_ReceivedWarningMessageCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "ChannelInterferenceCallback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_FrequencyInterferenceUpdatedCallbackInterface.html",
                   "",
                   "Updated power for interference signals with frequencies in the 2.4 GHz (2400MHz to 2482 MHz) frequency band incident  on the remote controller. Note, measuring the interference reduces effective data rate as the radio is spending time listening to frequencies outside of the communication channel. Interference measurements will only be made if  the `setChannelInterferenceCallback` property in OcuSyncLink is assigned to a method that  implements this callback.",
            ],
            [
                   "Updated power for interference signals with frequencies in the 2.4 GHz (2400MHz to 2482 MHz) frequency band incident  on the remote controller. Note, measuring the interference reduces effective data rate as the radio is spending time listening to frequencies outside of the communication channel. Interference measurements will only be made if  the `setChannelInterferenceCallback` property in OcuSyncLink is assigned to a method that  implements this callback.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_FrequencyInterferenceUpdatedCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "FrequencyInterference",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "",
                   "This class represents the power spectral density of a frequency slice. Only supported by Mavic Pro.",
            ],
            [
                   "This class represents the power spectral density of a frequency slice. Only supported by Mavic Pro.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "",
                   "",
            ],
            [
                   "FREQUENCY_POINT_RSSIS",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "",
                   "SDK Key for FrequencyInterference: This class represents the power spectral density of a frequency slice. Only supported by Mavic Pro.",
            ],
            [
                   "SDK Key for FrequencyInterference: This class represents the power spectral density of a frequency slice. Only supported by Mavic Pro.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "",
                   "",
            ],
            [
                   "OcuSyncWarningMessage",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_inline",
                   "OcuSync link warning messages.",
            ],
            [
                   "OcuSync link warning messages.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_inline",
                   "",
            ],
            [
                   "WARNING_MESSAGES",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_inline",
                   "SDK Key for OcuSyncWarningMessage: OcuSync link warning messages.",
            ],
            [
                   "SDK Key for OcuSyncWarningMessage: OcuSync link warning messages.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_inline",
                   "",
            ],
            [
                   "frequencyFrom",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_frequencyFrom_inline",
                   "Start frequency.",
            ],
            [
                   "Start frequency.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_frequencyFrom_inline",
                   "",
            ],
            [
                   "frequencyTo",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_frequencyTo_inline",
                   "Stop frequency.",
            ],
            [
                   "Stop frequency.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_frequencyTo_inline",
                   "",
            ],
            [
                   "rssi",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_rssi_inline",
                   "Signal strength within the band defined by the start and stop frequencies.",
            ],
            [
                   "Signal strength within the band defined by the start and stop frequencies.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncFrequencyInterference.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyInterference_rssi_inline",
                   "",
            ],
            [
                   "OcuSyncFrequencyBand",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "The frequency bands for OcuSync.",
            ],
            [
                   "The frequency bands for OcuSync.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "",
            ],
            [
                   "OCUSYNC_FREQUENCY_BAND",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "SDK Key for OcuSyncFrequencyBand: The frequency bands for OcuSync.",
            ],
            [
                   "SDK Key for OcuSyncFrequencyBand: The frequency bands for OcuSync.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "",
            ],
            [
                   "OCUSYNC_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "SDK Key for OcuSyncFrequencyBand: The frequency bands for OcuSync.",
            ],
            [
                   "SDK Key for OcuSyncFrequencyBand: The frequency bands for OcuSync.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_2_DOT_4_GHZ",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_2Dot4GHz_inline",
                   "The Frequency band is 2.4 GHz.",
            ],
            [
                   "The Frequency band is 2.4 GHz.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_2Dot4GHz_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_5_DOT_8_GHZ",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_5Dot8GHz_inline",
                   "The Frequency band is 5.8 GHz.",
            ],
            [
                   "The Frequency band is 5.8 GHz.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_5Dot8GHz_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_DUAL",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_Dual_inline",
                   "Dual frequency band mode. The frequency band can be either 2.4 GHz or 5 GHz.",
            ],
            [
                   "Dual frequency band mode. The frequency band can be either 2.4 GHz or 5 GHz.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_Dual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncFrequencyBand_Unknown_inline",
                   "",
            ],
            [
                   "OcuSyncBandwidth",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_inline",
                   "The channel bandwidth for the OcuSync downlink (from the aircraft to the remote controller). Setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
            ],
            [
                   "The channel bandwidth for the OcuSync downlink (from the aircraft to the remote controller). Setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_inline",
                   "",
            ],
            [
                   "BANDWIDTH",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_inline",
                   "SDK Key for OcuSyncBandwidth: The channel bandwidth for the OcuSync downlink (from the aircraft to the remote controller). Setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
            ],
            [
                   "SDK Key for OcuSyncBandwidth: The channel bandwidth for the OcuSync downlink (from the aircraft to the remote controller). Setting a smaller  bandwidth will reduce the data rate, but make the connection more robust.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_inline",
                   "",
            ],
            [
                   "Bandwidth20MHz",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_20MHz_inline",
                   "The frequency band of the OcuSync link is 20 MHz (up to 46 Mbps).",
            ],
            [
                   "The frequency band of the OcuSync link is 20 MHz (up to 46 Mbps).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_20MHz_inline",
                   "",
            ],
            [
                   "Bandwidth10MHz",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_10MHz_inline",
                   "The frequency band of the OcuSync link is 10 MHz (up to 23 Mbps).",
            ],
            [
                   "The frequency band of the OcuSync link is 10 MHz (up to 23 Mbps).",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_10MHz_inline",
                   "",
            ],
            [
                   "Bandwidth40MHZ",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_40MHz_inline",
                   "The frequency band of the OcuSync link is 40 MHz (up to 80 Mbps).  Only supported by Matrice 300 RTK.",
            ],
            [
                   "The frequency band of the OcuSync link is 40 MHz (up to 80 Mbps).  Only supported by Matrice 300 RTK.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_40MHz_inline",
                   "",
            ],
            [
                   "Unknown",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_Unknown_inline",
                   "Unknown frequency band.",
            ],
            [
                   "Unknown frequency band.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncBandwidth_Unknown_inline",
                   "",
            ],
            [
                   "STRONG_TAKE_OFF_INTERFERENCE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongTakeoffInterference_inline",
                   "Warning that interference is high for take-off. When the signal gets weaker as separation between remote  controller and aircraft get larger, there is a change the link will fail.",
            ],
            [
                   "Warning that interference is high for take-off. When the signal gets weaker as separation between remote  controller and aircraft get larger, there is a change the link will fail.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongTakeoffInterference_inline",
                   "",
            ],
            [
                   "STRONG_DOWN_LINK_INTERFERENCE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongDownlinkInterference_inline",
                   "There is strong interference on the downlink signal incident on the remote controller. If the channel selection  mode  `MANUAL` is being used, consider changing to   `AUTO` as the OcuSync link can automatically select  Channel Numbers and bandwidth to mitigate interference on the fly.",
            ],
            [
                   "There is strong interference on the downlink signal incident on the remote controller. If the channel selection  mode  `MANUAL` is being used, consider changing to   `AUTO` as the OcuSync link can automatically select  Channel Numbers and bandwidth to mitigate interference on the fly.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongDownlinkInterference_inline",
                   "",
            ],
            [
                   "STRONG_UP_LINK_INTERFERENCE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongUplinkInterference_inline",
                   "There is strong interference on the uplink signal incident on the aircraft.",
            ],
            [
                   "There is strong interference on the uplink signal incident on the aircraft.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_StrongUplinkInterference_inline",
                   "",
            ],
            [
                   "WEAK_SIGNAL",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_WeakSignal_inline",
                   "Weak OcuSync signal strength. Be aware of anything blocking the signal between the remote controller and aircraft,  adjust the orientation of the antennas on the remote controller, or reduce the distance between remote controller  and aircraft to increase signal strength.",
            ],
            [
                   "Weak OcuSync signal strength. Be aware of anything blocking the signal between the remote controller and aircraft,  adjust the orientation of the antennas on the remote controller, or reduce the distance between remote controller  and aircraft to increase signal strength.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_WeakSignal_inline",
                   "",
            ],
            [
                   "AIRCRAFT_LINK_REBOOT",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_AircraftLinkReboot_inline",
                   "The OcuSync link on the aircraft is rebooting.",
            ],
            [
                   "The OcuSync link on the aircraft is rebooting.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_AircraftLinkReboot_inline",
                   "",
            ],
            [
                   "UP_LINK_BROKEN",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_UplinkBroken_inline",
                   "The uplink from the remote controller to the aircraft is broken. Usually if only the uplink disconnects, it is due  to interference on the aircraft's OcuSync antennas. Try changing the channel number if the interference source  cannot be removed.",
            ],
            [
                   "The uplink from the remote controller to the aircraft is broken. Usually if only the uplink disconnects, it is due  to interference on the aircraft's OcuSync antennas. Try changing the channel number if the interference source  cannot be removed.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_UplinkBroken_inline",
                   "",
            ],
            [
                   "DOWN_LINK_BROKEN",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_DownlinkBroken_inline",
                   "The downlink from the aircraft to the remote controller is broken. Usually if only the downlink disconnects, it is  due to interference on the remote controller's OcuSync antennas. Try changing channel number, or reducing the bandwidth of the channel to make it more robust.",
            ],
            [
                   "The downlink from the aircraft to the remote controller is broken. Usually if only the downlink disconnects, it is  due to interference on the remote controller's OcuSync antennas. Try changing channel number, or reducing the bandwidth of the channel to make it more robust.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_DownlinkBroken_inline",
                   "",
            ],
            [
                   "LINK_UNUSABLE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_LinkUnusable_inline",
                   "The link between the remote controller and the aircraft is unusable. It is determined to be unusable if signal is  too weak. Check to see if the antennas are setup correctly and the path from remote controller to aircraft is unobstructed.",
            ],
            [
                   "The link between the remote controller and the aircraft is unusable. It is determined to be unusable if signal is  too weak. Check to see if the antennas are setup correctly and the path from remote controller to aircraft is unobstructed.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncWarningMessage_LinkUnusable_inline",
                   "",
            ],
            [
                   "OcuSyncMagneticInterferenceLevel",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_inline",
                   "OcuSync link magnetic interference level.",
            ],
            [
                   "OcuSync link magnetic interference level.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_inline",
                   "",
            ],
            [
                   "NONE",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_None_inline",
                   "There is no detected Ocusync link magnetic interference.",
            ],
            [
                   "There is no detected Ocusync link magnetic interference.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_None_inline",
                   "",
            ],
            [
                   "LOW",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Low_inline",
                   "There is a low level of detected Ocusync link magnetic interference.",
            ],
            [
                   "There is a low level of detected Ocusync link magnetic interference.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Low_inline",
                   "",
            ],
            [
                   "MEDIUM",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Medium_inline",
                   "There is a medium level of detected Ocusync link magnetic interference.",
            ],
            [
                   "There is a medium level of detected Ocusync link magnetic interference.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Medium_inline",
                   "",
            ],
            [
                   "HIGH",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_High_inline",
                   "There is a high level of detected Ocusync link magnetic interference.",
            ],
            [
                   "There is a high level of detected Ocusync link magnetic interference.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_High_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Unknown_inline",
                   "The level of the detected OcuSync link magnetic interference is currently unknown.",
            ],
            [
                   "The level of the detected OcuSync link magnetic interference is currently unknown.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_Unknown_inline",
                   "",
            ],
            [
                   "Callback",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevelCallbackInterface.html",
                   "",
                   "Callback interface for OcuSyncMagneticInterferenceLevel.",
            ],
            [
                   "Callback interface for OcuSyncMagneticInterferenceLevel.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevelCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevelCallbackInterface.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_onUpdateCallback_inline",
                   "Updates the OcuSync Signal Quality. It is only supported by Mavic Pro, Mavic 2 Series.  @param level The level of ocu magnetic interference level.",
            ],
            [
                   "Updates the OcuSync Signal Quality. It is only supported by Mavic Pro, Mavic 2 Series.  @param level The level of ocu magnetic interference level.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevelCallbackInterface.html",
                   "#DJIOcuSyncLink_DJIOcuSyncMagneticInterferenceLevel_onUpdateCallback_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_VideoDataRateUpdatedCallbackInterface.html",
                   "#DJIOcuSyncLink_didUpdateVideoDataRate_inline",
                   "Updated data rate in Mbps for the wireless downlink (from aircraft to remote controller). This link transfers  all information from aircraft to remote controller, which is predominantly video information.  @param newValue The data rate of the downlink in Mbps.",
            ],
            [
                   "Updated data rate in Mbps for the wireless downlink (from aircraft to remote controller). This link transfers  all information from aircraft to remote controller, which is predominantly video information.  @param newValue The data rate of the downlink in Mbps.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_VideoDataRateUpdatedCallbackInterface.html",
                   "#DJIOcuSyncLink_didUpdateVideoDataRate_inline",
                   "",
            ],
            [
                   "onReceive",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_ReceivedWarningMessageCallbackInterface.html",
                   "#DJIOcuSyncLink_didReceiveWarningMessages_inline",
                   "Updated OcuSync link warning messages. This delegate method is called only when there are new warning messages  on the OcuSync link (either uplink or downlink). If the array has no elements, then all previous warning  messages are no longer in effect.  @param messages The array of `OcuSyncWarningMessage` representation of the current Warning Messages.",
            ],
            [
                   "Updated OcuSync link warning messages. This delegate method is called only when there are new warning messages  on the OcuSync link (either uplink or downlink). If the array has no elements, then all previous warning  messages are no longer in effect.  @param messages The array of `OcuSyncWarningMessage` representation of the current Warning Messages.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_ReceivedWarningMessageCallbackInterface.html",
                   "#DJIOcuSyncLink_didReceiveWarningMessages_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_FrequencyInterferenceUpdatedCallbackInterface.html",
                   "#DJIOcuSyncLink_didUpdateDownlinkInterference_inline",
                   "Updated power for interference signals with frequencies in the 2.4 GHz (2400MHz to 2482 MHz) frequency band  incident on the remote controller. Note, measuring the interference reduces effective data rate as the radio  is spending time listening to frequencies outside of the communication channel.  @param rssis The updated interference information. The elements in the array  of `FrequencyInterference` objects each hold interference information about a small  part of the frequency band. Elements are sorted by increasing frequency.",
            ],
            [
                   "Updated power for interference signals with frequencies in the 2.4 GHz (2400MHz to 2482 MHz) frequency band  incident on the remote controller. Note, measuring the interference reduces effective data rate as the radio  is spending time listening to frequencies outside of the communication channel.  @param rssis The updated interference information. The elements in the array  of `FrequencyInterference` objects each hold interference information about a small  part of the frequency band. Elements are sorted by increasing frequency.",
                   1,
                   "/Components/OcuSyncLink/DJIOcuSyncLink_FrequencyInterferenceUpdatedCallbackInterface.html",
                   "#DJIOcuSyncLink_didUpdateDownlinkInterference_inline",
                   "",
            ],
            [
                   "setChannelSelectionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannelSelectionMode_inline",
                   "Sets the downlink channel selection mode (automatic or manual).  @param mode Channel selection mode for the air link. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the downlink channel selection mode (automatic or manual).  @param mode Channel selection mode for the air link. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannelSelectionMode_inline",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannelSelectionMode_inline",
                   "SDK Key for setChannelSelectionMode: Sets the downlink channel selection mode (automatic or manual).  @param mode Channel selection mode for the air link. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setChannelSelectionMode: Sets the downlink channel selection mode (automatic or manual).  @param mode Channel selection mode for the air link. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannelSelectionMode_inline",
                   "",
            ],
            [
                   "getChannelSelectionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelSelectionMode_inline",
                   "Gets the downlink channel selection mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the downlink channel selection mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelSelectionMode_inline",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelSelectionMode_inline",
                   "SDK Key for getChannelSelectionMode: Gets the downlink channel selection mode.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getChannelSelectionMode: Gets the downlink channel selection mode.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelSelectionMode_inline",
                   "",
            ],
            [
                   "getChannelRange",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelRange_inline",
                   "Gets the channels available for the current frequency band.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the channels available for the current frequency band.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelRange_inline",
                   "",
            ],
            [
                   "CHANNEL_RANGE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelRange_inline",
                   "SDK Key for getChannelRange: Gets the channels available for the current frequency band.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getChannelRange: Gets the channels available for the current frequency band.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannelRange_inline",
                   "",
            ],
            [
                   "setChannelNumber",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannel_inline",
                   "Sets the fixed downlink channel. Channel selection mode should be set  to `MANUAL`. The valid range  of channel can be obtained from `getChannelRange`.  @param channelNumber Specific channel for the air link. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the fixed downlink channel. Channel selection mode should be set  to `MANUAL`. The valid range  of channel can be obtained from `getChannelRange`.  @param channelNumber Specific channel for the air link. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannel_inline",
                   "",
            ],
            [
                   "CHANNEL_NUMBER",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannel_inline",
                   "SDK Key for setChannelNumber: Sets the fixed downlink channel. Channel selection mode should be set  to `MANUAL`. The valid range  of channel can be obtained from `getChannelRange`.  @param channelNumber Specific channel for the air link. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setChannelNumber: Sets the fixed downlink channel. Channel selection mode should be set  to `MANUAL`. The valid range  of channel can be obtained from `getChannelRange`.  @param channelNumber Specific channel for the air link. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setChannel_inline",
                   "",
            ],
            [
                   "getChannelNumber",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannel_inline",
                   "Gets current downlink channel of air link.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets current downlink channel of air link.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannel_inline",
                   "",
            ],
            [
                   "CHANNEL_NUMBER",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannel_inline",
                   "SDK Key for getChannelNumber: Gets current downlink channel of air link.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getChannelNumber: Gets current downlink channel of air link.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getChannel_inline",
                   "",
            ],
            [
                   "setDataRate",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDataRate_inline",
                   "Sets the downlink data rate (throughput). Higher data rates increase the quality of video transmission, but can  only be used at shorter ranges.  @param rate Fixed rate (throughput). @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the downlink data rate (throughput). Higher data rates increase the quality of video transmission, but can  only be used at shorter ranges.  @param rate Fixed rate (throughput). @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDataRate_inline",
                   "",
            ],
            [
                   "getDataRate",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDataRate_inline",
                   "Gets the current downlink data rate (throughput).  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the current downlink data rate (throughput).  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDataRate_inline",
                   "",
            ],
            [
                   "setTransmissionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVQualityLatency_inline",
                   "Sets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param mode Quality vs Latency tradeoff for the FPV video @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param mode Quality vs Latency tradeoff for the FPV video @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVQualityLatency_inline",
                   "",
            ],
            [
                   "TRANSMISSION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVQualityLatency_inline",
                   "SDK Key for setTransmissionMode: Sets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param mode Quality vs Latency tradeoff for the FPV video @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setTransmissionMode: Sets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param mode Quality vs Latency tradeoff for the FPV video @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVQualityLatency_inline",
                   "",
            ],
            [
                   "getTransmissionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVQualityLatency_inline",
                   "Gets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVQualityLatency_inline",
                   "",
            ],
            [
                   "TRANSMISSION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVQualityLatency_inline",
                   "SDK Key for getTransmissionMode: Gets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getTransmissionMode: Gets FPV video quality vs latency preference. This mode only affects the FPV camera and not the camera on the HD Gimbal.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVQualityLatency_inline",
                   "",
            ],
            [
                   "setBandwidthAllocationForLBVideoInputPort",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVVideoBandwidthPercent_inline",
                   "Sets the percentage downlink video bandwidth dedicated to the video  feed from one of the LB input ports. The remaining percentage is dedicated  to the video feed from EXT input port. Setting 100% dedicates all the video bandwidth to LB.  @param percent Percentage downlink bandwidth for video feed from LB port. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the percentage downlink video bandwidth dedicated to the video  feed from one of the LB input ports. The remaining percentage is dedicated  to the video feed from EXT input port. Setting 100% dedicates all the video bandwidth to LB.  @param percent Percentage downlink bandwidth for video feed from LB port. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVVideoBandwidthPercent_inline",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_LB_VIDEO_INPUT_PORT",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVVideoBandwidthPercent_inline",
                   "SDK Key for setBandwidthAllocationForLBVideoInputPort: Sets the percentage downlink video bandwidth dedicated to the video  feed from one of the LB input ports. The remaining percentage is dedicated  to the video feed from EXT input port. Setting 100% dedicates all the video bandwidth to LB.  @param percent Percentage downlink bandwidth for video feed from LB port. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setBandwidthAllocationForLBVideoInputPort: Sets the percentage downlink video bandwidth dedicated to the video  feed from one of the LB input ports. The remaining percentage is dedicated  to the video feed from EXT input port. Setting 100% dedicates all the video bandwidth to LB.  @param percent Percentage downlink bandwidth for video feed from LB port. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFPVVideoBandwidthPercent_inline",
                   "",
            ],
            [
                   "getBandwidthAllocationForLBVideoInputPort",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVVideoBandwidthPercent_inline",
                   "Gets the percentage downlink video bandwidth dedicated to the video feed from one of  the LB input ports. The remaining percentage is dedicated to the video feed from EXT input port.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the percentage downlink video bandwidth dedicated to the video feed from one of  the LB input ports. The remaining percentage is dedicated to the video feed from EXT input port.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVVideoBandwidthPercent_inline",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_LB_VIDEO_INPUT_PORT",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVVideoBandwidthPercent_inline",
                   "SDK Key for getBandwidthAllocationForLBVideoInputPort: Gets the percentage downlink video bandwidth dedicated to the video feed from one of  the LB input ports. The remaining percentage is dedicated to the video feed from EXT input port.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getBandwidthAllocationForLBVideoInputPort: Gets the percentage downlink video bandwidth dedicated to the video feed from one of  the LB input ports. The remaining percentage is dedicated to the video feed from EXT input port.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFPVVideoBandwidthPercent_inline",
                   "",
            ],
            [
                   "setBandwidthAllocationForMainCamera",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setBandwidthAllocationForMainCamera_inline",
                   "Sets the percentage downlink video bandwidth dedicated to the main camera or main cameras (for  M210 and M210 RTK). The remaining percentage is dedicated to the FPV camera. For M210 and M210  RTK, the bandwidth for main cameras can be further divided by calling  `setBandwidthAllocationForLeftCamera`. It is only supported by Inspire 2  and M200 series.  @param percent Percentage downlink bandwidth for main camera(s). @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the percentage downlink video bandwidth dedicated to the main camera or main cameras (for  M210 and M210 RTK). The remaining percentage is dedicated to the FPV camera. For M210 and M210  RTK, the bandwidth for main cameras can be further divided by calling  `setBandwidthAllocationForLeftCamera`. It is only supported by Inspire 2  and M200 series.  @param percent Percentage downlink bandwidth for main camera(s). @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setBandwidthAllocationForMainCamera_inline",
                   "",
            ],
            [
                   "getBandwidthAllocationForMainCamera",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getBandwidthAllocationForMainCamera_inline",
                   "Gets the percentage downlink video bandwidth dedicated to the main camera or main cameras  (for M210 and M210 RTK). The remaining percentage is dedicated to the FPV camera. It is  only supported by Inspire 2 and M200 series.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the percentage downlink video bandwidth dedicated to the main camera or main cameras  (for M210 and M210 RTK). The remaining percentage is dedicated to the FPV camera. It is  only supported by Inspire 2 and M200 series.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getBandwidthAllocationForMainCamera_inline",
                   "",
            ],
            [
                   "setBandwidthAllocationForLeftCamera",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setBandwidthAllocationForLeftCamera_inline",
                   "Sets the percentage of the main cameras' bandwidth dedicated to the left camera. The remaining percentage  is dedicated to the right camera. The main cameras' bandwidth is determined by  `setBandwidthAllocationForMainCamera`.  This setting will influence the physical sources  of video feeds (`getPrimaryVideoFeed` and `getSecondaryVideoFeed`):  - When  bandwidth is 100% on the left camera, the primary source is `LEFT_CAM` and the secondary source is `FPV_CAM`.  - When bandwidth 0% on  the left camera, the primary source is `RIGHT_CAM` and the secondary  source is `FPV_CAM`.  - When bandwidth is neither 0% nor 100% on  the left camera, the primary source is `LEFT_CAM` and the secondary  source is `RIGHT_CAM`. It is only supported by M210 and M210 RTK.  @param percent Percentage downlink bandwidth for FPV camera. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the percentage of the main cameras' bandwidth dedicated to the left camera. The remaining percentage  is dedicated to the right camera. The main cameras' bandwidth is determined by  `setBandwidthAllocationForMainCamera`.  This setting will influence the physical sources  of video feeds (`getPrimaryVideoFeed` and `getSecondaryVideoFeed`):  - When  bandwidth is 100% on the left camera, the primary source is `LEFT_CAM` and the secondary source is `FPV_CAM`.  - When bandwidth 0% on  the left camera, the primary source is `RIGHT_CAM` and the secondary  source is `FPV_CAM`.  - When bandwidth is neither 0% nor 100% on  the left camera, the primary source is `LEFT_CAM` and the secondary  source is `RIGHT_CAM`. It is only supported by M210 and M210 RTK.  @param percent Percentage downlink bandwidth for FPV camera. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setBandwidthAllocationForLeftCamera_inline",
                   "",
            ],
            [
                   "getBandwidthAllocationForLeftCamera",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getBandwidthAllocationForLeftCamera_inline",
                   "When a product has multiple main cameras, this method gets the percentage bandwidth allocation  dedicated to the port (left) camera. The remaining percentage is dedicated to the starboard  (right) camera. The total bandwidth allocated to both main cameras (vs the FPV camera) is  determined by `setBandwidthAllocationForMainCamera`.  This setting will  influence the physical sources of video feeds (`getPrimaryVideoFeed`  and `getSecondaryVideoFeed`):  - When bandwidth is 100% on the left camera,  the primary source is `LEFT_CAM` and the secondary source is `FPV_CAM`.  - When bandwidth is 0% on the left camera, the primary source is  `RIGHT_CAM` and the secondary source  is `FPV_CAM`.  - When bandwidth is  neither 0% nor 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `RIGHT_CAM`.  It is only supported  by M210 and M210 RTK.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "When a product has multiple main cameras, this method gets the percentage bandwidth allocation  dedicated to the port (left) camera. The remaining percentage is dedicated to the starboard  (right) camera. The total bandwidth allocated to both main cameras (vs the FPV camera) is  determined by `setBandwidthAllocationForMainCamera`.  This setting will  influence the physical sources of video feeds (`getPrimaryVideoFeed`  and `getSecondaryVideoFeed`):  - When bandwidth is 100% on the left camera,  the primary source is `LEFT_CAM` and the secondary source is `FPV_CAM`.  - When bandwidth is 0% on the left camera, the primary source is  `RIGHT_CAM` and the secondary source  is `FPV_CAM`.  - When bandwidth is  neither 0% nor 100% on the left camera, the primary source is  `LEFT_CAM` and the secondary source is  `RIGHT_CAM`.  It is only supported  by M210 and M210 RTK.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getBandwidthAllocationForLeftCamera_inline",
                   "",
            ],
            [
                   "isDualEncodeModeSupported",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_isDualEncodeModeSupported_inline",
                   "`true` if Lightbridge 2 device supports dual encode mode. Dual encode mode allows the  Lightbridge module to encode and transmit both it's AV and HDMI inputs simultaneously.  @return A boolean value.",
            ],
            [
                   "`true` if Lightbridge 2 device supports dual encode mode. Dual encode mode allows the  Lightbridge module to encode and transmit both it's AV and HDMI inputs simultaneously.  @return A boolean value.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_isDualEncodeModeSupported_inline",
                   "",
            ],
            [
                   "setEXTVideoInputPortEnabled",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setEncodeMode_inline",
                   "Sets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled The encode mode to set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled The encode mode to set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setEncodeMode_inline",
                   "",
            ],
            [
                   "IS_EXT_VIDEO_INPUT_PORT_ENABLED",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setEncodeMode_inline",
                   "SDK Key for setEXTVideoInputPortEnabled: Sets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled The encode mode to set. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setEXTVideoInputPortEnabled: Sets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param enabled The encode mode to set. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setEncodeMode_inline",
                   "",
            ],
            [
                   "getEXTVideoInputPortEnabled",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getEncodeMode_inline",
                   "Gets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getEncodeMode_inline",
                   "",
            ],
            [
                   "IS_EXT_VIDEO_INPUT_PORT_ENABLED",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getEncodeMode_inline",
                   "SDK Key for getEXTVideoInputPortEnabled: Gets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getEXTVideoInputPortEnabled: Gets Lightbridge 2 encode mode. It is only available when `isDualEncodeModeSupported` returns  `true`. For Lightbridge 2 modules that don't support dual encode mode, the encode mode is  always single.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getEncodeMode_inline",
                   "",
            ],
            [
                   "setBandwidthAllocationForHDMIVideoInputPort",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDualEncodeModePercent_inline",
                   "Sets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. Balance is in percent [0.0,  1.0]. It is only available  when `isDualEncodeModeSupported` returns `true`. When percent</code> is 0.0,  all resources are allocated for video data from AV port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param percent Percentage resources dedicated to HDMI encoding and transmission. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "Sets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. Balance is in percent [0.0,  1.0]. It is only available  when `isDualEncodeModeSupported` returns `true`. When percent</code> is 0.0,  all resources are allocated for video data from AV port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param percent Percentage resources dedicated to HDMI encoding and transmission. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDualEncodeModePercent_inline",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_HDMI_VIDEO_INPUT_PORT",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDualEncodeModePercent_inline",
                   "SDK Key for setBandwidthAllocationForHDMIVideoInputPort: Sets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. Balance is in percent [0.0,  1.0]. It is only available  when `isDualEncodeModeSupported` returns `true`. When percent</code> is 0.0,  all resources are allocated for video data from AV port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param percent Percentage resources dedicated to HDMI encoding and transmission. @param callback The execution callback with the execution result returned.",
            ],
            [
                   "SDK Key for setBandwidthAllocationForHDMIVideoInputPort: Sets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. Balance is in percent [0.0,  1.0]. It is only available  when `isDualEncodeModeSupported` returns `true`. When percent</code> is 0.0,  all resources are allocated for video data from AV port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param percent Percentage resources dedicated to HDMI encoding and transmission. @param callback The execution callback with the execution result returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setDualEncodeModePercent_inline",
                   "",
            ],
            [
                   "getBandwidthAllocationForHDMIVideoInputPort",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDualEncodeModePercent_inline",
                   "Gets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. It is only available when `isDualEncodeModeSupported` returns  `true`. When percent</code> is 0.0, all resources are allocated for video data from AV  port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. It is only available when `isDualEncodeModeSupported` returns  `true`. When percent</code> is 0.0, all resources are allocated for video data from AV  port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDualEncodeModePercent_inline",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_HDMI_VIDEO_INPUT_PORT",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDualEncodeModePercent_inline",
                   "SDK Key for getBandwidthAllocationForHDMIVideoInputPort: Gets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. It is only available when `isDualEncodeModeSupported` returns  `true`. When percent</code> is 0.0, all resources are allocated for video data from AV  port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getBandwidthAllocationForHDMIVideoInputPort: Gets the computational power and bandwidth balance between AV and HDMI inputs on the Lightbridge 2 module when  dual encode mode is enabled. It is only available when `isDualEncodeModeSupported` returns  `true`. When percent</code> is 0.0, all resources are allocated for video data from AV  port. When percent</code> is 1.0, all resources are allocated for video data from HDMI port.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getDualEncodeModePercent_inline",
                   "",
            ],
            [
                   "getSupportedFrequencyBands",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getSupportedFrequencyBand_inline",
                   "Gets the frequency bands supported by the product in the current area. It is only supported by Inspire 2 and  Phantom 4 Pro. For the other products with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the frequency bands supported by the product in the current area. It is only supported by Inspire 2 and  Phantom 4 Pro. For the other products with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getSupportedFrequencyBand_inline",
                   "",
            ],
            [
                   "LB_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getSupportedFrequencyBand_inline",
                   "SDK Key for getSupportedFrequencyBands: Gets the frequency bands supported by the product in the current area. It is only supported by Inspire 2 and  Phantom 4 Pro. For the other products with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getSupportedFrequencyBands: Gets the frequency bands supported by the product in the current area. It is only supported by Inspire 2 and  Phantom 4 Pro. For the other products with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getSupportedFrequencyBand_inline",
                   "",
            ],
            [
                   "setFrequencyBand",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFrequencyBand_inline",
                   "Sets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param frequencyBand LBAirLink frequency band to change to. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Sets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param frequencyBand LBAirLink frequency band to change to. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFrequencyBand_inline",
                   "",
            ],
            [
                   "LB_FREQUENCY_BAND",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFrequencyBand_inline",
                   "SDK Key for setFrequencyBand: Sets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param frequencyBand LBAirLink frequency band to change to. @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for setFrequencyBand: Sets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param frequencyBand LBAirLink frequency band to change to. @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setFrequencyBand_inline",
                   "",
            ],
            [
                   "getFrequencyBand",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFrequencyBand_inline",
                   "Gets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "Gets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFrequencyBand_inline",
                   "",
            ],
            [
                   "LB_FREQUENCY_BAND",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFrequencyBand_inline",
                   "SDK Key for getFrequencyBand: Gets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
            ],
            [
                   "SDK Key for getFrequencyBand: Gets the LB air link frequency band. It is only supported by Inspire 2 and Phantom 4 Pro. For the other products  with LB air link, the frequency band is always 2.4 GHz.  @param callback The execution callback with the value(s) returned.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_getFrequencyBand_inline",
                   "",
            ],
            [
                   "ChannelInterference",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "",
                   "The interference power of a LBAirLink channel.",
            ],
            [
                   "The interference power of a LBAirLink channel.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "",
                   "",
            ],
            [
                   "getPower",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "#DJILBAirLink_DJILBAirLinkChannelInterference_power_inline",
                   "The interference power with range from [-60, -100] dBm. A smaller, more negative value represents less  interference and better communication quality.  @return An int value.",
            ],
            [
                   "The interference power with range from [-60, -100] dBm. A smaller, more negative value represents less  interference and better communication quality.  @return An int value.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "#DJILBAirLink_DJILBAirLinkChannelInterference_power_inline",
                   "",
            ],
            [
                   "getChannel",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "#DJILBAirLink_DJILBAirLinkChannelInterference_channel_inline",
                   "The channel number. Different frequency bands have different channel index ranges.  @return An int value.",
            ],
            [
                   "The channel number. Different frequency bands have different channel index ranges.  @return An int value.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILBAirLinkChannelInterference.html",
                   "#DJILBAirLink_DJILBAirLinkChannelInterference_channel_inline",
                   "",
            ],
            [
                   "LightbridgeFrequencyBand",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "LBAirLink frequency band. Supported only by Phantom 4 Professional.",
            ],
            [
                   "LBAirLink frequency band. Supported only by Phantom 4 Professional.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "",
            ],
            [
                   "LB_FREQUENCY_BAND",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "SDK Key for LightbridgeFrequencyBand: LBAirLink frequency band. Supported only by Phantom 4 Professional.",
            ],
            [
                   "SDK Key for LightbridgeFrequencyBand: LBAirLink frequency band. Supported only by Phantom 4 Professional.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "",
            ],
            [
                   "LB_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "SDK Key for LightbridgeFrequencyBand: LBAirLink frequency band. Supported only by Phantom 4 Professional.",
            ],
            [
                   "SDK Key for LightbridgeFrequencyBand: LBAirLink frequency band. Supported only by Phantom 4 Professional.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_2_DOT_4_GHZ",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_2Dot4G_inline",
                   "The LBAirLink Frequency band is 2.4 GHz.",
            ],
            [
                   "The LBAirLink Frequency band is 2.4 GHz.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_2Dot4G_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_5_DOT_7_GHZ",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_5Dot7G_inline",
                   "The LBAirLink Frequency band is 5.7 GHz.",
            ],
            [
                   "The LBAirLink Frequency band is 5.7 GHz.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_5Dot7G_inline",
                   "",
            ],
            [
                   "FREQUENCY_BAND_5_DOT_8_GHZ",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_5Dot8G_inline",
                   "The LBAirLink Frequency band is 5.8 GHz.",
            ],
            [
                   "The LBAirLink Frequency band is 5.8 GHz.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_5Dot8G_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_Unknown_inline",
                   "The LBAirLink Frequency is unknown.",
            ],
            [
                   "The LBAirLink Frequency is unknown.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFrequencyBand_Unknown_inline",
                   "",
            ],
            [
                   "ChannelSelectionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_inline",
                   "Downlink channel selection mode (manual or automatic) for the wireless link.",
            ],
            [
                   "Downlink channel selection mode (manual or automatic) for the wireless link.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_inline",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_inline",
                   "SDK Key for ChannelSelectionMode: Downlink channel selection mode (manual or automatic) for the wireless link.",
            ],
            [
                   "SDK Key for ChannelSelectionMode: Downlink channel selection mode (manual or automatic) for the wireless link.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_inline",
                   "",
            ],
            [
                   "AUTO",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Auto_inline",
                   "Air link will automatically select the best physical channel based on the signal environment.",
            ],
            [
                   "Air link will automatically select the best physical channel based on the signal environment.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Auto_inline",
                   "",
            ],
            [
                   "MANUAL",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Manual_inline",
                   "Manually select the physical channel.",
            ],
            [
                   "Manually select the physical channel.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Manual_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Unknown_inline",
                   "Unknown physical channel selection mode.",
            ],
            [
                   "Unknown physical channel selection mode.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkChannelSelectionMode_Unknown_inline",
                   "",
            ],
            [
                   "LightbridgeTransmissionMode",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_inline",
                   "FPV(First-person view) Video can prioritize either quality or latency.",
            ],
            [
                   "FPV(First-person view) Video can prioritize either quality or latency.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_inline",
                   "",
            ],
            [
                   "TRANSMISSION_MODE",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_inline",
                   "SDK Key for LightbridgeTransmissionMode: FPV(First-person view) Video can prioritize either quality or latency.",
            ],
            [
                   "SDK Key for LightbridgeTransmissionMode: FPV(First-person view) Video can prioritize either quality or latency.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_inline",
                   "",
            ],
            [
                   "HIGH_QUALITY",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_HighQuality_inline",
                   "High quality priority.",
            ],
            [
                   "High quality priority.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_HighQuality_inline",
                   "",
            ],
            [
                   "LOW_LATENCY",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_LowLatency_inline",
                   "Low latency priority.",
            ],
            [
                   "Low latency priority.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_LowLatency_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkFPVVideoQualityLatency_Unknown_inline",
                   "",
            ],
            [
                   "LightbridgeDataRate",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_inline",
                   "Wireless downlink data rate. Lower rates are used for longer ranges, but will have lower video quality.",
            ],
            [
                   "Wireless downlink data rate. Lower rates are used for longer ranges, but will have lower video quality.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_inline",
                   "",
            ],
            [
                   "BANDWIDTH_4_MBPS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_4Mbps_inline",
                   "4 Mbps (Potential range up to 3 km)",
            ],
            [
                   "4 Mbps (Potential range up to 3 km)",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_4Mbps_inline",
                   "",
            ],
            [
                   "BANDWIDTH_6_MBPS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_6Mbps_inline",
                   "6 Mbps (Potential range up to 2 km)",
            ],
            [
                   "6 Mbps (Potential range up to 2 km)",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_6Mbps_inline",
                   "",
            ],
            [
                   "BANDWIDTH_8_MBPS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_8Mbps_inline",
                   "8 Mbps (Potential range up to 1.5 km)",
            ],
            [
                   "8 Mbps (Potential range up to 1.5 km)",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_8Mbps_inline",
                   "",
            ],
            [
                   "BANDWIDTH_10_MBPS",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_10Mbps_inline",
                   "10 Mbps (Potential range up to 0.7 km)",
            ],
            [
                   "10 Mbps (Potential range up to 0.7 km)",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_10Mbps_inline",
                   "",
            ],
            [
                   "UNKNOWN",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_Unknown_inline",
                   "Unknown.",
            ],
            [
                   "Unknown.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_DJILBAirLinkDataRate_Unknown_inline",
                   "",
            ],
            [
                   "LightbridgeAntennaRSSI",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "RSSI object (received signal strength indicator).",
            ],
            [
                   "RSSI object (received signal strength indicator).",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_ANTENNA_RSSI",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "SDK Key for LightbridgeAntennaRSSI: RSSI object (received signal strength indicator).",
            ],
            [
                   "SDK Key for LightbridgeAntennaRSSI: RSSI object (received signal strength indicator).",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "",
            ],
            [
                   "AIRCRAFT_ANTENNA_RSSI",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "SDK Key for LightbridgeAntennaRSSI: RSSI object (received signal strength indicator).",
            ],
            [
                   "SDK Key for LightbridgeAntennaRSSI: RSSI object (received signal strength indicator).",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "",
                   "",
            ],
            [
                   "getAntenna1",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "#DJILBAirLink_DJILightbridgeAntennaRSSI_antenna1_inline",
                   "Antenna1 RSSI value  @return An int value of antenna RSSI.",
            ],
            [
                   "Antenna1 RSSI value  @return An int value of antenna RSSI.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "#DJILBAirLink_DJILightbridgeAntennaRSSI_antenna1_inline",
                   "",
            ],
            [
                   "getAntenna2",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "#DJILBAirLink_DJILightbridgeAntennaRSSI_antenna2_inline",
                   "Antenna2 RSSI value  @return An int value of antenna RSSI.",
            ],
            [
                   "Antenna2 RSSI value  @return An int value of antenna RSSI.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_DJILightbridgeAntennaRSSI.html",
                   "#DJILBAirLink_DJILightbridgeAntennaRSSI_antenna2_inline",
                   "",
            ],
            [
                   "setAircraftAntennaRSSICallback",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setAircraftAntennaRSSICallback_inline",
                   "Set callback to receive RSSI information on each antenna of aircraft.  @param callback The interface of `AntennaRSSICallback`.",
            ],
            [
                   "Set callback to receive RSSI information on each antenna of aircraft.  @param callback The interface of `AntennaRSSICallback`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setAircraftAntennaRSSICallback_inline",
                   "",
            ],
            [
                   "AIRCRAFT_ANTENNA_RSSI",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setAircraftAntennaRSSICallback_inline",
                   "SDK Key for setAircraftAntennaRSSICallback: Set callback to receive RSSI information on each antenna of aircraft.  @param callback The interface of `AntennaRSSICallback`.",
            ],
            [
                   "SDK Key for setAircraftAntennaRSSICallback: Set callback to receive RSSI information on each antenna of aircraft.  @param callback The interface of `AntennaRSSICallback`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setAircraftAntennaRSSICallback_inline",
                   "",
            ],
            [
                   "setRemoteControllerAntennaRSSICallback",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setRemoteControllerAntennaRSSICallback_inline",
                   "Set callback to receive RSSI information on each antenna of remote controller.  @param callback The interface of `AntennaRSSICallback`.",
            ],
            [
                   "Set callback to receive RSSI information on each antenna of remote controller.  @param callback The interface of `AntennaRSSICallback`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setRemoteControllerAntennaRSSICallback_inline",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_ANTENNA_RSSI",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setRemoteControllerAntennaRSSICallback_inline",
                   "SDK Key for setRemoteControllerAntennaRSSICallback: Set callback to receive RSSI information on each antenna of remote controller.  @param callback The interface of `AntennaRSSICallback`.",
            ],
            [
                   "SDK Key for setRemoteControllerAntennaRSSICallback: Set callback to receive RSSI information on each antenna of remote controller.  @param callback The interface of `AntennaRSSICallback`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_setRemoteControllerAntennaRSSICallback_inline",
                   "",
            ],
            [
                   "onUpdate",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_AntennaRSSICallbackInterface.html",
                   "#DJILBAirLink_AntennaRSSIOnUpdateCallback_inline",
                   "Method called when antenna RSSI information has updated.  @param antennaRSSI An instance of `LightbridgeAntennaRSSI`.",
            ],
            [
                   "Method called when antenna RSSI information has updated.  @param antennaRSSI An instance of `LightbridgeAntennaRSSI`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_AntennaRSSICallbackInterface.html",
                   "#DJILBAirLink_AntennaRSSIOnUpdateCallback_inline",
                   "",
            ],
            [
                   "setChannelInterferenceCallback",
                   2,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_UpdateAllChannelInterferenceCallback_inline",
                   "Sets up the DJILBAirLinkUpdatedAllChannelInterferenceCallback.  @param callback The `ChannelInterferenceCallback`.",
            ],
            [
                   "Sets up the DJILBAirLinkUpdatedAllChannelInterferenceCallback.  @param callback The `ChannelInterferenceCallback`.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink.html",
                   "#DJILBAirLink_UpdateAllChannelInterferenceCallback_inline",
                   "",
            ],
            [
                   "onResult",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_UpdateAllChannelInterferenceCallbackInterface.html",
                   "#DJILBAirLink_UpdateAllChannelInterference_inline",
                   "Signal strength of all signals present on all available downlink channels. Signals  that are not the communication signal are considered interference.  @param channelInterferences The updated interference information. The elements in the array  of `ChannelInterference` objects each hold the  interference signal strength of a channel. Elements are sorted by increasing  channel number.",
            ],
            [
                   "Signal strength of all signals present on all available downlink channels. Signals  that are not the communication signal are considered interference.  @param channelInterferences The updated interference information. The elements in the array  of `ChannelInterference` objects each hold the  interference signal strength of a channel. Elements are sorted by increasing  channel number.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_UpdateAllChannelInterferenceCallbackInterface.html",
                   "#DJILBAirLink_UpdateAllChannelInterference_inline",
                   "",
            ],
            [
                   "AntennaRSSICallback",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_AntennaRSSICallbackInterface.html",
                   "",
                   "Callback of antenna RSSI information for each antenna.",
            ],
            [
                   "Callback of antenna RSSI information for each antenna.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_AntennaRSSICallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "ChannelInterferenceCallback",
                   2,
                   "/Components/LBAirLink/DJILBAirLink_UpdateAllChannelInterferenceCallbackInterface.html",
                   "",
                   "Callback of signal strength of all signals present on all available downlink channels. Signals that are not the  communication signal are considered interference.",
            ],
            [
                   "Callback of signal strength of all signals present on all available downlink channels. Signals that are not the  communication signal are considered interference.",
                   1,
                   "/Components/LBAirLink/DJILBAirLink_UpdateAllChannelInterferenceCallbackInterface.html",
                   "",
                   "",
            ],
            [
                   "onValueChange",
                   2,
                   "/Components/KeyManager/DJIKeyManager_DJIKeyedListenerUpdateBlock.html",
                   "#DJIKeyManager_KeyListener_Interface_onValueChange_inline",
                   "The callback, called every time the value behind a key is updated.  @param oldValue The old value. `null` if no value was present before. @param newValue The new value. `null` if the stored values are being flushed.",
            ],
            [
                   "The callback, called every time the value behind a key is updated.  @param oldValue The old value. `null` if no value was present before. @param newValue The new value. `null` if the stored values are being flushed.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_DJIKeyedListenerUpdateBlock.html",
                   "#DJIKeyManager_KeyListener_Interface_onValueChange_inline",
                   "",
            ],
            [
                   "getValue",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_getValueForKey_inline",
                   "Returns the latest known value if available for the key.  Does not pull it from the product if unavailable.  @param key An instance of `DJIKey`.  @return The value associated with the key.",
            ],
            [
                   "Returns the latest known value if available for the key.  Does not pull it from the product if unavailable.  @param key An instance of `DJIKey`.  @return The value associated with the key.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_getValueForKey_inline",
                   "",
            ],
            [
                   "getValue",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_getValueForKeywithCompletion_inline",
                   "Performs a get on a gettable key, pulling the information from the product if necessary.  @param key A valid gettable key @param callback A valid get callback.",
            ],
            [
                   "Performs a get on a gettable key, pulling the information from the product if necessary.  @param key A valid gettable key @param callback A valid get callback.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_getValueForKeywithCompletion_inline",
                   "",
            ],
            [
                   "setValue",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_setValueForKeyWithCompletion_inline",
                   "Performs a set on a settable key, changing attributes on the  connected product.  @param value A value object relevant to the given key @param key A valid settable key @param callback A set callback.",
            ],
            [
                   "Performs a set on a settable key, changing attributes on the  connected product.  @param value A value object relevant to the given key @param key A valid settable key @param callback A set callback.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_setValueForKeyWithCompletion_inline",
                   "",
            ],
            [
                   "performAction",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_performActionForKeyWithArgumentsAndCompletion_inline",
                   "Performs an action on an actionable key.  @param key A valid actionable key @param arguments Optional arguments relevant to the specific key @param callback An action callback.",
            ],
            [
                   "Performs an action on an actionable key.  @param key A valid actionable key @param arguments Optional arguments relevant to the specific key @param callback An action callback.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_performActionForKeyWithArgumentsAndCompletion_inline",
                   "",
            ],
            [
                   "addListener",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_startListeningForChangesOnKeuyWithListenerAndUpdateBlock_inline",
                   "Subscribes the listener object to all changes of value on the given  key.  @param key A valid value-based key (get, set and/or action) @param listener A valid object to hold the subscription",
            ],
            [
                   "Subscribes the listener object to all changes of value on the given  key.  @param key A valid value-based key (get, set and/or action) @param listener A valid object to hold the subscription",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_startListeningForChangesOnKeuyWithListenerAndUpdateBlock_inline",
                   "",
            ],
            [
                   "removeListener",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_stopListeningOnKeyOfListener_inline",
                   "Stops the subscription to updates of a specific key value for a  specific listener. Does not affect other listeners subscribing to  this key or other subscriptions of the `listener`.  @param listener The listener object passed at the moment of calling startListening.",
            ],
            [
                   "Stops the subscription to updates of a specific key value for a  specific listener. Does not affect other listeners subscribing to  this key or other subscriptions of the `listener`.  @param listener The listener object passed at the moment of calling startListening.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_stopListeningOnKeyOfListener_inline",
                   "",
            ],
            [
                   "isKeySupported",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_isKeySupported_inline",
                   "Determines if a key is supported by the connected product.  @param key Key to be check on current product.  @return `true` if the key is supported.",
            ],
            [
                   "Determines if a key is supported by the connected product.  @param key Key to be check on current product.  @return `true` if the key is supported.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_isKeySupported_inline",
                   "",
            ],
            [
                   "removeKey",
                   2,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_removeKey_inline",
                   "Remove a key's cache value.  @param key Key to be removed on current product.",
            ],
            [
                   "Remove a key's cache value.  @param key Key to be removed on current product.",
                   1,
                   "/Components/KeyManager/DJIKeyManager.html",
                   "#DJIKeyManager_removeKey_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_AirLink_inline",
                   "Creates an AirLink key.  @param paramKey A valid paramKey.  @return AirLink Key",
            ],
            [
                   "Creates an AirLink key.  @param paramKey A valid paramKey.  @return AirLink Key",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_AirLink_inline",
                   "",
            ],
            [
                   "createWiFiLinkKey",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_WIFILink_inline",
                   "Creates a WIFILink key. The `WIFILinkParamKey` values are listed below: REBOOT, DOWNLINK_SIGNAL_QUALITY, UPLINK_SIGNAL_QUALITY, MAGNETIC_INTERFERENCE, CHANNEL_INTERFERENCE, CHANNEL_NUMBER, AVAILABLE_CHANNEL_NUMBERS, SSID, PASSWORD, WIFI_FREQUENCY_BAND, DATA_RATE  @param paramKey A valid paramKey.  @return WiFiLink Key",
            ],
            [
                   "Creates a WIFILink key. The `WIFILinkParamKey` values are listed below: REBOOT, DOWNLINK_SIGNAL_QUALITY, UPLINK_SIGNAL_QUALITY, MAGNETIC_INTERFERENCE, CHANNEL_INTERFERENCE, CHANNEL_NUMBER, AVAILABLE_CHANNEL_NUMBERS, SSID, PASSWORD, WIFI_FREQUENCY_BAND, DATA_RATE  @param paramKey A valid paramKey.  @return WiFiLink Key",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_WIFILink_inline",
                   "",
            ],
            [
                   "createLightbridgeLinkKey",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_LBLink_inline",
                   "Creates a LBLink key. The `LightbridgeLinkParamKey` values are listed below: BANDWIDTH_ALLOCATION_FOR_HDMI_VIDEO_INPUT_PORT, IS_EXT_VIDEO_INPUT_PORT_ENABLED, BANDWIDTH_ALLOCATION_FOR_LB_VIDEO_INPUT_PORT, CHANNEL_INTERFERENCE, CHANNEL_NUMBER, DATA_RATE, SECONDARY_VIDEO_OUTPUT_ENABLED, SECONDARY_VIDEO_OUTPUT_PORT, SECONDARY_VIDEO_DISPLAY_MODE, SECONDARY_VIDEO_OSD_ENABLED, SECONDARY_VIDEO_OSD_TOP_MARGIN, SECONDARY_VIDEO_OSD_LEFT_MARGIN, SECONDARY_VIDEO_OSD_BOTTOM_MARGIN, SECONDARY_VIDEO_OSD_RIGHT_MARGIN, SECONDARY_VIDEO_OSD_UNIT, HDMI_OUTPUT_FORMAT, SDI_OUTPUT_FORMAT, PIP_POSITION, CHANNEL_SELECTION_MODE, UPLINK_SIGNAL_QUALITY, DOWNLINK_SIGNAL_QUALITY, AIRCRAFT_ANTENNA_RSSI, REMOTE_CONTROLLER_ANTENNA_RSSI, CHANNEL_RANGE, SUPPORTED_FREQUENCY_BANDS, TRANSMISSION_MODE, LB_FREQUENCY_BAND, BANDWIDTH_ALLOCATION_FOR_LEFT_CAMERA  @param paramKey A valid paramKey.  @return LBLink Key",
            ],
            [
                   "Creates a LBLink key. The `LightbridgeLinkParamKey` values are listed below: BANDWIDTH_ALLOCATION_FOR_HDMI_VIDEO_INPUT_PORT, IS_EXT_VIDEO_INPUT_PORT_ENABLED, BANDWIDTH_ALLOCATION_FOR_LB_VIDEO_INPUT_PORT, CHANNEL_INTERFERENCE, CHANNEL_NUMBER, DATA_RATE, SECONDARY_VIDEO_OUTPUT_ENABLED, SECONDARY_VIDEO_OUTPUT_PORT, SECONDARY_VIDEO_DISPLAY_MODE, SECONDARY_VIDEO_OSD_ENABLED, SECONDARY_VIDEO_OSD_TOP_MARGIN, SECONDARY_VIDEO_OSD_LEFT_MARGIN, SECONDARY_VIDEO_OSD_BOTTOM_MARGIN, SECONDARY_VIDEO_OSD_RIGHT_MARGIN, SECONDARY_VIDEO_OSD_UNIT, HDMI_OUTPUT_FORMAT, SDI_OUTPUT_FORMAT, PIP_POSITION, CHANNEL_SELECTION_MODE, UPLINK_SIGNAL_QUALITY, DOWNLINK_SIGNAL_QUALITY, AIRCRAFT_ANTENNA_RSSI, REMOTE_CONTROLLER_ANTENNA_RSSI, CHANNEL_RANGE, SUPPORTED_FREQUENCY_BANDS, TRANSMISSION_MODE, LB_FREQUENCY_BAND, BANDWIDTH_ALLOCATION_FOR_LEFT_CAMERA  @param paramKey A valid paramKey.  @return LBLink Key",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_LBLink_inline",
                   "",
            ],
            [
                   "createOcuSyncLinkKey",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_OcuSyncLink_inline",
                   "Creates an OcuSyncLink key. The `OcuSyncLinkParamKey` values are listed below: UPLINK_SIGNAL_QUALITY, DOWNLINK_SIGNAL_QUALITY, BANDWIDTH, DYNAMIC_DATA_RATE, FREQUENCY_POINT_INDEX, FREQUENCY_POINT_INDEX_VALID_RANGE, FREQUENCY_POINT_RSSIS, WARNING_MESSAGES, CHANNEL_SELECTION_MODE  @param paramKey A valid paramKey.  @return OcuSyncLink Key",
            ],
            [
                   "Creates an OcuSyncLink key. The `OcuSyncLinkParamKey` values are listed below: UPLINK_SIGNAL_QUALITY, DOWNLINK_SIGNAL_QUALITY, BANDWIDTH, DYNAMIC_DATA_RATE, FREQUENCY_POINT_INDEX, FREQUENCY_POINT_INDEX_VALID_RANGE, FREQUENCY_POINT_RSSIS, WARNING_MESSAGES, CHANNEL_SELECTION_MODE  @param paramKey A valid paramKey.  @return OcuSyncLink Key",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#DJIAirLinkKey_create_OcuSyncLink_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createWithParamKey_inline",
                   "Creates an AccessoryAggregation key.  @param paramKey A valid paramKey  @return AccessoryAggregation Key",
            ],
            [
                   "Creates an AccessoryAggregation key.  @param paramKey A valid paramKey  @return AccessoryAggregation Key",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createWithParamKey_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createWithParamKeyAndComponentIndex_inline",
                   "Creates an AccessoryAggregation key.  @param paramKey A valid paramKey @param componentIndex The index of the AccessoryAggregation component.  @return AccessoryAggregation Key",
            ],
            [
                   "Creates an AccessoryAggregation key.  @param paramKey A valid paramKey @param componentIndex The index of the AccessoryAggregation component.  @return AccessoryAggregation Key",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createWithParamKeyAndComponentIndex_inline",
                   "",
            ],
            [
                   "createSpeakerKey",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createSpeakerKeyWithParamKey_inline",
                   "Creates a Speaker key.  @param paramKey A valid paramKey.  @return Speaker key.",
            ],
            [
                   "Creates a Speaker key.  @param paramKey A valid paramKey.  @return Speaker key.",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createSpeakerKeyWithParamKey_inline",
                   "",
            ],
            [
                   "createSpotlightKey",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createSpotlightKeyWithParamKey_inline",
                   "Creates a Spotlight key.  @param paramKey A valid paramKey.  @return Speaker key.",
            ],
            [
                   "Creates a Spotlight key.  @param paramKey A valid paramKey.  @return Speaker key.",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createSpotlightKeyWithParamKey_inline",
                   "",
            ],
            [
                   "createBeaconKey",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createBeaconKeyWithParamKey_inline",
                   "Creates a Beacon key.  @param paramKey A valid paramKey.  @return Beacon key.",
            ],
            [
                   "Creates a Beacon key.  @param paramKey A valid paramKey.  @return Beacon key.",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#DJIAccessoryKey_createBeaconKeyWithParamKey_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_inline",
                   "Creates a Battery key.  @param paramKey A valid paramKey.  @return Battery Key",
            ],
            [
                   "Creates a Battery key.  @param paramKey A valid paramKey.  @return Battery Key",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_with_index_inline",
                   "Creates a battery key at selected index. Use this when the product supports multiple batteries.  @param paramKey A valid paramKey. @param componentIndex The index of the Battery component.  @return Battery Key",
            ],
            [
                   "Creates a battery key at selected index. Use this when the product supports multiple batteries.  @param paramKey A valid paramKey. @param componentIndex The index of the Battery component.  @return Battery Key",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_with_index_inline",
                   "",
            ],
            [
                   "createBatteryAggregationKey",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_BatteryAggregationKey_inline",
                   "Creates a Battery Aggregation key.  @param paramKey A valid paramKey.  @return An object of `BatteryKey`.",
            ],
            [
                   "Creates a Battery Aggregation key.  @param paramKey A valid paramKey.  @return An object of `BatteryKey`.",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#DJIBatteryKey_create_BatteryAggregationKey_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_create_inline",
                   "Creates a Camera key.  @param paramKey A valid paramKey.  @return Camera Key",
            ],
            [
                   "Creates a Camera key.  @param paramKey A valid paramKey.  @return Camera Key",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_create_with_index_inline",
                   "Creates a Camera key at selected index. Use this when the product supports multiple cameras.  @param paramKey A valid paramKey. @param componentIndex The index of the Camera component.  @return Camera Key",
            ],
            [
                   "Creates a Camera key at selected index. Use this when the product supports multiple cameras.  @param paramKey A valid paramKey. @param componentIndex The index of the Camera component.  @return Camera Key",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_create_with_index_inline",
                   "",
            ],
            [
                   "createLensKey",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_createLensKey_with_index_inline",
                   "Creates a Lens key at selected component index and subComponent Index. Use this when the product supports camera which has multi lens.  @param paramKey A valid paramKey. @param componentIndex The index of the Camera component. @param subComponentIndex The index of the Camera subcomponent.  @return Camera Key",
            ],
            [
                   "Creates a Lens key at selected component index and subComponent Index. Use this when the product supports camera which has multi lens.  @param paramKey A valid paramKey. @param componentIndex The index of the Camera component. @param subComponentIndex The index of the Camera subcomponent.  @return Camera Key",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#DJICameraKey_createLensKey_with_index_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_inline",
                   "Creates a FlightController key.  @param paramKey A valid paramKey.  @return FlightController Key",
            ],
            [
                   "Creates a FlightController key.  @param paramKey A valid paramKey.  @return FlightController Key",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_inline",
                   "",
            ],
            [
                   "createFlightAssistantKey",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_FlightAssistant_inline",
                   "Creates a FlightAssistant key. The `IntelligentFlightAssistantParamKey` values are listed below: COLLISION_AVOIDANCE_ENABLED, VISION_ASSISTED_POSITIONING_ENABLED, IS_BRAKING, VISION_SYSTEM_WARNING, DETECTION_SECTORS, VISION_DETECTION_STATE, ACTIVE_TRACK_MODE, ACTIVE_TRACK_CIRCULAR_SPEED, ACTIVE_TRACK_GPS_ASSISTANT_ENABLED, ACTIVE_TRACK_GESTURE_MODE_ENABLED, DRAW_STATUS, DRAW_HEADING_MODE, UPWARDS_AVOIDANCE_ENABLED, LANDING_PROTECTION_ENABLED, PRECISION_LANDING_ENABLED, LANDING_PROTECTION_STATE, SET_ACTIVE_TRACK_CAMERA, ACTIVE_OBSTACLE_AVOIDANCE_ENABLED, INTELLIGENT_FLIGHT_ASSISTANT_GHAVOID_ENABLED, INTELLIGENT_FLIGHT_ASSISTANT_IS_USERAVOID_ENABLE, IS_AVOIDING_ACTIVE_OBSTACLE_COLLISION, IS_ASCENT_LIMITED_BY_OBSTACLE, IS_PERFORMING_PRECISION_LANDING, ADVANCED_GESTURE_CONTROL_ENABLED  @param paramKey A valid paramKey.  @return FlightAssistant Key",
            ],
            [
                   "Creates a FlightAssistant key. The `IntelligentFlightAssistantParamKey` values are listed below: COLLISION_AVOIDANCE_ENABLED, VISION_ASSISTED_POSITIONING_ENABLED, IS_BRAKING, VISION_SYSTEM_WARNING, DETECTION_SECTORS, VISION_DETECTION_STATE, ACTIVE_TRACK_MODE, ACTIVE_TRACK_CIRCULAR_SPEED, ACTIVE_TRACK_GPS_ASSISTANT_ENABLED, ACTIVE_TRACK_GESTURE_MODE_ENABLED, DRAW_STATUS, DRAW_HEADING_MODE, UPWARDS_AVOIDANCE_ENABLED, LANDING_PROTECTION_ENABLED, PRECISION_LANDING_ENABLED, LANDING_PROTECTION_STATE, SET_ACTIVE_TRACK_CAMERA, ACTIVE_OBSTACLE_AVOIDANCE_ENABLED, INTELLIGENT_FLIGHT_ASSISTANT_GHAVOID_ENABLED, INTELLIGENT_FLIGHT_ASSISTANT_IS_USERAVOID_ENABLE, IS_AVOIDING_ACTIVE_OBSTACLE_COLLISION, IS_ASCENT_LIMITED_BY_OBSTACLE, IS_PERFORMING_PRECISION_LANDING, ADVANCED_GESTURE_CONTROL_ENABLED  @param paramKey A valid paramKey.  @return FlightAssistant Key",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_FlightAssistant_inline",
                   "",
            ],
            [
                   "createRTKKey",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_RTK_inline",
                   "Creates a RTK key.  @param paramKey A valid paramKey.  @return RTK key.",
            ],
            [
                   "Creates a RTK key.  @param paramKey A valid paramKey.  @return RTK key.",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_RTK_inline",
                   "",
            ],
            [
                   "createAccessLockerKey",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_AccessLocker_inline",
                   "Creates a AccessLocker key.  @param paramKey A valid paramKey.  @return AccessLocker key.",
            ],
            [
                   "Creates a AccessLocker key.  @param paramKey A valid paramKey.  @return AccessLocker key.",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#DJIFlightControllerKey_create_AccessLocker_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#DJIGimbalKey_create_inline",
                   "Creates a Gimbal key.  @param paramKey A valid paramKey.  @return Gimbal Key",
            ],
            [
                   "Creates a Gimbal key.  @param paramKey A valid paramKey.  @return Gimbal Key",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#DJIGimbalKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#DJIProductKey_create_inline",
                   "Creates a Product key.  @param paramKey A valid paramKey.  @return Product Key",
            ],
            [
                   "Creates a Product key.  @param paramKey A valid paramKey.  @return Product Key",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#DJIProductKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#DJIRemoteControllerKey_create_inline",
                   "Creates a RemoteControllerKey key.  @param paramKey A valid paramKey.  @return Remote Controller Key",
            ],
            [
                   "Creates a RemoteControllerKey key.  @param paramKey A valid paramKey.  @return Remote Controller Key",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#DJIRemoteControllerKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#DJIHandheldControllerKey_create_inline",
                   "Creates a HandheldController key.  @param paramKey A valid paramKey.  @return Handheld Controller Key",
            ],
            [
                   "Creates a HandheldController key.  @param paramKey A valid paramKey.  @return Handheld Controller Key",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#DJIHandheldControllerKey_create_inline",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "#DJIDiagnosticsKey_create_inline",
                   "Creates a Diagnostics key.  @param paramKey A valid paramKey.  @return Diagnostics Key",
            ],
            [
                   "Creates a Diagnostics key.  @param paramKey A valid paramKey.  @return Diagnostics Key",
                   1,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "#DJIDiagnosticsKey_create_inline",
                   "",
            ],
            [
                   "DJIKey",
                   2,
                   "/Components/KeyManager/DJIKey.html",
                   "",
                   "Base class of all keys to be used with the keyed interface and the `KeyManager`.",
            ],
            [
                   "Base class of all keys to be used with the keyed interface and the `KeyManager`.",
                   1,
                   "/Components/KeyManager/DJIKey.html",
                   "",
                   "",
            ],
            [
                   "BatteryKey",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "",
                   "`BatteryKey` is a key dedicated to accessing Battery related attributes.",
            ],
            [
                   "`BatteryKey` is a key dedicated to accessing Battery related attributes.",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "",
                   "",
            ],
            [
                   "CameraKey",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "",
                   "`CameraKey` is an object dedicated to providing access to Camera  related attributes.",
            ],
            [
                   "`CameraKey` is an object dedicated to providing access to Camera  related attributes.",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "",
                   "",
            ],
            [
                   "FlightControllerKey",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "",
                   "`FlightControllerKey` provides dedicated access to Flight  controller attributes.",
            ],
            [
                   "`FlightControllerKey` provides dedicated access to Flight  controller attributes.",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "",
                   "",
            ],
            [
                   "RadarKey",
                   2,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "",
                   "`RadarKey` provides dedicated access to radar attributes.",
            ],
            [
                   "`RadarKey` provides dedicated access to radar attributes.",
                   1,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "",
                   "",
            ],
            [
                   "PayloadKey",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "",
                   "`PayloadKey` provides dedicated access to Flight  controller attributes.",
            ],
            [
                   "`PayloadKey` provides dedicated access to Flight  controller attributes.",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "",
                   "",
            ],
            [
                   "GimbalKey",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "",
                   "`GimbalKey` is an object providing access to Gimbal attributes.",
            ],
            [
                   "`GimbalKey` is an object providing access to Gimbal attributes.",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "",
                   "",
            ],
            [
                   "ProductKey",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "",
                   "`ProductKey` represent keys which are global to the whole product.",
            ],
            [
                   "`ProductKey` represent keys which are global to the whole product.",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "",
                   "",
            ],
            [
                   "RemoteControllerKey",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "",
                   "`RemoteControllerKey` provides dedicated access to remote controller attributes.",
            ],
            [
                   "`RemoteControllerKey` provides dedicated access to remote controller attributes.",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "",
                   "",
            ],
            [
                   "HandheldControllerKey",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "",
                   "`HandheldControllerKey` provides dedicated access to all handheld  controller attributes.",
            ],
            [
                   "`HandheldControllerKey` provides dedicated access to all handheld  controller attributes.",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "",
                   "",
            ],
            [
                   "AirLinkKey",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "",
                   "`AirLinkKey` provides dedicated access to all communication  to the product attributes.",
            ],
            [
                   "`AirLinkKey` provides dedicated access to all communication  to the product attributes.",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "",
                   "",
            ],
            [
                   "AccessoryAggregationKey",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "",
                   "`AccessoryAggregationKey` provides dedicated access to Accessories related attributes.",
            ],
            [
                   "`AccessoryAggregationKey` provides dedicated access to Accessories related attributes.",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "",
                   "",
            ],
            [
                   "LidarKey",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "",
                   "`LidarKey` provides dedicated access to the lidar attributes.",
            ],
            [
                   "`LidarKey` provides dedicated access to the lidar attributes.",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "",
                   "",
            ],
            [
                   "BaseStationKey",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "",
                   "`BaseStationKey` provides dedicated access to the base station attributes.",
            ],
            [
                   "`BaseStationKey` provides dedicated access to the base station attributes.",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "",
                   "",
            ],
            [
                   "create",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#DJIRTKBaseStationKey_create_inline",
                   "Creates an BaseStation key.  @param paramKey A valid paramKey.  @return BaseStation key.",
            ],
            [
                   "Creates an BaseStation key.  @param paramKey A valid paramKey.  @return BaseStation key.",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#DJIRTKBaseStationKey_create_inline",
                   "",
            ],
            [
                   "DiagnosticsKey",
                   2,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "",
                   "`DiagnosticsKey` provides various diagnostics information.",
            ],
            [
                   "`DiagnosticsKey` provides various diagnostics information.",
                   1,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "",
                   "",
            ],
            [
                   "GetCallback",
                   2,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "",
                   "Callback called when performing a get on a key.",
            ],
            [
                   "Callback called when performing a get on a key.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "#DJIKeyManager_GetCallback_Interface_onSuccess_inline",
                   "Invoked when getting process is done successfully.  @param value The value returned back.",
            ],
            [
                   "Invoked when getting process is done successfully.  @param value The value returned back.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "#DJIKeyManager_GetCallback_Interface_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "#DJIKeyManager_GetCallback_Interface_onFailure_inline",
                   "Invoked when getting process has failed.  @param error The error that occurred.",
            ],
            [
                   "Invoked when getting process has failed.  @param error The error that occurred.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_GetCallback_Interface.html",
                   "#DJIKeyManager_GetCallback_Interface_onFailure_inline",
                   "",
            ],
            [
                   "SetCallback",
                   2,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "",
                   "Callback called when performing a set on a key.",
            ],
            [
                   "Callback called when performing a set on a key.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "#DJIKeyManager_SetCallback_Interface_onSuccess_inline",
                   "Invoked when setting process is done successfully.",
            ],
            [
                   "Invoked when setting process is done successfully.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "#DJIKeyManager_SetCallback_Interface_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "#DJIKeyManager_SetCallback_Interface_onFailure_inline",
                   "Invoked when setting process has failed.  @param error The error that occurred.",
            ],
            [
                   "Invoked when setting process has failed.  @param error The error that occurred.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_SetCallback_Interface.html",
                   "#DJIKeyManager_SetCallback_Interface_onFailure_inline",
                   "",
            ],
            [
                   "ActionCallback",
                   2,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "",
                   "Callback called when performing an action on a key.",
            ],
            [
                   "Callback called when performing an action on a key.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "",
                   "",
            ],
            [
                   "onSuccess",
                   2,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "#DJIKeyManager_ActionCallback_Interface_onSuccess_inline",
                   "Invoked when the action is done successfully.",
            ],
            [
                   "Invoked when the action is done successfully.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "#DJIKeyManager_ActionCallback_Interface_onSuccess_inline",
                   "",
            ],
            [
                   "onFailure",
                   2,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "#DJIKeyManager_ActionCallback_Interface_onFailure_inline",
                   "Invoked when the action has failed.  @param error The error that occurred.",
            ],
            [
                   "Invoked when the action has failed.  @param error The error that occurred.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_ActionCallback_Interface.html",
                   "#DJIKeyManager_ActionCallback_Interface_onFailure_inline",
                   "",
            ],
            [
                   "KeyListener",
                   2,
                   "/Components/KeyManager/DJIKeyManager_DJIKeyedListenerUpdateBlock.html",
                   "",
                   "Interface to check if the value behind a key is updated.",
            ],
            [
                   "Interface to check if the value behind a key is updated.",
                   1,
                   "/Components/KeyManager/DJIKeyManager_DJIKeyedListenerUpdateBlock.html",
                   "",
                   "",
            ],
            [
                   "IS_EXT_VIDEO_INPUT_PORT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_ext_video_input_port_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_ext_video_input_port_enabled_key",
                   "",
            ],
            [
                   "UPLINK_SIGNAL_QUALITY",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_uplink_signal_quality_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_uplink_signal_quality_key",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_PRIMARY_VIDEO",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_primary_video_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_primary_video_key",
                   "",
            ],
            [
                   "CHANNEL_RANGE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_range_key",
                   "",
            ],
            [
                   "PASSWORD",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_password_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_password_key",
                   "",
            ],
            [
                   "DISABLED_IMAGE_TRANSMISSION",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_disabled_image_transmission_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_disabled_image_transmission_key",
                   "",
            ],
            [
                   "OCUSYNC_FREQUENCY_BAND",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_frequency_band_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_frequency_band_key",
                   "",
            ],
            [
                   "EID_BROADCAST_ENABLE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_eid_broadcast_enable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_eid_broadcast_enable_key",
                   "",
            ],
            [
                   "CHANNEL_INTERFERENCE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_interference_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_interference_key",
                   "",
            ],
            [
                   "SSID",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ssid_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ssid_key",
                   "",
            ],
            [
                   "WARNING_MESSAGES",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_warning_messages_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_warning_messages_key",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_LEFT_CAMERA",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_left_camera_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_left_camera_key",
                   "",
            ],
            [
                   "OTHER_ROLE_VIDEO_CAMERAS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_other_role_video_cameras_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_other_role_video_cameras_key",
                   "",
            ],
            [
                   "OCUSYNC_VIDEO_CAMERAS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_video_cameras_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_video_cameras_key",
                   "",
            ],
            [
                   "AVAILABLE_CHANNEL_NUMBERS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_available_channel_numbers_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_available_channel_numbers_key",
                   "",
            ],
            [
                   "LB_DATA_RATE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_data_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_data_rate_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_ANTENNA_RSSI",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_remote_controller_antenna_rssi_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_remote_controller_antenna_rssi_key",
                   "",
            ],
            [
                   "FREQUENCY_POINT_RSSIS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_rssis_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_rssis_key",
                   "",
            ],
            [
                   "ASSIGN_SOURCE_TO_PRIMARY_CHANNEL",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_assign_source_to_primary_channel_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_assign_source_to_primary_channel_key",
                   "",
            ],
            [
                   "AIRCRAFT_ANTENNA_RSSI",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_aircraft_antenna_rssi_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_aircraft_antenna_rssi_key",
                   "",
            ],
            [
                   "LEFT_CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_left_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_left_camera_type_key",
                   "",
            ],
            [
                   "LB_CHANNEL",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_channel_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_channel_key",
                   "",
            ],
            [
                   "WIFI_FREQUENCY_BAND",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_wifi_frequency_band_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_wifi_frequency_band_key",
                   "",
            ],
            [
                   "MAGNETIC_INTERFERENCE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_magnetic_interference_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_magnetic_interference_key",
                   "",
            ],
            [
                   "RIGHT_CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_right_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_right_camera_type_key",
                   "",
            ],
            [
                   "DOWNLINK_SIGNAL_QUALITY",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_downlink_signal_quality_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_downlink_signal_quality_key",
                   "",
            ],
            [
                   "REBOOT",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_reboot_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_reboot_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_FEED_PHYSICAL_SOURCE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_secondary_video_feed_physical_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_secondary_video_feed_physical_source_key",
                   "",
            ],
            [
                   "MASTER_LIVE_VIDEO_CAMERA",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_master_live_video_camera_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_master_live_video_camera_key",
                   "",
            ],
            [
                   "OCUSYNC_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_supported_frequency_bands_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_ocusync_supported_frequency_bands_key",
                   "",
            ],
            [
                   "SDR_INTERFERENCE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_sdr_interference_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_sdr_interference_key",
                   "",
            ],
            [
                   "PRIMARY_VIDEO_PRIORITY",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_primary_video_priority_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_primary_video_priority_key",
                   "",
            ],
            [
                   "HD_OFFSET_PARAM_VALUES",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_hd_offset_param_values_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_hd_offset_param_values_key",
                   "",
            ],
            [
                   "PRIMARY_VIDEO_FEED_PHYSICAL_SOURCE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_primary_video_feed_physical_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_primary_video_feed_physical_source_key",
                   "",
            ],
            [
                   "FPV_CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_fpv_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_fpv_camera_type_key",
                   "",
            ],
            [
                   "IS_1_DOT_4_G_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_1_dot_4_g_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_1_dot_4_g_supported_key",
                   "",
            ],
            [
                   "IS_LIGHTBRIDGE_LINK_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_lightbridge_link_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_lightbridge_link_supported_key",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_LB_VIDEO_INPUT_PORT",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_lb_video_input_port_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_lb_video_input_port_key",
                   "",
            ],
            [
                   "LB_FREQUENCY_BAND",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_frequency_band_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_frequency_band_key",
                   "",
            ],
            [
                   "FREQUENCY_POINT_INDEX",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_index_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_index_key",
                   "",
            ],
            [
                   "FREQUENCY_POINT_INDEX_VALID_RANGE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_index_valid_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_frequency_point_index_valid_range_key",
                   "",
            ],
            [
                   "CHANNEL_SELECTION_MODE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_selection_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_selection_mode_key",
                   "",
            ],
            [
                   "TOP_CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_top_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_top_camera_type_key",
                   "",
            ],
            [
                   "DATA_RATE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_data_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_data_rate_key",
                   "",
            ],
            [
                   "LB_SUPPORTED_FREQUENCY_BANDS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_supported_frequency_bands_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_lb_supported_frequency_bands_key",
                   "",
            ],
            [
                   "TRANSMISSION_MODE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_transmission_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_transmission_mode_key",
                   "",
            ],
            [
                   "IS_DUAL_BAND_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_dual_band_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_dual_band_supported_key",
                   "",
            ],
            [
                   "HD_DIST_OFFSET",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_hd_dist_offset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_hd_dist_offset_key",
                   "",
            ],
            [
                   "DYNAMIC_DATA_RATE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_dynamic_data_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_dynamic_data_rate_key",
                   "",
            ],
            [
                   "COUNTRY_CODE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_country_code_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_country_code_key",
                   "",
            ],
            [
                   "BANDWIDTH_ALLOCATION_FOR_HDMI_VIDEO_INPUT_PORT",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_hdmi_video_input_port_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_allocation_for_hdmi_video_input_port_key",
                   "",
            ],
            [
                   "IS_5_DOT_7_G_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_5_dot_7_g_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_5_dot_7_g_supported_key",
                   "",
            ],
            [
                   "SELECTION_MODE",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_selection_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_selection_mode_key",
                   "",
            ],
            [
                   "CHANNEL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_channel_number_key",
                   "",
            ],
            [
                   "IS_WIFI_LINK_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_wifi_link_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_is_wifi_link_supported_key",
                   "",
            ],
            [
                   "AVAILABLE_CAMERA_VIDEO_STREAMS",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_available_camera_video_streams_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_available_camera_video_streams_key",
                   "",
            ],
            [
                   "BANDWIDTH",
                   2,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAirLinkKey.html",
                   "#airlinkkey_bandwidth_key",
                   "",
            ],
            [
                   "YAW_RIGHT_ENDPOINT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_right_endpoint_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_right_endpoint_key",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_smoothing_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_smoothing_factor_key",
                   "",
            ],
            [
                   "START_BALANCE_DETECTION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_balance_detection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_balance_detection_key",
                   "",
            ],
            [
                   "IS_ATTITUDE_RESET",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_attitude_reset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_attitude_reset_key",
                   "",
            ],
            [
                   "FIRMWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_firmware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_firmware_version_key",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_gyro_filtering_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_gyro_filtering_factor_key",
                   "",
            ],
            [
                   "ROTATE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_rotate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_rotate_key",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_pre_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_pre_control_key",
                   "",
            ],
            [
                   "BALANCE_STATE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_balance_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_balance_state_key",
                   "",
            ],
            [
                   "IS_CALIBRATING",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_calibrating_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_calibrating_key",
                   "",
            ],
            [
                   "MOTOR_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_motor_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_motor_enabled_key",
                   "",
            ],
            [
                   "YAW_ANGLE_WITH_AIRCRAFT_IN_DEGREE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_angle_with_aircraft_in_degree_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_angle_with_aircraft_in_degree_key",
                   "",
            ],
            [
                   "APPLY_MOTOR_CONTROL_PRESET",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_apply_motor_control_preset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_apply_motor_control_preset_key",
                   "",
            ],
            [
                   "CONCENTRICITY_CHECK_RESULT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_concentricity_check_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_concentricity_check_result_key",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_deadband_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_deadband_key",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_enabled_key",
                   "",
            ],
            [
                   "IS_MOTOR_OVER_LOADED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_motor_over_loaded_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_motor_over_loaded_key",
                   "",
            ],
            [
                   "IS_GIMBAL_ON_TOP",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_gimbal_on_top_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_gimbal_on_top_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_serial_number_key",
                   "",
            ],
            [
                   "FINE_TUNE_ROLL_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_roll_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_roll_in_degrees_key",
                   "",
            ],
            [
                   "START_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_calibration_key",
                   "",
            ],
            [
                   "IS_YAW_AT_STOP",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_yaw_at_stop_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_yaw_at_stop_key",
                   "",
            ],
            [
                   "TOGGLE_SELFIE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_toggle_selfie_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_toggle_selfie_key",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_pre_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_pre_control_key",
                   "",
            ],
            [
                   "PITCH_DOWN_ENDPOINT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_down_endpoint_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_down_endpoint_key",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_gyro_filtering_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_gyro_filtering_factor_key",
                   "",
            ],
            [
                   "MODE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_mode_key",
                   "",
            ],
            [
                   "IS_TESTING_BALANCE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_testing_balance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_testing_balance_key",
                   "",
            ],
            [
                   "YAW_CONTROLLER_DEADBAND",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_deadband_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_deadband_key",
                   "",
            ],
            [
                   "YAW_LEFT_ENDPOINT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_left_endpoint_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_left_endpoint_key",
                   "",
            ],
            [
                   "CAPABILITIES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_capabilities_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_capabilities_key",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SMOOTHING_FACTOR",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_smoothing_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_smoothing_factor_key",
                   "",
            ],
            [
                   "STIFFNESS_SELF_TUNING_RESULT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stiffness_self_tuning_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stiffness_self_tuning_result_key",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_stiffness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_stiffness_key",
                   "",
            ],
            [
                   "CONNECTION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_connection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_connection_key",
                   "",
            ],
            [
                   "MOVEMENT_SETTINGS_PROFILE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_movement_settings_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_movement_settings_profile_key",
                   "",
            ],
            [
                   "ROLL_FINE_TUNE_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_fine_tune_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_fine_tune_in_degrees_key",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_strength_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_strength_key",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_speed_key",
                   "",
            ],
            [
                   "CALIBRATION_PROGRESS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_calibration_progress_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_calibration_progress_key",
                   "",
            ],
            [
                   "START_CONTROL_PARAMETERS_AUTO_TUNING",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_control_parameters_auto_tuning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_control_parameters_auto_tuning_key",
                   "",
            ],
            [
                   "YAW_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_inverted_control_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_inverted_control_enabled_key",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_PRE_CONTROL",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_pre_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_pre_control_key",
                   "",
            ],
            [
                   "ROLL_TEST_RESULT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_test_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_test_result_key",
                   "",
            ],
            [
                   "IS_STUCK",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_stuck_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_stuck_key",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_DEADBAND",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_deadband_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_deadband_key",
                   "",
            ],
            [
                   "GIMBAL_ATTITUDE_SYNCHRONIZATION_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_gimbal_attitude_synchronization_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_gimbal_attitude_synchronization_enabled_key",
                   "",
            ],
            [
                   "FINE_TUNE_PITCH_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_pitch_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_pitch_in_degrees_key",
                   "",
            ],
            [
                   "PITCH_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_speed_coefficient_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_controller_speed_coefficient_key",
                   "",
            ],
            [
                   "RESET_GIMBAL_WITH_PARAMETERS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_with_parameters_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_with_parameters_key",
                   "",
            ],
            [
                   "START_CONCENTRICITY_DETECTION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_concentricity_detection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_concentricity_detection_key",
                   "",
            ],
            [
                   "START_BALANCE_TEST",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_balance_test_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_start_balance_test_key",
                   "",
            ],
            [
                   "CONTROLLER_MODE",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_controller_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_controller_mode_key",
                   "",
            ],
            [
                   "PITCH_RANGE_EXTENSION_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_range_extension_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_range_extension_enabled_key",
                   "",
            ],
            [
                   "IS_ROLL_AT_STOP",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_roll_at_stop_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_roll_at_stop_key",
                   "",
            ],
            [
                   "BALANCE_CHECK_RESULT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_balance_check_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_balance_check_result_key",
                   "",
            ],
            [
                   "RESET_GIMBAL_YAW",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_yaw_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_yaw_key",
                   "",
            ],
            [
                   "IS_PITCH_AT_STOP",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_pitch_at_stop_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_pitch_at_stop_key",
                   "",
            ],
            [
                   "DISPLAY_NAME",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_display_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_display_name_key",
                   "",
            ],
            [
                   "FINE_TUNE_YAW_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_yaw_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_fine_tune_yaw_in_degrees_key",
                   "",
            ],
            [
                   "PITCH_UP_ENDPOINT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_up_endpoint_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_up_endpoint_key",
                   "",
            ],
            [
                   "STOP_BALANCE_DETECTION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_balance_detection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_balance_detection_key",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_GYRO_FILTERING_FACTOR",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_gyro_filtering_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_gyro_filtering_factor_key",
                   "",
            ],
            [
                   "ROLL_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_strength_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_roll_motor_control_strength_key",
                   "",
            ],
            [
                   "PITCH_FINE_TUNE_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_fine_tune_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_fine_tune_in_degrees_key",
                   "",
            ],
            [
                   "PITCH_INVERTED_CONTROL_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_inverted_control_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_inverted_control_enabled_key",
                   "",
            ],
            [
                   "STOP_CONTROL_PARAMETERS_AUTO_TUNING",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_control_parameters_auto_tuning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_control_parameters_auto_tuning_key",
                   "",
            ],
            [
                   "PITCH_TEST_RESULT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_test_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_test_result_key",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_DEADBAND",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_deadband_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_deadband_key",
                   "",
            ],
            [
                   "YAW_FINE_TUNE_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_fine_tune_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_fine_tune_in_degrees_key",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STRENGTH",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_strength_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_strength_key",
                   "",
            ],
            [
                   "IS_MOBILE_DEVICE_MOUNTED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_mobile_device_mounted_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_mobile_device_mounted_key",
                   "",
            ],
            [
                   "RESET_GIMBAL",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_gimbal_key",
                   "",
            ],
            [
                   "YAW_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_stiffness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_motor_control_stiffness_key",
                   "",
            ],
            [
                   "YAW_CONTROLLER_SPEED_COEFFICIENT",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_speed_coefficient_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_controller_speed_coefficient_key",
                   "",
            ],
            [
                   "YAW_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_acceleration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_smooth_track_acceleration_key",
                   "",
            ],
            [
                   "IS_CALIBRATION_SUCCESSFUL",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_calibration_successful_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_is_calibration_successful_key",
                   "",
            ],
            [
                   "RESTORE_FACTORY_SETTINGS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_restore_factory_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_restore_factory_settings_key",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_enabled_key",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_SPEED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_speed_key",
                   "",
            ],
            [
                   "STOP_CONCENTRICITY_DETECTION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_concentricity_detection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_stop_concentricity_detection_key",
                   "",
            ],
            [
                   "ATTITUDE_IN_DEGREES",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_attitude_in_degrees_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_attitude_in_degrees_key",
                   "",
            ],
            [
                   "YAW_SIMULTANEOUS_FOLLOW_ENABLED",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_simultaneous_follow_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_yaw_simultaneous_follow_enabled_key",
                   "",
            ],
            [
                   "PITCH_SMOOTH_TRACK_ACCELERATION",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_acceleration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_smooth_track_acceleration_key",
                   "",
            ],
            [
                   "RESET_CONTROL_PARAMETERS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_control_parameters_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_reset_control_parameters_key",
                   "",
            ],
            [
                   "PITCH_MOTOR_CONTROL_STIFFNESS",
                   2,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_stiffness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIGimbalKey.html",
                   "#gimbalkey_pitch_motor_control_stiffness_key",
                   "",
            ],
            [
                   "SYSTEM_STATUS",
                   2,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "#diagnosticskey_system_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIDiagnosticsKey.html",
                   "#diagnosticskey_system_status_key",
                   "",
            ],
            [
                   "RADAR_OBSTACLE_AVOIDANCE_STATE",
                   2,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_obstacle_avoidance_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_obstacle_avoidance_state_key",
                   "",
            ],
            [
                   "CONNECTION",
                   2,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_connection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_connection_key",
                   "",
            ],
            [
                   "RADAR_UPWARDS_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_upwards_obstacle_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_upwards_obstacle_avoidance_enabled_key",
                   "",
            ],
            [
                   "RADAR_HORIZONTAL_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_horizontal_obstacle_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRadarKey.html",
                   "#radarkey_radar_horizontal_obstacle_avoidance_enabled_key",
                   "",
            ],
            [
                   "COMPONENT_KEY",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_component_key_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_component_key_key",
                   "",
            ],
            [
                   "MODEL_NAME",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_model_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_model_name_key",
                   "",
            ],
            [
                   "FIRMWARE_PACKAGE_VERSION",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_firmware_package_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_firmware_package_version_key",
                   "",
            ],
            [
                   "HAS_REMOTE_CONTROLLER",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_has_remote_controller_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_has_remote_controller_key",
                   "",
            ],
            [
                   "CONNECTION",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_connection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_connection_key",
                   "",
            ],
            [
                   "IS_OSMO",
                   2,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_is_osmo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIProductKey.html",
                   "#productkey_is_osmo_key",
                   "",
            ],
            [
                   "SET_MASTER_AUTH_CODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_set_master_auth_code_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_set_master_auth_code_key",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_1",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_1_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_1_key",
                   "",
            ],
            [
                   "MULTI_RC_GIMBALS_CONTROL_AUTH_OWNER",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_gimbals_control_auth_owner_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_gimbals_control_auth_owner_key",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_IS_WORKING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_is_working_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_is_working_key",
                   "",
            ],
            [
                   "SHUTTER_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shutter_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shutter_button_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_B_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_b_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_b_axis_status_key",
                   "",
            ],
            [
                   "IS_MASTER_SLAVE_MODE_V4_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v4_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v4_supported_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_TOP_MARGIN",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_top_margin_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_top_margin_key",
                   "",
            ],
            [
                   "RC_UPGRADE_VOICE_DISABLE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_upgrade_voice_disable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_upgrade_voice_disable_key",
                   "",
            ],
            [
                   "GIMBAL_MAPPING_STYLE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gimbal_mapping_style_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gimbal_mapping_style_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_RIGHT_MARGIN",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_right_margin_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_right_margin_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_D_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_d_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_d_axis_status_key",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_2",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_2_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_2_key",
                   "",
            ],
            [
                   "SECOND_CHARGE_REMAINING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_second_charge_remaining_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_second_charge_remaining_key",
                   "",
            ],
            [
                   "SELECT_BUTTON_PROFILE_GROUP",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_select_button_profile_group_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_select_button_profile_group_key",
                   "",
            ],
            [
                   "AIRCRAFT_MAPPING_STYLE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_aircraft_mapping_style_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_aircraft_mapping_style_key",
                   "",
            ],
            [
                   "SWITCH_RC_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_switch_rc_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_switch_rc_state_key",
                   "",
            ],
            [
                   "RIGHT_STICK_VALUE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_right_stick_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_right_stick_value_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_DISPLAY_MODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_display_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_display_mode_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_UNIT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_unit_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_unit_key",
                   "",
            ],
            [
                   "FETCH_CUSTOMIZED_ACTION_OF_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_fetch_customized_action_of_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_fetch_customized_action_of_button_key",
                   "",
            ],
            [
                   "PIP_POSITION",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pip_position_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pip_position_key",
                   "",
            ],
            [
                   "FIRMWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_firmware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_firmware_version_key",
                   "",
            ],
            [
                   "MASTER_LIST",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_list_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_list_key",
                   "",
            ],
            [
                   "STOP_MULTI_DEVICE_PAIRING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_multi_device_pairing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_multi_device_pairing_key",
                   "",
            ],
            [
                   "PAUSE_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pause_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pause_button_key",
                   "",
            ],
            [
                   "IS_MASTER_SLAVE_MODE_V2_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v2_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v2_supported_key",
                   "",
            ],
            [
                   "GO_HOME_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_go_home_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_go_home_button_key",
                   "",
            ],
            [
                   "MULTI_RC_LOST_NOTICE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_lost_notice_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_lost_notice_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_enabled_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_UNIT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_unit_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_unit_key",
                   "",
            ],
            [
                   "GET_MASTER_AUTH_CODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_get_master_auth_code_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_get_master_auth_code_key",
                   "",
            ],
            [
                   "IS_MASTER_SLAVE_MODE_V3_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v3_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_v3_supported_key",
                   "",
            ],
            [
                   "SHUTTER_BUTTON_BINDING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shutter_button_binding_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shutter_button_binding_enabled_key",
                   "",
            ],
            [
                   "REQUEST_LEGACY_GIMBAL_CONTROL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_request_legacy_gimbal_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_request_legacy_gimbal_control_key",
                   "",
            ],
            [
                   "RIGHT_DIAL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_right_dial_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_right_dial_key",
                   "",
            ],
            [
                   "CUSTOM_GIMBAL_MAPPING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_gimbal_mapping_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_gimbal_mapping_key",
                   "",
            ],
            [
                   "RECORD_BUTTON_BINDING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_record_button_binding_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_record_button_binding_enabled_key",
                   "",
            ],
            [
                   "BUTTON_PROFILE_GROUPS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_profile_groups_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_profile_groups_key",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connect_to_master_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connect_to_master_key",
                   "",
            ],
            [
                   "CONNECTED_MASTER_CREDENTIALS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connected_master_credentials_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connected_master_credentials_key",
                   "",
            ],
            [
                   "FIVE_D_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_five_d_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_five_d_button_key",
                   "",
            ],
            [
                   "SLAVE_REMOTE_CONTROLLER_STICK_MODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_slave_remote_controller_stick_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_slave_remote_controller_stick_mode_key",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_DIRECTION",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_direction_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_direction_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_E_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_e_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_e_axis_status_key",
                   "",
            ],
            [
                   "STOP_MASTER_SEARCHING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_master_searching_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_master_searching_key",
                   "",
            ],
            [
                   "COUNTRY_CODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_country_code_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_country_code_key",
                   "",
            ],
            [
                   "STOP_PAIRING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_pairing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_stop_pairing_key",
                   "",
            ],
            [
                   "MULTI_DEVICES_PAIRING_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_devices_pairing_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_devices_pairing_state_key",
                   "",
            ],
            [
                   "MULTI_RC_RCS_ONLINE_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_rcs_online_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_rcs_online_state_key",
                   "",
            ],
            [
                   "LEFT_STICK_VALUE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_stick_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_stick_value_key",
                   "",
            ],
            [
                   "RC_INDEX",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_index_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_index_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_NUMBER_OF_SEGMENT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_number_of_segment_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_number_of_segment_key",
                   "",
            ],
            [
                   "SLAVE_LIST",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_slave_list_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_slave_list_key",
                   "",
            ],
            [
                   "MULTI_RC_APPS_ONLINE_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_apps_online_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_apps_online_state_key",
                   "",
            ],
            [
                   "CUSTOMIZE_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_customize_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_customize_button_key",
                   "",
            ],
            [
                   "SHAKE_MOTOR",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shake_motor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_shake_motor_key",
                   "",
            ],
            [
                   "BATTERY_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_battery_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_battery_state_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_G_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_g_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_g_axis_status_key",
                   "",
            ],
            [
                   "NAME",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_name_key",
                   "",
            ],
            [
                   "FOCUS_CONTROLLER_CONTROL_TYPE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_control_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_focus_controller_control_type_key",
                   "",
            ],
            [
                   "REMOVE_BUTTON_PROFILE_GROUP",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remove_button_profile_group_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remove_button_profile_group_key",
                   "",
            ],
            [
                   "RECORD_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_record_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_record_button_key",
                   "",
            ],
            [
                   "PAIRING_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pairing_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_pairing_state_key",
                   "",
            ],
            [
                   "MASTER_SEARCHING_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_searching_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_searching_state_key",
                   "",
            ],
            [
                   "IS_FOCUS_CONTROLLER_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_focus_controller_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_focus_controller_supported_key",
                   "",
            ],
            [
                   "RENAME_BUTTON_PROFILE_GROUP",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rename_button_profile_group_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rename_button_profile_group_key",
                   "",
            ],
            [
                   "GIMBAL_CONTROL_SPEED_COEFFICIENT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gimbal_control_speed_coefficient_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gimbal_control_speed_coefficient_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_LEFT_MARGIN",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_left_margin_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_left_margin_key",
                   "",
            ],
            [
                   "GPS_DATA",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gps_data_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_gps_data_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OUTPUT_PORT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_output_port_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_output_port_key",
                   "",
            ],
            [
                   "RESET_BUTTON_CONFIG",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_reset_button_config_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_reset_button_config_key",
                   "",
            ],
            [
                   "MULTI_RC_CONTROL_AUTHORITY_SURPASS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_control_authority_surpass_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_control_authority_surpass_key",
                   "",
            ],
            [
                   "LEFT_DIAL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_dial_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_dial_key",
                   "",
            ],
            [
                   "START_PAIRING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_pairing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_pairing_key",
                   "",
            ],
            [
                   "CUSTOM_BUTTON_TAGS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_tags_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_custom_button_tags_key",
                   "",
            ],
            [
                   "FUNCTION_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_function_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_function_button_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_C_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_c_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_c_axis_status_key",
                   "",
            ],
            [
                   "FLIGHT_MODE_SWITCH_POSITION",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_flight_mode_switch_position_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_flight_mode_switch_position_key",
                   "",
            ],
            [
                   "IS_MASTER_SLAVE_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_master_slave_mode_supported_key",
                   "",
            ],
            [
                   "MULTI_RC_RCS_COUNT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_rcs_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_rcs_count_key",
                   "",
            ],
            [
                   "MASTER_SLAVE_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_slave_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_master_slave_state_key",
                   "",
            ],
            [
                   "MULTI_RC_APPS_COUNT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_apps_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_multi_rc_apps_count_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OSD_BOTTOM_MARGIN",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_bottom_margin_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_osd_bottom_margin_key",
                   "",
            ],
            [
                   "AIRCRAFT_CUSTOM_MAPPING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_aircraft_custom_mapping_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_aircraft_custom_mapping_key",
                   "",
            ],
            [
                   "BUTTON_CONFIG",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_config_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_config_key",
                   "",
            ],
            [
                   "RC_MASTER_SLAVE_OPEN",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_master_slave_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_master_slave_open_key",
                   "",
            ],
            [
                   "START_SEARCH_MASTER",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_search_master_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_search_master_key",
                   "",
            ],
            [
                   "AVAILABLE_MASTERS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_available_masters_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_available_masters_key",
                   "",
            ],
            [
                   "CALIBRATION_STATE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_calibration_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_calibration_state_key",
                   "",
            ],
            [
                   "RC_HAS_GIMBAL_CONTROL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_has_gimbal_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rc_has_gimbal_control_key",
                   "",
            ],
            [
                   "SDI_OUTPUT_FORMAT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_sdi_output_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_sdi_output_format_key",
                   "",
            ],
            [
                   "HDMI_OUTPUT_FORMAT",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_hdmi_output_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_hdmi_output_format_key",
                   "",
            ],
            [
                   "REQUEST_GIMBAL_CONTROL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_request_gimbal_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_request_gimbal_control_key",
                   "",
            ],
            [
                   "SECONDARY_VIDEO_OUTPUT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_output_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_secondary_video_output_enabled_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_A_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_a_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_a_axis_status_key",
                   "",
            ],
            [
                   "START_MULTI_DEVICE_PAIRING",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_multi_device_pairing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_start_multi_device_pairing_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_serial_number_key",
                   "",
            ],
            [
                   "PLAYBACK_BUTTON",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_playback_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_playback_button_key",
                   "",
            ],
            [
                   "IS_CHARGE_REMAINING_LOW",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_charge_remaining_low_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_is_charge_remaining_low_key",
                   "",
            ],
            [
                   "RTK_CHANNEL_ENABLE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rtk_channel_enable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_rtk_channel_enable_key",
                   "",
            ],
            [
                   "RESPONSE_TO_REQUEST_FOR_GIMBAL_CONTROL",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_response_to_request_for_gimbal_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_response_to_request_for_gimbal_control_key",
                   "",
            ],
            [
                   "MODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_mode_key",
                   "",
            ],
            [
                   "DISPLAY_NAME",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_display_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_display_name_key",
                   "",
            ],
            [
                   "ADD_BUTTON_PROFILE_GROUP",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_add_button_profile_group_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_add_button_profile_group_key",
                   "",
            ],
            [
                   "BUTTON_EVENT_OF_PROFESSIONAL_RC",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_event_of_professional_rc_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_button_event_of_professional_rc_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_H_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_h_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_h_axis_status_key",
                   "",
            ],
            [
                   "CONNECT_TO_MASTER_WITH_ID",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connect_to_master_with_id_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_connect_to_master_with_id_key",
                   "",
            ],
            [
                   "REMOTE_CONTROLLER_CALIBRATION_F_AXIS_STATUS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_f_axis_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_remote_controller_calibration_f_axis_status_key",
                   "",
            ],
            [
                   "PASSWORD",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_password_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_password_key",
                   "",
            ],
            [
                   "SELECT_BUTTON_PROFILE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_select_button_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_select_button_profile_key",
                   "",
            ],
            [
                   "TRANSFORMATION_SWITCH",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_transformation_switch_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_transformation_switch_key",
                   "",
            ],
            [
                   "LEFT_DIAL_GIMBAL_CONTROL_AXIS",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_dial_gimbal_control_axis_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_left_dial_gimbal_control_axis_key",
                   "",
            ],
            [
                   "CHARGE_MOBILE_MODE",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_charge_mobile_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_charge_mobile_mode_key",
                   "",
            ],
            [
                   "CONTROLLING_GIMBAL_INDEX",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_controlling_gimbal_index_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_controlling_gimbal_index_key",
                   "",
            ],
            [
                   "HDMI_SYSTEM_SETTING_OUTPUT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_hdmi_system_setting_output_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRemoteControllerKey.html",
                   "#remotecontrollerkey_hdmi_system_setting_output_enabled_key",
                   "",
            ],
            [
                   "CONFIG_INTERFACE_PAYLOAD_WIDGETS",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_config_interface_payload_widgets_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_config_interface_payload_widgets_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_serial_number_key",
                   "",
            ],
            [
                   "PAYLOAD_MODEL",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_model_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_model_key",
                   "",
            ],
            [
                   "FIRMWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_firmware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_firmware_version_key",
                   "",
            ],
            [
                   "SEND_DATA_TO_PAYLOAD",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_send_data_to_payload_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_send_data_to_payload_key",
                   "",
            ],
            [
                   "IS_ACCESSORY_CONNECT",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_accessory_connect_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_accessory_connect_key",
                   "",
            ],
            [
                   "CONNECTION",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_connection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_connection_key",
                   "",
            ],
            [
                   "PAYLOAD_WIDGETS_LIST_INFO",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_widgets_list_info_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_widgets_list_info_key",
                   "",
            ],
            [
                   "GET_INPUT_TEXT_PARAM",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_input_text_param_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_input_text_param_key",
                   "",
            ],
            [
                   "GET_PAYLOAD_CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_payload_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_payload_camera_type_key",
                   "",
            ],
            [
                   "IS_PAYLOAD_SDK_READY",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_payload_sdk_ready_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_payload_sdk_ready_key",
                   "",
            ],
            [
                   "GET_WIDGET",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_widget_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_widget_key",
                   "",
            ],
            [
                   "GET_DATA_FROM_PAYLOAD",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_data_from_payload_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_data_from_payload_key",
                   "",
            ],
            [
                   "GET_UPSTREAM_BANDWIDTH",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_upstream_bandwidth_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_get_upstream_bandwidth_key",
                   "",
            ],
            [
                   "PAYLOAD_DEVICE_TYPE",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_device_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_device_type_key",
                   "",
            ],
            [
                   "CONFIGURE_WIDGET_VALUE",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_configure_widget_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_configure_widget_value_key",
                   "",
            ],
            [
                   "MAIN_INTERFACE_PAYLOAD_WIDGETS",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_main_interface_payload_widgets_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_main_interface_payload_widgets_key",
                   "",
            ],
            [
                   "IS_DJI_VIDEO_STREAMING_CHANNEL_AVAILABLE",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_dji_video_streaming_channel_available_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_is_dji_video_streaming_channel_available_key",
                   "",
            ],
            [
                   "PAYLOAD_PRODUCT_NAME",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_product_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_payload_product_name_key",
                   "",
            ],
            [
                   "HINT_MESSAGE",
                   2,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_hint_message_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIPayloadKey.html",
                   "#payloadkey_hint_message_key",
                   "",
            ],
            [
                   "LOG_IN_AS_DEVICE_ADMIN",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_log_in_as_device_admin_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_log_in_as_device_admin_key",
                   "",
            ],
            [
                   "LOG_OUT",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_log_out_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_log_out_key",
                   "",
            ],
            [
                   "HAS_DEVICE_ADMIN_LOGGED_IN",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_has_device_admin_logged_in_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_has_device_admin_logged_in_key",
                   "",
            ],
            [
                   "BASE_STATION_STATE",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_state_key",
                   "",
            ],
            [
                   "NAME",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_name_key",
                   "",
            ],
            [
                   "CHANGE_PASSWORD",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_change_password_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_change_password_key",
                   "",
            ],
            [
                   "BASE_STATION_REFERENCING_LOCATION",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_referencing_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_referencing_location_key",
                   "",
            ],
            [
                   "RESET_BASE_STATION_REFERENCING_LOCATION",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_reset_base_station_referencing_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_reset_base_station_referencing_location_key",
                   "",
            ],
            [
                   "BASE_STATION_BATTERY_STATE",
                   2,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_battery_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIRTKBaseStationKey.html",
                   "#basestationkey_base_station_battery_state_key",
                   "",
            ],
            [
                   "SPOTLIGHT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_enabled_key",
                   "",
            ],
            [
                   "SPOTLIGHT_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_temperature_key",
                   "",
            ],
            [
                   "PLAY_MODE",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_play_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_play_mode_key",
                   "",
            ],
            [
                   "STOP",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_stop_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_stop_key",
                   "",
            ],
            [
                   "REMAINING_SPACE",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_remaining_space_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_remaining_space_key",
                   "",
            ],
            [
                   "SPEAKER_VOLUME",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_speaker_volume_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_speaker_volume_key",
                   "",
            ],
            [
                   "TOTAL_SPACE",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_total_space_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_total_space_key",
                   "",
            ],
            [
                   "SPEAKER_STATE",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_speaker_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_speaker_state_key",
                   "",
            ],
            [
                   "BEACON_ENABLED",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_beacon_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_beacon_enabled_key",
                   "",
            ],
            [
                   "SPOTLIGHT_BRIGHTNESS",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_brightness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_spotlight_brightness_key",
                   "",
            ],
            [
                   "PLAY",
                   2,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_play_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIAccessoryKey.html",
                   "#accessoryaggregationkey_play_key",
                   "",
            ],
            [
                   "SELF_DISCHARGE_IN_DAYS",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_self_discharge_in_days_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_self_discharge_in_days_key",
                   "",
            ],
            [
                   "BATTERY_TYPE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_type_key",
                   "",
            ],
            [
                   "OVERVIEWS",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_overviews_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_overviews_key",
                   "",
            ],
            [
                   "SELF_HEATING_STATE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_self_heating_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_self_heating_state_key",
                   "",
            ],
            [
                   "AGGREGATION_STATE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_aggregation_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_aggregation_state_key",
                   "",
            ],
            [
                   "BATTERY_LEDS_ENABLED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_leds_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_leds_enabled_key",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_2_cell_voltage_behavior_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_2_cell_voltage_behavior_key",
                   "",
            ],
            [
                   "LEVEL_2_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_2_cell_voltage_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_2_cell_voltage_threshold_key",
                   "",
            ],
            [
                   "FIRMWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_firmware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_firmware_version_key",
                   "",
            ],
            [
                   "IS_BATTERY_SELF_HEATING",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_battery_self_heating_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_battery_self_heating_key",
                   "",
            ],
            [
                   "CURRENT",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_current_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_current_key",
                   "",
            ],
            [
                   "DESIGN_CAPACITY",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_design_capacity_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_design_capacity_key",
                   "",
            ],
            [
                   "IS_CELL_DAMAGED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_cell_damaged_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_cell_damaged_key",
                   "",
            ],
            [
                   "IS_FIRMWARE_DIFFERENCE_DETECTED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_firmware_difference_detected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_firmware_difference_detected_key",
                   "",
            ],
            [
                   "IS_LOW_CELL_VOLTAGE_DETECTED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_low_cell_voltage_detected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_low_cell_voltage_detected_key",
                   "",
            ],
            [
                   "CHARGE_REMAINING",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_charge_remaining_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_charge_remaining_key",
                   "",
            ],
            [
                   "CHARGE_REMAINING_IN_PERCENT",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_charge_remaining_in_percent_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_charge_remaining_in_percent_key",
                   "",
            ],
            [
                   "HISTORICAL_WARNING_RECORDS",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_historical_warning_records_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_historical_warning_records_key",
                   "",
            ],
            [
                   "LATEST_WARNING_RECORD",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_latest_warning_record_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_latest_warning_record_key",
                   "",
            ],
            [
                   "MANUFACTURE_DATE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_manufacture_date_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_manufacture_date_key",
                   "",
            ],
            [
                   "PAIR_BATTERIES",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_pair_batteries_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_pair_batteries_key",
                   "",
            ],
            [
                   "IS_IN_SINGLE_BATTERY_MODE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_in_single_battery_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_in_single_battery_mode_key",
                   "",
            ],
            [
                   "NUMBER_OF_DISCHARGES",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_discharges_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_discharges_key",
                   "",
            ],
            [
                   "CELL_VOLTAGES",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_cell_voltages_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_cell_voltages_key",
                   "",
            ],
            [
                   "TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_temperature_key",
                   "",
            ],
            [
                   "VOLTAGE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_voltage_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_voltage_key",
                   "",
            ],
            [
                   "PAIRING_STATE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_pairing_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_pairing_state_key",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_BEHAVIOR",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_1_cell_voltage_behavior_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_1_cell_voltage_behavior_key",
                   "",
            ],
            [
                   "CELL_VOLTAGE_LEVEL",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_cell_voltage_level_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_cell_voltage_level_key",
                   "",
            ],
            [
                   "IS_BIG_BATTERY",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_big_battery_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_big_battery_key",
                   "",
            ],
            [
                   "CONNECTION_STATE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_connection_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_connection_state_key",
                   "",
            ],
            [
                   "NUMBER_OF_CONNECTED_BATTERIES",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_connected_batteries_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_connected_batteries_key",
                   "",
            ],
            [
                   "FULL_CHARGE_CAPACITY",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_full_charge_capacity_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_full_charge_capacity_key",
                   "",
            ],
            [
                   "BATTERY_EMBED_OK",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_embed_ok_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_battery_embed_ok_key",
                   "",
            ],
            [
                   "IS_SMART_BATTERY",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_smart_battery_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_smart_battery_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_serial_number_key",
                   "",
            ],
            [
                   "NUMBER_OF_CELLS",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_cells_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_number_of_cells_key",
                   "",
            ],
            [
                   "LIFETIME_REMAINING",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_lifetime_remaining_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_lifetime_remaining_key",
                   "",
            ],
            [
                   "HIGHEST_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_highest_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_highest_temperature_key",
                   "",
            ],
            [
                   "LEVEL_1_CELL_VOLTAGE_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_1_cell_voltage_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_level_1_cell_voltage_threshold_key",
                   "",
            ],
            [
                   "IS_BEING_CHARGED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_being_charged_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_being_charged_key",
                   "",
            ],
            [
                   "IS_ANY_BATTERY_DISCONNECTED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_any_battery_disconnected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_any_battery_disconnected_key",
                   "",
            ],
            [
                   "IS_VOLTAGE_DIFFERENCE_DETECTED",
                   2,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_voltage_difference_detected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIBatteryKey.html",
                   "#batterykey_is_voltage_difference_detected_key",
                   "",
            ],
            [
                   "THERMAL_MEASUREMENT_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_measurement_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_measurement_mode_key",
                   "",
            ],
            [
                   "START_RECORD_VIDEO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_record_video_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_record_video_key",
                   "",
            ],
            [
                   "FORMAT_SD_CARD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_sd_card_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_sd_card_key",
                   "",
            ],
            [
                   "SDCARD_IS_READ_ONLY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_read_only_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_read_only_key",
                   "",
            ],
            [
                   "PHOTO_QUICK_VIEW_DURATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_quick_view_duration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_quick_view_duration_key",
                   "",
            ],
            [
                   "IS_SHOOTING_PANORAMA_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_panorama_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_panorama_photo_key",
                   "",
            ],
            [
                   "SSD_CLIP_FILE_NAME",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_clip_file_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_clip_file_name_key",
                   "",
            ],
            [
                   "RAW_PHOTO_BURST_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_raw_photo_burst_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_raw_photo_burst_count_key",
                   "",
            ],
            [
                   "IS_ADJUSTABLE_APERTURE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_adjustable_aperture_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_adjustable_aperture_supported_key",
                   "",
            ],
            [
                   "CAMERA_STORAGE_LOCATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_storage_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_storage_location_key",
                   "",
            ],
            [
                   "IS_CONTINUOUS_DIGITAL_ZOOM",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_continuous_digital_zoom_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_continuous_digital_zoom_key",
                   "",
            ],
            [
                   "THERMAL_ACE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_ace_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_ace_key",
                   "",
            ],
            [
                   "VIDEO_FILE_COMPRESSION_STANDARD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_compression_standard_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_compression_standard_key",
                   "",
            ],
            [
                   "MSX_LEVEL",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_msx_level_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_msx_level_key",
                   "",
            ],
            [
                   "EXPOSURE_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_state_key",
                   "",
            ],
            [
                   "TAP_ZOOM_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_enabled_key",
                   "",
            ],
            [
                   "SHUTTER_SPEED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shutter_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shutter_speed_key",
                   "",
            ],
            [
                   "SSD_COLOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_color_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_color_key",
                   "",
            ],
            [
                   "TRIGGER_THERMAL_FFC",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_trigger_thermal_ffc_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_trigger_thermal_ffc_key",
                   "",
            ],
            [
                   "HISTOGRAM_LIGHT_VALUES",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_histogram_light_values_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_histogram_light_values_key",
                   "",
            ],
            [
                   "IS_TAP_ZOOM_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_tap_zoom_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_tap_zoom_supported_key",
                   "",
            ],
            [
                   "DISPLAY_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_mode_key",
                   "",
            ],
            [
                   "METERING_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_metering_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_metering_mode_key",
                   "",
            ],
            [
                   "IS_SHOOTING_SINGLE_PHOTO_IN_RAW_FORMAT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_single_photo_in_raw_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_single_photo_in_raw_format_key",
                   "",
            ],
            [
                   "LED_AUTO_TURN_OFF_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_led_auto_turn_off_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_led_auto_turn_off_enabled_key",
                   "",
            ],
            [
                   "SSD_COLOR_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_color_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_color_range_key",
                   "",
            ],
            [
                   "DEMARCATE_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_demarcate_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_demarcate_value_key",
                   "",
            ],
            [
                   "HISTOGRAM_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_histogram_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_histogram_enabled_key",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_MIDDLE_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_middle_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_middle_value_key",
                   "",
            ],
            [
                   "THERMAL_BRIGHTNESS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_brightness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_brightness_key",
                   "",
            ],
            [
                   "THERMAL_BACKGROUND_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_background_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_background_temperature_key",
                   "",
            ],
            [
                   "DEWARPING_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dewarping_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dewarping_enabled_key",
                   "",
            ],
            [
                   "IS_MECHANICAL_SHUTTER_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_mechanical_shutter_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_mechanical_shutter_supported_key",
                   "",
            ],
            [
                   "IS_FORBID_RECORD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_forbid_record_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_forbid_record_key",
                   "",
            ],
            [
                   "SSD_OPERATION_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_operation_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_operation_state_key",
                   "",
            ],
            [
                   "PIP_POSITION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pip_position_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pip_position_key",
                   "",
            ],
            [
                   "INTERVAL_SHOOT_COUNTDOWN",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_interval_shoot_countdown_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_interval_shoot_countdown_key",
                   "",
            ],
            [
                   "ISO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_iso_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_iso_key",
                   "",
            ],
            [
                   "THERMAL_CONTRAST",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_contrast_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_contrast_key",
                   "",
            ],
            [
                   "START_SHOOT_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_shoot_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_shoot_photo_key",
                   "",
            ],
            [
                   "INFRARED_THERMAL_CAMERA_SENSOR_BURNING_PROTECTION_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_infrared_thermal_camera_sensor_burning_protection_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_infrared_thermal_camera_sensor_burning_protection_enabled_key",
                   "",
            ],
            [
                   "LASER_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_enabled_key",
                   "",
            ],
            [
                   "INNERSTORAGE_AVAILABLE_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_available_recording_time_in_seconds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_available_recording_time_in_seconds_key",
                   "",
            ],
            [
                   "IS_SHOOTING_SHALLOW_FOCUS_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_shallow_focus_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_shallow_focus_photo_key",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UPPER_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_upper_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_upper_value_key",
                   "",
            ],
            [
                   "LASER_MEASURE_INFORMATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_measure_information_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_measure_information_key",
                   "",
            ],
            [
                   "SPOT_METERING_COL_NUMS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_col_nums_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_col_nums_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_INITIALIZING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_initializing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_initializing_key",
                   "",
            ],
            [
                   "THERMAL_AREA_TEMPERATURE_AGGREGATIONS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_area_temperature_aggregations_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_area_temperature_aggregations_key",
                   "",
            ],
            [
                   "IS_PHOTO_QUICK_VIEW_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_photo_quick_view_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_photo_quick_view_supported_key",
                   "",
            ],
            [
                   "CAMERA_TYPE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_type_key",
                   "",
            ],
            [
                   "IS_THERMAL_LENS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_thermal_lens_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_thermal_lens_key",
                   "",
            ],
            [
                   "SSD_IS_CONNECTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_is_connected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_is_connected_key",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_compensation_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_compensation_key",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_range_key",
                   "",
            ],
            [
                   "SDCARD_IS_INVALID_FORMAT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_invalid_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_invalid_format_key",
                   "",
            ],
            [
                   "STOP_SHOOT_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_shoot_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_shoot_photo_key",
                   "",
            ],
            [
                   "SUPER_RESOLUTION_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_super_resolution_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_super_resolution_state_key",
                   "",
            ],
            [
                   "MECHANICAL_SHUTTER_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mechanical_shutter_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mechanical_shutter_enabled_key",
                   "",
            ],
            [
                   "STOP_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_continuous_optical_zoom_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_continuous_optical_zoom_key",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_temperature_key",
                   "",
            ],
            [
                   "CAMERA_VIDEO_STREAM_SOURCE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_video_stream_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_video_stream_source_key",
                   "",
            ],
            [
                   "SDCARD_IS_VERIFIED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_verified_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_verified_key",
                   "",
            ],
            [
                   "FLAT_CAMERA_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_key",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_atmospheric_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_atmospheric_temperature_key",
                   "",
            ],
            [
                   "AUDIO_GAIN",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_audio_gain_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_audio_gain_key",
                   "",
            ],
            [
                   "EXPOSURE_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_settings_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_serial_number_key",
                   "",
            ],
            [
                   "PAYLOAD_E1E_SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_payload_e1e_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_payload_e1e_serial_number_key",
                   "",
            ],
            [
                   "APERTURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_aperture_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_aperture_key",
                   "",
            ],
            [
                   "CURRENT_VIDEO_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_video_recording_time_in_seconds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_video_recording_time_in_seconds_key",
                   "",
            ],
            [
                   "THERMAL_ROI",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_roi_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_roi_key",
                   "",
            ],
            [
                   "HYPERLAPSE_ORIGINAL_PHOTO_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hyperlapse_original_photo_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hyperlapse_original_photo_settings_key",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_FOCAL_LENGTH",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_focal_length_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_focal_length_key",
                   "",
            ],
            [
                   "CAMERA_TARGET_FOCAL_LENGTH",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_target_focal_length_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_target_focal_length_key",
                   "",
            ],
            [
                   "SDCARD_IS_REPAIRING_FILES",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_repairing_files_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_repairing_files_key",
                   "",
            ],
            [
                   "SDCARD_IS_WRITE_SLOW",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_write_slow_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_write_slow_key",
                   "",
            ],
            [
                   "STOP_LOG_EXPORT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_log_export_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_log_export_key",
                   "",
            ],
            [
                   "VIDEO_CAPTION_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_caption_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_caption_enabled_key",
                   "",
            ],
            [
                   "EXPOSURE_COMPENSATION_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_compensation_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_compensation_range_key",
                   "",
            ],
            [
                   "IS_SHOOTING_SUPER_RESOLUTION_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_super_resolution_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_super_resolution_photo_key",
                   "",
            ],
            [
                   "CAMERA_MF_DEMARCATE_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_mf_demarcate_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_mf_demarcate_state_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_INVALID_FORMAT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_invalid_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_invalid_format_key",
                   "",
            ],
            [
                   "IS_AFC_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_afc_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_afc_supported_key",
                   "",
            ],
            [
                   "DUAL_FEED_HORIZONTAL_ALIGNMENT_OFFSET_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_horizontal_alignment_offset_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_horizontal_alignment_offset_range_key",
                   "",
            ],
            [
                   "RESOLUTION_FRAME_RATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_resolution_frame_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_resolution_frame_rate_key",
                   "",
            ],
            [
                   "THERMAL_WINDOW_TRANSMISSION_COEFFICIENT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_transmission_coefficient_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_transmission_coefficient_key",
                   "",
            ],
            [
                   "CUSTOM_INFORMATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_information_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_information_key",
                   "",
            ],
            [
                   "ANTI_FLICKER_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_anti_flicker_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_anti_flicker_range_key",
                   "",
            ],
            [
                   "STORAGE_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_storage_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_storage_state_key",
                   "",
            ],
            [
                   "COLOR_WAVEFORM_DISPLAY_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_color_waveform_display_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_color_waveform_display_state_key",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_SPEC",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_spec_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_spec_key",
                   "",
            ],
            [
                   "HAS_ERROR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_has_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_has_error_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_SLOW",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_slow_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_slow_key",
                   "",
            ],
            [
                   "INNERSTORAGE_TOTAL_SPACE_IN_MB",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_total_space_in_mb_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_total_space_in_mb_key",
                   "",
            ],
            [
                   "IS_MULTI_VIDEO_STREAM_SOURCE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_multi_video_stream_source_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_multi_video_stream_source_supported_key",
                   "",
            ],
            [
                   "SSD_VIDEO_RECORDING_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_recording_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_recording_enabled_key",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_reflection_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_reflection_key",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_format_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_format_range_key",
                   "",
            ],
            [
                   "HYBRID_ZOOM_SPEC",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hybrid_zoom_spec_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hybrid_zoom_spec_key",
                   "",
            ],
            [
                   "FOCUS_STATUS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_status_key",
                   "",
            ],
            [
                   "SDCARD_NEEDS_FORMATTING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_needs_formatting_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_needs_formatting_key",
                   "",
            ],
            [
                   "IS_ADJUSTABLE_FOCAL_POINT_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_adjustable_focal_point_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_adjustable_focal_point_supported_key",
                   "",
            ],
            [
                   "IS_SUPER_RESOLUTION_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_super_resolution_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_super_resolution_supported_key",
                   "",
            ],
            [
                   "CAMERA_COLOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_color_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_color_key",
                   "",
            ],
            [
                   "HYPERLAPSE_ORIGINAL_IMAGES_FORMAT_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hyperlapse_original_images_format_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hyperlapse_original_images_format_range_key",
                   "",
            ],
            [
                   "IS_SHOOTING_RAW_BURST_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_raw_burst_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_raw_burst_photo_key",
                   "",
            ],
            [
                   "AUDIO_RECORDING_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_audio_recording_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_audio_recording_enabled_key",
                   "",
            ],
            [
                   "SDCARD_IS_INITIALIZING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_initializing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_initializing_key",
                   "",
            ],
            [
                   "LENS_IS_AF_SWITCH_ON",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_af_switch_on_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_af_switch_on_key",
                   "",
            ],
            [
                   "RC_WHEEL_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_rc_wheel_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_rc_wheel_mode_key",
                   "",
            ],
            [
                   "IS_SHOOTING_BURST_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_burst_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_burst_photo_key",
                   "",
            ],
            [
                   "FOCUS_ASSISTANT_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_assistant_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_assistant_settings_key",
                   "",
            ],
            [
                   "THERMAL_GAIN_MODE_TEMPERATURE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_gain_mode_temperature_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_gain_mode_temperature_range_key",
                   "",
            ],
            [
                   "THERMAL_ATMOSPHERIC_TRANSMISSION_COEFFICIENT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_atmospheric_transmission_coefficient_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_atmospheric_transmission_coefficient_key",
                   "",
            ],
            [
                   "THERMAL_PALETTE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_palette_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_palette_key",
                   "",
            ],
            [
                   "IS_INTERCHANGEABLE_LENS_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_interchangeable_lens_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_interchangeable_lens_supported_key",
                   "",
            ],
            [
                   "IS_SENSOR_CLEANING_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_sensor_cleaning_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_sensor_cleaning_supported_key",
                   "",
            ],
            [
                   "THERMAL_FFC_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_ffc_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_ffc_mode_key",
                   "",
            ],
            [
                   "STOP_RECORD_VIDEO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_record_video_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_record_video_key",
                   "",
            ],
            [
                   "TEMPERATURE_UNIT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_temperature_unit_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_temperature_unit_key",
                   "",
            ],
            [
                   "IS_MEDIA_DOWNLOAD_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_media_download_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_media_download_mode_supported_key",
                   "",
            ],
            [
                   "IS_RECORDING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_recording_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_recording_key",
                   "",
            ],
            [
                   "WHITE_BALANCE_CUSTOM_COLOR_TEMPERATURE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_custom_color_temperature_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_custom_color_temperature_range_key",
                   "",
            ],
            [
                   "SSD_VIDEO_LICENSES",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_licenses_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_licenses_key",
                   "",
            ],
            [
                   "IRC_ENABLE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_irc_enable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_irc_enable_key",
                   "",
            ],
            [
                   "PHOTO_PANORAMA_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_panorama_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_panorama_mode_key",
                   "",
            ],
            [
                   "LAST_CAMERA_VIDEO_STREAM_SOURCE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_last_camera_video_stream_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_last_camera_video_stream_source_key",
                   "",
            ],
            [
                   "MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mode_range_key",
                   "",
            ],
            [
                   "IS_PROCESSING_PANORAMA_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_processing_panorama_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_processing_panorama_photo_key",
                   "",
            ],
            [
                   "IS_VIDEO_PLAYBACK_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_video_playback_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_video_playback_supported_key",
                   "",
            ],
            [
                   "SDCARD_HAS_ERROR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_has_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_has_error_key",
                   "",
            ],
            [
                   "THERMAL_IS_FFC_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_is_ffc_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_is_ffc_mode_supported_key",
                   "",
            ],
            [
                   "START_SENSOR_CLEANING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_sensor_cleaning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_sensor_cleaning_key",
                   "",
            ],
            [
                   "LOG_EXPORT_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_log_export_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_log_export_state_key",
                   "",
            ],
            [
                   "DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_digital_zoom_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_digital_zoom_factor_key",
                   "",
            ],
            [
                   "EXIT_SENSOR_CLEANING_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exit_sensor_cleaning_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exit_sensor_cleaning_mode_key",
                   "",
            ],
            [
                   "IS_SHOOTING_INTERVAL_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_interval_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_interval_photo_key",
                   "",
            ],
            [
                   "LOAD_SETTINGS_FROM_PROFILE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_load_settings_from_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_load_settings_from_profile_key",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aspect_ratio_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aspect_ratio_range_key",
                   "",
            ],
            [
                   "IS_SSD_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_ssd_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_ssd_supported_key",
                   "",
            ],
            [
                   "PHOTO_RAW_BURST_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_raw_burst_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_raw_burst_count_key",
                   "",
            ],
            [
                   "INNERSTORAGE_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_state_key",
                   "",
            ],
            [
                   "SDCARD_AVAILABLE_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_available_recording_time_in_seconds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_available_recording_time_in_seconds_key",
                   "",
            ],
            [
                   "IS_SHOOTING_SINGLE_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_single_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_single_photo_key",
                   "",
            ],
            [
                   "FOCUS_TARGET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_target_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_target_key",
                   "",
            ],
            [
                   "CAMERA_VIDEO_STREAM_SOURCE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_video_stream_source_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_video_stream_source_range_key",
                   "",
            ],
            [
                   "IS_DIGITAL_ZOOM_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_digital_zoom_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_digital_zoom_supported_key",
                   "",
            ],
            [
                   "FOCUS_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_mode_key",
                   "",
            ],
            [
                   "THERMAL_GLOBAL_MIN_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_global_min_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_global_min_temperature_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_FULL",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_full_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_full_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_VERIFIED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_verified_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_verified_key",
                   "",
            ],
            [
                   "EI_VALUE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_value_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_value_range_key",
                   "",
            ],
            [
                   "VIDEO_STANDARD_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_standard_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_standard_range_key",
                   "",
            ],
            [
                   "SDCARD_TOTAL_SPACE_IN_MB",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_total_space_in_mb_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_total_space_in_mb_key",
                   "",
            ],
            [
                   "CLEAR_LOG_EXPORT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_clear_log_export_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_clear_log_export_key",
                   "",
            ],
            [
                   "FORMAT_INTERNAL_STORAGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_internal_storage_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_internal_storage_key",
                   "",
            ],
            [
                   "CAPTURE_CAMERA_STREAM_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_capture_camera_stream_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_capture_camera_stream_settings_key",
                   "",
            ],
            [
                   "SDCARD_IS_FULL",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_full_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_full_key",
                   "",
            ],
            [
                   "CAMERA_COLOR_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_color_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_color_range_key",
                   "",
            ],
            [
                   "PHOTO_TIME_LAPSE_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_time_lapse_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_time_lapse_settings_key",
                   "",
            ],
            [
                   "PHOTO_ASPECT_RATIO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aspect_ratio_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aspect_ratio_key",
                   "",
            ],
            [
                   "EXIT_PLAYBACK",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exit_playback_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exit_playback_key",
                   "",
            ],
            [
                   "WATERMARK_DISPLAY_CONTENT_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_display_content_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_display_content_settings_key",
                   "",
            ],
            [
                   "DISPLAY_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_mode_range_key",
                   "",
            ],
            [
                   "DUAL_FEED_HORIZONTAL_ALIGNMENT_OFFSET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_horizontal_alignment_offset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_horizontal_alignment_offset_key",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_key",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_file_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_file_format_key",
                   "",
            ],
            [
                   "COLOR_WAVEFORM_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_color_waveform_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_color_waveform_enabled_key",
                   "",
            ],
            [
                   "START_RECORD_VIDEO_IN_CACHE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_record_video_in_cache_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_record_video_in_cache_key",
                   "",
            ],
            [
                   "THERMAL_DIGITAL_ZOOM_FACTOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_digital_zoom_factor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_digital_zoom_factor_key",
                   "",
            ],
            [
                   "THERMAL_PALETTE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_palette_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_palette_range_key",
                   "",
            ],
            [
                   "LENS_INFORMATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_information_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_information_key",
                   "",
            ],
            [
                   "INFRARED_THERMAL_CAMERA_SHUTTER_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_infrared_thermal_camera_shutter_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_infrared_thermal_camera_shutter_enabled_key",
                   "",
            ],
            [
                   "THERMAL_METERING_AREA",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_metering_area_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_metering_area_key",
                   "",
            ],
            [
                   "SDCARD_IS_INSERTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_inserted_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_inserted_key",
                   "",
            ],
            [
                   "SDCARD_IS_FILE_INDEX_MAX",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_file_index_max_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_file_index_max_key",
                   "",
            ],
            [
                   "INIT_SENSOR_CLEANING_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_init_sensor_cleaning_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_init_sensor_cleaning_mode_key",
                   "",
            ],
            [
                   "MUTUALLY_EXCLUSIVE_STATUS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mutually_exclusive_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mutually_exclusive_status_key",
                   "",
            ],
            [
                   "CAMERA_START_MF_DEMARCATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_start_mf_demarcate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_start_mf_demarcate_key",
                   "",
            ],
            [
                   "START_LOG_EXPORT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_log_export_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_log_export_key",
                   "",
            ],
            [
                   "IS_PLAYBACK_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_playback_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_playback_supported_key",
                   "",
            ],
            [
                   "SAVE_SETTINGS_TO_PROFILE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_save_settings_to_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_save_settings_to_profile_key",
                   "",
            ],
            [
                   "SPOT_METERING_TARGET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_target_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_target_key",
                   "",
            ],
            [
                   "INNERSTORAGE_HAS_ERROR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_has_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_has_error_key",
                   "",
            ],
            [
                   "SSD_AVAILABLE_RECORDING_TIME_IN_SECONDS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_available_recording_time_in_seconds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_available_recording_time_in_seconds_key",
                   "",
            ],
            [
                   "FIRMWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_firmware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_firmware_version_key",
                   "",
            ],
            [
                   "IS_IN_PLAYBACK_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_in_playback_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_in_playback_mode_key",
                   "",
            ],
            [
                   "APERTURE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_aperture_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_aperture_range_key",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_AND_FRAME_RATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_and_frame_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_and_frame_rate_key",
                   "",
            ],
            [
                   "SHARPNESS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sharpness_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sharpness_key",
                   "",
            ],
            [
                   "SSD_REMAINING_SPACE_IN_MB",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_remaining_space_in_mb_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_remaining_space_in_mb_key",
                   "",
            ],
            [
                   "SDCARD_AVAILABLE_CAPTURE_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_available_capture_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_available_capture_count_key",
                   "",
            ],
            [
                   "THERMAL_PROFILE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_profile_key",
                   "",
            ],
            [
                   "STOP_RECORD_VIDEO_IN_CACHE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_record_video_in_cache_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_stop_record_video_in_cache_key",
                   "",
            ],
            [
                   "EI_COLOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_color_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_color_key",
                   "",
            ],
            [
                   "ZOOM_BOX_RELATIVE_FOV",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_zoom_box_relative_fov_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_zoom_box_relative_fov_key",
                   "",
            ],
            [
                   "IS_INTERNAL_STORAGE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_internal_storage_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_internal_storage_supported_key",
                   "",
            ],
            [
                   "SDCARD_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_state_key",
                   "",
            ],
            [
                   "IS_SHOOTING_PHOTO_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_photo_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_photo_enabled_key",
                   "",
            ],
            [
                   "ISO_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_iso_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_iso_range_key",
                   "",
            ],
            [
                   "THERMAL_DDE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_dde_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_dde_key",
                   "",
            ],
            [
                   "THERMAL_SCENE_EMISSIVITY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_scene_emissivity_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_scene_emissivity_key",
                   "",
            ],
            [
                   "VIDEO_COMPRESSION_STANDARD_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_compression_standard_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_compression_standard_range_key",
                   "",
            ],
            [
                   "AUTO_AE_UNLOCK_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_auto_ae_unlock_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_auto_ae_unlock_enabled_key",
                   "",
            ],
            [
                   "FOCUS_RING_VALUE_UPPER_BOUND",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_ring_value_upper_bound_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_ring_value_upper_bound_key",
                   "",
            ],
            [
                   "FAST_PLAYBACK_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_fast_playback_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_fast_playback_settings_key",
                   "",
            ],
            [
                   "PANORAMA_CAPTURE_RESULT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_panorama_capture_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_panorama_capture_result_key",
                   "",
            ],
            [
                   "IS_STORING_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_storing_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_storing_photo_key",
                   "",
            ],
            [
                   "RECORD_CAMERA_STREAM_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_record_camera_stream_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_record_camera_stream_settings_key",
                   "",
            ],
            [
                   "IS_AUDIO_RECORDING_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_audio_recording_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_audio_recording_supported_key",
                   "",
            ],
            [
                   "LENS_IS_INSTALLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_installed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_installed_key",
                   "",
            ],
            [
                   "NDFILTER_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ndfilter_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ndfilter_mode_key",
                   "",
            ],
            [
                   "THERMAL_TEMPERATURE_DATA",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_temperature_data_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_temperature_data_key",
                   "",
            ],
            [
                   "PICTURE_STYLE_PRESET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_picture_style_preset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_picture_style_preset_key",
                   "",
            ],
            [
                   "PANO_ORIGINAL_PHOTO_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pano_original_photo_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pano_original_photo_settings_key",
                   "",
            ],
            [
                   "IS_COLOR_WAVEFORM_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_color_waveform_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_color_waveform_supported_key",
                   "",
            ],
            [
                   "PHOTO_FILE_FORMAT_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_file_format_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_file_format_range_key",
                   "",
            ],
            [
                   "WHITE_BALANCE_PRESENT_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_present_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_present_range_key",
                   "",
            ],
            [
                   "CUSTOM_EXPAND_DIRECTORY_NAME_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_expand_directory_name_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_expand_directory_name_settings_key",
                   "",
            ],
            [
                   "IS_LOG_EXPORTING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_log_exporting_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_log_exporting_key",
                   "",
            ],
            [
                   "DUAL_FEED_VERTICAL_ALIGNMENT_OFFSET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_vertical_alignment_offset_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_vertical_alignment_offset_key",
                   "",
            ],
            [
                   "TEMP_ALARM",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_temp_alarm_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_temp_alarm_key",
                   "",
            ],
            [
                   "DISPLAY_NAME",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_display_name_key",
                   "",
            ],
            [
                   "RESTORE_FACTORY_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_restore_factory_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_restore_factory_settings_key",
                   "",
            ],
            [
                   "START_CONTINUOUS_OPTICAL_ZOOM",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_continuous_optical_zoom_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_start_continuous_optical_zoom_key",
                   "",
            ],
            [
                   "LENS_IS_FOCUS_ASSISTANT_WORKING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_focus_assistant_working_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_lens_is_focus_assistant_working_key",
                   "",
            ],
            [
                   "FLAT_CAMERA_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_range_key",
                   "",
            ],
            [
                   "VIDEO_RESOLUTION_FRAME_RATE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_resolution_frame_rate_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_resolution_frame_rate_range_key",
                   "",
            ],
            [
                   "AUTO_LOCK_GIMBAL_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_auto_lock_gimbal_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_auto_lock_gimbal_enabled_key",
                   "",
            ],
            [
                   "THERMAL_CUSTOM_EXTERNAL_SCENE_SETTINGS_PROFILE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_custom_external_scene_settings_profile_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_custom_external_scene_settings_profile_key",
                   "",
            ],
            [
                   "FLAT_CAMERA_MODE_CHILD_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_child_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_camera_mode_child_range_key",
                   "",
            ],
            [
                   "IS_THERMAL_CAMERA",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_thermal_camera_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_thermal_camera_key",
                   "",
            ],
            [
                   "ORIENTATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_orientation_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_orientation_key",
                   "",
            ],
            [
                   "THERMAL_SPOT_METERING_TARGET_POINT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_spot_metering_target_point_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_spot_metering_target_point_key",
                   "",
            ],
            [
                   "CAMERA_PEAK_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_peak_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_peak_threshold_key",
                   "",
            ],
            [
                   "SSD_VIDEO_RESOLUTION_FRAME_RATE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_frame_rate_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_video_resolution_frame_rate_range_key",
                   "",
            ],
            [
                   "CONTRAST",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_contrast_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_contrast_key",
                   "",
            ],
            [
                   "IS_CAPTURE_IN_VIDEO_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_capture_in_video_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_capture_in_video_supported_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_BUSY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_busy_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_busy_key",
                   "",
            ],
            [
                   "IS_MULTI_LENS_CAMERA_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_multi_lens_camera_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_multi_lens_camera_supported_key",
                   "",
            ],
            [
                   "RECOMMENDED_EI_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_recommended_ei_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_recommended_ei_value_key",
                   "",
            ],
            [
                   "DUAL_FEED_VERTICAL_ALIGNMENT_OFFSET_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_vertical_alignment_offset_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_dual_feed_vertical_alignment_offset_range_key",
                   "",
            ],
            [
                   "IS_HYBRID_ZOOM_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_hybrid_zoom_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_hybrid_zoom_supported_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_FORMATTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_formatted_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_formatted_key",
                   "",
            ],
            [
                   "INNERSTORAGE_REMAINING_SPACE_IN_MB",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_remaining_space_in_mb_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_remaining_space_in_mb_key",
                   "",
            ],
            [
                   "PANORAMA_PROGRESS_IN_PERCENT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_panorama_progress_in_percent_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_panorama_progress_in_percent_key",
                   "",
            ],
            [
                   "SDCARD_IS_FORMATTING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_formatting_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_formatting_key",
                   "",
            ],
            [
                   "SDCARD_REMAINING_SPACE_IN_MB",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_remaining_space_in_mb_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_remaining_space_in_mb_key",
                   "",
            ],
            [
                   "IS_FLAT_CAMERA_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_flat_camera_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_flat_camera_mode_supported_key",
                   "",
            ],
            [
                   "ENTER_PLAYBACK",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_enter_playback_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_enter_playback_key",
                   "",
            ],
            [
                   "WATERMARK_USER_CUSTOM_INFO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_user_custom_info_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_user_custom_info_key",
                   "",
            ],
            [
                   "SSD_TOTAL_SPACE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_total_space_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_total_space_key",
                   "",
            ],
            [
                   "FOCUS_RING_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_ring_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_focus_ring_value_key",
                   "",
            ],
            [
                   "IS_ND_FILTER_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_nd_filter_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_nd_filter_mode_supported_key",
                   "",
            ],
            [
                   "ACTIVATE_SSD_VIDEO_LICENSE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_activate_ssd_video_license_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_activate_ssd_video_license_key",
                   "",
            ],
            [
                   "ANTI_FLICKER_FREQUENCY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_anti_flicker_frequency_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_anti_flicker_frequency_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_INSERTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_inserted_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_inserted_key",
                   "",
            ],
            [
                   "PHOTO_BURST_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_burst_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_burst_count_key",
                   "",
            ],
            [
                   "EI_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ei_value_key",
                   "",
            ],
            [
                   "THERMAL_GLOBAL_MAX_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_global_max_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_global_max_temperature_key",
                   "",
            ],
            [
                   "SPOT_METERING_ROW_NUMS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_row_nums_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_spot_metering_row_nums_key",
                   "",
            ],
            [
                   "WATERMARK_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_watermark_settings_key",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_enabled_key",
                   "",
            ],
            [
                   "MULTI_SPECTRAL_SHUTTER_SPEED_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_multi_spectral_shutter_speed_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_multi_spectral_shutter_speed_range_key",
                   "",
            ],
            [
                   "CREATE_SUBSCRIPTION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_create_subscription_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_create_subscription_key",
                   "",
            ],
            [
                   "TAP_ZOOM_MULTIPLIER",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_multiplier_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_multiplier_key",
                   "",
            ],
            [
                   "HD_LIVE_VIEW_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hd_live_view_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hd_live_view_enabled_key",
                   "",
            ],
            [
                   "TURN_OFF_FAN_WHEN_POSSIBLE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_turn_off_fan_when_possible_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_turn_off_fan_when_possible_key",
                   "",
            ],
            [
                   "OPTICAL_ZOOM_SCALE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_scale_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_optical_zoom_scale_key",
                   "",
            ],
            [
                   "THERMAL_GAIN_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_gain_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_gain_mode_key",
                   "",
            ],
            [
                   "MULTI_SPECTRAL_EXPOSURE_COMPENSATION_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_multi_spectral_exposure_compensation_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_multi_spectral_exposure_compensation_range_key",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_LOWER_VALUE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_lower_value_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_lower_value_key",
                   "",
            ],
            [
                   "VIDEO_FILE_FORMAT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_file_format_key",
                   "",
            ],
            [
                   "PHOTO_TIME_INTERVAL_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_time_interval_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_time_interval_settings_key",
                   "",
            ],
            [
                   "AE_LOCK",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ae_lock_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ae_lock_key",
                   "",
            ],
            [
                   "FORMAT_SSD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_ssd_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_format_ssd_key",
                   "",
            ],
            [
                   "MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_mode_key",
                   "",
            ],
            [
                   "EXPOSURE_SENSITIVITY_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_sensitivity_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_sensitivity_mode_key",
                   "",
            ],
            [
                   "PRE_FLAT_SHOOT_PHOTO_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pre_flat_shoot_photo_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pre_flat_shoot_photo_mode_key",
                   "",
            ],
            [
                   "VISION_STABILIZATION_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_vision_stabilization_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_vision_stabilization_enabled_key",
                   "",
            ],
            [
                   "CUSTOM_EXPAND_FILE_NAME_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_expand_file_name_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_custom_expand_file_name_settings_key",
                   "",
            ],
            [
                   "INNERSTORAGE_AVAILABLE_CAPTURE_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_available_capture_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_available_capture_count_key",
                   "",
            ],
            [
                   "SDCARD_IS_SLOW",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_slow_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_slow_key",
                   "",
            ],
            [
                   "IS_OVERHEATING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_overheating_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_overheating_key",
                   "",
            ],
            [
                   "PANO_ORIGINAL_IMAGES_FORMAT_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pano_original_images_format_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_pano_original_images_format_range_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_FORMATTING",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_formatting_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_formatting_key",
                   "",
            ],
            [
                   "SSD_LEGACY_COLOR",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_legacy_color_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_ssd_legacy_color_key",
                   "",
            ],
            [
                   "CAMERA_STOP_MF_DEMARCATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_stop_mf_demarcate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_stop_mf_demarcate_key",
                   "",
            ],
            [
                   "CURRENT_THERMAL_GAIN_MODE_TEMPERATURE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_thermal_gain_mode_temperature_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_thermal_gain_mode_temperature_range_key",
                   "",
            ],
            [
                   "WHITE_BALANCE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_white_balance_key",
                   "",
            ],
            [
                   "DEFOG_ENABLED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_defog_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_defog_enabled_key",
                   "",
            ],
            [
                   "IS_EI_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_ei_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_ei_mode_supported_key",
                   "",
            ],
            [
                   "INNERSTORAGE_IS_READ_ONLY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_read_only_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_innerstorage_is_read_only_key",
                   "",
            ],
            [
                   "HYBRID_ZOOM_FOCAL_LENGTH",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hybrid_zoom_focal_length_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hybrid_zoom_focal_length_key",
                   "",
            ],
            [
                   "CURRENT_PANORAMA_PHOTO_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_panorama_photo_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_current_panorama_photo_count_key",
                   "",
            ],
            [
                   "PHOTO_AEB_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aeb_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_photo_aeb_count_key",
                   "",
            ],
            [
                   "FILE_INDEX_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_file_index_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_file_index_mode_key",
                   "",
            ],
            [
                   "IS_TIME_LAPSE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_time_lapse_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_time_lapse_supported_key",
                   "",
            ],
            [
                   "SENSOR_CLEANING_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sensor_cleaning_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sensor_cleaning_state_key",
                   "",
            ],
            [
                   "THERMAL_ISOTHERM_UNIT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_unit_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_isotherm_unit_key",
                   "",
            ],
            [
                   "SUPER_RESOLUTION_CAPTURE_AREA",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_super_resolution_capture_area_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_super_resolution_capture_area_key",
                   "",
            ],
            [
                   "VIDEO_STANDARD",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_standard_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_video_standard_key",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE_CHILD_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_child_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_child_range_key",
                   "",
            ],
            [
                   "LASER_SERVICE_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_service_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_laser_service_mode_key",
                   "",
            ],
            [
                   "THERMAL_MEASURING_STATUS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_measuring_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_measuring_status_key",
                   "",
            ],
            [
                   "RECORDING_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_recording_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_recording_state_key",
                   "",
            ],
            [
                   "FLAT_PHOTO_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_photo_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_flat_photo_mode_range_key",
                   "",
            ],
            [
                   "THERMAL_SSO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_sso_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_sso_key",
                   "",
            ],
            [
                   "CAMERA_MF_DEMARCATE_RESULT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_mf_demarcate_result_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_camera_mf_demarcate_result_key",
                   "",
            ],
            [
                   "HARDWARE_VERSION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hardware_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_hardware_version_key",
                   "",
            ],
            [
                   "SHOOT_PHOTO_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shoot_photo_mode_range_key",
                   "",
            ],
            [
                   "IS_SHOOTING_PHOTO",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_photo_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_shooting_photo_key",
                   "",
            ],
            [
                   "IS_DEWARPING_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_dewarping_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_dewarping_supported_key",
                   "",
            ],
            [
                   "SATURATION",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_saturation_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_saturation_key",
                   "",
            ],
            [
                   "REAL_SHUTTER_SPEED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_real_shutter_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_real_shutter_speed_key",
                   "",
            ],
            [
                   "LEDS_AUTO_TURN_OFF_ENABLED_SETTINGS",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_leds_auto_turn_off_enabled_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_leds_auto_turn_off_enabled_settings_key",
                   "",
            ],
            [
                   "EXPOSURE_MODE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_mode_key",
                   "",
            ],
            [
                   "SHUTTER_SPEED_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shutter_speed_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_shutter_speed_range_key",
                   "",
            ],
            [
                   "THERMAL_SCENE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_scene_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_scene_key",
                   "",
            ],
            [
                   "VISION_STABILIZATION_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_vision_stabilization_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_vision_stabilization_state_key",
                   "",
            ],
            [
                   "IS_OPTICAL_ZOOM_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_optical_zoom_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_optical_zoom_supported_key",
                   "",
            ],
            [
                   "IS_METERING_MODE_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_metering_mode_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_is_metering_mode_supported_key",
                   "",
            ],
            [
                   "TAP_ZOOM_STATE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_state_key",
                   "",
            ],
            [
                   "THERMAL_WINDOW_REFLECTED_TEMPERATURE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_reflected_temperature_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_thermal_window_reflected_temperature_key",
                   "",
            ],
            [
                   "SDCARD_IS_CONNECTED_TO_PC",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_connected_to_pc_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_connected_to_pc_key",
                   "",
            ],
            [
                   "SDCARD_IS_BUSY",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_busy_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_busy_key",
                   "",
            ],
            [
                   "TAP_ZOOM_AT_TARGET",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_at_target_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_tap_zoom_at_target_key",
                   "",
            ],
            [
                   "EXPOSURE_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_exposure_mode_range_key",
                   "",
            ],
            [
                   "TOTAL_PANORAMA_PHOTO_COUNT",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_total_panorama_photo_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_total_panorama_photo_count_key",
                   "",
            ],
            [
                   "SDCARD_IS_FORMATTED",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_formatted_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_sdcard_is_formatted_key",
                   "",
            ],
            [
                   "ORIENTATION_RANGE",
                   2,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_orientation_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJICameraKey.html",
                   "#camerakey_orientation_range_key",
                   "",
            ],
            [
                   "IS_HOME_LOCATION_SET",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_home_location_set_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_home_location_set_key",
                   "",
            ],
            [
                   "HOTPOINT_MIN_RADIUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_hotpoint_min_radius_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_hotpoint_min_radius_key",
                   "",
            ],
            [
                   "IS_VISION_POSITIONING_SENSOR_BEING_USED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_vision_positioning_sensor_being_used_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_vision_positioning_sensor_being_used_key",
                   "",
            ],
            [
                   "VELOCITY_X",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_x_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_x_key",
                   "",
            ],
            [
                   "VELOCITY_Z",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_z_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_z_key",
                   "",
            ],
            [
                   "GO_HOME_ASSESSMENT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_assessment_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_assessment_key",
                   "",
            ],
            [
                   "IS_BRAKING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_braking_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_braking_key",
                   "",
            ],
            [
                   "IS_MULTI_TRACKING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_enabled_key",
                   "",
            ],
            [
                   "RESET_MOTOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_motor_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_motor_key",
                   "",
            ],
            [
                   "SINGLE_VISION_SENSOR_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_single_vision_sensor_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_single_vision_sensor_enabled_key",
                   "",
            ],
            [
                   "UPGRADE_VOICE_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_upgrade_voice_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_upgrade_voice_open_key",
                   "",
            ],
            [
                   "RESET_USER_ACCOUNT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_user_account_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_user_account_key",
                   "",
            ],
            [
                   "IS_MULTI_TRACKING_EXECUTING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_executing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_executing_key",
                   "",
            ],
            [
                   "DOWN_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_down_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_down_avoidance_distance_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT_LIMIT_REASON",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_limit_reason_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_limit_reason_key",
                   "",
            ],
            [
                   "DOES_APAS_HAVE_TEMP_ERROR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_does_apas_have_temp_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_does_apas_have_temp_error_key",
                   "",
            ],
            [
                   "VELOCITY_Y",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_y_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_velocity_y_key",
                   "",
            ],
            [
                   "COMPASS_HAS_ERROR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_has_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_has_error_key",
                   "",
            ],
            [
                   "REDUNDANCY_IMU_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_imu_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_imu_status_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS_RANGE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_range_key",
                   "",
            ],
            [
                   "IS_CANCEL_AUTO_LANDING_DISABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_cancel_auto_landing_disabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_cancel_auto_landing_disabled_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_GPS_ASSISTANT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_gps_assistant_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_gps_assistant_enabled_key",
                   "",
            ],
            [
                   "TURN_ON_MOTORS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_turn_on_motors_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_turn_on_motors_key",
                   "",
            ],
            [
                   "START_IMU_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_imu_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_imu_calibration_key",
                   "",
            ],
            [
                   "CONFIRM_IN_MOVING_PLATFORM",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_in_moving_platform_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_in_moving_platform_key",
                   "",
            ],
            [
                   "IS_CANCEL_RETURN_TO_HOME_DISABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_cancel_return_to_home_disabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_cancel_return_to_home_disabled_key",
                   "",
            ],
            [
                   "VISION_SYSTEM_WARNING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_system_warning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_system_warning_key",
                   "",
            ],
            [
                   "REDUNDANCY_SENSOR_USED_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_sensor_used_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_sensor_used_state_key",
                   "",
            ],
            [
                   "LOCK_MOTORS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_lock_motors_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_lock_motors_key",
                   "",
            ],
            [
                   "HOME_LOCATION_LATITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_latitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_latitude_key",
                   "",
            ],
            [
                   "START_SIMULATOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_simulator_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_simulator_key",
                   "",
            ],
            [
                   "UNSUBSCRIBE_PACK",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_unsubscribe_pack_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_unsubscribe_pack_key",
                   "",
            ],
            [
                   "DEPLOY_LANDING_GEAR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_deploy_landing_gear_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_deploy_landing_gear_key",
                   "",
            ],
            [
                   "SMART_TRACK_SET_CAMERA_FOCAL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_smart_track_set_camera_focal_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_smart_track_set_camera_focal_key",
                   "",
            ],
            [
                   "RTK_FUSION_HAS_SET_TAKE_OFF_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_has_set_take_off_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_has_set_take_off_altitude_key",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_TRACK_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_controller_track_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_controller_track_mode_key",
                   "",
            ],
            [
                   "IS_LANDING_GEAR_MOVABLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_gear_movable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_gear_movable_key",
                   "",
            ],
            [
                   "ULTRASONIC_ERROR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_ultrasonic_error_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_ultrasonic_error_key",
                   "",
            ],
            [
                   "AIRCRAFT_LOCATION_LATITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_latitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_latitude_key",
                   "",
            ],
            [
                   "SET_DATA_UPGRADE_SELF",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_data_upgrade_self_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_data_upgrade_self_key",
                   "",
            ],
            [
                   "WAYPOINT_MISSION_INTERRUPTION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_waypoint_mission_interruption_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_waypoint_mission_interruption_key",
                   "",
            ],
            [
                   "OMNI_PERCEPTION_RADAR_DOWN_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_down_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_down_distance_key",
                   "",
            ],
            [
                   "RTH_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rth_obstacle_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rth_obstacle_avoidance_enabled_key",
                   "",
            ],
            [
                   "AIRCRAFT_GO_HOME_COUNT_DOWN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_go_home_count_down_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_go_home_count_down_key",
                   "",
            ],
            [
                   "STOP_SIMULATOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_simulator_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_simulator_key",
                   "",
            ],
            [
                   "IS_REBOOT_IN_S_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_reboot_in_s_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_reboot_in_s_mode_key",
                   "",
            ],
            [
                   "IS_PERFORMING_PRECISION_LANDING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_performing_precision_landing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_performing_precision_landing_key",
                   "",
            ],
            [
                   "HOME_LOCATION_USING_CURRENT_AIRCRAFT_LOCATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_using_current_aircraft_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_using_current_aircraft_location_key",
                   "",
            ],
            [
                   "OUT_OF_BOTH_CONTROL_GIMBALS_REASON",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_out_of_both_control_gimbals_reason_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_out_of_both_control_gimbals_reason_key",
                   "",
            ],
            [
                   "SET_HOME_LOCATION_WITHOUT_LIMITATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_home_location_without_limitation_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_home_location_without_limitation_key",
                   "",
            ],
            [
                   "FORMAT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_format_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_format_key",
                   "",
            ],
            [
                   "MULTI_TRACKING_SUB_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_tracking_sub_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_tracking_sub_mode_key",
                   "",
            ],
            [
                   "OMNI_HORIZONTAL_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_avoidance_enabled_key",
                   "",
            ],
            [
                   "CUSTOM_FUNCTION_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_custom_function_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_custom_function_mode_key",
                   "",
            ],
            [
                   "RTH_REMOTE_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rth_remote_obstacle_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rth_remote_obstacle_avoidance_enabled_key",
                   "",
            ],
            [
                   "IS_ABSOLUTE_GPS_ALTITUDE_SUPPORT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_absolute_gps_altitude_support_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_absolute_gps_altitude_support_key",
                   "",
            ],
            [
                   "OMNI_DOWN_RADAR_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_down_radar_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_down_radar_distance_key",
                   "",
            ],
            [
                   "LANDING_GEAR_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_mode_key",
                   "",
            ],
            [
                   "MULTI_RC_FLIGHT_CONTROL_AUTH_LOCK_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_lock_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_lock_state_key",
                   "",
            ],
            [
                   "LANDING_PROTECTION_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_protection_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_protection_enabled_key",
                   "",
            ],
            [
                   "IS_MOTOR_STOP_LANDING_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_motor_stop_landing_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_motor_stop_landing_mode_key",
                   "",
            ],
            [
                   "HOTPOINT_MAX_ACCELERATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_hotpoint_max_acceleration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_hotpoint_max_acceleration_key",
                   "",
            ],
            [
                   "TAP_FLY_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_tap_fly_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_tap_fly_mode_key",
                   "",
            ],
            [
                   "GET_WAYPOINT_BREAK_INFO",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_get_waypoint_break_info_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_get_waypoint_break_info_key",
                   "",
            ],
            [
                   "IS_FAIL_SAFE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_fail_safe_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_fail_safe_key",
                   "",
            ],
            [
                   "TRIPOD_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_tripod_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_tripod_mode_enabled_key",
                   "",
            ],
            [
                   "CINEMATIC_BRAKE_SENSITIVITY_RANGE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_brake_sensitivity_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_brake_sensitivity_range_key",
                   "",
            ],
            [
                   "TAKE_OFF",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_take_off_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_take_off_key",
                   "",
            ],
            [
                   "HAS_INTERNAL_BEACON_LEDS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_internal_beacon_leds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_internal_beacon_leds_key",
                   "",
            ],
            [
                   "SET_UP_USER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_up_user_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_up_user_key",
                   "",
            ],
            [
                   "FLY_TIME_IN_SECONDS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fly_time_in_seconds_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fly_time_in_seconds_key",
                   "",
            ],
            [
                   "START_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_go_home_key",
                   "",
            ],
            [
                   "OPEN_ALTITUDE_FLIGHT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_open_altitude_flight_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_open_altitude_flight_mode_key",
                   "",
            ],
            [
                   "TEMP_MOTOR_LOCKED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_temp_motor_locked_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_temp_motor_locked_key",
                   "",
            ],
            [
                   "MULTI_RC_FLIGHT_CONTROL_AUTH_LOCK",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_lock_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_lock_key",
                   "",
            ],
            [
                   "IS_MULTI_TRACKING_WAITING_CONFIRMATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_waiting_confirmation_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_multi_tracking_waiting_confirmation_key",
                   "",
            ],
            [
                   "CANCEL_TAKE_OFF",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_take_off_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_take_off_key",
                   "",
            ],
            [
                   "FLIGHT_CONTROLLER_DYNAMIC_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_controller_dynamic_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_controller_dynamic_home_key",
                   "",
            ],
            [
                   "GO_HOME_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_status_key",
                   "",
            ],
            [
                   "APP_SET_PARAM_DISPLAY_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_app_set_param_display_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_app_set_param_display_status_key",
                   "",
            ],
            [
                   "IMU_COUNT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_imu_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_imu_count_key",
                   "",
            ],
            [
                   "FORMATTING_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_formatting_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_formatting_state_key",
                   "",
            ],
            [
                   "ACTIVE_FORBID_SIDE_FLY_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_forbid_side_fly_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_forbid_side_fly_enabled_key",
                   "",
            ],
            [
                   "ACCESS_LOCKER_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_state_key",
                   "",
            ],
            [
                   "LANDING_GEAR_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_status_key",
                   "",
            ],
            [
                   "RTK_ACTIVATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_activate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_activate_key",
                   "",
            ],
            [
                   "WAYPOINT_PROTOCOL_VERSION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_waypoint_protocol_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_waypoint_protocol_version_key",
                   "",
            ],
            [
                   "TURN_OFF_MOTORS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_turn_off_motors_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_turn_off_motors_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_CIRCULAR_SPEED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_circular_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_circular_speed_key",
                   "",
            ],
            [
                   "COMPASS_HEADING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_heading_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_heading_key",
                   "",
            ],
            [
                   "OMNI_DOWN_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_down_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_down_avoidance_distance_key",
                   "",
            ],
            [
                   "MOTOR_START_FAILED_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_motor_start_failed_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_motor_start_failed_state_key",
                   "",
            ],
            [
                   "CINEMATIC_BRAKE_SENSITIVITY",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_brake_sensitivity_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_brake_sensitivity_key",
                   "",
            ],
            [
                   "START_IMU_CALIBRATION_WITH_ID",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_imu_calibration_with_id_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_imu_calibration_with_id_key",
                   "",
            ],
            [
                   "LANDING_GEAR_AUTOMATIC_MOVEMENT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_automatic_movement_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_automatic_movement_enabled_key",
                   "",
            ],
            [
                   "IS_APAS_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_apas_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_apas_enabled_key",
                   "",
            ],
            [
                   "RTK_FUSION_HOME_LOCATION_DATA_SOURCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_home_location_data_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_home_location_data_source_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_GESTURE_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_gesture_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_gesture_mode_enabled_key",
                   "",
            ],
            [
                   "ORIENTATION_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_orientation_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_orientation_mode_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_CAMERA",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_camera_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_camera_key",
                   "",
            ],
            [
                   "REMAINING_FLIGHT_TIME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_remaining_flight_time_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_remaining_flight_time_key",
                   "",
            ],
            [
                   "IS_LOWER_THAN_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_lower_than_battery_warning_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_lower_than_battery_warning_threshold_key",
                   "",
            ],
            [
                   "DRAW_HEADING_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_draw_heading_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_draw_heading_mode_key",
                   "",
            ],
            [
                   "IS_RTK_CONNECTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_connected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_connected_key",
                   "",
            ],
            [
                   "ATTITUDE_PITCH",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_pitch_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_pitch_key",
                   "",
            ],
            [
                   "UP_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_up_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_up_avoidance_distance_key",
                   "",
            ],
            [
                   "IS_MOTORS_LOCK_BY_APP",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_motors_lock_by_app_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_motors_lock_by_app_key",
                   "",
            ],
            [
                   "AIRCRAFT_LOCATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_key",
                   "",
            ],
            [
                   "ADVANCED_GESTURE_CONTROL_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_advanced_gesture_control_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_advanced_gesture_control_enabled_key",
                   "",
            ],
            [
                   "IS_FLYING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_flying_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_flying_key",
                   "",
            ],
            [
                   "ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_altitude_key",
                   "",
            ],
            [
                   "RTK_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_enabled_key",
                   "",
            ],
            [
                   "OMNI_HORIZONTAL_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_avoidance_distance_key",
                   "",
            ],
            [
                   "STOP_GRAVITY_CENTER_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_gravity_center_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_gravity_center_calibration_key",
                   "",
            ],
            [
                   "HOME_POINT_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_point_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_point_state_key",
                   "",
            ],
            [
                   "IS_RIGHT_RADAR_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_right_radar_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_right_radar_open_key",
                   "",
            ],
            [
                   "TAKEOFF_LOCATION_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_takeoff_location_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_takeoff_location_altitude_key",
                   "",
            ],
            [
                   "IS_LANDING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_key",
                   "",
            ],
            [
                   "RTK_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_state_key",
                   "",
            ],
            [
                   "SIMULATOR_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_simulator_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_simulator_state_key",
                   "",
            ],
            [
                   "VISION_ASSISTED_POSITIONING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_assisted_positioning_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_assisted_positioning_enabled_key",
                   "",
            ],
            [
                   "COMPASS_IS_CALIBRATING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_is_calibrating_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_is_calibrating_key",
                   "",
            ],
            [
                   "FLIGHT_ACTION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_action_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_action_key",
                   "",
            ],
            [
                   "IS_NO_GPS_MAX_FLIGHT_HEIGHT_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_no_gps_max_flight_height_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_no_gps_max_flight_height_supported_key",
                   "",
            ],
            [
                   "ENTER_NAVIGATION_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enter_navigation_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enter_navigation_mode_key",
                   "",
            ],
            [
                   "SIMULATOR_WIND_DATA",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_simulator_wind_data_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_simulator_wind_data_key",
                   "",
            ],
            [
                   "ENTER_TRANSPORT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enter_transport_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enter_transport_mode_key",
                   "",
            ],
            [
                   "CANCEL_LANDING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_landing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_landing_key",
                   "",
            ],
            [
                   "RTK_SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_serial_number_key",
                   "",
            ],
            [
                   "IN_ON_LIMITE_AREA_BOUNDARIES",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_in_on_limite_area_boundaries_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_in_on_limite_area_boundaries_key",
                   "",
            ],
            [
                   "RTK_FUSION_MOBILE_HEADING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_mobile_heading_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_mobile_heading_key",
                   "",
            ],
            [
                   "VIRTUAL_STICK_CONTROL_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_virtual_stick_control_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_virtual_stick_control_mode_enabled_key",
                   "",
            ],
            [
                   "CINEMATIC_YAW_SPEED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_yaw_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_yaw_speed_key",
                   "",
            ],
            [
                   "IS_FRONT_RADAR_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_front_radar_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_front_radar_open_key",
                   "",
            ],
            [
                   "IS_APAS_FUNCTIONING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_apas_functioning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_apas_functioning_key",
                   "",
            ],
            [
                   "IS_FLIGHT_ASSISTANT_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_flight_assistant_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_flight_assistant_supported_key",
                   "",
            ],
            [
                   "AIRCRAFT_TOTAL_FLIGHT_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_distance_key",
                   "",
            ],
            [
                   "EXIT_TRANSPORT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_exit_transport_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_exit_transport_mode_key",
                   "",
            ],
            [
                   "CINEMATIC_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_mode_enabled_key",
                   "",
            ],
            [
                   "RC_MODE_CHANNEL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rc_mode_channel_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rc_mode_channel_key",
                   "",
            ],
            [
                   "IS_PRECISION_TAKE_OFF_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_precision_take_off_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_precision_take_off_supported_key",
                   "",
            ],
            [
                   "STOP_SEARCH_BASE_STATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_search_base_station_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_stop_search_base_station_key",
                   "",
            ],
            [
                   "BINDING_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_binding_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_binding_state_key",
                   "",
            ],
            [
                   "RTK_DEVICE_PASSWORD",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_device_password_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_device_password_key",
                   "",
            ],
            [
                   "RTK_BASE_STATION_CONNECTION_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_connection_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_connection_state_key",
                   "",
            ],
            [
                   "HAS_REACHED_MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_reached_max_flight_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_reached_max_flight_height_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_mode_key",
                   "",
            ],
            [
                   "IS_AVOIDING_ACTIVE_OBSTACLE_COLLISION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_avoiding_active_obstacle_collision_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_avoiding_active_obstacle_collision_key",
                   "",
            ],
            [
                   "AREA_CODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_area_code_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_area_code_key",
                   "",
            ],
            [
                   "PROPELLER_COVER_LIMIT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_propeller_cover_limit_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_propeller_cover_limit_enabled_key",
                   "",
            ],
            [
                   "OMNI_PERCEPTION_AVOIDANCE_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_avoidance_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_avoidance_state_key",
                   "",
            ],
            [
                   "START_LANDING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_landing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_landing_key",
                   "",
            ],
            [
                   "HORIZONTAL_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_horizontal_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_horizontal_avoidance_distance_key",
                   "",
            ],
            [
                   "TOP_AUXILIARY_LIGHT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_top_auxiliary_light_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_top_auxiliary_light_mode_key",
                   "",
            ],
            [
                   "RTK_CONNECTED_WITH_BASE_STATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_connected_with_base_station_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_connected_with_base_station_key",
                   "",
            ],
            [
                   "RTK_CONNECT_TYPE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_connect_type_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_connect_type_key",
                   "",
            ],
            [
                   "IS_ASCENT_LIMITED_BY_OBSTACLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_ascent_limited_by_obstacle_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_ascent_limited_by_obstacle_key",
                   "",
            ],
            [
                   "LOCK_COURSE_USING_CURRENT_HEADING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_lock_course_using_current_heading_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_lock_course_using_current_heading_key",
                   "",
            ],
            [
                   "AIRCRAFT_NAME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_name_key",
                   "",
            ],
            [
                   "ACCESS_LOCKER_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_supported_key",
                   "",
            ],
            [
                   "IS_ADVANCED_PILOT_ASSISTANT_SYSTEM_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_advanced_pilot_assistant_system_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_advanced_pilot_assistant_system_enabled_key",
                   "",
            ],
            [
                   "RTK_REFERENCE_STATION_SOURCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_reference_station_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_reference_station_source_key",
                   "",
            ],
            [
                   "OMNI_VERTICAL_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_vertical_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_vertical_avoidance_enabled_key",
                   "",
            ],
            [
                   "MAX_RADIUS_AIRCRAFT_CAN_FLY_AND_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_radius_aircraft_can_fly_and_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_radius_aircraft_can_fly_and_go_home_key",
                   "",
            ],
            [
                   "ACTIVE_BRAKE_ENGAGED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_brake_engaged_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_brake_engaged_key",
                   "",
            ],
            [
                   "RTK_BASE_STATION_LOCATION_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_location_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_location_state_key",
                   "",
            ],
            [
                   "ATTITUDE_YAW",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_yaw_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_yaw_key",
                   "",
            ],
            [
                   "LANDING_GEAR_HIDE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_hide_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_gear_hide_enabled_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_key",
                   "",
            ],
            [
                   "LANDING_PROTECTION_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_protection_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_landing_protection_state_key",
                   "",
            ],
            [
                   "CONTROL_GIMBAL_BEHAVIOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_control_gimbal_behavior_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_control_gimbal_behavior_key",
                   "",
            ],
            [
                   "AIR_SENSE_SYSTEM_CONNECTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_system_connected_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_system_connected_key",
                   "",
            ],
            [
                   "LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_low_battery_warning_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_low_battery_warning_threshold_key",
                   "",
            ],
            [
                   "RTK_FUSION_AIRCRAFT_TO_HOME_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_aircraft_to_home_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_aircraft_to_home_distance_key",
                   "",
            ],
            [
                   "IS_VIRTUAL_STICK_CONTROL_MODE_AVAILABLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_virtual_stick_control_mode_available_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_virtual_stick_control_mode_available_key",
                   "",
            ],
            [
                   "VISION_DETECTION_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_detection_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_vision_detection_state_key",
                   "",
            ],
            [
                   "LOGIN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_login_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_login_key",
                   "",
            ],
            [
                   "START_SEARCH_BASE_STATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_search_base_station_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_search_base_station_key",
                   "",
            ],
            [
                   "AIR_SENSE_SYSTEM_WARNING_LEVEL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_system_warning_level_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_system_warning_level_key",
                   "",
            ],
            [
                   "INIT_IO",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_init_io_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_init_io_key",
                   "",
            ],
            [
                   "IS_RTK_SUPPORTED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_supported_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_supported_key",
                   "",
            ],
            [
                   "CONFIG_RTH_IN_CURRENT_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_config_rth_in_current_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_config_rth_in_current_altitude_key",
                   "",
            ],
            [
                   "QUICK_SPIN_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_quick_spin_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_quick_spin_enabled_key",
                   "",
            ],
            [
                   "IS_AIRCRAFT_HOVERING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_aircraft_hovering_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_aircraft_hovering_key",
                   "",
            ],
            [
                   "OMNI_HORIZONTAL_RADAR_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_radar_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_horizontal_radar_distance_key",
                   "",
            ],
            [
                   "URGENT_STOP_MOTOR_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_urgent_stop_motor_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_urgent_stop_motor_mode_key",
                   "",
            ],
            [
                   "AIRCRAFT_LOCATION_LONGITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_longitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_location_longitude_key",
                   "",
            ],
            [
                   "FORCE_LANDING_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_force_landing_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_force_landing_height_key",
                   "",
            ],
            [
                   "RTK_HEADING_SOLUTION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_heading_solution_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_heading_solution_key",
                   "",
            ],
            [
                   "MULTI_MODE_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_mode_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_mode_open_key",
                   "",
            ],
            [
                   "IS_SIMULATOR_ACTIVE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_simulator_active_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_simulator_active_key",
                   "",
            ],
            [
                   "SET_MULTI_TRACKING_ENABLED_WITH_VIDEO_SOURCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_multi_tracking_enabled_with_video_source_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_set_multi_tracking_enabled_with_video_source_key",
                   "",
            ],
            [
                   "HOME_LOCATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_key",
                   "",
            ],
            [
                   "IOSTATE_4",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_4_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_4_key",
                   "",
            ],
            [
                   "IOSTATE_2",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_2_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_2_key",
                   "",
            ],
            [
                   "IOSTATE_3",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_3_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_3_key",
                   "",
            ],
            [
                   "IOSTATE_0",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_0_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_0_key",
                   "",
            ],
            [
                   "IOSTATE_1",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_1_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_iostate_1_key",
                   "",
            ],
            [
                   "COMPASS_COUNT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_count_key",
                   "",
            ],
            [
                   "AIRCRAFT_TOTAL_FLIGHT_TIMES",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_times_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_times_key",
                   "",
            ],
            [
                   "ACTIVE_OBSTACLE_AVOIDANCE_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_obstacle_avoidance_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_obstacle_avoidance_mode_key",
                   "",
            ],
            [
                   "IMU_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_imu_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_imu_state_key",
                   "",
            ],
            [
                   "OMNI_PERCEPTION_RADAR_FULL_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_full_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_full_distance_key",
                   "",
            ],
            [
                   "WIND_SPEED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_wind_speed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_wind_speed_key",
                   "",
            ],
            [
                   "AIRCRAFT_TOTAL_FLIGHT_DURATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_duration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_total_flight_duration_key",
                   "",
            ],
            [
                   "FLY_ZONE_LIMITATION_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fly_zone_limitation_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fly_zone_limitation_enabled_key",
                   "",
            ],
            [
                   "IS_SYSTEM_UPGRADE_ABNORMAL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_system_upgrade_abnormal_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_system_upgrade_abnormal_key",
                   "",
            ],
            [
                   "LIMIT_MAX_FLIGHT_HEIGHT_IN_METER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_limit_max_flight_height_in_meter_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_limit_max_flight_height_in_meter_key",
                   "",
            ],
            [
                   "HAS_REACHED_MAX_FLIGHT_RADIUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_reached_max_flight_radius_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_has_reached_max_flight_radius_key",
                   "",
            ],
            [
                   "IS_IN_LANDING_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_in_landing_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_in_landing_mode_key",
                   "",
            ],
            [
                   "AIRCRAFT_SHOULD_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_should_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_aircraft_should_go_home_key",
                   "",
            ],
            [
                   "PRECISION_LANDING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_precision_landing_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_precision_landing_enabled_key",
                   "",
            ],
            [
                   "CONNECT_TO_BASE_STATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_connect_to_base_station_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_connect_to_base_station_key",
                   "",
            ],
            [
                   "ACCESS_LOCKER_VERSION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_version_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_version_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT_IN_NFZ",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_in_nfz_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_in_nfz_key",
                   "",
            ],
            [
                   "DETECTION_SECTORS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_detection_sectors_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_detection_sectors_key",
                   "",
            ],
            [
                   "FLIGHT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_mode_key",
                   "",
            ],
            [
                   "AIR_SENSE_AIRPLANE_STATES",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_airplane_states_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_air_sense_airplane_states_key",
                   "",
            ],
            [
                   "FLIGHT_USER_AVOID_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_user_avoid_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_user_avoid_enabled_key",
                   "",
            ],
            [
                   "FORCE_LANDING_AFTER_FLAT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_force_landing_after_flat_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_force_landing_after_flat_mode_key",
                   "",
            ],
            [
                   "APAS_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_apas_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_apas_state_key",
                   "",
            ],
            [
                   "TIME_NEEDED_TO_LAND_FROM_CURRENT_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_time_needed_to_land_from_current_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_time_needed_to_land_from_current_height_key",
                   "",
            ],
            [
                   "OMNI_PERCEPTION_RADAR_BIRD_VIEW_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_bird_view_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_bird_view_distance_key",
                   "",
            ],
            [
                   "FIXED_WING_CONTROL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fixed_wing_control_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_fixed_wing_control_key",
                   "",
            ],
            [
                   "IS_IMU_PREHEATING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_imu_preheating_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_imu_preheating_key",
                   "",
            ],
            [
                   "START_GRAVITY_CENTER_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_gravity_center_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_start_gravity_center_calibration_key",
                   "",
            ],
            [
                   "RTK_POSITIONING_SOLUTION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_positioning_solution_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_positioning_solution_key",
                   "",
            ],
            [
                   "PERCEPTION_TOF_FULL_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_perception_tof_full_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_perception_tof_full_distance_key",
                   "",
            ],
            [
                   "REDUNDANCY_COMPASS_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_compass_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_redundancy_compass_status_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_serial_number_key",
                   "",
            ],
            [
                   "NOVICE_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_novice_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_novice_mode_enabled_key",
                   "",
            ],
            [
                   "BOTTOM_AUXILIARY_LIGHT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_bottom_auxiliary_light_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_bottom_auxiliary_light_mode_key",
                   "",
            ],
            [
                   "LEDS_ENABLED_SETTINGS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_leds_enabled_settings_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_leds_enabled_settings_key",
                   "",
            ],
            [
                   "CURRENT_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_current_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_current_mode_key",
                   "",
            ],
            [
                   "GRAVITY_CENTER_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gravity_center_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gravity_center_state_key",
                   "",
            ],
            [
                   "RTK_BASE_STATION_LIST",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_list_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_base_station_list_key",
                   "",
            ],
            [
                   "MAX_WAYPOINT_NUM",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_waypoint_num_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_waypoint_num_key",
                   "",
            ],
            [
                   "OMNI_PERCEPTION_RADAR_UP_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_up_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_perception_radar_up_distance_key",
                   "",
            ],
            [
                   "SEND_DATA_TO_ON_BOARD_SDK_DEVICE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_send_data_to_on_board_sdk_device_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_send_data_to_on_board_sdk_device_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_key",
                   "",
            ],
            [
                   "IS_RTK_FUSION_DATA_USABLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_fusion_data_usable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_rtk_fusion_data_usable_key",
                   "",
            ],
            [
                   "COLLISION_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_collision_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_collision_avoidance_enabled_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_HEIGHT_RANGE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_height_range_key",
                   "",
            ],
            [
                   "CONNECTION_FAIL_SAFE_BEHAVIOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_connection_fail_safe_behavior_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_connection_fail_safe_behavior_key",
                   "",
            ],
            [
                   "TIME_NEEDED_TO_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_time_needed_to_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_time_needed_to_go_home_key",
                   "",
            ],
            [
                   "FLIGHT_MODE_STRING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_mode_string_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_mode_string_key",
                   "",
            ],
            [
                   "CANCEL_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cancel_go_home_key",
                   "",
            ],
            [
                   "BATTERY_PERCENTAGE_NEEDED_TO_GO_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_battery_percentage_needed_to_go_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_battery_percentage_needed_to_go_home_key",
                   "",
            ],
            [
                   "HOME_POINT_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_point_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_point_altitude_key",
                   "",
            ],
            [
                   "ESC_BEEPING_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_esc_beeping_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_esc_beeping_enabled_key",
                   "",
            ],
            [
                   "ACTIVE_OBSTACLE_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_obstacle_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_obstacle_avoidance_enabled_key",
                   "",
            ],
            [
                   "HOME_LOCATION_LONGITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_longitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_home_location_longitude_key",
                   "",
            ],
            [
                   "NEED_LIMIT_FLIGHT_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_need_limit_flight_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_need_limit_flight_height_key",
                   "",
            ],
            [
                   "BATTERY_THRESHOLD_BEHAVIOR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_battery_threshold_behavior_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_battery_threshold_behavior_key",
                   "",
            ],
            [
                   "MAX_FLIGHT_RADIUS_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_max_flight_radius_enabled_key",
                   "",
            ],
            [
                   "ABSOLUTE_GPS_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_absolute_gps_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_absolute_gps_altitude_key",
                   "",
            ],
            [
                   "RETURN_TO_HOME_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_return_to_home_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_return_to_home_state_key",
                   "",
            ],
            [
                   "COMPASS_CALIBRATION_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_calibration_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_calibration_status_key",
                   "",
            ],
            [
                   "IS_ULTRASONIC_BEING_USED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_ultrasonic_being_used_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_ultrasonic_being_used_key",
                   "",
            ],
            [
                   "ACCESS_LOCKER_USERNAME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_username_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_access_locker_username_key",
                   "",
            ],
            [
                   "RTK_DEVICE_NAME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_device_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_device_name_key",
                   "",
            ],
            [
                   "CONTROL_MODE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_control_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_control_mode_key",
                   "",
            ],
            [
                   "IS_LEFT_RADAR_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_left_radar_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_left_radar_open_key",
                   "",
            ],
            [
                   "MULTI_RC_EXECUTE_AIRCRAFT_LOST_LOGIC",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_execute_aircraft_lost_logic_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_execute_aircraft_lost_logic_key",
                   "",
            ],
            [
                   "SEND_VIRTUAL_STICK_FLIGHT_CONTROL_DATA",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_send_virtual_stick_flight_control_data_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_send_virtual_stick_flight_control_data_key",
                   "",
            ],
            [
                   "OMNI_UP_AVOIDANCE_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_up_avoidance_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_up_avoidance_distance_key",
                   "",
            ],
            [
                   "ENABLE_1860",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enable_1860_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_enable_1860_key",
                   "",
            ],
            [
                   "RESET_GRAVITY_CENTER_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_gravity_center_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_reset_gravity_center_calibration_key",
                   "",
            ],
            [
                   "POWER_SUPPLY_PORT_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_power_supply_port_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_power_supply_port_enabled_key",
                   "",
            ],
            [
                   "GO_HOME_HEIGHT_IN_METERS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_height_in_meters_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_go_home_height_in_meters_key",
                   "",
            ],
            [
                   "IS_IN_MOVING_PLATFORM",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_in_moving_platform_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_in_moving_platform_key",
                   "",
            ],
            [
                   "ULTRASONIC_HEIGHT_IN_METERS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_ultrasonic_height_in_meters_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_ultrasonic_height_in_meters_key",
                   "",
            ],
            [
                   "CONFIRM_LANDING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_landing_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_landing_key",
                   "",
            ],
            [
                   "RID_WORKING_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rid_working_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rid_working_status_key",
                   "",
            ],
            [
                   "CONFIRM_SMART_RETURN_TO_HOME_REQUEST",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_smart_return_to_home_request_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_confirm_smart_return_to_home_request_key",
                   "",
            ],
            [
                   "DRAW_STATUS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_draw_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_draw_status_key",
                   "",
            ],
            [
                   "TERRAIN_FOLLOW_MODE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_terrain_follow_mode_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_terrain_follow_mode_enabled_key",
                   "",
            ],
            [
                   "MODIFY_USER_ACCOUNT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_modify_user_account_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_modify_user_account_key",
                   "",
            ],
            [
                   "OMNI_UP_RADAR_DISTANCE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_up_radar_distance_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_up_radar_distance_key",
                   "",
            ],
            [
                   "COMPASS_START_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_start_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_start_calibration_key",
                   "",
            ],
            [
                   "EID_NUMBER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_eid_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_eid_number_key",
                   "",
            ],
            [
                   "WIND_DIRECTION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_wind_direction_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_wind_direction_key",
                   "",
            ],
            [
                   "IS_LANDING_CONFIRMATION_NEEDED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_confirmation_needed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_landing_confirmation_needed_key",
                   "",
            ],
            [
                   "ARE_MOTOR_ON",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_are_motor_on_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_are_motor_on_key",
                   "",
            ],
            [
                   "PRECISION_TAKE_OFF",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_precision_take_off_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_precision_take_off_key",
                   "",
            ],
            [
                   "ATTITUDE_ROLL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_roll_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_attitude_roll_key",
                   "",
            ],
            [
                   "IS_GOING_HOME",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_going_home_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_going_home_key",
                   "",
            ],
            [
                   "RETRACT_LANDING_GEAR",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_retract_landing_gear_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_retract_landing_gear_key",
                   "",
            ],
            [
                   "SUBCOMPONENT_IMU_KEY",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_subcomponent_imu_key_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_subcomponent_imu_key_key",
                   "",
            ],
            [
                   "RTK_FUSION_MOBILE_LOCATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_mobile_location_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_mobile_location_key",
                   "",
            ],
            [
                   "SUBSCRIBE_PACK",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_subscribe_pack_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_subscribe_pack_key",
                   "",
            ],
            [
                   "COMPASS_STATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_state_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_state_key",
                   "",
            ],
            [
                   "GPS_SIGNAL_LEVEL",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gps_signal_level_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gps_signal_level_key",
                   "",
            ],
            [
                   "UPWARDS_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_upwards_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_upwards_avoidance_enabled_key",
                   "",
            ],
            [
                   "OMNI_UPWARDS_AVOIDANCE_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_upwards_avoidance_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_omni_upwards_avoidance_enabled_key",
                   "",
            ],
            [
                   "IS_BACK_RADAR_OPEN",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_back_radar_open_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_back_radar_open_key",
                   "",
            ],
            [
                   "CINEMATIC_YAW_SPEED_RANGE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_yaw_speed_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_cinematic_yaw_speed_range_key",
                   "",
            ],
            [
                   "SERIOUS_LOW_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_serious_low_battery_warning_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_serious_low_battery_warning_threshold_key",
                   "",
            ],
            [
                   "SMART_RETURN_TO_HOME_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_smart_return_to_home_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_smart_return_to_home_enabled_key",
                   "",
            ],
            [
                   "SATELLITE_COUNT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_satellite_count_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_satellite_count_key",
                   "",
            ],
            [
                   "NO_GPS_MAX_FLIGHT_HEIGHT",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_no_gps_max_flight_height_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_no_gps_max_flight_height_key",
                   "",
            ],
            [
                   "ACTIVE_TRACK_CAMERA_STREAM",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_camera_stream_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_active_track_camera_stream_key",
                   "",
            ],
            [
                   "CURRENT_LAND_IMMEDIATELY_BATTERY",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_current_land_immediately_battery_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_current_land_immediately_battery_key",
                   "",
            ],
            [
                   "BOTH_CONTROL_MULTI_GIMBALS",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_both_control_multi_gimbals_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_both_control_multi_gimbals_key",
                   "",
            ],
            [
                   "IS_LOWER_THAN_SERIOUS_BATTERY_WARNING_THRESHOLD",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_lower_than_serious_battery_warning_threshold_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_lower_than_serious_battery_warning_threshold_key",
                   "",
            ],
            [
                   "RTK_FUSION_TAKE_OFF_ALTITUDE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_take_off_altitude_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_rtk_fusion_take_off_altitude_key",
                   "",
            ],
            [
                   "FLIGHT_WIND_WARNING",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_wind_warning_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_flight_wind_warning_key",
                   "",
            ],
            [
                   "MULTI_RC_FLIGHT_CONTROL_AUTH_OWNER",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_owner_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_multi_rc_flight_control_auth_owner_key",
                   "",
            ],
            [
                   "COMPASS_STOP_CALIBRATION",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_stop_calibration_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_compass_stop_calibration_key",
                   "",
            ],
            [
                   "GIMBAL_ATTITUDE_GROUND_COORDINATE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gimbal_attitude_ground_coordinate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_gimbal_attitude_ground_coordinate_key",
                   "",
            ],
            [
                   "IS_ON_BOARD_SDK_AVAILABLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_on_board_sdk_available_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_on_board_sdk_available_key",
                   "",
            ],
            [
                   "INTELLIGENT_FLIGHT_ASSISTANT_IS_USERAVOID_ENABLE",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_intelligent_flight_assistant_is_useravoid_enable_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_intelligent_flight_assistant_is_useravoid_enable_key",
                   "",
            ],
            [
                   "IS_POI2_ENABLED",
                   2,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_poi2_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIFlightControllerKey.html",
                   "#flightcontrollerkey_is_poi2_enabled_key",
                   "",
            ],
            [
                   "IS_MODE_BUTTON_BEING_PRESSED",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_is_mode_button_being_pressed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_is_mode_button_being_pressed_key",
                   "",
            ],
            [
                   "MODE_BUTTON",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_mode_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_mode_button_key",
                   "",
            ],
            [
                   "STICK_HORIZONTAL_DIRECTION",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_horizontal_direction_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_horizontal_direction_key",
                   "",
            ],
            [
                   "COMPONENT_KEY",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_component_key_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_component_key_key",
                   "",
            ],
            [
                   "POWER_MODE",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_power_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_power_mode_key",
                   "",
            ],
            [
                   "HANDHELD_NAME",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_handheld_name_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_handheld_name_key",
                   "",
            ],
            [
                   "IS_TRIGGER_BEING_PRESSED",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_is_trigger_being_pressed_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_is_trigger_being_pressed_key",
                   "",
            ],
            [
                   "TRIGGER_BUTTON",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_trigger_button_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_trigger_button_key",
                   "",
            ],
            [
                   "LED_COMMAND",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_led_command_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_led_command_key",
                   "",
            ],
            [
                   "STICK",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_key",
                   "",
            ],
            [
                   "STICK_GIMBAL_CONTROL_ENABLED",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_gimbal_control_enabled_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_gimbal_control_enabled_key",
                   "",
            ],
            [
                   "STICK_VERTICAL_DIRECTION",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_vertical_direction_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_stick_vertical_direction_key",
                   "",
            ],
            [
                   "FULL_SERIAL_NUMBER_HASH",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_full_serial_number_hash_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_full_serial_number_hash_key",
                   "",
            ],
            [
                   "RECORD_AND_SHUTTER_BUTTONS",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_record_and_shutter_buttons_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_record_and_shutter_buttons_key",
                   "",
            ],
            [
                   "SERIAL_NUMBER",
                   2,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_serial_number_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJIHandheldControllerKey.html",
                   "#handheldcontrollerkey_serial_number_key",
                   "",
            ],
            [
                   "ECHO_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_echo_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_echo_mode_range_key",
                   "",
            ],
            [
                   "SEND_COMMAND_TO_PERCEPTION",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_send_command_to_perception_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_send_command_to_perception_key",
                   "",
            ],
            [
                   "LIDAR_DATA_SAMPLE_RATE_RANGE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_lidar_data_sample_rate_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_lidar_data_sample_rate_range_key",
                   "",
            ],
            [
                   "PAYLOAD_POS_STATUS_INFO",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_payload_pos_status_info_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_payload_pos_status_info_key",
                   "",
            ],
            [
                   "VISIBLE_LIGHT_PIXEL",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_visible_light_pixel_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_visible_light_pixel_key",
                   "",
            ],
            [
                   "SCAN_MODE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_scan_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_scan_mode_key",
                   "",
            ],
            [
                   "HIGH_SENSITIVITY_MODE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_high_sensitivity_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_high_sensitivity_mode_key",
                   "",
            ],
            [
                   "SCAN_MODE_RANGE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_scan_mode_range_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_scan_mode_range_key",
                   "",
            ],
            [
                   "PAYLOAD_PERCEPTION_STATUS",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_payload_perception_status_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_payload_perception_status_key",
                   "",
            ],
            [
                   "LIDAR_DATA_SAMPLE_RATE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_lidar_data_sample_rate_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_lidar_data_sample_rate_key",
                   "",
            ],
            [
                   "ECHO_MODE",
                   2,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_echo_mode_key",
                   "SDK Key description",
            ],
            [
                   "SDK Key description",
                   1,
                   "/Components/KeyManager/DJILidarKey.html",
                   "#lidarkey_echo_mode_key",
                   "",
            ],
        ]
    }
}
